/* application-database-manager.c generated by valac 0.56.17, the Vala compiler
 * generated from application-database-manager.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2020 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib-object.h>
#include <glib.h>
#include "geary-client-46.0.h"
#include <gtk/gtk.h>
#include <gee.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define APPLICATION_TYPE_DATABASE_MANAGER (application_database_manager_get_type ())
#define APPLICATION_DATABASE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLICATION_TYPE_DATABASE_MANAGER, ApplicationDatabaseManager))
#define APPLICATION_DATABASE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APPLICATION_TYPE_DATABASE_MANAGER, ApplicationDatabaseManagerClass))
#define APPLICATION_IS_DATABASE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLICATION_TYPE_DATABASE_MANAGER))
#define APPLICATION_IS_DATABASE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLICATION_TYPE_DATABASE_MANAGER))
#define APPLICATION_DATABASE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLICATION_TYPE_DATABASE_MANAGER, ApplicationDatabaseManagerClass))

typedef struct _ApplicationDatabaseManager ApplicationDatabaseManager;
typedef struct _ApplicationDatabaseManagerClass ApplicationDatabaseManagerClass;
typedef struct _ApplicationDatabaseManagerPrivate ApplicationDatabaseManagerPrivate;
enum  {
	APPLICATION_DATABASE_MANAGER_0_PROPERTY,
	APPLICATION_DATABASE_MANAGER_MONITOR_PROPERTY,
	APPLICATION_DATABASE_MANAGER_VISIBLE_PROPERTY,
	APPLICATION_DATABASE_MANAGER_NUM_PROPERTIES
};
static GParamSpec* application_database_manager_properties[APPLICATION_DATABASE_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _ApplicationDatabaseManager {
	GearyBaseObject parent_instance;
	ApplicationDatabaseManagerPrivate * priv;
};

struct _ApplicationDatabaseManagerClass {
	GearyBaseObjectClass parent_class;
};

struct _ApplicationDatabaseManagerPrivate {
	GearyAggregateProgressMonitor* _monitor;
	gboolean _visible;
	ApplicationClient* application;
	GtkDialog* dialog;
	GeeSet* cancellables;
};

static gint ApplicationDatabaseManager_private_offset;
static gpointer application_database_manager_parent_class = NULL;

VALA_EXTERN GType application_database_manager_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GearyAggregateProgressMonitor* application_database_manager_get_monitor (ApplicationDatabaseManager* self);
static void application_database_manager_set_monitor (ApplicationDatabaseManager* self,
                                               GearyAggregateProgressMonitor* value);
VALA_EXTERN gboolean application_database_manager_get_visible (ApplicationDatabaseManager* self);
VALA_EXTERN void application_database_manager_set_visible (ApplicationDatabaseManager* self,
                                               gboolean value);
VALA_EXTERN ApplicationDatabaseManager* application_database_manager_new (ApplicationClient* application);
VALA_EXTERN ApplicationDatabaseManager* application_database_manager_construct (GType object_type,
                                                                    ApplicationClient* application);
static void application_database_manager_on_start (ApplicationDatabaseManager* self);
static void _application_database_manager_on_start_geary_progress_monitor_start (GearyProgressMonitor* _sender,
                                                                          gpointer self);
static void application_database_manager_on_close (ApplicationDatabaseManager* self);
static void _application_database_manager_on_close_geary_progress_monitor_finish (GearyProgressMonitor* _sender,
                                                                           gpointer self);
VALA_EXTERN void application_database_manager_add_account (ApplicationDatabaseManager* self,
                                               GearyAccount* account,
                                               GCancellable* cancellable);
VALA_EXTERN void application_database_manager_remove_account (ApplicationDatabaseManager* self,
                                                  GearyAccount* account);
static gboolean application_database_manager_on_delete_event (ApplicationDatabaseManager* self);
static gboolean _application_database_manager_on_delete_event_gtk_widget_delete_event (GtkWidget* _sender,
                                                                                GdkEventAny* event,
                                                                                gpointer self);
static void _application_database_manager_on_close_gtk_dialog_close (GtkDialog* _sender,
                                                              gpointer self);
static void application_database_manager_finalize (GObject * obj);
static GType application_database_manager_get_type_once (void);
static void _vala_application_database_manager_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_application_database_manager_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);

static inline gpointer
application_database_manager_get_instance_private (ApplicationDatabaseManager* self)
{
	return G_STRUCT_MEMBER_P (self, ApplicationDatabaseManager_private_offset);
}

GearyAggregateProgressMonitor*
application_database_manager_get_monitor (ApplicationDatabaseManager* self)
{
	GearyAggregateProgressMonitor* result;
	GearyAggregateProgressMonitor* _tmp0_;
#line 15 "../src/client/application/application-database-manager.vala"
	g_return_val_if_fail (APPLICATION_IS_DATABASE_MANAGER (self), NULL);
#line 15 "../src/client/application/application-database-manager.vala"
	_tmp0_ = self->priv->_monitor;
#line 15 "../src/client/application/application-database-manager.vala"
	result = _tmp0_;
#line 15 "../src/client/application/application-database-manager.vala"
	return result;
#line 128 "application-database-manager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 15 "../src/client/application/application-database-manager.vala"
	return self ? g_object_ref (self) : NULL;
#line 136 "application-database-manager.c"
}

static void
application_database_manager_set_monitor (ApplicationDatabaseManager* self,
                                          GearyAggregateProgressMonitor* value)
{
	GearyAggregateProgressMonitor* old_value;
#line 15 "../src/client/application/application-database-manager.vala"
	g_return_if_fail (APPLICATION_IS_DATABASE_MANAGER (self));
#line 15 "../src/client/application/application-database-manager.vala"
	old_value = application_database_manager_get_monitor (self);
#line 15 "../src/client/application/application-database-manager.vala"
	if (old_value != value) {
#line 150 "application-database-manager.c"
		GearyAggregateProgressMonitor* _tmp0_;
#line 15 "../src/client/application/application-database-manager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 15 "../src/client/application/application-database-manager.vala"
		_g_object_unref0 (self->priv->_monitor);
#line 15 "../src/client/application/application-database-manager.vala"
		self->priv->_monitor = _tmp0_;
#line 15 "../src/client/application/application-database-manager.vala"
		g_object_notify_by_pspec ((GObject *) self, application_database_manager_properties[APPLICATION_DATABASE_MANAGER_MONITOR_PROPERTY]);
#line 160 "application-database-manager.c"
	}
}

gboolean
application_database_manager_get_visible (ApplicationDatabaseManager* self)
{
	gboolean result;
#line 20 "../src/client/application/application-database-manager.vala"
	g_return_val_if_fail (APPLICATION_IS_DATABASE_MANAGER (self), FALSE);
#line 20 "../src/client/application/application-database-manager.vala"
	result = self->priv->_visible;
#line 20 "../src/client/application/application-database-manager.vala"
	return result;
#line 174 "application-database-manager.c"
}

void
application_database_manager_set_visible (ApplicationDatabaseManager* self,
                                          gboolean value)
{
	gboolean old_value;
#line 20 "../src/client/application/application-database-manager.vala"
	g_return_if_fail (APPLICATION_IS_DATABASE_MANAGER (self));
#line 20 "../src/client/application/application-database-manager.vala"
	old_value = application_database_manager_get_visible (self);
#line 20 "../src/client/application/application-database-manager.vala"
	if (old_value != value) {
#line 20 "../src/client/application/application-database-manager.vala"
		self->priv->_visible = value;
#line 20 "../src/client/application/application-database-manager.vala"
		g_object_notify_by_pspec ((GObject *) self, application_database_manager_properties[APPLICATION_DATABASE_MANAGER_VISIBLE_PROPERTY]);
#line 192 "application-database-manager.c"
	}
}

/**
     * Creates a new manager for the given application.
     */
static void
_application_database_manager_on_start_geary_progress_monitor_start (GearyProgressMonitor* _sender,
                                                                     gpointer self)
{
#line 34 "../src/client/application/application-database-manager.vala"
	application_database_manager_on_start ((ApplicationDatabaseManager*) self);
#line 205 "application-database-manager.c"
}

static void
_application_database_manager_on_close_geary_progress_monitor_finish (GearyProgressMonitor* _sender,
                                                                      gpointer self)
{
#line 35 "../src/client/application/application-database-manager.vala"
	application_database_manager_on_close ((ApplicationDatabaseManager*) self);
#line 214 "application-database-manager.c"
}

ApplicationDatabaseManager*
application_database_manager_construct (GType object_type,
                                        ApplicationClient* application)
{
	ApplicationDatabaseManager * self = NULL;
	GearyAggregateProgressMonitor* _tmp0_;
	GearyAggregateProgressMonitor* _tmp1_;
#line 31 "../src/client/application/application-database-manager.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (application), NULL);
#line 31 "../src/client/application/application-database-manager.vala"
	self = (ApplicationDatabaseManager*) geary_base_object_construct (object_type);
#line 32 "../src/client/application/application-database-manager.vala"
	self->priv->application = application;
#line 34 "../src/client/application/application-database-manager.vala"
	_tmp0_ = self->priv->_monitor;
#line 34 "../src/client/application/application-database-manager.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_TYPE_PROGRESS_MONITOR, GearyProgressMonitor), "start", (GCallback) _application_database_manager_on_start_geary_progress_monitor_start, self, 0);
#line 35 "../src/client/application/application-database-manager.vala"
	_tmp1_ = self->priv->_monitor;
#line 35 "../src/client/application/application-database-manager.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_TYPE_PROGRESS_MONITOR, GearyProgressMonitor), "finish", (GCallback) _application_database_manager_on_close_geary_progress_monitor_finish, self, 0);
#line 31 "../src/client/application/application-database-manager.vala"
	return self;
#line 240 "application-database-manager.c"
}

ApplicationDatabaseManager*
application_database_manager_new (ApplicationClient* application)
{
#line 31 "../src/client/application/application-database-manager.vala"
	return application_database_manager_construct (APPLICATION_TYPE_DATABASE_MANAGER, application);
#line 248 "application-database-manager.c"
}

/**
     * Adds an account to be monitored for upgrades by the dialog.
     *
     * Accounts should be added before being opened.
     */
void
application_database_manager_add_account (ApplicationDatabaseManager* self,
                                          GearyAccount* account,
                                          GCancellable* cancellable)
{
	GearyAggregateProgressMonitor* _tmp0_;
	GearyProgressMonitor* _tmp1_;
	GearyProgressMonitor* _tmp2_;
	GearyAggregateProgressMonitor* _tmp3_;
	GearyProgressMonitor* _tmp4_;
	GearyProgressMonitor* _tmp5_;
#line 43 "../src/client/application/application-database-manager.vala"
	g_return_if_fail (APPLICATION_IS_DATABASE_MANAGER (self));
#line 43 "../src/client/application/application-database-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT));
#line 43 "../src/client/application/application-database-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 45 "../src/client/application/application-database-manager.vala"
	_tmp0_ = self->priv->_monitor;
#line 45 "../src/client/application/application-database-manager.vala"
	_tmp1_ = geary_account_get_db_upgrade_monitor (account);
#line 45 "../src/client/application/application-database-manager.vala"
	_tmp2_ = _tmp1_;
#line 45 "../src/client/application/application-database-manager.vala"
	geary_aggregate_progress_monitor_add (_tmp0_, _tmp2_);
#line 46 "../src/client/application/application-database-manager.vala"
	_tmp3_ = self->priv->_monitor;
#line 46 "../src/client/application/application-database-manager.vala"
	_tmp4_ = geary_account_get_db_vacuum_monitor (account);
#line 46 "../src/client/application/application-database-manager.vala"
	_tmp5_ = _tmp4_;
#line 46 "../src/client/application/application-database-manager.vala"
	geary_aggregate_progress_monitor_add (_tmp3_, _tmp5_);
#line 47 "../src/client/application/application-database-manager.vala"
	if (cancellable != NULL) {
#line 291 "application-database-manager.c"
		GeeSet* _tmp6_;
#line 48 "../src/client/application/application-database-manager.vala"
		_tmp6_ = self->priv->cancellables;
#line 48 "../src/client/application/application-database-manager.vala"
		gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_COLLECTION, GeeCollection), cancellable);
#line 297 "application-database-manager.c"
	}
}

/**
     * Stops an account from being monitored.
     */
void
application_database_manager_remove_account (ApplicationDatabaseManager* self,
                                             GearyAccount* account)
{
	GearyAggregateProgressMonitor* _tmp0_;
	GearyProgressMonitor* _tmp1_;
	GearyProgressMonitor* _tmp2_;
	GearyAggregateProgressMonitor* _tmp3_;
	GearyProgressMonitor* _tmp4_;
	GearyProgressMonitor* _tmp5_;
#line 55 "../src/client/application/application-database-manager.vala"
	g_return_if_fail (APPLICATION_IS_DATABASE_MANAGER (self));
#line 55 "../src/client/application/application-database-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT));
#line 56 "../src/client/application/application-database-manager.vala"
	_tmp0_ = self->priv->_monitor;
#line 56 "../src/client/application/application-database-manager.vala"
	_tmp1_ = geary_account_get_db_upgrade_monitor (account);
#line 56 "../src/client/application/application-database-manager.vala"
	_tmp2_ = _tmp1_;
#line 56 "../src/client/application/application-database-manager.vala"
	geary_aggregate_progress_monitor_remove (_tmp0_, _tmp2_);
#line 57 "../src/client/application/application-database-manager.vala"
	_tmp3_ = self->priv->_monitor;
#line 57 "../src/client/application/application-database-manager.vala"
	_tmp4_ = geary_account_get_db_vacuum_monitor (account);
#line 57 "../src/client/application/application-database-manager.vala"
	_tmp5_ = _tmp4_;
#line 57 "../src/client/application/application-database-manager.vala"
	geary_aggregate_progress_monitor_remove (_tmp3_, _tmp5_);
#line 334 "application-database-manager.c"
}

static gboolean
_application_database_manager_on_delete_event_gtk_widget_delete_event (GtkWidget* _sender,
                                                                       GdkEventAny* event,
                                                                       gpointer self)
{
	gboolean result;
	result = application_database_manager_on_delete_event ((ApplicationDatabaseManager*) self);
#line 87 "../src/client/application/application-database-manager.vala"
	return result;
#line 346 "application-database-manager.c"
}

static void
_application_database_manager_on_close_gtk_dialog_close (GtkDialog* _sender,
                                                         gpointer self)
{
#line 88 "../src/client/application/application-database-manager.vala"
	application_database_manager_on_close ((ApplicationDatabaseManager*) self);
#line 355 "application-database-manager.c"
}

static void
application_database_manager_on_start (ApplicationDatabaseManager* self)
{
	GtkSpinner* spinner = NULL;
	GtkSpinner* _tmp9_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	ApplicationClient* _tmp13_;
	ApplicationMainWindow* _tmp14_;
	ApplicationMainWindow* _tmp15_;
	GtkDialog* _tmp16_;
	GtkDialog* _tmp17_;
	GtkStyleContext* _tmp18_;
	GtkDialog* _tmp19_;
	GtkBox* _tmp20_;
	GtkDialog* _tmp21_;
	GtkDialog* _tmp22_;
	GtkDialog* _tmp23_;
	GtkDialog* _tmp24_;
#line 60 "../src/client/application/application-database-manager.vala"
	g_return_if_fail (APPLICATION_IS_DATABASE_MANAGER (self));
#line 381 "application-database-manager.c"
	{
		GeeIterator* _window_it = NULL;
		ApplicationClient* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 62 "../src/client/application/application-database-manager.vala"
		_tmp0_ = self->priv->application;
#line 62 "../src/client/application/application-database-manager.vala"
		_tmp1_ = application_client_get_main_windows (_tmp0_);
#line 62 "../src/client/application/application-database-manager.vala"
		_tmp2_ = _tmp1_;
#line 62 "../src/client/application/application-database-manager.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 62 "../src/client/application/application-database-manager.vala"
		_tmp4_ = _tmp3_;
#line 62 "../src/client/application/application-database-manager.vala"
		_g_object_unref0 (_tmp2_);
#line 62 "../src/client/application/application-database-manager.vala"
		_window_it = _tmp4_;
#line 62 "../src/client/application/application-database-manager.vala"
		while (TRUE) {
#line 405 "application-database-manager.c"
			GeeIterator* _tmp5_;
			ApplicationMainWindow* window = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			ApplicationMainWindow* _tmp8_;
#line 62 "../src/client/application/application-database-manager.vala"
			_tmp5_ = _window_it;
#line 62 "../src/client/application/application-database-manager.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 62 "../src/client/application/application-database-manager.vala"
				break;
#line 417 "application-database-manager.c"
			}
#line 62 "../src/client/application/application-database-manager.vala"
			_tmp6_ = _window_it;
#line 62 "../src/client/application/application-database-manager.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 62 "../src/client/application/application-database-manager.vala"
			window = (ApplicationMainWindow*) _tmp7_;
#line 63 "../src/client/application/application-database-manager.vala"
			_tmp8_ = window;
#line 63 "../src/client/application/application-database-manager.vala"
			gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 62 "../src/client/application/application-database-manager.vala"
			_g_object_unref0 (window);
#line 431 "application-database-manager.c"
		}
#line 62 "../src/client/application/application-database-manager.vala"
		_g_object_unref0 (_window_it);
#line 435 "application-database-manager.c"
	}
#line 66 "../src/client/application/application-database-manager.vala"
	_tmp9_ = (GtkSpinner*) gtk_spinner_new ();
#line 66 "../src/client/application/application-database-manager.vala"
	g_object_ref_sink (_tmp9_);
#line 66 "../src/client/application/application-database-manager.vala"
	spinner = _tmp9_;
#line 67 "../src/client/application/application-database-manager.vala"
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (spinner, gtk_widget_get_type (), GtkWidget), 45, 45);
#line 68 "../src/client/application/application-database-manager.vala"
	gtk_spinner_start (spinner);
#line 70 "../src/client/application/application-database-manager.vala"
	_tmp10_ = (GtkGrid*) gtk_grid_new ();
#line 70 "../src/client/application/application-database-manager.vala"
	g_object_ref_sink (_tmp10_);
#line 70 "../src/client/application/application-database-manager.vala"
	grid = _tmp10_;
#line 71 "../src/client/application/application-database-manager.vala"
	gtk_orientable_set_orientation (G_TYPE_CHECK_INSTANCE_CAST (grid, gtk_orientable_get_type (), GtkOrientable), GTK_ORIENTATION_VERTICAL);
#line 72 "../src/client/application/application-database-manager.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (grid, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (spinner, gtk_widget_get_type (), GtkWidget));
#line 74 "../src/client/application/application-database-manager.vala"
	_tmp11_ = (GtkLabel*) gtk_label_new (_ ("Account update in progress"));
#line 74 "../src/client/application/application-database-manager.vala"
	g_object_ref_sink (_tmp11_);
#line 74 "../src/client/application/application-database-manager.vala"
	_tmp12_ = _tmp11_;
#line 74 "../src/client/application/application-database-manager.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (grid, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_widget_get_type (), GtkWidget));
#line 74 "../src/client/application/application-database-manager.vala"
	_g_object_unref0 (_tmp12_);
#line 75 "../src/client/application/application-database-manager.vala"
	gtk_widget_show_all (G_TYPE_CHECK_INSTANCE_CAST (grid, gtk_widget_get_type (), GtkWidget));
#line 77 "../src/client/application/application-database-manager.vala"
	_tmp13_ = self->priv->application;
#line 77 "../src/client/application/application-database-manager.vala"
	_tmp14_ = application_client_get_active_main_window (_tmp13_);
#line 77 "../src/client/application/application-database-manager.vala"
	_tmp15_ = _tmp14_;
#line 77 "../src/client/application/application-database-manager.vala"
	_tmp16_ = (GtkDialog*) gtk_dialog_new_with_buttons (_ ("Account update"), G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_window_get_type (), GtkWindow), GTK_DIALOG_MODAL, NULL);
#line 77 "../src/client/application/application-database-manager.vala"
	g_object_ref_sink (_tmp16_);
#line 77 "../src/client/application/application-database-manager.vala"
	_g_object_unref0 (self->priv->dialog);
#line 77 "../src/client/application/application-database-manager.vala"
	self->priv->dialog = _tmp16_;
#line 77 "../src/client/application/application-database-manager.vala"
	_g_object_unref0 (_tmp15_);
#line 84 "../src/client/application/application-database-manager.vala"
	_tmp17_ = self->priv->dialog;
#line 84 "../src/client/application/application-database-manager.vala"
	_tmp18_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, gtk_widget_get_type (), GtkWidget));
#line 84 "../src/client/application/application-database-manager.vala"
	gtk_style_context_add_class (_tmp18_, "geary-upgrade");
#line 85 "../src/client/application/application-database-manager.vala"
	_tmp19_ = self->priv->dialog;
#line 85 "../src/client/application/application-database-manager.vala"
	_tmp20_ = gtk_dialog_get_content_area (_tmp19_);
#line 85 "../src/client/application/application-database-manager.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (grid, gtk_widget_get_type (), GtkWidget));
#line 86 "../src/client/application/application-database-manager.vala"
	_tmp21_ = self->priv->dialog;
#line 86 "../src/client/application/application-database-manager.vala"
	gtk_window_set_deletable (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, gtk_window_get_type (), GtkWindow), FALSE);
#line 87 "../src/client/application/application-database-manager.vala"
	_tmp22_ = self->priv->dialog;
#line 87 "../src/client/application/application-database-manager.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, gtk_widget_get_type (), GtkWidget), "delete-event", (GCallback) _application_database_manager_on_delete_event_gtk_widget_delete_event, self, 0);
#line 88 "../src/client/application/application-database-manager.vala"
	_tmp23_ = self->priv->dialog;
#line 88 "../src/client/application/application-database-manager.vala"
	g_signal_connect_object (_tmp23_, "close", (GCallback) _application_database_manager_on_close_gtk_dialog_close, self, 0);
#line 89 "../src/client/application/application-database-manager.vala"
	_tmp24_ = self->priv->dialog;
#line 89 "../src/client/application/application-database-manager.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, gtk_widget_get_type (), GtkWidget));
#line 60 "../src/client/application/application-database-manager.vala"
	_g_object_unref0 (grid);
#line 60 "../src/client/application/application-database-manager.vala"
	_g_object_unref0 (spinner);
#line 517 "application-database-manager.c"
}

static gboolean
application_database_manager_on_delete_event (ApplicationDatabaseManager* self)
{
	GearyAggregateProgressMonitor* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 92 "../src/client/application/application-database-manager.vala"
	g_return_val_if_fail (APPLICATION_IS_DATABASE_MANAGER (self), FALSE);
#line 94 "../src/client/application/application-database-manager.vala"
	_tmp0_ = self->priv->_monitor;
#line 94 "../src/client/application/application-database-manager.vala"
	_tmp1_ = geary_progress_monitor_get_is_in_progress (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_TYPE_PROGRESS_MONITOR, GearyProgressMonitor));
#line 94 "../src/client/application/application-database-manager.vala"
	_tmp2_ = _tmp1_;
#line 94 "../src/client/application/application-database-manager.vala"
	result = !_tmp2_;
#line 94 "../src/client/application/application-database-manager.vala"
	return result;
#line 539 "application-database-manager.c"
}

static void
application_database_manager_on_close (ApplicationDatabaseManager* self)
{
	GearyAggregateProgressMonitor* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp9_ = FALSE;
	GtkDialog* _tmp10_;
#line 97 "../src/client/application/application-database-manager.vala"
	g_return_if_fail (APPLICATION_IS_DATABASE_MANAGER (self));
#line 99 "../src/client/application/application-database-manager.vala"
	_tmp0_ = self->priv->_monitor;
#line 99 "../src/client/application/application-database-manager.vala"
	_tmp1_ = geary_progress_monitor_get_is_in_progress (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_TYPE_PROGRESS_MONITOR, GearyProgressMonitor));
#line 99 "../src/client/application/application-database-manager.vala"
	_tmp2_ = _tmp1_;
#line 99 "../src/client/application/application-database-manager.vala"
	if (_tmp2_) {
#line 560 "application-database-manager.c"
		{
			GeeIterator* _c_it = NULL;
			GeeSet* _tmp3_;
			GeeIterator* _tmp4_;
#line 100 "../src/client/application/application-database-manager.vala"
			_tmp3_ = self->priv->cancellables;
#line 100 "../src/client/application/application-database-manager.vala"
			_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 100 "../src/client/application/application-database-manager.vala"
			_c_it = _tmp4_;
#line 100 "../src/client/application/application-database-manager.vala"
			while (TRUE) {
#line 573 "application-database-manager.c"
				GeeIterator* _tmp5_;
				GCancellable* c = NULL;
				GeeIterator* _tmp6_;
				gpointer _tmp7_;
				GCancellable* _tmp8_;
#line 100 "../src/client/application/application-database-manager.vala"
				_tmp5_ = _c_it;
#line 100 "../src/client/application/application-database-manager.vala"
				if (!gee_iterator_next (_tmp5_)) {
#line 100 "../src/client/application/application-database-manager.vala"
					break;
#line 585 "application-database-manager.c"
				}
#line 100 "../src/client/application/application-database-manager.vala"
				_tmp6_ = _c_it;
#line 100 "../src/client/application/application-database-manager.vala"
				_tmp7_ = gee_iterator_get (_tmp6_);
#line 100 "../src/client/application/application-database-manager.vala"
				c = (GCancellable*) _tmp7_;
#line 101 "../src/client/application/application-database-manager.vala"
				_tmp8_ = c;
#line 101 "../src/client/application/application-database-manager.vala"
				g_cancellable_cancel (_tmp8_);
#line 100 "../src/client/application/application-database-manager.vala"
				_g_object_unref0 (c);
#line 599 "application-database-manager.c"
			}
#line 100 "../src/client/application/application-database-manager.vala"
			_g_object_unref0 (_c_it);
#line 603 "application-database-manager.c"
		}
	}
#line 105 "../src/client/application/application-database-manager.vala"
	_tmp10_ = self->priv->dialog;
#line 105 "../src/client/application/application-database-manager.vala"
	if (_tmp10_ != NULL) {
#line 610 "application-database-manager.c"
		GtkDialog* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
#line 106 "../src/client/application/application-database-manager.vala"
		_tmp11_ = self->priv->dialog;
#line 106 "../src/client/application/application-database-manager.vala"
		_tmp12_ = gtk_widget_get_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_widget_get_type (), GtkWidget));
#line 106 "../src/client/application/application-database-manager.vala"
		_tmp13_ = _tmp12_;
#line 106 "../src/client/application/application-database-manager.vala"
		_tmp9_ = _tmp13_;
#line 622 "application-database-manager.c"
	} else {
#line 105 "../src/client/application/application-database-manager.vala"
		_tmp9_ = FALSE;
#line 626 "application-database-manager.c"
	}
#line 105 "../src/client/application/application-database-manager.vala"
	if (_tmp9_) {
#line 630 "application-database-manager.c"
		GtkDialog* _tmp14_;
		GtkDialog* _tmp15_;
#line 107 "../src/client/application/application-database-manager.vala"
		_tmp14_ = self->priv->dialog;
#line 107 "../src/client/application/application-database-manager.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_widget_get_type (), GtkWidget));
#line 108 "../src/client/application/application-database-manager.vala"
		_tmp15_ = self->priv->dialog;
#line 108 "../src/client/application/application-database-manager.vala"
		gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_widget_get_type (), GtkWidget));
#line 109 "../src/client/application/application-database-manager.vala"
		_g_object_unref0 (self->priv->dialog);
#line 109 "../src/client/application/application-database-manager.vala"
		self->priv->dialog = NULL;
#line 645 "application-database-manager.c"
	}
	{
		GeeIterator* _window_it = NULL;
		ApplicationClient* _tmp16_;
		GeeCollection* _tmp17_;
		GeeCollection* _tmp18_;
		GeeIterator* _tmp19_;
		GeeIterator* _tmp20_;
#line 113 "../src/client/application/application-database-manager.vala"
		_tmp16_ = self->priv->application;
#line 113 "../src/client/application/application-database-manager.vala"
		_tmp17_ = application_client_get_main_windows (_tmp16_);
#line 113 "../src/client/application/application-database-manager.vala"
		_tmp18_ = _tmp17_;
#line 113 "../src/client/application/application-database-manager.vala"
		_tmp19_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_ITERABLE, GeeIterable));
#line 113 "../src/client/application/application-database-manager.vala"
		_tmp20_ = _tmp19_;
#line 113 "../src/client/application/application-database-manager.vala"
		_g_object_unref0 (_tmp18_);
#line 113 "../src/client/application/application-database-manager.vala"
		_window_it = _tmp20_;
#line 113 "../src/client/application/application-database-manager.vala"
		while (TRUE) {
#line 670 "application-database-manager.c"
			GeeIterator* _tmp21_;
			ApplicationMainWindow* window = NULL;
			GeeIterator* _tmp22_;
			gpointer _tmp23_;
			ApplicationMainWindow* _tmp24_;
#line 113 "../src/client/application/application-database-manager.vala"
			_tmp21_ = _window_it;
#line 113 "../src/client/application/application-database-manager.vala"
			if (!gee_iterator_next (_tmp21_)) {
#line 113 "../src/client/application/application-database-manager.vala"
				break;
#line 682 "application-database-manager.c"
			}
#line 113 "../src/client/application/application-database-manager.vala"
			_tmp22_ = _window_it;
#line 113 "../src/client/application/application-database-manager.vala"
			_tmp23_ = gee_iterator_get (_tmp22_);
#line 113 "../src/client/application/application-database-manager.vala"
			window = (ApplicationMainWindow*) _tmp23_;
#line 114 "../src/client/application/application-database-manager.vala"
			_tmp24_ = window;
#line 114 "../src/client/application/application-database-manager.vala"
			gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, gtk_widget_get_type (), GtkWidget), TRUE);
#line 113 "../src/client/application/application-database-manager.vala"
			_g_object_unref0 (window);
#line 696 "application-database-manager.c"
		}
#line 113 "../src/client/application/application-database-manager.vala"
		_g_object_unref0 (_window_it);
#line 700 "application-database-manager.c"
	}
}

static void
application_database_manager_class_init (ApplicationDatabaseManagerClass * klass,
                                         gpointer klass_data)
{
#line 10 "../src/client/application/application-database-manager.vala"
	application_database_manager_parent_class = g_type_class_peek_parent (klass);
#line 10 "../src/client/application/application-database-manager.vala"
	g_type_class_adjust_private_offset (klass, &ApplicationDatabaseManager_private_offset);
#line 10 "../src/client/application/application-database-manager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_application_database_manager_get_property;
#line 10 "../src/client/application/application-database-manager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_application_database_manager_set_property;
#line 10 "../src/client/application/application-database-manager.vala"
	G_OBJECT_CLASS (klass)->finalize = application_database_manager_finalize;
#line 10 "../src/client/application/application-database-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_DATABASE_MANAGER_MONITOR_PROPERTY, application_database_manager_properties[APPLICATION_DATABASE_MANAGER_MONITOR_PROPERTY] = g_param_spec_object ("monitor", "monitor", "monitor", GEARY_TYPE_AGGREGATE_PROGRESS_MONITOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 720 "application-database-manager.c"
	/** Determines whether or not the database dialog is visible. */
#line 10 "../src/client/application/application-database-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_DATABASE_MANAGER_VISIBLE_PROPERTY, application_database_manager_properties[APPLICATION_DATABASE_MANAGER_VISIBLE_PROPERTY] = g_param_spec_boolean ("visible", "visible", "visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 724 "application-database-manager.c"
}

static void
application_database_manager_instance_init (ApplicationDatabaseManager * self,
                                            gpointer klass)
{
	GearyAggregateProgressMonitor* _tmp0_;
	GeeHashSet* _tmp1_;
#line 10 "../src/client/application/application-database-manager.vala"
	self->priv = application_database_manager_get_instance_private (self);
#line 14 "../src/client/application/application-database-manager.vala"
	_tmp0_ = geary_aggregate_progress_monitor_new ();
#line 14 "../src/client/application/application-database-manager.vala"
	self->priv->_monitor = _tmp0_;
#line 24 "../src/client/application/application-database-manager.vala"
	self->priv->dialog = NULL;
#line 25 "../src/client/application/application-database-manager.vala"
	_tmp1_ = gee_hash_set_new (g_cancellable_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 25 "../src/client/application/application-database-manager.vala"
	self->priv->cancellables = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_SET, GeeSet);
#line 745 "application-database-manager.c"
}

static void
application_database_manager_finalize (GObject * obj)
{
	ApplicationDatabaseManager * self;
#line 10 "../src/client/application/application-database-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APPLICATION_TYPE_DATABASE_MANAGER, ApplicationDatabaseManager);
#line 14 "../src/client/application/application-database-manager.vala"
	_g_object_unref0 (self->priv->_monitor);
#line 24 "../src/client/application/application-database-manager.vala"
	_g_object_unref0 (self->priv->dialog);
#line 25 "../src/client/application/application-database-manager.vala"
	_g_object_unref0 (self->priv->cancellables);
#line 10 "../src/client/application/application-database-manager.vala"
	G_OBJECT_CLASS (application_database_manager_parent_class)->finalize (obj);
#line 762 "application-database-manager.c"
}

/** Manages progress when upgrading and rebuilding account databases. */
static GType
application_database_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ApplicationDatabaseManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) application_database_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ApplicationDatabaseManager), 0, (GInstanceInitFunc) application_database_manager_instance_init, NULL };
	GType application_database_manager_type_id;
	application_database_manager_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "ApplicationDatabaseManager", &g_define_type_info, 0);
	ApplicationDatabaseManager_private_offset = g_type_add_instance_private (application_database_manager_type_id, sizeof (ApplicationDatabaseManagerPrivate));
	return application_database_manager_type_id;
}

GType
application_database_manager_get_type (void)
{
	static volatile gsize application_database_manager_type_id__once = 0;
	if (g_once_init_enter (&application_database_manager_type_id__once)) {
		GType application_database_manager_type_id;
		application_database_manager_type_id = application_database_manager_get_type_once ();
		g_once_init_leave (&application_database_manager_type_id__once, application_database_manager_type_id);
	}
	return application_database_manager_type_id__once;
}

static void
_vala_application_database_manager_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	ApplicationDatabaseManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APPLICATION_TYPE_DATABASE_MANAGER, ApplicationDatabaseManager);
#line 10 "../src/client/application/application-database-manager.vala"
	switch (property_id) {
#line 10 "../src/client/application/application-database-manager.vala"
		case APPLICATION_DATABASE_MANAGER_MONITOR_PROPERTY:
#line 10 "../src/client/application/application-database-manager.vala"
		g_value_set_object (value, application_database_manager_get_monitor (self));
#line 10 "../src/client/application/application-database-manager.vala"
		break;
#line 10 "../src/client/application/application-database-manager.vala"
		case APPLICATION_DATABASE_MANAGER_VISIBLE_PROPERTY:
#line 10 "../src/client/application/application-database-manager.vala"
		g_value_set_boolean (value, application_database_manager_get_visible (self));
#line 10 "../src/client/application/application-database-manager.vala"
		break;
#line 810 "application-database-manager.c"
		default:
#line 10 "../src/client/application/application-database-manager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/client/application/application-database-manager.vala"
		break;
#line 816 "application-database-manager.c"
	}
}

static void
_vala_application_database_manager_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	ApplicationDatabaseManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APPLICATION_TYPE_DATABASE_MANAGER, ApplicationDatabaseManager);
#line 10 "../src/client/application/application-database-manager.vala"
	switch (property_id) {
#line 10 "../src/client/application/application-database-manager.vala"
		case APPLICATION_DATABASE_MANAGER_MONITOR_PROPERTY:
#line 10 "../src/client/application/application-database-manager.vala"
		application_database_manager_set_monitor (self, g_value_get_object (value));
#line 10 "../src/client/application/application-database-manager.vala"
		break;
#line 10 "../src/client/application/application-database-manager.vala"
		case APPLICATION_DATABASE_MANAGER_VISIBLE_PROPERTY:
#line 10 "../src/client/application/application-database-manager.vala"
		application_database_manager_set_visible (self, g_value_get_boolean (value));
#line 10 "../src/client/application/application-database-manager.vala"
		break;
#line 842 "application-database-manager.c"
		default:
#line 10 "../src/client/application/application-database-manager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/client/application/application-database-manager.vala"
		break;
#line 848 "application-database-manager.c"
	}
}

