/* goa-mediator.c generated by valac 0.56.17, the Vala compiler
 * generated from goa-mediator.vala, do not modify */

/*
 * Copyright 2017 Software Freedom Conservancy Inc.
 * Copyright 2018 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-client-46.0.h"
#include <goa/goa.h>
#include <gio/gio.h>
#include "geary-engine.h"
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GOA_MEDIATOR_0_PROPERTY,
	GOA_MEDIATOR_NUM_PROPERTIES
};
static GParamSpec* goa_mediator_properties[GOA_MEDIATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _GoaMediatorUpdateData GoaMediatorUpdateData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _GoaMediatorLoadTokenData GoaMediatorLoadTokenData;

struct _GoaMediatorPrivate {
	GoaObject* handle;
};

struct _GoaMediatorUpdateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GoaMediator* self;
	GearyAccountInformation* geary_account;
	GCancellable* cancellable;
	GearyServiceInformation* _tmp0_;
	GearyServiceInformation* _tmp1_;
	GearyServiceInformation* _tmp2_;
	GearyServiceInformation* _tmp3_;
	GError* _inner_error0_;
};

struct _GoaMediatorLoadTokenData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GoaMediator* self;
	GearyAccountInformation* account;
	GearyServiceInformation* service;
	GCancellable* cancellable;
	gboolean result;
	GoaAccount* goa_account;
	GoaObject* _tmp0_;
	GoaAccount* _tmp1_;
	GoaAccount* _tmp2_;
	GError* err;
	GError* _tmp3_;
	const gchar* _tmp4_;
	GoaAccount* _tmp5_;
	gboolean loaded;
	gchar* token;
	GearyCredentialsMethod _tmp6_;
	GoaObject* _tmp7_;
	GoaOAuth2Based* _tmp8_;
	GoaOAuth2Based* _tmp9_;
	gchar* _tmp10_;
	GearyProtocol _tmp11_;
	GearyProtocol _tmp12_;
	GoaObject* _tmp13_;
	GoaPasswordBased* _tmp14_;
	GoaPasswordBased* _tmp15_;
	gchar* _tmp16_;
	GoaObject* _tmp17_;
	GoaPasswordBased* _tmp18_;
	GoaPasswordBased* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	GearyCredentials* _tmp22_;
	GearyCredentials* _tmp23_;
	const gchar* _tmp24_;
	GearyCredentials* _tmp25_;
	GearyCredentials* _tmp26_;
	GError* _inner_error0_;
};

static gint GoaMediator_private_offset;
static gpointer goa_mediator_parent_class = NULL;
static GearyCredentialsMediatorIface * goa_mediator_geary_credentials_mediator_parent_iface = NULL;

static void goa_mediator_update_data_free (gpointer _data);
static gboolean goa_mediator_update_co (GoaMediatorUpdateData* _data_);
static GearyCredentialsMethod goa_mediator_get_auth_method (GoaMediator* self,
                                                     GError** error);
static void goa_mediator_update_imap_config (GoaMediator* self,
                                      GearyServiceInformation* service,
                                      GError** error);
static void goa_mediator_update_smtp_config (GoaMediator* self,
                                      GearyServiceInformation* service,
                                      GError** error);
static void goa_mediator_real_load_token_data_free (gpointer _data);
static void goa_mediator_real_load_token (GoaMediator* self,
                                   GearyAccountInformation* account,
                                   GearyServiceInformation* service,
                                   GCancellable* cancellable,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
static gboolean goa_mediator_real_load_token_co (GoaMediatorLoadTokenData* _data_);
static void goa_mediator_load_token_ready (GObject* source_object,
                                    GAsyncResult* _res_,
                                    gpointer _user_data_);
static void goa_mediator_parse_host_name (GoaMediator* self,
                                   GearyServiceInformation* service,
                                   const gchar* host_name);
static void goa_mediator_finalize (GObject * obj);
static GType goa_mediator_get_type_once (void);

static inline gpointer
goa_mediator_get_instance_private (GoaMediator* self)
{
	return G_STRUCT_MEMBER_P (self, GoaMediator_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 17 "../src/client/application/goa-mediator.vala"
	return self ? g_object_ref (self) : NULL;
#line 147 "goa-mediator.c"
}

GoaMediator*
goa_mediator_construct (GType object_type,
                        GoaObject* handle)
{
	GoaMediator * self = NULL;
	GoaObject* _tmp0_;
#line 16 "../src/client/application/goa-mediator.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (handle, goa_object_get_type ()), NULL);
#line 16 "../src/client/application/goa-mediator.vala"
	self = (GoaMediator*) g_object_new (object_type, NULL);
#line 17 "../src/client/application/goa-mediator.vala"
	_tmp0_ = _g_object_ref0 (handle);
#line 17 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (self->priv->handle);
#line 17 "../src/client/application/goa-mediator.vala"
	self->priv->handle = _tmp0_;
#line 16 "../src/client/application/goa-mediator.vala"
	return self;
#line 168 "goa-mediator.c"
}

GoaMediator*
goa_mediator_new (GoaObject* handle)
{
#line 16 "../src/client/application/goa-mediator.vala"
	return goa_mediator_construct (TYPE_GOA_MEDIATOR, handle);
#line 176 "goa-mediator.c"
}

GearyServiceProvider
goa_mediator_get_service_provider (GoaMediator* self)
{
	GearyServiceProvider provider = 0;
	GoaObject* _tmp0_;
	GoaAccount* _tmp1_;
	GoaAccount* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GQuark _tmp8_ = 0U;
#line 22 "../src/client/application/goa-mediator.vala"
	static GQuark _tmp7_label0 = 0;
#line 22 "../src/client/application/goa-mediator.vala"
	static GQuark _tmp7_label1 = 0;
#line 195 "goa-mediator.c"
	GearyServiceProvider result;
#line 20 "../src/client/application/goa-mediator.vala"
	g_return_val_if_fail (IS_GOA_MEDIATOR (self), 0);
#line 21 "../src/client/application/goa-mediator.vala"
	provider = GEARY_SERVICE_PROVIDER_OTHER;
#line 22 "../src/client/application/goa-mediator.vala"
	_tmp0_ = self->priv->handle;
#line 22 "../src/client/application/goa-mediator.vala"
	_tmp1_ = goa_object_get_account (_tmp0_);
#line 22 "../src/client/application/goa-mediator.vala"
	_tmp2_ = _tmp1_;
#line 22 "../src/client/application/goa-mediator.vala"
	g_object_get (_tmp2_, "provider-type", &_tmp3_, NULL);
#line 22 "../src/client/application/goa-mediator.vala"
	_tmp4_ = _tmp3_;
#line 22 "../src/client/application/goa-mediator.vala"
	_tmp5_ = _tmp4_;
#line 22 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_tmp2_);
#line 22 "../src/client/application/goa-mediator.vala"
	_tmp6_ = _tmp5_;
#line 22 "../src/client/application/goa-mediator.vala"
	_tmp8_ = (NULL == _tmp6_) ? 0 : g_quark_from_string (_tmp6_);
#line 22 "../src/client/application/goa-mediator.vala"
	g_free (_tmp6_);
#line 22 "../src/client/application/goa-mediator.vala"
	if (_tmp8_ == ((0 != _tmp7_label0) ? _tmp7_label0 : (_tmp7_label0 = g_quark_from_static_string ("google")))) {
#line 22 "../src/client/application/goa-mediator.vala"
		switch (0) {
#line 225 "goa-mediator.c"
			default:
			{
#line 24 "../src/client/application/goa-mediator.vala"
				provider = GEARY_SERVICE_PROVIDER_GMAIL;
#line 25 "../src/client/application/goa-mediator.vala"
				break;
#line 232 "goa-mediator.c"
			}
		}
	} else if (_tmp8_ == ((0 != _tmp7_label1) ? _tmp7_label1 : (_tmp7_label1 = g_quark_from_static_string ("windows_live")))) {
#line 22 "../src/client/application/goa-mediator.vala"
		switch (0) {
#line 238 "goa-mediator.c"
			default:
			{
#line 28 "../src/client/application/goa-mediator.vala"
				provider = GEARY_SERVICE_PROVIDER_OUTLOOK;
#line 29 "../src/client/application/goa-mediator.vala"
				break;
#line 245 "goa-mediator.c"
			}
		}
	}
#line 31 "../src/client/application/goa-mediator.vala"
	result = provider;
#line 31 "../src/client/application/goa-mediator.vala"
	return result;
#line 253 "goa-mediator.c"
}

gchar*
goa_mediator_get_service_label (GoaMediator* self)
{
	GoaObject* _tmp0_;
	GoaAccount* _tmp1_;
	GoaAccount* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result;
#line 34 "../src/client/application/goa-mediator.vala"
	g_return_val_if_fail (IS_GOA_MEDIATOR (self), NULL);
#line 35 "../src/client/application/goa-mediator.vala"
	_tmp0_ = self->priv->handle;
#line 35 "../src/client/application/goa-mediator.vala"
	_tmp1_ = goa_object_get_account (_tmp0_);
#line 35 "../src/client/application/goa-mediator.vala"
	_tmp2_ = _tmp1_;
#line 35 "../src/client/application/goa-mediator.vala"
	g_object_get (_tmp2_, "provider-name", &_tmp3_, NULL);
#line 35 "../src/client/application/goa-mediator.vala"
	_tmp4_ = _tmp3_;
#line 35 "../src/client/application/goa-mediator.vala"
	_tmp5_ = _tmp4_;
#line 35 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_tmp2_);
#line 35 "../src/client/application/goa-mediator.vala"
	result = _tmp5_;
#line 35 "../src/client/application/goa-mediator.vala"
	return result;
#line 286 "goa-mediator.c"
}

static void
goa_mediator_update_data_free (gpointer _data)
{
	GoaMediatorUpdateData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->geary_account);
#line 10 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/goa-mediator.vala"
	g_slice_free (GoaMediatorUpdateData, _data_);
#line 302 "goa-mediator.c"
}

void
goa_mediator_update (GoaMediator* self,
                     GearyAccountInformation* geary_account,
                     GCancellable* cancellable,
                     GAsyncReadyCallback _callback_,
                     gpointer _user_data_)
{
	GoaMediatorUpdateData* _data_;
	GoaMediator* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GCancellable* _tmp2_;
#line 10 "../src/client/application/goa-mediator.vala"
	g_return_if_fail (IS_GOA_MEDIATOR (self));
#line 10 "../src/client/application/goa-mediator.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (geary_account, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 10 "../src/client/application/goa-mediator.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 10 "../src/client/application/goa-mediator.vala"
	_data_ = g_slice_new0 (GoaMediatorUpdateData);
#line 10 "../src/client/application/goa-mediator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 10 "../src/client/application/goa-mediator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, goa_mediator_update_data_free);
#line 10 "../src/client/application/goa-mediator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/goa-mediator.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/goa-mediator.vala"
	_tmp1_ = _g_object_ref0 (geary_account);
#line 10 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->geary_account);
#line 10 "../src/client/application/goa-mediator.vala"
	_data_->geary_account = _tmp1_;
#line 10 "../src/client/application/goa-mediator.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 10 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/client/application/goa-mediator.vala"
	_data_->cancellable = _tmp2_;
#line 10 "../src/client/application/goa-mediator.vala"
	goa_mediator_update_co (_data_);
#line 346 "goa-mediator.c"
}

void
goa_mediator_update_finish (GoaMediator* self,
                            GAsyncResult* _res_,
                            GError** error)
{
	GoaMediatorUpdateData* _data_;
#line 10 "../src/client/application/goa-mediator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 10 "../src/client/application/goa-mediator.vala"
	if (NULL == _data_) {
#line 10 "../src/client/application/goa-mediator.vala"
		return;
#line 361 "goa-mediator.c"
	}
}

static gboolean
goa_mediator_update_co (GoaMediatorUpdateData* _data_)
{
#line 38 "../src/client/application/goa-mediator.vala"
	switch (_data_->_state_) {
#line 38 "../src/client/application/goa-mediator.vala"
		case 0:
#line 372 "goa-mediator.c"
		goto _state_0;
		default:
#line 38 "../src/client/application/goa-mediator.vala"
		g_assert_not_reached ();
#line 377 "goa-mediator.c"
	}
	_state_0:
#line 43 "../src/client/application/goa-mediator.vala"
	goa_mediator_get_auth_method (_data_->self, &_data_->_inner_error0_);
#line 43 "../src/client/application/goa-mediator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 43 "../src/client/application/goa-mediator.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 43 "../src/client/application/goa-mediator.vala"
		g_object_unref (_data_->_async_result);
#line 43 "../src/client/application/goa-mediator.vala"
		return FALSE;
#line 390 "goa-mediator.c"
	}
#line 45 "../src/client/application/goa-mediator.vala"
	_data_->_tmp0_ = geary_account_information_get_incoming (_data_->geary_account);
#line 45 "../src/client/application/goa-mediator.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 45 "../src/client/application/goa-mediator.vala"
	goa_mediator_update_imap_config (_data_->self, _data_->_tmp1_, &_data_->_inner_error0_);
#line 45 "../src/client/application/goa-mediator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 45 "../src/client/application/goa-mediator.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 45 "../src/client/application/goa-mediator.vala"
		g_object_unref (_data_->_async_result);
#line 45 "../src/client/application/goa-mediator.vala"
		return FALSE;
#line 406 "goa-mediator.c"
	}
#line 46 "../src/client/application/goa-mediator.vala"
	_data_->_tmp2_ = geary_account_information_get_outgoing (_data_->geary_account);
#line 46 "../src/client/application/goa-mediator.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 46 "../src/client/application/goa-mediator.vala"
	goa_mediator_update_smtp_config (_data_->self, _data_->_tmp3_, &_data_->_inner_error0_);
#line 46 "../src/client/application/goa-mediator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 46 "../src/client/application/goa-mediator.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 46 "../src/client/application/goa-mediator.vala"
		g_object_unref (_data_->_async_result);
#line 46 "../src/client/application/goa-mediator.vala"
		return FALSE;
#line 422 "goa-mediator.c"
	}
#line 38 "../src/client/application/goa-mediator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 38 "../src/client/application/goa-mediator.vala"
	if (_data_->_state_ != 0) {
#line 38 "../src/client/application/goa-mediator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 38 "../src/client/application/goa-mediator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 432 "goa-mediator.c"
		}
	}
#line 38 "../src/client/application/goa-mediator.vala"
	g_object_unref (_data_->_async_result);
#line 38 "../src/client/application/goa-mediator.vala"
	return FALSE;
#line 439 "goa-mediator.c"
}

static void
goa_mediator_real_load_token_data_free (gpointer _data)
{
	GoaMediatorLoadTokenData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->account);
#line 10 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->service);
#line 10 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/goa-mediator.vala"
	g_slice_free (GoaMediatorLoadTokenData, _data_);
#line 457 "goa-mediator.c"
}

static void
goa_mediator_real_load_token (GoaMediator* self,
                              GearyAccountInformation* account,
                              GearyServiceInformation* service,
                              GCancellable* cancellable,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	GoaMediatorLoadTokenData* _data_;
	GoaMediator* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GearyServiceInformation* _tmp2_;
	GCancellable* _tmp3_;
#line 10 "../src/client/application/goa-mediator.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 10 "../src/client/application/goa-mediator.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (service, GEARY_TYPE_SERVICE_INFORMATION));
#line 10 "../src/client/application/goa-mediator.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 10 "../src/client/application/goa-mediator.vala"
	_data_ = g_slice_new0 (GoaMediatorLoadTokenData);
#line 10 "../src/client/application/goa-mediator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 10 "../src/client/application/goa-mediator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, goa_mediator_real_load_token_data_free);
#line 10 "../src/client/application/goa-mediator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/goa-mediator.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/goa-mediator.vala"
	_tmp1_ = _g_object_ref0 (account);
#line 10 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->account);
#line 10 "../src/client/application/goa-mediator.vala"
	_data_->account = _tmp1_;
#line 10 "../src/client/application/goa-mediator.vala"
	_tmp2_ = _g_object_ref0 (service);
#line 10 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->service);
#line 10 "../src/client/application/goa-mediator.vala"
	_data_->service = _tmp2_;
#line 10 "../src/client/application/goa-mediator.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 10 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/client/application/goa-mediator.vala"
	_data_->cancellable = _tmp3_;
#line 10 "../src/client/application/goa-mediator.vala"
	goa_mediator_real_load_token_co (_data_);
#line 509 "goa-mediator.c"
}

static gboolean
goa_mediator_real_load_token_finish (GoaMediator* self,
                                     GAsyncResult* _res_,
                                     GError** error)
{
	gboolean result;
	GoaMediatorLoadTokenData* _data_;
#line 10 "../src/client/application/goa-mediator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 10 "../src/client/application/goa-mediator.vala"
	if (NULL == _data_) {
#line 523 "goa-mediator.c"
		gboolean _tmp0_ = FALSE;
#line 10 "../src/client/application/goa-mediator.vala"
		return _tmp0_;
#line 527 "goa-mediator.c"
	}
#line 10 "../src/client/application/goa-mediator.vala"
	result = _data_->result;
#line 10 "../src/client/application/goa-mediator.vala"
	return result;
#line 533 "goa-mediator.c"
}

static void
goa_mediator_load_token_ready (GObject* source_object,
                               GAsyncResult* _res_,
                               gpointer _user_data_)
{
	GoaMediatorLoadTokenData* _data_;
#line 64 "../src/client/application/goa-mediator.vala"
	_data_ = _user_data_;
#line 64 "../src/client/application/goa-mediator.vala"
	_data_->_source_object_ = source_object;
#line 64 "../src/client/application/goa-mediator.vala"
	_data_->_res_ = _res_;
#line 64 "../src/client/application/goa-mediator.vala"
	goa_mediator_real_load_token_co (_data_);
#line 550 "goa-mediator.c"
}

static gboolean
goa_mediator_real_load_token_co (GoaMediatorLoadTokenData* _data_)
{
#line 49 "../src/client/application/goa-mediator.vala"
	switch (_data_->_state_) {
#line 49 "../src/client/application/goa-mediator.vala"
		case 0:
#line 560 "goa-mediator.c"
		goto _state_0;
#line 49 "../src/client/application/goa-mediator.vala"
		case 1:
#line 564 "goa-mediator.c"
		goto _state_1;
#line 49 "../src/client/application/goa-mediator.vala"
		case 2:
#line 568 "goa-mediator.c"
		goto _state_2;
#line 49 "../src/client/application/goa-mediator.vala"
		case 3:
#line 572 "goa-mediator.c"
		goto _state_3;
#line 49 "../src/client/application/goa-mediator.vala"
		case 4:
#line 576 "goa-mediator.c"
		goto _state_4;
#line 49 "../src/client/application/goa-mediator.vala"
		case 5:
#line 580 "goa-mediator.c"
		goto _state_5;
		default:
#line 49 "../src/client/application/goa-mediator.vala"
		g_assert_not_reached ();
#line 585 "goa-mediator.c"
	}
	_state_0:
#line 61 "../src/client/application/goa-mediator.vala"
	_data_->_tmp0_ = _data_->self->priv->handle;
#line 61 "../src/client/application/goa-mediator.vala"
	_data_->_tmp1_ = goa_object_get_account (_data_->_tmp0_);
#line 61 "../src/client/application/goa-mediator.vala"
	_data_->goa_account = _data_->_tmp1_;
#line 62 "../src/client/application/goa-mediator.vala"
	if (_data_->account != NULL) {
#line 596 "goa-mediator.c"
		{
#line 64 "../src/client/application/goa-mediator.vala"
			_data_->_tmp2_ = _data_->goa_account;
#line 64 "../src/client/application/goa-mediator.vala"
			_data_->_state_ = 1;
#line 64 "../src/client/application/goa-mediator.vala"
			goa_account_call_ensure_credentials (_data_->_tmp2_, _data_->cancellable, goa_mediator_load_token_ready, _data_);
#line 64 "../src/client/application/goa-mediator.vala"
			return FALSE;
#line 606 "goa-mediator.c"
			_state_1:
#line 64 "../src/client/application/goa-mediator.vala"
			goa_account_call_ensure_credentials_finish (_data_->_tmp2_, NULL, _data_->_res_, &_data_->_inner_error0_);
#line 64 "../src/client/application/goa-mediator.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 64 "../src/client/application/goa-mediator.vala"
				if (g_error_matches (_data_->_inner_error0_, GOA_ERROR, GOA_ERROR_NOT_AUTHORIZED)) {
#line 614 "goa-mediator.c"
					goto __catch0_goa_error_not_authorized;
				}
				goto __finally0;
			}
		}
		goto __finally0;
		__catch0_goa_error_not_authorized:
		{
#line 63 "../src/client/application/goa-mediator.vala"
			_data_->err = _data_->_inner_error0_;
#line 63 "../src/client/application/goa-mediator.vala"
			_data_->_inner_error0_ = NULL;
#line 66 "../src/client/application/goa-mediator.vala"
			_data_->_tmp3_ = _data_->err;
#line 66 "../src/client/application/goa-mediator.vala"
			_data_->_tmp4_ = _data_->_tmp3_->message;
#line 66 "../src/client/application/goa-mediator.vala"
			g_debug ("goa-mediator.vala:66: GOA updating auth failed, retrying: %s", _data_->_tmp4_);
#line 67 "../src/client/application/goa-mediator.vala"
			_data_->_tmp5_ = _data_->goa_account;
#line 67 "../src/client/application/goa-mediator.vala"
			_data_->_state_ = 2;
#line 67 "../src/client/application/goa-mediator.vala"
			goa_account_call_ensure_credentials (_data_->_tmp5_, _data_->cancellable, goa_mediator_load_token_ready, _data_);
#line 67 "../src/client/application/goa-mediator.vala"
			return FALSE;
#line 641 "goa-mediator.c"
			_state_2:
#line 67 "../src/client/application/goa-mediator.vala"
			goa_account_call_ensure_credentials_finish (_data_->_tmp5_, NULL, _data_->_res_, &_data_->_inner_error0_);
#line 67 "../src/client/application/goa-mediator.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 67 "../src/client/application/goa-mediator.vala"
				_g_error_free0 (_data_->err);
#line 649 "goa-mediator.c"
				goto __finally0;
			}
#line 63 "../src/client/application/goa-mediator.vala"
			_g_error_free0 (_data_->err);
#line 654 "goa-mediator.c"
		}
		__finally0:
#line 63 "../src/client/application/goa-mediator.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 63 "../src/client/application/goa-mediator.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 63 "../src/client/application/goa-mediator.vala"
			_g_object_unref0 (_data_->goa_account);
#line 63 "../src/client/application/goa-mediator.vala"
			g_object_unref (_data_->_async_result);
#line 63 "../src/client/application/goa-mediator.vala"
			return FALSE;
#line 667 "goa-mediator.c"
		}
	}
#line 71 "../src/client/application/goa-mediator.vala"
	_data_->loaded = FALSE;
#line 72 "../src/client/application/goa-mediator.vala"
	_data_->token = NULL;
#line 74 "../src/client/application/goa-mediator.vala"
	_data_->_tmp6_ = goa_mediator_get_auth_method (_data_->self, &_data_->_inner_error0_);
#line 74 "../src/client/application/goa-mediator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 74 "../src/client/application/goa-mediator.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 74 "../src/client/application/goa-mediator.vala"
		_g_free0 (_data_->token);
#line 74 "../src/client/application/goa-mediator.vala"
		_g_object_unref0 (_data_->goa_account);
#line 74 "../src/client/application/goa-mediator.vala"
		g_object_unref (_data_->_async_result);
#line 74 "../src/client/application/goa-mediator.vala"
		return FALSE;
#line 688 "goa-mediator.c"
	}
#line 74 "../src/client/application/goa-mediator.vala"
	switch (_data_->_tmp6_) {
#line 74 "../src/client/application/goa-mediator.vala"
		case GEARY_CREDENTIALS_METHOD_OAUTH2:
#line 694 "goa-mediator.c"
		{
#line 76 "../src/client/application/goa-mediator.vala"
			_data_->_tmp7_ = _data_->self->priv->handle;
#line 76 "../src/client/application/goa-mediator.vala"
			_data_->_tmp8_ = goa_object_get_oauth2_based (_data_->_tmp7_);
#line 76 "../src/client/application/goa-mediator.vala"
			_data_->_tmp9_ = _data_->_tmp8_;
#line 76 "../src/client/application/goa-mediator.vala"
			_data_->_tmp10_ = NULL;
#line 76 "../src/client/application/goa-mediator.vala"
			_data_->_state_ = 3;
#line 76 "../src/client/application/goa-mediator.vala"
			goa_oauth2_based_call_get_access_token (_data_->_tmp9_, _data_->cancellable, goa_mediator_load_token_ready, _data_);
#line 76 "../src/client/application/goa-mediator.vala"
			return FALSE;
#line 710 "goa-mediator.c"
			_state_3:
#line 76 "../src/client/application/goa-mediator.vala"
			goa_oauth2_based_call_get_access_token_finish (_data_->_tmp9_, &_data_->_tmp10_, NULL, _data_->_res_, &_data_->_inner_error0_);
#line 76 "../src/client/application/goa-mediator.vala"
			_g_free0 (_data_->token);
#line 76 "../src/client/application/goa-mediator.vala"
			_data_->token = _data_->_tmp10_;
#line 76 "../src/client/application/goa-mediator.vala"
			_g_object_unref0 (_data_->_tmp9_);
#line 76 "../src/client/application/goa-mediator.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 76 "../src/client/application/goa-mediator.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 76 "../src/client/application/goa-mediator.vala"
				_g_free0 (_data_->token);
#line 76 "../src/client/application/goa-mediator.vala"
				_g_object_unref0 (_data_->goa_account);
#line 76 "../src/client/application/goa-mediator.vala"
				g_object_unref (_data_->_async_result);
#line 76 "../src/client/application/goa-mediator.vala"
				return FALSE;
#line 732 "goa-mediator.c"
			}
#line 79 "../src/client/application/goa-mediator.vala"
			break;
#line 736 "goa-mediator.c"
		}
#line 74 "../src/client/application/goa-mediator.vala"
		case GEARY_CREDENTIALS_METHOD_PASSWORD:
#line 740 "goa-mediator.c"
		{
#line 82 "../src/client/application/goa-mediator.vala"
			_data_->_tmp11_ = geary_service_information_get_protocol (_data_->service);
#line 82 "../src/client/application/goa-mediator.vala"
			_data_->_tmp12_ = _data_->_tmp11_;
#line 82 "../src/client/application/goa-mediator.vala"
			switch (_data_->_tmp12_) {
#line 82 "../src/client/application/goa-mediator.vala"
				case GEARY_PROTOCOL_IMAP:
#line 750 "goa-mediator.c"
				{
#line 84 "../src/client/application/goa-mediator.vala"
					_data_->_tmp13_ = _data_->self->priv->handle;
#line 84 "../src/client/application/goa-mediator.vala"
					_data_->_tmp14_ = goa_object_get_password_based (_data_->_tmp13_);
#line 84 "../src/client/application/goa-mediator.vala"
					_data_->_tmp15_ = _data_->_tmp14_;
#line 84 "../src/client/application/goa-mediator.vala"
					_data_->_tmp16_ = NULL;
#line 84 "../src/client/application/goa-mediator.vala"
					_data_->_state_ = 4;
#line 84 "../src/client/application/goa-mediator.vala"
					goa_password_based_call_get_password (_data_->_tmp15_, "imap-password", _data_->cancellable, goa_mediator_load_token_ready, _data_);
#line 84 "../src/client/application/goa-mediator.vala"
					return FALSE;
#line 766 "goa-mediator.c"
					_state_4:
#line 84 "../src/client/application/goa-mediator.vala"
					goa_password_based_call_get_password_finish (_data_->_tmp15_, &_data_->_tmp16_, _data_->_res_, &_data_->_inner_error0_);
#line 84 "../src/client/application/goa-mediator.vala"
					_g_free0 (_data_->token);
#line 84 "../src/client/application/goa-mediator.vala"
					_data_->token = _data_->_tmp16_;
#line 84 "../src/client/application/goa-mediator.vala"
					_g_object_unref0 (_data_->_tmp15_);
#line 84 "../src/client/application/goa-mediator.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 84 "../src/client/application/goa-mediator.vala"
						g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 84 "../src/client/application/goa-mediator.vala"
						_g_free0 (_data_->token);
#line 84 "../src/client/application/goa-mediator.vala"
						_g_object_unref0 (_data_->goa_account);
#line 84 "../src/client/application/goa-mediator.vala"
						g_object_unref (_data_->_async_result);
#line 84 "../src/client/application/goa-mediator.vala"
						return FALSE;
#line 788 "goa-mediator.c"
					}
#line 87 "../src/client/application/goa-mediator.vala"
					break;
#line 792 "goa-mediator.c"
				}
#line 82 "../src/client/application/goa-mediator.vala"
				case GEARY_PROTOCOL_SMTP:
#line 796 "goa-mediator.c"
				{
#line 90 "../src/client/application/goa-mediator.vala"
					_data_->_tmp17_ = _data_->self->priv->handle;
#line 90 "../src/client/application/goa-mediator.vala"
					_data_->_tmp18_ = goa_object_get_password_based (_data_->_tmp17_);
#line 90 "../src/client/application/goa-mediator.vala"
					_data_->_tmp19_ = _data_->_tmp18_;
#line 90 "../src/client/application/goa-mediator.vala"
					_data_->_tmp20_ = NULL;
#line 90 "../src/client/application/goa-mediator.vala"
					_data_->_state_ = 5;
#line 90 "../src/client/application/goa-mediator.vala"
					goa_password_based_call_get_password (_data_->_tmp19_, "smtp-password", _data_->cancellable, goa_mediator_load_token_ready, _data_);
#line 90 "../src/client/application/goa-mediator.vala"
					return FALSE;
#line 812 "goa-mediator.c"
					_state_5:
#line 90 "../src/client/application/goa-mediator.vala"
					goa_password_based_call_get_password_finish (_data_->_tmp19_, &_data_->_tmp20_, _data_->_res_, &_data_->_inner_error0_);
#line 90 "../src/client/application/goa-mediator.vala"
					_g_free0 (_data_->token);
#line 90 "../src/client/application/goa-mediator.vala"
					_data_->token = _data_->_tmp20_;
#line 90 "../src/client/application/goa-mediator.vala"
					_g_object_unref0 (_data_->_tmp19_);
#line 90 "../src/client/application/goa-mediator.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 90 "../src/client/application/goa-mediator.vala"
						g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 90 "../src/client/application/goa-mediator.vala"
						_g_free0 (_data_->token);
#line 90 "../src/client/application/goa-mediator.vala"
						_g_object_unref0 (_data_->goa_account);
#line 90 "../src/client/application/goa-mediator.vala"
						g_object_unref (_data_->_async_result);
#line 90 "../src/client/application/goa-mediator.vala"
						return FALSE;
#line 834 "goa-mediator.c"
					}
#line 93 "../src/client/application/goa-mediator.vala"
					break;
#line 838 "goa-mediator.c"
				}
				default:
				{
#line 96 "../src/client/application/goa-mediator.vala"
					_data_->result = FALSE;
#line 96 "../src/client/application/goa-mediator.vala"
					_g_free0 (_data_->token);
#line 96 "../src/client/application/goa-mediator.vala"
					_g_object_unref0 (_data_->goa_account);
#line 96 "../src/client/application/goa-mediator.vala"
					g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 96 "../src/client/application/goa-mediator.vala"
					if (_data_->_state_ != 0) {
#line 96 "../src/client/application/goa-mediator.vala"
						while (!g_task_get_completed (_data_->_async_result)) {
#line 96 "../src/client/application/goa-mediator.vala"
							g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 856 "goa-mediator.c"
						}
					}
#line 96 "../src/client/application/goa-mediator.vala"
					g_object_unref (_data_->_async_result);
#line 96 "../src/client/application/goa-mediator.vala"
					return FALSE;
#line 863 "goa-mediator.c"
				}
			}
#line 98 "../src/client/application/goa-mediator.vala"
			break;
#line 868 "goa-mediator.c"
		}
		default:
#line 74 "../src/client/application/goa-mediator.vala"
		break;
#line 873 "goa-mediator.c"
	}
#line 101 "../src/client/application/goa-mediator.vala"
	_data_->_tmp21_ = _data_->token;
#line 101 "../src/client/application/goa-mediator.vala"
	if (_data_->_tmp21_ != NULL) {
#line 102 "../src/client/application/goa-mediator.vala"
		_data_->_tmp22_ = geary_service_information_get_credentials (_data_->service);
#line 102 "../src/client/application/goa-mediator.vala"
		_data_->_tmp23_ = _data_->_tmp22_;
#line 102 "../src/client/application/goa-mediator.vala"
		_data_->_tmp24_ = _data_->token;
#line 102 "../src/client/application/goa-mediator.vala"
		_data_->_tmp25_ = geary_credentials_copy_with_token (_data_->_tmp23_, _data_->_tmp24_);
#line 102 "../src/client/application/goa-mediator.vala"
		_data_->_tmp26_ = _data_->_tmp25_;
#line 102 "../src/client/application/goa-mediator.vala"
		geary_service_information_set_credentials (_data_->service, _data_->_tmp26_);
#line 102 "../src/client/application/goa-mediator.vala"
		_g_object_unref0 (_data_->_tmp26_);
#line 103 "../src/client/application/goa-mediator.vala"
		_data_->loaded = TRUE;
#line 895 "goa-mediator.c"
	}
#line 105 "../src/client/application/goa-mediator.vala"
	_data_->result = _data_->loaded;
#line 105 "../src/client/application/goa-mediator.vala"
	_g_free0 (_data_->token);
#line 105 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->goa_account);
#line 105 "../src/client/application/goa-mediator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 105 "../src/client/application/goa-mediator.vala"
	if (_data_->_state_ != 0) {
#line 105 "../src/client/application/goa-mediator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 105 "../src/client/application/goa-mediator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 911 "goa-mediator.c"
		}
	}
#line 105 "../src/client/application/goa-mediator.vala"
	g_object_unref (_data_->_async_result);
#line 105 "../src/client/application/goa-mediator.vala"
	return FALSE;
#line 918 "goa-mediator.c"
}

void
goa_mediator_load_token (GoaMediator* self,
                         GearyAccountInformation* account,
                         GearyServiceInformation* service,
                         GCancellable* cancellable,
                         GAsyncReadyCallback _callback_,
                         gpointer _user_data_)
{
	GoaMediatorClass* _klass_;
#line 10 "../src/client/application/goa-mediator.vala"
	_klass_ = GOA_MEDIATOR_GET_CLASS (self);
#line 10 "../src/client/application/goa-mediator.vala"
	if (_klass_->load_token) {
#line 10 "../src/client/application/goa-mediator.vala"
		_klass_->load_token (self, account, service, cancellable, _callback_, _user_data_);
#line 936 "goa-mediator.c"
	}
}

gboolean
goa_mediator_load_token_finish (GoaMediator* self,
                                GAsyncResult* _res_,
                                GError** error)
{
	GoaMediatorClass* _klass_;
#line 10 "../src/client/application/goa-mediator.vala"
	_klass_ = GOA_MEDIATOR_GET_CLASS (self);
#line 10 "../src/client/application/goa-mediator.vala"
	if (_klass_->load_token_finish) {
#line 10 "../src/client/application/goa-mediator.vala"
		return _klass_->load_token_finish (self, _res_, error);
#line 952 "goa-mediator.c"
	}
#line 10 "../src/client/application/goa-mediator.vala"
	return FALSE;
#line 956 "goa-mediator.c"
}

static GearyCredentialsMethod
goa_mediator_get_auth_method (GoaMediator* self,
                              GError** error)
{
	GoaObject* _tmp0_;
	GoaOAuth2Based* _tmp1_;
	GoaOAuth2Based* _tmp2_;
	gboolean _tmp3_;
	GoaObject* _tmp4_;
	GoaPasswordBased* _tmp5_;
	GoaPasswordBased* _tmp6_;
	gboolean _tmp7_;
	GError* _tmp8_;
	GError* _inner_error0_ = NULL;
	GearyCredentialsMethod result;
#line 108 "../src/client/application/goa-mediator.vala"
	g_return_val_if_fail (IS_GOA_MEDIATOR (self), 0);
#line 109 "../src/client/application/goa-mediator.vala"
	_tmp0_ = self->priv->handle;
#line 109 "../src/client/application/goa-mediator.vala"
	_tmp1_ = goa_object_get_oauth2_based (_tmp0_);
#line 109 "../src/client/application/goa-mediator.vala"
	_tmp2_ = _tmp1_;
#line 109 "../src/client/application/goa-mediator.vala"
	_tmp3_ = _tmp2_ != NULL;
#line 109 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_tmp2_);
#line 109 "../src/client/application/goa-mediator.vala"
	if (_tmp3_) {
#line 110 "../src/client/application/goa-mediator.vala"
		result = GEARY_CREDENTIALS_METHOD_OAUTH2;
#line 110 "../src/client/application/goa-mediator.vala"
		return result;
#line 992 "goa-mediator.c"
	}
#line 112 "../src/client/application/goa-mediator.vala"
	_tmp4_ = self->priv->handle;
#line 112 "../src/client/application/goa-mediator.vala"
	_tmp5_ = goa_object_get_password_based (_tmp4_);
#line 112 "../src/client/application/goa-mediator.vala"
	_tmp6_ = _tmp5_;
#line 112 "../src/client/application/goa-mediator.vala"
	_tmp7_ = _tmp6_ != NULL;
#line 112 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_tmp6_);
#line 112 "../src/client/application/goa-mediator.vala"
	if (_tmp7_) {
#line 113 "../src/client/application/goa-mediator.vala"
		result = GEARY_CREDENTIALS_METHOD_PASSWORD;
#line 113 "../src/client/application/goa-mediator.vala"
		return result;
#line 1010 "goa-mediator.c"
	}
#line 115 "../src/client/application/goa-mediator.vala"
	_tmp8_ = g_error_new_literal (GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_UNSUPPORTED, "GOA account supports neither password or OAuth2 auth");
#line 115 "../src/client/application/goa-mediator.vala"
	_inner_error0_ = _tmp8_;
#line 115 "../src/client/application/goa-mediator.vala"
	g_propagate_error (error, _inner_error0_);
#line 115 "../src/client/application/goa-mediator.vala"
	return 0;
#line 1020 "goa-mediator.c"
}

static void
goa_mediator_update_imap_config (GoaMediator* self,
                                 GearyServiceInformation* service,
                                 GError** error)
{
	GoaMail* mail = NULL;
	GoaObject* _tmp0_;
	GoaMail* _tmp1_;
	GoaMail* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 120 "../src/client/application/goa-mediator.vala"
	g_return_if_fail (IS_GOA_MEDIATOR (self));
#line 120 "../src/client/application/goa-mediator.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (service, GEARY_TYPE_SERVICE_INFORMATION));
#line 122 "../src/client/application/goa-mediator.vala"
	_tmp0_ = self->priv->handle;
#line 122 "../src/client/application/goa-mediator.vala"
	_tmp1_ = goa_object_get_mail (_tmp0_);
#line 122 "../src/client/application/goa-mediator.vala"
	mail = _tmp1_;
#line 123 "../src/client/application/goa-mediator.vala"
	_tmp2_ = mail;
#line 123 "../src/client/application/goa-mediator.vala"
	if (_tmp2_ != NULL) {
#line 1047 "goa-mediator.c"
		GoaMail* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GoaMail* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
		GearyCredentialsMethod _tmp13_ = 0;
		GoaMail* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		GearyCredentials* _tmp18_;
		GearyCredentials* _tmp19_;
		guint16 _tmp20_;
		guint16 _tmp21_;
#line 124 "../src/client/application/goa-mediator.vala"
		_tmp3_ = mail;
#line 124 "../src/client/application/goa-mediator.vala"
		g_object_get (_tmp3_, "imap-host", &_tmp4_, NULL);
#line 124 "../src/client/application/goa-mediator.vala"
		_tmp5_ = _tmp4_;
#line 124 "../src/client/application/goa-mediator.vala"
		_tmp6_ = _tmp5_;
#line 124 "../src/client/application/goa-mediator.vala"
		goa_mediator_parse_host_name (self, service, _tmp6_);
#line 124 "../src/client/application/goa-mediator.vala"
		_g_free0 (_tmp6_);
#line 126 "../src/client/application/goa-mediator.vala"
		_tmp7_ = mail;
#line 126 "../src/client/application/goa-mediator.vala"
		g_object_get (_tmp7_, "imap-use-ssl", &_tmp8_, NULL);
#line 126 "../src/client/application/goa-mediator.vala"
		_tmp9_ = _tmp8_;
#line 126 "../src/client/application/goa-mediator.vala"
		if (_tmp9_) {
#line 127 "../src/client/application/goa-mediator.vala"
			geary_service_information_set_transport_security (service, GEARY_TLS_NEGOTIATION_METHOD_TRANSPORT);
#line 1086 "goa-mediator.c"
		} else {
			GoaMail* _tmp10_;
			gboolean _tmp11_;
			gboolean _tmp12_;
#line 128 "../src/client/application/goa-mediator.vala"
			_tmp10_ = mail;
#line 128 "../src/client/application/goa-mediator.vala"
			g_object_get (_tmp10_, "imap-use-tls", &_tmp11_, NULL);
#line 128 "../src/client/application/goa-mediator.vala"
			_tmp12_ = _tmp11_;
#line 128 "../src/client/application/goa-mediator.vala"
			if (_tmp12_) {
#line 129 "../src/client/application/goa-mediator.vala"
				geary_service_information_set_transport_security (service, GEARY_TLS_NEGOTIATION_METHOD_START_TLS);
#line 1101 "goa-mediator.c"
			} else {
#line 131 "../src/client/application/goa-mediator.vala"
				geary_service_information_set_transport_security (service, GEARY_TLS_NEGOTIATION_METHOD_NONE);
#line 1105 "goa-mediator.c"
			}
		}
#line 135 "../src/client/application/goa-mediator.vala"
		_tmp13_ = goa_mediator_get_auth_method (self, &_inner_error0_);
#line 135 "../src/client/application/goa-mediator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 135 "../src/client/application/goa-mediator.vala"
			g_propagate_error (error, _inner_error0_);
#line 135 "../src/client/application/goa-mediator.vala"
			_g_object_unref0 (mail);
#line 135 "../src/client/application/goa-mediator.vala"
			return;
#line 1118 "goa-mediator.c"
		}
#line 134 "../src/client/application/goa-mediator.vala"
		_tmp14_ = mail;
#line 134 "../src/client/application/goa-mediator.vala"
		g_object_get (_tmp14_, "imap-user-name", &_tmp15_, NULL);
#line 134 "../src/client/application/goa-mediator.vala"
		_tmp16_ = _tmp15_;
#line 134 "../src/client/application/goa-mediator.vala"
		_tmp17_ = _tmp16_;
#line 134 "../src/client/application/goa-mediator.vala"
		_tmp18_ = geary_credentials_new (_tmp13_, _tmp17_, NULL);
#line 134 "../src/client/application/goa-mediator.vala"
		_tmp19_ = _tmp18_;
#line 134 "../src/client/application/goa-mediator.vala"
		geary_service_information_set_credentials (service, _tmp19_);
#line 134 "../src/client/application/goa-mediator.vala"
		_g_object_unref0 (_tmp19_);
#line 134 "../src/client/application/goa-mediator.vala"
		_g_free0 (_tmp17_);
#line 138 "../src/client/application/goa-mediator.vala"
		_tmp20_ = geary_service_information_get_port (service);
#line 138 "../src/client/application/goa-mediator.vala"
		_tmp21_ = _tmp20_;
#line 138 "../src/client/application/goa-mediator.vala"
		if (((gint) _tmp21_) == 0) {
#line 139 "../src/client/application/goa-mediator.vala"
			geary_service_information_set_port (service, geary_service_information_get_default_port (service));
#line 1146 "goa-mediator.c"
		}
	}
#line 120 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (mail);
#line 1151 "goa-mediator.c"
}

static void
goa_mediator_update_smtp_config (GoaMediator* self,
                                 GearyServiceInformation* service,
                                 GError** error)
{
	GoaMail* mail = NULL;
	GoaObject* _tmp0_;
	GoaMail* _tmp1_;
	GoaMail* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 144 "../src/client/application/goa-mediator.vala"
	g_return_if_fail (IS_GOA_MEDIATOR (self));
#line 144 "../src/client/application/goa-mediator.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (service, GEARY_TYPE_SERVICE_INFORMATION));
#line 146 "../src/client/application/goa-mediator.vala"
	_tmp0_ = self->priv->handle;
#line 146 "../src/client/application/goa-mediator.vala"
	_tmp1_ = goa_object_get_mail (_tmp0_);
#line 146 "../src/client/application/goa-mediator.vala"
	mail = _tmp1_;
#line 147 "../src/client/application/goa-mediator.vala"
	_tmp2_ = mail;
#line 147 "../src/client/application/goa-mediator.vala"
	if (_tmp2_ != NULL) {
#line 1178 "goa-mediator.c"
		GoaMail* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GoaMail* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
		GoaMail* _tmp13_;
		gboolean _tmp14_;
		gboolean _tmp15_;
		GoaMail* _tmp16_;
		gboolean _tmp17_;
		gboolean _tmp18_;
		guint16 _tmp26_;
		guint16 _tmp27_;
#line 148 "../src/client/application/goa-mediator.vala"
		_tmp3_ = mail;
#line 148 "../src/client/application/goa-mediator.vala"
		g_object_get (_tmp3_, "smtp-host", &_tmp4_, NULL);
#line 148 "../src/client/application/goa-mediator.vala"
		_tmp5_ = _tmp4_;
#line 148 "../src/client/application/goa-mediator.vala"
		_tmp6_ = _tmp5_;
#line 148 "../src/client/application/goa-mediator.vala"
		goa_mediator_parse_host_name (self, service, _tmp6_);
#line 148 "../src/client/application/goa-mediator.vala"
		_g_free0 (_tmp6_);
#line 150 "../src/client/application/goa-mediator.vala"
		_tmp7_ = mail;
#line 150 "../src/client/application/goa-mediator.vala"
		g_object_get (_tmp7_, "smtp-use-ssl", &_tmp8_, NULL);
#line 150 "../src/client/application/goa-mediator.vala"
		_tmp9_ = _tmp8_;
#line 150 "../src/client/application/goa-mediator.vala"
		if (_tmp9_) {
#line 151 "../src/client/application/goa-mediator.vala"
			geary_service_information_set_transport_security (service, GEARY_TLS_NEGOTIATION_METHOD_TRANSPORT);
#line 1216 "goa-mediator.c"
		} else {
			GoaMail* _tmp10_;
			gboolean _tmp11_;
			gboolean _tmp12_;
#line 152 "../src/client/application/goa-mediator.vala"
			_tmp10_ = mail;
#line 152 "../src/client/application/goa-mediator.vala"
			g_object_get (_tmp10_, "smtp-use-tls", &_tmp11_, NULL);
#line 152 "../src/client/application/goa-mediator.vala"
			_tmp12_ = _tmp11_;
#line 152 "../src/client/application/goa-mediator.vala"
			if (_tmp12_) {
#line 153 "../src/client/application/goa-mediator.vala"
				geary_service_information_set_transport_security (service, GEARY_TLS_NEGOTIATION_METHOD_START_TLS);
#line 1231 "goa-mediator.c"
			} else {
#line 155 "../src/client/application/goa-mediator.vala"
				geary_service_information_set_transport_security (service, GEARY_TLS_NEGOTIATION_METHOD_NONE);
#line 1235 "goa-mediator.c"
			}
		}
#line 158 "../src/client/application/goa-mediator.vala"
		_tmp13_ = mail;
#line 158 "../src/client/application/goa-mediator.vala"
		g_object_get (_tmp13_, "smtp-use-auth", &_tmp14_, NULL);
#line 158 "../src/client/application/goa-mediator.vala"
		_tmp15_ = _tmp14_;
#line 158 "../src/client/application/goa-mediator.vala"
		if (_tmp15_) {
#line 159 "../src/client/application/goa-mediator.vala"
			geary_service_information_set_credentials_requirement (service, GEARY_CREDENTIALS_REQUIREMENT_CUSTOM);
#line 1248 "goa-mediator.c"
		} else {
#line 161 "../src/client/application/goa-mediator.vala"
			geary_service_information_set_credentials_requirement (service, GEARY_CREDENTIALS_REQUIREMENT_NONE);
#line 1252 "goa-mediator.c"
		}
#line 164 "../src/client/application/goa-mediator.vala"
		_tmp16_ = mail;
#line 164 "../src/client/application/goa-mediator.vala"
		g_object_get (_tmp16_, "smtp-use-auth", &_tmp17_, NULL);
#line 164 "../src/client/application/goa-mediator.vala"
		_tmp18_ = _tmp17_;
#line 164 "../src/client/application/goa-mediator.vala"
		if (_tmp18_) {
#line 1262 "goa-mediator.c"
			GearyCredentialsMethod _tmp19_ = 0;
			GoaMail* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			GearyCredentials* _tmp24_;
			GearyCredentials* _tmp25_;
#line 166 "../src/client/application/goa-mediator.vala"
			_tmp19_ = goa_mediator_get_auth_method (self, &_inner_error0_);
#line 166 "../src/client/application/goa-mediator.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 166 "../src/client/application/goa-mediator.vala"
				g_propagate_error (error, _inner_error0_);
#line 166 "../src/client/application/goa-mediator.vala"
				_g_object_unref0 (mail);
#line 166 "../src/client/application/goa-mediator.vala"
				return;
#line 1280 "goa-mediator.c"
			}
#line 165 "../src/client/application/goa-mediator.vala"
			_tmp20_ = mail;
#line 165 "../src/client/application/goa-mediator.vala"
			g_object_get (_tmp20_, "smtp-user-name", &_tmp21_, NULL);
#line 165 "../src/client/application/goa-mediator.vala"
			_tmp22_ = _tmp21_;
#line 165 "../src/client/application/goa-mediator.vala"
			_tmp23_ = _tmp22_;
#line 165 "../src/client/application/goa-mediator.vala"
			_tmp24_ = geary_credentials_new (_tmp19_, _tmp23_, NULL);
#line 165 "../src/client/application/goa-mediator.vala"
			_tmp25_ = _tmp24_;
#line 165 "../src/client/application/goa-mediator.vala"
			geary_service_information_set_credentials (service, _tmp25_);
#line 165 "../src/client/application/goa-mediator.vala"
			_g_object_unref0 (_tmp25_);
#line 165 "../src/client/application/goa-mediator.vala"
			_g_free0 (_tmp23_);
#line 1300 "goa-mediator.c"
		}
#line 170 "../src/client/application/goa-mediator.vala"
		_tmp26_ = geary_service_information_get_port (service);
#line 170 "../src/client/application/goa-mediator.vala"
		_tmp27_ = _tmp26_;
#line 170 "../src/client/application/goa-mediator.vala"
		if (((gint) _tmp27_) == 0) {
#line 171 "../src/client/application/goa-mediator.vala"
			geary_service_information_set_port (service, geary_service_information_get_default_port (service));
#line 1310 "goa-mediator.c"
		}
	}
#line 144 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (mail);
#line 1315 "goa-mediator.c"
}

static void
goa_mediator_parse_host_name (GoaMediator* self,
                              GearyServiceInformation* service,
                              const gchar* host_name)
{
	GError* _inner_error0_ = NULL;
#line 176 "../src/client/application/goa-mediator.vala"
	g_return_if_fail (IS_GOA_MEDIATOR (self));
#line 176 "../src/client/application/goa-mediator.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (service, GEARY_TYPE_SERVICE_INFORMATION));
#line 176 "../src/client/application/goa-mediator.vala"
	g_return_if_fail (host_name != NULL);
#line 181 "../src/client/application/goa-mediator.vala"
	geary_service_information_set_host (service, host_name);
#line 182 "../src/client/application/goa-mediator.vala"
	geary_service_information_set_port (service, (guint16) 0);
#line 1334 "goa-mediator.c"
	{
		GNetworkAddress* address = NULL;
		guint16 _tmp0_;
		guint16 _tmp1_;
		GNetworkAddress* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		guint _tmp5_;
		guint _tmp6_;
#line 185 "../src/client/application/goa-mediator.vala"
		_tmp0_ = geary_service_information_get_port (service);
#line 185 "../src/client/application/goa-mediator.vala"
		_tmp1_ = _tmp0_;
#line 185 "../src/client/application/goa-mediator.vala"
		_tmp2_ = g_network_address_parse (host_name, _tmp1_, &_inner_error0_);
#line 185 "../src/client/application/goa-mediator.vala"
		address = _tmp2_;
#line 185 "../src/client/application/goa-mediator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1354 "goa-mediator.c"
			goto __catch0_g_error;
		}
#line 189 "../src/client/application/goa-mediator.vala"
		_tmp3_ = g_network_address_get_hostname (address);
#line 189 "../src/client/application/goa-mediator.vala"
		_tmp4_ = _tmp3_;
#line 189 "../src/client/application/goa-mediator.vala"
		geary_service_information_set_host (service, _tmp4_);
#line 190 "../src/client/application/goa-mediator.vala"
		_tmp5_ = g_network_address_get_port (address);
#line 190 "../src/client/application/goa-mediator.vala"
		_tmp6_ = _tmp5_;
#line 190 "../src/client/application/goa-mediator.vala"
		geary_service_information_set_port (service, (guint16) _tmp6_);
#line 184 "../src/client/application/goa-mediator.vala"
		_g_object_unref0 (address);
#line 1371 "goa-mediator.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GoaObject* _tmp7_;
		GoaAccount* _tmp8_;
		GoaAccount* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		GearyProtocol _tmp13_;
		GearyProtocol _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 184 "../src/client/application/goa-mediator.vala"
		err = _inner_error0_;
#line 184 "../src/client/application/goa-mediator.vala"
		_inner_error0_ = NULL;
#line 192 "../src/client/application/goa-mediator.vala"
		_tmp7_ = self->priv->handle;
#line 192 "../src/client/application/goa-mediator.vala"
		_tmp8_ = goa_object_get_account (_tmp7_);
#line 192 "../src/client/application/goa-mediator.vala"
		_tmp9_ = _tmp8_;
#line 192 "../src/client/application/goa-mediator.vala"
		g_object_get (_tmp9_, "id", &_tmp10_, NULL);
#line 192 "../src/client/application/goa-mediator.vala"
		_tmp11_ = _tmp10_;
#line 192 "../src/client/application/goa-mediator.vala"
		_tmp12_ = _tmp11_;
#line 192 "../src/client/application/goa-mediator.vala"
		_tmp13_ = geary_service_information_get_protocol (service);
#line 192 "../src/client/application/goa-mediator.vala"
		_tmp14_ = _tmp13_;
#line 192 "../src/client/application/goa-mediator.vala"
		_tmp15_ = geary_protocol_to_value (_tmp14_);
#line 192 "../src/client/application/goa-mediator.vala"
		_tmp16_ = _tmp15_;
#line 192 "../src/client/application/goa-mediator.vala"
		_tmp17_ = err;
#line 192 "../src/client/application/goa-mediator.vala"
		_tmp18_ = _tmp17_->message;
#line 192 "../src/client/application/goa-mediator.vala"
		g_warning ("goa-mediator.vala:192: GOA account \"%s\" %s hostname \"%s\": %", _tmp12_, _tmp16_, host_name, _tmp18_);
#line 192 "../src/client/application/goa-mediator.vala"
		_g_free0 (_tmp16_);
#line 192 "../src/client/application/goa-mediator.vala"
		_g_free0 (_tmp12_);
#line 192 "../src/client/application/goa-mediator.vala"
		_g_object_unref0 (_tmp9_);
#line 184 "../src/client/application/goa-mediator.vala"
		_g_error_free0 (err);
#line 1427 "goa-mediator.c"
	}
	__finally0:
#line 184 "../src/client/application/goa-mediator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 184 "../src/client/application/goa-mediator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 184 "../src/client/application/goa-mediator.vala"
		g_clear_error (&_inner_error0_);
#line 184 "../src/client/application/goa-mediator.vala"
		return;
#line 1438 "goa-mediator.c"
	}
}

static void
goa_mediator_class_init (GoaMediatorClass * klass,
                         gpointer klass_data)
{
#line 10 "../src/client/application/goa-mediator.vala"
	goa_mediator_parent_class = g_type_class_peek_parent (klass);
#line 10 "../src/client/application/goa-mediator.vala"
	g_type_class_adjust_private_offset (klass, &GoaMediator_private_offset);
#line 10 "../src/client/application/goa-mediator.vala"
	((GoaMediatorClass *) klass)->load_token = (void (*) (GoaMediator*, GearyAccountInformation*, GearyServiceInformation*, GCancellable*, GAsyncReadyCallback, gpointer)) goa_mediator_real_load_token;
#line 10 "../src/client/application/goa-mediator.vala"
	((GoaMediatorClass *) klass)->load_token_finish = (gboolean (*) (GoaMediator*, GAsyncResult*, GError**)) goa_mediator_real_load_token_finish;
#line 10 "../src/client/application/goa-mediator.vala"
	G_OBJECT_CLASS (klass)->finalize = goa_mediator_finalize;
#line 1456 "goa-mediator.c"
}

static void
goa_mediator_geary_credentials_mediator_interface_init (GearyCredentialsMediatorIface * iface,
                                                        gpointer iface_data)
{
#line 10 "../src/client/application/goa-mediator.vala"
	goa_mediator_geary_credentials_mediator_parent_iface = g_type_interface_peek_parent (iface);
#line 10 "../src/client/application/goa-mediator.vala"
	iface->load_token = (void (*) (GearyCredentialsMediator*, GearyAccountInformation*, GearyServiceInformation*, GCancellable*, GAsyncReadyCallback, gpointer)) goa_mediator_load_token;
#line 10 "../src/client/application/goa-mediator.vala"
	iface->load_token_finish = (gboolean (*) (GearyCredentialsMediator*, GAsyncResult*, GError**)) goa_mediator_load_token_finish;
#line 1469 "goa-mediator.c"
}

static void
goa_mediator_instance_init (GoaMediator * self,
                            gpointer klass)
{
#line 10 "../src/client/application/goa-mediator.vala"
	self->priv = goa_mediator_get_instance_private (self);
#line 1478 "goa-mediator.c"
}

static void
goa_mediator_finalize (GObject * obj)
{
	GoaMediator * self;
#line 10 "../src/client/application/goa-mediator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GOA_MEDIATOR, GoaMediator);
#line 13 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (self->priv->handle);
#line 10 "../src/client/application/goa-mediator.vala"
	G_OBJECT_CLASS (goa_mediator_parent_class)->finalize (obj);
#line 1491 "goa-mediator.c"
}

/** GNOME Online Accounts token adapter. */
static GType
goa_mediator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GoaMediatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) goa_mediator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GoaMediator), 0, (GInstanceInitFunc) goa_mediator_instance_init, NULL };
	static const GInterfaceInfo geary_credentials_mediator_info = { (GInterfaceInitFunc) goa_mediator_geary_credentials_mediator_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType goa_mediator_type_id;
	goa_mediator_type_id = g_type_register_static (G_TYPE_OBJECT, "GoaMediator", &g_define_type_info, 0);
	g_type_add_interface_static (goa_mediator_type_id, GEARY_TYPE_CREDENTIALS_MEDIATOR, &geary_credentials_mediator_info);
	GoaMediator_private_offset = g_type_add_instance_private (goa_mediator_type_id, sizeof (GoaMediatorPrivate));
	return goa_mediator_type_id;
}

GType
goa_mediator_get_type (void)
{
	static volatile gsize goa_mediator_type_id__once = 0;
	if (g_once_init_enter (&goa_mediator_type_id__once)) {
		GType goa_mediator_type_id;
		goa_mediator_type_id = goa_mediator_get_type_once ();
		g_once_init_leave (&goa_mediator_type_id__once, goa_mediator_type_id);
	}
	return goa_mediator_type_id__once;
}

