/* secret-mediator.c generated by valac 0.56.17, the Vala compiler
 * generated from secret-mediator.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-client-46.0.h"
#include <gio/gio.h>
#include "geary-engine.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <libsecret/secret.h>
#include <glib-object.h>

#define SECRET_MEDIATOR_ATTR_LOGIN "login"
#define SECRET_MEDIATOR_ATTR_HOST "host"
#define SECRET_MEDIATOR_ATTR_PROTO "proto"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SECRET_MEDIATOR_0_PROPERTY,
	SECRET_MEDIATOR_NUM_PROPERTIES
};
static GParamSpec* secret_mediator_properties[SECRET_MEDIATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _SecretMediatorNewData SecretMediatorNewData;
typedef struct _SecretMediatorLoadTokenData SecretMediatorLoadTokenData;
typedef struct _SecretMediatorUpdateTokenData SecretMediatorUpdateTokenData;
typedef struct _SecretMediatorClearTokenData SecretMediatorClearTokenData;
typedef struct _SecretMediatorCheckUnlockedData SecretMediatorCheckUnlockedData;
typedef struct _SecretMediatorDoStoreData SecretMediatorDoStoreData;
typedef struct _SecretMediatorMigrateOldPasswordData SecretMediatorMigrateOldPasswordData;

struct _SecretMediatorNewData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GType object_type;
	SecretMediator* self;
	ApplicationClient* application;
	GCancellable* cancellable;
	gboolean _tmp0_;
	gboolean _tmp1_;
	SecretSchema* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GError* _inner_error0_;
};

struct _SecretMediatorLoadTokenData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SecretMediator* self;
	GearyAccountInformation* account;
	GearyServiceInformation* service;
	GCancellable* cancellable;
	gboolean result;
	gboolean loaded;
	GearyCredentials* _tmp0_;
	GearyCredentials* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gchar* password;
	SecretSchema* _tmp4_;
	GHashTable* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	GearyCredentials* _tmp12_;
	GearyCredentials* _tmp13_;
	const gchar* _tmp14_;
	GearyCredentials* _tmp15_;
	GearyCredentials* _tmp16_;
	GearyCredentials* _tmp17_;
	GearyCredentials* _tmp18_;
	GError* _inner_error0_;
};

struct _SecretMediatorUpdateTokenData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SecretMediator* self;
	GearyAccountInformation* account;
	GearyServiceInformation* service;
	GCancellable* cancellable;
	GearyCredentials* _tmp0_;
	GearyCredentials* _tmp1_;
	GearyCredentials* _tmp2_;
	GearyCredentials* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GError* _inner_error0_;
};

struct _SecretMediatorClearTokenData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SecretMediator* self;
	GearyAccountInformation* account;
	GearyServiceInformation* service;
	GCancellable* cancellable;
	GearyCredentials* _tmp0_;
	GearyCredentials* _tmp1_;
	SecretSchema* _tmp2_;
	GHashTable* _tmp3_;
	SecretSchema* _tmp4_;
	GearyRFC822MailboxAddress* _tmp5_;
	GearyRFC822MailboxAddress* _tmp6_;
	GearyRFC822MailboxAddress* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	SecretSchema* _tmp12_;
	GearyCredentials* _tmp13_;
	GearyCredentials* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GError* _inner_error0_;
};

struct _SecretMediatorCheckUnlockedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SecretMediator* self;
	GCancellable* cancellable;
	SecretService* service;
	SecretService* _tmp0_;
	SecretCollection* collection;
	SecretService* _tmp1_;
	SecretCollection* _tmp2_;
	gboolean _tmp3_;
	SecretCollection* _tmp4_;
	SecretCollection* _tmp5_;
	GList* to_lock;
	SecretCollection* _tmp6_;
	SecretCollection* _tmp7_;
	GList* unlocked;
	SecretService* _tmp8_;
	GList* _tmp9_;
	GList* _tmp10_;
	GList* _tmp11_;
	GError* _inner_error0_;
};

struct _SecretMediatorDoStoreData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SecretMediator* self;
	GearyServiceInformation* service;
	gchar* password;
	GCancellable* cancellable;
	SecretSchema* _tmp0_;
	GHashTable* _tmp1_;
	GearyProtocol _tmp2_;
	GearyProtocol _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GError* _inner_error0_;
};

struct _SecretMediatorMigrateOldPasswordData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SecretMediator* self;
	GearyServiceInformation* service;
	GCancellable* cancellable;
	gchar* result;
	gchar* user;
	GearyCredentials* _tmp0_;
	GearyCredentials* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* password;
	SecretSchema* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	SecretSchema* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	GError* _inner_error0_;
};

static gpointer secret_mediator_parent_class = NULL;
static SecretSchema* secret_mediator_schema;
static SecretSchema* secret_mediator_schema = NULL;
static SecretSchema* secret_mediator_compat_schema;
static SecretSchema* secret_mediator_compat_schema = NULL;
static GearyCredentialsMediatorIface * secret_mediator_geary_credentials_mediator_parent_iface = NULL;

static void secret_mediator_construct_data_free (gpointer _data);
static gboolean secret_mediator_construct_co (SecretMediatorNewData* _data_);
static void secret_mediator_check_unlocked (SecretMediator* self,
                                     GCancellable* cancellable,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
static void secret_mediator_check_unlocked_finish (SecretMediator* self,
                                            GAsyncResult* _res_,
                                            GError** error);
static void secret_mediator_new_ready (GObject* source_object,
                                GAsyncResult* _res_,
                                gpointer _user_data_);
static void secret_mediator_real_load_token_data_free (gpointer _data);
static void secret_mediator_real_load_token (SecretMediator* self,
                                      GearyAccountInformation* account,
                                      GearyServiceInformation* service,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static gboolean secret_mediator_real_load_token_co (SecretMediatorLoadTokenData* _data_);
static GHashTable* secret_mediator_new_attrs (SecretMediator* self,
                                       GearyServiceInformation* service);
static void secret_mediator_load_token_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_);
static void secret_mediator_migrate_old_password (SecretMediator* self,
                                           GearyServiceInformation* service,
                                           GCancellable* cancellable,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
static gchar* secret_mediator_migrate_old_password_finish (SecretMediator* self,
                                                    GAsyncResult* _res_,
                                                    GError** error);
static void secret_mediator_update_token_data_free (gpointer _data);
static gboolean secret_mediator_update_token_co (SecretMediatorUpdateTokenData* _data_);
static void secret_mediator_do_store (SecretMediator* self,
                               GearyServiceInformation* service,
                               const gchar* password,
                               GCancellable* cancellable,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
static void secret_mediator_do_store_finish (SecretMediator* self,
                                      GAsyncResult* _res_,
                                      GError** error);
static void secret_mediator_update_token_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_);
static void secret_mediator_clear_token_data_free (gpointer _data);
static gboolean secret_mediator_clear_token_co (SecretMediatorClearTokenData* _data_);
static void secret_mediator_clear_token_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_);
static gchar* secret_mediator_get_legacy_user (SecretMediator* self,
                                        GearyServiceInformation* service,
                                        const gchar* user);
static void secret_mediator_check_unlocked_data_free (gpointer _data);
static gboolean secret_mediator_check_unlocked_co (SecretMediatorCheckUnlockedData* _data_);
static void secret_mediator_check_unlocked_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void secret_mediator_do_store_data_free (gpointer _data);
static gboolean secret_mediator_do_store_co (SecretMediatorDoStoreData* _data_);
static inline gchar* secret_mediator_to_proto_value (SecretMediator* self,
                                       GearyProtocol protocol);
static void secret_mediator_do_store_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_);
static void _g_free0_ (gpointer var);
static void secret_mediator_migrate_old_password_data_free (gpointer _data);
static gboolean secret_mediator_migrate_old_password_co (SecretMediatorMigrateOldPasswordData* _data_);
static void secret_mediator_migrate_old_password_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_);
static void secret_mediator_finalize (GObject * obj);
static GType secret_mediator_get_type_once (void);

static void
secret_mediator_construct_data_free (gpointer _data)
{
	SecretMediatorNewData* _data_;
	_data_ = _data;
#line 39 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->application);
#line 39 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->cancellable);
#line 39 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->self);
#line 39 "../src/client/application/secret-mediator.vala"
	g_slice_free (SecretMediatorNewData, _data_);
#line 318 "secret-mediator.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 39 "../src/client/application/secret-mediator.vala"
	return self ? g_object_ref (self) : NULL;
#line 326 "secret-mediator.c"
}

void
secret_mediator_construct (GType object_type,
                           ApplicationClient* application,
                           GCancellable* cancellable,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_)
{
	SecretMediatorNewData* _data_;
	ApplicationClient* _tmp0_;
	GCancellable* _tmp1_;
#line 39 "../src/client/application/secret-mediator.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (application));
#line 39 "../src/client/application/secret-mediator.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 39 "../src/client/application/secret-mediator.vala"
	_data_ = g_slice_new0 (SecretMediatorNewData);
#line 39 "../src/client/application/secret-mediator.vala"
	_data_->_async_result = g_task_new (NULL, cancellable, _callback_, _user_data_);
#line 39 "../src/client/application/secret-mediator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, secret_mediator_construct_data_free);
#line 39 "../src/client/application/secret-mediator.vala"
	_data_->object_type = object_type;
#line 39 "../src/client/application/secret-mediator.vala"
	_tmp0_ = _g_object_ref0 (application);
#line 39 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->application);
#line 39 "../src/client/application/secret-mediator.vala"
	_data_->application = _tmp0_;
#line 39 "../src/client/application/secret-mediator.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 39 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->cancellable);
#line 39 "../src/client/application/secret-mediator.vala"
	_data_->cancellable = _tmp1_;
#line 39 "../src/client/application/secret-mediator.vala"
	secret_mediator_construct_co (_data_);
#line 365 "secret-mediator.c"
}

SecretMediator*
secret_mediator_construct_finish (GAsyncResult* _res_,
                                  GError** error)
{
	SecretMediator* result;
	SecretMediatorNewData* _data_;
#line 39 "../src/client/application/secret-mediator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 39 "../src/client/application/secret-mediator.vala"
	if (NULL == _data_) {
#line 39 "../src/client/application/secret-mediator.vala"
		return NULL;
#line 380 "secret-mediator.c"
	}
#line 39 "../src/client/application/secret-mediator.vala"
	result = _data_->self;
#line 39 "../src/client/application/secret-mediator.vala"
	_data_->self = NULL;
#line 39 "../src/client/application/secret-mediator.vala"
	return result;
#line 388 "secret-mediator.c"
}

static void
secret_mediator_new_ready (GObject* source_object,
                           GAsyncResult* _res_,
                           gpointer _user_data_)
{
	SecretMediatorNewData* _data_;
#line 42 "../src/client/application/secret-mediator.vala"
	_data_ = _user_data_;
#line 42 "../src/client/application/secret-mediator.vala"
	_data_->_source_object_ = source_object;
#line 42 "../src/client/application/secret-mediator.vala"
	_data_->_res_ = _res_;
#line 42 "../src/client/application/secret-mediator.vala"
	secret_mediator_construct_co (_data_);
#line 405 "secret-mediator.c"
}

static gboolean
secret_mediator_construct_co (SecretMediatorNewData* _data_)
{
#line 39 "../src/client/application/secret-mediator.vala"
	switch (_data_->_state_) {
#line 39 "../src/client/application/secret-mediator.vala"
		case 0:
#line 415 "secret-mediator.c"
		goto _state_0;
#line 39 "../src/client/application/secret-mediator.vala"
		case 1:
#line 419 "secret-mediator.c"
		goto _state_1;
#line 39 "../src/client/application/secret-mediator.vala"
		case 2:
#line 423 "secret-mediator.c"
		goto _state_2;
		default:
#line 39 "../src/client/application/secret-mediator.vala"
		g_assert_not_reached ();
#line 428 "secret-mediator.c"
	}
	_state_0:
#line 39 "../src/client/application/secret-mediator.vala"
	_data_->self = (SecretMediator*) g_object_new (_data_->object_type, NULL);
#line 42 "../src/client/application/secret-mediator.vala"
	_data_->_state_ = 1;
#line 42 "../src/client/application/secret-mediator.vala"
	secret_mediator_check_unlocked (_data_->self, _data_->cancellable, secret_mediator_new_ready, _data_);
#line 42 "../src/client/application/secret-mediator.vala"
	return FALSE;
#line 439 "secret-mediator.c"
	_state_1:
#line 42 "../src/client/application/secret-mediator.vala"
	secret_mediator_check_unlocked_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 42 "../src/client/application/secret-mediator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 42 "../src/client/application/secret-mediator.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 42 "../src/client/application/secret-mediator.vala"
		g_object_unref (_data_->_async_result);
#line 42 "../src/client/application/secret-mediator.vala"
		return FALSE;
#line 451 "secret-mediator.c"
	}
#line 44 "../src/client/application/secret-mediator.vala"
	_data_->_tmp0_ = application_client_get_is_flatpak_sandboxed (_data_->application);
#line 44 "../src/client/application/secret-mediator.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 44 "../src/client/application/secret-mediator.vala"
	if (_data_->_tmp1_) {
#line 45 "../src/client/application/secret-mediator.vala"
		_data_->_tmp2_ = secret_mediator_schema;
#line 45 "../src/client/application/secret-mediator.vala"
		_data_->_state_ = 2;
#line 45 "../src/client/application/secret-mediator.vala"
		secret_password_lookup (_data_->_tmp2_, _data_->cancellable, secret_mediator_new_ready, _data_, SECRET_MEDIATOR_ATTR_LOGIN, "", NULL);
#line 45 "../src/client/application/secret-mediator.vala"
		return FALSE;
#line 467 "secret-mediator.c"
		_state_2:
#line 45 "../src/client/application/secret-mediator.vala"
		_data_->_tmp3_ = secret_password_lookup_finish (_data_->_res_, &_data_->_inner_error0_);
#line 45 "../src/client/application/secret-mediator.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 45 "../src/client/application/secret-mediator.vala"
		_g_free0 (_data_->_tmp4_);
#line 45 "../src/client/application/secret-mediator.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 45 "../src/client/application/secret-mediator.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 45 "../src/client/application/secret-mediator.vala"
			g_object_unref (_data_->_async_result);
#line 45 "../src/client/application/secret-mediator.vala"
			return FALSE;
#line 483 "secret-mediator.c"
		}
	}
#line 39 "../src/client/application/secret-mediator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 39 "../src/client/application/secret-mediator.vala"
	if (_data_->_state_ != 0) {
#line 39 "../src/client/application/secret-mediator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 39 "../src/client/application/secret-mediator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 494 "secret-mediator.c"
		}
	}
#line 39 "../src/client/application/secret-mediator.vala"
	g_object_unref (_data_->_async_result);
#line 39 "../src/client/application/secret-mediator.vala"
	return FALSE;
#line 501 "secret-mediator.c"
}

void
secret_mediator_new (ApplicationClient* application,
                     GCancellable* cancellable,
                     GAsyncReadyCallback _callback_,
                     gpointer _user_data_)
{
#line 39 "../src/client/application/secret-mediator.vala"
	secret_mediator_construct (TYPE_SECRET_MEDIATOR, application, cancellable, _callback_, _user_data_);
#line 512 "secret-mediator.c"
}

SecretMediator*
secret_mediator_new_finish (GAsyncResult* _res_,
                            GError** error)
{
#line 39 "../src/client/application/secret-mediator.vala"
	return secret_mediator_construct_finish (_res_, error);
#line 521 "secret-mediator.c"
}

static void
secret_mediator_real_load_token_data_free (gpointer _data)
{
	SecretMediatorLoadTokenData* _data_;
	_data_ = _data;
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->account);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->service);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->self);
#line 9 "../src/client/application/secret-mediator.vala"
	g_slice_free (SecretMediatorLoadTokenData, _data_);
#line 539 "secret-mediator.c"
}

static void
secret_mediator_real_load_token (SecretMediator* self,
                                 GearyAccountInformation* account,
                                 GearyServiceInformation* service,
                                 GCancellable* cancellable,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	SecretMediatorLoadTokenData* _data_;
	SecretMediator* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GearyServiceInformation* _tmp2_;
	GCancellable* _tmp3_;
#line 9 "../src/client/application/secret-mediator.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 9 "../src/client/application/secret-mediator.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (service, GEARY_TYPE_SERVICE_INFORMATION));
#line 9 "../src/client/application/secret-mediator.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 9 "../src/client/application/secret-mediator.vala"
	_data_ = g_slice_new0 (SecretMediatorLoadTokenData);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 9 "../src/client/application/secret-mediator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, secret_mediator_real_load_token_data_free);
#line 9 "../src/client/application/secret-mediator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->self = _tmp0_;
#line 9 "../src/client/application/secret-mediator.vala"
	_tmp1_ = _g_object_ref0 (account);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->account);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->account = _tmp1_;
#line 9 "../src/client/application/secret-mediator.vala"
	_tmp2_ = _g_object_ref0 (service);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->service);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->service = _tmp2_;
#line 9 "../src/client/application/secret-mediator.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->cancellable = _tmp3_;
#line 9 "../src/client/application/secret-mediator.vala"
	secret_mediator_real_load_token_co (_data_);
#line 591 "secret-mediator.c"
}

static gboolean
secret_mediator_real_load_token_finish (SecretMediator* self,
                                        GAsyncResult* _res_,
                                        GError** error)
{
	gboolean result;
	SecretMediatorLoadTokenData* _data_;
#line 9 "../src/client/application/secret-mediator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 9 "../src/client/application/secret-mediator.vala"
	if (NULL == _data_) {
#line 605 "secret-mediator.c"
		gboolean _tmp0_ = FALSE;
#line 9 "../src/client/application/secret-mediator.vala"
		return _tmp0_;
#line 609 "secret-mediator.c"
	}
#line 9 "../src/client/application/secret-mediator.vala"
	result = _data_->result;
#line 9 "../src/client/application/secret-mediator.vala"
	return result;
#line 615 "secret-mediator.c"
}

static void
secret_mediator_load_token_ready (GObject* source_object,
                                  GAsyncResult* _res_,
                                  gpointer _user_data_)
{
	SecretMediatorLoadTokenData* _data_;
#line 61 "../src/client/application/secret-mediator.vala"
	_data_ = _user_data_;
#line 61 "../src/client/application/secret-mediator.vala"
	_data_->_source_object_ = source_object;
#line 61 "../src/client/application/secret-mediator.vala"
	_data_->_res_ = _res_;
#line 61 "../src/client/application/secret-mediator.vala"
	secret_mediator_real_load_token_co (_data_);
#line 632 "secret-mediator.c"
}

static gboolean
secret_mediator_real_load_token_co (SecretMediatorLoadTokenData* _data_)
{
#line 54 "../src/client/application/secret-mediator.vala"
	switch (_data_->_state_) {
#line 54 "../src/client/application/secret-mediator.vala"
		case 0:
#line 642 "secret-mediator.c"
		goto _state_0;
#line 54 "../src/client/application/secret-mediator.vala"
		case 1:
#line 646 "secret-mediator.c"
		goto _state_1;
#line 54 "../src/client/application/secret-mediator.vala"
		case 2:
#line 650 "secret-mediator.c"
		goto _state_2;
		default:
#line 54 "../src/client/application/secret-mediator.vala"
		g_assert_not_reached ();
#line 655 "secret-mediator.c"
	}
	_state_0:
#line 58 "../src/client/application/secret-mediator.vala"
	_data_->loaded = FALSE;
#line 59 "../src/client/application/secret-mediator.vala"
	_data_->_tmp0_ = geary_service_information_get_credentials (_data_->service);
#line 59 "../src/client/application/secret-mediator.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 59 "../src/client/application/secret-mediator.vala"
	if (_data_->_tmp1_ != NULL) {
#line 60 "../src/client/application/secret-mediator.vala"
		_data_->_tmp2_ = geary_service_information_get_remember_password (_data_->service);
#line 60 "../src/client/application/secret-mediator.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 60 "../src/client/application/secret-mediator.vala"
		if (_data_->_tmp3_) {
#line 61 "../src/client/application/secret-mediator.vala"
			_data_->_tmp4_ = secret_mediator_schema;
#line 61 "../src/client/application/secret-mediator.vala"
			_data_->_tmp5_ = secret_mediator_new_attrs (_data_->self, _data_->service);
#line 61 "../src/client/application/secret-mediator.vala"
			_data_->_state_ = 1;
#line 61 "../src/client/application/secret-mediator.vala"
			secret_password_lookupv (_data_->_tmp4_, _data_->_tmp5_, _data_->cancellable, secret_mediator_load_token_ready, _data_);
#line 61 "../src/client/application/secret-mediator.vala"
			return FALSE;
#line 682 "secret-mediator.c"
			_state_1:
#line 61 "../src/client/application/secret-mediator.vala"
			_data_->_tmp6_ = secret_password_lookup_finish (_data_->_res_, &_data_->_inner_error0_);
#line 61 "../src/client/application/secret-mediator.vala"
			_data_->password = _data_->_tmp6_;
#line 61 "../src/client/application/secret-mediator.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 61 "../src/client/application/secret-mediator.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 61 "../src/client/application/secret-mediator.vala"
				g_object_unref (_data_->_async_result);
#line 61 "../src/client/application/secret-mediator.vala"
				return FALSE;
#line 696 "secret-mediator.c"
			}
#line 65 "../src/client/application/secret-mediator.vala"
			_data_->_tmp7_ = _data_->password;
#line 65 "../src/client/application/secret-mediator.vala"
			if (_data_->_tmp7_ == NULL) {
#line 66 "../src/client/application/secret-mediator.vala"
				_data_->_state_ = 2;
#line 66 "../src/client/application/secret-mediator.vala"
				secret_mediator_migrate_old_password (_data_->self, _data_->service, _data_->cancellable, secret_mediator_load_token_ready, _data_);
#line 66 "../src/client/application/secret-mediator.vala"
				return FALSE;
#line 708 "secret-mediator.c"
				_state_2:
#line 66 "../src/client/application/secret-mediator.vala"
				_data_->_tmp9_ = secret_mediator_migrate_old_password_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 66 "../src/client/application/secret-mediator.vala"
				_data_->_tmp8_ = _data_->_tmp9_;
#line 66 "../src/client/application/secret-mediator.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 66 "../src/client/application/secret-mediator.vala"
					g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 66 "../src/client/application/secret-mediator.vala"
					_g_free0 (_data_->password);
#line 66 "../src/client/application/secret-mediator.vala"
					g_object_unref (_data_->_async_result);
#line 66 "../src/client/application/secret-mediator.vala"
					return FALSE;
#line 724 "secret-mediator.c"
				}
#line 66 "../src/client/application/secret-mediator.vala"
				_data_->_tmp10_ = _data_->_tmp8_;
#line 66 "../src/client/application/secret-mediator.vala"
				_data_->_tmp8_ = NULL;
#line 66 "../src/client/application/secret-mediator.vala"
				_g_free0 (_data_->password);
#line 66 "../src/client/application/secret-mediator.vala"
				_data_->password = _data_->_tmp10_;
#line 65 "../src/client/application/secret-mediator.vala"
				_g_free0 (_data_->_tmp8_);
#line 736 "secret-mediator.c"
			}
#line 69 "../src/client/application/secret-mediator.vala"
			_data_->_tmp11_ = _data_->password;
#line 69 "../src/client/application/secret-mediator.vala"
			if (_data_->_tmp11_ != NULL) {
#line 70 "../src/client/application/secret-mediator.vala"
				_data_->_tmp12_ = geary_service_information_get_credentials (_data_->service);
#line 70 "../src/client/application/secret-mediator.vala"
				_data_->_tmp13_ = _data_->_tmp12_;
#line 70 "../src/client/application/secret-mediator.vala"
				_data_->_tmp14_ = _data_->password;
#line 70 "../src/client/application/secret-mediator.vala"
				_data_->_tmp15_ = geary_credentials_copy_with_token (_data_->_tmp13_, _data_->_tmp14_);
#line 70 "../src/client/application/secret-mediator.vala"
				_data_->_tmp16_ = _data_->_tmp15_;
#line 70 "../src/client/application/secret-mediator.vala"
				geary_service_information_set_credentials (_data_->service, _data_->_tmp16_);
#line 70 "../src/client/application/secret-mediator.vala"
				_g_object_unref0 (_data_->_tmp16_);
#line 72 "../src/client/application/secret-mediator.vala"
				_data_->loaded = TRUE;
#line 758 "secret-mediator.c"
			}
#line 60 "../src/client/application/secret-mediator.vala"
			_g_free0 (_data_->password);
#line 762 "secret-mediator.c"
		} else {
#line 77 "../src/client/application/secret-mediator.vala"
			_data_->_tmp17_ = geary_service_information_get_credentials (_data_->service);
#line 77 "../src/client/application/secret-mediator.vala"
			_data_->_tmp18_ = _data_->_tmp17_;
#line 77 "../src/client/application/secret-mediator.vala"
			_data_->loaded = geary_credentials_is_complete (_data_->_tmp18_);
#line 770 "secret-mediator.c"
		}
	}
#line 81 "../src/client/application/secret-mediator.vala"
	_data_->result = _data_->loaded;
#line 81 "../src/client/application/secret-mediator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 81 "../src/client/application/secret-mediator.vala"
	if (_data_->_state_ != 0) {
#line 81 "../src/client/application/secret-mediator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 81 "../src/client/application/secret-mediator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 783 "secret-mediator.c"
		}
	}
#line 81 "../src/client/application/secret-mediator.vala"
	g_object_unref (_data_->_async_result);
#line 81 "../src/client/application/secret-mediator.vala"
	return FALSE;
#line 790 "secret-mediator.c"
}

void
secret_mediator_load_token (SecretMediator* self,
                            GearyAccountInformation* account,
                            GearyServiceInformation* service,
                            GCancellable* cancellable,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
	SecretMediatorClass* _klass_;
#line 9 "../src/client/application/secret-mediator.vala"
	_klass_ = SECRET_MEDIATOR_GET_CLASS (self);
#line 9 "../src/client/application/secret-mediator.vala"
	if (_klass_->load_token) {
#line 9 "../src/client/application/secret-mediator.vala"
		_klass_->load_token (self, account, service, cancellable, _callback_, _user_data_);
#line 808 "secret-mediator.c"
	}
}

gboolean
secret_mediator_load_token_finish (SecretMediator* self,
                                   GAsyncResult* _res_,
                                   GError** error)
{
	SecretMediatorClass* _klass_;
#line 9 "../src/client/application/secret-mediator.vala"
	_klass_ = SECRET_MEDIATOR_GET_CLASS (self);
#line 9 "../src/client/application/secret-mediator.vala"
	if (_klass_->load_token_finish) {
#line 9 "../src/client/application/secret-mediator.vala"
		return _klass_->load_token_finish (self, _res_, error);
#line 824 "secret-mediator.c"
	}
#line 9 "../src/client/application/secret-mediator.vala"
	return FALSE;
#line 828 "secret-mediator.c"
}

static void
secret_mediator_update_token_data_free (gpointer _data)
{
	SecretMediatorUpdateTokenData* _data_;
	_data_ = _data;
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->account);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->service);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->self);
#line 9 "../src/client/application/secret-mediator.vala"
	g_slice_free (SecretMediatorUpdateTokenData, _data_);
#line 846 "secret-mediator.c"
}

void
secret_mediator_update_token (SecretMediator* self,
                              GearyAccountInformation* account,
                              GearyServiceInformation* service,
                              GCancellable* cancellable,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	SecretMediatorUpdateTokenData* _data_;
	SecretMediator* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GearyServiceInformation* _tmp2_;
	GCancellable* _tmp3_;
#line 9 "../src/client/application/secret-mediator.vala"
	g_return_if_fail (IS_SECRET_MEDIATOR (self));
#line 9 "../src/client/application/secret-mediator.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 9 "../src/client/application/secret-mediator.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (service, GEARY_TYPE_SERVICE_INFORMATION));
#line 9 "../src/client/application/secret-mediator.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 9 "../src/client/application/secret-mediator.vala"
	_data_ = g_slice_new0 (SecretMediatorUpdateTokenData);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 9 "../src/client/application/secret-mediator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, secret_mediator_update_token_data_free);
#line 9 "../src/client/application/secret-mediator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->self = _tmp0_;
#line 9 "../src/client/application/secret-mediator.vala"
	_tmp1_ = _g_object_ref0 (account);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->account);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->account = _tmp1_;
#line 9 "../src/client/application/secret-mediator.vala"
	_tmp2_ = _g_object_ref0 (service);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->service);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->service = _tmp2_;
#line 9 "../src/client/application/secret-mediator.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->cancellable = _tmp3_;
#line 9 "../src/client/application/secret-mediator.vala"
	secret_mediator_update_token_co (_data_);
#line 900 "secret-mediator.c"
}

void
secret_mediator_update_token_finish (SecretMediator* self,
                                     GAsyncResult* _res_,
                                     GError** error)
{
	SecretMediatorUpdateTokenData* _data_;
#line 9 "../src/client/application/secret-mediator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 9 "../src/client/application/secret-mediator.vala"
	if (NULL == _data_) {
#line 9 "../src/client/application/secret-mediator.vala"
		return;
#line 915 "secret-mediator.c"
	}
}

static void
secret_mediator_update_token_ready (GObject* source_object,
                                    GAsyncResult* _res_,
                                    gpointer _user_data_)
{
	SecretMediatorUpdateTokenData* _data_;
#line 89 "../src/client/application/secret-mediator.vala"
	_data_ = _user_data_;
#line 89 "../src/client/application/secret-mediator.vala"
	_data_->_source_object_ = source_object;
#line 89 "../src/client/application/secret-mediator.vala"
	_data_->_res_ = _res_;
#line 89 "../src/client/application/secret-mediator.vala"
	secret_mediator_update_token_co (_data_);
#line 933 "secret-mediator.c"
}

static gboolean
secret_mediator_update_token_co (SecretMediatorUpdateTokenData* _data_)
{
#line 84 "../src/client/application/secret-mediator.vala"
	switch (_data_->_state_) {
#line 84 "../src/client/application/secret-mediator.vala"
		case 0:
#line 943 "secret-mediator.c"
		goto _state_0;
#line 84 "../src/client/application/secret-mediator.vala"
		case 1:
#line 947 "secret-mediator.c"
		goto _state_1;
		default:
#line 84 "../src/client/application/secret-mediator.vala"
		g_assert_not_reached ();
#line 952 "secret-mediator.c"
	}
	_state_0:
#line 88 "../src/client/application/secret-mediator.vala"
	_data_->_tmp0_ = geary_service_information_get_credentials (_data_->service);
#line 88 "../src/client/application/secret-mediator.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 88 "../src/client/application/secret-mediator.vala"
	if (_data_->_tmp1_ != NULL) {
#line 89 "../src/client/application/secret-mediator.vala"
		_data_->_tmp2_ = geary_service_information_get_credentials (_data_->service);
#line 89 "../src/client/application/secret-mediator.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 89 "../src/client/application/secret-mediator.vala"
		_data_->_tmp4_ = geary_credentials_get_token (_data_->_tmp3_);
#line 89 "../src/client/application/secret-mediator.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 89 "../src/client/application/secret-mediator.vala"
		_data_->_state_ = 1;
#line 89 "../src/client/application/secret-mediator.vala"
		secret_mediator_do_store (_data_->self, _data_->service, _data_->_tmp5_, _data_->cancellable, secret_mediator_update_token_ready, _data_);
#line 89 "../src/client/application/secret-mediator.vala"
		return FALSE;
#line 975 "secret-mediator.c"
		_state_1:
#line 89 "../src/client/application/secret-mediator.vala"
		secret_mediator_do_store_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 89 "../src/client/application/secret-mediator.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 89 "../src/client/application/secret-mediator.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 89 "../src/client/application/secret-mediator.vala"
			g_object_unref (_data_->_async_result);
#line 89 "../src/client/application/secret-mediator.vala"
			return FALSE;
#line 987 "secret-mediator.c"
		}
	}
#line 84 "../src/client/application/secret-mediator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 84 "../src/client/application/secret-mediator.vala"
	if (_data_->_state_ != 0) {
#line 84 "../src/client/application/secret-mediator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 84 "../src/client/application/secret-mediator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 998 "secret-mediator.c"
		}
	}
#line 84 "../src/client/application/secret-mediator.vala"
	g_object_unref (_data_->_async_result);
#line 84 "../src/client/application/secret-mediator.vala"
	return FALSE;
#line 1005 "secret-mediator.c"
}

static void
secret_mediator_clear_token_data_free (gpointer _data)
{
	SecretMediatorClearTokenData* _data_;
	_data_ = _data;
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->account);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->service);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->self);
#line 9 "../src/client/application/secret-mediator.vala"
	g_slice_free (SecretMediatorClearTokenData, _data_);
#line 1023 "secret-mediator.c"
}

void
secret_mediator_clear_token (SecretMediator* self,
                             GearyAccountInformation* account,
                             GearyServiceInformation* service,
                             GCancellable* cancellable,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_)
{
	SecretMediatorClearTokenData* _data_;
	SecretMediator* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GearyServiceInformation* _tmp2_;
	GCancellable* _tmp3_;
#line 9 "../src/client/application/secret-mediator.vala"
	g_return_if_fail (IS_SECRET_MEDIATOR (self));
#line 9 "../src/client/application/secret-mediator.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 9 "../src/client/application/secret-mediator.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (service, GEARY_TYPE_SERVICE_INFORMATION));
#line 9 "../src/client/application/secret-mediator.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 9 "../src/client/application/secret-mediator.vala"
	_data_ = g_slice_new0 (SecretMediatorClearTokenData);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 9 "../src/client/application/secret-mediator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, secret_mediator_clear_token_data_free);
#line 9 "../src/client/application/secret-mediator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->self = _tmp0_;
#line 9 "../src/client/application/secret-mediator.vala"
	_tmp1_ = _g_object_ref0 (account);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->account);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->account = _tmp1_;
#line 9 "../src/client/application/secret-mediator.vala"
	_tmp2_ = _g_object_ref0 (service);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->service);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->service = _tmp2_;
#line 9 "../src/client/application/secret-mediator.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->cancellable = _tmp3_;
#line 9 "../src/client/application/secret-mediator.vala"
	secret_mediator_clear_token_co (_data_);
#line 1077 "secret-mediator.c"
}

void
secret_mediator_clear_token_finish (SecretMediator* self,
                                    GAsyncResult* _res_,
                                    GError** error)
{
	SecretMediatorClearTokenData* _data_;
#line 9 "../src/client/application/secret-mediator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 9 "../src/client/application/secret-mediator.vala"
	if (NULL == _data_) {
#line 9 "../src/client/application/secret-mediator.vala"
		return;
#line 1092 "secret-mediator.c"
	}
}

static void
secret_mediator_clear_token_ready (GObject* source_object,
                                   GAsyncResult* _res_,
                                   gpointer _user_data_)
{
	SecretMediatorClearTokenData* _data_;
#line 98 "../src/client/application/secret-mediator.vala"
	_data_ = _user_data_;
#line 98 "../src/client/application/secret-mediator.vala"
	_data_->_source_object_ = source_object;
#line 98 "../src/client/application/secret-mediator.vala"
	_data_->_res_ = _res_;
#line 98 "../src/client/application/secret-mediator.vala"
	secret_mediator_clear_token_co (_data_);
#line 1110 "secret-mediator.c"
}

static gboolean
secret_mediator_clear_token_co (SecretMediatorClearTokenData* _data_)
{
#line 93 "../src/client/application/secret-mediator.vala"
	switch (_data_->_state_) {
#line 93 "../src/client/application/secret-mediator.vala"
		case 0:
#line 1120 "secret-mediator.c"
		goto _state_0;
#line 93 "../src/client/application/secret-mediator.vala"
		case 1:
#line 1124 "secret-mediator.c"
		goto _state_1;
#line 93 "../src/client/application/secret-mediator.vala"
		case 2:
#line 1128 "secret-mediator.c"
		goto _state_2;
#line 93 "../src/client/application/secret-mediator.vala"
		case 3:
#line 1132 "secret-mediator.c"
		goto _state_3;
		default:
#line 93 "../src/client/application/secret-mediator.vala"
		g_assert_not_reached ();
#line 1137 "secret-mediator.c"
	}
	_state_0:
#line 97 "../src/client/application/secret-mediator.vala"
	_data_->_tmp0_ = geary_service_information_get_credentials (_data_->service);
#line 97 "../src/client/application/secret-mediator.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 97 "../src/client/application/secret-mediator.vala"
	if (_data_->_tmp1_ != NULL) {
#line 98 "../src/client/application/secret-mediator.vala"
		_data_->_tmp2_ = secret_mediator_schema;
#line 98 "../src/client/application/secret-mediator.vala"
		_data_->_tmp3_ = secret_mediator_new_attrs (_data_->self, _data_->service);
#line 98 "../src/client/application/secret-mediator.vala"
		_data_->_state_ = 1;
#line 98 "../src/client/application/secret-mediator.vala"
		secret_password_clearv (_data_->_tmp2_, _data_->_tmp3_, _data_->cancellable, secret_mediator_clear_token_ready, _data_);
#line 98 "../src/client/application/secret-mediator.vala"
		return FALSE;
#line 1156 "secret-mediator.c"
		_state_1:
#line 98 "../src/client/application/secret-mediator.vala"
		secret_password_clear_finish (_data_->_res_, &_data_->_inner_error0_);
#line 98 "../src/client/application/secret-mediator.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 98 "../src/client/application/secret-mediator.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 98 "../src/client/application/secret-mediator.vala"
			g_object_unref (_data_->_async_result);
#line 98 "../src/client/application/secret-mediator.vala"
			return FALSE;
#line 1168 "secret-mediator.c"
		}
#line 104 "../src/client/application/secret-mediator.vala"
		_data_->_tmp4_ = secret_mediator_compat_schema;
#line 104 "../src/client/application/secret-mediator.vala"
		_data_->_tmp5_ = geary_account_information_get_primary_mailbox (_data_->account);
#line 104 "../src/client/application/secret-mediator.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 104 "../src/client/application/secret-mediator.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 104 "../src/client/application/secret-mediator.vala"
		_data_->_tmp8_ = geary_rf_c822_mailbox_address_get_address (_data_->_tmp7_);
#line 104 "../src/client/application/secret-mediator.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 104 "../src/client/application/secret-mediator.vala"
		_data_->_tmp10_ = secret_mediator_get_legacy_user (_data_->self, _data_->service, _data_->_tmp9_);
#line 104 "../src/client/application/secret-mediator.vala"
		_data_->_tmp11_ = _data_->_tmp10_;
#line 104 "../src/client/application/secret-mediator.vala"
		_data_->_state_ = 2;
#line 104 "../src/client/application/secret-mediator.vala"
		secret_password_clear (_data_->_tmp4_, _data_->cancellable, secret_mediator_clear_token_ready, _data_, "user", _data_->_tmp11_, NULL);
#line 104 "../src/client/application/secret-mediator.vala"
		return FALSE;
#line 1192 "secret-mediator.c"
		_state_2:
#line 104 "../src/client/application/secret-mediator.vala"
		secret_password_clear_finish (_data_->_res_, &_data_->_inner_error0_);
#line 104 "../src/client/application/secret-mediator.vala"
		_g_free0 (_data_->_tmp11_);
#line 104 "../src/client/application/secret-mediator.vala"
		_g_object_unref0 (_data_->_tmp7_);
#line 104 "../src/client/application/secret-mediator.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 104 "../src/client/application/secret-mediator.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 104 "../src/client/application/secret-mediator.vala"
			g_object_unref (_data_->_async_result);
#line 104 "../src/client/application/secret-mediator.vala"
			return FALSE;
#line 1208 "secret-mediator.c"
		}
#line 110 "../src/client/application/secret-mediator.vala"
		_data_->_tmp12_ = secret_mediator_compat_schema;
#line 110 "../src/client/application/secret-mediator.vala"
		_data_->_tmp13_ = geary_service_information_get_credentials (_data_->service);
#line 110 "../src/client/application/secret-mediator.vala"
		_data_->_tmp14_ = _data_->_tmp13_;
#line 110 "../src/client/application/secret-mediator.vala"
		_data_->_tmp15_ = geary_credentials_get_user (_data_->_tmp14_);
#line 110 "../src/client/application/secret-mediator.vala"
		_data_->_tmp16_ = _data_->_tmp15_;
#line 110 "../src/client/application/secret-mediator.vala"
		_data_->_tmp17_ = secret_mediator_get_legacy_user (_data_->self, _data_->service, _data_->_tmp16_);
#line 110 "../src/client/application/secret-mediator.vala"
		_data_->_tmp18_ = _data_->_tmp17_;
#line 110 "../src/client/application/secret-mediator.vala"
		_data_->_state_ = 3;
#line 110 "../src/client/application/secret-mediator.vala"
		secret_password_clear (_data_->_tmp12_, _data_->cancellable, secret_mediator_clear_token_ready, _data_, "user", _data_->_tmp18_, NULL);
#line 110 "../src/client/application/secret-mediator.vala"
		return FALSE;
#line 1230 "secret-mediator.c"
		_state_3:
#line 110 "../src/client/application/secret-mediator.vala"
		secret_password_clear_finish (_data_->_res_, &_data_->_inner_error0_);
#line 110 "../src/client/application/secret-mediator.vala"
		_g_free0 (_data_->_tmp18_);
#line 110 "../src/client/application/secret-mediator.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 110 "../src/client/application/secret-mediator.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 110 "../src/client/application/secret-mediator.vala"
			g_object_unref (_data_->_async_result);
#line 110 "../src/client/application/secret-mediator.vala"
			return FALSE;
#line 1244 "secret-mediator.c"
		}
	}
#line 93 "../src/client/application/secret-mediator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 93 "../src/client/application/secret-mediator.vala"
	if (_data_->_state_ != 0) {
#line 93 "../src/client/application/secret-mediator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 93 "../src/client/application/secret-mediator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1255 "secret-mediator.c"
		}
	}
#line 93 "../src/client/application/secret-mediator.vala"
	g_object_unref (_data_->_async_result);
#line 93 "../src/client/application/secret-mediator.vala"
	return FALSE;
#line 1262 "secret-mediator.c"
}

static void
secret_mediator_check_unlocked_data_free (gpointer _data)
{
	SecretMediatorCheckUnlockedData* _data_;
	_data_ = _data;
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->self);
#line 9 "../src/client/application/secret-mediator.vala"
	g_slice_free (SecretMediatorCheckUnlockedData, _data_);
#line 1276 "secret-mediator.c"
}

static void
secret_mediator_check_unlocked (SecretMediator* self,
                                GCancellable* cancellable,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
	SecretMediatorCheckUnlockedData* _data_;
	SecretMediator* _tmp0_;
	GCancellable* _tmp1_;
#line 9 "../src/client/application/secret-mediator.vala"
	g_return_if_fail (IS_SECRET_MEDIATOR (self));
#line 9 "../src/client/application/secret-mediator.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 9 "../src/client/application/secret-mediator.vala"
	_data_ = g_slice_new0 (SecretMediatorCheckUnlockedData);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 9 "../src/client/application/secret-mediator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, secret_mediator_check_unlocked_data_free);
#line 9 "../src/client/application/secret-mediator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->self = _tmp0_;
#line 9 "../src/client/application/secret-mediator.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->cancellable = _tmp1_;
#line 9 "../src/client/application/secret-mediator.vala"
	secret_mediator_check_unlocked_co (_data_);
#line 1310 "secret-mediator.c"
}

static void
secret_mediator_check_unlocked_finish (SecretMediator* self,
                                       GAsyncResult* _res_,
                                       GError** error)
{
	SecretMediatorCheckUnlockedData* _data_;
#line 9 "../src/client/application/secret-mediator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 9 "../src/client/application/secret-mediator.vala"
	if (NULL == _data_) {
#line 9 "../src/client/application/secret-mediator.vala"
		return;
#line 1325 "secret-mediator.c"
	}
}

static void
secret_mediator_check_unlocked_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_)
{
	SecretMediatorCheckUnlockedData* _data_;
#line 124 "../src/client/application/secret-mediator.vala"
	_data_ = _user_data_;
#line 124 "../src/client/application/secret-mediator.vala"
	_data_->_source_object_ = source_object;
#line 124 "../src/client/application/secret-mediator.vala"
	_data_->_res_ = _res_;
#line 124 "../src/client/application/secret-mediator.vala"
	secret_mediator_check_unlocked_co (_data_);
#line 1343 "secret-mediator.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 143 "../src/client/application/secret-mediator.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 1351 "secret-mediator.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 143 "../src/client/application/secret-mediator.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 1359 "secret-mediator.c"
}

static gboolean
secret_mediator_check_unlocked_co (SecretMediatorCheckUnlockedData* _data_)
{
#line 122 "../src/client/application/secret-mediator.vala"
	switch (_data_->_state_) {
#line 122 "../src/client/application/secret-mediator.vala"
		case 0:
#line 1369 "secret-mediator.c"
		goto _state_0;
#line 122 "../src/client/application/secret-mediator.vala"
		case 1:
#line 1373 "secret-mediator.c"
		goto _state_1;
#line 122 "../src/client/application/secret-mediator.vala"
		case 2:
#line 1377 "secret-mediator.c"
		goto _state_2;
#line 122 "../src/client/application/secret-mediator.vala"
		case 3:
#line 1381 "secret-mediator.c"
		goto _state_3;
		default:
#line 122 "../src/client/application/secret-mediator.vala"
		g_assert_not_reached ();
#line 1386 "secret-mediator.c"
	}
	_state_0:
#line 124 "../src/client/application/secret-mediator.vala"
	_data_->_state_ = 1;
#line 124 "../src/client/application/secret-mediator.vala"
	secret_service_get (SECRET_SERVICE_OPEN_SESSION, _data_->cancellable, secret_mediator_check_unlocked_ready, _data_);
#line 124 "../src/client/application/secret-mediator.vala"
	return FALSE;
#line 1395 "secret-mediator.c"
	_state_1:
#line 124 "../src/client/application/secret-mediator.vala"
	_data_->_tmp0_ = secret_service_get_finish (_data_->_res_, &_data_->_inner_error0_);
#line 124 "../src/client/application/secret-mediator.vala"
	_data_->service = _data_->_tmp0_;
#line 124 "../src/client/application/secret-mediator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 124 "../src/client/application/secret-mediator.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 124 "../src/client/application/secret-mediator.vala"
		g_object_unref (_data_->_async_result);
#line 124 "../src/client/application/secret-mediator.vala"
		return FALSE;
#line 1409 "secret-mediator.c"
	}
#line 127 "../src/client/application/secret-mediator.vala"
	_data_->_tmp1_ = _data_->service;
#line 127 "../src/client/application/secret-mediator.vala"
	_data_->_state_ = 2;
#line 127 "../src/client/application/secret-mediator.vala"
	secret_collection_for_alias (_data_->_tmp1_, SECRET_COLLECTION_DEFAULT, SECRET_COLLECTION_NONE, _data_->cancellable, secret_mediator_check_unlocked_ready, _data_);
#line 127 "../src/client/application/secret-mediator.vala"
	return FALSE;
#line 1419 "secret-mediator.c"
	_state_2:
#line 127 "../src/client/application/secret-mediator.vala"
	_data_->_tmp2_ = secret_collection_for_alias_finish (_data_->_res_, &_data_->_inner_error0_);
#line 127 "../src/client/application/secret-mediator.vala"
	_data_->collection = _data_->_tmp2_;
#line 127 "../src/client/application/secret-mediator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 127 "../src/client/application/secret-mediator.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 127 "../src/client/application/secret-mediator.vala"
		_g_object_unref0 (_data_->service);
#line 127 "../src/client/application/secret-mediator.vala"
		g_object_unref (_data_->_async_result);
#line 127 "../src/client/application/secret-mediator.vala"
		return FALSE;
#line 1435 "secret-mediator.c"
	}
#line 139 "../src/client/application/secret-mediator.vala"
	_data_->_tmp4_ = _data_->collection;
#line 139 "../src/client/application/secret-mediator.vala"
	if (_data_->_tmp4_ != NULL) {
#line 139 "../src/client/application/secret-mediator.vala"
		_data_->_tmp5_ = _data_->collection;
#line 139 "../src/client/application/secret-mediator.vala"
		_data_->_tmp3_ = secret_collection_get_locked (_data_->_tmp5_);
#line 1445 "secret-mediator.c"
	} else {
#line 139 "../src/client/application/secret-mediator.vala"
		_data_->_tmp3_ = FALSE;
#line 1449 "secret-mediator.c"
	}
#line 139 "../src/client/application/secret-mediator.vala"
	if (_data_->_tmp3_) {
#line 140 "../src/client/application/secret-mediator.vala"
		_data_->to_lock = NULL;
#line 141 "../src/client/application/secret-mediator.vala"
		_data_->_tmp6_ = _data_->collection;
#line 141 "../src/client/application/secret-mediator.vala"
		_data_->_tmp7_ = _g_object_ref0 (_data_->_tmp6_);
#line 141 "../src/client/application/secret-mediator.vala"
		_data_->to_lock = g_list_append (_data_->to_lock, _data_->_tmp7_);
#line 143 "../src/client/application/secret-mediator.vala"
		_data_->_tmp8_ = _data_->service;
#line 143 "../src/client/application/secret-mediator.vala"
		_data_->_tmp9_ = _data_->to_lock;
#line 143 "../src/client/application/secret-mediator.vala"
		_data_->_tmp10_ = NULL;
#line 143 "../src/client/application/secret-mediator.vala"
		_data_->_state_ = 3;
#line 143 "../src/client/application/secret-mediator.vala"
		secret_service_unlock (_data_->_tmp8_, _data_->_tmp9_, _data_->cancellable, secret_mediator_check_unlocked_ready, _data_);
#line 143 "../src/client/application/secret-mediator.vala"
		return FALSE;
#line 1473 "secret-mediator.c"
		_state_3:
#line 143 "../src/client/application/secret-mediator.vala"
		secret_service_unlock_finish (_data_->_tmp8_, _data_->_res_, &_data_->_tmp10_, &_data_->_inner_error0_);
#line 143 "../src/client/application/secret-mediator.vala"
		(_data_->unlocked == NULL) ? NULL : (_data_->unlocked = (_g_list_free__g_object_unref0_ (_data_->unlocked), NULL));
#line 143 "../src/client/application/secret-mediator.vala"
		_data_->unlocked = _data_->_tmp10_;
#line 143 "../src/client/application/secret-mediator.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 143 "../src/client/application/secret-mediator.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 143 "../src/client/application/secret-mediator.vala"
			(_data_->unlocked == NULL) ? NULL : (_data_->unlocked = (_g_list_free__g_object_unref0_ (_data_->unlocked), NULL));
#line 143 "../src/client/application/secret-mediator.vala"
			(_data_->to_lock == NULL) ? NULL : (_data_->to_lock = (_g_list_free__g_object_unref0_ (_data_->to_lock), NULL));
#line 143 "../src/client/application/secret-mediator.vala"
			_g_object_unref0 (_data_->collection);
#line 143 "../src/client/application/secret-mediator.vala"
			_g_object_unref0 (_data_->service);
#line 143 "../src/client/application/secret-mediator.vala"
			g_object_unref (_data_->_async_result);
#line 143 "../src/client/application/secret-mediator.vala"
			return FALSE;
#line 1497 "secret-mediator.c"
		}
#line 144 "../src/client/application/secret-mediator.vala"
		_data_->_tmp11_ = _data_->unlocked;
#line 144 "../src/client/application/secret-mediator.vala"
		if (g_list_length (_data_->_tmp11_) != ((guint) 0)) {
#line 1503 "secret-mediator.c"
		}
#line 139 "../src/client/application/secret-mediator.vala"
		(_data_->unlocked == NULL) ? NULL : (_data_->unlocked = (_g_list_free__g_object_unref0_ (_data_->unlocked), NULL));
#line 139 "../src/client/application/secret-mediator.vala"
		(_data_->to_lock == NULL) ? NULL : (_data_->to_lock = (_g_list_free__g_object_unref0_ (_data_->to_lock), NULL));
#line 1509 "secret-mediator.c"
	}
#line 122 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->collection);
#line 122 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->service);
#line 122 "../src/client/application/secret-mediator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 122 "../src/client/application/secret-mediator.vala"
	if (_data_->_state_ != 0) {
#line 122 "../src/client/application/secret-mediator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 122 "../src/client/application/secret-mediator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1523 "secret-mediator.c"
		}
	}
#line 122 "../src/client/application/secret-mediator.vala"
	g_object_unref (_data_->_async_result);
#line 122 "../src/client/application/secret-mediator.vala"
	return FALSE;
#line 1530 "secret-mediator.c"
}

static void
secret_mediator_do_store_data_free (gpointer _data)
{
	SecretMediatorDoStoreData* _data_;
	_data_ = _data;
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->service);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_free0 (_data_->password);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->self);
#line 9 "../src/client/application/secret-mediator.vala"
	g_slice_free (SecretMediatorDoStoreData, _data_);
#line 1548 "secret-mediator.c"
}

static void
secret_mediator_do_store (SecretMediator* self,
                          GearyServiceInformation* service,
                          const gchar* password,
                          GCancellable* cancellable,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_)
{
	SecretMediatorDoStoreData* _data_;
	SecretMediator* _tmp0_;
	GearyServiceInformation* _tmp1_;
	gchar* _tmp2_;
	GCancellable* _tmp3_;
#line 9 "../src/client/application/secret-mediator.vala"
	g_return_if_fail (IS_SECRET_MEDIATOR (self));
#line 9 "../src/client/application/secret-mediator.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (service, GEARY_TYPE_SERVICE_INFORMATION));
#line 9 "../src/client/application/secret-mediator.vala"
	g_return_if_fail (password != NULL);
#line 9 "../src/client/application/secret-mediator.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 9 "../src/client/application/secret-mediator.vala"
	_data_ = g_slice_new0 (SecretMediatorDoStoreData);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 9 "../src/client/application/secret-mediator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, secret_mediator_do_store_data_free);
#line 9 "../src/client/application/secret-mediator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->self = _tmp0_;
#line 9 "../src/client/application/secret-mediator.vala"
	_tmp1_ = _g_object_ref0 (service);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->service);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->service = _tmp1_;
#line 9 "../src/client/application/secret-mediator.vala"
	_tmp2_ = g_strdup (password);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_free0 (_data_->password);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->password = _tmp2_;
#line 9 "../src/client/application/secret-mediator.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->cancellable = _tmp3_;
#line 9 "../src/client/application/secret-mediator.vala"
	secret_mediator_do_store_co (_data_);
#line 1602 "secret-mediator.c"
}

static void
secret_mediator_do_store_finish (SecretMediator* self,
                                 GAsyncResult* _res_,
                                 GError** error)
{
	SecretMediatorDoStoreData* _data_;
#line 9 "../src/client/application/secret-mediator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 9 "../src/client/application/secret-mediator.vala"
	if (NULL == _data_) {
#line 9 "../src/client/application/secret-mediator.vala"
		return;
#line 1617 "secret-mediator.c"
	}
}

static void
secret_mediator_do_store_ready (GObject* source_object,
                                GAsyncResult* _res_,
                                gpointer _user_data_)
{
	SecretMediatorDoStoreData* _data_;
#line 154 "../src/client/application/secret-mediator.vala"
	_data_ = _user_data_;
#line 154 "../src/client/application/secret-mediator.vala"
	_data_->_source_object_ = source_object;
#line 154 "../src/client/application/secret-mediator.vala"
	_data_->_res_ = _res_;
#line 154 "../src/client/application/secret-mediator.vala"
	secret_mediator_do_store_co (_data_);
#line 1635 "secret-mediator.c"
}

static gboolean
secret_mediator_do_store_co (SecretMediatorDoStoreData* _data_)
{
#line 150 "../src/client/application/secret-mediator.vala"
	switch (_data_->_state_) {
#line 150 "../src/client/application/secret-mediator.vala"
		case 0:
#line 1645 "secret-mediator.c"
		goto _state_0;
#line 150 "../src/client/application/secret-mediator.vala"
		case 1:
#line 1649 "secret-mediator.c"
		goto _state_1;
		default:
#line 150 "../src/client/application/secret-mediator.vala"
		g_assert_not_reached ();
#line 1654 "secret-mediator.c"
	}
	_state_0:
#line 154 "../src/client/application/secret-mediator.vala"
	_data_->_tmp0_ = secret_mediator_schema;
#line 154 "../src/client/application/secret-mediator.vala"
	_data_->_tmp1_ = secret_mediator_new_attrs (_data_->self, _data_->service);
#line 154 "../src/client/application/secret-mediator.vala"
	_data_->_tmp2_ = geary_service_information_get_protocol (_data_->service);
#line 154 "../src/client/application/secret-mediator.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 154 "../src/client/application/secret-mediator.vala"
	_data_->_tmp4_ = secret_mediator_to_proto_value (_data_->self, _data_->_tmp3_);
#line 154 "../src/client/application/secret-mediator.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 154 "../src/client/application/secret-mediator.vala"
	_data_->_tmp6_ = g_strdup_printf ("Geary %s password", _data_->_tmp5_);
#line 154 "../src/client/application/secret-mediator.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 154 "../src/client/application/secret-mediator.vala"
	_data_->_state_ = 1;
#line 154 "../src/client/application/secret-mediator.vala"
	secret_password_storev (_data_->_tmp0_, _data_->_tmp1_, SECRET_COLLECTION_DEFAULT, _data_->_tmp7_, _data_->password, _data_->cancellable, secret_mediator_do_store_ready, _data_);
#line 154 "../src/client/application/secret-mediator.vala"
	return FALSE;
#line 1679 "secret-mediator.c"
	_state_1:
#line 154 "../src/client/application/secret-mediator.vala"
	secret_password_store_finish (_data_->_res_, &_data_->_inner_error0_);
#line 154 "../src/client/application/secret-mediator.vala"
	_g_free0 (_data_->_tmp7_);
#line 154 "../src/client/application/secret-mediator.vala"
	_g_free0 (_data_->_tmp5_);
#line 154 "../src/client/application/secret-mediator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 154 "../src/client/application/secret-mediator.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 154 "../src/client/application/secret-mediator.vala"
		g_object_unref (_data_->_async_result);
#line 154 "../src/client/application/secret-mediator.vala"
		return FALSE;
#line 1695 "secret-mediator.c"
	}
#line 150 "../src/client/application/secret-mediator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 150 "../src/client/application/secret-mediator.vala"
	if (_data_->_state_ != 0) {
#line 150 "../src/client/application/secret-mediator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 150 "../src/client/application/secret-mediator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1705 "secret-mediator.c"
		}
	}
#line 150 "../src/client/application/secret-mediator.vala"
	g_object_unref (_data_->_async_result);
#line 150 "../src/client/application/secret-mediator.vala"
	return FALSE;
#line 1712 "secret-mediator.c"
}

static void
_g_free0_ (gpointer var)
{
#line 165 "../src/client/application/secret-mediator.vala"
	var = (g_free (var), NULL);
#line 1720 "secret-mediator.c"
}

static GHashTable*
secret_mediator_new_attrs (SecretMediator* self,
                           GearyServiceInformation* service)
{
	GHashTable* table = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	gchar* _tmp3_;
	GearyProtocol _tmp4_;
	GearyProtocol _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GearyCredentials* _tmp12_;
	GearyCredentials* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	GHashTable* result;
#line 164 "../src/client/application/secret-mediator.vala"
	g_return_val_if_fail (IS_SECRET_MEDIATOR (self), NULL);
#line 164 "../src/client/application/secret-mediator.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (service, GEARY_TYPE_SERVICE_INFORMATION), NULL);
#line 165 "../src/client/application/secret-mediator.vala"
	_tmp0_ = g_str_hash;
#line 165 "../src/client/application/secret-mediator.vala"
	_tmp1_ = g_str_equal;
#line 165 "../src/client/application/secret-mediator.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_free0_);
#line 165 "../src/client/application/secret-mediator.vala"
	table = _tmp2_;
#line 168 "../src/client/application/secret-mediator.vala"
	_tmp3_ = g_strdup (SECRET_MEDIATOR_ATTR_PROTO);
#line 168 "../src/client/application/secret-mediator.vala"
	_tmp4_ = geary_service_information_get_protocol (service);
#line 168 "../src/client/application/secret-mediator.vala"
	_tmp5_ = _tmp4_;
#line 168 "../src/client/application/secret-mediator.vala"
	_tmp6_ = secret_mediator_to_proto_value (self, _tmp5_);
#line 168 "../src/client/application/secret-mediator.vala"
	g_hash_table_insert (table, _tmp3_, _tmp6_);
#line 169 "../src/client/application/secret-mediator.vala"
	_tmp7_ = g_strdup (SECRET_MEDIATOR_ATTR_HOST);
#line 169 "../src/client/application/secret-mediator.vala"
	_tmp8_ = geary_service_information_get_host (service);
#line 169 "../src/client/application/secret-mediator.vala"
	_tmp9_ = _tmp8_;
#line 169 "../src/client/application/secret-mediator.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 169 "../src/client/application/secret-mediator.vala"
	g_hash_table_insert (table, _tmp7_, _tmp10_);
#line 170 "../src/client/application/secret-mediator.vala"
	_tmp11_ = g_strdup (SECRET_MEDIATOR_ATTR_LOGIN);
#line 170 "../src/client/application/secret-mediator.vala"
	_tmp12_ = geary_service_information_get_credentials (service);
#line 170 "../src/client/application/secret-mediator.vala"
	_tmp13_ = _tmp12_;
#line 170 "../src/client/application/secret-mediator.vala"
	_tmp14_ = geary_credentials_get_user (_tmp13_);
#line 170 "../src/client/application/secret-mediator.vala"
	_tmp15_ = _tmp14_;
#line 170 "../src/client/application/secret-mediator.vala"
	_tmp16_ = g_strdup (_tmp15_);
#line 170 "../src/client/application/secret-mediator.vala"
	g_hash_table_insert (table, _tmp11_, _tmp16_);
#line 171 "../src/client/application/secret-mediator.vala"
	result = table;
#line 171 "../src/client/application/secret-mediator.vala"
	return result;
#line 1796 "secret-mediator.c"
}

static inline gchar*
secret_mediator_to_proto_value (SecretMediator* self,
                                GearyProtocol protocol)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 174 "../src/client/application/secret-mediator.vala"
	g_return_val_if_fail (IS_SECRET_MEDIATOR (self), NULL);
#line 175 "../src/client/application/secret-mediator.vala"
	_tmp0_ = geary_protocol_to_value (protocol);
#line 175 "../src/client/application/secret-mediator.vala"
	_tmp1_ = _tmp0_;
#line 175 "../src/client/application/secret-mediator.vala"
	_tmp2_ = g_ascii_strup (_tmp1_, (gssize) -1);
#line 175 "../src/client/application/secret-mediator.vala"
	_tmp3_ = _tmp2_;
#line 175 "../src/client/application/secret-mediator.vala"
	_g_free0 (_tmp1_);
#line 175 "../src/client/application/secret-mediator.vala"
	result = _tmp3_;
#line 175 "../src/client/application/secret-mediator.vala"
	return result;
#line 1824 "secret-mediator.c"
}

static void
secret_mediator_migrate_old_password_data_free (gpointer _data)
{
	SecretMediatorMigrateOldPasswordData* _data_;
	_data_ = _data;
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->service);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_free0 (_data_->result);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->self);
#line 9 "../src/client/application/secret-mediator.vala"
	g_slice_free (SecretMediatorMigrateOldPasswordData, _data_);
#line 1842 "secret-mediator.c"
}

static void
secret_mediator_migrate_old_password (SecretMediator* self,
                                      GearyServiceInformation* service,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	SecretMediatorMigrateOldPasswordData* _data_;
	SecretMediator* _tmp0_;
	GearyServiceInformation* _tmp1_;
	GCancellable* _tmp2_;
#line 9 "../src/client/application/secret-mediator.vala"
	g_return_if_fail (IS_SECRET_MEDIATOR (self));
#line 9 "../src/client/application/secret-mediator.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (service, GEARY_TYPE_SERVICE_INFORMATION));
#line 9 "../src/client/application/secret-mediator.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 9 "../src/client/application/secret-mediator.vala"
	_data_ = g_slice_new0 (SecretMediatorMigrateOldPasswordData);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 9 "../src/client/application/secret-mediator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, secret_mediator_migrate_old_password_data_free);
#line 9 "../src/client/application/secret-mediator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->self = _tmp0_;
#line 9 "../src/client/application/secret-mediator.vala"
	_tmp1_ = _g_object_ref0 (service);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->service);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->service = _tmp1_;
#line 9 "../src/client/application/secret-mediator.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 9 "../src/client/application/secret-mediator.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->cancellable = _tmp2_;
#line 9 "../src/client/application/secret-mediator.vala"
	secret_mediator_migrate_old_password_co (_data_);
#line 1886 "secret-mediator.c"
}

static gchar*
secret_mediator_migrate_old_password_finish (SecretMediator* self,
                                             GAsyncResult* _res_,
                                             GError** error)
{
	gchar* result;
	SecretMediatorMigrateOldPasswordData* _data_;
#line 9 "../src/client/application/secret-mediator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 9 "../src/client/application/secret-mediator.vala"
	if (NULL == _data_) {
#line 9 "../src/client/application/secret-mediator.vala"
		return NULL;
#line 1902 "secret-mediator.c"
	}
#line 9 "../src/client/application/secret-mediator.vala"
	result = _data_->result;
#line 9 "../src/client/application/secret-mediator.vala"
	_data_->result = NULL;
#line 9 "../src/client/application/secret-mediator.vala"
	return result;
#line 1910 "secret-mediator.c"
}

static void
secret_mediator_migrate_old_password_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_)
{
	SecretMediatorMigrateOldPasswordData* _data_;
#line 183 "../src/client/application/secret-mediator.vala"
	_data_ = _user_data_;
#line 183 "../src/client/application/secret-mediator.vala"
	_data_->_source_object_ = source_object;
#line 183 "../src/client/application/secret-mediator.vala"
	_data_->_res_ = _res_;
#line 183 "../src/client/application/secret-mediator.vala"
	secret_mediator_migrate_old_password_co (_data_);
#line 1927 "secret-mediator.c"
}

static gboolean
secret_mediator_migrate_old_password_co (SecretMediatorMigrateOldPasswordData* _data_)
{
#line 178 "../src/client/application/secret-mediator.vala"
	switch (_data_->_state_) {
#line 178 "../src/client/application/secret-mediator.vala"
		case 0:
#line 1937 "secret-mediator.c"
		goto _state_0;
#line 178 "../src/client/application/secret-mediator.vala"
		case 1:
#line 1941 "secret-mediator.c"
		goto _state_1;
#line 178 "../src/client/application/secret-mediator.vala"
		case 2:
#line 1945 "secret-mediator.c"
		goto _state_2;
#line 178 "../src/client/application/secret-mediator.vala"
		case 3:
#line 1949 "secret-mediator.c"
		goto _state_3;
		default:
#line 178 "../src/client/application/secret-mediator.vala"
		g_assert_not_reached ();
#line 1954 "secret-mediator.c"
	}
	_state_0:
#line 182 "../src/client/application/secret-mediator.vala"
	_data_->_tmp0_ = geary_service_information_get_credentials (_data_->service);
#line 182 "../src/client/application/secret-mediator.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 182 "../src/client/application/secret-mediator.vala"
	_data_->_tmp2_ = geary_credentials_get_user (_data_->_tmp1_);
#line 182 "../src/client/application/secret-mediator.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 182 "../src/client/application/secret-mediator.vala"
	_data_->_tmp4_ = secret_mediator_get_legacy_user (_data_->self, _data_->service, _data_->_tmp3_);
#line 182 "../src/client/application/secret-mediator.vala"
	_data_->user = _data_->_tmp4_;
#line 183 "../src/client/application/secret-mediator.vala"
	_data_->_tmp5_ = secret_mediator_compat_schema;
#line 183 "../src/client/application/secret-mediator.vala"
	_data_->_tmp6_ = _data_->user;
#line 183 "../src/client/application/secret-mediator.vala"
	_data_->_state_ = 1;
#line 183 "../src/client/application/secret-mediator.vala"
	secret_password_lookup (_data_->_tmp5_, _data_->cancellable, secret_mediator_migrate_old_password_ready, _data_, "user", _data_->_tmp6_, NULL);
#line 183 "../src/client/application/secret-mediator.vala"
	return FALSE;
#line 1979 "secret-mediator.c"
	_state_1:
#line 183 "../src/client/application/secret-mediator.vala"
	_data_->_tmp7_ = secret_password_lookup_finish (_data_->_res_, &_data_->_inner_error0_);
#line 183 "../src/client/application/secret-mediator.vala"
	_data_->password = _data_->_tmp7_;
#line 183 "../src/client/application/secret-mediator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 183 "../src/client/application/secret-mediator.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 183 "../src/client/application/secret-mediator.vala"
		_g_free0 (_data_->user);
#line 183 "../src/client/application/secret-mediator.vala"
		g_object_unref (_data_->_async_result);
#line 183 "../src/client/application/secret-mediator.vala"
		return FALSE;
#line 1995 "secret-mediator.c"
	}
#line 189 "../src/client/application/secret-mediator.vala"
	_data_->_tmp8_ = _data_->password;
#line 189 "../src/client/application/secret-mediator.vala"
	if (_data_->_tmp8_ != NULL) {
#line 191 "../src/client/application/secret-mediator.vala"
		_data_->_tmp9_ = secret_mediator_compat_schema;
#line 191 "../src/client/application/secret-mediator.vala"
		_data_->_tmp10_ = _data_->user;
#line 191 "../src/client/application/secret-mediator.vala"
		_data_->_state_ = 2;
#line 191 "../src/client/application/secret-mediator.vala"
		secret_password_clear (_data_->_tmp9_, _data_->cancellable, secret_mediator_migrate_old_password_ready, _data_, "user", _data_->_tmp10_, NULL);
#line 191 "../src/client/application/secret-mediator.vala"
		return FALSE;
#line 2011 "secret-mediator.c"
		_state_2:
#line 191 "../src/client/application/secret-mediator.vala"
		secret_password_clear_finish (_data_->_res_, &_data_->_inner_error0_);
#line 191 "../src/client/application/secret-mediator.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 191 "../src/client/application/secret-mediator.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 191 "../src/client/application/secret-mediator.vala"
			_g_free0 (_data_->password);
#line 191 "../src/client/application/secret-mediator.vala"
			_g_free0 (_data_->user);
#line 191 "../src/client/application/secret-mediator.vala"
			g_object_unref (_data_->_async_result);
#line 191 "../src/client/application/secret-mediator.vala"
			return FALSE;
#line 2027 "secret-mediator.c"
		}
#line 198 "../src/client/application/secret-mediator.vala"
		_data_->_tmp11_ = _data_->password;
#line 198 "../src/client/application/secret-mediator.vala"
		_data_->_state_ = 3;
#line 198 "../src/client/application/secret-mediator.vala"
		secret_mediator_do_store (_data_->self, _data_->service, _data_->_tmp11_, _data_->cancellable, secret_mediator_migrate_old_password_ready, _data_);
#line 198 "../src/client/application/secret-mediator.vala"
		return FALSE;
#line 2037 "secret-mediator.c"
		_state_3:
#line 198 "../src/client/application/secret-mediator.vala"
		secret_mediator_do_store_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 198 "../src/client/application/secret-mediator.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 198 "../src/client/application/secret-mediator.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 198 "../src/client/application/secret-mediator.vala"
			_g_free0 (_data_->password);
#line 198 "../src/client/application/secret-mediator.vala"
			_g_free0 (_data_->user);
#line 198 "../src/client/application/secret-mediator.vala"
			g_object_unref (_data_->_async_result);
#line 198 "../src/client/application/secret-mediator.vala"
			return FALSE;
#line 2053 "secret-mediator.c"
		}
	}
#line 201 "../src/client/application/secret-mediator.vala"
	_data_->result = _data_->password;
#line 201 "../src/client/application/secret-mediator.vala"
	_g_free0 (_data_->user);
#line 201 "../src/client/application/secret-mediator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 201 "../src/client/application/secret-mediator.vala"
	if (_data_->_state_ != 0) {
#line 201 "../src/client/application/secret-mediator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 201 "../src/client/application/secret-mediator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2068 "secret-mediator.c"
		}
	}
#line 201 "../src/client/application/secret-mediator.vala"
	g_object_unref (_data_->_async_result);
#line 201 "../src/client/application/secret-mediator.vala"
	return FALSE;
#line 2075 "secret-mediator.c"
}

static gchar*
secret_mediator_get_legacy_user (SecretMediator* self,
                                 GearyServiceInformation* service,
                                 const gchar* user)
{
	GearyProtocol _tmp0_;
	GearyProtocol _tmp1_;
	gchar* result;
#line 204 "../src/client/application/secret-mediator.vala"
	g_return_val_if_fail (IS_SECRET_MEDIATOR (self), NULL);
#line 204 "../src/client/application/secret-mediator.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (service, GEARY_TYPE_SERVICE_INFORMATION), NULL);
#line 204 "../src/client/application/secret-mediator.vala"
	g_return_val_if_fail (user != NULL, NULL);
#line 205 "../src/client/application/secret-mediator.vala"
	_tmp0_ = geary_service_information_get_protocol (service);
#line 205 "../src/client/application/secret-mediator.vala"
	_tmp1_ = _tmp0_;
#line 205 "../src/client/application/secret-mediator.vala"
	switch (_tmp1_) {
#line 205 "../src/client/application/secret-mediator.vala"
		case GEARY_PROTOCOL_IMAP:
#line 2100 "secret-mediator.c"
		{
			gchar* _tmp2_;
#line 207 "../src/client/application/secret-mediator.vala"
			_tmp2_ = g_strconcat ("org.yorba.geary imap_username:", user, NULL);
#line 207 "../src/client/application/secret-mediator.vala"
			result = _tmp2_;
#line 207 "../src/client/application/secret-mediator.vala"
			return result;
#line 2109 "secret-mediator.c"
		}
#line 205 "../src/client/application/secret-mediator.vala"
		case GEARY_PROTOCOL_SMTP:
#line 2113 "secret-mediator.c"
		{
			gchar* _tmp3_;
#line 209 "../src/client/application/secret-mediator.vala"
			_tmp3_ = g_strconcat ("org.yorba.geary smtp_username:", user, NULL);
#line 209 "../src/client/application/secret-mediator.vala"
			result = _tmp3_;
#line 209 "../src/client/application/secret-mediator.vala"
			return result;
#line 2122 "secret-mediator.c"
		}
		default:
		{
			gchar* _tmp4_;
#line 211 "../src/client/application/secret-mediator.vala"
			g_warning ("secret-mediator.vala:211: Unknown service type");
#line 212 "../src/client/application/secret-mediator.vala"
			_tmp4_ = g_strdup ("");
#line 212 "../src/client/application/secret-mediator.vala"
			result = _tmp4_;
#line 212 "../src/client/application/secret-mediator.vala"
			return result;
#line 2135 "secret-mediator.c"
		}
	}
}

static void
secret_mediator_class_init (SecretMediatorClass * klass,
                            gpointer klass_data)
{
	SecretSchema* _tmp0_;
	SecretSchema* _tmp1_;
#line 9 "../src/client/application/secret-mediator.vala"
	secret_mediator_parent_class = g_type_class_peek_parent (klass);
#line 9 "../src/client/application/secret-mediator.vala"
	((SecretMediatorClass *) klass)->load_token = (void (*) (SecretMediator*, GearyAccountInformation*, GearyServiceInformation*, GCancellable*, GAsyncReadyCallback, gpointer)) secret_mediator_real_load_token;
#line 9 "../src/client/application/secret-mediator.vala"
	((SecretMediatorClass *) klass)->load_token_finish = (gboolean (*) (SecretMediator*, GAsyncResult*, GError**)) secret_mediator_real_load_token_finish;
#line 9 "../src/client/application/secret-mediator.vala"
	G_OBJECT_CLASS (klass)->finalize = secret_mediator_finalize;
#line 15 "../src/client/application/secret-mediator.vala"
	_tmp0_ = secret_schema_new (APPLICATION_CLIENT_SCHEMA_ID, SECRET_SCHEMA_NONE, SECRET_MEDIATOR_ATTR_LOGIN, SECRET_SCHEMA_ATTRIBUTE_STRING, SECRET_MEDIATOR_ATTR_HOST, SECRET_SCHEMA_ATTRIBUTE_STRING, SECRET_MEDIATOR_ATTR_PROTO, SECRET_SCHEMA_ATTRIBUTE_STRING, NULL, NULL);
#line 15 "../src/client/application/secret-mediator.vala"
	secret_mediator_schema = _tmp0_;
#line 25 "../src/client/application/secret-mediator.vala"
	_tmp1_ = secret_schema_new ("org.gnome.keyring.NetworkPassword", SECRET_SCHEMA_NONE, "user", SECRET_SCHEMA_ATTRIBUTE_STRING, "domain", SECRET_SCHEMA_ATTRIBUTE_STRING, "object", SECRET_SCHEMA_ATTRIBUTE_STRING, "protocol", SECRET_SCHEMA_ATTRIBUTE_STRING, "port", SECRET_SCHEMA_ATTRIBUTE_INTEGER, "server", SECRET_SCHEMA_ATTRIBUTE_STRING, "authtype", SECRET_SCHEMA_ATTRIBUTE_STRING, NULL, NULL);
#line 25 "../src/client/application/secret-mediator.vala"
	secret_mediator_compat_schema = _tmp1_;
#line 2162 "secret-mediator.c"
}

static void
secret_mediator_geary_credentials_mediator_interface_init (GearyCredentialsMediatorIface * iface,
                                                           gpointer iface_data)
{
#line 9 "../src/client/application/secret-mediator.vala"
	secret_mediator_geary_credentials_mediator_parent_iface = g_type_interface_peek_parent (iface);
#line 9 "../src/client/application/secret-mediator.vala"
	iface->load_token = (void (*) (GearyCredentialsMediator*, GearyAccountInformation*, GearyServiceInformation*, GCancellable*, GAsyncReadyCallback, gpointer)) secret_mediator_load_token;
#line 9 "../src/client/application/secret-mediator.vala"
	iface->load_token_finish = (gboolean (*) (GearyCredentialsMediator*, GAsyncResult*, GError**)) secret_mediator_load_token_finish;
#line 2175 "secret-mediator.c"
}

static void
secret_mediator_instance_init (SecretMediator * self,
                               gpointer klass)
{
}

static void
secret_mediator_finalize (GObject * obj)
{
	SecretMediator * self;
#line 9 "../src/client/application/secret-mediator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SECRET_MEDIATOR, SecretMediator);
#line 9 "../src/client/application/secret-mediator.vala"
	G_OBJECT_CLASS (secret_mediator_parent_class)->finalize (obj);
#line 2192 "secret-mediator.c"
}

/** LibSecret password adapter. */
static GType
secret_mediator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SecretMediatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) secret_mediator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SecretMediator), 0, (GInstanceInitFunc) secret_mediator_instance_init, NULL };
	static const GInterfaceInfo geary_credentials_mediator_info = { (GInterfaceInitFunc) secret_mediator_geary_credentials_mediator_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType secret_mediator_type_id;
	secret_mediator_type_id = g_type_register_static (G_TYPE_OBJECT, "SecretMediator", &g_define_type_info, 0);
	g_type_add_interface_static (secret_mediator_type_id, GEARY_TYPE_CREDENTIALS_MEDIATOR, &geary_credentials_mediator_info);
	return secret_mediator_type_id;
}

GType
secret_mediator_get_type (void)
{
	static volatile gsize secret_mediator_type_id__once = 0;
	if (g_once_init_enter (&secret_mediator_type_id__once)) {
		GType secret_mediator_type_id;
		secret_mediator_type_id = secret_mediator_get_type_once ();
		g_once_init_leave (&secret_mediator_type_id__once, secret_mediator_type_id);
	}
	return secret_mediator_type_id__once;
}

