/* components-inspector.c generated by valac 0.56.17, the Vala compiler
 * generated from components-inspector.vala, do not modify */

/*
 * Copyright 2019 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-client-46.0.h"
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include "geary-engine.h"

#define COMPONENTS_INSPECTOR_ACTION_CLOSE "inspector-close"
#define COMPONENTS_INSPECTOR_ACTION_PLAY_TOGGLE "toggle-play"
#define COMPONENTS_INSPECTOR_ACTION_SEARCH_TOGGLE "toggle-search"
#define COMPONENTS_INSPECTOR_ACTION_SEARCH_ACTIVATE "activate-search"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	COMPONENTS_INSPECTOR_0_PROPERTY,
	COMPONENTS_INSPECTOR_NUM_PROPERTIES
};
static GParamSpec* components_inspector_properties[COMPONENTS_INSPECTOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _geary_logging_record_unref0(var) ((var == NULL) ? NULL : (var = (geary_logging_record_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ComponentsInspectorSaveData ComponentsInspectorSaveData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _ComponentsInspectorPrivate {
	GtkHeaderBar* header_bar;
	GtkStack* stack;
	GtkButton* copy_button;
	GtkToggleButton* play_button;
	GtkButton* mark_button;
	GtkToggleButton* search_button;
	GtkButton* clear_button;
	ComponentsInspectorLogView* log_pane;
	ComponentsInspectorSystemView* system_pane;
};

struct _ComponentsInspectorSaveData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ComponentsInspector* self;
	gchar* path;
	GCancellable* cancellable;
	GFile* dest;
	GFile* _tmp0_;
	GFileIOStream* dest_io;
	GFile* _tmp1_;
	GFileIOStream* _tmp2_;
	GDataOutputStream* out;
	GFileIOStream* _tmp3_;
	GOutputStream* _tmp4_;
	GBufferedOutputStream* _tmp5_;
	GBufferedOutputStream* _tmp6_;
	GDataOutputStream* _tmp7_;
	GDataOutputStream* _tmp8_;
	ComponentsInspectorSystemView* _tmp9_;
	GDataOutputStream* _tmp10_;
	GDataOutputStream* _tmp11_;
	ComponentsInspectorLogView* _tmp12_;
	GDataOutputStream* _tmp13_;
	GDataOutputStream* _tmp14_;
	GFileIOStream* _tmp15_;
	GError* _inner_error0_;
};

static gint ComponentsInspector_private_offset;
static gpointer components_inspector_parent_class = NULL;

static void components_inspector_on_copy_clicked (ComponentsInspector* self);
static void _components_inspector_on_copy_clicked_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self);
static void components_inspector_on_close (ComponentsInspector* self);
static void _components_inspector_on_close_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self);
static void components_inspector_on_logs_play_toggled (ComponentsInspector* self,
                                                GSimpleAction* action,
                                                GVariant* param);
static void _components_inspector_on_logs_play_toggled_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self);
static void components_inspector_on_logs_search_toggled (ComponentsInspector* self,
                                                  GSimpleAction* action,
                                                  GVariant* param);
static void _components_inspector_on_logs_search_toggled_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                    GVariant* parameter,
                                                                                    gpointer self);
static void components_inspector_on_logs_search_activated (ComponentsInspector* self);
static void _components_inspector_on_logs_search_activated_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                      GVariant* parameter,
                                                                                      gpointer self);
static void components_inspector_on_logs_selection_changed (ComponentsInspector* self);
static void _components_inspector_on_logs_selection_changed_components_inspector_log_view_record_selection_changed (ComponentsInspectorLogView* _sender,
                                                                                                             gpointer self);
static void components_inspector_enable_log_updates (ComponentsInspector* self,
                                              gboolean enabled);
static gboolean components_inspector_real_key_press_event (GtkWidget* base,
                                                    GdkEventKey* event);
static void components_inspector_save_data_free (gpointer _data);
static void components_inspector_save (ComponentsInspector* self,
                                const gchar* path,
                                GCancellable* cancellable,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_);
static void components_inspector_save_finish (ComponentsInspector* self,
                                       GAsyncResult* _res_,
                                       GError** error);
static gboolean components_inspector_save_co (ComponentsInspectorSaveData* _data_);
static void components_inspector_save_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_);
static void components_inspector_update_ui (ComponentsInspector* self);
static void components_inspector_on_visible_child_changed (ComponentsInspector* self);
static void _components_inspector_on_visible_child_changed_g_object_notify (GObject* _sender,
                                                                     GParamSpec* pspec,
                                                                     gpointer self);
static void components_inspector_on_mark_clicked (ComponentsInspector* self);
static void _components_inspector_on_mark_clicked_gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self);
static void components_inspector_on_clear_clicked (ComponentsInspector* self);
static void _components_inspector_on_clear_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self);
static void components_inspector_on_save_as_clicked (ComponentsInspector* self);
static void ___lambda39_ (ComponentsInspector* self,
                   GObject* obj,
                   GAsyncResult* res);
static void ____lambda39__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void _components_inspector_on_save_as_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self);
static gboolean _variant_get6 (GVariant* value);
static GVariant* _variant_new5 (gboolean value);
static gboolean _variant_get7 (GVariant* value);
static GVariant* _variant_new6 (gboolean value);
static void components_inspector_finalize (GObject * obj);
static GType components_inspector_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GActionEntry COMPONENTS_INSPECTOR_EDIT_ACTIONS[1] = {{ACTION_EDIT_COPY, _components_inspector_on_copy_clicked_gsimple_action_activate_callback}};
static const GActionEntry COMPONENTS_INSPECTOR_WINDOW_ACTIONS[5] = {{ACTION_WINDOW_CLOSE, _components_inspector_on_close_gsimple_action_activate_callback}, {COMPONENTS_INSPECTOR_ACTION_CLOSE, _components_inspector_on_close_gsimple_action_activate_callback}, {COMPONENTS_INSPECTOR_ACTION_PLAY_TOGGLE, _components_inspector_on_logs_play_toggled_gsimple_action_activate_callback, NULL, "true"}, {COMPONENTS_INSPECTOR_ACTION_SEARCH_TOGGLE, _components_inspector_on_logs_search_toggled_gsimple_action_activate_callback, NULL, "false"}, {COMPONENTS_INSPECTOR_ACTION_SEARCH_ACTIVATE, _components_inspector_on_logs_search_activated_gsimple_action_activate_callback}};

static inline gpointer
components_inspector_get_instance_private (ComponentsInspector* self)
{
	return G_STRUCT_MEMBER_P (self, ComponentsInspector_private_offset);
}

/** Determines the format used when serialising inspector data. */
gchar*
components_inspector_text_format_get_line_separator (ComponentsInspectorTextFormat self)
{
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* result;
#line 21 "../src/client/components/components-inspector.vala"
	if (self == COMPONENTS_INSPECTOR_TEXT_FORMAT_MARKDOWN) {
#line 21 "../src/client/components/components-inspector.vala"
		_tmp0_ = "  \n";
#line 191 "components-inspector.c"
	} else {
#line 21 "../src/client/components/components-inspector.vala"
		_tmp0_ = "\n";
#line 195 "components-inspector.c"
	}
#line 21 "../src/client/components/components-inspector.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 21 "../src/client/components/components-inspector.vala"
	result = _tmp1_;
#line 21 "../src/client/components/components-inspector.vala"
	return result;
#line 203 "components-inspector.c"
}

static GType
components_inspector_text_format_get_type_once (void)
{
	static const GEnumValue values[] = {{COMPONENTS_INSPECTOR_TEXT_FORMAT_PLAIN, "COMPONENTS_INSPECTOR_TEXT_FORMAT_PLAIN", "plain"}, {COMPONENTS_INSPECTOR_TEXT_FORMAT_MARKDOWN, "COMPONENTS_INSPECTOR_TEXT_FORMAT_MARKDOWN", "markdown"}, {0, NULL, NULL}};
	GType components_inspector_text_format_type_id;
	components_inspector_text_format_type_id = g_enum_register_static ("ComponentsInspectorTextFormat", values);
	return components_inspector_text_format_type_id;
}

GType
components_inspector_text_format_get_type (void)
{
	static volatile gsize components_inspector_text_format_type_id__once = 0;
	if (g_once_init_enter (&components_inspector_text_format_type_id__once)) {
		GType components_inspector_text_format_type_id;
		components_inspector_text_format_type_id = components_inspector_text_format_get_type_once ();
		g_once_init_leave (&components_inspector_text_format_type_id__once, components_inspector_text_format_type_id);
	}
	return components_inspector_text_format_type_id__once;
}

static void
_components_inspector_on_copy_clicked_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self)
{
#line 31 "../src/client/components/components-inspector.vala"
	components_inspector_on_copy_clicked ((ComponentsInspector*) self);
#line 234 "components-inspector.c"
}

static void
_components_inspector_on_close_gsimple_action_activate_callback (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 gpointer self)
{
#line 35 "../src/client/components/components-inspector.vala"
	components_inspector_on_close ((ComponentsInspector*) self);
#line 244 "components-inspector.c"
}

static void
_components_inspector_on_logs_play_toggled_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self)
{
#line 35 "../src/client/components/components-inspector.vala"
	components_inspector_on_logs_play_toggled ((ComponentsInspector*) self, action, parameter);
#line 254 "components-inspector.c"
}

static void
_components_inspector_on_logs_search_toggled_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self)
{
#line 35 "../src/client/components/components-inspector.vala"
	components_inspector_on_logs_search_toggled ((ComponentsInspector*) self, action, parameter);
#line 264 "components-inspector.c"
}

static void
_components_inspector_on_logs_search_activated_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self)
{
#line 35 "../src/client/components/components-inspector.vala"
	components_inspector_on_logs_search_activated ((ComponentsInspector*) self);
#line 274 "components-inspector.c"
}

void
components_inspector_add_accelerators (ApplicationClient* app)
{
	gchar* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
#line 44 "../src/client/components/components-inspector.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (app));
#line 45 "../src/client/components/components-inspector.vala"
	_tmp0_ = g_strdup ("Escape");
#line 45 "../src/client/components/components-inspector.vala"
	_tmp1_ = g_new0 (gchar*, 1 + 1);
#line 45 "../src/client/components/components-inspector.vala"
	_tmp1_[0] = _tmp0_;
#line 45 "../src/client/components/components-inspector.vala"
	_tmp2_ = _tmp1_;
#line 45 "../src/client/components/components-inspector.vala"
	_tmp2__length1 = 1;
#line 45 "../src/client/components/components-inspector.vala"
	application_client_add_window_accelerators (app, COMPONENTS_INSPECTOR_ACTION_CLOSE, _tmp2_, (gint) 1, NULL);
#line 45 "../src/client/components/components-inspector.vala"
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
#line 46 "../src/client/components/components-inspector.vala"
	_tmp3_ = g_strdup ("space");
#line 46 "../src/client/components/components-inspector.vala"
	_tmp4_ = g_new0 (gchar*, 1 + 1);
#line 46 "../src/client/components/components-inspector.vala"
	_tmp4_[0] = _tmp3_;
#line 46 "../src/client/components/components-inspector.vala"
	_tmp5_ = _tmp4_;
#line 46 "../src/client/components/components-inspector.vala"
	_tmp5__length1 = 1;
#line 46 "../src/client/components/components-inspector.vala"
	application_client_add_window_accelerators (app, COMPONENTS_INSPECTOR_ACTION_PLAY_TOGGLE, _tmp5_, (gint) 1, NULL);
#line 46 "../src/client/components/components-inspector.vala"
	_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
#line 47 "../src/client/components/components-inspector.vala"
	_tmp6_ = g_strdup ("<Ctrl>F");
#line 47 "../src/client/components/components-inspector.vala"
	_tmp7_ = g_new0 (gchar*, 1 + 1);
#line 47 "../src/client/components/components-inspector.vala"
	_tmp7_[0] = _tmp6_;
#line 47 "../src/client/components/components-inspector.vala"
	_tmp8_ = _tmp7_;
#line 47 "../src/client/components/components-inspector.vala"
	_tmp8__length1 = 1;
#line 47 "../src/client/components/components-inspector.vala"
	application_client_add_window_accelerators (app, COMPONENTS_INSPECTOR_ACTION_SEARCH_ACTIVATE, _tmp8_, (gint) 1, NULL);
#line 47 "../src/client/components/components-inspector.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 336 "components-inspector.c"
}

static void
_components_inspector_on_logs_selection_changed_components_inspector_log_view_record_selection_changed (ComponentsInspectorLogView* _sender,
                                                                                                        gpointer self)
{
#line 82 "../src/client/components/components-inspector.vala"
	components_inspector_on_logs_selection_changed ((ComponentsInspector*) self);
#line 345 "components-inspector.c"
}

ComponentsInspector*
components_inspector_construct (GType object_type,
                                ApplicationClient* application)
{
	ComponentsInspector * self = NULL;
	GtkHeaderBar* _tmp0_;
	GSimpleActionGroup* edit_actions = NULL;
	GSimpleActionGroup* _tmp1_;
	ApplicationConfiguration* _tmp2_;
	ApplicationConfiguration* _tmp3_;
	ComponentsInspectorLogView* _tmp4_;
	ComponentsInspectorLogView* _tmp5_;
	GtkStack* _tmp6_;
	ComponentsInspectorLogView* _tmp7_;
	ComponentsInspectorSystemView* _tmp8_;
	GtkStack* _tmp9_;
	ComponentsInspectorSystemView* _tmp10_;
	ComponentsInspectorLogView* _tmp11_;
	GearyLoggingRecord* _tmp12_;
	GearyLoggingRecord* _tmp13_;
#line 69 "../src/client/components/components-inspector.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (application), NULL);
#line 70 "../src/client/components/components-inspector.vala"
	self = (ComponentsInspector*) g_object_new (object_type, "application", application, NULL);
#line 71 "../src/client/components/components-inspector.vala"
	_tmp0_ = self->priv->header_bar;
#line 71 "../src/client/components/components-inspector.vala"
	gtk_header_bar_set_title (_tmp0_, _ ("Inspector"));
#line 71 "../src/client/components/components-inspector.vala"
	gtk_window_set_title (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), _ ("Inspector"));
#line 74 "../src/client/components/components-inspector.vala"
	_tmp1_ = g_simple_action_group_new ();
#line 74 "../src/client/components/components-inspector.vala"
	edit_actions = _tmp1_;
#line 75 "../src/client/components/components-inspector.vala"
	g_action_map_add_action_entries (G_TYPE_CHECK_INSTANCE_CAST (edit_actions, g_action_map_get_type (), GActionMap), COMPONENTS_INSPECTOR_EDIT_ACTIONS, (gint) G_N_ELEMENTS (COMPONENTS_INSPECTOR_EDIT_ACTIONS), self);
#line 76 "../src/client/components/components-inspector.vala"
	gtk_widget_insert_action_group (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), ACTION_EDIT_GROUP_NAME, G_TYPE_CHECK_INSTANCE_CAST (edit_actions, g_action_group_get_type (), GActionGroup));
#line 79 "../src/client/components/components-inspector.vala"
	g_action_map_add_action_entries (G_TYPE_CHECK_INSTANCE_CAST (self, g_action_map_get_type (), GActionMap), COMPONENTS_INSPECTOR_WINDOW_ACTIONS, (gint) G_N_ELEMENTS (COMPONENTS_INSPECTOR_WINDOW_ACTIONS), self);
#line 81 "../src/client/components/components-inspector.vala"
	_tmp2_ = application_client_get_config (application);
#line 81 "../src/client/components/components-inspector.vala"
	_tmp3_ = _tmp2_;
#line 81 "../src/client/components/components-inspector.vala"
	_tmp4_ = components_inspector_log_view_new (_tmp3_, NULL);
#line 81 "../src/client/components/components-inspector.vala"
	g_object_ref_sink (_tmp4_);
#line 81 "../src/client/components/components-inspector.vala"
	_g_object_unref0 (self->priv->log_pane);
#line 81 "../src/client/components/components-inspector.vala"
	self->priv->log_pane = _tmp4_;
#line 82 "../src/client/components/components-inspector.vala"
	_tmp5_ = self->priv->log_pane;
#line 82 "../src/client/components/components-inspector.vala"
	g_signal_connect_object (_tmp5_, "record-selection-changed", (GCallback) _components_inspector_on_logs_selection_changed_components_inspector_log_view_record_selection_changed, self, 0);
#line 86 "../src/client/components/components-inspector.vala"
	_tmp6_ = self->priv->stack;
#line 86 "../src/client/components/components-inspector.vala"
	_tmp7_ = self->priv->log_pane;
#line 86 "../src/client/components/components-inspector.vala"
	gtk_stack_add_titled (_tmp6_, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget), "log_pane", _ ("Logs"));
#line 88 "../src/client/components/components-inspector.vala"
	_tmp8_ = components_inspector_system_view_new (application);
#line 88 "../src/client/components/components-inspector.vala"
	g_object_ref_sink (_tmp8_);
#line 88 "../src/client/components/components-inspector.vala"
	_g_object_unref0 (self->priv->system_pane);
#line 88 "../src/client/components/components-inspector.vala"
	self->priv->system_pane = _tmp8_;
#line 90 "../src/client/components/components-inspector.vala"
	_tmp9_ = self->priv->stack;
#line 90 "../src/client/components/components-inspector.vala"
	_tmp10_ = self->priv->system_pane;
#line 90 "../src/client/components/components-inspector.vala"
	gtk_stack_add_titled (_tmp9_, G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_widget_get_type (), GtkWidget), "system_pane", _ ("System"));
#line 94 "../src/client/components/components-inspector.vala"
	components_inspector_enable_log_updates (self, TRUE);
#line 95 "../src/client/components/components-inspector.vala"
	_tmp11_ = self->priv->log_pane;
#line 95 "../src/client/components/components-inspector.vala"
	_tmp12_ = geary_logging_get_earliest_record ();
#line 95 "../src/client/components/components-inspector.vala"
	_tmp13_ = _tmp12_;
#line 95 "../src/client/components/components-inspector.vala"
	components_inspector_log_view_load (_tmp11_, _tmp13_, NULL);
#line 95 "../src/client/components/components-inspector.vala"
	_geary_logging_record_unref0 (_tmp13_);
#line 69 "../src/client/components/components-inspector.vala"
	_g_object_unref0 (edit_actions);
#line 69 "../src/client/components/components-inspector.vala"
	return self;
#line 440 "components-inspector.c"
}

ComponentsInspector*
components_inspector_new (ApplicationClient* application)
{
#line 69 "../src/client/components/components-inspector.vala"
	return components_inspector_construct (COMPONENTS_TYPE_INSPECTOR, application);
#line 448 "components-inspector.c"
}

static gboolean
components_inspector_real_key_press_event (GtkWidget* base,
                                           GdkEventKey* event)
{
	ComponentsInspector * self;
	gboolean ret = FALSE;
	gboolean _tmp0_ = FALSE;
	ComponentsInspectorLogView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean result;
#line 98 "../src/client/components/components-inspector.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, COMPONENTS_TYPE_INSPECTOR, ComponentsInspector);
#line 98 "../src/client/components/components-inspector.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 99 "../src/client/components/components-inspector.vala"
	ret = GDK_EVENT_PROPAGATE;
#line 101 "../src/client/components/components-inspector.vala"
	_tmp1_ = self->priv->log_pane;
#line 101 "../src/client/components/components-inspector.vala"
	_tmp2_ = components_inspector_log_view_get_search_mode_enabled (_tmp1_);
#line 101 "../src/client/components/components-inspector.vala"
	_tmp3_ = _tmp2_;
#line 101 "../src/client/components/components-inspector.vala"
	if (_tmp3_) {
#line 102 "../src/client/components/components-inspector.vala"
		_tmp0_ = event->keyval == GDK_KEY_Escape;
#line 480 "components-inspector.c"
	} else {
#line 101 "../src/client/components/components-inspector.vala"
		_tmp0_ = FALSE;
#line 484 "components-inspector.c"
	}
#line 101 "../src/client/components/components-inspector.vala"
	if (_tmp0_) {
#line 488 "components-inspector.c"
		GtkToggleButton* _tmp4_;
#line 104 "../src/client/components/components-inspector.vala"
		_tmp4_ = self->priv->search_button;
#line 104 "../src/client/components/components-inspector.vala"
		gtk_toggle_button_set_active (_tmp4_, FALSE);
#line 105 "../src/client/components/components-inspector.vala"
		ret = GDK_EVENT_STOP;
#line 496 "components-inspector.c"
	}
#line 108 "../src/client/components/components-inspector.vala"
	if (ret == GDK_EVENT_PROPAGATE) {
#line 500 "components-inspector.c"
		ComponentsInspectorLogView* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 109 "../src/client/components/components-inspector.vala"
		_tmp6_ = self->priv->log_pane;
#line 109 "../src/client/components/components-inspector.vala"
		_tmp7_ = components_inspector_log_view_get_search_mode_enabled (_tmp6_);
#line 109 "../src/client/components/components-inspector.vala"
		_tmp8_ = _tmp7_;
#line 109 "../src/client/components/components-inspector.vala"
		_tmp5_ = _tmp8_;
#line 512 "components-inspector.c"
	} else {
#line 108 "../src/client/components/components-inspector.vala"
		_tmp5_ = FALSE;
#line 516 "components-inspector.c"
	}
#line 108 "../src/client/components/components-inspector.vala"
	if (_tmp5_) {
#line 520 "components-inspector.c"
		ComponentsInspectorLogView* _tmp9_;
#line 112 "../src/client/components/components-inspector.vala"
		_tmp9_ = self->priv->log_pane;
#line 112 "../src/client/components/components-inspector.vala"
		ret = components_inspector_log_view_handle_key_press (_tmp9_, event);
#line 526 "components-inspector.c"
	}
#line 115 "../src/client/components/components-inspector.vala"
	if (ret == GDK_EVENT_PROPAGATE) {
#line 116 "../src/client/components/components-inspector.vala"
		ret = GTK_WIDGET_CLASS (components_inspector_parent_class)->key_press_event (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_window_get_type (), GtkApplicationWindow), gtk_widget_get_type (), GtkWidget), event);
#line 532 "components-inspector.c"
	}
#line 119 "../src/client/components/components-inspector.vala"
	if (ret == GDK_EVENT_PROPAGATE) {
#line 536 "components-inspector.c"
		ComponentsInspectorLogView* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
#line 120 "../src/client/components/components-inspector.vala"
		_tmp11_ = self->priv->log_pane;
#line 120 "../src/client/components/components-inspector.vala"
		_tmp12_ = components_inspector_log_view_get_search_mode_enabled (_tmp11_);
#line 120 "../src/client/components/components-inspector.vala"
		_tmp13_ = _tmp12_;
#line 120 "../src/client/components/components-inspector.vala"
		_tmp10_ = !_tmp13_;
#line 548 "components-inspector.c"
	} else {
#line 119 "../src/client/components/components-inspector.vala"
		_tmp10_ = FALSE;
#line 552 "components-inspector.c"
	}
#line 119 "../src/client/components/components-inspector.vala"
	if (_tmp10_) {
#line 556 "components-inspector.c"
		ComponentsInspectorLogView* _tmp14_;
#line 123 "../src/client/components/components-inspector.vala"
		_tmp14_ = self->priv->log_pane;
#line 123 "../src/client/components/components-inspector.vala"
		ret = components_inspector_log_view_handle_key_press (_tmp14_, event);
#line 124 "../src/client/components/components-inspector.vala"
		if (ret == GDK_EVENT_STOP) {
#line 564 "components-inspector.c"
			GtkToggleButton* _tmp15_;
#line 125 "../src/client/components/components-inspector.vala"
			_tmp15_ = self->priv->search_button;
#line 125 "../src/client/components/components-inspector.vala"
			gtk_toggle_button_set_active (_tmp15_, TRUE);
#line 570 "components-inspector.c"
		}
	}
#line 129 "../src/client/components/components-inspector.vala"
	result = ret;
#line 129 "../src/client/components/components-inspector.vala"
	return result;
#line 577 "components-inspector.c"
}

static void
components_inspector_enable_log_updates (ComponentsInspector* self,
                                         gboolean enabled)
{
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	ComponentsInspectorLogView* _tmp3_;
#line 132 "../src/client/components/components-inspector.vala"
	g_return_if_fail (COMPONENTS_IS_INSPECTOR (self));
#line 137 "../src/client/components/components-inspector.vala"
	if (enabled) {
#line 137 "../src/client/components/components-inspector.vala"
		_tmp0_ = "▶";
#line 594 "components-inspector.c"
	} else {
#line 137 "../src/client/components/components-inspector.vala"
		_tmp0_ = "■";
#line 598 "components-inspector.c"
	}
#line 134 "../src/client/components/components-inspector.vala"
	_tmp1_ = gtk_window_get_title (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
#line 134 "../src/client/components/components-inspector.vala"
	_tmp2_ = _tmp1_;
#line 134 "../src/client/components/components-inspector.vala"
	g_debug ("components-inspector.vala:134: ---- 8< ---- %s %s ---- 8< ----", _tmp2_, _tmp0_);
#line 140 "../src/client/components/components-inspector.vala"
	_tmp3_ = self->priv->log_pane;
#line 140 "../src/client/components/components-inspector.vala"
	components_inspector_log_view_enable_log_updates (_tmp3_, enabled);
#line 610 "components-inspector.c"
}

static void
components_inspector_save_data_free (gpointer _data)
{
	ComponentsInspectorSaveData* _data_;
	_data_ = _data;
#line 12 "../src/client/components/components-inspector.vala"
	_g_free0 (_data_->path);
#line 12 "../src/client/components/components-inspector.vala"
	_g_object_unref0 (_data_->cancellable);
#line 12 "../src/client/components/components-inspector.vala"
	_g_object_unref0 (_data_->self);
#line 12 "../src/client/components/components-inspector.vala"
	g_slice_free (ComponentsInspectorSaveData, _data_);
#line 626 "components-inspector.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 12 "../src/client/components/components-inspector.vala"
	return self ? g_object_ref (self) : NULL;
#line 634 "components-inspector.c"
}

static void
components_inspector_save (ComponentsInspector* self,
                           const gchar* path,
                           GCancellable* cancellable,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_)
{
	ComponentsInspectorSaveData* _data_;
	ComponentsInspector* _tmp0_;
	gchar* _tmp1_;
	GCancellable* _tmp2_;
#line 12 "../src/client/components/components-inspector.vala"
	g_return_if_fail (COMPONENTS_IS_INSPECTOR (self));
#line 12 "../src/client/components/components-inspector.vala"
	g_return_if_fail (path != NULL);
#line 12 "../src/client/components/components-inspector.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 12 "../src/client/components/components-inspector.vala"
	_data_ = g_slice_new0 (ComponentsInspectorSaveData);
#line 12 "../src/client/components/components-inspector.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 12 "../src/client/components/components-inspector.vala"
	g_task_set_task_data (_data_->_async_result, _data_, components_inspector_save_data_free);
#line 12 "../src/client/components/components-inspector.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 12 "../src/client/components/components-inspector.vala"
	_data_->self = _tmp0_;
#line 12 "../src/client/components/components-inspector.vala"
	_tmp1_ = g_strdup (path);
#line 12 "../src/client/components/components-inspector.vala"
	_g_free0 (_data_->path);
#line 12 "../src/client/components/components-inspector.vala"
	_data_->path = _tmp1_;
#line 12 "../src/client/components/components-inspector.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 12 "../src/client/components/components-inspector.vala"
	_g_object_unref0 (_data_->cancellable);
#line 12 "../src/client/components/components-inspector.vala"
	_data_->cancellable = _tmp2_;
#line 12 "../src/client/components/components-inspector.vala"
	components_inspector_save_co (_data_);
#line 678 "components-inspector.c"
}

static void
components_inspector_save_finish (ComponentsInspector* self,
                                  GAsyncResult* _res_,
                                  GError** error)
{
	ComponentsInspectorSaveData* _data_;
#line 12 "../src/client/components/components-inspector.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 12 "../src/client/components/components-inspector.vala"
	if (NULL == _data_) {
#line 12 "../src/client/components/components-inspector.vala"
		return;
#line 693 "components-inspector.c"
	}
}

static void
components_inspector_save_ready (GObject* source_object,
                                 GAsyncResult* _res_,
                                 gpointer _user_data_)
{
	ComponentsInspectorSaveData* _data_;
#line 147 "../src/client/components/components-inspector.vala"
	_data_ = _user_data_;
#line 147 "../src/client/components/components-inspector.vala"
	_data_->_source_object_ = source_object;
#line 147 "../src/client/components/components-inspector.vala"
	_data_->_res_ = _res_;
#line 147 "../src/client/components/components-inspector.vala"
	components_inspector_save_co (_data_);
#line 711 "components-inspector.c"
}

static gboolean
components_inspector_save_co (ComponentsInspectorSaveData* _data_)
{
#line 143 "../src/client/components/components-inspector.vala"
	switch (_data_->_state_) {
#line 143 "../src/client/components/components-inspector.vala"
		case 0:
#line 721 "components-inspector.c"
		goto _state_0;
#line 143 "../src/client/components/components-inspector.vala"
		case 1:
#line 725 "components-inspector.c"
		goto _state_1;
#line 143 "../src/client/components/components-inspector.vala"
		case 2:
#line 729 "components-inspector.c"
		goto _state_2;
#line 143 "../src/client/components/components-inspector.vala"
		case 3:
#line 733 "components-inspector.c"
		goto _state_3;
		default:
#line 143 "../src/client/components/components-inspector.vala"
		g_assert_not_reached ();
#line 738 "components-inspector.c"
	}
	_state_0:
#line 146 "../src/client/components/components-inspector.vala"
	_data_->_tmp0_ = g_file_new_for_path (_data_->path);
#line 146 "../src/client/components/components-inspector.vala"
	_data_->dest = _data_->_tmp0_;
#line 147 "../src/client/components/components-inspector.vala"
	_data_->_tmp1_ = _data_->dest;
#line 147 "../src/client/components/components-inspector.vala"
	_data_->_state_ = 1;
#line 147 "../src/client/components/components-inspector.vala"
	g_file_replace_readwrite_async (_data_->_tmp1_, NULL, FALSE, G_FILE_CREATE_NONE, G_PRIORITY_DEFAULT, _data_->cancellable, components_inspector_save_ready, _data_);
#line 147 "../src/client/components/components-inspector.vala"
	return FALSE;
#line 753 "components-inspector.c"
	_state_1:
#line 147 "../src/client/components/components-inspector.vala"
	_data_->_tmp2_ = g_file_replace_readwrite_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error0_);
#line 147 "../src/client/components/components-inspector.vala"
	_data_->dest_io = _data_->_tmp2_;
#line 147 "../src/client/components/components-inspector.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 147 "../src/client/components/components-inspector.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 147 "../src/client/components/components-inspector.vala"
		_g_object_unref0 (_data_->dest);
#line 147 "../src/client/components/components-inspector.vala"
		g_object_unref (_data_->_async_result);
#line 147 "../src/client/components/components-inspector.vala"
		return FALSE;
#line 769 "components-inspector.c"
	}
#line 154 "../src/client/components/components-inspector.vala"
	_data_->_tmp3_ = _data_->dest_io;
#line 154 "../src/client/components/components-inspector.vala"
	_data_->_tmp4_ = g_io_stream_get_output_stream (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, g_io_stream_get_type (), GIOStream));
#line 154 "../src/client/components/components-inspector.vala"
	_data_->_tmp5_ = (GBufferedOutputStream*) g_buffered_output_stream_new (_data_->_tmp4_);
#line 154 "../src/client/components/components-inspector.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 154 "../src/client/components/components-inspector.vala"
	_data_->_tmp7_ = g_data_output_stream_new (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, g_output_stream_get_type (), GOutputStream));
#line 154 "../src/client/components/components-inspector.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 154 "../src/client/components/components-inspector.vala"
	_g_object_unref0 (_data_->_tmp6_);
#line 154 "../src/client/components/components-inspector.vala"
	_data_->out = _data_->_tmp8_;
#line 158 "../src/client/components/components-inspector.vala"
	_data_->_tmp9_ = _data_->self->priv->system_pane;
#line 158 "../src/client/components/components-inspector.vala"
	_data_->_tmp10_ = _data_->out;
#line 158 "../src/client/components/components-inspector.vala"
	components_inspector_system_view_save (_data_->_tmp9_, _data_->_tmp10_, COMPONENTS_INSPECTOR_TEXT_FORMAT_PLAIN, _data_->cancellable, &_data_->_inner_error0_);
#line 158 "../src/client/components/components-inspector.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 158 "../src/client/components/components-inspector.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 158 "../src/client/components/components-inspector.vala"
		_g_object_unref0 (_data_->out);
#line 158 "../src/client/components/components-inspector.vala"
		_g_object_unref0 (_data_->dest_io);
#line 158 "../src/client/components/components-inspector.vala"
		_g_object_unref0 (_data_->dest);
#line 158 "../src/client/components/components-inspector.vala"
		g_object_unref (_data_->_async_result);
#line 158 "../src/client/components/components-inspector.vala"
		return FALSE;
#line 807 "components-inspector.c"
	}
#line 159 "../src/client/components/components-inspector.vala"
	_data_->_tmp11_ = _data_->out;
#line 159 "../src/client/components/components-inspector.vala"
	g_data_output_stream_put_string (_data_->_tmp11_, "\n", NULL, &_data_->_inner_error0_);
#line 159 "../src/client/components/components-inspector.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 159 "../src/client/components/components-inspector.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 159 "../src/client/components/components-inspector.vala"
		_g_object_unref0 (_data_->out);
#line 159 "../src/client/components/components-inspector.vala"
		_g_object_unref0 (_data_->dest_io);
#line 159 "../src/client/components/components-inspector.vala"
		_g_object_unref0 (_data_->dest);
#line 159 "../src/client/components/components-inspector.vala"
		g_object_unref (_data_->_async_result);
#line 159 "../src/client/components/components-inspector.vala"
		return FALSE;
#line 827 "components-inspector.c"
	}
#line 160 "../src/client/components/components-inspector.vala"
	_data_->_tmp12_ = _data_->self->priv->log_pane;
#line 160 "../src/client/components/components-inspector.vala"
	_data_->_tmp13_ = _data_->out;
#line 160 "../src/client/components/components-inspector.vala"
	components_inspector_log_view_save (_data_->_tmp12_, _data_->_tmp13_, COMPONENTS_INSPECTOR_TEXT_FORMAT_PLAIN, TRUE, _data_->cancellable, &_data_->_inner_error0_);
#line 160 "../src/client/components/components-inspector.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 160 "../src/client/components/components-inspector.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 160 "../src/client/components/components-inspector.vala"
		_g_object_unref0 (_data_->out);
#line 160 "../src/client/components/components-inspector.vala"
		_g_object_unref0 (_data_->dest_io);
#line 160 "../src/client/components/components-inspector.vala"
		_g_object_unref0 (_data_->dest);
#line 160 "../src/client/components/components-inspector.vala"
		g_object_unref (_data_->_async_result);
#line 160 "../src/client/components/components-inspector.vala"
		return FALSE;
#line 849 "components-inspector.c"
	}
#line 162 "../src/client/components/components-inspector.vala"
	_data_->_tmp14_ = _data_->out;
#line 162 "../src/client/components/components-inspector.vala"
	_data_->_state_ = 2;
#line 162 "../src/client/components/components-inspector.vala"
	g_output_stream_close_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp14_, g_output_stream_get_type (), GOutputStream), G_PRIORITY_DEFAULT, NULL, components_inspector_save_ready, _data_);
#line 162 "../src/client/components/components-inspector.vala"
	return FALSE;
#line 859 "components-inspector.c"
	_state_2:
#line 162 "../src/client/components/components-inspector.vala"
	g_output_stream_close_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp14_, g_output_stream_get_type (), GOutputStream), _data_->_res_, &_data_->_inner_error0_);
#line 162 "../src/client/components/components-inspector.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 162 "../src/client/components/components-inspector.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 162 "../src/client/components/components-inspector.vala"
		_g_object_unref0 (_data_->out);
#line 162 "../src/client/components/components-inspector.vala"
		_g_object_unref0 (_data_->dest_io);
#line 162 "../src/client/components/components-inspector.vala"
		_g_object_unref0 (_data_->dest);
#line 162 "../src/client/components/components-inspector.vala"
		g_object_unref (_data_->_async_result);
#line 162 "../src/client/components/components-inspector.vala"
		return FALSE;
#line 877 "components-inspector.c"
	}
#line 163 "../src/client/components/components-inspector.vala"
	_data_->_tmp15_ = _data_->dest_io;
#line 163 "../src/client/components/components-inspector.vala"
	_data_->_state_ = 3;
#line 163 "../src/client/components/components-inspector.vala"
	g_io_stream_close_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp15_, g_io_stream_get_type (), GIOStream), G_PRIORITY_DEFAULT, NULL, components_inspector_save_ready, _data_);
#line 163 "../src/client/components/components-inspector.vala"
	return FALSE;
#line 887 "components-inspector.c"
	_state_3:
#line 163 "../src/client/components/components-inspector.vala"
	g_io_stream_close_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp15_, g_io_stream_get_type (), GIOStream), _data_->_res_, &_data_->_inner_error0_);
#line 163 "../src/client/components/components-inspector.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 163 "../src/client/components/components-inspector.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 163 "../src/client/components/components-inspector.vala"
		_g_object_unref0 (_data_->out);
#line 163 "../src/client/components/components-inspector.vala"
		_g_object_unref0 (_data_->dest_io);
#line 163 "../src/client/components/components-inspector.vala"
		_g_object_unref0 (_data_->dest);
#line 163 "../src/client/components/components-inspector.vala"
		g_object_unref (_data_->_async_result);
#line 163 "../src/client/components/components-inspector.vala"
		return FALSE;
#line 905 "components-inspector.c"
	}
#line 143 "../src/client/components/components-inspector.vala"
	_g_object_unref0 (_data_->out);
#line 143 "../src/client/components/components-inspector.vala"
	_g_object_unref0 (_data_->dest_io);
#line 143 "../src/client/components/components-inspector.vala"
	_g_object_unref0 (_data_->dest);
#line 143 "../src/client/components/components-inspector.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 143 "../src/client/components/components-inspector.vala"
	if (_data_->_state_ != 0) {
#line 143 "../src/client/components/components-inspector.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 143 "../src/client/components/components-inspector.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 921 "components-inspector.c"
		}
	}
#line 143 "../src/client/components/components-inspector.vala"
	g_object_unref (_data_->_async_result);
#line 143 "../src/client/components/components-inspector.vala"
	return FALSE;
#line 928 "components-inspector.c"
}

static void
components_inspector_update_ui (ComponentsInspector* self)
{
	gboolean logs_visible = FALSE;
	GtkStack* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	ComponentsInspectorLogView* _tmp3_;
	guint logs_selected = 0U;
	ComponentsInspectorLogView* _tmp4_;
	gboolean _tmp5_ = FALSE;
	GtkButton* _tmp6_;
	GtkToggleButton* _tmp7_;
	GtkButton* _tmp8_;
	GtkButton* _tmp9_;
	GtkToggleButton* _tmp10_;
#line 166 "../src/client/components/components-inspector.vala"
	g_return_if_fail (COMPONENTS_IS_INSPECTOR (self));
#line 167 "../src/client/components/components-inspector.vala"
	_tmp0_ = self->priv->stack;
#line 167 "../src/client/components/components-inspector.vala"
	_tmp1_ = gtk_stack_get_visible_child (_tmp0_);
#line 167 "../src/client/components/components-inspector.vala"
	_tmp2_ = _tmp1_;
#line 167 "../src/client/components/components-inspector.vala"
	_tmp3_ = self->priv->log_pane;
#line 167 "../src/client/components/components-inspector.vala"
	logs_visible = _tmp2_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget);
#line 168 "../src/client/components/components-inspector.vala"
	_tmp4_ = self->priv->log_pane;
#line 168 "../src/client/components/components-inspector.vala"
	logs_selected = (guint) components_inspector_log_view_count_selected_records (_tmp4_);
#line 169 "../src/client/components/components-inspector.vala"
	if (!logs_visible) {
#line 169 "../src/client/components/components-inspector.vala"
		_tmp5_ = TRUE;
#line 967 "components-inspector.c"
	} else {
#line 169 "../src/client/components/components-inspector.vala"
		_tmp5_ = logs_selected > ((guint) 0);
#line 971 "components-inspector.c"
	}
#line 169 "../src/client/components/components-inspector.vala"
	_tmp6_ = self->priv->copy_button;
#line 169 "../src/client/components/components-inspector.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget), _tmp5_);
#line 170 "../src/client/components/components-inspector.vala"
	_tmp7_ = self->priv->play_button;
#line 170 "../src/client/components/components-inspector.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget), logs_visible);
#line 171 "../src/client/components/components-inspector.vala"
	_tmp8_ = self->priv->mark_button;
#line 171 "../src/client/components/components-inspector.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget), logs_visible);
#line 172 "../src/client/components/components-inspector.vala"
	_tmp9_ = self->priv->clear_button;
#line 172 "../src/client/components/components-inspector.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_widget_get_type (), GtkWidget), logs_visible);
#line 173 "../src/client/components/components-inspector.vala"
	_tmp10_ = self->priv->search_button;
#line 173 "../src/client/components/components-inspector.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_widget_get_type (), GtkWidget), logs_visible);
#line 993 "components-inspector.c"
}

static void
components_inspector_on_visible_child_changed (ComponentsInspector* self)
{
#line 177 "../src/client/components/components-inspector.vala"
	g_return_if_fail (COMPONENTS_IS_INSPECTOR (self));
#line 178 "../src/client/components/components-inspector.vala"
	components_inspector_update_ui (self);
#line 1003 "components-inspector.c"
}

static void
_components_inspector_on_visible_child_changed_g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self)
{
#line 12 "../src/client/components/components-inspector.vala"
	components_inspector_on_visible_child_changed ((ComponentsInspector*) self);
#line 1013 "components-inspector.c"
}

static void
components_inspector_on_mark_clicked (ComponentsInspector* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 182 "../src/client/components/components-inspector.vala"
	g_return_if_fail (COMPONENTS_IS_INSPECTOR (self));
#line 183 "../src/client/components/components-inspector.vala"
	_tmp0_ = gtk_window_get_title (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
#line 183 "../src/client/components/components-inspector.vala"
	_tmp1_ = _tmp0_;
#line 183 "../src/client/components/components-inspector.vala"
	g_debug ("components-inspector.vala:183: ---- 8< ---- %s ---- 8< ----", _tmp1_);
#line 1029 "components-inspector.c"
}

static void
_components_inspector_on_mark_clicked_gtk_button_clicked (GtkButton* _sender,
                                                          gpointer self)
{
#line 12 "../src/client/components/components-inspector.vala"
	components_inspector_on_mark_clicked ((ComponentsInspector*) self);
#line 1038 "components-inspector.c"
}

static void
components_inspector_on_clear_clicked (ComponentsInspector* self)
{
	ComponentsInspectorLogView* _tmp0_;
#line 187 "../src/client/components/components-inspector.vala"
	g_return_if_fail (COMPONENTS_IS_INSPECTOR (self));
#line 188 "../src/client/components/components-inspector.vala"
	_tmp0_ = self->priv->log_pane;
#line 188 "../src/client/components/components-inspector.vala"
	components_inspector_log_view_clear (_tmp0_);
#line 1051 "components-inspector.c"
}

static void
_components_inspector_on_clear_clicked_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self)
{
#line 12 "../src/client/components/components-inspector.vala"
	components_inspector_on_clear_clicked ((ComponentsInspector*) self);
#line 1060 "components-inspector.c"
}

static void
components_inspector_on_copy_clicked (ComponentsInspector* self)
{
	GMemoryOutputStream* bytes = NULL;
	GMemoryOutputStream* _tmp0_;
	GDataOutputStream* out = NULL;
	GMemoryOutputStream* _tmp1_;
	GDataOutputStream* _tmp2_;
	gchar* clipboard_value = NULL;
	GMemoryOutputStream* _tmp18_;
	guint8* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	GError* _inner_error0_ = NULL;
#line 191 "../src/client/components/components-inspector.vala"
	g_return_if_fail (COMPONENTS_IS_INSPECTOR (self));
#line 192 "../src/client/components/components-inspector.vala"
	_tmp0_ = (GMemoryOutputStream*) g_memory_output_stream_new_resizable ();
#line 192 "../src/client/components/components-inspector.vala"
	bytes = _tmp0_;
#line 193 "../src/client/components/components-inspector.vala"
	_tmp1_ = bytes;
#line 193 "../src/client/components/components-inspector.vala"
	_tmp2_ = g_data_output_stream_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_output_stream_get_type (), GOutputStream));
#line 193 "../src/client/components/components-inspector.vala"
	out = _tmp2_;
#line 1089 "components-inspector.c"
	{
		GtkStack* _tmp3_;
		GtkWidget* _tmp4_;
		GtkWidget* _tmp5_;
		ComponentsInspectorLogView* _tmp6_;
		GDataOutputStream* _tmp15_;
#line 195 "../src/client/components/components-inspector.vala"
		_tmp3_ = self->priv->stack;
#line 195 "../src/client/components/components-inspector.vala"
		_tmp4_ = gtk_stack_get_visible_child (_tmp3_);
#line 195 "../src/client/components/components-inspector.vala"
		_tmp5_ = _tmp4_;
#line 195 "../src/client/components/components-inspector.vala"
		_tmp6_ = self->priv->log_pane;
#line 195 "../src/client/components/components-inspector.vala"
		if (_tmp5_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget)) {
#line 1106 "components-inspector.c"
			ComponentsInspectorLogView* _tmp7_;
			GDataOutputStream* _tmp8_;
#line 196 "../src/client/components/components-inspector.vala"
			_tmp7_ = self->priv->log_pane;
#line 196 "../src/client/components/components-inspector.vala"
			_tmp8_ = out;
#line 196 "../src/client/components/components-inspector.vala"
			components_inspector_log_view_save (_tmp7_, _tmp8_, COMPONENTS_INSPECTOR_TEXT_FORMAT_MARKDOWN, FALSE, NULL, &_inner_error0_);
#line 196 "../src/client/components/components-inspector.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1117 "components-inspector.c"
				goto __catch0_g_error;
			}
		} else {
			GtkStack* _tmp9_;
			GtkWidget* _tmp10_;
			GtkWidget* _tmp11_;
			ComponentsInspectorSystemView* _tmp12_;
#line 197 "../src/client/components/components-inspector.vala"
			_tmp9_ = self->priv->stack;
#line 197 "../src/client/components/components-inspector.vala"
			_tmp10_ = gtk_stack_get_visible_child (_tmp9_);
#line 197 "../src/client/components/components-inspector.vala"
			_tmp11_ = _tmp10_;
#line 197 "../src/client/components/components-inspector.vala"
			_tmp12_ = self->priv->system_pane;
#line 197 "../src/client/components/components-inspector.vala"
			if (_tmp11_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_widget_get_type (), GtkWidget)) {
#line 1135 "components-inspector.c"
				ComponentsInspectorSystemView* _tmp13_;
				GDataOutputStream* _tmp14_;
#line 198 "../src/client/components/components-inspector.vala"
				_tmp13_ = self->priv->system_pane;
#line 198 "../src/client/components/components-inspector.vala"
				_tmp14_ = out;
#line 198 "../src/client/components/components-inspector.vala"
				components_inspector_system_view_save (_tmp13_, _tmp14_, COMPONENTS_INSPECTOR_TEXT_FORMAT_MARKDOWN, NULL, &_inner_error0_);
#line 198 "../src/client/components/components-inspector.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1146 "components-inspector.c"
					goto __catch0_g_error;
				}
			}
		}
#line 202 "../src/client/components/components-inspector.vala"
		_tmp15_ = out;
#line 202 "../src/client/components/components-inspector.vala"
		g_data_output_stream_put_byte (_tmp15_, (guint8) 0, NULL, &_inner_error0_);
#line 202 "../src/client/components/components-inspector.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1157 "components-inspector.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 194 "../src/client/components/components-inspector.vala"
		err = _inner_error0_;
#line 194 "../src/client/components/components-inspector.vala"
		_inner_error0_ = NULL;
#line 204 "../src/client/components/components-inspector.vala"
		_tmp16_ = err;
#line 204 "../src/client/components/components-inspector.vala"
		_tmp17_ = _tmp16_->message;
#line 204 "../src/client/components/components-inspector.vala"
		g_warning ("components-inspector.vala:204: Error saving inspector data for clipboa" \
"rd: %s", _tmp17_);
#line 194 "../src/client/components/components-inspector.vala"
		_g_error_free0 (err);
#line 1179 "components-inspector.c"
	}
	__finally0:
#line 194 "../src/client/components/components-inspector.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 194 "../src/client/components/components-inspector.vala"
		_g_object_unref0 (out);
#line 194 "../src/client/components/components-inspector.vala"
		_g_object_unref0 (bytes);
#line 194 "../src/client/components/components-inspector.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 194 "../src/client/components/components-inspector.vala"
		g_clear_error (&_inner_error0_);
#line 194 "../src/client/components/components-inspector.vala"
		return;
#line 1194 "components-inspector.c"
	}
#line 210 "../src/client/components/components-inspector.vala"
	_tmp18_ = bytes;
#line 210 "../src/client/components/components-inspector.vala"
	_tmp19_ = g_memory_output_stream_get_data (_tmp18_);
#line 210 "../src/client/components/components-inspector.vala"
	_tmp20_ = g_strdup ((const gchar*) _tmp19_);
#line 210 "../src/client/components/components-inspector.vala"
	clipboard_value = _tmp20_;
#line 211 "../src/client/components/components-inspector.vala"
	_tmp21_ = clipboard_value;
#line 211 "../src/client/components/components-inspector.vala"
	if (!geary_string_is_empty (_tmp21_)) {
#line 1208 "components-inspector.c"
		GtkClipboard* _tmp22_;
		const gchar* _tmp23_;
#line 212 "../src/client/components/components-inspector.vala"
		_tmp22_ = gtk_widget_get_clipboard (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), GDK_SELECTION_CLIPBOARD);
#line 212 "../src/client/components/components-inspector.vala"
		_tmp23_ = clipboard_value;
#line 212 "../src/client/components/components-inspector.vala"
		gtk_clipboard_set_text (_tmp22_, _tmp23_, -1);
#line 1217 "components-inspector.c"
	}
#line 191 "../src/client/components/components-inspector.vala"
	_g_free0 (clipboard_value);
#line 191 "../src/client/components/components-inspector.vala"
	_g_object_unref0 (out);
#line 191 "../src/client/components/components-inspector.vala"
	_g_object_unref0 (bytes);
#line 1225 "components-inspector.c"
}

static void
___lambda39_ (ComponentsInspector* self,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 233 "../src/client/components/components-inspector.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 233 "../src/client/components/components-inspector.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 1238 "components-inspector.c"
	{
#line 235 "../src/client/components/components-inspector.vala"
		components_inspector_save_finish (self, res, &_inner_error0_);
#line 235 "../src/client/components/components-inspector.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1244 "components-inspector.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 234 "../src/client/components/components-inspector.vala"
		err = _inner_error0_;
#line 234 "../src/client/components/components-inspector.vala"
		_inner_error0_ = NULL;
#line 237 "../src/client/components/components-inspector.vala"
		_tmp0_ = err;
#line 237 "../src/client/components/components-inspector.vala"
		_tmp1_ = _tmp0_->message;
#line 237 "../src/client/components/components-inspector.vala"
		g_warning ("components-inspector.vala:237: Failed to save inspector data: %s", _tmp1_);
#line 234 "../src/client/components/components-inspector.vala"
		_g_error_free0 (err);
#line 1266 "components-inspector.c"
	}
	__finally0:
#line 234 "../src/client/components/components-inspector.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 234 "../src/client/components/components-inspector.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 234 "../src/client/components/components-inspector.vala"
		g_clear_error (&_inner_error0_);
#line 234 "../src/client/components/components-inspector.vala"
		return;
#line 1277 "components-inspector.c"
	}
}

static void
____lambda39__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 230 "../src/client/components/components-inspector.vala"
	___lambda39_ ((ComponentsInspector*) self, source_object, res);
#line 230 "../src/client/components/components-inspector.vala"
	g_object_unref (self);
#line 1290 "components-inspector.c"
}

static void
components_inspector_on_save_as_clicked (ComponentsInspector* self)
{
	GtkFileChooserNative* chooser = NULL;
	GtkFileChooserNative* _tmp0_;
	GtkFileChooserNative* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GtkFileChooserNative* _tmp6_;
#line 217 "../src/client/components/components-inspector.vala"
	g_return_if_fail (COMPONENTS_IS_INSPECTOR (self));
#line 218 "../src/client/components/components-inspector.vala"
	_tmp0_ = gtk_file_chooser_native_new (_ ("Save As"), G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), GTK_FILE_CHOOSER_ACTION_SAVE, _ ("Save As"), _ ("Cancel"));
#line 218 "../src/client/components/components-inspector.vala"
	chooser = _tmp0_;
#line 225 "../src/client/components/components-inspector.vala"
	_tmp1_ = chooser;
#line 225 "../src/client/components/components-inspector.vala"
	_tmp2_ = g_date_time_new_now_local ();
#line 225 "../src/client/components/components-inspector.vala"
	_tmp3_ = _tmp2_;
#line 225 "../src/client/components/components-inspector.vala"
	_tmp4_ = g_date_time_format (_tmp3_, "Geary Inspector - %F %T.txt");
#line 225 "../src/client/components/components-inspector.vala"
	_tmp5_ = _tmp4_;
#line 225 "../src/client/components/components-inspector.vala"
	gtk_file_chooser_set_current_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_file_chooser_get_type (), GtkFileChooser), _tmp5_);
#line 225 "../src/client/components/components-inspector.vala"
	_g_free0 (_tmp5_);
#line 225 "../src/client/components/components-inspector.vala"
	_g_date_time_unref0 (_tmp3_);
#line 229 "../src/client/components/components-inspector.vala"
	_tmp6_ = chooser;
#line 229 "../src/client/components/components-inspector.vala"
	if (gtk_native_dialog_run (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_native_dialog_get_type (), GtkNativeDialog)) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 1330 "components-inspector.c"
		GtkFileChooserNative* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 230 "../src/client/components/components-inspector.vala"
		_tmp7_ = chooser;
#line 230 "../src/client/components/components-inspector.vala"
		_tmp8_ = gtk_file_chooser_get_filename (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_file_chooser_get_type (), GtkFileChooser));
#line 230 "../src/client/components/components-inspector.vala"
		_tmp9_ = _tmp8_;
#line 230 "../src/client/components/components-inspector.vala"
		components_inspector_save (self, _tmp9_, NULL, ____lambda39__gasync_ready_callback, g_object_ref (self));
#line 230 "../src/client/components/components-inspector.vala"
		_g_free0 (_tmp9_);
#line 1344 "components-inspector.c"
	}
#line 217 "../src/client/components/components-inspector.vala"
	_g_object_unref0 (chooser);
#line 1348 "components-inspector.c"
}

static void
_components_inspector_on_save_as_clicked_gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self)
{
#line 12 "../src/client/components/components-inspector.vala"
	components_inspector_on_save_as_clicked ((ComponentsInspector*) self);
#line 1357 "components-inspector.c"
}

static void
components_inspector_on_logs_selection_changed (ComponentsInspector* self)
{
#line 244 "../src/client/components/components-inspector.vala"
	g_return_if_fail (COMPONENTS_IS_INSPECTOR (self));
#line 245 "../src/client/components/components-inspector.vala"
	components_inspector_update_ui (self);
#line 1367 "components-inspector.c"
}

static gboolean
_variant_get6 (GVariant* value)
{
#line 250 "../src/client/components/components-inspector.vala"
	return g_variant_get_boolean (value);
#line 1375 "components-inspector.c"
}

static GVariant*
_variant_new5 (gboolean value)
{
#line 252 "../src/client/components/components-inspector.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 1383 "components-inspector.c"
}

static void
components_inspector_on_logs_search_toggled (ComponentsInspector* self,
                                             GSimpleAction* action,
                                             GVariant* param)
{
	gboolean enabled = FALSE;
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	ComponentsInspectorLogView* _tmp5_;
	GVariant* _tmp6_;
#line 248 "../src/client/components/components-inspector.vala"
	g_return_if_fail (COMPONENTS_IS_INSPECTOR (self));
#line 248 "../src/client/components/components-inspector.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_simple_action_get_type ()));
#line 250 "../src/client/components/components-inspector.vala"
	_tmp0_ = g_action_get_state (G_TYPE_CHECK_INSTANCE_CAST (action, g_action_get_type (), GAction));
#line 250 "../src/client/components/components-inspector.vala"
	_tmp1_ = _tmp0_;
#line 250 "../src/client/components/components-inspector.vala"
	_tmp2_ = _tmp1_;
#line 250 "../src/client/components/components-inspector.vala"
	_tmp3_ = _variant_get6 (_tmp2_);
#line 250 "../src/client/components/components-inspector.vala"
	_tmp4_ = !_tmp3_;
#line 250 "../src/client/components/components-inspector.vala"
	_g_variant_unref0 (_tmp2_);
#line 250 "../src/client/components/components-inspector.vala"
	enabled = _tmp4_;
#line 251 "../src/client/components/components-inspector.vala"
	_tmp5_ = self->priv->log_pane;
#line 251 "../src/client/components/components-inspector.vala"
	components_inspector_log_view_set_search_mode_enabled (_tmp5_, enabled);
#line 252 "../src/client/components/components-inspector.vala"
	_tmp6_ = _variant_new5 (enabled);
#line 252 "../src/client/components/components-inspector.vala"
	g_simple_action_set_state (action, _tmp6_);
#line 252 "../src/client/components/components-inspector.vala"
	_g_variant_unref0 (_tmp6_);
#line 1427 "components-inspector.c"
}

static void
components_inspector_on_logs_search_activated (ComponentsInspector* self)
{
	GtkToggleButton* _tmp0_;
#line 255 "../src/client/components/components-inspector.vala"
	g_return_if_fail (COMPONENTS_IS_INSPECTOR (self));
#line 256 "../src/client/components/components-inspector.vala"
	_tmp0_ = self->priv->search_button;
#line 256 "../src/client/components/components-inspector.vala"
	gtk_toggle_button_set_active (_tmp0_, TRUE);
#line 1440 "components-inspector.c"
}

static gboolean
_variant_get7 (GVariant* value)
{
#line 261 "../src/client/components/components-inspector.vala"
	return g_variant_get_boolean (value);
#line 1448 "components-inspector.c"
}

static GVariant*
_variant_new6 (gboolean value)
{
#line 263 "../src/client/components/components-inspector.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 1456 "components-inspector.c"
}

static void
components_inspector_on_logs_play_toggled (ComponentsInspector* self,
                                           GSimpleAction* action,
                                           GVariant* param)
{
	gboolean enabled = FALSE;
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GVariant* _tmp5_;
#line 259 "../src/client/components/components-inspector.vala"
	g_return_if_fail (COMPONENTS_IS_INSPECTOR (self));
#line 259 "../src/client/components/components-inspector.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_simple_action_get_type ()));
#line 261 "../src/client/components/components-inspector.vala"
	_tmp0_ = g_action_get_state (G_TYPE_CHECK_INSTANCE_CAST (action, g_action_get_type (), GAction));
#line 261 "../src/client/components/components-inspector.vala"
	_tmp1_ = _tmp0_;
#line 261 "../src/client/components/components-inspector.vala"
	_tmp2_ = _tmp1_;
#line 261 "../src/client/components/components-inspector.vala"
	_tmp3_ = _variant_get7 (_tmp2_);
#line 261 "../src/client/components/components-inspector.vala"
	_tmp4_ = !_tmp3_;
#line 261 "../src/client/components/components-inspector.vala"
	_g_variant_unref0 (_tmp2_);
#line 261 "../src/client/components/components-inspector.vala"
	enabled = _tmp4_;
#line 262 "../src/client/components/components-inspector.vala"
	components_inspector_enable_log_updates (self, enabled);
#line 263 "../src/client/components/components-inspector.vala"
	_tmp5_ = _variant_new6 (enabled);
#line 263 "../src/client/components/components-inspector.vala"
	g_simple_action_set_state (action, _tmp5_);
#line 263 "../src/client/components/components-inspector.vala"
	_g_variant_unref0 (_tmp5_);
#line 1497 "components-inspector.c"
}

static void
components_inspector_on_close (ComponentsInspector* self)
{
#line 266 "../src/client/components/components-inspector.vala"
	g_return_if_fail (COMPONENTS_IS_INSPECTOR (self));
#line 267 "../src/client/components/components-inspector.vala"
	gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 1507 "components-inspector.c"
}

static void
components_inspector_class_init (ComponentsInspectorClass * klass,
                                 gpointer klass_data)
{
#line 12 "../src/client/components/components-inspector.vala"
	components_inspector_parent_class = g_type_class_peek_parent (klass);
#line 12 "../src/client/components/components-inspector.vala"
	g_type_class_adjust_private_offset (klass, &ComponentsInspector_private_offset);
#line 12 "../src/client/components/components-inspector.vala"
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) components_inspector_real_key_press_event;
#line 12 "../src/client/components/components-inspector.vala"
	G_OBJECT_CLASS (klass)->finalize = components_inspector_finalize;
#line 12 "../src/client/components/components-inspector.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Geary/components-inspector.ui");
#line 12 "../src/client/components/components-inspector.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "header_bar", FALSE, ComponentsInspector_private_offset + G_STRUCT_OFFSET (ComponentsInspectorPrivate, header_bar));
#line 12 "../src/client/components/components-inspector.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "stack", FALSE, ComponentsInspector_private_offset + G_STRUCT_OFFSET (ComponentsInspectorPrivate, stack));
#line 12 "../src/client/components/components-inspector.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "copy_button", FALSE, ComponentsInspector_private_offset + G_STRUCT_OFFSET (ComponentsInspectorPrivate, copy_button));
#line 12 "../src/client/components/components-inspector.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "play_button", FALSE, ComponentsInspector_private_offset + G_STRUCT_OFFSET (ComponentsInspectorPrivate, play_button));
#line 12 "../src/client/components/components-inspector.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "mark_button", FALSE, ComponentsInspector_private_offset + G_STRUCT_OFFSET (ComponentsInspectorPrivate, mark_button));
#line 12 "../src/client/components/components-inspector.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "search_button", FALSE, ComponentsInspector_private_offset + G_STRUCT_OFFSET (ComponentsInspectorPrivate, search_button));
#line 12 "../src/client/components/components-inspector.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "clear_button", FALSE, ComponentsInspector_private_offset + G_STRUCT_OFFSET (ComponentsInspectorPrivate, clear_button));
#line 12 "../src/client/components/components-inspector.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_visible_child_changed", G_CALLBACK(_components_inspector_on_visible_child_changed_g_object_notify));
#line 12 "../src/client/components/components-inspector.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_mark_clicked", G_CALLBACK(_components_inspector_on_mark_clicked_gtk_button_clicked));
#line 12 "../src/client/components/components-inspector.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_clear_clicked", G_CALLBACK(_components_inspector_on_clear_clicked_gtk_button_clicked));
#line 12 "../src/client/components/components-inspector.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_save_as_clicked", G_CALLBACK(_components_inspector_on_save_as_clicked_gtk_button_clicked));
#line 1546 "components-inspector.c"
}

static void
components_inspector_instance_init (ComponentsInspector * self,
                                    gpointer klass)
{
#line 12 "../src/client/components/components-inspector.vala"
	self->priv = components_inspector_get_instance_private (self);
#line 12 "../src/client/components/components-inspector.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1557 "components-inspector.c"
}

static void
components_inspector_finalize (GObject * obj)
{
	ComponentsInspector * self;
#line 12 "../src/client/components/components-inspector.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, COMPONENTS_TYPE_INSPECTOR, ComponentsInspector);
#line 65 "../src/client/components/components-inspector.vala"
	_g_object_unref0 (self->priv->log_pane);
#line 66 "../src/client/components/components-inspector.vala"
	_g_object_unref0 (self->priv->system_pane);
#line 12 "../src/client/components/components-inspector.vala"
	G_OBJECT_CLASS (components_inspector_parent_class)->finalize (obj);
#line 1572 "components-inspector.c"
}

/**
 * A window that displays debugging and development information.
 */
static GType
components_inspector_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ComponentsInspectorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) components_inspector_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ComponentsInspector), 0, (GInstanceInitFunc) components_inspector_instance_init, NULL };
	GType components_inspector_type_id;
	components_inspector_type_id = g_type_register_static (gtk_application_window_get_type (), "ComponentsInspector", &g_define_type_info, 0);
	ComponentsInspector_private_offset = g_type_add_instance_private (components_inspector_type_id, sizeof (ComponentsInspectorPrivate));
	return components_inspector_type_id;
}

GType
components_inspector_get_type (void)
{
	static volatile gsize components_inspector_type_id__once = 0;
	if (g_once_init_enter (&components_inspector_type_id__once)) {
		GType components_inspector_type_id;
		components_inspector_type_id = components_inspector_get_type_once ();
		g_once_init_leave (&components_inspector_type_id__once, components_inspector_type_id);
	}
	return components_inspector_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

