/* components-search-bar.c generated by valac 0.56.17, the Vala compiler
 * generated from components-search-bar.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2019 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-client-46.0.h"
#include <gtk/gtk.h>
#include "geary-engine.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include <handy.h>

#define SEARCH_BAR_DEFAULT_SEARCH_TEXT _ ("Search")
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SEARCH_BAR_0_PROPERTY,
	SEARCH_BAR_ENTRY_PROPERTY,
	SEARCH_BAR_NUM_PROPERTIES
};
static GParamSpec* search_bar_properties[SEARCH_BAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	SEARCH_BAR_SEARCH_TEXT_CHANGED_SIGNAL,
	SEARCH_BAR_NUM_SIGNALS
};
static guint search_bar_signals[SEARCH_BAR_NUM_SIGNALS] = {0};

struct _SearchBarPrivate {
	GtkSearchEntry* _entry;
	ComponentsEntryUndo* search_undo;
	GearyAccount* current_account;
	GearyEngine* engine;
};

static gint SearchBar_private_offset;
static gpointer search_bar_parent_class = NULL;

static void search_bar_set_entry (SearchBar* self,
                           GtkSearchEntry* value);
static void search_bar_on_search_mode_changed (SearchBar* self);
static void _search_bar_on_search_mode_changed_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void __lambda93_ (SearchBar* self);
static void ___lambda93__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                   gpointer self);
static void __lambda94_ (SearchBar* self);
static void ___lambda94__gtk_entry_activate (GtkEntry* _sender,
                                      gpointer self);
static void search_bar_real_grab_focus (GtkWidget* base);
static void search_bar_on_information_changed (SearchBar* self);
static void _search_bar_on_information_changed_geary_account_information_changed (GearyAccountInformation* _sender,
                                                                           gpointer self);
static void search_bar_finalize (GObject * obj);
static GType search_bar_get_type_once (void);
static void _vala_search_bar_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_search_bar_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);

static inline gpointer
search_bar_get_instance_private (SearchBar* self)
{
	return G_STRUCT_MEMBER_P (self, SearchBar_private_offset);
}

GtkSearchEntry*
search_bar_get_entry (SearchBar* self)
{
	GtkSearchEntry* result;
	GtkSearchEntry* _tmp0_;
#line 15 "../src/client/components/components-search-bar.vala"
	g_return_val_if_fail (IS_SEARCH_BAR (self), NULL);
#line 15 "../src/client/components/components-search-bar.vala"
	_tmp0_ = self->priv->_entry;
#line 15 "../src/client/components/components-search-bar.vala"
	result = _tmp0_;
#line 15 "../src/client/components/components-search-bar.vala"
	return result;
#line 103 "components-search-bar.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 15 "../src/client/components/components-search-bar.vala"
	return self ? g_object_ref (self) : NULL;
#line 111 "components-search-bar.c"
}

static void
search_bar_set_entry (SearchBar* self,
                      GtkSearchEntry* value)
{
	GtkSearchEntry* old_value;
#line 15 "../src/client/components/components-search-bar.vala"
	g_return_if_fail (IS_SEARCH_BAR (self));
#line 15 "../src/client/components/components-search-bar.vala"
	old_value = search_bar_get_entry (self);
#line 15 "../src/client/components/components-search-bar.vala"
	if (old_value != value) {
#line 125 "components-search-bar.c"
		GtkSearchEntry* _tmp0_;
#line 15 "../src/client/components/components-search-bar.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 15 "../src/client/components/components-search-bar.vala"
		_g_object_unref0 (self->priv->_entry);
#line 15 "../src/client/components/components-search-bar.vala"
		self->priv->_entry = _tmp0_;
#line 15 "../src/client/components/components-search-bar.vala"
		g_object_notify_by_pspec ((GObject *) self, search_bar_properties[SEARCH_BAR_ENTRY_PROPERTY]);
#line 135 "components-search-bar.c"
	}
}

static void
_search_bar_on_search_mode_changed_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
#line 29 "../src/client/components/components-search-bar.vala"
	search_bar_on_search_mode_changed ((SearchBar*) self);
#line 146 "components-search-bar.c"
}

static void
__lambda93_ (SearchBar* self)
{
	GtkSearchEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 34 "../src/client/components/components-search-bar.vala"
	_tmp0_ = self->priv->_entry;
#line 34 "../src/client/components/components-search-bar.vala"
	_tmp1_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_entry_get_type (), GtkEntry));
#line 34 "../src/client/components/components-search-bar.vala"
	_tmp2_ = _tmp1_;
#line 34 "../src/client/components/components-search-bar.vala"
	g_signal_emit (self, search_bar_signals[SEARCH_BAR_SEARCH_TEXT_CHANGED_SIGNAL], 0, _tmp2_);
#line 163 "components-search-bar.c"
}

static void
___lambda93__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                              gpointer self)
{
#line 33 "../src/client/components/components-search-bar.vala"
	__lambda93_ ((SearchBar*) self);
#line 172 "components-search-bar.c"
}

static void
__lambda94_ (SearchBar* self)
{
	GtkSearchEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 37 "../src/client/components/components-search-bar.vala"
	_tmp0_ = self->priv->_entry;
#line 37 "../src/client/components/components-search-bar.vala"
	_tmp1_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_entry_get_type (), GtkEntry));
#line 37 "../src/client/components/components-search-bar.vala"
	_tmp2_ = _tmp1_;
#line 37 "../src/client/components/components-search-bar.vala"
	g_signal_emit (self, search_bar_signals[SEARCH_BAR_SEARCH_TEXT_CHANGED_SIGNAL], 0, _tmp2_);
#line 189 "components-search-bar.c"
}

static void
___lambda94__gtk_entry_activate (GtkEntry* _sender,
                                 gpointer self)
{
#line 36 "../src/client/components/components-search-bar.vala"
	__lambda94_ ((SearchBar*) self);
#line 198 "components-search-bar.c"
}

SearchBar*
search_bar_construct (GType object_type,
                      GearyEngine* engine)
{
	SearchBar * self = NULL;
	GearyEngine* _tmp0_;
	GtkSearchEntry* _tmp1_;
	ComponentsEntryUndo* _tmp2_;
	GtkSearchEntry* _tmp3_;
	GtkSearchEntry* _tmp4_;
	GtkSearchEntry* _tmp5_;
	GtkSearchEntry* _tmp6_;
	GtkSearchEntry* _tmp7_;
	HdyClamp* column = NULL;
	HdyClamp* _tmp8_;
	GtkSearchEntry* _tmp9_;
	GtkSearchEntry* _tmp10_;
#line 25 "../src/client/components/components-search-bar.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (engine, GEARY_TYPE_ENGINE), NULL);
#line 25 "../src/client/components/components-search-bar.vala"
	self = (SearchBar*) g_object_new (object_type, NULL);
#line 26 "../src/client/components/components-search-bar.vala"
	_tmp0_ = _g_object_ref0 (engine);
#line 26 "../src/client/components/components-search-bar.vala"
	_g_object_unref0 (self->priv->engine);
#line 26 "../src/client/components/components-search-bar.vala"
	self->priv->engine = _tmp0_;
#line 27 "../src/client/components/components-search-bar.vala"
	_tmp1_ = self->priv->_entry;
#line 27 "../src/client/components/components-search-bar.vala"
	_tmp2_ = components_entry_undo_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_entry_get_type (), GtkEntry));
#line 27 "../src/client/components/components-search-bar.vala"
	_g_object_unref0 (self->priv->search_undo);
#line 27 "../src/client/components/components-search-bar.vala"
	self->priv->search_undo = _tmp2_;
#line 29 "../src/client/components/components-search-bar.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "notify::search-mode-enabled", (GCallback) _search_bar_on_search_mode_changed_g_object_notify, self, 0);
#line 32 "../src/client/components/components-search-bar.vala"
	_tmp3_ = self->priv->_entry;
#line 32 "../src/client/components/components-search-bar.vala"
	gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget), _ ("Search all mail in account for keywords"));
#line 33 "../src/client/components/components-search-bar.vala"
	_tmp4_ = self->priv->_entry;
#line 33 "../src/client/components/components-search-bar.vala"
	g_signal_connect_object (_tmp4_, "search-changed", (GCallback) ___lambda93__gtk_search_entry_search_changed, self, 0);
#line 36 "../src/client/components/components-search-bar.vala"
	_tmp5_ = self->priv->_entry;
#line 36 "../src/client/components/components-search-bar.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_entry_get_type (), GtkEntry), "activate", (GCallback) ___lambda94__gtk_entry_activate, self, 0);
#line 39 "../src/client/components/components-search-bar.vala"
	_tmp6_ = self->priv->_entry;
#line 39 "../src/client/components/components-search-bar.vala"
	gtk_entry_set_placeholder_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_entry_get_type (), GtkEntry), SEARCH_BAR_DEFAULT_SEARCH_TEXT);
#line 40 "../src/client/components/components-search-bar.vala"
	_tmp7_ = self->priv->_entry;
#line 40 "../src/client/components/components-search-bar.vala"
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget), "has-focus", TRUE, NULL);
#line 42 "../src/client/components/components-search-bar.vala"
	_tmp8_ = (HdyClamp*) hdy_clamp_new ();
#line 42 "../src/client/components/components-search-bar.vala"
	g_object_ref_sink (_tmp8_);
#line 42 "../src/client/components/components-search-bar.vala"
	column = _tmp8_;
#line 43 "../src/client/components/components-search-bar.vala"
	hdy_clamp_set_maximum_size (column, 400);
#line 44 "../src/client/components/components-search-bar.vala"
	_tmp9_ = self->priv->_entry;
#line 44 "../src/client/components/components-search-bar.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (column, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_widget_get_type (), GtkWidget));
#line 46 "../src/client/components/components-search-bar.vala"
	_tmp10_ = self->priv->_entry;
#line 46 "../src/client/components/components-search-bar.vala"
	hdy_search_bar_connect_entry (G_TYPE_CHECK_INSTANCE_CAST (self, hdy_search_bar_get_type (), HdySearchBar), G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_entry_get_type (), GtkEntry));
#line 47 "../src/client/components/components-search-bar.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (column, gtk_widget_get_type (), GtkWidget));
#line 49 "../src/client/components/components-search-bar.vala"
	gtk_widget_show_all (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 25 "../src/client/components/components-search-bar.vala"
	_g_object_unref0 (column);
#line 25 "../src/client/components/components-search-bar.vala"
	return self;
#line 282 "components-search-bar.c"
}

SearchBar*
search_bar_new (GearyEngine* engine)
{
#line 25 "../src/client/components/components-search-bar.vala"
	return search_bar_construct (TYPE_SEARCH_BAR, engine);
#line 290 "components-search-bar.c"
}

static void
search_bar_real_grab_focus (GtkWidget* base)
{
	SearchBar * self;
	GtkSearchEntry* _tmp0_;
#line 52 "../src/client/components/components-search-bar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SEARCH_BAR, SearchBar);
#line 53 "../src/client/components/components-search-bar.vala"
	hdy_search_bar_set_search_mode (G_TYPE_CHECK_INSTANCE_CAST (self, hdy_search_bar_get_type (), HdySearchBar), TRUE);
#line 54 "../src/client/components/components-search-bar.vala"
	_tmp0_ = self->priv->_entry;
#line 54 "../src/client/components/components-search-bar.vala"
	gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 306 "components-search-bar.c"
}

static void
_search_bar_on_information_changed_geary_account_information_changed (GearyAccountInformation* _sender,
                                                                      gpointer self)
{
#line 59 "../src/client/components/components-search-bar.vala"
	search_bar_on_information_changed ((SearchBar*) self);
#line 315 "components-search-bar.c"
}

void
search_bar_set_account (SearchBar* self,
                        GearyAccount* account)
{
	GearyAccount* _tmp0_;
	GearyAccount* _tmp7_;
#line 57 "../src/client/components/components-search-bar.vala"
	g_return_if_fail (IS_SEARCH_BAR (self));
#line 57 "../src/client/components/components-search-bar.vala"
	g_return_if_fail ((account == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT));
#line 58 "../src/client/components/components-search-bar.vala"
	_tmp0_ = self->priv->current_account;
#line 58 "../src/client/components/components-search-bar.vala"
	if (_tmp0_ != NULL) {
#line 332 "components-search-bar.c"
		GearyAccount* _tmp1_;
		GearyAccountInformation* _tmp2_;
		GearyAccountInformation* _tmp3_;
		guint _tmp4_;
#line 59 "../src/client/components/components-search-bar.vala"
		_tmp1_ = self->priv->current_account;
#line 59 "../src/client/components/components-search-bar.vala"
		_tmp2_ = geary_account_get_information (_tmp1_);
#line 59 "../src/client/components/components-search-bar.vala"
		_tmp3_ = _tmp2_;
#line 59 "../src/client/components/components-search-bar.vala"
		g_signal_parse_name ("changed", GEARY_TYPE_ACCOUNT_INFORMATION, &_tmp4_, NULL, FALSE);
#line 59 "../src/client/components/components-search-bar.vala"
		g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _search_bar_on_information_changed_geary_account_information_changed, self);
#line 347 "components-search-bar.c"
	}
#line 64 "../src/client/components/components-search-bar.vala"
	if (account != NULL) {
#line 351 "components-search-bar.c"
		GearyAccountInformation* _tmp5_;
		GearyAccountInformation* _tmp6_;
#line 65 "../src/client/components/components-search-bar.vala"
		_tmp5_ = geary_account_get_information (account);
#line 65 "../src/client/components/components-search-bar.vala"
		_tmp6_ = _tmp5_;
#line 65 "../src/client/components/components-search-bar.vala"
		g_signal_connect_object (_tmp6_, "changed", (GCallback) _search_bar_on_information_changed_geary_account_information_changed, self, 0);
#line 360 "components-search-bar.c"
	}
#line 70 "../src/client/components/components-search-bar.vala"
	_tmp7_ = _g_object_ref0 (account);
#line 70 "../src/client/components/components-search-bar.vala"
	_g_object_unref0 (self->priv->current_account);
#line 70 "../src/client/components/components-search-bar.vala"
	self->priv->current_account = _tmp7_;
#line 72 "../src/client/components/components-search-bar.vala"
	search_bar_on_information_changed (self);
#line 370 "components-search-bar.c"
}

static void
search_bar_on_information_changed (SearchBar* self)
{
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GearyAccount* _tmp2_;
	GtkSearchEntry* _tmp13_;
#line 75 "../src/client/components/components-search-bar.vala"
	g_return_if_fail (IS_SEARCH_BAR (self));
#line 77 "../src/client/components/components-search-bar.vala"
	_tmp2_ = self->priv->current_account;
#line 77 "../src/client/components/components-search-bar.vala"
	if (_tmp2_ == NULL) {
#line 77 "../src/client/components/components-search-bar.vala"
		_tmp1_ = TRUE;
#line 388 "components-search-bar.c"
	} else {
		GearyEngine* _tmp3_;
		guint _tmp4_;
		guint _tmp5_;
#line 77 "../src/client/components/components-search-bar.vala"
		_tmp3_ = self->priv->engine;
#line 77 "../src/client/components/components-search-bar.vala"
		_tmp4_ = geary_engine_get_accounts_count (_tmp3_);
#line 77 "../src/client/components/components-search-bar.vala"
		_tmp5_ = _tmp4_;
#line 77 "../src/client/components/components-search-bar.vala"
		_tmp1_ = _tmp5_ == ((guint) 1);
#line 401 "components-search-bar.c"
	}
#line 76 "../src/client/components/components-search-bar.vala"
	if (_tmp1_) {
#line 405 "components-search-bar.c"
		gchar* _tmp6_;
#line 78 "../src/client/components/components-search-bar.vala"
		_tmp6_ = g_strdup (SEARCH_BAR_DEFAULT_SEARCH_TEXT);
#line 78 "../src/client/components/components-search-bar.vala"
		_g_free0 (_tmp0_);
#line 78 "../src/client/components/components-search-bar.vala"
		_tmp0_ = _tmp6_;
#line 413 "components-search-bar.c"
	} else {
		GearyAccount* _tmp7_;
		GearyAccountInformation* _tmp8_;
		GearyAccountInformation* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
#line 81 "../src/client/components/components-search-bar.vala"
		_tmp7_ = self->priv->current_account;
#line 81 "../src/client/components/components-search-bar.vala"
		_tmp8_ = geary_account_get_information (_tmp7_);
#line 81 "../src/client/components/components-search-bar.vala"
		_tmp9_ = _tmp8_;
#line 81 "../src/client/components/components-search-bar.vala"
		_tmp10_ = geary_account_information_get_display_name (_tmp9_);
#line 81 "../src/client/components/components-search-bar.vala"
		_tmp11_ = _tmp10_;
#line 81 "../src/client/components/components-search-bar.vala"
		_tmp12_ = g_strdup_printf (_ ("Search %s account"), _tmp11_);
#line 81 "../src/client/components/components-search-bar.vala"
		_g_free0 (_tmp0_);
#line 81 "../src/client/components/components-search-bar.vala"
		_tmp0_ = _tmp12_;
#line 437 "components-search-bar.c"
	}
#line 76 "../src/client/components/components-search-bar.vala"
	_tmp13_ = self->priv->_entry;
#line 76 "../src/client/components/components-search-bar.vala"
	gtk_entry_set_placeholder_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_entry_get_type (), GtkEntry), _tmp0_);
#line 75 "../src/client/components/components-search-bar.vala"
	_g_free0 (_tmp0_);
#line 445 "components-search-bar.c"
}

static void
search_bar_on_search_mode_changed (SearchBar* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 87 "../src/client/components/components-search-bar.vala"
	g_return_if_fail (IS_SEARCH_BAR (self));
#line 88 "../src/client/components/components-search-bar.vala"
	g_object_get (G_TYPE_CHECK_INSTANCE_CAST (self, hdy_search_bar_get_type (), HdySearchBar), "search-mode-enabled", &_tmp0_, NULL);
#line 88 "../src/client/components/components-search-bar.vala"
	_tmp1_ = _tmp0_;
#line 88 "../src/client/components/components-search-bar.vala"
	if (!_tmp1_) {
#line 461 "components-search-bar.c"
		ComponentsEntryUndo* _tmp2_;
#line 89 "../src/client/components/components-search-bar.vala"
		_tmp2_ = self->priv->search_undo;
#line 89 "../src/client/components/components-search-bar.vala"
		components_entry_undo_reset (_tmp2_);
#line 467 "components-search-bar.c"
	}
}

static void
search_bar_class_init (SearchBarClass * klass,
                       gpointer klass_data)
{
#line 9 "../src/client/components/components-search-bar.vala"
	search_bar_parent_class = g_type_class_peek_parent (klass);
#line 9 "../src/client/components/components-search-bar.vala"
	g_type_class_adjust_private_offset (klass, &SearchBar_private_offset);
#line 9 "../src/client/components/components-search-bar.vala"
	((GtkWidgetClass *) klass)->grab_focus = (void (*) (GtkWidget*)) search_bar_real_grab_focus;
#line 9 "../src/client/components/components-search-bar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_search_bar_get_property;
#line 9 "../src/client/components/components-search-bar.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_search_bar_set_property;
#line 9 "../src/client/components/components-search-bar.vala"
	G_OBJECT_CLASS (klass)->finalize = search_bar_finalize;
#line 9 "../src/client/components/components-search-bar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEARCH_BAR_ENTRY_PROPERTY, search_bar_properties[SEARCH_BAR_ENTRY_PROPERTY] = g_param_spec_object ("entry", "entry", "entry", gtk_search_entry_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 9 "../src/client/components/components-search-bar.vala"
	search_bar_signals[SEARCH_BAR_SEARCH_TEXT_CHANGED_SIGNAL] = g_signal_new ("search-text-changed", TYPE_SEARCH_BAR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 491 "components-search-bar.c"
}

static void
search_bar_instance_init (SearchBar * self,
                          gpointer klass)
{
	GtkSearchEntry* _tmp0_;
#line 9 "../src/client/components/components-search-bar.vala"
	self->priv = search_bar_get_instance_private (self);
#line 14 "../src/client/components/components-search-bar.vala"
	_tmp0_ = (GtkSearchEntry*) gtk_search_entry_new ();
#line 14 "../src/client/components/components-search-bar.vala"
	g_object_ref_sink (_tmp0_);
#line 14 "../src/client/components/components-search-bar.vala"
	self->priv->_entry = _tmp0_;
#line 19 "../src/client/components/components-search-bar.vala"
	self->priv->current_account = NULL;
#line 509 "components-search-bar.c"
}

static void
search_bar_finalize (GObject * obj)
{
	SearchBar * self;
#line 9 "../src/client/components/components-search-bar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SEARCH_BAR, SearchBar);
#line 14 "../src/client/components/components-search-bar.vala"
	_g_object_unref0 (self->priv->_entry);
#line 18 "../src/client/components/components-search-bar.vala"
	_g_object_unref0 (self->priv->search_undo);
#line 19 "../src/client/components/components-search-bar.vala"
	_g_object_unref0 (self->priv->current_account);
#line 20 "../src/client/components/components-search-bar.vala"
	_g_object_unref0 (self->priv->engine);
#line 9 "../src/client/components/components-search-bar.vala"
	G_OBJECT_CLASS (search_bar_parent_class)->finalize (obj);
#line 528 "components-search-bar.c"
}

static GType
search_bar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SearchBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchBar), 0, (GInstanceInitFunc) search_bar_instance_init, NULL };
	GType search_bar_type_id;
	search_bar_type_id = g_type_register_static (hdy_search_bar_get_type (), "SearchBar", &g_define_type_info, 0);
	SearchBar_private_offset = g_type_add_instance_private (search_bar_type_id, sizeof (SearchBarPrivate));
	return search_bar_type_id;
}

GType
search_bar_get_type (void)
{
	static volatile gsize search_bar_type_id__once = 0;
	if (g_once_init_enter (&search_bar_type_id__once)) {
		GType search_bar_type_id;
		search_bar_type_id = search_bar_get_type_once ();
		g_once_init_leave (&search_bar_type_id__once, search_bar_type_id);
	}
	return search_bar_type_id__once;
}

static void
_vala_search_bar_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	SearchBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SEARCH_BAR, SearchBar);
#line 9 "../src/client/components/components-search-bar.vala"
	switch (property_id) {
#line 9 "../src/client/components/components-search-bar.vala"
		case SEARCH_BAR_ENTRY_PROPERTY:
#line 9 "../src/client/components/components-search-bar.vala"
		g_value_set_object (value, search_bar_get_entry (self));
#line 9 "../src/client/components/components-search-bar.vala"
		break;
#line 569 "components-search-bar.c"
		default:
#line 9 "../src/client/components/components-search-bar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 9 "../src/client/components/components-search-bar.vala"
		break;
#line 575 "components-search-bar.c"
	}
}

static void
_vala_search_bar_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	SearchBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SEARCH_BAR, SearchBar);
#line 9 "../src/client/components/components-search-bar.vala"
	switch (property_id) {
#line 9 "../src/client/components/components-search-bar.vala"
		case SEARCH_BAR_ENTRY_PROPERTY:
#line 9 "../src/client/components/components-search-bar.vala"
		search_bar_set_entry (self, g_value_get_object (value));
#line 9 "../src/client/components/components-search-bar.vala"
		break;
#line 595 "components-search-bar.c"
		default:
#line 9 "../src/client/components/components-search-bar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 9 "../src/client/components/components-search-bar.vala"
		break;
#line 601 "components-search-bar.c"
	}
}

