/* composer-email-entry.c generated by valac 0.56.17, the Vala compiler
 * generated from composer-email-entry.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2020 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-client-46.0.h"
#include "geary-engine.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	COMPOSER_EMAIL_ENTRY_0_PROPERTY,
	COMPOSER_EMAIL_ENTRY_ADDRESSES_PROPERTY,
	COMPOSER_EMAIL_ENTRY_IS_VALID_PROPERTY,
	COMPOSER_EMAIL_ENTRY_IS_EMPTY_PROPERTY,
	COMPOSER_EMAIL_ENTRY_IS_MODIFIED_PROPERTY,
	COMPOSER_EMAIL_ENTRY_NUM_PROPERTIES
};
static GParamSpec* composer_email_entry_properties[COMPOSER_EMAIL_ENTRY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ComposerEmailEntryPrivate {
	GearyRFC822MailboxAddresses* _addresses;
	gboolean _is_valid;
	gboolean _is_modified;
	ComposerWidget* composer;
};

static gint ComposerEmailEntry_private_offset;
static gpointer composer_email_entry_parent_class = NULL;

static void composer_email_entry_validate_addresses (ComposerEmailEntry* self);
static void composer_email_entry_set_is_modified (ComposerEmailEntry* self,
                                           gboolean value);
static void composer_email_entry_set_is_valid (ComposerEmailEntry* self,
                                        gboolean value);
static void composer_email_entry_on_changed (ComposerEmailEntry* self);
static void _composer_email_entry_on_changed_gtk_editable_changed (GtkEditable* _sender,
                                                            gpointer self);
static gboolean composer_email_entry_on_key_press (ComposerEmailEntry* self,
                                            GtkWidget* widget,
                                            GdkEventKey* event);
static gboolean _composer_email_entry_on_key_press_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                        GdkEventKey* event,
                                                                        gpointer self);
static void composer_email_entry_finalize (GObject * obj);
static GType composer_email_entry_get_type_once (void);
static void _vala_composer_email_entry_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_composer_email_entry_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
composer_email_entry_get_instance_private (ComposerEmailEntry* self)
{
	return G_STRUCT_MEMBER_P (self, ComposerEmailEntry_private_offset);
}

GearyRFC822MailboxAddresses*
composer_email_entry_get_addresses (ComposerEmailEntry* self)
{
	GearyRFC822MailboxAddresses* result;
	GearyRFC822MailboxAddresses* _tmp0_;
#line 16 "../src/client/composer/composer-email-entry.vala"
	g_return_val_if_fail (COMPOSER_IS_EMAIL_ENTRY (self), NULL);
#line 16 "../src/client/composer/composer-email-entry.vala"
	_tmp0_ = self->priv->_addresses;
#line 16 "../src/client/composer/composer-email-entry.vala"
	result = _tmp0_;
#line 16 "../src/client/composer/composer-email-entry.vala"
	return result;
#line 97 "composer-email-entry.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 18 "../src/client/composer/composer-email-entry.vala"
	return self ? g_object_ref (self) : NULL;
#line 105 "composer-email-entry.c"
}

void
composer_email_entry_set_addresses (ComposerEmailEntry* self,
                                    GearyRFC822MailboxAddresses* value)
{
	GearyRFC822MailboxAddresses* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 17 "../src/client/composer/composer-email-entry.vala"
	g_return_if_fail (COMPOSER_IS_EMAIL_ENTRY (self));
#line 18 "../src/client/composer/composer-email-entry.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 18 "../src/client/composer/composer-email-entry.vala"
	_g_object_unref0 (self->priv->_addresses);
#line 18 "../src/client/composer/composer-email-entry.vala"
	self->priv->_addresses = _tmp0_;
#line 19 "../src/client/composer/composer-email-entry.vala"
	composer_email_entry_validate_addresses (self);
#line 20 "../src/client/composer/composer-email-entry.vala"
	composer_email_entry_set_is_modified (self, FALSE);
#line 21 "../src/client/composer/composer-email-entry.vala"
	_tmp1_ = geary_rf_c822_mailbox_addresses_to_full_display (value);
#line 21 "../src/client/composer/composer-email-entry.vala"
	_tmp2_ = _tmp1_;
#line 21 "../src/client/composer/composer-email-entry.vala"
	gtk_entry_set_text (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_get_type (), GtkEntry), _tmp2_);
#line 21 "../src/client/composer/composer-email-entry.vala"
	_g_free0 (_tmp2_);
#line 17 "../src/client/composer/composer-email-entry.vala"
	g_object_notify_by_pspec ((GObject *) self, composer_email_entry_properties[COMPOSER_EMAIL_ENTRY_ADDRESSES_PROPERTY]);
#line 137 "composer-email-entry.c"
}

gboolean
composer_email_entry_get_is_valid (ComposerEmailEntry* self)
{
	gboolean result;
#line 27 "../src/client/composer/composer-email-entry.vala"
	g_return_val_if_fail (COMPOSER_IS_EMAIL_ENTRY (self), FALSE);
#line 27 "../src/client/composer/composer-email-entry.vala"
	result = self->priv->_is_valid;
#line 27 "../src/client/composer/composer-email-entry.vala"
	return result;
#line 150 "composer-email-entry.c"
}

static void
composer_email_entry_set_is_valid (ComposerEmailEntry* self,
                                   gboolean value)
{
	gboolean old_value;
#line 27 "../src/client/composer/composer-email-entry.vala"
	g_return_if_fail (COMPOSER_IS_EMAIL_ENTRY (self));
#line 27 "../src/client/composer/composer-email-entry.vala"
	old_value = composer_email_entry_get_is_valid (self);
#line 27 "../src/client/composer/composer-email-entry.vala"
	if (old_value != value) {
#line 27 "../src/client/composer/composer-email-entry.vala"
		self->priv->_is_valid = value;
#line 27 "../src/client/composer/composer-email-entry.vala"
		g_object_notify_by_pspec ((GObject *) self, composer_email_entry_properties[COMPOSER_EMAIL_ENTRY_IS_VALID_PROPERTY]);
#line 168 "composer-email-entry.c"
	}
}

gboolean
composer_email_entry_get_is_empty (ComposerEmailEntry* self)
{
	gboolean result;
	GearyRFC822MailboxAddresses* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 31 "../src/client/composer/composer-email-entry.vala"
	g_return_val_if_fail (COMPOSER_IS_EMAIL_ENTRY (self), FALSE);
#line 32 "../src/client/composer/composer-email-entry.vala"
	_tmp0_ = self->priv->_addresses;
#line 32 "../src/client/composer/composer-email-entry.vala"
	_tmp1_ = geary_rf_c822_mailbox_addresses_get_is_empty (_tmp0_);
#line 32 "../src/client/composer/composer-email-entry.vala"
	_tmp2_ = _tmp1_;
#line 32 "../src/client/composer/composer-email-entry.vala"
	result = _tmp2_;
#line 32 "../src/client/composer/composer-email-entry.vala"
	return result;
#line 191 "composer-email-entry.c"
}

gboolean
composer_email_entry_get_is_modified (ComposerEmailEntry* self)
{
	gboolean result;
#line 43 "../src/client/composer/composer-email-entry.vala"
	g_return_val_if_fail (COMPOSER_IS_EMAIL_ENTRY (self), FALSE);
#line 43 "../src/client/composer/composer-email-entry.vala"
	result = self->priv->_is_modified;
#line 43 "../src/client/composer/composer-email-entry.vala"
	return result;
#line 204 "composer-email-entry.c"
}

static void
composer_email_entry_set_is_modified (ComposerEmailEntry* self,
                                      gboolean value)
{
	gboolean old_value;
#line 43 "../src/client/composer/composer-email-entry.vala"
	g_return_if_fail (COMPOSER_IS_EMAIL_ENTRY (self));
#line 43 "../src/client/composer/composer-email-entry.vala"
	old_value = composer_email_entry_get_is_modified (self);
#line 43 "../src/client/composer/composer-email-entry.vala"
	if (old_value != value) {
#line 43 "../src/client/composer/composer-email-entry.vala"
		self->priv->_is_modified = value;
#line 43 "../src/client/composer/composer-email-entry.vala"
		g_object_notify_by_pspec ((GObject *) self, composer_email_entry_properties[COMPOSER_EMAIL_ENTRY_IS_MODIFIED_PROPERTY]);
#line 222 "composer-email-entry.c"
	}
}

static void
_composer_email_entry_on_changed_gtk_editable_changed (GtkEditable* _sender,
                                                       gpointer self)
{
#line 49 "../src/client/composer/composer-email-entry.vala"
	composer_email_entry_on_changed ((ComposerEmailEntry*) self);
#line 232 "composer-email-entry.c"
}

static gboolean
_composer_email_entry_on_key_press_gtk_widget_key_press_event (GtkWidget* _sender,
                                                               GdkEventKey* event,
                                                               gpointer self)
{
	gboolean result;
	result = composer_email_entry_on_key_press ((ComposerEmailEntry*) self, _sender, event);
#line 50 "../src/client/composer/composer-email-entry.vala"
	return result;
#line 244 "composer-email-entry.c"
}

ComposerEmailEntry*
composer_email_entry_construct (GType object_type,
                                ComposerWidget* composer)
{
	ComposerEmailEntry * self = NULL;
#line 48 "../src/client/composer/composer-email-entry.vala"
	g_return_val_if_fail (COMPOSER_IS_WIDGET (composer), NULL);
#line 48 "../src/client/composer/composer-email-entry.vala"
	self = (ComposerEmailEntry*) g_object_new (object_type, NULL);
#line 49 "../src/client/composer/composer-email-entry.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_editable_get_type (), GtkEditable), "changed", (GCallback) _composer_email_entry_on_changed_gtk_editable_changed, self, 0);
#line 50 "../src/client/composer/composer-email-entry.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "key-press-event", (GCallback) _composer_email_entry_on_key_press_gtk_widget_key_press_event, self, 0);
#line 51 "../src/client/composer/composer-email-entry.vala"
	self->priv->composer = composer;
#line 52 "../src/client/composer/composer-email-entry.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 48 "../src/client/composer/composer-email-entry.vala"
	return self;
#line 266 "composer-email-entry.c"
}

ComposerEmailEntry*
composer_email_entry_new (ComposerWidget* composer)
{
#line 48 "../src/client/composer/composer-email-entry.vala"
	return composer_email_entry_construct (COMPOSER_TYPE_EMAIL_ENTRY, composer);
#line 274 "composer-email-entry.c"
}

/** Marks the entry as being modified. */
void
composer_email_entry_set_modified (ComposerEmailEntry* self)
{
#line 56 "../src/client/composer/composer-email-entry.vala"
	g_return_if_fail (COMPOSER_IS_EMAIL_ENTRY (self));
#line 57 "../src/client/composer/composer-email-entry.vala"
	composer_email_entry_set_is_modified (self, TRUE);
#line 285 "composer-email-entry.c"
}

static void
composer_email_entry_validate_addresses (ComposerEmailEntry* self)
{
	gboolean is_valid = FALSE;
	GearyRFC822MailboxAddresses* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 60 "../src/client/composer/composer-email-entry.vala"
	g_return_if_fail (COMPOSER_IS_EMAIL_ENTRY (self));
#line 61 "../src/client/composer/composer-email-entry.vala"
	_tmp0_ = self->priv->_addresses;
#line 61 "../src/client/composer/composer-email-entry.vala"
	_tmp1_ = geary_rf_c822_mailbox_addresses_get_is_empty (_tmp0_);
#line 61 "../src/client/composer/composer-email-entry.vala"
	_tmp2_ = _tmp1_;
#line 61 "../src/client/composer/composer-email-entry.vala"
	is_valid = !_tmp2_;
#line 305 "composer-email-entry.c"
	{
		GearyRFC822MailboxAddresses* _address_list = NULL;
		GearyRFC822MailboxAddresses* _tmp3_;
		GearyRFC822MailboxAddresses* _tmp4_;
		gint _address_size = 0;
		GearyRFC822MailboxAddresses* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _address_index = 0;
#line 62 "../src/client/composer/composer-email-entry.vala"
		_tmp3_ = composer_email_entry_get_addresses (self);
#line 62 "../src/client/composer/composer-email-entry.vala"
		_tmp4_ = _tmp3_;
#line 62 "../src/client/composer/composer-email-entry.vala"
		_address_list = _tmp4_;
#line 62 "../src/client/composer/composer-email-entry.vala"
		_tmp5_ = _address_list;
#line 62 "../src/client/composer/composer-email-entry.vala"
		_tmp6_ = geary_rf_c822_mailbox_addresses_get_size (_tmp5_);
#line 62 "../src/client/composer/composer-email-entry.vala"
		_tmp7_ = _tmp6_;
#line 62 "../src/client/composer/composer-email-entry.vala"
		_address_size = _tmp7_;
#line 62 "../src/client/composer/composer-email-entry.vala"
		_address_index = -1;
#line 62 "../src/client/composer/composer-email-entry.vala"
		while (TRUE) {
#line 333 "composer-email-entry.c"
			gint _tmp8_;
			gint _tmp9_;
			GearyRFC822MailboxAddress* address = NULL;
			GearyRFC822MailboxAddresses* _tmp10_;
			GearyRFC822MailboxAddress* _tmp11_;
			GearyRFC822MailboxAddress* _tmp12_;
#line 62 "../src/client/composer/composer-email-entry.vala"
			_address_index = _address_index + 1;
#line 62 "../src/client/composer/composer-email-entry.vala"
			_tmp8_ = _address_index;
#line 62 "../src/client/composer/composer-email-entry.vala"
			_tmp9_ = _address_size;
#line 62 "../src/client/composer/composer-email-entry.vala"
			if (!(_tmp8_ < _tmp9_)) {
#line 62 "../src/client/composer/composer-email-entry.vala"
				break;
#line 350 "composer-email-entry.c"
			}
#line 62 "../src/client/composer/composer-email-entry.vala"
			_tmp10_ = _address_list;
#line 62 "../src/client/composer/composer-email-entry.vala"
			_tmp11_ = geary_rf_c822_mailbox_addresses_get (_tmp10_, _address_index);
#line 62 "../src/client/composer/composer-email-entry.vala"
			address = _tmp11_;
#line 63 "../src/client/composer/composer-email-entry.vala"
			_tmp12_ = address;
#line 63 "../src/client/composer/composer-email-entry.vala"
			if (!geary_rf_c822_mailbox_address_is_valid (_tmp12_)) {
#line 64 "../src/client/composer/composer-email-entry.vala"
				is_valid = FALSE;
#line 65 "../src/client/composer/composer-email-entry.vala"
				_g_object_unref0 (address);
#line 65 "../src/client/composer/composer-email-entry.vala"
				return;
#line 368 "composer-email-entry.c"
			}
#line 62 "../src/client/composer/composer-email-entry.vala"
			_g_object_unref0 (address);
#line 372 "composer-email-entry.c"
		}
	}
#line 68 "../src/client/composer/composer-email-entry.vala"
	composer_email_entry_set_is_valid (self, is_valid);
#line 377 "composer-email-entry.c"
}

static void
composer_email_entry_on_changed (ComposerEmailEntry* self)
{
	ContactEntryCompletion* completion = NULL;
	GtkEntryCompletion* _tmp0_;
	ContactEntryCompletion* _tmp1_;
	ContactEntryCompletion* _tmp2_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 71 "../src/client/composer/composer-email-entry.vala"
	g_return_if_fail (COMPOSER_IS_EMAIL_ENTRY (self));
#line 72 "../src/client/composer/composer-email-entry.vala"
	composer_email_entry_set_is_modified (self, TRUE);
#line 74 "../src/client/composer/composer-email-entry.vala"
	_tmp0_ = gtk_entry_get_completion (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_get_type (), GtkEntry));
#line 74 "../src/client/composer/composer-email-entry.vala"
	_tmp1_ = _g_object_ref0 (IS_CONTACT_ENTRY_COMPLETION (_tmp0_) ? ((ContactEntryCompletion*) _tmp0_) : NULL);
#line 74 "../src/client/composer/composer-email-entry.vala"
	completion = _tmp1_;
#line 76 "../src/client/composer/composer-email-entry.vala"
	_tmp2_ = completion;
#line 76 "../src/client/composer/composer-email-entry.vala"
	if (_tmp2_ != NULL) {
#line 404 "composer-email-entry.c"
		ContactEntryCompletion* _tmp3_;
#line 77 "../src/client/composer/composer-email-entry.vala"
		_tmp3_ = completion;
#line 77 "../src/client/composer/composer-email-entry.vala"
		contact_entry_completion_update_model (_tmp3_);
#line 410 "composer-email-entry.c"
	}
#line 80 "../src/client/composer/composer-email-entry.vala"
	_tmp4_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_get_type (), GtkEntry));
#line 80 "../src/client/composer/composer-email-entry.vala"
	_tmp5_ = _tmp4_;
#line 80 "../src/client/composer/composer-email-entry.vala"
	if (geary_string_is_empty_or_whitespace (_tmp5_)) {
#line 418 "composer-email-entry.c"
		GearyRFC822MailboxAddresses* _tmp6_;
#line 81 "../src/client/composer/composer-email-entry.vala"
		_tmp6_ = geary_rf_c822_mailbox_addresses_new (NULL);
#line 81 "../src/client/composer/composer-email-entry.vala"
		_g_object_unref0 (self->priv->_addresses);
#line 81 "../src/client/composer/composer-email-entry.vala"
		self->priv->_addresses = _tmp6_;
#line 82 "../src/client/composer/composer-email-entry.vala"
		composer_email_entry_set_is_valid (self, FALSE);
#line 428 "composer-email-entry.c"
	} else {
		{
			GearyRFC822MailboxAddresses* _tmp7_ = NULL;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			GearyRFC822MailboxAddresses* _tmp10_;
			GearyRFC822MailboxAddresses* _tmp11_;
#line 86 "../src/client/composer/composer-email-entry.vala"
			_tmp8_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_get_type (), GtkEntry));
#line 86 "../src/client/composer/composer-email-entry.vala"
			_tmp9_ = _tmp8_;
#line 86 "../src/client/composer/composer-email-entry.vala"
			_tmp10_ = geary_rf_c822_mailbox_addresses_new_from_rfc822_string (_tmp9_, &_inner_error0_);
#line 86 "../src/client/composer/composer-email-entry.vala"
			_tmp7_ = _tmp10_;
#line 86 "../src/client/composer/composer-email-entry.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 86 "../src/client/composer/composer-email-entry.vala"
				if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 448 "composer-email-entry.c"
					goto __catch0_geary_rf_c822_error;
				}
#line 86 "../src/client/composer/composer-email-entry.vala"
				_g_object_unref0 (completion);
#line 86 "../src/client/composer/composer-email-entry.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 86 "../src/client/composer/composer-email-entry.vala"
				g_clear_error (&_inner_error0_);
#line 86 "../src/client/composer/composer-email-entry.vala"
				return;
#line 459 "composer-email-entry.c"
			}
#line 85 "../src/client/composer/composer-email-entry.vala"
			_tmp11_ = _tmp7_;
#line 85 "../src/client/composer/composer-email-entry.vala"
			_tmp7_ = NULL;
#line 85 "../src/client/composer/composer-email-entry.vala"
			_g_object_unref0 (self->priv->_addresses);
#line 85 "../src/client/composer/composer-email-entry.vala"
			self->priv->_addresses = _tmp11_;
#line 87 "../src/client/composer/composer-email-entry.vala"
			composer_email_entry_set_is_valid (self, TRUE);
#line 84 "../src/client/composer/composer-email-entry.vala"
			_g_object_unref0 (_tmp7_);
#line 473 "composer-email-entry.c"
		}
		goto __finally0;
		__catch0_geary_rf_c822_error:
		{
			GearyRFC822MailboxAddresses* _tmp12_;
#line 84 "../src/client/composer/composer-email-entry.vala"
			g_clear_error (&_inner_error0_);
#line 89 "../src/client/composer/composer-email-entry.vala"
			_tmp12_ = geary_rf_c822_mailbox_addresses_new (NULL);
#line 89 "../src/client/composer/composer-email-entry.vala"
			_g_object_unref0 (self->priv->_addresses);
#line 89 "../src/client/composer/composer-email-entry.vala"
			self->priv->_addresses = _tmp12_;
#line 90 "../src/client/composer/composer-email-entry.vala"
			composer_email_entry_set_is_valid (self, FALSE);
#line 489 "composer-email-entry.c"
		}
		__finally0:
#line 84 "../src/client/composer/composer-email-entry.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 84 "../src/client/composer/composer-email-entry.vala"
			_g_object_unref0 (completion);
#line 84 "../src/client/composer/composer-email-entry.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 84 "../src/client/composer/composer-email-entry.vala"
			g_clear_error (&_inner_error0_);
#line 84 "../src/client/composer/composer-email-entry.vala"
			return;
#line 502 "composer-email-entry.c"
		}
	}
#line 71 "../src/client/composer/composer-email-entry.vala"
	_g_object_unref0 (completion);
#line 507 "composer-email-entry.c"
}

static gboolean
composer_email_entry_on_key_press (ComposerEmailEntry* self,
                                   GtkWidget* widget,
                                   GdkEventKey* event)
{
	gboolean propagate = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean result;
#line 95 "../src/client/composer/composer-email-entry.vala"
	g_return_val_if_fail (COMPOSER_IS_EMAIL_ENTRY (self), FALSE);
#line 95 "../src/client/composer/composer-email-entry.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_widget_get_type ()), FALSE);
#line 95 "../src/client/composer/composer-email-entry.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 96 "../src/client/composer/composer-email-entry.vala"
	propagate = GDK_EVENT_PROPAGATE;
#line 97 "../src/client/composer/composer-email-entry.vala"
	if (event->keyval == GDK_KEY_Tab) {
#line 528 "composer-email-entry.c"
		ContactEntryCompletion* completion = NULL;
		GtkEntryCompletion* _tmp0_;
		ContactEntryCompletion* _tmp1_;
		ContactEntryCompletion* _tmp2_;
#line 99 "../src/client/composer/composer-email-entry.vala"
		_tmp0_ = gtk_entry_get_completion (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_get_type (), GtkEntry));
#line 99 "../src/client/composer/composer-email-entry.vala"
		_tmp1_ = _g_object_ref0 (IS_CONTACT_ENTRY_COMPLETION (_tmp0_) ? ((ContactEntryCompletion*) _tmp0_) : NULL);
#line 99 "../src/client/composer/composer-email-entry.vala"
		completion = _tmp1_;
#line 102 "../src/client/composer/composer-email-entry.vala"
		_tmp2_ = completion;
#line 102 "../src/client/composer/composer-email-entry.vala"
		if (_tmp2_ != NULL) {
#line 543 "composer-email-entry.c"
			ContactEntryCompletion* _tmp3_;
			ComposerWidget* _tmp4_;
#line 103 "../src/client/composer/composer-email-entry.vala"
			_tmp3_ = completion;
#line 103 "../src/client/composer/composer-email-entry.vala"
			contact_entry_completion_trigger_selection (_tmp3_);
#line 104 "../src/client/composer/composer-email-entry.vala"
			_tmp4_ = self->priv->composer;
#line 104 "../src/client/composer/composer-email-entry.vala"
			gtk_widget_child_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget), GTK_DIR_TAB_FORWARD);
#line 105 "../src/client/composer/composer-email-entry.vala"
			propagate = GDK_EVENT_STOP;
#line 556 "composer-email-entry.c"
		}
#line 97 "../src/client/composer/composer-email-entry.vala"
		_g_object_unref0 (completion);
#line 560 "composer-email-entry.c"
	}
#line 109 "../src/client/composer/composer-email-entry.vala"
	if (propagate == GDK_EVENT_PROPAGATE) {
#line 110 "../src/client/composer/composer-email-entry.vala"
		_tmp5_ = event->keyval != GDK_KEY_Escape;
#line 566 "composer-email-entry.c"
	} else {
#line 109 "../src/client/composer/composer-email-entry.vala"
		_tmp5_ = FALSE;
#line 570 "composer-email-entry.c"
	}
#line 109 "../src/client/composer/composer-email-entry.vala"
	if (_tmp5_) {
#line 574 "composer-email-entry.c"
		GtkWindow* window = NULL;
		GtkWidget* _tmp6_;
		GtkWindow* _tmp7_;
		GtkWindow* _tmp8_;
#line 118 "../src/client/composer/composer-email-entry.vala"
		_tmp6_ = gtk_widget_get_toplevel (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 118 "../src/client/composer/composer-email-entry.vala"
		_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp6_) : NULL);
#line 118 "../src/client/composer/composer-email-entry.vala"
		window = _tmp7_;
#line 119 "../src/client/composer/composer-email-entry.vala"
		_tmp8_ = window;
#line 119 "../src/client/composer/composer-email-entry.vala"
		if (_tmp8_ != NULL) {
#line 589 "composer-email-entry.c"
			GtkWindow* _tmp9_;
#line 120 "../src/client/composer/composer-email-entry.vala"
			_tmp9_ = window;
#line 120 "../src/client/composer/composer-email-entry.vala"
			propagate = gtk_window_activate_key (_tmp9_, event);
#line 595 "composer-email-entry.c"
		}
#line 109 "../src/client/composer/composer-email-entry.vala"
		_g_object_unref0 (window);
#line 599 "composer-email-entry.c"
	}
#line 123 "../src/client/composer/composer-email-entry.vala"
	result = propagate;
#line 123 "../src/client/composer/composer-email-entry.vala"
	return result;
#line 605 "composer-email-entry.c"
}

static void
composer_email_entry_class_init (ComposerEmailEntryClass * klass,
                                 gpointer klass_data)
{
#line 12 "../src/client/composer/composer-email-entry.vala"
	composer_email_entry_parent_class = g_type_class_peek_parent (klass);
#line 12 "../src/client/composer/composer-email-entry.vala"
	g_type_class_adjust_private_offset (klass, &ComposerEmailEntry_private_offset);
#line 12 "../src/client/composer/composer-email-entry.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_composer_email_entry_get_property;
#line 12 "../src/client/composer/composer-email-entry.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_composer_email_entry_set_property;
#line 12 "../src/client/composer/composer-email-entry.vala"
	G_OBJECT_CLASS (klass)->finalize = composer_email_entry_finalize;
#line 622 "composer-email-entry.c"
	/** The entry's list of possibly valid email addresses. */
#line 12 "../src/client/composer/composer-email-entry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), COMPOSER_EMAIL_ENTRY_ADDRESSES_PROPERTY, composer_email_entry_properties[COMPOSER_EMAIL_ENTRY_ADDRESSES_PROPERTY] = g_param_spec_object ("addresses", "addresses", "addresses", GEARY_RF_C822_TYPE_MAILBOX_ADDRESSES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 626 "composer-email-entry.c"
	/** Determines if the entry contains only valid email addresses. */
#line 12 "../src/client/composer/composer-email-entry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), COMPOSER_EMAIL_ENTRY_IS_VALID_PROPERTY, composer_email_entry_properties[COMPOSER_EMAIL_ENTRY_IS_VALID_PROPERTY] = g_param_spec_boolean ("is-valid", "is-valid", "is-valid", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 630 "composer-email-entry.c"
	/** Determines if the entry contains any email addresses. */
#line 12 "../src/client/composer/composer-email-entry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), COMPOSER_EMAIL_ENTRY_IS_EMPTY_PROPERTY, composer_email_entry_properties[COMPOSER_EMAIL_ENTRY_IS_EMPTY_PROPERTY] = g_param_spec_boolean ("is-empty", "is-empty", "is-empty", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 634 "composer-email-entry.c"
	/**
	     * Determines if the entry has been modified.
	     *
	     * The entry is considered to be modified only if the text has
	     * been changed after it as been constructed or if modified after
	     * setting {@link addresses}.
	     */
#line 12 "../src/client/composer/composer-email-entry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), COMPOSER_EMAIL_ENTRY_IS_MODIFIED_PROPERTY, composer_email_entry_properties[COMPOSER_EMAIL_ENTRY_IS_MODIFIED_PROPERTY] = g_param_spec_boolean ("is-modified", "is-modified", "is-modified", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 644 "composer-email-entry.c"
}

static void
composer_email_entry_instance_init (ComposerEmailEntry * self,
                                    gpointer klass)
{
	GearyRFC822MailboxAddresses* _tmp0_;
#line 12 "../src/client/composer/composer-email-entry.vala"
	self->priv = composer_email_entry_get_instance_private (self);
#line 24 "../src/client/composer/composer-email-entry.vala"
	_tmp0_ = geary_rf_c822_mailbox_addresses_new (NULL);
#line 24 "../src/client/composer/composer-email-entry.vala"
	self->priv->_addresses = _tmp0_;
#line 27 "../src/client/composer/composer-email-entry.vala"
	self->priv->_is_valid = FALSE;
#line 43 "../src/client/composer/composer-email-entry.vala"
	self->priv->_is_modified = FALSE;
#line 662 "composer-email-entry.c"
}

static void
composer_email_entry_finalize (GObject * obj)
{
	ComposerEmailEntry * self;
#line 12 "../src/client/composer/composer-email-entry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, COMPOSER_TYPE_EMAIL_ENTRY, ComposerEmailEntry);
#line 24 "../src/client/composer/composer-email-entry.vala"
	_g_object_unref0 (self->priv->_addresses);
#line 12 "../src/client/composer/composer-email-entry.vala"
	G_OBJECT_CLASS (composer_email_entry_parent_class)->finalize (obj);
#line 675 "composer-email-entry.c"
}

/**
 * A GTK entry for entering email addresses.
 */
static GType
composer_email_entry_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ComposerEmailEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) composer_email_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ComposerEmailEntry), 0, (GInstanceInitFunc) composer_email_entry_instance_init, NULL };
	GType composer_email_entry_type_id;
	composer_email_entry_type_id = g_type_register_static (gtk_entry_get_type (), "ComposerEmailEntry", &g_define_type_info, 0);
	ComposerEmailEntry_private_offset = g_type_add_instance_private (composer_email_entry_type_id, sizeof (ComposerEmailEntryPrivate));
	return composer_email_entry_type_id;
}

GType
composer_email_entry_get_type (void)
{
	static volatile gsize composer_email_entry_type_id__once = 0;
	if (g_once_init_enter (&composer_email_entry_type_id__once)) {
		GType composer_email_entry_type_id;
		composer_email_entry_type_id = composer_email_entry_get_type_once ();
		g_once_init_leave (&composer_email_entry_type_id__once, composer_email_entry_type_id);
	}
	return composer_email_entry_type_id__once;
}

static void
_vala_composer_email_entry_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	ComposerEmailEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, COMPOSER_TYPE_EMAIL_ENTRY, ComposerEmailEntry);
#line 12 "../src/client/composer/composer-email-entry.vala"
	switch (property_id) {
#line 12 "../src/client/composer/composer-email-entry.vala"
		case COMPOSER_EMAIL_ENTRY_ADDRESSES_PROPERTY:
#line 12 "../src/client/composer/composer-email-entry.vala"
		g_value_set_object (value, composer_email_entry_get_addresses (self));
#line 12 "../src/client/composer/composer-email-entry.vala"
		break;
#line 12 "../src/client/composer/composer-email-entry.vala"
		case COMPOSER_EMAIL_ENTRY_IS_VALID_PROPERTY:
#line 12 "../src/client/composer/composer-email-entry.vala"
		g_value_set_boolean (value, composer_email_entry_get_is_valid (self));
#line 12 "../src/client/composer/composer-email-entry.vala"
		break;
#line 12 "../src/client/composer/composer-email-entry.vala"
		case COMPOSER_EMAIL_ENTRY_IS_EMPTY_PROPERTY:
#line 12 "../src/client/composer/composer-email-entry.vala"
		g_value_set_boolean (value, composer_email_entry_get_is_empty (self));
#line 12 "../src/client/composer/composer-email-entry.vala"
		break;
#line 12 "../src/client/composer/composer-email-entry.vala"
		case COMPOSER_EMAIL_ENTRY_IS_MODIFIED_PROPERTY:
#line 12 "../src/client/composer/composer-email-entry.vala"
		g_value_set_boolean (value, composer_email_entry_get_is_modified (self));
#line 12 "../src/client/composer/composer-email-entry.vala"
		break;
#line 737 "composer-email-entry.c"
		default:
#line 12 "../src/client/composer/composer-email-entry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "../src/client/composer/composer-email-entry.vala"
		break;
#line 743 "composer-email-entry.c"
	}
}

static void
_vala_composer_email_entry_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	ComposerEmailEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, COMPOSER_TYPE_EMAIL_ENTRY, ComposerEmailEntry);
#line 12 "../src/client/composer/composer-email-entry.vala"
	switch (property_id) {
#line 12 "../src/client/composer/composer-email-entry.vala"
		case COMPOSER_EMAIL_ENTRY_ADDRESSES_PROPERTY:
#line 12 "../src/client/composer/composer-email-entry.vala"
		composer_email_entry_set_addresses (self, g_value_get_object (value));
#line 12 "../src/client/composer/composer-email-entry.vala"
		break;
#line 12 "../src/client/composer/composer-email-entry.vala"
		case COMPOSER_EMAIL_ENTRY_IS_VALID_PROPERTY:
#line 12 "../src/client/composer/composer-email-entry.vala"
		composer_email_entry_set_is_valid (self, g_value_get_boolean (value));
#line 12 "../src/client/composer/composer-email-entry.vala"
		break;
#line 12 "../src/client/composer/composer-email-entry.vala"
		case COMPOSER_EMAIL_ENTRY_IS_MODIFIED_PROPERTY:
#line 12 "../src/client/composer/composer-email-entry.vala"
		composer_email_entry_set_is_modified (self, g_value_get_boolean (value));
#line 12 "../src/client/composer/composer-email-entry.vala"
		break;
#line 775 "composer-email-entry.c"
		default:
#line 12 "../src/client/composer/composer-email-entry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "../src/client/composer/composer-email-entry.vala"
		break;
#line 781 "composer-email-entry.c"
	}
}

