/* composer-embed.c generated by valac 0.56.17, the Vala compiler
 * generated from composer-embed.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2019 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-client-46.0.h"
#include "geary-engine.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <cairo-gobject.h>

#define COMPOSER_EMBED_MIN_EDITOR_HEIGHT 200
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	COMPOSER_EMBED_0_PROPERTY,
	COMPOSER_EMBED_REFERRED_PROPERTY,
	COMPOSER_EMBED_NUM_PROPERTIES
};
static GParamSpec* composer_embed_properties[COMPOSER_EMBED_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	COMPOSER_EMBED_VANISHED_SIGNAL,
	COMPOSER_EMBED_NUM_SIGNALS
};
static guint composer_embed_signals[COMPOSER_EMBED_NUM_SIGNALS] = {0};

struct _ComposerEmbedPrivate {
	GearyEmail* _referred;
	ComposerWidget* _composer;
	GtkScrolledWindow* outer_scroller;
};

static gint ComposerEmbed_private_offset;
static gpointer composer_embed_parent_class = NULL;
static ComposerContainerIface * composer_embed_composer_container_parent_iface = NULL;

static void composer_embed_set_referred (ComposerEmbed* self,
                                  GearyEmail* value);
VALA_EXTERN void composer_container_set_composer (ComposerContainer* self,
                                      ComposerWidget* value);
VALA_EXTERN ComposerWidget* composer_container_get_composer (ComposerContainer* self);
VALA_EXTERN void composer_widget_embed_header (ComposerWidget* self);
VALA_EXTERN gboolean composer_widget_get_has_multiple_from_addresses (ComposerWidget* self);
VALA_EXTERN void composer_widget_set_mode (ComposerWidget* self,
                               ComposerWidgetPresentationMode new_mode);
static void composer_embed_on_realize (ComposerEmbed* self);
static void _composer_embed_on_realize_gtk_widget_realize (GtkWidget* _sender,
                                                    gpointer self);
static void composer_embed_real_close (ComposerContainer* base);
static void composer_embed_disable_scroll_reroute (ComposerEmbed* self,
                                            GtkWidget* widget);
VALA_EXTERN void composer_widget_free_header (ComposerWidget* self);
static void composer_embed_reroute_scroll_handling (ComposerEmbed* self,
                                             GtkWidget* widget);
static gboolean composer_embed_on_inner_scroll_event (ComposerEmbed* self,
                                               GdkEventScroll* event);
static gboolean _composer_embed_on_inner_scroll_event_gtk_widget_scroll_event (GtkWidget* _sender,
                                                                        GdkEventScroll* event,
                                                                        gpointer self);
static void composer_embed_finalize (GObject * obj);
static GType composer_embed_get_type_once (void);
static void _vala_composer_embed_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_composer_embed_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);

static inline gpointer
composer_embed_get_instance_private (ComposerEmbed* self)
{
	return G_STRUCT_MEMBER_P (self, ComposerEmbed_private_offset);
}

static GtkApplicationWindow*
composer_embed_real_get_top_window (ComposerContainer* base)
{
	GtkApplicationWindow* result;
	ComposerEmbed* self;
	GtkWidget* _tmp0_;
#line 28 "../src/client/composer/composer-embed.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, COMPOSER_TYPE_EMBED, ComposerEmbed);
#line 28 "../src/client/composer/composer-embed.vala"
	_tmp0_ = gtk_widget_get_toplevel (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 28 "../src/client/composer/composer-embed.vala"
	result = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_application_window_get_type ()) ? ((GtkApplicationWindow*) _tmp0_) : NULL;
#line 28 "../src/client/composer/composer-embed.vala"
	return result;
#line 110 "composer-embed.c"
}

GearyEmail*
composer_embed_get_referred (ComposerEmbed* self)
{
	GearyEmail* result;
	GearyEmail* _tmp0_;
#line 32 "../src/client/composer/composer-embed.vala"
	g_return_val_if_fail (COMPOSER_IS_EMBED (self), NULL);
#line 32 "../src/client/composer/composer-embed.vala"
	_tmp0_ = self->priv->_referred;
#line 32 "../src/client/composer/composer-embed.vala"
	result = _tmp0_;
#line 32 "../src/client/composer/composer-embed.vala"
	return result;
#line 126 "composer-embed.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 32 "../src/client/composer/composer-embed.vala"
	return self ? g_object_ref (self) : NULL;
#line 134 "composer-embed.c"
}

static void
composer_embed_set_referred (ComposerEmbed* self,
                             GearyEmail* value)
{
	GearyEmail* old_value;
#line 32 "../src/client/composer/composer-embed.vala"
	g_return_if_fail (COMPOSER_IS_EMBED (self));
#line 32 "../src/client/composer/composer-embed.vala"
	old_value = composer_embed_get_referred (self);
#line 32 "../src/client/composer/composer-embed.vala"
	if (old_value != value) {
#line 148 "composer-embed.c"
		GearyEmail* _tmp0_;
#line 32 "../src/client/composer/composer-embed.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 32 "../src/client/composer/composer-embed.vala"
		_g_object_unref0 (self->priv->_referred);
#line 32 "../src/client/composer/composer-embed.vala"
		self->priv->_referred = _tmp0_;
#line 32 "../src/client/composer/composer-embed.vala"
		g_object_notify_by_pspec ((GObject *) self, composer_embed_properties[COMPOSER_EMBED_REFERRED_PROPERTY]);
#line 158 "composer-embed.c"
	}
}

static ComposerWidget*
composer_embed_real_get_composer (ComposerContainer* base)
{
	ComposerWidget* result;
	ComposerEmbed* self;
	ComposerWidget* _tmp0_;
#line 35 "../src/client/composer/composer-embed.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, COMPOSER_TYPE_EMBED, ComposerEmbed);
#line 35 "../src/client/composer/composer-embed.vala"
	_tmp0_ = self->priv->_composer;
#line 35 "../src/client/composer/composer-embed.vala"
	result = _tmp0_;
#line 35 "../src/client/composer/composer-embed.vala"
	return result;
#line 176 "composer-embed.c"
}

static void
composer_embed_real_set_composer (ComposerContainer* base,
                                  ComposerWidget* value)
{
	ComposerEmbed* self;
	ComposerWidget* _tmp0_;
#line 35 "../src/client/composer/composer-embed.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, COMPOSER_TYPE_EMBED, ComposerEmbed);
#line 35 "../src/client/composer/composer-embed.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 35 "../src/client/composer/composer-embed.vala"
	_g_object_unref0 (self->priv->_composer);
#line 35 "../src/client/composer/composer-embed.vala"
	self->priv->_composer = _tmp0_;
#line 193 "composer-embed.c"
}

static void
_composer_embed_on_realize_gtk_widget_realize (GtkWidget* _sender,
                                               gpointer self)
{
#line 66 "../src/client/composer/composer-embed.vala"
	composer_embed_on_realize ((ComposerEmbed*) self);
#line 202 "composer-embed.c"
}

ComposerEmbed*
composer_embed_construct (GType object_type,
                          GearyEmail* referred,
                          ComposerWidget* composer,
                          GtkScrolledWindow* outer_scroller)
{
	ComposerEmbed * self = NULL;
	ComposerWidget* _tmp0_;
	ComposerWidget* _tmp1_;
	ComposerWidgetPresentationMode mode = 0;
	gboolean _tmp2_ = FALSE;
	ComposerWidgetContextType _tmp3_;
	ComposerWidgetContextType _tmp4_;
	GtkScrolledWindow* _tmp7_;
	GtkStyleContext* _tmp8_;
#line 44 "../src/client/composer/composer-embed.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (referred, GEARY_TYPE_EMAIL), NULL);
#line 44 "../src/client/composer/composer-embed.vala"
	g_return_val_if_fail (COMPOSER_IS_WIDGET (composer), NULL);
#line 44 "../src/client/composer/composer-embed.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (outer_scroller, gtk_scrolled_window_get_type ()), NULL);
#line 44 "../src/client/composer/composer-embed.vala"
	self = (ComposerEmbed*) g_object_new (object_type, NULL);
#line 47 "../src/client/composer/composer-embed.vala"
	composer_embed_set_referred (self, referred);
#line 48 "../src/client/composer/composer-embed.vala"
	composer_container_set_composer (G_TYPE_CHECK_INSTANCE_CAST (self, COMPOSER_TYPE_CONTAINER, ComposerContainer), composer);
#line 49 "../src/client/composer/composer-embed.vala"
	_tmp0_ = composer_container_get_composer (G_TYPE_CHECK_INSTANCE_CAST (self, COMPOSER_TYPE_CONTAINER, ComposerContainer));
#line 49 "../src/client/composer/composer-embed.vala"
	_tmp1_ = _tmp0_;
#line 49 "../src/client/composer/composer-embed.vala"
	composer_widget_embed_header (_tmp1_);
#line 51 "../src/client/composer/composer-embed.vala"
	mode = COMPOSER_WIDGET_PRESENTATION_MODE_INLINE_COMPACT;
#line 52 "../src/client/composer/composer-embed.vala"
	_tmp3_ = composer_widget_get_context_type (composer);
#line 52 "../src/client/composer/composer-embed.vala"
	_tmp4_ = _tmp3_;
#line 52 "../src/client/composer/composer-embed.vala"
	if (_tmp4_ == COMPOSER_WIDGET_CONTEXT_TYPE_FORWARD) {
#line 52 "../src/client/composer/composer-embed.vala"
		_tmp2_ = TRUE;
#line 248 "composer-embed.c"
	} else {
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 53 "../src/client/composer/composer-embed.vala"
		_tmp5_ = composer_widget_get_has_multiple_from_addresses (composer);
#line 53 "../src/client/composer/composer-embed.vala"
		_tmp6_ = _tmp5_;
#line 53 "../src/client/composer/composer-embed.vala"
		_tmp2_ = _tmp6_;
#line 258 "composer-embed.c"
	}
#line 52 "../src/client/composer/composer-embed.vala"
	if (_tmp2_) {
#line 54 "../src/client/composer/composer-embed.vala"
		mode = COMPOSER_WIDGET_PRESENTATION_MODE_INLINE;
#line 264 "composer-embed.c"
	}
#line 56 "../src/client/composer/composer-embed.vala"
	composer_widget_set_mode (composer, mode);
#line 58 "../src/client/composer/composer-embed.vala"
	_tmp7_ = _g_object_ref0 (outer_scroller);
#line 58 "../src/client/composer/composer-embed.vala"
	_g_object_unref0 (self->priv->outer_scroller);
#line 58 "../src/client/composer/composer-embed.vala"
	self->priv->outer_scroller = _tmp7_;
#line 60 "../src/client/composer/composer-embed.vala"
	_tmp8_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 60 "../src/client/composer/composer-embed.vala"
	gtk_style_context_add_class (_tmp8_, "geary-composer-embed");
#line 61 "../src/client/composer/composer-embed.vala"
	gtk_widget_set_halign (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_FILL);
#line 62 "../src/client/composer/composer-embed.vala"
	gtk_widget_set_vexpand (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), TRUE);
#line 63 "../src/client/composer/composer-embed.vala"
	gtk_widget_set_vexpand_set (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), TRUE);
#line 65 "../src/client/composer/composer-embed.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (composer, gtk_widget_get_type (), GtkWidget));
#line 66 "../src/client/composer/composer-embed.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "realize", (GCallback) _composer_embed_on_realize_gtk_widget_realize, self, 0);
#line 67 "../src/client/composer/composer-embed.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 44 "../src/client/composer/composer-embed.vala"
	return self;
#line 292 "composer-embed.c"
}

ComposerEmbed*
composer_embed_new (GearyEmail* referred,
                    ComposerWidget* composer,
                    GtkScrolledWindow* outer_scroller)
{
#line 44 "../src/client/composer/composer-embed.vala"
	return composer_embed_construct (COMPOSER_TYPE_EMBED, referred, composer, outer_scroller);
#line 302 "composer-embed.c"
}

/** {@inheritDoc} */
static void
composer_embed_real_close (ComposerContainer* base)
{
	ComposerEmbed * self;
	ComposerWidget* _tmp0_;
	ComposerWidget* _tmp1_;
	ComposerWidget* _tmp2_;
	ComposerWidget* _tmp3_;
#line 71 "../src/client/composer/composer-embed.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, COMPOSER_TYPE_EMBED, ComposerEmbed);
#line 72 "../src/client/composer/composer-embed.vala"
	composer_embed_disable_scroll_reroute (self, G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 73 "../src/client/composer/composer-embed.vala"
	g_signal_emit (self, composer_embed_signals[COMPOSER_EMBED_VANISHED_SIGNAL], 0);
#line 75 "../src/client/composer/composer-embed.vala"
	_tmp0_ = composer_container_get_composer (G_TYPE_CHECK_INSTANCE_CAST (self, COMPOSER_TYPE_CONTAINER, ComposerContainer));
#line 75 "../src/client/composer/composer-embed.vala"
	_tmp1_ = _tmp0_;
#line 75 "../src/client/composer/composer-embed.vala"
	composer_widget_free_header (_tmp1_);
#line 76 "../src/client/composer/composer-embed.vala"
	_tmp2_ = composer_container_get_composer (G_TYPE_CHECK_INSTANCE_CAST (self, COMPOSER_TYPE_CONTAINER, ComposerContainer));
#line 76 "../src/client/composer/composer-embed.vala"
	_tmp3_ = _tmp2_;
#line 76 "../src/client/composer/composer-embed.vala"
	gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget));
#line 77 "../src/client/composer/composer-embed.vala"
	gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 334 "composer-embed.c"
}

static void
composer_embed_on_realize (ComposerEmbed* self)
{
#line 80 "../src/client/composer/composer-embed.vala"
	g_return_if_fail (COMPOSER_IS_EMBED (self));
#line 81 "../src/client/composer/composer-embed.vala"
	composer_embed_reroute_scroll_handling (self, G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 344 "composer-embed.c"
}

static gboolean
_composer_embed_on_inner_scroll_event_gtk_widget_scroll_event (GtkWidget* _sender,
                                                               GdkEventScroll* event,
                                                               gpointer self)
{
	gboolean result;
	result = composer_embed_on_inner_scroll_event ((ComposerEmbed*) self, event);
#line 86 "../src/client/composer/composer-embed.vala"
	return result;
#line 356 "composer-embed.c"
}

static void
composer_embed_reroute_scroll_handling (ComposerEmbed* self,
                                        GtkWidget* widget)
{
	GtkContainer* container = NULL;
	GtkContainer* _tmp0_;
	GtkContainer* _tmp1_;
#line 84 "../src/client/composer/composer-embed.vala"
	g_return_if_fail (COMPOSER_IS_EMBED (self));
#line 84 "../src/client/composer/composer-embed.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_widget_get_type ()));
#line 85 "../src/client/composer/composer-embed.vala"
	gtk_widget_add_events (widget, (gint) (GDK_SCROLL_MASK | GDK_SMOOTH_SCROLL_MASK));
#line 86 "../src/client/composer/composer-embed.vala"
	g_signal_connect_object (widget, "scroll-event", (GCallback) _composer_embed_on_inner_scroll_event_gtk_widget_scroll_event, self, 0);
#line 87 "../src/client/composer/composer-embed.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_container_get_type ()) ? ((GtkContainer*) widget) : NULL);
#line 87 "../src/client/composer/composer-embed.vala"
	container = _tmp0_;
#line 88 "../src/client/composer/composer-embed.vala"
	_tmp1_ = container;
#line 88 "../src/client/composer/composer-embed.vala"
	if (_tmp1_ != NULL) {
#line 382 "composer-embed.c"
		GtkContainer* _tmp2_;
		GList* _tmp3_;
#line 89 "../src/client/composer/composer-embed.vala"
		_tmp2_ = container;
#line 89 "../src/client/composer/composer-embed.vala"
		_tmp3_ = gtk_container_get_children (_tmp2_);
#line 389 "composer-embed.c"
		{
			GList* child_collection = NULL;
			GList* child_it = NULL;
#line 89 "../src/client/composer/composer-embed.vala"
			child_collection = _tmp3_;
#line 89 "../src/client/composer/composer-embed.vala"
			for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 397 "composer-embed.c"
				GtkWidget* _tmp4_;
				GtkWidget* child = NULL;
#line 89 "../src/client/composer/composer-embed.vala"
				_tmp4_ = _g_object_ref0 ((GtkWidget*) child_it->data);
#line 89 "../src/client/composer/composer-embed.vala"
				child = _tmp4_;
#line 404 "composer-embed.c"
				{
					GtkWidget* _tmp5_;
#line 90 "../src/client/composer/composer-embed.vala"
					_tmp5_ = child;
#line 90 "../src/client/composer/composer-embed.vala"
					composer_embed_reroute_scroll_handling (self, _tmp5_);
#line 89 "../src/client/composer/composer-embed.vala"
					_g_object_unref0 (child);
#line 413 "composer-embed.c"
				}
			}
#line 89 "../src/client/composer/composer-embed.vala"
			(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 418 "composer-embed.c"
		}
	}
#line 84 "../src/client/composer/composer-embed.vala"
	_g_object_unref0 (container);
#line 423 "composer-embed.c"
}

static void
composer_embed_disable_scroll_reroute (ComposerEmbed* self,
                                       GtkWidget* widget)
{
	guint _tmp0_;
	GtkContainer* container = NULL;
	GtkContainer* _tmp1_;
	GtkContainer* _tmp2_;
#line 94 "../src/client/composer/composer-embed.vala"
	g_return_if_fail (COMPOSER_IS_EMBED (self));
#line 94 "../src/client/composer/composer-embed.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_widget_get_type ()));
#line 95 "../src/client/composer/composer-embed.vala"
	g_signal_parse_name ("scroll-event", gtk_widget_get_type (), &_tmp0_, NULL, FALSE);
#line 95 "../src/client/composer/composer-embed.vala"
	g_signal_handlers_disconnect_matched (widget, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _composer_embed_on_inner_scroll_event_gtk_widget_scroll_event, self);
#line 96 "../src/client/composer/composer-embed.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_container_get_type ()) ? ((GtkContainer*) widget) : NULL);
#line 96 "../src/client/composer/composer-embed.vala"
	container = _tmp1_;
#line 97 "../src/client/composer/composer-embed.vala"
	_tmp2_ = container;
#line 97 "../src/client/composer/composer-embed.vala"
	if (_tmp2_ != NULL) {
#line 450 "composer-embed.c"
		GtkContainer* _tmp3_;
		GList* _tmp4_;
#line 98 "../src/client/composer/composer-embed.vala"
		_tmp3_ = container;
#line 98 "../src/client/composer/composer-embed.vala"
		_tmp4_ = gtk_container_get_children (_tmp3_);
#line 457 "composer-embed.c"
		{
			GList* child_collection = NULL;
			GList* child_it = NULL;
#line 98 "../src/client/composer/composer-embed.vala"
			child_collection = _tmp4_;
#line 98 "../src/client/composer/composer-embed.vala"
			for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 465 "composer-embed.c"
				GtkWidget* _tmp5_;
				GtkWidget* child = NULL;
#line 98 "../src/client/composer/composer-embed.vala"
				_tmp5_ = _g_object_ref0 ((GtkWidget*) child_it->data);
#line 98 "../src/client/composer/composer-embed.vala"
				child = _tmp5_;
#line 472 "composer-embed.c"
				{
					GtkWidget* _tmp6_;
#line 99 "../src/client/composer/composer-embed.vala"
					_tmp6_ = child;
#line 99 "../src/client/composer/composer-embed.vala"
					composer_embed_disable_scroll_reroute (self, _tmp6_);
#line 98 "../src/client/composer/composer-embed.vala"
					_g_object_unref0 (child);
#line 481 "composer-embed.c"
				}
			}
#line 98 "../src/client/composer/composer-embed.vala"
			(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 486 "composer-embed.c"
		}
	}
#line 94 "../src/client/composer/composer-embed.vala"
	_g_object_unref0 (container);
#line 491 "composer-embed.c"
}

static gboolean
composer_embed_on_inner_scroll_event (ComposerEmbed* self,
                                      GdkEventScroll* event)
{
	gboolean ret = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 111 "../src/client/composer/composer-embed.vala"
	g_return_val_if_fail (COMPOSER_IS_EMBED (self), FALSE);
#line 111 "../src/client/composer/composer-embed.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 125 "../src/client/composer/composer-embed.vala"
	ret = GDK_EVENT_STOP;
#line 126 "../src/client/composer/composer-embed.vala"
	if (event->direction == GDK_SCROLL_SMOOTH) {
#line 127 "../src/client/composer/composer-embed.vala"
		_tmp0_ = event->delta_y != 0.0;
#line 511 "composer-embed.c"
	} else {
#line 126 "../src/client/composer/composer-embed.vala"
		_tmp0_ = FALSE;
#line 515 "composer-embed.c"
	}
#line 126 "../src/client/composer/composer-embed.vala"
	if (_tmp0_) {
#line 519 "composer-embed.c"
		GtkAdjustment* adj = NULL;
		GtkScrolledWindow* _tmp1_;
		GtkAdjustment* _tmp2_;
		GtkAdjustment* _tmp3_;
		GtkAdjustment* _tmp4_;
		GtkAllocation alloc = {0};
		GtkAllocation _tmp5_ = {0};
		gdouble scroll_unit = 0.0;
		GtkAdjustment* _tmp6_;
		gdouble _tmp7_;
		gdouble _tmp8_;
		gdouble scroll_delta = 0.0;
		gdouble initial_value = 0.0;
		GtkAdjustment* _tmp9_;
		gdouble _tmp10_;
		gdouble _tmp11_;
#line 129 "../src/client/composer/composer-embed.vala"
		_tmp1_ = self->priv->outer_scroller;
#line 129 "../src/client/composer/composer-embed.vala"
		_tmp2_ = gtk_scrolled_window_get_vadjustment (_tmp1_);
#line 129 "../src/client/composer/composer-embed.vala"
		_tmp3_ = _tmp2_;
#line 129 "../src/client/composer/composer-embed.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 129 "../src/client/composer/composer-embed.vala"
		adj = _tmp4_;
#line 131 "../src/client/composer/composer-embed.vala"
		gtk_widget_get_allocation (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), &_tmp5_);
#line 131 "../src/client/composer/composer-embed.vala"
		alloc = _tmp5_;
#line 135 "../src/client/composer/composer-embed.vala"
		_tmp6_ = adj;
#line 135 "../src/client/composer/composer-embed.vala"
		_tmp7_ = gtk_adjustment_get_page_size (_tmp6_);
#line 135 "../src/client/composer/composer-embed.vala"
		_tmp8_ = _tmp7_;
#line 135 "../src/client/composer/composer-embed.vala"
		scroll_unit = pow (_tmp8_, 2.0 / 3.0);
#line 136 "../src/client/composer/composer-embed.vala"
		scroll_delta = event->delta_y * scroll_unit;
#line 137 "../src/client/composer/composer-embed.vala"
		_tmp9_ = adj;
#line 137 "../src/client/composer/composer-embed.vala"
		_tmp10_ = gtk_adjustment_get_value (_tmp9_);
#line 137 "../src/client/composer/composer-embed.vala"
		_tmp11_ = _tmp10_;
#line 137 "../src/client/composer/composer-embed.vala"
		initial_value = _tmp11_;
#line 139 "../src/client/composer/composer-embed.vala"
		if (event->delta_y > 0.0) {
#line 570 "composer-embed.c"
			GtkAllocation _tmp12_;
			GtkAdjustment* _tmp13_;
			gdouble _tmp14_;
			gdouble _tmp15_;
			gdouble remainder_delta = 0.0;
			GtkAdjustment* _tmp22_;
			gdouble _tmp23_;
			gdouble _tmp24_;
#line 141 "../src/client/composer/composer-embed.vala"
			_tmp12_ = alloc;
#line 141 "../src/client/composer/composer-embed.vala"
			_tmp13_ = adj;
#line 141 "../src/client/composer/composer-embed.vala"
			_tmp14_ = gtk_adjustment_get_value (_tmp13_);
#line 141 "../src/client/composer/composer-embed.vala"
			_tmp15_ = _tmp14_;
#line 141 "../src/client/composer/composer-embed.vala"
			if (((gdouble) _tmp12_.y) > _tmp15_) {
#line 589 "composer-embed.c"
				GtkAllocation _tmp16_;
				GtkAdjustment* _tmp17_;
				gdouble _tmp18_;
				gdouble _tmp19_;
				GtkScrolledWindow* _tmp20_;
				gboolean _tmp21_ = FALSE;
#line 145 "../src/client/composer/composer-embed.vala"
				_tmp16_ = alloc;
#line 145 "../src/client/composer/composer-embed.vala"
				_tmp17_ = adj;
#line 145 "../src/client/composer/composer-embed.vala"
				_tmp18_ = gtk_adjustment_get_value (_tmp17_);
#line 145 "../src/client/composer/composer-embed.vala"
				_tmp19_ = _tmp18_;
#line 145 "../src/client/composer/composer-embed.vala"
				event->delta_y = fmin (scroll_delta, _tmp16_.y - _tmp19_) / scroll_unit;
#line 148 "../src/client/composer/composer-embed.vala"
				_tmp20_ = self->priv->outer_scroller;
#line 148 "../src/client/composer/composer-embed.vala"
				g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, gtk_widget_get_type (), GtkWidget), "scroll-event", event, &_tmp21_);
#line 610 "composer-embed.c"
			}
#line 150 "../src/client/composer/composer-embed.vala"
			_tmp22_ = adj;
#line 150 "../src/client/composer/composer-embed.vala"
			_tmp23_ = gtk_adjustment_get_value (_tmp22_);
#line 150 "../src/client/composer/composer-embed.vala"
			_tmp24_ = _tmp23_;
#line 150 "../src/client/composer/composer-embed.vala"
			remainder_delta = scroll_delta - (_tmp24_ - initial_value);
#line 152 "../src/client/composer/composer-embed.vala"
			if (remainder_delta > 0.0001) {
#line 622 "composer-embed.c"
				ComposerWebView* body = NULL;
				ComposerWidget* _tmp25_;
				ComposerWidget* _tmp26_;
				ComposerEditor* _tmp27_;
				ComposerEditor* _tmp28_;
				ComposerWebView* _tmp29_;
				ComposerWebView* _tmp30_;
				ComposerWebView* _tmp31_;
				gint editor_height = 0;
				ComposerWebView* _tmp32_;
				gint editor_preferred = 0;
				ComposerWebView* _tmp33_;
				gint _tmp34_;
				gint _tmp35_;
				gint scrolled_height = 0;
				ComposerWebView* _tmp36_;
				gboolean _tmp37_ = FALSE;
				GtkAllocation _tmp38_;
#line 156 "../src/client/composer/composer-embed.vala"
				_tmp25_ = composer_container_get_composer (G_TYPE_CHECK_INSTANCE_CAST (self, COMPOSER_TYPE_CONTAINER, ComposerContainer));
#line 156 "../src/client/composer/composer-embed.vala"
				_tmp26_ = _tmp25_;
#line 156 "../src/client/composer/composer-embed.vala"
				_tmp27_ = composer_widget_get_editor (_tmp26_);
#line 156 "../src/client/composer/composer-embed.vala"
				_tmp28_ = _tmp27_;
#line 156 "../src/client/composer/composer-embed.vala"
				_tmp29_ = composer_editor_get_body (_tmp28_);
#line 156 "../src/client/composer/composer-embed.vala"
				_tmp30_ = _tmp29_;
#line 156 "../src/client/composer/composer-embed.vala"
				_tmp31_ = _g_object_ref0 (_tmp30_);
#line 156 "../src/client/composer/composer-embed.vala"
				body = _tmp31_;
#line 157 "../src/client/composer/composer-embed.vala"
				_tmp32_ = body;
#line 157 "../src/client/composer/composer-embed.vala"
				editor_height = gtk_widget_get_allocated_height (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, gtk_widget_get_type (), GtkWidget));
#line 158 "../src/client/composer/composer-embed.vala"
				_tmp33_ = body;
#line 158 "../src/client/composer/composer-embed.vala"
				_tmp34_ = components_web_view_get_preferred_height (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, COMPONENTS_TYPE_WEB_VIEW, ComponentsWebView));
#line 158 "../src/client/composer/composer-embed.vala"
				_tmp35_ = _tmp34_;
#line 158 "../src/client/composer/composer-embed.vala"
				editor_preferred = _tmp35_;
#line 159 "../src/client/composer/composer-embed.vala"
				_tmp36_ = body;
#line 159 "../src/client/composer/composer-embed.vala"
				scrolled_height = gtk_widget_get_allocated_height (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, gtk_widget_get_type (), GtkWidget));
#line 161 "../src/client/composer/composer-embed.vala"
				_tmp38_ = alloc;
#line 161 "../src/client/composer/composer-embed.vala"
				if (_tmp38_.height < scrolled_height) {
#line 162 "../src/client/composer/composer-embed.vala"
					_tmp37_ = editor_height < editor_preferred;
#line 679 "composer-embed.c"
				} else {
#line 161 "../src/client/composer/composer-embed.vala"
					_tmp37_ = FALSE;
#line 683 "composer-embed.c"
				}
#line 161 "../src/client/composer/composer-embed.vala"
				if (_tmp37_) {
#line 687 "composer-embed.c"
					gint editor_delta = 0;
					GtkAllocation _tmp39_;
#line 165 "../src/client/composer/composer-embed.vala"
					editor_delta = (gint) round (remainder_delta);
#line 166 "../src/client/composer/composer-embed.vala"
					_tmp39_ = alloc;
#line 166 "../src/client/composer/composer-embed.vala"
					if ((editor_delta + _tmp39_.height) > scrolled_height) {
#line 696 "composer-embed.c"
						GtkAllocation _tmp40_;
#line 167 "../src/client/composer/composer-embed.vala"
						_tmp40_ = alloc;
#line 167 "../src/client/composer/composer-embed.vala"
						editor_delta = scrolled_height - _tmp40_.height;
#line 702 "composer-embed.c"
					}
#line 169 "../src/client/composer/composer-embed.vala"
					if ((editor_delta + editor_height) > editor_preferred) {
#line 170 "../src/client/composer/composer-embed.vala"
						editor_delta = editor_preferred - editor_height;
#line 708 "composer-embed.c"
					}
#line 172 "../src/client/composer/composer-embed.vala"
					remainder_delta -= (gdouble) editor_delta;
#line 173 "../src/client/composer/composer-embed.vala"
					gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), -1, gtk_widget_get_allocated_height (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget)) + editor_delta);
#line 714 "composer-embed.c"
				} else {
#line 177 "../src/client/composer/composer-embed.vala"
					event->delta_y = remainder_delta / scroll_unit;
#line 178 "../src/client/composer/composer-embed.vala"
					ret = GDK_EVENT_PROPAGATE;
#line 720 "composer-embed.c"
				}
#line 152 "../src/client/composer/composer-embed.vala"
				_g_object_unref0 (body);
#line 724 "composer-embed.c"
			}
		} else {
#line 181 "../src/client/composer/composer-embed.vala"
			if (event->delta_y < 0.0) {
#line 729 "composer-embed.c"
				gdouble alloc_bottom = 0.0;
				GtkAllocation _tmp41_;
				GtkAllocation _tmp42_;
				gdouble adj_bottom = 0.0;
				GtkAdjustment* _tmp43_;
				gdouble _tmp44_;
				gdouble _tmp45_;
				GtkAdjustment* _tmp46_;
				gdouble _tmp47_;
				gdouble _tmp48_;
#line 183 "../src/client/composer/composer-embed.vala"
				_tmp41_ = alloc;
#line 183 "../src/client/composer/composer-embed.vala"
				_tmp42_ = alloc;
#line 183 "../src/client/composer/composer-embed.vala"
				alloc_bottom = (gdouble) (_tmp41_.y + _tmp42_.height);
#line 184 "../src/client/composer/composer-embed.vala"
				_tmp43_ = adj;
#line 184 "../src/client/composer/composer-embed.vala"
				_tmp44_ = gtk_adjustment_get_value (_tmp43_);
#line 184 "../src/client/composer/composer-embed.vala"
				_tmp45_ = _tmp44_;
#line 184 "../src/client/composer/composer-embed.vala"
				_tmp46_ = adj;
#line 184 "../src/client/composer/composer-embed.vala"
				_tmp47_ = gtk_adjustment_get_page_size (_tmp46_);
#line 184 "../src/client/composer/composer-embed.vala"
				_tmp48_ = _tmp47_;
#line 184 "../src/client/composer/composer-embed.vala"
				adj_bottom = _tmp45_ + _tmp48_;
#line 185 "../src/client/composer/composer-embed.vala"
				if (alloc_bottom < adj_bottom) {
#line 762 "composer-embed.c"
					GtkScrolledWindow* _tmp49_;
					gboolean _tmp50_ = FALSE;
					gdouble remainder_delta = 0.0;
					GtkAdjustment* _tmp51_;
					gdouble _tmp52_;
					gdouble _tmp53_;
#line 190 "../src/client/composer/composer-embed.vala"
					event->delta_y = fmax (scroll_delta, alloc_bottom - adj_bottom) / scroll_unit;
#line 193 "../src/client/composer/composer-embed.vala"
					_tmp49_ = self->priv->outer_scroller;
#line 193 "../src/client/composer/composer-embed.vala"
					g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, gtk_widget_get_type (), GtkWidget), "scroll-event", event, &_tmp50_);
#line 194 "../src/client/composer/composer-embed.vala"
					_tmp51_ = adj;
#line 194 "../src/client/composer/composer-embed.vala"
					_tmp52_ = gtk_adjustment_get_value (_tmp51_);
#line 194 "../src/client/composer/composer-embed.vala"
					_tmp53_ = _tmp52_;
#line 194 "../src/client/composer/composer-embed.vala"
					remainder_delta = scroll_delta - (_tmp53_ - initial_value);
#line 195 "../src/client/composer/composer-embed.vala"
					if (fabs (remainder_delta) > 0.0001) {
#line 196 "../src/client/composer/composer-embed.vala"
						event->delta_y = remainder_delta / scroll_unit;
#line 197 "../src/client/composer/composer-embed.vala"
						ret = GDK_EVENT_PROPAGATE;
#line 789 "composer-embed.c"
					}
				} else {
#line 200 "../src/client/composer/composer-embed.vala"
					ret = GDK_EVENT_PROPAGATE;
#line 794 "composer-embed.c"
				}
			}
		}
#line 126 "../src/client/composer/composer-embed.vala"
		_g_object_unref0 (adj);
#line 800 "composer-embed.c"
	}
#line 204 "../src/client/composer/composer-embed.vala"
	result = ret;
#line 204 "../src/client/composer/composer-embed.vala"
	return result;
#line 806 "composer-embed.c"
}

static void
composer_embed_class_init (ComposerEmbedClass * klass,
                           gpointer klass_data)
{
#line 16 "../src/client/composer/composer-embed.vala"
	composer_embed_parent_class = g_type_class_peek_parent (klass);
#line 16 "../src/client/composer/composer-embed.vala"
	g_type_class_adjust_private_offset (klass, &ComposerEmbed_private_offset);
#line 16 "../src/client/composer/composer-embed.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_composer_embed_get_property;
#line 16 "../src/client/composer/composer-embed.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_composer_embed_set_property;
#line 16 "../src/client/composer/composer-embed.vala"
	G_OBJECT_CLASS (klass)->finalize = composer_embed_finalize;
#line 823 "composer-embed.c"
	/** The email this composer was originally a reply to. */
#line 16 "../src/client/composer/composer-embed.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), COMPOSER_EMBED_REFERRED_PROPERTY, composer_embed_properties[COMPOSER_EMBED_REFERRED_PROPERTY] = g_param_spec_object ("referred", "referred", "referred", GEARY_TYPE_EMAIL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 827 "composer-embed.c"
	/** Emitted when the container is closed. */
#line 16 "../src/client/composer/composer-embed.vala"
	composer_embed_signals[COMPOSER_EMBED_VANISHED_SIGNAL] = g_signal_new ("vanished", COMPOSER_TYPE_EMBED, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 22 "../src/client/composer/composer-embed.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "geary-composer-embed");
#line 833 "composer-embed.c"
}

static void
composer_embed_composer_container_interface_init (ComposerContainerIface * iface,
                                                  gpointer iface_data)
{
#line 16 "../src/client/composer/composer-embed.vala"
	composer_embed_composer_container_parent_iface = g_type_interface_peek_parent (iface);
#line 16 "../src/client/composer/composer-embed.vala"
	iface->close = (void (*) (ComposerContainer*)) composer_embed_real_close;
#line 16 "../src/client/composer/composer-embed.vala"
	iface->get_top_window = composer_embed_real_get_top_window;
#line 16 "../src/client/composer/composer-embed.vala"
	iface->get_composer = composer_embed_real_get_composer;
#line 16 "../src/client/composer/composer-embed.vala"
	iface->set_composer = composer_embed_real_set_composer;
#line 850 "composer-embed.c"
}

static void
composer_embed_instance_init (ComposerEmbed * self,
                              gpointer klass)
{
#line 16 "../src/client/composer/composer-embed.vala"
	self->priv = composer_embed_get_instance_private (self);
#line 859 "composer-embed.c"
}

static void
composer_embed_finalize (GObject * obj)
{
	ComposerEmbed * self;
#line 16 "../src/client/composer/composer-embed.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, COMPOSER_TYPE_EMBED, ComposerEmbed);
#line 32 "../src/client/composer/composer-embed.vala"
	_g_object_unref0 (self->priv->_referred);
#line 35 "../src/client/composer/composer-embed.vala"
	_g_object_unref0 (self->priv->_composer);
#line 37 "../src/client/composer/composer-embed.vala"
	_g_object_unref0 (self->priv->outer_scroller);
#line 16 "../src/client/composer/composer-embed.vala"
	G_OBJECT_CLASS (composer_embed_parent_class)->finalize (obj);
#line 876 "composer-embed.c"
}

/**
 * A container for full-height paned composers in the main window.
 *
 * Adding a composer to this container places it in {@link
 * Widget.PresentationMode.INLINE} or {@link
 * Widget.PresentationMode.INLINE_COMPACT} mode.
 */
static GType
composer_embed_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ComposerEmbedClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) composer_embed_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ComposerEmbed), 0, (GInstanceInitFunc) composer_embed_instance_init, NULL };
	static const GInterfaceInfo composer_container_info = { (GInterfaceInitFunc) composer_embed_composer_container_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType composer_embed_type_id;
	composer_embed_type_id = g_type_register_static (gtk_event_box_get_type (), "ComposerEmbed", &g_define_type_info, 0);
	g_type_add_interface_static (composer_embed_type_id, COMPOSER_TYPE_CONTAINER, &composer_container_info);
	ComposerEmbed_private_offset = g_type_add_instance_private (composer_embed_type_id, sizeof (ComposerEmbedPrivate));
	return composer_embed_type_id;
}

GType
composer_embed_get_type (void)
{
	static volatile gsize composer_embed_type_id__once = 0;
	if (g_once_init_enter (&composer_embed_type_id__once)) {
		GType composer_embed_type_id;
		composer_embed_type_id = composer_embed_get_type_once ();
		g_once_init_leave (&composer_embed_type_id__once, composer_embed_type_id);
	}
	return composer_embed_type_id__once;
}

static void
_vala_composer_embed_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	ComposerEmbed * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, COMPOSER_TYPE_EMBED, ComposerEmbed);
#line 16 "../src/client/composer/composer-embed.vala"
	switch (property_id) {
#line 16 "../src/client/composer/composer-embed.vala"
		case COMPOSER_EMBED_REFERRED_PROPERTY:
#line 16 "../src/client/composer/composer-embed.vala"
		g_value_set_object (value, composer_embed_get_referred (self));
#line 16 "../src/client/composer/composer-embed.vala"
		break;
#line 926 "composer-embed.c"
		default:
#line 16 "../src/client/composer/composer-embed.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 16 "../src/client/composer/composer-embed.vala"
		break;
#line 932 "composer-embed.c"
	}
}

static void
_vala_composer_embed_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	ComposerEmbed * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, COMPOSER_TYPE_EMBED, ComposerEmbed);
#line 16 "../src/client/composer/composer-embed.vala"
	switch (property_id) {
#line 16 "../src/client/composer/composer-embed.vala"
		case COMPOSER_EMBED_REFERRED_PROPERTY:
#line 16 "../src/client/composer/composer-embed.vala"
		composer_embed_set_referred (self, g_value_get_object (value));
#line 16 "../src/client/composer/composer-embed.vala"
		break;
#line 952 "composer-embed.c"
		default:
#line 16 "../src/client/composer/composer-embed.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 16 "../src/client/composer/composer-embed.vala"
		break;
#line 958 "composer-embed.c"
	}
}

