/* composer-link-popover.c generated by valac 0.56.17, the Vala compiler
 * generated from composer-link-popover.vala, do not modify */

/*
 * Copyright 2017 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-client-46.0.h"
#include <gtk/gtk.h>
#include "geary-engine.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	COMPOSER_LINK_POPOVER_0_PROPERTY,
	COMPOSER_LINK_POPOVER_LINK_URI_PROPERTY,
	COMPOSER_LINK_POPOVER_NUM_PROPERTIES
};
static GParamSpec* composer_link_popover_properties[COMPOSER_LINK_POPOVER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_uri_unref0(var) ((var == NULL) ? NULL : (var = (g_uri_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	COMPOSER_LINK_POPOVER_LINK_CHANGED_SIGNAL,
	COMPOSER_LINK_POPOVER_LINK_ACTIVATE_SIGNAL,
	COMPOSER_LINK_POPOVER_LINK_DELETE_SIGNAL,
	COMPOSER_LINK_POPOVER_NUM_SIGNALS
};
static guint composer_link_popover_signals[COMPOSER_LINK_POPOVER_NUM_SIGNALS] = {0};

struct _ComposerLinkPopoverPrivate {
	GtkEntry* url;
	GtkButton* insert;
	GtkButton* update;
	GtkButton* remove;
	GearyTimeoutManager* validation_timeout;
};

static gint ComposerLinkPopover_private_offset;
static gpointer composer_link_popover_parent_class = NULL;

static void g_cclosure_user_marshal_VOID__BOXED_BOOLEAN (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void __lambda174_ (ComposerLinkPopover* self);
static void composer_link_popover_validate (ComposerLinkPopover* self);
static void ___lambda174__geary_timeout_manager_timeout_func (GearyTimeoutManager* manager,
                                                       gpointer self);
static void composer_link_popover_real_show (GtkWidget* base);
static void composer_link_popover_real_destroy (GtkWidget* base);
static gboolean _vala_string_array_contains (const gchar* * stack,
                                      gssize stack_length,
                                      const const gchar* needle);
static void composer_link_popover_on_url_changed (ComposerLinkPopover* self);
static void _composer_link_popover_on_url_changed_gtk_editable_changed (GtkEditable* _sender,
                                                                 gpointer self);
static void composer_link_popover_on_activate_popover (ComposerLinkPopover* self);
static void _composer_link_popover_on_activate_popover_gtk_button_clicked (GtkButton* _sender,
                                                                    gpointer self);
static void composer_link_popover_on_remove_clicked (ComposerLinkPopover* self);
static void _composer_link_popover_on_remove_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self);
static void composer_link_popover_finalize (GObject * obj);
static GType composer_link_popover_get_type_once (void);
static void _vala_composer_link_popover_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);

static const gchar* COMPOSER_LINK_POPOVER_HTTP_SCHEMES[2] = {"http", "https"};
static const gchar* COMPOSER_LINK_POPOVER_OTHER_SCHEMES[30] = {"aim", "apt", "bitcoin", "cvs", "ed2k", "ftp", "file", "finger", "git", "gtalk", "irc", "ircs", "irc6", "lastfm", "ldap", "ldaps", "magnet", "news", "nntp", "rsync", "sftp", "skype", "smb", "sms", "svn", "telnet", "tftp", "ssh", "webcal", "xmpp"};

static inline gpointer
composer_link_popover_get_instance_private (ComposerLinkPopover* self)
{
	return G_STRUCT_MEMBER_P (self, ComposerLinkPopover_private_offset);
}

/** Determines which version of the UI is presented to the user. */
static GType
composer_link_popover_type_get_type_once (void)
{
	static const GEnumValue values[] = {{COMPOSER_LINK_POPOVER_TYPE_NEW_LINK, "COMPOSER_LINK_POPOVER_TYPE_NEW_LINK", "new-link"}, {COMPOSER_LINK_POPOVER_TYPE_EXISTING_LINK, "COMPOSER_LINK_POPOVER_TYPE_EXISTING_LINK", "existing-link"}, {0, NULL, NULL}};
	GType composer_link_popover_type_type_id;
	composer_link_popover_type_type_id = g_enum_register_static ("ComposerLinkPopoverType", values);
	return composer_link_popover_type_type_id;
}

GType
composer_link_popover_type_get_type (void)
{
	static volatile gsize composer_link_popover_type_type_id__once = 0;
	if (g_once_init_enter (&composer_link_popover_type_type_id__once)) {
		GType composer_link_popover_type_type_id;
		composer_link_popover_type_type_id = composer_link_popover_type_get_type_once ();
		g_once_init_leave (&composer_link_popover_type_type_id__once, composer_link_popover_type_type_id);
	}
	return composer_link_popover_type_type_id__once;
}

const gchar*
composer_link_popover_get_link_uri (ComposerLinkPopover* self)
{
	const gchar* result;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
#line 41 "../src/client/composer/composer-link-popover.vala"
	g_return_val_if_fail (COMPOSER_IS_LINK_POPOVER (self), NULL);
#line 41 "../src/client/composer/composer-link-popover.vala"
	_tmp0_ = self->priv->url;
#line 41 "../src/client/composer/composer-link-popover.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 41 "../src/client/composer/composer-link-popover.vala"
	result = _tmp1_;
#line 41 "../src/client/composer/composer-link-popover.vala"
	return result;
#line 137 "composer-link-popover.c"
}

static void
g_cclosure_user_marshal_VOID__BOXED_BOOLEAN (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__BOXED_BOOLEAN) (gpointer data1, gpointer arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__BOXED_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 21 "../src/client/composer/composer-link-popover.vala"
	g_return_if_fail (n_param_values == 3);
#line 21 "../src/client/composer/composer-link-popover.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 21 "../src/client/composer/composer-link-popover.vala"
		data1 = closure->data;
#line 21 "../src/client/composer/composer-link-popover.vala"
		data2 = param_values->data[0].v_pointer;
#line 162 "composer-link-popover.c"
	} else {
#line 21 "../src/client/composer/composer-link-popover.vala"
		data1 = param_values->data[0].v_pointer;
#line 21 "../src/client/composer/composer-link-popover.vala"
		data2 = closure->data;
#line 168 "composer-link-popover.c"
	}
#line 21 "../src/client/composer/composer-link-popover.vala"
	callback = (GMarshalFunc_VOID__BOXED_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 21 "../src/client/composer/composer-link-popover.vala"
	callback (data1, g_value_get_boxed (param_values + 1), g_value_get_boolean (param_values + 2), data2);
#line 174 "composer-link-popover.c"
}

static void
__lambda174_ (ComposerLinkPopover* self)
{
#line 77 "../src/client/composer/composer-link-popover.vala"
	composer_link_popover_validate (self);
#line 182 "composer-link-popover.c"
}

static void
___lambda174__geary_timeout_manager_timeout_func (GearyTimeoutManager* manager,
                                                  gpointer self)
{
#line 76 "../src/client/composer/composer-link-popover.vala"
	__lambda174_ ((ComposerLinkPopover*) self);
#line 191 "composer-link-popover.c"
}

ComposerLinkPopover*
composer_link_popover_construct (GType object_type,
                                 ComposerLinkPopoverType type)
{
	ComposerLinkPopover * self = NULL;
	GtkEntry* _tmp0_;
	GtkEntry* _tmp1_;
	GearyTimeoutManager* _tmp5_;
#line 64 "../src/client/composer/composer-link-popover.vala"
	self = (ComposerLinkPopover*) g_object_new (object_type, NULL);
#line 65 "../src/client/composer/composer-link-popover.vala"
	_tmp0_ = self->priv->url;
#line 65 "../src/client/composer/composer-link-popover.vala"
	gtk_popover_set_default_widget (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_popover_get_type (), GtkPopover), G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 66 "../src/client/composer/composer-link-popover.vala"
	_tmp1_ = self->priv->url;
#line 66 "../src/client/composer/composer-link-popover.vala"
	gtk_container_set_focus_child (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget));
#line 67 "../src/client/composer/composer-link-popover.vala"
	switch (type) {
#line 67 "../src/client/composer/composer-link-popover.vala"
		case COMPOSER_LINK_POPOVER_TYPE_NEW_LINK:
#line 216 "composer-link-popover.c"
		{
			GtkButton* _tmp2_;
			GtkButton* _tmp3_;
#line 69 "../src/client/composer/composer-link-popover.vala"
			_tmp2_ = self->priv->update;
#line 69 "../src/client/composer/composer-link-popover.vala"
			gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_widget_get_type (), GtkWidget));
#line 70 "../src/client/composer/composer-link-popover.vala"
			_tmp3_ = self->priv->remove;
#line 70 "../src/client/composer/composer-link-popover.vala"
			gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget));
#line 71 "../src/client/composer/composer-link-popover.vala"
			break;
#line 230 "composer-link-popover.c"
		}
#line 67 "../src/client/composer/composer-link-popover.vala"
		case COMPOSER_LINK_POPOVER_TYPE_EXISTING_LINK:
#line 234 "composer-link-popover.c"
		{
			GtkButton* _tmp4_;
#line 73 "../src/client/composer/composer-link-popover.vala"
			_tmp4_ = self->priv->insert;
#line 73 "../src/client/composer/composer-link-popover.vala"
			gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget));
#line 74 "../src/client/composer/composer-link-popover.vala"
			break;
#line 243 "composer-link-popover.c"
		}
		default:
#line 67 "../src/client/composer/composer-link-popover.vala"
		break;
#line 248 "composer-link-popover.c"
	}
#line 76 "../src/client/composer/composer-link-popover.vala"
	_tmp5_ = geary_timeout_manager_new_milliseconds ((guint) 150, ___lambda174__geary_timeout_manager_timeout_func, self);
#line 76 "../src/client/composer/composer-link-popover.vala"
	_g_object_unref0 (self->priv->validation_timeout);
#line 76 "../src/client/composer/composer-link-popover.vala"
	self->priv->validation_timeout = _tmp5_;
#line 64 "../src/client/composer/composer-link-popover.vala"
	return self;
#line 258 "composer-link-popover.c"
}

ComposerLinkPopover*
composer_link_popover_new (ComposerLinkPopoverType type)
{
#line 64 "../src/client/composer/composer-link-popover.vala"
	return composer_link_popover_construct (COMPOSER_TYPE_LINK_POPOVER, type);
#line 266 "composer-link-popover.c"
}

static void
composer_link_popover_real_show (GtkWidget* base)
{
	ComposerLinkPopover * self;
	GtkEntry* _tmp0_;
#line 81 "../src/client/composer/composer-link-popover.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, COMPOSER_TYPE_LINK_POPOVER, ComposerLinkPopover);
#line 82 "../src/client/composer/composer-link-popover.vala"
	GTK_WIDGET_CLASS (composer_link_popover_parent_class)->show (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_popover_get_type (), GtkPopover), gtk_widget_get_type (), GtkWidget));
#line 83 "../src/client/composer/composer-link-popover.vala"
	_tmp0_ = self->priv->url;
#line 83 "../src/client/composer/composer-link-popover.vala"
	gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 282 "composer-link-popover.c"
}

static void
composer_link_popover_real_destroy (GtkWidget* base)
{
	ComposerLinkPopover * self;
	GearyTimeoutManager* _tmp0_;
#line 86 "../src/client/composer/composer-link-popover.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, COMPOSER_TYPE_LINK_POPOVER, ComposerLinkPopover);
#line 87 "../src/client/composer/composer-link-popover.vala"
	_tmp0_ = self->priv->validation_timeout;
#line 87 "../src/client/composer/composer-link-popover.vala"
	geary_timeout_manager_reset (_tmp0_);
#line 88 "../src/client/composer/composer-link-popover.vala"
	GTK_WIDGET_CLASS (composer_link_popover_parent_class)->destroy (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_popover_get_type (), GtkPopover), gtk_widget_get_type (), GtkWidget));
#line 298 "composer-link-popover.c"
}

void
composer_link_popover_set_link_url (ComposerLinkPopover* self,
                                    const gchar* url)
{
	GtkEntry* _tmp0_;
	GearyTimeoutManager* _tmp1_;
#line 91 "../src/client/composer/composer-link-popover.vala"
	g_return_if_fail (COMPOSER_IS_LINK_POPOVER (self));
#line 91 "../src/client/composer/composer-link-popover.vala"
	g_return_if_fail (url != NULL);
#line 92 "../src/client/composer/composer-link-popover.vala"
	_tmp0_ = self->priv->url;
#line 92 "../src/client/composer/composer-link-popover.vala"
	gtk_entry_set_text (_tmp0_, url);
#line 93 "../src/client/composer/composer-link-popover.vala"
	_tmp1_ = self->priv->validation_timeout;
#line 93 "../src/client/composer/composer-link-popover.vala"
	geary_timeout_manager_reset (_tmp1_);
#line 319 "composer-link-popover.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 340 "composer-link-popover.c"
}

static gboolean
_vala_string_array_contains (const gchar* * stack,
                             gssize stack_length,
                             const const gchar* needle)
{
	gssize i;
#line 114 "../src/client/composer/composer-link-popover.vala"
	for (i = 0; i < stack_length; i++) {
#line 114 "../src/client/composer/composer-link-popover.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 114 "../src/client/composer/composer-link-popover.vala"
			return TRUE;
#line 355 "composer-link-popover.c"
		}
	}
#line 114 "../src/client/composer/composer-link-popover.vala"
	return FALSE;
#line 360 "composer-link-popover.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 132 "../src/client/composer/composer-link-popover.vala"
	return self ? g_object_ref (self) : NULL;
#line 368 "composer-link-popover.c"
}

static void
composer_link_popover_validate (ComposerLinkPopover* self)
{
	gchar* text = NULL;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean is_empty = FALSE;
	const gchar* _tmp3_;
	gboolean is_valid = FALSE;
	gboolean is_nominal = FALSE;
	gboolean is_mailto = FALSE;
	GUri* url = NULL;
	GtkStyleContext* style = NULL;
	GtkEntry* _tmp30_;
	GtkStyleContext* _tmp31_;
	GtkStyleContext* _tmp32_;
	GtkEntryIconPosition pos = 0;
	gboolean _tmp46_ = FALSE;
	GUri* _tmp47_;
	GError* _inner_error0_ = NULL;
#line 96 "../src/client/composer/composer-link-popover.vala"
	g_return_if_fail (COMPOSER_IS_LINK_POPOVER (self));
#line 97 "../src/client/composer/composer-link-popover.vala"
	_tmp0_ = self->priv->url;
#line 97 "../src/client/composer/composer-link-popover.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 97 "../src/client/composer/composer-link-popover.vala"
	_tmp2_ = string_strip (_tmp1_);
#line 97 "../src/client/composer/composer-link-popover.vala"
	text = _tmp2_;
#line 98 "../src/client/composer/composer-link-popover.vala"
	_tmp3_ = text;
#line 98 "../src/client/composer/composer-link-popover.vala"
	is_empty = geary_string_is_empty (_tmp3_);
#line 99 "../src/client/composer/composer-link-popover.vala"
	is_valid = FALSE;
#line 100 "../src/client/composer/composer-link-popover.vala"
	is_nominal = FALSE;
#line 101 "../src/client/composer/composer-link-popover.vala"
	is_mailto = FALSE;
#line 102 "../src/client/composer/composer-link-popover.vala"
	url = NULL;
#line 103 "../src/client/composer/composer-link-popover.vala"
	if (!is_empty) {
#line 416 "composer-link-popover.c"
		GUri* _tmp10_;
		{
			GUri* _tmp4_ = NULL;
			const gchar* _tmp5_;
			GUri* _tmp6_;
			GUri* _tmp7_;
#line 105 "../src/client/composer/composer-link-popover.vala"
			_tmp5_ = text;
#line 105 "../src/client/composer/composer-link-popover.vala"
			_tmp6_ = g_uri_parse (_tmp5_, G_URI_FLAGS_PARSE_RELAXED, &_inner_error0_);
#line 105 "../src/client/composer/composer-link-popover.vala"
			_tmp4_ = _tmp6_;
#line 105 "../src/client/composer/composer-link-popover.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 105 "../src/client/composer/composer-link-popover.vala"
				if (_inner_error0_->domain == G_URI_ERROR) {
#line 433 "composer-link-popover.c"
					goto __catch0_g_uri_error;
				}
#line 105 "../src/client/composer/composer-link-popover.vala"
				_g_uri_unref0 (url);
#line 105 "../src/client/composer/composer-link-popover.vala"
				_g_free0 (text);
#line 105 "../src/client/composer/composer-link-popover.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 105 "../src/client/composer/composer-link-popover.vala"
				g_clear_error (&_inner_error0_);
#line 105 "../src/client/composer/composer-link-popover.vala"
				return;
#line 446 "composer-link-popover.c"
			}
#line 105 "../src/client/composer/composer-link-popover.vala"
			_tmp7_ = _tmp4_;
#line 105 "../src/client/composer/composer-link-popover.vala"
			_tmp4_ = NULL;
#line 105 "../src/client/composer/composer-link-popover.vala"
			_g_uri_unref0 (url);
#line 105 "../src/client/composer/composer-link-popover.vala"
			url = _tmp7_;
#line 104 "../src/client/composer/composer-link-popover.vala"
			_g_uri_unref0 (_tmp4_);
#line 458 "composer-link-popover.c"
		}
		goto __finally0;
		__catch0_g_uri_error:
		{
			GError* err = NULL;
			GError* _tmp8_;
			const gchar* _tmp9_;
#line 104 "../src/client/composer/composer-link-popover.vala"
			err = _inner_error0_;
#line 104 "../src/client/composer/composer-link-popover.vala"
			_inner_error0_ = NULL;
#line 107 "../src/client/composer/composer-link-popover.vala"
			_tmp8_ = err;
#line 107 "../src/client/composer/composer-link-popover.vala"
			_tmp9_ = _tmp8_->message;
#line 107 "../src/client/composer/composer-link-popover.vala"
			g_debug ("composer-link-popover.vala:107: Invalid link URI: %s", _tmp9_);
#line 104 "../src/client/composer/composer-link-popover.vala"
			_g_error_free0 (err);
#line 478 "composer-link-popover.c"
		}
		__finally0:
#line 104 "../src/client/composer/composer-link-popover.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 104 "../src/client/composer/composer-link-popover.vala"
			_g_uri_unref0 (url);
#line 104 "../src/client/composer/composer-link-popover.vala"
			_g_free0 (text);
#line 104 "../src/client/composer/composer-link-popover.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 104 "../src/client/composer/composer-link-popover.vala"
			g_clear_error (&_inner_error0_);
#line 104 "../src/client/composer/composer-link-popover.vala"
			return;
#line 493 "composer-link-popover.c"
		}
#line 109 "../src/client/composer/composer-link-popover.vala"
		_tmp10_ = url;
#line 109 "../src/client/composer/composer-link-popover.vala"
		if (_tmp10_ != NULL) {
#line 499 "composer-link-popover.c"
			gchar* scheme = NULL;
			GUri* _tmp11_;
			const gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* path = NULL;
			GUri* _tmp14_;
			const gchar* _tmp15_;
			gchar* _tmp16_;
			const gchar* _tmp17_;
#line 110 "../src/client/composer/composer-link-popover.vala"
			is_valid = TRUE;
#line 112 "../src/client/composer/composer-link-popover.vala"
			_tmp11_ = url;
#line 112 "../src/client/composer/composer-link-popover.vala"
			_tmp12_ = g_uri_get_scheme (_tmp11_);
#line 112 "../src/client/composer/composer-link-popover.vala"
			_tmp13_ = g_strdup (_tmp12_);
#line 112 "../src/client/composer/composer-link-popover.vala"
			scheme = _tmp13_;
#line 113 "../src/client/composer/composer-link-popover.vala"
			_tmp14_ = url;
#line 113 "../src/client/composer/composer-link-popover.vala"
			_tmp15_ = g_uri_get_path (_tmp14_);
#line 113 "../src/client/composer/composer-link-popover.vala"
			_tmp16_ = g_strdup (_tmp15_);
#line 113 "../src/client/composer/composer-link-popover.vala"
			path = _tmp16_;
#line 114 "../src/client/composer/composer-link-popover.vala"
			_tmp17_ = scheme;
#line 114 "../src/client/composer/composer-link-popover.vala"
			if (_vala_string_array_contains (COMPOSER_LINK_POPOVER_HTTP_SCHEMES, G_N_ELEMENTS (COMPOSER_LINK_POPOVER_HTTP_SCHEMES), _tmp17_)) {
#line 531 "composer-link-popover.c"
				GUri* _tmp18_;
				const gchar* _tmp19_;
				gchar* _tmp20_;
#line 115 "../src/client/composer/composer-link-popover.vala"
				_tmp18_ = url;
#line 115 "../src/client/composer/composer-link-popover.vala"
				_tmp19_ = g_uri_get_host (_tmp18_);
#line 115 "../src/client/composer/composer-link-popover.vala"
				_tmp20_ = g_strdup (_tmp19_);
#line 115 "../src/client/composer/composer-link-popover.vala"
				is_nominal = geary_inet_is_valid_display_host (_tmp20_);
#line 543 "composer-link-popover.c"
			} else {
				const gchar* _tmp21_;
#line 116 "../src/client/composer/composer-link-popover.vala"
				_tmp21_ = scheme;
#line 116 "../src/client/composer/composer-link-popover.vala"
				if (g_strcmp0 (_tmp21_, "mailto") == 0) {
#line 550 "composer-link-popover.c"
					gboolean _tmp22_ = FALSE;
					const gchar* _tmp23_;
#line 117 "../src/client/composer/composer-link-popover.vala"
					is_mailto = TRUE;
#line 118 "../src/client/composer/composer-link-popover.vala"
					_tmp23_ = path;
#line 118 "../src/client/composer/composer-link-popover.vala"
					if (!geary_string_is_empty (_tmp23_)) {
#line 559 "composer-link-popover.c"
						const gchar* _tmp24_;
#line 120 "../src/client/composer/composer-link-popover.vala"
						_tmp24_ = path;
#line 120 "../src/client/composer/composer-link-popover.vala"
						_tmp22_ = geary_rf_c822_mailbox_address_is_valid_address (_tmp24_);
#line 565 "composer-link-popover.c"
					} else {
#line 119 "../src/client/composer/composer-link-popover.vala"
						_tmp22_ = FALSE;
#line 569 "composer-link-popover.c"
					}
#line 118 "../src/client/composer/composer-link-popover.vala"
					is_nominal = _tmp22_;
#line 573 "composer-link-popover.c"
				} else {
					const gchar* _tmp25_;
#line 122 "../src/client/composer/composer-link-popover.vala"
					_tmp25_ = scheme;
#line 122 "../src/client/composer/composer-link-popover.vala"
					if (_vala_string_array_contains (COMPOSER_LINK_POPOVER_OTHER_SCHEMES, G_N_ELEMENTS (COMPOSER_LINK_POPOVER_OTHER_SCHEMES), _tmp25_)) {
#line 580 "composer-link-popover.c"
						const gchar* _tmp26_;
#line 123 "../src/client/composer/composer-link-popover.vala"
						_tmp26_ = path;
#line 123 "../src/client/composer/composer-link-popover.vala"
						is_nominal = !geary_string_is_empty (_tmp26_);
#line 586 "composer-link-popover.c"
					}
				}
			}
#line 109 "../src/client/composer/composer-link-popover.vala"
			_g_free0 (path);
#line 109 "../src/client/composer/composer-link-popover.vala"
			_g_free0 (scheme);
#line 594 "composer-link-popover.c"
		} else {
			gboolean _tmp27_ = FALSE;
			const gchar* _tmp28_;
#line 125 "../src/client/composer/composer-link-popover.vala"
			_tmp28_ = text;
#line 125 "../src/client/composer/composer-link-popover.vala"
			if (g_strcmp0 (_tmp28_, "http:/") == 0) {
#line 125 "../src/client/composer/composer-link-popover.vala"
				_tmp27_ = TRUE;
#line 604 "composer-link-popover.c"
			} else {
				const gchar* _tmp29_;
#line 125 "../src/client/composer/composer-link-popover.vala"
				_tmp29_ = text;
#line 125 "../src/client/composer/composer-link-popover.vala"
				_tmp27_ = g_strcmp0 (_tmp29_, "https:/") == 0;
#line 611 "composer-link-popover.c"
			}
#line 125 "../src/client/composer/composer-link-popover.vala"
			if (_tmp27_) {
#line 128 "../src/client/composer/composer-link-popover.vala"
				is_valid = TRUE;
#line 617 "composer-link-popover.c"
			}
		}
	}
#line 132 "../src/client/composer/composer-link-popover.vala"
	_tmp30_ = self->priv->url;
#line 132 "../src/client/composer/composer-link-popover.vala"
	_tmp31_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, gtk_widget_get_type (), GtkWidget));
#line 132 "../src/client/composer/composer-link-popover.vala"
	_tmp32_ = _g_object_ref0 (_tmp31_);
#line 132 "../src/client/composer/composer-link-popover.vala"
	style = _tmp32_;
#line 133 "../src/client/composer/composer-link-popover.vala"
	pos = GTK_ENTRY_ICON_SECONDARY;
#line 134 "../src/client/composer/composer-link-popover.vala"
	if (!is_valid) {
#line 633 "composer-link-popover.c"
		GtkStyleContext* _tmp33_;
		GtkStyleContext* _tmp34_;
		GtkEntry* _tmp35_;
		GtkEntry* _tmp36_;
#line 135 "../src/client/composer/composer-link-popover.vala"
		_tmp33_ = style;
#line 135 "../src/client/composer/composer-link-popover.vala"
		gtk_style_context_add_class (_tmp33_, GTK_STYLE_CLASS_ERROR);
#line 136 "../src/client/composer/composer-link-popover.vala"
		_tmp34_ = style;
#line 136 "../src/client/composer/composer-link-popover.vala"
		gtk_style_context_remove_class (_tmp34_, GTK_STYLE_CLASS_WARNING);
#line 137 "../src/client/composer/composer-link-popover.vala"
		_tmp35_ = self->priv->url;
#line 137 "../src/client/composer/composer-link-popover.vala"
		gtk_entry_set_icon_from_icon_name (_tmp35_, pos, "dialog-error-symbolic");
#line 138 "../src/client/composer/composer-link-popover.vala"
		_tmp36_ = self->priv->url;
#line 138 "../src/client/composer/composer-link-popover.vala"
		gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, gtk_widget_get_type (), GtkWidget), _ ("Link URL is not correctly formatted, e.g. http://example.com"));
#line 654 "composer-link-popover.c"
	} else {
#line 141 "../src/client/composer/composer-link-popover.vala"
		if (!is_nominal) {
#line 658 "composer-link-popover.c"
			GtkStyleContext* _tmp37_;
			GtkStyleContext* _tmp38_;
			GtkEntry* _tmp39_;
			const gchar* _tmp40_ = NULL;
			GtkEntry* _tmp41_;
#line 142 "../src/client/composer/composer-link-popover.vala"
			_tmp37_ = style;
#line 142 "../src/client/composer/composer-link-popover.vala"
			gtk_style_context_remove_class (_tmp37_, GTK_STYLE_CLASS_ERROR);
#line 143 "../src/client/composer/composer-link-popover.vala"
			_tmp38_ = style;
#line 143 "../src/client/composer/composer-link-popover.vala"
			gtk_style_context_add_class (_tmp38_, GTK_STYLE_CLASS_WARNING);
#line 144 "../src/client/composer/composer-link-popover.vala"
			_tmp39_ = self->priv->url;
#line 144 "../src/client/composer/composer-link-popover.vala"
			gtk_entry_set_icon_from_icon_name (_tmp39_, pos, "dialog-warning-symbolic");
#line 146 "../src/client/composer/composer-link-popover.vala"
			if (!is_mailto) {
#line 146 "../src/client/composer/composer-link-popover.vala"
				_tmp40_ = _ ("Invalid link URL");
#line 680 "composer-link-popover.c"
			} else {
#line 146 "../src/client/composer/composer-link-popover.vala"
				_tmp40_ = _ ("Invalid email address");
#line 684 "composer-link-popover.c"
			}
#line 145 "../src/client/composer/composer-link-popover.vala"
			_tmp41_ = self->priv->url;
#line 145 "../src/client/composer/composer-link-popover.vala"
			gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, gtk_widget_get_type (), GtkWidget), _tmp40_);
#line 690 "composer-link-popover.c"
		} else {
			GtkStyleContext* _tmp42_;
			GtkStyleContext* _tmp43_;
			GtkEntry* _tmp44_;
			GtkEntry* _tmp45_;
#line 149 "../src/client/composer/composer-link-popover.vala"
			_tmp42_ = style;
#line 149 "../src/client/composer/composer-link-popover.vala"
			gtk_style_context_remove_class (_tmp42_, GTK_STYLE_CLASS_ERROR);
#line 150 "../src/client/composer/composer-link-popover.vala"
			_tmp43_ = style;
#line 150 "../src/client/composer/composer-link-popover.vala"
			gtk_style_context_remove_class (_tmp43_, GTK_STYLE_CLASS_WARNING);
#line 151 "../src/client/composer/composer-link-popover.vala"
			_tmp44_ = self->priv->url;
#line 151 "../src/client/composer/composer-link-popover.vala"
			gtk_entry_set_icon_from_icon_name (_tmp44_, pos, NULL);
#line 152 "../src/client/composer/composer-link-popover.vala"
			_tmp45_ = self->priv->url;
#line 152 "../src/client/composer/composer-link-popover.vala"
			gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, gtk_widget_get_type (), GtkWidget), "");
#line 712 "composer-link-popover.c"
		}
	}
#line 155 "../src/client/composer/composer-link-popover.vala"
	if (is_valid) {
#line 155 "../src/client/composer/composer-link-popover.vala"
		_tmp46_ = is_nominal;
#line 719 "composer-link-popover.c"
	} else {
#line 155 "../src/client/composer/composer-link-popover.vala"
		_tmp46_ = FALSE;
#line 723 "composer-link-popover.c"
	}
#line 155 "../src/client/composer/composer-link-popover.vala"
	_tmp47_ = url;
#line 155 "../src/client/composer/composer-link-popover.vala"
	g_signal_emit (self, composer_link_popover_signals[COMPOSER_LINK_POPOVER_LINK_CHANGED_SIGNAL], 0, _tmp47_, _tmp46_);
#line 96 "../src/client/composer/composer-link-popover.vala"
	_g_object_unref0 (style);
#line 96 "../src/client/composer/composer-link-popover.vala"
	_g_uri_unref0 (url);
#line 96 "../src/client/composer/composer-link-popover.vala"
	_g_free0 (text);
#line 735 "composer-link-popover.c"
}

static void
composer_link_popover_on_url_changed (ComposerLinkPopover* self)
{
	GearyTimeoutManager* _tmp0_;
#line 159 "../src/client/composer/composer-link-popover.vala"
	g_return_if_fail (COMPOSER_IS_LINK_POPOVER (self));
#line 160 "../src/client/composer/composer-link-popover.vala"
	_tmp0_ = self->priv->validation_timeout;
#line 160 "../src/client/composer/composer-link-popover.vala"
	geary_timeout_manager_start (_tmp0_);
#line 748 "composer-link-popover.c"
}

static void
_composer_link_popover_on_url_changed_gtk_editable_changed (GtkEditable* _sender,
                                                            gpointer self)
{
#line 21 "../src/client/composer/composer-link-popover.vala"
	composer_link_popover_on_url_changed ((ComposerLinkPopover*) self);
#line 757 "composer-link-popover.c"
}

static void
composer_link_popover_on_activate_popover (ComposerLinkPopover* self)
{
#line 164 "../src/client/composer/composer-link-popover.vala"
	g_return_if_fail (COMPOSER_IS_LINK_POPOVER (self));
#line 165 "../src/client/composer/composer-link-popover.vala"
	g_signal_emit (self, composer_link_popover_signals[COMPOSER_LINK_POPOVER_LINK_ACTIVATE_SIGNAL], 0);
#line 166 "../src/client/composer/composer-link-popover.vala"
	gtk_popover_popdown (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_popover_get_type (), GtkPopover));
#line 769 "composer-link-popover.c"
}

static void
_composer_link_popover_on_activate_popover_gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self)
{
#line 21 "../src/client/composer/composer-link-popover.vala"
	composer_link_popover_on_activate_popover ((ComposerLinkPopover*) self);
#line 778 "composer-link-popover.c"
}

static void
composer_link_popover_on_remove_clicked (ComposerLinkPopover* self)
{
#line 170 "../src/client/composer/composer-link-popover.vala"
	g_return_if_fail (COMPOSER_IS_LINK_POPOVER (self));
#line 171 "../src/client/composer/composer-link-popover.vala"
	g_signal_emit (self, composer_link_popover_signals[COMPOSER_LINK_POPOVER_LINK_DELETE_SIGNAL], 0);
#line 172 "../src/client/composer/composer-link-popover.vala"
	gtk_popover_popdown (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_popover_get_type (), GtkPopover));
#line 790 "composer-link-popover.c"
}

static void
_composer_link_popover_on_remove_clicked_gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self)
{
#line 21 "../src/client/composer/composer-link-popover.vala"
	composer_link_popover_on_remove_clicked ((ComposerLinkPopover*) self);
#line 799 "composer-link-popover.c"
}

static void
composer_link_popover_class_init (ComposerLinkPopoverClass * klass,
                                  gpointer klass_data)
{
#line 21 "../src/client/composer/composer-link-popover.vala"
	composer_link_popover_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/client/composer/composer-link-popover.vala"
	g_type_class_adjust_private_offset (klass, &ComposerLinkPopover_private_offset);
#line 21 "../src/client/composer/composer-link-popover.vala"
	((GtkWidgetClass *) klass)->show = (void (*) (GtkWidget*)) composer_link_popover_real_show;
#line 21 "../src/client/composer/composer-link-popover.vala"
	((GtkWidgetClass *) klass)->destroy = (void (*) (GtkWidget*)) composer_link_popover_real_destroy;
#line 21 "../src/client/composer/composer-link-popover.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_composer_link_popover_get_property;
#line 21 "../src/client/composer/composer-link-popover.vala"
	G_OBJECT_CLASS (klass)->finalize = composer_link_popover_finalize;
#line 818 "composer-link-popover.c"
	/** The URL displayed in the popover */
#line 21 "../src/client/composer/composer-link-popover.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), COMPOSER_LINK_POPOVER_LINK_URI_PROPERTY, composer_link_popover_properties[COMPOSER_LINK_POPOVER_LINK_URI_PROPERTY] = g_param_spec_string ("link-uri", "link-uri", "link-uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/client/composer/composer-link-popover.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Geary/composer-link-popover.ui");
#line 824 "composer-link-popover.c"
	/** Emitted when the link URL has changed. */
#line 21 "../src/client/composer/composer-link-popover.vala"
	composer_link_popover_signals[COMPOSER_LINK_POPOVER_LINK_CHANGED_SIGNAL] = g_signal_new ("link-changed", COMPOSER_TYPE_LINK_POPOVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOXED_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_URI, G_TYPE_BOOLEAN);
#line 828 "composer-link-popover.c"
	/** Emitted when the link URL was activated. */
#line 21 "../src/client/composer/composer-link-popover.vala"
	composer_link_popover_signals[COMPOSER_LINK_POPOVER_LINK_ACTIVATE_SIGNAL] = g_signal_new ("link-activate", COMPOSER_TYPE_LINK_POPOVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 832 "composer-link-popover.c"
	/** Emitted when the delete button was activated. */
#line 21 "../src/client/composer/composer-link-popover.vala"
	composer_link_popover_signals[COMPOSER_LINK_POPOVER_LINK_DELETE_SIGNAL] = g_signal_new ("link-delete", COMPOSER_TYPE_LINK_POPOVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 21 "../src/client/composer/composer-link-popover.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "url", FALSE, ComposerLinkPopover_private_offset + G_STRUCT_OFFSET (ComposerLinkPopoverPrivate, url));
#line 21 "../src/client/composer/composer-link-popover.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "insert", FALSE, ComposerLinkPopover_private_offset + G_STRUCT_OFFSET (ComposerLinkPopoverPrivate, insert));
#line 21 "../src/client/composer/composer-link-popover.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "update", FALSE, ComposerLinkPopover_private_offset + G_STRUCT_OFFSET (ComposerLinkPopoverPrivate, update));
#line 21 "../src/client/composer/composer-link-popover.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "remove", FALSE, ComposerLinkPopover_private_offset + G_STRUCT_OFFSET (ComposerLinkPopoverPrivate, remove));
#line 21 "../src/client/composer/composer-link-popover.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_url_changed", G_CALLBACK(_composer_link_popover_on_url_changed_gtk_editable_changed));
#line 21 "../src/client/composer/composer-link-popover.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_activate_popover", G_CALLBACK(_composer_link_popover_on_activate_popover_gtk_button_clicked));
#line 21 "../src/client/composer/composer-link-popover.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_remove_clicked", G_CALLBACK(_composer_link_popover_on_remove_clicked_gtk_button_clicked));
#line 850 "composer-link-popover.c"
}

static void
composer_link_popover_instance_init (ComposerLinkPopover * self,
                                     gpointer klass)
{
#line 21 "../src/client/composer/composer-link-popover.vala"
	self->priv = composer_link_popover_get_instance_private (self);
#line 21 "../src/client/composer/composer-link-popover.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 861 "composer-link-popover.c"
}

static void
composer_link_popover_finalize (GObject * obj)
{
	ComposerLinkPopover * self;
#line 21 "../src/client/composer/composer-link-popover.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, COMPOSER_TYPE_LINK_POPOVER, ComposerLinkPopover);
#line 51 "../src/client/composer/composer-link-popover.vala"
	_g_object_unref0 (self->priv->validation_timeout);
#line 21 "../src/client/composer/composer-link-popover.vala"
	G_OBJECT_CLASS (composer_link_popover_parent_class)->finalize (obj);
#line 874 "composer-link-popover.c"
}

/**
 * A popover for editing a link in the composer.
 *
 * The exact appearance of the popover will depend on the {@link
 * Type} passed to the constructor:
 *
 *  * For {@link Type.NEW_LINK}, the user will be presented with an
 *    insert button and an open button.
 *  * For {@link Type.EXISTING_LINK}, the user will be presented with
 *    an update, delete and open buttons.
 */
static GType
composer_link_popover_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ComposerLinkPopoverClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) composer_link_popover_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ComposerLinkPopover), 0, (GInstanceInitFunc) composer_link_popover_instance_init, NULL };
	GType composer_link_popover_type_id;
	composer_link_popover_type_id = g_type_register_static (gtk_popover_get_type (), "ComposerLinkPopover", &g_define_type_info, 0);
	ComposerLinkPopover_private_offset = g_type_add_instance_private (composer_link_popover_type_id, sizeof (ComposerLinkPopoverPrivate));
	return composer_link_popover_type_id;
}

GType
composer_link_popover_get_type (void)
{
	static volatile gsize composer_link_popover_type_id__once = 0;
	if (g_once_init_enter (&composer_link_popover_type_id__once)) {
		GType composer_link_popover_type_id;
		composer_link_popover_type_id = composer_link_popover_get_type_once ();
		g_once_init_leave (&composer_link_popover_type_id__once, composer_link_popover_type_id);
	}
	return composer_link_popover_type_id__once;
}

static void
_vala_composer_link_popover_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	ComposerLinkPopover * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, COMPOSER_TYPE_LINK_POPOVER, ComposerLinkPopover);
#line 21 "../src/client/composer/composer-link-popover.vala"
	switch (property_id) {
#line 21 "../src/client/composer/composer-link-popover.vala"
		case COMPOSER_LINK_POPOVER_LINK_URI_PROPERTY:
#line 21 "../src/client/composer/composer-link-popover.vala"
		g_value_set_string (value, composer_link_popover_get_link_uri (self));
#line 21 "../src/client/composer/composer-link-popover.vala"
		break;
#line 926 "composer-link-popover.c"
		default:
#line 21 "../src/client/composer/composer-link-popover.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/client/composer/composer-link-popover.vala"
		break;
#line 932 "composer-link-popover.c"
	}
}

