/* contact-entry-completion.c generated by valac 0.56.17, the Vala compiler
 * generated from contact-entry-completion.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2019 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-client-46.0.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include "geary-engine.h"

#define CONTACT_ENTRY_COMPLETION_VISIBILITY_THRESHOLD GEARY_CONTACT_IMPORTANCE_RECEIVED_FROM
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	CONTACT_ENTRY_COMPLETION_0_PROPERTY,
	CONTACT_ENTRY_COMPLETION_NUM_PROPERTIES
};
static GParamSpec* contact_entry_completion_properties[CONTACT_ENTRY_COMPLETION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GtkTreeIter_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreeIter_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ContactEntryCompletionSearchContactsData ContactEntryCompletionSearchContactsData;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _ContactEntryCompletionPrivate {
	ApplicationContactStore* contacts;
	gchar* current_key;
	GeeArrayList* address_parts;
	gint cursor_at_address;
	GCancellable* search_cancellable;
	GtkTreeIter* last_iter;
};

struct _ContactEntryCompletionSearchContactsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ContactEntryCompletion* self;
	gchar* query;
	GCancellable* cancellable;
	GeeCollection* results;
	GeeCollection* _tmp0_;
	ApplicationContactStore* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GError* err;
	GError* _tmp4_;
	const gchar* _tmp5_;
	GtkListStore* model;
	GtkListStore* _tmp6_;
	GeeIterator* _contact_it;
	GeeCollection* _tmp7_;
	GeeIterator* _tmp8_;
	GeeIterator* _tmp9_;
	ApplicationContact* contact;
	GeeIterator* _tmp10_;
	gpointer _tmp11_;
	GeeIterator* _addr_it;
	ApplicationContact* _tmp12_;
	GeeCollection* _tmp13_;
	GeeCollection* _tmp14_;
	GeeIterator* _tmp15_;
	GeeIterator* _tmp16_;
	GearyRFC822MailboxAddress* addr;
	GeeIterator* _tmp17_;
	gpointer _tmp18_;
	GtkTreeIter iter;
	GtkListStore* _tmp19_;
	GtkTreeIter _tmp20_;
	GtkListStore* _tmp21_;
	GtkTreeIter _tmp22_;
	ApplicationContact* _tmp23_;
	GtkListStore* _tmp24_;
	GtkTreeIter _tmp25_;
	GearyRFC822MailboxAddress* _tmp26_;
	GtkListStore* _tmp27_;
	GError* _inner_error0_;
};

static gint ContactEntryCompletion_private_offset;
static gpointer contact_entry_completion_parent_class = NULL;
static GearyBaseInterfaceIface * contact_entry_completion_geary_base_interface_parent_iface = NULL;

static void _vala_GtkTreeIter_free (GtkTreeIter* self);
static inline GtkListStore* contact_entry_completion_new_model (ContactEntryCompletion* self);
static gboolean __lambda20_ (ContactEntryCompletion* self);
static gboolean ___lambda20__gtk_entry_completion_match_func (GtkEntryCompletion* completion,
                                                       const gchar* key,
                                                       GtkTreeIter* iter,
                                                       gpointer self);
static void contact_entry_completion_cell_icon_data (ContactEntryCompletion* self,
                                              GtkCellLayout* cell_layout,
                                              GtkCellRenderer* cell,
                                              GtkTreeModel* tree_model,
                                              GtkTreeIter* iter);
static void _contact_entry_completion_cell_icon_data_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                         GtkCellRenderer* cell,
                                                                         GtkTreeModel* tree_model,
                                                                         GtkTreeIter* iter,
                                                                         gpointer self);
static void contact_entry_completion_cell_text_data (ContactEntryCompletion* self,
                                              GtkCellLayout* cell_layout,
                                              GtkCellRenderer* cell,
                                              GtkTreeModel* tree_model,
                                              GtkTreeIter* iter);
static void _contact_entry_completion_cell_text_data_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                         GtkCellRenderer* cell,
                                                                         GtkTreeModel* tree_model,
                                                                         GtkTreeIter* iter,
                                                                         gpointer self);
static gboolean contact_entry_completion_on_match_selected (ContactEntryCompletion* self,
                                                     GtkTreeModel* model,
                                                     GtkTreeIter* iter);
static gboolean _contact_entry_completion_on_match_selected_gtk_entry_completion_match_selected (GtkEntryCompletion* _sender,
                                                                                          GtkTreeModel* model,
                                                                                          GtkTreeIter* iter,
                                                                                          gpointer self);
static gboolean contact_entry_completion_on_cursor_on_match (ContactEntryCompletion* self,
                                                      GtkTreeModel* model,
                                                      GtkTreeIter* iter);
static gboolean _contact_entry_completion_on_cursor_on_match_gtk_entry_completion_cursor_on_match (GtkEntryCompletion* _sender,
                                                                                            GtkTreeModel* model,
                                                                                            GtkTreeIter* iter,
                                                                                            gpointer self);
static void contact_entry_completion_update_addresses (ContactEntryCompletion* self);
static void contact_entry_completion_search_contacts (ContactEntryCompletion* self,
                                               const gchar* query,
                                               GCancellable* cancellable,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
static void contact_entry_completion_search_contacts_finish (ContactEntryCompletion* self,
                                                      GAsyncResult* _res_);
static void contact_entry_completion_insert_address_at_cursor (ContactEntryCompletion* self,
                                                        GtkTreeIter* iter);
static gint ____lambda21_ (ContactEntryCompletion* self,
                    gchar* a,
                    gint chars);
static gpointer _____lambda21__gee_fold_func (gpointer g,
                                       gpointer a,
                                       gpointer self);
static void contact_entry_completion_search_contacts_data_free (gpointer _data);
static gboolean contact_entry_completion_search_contacts_co (ContactEntryCompletionSearchContactsData* _data_);
static void contact_entry_completion_search_contacts_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_);
static gchar* contact_entry_completion_match_prefix_contact (ContactEntryCompletion* self,
                                                      GearyRFC822MailboxAddress* mailbox);
static gchar* contact_entry_completion_match_prefix_string (ContactEntryCompletion* self,
                                                     const gchar* haystack);
static gboolean contact_entry_completion_eval_callback (ContactEntryCompletion* self,
                                                 GMatchInfo* match_info,
                                                 GString* _result_);
static gboolean _contact_entry_completion_eval_callback_gregex_eval_callback (GMatchInfo* match_info,
                                                                       GString* _result_,
                                                                       gpointer self);
static GtkTreeIter* _vala_GtkTreeIter_copy (GtkTreeIter* self);
static void contact_entry_completion_finalize (GObject * obj);
static GType contact_entry_completion_get_type_once (void);

static inline gpointer
contact_entry_completion_get_instance_private (ContactEntryCompletion* self)
{
	return G_STRUCT_MEMBER_P (self, ContactEntryCompletion_private_offset);
}

GType*
contact_entry_completion_column_get_types (gint* result_length1)
{
	GType* _tmp0_;
	GType* _tmp1_;
	gint _tmp1__length1;
	GType* result;
#line 22 "../src/client/composer/contact-entry-completion.vala"
	_tmp0_ = g_new0 (GType, 2);
#line 22 "../src/client/composer/contact-entry-completion.vala"
	_tmp0_[0] = APPLICATION_TYPE_CONTACT;
#line 22 "../src/client/composer/contact-entry-completion.vala"
	_tmp0_[1] = GEARY_RF_C822_TYPE_MAILBOX_ADDRESS;
#line 22 "../src/client/composer/contact-entry-completion.vala"
	_tmp1_ = _tmp0_;
#line 22 "../src/client/composer/contact-entry-completion.vala"
	_tmp1__length1 = 2;
#line 22 "../src/client/composer/contact-entry-completion.vala"
	if (result_length1) {
#line 22 "../src/client/composer/contact-entry-completion.vala"
		*result_length1 = _tmp1__length1;
#line 208 "contact-entry-completion.c"
	}
#line 22 "../src/client/composer/contact-entry-completion.vala"
	result = _tmp1_;
#line 22 "../src/client/composer/contact-entry-completion.vala"
	return result;
#line 214 "contact-entry-completion.c"
}

static GType
contact_entry_completion_column_get_type_once (void)
{
	static const GEnumValue values[] = {{CONTACT_ENTRY_COMPLETION_COLUMN_CONTACT, "CONTACT_ENTRY_COMPLETION_COLUMN_CONTACT", "contact"}, {CONTACT_ENTRY_COMPLETION_COLUMN_MAILBOX, "CONTACT_ENTRY_COMPLETION_COLUMN_MAILBOX", "mailbox"}, {0, NULL, NULL}};
	GType contact_entry_completion_column_type_id;
	contact_entry_completion_column_type_id = g_enum_register_static ("ContactEntryCompletionColumn", values);
	return contact_entry_completion_column_type_id;
}

GType
contact_entry_completion_column_get_type (void)
{
	static volatile gsize contact_entry_completion_column_type_id__once = 0;
	if (g_once_init_enter (&contact_entry_completion_column_type_id__once)) {
		GType contact_entry_completion_column_type_id;
		contact_entry_completion_column_type_id = contact_entry_completion_column_get_type_once ();
		g_once_init_leave (&contact_entry_completion_column_type_id__once, contact_entry_completion_column_type_id);
	}
	return contact_entry_completion_column_type_id__once;
}

static void
_vala_GtkTreeIter_free (GtkTreeIter* self)
{
#line 43 "../src/client/composer/contact-entry-completion.vala"
	g_boxed_free (gtk_tree_iter_get_type (), self);
#line 243 "contact-entry-completion.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 48 "../src/client/composer/contact-entry-completion.vala"
	return self ? g_object_ref (self) : NULL;
#line 251 "contact-entry-completion.c"
}

static gboolean
__lambda20_ (ContactEntryCompletion* self)
{
	gboolean result;
#line 53 "../src/client/composer/contact-entry-completion.vala"
	result = TRUE;
#line 53 "../src/client/composer/contact-entry-completion.vala"
	return result;
#line 262 "contact-entry-completion.c"
}

static gboolean
___lambda20__gtk_entry_completion_match_func (GtkEntryCompletion* completion,
                                              const gchar* key,
                                              GtkTreeIter* iter,
                                              gpointer self)
{
	gboolean result;
	result = __lambda20_ ((ContactEntryCompletion*) self);
#line 53 "../src/client/composer/contact-entry-completion.vala"
	return result;
#line 275 "contact-entry-completion.c"
}

static void
_contact_entry_completion_cell_icon_data_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                    GtkCellRenderer* cell,
                                                                    GtkTreeModel* tree_model,
                                                                    GtkTreeIter* iter,
                                                                    gpointer self)
{
#line 59 "../src/client/composer/contact-entry-completion.vala"
	contact_entry_completion_cell_icon_data ((ContactEntryCompletion*) self, cell_layout, cell, tree_model, iter);
#line 287 "contact-entry-completion.c"
}

static void
_contact_entry_completion_cell_text_data_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                    GtkCellRenderer* cell,
                                                                    GtkTreeModel* tree_model,
                                                                    GtkTreeIter* iter,
                                                                    gpointer self)
{
#line 64 "../src/client/composer/contact-entry-completion.vala"
	contact_entry_completion_cell_text_data ((ContactEntryCompletion*) self, cell_layout, cell, tree_model, iter);
#line 299 "contact-entry-completion.c"
}

static gboolean
_contact_entry_completion_on_match_selected_gtk_entry_completion_match_selected (GtkEntryCompletion* _sender,
                                                                                 GtkTreeModel* model,
                                                                                 GtkTreeIter* iter,
                                                                                 gpointer self)
{
	gboolean result;
	result = contact_entry_completion_on_match_selected ((ContactEntryCompletion*) self, model, iter);
#line 69 "../src/client/composer/contact-entry-completion.vala"
	return result;
#line 312 "contact-entry-completion.c"
}

static gboolean
_contact_entry_completion_on_cursor_on_match_gtk_entry_completion_cursor_on_match (GtkEntryCompletion* _sender,
                                                                                   GtkTreeModel* model,
                                                                                   GtkTreeIter* iter,
                                                                                   gpointer self)
{
	gboolean result;
	result = contact_entry_completion_on_cursor_on_match ((ContactEntryCompletion*) self, model, iter);
#line 70 "../src/client/composer/contact-entry-completion.vala"
	return result;
#line 325 "contact-entry-completion.c"
}

ContactEntryCompletion*
contact_entry_completion_construct (GType object_type,
                                    ApplicationContactStore* contacts)
{
	ContactEntryCompletion * self = NULL;
	ApplicationContactStore* _tmp0_;
	GtkListStore* _tmp1_;
	GtkListStore* _tmp2_;
	GtkCellRendererPixbuf* icon_renderer = NULL;
	GtkCellRendererPixbuf* _tmp3_;
	GtkCellRendererText* text_renderer = NULL;
	GtkCellRendererText* _tmp4_;
#line 46 "../src/client/composer/contact-entry-completion.vala"
	g_return_val_if_fail (APPLICATION_IS_CONTACT_STORE (contacts), NULL);
#line 46 "../src/client/composer/contact-entry-completion.vala"
	self = (ContactEntryCompletion*) g_object_new (object_type, NULL);
#line 47 "../src/client/composer/contact-entry-completion.vala"
	geary_base_interface_base_ref (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_BASE_INTERFACE, GearyBaseInterface));
#line 48 "../src/client/composer/contact-entry-completion.vala"
	_tmp0_ = _g_object_ref0 (contacts);
#line 48 "../src/client/composer/contact-entry-completion.vala"
	_g_object_unref0 (self->priv->contacts);
#line 48 "../src/client/composer/contact-entry-completion.vala"
	self->priv->contacts = _tmp0_;
#line 49 "../src/client/composer/contact-entry-completion.vala"
	_tmp1_ = contact_entry_completion_new_model (self);
#line 49 "../src/client/composer/contact-entry-completion.vala"
	_tmp2_ = _tmp1_;
#line 49 "../src/client/composer/contact-entry-completion.vala"
	gtk_entry_completion_set_model (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_completion_get_type (), GtkEntryCompletion), G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_tree_model_get_type (), GtkTreeModel));
#line 49 "../src/client/composer/contact-entry-completion.vala"
	_g_object_unref0 (_tmp2_);
#line 53 "../src/client/composer/contact-entry-completion.vala"
	gtk_entry_completion_set_match_func (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_completion_get_type (), GtkEntryCompletion), ___lambda20__gtk_entry_completion_match_func, g_object_ref (self), g_object_unref);
#line 55 "../src/client/composer/contact-entry-completion.vala"
	_tmp3_ = (GtkCellRendererPixbuf*) gtk_cell_renderer_pixbuf_new ();
#line 55 "../src/client/composer/contact-entry-completion.vala"
	g_object_ref_sink (_tmp3_);
#line 55 "../src/client/composer/contact-entry-completion.vala"
	icon_renderer = _tmp3_;
#line 56 "../src/client/composer/contact-entry-completion.vala"
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (icon_renderer, gtk_cell_renderer_get_type (), GtkCellRenderer), "xpad", (guint) 2, NULL);
#line 57 "../src/client/composer/contact-entry-completion.vala"
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (icon_renderer, gtk_cell_renderer_get_type (), GtkCellRenderer), "ypad", (guint) 2, NULL);
#line 58 "../src/client/composer/contact-entry-completion.vala"
	gtk_cell_layout_pack_start (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_cell_layout_get_type (), GtkCellLayout), G_TYPE_CHECK_INSTANCE_CAST (icon_renderer, gtk_cell_renderer_get_type (), GtkCellRenderer), FALSE);
#line 59 "../src/client/composer/contact-entry-completion.vala"
	gtk_cell_layout_set_cell_data_func (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_cell_layout_get_type (), GtkCellLayout), G_TYPE_CHECK_INSTANCE_CAST (icon_renderer, gtk_cell_renderer_get_type (), GtkCellRenderer), _contact_entry_completion_cell_icon_data_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
#line 61 "../src/client/composer/contact-entry-completion.vala"
	_tmp4_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 61 "../src/client/composer/contact-entry-completion.vala"
	g_object_ref_sink (_tmp4_);
#line 61 "../src/client/composer/contact-entry-completion.vala"
	text_renderer = _tmp4_;
#line 62 "../src/client/composer/contact-entry-completion.vala"
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (icon_renderer, gtk_cell_renderer_get_type (), GtkCellRenderer), "ypad", (guint) 2, NULL);
#line 63 "../src/client/composer/contact-entry-completion.vala"
	gtk_cell_layout_pack_start (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_cell_layout_get_type (), GtkCellLayout), G_TYPE_CHECK_INSTANCE_CAST (text_renderer, gtk_cell_renderer_get_type (), GtkCellRenderer), TRUE);
#line 64 "../src/client/composer/contact-entry-completion.vala"
	gtk_cell_layout_set_cell_data_func (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_cell_layout_get_type (), GtkCellLayout), G_TYPE_CHECK_INSTANCE_CAST (text_renderer, gtk_cell_renderer_get_type (), GtkCellRenderer), _contact_entry_completion_cell_text_data_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
#line 67 "../src/client/composer/contact-entry-completion.vala"
	gtk_entry_completion_set_inline_selection (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_completion_get_type (), GtkEntryCompletion), TRUE);
#line 69 "../src/client/composer/contact-entry-completion.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_completion_get_type (), GtkEntryCompletion), "match-selected", (GCallback) _contact_entry_completion_on_match_selected_gtk_entry_completion_match_selected, self, 0);
#line 70 "../src/client/composer/contact-entry-completion.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_completion_get_type (), GtkEntryCompletion), "cursor-on-match", (GCallback) _contact_entry_completion_on_cursor_on_match_gtk_entry_completion_cursor_on_match, self, 0);
#line 46 "../src/client/composer/contact-entry-completion.vala"
	_g_object_unref0 (text_renderer);
#line 46 "../src/client/composer/contact-entry-completion.vala"
	_g_object_unref0 (icon_renderer);
#line 46 "../src/client/composer/contact-entry-completion.vala"
	return self;
#line 400 "contact-entry-completion.c"
}

ContactEntryCompletion*
contact_entry_completion_new (ApplicationContactStore* contacts)
{
#line 46 "../src/client/composer/contact-entry-completion.vala"
	return contact_entry_completion_construct (TYPE_CONTACT_ENTRY_COMPLETION, contacts);
#line 408 "contact-entry-completion.c"
}

void
contact_entry_completion_update_model (ContactEntryCompletion* self)
{
	GCancellable* _tmp0_;
	GtkListStore* model = NULL;
	GtkTreeModel* _tmp2_;
	GtkTreeModel* _tmp3_;
	GtkListStore* _tmp4_;
	gchar* completion_key = NULL;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
#line 77 "../src/client/composer/contact-entry-completion.vala"
	g_return_if_fail (IS_CONTACT_ENTRY_COMPLETION (self));
#line 78 "../src/client/composer/contact-entry-completion.vala"
	__vala_GtkTreeIter_free0 (self->priv->last_iter);
#line 78 "../src/client/composer/contact-entry-completion.vala"
	self->priv->last_iter = NULL;
#line 80 "../src/client/composer/contact-entry-completion.vala"
	contact_entry_completion_update_addresses (self);
#line 82 "../src/client/composer/contact-entry-completion.vala"
	_tmp0_ = self->priv->search_cancellable;
#line 82 "../src/client/composer/contact-entry-completion.vala"
	if (_tmp0_ != NULL) {
#line 435 "contact-entry-completion.c"
		GCancellable* _tmp1_;
#line 83 "../src/client/composer/contact-entry-completion.vala"
		_tmp1_ = self->priv->search_cancellable;
#line 83 "../src/client/composer/contact-entry-completion.vala"
		g_cancellable_cancel (_tmp1_);
#line 84 "../src/client/composer/contact-entry-completion.vala"
		_g_object_unref0 (self->priv->search_cancellable);
#line 84 "../src/client/composer/contact-entry-completion.vala"
		self->priv->search_cancellable = NULL;
#line 445 "contact-entry-completion.c"
	}
#line 87 "../src/client/composer/contact-entry-completion.vala"
	_tmp2_ = gtk_entry_completion_get_model (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_completion_get_type (), GtkEntryCompletion));
#line 87 "../src/client/composer/contact-entry-completion.vala"
	_tmp3_ = _tmp2_;
#line 87 "../src/client/composer/contact-entry-completion.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_list_store_get_type (), GtkListStore));
#line 87 "../src/client/composer/contact-entry-completion.vala"
	model = _tmp4_;
#line 88 "../src/client/composer/contact-entry-completion.vala"
	_tmp5_ = self->priv->current_key;
#line 88 "../src/client/composer/contact-entry-completion.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 88 "../src/client/composer/contact-entry-completion.vala"
	completion_key = _tmp6_;
#line 89 "../src/client/composer/contact-entry-completion.vala"
	_tmp7_ = completion_key;
#line 89 "../src/client/composer/contact-entry-completion.vala"
	if (!geary_string_is_empty_or_whitespace (_tmp7_)) {
#line 465 "contact-entry-completion.c"
		GCancellable* _tmp8_;
		const gchar* _tmp9_;
		GCancellable* _tmp10_;
#line 90 "../src/client/composer/contact-entry-completion.vala"
		_tmp8_ = g_cancellable_new ();
#line 90 "../src/client/composer/contact-entry-completion.vala"
		_g_object_unref0 (self->priv->search_cancellable);
#line 90 "../src/client/composer/contact-entry-completion.vala"
		self->priv->search_cancellable = _tmp8_;
#line 91 "../src/client/composer/contact-entry-completion.vala"
		_tmp9_ = completion_key;
#line 91 "../src/client/composer/contact-entry-completion.vala"
		_tmp10_ = self->priv->search_cancellable;
#line 91 "../src/client/composer/contact-entry-completion.vala"
		contact_entry_completion_search_contacts (self, _tmp9_, _tmp10_, NULL, NULL);
#line 481 "contact-entry-completion.c"
	} else {
		GtkListStore* _tmp11_;
#line 93 "../src/client/composer/contact-entry-completion.vala"
		_tmp11_ = model;
#line 93 "../src/client/composer/contact-entry-completion.vala"
		gtk_list_store_clear (_tmp11_);
#line 488 "contact-entry-completion.c"
	}
#line 77 "../src/client/composer/contact-entry-completion.vala"
	_g_free0 (completion_key);
#line 77 "../src/client/composer/contact-entry-completion.vala"
	_g_object_unref0 (model);
#line 494 "contact-entry-completion.c"
}

void
contact_entry_completion_trigger_selection (ContactEntryCompletion* self)
{
	GtkTreeIter* _tmp0_;
#line 97 "../src/client/composer/contact-entry-completion.vala"
	g_return_if_fail (IS_CONTACT_ENTRY_COMPLETION (self));
#line 98 "../src/client/composer/contact-entry-completion.vala"
	_tmp0_ = self->priv->last_iter;
#line 98 "../src/client/composer/contact-entry-completion.vala"
	if (_tmp0_ != NULL) {
#line 507 "contact-entry-completion.c"
		GtkTreeIter* _tmp1_;
		GtkTreeIter _tmp2_;
#line 99 "../src/client/composer/contact-entry-completion.vala"
		_tmp1_ = self->priv->last_iter;
#line 99 "../src/client/composer/contact-entry-completion.vala"
		_tmp2_ = *_tmp1_;
#line 99 "../src/client/composer/contact-entry-completion.vala"
		contact_entry_completion_insert_address_at_cursor (self, &_tmp2_);
#line 100 "../src/client/composer/contact-entry-completion.vala"
		__vala_GtkTreeIter_free0 (self->priv->last_iter);
#line 100 "../src/client/composer/contact-entry-completion.vala"
		self->priv->last_iter = NULL;
#line 520 "contact-entry-completion.c"
	}
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1302 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1303 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1304 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 537 "contact-entry-completion.c"
		gchar* _tmp0_;
#line 1305 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1305 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1306 "glib-2.0.vapi"
		result = TRUE;
#line 1306 "glib-2.0.vapi"
		if (c) {
#line 1306 "glib-2.0.vapi"
			*c = _vala_c;
#line 549 "contact-entry-completion.c"
		}
#line 1306 "glib-2.0.vapi"
		return result;
#line 553 "contact-entry-completion.c"
	} else {
#line 1308 "glib-2.0.vapi"
		result = FALSE;
#line 1308 "glib-2.0.vapi"
		if (c) {
#line 1308 "glib-2.0.vapi"
			*c = _vala_c;
#line 561 "contact-entry-completion.c"
		}
#line 1308 "glib-2.0.vapi"
		return result;
#line 565 "contact-entry-completion.c"
	}
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 593 "contact-entry-completion.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 599 "contact-entry-completion.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 605 "contact-entry-completion.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 609 "contact-entry-completion.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 617 "contact-entry-completion.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 621 "contact-entry-completion.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 633 "contact-entry-completion.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 654 "contact-entry-completion.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 677 "contact-entry-completion.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 686 "contact-entry-completion.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 705 "contact-entry-completion.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 709 "contact-entry-completion.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 715 "contact-entry-completion.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 725 "contact-entry-completion.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 733 "contact-entry-completion.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 737 "contact-entry-completion.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 743 "contact-entry-completion.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 753 "contact-entry-completion.c"
}

static void
contact_entry_completion_update_addresses (ContactEntryCompletion* self)
{
	GtkEntry* entry = NULL;
	GtkWidget* _tmp0_;
	GtkEntry* _tmp1_;
	GtkEntry* _tmp2_;
#line 104 "../src/client/composer/contact-entry-completion.vala"
	g_return_if_fail (IS_CONTACT_ENTRY_COMPLETION (self));
#line 105 "../src/client/composer/contact-entry-completion.vala"
	_tmp0_ = gtk_entry_completion_get_entry (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_completion_get_type (), GtkEntryCompletion));
#line 105 "../src/client/composer/contact-entry-completion.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_entry_get_type ()) ? ((GtkEntry*) _tmp0_) : NULL);
#line 105 "../src/client/composer/contact-entry-completion.vala"
	entry = _tmp1_;
#line 106 "../src/client/composer/contact-entry-completion.vala"
	_tmp2_ = entry;
#line 106 "../src/client/composer/contact-entry-completion.vala"
	if (_tmp2_ != NULL) {
#line 775 "contact-entry-completion.c"
		gchar* _tmp3_;
		GeeArrayList* _tmp4_;
		gchar* text = NULL;
		GtkEntry* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gint cursor_pos = 0;
		GtkEntry* _tmp8_;
		gint current_char = 0;
		gunichar c = 0U;
		gint start_idx = 0;
		gint next_idx = 0;
		gboolean in_quote = FALSE;
		gchar* address = NULL;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		GeeArrayList* _tmp27_;
		const gchar* _tmp28_;
#line 107 "../src/client/composer/contact-entry-completion.vala"
		_tmp3_ = g_strdup ("");
#line 107 "../src/client/composer/contact-entry-completion.vala"
		_g_free0 (self->priv->current_key);
#line 107 "../src/client/composer/contact-entry-completion.vala"
		self->priv->current_key = _tmp3_;
#line 108 "../src/client/composer/contact-entry-completion.vala"
		self->priv->cursor_at_address = 0;
#line 109 "../src/client/composer/contact-entry-completion.vala"
		_tmp4_ = self->priv->address_parts;
#line 109 "../src/client/composer/contact-entry-completion.vala"
		gee_abstract_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 116 "../src/client/composer/contact-entry-completion.vala"
		_tmp5_ = entry;
#line 116 "../src/client/composer/contact-entry-completion.vala"
		_tmp6_ = gtk_entry_get_text (_tmp5_);
#line 116 "../src/client/composer/contact-entry-completion.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 116 "../src/client/composer/contact-entry-completion.vala"
		text = _tmp7_;
#line 117 "../src/client/composer/contact-entry-completion.vala"
		_tmp8_ = entry;
#line 117 "../src/client/composer/contact-entry-completion.vala"
		cursor_pos = gtk_editable_get_position (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_editable_get_type (), GtkEditable));
#line 119 "../src/client/composer/contact-entry-completion.vala"
		current_char = 0;
#line 120 "../src/client/composer/contact-entry-completion.vala"
		c = (gunichar) 0;
#line 121 "../src/client/composer/contact-entry-completion.vala"
		start_idx = 0;
#line 122 "../src/client/composer/contact-entry-completion.vala"
		next_idx = 0;
#line 123 "../src/client/composer/contact-entry-completion.vala"
		in_quote = FALSE;
#line 124 "../src/client/composer/contact-entry-completion.vala"
		while (TRUE) {
#line 830 "contact-entry-completion.c"
			const gchar* _tmp9_;
			gunichar _tmp10_ = 0U;
			gboolean _tmp11_;
			gboolean _tmp12_ = FALSE;
			gint _tmp24_;
#line 124 "../src/client/composer/contact-entry-completion.vala"
			_tmp9_ = text;
#line 124 "../src/client/composer/contact-entry-completion.vala"
			_tmp11_ = string_get_next_char (_tmp9_, &next_idx, &_tmp10_);
#line 124 "../src/client/composer/contact-entry-completion.vala"
			c = _tmp10_;
#line 124 "../src/client/composer/contact-entry-completion.vala"
			if (!_tmp11_) {
#line 124 "../src/client/composer/contact-entry-completion.vala"
				break;
#line 846 "contact-entry-completion.c"
			}
#line 125 "../src/client/composer/contact-entry-completion.vala"
			if (current_char == cursor_pos) {
#line 126 "../src/client/composer/contact-entry-completion.vala"
				_tmp12_ = current_char != 0;
#line 852 "contact-entry-completion.c"
			} else {
#line 125 "../src/client/composer/contact-entry-completion.vala"
				_tmp12_ = FALSE;
#line 856 "contact-entry-completion.c"
			}
#line 125 "../src/client/composer/contact-entry-completion.vala"
			if (_tmp12_) {
#line 860 "contact-entry-completion.c"
				GeeArrayList* _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
#line 127 "../src/client/composer/contact-entry-completion.vala"
				if (c != ((gunichar) ',')) {
#line 866 "contact-entry-completion.c"
					const gchar* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
#line 130 "../src/client/composer/contact-entry-completion.vala"
					_tmp13_ = text;
#line 130 "../src/client/composer/contact-entry-completion.vala"
					_tmp14_ = string_slice (_tmp13_, (glong) start_idx, (glong) next_idx);
#line 130 "../src/client/composer/contact-entry-completion.vala"
					_tmp15_ = _tmp14_;
#line 130 "../src/client/composer/contact-entry-completion.vala"
					_tmp16_ = string_strip (_tmp15_);
#line 130 "../src/client/composer/contact-entry-completion.vala"
					_g_free0 (self->priv->current_key);
#line 130 "../src/client/composer/contact-entry-completion.vala"
					self->priv->current_key = _tmp16_;
#line 130 "../src/client/composer/contact-entry-completion.vala"
					_g_free0 (_tmp15_);
#line 885 "contact-entry-completion.c"
				}
#line 137 "../src/client/composer/contact-entry-completion.vala"
				_tmp17_ = self->priv->address_parts;
#line 137 "../src/client/composer/contact-entry-completion.vala"
				_tmp18_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 137 "../src/client/composer/contact-entry-completion.vala"
				_tmp19_ = _tmp18_;
#line 137 "../src/client/composer/contact-entry-completion.vala"
				self->priv->cursor_at_address = _tmp19_;
#line 895 "contact-entry-completion.c"
			}
#line 140 "../src/client/composer/contact-entry-completion.vala"
			switch (c) {
#line 140 "../src/client/composer/contact-entry-completion.vala"
				case ',':
#line 901 "contact-entry-completion.c"
				{
#line 142 "../src/client/composer/contact-entry-completion.vala"
					if (!in_quote) {
#line 905 "contact-entry-completion.c"
						gchar* address = NULL;
						const gchar* _tmp20_;
						gchar* _tmp21_;
						GeeArrayList* _tmp22_;
						const gchar* _tmp23_;
#line 144 "../src/client/composer/contact-entry-completion.vala"
						_tmp20_ = text;
#line 144 "../src/client/composer/contact-entry-completion.vala"
						_tmp21_ = string_slice (_tmp20_, (glong) start_idx, (glong) (next_idx - 1));
#line 144 "../src/client/composer/contact-entry-completion.vala"
						address = _tmp21_;
#line 145 "../src/client/composer/contact-entry-completion.vala"
						_tmp22_ = self->priv->address_parts;
#line 145 "../src/client/composer/contact-entry-completion.vala"
						_tmp23_ = address;
#line 145 "../src/client/composer/contact-entry-completion.vala"
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp23_);
#line 147 "../src/client/composer/contact-entry-completion.vala"
						start_idx = next_idx;
#line 142 "../src/client/composer/contact-entry-completion.vala"
						_g_free0 (address);
#line 927 "contact-entry-completion.c"
					}
#line 149 "../src/client/composer/contact-entry-completion.vala"
					break;
#line 931 "contact-entry-completion.c"
				}
#line 140 "../src/client/composer/contact-entry-completion.vala"
				case '"':
#line 935 "contact-entry-completion.c"
				{
#line 152 "../src/client/composer/contact-entry-completion.vala"
					in_quote = !in_quote;
#line 153 "../src/client/composer/contact-entry-completion.vala"
					break;
#line 941 "contact-entry-completion.c"
				}
				default:
#line 140 "../src/client/composer/contact-entry-completion.vala"
				break;
#line 946 "contact-entry-completion.c"
			}
#line 156 "../src/client/composer/contact-entry-completion.vala"
			_tmp24_ = current_char;
#line 156 "../src/client/composer/contact-entry-completion.vala"
			current_char = _tmp24_ + 1;
#line 952 "contact-entry-completion.c"
		}
#line 160 "../src/client/composer/contact-entry-completion.vala"
		_tmp25_ = text;
#line 160 "../src/client/composer/contact-entry-completion.vala"
		_tmp26_ = string_substring (_tmp25_, (glong) start_idx, (glong) -1);
#line 160 "../src/client/composer/contact-entry-completion.vala"
		address = _tmp26_;
#line 161 "../src/client/composer/contact-entry-completion.vala"
		_tmp27_ = self->priv->address_parts;
#line 161 "../src/client/composer/contact-entry-completion.vala"
		_tmp28_ = address;
#line 161 "../src/client/composer/contact-entry-completion.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp28_);
#line 106 "../src/client/composer/contact-entry-completion.vala"
		_g_free0 (address);
#line 106 "../src/client/composer/contact-entry-completion.vala"
		_g_free0 (text);
#line 970 "contact-entry-completion.c"
	}
#line 104 "../src/client/composer/contact-entry-completion.vala"
	_g_object_unref0 (entry);
#line 974 "contact-entry-completion.c"
}

static gint
____lambda21_ (ContactEntryCompletion* self,
               gchar* a,
               gint chars)
{
	gint result;
#line 182 "../src/client/composer/contact-entry-completion.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 182 "../src/client/composer/contact-entry-completion.vala"
	result = (g_utf8_strlen (a, (gssize) -1) + chars) + 1;
#line 182 "../src/client/composer/contact-entry-completion.vala"
	_g_free0 (a);
#line 182 "../src/client/composer/contact-entry-completion.vala"
	return result;
#line 991 "contact-entry-completion.c"
}

static gpointer
_____lambda21__gee_fold_func (gpointer g,
                              gpointer a,
                              gpointer self)
{
	gpointer result;
	result = (gpointer) ((gintptr) ____lambda21_ ((ContactEntryCompletion*) self, (gchar*) g, (gint) ((gintptr) a)));
#line 175 "../src/client/composer/contact-entry-completion.vala"
	return result;
#line 1003 "contact-entry-completion.c"
}

static void
contact_entry_completion_insert_address_at_cursor (ContactEntryCompletion* self,
                                                   GtkTreeIter* iter)
{
	GtkEntry* entry = NULL;
	GtkWidget* _tmp0_;
	GtkEntry* _tmp1_;
	GtkEntry* _tmp2_;
#line 165 "../src/client/composer/contact-entry-completion.vala"
	g_return_if_fail (IS_CONTACT_ENTRY_COMPLETION (self));
#line 165 "../src/client/composer/contact-entry-completion.vala"
	g_return_if_fail (iter != NULL);
#line 166 "../src/client/composer/contact-entry-completion.vala"
	_tmp0_ = gtk_entry_completion_get_entry (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_completion_get_type (), GtkEntryCompletion));
#line 166 "../src/client/composer/contact-entry-completion.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_entry_get_type ()) ? ((GtkEntry*) _tmp0_) : NULL);
#line 166 "../src/client/composer/contact-entry-completion.vala"
	entry = _tmp1_;
#line 167 "../src/client/composer/contact-entry-completion.vala"
	_tmp2_ = entry;
#line 167 "../src/client/composer/contact-entry-completion.vala"
	if (_tmp2_ != NULL) {
#line 1028 "contact-entry-completion.c"
		gint start_char = 0;
		gint end_char = 0;
		GtkEntry* _tmp7_;
		GValue value = {0};
		GtkTreeModel* _tmp8_;
		GtkTreeModel* _tmp9_;
		GtkTreeIter _tmp10_;
		GValue _tmp11_ = {0};
		GearyRFC822MailboxAddress* mailbox = NULL;
		GObject* _tmp12_;
		GearyRFC822MailboxAddress* _tmp13_;
		gchar* formatted = NULL;
		GearyRFC822MailboxAddress* _tmp14_;
		gchar* _tmp15_;
		gboolean _tmp18_ = FALSE;
		GtkEntry* _tmp19_;
		GtkEntry* _tmp20_;
		GtkEntryBuffer* _tmp21_;
		GtkEntryBuffer* _tmp22_;
		GeeArrayList* _tmp33_;
		const gchar* _tmp34_;
		GtkEntry* _tmp36_;
		const gchar* _tmp37_;
		GtkEntry* _tmp38_;
		GtkEntryBuffer* _tmp39_;
		GtkEntryBuffer* _tmp40_;
		GtkEntry* _tmp41_;
#line 173 "../src/client/composer/contact-entry-completion.vala"
		start_char = 0;
#line 174 "../src/client/composer/contact-entry-completion.vala"
		if (self->priv->cursor_at_address > 0) {
#line 1060 "contact-entry-completion.c"
			GeeArrayList* _tmp3_;
			GeeList* _tmp4_;
			GeeList* _tmp5_;
			gpointer _tmp6_;
#line 175 "../src/client/composer/contact-entry-completion.vala"
			_tmp3_ = self->priv->address_parts;
#line 175 "../src/client/composer/contact-entry-completion.vala"
			_tmp4_ = gee_abstract_list_slice (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), 0, self->priv->cursor_at_address);
#line 175 "../src/client/composer/contact-entry-completion.vala"
			_tmp5_ = _tmp4_;
#line 175 "../src/client/composer/contact-entry-completion.vala"
			_tmp6_ = gee_traversable_fold (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_TRAVERSABLE, GeeTraversable), G_TYPE_INT, NULL, NULL, _____lambda21__gee_fold_func, self, (gpointer) ((gintptr) 0));
#line 175 "../src/client/composer/contact-entry-completion.vala"
			start_char = (gint) ((gintptr) _tmp6_);
#line 175 "../src/client/composer/contact-entry-completion.vala"
			_g_object_unref0 (_tmp5_);
#line 1077 "contact-entry-completion.c"
		}
#line 185 "../src/client/composer/contact-entry-completion.vala"
		_tmp7_ = entry;
#line 185 "../src/client/composer/contact-entry-completion.vala"
		end_char = gtk_editable_get_position (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_editable_get_type (), GtkEditable));
#line 189 "../src/client/composer/contact-entry-completion.vala"
		_tmp8_ = gtk_entry_completion_get_model (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_completion_get_type (), GtkEntryCompletion));
#line 189 "../src/client/composer/contact-entry-completion.vala"
		_tmp9_ = _tmp8_;
#line 189 "../src/client/composer/contact-entry-completion.vala"
		_tmp10_ = *iter;
#line 189 "../src/client/composer/contact-entry-completion.vala"
		gtk_tree_model_get_value (_tmp9_, &_tmp10_, (gint) CONTACT_ENTRY_COMPLETION_COLUMN_MAILBOX, &_tmp11_);
#line 189 "../src/client/composer/contact-entry-completion.vala"
		G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 189 "../src/client/composer/contact-entry-completion.vala"
		value = _tmp11_;
#line 190 "../src/client/composer/contact-entry-completion.vala"
		_tmp12_ = g_value_get_object (&value);
#line 190 "../src/client/composer/contact-entry-completion.vala"
		_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEARY_RF_C822_TYPE_MAILBOX_ADDRESS, GearyRFC822MailboxAddress));
#line 190 "../src/client/composer/contact-entry-completion.vala"
		mailbox = _tmp13_;
#line 192 "../src/client/composer/contact-entry-completion.vala"
		_tmp14_ = mailbox;
#line 192 "../src/client/composer/contact-entry-completion.vala"
		_tmp15_ = geary_rf_c822_mailbox_address_to_full_display (_tmp14_, "<", ">");
#line 192 "../src/client/composer/contact-entry-completion.vala"
		formatted = _tmp15_;
#line 193 "../src/client/composer/contact-entry-completion.vala"
		if (self->priv->cursor_at_address != 0) {
#line 1109 "contact-entry-completion.c"
			const gchar* _tmp16_;
			gchar* _tmp17_;
#line 196 "../src/client/composer/contact-entry-completion.vala"
			_tmp16_ = formatted;
#line 196 "../src/client/composer/contact-entry-completion.vala"
			_tmp17_ = g_strconcat (" ", _tmp16_, NULL);
#line 196 "../src/client/composer/contact-entry-completion.vala"
			_g_free0 (formatted);
#line 196 "../src/client/composer/contact-entry-completion.vala"
			formatted = _tmp17_;
#line 1120 "contact-entry-completion.c"
		}
#line 198 "../src/client/composer/contact-entry-completion.vala"
		_tmp19_ = entry;
#line 198 "../src/client/composer/contact-entry-completion.vala"
		_tmp20_ = entry;
#line 198 "../src/client/composer/contact-entry-completion.vala"
		_tmp21_ = gtk_entry_get_buffer (_tmp20_);
#line 198 "../src/client/composer/contact-entry-completion.vala"
		_tmp22_ = _tmp21_;
#line 198 "../src/client/composer/contact-entry-completion.vala"
		if (((guint) gtk_editable_get_position (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_editable_get_type (), GtkEditable))) < gtk_entry_buffer_get_length (_tmp22_)) {
#line 1132 "contact-entry-completion.c"
			GeeArrayList* _tmp23_;
			gpointer _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			const gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
#line 199 "../src/client/composer/contact-entry-completion.vala"
			_tmp23_ = self->priv->address_parts;
#line 199 "../src/client/composer/contact-entry-completion.vala"
			_tmp24_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), self->priv->cursor_at_address);
#line 199 "../src/client/composer/contact-entry-completion.vala"
			_tmp25_ = (gchar*) _tmp24_;
#line 199 "../src/client/composer/contact-entry-completion.vala"
			_tmp26_ = string_strip (_tmp25_);
#line 199 "../src/client/composer/contact-entry-completion.vala"
			_tmp27_ = _tmp26_;
#line 199 "../src/client/composer/contact-entry-completion.vala"
			_tmp28_ = self->priv->current_key;
#line 199 "../src/client/composer/contact-entry-completion.vala"
			_tmp29_ = string_strip (_tmp28_);
#line 199 "../src/client/composer/contact-entry-completion.vala"
			_tmp30_ = _tmp29_;
#line 199 "../src/client/composer/contact-entry-completion.vala"
			_tmp18_ = g_strcmp0 (_tmp27_, _tmp30_) != 0;
#line 199 "../src/client/composer/contact-entry-completion.vala"
			_g_free0 (_tmp30_);
#line 199 "../src/client/composer/contact-entry-completion.vala"
			_g_free0 (_tmp27_);
#line 199 "../src/client/composer/contact-entry-completion.vala"
			_g_free0 (_tmp25_);
#line 1165 "contact-entry-completion.c"
		} else {
#line 198 "../src/client/composer/contact-entry-completion.vala"
			_tmp18_ = FALSE;
#line 1169 "contact-entry-completion.c"
		}
#line 198 "../src/client/composer/contact-entry-completion.vala"
		if (_tmp18_) {
#line 1173 "contact-entry-completion.c"
			const gchar* _tmp31_;
			gchar* _tmp32_;
#line 206 "../src/client/composer/contact-entry-completion.vala"
			_tmp31_ = formatted;
#line 206 "../src/client/composer/contact-entry-completion.vala"
			_tmp32_ = g_strconcat (_tmp31_, ", ", NULL);
#line 206 "../src/client/composer/contact-entry-completion.vala"
			_g_free0 (formatted);
#line 206 "../src/client/composer/contact-entry-completion.vala"
			formatted = _tmp32_;
#line 1184 "contact-entry-completion.c"
		}
#line 208 "../src/client/composer/contact-entry-completion.vala"
		_tmp33_ = self->priv->address_parts;
#line 208 "../src/client/composer/contact-entry-completion.vala"
		_tmp34_ = formatted;
#line 208 "../src/client/composer/contact-entry-completion.vala"
		gee_abstract_list_insert (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), self->priv->cursor_at_address, _tmp34_);
#line 211 "../src/client/composer/contact-entry-completion.vala"
		if (start_char < end_char) {
#line 1194 "contact-entry-completion.c"
			GtkEntry* _tmp35_;
#line 212 "../src/client/composer/contact-entry-completion.vala"
			_tmp35_ = entry;
#line 212 "../src/client/composer/contact-entry-completion.vala"
			g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, gtk_editable_get_type (), GtkEditable), "delete-text", start_char, end_char);
#line 1200 "contact-entry-completion.c"
		}
#line 214 "../src/client/composer/contact-entry-completion.vala"
		_tmp36_ = entry;
#line 214 "../src/client/composer/contact-entry-completion.vala"
		_tmp37_ = formatted;
#line 214 "../src/client/composer/contact-entry-completion.vala"
		g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, gtk_editable_get_type (), GtkEditable), "insert-text", _tmp37_, -1, &start_char);
#line 220 "../src/client/composer/contact-entry-completion.vala"
		_tmp38_ = entry;
#line 220 "../src/client/composer/contact-entry-completion.vala"
		_tmp39_ = gtk_entry_get_buffer (_tmp38_);
#line 220 "../src/client/composer/contact-entry-completion.vala"
		_tmp40_ = _tmp39_;
#line 220 "../src/client/composer/contact-entry-completion.vala"
		if (((guint) start_char) < gtk_entry_buffer_get_length (_tmp40_)) {
#line 221 "../src/client/composer/contact-entry-completion.vala"
			start_char += 2;
#line 1218 "contact-entry-completion.c"
		}
#line 223 "../src/client/composer/contact-entry-completion.vala"
		_tmp41_ = entry;
#line 223 "../src/client/composer/contact-entry-completion.vala"
		gtk_editable_set_position (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, gtk_editable_get_type (), GtkEditable), start_char);
#line 167 "../src/client/composer/contact-entry-completion.vala"
		_g_free0 (formatted);
#line 167 "../src/client/composer/contact-entry-completion.vala"
		_g_object_unref0 (mailbox);
#line 167 "../src/client/composer/contact-entry-completion.vala"
		G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 1230 "contact-entry-completion.c"
	}
#line 165 "../src/client/composer/contact-entry-completion.vala"
	_g_object_unref0 (entry);
#line 1234 "contact-entry-completion.c"
}

static void
contact_entry_completion_search_contacts_data_free (gpointer _data)
{
	ContactEntryCompletionSearchContactsData* _data_;
	_data_ = _data;
#line 9 "../src/client/composer/contact-entry-completion.vala"
	_g_free0 (_data_->query);
#line 9 "../src/client/composer/contact-entry-completion.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/client/composer/contact-entry-completion.vala"
	_g_object_unref0 (_data_->self);
#line 9 "../src/client/composer/contact-entry-completion.vala"
	g_slice_free (ContactEntryCompletionSearchContactsData, _data_);
#line 1250 "contact-entry-completion.c"
}

static void
contact_entry_completion_search_contacts (ContactEntryCompletion* self,
                                          const gchar* query,
                                          GCancellable* cancellable,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	ContactEntryCompletionSearchContactsData* _data_;
	ContactEntryCompletion* _tmp0_;
	gchar* _tmp1_;
	GCancellable* _tmp2_;
#line 9 "../src/client/composer/contact-entry-completion.vala"
	g_return_if_fail (IS_CONTACT_ENTRY_COMPLETION (self));
#line 9 "../src/client/composer/contact-entry-completion.vala"
	g_return_if_fail (query != NULL);
#line 9 "../src/client/composer/contact-entry-completion.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 9 "../src/client/composer/contact-entry-completion.vala"
	_data_ = g_slice_new0 (ContactEntryCompletionSearchContactsData);
#line 9 "../src/client/composer/contact-entry-completion.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 9 "../src/client/composer/contact-entry-completion.vala"
	g_task_set_task_data (_data_->_async_result, _data_, contact_entry_completion_search_contacts_data_free);
#line 9 "../src/client/composer/contact-entry-completion.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 9 "../src/client/composer/contact-entry-completion.vala"
	_data_->self = _tmp0_;
#line 9 "../src/client/composer/contact-entry-completion.vala"
	_tmp1_ = g_strdup (query);
#line 9 "../src/client/composer/contact-entry-completion.vala"
	_g_free0 (_data_->query);
#line 9 "../src/client/composer/contact-entry-completion.vala"
	_data_->query = _tmp1_;
#line 9 "../src/client/composer/contact-entry-completion.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 9 "../src/client/composer/contact-entry-completion.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/client/composer/contact-entry-completion.vala"
	_data_->cancellable = _tmp2_;
#line 9 "../src/client/composer/contact-entry-completion.vala"
	contact_entry_completion_search_contacts_co (_data_);
#line 1294 "contact-entry-completion.c"
}

static void
contact_entry_completion_search_contacts_finish (ContactEntryCompletion* self,
                                                 GAsyncResult* _res_)
{
	ContactEntryCompletionSearchContactsData* _data_;
#line 9 "../src/client/composer/contact-entry-completion.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 9 "../src/client/composer/contact-entry-completion.vala"
	if (NULL == _data_) {
#line 9 "../src/client/composer/contact-entry-completion.vala"
		return;
#line 1308 "contact-entry-completion.c"
	}
}

static void
contact_entry_completion_search_contacts_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_)
{
	ContactEntryCompletionSearchContactsData* _data_;
#line 231 "../src/client/composer/contact-entry-completion.vala"
	_data_ = _user_data_;
#line 231 "../src/client/composer/contact-entry-completion.vala"
	_data_->_source_object_ = source_object;
#line 231 "../src/client/composer/contact-entry-completion.vala"
	_data_->_res_ = _res_;
#line 231 "../src/client/composer/contact-entry-completion.vala"
	contact_entry_completion_search_contacts_co (_data_);
#line 1326 "contact-entry-completion.c"
}

static gboolean
contact_entry_completion_search_contacts_co (ContactEntryCompletionSearchContactsData* _data_)
{
#line 227 "../src/client/composer/contact-entry-completion.vala"
	switch (_data_->_state_) {
#line 227 "../src/client/composer/contact-entry-completion.vala"
		case 0:
#line 1336 "contact-entry-completion.c"
		goto _state_0;
#line 227 "../src/client/composer/contact-entry-completion.vala"
		case 1:
#line 1340 "contact-entry-completion.c"
		goto _state_1;
		default:
#line 227 "../src/client/composer/contact-entry-completion.vala"
		g_assert_not_reached ();
#line 1345 "contact-entry-completion.c"
	}
	_state_0:
#line 229 "../src/client/composer/contact-entry-completion.vala"
	_data_->results = NULL;
#line 1350 "contact-entry-completion.c"
	{
#line 231 "../src/client/composer/contact-entry-completion.vala"
		_data_->_tmp1_ = _data_->self->priv->contacts;
#line 231 "../src/client/composer/contact-entry-completion.vala"
		_data_->_state_ = 1;
#line 231 "../src/client/composer/contact-entry-completion.vala"
		application_contact_store_search (_data_->_tmp1_, _data_->query, (guint) CONTACT_ENTRY_COMPLETION_VISIBILITY_THRESHOLD, (guint) 20, _data_->cancellable, contact_entry_completion_search_contacts_ready, _data_);
#line 231 "../src/client/composer/contact-entry-completion.vala"
		return FALSE;
#line 1360 "contact-entry-completion.c"
		_state_1:
#line 231 "../src/client/composer/contact-entry-completion.vala"
		_data_->_tmp2_ = application_contact_store_search_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error0_);
#line 231 "../src/client/composer/contact-entry-completion.vala"
		_data_->_tmp0_ = _data_->_tmp2_;
#line 231 "../src/client/composer/contact-entry-completion.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 231 "../src/client/composer/contact-entry-completion.vala"
			if (g_error_matches (_data_->_inner_error0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 1370 "contact-entry-completion.c"
				goto __catch0_g_io_error_cancelled;
			}
			goto __catch0_g_error;
		}
#line 231 "../src/client/composer/contact-entry-completion.vala"
		_data_->_tmp3_ = _data_->_tmp0_;
#line 231 "../src/client/composer/contact-entry-completion.vala"
		_data_->_tmp0_ = NULL;
#line 231 "../src/client/composer/contact-entry-completion.vala"
		_g_object_unref0 (_data_->results);
#line 231 "../src/client/composer/contact-entry-completion.vala"
		_data_->results = _data_->_tmp3_;
#line 230 "../src/client/composer/contact-entry-completion.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 1385 "contact-entry-completion.c"
	}
	goto __finally0;
	__catch0_g_io_error_cancelled:
	{
#line 230 "../src/client/composer/contact-entry-completion.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 1392 "contact-entry-completion.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 230 "../src/client/composer/contact-entry-completion.vala"
		_data_->err = _data_->_inner_error0_;
#line 230 "../src/client/composer/contact-entry-completion.vala"
		_data_->_inner_error0_ = NULL;
#line 240 "../src/client/composer/contact-entry-completion.vala"
		_data_->_tmp4_ = _data_->err;
#line 240 "../src/client/composer/contact-entry-completion.vala"
		_data_->_tmp5_ = _data_->_tmp4_->message;
#line 240 "../src/client/composer/contact-entry-completion.vala"
		g_debug ("contact-entry-completion.vala:240: Error searching contacts for comple" \
"tion: %s", _data_->_tmp5_);
#line 230 "../src/client/composer/contact-entry-completion.vala"
		_g_error_free0 (_data_->err);
#line 1409 "contact-entry-completion.c"
	}
	__finally0:
#line 230 "../src/client/composer/contact-entry-completion.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 230 "../src/client/composer/contact-entry-completion.vala"
		_g_object_unref0 (_data_->results);
#line 230 "../src/client/composer/contact-entry-completion.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 230 "../src/client/composer/contact-entry-completion.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 230 "../src/client/composer/contact-entry-completion.vala"
		g_object_unref (_data_->_async_result);
#line 230 "../src/client/composer/contact-entry-completion.vala"
		return FALSE;
#line 1424 "contact-entry-completion.c"
	}
#line 243 "../src/client/composer/contact-entry-completion.vala"
	if (!g_cancellable_is_cancelled (_data_->cancellable)) {
#line 244 "../src/client/composer/contact-entry-completion.vala"
		_data_->_tmp6_ = contact_entry_completion_new_model (_data_->self);
#line 244 "../src/client/composer/contact-entry-completion.vala"
		_data_->model = _data_->_tmp6_;
#line 1432 "contact-entry-completion.c"
		{
#line 245 "../src/client/composer/contact-entry-completion.vala"
			_data_->_tmp7_ = _data_->results;
#line 245 "../src/client/composer/contact-entry-completion.vala"
			_data_->_tmp8_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp7_, GEE_TYPE_ITERABLE, GeeIterable));
#line 245 "../src/client/composer/contact-entry-completion.vala"
			_data_->_contact_it = _data_->_tmp8_;
#line 245 "../src/client/composer/contact-entry-completion.vala"
			while (TRUE) {
#line 245 "../src/client/composer/contact-entry-completion.vala"
				_data_->_tmp9_ = _data_->_contact_it;
#line 245 "../src/client/composer/contact-entry-completion.vala"
				if (!gee_iterator_next (_data_->_tmp9_)) {
#line 245 "../src/client/composer/contact-entry-completion.vala"
					break;
#line 1448 "contact-entry-completion.c"
				}
#line 245 "../src/client/composer/contact-entry-completion.vala"
				_data_->_tmp10_ = _data_->_contact_it;
#line 245 "../src/client/composer/contact-entry-completion.vala"
				_data_->_tmp11_ = gee_iterator_get (_data_->_tmp10_);
#line 245 "../src/client/composer/contact-entry-completion.vala"
				_data_->contact = (ApplicationContact*) _data_->_tmp11_;
#line 1456 "contact-entry-completion.c"
				{
#line 246 "../src/client/composer/contact-entry-completion.vala"
					_data_->_tmp12_ = _data_->contact;
#line 246 "../src/client/composer/contact-entry-completion.vala"
					_data_->_tmp13_ = application_contact_get_email_addresses (_data_->_tmp12_);
#line 246 "../src/client/composer/contact-entry-completion.vala"
					_data_->_tmp14_ = _data_->_tmp13_;
#line 246 "../src/client/composer/contact-entry-completion.vala"
					_data_->_tmp15_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp14_, GEE_TYPE_ITERABLE, GeeIterable));
#line 246 "../src/client/composer/contact-entry-completion.vala"
					_data_->_addr_it = _data_->_tmp15_;
#line 246 "../src/client/composer/contact-entry-completion.vala"
					while (TRUE) {
#line 246 "../src/client/composer/contact-entry-completion.vala"
						_data_->_tmp16_ = _data_->_addr_it;
#line 246 "../src/client/composer/contact-entry-completion.vala"
						if (!gee_iterator_next (_data_->_tmp16_)) {
#line 246 "../src/client/composer/contact-entry-completion.vala"
							break;
#line 1476 "contact-entry-completion.c"
						}
#line 246 "../src/client/composer/contact-entry-completion.vala"
						_data_->_tmp17_ = _data_->_addr_it;
#line 246 "../src/client/composer/contact-entry-completion.vala"
						_data_->_tmp18_ = gee_iterator_get (_data_->_tmp17_);
#line 246 "../src/client/composer/contact-entry-completion.vala"
						_data_->addr = (GearyRFC822MailboxAddress*) _data_->_tmp18_;
#line 249 "../src/client/composer/contact-entry-completion.vala"
						_data_->_tmp19_ = _data_->model;
#line 249 "../src/client/composer/contact-entry-completion.vala"
						memset (&_data_->_tmp20_, 0, sizeof (GtkTreeIter));
#line 249 "../src/client/composer/contact-entry-completion.vala"
						gtk_list_store_append (_data_->_tmp19_, &_data_->_tmp20_);
#line 249 "../src/client/composer/contact-entry-completion.vala"
						_data_->iter = _data_->_tmp20_;
#line 250 "../src/client/composer/contact-entry-completion.vala"
						_data_->_tmp21_ = _data_->model;
#line 250 "../src/client/composer/contact-entry-completion.vala"
						_data_->_tmp22_ = _data_->iter;
#line 250 "../src/client/composer/contact-entry-completion.vala"
						_data_->_tmp23_ = _data_->contact;
#line 250 "../src/client/composer/contact-entry-completion.vala"
						gtk_list_store_set (_data_->_tmp21_, &_data_->_tmp22_, CONTACT_ENTRY_COMPLETION_COLUMN_CONTACT, _data_->_tmp23_, -1);
#line 251 "../src/client/composer/contact-entry-completion.vala"
						_data_->_tmp24_ = _data_->model;
#line 251 "../src/client/composer/contact-entry-completion.vala"
						_data_->_tmp25_ = _data_->iter;
#line 251 "../src/client/composer/contact-entry-completion.vala"
						_data_->_tmp26_ = _data_->addr;
#line 251 "../src/client/composer/contact-entry-completion.vala"
						gtk_list_store_set (_data_->_tmp24_, &_data_->_tmp25_, CONTACT_ENTRY_COMPLETION_COLUMN_MAILBOX, _data_->_tmp26_, -1);
#line 246 "../src/client/composer/contact-entry-completion.vala"
						_g_object_unref0 (_data_->addr);
#line 1510 "contact-entry-completion.c"
					}
#line 246 "../src/client/composer/contact-entry-completion.vala"
					_g_object_unref0 (_data_->_addr_it);
#line 1514 "contact-entry-completion.c"
				}
#line 245 "../src/client/composer/contact-entry-completion.vala"
				_g_object_unref0 (_data_->contact);
#line 1518 "contact-entry-completion.c"
			}
#line 245 "../src/client/composer/contact-entry-completion.vala"
			_g_object_unref0 (_data_->_contact_it);
#line 1522 "contact-entry-completion.c"
		}
#line 254 "../src/client/composer/contact-entry-completion.vala"
		_data_->_tmp27_ = _data_->model;
#line 254 "../src/client/composer/contact-entry-completion.vala"
		gtk_entry_completion_set_model (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, gtk_entry_completion_get_type (), GtkEntryCompletion), G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp27_, gtk_tree_model_get_type (), GtkTreeModel));
#line 255 "../src/client/composer/contact-entry-completion.vala"
		gtk_entry_completion_complete (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, gtk_entry_completion_get_type (), GtkEntryCompletion));
#line 243 "../src/client/composer/contact-entry-completion.vala"
		_g_object_unref0 (_data_->model);
#line 1532 "contact-entry-completion.c"
	}
#line 227 "../src/client/composer/contact-entry-completion.vala"
	_g_object_unref0 (_data_->results);
#line 227 "../src/client/composer/contact-entry-completion.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 227 "../src/client/composer/contact-entry-completion.vala"
	if (_data_->_state_ != 0) {
#line 227 "../src/client/composer/contact-entry-completion.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 227 "../src/client/composer/contact-entry-completion.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1544 "contact-entry-completion.c"
		}
	}
#line 227 "../src/client/composer/contact-entry-completion.vala"
	g_object_unref (_data_->_async_result);
#line 227 "../src/client/composer/contact-entry-completion.vala"
	return FALSE;
#line 1551 "contact-entry-completion.c"
}

static gchar*
contact_entry_completion_match_prefix_contact (ContactEntryCompletion* self,
                                               GearyRFC822MailboxAddress* mailbox)
{
	gchar* email = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* result;
#line 259 "../src/client/composer/contact-entry-completion.vala"
	g_return_val_if_fail (IS_CONTACT_ENTRY_COMPLETION (self), NULL);
#line 259 "../src/client/composer/contact-entry-completion.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (mailbox, GEARY_RF_C822_TYPE_MAILBOX_ADDRESS), NULL);
#line 260 "../src/client/composer/contact-entry-completion.vala"
	_tmp0_ = geary_rf_c822_mailbox_address_get_address (mailbox);
#line 260 "../src/client/composer/contact-entry-completion.vala"
	_tmp1_ = _tmp0_;
#line 260 "../src/client/composer/contact-entry-completion.vala"
	_tmp2_ = contact_entry_completion_match_prefix_string (self, _tmp1_);
#line 260 "../src/client/composer/contact-entry-completion.vala"
	email = _tmp2_;
#line 261 "../src/client/composer/contact-entry-completion.vala"
	_tmp4_ = geary_rf_c822_mailbox_address_get_name (mailbox);
#line 261 "../src/client/composer/contact-entry-completion.vala"
	_tmp5_ = _tmp4_;
#line 261 "../src/client/composer/contact-entry-completion.vala"
	if (_tmp5_ != NULL) {
#line 261 "../src/client/composer/contact-entry-completion.vala"
		_tmp3_ = !geary_rf_c822_mailbox_address_is_spoofed (mailbox);
#line 1586 "contact-entry-completion.c"
	} else {
#line 261 "../src/client/composer/contact-entry-completion.vala"
		_tmp3_ = FALSE;
#line 1590 "contact-entry-completion.c"
	}
#line 261 "../src/client/composer/contact-entry-completion.vala"
	if (_tmp3_) {
#line 1594 "contact-entry-completion.c"
		gchar* real_name = NULL;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 262 "../src/client/composer/contact-entry-completion.vala"
		_tmp6_ = geary_rf_c822_mailbox_address_get_name (mailbox);
#line 262 "../src/client/composer/contact-entry-completion.vala"
		_tmp7_ = _tmp6_;
#line 262 "../src/client/composer/contact-entry-completion.vala"
		_tmp8_ = contact_entry_completion_match_prefix_string (self, _tmp7_);
#line 262 "../src/client/composer/contact-entry-completion.vala"
		real_name = _tmp8_;
#line 266 "../src/client/composer/contact-entry-completion.vala"
		_tmp9_ = real_name;
#line 266 "../src/client/composer/contact-entry-completion.vala"
		_tmp10_ = g_markup_escape_text (" <", (gssize) -1);
#line 266 "../src/client/composer/contact-entry-completion.vala"
		_tmp11_ = _tmp10_;
#line 266 "../src/client/composer/contact-entry-completion.vala"
		_tmp12_ = g_strconcat (_tmp9_, _tmp11_, NULL);
#line 266 "../src/client/composer/contact-entry-completion.vala"
		_tmp13_ = _tmp12_;
#line 266 "../src/client/composer/contact-entry-completion.vala"
		_tmp14_ = email;
#line 266 "../src/client/composer/contact-entry-completion.vala"
		_tmp15_ = g_strconcat (_tmp13_, _tmp14_, NULL);
#line 266 "../src/client/composer/contact-entry-completion.vala"
		_tmp16_ = _tmp15_;
#line 266 "../src/client/composer/contact-entry-completion.vala"
		_tmp17_ = g_markup_escape_text (">", (gssize) -1);
#line 266 "../src/client/composer/contact-entry-completion.vala"
		_tmp18_ = _tmp17_;
#line 266 "../src/client/composer/contact-entry-completion.vala"
		_tmp19_ = g_strconcat (_tmp16_, _tmp18_, NULL);
#line 266 "../src/client/composer/contact-entry-completion.vala"
		_g_free0 (email);
#line 266 "../src/client/composer/contact-entry-completion.vala"
		email = _tmp19_;
#line 266 "../src/client/composer/contact-entry-completion.vala"
		_g_free0 (_tmp18_);
#line 266 "../src/client/composer/contact-entry-completion.vala"
		_g_free0 (_tmp16_);
#line 266 "../src/client/composer/contact-entry-completion.vala"
		_g_free0 (_tmp13_);
#line 266 "../src/client/composer/contact-entry-completion.vala"
		_g_free0 (_tmp11_);
#line 261 "../src/client/composer/contact-entry-completion.vala"
		_g_free0 (real_name);
#line 1654 "contact-entry-completion.c"
	}
#line 271 "../src/client/composer/contact-entry-completion.vala"
	result = email;
#line 271 "../src/client/composer/contact-entry-completion.vala"
	return result;
#line 1660 "contact-entry-completion.c"
}

static gboolean
_contact_entry_completion_eval_callback_gregex_eval_callback (GMatchInfo* match_info,
                                                              GString* _result_,
                                                              gpointer self)
{
	gboolean result;
	result = contact_entry_completion_eval_callback ((ContactEntryCompletion*) self, match_info, _result_);
#line 288 "../src/client/composer/contact-entry-completion.vala"
	return result;
#line 1672 "contact-entry-completion.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1694 "contact-entry-completion.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1698 "contact-entry-completion.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1704 "contact-entry-completion.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1708 "contact-entry-completion.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1712 "contact-entry-completion.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 1720 "contact-entry-completion.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1748 "contact-entry-completion.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 1757 "contact-entry-completion.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1771 "contact-entry-completion.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 1780 "contact-entry-completion.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 1794 "contact-entry-completion.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1803 "contact-entry-completion.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 1812 "contact-entry-completion.c"
}

static gchar*
contact_entry_completion_match_prefix_string (ContactEntryCompletion* self,
                                              const gchar* haystack)
{
	gchar* value = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 274 "../src/client/composer/contact-entry-completion.vala"
	g_return_val_if_fail (IS_CONTACT_ENTRY_COMPLETION (self), NULL);
#line 274 "../src/client/composer/contact-entry-completion.vala"
	g_return_val_if_fail (haystack != NULL, NULL);
#line 275 "../src/client/composer/contact-entry-completion.vala"
	_tmp0_ = g_strdup (haystack);
#line 275 "../src/client/composer/contact-entry-completion.vala"
	value = _tmp0_;
#line 276 "../src/client/composer/contact-entry-completion.vala"
	_tmp1_ = self->priv->current_key;
#line 276 "../src/client/composer/contact-entry-completion.vala"
	if (!geary_string_is_empty (_tmp1_)) {
#line 1836 "contact-entry-completion.c"
		gboolean matched = FALSE;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
#line 277 "../src/client/composer/contact-entry-completion.vala"
		matched = FALSE;
#line 1846 "contact-entry-completion.c"
		{
			gchar* escaped_needle = NULL;
			const gchar* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			GRegex* regex = NULL;
			const gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			GRegex* _tmp10_;
			GRegex* _tmp11_;
			gchar* haystack_normalized = NULL;
			gchar* _tmp12_;
			GRegex* _tmp13_;
			const gchar* _tmp14_;
#line 279 "../src/client/composer/contact-entry-completion.vala"
			_tmp2_ = self->priv->current_key;
#line 279 "../src/client/composer/contact-entry-completion.vala"
			_tmp3_ = g_utf8_normalize (_tmp2_, (gssize) -1, G_NORMALIZE_DEFAULT);
#line 279 "../src/client/composer/contact-entry-completion.vala"
			_tmp4_ = _tmp3_;
#line 279 "../src/client/composer/contact-entry-completion.vala"
			_tmp5_ = g_regex_escape_string (_tmp4_, -1);
#line 279 "../src/client/composer/contact-entry-completion.vala"
			_tmp6_ = _tmp5_;
#line 279 "../src/client/composer/contact-entry-completion.vala"
			_g_free0 (_tmp4_);
#line 279 "../src/client/composer/contact-entry-completion.vala"
			escaped_needle = _tmp6_;
#line 282 "../src/client/composer/contact-entry-completion.vala"
			_tmp7_ = escaped_needle;
#line 282 "../src/client/composer/contact-entry-completion.vala"
			_tmp8_ = g_strconcat ("\\b", _tmp7_, NULL);
#line 282 "../src/client/composer/contact-entry-completion.vala"
			_tmp9_ = _tmp8_;
#line 282 "../src/client/composer/contact-entry-completion.vala"
			_tmp10_ = g_regex_new (_tmp9_, G_REGEX_CASELESS, 0, &_inner_error0_);
#line 282 "../src/client/composer/contact-entry-completion.vala"
			_tmp11_ = _tmp10_;
#line 282 "../src/client/composer/contact-entry-completion.vala"
			_g_free0 (_tmp9_);
#line 282 "../src/client/composer/contact-entry-completion.vala"
			regex = _tmp11_;
#line 282 "../src/client/composer/contact-entry-completion.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 282 "../src/client/composer/contact-entry-completion.vala"
				_g_free0 (escaped_needle);
#line 282 "../src/client/composer/contact-entry-completion.vala"
				if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1898 "contact-entry-completion.c"
					goto __catch0_g_regex_error;
				}
#line 282 "../src/client/composer/contact-entry-completion.vala"
				_g_free0 (value);
#line 282 "../src/client/composer/contact-entry-completion.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 282 "../src/client/composer/contact-entry-completion.vala"
				g_clear_error (&_inner_error0_);
#line 282 "../src/client/composer/contact-entry-completion.vala"
				return NULL;
#line 1909 "contact-entry-completion.c"
			}
#line 286 "../src/client/composer/contact-entry-completion.vala"
			_tmp12_ = g_utf8_normalize (haystack, (gssize) -1, G_NORMALIZE_DEFAULT);
#line 286 "../src/client/composer/contact-entry-completion.vala"
			haystack_normalized = _tmp12_;
#line 287 "../src/client/composer/contact-entry-completion.vala"
			_tmp13_ = regex;
#line 287 "../src/client/composer/contact-entry-completion.vala"
			_tmp14_ = haystack_normalized;
#line 287 "../src/client/composer/contact-entry-completion.vala"
			if (g_regex_match (_tmp13_, _tmp14_, 0, NULL)) {
#line 1921 "contact-entry-completion.c"
				gchar* _tmp15_ = NULL;
				GRegex* _tmp16_;
				const gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
#line 288 "../src/client/composer/contact-entry-completion.vala"
				_tmp16_ = regex;
#line 288 "../src/client/composer/contact-entry-completion.vala"
				_tmp17_ = haystack_normalized;
#line 288 "../src/client/composer/contact-entry-completion.vala"
				_tmp18_ = g_regex_replace_eval (_tmp16_, _tmp17_, (gssize) -1, 0, 0, _contact_entry_completion_eval_callback_gregex_eval_callback, self, &_inner_error0_);
#line 288 "../src/client/composer/contact-entry-completion.vala"
				_tmp15_ = _tmp18_;
#line 288 "../src/client/composer/contact-entry-completion.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 288 "../src/client/composer/contact-entry-completion.vala"
					_g_free0 (haystack_normalized);
#line 288 "../src/client/composer/contact-entry-completion.vala"
					_g_regex_unref0 (regex);
#line 288 "../src/client/composer/contact-entry-completion.vala"
					_g_free0 (escaped_needle);
#line 288 "../src/client/composer/contact-entry-completion.vala"
					if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1945 "contact-entry-completion.c"
						goto __catch0_g_regex_error;
					}
#line 288 "../src/client/composer/contact-entry-completion.vala"
					_g_free0 (value);
#line 288 "../src/client/composer/contact-entry-completion.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 288 "../src/client/composer/contact-entry-completion.vala"
					g_clear_error (&_inner_error0_);
#line 288 "../src/client/composer/contact-entry-completion.vala"
					return NULL;
#line 1956 "contact-entry-completion.c"
				}
#line 288 "../src/client/composer/contact-entry-completion.vala"
				_tmp19_ = _tmp15_;
#line 288 "../src/client/composer/contact-entry-completion.vala"
				_tmp15_ = NULL;
#line 288 "../src/client/composer/contact-entry-completion.vala"
				_g_free0 (value);
#line 288 "../src/client/composer/contact-entry-completion.vala"
				value = _tmp19_;
#line 291 "../src/client/composer/contact-entry-completion.vala"
				matched = TRUE;
#line 287 "../src/client/composer/contact-entry-completion.vala"
				_g_free0 (_tmp15_);
#line 1970 "contact-entry-completion.c"
			}
#line 278 "../src/client/composer/contact-entry-completion.vala"
			_g_free0 (haystack_normalized);
#line 278 "../src/client/composer/contact-entry-completion.vala"
			_g_regex_unref0 (regex);
#line 278 "../src/client/composer/contact-entry-completion.vala"
			_g_free0 (escaped_needle);
#line 1978 "contact-entry-completion.c"
		}
		goto __finally0;
		__catch0_g_regex_error:
		{
			GError* err = NULL;
			GError* _tmp20_;
			const gchar* _tmp21_;
#line 278 "../src/client/composer/contact-entry-completion.vala"
			err = _inner_error0_;
#line 278 "../src/client/composer/contact-entry-completion.vala"
			_inner_error0_ = NULL;
#line 294 "../src/client/composer/contact-entry-completion.vala"
			_tmp20_ = err;
#line 294 "../src/client/composer/contact-entry-completion.vala"
			_tmp21_ = _tmp20_->message;
#line 294 "../src/client/composer/contact-entry-completion.vala"
			g_debug ("contact-entry-completion.vala:294: Error matching regex: %s", _tmp21_);
#line 278 "../src/client/composer/contact-entry-completion.vala"
			_g_error_free0 (err);
#line 1998 "contact-entry-completion.c"
		}
		__finally0:
#line 278 "../src/client/composer/contact-entry-completion.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 278 "../src/client/composer/contact-entry-completion.vala"
			_g_free0 (value);
#line 278 "../src/client/composer/contact-entry-completion.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 278 "../src/client/composer/contact-entry-completion.vala"
			g_clear_error (&_inner_error0_);
#line 278 "../src/client/composer/contact-entry-completion.vala"
			return NULL;
#line 2011 "contact-entry-completion.c"
		}
#line 297 "../src/client/composer/contact-entry-completion.vala"
		_tmp22_ = value;
#line 297 "../src/client/composer/contact-entry-completion.vala"
		_tmp23_ = g_markup_escape_text (_tmp22_, (gssize) -1);
#line 297 "../src/client/composer/contact-entry-completion.vala"
		_tmp24_ = _tmp23_;
#line 297 "../src/client/composer/contact-entry-completion.vala"
		_tmp25_ = string_replace (_tmp24_, "&#x91;", "<b>");
#line 297 "../src/client/composer/contact-entry-completion.vala"
		_tmp26_ = _tmp25_;
#line 297 "../src/client/composer/contact-entry-completion.vala"
		_tmp27_ = string_replace (_tmp26_, "&#x92;", "</b>");
#line 297 "../src/client/composer/contact-entry-completion.vala"
		_g_free0 (value);
#line 297 "../src/client/composer/contact-entry-completion.vala"
		value = _tmp27_;
#line 297 "../src/client/composer/contact-entry-completion.vala"
		_g_free0 (_tmp26_);
#line 297 "../src/client/composer/contact-entry-completion.vala"
		_g_free0 (_tmp24_);
#line 2033 "contact-entry-completion.c"
	}
#line 302 "../src/client/composer/contact-entry-completion.vala"
	result = value;
#line 302 "../src/client/composer/contact-entry-completion.vala"
	return result;
#line 2039 "contact-entry-completion.c"
}

static gboolean
contact_entry_completion_eval_callback (ContactEntryCompletion* self,
                                        GMatchInfo* match_info,
                                        GString* _result_)
{
	gchar* match = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean result;
#line 305 "../src/client/composer/contact-entry-completion.vala"
	g_return_val_if_fail (IS_CONTACT_ENTRY_COMPLETION (self), FALSE);
#line 305 "../src/client/composer/contact-entry-completion.vala"
	g_return_val_if_fail (match_info != NULL, FALSE);
#line 305 "../src/client/composer/contact-entry-completion.vala"
	g_return_val_if_fail (_result_ != NULL, FALSE);
#line 307 "../src/client/composer/contact-entry-completion.vala"
	_tmp0_ = g_match_info_fetch (match_info, 0);
#line 307 "../src/client/composer/contact-entry-completion.vala"
	match = _tmp0_;
#line 308 "../src/client/composer/contact-entry-completion.vala"
	_tmp1_ = match;
#line 308 "../src/client/composer/contact-entry-completion.vala"
	if (_tmp1_ != NULL) {
#line 2065 "contact-entry-completion.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 309 "../src/client/composer/contact-entry-completion.vala"
		_tmp2_ = match;
#line 309 "../src/client/composer/contact-entry-completion.vala"
		_tmp3_ = g_strdup_printf ("\xc2\x91%s\xc2\x92", _tmp2_);
#line 309 "../src/client/composer/contact-entry-completion.vala"
		_tmp4_ = _tmp3_;
#line 309 "../src/client/composer/contact-entry-completion.vala"
		g_string_append (_result_, _tmp4_);
#line 309 "../src/client/composer/contact-entry-completion.vala"
		_g_free0 (_tmp4_);
#line 2079 "contact-entry-completion.c"
	}
#line 312 "../src/client/composer/contact-entry-completion.vala"
	result = FALSE;
#line 312 "../src/client/composer/contact-entry-completion.vala"
	_g_free0 (match);
#line 312 "../src/client/composer/contact-entry-completion.vala"
	return result;
#line 2087 "contact-entry-completion.c"
}

static void
contact_entry_completion_cell_icon_data (ContactEntryCompletion* self,
                                         GtkCellLayout* cell_layout,
                                         GtkCellRenderer* cell,
                                         GtkTreeModel* tree_model,
                                         GtkTreeIter* iter)
{
	GValue value = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	ApplicationContact* contact = NULL;
	GObject* _tmp2_;
	ApplicationContact* _tmp3_;
	gchar* icon = NULL;
	gchar* _tmp4_;
	ApplicationContact* _tmp5_;
	GtkCellRendererPixbuf* renderer = NULL;
	GtkCellRendererPixbuf* _tmp14_;
	const gchar* _tmp15_;
#line 315 "../src/client/composer/contact-entry-completion.vala"
	g_return_if_fail (IS_CONTACT_ENTRY_COMPLETION (self));
#line 315 "../src/client/composer/contact-entry-completion.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cell_layout, gtk_cell_layout_get_type ()));
#line 315 "../src/client/composer/contact-entry-completion.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cell, gtk_cell_renderer_get_type ()));
#line 315 "../src/client/composer/contact-entry-completion.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (tree_model, gtk_tree_model_get_type ()));
#line 315 "../src/client/composer/contact-entry-completion.vala"
	g_return_if_fail (iter != NULL);
#line 320 "../src/client/composer/contact-entry-completion.vala"
	_tmp0_ = *iter;
#line 320 "../src/client/composer/contact-entry-completion.vala"
	gtk_tree_model_get_value (tree_model, &_tmp0_, (gint) CONTACT_ENTRY_COMPLETION_COLUMN_CONTACT, &_tmp1_);
#line 320 "../src/client/composer/contact-entry-completion.vala"
	G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 320 "../src/client/composer/contact-entry-completion.vala"
	value = _tmp1_;
#line 321 "../src/client/composer/contact-entry-completion.vala"
	_tmp2_ = g_value_get_object (&value);
#line 321 "../src/client/composer/contact-entry-completion.vala"
	_tmp3_ = _g_object_ref0 (APPLICATION_IS_CONTACT (_tmp2_) ? ((ApplicationContact*) _tmp2_) : NULL);
#line 321 "../src/client/composer/contact-entry-completion.vala"
	contact = _tmp3_;
#line 323 "../src/client/composer/contact-entry-completion.vala"
	_tmp4_ = g_strdup ("");
#line 323 "../src/client/composer/contact-entry-completion.vala"
	icon = _tmp4_;
#line 324 "../src/client/composer/contact-entry-completion.vala"
	_tmp5_ = contact;
#line 324 "../src/client/composer/contact-entry-completion.vala"
	if (_tmp5_ != NULL) {
#line 2141 "contact-entry-completion.c"
		ApplicationContact* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 325 "../src/client/composer/contact-entry-completion.vala"
		_tmp6_ = contact;
#line 325 "../src/client/composer/contact-entry-completion.vala"
		_tmp7_ = application_contact_get_is_favourite (_tmp6_);
#line 325 "../src/client/composer/contact-entry-completion.vala"
		_tmp8_ = _tmp7_;
#line 325 "../src/client/composer/contact-entry-completion.vala"
		if (_tmp8_) {
#line 2153 "contact-entry-completion.c"
			gchar* _tmp9_;
#line 326 "../src/client/composer/contact-entry-completion.vala"
			_tmp9_ = g_strdup ("starred-symbolic");
#line 326 "../src/client/composer/contact-entry-completion.vala"
			_g_free0 (icon);
#line 326 "../src/client/composer/contact-entry-completion.vala"
			icon = _tmp9_;
#line 2161 "contact-entry-completion.c"
		} else {
			ApplicationContact* _tmp10_;
			gboolean _tmp11_;
			gboolean _tmp12_;
#line 327 "../src/client/composer/contact-entry-completion.vala"
			_tmp10_ = contact;
#line 327 "../src/client/composer/contact-entry-completion.vala"
			_tmp11_ = application_contact_get_is_desktop_contact (_tmp10_);
#line 327 "../src/client/composer/contact-entry-completion.vala"
			_tmp12_ = _tmp11_;
#line 327 "../src/client/composer/contact-entry-completion.vala"
			if (_tmp12_) {
#line 2174 "contact-entry-completion.c"
				gchar* _tmp13_;
#line 328 "../src/client/composer/contact-entry-completion.vala"
				_tmp13_ = g_strdup ("avatar-default-symbolic");
#line 328 "../src/client/composer/contact-entry-completion.vala"
				_g_free0 (icon);
#line 328 "../src/client/composer/contact-entry-completion.vala"
				icon = _tmp13_;
#line 2182 "contact-entry-completion.c"
			}
		}
	}
#line 332 "../src/client/composer/contact-entry-completion.vala"
	_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (cell, gtk_cell_renderer_pixbuf_get_type (), GtkCellRendererPixbuf));
#line 332 "../src/client/composer/contact-entry-completion.vala"
	renderer = _tmp14_;
#line 333 "../src/client/composer/contact-entry-completion.vala"
	_tmp15_ = icon;
#line 333 "../src/client/composer/contact-entry-completion.vala"
	g_object_set (renderer, "icon-name", _tmp15_, NULL);
#line 315 "../src/client/composer/contact-entry-completion.vala"
	_g_object_unref0 (renderer);
#line 315 "../src/client/composer/contact-entry-completion.vala"
	_g_free0 (icon);
#line 315 "../src/client/composer/contact-entry-completion.vala"
	_g_object_unref0 (contact);
#line 315 "../src/client/composer/contact-entry-completion.vala"
	G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 2202 "contact-entry-completion.c"
}

static void
contact_entry_completion_cell_text_data (ContactEntryCompletion* self,
                                         GtkCellLayout* cell_layout,
                                         GtkCellRenderer* cell,
                                         GtkTreeModel* tree_model,
                                         GtkTreeIter* iter)
{
	GValue value = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	GearyRFC822MailboxAddress* mailbox = NULL;
	GObject* _tmp2_;
	GearyRFC822MailboxAddress* _tmp3_;
	gchar* markup = NULL;
	gchar* _tmp4_;
	GearyRFC822MailboxAddress* _tmp5_;
	GtkCellRendererText* renderer = NULL;
	GtkCellRendererText* _tmp8_;
	const gchar* _tmp9_;
#line 336 "../src/client/composer/contact-entry-completion.vala"
	g_return_if_fail (IS_CONTACT_ENTRY_COMPLETION (self));
#line 336 "../src/client/composer/contact-entry-completion.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cell_layout, gtk_cell_layout_get_type ()));
#line 336 "../src/client/composer/contact-entry-completion.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cell, gtk_cell_renderer_get_type ()));
#line 336 "../src/client/composer/contact-entry-completion.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (tree_model, gtk_tree_model_get_type ()));
#line 336 "../src/client/composer/contact-entry-completion.vala"
	g_return_if_fail (iter != NULL);
#line 341 "../src/client/composer/contact-entry-completion.vala"
	_tmp0_ = *iter;
#line 341 "../src/client/composer/contact-entry-completion.vala"
	gtk_tree_model_get_value (tree_model, &_tmp0_, (gint) CONTACT_ENTRY_COMPLETION_COLUMN_MAILBOX, &_tmp1_);
#line 341 "../src/client/composer/contact-entry-completion.vala"
	G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 341 "../src/client/composer/contact-entry-completion.vala"
	value = _tmp1_;
#line 342 "../src/client/composer/contact-entry-completion.vala"
	_tmp2_ = g_value_get_object (&value);
#line 342 "../src/client/composer/contact-entry-completion.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, GEARY_RF_C822_TYPE_MAILBOX_ADDRESS) ? ((GearyRFC822MailboxAddress*) _tmp2_) : NULL);
#line 342 "../src/client/composer/contact-entry-completion.vala"
	mailbox = _tmp3_;
#line 345 "../src/client/composer/contact-entry-completion.vala"
	_tmp4_ = g_strdup ("");
#line 345 "../src/client/composer/contact-entry-completion.vala"
	markup = _tmp4_;
#line 346 "../src/client/composer/contact-entry-completion.vala"
	_tmp5_ = mailbox;
#line 346 "../src/client/composer/contact-entry-completion.vala"
	if (_tmp5_ != NULL) {
#line 2256 "contact-entry-completion.c"
		GearyRFC822MailboxAddress* _tmp6_;
		gchar* _tmp7_;
#line 347 "../src/client/composer/contact-entry-completion.vala"
		_tmp6_ = mailbox;
#line 347 "../src/client/composer/contact-entry-completion.vala"
		_tmp7_ = contact_entry_completion_match_prefix_contact (self, _tmp6_);
#line 347 "../src/client/composer/contact-entry-completion.vala"
		_g_free0 (markup);
#line 347 "../src/client/composer/contact-entry-completion.vala"
		markup = _tmp7_;
#line 2267 "contact-entry-completion.c"
	}
#line 350 "../src/client/composer/contact-entry-completion.vala"
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (cell, gtk_cell_renderer_text_get_type (), GtkCellRendererText));
#line 350 "../src/client/composer/contact-entry-completion.vala"
	renderer = _tmp8_;
#line 351 "../src/client/composer/contact-entry-completion.vala"
	_tmp9_ = markup;
#line 351 "../src/client/composer/contact-entry-completion.vala"
	g_object_set (renderer, "markup", _tmp9_, NULL);
#line 336 "../src/client/composer/contact-entry-completion.vala"
	_g_object_unref0 (renderer);
#line 336 "../src/client/composer/contact-entry-completion.vala"
	_g_free0 (markup);
#line 336 "../src/client/composer/contact-entry-completion.vala"
	_g_object_unref0 (mailbox);
#line 336 "../src/client/composer/contact-entry-completion.vala"
	G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 2285 "contact-entry-completion.c"
}

static inline GtkListStore*
contact_entry_completion_new_model (ContactEntryCompletion* self)
{
	gint _tmp0_ = 0;
	GType* _tmp1_;
	GType* _tmp2_;
	gint _tmp2__length1;
	GtkListStore* _tmp3_;
	GtkListStore* _tmp4_;
	GtkListStore* result;
#line 354 "../src/client/composer/contact-entry-completion.vala"
	g_return_val_if_fail (IS_CONTACT_ENTRY_COMPLETION (self), NULL);
#line 355 "../src/client/composer/contact-entry-completion.vala"
	_tmp1_ = contact_entry_completion_column_get_types (&_tmp0_);
#line 355 "../src/client/composer/contact-entry-completion.vala"
	_tmp2_ = _tmp1_;
#line 355 "../src/client/composer/contact-entry-completion.vala"
	_tmp2__length1 = _tmp0_;
#line 355 "../src/client/composer/contact-entry-completion.vala"
	_tmp3_ = gtk_list_store_newv (_tmp0_, _tmp2_);
#line 355 "../src/client/composer/contact-entry-completion.vala"
	_tmp4_ = _tmp3_;
#line 355 "../src/client/composer/contact-entry-completion.vala"
	_tmp2_ = (g_free (_tmp2_), NULL);
#line 355 "../src/client/composer/contact-entry-completion.vala"
	result = _tmp4_;
#line 355 "../src/client/composer/contact-entry-completion.vala"
	return result;
#line 2316 "contact-entry-completion.c"
}

static gboolean
contact_entry_completion_on_match_selected (ContactEntryCompletion* self,
                                            GtkTreeModel* model,
                                            GtkTreeIter* iter)
{
	GtkTreeIter _tmp0_;
	gboolean result;
#line 358 "../src/client/composer/contact-entry-completion.vala"
	g_return_val_if_fail (IS_CONTACT_ENTRY_COMPLETION (self), FALSE);
#line 358 "../src/client/composer/contact-entry-completion.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (model, gtk_tree_model_get_type ()), FALSE);
#line 358 "../src/client/composer/contact-entry-completion.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 359 "../src/client/composer/contact-entry-completion.vala"
	_tmp0_ = *iter;
#line 359 "../src/client/composer/contact-entry-completion.vala"
	contact_entry_completion_insert_address_at_cursor (self, &_tmp0_);
#line 360 "../src/client/composer/contact-entry-completion.vala"
	result = TRUE;
#line 360 "../src/client/composer/contact-entry-completion.vala"
	return result;
#line 2340 "contact-entry-completion.c"
}

static GtkTreeIter*
_vala_GtkTreeIter_copy (GtkTreeIter* self)
{
#line 364 "../src/client/composer/contact-entry-completion.vala"
	return g_boxed_copy (gtk_tree_iter_get_type (), self);
#line 2348 "contact-entry-completion.c"
}

static gpointer
__vala_GtkTreeIter_copy0 (gpointer self)
{
#line 364 "../src/client/composer/contact-entry-completion.vala"
	return self ? _vala_GtkTreeIter_copy (self) : NULL;
#line 2356 "contact-entry-completion.c"
}

static gboolean
contact_entry_completion_on_cursor_on_match (ContactEntryCompletion* self,
                                             GtkTreeModel* model,
                                             GtkTreeIter* iter)
{
	GtkTreeIter _tmp0_;
	GtkTreeIter* _tmp1_;
	gboolean result;
#line 363 "../src/client/composer/contact-entry-completion.vala"
	g_return_val_if_fail (IS_CONTACT_ENTRY_COMPLETION (self), FALSE);
#line 363 "../src/client/composer/contact-entry-completion.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (model, gtk_tree_model_get_type ()), FALSE);
#line 363 "../src/client/composer/contact-entry-completion.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 364 "../src/client/composer/contact-entry-completion.vala"
	_tmp0_ = *iter;
#line 364 "../src/client/composer/contact-entry-completion.vala"
	_tmp1_ = __vala_GtkTreeIter_copy0 (&_tmp0_);
#line 364 "../src/client/composer/contact-entry-completion.vala"
	__vala_GtkTreeIter_free0 (self->priv->last_iter);
#line 364 "../src/client/composer/contact-entry-completion.vala"
	self->priv->last_iter = _tmp1_;
#line 365 "../src/client/composer/contact-entry-completion.vala"
	result = TRUE;
#line 365 "../src/client/composer/contact-entry-completion.vala"
	return result;
#line 2385 "contact-entry-completion.c"
}

static void
contact_entry_completion_class_init (ContactEntryCompletionClass * klass,
                                     gpointer klass_data)
{
#line 9 "../src/client/composer/contact-entry-completion.vala"
	contact_entry_completion_parent_class = g_type_class_peek_parent (klass);
#line 9 "../src/client/composer/contact-entry-completion.vala"
	g_type_class_adjust_private_offset (klass, &ContactEntryCompletion_private_offset);
#line 9 "../src/client/composer/contact-entry-completion.vala"
	G_OBJECT_CLASS (klass)->finalize = contact_entry_completion_finalize;
#line 2398 "contact-entry-completion.c"
}

static void
contact_entry_completion_geary_base_interface_interface_init (GearyBaseInterfaceIface * iface,
                                                              gpointer iface_data)
{
#line 9 "../src/client/composer/contact-entry-completion.vala"
	contact_entry_completion_geary_base_interface_parent_iface = g_type_interface_peek_parent (iface);
#line 2407 "contact-entry-completion.c"
}

static void
contact_entry_completion_instance_init (ContactEntryCompletion * self,
                                        gpointer klass)
{
	gchar* _tmp0_;
	GeeArrayList* _tmp1_;
#line 9 "../src/client/composer/contact-entry-completion.vala"
	self->priv = contact_entry_completion_get_instance_private (self);
#line 34 "../src/client/composer/contact-entry-completion.vala"
	_tmp0_ = g_strdup ("");
#line 34 "../src/client/composer/contact-entry-completion.vala"
	self->priv->current_key = _tmp0_;
#line 37 "../src/client/composer/contact-entry-completion.vala"
	_tmp1_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 37 "../src/client/composer/contact-entry-completion.vala"
	self->priv->address_parts = _tmp1_;
#line 40 "../src/client/composer/contact-entry-completion.vala"
	self->priv->cursor_at_address = 0;
#line 42 "../src/client/composer/contact-entry-completion.vala"
	self->priv->search_cancellable = NULL;
#line 43 "../src/client/composer/contact-entry-completion.vala"
	self->priv->last_iter = NULL;
#line 2432 "contact-entry-completion.c"
}

static void
contact_entry_completion_finalize (GObject * obj)
{
	ContactEntryCompletion * self;
#line 9 "../src/client/composer/contact-entry-completion.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CONTACT_ENTRY_COMPLETION, ContactEntryCompletion);
#line 74 "../src/client/composer/contact-entry-completion.vala"
	geary_base_interface_base_unref (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_BASE_INTERFACE, GearyBaseInterface));
#line 30 "../src/client/composer/contact-entry-completion.vala"
	_g_object_unref0 (self->priv->contacts);
#line 34 "../src/client/composer/contact-entry-completion.vala"
	_g_free0 (self->priv->current_key);
#line 37 "../src/client/composer/contact-entry-completion.vala"
	_g_object_unref0 (self->priv->address_parts);
#line 42 "../src/client/composer/contact-entry-completion.vala"
	_g_object_unref0 (self->priv->search_cancellable);
#line 43 "../src/client/composer/contact-entry-completion.vala"
	__vala_GtkTreeIter_free0 (self->priv->last_iter);
#line 9 "../src/client/composer/contact-entry-completion.vala"
	G_OBJECT_CLASS (contact_entry_completion_parent_class)->finalize (obj);
#line 2455 "contact-entry-completion.c"
}

static GType
contact_entry_completion_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ContactEntryCompletionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contact_entry_completion_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContactEntryCompletion), 0, (GInstanceInitFunc) contact_entry_completion_instance_init, NULL };
	static const GInterfaceInfo geary_base_interface_info = { (GInterfaceInitFunc) contact_entry_completion_geary_base_interface_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType contact_entry_completion_type_id;
	contact_entry_completion_type_id = g_type_register_static (gtk_entry_completion_get_type (), "ContactEntryCompletion", &g_define_type_info, 0);
	g_type_add_interface_static (contact_entry_completion_type_id, GEARY_TYPE_BASE_INTERFACE, &geary_base_interface_info);
	ContactEntryCompletion_private_offset = g_type_add_instance_private (contact_entry_completion_type_id, sizeof (ContactEntryCompletionPrivate));
	return contact_entry_completion_type_id;
}

GType
contact_entry_completion_get_type (void)
{
	static volatile gsize contact_entry_completion_type_id__once = 0;
	if (g_once_init_enter (&contact_entry_completion_type_id__once)) {
		GType contact_entry_completion_type_id;
		contact_entry_completion_type_id = contact_entry_completion_get_type_once ();
		g_once_init_leave (&contact_entry_completion_type_id__once, contact_entry_completion_type_id);
	}
	return contact_entry_completion_type_id__once;
}

