/* conversation-list-row.c generated by valac 0.56.17, the Vala compiler
 * generated from conversation-list-row.vala, do not modify */

/*
 * Copyright © 2022 John Renner <john@jrenner.net>
 * Copyright © 2022 Cédric Bellegarde <cedric.bellegarde@adishatz.org>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "geary-engine.h"
#include "geary-client-46.0.h"
#include <glib.h>
#include <gee.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define CONVERSATION_LIST_TYPE_ROW (conversation_list_row_get_type ())
#define CONVERSATION_LIST_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONVERSATION_LIST_TYPE_ROW, ConversationListRow))
#define CONVERSATION_LIST_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONVERSATION_LIST_TYPE_ROW, ConversationListRowClass))
#define CONVERSATION_LIST_IS_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONVERSATION_LIST_TYPE_ROW))
#define CONVERSATION_LIST_IS_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONVERSATION_LIST_TYPE_ROW))
#define CONVERSATION_LIST_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONVERSATION_LIST_TYPE_ROW, ConversationListRowClass))

typedef struct _ConversationListRow ConversationListRow;
typedef struct _ConversationListRowClass ConversationListRowClass;
typedef struct _ConversationListRowPrivate ConversationListRowPrivate;
enum  {
	CONVERSATION_LIST_ROW_0_PROPERTY,
	CONVERSATION_LIST_ROW_NUM_PROPERTIES
};
static GParamSpec* conversation_list_row_properties[CONVERSATION_LIST_ROW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define CONVERSATION_LIST_TYPE_PARTICIPANT (conversation_list_participant_get_type ())
#define CONVERSATION_LIST_PARTICIPANT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONVERSATION_LIST_TYPE_PARTICIPANT, ConversationListParticipant))
#define CONVERSATION_LIST_PARTICIPANT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONVERSATION_LIST_TYPE_PARTICIPANT, ConversationListParticipantClass))
#define CONVERSATION_LIST_IS_PARTICIPANT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONVERSATION_LIST_TYPE_PARTICIPANT))
#define CONVERSATION_LIST_IS_PARTICIPANT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONVERSATION_LIST_TYPE_PARTICIPANT))
#define CONVERSATION_LIST_PARTICIPANT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONVERSATION_LIST_TYPE_PARTICIPANT, ConversationListParticipantClass))

typedef struct _ConversationListParticipant ConversationListParticipant;
typedef struct _ConversationListParticipantClass ConversationListParticipantClass;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
enum  {
	CONVERSATION_LIST_ROW_TOGGLE_FLAG_SIGNAL,
	CONVERSATION_LIST_ROW_TOGGLE_SELECTION_SIGNAL,
	CONVERSATION_LIST_ROW_NUM_SIGNALS
};
static guint conversation_list_row_signals[CONVERSATION_LIST_ROW_NUM_SIGNALS] = {0};

struct _ConversationListRow {
	GtkListBoxRow parent_instance;
	GearyAppConversation* conversation;
	ConversationListRowPrivate * priv;
};

struct _ConversationListRowClass {
	GtkListBoxRowClass parent_class;
};

struct _ConversationListRowPrivate {
	GtkLabel* preview;
	GtkLabel* subject;
	GtkLabel* participants;
	GtkLabel* date;
	GtkLabel* count_badge;
	GtkImage* flagged_icon;
	GtkCheckButton* selected_button;
	ApplicationConfiguration* config;
	GDateTime* recv_time;
};

static gint ConversationListRow_private_offset;
static gpointer conversation_list_row_parent_class = NULL;

VALA_EXTERN GType conversation_list_row_get_type (void) G_GNUC_CONST ;
static GeeList* conversation_list_row_get_user_accounts (ConversationListRow* self);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
VALA_EXTERN ConversationListRow* conversation_list_row_new (ApplicationConfiguration* config,
                                                GearyAppConversation* conversation,
                                                gboolean selection_mode_enabled);
VALA_EXTERN ConversationListRow* conversation_list_row_construct (GType object_type,
                                                      ApplicationConfiguration* config,
                                                      GearyAppConversation* conversation,
                                                      gboolean selection_mode_enabled);
static void conversation_list_row_update_flags (ConversationListRow* self,
                                         GearyEmail* email);
static void _conversation_list_row_update_flags_geary_app_conversation_email_flags_changed (GearyAppConversation* _sender,
                                                                                     GearyEmail* email,
                                                                                     gpointer self);
VALA_EXTERN void conversation_list_row_set_selection_enabled (ConversationListRow* self,
                                                  gboolean enabled);
VALA_EXTERN void conversation_list_row_update (ConversationListRow* self);
VALA_EXTERN void conversation_list_row_refresh_time (ConversationListRow* self);
static gchar* conversation_list_row_get_participants (ConversationListRow* self);
static void conversation_list_row_set_button_active (ConversationListRow* self,
                                              gboolean active);
static void conversation_list_row_update_button (ConversationListRow* self);
static void _conversation_list_row_update_button_gtk_widget_state_flags_changed (GtkWidget* _sender,
                                                                          GtkStateFlags previous_state_flags,
                                                                          gpointer self);
static void conversation_list_row_update_state_flags (ConversationListRow* self);
static void _conversation_list_row_update_state_flags_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                          gpointer self);
VALA_EXTERN GType conversation_list_participant_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ConversationListParticipant* conversation_list_participant_new (GearyRFC822MailboxAddress* address);
VALA_EXTERN ConversationListParticipant* conversation_list_participant_construct (GType object_type,
                                                                      GearyRFC822MailboxAddress* address);
VALA_EXTERN gchar* conversation_list_participant_get_full_markup (ConversationListParticipant* self,
                                                      GeeList* account_mailboxes);
VALA_EXTERN gchar* conversation_list_participant_get_short_markup (ConversationListParticipant* self,
                                                       GeeList* account_mailboxes);
static void conversation_list_row_finalize (GObject * obj);
static GType conversation_list_row_get_type_once (void);
static void _vala_conversation_list_row_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);

static inline gpointer
conversation_list_row_get_instance_private (ConversationListRow* self)
{
	return G_STRUCT_MEMBER_P (self, ConversationListRow_private_offset);
}

static GeeList*
conversation_list_row_get_user_accounts (ConversationListRow* self)
{
	GeeList* result;
	GearyAppConversation* _tmp0_;
	GearyFolder* _tmp1_;
	GearyFolder* _tmp2_;
	GearyAccount* _tmp3_;
	GearyAccount* _tmp4_;
	GearyAccountInformation* _tmp5_;
	GearyAccountInformation* _tmp6_;
	GeeList* _tmp7_;
	GeeList* _tmp8_;
#line 17 "../src/client/conversation-list/conversation-list-row.vala"
	g_return_val_if_fail (CONVERSATION_LIST_IS_ROW (self), NULL);
#line 18 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp0_ = self->conversation;
#line 18 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp1_ = geary_app_conversation_get_base_folder (_tmp0_);
#line 18 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp2_ = _tmp1_;
#line 18 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp3_ = geary_folder_get_account (_tmp2_);
#line 18 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp4_ = _tmp3_;
#line 18 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp5_ = geary_account_get_information (_tmp4_);
#line 18 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp6_ = _tmp5_;
#line 18 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp7_ = geary_account_information_get_sender_mailboxes (_tmp6_);
#line 18 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp8_ = _tmp7_;
#line 18 "../src/client/conversation-list/conversation-list-row.vala"
	result = _tmp8_;
#line 18 "../src/client/conversation-list/conversation-list-row.vala"
	return result;
#line 191 "conversation-list-row.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	g_return_if_fail (n_param_values == 3);
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
		data1 = closure->data;
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
		data2 = param_values->data[0].v_pointer;
#line 216 "conversation-list-row.c"
	} else {
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
		data1 = param_values->data[0].v_pointer;
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
		data2 = closure->data;
#line 222 "conversation-list-row.c"
	}
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 228 "conversation-list-row.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_BOOLEAN) (gpointer data1, gpointer arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	g_return_if_fail (n_param_values == 3);
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
		data1 = closure->data;
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
		data2 = param_values->data[0].v_pointer;
#line 253 "conversation-list-row.c"
	} else {
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
		data1 = param_values->data[0].v_pointer;
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
		data2 = closure->data;
#line 259 "conversation-list-row.c"
	}
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	callback = (GMarshalFunc_VOID__OBJECT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_boolean (param_values + 2), data2);
#line 265 "conversation-list-row.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 44 "../src/client/conversation-list/conversation-list-row.vala"
	return self ? g_object_ref (self) : NULL;
#line 273 "conversation-list-row.c"
}

static void
_conversation_list_row_update_flags_geary_app_conversation_email_flags_changed (GearyAppConversation* _sender,
                                                                                GearyEmail* email,
                                                                                gpointer self)
{
#line 47 "../src/client/conversation-list/conversation-list-row.vala"
	conversation_list_row_update_flags ((ConversationListRow*) self, email);
#line 283 "conversation-list-row.c"
}

ConversationListRow*
conversation_list_row_construct (GType object_type,
                                 ApplicationConfiguration* config,
                                 GearyAppConversation* conversation,
                                 gboolean selection_mode_enabled)
{
	ConversationListRow * self = NULL;
	ApplicationConfiguration* _tmp0_;
	GearyAppConversation* _tmp1_;
	GtkLabel* _tmp2_;
#line 41 "../src/client/conversation-list/conversation-list-row.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (config), NULL);
#line 41 "../src/client/conversation-list/conversation-list-row.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (conversation, GEARY_APP_TYPE_CONVERSATION), NULL);
#line 41 "../src/client/conversation-list/conversation-list-row.vala"
	self = (ConversationListRow*) g_object_new (object_type, NULL);
#line 44 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp0_ = _g_object_ref0 (config);
#line 44 "../src/client/conversation-list/conversation-list-row.vala"
	_g_object_unref0 (self->priv->config);
#line 44 "../src/client/conversation-list/conversation-list-row.vala"
	self->priv->config = _tmp0_;
#line 45 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp1_ = _g_object_ref0 (conversation);
#line 45 "../src/client/conversation-list/conversation-list-row.vala"
	_g_object_unref0 (self->conversation);
#line 45 "../src/client/conversation-list/conversation-list-row.vala"
	self->conversation = _tmp1_;
#line 47 "../src/client/conversation-list/conversation-list-row.vala"
	g_signal_connect_object (conversation, "email-flags-changed", (GCallback) _conversation_list_row_update_flags_geary_app_conversation_email_flags_changed, self, 0);
#line 49 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp2_ = self->priv->preview;
#line 49 "../src/client/conversation-list/conversation-list-row.vala"
	application_configuration_bind (config, APPLICATION_CONFIGURATION_DISPLAY_PREVIEW_KEY, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, G_TYPE_OBJECT, GObject), "visible", G_SETTINGS_BIND_DEFAULT);
#line 52 "../src/client/conversation-list/conversation-list-row.vala"
	if (selection_mode_enabled) {
#line 53 "../src/client/conversation-list/conversation-list-row.vala"
		conversation_list_row_set_selection_enabled (self, TRUE);
#line 324 "conversation-list-row.c"
	}
#line 56 "../src/client/conversation-list/conversation-list-row.vala"
	conversation_list_row_update (self);
#line 41 "../src/client/conversation-list/conversation-list-row.vala"
	return self;
#line 330 "conversation-list-row.c"
}

ConversationListRow*
conversation_list_row_new (ApplicationConfiguration* config,
                           GearyAppConversation* conversation,
                           gboolean selection_mode_enabled)
{
#line 41 "../src/client/conversation-list/conversation-list-row.vala"
	return conversation_list_row_construct (CONVERSATION_LIST_TYPE_ROW, config, conversation, selection_mode_enabled);
#line 340 "conversation-list-row.c"
}

void
conversation_list_row_update (ConversationListRow* self)
{
	GearyEmail* last_email = NULL;
	GearyAppConversation* _tmp0_;
	GearyEmail* _tmp1_;
	GearyEmail* _tmp2_;
	GtkLabel* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gint count = 0;
	GearyAppConversation* _tmp20_;
#line 59 "../src/client/conversation-list/conversation-list-row.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_ROW (self));
#line 60 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp0_ = self->conversation;
#line 60 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp1_ = geary_app_conversation_get_latest_recv_email (_tmp0_, GEARY_APP_CONVERSATION_LOCATION_ANYWHERE, NULL);
#line 60 "../src/client/conversation-list/conversation-list-row.vala"
	last_email = _tmp1_;
#line 64 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp2_ = last_email;
#line 64 "../src/client/conversation-list/conversation-list-row.vala"
	if (_tmp2_ != NULL) {
#line 367 "conversation-list-row.c"
		gchar* text = NULL;
		GearyEmail* _tmp3_;
		gchar* _tmp4_;
		GtkLabel* _tmp5_;
		const gchar* _tmp6_;
		GtkLabel* _tmp7_;
		GearyEmail* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		GearyEmail* _tmp11_;
		GearyEmailProperties* _tmp12_;
		GearyEmailProperties* _tmp13_;
		GDateTime* _tmp14_;
		GDateTime* _tmp15_;
		GDateTime* _tmp16_;
#line 65 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp3_ = last_email;
#line 65 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp4_ = util_email_strip_subject_prefixes (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 65 "../src/client/conversation-list/conversation-list-row.vala"
		text = _tmp4_;
#line 66 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp5_ = self->priv->subject;
#line 66 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp6_ = text;
#line 66 "../src/client/conversation-list/conversation-list-row.vala"
		gtk_label_set_text (_tmp5_, _tmp6_);
#line 67 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp7_ = self->priv->preview;
#line 67 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp8_ = last_email;
#line 67 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp9_ = geary_email_get_preview_as_string (_tmp8_);
#line 67 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp10_ = _tmp9_;
#line 67 "../src/client/conversation-list/conversation-list-row.vala"
		gtk_label_set_text (_tmp7_, _tmp10_);
#line 67 "../src/client/conversation-list/conversation-list-row.vala"
		_g_free0 (_tmp10_);
#line 68 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp11_ = last_email;
#line 68 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp12_ = geary_email_get_properties (_tmp11_);
#line 68 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp13_ = _tmp12_;
#line 68 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp14_ = geary_email_properties_get_date_received (_tmp13_);
#line 68 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp15_ = _tmp14_;
#line 68 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp16_ = g_date_time_to_local (_tmp15_);
#line 68 "../src/client/conversation-list/conversation-list-row.vala"
		_g_date_time_unref0 (self->priv->recv_time);
#line 68 "../src/client/conversation-list/conversation-list-row.vala"
		self->priv->recv_time = _tmp16_;
#line 69 "../src/client/conversation-list/conversation-list-row.vala"
		conversation_list_row_refresh_time (self);
#line 64 "../src/client/conversation-list/conversation-list-row.vala"
		_g_free0 (text);
#line 427 "conversation-list-row.c"
	}
#line 72 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp17_ = self->priv->participants;
#line 72 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp18_ = conversation_list_row_get_participants (self);
#line 72 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp19_ = _tmp18_;
#line 72 "../src/client/conversation-list/conversation-list-row.vala"
	gtk_label_set_markup (_tmp17_, _tmp19_);
#line 72 "../src/client/conversation-list/conversation-list-row.vala"
	_g_free0 (_tmp19_);
#line 74 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp20_ = self->conversation;
#line 74 "../src/client/conversation-list/conversation-list-row.vala"
	count = geary_app_conversation_get_count (_tmp20_);
#line 75 "../src/client/conversation-list/conversation-list-row.vala"
	if (count > 1) {
#line 445 "conversation-list-row.c"
		GtkLabel* _tmp21_;
		GearyAppConversation* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
#line 76 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp21_ = self->priv->count_badge;
#line 76 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp22_ = self->conversation;
#line 76 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp23_ = g_strdup_printf ("%i", geary_app_conversation_get_count (_tmp22_));
#line 76 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp24_ = _tmp23_;
#line 76 "../src/client/conversation-list/conversation-list-row.vala"
		gtk_label_set_text (_tmp21_, _tmp24_);
#line 76 "../src/client/conversation-list/conversation-list-row.vala"
		_g_free0 (_tmp24_);
#line 462 "conversation-list-row.c"
	} else {
		GtkLabel* _tmp25_;
#line 78 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp25_ = self->priv->count_badge;
#line 78 "../src/client/conversation-list/conversation-list-row.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, gtk_widget_get_type (), GtkWidget));
#line 469 "conversation-list-row.c"
	}
#line 81 "../src/client/conversation-list/conversation-list-row.vala"
	conversation_list_row_update_flags (self, NULL);
#line 59 "../src/client/conversation-list/conversation-list-row.vala"
	_g_object_unref0 (last_email);
#line 475 "conversation-list-row.c"
}

static void
_conversation_list_row_update_button_gtk_widget_state_flags_changed (GtkWidget* _sender,
                                                                     GtkStateFlags previous_state_flags,
                                                                     gpointer self)
{
#line 88 "../src/client/conversation-list/conversation-list-row.vala"
	conversation_list_row_update_button ((ConversationListRow*) self);
#line 485 "conversation-list-row.c"
}

static void
_conversation_list_row_update_state_flags_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                     gpointer self)
{
#line 89 "../src/client/conversation-list/conversation-list-row.vala"
	conversation_list_row_update_state_flags ((ConversationListRow*) self);
#line 494 "conversation-list-row.c"
}

void
conversation_list_row_set_selection_enabled (ConversationListRow* self,
                                             gboolean enabled)
{
#line 85 "../src/client/conversation-list/conversation-list-row.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_ROW (self));
#line 86 "../src/client/conversation-list/conversation-list-row.vala"
	if (enabled) {
#line 505 "conversation-list-row.c"
		GtkCheckButton* _tmp0_;
		GtkCheckButton* _tmp1_;
#line 87 "../src/client/conversation-list/conversation-list-row.vala"
		conversation_list_row_set_button_active (self, gtk_list_box_row_is_selected (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_list_box_row_get_type (), GtkListBoxRow)));
#line 88 "../src/client/conversation-list/conversation-list-row.vala"
		g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "state-flags-changed", (GCallback) _conversation_list_row_update_button_gtk_widget_state_flags_changed, self, 0);
#line 89 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp0_ = self->priv->selected_button;
#line 89 "../src/client/conversation-list/conversation-list-row.vala"
		g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_toggle_button_get_type (), GtkToggleButton), "toggled", (GCallback) _conversation_list_row_update_state_flags_gtk_toggle_button_toggled, self, 0);
#line 90 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp1_ = self->priv->selected_button;
#line 90 "../src/client/conversation-list/conversation-list-row.vala"
		gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget));
#line 520 "conversation-list-row.c"
	} else {
		guint _tmp2_;
		GtkCheckButton* _tmp3_;
		guint _tmp4_;
		GtkCheckButton* _tmp5_;
#line 92 "../src/client/conversation-list/conversation-list-row.vala"
		g_signal_parse_name ("state-flags-changed", gtk_widget_get_type (), &_tmp2_, NULL, FALSE);
#line 92 "../src/client/conversation-list/conversation-list-row.vala"
		g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _conversation_list_row_update_button_gtk_widget_state_flags_changed, self);
#line 93 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp3_ = self->priv->selected_button;
#line 93 "../src/client/conversation-list/conversation-list-row.vala"
		g_signal_parse_name ("toggled", gtk_toggle_button_get_type (), &_tmp4_, NULL, FALSE);
#line 93 "../src/client/conversation-list/conversation-list-row.vala"
		g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_toggle_button_get_type (), GtkToggleButton), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _conversation_list_row_update_state_flags_gtk_toggle_button_toggled, self);
#line 94 "../src/client/conversation-list/conversation-list-row.vala"
		conversation_list_row_set_button_active (self, FALSE);
#line 95 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp5_ = self->priv->selected_button;
#line 95 "../src/client/conversation-list/conversation-list-row.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_widget_get_type (), GtkWidget));
#line 542 "conversation-list-row.c"
	}
}

void
conversation_list_row_refresh_time (ConversationListRow* self)
{
	GDateTime* _tmp0_;
#line 99 "../src/client/conversation-list/conversation-list-row.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_ROW (self));
#line 100 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp0_ = self->priv->recv_time;
#line 100 "../src/client/conversation-list/conversation-list-row.vala"
	if (_tmp0_ != NULL) {
#line 556 "conversation-list-row.c"
		GtkLabel* _tmp1_;
		GDateTime* _tmp2_;
		ApplicationConfiguration* _tmp3_;
		UtilDateClockFormat _tmp4_;
		UtilDateClockFormat _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 103 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp1_ = self->priv->date;
#line 103 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp2_ = self->priv->recv_time;
#line 103 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp3_ = self->priv->config;
#line 103 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp4_ = application_configuration_get_clock_format (_tmp3_);
#line 103 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp5_ = _tmp4_;
#line 103 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp6_ = util_date_pretty_print (_tmp2_, _tmp5_);
#line 103 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp7_ = _tmp6_;
#line 103 "../src/client/conversation-list/conversation-list-row.vala"
		gtk_label_set_text (_tmp1_, _tmp7_);
#line 103 "../src/client/conversation-list/conversation-list-row.vala"
		_g_free0 (_tmp7_);
#line 582 "conversation-list-row.c"
	}
}

static void
conversation_list_row_set_button_active (ConversationListRow* self,
                                         gboolean active)
{
	GtkCheckButton* _tmp0_;
#line 110 "../src/client/conversation-list/conversation-list-row.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_ROW (self));
#line 111 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp0_ = self->priv->selected_button;
#line 111 "../src/client/conversation-list/conversation-list-row.vala"
	gtk_toggle_button_set_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_toggle_button_get_type (), GtkToggleButton), active);
#line 112 "../src/client/conversation-list/conversation-list-row.vala"
	if (active) {
#line 599 "conversation-list-row.c"
		GtkStyleContext* _tmp1_;
#line 113 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp1_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 113 "../src/client/conversation-list/conversation-list-row.vala"
		gtk_style_context_add_class (_tmp1_, "selected");
#line 114 "../src/client/conversation-list/conversation-list-row.vala"
		gtk_widget_set_state_flags (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), GTK_STATE_FLAG_SELECTED, FALSE);
#line 607 "conversation-list-row.c"
	} else {
		GtkStyleContext* _tmp2_;
#line 116 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp2_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 116 "../src/client/conversation-list/conversation-list-row.vala"
		gtk_style_context_remove_class (_tmp2_, "selected");
#line 117 "../src/client/conversation-list/conversation-list-row.vala"
		gtk_widget_unset_state_flags (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), GTK_STATE_FLAG_SELECTED);
#line 616 "conversation-list-row.c"
	}
}

static void
conversation_list_row_update_button (ConversationListRow* self)
{
	gboolean is_selected = FALSE;
	GtkCheckButton* _tmp0_;
	guint _tmp1_;
	GtkCheckButton* _tmp2_;
#line 120 "../src/client/conversation-list/conversation-list-row.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_ROW (self));
#line 121 "../src/client/conversation-list/conversation-list-row.vala"
	is_selected = (gtk_widget_get_state_flags (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget)) & GTK_STATE_FLAG_SELECTED) == GTK_STATE_FLAG_SELECTED;
#line 123 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp0_ = self->priv->selected_button;
#line 123 "../src/client/conversation-list/conversation-list-row.vala"
	g_signal_parse_name ("toggled", gtk_toggle_button_get_type (), &_tmp1_, NULL, FALSE);
#line 123 "../src/client/conversation-list/conversation-list-row.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_toggle_button_get_type (), GtkToggleButton), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _conversation_list_row_update_state_flags_gtk_toggle_button_toggled, self);
#line 124 "../src/client/conversation-list/conversation-list-row.vala"
	conversation_list_row_set_button_active (self, is_selected);
#line 125 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp2_ = self->priv->selected_button;
#line 125 "../src/client/conversation-list/conversation-list-row.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_toggle_button_get_type (), GtkToggleButton), "toggled", (GCallback) _conversation_list_row_update_state_flags_gtk_toggle_button_toggled, self, 0);
#line 643 "conversation-list-row.c"
}

static void
conversation_list_row_update_state_flags (ConversationListRow* self)
{
	guint _tmp0_;
	GtkCheckButton* _tmp1_;
#line 129 "../src/client/conversation-list/conversation-list-row.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_ROW (self));
#line 130 "../src/client/conversation-list/conversation-list-row.vala"
	g_signal_parse_name ("state-flags-changed", gtk_widget_get_type (), &_tmp0_, NULL, FALSE);
#line 130 "../src/client/conversation-list/conversation-list-row.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _conversation_list_row_update_button_gtk_widget_state_flags_changed, self);
#line 131 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp1_ = self->priv->selected_button;
#line 131 "../src/client/conversation-list/conversation-list-row.vala"
	g_signal_emit (self, conversation_list_row_signals[CONVERSATION_LIST_ROW_TOGGLE_SELECTION_SIGNAL], 0, self, gtk_toggle_button_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_toggle_button_get_type (), GtkToggleButton)));
#line 132 "../src/client/conversation-list/conversation-list-row.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "state-flags-changed", (GCallback) _conversation_list_row_update_button_gtk_widget_state_flags_changed, self, 0);
#line 663 "conversation-list-row.c"
}

static void
conversation_list_row_update_flags (ConversationListRow* self,
                                    GearyEmail* email)
{
	GearyAppConversation* _tmp0_;
	GearyAppConversation* _tmp3_;
#line 135 "../src/client/conversation-list/conversation-list-row.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_ROW (self));
#line 135 "../src/client/conversation-list/conversation-list-row.vala"
	g_return_if_fail ((email == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (email, GEARY_TYPE_EMAIL));
#line 136 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp0_ = self->conversation;
#line 136 "../src/client/conversation-list/conversation-list-row.vala"
	if (geary_app_conversation_is_unread (_tmp0_)) {
#line 680 "conversation-list-row.c"
		GtkStyleContext* _tmp1_;
#line 137 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp1_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 137 "../src/client/conversation-list/conversation-list-row.vala"
		gtk_style_context_add_class (_tmp1_, "unread");
#line 686 "conversation-list-row.c"
	} else {
		GtkStyleContext* _tmp2_;
#line 139 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp2_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 139 "../src/client/conversation-list/conversation-list-row.vala"
		gtk_style_context_remove_class (_tmp2_, "unread");
#line 693 "conversation-list-row.c"
	}
#line 142 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp3_ = self->conversation;
#line 142 "../src/client/conversation-list/conversation-list-row.vala"
	if (geary_app_conversation_is_flagged (_tmp3_)) {
#line 699 "conversation-list-row.c"
		GtkImage* _tmp4_;
#line 143 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp4_ = self->priv->flagged_icon;
#line 143 "../src/client/conversation-list/conversation-list-row.vala"
		gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget));
#line 705 "conversation-list-row.c"
	} else {
		GtkImage* _tmp5_;
#line 145 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp5_ = self->priv->flagged_icon;
#line 145 "../src/client/conversation-list/conversation-list-row.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_widget_get_type (), GtkWidget));
#line 712 "conversation-list-row.c"
	}
}

static gchar*
conversation_list_row_get_participants (ConversationListRow* self)
{
	GeeArrayList* participants = NULL;
	GeeArrayList* _tmp0_;
	GeeList* emails = NULL;
	GearyAppConversation* _tmp1_;
	GeeList* _tmp2_;
	GeeArrayList* _tmp41_;
	gint _tmp42_;
	gint _tmp43_;
	GeeArrayList* _tmp45_;
	gint _tmp46_;
	gint _tmp47_;
	GString* builder = NULL;
	GString* _tmp56_;
	gboolean first = FALSE;
	GString* _tmp73_;
	const gchar* _tmp74_;
	gchar* _tmp75_;
	gchar* result;
#line 149 "../src/client/conversation-list/conversation-list-row.vala"
	g_return_val_if_fail (CONVERSATION_LIST_IS_ROW (self), NULL);
#line 150 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp0_ = gee_array_list_new (CONVERSATION_LIST_TYPE_PARTICIPANT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 150 "../src/client/conversation-list/conversation-list-row.vala"
	participants = _tmp0_;
#line 151 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp1_ = self->conversation;
#line 151 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp2_ = geary_app_conversation_get_emails (_tmp1_, GEARY_APP_CONVERSATION_ORDERING_RECV_DATE_ASCENDING, GEARY_APP_CONVERSATION_LOCATION_ANYWHERE, NULL, TRUE);
#line 151 "../src/client/conversation-list/conversation-list-row.vala"
	emails = _tmp2_;
#line 749 "conversation-list-row.c"
	{
		GeeList* _message_list = NULL;
		GeeList* _tmp3_;
		gint _message_size = 0;
		GeeList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _message_index = 0;
#line 154 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp3_ = emails;
#line 154 "../src/client/conversation-list/conversation-list-row.vala"
		_message_list = _tmp3_;
#line 154 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp4_ = _message_list;
#line 154 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp5_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_COLLECTION, GeeCollection));
#line 154 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp6_ = _tmp5_;
#line 154 "../src/client/conversation-list/conversation-list-row.vala"
		_message_size = _tmp6_;
#line 154 "../src/client/conversation-list/conversation-list-row.vala"
		_message_index = -1;
#line 154 "../src/client/conversation-list/conversation-list-row.vala"
		while (TRUE) {
#line 774 "conversation-list-row.c"
			gint _tmp7_;
			gint _tmp8_;
			GearyEmail* message = NULL;
			GeeList* _tmp9_;
			gpointer _tmp10_;
			GearyRFC822MailboxAddresses* _tmp11_ = NULL;
			GearyAppConversation* _tmp12_;
			GearyFolder* _tmp13_;
			GearyFolder* _tmp14_;
			GearyFolderSpecialUse _tmp15_;
			GearyFolderSpecialUse _tmp16_;
			GearyRFC822MailboxAddresses* addresses = NULL;
			GearyRFC822MailboxAddresses* _tmp25_;
			GearyRFC822MailboxAddresses* _tmp26_;
#line 154 "../src/client/conversation-list/conversation-list-row.vala"
			_message_index = _message_index + 1;
#line 154 "../src/client/conversation-list/conversation-list-row.vala"
			_tmp7_ = _message_index;
#line 154 "../src/client/conversation-list/conversation-list-row.vala"
			_tmp8_ = _message_size;
#line 154 "../src/client/conversation-list/conversation-list-row.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 154 "../src/client/conversation-list/conversation-list-row.vala"
				break;
#line 799 "conversation-list-row.c"
			}
#line 154 "../src/client/conversation-list/conversation-list-row.vala"
			_tmp9_ = _message_list;
#line 154 "../src/client/conversation-list/conversation-list-row.vala"
			_tmp10_ = gee_list_get (_tmp9_, _message_index);
#line 154 "../src/client/conversation-list/conversation-list-row.vala"
			message = (GearyEmail*) _tmp10_;
#line 156 "../src/client/conversation-list/conversation-list-row.vala"
			_tmp12_ = self->conversation;
#line 156 "../src/client/conversation-list/conversation-list-row.vala"
			_tmp13_ = geary_app_conversation_get_base_folder (_tmp12_);
#line 156 "../src/client/conversation-list/conversation-list-row.vala"
			_tmp14_ = _tmp13_;
#line 156 "../src/client/conversation-list/conversation-list-row.vala"
			_tmp15_ = geary_folder_get_used_as (_tmp14_);
#line 156 "../src/client/conversation-list/conversation-list-row.vala"
			_tmp16_ = _tmp15_;
#line 156 "../src/client/conversation-list/conversation-list-row.vala"
			if (geary_folder_special_use_is_outgoing (_tmp16_)) {
#line 819 "conversation-list-row.c"
				GearyEmail* _tmp17_;
				GearyRFC822MailboxAddress* _tmp18_;
				GearyRFC822MailboxAddress* _tmp19_;
				GearyRFC822MailboxAddresses* _tmp20_;
#line 157 "../src/client/conversation-list/conversation-list-row.vala"
				_tmp17_ = message;
#line 157 "../src/client/conversation-list/conversation-list-row.vala"
				_tmp18_ = util_email_get_primary_originator (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 157 "../src/client/conversation-list/conversation-list-row.vala"
				_tmp19_ = _tmp18_;
#line 157 "../src/client/conversation-list/conversation-list-row.vala"
				_tmp20_ = geary_rf_c822_mailbox_addresses_new_single (_tmp19_);
#line 157 "../src/client/conversation-list/conversation-list-row.vala"
				_g_object_unref0 (_tmp11_);
#line 157 "../src/client/conversation-list/conversation-list-row.vala"
				_tmp11_ = _tmp20_;
#line 157 "../src/client/conversation-list/conversation-list-row.vala"
				_g_object_unref0 (_tmp19_);
#line 838 "conversation-list-row.c"
			} else {
				GearyEmail* _tmp21_;
				GearyRFC822MailboxAddresses* _tmp22_;
				GearyRFC822MailboxAddresses* _tmp23_;
				GearyRFC822MailboxAddresses* _tmp24_;
#line 158 "../src/client/conversation-list/conversation-list-row.vala"
				_tmp21_ = message;
#line 158 "../src/client/conversation-list/conversation-list-row.vala"
				_tmp22_ = geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 158 "../src/client/conversation-list/conversation-list-row.vala"
				_tmp23_ = _tmp22_;
#line 158 "../src/client/conversation-list/conversation-list-row.vala"
				_tmp24_ = _g_object_ref0 (_tmp23_);
#line 158 "../src/client/conversation-list/conversation-list-row.vala"
				_g_object_unref0 (_tmp11_);
#line 158 "../src/client/conversation-list/conversation-list-row.vala"
				_tmp11_ = _tmp24_;
#line 856 "conversation-list-row.c"
			}
#line 155 "../src/client/conversation-list/conversation-list-row.vala"
			_tmp25_ = _g_object_ref0 (_tmp11_);
#line 155 "../src/client/conversation-list/conversation-list-row.vala"
			addresses = _tmp25_;
#line 160 "../src/client/conversation-list/conversation-list-row.vala"
			_tmp26_ = addresses;
#line 160 "../src/client/conversation-list/conversation-list-row.vala"
			if (_tmp26_ == NULL) {
#line 161 "../src/client/conversation-list/conversation-list-row.vala"
				_g_object_unref0 (addresses);
#line 161 "../src/client/conversation-list/conversation-list-row.vala"
				_g_object_unref0 (_tmp11_);
#line 161 "../src/client/conversation-list/conversation-list-row.vala"
				_g_object_unref0 (message);
#line 161 "../src/client/conversation-list/conversation-list-row.vala"
				continue;
#line 874 "conversation-list-row.c"
			}
			{
				GearyRFC822MailboxAddresses* _address_list = NULL;
				GearyRFC822MailboxAddresses* _tmp27_;
				gint _address_size = 0;
				GearyRFC822MailboxAddresses* _tmp28_;
				gint _tmp29_;
				gint _tmp30_;
				gint _address_index = 0;
#line 164 "../src/client/conversation-list/conversation-list-row.vala"
				_tmp27_ = addresses;
#line 164 "../src/client/conversation-list/conversation-list-row.vala"
				_address_list = _tmp27_;
#line 164 "../src/client/conversation-list/conversation-list-row.vala"
				_tmp28_ = _address_list;
#line 164 "../src/client/conversation-list/conversation-list-row.vala"
				_tmp29_ = geary_rf_c822_mailbox_addresses_get_size (_tmp28_);
#line 164 "../src/client/conversation-list/conversation-list-row.vala"
				_tmp30_ = _tmp29_;
#line 164 "../src/client/conversation-list/conversation-list-row.vala"
				_address_size = _tmp30_;
#line 164 "../src/client/conversation-list/conversation-list-row.vala"
				_address_index = -1;
#line 164 "../src/client/conversation-list/conversation-list-row.vala"
				while (TRUE) {
#line 900 "conversation-list-row.c"
					gint _tmp31_;
					gint _tmp32_;
					GearyRFC822MailboxAddress* address = NULL;
					GearyRFC822MailboxAddresses* _tmp33_;
					GearyRFC822MailboxAddress* _tmp34_;
					ConversationListParticipant* participant_display = NULL;
					GearyRFC822MailboxAddress* _tmp35_;
					ConversationListParticipant* _tmp36_;
					gint existing_index = 0;
					GeeArrayList* _tmp37_;
					ConversationListParticipant* _tmp38_;
#line 164 "../src/client/conversation-list/conversation-list-row.vala"
					_address_index = _address_index + 1;
#line 164 "../src/client/conversation-list/conversation-list-row.vala"
					_tmp31_ = _address_index;
#line 164 "../src/client/conversation-list/conversation-list-row.vala"
					_tmp32_ = _address_size;
#line 164 "../src/client/conversation-list/conversation-list-row.vala"
					if (!(_tmp31_ < _tmp32_)) {
#line 164 "../src/client/conversation-list/conversation-list-row.vala"
						break;
#line 922 "conversation-list-row.c"
					}
#line 164 "../src/client/conversation-list/conversation-list-row.vala"
					_tmp33_ = _address_list;
#line 164 "../src/client/conversation-list/conversation-list-row.vala"
					_tmp34_ = geary_rf_c822_mailbox_addresses_get (_tmp33_, _address_index);
#line 164 "../src/client/conversation-list/conversation-list-row.vala"
					address = _tmp34_;
#line 165 "../src/client/conversation-list/conversation-list-row.vala"
					_tmp35_ = address;
#line 165 "../src/client/conversation-list/conversation-list-row.vala"
					_tmp36_ = conversation_list_participant_new (_tmp35_);
#line 165 "../src/client/conversation-list/conversation-list-row.vala"
					participant_display = _tmp36_;
#line 166 "../src/client/conversation-list/conversation-list-row.vala"
					_tmp37_ = participants;
#line 166 "../src/client/conversation-list/conversation-list-row.vala"
					_tmp38_ = participant_display;
#line 166 "../src/client/conversation-list/conversation-list-row.vala"
					existing_index = gee_abstract_list_index_of (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp38_);
#line 167 "../src/client/conversation-list/conversation-list-row.vala"
					if (existing_index < 0) {
#line 944 "conversation-list-row.c"
						GeeArrayList* _tmp39_;
						ConversationListParticipant* _tmp40_;
#line 168 "../src/client/conversation-list/conversation-list-row.vala"
						_tmp39_ = participants;
#line 168 "../src/client/conversation-list/conversation-list-row.vala"
						_tmp40_ = participant_display;
#line 168 "../src/client/conversation-list/conversation-list-row.vala"
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp40_);
#line 169 "../src/client/conversation-list/conversation-list-row.vala"
						_g_object_unref0 (participant_display);
#line 169 "../src/client/conversation-list/conversation-list-row.vala"
						_g_object_unref0 (address);
#line 169 "../src/client/conversation-list/conversation-list-row.vala"
						continue;
#line 959 "conversation-list-row.c"
					}
#line 164 "../src/client/conversation-list/conversation-list-row.vala"
					_g_object_unref0 (participant_display);
#line 164 "../src/client/conversation-list/conversation-list-row.vala"
					_g_object_unref0 (address);
#line 965 "conversation-list-row.c"
				}
			}
#line 154 "../src/client/conversation-list/conversation-list-row.vala"
			_g_object_unref0 (addresses);
#line 154 "../src/client/conversation-list/conversation-list-row.vala"
			_g_object_unref0 (_tmp11_);
#line 154 "../src/client/conversation-list/conversation-list-row.vala"
			_g_object_unref0 (message);
#line 974 "conversation-list-row.c"
		}
	}
#line 174 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp41_ = participants;
#line 174 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp42_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 174 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp43_ = _tmp42_;
#line 174 "../src/client/conversation-list/conversation-list-row.vala"
	if (_tmp43_ == 0) {
#line 985 "conversation-list-row.c"
		gchar* _tmp44_;
#line 175 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp44_ = g_strdup ("");
#line 175 "../src/client/conversation-list/conversation-list-row.vala"
		result = _tmp44_;
#line 175 "../src/client/conversation-list/conversation-list-row.vala"
		_g_object_unref0 (emails);
#line 175 "../src/client/conversation-list/conversation-list-row.vala"
		_g_object_unref0 (participants);
#line 175 "../src/client/conversation-list/conversation-list-row.vala"
		return result;
#line 997 "conversation-list-row.c"
	}
#line 178 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp45_ = participants;
#line 178 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp46_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 178 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp47_ = _tmp46_;
#line 178 "../src/client/conversation-list/conversation-list-row.vala"
	if (_tmp47_ == 1) {
#line 1007 "conversation-list-row.c"
		GeeArrayList* _tmp48_;
		gpointer _tmp49_;
		ConversationListParticipant* _tmp50_;
		GeeList* _tmp51_;
		GeeList* _tmp52_;
		GeeList* _tmp53_;
		gchar* _tmp54_;
		gchar* _tmp55_;
#line 179 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp48_ = participants;
#line 179 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp49_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), 0);
#line 179 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp50_ = (ConversationListParticipant*) _tmp49_;
#line 179 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp51_ = conversation_list_row_get_user_accounts (self);
#line 179 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp52_ = _tmp51_;
#line 179 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp53_ = _tmp52_;
#line 179 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp54_ = conversation_list_participant_get_full_markup (_tmp50_, _tmp53_);
#line 179 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp55_ = _tmp54_;
#line 179 "../src/client/conversation-list/conversation-list-row.vala"
		_g_object_unref0 (_tmp53_);
#line 179 "../src/client/conversation-list/conversation-list-row.vala"
		_g_object_unref0 (_tmp50_);
#line 179 "../src/client/conversation-list/conversation-list-row.vala"
		result = _tmp55_;
#line 179 "../src/client/conversation-list/conversation-list-row.vala"
		_g_object_unref0 (emails);
#line 179 "../src/client/conversation-list/conversation-list-row.vala"
		_g_object_unref0 (participants);
#line 179 "../src/client/conversation-list/conversation-list-row.vala"
		return result;
#line 1044 "conversation-list-row.c"
	}
#line 182 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp56_ = g_string_new ("");
#line 182 "../src/client/conversation-list/conversation-list-row.vala"
	builder = _tmp56_;
#line 183 "../src/client/conversation-list/conversation-list-row.vala"
	first = TRUE;
#line 1052 "conversation-list-row.c"
	{
		GeeArrayList* _participant_list = NULL;
		GeeArrayList* _tmp57_;
		gint _participant_size = 0;
		GeeArrayList* _tmp58_;
		gint _tmp59_;
		gint _tmp60_;
		gint _participant_index = 0;
#line 184 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp57_ = participants;
#line 184 "../src/client/conversation-list/conversation-list-row.vala"
		_participant_list = _tmp57_;
#line 184 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp58_ = _participant_list;
#line 184 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp59_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp58_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 184 "../src/client/conversation-list/conversation-list-row.vala"
		_tmp60_ = _tmp59_;
#line 184 "../src/client/conversation-list/conversation-list-row.vala"
		_participant_size = _tmp60_;
#line 184 "../src/client/conversation-list/conversation-list-row.vala"
		_participant_index = -1;
#line 184 "../src/client/conversation-list/conversation-list-row.vala"
		while (TRUE) {
#line 1077 "conversation-list-row.c"
			gint _tmp61_;
			gint _tmp62_;
			ConversationListParticipant* participant = NULL;
			GeeArrayList* _tmp63_;
			gpointer _tmp64_;
			GString* _tmp66_;
			ConversationListParticipant* _tmp67_;
			GeeList* _tmp68_;
			GeeList* _tmp69_;
			GeeList* _tmp70_;
			gchar* _tmp71_;
			gchar* _tmp72_;
#line 184 "../src/client/conversation-list/conversation-list-row.vala"
			_participant_index = _participant_index + 1;
#line 184 "../src/client/conversation-list/conversation-list-row.vala"
			_tmp61_ = _participant_index;
#line 184 "../src/client/conversation-list/conversation-list-row.vala"
			_tmp62_ = _participant_size;
#line 184 "../src/client/conversation-list/conversation-list-row.vala"
			if (!(_tmp61_ < _tmp62_)) {
#line 184 "../src/client/conversation-list/conversation-list-row.vala"
				break;
#line 1100 "conversation-list-row.c"
			}
#line 184 "../src/client/conversation-list/conversation-list-row.vala"
			_tmp63_ = _participant_list;
#line 184 "../src/client/conversation-list/conversation-list-row.vala"
			_tmp64_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp63_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _participant_index);
#line 184 "../src/client/conversation-list/conversation-list-row.vala"
			participant = (ConversationListParticipant*) _tmp64_;
#line 185 "../src/client/conversation-list/conversation-list-row.vala"
			if (!first) {
#line 1110 "conversation-list-row.c"
				GString* _tmp65_;
#line 186 "../src/client/conversation-list/conversation-list-row.vala"
				_tmp65_ = builder;
#line 186 "../src/client/conversation-list/conversation-list-row.vala"
				g_string_append (_tmp65_, ", ");
#line 1116 "conversation-list-row.c"
			}
#line 189 "../src/client/conversation-list/conversation-list-row.vala"
			_tmp66_ = builder;
#line 189 "../src/client/conversation-list/conversation-list-row.vala"
			_tmp67_ = participant;
#line 189 "../src/client/conversation-list/conversation-list-row.vala"
			_tmp68_ = conversation_list_row_get_user_accounts (self);
#line 189 "../src/client/conversation-list/conversation-list-row.vala"
			_tmp69_ = _tmp68_;
#line 189 "../src/client/conversation-list/conversation-list-row.vala"
			_tmp70_ = _tmp69_;
#line 189 "../src/client/conversation-list/conversation-list-row.vala"
			_tmp71_ = conversation_list_participant_get_short_markup (_tmp67_, _tmp70_);
#line 189 "../src/client/conversation-list/conversation-list-row.vala"
			_tmp72_ = _tmp71_;
#line 189 "../src/client/conversation-list/conversation-list-row.vala"
			g_string_append (_tmp66_, _tmp72_);
#line 189 "../src/client/conversation-list/conversation-list-row.vala"
			_g_free0 (_tmp72_);
#line 189 "../src/client/conversation-list/conversation-list-row.vala"
			_g_object_unref0 (_tmp70_);
#line 190 "../src/client/conversation-list/conversation-list-row.vala"
			first = FALSE;
#line 184 "../src/client/conversation-list/conversation-list-row.vala"
			_g_object_unref0 (participant);
#line 1142 "conversation-list-row.c"
		}
	}
#line 193 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp73_ = builder;
#line 193 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp74_ = _tmp73_->str;
#line 193 "../src/client/conversation-list/conversation-list-row.vala"
	_tmp75_ = g_strdup (_tmp74_);
#line 193 "../src/client/conversation-list/conversation-list-row.vala"
	result = _tmp75_;
#line 193 "../src/client/conversation-list/conversation-list-row.vala"
	_g_string_free0 (builder);
#line 193 "../src/client/conversation-list/conversation-list-row.vala"
	_g_object_unref0 (emails);
#line 193 "../src/client/conversation-list/conversation-list-row.vala"
	_g_object_unref0 (participants);
#line 193 "../src/client/conversation-list/conversation-list-row.vala"
	return result;
#line 1161 "conversation-list-row.c"
}

static void
conversation_list_row_class_init (ConversationListRowClass * klass,
                                  gpointer klass_data)
{
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	conversation_list_row_parent_class = g_type_class_peek_parent (klass);
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	g_type_class_adjust_private_offset (klass, &ConversationListRow_private_offset);
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_conversation_list_row_get_property;
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	G_OBJECT_CLASS (klass)->finalize = conversation_list_row_finalize;
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Geary/conversation-list-row.ui");
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	conversation_list_row_signals[CONVERSATION_LIST_ROW_TOGGLE_FLAG_SIGNAL] = g_signal_new ("toggle-flag", CONVERSATION_LIST_TYPE_ROW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, CONVERSATION_LIST_TYPE_ROW, GEARY_TYPE_NAMED_FLAG);
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	conversation_list_row_signals[CONVERSATION_LIST_ROW_TOGGLE_SELECTION_SIGNAL] = g_signal_new ("toggle-selection", CONVERSATION_LIST_TYPE_ROW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN, G_TYPE_NONE, 2, CONVERSATION_LIST_TYPE_ROW, G_TYPE_BOOLEAN);
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "preview", FALSE, ConversationListRow_private_offset + G_STRUCT_OFFSET (ConversationListRowPrivate, preview));
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "subject", FALSE, ConversationListRow_private_offset + G_STRUCT_OFFSET (ConversationListRowPrivate, subject));
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "participants", FALSE, ConversationListRow_private_offset + G_STRUCT_OFFSET (ConversationListRowPrivate, participants));
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "date", FALSE, ConversationListRow_private_offset + G_STRUCT_OFFSET (ConversationListRowPrivate, date));
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "count_badge", FALSE, ConversationListRow_private_offset + G_STRUCT_OFFSET (ConversationListRowPrivate, count_badge));
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "flagged_icon", FALSE, ConversationListRow_private_offset + G_STRUCT_OFFSET (ConversationListRowPrivate, flagged_icon));
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "selected_button", FALSE, ConversationListRow_private_offset + G_STRUCT_OFFSET (ConversationListRowPrivate, selected_button));
#line 1196 "conversation-list-row.c"
}

static void
conversation_list_row_instance_init (ConversationListRow * self,
                                     gpointer klass)
{
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	self->priv = conversation_list_row_get_instance_private (self);
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1207 "conversation-list-row.c"
}

static void
conversation_list_row_finalize (GObject * obj)
{
	ConversationListRow * self;
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONVERSATION_LIST_TYPE_ROW, ConversationListRow);
#line 32 "../src/client/conversation-list/conversation-list-row.vala"
	_g_object_unref0 (self->conversation);
#line 33 "../src/client/conversation-list/conversation-list-row.vala"
	_g_object_unref0 (self->priv->config);
#line 34 "../src/client/conversation-list/conversation-list-row.vala"
	_g_date_time_unref0 (self->priv->recv_time);
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	G_OBJECT_CLASS (conversation_list_row_parent_class)->finalize (obj);
#line 1224 "conversation-list-row.c"
}

/**
 * A conversation list row displaying an email summary
 */
static GType
conversation_list_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ConversationListRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) conversation_list_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ConversationListRow), 0, (GInstanceInitFunc) conversation_list_row_instance_init, NULL };
	GType conversation_list_row_type_id;
	conversation_list_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "ConversationListRow", &g_define_type_info, 0);
	ConversationListRow_private_offset = g_type_add_instance_private (conversation_list_row_type_id, sizeof (ConversationListRowPrivate));
	return conversation_list_row_type_id;
}

GType
conversation_list_row_get_type (void)
{
	static volatile gsize conversation_list_row_type_id__once = 0;
	if (g_once_init_enter (&conversation_list_row_type_id__once)) {
		GType conversation_list_row_type_id;
		conversation_list_row_type_id = conversation_list_row_get_type_once ();
		g_once_init_leave (&conversation_list_row_type_id__once, conversation_list_row_type_id);
	}
	return conversation_list_row_type_id__once;
}

static void
_vala_conversation_list_row_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	ConversationListRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONVERSATION_LIST_TYPE_ROW, ConversationListRow);
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
	switch (property_id) {
#line 1262 "conversation-list-row.c"
		default:
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/client/conversation-list/conversation-list-row.vala"
		break;
#line 1268 "conversation-list-row.c"
	}
}

