/* conversation-list-view.c generated by valac 0.56.17, the Vala compiler
 * generated from conversation-list-view.vala, do not modify */

/*
 * Copyright © 2022 John Renner <john@jrenner.net>
 * Copyright © 2022 Cédric Bellegarde <cedric.bellegarde@adishatz.org>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-client-46.0.h"
#include <gee.h>
#include <glib-object.h>
#include "geary-engine.h"
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <cairo-gobject.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define CONVERSATION_LIST_TYPE_ROW (conversation_list_row_get_type ())
#define CONVERSATION_LIST_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONVERSATION_LIST_TYPE_ROW, ConversationListRow))
#define CONVERSATION_LIST_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONVERSATION_LIST_TYPE_ROW, ConversationListRowClass))
#define CONVERSATION_LIST_IS_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONVERSATION_LIST_TYPE_ROW))
#define CONVERSATION_LIST_IS_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONVERSATION_LIST_TYPE_ROW))
#define CONVERSATION_LIST_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONVERSATION_LIST_TYPE_ROW, ConversationListRowClass))

typedef struct _ConversationListRow ConversationListRow;
typedef struct _ConversationListRowClass ConversationListRowClass;
enum  {
	CONVERSATION_LIST_VIEW_0_PROPERTY,
	CONVERSATION_LIST_VIEW_SELECTION_MODE_ENABLED_PROPERTY,
	CONVERSATION_LIST_VIEW_SELECTED_PROPERTY,
	CONVERSATION_LIST_VIEW_VISIBLE_CONVERSATIONS_PROPERTY,
	CONVERSATION_LIST_VIEW_NUM_PROPERTIES
};
static GParamSpec* conversation_list_view_properties[CONVERSATION_LIST_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ConversationListRowPrivate ConversationListRowPrivate;
typedef struct _Block82Data Block82Data;
typedef struct _Block83Data Block83Data;
#define __vala_GdkEvent_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEvent_free (var), NULL)))
#define __vala_GdkEventSequence_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEventSequence_free (var), NULL)))
enum  {
	CONVERSATION_LIST_VIEW_CONVERSATIONS_SELECTED_SIGNAL,
	CONVERSATION_LIST_VIEW_CONVERSATION_ACTIVATED_SIGNAL,
	CONVERSATION_LIST_VIEW_MARK_CONVERSATIONS_SIGNAL,
	CONVERSATION_LIST_VIEW_NUM_SIGNALS
};
static guint conversation_list_view_signals[CONVERSATION_LIST_VIEW_NUM_SIGNALS] = {0};

struct _ConversationListViewPrivate {
	GeeSet* _selected;
	ApplicationConfiguration* config;
	GtkGestureMultiPress* press_gesture;
	GtkGestureLongPress* long_press_gesture;
	GtkEventControllerKey* key_event_controller;
	GdkModifierType last_modifier_type;
	GtkListBox* list;
	GtkListBoxRow* to_restore_row;
	ConversationListModel* model;
	gdouble LOAD_MORE_THRESHOLD;
	gint LOAD_MORE_COUNT;
	gint VISIBILITY_UPDATE_DELAY_MS;
	GeeSet* _visible_conversations;
	GearySchedulerScheduled* scheduled_visible_update;
	gboolean should_inhibit_autoactivate;
	ConversationListRow* drag_widget;
};

struct _ConversationListRow {
	GtkListBoxRow parent_instance;
	GearyAppConversation* conversation;
	ConversationListRowPrivate * priv;
};

struct _ConversationListRowClass {
	GtkListBoxRowClass parent_class;
};

struct _Block82Data {
	int _ref_count_;
	ConversationListView* self;
	GeeCollection* selection;
};

struct _Block83Data {
	int _ref_count_;
	ConversationListView* self;
	GearyAppConversation* convo;
};

static gint ConversationListView_private_offset;
static gpointer conversation_list_view_parent_class = NULL;
static GearyBaseInterfaceIface * conversation_list_view_geary_base_interface_parent_iface = NULL;

VALA_EXTERN GType conversation_list_row_get_type (void) G_GNUC_CONST ;
static void conversation_list_view_on_selection_mode_changed (ConversationListView* self);
static void _conversation_list_view_on_selection_mode_changed_g_object_notify (GObject* _sender,
                                                                        GParamSpec* pspec,
                                                                        gpointer self);
static void conversation_list_view_on_selected_rows_changed (ConversationListView* self);
static void _conversation_list_view_on_selected_rows_changed_gtk_list_box_selected_rows_changed (GtkListBox* _sender,
                                                                                          gpointer self);
static void conversation_list_view_on_row_activated (ConversationListView* self);
static void _conversation_list_view_on_row_activated_gtk_list_box_row_activated (GtkListBox* _sender,
                                                                          GtkListBoxRow* row,
                                                                          gpointer self);
static void conversation_list_view_header_func (ConversationListView* self,
                                         GtkListBoxRow* row,
                                         GtkListBoxRow* before);
static void _conversation_list_view_header_func_gtk_list_box_update_header_func (GtkListBoxRow* row,
                                                                          GtkListBoxRow* before,
                                                                          gpointer self);
static void conversation_list_view_maybe_load_more (ConversationListView* self,
                                             GtkAdjustment* adjustment);
static void _conversation_list_view_maybe_load_more_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                           gpointer self);
static void conversation_list_view_update_visible_conversations (ConversationListView* self);
static void _conversation_list_view_update_visible_conversations_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                                        gpointer self);
static void conversation_list_view_on_press_gesture_released (ConversationListView* self,
                                                       gint n_press,
                                                       gdouble x,
                                                       gdouble y);
static void _conversation_list_view_on_press_gesture_released_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                                                         gint n_press,
                                                                                         gdouble x,
                                                                                         gdouble y,
                                                                                         gpointer self);
static void __lambda28_ (ConversationListView* self,
                  GtkGestureLongPress* n_press,
                  gdouble x,
                  gdouble y);
static void ___lambda28__gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                  gdouble x,
                                                  gdouble y,
                                                  gpointer self);
static gboolean conversation_list_view_on_key_event_controller_key_pressed (ConversationListView* self,
                                                                     guint keyval,
                                                                     guint keycode,
                                                                     GdkModifierType modifier_type);
static gboolean _conversation_list_view_on_key_event_controller_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                                           guint keyval,
                                                                                                           guint keycode,
                                                                                                           GdkModifierType state,
                                                                                                           gpointer self);
static void conversation_list_view_on_drag_begin (ConversationListView* self,
                                           GdkDragContext* ctx);
static void _conversation_list_view_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                                  GdkDragContext* context,
                                                                  gpointer self);
static void conversation_list_view_on_drag_end (ConversationListView* self,
                                         GdkDragContext* ctx);
static void _conversation_list_view_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                              GdkDragContext* context,
                                                              gpointer self);
static void __lambda29_ (ConversationListView* self,
                  GtkWidget* child);
VALA_EXTERN void conversation_list_row_refresh_time (ConversationListRow* self);
static void ___lambda29__gtk_callback (GtkWidget* widget,
                                gpointer self);
static void conversation_list_view_on_conversations_loaded (ConversationListView* self);
static void _conversation_list_view_on_conversations_loaded_conversation_list_model_conversations_loaded (ConversationListModel* _sender,
                                                                                                   gpointer self);
static void conversation_list_view_on_conversations_removed (ConversationListView* self,
                                                      gboolean start);
static void _conversation_list_view_on_conversations_removed_conversation_list_model_conversations_removed (ConversationListModel* _sender,
                                                                                                     gboolean start,
                                                                                                     gpointer self);
static void conversation_list_view_on_conversation_updated (ConversationListView* self,
                                                     GearyAppConversation* convo);
static void _conversation_list_view_on_conversation_updated_conversation_list_model_conversation_updated (ConversationListModel* _sender,
                                                                                                   GearyAppConversation* convo,
                                                                                                   gpointer self);
static GtkWidget* conversation_list_view_row_factory (ConversationListView* self,
                                               GObject* convo_obj);
static GtkWidget* _conversation_list_view_row_factory_gtk_list_box_create_widget_func (GObject* item,
                                                                                gpointer self);
VALA_EXTERN ConversationListModel* conversation_list_model_new (GearyAppConversationMonitor* monitor);
VALA_EXTERN ConversationListModel* conversation_list_model_construct (GType object_type,
                                                          GearyAppConversationMonitor* monitor);
VALA_EXTERN ConversationListRow* conversation_list_row_new (ApplicationConfiguration* config,
                                                GearyAppConversation* conversation,
                                                gboolean selection_mode_enabled);
VALA_EXTERN ConversationListRow* conversation_list_row_construct (GType object_type,
                                                      ApplicationConfiguration* config,
                                                      GearyAppConversation* conversation,
                                                      gboolean selection_mode_enabled);
static void conversation_list_view_on_toggle_flags (ConversationListView* self,
                                             ConversationListRow* row,
                                             GearyNamedFlag* flag);
static void _conversation_list_view_on_toggle_flags_conversation_list_row_toggle_flag (ConversationListRow* _sender,
                                                                                ConversationListRow* row,
                                                                                GearyNamedFlag* flag,
                                                                                gpointer self);
static void conversation_list_view_on_toggle_selection (ConversationListView* self,
                                                 ConversationListRow* row,
                                                 gboolean active);
static void _conversation_list_view_on_toggle_selection_conversation_list_row_toggle_selection (ConversationListRow* _sender,
                                                                                         ConversationListRow* row,
                                                                                         gboolean active,
                                                                                         gpointer self);
static void conversation_list_view_context_menu (ConversationListView* self,
                                          ConversationListRow* row,
                                          GdkRectangle* rect);
static GtkPopover* conversation_list_view_construct_popover (ConversationListView* self,
                                                      ConversationListRow* row,
                                                      guint selection_size);
static void g_cclosure_user_marshal_VOID__OBJECT_UINT (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static Block82Data* block82_data_ref (Block82Data* _data82_);
static void block82_data_unref (void * _userdata_);
static void __lambda31_ (Block82Data* _data82_,
                  GtkWidget* child);
static void ___lambda31__gtk_callback (GtkWidget* widget,
                                gpointer self);
static gboolean conversation_list_view_selection_changed (ConversationListView* self,
                                                   GeeSet* selection);
static void conversation_list_view_restore_row (ConversationListView* self);
static gboolean ___lambda26_ (ConversationListView* self);
static gboolean ____lambda26__gsource_func (gpointer self);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void conversation_list_view_set_visible_conversations (ConversationListView* self,
                                                       GeeSet* value);
static gboolean __lambda27_ (ConversationListView* self);
static gboolean ___lambda27__gsource_func (gpointer self);
static GtkListBoxRow* conversation_list_view_get_next_conversation (ConversationListView* self,
                                                             gboolean asc);
static Block83Data* block83_data_ref (Block83Data* _data83_);
static void block83_data_unref (void * _userdata_);
static void __lambda30_ (Block83Data* _data83_,
                  GtkWidget* child);
VALA_EXTERN void conversation_list_row_update (ConversationListRow* self);
static void ___lambda30__gtk_callback (GtkWidget* widget,
                                gpointer self);
static GdkEvent* _vala_GdkEvent_copy (GdkEvent* self);
static void _vala_GdkEvent_free (GdkEvent* self);
static void _vala_GdkEventSequence_free (GdkEventSequence* self);
static void __lambda25_ (ConversationListView* self,
                  GtkWidget* child);
VALA_EXTERN void conversation_list_row_set_selection_enabled (ConversationListRow* self,
                                                  gboolean enabled);
static void ___lambda25__gtk_callback (GtkWidget* widget,
                                gpointer self);
static void conversation_list_view_finalize (GObject * obj);
static GType conversation_list_view_get_type_once (void);
static void _vala_conversation_list_view_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_conversation_list_view_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

VALA_EXTERN const GtkTargetEntry FOLDER_LIST_TREE_TARGET_ENTRY_LIST[1];

static inline gpointer
conversation_list_view_get_instance_private (ConversationListView* self)
{
	return G_STRUCT_MEMBER_P (self, ConversationListView_private_offset);
}

gboolean
conversation_list_view_get_selection_mode_enabled (ConversationListView* self)
{
	gboolean result;
	GtkListBox* _tmp0_;
#line 27 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_val_if_fail (CONVERSATION_LIST_IS_VIEW (self), FALSE);
#line 28 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = self->priv->list;
#line 28 "../src/client/conversation-list/conversation-list-view.vala"
	result = gtk_list_box_get_selection_mode (_tmp0_) == GTK_SELECTION_MULTIPLE;
#line 28 "../src/client/conversation-list/conversation-list-view.vala"
	return result;
#line 310 "conversation-list-view.c"
}

void
conversation_list_view_set_selection_mode_enabled (ConversationListView* self,
                                                   gboolean value)
{
	GtkSelectionMode _tmp0_ = 0;
	GtkSelectionMode mode = 0;
	GtkListBox* _tmp1_;
#line 30 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 31 "../src/client/conversation-list/conversation-list-view.vala"
	if (value) {
#line 31 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp0_ = GTK_SELECTION_MULTIPLE;
#line 326 "conversation-list-view.c"
	} else {
#line 31 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp0_ = GTK_SELECTION_SINGLE;
#line 330 "conversation-list-view.c"
	}
#line 31 "../src/client/conversation-list/conversation-list-view.vala"
	mode = _tmp0_;
#line 32 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp1_ = self->priv->list;
#line 32 "../src/client/conversation-list/conversation-list-view.vala"
	if (gtk_list_box_get_selection_mode (_tmp1_) != mode) {
#line 338 "conversation-list-view.c"
		GtkListBox* _tmp2_;
#line 33 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp2_ = self->priv->list;
#line 33 "../src/client/conversation-list/conversation-list-view.vala"
		gtk_list_box_set_selection_mode (_tmp2_, mode);
#line 34 "../src/client/conversation-list/conversation-list-view.vala"
		g_object_notify (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "selection-mode-enabled");
#line 346 "conversation-list-view.c"
	}
}

GeeSet*
conversation_list_view_get_selected (ConversationListView* self)
{
	GeeSet* result;
	GeeSet* _tmp0_;
#line 40 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_val_if_fail (CONVERSATION_LIST_IS_VIEW (self), NULL);
#line 40 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = self->priv->_selected;
#line 40 "../src/client/conversation-list/conversation-list-view.vala"
	result = _tmp0_;
#line 40 "../src/client/conversation-list/conversation-list-view.vala"
	return result;
#line 363 "conversation-list-view.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 40 "../src/client/conversation-list/conversation-list-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 371 "conversation-list-view.c"
}

void
conversation_list_view_set_selected (ConversationListView* self,
                                     GeeSet* value)
{
	GeeSet* old_value;
#line 40 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 40 "../src/client/conversation-list/conversation-list-view.vala"
	old_value = conversation_list_view_get_selected (self);
#line 40 "../src/client/conversation-list/conversation-list-view.vala"
	if (old_value != value) {
#line 385 "conversation-list-view.c"
		GeeSet* _tmp0_;
#line 40 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 40 "../src/client/conversation-list/conversation-list-view.vala"
		_g_object_unref0 (self->priv->_selected);
#line 40 "../src/client/conversation-list/conversation-list-view.vala"
		self->priv->_selected = _tmp0_;
#line 40 "../src/client/conversation-list/conversation-list-view.vala"
		g_object_notify_by_pspec ((GObject *) self, conversation_list_view_properties[CONVERSATION_LIST_VIEW_SELECTED_PROPERTY]);
#line 395 "conversation-list-view.c"
	}
}

static void
_conversation_list_view_on_selection_mode_changed_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self)
{
#line 60 "../src/client/conversation-list/conversation-list-view.vala"
	conversation_list_view_on_selection_mode_changed ((ConversationListView*) self);
#line 406 "conversation-list-view.c"
}

static void
_conversation_list_view_on_selected_rows_changed_gtk_list_box_selected_rows_changed (GtkListBox* _sender,
                                                                                     gpointer self)
{
#line 62 "../src/client/conversation-list/conversation-list-view.vala"
	conversation_list_view_on_selected_rows_changed ((ConversationListView*) self);
#line 415 "conversation-list-view.c"
}

static void
_conversation_list_view_on_row_activated_gtk_list_box_row_activated (GtkListBox* _sender,
                                                                     GtkListBoxRow* row,
                                                                     gpointer self)
{
#line 63 "../src/client/conversation-list/conversation-list-view.vala"
	conversation_list_view_on_row_activated ((ConversationListView*) self);
#line 425 "conversation-list-view.c"
}

static void
_conversation_list_view_header_func_gtk_list_box_update_header_func (GtkListBoxRow* row,
                                                                     GtkListBoxRow* before,
                                                                     gpointer self)
{
#line 65 "../src/client/conversation-list/conversation-list-view.vala"
	conversation_list_view_header_func ((ConversationListView*) self, row, before);
#line 435 "conversation-list-view.c"
}

static void
_conversation_list_view_maybe_load_more_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                      gpointer self)
{
#line 67 "../src/client/conversation-list/conversation-list-view.vala"
	conversation_list_view_maybe_load_more ((ConversationListView*) self, _sender);
#line 444 "conversation-list-view.c"
}

static void
_conversation_list_view_update_visible_conversations_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                                   gpointer self)
{
#line 68 "../src/client/conversation-list/conversation-list-view.vala"
	conversation_list_view_update_visible_conversations ((ConversationListView*) self);
#line 453 "conversation-list-view.c"
}

static void
_conversation_list_view_on_press_gesture_released_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                                                    gint n_press,
                                                                                    gdouble x,
                                                                                    gdouble y,
                                                                                    gpointer self)
{
#line 72 "../src/client/conversation-list/conversation-list-view.vala"
	conversation_list_view_on_press_gesture_released ((ConversationListView*) self, n_press, x, y);
#line 465 "conversation-list-view.c"
}

static void
__lambda28_ (ConversationListView* self,
             GtkGestureLongPress* n_press,
             gdouble x,
             gdouble y)
{
	ConversationListRow* row = NULL;
	GtkListBox* _tmp0_;
	GtkListBoxRow* _tmp1_;
	ConversationListRow* _tmp2_;
	ConversationListRow* _tmp3_;
#line 76 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (n_press, gtk_gesture_long_press_get_type ()));
#line 77 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = self->priv->list;
#line 77 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp1_ = gtk_list_box_get_row_at_y (_tmp0_, (gint) y);
#line 77 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, CONVERSATION_LIST_TYPE_ROW, ConversationListRow));
#line 77 "../src/client/conversation-list/conversation-list-view.vala"
	row = _tmp2_;
#line 78 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp3_ = row;
#line 78 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp3_ != NULL) {
#line 493 "conversation-list-view.c"
		GtkListBox* _tmp4_;
#line 79 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp4_ = self->priv->list;
#line 79 "../src/client/conversation-list/conversation-list-view.vala"
		gtk_list_box_unselect_all (_tmp4_);
#line 80 "../src/client/conversation-list/conversation-list-view.vala"
		conversation_list_view_set_selection_mode_enabled (self, TRUE);
#line 501 "conversation-list-view.c"
	}
#line 76 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (row);
#line 505 "conversation-list-view.c"
}

static void
___lambda28__gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                             gdouble x,
                                             gdouble y,
                                             gpointer self)
{
#line 76 "../src/client/conversation-list/conversation-list-view.vala"
	__lambda28_ ((ConversationListView*) self, _sender, x, y);
#line 516 "conversation-list-view.c"
}

static gboolean
_conversation_list_view_on_key_event_controller_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                                  guint keyval,
                                                                                                  guint keycode,
                                                                                                  GdkModifierType state,
                                                                                                  gpointer self)
{
	gboolean result;
	result = conversation_list_view_on_key_event_controller_key_pressed ((ConversationListView*) self, keyval, keycode, state);
#line 85 "../src/client/conversation-list/conversation-list-view.vala"
	return result;
#line 530 "conversation-list-view.c"
}

static void
_conversation_list_view_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                             GdkDragContext* context,
                                                             gpointer self)
{
#line 89 "../src/client/conversation-list/conversation-list-view.vala"
	conversation_list_view_on_drag_begin ((ConversationListView*) self, context);
#line 540 "conversation-list-view.c"
}

static void
_conversation_list_view_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                         GdkDragContext* context,
                                                         gpointer self)
{
#line 90 "../src/client/conversation-list/conversation-list-view.vala"
	conversation_list_view_on_drag_end ((ConversationListView*) self, context);
#line 550 "conversation-list-view.c"
}

ConversationListView*
conversation_list_view_construct (GType object_type,
                                  ApplicationConfiguration* config)
{
	ConversationListView * self = NULL;
	ApplicationConfiguration* _tmp0_;
	GtkListBox* _tmp1_;
	GtkListBox* _tmp2_;
	GtkListBox* _tmp3_;
	GtkAdjustment* _tmp4_;
	GtkAdjustment* _tmp5_;
	GtkAdjustment* _tmp6_;
	GtkAdjustment* _tmp7_;
	GtkListBox* _tmp8_;
	GtkGestureMultiPress* _tmp9_;
	GtkGestureMultiPress* _tmp10_;
	GtkGestureMultiPress* _tmp11_;
	GtkListBox* _tmp12_;
	GtkGestureLongPress* _tmp13_;
	GtkGestureLongPress* _tmp14_;
	GtkGestureLongPress* _tmp15_;
	GtkListBox* _tmp16_;
	GtkEventControllerKey* _tmp17_;
	GtkEventControllerKey* _tmp18_;
	GtkListBox* _tmp19_;
	GtkListBox* _tmp20_;
	GtkListBox* _tmp21_;
#line 57 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (config), NULL);
#line 57 "../src/client/conversation-list/conversation-list-view.vala"
	self = (ConversationListView*) g_object_new (object_type, NULL);
#line 58 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = _g_object_ref0 (config);
#line 58 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (self->priv->config);
#line 58 "../src/client/conversation-list/conversation-list-view.vala"
	self->priv->config = _tmp0_;
#line 60 "../src/client/conversation-list/conversation-list-view.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "notify::selection-mode-enabled", (GCallback) _conversation_list_view_on_selection_mode_changed_g_object_notify, self, 0);
#line 62 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp1_ = self->priv->list;
#line 62 "../src/client/conversation-list/conversation-list-view.vala"
	g_signal_connect_object (_tmp1_, "selected-rows-changed", (GCallback) _conversation_list_view_on_selected_rows_changed_gtk_list_box_selected_rows_changed, self, 0);
#line 63 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp2_ = self->priv->list;
#line 63 "../src/client/conversation-list/conversation-list-view.vala"
	g_signal_connect_object (_tmp2_, "row-activated", (GCallback) _conversation_list_view_on_row_activated_gtk_list_box_row_activated, self, 0);
#line 65 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp3_ = self->priv->list;
#line 65 "../src/client/conversation-list/conversation-list-view.vala"
	gtk_list_box_set_header_func (_tmp3_, _conversation_list_view_header_func_gtk_list_box_update_header_func, g_object_ref (self), g_object_unref);
#line 67 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp4_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
#line 67 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp5_ = _tmp4_;
#line 67 "../src/client/conversation-list/conversation-list-view.vala"
	g_signal_connect_object (_tmp5_, "value-changed", (GCallback) _conversation_list_view_maybe_load_more_gtk_adjustment_value_changed, self, 0);
#line 68 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp6_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
#line 68 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp7_ = _tmp6_;
#line 68 "../src/client/conversation-list/conversation-list-view.vala"
	g_signal_connect_object (_tmp7_, "value-changed", (GCallback) _conversation_list_view_update_visible_conversations_gtk_adjustment_value_changed, self, 0);
#line 70 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp8_ = self->priv->list;
#line 70 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp9_ = (GtkGestureMultiPress*) gtk_gesture_multi_press_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget));
#line 70 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (self->priv->press_gesture);
#line 70 "../src/client/conversation-list/conversation-list-view.vala"
	self->priv->press_gesture = _tmp9_;
#line 71 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp10_ = self->priv->press_gesture;
#line 71 "../src/client/conversation-list/conversation-list-view.vala"
	gtk_gesture_single_set_button (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_gesture_single_get_type (), GtkGestureSingle), (guint) 0);
#line 72 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp11_ = self->priv->press_gesture;
#line 72 "../src/client/conversation-list/conversation-list-view.vala"
	g_signal_connect_object (_tmp11_, "released", (GCallback) _conversation_list_view_on_press_gesture_released_gtk_gesture_multi_press_released, self, 0);
#line 74 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp12_ = self->priv->list;
#line 74 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp13_ = (GtkGestureLongPress*) gtk_gesture_long_press_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_widget_get_type (), GtkWidget));
#line 74 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (self->priv->long_press_gesture);
#line 74 "../src/client/conversation-list/conversation-list-view.vala"
	self->priv->long_press_gesture = _tmp13_;
#line 75 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp14_ = self->priv->long_press_gesture;
#line 75 "../src/client/conversation-list/conversation-list-view.vala"
	gtk_event_controller_set_propagation_phase (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_event_controller_get_type (), GtkEventController), GTK_PHASE_CAPTURE);
#line 76 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp15_ = self->priv->long_press_gesture;
#line 76 "../src/client/conversation-list/conversation-list-view.vala"
	g_signal_connect_object (_tmp15_, "pressed", (GCallback) ___lambda28__gtk_gesture_long_press_pressed, self, 0);
#line 84 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp16_ = self->priv->list;
#line 84 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp17_ = (GtkEventControllerKey*) gtk_event_controller_key_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_widget_get_type (), GtkWidget));
#line 84 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (self->priv->key_event_controller);
#line 84 "../src/client/conversation-list/conversation-list-view.vala"
	self->priv->key_event_controller = _tmp17_;
#line 85 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp18_ = self->priv->key_event_controller;
#line 85 "../src/client/conversation-list/conversation-list-view.vala"
	g_signal_connect_object (_tmp18_, "key-pressed", (GCallback) _conversation_list_view_on_key_event_controller_key_pressed_gtk_event_controller_key_key_pressed, self, 0);
#line 87 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp19_ = self->priv->list;
#line 87 "../src/client/conversation-list/conversation-list-view.vala"
	gtk_drag_source_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_widget_get_type (), GtkWidget), GDK_BUTTON1_MASK, FOLDER_LIST_TREE_TARGET_ENTRY_LIST, (gint) G_N_ELEMENTS (FOLDER_LIST_TREE_TARGET_ENTRY_LIST), GDK_ACTION_COPY | GDK_ACTION_MOVE);
#line 89 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp20_ = self->priv->list;
#line 89 "../src/client/conversation-list/conversation-list-view.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, gtk_widget_get_type (), GtkWidget), "drag-begin", (GCallback) _conversation_list_view_on_drag_begin_gtk_widget_drag_begin, self, 0);
#line 90 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp21_ = self->priv->list;
#line 90 "../src/client/conversation-list/conversation-list-view.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, gtk_widget_get_type (), GtkWidget), "drag-end", (GCallback) _conversation_list_view_on_drag_end_gtk_widget_drag_end, self, 0);
#line 57 "../src/client/conversation-list/conversation-list-view.vala"
	return self;
#line 674 "conversation-list-view.c"
}

ConversationListView*
conversation_list_view_new (ApplicationConfiguration* config)
{
#line 57 "../src/client/conversation-list/conversation-list-view.vala"
	return conversation_list_view_construct (CONVERSATION_LIST_TYPE_VIEW, config);
#line 682 "conversation-list-view.c"
}

static void
conversation_list_view_header_func (ConversationListView* self,
                                    GtkListBoxRow* row,
                                    GtkListBoxRow* before)
{
#line 100 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 100 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (row, gtk_list_box_row_get_type ()));
#line 100 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail ((before == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (before, gtk_list_box_row_get_type ()));
#line 101 "../src/client/conversation-list/conversation-list-view.vala"
	if (before != NULL) {
#line 698 "conversation-list-view.c"
		GtkSeparator* sep = NULL;
		GtkSeparator* _tmp0_;
		GtkSeparator* _tmp1_;
		GtkSeparator* _tmp2_;
#line 102 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp0_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 102 "../src/client/conversation-list/conversation-list-view.vala"
		g_object_ref_sink (_tmp0_);
#line 102 "../src/client/conversation-list/conversation-list-view.vala"
		sep = _tmp0_;
#line 103 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp1_ = sep;
#line 103 "../src/client/conversation-list/conversation-list-view.vala"
		gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget));
#line 104 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp2_ = sep;
#line 104 "../src/client/conversation-list/conversation-list-view.vala"
		gtk_list_box_row_set_header (row, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_widget_get_type (), GtkWidget));
#line 101 "../src/client/conversation-list/conversation-list-view.vala"
		_g_object_unref0 (sep);
#line 719 "conversation-list-view.c"
	}
}

/**
     * Updates the display of the received time on each list row.
     *
     * Because the received time is displayed as relative to the current time,
     * it must be periodically updated. ConversationList.View does not do this
     * automatically but instead it must be externally scheduled
     */
static void
__lambda29_ (ConversationListView* self,
             GtkWidget* child)
{
	ConversationListRow* row = NULL;
	ConversationListRow* _tmp0_;
#line 116 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (child, gtk_widget_get_type ()));
#line 117 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (child, CONVERSATION_LIST_TYPE_ROW, ConversationListRow));
#line 117 "../src/client/conversation-list/conversation-list-view.vala"
	row = _tmp0_;
#line 118 "../src/client/conversation-list/conversation-list-view.vala"
	conversation_list_row_refresh_time (row);
#line 116 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (row);
#line 746 "conversation-list-view.c"
}

static void
___lambda29__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
#line 116 "../src/client/conversation-list/conversation-list-view.vala"
	__lambda29_ ((ConversationListView*) self, widget);
#line 755 "conversation-list-view.c"
}

void
conversation_list_view_refresh_times (ConversationListView* self)
{
	GtkListBox* _tmp0_;
#line 115 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 116 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = self->priv->list;
#line 116 "../src/client/conversation-list/conversation-list-view.vala"
	gtk_container_foreach (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_container_get_type (), GtkContainer), ___lambda29__gtk_callback, self);
#line 768 "conversation-list-view.c"
}

/**
     * Set the conversation monitor which the listview is displaying
     */
static void
_conversation_list_view_on_conversations_loaded_conversation_list_model_conversations_loaded (ConversationListModel* _sender,
                                                                                              gpointer self)
{
#line 136 "../src/client/conversation-list/conversation-list-view.vala"
	conversation_list_view_on_conversations_loaded ((ConversationListView*) self);
#line 780 "conversation-list-view.c"
}

static void
_conversation_list_view_on_conversations_removed_conversation_list_model_conversations_removed (ConversationListModel* _sender,
                                                                                                gboolean start,
                                                                                                gpointer self)
{
#line 137 "../src/client/conversation-list/conversation-list-view.vala"
	conversation_list_view_on_conversations_removed ((ConversationListView*) self, start);
#line 790 "conversation-list-view.c"
}

static void
_conversation_list_view_on_conversation_updated_conversation_list_model_conversation_updated (ConversationListModel* _sender,
                                                                                              GearyAppConversation* convo,
                                                                                              gpointer self)
{
#line 138 "../src/client/conversation-list/conversation-list-view.vala"
	conversation_list_view_on_conversation_updated ((ConversationListView*) self, convo);
#line 800 "conversation-list-view.c"
}

static GtkWidget*
_conversation_list_view_row_factory_gtk_list_box_create_widget_func (GObject* item,
                                                                     gpointer self)
{
	GtkWidget* result;
	result = conversation_list_view_row_factory ((ConversationListView*) self, item);
#line 142 "../src/client/conversation-list/conversation-list-view.vala"
	return result;
#line 811 "conversation-list-view.c"
}

void
conversation_list_view_set_monitor (ConversationListView* self,
                                    GearyAppConversationMonitor* monitor)
{
	ConversationListModel* _tmp0_;
#line 134 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 134 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail ((monitor == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (monitor, GEARY_APP_TYPE_CONVERSATION_MONITOR));
#line 135 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = self->priv->model;
#line 135 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp0_ != NULL) {
#line 827 "conversation-list-view.c"
		ConversationListModel* _tmp1_;
		guint _tmp2_;
		ConversationListModel* _tmp3_;
		guint _tmp4_;
		ConversationListModel* _tmp5_;
		guint _tmp6_;
#line 136 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp1_ = self->priv->model;
#line 136 "../src/client/conversation-list/conversation-list-view.vala"
		g_signal_parse_name ("conversations-loaded", CONVERSATION_LIST_TYPE_MODEL, &_tmp2_, NULL, FALSE);
#line 136 "../src/client/conversation-list/conversation-list-view.vala"
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _conversation_list_view_on_conversations_loaded_conversation_list_model_conversations_loaded, self);
#line 137 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp3_ = self->priv->model;
#line 137 "../src/client/conversation-list/conversation-list-view.vala"
		g_signal_parse_name ("conversations-removed", CONVERSATION_LIST_TYPE_MODEL, &_tmp4_, NULL, FALSE);
#line 137 "../src/client/conversation-list/conversation-list-view.vala"
		g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _conversation_list_view_on_conversations_removed_conversation_list_model_conversations_removed, self);
#line 138 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp5_ = self->priv->model;
#line 138 "../src/client/conversation-list/conversation-list-view.vala"
		g_signal_parse_name ("conversation-updated", CONVERSATION_LIST_TYPE_MODEL, &_tmp6_, NULL, FALSE);
#line 138 "../src/client/conversation-list/conversation-list-view.vala"
		g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _conversation_list_view_on_conversation_updated_conversation_list_model_conversation_updated, self);
#line 852 "conversation-list-view.c"
	}
#line 140 "../src/client/conversation-list/conversation-list-view.vala"
	if (monitor == NULL) {
#line 856 "conversation-list-view.c"
		GtkListBox* _tmp7_;
#line 141 "../src/client/conversation-list/conversation-list-view.vala"
		_g_object_unref0 (self->priv->model);
#line 141 "../src/client/conversation-list/conversation-list-view.vala"
		self->priv->model = NULL;
#line 142 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp7_ = self->priv->list;
#line 142 "../src/client/conversation-list/conversation-list-view.vala"
		gtk_list_box_bind_model (_tmp7_, NULL, _conversation_list_view_row_factory_gtk_list_box_create_widget_func, g_object_ref (self), g_object_unref);
#line 866 "conversation-list-view.c"
	} else {
		ConversationListModel* _tmp8_;
		GtkListBox* _tmp9_;
		ConversationListModel* _tmp10_;
		ConversationListModel* _tmp11_;
		ConversationListModel* _tmp12_;
		ConversationListModel* _tmp13_;
#line 144 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp8_ = conversation_list_model_new (monitor);
#line 144 "../src/client/conversation-list/conversation-list-view.vala"
		_g_object_unref0 (self->priv->model);
#line 144 "../src/client/conversation-list/conversation-list-view.vala"
		self->priv->model = _tmp8_;
#line 145 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp9_ = self->priv->list;
#line 145 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp10_ = self->priv->model;
#line 145 "../src/client/conversation-list/conversation-list-view.vala"
		gtk_list_box_bind_model (_tmp9_, G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, g_list_model_get_type (), GListModel), _conversation_list_view_row_factory_gtk_list_box_create_widget_func, g_object_ref (self), g_object_unref);
#line 146 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp11_ = self->priv->model;
#line 146 "../src/client/conversation-list/conversation-list-view.vala"
		g_signal_connect_object (_tmp11_, "conversations-loaded", (GCallback) _conversation_list_view_on_conversations_loaded_conversation_list_model_conversations_loaded, self, 0);
#line 147 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp12_ = self->priv->model;
#line 147 "../src/client/conversation-list/conversation-list-view.vala"
		g_signal_connect_object (_tmp12_, "conversations-removed", (GCallback) _conversation_list_view_on_conversations_removed_conversation_list_model_conversations_removed, self, 0);
#line 148 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp13_ = self->priv->model;
#line 148 "../src/client/conversation-list/conversation-list-view.vala"
		g_signal_connect_object (_tmp13_, "conversation-updated", (GCallback) _conversation_list_view_on_conversation_updated_conversation_list_model_conversation_updated, self, 0);
#line 898 "conversation-list-view.c"
	}
}

/**
     * Attempt to load more conversations from the current monitor
     */
void
conversation_list_view_load_more (ConversationListView* self,
                                  gint request)
{
	ConversationListModel* _tmp0_;
#line 155 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 156 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = self->priv->model;
#line 156 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp0_ != NULL) {
#line 916 "conversation-list-view.c"
		ConversationListModel* _tmp1_;
#line 157 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp1_ = self->priv->model;
#line 157 "../src/client/conversation-list/conversation-list-view.vala"
		conversation_list_model_load_more (_tmp1_, request);
#line 922 "conversation-list-view.c"
	}
}

void
conversation_list_view_scroll (ConversationListView* self,
                               GtkScrollType scroll_type)
{
	GtkListBoxRow* row = NULL;
	GtkListBox* _tmp0_;
	GtkListBoxRow* _tmp1_;
	GtkListBoxRow* _tmp2_;
	GtkListBoxRow* _tmp3_;
	gint index = 0;
	GtkListBoxRow* _tmp4_;
	GtkListBoxRow* _tmp11_;
#line 161 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 162 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = self->priv->list;
#line 162 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp1_ = gtk_list_box_get_selected_row (_tmp0_);
#line 162 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 162 "../src/client/conversation-list/conversation-list-view.vala"
	row = _tmp2_;
#line 164 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp3_ = row;
#line 164 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp3_ == NULL) {
#line 165 "../src/client/conversation-list/conversation-list-view.vala"
		_g_object_unref0 (row);
#line 165 "../src/client/conversation-list/conversation-list-view.vala"
		return;
#line 956 "conversation-list-view.c"
	}
#line 168 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp4_ = row;
#line 168 "../src/client/conversation-list/conversation-list-view.vala"
	index = gtk_list_box_row_get_index (_tmp4_);
#line 169 "../src/client/conversation-list/conversation-list-view.vala"
	if (scroll_type == GTK_SCROLL_STEP_UP) {
#line 964 "conversation-list-view.c"
		GtkListBox* _tmp5_;
		GtkListBoxRow* _tmp6_;
		GtkListBoxRow* _tmp7_;
#line 170 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp5_ = self->priv->list;
#line 170 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp6_ = gtk_list_box_get_row_at_index (_tmp5_, index - 1);
#line 170 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp7_ = _g_object_ref0 (_tmp6_);
#line 170 "../src/client/conversation-list/conversation-list-view.vala"
		_g_object_unref0 (row);
#line 170 "../src/client/conversation-list/conversation-list-view.vala"
		row = _tmp7_;
#line 978 "conversation-list-view.c"
	} else {
		GtkListBox* _tmp8_;
		GtkListBoxRow* _tmp9_;
		GtkListBoxRow* _tmp10_;
#line 172 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp8_ = self->priv->list;
#line 172 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp9_ = gtk_list_box_get_row_at_index (_tmp8_, index + 1);
#line 172 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp10_ = _g_object_ref0 (_tmp9_);
#line 172 "../src/client/conversation-list/conversation-list-view.vala"
		_g_object_unref0 (row);
#line 172 "../src/client/conversation-list/conversation-list-view.vala"
		row = _tmp10_;
#line 993 "conversation-list-view.c"
	}
#line 175 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp11_ = row;
#line 175 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp11_ != NULL) {
#line 999 "conversation-list-view.c"
		GtkListBox* _tmp12_;
		GtkListBoxRow* _tmp13_;
#line 176 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp12_ = self->priv->list;
#line 176 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp13_ = row;
#line 176 "../src/client/conversation-list/conversation-list-view.vala"
		gtk_list_box_select_row (_tmp12_, _tmp13_);
#line 1008 "conversation-list-view.c"
	}
#line 161 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (row);
#line 1012 "conversation-list-view.c"
}

static void
_conversation_list_view_on_toggle_flags_conversation_list_row_toggle_flag (ConversationListRow* _sender,
                                                                           ConversationListRow* row,
                                                                           GearyNamedFlag* flag,
                                                                           gpointer self)
{
#line 183 "../src/client/conversation-list/conversation-list-view.vala"
	conversation_list_view_on_toggle_flags ((ConversationListView*) self, row, flag);
#line 1023 "conversation-list-view.c"
}

static void
_conversation_list_view_on_toggle_selection_conversation_list_row_toggle_selection (ConversationListRow* _sender,
                                                                                    ConversationListRow* row,
                                                                                    gboolean active,
                                                                                    gpointer self)
{
#line 184 "../src/client/conversation-list/conversation-list-view.vala"
	conversation_list_view_on_toggle_selection ((ConversationListView*) self, row, active);
#line 1034 "conversation-list-view.c"
}

static GtkWidget*
conversation_list_view_row_factory (ConversationListView* self,
                                    GObject* convo_obj)
{
	GearyAppConversation* convo = NULL;
	GearyAppConversation* _tmp0_;
	ConversationListRow* row = NULL;
	ApplicationConfiguration* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	ConversationListRow* _tmp4_;
	GtkWidget* result;
#line 180 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_val_if_fail (CONVERSATION_LIST_IS_VIEW (self), NULL);
#line 180 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (convo_obj, G_TYPE_OBJECT), NULL);
#line 181 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (convo_obj, GEARY_APP_TYPE_CONVERSATION, GearyAppConversation));
#line 181 "../src/client/conversation-list/conversation-list-view.vala"
	convo = _tmp0_;
#line 182 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp1_ = self->priv->config;
#line 182 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp2_ = conversation_list_view_get_selection_mode_enabled (self);
#line 182 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp3_ = _tmp2_;
#line 182 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp4_ = conversation_list_row_new (_tmp1_, convo, _tmp3_);
#line 182 "../src/client/conversation-list/conversation-list-view.vala"
	g_object_ref_sink (_tmp4_);
#line 182 "../src/client/conversation-list/conversation-list-view.vala"
	row = _tmp4_;
#line 183 "../src/client/conversation-list/conversation-list-view.vala"
	g_signal_connect_object (row, "toggle-flag", (GCallback) _conversation_list_view_on_toggle_flags_conversation_list_row_toggle_flag, self, 0);
#line 184 "../src/client/conversation-list/conversation-list-view.vala"
	g_signal_connect_object (row, "toggle-selection", (GCallback) _conversation_list_view_on_toggle_selection_conversation_list_row_toggle_selection, self, 0);
#line 185 "../src/client/conversation-list/conversation-list-view.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (row, gtk_widget_get_type (), GtkWidget);
#line 185 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (convo);
#line 185 "../src/client/conversation-list/conversation-list-view.vala"
	return result;
#line 1079 "conversation-list-view.c"
}

static void
conversation_list_view_context_menu (ConversationListView* self,
                                     ConversationListRow* row,
                                     GdkRectangle* rect)
{
	GtkPopover* popup_menu = NULL;
	GtkListBox* _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
	GtkPopover* _tmp5_;
	GtkPopover* _tmp6_;
	GtkPopover* _tmp9_;
#line 192 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 192 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_ROW (row));
#line 193 "../src/client/conversation-list/conversation-list-view.vala"
	if (!gtk_list_box_row_is_selected (G_TYPE_CHECK_INSTANCE_CAST (row, gtk_list_box_row_get_type (), GtkListBoxRow))) {
#line 1100 "conversation-list-view.c"
		GtkListBox* _tmp0_;
		GtkListBox* _tmp1_;
#line 194 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp0_ = self->priv->list;
#line 194 "../src/client/conversation-list/conversation-list-view.vala"
		gtk_list_box_unselect_all (_tmp0_);
#line 195 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp1_ = self->priv->list;
#line 195 "../src/client/conversation-list/conversation-list-view.vala"
		gtk_list_box_select_row (_tmp1_, G_TYPE_CHECK_INSTANCE_CAST (row, gtk_list_box_row_get_type (), GtkListBoxRow));
#line 1111 "conversation-list-view.c"
	}
#line 198 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp2_ = self->priv->list;
#line 198 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp3_ = gtk_list_box_get_selected_rows (_tmp2_);
#line 198 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp4_ = _tmp3_;
#line 198 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp5_ = conversation_list_view_construct_popover (self, row, g_list_length (_tmp4_));
#line 198 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp6_ = _tmp5_;
#line 198 "../src/client/conversation-list/conversation-list-view.vala"
	(_tmp4_ == NULL) ? NULL : (_tmp4_ = (g_list_free (_tmp4_), NULL));
#line 198 "../src/client/conversation-list/conversation-list-view.vala"
	popup_menu = _tmp6_;
#line 199 "../src/client/conversation-list/conversation-list-view.vala"
	if (rect != NULL) {
#line 1129 "conversation-list-view.c"
		GtkPopover* _tmp7_;
		GdkRectangle _tmp8_;
#line 200 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp7_ = popup_menu;
#line 200 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp8_ = *rect;
#line 200 "../src/client/conversation-list/conversation-list-view.vala"
		gtk_popover_set_pointing_to (_tmp7_, &_tmp8_);
#line 1138 "conversation-list-view.c"
	}
#line 202 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp9_ = popup_menu;
#line 202 "../src/client/conversation-list/conversation-list-view.vala"
	gtk_popover_popup (_tmp9_);
#line 192 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (popup_menu);
#line 1146 "conversation-list-view.c"
}

static GtkPopover*
conversation_list_view_construct_popover (ConversationListView* self,
                                          ConversationListRow* row,
                                          guint selection_size)
{
	GMenu* context_menu_model = NULL;
	GMenu* _tmp0_;
	ApplicationMainWindow* main = NULL;
	GtkWidget* _tmp1_;
	ApplicationMainWindow* _tmp2_;
	ApplicationMainWindow* _tmp3_;
	GearyAppConversation* _tmp13_;
	GearyAppConversation* _tmp17_;
	GearyAppConversation* _tmp21_;
	gboolean _tmp28_ = FALSE;
	GearyAppConversation* _tmp29_;
	GearyFolder* _tmp30_;
	GearyFolder* _tmp31_;
	GearyFolderSpecialUse _tmp32_;
	GearyFolderSpecialUse _tmp33_;
	GMenu* actions_section = NULL;
	GMenu* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	GMenu* _tmp49_;
	GtkPopover* context_menu = NULL;
	GMenu* _tmp50_;
	GtkPopover* _tmp51_;
	GtkPopover* result;
#line 205 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_val_if_fail (CONVERSATION_LIST_IS_VIEW (self), NULL);
#line 205 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_val_if_fail (CONVERSATION_LIST_IS_ROW (row), NULL);
#line 206 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = g_menu_new ();
#line 206 "../src/client/conversation-list/conversation-list-view.vala"
	context_menu_model = _tmp0_;
#line 207 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp1_ = gtk_widget_get_toplevel (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 207 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp2_ = _g_object_ref0 (APPLICATION_IS_MAIN_WINDOW (_tmp1_) ? ((ApplicationMainWindow*) _tmp1_) : NULL);
#line 207 "../src/client/conversation-list/conversation-list-view.vala"
	main = _tmp2_;
#line 209 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp3_ = main;
#line 209 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp3_ != NULL) {
#line 1200 "conversation-list-view.c"
		ApplicationMainWindow* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 210 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp4_ = main;
#line 210 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp5_ = application_main_window_get_is_shift_down (_tmp4_);
#line 210 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp6_ = _tmp5_;
#line 210 "../src/client/conversation-list/conversation-list-view.vala"
		if (!_tmp6_) {
#line 1212 "conversation-list-view.c"
			GMenu* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
#line 211 "../src/client/conversation-list/conversation-list-view.vala"
			_tmp7_ = context_menu_model;
#line 211 "../src/client/conversation-list/conversation-list-view.vala"
			_tmp8_ = action_window_prefix (APPLICATION_MAIN_WINDOW_ACTION_TRASH_CONVERSATION);
#line 211 "../src/client/conversation-list/conversation-list-view.vala"
			_tmp9_ = _tmp8_;
#line 211 "../src/client/conversation-list/conversation-list-view.vala"
			g_menu_append (_tmp7_, ngettext ("Move conversation to _Trash", "Move conversations to _Trash", (gulong) selection_size), _tmp9_);
#line 211 "../src/client/conversation-list/conversation-list-view.vala"
			_g_free0 (_tmp9_);
#line 1226 "conversation-list-view.c"
		} else {
			GMenu* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 223 "../src/client/conversation-list/conversation-list-view.vala"
			_tmp10_ = context_menu_model;
#line 223 "../src/client/conversation-list/conversation-list-view.vala"
			_tmp11_ = action_window_prefix (APPLICATION_MAIN_WINDOW_ACTION_DELETE_CONVERSATION);
#line 223 "../src/client/conversation-list/conversation-list-view.vala"
			_tmp12_ = _tmp11_;
#line 223 "../src/client/conversation-list/conversation-list-view.vala"
			g_menu_append (_tmp10_, ngettext ("_Delete conversation", "_Delete conversations", (gulong) selection_size), _tmp12_);
#line 223 "../src/client/conversation-list/conversation-list-view.vala"
			_g_free0 (_tmp12_);
#line 1241 "conversation-list-view.c"
		}
	}
#line 237 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp13_ = row->conversation;
#line 237 "../src/client/conversation-list/conversation-list-view.vala"
	if (geary_app_conversation_is_unread (_tmp13_)) {
#line 1248 "conversation-list-view.c"
		GMenu* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 238 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp14_ = context_menu_model;
#line 238 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp15_ = action_window_prefix (APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_READ);
#line 238 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp16_ = _tmp15_;
#line 238 "../src/client/conversation-list/conversation-list-view.vala"
		g_menu_append (_tmp14_, _ ("Mark as _Read"), _tmp16_);
#line 238 "../src/client/conversation-list/conversation-list-view.vala"
		_g_free0 (_tmp16_);
#line 1262 "conversation-list-view.c"
	}
#line 246 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp17_ = row->conversation;
#line 246 "../src/client/conversation-list/conversation-list-view.vala"
	if (geary_app_conversation_has_any_read_message (_tmp17_)) {
#line 1268 "conversation-list-view.c"
		GMenu* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
#line 247 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp18_ = context_menu_model;
#line 247 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp19_ = action_window_prefix (APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_UNREAD);
#line 247 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp20_ = _tmp19_;
#line 247 "../src/client/conversation-list/conversation-list-view.vala"
		g_menu_append (_tmp18_, _ ("Mark as _Unread"), _tmp20_);
#line 247 "../src/client/conversation-list/conversation-list-view.vala"
		_g_free0 (_tmp20_);
#line 1282 "conversation-list-view.c"
	}
#line 255 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp21_ = row->conversation;
#line 255 "../src/client/conversation-list/conversation-list-view.vala"
	if (geary_app_conversation_is_flagged (_tmp21_)) {
#line 1288 "conversation-list-view.c"
		GMenu* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
#line 256 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp22_ = context_menu_model;
#line 256 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp23_ = action_window_prefix (APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_UNSTARRED);
#line 256 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp24_ = _tmp23_;
#line 256 "../src/client/conversation-list/conversation-list-view.vala"
		g_menu_append (_tmp22_, _ ("U_nstar"), _tmp24_);
#line 256 "../src/client/conversation-list/conversation-list-view.vala"
		_g_free0 (_tmp24_);
#line 1302 "conversation-list-view.c"
	} else {
		GMenu* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
#line 263 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp25_ = context_menu_model;
#line 263 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp26_ = action_window_prefix (APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_STARRED);
#line 263 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp27_ = _tmp26_;
#line 263 "../src/client/conversation-list/conversation-list-view.vala"
		g_menu_append (_tmp25_, _ ("_Star"), _tmp27_);
#line 263 "../src/client/conversation-list/conversation-list-view.vala"
		_g_free0 (_tmp27_);
#line 1317 "conversation-list-view.c"
	}
#line 271 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp29_ = row->conversation;
#line 271 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp30_ = geary_app_conversation_get_base_folder (_tmp29_);
#line 271 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp31_ = _tmp30_;
#line 271 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp32_ = geary_folder_get_used_as (_tmp31_);
#line 271 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp33_ = _tmp32_;
#line 271 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp33_ != GEARY_FOLDER_SPECIAL_USE_ARCHIVE) {
#line 1331 "conversation-list-view.c"
		GearyAppConversation* _tmp34_;
		GearyFolder* _tmp35_;
		GearyFolder* _tmp36_;
		GearyFolderSpecialUse _tmp37_;
		GearyFolderSpecialUse _tmp38_;
#line 272 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp34_ = row->conversation;
#line 272 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp35_ = geary_app_conversation_get_base_folder (_tmp34_);
#line 272 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp36_ = _tmp35_;
#line 272 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp37_ = geary_folder_get_used_as (_tmp36_);
#line 272 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp38_ = _tmp37_;
#line 272 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp28_ = _tmp38_ != GEARY_FOLDER_SPECIAL_USE_ALL_MAIL;
#line 1349 "conversation-list-view.c"
	} else {
#line 271 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp28_ = FALSE;
#line 1353 "conversation-list-view.c"
	}
#line 271 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp28_) {
#line 1357 "conversation-list-view.c"
		GMenu* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
#line 273 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp39_ = context_menu_model;
#line 273 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp40_ = action_window_prefix (APPLICATION_MAIN_WINDOW_ACTION_ARCHIVE_CONVERSATION);
#line 273 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp41_ = _tmp40_;
#line 273 "../src/client/conversation-list/conversation-list-view.vala"
		g_menu_append (_tmp39_, ngettext ("_Archive conversation", "_Archive conversations", (gulong) selection_size), _tmp41_);
#line 273 "../src/client/conversation-list/conversation-list-view.vala"
		_g_free0 (_tmp41_);
#line 1371 "conversation-list-view.c"
	}
#line 285 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp42_ = g_menu_new ();
#line 285 "../src/client/conversation-list/conversation-list-view.vala"
	actions_section = _tmp42_;
#line 286 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp43_ = action_window_prefix (APPLICATION_MAIN_WINDOW_ACTION_REPLY_CONVERSATION);
#line 286 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp44_ = _tmp43_;
#line 286 "../src/client/conversation-list/conversation-list-view.vala"
	g_menu_append (actions_section, _ ("_Reply"), _tmp44_);
#line 286 "../src/client/conversation-list/conversation-list-view.vala"
	_g_free0 (_tmp44_);
#line 292 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp45_ = action_window_prefix (APPLICATION_MAIN_WINDOW_ACTION_REPLY_ALL_CONVERSATION);
#line 292 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp46_ = _tmp45_;
#line 292 "../src/client/conversation-list/conversation-list-view.vala"
	g_menu_append (actions_section, _ ("R_eply All"), _tmp46_);
#line 292 "../src/client/conversation-list/conversation-list-view.vala"
	_g_free0 (_tmp46_);
#line 298 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp47_ = action_window_prefix (APPLICATION_MAIN_WINDOW_ACTION_FORWARD_CONVERSATION);
#line 298 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp48_ = _tmp47_;
#line 298 "../src/client/conversation-list/conversation-list-view.vala"
	g_menu_append (actions_section, _ ("_Forward"), _tmp48_);
#line 298 "../src/client/conversation-list/conversation-list-view.vala"
	_g_free0 (_tmp48_);
#line 304 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp49_ = context_menu_model;
#line 304 "../src/client/conversation-list/conversation-list-view.vala"
	g_menu_append_section (_tmp49_, NULL, G_TYPE_CHECK_INSTANCE_CAST (actions_section, g_menu_model_get_type (), GMenuModel));
#line 310 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp50_ = context_menu_model;
#line 310 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp51_ = (GtkPopover*) gtk_popover_new_from_model (G_TYPE_CHECK_INSTANCE_CAST (row, gtk_widget_get_type (), GtkWidget), G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, g_menu_model_get_type (), GMenuModel));
#line 310 "../src/client/conversation-list/conversation-list-view.vala"
	g_object_ref_sink (_tmp51_);
#line 310 "../src/client/conversation-list/conversation-list-view.vala"
	context_menu = _tmp51_;
#line 314 "../src/client/conversation-list/conversation-list-view.vala"
	result = context_menu;
#line 314 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (actions_section);
#line 314 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (main);
#line 314 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (context_menu_model);
#line 314 "../src/client/conversation-list/conversation-list-view.vala"
	return result;
#line 1423 "conversation-list-view.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_UINT (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_UINT) (gpointer data1, gpointer arg_1, guint arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_UINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (n_param_values == 3);
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		data1 = closure->data;
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		data2 = param_values->data[0].v_pointer;
#line 1448 "conversation-list-view.c"
	} else {
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		data1 = param_values->data[0].v_pointer;
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		data2 = closure->data;
#line 1454 "conversation-list-view.c"
	}
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	callback = (GMarshalFunc_VOID__OBJECT_UINT) (marshal_data ? marshal_data : cc->callback);
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_uint (param_values + 2), data2);
#line 1460 "conversation-list-view.c"
}

/**
     * Gets the conversations represented by the current selection in the ListBox
     */
GeeSet*
conversation_list_view_get_selected_conversations (ConversationListView* self)
{
	GeeHashSet* selected = NULL;
	GeeHashSet* _tmp0_;
	GtkListBox* _tmp1_;
	GList* _tmp2_;
	GeeSet* result;
#line 335 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_val_if_fail (CONVERSATION_LIST_IS_VIEW (self), NULL);
#line 336 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = gee_hash_set_new (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 336 "../src/client/conversation-list/conversation-list-view.vala"
	selected = _tmp0_;
#line 338 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp1_ = self->priv->list;
#line 338 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp2_ = gtk_list_box_get_selected_rows (_tmp1_);
#line 1484 "conversation-list-view.c"
	{
		GList* row_collection = NULL;
		GList* row_it = NULL;
#line 338 "../src/client/conversation-list/conversation-list-view.vala"
		row_collection = _tmp2_;
#line 338 "../src/client/conversation-list/conversation-list-view.vala"
		for (row_it = row_collection; row_it != NULL; row_it = row_it->next) {
#line 1492 "conversation-list-view.c"
			GtkListBoxRow* row = NULL;
#line 338 "../src/client/conversation-list/conversation-list-view.vala"
			row = (GtkListBoxRow*) row_it->data;
#line 1496 "conversation-list-view.c"
			{
				GeeHashSet* _tmp3_;
				GtkListBoxRow* _tmp4_;
				GearyAppConversation* _tmp5_;
#line 339 "../src/client/conversation-list/conversation-list-view.vala"
				_tmp3_ = selected;
#line 339 "../src/client/conversation-list/conversation-list-view.vala"
				_tmp4_ = row;
#line 339 "../src/client/conversation-list/conversation-list-view.vala"
				_tmp5_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, CONVERSATION_LIST_TYPE_ROW, ConversationListRow)->conversation;
#line 339 "../src/client/conversation-list/conversation-list-view.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp5_);
#line 1509 "conversation-list-view.c"
			}
		}
#line 338 "../src/client/conversation-list/conversation-list-view.vala"
		(row_collection == NULL) ? NULL : (row_collection = (g_list_free (row_collection), NULL));
#line 1514 "conversation-list-view.c"
	}
#line 341 "../src/client/conversation-list/conversation-list-view.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (selected, GEE_TYPE_SET, GeeSet);
#line 341 "../src/client/conversation-list/conversation-list-view.vala"
	return result;
#line 1520 "conversation-list-view.c"
}

/**
     * Selects the rows for a given collection of conversations
     *
     * If a conversation is not present in the ListBox, it is ignored.
     */
static Block82Data*
block82_data_ref (Block82Data* _data82_)
{
#line 349 "../src/client/conversation-list/conversation-list-view.vala"
	g_atomic_int_inc (&_data82_->_ref_count_);
#line 349 "../src/client/conversation-list/conversation-list-view.vala"
	return _data82_;
#line 1535 "conversation-list-view.c"
}

static void
block82_data_unref (void * _userdata_)
{
	Block82Data* _data82_;
	_data82_ = (Block82Data*) _userdata_;
#line 349 "../src/client/conversation-list/conversation-list-view.vala"
	if (g_atomic_int_dec_and_test (&_data82_->_ref_count_)) {
#line 1545 "conversation-list-view.c"
		ConversationListView* self;
#line 349 "../src/client/conversation-list/conversation-list-view.vala"
		self = _data82_->self;
#line 349 "../src/client/conversation-list/conversation-list-view.vala"
		_g_object_unref0 (_data82_->selection);
#line 349 "../src/client/conversation-list/conversation-list-view.vala"
		_g_object_unref0 (self);
#line 349 "../src/client/conversation-list/conversation-list-view.vala"
		g_slice_free (Block82Data, _data82_);
#line 1555 "conversation-list-view.c"
	}
}

static void
__lambda31_ (Block82Data* _data82_,
             GtkWidget* child)
{
	ConversationListView* self;
	ConversationListRow* row = NULL;
	ConversationListRow* _tmp0_;
	GearyAppConversation* conversation = NULL;
	ConversationListRow* _tmp1_;
	GearyAppConversation* _tmp2_;
	GearyAppConversation* _tmp3_;
	GearyAppConversation* _tmp4_;
#line 350 "../src/client/conversation-list/conversation-list-view.vala"
	self = _data82_->self;
#line 350 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (child, gtk_widget_get_type ()));
#line 351 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (child, CONVERSATION_LIST_TYPE_ROW, ConversationListRow));
#line 351 "../src/client/conversation-list/conversation-list-view.vala"
	row = _tmp0_;
#line 352 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp1_ = row;
#line 352 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp2_ = _tmp1_->conversation;
#line 352 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 352 "../src/client/conversation-list/conversation-list-view.vala"
	conversation = _tmp3_;
#line 353 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp4_ = conversation;
#line 353 "../src/client/conversation-list/conversation-list-view.vala"
	if (gee_collection_contains (_data82_->selection, _tmp4_)) {
#line 1591 "conversation-list-view.c"
		GtkListBox* _tmp5_;
		ConversationListRow* _tmp6_;
#line 354 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp5_ = self->priv->list;
#line 354 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp6_ = row;
#line 354 "../src/client/conversation-list/conversation-list-view.vala"
		gtk_list_box_select_row (_tmp5_, G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_list_box_row_get_type (), GtkListBoxRow));
#line 1600 "conversation-list-view.c"
	}
#line 350 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (conversation);
#line 350 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (row);
#line 1606 "conversation-list-view.c"
}

static void
___lambda31__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
#line 350 "../src/client/conversation-list/conversation-list-view.vala"
	__lambda31_ (self, widget);
#line 1615 "conversation-list-view.c"
}

void
conversation_list_view_select_conversations (ConversationListView* self,
                                             GeeCollection* selection)
{
	Block82Data* _data82_;
	GeeCollection* _tmp0_;
	GtkListBox* _tmp1_;
#line 349 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 349 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (selection, GEE_TYPE_COLLECTION));
#line 349 "../src/client/conversation-list/conversation-list-view.vala"
	_data82_ = g_slice_new0 (Block82Data);
#line 349 "../src/client/conversation-list/conversation-list-view.vala"
	_data82_->_ref_count_ = 1;
#line 349 "../src/client/conversation-list/conversation-list-view.vala"
	_data82_->self = g_object_ref (self);
#line 349 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = _g_object_ref0 (selection);
#line 349 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (_data82_->selection);
#line 349 "../src/client/conversation-list/conversation-list-view.vala"
	_data82_->selection = _tmp0_;
#line 350 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp1_ = self->priv->list;
#line 350 "../src/client/conversation-list/conversation-list-view.vala"
	gtk_container_foreach (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_container_get_type (), GtkContainer), ___lambda31__gtk_callback, _data82_);
#line 349 "../src/client/conversation-list/conversation-list-view.vala"
	block82_data_unref (_data82_);
#line 349 "../src/client/conversation-list/conversation-list-view.vala"
	_data82_ = NULL;
#line 1649 "conversation-list-view.c"
}

/**
     * Activate currently selected row
     *
     * If more than one selected, activate the first one
     */
void
conversation_list_view_activate_selected (ConversationListView* self)
{
	GeeSet* conversations = NULL;
	GeeSet* _tmp0_;
	GeeSet* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 364 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 365 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = conversation_list_view_get_selected_conversations (self);
#line 365 "../src/client/conversation-list/conversation-list-view.vala"
	conversations = _tmp0_;
#line 366 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp1_ = conversations;
#line 366 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp2_ = gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 366 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp3_ = _tmp2_;
#line 366 "../src/client/conversation-list/conversation-list-view.vala"
	if (!_tmp3_) {
#line 1679 "conversation-list-view.c"
		GeeSet* _tmp4_;
		gint _tmp5_ = 0;
		gpointer* _tmp6_;
		GearyAppConversation** _tmp7_;
		gint _tmp7__length1;
		GearyAppConversation* _tmp8_;
#line 367 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp4_ = conversations;
#line 367 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp6_ = gee_collection_to_array (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_COLLECTION, GeeCollection), &_tmp5_);
#line 367 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp7_ = _tmp6_;
#line 367 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp7__length1 = _tmp5_;
#line 367 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp8_ = _tmp7_[0];
#line 367 "../src/client/conversation-list/conversation-list-view.vala"
		g_signal_emit (self, conversation_list_view_signals[CONVERSATION_LIST_VIEW_CONVERSATION_ACTIVATED_SIGNAL], 0, _tmp8_, (guint) 1);
#line 367 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_object_unref), NULL);
#line 1700 "conversation-list-view.c"
	}
#line 364 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (conversations);
#line 1704 "conversation-list-view.c"
}

/**
     * Selects all conversations
     */
void
conversation_list_view_select_all (ConversationListView* self)
{
	GtkListBox* _tmp0_;
#line 374 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 375 "../src/client/conversation-list/conversation-list-view.vala"
	conversation_list_view_set_selection_mode_enabled (self, TRUE);
#line 376 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = self->priv->list;
#line 376 "../src/client/conversation-list/conversation-list-view.vala"
	gtk_list_box_select_all (_tmp0_);
#line 1722 "conversation-list-view.c"
}

/**
     * Unselects all conversations
     */
void
conversation_list_view_unselect_all (ConversationListView* self)
{
	GtkListBox* _tmp0_;
#line 382 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 383 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = self->priv->list;
#line 383 "../src/client/conversation-list/conversation-list-view.vala"
	gtk_list_box_unselect_all (_tmp0_);
#line 1738 "conversation-list-view.c"
}

static gboolean
conversation_list_view_selection_changed (ConversationListView* self,
                                          GeeSet* selection)
{
	gboolean changed = FALSE;
	GeeSet* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean result;
#line 386 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_val_if_fail (CONVERSATION_LIST_IS_VIEW (self), FALSE);
#line 386 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (selection, GEE_TYPE_SET), FALSE);
#line 387 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = self->priv->_selected;
#line 387 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp1_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection));
#line 387 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp2_ = _tmp1_;
#line 387 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp3_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (selection, GEE_TYPE_COLLECTION, GeeCollection));
#line 387 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp4_ = _tmp3_;
#line 387 "../src/client/conversation-list/conversation-list-view.vala"
	changed = _tmp2_ != _tmp4_;
#line 388 "../src/client/conversation-list/conversation-list-view.vala"
	if (changed) {
#line 389 "../src/client/conversation-list/conversation-list-view.vala"
		result = TRUE;
#line 389 "../src/client/conversation-list/conversation-list-view.vala"
		return result;
#line 1774 "conversation-list-view.c"
	}
	{
		GeeIterator* _conversation_it = NULL;
		GeeIterator* _tmp5_;
#line 391 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp5_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (selection, GEE_TYPE_ITERABLE, GeeIterable));
#line 391 "../src/client/conversation-list/conversation-list-view.vala"
		_conversation_it = _tmp5_;
#line 391 "../src/client/conversation-list/conversation-list-view.vala"
		while (TRUE) {
#line 1785 "conversation-list-view.c"
			GeeIterator* _tmp6_;
			GearyAppConversation* conversation = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeSet* _tmp9_;
			GearyAppConversation* _tmp10_;
#line 391 "../src/client/conversation-list/conversation-list-view.vala"
			_tmp6_ = _conversation_it;
#line 391 "../src/client/conversation-list/conversation-list-view.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 391 "../src/client/conversation-list/conversation-list-view.vala"
				break;
#line 1798 "conversation-list-view.c"
			}
#line 391 "../src/client/conversation-list/conversation-list-view.vala"
			_tmp7_ = _conversation_it;
#line 391 "../src/client/conversation-list/conversation-list-view.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 391 "../src/client/conversation-list/conversation-list-view.vala"
			conversation = (GearyAppConversation*) _tmp8_;
#line 392 "../src/client/conversation-list/conversation-list-view.vala"
			_tmp9_ = self->priv->_selected;
#line 392 "../src/client/conversation-list/conversation-list-view.vala"
			_tmp10_ = conversation;
#line 392 "../src/client/conversation-list/conversation-list-view.vala"
			if (!gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_COLLECTION, GeeCollection), _tmp10_)) {
#line 393 "../src/client/conversation-list/conversation-list-view.vala"
				changed = TRUE;
#line 1814 "conversation-list-view.c"
			}
#line 391 "../src/client/conversation-list/conversation-list-view.vala"
			_g_object_unref0 (conversation);
#line 1818 "conversation-list-view.c"
		}
#line 391 "../src/client/conversation-list/conversation-list-view.vala"
		_g_object_unref0 (_conversation_it);
#line 1822 "conversation-list-view.c"
	}
#line 396 "../src/client/conversation-list/conversation-list-view.vala"
	result = changed;
#line 396 "../src/client/conversation-list/conversation-list-view.vala"
	return result;
#line 1828 "conversation-list-view.c"
}

static gboolean
___lambda26_ (ConversationListView* self)
{
	GtkListBoxRow* _tmp0_;
	gboolean result;
#line 404 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = self->priv->to_restore_row;
#line 404 "../src/client/conversation-list/conversation-list-view.vala"
	g_signal_emit_by_name (_tmp0_, "activate");
#line 405 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (self->priv->to_restore_row);
#line 405 "../src/client/conversation-list/conversation-list-view.vala"
	self->priv->to_restore_row = NULL;
#line 406 "../src/client/conversation-list/conversation-list-view.vala"
	result = FALSE;
#line 406 "../src/client/conversation-list/conversation-list-view.vala"
	return result;
#line 1848 "conversation-list-view.c"
}

static gboolean
____lambda26__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda26_ ((ConversationListView*) self);
#line 403 "../src/client/conversation-list/conversation-list-view.vala"
	return result;
#line 1858 "conversation-list-view.c"
}

static void
conversation_list_view_restore_row (ConversationListView* self)
{
	GtkListBoxRow* _tmp0_;
#line 399 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 400 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = self->priv->to_restore_row;
#line 400 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp0_ != NULL) {
#line 403 "../src/client/conversation-list/conversation-list-view.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, ____lambda26__gsource_func, g_object_ref (self), g_object_unref);
#line 1873 "conversation-list-view.c"
	}
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (n_param_values == 3);
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		data1 = closure->data;
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		data2 = param_values->data[0].v_pointer;
#line 1899 "conversation-list-view.c"
	} else {
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		data1 = param_values->data[0].v_pointer;
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		data2 = closure->data;
#line 1905 "conversation-list-view.c"
	}
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 1911 "conversation-list-view.c"
}

static void
conversation_list_view_on_toggle_flags (ConversationListView* self,
                                        ConversationListRow* row,
                                        GearyNamedFlag* flag)
{
#line 422 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 422 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_ROW (row));
#line 422 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (flag, GEARY_TYPE_NAMED_FLAG));
#line 423 "../src/client/conversation-list/conversation-list-view.vala"
	if (gtk_list_box_row_is_selected (G_TYPE_CHECK_INSTANCE_CAST (row, gtk_list_box_row_get_type (), GtkListBoxRow))) {
#line 1927 "conversation-list-view.c"
		GeeSet* _tmp0_;
#line 424 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp0_ = self->priv->_selected;
#line 424 "../src/client/conversation-list/conversation-list-view.vala"
		g_signal_emit (self, conversation_list_view_signals[CONVERSATION_LIST_VIEW_MARK_CONVERSATIONS_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), flag);
#line 1933 "conversation-list-view.c"
	} else {
		GearyAppConversation* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
#line 426 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp1_ = row->conversation;
#line 426 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp2_ = geary_collection_single (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp1_);
#line 426 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp3_ = _tmp2_;
#line 426 "../src/client/conversation-list/conversation-list-view.vala"
		g_signal_emit (self, conversation_list_view_signals[CONVERSATION_LIST_VIEW_MARK_CONVERSATIONS_SIGNAL], 0, _tmp3_, flag);
#line 426 "../src/client/conversation-list/conversation-list-view.vala"
		_g_object_unref0 (_tmp3_);
#line 1948 "conversation-list-view.c"
	}
}

static void
conversation_list_view_on_toggle_selection (ConversationListView* self,
                                            ConversationListRow* row,
                                            gboolean active)
{
#line 430 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 430 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_ROW (row));
#line 431 "../src/client/conversation-list/conversation-list-view.vala"
	if (active) {
#line 1963 "conversation-list-view.c"
		GtkListBox* _tmp0_;
#line 432 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp0_ = self->priv->list;
#line 432 "../src/client/conversation-list/conversation-list-view.vala"
		gtk_list_box_select_row (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (row, gtk_list_box_row_get_type (), GtkListBoxRow));
#line 1969 "conversation-list-view.c"
	} else {
		GtkListBox* _tmp1_;
#line 434 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp1_ = self->priv->list;
#line 434 "../src/client/conversation-list/conversation-list-view.vala"
		gtk_list_box_unselect_row (_tmp1_, G_TYPE_CHECK_INSTANCE_CAST (row, gtk_list_box_row_get_type (), GtkListBoxRow));
#line 1976 "conversation-list-view.c"
	}
}

/**
     * Called on scroll to possibly load more conversations from the model
     */
static void
conversation_list_view_maybe_load_more (ConversationListView* self,
                                        GtkAdjustment* adjustment)
{
	gdouble upper = 0.0;
	gdouble threshold = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 453 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 453 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (adjustment, gtk_adjustment_get_type ()));
#line 454 "../src/client/conversation-list/conversation-list-view.vala"
	upper = gtk_adjustment_get_upper (adjustment);
#line 455 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = gtk_adjustment_get_page_size (adjustment);
#line 455 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp1_ = _tmp0_;
#line 455 "../src/client/conversation-list/conversation-list-view.vala"
	threshold = (upper - _tmp1_) - self->priv->LOAD_MORE_THRESHOLD;
#line 457 "../src/client/conversation-list/conversation-list-view.vala"
	if (gtk_widget_is_visible (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget))) {
#line 457 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp2_ = gtk_adjustment_get_value (adjustment) >= threshold;
#line 2008 "conversation-list-view.c"
	} else {
#line 457 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp2_ = FALSE;
#line 2012 "conversation-list-view.c"
	}
#line 457 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp2_) {
#line 458 "../src/client/conversation-list/conversation-list-view.vala"
		conversation_list_view_load_more (self, self->priv->LOAD_MORE_COUNT);
#line 2018 "conversation-list-view.c"
	}
}

GeeSet*
conversation_list_view_get_visible_conversations (ConversationListView* self)
{
	GeeSet* result;
	GeeSet* _tmp0_;
#line 472 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_val_if_fail (CONVERSATION_LIST_IS_VIEW (self), NULL);
#line 472 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = self->priv->_visible_conversations;
#line 472 "../src/client/conversation-list/conversation-list-view.vala"
	result = _tmp0_;
#line 472 "../src/client/conversation-list/conversation-list-view.vala"
	return result;
#line 2035 "conversation-list-view.c"
}

static void
conversation_list_view_set_visible_conversations (ConversationListView* self,
                                                  GeeSet* value)
{
	GeeSet* old_value;
#line 472 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 472 "../src/client/conversation-list/conversation-list-view.vala"
	old_value = conversation_list_view_get_visible_conversations (self);
#line 472 "../src/client/conversation-list/conversation-list-view.vala"
	if (old_value != value) {
#line 2049 "conversation-list-view.c"
		GeeSet* _tmp0_;
#line 472 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 472 "../src/client/conversation-list/conversation-list-view.vala"
		_g_object_unref0 (self->priv->_visible_conversations);
#line 472 "../src/client/conversation-list/conversation-list-view.vala"
		self->priv->_visible_conversations = _tmp0_;
#line 472 "../src/client/conversation-list/conversation-list-view.vala"
		g_object_notify_by_pspec ((GObject *) self, conversation_list_view_properties[CONVERSATION_LIST_VIEW_VISIBLE_CONVERSATIONS_PROPERTY]);
#line 2059 "conversation-list-view.c"
	}
}

/**
     * Called on scroll to update the set of visible conversations
     */
static gboolean
__lambda27_ (ConversationListView* self)
{
	GeeHashSet* visible = NULL;
	GeeHashSet* _tmp0_;
	GtkListBoxRow* first = NULL;
	GtkListBox* _tmp1_;
	GtkAdjustment* _tmp2_;
	GtkAdjustment* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	GtkListBoxRow* _tmp6_;
	GtkListBoxRow* _tmp7_;
	GtkListBoxRow* _tmp8_;
	guint start_index = 0U;
	GtkListBoxRow* _tmp10_;
	guint end_index = 0U;
	GtkAdjustment* _tmp11_;
	GtkAdjustment* _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	GtkListBoxRow* _tmp15_;
	ConversationListModel* _tmp16_;
	GeeHashSet* _tmp24_;
	gboolean result;
#line 484 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = gee_hash_set_new (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 484 "../src/client/conversation-list/conversation-list-view.vala"
	visible = _tmp0_;
#line 485 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp1_ = self->priv->list;
#line 485 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp2_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
#line 485 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp3_ = _tmp2_;
#line 485 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp4_ = gtk_adjustment_get_value (_tmp3_);
#line 485 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp5_ = _tmp4_;
#line 485 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp6_ = gtk_list_box_get_row_at_y (_tmp1_, (gint) _tmp5_);
#line 485 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 485 "../src/client/conversation-list/conversation-list-view.vala"
	first = _tmp7_;
#line 487 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp8_ = first;
#line 487 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp8_ == NULL) {
#line 2115 "conversation-list-view.c"
		GeeHashSet* _tmp9_;
#line 488 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp9_ = visible;
#line 488 "../src/client/conversation-list/conversation-list-view.vala"
		conversation_list_view_set_visible_conversations (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_SET, GeeSet));
#line 489 "../src/client/conversation-list/conversation-list-view.vala"
		result = G_SOURCE_REMOVE;
#line 489 "../src/client/conversation-list/conversation-list-view.vala"
		_g_object_unref0 (first);
#line 489 "../src/client/conversation-list/conversation-list-view.vala"
		_g_object_unref0 (visible);
#line 489 "../src/client/conversation-list/conversation-list-view.vala"
		return result;
#line 2129 "conversation-list-view.c"
	}
#line 492 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp10_ = first;
#line 492 "../src/client/conversation-list/conversation-list-view.vala"
	start_index = (guint) gtk_list_box_row_get_index (_tmp10_);
#line 493 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp11_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
#line 493 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp12_ = _tmp11_;
#line 493 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp13_ = gtk_adjustment_get_page_size (_tmp12_);
#line 493 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp14_ = _tmp13_;
#line 493 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp15_ = first;
#line 493 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp16_ = self->priv->model;
#line 493 "../src/client/conversation-list/conversation-list-view.vala"
	end_index = MIN (start_index + ((guint) (_tmp14_ / gtk_widget_get_allocated_height (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_widget_get_type (), GtkWidget)))), g_list_model_get_n_items (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, g_list_model_get_type (), GListModel)));
#line 2149 "conversation-list-view.c"
	{
		guint i = 0U;
#line 499 "../src/client/conversation-list/conversation-list-view.vala"
		i = start_index;
#line 2154 "conversation-list-view.c"
		{
			gboolean _tmp17_ = FALSE;
#line 499 "../src/client/conversation-list/conversation-list-view.vala"
			_tmp17_ = TRUE;
#line 499 "../src/client/conversation-list/conversation-list-view.vala"
			while (TRUE) {
#line 2161 "conversation-list-view.c"
				GeeSet* _tmp19_;
				ConversationListModel* _tmp20_;
				GObject* _tmp21_;
				GearyAppConversation* _tmp22_;
				GearyAppConversation* _tmp23_;
#line 499 "../src/client/conversation-list/conversation-list-view.vala"
				if (!_tmp17_) {
#line 2169 "conversation-list-view.c"
					guint _tmp18_;
#line 499 "../src/client/conversation-list/conversation-list-view.vala"
					_tmp18_ = i;
#line 499 "../src/client/conversation-list/conversation-list-view.vala"
					i = _tmp18_ + 1;
#line 2175 "conversation-list-view.c"
				}
#line 499 "../src/client/conversation-list/conversation-list-view.vala"
				_tmp17_ = FALSE;
#line 499 "../src/client/conversation-list/conversation-list-view.vala"
				if (!(i < end_index)) {
#line 499 "../src/client/conversation-list/conversation-list-view.vala"
					break;
#line 2183 "conversation-list-view.c"
				}
#line 500 "../src/client/conversation-list/conversation-list-view.vala"
				_tmp19_ = self->priv->_visible_conversations;
#line 500 "../src/client/conversation-list/conversation-list-view.vala"
				_tmp20_ = self->priv->model;
#line 500 "../src/client/conversation-list/conversation-list-view.vala"
				_tmp21_ = g_list_model_get_item (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, g_list_model_get_type (), GListModel), i);
#line 500 "../src/client/conversation-list/conversation-list-view.vala"
				_tmp22_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp21_, GEARY_APP_TYPE_CONVERSATION) ? ((GearyAppConversation*) _tmp21_) : NULL;
#line 500 "../src/client/conversation-list/conversation-list-view.vala"
				if (_tmp22_ == NULL) {
#line 500 "../src/client/conversation-list/conversation-list-view.vala"
					_g_object_unref0 (_tmp21_);
#line 2197 "conversation-list-view.c"
				}
#line 500 "../src/client/conversation-list/conversation-list-view.vala"
				_tmp23_ = _tmp22_;
#line 500 "../src/client/conversation-list/conversation-list-view.vala"
				gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEE_TYPE_COLLECTION, GeeCollection), _tmp23_);
#line 500 "../src/client/conversation-list/conversation-list-view.vala"
				_g_object_unref0 (_tmp23_);
#line 2205 "conversation-list-view.c"
			}
		}
	}
#line 505 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp24_ = visible;
#line 505 "../src/client/conversation-list/conversation-list-view.vala"
	conversation_list_view_set_visible_conversations (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, GEE_TYPE_SET, GeeSet));
#line 506 "../src/client/conversation-list/conversation-list-view.vala"
	result = G_SOURCE_REMOVE;
#line 506 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (first);
#line 506 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (visible);
#line 506 "../src/client/conversation-list/conversation-list-view.vala"
	return result;
#line 2221 "conversation-list-view.c"
}

static gboolean
___lambda27__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda27_ ((ConversationListView*) self);
#line 483 "../src/client/conversation-list/conversation-list-view.vala"
	return result;
#line 2231 "conversation-list-view.c"
}

static void
conversation_list_view_update_visible_conversations (ConversationListView* self)
{
	GearySchedulerScheduled* _tmp0_;
	gint _tmp2_;
	GearySchedulerScheduled* _tmp3_;
#line 478 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 479 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = self->priv->scheduled_visible_update;
#line 479 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp0_ != NULL) {
#line 2246 "conversation-list-view.c"
		GearySchedulerScheduled* _tmp1_;
#line 480 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp1_ = self->priv->scheduled_visible_update;
#line 480 "../src/client/conversation-list/conversation-list-view.vala"
		geary_scheduler_scheduled_cancel (_tmp1_);
#line 2252 "conversation-list-view.c"
	}
#line 483 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp2_ = self->priv->VISIBILITY_UPDATE_DELAY_MS;
#line 483 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp3_ = geary_scheduler_after_msec ((guint) _tmp2_, ___lambda27__gsource_func, self, G_PRIORITY_DEFAULT_IDLE);
#line 483 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (self->priv->scheduled_visible_update);
#line 483 "../src/client/conversation-list/conversation-list-view.vala"
	self->priv->scheduled_visible_update = _tmp3_;
#line 2262 "conversation-list-view.c"
}

/**
     * Informs the listbox to suppress autoactivate behavior on the next update
     */
void
conversation_list_view_inhibit_next_autoselect (ConversationListView* self)
{
#line 518 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 519 "../src/client/conversation-list/conversation-list-view.vala"
	self->priv->should_inhibit_autoactivate = TRUE;
#line 2275 "conversation-list-view.c"
}

/**
     * Find a selectable conversation near current selection
     */
static GtkListBoxRow*
conversation_list_view_get_next_conversation (ConversationListView* self,
                                              gboolean asc)
{
	gint _tmp0_ = 0;
	gint index = 0;
	GList* selected_rows = NULL;
	GtkListBox* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
	GtkListBoxRow* row = NULL;
	GtkListBox* _tmp11_;
	GtkListBoxRow* _tmp12_;
	GtkListBoxRow* _tmp13_;
	GtkListBoxRow* _tmp14_ = NULL;
	gboolean _tmp15_ = FALSE;
	GtkListBoxRow* _tmp16_;
	GtkListBoxRow* result;
#line 525 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_val_if_fail (CONVERSATION_LIST_IS_VIEW (self), NULL);
#line 526 "../src/client/conversation-list/conversation-list-view.vala"
	if (asc) {
#line 526 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp0_ = 0;
#line 2306 "conversation-list-view.c"
	} else {
#line 526 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp0_ = G_MAXINT;
#line 2310 "conversation-list-view.c"
	}
#line 526 "../src/client/conversation-list/conversation-list-view.vala"
	index = _tmp0_;
#line 529 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp1_ = self->priv->list;
#line 529 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp2_ = gtk_list_box_get_selected_rows (_tmp1_);
#line 529 "../src/client/conversation-list/conversation-list-view.vala"
	(selected_rows == NULL) ? NULL : (selected_rows = (g_list_free (selected_rows), NULL));
#line 529 "../src/client/conversation-list/conversation-list-view.vala"
	selected_rows = _tmp2_;
#line 530 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp3_ = selected_rows;
#line 530 "../src/client/conversation-list/conversation-list-view.vala"
	if (g_list_length (_tmp3_) == ((guint) 0)) {
#line 531 "../src/client/conversation-list/conversation-list-view.vala"
		result = NULL;
#line 531 "../src/client/conversation-list/conversation-list-view.vala"
		(selected_rows == NULL) ? NULL : (selected_rows = (g_list_free (selected_rows), NULL));
#line 531 "../src/client/conversation-list/conversation-list-view.vala"
		return result;
#line 2332 "conversation-list-view.c"
	}
#line 534 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp4_ = selected_rows;
#line 2336 "conversation-list-view.c"
	{
		GList* row_collection = NULL;
		GList* row_it = NULL;
#line 534 "../src/client/conversation-list/conversation-list-view.vala"
		row_collection = _tmp4_;
#line 534 "../src/client/conversation-list/conversation-list-view.vala"
		for (row_it = row_collection; row_it != NULL; row_it = row_it->next) {
#line 2344 "conversation-list-view.c"
			GtkListBoxRow* row = NULL;
#line 534 "../src/client/conversation-list/conversation-list-view.vala"
			row = (GtkListBoxRow*) row_it->data;
#line 2348 "conversation-list-view.c"
			{
				gboolean _tmp5_ = FALSE;
				gboolean _tmp6_ = FALSE;
#line 535 "../src/client/conversation-list/conversation-list-view.vala"
				if (asc) {
#line 2354 "conversation-list-view.c"
					GtkListBoxRow* _tmp7_;
#line 535 "../src/client/conversation-list/conversation-list-view.vala"
					_tmp7_ = row;
#line 535 "../src/client/conversation-list/conversation-list-view.vala"
					_tmp6_ = gtk_list_box_row_get_index (_tmp7_) > index;
#line 2360 "conversation-list-view.c"
				} else {
#line 535 "../src/client/conversation-list/conversation-list-view.vala"
					_tmp6_ = FALSE;
#line 2364 "conversation-list-view.c"
				}
#line 535 "../src/client/conversation-list/conversation-list-view.vala"
				if (_tmp6_) {
#line 535 "../src/client/conversation-list/conversation-list-view.vala"
					_tmp5_ = TRUE;
#line 2370 "conversation-list-view.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 536 "../src/client/conversation-list/conversation-list-view.vala"
					if (!asc) {
#line 2375 "conversation-list-view.c"
						GtkListBoxRow* _tmp9_;
#line 536 "../src/client/conversation-list/conversation-list-view.vala"
						_tmp9_ = row;
#line 536 "../src/client/conversation-list/conversation-list-view.vala"
						_tmp8_ = gtk_list_box_row_get_index (_tmp9_) < index;
#line 2381 "conversation-list-view.c"
					} else {
#line 536 "../src/client/conversation-list/conversation-list-view.vala"
						_tmp8_ = FALSE;
#line 2385 "conversation-list-view.c"
					}
#line 536 "../src/client/conversation-list/conversation-list-view.vala"
					_tmp5_ = _tmp8_;
#line 2389 "conversation-list-view.c"
				}
#line 535 "../src/client/conversation-list/conversation-list-view.vala"
				if (_tmp5_) {
#line 2393 "conversation-list-view.c"
					GtkListBoxRow* _tmp10_;
#line 537 "../src/client/conversation-list/conversation-list-view.vala"
					_tmp10_ = row;
#line 537 "../src/client/conversation-list/conversation-list-view.vala"
					index = gtk_list_box_row_get_index (_tmp10_);
#line 2399 "conversation-list-view.c"
				}
			}
		}
	}
#line 540 "../src/client/conversation-list/conversation-list-view.vala"
	if (asc) {
#line 541 "../src/client/conversation-list/conversation-list-view.vala"
		index += 1;
#line 2408 "conversation-list-view.c"
	} else {
#line 543 "../src/client/conversation-list/conversation-list-view.vala"
		index -= 1;
#line 2412 "conversation-list-view.c"
	}
#line 545 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp11_ = self->priv->list;
#line 545 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp12_ = gtk_list_box_get_row_at_index (_tmp11_, index);
#line 545 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp13_ = _g_object_ref0 (_tmp12_);
#line 545 "../src/client/conversation-list/conversation-list-view.vala"
	row = _tmp13_;
#line 546 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp16_ = row;
#line 546 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp16_ != NULL) {
#line 546 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp15_ = TRUE;
#line 2428 "conversation-list-view.c"
	} else {
#line 546 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp15_ = !asc;
#line 2432 "conversation-list-view.c"
	}
#line 546 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp15_) {
#line 2436 "conversation-list-view.c"
		GtkListBoxRow* _tmp17_;
		GtkListBoxRow* _tmp18_;
#line 546 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp17_ = row;
#line 546 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp18_ = _g_object_ref0 (_tmp17_);
#line 546 "../src/client/conversation-list/conversation-list-view.vala"
		_g_object_unref0 (_tmp14_);
#line 546 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp14_ = _tmp18_;
#line 2447 "conversation-list-view.c"
	} else {
		GtkListBoxRow* _tmp19_;
#line 546 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp19_ = conversation_list_view_get_next_conversation (self, FALSE);
#line 546 "../src/client/conversation-list/conversation-list-view.vala"
		_g_object_unref0 (_tmp14_);
#line 546 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp14_ = _tmp19_;
#line 2456 "conversation-list-view.c"
	}
#line 546 "../src/client/conversation-list/conversation-list-view.vala"
	result = _tmp14_;
#line 546 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (row);
#line 546 "../src/client/conversation-list/conversation-list-view.vala"
	(selected_rows == NULL) ? NULL : (selected_rows = (g_list_free (selected_rows), NULL));
#line 546 "../src/client/conversation-list/conversation-list-view.vala"
	return result;
#line 2466 "conversation-list-view.c"
}

static void
conversation_list_view_on_conversations_loaded (ConversationListView* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	ApplicationConfiguration* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 549 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 550 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp2_ = self->priv->config;
#line 550 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp3_ = application_configuration_get_autoselect (_tmp2_);
#line 550 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp4_ = _tmp3_;
#line 550 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp4_) {
#line 551 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp1_ = !self->priv->should_inhibit_autoactivate;
#line 2489 "conversation-list-view.c"
	} else {
#line 550 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp1_ = FALSE;
#line 2493 "conversation-list-view.c"
	}
#line 550 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp1_) {
#line 2497 "conversation-list-view.c"
		GtkListBox* _tmp5_;
		GList* _tmp6_;
		GList* _tmp7_;
#line 552 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp5_ = self->priv->list;
#line 552 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp6_ = gtk_list_box_get_selected_rows (_tmp5_);
#line 552 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp7_ = _tmp6_;
#line 552 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp0_ = g_list_length (_tmp7_) == ((guint) 0);
#line 552 "../src/client/conversation-list/conversation-list-view.vala"
		(_tmp7_ == NULL) ? NULL : (_tmp7_ = (g_list_free (_tmp7_), NULL));
#line 2511 "conversation-list-view.c"
	} else {
#line 550 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp0_ = FALSE;
#line 2515 "conversation-list-view.c"
	}
#line 550 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp0_) {
#line 2519 "conversation-list-view.c"
		GtkListBoxRow* first_row = NULL;
		GtkListBox* _tmp8_;
		GtkListBoxRow* _tmp9_;
		GtkListBoxRow* _tmp10_;
		GtkListBoxRow* _tmp11_;
#line 554 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp8_ = self->priv->list;
#line 554 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp9_ = gtk_list_box_get_row_at_index (_tmp8_, 0);
#line 554 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp10_ = _g_object_ref0 (_tmp9_);
#line 554 "../src/client/conversation-list/conversation-list-view.vala"
		first_row = _tmp10_;
#line 555 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp11_ = first_row;
#line 555 "../src/client/conversation-list/conversation-list-view.vala"
		if (_tmp11_ != NULL) {
#line 2537 "conversation-list-view.c"
			GtkListBox* _tmp12_;
			GtkListBoxRow* _tmp13_;
#line 556 "../src/client/conversation-list/conversation-list-view.vala"
			_tmp12_ = self->priv->list;
#line 556 "../src/client/conversation-list/conversation-list-view.vala"
			_tmp13_ = first_row;
#line 556 "../src/client/conversation-list/conversation-list-view.vala"
			gtk_list_box_select_row (_tmp12_, _tmp13_);
#line 2546 "conversation-list-view.c"
		}
#line 550 "../src/client/conversation-list/conversation-list-view.vala"
		_g_object_unref0 (first_row);
#line 2550 "conversation-list-view.c"
	}
#line 560 "../src/client/conversation-list/conversation-list-view.vala"
	self->priv->should_inhibit_autoactivate = FALSE;
#line 2554 "conversation-list-view.c"
}

static void
conversation_list_view_on_conversations_removed (ConversationListView* self,
                                                 gboolean start)
{
	gboolean _tmp0_ = FALSE;
	ApplicationConfiguration* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 566 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 568 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp1_ = self->priv->config;
#line 568 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp2_ = application_configuration_get_autoselect (_tmp1_);
#line 568 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp3_ = _tmp2_;
#line 568 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp3_) {
#line 568 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp0_ = start;
#line 2577 "conversation-list-view.c"
	} else {
#line 568 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp0_ = FALSE;
#line 2581 "conversation-list-view.c"
	}
#line 568 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp0_) {
#line 2585 "conversation-list-view.c"
		GtkListBoxRow* _tmp4_;
#line 569 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp4_ = conversation_list_view_get_next_conversation (self, TRUE);
#line 569 "../src/client/conversation-list/conversation-list-view.vala"
		_g_object_unref0 (self->priv->to_restore_row);
#line 569 "../src/client/conversation-list/conversation-list-view.vala"
		self->priv->to_restore_row = _tmp4_;
#line 2593 "conversation-list-view.c"
	} else {
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 571 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp5_ = conversation_list_view_get_selection_mode_enabled (self);
#line 571 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp6_ = _tmp5_;
#line 571 "../src/client/conversation-list/conversation-list-view.vala"
		if (_tmp6_) {
#line 572 "../src/client/conversation-list/conversation-list-view.vala"
			conversation_list_view_set_selection_mode_enabled (self, FALSE);
#line 2605 "conversation-list-view.c"
		} else {
			gboolean _tmp7_ = FALSE;
			ApplicationConfiguration* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 574 "../src/client/conversation-list/conversation-list-view.vala"
			_tmp8_ = self->priv->config;
#line 574 "../src/client/conversation-list/conversation-list-view.vala"
			_tmp9_ = application_configuration_get_autoselect (_tmp8_);
#line 574 "../src/client/conversation-list/conversation-list-view.vala"
			_tmp10_ = _tmp9_;
#line 574 "../src/client/conversation-list/conversation-list-view.vala"
			if (_tmp10_) {
#line 2619 "conversation-list-view.c"
				GtkListBox* _tmp11_;
				GList* _tmp12_;
				GList* _tmp13_;
#line 575 "../src/client/conversation-list/conversation-list-view.vala"
				_tmp11_ = self->priv->list;
#line 575 "../src/client/conversation-list/conversation-list-view.vala"
				_tmp12_ = gtk_list_box_get_selected_rows (_tmp11_);
#line 575 "../src/client/conversation-list/conversation-list-view.vala"
				_tmp13_ = _tmp12_;
#line 575 "../src/client/conversation-list/conversation-list-view.vala"
				_tmp7_ = g_list_length (_tmp13_) == ((guint) 0);
#line 575 "../src/client/conversation-list/conversation-list-view.vala"
				(_tmp13_ == NULL) ? NULL : (_tmp13_ = (g_list_free (_tmp13_), NULL));
#line 2633 "conversation-list-view.c"
			} else {
#line 574 "../src/client/conversation-list/conversation-list-view.vala"
				_tmp7_ = FALSE;
#line 2637 "conversation-list-view.c"
			}
#line 574 "../src/client/conversation-list/conversation-list-view.vala"
			if (_tmp7_) {
#line 576 "../src/client/conversation-list/conversation-list-view.vala"
				conversation_list_view_restore_row (self);
#line 2643 "conversation-list-view.c"
			}
		}
	}
}

static Block83Data*
block83_data_ref (Block83Data* _data83_)
{
#line 583 "../src/client/conversation-list/conversation-list-view.vala"
	g_atomic_int_inc (&_data83_->_ref_count_);
#line 583 "../src/client/conversation-list/conversation-list-view.vala"
	return _data83_;
#line 2656 "conversation-list-view.c"
}

static void
block83_data_unref (void * _userdata_)
{
	Block83Data* _data83_;
	_data83_ = (Block83Data*) _userdata_;
#line 583 "../src/client/conversation-list/conversation-list-view.vala"
	if (g_atomic_int_dec_and_test (&_data83_->_ref_count_)) {
#line 2666 "conversation-list-view.c"
		ConversationListView* self;
#line 583 "../src/client/conversation-list/conversation-list-view.vala"
		self = _data83_->self;
#line 583 "../src/client/conversation-list/conversation-list-view.vala"
		_g_object_unref0 (_data83_->convo);
#line 583 "../src/client/conversation-list/conversation-list-view.vala"
		_g_object_unref0 (self);
#line 583 "../src/client/conversation-list/conversation-list-view.vala"
		g_slice_free (Block83Data, _data83_);
#line 2676 "conversation-list-view.c"
	}
}

static void
__lambda30_ (Block83Data* _data83_,
             GtkWidget* child)
{
	ConversationListView* self;
	ConversationListRow* row = NULL;
	ConversationListRow* _tmp0_;
	ConversationListRow* _tmp1_;
	GearyAppConversation* _tmp2_;
#line 584 "../src/client/conversation-list/conversation-list-view.vala"
	self = _data83_->self;
#line 584 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (child, gtk_widget_get_type ()));
#line 585 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (child, CONVERSATION_LIST_TYPE_ROW, ConversationListRow));
#line 585 "../src/client/conversation-list/conversation-list-view.vala"
	row = _tmp0_;
#line 586 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp1_ = row;
#line 586 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp2_ = _tmp1_->conversation;
#line 586 "../src/client/conversation-list/conversation-list-view.vala"
	if (_data83_->convo == _tmp2_) {
#line 2703 "conversation-list-view.c"
		ConversationListRow* _tmp3_;
#line 587 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp3_ = row;
#line 587 "../src/client/conversation-list/conversation-list-view.vala"
		conversation_list_row_update (_tmp3_);
#line 2709 "conversation-list-view.c"
	}
#line 584 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (row);
#line 2713 "conversation-list-view.c"
}

static void
___lambda30__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
#line 584 "../src/client/conversation-list/conversation-list-view.vala"
	__lambda30_ (self, widget);
#line 2722 "conversation-list-view.c"
}

static void
conversation_list_view_on_conversation_updated (ConversationListView* self,
                                                GearyAppConversation* convo)
{
	Block83Data* _data83_;
	GearyAppConversation* _tmp0_;
	GtkListBox* _tmp1_;
#line 583 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 583 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (convo, GEARY_APP_TYPE_CONVERSATION));
#line 583 "../src/client/conversation-list/conversation-list-view.vala"
	_data83_ = g_slice_new0 (Block83Data);
#line 583 "../src/client/conversation-list/conversation-list-view.vala"
	_data83_->_ref_count_ = 1;
#line 583 "../src/client/conversation-list/conversation-list-view.vala"
	_data83_->self = g_object_ref (self);
#line 583 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = _g_object_ref0 (convo);
#line 583 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (_data83_->convo);
#line 583 "../src/client/conversation-list/conversation-list-view.vala"
	_data83_->convo = _tmp0_;
#line 584 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp1_ = self->priv->list;
#line 584 "../src/client/conversation-list/conversation-list-view.vala"
	gtk_container_foreach (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_container_get_type (), GtkContainer), ___lambda30__gtk_callback, _data83_);
#line 583 "../src/client/conversation-list/conversation-list-view.vala"
	block83_data_unref (_data83_);
#line 583 "../src/client/conversation-list/conversation-list-view.vala"
	_data83_ = NULL;
#line 2756 "conversation-list-view.c"
}

static GdkEvent*
_vala_GdkEvent_copy (GdkEvent* self)
{
#line 605 "../src/client/conversation-list/conversation-list-view.vala"
	return g_boxed_copy (gdk_event_get_type (), self);
#line 2764 "conversation-list-view.c"
}

static gpointer
__vala_GdkEvent_copy0 (gpointer self)
{
#line 605 "../src/client/conversation-list/conversation-list-view.vala"
	return self ? _vala_GdkEvent_copy (self) : NULL;
#line 2772 "conversation-list-view.c"
}

static void
_vala_GdkEvent_free (GdkEvent* self)
{
#line 603 "../src/client/conversation-list/conversation-list-view.vala"
	g_boxed_free (gdk_event_get_type (), self);
#line 2780 "conversation-list-view.c"
}

static void
_vala_GdkEventSequence_free (GdkEventSequence* self)
{
#line 603 "../src/client/conversation-list/conversation-list-view.vala"
	g_boxed_free (gdk_event_sequence_get_type (), self);
#line 2788 "conversation-list-view.c"
}

static void
conversation_list_view_on_press_gesture_released (ConversationListView* self,
                                                  gint n_press,
                                                  gdouble x,
                                                  gdouble y)
{
	ConversationListRow* row = NULL;
	GtkListBox* _tmp0_;
	GtkListBoxRow* _tmp1_;
	ConversationListRow* _tmp2_;
	ConversationListRow* _tmp3_;
	guint button = 0U;
	GtkGestureMultiPress* _tmp4_;
#line 596 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 597 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = self->priv->list;
#line 597 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp1_ = gtk_list_box_get_row_at_y (_tmp0_, (gint) y);
#line 597 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, CONVERSATION_LIST_TYPE_ROW, ConversationListRow));
#line 597 "../src/client/conversation-list/conversation-list-view.vala"
	row = _tmp2_;
#line 599 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp3_ = row;
#line 599 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp3_ == NULL) {
#line 600 "../src/client/conversation-list/conversation-list-view.vala"
		_g_object_unref0 (row);
#line 600 "../src/client/conversation-list/conversation-list-view.vala"
		return;
#line 2822 "conversation-list-view.c"
	}
#line 602 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp4_ = self->priv->press_gesture;
#line 602 "../src/client/conversation-list/conversation-list-view.vala"
	button = gtk_gesture_single_get_current_button (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_gesture_single_get_type (), GtkGestureSingle));
#line 603 "../src/client/conversation-list/conversation-list-view.vala"
	if (button == ((guint) 1)) {
#line 2830 "conversation-list-view.c"
		GdkEventSequence* sequence = NULL;
		GtkGestureMultiPress* _tmp5_;
		GdkEventSequence* _tmp6_;
		GdkEvent* event = NULL;
		GtkGestureMultiPress* _tmp7_;
		GdkEventSequence* _tmp8_;
		GdkEvent* _tmp9_;
		GdkEvent* _tmp10_;
		GdkEvent* _tmp11_;
		GdkModifierType _tmp12_ = 0U;
		gboolean _tmp13_;
		gboolean _tmp14_;
#line 604 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp5_ = self->priv->press_gesture;
#line 604 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp6_ = gtk_gesture_single_get_current_sequence (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_gesture_single_get_type (), GtkGestureSingle));
#line 604 "../src/client/conversation-list/conversation-list-view.vala"
		sequence = _tmp6_;
#line 605 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp7_ = self->priv->press_gesture;
#line 605 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp8_ = sequence;
#line 605 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp9_ = gtk_gesture_get_last_event (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_gesture_get_type (), GtkGesture), _tmp8_);
#line 605 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp10_ = __vala_GdkEvent_copy0 (_tmp9_);
#line 605 "../src/client/conversation-list/conversation-list-view.vala"
		event = _tmp10_;
#line 606 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp11_ = event;
#line 606 "../src/client/conversation-list/conversation-list-view.vala"
		gdk_event_get_state (_tmp11_, &_tmp12_);
#line 606 "../src/client/conversation-list/conversation-list-view.vala"
		self->priv->last_modifier_type = _tmp12_;
#line 607 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp13_ = conversation_list_view_get_selection_mode_enabled (self);
#line 607 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp14_ = _tmp13_;
#line 607 "../src/client/conversation-list/conversation-list-view.vala"
		if (!_tmp14_) {
#line 2871 "conversation-list-view.c"
			gboolean _tmp15_ = FALSE;
#line 608 "../src/client/conversation-list/conversation-list-view.vala"
			if ((self->priv->last_modifier_type & GDK_SHIFT_MASK) == GDK_SHIFT_MASK) {
#line 608 "../src/client/conversation-list/conversation-list-view.vala"
				_tmp15_ = TRUE;
#line 2877 "conversation-list-view.c"
			} else {
#line 610 "../src/client/conversation-list/conversation-list-view.vala"
				_tmp15_ = (self->priv->last_modifier_type & GDK_CONTROL_MASK) == GDK_CONTROL_MASK;
#line 2881 "conversation-list-view.c"
			}
#line 608 "../src/client/conversation-list/conversation-list-view.vala"
			if (_tmp15_) {
#line 612 "../src/client/conversation-list/conversation-list-view.vala"
				conversation_list_view_set_selection_mode_enabled (self, TRUE);
#line 2887 "conversation-list-view.c"
			} else {
				ConversationListRow* _tmp16_;
				GearyAppConversation* _tmp17_;
#line 614 "../src/client/conversation-list/conversation-list-view.vala"
				_tmp16_ = row;
#line 614 "../src/client/conversation-list/conversation-list-view.vala"
				_tmp17_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, CONVERSATION_LIST_TYPE_ROW, ConversationListRow)->conversation;
#line 614 "../src/client/conversation-list/conversation-list-view.vala"
				g_signal_emit (self, conversation_list_view_signals[CONVERSATION_LIST_VIEW_CONVERSATION_ACTIVATED_SIGNAL], 0, _tmp17_, (guint) 1);
#line 2897 "conversation-list-view.c"
			}
		}
#line 603 "../src/client/conversation-list/conversation-list-view.vala"
		__vala_GdkEvent_free0 (event);
#line 603 "../src/client/conversation-list/conversation-list-view.vala"
		__vala_GdkEventSequence_free0 (sequence);
#line 2904 "conversation-list-view.c"
	} else {
#line 617 "../src/client/conversation-list/conversation-list-view.vala"
		if (button == ((guint) 2)) {
#line 2908 "conversation-list-view.c"
			ConversationListRow* _tmp18_;
			GearyAppConversation* _tmp19_;
#line 618 "../src/client/conversation-list/conversation-list-view.vala"
			_tmp18_ = row;
#line 618 "../src/client/conversation-list/conversation-list-view.vala"
			_tmp19_ = _tmp18_->conversation;
#line 618 "../src/client/conversation-list/conversation-list-view.vala"
			g_signal_emit (self, conversation_list_view_signals[CONVERSATION_LIST_VIEW_CONVERSATION_ACTIVATED_SIGNAL], 0, _tmp19_, (guint) 2);
#line 2917 "conversation-list-view.c"
		} else {
#line 619 "../src/client/conversation-list/conversation-list-view.vala"
			if (button == ((guint) 3)) {
#line 2921 "conversation-list-view.c"
				GdkRectangle rect = {0};
				ConversationListRow* _tmp20_;
				GtkListBox* _tmp21_;
				gint _tmp22_ = 0;
				gint _tmp23_ = 0;
				GdkRectangle _tmp24_;
				ConversationListRow* _tmp25_;
				GdkRectangle _tmp26_;
#line 620 "../src/client/conversation-list/conversation-list-view.vala"
				memset (&rect, 0, sizeof (GdkRectangle));
#line 621 "../src/client/conversation-list/conversation-list-view.vala"
				_tmp20_ = row;
#line 621 "../src/client/conversation-list/conversation-list-view.vala"
				_tmp21_ = self->priv->list;
#line 621 "../src/client/conversation-list/conversation-list-view.vala"
				gtk_widget_translate_coordinates (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, gtk_widget_get_type (), GtkWidget), G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, gtk_widget_get_type (), GtkWidget), 0, 0, &_tmp22_, &_tmp23_);
#line 621 "../src/client/conversation-list/conversation-list-view.vala"
				rect.x = _tmp22_;
#line 621 "../src/client/conversation-list/conversation-list-view.vala"
				rect.y = _tmp23_;
#line 622 "../src/client/conversation-list/conversation-list-view.vala"
				rect.x = (gint) x;
#line 623 "../src/client/conversation-list/conversation-list-view.vala"
				_tmp24_ = rect;
#line 623 "../src/client/conversation-list/conversation-list-view.vala"
				rect.y = ((gint) y) - _tmp24_.y;
#line 624 "../src/client/conversation-list/conversation-list-view.vala"
				rect.height = 0;
#line 624 "../src/client/conversation-list/conversation-list-view.vala"
				rect.width = rect.height;
#line 625 "../src/client/conversation-list/conversation-list-view.vala"
				_tmp25_ = row;
#line 625 "../src/client/conversation-list/conversation-list-view.vala"
				_tmp26_ = rect;
#line 625 "../src/client/conversation-list/conversation-list-view.vala"
				conversation_list_view_context_menu (self, _tmp25_, &_tmp26_);
#line 2958 "conversation-list-view.c"
			}
		}
	}
#line 596 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (row);
#line 2964 "conversation-list-view.c"
}

static gboolean
conversation_list_view_on_key_event_controller_key_pressed (ConversationListView* self,
                                                            guint keyval,
                                                            guint keycode,
                                                            GdkModifierType modifier_type)
{
	gboolean result;
#line 629 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_val_if_fail (CONVERSATION_LIST_IS_VIEW (self), FALSE);
#line 630 "../src/client/conversation-list/conversation-list-view.vala"
	switch (keyval) {
#line 630 "../src/client/conversation-list/conversation-list-view.vala"
		case GDK_KEY_Up:
#line 630 "../src/client/conversation-list/conversation-list-view.vala"
		case GDK_KEY_Down:
#line 2982 "conversation-list-view.c"
		{
#line 633 "../src/client/conversation-list/conversation-list-view.vala"
			if ((modifier_type & GDK_SHIFT_MASK) == GDK_SHIFT_MASK) {
#line 635 "../src/client/conversation-list/conversation-list-view.vala"
				conversation_list_view_set_selection_mode_enabled (self, TRUE);
#line 2988 "conversation-list-view.c"
			}
#line 637 "../src/client/conversation-list/conversation-list-view.vala"
			break;
#line 2992 "conversation-list-view.c"
		}
#line 630 "../src/client/conversation-list/conversation-list-view.vala"
		case GDK_KEY_Escape:
#line 2996 "conversation-list-view.c"
		{
			gboolean _tmp0_;
			gboolean _tmp1_;
#line 639 "../src/client/conversation-list/conversation-list-view.vala"
			_tmp0_ = conversation_list_view_get_selection_mode_enabled (self);
#line 639 "../src/client/conversation-list/conversation-list-view.vala"
			_tmp1_ = _tmp0_;
#line 639 "../src/client/conversation-list/conversation-list-view.vala"
			if (_tmp1_) {
#line 640 "../src/client/conversation-list/conversation-list-view.vala"
				conversation_list_view_set_selection_mode_enabled (self, FALSE);
#line 641 "../src/client/conversation-list/conversation-list-view.vala"
				result = TRUE;
#line 641 "../src/client/conversation-list/conversation-list-view.vala"
				return result;
#line 3012 "conversation-list-view.c"
			}
#line 643 "../src/client/conversation-list/conversation-list-view.vala"
			break;
#line 3016 "conversation-list-view.c"
		}
		default:
#line 630 "../src/client/conversation-list/conversation-list-view.vala"
		break;
#line 3021 "conversation-list-view.c"
	}
#line 645 "../src/client/conversation-list/conversation-list-view.vala"
	result = FALSE;
#line 645 "../src/client/conversation-list/conversation-list-view.vala"
	return result;
#line 3027 "conversation-list-view.c"
}

static void
conversation_list_view_on_drag_begin (ConversationListView* self,
                                      GdkDragContext* ctx)
{
	gint screen_x = 0;
	gint screen_y = 0;
	GdkModifierType _modifier = 0U;
	GdkWindow* _tmp0_;
	GdkDevice* _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	GdkModifierType _tmp4_ = 0U;
	ConversationListRow* row = NULL;
	GtkListBox* _tmp5_;
	GtkAdjustment* _tmp6_;
	GtkAdjustment* _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	GtkListBoxRow* _tmp10_;
	ConversationListRow* _tmp11_;
	gboolean _tmp12_ = FALSE;
	ConversationListRow* _tmp13_;
	ApplicationConfiguration* _tmp18_;
	ConversationListRow* _tmp19_;
	GearyAppConversation* _tmp20_;
	ConversationListRow* _tmp21_;
	ConversationListRow* _tmp22_;
	ConversationListRow* _tmp23_;
	ConversationListRow* _tmp24_;
	GtkStyleContext* _tmp25_;
	ConversationListRow* _tmp26_;
	gint hot_x = 0;
	gint hot_y = 0;
	ConversationListRow* _tmp27_;
	gint _tmp28_ = 0;
	gint _tmp29_ = 0;
	ConversationListRow* _tmp30_;
#line 655 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 655 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (ctx, gdk_drag_context_get_type ()));
#line 659 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = gtk_widget_get_window (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 659 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp1_ = gdk_drag_context_get_device (ctx);
#line 659 "../src/client/conversation-list/conversation-list-view.vala"
	gdk_window_get_device_position (_tmp0_, _tmp1_, &_tmp2_, &_tmp3_, &_tmp4_);
#line 659 "../src/client/conversation-list/conversation-list-view.vala"
	screen_x = _tmp2_;
#line 659 "../src/client/conversation-list/conversation-list-view.vala"
	screen_y = _tmp3_;
#line 659 "../src/client/conversation-list/conversation-list-view.vala"
	_modifier = _tmp4_;
#line 663 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp5_ = self->priv->list;
#line 663 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp6_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
#line 663 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp7_ = _tmp6_;
#line 663 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp8_ = gtk_adjustment_get_value (_tmp7_);
#line 663 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp9_ = _tmp8_;
#line 663 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp10_ = gtk_list_box_get_row_at_y (_tmp5_, screen_y + ((gint) _tmp9_));
#line 663 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp11_ = _g_object_ref0 (CONVERSATION_LIST_IS_ROW (_tmp10_) ? ((ConversationListRow*) _tmp10_) : NULL);
#line 663 "../src/client/conversation-list/conversation-list-view.vala"
	row = _tmp11_;
#line 664 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp13_ = row;
#line 664 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp13_ != NULL) {
#line 3103 "conversation-list-view.c"
		ConversationListRow* _tmp14_;
#line 664 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp14_ = row;
#line 664 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp12_ = !gtk_list_box_row_is_selected (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_list_box_row_get_type (), GtkListBoxRow));
#line 3109 "conversation-list-view.c"
	} else {
#line 664 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp12_ = FALSE;
#line 3113 "conversation-list-view.c"
	}
#line 664 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp12_) {
#line 3117 "conversation-list-view.c"
		GtkListBox* _tmp15_;
		GtkListBox* _tmp16_;
		ConversationListRow* _tmp17_;
#line 665 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp15_ = self->priv->list;
#line 665 "../src/client/conversation-list/conversation-list-view.vala"
		gtk_list_box_unselect_all (_tmp15_);
#line 666 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp16_ = self->priv->list;
#line 666 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp17_ = row;
#line 666 "../src/client/conversation-list/conversation-list-view.vala"
		gtk_list_box_select_row (_tmp16_, G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, gtk_list_box_row_get_type (), GtkListBoxRow));
#line 3131 "conversation-list-view.c"
	}
#line 669 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp18_ = self->priv->config;
#line 669 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp19_ = row;
#line 669 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp20_ = _tmp19_->conversation;
#line 669 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp21_ = conversation_list_row_new (_tmp18_, _tmp20_, FALSE);
#line 669 "../src/client/conversation-list/conversation-list-view.vala"
	g_object_ref_sink (_tmp21_);
#line 669 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (self->priv->drag_widget);
#line 669 "../src/client/conversation-list/conversation-list-view.vala"
	self->priv->drag_widget = _tmp21_;
#line 670 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp22_ = self->priv->drag_widget;
#line 670 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp23_ = row;
#line 670 "../src/client/conversation-list/conversation-list-view.vala"
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, gtk_widget_get_type (), GtkWidget), "width-request", gtk_widget_get_allocated_width (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, gtk_widget_get_type (), GtkWidget)), NULL);
#line 671 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp24_ = self->priv->drag_widget;
#line 671 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp25_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, gtk_widget_get_type (), GtkWidget));
#line 671 "../src/client/conversation-list/conversation-list-view.vala"
	gtk_style_context_add_class (_tmp25_, "drag-n-drop");
#line 672 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp26_ = self->priv->drag_widget;
#line 672 "../src/client/conversation-list/conversation-list-view.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, gtk_widget_get_type (), GtkWidget), TRUE);
#line 675 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp27_ = row;
#line 675 "../src/client/conversation-list/conversation-list-view.vala"
	gtk_widget_translate_coordinates (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, gtk_widget_get_type (), GtkWidget), screen_x, screen_y, &_tmp28_, &_tmp29_);
#line 675 "../src/client/conversation-list/conversation-list-view.vala"
	hot_x = _tmp28_;
#line 675 "../src/client/conversation-list/conversation-list-view.vala"
	hot_y = _tmp29_;
#line 676 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp30_ = self->priv->drag_widget;
#line 676 "../src/client/conversation-list/conversation-list-view.vala"
	gtk_drag_set_icon_widget (ctx, G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, gtk_widget_get_type (), GtkWidget), hot_x, hot_y);
#line 655 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (row);
#line 3177 "conversation-list-view.c"
}

static void
conversation_list_view_on_drag_end (ConversationListView* self,
                                    GdkDragContext* ctx)
{
	ConversationListRow* _tmp0_;
#line 679 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 679 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (ctx, gdk_drag_context_get_type ()));
#line 680 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = self->priv->drag_widget;
#line 680 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp0_ != NULL) {
#line 3193 "conversation-list-view.c"
		ConversationListRow* _tmp1_;
#line 681 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp1_ = self->priv->drag_widget;
#line 681 "../src/client/conversation-list/conversation-list-view.vala"
		gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget));
#line 682 "../src/client/conversation-list/conversation-list-view.vala"
		_g_object_unref0 (self->priv->drag_widget);
#line 682 "../src/client/conversation-list/conversation-list-view.vala"
		self->priv->drag_widget = NULL;
#line 3203 "conversation-list-view.c"
	}
}

static void
conversation_list_view_on_selected_rows_changed (ConversationListView* self)
{
	GeeSet* selected = NULL;
	GeeSet* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GeeSet* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
#line 686 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 687 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = conversation_list_view_get_selected_conversations (self);
#line 687 "../src/client/conversation-list/conversation-list-view.vala"
	selected = _tmp0_;
#line 689 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp1_ = selected;
#line 689 "../src/client/conversation-list/conversation-list-view.vala"
	if (!conversation_list_view_selection_changed (self, _tmp1_)) {
#line 690 "../src/client/conversation-list/conversation-list-view.vala"
		_g_object_unref0 (selected);
#line 690 "../src/client/conversation-list/conversation-list-view.vala"
		return;
#line 3232 "conversation-list-view.c"
	}
#line 693 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp2_ = selected;
#line 693 "../src/client/conversation-list/conversation-list-view.vala"
	conversation_list_view_set_selected (self, _tmp2_);
#line 694 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp4_ = self->priv->_selected;
#line 694 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp5_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_COLLECTION, GeeCollection));
#line 694 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp6_ = _tmp5_;
#line 694 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp6_ > 0) {
#line 694 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp3_ = TRUE;
#line 3248 "conversation-list-view.c"
	} else {
		GtkListBoxRow* _tmp7_;
#line 694 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp7_ = self->priv->to_restore_row;
#line 694 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp3_ = _tmp7_ == NULL;
#line 3255 "conversation-list-view.c"
	}
#line 694 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp3_) {
#line 3259 "conversation-list-view.c"
		GeeSet* _tmp8_;
#line 695 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp8_ = self->priv->_selected;
#line 695 "../src/client/conversation-list/conversation-list-view.vala"
		g_signal_emit (self, conversation_list_view_signals[CONVERSATION_LIST_VIEW_CONVERSATIONS_SELECTED_SIGNAL], 0, _tmp8_);
#line 3265 "conversation-list-view.c"
	}
#line 686 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (selected);
#line 3269 "conversation-list-view.c"
}

static void
conversation_list_view_on_row_activated (ConversationListView* self)
{
	GtkListBoxRow* row = NULL;
	GtkListBox* _tmp0_;
	GtkListBoxRow* _tmp1_;
	GtkListBoxRow* _tmp2_;
	GtkListBoxRow* _tmp3_;
#line 699 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 700 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = self->priv->list;
#line 700 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp1_ = gtk_list_box_get_selected_row (_tmp0_);
#line 700 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 700 "../src/client/conversation-list/conversation-list-view.vala"
	row = _tmp2_;
#line 701 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp3_ = row;
#line 701 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp3_ != NULL) {
#line 3294 "conversation-list-view.c"
		GtkListBoxRow* _tmp4_;
		GearyAppConversation* _tmp5_;
#line 702 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp4_ = row;
#line 702 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp5_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, CONVERSATION_LIST_TYPE_ROW, ConversationListRow)->conversation;
#line 702 "../src/client/conversation-list/conversation-list-view.vala"
		g_signal_emit (self, conversation_list_view_signals[CONVERSATION_LIST_VIEW_CONVERSATION_ACTIVATED_SIGNAL], 0, _tmp5_, (guint) 1);
#line 3303 "conversation-list-view.c"
	}
#line 699 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (row);
#line 3307 "conversation-list-view.c"
}

static void
__lambda25_ (ConversationListView* self,
             GtkWidget* child)
{
	ConversationListRow* row = NULL;
	ConversationListRow* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 707 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (child, gtk_widget_get_type ()));
#line 708 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (child, CONVERSATION_LIST_TYPE_ROW, ConversationListRow));
#line 708 "../src/client/conversation-list/conversation-list-view.vala"
	row = _tmp0_;
#line 709 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp1_ = conversation_list_view_get_selection_mode_enabled (self);
#line 709 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp2_ = _tmp1_;
#line 709 "../src/client/conversation-list/conversation-list-view.vala"
	conversation_list_row_set_selection_enabled (row, _tmp2_);
#line 707 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (row);
#line 3332 "conversation-list-view.c"
}

static void
___lambda25__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
#line 707 "../src/client/conversation-list/conversation-list-view.vala"
	__lambda25_ ((ConversationListView*) self, widget);
#line 3341 "conversation-list-view.c"
}

static void
conversation_list_view_on_selection_mode_changed (ConversationListView* self)
{
	GtkListBox* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 706 "../src/client/conversation-list/conversation-list-view.vala"
	g_return_if_fail (CONVERSATION_LIST_IS_VIEW (self));
#line 707 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = self->priv->list;
#line 707 "../src/client/conversation-list/conversation-list-view.vala"
	gtk_container_foreach (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_container_get_type (), GtkContainer), ___lambda25__gtk_callback, self);
#line 712 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp1_ = conversation_list_view_get_selection_mode_enabled (self);
#line 712 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp2_ = _tmp1_;
#line 712 "../src/client/conversation-list/conversation-list-view.vala"
	if (_tmp2_) {
#line 3362 "conversation-list-view.c"
		GtkListBox* _tmp3_;
		GtkListBoxRow* _tmp4_;
		GtkListBoxRow* _tmp5_;
#line 713 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp3_ = self->priv->list;
#line 713 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp4_ = gtk_list_box_get_selected_row (_tmp3_);
#line 713 "../src/client/conversation-list/conversation-list-view.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 713 "../src/client/conversation-list/conversation-list-view.vala"
		_g_object_unref0 (self->priv->to_restore_row);
#line 713 "../src/client/conversation-list/conversation-list-view.vala"
		self->priv->to_restore_row = _tmp5_;
#line 3376 "conversation-list-view.c"
	} else {
#line 715 "../src/client/conversation-list/conversation-list-view.vala"
		conversation_list_view_restore_row (self);
#line 3380 "conversation-list-view.c"
	}
}

static void
conversation_list_view_class_init (ConversationListViewClass * klass,
                                   gpointer klass_data)
{
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	conversation_list_view_parent_class = g_type_class_peek_parent (klass);
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	g_type_class_adjust_private_offset (klass, &ConversationListView_private_offset);
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_conversation_list_view_get_property;
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_conversation_list_view_set_property;
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	G_OBJECT_CLASS (klass)->finalize = conversation_list_view_finalize;
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONVERSATION_LIST_VIEW_SELECTION_MODE_ENABLED_PROPERTY, conversation_list_view_properties[CONVERSATION_LIST_VIEW_SELECTION_MODE_ENABLED_PROPERTY] = g_param_spec_boolean ("selection-mode-enabled", "selection-mode-enabled", "selection-mode-enabled", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONVERSATION_LIST_VIEW_SELECTED_PROPERTY, conversation_list_view_properties[CONVERSATION_LIST_VIEW_SELECTED_PROPERTY] = g_param_spec_object ("selected", "selected", "selected", GEE_TYPE_SET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3402 "conversation-list-view.c"
	/**
	 * The set of all conversations currently displayed in the viewport
	 */
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONVERSATION_LIST_VIEW_VISIBLE_CONVERSATIONS_PROPERTY, conversation_list_view_properties[CONVERSATION_LIST_VIEW_VISIBLE_CONVERSATIONS_PROPERTY] = g_param_spec_object ("visible-conversations", "visible-conversations", "visible-conversations", GEE_TYPE_SET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Geary/conversation-list-view.ui");
#line 3410 "conversation-list-view.c"
	/**
	     * Emitted when one or more conversations are selected
	     */
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	conversation_list_view_signals[CONVERSATION_LIST_VIEW_CONVERSATIONS_SELECTED_SIGNAL] = g_signal_new ("conversations-selected", CONVERSATION_LIST_TYPE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_SET);
#line 3416 "conversation-list-view.c"
	/**
	     * Emitted when one conversation is activated
	     */
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	conversation_list_view_signals[CONVERSATION_LIST_VIEW_CONVERSATION_ACTIVATED_SIGNAL] = g_signal_new ("conversation-activated", CONVERSATION_LIST_TYPE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_UINT, G_TYPE_NONE, 2, GEARY_APP_TYPE_CONVERSATION, G_TYPE_UINT);
#line 3422 "conversation-list-view.c"
	/**
	     * Emitted when the user expresses intent to update the flags on a set of conversations
	     */
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	conversation_list_view_signals[CONVERSATION_LIST_VIEW_MARK_CONVERSATIONS_SIGNAL] = g_signal_new ("mark-conversations", CONVERSATION_LIST_TYPE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEE_TYPE_COLLECTION, GEARY_TYPE_NAMED_FLAG);
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "list", FALSE, ConversationListView_private_offset + G_STRUCT_OFFSET (ConversationListViewPrivate, list));
#line 94 "../src/client/conversation-list/conversation-list-view.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "conversation-list");
#line 3432 "conversation-list-view.c"
}

static void
conversation_list_view_geary_base_interface_interface_init (GearyBaseInterfaceIface * iface,
                                                            gpointer iface_data)
{
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	conversation_list_view_geary_base_interface_parent_iface = g_type_interface_peek_parent (iface);
#line 3441 "conversation-list-view.c"
}

static void
conversation_list_view_instance_init (ConversationListView * self,
                                      gpointer klass)
{
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	self->priv = conversation_list_view_get_instance_private (self);
#line 39 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp0_ = gee_hash_set_new (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 39 "../src/client/conversation-list/conversation-list-view.vala"
	self->priv->_selected = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_SET, GeeSet);
#line 55 "../src/client/conversation-list/conversation-list-view.vala"
	self->priv->to_restore_row = NULL;
#line 447 "../src/client/conversation-list/conversation-list-view.vala"
	self->priv->LOAD_MORE_THRESHOLD = (gdouble) 100;
#line 448 "../src/client/conversation-list/conversation-list-view.vala"
	self->priv->LOAD_MORE_COUNT = 50;
#line 467 "../src/client/conversation-list/conversation-list-view.vala"
	self->priv->VISIBILITY_UPDATE_DELAY_MS = 1000;
#line 472 "../src/client/conversation-list/conversation-list-view.vala"
	_tmp1_ = gee_hash_set_new (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 472 "../src/client/conversation-list/conversation-list-view.vala"
	self->priv->_visible_conversations = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_SET, GeeSet);
#line 513 "../src/client/conversation-list/conversation-list-view.vala"
	self->priv->should_inhibit_autoactivate = FALSE;
#line 653 "../src/client/conversation-list/conversation-list-view.vala"
	self->priv->drag_widget = NULL;
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 3474 "conversation-list-view.c"
}

static void
conversation_list_view_finalize (GObject * obj)
{
	ConversationListView * self;
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONVERSATION_LIST_TYPE_VIEW, ConversationListView);
#line 39 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (self->priv->_selected);
#line 43 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (self->priv->config);
#line 45 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (self->priv->press_gesture);
#line 46 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (self->priv->long_press_gesture);
#line 47 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (self->priv->key_event_controller);
#line 55 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (self->priv->to_restore_row);
#line 129 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (self->priv->model);
#line 472 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (self->priv->_visible_conversations);
#line 473 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (self->priv->scheduled_visible_update);
#line 653 "../src/client/conversation-list/conversation-list-view.vala"
	_g_object_unref0 (self->priv->drag_widget);
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	G_OBJECT_CLASS (conversation_list_view_parent_class)->finalize (obj);
#line 3505 "conversation-list-view.c"
}

/**
 * Represents in folder conversations list.
 *
 */
static GType
conversation_list_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ConversationListViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) conversation_list_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ConversationListView), 0, (GInstanceInitFunc) conversation_list_view_instance_init, NULL };
	static const GInterfaceInfo geary_base_interface_info = { (GInterfaceInitFunc) conversation_list_view_geary_base_interface_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType conversation_list_view_type_id;
	conversation_list_view_type_id = g_type_register_static (gtk_scrolled_window_get_type (), "ConversationListView", &g_define_type_info, 0);
	g_type_add_interface_static (conversation_list_view_type_id, GEARY_TYPE_BASE_INTERFACE, &geary_base_interface_info);
	ConversationListView_private_offset = g_type_add_instance_private (conversation_list_view_type_id, sizeof (ConversationListViewPrivate));
	return conversation_list_view_type_id;
}

GType
conversation_list_view_get_type (void)
{
	static volatile gsize conversation_list_view_type_id__once = 0;
	if (g_once_init_enter (&conversation_list_view_type_id__once)) {
		GType conversation_list_view_type_id;
		conversation_list_view_type_id = conversation_list_view_get_type_once ();
		g_once_init_leave (&conversation_list_view_type_id__once, conversation_list_view_type_id);
	}
	return conversation_list_view_type_id__once;
}

static void
_vala_conversation_list_view_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	ConversationListView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONVERSATION_LIST_TYPE_VIEW, ConversationListView);
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	switch (property_id) {
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		case CONVERSATION_LIST_VIEW_SELECTION_MODE_ENABLED_PROPERTY:
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		g_value_set_boolean (value, conversation_list_view_get_selection_mode_enabled (self));
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		break;
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		case CONVERSATION_LIST_VIEW_SELECTED_PROPERTY:
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		g_value_set_object (value, conversation_list_view_get_selected (self));
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		break;
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		case CONVERSATION_LIST_VIEW_VISIBLE_CONVERSATIONS_PROPERTY:
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		g_value_set_object (value, conversation_list_view_get_visible_conversations (self));
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		break;
#line 3564 "conversation-list-view.c"
		default:
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		break;
#line 3570 "conversation-list-view.c"
	}
}

static void
_vala_conversation_list_view_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	ConversationListView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONVERSATION_LIST_TYPE_VIEW, ConversationListView);
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
	switch (property_id) {
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		case CONVERSATION_LIST_VIEW_SELECTION_MODE_ENABLED_PROPERTY:
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		conversation_list_view_set_selection_mode_enabled (self, g_value_get_boolean (value));
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		break;
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		case CONVERSATION_LIST_VIEW_SELECTED_PROPERTY:
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		conversation_list_view_set_selected (self, g_value_get_object (value));
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		break;
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		case CONVERSATION_LIST_VIEW_VISIBLE_CONVERSATIONS_PROPERTY:
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		conversation_list_view_set_visible_conversations (self, g_value_get_object (value));
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		break;
#line 3602 "conversation-list-view.c"
		default:
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/client/conversation-list/conversation-list-view.vala"
		break;
#line 3608 "conversation-list-view.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

