/* conversation-viewer.c generated by valac 0.56.17, the Vala compiler
 * generated from conversation-viewer.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2016,2019 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-client-46.0.h"
#include <gee.h>
#include <glib-object.h>
#include "geary-engine.h"
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <handy.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	CONVERSATION_VIEWER_0_PROPERTY,
	CONVERSATION_VIEWER_CURRENT_LIST_PROPERTY,
	CONVERSATION_VIEWER_CURRENT_COMPOSER_PROPERTY,
	CONVERSATION_VIEWER_PREVIOUS_WEB_VIEW_PROPERTY,
	CONVERSATION_VIEWER_NUM_PROPERTIES
};
static GParamSpec* conversation_viewer_properties[CONVERSATION_VIEWER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ConversationViewerLoadConversationData ConversationViewerLoadConversationData;
typedef struct _Block102Data Block102Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ConversationViewerUpdateFindResultsData ConversationViewerUpdateFindResultsData;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block103Data Block103Data;
enum  {
	CONVERSATION_VIEWER_CONVERSATION_ADDED_SIGNAL,
	CONVERSATION_VIEWER_CONVERSATION_REMOVED_SIGNAL,
	CONVERSATION_VIEWER_NUM_SIGNALS
};
static guint conversation_viewer_signals[CONVERSATION_VIEWER_NUM_SIGNALS] = {0};

struct _ConversationViewerPrivate {
	ConversationListBox* _current_list;
	ComposerWidget* _current_composer;
	ConversationWebView* _previous_web_view;
	ApplicationConfiguration* config;
	GeeSet* selection_while_composing;
	GCancellable* find_cancellable;
	GtkSpinner* loading_page;
	GtkGrid* no_conversations_page;
	GtkGrid* conversation_page;
	GtkGrid* multiple_conversations_page;
	GtkGrid* empty_folder_page;
	GtkGrid* empty_search_page;
	GtkGrid* composer_page;
	GtkScrolledWindow* conversation_scroller;
	ComponentsEntryUndo* conversation_find_undo;
	GtkButton* conversation_find_next;
	GtkButton* conversation_find_prev;
};

struct _ConversationViewerLoadConversationData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ConversationViewer* self;
	GearyAppConversation* conversation;
	GeeCollection* scroll_to;
	GearyAppEmailStore* store;
	ApplicationContactStore* contacts;
	gboolean start_mark_timer;
	GtkWidget* old_viewport;
	GtkWidget* _tmp0_;
	ConversationListBox* new_list;
	ApplicationConfiguration* _tmp1_;
	GtkScrolledWindow* _tmp2_;
	GtkAdjustment* _tmp3_;
	ConversationListBox* _tmp4_;
	ConversationListBox* _tmp5_;
	GtkButton* _tmp6_;
	GtkButton* _tmp7_;
	ConversationListBox* _tmp8_;
	ConversationListBoxSearchManager* _tmp9_;
	ConversationListBoxSearchManager* _tmp10_;
	ConversationListBox* _tmp11_;
	GtkGrid* _tmp12_;
	GearySearchQuery* query;
	GearyFolder* _tmp13_;
	GearyFolder* _tmp14_;
	GearyAccount* _tmp15_;
	GearyAccount* _tmp16_;
	GearySearchQuery* _tmp17_;
	GearySearchQuery* _tmp18_;
	GearyAppSearchFolder* search_folder;
	GearyFolder* _tmp19_;
	GearyFolder* _tmp20_;
	GearyAppSearchFolder* _tmp21_;
	GearyAppSearchFolder* _tmp22_;
	GearyAppSearchFolder* _tmp23_;
	GearySearchQuery* _tmp24_;
	GearySearchQuery* _tmp25_;
	GearySearchQuery* _tmp26_;
	ConversationListBox* _tmp27_;
	GearySearchQuery* _tmp28_;
	GError* _inner_error0_;
};

struct _Block102Data {
	int _ref_count_;
	ConversationViewer* self;
	ConversationListBox* list;
	gpointer _async_data_;
};

struct _ConversationViewerUpdateFindResultsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ConversationViewer* self;
	Block102Data* _data102_;
	ConversationListBox* _tmp0_;
	ConversationListBox* _tmp1_;
	ConversationListBox* _tmp2_;
	GCancellable* _tmp3_;
	GCancellable* _tmp4_;
	GCancellable* cancellable;
	GCancellable* _tmp5_;
	GCancellable* _tmp6_;
	GCancellable* _tmp7_;
	GCancellable* _tmp8_;
	GearySearchQuery* query;
	ConversationListBox* _tmp9_;
	GearyAppConversation* _tmp10_;
	GearyAppConversation* _tmp11_;
	GearyFolder* _tmp12_;
	GearyFolder* _tmp13_;
	GearyAccount* _tmp14_;
	GearyAccount* _tmp15_;
	GearySearchQuery* _tmp16_;
	GearySearchQuery* _tmp17_;
	ConversationListBox* _tmp18_;
	ConversationListBoxSearchManager* _tmp19_;
	ConversationListBoxSearchManager* _tmp20_;
	GearySearchQuery* _tmp21_;
	GError* err;
	GError* _tmp22_;
	const gchar* _tmp23_;
	GError* _inner_error0_;
};

struct _Block103Data {
	int _ref_count_;
	ConversationViewer* self;
	ConversationEmail* email_view;
};

static gint ConversationViewer_private_offset;
static gpointer conversation_viewer_parent_class = NULL;
static GearyBaseInterfaceIface * conversation_viewer_geary_base_interface_parent_iface = NULL;

static void conversation_viewer_set_current_list (ConversationViewer* self,
                                           ConversationListBox* value);
static void conversation_viewer_set_current_composer (ConversationViewer* self,
                                               ComposerWidget* value);
VALA_EXTERN ConversationWebView* conversation_viewer_get_previous_web_view (ConversationViewer* self);
VALA_EXTERN void conversation_viewer_set_previous_web_view (ConversationViewer* self,
                                                ConversationWebView* value);
static void conversation_viewer_on_composer_closed (ConversationViewer* self);
static void _conversation_viewer_on_composer_closed_composer_box_vanished (ComposerBox* _sender,
                                                                    gpointer self);
static void conversation_viewer_set_visible_child (ConversationViewer* self,
                                            GtkWidget* widget);
static void _conversation_viewer_on_composer_closed_composer_embed_vanished (ComposerEmbed* _sender,
                                                                      gpointer self);
static void conversation_viewer_load_conversation_data_free (gpointer _data);
static gboolean conversation_viewer_load_conversation_co (ConversationViewerLoadConversationData* _data_);
static GtkWidget* conversation_viewer_remove_current_list (ConversationViewer* self);
static void __lambda137_ (ConversationViewer* self,
                   guint count);
static void ___lambda137__conversation_list_box_search_manager_matches_updated (ConversationListBoxSearchManager* _sender,
                                                                         guint matches,
                                                                         gpointer self);
static void conversation_viewer_add_new_list (ConversationViewer* self,
                                       ConversationListBox* list);
static GearySearchQuery* conversation_viewer_get_find_search_query (ConversationViewer* self,
                                                             GearyAccount* account,
                                                             GError** error);
static void conversation_viewer_load_conversation_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
static void conversation_viewer_update_find_results_data_free (gpointer _data);
static void conversation_viewer_update_find_results (ConversationViewer* self,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
static void conversation_viewer_update_find_results_finish (ConversationViewer* self,
                                                     GAsyncResult* _res_);
static gboolean conversation_viewer_update_find_results_co (ConversationViewerUpdateFindResultsData* _data_);
static Block102Data* block102_data_ref (Block102Data* _data102_);
static void block102_data_unref (void * _userdata_);
static void ___lambda138_ (Block102Data* _data102_);
static void ____lambda138__g_cancellable_cancelled (GCancellable* _sender,
                                             gpointer self);
static void conversation_viewer_update_find_results_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_);
static void conversation_viewer_on_find_mode_changed (ConversationViewer* self,
                                               GObject* obj,
                                               GParamSpec* param);
static Block103Data* block103_data_ref (Block103Data* _data103_);
static void block103_data_unref (void * _userdata_);
static void _____lambda139_ (Block103Data* _data103_,
                      GObject* obj,
                      GAsyncResult* res);
static void ______lambda139__gasync_ready_callback (GObject* source_object,
                                             GAsyncResult* res,
                                             gpointer self);
static void _conversation_viewer_on_find_mode_changed_g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self);
static void conversation_viewer_on_find_text_changed (ConversationViewer* self,
                                               GtkSearchEntry* entry);
static void _conversation_viewer_on_find_text_changed_gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                                                gpointer self);
static void conversation_viewer_on_find_next (ConversationViewer* self,
                                       GtkWidget* entry);
static void _conversation_viewer_on_find_next_gtk_button_activate (GtkButton* _sender,
                                                            gpointer self);
static void conversation_viewer_on_find_prev (ConversationViewer* self,
                                       GtkWidget* entry);
static void _conversation_viewer_on_find_prev_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self);
static gboolean conversation_viewer_on_conversation_scroll (ConversationViewer* self);
static gboolean _conversation_viewer_on_conversation_scroll_gtk_widget_scroll_event (GtkWidget* _sender,
                                                                              GdkEventScroll* event,
                                                                              gpointer self);
static void conversation_viewer_finalize (GObject * obj);
static GType conversation_viewer_get_type_once (void);
static void _vala_conversation_viewer_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_conversation_viewer_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
conversation_viewer_get_instance_private (ConversationViewer* self)
{
	return G_STRUCT_MEMBER_P (self, ConversationViewer_private_offset);
}

ConversationListBox*
conversation_viewer_get_current_list (ConversationViewer* self)
{
	ConversationListBox* result;
	ConversationListBox* _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_val_if_fail (IS_CONVERSATION_VIEWER (self), NULL);
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->_current_list;
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
	result = _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
	return result;
#line 285 "conversation-viewer.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
	return self ? g_object_ref (self) : NULL;
#line 293 "conversation-viewer.c"
}

static void
conversation_viewer_set_current_list (ConversationViewer* self,
                                      ConversationListBox* value)
{
	ConversationListBox* old_value;
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
	old_value = conversation_viewer_get_current_list (self);
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (old_value != value) {
#line 307 "conversation-viewer.c"
		ConversationListBox* _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (self->priv->_current_list);
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
		self->priv->_current_list = _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_object_notify_by_pspec ((GObject *) self, conversation_viewer_properties[CONVERSATION_VIEWER_CURRENT_LIST_PROPERTY]);
#line 317 "conversation-viewer.c"
	}
}

ComposerWidget*
conversation_viewer_get_current_composer (ConversationViewer* self)
{
	ComposerWidget* result;
	ComposerWidget* _tmp0_;
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_val_if_fail (IS_CONVERSATION_VIEWER (self), NULL);
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->_current_composer;
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
	result = _tmp0_;
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
	return result;
#line 334 "conversation-viewer.c"
}

static void
conversation_viewer_set_current_composer (ConversationViewer* self,
                                          ComposerWidget* value)
{
	ComposerWidget* old_value;
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
	old_value = conversation_viewer_get_current_composer (self);
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (old_value != value) {
#line 348 "conversation-viewer.c"
		ComposerWidget* _tmp0_;
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (self->priv->_current_composer);
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
		self->priv->_current_composer = _tmp0_;
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_object_notify_by_pspec ((GObject *) self, conversation_viewer_properties[CONVERSATION_VIEWER_CURRENT_COMPOSER_PROPERTY]);
#line 358 "conversation-viewer.c"
	}
}

ConversationWebView*
conversation_viewer_get_previous_web_view (ConversationViewer* self)
{
	ConversationWebView* result;
	ConversationWebView* _tmp0_;
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_val_if_fail (IS_CONVERSATION_VIEWER (self), NULL);
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->_previous_web_view;
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	result = _tmp0_;
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	return result;
#line 375 "conversation-viewer.c"
}

void
conversation_viewer_set_previous_web_view (ConversationViewer* self,
                                           ConversationWebView* value)
{
	ConversationWebView* old_value;
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	old_value = conversation_viewer_get_previous_web_view (self);
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (old_value != value) {
#line 389 "conversation-viewer.c"
		ConversationWebView* _tmp0_;
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (self->priv->_previous_web_view);
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
		self->priv->_previous_web_view = _tmp0_;
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_object_notify_by_pspec ((GObject *) self, conversation_viewer_properties[CONVERSATION_VIEWER_PREVIOUS_WEB_VIEW_PROPERTY]);
#line 399 "conversation-viewer.c"
	}
}

/**
     * Constructs a new conversation view instance.
     */
ConversationViewer*
conversation_viewer_construct (GType object_type,
                               ApplicationConfiguration* config)
{
	ConversationViewer * self = NULL;
	ApplicationConfiguration* _tmp0_;
	HdyStatusPage* no_conversations = NULL;
	HdyStatusPage* _tmp1_;
	GtkGrid* _tmp2_;
	HdyStatusPage* multi_conversations = NULL;
	HdyStatusPage* _tmp3_;
	GtkGrid* _tmp4_;
	HdyStatusPage* empty_folder = NULL;
	HdyStatusPage* _tmp5_;
	GtkGrid* _tmp6_;
	HdyStatusPage* empty_search = NULL;
	HdyStatusPage* _tmp7_;
	GtkGrid* _tmp8_;
	GtkSearchEntry* _tmp9_;
	ComponentsEntryUndo* _tmp10_;
	GtkSearchBar* _tmp11_;
	GtkSearchEntry* _tmp12_;
#line 74 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (config), NULL);
#line 74 "../src/client/conversation-viewer/conversation-viewer.vala"
	self = (ConversationViewer*) g_object_new (object_type, NULL);
#line 75 "../src/client/conversation-viewer/conversation-viewer.vala"
	geary_base_interface_base_ref (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_BASE_INTERFACE, GearyBaseInterface));
#line 76 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = _g_object_ref0 (config);
#line 76 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->config);
#line 76 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv->config = _tmp0_;
#line 78 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = (HdyStatusPage*) hdy_status_page_new ();
#line 78 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_ref_sink (_tmp1_);
#line 78 "../src/client/conversation-viewer/conversation-viewer.vala"
	no_conversations = _tmp1_;
#line 80 "../src/client/conversation-viewer/conversation-viewer.vala"
	hdy_status_page_set_icon_name (no_conversations, "folder-symbolic");
#line 83 "../src/client/conversation-viewer/conversation-viewer.vala"
	hdy_status_page_set_title (no_conversations, _ ("No Conversations Selected"));
#line 86 "../src/client/conversation-viewer/conversation-viewer.vala"
	hdy_status_page_set_description (no_conversations, _ ("Selecting a conversation from the list will display it here."));
#line 89 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_hexpand (G_TYPE_CHECK_INSTANCE_CAST (no_conversations, gtk_widget_get_type (), GtkWidget), TRUE);
#line 90 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_vexpand (G_TYPE_CHECK_INSTANCE_CAST (no_conversations, gtk_widget_get_type (), GtkWidget), TRUE);
#line 91 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (no_conversations, gtk_widget_get_type (), GtkWidget));
#line 92 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = self->priv->no_conversations_page;
#line 92 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (no_conversations, gtk_widget_get_type (), GtkWidget));
#line 94 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp3_ = (HdyStatusPage*) hdy_status_page_new ();
#line 94 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_ref_sink (_tmp3_);
#line 94 "../src/client/conversation-viewer/conversation-viewer.vala"
	multi_conversations = _tmp3_;
#line 96 "../src/client/conversation-viewer/conversation-viewer.vala"
	hdy_status_page_set_icon_name (multi_conversations, "folder-symbolic");
#line 99 "../src/client/conversation-viewer/conversation-viewer.vala"
	hdy_status_page_set_title (multi_conversations, _ ("Multiple Conversations Selected"));
#line 102 "../src/client/conversation-viewer/conversation-viewer.vala"
	hdy_status_page_set_description (multi_conversations, _ ("Choosing an action will apply to all selected conversations."));
#line 105 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_hexpand (G_TYPE_CHECK_INSTANCE_CAST (multi_conversations, gtk_widget_get_type (), GtkWidget), TRUE);
#line 106 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_vexpand (G_TYPE_CHECK_INSTANCE_CAST (multi_conversations, gtk_widget_get_type (), GtkWidget), TRUE);
#line 107 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (multi_conversations, gtk_widget_get_type (), GtkWidget));
#line 108 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp4_ = self->priv->multiple_conversations_page;
#line 108 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (multi_conversations, gtk_widget_get_type (), GtkWidget));
#line 110 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp5_ = (HdyStatusPage*) hdy_status_page_new ();
#line 110 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_ref_sink (_tmp5_);
#line 110 "../src/client/conversation-viewer/conversation-viewer.vala"
	empty_folder = _tmp5_;
#line 112 "../src/client/conversation-viewer/conversation-viewer.vala"
	hdy_status_page_set_icon_name (empty_folder, "folder-symbolic");
#line 115 "../src/client/conversation-viewer/conversation-viewer.vala"
	hdy_status_page_set_title (empty_folder, _ ("No Conversations Found"));
#line 118 "../src/client/conversation-viewer/conversation-viewer.vala"
	hdy_status_page_set_description (empty_folder, _ ("This folder does not contain any conversations."));
#line 121 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_hexpand (G_TYPE_CHECK_INSTANCE_CAST (empty_folder, gtk_widget_get_type (), GtkWidget), TRUE);
#line 122 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_vexpand (G_TYPE_CHECK_INSTANCE_CAST (empty_folder, gtk_widget_get_type (), GtkWidget), TRUE);
#line 123 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (empty_folder, gtk_widget_get_type (), GtkWidget));
#line 124 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp6_ = self->priv->empty_folder_page;
#line 124 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (empty_folder, gtk_widget_get_type (), GtkWidget));
#line 126 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp7_ = (HdyStatusPage*) hdy_status_page_new ();
#line 126 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_ref_sink (_tmp7_);
#line 126 "../src/client/conversation-viewer/conversation-viewer.vala"
	empty_search = _tmp7_;
#line 128 "../src/client/conversation-viewer/conversation-viewer.vala"
	hdy_status_page_set_icon_name (empty_search, "folder-symbolic");
#line 131 "../src/client/conversation-viewer/conversation-viewer.vala"
	hdy_status_page_set_title (empty_search, _ ("No Conversations Found"));
#line 134 "../src/client/conversation-viewer/conversation-viewer.vala"
	hdy_status_page_set_description (empty_search, _ ("Your search returned no results, try refining your search terms."));
#line 137 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_hexpand (G_TYPE_CHECK_INSTANCE_CAST (empty_search, gtk_widget_get_type (), GtkWidget), TRUE);
#line 138 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_vexpand (G_TYPE_CHECK_INSTANCE_CAST (empty_search, gtk_widget_get_type (), GtkWidget), TRUE);
#line 139 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (empty_search, gtk_widget_get_type (), GtkWidget));
#line 140 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp8_ = self->priv->empty_search_page;
#line 140 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (empty_search, gtk_widget_get_type (), GtkWidget));
#line 142 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp9_ = self->conversation_find_entry;
#line 142 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp10_ = components_entry_undo_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_entry_get_type (), GtkEntry));
#line 142 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->conversation_find_undo);
#line 142 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv->conversation_find_undo = _tmp10_;
#line 147 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp11_ = self->conversation_find_bar;
#line 147 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp12_ = self->conversation_find_entry;
#line 147 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_search_bar_connect_entry (_tmp11_, G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_entry_get_type (), GtkEntry));
#line 74 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (empty_search);
#line 74 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (empty_folder);
#line 74 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (multi_conversations);
#line 74 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (no_conversations);
#line 74 "../src/client/conversation-viewer/conversation-viewer.vala"
	return self;
#line 552 "conversation-viewer.c"
}

ConversationViewer*
conversation_viewer_new (ApplicationConfiguration* config)
{
#line 74 "../src/client/conversation-viewer/conversation-viewer.vala"
	return conversation_viewer_construct (TYPE_CONVERSATION_VIEWER, config);
#line 560 "conversation-viewer.c"
}

/**
     * Puts the view into composer mode, showing a full-height composer.
     */
static void
_conversation_viewer_on_composer_closed_composer_box_vanished (ComposerBox* _sender,
                                                               gpointer self)
{
#line 171 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_on_composer_closed ((ConversationViewer*) self);
#line 572 "conversation-viewer.c"
}

void
conversation_viewer_do_compose (ConversationViewer* self,
                                ComposerWidget* composer)
{
	ApplicationMainWindow* main_window = NULL;
	GtkWidget* _tmp0_;
	ApplicationMainWindow* _tmp1_;
	ApplicationMainWindow* _tmp2_;
#line 157 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 157 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (COMPOSER_IS_WIDGET (composer));
#line 158 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = gtk_widget_get_toplevel (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 158 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = _g_object_ref0 (APPLICATION_IS_MAIN_WINDOW (_tmp0_) ? ((ApplicationMainWindow*) _tmp0_) : NULL);
#line 158 "../src/client/conversation-viewer/conversation-viewer.vala"
	main_window = _tmp1_;
#line 159 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = main_window;
#line 159 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp2_ != NULL) {
#line 597 "conversation-viewer.c"
		ComposerBox* box = NULL;
		ApplicationMainWindow* _tmp3_;
		ComponentsConversationHeaderBar* _tmp4_;
		ComposerBox* _tmp5_;
		ConversationListView* conversation_list = NULL;
		ApplicationMainWindow* _tmp6_;
		ConversationListView* _tmp7_;
		ConversationListView* _tmp8_;
		ConversationListView* _tmp9_;
		ConversationListView* _tmp10_;
		GeeSet* _tmp11_;
		GeeSet* _tmp12_;
		GeeSet* _tmp13_;
		ConversationListView* _tmp14_;
		ComposerBox* _tmp15_;
		GtkGrid* _tmp16_;
		ComposerBox* _tmp17_;
		GtkGrid* _tmp18_;
#line 160 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp3_ = main_window;
#line 160 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp4_ = _tmp3_->conversation_headerbar;
#line 160 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp5_ = composer_box_new (composer, _tmp4_);
#line 160 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_object_ref_sink (_tmp5_);
#line 160 "../src/client/conversation-viewer/conversation-viewer.vala"
		box = _tmp5_;
#line 163 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_viewer_set_current_composer (self, composer);
#line 167 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp6_ = main_window;
#line 167 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp7_ = application_main_window_get_conversation_list_view (_tmp6_);
#line 167 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp8_ = _tmp7_;
#line 167 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 167 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_list = _tmp9_;
#line 168 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp10_ = conversation_list;
#line 168 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp11_ = conversation_list_view_get_selected (_tmp10_);
#line 168 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp12_ = _tmp11_;
#line 168 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp13_ = _g_object_ref0 (_tmp12_);
#line 168 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (self->priv->selection_while_composing);
#line 168 "../src/client/conversation-viewer/conversation-viewer.vala"
		self->priv->selection_while_composing = _tmp13_;
#line 169 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp14_ = conversation_list;
#line 169 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_list_view_unselect_all (_tmp14_);
#line 171 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp15_ = box;
#line 171 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_signal_connect_object (_tmp15_, "vanished", (GCallback) _conversation_viewer_on_composer_closed_composer_box_vanished, self, 0);
#line 172 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp16_ = self->priv->composer_page;
#line 172 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp17_ = box;
#line 172 "../src/client/conversation-viewer/conversation-viewer.vala"
		gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, gtk_widget_get_type (), GtkWidget));
#line 173 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp18_ = self->priv->composer_page;
#line 173 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_viewer_set_visible_child (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, gtk_widget_get_type (), GtkWidget));
#line 174 "../src/client/conversation-viewer/conversation-viewer.vala"
		composer_widget_update_window_title (composer);
#line 159 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (conversation_list);
#line 159 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (box);
#line 674 "conversation-viewer.c"
	}
#line 157 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (main_window);
#line 678 "conversation-viewer.c"
}

/**
     * Puts the view into composer mode, showing an embedded composer.
     */
static void
_conversation_viewer_on_composer_closed_composer_embed_vanished (ComposerEmbed* _sender,
                                                                 gpointer self)
{
#line 189 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_on_composer_closed ((ConversationViewer*) self);
#line 690 "conversation-viewer.c"
}

void
conversation_viewer_do_compose_embedded (ConversationViewer* self,
                                         ComposerWidget* composer,
                                         GearyEmail* referred)
{
	ComposerEmbed* embed = NULL;
	GtkScrolledWindow* _tmp0_;
	ComposerEmbed* _tmp1_;
	ComposerEmbed* _tmp2_;
	gboolean kinetic = FALSE;
	GtkScrolledWindow* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	ConversationListBox* _tmp7_;
	GtkScrolledWindow* _tmp13_;
#line 181 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 181 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (COMPOSER_IS_WIDGET (composer));
#line 181 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail ((referred == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (referred, GEARY_TYPE_EMAIL));
#line 183 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_current_composer (self, composer);
#line 184 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->conversation_scroller;
#line 184 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = composer_embed_new (referred, composer, _tmp0_);
#line 184 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_ref_sink (_tmp1_);
#line 184 "../src/client/conversation-viewer/conversation-viewer.vala"
	embed = _tmp1_;
#line 189 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = embed;
#line 189 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_signal_connect_object (_tmp2_, "vanished", (GCallback) _conversation_viewer_on_composer_closed_composer_embed_vanished, self, 0);
#line 194 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp3_ = self->priv->conversation_scroller;
#line 194 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp4_ = gtk_scrolled_window_get_kinetic_scrolling (_tmp3_);
#line 194 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp5_ = _tmp4_;
#line 194 "../src/client/conversation-viewer/conversation-viewer.vala"
	kinetic = _tmp5_;
#line 195 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (kinetic) {
#line 738 "conversation-viewer.c"
		GtkScrolledWindow* _tmp6_;
#line 195 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp6_ = self->priv->conversation_scroller;
#line 195 "../src/client/conversation-viewer/conversation-viewer.vala"
		gtk_scrolled_window_set_kinetic_scrolling (_tmp6_, FALSE);
#line 744 "conversation-viewer.c"
	}
#line 197 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp7_ = self->priv->_current_list;
#line 197 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp7_ != NULL) {
#line 750 "conversation-viewer.c"
		ConversationListBox* _tmp8_;
		ComposerEmbed* _tmp9_;
		GearyEmailIdentifier* _tmp10_;
		GearyEmailIdentifier* _tmp11_;
#line 198 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp8_ = self->priv->_current_list;
#line 198 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp9_ = embed;
#line 198 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp10_ = composer_widget_get_saved_id (composer);
#line 198 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp11_ = _tmp10_;
#line 198 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_list_box_add_embedded_composer (_tmp8_, _tmp9_, _tmp11_ != NULL);
#line 202 "../src/client/conversation-viewer/conversation-viewer.vala"
		composer_widget_update_window_title (composer);
#line 767 "conversation-viewer.c"
	}
#line 205 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (kinetic) {
#line 771 "conversation-viewer.c"
		GtkScrolledWindow* _tmp12_;
#line 205 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp12_ = self->priv->conversation_scroller;
#line 205 "../src/client/conversation-viewer/conversation-viewer.vala"
		gtk_scrolled_window_set_kinetic_scrolling (_tmp12_, TRUE);
#line 777 "conversation-viewer.c"
	}
#line 208 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp13_ = self->priv->conversation_scroller;
#line 208 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (composer, gtk_widget_get_type (), GtkWidget), -1, (gtk_widget_get_allocated_height (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_widget_get_type (), GtkWidget)) / 3) * 2);
#line 181 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (embed);
#line 785 "conversation-viewer.c"
}

/**
     * Shows the loading UI.
     */
void
conversation_viewer_show_loading (ConversationViewer* self)
{
	GtkSpinner* _tmp0_;
	GtkSpinner* _tmp1_;
#line 216 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 217 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->loading_page;
#line 217 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_spinner_start (_tmp0_);
#line 218 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = self->priv->loading_page;
#line 218 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_visible_child (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget));
#line 806 "conversation-viewer.c"
}

/**
     * Shows the UI when no conversations have been selected
     */
void
conversation_viewer_show_none_selected (ConversationViewer* self)
{
	GtkGrid* _tmp0_;
#line 224 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 225 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->no_conversations_page;
#line 225 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_visible_child (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 822 "conversation-viewer.c"
}

/**
     * Shows the UI when multiple conversations have been selected
     */
void
conversation_viewer_show_multiple_selected (ConversationViewer* self)
{
	GtkGrid* _tmp0_;
#line 231 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 232 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->multiple_conversations_page;
#line 232 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_visible_child (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 838 "conversation-viewer.c"
}

/**
     * Shows the empty folder UI.
     */
void
conversation_viewer_show_empty_folder (ConversationViewer* self)
{
	GtkGrid* _tmp0_;
#line 238 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 239 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->empty_folder_page;
#line 239 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_visible_child (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 854 "conversation-viewer.c"
}

/**
     * Shows the empty search UI.
     */
void
conversation_viewer_show_empty_search (ConversationViewer* self)
{
	GtkGrid* _tmp0_;
#line 245 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 246 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->empty_search_page;
#line 246 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_visible_child (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 870 "conversation-viewer.c"
}

/** Shows and focuses the find entry. */
void
conversation_viewer_enable_find (ConversationViewer* self)
{
	GtkSearchBar* _tmp0_;
	GtkSearchEntry* _tmp1_;
#line 250 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 251 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->conversation_find_bar;
#line 251 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_search_bar_set_search_mode (_tmp0_, TRUE);
#line 252 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = self->conversation_find_entry;
#line 252 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget));
#line 889 "conversation-viewer.c"
}

static void
conversation_viewer_load_conversation_data_free (gpointer _data)
{
	ConversationViewerLoadConversationData* _data_;
	_data_ = _data;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->conversation);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->scroll_to);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->store);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->contacts);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->self);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_slice_free (ConversationViewerLoadConversationData, _data_);
#line 909 "conversation-viewer.c"
}

void
conversation_viewer_load_conversation (ConversationViewer* self,
                                       GearyAppConversation* conversation,
                                       GeeCollection* scroll_to,
                                       GearyAppEmailStore* store,
                                       ApplicationContactStore* contacts,
                                       gboolean start_mark_timer,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	ConversationViewerLoadConversationData* _data_;
	ConversationViewer* _tmp0_;
	GearyAppConversation* _tmp1_;
	GeeCollection* _tmp2_;
	GearyAppEmailStore* _tmp3_;
	ApplicationContactStore* _tmp4_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (conversation, GEARY_APP_TYPE_CONVERSATION));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (scroll_to, GEE_TYPE_COLLECTION));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (store, GEARY_APP_TYPE_EMAIL_STORE));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (APPLICATION_IS_CONTACT_STORE (contacts));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_ = g_slice_new0 (ConversationViewerLoadConversationData);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_task_set_task_data (_data_->_async_result, _data_, conversation_viewer_load_conversation_data_free);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->self = _tmp0_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = _g_object_ref0 (conversation);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->conversation);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->conversation = _tmp1_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = _g_object_ref0 (scroll_to);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->scroll_to);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->scroll_to = _tmp2_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp3_ = _g_object_ref0 (store);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->store);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->store = _tmp3_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp4_ = _g_object_ref0 (contacts);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->contacts);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->contacts = _tmp4_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->start_mark_timer = start_mark_timer;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_load_conversation_co (_data_);
#line 976 "conversation-viewer.c"
}

void
conversation_viewer_load_conversation_finish (ConversationViewer* self,
                                              GAsyncResult* _res_,
                                              GError** error)
{
	ConversationViewerLoadConversationData* _data_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (NULL == _data_) {
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		return;
#line 991 "conversation-viewer.c"
	}
}

/**
     * Shows a conversation in the viewer.
     */
static void
__lambda137_ (ConversationViewer* self,
              guint count)
{
	gboolean found = FALSE;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GtkSearchEntry* _tmp5_;
	GtkButton* _tmp6_;
	GtkButton* _tmp7_;
#line 285 "../src/client/conversation-viewer/conversation-viewer.vala"
	found = count > ((guint) 0);
#line 288 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (found) {
#line 288 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp1_ = TRUE;
#line 1014 "conversation-viewer.c"
	} else {
		GtkSearchEntry* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 288 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp2_ = self->conversation_find_entry;
#line 288 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp3_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_entry_get_type (), GtkEntry));
#line 288 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp4_ = _tmp3_;
#line 288 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp1_ = geary_string_is_empty (_tmp4_);
#line 1027 "conversation-viewer.c"
	}
#line 288 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp1_) {
#line 289 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp0_ = "edit-find-symbolic";
#line 1033 "conversation-viewer.c"
	} else {
#line 289 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp0_ = "computer-fail-symbolic";
#line 1037 "conversation-viewer.c"
	}
#line 286 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp5_ = self->conversation_find_entry;
#line 286 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_entry_set_icon_from_icon_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_entry_get_type (), GtkEntry), GTK_ENTRY_ICON_PRIMARY, _tmp0_);
#line 291 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp6_ = self->priv->conversation_find_next;
#line 291 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget), found);
#line 292 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp7_ = self->priv->conversation_find_prev;
#line 292 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget), found);
#line 1051 "conversation-viewer.c"
}

static void
___lambda137__conversation_list_box_search_manager_matches_updated (ConversationListBoxSearchManager* _sender,
                                                                    guint matches,
                                                                    gpointer self)
{
#line 284 "../src/client/conversation-viewer/conversation-viewer.vala"
	__lambda137_ ((ConversationViewer*) self, matches);
#line 1061 "conversation-viewer.c"
}

static void
conversation_viewer_load_conversation_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	ConversationViewerLoadConversationData* _data_;
#line 307 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_ = _user_data_;
#line 307 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_source_object_ = source_object;
#line 307 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_res_ = _res_;
#line 307 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_load_conversation_co (_data_);
#line 1078 "conversation-viewer.c"
}

static gboolean
conversation_viewer_load_conversation_co (ConversationViewerLoadConversationData* _data_)
{
#line 258 "../src/client/conversation-viewer/conversation-viewer.vala"
	switch (_data_->_state_) {
#line 258 "../src/client/conversation-viewer/conversation-viewer.vala"
		case 0:
#line 1088 "conversation-viewer.c"
		goto _state_0;
#line 258 "../src/client/conversation-viewer/conversation-viewer.vala"
		case 1:
#line 1092 "conversation-viewer.c"
		goto _state_1;
		default:
#line 258 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_assert_not_reached ();
#line 1097 "conversation-viewer.c"
	}
	_state_0:
#line 264 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp0_ = conversation_viewer_remove_current_list (_data_->self);
#line 264 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->old_viewport = _data_->_tmp0_;
#line 266 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp1_ = _data_->self->priv->config;
#line 266 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp2_ = _data_->self->priv->conversation_scroller;
#line 266 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp3_ = gtk_scrolled_window_get_vadjustment (_data_->_tmp2_);
#line 266 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp4_ = conversation_list_box_new (_data_->conversation, !_data_->start_mark_timer, _data_->store, _data_->contacts, _data_->_tmp1_, _data_->_tmp3_);
#line 266 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_ref_sink (_data_->_tmp4_);
#line 266 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->new_list = _data_->_tmp4_;
#line 278 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp5_ = _data_->new_list;
#line 278 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_signal_emit (_data_->self, conversation_viewer_signals[CONVERSATION_VIEWER_CONVERSATION_ADDED_SIGNAL], 0, _data_->_tmp5_);
#line 282 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp6_ = _data_->self->priv->conversation_find_next;
#line 282 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 283 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp7_ = _data_->self->priv->conversation_find_prev;
#line 283 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp7_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 284 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp8_ = _data_->new_list;
#line 284 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp9_ = conversation_list_box_get_search (_data_->_tmp8_);
#line 284 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 284 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_signal_connect_object (_data_->_tmp10_, "matches-updated", (GCallback) ___lambda137__conversation_list_box_search_manager_matches_updated, _data_->self, 0);
#line 294 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp11_ = _data_->new_list;
#line 294 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_add_new_list (_data_->self, _data_->_tmp11_);
#line 295 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp12_ = _data_->self->priv->conversation_page;
#line 295 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_visible_child (_data_->self, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp12_, gtk_widget_get_type (), GtkWidget));
#line 299 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp13_ = geary_app_conversation_get_base_folder (_data_->conversation);
#line 299 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp14_ = _data_->_tmp13_;
#line 299 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp15_ = geary_folder_get_account (_data_->_tmp14_);
#line 299 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp16_ = _data_->_tmp15_;
#line 299 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp17_ = conversation_viewer_get_find_search_query (_data_->self, _data_->_tmp16_, &_data_->_inner_error0_);
#line 299 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->query = _data_->_tmp17_;
#line 299 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 299 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 299 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data_->new_list);
#line 299 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data_->old_viewport);
#line 299 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_object_unref (_data_->_async_result);
#line 299 "../src/client/conversation-viewer/conversation-viewer.vala"
		return FALSE;
#line 1168 "conversation-viewer.c"
	}
#line 300 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp18_ = _data_->query;
#line 300 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_data_->_tmp18_ == NULL) {
#line 301 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp19_ = geary_app_conversation_get_base_folder (_data_->conversation);
#line 301 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp20_ = _data_->_tmp19_;
#line 301 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp21_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp20_, GEARY_APP_TYPE_SEARCH_FOLDER) ? ((GearyAppSearchFolder*) _data_->_tmp20_) : NULL);
#line 301 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->search_folder = _data_->_tmp21_;
#line 302 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp22_ = _data_->search_folder;
#line 302 "../src/client/conversation-viewer/conversation-viewer.vala"
		if (_data_->_tmp22_ != NULL) {
#line 303 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp23_ = _data_->search_folder;
#line 303 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp24_ = geary_app_search_folder_get_query (_data_->_tmp23_);
#line 303 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp25_ = _data_->_tmp24_;
#line 303 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp26_ = _g_object_ref0 (_data_->_tmp25_);
#line 303 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (_data_->query);
#line 303 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->query = _data_->_tmp26_;
#line 1198 "conversation-viewer.c"
		}
#line 300 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data_->search_folder);
#line 1202 "conversation-viewer.c"
	}
#line 307 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp27_ = _data_->new_list;
#line 307 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp28_ = _data_->query;
#line 307 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_state_ = 1;
#line 307 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_list_box_load_conversation (_data_->_tmp27_, _data_->scroll_to, _data_->_tmp28_, conversation_viewer_load_conversation_ready, _data_);
#line 307 "../src/client/conversation-viewer/conversation-viewer.vala"
	return FALSE;
#line 1214 "conversation-viewer.c"
	_state_1:
#line 307 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_list_box_load_conversation_finish (_data_->_tmp27_, _data_->_res_, &_data_->_inner_error0_);
#line 307 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 307 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 307 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data_->query);
#line 307 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data_->new_list);
#line 307 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data_->old_viewport);
#line 307 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_object_unref (_data_->_async_result);
#line 307 "../src/client/conversation-viewer/conversation-viewer.vala"
		return FALSE;
#line 1232 "conversation-viewer.c"
	}
#line 308 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->old_viewport);
#line 308 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->old_viewport = NULL;
#line 258 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->query);
#line 258 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->new_list);
#line 258 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->old_viewport);
#line 258 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 258 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_data_->_state_ != 0) {
#line 258 "../src/client/conversation-viewer/conversation-viewer.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 258 "../src/client/conversation-viewer/conversation-viewer.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1252 "conversation-viewer.c"
		}
	}
#line 258 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_unref (_data_->_async_result);
#line 258 "../src/client/conversation-viewer/conversation-viewer.vala"
	return FALSE;
#line 1259 "conversation-viewer.c"
}

static void
conversation_viewer_add_new_list (ConversationViewer* self,
                                  ConversationListBox* list)
{
	GtkViewport* viewport = NULL;
	GtkViewport* _tmp0_;
	GtkScrolledWindow* _tmp1_;
#line 312 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 312 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_LIST_BOX (list));
#line 313 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_current_list (self, list);
#line 314 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (list, gtk_widget_get_type (), GtkWidget));
#line 320 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = (GtkViewport*) gtk_viewport_new (NULL, NULL);
#line 320 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_ref_sink (_tmp0_);
#line 320 "../src/client/conversation-viewer/conversation-viewer.vala"
	viewport = _tmp0_;
#line 321 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (viewport, gtk_widget_get_type (), GtkWidget));
#line 322 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (viewport, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (list, gtk_widget_get_type (), GtkWidget));
#line 324 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = self->priv->conversation_scroller;
#line 324 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (viewport, gtk_widget_get_type (), GtkWidget));
#line 312 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (viewport);
#line 1293 "conversation-viewer.c"
}

static GtkWidget*
conversation_viewer_remove_current_list (ConversationViewer* self)
{
	GtkWidget* scrolled_child = NULL;
	GtkScrolledWindow* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkScrolledWindow* _tmp6_;
	GtkAdjustment* _tmp7_;
	GtkAdjustment* _tmp8_;
	GtkScrolledWindow* _tmp9_;
	GtkAdjustment* _tmp10_;
	GtkAdjustment* _tmp11_;
	ConversationListBox* _tmp12_;
	GtkWidget* result;
#line 328 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_val_if_fail (IS_CONVERSATION_VIEWER (self), NULL);
#line 330 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->conversation_scroller;
#line 330 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = gtk_bin_get_child (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_bin_get_type (), GtkBin));
#line 330 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 330 "../src/client/conversation-viewer/conversation-viewer.vala"
	scrolled_child = _tmp2_;
#line 331 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp3_ = scrolled_child;
#line 331 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp3_ != NULL) {
#line 1326 "conversation-viewer.c"
		GtkScrolledWindow* _tmp4_;
		GtkWidget* _tmp5_;
#line 332 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp4_ = self->priv->conversation_scroller;
#line 332 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp5_ = scrolled_child;
#line 332 "../src/client/conversation-viewer/conversation-viewer.vala"
		gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_container_get_type (), GtkContainer), _tmp5_);
#line 1335 "conversation-viewer.c"
	}
#line 336 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp6_ = self->priv->conversation_scroller;
#line 336 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp7_ = gtk_scrolled_window_get_hadjustment (_tmp6_);
#line 336 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp8_ = _tmp7_;
#line 336 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_adjustment_set_value (_tmp8_, (gdouble) 0);
#line 337 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp9_ = self->priv->conversation_scroller;
#line 337 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp10_ = gtk_scrolled_window_get_vadjustment (_tmp9_);
#line 337 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp11_ = _tmp10_;
#line 337 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_adjustment_set_value (_tmp11_, (gdouble) 0);
#line 339 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp12_ = self->priv->_current_list;
#line 339 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp12_ != NULL) {
#line 1357 "conversation-viewer.c"
		ConversationListBox* _tmp13_;
		ConversationListBox* _tmp14_;
#line 340 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp13_ = self->priv->_current_list;
#line 340 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_list_box_cancel_conversation_load (_tmp13_);
#line 341 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp14_ = self->priv->_current_list;
#line 341 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_signal_emit (self, conversation_viewer_signals[CONVERSATION_VIEWER_CONVERSATION_REMOVED_SIGNAL], 0, _tmp14_);
#line 342 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_viewer_set_current_list (self, NULL);
#line 1370 "conversation-viewer.c"
	}
#line 344 "../src/client/conversation-viewer/conversation-viewer.vala"
	result = scrolled_child;
#line 344 "../src/client/conversation-viewer/conversation-viewer.vala"
	return result;
#line 1376 "conversation-viewer.c"
}

/**
     * Sets the currently visible page of the stack.
     */
static void
conversation_viewer_set_visible_child (ConversationViewer* self,
                                       GtkWidget* widget)
{
	const gchar* _tmp0_;
	GtkWidget* current = NULL;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkGrid* _tmp4_;
#line 350 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 350 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_widget_get_type ()));
#line 351 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = gtk_buildable_get_name (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_buildable_get_type (), GtkBuildable));
#line 351 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_debug ("conversation-viewer.vala:351: Showing: %s", _tmp0_);
#line 352 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = gtk_stack_get_visible_child (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_stack_get_type (), GtkStack));
#line 352 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 352 "../src/client/conversation-viewer/conversation-viewer.vala"
	current = _tmp2_;
#line 353 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp3_ = current;
#line 353 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp4_ = self->priv->conversation_page;
#line 353 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp3_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget)) {
#line 1412 "conversation-viewer.c"
		GtkGrid* _tmp5_;
#line 354 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp5_ = self->priv->conversation_page;
#line 354 "../src/client/conversation-viewer/conversation-viewer.vala"
		if (widget != G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_widget_get_type (), GtkWidget)) {
#line 1418 "conversation-viewer.c"
			GtkWidget* _tmp6_;
			GtkWidget* _tmp7_;
#line 359 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp6_ = conversation_viewer_remove_current_list (self);
#line 359 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp7_ = _tmp6_;
#line 359 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (_tmp7_);
#line 1427 "conversation-viewer.c"
		}
	} else {
		GtkWidget* _tmp8_;
		GtkSpinner* _tmp9_;
#line 361 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp8_ = current;
#line 361 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp9_ = self->priv->loading_page;
#line 361 "../src/client/conversation-viewer/conversation-viewer.vala"
		if (_tmp8_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_widget_get_type (), GtkWidget)) {
#line 1438 "conversation-viewer.c"
			GtkSpinner* _tmp10_;
#line 364 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp10_ = self->priv->loading_page;
#line 364 "../src/client/conversation-viewer/conversation-viewer.vala"
			gtk_spinner_stop (_tmp10_);
#line 1444 "conversation-viewer.c"
		}
	}
#line 366 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_stack_set_visible_child (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_stack_get_type (), GtkStack), widget);
#line 350 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (current);
#line 1451 "conversation-viewer.c"
}

static void
conversation_viewer_update_find_results_data_free (gpointer _data)
{
	ConversationViewerUpdateFindResultsData* _data_;
	_data_ = _data;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->self);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_slice_free (ConversationViewerUpdateFindResultsData, _data_);
#line 1463 "conversation-viewer.c"
}

static void
conversation_viewer_update_find_results (ConversationViewer* self,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	ConversationViewerUpdateFindResultsData* _data_;
	ConversationViewer* _tmp0_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_ = g_slice_new0 (ConversationViewerUpdateFindResultsData);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_task_set_task_data (_data_->_async_result, _data_, conversation_viewer_update_find_results_data_free);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->self = _tmp0_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_update_find_results_co (_data_);
#line 1487 "conversation-viewer.c"
}

static void
conversation_viewer_update_find_results_finish (ConversationViewer* self,
                                                GAsyncResult* _res_)
{
	ConversationViewerUpdateFindResultsData* _data_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1497 "conversation-viewer.c"
}

static Block102Data*
block102_data_ref (Block102Data* _data102_)
{
#line 369 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_atomic_int_inc (&_data102_->_ref_count_);
#line 369 "../src/client/conversation-viewer/conversation-viewer.vala"
	return _data102_;
#line 1507 "conversation-viewer.c"
}

static void
block102_data_unref (void * _userdata_)
{
	Block102Data* _data102_;
	_data102_ = (Block102Data*) _userdata_;
#line 369 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (g_atomic_int_dec_and_test (&_data102_->_ref_count_)) {
#line 1517 "conversation-viewer.c"
		ConversationViewer* self;
#line 369 "../src/client/conversation-viewer/conversation-viewer.vala"
		self = _data102_->self;
#line 369 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data102_->list);
#line 369 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (self);
#line 369 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_slice_free (Block102Data, _data102_);
#line 1527 "conversation-viewer.c"
	}
}

static void
___lambda138_ (Block102Data* _data102_)
{
	ConversationViewer* self;
	ConversationListBox* _tmp0_;
	ConversationListBoxSearchManager* _tmp1_;
	ConversationListBoxSearchManager* _tmp2_;
#line 376 "../src/client/conversation-viewer/conversation-viewer.vala"
	self = _data102_->self;
#line 377 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = _data102_->list;
#line 377 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = conversation_list_box_get_search (_tmp0_);
#line 377 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = _tmp1_;
#line 377 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_list_box_search_manager_cancel (_tmp2_);
#line 1548 "conversation-viewer.c"
}

static void
____lambda138__g_cancellable_cancelled (GCancellable* _sender,
                                        gpointer self)
{
#line 376 "../src/client/conversation-viewer/conversation-viewer.vala"
	___lambda138_ (self);
#line 1557 "conversation-viewer.c"
}

static void
conversation_viewer_update_find_results_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_)
{
	ConversationViewerUpdateFindResultsData* _data_;
#line 385 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_ = _user_data_;
#line 385 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_source_object_ = source_object;
#line 385 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_res_ = _res_;
#line 385 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_update_find_results_co (_data_);
#line 1574 "conversation-viewer.c"
}

static gboolean
conversation_viewer_update_find_results_co (ConversationViewerUpdateFindResultsData* _data_)
{
#line 369 "../src/client/conversation-viewer/conversation-viewer.vala"
	switch (_data_->_state_) {
#line 369 "../src/client/conversation-viewer/conversation-viewer.vala"
		case 0:
#line 1584 "conversation-viewer.c"
		goto _state_0;
#line 369 "../src/client/conversation-viewer/conversation-viewer.vala"
		case 1:
#line 1588 "conversation-viewer.c"
		goto _state_1;
		default:
#line 369 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_assert_not_reached ();
#line 1593 "conversation-viewer.c"
	}
	_state_0:
#line 369 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_data102_ = g_slice_new0 (Block102Data);
#line 369 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_data102_->_ref_count_ = 1;
#line 369 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_data102_->self = g_object_ref (_data_->self);
#line 369 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_data102_->_async_data_ = _data_;
#line 370 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp0_ = _data_->self->priv->_current_list;
#line 370 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp1_ = _g_object_ref0 (_data_->_tmp0_);
#line 370 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_data102_->list = _data_->_tmp1_;
#line 371 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp2_ = _data_->_data102_->list;
#line 371 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_data_->_tmp2_ != NULL) {
#line 372 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp3_ = _data_->self->priv->find_cancellable;
#line 372 "../src/client/conversation-viewer/conversation-viewer.vala"
		if (_data_->_tmp3_ != NULL) {
#line 373 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp4_ = _data_->self->priv->find_cancellable;
#line 373 "../src/client/conversation-viewer/conversation-viewer.vala"
			g_cancellable_cancel (_data_->_tmp4_);
#line 1622 "conversation-viewer.c"
		}
#line 375 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp5_ = g_cancellable_new ();
#line 375 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->cancellable = _data_->_tmp5_;
#line 376 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp6_ = _data_->cancellable;
#line 376 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_signal_connect_data (_data_->_tmp6_, "cancelled", (GCallback) ____lambda138__g_cancellable_cancelled, block102_data_ref (_data_->_data102_), (GClosureNotify) block102_data_unref, 0);
#line 379 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp7_ = _data_->cancellable;
#line 379 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp8_ = _g_object_ref0 (_data_->_tmp7_);
#line 379 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data_->self->priv->find_cancellable);
#line 379 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->self->priv->find_cancellable = _data_->_tmp8_;
#line 1640 "conversation-viewer.c"
		{
#line 381 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp9_ = _data_->_data102_->list;
#line 381 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp10_ = conversation_list_box_get_conversation (_data_->_tmp9_);
#line 381 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp11_ = _data_->_tmp10_;
#line 381 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp12_ = geary_app_conversation_get_base_folder (_data_->_tmp11_);
#line 381 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp13_ = _data_->_tmp12_;
#line 381 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp14_ = geary_folder_get_account (_data_->_tmp13_);
#line 381 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp15_ = _data_->_tmp14_;
#line 381 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp16_ = conversation_viewer_get_find_search_query (_data_->self, _data_->_tmp15_, &_data_->_inner_error0_);
#line 381 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->query = _data_->_tmp16_;
#line 381 "../src/client/conversation-viewer/conversation-viewer.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1662 "conversation-viewer.c"
				goto __catch0_g_error;
			}
#line 384 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp17_ = _data_->query;
#line 384 "../src/client/conversation-viewer/conversation-viewer.vala"
			if (_data_->_tmp17_ != NULL) {
#line 385 "../src/client/conversation-viewer/conversation-viewer.vala"
				_data_->_tmp18_ = _data_->_data102_->list;
#line 385 "../src/client/conversation-viewer/conversation-viewer.vala"
				_data_->_tmp19_ = conversation_list_box_get_search (_data_->_tmp18_);
#line 385 "../src/client/conversation-viewer/conversation-viewer.vala"
				_data_->_tmp20_ = _data_->_tmp19_;
#line 385 "../src/client/conversation-viewer/conversation-viewer.vala"
				_data_->_tmp21_ = _data_->query;
#line 385 "../src/client/conversation-viewer/conversation-viewer.vala"
				_data_->_state_ = 1;
#line 385 "../src/client/conversation-viewer/conversation-viewer.vala"
				conversation_list_box_search_manager_highlight_matching_email (_data_->_tmp20_, _data_->_tmp21_, TRUE, conversation_viewer_update_find_results_ready, _data_);
#line 385 "../src/client/conversation-viewer/conversation-viewer.vala"
				return FALSE;
#line 1683 "conversation-viewer.c"
				_state_1:
#line 385 "../src/client/conversation-viewer/conversation-viewer.vala"
				conversation_list_box_search_manager_highlight_matching_email_finish (_data_->_tmp20_, _data_->_res_, &_data_->_inner_error0_);
#line 385 "../src/client/conversation-viewer/conversation-viewer.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 385 "../src/client/conversation-viewer/conversation-viewer.vala"
					_g_object_unref0 (_data_->query);
#line 1691 "conversation-viewer.c"
					goto __catch0_g_error;
				}
			}
#line 380 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (_data_->query);
#line 1697 "conversation-viewer.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 380 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->err = _data_->_inner_error0_;
#line 380 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_inner_error0_ = NULL;
#line 388 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp22_ = _data_->err;
#line 388 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp23_ = _data_->_tmp22_->message;
#line 388 "../src/client/conversation-viewer/conversation-viewer.vala"
			g_warning ("conversation-viewer.vala:388: Error updating find results: %s", _data_->_tmp23_);
#line 380 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_error_free0 (_data_->err);
#line 1714 "conversation-viewer.c"
		}
		__finally0:
#line 380 "../src/client/conversation-viewer/conversation-viewer.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 380 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (_data_->cancellable);
#line 380 "../src/client/conversation-viewer/conversation-viewer.vala"
			block102_data_unref (_data_->_data102_);
#line 380 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_data102_ = NULL;
#line 380 "../src/client/conversation-viewer/conversation-viewer.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 380 "../src/client/conversation-viewer/conversation-viewer.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 380 "../src/client/conversation-viewer/conversation-viewer.vala"
			g_object_unref (_data_->_async_result);
#line 380 "../src/client/conversation-viewer/conversation-viewer.vala"
			return FALSE;
#line 1733 "conversation-viewer.c"
		}
#line 371 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data_->cancellable);
#line 1737 "conversation-viewer.c"
	}
#line 369 "../src/client/conversation-viewer/conversation-viewer.vala"
	block102_data_unref (_data_->_data102_);
#line 369 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_data102_ = NULL;
#line 369 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 369 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_data_->_state_ != 0) {
#line 369 "../src/client/conversation-viewer/conversation-viewer.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 369 "../src/client/conversation-viewer/conversation-viewer.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1751 "conversation-viewer.c"
		}
	}
#line 369 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_unref (_data_->_async_result);
#line 369 "../src/client/conversation-viewer/conversation-viewer.vala"
	return FALSE;
#line 1758 "conversation-viewer.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 1779 "conversation-viewer.c"
}

static GearySearchQuery*
conversation_viewer_get_find_search_query (ConversationViewer* self,
                                           GearyAccount* account,
                                           GError** error)
{
	GearySearchQuery* query = NULL;
	GtkSearchBar* _tmp0_;
	GError* _inner_error0_ = NULL;
	GearySearchQuery* result;
#line 393 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_val_if_fail (IS_CONVERSATION_VIEWER (self), NULL);
#line 393 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT), NULL);
#line 395 "../src/client/conversation-viewer/conversation-viewer.vala"
	query = NULL;
#line 396 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->conversation_find_bar;
#line 396 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (gtk_search_bar_get_search_mode (_tmp0_)) {
#line 1801 "conversation-viewer.c"
		gchar* text = NULL;
		GtkSearchEntry* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 397 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp1_ = self->conversation_find_entry;
#line 397 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp2_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_entry_get_type (), GtkEntry));
#line 397 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp3_ = string_strip (_tmp2_);
#line 397 "../src/client/conversation-viewer/conversation-viewer.vala"
		text = _tmp3_;
#line 401 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp4_ = text;
#line 401 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp5_ = strlen (_tmp4_);
#line 401 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp6_ = _tmp5_;
#line 401 "../src/client/conversation-viewer/conversation-viewer.vala"
		if (_tmp6_ >= 2) {
#line 1825 "conversation-viewer.c"
			UtilEmailSearchExpressionFactory* expr_factory = NULL;
			ApplicationConfiguration* _tmp7_;
			GearyAccountInformation* _tmp8_;
			GearyAccountInformation* _tmp9_;
			UtilEmailSearchExpressionFactory* _tmp10_;
			GearySearchQuery* _tmp11_ = NULL;
			UtilEmailSearchExpressionFactory* _tmp12_;
			const gchar* _tmp13_;
			GeeList* _tmp14_;
			GeeList* _tmp15_;
			const gchar* _tmp16_;
			GearySearchQuery* _tmp17_;
			GearySearchQuery* _tmp18_;
			GearySearchQuery* _tmp19_;
#line 402 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp7_ = self->priv->config;
#line 402 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp8_ = geary_account_get_information (account);
#line 402 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp9_ = _tmp8_;
#line 402 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp10_ = util_email_search_expression_factory_new (application_configuration_get_search_strategy (_tmp7_), _tmp9_);
#line 402 "../src/client/conversation-viewer/conversation-viewer.vala"
			expr_factory = _tmp10_;
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp12_ = expr_factory;
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp13_ = text;
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp14_ = util_email_search_expression_factory_parse_query (_tmp12_, _tmp13_);
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp15_ = _tmp14_;
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp16_ = text;
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp17_ = geary_account_new_search_query (account, _tmp15_, _tmp16_, &_inner_error0_);
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp18_ = _tmp17_;
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (_tmp15_);
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp11_ = _tmp18_;
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
				g_propagate_error (error, _inner_error0_);
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
				_g_object_unref0 (expr_factory);
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
				_g_free0 (text);
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
				_g_object_unref0 (query);
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
				return NULL;
#line 1880 "conversation-viewer.c"
			}
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp19_ = _tmp11_;
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp11_ = NULL;
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (query);
#line 406 "../src/client/conversation-viewer/conversation-viewer.vala"
			query = _tmp19_;
#line 401 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (_tmp11_);
#line 401 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (expr_factory);
#line 1894 "conversation-viewer.c"
		}
#line 396 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_free0 (text);
#line 1898 "conversation-viewer.c"
	}
#line 412 "../src/client/conversation-viewer/conversation-viewer.vala"
	result = query;
#line 412 "../src/client/conversation-viewer/conversation-viewer.vala"
	return result;
#line 1904 "conversation-viewer.c"
}

static Block103Data*
block103_data_ref (Block103Data* _data103_)
{
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_atomic_int_inc (&_data103_->_ref_count_);
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
	return _data103_;
#line 1914 "conversation-viewer.c"
}

static void
block103_data_unref (void * _userdata_)
{
	Block103Data* _data103_;
	_data103_ = (Block103Data*) _userdata_;
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (g_atomic_int_dec_and_test (&_data103_->_ref_count_)) {
#line 1924 "conversation-viewer.c"
		ConversationViewer* self;
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
		self = _data103_->self;
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data103_->email_view);
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (self);
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_slice_free (Block103Data, _data103_);
#line 1934 "conversation-viewer.c"
	}
}

static void
_____lambda139_ (Block103Data* _data103_,
                 GObject* obj,
                 GAsyncResult* res)
{
	ConversationViewer* self;
	gchar* text = NULL;
	ConversationEmail* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 423 "../src/client/conversation-viewer/conversation-viewer.vala"
	self = _data103_->self;
#line 423 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 423 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 424 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = _data103_->email_view;
#line 424 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = conversation_email_get_selection_for_find_finish (_tmp0_, res);
#line 424 "../src/client/conversation-viewer/conversation-viewer.vala"
	text = _tmp1_;
#line 425 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = text;
#line 425 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp2_ != NULL) {
#line 1964 "conversation-viewer.c"
		GtkSearchEntry* _tmp3_;
		const gchar* _tmp4_;
		GtkSearchEntry* _tmp5_;
#line 426 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp3_ = self->conversation_find_entry;
#line 426 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp4_ = text;
#line 426 "../src/client/conversation-viewer/conversation-viewer.vala"
		gtk_entry_set_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_entry_get_type (), GtkEntry), _tmp4_);
#line 427 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp5_ = self->conversation_find_entry;
#line 427 "../src/client/conversation-viewer/conversation-viewer.vala"
		gtk_editable_select_region (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_editable_get_type (), GtkEditable), 0, -1);
#line 1978 "conversation-viewer.c"
	}
#line 423 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_free0 (text);
#line 1982 "conversation-viewer.c"
}

static void
______lambda139__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self)
{
#line 423 "../src/client/conversation-viewer/conversation-viewer.vala"
	_____lambda139_ (self, source_object, res);
#line 423 "../src/client/conversation-viewer/conversation-viewer.vala"
	block103_data_unref (self);
#line 1994 "conversation-viewer.c"
}

static void
conversation_viewer_on_find_mode_changed (ConversationViewer* self,
                                          GObject* obj,
                                          GParamSpec* param)
{
	ConversationListBox* _tmp0_;
#line 416 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 416 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 416 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (param, G_TYPE_PARAM));
#line 417 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->_current_list;
#line 417 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp0_ != NULL) {
#line 2013 "conversation-viewer.c"
		GtkSearchBar* _tmp1_;
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp1_ = self->conversation_find_bar;
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
		if (gtk_search_bar_get_search_mode (_tmp1_)) {
#line 2019 "conversation-viewer.c"
			Block103Data* _data103_;
			ConversationListBox* _tmp2_;
			ConversationEmail* _tmp3_;
			ConversationEmail* _tmp4_;
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data103_ = g_slice_new0 (Block103Data);
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data103_->_ref_count_ = 1;
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data103_->self = g_object_ref (self);
#line 420 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp2_ = self->priv->_current_list;
#line 420 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp3_ = conversation_list_box_get_selection_view (_tmp2_);
#line 420 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data103_->email_view = _tmp3_;
#line 422 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp4_ = _data103_->email_view;
#line 422 "../src/client/conversation-viewer/conversation-viewer.vala"
			if (_tmp4_ != NULL) {
#line 2040 "conversation-viewer.c"
				ConversationEmail* _tmp5_;
#line 423 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp5_ = _data103_->email_view;
#line 423 "../src/client/conversation-viewer/conversation-viewer.vala"
				conversation_email_get_selection_for_find (_tmp5_, ______lambda139__gasync_ready_callback, block103_data_ref (_data103_));
#line 2046 "conversation-viewer.c"
			}
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
			block103_data_unref (_data103_);
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data103_ = NULL;
#line 2052 "conversation-viewer.c"
		} else {
			ConversationListBox* _tmp6_;
			ConversationListBoxSearchManager* _tmp7_;
			ConversationListBoxSearchManager* _tmp8_;
			GearyAppSearchFolder* search_folder = NULL;
			ConversationListBox* _tmp9_;
			GearyAppConversation* _tmp10_;
			GearyAppConversation* _tmp11_;
			GearyFolder* _tmp12_;
			GearyFolder* _tmp13_;
			GearyAppSearchFolder* _tmp14_;
			ComponentsEntryUndo* _tmp15_;
			GearyAppSearchFolder* _tmp16_;
#line 433 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp6_ = self->priv->_current_list;
#line 433 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp7_ = conversation_list_box_get_search (_tmp6_);
#line 433 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp8_ = _tmp7_;
#line 433 "../src/client/conversation-viewer/conversation-viewer.vala"
			conversation_list_box_search_manager_unmark_terms (_tmp8_);
#line 434 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp9_ = self->priv->_current_list;
#line 434 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp10_ = conversation_list_box_get_conversation (_tmp9_);
#line 434 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp11_ = _tmp10_;
#line 434 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp12_ = geary_app_conversation_get_base_folder (_tmp11_);
#line 434 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp13_ = _tmp12_;
#line 434 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp13_, GEARY_APP_TYPE_SEARCH_FOLDER) ? ((GearyAppSearchFolder*) _tmp13_) : NULL);
#line 434 "../src/client/conversation-viewer/conversation-viewer.vala"
			search_folder = _tmp14_;
#line 438 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp15_ = self->priv->conversation_find_undo;
#line 438 "../src/client/conversation-viewer/conversation-viewer.vala"
			components_entry_undo_reset (_tmp15_);
#line 439 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp16_ = search_folder;
#line 439 "../src/client/conversation-viewer/conversation-viewer.vala"
			if (_tmp16_ != NULL) {
#line 2096 "conversation-viewer.c"
				GearySearchQuery* query = NULL;
				GearyAppSearchFolder* _tmp17_;
				GearySearchQuery* _tmp18_;
				GearySearchQuery* _tmp19_;
				GearySearchQuery* _tmp20_;
				GearySearchQuery* _tmp21_;
#line 440 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp17_ = search_folder;
#line 440 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp18_ = geary_app_search_folder_get_query (_tmp17_);
#line 440 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp19_ = _tmp18_;
#line 440 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp20_ = _g_object_ref0 (_tmp19_);
#line 440 "../src/client/conversation-viewer/conversation-viewer.vala"
				query = _tmp20_;
#line 441 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp21_ = query;
#line 441 "../src/client/conversation-viewer/conversation-viewer.vala"
				if (_tmp21_ != NULL) {
#line 2117 "conversation-viewer.c"
					ConversationListBox* _tmp22_;
					ConversationListBoxSearchManager* _tmp23_;
					ConversationListBoxSearchManager* _tmp24_;
					GearySearchQuery* _tmp25_;
#line 442 "../src/client/conversation-viewer/conversation-viewer.vala"
					_tmp22_ = self->priv->_current_list;
#line 442 "../src/client/conversation-viewer/conversation-viewer.vala"
					_tmp23_ = conversation_list_box_get_search (_tmp22_);
#line 442 "../src/client/conversation-viewer/conversation-viewer.vala"
					_tmp24_ = _tmp23_;
#line 442 "../src/client/conversation-viewer/conversation-viewer.vala"
					_tmp25_ = query;
#line 442 "../src/client/conversation-viewer/conversation-viewer.vala"
					conversation_list_box_search_manager_highlight_matching_email (_tmp24_, _tmp25_, TRUE, NULL, NULL);
#line 2132 "conversation-viewer.c"
				}
#line 439 "../src/client/conversation-viewer/conversation-viewer.vala"
				_g_object_unref0 (query);
#line 2136 "conversation-viewer.c"
			}
#line 418 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (search_folder);
#line 2140 "conversation-viewer.c"
		}
	}
}

static void
_conversation_viewer_on_find_mode_changed_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self)
{
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_on_find_mode_changed ((ConversationViewer*) self, _sender, pspec);
#line 2152 "conversation-viewer.c"
}

static void
conversation_viewer_on_find_text_changed (ConversationViewer* self,
                                          GtkSearchEntry* entry)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
#line 453 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 453 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (entry, gtk_search_entry_get_type ()));
#line 454 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->conversation_find_next;
#line 454 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 455 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = self->priv->conversation_find_prev;
#line 455 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 456 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_update_find_results (self, NULL, NULL);
#line 2175 "conversation-viewer.c"
}

static void
_conversation_viewer_on_find_text_changed_gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                                           gpointer self)
{
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_on_find_text_changed ((ConversationViewer*) self, _sender);
#line 2184 "conversation-viewer.c"
}

static void
conversation_viewer_on_find_next (ConversationViewer* self,
                                  GtkWidget* entry)
{
	ConversationListBox* _tmp0_;
#line 460 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 460 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (entry, gtk_widget_get_type ()));
#line 461 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->_current_list;
#line 461 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp0_ != NULL) {
#line 2200 "conversation-viewer.c"
	}
}

static void
_conversation_viewer_on_find_next_gtk_button_activate (GtkButton* _sender,
                                                       gpointer self)
{
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_on_find_next ((ConversationViewer*) self, _sender);
#line 2210 "conversation-viewer.c"
}

static void
conversation_viewer_on_find_prev (ConversationViewer* self,
                                  GtkWidget* entry)
{
	ConversationListBox* _tmp0_;
#line 467 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 467 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (entry, gtk_widget_get_type ()));
#line 468 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->_current_list;
#line 468 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp0_ != NULL) {
#line 2226 "conversation-viewer.c"
	}
}

static void
_conversation_viewer_on_find_prev_gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self)
{
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_on_find_prev ((ConversationViewer*) self, _sender);
#line 2236 "conversation-viewer.c"
}

static gboolean
conversation_viewer_on_conversation_scroll (ConversationViewer* self)
{
	ConversationListBox* _tmp0_;
	gboolean result;
#line 474 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_val_if_fail (IS_CONVERSATION_VIEWER (self), FALSE);
#line 475 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->_current_list;
#line 475 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp0_ != NULL) {
#line 2250 "conversation-viewer.c"
		ConversationListBox* _tmp1_;
#line 476 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp1_ = self->priv->_current_list;
#line 476 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_list_box_mark_visible_read (_tmp1_);
#line 2256 "conversation-viewer.c"
	}
#line 478 "../src/client/conversation-viewer/conversation-viewer.vala"
	result = GDK_EVENT_PROPAGATE;
#line 478 "../src/client/conversation-viewer/conversation-viewer.vala"
	return result;
#line 2262 "conversation-viewer.c"
}

static gboolean
_conversation_viewer_on_conversation_scroll_gtk_widget_scroll_event (GtkWidget* _sender,
                                                                     GdkEventScroll* event,
                                                                     gpointer self)
{
	gboolean result;
	result = conversation_viewer_on_conversation_scroll ((ConversationViewer*) self);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	return result;
#line 2274 "conversation-viewer.c"
}

static void
conversation_viewer_on_composer_closed (ConversationViewer* self)
{
	GtkWidget* _tmp0_;
	GtkGrid* _tmp1_;
#line 481 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 482 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_current_composer (self, NULL);
#line 483 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = gtk_stack_get_visible_child (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_stack_get_type (), GtkStack));
#line 483 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = self->priv->composer_page;
#line 483 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp0_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget)) {
#line 2292 "conversation-viewer.c"
		GtkGrid* _tmp2_;
		ApplicationMainWindow* main_window = NULL;
		GtkWidget* _tmp3_;
		ApplicationMainWindow* _tmp4_;
		ApplicationMainWindow* _tmp5_;
#line 484 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp2_ = self->priv->conversation_page;
#line 484 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_viewer_set_visible_child (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_widget_get_type (), GtkWidget));
#line 487 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp3_ = gtk_widget_get_toplevel (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 487 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp4_ = _g_object_ref0 (APPLICATION_IS_MAIN_WINDOW (_tmp3_) ? ((ApplicationMainWindow*) _tmp3_) : NULL);
#line 487 "../src/client/conversation-viewer/conversation-viewer.vala"
		main_window = _tmp4_;
#line 488 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp5_ = main_window;
#line 488 "../src/client/conversation-viewer/conversation-viewer.vala"
		if (_tmp5_ != NULL) {
#line 2312 "conversation-viewer.c"
			ApplicationMainWindow* _tmp6_;
			GeeSet* _tmp7_;
#line 489 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp6_ = main_window;
#line 489 "../src/client/conversation-viewer/conversation-viewer.vala"
			application_main_window_update_title (_tmp6_);
#line 491 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp7_ = self->priv->selection_while_composing;
#line 491 "../src/client/conversation-viewer/conversation-viewer.vala"
			if (_tmp7_ != NULL) {
#line 2323 "conversation-viewer.c"
				ConversationListView* conversation_list = NULL;
				ApplicationMainWindow* _tmp8_;
				ConversationListView* _tmp9_;
				ConversationListView* _tmp10_;
				ConversationListView* _tmp11_;
				GeeSet* _tmp12_;
				gboolean _tmp13_;
				gboolean _tmp14_;
#line 492 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp8_ = main_window;
#line 492 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp9_ = application_main_window_get_conversation_list_view (_tmp8_);
#line 492 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp10_ = _tmp9_;
#line 492 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp11_ = _g_object_ref0 (_tmp10_);
#line 492 "../src/client/conversation-viewer/conversation-viewer.vala"
				conversation_list = _tmp11_;
#line 493 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp12_ = self->priv->selection_while_composing;
#line 493 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp13_ = gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_COLLECTION, GeeCollection));
#line 493 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp14_ = _tmp13_;
#line 493 "../src/client/conversation-viewer/conversation-viewer.vala"
				if (_tmp14_) {
#line 2350 "conversation-viewer.c"
					ConversationListView* _tmp15_;
					GeeSet* _tmp16_;
#line 494 "../src/client/conversation-viewer/conversation-viewer.vala"
					_tmp15_ = conversation_list;
#line 494 "../src/client/conversation-viewer/conversation-viewer.vala"
					_tmp16_ = self->priv->selection_while_composing;
#line 494 "../src/client/conversation-viewer/conversation-viewer.vala"
					g_signal_emit_by_name (_tmp15_, "conversations-selected", _tmp16_);
#line 2359 "conversation-viewer.c"
				} else {
					ConversationListView* _tmp17_;
					GeeSet* _tmp18_;
#line 498 "../src/client/conversation-viewer/conversation-viewer.vala"
					_tmp17_ = conversation_list;
#line 498 "../src/client/conversation-viewer/conversation-viewer.vala"
					_tmp18_ = self->priv->selection_while_composing;
#line 498 "../src/client/conversation-viewer/conversation-viewer.vala"
					conversation_list_view_select_conversations (_tmp17_, G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_COLLECTION, GeeCollection));
#line 2369 "conversation-viewer.c"
				}
#line 503 "../src/client/conversation-viewer/conversation-viewer.vala"
				_g_object_unref0 (self->priv->selection_while_composing);
#line 503 "../src/client/conversation-viewer/conversation-viewer.vala"
				self->priv->selection_while_composing = NULL;
#line 491 "../src/client/conversation-viewer/conversation-viewer.vala"
				_g_object_unref0 (conversation_list);
#line 2377 "conversation-viewer.c"
			}
		}
#line 483 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (main_window);
#line 2382 "conversation-viewer.c"
	}
}

static void
conversation_viewer_class_init (ConversationViewerClass * klass,
                                gpointer klass_data)
{
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_parent_class = g_type_class_peek_parent (klass);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_type_class_adjust_private_offset (klass, &ConversationViewer_private_offset);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_conversation_viewer_get_property;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_conversation_viewer_set_property;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	G_OBJECT_CLASS (klass)->finalize = conversation_viewer_finalize;
#line 2400 "conversation-viewer.c"
	/**
	     * The current conversation listbox, if any.
	     */
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONVERSATION_VIEWER_CURRENT_LIST_PROPERTY, conversation_viewer_properties[CONVERSATION_VIEWER_CURRENT_LIST_PROPERTY] = g_param_spec_object ("current-list", "current-list", "current-list", TYPE_CONVERSATION_LIST_BOX, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2406 "conversation-viewer.c"
	/** Returns the currently displayed composer if any. */
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONVERSATION_VIEWER_CURRENT_COMPOSER_PROPERTY, conversation_viewer_properties[CONVERSATION_VIEWER_CURRENT_COMPOSER_PROPERTY] = g_param_spec_object ("current-composer", "current-composer", "current-composer", COMPOSER_TYPE_WIDGET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2410 "conversation-viewer.c"
	/**
	     * The most recent web view created in this viewer.
	     *
	     * Keep the last created web view around so others can share the
	     * same WebKitGTK WebProcess.
	     */
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONVERSATION_VIEWER_PREVIOUS_WEB_VIEW_PROPERTY, conversation_viewer_properties[CONVERSATION_VIEWER_PREVIOUS_WEB_VIEW_PROPERTY] = g_param_spec_object ("previous-web-view", "previous-web-view", "previous-web-view", TYPE_CONVERSATION_WEB_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Geary/conversation-viewer.ui");
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_signals[CONVERSATION_VIEWER_CONVERSATION_ADDED_SIGNAL] = g_signal_new ("conversation-added", TYPE_CONVERSATION_VIEWER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_CONVERSATION_LIST_BOX);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_signals[CONVERSATION_VIEWER_CONVERSATION_REMOVED_SIGNAL] = g_signal_new ("conversation-removed", TYPE_CONVERSATION_VIEWER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_CONVERSATION_LIST_BOX);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "loading_page", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, loading_page));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "no_conversations_page", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, no_conversations_page));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_page", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, conversation_page));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "multiple_conversations_page", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, multiple_conversations_page));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "empty_folder_page", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, empty_folder_page));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "empty_search_page", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, empty_search_page));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "composer_page", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, composer_page));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_scroller", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, conversation_scroller));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_find_bar", FALSE, G_STRUCT_OFFSET (ConversationViewer, conversation_find_bar));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_find_entry", FALSE, G_STRUCT_OFFSET (ConversationViewer, conversation_find_entry));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_find_next", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, conversation_find_next));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_find_prev", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, conversation_find_prev));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_find_mode_changed", G_CALLBACK(_conversation_viewer_on_find_mode_changed_g_object_notify));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_find_text_changed", G_CALLBACK(_conversation_viewer_on_find_text_changed_gtk_search_entry_search_changed));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_find_next", G_CALLBACK(_conversation_viewer_on_find_next_gtk_button_activate));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_find_prev", G_CALLBACK(_conversation_viewer_on_find_prev_gtk_button_clicked));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_conversation_scroll", G_CALLBACK(_conversation_viewer_on_conversation_scroll_gtk_widget_scroll_event));
#line 68 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "geary-conversation-viewer");
#line 2461 "conversation-viewer.c"
}

static void
conversation_viewer_geary_base_interface_interface_init (GearyBaseInterfaceIface * iface,
                                                         gpointer iface_data)
{
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_geary_base_interface_parent_iface = g_type_interface_peek_parent (iface);
#line 2470 "conversation-viewer.c"
}

static void
conversation_viewer_instance_init (ConversationViewer * self,
                                   gpointer klass)
{
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv = conversation_viewer_get_instance_private (self);
#line 18 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv->_current_list = NULL;
#line 23 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv->_current_composer = NULL;
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv->_previous_web_view = NULL;
#line 37 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv->selection_while_composing = NULL;
#line 38 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv->find_cancellable = NULL;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2491 "conversation-viewer.c"
}

static void
conversation_viewer_finalize (GObject * obj)
{
	ConversationViewer * self;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CONVERSATION_VIEWER, ConversationViewer);
#line 151 "../src/client/conversation-viewer/conversation-viewer.vala"
	geary_base_interface_base_unref (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_BASE_INTERFACE, GearyBaseInterface));
#line 18 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->_current_list);
#line 23 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->_current_composer);
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->_previous_web_view);
#line 35 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->config);
#line 37 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->selection_while_composing);
#line 38 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->find_cancellable);
#line 53 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->conversation_find_undo);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	G_OBJECT_CLASS (conversation_viewer_parent_class)->finalize (obj);
#line 2518 "conversation-viewer.c"
}

/**
 * Displays the messages in a conversation and in-window composers.
 */
static GType
conversation_viewer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ConversationViewerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) conversation_viewer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ConversationViewer), 0, (GInstanceInitFunc) conversation_viewer_instance_init, NULL };
	static const GInterfaceInfo geary_base_interface_info = { (GInterfaceInitFunc) conversation_viewer_geary_base_interface_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType conversation_viewer_type_id;
	conversation_viewer_type_id = g_type_register_static (gtk_stack_get_type (), "ConversationViewer", &g_define_type_info, 0);
	g_type_add_interface_static (conversation_viewer_type_id, GEARY_TYPE_BASE_INTERFACE, &geary_base_interface_info);
	ConversationViewer_private_offset = g_type_add_instance_private (conversation_viewer_type_id, sizeof (ConversationViewerPrivate));
	return conversation_viewer_type_id;
}

GType
conversation_viewer_get_type (void)
{
	static volatile gsize conversation_viewer_type_id__once = 0;
	if (g_once_init_enter (&conversation_viewer_type_id__once)) {
		GType conversation_viewer_type_id;
		conversation_viewer_type_id = conversation_viewer_get_type_once ();
		g_once_init_leave (&conversation_viewer_type_id__once, conversation_viewer_type_id);
	}
	return conversation_viewer_type_id__once;
}

static void
_vala_conversation_viewer_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	ConversationViewer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CONVERSATION_VIEWER, ConversationViewer);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	switch (property_id) {
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		case CONVERSATION_VIEWER_CURRENT_LIST_PROPERTY:
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_value_set_object (value, conversation_viewer_get_current_list (self));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		break;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		case CONVERSATION_VIEWER_CURRENT_COMPOSER_PROPERTY:
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_value_set_object (value, conversation_viewer_get_current_composer (self));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		break;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		case CONVERSATION_VIEWER_PREVIOUS_WEB_VIEW_PROPERTY:
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_value_set_object (value, conversation_viewer_get_previous_web_view (self));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		break;
#line 2576 "conversation-viewer.c"
		default:
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		break;
#line 2582 "conversation-viewer.c"
	}
}

static void
_vala_conversation_viewer_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	ConversationViewer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CONVERSATION_VIEWER, ConversationViewer);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	switch (property_id) {
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		case CONVERSATION_VIEWER_CURRENT_LIST_PROPERTY:
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_viewer_set_current_list (self, g_value_get_object (value));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		break;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		case CONVERSATION_VIEWER_CURRENT_COMPOSER_PROPERTY:
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_viewer_set_current_composer (self, g_value_get_object (value));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		break;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		case CONVERSATION_VIEWER_PREVIOUS_WEB_VIEW_PROPERTY:
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_viewer_set_previous_web_view (self, g_value_get_object (value));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		break;
#line 2614 "conversation-viewer.c"
		default:
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		break;
#line 2620 "conversation-viewer.c"
	}
}

