/* password-dialog.c generated by valac 0.56.17, the Vala compiler
 * generated from password-dialog.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-client-46.0.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include "geary-engine.h"
#include <gdk/gdk.h>
#include <gobject/gvaluecollector.h>

#define PASSWORD_DIALOG_PRIMARY_TEXT_MARKUP "<span weight=\"bold\" size=\"larger\">%s</span>"
#define PASSWORD_DIALOG_PRIMARY_TEXT_FIRST_TRY _ ("Geary requires your email password to continue")
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecPasswordDialog ParamSpecPasswordDialog;

struct _PasswordDialogPrivate {
	GtkDialog* dialog;
	GtkEntry* entry_password;
	GtkCheckButton* check_remember_password;
	GtkButton* ok_button;
	gchar* _password;
	gboolean _remember_password;
};

struct _ParamSpecPasswordDialog {
	GParamSpec parent_instance;
};

static gint PasswordDialog_private_offset;
static gpointer password_dialog_parent_class = NULL;

static void password_dialog_set_password (PasswordDialog* self,
                                   const gchar* value);
static void password_dialog_set_remember_password (PasswordDialog* self,
                                            gboolean value);
static void password_dialog_refresh_ok_button_sensitivity (PasswordDialog* self);
static void _password_dialog_refresh_ok_button_sensitivity_gtk_editable_changed (GtkEditable* _sender,
                                                                          gpointer self);
static void password_dialog_finalize (PasswordDialog * obj);
static GType password_dialog_get_type_once (void);

static inline gpointer
password_dialog_get_instance_private (PasswordDialog* self)
{
	return G_STRUCT_MEMBER_P (self, PasswordDialog_private_offset);
}

const gchar*
password_dialog_get_password (PasswordDialog* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 23 "../src/client/dialogs/password-dialog.vala"
	g_return_val_if_fail (IS_PASSWORD_DIALOG (self), NULL);
#line 23 "../src/client/dialogs/password-dialog.vala"
	_tmp0_ = self->priv->_password;
#line 23 "../src/client/dialogs/password-dialog.vala"
	result = _tmp0_;
#line 23 "../src/client/dialogs/password-dialog.vala"
	return result;
#line 82 "password-dialog.c"
}

static void
password_dialog_set_password (PasswordDialog* self,
                              const gchar* value)
{
	gchar* _tmp0_;
#line 23 "../src/client/dialogs/password-dialog.vala"
	g_return_if_fail (IS_PASSWORD_DIALOG (self));
#line 23 "../src/client/dialogs/password-dialog.vala"
	_tmp0_ = g_strdup (value);
#line 23 "../src/client/dialogs/password-dialog.vala"
	_g_free0 (self->priv->_password);
#line 23 "../src/client/dialogs/password-dialog.vala"
	self->priv->_password = _tmp0_;
#line 98 "password-dialog.c"
}

gboolean
password_dialog_get_remember_password (PasswordDialog* self)
{
	gboolean result;
#line 24 "../src/client/dialogs/password-dialog.vala"
	g_return_val_if_fail (IS_PASSWORD_DIALOG (self), FALSE);
#line 24 "../src/client/dialogs/password-dialog.vala"
	result = self->priv->_remember_password;
#line 24 "../src/client/dialogs/password-dialog.vala"
	return result;
#line 111 "password-dialog.c"
}

static void
password_dialog_set_remember_password (PasswordDialog* self,
                                       gboolean value)
{
#line 24 "../src/client/dialogs/password-dialog.vala"
	g_return_if_fail (IS_PASSWORD_DIALOG (self));
#line 24 "../src/client/dialogs/password-dialog.vala"
	self->priv->_remember_password = value;
#line 122 "password-dialog.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 32 "../src/client/dialogs/password-dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 130 "password-dialog.c"
}

static void
_password_dialog_refresh_ok_button_sensitivity_gtk_editable_changed (GtkEditable* _sender,
                                                                     gpointer self)
{
#line 60 "../src/client/dialogs/password-dialog.vala"
	password_dialog_refresh_ok_button_sensitivity ((PasswordDialog*) self);
#line 139 "password-dialog.c"
}

PasswordDialog*
password_dialog_construct (GType object_type,
                           GtkWindow* parent,
                           GearyAccountInformation* account,
                           GearyServiceInformation* service,
                           GearyCredentials* credentials)
{
	PasswordDialog* self = NULL;
	GtkBuilder* builder = NULL;
	GtkBuilder* _tmp0_;
	GtkBuilder* _tmp1_;
	GObject* _tmp2_;
	GtkDialog* _tmp3_;
	GtkDialog* _tmp4_;
	GtkDialog* _tmp5_;
	GtkDialog* _tmp6_;
	GtkBuilder* _tmp7_;
	GObject* _tmp8_;
	GtkEntry* _tmp9_;
	GtkBuilder* _tmp10_;
	GObject* _tmp11_;
	GtkCheckButton* _tmp12_;
	GtkLabel* label_username = NULL;
	GtkBuilder* _tmp13_;
	GObject* _tmp14_;
	GtkLabel* _tmp15_;
	GtkLabel* label_smtp = NULL;
	GtkBuilder* _tmp16_;
	GObject* _tmp17_;
	GtkLabel* _tmp18_;
	GtkLabel* primary_text_label = NULL;
	GtkBuilder* _tmp19_;
	GObject* _tmp20_;
	GtkLabel* _tmp21_;
	GtkLabel* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GtkCheckButton* _tmp32_;
	gboolean _tmp33_;
	gboolean _tmp34_;
	GearyProtocol _tmp35_;
	GearyProtocol _tmp36_;
	GtkBuilder* _tmp38_;
	GObject* _tmp39_;
	GtkButton* _tmp40_;
	GtkEntry* _tmp41_;
#line 26 "../src/client/dialogs/password-dialog.vala"
	g_return_val_if_fail ((parent == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (parent, gtk_window_get_type ()), NULL);
#line 26 "../src/client/dialogs/password-dialog.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION), NULL);
#line 26 "../src/client/dialogs/password-dialog.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (service, GEARY_TYPE_SERVICE_INFORMATION), NULL);
#line 26 "../src/client/dialogs/password-dialog.vala"
	g_return_val_if_fail ((credentials == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (credentials, GEARY_TYPE_CREDENTIALS), NULL);
#line 26 "../src/client/dialogs/password-dialog.vala"
	self = (PasswordDialog*) g_type_create_instance (object_type);
#line 30 "../src/client/dialogs/password-dialog.vala"
	_tmp0_ = gio_util_create_builder ("password-dialog.glade");
#line 30 "../src/client/dialogs/password-dialog.vala"
	builder = _tmp0_;
#line 32 "../src/client/dialogs/password-dialog.vala"
	_tmp1_ = builder;
#line 32 "../src/client/dialogs/password-dialog.vala"
	_tmp2_ = gtk_builder_get_object (_tmp1_, "PasswordDialog");
#line 32 "../src/client/dialogs/password-dialog.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_dialog_get_type (), GtkDialog));
#line 32 "../src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (self->priv->dialog);
#line 32 "../src/client/dialogs/password-dialog.vala"
	self->priv->dialog = _tmp3_;
#line 33 "../src/client/dialogs/password-dialog.vala"
	_tmp4_ = self->priv->dialog;
#line 33 "../src/client/dialogs/password-dialog.vala"
	gtk_window_set_transient_for (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_window_get_type (), GtkWindow), parent);
#line 34 "../src/client/dialogs/password-dialog.vala"
	_tmp5_ = self->priv->dialog;
#line 34 "../src/client/dialogs/password-dialog.vala"
	gtk_window_set_type_hint (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_window_get_type (), GtkWindow), GDK_WINDOW_TYPE_HINT_DIALOG);
#line 35 "../src/client/dialogs/password-dialog.vala"
	_tmp6_ = self->priv->dialog;
#line 35 "../src/client/dialogs/password-dialog.vala"
	gtk_dialog_set_default_response (_tmp6_, (gint) GTK_RESPONSE_OK);
#line 37 "../src/client/dialogs/password-dialog.vala"
	_tmp7_ = builder;
#line 37 "../src/client/dialogs/password-dialog.vala"
	_tmp8_ = gtk_builder_get_object (_tmp7_, "entry: password");
#line 37 "../src/client/dialogs/password-dialog.vala"
	_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_entry_get_type (), GtkEntry));
#line 37 "../src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (self->priv->entry_password);
#line 37 "../src/client/dialogs/password-dialog.vala"
	self->priv->entry_password = _tmp9_;
#line 38 "../src/client/dialogs/password-dialog.vala"
	_tmp10_ = builder;
#line 38 "../src/client/dialogs/password-dialog.vala"
	_tmp11_ = gtk_builder_get_object (_tmp10_, "check: remember_password");
#line 38 "../src/client/dialogs/password-dialog.vala"
	_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_check_button_get_type (), GtkCheckButton));
#line 38 "../src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (self->priv->check_remember_password);
#line 38 "../src/client/dialogs/password-dialog.vala"
	self->priv->check_remember_password = _tmp12_;
#line 40 "../src/client/dialogs/password-dialog.vala"
	_tmp13_ = builder;
#line 40 "../src/client/dialogs/password-dialog.vala"
	_tmp14_ = gtk_builder_get_object (_tmp13_, "label: username");
#line 40 "../src/client/dialogs/password-dialog.vala"
	_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_label_get_type (), GtkLabel));
#line 40 "../src/client/dialogs/password-dialog.vala"
	label_username = _tmp15_;
#line 41 "../src/client/dialogs/password-dialog.vala"
	_tmp16_ = builder;
#line 41 "../src/client/dialogs/password-dialog.vala"
	_tmp17_ = gtk_builder_get_object (_tmp16_, "label: smtp");
#line 41 "../src/client/dialogs/password-dialog.vala"
	_tmp18_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, gtk_label_get_type (), GtkLabel));
#line 41 "../src/client/dialogs/password-dialog.vala"
	label_smtp = _tmp18_;
#line 44 "../src/client/dialogs/password-dialog.vala"
	_tmp19_ = builder;
#line 44 "../src/client/dialogs/password-dialog.vala"
	_tmp20_ = gtk_builder_get_object (_tmp19_, "primary_text_label");
#line 44 "../src/client/dialogs/password-dialog.vala"
	_tmp21_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, gtk_label_get_type (), GtkLabel));
#line 44 "../src/client/dialogs/password-dialog.vala"
	primary_text_label = _tmp21_;
#line 45 "../src/client/dialogs/password-dialog.vala"
	_tmp22_ = primary_text_label;
#line 45 "../src/client/dialogs/password-dialog.vala"
	_tmp23_ = g_strdup_printf (PASSWORD_DIALOG_PRIMARY_TEXT_MARKUP, PASSWORD_DIALOG_PRIMARY_TEXT_FIRST_TRY);
#line 45 "../src/client/dialogs/password-dialog.vala"
	_tmp24_ = _tmp23_;
#line 45 "../src/client/dialogs/password-dialog.vala"
	gtk_label_set_markup (_tmp22_, _tmp24_);
#line 45 "../src/client/dialogs/password-dialog.vala"
	_g_free0 (_tmp24_);
#line 47 "../src/client/dialogs/password-dialog.vala"
	if (credentials != NULL) {
#line 280 "password-dialog.c"
		GtkLabel* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_ = NULL;
		const gchar* _tmp29_;
		const gchar* _tmp30_;
		GtkEntry* _tmp31_;
#line 48 "../src/client/dialogs/password-dialog.vala"
		_tmp25_ = label_username;
#line 48 "../src/client/dialogs/password-dialog.vala"
		_tmp26_ = geary_credentials_get_user (credentials);
#line 48 "../src/client/dialogs/password-dialog.vala"
		_tmp27_ = _tmp26_;
#line 48 "../src/client/dialogs/password-dialog.vala"
		gtk_label_set_text (_tmp25_, _tmp27_);
#line 49 "../src/client/dialogs/password-dialog.vala"
		_tmp29_ = geary_credentials_get_token (credentials);
#line 49 "../src/client/dialogs/password-dialog.vala"
		_tmp30_ = _tmp29_;
#line 49 "../src/client/dialogs/password-dialog.vala"
		_tmp28_ = _tmp30_;
#line 49 "../src/client/dialogs/password-dialog.vala"
		if (_tmp28_ == NULL) {
#line 49 "../src/client/dialogs/password-dialog.vala"
			_tmp28_ = "";
#line 306 "password-dialog.c"
		}
#line 49 "../src/client/dialogs/password-dialog.vala"
		_tmp31_ = self->priv->entry_password;
#line 49 "../src/client/dialogs/password-dialog.vala"
		gtk_entry_set_text (_tmp31_, _tmp28_);
#line 312 "password-dialog.c"
	}
#line 51 "../src/client/dialogs/password-dialog.vala"
	_tmp32_ = self->priv->check_remember_password;
#line 51 "../src/client/dialogs/password-dialog.vala"
	_tmp33_ = geary_service_information_get_remember_password (service);
#line 51 "../src/client/dialogs/password-dialog.vala"
	_tmp34_ = _tmp33_;
#line 51 "../src/client/dialogs/password-dialog.vala"
	gtk_toggle_button_set_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, gtk_toggle_button_get_type (), GtkToggleButton), _tmp34_);
#line 53 "../src/client/dialogs/password-dialog.vala"
	_tmp35_ = geary_service_information_get_protocol (service);
#line 53 "../src/client/dialogs/password-dialog.vala"
	_tmp36_ = _tmp35_;
#line 53 "../src/client/dialogs/password-dialog.vala"
	if (_tmp36_ == GEARY_PROTOCOL_SMTP) {
#line 328 "password-dialog.c"
		GtkLabel* _tmp37_;
#line 54 "../src/client/dialogs/password-dialog.vala"
		_tmp37_ = label_smtp;
#line 54 "../src/client/dialogs/password-dialog.vala"
		gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, gtk_widget_get_type (), GtkWidget));
#line 334 "password-dialog.c"
	}
#line 57 "../src/client/dialogs/password-dialog.vala"
	_tmp38_ = builder;
#line 57 "../src/client/dialogs/password-dialog.vala"
	_tmp39_ = gtk_builder_get_object (_tmp38_, "authenticate_button");
#line 57 "../src/client/dialogs/password-dialog.vala"
	_tmp40_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, gtk_button_get_type (), GtkButton));
#line 57 "../src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (self->priv->ok_button);
#line 57 "../src/client/dialogs/password-dialog.vala"
	self->priv->ok_button = _tmp40_;
#line 59 "../src/client/dialogs/password-dialog.vala"
	password_dialog_refresh_ok_button_sensitivity (self);
#line 60 "../src/client/dialogs/password-dialog.vala"
	_tmp41_ = self->priv->entry_password;
#line 60 "../src/client/dialogs/password-dialog.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, gtk_editable_get_type (), GtkEditable), "changed", (GCallback) _password_dialog_refresh_ok_button_sensitivity_gtk_editable_changed, self);
#line 26 "../src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (primary_text_label);
#line 26 "../src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (label_smtp);
#line 26 "../src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (label_username);
#line 26 "../src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (builder);
#line 26 "../src/client/dialogs/password-dialog.vala"
	return self;
#line 362 "password-dialog.c"
}

PasswordDialog*
password_dialog_new (GtkWindow* parent,
                     GearyAccountInformation* account,
                     GearyServiceInformation* service,
                     GearyCredentials* credentials)
{
#line 26 "../src/client/dialogs/password-dialog.vala"
	return password_dialog_construct (TYPE_PASSWORD_DIALOG, parent, account, service, credentials);
#line 373 "password-dialog.c"
}

static void
password_dialog_refresh_ok_button_sensitivity (PasswordDialog* self)
{
	GtkButton* _tmp0_;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
#line 63 "../src/client/dialogs/password-dialog.vala"
	g_return_if_fail (IS_PASSWORD_DIALOG (self));
#line 64 "../src/client/dialogs/password-dialog.vala"
	_tmp0_ = self->priv->ok_button;
#line 64 "../src/client/dialogs/password-dialog.vala"
	_tmp1_ = self->priv->entry_password;
#line 64 "../src/client/dialogs/password-dialog.vala"
	_tmp2_ = gtk_entry_get_text (_tmp1_);
#line 64 "../src/client/dialogs/password-dialog.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), !geary_string_is_empty_or_whitespace (_tmp2_));
#line 392 "password-dialog.c"
}

gboolean
password_dialog_run (PasswordDialog* self)
{
	GtkDialog* _tmp0_;
	GtkResponseType response = 0;
	GtkDialog* _tmp1_;
	GtkDialog* _tmp7_;
	gboolean result;
#line 67 "../src/client/dialogs/password-dialog.vala"
	g_return_val_if_fail (IS_PASSWORD_DIALOG (self), FALSE);
#line 68 "../src/client/dialogs/password-dialog.vala"
	_tmp0_ = self->priv->dialog;
#line 68 "../src/client/dialogs/password-dialog.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 70 "../src/client/dialogs/password-dialog.vala"
	_tmp1_ = self->priv->dialog;
#line 70 "../src/client/dialogs/password-dialog.vala"
	response = (GtkResponseType) gtk_dialog_run (_tmp1_);
#line 71 "../src/client/dialogs/password-dialog.vala"
	if (response == GTK_RESPONSE_OK) {
#line 415 "password-dialog.c"
		GtkEntry* _tmp2_;
		const gchar* _tmp3_;
		GtkCheckButton* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 72 "../src/client/dialogs/password-dialog.vala"
		_tmp2_ = self->priv->entry_password;
#line 72 "../src/client/dialogs/password-dialog.vala"
		_tmp3_ = gtk_entry_get_text (_tmp2_);
#line 72 "../src/client/dialogs/password-dialog.vala"
		password_dialog_set_password (self, _tmp3_);
#line 73 "../src/client/dialogs/password-dialog.vala"
		_tmp4_ = self->priv->check_remember_password;
#line 73 "../src/client/dialogs/password-dialog.vala"
		_tmp5_ = gtk_toggle_button_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_toggle_button_get_type (), GtkToggleButton));
#line 73 "../src/client/dialogs/password-dialog.vala"
		_tmp6_ = _tmp5_;
#line 73 "../src/client/dialogs/password-dialog.vala"
		password_dialog_set_remember_password (self, _tmp6_);
#line 435 "password-dialog.c"
	}
#line 76 "../src/client/dialogs/password-dialog.vala"
	_tmp7_ = self->priv->dialog;
#line 76 "../src/client/dialogs/password-dialog.vala"
	gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget));
#line 78 "../src/client/dialogs/password-dialog.vala"
	result = response == GTK_RESPONSE_OK;
#line 78 "../src/client/dialogs/password-dialog.vala"
	return result;
#line 445 "password-dialog.c"
}

static void
value_password_dialog_init (GValue* value)
{
#line 11 "../src/client/dialogs/password-dialog.vala"
	value->data[0].v_pointer = NULL;
#line 453 "password-dialog.c"
}

static void
value_password_dialog_free_value (GValue* value)
{
#line 11 "../src/client/dialogs/password-dialog.vala"
	if (value->data[0].v_pointer) {
#line 11 "../src/client/dialogs/password-dialog.vala"
		password_dialog_unref (value->data[0].v_pointer);
#line 463 "password-dialog.c"
	}
}

static void
value_password_dialog_copy_value (const GValue* src_value,
                                  GValue* dest_value)
{
#line 11 "../src/client/dialogs/password-dialog.vala"
	if (src_value->data[0].v_pointer) {
#line 11 "../src/client/dialogs/password-dialog.vala"
		dest_value->data[0].v_pointer = password_dialog_ref (src_value->data[0].v_pointer);
#line 475 "password-dialog.c"
	} else {
#line 11 "../src/client/dialogs/password-dialog.vala"
		dest_value->data[0].v_pointer = NULL;
#line 479 "password-dialog.c"
	}
}

static gpointer
value_password_dialog_peek_pointer (const GValue* value)
{
#line 11 "../src/client/dialogs/password-dialog.vala"
	return value->data[0].v_pointer;
#line 488 "password-dialog.c"
}

static gchar*
value_password_dialog_collect_value (GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
#line 11 "../src/client/dialogs/password-dialog.vala"
	if (collect_values[0].v_pointer) {
#line 499 "password-dialog.c"
		PasswordDialog * object;
		object = collect_values[0].v_pointer;
#line 11 "../src/client/dialogs/password-dialog.vala"
		if (object->parent_instance.g_class == NULL) {
#line 11 "../src/client/dialogs/password-dialog.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 506 "password-dialog.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 11 "../src/client/dialogs/password-dialog.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 510 "password-dialog.c"
		}
#line 11 "../src/client/dialogs/password-dialog.vala"
		value->data[0].v_pointer = password_dialog_ref (object);
#line 514 "password-dialog.c"
	} else {
#line 11 "../src/client/dialogs/password-dialog.vala"
		value->data[0].v_pointer = NULL;
#line 518 "password-dialog.c"
	}
#line 11 "../src/client/dialogs/password-dialog.vala"
	return NULL;
#line 522 "password-dialog.c"
}

static gchar*
value_password_dialog_lcopy_value (const GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
	PasswordDialog ** object_p;
	object_p = collect_values[0].v_pointer;
#line 11 "../src/client/dialogs/password-dialog.vala"
	if (!object_p) {
#line 11 "../src/client/dialogs/password-dialog.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 537 "password-dialog.c"
	}
#line 11 "../src/client/dialogs/password-dialog.vala"
	if (!value->data[0].v_pointer) {
#line 11 "../src/client/dialogs/password-dialog.vala"
		*object_p = NULL;
#line 543 "password-dialog.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 11 "../src/client/dialogs/password-dialog.vala"
		*object_p = value->data[0].v_pointer;
#line 547 "password-dialog.c"
	} else {
#line 11 "../src/client/dialogs/password-dialog.vala"
		*object_p = password_dialog_ref (value->data[0].v_pointer);
#line 551 "password-dialog.c"
	}
#line 11 "../src/client/dialogs/password-dialog.vala"
	return NULL;
#line 555 "password-dialog.c"
}

GParamSpec*
param_spec_password_dialog (const gchar* name,
                            const gchar* nick,
                            const gchar* blurb,
                            GType object_type,
                            GParamFlags flags)
{
	ParamSpecPasswordDialog* spec;
#line 11 "../src/client/dialogs/password-dialog.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PASSWORD_DIALOG), NULL);
#line 11 "../src/client/dialogs/password-dialog.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 11 "../src/client/dialogs/password-dialog.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 11 "../src/client/dialogs/password-dialog.vala"
	return G_PARAM_SPEC (spec);
#line 574 "password-dialog.c"
}

gpointer
value_get_password_dialog (const GValue* value)
{
#line 11 "../src/client/dialogs/password-dialog.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PASSWORD_DIALOG), NULL);
#line 11 "../src/client/dialogs/password-dialog.vala"
	return value->data[0].v_pointer;
#line 584 "password-dialog.c"
}

void
value_set_password_dialog (GValue* value,
                           gpointer v_object)
{
	PasswordDialog * old;
#line 11 "../src/client/dialogs/password-dialog.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PASSWORD_DIALOG));
#line 11 "../src/client/dialogs/password-dialog.vala"
	old = value->data[0].v_pointer;
#line 11 "../src/client/dialogs/password-dialog.vala"
	if (v_object) {
#line 11 "../src/client/dialogs/password-dialog.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PASSWORD_DIALOG));
#line 11 "../src/client/dialogs/password-dialog.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 11 "../src/client/dialogs/password-dialog.vala"
		value->data[0].v_pointer = v_object;
#line 11 "../src/client/dialogs/password-dialog.vala"
		password_dialog_ref (value->data[0].v_pointer);
#line 606 "password-dialog.c"
	} else {
#line 11 "../src/client/dialogs/password-dialog.vala"
		value->data[0].v_pointer = NULL;
#line 610 "password-dialog.c"
	}
#line 11 "../src/client/dialogs/password-dialog.vala"
	if (old) {
#line 11 "../src/client/dialogs/password-dialog.vala"
		password_dialog_unref (old);
#line 616 "password-dialog.c"
	}
}

void
value_take_password_dialog (GValue* value,
                            gpointer v_object)
{
	PasswordDialog * old;
#line 11 "../src/client/dialogs/password-dialog.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PASSWORD_DIALOG));
#line 11 "../src/client/dialogs/password-dialog.vala"
	old = value->data[0].v_pointer;
#line 11 "../src/client/dialogs/password-dialog.vala"
	if (v_object) {
#line 11 "../src/client/dialogs/password-dialog.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PASSWORD_DIALOG));
#line 11 "../src/client/dialogs/password-dialog.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 11 "../src/client/dialogs/password-dialog.vala"
		value->data[0].v_pointer = v_object;
#line 637 "password-dialog.c"
	} else {
#line 11 "../src/client/dialogs/password-dialog.vala"
		value->data[0].v_pointer = NULL;
#line 641 "password-dialog.c"
	}
#line 11 "../src/client/dialogs/password-dialog.vala"
	if (old) {
#line 11 "../src/client/dialogs/password-dialog.vala"
		password_dialog_unref (old);
#line 647 "password-dialog.c"
	}
}

static void
password_dialog_class_init (PasswordDialogClass * klass,
                            gpointer klass_data)
{
#line 11 "../src/client/dialogs/password-dialog.vala"
	password_dialog_parent_class = g_type_class_peek_parent (klass);
#line 11 "../src/client/dialogs/password-dialog.vala"
	((PasswordDialogClass *) klass)->finalize = password_dialog_finalize;
#line 11 "../src/client/dialogs/password-dialog.vala"
	g_type_class_adjust_private_offset (klass, &PasswordDialog_private_offset);
#line 661 "password-dialog.c"
}

static void
password_dialog_instance_init (PasswordDialog * self,
                               gpointer klass)
{
	gchar* _tmp0_;
#line 11 "../src/client/dialogs/password-dialog.vala"
	self->priv = password_dialog_get_instance_private (self);
#line 23 "../src/client/dialogs/password-dialog.vala"
	_tmp0_ = g_strdup ("");
#line 23 "../src/client/dialogs/password-dialog.vala"
	self->priv->_password = _tmp0_;
#line 11 "../src/client/dialogs/password-dialog.vala"
	self->ref_count = 1;
#line 677 "password-dialog.c"
}

static void
password_dialog_finalize (PasswordDialog * obj)
{
	PasswordDialog * self;
#line 11 "../src/client/dialogs/password-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PASSWORD_DIALOG, PasswordDialog);
#line 11 "../src/client/dialogs/password-dialog.vala"
	g_signal_handlers_destroy (self);
#line 18 "../src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (self->priv->dialog);
#line 19 "../src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (self->priv->entry_password);
#line 20 "../src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (self->priv->check_remember_password);
#line 21 "../src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (self->priv->ok_button);
#line 23 "../src/client/dialogs/password-dialog.vala"
	_g_free0 (self->priv->_password);
#line 698 "password-dialog.c"
}

/**
 * Displays a dialog for collecting the user's password, without allowing them to change their
 * other data.
 */
static GType
password_dialog_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_password_dialog_init, value_password_dialog_free_value, value_password_dialog_copy_value, value_password_dialog_peek_pointer, "p", value_password_dialog_collect_value, "p", value_password_dialog_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PasswordDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) password_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PasswordDialog), 0, (GInstanceInitFunc) password_dialog_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType password_dialog_type_id;
	password_dialog_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PasswordDialog", &g_define_type_info, &g_define_type_fundamental_info, 0);
	PasswordDialog_private_offset = g_type_add_instance_private (password_dialog_type_id, sizeof (PasswordDialogPrivate));
	return password_dialog_type_id;
}

GType
password_dialog_get_type (void)
{
	static volatile gsize password_dialog_type_id__once = 0;
	if (g_once_init_enter (&password_dialog_type_id__once)) {
		GType password_dialog_type_id;
		password_dialog_type_id = password_dialog_get_type_once ();
		g_once_init_leave (&password_dialog_type_id__once, password_dialog_type_id);
	}
	return password_dialog_type_id__once;
}

gpointer
password_dialog_ref (gpointer instance)
{
	PasswordDialog * self;
	self = instance;
#line 11 "../src/client/dialogs/password-dialog.vala"
	g_atomic_int_inc (&self->ref_count);
#line 11 "../src/client/dialogs/password-dialog.vala"
	return instance;
#line 738 "password-dialog.c"
}

void
password_dialog_unref (gpointer instance)
{
	PasswordDialog * self;
	self = instance;
#line 11 "../src/client/dialogs/password-dialog.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 11 "../src/client/dialogs/password-dialog.vala"
		PASSWORD_DIALOG_GET_CLASS (self)->finalize (self);
#line 11 "../src/client/dialogs/password-dialog.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 752 "password-dialog.c"
	}
}

