/* folder-list-account-branch.c generated by valac 0.56.17, the Vala compiler
 * generated from folder-list-account-branch.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* A branch that holds all the folders for a particular account.*/

#include "geary-client-46.0.h"
#include "geary-engine.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	FOLDER_LIST_ACCOUNT_BRANCH_0_PROPERTY,
	FOLDER_LIST_ACCOUNT_BRANCH_ACCOUNT_PROPERTY,
	FOLDER_LIST_ACCOUNT_BRANCH_USER_FOLDER_GROUP_PROPERTY,
	FOLDER_LIST_ACCOUNT_BRANCH_FOLDER_ENTRIES_PROPERTY,
	FOLDER_LIST_ACCOUNT_BRANCH_NUM_PROPERTIES
};
static GParamSpec* folder_list_account_branch_properties[FOLDER_LIST_ACCOUNT_BRANCH_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block105Data Block105Data;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FolderListAccountBranchPrivate {
	GearyAccount* _account;
	FolderListSpecialGrouping* _user_folder_group;
	GeeHashMap* _folder_entries;
	gchar* display_name;
};

struct _Block105Data {
	int _ref_count_;
	FolderListAccountBranch* self;
	FolderListFolderEntry* folder_entry;
};

static gint FolderListAccountBranch_private_offset;
static gpointer folder_list_account_branch_parent_class = NULL;

static void folder_list_account_branch_on_information_changed (FolderListAccountBranch* self);
static void _folder_list_account_branch_on_information_changed_geary_account_information_changed (GearyAccountInformation* _sender,
                                                                                           gpointer self);
static void folder_list_account_branch_on_entry_removed (FolderListAccountBranch* self,
                                                  SidebarEntry* entry);
static void _folder_list_account_branch_on_entry_removed_sidebar_branch_entry_removed (SidebarBranch* _sender,
                                                                                SidebarEntry* entry,
                                                                                gpointer self);
static void folder_list_account_branch_check_user_folders (FolderListAccountBranch* self,
                                                    SidebarEntry* entry);
static void _folder_list_account_branch_check_user_folders_sidebar_branch_entry_moved (SidebarBranch* _sender,
                                                                                SidebarEntry* entry,
                                                                                gpointer self);
static void folder_list_account_branch_set_account (FolderListAccountBranch* self,
                                             GearyAccount* value);
static void folder_list_account_branch_set_user_folder_group (FolderListAccountBranch* self,
                                                       FolderListSpecialGrouping* value);
static void folder_list_account_branch_set_folder_entries (FolderListAccountBranch* self,
                                                    GeeHashMap* value);
static gint folder_list_account_branch_normal_folder_comparator (SidebarEntry* a,
                                                          SidebarEntry* b);
static gint _folder_list_account_branch_normal_folder_comparator_gcompare_func (gconstpointer a,
                                                                         gconstpointer b);
static gint folder_list_account_branch_special_folder_comparator (SidebarEntry* a,
                                                           SidebarEntry* b);
static gint _folder_list_account_branch_special_folder_comparator_gcompare_func (gconstpointer a,
                                                                          gconstpointer b);
static gint folder_list_account_branch_special_grouping_comparator (SidebarEntry* a,
                                                             SidebarEntry* b);
static Block105Data* block105_data_ref (Block105Data* _data105_);
static void block105_data_unref (void * _userdata_);
static gboolean ___lambda6_ (Block105Data* _data105_,
                      SidebarEntry* e);
static gboolean ____lambda6__locator (gconstpointer item,
                               gpointer self);
static void folder_list_account_branch_finalize (GObject * obj);
static GType folder_list_account_branch_get_type_once (void);
static void _vala_folder_list_account_branch_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_folder_list_account_branch_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);

static const GearyFolderSpecialUse FOLDER_LIST_ACCOUNT_BRANCH_SPECIAL_USE_ORDERING[13] = {GEARY_FOLDER_SPECIAL_USE_INBOX, GEARY_FOLDER_SPECIAL_USE_SEARCH, GEARY_FOLDER_SPECIAL_USE_FLAGGED, GEARY_FOLDER_SPECIAL_USE_IMPORTANT, GEARY_FOLDER_SPECIAL_USE_DRAFTS, GEARY_FOLDER_SPECIAL_USE_CUSTOM, GEARY_FOLDER_SPECIAL_USE_NONE, GEARY_FOLDER_SPECIAL_USE_OUTBOX, GEARY_FOLDER_SPECIAL_USE_SENT, GEARY_FOLDER_SPECIAL_USE_ARCHIVE, GEARY_FOLDER_SPECIAL_USE_ALL_MAIL, GEARY_FOLDER_SPECIAL_USE_TRASH, GEARY_FOLDER_SPECIAL_USE_JUNK};

static inline gpointer
folder_list_account_branch_get_instance_private (FolderListAccountBranch* self)
{
	return G_STRUCT_MEMBER_P (self, FolderListAccountBranch_private_offset);
}

static void
_folder_list_account_branch_on_information_changed_geary_account_information_changed (GearyAccountInformation* _sender,
                                                                                      gpointer self)
{
#line 68 "../src/client/folder-list/folder-list-account-branch.vala"
	folder_list_account_branch_on_information_changed ((FolderListAccountBranch*) self);
#line 122 "folder-list-account-branch.c"
}

static void
_folder_list_account_branch_on_entry_removed_sidebar_branch_entry_removed (SidebarBranch* _sender,
                                                                           SidebarEntry* entry,
                                                                           gpointer self)
{
#line 69 "../src/client/folder-list/folder-list-account-branch.vala"
	folder_list_account_branch_on_entry_removed ((FolderListAccountBranch*) self, entry);
#line 132 "folder-list-account-branch.c"
}

static void
_folder_list_account_branch_check_user_folders_sidebar_branch_entry_moved (SidebarBranch* _sender,
                                                                           SidebarEntry* entry,
                                                                           gpointer self)
{
#line 70 "../src/client/folder-list/folder-list-account-branch.vala"
	folder_list_account_branch_check_user_folders ((FolderListAccountBranch*) self, entry);
#line 142 "folder-list-account-branch.c"
}

GearyAccount*
folder_list_account_branch_get_account (FolderListAccountBranch* self)
{
	GearyAccount* result;
	GearyAccount* _tmp0_;
#line 29 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_val_if_fail (FOLDER_LIST_IS_ACCOUNT_BRANCH (self), NULL);
#line 29 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp0_ = self->priv->_account;
#line 29 "../src/client/folder-list/folder-list-account-branch.vala"
	result = _tmp0_;
#line 29 "../src/client/folder-list/folder-list-account-branch.vala"
	return result;
#line 158 "folder-list-account-branch.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 29 "../src/client/folder-list/folder-list-account-branch.vala"
	return self ? g_object_ref (self) : NULL;
#line 166 "folder-list-account-branch.c"
}

static void
folder_list_account_branch_set_account (FolderListAccountBranch* self,
                                        GearyAccount* value)
{
	GearyAccount* old_value;
#line 29 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_if_fail (FOLDER_LIST_IS_ACCOUNT_BRANCH (self));
#line 29 "../src/client/folder-list/folder-list-account-branch.vala"
	old_value = folder_list_account_branch_get_account (self);
#line 29 "../src/client/folder-list/folder-list-account-branch.vala"
	if (old_value != value) {
#line 180 "folder-list-account-branch.c"
		GearyAccount* _tmp0_;
#line 29 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 29 "../src/client/folder-list/folder-list-account-branch.vala"
		_g_object_unref0 (self->priv->_account);
#line 29 "../src/client/folder-list/folder-list-account-branch.vala"
		self->priv->_account = _tmp0_;
#line 29 "../src/client/folder-list/folder-list-account-branch.vala"
		g_object_notify_by_pspec ((GObject *) self, folder_list_account_branch_properties[FOLDER_LIST_ACCOUNT_BRANCH_ACCOUNT_PROPERTY]);
#line 190 "folder-list-account-branch.c"
	}
}

FolderListSpecialGrouping*
folder_list_account_branch_get_user_folder_group (FolderListAccountBranch* self)
{
	FolderListSpecialGrouping* result;
	FolderListSpecialGrouping* _tmp0_;
#line 30 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_val_if_fail (FOLDER_LIST_IS_ACCOUNT_BRANCH (self), NULL);
#line 30 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp0_ = self->priv->_user_folder_group;
#line 30 "../src/client/folder-list/folder-list-account-branch.vala"
	result = _tmp0_;
#line 30 "../src/client/folder-list/folder-list-account-branch.vala"
	return result;
#line 207 "folder-list-account-branch.c"
}

static void
folder_list_account_branch_set_user_folder_group (FolderListAccountBranch* self,
                                                  FolderListSpecialGrouping* value)
{
	FolderListSpecialGrouping* old_value;
#line 30 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_if_fail (FOLDER_LIST_IS_ACCOUNT_BRANCH (self));
#line 30 "../src/client/folder-list/folder-list-account-branch.vala"
	old_value = folder_list_account_branch_get_user_folder_group (self);
#line 30 "../src/client/folder-list/folder-list-account-branch.vala"
	if (old_value != value) {
#line 221 "folder-list-account-branch.c"
		FolderListSpecialGrouping* _tmp0_;
#line 30 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 30 "../src/client/folder-list/folder-list-account-branch.vala"
		_g_object_unref0 (self->priv->_user_folder_group);
#line 30 "../src/client/folder-list/folder-list-account-branch.vala"
		self->priv->_user_folder_group = _tmp0_;
#line 30 "../src/client/folder-list/folder-list-account-branch.vala"
		g_object_notify_by_pspec ((GObject *) self, folder_list_account_branch_properties[FOLDER_LIST_ACCOUNT_BRANCH_USER_FOLDER_GROUP_PROPERTY]);
#line 231 "folder-list-account-branch.c"
	}
}

GeeHashMap*
folder_list_account_branch_get_folder_entries (FolderListAccountBranch* self)
{
	GeeHashMap* result;
	GeeHashMap* _tmp0_;
#line 31 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_val_if_fail (FOLDER_LIST_IS_ACCOUNT_BRANCH (self), NULL);
#line 31 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp0_ = self->priv->_folder_entries;
#line 31 "../src/client/folder-list/folder-list-account-branch.vala"
	result = _tmp0_;
#line 31 "../src/client/folder-list/folder-list-account-branch.vala"
	return result;
#line 248 "folder-list-account-branch.c"
}

static void
folder_list_account_branch_set_folder_entries (FolderListAccountBranch* self,
                                               GeeHashMap* value)
{
	GeeHashMap* old_value;
#line 31 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_if_fail (FOLDER_LIST_IS_ACCOUNT_BRANCH (self));
#line 31 "../src/client/folder-list/folder-list-account-branch.vala"
	old_value = folder_list_account_branch_get_folder_entries (self);
#line 31 "../src/client/folder-list/folder-list-account-branch.vala"
	if (old_value != value) {
#line 262 "folder-list-account-branch.c"
		GeeHashMap* _tmp0_;
#line 31 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 31 "../src/client/folder-list/folder-list-account-branch.vala"
		_g_object_unref0 (self->priv->_folder_entries);
#line 31 "../src/client/folder-list/folder-list-account-branch.vala"
		self->priv->_folder_entries = _tmp0_;
#line 31 "../src/client/folder-list/folder-list-account-branch.vala"
		g_object_notify_by_pspec ((GObject *) self, folder_list_account_branch_properties[FOLDER_LIST_ACCOUNT_BRANCH_FOLDER_ENTRIES_PROPERTY]);
#line 272 "folder-list-account-branch.c"
	}
}

static gint
_folder_list_account_branch_normal_folder_comparator_gcompare_func (gconstpointer a,
                                                                    gconstpointer b)
{
	gint result;
	result = folder_list_account_branch_normal_folder_comparator ((SidebarEntry*) a, (SidebarEntry*) b);
#line 36 "../src/client/folder-list/folder-list-account-branch.vala"
	return result;
#line 284 "folder-list-account-branch.c"
}

static gint
_folder_list_account_branch_special_folder_comparator_gcompare_func (gconstpointer a,
                                                                     gconstpointer b)
{
	gint result;
	result = folder_list_account_branch_special_folder_comparator ((SidebarEntry*) a, (SidebarEntry*) b);
#line 36 "../src/client/folder-list/folder-list-account-branch.vala"
	return result;
#line 295 "folder-list-account-branch.c"
}

FolderListAccountBranch*
folder_list_account_branch_construct (GType object_type,
                                      GearyAccount* account)
{
	FolderListAccountBranch * self = NULL;
	GearyAccountInformation* _tmp0_;
	GearyAccountInformation* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	SidebarHeader* _tmp4_;
	SidebarHeader* _tmp5_;
	gchar* name = NULL;
	gchar* icon_name = NULL;
	GearyAccountInformation* _tmp6_;
	GearyAccountInformation* _tmp7_;
	GearyServiceProvider _tmp8_;
	GearyServiceProvider _tmp9_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	FolderListSpecialGrouping* _tmp16_;
	FolderListSpecialGrouping* _tmp17_;
	GeeHashMap* _tmp18_;
	GeeHashMap* _tmp19_;
	GearyAccountInformation* _tmp20_;
	GearyAccountInformation* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	GearyAccountInformation* _tmp25_;
	GearyAccountInformation* _tmp26_;
#line 35 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT), NULL);
#line 36 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp0_ = geary_account_get_information (account);
#line 36 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp1_ = _tmp0_;
#line 36 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp2_ = geary_account_information_get_display_name (_tmp1_);
#line 36 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp3_ = _tmp2_;
#line 36 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp4_ = sidebar_header_new (_tmp3_, TRUE);
#line 36 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp5_ = _tmp4_;
#line 36 "../src/client/folder-list/folder-list-account-branch.vala"
	self = (FolderListAccountBranch*) sidebar_branch_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, SIDEBAR_TYPE_ENTRY, SidebarEntry), SIDEBAR_BRANCH_OPTIONS_STARTUP_OPEN_GROUPING | SIDEBAR_BRANCH_OPTIONS_STARTUP_EXPAND_TO_FIRST_CHILD, _folder_list_account_branch_normal_folder_comparator_gcompare_func, _folder_list_account_branch_special_folder_comparator_gcompare_func);
#line 36 "../src/client/folder-list/folder-list-account-branch.vala"
	_g_object_unref0 (_tmp5_);
#line 42 "../src/client/folder-list/folder-list-account-branch.vala"
	folder_list_account_branch_set_account (self, account);
#line 47 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp6_ = geary_account_get_information (account);
#line 47 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp7_ = _tmp6_;
#line 47 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp8_ = geary_account_information_get_service_provider (_tmp7_);
#line 47 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp9_ = _tmp8_;
#line 47 "../src/client/folder-list/folder-list-account-branch.vala"
	switch (_tmp9_) {
#line 47 "../src/client/folder-list/folder-list-account-branch.vala"
		case GEARY_SERVICE_PROVIDER_GMAIL:
#line 360 "folder-list-account-branch.c"
		{
			gchar* _tmp10_;
			gchar* _tmp11_;
#line 49 "../src/client/folder-list/folder-list-account-branch.vala"
			_tmp10_ = g_strdup (_ ("Labels"));
#line 49 "../src/client/folder-list/folder-list-account-branch.vala"
			_g_free0 (name);
#line 49 "../src/client/folder-list/folder-list-account-branch.vala"
			name = _tmp10_;
#line 50 "../src/client/folder-list/folder-list-account-branch.vala"
			_tmp11_ = g_strdup ("tag-symbolic");
#line 50 "../src/client/folder-list/folder-list-account-branch.vala"
			_g_free0 (icon_name);
#line 50 "../src/client/folder-list/folder-list-account-branch.vala"
			icon_name = _tmp11_;
#line 51 "../src/client/folder-list/folder-list-account-branch.vala"
			break;
#line 378 "folder-list-account-branch.c"
		}
		default:
		{
			gchar* _tmp12_;
			gchar* _tmp13_;
#line 53 "../src/client/folder-list/folder-list-account-branch.vala"
			_tmp12_ = g_strdup (_ ("Folders"));
#line 53 "../src/client/folder-list/folder-list-account-branch.vala"
			_g_free0 (name);
#line 53 "../src/client/folder-list/folder-list-account-branch.vala"
			name = _tmp12_;
#line 54 "../src/client/folder-list/folder-list-account-branch.vala"
			_tmp13_ = g_strdup ("folder-symbolic");
#line 54 "../src/client/folder-list/folder-list-account-branch.vala"
			_g_free0 (icon_name);
#line 54 "../src/client/folder-list/folder-list-account-branch.vala"
			icon_name = _tmp13_;
#line 55 "../src/client/folder-list/folder-list-account-branch.vala"
			break;
#line 398 "folder-list-account-branch.c"
		}
	}
#line 57 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp14_ = name;
#line 57 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp15_ = icon_name;
#line 57 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp16_ = folder_list_special_grouping_new (2, _tmp14_, _tmp15_, NULL);
#line 57 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp17_ = _tmp16_;
#line 57 "../src/client/folder-list/folder-list-account-branch.vala"
	folder_list_account_branch_set_user_folder_group (self, _tmp17_);
#line 57 "../src/client/folder-list/folder-list-account-branch.vala"
	_g_object_unref0 (_tmp17_);
#line 58 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp18_ = gee_hash_map_new (GEARY_TYPE_FOLDER_PATH, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, FOLDER_LIST_TYPE_FOLDER_ENTRY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 58 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp19_ = _tmp18_;
#line 58 "../src/client/folder-list/folder-list-account-branch.vala"
	folder_list_account_branch_set_folder_entries (self, _tmp19_);
#line 58 "../src/client/folder-list/folder-list-account-branch.vala"
	_g_object_unref0 (_tmp19_);
#line 60 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp20_ = geary_account_get_information (account);
#line 60 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp21_ = _tmp20_;
#line 60 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp22_ = geary_account_information_get_display_name (_tmp21_);
#line 60 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp23_ = _tmp22_;
#line 60 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp24_ = g_strdup (_tmp23_);
#line 60 "../src/client/folder-list/folder-list-account-branch.vala"
	_g_free0 (self->priv->display_name);
#line 60 "../src/client/folder-list/folder-list-account-branch.vala"
	self->priv->display_name = _tmp24_;
#line 61 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp25_ = geary_account_get_information (account);
#line 61 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp26_ = _tmp25_;
#line 61 "../src/client/folder-list/folder-list-account-branch.vala"
	g_signal_connect_object (_tmp26_, "changed", (GCallback) _folder_list_account_branch_on_information_changed_geary_account_information_changed, self, 0);
#line 63 "../src/client/folder-list/folder-list-account-branch.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, SIDEBAR_TYPE_BRANCH, SidebarBranch), "entry-removed", (GCallback) _folder_list_account_branch_on_entry_removed_sidebar_branch_entry_removed, self, 0);
#line 64 "../src/client/folder-list/folder-list-account-branch.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, SIDEBAR_TYPE_BRANCH, SidebarBranch), "entry-moved", (GCallback) _folder_list_account_branch_check_user_folders_sidebar_branch_entry_moved, self, 0);
#line 35 "../src/client/folder-list/folder-list-account-branch.vala"
	_g_free0 (icon_name);
#line 35 "../src/client/folder-list/folder-list-account-branch.vala"
	_g_free0 (name);
#line 35 "../src/client/folder-list/folder-list-account-branch.vala"
	return self;
#line 451 "folder-list-account-branch.c"
}

FolderListAccountBranch*
folder_list_account_branch_new (GearyAccount* account)
{
#line 35 "../src/client/folder-list/folder-list-account-branch.vala"
	return folder_list_account_branch_construct (FOLDER_LIST_TYPE_ACCOUNT_BRANCH, account);
#line 459 "folder-list-account-branch.c"
}

static void
folder_list_account_branch_on_information_changed (FolderListAccountBranch* self)
{
	const gchar* _tmp0_;
	GearyAccount* _tmp1_;
	GearyAccountInformation* _tmp2_;
	GearyAccountInformation* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
#line 73 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_if_fail (FOLDER_LIST_IS_ACCOUNT_BRANCH (self));
#line 74 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp0_ = self->priv->display_name;
#line 74 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp1_ = self->priv->_account;
#line 74 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp2_ = geary_account_get_information (_tmp1_);
#line 74 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp3_ = _tmp2_;
#line 74 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp4_ = geary_account_information_get_display_name (_tmp3_);
#line 74 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp5_ = _tmp4_;
#line 74 "../src/client/folder-list/folder-list-account-branch.vala"
	if (g_strcmp0 (_tmp0_, _tmp5_) != 0) {
#line 487 "folder-list-account-branch.c"
		GearyAccount* _tmp6_;
		GearyAccountInformation* _tmp7_;
		GearyAccountInformation* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		SidebarEntry* _tmp12_;
		SidebarGrouping* _tmp13_;
		const gchar* _tmp14_;
#line 75 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp6_ = self->priv->_account;
#line 75 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp7_ = geary_account_get_information (_tmp6_);
#line 75 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp8_ = _tmp7_;
#line 75 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp9_ = geary_account_information_get_display_name (_tmp8_);
#line 75 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp10_ = _tmp9_;
#line 75 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 75 "../src/client/folder-list/folder-list-account-branch.vala"
		_g_free0 (self->priv->display_name);
#line 75 "../src/client/folder-list/folder-list-account-branch.vala"
		self->priv->display_name = _tmp11_;
#line 76 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp12_ = sidebar_branch_get_root (G_TYPE_CHECK_INSTANCE_CAST (self, SIDEBAR_TYPE_BRANCH, SidebarBranch));
#line 76 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp13_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, SIDEBAR_TYPE_GROUPING, SidebarGrouping);
#line 76 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp14_ = self->priv->display_name;
#line 76 "../src/client/folder-list/folder-list-account-branch.vala"
		sidebar_renameable_entry_rename (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, SIDEBAR_TYPE_RENAMEABLE_ENTRY, SidebarRenameableEntry), _tmp14_);
#line 76 "../src/client/folder-list/folder-list-account-branch.vala"
		_g_object_unref0 (_tmp13_);
#line 523 "folder-list-account-branch.c"
	}
}

static gint
folder_list_account_branch_special_grouping_comparator (SidebarEntry* a,
                                                        SidebarEntry* b)
{
	FolderListSpecialGrouping* grouping_a = NULL;
	FolderListSpecialGrouping* _tmp0_;
	FolderListSpecialGrouping* grouping_b = NULL;
	FolderListSpecialGrouping* _tmp1_;
	gboolean _tmp2_ = FALSE;
	FolderListSpecialGrouping* _tmp3_;
	gint _tmp5_ = 0;
	FolderListSpecialGrouping* _tmp6_;
	gint position_a = 0;
	gint _tmp10_ = 0;
	FolderListSpecialGrouping* _tmp11_;
	gint position_b = 0;
	gint result;
#line 80 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_val_if_fail (SIDEBAR_IS_ENTRY (a), 0);
#line 80 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_val_if_fail (SIDEBAR_IS_ENTRY (b), 0);
#line 81 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp0_ = _g_object_ref0 (FOLDER_LIST_IS_SPECIAL_GROUPING (a) ? ((FolderListSpecialGrouping*) a) : NULL);
#line 81 "../src/client/folder-list/folder-list-account-branch.vala"
	grouping_a = _tmp0_;
#line 82 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp1_ = _g_object_ref0 (FOLDER_LIST_IS_SPECIAL_GROUPING (b) ? ((FolderListSpecialGrouping*) b) : NULL);
#line 82 "../src/client/folder-list/folder-list-account-branch.vala"
	grouping_b = _tmp1_;
#line 84 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp3_ = grouping_a;
#line 84 "../src/client/folder-list/folder-list-account-branch.vala"
	if (_tmp3_ != NULL) {
#line 84 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp2_ = TRUE;
#line 562 "folder-list-account-branch.c"
	} else {
		FolderListSpecialGrouping* _tmp4_;
#line 84 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp4_ = grouping_b;
#line 84 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp2_ = _tmp4_ != NULL;
#line 569 "folder-list-account-branch.c"
	}
#line 84 "../src/client/folder-list/folder-list-account-branch.vala"
	_vala_assert (_tmp2_, "grouping_a != null || grouping_b != null");
#line 86 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp6_ = grouping_a;
#line 86 "../src/client/folder-list/folder-list-account-branch.vala"
	if (_tmp6_ != NULL) {
#line 577 "folder-list-account-branch.c"
		FolderListSpecialGrouping* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
#line 86 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp7_ = grouping_a;
#line 86 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp8_ = folder_list_special_grouping_get_position (_tmp7_);
#line 86 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp9_ = _tmp8_;
#line 86 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp5_ = _tmp9_;
#line 589 "folder-list-account-branch.c"
	} else {
#line 86 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp5_ = 0;
#line 593 "folder-list-account-branch.c"
	}
#line 86 "../src/client/folder-list/folder-list-account-branch.vala"
	position_a = _tmp5_;
#line 87 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp11_ = grouping_b;
#line 87 "../src/client/folder-list/folder-list-account-branch.vala"
	if (_tmp11_ != NULL) {
#line 601 "folder-list-account-branch.c"
		FolderListSpecialGrouping* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
#line 87 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp12_ = grouping_b;
#line 87 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp13_ = folder_list_special_grouping_get_position (_tmp12_);
#line 87 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp14_ = _tmp13_;
#line 87 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp10_ = _tmp14_;
#line 613 "folder-list-account-branch.c"
	} else {
#line 87 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp10_ = 0;
#line 617 "folder-list-account-branch.c"
	}
#line 87 "../src/client/folder-list/folder-list-account-branch.vala"
	position_b = _tmp10_;
#line 89 "../src/client/folder-list/folder-list-account-branch.vala"
	result = position_a - position_b;
#line 89 "../src/client/folder-list/folder-list-account-branch.vala"
	_g_object_unref0 (grouping_b);
#line 89 "../src/client/folder-list/folder-list-account-branch.vala"
	_g_object_unref0 (grouping_a);
#line 89 "../src/client/folder-list/folder-list-account-branch.vala"
	return result;
#line 629 "folder-list-account-branch.c"
}

static gint
folder_list_account_branch_special_folder_comparator (SidebarEntry* a,
                                                      SidebarEntry* b)
{
	gboolean _tmp0_ = FALSE;
	FolderListFolderEntry* entry_a = NULL;
	FolderListFolderEntry* _tmp1_;
	FolderListFolderEntry* entry_b = NULL;
	FolderListFolderEntry* _tmp2_;
	GearyFolderSpecialUse type_a = 0;
	FolderListFolderEntry* _tmp3_;
	GearyFolder* _tmp4_;
	GearyFolder* _tmp5_;
	GearyFolderSpecialUse _tmp6_;
	GearyFolderSpecialUse _tmp7_;
	GearyFolderSpecialUse type_b = 0;
	FolderListFolderEntry* _tmp8_;
	GearyFolder* _tmp9_;
	GearyFolder* _tmp10_;
	GearyFolderSpecialUse _tmp11_;
	GearyFolderSpecialUse _tmp12_;
	gint ordering_a = 0;
	gint ordering_b = 0;
	gint result;
#line 92 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_val_if_fail (SIDEBAR_IS_ENTRY (a), 0);
#line 92 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_val_if_fail (SIDEBAR_IS_ENTRY (b), 0);
#line 93 "../src/client/folder-list/folder-list-account-branch.vala"
	if (SIDEBAR_IS_GROUPING (a)) {
#line 93 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp0_ = TRUE;
#line 664 "folder-list-account-branch.c"
	} else {
#line 93 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp0_ = SIDEBAR_IS_GROUPING (b);
#line 668 "folder-list-account-branch.c"
	}
#line 93 "../src/client/folder-list/folder-list-account-branch.vala"
	if (_tmp0_) {
#line 94 "../src/client/folder-list/folder-list-account-branch.vala"
		result = folder_list_account_branch_special_grouping_comparator (a, b);
#line 94 "../src/client/folder-list/folder-list-account-branch.vala"
		return result;
#line 676 "folder-list-account-branch.c"
	}
#line 96 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (a, FOLDER_LIST_TYPE_FOLDER_ENTRY, FolderListFolderEntry));
#line 96 "../src/client/folder-list/folder-list-account-branch.vala"
	entry_a = _tmp1_;
#line 97 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (b, FOLDER_LIST_TYPE_FOLDER_ENTRY, FolderListFolderEntry));
#line 97 "../src/client/folder-list/folder-list-account-branch.vala"
	entry_b = _tmp2_;
#line 98 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp3_ = entry_a;
#line 98 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp4_ = folder_list_abstract_folder_entry_get_folder (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, FOLDER_LIST_TYPE_ABSTRACT_FOLDER_ENTRY, FolderListAbstractFolderEntry));
#line 98 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp5_ = _tmp4_;
#line 98 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp6_ = geary_folder_get_used_as (_tmp5_);
#line 98 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp7_ = _tmp6_;
#line 98 "../src/client/folder-list/folder-list-account-branch.vala"
	type_a = _tmp7_;
#line 99 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp8_ = entry_b;
#line 99 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp9_ = folder_list_abstract_folder_entry_get_folder (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, FOLDER_LIST_TYPE_ABSTRACT_FOLDER_ENTRY, FolderListAbstractFolderEntry));
#line 99 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp10_ = _tmp9_;
#line 99 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp11_ = geary_folder_get_used_as (_tmp10_);
#line 99 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp12_ = _tmp11_;
#line 99 "../src/client/folder-list/folder-list-account-branch.vala"
	type_b = _tmp12_;
#line 101 "../src/client/folder-list/folder-list-account-branch.vala"
	if (type_a == type_b) {
#line 101 "../src/client/folder-list/folder-list-account-branch.vala"
		result = 0;
#line 101 "../src/client/folder-list/folder-list-account-branch.vala"
		_g_object_unref0 (entry_b);
#line 101 "../src/client/folder-list/folder-list-account-branch.vala"
		_g_object_unref0 (entry_a);
#line 101 "../src/client/folder-list/folder-list-account-branch.vala"
		return result;
#line 720 "folder-list-account-branch.c"
	}
#line 102 "../src/client/folder-list/folder-list-account-branch.vala"
	if (type_a == GEARY_FOLDER_SPECIAL_USE_INBOX) {
#line 102 "../src/client/folder-list/folder-list-account-branch.vala"
		result = -1;
#line 102 "../src/client/folder-list/folder-list-account-branch.vala"
		_g_object_unref0 (entry_b);
#line 102 "../src/client/folder-list/folder-list-account-branch.vala"
		_g_object_unref0 (entry_a);
#line 102 "../src/client/folder-list/folder-list-account-branch.vala"
		return result;
#line 732 "folder-list-account-branch.c"
	}
#line 103 "../src/client/folder-list/folder-list-account-branch.vala"
	if (type_b == GEARY_FOLDER_SPECIAL_USE_INBOX) {
#line 103 "../src/client/folder-list/folder-list-account-branch.vala"
		result = 1;
#line 103 "../src/client/folder-list/folder-list-account-branch.vala"
		_g_object_unref0 (entry_b);
#line 103 "../src/client/folder-list/folder-list-account-branch.vala"
		_g_object_unref0 (entry_a);
#line 103 "../src/client/folder-list/folder-list-account-branch.vala"
		return result;
#line 744 "folder-list-account-branch.c"
	}
#line 105 "../src/client/folder-list/folder-list-account-branch.vala"
	ordering_a = 0;
#line 748 "folder-list-account-branch.c"
	{
		gboolean _tmp13_ = FALSE;
#line 106 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp13_ = TRUE;
#line 106 "../src/client/folder-list/folder-list-account-branch.vala"
		while (TRUE) {
#line 755 "folder-list-account-branch.c"
			GearyFolderSpecialUse _tmp15_;
#line 106 "../src/client/folder-list/folder-list-account-branch.vala"
			if (!_tmp13_) {
#line 759 "folder-list-account-branch.c"
				gint _tmp14_;
#line 106 "../src/client/folder-list/folder-list-account-branch.vala"
				_tmp14_ = ordering_a;
#line 106 "../src/client/folder-list/folder-list-account-branch.vala"
				ordering_a = _tmp14_ + 1;
#line 765 "folder-list-account-branch.c"
			}
#line 106 "../src/client/folder-list/folder-list-account-branch.vala"
			_tmp13_ = FALSE;
#line 106 "../src/client/folder-list/folder-list-account-branch.vala"
			if (!(ordering_a < G_N_ELEMENTS (FOLDER_LIST_ACCOUNT_BRANCH_SPECIAL_USE_ORDERING))) {
#line 106 "../src/client/folder-list/folder-list-account-branch.vala"
				break;
#line 773 "folder-list-account-branch.c"
			}
#line 107 "../src/client/folder-list/folder-list-account-branch.vala"
			_tmp15_ = FOLDER_LIST_ACCOUNT_BRANCH_SPECIAL_USE_ORDERING[ordering_a];
#line 107 "../src/client/folder-list/folder-list-account-branch.vala"
			if (type_a == _tmp15_) {
#line 108 "../src/client/folder-list/folder-list-account-branch.vala"
				break;
#line 781 "folder-list-account-branch.c"
			}
		}
	}
#line 111 "../src/client/folder-list/folder-list-account-branch.vala"
	ordering_b = 0;
#line 787 "folder-list-account-branch.c"
	{
		gboolean _tmp16_ = FALSE;
#line 112 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp16_ = TRUE;
#line 112 "../src/client/folder-list/folder-list-account-branch.vala"
		while (TRUE) {
#line 794 "folder-list-account-branch.c"
			GearyFolderSpecialUse _tmp18_;
#line 112 "../src/client/folder-list/folder-list-account-branch.vala"
			if (!_tmp16_) {
#line 798 "folder-list-account-branch.c"
				gint _tmp17_;
#line 112 "../src/client/folder-list/folder-list-account-branch.vala"
				_tmp17_ = ordering_b;
#line 112 "../src/client/folder-list/folder-list-account-branch.vala"
				ordering_b = _tmp17_ + 1;
#line 804 "folder-list-account-branch.c"
			}
#line 112 "../src/client/folder-list/folder-list-account-branch.vala"
			_tmp16_ = FALSE;
#line 112 "../src/client/folder-list/folder-list-account-branch.vala"
			if (!(ordering_b < G_N_ELEMENTS (FOLDER_LIST_ACCOUNT_BRANCH_SPECIAL_USE_ORDERING))) {
#line 112 "../src/client/folder-list/folder-list-account-branch.vala"
				break;
#line 812 "folder-list-account-branch.c"
			}
#line 113 "../src/client/folder-list/folder-list-account-branch.vala"
			_tmp18_ = FOLDER_LIST_ACCOUNT_BRANCH_SPECIAL_USE_ORDERING[ordering_b];
#line 113 "../src/client/folder-list/folder-list-account-branch.vala"
			if (type_b == _tmp18_) {
#line 114 "../src/client/folder-list/folder-list-account-branch.vala"
				break;
#line 820 "folder-list-account-branch.c"
			}
		}
	}
#line 118 "../src/client/folder-list/folder-list-account-branch.vala"
	if (ordering_a == ordering_b) {
#line 118 "../src/client/folder-list/folder-list-account-branch.vala"
		result = folder_list_account_branch_normal_folder_comparator (a, b);
#line 118 "../src/client/folder-list/folder-list-account-branch.vala"
		_g_object_unref0 (entry_b);
#line 118 "../src/client/folder-list/folder-list-account-branch.vala"
		_g_object_unref0 (entry_a);
#line 118 "../src/client/folder-list/folder-list-account-branch.vala"
		return result;
#line 834 "folder-list-account-branch.c"
	}
#line 119 "../src/client/folder-list/folder-list-account-branch.vala"
	result = ordering_a - ordering_b;
#line 119 "../src/client/folder-list/folder-list-account-branch.vala"
	_g_object_unref0 (entry_b);
#line 119 "../src/client/folder-list/folder-list-account-branch.vala"
	_g_object_unref0 (entry_a);
#line 119 "../src/client/folder-list/folder-list-account-branch.vala"
	return result;
#line 844 "folder-list-account-branch.c"
}

static gint
folder_list_account_branch_normal_folder_comparator (SidebarEntry* a,
                                                     SidebarEntry* b)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gint result;
#line 122 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_val_if_fail (SIDEBAR_IS_ENTRY (a), 0);
#line 122 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_val_if_fail (SIDEBAR_IS_ENTRY (b), 0);
#line 124 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp0_ = sidebar_entry_get_sidebar_name (a);
#line 124 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp1_ = _tmp0_;
#line 124 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp2_ = sidebar_entry_get_sidebar_name (b);
#line 124 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp3_ = _tmp2_;
#line 124 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp4_ = g_utf8_collate (_tmp1_, _tmp3_);
#line 124 "../src/client/folder-list/folder-list-account-branch.vala"
	_g_free0 (_tmp3_);
#line 124 "../src/client/folder-list/folder-list-account-branch.vala"
	_g_free0 (_tmp1_);
#line 124 "../src/client/folder-list/folder-list-account-branch.vala"
	result = _tmp4_;
#line 124 "../src/client/folder-list/folder-list-account-branch.vala"
	return result;
#line 879 "folder-list-account-branch.c"
}

FolderListFolderEntry*
folder_list_account_branch_get_entry_for_path (FolderListAccountBranch* self,
                                               GearyFolderPath* folder_path)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	FolderListFolderEntry* result;
#line 127 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_val_if_fail (FOLDER_LIST_IS_ACCOUNT_BRANCH (self), NULL);
#line 127 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (folder_path, GEARY_TYPE_FOLDER_PATH), NULL);
#line 128 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp0_ = self->priv->_folder_entries;
#line 128 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp1_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), folder_path);
#line 128 "../src/client/folder-list/folder-list-account-branch.vala"
	result = (FolderListFolderEntry*) _tmp1_;
#line 128 "../src/client/folder-list/folder-list-account-branch.vala"
	return result;
#line 901 "folder-list-account-branch.c"
}

static Block105Data*
block105_data_ref (Block105Data* _data105_)
{
#line 131 "../src/client/folder-list/folder-list-account-branch.vala"
	g_atomic_int_inc (&_data105_->_ref_count_);
#line 131 "../src/client/folder-list/folder-list-account-branch.vala"
	return _data105_;
#line 911 "folder-list-account-branch.c"
}

static void
block105_data_unref (void * _userdata_)
{
	Block105Data* _data105_;
	_data105_ = (Block105Data*) _userdata_;
#line 131 "../src/client/folder-list/folder-list-account-branch.vala"
	if (g_atomic_int_dec_and_test (&_data105_->_ref_count_)) {
#line 921 "folder-list-account-branch.c"
		FolderListAccountBranch* self;
#line 131 "../src/client/folder-list/folder-list-account-branch.vala"
		self = _data105_->self;
#line 131 "../src/client/folder-list/folder-list-account-branch.vala"
		_g_object_unref0 (_data105_->folder_entry);
#line 131 "../src/client/folder-list/folder-list-account-branch.vala"
		_g_object_unref0 (self);
#line 131 "../src/client/folder-list/folder-list-account-branch.vala"
		g_slice_free (Block105Data, _data105_);
#line 931 "folder-list-account-branch.c"
	}
}

static gboolean
___lambda6_ (Block105Data* _data105_,
             SidebarEntry* e)
{
	FolderListAccountBranch* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	FolderListFolderEntry* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
	gboolean result;
#line 159 "../src/client/folder-list/folder-list-account-branch.vala"
	self = _data105_->self;
#line 159 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_val_if_fail (SIDEBAR_IS_ENTRY (e), FALSE);
#line 160 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp0_ = sidebar_entry_get_sidebar_name (e);
#line 160 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp1_ = _tmp0_;
#line 160 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp2_ = _data105_->folder_entry;
#line 160 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp3_ = folder_list_abstract_folder_entry_get_sidebar_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, FOLDER_LIST_TYPE_ABSTRACT_FOLDER_ENTRY, FolderListAbstractFolderEntry));
#line 160 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp4_ = _tmp3_;
#line 160 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp5_ = g_strcmp0 (_tmp1_, _tmp4_) == 0;
#line 160 "../src/client/folder-list/folder-list-account-branch.vala"
	_g_free0 (_tmp4_);
#line 160 "../src/client/folder-list/folder-list-account-branch.vala"
	_g_free0 (_tmp1_);
#line 160 "../src/client/folder-list/folder-list-account-branch.vala"
	result = _tmp5_;
#line 160 "../src/client/folder-list/folder-list-account-branch.vala"
	return result;
#line 971 "folder-list-account-branch.c"
}

static gboolean
____lambda6__locator (gconstpointer item,
                      gpointer self)
{
	gboolean result;
	result = ___lambda6_ (self, (SidebarEntry*) item);
#line 159 "../src/client/folder-list/folder-list-account-branch.vala"
	return result;
#line 982 "folder-list-account-branch.c"
}

void
folder_list_account_branch_add_folder (FolderListAccountBranch* self,
                                       ApplicationFolderContext* context)
{
	Block105Data* _data105_;
	SidebarEntry* graft_point = NULL;
	FolderListFolderEntry* _tmp0_;
	GearyFolderSpecialUse used_as = 0;
	GearyFolder* _tmp1_;
	GearyFolder* _tmp2_;
	GearyFolderSpecialUse _tmp3_;
	GearyFolderSpecialUse _tmp4_;
	SidebarEntry* _tmp29_;
	SidebarEntry* _tmp33_;
#line 131 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_if_fail (FOLDER_LIST_IS_ACCOUNT_BRANCH (self));
#line 131 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_if_fail (APPLICATION_IS_FOLDER_CONTEXT (context));
#line 131 "../src/client/folder-list/folder-list-account-branch.vala"
	_data105_ = g_slice_new0 (Block105Data);
#line 131 "../src/client/folder-list/folder-list-account-branch.vala"
	_data105_->_ref_count_ = 1;
#line 131 "../src/client/folder-list/folder-list-account-branch.vala"
	_data105_->self = g_object_ref (self);
#line 132 "../src/client/folder-list/folder-list-account-branch.vala"
	graft_point = NULL;
#line 133 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp0_ = folder_list_folder_entry_new (context);
#line 133 "../src/client/folder-list/folder-list-account-branch.vala"
	_data105_->folder_entry = _tmp0_;
#line 134 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp1_ = application_folder_context_get_folder (context);
#line 134 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp2_ = _tmp1_;
#line 134 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp3_ = geary_folder_get_used_as (_tmp2_);
#line 134 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp4_ = _tmp3_;
#line 134 "../src/client/folder-list/folder-list-account-branch.vala"
	used_as = _tmp4_;
#line 135 "../src/client/folder-list/folder-list-account-branch.vala"
	if (used_as != GEARY_FOLDER_SPECIAL_USE_NONE) {
#line 1027 "folder-list-account-branch.c"
		SidebarEntry* _tmp5_;
#line 136 "../src/client/folder-list/folder-list-account-branch.vala"
		if (used_as == GEARY_FOLDER_SPECIAL_USE_SEARCH) {
#line 137 "../src/client/folder-list/folder-list-account-branch.vala"
			_g_object_unref0 (graft_point);
#line 137 "../src/client/folder-list/folder-list-account-branch.vala"
			block105_data_unref (_data105_);
#line 137 "../src/client/folder-list/folder-list-account-branch.vala"
			_data105_ = NULL;
#line 137 "../src/client/folder-list/folder-list-account-branch.vala"
			return;
#line 1039 "folder-list-account-branch.c"
		}
#line 140 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp5_ = sidebar_branch_get_root (G_TYPE_CHECK_INSTANCE_CAST (self, SIDEBAR_TYPE_BRANCH, SidebarBranch));
#line 140 "../src/client/folder-list/folder-list-account-branch.vala"
		_g_object_unref0 (graft_point);
#line 140 "../src/client/folder-list/folder-list-account-branch.vala"
		graft_point = _tmp5_;
#line 1047 "folder-list-account-branch.c"
	} else {
		GearyFolder* _tmp6_;
		GearyFolder* _tmp7_;
		GearyFolderPath* _tmp8_;
		GearyFolderPath* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
#line 141 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp6_ = application_folder_context_get_folder (context);
#line 141 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp7_ = _tmp6_;
#line 141 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp8_ = geary_folder_get_path (_tmp7_);
#line 141 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp9_ = _tmp8_;
#line 141 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp10_ = geary_folder_path_get_is_top_level (_tmp9_);
#line 141 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp11_ = _tmp10_;
#line 141 "../src/client/folder-list/folder-list-account-branch.vala"
		if (_tmp11_) {
#line 1069 "folder-list-account-branch.c"
			FolderListSpecialGrouping* _tmp12_;
			SidebarEntry* _tmp13_;
			FolderListSpecialGrouping* _tmp14_;
#line 143 "../src/client/folder-list/folder-list-account-branch.vala"
			_tmp12_ = self->priv->_user_folder_group;
#line 143 "../src/client/folder-list/folder-list-account-branch.vala"
			_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, SIDEBAR_TYPE_ENTRY, SidebarEntry));
#line 143 "../src/client/folder-list/folder-list-account-branch.vala"
			_g_object_unref0 (graft_point);
#line 143 "../src/client/folder-list/folder-list-account-branch.vala"
			graft_point = _tmp13_;
#line 145 "../src/client/folder-list/folder-list-account-branch.vala"
			_tmp14_ = self->priv->_user_folder_group;
#line 145 "../src/client/folder-list/folder-list-account-branch.vala"
			if (!sidebar_branch_has_entry (G_TYPE_CHECK_INSTANCE_CAST (self, SIDEBAR_TYPE_BRANCH, SidebarBranch), G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, SIDEBAR_TYPE_ENTRY, SidebarEntry))) {
#line 1085 "folder-list-account-branch.c"
				SidebarEntry* _tmp15_;
				SidebarEntry* _tmp16_;
				FolderListSpecialGrouping* _tmp17_;
#line 146 "../src/client/folder-list/folder-list-account-branch.vala"
				_tmp15_ = sidebar_branch_get_root (G_TYPE_CHECK_INSTANCE_CAST (self, SIDEBAR_TYPE_BRANCH, SidebarBranch));
#line 146 "../src/client/folder-list/folder-list-account-branch.vala"
				_tmp16_ = _tmp15_;
#line 146 "../src/client/folder-list/folder-list-account-branch.vala"
				_tmp17_ = self->priv->_user_folder_group;
#line 146 "../src/client/folder-list/folder-list-account-branch.vala"
				sidebar_branch_graft (G_TYPE_CHECK_INSTANCE_CAST (self, SIDEBAR_TYPE_BRANCH, SidebarBranch), _tmp16_, G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, SIDEBAR_TYPE_ENTRY, SidebarEntry), NULL);
#line 146 "../src/client/folder-list/folder-list-account-branch.vala"
				_g_object_unref0 (_tmp16_);
#line 1099 "folder-list-account-branch.c"
			}
		} else {
			FolderListFolderEntry* entry = NULL;
			GeeHashMap* _tmp18_;
			GearyFolder* _tmp19_;
			GearyFolder* _tmp20_;
			GearyFolderPath* _tmp21_;
			GearyFolderPath* _tmp22_;
			GearyFolderPath* _tmp23_;
			GearyFolderPath* _tmp24_;
			gpointer _tmp25_;
			FolderListFolderEntry* _tmp26_;
#line 149 "../src/client/folder-list/folder-list-account-branch.vala"
			_tmp18_ = self->priv->_folder_entries;
#line 149 "../src/client/folder-list/folder-list-account-branch.vala"
			_tmp19_ = application_folder_context_get_folder (context);
#line 149 "../src/client/folder-list/folder-list-account-branch.vala"
			_tmp20_ = _tmp19_;
#line 149 "../src/client/folder-list/folder-list-account-branch.vala"
			_tmp21_ = geary_folder_get_path (_tmp20_);
#line 149 "../src/client/folder-list/folder-list-account-branch.vala"
			_tmp22_ = _tmp21_;
#line 149 "../src/client/folder-list/folder-list-account-branch.vala"
			_tmp23_ = geary_folder_path_get_parent (_tmp22_);
#line 149 "../src/client/folder-list/folder-list-account-branch.vala"
			_tmp24_ = _tmp23_;
#line 149 "../src/client/folder-list/folder-list-account-branch.vala"
			_tmp25_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp24_);
#line 149 "../src/client/folder-list/folder-list-account-branch.vala"
			entry = (FolderListFolderEntry*) _tmp25_;
#line 150 "../src/client/folder-list/folder-list-account-branch.vala"
			_tmp26_ = entry;
#line 150 "../src/client/folder-list/folder-list-account-branch.vala"
			if (_tmp26_ != NULL) {
#line 1134 "folder-list-account-branch.c"
				FolderListFolderEntry* _tmp27_;
				SidebarEntry* _tmp28_;
#line 151 "../src/client/folder-list/folder-list-account-branch.vala"
				_tmp27_ = entry;
#line 151 "../src/client/folder-list/folder-list-account-branch.vala"
				_tmp28_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, SIDEBAR_TYPE_ENTRY, SidebarEntry));
#line 151 "../src/client/folder-list/folder-list-account-branch.vala"
				_g_object_unref0 (graft_point);
#line 151 "../src/client/folder-list/folder-list-account-branch.vala"
				graft_point = _tmp28_;
#line 1145 "folder-list-account-branch.c"
			}
#line 141 "../src/client/folder-list/folder-list-account-branch.vala"
			_g_object_unref0 (entry);
#line 1149 "folder-list-account-branch.c"
		}
	}
#line 158 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp29_ = graft_point;
#line 158 "../src/client/folder-list/folder-list-account-branch.vala"
	if (_tmp29_ != NULL) {
#line 1156 "folder-list-account-branch.c"
		SidebarEntry* twin = NULL;
		SidebarEntry* _tmp30_;
		SidebarEntry* _tmp31_;
		SidebarEntry* _tmp32_;
#line 159 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp30_ = graft_point;
#line 159 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp31_ = sidebar_branch_find_first_child (G_TYPE_CHECK_INSTANCE_CAST (self, SIDEBAR_TYPE_BRANCH, SidebarBranch), _tmp30_, ____lambda6__locator, _data105_);
#line 159 "../src/client/folder-list/folder-list-account-branch.vala"
		twin = _tmp31_;
#line 162 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp32_ = twin;
#line 162 "../src/client/folder-list/folder-list-account-branch.vala"
		if (_tmp32_ != NULL) {
#line 163 "../src/client/folder-list/folder-list-account-branch.vala"
			_g_object_unref0 (graft_point);
#line 163 "../src/client/folder-list/folder-list-account-branch.vala"
			graft_point = NULL;
#line 1175 "folder-list-account-branch.c"
		}
#line 158 "../src/client/folder-list/folder-list-account-branch.vala"
		_g_object_unref0 (twin);
#line 1179 "folder-list-account-branch.c"
	}
#line 166 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp33_ = graft_point;
#line 166 "../src/client/folder-list/folder-list-account-branch.vala"
	if (_tmp33_ != NULL) {
#line 1185 "folder-list-account-branch.c"
		SidebarEntry* _tmp34_;
		FolderListFolderEntry* _tmp35_;
		GeeHashMap* _tmp36_;
		GearyFolder* _tmp37_;
		GearyFolder* _tmp38_;
		GearyFolderPath* _tmp39_;
		GearyFolderPath* _tmp40_;
		FolderListFolderEntry* _tmp41_;
#line 167 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp34_ = graft_point;
#line 167 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp35_ = _data105_->folder_entry;
#line 167 "../src/client/folder-list/folder-list-account-branch.vala"
		sidebar_branch_graft (G_TYPE_CHECK_INSTANCE_CAST (self, SIDEBAR_TYPE_BRANCH, SidebarBranch), _tmp34_, G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, SIDEBAR_TYPE_ENTRY, SidebarEntry), NULL);
#line 168 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp36_ = self->priv->_folder_entries;
#line 168 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp37_ = application_folder_context_get_folder (context);
#line 168 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp38_ = _tmp37_;
#line 168 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp39_ = geary_folder_get_path (_tmp38_);
#line 168 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp40_ = _tmp39_;
#line 168 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp41_ = _data105_->folder_entry;
#line 168 "../src/client/folder-list/folder-list-account-branch.vala"
		gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp40_, _tmp41_);
#line 1214 "folder-list-account-branch.c"
	} else {
		GearyFolder* _tmp42_;
		GearyFolder* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		GEnumValue* _tmp46_;
#line 170 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp42_ = application_folder_context_get_folder (context);
#line 170 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp43_ = _tmp42_;
#line 170 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp44_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 170 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp45_ = _tmp44_;
#line 173 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp46_ = g_enum_get_value (g_type_class_ref (GEARY_FOLDER_TYPE_SPECIAL_USE), used_as);
#line 170 "../src/client/folder-list/folder-list-account-branch.vala"
		g_debug ("folder-list-account-branch.vala:170: Could not add folder %s of type %" \
"s to folder list", _tmp45_, (_tmp46_ != NULL) ? _tmp46_->value_name : NULL);
#line 170 "../src/client/folder-list/folder-list-account-branch.vala"
		_g_free0 (_tmp45_);
#line 1235 "folder-list-account-branch.c"
	}
#line 131 "../src/client/folder-list/folder-list-account-branch.vala"
	_g_object_unref0 (graft_point);
#line 131 "../src/client/folder-list/folder-list-account-branch.vala"
	block105_data_unref (_data105_);
#line 131 "../src/client/folder-list/folder-list-account-branch.vala"
	_data105_ = NULL;
#line 1243 "folder-list-account-branch.c"
}

void
folder_list_account_branch_remove_folder (FolderListAccountBranch* self,
                                          GearyFolderPath* path)
{
	SidebarEntry* entry = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	SidebarEntry* _tmp2_;
	SidebarEntry* _tmp5_;
	GeeHashMap* _tmp6_;
#line 178 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_if_fail (FOLDER_LIST_IS_ACCOUNT_BRANCH (self));
#line 178 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (path, GEARY_TYPE_FOLDER_PATH));
#line 179 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp0_ = self->priv->_folder_entries;
#line 179 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp1_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), path);
#line 179 "../src/client/folder-list/folder-list-account-branch.vala"
	entry = G_TYPE_CHECK_INSTANCE_CAST ((FolderListFolderEntry*) _tmp1_, SIDEBAR_TYPE_ENTRY, SidebarEntry);
#line 180 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp2_ = entry;
#line 180 "../src/client/folder-list/folder-list-account-branch.vala"
	if (_tmp2_ == NULL) {
#line 1270 "folder-list-account-branch.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 181 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp3_ = geary_folder_path_to_string (path);
#line 181 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp4_ = _tmp3_;
#line 181 "../src/client/folder-list/folder-list-account-branch.vala"
		g_debug ("folder-list-account-branch.vala:181: Could not remove folder %s", _tmp4_);
#line 181 "../src/client/folder-list/folder-list-account-branch.vala"
		_g_free0 (_tmp4_);
#line 182 "../src/client/folder-list/folder-list-account-branch.vala"
		_g_object_unref0 (entry);
#line 182 "../src/client/folder-list/folder-list-account-branch.vala"
		return;
#line 1285 "folder-list-account-branch.c"
	}
#line 185 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp5_ = entry;
#line 185 "../src/client/folder-list/folder-list-account-branch.vala"
	sidebar_branch_prune (G_TYPE_CHECK_INSTANCE_CAST (self, SIDEBAR_TYPE_BRANCH, SidebarBranch), _tmp5_);
#line 186 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp6_ = self->priv->_folder_entries;
#line 186 "../src/client/folder-list/folder-list-account-branch.vala"
	gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), path, NULL);
#line 178 "../src/client/folder-list/folder-list-account-branch.vala"
	_g_object_unref0 (entry);
#line 1297 "folder-list-account-branch.c"
}

static void
folder_list_account_branch_on_entry_removed (FolderListAccountBranch* self,
                                             SidebarEntry* entry)
{
	FolderListFolderEntry* folder_entry = NULL;
	FolderListFolderEntry* _tmp0_;
	gboolean _tmp1_ = FALSE;
	FolderListFolderEntry* _tmp2_;
#line 189 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_if_fail (FOLDER_LIST_IS_ACCOUNT_BRANCH (self));
#line 189 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_if_fail (SIDEBAR_IS_ENTRY (entry));
#line 190 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp0_ = _g_object_ref0 (FOLDER_LIST_IS_FOLDER_ENTRY (entry) ? ((FolderListFolderEntry*) entry) : NULL);
#line 190 "../src/client/folder-list/folder-list-account-branch.vala"
	folder_entry = _tmp0_;
#line 191 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp2_ = folder_entry;
#line 191 "../src/client/folder-list/folder-list-account-branch.vala"
	if (_tmp2_ != NULL) {
#line 1320 "folder-list-account-branch.c"
		GeeHashMap* _tmp3_;
		FolderListFolderEntry* _tmp4_;
		GearyFolder* _tmp5_;
		GearyFolder* _tmp6_;
		GearyFolderPath* _tmp7_;
		GearyFolderPath* _tmp8_;
#line 191 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp3_ = self->priv->_folder_entries;
#line 191 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp4_ = folder_entry;
#line 191 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp5_ = folder_list_abstract_folder_entry_get_folder (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, FOLDER_LIST_TYPE_ABSTRACT_FOLDER_ENTRY, FolderListAbstractFolderEntry));
#line 191 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp6_ = _tmp5_;
#line 191 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp7_ = geary_folder_get_path (_tmp6_);
#line 191 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp8_ = _tmp7_;
#line 191 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp1_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp8_);
#line 1341 "folder-list-account-branch.c"
	} else {
#line 191 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp1_ = FALSE;
#line 1345 "folder-list-account-branch.c"
	}
#line 191 "../src/client/folder-list/folder-list-account-branch.vala"
	if (_tmp1_) {
#line 1349 "folder-list-account-branch.c"
		GeeHashMap* _tmp9_;
		FolderListFolderEntry* _tmp10_;
		GearyFolder* _tmp11_;
		GearyFolder* _tmp12_;
		GearyFolderPath* _tmp13_;
		GearyFolderPath* _tmp14_;
#line 192 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp9_ = self->priv->_folder_entries;
#line 192 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp10_ = folder_entry;
#line 192 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp11_ = folder_list_abstract_folder_entry_get_folder (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, FOLDER_LIST_TYPE_ABSTRACT_FOLDER_ENTRY, FolderListAbstractFolderEntry));
#line 192 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp12_ = _tmp11_;
#line 192 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp13_ = geary_folder_get_path (_tmp12_);
#line 192 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp14_ = _tmp13_;
#line 192 "../src/client/folder-list/folder-list-account-branch.vala"
		gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp14_, NULL);
#line 1370 "folder-list-account-branch.c"
	}
#line 194 "../src/client/folder-list/folder-list-account-branch.vala"
	folder_list_account_branch_check_user_folders (self, entry);
#line 189 "../src/client/folder-list/folder-list-account-branch.vala"
	_g_object_unref0 (folder_entry);
#line 1376 "folder-list-account-branch.c"
}

static void
folder_list_account_branch_check_user_folders (FolderListAccountBranch* self,
                                               SidebarEntry* entry)
{
	FolderListSpecialGrouping* _tmp0_;
#line 197 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_if_fail (FOLDER_LIST_IS_ACCOUNT_BRANCH (self));
#line 197 "../src/client/folder-list/folder-list-account-branch.vala"
	g_return_if_fail (SIDEBAR_IS_ENTRY (entry));
#line 198 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp0_ = self->priv->_user_folder_group;
#line 198 "../src/client/folder-list/folder-list-account-branch.vala"
	if (entry != G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, SIDEBAR_TYPE_ENTRY, SidebarEntry)) {
#line 1392 "folder-list-account-branch.c"
		gboolean _tmp1_ = FALSE;
		FolderListSpecialGrouping* _tmp2_;
#line 200 "../src/client/folder-list/folder-list-account-branch.vala"
		_tmp2_ = self->priv->_user_folder_group;
#line 200 "../src/client/folder-list/folder-list-account-branch.vala"
		if (sidebar_branch_has_entry (G_TYPE_CHECK_INSTANCE_CAST (self, SIDEBAR_TYPE_BRANCH, SidebarBranch), G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, SIDEBAR_TYPE_ENTRY, SidebarEntry))) {
#line 1399 "folder-list-account-branch.c"
			FolderListSpecialGrouping* _tmp3_;
#line 200 "../src/client/folder-list/folder-list-account-branch.vala"
			_tmp3_ = self->priv->_user_folder_group;
#line 200 "../src/client/folder-list/folder-list-account-branch.vala"
			_tmp1_ = sidebar_branch_get_child_count (G_TYPE_CHECK_INSTANCE_CAST (self, SIDEBAR_TYPE_BRANCH, SidebarBranch), G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, SIDEBAR_TYPE_ENTRY, SidebarEntry)) == 0;
#line 1405 "folder-list-account-branch.c"
		} else {
#line 200 "../src/client/folder-list/folder-list-account-branch.vala"
			_tmp1_ = FALSE;
#line 1409 "folder-list-account-branch.c"
		}
#line 200 "../src/client/folder-list/folder-list-account-branch.vala"
		if (_tmp1_) {
#line 1413 "folder-list-account-branch.c"
			FolderListSpecialGrouping* _tmp4_;
#line 201 "../src/client/folder-list/folder-list-account-branch.vala"
			_tmp4_ = self->priv->_user_folder_group;
#line 201 "../src/client/folder-list/folder-list-account-branch.vala"
			sidebar_branch_prune (G_TYPE_CHECK_INSTANCE_CAST (self, SIDEBAR_TYPE_BRANCH, SidebarBranch), G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, SIDEBAR_TYPE_ENTRY, SidebarEntry));
#line 1419 "folder-list-account-branch.c"
		}
	}
}

static void
folder_list_account_branch_class_init (FolderListAccountBranchClass * klass,
                                       gpointer klass_data)
{
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
	folder_list_account_branch_parent_class = g_type_class_peek_parent (klass);
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
	g_type_class_adjust_private_offset (klass, &FolderListAccountBranch_private_offset);
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_folder_list_account_branch_get_property;
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_folder_list_account_branch_set_property;
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
	G_OBJECT_CLASS (klass)->finalize = folder_list_account_branch_finalize;
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLDER_LIST_ACCOUNT_BRANCH_ACCOUNT_PROPERTY, folder_list_account_branch_properties[FOLDER_LIST_ACCOUNT_BRANCH_ACCOUNT_PROPERTY] = g_param_spec_object ("account", "account", "account", GEARY_TYPE_ACCOUNT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLDER_LIST_ACCOUNT_BRANCH_USER_FOLDER_GROUP_PROPERTY, folder_list_account_branch_properties[FOLDER_LIST_ACCOUNT_BRANCH_USER_FOLDER_GROUP_PROPERTY] = g_param_spec_object ("user-folder-group", "user-folder-group", "user-folder-group", FOLDER_LIST_TYPE_SPECIAL_GROUPING, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLDER_LIST_ACCOUNT_BRANCH_FOLDER_ENTRIES_PROPERTY, folder_list_account_branch_properties[FOLDER_LIST_ACCOUNT_BRANCH_FOLDER_ENTRIES_PROPERTY] = g_param_spec_object ("folder-entries", "folder-entries", "folder-entries", GEE_TYPE_HASH_MAP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1444 "folder-list-account-branch.c"
}

static void
folder_list_account_branch_instance_init (FolderListAccountBranch * self,
                                          gpointer klass)
{
	gchar* _tmp0_;
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
	self->priv = folder_list_account_branch_get_instance_private (self);
#line 33 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp0_ = g_strdup ("");
#line 33 "../src/client/folder-list/folder-list-account-branch.vala"
	self->priv->display_name = _tmp0_;
#line 1458 "folder-list-account-branch.c"
}

static void
folder_list_account_branch_finalize (GObject * obj)
{
	FolderListAccountBranch * self;
	GearyAccount* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GearyAccountInformation* _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FOLDER_LIST_TYPE_ACCOUNT_BRANCH, FolderListAccountBranch);
#line 68 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp0_ = self->priv->_account;
#line 68 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp1_ = geary_account_get_information (_tmp0_);
#line 68 "../src/client/folder-list/folder-list-account-branch.vala"
	_tmp2_ = _tmp1_;
#line 68 "../src/client/folder-list/folder-list-account-branch.vala"
	g_signal_parse_name ("changed", GEARY_TYPE_ACCOUNT_INFORMATION, &_tmp3_, NULL, FALSE);
#line 68 "../src/client/folder-list/folder-list-account-branch.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _folder_list_account_branch_on_information_changed_geary_account_information_changed, self);
#line 69 "../src/client/folder-list/folder-list-account-branch.vala"
	g_signal_parse_name ("entry-removed", SIDEBAR_TYPE_BRANCH, &_tmp4_, NULL, FALSE);
#line 69 "../src/client/folder-list/folder-list-account-branch.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (self, SIDEBAR_TYPE_BRANCH, SidebarBranch), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _folder_list_account_branch_on_entry_removed_sidebar_branch_entry_removed, self);
#line 70 "../src/client/folder-list/folder-list-account-branch.vala"
	g_signal_parse_name ("entry-moved", SIDEBAR_TYPE_BRANCH, &_tmp5_, NULL, FALSE);
#line 70 "../src/client/folder-list/folder-list-account-branch.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (self, SIDEBAR_TYPE_BRANCH, SidebarBranch), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _folder_list_account_branch_check_user_folders_sidebar_branch_entry_moved, self);
#line 29 "../src/client/folder-list/folder-list-account-branch.vala"
	_g_object_unref0 (self->priv->_account);
#line 30 "../src/client/folder-list/folder-list-account-branch.vala"
	_g_object_unref0 (self->priv->_user_folder_group);
#line 31 "../src/client/folder-list/folder-list-account-branch.vala"
	_g_object_unref0 (self->priv->_folder_entries);
#line 33 "../src/client/folder-list/folder-list-account-branch.vala"
	_g_free0 (self->priv->display_name);
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
	G_OBJECT_CLASS (folder_list_account_branch_parent_class)->finalize (obj);
#line 1501 "folder-list-account-branch.c"
}

static GType
folder_list_account_branch_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FolderListAccountBranchClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) folder_list_account_branch_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FolderListAccountBranch), 0, (GInstanceInitFunc) folder_list_account_branch_instance_init, NULL };
	GType folder_list_account_branch_type_id;
	folder_list_account_branch_type_id = g_type_register_static (SIDEBAR_TYPE_BRANCH, "FolderListAccountBranch", &g_define_type_info, 0);
	FolderListAccountBranch_private_offset = g_type_add_instance_private (folder_list_account_branch_type_id, sizeof (FolderListAccountBranchPrivate));
	return folder_list_account_branch_type_id;
}

GType
folder_list_account_branch_get_type (void)
{
	static volatile gsize folder_list_account_branch_type_id__once = 0;
	if (g_once_init_enter (&folder_list_account_branch_type_id__once)) {
		GType folder_list_account_branch_type_id;
		folder_list_account_branch_type_id = folder_list_account_branch_get_type_once ();
		g_once_init_leave (&folder_list_account_branch_type_id__once, folder_list_account_branch_type_id);
	}
	return folder_list_account_branch_type_id__once;
}

static void
_vala_folder_list_account_branch_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	FolderListAccountBranch * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FOLDER_LIST_TYPE_ACCOUNT_BRANCH, FolderListAccountBranch);
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
	switch (property_id) {
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
		case FOLDER_LIST_ACCOUNT_BRANCH_ACCOUNT_PROPERTY:
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
		g_value_set_object (value, folder_list_account_branch_get_account (self));
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
		break;
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
		case FOLDER_LIST_ACCOUNT_BRANCH_USER_FOLDER_GROUP_PROPERTY:
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
		g_value_set_object (value, folder_list_account_branch_get_user_folder_group (self));
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
		break;
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
		case FOLDER_LIST_ACCOUNT_BRANCH_FOLDER_ENTRIES_PROPERTY:
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
		g_value_set_object (value, folder_list_account_branch_get_folder_entries (self));
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
		break;
#line 1554 "folder-list-account-branch.c"
		default:
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
		break;
#line 1560 "folder-list-account-branch.c"
	}
}

static void
_vala_folder_list_account_branch_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	FolderListAccountBranch * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FOLDER_LIST_TYPE_ACCOUNT_BRANCH, FolderListAccountBranch);
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
	switch (property_id) {
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
		case FOLDER_LIST_ACCOUNT_BRANCH_ACCOUNT_PROPERTY:
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
		folder_list_account_branch_set_account (self, g_value_get_object (value));
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
		break;
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
		case FOLDER_LIST_ACCOUNT_BRANCH_USER_FOLDER_GROUP_PROPERTY:
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
		folder_list_account_branch_set_user_folder_group (self, g_value_get_object (value));
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
		break;
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
		case FOLDER_LIST_ACCOUNT_BRANCH_FOLDER_ENTRIES_PROPERTY:
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
		folder_list_account_branch_set_folder_entries (self, g_value_get_object (value));
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
		break;
#line 1592 "folder-list-account-branch.c"
		default:
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/client/folder-list/folder-list-account-branch.vala"
		break;
#line 1598 "folder-list-account-branch.c"
	}
}

