/* plugin-email.c generated by valac 0.56.17, the Vala compiler
 * generated from plugin-email.vala, do not modify */

/*
 * Copyright © 2020 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-client-46.0.h"
#include <glib.h>
#include "geary-engine.h"
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

static GType plugin_email_get_type_once (void);
static GType plugin_email_identifier_get_type_once (void);

/** Defines the formats that email body text can be loaded as. */
static GType
plugin_email_body_type_get_type_once (void)
{
	static const GEnumValue values[] = {{PLUGIN_EMAIL_BODY_TYPE_PLAIN, "PLUGIN_EMAIL_BODY_TYPE_PLAIN", "plain"}, {PLUGIN_EMAIL_BODY_TYPE_HTML, "PLUGIN_EMAIL_BODY_TYPE_HTML", "html"}, {0, NULL, NULL}};
	GType plugin_email_body_type_type_id;
	plugin_email_body_type_type_id = g_enum_register_static ("PluginEmailBodyType", values);
	return plugin_email_body_type_type_id;
}

GType
plugin_email_body_type_get_type (void)
{
	static volatile gsize plugin_email_body_type_type_id__once = 0;
	if (g_once_init_enter (&plugin_email_body_type_type_id__once)) {
		GType plugin_email_body_type_type_id;
		plugin_email_body_type_type_id = plugin_email_body_type_get_type_once ();
		g_once_init_leave (&plugin_email_body_type_type_id__once, plugin_email_body_type_type_id);
	}
	return plugin_email_body_type_type_id__once;
}

PluginEmailIdentifier*
plugin_email_get_identifier (PluginEmail* self)
{
	PluginEmailIface* _iface_;
#line 28 "../src/client/plugin/plugin-email.vala"
	g_return_val_if_fail (PLUGIN_IS_EMAIL (self), NULL);
#line 28 "../src/client/plugin/plugin-email.vala"
	_iface_ = PLUGIN_EMAIL_GET_INTERFACE (self);
#line 28 "../src/client/plugin/plugin-email.vala"
	if (_iface_->get_identifier) {
#line 28 "../src/client/plugin/plugin-email.vala"
		return _iface_->get_identifier (self);
#line 65 "plugin-email.c"
	}
#line 28 "../src/client/plugin/plugin-email.vala"
	return NULL;
#line 69 "plugin-email.c"
}

GearyEmailFlags*
plugin_email_get_flags (PluginEmail* self)
{
	PluginEmailIface* _iface_;
#line 31 "../src/client/plugin/plugin-email.vala"
	g_return_val_if_fail (PLUGIN_IS_EMAIL (self), NULL);
#line 31 "../src/client/plugin/plugin-email.vala"
	_iface_ = PLUGIN_EMAIL_GET_INTERFACE (self);
#line 31 "../src/client/plugin/plugin-email.vala"
	if (_iface_->get_flags) {
#line 31 "../src/client/plugin/plugin-email.vala"
		return _iface_->get_flags (self);
#line 84 "plugin-email.c"
	}
#line 31 "../src/client/plugin/plugin-email.vala"
	return NULL;
#line 88 "plugin-email.c"
}

/**
     * Returns the email's primary originator.
     *
     * This method returns the mailbox of the best originator of the
     * email, if any.
     *
     * @see Util.Email.get_primary_originator
     */
GearyRFC822MailboxAddress*
plugin_email_get_primary_originator (PluginEmail* self)
{
	PluginEmailIface* _iface_;
#line 41 "../src/client/plugin/plugin-email.vala"
	g_return_val_if_fail (PLUGIN_IS_EMAIL (self), NULL);
#line 41 "../src/client/plugin/plugin-email.vala"
	_iface_ = PLUGIN_EMAIL_GET_INTERFACE (self);
#line 41 "../src/client/plugin/plugin-email.vala"
	if (_iface_->get_primary_originator) {
#line 41 "../src/client/plugin/plugin-email.vala"
		return _iface_->get_primary_originator (self);
#line 111 "plugin-email.c"
	}
#line 41 "../src/client/plugin/plugin-email.vala"
	return NULL;
#line 115 "plugin-email.c"
}

void
plugin_email_load_body_as (PluginEmail* self,
                           PluginEmailBodyType type,
                           gboolean convert,
                           GCancellable* cancellable,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_)
{
	PluginEmailIface* _iface_;
#line 13 "../src/client/plugin/plugin-email.vala"
	_iface_ = PLUGIN_EMAIL_GET_INTERFACE (self);
#line 13 "../src/client/plugin/plugin-email.vala"
	if (_iface_->load_body_as) {
#line 13 "../src/client/plugin/plugin-email.vala"
		_iface_->load_body_as (self, type, convert, cancellable, _callback_, _user_data_);
#line 133 "plugin-email.c"
	}
}

gchar*
plugin_email_load_body_as_finish (PluginEmail* self,
                                  GAsyncResult* _res_,
                                  GError** error)
{
	PluginEmailIface* _iface_;
#line 13 "../src/client/plugin/plugin-email.vala"
	_iface_ = PLUGIN_EMAIL_GET_INTERFACE (self);
#line 13 "../src/client/plugin/plugin-email.vala"
	if (_iface_->load_body_as_finish) {
#line 13 "../src/client/plugin/plugin-email.vala"
		return _iface_->load_body_as_finish (self, _res_, error);
#line 149 "plugin-email.c"
	}
#line 13 "../src/client/plugin/plugin-email.vala"
	return NULL;
#line 153 "plugin-email.c"
}

static void
plugin_email_default_init (PluginEmailIface * iface,
                           gpointer iface_data)
{
	/** Returns a unique identifier for this email. */
#line 13 "../src/client/plugin/plugin-email.vala"
	g_object_interface_install_property (iface, g_param_spec_object ("identifier", "identifier", "identifier", PLUGIN_TYPE_EMAIL_IDENTIFIER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 163 "plugin-email.c"
	/** Returns the set of mutable flags for the email. */
#line 13 "../src/client/plugin/plugin-email.vala"
	g_object_interface_install_property (iface, g_param_spec_object ("flags", "flags", "flags", GEARY_TYPE_EMAIL_FLAGS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 167 "plugin-email.c"
}

/**
 * An object representing an email for use by plugins.
 *
 * Instances of these may be obtained from {@link EmailStore}.
 */
static GType
plugin_email_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PluginEmailIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plugin_email_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType plugin_email_type_id;
	plugin_email_type_id = g_type_register_static (G_TYPE_INTERFACE, "PluginEmail", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (plugin_email_type_id, GEARY_TYPE_BASE_OBJECT);
	g_type_interface_add_prerequisite (plugin_email_type_id, GEARY_TYPE_EMAIL_HEADER_SET);
	return plugin_email_type_id;
}

GType
plugin_email_get_type (void)
{
	static volatile gsize plugin_email_type_id__once = 0;
	if (g_once_init_enter (&plugin_email_type_id__once)) {
		GType plugin_email_type_id;
		plugin_email_type_id = plugin_email_get_type_once ();
		g_once_init_leave (&plugin_email_type_id__once, plugin_email_type_id);
	}
	return plugin_email_type_id__once;
}

PluginAccount*
plugin_email_identifier_get_account (PluginEmailIdentifier* self)
{
	PluginEmailIdentifierIface* _iface_;
#line 84 "../src/client/plugin/plugin-email.vala"
	g_return_val_if_fail (PLUGIN_IS_EMAIL_IDENTIFIER (self), NULL);
#line 84 "../src/client/plugin/plugin-email.vala"
	_iface_ = PLUGIN_EMAIL_IDENTIFIER_GET_INTERFACE (self);
#line 84 "../src/client/plugin/plugin-email.vala"
	if (_iface_->get_account) {
#line 84 "../src/client/plugin/plugin-email.vala"
		return _iface_->get_account (self);
#line 210 "plugin-email.c"
	}
#line 84 "../src/client/plugin/plugin-email.vala"
	return NULL;
#line 214 "plugin-email.c"
}

/**
     * Returns a variant version of this identifier.
     *
     * This value is suitable to be used as the `show-email`
     * application action parameter.
     *
     * @see EmailStore.get_email_identifier_for_variant
     * @see EmailStore.email_identifier_variant_type
     */
GVariant*
plugin_email_identifier_to_variant (PluginEmailIdentifier* self)
{
	PluginEmailIdentifierIface* _iface_;
#line 96 "../src/client/plugin/plugin-email.vala"
	g_return_val_if_fail (PLUGIN_IS_EMAIL_IDENTIFIER (self), NULL);
#line 96 "../src/client/plugin/plugin-email.vala"
	_iface_ = PLUGIN_EMAIL_IDENTIFIER_GET_INTERFACE (self);
#line 96 "../src/client/plugin/plugin-email.vala"
	if (_iface_->to_variant) {
#line 96 "../src/client/plugin/plugin-email.vala"
		return _iface_->to_variant (self);
#line 238 "plugin-email.c"
	}
#line 96 "../src/client/plugin/plugin-email.vala"
	return NULL;
#line 242 "plugin-email.c"
}

static void
plugin_email_identifier_default_init (PluginEmailIdentifierIface * iface,
                                      gpointer iface_data)
{
	/** Returns the account that the email belongs to. */
#line 79 "../src/client/plugin/plugin-email.vala"
	g_object_interface_install_property (iface, g_param_spec_object ("account", "account", "account", PLUGIN_TYPE_ACCOUNT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 252 "plugin-email.c"
}

/**
 * An object representing an email's identifier.
 */
static GType
plugin_email_identifier_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PluginEmailIdentifierIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plugin_email_identifier_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType plugin_email_identifier_type_id;
	plugin_email_identifier_type_id = g_type_register_static (G_TYPE_INTERFACE, "PluginEmailIdentifier", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (plugin_email_identifier_type_id, GEARY_TYPE_BASE_OBJECT);
	g_type_interface_add_prerequisite (plugin_email_identifier_type_id, GEE_TYPE_HASHABLE);
	return plugin_email_identifier_type_id;
}

GType
plugin_email_identifier_get_type (void)
{
	static volatile gsize plugin_email_identifier_type_id__once = 0;
	if (g_once_init_enter (&plugin_email_identifier_type_id__once)) {
		GType plugin_email_identifier_type_id;
		plugin_email_identifier_type_id = plugin_email_identifier_get_type_once ();
		g_once_init_leave (&plugin_email_identifier_type_id__once, plugin_email_identifier_type_id);
	}
	return plugin_email_identifier_type_id__once;
}

