/* util-contact.c generated by valac 0.56.17, the Vala compiler
 * generated from util-contact.vala, do not modify */

/*
 * Copyright 2022 Cédric Bellegarde <cedric.bellegarde@adishatz.org>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-client-46.0.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include "geary-engine.h"
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

/**
     * Returns true if loading images for contact is allowed
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 14 "../src/client/util/util-contact.vala"
	return self ? g_object_ref (self) : NULL;
#line 49 "util-contact.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 27 "../src/client/util/util-contact.vala"
	for (i = 0; i < stack_length; i++) {
#line 27 "../src/client/util/util-contact.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 27 "../src/client/util/util-contact.vala"
			return TRUE;
#line 64 "util-contact.c"
		}
	}
#line 27 "../src/client/util/util-contact.vala"
	return FALSE;
#line 69 "util-contact.c"
}

gboolean
util_contact_should_load_images (ApplicationContact* contact,
                                 ApplicationConfiguration* config)
{
	GeeCollection* email_addresses = NULL;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	gchar** domains = NULL;
	gint _tmp3_ = 0;
	gchar** _tmp4_;
	gint domains_length1;
	gint _domains_size_;
	gboolean result;
#line 13 "../src/client/util/util-contact.vala"
	g_return_val_if_fail (APPLICATION_IS_CONTACT (contact), FALSE);
#line 13 "../src/client/util/util-contact.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (config), FALSE);
#line 14 "../src/client/util/util-contact.vala"
	_tmp0_ = application_contact_get_email_addresses (contact);
#line 14 "../src/client/util/util-contact.vala"
	_tmp1_ = _tmp0_;
#line 14 "../src/client/util/util-contact.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 14 "../src/client/util/util-contact.vala"
	email_addresses = _tmp2_;
#line 15 "../src/client/util/util-contact.vala"
	_tmp4_ = application_configuration_get_images_trusted_domains (config, &_tmp3_);
#line 15 "../src/client/util/util-contact.vala"
	domains = _tmp4_;
#line 15 "../src/client/util/util-contact.vala"
	domains_length1 = _tmp3_;
#line 15 "../src/client/util/util-contact.vala"
	_domains_size_ = domains_length1;
#line 16 "../src/client/util/util-contact.vala"
	if (contact == NULL) {
#line 17 "../src/client/util/util-contact.vala"
		result = FALSE;
#line 17 "../src/client/util/util-contact.vala"
		domains = (_vala_array_free (domains, domains_length1, (GDestroyNotify) g_free), NULL);
#line 17 "../src/client/util/util-contact.vala"
		_g_object_unref0 (email_addresses);
#line 17 "../src/client/util/util-contact.vala"
		return result;
#line 116 "util-contact.c"
	} else {
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 19 "../src/client/util/util-contact.vala"
		_tmp5_ = application_contact_get_load_remote_resources (contact);
#line 19 "../src/client/util/util-contact.vala"
		_tmp6_ = _tmp5_;
#line 19 "../src/client/util/util-contact.vala"
		if (_tmp6_) {
#line 20 "../src/client/util/util-contact.vala"
			result = TRUE;
#line 20 "../src/client/util/util-contact.vala"
			domains = (_vala_array_free (domains, domains_length1, (GDestroyNotify) g_free), NULL);
#line 20 "../src/client/util/util-contact.vala"
			_g_object_unref0 (email_addresses);
#line 20 "../src/client/util/util-contact.vala"
			return result;
#line 134 "util-contact.c"
		} else {
			gboolean _tmp7_ = FALSE;
			gchar** _tmp8_;
			gint _tmp8__length1;
#line 22 "../src/client/util/util-contact.vala"
			_tmp8_ = domains;
#line 22 "../src/client/util/util-contact.vala"
			_tmp8__length1 = domains_length1;
#line 22 "../src/client/util/util-contact.vala"
			if (_tmp8__length1 > 0) {
#line 145 "util-contact.c"
				gchar** _tmp9_;
				gint _tmp9__length1;
				const gchar* _tmp10_;
#line 22 "../src/client/util/util-contact.vala"
				_tmp9_ = domains;
#line 22 "../src/client/util/util-contact.vala"
				_tmp9__length1 = domains_length1;
#line 22 "../src/client/util/util-contact.vala"
				_tmp10_ = _tmp9_[0];
#line 22 "../src/client/util/util-contact.vala"
				_tmp7_ = g_strcmp0 (_tmp10_, "*") == 0;
#line 157 "util-contact.c"
			} else {
#line 22 "../src/client/util/util-contact.vala"
				_tmp7_ = FALSE;
#line 161 "util-contact.c"
			}
#line 22 "../src/client/util/util-contact.vala"
			if (_tmp7_) {
#line 23 "../src/client/util/util-contact.vala"
				result = TRUE;
#line 23 "../src/client/util/util-contact.vala"
				domains = (_vala_array_free (domains, domains_length1, (GDestroyNotify) g_free), NULL);
#line 23 "../src/client/util/util-contact.vala"
				_g_object_unref0 (email_addresses);
#line 23 "../src/client/util/util-contact.vala"
				return result;
#line 173 "util-contact.c"
			} else {
				{
					GeeIterator* _email_it = NULL;
					GeeCollection* _tmp11_;
					GeeIterator* _tmp12_;
#line 26 "../src/client/util/util-contact.vala"
					_tmp11_ = email_addresses;
#line 26 "../src/client/util/util-contact.vala"
					_tmp12_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ITERABLE, GeeIterable));
#line 26 "../src/client/util/util-contact.vala"
					_email_it = _tmp12_;
#line 26 "../src/client/util/util-contact.vala"
					while (TRUE) {
#line 187 "util-contact.c"
						GeeIterator* _tmp13_;
						GearyRFC822MailboxAddress* email = NULL;
						GeeIterator* _tmp14_;
						gpointer _tmp15_;
						GearyRFC822MailboxAddress* _tmp16_;
						const gchar* _tmp17_;
						const gchar* _tmp18_;
						gchar** _tmp19_;
						gint _tmp19__length1;
#line 26 "../src/client/util/util-contact.vala"
						_tmp13_ = _email_it;
#line 26 "../src/client/util/util-contact.vala"
						if (!gee_iterator_next (_tmp13_)) {
#line 26 "../src/client/util/util-contact.vala"
							break;
#line 203 "util-contact.c"
						}
#line 26 "../src/client/util/util-contact.vala"
						_tmp14_ = _email_it;
#line 26 "../src/client/util/util-contact.vala"
						_tmp15_ = gee_iterator_get (_tmp14_);
#line 26 "../src/client/util/util-contact.vala"
						email = (GearyRFC822MailboxAddress*) _tmp15_;
#line 27 "../src/client/util/util-contact.vala"
						_tmp16_ = email;
#line 27 "../src/client/util/util-contact.vala"
						_tmp17_ = geary_rf_c822_mailbox_address_get_domain (_tmp16_);
#line 27 "../src/client/util/util-contact.vala"
						_tmp18_ = _tmp17_;
#line 27 "../src/client/util/util-contact.vala"
						_tmp19_ = domains;
#line 27 "../src/client/util/util-contact.vala"
						_tmp19__length1 = domains_length1;
#line 27 "../src/client/util/util-contact.vala"
						if (_vala_string_array_contains (_tmp19_, _tmp19__length1, _tmp18_)) {
#line 28 "../src/client/util/util-contact.vala"
							result = TRUE;
#line 28 "../src/client/util/util-contact.vala"
							_g_object_unref0 (email);
#line 28 "../src/client/util/util-contact.vala"
							_g_object_unref0 (_email_it);
#line 28 "../src/client/util/util-contact.vala"
							domains = (_vala_array_free (domains, domains_length1, (GDestroyNotify) g_free), NULL);
#line 28 "../src/client/util/util-contact.vala"
							_g_object_unref0 (email_addresses);
#line 28 "../src/client/util/util-contact.vala"
							return result;
#line 235 "util-contact.c"
						}
#line 26 "../src/client/util/util-contact.vala"
						_g_object_unref0 (email);
#line 239 "util-contact.c"
					}
#line 26 "../src/client/util/util-contact.vala"
					_g_object_unref0 (_email_it);
#line 243 "util-contact.c"
				}
			}
		}
	}
#line 32 "../src/client/util/util-contact.vala"
	result = FALSE;
#line 32 "../src/client/util/util-contact.vala"
	domains = (_vala_array_free (domains, domains_length1, (GDestroyNotify) g_free), NULL);
#line 32 "../src/client/util/util-contact.vala"
	_g_object_unref0 (email_addresses);
#line 32 "../src/client/util/util-contact.vala"
	return result;
#line 256 "util-contact.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

