/* util-gio.c generated by valac 0.56.17, the Vala compiler
 * generated from util-gio.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-client-46.0.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

/**
     * Creates a GTK builder given the name of a GResource.
     *
     * The given `name` will automatically have
     * `GEARY_RESOURCE_PREFIX` pre-pended to it.
     */
GtkBuilder*
gio_util_create_builder (const gchar* name)
{
	GtkBuilder* builder = NULL;
	GtkBuilder* _tmp0_;
	GError* _inner_error0_ = NULL;
	GtkBuilder* result;
#line 20 "../src/client/util/util-gio.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 21 "../src/client/util/util-gio.vala"
	_tmp0_ = gtk_builder_new ();
#line 21 "../src/client/util/util-gio.vala"
	builder = _tmp0_;
#line 50 "util-gio.c"
	{
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 23 "../src/client/util/util-gio.vala"
		_tmp1_ = g_strconcat (GIO_UTIL_GEARY_RESOURCE_PREFIX, name, NULL);
#line 23 "../src/client/util/util-gio.vala"
		_tmp2_ = _tmp1_;
#line 23 "../src/client/util/util-gio.vala"
		gtk_builder_add_from_resource (builder, _tmp2_, &_inner_error0_);
#line 23 "../src/client/util/util-gio.vala"
		_g_free0 (_tmp2_);
#line 23 "../src/client/util/util-gio.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 64 "util-gio.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 22 "../src/client/util/util-gio.vala"
		_error_ = _inner_error0_;
#line 22 "../src/client/util/util-gio.vala"
		_inner_error0_ = NULL;
#line 25 "../src/client/util/util-gio.vala"
		_tmp3_ = _error_;
#line 25 "../src/client/util/util-gio.vala"
		_tmp4_ = _tmp3_->message;
#line 25 "../src/client/util/util-gio.vala"
		_tmp5_ = g_strdup_printf ("Unable load GResource \"%s\" for Gtk.Builder: %s", name, _tmp4_);
#line 25 "../src/client/util/util-gio.vala"
		_tmp6_ = _tmp5_;
#line 25 "../src/client/util/util-gio.vala"
		g_critical ("util-gio.vala:25: %s", _tmp6_);
#line 25 "../src/client/util/util-gio.vala"
		_g_free0 (_tmp6_);
#line 22 "../src/client/util/util-gio.vala"
		_g_error_free0 (_error_);
#line 94 "util-gio.c"
	}
	__finally0:
#line 22 "../src/client/util/util-gio.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 22 "../src/client/util/util-gio.vala"
		_g_object_unref0 (builder);
#line 22 "../src/client/util/util-gio.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 22 "../src/client/util/util-gio.vala"
		g_clear_error (&_inner_error0_);
#line 22 "../src/client/util/util-gio.vala"
		return NULL;
#line 107 "util-gio.c"
	}
#line 29 "../src/client/util/util-gio.vala"
	result = builder;
#line 29 "../src/client/util/util-gio.vala"
	return result;
#line 113 "util-gio.c"
}

/**
     * Loads a GResource file as a string.
     *
     * The given `name` will automatically have
     * `GEARY_RESOURCE_PREFIX` pre-pended to it.
     */
gchar*
gio_util_read_resource (const gchar* name,
                        GError** error)
{
	GInputStream* input_stream = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GInputStream* _tmp2_;
	GInputStream* _tmp3_;
	GDataInputStream* data_stream = NULL;
	GInputStream* _tmp4_;
	GDataInputStream* _tmp5_;
	gsize length = 0UL;
	gchar* _tmp6_ = NULL;
	GDataInputStream* _tmp7_;
	gsize _tmp8_ = 0UL;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 38 "../src/client/util/util-gio.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 39 "../src/client/util/util-gio.vala"
	_tmp0_ = g_strconcat (GIO_UTIL_GEARY_RESOURCE_PREFIX, name, NULL);
#line 39 "../src/client/util/util-gio.vala"
	_tmp1_ = _tmp0_;
#line 39 "../src/client/util/util-gio.vala"
	_tmp2_ = g_resources_open_stream (_tmp1_, G_RESOURCE_LOOKUP_FLAGS_NONE, &_inner_error0_);
#line 39 "../src/client/util/util-gio.vala"
	_tmp3_ = _tmp2_;
#line 39 "../src/client/util/util-gio.vala"
	_g_free0 (_tmp1_);
#line 39 "../src/client/util/util-gio.vala"
	input_stream = _tmp3_;
#line 39 "../src/client/util/util-gio.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 39 "../src/client/util/util-gio.vala"
		g_propagate_error (error, _inner_error0_);
#line 39 "../src/client/util/util-gio.vala"
		return NULL;
#line 162 "util-gio.c"
	}
#line 43 "../src/client/util/util-gio.vala"
	_tmp4_ = input_stream;
#line 43 "../src/client/util/util-gio.vala"
	_tmp5_ = g_data_input_stream_new (_tmp4_);
#line 43 "../src/client/util/util-gio.vala"
	data_stream = _tmp5_;
#line 45 "../src/client/util/util-gio.vala"
	_tmp7_ = data_stream;
#line 45 "../src/client/util/util-gio.vala"
	_tmp9_ = g_data_input_stream_read_upto (_tmp7_, "\0", (gssize) 1, &_tmp8_, NULL, &_inner_error0_);
#line 45 "../src/client/util/util-gio.vala"
	length = _tmp8_;
#line 45 "../src/client/util/util-gio.vala"
	_tmp6_ = _tmp9_;
#line 45 "../src/client/util/util-gio.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 45 "../src/client/util/util-gio.vala"
		g_propagate_error (error, _inner_error0_);
#line 45 "../src/client/util/util-gio.vala"
		_g_object_unref0 (data_stream);
#line 45 "../src/client/util/util-gio.vala"
		_g_object_unref0 (input_stream);
#line 45 "../src/client/util/util-gio.vala"
		return NULL;
#line 188 "util-gio.c"
	}
#line 45 "../src/client/util/util-gio.vala"
	_tmp10_ = _tmp6_;
#line 45 "../src/client/util/util-gio.vala"
	_tmp6_ = NULL;
#line 45 "../src/client/util/util-gio.vala"
	result = _tmp10_;
#line 45 "../src/client/util/util-gio.vala"
	_g_free0 (_tmp6_);
#line 45 "../src/client/util/util-gio.vala"
	_g_object_unref0 (data_stream);
#line 45 "../src/client/util/util-gio.vala"
	_g_object_unref0 (input_stream);
#line 45 "../src/client/util/util-gio.vala"
	return result;
#line 204 "util-gio.c"
}

