/* util-gtk.c generated by valac 0.56.17, the Vala compiler
 * generated from util-gtk.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2019 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-client-46.0.h"
#include <cairo-gobject.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
typedef void (*UtilGtkMenuForeachFunc) (const gchar* label, const gchar* action_name, GVariant* target, GMenu* section, gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

VALA_EXTERN gboolean util_gtk_close_button_at_end (void);
VALA_EXTERN void util_gtk_menu_foreach (GMenu* menu,
                            UtilGtkMenuForeachFunc foreach_func,
                            gpointer foreach_func_target);
static gchar* _variant_get18 (GVariant* value);
static gchar* _variant_get19 (GVariant* value);

/**
     * Given an HTML-style color spec, parses the color and sets it to
     * the source RGB of the Cairo context. (Borrowed from Shotwell.)
     */
void
util_gtk_set_source_color_from_string (cairo_t* ctx,
                                       const gchar* spec)
{
	GdkRGBA rgba = {0};
	GdkRGBA _tmp0_;
	GdkRGBA _tmp1_;
	GdkRGBA _tmp2_;
#line 22 "../src/client/util/util-gtk.vala"
	g_return_if_fail (ctx != NULL);
#line 22 "../src/client/util/util-gtk.vala"
	g_return_if_fail (spec != NULL);
#line 23 "../src/client/util/util-gtk.vala"
	memset (&rgba, 0, sizeof (GdkRGBA));
#line 24 "../src/client/util/util-gtk.vala"
	if (!gdk_rgba_parse (&rgba, spec)) {
#line 25 "../src/client/util/util-gtk.vala"
		g_error ("util-gtk.vala:25: Can't parse color %s", spec);
#line 70 "util-gtk.c"
	}
#line 26 "../src/client/util/util-gtk.vala"
	_tmp0_ = rgba;
#line 26 "../src/client/util/util-gtk.vala"
	_tmp1_ = rgba;
#line 26 "../src/client/util/util-gtk.vala"
	_tmp2_ = rgba;
#line 26 "../src/client/util/util-gtk.vala"
	cairo_set_source_rgb (ctx, _tmp0_.red, _tmp1_.green, _tmp2_.blue);
#line 80 "util-gtk.c"
}

/**
     * Returns whether the close button is at the end of the headerbar.
     */
static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1184 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1184 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1185 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1185 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1187 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1187 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 107 "util-gtk.c"
		gchar* _tmp2_;
#line 1188 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1188 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1188 "glib-2.0.vapi"
		return result;
#line 115 "util-gtk.c"
	} else {
#line 1190 "glib-2.0.vapi"
		result = -1;
#line 1190 "glib-2.0.vapi"
		return result;
#line 121 "util-gtk.c"
	}
}

gboolean
util_gtk_close_button_at_end (void)
{
	gchar* layout = NULL;
	GtkSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean at_end = FALSE;
	const gchar* _tmp3_;
	gboolean result;
#line 33 "../src/client/util/util-gtk.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 33 "../src/client/util/util-gtk.vala"
	g_object_get (_tmp0_, "gtk-decoration-layout", &_tmp1_, NULL);
#line 33 "../src/client/util/util-gtk.vala"
	_tmp2_ = _tmp1_;
#line 33 "../src/client/util/util-gtk.vala"
	layout = _tmp2_;
#line 34 "../src/client/util/util-gtk.vala"
	at_end = FALSE;
#line 38 "../src/client/util/util-gtk.vala"
	_tmp3_ = layout;
#line 38 "../src/client/util/util-gtk.vala"
	if (_tmp3_ != NULL) {
#line 149 "util-gtk.c"
		gint colon_ind = 0;
		const gchar* _tmp4_;
		gboolean _tmp5_ = FALSE;
#line 39 "../src/client/util/util-gtk.vala"
		_tmp4_ = layout;
#line 39 "../src/client/util/util-gtk.vala"
		colon_ind = string_index_of (_tmp4_, ":", 0);
#line 40 "../src/client/util/util-gtk.vala"
		if (colon_ind >= 0) {
#line 159 "util-gtk.c"
			const gchar* _tmp6_;
#line 40 "../src/client/util/util-gtk.vala"
			_tmp6_ = layout;
#line 40 "../src/client/util/util-gtk.vala"
			_tmp5_ = string_index_of (_tmp6_, "close", colon_ind) >= 0;
#line 165 "util-gtk.c"
		} else {
#line 40 "../src/client/util/util-gtk.vala"
			_tmp5_ = FALSE;
#line 169 "util-gtk.c"
		}
#line 40 "../src/client/util/util-gtk.vala"
		at_end = _tmp5_;
#line 173 "util-gtk.c"
	}
#line 42 "../src/client/util/util-gtk.vala"
	result = at_end;
#line 42 "../src/client/util/util-gtk.vala"
	_g_free0 (layout);
#line 42 "../src/client/util/util-gtk.vala"
	return result;
#line 181 "util-gtk.c"
}

/**
     * Allows iterating over a GMenu, without having to handle MenuItems
     * @param menu - The menu to iterate over
     * @param foreach_func - The function which will be called on the
     * attributes of menu's children
     */
void
util_gtk_menu_foreach (GMenu* menu,
                       UtilGtkMenuForeachFunc foreach_func,
                       gpointer foreach_func_target)
{
#line 51 "../src/client/util/util-gtk.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (menu, g_menu_get_type ()));
#line 197 "util-gtk.c"
	{
		gint i = 0;
#line 52 "../src/client/util/util-gtk.vala"
		i = 0;
#line 202 "util-gtk.c"
		{
			gboolean _tmp0_ = FALSE;
#line 52 "../src/client/util/util-gtk.vala"
			_tmp0_ = TRUE;
#line 52 "../src/client/util/util-gtk.vala"
			while (TRUE) {
#line 209 "util-gtk.c"
				GVariant* label = NULL;
				const GVariantType* _tmp2_;
				GVariant* _tmp3_;
				GVariant* action_name = NULL;
				const GVariantType* _tmp4_;
				GVariant* _tmp5_;
				GVariant* action_target = NULL;
				const GVariantType* _tmp6_;
				GVariant* _tmp7_;
				GMenu* section = NULL;
				GMenuModel* _tmp8_;
				const gchar* _tmp9_ = NULL;
				GVariant* _tmp10_;
				const gchar* _tmp13_ = NULL;
				GVariant* _tmp14_;
				GVariant* _tmp17_;
				GMenu* _tmp18_;
#line 52 "../src/client/util/util-gtk.vala"
				if (!_tmp0_) {
#line 229 "util-gtk.c"
					gint _tmp1_;
#line 52 "../src/client/util/util-gtk.vala"
					_tmp1_ = i;
#line 52 "../src/client/util/util-gtk.vala"
					i = _tmp1_ + 1;
#line 235 "util-gtk.c"
				}
#line 52 "../src/client/util/util-gtk.vala"
				_tmp0_ = FALSE;
#line 52 "../src/client/util/util-gtk.vala"
				if (!(i < g_menu_model_get_n_items (G_TYPE_CHECK_INSTANCE_CAST (menu, g_menu_model_get_type (), GMenuModel)))) {
#line 52 "../src/client/util/util-gtk.vala"
					break;
#line 243 "util-gtk.c"
				}
#line 54 "../src/client/util/util-gtk.vala"
				_tmp2_ = G_VARIANT_TYPE_STRING;
#line 54 "../src/client/util/util-gtk.vala"
				_tmp3_ = g_menu_model_get_item_attribute_value (G_TYPE_CHECK_INSTANCE_CAST (menu, g_menu_model_get_type (), GMenuModel), i, G_MENU_ATTRIBUTE_LABEL, _tmp2_);
#line 54 "../src/client/util/util-gtk.vala"
				label = _tmp3_;
#line 55 "../src/client/util/util-gtk.vala"
				_tmp4_ = G_VARIANT_TYPE_STRING;
#line 55 "../src/client/util/util-gtk.vala"
				_tmp5_ = g_menu_model_get_item_attribute_value (G_TYPE_CHECK_INSTANCE_CAST (menu, g_menu_model_get_type (), GMenuModel), i, G_MENU_ATTRIBUTE_ACTION, _tmp4_);
#line 55 "../src/client/util/util-gtk.vala"
				action_name = _tmp5_;
#line 56 "../src/client/util/util-gtk.vala"
				_tmp6_ = G_VARIANT_TYPE_STRING;
#line 56 "../src/client/util/util-gtk.vala"
				_tmp7_ = g_menu_model_get_item_attribute_value (G_TYPE_CHECK_INSTANCE_CAST (menu, g_menu_model_get_type (), GMenuModel), i, G_MENU_ATTRIBUTE_TARGET, _tmp6_);
#line 56 "../src/client/util/util-gtk.vala"
				action_target = _tmp7_;
#line 59 "../src/client/util/util-gtk.vala"
				_tmp8_ = g_menu_model_get_item_link (G_TYPE_CHECK_INSTANCE_CAST (menu, g_menu_model_get_type (), GMenuModel), i, G_MENU_LINK_SECTION);
#line 59 "../src/client/util/util-gtk.vala"
				section = G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, g_menu_get_type (), GMenu);
#line 62 "../src/client/util/util-gtk.vala"
				_tmp10_ = label;
#line 62 "../src/client/util/util-gtk.vala"
				if (_tmp10_ != NULL) {
#line 271 "util-gtk.c"
					GVariant* _tmp11_;
					const gchar* _tmp12_;
#line 62 "../src/client/util/util-gtk.vala"
					_tmp11_ = label;
#line 62 "../src/client/util/util-gtk.vala"
					_tmp12_ = g_variant_get_string (_tmp11_, NULL);
#line 62 "../src/client/util/util-gtk.vala"
					_tmp9_ = _tmp12_;
#line 280 "util-gtk.c"
				} else {
#line 62 "../src/client/util/util-gtk.vala"
					_tmp9_ = NULL;
#line 284 "util-gtk.c"
				}
#line 63 "../src/client/util/util-gtk.vala"
				_tmp14_ = action_name;
#line 63 "../src/client/util/util-gtk.vala"
				if (_tmp14_ != NULL) {
#line 290 "util-gtk.c"
					GVariant* _tmp15_;
					const gchar* _tmp16_;
#line 63 "../src/client/util/util-gtk.vala"
					_tmp15_ = action_name;
#line 63 "../src/client/util/util-gtk.vala"
					_tmp16_ = g_variant_get_string (_tmp15_, NULL);
#line 63 "../src/client/util/util-gtk.vala"
					_tmp13_ = _tmp16_;
#line 299 "util-gtk.c"
				} else {
#line 63 "../src/client/util/util-gtk.vala"
					_tmp13_ = NULL;
#line 303 "util-gtk.c"
				}
#line 62 "../src/client/util/util-gtk.vala"
				_tmp17_ = action_target;
#line 62 "../src/client/util/util-gtk.vala"
				_tmp18_ = section;
#line 62 "../src/client/util/util-gtk.vala"
				foreach_func (_tmp9_, _tmp13_, _tmp17_, _tmp18_, foreach_func_target);
#line 52 "../src/client/util/util-gtk.vala"
				_g_object_unref0 (section);
#line 52 "../src/client/util/util-gtk.vala"
				_g_variant_unref0 (action_target);
#line 52 "../src/client/util/util-gtk.vala"
				_g_variant_unref0 (action_name);
#line 52 "../src/client/util/util-gtk.vala"
				_g_variant_unref0 (label);
#line 319 "util-gtk.c"
			}
		}
	}
}

/**
     * Returns the CSS border box height for a widget.
     *
     * This adjusts the GTK widget's allocated height to exclude extra
     * space added by the CSS margin property, if any.
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 87 "../src/client/util/util-gtk.vala"
	return self ? g_object_ref (self) : NULL;
#line 336 "util-gtk.c"
}

inline gint
util_gtk_get_border_box_height (GtkWidget* widget)
{
	GtkStyleContext* style = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStateFlags flags = 0U;
	GtkBorder margin = {0};
	GtkBorder _tmp2_ = {0};
	GtkBorder _tmp3_;
	GtkBorder _tmp4_;
	gint result;
#line 86 "../src/client/util/util-gtk.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_widget_get_type ()), 0);
#line 87 "../src/client/util/util-gtk.vala"
	_tmp0_ = gtk_widget_get_style_context (widget);
#line 87 "../src/client/util/util-gtk.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 87 "../src/client/util/util-gtk.vala"
	style = _tmp1_;
#line 88 "../src/client/util/util-gtk.vala"
	flags = gtk_style_context_get_state (style);
#line 89 "../src/client/util/util-gtk.vala"
	gtk_style_context_get_margin (style, flags, &_tmp2_);
#line 89 "../src/client/util/util-gtk.vala"
	margin = _tmp2_;
#line 91 "../src/client/util/util-gtk.vala"
	_tmp3_ = margin;
#line 91 "../src/client/util/util-gtk.vala"
	_tmp4_ = margin;
#line 91 "../src/client/util/util-gtk.vala"
	result = (gtk_widget_get_allocated_height (widget) - _tmp3_.top) - _tmp4_.bottom;
#line 91 "../src/client/util/util-gtk.vala"
	_g_object_unref0 (style);
#line 91 "../src/client/util/util-gtk.vala"
	return result;
#line 375 "util-gtk.c"
}

/**
     * Constructs a frozen GMenu from an existing model using a visitor.
     *
     * The visitor is applied to the given template model to each of
     * its items, or recursively for any section or submenu. If the
     * visitor returns false when passed an item, section or submenu
     * then it will be skipped, otherwise it will be added to a new
     * menu.
     *
     * The constructed menu will be returned frozen.
     *
     * @see MenuVisitor
     */
static gchar*
_variant_get18 (GVariant* value)
{
#line 117 "../src/client/util/util-gtk.vala"
	return g_variant_dup_string (value, NULL);
#line 396 "util-gtk.c"
}

GMenu*
util_gtk_construct_menu (GMenuModel* template,
                         UtilGtkMenuVisitor visitor,
                         gpointer visitor_target)
{
	GMenu* model = NULL;
	GMenu* _tmp0_;
	GMenu* _tmp34_;
	GMenu* result;
#line 107 "../src/client/util/util-gtk.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (template, g_menu_model_get_type ()), NULL);
#line 109 "../src/client/util/util-gtk.vala"
	_tmp0_ = g_menu_new ();
#line 109 "../src/client/util/util-gtk.vala"
	model = _tmp0_;
#line 414 "util-gtk.c"
	{
		gint i = 0;
#line 110 "../src/client/util/util-gtk.vala"
		i = 0;
#line 419 "util-gtk.c"
		{
			gboolean _tmp1_ = FALSE;
#line 110 "../src/client/util/util-gtk.vala"
			_tmp1_ = TRUE;
#line 110 "../src/client/util/util-gtk.vala"
			while (TRUE) {
#line 426 "util-gtk.c"
				GMenuItem* item = NULL;
				GMenuItem* _tmp3_;
				gchar* action = NULL;
				GVariant* action_value = NULL;
				GMenuItem* _tmp4_;
				const GVariantType* _tmp5_;
				GVariant* _tmp6_;
				GVariant* _tmp7_;
				GMenu* section = NULL;
				GMenuItem* _tmp10_;
				GMenuModel* _tmp11_;
				GMenu* submenu = NULL;
				GMenuItem* _tmp12_;
				GMenuModel* _tmp13_;
				gboolean append = FALSE;
				GMenu* _tmp14_;
#line 110 "../src/client/util/util-gtk.vala"
				if (!_tmp1_) {
#line 445 "util-gtk.c"
					gint _tmp2_;
#line 110 "../src/client/util/util-gtk.vala"
					_tmp2_ = i;
#line 110 "../src/client/util/util-gtk.vala"
					i = _tmp2_ + 1;
#line 451 "util-gtk.c"
				}
#line 110 "../src/client/util/util-gtk.vala"
				_tmp1_ = FALSE;
#line 110 "../src/client/util/util-gtk.vala"
				if (!(i < g_menu_model_get_n_items (template))) {
#line 110 "../src/client/util/util-gtk.vala"
					break;
#line 459 "util-gtk.c"
				}
#line 111 "../src/client/util/util-gtk.vala"
				_tmp3_ = g_menu_item_new_from_model (template, i);
#line 111 "../src/client/util/util-gtk.vala"
				item = _tmp3_;
#line 112 "../src/client/util/util-gtk.vala"
				action = NULL;
#line 113 "../src/client/util/util-gtk.vala"
				_tmp4_ = item;
#line 113 "../src/client/util/util-gtk.vala"
				_tmp5_ = G_VARIANT_TYPE_STRING;
#line 113 "../src/client/util/util-gtk.vala"
				_tmp6_ = g_menu_item_get_attribute_value (_tmp4_, G_MENU_ATTRIBUTE_ACTION, _tmp5_);
#line 113 "../src/client/util/util-gtk.vala"
				action_value = _tmp6_;
#line 116 "../src/client/util/util-gtk.vala"
				_tmp7_ = action_value;
#line 116 "../src/client/util/util-gtk.vala"
				if (_tmp7_ != NULL) {
#line 479 "util-gtk.c"
					GVariant* _tmp8_;
					gchar* _tmp9_;
#line 117 "../src/client/util/util-gtk.vala"
					_tmp8_ = action_value;
#line 117 "../src/client/util/util-gtk.vala"
					_tmp9_ = _variant_get18 (_tmp8_);
#line 117 "../src/client/util/util-gtk.vala"
					_g_free0 (action);
#line 117 "../src/client/util/util-gtk.vala"
					action = _tmp9_;
#line 490 "util-gtk.c"
				}
#line 119 "../src/client/util/util-gtk.vala"
				_tmp10_ = item;
#line 119 "../src/client/util/util-gtk.vala"
				_tmp11_ = g_menu_item_get_link (_tmp10_, G_MENU_LINK_SECTION);
#line 119 "../src/client/util/util-gtk.vala"
				section = G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, g_menu_get_type (), GMenu);
#line 122 "../src/client/util/util-gtk.vala"
				_tmp12_ = item;
#line 122 "../src/client/util/util-gtk.vala"
				_tmp13_ = g_menu_item_get_link (_tmp12_, G_MENU_LINK_SUBMENU);
#line 122 "../src/client/util/util-gtk.vala"
				submenu = G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, g_menu_get_type (), GMenu);
#line 126 "../src/client/util/util-gtk.vala"
				append = FALSE;
#line 127 "../src/client/util/util-gtk.vala"
				_tmp14_ = section;
#line 127 "../src/client/util/util-gtk.vala"
				if (_tmp14_ != NULL) {
#line 510 "util-gtk.c"
					GMenu* _tmp15_;
					const gchar* _tmp16_;
					GMenuItem* _tmp17_;
#line 128 "../src/client/util/util-gtk.vala"
					_tmp15_ = section;
#line 128 "../src/client/util/util-gtk.vala"
					_tmp16_ = action;
#line 128 "../src/client/util/util-gtk.vala"
					_tmp17_ = item;
#line 128 "../src/client/util/util-gtk.vala"
					if (visitor (template, G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, g_menu_model_get_type (), GMenuModel), _tmp16_, _tmp17_, visitor_target)) {
#line 522 "util-gtk.c"
						GMenu* _tmp18_;
						GMenu* _tmp19_;
						GMenuItem* _tmp20_;
						GMenu* _tmp21_;
#line 129 "../src/client/util/util-gtk.vala"
						append = TRUE;
#line 130 "../src/client/util/util-gtk.vala"
						_tmp18_ = section;
#line 130 "../src/client/util/util-gtk.vala"
						_tmp19_ = util_gtk_construct_menu (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, g_menu_model_get_type (), GMenuModel), visitor, visitor_target);
#line 130 "../src/client/util/util-gtk.vala"
						_g_object_unref0 (section);
#line 130 "../src/client/util/util-gtk.vala"
						section = _tmp19_;
#line 131 "../src/client/util/util-gtk.vala"
						_tmp20_ = item;
#line 131 "../src/client/util/util-gtk.vala"
						_tmp21_ = section;
#line 131 "../src/client/util/util-gtk.vala"
						g_menu_item_set_section (_tmp20_, G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, g_menu_model_get_type (), GMenuModel));
#line 543 "util-gtk.c"
					}
				} else {
					GMenu* _tmp22_;
#line 133 "../src/client/util/util-gtk.vala"
					_tmp22_ = submenu;
#line 133 "../src/client/util/util-gtk.vala"
					if (_tmp22_ != NULL) {
#line 551 "util-gtk.c"
						GMenu* _tmp23_;
						const gchar* _tmp24_;
						GMenuItem* _tmp25_;
#line 134 "../src/client/util/util-gtk.vala"
						_tmp23_ = submenu;
#line 134 "../src/client/util/util-gtk.vala"
						_tmp24_ = action;
#line 134 "../src/client/util/util-gtk.vala"
						_tmp25_ = item;
#line 134 "../src/client/util/util-gtk.vala"
						if (visitor (template, G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, g_menu_model_get_type (), GMenuModel), _tmp24_, _tmp25_, visitor_target)) {
#line 563 "util-gtk.c"
							GMenu* _tmp26_;
							GMenu* _tmp27_;
							GMenuItem* _tmp28_;
							GMenu* _tmp29_;
#line 135 "../src/client/util/util-gtk.vala"
							append = TRUE;
#line 136 "../src/client/util/util-gtk.vala"
							_tmp26_ = submenu;
#line 136 "../src/client/util/util-gtk.vala"
							_tmp27_ = util_gtk_construct_menu (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, g_menu_model_get_type (), GMenuModel), visitor, visitor_target);
#line 136 "../src/client/util/util-gtk.vala"
							_g_object_unref0 (submenu);
#line 136 "../src/client/util/util-gtk.vala"
							submenu = _tmp27_;
#line 137 "../src/client/util/util-gtk.vala"
							_tmp28_ = item;
#line 137 "../src/client/util/util-gtk.vala"
							_tmp29_ = submenu;
#line 137 "../src/client/util/util-gtk.vala"
							g_menu_item_set_submenu (_tmp28_, G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, g_menu_model_get_type (), GMenuModel));
#line 584 "util-gtk.c"
						}
					} else {
						const gchar* _tmp30_;
						GMenuItem* _tmp31_;
#line 140 "../src/client/util/util-gtk.vala"
						_tmp30_ = action;
#line 140 "../src/client/util/util-gtk.vala"
						_tmp31_ = item;
#line 140 "../src/client/util/util-gtk.vala"
						append = visitor (template, NULL, _tmp30_, _tmp31_, visitor_target);
#line 595 "util-gtk.c"
					}
				}
#line 143 "../src/client/util/util-gtk.vala"
				if (append) {
#line 600 "util-gtk.c"
					GMenu* _tmp32_;
					GMenuItem* _tmp33_;
#line 144 "../src/client/util/util-gtk.vala"
					_tmp32_ = model;
#line 144 "../src/client/util/util-gtk.vala"
					_tmp33_ = item;
#line 144 "../src/client/util/util-gtk.vala"
					g_menu_append_item (_tmp32_, _tmp33_);
#line 609 "util-gtk.c"
				}
#line 110 "../src/client/util/util-gtk.vala"
				_g_object_unref0 (submenu);
#line 110 "../src/client/util/util-gtk.vala"
				_g_object_unref0 (section);
#line 110 "../src/client/util/util-gtk.vala"
				_g_variant_unref0 (action_value);
#line 110 "../src/client/util/util-gtk.vala"
				_g_free0 (action);
#line 110 "../src/client/util/util-gtk.vala"
				_g_object_unref0 (item);
#line 621 "util-gtk.c"
			}
		}
	}
#line 147 "../src/client/util/util-gtk.vala"
	_tmp34_ = model;
#line 147 "../src/client/util/util-gtk.vala"
	g_menu_freeze (_tmp34_);
#line 148 "../src/client/util/util-gtk.vala"
	result = model;
#line 148 "../src/client/util/util-gtk.vala"
	return result;
#line 633 "util-gtk.c"
}

/** Copies a GLib menu, setting targets for the given actions. */
static gchar*
_variant_get19 (GVariant* value)
{
#line 195 "../src/client/util/util-gtk.vala"
	return g_variant_dup_string (value, NULL);
#line 642 "util-gtk.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 665 "util-gtk.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 674 "util-gtk.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 693 "util-gtk.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 697 "util-gtk.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 703 "util-gtk.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 713 "util-gtk.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 721 "util-gtk.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 725 "util-gtk.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 731 "util-gtk.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 741 "util-gtk.c"
}

GMenu*
util_gtk_copy_menu_with_targets (GMenu* template,
                                 const gchar* group,
                                 GeeMap* targets)
{
	gchar* group_prefix = NULL;
	gchar* _tmp0_;
	GMenu* copy = NULL;
	GMenu* _tmp1_;
	GMenu* result;
#line 172 "../src/client/util/util-gtk.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (template, g_menu_get_type ()), NULL);
#line 172 "../src/client/util/util-gtk.vala"
	g_return_val_if_fail (group != NULL, NULL);
#line 172 "../src/client/util/util-gtk.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (targets, GEE_TYPE_MAP), NULL);
#line 175 "../src/client/util/util-gtk.vala"
	_tmp0_ = g_strconcat (group, ".", NULL);
#line 175 "../src/client/util/util-gtk.vala"
	group_prefix = _tmp0_;
#line 176 "../src/client/util/util-gtk.vala"
	_tmp1_ = g_menu_new ();
#line 176 "../src/client/util/util-gtk.vala"
	copy = _tmp1_;
#line 768 "util-gtk.c"
	{
		gint i = 0;
#line 177 "../src/client/util/util-gtk.vala"
		i = 0;
#line 773 "util-gtk.c"
		{
			gboolean _tmp2_ = FALSE;
#line 177 "../src/client/util/util-gtk.vala"
			_tmp2_ = TRUE;
#line 177 "../src/client/util/util-gtk.vala"
			while (TRUE) {
#line 780 "util-gtk.c"
				GMenuItem* item = NULL;
				GMenuItem* _tmp4_;
				GMenu* section = NULL;
				GMenuItem* _tmp5_;
				GMenuModel* _tmp6_;
				GMenu* submenu = NULL;
				GMenuItem* _tmp7_;
				GMenuModel* _tmp8_;
				GMenu* _tmp9_;
				GMenu* _tmp41_;
				GMenuItem* _tmp42_;
#line 177 "../src/client/util/util-gtk.vala"
				if (!_tmp2_) {
#line 794 "util-gtk.c"
					gint _tmp3_;
#line 177 "../src/client/util/util-gtk.vala"
					_tmp3_ = i;
#line 177 "../src/client/util/util-gtk.vala"
					i = _tmp3_ + 1;
#line 800 "util-gtk.c"
				}
#line 177 "../src/client/util/util-gtk.vala"
				_tmp2_ = FALSE;
#line 177 "../src/client/util/util-gtk.vala"
				if (!(i < g_menu_model_get_n_items (G_TYPE_CHECK_INSTANCE_CAST (template, g_menu_model_get_type (), GMenuModel)))) {
#line 177 "../src/client/util/util-gtk.vala"
					break;
#line 808 "util-gtk.c"
				}
#line 178 "../src/client/util/util-gtk.vala"
				_tmp4_ = g_menu_item_new_from_model (G_TYPE_CHECK_INSTANCE_CAST (template, g_menu_model_get_type (), GMenuModel), i);
#line 178 "../src/client/util/util-gtk.vala"
				item = _tmp4_;
#line 179 "../src/client/util/util-gtk.vala"
				_tmp5_ = item;
#line 179 "../src/client/util/util-gtk.vala"
				_tmp6_ = g_menu_item_get_link (_tmp5_, G_MENU_LINK_SECTION);
#line 179 "../src/client/util/util-gtk.vala"
				section = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, g_menu_get_type (), GMenu);
#line 182 "../src/client/util/util-gtk.vala"
				_tmp7_ = item;
#line 182 "../src/client/util/util-gtk.vala"
				_tmp8_ = g_menu_item_get_link (_tmp7_, G_MENU_LINK_SUBMENU);
#line 182 "../src/client/util/util-gtk.vala"
				submenu = G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, g_menu_get_type (), GMenu);
#line 186 "../src/client/util/util-gtk.vala"
				_tmp9_ = section;
#line 186 "../src/client/util/util-gtk.vala"
				if (_tmp9_ != NULL) {
#line 830 "util-gtk.c"
					GMenuItem* _tmp10_;
					GMenu* _tmp11_;
					GMenu* _tmp12_;
					GMenu* _tmp13_;
#line 187 "../src/client/util/util-gtk.vala"
					_tmp10_ = item;
#line 187 "../src/client/util/util-gtk.vala"
					_tmp11_ = section;
#line 187 "../src/client/util/util-gtk.vala"
					_tmp12_ = util_gtk_copy_menu_with_targets (_tmp11_, group, targets);
#line 187 "../src/client/util/util-gtk.vala"
					_tmp13_ = _tmp12_;
#line 187 "../src/client/util/util-gtk.vala"
					g_menu_item_set_section (_tmp10_, G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, g_menu_model_get_type (), GMenuModel));
#line 187 "../src/client/util/util-gtk.vala"
					_g_object_unref0 (_tmp13_);
#line 847 "util-gtk.c"
				} else {
					GMenu* _tmp14_;
#line 190 "../src/client/util/util-gtk.vala"
					_tmp14_ = submenu;
#line 190 "../src/client/util/util-gtk.vala"
					if (_tmp14_ != NULL) {
#line 854 "util-gtk.c"
						GMenuItem* _tmp15_;
						GMenu* _tmp16_;
						GMenu* _tmp17_;
						GMenu* _tmp18_;
#line 191 "../src/client/util/util-gtk.vala"
						_tmp15_ = item;
#line 191 "../src/client/util/util-gtk.vala"
						_tmp16_ = submenu;
#line 191 "../src/client/util/util-gtk.vala"
						_tmp17_ = util_gtk_copy_menu_with_targets (_tmp16_, group, targets);
#line 191 "../src/client/util/util-gtk.vala"
						_tmp18_ = _tmp17_;
#line 191 "../src/client/util/util-gtk.vala"
						g_menu_item_set_submenu (_tmp15_, G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, g_menu_model_get_type (), GMenuModel));
#line 191 "../src/client/util/util-gtk.vala"
						_g_object_unref0 (_tmp18_);
#line 871 "util-gtk.c"
					} else {
						gchar* action = NULL;
						GMenuItem* _tmp19_;
						const GVariantType* _tmp20_;
						GVariant* _tmp21_;
						GVariant* _tmp22_;
						gchar* _tmp23_;
						gchar* _tmp24_;
						gboolean _tmp25_ = FALSE;
						const gchar* _tmp26_;
#line 195 "../src/client/util/util-gtk.vala"
						_tmp19_ = item;
#line 195 "../src/client/util/util-gtk.vala"
						_tmp20_ = G_VARIANT_TYPE_STRING;
#line 195 "../src/client/util/util-gtk.vala"
						_tmp21_ = g_menu_item_get_attribute_value (_tmp19_, G_MENU_ATTRIBUTE_ACTION, _tmp20_);
#line 195 "../src/client/util/util-gtk.vala"
						_tmp22_ = _tmp21_;
#line 195 "../src/client/util/util-gtk.vala"
						_tmp23_ = _variant_get19 (_tmp22_);
#line 195 "../src/client/util/util-gtk.vala"
						_tmp24_ = _tmp23_;
#line 195 "../src/client/util/util-gtk.vala"
						_g_variant_unref0 (_tmp22_);
#line 195 "../src/client/util/util-gtk.vala"
						action = _tmp24_;
#line 198 "../src/client/util/util-gtk.vala"
						_tmp26_ = action;
#line 198 "../src/client/util/util-gtk.vala"
						if (_tmp26_ != NULL) {
#line 902 "util-gtk.c"
							const gchar* _tmp27_;
							const gchar* _tmp28_;
#line 198 "../src/client/util/util-gtk.vala"
							_tmp27_ = action;
#line 198 "../src/client/util/util-gtk.vala"
							_tmp28_ = group_prefix;
#line 198 "../src/client/util/util-gtk.vala"
							_tmp25_ = g_str_has_prefix (_tmp27_, _tmp28_);
#line 911 "util-gtk.c"
						} else {
#line 198 "../src/client/util/util-gtk.vala"
							_tmp25_ = FALSE;
#line 915 "util-gtk.c"
						}
#line 198 "../src/client/util/util-gtk.vala"
						if (_tmp25_) {
#line 919 "util-gtk.c"
							GVariant* target = NULL;
							const gchar* _tmp29_;
							const gchar* _tmp30_;
							gint _tmp31_;
							gint _tmp32_;
							gchar* _tmp33_;
							gchar* _tmp34_;
							gpointer _tmp35_;
							GVariant* _tmp36_;
							GVariant* _tmp37_;
#line 199 "../src/client/util/util-gtk.vala"
							_tmp29_ = action;
#line 199 "../src/client/util/util-gtk.vala"
							_tmp30_ = group_prefix;
#line 199 "../src/client/util/util-gtk.vala"
							_tmp31_ = strlen (_tmp30_);
#line 199 "../src/client/util/util-gtk.vala"
							_tmp32_ = _tmp31_;
#line 199 "../src/client/util/util-gtk.vala"
							_tmp33_ = string_substring (_tmp29_, (glong) _tmp32_, (glong) -1);
#line 199 "../src/client/util/util-gtk.vala"
							_tmp34_ = _tmp33_;
#line 199 "../src/client/util/util-gtk.vala"
							_tmp35_ = gee_map_get (targets, _tmp34_);
#line 199 "../src/client/util/util-gtk.vala"
							_tmp36_ = (GVariant*) _tmp35_;
#line 199 "../src/client/util/util-gtk.vala"
							_g_free0 (_tmp34_);
#line 199 "../src/client/util/util-gtk.vala"
							target = _tmp36_;
#line 202 "../src/client/util/util-gtk.vala"
							_tmp37_ = target;
#line 202 "../src/client/util/util-gtk.vala"
							if (_tmp37_ != NULL) {
#line 954 "util-gtk.c"
								GMenuItem* _tmp38_;
								const gchar* _tmp39_;
								GVariant* _tmp40_;
#line 203 "../src/client/util/util-gtk.vala"
								_tmp38_ = item;
#line 203 "../src/client/util/util-gtk.vala"
								_tmp39_ = action;
#line 203 "../src/client/util/util-gtk.vala"
								_tmp40_ = target;
#line 203 "../src/client/util/util-gtk.vala"
								g_menu_item_set_action_and_target_value (_tmp38_, _tmp39_, _tmp40_);
#line 966 "util-gtk.c"
							}
#line 198 "../src/client/util/util-gtk.vala"
							_g_variant_unref0 (target);
#line 970 "util-gtk.c"
						}
#line 190 "../src/client/util/util-gtk.vala"
						_g_free0 (action);
#line 974 "util-gtk.c"
					}
				}
#line 207 "../src/client/util/util-gtk.vala"
				_tmp41_ = copy;
#line 207 "../src/client/util/util-gtk.vala"
				_tmp42_ = item;
#line 207 "../src/client/util/util-gtk.vala"
				g_menu_append_item (_tmp41_, _tmp42_);
#line 177 "../src/client/util/util-gtk.vala"
				_g_object_unref0 (submenu);
#line 177 "../src/client/util/util-gtk.vala"
				_g_object_unref0 (section);
#line 177 "../src/client/util/util-gtk.vala"
				_g_object_unref0 (item);
#line 989 "util-gtk.c"
			}
		}
	}
#line 209 "../src/client/util/util-gtk.vala"
	result = copy;
#line 209 "../src/client/util/util-gtk.vala"
	_g_free0 (group_prefix);
#line 209 "../src/client/util/util-gtk.vala"
	return result;
#line 999 "util-gtk.c"
}

/** Returns a truncated form of a URL if it is too long for display. */
gchar*
util_gtk_shorten_url (const gchar* url)
{
	gchar* new_url = NULL;
	gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* result;
#line 213 "../src/client/util/util-gtk.vala"
	g_return_val_if_fail (url != NULL, NULL);
#line 214 "../src/client/util/util-gtk.vala"
	_tmp0_ = g_strdup (url);
#line 214 "../src/client/util/util-gtk.vala"
	new_url = _tmp0_;
#line 215 "../src/client/util/util-gtk.vala"
	_tmp1_ = strlen (url);
#line 215 "../src/client/util/util-gtk.vala"
	_tmp2_ = _tmp1_;
#line 215 "../src/client/util/util-gtk.vala"
	if (_tmp2_ >= 90) {
#line 1023 "util-gtk.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 216 "../src/client/util/util-gtk.vala"
		_tmp3_ = string_substring (url, (glong) 0, (glong) 40);
#line 216 "../src/client/util/util-gtk.vala"
		_tmp4_ = _tmp3_;
#line 216 "../src/client/util/util-gtk.vala"
		_tmp5_ = g_strconcat (_tmp4_, "…", NULL);
#line 216 "../src/client/util/util-gtk.vala"
		_tmp6_ = _tmp5_;
#line 216 "../src/client/util/util-gtk.vala"
		_tmp7_ = string_substring (url, (glong) -40, (glong) -1);
#line 216 "../src/client/util/util-gtk.vala"
		_tmp8_ = _tmp7_;
#line 216 "../src/client/util/util-gtk.vala"
		_tmp9_ = g_strconcat (_tmp6_, _tmp8_, NULL);
#line 216 "../src/client/util/util-gtk.vala"
		_g_free0 (new_url);
#line 216 "../src/client/util/util-gtk.vala"
		new_url = _tmp9_;
#line 216 "../src/client/util/util-gtk.vala"
		_g_free0 (_tmp8_);
#line 216 "../src/client/util/util-gtk.vala"
		_g_free0 (_tmp6_);
#line 216 "../src/client/util/util-gtk.vala"
		_g_free0 (_tmp4_);
#line 1055 "util-gtk.c"
	}
#line 218 "../src/client/util/util-gtk.vala"
	result = new_url;
#line 218 "../src/client/util/util-gtk.vala"
	return result;
#line 1061 "util-gtk.c"
}

void
util_gtk_rgba (gdouble red,
               gdouble green,
               gdouble blue,
               gdouble alpha,
               GdkRGBA* result)
{
	GdkRGBA _tmp0_ = {0};
#line 222 "../src/client/util/util-gtk.vala"
	memset (&_tmp0_, 0, sizeof (GdkRGBA));
#line 222 "../src/client/util/util-gtk.vala"
	_tmp0_.red = red;
#line 222 "../src/client/util/util-gtk.vala"
	_tmp0_.green = green;
#line 222 "../src/client/util/util-gtk.vala"
	_tmp0_.blue = blue;
#line 222 "../src/client/util/util-gtk.vala"
	_tmp0_.alpha = alpha;
#line 222 "../src/client/util/util-gtk.vala"
	*result = _tmp0_;
#line 222 "../src/client/util/util-gtk.vala"
	return;
#line 1086 "util-gtk.c"
}

gboolean
util_gtk_query_tooltip_label (GtkWidget* widget,
                              gint x,
                              gint y,
                              gboolean keyboard,
                              GtkTooltip* tooltip)
{
	GtkLabel* label = NULL;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	PangoLayout* _tmp2_;
	gboolean result;
#line 231 "../src/client/util/util-gtk.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_widget_get_type ()), FALSE);
#line 231 "../src/client/util/util-gtk.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (tooltip, gtk_tooltip_get_type ()), FALSE);
#line 232 "../src/client/util/util-gtk.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_label_get_type ()) ? ((GtkLabel*) widget) : NULL);
#line 232 "../src/client/util/util-gtk.vala"
	label = _tmp0_;
#line 233 "../src/client/util/util-gtk.vala"
	_tmp1_ = label;
#line 233 "../src/client/util/util-gtk.vala"
	_tmp2_ = gtk_label_get_layout (_tmp1_);
#line 233 "../src/client/util/util-gtk.vala"
	if (pango_layout_is_ellipsized (_tmp2_)) {
#line 1115 "util-gtk.c"
		GtkLabel* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 234 "../src/client/util/util-gtk.vala"
		_tmp3_ = label;
#line 234 "../src/client/util/util-gtk.vala"
		_tmp4_ = gtk_label_get_label (_tmp3_);
#line 234 "../src/client/util/util-gtk.vala"
		_tmp5_ = _tmp4_;
#line 234 "../src/client/util/util-gtk.vala"
		gtk_tooltip_set_markup (tooltip, _tmp5_);
#line 235 "../src/client/util/util-gtk.vala"
		result = TRUE;
#line 235 "../src/client/util/util-gtk.vala"
		_g_object_unref0 (label);
#line 235 "../src/client/util/util-gtk.vala"
		return result;
#line 1133 "util-gtk.c"
	}
#line 237 "../src/client/util/util-gtk.vala"
	result = FALSE;
#line 237 "../src/client/util/util-gtk.vala"
	_g_object_unref0 (label);
#line 237 "../src/client/util/util-gtk.vala"
	return result;
#line 1141 "util-gtk.c"
}

