/* util-migrate.c generated by valac 0.56.17, the Vala compiler
 * generated from util-migrate.vala, do not modify */

/*
 * Copyright © 2016 Software Freedom Conservancy Inc.
 * Copyright © 2020 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
n */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "geary-client-46.0.h"
#include <gio/gio.h>
#include "geary-engine.h"

#define UTIL_MIGRATE_GROUP "AccountInformation"
#define UTIL_MIGRATE_PRIMARY_EMAIL_KEY "primary_email"
#define UTIL_MIGRATE_SETTINGS_FILENAME ACCOUNTS_MANAGER_SETTINGS_FILENAME
#define UTIL_MIGRATE_MIGRATED_FILENAME ".config_migrated"
#define UTIL_MIGRATE_MIGRATED_CONFIG_KEY "migrated-config"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_settings_schema_source_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_source_unref (var), NULL)))
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

VALA_EXTERN gboolean util_migrate_is_directory_empty (GFile* dir);
VALA_EXTERN void util_migrate_recursive_copy (GFile* src,
                                  GFile* dest,
                                  GCancellable* cancellable,
                                  GError** error);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

/**
     * Migrates geary.ini to the XDG configuration directory with the account's email address
     *
     * This function iterates through all the account directories in $XDG_DATA_DIR and copies over
     * geary.ini to ~/.config/geary/<account>/geary.ini. Note that it leaves the
     * original file untouched.
     * It also appends a "primary_email" key to the new configuration file to reliaby keep
     * track of the user's email address.
     */
static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 99 "util-migrate.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 105 "util-migrate.c"
}

void
util_migrate_xdg_config_dir (GFile* user_config_dir,
                             GFile* user_data_dir,
                             GError** error)
{
	GFile* new_config_dir = NULL;
	GFile* old_data_dir = NULL;
	GFile* new_config_file = NULL;
	GFile* old_config_file = NULL;
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp0_ = NULL;
	GFileEnumerator* _tmp1_;
	GFileEnumerator* _tmp2_;
	GFileInfo* info = NULL;
	gchar* email = NULL;
	GFile* is_migrated = NULL;
	GError* _inner_error0_ = NULL;
#line 24 "../src/client/util/util-migrate.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (user_config_dir, g_file_get_type ()));
#line 24 "../src/client/util/util-migrate.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (user_data_dir, g_file_get_type ()));
#line 33 "../src/client/util/util-migrate.vala"
	if (!g_file_query_exists (user_data_dir, NULL)) {
#line 34 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (old_config_file);
#line 34 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (new_config_file);
#line 34 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (old_data_dir);
#line 34 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (new_config_dir);
#line 34 "../src/client/util/util-migrate.vala"
		return;
#line 141 "util-migrate.c"
	}
#line 37 "../src/client/util/util-migrate.vala"
	_tmp1_ = g_file_enumerate_children (user_data_dir, "standard::*", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 37 "../src/client/util/util-migrate.vala"
	_tmp0_ = _tmp1_;
#line 37 "../src/client/util/util-migrate.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 37 "../src/client/util/util-migrate.vala"
		g_propagate_error (error, _inner_error0_);
#line 37 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (enumerator);
#line 37 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (old_config_file);
#line 37 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (new_config_file);
#line 37 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (old_data_dir);
#line 37 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (new_config_dir);
#line 37 "../src/client/util/util-migrate.vala"
		return;
#line 163 "util-migrate.c"
	}
#line 37 "../src/client/util/util-migrate.vala"
	_tmp2_ = _tmp0_;
#line 37 "../src/client/util/util-migrate.vala"
	_tmp0_ = NULL;
#line 37 "../src/client/util/util-migrate.vala"
	_g_object_unref0 (enumerator);
#line 37 "../src/client/util/util-migrate.vala"
	enumerator = _tmp2_;
#line 43 "../src/client/util/util-migrate.vala"
	while (TRUE) {
#line 175 "util-migrate.c"
		GFileInfo* _tmp3_ = NULL;
		GFileEnumerator* _tmp4_;
		GFileInfo* _tmp5_;
		GFileInfo* _tmp6_;
		GFileInfo* _tmp7_;
		GFileInfo* _tmp8_;
		GFileInfo* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		GFile* _tmp14_;
		const gchar* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
		GFile* _tmp18_;
		GFile* _tmp19_;
		GFile* _tmp20_;
		GFile* _tmp21_;
		GFile* _tmp22_;
		GFile* _tmp23_;
		GFile* _tmp27_;
		GFile* _tmp28_;
		GFile* _tmp29_;
		GKeyFile* key_file = NULL;
		GKeyFile* _tmp35_;
		GKeyFile* _tmp43_;
		const gchar* _tmp44_;
		gchar* data = NULL;
		GKeyFile* _tmp45_;
		gchar* _tmp46_;
		GFile* _tmp53_;
		GFileOutputStream* _tmp54_;
		GFileOutputStream* _tmp55_;
#line 43 "../src/client/util/util-migrate.vala"
		_tmp4_ = enumerator;
#line 43 "../src/client/util/util-migrate.vala"
		_tmp5_ = g_file_enumerator_next_file (_tmp4_, NULL, &_inner_error0_);
#line 43 "../src/client/util/util-migrate.vala"
		_tmp3_ = _tmp5_;
#line 43 "../src/client/util/util-migrate.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 43 "../src/client/util/util-migrate.vala"
			g_propagate_error (error, _inner_error0_);
#line 43 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (is_migrated);
#line 43 "../src/client/util/util-migrate.vala"
			_g_free0 (email);
#line 43 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (info);
#line 43 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp0_);
#line 43 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (enumerator);
#line 43 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (old_config_file);
#line 43 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_file);
#line 43 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (old_data_dir);
#line 43 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_dir);
#line 43 "../src/client/util/util-migrate.vala"
			return;
#line 240 "util-migrate.c"
		}
#line 43 "../src/client/util/util-migrate.vala"
		_tmp6_ = _tmp3_;
#line 43 "../src/client/util/util-migrate.vala"
		_tmp3_ = NULL;
#line 43 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (info);
#line 43 "../src/client/util/util-migrate.vala"
		info = _tmp6_;
#line 43 "../src/client/util/util-migrate.vala"
		_tmp7_ = info;
#line 43 "../src/client/util/util-migrate.vala"
		if (!(_tmp7_ != NULL)) {
#line 43 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp3_);
#line 43 "../src/client/util/util-migrate.vala"
			break;
#line 258 "util-migrate.c"
		}
#line 44 "../src/client/util/util-migrate.vala"
		_tmp8_ = info;
#line 44 "../src/client/util/util-migrate.vala"
		if (g_file_info_get_file_type (_tmp8_) != G_FILE_TYPE_DIRECTORY) {
#line 45 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp3_);
#line 45 "../src/client/util/util-migrate.vala"
			continue;
#line 268 "util-migrate.c"
		}
#line 47 "../src/client/util/util-migrate.vala"
		_tmp9_ = info;
#line 47 "../src/client/util/util-migrate.vala"
		_tmp10_ = g_file_info_get_name (_tmp9_);
#line 47 "../src/client/util/util-migrate.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 47 "../src/client/util/util-migrate.vala"
		_g_free0 (email);
#line 47 "../src/client/util/util-migrate.vala"
		email = _tmp11_;
#line 50 "../src/client/util/util-migrate.vala"
		_tmp12_ = email;
#line 50 "../src/client/util/util-migrate.vala"
		if (!geary_rf_c822_mailbox_address_is_valid_address (_tmp12_)) {
#line 51 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp3_);
#line 51 "../src/client/util/util-migrate.vala"
			continue;
#line 288 "util-migrate.c"
		}
#line 53 "../src/client/util/util-migrate.vala"
		_tmp13_ = email;
#line 53 "../src/client/util/util-migrate.vala"
		_tmp14_ = g_file_get_child (user_data_dir, _tmp13_);
#line 53 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (old_data_dir);
#line 53 "../src/client/util/util-migrate.vala"
		old_data_dir = _tmp14_;
#line 54 "../src/client/util/util-migrate.vala"
		_tmp15_ = email;
#line 54 "../src/client/util/util-migrate.vala"
		_tmp16_ = g_file_get_child (user_config_dir, _tmp15_);
#line 54 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (new_config_dir);
#line 54 "../src/client/util/util-migrate.vala"
		new_config_dir = _tmp16_;
#line 57 "../src/client/util/util-migrate.vala"
		_tmp17_ = old_data_dir;
#line 57 "../src/client/util/util-migrate.vala"
		_tmp18_ = g_file_get_child (_tmp17_, UTIL_MIGRATE_SETTINGS_FILENAME);
#line 57 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (old_config_file);
#line 57 "../src/client/util/util-migrate.vala"
		old_config_file = _tmp18_;
#line 58 "../src/client/util/util-migrate.vala"
		_tmp19_ = old_config_file;
#line 58 "../src/client/util/util-migrate.vala"
		if (!g_file_query_exists (_tmp19_, NULL)) {
#line 59 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp3_);
#line 59 "../src/client/util/util-migrate.vala"
			continue;
#line 322 "util-migrate.c"
		}
#line 62 "../src/client/util/util-migrate.vala"
		_tmp20_ = old_data_dir;
#line 62 "../src/client/util/util-migrate.vala"
		_tmp21_ = g_file_get_child (_tmp20_, UTIL_MIGRATE_MIGRATED_FILENAME);
#line 62 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (is_migrated);
#line 62 "../src/client/util/util-migrate.vala"
		is_migrated = _tmp21_;
#line 63 "../src/client/util/util-migrate.vala"
		_tmp22_ = is_migrated;
#line 63 "../src/client/util/util-migrate.vala"
		if (g_file_query_exists (_tmp22_, NULL)) {
#line 64 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp3_);
#line 64 "../src/client/util/util-migrate.vala"
			continue;
#line 340 "util-migrate.c"
		}
#line 66 "../src/client/util/util-migrate.vala"
		_tmp23_ = new_config_dir;
#line 66 "../src/client/util/util-migrate.vala"
		if (!g_file_query_exists (_tmp23_, NULL)) {
#line 346 "util-migrate.c"
			{
				GFile* _tmp24_;
#line 68 "../src/client/util/util-migrate.vala"
				_tmp24_ = new_config_dir;
#line 68 "../src/client/util/util-migrate.vala"
				g_file_make_directory_with_parents (_tmp24_, NULL, &_inner_error0_);
#line 68 "../src/client/util/util-migrate.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 355 "util-migrate.c"
					goto __catch0_g_error;
				}
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				GError* _tmp25_;
				const gchar* _tmp26_;
#line 67 "../src/client/util/util-migrate.vala"
				e = _inner_error0_;
#line 67 "../src/client/util/util-migrate.vala"
				_inner_error0_ = NULL;
#line 70 "../src/client/util/util-migrate.vala"
				_tmp25_ = e;
#line 70 "../src/client/util/util-migrate.vala"
				_tmp26_ = _tmp25_->message;
#line 70 "../src/client/util/util-migrate.vala"
				g_debug ("util-migrate.vala:70: Cannot make directory, %s", _tmp26_);
#line 71 "../src/client/util/util-migrate.vala"
				_g_error_free0 (e);
#line 71 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (_tmp3_);
#line 71 "../src/client/util/util-migrate.vala"
				continue;
#line 381 "util-migrate.c"
			}
			__finally0:
#line 67 "../src/client/util/util-migrate.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 67 "../src/client/util/util-migrate.vala"
				g_propagate_error (error, _inner_error0_);
#line 67 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (_tmp3_);
#line 67 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (is_migrated);
#line 67 "../src/client/util/util-migrate.vala"
				_g_free0 (email);
#line 67 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (info);
#line 67 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (_tmp0_);
#line 67 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (enumerator);
#line 67 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (old_config_file);
#line 67 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (new_config_file);
#line 67 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (old_data_dir);
#line 67 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (new_config_dir);
#line 67 "../src/client/util/util-migrate.vala"
				return;
#line 410 "util-migrate.c"
			}
		}
#line 75 "../src/client/util/util-migrate.vala"
		_tmp27_ = new_config_dir;
#line 75 "../src/client/util/util-migrate.vala"
		_tmp28_ = g_file_get_child (_tmp27_, UTIL_MIGRATE_SETTINGS_FILENAME);
#line 75 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (new_config_file);
#line 75 "../src/client/util/util-migrate.vala"
		new_config_file = _tmp28_;
#line 76 "../src/client/util/util-migrate.vala"
		_tmp29_ = new_config_file;
#line 76 "../src/client/util/util-migrate.vala"
		if (g_file_query_exists (_tmp29_, NULL)) {
#line 77 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp3_);
#line 77 "../src/client/util/util-migrate.vala"
			continue;
#line 429 "util-migrate.c"
		}
		{
			GFile* _tmp30_;
			GFile* _tmp31_;
#line 80 "../src/client/util/util-migrate.vala"
			_tmp30_ = old_config_file;
#line 80 "../src/client/util/util-migrate.vala"
			_tmp31_ = new_config_file;
#line 80 "../src/client/util/util-migrate.vala"
			g_file_copy (_tmp30_, _tmp31_, G_FILE_COPY_NONE, NULL, NULL, NULL, &_inner_error0_);
#line 80 "../src/client/util/util-migrate.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 442 "util-migrate.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			GFile* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
#line 79 "../src/client/util/util-migrate.vala"
			g_clear_error (&_inner_error0_);
#line 82 "../src/client/util/util-migrate.vala"
			_tmp32_ = new_config_dir;
#line 82 "../src/client/util/util-migrate.vala"
			_tmp33_ = g_file_get_path (_tmp32_);
#line 82 "../src/client/util/util-migrate.vala"
			_tmp34_ = _tmp33_;
#line 82 "../src/client/util/util-migrate.vala"
			g_debug ("util-migrate.vala:82: Error copying over to %s", _tmp34_);
#line 82 "../src/client/util/util-migrate.vala"
			_g_free0 (_tmp34_);
#line 83 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp3_);
#line 83 "../src/client/util/util-migrate.vala"
			continue;
#line 468 "util-migrate.c"
		}
		__finally1:
#line 79 "../src/client/util/util-migrate.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 79 "../src/client/util/util-migrate.vala"
			g_propagate_error (error, _inner_error0_);
#line 79 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp3_);
#line 79 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (is_migrated);
#line 79 "../src/client/util/util-migrate.vala"
			_g_free0 (email);
#line 79 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (info);
#line 79 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp0_);
#line 79 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (enumerator);
#line 79 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (old_config_file);
#line 79 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_file);
#line 79 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (old_data_dir);
#line 79 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_dir);
#line 79 "../src/client/util/util-migrate.vala"
			return;
#line 497 "util-migrate.c"
		}
#line 85 "../src/client/util/util-migrate.vala"
		_tmp35_ = g_key_file_new ();
#line 85 "../src/client/util/util-migrate.vala"
		key_file = _tmp35_;
#line 503 "util-migrate.c"
		{
			GKeyFile* _tmp36_;
			GFile* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
#line 87 "../src/client/util/util-migrate.vala"
			_tmp36_ = key_file;
#line 87 "../src/client/util/util-migrate.vala"
			_tmp37_ = new_config_file;
#line 87 "../src/client/util/util-migrate.vala"
			_tmp38_ = g_file_get_path (_tmp37_);
#line 87 "../src/client/util/util-migrate.vala"
			_tmp39_ = _tmp38_;
#line 87 "../src/client/util/util-migrate.vala"
			g_key_file_load_from_file (_tmp36_, _tmp39_, G_KEY_FILE_NONE, &_inner_error0_);
#line 87 "../src/client/util/util-migrate.vala"
			_g_free0 (_tmp39_);
#line 87 "../src/client/util/util-migrate.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 523 "util-migrate.c"
				goto __catch2_g_error;
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GFile* _tmp40_;
			gchar* _tmp41_;
			gchar* _tmp42_;
#line 86 "../src/client/util/util-migrate.vala"
			g_clear_error (&_inner_error0_);
#line 89 "../src/client/util/util-migrate.vala"
			_tmp40_ = new_config_file;
#line 89 "../src/client/util/util-migrate.vala"
			_tmp41_ = g_file_get_path (_tmp40_);
#line 89 "../src/client/util/util-migrate.vala"
			_tmp42_ = _tmp41_;
#line 89 "../src/client/util/util-migrate.vala"
			g_debug ("util-migrate.vala:89: Error opening %s", _tmp42_);
#line 89 "../src/client/util/util-migrate.vala"
			_g_free0 (_tmp42_);
#line 90 "../src/client/util/util-migrate.vala"
			_g_key_file_unref0 (key_file);
#line 90 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp3_);
#line 90 "../src/client/util/util-migrate.vala"
			continue;
#line 551 "util-migrate.c"
		}
		__finally2:
#line 86 "../src/client/util/util-migrate.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 86 "../src/client/util/util-migrate.vala"
			g_propagate_error (error, _inner_error0_);
#line 86 "../src/client/util/util-migrate.vala"
			_g_key_file_unref0 (key_file);
#line 86 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp3_);
#line 86 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (is_migrated);
#line 86 "../src/client/util/util-migrate.vala"
			_g_free0 (email);
#line 86 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (info);
#line 86 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp0_);
#line 86 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (enumerator);
#line 86 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (old_config_file);
#line 86 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_file);
#line 86 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (old_data_dir);
#line 86 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_dir);
#line 86 "../src/client/util/util-migrate.vala"
			return;
#line 582 "util-migrate.c"
		}
#line 94 "../src/client/util/util-migrate.vala"
		_tmp43_ = key_file;
#line 94 "../src/client/util/util-migrate.vala"
		_tmp44_ = email;
#line 94 "../src/client/util/util-migrate.vala"
		g_key_file_set_value (_tmp43_, UTIL_MIGRATE_GROUP, UTIL_MIGRATE_PRIMARY_EMAIL_KEY, _tmp44_);
#line 95 "../src/client/util/util-migrate.vala"
		_tmp45_ = key_file;
#line 95 "../src/client/util/util-migrate.vala"
		_tmp46_ = g_key_file_to_data (_tmp45_, NULL, NULL);
#line 95 "../src/client/util/util-migrate.vala"
		data = _tmp46_;
#line 596 "util-migrate.c"
		{
			GFile* _tmp47_;
			const gchar* _tmp48_;
			guint8* _tmp49_;
			gint _tmp49__length1;
			gint _tmp50_ = 0;
			guint8* _tmp51_;
			gint _tmp51__length1;
#line 97 "../src/client/util/util-migrate.vala"
			_tmp47_ = new_config_file;
#line 97 "../src/client/util/util-migrate.vala"
			_tmp48_ = data;
#line 97 "../src/client/util/util-migrate.vala"
			_tmp49_ = string_get_data (_tmp48_, &_tmp50_);
#line 97 "../src/client/util/util-migrate.vala"
			_tmp49__length1 = _tmp50_;
#line 97 "../src/client/util/util-migrate.vala"
			_tmp51_ = _tmp49_;
#line 97 "../src/client/util/util-migrate.vala"
			_tmp51__length1 = _tmp49__length1;
#line 97 "../src/client/util/util-migrate.vala"
			g_file_replace_contents (_tmp47_, (const char*) _tmp51_, (gsize) _tmp51__length1, NULL, FALSE, G_FILE_CREATE_NONE, NULL, NULL, &_inner_error0_);
#line 97 "../src/client/util/util-migrate.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 621 "util-migrate.c"
				goto __catch3_g_error;
			}
		}
		goto __finally3;
		__catch3_g_error:
		{
			const gchar* _tmp52_;
#line 96 "../src/client/util/util-migrate.vala"
			g_clear_error (&_inner_error0_);
#line 100 "../src/client/util/util-migrate.vala"
			_tmp52_ = email;
#line 100 "../src/client/util/util-migrate.vala"
			g_debug ("util-migrate.vala:100: Error writing email %s to config file", _tmp52_);
#line 101 "../src/client/util/util-migrate.vala"
			_g_free0 (data);
#line 101 "../src/client/util/util-migrate.vala"
			_g_key_file_unref0 (key_file);
#line 101 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp3_);
#line 101 "../src/client/util/util-migrate.vala"
			continue;
#line 643 "util-migrate.c"
		}
		__finally3:
#line 96 "../src/client/util/util-migrate.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 96 "../src/client/util/util-migrate.vala"
			g_propagate_error (error, _inner_error0_);
#line 96 "../src/client/util/util-migrate.vala"
			_g_free0 (data);
#line 96 "../src/client/util/util-migrate.vala"
			_g_key_file_unref0 (key_file);
#line 96 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp3_);
#line 96 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (is_migrated);
#line 96 "../src/client/util/util-migrate.vala"
			_g_free0 (email);
#line 96 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (info);
#line 96 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp0_);
#line 96 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (enumerator);
#line 96 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (old_config_file);
#line 96 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_file);
#line 96 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (old_data_dir);
#line 96 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_dir);
#line 96 "../src/client/util/util-migrate.vala"
			return;
#line 676 "util-migrate.c"
		}
#line 103 "../src/client/util/util-migrate.vala"
		_tmp53_ = is_migrated;
#line 103 "../src/client/util/util-migrate.vala"
		_tmp54_ = g_file_create (_tmp53_, G_FILE_CREATE_PRIVATE, NULL, &_inner_error0_);
#line 103 "../src/client/util/util-migrate.vala"
		_tmp55_ = _tmp54_;
#line 103 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (_tmp55_);
#line 103 "../src/client/util/util-migrate.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 103 "../src/client/util/util-migrate.vala"
			g_propagate_error (error, _inner_error0_);
#line 103 "../src/client/util/util-migrate.vala"
			_g_free0 (data);
#line 103 "../src/client/util/util-migrate.vala"
			_g_key_file_unref0 (key_file);
#line 103 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp3_);
#line 103 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (is_migrated);
#line 103 "../src/client/util/util-migrate.vala"
			_g_free0 (email);
#line 103 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (info);
#line 103 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp0_);
#line 103 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (enumerator);
#line 103 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (old_config_file);
#line 103 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_file);
#line 103 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (old_data_dir);
#line 103 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_dir);
#line 103 "../src/client/util/util-migrate.vala"
			return;
#line 716 "util-migrate.c"
		}
#line 43 "../src/client/util/util-migrate.vala"
		_g_free0 (data);
#line 43 "../src/client/util/util-migrate.vala"
		_g_key_file_unref0 (key_file);
#line 43 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (_tmp3_);
#line 724 "util-migrate.c"
	}
#line 24 "../src/client/util/util-migrate.vala"
	_g_object_unref0 (is_migrated);
#line 24 "../src/client/util/util-migrate.vala"
	_g_free0 (email);
#line 24 "../src/client/util/util-migrate.vala"
	_g_object_unref0 (info);
#line 24 "../src/client/util/util-migrate.vala"
	_g_object_unref0 (_tmp0_);
#line 24 "../src/client/util/util-migrate.vala"
	_g_object_unref0 (enumerator);
#line 24 "../src/client/util/util-migrate.vala"
	_g_object_unref0 (old_config_file);
#line 24 "../src/client/util/util-migrate.vala"
	_g_object_unref0 (new_config_file);
#line 24 "../src/client/util/util-migrate.vala"
	_g_object_unref0 (old_data_dir);
#line 24 "../src/client/util/util-migrate.vala"
	_g_object_unref0 (new_config_dir);
#line 744 "util-migrate.c"
}

/**
     * Migrates configuration from release build locations.
     *
     * This will migrate configuration from release build locations to
     * the current config directory, if and only if the current config
     * directory is empty. For example, from the standard
     * distro-package config location to the current Flatpak location,
     * or from either to a development config location.
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 122 "../src/client/util/util-migrate.vala"
	return self ? g_object_ref (self) : NULL;
#line 761 "util-migrate.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 146 "../src/client/util/util-migrate.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 769 "util-migrate.c"
}

void
util_migrate_release_config (GFile** search_path,
                             gint search_path_length1,
                             GFile* config_dir,
                             GError** error)
{
	GError* _inner_error0_ = NULL;
#line 116 "../src/client/util/util-migrate.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (config_dir, g_file_get_type ()));
#line 119 "../src/client/util/util-migrate.vala"
	if (util_migrate_is_directory_empty (config_dir)) {
#line 783 "util-migrate.c"
		GFile* most_recent = NULL;
		GDateTime* most_recent_modified = NULL;
		GFile* _tmp22_;
#line 120 "../src/client/util/util-migrate.vala"
		most_recent = NULL;
#line 121 "../src/client/util/util-migrate.vala"
		most_recent_modified = NULL;
#line 791 "util-migrate.c"
		{
			GFile** source_collection = NULL;
			gint source_collection_length1 = 0;
			gint _source_collection_size_ = 0;
			gint source_it = 0;
#line 122 "../src/client/util/util-migrate.vala"
			source_collection = search_path;
#line 122 "../src/client/util/util-migrate.vala"
			source_collection_length1 = search_path_length1;
#line 122 "../src/client/util/util-migrate.vala"
			for (source_it = 0; source_it < source_collection_length1; source_it = source_it + 1) {
#line 803 "util-migrate.c"
				GFile* _tmp0_;
				GFile* source = NULL;
#line 122 "../src/client/util/util-migrate.vala"
				_tmp0_ = _g_object_ref0 (source_collection[source_it]);
#line 122 "../src/client/util/util-migrate.vala"
				source = _tmp0_;
#line 810 "util-migrate.c"
				{
					GFile* _tmp1_;
#line 123 "../src/client/util/util-migrate.vala"
					_tmp1_ = source;
#line 123 "../src/client/util/util-migrate.vala"
					if (!g_file_equal (_tmp1_, config_dir)) {
#line 817 "util-migrate.c"
						GDateTime* src_modified = NULL;
						gboolean _tmp12_ = FALSE;
						GDateTime* _tmp13_;
#line 124 "../src/client/util/util-migrate.vala"
						src_modified = NULL;
#line 823 "util-migrate.c"
						{
							GFileInfo* src_info = NULL;
							GFile* _tmp2_;
							GFileInfo* _tmp3_;
							GFileInfo* _tmp4_;
#line 126 "../src/client/util/util-migrate.vala"
							_tmp2_ = source;
#line 126 "../src/client/util/util-migrate.vala"
							_tmp3_ = g_file_query_info (_tmp2_, G_FILE_ATTRIBUTE_TIME_MODIFIED, 0, NULL, &_inner_error0_);
#line 126 "../src/client/util/util-migrate.vala"
							src_info = _tmp3_;
#line 126 "../src/client/util/util-migrate.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 126 "../src/client/util/util-migrate.vala"
								if (g_error_matches (_inner_error0_, G_IO_ERROR, G_IO_ERROR_NOT_FOUND)) {
#line 839 "util-migrate.c"
									goto __catch0_g_io_error_not_found;
								}
								goto __catch0_g_error;
							}
#line 129 "../src/client/util/util-migrate.vala"
							_tmp4_ = src_info;
#line 129 "../src/client/util/util-migrate.vala"
							if (_tmp4_ != NULL) {
#line 848 "util-migrate.c"
								GFileInfo* _tmp5_;
								GDateTime* _tmp6_;
#line 130 "../src/client/util/util-migrate.vala"
								_tmp5_ = src_info;
#line 130 "../src/client/util/util-migrate.vala"
								_tmp6_ = g_file_info_get_modification_date_time (_tmp5_);
#line 130 "../src/client/util/util-migrate.vala"
								_g_date_time_unref0 (src_modified);
#line 130 "../src/client/util/util-migrate.vala"
								src_modified = _tmp6_;
#line 859 "util-migrate.c"
							}
#line 125 "../src/client/util/util-migrate.vala"
							_g_object_unref0 (src_info);
#line 863 "util-migrate.c"
						}
						goto __finally0;
						__catch0_g_io_error_not_found:
						{
#line 125 "../src/client/util/util-migrate.vala"
							g_clear_error (&_inner_error0_);
#line 870 "util-migrate.c"
						}
						goto __finally0;
						__catch0_g_error:
						{
							GError* err = NULL;
							GFile* _tmp7_;
							gchar* _tmp8_;
							gchar* _tmp9_;
							GError* _tmp10_;
							const gchar* _tmp11_;
#line 125 "../src/client/util/util-migrate.vala"
							err = _inner_error0_;
#line 125 "../src/client/util/util-migrate.vala"
							_inner_error0_ = NULL;
#line 136 "../src/client/util/util-migrate.vala"
							_tmp7_ = source;
#line 136 "../src/client/util/util-migrate.vala"
							_tmp8_ = g_file_get_path (_tmp7_);
#line 136 "../src/client/util/util-migrate.vala"
							_tmp9_ = _tmp8_;
#line 136 "../src/client/util/util-migrate.vala"
							_tmp10_ = err;
#line 136 "../src/client/util/util-migrate.vala"
							_tmp11_ = _tmp10_->message;
#line 136 "../src/client/util/util-migrate.vala"
							g_debug ("util-migrate.vala:136: Error querying release config dir %s: %s", _tmp9_, _tmp11_);
#line 136 "../src/client/util/util-migrate.vala"
							_g_free0 (_tmp9_);
#line 125 "../src/client/util/util-migrate.vala"
							_g_error_free0 (err);
#line 901 "util-migrate.c"
						}
						__finally0:
#line 125 "../src/client/util/util-migrate.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 125 "../src/client/util/util-migrate.vala"
							g_propagate_error (error, _inner_error0_);
#line 125 "../src/client/util/util-migrate.vala"
							_g_date_time_unref0 (src_modified);
#line 125 "../src/client/util/util-migrate.vala"
							_g_object_unref0 (source);
#line 125 "../src/client/util/util-migrate.vala"
							_g_date_time_unref0 (most_recent_modified);
#line 125 "../src/client/util/util-migrate.vala"
							_g_object_unref0 (most_recent);
#line 125 "../src/client/util/util-migrate.vala"
							return;
#line 918 "util-migrate.c"
						}
#line 142 "../src/client/util/util-migrate.vala"
						_tmp13_ = most_recent_modified;
#line 142 "../src/client/util/util-migrate.vala"
						if (_tmp13_ == NULL) {
#line 142 "../src/client/util/util-migrate.vala"
							_tmp12_ = TRUE;
#line 926 "util-migrate.c"
						} else {
							gboolean _tmp14_ = FALSE;
							GDateTime* _tmp15_;
#line 143 "../src/client/util/util-migrate.vala"
							_tmp15_ = src_modified;
#line 143 "../src/client/util/util-migrate.vala"
							if (_tmp15_ != NULL) {
#line 934 "util-migrate.c"
								GDateTime* _tmp16_;
								GDateTime* _tmp17_;
#line 144 "../src/client/util/util-migrate.vala"
								_tmp16_ = most_recent_modified;
#line 144 "../src/client/util/util-migrate.vala"
								_tmp17_ = src_modified;
#line 144 "../src/client/util/util-migrate.vala"
								_tmp14_ = g_date_time_compare (_tmp16_, _tmp17_) < 0;
#line 943 "util-migrate.c"
							} else {
#line 143 "../src/client/util/util-migrate.vala"
								_tmp14_ = FALSE;
#line 947 "util-migrate.c"
							}
#line 143 "../src/client/util/util-migrate.vala"
							_tmp12_ = _tmp14_;
#line 951 "util-migrate.c"
						}
#line 142 "../src/client/util/util-migrate.vala"
						if (_tmp12_) {
#line 955 "util-migrate.c"
							GFile* _tmp18_;
							GFile* _tmp19_;
							GDateTime* _tmp20_;
							GDateTime* _tmp21_;
#line 145 "../src/client/util/util-migrate.vala"
							_tmp18_ = source;
#line 145 "../src/client/util/util-migrate.vala"
							_tmp19_ = _g_object_ref0 (_tmp18_);
#line 145 "../src/client/util/util-migrate.vala"
							_g_object_unref0 (most_recent);
#line 145 "../src/client/util/util-migrate.vala"
							most_recent = _tmp19_;
#line 146 "../src/client/util/util-migrate.vala"
							_tmp20_ = src_modified;
#line 146 "../src/client/util/util-migrate.vala"
							_tmp21_ = _g_date_time_ref0 (_tmp20_);
#line 146 "../src/client/util/util-migrate.vala"
							_g_date_time_unref0 (most_recent_modified);
#line 146 "../src/client/util/util-migrate.vala"
							most_recent_modified = _tmp21_;
#line 976 "util-migrate.c"
						}
#line 123 "../src/client/util/util-migrate.vala"
						_g_date_time_unref0 (src_modified);
#line 980 "util-migrate.c"
					}
#line 122 "../src/client/util/util-migrate.vala"
					_g_object_unref0 (source);
#line 984 "util-migrate.c"
				}
			}
		}
#line 151 "../src/client/util/util-migrate.vala"
		_tmp22_ = most_recent;
#line 151 "../src/client/util/util-migrate.vala"
		if (_tmp22_ != NULL) {
#line 992 "util-migrate.c"
			{
				GFile* _tmp23_;
				gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				GFile* _tmp28_;
#line 153 "../src/client/util/util-migrate.vala"
				_tmp23_ = most_recent;
#line 153 "../src/client/util/util-migrate.vala"
				_tmp24_ = g_file_get_path (_tmp23_);
#line 153 "../src/client/util/util-migrate.vala"
				_tmp25_ = _tmp24_;
#line 153 "../src/client/util/util-migrate.vala"
				_tmp26_ = g_file_get_path (config_dir);
#line 153 "../src/client/util/util-migrate.vala"
				_tmp27_ = _tmp26_;
#line 153 "../src/client/util/util-migrate.vala"
				g_debug ("util-migrate.vala:153: Migrating release config from %s to %s", _tmp25_, _tmp27_);
#line 153 "../src/client/util/util-migrate.vala"
				_g_free0 (_tmp27_);
#line 153 "../src/client/util/util-migrate.vala"
				_g_free0 (_tmp25_);
#line 158 "../src/client/util/util-migrate.vala"
				_tmp28_ = most_recent;
#line 158 "../src/client/util/util-migrate.vala"
				util_migrate_recursive_copy (_tmp28_, config_dir, NULL, &_inner_error0_);
#line 158 "../src/client/util/util-migrate.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1022 "util-migrate.c"
					goto __catch1_g_error;
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* err = NULL;
				GError* _tmp29_;
				const gchar* _tmp30_;
#line 152 "../src/client/util/util-migrate.vala"
				err = _inner_error0_;
#line 152 "../src/client/util/util-migrate.vala"
				_inner_error0_ = NULL;
#line 160 "../src/client/util/util-migrate.vala"
				_tmp29_ = err;
#line 160 "../src/client/util/util-migrate.vala"
				_tmp30_ = _tmp29_->message;
#line 160 "../src/client/util/util-migrate.vala"
				g_debug ("util-migrate.vala:160: Error migrating release config: %s", _tmp30_);
#line 152 "../src/client/util/util-migrate.vala"
				_g_error_free0 (err);
#line 1044 "util-migrate.c"
			}
			__finally1:
#line 152 "../src/client/util/util-migrate.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 152 "../src/client/util/util-migrate.vala"
				g_propagate_error (error, _inner_error0_);
#line 152 "../src/client/util/util-migrate.vala"
				_g_date_time_unref0 (most_recent_modified);
#line 152 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (most_recent);
#line 152 "../src/client/util/util-migrate.vala"
				return;
#line 1057 "util-migrate.c"
			}
		}
#line 119 "../src/client/util/util-migrate.vala"
		_g_date_time_unref0 (most_recent_modified);
#line 119 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (most_recent);
#line 1064 "util-migrate.c"
	}
}

gboolean
util_migrate_is_directory_empty (GFile* dir)
{
	gboolean is_empty = FALSE;
	GFileEnumerator* existing = NULL;
	GFileEnumerator* _tmp8_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 166 "../src/client/util/util-migrate.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()), FALSE);
#line 167 "../src/client/util/util-migrate.vala"
	is_empty = TRUE;
#line 168 "../src/client/util/util-migrate.vala"
	existing = NULL;
#line 1082 "util-migrate.c"
	{
		GFileEnumerator* _tmp0_ = NULL;
		GFileEnumerator* _tmp1_;
		GFileEnumerator* _tmp2_;
#line 170 "../src/client/util/util-migrate.vala"
		_tmp1_ = g_file_enumerate_children (dir, G_FILE_ATTRIBUTE_STANDARD_TYPE, 0, NULL, &_inner_error0_);
#line 170 "../src/client/util/util-migrate.vala"
		_tmp0_ = _tmp1_;
#line 170 "../src/client/util/util-migrate.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 170 "../src/client/util/util-migrate.vala"
			if (g_error_matches (_inner_error0_, G_IO_ERROR, G_IO_ERROR_NOT_FOUND)) {
#line 1095 "util-migrate.c"
				goto __catch0_g_io_error_not_found;
			}
			goto __catch0_g_error;
		}
#line 170 "../src/client/util/util-migrate.vala"
		_tmp2_ = _tmp0_;
#line 170 "../src/client/util/util-migrate.vala"
		_tmp0_ = NULL;
#line 170 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (existing);
#line 170 "../src/client/util/util-migrate.vala"
		existing = _tmp2_;
#line 169 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (_tmp0_);
#line 1110 "util-migrate.c"
	}
	goto __finally0;
	__catch0_g_io_error_not_found:
	{
#line 169 "../src/client/util/util-migrate.vala"
		g_clear_error (&_inner_error0_);
#line 1117 "util-migrate.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 169 "../src/client/util/util-migrate.vala"
		err = _inner_error0_;
#line 169 "../src/client/util/util-migrate.vala"
		_inner_error0_ = NULL;
#line 176 "../src/client/util/util-migrate.vala"
		_tmp3_ = g_file_get_path (dir);
#line 176 "../src/client/util/util-migrate.vala"
		_tmp4_ = _tmp3_;
#line 176 "../src/client/util/util-migrate.vala"
		_tmp5_ = err;
#line 176 "../src/client/util/util-migrate.vala"
		_tmp6_ = _tmp5_->message;
#line 176 "../src/client/util/util-migrate.vala"
		g_debug ("util-migrate.vala:176: Error enumerating directory %s: %s", _tmp4_, _tmp6_);
#line 176 "../src/client/util/util-migrate.vala"
		_g_free0 (_tmp4_);
#line 169 "../src/client/util/util-migrate.vala"
		_g_error_free0 (err);
#line 1145 "util-migrate.c"
	}
	__finally0:
#line 169 "../src/client/util/util-migrate.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1150 "util-migrate.c"
		gboolean _tmp7_ = FALSE;
#line 169 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (existing);
#line 169 "../src/client/util/util-migrate.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 169 "../src/client/util/util-migrate.vala"
		g_clear_error (&_inner_error0_);
#line 169 "../src/client/util/util-migrate.vala"
		return _tmp7_;
#line 1160 "util-migrate.c"
	}
#line 183 "../src/client/util/util-migrate.vala"
	_tmp8_ = existing;
#line 183 "../src/client/util/util-migrate.vala"
	if (_tmp8_ != NULL) {
#line 1166 "util-migrate.c"
		{
			GFileInfo* _tmp9_ = NULL;
			GFileEnumerator* _tmp10_;
			GFileInfo* _tmp11_;
#line 185 "../src/client/util/util-migrate.vala"
			_tmp10_ = existing;
#line 185 "../src/client/util/util-migrate.vala"
			_tmp11_ = g_file_enumerator_next_file (_tmp10_, NULL, &_inner_error0_);
#line 185 "../src/client/util/util-migrate.vala"
			_tmp9_ = _tmp11_;
#line 185 "../src/client/util/util-migrate.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1179 "util-migrate.c"
				goto __catch1_g_error;
			}
#line 185 "../src/client/util/util-migrate.vala"
			is_empty = _tmp9_ == NULL;
#line 184 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp9_);
#line 1186 "util-migrate.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* err = NULL;
			gchar* _tmp12_;
			gchar* _tmp13_;
			GError* _tmp14_;
			const gchar* _tmp15_;
#line 184 "../src/client/util/util-migrate.vala"
			err = _inner_error0_;
#line 184 "../src/client/util/util-migrate.vala"
			_inner_error0_ = NULL;
#line 187 "../src/client/util/util-migrate.vala"
			_tmp12_ = g_file_get_path (dir);
#line 187 "../src/client/util/util-migrate.vala"
			_tmp13_ = _tmp12_;
#line 187 "../src/client/util/util-migrate.vala"
			_tmp14_ = err;
#line 187 "../src/client/util/util-migrate.vala"
			_tmp15_ = _tmp14_->message;
#line 187 "../src/client/util/util-migrate.vala"
			g_debug ("util-migrate.vala:187: Error getting next child in directory %s: %s", _tmp13_, _tmp15_);
#line 187 "../src/client/util/util-migrate.vala"
			_g_free0 (_tmp13_);
#line 184 "../src/client/util/util-migrate.vala"
			_g_error_free0 (err);
#line 1214 "util-migrate.c"
		}
		__finally1:
#line 184 "../src/client/util/util-migrate.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1219 "util-migrate.c"
			gboolean _tmp16_ = FALSE;
#line 184 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (existing);
#line 184 "../src/client/util/util-migrate.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 184 "../src/client/util/util-migrate.vala"
			g_clear_error (&_inner_error0_);
#line 184 "../src/client/util/util-migrate.vala"
			return _tmp16_;
#line 1229 "util-migrate.c"
		}
		{
			GFileEnumerator* _tmp17_;
#line 195 "../src/client/util/util-migrate.vala"
			_tmp17_ = existing;
#line 195 "../src/client/util/util-migrate.vala"
			g_file_enumerator_close (_tmp17_, NULL, &_inner_error0_);
#line 195 "../src/client/util/util-migrate.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1239 "util-migrate.c"
				goto __catch2_g_error;
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* err = NULL;
			gchar* _tmp18_;
			gchar* _tmp19_;
			GError* _tmp20_;
			const gchar* _tmp21_;
#line 194 "../src/client/util/util-migrate.vala"
			err = _inner_error0_;
#line 194 "../src/client/util/util-migrate.vala"
			_inner_error0_ = NULL;
#line 197 "../src/client/util/util-migrate.vala"
			_tmp18_ = g_file_get_path (dir);
#line 197 "../src/client/util/util-migrate.vala"
			_tmp19_ = _tmp18_;
#line 197 "../src/client/util/util-migrate.vala"
			_tmp20_ = err;
#line 197 "../src/client/util/util-migrate.vala"
			_tmp21_ = _tmp20_->message;
#line 197 "../src/client/util/util-migrate.vala"
			g_debug ("util-migrate.vala:197: Error closing directory enumeration %s: %s", _tmp19_, _tmp21_);
#line 197 "../src/client/util/util-migrate.vala"
			_g_free0 (_tmp19_);
#line 194 "../src/client/util/util-migrate.vala"
			_g_error_free0 (err);
#line 1269 "util-migrate.c"
		}
		__finally2:
#line 194 "../src/client/util/util-migrate.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1274 "util-migrate.c"
			gboolean _tmp22_ = FALSE;
#line 194 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (existing);
#line 194 "../src/client/util/util-migrate.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 194 "../src/client/util/util-migrate.vala"
			g_clear_error (&_inner_error0_);
#line 194 "../src/client/util/util-migrate.vala"
			return _tmp22_;
#line 1284 "util-migrate.c"
		}
	}
#line 205 "../src/client/util/util-migrate.vala"
	result = is_empty;
#line 205 "../src/client/util/util-migrate.vala"
	_g_object_unref0 (existing);
#line 205 "../src/client/util/util-migrate.vala"
	return result;
#line 1293 "util-migrate.c"
}

void
util_migrate_recursive_copy (GFile* src,
                             GFile* dest,
                             GCancellable* cancellable,
                             GError** error)
{
	GError* _inner_error0_ = NULL;
#line 208 "../src/client/util/util-migrate.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (src, g_file_get_type ()));
#line 208 "../src/client/util/util-migrate.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dest, g_file_get_type ()));
#line 208 "../src/client/util/util-migrate.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 212 "../src/client/util/util-migrate.vala"
	switch (g_file_query_file_type (src, G_FILE_QUERY_INFO_NONE, cancellable)) {
#line 212 "../src/client/util/util-migrate.vala"
		case G_FILE_TYPE_DIRECTORY:
#line 1313 "util-migrate.c"
		{
			GFileEnumerator* children = NULL;
			GFileEnumerator* _tmp0_;
			GFileInfo* child = NULL;
			GFileEnumerator* _tmp1_;
			GFileInfo* _tmp2_;
			{
#line 215 "../src/client/util/util-migrate.vala"
				g_file_make_directory (dest, cancellable, &_inner_error0_);
#line 215 "../src/client/util/util-migrate.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 215 "../src/client/util/util-migrate.vala"
					if (g_error_matches (_inner_error0_, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
#line 1327 "util-migrate.c"
						goto __catch0_g_io_error_exists;
					}
					goto __finally0;
				}
			}
			goto __finally0;
			__catch0_g_io_error_exists:
			{
#line 214 "../src/client/util/util-migrate.vala"
				g_clear_error (&_inner_error0_);
#line 1338 "util-migrate.c"
			}
			__finally0:
#line 214 "../src/client/util/util-migrate.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 214 "../src/client/util/util-migrate.vala"
				g_propagate_error (error, _inner_error0_);
#line 214 "../src/client/util/util-migrate.vala"
				return;
#line 1347 "util-migrate.c"
			}
#line 219 "../src/client/util/util-migrate.vala"
			g_file_copy_attributes (src, dest, G_FILE_COPY_NONE, cancellable, &_inner_error0_);
#line 219 "../src/client/util/util-migrate.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 219 "../src/client/util/util-migrate.vala"
				g_propagate_error (error, _inner_error0_);
#line 219 "../src/client/util/util-migrate.vala"
				return;
#line 1357 "util-migrate.c"
			}
#line 221 "../src/client/util/util-migrate.vala"
			_tmp0_ = g_file_enumerate_children (src, G_FILE_ATTRIBUTE_STANDARD_NAME, G_FILE_QUERY_INFO_NONE, cancellable, &_inner_error0_);
#line 221 "../src/client/util/util-migrate.vala"
			children = _tmp0_;
#line 221 "../src/client/util/util-migrate.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 221 "../src/client/util/util-migrate.vala"
				g_propagate_error (error, _inner_error0_);
#line 221 "../src/client/util/util-migrate.vala"
				return;
#line 1369 "util-migrate.c"
			}
#line 226 "../src/client/util/util-migrate.vala"
			_tmp1_ = children;
#line 226 "../src/client/util/util-migrate.vala"
			_tmp2_ = g_file_enumerator_next_file (_tmp1_, cancellable, &_inner_error0_);
#line 226 "../src/client/util/util-migrate.vala"
			child = _tmp2_;
#line 226 "../src/client/util/util-migrate.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 226 "../src/client/util/util-migrate.vala"
				g_propagate_error (error, _inner_error0_);
#line 226 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (children);
#line 226 "../src/client/util/util-migrate.vala"
				return;
#line 1385 "util-migrate.c"
			}
#line 227 "../src/client/util/util-migrate.vala"
			while (TRUE) {
#line 1389 "util-migrate.c"
				GFileInfo* _tmp3_;
				GFileInfo* _tmp4_;
				const gchar* _tmp5_;
				GFile* _tmp6_;
				GFile* _tmp7_;
				GFileInfo* _tmp8_;
				const gchar* _tmp9_;
				GFile* _tmp10_;
				GFile* _tmp11_;
				GFileInfo* _tmp12_ = NULL;
				GFileEnumerator* _tmp13_;
				GFileInfo* _tmp14_;
				GFileInfo* _tmp15_;
#line 227 "../src/client/util/util-migrate.vala"
				_tmp3_ = child;
#line 227 "../src/client/util/util-migrate.vala"
				if (!(_tmp3_ != NULL)) {
#line 227 "../src/client/util/util-migrate.vala"
					break;
#line 1409 "util-migrate.c"
				}
#line 228 "../src/client/util/util-migrate.vala"
				_tmp4_ = child;
#line 228 "../src/client/util/util-migrate.vala"
				_tmp5_ = g_file_info_get_name (_tmp4_);
#line 228 "../src/client/util/util-migrate.vala"
				_tmp6_ = g_file_get_child (src, _tmp5_);
#line 228 "../src/client/util/util-migrate.vala"
				_tmp7_ = _tmp6_;
#line 228 "../src/client/util/util-migrate.vala"
				_tmp8_ = child;
#line 228 "../src/client/util/util-migrate.vala"
				_tmp9_ = g_file_info_get_name (_tmp8_);
#line 228 "../src/client/util/util-migrate.vala"
				_tmp10_ = g_file_get_child (dest, _tmp9_);
#line 228 "../src/client/util/util-migrate.vala"
				_tmp11_ = _tmp10_;
#line 228 "../src/client/util/util-migrate.vala"
				util_migrate_recursive_copy (_tmp7_, _tmp11_, NULL, &_inner_error0_);
#line 228 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (_tmp11_);
#line 228 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (_tmp7_);
#line 228 "../src/client/util/util-migrate.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 228 "../src/client/util/util-migrate.vala"
					g_propagate_error (error, _inner_error0_);
#line 228 "../src/client/util/util-migrate.vala"
					_g_object_unref0 (child);
#line 228 "../src/client/util/util-migrate.vala"
					_g_object_unref0 (children);
#line 228 "../src/client/util/util-migrate.vala"
					return;
#line 1443 "util-migrate.c"
				}
#line 232 "../src/client/util/util-migrate.vala"
				_tmp13_ = children;
#line 232 "../src/client/util/util-migrate.vala"
				_tmp14_ = g_file_enumerator_next_file (_tmp13_, cancellable, &_inner_error0_);
#line 232 "../src/client/util/util-migrate.vala"
				_tmp12_ = _tmp14_;
#line 232 "../src/client/util/util-migrate.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 232 "../src/client/util/util-migrate.vala"
					g_propagate_error (error, _inner_error0_);
#line 232 "../src/client/util/util-migrate.vala"
					_g_object_unref0 (child);
#line 232 "../src/client/util/util-migrate.vala"
					_g_object_unref0 (children);
#line 232 "../src/client/util/util-migrate.vala"
					return;
#line 1461 "util-migrate.c"
				}
#line 232 "../src/client/util/util-migrate.vala"
				_tmp15_ = _tmp12_;
#line 232 "../src/client/util/util-migrate.vala"
				_tmp12_ = NULL;
#line 232 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (child);
#line 232 "../src/client/util/util-migrate.vala"
				child = _tmp15_;
#line 227 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (_tmp12_);
#line 1473 "util-migrate.c"
			}
#line 234 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (child);
#line 234 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (children);
#line 234 "../src/client/util/util-migrate.vala"
			break;
#line 1481 "util-migrate.c"
		}
#line 212 "../src/client/util/util-migrate.vala"
		case G_FILE_TYPE_REGULAR:
#line 1485 "util-migrate.c"
		{
#line 237 "../src/client/util/util-migrate.vala"
			g_file_copy (src, dest, G_FILE_COPY_NONE, cancellable, NULL, NULL, &_inner_error0_);
#line 237 "../src/client/util/util-migrate.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 237 "../src/client/util/util-migrate.vala"
				g_propagate_error (error, _inner_error0_);
#line 237 "../src/client/util/util-migrate.vala"
				return;
#line 1495 "util-migrate.c"
			}
#line 238 "../src/client/util/util-migrate.vala"
			break;
#line 1499 "util-migrate.c"
		}
		default:
		{
#line 242 "../src/client/util/util-migrate.vala"
			break;
#line 1505 "util-migrate.c"
		}
	}
}

static gpointer
_g_settings_schema_source_ref0 (gpointer self)
{
#line 250 "../src/client/util/util-migrate.vala"
	return self ? g_settings_schema_source_ref (self) : NULL;
#line 1515 "util-migrate.c"
}

void
util_migrate_old_app_config (GSettings* newSettings,
                             const gchar* old_app_id)
{
	GSettingsSchemaSource* schemaSource = NULL;
	GSettingsSchemaSource* _tmp0_;
	GSettingsSchemaSource* _tmp1_;
	GSettingsSchema* oldSettingsSchema = NULL;
	GSettingsSchemaSource* _tmp5_;
	GSettingsSchema* _tmp6_;
	GSettingsSchema* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 249 "../src/client/util/util-migrate.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (newSettings, g_settings_get_type ()));
#line 249 "../src/client/util/util-migrate.vala"
	g_return_if_fail (old_app_id != NULL);
#line 250 "../src/client/util/util-migrate.vala"
	_tmp0_ = g_settings_schema_source_get_default ();
#line 250 "../src/client/util/util-migrate.vala"
	_tmp1_ = _g_settings_schema_source_ref0 (_tmp0_);
#line 250 "../src/client/util/util-migrate.vala"
	schemaSource = _tmp1_;
#line 251 "../src/client/util/util-migrate.vala"
	if (APPLICATION_CLIENT_GSETTINGS_DIR != NULL) {
#line 1542 "util-migrate.c"
		{
			GSettingsSchemaSource* _tmp2_ = NULL;
			GSettingsSchemaSource* _tmp3_;
			GSettingsSchemaSource* _tmp4_;
#line 253 "../src/client/util/util-migrate.vala"
			_tmp3_ = g_settings_schema_source_new_from_directory (APPLICATION_CLIENT_GSETTINGS_DIR, NULL, FALSE, &_inner_error0_);
#line 253 "../src/client/util/util-migrate.vala"
			_tmp2_ = _tmp3_;
#line 253 "../src/client/util/util-migrate.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1553 "util-migrate.c"
				goto __catch0_g_error;
			}
#line 253 "../src/client/util/util-migrate.vala"
			_tmp4_ = _tmp2_;
#line 253 "../src/client/util/util-migrate.vala"
			_tmp2_ = NULL;
#line 253 "../src/client/util/util-migrate.vala"
			_g_settings_schema_source_unref0 (schemaSource);
#line 253 "../src/client/util/util-migrate.vala"
			schemaSource = _tmp4_;
#line 252 "../src/client/util/util-migrate.vala"
			_g_settings_schema_source_unref0 (_tmp2_);
#line 1566 "util-migrate.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 252 "../src/client/util/util-migrate.vala"
			g_clear_error (&_inner_error0_);
#line 1573 "util-migrate.c"
		}
		__finally0:
#line 252 "../src/client/util/util-migrate.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 252 "../src/client/util/util-migrate.vala"
			_g_settings_schema_source_unref0 (schemaSource);
#line 252 "../src/client/util/util-migrate.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 252 "../src/client/util/util-migrate.vala"
			g_clear_error (&_inner_error0_);
#line 252 "../src/client/util/util-migrate.vala"
			return;
#line 1586 "util-migrate.c"
		}
	}
#line 258 "../src/client/util/util-migrate.vala"
	_tmp5_ = schemaSource;
#line 258 "../src/client/util/util-migrate.vala"
	_tmp6_ = g_settings_schema_source_lookup (_tmp5_, old_app_id, FALSE);
#line 258 "../src/client/util/util-migrate.vala"
	oldSettingsSchema = _tmp6_;
#line 260 "../src/client/util/util-migrate.vala"
	if (g_settings_get_boolean (newSettings, UTIL_MIGRATE_MIGRATED_CONFIG_KEY)) {
#line 261 "../src/client/util/util-migrate.vala"
		_g_settings_schema_unref0 (oldSettingsSchema);
#line 261 "../src/client/util/util-migrate.vala"
		_g_settings_schema_source_unref0 (schemaSource);
#line 261 "../src/client/util/util-migrate.vala"
		return;
#line 1603 "util-migrate.c"
	}
#line 263 "../src/client/util/util-migrate.vala"
	_tmp7_ = oldSettingsSchema;
#line 263 "../src/client/util/util-migrate.vala"
	if (_tmp7_ != NULL) {
#line 1609 "util-migrate.c"
		GSettings* oldSettings = NULL;
		GSettingsSchema* _tmp8_;
		GSettings* _tmp9_;
		GSettingsSchema* _tmp10_;
		GSettingsSchema* _tmp11_;
		GSettingsSchema* _tmp12_;
		gchar** _tmp13_;
		gchar** _tmp14_;
		gchar** _tmp15_;
		gint _tmp15__length1;
#line 264 "../src/client/util/util-migrate.vala"
		_tmp8_ = oldSettingsSchema;
#line 264 "../src/client/util/util-migrate.vala"
		_tmp9_ = g_settings_new_full (_tmp8_, NULL, NULL);
#line 264 "../src/client/util/util-migrate.vala"
		oldSettings = _tmp9_;
#line 265 "../src/client/util/util-migrate.vala"
		g_object_get (newSettings, "settings-schema", &_tmp10_, NULL);
#line 265 "../src/client/util/util-migrate.vala"
		_tmp11_ = _tmp10_;
#line 265 "../src/client/util/util-migrate.vala"
		_tmp12_ = _tmp11_;
#line 265 "../src/client/util/util-migrate.vala"
		_tmp14_ = _tmp13_ = g_settings_schema_list_keys (_tmp12_);
#line 265 "../src/client/util/util-migrate.vala"
		_tmp15_ = _tmp14_;
#line 265 "../src/client/util/util-migrate.vala"
		_tmp15__length1 = _vala_array_length (_tmp13_);
#line 265 "../src/client/util/util-migrate.vala"
		_g_settings_schema_unref0 (_tmp12_);
#line 1640 "util-migrate.c"
		{
			gchar** key_collection = NULL;
			gint key_collection_length1 = 0;
			gint _key_collection_size_ = 0;
			gint key_it = 0;
#line 265 "../src/client/util/util-migrate.vala"
			key_collection = _tmp15_;
#line 265 "../src/client/util/util-migrate.vala"
			key_collection_length1 = _tmp15__length1;
#line 265 "../src/client/util/util-migrate.vala"
			for (key_it = 0; key_it < key_collection_length1; key_it = key_it + 1) {
#line 1652 "util-migrate.c"
				gchar* _tmp16_;
				gchar* key = NULL;
#line 265 "../src/client/util/util-migrate.vala"
				_tmp16_ = g_strdup (key_collection[key_it]);
#line 265 "../src/client/util/util-migrate.vala"
				key = _tmp16_;
#line 1659 "util-migrate.c"
				{
					GSettingsSchema* _tmp17_;
					const gchar* _tmp18_;
#line 266 "../src/client/util/util-migrate.vala"
					_tmp17_ = oldSettingsSchema;
#line 266 "../src/client/util/util-migrate.vala"
					_tmp18_ = key;
#line 266 "../src/client/util/util-migrate.vala"
					if (g_settings_schema_has_key (_tmp17_, _tmp18_)) {
#line 1669 "util-migrate.c"
						const gchar* _tmp19_;
						GSettings* _tmp20_;
						const gchar* _tmp21_;
						GVariant* _tmp22_;
						GVariant* _tmp23_;
#line 267 "../src/client/util/util-migrate.vala"
						_tmp19_ = key;
#line 267 "../src/client/util/util-migrate.vala"
						_tmp20_ = oldSettings;
#line 267 "../src/client/util/util-migrate.vala"
						_tmp21_ = key;
#line 267 "../src/client/util/util-migrate.vala"
						_tmp22_ = g_settings_get_value (_tmp20_, _tmp21_);
#line 267 "../src/client/util/util-migrate.vala"
						_tmp23_ = _tmp22_;
#line 267 "../src/client/util/util-migrate.vala"
						g_settings_set_value (newSettings, _tmp19_, _tmp23_);
#line 267 "../src/client/util/util-migrate.vala"
						_g_variant_unref0 (_tmp23_);
#line 1689 "util-migrate.c"
					}
#line 265 "../src/client/util/util-migrate.vala"
					_g_free0 (key);
#line 1693 "util-migrate.c"
				}
			}
#line 265 "../src/client/util/util-migrate.vala"
			key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1698 "util-migrate.c"
		}
#line 263 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (oldSettings);
#line 1702 "util-migrate.c"
	}
#line 272 "../src/client/util/util-migrate.vala"
	g_settings_set_boolean (newSettings, UTIL_MIGRATE_MIGRATED_CONFIG_KEY, TRUE);
#line 249 "../src/client/util/util-migrate.vala"
	_g_settings_schema_unref0 (oldSettingsSchema);
#line 249 "../src/client/util/util-migrate.vala"
	_g_settings_schema_source_unref0 (schemaSource);
#line 1710 "util-migrate.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

