/* mail-merge-processor.c generated by valac 0.56.17, the Vala compiler
 * generated from mail-merge-processor.vala, do not modify */

/*
 * Copyright © 2020 Michael Gratton <mike@vee.net>.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "util.h"
#include "geary-engine.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define MAIL_MERGE_PROCESSOR_FIELD_START "{{"
#define MAIL_MERGE_PROCESSOR_FIELD_END "}}"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	MAIL_MERGE_PROCESSOR_0_PROPERTY,
	MAIL_MERGE_PROCESSOR_TEMPLATE_PROPERTY,
	MAIL_MERGE_PROCESSOR_EMAIL_PROPERTY,
	MAIL_MERGE_PROCESSOR_MISSING_FIELDS_PROPERTY,
	MAIL_MERGE_PROCESSOR_NUM_PROPERTIES
};
static GParamSpec* mail_merge_processor_properties[MAIL_MERGE_PROCESSOR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define MAIL_MERGE_PROCESSOR_TYPE_PARSER (mail_merge_processor_parser_get_type ())
typedef struct _MailMergeProcessorParser MailMergeProcessorParser;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _MailMergeProcessorPrivate {
	GearyEmail* _template;
	GearyComposedEmail* _email;
	GeeList* _missing_fields;
};

struct _MailMergeProcessorParser {
	const gchar* text;
	gint index;
	gboolean spent;
	gboolean at_field_start;
	gboolean at_field_end;
};

static gint MailMergeProcessor_private_offset;
static gpointer mail_merge_processor_parent_class = NULL;

static GType mail_merge_processor_parser_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static MailMergeProcessorParser* mail_merge_processor_parser_dup (const MailMergeProcessorParser* self);
static void mail_merge_processor_parser_free (MailMergeProcessorParser* self);
static void mail_merge_processor_parser_init (MailMergeProcessorParser *self,
                                       const gchar* text);
static gchar* mail_merge_processor_parser_read_field (MailMergeProcessorParser *self);
static gchar* mail_merge_processor_parser_read_text (MailMergeProcessorParser *self);
static void mail_merge_processor_set_template (MailMergeProcessor* self,
                                        GearyEmail* value);
static void mail_merge_processor_set_email (MailMergeProcessor* self,
                                     GearyComposedEmail* value);
static void mail_merge_processor_set_missing_fields (MailMergeProcessor* self,
                                              GeeList* value);
static inline GearyRFC822MailboxAddresses* mail_merge_processor_format_mailbox_addresses (MailMergeProcessor* self,
                                                                            GearyRFC822MailboxAddresses* addresses,
                                                                            GeeMap* values);
static inline GearyRFC822MailboxAddress* mail_merge_processor_format_mailbox_address (MailMergeProcessor* self,
                                                                        GearyRFC822MailboxAddress* address,
                                                                        GeeMap* values);
static inline gchar* mail_merge_processor_format_string (MailMergeProcessor* self,
                                           const gchar* text,
                                           GeeMap* values);
static void mail_merge_processor_finalize (GObject * obj);
static GType mail_merge_processor_get_type_once (void);
static void _vala_mail_merge_processor_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_mail_merge_processor_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
mail_merge_processor_get_instance_private (MailMergeProcessor* self)
{
	return G_STRUCT_MEMBER_P (self, MailMergeProcessor_private_offset);
}

gchar*
mail_merge_processor_to_field (const gchar* name)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 98 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 99 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp0_ = g_strconcat (MAIL_MERGE_PROCESSOR_FIELD_START, name, NULL);
#line 99 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp1_ = _tmp0_;
#line 99 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp2_ = g_strconcat (_tmp1_, MAIL_MERGE_PROCESSOR_FIELD_END, NULL);
#line 99 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp3_ = _tmp2_;
#line 99 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_g_free0 (_tmp1_);
#line 99 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	result = _tmp3_;
#line 99 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	return result;
#line 128 "mail-merge-processor.c"
}

gboolean
mail_merge_processor_is_mail_merge_template (GearyEmail* email,
                                             GError** error)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	GearyRFC822Subject* _tmp6_;
	GearyRFC822Subject* _tmp7_;
	gboolean found = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 102 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (email, GEARY_TYPE_EMAIL), FALSE);
#line 105 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp6_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 105 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp7_ = _tmp6_;
#line 105 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	if (_tmp7_ != NULL) {
#line 154 "mail-merge-processor.c"
		GearyRFC822Subject* _tmp8_;
		GearyRFC822Subject* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 106 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp8_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 106 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp9_ = _tmp8_;
#line 106 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp10_ = geary_rf_c822_decoded_message_data_to_rfc822_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEARY_RF_C822_TYPE_DECODED_MESSAGE_DATA, GearyRFC822DecodedMessageData));
#line 106 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp11_ = _tmp10_;
#line 106 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp5_ = mail_merge_processor_contains_field (_tmp11_);
#line 106 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_g_free0 (_tmp11_);
#line 171 "mail-merge-processor.c"
	} else {
#line 105 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp5_ = FALSE;
#line 175 "mail-merge-processor.c"
	}
#line 105 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	if (_tmp5_) {
#line 105 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp4_ = TRUE;
#line 181 "mail-merge-processor.c"
	} else {
		gboolean _tmp12_ = FALSE;
		GearyRFC822MailboxAddresses* _tmp13_;
		GearyRFC822MailboxAddresses* _tmp14_;
#line 107 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp13_ = geary_email_header_set_get_to (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 107 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp14_ = _tmp13_;
#line 107 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		if (_tmp14_ != NULL) {
#line 192 "mail-merge-processor.c"
			GearyRFC822MailboxAddresses* _tmp15_;
			GearyRFC822MailboxAddresses* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
#line 108 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp15_ = geary_email_header_set_get_to (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 108 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp16_ = _tmp15_;
#line 108 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp17_ = geary_rf_c822_decoded_message_data_to_rfc822_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEARY_RF_C822_TYPE_DECODED_MESSAGE_DATA, GearyRFC822DecodedMessageData));
#line 108 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp18_ = _tmp17_;
#line 108 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp12_ = mail_merge_processor_contains_field (_tmp18_);
#line 108 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_g_free0 (_tmp18_);
#line 209 "mail-merge-processor.c"
		} else {
#line 107 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp12_ = FALSE;
#line 213 "mail-merge-processor.c"
		}
#line 107 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp4_ = _tmp12_;
#line 217 "mail-merge-processor.c"
	}
#line 105 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	if (_tmp4_) {
#line 105 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp3_ = TRUE;
#line 223 "mail-merge-processor.c"
	} else {
		gboolean _tmp19_ = FALSE;
		GearyRFC822MailboxAddresses* _tmp20_;
		GearyRFC822MailboxAddresses* _tmp21_;
#line 109 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp20_ = geary_email_header_set_get_cc (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 109 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp21_ = _tmp20_;
#line 109 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		if (_tmp21_ != NULL) {
#line 234 "mail-merge-processor.c"
			GearyRFC822MailboxAddresses* _tmp22_;
			GearyRFC822MailboxAddresses* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
#line 110 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp22_ = geary_email_header_set_get_cc (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 110 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp23_ = _tmp22_;
#line 110 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp24_ = geary_rf_c822_decoded_message_data_to_rfc822_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEARY_RF_C822_TYPE_DECODED_MESSAGE_DATA, GearyRFC822DecodedMessageData));
#line 110 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp25_ = _tmp24_;
#line 110 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp19_ = mail_merge_processor_contains_field (_tmp25_);
#line 110 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_g_free0 (_tmp25_);
#line 251 "mail-merge-processor.c"
		} else {
#line 109 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp19_ = FALSE;
#line 255 "mail-merge-processor.c"
		}
#line 109 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp3_ = _tmp19_;
#line 259 "mail-merge-processor.c"
	}
#line 105 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	if (_tmp3_) {
#line 105 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp2_ = TRUE;
#line 265 "mail-merge-processor.c"
	} else {
		gboolean _tmp26_ = FALSE;
		GearyRFC822MailboxAddresses* _tmp27_;
		GearyRFC822MailboxAddresses* _tmp28_;
#line 111 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp27_ = geary_email_header_set_get_bcc (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 111 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp28_ = _tmp27_;
#line 111 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		if (_tmp28_ != NULL) {
#line 276 "mail-merge-processor.c"
			GearyRFC822MailboxAddresses* _tmp29_;
			GearyRFC822MailboxAddresses* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
#line 112 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp29_ = geary_email_header_set_get_bcc (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 112 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp30_ = _tmp29_;
#line 112 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp31_ = geary_rf_c822_decoded_message_data_to_rfc822_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GEARY_RF_C822_TYPE_DECODED_MESSAGE_DATA, GearyRFC822DecodedMessageData));
#line 112 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp32_ = _tmp31_;
#line 112 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp26_ = mail_merge_processor_contains_field (_tmp32_);
#line 112 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_g_free0 (_tmp32_);
#line 293 "mail-merge-processor.c"
		} else {
#line 111 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp26_ = FALSE;
#line 297 "mail-merge-processor.c"
		}
#line 111 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp2_ = _tmp26_;
#line 301 "mail-merge-processor.c"
	}
#line 105 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	if (_tmp2_) {
#line 105 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp1_ = TRUE;
#line 307 "mail-merge-processor.c"
	} else {
		gboolean _tmp33_ = FALSE;
		GearyRFC822MailboxAddresses* _tmp34_;
		GearyRFC822MailboxAddresses* _tmp35_;
#line 113 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp34_ = geary_email_header_set_get_reply_to (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 113 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp35_ = _tmp34_;
#line 113 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		if (_tmp35_ != NULL) {
#line 318 "mail-merge-processor.c"
			GearyRFC822MailboxAddresses* _tmp36_;
			GearyRFC822MailboxAddresses* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
#line 114 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp36_ = geary_email_header_set_get_bcc (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 114 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp37_ = _tmp36_;
#line 114 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp38_ = geary_rf_c822_decoded_message_data_to_rfc822_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, GEARY_RF_C822_TYPE_DECODED_MESSAGE_DATA, GearyRFC822DecodedMessageData));
#line 114 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp39_ = _tmp38_;
#line 114 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp33_ = mail_merge_processor_contains_field (_tmp39_);
#line 114 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_g_free0 (_tmp39_);
#line 335 "mail-merge-processor.c"
		} else {
#line 113 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp33_ = FALSE;
#line 339 "mail-merge-processor.c"
		}
#line 113 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp1_ = _tmp33_;
#line 343 "mail-merge-processor.c"
	}
#line 104 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	if (_tmp1_) {
#line 105 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp0_ = TRUE;
#line 349 "mail-merge-processor.c"
	} else {
		gboolean _tmp40_ = FALSE;
		GearyRFC822MailboxAddress* _tmp41_;
		GearyRFC822MailboxAddress* _tmp42_;
#line 115 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp41_ = geary_email_header_set_get_sender (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 115 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp42_ = _tmp41_;
#line 115 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		if (_tmp42_ != NULL) {
#line 360 "mail-merge-processor.c"
			GearyRFC822MailboxAddress* _tmp43_;
			GearyRFC822MailboxAddress* _tmp44_;
			gchar* _tmp45_;
			gchar* _tmp46_;
#line 116 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp43_ = geary_email_header_set_get_sender (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 116 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp44_ = _tmp43_;
#line 116 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp45_ = geary_rf_c822_decoded_message_data_to_rfc822_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, GEARY_RF_C822_TYPE_DECODED_MESSAGE_DATA, GearyRFC822DecodedMessageData));
#line 116 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp46_ = _tmp45_;
#line 116 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp40_ = mail_merge_processor_contains_field (_tmp46_);
#line 116 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_g_free0 (_tmp46_);
#line 377 "mail-merge-processor.c"
		} else {
#line 115 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp40_ = FALSE;
#line 381 "mail-merge-processor.c"
		}
#line 115 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp0_ = _tmp40_;
#line 385 "mail-merge-processor.c"
	}
#line 104 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	found = _tmp0_;
#line 118 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	if (!found) {
#line 391 "mail-merge-processor.c"
		GearyRFC822Message* message = NULL;
		GearyRFC822Message* _tmp47_;
		gchar* _tmp49_ = NULL;
		GearyRFC822Message* _tmp50_;
		gchar* body = NULL;
		gchar* _tmp57_;
		const gchar* _tmp58_;
#line 119 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp47_ = geary_email_get_message (email, &_inner_error0_);
#line 119 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		message = _tmp47_;
#line 119 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 405 "mail-merge-processor.c"
			gboolean _tmp48_ = FALSE;
#line 119 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			g_propagate_error (error, _inner_error0_);
#line 119 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			return _tmp48_;
#line 411 "mail-merge-processor.c"
		}
#line 120 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp50_ = message;
#line 120 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		if (geary_rf_c822_message_has_plain_body (_tmp50_)) {
#line 417 "mail-merge-processor.c"
			GearyRFC822Message* _tmp51_;
			gchar* _tmp52_;
#line 122 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp51_ = message;
#line 122 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp52_ = geary_rf_c822_message_get_plain_body (_tmp51_, FALSE, NULL, NULL, &_inner_error0_);
#line 122 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_g_free0 (_tmp49_);
#line 122 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp49_ = _tmp52_;
#line 122 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 430 "mail-merge-processor.c"
				gboolean _tmp53_ = FALSE;
#line 122 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				g_propagate_error (error, _inner_error0_);
#line 122 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				_g_free0 (_tmp49_);
#line 122 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				_g_object_unref0 (message);
#line 122 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				return _tmp53_;
#line 440 "mail-merge-processor.c"
			}
		} else {
			GearyRFC822Message* _tmp54_;
			gchar* _tmp55_;
#line 123 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp54_ = message;
#line 123 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp55_ = geary_rf_c822_message_get_html_body (_tmp54_, NULL, NULL, &_inner_error0_);
#line 123 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_g_free0 (_tmp49_);
#line 123 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp49_ = _tmp55_;
#line 123 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 455 "mail-merge-processor.c"
				gboolean _tmp56_ = FALSE;
#line 123 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				g_propagate_error (error, _inner_error0_);
#line 123 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				_g_free0 (_tmp49_);
#line 123 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				_g_object_unref0 (message);
#line 123 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				return _tmp56_;
#line 465 "mail-merge-processor.c"
			}
		}
#line 120 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp57_ = g_strdup (_tmp49_);
#line 120 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		body = _tmp57_;
#line 125 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp58_ = body;
#line 125 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		found = mail_merge_processor_contains_field (_tmp58_);
#line 118 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_g_free0 (body);
#line 118 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_g_free0 (_tmp49_);
#line 118 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_g_object_unref0 (message);
#line 482 "mail-merge-processor.c"
	}
#line 127 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	result = found;
#line 127 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	return result;
#line 488 "mail-merge-processor.c"
}

gboolean
mail_merge_processor_contains_field (const gchar* text)
{
	MailMergeProcessorParser parser = {0};
	gboolean found = FALSE;
	gboolean result;
#line 130 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 131 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	mail_merge_processor_parser_init (&parser, text);
#line 132 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	found = FALSE;
#line 133 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	while (TRUE) {
#line 505 "mail-merge-processor.c"
		MailMergeProcessorParser _tmp0_;
		MailMergeProcessorParser _tmp1_;
#line 133 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp0_ = parser;
#line 133 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		if (!(!_tmp0_.spent)) {
#line 133 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			break;
#line 514 "mail-merge-processor.c"
		}
#line 134 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp1_ = parser;
#line 134 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		if (_tmp1_.at_field_start) {
#line 520 "mail-merge-processor.c"
			gchar* _tmp2_;
			gchar* _tmp3_;
			MailMergeProcessorParser _tmp4_;
#line 135 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp2_ = mail_merge_processor_parser_read_field (&parser);
#line 135 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp3_ = _tmp2_;
#line 135 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_g_free0 (_tmp3_);
#line 136 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp4_ = parser;
#line 136 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			if (_tmp4_.at_field_end) {
#line 137 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				found = TRUE;
#line 138 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				break;
#line 538 "mail-merge-processor.c"
			}
		} else {
			gchar* _tmp5_;
			gchar* _tmp6_;
#line 141 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp5_ = mail_merge_processor_parser_read_text (&parser);
#line 141 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp6_ = _tmp5_;
#line 141 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_g_free0 (_tmp6_);
#line 549 "mail-merge-processor.c"
		}
	}
#line 144 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	result = found;
#line 144 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	return result;
#line 556 "mail-merge-processor.c"
}

GearyEmail*
mail_merge_processor_get_template (MailMergeProcessor* self)
{
	GearyEmail* result;
	GearyEmail* _tmp0_;
#line 150 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_return_val_if_fail (MAIL_MERGE_IS_PROCESSOR (self), NULL);
#line 150 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp0_ = self->priv->_template;
#line 150 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	result = _tmp0_;
#line 150 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	return result;
#line 572 "mail-merge-processor.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 150 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	return self ? g_object_ref (self) : NULL;
#line 580 "mail-merge-processor.c"
}

static void
mail_merge_processor_set_template (MailMergeProcessor* self,
                                   GearyEmail* value)
{
	GearyEmail* old_value;
#line 150 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_return_if_fail (MAIL_MERGE_IS_PROCESSOR (self));
#line 150 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	old_value = mail_merge_processor_get_template (self);
#line 150 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	if (old_value != value) {
#line 594 "mail-merge-processor.c"
		GearyEmail* _tmp0_;
#line 150 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 150 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_g_object_unref0 (self->priv->_template);
#line 150 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		self->priv->_template = _tmp0_;
#line 150 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		g_object_notify_by_pspec ((GObject *) self, mail_merge_processor_properties[MAIL_MERGE_PROCESSOR_TEMPLATE_PROPERTY]);
#line 604 "mail-merge-processor.c"
	}
}

GearyComposedEmail*
mail_merge_processor_get_email (MailMergeProcessor* self)
{
	GearyComposedEmail* result;
	GearyComposedEmail* _tmp0_;
#line 155 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_return_val_if_fail (MAIL_MERGE_IS_PROCESSOR (self), NULL);
#line 155 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp0_ = self->priv->_email;
#line 155 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	result = _tmp0_;
#line 155 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	return result;
#line 621 "mail-merge-processor.c"
}

static void
mail_merge_processor_set_email (MailMergeProcessor* self,
                                GearyComposedEmail* value)
{
	GearyComposedEmail* old_value;
#line 155 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_return_if_fail (MAIL_MERGE_IS_PROCESSOR (self));
#line 155 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	old_value = mail_merge_processor_get_email (self);
#line 155 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	if (old_value != value) {
#line 635 "mail-merge-processor.c"
		GearyComposedEmail* _tmp0_;
#line 155 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 155 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_g_object_unref0 (self->priv->_email);
#line 155 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		self->priv->_email = _tmp0_;
#line 155 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		g_object_notify_by_pspec ((GObject *) self, mail_merge_processor_properties[MAIL_MERGE_PROCESSOR_EMAIL_PROPERTY]);
#line 645 "mail-merge-processor.c"
	}
}

GeeList*
mail_merge_processor_get_missing_fields (MailMergeProcessor* self)
{
	GeeList* result;
	GeeList* _tmp0_;
#line 160 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_return_val_if_fail (MAIL_MERGE_IS_PROCESSOR (self), NULL);
#line 160 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp0_ = self->priv->_missing_fields;
#line 160 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	result = _tmp0_;
#line 160 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	return result;
#line 662 "mail-merge-processor.c"
}

static void
mail_merge_processor_set_missing_fields (MailMergeProcessor* self,
                                         GeeList* value)
{
	GeeList* old_value;
#line 160 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_return_if_fail (MAIL_MERGE_IS_PROCESSOR (self));
#line 160 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	old_value = mail_merge_processor_get_missing_fields (self);
#line 160 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	if (old_value != value) {
#line 676 "mail-merge-processor.c"
		GeeList* _tmp0_;
#line 160 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 160 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_g_object_unref0 (self->priv->_missing_fields);
#line 160 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		self->priv->_missing_fields = _tmp0_;
#line 160 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		g_object_notify_by_pspec ((GObject *) self, mail_merge_processor_properties[MAIL_MERGE_PROCESSOR_MISSING_FIELDS_PROPERTY]);
#line 686 "mail-merge-processor.c"
	}
}

/** Constructs a new merge processor with the given template. */
MailMergeProcessor*
mail_merge_processor_construct (GType object_type,
                                GearyEmail* template)
{
	MailMergeProcessor * self = NULL;
#line 164 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (template, GEARY_TYPE_EMAIL), NULL);
#line 164 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	self = (MailMergeProcessor*) g_object_new (object_type, NULL);
#line 165 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	mail_merge_processor_set_template (self, template);
#line 164 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	return self;
#line 704 "mail-merge-processor.c"
}

MailMergeProcessor*
mail_merge_processor_new (GearyEmail* template)
{
#line 164 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	return mail_merge_processor_construct (MAIL_MERGE_TYPE_PROCESSOR, template);
#line 712 "mail-merge-processor.c"
}

/**
     * Merges the template with the given data to produce a complete message.
     *
     * Creates a new composed email based on the template and given
     * data, set it as the {@email} property and returns it.
     */
GearyComposedEmail*
mail_merge_processor_merge (MailMergeProcessor* self,
                            GeeMap* values,
                            GError** error)
{
	GearyRFC822MailboxAddresses* from = NULL;
	GearyEmail* _tmp0_;
	GearyRFC822MailboxAddresses* _tmp1_;
	GearyRFC822MailboxAddresses* _tmp2_;
	GearyRFC822MailboxAddresses* _tmp3_;
	GearyComposedEmail* email = NULL;
	GTimeZone* _tmp4_;
	GTimeZone* _tmp5_;
	GDateTime* _tmp6_;
	GDateTime* _tmp7_;
	GearyRFC822MailboxAddresses* _tmp8_;
	GearyComposedEmail* _tmp9_;
	GearyComposedEmail* _tmp10_;
	GearyComposedEmail* _tmp11_;
	GearyComposedEmail* _tmp12_;
	GearyComposedEmail* _tmp13_;
	GearyEmail* _tmp14_;
	GearyRFC822MailboxAddresses* _tmp15_;
	GearyRFC822MailboxAddresses* _tmp16_;
	GearyRFC822MailboxAddresses* _tmp17_;
	GearyRFC822MailboxAddresses* _tmp18_;
	GearyComposedEmail* _tmp19_;
	GearyComposedEmail* _tmp20_;
	GearyComposedEmail* _tmp21_;
	GearyEmail* _tmp22_;
	GearyRFC822MailboxAddresses* _tmp23_;
	GearyRFC822MailboxAddresses* _tmp24_;
	GearyRFC822MailboxAddresses* _tmp25_;
	GearyRFC822MailboxAddresses* _tmp26_;
	GearyComposedEmail* _tmp27_;
	GearyComposedEmail* _tmp28_;
	GearyComposedEmail* _tmp29_;
	GearyEmail* _tmp30_;
	GearyRFC822MailboxAddresses* _tmp31_;
	GearyRFC822MailboxAddresses* _tmp32_;
	GearyRFC822MailboxAddresses* _tmp33_;
	GearyRFC822MailboxAddresses* _tmp34_;
	GearyComposedEmail* _tmp35_;
	GearyComposedEmail* _tmp36_;
	GearyComposedEmail* _tmp37_;
	GearyEmail* _tmp38_;
	GearyRFC822MailboxAddresses* _tmp39_;
	GearyRFC822MailboxAddresses* _tmp40_;
	GearyRFC822MailboxAddresses* _tmp41_;
	GearyRFC822MailboxAddresses* _tmp42_;
	GearyComposedEmail* _tmp43_;
	GearyComposedEmail* _tmp44_;
	GearyComposedEmail* _tmp45_;
	GearyEmail* _tmp46_;
	GearyRFC822MailboxAddress* _tmp47_;
	GearyRFC822MailboxAddress* _tmp48_;
	GearyRFC822MailboxAddress* _tmp49_;
	GearyRFC822MailboxAddress* _tmp50_;
	GearyComposedEmail* _tmp51_;
	GearyComposedEmail* _tmp52_;
	GearyEmail* _tmp53_;
	GearyRFC822Subject* _tmp54_;
	GearyRFC822Subject* _tmp55_;
	GearyComposedEmail* _tmp66_;
	GearyEmail* _tmp67_;
	GearyRFC822MessageIDList* _tmp68_;
	GearyRFC822MessageIDList* _tmp69_;
	GearyComposedEmail* _tmp70_;
	GearyComposedEmail* _tmp71_;
	GearyComposedEmail* _tmp72_;
	GearyEmail* _tmp73_;
	GearyRFC822MessageIDList* _tmp74_;
	GearyRFC822MessageIDList* _tmp75_;
	GearyComposedEmail* _tmp76_;
	GearyComposedEmail* _tmp77_;
	GearyRFC822Message* message = NULL;
	GearyEmail* _tmp78_;
	GearyRFC822Message* _tmp79_;
	GearyRFC822Message* _tmp80_;
	GearyRFC822Message* _tmp87_;
	GError* _inner_error0_ = NULL;
	GearyComposedEmail* result;
#line 174 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_return_val_if_fail (MAIL_MERGE_IS_PROCESSOR (self), NULL);
#line 174 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (values, GEE_TYPE_MAP), NULL);
#line 176 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp0_ = self->priv->_template;
#line 176 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp1_ = geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 176 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp2_ = _tmp1_;
#line 176 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp3_ = mail_merge_processor_format_mailbox_addresses (self, _tmp2_, values);
#line 176 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	from = _tmp3_;
#line 177 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp4_ = g_time_zone_new_local ();
#line 177 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp5_ = _tmp4_;
#line 177 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp6_ = g_date_time_new_now (_tmp5_);
#line 177 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp7_ = _tmp6_;
#line 177 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp8_ = from;
#line 177 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp9_ = geary_composed_email_new (_tmp7_, _tmp8_);
#line 177 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp10_ = _tmp9_;
#line 177 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	mail_merge_processor_set_email (self, _tmp10_);
#line 177 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 177 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp12_ = _tmp11_;
#line 177 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_g_object_unref0 (_tmp10_);
#line 177 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_g_date_time_unref0 (_tmp7_);
#line 177 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_g_time_zone_unref0 (_tmp5_);
#line 177 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	email = _tmp12_;
#line 180 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp13_ = email;
#line 180 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp14_ = self->priv->_template;
#line 180 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp15_ = geary_email_header_set_get_to (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 180 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp16_ = _tmp15_;
#line 180 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp17_ = mail_merge_processor_format_mailbox_addresses (self, _tmp16_, values);
#line 180 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp18_ = _tmp17_;
#line 180 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp19_ = geary_composed_email_set_to (_tmp13_, _tmp18_);
#line 180 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp20_ = _tmp19_;
#line 180 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_g_object_unref0 (_tmp20_);
#line 180 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_g_object_unref0 (_tmp18_);
#line 181 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp21_ = email;
#line 181 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp22_ = self->priv->_template;
#line 181 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp23_ = geary_email_header_set_get_cc (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 181 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp24_ = _tmp23_;
#line 181 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp25_ = mail_merge_processor_format_mailbox_addresses (self, _tmp24_, values);
#line 181 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp26_ = _tmp25_;
#line 181 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp27_ = geary_composed_email_set_cc (_tmp21_, _tmp26_);
#line 181 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp28_ = _tmp27_;
#line 181 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_g_object_unref0 (_tmp28_);
#line 181 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_g_object_unref0 (_tmp26_);
#line 182 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp29_ = email;
#line 182 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp30_ = self->priv->_template;
#line 182 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp31_ = geary_email_header_set_get_bcc (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 182 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp32_ = _tmp31_;
#line 182 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp33_ = mail_merge_processor_format_mailbox_addresses (self, _tmp32_, values);
#line 182 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp34_ = _tmp33_;
#line 182 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp35_ = geary_composed_email_set_bcc (_tmp29_, _tmp34_);
#line 182 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp36_ = _tmp35_;
#line 182 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_g_object_unref0 (_tmp36_);
#line 182 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_g_object_unref0 (_tmp34_);
#line 183 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp37_ = email;
#line 183 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp38_ = self->priv->_template;
#line 183 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp39_ = geary_email_header_set_get_reply_to (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 183 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp40_ = _tmp39_;
#line 183 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp41_ = mail_merge_processor_format_mailbox_addresses (self, _tmp40_, values);
#line 183 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp42_ = _tmp41_;
#line 183 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp43_ = geary_composed_email_set_reply_to (_tmp37_, _tmp42_);
#line 183 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp44_ = _tmp43_;
#line 183 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_g_object_unref0 (_tmp44_);
#line 183 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_g_object_unref0 (_tmp42_);
#line 184 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp45_ = email;
#line 184 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp46_ = self->priv->_template;
#line 184 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp47_ = geary_email_header_set_get_sender (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 184 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp48_ = _tmp47_;
#line 184 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp49_ = mail_merge_processor_format_mailbox_address (self, _tmp48_, values);
#line 184 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp50_ = _tmp49_;
#line 184 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp51_ = geary_composed_email_set_sender (_tmp45_, _tmp50_);
#line 184 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp52_ = _tmp51_;
#line 184 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_g_object_unref0 (_tmp52_);
#line 184 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_g_object_unref0 (_tmp50_);
#line 185 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp53_ = self->priv->_template;
#line 185 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp54_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 185 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp55_ = _tmp54_;
#line 185 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	if (_tmp55_ != NULL) {
#line 953 "mail-merge-processor.c"
		GearyComposedEmail* _tmp56_;
		GearyEmail* _tmp57_;
		GearyRFC822Subject* _tmp58_;
		GearyRFC822Subject* _tmp59_;
		const gchar* _tmp60_;
		const gchar* _tmp61_;
		gchar* _tmp62_;
		gchar* _tmp63_;
		GearyComposedEmail* _tmp64_;
		GearyComposedEmail* _tmp65_;
#line 186 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp56_ = email;
#line 186 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp57_ = self->priv->_template;
#line 186 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp58_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (_tmp57_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 186 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp59_ = _tmp58_;
#line 186 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp60_ = geary_message_data_string_message_data_get_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp59_, GEARY_MESSAGE_DATA_TYPE_STRING_MESSAGE_DATA, GearyMessageDataStringMessageData));
#line 186 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp61_ = _tmp60_;
#line 186 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp62_ = mail_merge_processor_format_string (self, _tmp61_, values);
#line 186 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp63_ = _tmp62_;
#line 186 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp64_ = geary_composed_email_set_subject (_tmp56_, _tmp63_);
#line 186 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp65_ = _tmp64_;
#line 186 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_g_object_unref0 (_tmp65_);
#line 186 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_g_free0 (_tmp63_);
#line 988 "mail-merge-processor.c"
	}
#line 190 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp66_ = email;
#line 190 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp67_ = self->priv->_template;
#line 190 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp68_ = geary_email_header_set_get_in_reply_to (G_TYPE_CHECK_INSTANCE_CAST (_tmp67_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 190 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp69_ = _tmp68_;
#line 190 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp70_ = geary_composed_email_set_in_reply_to (_tmp66_, _tmp69_);
#line 190 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp71_ = _tmp70_;
#line 190 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_g_object_unref0 (_tmp71_);
#line 191 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp72_ = email;
#line 191 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp73_ = self->priv->_template;
#line 191 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp74_ = geary_email_header_set_get_references (G_TYPE_CHECK_INSTANCE_CAST (_tmp73_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 191 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp75_ = _tmp74_;
#line 191 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp76_ = geary_composed_email_set_references (_tmp72_, _tmp75_);
#line 191 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp77_ = _tmp76_;
#line 191 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_g_object_unref0 (_tmp77_);
#line 194 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp78_ = self->priv->_template;
#line 194 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp79_ = geary_email_get_message (_tmp78_, &_inner_error0_);
#line 194 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	message = _tmp79_;
#line 194 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 194 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		g_propagate_error (error, _inner_error0_);
#line 194 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_g_object_unref0 (email);
#line 194 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_g_object_unref0 (from);
#line 194 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		return NULL;
#line 1034 "mail-merge-processor.c"
	}
#line 195 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp80_ = message;
#line 195 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	if (geary_rf_c822_message_has_plain_body (_tmp80_)) {
#line 1040 "mail-merge-processor.c"
		gchar* _tmp81_ = NULL;
		GearyRFC822Message* _tmp82_;
		gchar* _tmp83_;
		GearyComposedEmail* _tmp84_;
		gchar* _tmp85_;
		gchar* _tmp86_;
#line 197 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp82_ = message;
#line 197 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp83_ = geary_rf_c822_message_get_plain_body (_tmp82_, FALSE, NULL, NULL, &_inner_error0_);
#line 197 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp81_ = _tmp83_;
#line 197 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 197 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			g_propagate_error (error, _inner_error0_);
#line 197 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_g_object_unref0 (message);
#line 197 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_g_object_unref0 (email);
#line 197 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_g_object_unref0 (from);
#line 197 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			return NULL;
#line 1065 "mail-merge-processor.c"
		}
#line 196 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp84_ = email;
#line 196 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp85_ = mail_merge_processor_format_string (self, _tmp81_, values);
#line 196 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp86_ = _tmp85_;
#line 196 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		geary_composed_email_set_body_text (_tmp84_, _tmp86_);
#line 196 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_g_free0 (_tmp86_);
#line 195 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_g_free0 (_tmp81_);
#line 1079 "mail-merge-processor.c"
	}
#line 200 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp87_ = message;
#line 200 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	if (geary_rf_c822_message_has_html_body (_tmp87_)) {
#line 1085 "mail-merge-processor.c"
		gchar* _tmp88_ = NULL;
		GearyRFC822Message* _tmp89_;
		gchar* _tmp90_;
		GearyComposedEmail* _tmp91_;
		gchar* _tmp92_;
		gchar* _tmp93_;
#line 202 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp89_ = message;
#line 202 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp90_ = geary_rf_c822_message_get_html_body (_tmp89_, NULL, NULL, &_inner_error0_);
#line 202 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp88_ = _tmp90_;
#line 202 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 202 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			g_propagate_error (error, _inner_error0_);
#line 202 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_g_object_unref0 (message);
#line 202 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_g_object_unref0 (email);
#line 202 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_g_object_unref0 (from);
#line 202 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			return NULL;
#line 1110 "mail-merge-processor.c"
		}
#line 201 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp91_ = email;
#line 201 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp92_ = mail_merge_processor_format_string (self, _tmp88_, values);
#line 201 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp93_ = _tmp92_;
#line 201 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		geary_composed_email_set_body_html (_tmp91_, _tmp93_);
#line 201 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_g_free0 (_tmp93_);
#line 200 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_g_free0 (_tmp88_);
#line 1124 "mail-merge-processor.c"
	}
#line 206 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	result = email;
#line 206 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_g_object_unref0 (message);
#line 206 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_g_object_unref0 (from);
#line 206 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	return result;
#line 1134 "mail-merge-processor.c"
}

static inline GearyRFC822MailboxAddresses*
mail_merge_processor_format_mailbox_addresses (MailMergeProcessor* self,
                                               GearyRFC822MailboxAddresses* addresses,
                                               GeeMap* values)
{
	GearyRFC822MailboxAddresses* formatted = NULL;
	gboolean _tmp0_ = FALSE;
	GearyRFC822MailboxAddresses* result;
#line 209 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_return_val_if_fail (MAIL_MERGE_IS_PROCESSOR (self), NULL);
#line 209 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_return_val_if_fail ((addresses == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (addresses, GEARY_RF_C822_TYPE_MAILBOX_ADDRESSES), NULL);
#line 209 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (values, GEE_TYPE_MAP), NULL);
#line 213 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	formatted = NULL;
#line 214 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	if (addresses != NULL) {
#line 1155 "mail-merge-processor.c"
		gboolean _tmp1_;
		gboolean _tmp2_;
#line 214 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp1_ = geary_rf_c822_mailbox_addresses_get_is_empty (addresses);
#line 214 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp2_ = _tmp1_;
#line 214 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp0_ = !_tmp2_;
#line 1164 "mail-merge-processor.c"
	} else {
#line 214 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp0_ = FALSE;
#line 1168 "mail-merge-processor.c"
	}
#line 214 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	if (_tmp0_) {
#line 1172 "mail-merge-processor.c"
		GearyRFC822MailboxAddresses* _tmp3_;
#line 215 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp3_ = geary_rf_c822_mailbox_addresses_new (NULL);
#line 215 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_g_object_unref0 (formatted);
#line 215 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		formatted = _tmp3_;
#line 1180 "mail-merge-processor.c"
		{
			GearyRFC822MailboxAddresses* _addr_list = NULL;
			gint _addr_size = 0;
			GearyRFC822MailboxAddresses* _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			gint _addr_index = 0;
#line 216 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_addr_list = addresses;
#line 216 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp4_ = _addr_list;
#line 216 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp5_ = geary_rf_c822_mailbox_addresses_get_size (_tmp4_);
#line 216 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp6_ = _tmp5_;
#line 216 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_addr_size = _tmp6_;
#line 216 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_addr_index = -1;
#line 216 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			while (TRUE) {
#line 1202 "mail-merge-processor.c"
				gint _tmp7_;
				gint _tmp8_;
				GearyRFC822MailboxAddress* addr = NULL;
				GearyRFC822MailboxAddresses* _tmp9_;
				GearyRFC822MailboxAddress* _tmp10_;
				GearyRFC822MailboxAddresses* _tmp11_;
				GearyRFC822MailboxAddress* _tmp12_;
				GearyRFC822MailboxAddress* _tmp13_;
				GearyRFC822MailboxAddress* _tmp14_;
				GearyRFC822MailboxAddresses* _tmp15_;
#line 216 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				_addr_index = _addr_index + 1;
#line 216 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				_tmp7_ = _addr_index;
#line 216 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				_tmp8_ = _addr_size;
#line 216 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				if (!(_tmp7_ < _tmp8_)) {
#line 216 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
					break;
#line 1223 "mail-merge-processor.c"
				}
#line 216 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				_tmp9_ = _addr_list;
#line 216 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				_tmp10_ = geary_rf_c822_mailbox_addresses_get (_tmp9_, _addr_index);
#line 216 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				addr = _tmp10_;
#line 217 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				_tmp11_ = formatted;
#line 217 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				_tmp12_ = addr;
#line 217 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				_tmp13_ = mail_merge_processor_format_mailbox_address (self, _tmp12_, values);
#line 217 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				_tmp14_ = _tmp13_;
#line 217 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				_tmp15_ = geary_rf_c822_mailbox_addresses_merge_mailbox (_tmp11_, _tmp14_);
#line 217 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				_g_object_unref0 (formatted);
#line 217 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				formatted = _tmp15_;
#line 217 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				_g_object_unref0 (_tmp14_);
#line 216 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				_g_object_unref0 (addr);
#line 1249 "mail-merge-processor.c"
			}
		}
	}
#line 222 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	result = formatted;
#line 222 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	return result;
#line 1257 "mail-merge-processor.c"
}

static inline GearyRFC822MailboxAddress*
mail_merge_processor_format_mailbox_address (MailMergeProcessor* self,
                                             GearyRFC822MailboxAddress* address,
                                             GeeMap* values)
{
	GearyRFC822MailboxAddress* formatted = NULL;
	GearyRFC822MailboxAddress* result;
#line 225 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_return_val_if_fail (MAIL_MERGE_IS_PROCESSOR (self), NULL);
#line 225 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_return_val_if_fail ((address == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (address, GEARY_RF_C822_TYPE_MAILBOX_ADDRESS), NULL);
#line 225 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (values, GEE_TYPE_MAP), NULL);
#line 229 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	formatted = NULL;
#line 230 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	if (address != NULL) {
#line 1277 "mail-merge-processor.c"
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		GearyRFC822MailboxAddress* _tmp8_;
#line 231 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp0_ = geary_rf_c822_mailbox_address_get_name (address);
#line 231 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp1_ = _tmp0_;
#line 231 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp2_ = mail_merge_processor_format_string (self, _tmp1_, values);
#line 231 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp3_ = _tmp2_;
#line 231 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp4_ = geary_rf_c822_mailbox_address_get_address (address);
#line 231 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp5_ = _tmp4_;
#line 231 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp6_ = mail_merge_processor_format_string (self, _tmp5_, values);
#line 231 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp7_ = _tmp6_;
#line 231 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp8_ = geary_rf_c822_mailbox_address_new (_tmp3_, _tmp7_);
#line 231 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_g_object_unref0 (formatted);
#line 231 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		formatted = _tmp8_;
#line 231 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_g_free0 (_tmp7_);
#line 231 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_g_free0 (_tmp3_);
#line 1313 "mail-merge-processor.c"
	}
#line 236 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	result = formatted;
#line 236 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	return result;
#line 1319 "mail-merge-processor.c"
}

static inline gchar*
mail_merge_processor_format_string (MailMergeProcessor* self,
                                    const gchar* text,
                                    GeeMap* values)
{
	gchar* formatted = NULL;
	gchar* result;
#line 239 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_return_val_if_fail (MAIL_MERGE_IS_PROCESSOR (self), NULL);
#line 239 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (values, GEE_TYPE_MAP), NULL);
#line 241 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	formatted = NULL;
#line 242 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	if (text != NULL) {
#line 1337 "mail-merge-processor.c"
		GString* buf = NULL;
		gint _tmp0_;
		gint _tmp1_;
		GString* _tmp2_;
		MailMergeProcessorParser parser = {0};
		GString* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
#line 243 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp0_ = strlen (text);
#line 243 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp1_ = _tmp0_;
#line 243 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp2_ = g_string_sized_new ((gsize) _tmp1_);
#line 243 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		buf = _tmp2_;
#line 244 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		mail_merge_processor_parser_init (&parser, text);
#line 246 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		while (TRUE) {
#line 1358 "mail-merge-processor.c"
			MailMergeProcessorParser _tmp3_;
			gchar* value = NULL;
			MailMergeProcessorParser _tmp4_;
			GString* _tmp17_;
			const gchar* _tmp18_;
#line 246 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp3_ = parser;
#line 246 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			if (!(!_tmp3_.spent)) {
#line 246 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				break;
#line 1370 "mail-merge-processor.c"
			}
#line 247 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			value = NULL;
#line 248 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp4_ = parser;
#line 248 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			if (_tmp4_.at_field_start) {
#line 1378 "mail-merge-processor.c"
				gchar* field = NULL;
				gchar* _tmp5_;
				MailMergeProcessorParser _tmp6_;
#line 249 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				_tmp5_ = mail_merge_processor_parser_read_field (&parser);
#line 249 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				field = _tmp5_;
#line 250 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				_tmp6_ = parser;
#line 250 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				if (_tmp6_.at_field_end) {
#line 1390 "mail-merge-processor.c"
					const gchar* _tmp7_;
					gpointer _tmp8_;
					const gchar* _tmp9_;
#line 252 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
					_tmp7_ = field;
#line 252 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
					_tmp8_ = gee_map_get (values, _tmp7_);
#line 252 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
					_g_free0 (value);
#line 252 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
					value = (gchar*) _tmp8_;
#line 253 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
					_tmp9_ = value;
#line 253 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
					if (_tmp9_ == NULL) {
#line 1406 "mail-merge-processor.c"
						GeeList* _tmp10_;
						const gchar* _tmp11_;
						const gchar* _tmp12_;
						gchar* _tmp13_;
#line 254 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
						_tmp10_ = self->priv->_missing_fields;
#line 254 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
						_tmp11_ = field;
#line 254 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
						gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_COLLECTION, GeeCollection), _tmp11_);
#line 255 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
						_tmp12_ = field;
#line 255 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
						_tmp13_ = mail_merge_processor_to_field (_tmp12_);
#line 255 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
						_g_free0 (value);
#line 255 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
						value = _tmp13_;
#line 1425 "mail-merge-processor.c"
					}
				} else {
					const gchar* _tmp14_;
					gchar* _tmp15_;
#line 259 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
					_tmp14_ = field;
#line 259 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
					_tmp15_ = g_strdup (_tmp14_);
#line 259 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
					_g_free0 (value);
#line 259 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
					value = _tmp15_;
#line 1438 "mail-merge-processor.c"
				}
#line 248 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				_g_free0 (field);
#line 1442 "mail-merge-processor.c"
			} else {
				gchar* _tmp16_;
#line 262 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				_tmp16_ = mail_merge_processor_parser_read_text (&parser);
#line 262 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				_g_free0 (value);
#line 262 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				value = _tmp16_;
#line 1451 "mail-merge-processor.c"
			}
#line 264 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp17_ = buf;
#line 264 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp18_ = value;
#line 264 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			g_string_append (_tmp17_, _tmp18_);
#line 246 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_g_free0 (value);
#line 1461 "mail-merge-processor.c"
		}
#line 266 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp19_ = buf;
#line 266 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp20_ = _tmp19_->str;
#line 266 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp21_ = g_strdup (_tmp20_);
#line 266 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_g_free0 (formatted);
#line 266 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		formatted = _tmp21_;
#line 242 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_g_string_free0 (buf);
#line 1475 "mail-merge-processor.c"
	}
#line 268 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	result = formatted;
#line 268 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	return result;
#line 1481 "mail-merge-processor.c"
}

static void
mail_merge_processor_parser_init (MailMergeProcessorParser *self,
                                  const gchar* text)
{
	gint _tmp0_;
	gint _tmp1_;
#line 31 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_return_if_fail (text != NULL);
#line 31 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	memset (self, 0, sizeof (MailMergeProcessorParser));
#line 32 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	(*self).text = text;
#line 33 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	(*self).index = 0;
#line 34 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp0_ = strlen (text);
#line 34 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp1_ = _tmp0_;
#line 34 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	(*self).spent = _tmp1_ == 0;
#line 35 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	(*self).at_field_start = g_str_has_prefix (text, MAIL_MERGE_PROCESSOR_FIELD_START);
#line 36 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	(*self).at_field_end = FALSE;
#line 1508 "mail-merge-processor.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 1525 "mail-merge-processor.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 1552 "mail-merge-processor.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 1558 "mail-merge-processor.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 1564 "mail-merge-processor.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 1568 "mail-merge-processor.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 1576 "mail-merge-processor.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 1580 "mail-merge-processor.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 1592 "mail-merge-processor.c"
}

static gchar*
mail_merge_processor_parser_read_text (MailMergeProcessorParser *self)
{
	gint start = 0;
	gchar c = '\0';
	const gchar* _tmp0_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result;
#line 40 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	(*self).at_field_end = FALSE;
#line 42 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	start = (*self).index;
#line 43 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp0_ = (*self).text;
#line 43 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	c = string_get (_tmp0_, (glong) (*self).index);
#line 44 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	while (TRUE) {
#line 1614 "mail-merge-processor.c"
		gint _tmp1_;
		gboolean _tmp2_ = FALSE;
		const gchar* _tmp5_;
#line 44 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		if (!(((gint) c) != 0)) {
#line 44 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			break;
#line 1622 "mail-merge-processor.c"
		}
#line 45 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp1_ = (*self).index;
#line 45 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		(*self).index = _tmp1_ + 1;
#line 46 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		if (c == string_get (MAIL_MERGE_PROCESSOR_FIELD_START, (glong) 0)) {
#line 1630 "mail-merge-processor.c"
			const gchar* _tmp3_;
#line 47 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp3_ = (*self).text;
#line 47 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp2_ = string_get (_tmp3_, (glong) (*self).index) == string_get (MAIL_MERGE_PROCESSOR_FIELD_START, (glong) 1);
#line 1636 "mail-merge-processor.c"
		} else {
#line 46 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp2_ = FALSE;
#line 1640 "mail-merge-processor.c"
		}
#line 46 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		if (_tmp2_) {
#line 1644 "mail-merge-processor.c"
			gint _tmp4_;
#line 48 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp4_ = (*self).index;
#line 48 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			(*self).index = _tmp4_ - 1;
#line 49 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			(*self).at_field_start = TRUE;
#line 50 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			break;
#line 1654 "mail-merge-processor.c"
		}
#line 52 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp5_ = (*self).text;
#line 52 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		c = string_get (_tmp5_, (glong) (*self).index);
#line 1660 "mail-merge-processor.c"
	}
#line 54 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	if (((gint) c) == 0) {
#line 55 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		(*self).spent = TRUE;
#line 1666 "mail-merge-processor.c"
	}
#line 57 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp6_ = (*self).text;
#line 57 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp7_ = string_slice (_tmp6_, (glong) start, (glong) (*self).index);
#line 57 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	result = _tmp7_;
#line 57 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	return result;
#line 1676 "mail-merge-processor.c"
}

static gchar*
mail_merge_processor_parser_read_field (MailMergeProcessorParser *self)
{
	gint _tmp0_;
	gint _tmp1_;
	gint start = 0;
	gchar c = '\0';
	const gchar* _tmp2_;
	gint end = 0;
	gboolean _tmp11_ = FALSE;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* result;
#line 61 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	(*self).at_field_start = FALSE;
#line 64 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp0_ = strlen (MAIL_MERGE_PROCESSOR_FIELD_START);
#line 64 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp1_ = _tmp0_;
#line 64 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	(*self).index = (*self).index + _tmp1_;
#line 66 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	start = (*self).index;
#line 67 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp2_ = (*self).text;
#line 67 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	c = string_get (_tmp2_, (glong) (*self).index);
#line 68 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	while (TRUE) {
#line 1708 "mail-merge-processor.c"
		gint _tmp3_;
		const gchar* _tmp6_;
#line 68 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		if (!(((gint) c) != 0)) {
#line 68 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			break;
#line 1715 "mail-merge-processor.c"
		}
#line 69 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp3_ = (*self).index;
#line 69 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		(*self).index = _tmp3_ + 1;
#line 70 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		if (c == string_get (MAIL_MERGE_PROCESSOR_FIELD_END, (glong) 0)) {
#line 1723 "mail-merge-processor.c"
			const gchar* _tmp4_;
#line 71 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			_tmp4_ = (*self).text;
#line 71 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
			if (string_get (_tmp4_, (glong) (*self).index) == string_get (MAIL_MERGE_PROCESSOR_FIELD_END, (glong) 1)) {
#line 1729 "mail-merge-processor.c"
				gint _tmp5_;
#line 72 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				_tmp5_ = (*self).index;
#line 72 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				(*self).index = _tmp5_ + 1;
#line 73 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				(*self).at_field_end = TRUE;
#line 74 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
				break;
#line 1739 "mail-merge-processor.c"
			}
		}
#line 77 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp6_ = (*self).text;
#line 77 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		c = string_get (_tmp6_, (glong) (*self).index);
#line 1746 "mail-merge-processor.c"
	}
#line 79 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	end = (*self).index;
#line 80 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	if ((*self).at_field_end) {
#line 1752 "mail-merge-processor.c"
		gint _tmp7_;
		gint _tmp8_;
#line 82 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp7_ = strlen (MAIL_MERGE_PROCESSOR_FIELD_END);
#line 82 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp8_ = _tmp7_;
#line 82 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		end -= _tmp8_;
#line 1761 "mail-merge-processor.c"
	} else {
		gint _tmp9_;
		gint _tmp10_;
#line 87 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp9_ = strlen (MAIL_MERGE_PROCESSOR_FIELD_START);
#line 87 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp10_ = _tmp9_;
#line 87 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		start -= _tmp10_;
#line 1771 "mail-merge-processor.c"
	}
#line 89 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	if (((gint) c) == 0) {
#line 89 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp11_ = TRUE;
#line 1777 "mail-merge-processor.c"
	} else {
		const gchar* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
#line 89 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp12_ = (*self).text;
#line 89 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp13_ = strlen (_tmp12_);
#line 89 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp14_ = _tmp13_;
#line 89 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		_tmp11_ = (*self).index == _tmp14_;
#line 1790 "mail-merge-processor.c"
	}
#line 89 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	if (_tmp11_) {
#line 90 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		(*self).spent = TRUE;
#line 1796 "mail-merge-processor.c"
	}
#line 92 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp15_ = (*self).text;
#line 92 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp16_ = string_slice (_tmp15_, (glong) start, (glong) end);
#line 92 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	result = _tmp16_;
#line 92 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	return result;
#line 1806 "mail-merge-processor.c"
}

static MailMergeProcessorParser*
mail_merge_processor_parser_dup (const MailMergeProcessorParser* self)
{
	MailMergeProcessorParser* dup;
#line 23 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	dup = g_new0 (MailMergeProcessorParser, 1);
#line 23 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	memcpy (dup, self, sizeof (MailMergeProcessorParser));
#line 23 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	return dup;
#line 1819 "mail-merge-processor.c"
}

static void
mail_merge_processor_parser_free (MailMergeProcessorParser* self)
{
#line 23 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_free (self);
#line 1827 "mail-merge-processor.c"
}

static GType
mail_merge_processor_parser_get_type_once (void)
{
	GType mail_merge_processor_parser_type_id;
	mail_merge_processor_parser_type_id = g_boxed_type_register_static ("MailMergeProcessorParser", (GBoxedCopyFunc) mail_merge_processor_parser_dup, (GBoxedFreeFunc) mail_merge_processor_parser_free);
	return mail_merge_processor_parser_type_id;
}

static GType
mail_merge_processor_parser_get_type (void)
{
	static volatile gsize mail_merge_processor_parser_type_id__once = 0;
	if (g_once_init_enter (&mail_merge_processor_parser_type_id__once)) {
		GType mail_merge_processor_parser_type_id;
		mail_merge_processor_parser_type_id = mail_merge_processor_parser_get_type_once ();
		g_once_init_leave (&mail_merge_processor_parser_type_id__once, mail_merge_processor_parser_type_id);
	}
	return mail_merge_processor_parser_type_id__once;
}

static void
mail_merge_processor_class_init (MailMergeProcessorClass * klass,
                                 gpointer klass_data)
{
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	mail_merge_processor_parent_class = g_type_class_peek_parent (klass);
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_type_class_adjust_private_offset (klass, &MailMergeProcessor_private_offset);
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_mail_merge_processor_get_property;
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_mail_merge_processor_set_property;
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	G_OBJECT_CLASS (klass)->finalize = mail_merge_processor_finalize;
#line 1864 "mail-merge-processor.c"
	/** The email template being processed. */
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_MERGE_PROCESSOR_TEMPLATE_PROPERTY, mail_merge_processor_properties[MAIL_MERGE_PROCESSOR_TEMPLATE_PROPERTY] = g_param_spec_object ("template", "template", "template", GEARY_TYPE_EMAIL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1868 "mail-merge-processor.c"
	/** The email constructed by the processor. */
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_MERGE_PROCESSOR_EMAIL_PROPERTY, mail_merge_processor_properties[MAIL_MERGE_PROCESSOR_EMAIL_PROPERTY] = g_param_spec_object ("email", "email", "email", GEARY_TYPE_COMPOSED_EMAIL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1872 "mail-merge-processor.c"
	/** A list of data fields missing when processing the template. */
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_MERGE_PROCESSOR_MISSING_FIELDS_PROPERTY, mail_merge_processor_properties[MAIL_MERGE_PROCESSOR_MISSING_FIELDS_PROPERTY] = g_param_spec_object ("missing-fields", "missing-fields", "missing-fields", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1876 "mail-merge-processor.c"
}

static void
mail_merge_processor_instance_init (MailMergeProcessor * self,
                                    gpointer klass)
{
	GeeLinkedList* _tmp0_;
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	self->priv = mail_merge_processor_get_instance_private (self);
#line 154 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	self->priv->_email = NULL;
#line 159 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_tmp0_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 159 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	self->priv->_missing_fields = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_LIST, GeeList);
#line 1892 "mail-merge-processor.c"
}

static void
mail_merge_processor_finalize (GObject * obj)
{
	MailMergeProcessor * self;
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAIL_MERGE_TYPE_PROCESSOR, MailMergeProcessor);
#line 149 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_g_object_unref0 (self->priv->_template);
#line 154 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_g_object_unref0 (self->priv->_email);
#line 159 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	_g_object_unref0 (self->priv->_missing_fields);
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	G_OBJECT_CLASS (mail_merge_processor_parent_class)->finalize (obj);
#line 1909 "mail-merge-processor.c"
}

/**
 * Substitutes merge fields in an email with actual data.
 */
static GType
mail_merge_processor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MailMergeProcessorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mail_merge_processor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MailMergeProcessor), 0, (GInstanceInitFunc) mail_merge_processor_instance_init, NULL };
	GType mail_merge_processor_type_id;
	mail_merge_processor_type_id = g_type_register_static (G_TYPE_OBJECT, "MailMergeProcessor", &g_define_type_info, 0);
	MailMergeProcessor_private_offset = g_type_add_instance_private (mail_merge_processor_type_id, sizeof (MailMergeProcessorPrivate));
	return mail_merge_processor_type_id;
}

GType
mail_merge_processor_get_type (void)
{
	static volatile gsize mail_merge_processor_type_id__once = 0;
	if (g_once_init_enter (&mail_merge_processor_type_id__once)) {
		GType mail_merge_processor_type_id;
		mail_merge_processor_type_id = mail_merge_processor_get_type_once ();
		g_once_init_leave (&mail_merge_processor_type_id__once, mail_merge_processor_type_id);
	}
	return mail_merge_processor_type_id__once;
}

static void
_vala_mail_merge_processor_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	MailMergeProcessor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MAIL_MERGE_TYPE_PROCESSOR, MailMergeProcessor);
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	switch (property_id) {
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		case MAIL_MERGE_PROCESSOR_TEMPLATE_PROPERTY:
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		g_value_set_object (value, mail_merge_processor_get_template (self));
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		break;
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		case MAIL_MERGE_PROCESSOR_EMAIL_PROPERTY:
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		g_value_set_object (value, mail_merge_processor_get_email (self));
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		break;
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		case MAIL_MERGE_PROCESSOR_MISSING_FIELDS_PROPERTY:
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		g_value_set_object (value, mail_merge_processor_get_missing_fields (self));
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		break;
#line 1965 "mail-merge-processor.c"
		default:
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		break;
#line 1971 "mail-merge-processor.c"
	}
}

static void
_vala_mail_merge_processor_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	MailMergeProcessor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MAIL_MERGE_TYPE_PROCESSOR, MailMergeProcessor);
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
	switch (property_id) {
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		case MAIL_MERGE_PROCESSOR_TEMPLATE_PROPERTY:
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		mail_merge_processor_set_template (self, g_value_get_object (value));
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		break;
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		case MAIL_MERGE_PROCESSOR_EMAIL_PROPERTY:
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		mail_merge_processor_set_email (self, g_value_get_object (value));
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		break;
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		case MAIL_MERGE_PROCESSOR_MISSING_FIELDS_PROPERTY:
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		mail_merge_processor_set_missing_fields (self, g_value_get_object (value));
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		break;
#line 2003 "mail-merge-processor.c"
		default:
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 11 "../src/client/plugin/mail-merge/mail-merge-processor.vala"
		break;
#line 2009 "mail-merge-processor.c"
	}
}

