/* geary-account.c generated by valac 0.56.17, the Vala compiler
 * generated from geary-account.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2018-2019 Michael Gratton <mike@vee.net>.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define GEARY_ACCOUNT_AUTH_ATTEMPTS_MAX ((guint) 3)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_ACCOUNT_0_PROPERTY,
	GEARY_ACCOUNT_INFORMATION_PROPERTY,
	GEARY_ACCOUNT_CURRENT_STATUS_PROPERTY,
	GEARY_ACCOUNT_INCOMING_PROPERTY,
	GEARY_ACCOUNT_OUTGOING_PROPERTY,
	GEARY_ACCOUNT_CONTACT_STORE_PROPERTY,
	GEARY_ACCOUNT_LOCAL_FOLDER_ROOT_PROPERTY,
	GEARY_ACCOUNT_BACKGROUND_PROGRESS_PROPERTY,
	GEARY_ACCOUNT_DB_UPGRADE_MONITOR_PROPERTY,
	GEARY_ACCOUNT_DB_VACUUM_MONITOR_PROPERTY,
	GEARY_ACCOUNT_LAST_STORAGE_CLEANUP_PROPERTY,
	GEARY_ACCOUNT_LOGGING_PARENT_PROPERTY,
	GEARY_ACCOUNT_NUM_PROPERTIES
};
static GParamSpec* geary_account_properties[GEARY_ACCOUNT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
enum  {
	GEARY_ACCOUNT_OPENED_SIGNAL,
	GEARY_ACCOUNT_CLOSED_SIGNAL,
	GEARY_ACCOUNT_REPORT_PROBLEM_SIGNAL,
	GEARY_ACCOUNT_FOLDERS_AVAILABLE_UNAVAILABLE_SIGNAL,
	GEARY_ACCOUNT_FOLDERS_CREATED_SIGNAL,
	GEARY_ACCOUNT_FOLDERS_DELETED_SIGNAL,
	GEARY_ACCOUNT_FOLDERS_USE_CHANGED_SIGNAL,
	GEARY_ACCOUNT_EMAIL_APPENDED_SIGNAL,
	GEARY_ACCOUNT_EMAIL_INSERTED_SIGNAL,
	GEARY_ACCOUNT_EMAIL_REMOVED_SIGNAL,
	GEARY_ACCOUNT_EMAIL_LOCALLY_REMOVED_SIGNAL,
	GEARY_ACCOUNT_EMAIL_LOCALLY_COMPLETE_SIGNAL,
	GEARY_ACCOUNT_EMAIL_DISCOVERED_SIGNAL,
	GEARY_ACCOUNT_EMAIL_FLAGS_CHANGED_SIGNAL,
	GEARY_ACCOUNT_NUM_SIGNALS
};
static guint geary_account_signals[GEARY_ACCOUNT_NUM_SIGNALS] = {0};

struct _GearyAccountPrivate {
	GearyAccountInformation* _information;
	GearyAccountStatus _current_status;
	GearyClientService* _incoming;
	GearyClientService* _outgoing;
	GearyContactStore* _contact_store;
	GearyFolderRoot* _local_folder_root;
	GearyProgressMonitor* _background_progress;
	GearyProgressMonitor* _db_upgrade_monitor;
	GearyProgressMonitor* _db_vacuum_monitor;
	GDateTime* _last_storage_cleanup;
};

struct _Block1Data {
	int _ref_count_;
	GearyAccount* self;
	GearyFolderSpecialUse use;
};

static gint GearyAccount_private_offset;
static gpointer geary_account_parent_class = NULL;
static GearyLoggingSourceIface * geary_account_geary_logging_source_parent_iface = NULL;

static gint _geary_account_folder_path_comparator_gcompare_data_func (gconstpointer a,
                                                               gconstpointer b,
                                                               gpointer self);
static void geary_account_set_incoming (GearyAccount* self,
                                 GearyClientService* value);
static void geary_account_set_outgoing (GearyAccount* self,
                                 GearyClientService* value);
static void geary_account_set_local_folder_root (GearyAccount* self,
                                          GearyFolderRoot* value);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void geary_account_on_service_status_notify (GearyAccount* self);
static void _geary_account_on_service_status_notify_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self);
static gboolean geary_account_real_is_open (GearyAccount* self);
static void geary_account_real_cancel_remote_update (GearyAccount* self);
static GearyEmailIdentifier* geary_account_real_to_email_identifier (GearyAccount* self,
                                                              GVariant* serialised,
                                                              GError** error);
static GearyFolderPath* geary_account_real_to_folder_path (GearyAccount* self,
                                                    GVariant* serialised,
                                                    GError** error);
static gboolean geary_account_real_has_folder (GearyAccount* self,
                                        GearyFolderPath* path);
static GearyFolder* geary_account_real_get_folder (GearyAccount* self,
                                            GearyFolderPath* path,
                                            GError** error);
static GeeCollection* geary_account_real_list_folders (GearyAccount* self);
static GeeCollection* geary_account_real_list_matching_folders (GearyAccount* self,
                                                         GearyFolderPath* parent,
                                                         GError** error);
static GearyFolder* geary_account_real_get_special_folder (GearyAccount* self,
                                                    GearyFolderSpecialUse use);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda126_ (Block1Data* _data1_,
                       GearyFolder* f);
static gboolean ___lambda126__gee_predicate (gconstpointer g,
                                      gpointer self);
static void geary_account_real_register_local_folder (GearyAccount* self,
                                               GearyFolder* local,
                                               GError** error);
static void geary_account_real_deregister_local_folder (GearyAccount* self,
                                                 GearyFolder* local,
                                                 GError** error);
static GearySearchQuery* geary_account_real_new_search_query (GearyAccount* self,
                                                       GeeList* expression,
                                                       const gchar* text,
                                                       GError** error);
static GearyLoggingState* geary_account_real_to_logging_state (GearyAccount* self);
static void geary_account_real_notify_opened (GearyAccount* self);
static void geary_account_real_notify_closed (GearyAccount* self);
static void geary_account_real_notify_folders_available_unavailable (GearyAccount* self,
                                                              GeeBidirSortedSet* available,
                                                              GeeBidirSortedSet* unavailable);
static void geary_account_real_notify_folders_created (GearyAccount* self,
                                                GeeBidirSortedSet* created);
static void geary_account_real_notify_folders_deleted (GearyAccount* self,
                                                GeeBidirSortedSet* deleted);
static void geary_account_real_notify_email_appended (GearyAccount* self,
                                               GearyFolder* folder,
                                               GeeCollection* ids);
static void geary_account_real_notify_email_inserted (GearyAccount* self,
                                               GearyFolder* folder,
                                               GeeCollection* ids);
static void geary_account_real_notify_email_removed (GearyAccount* self,
                                              GearyFolder* folder,
                                              GeeCollection* ids);
static void geary_account_real_notify_email_locally_removed (GearyAccount* self,
                                                      GearyFolder* folder,
                                                      GeeCollection* ids);
static void geary_account_real_notify_email_locally_complete (GearyAccount* self,
                                                       GearyFolder* folder,
                                                       GeeCollection* ids);
static void geary_account_real_notify_email_discovered (GearyAccount* self,
                                                 GearyFolder* folder,
                                                 GeeCollection* ids);
static void geary_account_real_notify_email_flags_changed (GearyAccount* self,
                                                    GearyFolder* folder,
                                                    GeeMap* flag_map);
static void geary_account_real_notify_report_problem (GearyAccount* self,
                                               GearyProblemReport* report);
static void geary_account_real_notify_account_problem (GearyAccount* self,
                                                GError* err);
static void geary_account_real_notify_service_problem (GearyAccount* self,
                                                GearyServiceInformation* service,
                                                GError* err);
static void geary_account_finalize (GObject * obj);
static GType geary_account_get_type_once (void);
static void _vala_geary_account_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_geary_account_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);

static inline gpointer
geary_account_get_instance_private (GearyAccount* self)
{
	return G_STRUCT_MEMBER_P (self, GearyAccount_private_offset);
}

/**
     * Denotes the account's current status.
     *
     * @see Account.current_status
     * @see ClientService.current_status
     */
/** Determines if the {@link ONLINE} flag is set. */
gboolean
geary_account_status_is_online (GearyAccountStatus self)
{
	gboolean result;
#line 63 "../src/engine/api/geary-account.vala"
	result = (self & GEARY_ACCOUNT_STATUS_ONLINE) == GEARY_ACCOUNT_STATUS_ONLINE;
#line 63 "../src/engine/api/geary-account.vala"
	return result;
#line 216 "geary-account.c"
}

/** Determines if the {@link SERVICE_PROBLEM} flag is set. */
gboolean
geary_account_status_has_service_problem (GearyAccountStatus self)
{
	gboolean result;
#line 68 "../src/engine/api/geary-account.vala"
	result = (self & GEARY_ACCOUNT_STATUS_SERVICE_PROBLEM) == GEARY_ACCOUNT_STATUS_SERVICE_PROBLEM;
#line 68 "../src/engine/api/geary-account.vala"
	return result;
#line 228 "geary-account.c"
}

 G_GNUC_NO_INLINE static GType
geary_account_status_get_type_once (void)
{
	static const GFlagsValue values[] = {{GEARY_ACCOUNT_STATUS_ONLINE, "GEARY_ACCOUNT_STATUS_ONLINE", "online"}, {GEARY_ACCOUNT_STATUS_SERVICE_PROBLEM, "GEARY_ACCOUNT_STATUS_SERVICE_PROBLEM", "service-problem"}, {0, NULL, NULL}};
	GType geary_account_status_type_id;
	geary_account_status_type_id = g_flags_register_static ("GearyAccountStatus", values);
	return geary_account_status_type_id;
}

GType
geary_account_status_get_type (void)
{
	static gsize geary_account_status_type_id__once = 0;
	if (g_once_init_enter (&geary_account_status_type_id__once)) {
		GType geary_account_status_type_id;
		geary_account_status_type_id = geary_account_status_get_type_once ();
		g_once_init_leave (&geary_account_status_type_id__once, geary_account_status_type_id);
	}
	return geary_account_status_type_id__once;
}

/**
     * A utility method to sort a Gee.Collection of {@link Folder}s by
     * their {@link FolderPath}s to ensure they comport with {@link
     * folders_available_unavailable}, {@link folders_created}, {@link
     * folders_deleted} signals' contracts.
     */
static gint
_geary_account_folder_path_comparator_gcompare_data_func (gconstpointer a,
                                                          gconstpointer b,
                                                          gpointer self)
{
	gint result;
	result = geary_account_folder_path_comparator ((GearyFolder*) a, (GearyFolder*) b);
#line 81 "../src/engine/api/geary-account.vala"
	return result;
#line 267 "geary-account.c"
}

GeeBidirSortedSet*
geary_account_sort_by_path (GeeCollection* folders)
{
	GeeTreeSet* sorted = NULL;
	GeeTreeSet* _tmp0_;
	GeeBidirSortedSet* result;
#line 79 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (folders, GEE_TYPE_COLLECTION), NULL);
#line 81 "../src/engine/api/geary-account.vala"
	_tmp0_ = gee_tree_set_new (GEARY_TYPE_FOLDER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _geary_account_folder_path_comparator_gcompare_data_func, NULL, NULL);
#line 81 "../src/engine/api/geary-account.vala"
	sorted = _tmp0_;
#line 83 "../src/engine/api/geary-account.vala"
	gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (sorted, GEE_TYPE_COLLECTION, GeeCollection), folders);
#line 84 "../src/engine/api/geary-account.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (sorted, GEE_TYPE_BIDIR_SORTED_SET, GeeBidirSortedSet);
#line 84 "../src/engine/api/geary-account.vala"
	return result;
#line 288 "geary-account.c"
}

/**
     * Comparator used to sort folders.
     *
     * @see sort_by_path
     */
gint
geary_account_folder_path_comparator (GearyFolder* a,
                                      GearyFolder* b)
{
	GearyFolderPath* _tmp0_;
	GearyFolderPath* _tmp1_;
	GearyFolderPath* _tmp2_;
	GearyFolderPath* _tmp3_;
	gint result;
#line 92 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_FOLDER (a), 0);
#line 92 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_FOLDER (b), 0);
#line 93 "../src/engine/api/geary-account.vala"
	_tmp0_ = geary_folder_get_path (a);
#line 93 "../src/engine/api/geary-account.vala"
	_tmp1_ = _tmp0_;
#line 93 "../src/engine/api/geary-account.vala"
	_tmp2_ = geary_folder_get_path (b);
#line 93 "../src/engine/api/geary-account.vala"
	_tmp3_ = _tmp2_;
#line 93 "../src/engine/api/geary-account.vala"
	result = gee_comparable_compare_to (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COMPARABLE, GeeComparable), _tmp3_);
#line 93 "../src/engine/api/geary-account.vala"
	return result;
#line 321 "geary-account.c"
}

GearyAccountInformation*
geary_account_get_information (GearyAccount* self)
{
	GearyAccountInformation* result;
	GearyAccountInformation* _tmp0_;
#line 100 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT (self), NULL);
#line 100 "../src/engine/api/geary-account.vala"
	_tmp0_ = self->priv->_information;
#line 100 "../src/engine/api/geary-account.vala"
	result = _tmp0_;
#line 100 "../src/engine/api/geary-account.vala"
	return result;
#line 337 "geary-account.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 100 "../src/engine/api/geary-account.vala"
	return self ? g_object_ref (self) : NULL;
#line 345 "geary-account.c"
}

void
geary_account_set_information (GearyAccount* self,
                               GearyAccountInformation* value)
{
	GearyAccountInformation* old_value;
#line 100 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 100 "../src/engine/api/geary-account.vala"
	old_value = geary_account_get_information (self);
#line 100 "../src/engine/api/geary-account.vala"
	if (old_value != value) {
#line 359 "geary-account.c"
		GearyAccountInformation* _tmp0_;
#line 100 "../src/engine/api/geary-account.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 100 "../src/engine/api/geary-account.vala"
		_g_object_unref0 (self->priv->_information);
#line 100 "../src/engine/api/geary-account.vala"
		self->priv->_information = _tmp0_;
#line 100 "../src/engine/api/geary-account.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_account_properties[GEARY_ACCOUNT_INFORMATION_PROPERTY]);
#line 369 "geary-account.c"
	}
}

GearyAccountStatus
geary_account_get_current_status (GearyAccount* self)
{
	GearyAccountStatus result;
#line 117 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT (self), 0U);
#line 117 "../src/engine/api/geary-account.vala"
	result = self->priv->_current_status;
#line 117 "../src/engine/api/geary-account.vala"
	return result;
#line 383 "geary-account.c"
}

void
geary_account_set_current_status (GearyAccount* self,
                                  GearyAccountStatus value)
{
	GearyAccountStatus old_value;
#line 117 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 117 "../src/engine/api/geary-account.vala"
	old_value = geary_account_get_current_status (self);
#line 117 "../src/engine/api/geary-account.vala"
	if (old_value != value) {
#line 117 "../src/engine/api/geary-account.vala"
		self->priv->_current_status = value;
#line 117 "../src/engine/api/geary-account.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_account_properties[GEARY_ACCOUNT_CURRENT_STATUS_PROPERTY]);
#line 401 "geary-account.c"
	}
}

GearyClientService*
geary_account_get_incoming (GearyAccount* self)
{
	GearyClientService* result;
	GearyClientService* _tmp0_;
#line 122 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT (self), NULL);
#line 122 "../src/engine/api/geary-account.vala"
	_tmp0_ = self->priv->_incoming;
#line 122 "../src/engine/api/geary-account.vala"
	result = _tmp0_;
#line 122 "../src/engine/api/geary-account.vala"
	return result;
#line 418 "geary-account.c"
}

static void
geary_account_set_incoming (GearyAccount* self,
                            GearyClientService* value)
{
	GearyClientService* old_value;
#line 122 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 122 "../src/engine/api/geary-account.vala"
	old_value = geary_account_get_incoming (self);
#line 122 "../src/engine/api/geary-account.vala"
	if (old_value != value) {
#line 432 "geary-account.c"
		GearyClientService* _tmp0_;
#line 122 "../src/engine/api/geary-account.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 122 "../src/engine/api/geary-account.vala"
		_g_object_unref0 (self->priv->_incoming);
#line 122 "../src/engine/api/geary-account.vala"
		self->priv->_incoming = _tmp0_;
#line 122 "../src/engine/api/geary-account.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_account_properties[GEARY_ACCOUNT_INCOMING_PROPERTY]);
#line 442 "geary-account.c"
	}
}

GearyClientService*
geary_account_get_outgoing (GearyAccount* self)
{
	GearyClientService* result;
	GearyClientService* _tmp0_;
#line 127 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT (self), NULL);
#line 127 "../src/engine/api/geary-account.vala"
	_tmp0_ = self->priv->_outgoing;
#line 127 "../src/engine/api/geary-account.vala"
	result = _tmp0_;
#line 127 "../src/engine/api/geary-account.vala"
	return result;
#line 459 "geary-account.c"
}

static void
geary_account_set_outgoing (GearyAccount* self,
                            GearyClientService* value)
{
	GearyClientService* old_value;
#line 127 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 127 "../src/engine/api/geary-account.vala"
	old_value = geary_account_get_outgoing (self);
#line 127 "../src/engine/api/geary-account.vala"
	if (old_value != value) {
#line 473 "geary-account.c"
		GearyClientService* _tmp0_;
#line 127 "../src/engine/api/geary-account.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 127 "../src/engine/api/geary-account.vala"
		_g_object_unref0 (self->priv->_outgoing);
#line 127 "../src/engine/api/geary-account.vala"
		self->priv->_outgoing = _tmp0_;
#line 127 "../src/engine/api/geary-account.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_account_properties[GEARY_ACCOUNT_OUTGOING_PROPERTY]);
#line 483 "geary-account.c"
	}
}

GearyContactStore*
geary_account_get_contact_store (GearyAccount* self)
{
	GearyContactStore* result;
	GearyContactStore* _tmp0_;
#line 132 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT (self), NULL);
#line 132 "../src/engine/api/geary-account.vala"
	_tmp0_ = self->priv->_contact_store;
#line 132 "../src/engine/api/geary-account.vala"
	result = _tmp0_;
#line 132 "../src/engine/api/geary-account.vala"
	return result;
#line 500 "geary-account.c"
}

void
geary_account_set_contact_store (GearyAccount* self,
                                 GearyContactStore* value)
{
	GearyContactStore* old_value;
#line 132 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 132 "../src/engine/api/geary-account.vala"
	old_value = geary_account_get_contact_store (self);
#line 132 "../src/engine/api/geary-account.vala"
	if (old_value != value) {
#line 514 "geary-account.c"
		GearyContactStore* _tmp0_;
#line 132 "../src/engine/api/geary-account.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 132 "../src/engine/api/geary-account.vala"
		_g_object_unref0 (self->priv->_contact_store);
#line 132 "../src/engine/api/geary-account.vala"
		self->priv->_contact_store = _tmp0_;
#line 132 "../src/engine/api/geary-account.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_account_properties[GEARY_ACCOUNT_CONTACT_STORE_PROPERTY]);
#line 524 "geary-account.c"
	}
}

GearyFolderRoot*
geary_account_get_local_folder_root (GearyAccount* self)
{
	GearyFolderRoot* result;
	GearyFolderRoot* _tmp0_;
#line 141 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT (self), NULL);
#line 141 "../src/engine/api/geary-account.vala"
	_tmp0_ = self->priv->_local_folder_root;
#line 141 "../src/engine/api/geary-account.vala"
	result = _tmp0_;
#line 141 "../src/engine/api/geary-account.vala"
	return result;
#line 541 "geary-account.c"
}

static void
geary_account_set_local_folder_root (GearyAccount* self,
                                     GearyFolderRoot* value)
{
	GearyFolderRoot* old_value;
#line 141 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 141 "../src/engine/api/geary-account.vala"
	old_value = geary_account_get_local_folder_root (self);
#line 141 "../src/engine/api/geary-account.vala"
	if (old_value != value) {
#line 555 "geary-account.c"
		GearyFolderRoot* _tmp0_;
#line 141 "../src/engine/api/geary-account.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 141 "../src/engine/api/geary-account.vala"
		_g_object_unref0 (self->priv->_local_folder_root);
#line 141 "../src/engine/api/geary-account.vala"
		self->priv->_local_folder_root = _tmp0_;
#line 141 "../src/engine/api/geary-account.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_account_properties[GEARY_ACCOUNT_LOCAL_FOLDER_ROOT_PROPERTY]);
#line 565 "geary-account.c"
	}
}

GearyProgressMonitor*
geary_account_get_background_progress (GearyAccount* self)
{
	GearyProgressMonitor* result;
	GearyProgressMonitor* _tmp0_;
#line 144 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT (self), NULL);
#line 144 "../src/engine/api/geary-account.vala"
	_tmp0_ = self->priv->_background_progress;
#line 144 "../src/engine/api/geary-account.vala"
	result = _tmp0_;
#line 144 "../src/engine/api/geary-account.vala"
	return result;
#line 582 "geary-account.c"
}

void
geary_account_set_background_progress (GearyAccount* self,
                                       GearyProgressMonitor* value)
{
	GearyProgressMonitor* old_value;
#line 144 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 144 "../src/engine/api/geary-account.vala"
	old_value = geary_account_get_background_progress (self);
#line 144 "../src/engine/api/geary-account.vala"
	if (old_value != value) {
#line 596 "geary-account.c"
		GearyProgressMonitor* _tmp0_;
#line 144 "../src/engine/api/geary-account.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 144 "../src/engine/api/geary-account.vala"
		_g_object_unref0 (self->priv->_background_progress);
#line 144 "../src/engine/api/geary-account.vala"
		self->priv->_background_progress = _tmp0_;
#line 144 "../src/engine/api/geary-account.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_account_properties[GEARY_ACCOUNT_BACKGROUND_PROGRESS_PROPERTY]);
#line 606 "geary-account.c"
	}
}

GearyProgressMonitor*
geary_account_get_db_upgrade_monitor (GearyAccount* self)
{
	GearyProgressMonitor* result;
	GearyProgressMonitor* _tmp0_;
#line 145 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT (self), NULL);
#line 145 "../src/engine/api/geary-account.vala"
	_tmp0_ = self->priv->_db_upgrade_monitor;
#line 145 "../src/engine/api/geary-account.vala"
	result = _tmp0_;
#line 145 "../src/engine/api/geary-account.vala"
	return result;
#line 623 "geary-account.c"
}

void
geary_account_set_db_upgrade_monitor (GearyAccount* self,
                                      GearyProgressMonitor* value)
{
	GearyProgressMonitor* old_value;
#line 145 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 145 "../src/engine/api/geary-account.vala"
	old_value = geary_account_get_db_upgrade_monitor (self);
#line 145 "../src/engine/api/geary-account.vala"
	if (old_value != value) {
#line 637 "geary-account.c"
		GearyProgressMonitor* _tmp0_;
#line 145 "../src/engine/api/geary-account.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 145 "../src/engine/api/geary-account.vala"
		_g_object_unref0 (self->priv->_db_upgrade_monitor);
#line 145 "../src/engine/api/geary-account.vala"
		self->priv->_db_upgrade_monitor = _tmp0_;
#line 145 "../src/engine/api/geary-account.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_account_properties[GEARY_ACCOUNT_DB_UPGRADE_MONITOR_PROPERTY]);
#line 647 "geary-account.c"
	}
}

GearyProgressMonitor*
geary_account_get_db_vacuum_monitor (GearyAccount* self)
{
	GearyProgressMonitor* result;
	GearyProgressMonitor* _tmp0_;
#line 146 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT (self), NULL);
#line 146 "../src/engine/api/geary-account.vala"
	_tmp0_ = self->priv->_db_vacuum_monitor;
#line 146 "../src/engine/api/geary-account.vala"
	result = _tmp0_;
#line 146 "../src/engine/api/geary-account.vala"
	return result;
#line 664 "geary-account.c"
}

void
geary_account_set_db_vacuum_monitor (GearyAccount* self,
                                     GearyProgressMonitor* value)
{
	GearyProgressMonitor* old_value;
#line 146 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 146 "../src/engine/api/geary-account.vala"
	old_value = geary_account_get_db_vacuum_monitor (self);
#line 146 "../src/engine/api/geary-account.vala"
	if (old_value != value) {
#line 678 "geary-account.c"
		GearyProgressMonitor* _tmp0_;
#line 146 "../src/engine/api/geary-account.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 146 "../src/engine/api/geary-account.vala"
		_g_object_unref0 (self->priv->_db_vacuum_monitor);
#line 146 "../src/engine/api/geary-account.vala"
		self->priv->_db_vacuum_monitor = _tmp0_;
#line 146 "../src/engine/api/geary-account.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_account_properties[GEARY_ACCOUNT_DB_VACUUM_MONITOR_PROPERTY]);
#line 688 "geary-account.c"
	}
}

GDateTime*
geary_account_get_last_storage_cleanup (GearyAccount* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 158 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT (self), NULL);
#line 158 "../src/engine/api/geary-account.vala"
	_tmp0_ = self->priv->_last_storage_cleanup;
#line 158 "../src/engine/api/geary-account.vala"
	result = _tmp0_;
#line 158 "../src/engine/api/geary-account.vala"
	return result;
#line 705 "geary-account.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 158 "../src/engine/api/geary-account.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 713 "geary-account.c"
}

void
geary_account_set_last_storage_cleanup (GearyAccount* self,
                                        GDateTime* value)
{
	GDateTime* old_value;
#line 158 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 158 "../src/engine/api/geary-account.vala"
	old_value = geary_account_get_last_storage_cleanup (self);
#line 158 "../src/engine/api/geary-account.vala"
	if (old_value != value) {
#line 727 "geary-account.c"
		GDateTime* _tmp0_;
#line 158 "../src/engine/api/geary-account.vala"
		_tmp0_ = _g_date_time_ref0 (value);
#line 158 "../src/engine/api/geary-account.vala"
		_g_date_time_unref0 (self->priv->_last_storage_cleanup);
#line 158 "../src/engine/api/geary-account.vala"
		self->priv->_last_storage_cleanup = _tmp0_;
#line 158 "../src/engine/api/geary-account.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_account_properties[GEARY_ACCOUNT_LAST_STORAGE_CLEANUP_PROPERTY]);
#line 737 "geary-account.c"
	}
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 25 "../src/engine/api/geary-account.vala"
	g_return_if_fail (n_param_values == 3);
#line 25 "../src/engine/api/geary-account.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 25 "../src/engine/api/geary-account.vala"
		data1 = closure->data;
#line 25 "../src/engine/api/geary-account.vala"
		data2 = param_values->data[0].v_pointer;
#line 763 "geary-account.c"
	} else {
#line 25 "../src/engine/api/geary-account.vala"
		data1 = param_values->data[0].v_pointer;
#line 25 "../src/engine/api/geary-account.vala"
		data2 = closure->data;
#line 769 "geary-account.c"
	}
#line 25 "../src/engine/api/geary-account.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 25 "../src/engine/api/geary-account.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 775 "geary-account.c"
}

static GearyLoggingSource*
geary_account_real_get_logging_parent (GearyLoggingSource* base)
{
	GearyLoggingSource* result;
	GearyAccount* self;
#line 270 "../src/engine/api/geary-account.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_ACCOUNT, GearyAccount);
#line 270 "../src/engine/api/geary-account.vala"
	result = NULL;
#line 270 "../src/engine/api/geary-account.vala"
	return result;
#line 789 "geary-account.c"
}

static void
_geary_account_on_service_status_notify_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self)
{
#line 280 "../src/engine/api/geary-account.vala"
	geary_account_on_service_status_notify ((GearyAccount*) self);
#line 799 "geary-account.c"
}

GearyAccount*
geary_account_construct (GType object_type,
                         GearyAccountInformation* information,
                         GearyClientService* incoming,
                         GearyClientService* outgoing)
{
	GearyAccount * self = NULL;
#line 273 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (information), NULL);
#line 273 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_CLIENT_SERVICE (incoming), NULL);
#line 273 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_CLIENT_SERVICE (outgoing), NULL);
#line 273 "../src/engine/api/geary-account.vala"
	self = (GearyAccount*) geary_base_object_construct (object_type);
#line 276 "../src/engine/api/geary-account.vala"
	geary_account_set_information (self, information);
#line 277 "../src/engine/api/geary-account.vala"
	geary_account_set_incoming (self, incoming);
#line 278 "../src/engine/api/geary-account.vala"
	geary_account_set_outgoing (self, outgoing);
#line 280 "../src/engine/api/geary-account.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (incoming, G_TYPE_OBJECT, GObject), "notify::current-status", (GCallback) _geary_account_on_service_status_notify_g_object_notify, self, 0);
#line 283 "../src/engine/api/geary-account.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (outgoing, G_TYPE_OBJECT, GObject), "notify::current-status", (GCallback) _geary_account_on_service_status_notify_g_object_notify, self, 0);
#line 273 "../src/engine/api/geary-account.vala"
	return self;
#line 829 "geary-account.c"
}

void
geary_account_open_async (GearyAccount* self,
                          GCancellable* cancellable,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_)
{
	GearyAccountClass* _klass_;
#line 25 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 25 "../src/engine/api/geary-account.vala"
	if (_klass_->open_async) {
#line 25 "../src/engine/api/geary-account.vala"
		_klass_->open_async (self, cancellable, _callback_, _user_data_);
#line 845 "geary-account.c"
	}
}

void
geary_account_open_finish (GearyAccount* self,
                           GAsyncResult* _res_,
                           GError** error)
{
	GearyAccountClass* _klass_;
#line 25 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 25 "../src/engine/api/geary-account.vala"
	if (_klass_->open_finish) {
#line 25 "../src/engine/api/geary-account.vala"
		_klass_->open_finish (self, _res_, error);
#line 861 "geary-account.c"
	}
}

void
geary_account_close_async (GearyAccount* self,
                           GCancellable* cancellable,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_)
{
	GearyAccountClass* _klass_;
#line 25 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 25 "../src/engine/api/geary-account.vala"
	if (_klass_->close_async) {
#line 25 "../src/engine/api/geary-account.vala"
		_klass_->close_async (self, cancellable, _callback_, _user_data_);
#line 878 "geary-account.c"
	}
}

void
geary_account_close_finish (GearyAccount* self,
                            GAsyncResult* _res_,
                            GError** error)
{
	GearyAccountClass* _klass_;
#line 25 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 25 "../src/engine/api/geary-account.vala"
	if (_klass_->close_finish) {
#line 25 "../src/engine/api/geary-account.vala"
		_klass_->close_finish (self, _res_, error);
#line 894 "geary-account.c"
	}
}

/**
     * Returns true if this account is open, else false.
     */
static gboolean
geary_account_real_is_open (GearyAccount* self)
{
	gboolean _tmp0_ = FALSE;
#line 310 "../src/engine/api/geary-account.vala"
	g_critical ("Type `%s' does not implement abstract method `geary_account_is_open'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 310 "../src/engine/api/geary-account.vala"
	return _tmp0_;
#line 909 "geary-account.c"
}

gboolean
geary_account_is_open (GearyAccount* self)
{
	GearyAccountClass* _klass_;
#line 310 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT (self), FALSE);
#line 310 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 310 "../src/engine/api/geary-account.vala"
	if (_klass_->is_open) {
#line 310 "../src/engine/api/geary-account.vala"
		return _klass_->is_open (self);
#line 924 "geary-account.c"
	}
#line 310 "../src/engine/api/geary-account.vala"
	return FALSE;
#line 928 "geary-account.c"
}

/**
     * Cancel any running/pending remote update for this {@link Account}.
     */
static void
geary_account_real_cancel_remote_update (GearyAccount* self)
{
#line 315 "../src/engine/api/geary-account.vala"
	g_critical ("Type `%s' does not implement abstract method `geary_account_cancel_remote_update'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 315 "../src/engine/api/geary-account.vala"
	return;
#line 941 "geary-account.c"
}

void
geary_account_cancel_remote_update (GearyAccount* self)
{
	GearyAccountClass* _klass_;
#line 315 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 315 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 315 "../src/engine/api/geary-account.vala"
	if (_klass_->cancel_remote_update) {
#line 315 "../src/engine/api/geary-account.vala"
		_klass_->cancel_remote_update (self);
#line 956 "geary-account.c"
	}
}

void
geary_account_rebuild_async (GearyAccount* self,
                             GCancellable* cancellable,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_)
{
	GearyAccountClass* _klass_;
#line 25 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 25 "../src/engine/api/geary-account.vala"
	if (_klass_->rebuild_async) {
#line 25 "../src/engine/api/geary-account.vala"
		_klass_->rebuild_async (self, cancellable, _callback_, _user_data_);
#line 973 "geary-account.c"
	}
}

void
geary_account_rebuild_finish (GearyAccount* self,
                              GAsyncResult* _res_,
                              GError** error)
{
	GearyAccountClass* _klass_;
#line 25 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 25 "../src/engine/api/geary-account.vala"
	if (_klass_->rebuild_finish) {
#line 25 "../src/engine/api/geary-account.vala"
		_klass_->rebuild_finish (self, _res_, error);
#line 989 "geary-account.c"
	}
}

/**
     * Returns an email identifier from its serialised form.
     *
     * This is useful for converting a string representation of a
     * email id back into an actual instance of an id. This does not
     * guarantee that the email represented by the id will exist.
     *
     * @see EmailIdentifier.to_variant
     * @throws EngineError.BAD_PARAMETERS when the variant is not the
     * have the correct type.
     */
static GearyEmailIdentifier*
geary_account_real_to_email_identifier (GearyAccount* self,
                                        GVariant* serialised,
                                        GError** error)
{
#line 344 "../src/engine/api/geary-account.vala"
	g_critical ("Type `%s' does not implement abstract method `geary_account_to_email_identifier'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 344 "../src/engine/api/geary-account.vala"
	return NULL;
#line 1013 "geary-account.c"
}

GearyEmailIdentifier*
geary_account_to_email_identifier (GearyAccount* self,
                                   GVariant* serialised,
                                   GError** error)
{
	GearyAccountClass* _klass_;
#line 344 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT (self), NULL);
#line 344 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 344 "../src/engine/api/geary-account.vala"
	if (_klass_->to_email_identifier) {
#line 344 "../src/engine/api/geary-account.vala"
		return _klass_->to_email_identifier (self, serialised, error);
#line 1030 "geary-account.c"
	}
#line 344 "../src/engine/api/geary-account.vala"
	return NULL;
#line 1034 "geary-account.c"
}

/**
     * Returns the folder path from its serialised form.
     *
     * This is useful for converting a string representation of a
     * folder path back into an actual instance of a path. This does
     * not guarantee that the folder represented by the path will
     * exist.
     *
     * @see FolderPath.to_variant
     * @throws EngineError.BAD_PARAMETERS when the variant is not the
     * have the correct type or if no folder root with an appropriate
     * label exists.
     */
static GearyFolderPath*
geary_account_real_to_folder_path (GearyAccount* self,
                                   GVariant* serialised,
                                   GError** error)
{
#line 360 "../src/engine/api/geary-account.vala"
	g_critical ("Type `%s' does not implement abstract method `geary_account_to_folder_path'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 360 "../src/engine/api/geary-account.vala"
	return NULL;
#line 1059 "geary-account.c"
}

GearyFolderPath*
geary_account_to_folder_path (GearyAccount* self,
                              GVariant* serialised,
                              GError** error)
{
	GearyAccountClass* _klass_;
#line 360 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT (self), NULL);
#line 360 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 360 "../src/engine/api/geary-account.vala"
	if (_klass_->to_folder_path) {
#line 360 "../src/engine/api/geary-account.vala"
		return _klass_->to_folder_path (self, serialised, error);
#line 1076 "geary-account.c"
	}
#line 360 "../src/engine/api/geary-account.vala"
	return NULL;
#line 1080 "geary-account.c"
}

/**
     * Determines if a folder is known to the engine.
     *
     * This method only considers currently known folders, it does not
     * check the remote to see if a previously folder exists.
     */
static gboolean
geary_account_real_has_folder (GearyAccount* self,
                               GearyFolderPath* path)
{
	gboolean _tmp3_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 369 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_FOLDER_PATH (path), FALSE);
#line 1098 "geary-account.c"
	{
		GearyFolder* _tmp0_;
		GearyFolder* _tmp1_;
#line 371 "../src/engine/api/geary-account.vala"
		_tmp0_ = geary_account_get_folder (self, path, &_inner_error0_);
#line 371 "../src/engine/api/geary-account.vala"
		_tmp1_ = _tmp0_;
#line 371 "../src/engine/api/geary-account.vala"
		_g_object_unref0 (_tmp1_);
#line 371 "../src/engine/api/geary-account.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1110 "geary-account.c"
			gboolean _tmp2_ = FALSE;
#line 371 "../src/engine/api/geary-account.vala"
			if (g_error_matches (_inner_error0_, GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_NOT_FOUND)) {
#line 1114 "geary-account.c"
				goto __catch0_geary_engine_error_not_found;
			}
#line 371 "../src/engine/api/geary-account.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 371 "../src/engine/api/geary-account.vala"
			g_clear_error (&_inner_error0_);
#line 371 "../src/engine/api/geary-account.vala"
			return _tmp2_;
#line 1123 "geary-account.c"
		}
#line 372 "../src/engine/api/geary-account.vala"
		result = TRUE;
#line 372 "../src/engine/api/geary-account.vala"
		return result;
#line 1129 "geary-account.c"
	}
	goto __finally0;
	__catch0_geary_engine_error_not_found:
	{
#line 370 "../src/engine/api/geary-account.vala"
		g_clear_error (&_inner_error0_);
#line 374 "../src/engine/api/geary-account.vala"
		result = FALSE;
#line 374 "../src/engine/api/geary-account.vala"
		return result;
#line 1140 "geary-account.c"
	}
	__finally0:
#line 370 "../src/engine/api/geary-account.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 370 "../src/engine/api/geary-account.vala"
	g_clear_error (&_inner_error0_);
#line 370 "../src/engine/api/geary-account.vala"
	return _tmp3_;
#line 1149 "geary-account.c"
}

gboolean
geary_account_has_folder (GearyAccount* self,
                          GearyFolderPath* path)
{
	GearyAccountClass* _klass_;
#line 369 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT (self), FALSE);
#line 369 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 369 "../src/engine/api/geary-account.vala"
	if (_klass_->has_folder) {
#line 369 "../src/engine/api/geary-account.vala"
		return _klass_->has_folder (self, path);
#line 1165 "geary-account.c"
	}
#line 369 "../src/engine/api/geary-account.vala"
	return FALSE;
#line 1169 "geary-account.c"
}

/**
     * Returns the folder represented by a specific path.
     *
     * This method only considers currently known folders, it does not
     * check the remote to see if a previously folder exists.
     *
     * @throws EngineError.NOT_FOUND if the folder does not exist.
     */
static GearyFolder*
geary_account_real_get_folder (GearyAccount* self,
                               GearyFolderPath* path,
                               GError** error)
{
#line 386 "../src/engine/api/geary-account.vala"
	g_critical ("Type `%s' does not implement abstract method `geary_account_get_folder'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 386 "../src/engine/api/geary-account.vala"
	return NULL;
#line 1189 "geary-account.c"
}

GearyFolder*
geary_account_get_folder (GearyAccount* self,
                          GearyFolderPath* path,
                          GError** error)
{
	GearyAccountClass* _klass_;
#line 386 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT (self), NULL);
#line 386 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 386 "../src/engine/api/geary-account.vala"
	if (_klass_->get_folder) {
#line 386 "../src/engine/api/geary-account.vala"
		return _klass_->get_folder (self, path, error);
#line 1206 "geary-account.c"
	}
#line 386 "../src/engine/api/geary-account.vala"
	return NULL;
#line 1210 "geary-account.c"
}

/**
     * Lists all currently-available folders.
     *
     * @see list_matching_folders
     */
static GeeCollection*
geary_account_real_list_folders (GearyAccount* self)
{
#line 394 "../src/engine/api/geary-account.vala"
	g_critical ("Type `%s' does not implement abstract method `geary_account_list_folders'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 394 "../src/engine/api/geary-account.vala"
	return NULL;
#line 1225 "geary-account.c"
}

GeeCollection*
geary_account_list_folders (GearyAccount* self)
{
	GearyAccountClass* _klass_;
#line 394 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT (self), NULL);
#line 394 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 394 "../src/engine/api/geary-account.vala"
	if (_klass_->list_folders) {
#line 394 "../src/engine/api/geary-account.vala"
		return _klass_->list_folders (self);
#line 1240 "geary-account.c"
	}
#line 394 "../src/engine/api/geary-account.vala"
	return NULL;
#line 1244 "geary-account.c"
}

/**
     * Lists all currently-available folders found a under parent.
     *
     * If the parent path cannot be found, EngineError.NOT_FOUND is
     * thrown. However, the caller should be prepared to deal with an
     * empty list being returned instead.
     */
static GeeCollection*
geary_account_real_list_matching_folders (GearyAccount* self,
                                          GearyFolderPath* parent,
                                          GError** error)
{
#line 403 "../src/engine/api/geary-account.vala"
	g_critical ("Type `%s' does not implement abstract method `geary_account_list_matching_folders'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 403 "../src/engine/api/geary-account.vala"
	return NULL;
#line 1263 "geary-account.c"
}

GeeCollection*
geary_account_list_matching_folders (GearyAccount* self,
                                     GearyFolderPath* parent,
                                     GError** error)
{
	GearyAccountClass* _klass_;
#line 403 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT (self), NULL);
#line 403 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 403 "../src/engine/api/geary-account.vala"
	if (_klass_->list_matching_folders) {
#line 403 "../src/engine/api/geary-account.vala"
		return _klass_->list_matching_folders (self, parent, error);
#line 1280 "geary-account.c"
	}
#line 403 "../src/engine/api/geary-account.vala"
	return NULL;
#line 1284 "geary-account.c"
}

/**
     * Returns a folder for the given special folder type, it is exists.
     */
static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 409 "../src/engine/api/geary-account.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 409 "../src/engine/api/geary-account.vala"
	return _data1_;
#line 1297 "geary-account.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 409 "../src/engine/api/geary-account.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 1307 "geary-account.c"
		GearyAccount* self;
#line 409 "../src/engine/api/geary-account.vala"
		self = _data1_->self;
#line 409 "../src/engine/api/geary-account.vala"
		_g_object_unref0 (self);
#line 409 "../src/engine/api/geary-account.vala"
		g_slice_free (Block1Data, _data1_);
#line 1315 "geary-account.c"
	}
}

static gboolean
__lambda126_ (Block1Data* _data1_,
              GearyFolder* f)
{
	GearyAccount* self;
	GearyFolderSpecialUse _tmp0_;
	GearyFolderSpecialUse _tmp1_;
	gboolean result;
#line 411 "../src/engine/api/geary-account.vala"
	self = _data1_->self;
#line 411 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_FOLDER (f), FALSE);
#line 411 "../src/engine/api/geary-account.vala"
	_tmp0_ = geary_folder_get_used_as (f);
#line 411 "../src/engine/api/geary-account.vala"
	_tmp1_ = _tmp0_;
#line 411 "../src/engine/api/geary-account.vala"
	result = _tmp1_ == _data1_->use;
#line 411 "../src/engine/api/geary-account.vala"
	return result;
#line 1339 "geary-account.c"
}

static gboolean
___lambda126__gee_predicate (gconstpointer g,
                             gpointer self)
{
	gboolean result;
	result = __lambda126_ (self, (GearyFolder*) g);
#line 410 "../src/engine/api/geary-account.vala"
	return result;
#line 1350 "geary-account.c"
}

static GearyFolder*
geary_account_real_get_special_folder (GearyAccount* self,
                                       GearyFolderSpecialUse use)
{
	Block1Data* _data1_;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	GearyIterable* _tmp2_;
	GearyIterable* _tmp3_;
	gpointer _tmp4_;
	GearyFolder* _tmp5_;
	GearyFolder* result;
#line 409 "../src/engine/api/geary-account.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 409 "../src/engine/api/geary-account.vala"
	_data1_->_ref_count_ = 1;
#line 409 "../src/engine/api/geary-account.vala"
	_data1_->self = g_object_ref (self);
#line 409 "../src/engine/api/geary-account.vala"
	_data1_->use = use;
#line 410 "../src/engine/api/geary-account.vala"
	_tmp0_ = geary_account_list_folders (self);
#line 410 "../src/engine/api/geary-account.vala"
	_tmp1_ = _tmp0_;
#line 410 "../src/engine/api/geary-account.vala"
	_tmp2_ = geary_traverse (GEARY_TYPE_FOLDER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ITERABLE, GeeIterable));
#line 410 "../src/engine/api/geary-account.vala"
	_tmp3_ = _tmp2_;
#line 410 "../src/engine/api/geary-account.vala"
	_tmp4_ = geary_iterable_first_matching (_tmp3_, ___lambda126__gee_predicate, block1_data_ref (_data1_), block1_data_unref);
#line 410 "../src/engine/api/geary-account.vala"
	_tmp5_ = (GearyFolder*) _tmp4_;
#line 410 "../src/engine/api/geary-account.vala"
	_g_object_unref0 (_tmp3_);
#line 410 "../src/engine/api/geary-account.vala"
	_g_object_unref0 (_tmp1_);
#line 410 "../src/engine/api/geary-account.vala"
	result = _tmp5_;
#line 410 "../src/engine/api/geary-account.vala"
	block1_data_unref (_data1_);
#line 410 "../src/engine/api/geary-account.vala"
	_data1_ = NULL;
#line 410 "../src/engine/api/geary-account.vala"
	return result;
#line 1397 "geary-account.c"
}

GearyFolder*
geary_account_get_special_folder (GearyAccount* self,
                                  GearyFolderSpecialUse use)
{
	GearyAccountClass* _klass_;
#line 409 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT (self), NULL);
#line 409 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 409 "../src/engine/api/geary-account.vala"
	if (_klass_->get_special_folder) {
#line 409 "../src/engine/api/geary-account.vala"
		return _klass_->get_special_folder (self, use);
#line 1413 "geary-account.c"
	}
#line 409 "../src/engine/api/geary-account.vala"
	return NULL;
#line 1417 "geary-account.c"
}

void
geary_account_get_required_special_folder_async (GearyAccount* self,
                                                 GearyFolderSpecialUse special,
                                                 GCancellable* cancellable,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_)
{
	GearyAccountClass* _klass_;
#line 25 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 25 "../src/engine/api/geary-account.vala"
	if (_klass_->get_required_special_folder_async) {
#line 25 "../src/engine/api/geary-account.vala"
		_klass_->get_required_special_folder_async (self, special, cancellable, _callback_, _user_data_);
#line 1434 "geary-account.c"
	}
}

GearyFolder*
geary_account_get_required_special_folder_finish (GearyAccount* self,
                                                  GAsyncResult* _res_,
                                                  GError** error)
{
	GearyAccountClass* _klass_;
#line 25 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 25 "../src/engine/api/geary-account.vala"
	if (_klass_->get_required_special_folder_finish) {
#line 25 "../src/engine/api/geary-account.vala"
		return _klass_->get_required_special_folder_finish (self, _res_, error);
#line 1450 "geary-account.c"
	}
#line 25 "../src/engine/api/geary-account.vala"
	return NULL;
#line 1454 "geary-account.c"
}

void
geary_account_create_personal_folder (GearyAccount* self,
                                      const gchar* name,
                                      GearyFolderSpecialUse use,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	GearyAccountClass* _klass_;
#line 25 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 25 "../src/engine/api/geary-account.vala"
	if (_klass_->create_personal_folder) {
#line 25 "../src/engine/api/geary-account.vala"
		_klass_->create_personal_folder (self, name, use, cancellable, _callback_, _user_data_);
#line 1472 "geary-account.c"
	}
}

GearyFolder*
geary_account_create_personal_folder_finish (GearyAccount* self,
                                             GAsyncResult* _res_,
                                             GError** error)
{
	GearyAccountClass* _klass_;
#line 25 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 25 "../src/engine/api/geary-account.vala"
	if (_klass_->create_personal_folder_finish) {
#line 25 "../src/engine/api/geary-account.vala"
		return _klass_->create_personal_folder_finish (self, _res_, error);
#line 1488 "geary-account.c"
	}
#line 25 "../src/engine/api/geary-account.vala"
	return NULL;
#line 1492 "geary-account.c"
}

/**
     * Registers a local folder with the account.
     *
     * The registering a local folder will cause the account will hook
     * to the folder's signals such as {@link Folder.email_appended}
     * and forward them on to the account-wide equivalents, include
     * the list folder in the folder list, allow email in the folder
     * to be found by account-wide operations, and so on. The folder
     * will then be signalled as being available via {@link
     * folders_available_unavailable}.
     *
     * A {@link EngineError.ALREADY_EXISTS} exception will be thrown
     * if the given folder is already registered, or {@link
     * EngineError.NOT_FOUND} if its path does not have {@link
     * local_folder_root} as its root.
     *
     * @see deregister_local_folder
     */
static void
geary_account_real_register_local_folder (GearyAccount* self,
                                          GearyFolder* local,
                                          GError** error)
{
#line 455 "../src/engine/api/geary-account.vala"
	g_critical ("Type `%s' does not implement abstract method `geary_account_register_local_folder'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 455 "../src/engine/api/geary-account.vala"
	return;
#line 1522 "geary-account.c"
}

void
geary_account_register_local_folder (GearyAccount* self,
                                     GearyFolder* local,
                                     GError** error)
{
	GearyAccountClass* _klass_;
#line 455 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 455 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 455 "../src/engine/api/geary-account.vala"
	if (_klass_->register_local_folder) {
#line 455 "../src/engine/api/geary-account.vala"
		_klass_->register_local_folder (self, local, error);
#line 1539 "geary-account.c"
	}
}

/**
     * De-registers a local folder with the account.
     *
     * De-registering a previously registered local folder will signal
     * it as being unavailable via {@link
     * folders_available_unavailable} and unhook it from the account.
     *
     * A {@link local_folder_root} error will be thrown if the given
     * folder is not already registered.
     *
     * @see register_local_folder
     */
static void
geary_account_real_deregister_local_folder (GearyAccount* self,
                                            GearyFolder* local,
                                            GError** error)
{
#line 470 "../src/engine/api/geary-account.vala"
	g_critical ("Type `%s' does not implement abstract method `geary_account_deregister_local_folder'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 470 "../src/engine/api/geary-account.vala"
	return;
#line 1564 "geary-account.c"
}

void
geary_account_deregister_local_folder (GearyAccount* self,
                                       GearyFolder* local,
                                       GError** error)
{
	GearyAccountClass* _klass_;
#line 470 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 470 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 470 "../src/engine/api/geary-account.vala"
	if (_klass_->deregister_local_folder) {
#line 470 "../src/engine/api/geary-account.vala"
		_klass_->deregister_local_folder (self, local, error);
#line 1581 "geary-account.c"
	}
}

void
geary_account_local_search_message_id_async (GearyAccount* self,
                                             GearyRFC822MessageID* message_id,
                                             GearyEmailField requested_fields,
                                             gboolean partial_ok,
                                             GeeCollection* folder_blacklist,
                                             GearyEmailFlags* flag_blacklist,
                                             GCancellable* cancellable,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_)
{
	GearyAccountClass* _klass_;
#line 25 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 25 "../src/engine/api/geary-account.vala"
	if (_klass_->local_search_message_id_async) {
#line 25 "../src/engine/api/geary-account.vala"
		_klass_->local_search_message_id_async (self, message_id, requested_fields, partial_ok, folder_blacklist, flag_blacklist, cancellable, _callback_, _user_data_);
#line 1603 "geary-account.c"
	}
}

GeeMultiMap*
geary_account_local_search_message_id_finish (GearyAccount* self,
                                              GAsyncResult* _res_,
                                              GError** error)
{
	GearyAccountClass* _klass_;
#line 25 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 25 "../src/engine/api/geary-account.vala"
	if (_klass_->local_search_message_id_finish) {
#line 25 "../src/engine/api/geary-account.vala"
		return _klass_->local_search_message_id_finish (self, _res_, error);
#line 1619 "geary-account.c"
	}
#line 25 "../src/engine/api/geary-account.vala"
	return NULL;
#line 1623 "geary-account.c"
}

void
geary_account_local_fetch_email_async (GearyAccount* self,
                                       GearyEmailIdentifier* email_id,
                                       GearyEmailField required_fields,
                                       GCancellable* cancellable,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	GearyAccountClass* _klass_;
#line 25 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 25 "../src/engine/api/geary-account.vala"
	if (_klass_->local_fetch_email_async) {
#line 25 "../src/engine/api/geary-account.vala"
		_klass_->local_fetch_email_async (self, email_id, required_fields, cancellable, _callback_, _user_data_);
#line 1641 "geary-account.c"
	}
}

GearyEmail*
geary_account_local_fetch_email_finish (GearyAccount* self,
                                        GAsyncResult* _res_,
                                        GError** error)
{
	GearyAccountClass* _klass_;
#line 25 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 25 "../src/engine/api/geary-account.vala"
	if (_klass_->local_fetch_email_finish) {
#line 25 "../src/engine/api/geary-account.vala"
		return _klass_->local_fetch_email_finish (self, _res_, error);
#line 1657 "geary-account.c"
	}
#line 25 "../src/engine/api/geary-account.vala"
	return NULL;
#line 1661 "geary-account.c"
}

void
geary_account_list_local_email_async (GearyAccount* self,
                                      GeeCollection* ids,
                                      GearyEmailField required_fields,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	GearyAccountClass* _klass_;
#line 25 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 25 "../src/engine/api/geary-account.vala"
	if (_klass_->list_local_email_async) {
#line 25 "../src/engine/api/geary-account.vala"
		_klass_->list_local_email_async (self, ids, required_fields, cancellable, _callback_, _user_data_);
#line 1679 "geary-account.c"
	}
}

GeeList*
geary_account_list_local_email_finish (GearyAccount* self,
                                       GAsyncResult* _res_,
                                       GError** error)
{
	GearyAccountClass* _klass_;
#line 25 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 25 "../src/engine/api/geary-account.vala"
	if (_klass_->list_local_email_finish) {
#line 25 "../src/engine/api/geary-account.vala"
		return _klass_->list_local_email_finish (self, _res_, error);
#line 1695 "geary-account.c"
	}
#line 25 "../src/engine/api/geary-account.vala"
	return NULL;
#line 1699 "geary-account.c"
}

/**
     * Create a new search query for this account.
     */
static GearySearchQuery*
geary_account_real_new_search_query (GearyAccount* self,
                                     GeeList* expression,
                                     const gchar* text,
                                     GError** error)
{
#line 517 "../src/engine/api/geary-account.vala"
	g_critical ("Type `%s' does not implement abstract method `geary_account_new_search_query'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 517 "../src/engine/api/geary-account.vala"
	return NULL;
#line 1715 "geary-account.c"
}

GearySearchQuery*
geary_account_new_search_query (GearyAccount* self,
                                GeeList* expression,
                                const gchar* text,
                                GError** error)
{
	GearyAccountClass* _klass_;
#line 517 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT (self), NULL);
#line 517 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 517 "../src/engine/api/geary-account.vala"
	if (_klass_->new_search_query) {
#line 517 "../src/engine/api/geary-account.vala"
		return _klass_->new_search_query (self, expression, text, error);
#line 1733 "geary-account.c"
	}
#line 517 "../src/engine/api/geary-account.vala"
	return NULL;
#line 1737 "geary-account.c"
}

void
geary_account_local_search_async (GearyAccount* self,
                                  GearySearchQuery* query,
                                  gint limit,
                                  gint offset,
                                  GeeCollection* folder_blacklist,
                                  GeeCollection* search_ids,
                                  GCancellable* cancellable,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	GearyAccountClass* _klass_;
#line 25 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 25 "../src/engine/api/geary-account.vala"
	if (_klass_->local_search_async) {
#line 25 "../src/engine/api/geary-account.vala"
		_klass_->local_search_async (self, query, limit, offset, folder_blacklist, search_ids, cancellable, _callback_, _user_data_);
#line 1758 "geary-account.c"
	}
}

GeeCollection*
geary_account_local_search_finish (GearyAccount* self,
                                   GAsyncResult* _res_,
                                   GError** error)
{
	GearyAccountClass* _klass_;
#line 25 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 25 "../src/engine/api/geary-account.vala"
	if (_klass_->local_search_finish) {
#line 25 "../src/engine/api/geary-account.vala"
		return _klass_->local_search_finish (self, _res_, error);
#line 1774 "geary-account.c"
	}
#line 25 "../src/engine/api/geary-account.vala"
	return NULL;
#line 1778 "geary-account.c"
}

void
geary_account_get_search_matches_async (GearyAccount* self,
                                        GearySearchQuery* query,
                                        GeeCollection* ids,
                                        GCancellable* cancellable,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	GearyAccountClass* _klass_;
#line 25 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 25 "../src/engine/api/geary-account.vala"
	if (_klass_->get_search_matches_async) {
#line 25 "../src/engine/api/geary-account.vala"
		_klass_->get_search_matches_async (self, query, ids, cancellable, _callback_, _user_data_);
#line 1796 "geary-account.c"
	}
}

GeeSet*
geary_account_get_search_matches_finish (GearyAccount* self,
                                         GAsyncResult* _res_,
                                         GError** error)
{
	GearyAccountClass* _klass_;
#line 25 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 25 "../src/engine/api/geary-account.vala"
	if (_klass_->get_search_matches_finish) {
#line 25 "../src/engine/api/geary-account.vala"
		return _klass_->get_search_matches_finish (self, _res_, error);
#line 1812 "geary-account.c"
	}
#line 25 "../src/engine/api/geary-account.vala"
	return NULL;
#line 1816 "geary-account.c"
}

void
geary_account_get_containing_folders_async (GearyAccount* self,
                                            GeeCollection* ids,
                                            GCancellable* cancellable,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	GearyAccountClass* _klass_;
#line 25 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 25 "../src/engine/api/geary-account.vala"
	if (_klass_->get_containing_folders_async) {
#line 25 "../src/engine/api/geary-account.vala"
		_klass_->get_containing_folders_async (self, ids, cancellable, _callback_, _user_data_);
#line 1833 "geary-account.c"
	}
}

GeeMultiMap*
geary_account_get_containing_folders_finish (GearyAccount* self,
                                             GAsyncResult* _res_,
                                             GError** error)
{
	GearyAccountClass* _klass_;
#line 25 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 25 "../src/engine/api/geary-account.vala"
	if (_klass_->get_containing_folders_finish) {
#line 25 "../src/engine/api/geary-account.vala"
		return _klass_->get_containing_folders_finish (self, _res_, error);
#line 1849 "geary-account.c"
	}
#line 25 "../src/engine/api/geary-account.vala"
	return NULL;
#line 1853 "geary-account.c"
}

/** {@inheritDoc} */
static GearyLoggingState*
geary_account_real_to_logging_state (GearyAccount* self)
{
	GearyAccountInformation* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GearyLoggingState* _tmp3_;
	GearyLoggingState* result;
#line 552 "../src/engine/api/geary-account.vala"
	_tmp0_ = self->priv->_information;
#line 552 "../src/engine/api/geary-account.vala"
	_tmp1_ = geary_account_information_get_id (_tmp0_);
#line 552 "../src/engine/api/geary-account.vala"
	_tmp2_ = _tmp1_;
#line 552 "../src/engine/api/geary-account.vala"
	_tmp3_ = geary_logging_state_new (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "%s", _tmp2_);
#line 552 "../src/engine/api/geary-account.vala"
	result = _tmp3_;
#line 552 "../src/engine/api/geary-account.vala"
	return result;
#line 1877 "geary-account.c"
}

GearyLoggingState*
geary_account_to_logging_state (GearyAccount* self)
{
	GearyAccountClass* _klass_;
#line 551 "../src/engine/api/geary-account.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT (self), NULL);
#line 551 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 551 "../src/engine/api/geary-account.vala"
	if (_klass_->to_logging_state) {
#line 551 "../src/engine/api/geary-account.vala"
		return _klass_->to_logging_state (self);
#line 1892 "geary-account.c"
	}
#line 551 "../src/engine/api/geary-account.vala"
	return NULL;
#line 1896 "geary-account.c"
}

void
geary_account_cleanup_storage (GearyAccount* self,
                               GCancellable* cancellable,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	GearyAccountClass* _klass_;
#line 25 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 25 "../src/engine/api/geary-account.vala"
	if (_klass_->cleanup_storage) {
#line 25 "../src/engine/api/geary-account.vala"
		_klass_->cleanup_storage (self, cancellable, _callback_, _user_data_);
#line 1912 "geary-account.c"
	}
}

void
geary_account_cleanup_storage_finish (GearyAccount* self,
                                      GAsyncResult* _res_,
                                      GError** error)
{
	GearyAccountClass* _klass_;
#line 25 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 25 "../src/engine/api/geary-account.vala"
	if (_klass_->cleanup_storage_finish) {
#line 25 "../src/engine/api/geary-account.vala"
		_klass_->cleanup_storage_finish (self, _res_, error);
#line 1928 "geary-account.c"
	}
}

/** Fires a {@link opened} signal. */
static void
geary_account_real_notify_opened (GearyAccount* self)
{
#line 568 "../src/engine/api/geary-account.vala"
	g_signal_emit (self, geary_account_signals[GEARY_ACCOUNT_OPENED_SIGNAL], 0);
#line 1938 "geary-account.c"
}

void
geary_account_notify_opened (GearyAccount* self)
{
	GearyAccountClass* _klass_;
#line 567 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 567 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 567 "../src/engine/api/geary-account.vala"
	if (_klass_->notify_opened) {
#line 567 "../src/engine/api/geary-account.vala"
		_klass_->notify_opened (self);
#line 1953 "geary-account.c"
	}
}

/** Fires a {@link closed} signal. */
static void
geary_account_real_notify_closed (GearyAccount* self)
{
#line 573 "../src/engine/api/geary-account.vala"
	g_signal_emit (self, geary_account_signals[GEARY_ACCOUNT_CLOSED_SIGNAL], 0);
#line 1963 "geary-account.c"
}

void
geary_account_notify_closed (GearyAccount* self)
{
	GearyAccountClass* _klass_;
#line 572 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 572 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 572 "../src/engine/api/geary-account.vala"
	if (_klass_->notify_closed) {
#line 572 "../src/engine/api/geary-account.vala"
		_klass_->notify_closed (self);
#line 1978 "geary-account.c"
	}
}

/** Fires a {@link folders_available_unavailable} signal. */
static void
geary_account_real_notify_folders_available_unavailable (GearyAccount* self,
                                                         GeeBidirSortedSet* available,
                                                         GeeBidirSortedSet* unavailable)
{
#line 577 "../src/engine/api/geary-account.vala"
	g_return_if_fail ((available == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (available, GEE_TYPE_BIDIR_SORTED_SET));
#line 577 "../src/engine/api/geary-account.vala"
	g_return_if_fail ((unavailable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (unavailable, GEE_TYPE_BIDIR_SORTED_SET));
#line 580 "../src/engine/api/geary-account.vala"
	g_signal_emit (self, geary_account_signals[GEARY_ACCOUNT_FOLDERS_AVAILABLE_UNAVAILABLE_SIGNAL], 0, available, unavailable);
#line 1994 "geary-account.c"
}

void
geary_account_notify_folders_available_unavailable (GearyAccount* self,
                                                    GeeBidirSortedSet* available,
                                                    GeeBidirSortedSet* unavailable)
{
	GearyAccountClass* _klass_;
#line 577 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 577 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 577 "../src/engine/api/geary-account.vala"
	if (_klass_->notify_folders_available_unavailable) {
#line 577 "../src/engine/api/geary-account.vala"
		_klass_->notify_folders_available_unavailable (self, available, unavailable);
#line 2011 "geary-account.c"
	}
}

/** Fires a {@link folders_created} signal. */
static void
geary_account_real_notify_folders_created (GearyAccount* self,
                                           GeeBidirSortedSet* created)
{
#line 584 "../src/engine/api/geary-account.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (created, GEE_TYPE_BIDIR_SORTED_SET));
#line 585 "../src/engine/api/geary-account.vala"
	g_signal_emit (self, geary_account_signals[GEARY_ACCOUNT_FOLDERS_CREATED_SIGNAL], 0, created);
#line 2024 "geary-account.c"
}

void
geary_account_notify_folders_created (GearyAccount* self,
                                      GeeBidirSortedSet* created)
{
	GearyAccountClass* _klass_;
#line 584 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 584 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 584 "../src/engine/api/geary-account.vala"
	if (_klass_->notify_folders_created) {
#line 584 "../src/engine/api/geary-account.vala"
		_klass_->notify_folders_created (self, created);
#line 2040 "geary-account.c"
	}
}

/** Fires a {@link folders_deleted} signal. */
static void
geary_account_real_notify_folders_deleted (GearyAccount* self,
                                           GeeBidirSortedSet* deleted)
{
#line 589 "../src/engine/api/geary-account.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (deleted, GEE_TYPE_BIDIR_SORTED_SET));
#line 590 "../src/engine/api/geary-account.vala"
	g_signal_emit (self, geary_account_signals[GEARY_ACCOUNT_FOLDERS_DELETED_SIGNAL], 0, deleted);
#line 2053 "geary-account.c"
}

void
geary_account_notify_folders_deleted (GearyAccount* self,
                                      GeeBidirSortedSet* deleted)
{
	GearyAccountClass* _klass_;
#line 589 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 589 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 589 "../src/engine/api/geary-account.vala"
	if (_klass_->notify_folders_deleted) {
#line 589 "../src/engine/api/geary-account.vala"
		_klass_->notify_folders_deleted (self, deleted);
#line 2069 "geary-account.c"
	}
}

/** Fires a {@link email_appended} signal. */
static void
geary_account_real_notify_email_appended (GearyAccount* self,
                                          GearyFolder* folder,
                                          GeeCollection* ids)
{
#line 594 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 594 "../src/engine/api/geary-account.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (ids, GEE_TYPE_COLLECTION));
#line 595 "../src/engine/api/geary-account.vala"
	g_signal_emit (self, geary_account_signals[GEARY_ACCOUNT_EMAIL_APPENDED_SIGNAL], 0, folder, ids);
#line 2085 "geary-account.c"
}

void
geary_account_notify_email_appended (GearyAccount* self,
                                     GearyFolder* folder,
                                     GeeCollection* ids)
{
	GearyAccountClass* _klass_;
#line 594 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 594 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 594 "../src/engine/api/geary-account.vala"
	if (_klass_->notify_email_appended) {
#line 594 "../src/engine/api/geary-account.vala"
		_klass_->notify_email_appended (self, folder, ids);
#line 2102 "geary-account.c"
	}
}

/** Fires a {@link email_inserted} signal. */
static void
geary_account_real_notify_email_inserted (GearyAccount* self,
                                          GearyFolder* folder,
                                          GeeCollection* ids)
{
#line 599 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 599 "../src/engine/api/geary-account.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (ids, GEE_TYPE_COLLECTION));
#line 600 "../src/engine/api/geary-account.vala"
	g_signal_emit (self, geary_account_signals[GEARY_ACCOUNT_EMAIL_INSERTED_SIGNAL], 0, folder, ids);
#line 2118 "geary-account.c"
}

void
geary_account_notify_email_inserted (GearyAccount* self,
                                     GearyFolder* folder,
                                     GeeCollection* ids)
{
	GearyAccountClass* _klass_;
#line 599 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 599 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 599 "../src/engine/api/geary-account.vala"
	if (_klass_->notify_email_inserted) {
#line 599 "../src/engine/api/geary-account.vala"
		_klass_->notify_email_inserted (self, folder, ids);
#line 2135 "geary-account.c"
	}
}

/** Fires a {@link email_removed} signal. */
static void
geary_account_real_notify_email_removed (GearyAccount* self,
                                         GearyFolder* folder,
                                         GeeCollection* ids)
{
#line 604 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 604 "../src/engine/api/geary-account.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (ids, GEE_TYPE_COLLECTION));
#line 605 "../src/engine/api/geary-account.vala"
	g_signal_emit (self, geary_account_signals[GEARY_ACCOUNT_EMAIL_REMOVED_SIGNAL], 0, folder, ids);
#line 2151 "geary-account.c"
}

void
geary_account_notify_email_removed (GearyAccount* self,
                                    GearyFolder* folder,
                                    GeeCollection* ids)
{
	GearyAccountClass* _klass_;
#line 604 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 604 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 604 "../src/engine/api/geary-account.vala"
	if (_klass_->notify_email_removed) {
#line 604 "../src/engine/api/geary-account.vala"
		_klass_->notify_email_removed (self, folder, ids);
#line 2168 "geary-account.c"
	}
}

/** Fires a {@link email_locally_removed} signal. */
static void
geary_account_real_notify_email_locally_removed (GearyAccount* self,
                                                 GearyFolder* folder,
                                                 GeeCollection* ids)
{
#line 609 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 609 "../src/engine/api/geary-account.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (ids, GEE_TYPE_COLLECTION));
#line 610 "../src/engine/api/geary-account.vala"
	g_signal_emit (self, geary_account_signals[GEARY_ACCOUNT_EMAIL_LOCALLY_REMOVED_SIGNAL], 0, folder, ids);
#line 2184 "geary-account.c"
}

void
geary_account_notify_email_locally_removed (GearyAccount* self,
                                            GearyFolder* folder,
                                            GeeCollection* ids)
{
	GearyAccountClass* _klass_;
#line 609 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 609 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 609 "../src/engine/api/geary-account.vala"
	if (_klass_->notify_email_locally_removed) {
#line 609 "../src/engine/api/geary-account.vala"
		_klass_->notify_email_locally_removed (self, folder, ids);
#line 2201 "geary-account.c"
	}
}

/** Fires a {@link email_locally_complete} signal. */
static void
geary_account_real_notify_email_locally_complete (GearyAccount* self,
                                                  GearyFolder* folder,
                                                  GeeCollection* ids)
{
#line 614 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 614 "../src/engine/api/geary-account.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (ids, GEE_TYPE_COLLECTION));
#line 616 "../src/engine/api/geary-account.vala"
	g_signal_emit (self, geary_account_signals[GEARY_ACCOUNT_EMAIL_LOCALLY_COMPLETE_SIGNAL], 0, folder, ids);
#line 2217 "geary-account.c"
}

void
geary_account_notify_email_locally_complete (GearyAccount* self,
                                             GearyFolder* folder,
                                             GeeCollection* ids)
{
	GearyAccountClass* _klass_;
#line 614 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 614 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 614 "../src/engine/api/geary-account.vala"
	if (_klass_->notify_email_locally_complete) {
#line 614 "../src/engine/api/geary-account.vala"
		_klass_->notify_email_locally_complete (self, folder, ids);
#line 2234 "geary-account.c"
	}
}

/** Fires a {@link email_discovered} signal. */
static void
geary_account_real_notify_email_discovered (GearyAccount* self,
                                            GearyFolder* folder,
                                            GeeCollection* ids)
{
#line 620 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 620 "../src/engine/api/geary-account.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (ids, GEE_TYPE_COLLECTION));
#line 622 "../src/engine/api/geary-account.vala"
	g_signal_emit (self, geary_account_signals[GEARY_ACCOUNT_EMAIL_DISCOVERED_SIGNAL], 0, folder, ids);
#line 2250 "geary-account.c"
}

void
geary_account_notify_email_discovered (GearyAccount* self,
                                       GearyFolder* folder,
                                       GeeCollection* ids)
{
	GearyAccountClass* _klass_;
#line 620 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 620 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 620 "../src/engine/api/geary-account.vala"
	if (_klass_->notify_email_discovered) {
#line 620 "../src/engine/api/geary-account.vala"
		_klass_->notify_email_discovered (self, folder, ids);
#line 2267 "geary-account.c"
	}
}

/** Fires a {@link email_flags_changed} signal. */
static void
geary_account_real_notify_email_flags_changed (GearyAccount* self,
                                               GearyFolder* folder,
                                               GeeMap* flag_map)
{
#line 626 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 626 "../src/engine/api/geary-account.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (flag_map, GEE_TYPE_MAP));
#line 628 "../src/engine/api/geary-account.vala"
	g_signal_emit (self, geary_account_signals[GEARY_ACCOUNT_EMAIL_FLAGS_CHANGED_SIGNAL], 0, folder, flag_map);
#line 2283 "geary-account.c"
}

void
geary_account_notify_email_flags_changed (GearyAccount* self,
                                          GearyFolder* folder,
                                          GeeMap* flag_map)
{
	GearyAccountClass* _klass_;
#line 626 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 626 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 626 "../src/engine/api/geary-account.vala"
	if (_klass_->notify_email_flags_changed) {
#line 626 "../src/engine/api/geary-account.vala"
		_klass_->notify_email_flags_changed (self, folder, flag_map);
#line 2300 "geary-account.c"
	}
}

/** Fires a {@link report_problem} signal for this account. */
static void
geary_account_real_notify_report_problem (GearyAccount* self,
                                          GearyProblemReport* report)
{
#line 632 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_PROBLEM_REPORT (report));
#line 633 "../src/engine/api/geary-account.vala"
	g_signal_emit (self, geary_account_signals[GEARY_ACCOUNT_REPORT_PROBLEM_SIGNAL], 0, report);
#line 2313 "geary-account.c"
}

void
geary_account_notify_report_problem (GearyAccount* self,
                                     GearyProblemReport* report)
{
	GearyAccountClass* _klass_;
#line 632 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 632 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 632 "../src/engine/api/geary-account.vala"
	if (_klass_->notify_report_problem) {
#line 632 "../src/engine/api/geary-account.vala"
		_klass_->notify_report_problem (self, report);
#line 2329 "geary-account.c"
	}
}

/**
     * Fires a {@link report_problem} signal for this account.
     */
static void
geary_account_real_notify_account_problem (GearyAccount* self,
                                           GError* err)
{
	GearyAccountInformation* _tmp0_;
	GearyAccountProblemReport* _tmp1_;
	GearyAccountProblemReport* _tmp2_;
#line 640 "../src/engine/api/geary-account.vala"
	_tmp0_ = self->priv->_information;
#line 640 "../src/engine/api/geary-account.vala"
	_tmp1_ = geary_account_problem_report_new (_tmp0_, err);
#line 640 "../src/engine/api/geary-account.vala"
	_tmp2_ = _tmp1_;
#line 640 "../src/engine/api/geary-account.vala"
	g_signal_emit (self, geary_account_signals[GEARY_ACCOUNT_REPORT_PROBLEM_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEARY_TYPE_PROBLEM_REPORT, GearyProblemReport));
#line 640 "../src/engine/api/geary-account.vala"
	_g_object_unref0 (_tmp2_);
#line 2353 "geary-account.c"
}

void
geary_account_notify_account_problem (GearyAccount* self,
                                      GError* err)
{
	GearyAccountClass* _klass_;
#line 639 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 639 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 639 "../src/engine/api/geary-account.vala"
	if (_klass_->notify_account_problem) {
#line 639 "../src/engine/api/geary-account.vala"
		_klass_->notify_account_problem (self, err);
#line 2369 "geary-account.c"
	}
}

/** Fires a {@link report_problem} signal for a service for this account. */
static void
geary_account_real_notify_service_problem (GearyAccount* self,
                                           GearyServiceInformation* service,
                                           GError* err)
{
	GearyAccountInformation* _tmp0_;
	GearyServiceProblemReport* _tmp1_;
	GearyServiceProblemReport* _tmp2_;
#line 644 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_SERVICE_INFORMATION (service));
#line 646 "../src/engine/api/geary-account.vala"
	_tmp0_ = self->priv->_information;
#line 646 "../src/engine/api/geary-account.vala"
	_tmp1_ = geary_service_problem_report_new (_tmp0_, service, err);
#line 646 "../src/engine/api/geary-account.vala"
	_tmp2_ = _tmp1_;
#line 646 "../src/engine/api/geary-account.vala"
	g_signal_emit (self, geary_account_signals[GEARY_ACCOUNT_REPORT_PROBLEM_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEARY_TYPE_PROBLEM_REPORT, GearyProblemReport));
#line 646 "../src/engine/api/geary-account.vala"
	_g_object_unref0 (_tmp2_);
#line 2394 "geary-account.c"
}

void
geary_account_notify_service_problem (GearyAccount* self,
                                      GearyServiceInformation* service,
                                      GError* err)
{
	GearyAccountClass* _klass_;
#line 644 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 644 "../src/engine/api/geary-account.vala"
	_klass_ = GEARY_ACCOUNT_GET_CLASS (self);
#line 644 "../src/engine/api/geary-account.vala"
	if (_klass_->notify_service_problem) {
#line 644 "../src/engine/api/geary-account.vala"
		_klass_->notify_service_problem (self, service, err);
#line 2411 "geary-account.c"
	}
}

static void
geary_account_on_service_status_notify (GearyAccount* self)
{
	GearyAccountStatus new_status = 0U;
	GearyClientService* _tmp0_;
	GearyClientServiceStatus _tmp1_;
	GearyClientServiceStatus _tmp2_;
	gboolean _tmp3_ = FALSE;
	GearyClientService* _tmp4_;
	GearyClientServiceStatus _tmp5_;
	GearyClientServiceStatus _tmp6_;
#line 651 "../src/engine/api/geary-account.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT (self));
#line 652 "../src/engine/api/geary-account.vala"
	new_status = 0;
#line 658 "../src/engine/api/geary-account.vala"
	_tmp0_ = self->priv->_incoming;
#line 658 "../src/engine/api/geary-account.vala"
	_tmp1_ = geary_client_service_get_current_status (_tmp0_);
#line 658 "../src/engine/api/geary-account.vala"
	_tmp2_ = _tmp1_;
#line 658 "../src/engine/api/geary-account.vala"
	if (_tmp2_ != GEARY_CLIENT_SERVICE_STATUS_UNREACHABLE) {
#line 659 "../src/engine/api/geary-account.vala"
		new_status |= GEARY_ACCOUNT_STATUS_ONLINE;
#line 2440 "geary-account.c"
	}
#line 661 "../src/engine/api/geary-account.vala"
	_tmp4_ = self->priv->_incoming;
#line 661 "../src/engine/api/geary-account.vala"
	_tmp5_ = geary_client_service_get_current_status (_tmp4_);
#line 661 "../src/engine/api/geary-account.vala"
	_tmp6_ = _tmp5_;
#line 661 "../src/engine/api/geary-account.vala"
	if (geary_client_service_status_is_error (_tmp6_)) {
#line 661 "../src/engine/api/geary-account.vala"
		_tmp3_ = TRUE;
#line 2452 "geary-account.c"
	} else {
		GearyClientService* _tmp7_;
		GearyClientServiceStatus _tmp8_;
		GearyClientServiceStatus _tmp9_;
#line 662 "../src/engine/api/geary-account.vala"
		_tmp7_ = self->priv->_outgoing;
#line 662 "../src/engine/api/geary-account.vala"
		_tmp8_ = geary_client_service_get_current_status (_tmp7_);
#line 662 "../src/engine/api/geary-account.vala"
		_tmp9_ = _tmp8_;
#line 662 "../src/engine/api/geary-account.vala"
		_tmp3_ = geary_client_service_status_is_error (_tmp9_);
#line 2465 "geary-account.c"
	}
#line 661 "../src/engine/api/geary-account.vala"
	if (_tmp3_) {
#line 663 "../src/engine/api/geary-account.vala"
		new_status |= GEARY_ACCOUNT_STATUS_SERVICE_PROBLEM;
#line 2471 "geary-account.c"
	}
#line 665 "../src/engine/api/geary-account.vala"
	geary_account_set_current_status (self, new_status);
#line 2475 "geary-account.c"
}

static void
geary_account_class_init (GearyAccountClass * klass,
                          gpointer klass_data)
{
#line 25 "../src/engine/api/geary-account.vala"
	geary_account_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/engine/api/geary-account.vala"
	g_type_class_adjust_private_offset (klass, &GearyAccount_private_offset);
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->is_open = (gboolean (*) (GearyAccount*)) geary_account_real_is_open;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->cancel_remote_update = (void (*) (GearyAccount*)) geary_account_real_cancel_remote_update;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->to_email_identifier = (GearyEmailIdentifier* (*) (GearyAccount*, GVariant*, GError**)) geary_account_real_to_email_identifier;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->to_folder_path = (GearyFolderPath* (*) (GearyAccount*, GVariant*, GError**)) geary_account_real_to_folder_path;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->has_folder = (gboolean (*) (GearyAccount*, GearyFolderPath*)) geary_account_real_has_folder;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->get_folder = (GearyFolder* (*) (GearyAccount*, GearyFolderPath*, GError**)) geary_account_real_get_folder;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->list_folders = (GeeCollection* (*) (GearyAccount*)) geary_account_real_list_folders;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->list_matching_folders = (GeeCollection* (*) (GearyAccount*, GearyFolderPath*, GError**)) geary_account_real_list_matching_folders;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->get_special_folder = (GearyFolder* (*) (GearyAccount*, GearyFolderSpecialUse)) geary_account_real_get_special_folder;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->register_local_folder = (void (*) (GearyAccount*, GearyFolder*, GError**)) geary_account_real_register_local_folder;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->deregister_local_folder = (void (*) (GearyAccount*, GearyFolder*, GError**)) geary_account_real_deregister_local_folder;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->new_search_query = (GearySearchQuery* (*) (GearyAccount*, GeeList*, const gchar*, GError**)) geary_account_real_new_search_query;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->to_logging_state = (GearyLoggingState* (*) (GearyAccount*)) geary_account_real_to_logging_state;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->notify_opened = (void (*) (GearyAccount*)) geary_account_real_notify_opened;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->notify_closed = (void (*) (GearyAccount*)) geary_account_real_notify_closed;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->notify_folders_available_unavailable = (void (*) (GearyAccount*, GeeBidirSortedSet*, GeeBidirSortedSet*)) geary_account_real_notify_folders_available_unavailable;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->notify_folders_created = (void (*) (GearyAccount*, GeeBidirSortedSet*)) geary_account_real_notify_folders_created;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->notify_folders_deleted = (void (*) (GearyAccount*, GeeBidirSortedSet*)) geary_account_real_notify_folders_deleted;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->notify_email_appended = (void (*) (GearyAccount*, GearyFolder*, GeeCollection*)) geary_account_real_notify_email_appended;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->notify_email_inserted = (void (*) (GearyAccount*, GearyFolder*, GeeCollection*)) geary_account_real_notify_email_inserted;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->notify_email_removed = (void (*) (GearyAccount*, GearyFolder*, GeeCollection*)) geary_account_real_notify_email_removed;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->notify_email_locally_removed = (void (*) (GearyAccount*, GearyFolder*, GeeCollection*)) geary_account_real_notify_email_locally_removed;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->notify_email_locally_complete = (void (*) (GearyAccount*, GearyFolder*, GeeCollection*)) geary_account_real_notify_email_locally_complete;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->notify_email_discovered = (void (*) (GearyAccount*, GearyFolder*, GeeCollection*)) geary_account_real_notify_email_discovered;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->notify_email_flags_changed = (void (*) (GearyAccount*, GearyFolder*, GeeMap*)) geary_account_real_notify_email_flags_changed;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->notify_report_problem = (void (*) (GearyAccount*, GearyProblemReport*)) geary_account_real_notify_report_problem;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->notify_account_problem = (void (*) (GearyAccount*, GError*)) geary_account_real_notify_account_problem;
#line 25 "../src/engine/api/geary-account.vala"
	((GearyAccountClass *) klass)->notify_service_problem = (void (*) (GearyAccount*, GearyServiceInformation*, GError*)) geary_account_real_notify_service_problem;
#line 25 "../src/engine/api/geary-account.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_account_get_property;
#line 25 "../src/engine/api/geary-account.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_account_set_property;
#line 25 "../src/engine/api/geary-account.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_account_finalize;
#line 2548 "geary-account.c"
	/**
	     * The account's current configuration.
	     */
#line 25 "../src/engine/api/geary-account.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_INFORMATION_PROPERTY, geary_account_properties[GEARY_ACCOUNT_INFORMATION_PROPERTY] = g_param_spec_object ("information", "information", "information", GEARY_TYPE_ACCOUNT_INFORMATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2554 "geary-account.c"
	/**
	     * The account's current status.
	     *
	     * This property's value is set based on the {@link
	     * ClientService.current_status} of the account's {@link incoming}
	     * and {@link outgoing} services. See {@link Status} for more
	     * information.
	     *
	     * The initial value for this property is {@link Status.ONLINE},
	     * which may or may not be incorrect. However the once the account
	     * has been opened, its services will begin checking connectivity
	     * and the value will be updated to match in due course.
	     *
	     * @see ClientService.current_status
	     */
#line 25 "../src/engine/api/geary-account.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_CURRENT_STATUS_PROPERTY, geary_account_properties[GEARY_ACCOUNT_CURRENT_STATUS_PROPERTY] = g_param_spec_flags ("current-status", "current-status", "current-status", GEARY_ACCOUNT_TYPE_STATUS, GEARY_ACCOUNT_STATUS_ONLINE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2572 "geary-account.c"
	/**
	     * The service manager for the incoming email service.
	     */
#line 25 "../src/engine/api/geary-account.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_INCOMING_PROPERTY, geary_account_properties[GEARY_ACCOUNT_INCOMING_PROPERTY] = g_param_spec_object ("incoming", "incoming", "incoming", GEARY_TYPE_CLIENT_SERVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2578 "geary-account.c"
	/**
	     * The service manager for the outgoing email service.
	     */
#line 25 "../src/engine/api/geary-account.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_OUTGOING_PROPERTY, geary_account_properties[GEARY_ACCOUNT_OUTGOING_PROPERTY] = g_param_spec_object ("outgoing", "outgoing", "outgoing", GEARY_TYPE_CLIENT_SERVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2584 "geary-account.c"
	/**
	     * The contact information store for this account.
	     */
#line 25 "../src/engine/api/geary-account.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_CONTACT_STORE_PROPERTY, geary_account_properties[GEARY_ACCOUNT_CONTACT_STORE_PROPERTY] = g_param_spec_object ("contact-store", "contact-store", "contact-store", GEARY_TYPE_CONTACT_STORE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2590 "geary-account.c"
	/**
	     * The root path for all local folders.
	     *
	     * Any local folders create by the engine or clients must use this
	     * as the root for local folders.
	     */
#line 25 "../src/engine/api/geary-account.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_LOCAL_FOLDER_ROOT_PROPERTY, geary_account_properties[GEARY_ACCOUNT_LOCAL_FOLDER_ROOT_PROPERTY] = g_param_spec_object ("local-folder-root", "local-folder-root", "local-folder-root", GEARY_TYPE_FOLDER_ROOT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 25 "../src/engine/api/geary-account.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_BACKGROUND_PROGRESS_PROPERTY, geary_account_properties[GEARY_ACCOUNT_BACKGROUND_PROGRESS_PROPERTY] = g_param_spec_object ("background-progress", "background-progress", "background-progress", GEARY_TYPE_PROGRESS_MONITOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/engine/api/geary-account.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_DB_UPGRADE_MONITOR_PROPERTY, geary_account_properties[GEARY_ACCOUNT_DB_UPGRADE_MONITOR_PROPERTY] = g_param_spec_object ("db-upgrade-monitor", "db-upgrade-monitor", "db-upgrade-monitor", GEARY_TYPE_PROGRESS_MONITOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/engine/api/geary-account.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_DB_VACUUM_MONITOR_PROPERTY, geary_account_properties[GEARY_ACCOUNT_DB_VACUUM_MONITOR_PROPERTY] = g_param_spec_object ("db-vacuum-monitor", "db-vacuum-monitor", "db-vacuum-monitor", GEARY_TYPE_PROGRESS_MONITOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2605 "geary-account.c"
	/**
	     * The last time the account storage was cleaned.
	     *
	     * This does not imply that a full reap plus vacuum garbage
	     * collection (GC) is performed, merely that:
	     * 1. Any old messages are removed
	     * 2. If any old messages were removed, or the defined period
	     * (in ImapDB.GC) has past, a GC reap is performed
	     * 3. GC vacuum is run if recommended
	     */
#line 25 "../src/engine/api/geary-account.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_LAST_STORAGE_CLEANUP_PROPERTY, geary_account_properties[GEARY_ACCOUNT_LAST_STORAGE_CLEANUP_PROPERTY] = g_param_spec_boxed ("last-storage-cleanup", "last-storage-cleanup", "last-storage-cleanup", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2618 "geary-account.c"
	/** {@inheritDoc} */
#line 25 "../src/engine/api/geary-account.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_LOGGING_PARENT_PROPERTY, geary_account_properties[GEARY_ACCOUNT_LOGGING_PARENT_PROPERTY] = g_param_spec_object ("logging-parent", "logging-parent", "logging-parent", GEARY_LOGGING_TYPE_SOURCE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 25 "../src/engine/api/geary-account.vala"
	geary_account_signals[GEARY_ACCOUNT_OPENED_SIGNAL] = g_signal_new ("opened", GEARY_TYPE_ACCOUNT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 25 "../src/engine/api/geary-account.vala"
	geary_account_signals[GEARY_ACCOUNT_CLOSED_SIGNAL] = g_signal_new ("closed", GEARY_TYPE_ACCOUNT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2626 "geary-account.c"
	/**
	     * Emitted to notify the client that some problem has occurred.
	     *
	     * The engine uses this signal to report internal errors and other
	     * issues that the client should notify the user about. The {@link
	     * ProblemReport} class provides context about the nature of the
	     * problem itself.
	     */
#line 25 "../src/engine/api/geary-account.vala"
	geary_account_signals[GEARY_ACCOUNT_REPORT_PROBLEM_SIGNAL] = g_signal_new ("report-problem", GEARY_TYPE_ACCOUNT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_TYPE_PROBLEM_REPORT);
#line 2637 "geary-account.c"
	/**
	     * Fired when folders become available or unavailable in the account.
	     *
	     * Folders become available when the account is first opened or when
	     * they're created later; they become unavailable when the account is
	     * closed or they're deleted later.
	     *
	     * Folders are ordered for the convenience of the caller from the
	     * top of the hierarchy to lower in the hierarchy.  In other
	     * words, parents are listed before children, assuming the
	     * collections are traversed in natural order.
	     *
	     * @see sort_by_path
	     */
#line 25 "../src/engine/api/geary-account.vala"
	geary_account_signals[GEARY_ACCOUNT_FOLDERS_AVAILABLE_UNAVAILABLE_SIGNAL] = g_signal_new ("folders-available-unavailable", GEARY_TYPE_ACCOUNT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEE_TYPE_BIDIR_SORTED_SET, GEE_TYPE_BIDIR_SORTED_SET);
#line 2654 "geary-account.c"
	/**
	     * Fired when new folders have been created.
	     *
	     * This is fired in response to new folders appearing, for example
	     * the user created a new folder. It will be fired after {@link
	     * folders_available_unavailable} has been fired to mark the
	     * folders as having been made available.
	     *
	     * Folders are ordered for the convenience of the caller from the
	     * top of the hierarchy to lower in the hierarchy.  In other
	     * words, parents are listed before children, assuming the
	     * collection is traversed in natural order.
	     */
#line 25 "../src/engine/api/geary-account.vala"
	geary_account_signals[GEARY_ACCOUNT_FOLDERS_CREATED_SIGNAL] = g_signal_new ("folders-created", GEARY_TYPE_ACCOUNT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_BIDIR_SORTED_SET);
#line 2670 "geary-account.c"
	/**
	     * Fired when existing folders are deleted.
	     *
	     * This is fired in response to existing folders being removed,
	     * for example if the user deleted a folder. it will be fired
	     * after {@link folders_available_unavailable} has been fired to
	     * mark the folders as having been made unavailable.
	     *
	     * Folders are ordered for the convenience of the caller from the
	     * top of the hierarchy to lower in the hierarchy.  In other
	     * words, parents are listed before children, assuming the
	     * collection is traversed in natural order.
	     */
#line 25 "../src/engine/api/geary-account.vala"
	geary_account_signals[GEARY_ACCOUNT_FOLDERS_DELETED_SIGNAL] = g_signal_new ("folders-deleted", GEARY_TYPE_ACCOUNT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_BIDIR_SORTED_SET);
#line 2686 "geary-account.c"
	/**
	     * Fired when a Folder's special use is detected having changed.
	     */
#line 25 "../src/engine/api/geary-account.vala"
	geary_account_signals[GEARY_ACCOUNT_FOLDERS_USE_CHANGED_SIGNAL] = g_signal_new ("folders-use-changed", GEARY_TYPE_ACCOUNT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 2692 "geary-account.c"
	/**
	     * Fired when emails are appended to a folder in this account.
	     */
#line 25 "../src/engine/api/geary-account.vala"
	geary_account_signals[GEARY_ACCOUNT_EMAIL_APPENDED_SIGNAL] = g_signal_new ("email-appended", GEARY_TYPE_ACCOUNT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEARY_TYPE_FOLDER, GEE_TYPE_COLLECTION);
#line 2698 "geary-account.c"
	/**
	     * Fired when emails are inserted to a folder in this account.
	     *
	     * @see Folder.email_inserted
	     */
#line 25 "../src/engine/api/geary-account.vala"
	geary_account_signals[GEARY_ACCOUNT_EMAIL_INSERTED_SIGNAL] = g_signal_new ("email-inserted", GEARY_TYPE_ACCOUNT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEARY_TYPE_FOLDER, GEE_TYPE_COLLECTION);
#line 2706 "geary-account.c"
	/**
	     * Fired when emails are removed from a folder in this account.
	     */
#line 25 "../src/engine/api/geary-account.vala"
	geary_account_signals[GEARY_ACCOUNT_EMAIL_REMOVED_SIGNAL] = g_signal_new ("email-removed", GEARY_TYPE_ACCOUNT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEARY_TYPE_FOLDER, GEE_TYPE_COLLECTION);
#line 2712 "geary-account.c"
	/**
	     * Fired when emails are removed from a local folder in this account.
	     */
#line 25 "../src/engine/api/geary-account.vala"
	geary_account_signals[GEARY_ACCOUNT_EMAIL_LOCALLY_REMOVED_SIGNAL] = g_signal_new ("email-locally-removed", GEARY_TYPE_ACCOUNT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEARY_TYPE_FOLDER, GEE_TYPE_COLLECTION);
#line 2718 "geary-account.c"
	/**
	     * Fired when one or more emails have been locally saved to a folder with
	     * the full set of Fields.
	     */
#line 25 "../src/engine/api/geary-account.vala"
	geary_account_signals[GEARY_ACCOUNT_EMAIL_LOCALLY_COMPLETE_SIGNAL] = g_signal_new ("email-locally-complete", GEARY_TYPE_ACCOUNT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEARY_TYPE_FOLDER, GEE_TYPE_COLLECTION);
#line 2725 "geary-account.c"
	/**
	     * Fired when one or more emails have been discovered (added) to the Folder, but not necessarily
	     * appended (i.e. old email pulled down due to user request or background fetching).
	     */
#line 25 "../src/engine/api/geary-account.vala"
	geary_account_signals[GEARY_ACCOUNT_EMAIL_DISCOVERED_SIGNAL] = g_signal_new ("email-discovered", GEARY_TYPE_ACCOUNT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEARY_TYPE_FOLDER, GEE_TYPE_COLLECTION);
#line 2732 "geary-account.c"
	/**
	     * Fired when the supplied email flags have changed from any folder.
	     */
#line 25 "../src/engine/api/geary-account.vala"
	geary_account_signals[GEARY_ACCOUNT_EMAIL_FLAGS_CHANGED_SIGNAL] = g_signal_new ("email-flags-changed", GEARY_TYPE_ACCOUNT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEARY_TYPE_FOLDER, GEE_TYPE_MAP);
#line 2738 "geary-account.c"
}

static void
geary_account_geary_logging_source_interface_init (GearyLoggingSourceIface * iface,
                                                   gpointer iface_data)
{
#line 25 "../src/engine/api/geary-account.vala"
	geary_account_geary_logging_source_parent_iface = g_type_interface_peek_parent (iface);
#line 25 "../src/engine/api/geary-account.vala"
	iface->to_logging_state = (GearyLoggingState* (*) (GearyLoggingSource*)) geary_account_to_logging_state;
#line 25 "../src/engine/api/geary-account.vala"
	iface->get_logging_parent = geary_account_real_get_logging_parent;
#line 2751 "geary-account.c"
}

static void
geary_account_instance_init (GearyAccount * self,
                             gpointer klass)
{
	GearyFolderRoot* _tmp0_;
#line 25 "../src/engine/api/geary-account.vala"
	self->priv = geary_account_get_instance_private (self);
#line 117 "../src/engine/api/geary-account.vala"
	self->priv->_current_status = GEARY_ACCOUNT_STATUS_ONLINE;
#line 140 "../src/engine/api/geary-account.vala"
	_tmp0_ = geary_folder_root_new ("$geary-local", TRUE);
#line 140 "../src/engine/api/geary-account.vala"
	self->priv->_local_folder_root = _tmp0_;
#line 2767 "geary-account.c"
}

static void
geary_account_finalize (GObject * obj)
{
	GearyAccount * self;
#line 25 "../src/engine/api/geary-account.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_TYPE_ACCOUNT, GearyAccount);
#line 100 "../src/engine/api/geary-account.vala"
	_g_object_unref0 (self->priv->_information);
#line 122 "../src/engine/api/geary-account.vala"
	_g_object_unref0 (self->priv->_incoming);
#line 127 "../src/engine/api/geary-account.vala"
	_g_object_unref0 (self->priv->_outgoing);
#line 132 "../src/engine/api/geary-account.vala"
	_g_object_unref0 (self->priv->_contact_store);
#line 140 "../src/engine/api/geary-account.vala"
	_g_object_unref0 (self->priv->_local_folder_root);
#line 144 "../src/engine/api/geary-account.vala"
	_g_object_unref0 (self->priv->_background_progress);
#line 145 "../src/engine/api/geary-account.vala"
	_g_object_unref0 (self->priv->_db_upgrade_monitor);
#line 146 "../src/engine/api/geary-account.vala"
	_g_object_unref0 (self->priv->_db_vacuum_monitor);
#line 158 "../src/engine/api/geary-account.vala"
	_g_date_time_unref0 (self->priv->_last_storage_cleanup);
#line 25 "../src/engine/api/geary-account.vala"
	G_OBJECT_CLASS (geary_account_parent_class)->finalize (obj);
#line 2796 "geary-account.c"
}

/**
 * Account is the basic interface to the user's email account, {@link Folder}s, and various signals,
 * monitors, and notifications of account activity.
 *
 * In addition to providing an interface to the various Folders, Account offers aggregation signals
 * indicating changes to all Folders as they're discovered.  Because some mail interfaces don't
 * provide account-wide notification, these signals may only be fired when the Folder is open,
 * which sometimes happens in the background as background synchronization occurs.
 *
 * Accounts must be opened and closed with {@link open_async} and {@link close_async}.  Most
 * methods only work if the Account is opened (if not, that will be mentioned in their
 * documentation).
 *
 * A list of all Accounts may be retrieved from the {@link Engine} singleton.
 */
 G_GNUC_NO_INLINE static GType
geary_account_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyAccountClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_account_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyAccount), 0, (GInstanceInitFunc) geary_account_instance_init, NULL };
	static const GInterfaceInfo geary_logging_source_info = { (GInterfaceInitFunc) geary_account_geary_logging_source_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType geary_account_type_id;
	geary_account_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyAccount", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	g_type_add_interface_static (geary_account_type_id, GEARY_LOGGING_TYPE_SOURCE, &geary_logging_source_info);
	GearyAccount_private_offset = g_type_add_instance_private (geary_account_type_id, sizeof (GearyAccountPrivate));
	return geary_account_type_id;
}

GType
geary_account_get_type (void)
{
	static gsize geary_account_type_id__once = 0;
	if (g_once_init_enter (&geary_account_type_id__once)) {
		GType geary_account_type_id;
		geary_account_type_id = geary_account_get_type_once ();
		g_once_init_leave (&geary_account_type_id__once, geary_account_type_id);
	}
	return geary_account_type_id__once;
}

static void
_vala_geary_account_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	GearyAccount * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_ACCOUNT, GearyAccount);
#line 25 "../src/engine/api/geary-account.vala"
	switch (property_id) {
#line 25 "../src/engine/api/geary-account.vala"
		case GEARY_ACCOUNT_INFORMATION_PROPERTY:
#line 25 "../src/engine/api/geary-account.vala"
		g_value_set_object (value, geary_account_get_information (self));
#line 25 "../src/engine/api/geary-account.vala"
		break;
#line 25 "../src/engine/api/geary-account.vala"
		case GEARY_ACCOUNT_CURRENT_STATUS_PROPERTY:
#line 25 "../src/engine/api/geary-account.vala"
		g_value_set_flags (value, geary_account_get_current_status (self));
#line 25 "../src/engine/api/geary-account.vala"
		break;
#line 25 "../src/engine/api/geary-account.vala"
		case GEARY_ACCOUNT_INCOMING_PROPERTY:
#line 25 "../src/engine/api/geary-account.vala"
		g_value_set_object (value, geary_account_get_incoming (self));
#line 25 "../src/engine/api/geary-account.vala"
		break;
#line 25 "../src/engine/api/geary-account.vala"
		case GEARY_ACCOUNT_OUTGOING_PROPERTY:
#line 25 "../src/engine/api/geary-account.vala"
		g_value_set_object (value, geary_account_get_outgoing (self));
#line 25 "../src/engine/api/geary-account.vala"
		break;
#line 25 "../src/engine/api/geary-account.vala"
		case GEARY_ACCOUNT_CONTACT_STORE_PROPERTY:
#line 25 "../src/engine/api/geary-account.vala"
		g_value_set_object (value, geary_account_get_contact_store (self));
#line 25 "../src/engine/api/geary-account.vala"
		break;
#line 25 "../src/engine/api/geary-account.vala"
		case GEARY_ACCOUNT_LOCAL_FOLDER_ROOT_PROPERTY:
#line 25 "../src/engine/api/geary-account.vala"
		g_value_set_object (value, geary_account_get_local_folder_root (self));
#line 25 "../src/engine/api/geary-account.vala"
		break;
#line 25 "../src/engine/api/geary-account.vala"
		case GEARY_ACCOUNT_BACKGROUND_PROGRESS_PROPERTY:
#line 25 "../src/engine/api/geary-account.vala"
		g_value_set_object (value, geary_account_get_background_progress (self));
#line 25 "../src/engine/api/geary-account.vala"
		break;
#line 25 "../src/engine/api/geary-account.vala"
		case GEARY_ACCOUNT_DB_UPGRADE_MONITOR_PROPERTY:
#line 25 "../src/engine/api/geary-account.vala"
		g_value_set_object (value, geary_account_get_db_upgrade_monitor (self));
#line 25 "../src/engine/api/geary-account.vala"
		break;
#line 25 "../src/engine/api/geary-account.vala"
		case GEARY_ACCOUNT_DB_VACUUM_MONITOR_PROPERTY:
#line 25 "../src/engine/api/geary-account.vala"
		g_value_set_object (value, geary_account_get_db_vacuum_monitor (self));
#line 25 "../src/engine/api/geary-account.vala"
		break;
#line 25 "../src/engine/api/geary-account.vala"
		case GEARY_ACCOUNT_LAST_STORAGE_CLEANUP_PROPERTY:
#line 25 "../src/engine/api/geary-account.vala"
		g_value_set_boxed (value, geary_account_get_last_storage_cleanup (self));
#line 25 "../src/engine/api/geary-account.vala"
		break;
#line 25 "../src/engine/api/geary-account.vala"
		case GEARY_ACCOUNT_LOGGING_PARENT_PROPERTY:
#line 25 "../src/engine/api/geary-account.vala"
		g_value_set_object (value, geary_logging_source_get_logging_parent (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource)));
#line 25 "../src/engine/api/geary-account.vala"
		break;
#line 2914 "geary-account.c"
		default:
#line 25 "../src/engine/api/geary-account.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/engine/api/geary-account.vala"
		break;
#line 2920 "geary-account.c"
	}
}

static void
_vala_geary_account_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	GearyAccount * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_ACCOUNT, GearyAccount);
#line 25 "../src/engine/api/geary-account.vala"
	switch (property_id) {
#line 25 "../src/engine/api/geary-account.vala"
		case GEARY_ACCOUNT_INFORMATION_PROPERTY:
#line 25 "../src/engine/api/geary-account.vala"
		geary_account_set_information (self, g_value_get_object (value));
#line 25 "../src/engine/api/geary-account.vala"
		break;
#line 25 "../src/engine/api/geary-account.vala"
		case GEARY_ACCOUNT_CURRENT_STATUS_PROPERTY:
#line 25 "../src/engine/api/geary-account.vala"
		geary_account_set_current_status (self, g_value_get_flags (value));
#line 25 "../src/engine/api/geary-account.vala"
		break;
#line 25 "../src/engine/api/geary-account.vala"
		case GEARY_ACCOUNT_INCOMING_PROPERTY:
#line 25 "../src/engine/api/geary-account.vala"
		geary_account_set_incoming (self, g_value_get_object (value));
#line 25 "../src/engine/api/geary-account.vala"
		break;
#line 25 "../src/engine/api/geary-account.vala"
		case GEARY_ACCOUNT_OUTGOING_PROPERTY:
#line 25 "../src/engine/api/geary-account.vala"
		geary_account_set_outgoing (self, g_value_get_object (value));
#line 25 "../src/engine/api/geary-account.vala"
		break;
#line 25 "../src/engine/api/geary-account.vala"
		case GEARY_ACCOUNT_CONTACT_STORE_PROPERTY:
#line 25 "../src/engine/api/geary-account.vala"
		geary_account_set_contact_store (self, g_value_get_object (value));
#line 25 "../src/engine/api/geary-account.vala"
		break;
#line 25 "../src/engine/api/geary-account.vala"
		case GEARY_ACCOUNT_LOCAL_FOLDER_ROOT_PROPERTY:
#line 25 "../src/engine/api/geary-account.vala"
		geary_account_set_local_folder_root (self, g_value_get_object (value));
#line 25 "../src/engine/api/geary-account.vala"
		break;
#line 25 "../src/engine/api/geary-account.vala"
		case GEARY_ACCOUNT_BACKGROUND_PROGRESS_PROPERTY:
#line 25 "../src/engine/api/geary-account.vala"
		geary_account_set_background_progress (self, g_value_get_object (value));
#line 25 "../src/engine/api/geary-account.vala"
		break;
#line 25 "../src/engine/api/geary-account.vala"
		case GEARY_ACCOUNT_DB_UPGRADE_MONITOR_PROPERTY:
#line 25 "../src/engine/api/geary-account.vala"
		geary_account_set_db_upgrade_monitor (self, g_value_get_object (value));
#line 25 "../src/engine/api/geary-account.vala"
		break;
#line 25 "../src/engine/api/geary-account.vala"
		case GEARY_ACCOUNT_DB_VACUUM_MONITOR_PROPERTY:
#line 25 "../src/engine/api/geary-account.vala"
		geary_account_set_db_vacuum_monitor (self, g_value_get_object (value));
#line 25 "../src/engine/api/geary-account.vala"
		break;
#line 25 "../src/engine/api/geary-account.vala"
		case GEARY_ACCOUNT_LAST_STORAGE_CLEANUP_PROPERTY:
#line 25 "../src/engine/api/geary-account.vala"
		geary_account_set_last_storage_cleanup (self, g_value_get_boxed (value));
#line 25 "../src/engine/api/geary-account.vala"
		break;
#line 2994 "geary-account.c"
		default:
#line 25 "../src/engine/api/geary-account.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/engine/api/geary-account.vala"
		break;
#line 3000 "geary-account.c"
	}
}

