/* geary-client-service.c generated by valac 0.56.17, the Vala compiler
 * generated from geary-client-service.vala, do not modify */

/*
 * Copyright 2018 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>

#define GEARY_CLIENT_SERVICE_BECAME_REACHABLE_TIMEOUT_SEC 3
#define GEARY_CLIENT_SERVICE_BECAME_UNREACHABLE_TIMEOUT_SEC 1
#define GEARY_CLIENT_SERVICE_LOGIND_DBUS_NAME "org.freedesktop.login1"
#define GEARY_CLIENT_SERVICE_LOGIND_DBUS_PATH "/org/freedesktop/login1"
#define GEARY_CLIENT_SERVICE_LOGIND_DBUS_INTERFACE "org.freedesktop.login1.Manager"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_CLIENT_SERVICE_0_PROPERTY,
	GEARY_CLIENT_SERVICE_ACCOUNT_PROPERTY,
	GEARY_CLIENT_SERVICE_CONFIGURATION_PROPERTY,
	GEARY_CLIENT_SERVICE_CURRENT_STATUS_PROPERTY,
	GEARY_CLIENT_SERVICE_REMOTE_PROPERTY,
	GEARY_CLIENT_SERVICE_IS_RUNNING_PROPERTY,
	GEARY_CLIENT_SERVICE_LAST_ERROR_PROPERTY,
	GEARY_CLIENT_SERVICE_LOGGING_PARENT_PROPERTY,
	GEARY_CLIENT_SERVICE_NUM_PROPERTIES
};
static GParamSpec* geary_client_service_properties[GEARY_CLIENT_SERVICE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _GearyClientServiceUpdateConfigurationData GearyClientServiceUpdateConfigurationData;
typedef struct _GearyClientServiceRestartData GearyClientServiceRestartData;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	GEARY_CLIENT_SERVICE_CONNECTION_ERROR_SIGNAL,
	GEARY_CLIENT_SERVICE_UNRECOVERABLE_ERROR_SIGNAL,
	GEARY_CLIENT_SERVICE_NUM_SIGNALS
};
static guint geary_client_service_signals[GEARY_CLIENT_SERVICE_NUM_SIGNALS] = {0};

struct _GearyClientServicePrivate {
	GearyAccountInformation* _account;
	GearyServiceInformation* _configuration;
	GearyClientServiceStatus _current_status;
	GearyEndpoint* _remote;
	gboolean _is_running;
	GearyTimeoutManager* became_reachable_timer;
	GearyTimeoutManager* became_unreachable_timer;
	GDBusProxy* logind_proxy;
	GearyErrorContext* _last_error;
	GearyLoggingSource* _logging_parent;
};

struct _GearyClientServiceUpdateConfigurationData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyClientService* self;
	GearyServiceInformation* configuration;
	GearyEndpoint* remote;
	GCancellable* cancellable;
	gboolean do_restart;
	gboolean _tmp0_;
	GError* _inner_error0_;
};

struct _GearyClientServiceRestartData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyClientService* self;
	GCancellable* cancellable;
	gboolean _tmp0_;
	GError* _inner_error0_;
};

static gint GearyClientService_private_offset;
static gpointer geary_client_service_parent_class = NULL;
static GearyLoggingSourceIface * geary_client_service_geary_logging_source_parent_iface = NULL;

static void geary_client_service_disconnect_handlers (GearyClientService* self);
static void geary_client_service_set_account (GearyClientService* self,
                                       GearyAccountInformation* value);
static void geary_client_service_set_configuration (GearyClientService* self,
                                             GearyServiceInformation* value);
static void geary_client_service_set_remote (GearyClientService* self,
                                      GearyEndpoint* value);
static void geary_client_service_set_is_running (GearyClientService* self,
                                          gboolean value);
static void geary_client_service_set_last_error (GearyClientService* self,
                                          GearyErrorContext* value);
static void _geary_client_service_became_reachable_geary_timeout_manager_timeout_func (GearyTimeoutManager* manager,
                                                                                gpointer self);
static void _geary_client_service_became_unreachable_geary_timeout_manager_timeout_func (GearyTimeoutManager* manager,
                                                                                  gpointer self);
static void geary_client_service_on_logind_signal (GearyClientService* self,
                                            GDBusProxy* logind_proxy,
                                            const gchar* sender_name,
                                            const gchar* signal_name,
                                            GVariant* parameters);
static void _geary_client_service_on_logind_signal_g_dbus_proxy_g_signal (GDBusProxy* _sender,
                                                                   const gchar* sender_name,
                                                                   const gchar* signal_name,
                                                                   GVariant* parameters,
                                                                   gpointer self);
static void geary_client_service_connect_handlers (GearyClientService* self);
static void geary_client_service_on_running_notify (GearyClientService* self);
static void _geary_client_service_on_running_notify_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self);
static void geary_client_service_on_current_status_notify (GearyClientService* self);
static void _geary_client_service_on_current_status_notify_g_object_notify (GObject* _sender,
                                                                     GParamSpec* pspec,
                                                                     gpointer self);
static void geary_client_service_update_configuration_data_free (gpointer _data);
static gboolean geary_client_service_update_configuration_co (GearyClientServiceUpdateConfigurationData* _data_);
static void geary_client_service_update_configuration_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
static void geary_client_service_restart_data_free (gpointer _data);
static gboolean geary_client_service_restart_co (GearyClientServiceRestartData* _data_);
static void geary_client_service_restart_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_);
static GearyLoggingState* geary_client_service_real_to_logging_state (GearyClientService* self);
VALA_EXTERN void geary_client_service_set_logging_parent (GearyClientService* self,
                                              GearyLoggingSource* parent);
static void geary_client_service_real_became_reachable (GearyClientService* self);
static void geary_client_service_real_became_unreachable (GearyClientService* self);
static void geary_client_service_on_connectivity_change (GearyClientService* self);
static void _geary_client_service_on_connectivity_change_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self);
static void geary_client_service_on_connectivity_error (GearyClientService* self,
                                                 GError* _error_);
static void _geary_client_service_on_connectivity_error_geary_connectivity_manager_remote_error_reported (GearyConnectivityManager* _sender,
                                                                                                   GError* _error_,
                                                                                                   gpointer self);
static void geary_client_service_on_untrusted_host (GearyClientService* self,
                                             GearyEndpoint* remote,
                                             GTlsConnection* cx);
static void _geary_client_service_on_untrusted_host_geary_endpoint_untrusted_host (GearyEndpoint* _sender,
                                                                            GTlsConnection* cx,
                                                                            gpointer self);
static void geary_client_service_finalize (GObject * obj);
static GType geary_client_service_get_type_once (void);
static void _vala_geary_client_service_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_geary_client_service_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
geary_client_service_get_instance_private (GearyClientService* self)
{
	return G_STRUCT_MEMBER_P (self, GearyClientService_private_offset);
}

/**
     * Denotes the service's current status.
     *
     * @see ClientService.current_status
     * @see Account.current_status
     */
/**
         * Determines if re-connection should be attempted from this state.
         *
         * If the service is in this state, it will automatically
         * attempt to reconnect when connectivity changes have been
         * detected.
         */
gboolean
geary_client_service_status_automatically_reconnect (GearyClientServiceStatus self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result;
#line 130 "../src/engine/api/geary-client-service.vala"
	if (self == GEARY_CLIENT_SERVICE_STATUS_UNKNOWN) {
#line 130 "../src/engine/api/geary-client-service.vala"
		_tmp2_ = TRUE;
#line 205 "geary-client-service.c"
	} else {
#line 131 "../src/engine/api/geary-client-service.vala"
		_tmp2_ = self == GEARY_CLIENT_SERVICE_STATUS_UNREACHABLE;
#line 209 "geary-client-service.c"
	}
#line 130 "../src/engine/api/geary-client-service.vala"
	if (_tmp2_) {
#line 130 "../src/engine/api/geary-client-service.vala"
		_tmp1_ = TRUE;
#line 215 "geary-client-service.c"
	} else {
#line 132 "../src/engine/api/geary-client-service.vala"
		_tmp1_ = self == GEARY_CLIENT_SERVICE_STATUS_CONNECTED;
#line 219 "geary-client-service.c"
	}
#line 129 "../src/engine/api/geary-client-service.vala"
	if (_tmp1_) {
#line 130 "../src/engine/api/geary-client-service.vala"
		_tmp0_ = TRUE;
#line 225 "geary-client-service.c"
	} else {
#line 133 "../src/engine/api/geary-client-service.vala"
		_tmp0_ = self == GEARY_CLIENT_SERVICE_STATUS_CONNECTION_FAILED;
#line 229 "geary-client-service.c"
	}
#line 129 "../src/engine/api/geary-client-service.vala"
	result = _tmp0_;
#line 129 "../src/engine/api/geary-client-service.vala"
	return result;
#line 235 "geary-client-service.c"
}

/**
         * Determines the current status is an error condition.
         *
         * Returns true if not offline or connected.
         */
gboolean
geary_client_service_status_is_error (GearyClientServiceStatus self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 144 "../src/engine/api/geary-client-service.vala"
	if (self != GEARY_CLIENT_SERVICE_STATUS_UNKNOWN) {
#line 145 "../src/engine/api/geary-client-service.vala"
		_tmp1_ = self != GEARY_CLIENT_SERVICE_STATUS_UNREACHABLE;
#line 253 "geary-client-service.c"
	} else {
#line 144 "../src/engine/api/geary-client-service.vala"
		_tmp1_ = FALSE;
#line 257 "geary-client-service.c"
	}
#line 143 "../src/engine/api/geary-client-service.vala"
	if (_tmp1_) {
#line 146 "../src/engine/api/geary-client-service.vala"
		_tmp0_ = self != GEARY_CLIENT_SERVICE_STATUS_CONNECTED;
#line 263 "geary-client-service.c"
	} else {
#line 144 "../src/engine/api/geary-client-service.vala"
		_tmp0_ = FALSE;
#line 267 "geary-client-service.c"
	}
#line 143 "../src/engine/api/geary-client-service.vala"
	result = _tmp0_;
#line 143 "../src/engine/api/geary-client-service.vala"
	return result;
#line 273 "geary-client-service.c"
}

gchar*
geary_client_service_status_to_value (GearyClientServiceStatus self)
{
	gchar* _tmp0_;
	gchar* result;
#line 151 "../src/engine/api/geary-client-service.vala"
	_tmp0_ = geary_object_utils_to_enum_nick (GEARY_CLIENT_SERVICE_TYPE_STATUS, NULL, NULL, GEARY_CLIENT_SERVICE_TYPE_STATUS, (gpointer) ((gintptr) self));
#line 151 "../src/engine/api/geary-client-service.vala"
	result = _tmp0_;
#line 151 "../src/engine/api/geary-client-service.vala"
	return result;
#line 287 "geary-client-service.c"
}

 G_GNUC_NO_INLINE static GType
geary_client_service_status_get_type_once (void)
{
	static const GEnumValue values[] = {{GEARY_CLIENT_SERVICE_STATUS_UNKNOWN, "GEARY_CLIENT_SERVICE_STATUS_UNKNOWN", "unknown"}, {GEARY_CLIENT_SERVICE_STATUS_UNREACHABLE, "GEARY_CLIENT_SERVICE_STATUS_UNREACHABLE", "unreachable"}, {GEARY_CLIENT_SERVICE_STATUS_CONNECTED, "GEARY_CLIENT_SERVICE_STATUS_CONNECTED", "connected"}, {GEARY_CLIENT_SERVICE_STATUS_CONNECTION_FAILED, "GEARY_CLIENT_SERVICE_STATUS_CONNECTION_FAILED", "connection-failed"}, {GEARY_CLIENT_SERVICE_STATUS_AUTHENTICATION_FAILED, "GEARY_CLIENT_SERVICE_STATUS_AUTHENTICATION_FAILED", "authentication-failed"}, {GEARY_CLIENT_SERVICE_STATUS_TLS_VALIDATION_FAILED, "GEARY_CLIENT_SERVICE_STATUS_TLS_VALIDATION_FAILED", "tls-validation-failed"}, {GEARY_CLIENT_SERVICE_STATUS_UNRECOVERABLE_ERROR, "GEARY_CLIENT_SERVICE_STATUS_UNRECOVERABLE_ERROR", "unrecoverable-error"}, {0, NULL, NULL}};
	GType geary_client_service_status_type_id;
	geary_client_service_status_type_id = g_enum_register_static ("GearyClientServiceStatus", values);
	return geary_client_service_status_type_id;
}

GType
geary_client_service_status_get_type (void)
{
	static gsize geary_client_service_status_type_id__once = 0;
	if (g_once_init_enter (&geary_client_service_status_type_id__once)) {
		GType geary_client_service_status_type_id;
		geary_client_service_status_type_id = geary_client_service_status_get_type_once ();
		g_once_init_leave (&geary_client_service_status_type_id__once, geary_client_service_status_type_id);
	}
	return geary_client_service_status_type_id__once;
}

GearyAccountInformation*
geary_client_service_get_account (GearyClientService* self)
{
	GearyAccountInformation* result;
	GearyAccountInformation* _tmp0_;
#line 173 "../src/engine/api/geary-client-service.vala"
	g_return_val_if_fail (GEARY_IS_CLIENT_SERVICE (self), NULL);
#line 173 "../src/engine/api/geary-client-service.vala"
	_tmp0_ = self->priv->_account;
#line 173 "../src/engine/api/geary-client-service.vala"
	result = _tmp0_;
#line 173 "../src/engine/api/geary-client-service.vala"
	return result;
#line 324 "geary-client-service.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 173 "../src/engine/api/geary-client-service.vala"
	return self ? g_object_ref (self) : NULL;
#line 332 "geary-client-service.c"
}

static void
geary_client_service_set_account (GearyClientService* self,
                                  GearyAccountInformation* value)
{
	GearyAccountInformation* old_value;
#line 173 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 173 "../src/engine/api/geary-client-service.vala"
	old_value = geary_client_service_get_account (self);
#line 173 "../src/engine/api/geary-client-service.vala"
	if (old_value != value) {
#line 346 "geary-client-service.c"
		GearyAccountInformation* _tmp0_;
#line 173 "../src/engine/api/geary-client-service.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 173 "../src/engine/api/geary-client-service.vala"
		_g_object_unref0 (self->priv->_account);
#line 173 "../src/engine/api/geary-client-service.vala"
		self->priv->_account = _tmp0_;
#line 173 "../src/engine/api/geary-client-service.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_client_service_properties[GEARY_CLIENT_SERVICE_ACCOUNT_PROPERTY]);
#line 356 "geary-client-service.c"
	}
}

GearyServiceInformation*
geary_client_service_get_configuration (GearyClientService* self)
{
	GearyServiceInformation* result;
	GearyServiceInformation* _tmp0_;
#line 176 "../src/engine/api/geary-client-service.vala"
	g_return_val_if_fail (GEARY_IS_CLIENT_SERVICE (self), NULL);
#line 176 "../src/engine/api/geary-client-service.vala"
	_tmp0_ = self->priv->_configuration;
#line 176 "../src/engine/api/geary-client-service.vala"
	result = _tmp0_;
#line 176 "../src/engine/api/geary-client-service.vala"
	return result;
#line 373 "geary-client-service.c"
}

static void
geary_client_service_set_configuration (GearyClientService* self,
                                        GearyServiceInformation* value)
{
	GearyServiceInformation* old_value;
#line 176 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 176 "../src/engine/api/geary-client-service.vala"
	old_value = geary_client_service_get_configuration (self);
#line 176 "../src/engine/api/geary-client-service.vala"
	if (old_value != value) {
#line 387 "geary-client-service.c"
		GearyServiceInformation* _tmp0_;
#line 176 "../src/engine/api/geary-client-service.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 176 "../src/engine/api/geary-client-service.vala"
		_g_object_unref0 (self->priv->_configuration);
#line 176 "../src/engine/api/geary-client-service.vala"
		self->priv->_configuration = _tmp0_;
#line 176 "../src/engine/api/geary-client-service.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_client_service_properties[GEARY_CLIENT_SERVICE_CONFIGURATION_PROPERTY]);
#line 397 "geary-client-service.c"
	}
}

GearyClientServiceStatus
geary_client_service_get_current_status (GearyClientService* self)
{
	GearyClientServiceStatus result;
#line 191 "../src/engine/api/geary-client-service.vala"
	g_return_val_if_fail (GEARY_IS_CLIENT_SERVICE (self), 0);
#line 191 "../src/engine/api/geary-client-service.vala"
	result = self->priv->_current_status;
#line 191 "../src/engine/api/geary-client-service.vala"
	return result;
#line 411 "geary-client-service.c"
}

void
geary_client_service_set_current_status (GearyClientService* self,
                                         GearyClientServiceStatus value)
{
	GearyClientServiceStatus old_value;
#line 191 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 191 "../src/engine/api/geary-client-service.vala"
	old_value = geary_client_service_get_current_status (self);
#line 191 "../src/engine/api/geary-client-service.vala"
	if (old_value != value) {
#line 191 "../src/engine/api/geary-client-service.vala"
		self->priv->_current_status = value;
#line 191 "../src/engine/api/geary-client-service.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_client_service_properties[GEARY_CLIENT_SERVICE_CURRENT_STATUS_PROPERTY]);
#line 429 "geary-client-service.c"
	}
}

GearyEndpoint*
geary_client_service_get_remote (GearyClientService* self)
{
	GearyEndpoint* result;
	GearyEndpoint* _tmp0_;
#line 194 "../src/engine/api/geary-client-service.vala"
	g_return_val_if_fail (GEARY_IS_CLIENT_SERVICE (self), NULL);
#line 194 "../src/engine/api/geary-client-service.vala"
	_tmp0_ = self->priv->_remote;
#line 194 "../src/engine/api/geary-client-service.vala"
	result = _tmp0_;
#line 194 "../src/engine/api/geary-client-service.vala"
	return result;
#line 446 "geary-client-service.c"
}

static void
geary_client_service_set_remote (GearyClientService* self,
                                 GearyEndpoint* value)
{
	GearyEndpoint* old_value;
#line 194 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 194 "../src/engine/api/geary-client-service.vala"
	old_value = geary_client_service_get_remote (self);
#line 194 "../src/engine/api/geary-client-service.vala"
	if (old_value != value) {
#line 460 "geary-client-service.c"
		GearyEndpoint* _tmp0_;
#line 194 "../src/engine/api/geary-client-service.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 194 "../src/engine/api/geary-client-service.vala"
		_g_object_unref0 (self->priv->_remote);
#line 194 "../src/engine/api/geary-client-service.vala"
		self->priv->_remote = _tmp0_;
#line 194 "../src/engine/api/geary-client-service.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_client_service_properties[GEARY_CLIENT_SERVICE_REMOTE_PROPERTY]);
#line 470 "geary-client-service.c"
	}
}

gboolean
geary_client_service_get_is_running (GearyClientService* self)
{
	gboolean result;
#line 197 "../src/engine/api/geary-client-service.vala"
	g_return_val_if_fail (GEARY_IS_CLIENT_SERVICE (self), FALSE);
#line 197 "../src/engine/api/geary-client-service.vala"
	result = self->priv->_is_running;
#line 197 "../src/engine/api/geary-client-service.vala"
	return result;
#line 484 "geary-client-service.c"
}

static void
geary_client_service_set_is_running (GearyClientService* self,
                                     gboolean value)
{
	gboolean old_value;
#line 197 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 197 "../src/engine/api/geary-client-service.vala"
	old_value = geary_client_service_get_is_running (self);
#line 197 "../src/engine/api/geary-client-service.vala"
	if (old_value != value) {
#line 197 "../src/engine/api/geary-client-service.vala"
		self->priv->_is_running = value;
#line 197 "../src/engine/api/geary-client-service.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_client_service_properties[GEARY_CLIENT_SERVICE_IS_RUNNING_PROPERTY]);
#line 502 "geary-client-service.c"
	}
}

GearyErrorContext*
geary_client_service_get_last_error (GearyClientService* self)
{
	GearyErrorContext* result;
	GearyErrorContext* _tmp0_;
#line 208 "../src/engine/api/geary-client-service.vala"
	g_return_val_if_fail (GEARY_IS_CLIENT_SERVICE (self), NULL);
#line 208 "../src/engine/api/geary-client-service.vala"
	_tmp0_ = self->priv->_last_error;
#line 208 "../src/engine/api/geary-client-service.vala"
	result = _tmp0_;
#line 208 "../src/engine/api/geary-client-service.vala"
	return result;
#line 519 "geary-client-service.c"
}

static void
geary_client_service_set_last_error (GearyClientService* self,
                                     GearyErrorContext* value)
{
	GearyErrorContext* old_value;
#line 208 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 208 "../src/engine/api/geary-client-service.vala"
	old_value = geary_client_service_get_last_error (self);
#line 208 "../src/engine/api/geary-client-service.vala"
	if (old_value != value) {
#line 533 "geary-client-service.c"
		GearyErrorContext* _tmp0_;
#line 208 "../src/engine/api/geary-client-service.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 208 "../src/engine/api/geary-client-service.vala"
		_g_object_unref0 (self->priv->_last_error);
#line 208 "../src/engine/api/geary-client-service.vala"
		self->priv->_last_error = _tmp0_;
#line 208 "../src/engine/api/geary-client-service.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_client_service_properties[GEARY_CLIENT_SERVICE_LAST_ERROR_PROPERTY]);
#line 543 "geary-client-service.c"
	}
}

const gchar*
geary_client_service_get_logging_domain (GearyClientService* self)
{
	GearyClientServiceClass* _klass_;
#line 213 "../src/engine/api/geary-client-service.vala"
	g_return_val_if_fail (GEARY_IS_CLIENT_SERVICE (self), NULL);
#line 213 "../src/engine/api/geary-client-service.vala"
	_klass_ = GEARY_CLIENT_SERVICE_GET_CLASS (self);
#line 213 "../src/engine/api/geary-client-service.vala"
	if (_klass_->get_logging_domain) {
#line 213 "../src/engine/api/geary-client-service.vala"
		return _klass_->get_logging_domain (self);
#line 559 "geary-client-service.c"
	}
#line 213 "../src/engine/api/geary-client-service.vala"
	return NULL;
#line 563 "geary-client-service.c"
}

static const gchar*
geary_client_service_real_get_logging_domain (GearyClientService* base)
{
	const gchar* result;
	GearyClientService* self;
#line 213 "../src/engine/api/geary-client-service.vala"
	self = base;
#line 213 "../src/engine/api/geary-client-service.vala"
	result = GEARY_LOGGING_DOMAIN;
#line 213 "../src/engine/api/geary-client-service.vala"
	return result;
#line 577 "geary-client-service.c"
}

static GearyLoggingSource*
geary_client_service_real_get_logging_parent (GearyLoggingSource* base)
{
	GearyLoggingSource* result;
	GearyClientService* self;
	GearyLoggingSource* _tmp0_;
#line 217 "../src/engine/api/geary-client-service.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_CLIENT_SERVICE, GearyClientService);
#line 217 "../src/engine/api/geary-client-service.vala"
	_tmp0_ = self->priv->_logging_parent;
#line 217 "../src/engine/api/geary-client-service.vala"
	result = _tmp0_;
#line 217 "../src/engine/api/geary-client-service.vala"
	return result;
#line 594 "geary-client-service.c"
}

static void
_geary_client_service_became_reachable_geary_timeout_manager_timeout_func (GearyTimeoutManager* manager,
                                                                           gpointer self)
{
#line 228 "../src/engine/api/geary-client-service.vala"
	geary_client_service_became_reachable ((GearyClientService*) self);
#line 603 "geary-client-service.c"
}

static void
_geary_client_service_became_unreachable_geary_timeout_manager_timeout_func (GearyTimeoutManager* manager,
                                                                             gpointer self)
{
#line 231 "../src/engine/api/geary-client-service.vala"
	geary_client_service_became_unreachable ((GearyClientService*) self);
#line 612 "geary-client-service.c"
}

static void
_geary_client_service_on_logind_signal_g_dbus_proxy_g_signal (GDBusProxy* _sender,
                                                              const gchar* sender_name,
                                                              const gchar* signal_name,
                                                              GVariant* parameters,
                                                              gpointer self)
{
#line 245 "../src/engine/api/geary-client-service.vala"
	geary_client_service_on_logind_signal ((GearyClientService*) self, _sender, sender_name, signal_name, parameters);
#line 624 "geary-client-service.c"
}

static void
_geary_client_service_on_running_notify_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self)
{
#line 252 "../src/engine/api/geary-client-service.vala"
	geary_client_service_on_running_notify ((GearyClientService*) self);
#line 634 "geary-client-service.c"
}

static void
_geary_client_service_on_current_status_notify_g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self)
{
#line 253 "../src/engine/api/geary-client-service.vala"
	geary_client_service_on_current_status_notify ((GearyClientService*) self);
#line 644 "geary-client-service.c"
}

GearyClientService*
geary_client_service_construct (GType object_type,
                                GearyAccountInformation* account,
                                GearyServiceInformation* configuration,
                                GearyEndpoint* remote)
{
	GearyClientService * self = NULL;
	GearyTimeoutManager* _tmp0_;
	GearyTimeoutManager* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 221 "../src/engine/api/geary-client-service.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (account), NULL);
#line 221 "../src/engine/api/geary-client-service.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (configuration), NULL);
#line 221 "../src/engine/api/geary-client-service.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (remote), NULL);
#line 221 "../src/engine/api/geary-client-service.vala"
	self = (GearyClientService*) geary_base_object_construct (object_type);
#line 224 "../src/engine/api/geary-client-service.vala"
	geary_client_service_set_account (self, account);
#line 225 "../src/engine/api/geary-client-service.vala"
	geary_client_service_set_configuration (self, configuration);
#line 226 "../src/engine/api/geary-client-service.vala"
	geary_client_service_set_remote (self, remote);
#line 228 "../src/engine/api/geary-client-service.vala"
	_tmp0_ = geary_timeout_manager_new_seconds ((guint) GEARY_CLIENT_SERVICE_BECAME_REACHABLE_TIMEOUT_SEC, _geary_client_service_became_reachable_geary_timeout_manager_timeout_func, self);
#line 228 "../src/engine/api/geary-client-service.vala"
	_g_object_unref0 (self->priv->became_reachable_timer);
#line 228 "../src/engine/api/geary-client-service.vala"
	self->priv->became_reachable_timer = _tmp0_;
#line 231 "../src/engine/api/geary-client-service.vala"
	_tmp1_ = geary_timeout_manager_new_seconds ((guint) GEARY_CLIENT_SERVICE_BECAME_UNREACHABLE_TIMEOUT_SEC, _geary_client_service_became_unreachable_geary_timeout_manager_timeout_func, self);
#line 231 "../src/engine/api/geary-client-service.vala"
	_g_object_unref0 (self->priv->became_unreachable_timer);
#line 231 "../src/engine/api/geary-client-service.vala"
	self->priv->became_unreachable_timer = _tmp1_;
#line 683 "geary-client-service.c"
	{
		GDBusProxy* _tmp2_ = NULL;
		GDBusProxy* _tmp3_;
		GDBusProxy* _tmp4_;
		GDBusProxy* _tmp5_;
#line 236 "../src/engine/api/geary-client-service.vala"
		_tmp3_ = g_dbus_proxy_new_for_bus_sync (G_BUS_TYPE_SYSTEM, G_DBUS_PROXY_FLAGS_NONE, NULL, GEARY_CLIENT_SERVICE_LOGIND_DBUS_NAME, GEARY_CLIENT_SERVICE_LOGIND_DBUS_PATH, GEARY_CLIENT_SERVICE_LOGIND_DBUS_INTERFACE, NULL, &_inner_error0_);
#line 236 "../src/engine/api/geary-client-service.vala"
		_tmp2_ = _tmp3_;
#line 236 "../src/engine/api/geary-client-service.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 695 "geary-client-service.c"
			goto __catch0_g_error;
		}
#line 236 "../src/engine/api/geary-client-service.vala"
		_tmp4_ = _tmp2_;
#line 236 "../src/engine/api/geary-client-service.vala"
		_tmp2_ = NULL;
#line 236 "../src/engine/api/geary-client-service.vala"
		_g_object_unref0 (self->priv->logind_proxy);
#line 236 "../src/engine/api/geary-client-service.vala"
		self->priv->logind_proxy = _tmp4_;
#line 245 "../src/engine/api/geary-client-service.vala"
		_tmp5_ = self->priv->logind_proxy;
#line 245 "../src/engine/api/geary-client-service.vala"
		g_signal_connect_object (_tmp5_, "g-signal", (GCallback) _geary_client_service_on_logind_signal_g_dbus_proxy_g_signal, self, 0);
#line 235 "../src/engine/api/geary-client-service.vala"
		_g_object_unref0 (_tmp2_);
#line 712 "geary-client-service.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 235 "../src/engine/api/geary-client-service.vala"
		err = _inner_error0_;
#line 235 "../src/engine/api/geary-client-service.vala"
		_inner_error0_ = NULL;
#line 247 "../src/engine/api/geary-client-service.vala"
		_tmp6_ = err;
#line 247 "../src/engine/api/geary-client-service.vala"
		_tmp7_ = _tmp6_->message;
#line 247 "../src/engine/api/geary-client-service.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Failed to connect logind bus: %s", _tmp7_);
#line 235 "../src/engine/api/geary-client-service.vala"
		_g_error_free0 (err);
#line 732 "geary-client-service.c"
	}
	__finally0:
#line 235 "../src/engine/api/geary-client-service.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 235 "../src/engine/api/geary-client-service.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 235 "../src/engine/api/geary-client-service.vala"
		g_clear_error (&_inner_error0_);
#line 235 "../src/engine/api/geary-client-service.vala"
		return NULL;
#line 743 "geary-client-service.c"
	}
#line 250 "../src/engine/api/geary-client-service.vala"
	geary_client_service_connect_handlers (self);
#line 252 "../src/engine/api/geary-client-service.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "notify::is-running", (GCallback) _geary_client_service_on_running_notify_g_object_notify, self, 0);
#line 253 "../src/engine/api/geary-client-service.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "notify::current-status", (GCallback) _geary_client_service_on_current_status_notify_g_object_notify, self, 0);
#line 221 "../src/engine/api/geary-client-service.vala"
	return self;
#line 753 "geary-client-service.c"
}

static void
geary_client_service_update_configuration_data_free (gpointer _data)
{
	GearyClientServiceUpdateConfigurationData* _data_;
	_data_ = _data;
#line 17 "../src/engine/api/geary-client-service.vala"
	_g_object_unref0 (_data_->configuration);
#line 17 "../src/engine/api/geary-client-service.vala"
	_g_object_unref0 (_data_->remote);
#line 17 "../src/engine/api/geary-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 17 "../src/engine/api/geary-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 17 "../src/engine/api/geary-client-service.vala"
	g_slice_free (GearyClientServiceUpdateConfigurationData, _data_);
#line 771 "geary-client-service.c"
}

void
geary_client_service_update_configuration (GearyClientService* self,
                                           GearyServiceInformation* configuration,
                                           GearyEndpoint* remote,
                                           GCancellable* cancellable,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	GearyClientServiceUpdateConfigurationData* _data_;
	GearyClientService* _tmp0_;
	GearyServiceInformation* _tmp1_;
	GearyEndpoint* _tmp2_;
	GCancellable* _tmp3_;
#line 17 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 17 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_SERVICE_INFORMATION (configuration));
#line 17 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_ENDPOINT (remote));
#line 17 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 17 "../src/engine/api/geary-client-service.vala"
	_data_ = g_slice_new0 (GearyClientServiceUpdateConfigurationData);
#line 17 "../src/engine/api/geary-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 17 "../src/engine/api/geary-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_client_service_update_configuration_data_free);
#line 17 "../src/engine/api/geary-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 17 "../src/engine/api/geary-client-service.vala"
	_data_->self = _tmp0_;
#line 17 "../src/engine/api/geary-client-service.vala"
	_tmp1_ = _g_object_ref0 (configuration);
#line 17 "../src/engine/api/geary-client-service.vala"
	_g_object_unref0 (_data_->configuration);
#line 17 "../src/engine/api/geary-client-service.vala"
	_data_->configuration = _tmp1_;
#line 17 "../src/engine/api/geary-client-service.vala"
	_tmp2_ = _g_object_ref0 (remote);
#line 17 "../src/engine/api/geary-client-service.vala"
	_g_object_unref0 (_data_->remote);
#line 17 "../src/engine/api/geary-client-service.vala"
	_data_->remote = _tmp2_;
#line 17 "../src/engine/api/geary-client-service.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 17 "../src/engine/api/geary-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 17 "../src/engine/api/geary-client-service.vala"
	_data_->cancellable = _tmp3_;
#line 17 "../src/engine/api/geary-client-service.vala"
	geary_client_service_update_configuration_co (_data_);
#line 825 "geary-client-service.c"
}

void
geary_client_service_update_configuration_finish (GearyClientService* self,
                                                  GAsyncResult* _res_,
                                                  GError** error)
{
	GearyClientServiceUpdateConfigurationData* _data_;
#line 17 "../src/engine/api/geary-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 17 "../src/engine/api/geary-client-service.vala"
	if (NULL == _data_) {
#line 17 "../src/engine/api/geary-client-service.vala"
		return;
#line 840 "geary-client-service.c"
	}
}

/**
     * Updates the configuration for the service.
     *
     * The service will be restarted if it is already running, and if
     * so will be stopped before the old configuration and endpoint is
     * replaced by the new one, then started again.
     */
static void
geary_client_service_update_configuration_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	GearyClientServiceUpdateConfigurationData* _data_;
#line 275 "../src/engine/api/geary-client-service.vala"
	_data_ = _user_data_;
#line 275 "../src/engine/api/geary-client-service.vala"
	_data_->_source_object_ = source_object;
#line 275 "../src/engine/api/geary-client-service.vala"
	_data_->_res_ = _res_;
#line 275 "../src/engine/api/geary-client-service.vala"
	geary_client_service_update_configuration_co (_data_);
#line 865 "geary-client-service.c"
}

static gboolean
geary_client_service_update_configuration_co (GearyClientServiceUpdateConfigurationData* _data_)
{
#line 267 "../src/engine/api/geary-client-service.vala"
	switch (_data_->_state_) {
#line 267 "../src/engine/api/geary-client-service.vala"
		case 0:
#line 875 "geary-client-service.c"
		goto _state_0;
#line 267 "../src/engine/api/geary-client-service.vala"
		case 1:
#line 879 "geary-client-service.c"
		goto _state_1;
#line 267 "../src/engine/api/geary-client-service.vala"
		case 2:
#line 883 "geary-client-service.c"
		goto _state_2;
		default:
#line 267 "../src/engine/api/geary-client-service.vala"
		g_assert_not_reached ();
#line 888 "geary-client-service.c"
	}
	_state_0:
#line 271 "../src/engine/api/geary-client-service.vala"
	geary_client_service_disconnect_handlers (_data_->self);
#line 273 "../src/engine/api/geary-client-service.vala"
	_data_->_tmp0_ = _data_->self->priv->_is_running;
#line 273 "../src/engine/api/geary-client-service.vala"
	_data_->do_restart = _data_->_tmp0_;
#line 274 "../src/engine/api/geary-client-service.vala"
	if (_data_->do_restart) {
#line 275 "../src/engine/api/geary-client-service.vala"
		_data_->_state_ = 1;
#line 275 "../src/engine/api/geary-client-service.vala"
		geary_client_service_stop (_data_->self, _data_->cancellable, geary_client_service_update_configuration_ready, _data_);
#line 275 "../src/engine/api/geary-client-service.vala"
		return FALSE;
#line 905 "geary-client-service.c"
		_state_1:
#line 275 "../src/engine/api/geary-client-service.vala"
		geary_client_service_stop_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 275 "../src/engine/api/geary-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 275 "../src/engine/api/geary-client-service.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 275 "../src/engine/api/geary-client-service.vala"
			g_object_unref (_data_->_async_result);
#line 275 "../src/engine/api/geary-client-service.vala"
			return FALSE;
#line 917 "geary-client-service.c"
		}
	}
#line 278 "../src/engine/api/geary-client-service.vala"
	geary_client_service_set_configuration (_data_->self, _data_->configuration);
#line 279 "../src/engine/api/geary-client-service.vala"
	geary_client_service_set_remote (_data_->self, _data_->remote);
#line 280 "../src/engine/api/geary-client-service.vala"
	geary_client_service_connect_handlers (_data_->self);
#line 282 "../src/engine/api/geary-client-service.vala"
	if (_data_->do_restart) {
#line 283 "../src/engine/api/geary-client-service.vala"
		_data_->_state_ = 2;
#line 283 "../src/engine/api/geary-client-service.vala"
		geary_client_service_start (_data_->self, _data_->cancellable, geary_client_service_update_configuration_ready, _data_);
#line 283 "../src/engine/api/geary-client-service.vala"
		return FALSE;
#line 934 "geary-client-service.c"
		_state_2:
#line 283 "../src/engine/api/geary-client-service.vala"
		geary_client_service_start_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 283 "../src/engine/api/geary-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 283 "../src/engine/api/geary-client-service.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 283 "../src/engine/api/geary-client-service.vala"
			g_object_unref (_data_->_async_result);
#line 283 "../src/engine/api/geary-client-service.vala"
			return FALSE;
#line 946 "geary-client-service.c"
		}
	}
#line 267 "../src/engine/api/geary-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 267 "../src/engine/api/geary-client-service.vala"
	if (_data_->_state_ != 0) {
#line 267 "../src/engine/api/geary-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 267 "../src/engine/api/geary-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 957 "geary-client-service.c"
		}
	}
#line 267 "../src/engine/api/geary-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 267 "../src/engine/api/geary-client-service.vala"
	return FALSE;
#line 964 "geary-client-service.c"
}

void
geary_client_service_start (GearyClientService* self,
                            GCancellable* cancellable,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
	GearyClientServiceClass* _klass_;
#line 17 "../src/engine/api/geary-client-service.vala"
	_klass_ = GEARY_CLIENT_SERVICE_GET_CLASS (self);
#line 17 "../src/engine/api/geary-client-service.vala"
	if (_klass_->start) {
#line 17 "../src/engine/api/geary-client-service.vala"
		_klass_->start (self, cancellable, _callback_, _user_data_);
#line 980 "geary-client-service.c"
	}
}

void
geary_client_service_start_finish (GearyClientService* self,
                                   GAsyncResult* _res_,
                                   GError** error)
{
	GearyClientServiceClass* _klass_;
#line 17 "../src/engine/api/geary-client-service.vala"
	_klass_ = GEARY_CLIENT_SERVICE_GET_CLASS (self);
#line 17 "../src/engine/api/geary-client-service.vala"
	if (_klass_->start_finish) {
#line 17 "../src/engine/api/geary-client-service.vala"
		_klass_->start_finish (self, _res_, error);
#line 996 "geary-client-service.c"
	}
}

void
geary_client_service_stop (GearyClientService* self,
                           GCancellable* cancellable,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_)
{
	GearyClientServiceClass* _klass_;
#line 17 "../src/engine/api/geary-client-service.vala"
	_klass_ = GEARY_CLIENT_SERVICE_GET_CLASS (self);
#line 17 "../src/engine/api/geary-client-service.vala"
	if (_klass_->stop) {
#line 17 "../src/engine/api/geary-client-service.vala"
		_klass_->stop (self, cancellable, _callback_, _user_data_);
#line 1013 "geary-client-service.c"
	}
}

void
geary_client_service_stop_finish (GearyClientService* self,
                                  GAsyncResult* _res_,
                                  GError** error)
{
	GearyClientServiceClass* _klass_;
#line 17 "../src/engine/api/geary-client-service.vala"
	_klass_ = GEARY_CLIENT_SERVICE_GET_CLASS (self);
#line 17 "../src/engine/api/geary-client-service.vala"
	if (_klass_->stop_finish) {
#line 17 "../src/engine/api/geary-client-service.vala"
		_klass_->stop_finish (self, _res_, error);
#line 1029 "geary-client-service.c"
	}
}

static void
geary_client_service_restart_data_free (gpointer _data)
{
	GearyClientServiceRestartData* _data_;
	_data_ = _data;
#line 17 "../src/engine/api/geary-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 17 "../src/engine/api/geary-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 17 "../src/engine/api/geary-client-service.vala"
	g_slice_free (GearyClientServiceRestartData, _data_);
#line 1044 "geary-client-service.c"
}

void
geary_client_service_restart (GearyClientService* self,
                              GCancellable* cancellable,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	GearyClientServiceRestartData* _data_;
	GearyClientService* _tmp0_;
	GCancellable* _tmp1_;
#line 17 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 17 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 17 "../src/engine/api/geary-client-service.vala"
	_data_ = g_slice_new0 (GearyClientServiceRestartData);
#line 17 "../src/engine/api/geary-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 17 "../src/engine/api/geary-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_client_service_restart_data_free);
#line 17 "../src/engine/api/geary-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 17 "../src/engine/api/geary-client-service.vala"
	_data_->self = _tmp0_;
#line 17 "../src/engine/api/geary-client-service.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 17 "../src/engine/api/geary-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 17 "../src/engine/api/geary-client-service.vala"
	_data_->cancellable = _tmp1_;
#line 17 "../src/engine/api/geary-client-service.vala"
	geary_client_service_restart_co (_data_);
#line 1078 "geary-client-service.c"
}

void
geary_client_service_restart_finish (GearyClientService* self,
                                     GAsyncResult* _res_,
                                     GError** error)
{
	GearyClientServiceRestartData* _data_;
#line 17 "../src/engine/api/geary-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 17 "../src/engine/api/geary-client-service.vala"
	if (NULL == _data_) {
#line 17 "../src/engine/api/geary-client-service.vala"
		return;
#line 1093 "geary-client-service.c"
	}
}

/**
     * Starts the service, stopping it first if running.
     *
     * An error will be thrown if the service could not be stopped or
     * could not be started again. If an error is thrown while
     * stopping the service, no attempt will be made to start it
     * again.
     */
static void
geary_client_service_restart_ready (GObject* source_object,
                                    GAsyncResult* _res_,
                                    gpointer _user_data_)
{
	GearyClientServiceRestartData* _data_;
#line 315 "../src/engine/api/geary-client-service.vala"
	_data_ = _user_data_;
#line 315 "../src/engine/api/geary-client-service.vala"
	_data_->_source_object_ = source_object;
#line 315 "../src/engine/api/geary-client-service.vala"
	_data_->_res_ = _res_;
#line 315 "../src/engine/api/geary-client-service.vala"
	geary_client_service_restart_co (_data_);
#line 1119 "geary-client-service.c"
}

static gboolean
geary_client_service_restart_co (GearyClientServiceRestartData* _data_)
{
#line 312 "../src/engine/api/geary-client-service.vala"
	switch (_data_->_state_) {
#line 312 "../src/engine/api/geary-client-service.vala"
		case 0:
#line 1129 "geary-client-service.c"
		goto _state_0;
#line 312 "../src/engine/api/geary-client-service.vala"
		case 1:
#line 1133 "geary-client-service.c"
		goto _state_1;
#line 312 "../src/engine/api/geary-client-service.vala"
		case 2:
#line 1137 "geary-client-service.c"
		goto _state_2;
		default:
#line 312 "../src/engine/api/geary-client-service.vala"
		g_assert_not_reached ();
#line 1142 "geary-client-service.c"
	}
	_state_0:
#line 314 "../src/engine/api/geary-client-service.vala"
	_data_->_tmp0_ = _data_->self->priv->_is_running;
#line 314 "../src/engine/api/geary-client-service.vala"
	if (_data_->_tmp0_) {
#line 315 "../src/engine/api/geary-client-service.vala"
		_data_->_state_ = 1;
#line 315 "../src/engine/api/geary-client-service.vala"
		geary_client_service_stop (_data_->self, _data_->cancellable, geary_client_service_restart_ready, _data_);
#line 315 "../src/engine/api/geary-client-service.vala"
		return FALSE;
#line 1155 "geary-client-service.c"
		_state_1:
#line 315 "../src/engine/api/geary-client-service.vala"
		geary_client_service_stop_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 315 "../src/engine/api/geary-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 315 "../src/engine/api/geary-client-service.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 315 "../src/engine/api/geary-client-service.vala"
			g_object_unref (_data_->_async_result);
#line 315 "../src/engine/api/geary-client-service.vala"
			return FALSE;
#line 1167 "geary-client-service.c"
		}
	}
#line 318 "../src/engine/api/geary-client-service.vala"
	_data_->_state_ = 2;
#line 318 "../src/engine/api/geary-client-service.vala"
	geary_client_service_start (_data_->self, _data_->cancellable, geary_client_service_restart_ready, _data_);
#line 318 "../src/engine/api/geary-client-service.vala"
	return FALSE;
#line 1176 "geary-client-service.c"
	_state_2:
#line 318 "../src/engine/api/geary-client-service.vala"
	geary_client_service_start_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 318 "../src/engine/api/geary-client-service.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 318 "../src/engine/api/geary-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 318 "../src/engine/api/geary-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 318 "../src/engine/api/geary-client-service.vala"
		return FALSE;
#line 1188 "geary-client-service.c"
	}
#line 312 "../src/engine/api/geary-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 312 "../src/engine/api/geary-client-service.vala"
	if (_data_->_state_ != 0) {
#line 312 "../src/engine/api/geary-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 312 "../src/engine/api/geary-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1198 "geary-client-service.c"
		}
	}
#line 312 "../src/engine/api/geary-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 312 "../src/engine/api/geary-client-service.vala"
	return FALSE;
#line 1205 "geary-client-service.c"
}

/** {@inheritDoc} */
static GearyLoggingState*
geary_client_service_real_to_logging_state (GearyClientService* self)
{
	GearyServiceInformation* _tmp0_;
	GearyProtocol _tmp1_;
	GearyProtocol _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GearyLoggingState* _tmp5_;
	GearyLoggingState* _tmp6_;
	GearyLoggingState* result;
#line 323 "../src/engine/api/geary-client-service.vala"
	_tmp0_ = self->priv->_configuration;
#line 323 "../src/engine/api/geary-client-service.vala"
	_tmp1_ = geary_service_information_get_protocol (_tmp0_);
#line 323 "../src/engine/api/geary-client-service.vala"
	_tmp2_ = _tmp1_;
#line 323 "../src/engine/api/geary-client-service.vala"
	_tmp3_ = geary_protocol_to_value (_tmp2_);
#line 323 "../src/engine/api/geary-client-service.vala"
	_tmp4_ = _tmp3_;
#line 323 "../src/engine/api/geary-client-service.vala"
	_tmp5_ = geary_logging_state_new (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "%s", _tmp4_);
#line 323 "../src/engine/api/geary-client-service.vala"
	_tmp6_ = _tmp5_;
#line 323 "../src/engine/api/geary-client-service.vala"
	_g_free0 (_tmp4_);
#line 323 "../src/engine/api/geary-client-service.vala"
	result = _tmp6_;
#line 323 "../src/engine/api/geary-client-service.vala"
	return result;
#line 1240 "geary-client-service.c"
}

GearyLoggingState*
geary_client_service_to_logging_state (GearyClientService* self)
{
	GearyClientServiceClass* _klass_;
#line 322 "../src/engine/api/geary-client-service.vala"
	g_return_val_if_fail (GEARY_IS_CLIENT_SERVICE (self), NULL);
#line 322 "../src/engine/api/geary-client-service.vala"
	_klass_ = GEARY_CLIENT_SERVICE_GET_CLASS (self);
#line 322 "../src/engine/api/geary-client-service.vala"
	if (_klass_->to_logging_state) {
#line 322 "../src/engine/api/geary-client-service.vala"
		return _klass_->to_logging_state (self);
#line 1255 "geary-client-service.c"
	}
#line 322 "../src/engine/api/geary-client-service.vala"
	return NULL;
#line 1259 "geary-client-service.c"
}

/** Sets the service's logging parent. */
void
geary_client_service_set_logging_parent (GearyClientService* self,
                                         GearyLoggingSource* parent)
{
#line 327 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 327 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_LOGGING_IS_SOURCE (parent));
#line 328 "../src/engine/api/geary-client-service.vala"
	self->priv->_logging_parent = parent;
#line 1273 "geary-client-service.c"
}

/**
     * Called when the network service has become reachable.
     *
     * Derived classes may wish to attempt to establish a network
     * connection to the remote service when this is called.
     */
static void
geary_client_service_real_became_reachable (GearyClientService* self)
{
#line 337 "../src/engine/api/geary-client-service.vala"
	g_critical ("Type `%s' does not implement abstract method `geary_client_service_became_reachable'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 337 "../src/engine/api/geary-client-service.vala"
	return;
#line 1289 "geary-client-service.c"
}

void
geary_client_service_became_reachable (GearyClientService* self)
{
	GearyClientServiceClass* _klass_;
#line 337 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 337 "../src/engine/api/geary-client-service.vala"
	_klass_ = GEARY_CLIENT_SERVICE_GET_CLASS (self);
#line 337 "../src/engine/api/geary-client-service.vala"
	if (_klass_->became_reachable) {
#line 337 "../src/engine/api/geary-client-service.vala"
		_klass_->became_reachable (self);
#line 1304 "geary-client-service.c"
	}
}

/**
     * Called when the network service has become unreachable.
     *
     * Derived classes should close any network connections that are
     * being established, or have been established with remote
     * service.
     */
static void
geary_client_service_real_became_unreachable (GearyClientService* self)
{
#line 346 "../src/engine/api/geary-client-service.vala"
	g_critical ("Type `%s' does not implement abstract method `geary_client_service_became_unreachable'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 346 "../src/engine/api/geary-client-service.vala"
	return;
#line 1322 "geary-client-service.c"
}

void
geary_client_service_became_unreachable (GearyClientService* self)
{
	GearyClientServiceClass* _klass_;
#line 346 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 346 "../src/engine/api/geary-client-service.vala"
	_klass_ = GEARY_CLIENT_SERVICE_GET_CLASS (self);
#line 346 "../src/engine/api/geary-client-service.vala"
	if (_klass_->became_unreachable) {
#line 346 "../src/engine/api/geary-client-service.vala"
		_klass_->became_unreachable (self);
#line 1337 "geary-client-service.c"
	}
}

/**
     * Notifies the network service has been started.
     *
     * Derived classes must call this when they consider the service
     * to has been successfully started, to update service status and
     * start reachable checking.
     */
void
geary_client_service_notify_started (GearyClientService* self)
{
	GearyEndpoint* _tmp0_;
	GearyConnectivityManager* _tmp1_;
	GearyConnectivityManager* _tmp2_;
	GearyTrillian _tmp3_;
	GearyTrillian _tmp4_;
#line 355 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 356 "../src/engine/api/geary-client-service.vala"
	geary_client_service_set_is_running (self, TRUE);
#line 357 "../src/engine/api/geary-client-service.vala"
	_tmp0_ = self->priv->_remote;
#line 357 "../src/engine/api/geary-client-service.vala"
	_tmp1_ = geary_endpoint_get_connectivity (_tmp0_);
#line 357 "../src/engine/api/geary-client-service.vala"
	_tmp2_ = _tmp1_;
#line 357 "../src/engine/api/geary-client-service.vala"
	_tmp3_ = geary_connectivity_manager_get_is_reachable (_tmp2_);
#line 357 "../src/engine/api/geary-client-service.vala"
	_tmp4_ = _tmp3_;
#line 357 "../src/engine/api/geary-client-service.vala"
	if (geary_trillian_is_certain (_tmp4_)) {
#line 358 "../src/engine/api/geary-client-service.vala"
		geary_client_service_became_reachable (self);
#line 1374 "geary-client-service.c"
	} else {
		GearyEndpoint* _tmp5_;
		GearyConnectivityManager* _tmp6_;
		GearyConnectivityManager* _tmp7_;
		GearyTrillian _tmp8_;
		GearyTrillian _tmp9_;
#line 359 "../src/engine/api/geary-client-service.vala"
		_tmp5_ = self->priv->_remote;
#line 359 "../src/engine/api/geary-client-service.vala"
		_tmp6_ = geary_endpoint_get_connectivity (_tmp5_);
#line 359 "../src/engine/api/geary-client-service.vala"
		_tmp7_ = _tmp6_;
#line 359 "../src/engine/api/geary-client-service.vala"
		_tmp8_ = geary_connectivity_manager_get_is_reachable (_tmp7_);
#line 359 "../src/engine/api/geary-client-service.vala"
		_tmp9_ = _tmp8_;
#line 359 "../src/engine/api/geary-client-service.vala"
		if (geary_trillian_is_impossible (_tmp9_)) {
#line 360 "../src/engine/api/geary-client-service.vala"
			geary_client_service_set_current_status (self, GEARY_CLIENT_SERVICE_STATUS_UNREACHABLE);
#line 1395 "geary-client-service.c"
		} else {
			GearyEndpoint* _tmp10_;
			GearyConnectivityManager* _tmp11_;
			GearyConnectivityManager* _tmp12_;
#line 362 "../src/engine/api/geary-client-service.vala"
			_tmp10_ = self->priv->_remote;
#line 362 "../src/engine/api/geary-client-service.vala"
			_tmp11_ = geary_endpoint_get_connectivity (_tmp10_);
#line 362 "../src/engine/api/geary-client-service.vala"
			_tmp12_ = _tmp11_;
#line 362 "../src/engine/api/geary-client-service.vala"
			geary_connectivity_manager_check_reachable (_tmp12_, NULL, NULL);
#line 1408 "geary-client-service.c"
		}
	}
}

/**
     * Notifies when the network service has been stopped.
     *
     * Derived classes must call this before stopping the service to
     * update service status and cancel any pending reachable checks.
     */
void
geary_client_service_notify_stopped (GearyClientService* self)
{
	GearyTimeoutManager* _tmp0_;
	GearyTimeoutManager* _tmp1_;
#line 372 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 373 "../src/engine/api/geary-client-service.vala"
	geary_client_service_set_is_running (self, FALSE);
#line 374 "../src/engine/api/geary-client-service.vala"
	geary_client_service_set_current_status (self, GEARY_CLIENT_SERVICE_STATUS_UNKNOWN);
#line 375 "../src/engine/api/geary-client-service.vala"
	_tmp0_ = self->priv->became_reachable_timer;
#line 375 "../src/engine/api/geary-client-service.vala"
	geary_timeout_manager_reset (_tmp0_);
#line 376 "../src/engine/api/geary-client-service.vala"
	_tmp1_ = self->priv->became_unreachable_timer;
#line 376 "../src/engine/api/geary-client-service.vala"
	geary_timeout_manager_reset (_tmp1_);
#line 1438 "geary-client-service.c"
}

/**
     * Notifies that the service has successfully connected.
     *
     * Derived classes should call this when a connection to the
     * network service has been successfully negotiated and appears to
     * be operating normally.
     */
void
geary_client_service_notify_connected (GearyClientService* self)
{
#line 386 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 387 "../src/engine/api/geary-client-service.vala"
	geary_client_service_set_current_status (self, GEARY_CLIENT_SERVICE_STATUS_CONNECTED);
#line 1455 "geary-client-service.c"
}

/**
     * Notifies that a connection error occurred.
     *
     * Derived classes should call this when a connection to the
     * network service encountered some network error other than a
     * login failure or TLS certificate validation error.
     */
void
geary_client_service_notify_connection_failed (GearyClientService* self,
                                               GearyErrorContext* _error_)
{
#line 397 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 397 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail ((_error_ == NULL) || GEARY_IS_ERROR_CONTEXT (_error_));
#line 400 "../src/engine/api/geary-client-service.vala"
	geary_client_service_set_last_error (self, _error_);
#line 401 "../src/engine/api/geary-client-service.vala"
	geary_client_service_set_current_status (self, GEARY_CLIENT_SERVICE_STATUS_CONNECTION_FAILED);
#line 402 "../src/engine/api/geary-client-service.vala"
	g_signal_emit (self, geary_client_service_signals[GEARY_CLIENT_SERVICE_CONNECTION_ERROR_SIGNAL], 0, _error_);
#line 404 "../src/engine/api/geary-client-service.vala"
	geary_client_service_on_connectivity_change (self);
#line 1481 "geary-client-service.c"
}

/**
     * Notifies that an authentication failure has occurred.
     *
     * Derived classes should call this when they have detected that
     * authentication has failed because the service rejected the
     * supplied credentials, but not when login failed for other
     * reasons (for example, connection limits being reached, service
     * temporarily unavailable, etc).
     */
void
geary_client_service_notify_authentication_failed (GearyClientService* self)
{
	GearyAccountInformation* _tmp0_;
	GearyServiceInformation* _tmp1_;
#line 416 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 417 "../src/engine/api/geary-client-service.vala"
	geary_client_service_set_current_status (self, GEARY_CLIENT_SERVICE_STATUS_AUTHENTICATION_FAILED);
#line 418 "../src/engine/api/geary-client-service.vala"
	_tmp0_ = self->priv->_account;
#line 418 "../src/engine/api/geary-client-service.vala"
	_tmp1_ = self->priv->_configuration;
#line 418 "../src/engine/api/geary-client-service.vala"
	g_signal_emit_by_name (_tmp0_, "authentication-failure", _tmp1_);
#line 1508 "geary-client-service.c"
}

/**
     * Notifies that an unrecoverable error has occurred.
     *
     * Derived classes should call this when they have detected that
     * some unrecoverable error has occurred when connecting to the
     * service, such as an unsupported protocol or version.
     */
void
geary_client_service_notify_unrecoverable_error (GearyClientService* self,
                                                 GearyErrorContext* _error_)
{
#line 428 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 428 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_ERROR_CONTEXT (_error_));
#line 431 "../src/engine/api/geary-client-service.vala"
	geary_client_service_set_last_error (self, _error_);
#line 432 "../src/engine/api/geary-client-service.vala"
	geary_client_service_set_current_status (self, GEARY_CLIENT_SERVICE_STATUS_UNRECOVERABLE_ERROR);
#line 433 "../src/engine/api/geary-client-service.vala"
	g_signal_emit (self, geary_client_service_signals[GEARY_CLIENT_SERVICE_UNRECOVERABLE_ERROR_SIGNAL], 0, _error_);
#line 1532 "geary-client-service.c"
}

static void
_geary_client_service_on_connectivity_change_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self)
{
#line 437 "../src/engine/api/geary-client-service.vala"
	geary_client_service_on_connectivity_change ((GearyClientService*) self);
#line 1542 "geary-client-service.c"
}

static void
_geary_client_service_on_connectivity_error_geary_connectivity_manager_remote_error_reported (GearyConnectivityManager* _sender,
                                                                                              GError* _error_,
                                                                                              gpointer self)
{
#line 440 "../src/engine/api/geary-client-service.vala"
	geary_client_service_on_connectivity_error ((GearyClientService*) self, _error_);
#line 1552 "geary-client-service.c"
}

static void
_geary_client_service_on_untrusted_host_geary_endpoint_untrusted_host (GearyEndpoint* _sender,
                                                                       GTlsConnection* cx,
                                                                       gpointer self)
{
#line 443 "../src/engine/api/geary-client-service.vala"
	geary_client_service_on_untrusted_host ((GearyClientService*) self, _sender, cx);
#line 1562 "geary-client-service.c"
}

static void
geary_client_service_connect_handlers (GearyClientService* self)
{
	GearyEndpoint* _tmp0_;
	GearyConnectivityManager* _tmp1_;
	GearyConnectivityManager* _tmp2_;
	GearyEndpoint* _tmp3_;
	GearyConnectivityManager* _tmp4_;
	GearyConnectivityManager* _tmp5_;
	GearyEndpoint* _tmp6_;
#line 436 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 437 "../src/engine/api/geary-client-service.vala"
	_tmp0_ = self->priv->_remote;
#line 437 "../src/engine/api/geary-client-service.vala"
	_tmp1_ = geary_endpoint_get_connectivity (_tmp0_);
#line 437 "../src/engine/api/geary-client-service.vala"
	_tmp2_ = _tmp1_;
#line 437 "../src/engine/api/geary-client-service.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, G_TYPE_OBJECT, GObject), "notify::is-reachable", (GCallback) _geary_client_service_on_connectivity_change_g_object_notify, self, 0);
#line 440 "../src/engine/api/geary-client-service.vala"
	_tmp3_ = self->priv->_remote;
#line 440 "../src/engine/api/geary-client-service.vala"
	_tmp4_ = geary_endpoint_get_connectivity (_tmp3_);
#line 440 "../src/engine/api/geary-client-service.vala"
	_tmp5_ = _tmp4_;
#line 440 "../src/engine/api/geary-client-service.vala"
	g_signal_connect_object (_tmp5_, "remote-error-reported", (GCallback) _geary_client_service_on_connectivity_error_geary_connectivity_manager_remote_error_reported, self, 0);
#line 443 "../src/engine/api/geary-client-service.vala"
	_tmp6_ = self->priv->_remote;
#line 443 "../src/engine/api/geary-client-service.vala"
	g_signal_connect_object (_tmp6_, "untrusted-host", (GCallback) _geary_client_service_on_untrusted_host_geary_endpoint_untrusted_host, self, 0);
#line 1597 "geary-client-service.c"
}

static void
geary_client_service_disconnect_handlers (GearyClientService* self)
{
	GearyEndpoint* _tmp0_;
	GearyConnectivityManager* _tmp1_;
	GearyConnectivityManager* _tmp2_;
	guint _tmp3_;
	GQuark _tmp4_;
	GearyEndpoint* _tmp5_;
	GearyConnectivityManager* _tmp6_;
	GearyConnectivityManager* _tmp7_;
	guint _tmp8_;
	GearyEndpoint* _tmp9_;
	guint _tmp10_;
#line 446 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 447 "../src/engine/api/geary-client-service.vala"
	_tmp0_ = self->priv->_remote;
#line 447 "../src/engine/api/geary-client-service.vala"
	_tmp1_ = geary_endpoint_get_connectivity (_tmp0_);
#line 447 "../src/engine/api/geary-client-service.vala"
	_tmp2_ = _tmp1_;
#line 447 "../src/engine/api/geary-client-service.vala"
	g_signal_parse_name ("notify::is-reachable", G_TYPE_OBJECT, &_tmp3_, &_tmp4_, TRUE);
#line 447 "../src/engine/api/geary-client-service.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, G_TYPE_OBJECT, GObject), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, _tmp4_, NULL, (GCallback) _geary_client_service_on_connectivity_change_g_object_notify, self);
#line 450 "../src/engine/api/geary-client-service.vala"
	_tmp5_ = self->priv->_remote;
#line 450 "../src/engine/api/geary-client-service.vala"
	_tmp6_ = geary_endpoint_get_connectivity (_tmp5_);
#line 450 "../src/engine/api/geary-client-service.vala"
	_tmp7_ = _tmp6_;
#line 450 "../src/engine/api/geary-client-service.vala"
	g_signal_parse_name ("remote-error-reported", GEARY_TYPE_CONNECTIVITY_MANAGER, &_tmp8_, NULL, FALSE);
#line 450 "../src/engine/api/geary-client-service.vala"
	g_signal_handlers_disconnect_matched (_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _geary_client_service_on_connectivity_error_geary_connectivity_manager_remote_error_reported, self);
#line 453 "../src/engine/api/geary-client-service.vala"
	_tmp9_ = self->priv->_remote;
#line 453 "../src/engine/api/geary-client-service.vala"
	g_signal_parse_name ("untrusted-host", GEARY_TYPE_ENDPOINT, &_tmp10_, NULL, FALSE);
#line 453 "../src/engine/api/geary-client-service.vala"
	g_signal_handlers_disconnect_matched (_tmp9_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _geary_client_service_on_untrusted_host_geary_endpoint_untrusted_host, self);
#line 1642 "geary-client-service.c"
}

static void
geary_client_service_on_running_notify (GearyClientService* self)
{
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
#line 456 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 457 "../src/engine/api/geary-client-service.vala"
	_tmp1_ = self->priv->_is_running;
#line 457 "../src/engine/api/geary-client-service.vala"
	if (_tmp1_) {
#line 457 "../src/engine/api/geary-client-service.vala"
		_tmp0_ = "Started";
#line 1658 "geary-client-service.c"
	} else {
#line 457 "../src/engine/api/geary-client-service.vala"
		_tmp0_ = "Stopped";
#line 1662 "geary-client-service.c"
	}
#line 457 "../src/engine/api/geary-client-service.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "%s", _tmp0_);
#line 1666 "geary-client-service.c"
}

static void
geary_client_service_on_current_status_notify (GearyClientService* self)
{
	GearyClientServiceStatus _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 460 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 461 "../src/engine/api/geary-client-service.vala"
	_tmp0_ = self->priv->_current_status;
#line 461 "../src/engine/api/geary-client-service.vala"
	_tmp1_ = geary_client_service_status_to_value (_tmp0_);
#line 461 "../src/engine/api/geary-client-service.vala"
	_tmp2_ = _tmp1_;
#line 461 "../src/engine/api/geary-client-service.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Status changed to: %s", _tmp2_);
#line 461 "../src/engine/api/geary-client-service.vala"
	_g_free0 (_tmp2_);
#line 1687 "geary-client-service.c"
}

static void
geary_client_service_on_connectivity_change (GearyClientService* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 464 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 465 "../src/engine/api/geary-client-service.vala"
	_tmp1_ = self->priv->_is_running;
#line 465 "../src/engine/api/geary-client-service.vala"
	if (_tmp1_) {
#line 1701 "geary-client-service.c"
		GearyClientServiceStatus _tmp2_;
#line 465 "../src/engine/api/geary-client-service.vala"
		_tmp2_ = self->priv->_current_status;
#line 465 "../src/engine/api/geary-client-service.vala"
		_tmp0_ = geary_client_service_status_automatically_reconnect (_tmp2_);
#line 1707 "geary-client-service.c"
	} else {
#line 465 "../src/engine/api/geary-client-service.vala"
		_tmp0_ = FALSE;
#line 1711 "geary-client-service.c"
	}
#line 465 "../src/engine/api/geary-client-service.vala"
	if (_tmp0_) {
#line 1715 "geary-client-service.c"
		GearyEndpoint* _tmp3_;
		GearyConnectivityManager* _tmp4_;
		GearyConnectivityManager* _tmp5_;
		GearyTrillian _tmp6_;
		GearyTrillian _tmp7_;
#line 466 "../src/engine/api/geary-client-service.vala"
		_tmp3_ = self->priv->_remote;
#line 466 "../src/engine/api/geary-client-service.vala"
		_tmp4_ = geary_endpoint_get_connectivity (_tmp3_);
#line 466 "../src/engine/api/geary-client-service.vala"
		_tmp5_ = _tmp4_;
#line 466 "../src/engine/api/geary-client-service.vala"
		_tmp6_ = geary_connectivity_manager_get_is_reachable (_tmp5_);
#line 466 "../src/engine/api/geary-client-service.vala"
		_tmp7_ = _tmp6_;
#line 466 "../src/engine/api/geary-client-service.vala"
		if (geary_trillian_is_certain (_tmp7_)) {
#line 1733 "geary-client-service.c"
			GearyTimeoutManager* _tmp8_;
			GearyTimeoutManager* _tmp9_;
#line 467 "../src/engine/api/geary-client-service.vala"
			_tmp8_ = self->priv->became_reachable_timer;
#line 467 "../src/engine/api/geary-client-service.vala"
			geary_timeout_manager_start (_tmp8_);
#line 468 "../src/engine/api/geary-client-service.vala"
			_tmp9_ = self->priv->became_unreachable_timer;
#line 468 "../src/engine/api/geary-client-service.vala"
			geary_timeout_manager_reset (_tmp9_);
#line 1744 "geary-client-service.c"
		} else {
			GearyTimeoutManager* _tmp10_;
			GearyTimeoutManager* _tmp11_;
#line 470 "../src/engine/api/geary-client-service.vala"
			geary_client_service_set_current_status (self, GEARY_CLIENT_SERVICE_STATUS_UNREACHABLE);
#line 471 "../src/engine/api/geary-client-service.vala"
			_tmp10_ = self->priv->became_unreachable_timer;
#line 471 "../src/engine/api/geary-client-service.vala"
			geary_timeout_manager_start (_tmp10_);
#line 472 "../src/engine/api/geary-client-service.vala"
			_tmp11_ = self->priv->became_reachable_timer;
#line 472 "../src/engine/api/geary-client-service.vala"
			geary_timeout_manager_reset (_tmp11_);
#line 1758 "geary-client-service.c"
		}
	}
}

static void
geary_client_service_on_connectivity_error (GearyClientService* self,
                                            GError* _error_)
{
	gboolean _tmp0_;
#line 477 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 477 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (_error_ != NULL);
#line 478 "../src/engine/api/geary-client-service.vala"
	_tmp0_ = self->priv->_is_running;
#line 478 "../src/engine/api/geary-client-service.vala"
	if (_tmp0_) {
#line 1776 "geary-client-service.c"
		GearyTimeoutManager* _tmp1_;
		GearyTimeoutManager* _tmp2_;
		GearyErrorContext* _tmp3_;
		GearyErrorContext* _tmp4_;
#line 479 "../src/engine/api/geary-client-service.vala"
		_tmp1_ = self->priv->became_reachable_timer;
#line 479 "../src/engine/api/geary-client-service.vala"
		geary_timeout_manager_reset (_tmp1_);
#line 480 "../src/engine/api/geary-client-service.vala"
		_tmp2_ = self->priv->became_unreachable_timer;
#line 480 "../src/engine/api/geary-client-service.vala"
		geary_timeout_manager_reset (_tmp2_);
#line 483 "../src/engine/api/geary-client-service.vala"
		geary_client_service_became_unreachable (self);
#line 484 "../src/engine/api/geary-client-service.vala"
		_tmp3_ = geary_error_context_new (_error_);
#line 484 "../src/engine/api/geary-client-service.vala"
		_tmp4_ = _tmp3_;
#line 484 "../src/engine/api/geary-client-service.vala"
		geary_client_service_notify_connection_failed (self, _tmp4_);
#line 484 "../src/engine/api/geary-client-service.vala"
		_g_object_unref0 (_tmp4_);
#line 1799 "geary-client-service.c"
	}
}

static void
geary_client_service_on_untrusted_host (GearyClientService* self,
                                        GearyEndpoint* remote,
                                        GTlsConnection* cx)
{
	gboolean _tmp0_;
#line 488 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 488 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_ENDPOINT (remote));
#line 488 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cx, g_tls_connection_get_type ()));
#line 490 "../src/engine/api/geary-client-service.vala"
	_tmp0_ = self->priv->_is_running;
#line 490 "../src/engine/api/geary-client-service.vala"
	if (_tmp0_) {
#line 1819 "geary-client-service.c"
		GearyTimeoutManager* _tmp1_;
		GearyTimeoutManager* _tmp2_;
		GearyAccountInformation* _tmp3_;
		GearyServiceInformation* _tmp4_;
#line 491 "../src/engine/api/geary-client-service.vala"
		geary_client_service_set_current_status (self, GEARY_CLIENT_SERVICE_STATUS_TLS_VALIDATION_FAILED);
#line 492 "../src/engine/api/geary-client-service.vala"
		_tmp1_ = self->priv->became_reachable_timer;
#line 492 "../src/engine/api/geary-client-service.vala"
		geary_timeout_manager_reset (_tmp1_);
#line 493 "../src/engine/api/geary-client-service.vala"
		_tmp2_ = self->priv->became_unreachable_timer;
#line 493 "../src/engine/api/geary-client-service.vala"
		geary_timeout_manager_reset (_tmp2_);
#line 496 "../src/engine/api/geary-client-service.vala"
		geary_client_service_became_unreachable (self);
#line 497 "../src/engine/api/geary-client-service.vala"
		_tmp3_ = self->priv->_account;
#line 497 "../src/engine/api/geary-client-service.vala"
		_tmp4_ = self->priv->_configuration;
#line 497 "../src/engine/api/geary-client-service.vala"
		g_signal_emit_by_name (_tmp3_, "untrusted-host", _tmp4_, remote, cx);
#line 1842 "geary-client-service.c"
	}
}

static void
geary_client_service_on_logind_signal (GearyClientService* self,
                                       GDBusProxy* logind_proxy,
                                       const gchar* sender_name,
                                       const gchar* signal_name,
                                       GVariant* parameters)
{
	gboolean about_to_suspend = FALSE;
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	gboolean _tmp2_;
#line 501 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (GEARY_IS_CLIENT_SERVICE (self));
#line 501 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (logind_proxy, g_dbus_proxy_get_type ()));
#line 501 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (signal_name != NULL);
#line 501 "../src/engine/api/geary-client-service.vala"
	g_return_if_fail (parameters != NULL);
#line 503 "../src/engine/api/geary-client-service.vala"
	if (g_strcmp0 (signal_name, "PrepareForSleep") != 0) {
#line 504 "../src/engine/api/geary-client-service.vala"
		return;
#line 1869 "geary-client-service.c"
	}
#line 507 "../src/engine/api/geary-client-service.vala"
	_tmp0_ = g_variant_get_child_value (parameters, (gsize) 0);
#line 507 "../src/engine/api/geary-client-service.vala"
	_tmp1_ = _tmp0_;
#line 507 "../src/engine/api/geary-client-service.vala"
	_tmp2_ = g_variant_get_boolean (_tmp1_);
#line 507 "../src/engine/api/geary-client-service.vala"
	_g_variant_unref0 (_tmp1_);
#line 507 "../src/engine/api/geary-client-service.vala"
	about_to_suspend = _tmp2_;
#line 508 "../src/engine/api/geary-client-service.vala"
	if (about_to_suspend) {
#line 509 "../src/engine/api/geary-client-service.vala"
		geary_client_service_stop (self, NULL, NULL, NULL);
#line 1885 "geary-client-service.c"
	} else {
#line 511 "../src/engine/api/geary-client-service.vala"
		geary_client_service_start (self, NULL, NULL, NULL);
#line 1889 "geary-client-service.c"
	}
}

static void
geary_client_service_class_init (GearyClientServiceClass * klass,
                                 gpointer klass_data)
{
#line 17 "../src/engine/api/geary-client-service.vala"
	geary_client_service_parent_class = g_type_class_peek_parent (klass);
#line 17 "../src/engine/api/geary-client-service.vala"
	g_type_class_adjust_private_offset (klass, &GearyClientService_private_offset);
#line 17 "../src/engine/api/geary-client-service.vala"
	((GearyClientServiceClass *) klass)->to_logging_state = (GearyLoggingState* (*) (GearyClientService*)) geary_client_service_real_to_logging_state;
#line 17 "../src/engine/api/geary-client-service.vala"
	((GearyClientServiceClass *) klass)->became_reachable = (void (*) (GearyClientService*)) geary_client_service_real_became_reachable;
#line 17 "../src/engine/api/geary-client-service.vala"
	((GearyClientServiceClass *) klass)->became_unreachable = (void (*) (GearyClientService*)) geary_client_service_real_became_unreachable;
#line 17 "../src/engine/api/geary-client-service.vala"
	GEARY_CLIENT_SERVICE_CLASS (klass)->get_logging_domain = (const gchar* (*) (GearyClientService*)) geary_client_service_real_get_logging_domain;
#line 17 "../src/engine/api/geary-client-service.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_client_service_get_property;
#line 17 "../src/engine/api/geary-client-service.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_client_service_set_property;
#line 17 "../src/engine/api/geary-client-service.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_client_service_finalize;
#line 1915 "geary-client-service.c"
	/** The service's account. */
#line 17 "../src/engine/api/geary-client-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_CLIENT_SERVICE_ACCOUNT_PROPERTY, geary_client_service_properties[GEARY_CLIENT_SERVICE_ACCOUNT_PROPERTY] = g_param_spec_object ("account", "account", "account", GEARY_TYPE_ACCOUNT_INFORMATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1919 "geary-client-service.c"
	/** The configuration for the service. */
#line 17 "../src/engine/api/geary-client-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_CLIENT_SERVICE_CONFIGURATION_PROPERTY, geary_client_service_properties[GEARY_CLIENT_SERVICE_CONFIGURATION_PROPERTY] = g_param_spec_object ("configuration", "configuration", "configuration", GEARY_TYPE_SERVICE_INFORMATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1923 "geary-client-service.c"
	/**
	     * The service's current status.
	     *
	     * The current state of certain aspects of the service
	     * (e.g. online/offline state may not be fully known, and hence
	     * the value of this property reflects the engine's current
	     * understanding of the service's status, not necessarily that of
	     * actual reality.
	     *
	     * The initial value for this property is {@link Status.UNKNOWN}.
	     *
	     * @see Account.current_status
	     */
#line 17 "../src/engine/api/geary-client-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_CLIENT_SERVICE_CURRENT_STATUS_PROPERTY, geary_client_service_properties[GEARY_CLIENT_SERVICE_CURRENT_STATUS_PROPERTY] = g_param_spec_enum ("current-status", "current-status", "current-status", GEARY_CLIENT_SERVICE_TYPE_STATUS, GEARY_CLIENT_SERVICE_STATUS_UNKNOWN, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1939 "geary-client-service.c"
	/** The network endpoint the service will connect to. */
#line 17 "../src/engine/api/geary-client-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_CLIENT_SERVICE_REMOTE_PROPERTY, geary_client_service_properties[GEARY_CLIENT_SERVICE_REMOTE_PROPERTY] = g_param_spec_object ("remote", "remote", "remote", GEARY_TYPE_ENDPOINT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1943 "geary-client-service.c"
	/** Determines if this service has been started. */
#line 17 "../src/engine/api/geary-client-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_CLIENT_SERVICE_IS_RUNNING_PROPERTY, geary_client_service_properties[GEARY_CLIENT_SERVICE_IS_RUNNING_PROPERTY] = g_param_spec_boolean ("is-running", "is-running", "is-running", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1947 "geary-client-service.c"
	/** The last reported error, if any. */
#line 17 "../src/engine/api/geary-client-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_CLIENT_SERVICE_LAST_ERROR_PROPERTY, geary_client_service_properties[GEARY_CLIENT_SERVICE_LAST_ERROR_PROPERTY] = g_param_spec_object ("last-error", "last-error", "last-error", GEARY_TYPE_ERROR_CONTEXT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1951 "geary-client-service.c"
	/** {@inheritDoc} */
#line 17 "../src/engine/api/geary-client-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_CLIENT_SERVICE_LOGGING_PARENT_PROPERTY, geary_client_service_properties[GEARY_CLIENT_SERVICE_LOGGING_PARENT_PROPERTY] = g_param_spec_object ("logging-parent", "logging-parent", "logging-parent", GEARY_LOGGING_TYPE_SOURCE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1955 "geary-client-service.c"
	/**
	     * Fired when the service encounters a connection error.
	     *
	     * @see Status.CONNECTION_FAILED
	     */
#line 17 "../src/engine/api/geary-client-service.vala"
	geary_client_service_signals[GEARY_CLIENT_SERVICE_CONNECTION_ERROR_SIGNAL] = g_signal_new ("connection-error", GEARY_TYPE_CLIENT_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_TYPE_ERROR_CONTEXT);
#line 1963 "geary-client-service.c"
	/**
	     * Fired when the service encounters an unrecoverable error.
	     *
	     * @see Status.UNRECOVERABLE_ERROR
	     */
#line 17 "../src/engine/api/geary-client-service.vala"
	geary_client_service_signals[GEARY_CLIENT_SERVICE_UNRECOVERABLE_ERROR_SIGNAL] = g_signal_new ("unrecoverable-error", GEARY_TYPE_CLIENT_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_TYPE_ERROR_CONTEXT);
#line 1971 "geary-client-service.c"
}

static void
geary_client_service_geary_logging_source_interface_init (GearyLoggingSourceIface * iface,
                                                          gpointer iface_data)
{
#line 17 "../src/engine/api/geary-client-service.vala"
	geary_client_service_geary_logging_source_parent_iface = g_type_interface_peek_parent (iface);
#line 17 "../src/engine/api/geary-client-service.vala"
	iface->to_logging_state = (GearyLoggingState* (*) (GearyLoggingSource*)) geary_client_service_to_logging_state;
#line 17 "../src/engine/api/geary-client-service.vala"
	iface->get_logging_domain = (const gchar* (*) (GearyLoggingSource*)) geary_client_service_get_logging_domain;
#line 17 "../src/engine/api/geary-client-service.vala"
	iface->get_logging_parent = geary_client_service_real_get_logging_parent;
#line 1986 "geary-client-service.c"
}

static void
geary_client_service_instance_init (GearyClientService * self,
                                    gpointer klass)
{
#line 17 "../src/engine/api/geary-client-service.vala"
	self->priv = geary_client_service_get_instance_private (self);
#line 191 "../src/engine/api/geary-client-service.vala"
	self->priv->_current_status = GEARY_CLIENT_SERVICE_STATUS_UNKNOWN;
#line 197 "../src/engine/api/geary-client-service.vala"
	self->priv->_is_running = FALSE;
#line 208 "../src/engine/api/geary-client-service.vala"
	self->priv->_last_error = NULL;
#line 218 "../src/engine/api/geary-client-service.vala"
	self->priv->_logging_parent = NULL;
#line 2003 "geary-client-service.c"
}

static void
geary_client_service_finalize (GObject * obj)
{
	GearyClientService * self;
#line 17 "../src/engine/api/geary-client-service.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_TYPE_CLIENT_SERVICE, GearyClientService);
#line 257 "../src/engine/api/geary-client-service.vala"
	geary_client_service_disconnect_handlers (self);
#line 173 "../src/engine/api/geary-client-service.vala"
	_g_object_unref0 (self->priv->_account);
#line 176 "../src/engine/api/geary-client-service.vala"
	_g_object_unref0 (self->priv->_configuration);
#line 194 "../src/engine/api/geary-client-service.vala"
	_g_object_unref0 (self->priv->_remote);
#line 202 "../src/engine/api/geary-client-service.vala"
	_g_object_unref0 (self->priv->became_reachable_timer);
#line 203 "../src/engine/api/geary-client-service.vala"
	_g_object_unref0 (self->priv->became_unreachable_timer);
#line 205 "../src/engine/api/geary-client-service.vala"
	_g_object_unref0 (self->priv->logind_proxy);
#line 208 "../src/engine/api/geary-client-service.vala"
	_g_object_unref0 (self->priv->_last_error);
#line 17 "../src/engine/api/geary-client-service.vala"
	G_OBJECT_CLASS (geary_client_service_parent_class)->finalize (obj);
#line 2030 "geary-client-service.c"
}

/**
 * Manages client connections to a specific network service.
 *
 * Client service object are used by accounts to manage client
 * connections to a specific network service, such as IMAP or SMTP
 * services. This abstract class does not connect to the service
 * itself, rather manages the configuration, status tracking, and
 * life-cycle of concrete implementations.
 */
 G_GNUC_NO_INLINE static GType
geary_client_service_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyClientServiceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_client_service_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyClientService), 0, (GInstanceInitFunc) geary_client_service_instance_init, NULL };
	static const GInterfaceInfo geary_logging_source_info = { (GInterfaceInitFunc) geary_client_service_geary_logging_source_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType geary_client_service_type_id;
	geary_client_service_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyClientService", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	g_type_add_interface_static (geary_client_service_type_id, GEARY_LOGGING_TYPE_SOURCE, &geary_logging_source_info);
	GearyClientService_private_offset = g_type_add_instance_private (geary_client_service_type_id, sizeof (GearyClientServicePrivate));
	return geary_client_service_type_id;
}

GType
geary_client_service_get_type (void)
{
	static gsize geary_client_service_type_id__once = 0;
	if (g_once_init_enter (&geary_client_service_type_id__once)) {
		GType geary_client_service_type_id;
		geary_client_service_type_id = geary_client_service_get_type_once ();
		g_once_init_leave (&geary_client_service_type_id__once, geary_client_service_type_id);
	}
	return geary_client_service_type_id__once;
}

static void
_vala_geary_client_service_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GearyClientService * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_CLIENT_SERVICE, GearyClientService);
#line 17 "../src/engine/api/geary-client-service.vala"
	switch (property_id) {
#line 17 "../src/engine/api/geary-client-service.vala"
		case GEARY_CLIENT_SERVICE_ACCOUNT_PROPERTY:
#line 17 "../src/engine/api/geary-client-service.vala"
		g_value_set_object (value, geary_client_service_get_account (self));
#line 17 "../src/engine/api/geary-client-service.vala"
		break;
#line 17 "../src/engine/api/geary-client-service.vala"
		case GEARY_CLIENT_SERVICE_CONFIGURATION_PROPERTY:
#line 17 "../src/engine/api/geary-client-service.vala"
		g_value_set_object (value, geary_client_service_get_configuration (self));
#line 17 "../src/engine/api/geary-client-service.vala"
		break;
#line 17 "../src/engine/api/geary-client-service.vala"
		case GEARY_CLIENT_SERVICE_CURRENT_STATUS_PROPERTY:
#line 17 "../src/engine/api/geary-client-service.vala"
		g_value_set_enum (value, geary_client_service_get_current_status (self));
#line 17 "../src/engine/api/geary-client-service.vala"
		break;
#line 17 "../src/engine/api/geary-client-service.vala"
		case GEARY_CLIENT_SERVICE_REMOTE_PROPERTY:
#line 17 "../src/engine/api/geary-client-service.vala"
		g_value_set_object (value, geary_client_service_get_remote (self));
#line 17 "../src/engine/api/geary-client-service.vala"
		break;
#line 17 "../src/engine/api/geary-client-service.vala"
		case GEARY_CLIENT_SERVICE_IS_RUNNING_PROPERTY:
#line 17 "../src/engine/api/geary-client-service.vala"
		g_value_set_boolean (value, geary_client_service_get_is_running (self));
#line 17 "../src/engine/api/geary-client-service.vala"
		break;
#line 17 "../src/engine/api/geary-client-service.vala"
		case GEARY_CLIENT_SERVICE_LAST_ERROR_PROPERTY:
#line 17 "../src/engine/api/geary-client-service.vala"
		g_value_set_object (value, geary_client_service_get_last_error (self));
#line 17 "../src/engine/api/geary-client-service.vala"
		break;
#line 17 "../src/engine/api/geary-client-service.vala"
		case GEARY_CLIENT_SERVICE_LOGGING_PARENT_PROPERTY:
#line 17 "../src/engine/api/geary-client-service.vala"
		g_value_set_object (value, geary_logging_source_get_logging_parent (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource)));
#line 17 "../src/engine/api/geary-client-service.vala"
		break;
#line 2118 "geary-client-service.c"
		default:
#line 17 "../src/engine/api/geary-client-service.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 17 "../src/engine/api/geary-client-service.vala"
		break;
#line 2124 "geary-client-service.c"
	}
}

static void
_vala_geary_client_service_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	GearyClientService * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_CLIENT_SERVICE, GearyClientService);
#line 17 "../src/engine/api/geary-client-service.vala"
	switch (property_id) {
#line 17 "../src/engine/api/geary-client-service.vala"
		case GEARY_CLIENT_SERVICE_ACCOUNT_PROPERTY:
#line 17 "../src/engine/api/geary-client-service.vala"
		geary_client_service_set_account (self, g_value_get_object (value));
#line 17 "../src/engine/api/geary-client-service.vala"
		break;
#line 17 "../src/engine/api/geary-client-service.vala"
		case GEARY_CLIENT_SERVICE_CONFIGURATION_PROPERTY:
#line 17 "../src/engine/api/geary-client-service.vala"
		geary_client_service_set_configuration (self, g_value_get_object (value));
#line 17 "../src/engine/api/geary-client-service.vala"
		break;
#line 17 "../src/engine/api/geary-client-service.vala"
		case GEARY_CLIENT_SERVICE_CURRENT_STATUS_PROPERTY:
#line 17 "../src/engine/api/geary-client-service.vala"
		geary_client_service_set_current_status (self, g_value_get_enum (value));
#line 17 "../src/engine/api/geary-client-service.vala"
		break;
#line 17 "../src/engine/api/geary-client-service.vala"
		case GEARY_CLIENT_SERVICE_REMOTE_PROPERTY:
#line 17 "../src/engine/api/geary-client-service.vala"
		geary_client_service_set_remote (self, g_value_get_object (value));
#line 17 "../src/engine/api/geary-client-service.vala"
		break;
#line 17 "../src/engine/api/geary-client-service.vala"
		case GEARY_CLIENT_SERVICE_IS_RUNNING_PROPERTY:
#line 17 "../src/engine/api/geary-client-service.vala"
		geary_client_service_set_is_running (self, g_value_get_boolean (value));
#line 17 "../src/engine/api/geary-client-service.vala"
		break;
#line 17 "../src/engine/api/geary-client-service.vala"
		case GEARY_CLIENT_SERVICE_LAST_ERROR_PROPERTY:
#line 17 "../src/engine/api/geary-client-service.vala"
		geary_client_service_set_last_error (self, g_value_get_object (value));
#line 17 "../src/engine/api/geary-client-service.vala"
		break;
#line 2174 "geary-client-service.c"
		default:
#line 17 "../src/engine/api/geary-client-service.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 17 "../src/engine/api/geary-client-service.vala"
		break;
#line 2180 "geary-client-service.c"
	}
}

