/* geary-contact.c generated by valac 0.56.17, the Vala compiler
 * generated from geary-contact.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2019 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_CONTACT_0_PROPERTY,
	GEARY_CONTACT_NORMALIZED_EMAIL_PROPERTY,
	GEARY_CONTACT_EMAIL_PROPERTY,
	GEARY_CONTACT_REAL_NAME_PROPERTY,
	GEARY_CONTACT_HIGHEST_IMPORTANCE_PROPERTY,
	GEARY_CONTACT_FLAGS_PROPERTY,
	GEARY_CONTACT_NUM_PROPERTIES
};
static GParamSpec* geary_contact_properties[GEARY_CONTACT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	GEARY_CONTACT_FLAGS_0_PROPERTY,
	GEARY_CONTACT_FLAGS_NUM_PROPERTIES
};
static GParamSpec* geary_contact_flags_properties[GEARY_CONTACT_FLAGS_NUM_PROPERTIES];

struct _GearyContactPrivate {
	gchar* _normalized_email;
	gchar* _email;
	gchar* _real_name;
	gint _highest_importance;
	GearyContactFlags* _flags;
};

static gint GearyContact_private_offset;
static gpointer geary_contact_parent_class = NULL;
static gpointer geary_contact_flags_parent_class = NULL;
static GearyNamedFlag* geary_contact_flags__always_load_remote_images;
static GearyNamedFlag* geary_contact_flags__always_load_remote_images = NULL;

static void geary_contact_set_normalized_email (GearyContact* self,
                                         const gchar* value);
static void geary_contact_set_email (GearyContact* self,
                              const gchar* value);
static void geary_contact_flags_finalize (GObject * obj);
static GType geary_contact_flags_get_type_once (void);
static void _vala_geary_contact_flags_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void geary_contact_finalize (GObject * obj);
static GType geary_contact_get_type_once (void);
static void _vala_geary_contact_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_geary_contact_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
geary_contact_get_instance_private (GearyContact* self)
{
	return G_STRUCT_MEMBER_P (self, GearyContact_private_offset);
}

/**
     * Standard values for contact importance..
     */
 G_GNUC_NO_INLINE static GType
geary_contact_importance_get_type_once (void)
{
	static const GEnumValue values[] = {{GEARY_CONTACT_IMPORTANCE_DESKTOP, "GEARY_CONTACT_IMPORTANCE_DESKTOP", "desktop"}, {GEARY_CONTACT_IMPORTANCE_SENT_TO, "GEARY_CONTACT_IMPORTANCE_SENT_TO", "sent-to"}, {GEARY_CONTACT_IMPORTANCE_RECEIVED_FROM, "GEARY_CONTACT_IMPORTANCE_RECEIVED_FROM", "received-from"}, {GEARY_CONTACT_IMPORTANCE_SEEN, "GEARY_CONTACT_IMPORTANCE_SEEN", "seen"}, {0, NULL, NULL}};
	GType geary_contact_importance_type_id;
	geary_contact_importance_type_id = g_enum_register_static ("GearyContactImportance", values);
	return geary_contact_importance_type_id;
}

GType
geary_contact_importance_get_type (void)
{
	static gsize geary_contact_importance_type_id__once = 0;
	if (g_once_init_enter (&geary_contact_importance_type_id__once)) {
		GType geary_contact_importance_type_id;
		geary_contact_importance_type_id = geary_contact_importance_get_type_once ();
		g_once_init_leave (&geary_contact_importance_type_id__once, geary_contact_importance_type_id);
	}
	return geary_contact_importance_type_id__once;
}

/** Normalises an email address as for {@link normalized_email}. */
gchar*
geary_contact_normalise_email (const gchar* address)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 64 "../src/engine/api/geary-contact.vala"
	g_return_val_if_fail (address != NULL, NULL);
#line 65 "../src/engine/api/geary-contact.vala"
	_tmp0_ = g_utf8_normalize (address, (gssize) -1, G_NORMALIZE_DEFAULT);
#line 65 "../src/engine/api/geary-contact.vala"
	_tmp1_ = _tmp0_;
#line 65 "../src/engine/api/geary-contact.vala"
	_tmp2_ = g_utf8_casefold (_tmp1_, (gssize) -1);
#line 65 "../src/engine/api/geary-contact.vala"
	_tmp3_ = _tmp2_;
#line 65 "../src/engine/api/geary-contact.vala"
	_g_free0 (_tmp1_);
#line 65 "../src/engine/api/geary-contact.vala"
	result = _tmp3_;
#line 65 "../src/engine/api/geary-contact.vala"
	return result;
#line 144 "geary-contact.c"
}

const gchar*
geary_contact_get_normalized_email (GearyContact* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 69 "../src/engine/api/geary-contact.vala"
	g_return_val_if_fail (GEARY_IS_CONTACT (self), NULL);
#line 69 "../src/engine/api/geary-contact.vala"
	_tmp0_ = self->priv->_normalized_email;
#line 69 "../src/engine/api/geary-contact.vala"
	result = _tmp0_;
#line 69 "../src/engine/api/geary-contact.vala"
	return result;
#line 160 "geary-contact.c"
}

static void
geary_contact_set_normalized_email (GearyContact* self,
                                    const gchar* value)
{
	gchar* old_value;
#line 69 "../src/engine/api/geary-contact.vala"
	g_return_if_fail (GEARY_IS_CONTACT (self));
#line 69 "../src/engine/api/geary-contact.vala"
	old_value = geary_contact_get_normalized_email (self);
#line 69 "../src/engine/api/geary-contact.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 174 "geary-contact.c"
		gchar* _tmp0_;
#line 69 "../src/engine/api/geary-contact.vala"
		_tmp0_ = g_strdup (value);
#line 69 "../src/engine/api/geary-contact.vala"
		_g_free0 (self->priv->_normalized_email);
#line 69 "../src/engine/api/geary-contact.vala"
		self->priv->_normalized_email = _tmp0_;
#line 69 "../src/engine/api/geary-contact.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_contact_properties[GEARY_CONTACT_NORMALIZED_EMAIL_PROPERTY]);
#line 184 "geary-contact.c"
	}
}

const gchar*
geary_contact_get_email (GearyContact* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 70 "../src/engine/api/geary-contact.vala"
	g_return_val_if_fail (GEARY_IS_CONTACT (self), NULL);
#line 70 "../src/engine/api/geary-contact.vala"
	_tmp0_ = self->priv->_email;
#line 70 "../src/engine/api/geary-contact.vala"
	result = _tmp0_;
#line 70 "../src/engine/api/geary-contact.vala"
	return result;
#line 201 "geary-contact.c"
}

static void
geary_contact_set_email (GearyContact* self,
                         const gchar* value)
{
	gchar* old_value;
#line 70 "../src/engine/api/geary-contact.vala"
	g_return_if_fail (GEARY_IS_CONTACT (self));
#line 70 "../src/engine/api/geary-contact.vala"
	old_value = geary_contact_get_email (self);
#line 70 "../src/engine/api/geary-contact.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 215 "geary-contact.c"
		gchar* _tmp0_;
#line 70 "../src/engine/api/geary-contact.vala"
		_tmp0_ = g_strdup (value);
#line 70 "../src/engine/api/geary-contact.vala"
		_g_free0 (self->priv->_email);
#line 70 "../src/engine/api/geary-contact.vala"
		self->priv->_email = _tmp0_;
#line 70 "../src/engine/api/geary-contact.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_contact_properties[GEARY_CONTACT_EMAIL_PROPERTY]);
#line 225 "geary-contact.c"
	}
}

const gchar*
geary_contact_get_real_name (GearyContact* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 71 "../src/engine/api/geary-contact.vala"
	g_return_val_if_fail (GEARY_IS_CONTACT (self), NULL);
#line 71 "../src/engine/api/geary-contact.vala"
	_tmp0_ = self->priv->_real_name;
#line 71 "../src/engine/api/geary-contact.vala"
	result = _tmp0_;
#line 71 "../src/engine/api/geary-contact.vala"
	return result;
#line 242 "geary-contact.c"
}

void
geary_contact_set_real_name (GearyContact* self,
                             const gchar* value)
{
	gchar* old_value;
#line 71 "../src/engine/api/geary-contact.vala"
	g_return_if_fail (GEARY_IS_CONTACT (self));
#line 71 "../src/engine/api/geary-contact.vala"
	old_value = geary_contact_get_real_name (self);
#line 71 "../src/engine/api/geary-contact.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 256 "geary-contact.c"
		gchar* _tmp0_;
#line 71 "../src/engine/api/geary-contact.vala"
		_tmp0_ = g_strdup (value);
#line 71 "../src/engine/api/geary-contact.vala"
		_g_free0 (self->priv->_real_name);
#line 71 "../src/engine/api/geary-contact.vala"
		self->priv->_real_name = _tmp0_;
#line 71 "../src/engine/api/geary-contact.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_contact_properties[GEARY_CONTACT_REAL_NAME_PROPERTY]);
#line 266 "geary-contact.c"
	}
}

gint
geary_contact_get_highest_importance (GearyContact* self)
{
	gint result;
#line 72 "../src/engine/api/geary-contact.vala"
	g_return_val_if_fail (GEARY_IS_CONTACT (self), 0);
#line 72 "../src/engine/api/geary-contact.vala"
	result = self->priv->_highest_importance;
#line 72 "../src/engine/api/geary-contact.vala"
	return result;
#line 280 "geary-contact.c"
}

void
geary_contact_set_highest_importance (GearyContact* self,
                                      gint value)
{
	gint old_value;
#line 72 "../src/engine/api/geary-contact.vala"
	g_return_if_fail (GEARY_IS_CONTACT (self));
#line 72 "../src/engine/api/geary-contact.vala"
	old_value = geary_contact_get_highest_importance (self);
#line 72 "../src/engine/api/geary-contact.vala"
	if (old_value != value) {
#line 72 "../src/engine/api/geary-contact.vala"
		self->priv->_highest_importance = value;
#line 72 "../src/engine/api/geary-contact.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_contact_properties[GEARY_CONTACT_HIGHEST_IMPORTANCE_PROPERTY]);
#line 298 "geary-contact.c"
	}
}

GearyContactFlags*
geary_contact_get_flags (GearyContact* self)
{
	GearyContactFlags* result;
	GearyContactFlags* _tmp0_;
#line 73 "../src/engine/api/geary-contact.vala"
	g_return_val_if_fail (GEARY_IS_CONTACT (self), NULL);
#line 73 "../src/engine/api/geary-contact.vala"
	_tmp0_ = self->priv->_flags;
#line 73 "../src/engine/api/geary-contact.vala"
	result = _tmp0_;
#line 73 "../src/engine/api/geary-contact.vala"
	return result;
#line 315 "geary-contact.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 73 "../src/engine/api/geary-contact.vala"
	return self ? g_object_ref (self) : NULL;
#line 323 "geary-contact.c"
}

void
geary_contact_set_flags (GearyContact* self,
                         GearyContactFlags* value)
{
	GearyContactFlags* old_value;
#line 73 "../src/engine/api/geary-contact.vala"
	g_return_if_fail (GEARY_IS_CONTACT (self));
#line 73 "../src/engine/api/geary-contact.vala"
	old_value = geary_contact_get_flags (self);
#line 73 "../src/engine/api/geary-contact.vala"
	if (old_value != value) {
#line 337 "geary-contact.c"
		GearyContactFlags* _tmp0_;
#line 73 "../src/engine/api/geary-contact.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 73 "../src/engine/api/geary-contact.vala"
		_g_object_unref0 (self->priv->_flags);
#line 73 "../src/engine/api/geary-contact.vala"
		self->priv->_flags = _tmp0_;
#line 73 "../src/engine/api/geary-contact.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_contact_properties[GEARY_CONTACT_FLAGS_PROPERTY]);
#line 347 "geary-contact.c"
	}
}

GearyContact*
geary_contact_construct (GType object_type,
                         const gchar* email,
                         const gchar* real_name,
                         gint highest_importance,
                         const gchar* normalized_email)
{
	GearyContact * self = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	const gchar* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
#line 75 "../src/engine/api/geary-contact.vala"
	g_return_val_if_fail (email != NULL, NULL);
#line 75 "../src/engine/api/geary-contact.vala"
	self = (GearyContact*) geary_base_object_construct (object_type);
#line 79 "../src/engine/api/geary-contact.vala"
	_tmp1_ = g_strdup (normalized_email);
#line 79 "../src/engine/api/geary-contact.vala"
	_tmp0_ = _tmp1_;
#line 79 "../src/engine/api/geary-contact.vala"
	if (_tmp0_ == NULL) {
#line 373 "geary-contact.c"
		gchar* _tmp2_;
#line 79 "../src/engine/api/geary-contact.vala"
		_tmp2_ = geary_contact_normalise_email (email);
#line 79 "../src/engine/api/geary-contact.vala"
		_g_free0 (_tmp0_);
#line 79 "../src/engine/api/geary-contact.vala"
		_tmp0_ = _tmp2_;
#line 381 "geary-contact.c"
	}
#line 79 "../src/engine/api/geary-contact.vala"
	geary_contact_set_normalized_email (self, _tmp0_);
#line 80 "../src/engine/api/geary-contact.vala"
	geary_contact_set_email (self, email);
#line 82 "../src/engine/api/geary-contact.vala"
	if (g_strcmp0 (real_name, email) != 0) {
#line 82 "../src/engine/api/geary-contact.vala"
		_tmp4_ = g_strcmp0 (real_name, normalized_email) != 0;
#line 391 "geary-contact.c"
	} else {
#line 82 "../src/engine/api/geary-contact.vala"
		_tmp4_ = FALSE;
#line 395 "geary-contact.c"
	}
#line 81 "../src/engine/api/geary-contact.vala"
	if (_tmp4_) {
#line 83 "../src/engine/api/geary-contact.vala"
		_tmp3_ = real_name;
#line 401 "geary-contact.c"
	} else {
#line 83 "../src/engine/api/geary-contact.vala"
		_tmp3_ = NULL;
#line 405 "geary-contact.c"
	}
#line 81 "../src/engine/api/geary-contact.vala"
	geary_contact_set_real_name (self, _tmp3_);
#line 85 "../src/engine/api/geary-contact.vala"
	geary_contact_set_highest_importance (self, highest_importance);
#line 75 "../src/engine/api/geary-contact.vala"
	_g_free0 (_tmp0_);
#line 75 "../src/engine/api/geary-contact.vala"
	return self;
#line 415 "geary-contact.c"
}

GearyContact*
geary_contact_new (const gchar* email,
                   const gchar* real_name,
                   gint highest_importance,
                   const gchar* normalized_email)
{
#line 75 "../src/engine/api/geary-contact.vala"
	return geary_contact_construct (GEARY_TYPE_CONTACT, email, real_name, highest_importance, normalized_email);
#line 426 "geary-contact.c"
}

GearyContact*
geary_contact_construct_from_rfc822_address (GType object_type,
                                             GearyRFC822MailboxAddress* address,
                                             gint highest_importance)
{
	GearyContact * self = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
#line 88 "../src/engine/api/geary-contact.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MAILBOX_ADDRESS (address), NULL);
#line 92 "../src/engine/api/geary-contact.vala"
	if (geary_rf_c822_mailbox_address_has_distinct_name (address)) {
#line 442 "geary-contact.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 92 "../src/engine/api/geary-contact.vala"
		_tmp1_ = geary_rf_c822_mailbox_address_get_name (address);
#line 92 "../src/engine/api/geary-contact.vala"
		_tmp2_ = _tmp1_;
#line 92 "../src/engine/api/geary-contact.vala"
		_tmp0_ = _tmp2_;
#line 451 "geary-contact.c"
	} else {
#line 92 "../src/engine/api/geary-contact.vala"
		_tmp0_ = NULL;
#line 455 "geary-contact.c"
	}
#line 90 "../src/engine/api/geary-contact.vala"
	_tmp3_ = geary_rf_c822_mailbox_address_get_address (address);
#line 90 "../src/engine/api/geary-contact.vala"
	_tmp4_ = _tmp3_;
#line 90 "../src/engine/api/geary-contact.vala"
	self = (GearyContact*) geary_contact_construct (object_type, _tmp4_, _tmp0_, highest_importance, NULL);
#line 88 "../src/engine/api/geary-contact.vala"
	return self;
#line 465 "geary-contact.c"
}

GearyContact*
geary_contact_new_from_rfc822_address (GearyRFC822MailboxAddress* address,
                                       gint highest_importance)
{
#line 88 "../src/engine/api/geary-contact.vala"
	return geary_contact_construct_from_rfc822_address (GEARY_TYPE_CONTACT, address, highest_importance);
#line 474 "geary-contact.c"
}

GearyRFC822MailboxAddress*
geary_contact_get_rfc822_address (GearyContact* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GearyRFC822MailboxAddress* _tmp2_;
	GearyRFC822MailboxAddress* result;
#line 97 "../src/engine/api/geary-contact.vala"
	g_return_val_if_fail (GEARY_IS_CONTACT (self), NULL);
#line 98 "../src/engine/api/geary-contact.vala"
	_tmp0_ = self->priv->_real_name;
#line 98 "../src/engine/api/geary-contact.vala"
	_tmp1_ = self->priv->_email;
#line 98 "../src/engine/api/geary-contact.vala"
	_tmp2_ = geary_rf_c822_mailbox_address_new (_tmp0_, _tmp1_);
#line 98 "../src/engine/api/geary-contact.vala"
	result = _tmp2_;
#line 98 "../src/engine/api/geary-contact.vala"
	return result;
#line 496 "geary-contact.c"
}

GearyNamedFlag*
geary_contact_flags_get_ALWAYS_LOAD_REMOTE_IMAGES (void)
{
	GearyNamedFlag* result;
	GearyNamedFlag* _tmp0_;
	GearyNamedFlag* _tmp2_;
#line 29 "../src/engine/api/geary-contact.vala"
	_tmp0_ = geary_contact_flags__always_load_remote_images;
#line 29 "../src/engine/api/geary-contact.vala"
	if (_tmp0_ == NULL) {
#line 509 "geary-contact.c"
		GearyNamedFlag* _tmp1_;
#line 30 "../src/engine/api/geary-contact.vala"
		_tmp1_ = geary_named_flag_new ("ALWAYSLOADREMOTEIMAGES");
#line 30 "../src/engine/api/geary-contact.vala"
		_g_object_unref0 (geary_contact_flags__always_load_remote_images);
#line 30 "../src/engine/api/geary-contact.vala"
		geary_contact_flags__always_load_remote_images = _tmp1_;
#line 517 "geary-contact.c"
	}
#line 33 "../src/engine/api/geary-contact.vala"
	_tmp2_ = geary_contact_flags__always_load_remote_images;
#line 33 "../src/engine/api/geary-contact.vala"
	result = _tmp2_;
#line 33 "../src/engine/api/geary-contact.vala"
	return result;
#line 525 "geary-contact.c"
}

gboolean
geary_contact_flags_always_load_remote_images (GearyContactFlags* self)
{
	GearyNamedFlag* _tmp0_;
	GearyNamedFlag* _tmp1_;
	gboolean result;
#line 39 "../src/engine/api/geary-contact.vala"
	g_return_val_if_fail (GEARY_CONTACT_IS_FLAGS (self), FALSE);
#line 40 "../src/engine/api/geary-contact.vala"
	_tmp0_ = geary_contact_flags_get_ALWAYS_LOAD_REMOTE_IMAGES ();
#line 40 "../src/engine/api/geary-contact.vala"
	_tmp1_ = _tmp0_;
#line 40 "../src/engine/api/geary-contact.vala"
	result = geary_named_flags_contains (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_NAMED_FLAGS, GearyNamedFlags), _tmp1_);
#line 40 "../src/engine/api/geary-contact.vala"
	return result;
#line 544 "geary-contact.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 565 "geary-contact.c"
}

gchar*
geary_contact_flags_serialize (GearyContactFlags* self)
{
	gchar* ret = NULL;
	gchar* _tmp0_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* result;
#line 43 "../src/engine/api/geary-contact.vala"
	g_return_val_if_fail (GEARY_CONTACT_IS_FLAGS (self), NULL);
#line 44 "../src/engine/api/geary-contact.vala"
	_tmp0_ = g_strdup ("");
#line 44 "../src/engine/api/geary-contact.vala"
	ret = _tmp0_;
#line 582 "geary-contact.c"
	{
		GeeIterator* _flag_it = NULL;
		GeeSet* _tmp1_;
		GeeIterator* _tmp2_;
#line 45 "../src/engine/api/geary-contact.vala"
		_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_NAMED_FLAGS, GearyNamedFlags)->list;
#line 45 "../src/engine/api/geary-contact.vala"
		_tmp2_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ITERABLE, GeeIterable));
#line 45 "../src/engine/api/geary-contact.vala"
		_flag_it = _tmp2_;
#line 45 "../src/engine/api/geary-contact.vala"
		while (TRUE) {
#line 595 "geary-contact.c"
			GeeIterator* _tmp3_;
			GearyNamedFlag* flag = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			const gchar* _tmp6_;
			GearyNamedFlag* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 45 "../src/engine/api/geary-contact.vala"
			_tmp3_ = _flag_it;
#line 45 "../src/engine/api/geary-contact.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 45 "../src/engine/api/geary-contact.vala"
				break;
#line 613 "geary-contact.c"
			}
#line 45 "../src/engine/api/geary-contact.vala"
			_tmp4_ = _flag_it;
#line 45 "../src/engine/api/geary-contact.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 45 "../src/engine/api/geary-contact.vala"
			flag = (GearyNamedFlag*) _tmp5_;
#line 46 "../src/engine/api/geary-contact.vala"
			_tmp6_ = ret;
#line 46 "../src/engine/api/geary-contact.vala"
			_tmp7_ = flag;
#line 46 "../src/engine/api/geary-contact.vala"
			_tmp8_ = geary_named_flag_serialise (_tmp7_);
#line 46 "../src/engine/api/geary-contact.vala"
			_tmp9_ = _tmp8_;
#line 46 "../src/engine/api/geary-contact.vala"
			_tmp10_ = g_strconcat (_tmp9_, " ", NULL);
#line 46 "../src/engine/api/geary-contact.vala"
			_tmp11_ = _tmp10_;
#line 46 "../src/engine/api/geary-contact.vala"
			_tmp12_ = g_strconcat (_tmp6_, _tmp11_, NULL);
#line 46 "../src/engine/api/geary-contact.vala"
			_g_free0 (ret);
#line 46 "../src/engine/api/geary-contact.vala"
			ret = _tmp12_;
#line 46 "../src/engine/api/geary-contact.vala"
			_g_free0 (_tmp11_);
#line 46 "../src/engine/api/geary-contact.vala"
			_g_free0 (_tmp9_);
#line 45 "../src/engine/api/geary-contact.vala"
			_g_object_unref0 (flag);
#line 645 "geary-contact.c"
		}
#line 45 "../src/engine/api/geary-contact.vala"
		_g_object_unref0 (_flag_it);
#line 649 "geary-contact.c"
	}
#line 49 "../src/engine/api/geary-contact.vala"
	_tmp13_ = ret;
#line 49 "../src/engine/api/geary-contact.vala"
	_tmp14_ = string_strip (_tmp13_);
#line 49 "../src/engine/api/geary-contact.vala"
	result = _tmp14_;
#line 49 "../src/engine/api/geary-contact.vala"
	_g_free0 (ret);
#line 49 "../src/engine/api/geary-contact.vala"
	return result;
#line 661 "geary-contact.c"
}

void
geary_contact_flags_deserialize (GearyContactFlags* self,
                                 const gchar* flags)
{
#line 52 "../src/engine/api/geary-contact.vala"
	g_return_if_fail (GEARY_CONTACT_IS_FLAGS (self));
#line 53 "../src/engine/api/geary-contact.vala"
	if (!geary_string_is_empty (flags)) {
#line 672 "geary-contact.c"
		gchar** _tmp0_;
		gchar** _tmp1_;
#line 54 "../src/engine/api/geary-contact.vala"
		_tmp1_ = _tmp0_ = g_strsplit (flags, " ", 0);
#line 677 "geary-contact.c"
		{
			gchar** flag_collection = NULL;
			gint flag_collection_length1 = 0;
			gint _flag_collection_size_ = 0;
			gint flag_it = 0;
#line 54 "../src/engine/api/geary-contact.vala"
			flag_collection = _tmp1_;
#line 54 "../src/engine/api/geary-contact.vala"
			flag_collection_length1 = _vala_array_length (_tmp0_);
#line 54 "../src/engine/api/geary-contact.vala"
			for (flag_it = 0; flag_it < flag_collection_length1; flag_it = flag_it + 1) {
#line 689 "geary-contact.c"
				gchar* _tmp2_;
				gchar* flag = NULL;
#line 54 "../src/engine/api/geary-contact.vala"
				_tmp2_ = g_strdup (flag_collection[flag_it]);
#line 54 "../src/engine/api/geary-contact.vala"
				flag = _tmp2_;
#line 696 "geary-contact.c"
				{
					const gchar* _tmp3_;
					GearyNamedFlag* _tmp4_;
					GearyNamedFlag* _tmp5_;
#line 55 "../src/engine/api/geary-contact.vala"
					_tmp3_ = flag;
#line 55 "../src/engine/api/geary-contact.vala"
					_tmp4_ = geary_named_flag_new (_tmp3_);
#line 55 "../src/engine/api/geary-contact.vala"
					_tmp5_ = _tmp4_;
#line 55 "../src/engine/api/geary-contact.vala"
					geary_named_flags_add (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_NAMED_FLAGS, GearyNamedFlags), _tmp5_);
#line 55 "../src/engine/api/geary-contact.vala"
					_g_object_unref0 (_tmp5_);
#line 54 "../src/engine/api/geary-contact.vala"
					_g_free0 (flag);
#line 713 "geary-contact.c"
				}
			}
#line 54 "../src/engine/api/geary-contact.vala"
			flag_collection = (_vala_array_free (flag_collection, flag_collection_length1, (GDestroyNotify) g_free), NULL);
#line 718 "geary-contact.c"
		}
	}
}

GearyContactFlags*
geary_contact_flags_construct (GType object_type)
{
	GearyContactFlags * self = NULL;
#line 25 "../src/engine/api/geary-contact.vala"
	self = (GearyContactFlags*) geary_named_flags_construct (object_type);
#line 25 "../src/engine/api/geary-contact.vala"
	return self;
#line 731 "geary-contact.c"
}

GearyContactFlags*
geary_contact_flags_new (void)
{
#line 25 "../src/engine/api/geary-contact.vala"
	return geary_contact_flags_construct (GEARY_CONTACT_TYPE_FLAGS);
#line 739 "geary-contact.c"
}

static void
geary_contact_flags_class_init (GearyContactFlagsClass * klass,
                                gpointer klass_data)
{
#line 25 "../src/engine/api/geary-contact.vala"
	geary_contact_flags_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/engine/api/geary-contact.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_contact_flags_get_property;
#line 25 "../src/engine/api/geary-contact.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_contact_flags_finalize;
#line 752 "geary-contact.c"
}

static void
geary_contact_flags_instance_init (GearyContactFlags * self,
                                   gpointer klass)
{
}

static void
geary_contact_flags_finalize (GObject * obj)
{
	GearyContactFlags * self;
#line 25 "../src/engine/api/geary-contact.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_CONTACT_TYPE_FLAGS, GearyContactFlags);
#line 25 "../src/engine/api/geary-contact.vala"
	G_OBJECT_CLASS (geary_contact_flags_parent_class)->finalize (obj);
#line 769 "geary-contact.c"
}

/**
     * Named flags for contact objects.
     */
 G_GNUC_NO_INLINE static GType
geary_contact_flags_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyContactFlagsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_contact_flags_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyContactFlags), 0, (GInstanceInitFunc) geary_contact_flags_instance_init, NULL };
	GType geary_contact_flags_type_id;
	geary_contact_flags_type_id = g_type_register_static (GEARY_TYPE_NAMED_FLAGS, "GearyContactFlags", &g_define_type_info, 0);
	return geary_contact_flags_type_id;
}

GType
geary_contact_flags_get_type (void)
{
	static gsize geary_contact_flags_type_id__once = 0;
	if (g_once_init_enter (&geary_contact_flags_type_id__once)) {
		GType geary_contact_flags_type_id;
		geary_contact_flags_type_id = geary_contact_flags_get_type_once ();
		g_once_init_leave (&geary_contact_flags_type_id__once, geary_contact_flags_type_id);
	}
	return geary_contact_flags_type_id__once;
}

static void
_vala_geary_contact_flags_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	GearyContactFlags * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_CONTACT_TYPE_FLAGS, GearyContactFlags);
#line 25 "../src/engine/api/geary-contact.vala"
	switch (property_id) {
#line 806 "geary-contact.c"
		default:
#line 25 "../src/engine/api/geary-contact.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/engine/api/geary-contact.vala"
		break;
#line 812 "geary-contact.c"
	}
}

static void
geary_contact_class_init (GearyContactClass * klass,
                          gpointer klass_data)
{
#line 9 "../src/engine/api/geary-contact.vala"
	geary_contact_parent_class = g_type_class_peek_parent (klass);
#line 9 "../src/engine/api/geary-contact.vala"
	g_type_class_adjust_private_offset (klass, &GearyContact_private_offset);
#line 9 "../src/engine/api/geary-contact.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_contact_get_property;
#line 9 "../src/engine/api/geary-contact.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_contact_set_property;
#line 9 "../src/engine/api/geary-contact.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_contact_finalize;
#line 9 "../src/engine/api/geary-contact.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_CONTACT_NORMALIZED_EMAIL_PROPERTY, geary_contact_properties[GEARY_CONTACT_NORMALIZED_EMAIL_PROPERTY] = g_param_spec_string ("normalized-email", "normalized-email", "normalized-email", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 9 "../src/engine/api/geary-contact.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_CONTACT_EMAIL_PROPERTY, geary_contact_properties[GEARY_CONTACT_EMAIL_PROPERTY] = g_param_spec_string ("email", "email", "email", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 9 "../src/engine/api/geary-contact.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_CONTACT_REAL_NAME_PROPERTY, geary_contact_properties[GEARY_CONTACT_REAL_NAME_PROPERTY] = g_param_spec_string ("real-name", "real-name", "real-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 9 "../src/engine/api/geary-contact.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_CONTACT_HIGHEST_IMPORTANCE_PROPERTY, geary_contact_properties[GEARY_CONTACT_HIGHEST_IMPORTANCE_PROPERTY] = g_param_spec_int ("highest-importance", "highest-importance", "highest-importance", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 9 "../src/engine/api/geary-contact.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_CONTACT_FLAGS_PROPERTY, geary_contact_properties[GEARY_CONTACT_FLAGS_PROPERTY] = g_param_spec_object ("flags", "flags", "flags", GEARY_CONTACT_TYPE_FLAGS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 840 "geary-contact.c"
}

static void
geary_contact_instance_init (GearyContact * self,
                             gpointer klass)
{
	GearyContactFlags* _tmp0_;
#line 9 "../src/engine/api/geary-contact.vala"
	self->priv = geary_contact_get_instance_private (self);
#line 73 "../src/engine/api/geary-contact.vala"
	_tmp0_ = geary_contact_flags_new ();
#line 73 "../src/engine/api/geary-contact.vala"
	self->priv->_flags = _tmp0_;
#line 854 "geary-contact.c"
}

static void
geary_contact_finalize (GObject * obj)
{
	GearyContact * self;
#line 9 "../src/engine/api/geary-contact.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_TYPE_CONTACT, GearyContact);
#line 69 "../src/engine/api/geary-contact.vala"
	_g_free0 (self->priv->_normalized_email);
#line 70 "../src/engine/api/geary-contact.vala"
	_g_free0 (self->priv->_email);
#line 71 "../src/engine/api/geary-contact.vala"
	_g_free0 (self->priv->_real_name);
#line 73 "../src/engine/api/geary-contact.vala"
	_g_object_unref0 (self->priv->_flags);
#line 9 "../src/engine/api/geary-contact.vala"
	G_OBJECT_CLASS (geary_contact_parent_class)->finalize (obj);
#line 873 "geary-contact.c"
}

 G_GNUC_NO_INLINE static GType
geary_contact_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyContactClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_contact_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyContact), 0, (GInstanceInitFunc) geary_contact_instance_init, NULL };
	GType geary_contact_type_id;
	geary_contact_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyContact", &g_define_type_info, 0);
	GearyContact_private_offset = g_type_add_instance_private (geary_contact_type_id, sizeof (GearyContactPrivate));
	return geary_contact_type_id;
}

GType
geary_contact_get_type (void)
{
	static gsize geary_contact_type_id__once = 0;
	if (g_once_init_enter (&geary_contact_type_id__once)) {
		GType geary_contact_type_id;
		geary_contact_type_id = geary_contact_get_type_once ();
		g_once_init_leave (&geary_contact_type_id__once, geary_contact_type_id);
	}
	return geary_contact_type_id__once;
}

static void
_vala_geary_contact_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	GearyContact * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_CONTACT, GearyContact);
#line 9 "../src/engine/api/geary-contact.vala"
	switch (property_id) {
#line 9 "../src/engine/api/geary-contact.vala"
		case GEARY_CONTACT_NORMALIZED_EMAIL_PROPERTY:
#line 9 "../src/engine/api/geary-contact.vala"
		g_value_set_string (value, geary_contact_get_normalized_email (self));
#line 9 "../src/engine/api/geary-contact.vala"
		break;
#line 9 "../src/engine/api/geary-contact.vala"
		case GEARY_CONTACT_EMAIL_PROPERTY:
#line 9 "../src/engine/api/geary-contact.vala"
		g_value_set_string (value, geary_contact_get_email (self));
#line 9 "../src/engine/api/geary-contact.vala"
		break;
#line 9 "../src/engine/api/geary-contact.vala"
		case GEARY_CONTACT_REAL_NAME_PROPERTY:
#line 9 "../src/engine/api/geary-contact.vala"
		g_value_set_string (value, geary_contact_get_real_name (self));
#line 9 "../src/engine/api/geary-contact.vala"
		break;
#line 9 "../src/engine/api/geary-contact.vala"
		case GEARY_CONTACT_HIGHEST_IMPORTANCE_PROPERTY:
#line 9 "../src/engine/api/geary-contact.vala"
		g_value_set_int (value, geary_contact_get_highest_importance (self));
#line 9 "../src/engine/api/geary-contact.vala"
		break;
#line 9 "../src/engine/api/geary-contact.vala"
		case GEARY_CONTACT_FLAGS_PROPERTY:
#line 9 "../src/engine/api/geary-contact.vala"
		g_value_set_object (value, geary_contact_get_flags (self));
#line 9 "../src/engine/api/geary-contact.vala"
		break;
#line 938 "geary-contact.c"
		default:
#line 9 "../src/engine/api/geary-contact.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 9 "../src/engine/api/geary-contact.vala"
		break;
#line 944 "geary-contact.c"
	}
}

static void
_vala_geary_contact_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	GearyContact * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_CONTACT, GearyContact);
#line 9 "../src/engine/api/geary-contact.vala"
	switch (property_id) {
#line 9 "../src/engine/api/geary-contact.vala"
		case GEARY_CONTACT_NORMALIZED_EMAIL_PROPERTY:
#line 9 "../src/engine/api/geary-contact.vala"
		geary_contact_set_normalized_email (self, g_value_get_string (value));
#line 9 "../src/engine/api/geary-contact.vala"
		break;
#line 9 "../src/engine/api/geary-contact.vala"
		case GEARY_CONTACT_EMAIL_PROPERTY:
#line 9 "../src/engine/api/geary-contact.vala"
		geary_contact_set_email (self, g_value_get_string (value));
#line 9 "../src/engine/api/geary-contact.vala"
		break;
#line 9 "../src/engine/api/geary-contact.vala"
		case GEARY_CONTACT_REAL_NAME_PROPERTY:
#line 9 "../src/engine/api/geary-contact.vala"
		geary_contact_set_real_name (self, g_value_get_string (value));
#line 9 "../src/engine/api/geary-contact.vala"
		break;
#line 9 "../src/engine/api/geary-contact.vala"
		case GEARY_CONTACT_HIGHEST_IMPORTANCE_PROPERTY:
#line 9 "../src/engine/api/geary-contact.vala"
		geary_contact_set_highest_importance (self, g_value_get_int (value));
#line 9 "../src/engine/api/geary-contact.vala"
		break;
#line 9 "../src/engine/api/geary-contact.vala"
		case GEARY_CONTACT_FLAGS_PROPERTY:
#line 9 "../src/engine/api/geary-contact.vala"
		geary_contact_set_flags (self, g_value_get_object (value));
#line 9 "../src/engine/api/geary-contact.vala"
		break;
#line 988 "geary-contact.c"
		default:
#line 9 "../src/engine/api/geary-contact.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 9 "../src/engine/api/geary-contact.vala"
		break;
#line 994 "geary-contact.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

