/* geary-credentials.c generated by valac 0.56.17, the Vala compiler
 * generated from geary-credentials.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2018 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_CREDENTIALS_0_PROPERTY,
	GEARY_CREDENTIALS_SUPPORTED_METHOD_PROPERTY,
	GEARY_CREDENTIALS_USER_PROPERTY,
	GEARY_CREDENTIALS_TOKEN_PROPERTY,
	GEARY_CREDENTIALS_NUM_PROPERTIES
};
static GParamSpec* geary_credentials_properties[GEARY_CREDENTIALS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GearyCredentialsPrivate {
	GearyCredentialsMethod _supported_method;
	gchar* _user;
	gchar* _token;
};

static gint GearyCredentials_private_offset;
static gpointer geary_credentials_parent_class = NULL;
static GeeHashableIface * geary_credentials_gee_hashable_parent_iface = NULL;

static void geary_credentials_set_supported_method (GearyCredentials* self,
                                             GearyCredentialsMethod value);
static void geary_credentials_set_user (GearyCredentials* self,
                                 const gchar* value);
static void geary_credentials_set_token (GearyCredentials* self,
                                  const gchar* value);
static gboolean geary_credentials_real_equal_to (GeeHashable* base,
                                          GearyCredentials* c);
static guint geary_credentials_real_hash (GeeHashable* base);
static void geary_credentials_finalize (GObject * obj);
static GType geary_credentials_get_type_once (void);
static void _vala_geary_credentials_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_geary_credentials_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static inline gpointer
geary_credentials_get_instance_private (GearyCredentials* self)
{
	return G_STRUCT_MEMBER_P (self, GearyCredentials_private_offset);
}

/**
     * Authentication methods supported by the Engine.
     */
gchar*
geary_credentials_method_to_string (GearyCredentialsMethod self)
{
	gchar* result;
#line 44 "../src/engine/api/geary-credentials.vala"
	switch (self) {
#line 44 "../src/engine/api/geary-credentials.vala"
		case GEARY_CREDENTIALS_METHOD_PASSWORD:
#line 86 "geary-credentials.c"
		{
			gchar* _tmp0_;
#line 46 "../src/engine/api/geary-credentials.vala"
			_tmp0_ = g_strdup ("password");
#line 46 "../src/engine/api/geary-credentials.vala"
			result = _tmp0_;
#line 46 "../src/engine/api/geary-credentials.vala"
			return result;
#line 95 "geary-credentials.c"
		}
#line 44 "../src/engine/api/geary-credentials.vala"
		case GEARY_CREDENTIALS_METHOD_OAUTH2:
#line 99 "geary-credentials.c"
		{
			gchar* _tmp1_;
#line 49 "../src/engine/api/geary-credentials.vala"
			_tmp1_ = g_strdup ("oauth2");
#line 49 "../src/engine/api/geary-credentials.vala"
			result = _tmp1_;
#line 49 "../src/engine/api/geary-credentials.vala"
			return result;
#line 108 "geary-credentials.c"
		}
		default:
		{
#line 52 "../src/engine/api/geary-credentials.vala"
			g_assert_not_reached ();
#line 114 "geary-credentials.c"
		}
	}
}

GearyCredentialsMethod
geary_credentials_method_from_string (const gchar* str,
                                      GError** error)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 57 "../src/engine/api/geary-credentials.vala"
	static GQuark _tmp1_label0 = 0;
#line 57 "../src/engine/api/geary-credentials.vala"
	static GQuark _tmp1_label1 = 0;
#line 129 "geary-credentials.c"
	GError* _inner_error0_ = NULL;
	GearyCredentialsMethod result;
#line 56 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (str != NULL, 0);
#line 57 "../src/engine/api/geary-credentials.vala"
	_tmp0_ = str;
#line 57 "../src/engine/api/geary-credentials.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 57 "../src/engine/api/geary-credentials.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("password")))) {
#line 57 "../src/engine/api/geary-credentials.vala"
		switch (0) {
#line 142 "geary-credentials.c"
			default:
			{
#line 59 "../src/engine/api/geary-credentials.vala"
				result = GEARY_CREDENTIALS_METHOD_PASSWORD;
#line 59 "../src/engine/api/geary-credentials.vala"
				return result;
#line 149 "geary-credentials.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("oauth2")))) {
#line 57 "../src/engine/api/geary-credentials.vala"
		switch (0) {
#line 155 "geary-credentials.c"
			default:
			{
#line 62 "../src/engine/api/geary-credentials.vala"
				result = GEARY_CREDENTIALS_METHOD_OAUTH2;
#line 62 "../src/engine/api/geary-credentials.vala"
				return result;
#line 162 "geary-credentials.c"
			}
		}
	} else {
#line 57 "../src/engine/api/geary-credentials.vala"
		switch (0) {
#line 168 "geary-credentials.c"
			default:
			{
				GError* _tmp3_;
#line 65 "../src/engine/api/geary-credentials.vala"
				_tmp3_ = g_error_new (G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_INVALID_VALUE, "Unknown credentials method type: %s", str);
#line 65 "../src/engine/api/geary-credentials.vala"
				_inner_error0_ = _tmp3_;
#line 65 "../src/engine/api/geary-credentials.vala"
				g_propagate_error (error, _inner_error0_);
#line 65 "../src/engine/api/geary-credentials.vala"
				return 0;
#line 180 "geary-credentials.c"
			}
		}
	}
}

 G_GNUC_NO_INLINE static GType
geary_credentials_method_get_type_once (void)
{
	static const GEnumValue values[] = {{GEARY_CREDENTIALS_METHOD_PASSWORD, "GEARY_CREDENTIALS_METHOD_PASSWORD", "password"}, {GEARY_CREDENTIALS_METHOD_OAUTH2, "GEARY_CREDENTIALS_METHOD_OAUTH2", "oauth2"}, {0, NULL, NULL}};
	GType geary_credentials_method_type_id;
	geary_credentials_method_type_id = g_enum_register_static ("GearyCredentialsMethod", values);
	return geary_credentials_method_type_id;
}

GType
geary_credentials_method_get_type (void)
{
	static gsize geary_credentials_method_type_id__once = 0;
	if (g_once_init_enter (&geary_credentials_method_type_id__once)) {
		GType geary_credentials_method_type_id;
		geary_credentials_method_type_id = geary_credentials_method_get_type_once ();
		g_once_init_leave (&geary_credentials_method_type_id__once, geary_credentials_method_type_id);
	}
	return geary_credentials_method_type_id__once;
}

/** The requirements for a service's credentials. */
GearyCredentialsRequirement
geary_credentials_requirement_for_value (const gchar* value,
                                         GError** error)
{
	GearyCredentialsRequirement _tmp0_ = 0;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gpointer _tmp3_;
	GearyCredentialsRequirement _tmp4_;
	GError* _inner_error0_ = NULL;
	GearyCredentialsRequirement result;
#line 84 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (value != NULL, 0);
#line 86 "../src/engine/api/geary-credentials.vala"
	_tmp1_ = g_ascii_strdown (value, (gssize) -1);
#line 86 "../src/engine/api/geary-credentials.vala"
	_tmp2_ = _tmp1_;
#line 86 "../src/engine/api/geary-credentials.vala"
	_tmp3_ = geary_object_utils_from_enum_nick (GEARY_CREDENTIALS_TYPE_REQUIREMENT, NULL, NULL, GEARY_CREDENTIALS_TYPE_REQUIREMENT, _tmp2_, &_inner_error0_);
#line 86 "../src/engine/api/geary-credentials.vala"
	_tmp4_ = (GearyCredentialsRequirement) ((gintptr) _tmp3_);
#line 86 "../src/engine/api/geary-credentials.vala"
	_g_free0 (_tmp2_);
#line 86 "../src/engine/api/geary-credentials.vala"
	_tmp0_ = _tmp4_;
#line 86 "../src/engine/api/geary-credentials.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 86 "../src/engine/api/geary-credentials.vala"
		if (_inner_error0_->domain == GEARY_ENGINE_ERROR) {
#line 86 "../src/engine/api/geary-credentials.vala"
			g_propagate_error (error, _inner_error0_);
#line 86 "../src/engine/api/geary-credentials.vala"
			return 0;
#line 241 "geary-credentials.c"
		} else {
#line 86 "../src/engine/api/geary-credentials.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 86 "../src/engine/api/geary-credentials.vala"
			g_clear_error (&_inner_error0_);
#line 86 "../src/engine/api/geary-credentials.vala"
			return 0;
#line 249 "geary-credentials.c"
		}
	}
#line 86 "../src/engine/api/geary-credentials.vala"
	result = _tmp0_;
#line 86 "../src/engine/api/geary-credentials.vala"
	return result;
#line 256 "geary-credentials.c"
}

gchar*
geary_credentials_requirement_to_value (GearyCredentialsRequirement self)
{
	gchar* _tmp0_;
	gchar* result;
#line 92 "../src/engine/api/geary-credentials.vala"
	_tmp0_ = geary_object_utils_to_enum_nick (GEARY_CREDENTIALS_TYPE_REQUIREMENT, NULL, NULL, GEARY_CREDENTIALS_TYPE_REQUIREMENT, (gpointer) ((gintptr) self));
#line 92 "../src/engine/api/geary-credentials.vala"
	result = _tmp0_;
#line 92 "../src/engine/api/geary-credentials.vala"
	return result;
#line 270 "geary-credentials.c"
}

 G_GNUC_NO_INLINE static GType
geary_credentials_requirement_get_type_once (void)
{
	static const GEnumValue values[] = {{GEARY_CREDENTIALS_REQUIREMENT_NONE, "GEARY_CREDENTIALS_REQUIREMENT_NONE", "none"}, {GEARY_CREDENTIALS_REQUIREMENT_USE_INCOMING, "GEARY_CREDENTIALS_REQUIREMENT_USE_INCOMING", "use-incoming"}, {GEARY_CREDENTIALS_REQUIREMENT_CUSTOM, "GEARY_CREDENTIALS_REQUIREMENT_CUSTOM", "custom"}, {0, NULL, NULL}};
	GType geary_credentials_requirement_type_id;
	geary_credentials_requirement_type_id = g_enum_register_static ("GearyCredentialsRequirement", values);
	return geary_credentials_requirement_type_id;
}

GType
geary_credentials_requirement_get_type (void)
{
	static gsize geary_credentials_requirement_type_id__once = 0;
	if (g_once_init_enter (&geary_credentials_requirement_type_id__once)) {
		GType geary_credentials_requirement_type_id;
		geary_credentials_requirement_type_id = geary_credentials_requirement_get_type_once ();
		g_once_init_leave (&geary_credentials_requirement_type_id__once, geary_credentials_requirement_type_id);
	}
	return geary_credentials_requirement_type_id__once;
}

GearyCredentialsMethod
geary_credentials_get_supported_method (GearyCredentials* self)
{
	GearyCredentialsMethod result;
#line 100 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS (self), 0);
#line 100 "../src/engine/api/geary-credentials.vala"
	result = self->priv->_supported_method;
#line 100 "../src/engine/api/geary-credentials.vala"
	return result;
#line 304 "geary-credentials.c"
}

static void
geary_credentials_set_supported_method (GearyCredentials* self,
                                        GearyCredentialsMethod value)
{
	GearyCredentialsMethod old_value;
#line 100 "../src/engine/api/geary-credentials.vala"
	g_return_if_fail (GEARY_IS_CREDENTIALS (self));
#line 100 "../src/engine/api/geary-credentials.vala"
	old_value = geary_credentials_get_supported_method (self);
#line 100 "../src/engine/api/geary-credentials.vala"
	if (old_value != value) {
#line 100 "../src/engine/api/geary-credentials.vala"
		self->priv->_supported_method = value;
#line 100 "../src/engine/api/geary-credentials.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_credentials_properties[GEARY_CREDENTIALS_SUPPORTED_METHOD_PROPERTY]);
#line 322 "geary-credentials.c"
	}
}

const gchar*
geary_credentials_get_user (GearyCredentials* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 101 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS (self), NULL);
#line 101 "../src/engine/api/geary-credentials.vala"
	_tmp0_ = self->priv->_user;
#line 101 "../src/engine/api/geary-credentials.vala"
	result = _tmp0_;
#line 101 "../src/engine/api/geary-credentials.vala"
	return result;
#line 339 "geary-credentials.c"
}

static void
geary_credentials_set_user (GearyCredentials* self,
                            const gchar* value)
{
	gchar* old_value;
#line 101 "../src/engine/api/geary-credentials.vala"
	g_return_if_fail (GEARY_IS_CREDENTIALS (self));
#line 101 "../src/engine/api/geary-credentials.vala"
	old_value = geary_credentials_get_user (self);
#line 101 "../src/engine/api/geary-credentials.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 353 "geary-credentials.c"
		gchar* _tmp0_;
#line 101 "../src/engine/api/geary-credentials.vala"
		_tmp0_ = g_strdup (value);
#line 101 "../src/engine/api/geary-credentials.vala"
		_g_free0 (self->priv->_user);
#line 101 "../src/engine/api/geary-credentials.vala"
		self->priv->_user = _tmp0_;
#line 101 "../src/engine/api/geary-credentials.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_credentials_properties[GEARY_CREDENTIALS_USER_PROPERTY]);
#line 363 "geary-credentials.c"
	}
}

const gchar*
geary_credentials_get_token (GearyCredentials* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 102 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS (self), NULL);
#line 102 "../src/engine/api/geary-credentials.vala"
	_tmp0_ = self->priv->_token;
#line 102 "../src/engine/api/geary-credentials.vala"
	result = _tmp0_;
#line 102 "../src/engine/api/geary-credentials.vala"
	return result;
#line 380 "geary-credentials.c"
}

static void
geary_credentials_set_token (GearyCredentials* self,
                             const gchar* value)
{
	gchar* old_value;
#line 102 "../src/engine/api/geary-credentials.vala"
	g_return_if_fail (GEARY_IS_CREDENTIALS (self));
#line 102 "../src/engine/api/geary-credentials.vala"
	old_value = geary_credentials_get_token (self);
#line 102 "../src/engine/api/geary-credentials.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 394 "geary-credentials.c"
		gchar* _tmp0_;
#line 102 "../src/engine/api/geary-credentials.vala"
		_tmp0_ = g_strdup (value);
#line 102 "../src/engine/api/geary-credentials.vala"
		_g_free0 (self->priv->_token);
#line 102 "../src/engine/api/geary-credentials.vala"
		self->priv->_token = _tmp0_;
#line 102 "../src/engine/api/geary-credentials.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_credentials_properties[GEARY_CREDENTIALS_TOKEN_PROPERTY]);
#line 404 "geary-credentials.c"
	}
}

GearyCredentials*
geary_credentials_construct (GType object_type,
                             GearyCredentialsMethod supported_method,
                             const gchar* user,
                             const gchar* token)
{
	GearyCredentials * self = NULL;
#line 104 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (user != NULL, NULL);
#line 104 "../src/engine/api/geary-credentials.vala"
	self = (GearyCredentials*) geary_base_object_construct (object_type);
#line 105 "../src/engine/api/geary-credentials.vala"
	geary_credentials_set_supported_method (self, supported_method);
#line 106 "../src/engine/api/geary-credentials.vala"
	geary_credentials_set_user (self, user);
#line 107 "../src/engine/api/geary-credentials.vala"
	geary_credentials_set_token (self, token);
#line 104 "../src/engine/api/geary-credentials.vala"
	return self;
#line 427 "geary-credentials.c"
}

GearyCredentials*
geary_credentials_new (GearyCredentialsMethod supported_method,
                       const gchar* user,
                       const gchar* token)
{
#line 104 "../src/engine/api/geary-credentials.vala"
	return geary_credentials_construct (GEARY_TYPE_CREDENTIALS, supported_method, user, token);
#line 437 "geary-credentials.c"
}

/** Determines if a token has been provided. */
gboolean
geary_credentials_is_complete (GearyCredentials* self)
{
	const gchar* _tmp0_;
	gboolean result;
#line 111 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS (self), FALSE);
#line 112 "../src/engine/api/geary-credentials.vala"
	_tmp0_ = self->priv->_token;
#line 112 "../src/engine/api/geary-credentials.vala"
	result = _tmp0_ != NULL;
#line 112 "../src/engine/api/geary-credentials.vala"
	return result;
#line 454 "geary-credentials.c"
}

GearyCredentials*
geary_credentials_copy_with_user (GearyCredentials* self,
                                  const gchar* user)
{
	GearyCredentialsMethod _tmp0_;
	const gchar* _tmp1_;
	GearyCredentials* _tmp2_;
	GearyCredentials* result;
#line 115 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS (self), NULL);
#line 115 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (user != NULL, NULL);
#line 116 "../src/engine/api/geary-credentials.vala"
	_tmp0_ = self->priv->_supported_method;
#line 116 "../src/engine/api/geary-credentials.vala"
	_tmp1_ = self->priv->_token;
#line 116 "../src/engine/api/geary-credentials.vala"
	_tmp2_ = geary_credentials_new (_tmp0_, user, _tmp1_);
#line 116 "../src/engine/api/geary-credentials.vala"
	result = _tmp2_;
#line 116 "../src/engine/api/geary-credentials.vala"
	return result;
#line 479 "geary-credentials.c"
}

GearyCredentials*
geary_credentials_copy_with_token (GearyCredentials* self,
                                   const gchar* token)
{
	GearyCredentialsMethod _tmp0_;
	const gchar* _tmp1_;
	GearyCredentials* _tmp2_;
	GearyCredentials* result;
#line 119 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS (self), NULL);
#line 120 "../src/engine/api/geary-credentials.vala"
	_tmp0_ = self->priv->_supported_method;
#line 120 "../src/engine/api/geary-credentials.vala"
	_tmp1_ = self->priv->_user;
#line 120 "../src/engine/api/geary-credentials.vala"
	_tmp2_ = geary_credentials_new (_tmp0_, _tmp1_, token);
#line 120 "../src/engine/api/geary-credentials.vala"
	result = _tmp2_;
#line 120 "../src/engine/api/geary-credentials.vala"
	return result;
#line 502 "geary-credentials.c"
}

GearyCredentials*
geary_credentials_copy (GearyCredentials* self)
{
	GearyCredentialsMethod _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GearyCredentials* _tmp3_;
	GearyCredentials* result;
#line 123 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS (self), NULL);
#line 124 "../src/engine/api/geary-credentials.vala"
	_tmp0_ = self->priv->_supported_method;
#line 124 "../src/engine/api/geary-credentials.vala"
	_tmp1_ = self->priv->_user;
#line 124 "../src/engine/api/geary-credentials.vala"
	_tmp2_ = self->priv->_token;
#line 124 "../src/engine/api/geary-credentials.vala"
	_tmp3_ = geary_credentials_new (_tmp0_, _tmp1_, _tmp2_);
#line 124 "../src/engine/api/geary-credentials.vala"
	result = _tmp3_;
#line 124 "../src/engine/api/geary-credentials.vala"
	return result;
#line 527 "geary-credentials.c"
}

gchar*
geary_credentials_to_string (GearyCredentials* self)
{
	const gchar* _tmp0_;
	GearyCredentialsMethod _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result;
#line 127 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS (self), NULL);
#line 128 "../src/engine/api/geary-credentials.vala"
	_tmp0_ = self->priv->_user;
#line 128 "../src/engine/api/geary-credentials.vala"
	_tmp1_ = self->priv->_supported_method;
#line 128 "../src/engine/api/geary-credentials.vala"
	_tmp2_ = geary_credentials_method_to_string (_tmp1_);
#line 128 "../src/engine/api/geary-credentials.vala"
	_tmp3_ = _tmp2_;
#line 128 "../src/engine/api/geary-credentials.vala"
	_tmp4_ = g_strdup_printf ("%s:%s", _tmp0_, _tmp3_);
#line 128 "../src/engine/api/geary-credentials.vala"
	_tmp5_ = _tmp4_;
#line 128 "../src/engine/api/geary-credentials.vala"
	_g_free0 (_tmp3_);
#line 128 "../src/engine/api/geary-credentials.vala"
	result = _tmp5_;
#line 128 "../src/engine/api/geary-credentials.vala"
	return result;
#line 560 "geary-credentials.c"
}

static gboolean
geary_credentials_real_equal_to (GeeHashable* base,
                                 GearyCredentials* c)
{
	GearyCredentials * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GearyCredentialsMethod _tmp2_;
	GearyCredentialsMethod _tmp3_;
	gboolean result;
#line 131 "../src/engine/api/geary-credentials.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_CREDENTIALS, GearyCredentials);
#line 131 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS (c), FALSE);
#line 132 "../src/engine/api/geary-credentials.vala"
	if (self == c) {
#line 133 "../src/engine/api/geary-credentials.vala"
		result = TRUE;
#line 133 "../src/engine/api/geary-credentials.vala"
		return result;
#line 583 "geary-credentials.c"
	}
#line 136 "../src/engine/api/geary-credentials.vala"
	_tmp2_ = self->priv->_supported_method;
#line 136 "../src/engine/api/geary-credentials.vala"
	_tmp3_ = c->priv->_supported_method;
#line 136 "../src/engine/api/geary-credentials.vala"
	if (_tmp2_ == _tmp3_) {
#line 591 "geary-credentials.c"
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 137 "../src/engine/api/geary-credentials.vala"
		_tmp4_ = self->priv->_user;
#line 137 "../src/engine/api/geary-credentials.vala"
		_tmp5_ = c->priv->_user;
#line 137 "../src/engine/api/geary-credentials.vala"
		_tmp1_ = g_strcmp0 (_tmp4_, _tmp5_) == 0;
#line 600 "geary-credentials.c"
	} else {
#line 136 "../src/engine/api/geary-credentials.vala"
		_tmp1_ = FALSE;
#line 604 "geary-credentials.c"
	}
#line 135 "../src/engine/api/geary-credentials.vala"
	if (_tmp1_) {
#line 608 "geary-credentials.c"
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 138 "../src/engine/api/geary-credentials.vala"
		_tmp6_ = self->priv->_token;
#line 138 "../src/engine/api/geary-credentials.vala"
		_tmp7_ = c->priv->_token;
#line 138 "../src/engine/api/geary-credentials.vala"
		_tmp0_ = g_strcmp0 (_tmp6_, _tmp7_) == 0;
#line 617 "geary-credentials.c"
	} else {
#line 136 "../src/engine/api/geary-credentials.vala"
		_tmp0_ = FALSE;
#line 621 "geary-credentials.c"
	}
#line 135 "../src/engine/api/geary-credentials.vala"
	result = _tmp0_;
#line 135 "../src/engine/api/geary-credentials.vala"
	return result;
#line 627 "geary-credentials.c"
}

static guint
geary_credentials_real_hash (GeeHashable* base)
{
	GearyCredentials * self;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	GearyCredentialsMethod _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	guint _tmp6_;
	guint result;
#line 142 "../src/engine/api/geary-credentials.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_CREDENTIALS, GearyCredentials);
#line 144 "../src/engine/api/geary-credentials.vala"
	_tmp1_ = self->priv->_token;
#line 144 "../src/engine/api/geary-credentials.vala"
	_tmp0_ = _tmp1_;
#line 144 "../src/engine/api/geary-credentials.vala"
	if (_tmp0_ == NULL) {
#line 144 "../src/engine/api/geary-credentials.vala"
		_tmp0_ = "";
#line 652 "geary-credentials.c"
	}
#line 143 "../src/engine/api/geary-credentials.vala"
	_tmp2_ = self->priv->_supported_method;
#line 143 "../src/engine/api/geary-credentials.vala"
	_tmp3_ = self->priv->_user;
#line 143 "../src/engine/api/geary-credentials.vala"
	_tmp4_ = g_strdup_printf ("%d%s%s", (gint) _tmp2_, _tmp3_, _tmp0_);
#line 143 "../src/engine/api/geary-credentials.vala"
	_tmp5_ = _tmp4_;
#line 143 "../src/engine/api/geary-credentials.vala"
	_tmp6_ = g_str_hash (_tmp5_);
#line 143 "../src/engine/api/geary-credentials.vala"
	_g_free0 (_tmp5_);
#line 143 "../src/engine/api/geary-credentials.vala"
	result = _tmp6_;
#line 143 "../src/engine/api/geary-credentials.vala"
	return result;
#line 670 "geary-credentials.c"
}

static void
geary_credentials_class_init (GearyCredentialsClass * klass,
                              gpointer klass_data)
{
#line 28 "../src/engine/api/geary-credentials.vala"
	geary_credentials_parent_class = g_type_class_peek_parent (klass);
#line 28 "../src/engine/api/geary-credentials.vala"
	g_type_class_adjust_private_offset (klass, &GearyCredentials_private_offset);
#line 28 "../src/engine/api/geary-credentials.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_credentials_get_property;
#line 28 "../src/engine/api/geary-credentials.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_credentials_set_property;
#line 28 "../src/engine/api/geary-credentials.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_credentials_finalize;
#line 28 "../src/engine/api/geary-credentials.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_CREDENTIALS_SUPPORTED_METHOD_PROPERTY, geary_credentials_properties[GEARY_CREDENTIALS_SUPPORTED_METHOD_PROPERTY] = g_param_spec_enum ("supported-method", "supported-method", "supported-method", GEARY_CREDENTIALS_TYPE_METHOD, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../src/engine/api/geary-credentials.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_CREDENTIALS_USER_PROPERTY, geary_credentials_properties[GEARY_CREDENTIALS_USER_PROPERTY] = g_param_spec_string ("user", "user", "user", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../src/engine/api/geary-credentials.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_CREDENTIALS_TOKEN_PROPERTY, geary_credentials_properties[GEARY_CREDENTIALS_TOKEN_PROPERTY] = g_param_spec_string ("token", "token", "token", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 693 "geary-credentials.c"
}

static void
geary_credentials_gee_hashable_interface_init (GeeHashableIface * iface,
                                               gpointer iface_data)
{
#line 28 "../src/engine/api/geary-credentials.vala"
	geary_credentials_gee_hashable_parent_iface = g_type_interface_peek_parent (iface);
#line 28 "../src/engine/api/geary-credentials.vala"
	iface->equal_to = (gboolean (*) (GeeHashable*, gconstpointer)) geary_credentials_real_equal_to;
#line 28 "../src/engine/api/geary-credentials.vala"
	iface->hash = (guint (*) (GeeHashable*)) geary_credentials_real_hash;
#line 706 "geary-credentials.c"
}

static void
geary_credentials_instance_init (GearyCredentials * self,
                                 gpointer klass)
{
#line 28 "../src/engine/api/geary-credentials.vala"
	self->priv = geary_credentials_get_instance_private (self);
#line 715 "geary-credentials.c"
}

static void
geary_credentials_finalize (GObject * obj)
{
	GearyCredentials * self;
#line 28 "../src/engine/api/geary-credentials.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_TYPE_CREDENTIALS, GearyCredentials);
#line 101 "../src/engine/api/geary-credentials.vala"
	_g_free0 (self->priv->_user);
#line 102 "../src/engine/api/geary-credentials.vala"
	_g_free0 (self->priv->_token);
#line 28 "../src/engine/api/geary-credentials.vala"
	G_OBJECT_CLASS (geary_credentials_parent_class)->finalize (obj);
#line 730 "geary-credentials.c"
}

/**
 * Credentials provide a user's access details for authentication.
 *
 * The {@link user} property specifies the user's log in name, and the
 * {@link token} property is a shared secret between the user and a
 * service. For password-based schemes, this would be a password.

 * The token property may be null. This indicates the Credentials are
 * incomplete and need further information (i.e. prompt user for
 * username, fetch password from keyring, etc.). The token may be a
 * non-null zero-length string; this is considered valid and
 * is_complete() will return true in this case.
 *
 * Note that Geary will hold Credentials in memory for the long-term,
 * usually the duration of the application.  This is because network
 * resources often have to be connected (or reconnected) to in the
 * background and asking the user to reauthenticate each time is
 * deemed inconvenient.
 */
 G_GNUC_NO_INLINE static GType
geary_credentials_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyCredentialsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_credentials_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyCredentials), 0, (GInstanceInitFunc) geary_credentials_instance_init, NULL };
	static const GInterfaceInfo gee_hashable_info = { (GInterfaceInitFunc) geary_credentials_gee_hashable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType geary_credentials_type_id;
	geary_credentials_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyCredentials", &g_define_type_info, 0);
	g_type_add_interface_static (geary_credentials_type_id, GEE_TYPE_HASHABLE, &gee_hashable_info);
	GearyCredentials_private_offset = g_type_add_instance_private (geary_credentials_type_id, sizeof (GearyCredentialsPrivate));
	return geary_credentials_type_id;
}

GType
geary_credentials_get_type (void)
{
	static gsize geary_credentials_type_id__once = 0;
	if (g_once_init_enter (&geary_credentials_type_id__once)) {
		GType geary_credentials_type_id;
		geary_credentials_type_id = geary_credentials_get_type_once ();
		g_once_init_leave (&geary_credentials_type_id__once, geary_credentials_type_id);
	}
	return geary_credentials_type_id__once;
}

static void
_vala_geary_credentials_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	GearyCredentials * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_CREDENTIALS, GearyCredentials);
#line 28 "../src/engine/api/geary-credentials.vala"
	switch (property_id) {
#line 28 "../src/engine/api/geary-credentials.vala"
		case GEARY_CREDENTIALS_SUPPORTED_METHOD_PROPERTY:
#line 28 "../src/engine/api/geary-credentials.vala"
		g_value_set_enum (value, geary_credentials_get_supported_method (self));
#line 28 "../src/engine/api/geary-credentials.vala"
		break;
#line 28 "../src/engine/api/geary-credentials.vala"
		case GEARY_CREDENTIALS_USER_PROPERTY:
#line 28 "../src/engine/api/geary-credentials.vala"
		g_value_set_string (value, geary_credentials_get_user (self));
#line 28 "../src/engine/api/geary-credentials.vala"
		break;
#line 28 "../src/engine/api/geary-credentials.vala"
		case GEARY_CREDENTIALS_TOKEN_PROPERTY:
#line 28 "../src/engine/api/geary-credentials.vala"
		g_value_set_string (value, geary_credentials_get_token (self));
#line 28 "../src/engine/api/geary-credentials.vala"
		break;
#line 804 "geary-credentials.c"
		default:
#line 28 "../src/engine/api/geary-credentials.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../src/engine/api/geary-credentials.vala"
		break;
#line 810 "geary-credentials.c"
	}
}

static void
_vala_geary_credentials_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	GearyCredentials * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_CREDENTIALS, GearyCredentials);
#line 28 "../src/engine/api/geary-credentials.vala"
	switch (property_id) {
#line 28 "../src/engine/api/geary-credentials.vala"
		case GEARY_CREDENTIALS_SUPPORTED_METHOD_PROPERTY:
#line 28 "../src/engine/api/geary-credentials.vala"
		geary_credentials_set_supported_method (self, g_value_get_enum (value));
#line 28 "../src/engine/api/geary-credentials.vala"
		break;
#line 28 "../src/engine/api/geary-credentials.vala"
		case GEARY_CREDENTIALS_USER_PROPERTY:
#line 28 "../src/engine/api/geary-credentials.vala"
		geary_credentials_set_user (self, g_value_get_string (value));
#line 28 "../src/engine/api/geary-credentials.vala"
		break;
#line 28 "../src/engine/api/geary-credentials.vala"
		case GEARY_CREDENTIALS_TOKEN_PROPERTY:
#line 28 "../src/engine/api/geary-credentials.vala"
		geary_credentials_set_token (self, g_value_get_string (value));
#line 28 "../src/engine/api/geary-credentials.vala"
		break;
#line 842 "geary-credentials.c"
		default:
#line 28 "../src/engine/api/geary-credentials.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../src/engine/api/geary-credentials.vala"
		break;
#line 848 "geary-credentials.c"
	}
}

