/* geary-email.c generated by valac 0.56.17, the Vala compiler
 * generated from geary-email.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2018 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <gee.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_EMAIL_0_PROPERTY,
	GEARY_EMAIL_ID_PROPERTY,
	GEARY_EMAIL_FROM_PROPERTY,
	GEARY_EMAIL_SENDER_PROPERTY,
	GEARY_EMAIL_REPLY_TO_PROPERTY,
	GEARY_EMAIL_TO_PROPERTY,
	GEARY_EMAIL_CC_PROPERTY,
	GEARY_EMAIL_BCC_PROPERTY,
	GEARY_EMAIL_MESSAGE_ID_PROPERTY,
	GEARY_EMAIL_IN_REPLY_TO_PROPERTY,
	GEARY_EMAIL_REFERENCES_PROPERTY,
	GEARY_EMAIL_SUBJECT_PROPERTY,
	GEARY_EMAIL_DATE_PROPERTY,
	GEARY_EMAIL_HEADER_PROPERTY,
	GEARY_EMAIL_BODY_PROPERTY,
	GEARY_EMAIL_ATTACHMENTS_PROPERTY,
	GEARY_EMAIL_PREVIEW_PROPERTY,
	GEARY_EMAIL_PROPERTIES_PROPERTY,
	GEARY_EMAIL_EMAIL_FLAGS_PROPERTY,
	GEARY_EMAIL_FIELDS_PROPERTY,
	GEARY_EMAIL_NUM_PROPERTIES
};
static GParamSpec* geary_email_properties[GEARY_EMAIL_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _GearyEmailPrivate {
	GearyEmailIdentifier* _id;
	GearyRFC822MailboxAddresses* _from;
	GearyRFC822MailboxAddress* _sender;
	GearyRFC822MailboxAddresses* _reply_to;
	GearyRFC822MailboxAddresses* _to;
	GearyRFC822MailboxAddresses* _cc;
	GearyRFC822MailboxAddresses* _bcc;
	GearyRFC822MessageID* _message_id;
	GearyRFC822MessageIDList* _in_reply_to;
	GearyRFC822MessageIDList* _references;
	GearyRFC822Subject* _subject;
	GearyRFC822Date* _date;
	GearyRFC822Header* _header;
	GearyRFC822Text* _body;
	GeeList* _attachments;
	GearyRFC822PreviewText* _preview;
	GearyEmailProperties* _properties;
	GearyEmailFlags* _email_flags;
	GearyEmailField _fields;
	GearyRFC822Message* message;
};

static gint GearyEmail_private_offset;
static gpointer geary_email_parent_class = NULL;
static GearyEmailHeaderSetIface * geary_email_geary_email_header_set_parent_iface = NULL;

static void geary_email_set_id (GearyEmail* self,
                         GearyEmailIdentifier* value);
static void geary_email_set_body (GearyEmail* self,
                           GearyRFC822Text* value);
static void geary_email_set_attachments (GearyEmail* self,
                                  GeeList* value);
static void geary_email_set_preview (GearyEmail* self,
                              GearyRFC822PreviewText* value);
static void geary_email_set_properties (GearyEmail* self,
                                 GearyEmailProperties* value);
static void geary_email_set_email_flags (GearyEmail* self,
                                  GearyEmailFlags* value);
static void geary_email_set_fields (GearyEmail* self,
                             GearyEmailField value);
static gint geary_email_compare_id_ascending (GearyEmail* aemail,
                                       GearyEmail* bemail);
static void geary_email_finalize (GObject * obj);
static GType geary_email_get_type_once (void);
static void _vala_geary_email_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_geary_email_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
geary_email_get_instance_private (GearyEmail* self)
{
	return G_STRUCT_MEMBER_P (self, GearyEmail_private_offset);
}

/**
     * Specifies specific parts of an email message.
     *
     * See the {@link Email.fields} property to determine which parts
     * an email object currently contains.
     */
GearyEmailField*
geary_email_field_all (gint* result_length1)
{
	GearyEmailField* _tmp0_;
	GearyEmailField* _tmp1_;
	gint _tmp1__length1;
	GearyEmailField* result;
#line 114 "../src/engine/api/geary-email.vala"
	_tmp0_ = g_new0 (GearyEmailField, 10);
#line 114 "../src/engine/api/geary-email.vala"
	_tmp0_[0] = GEARY_EMAIL_FIELD_DATE;
#line 114 "../src/engine/api/geary-email.vala"
	_tmp0_[1] = GEARY_EMAIL_FIELD_ORIGINATORS;
#line 114 "../src/engine/api/geary-email.vala"
	_tmp0_[2] = GEARY_EMAIL_FIELD_RECEIVERS;
#line 114 "../src/engine/api/geary-email.vala"
	_tmp0_[3] = GEARY_EMAIL_FIELD_REFERENCES;
#line 114 "../src/engine/api/geary-email.vala"
	_tmp0_[4] = GEARY_EMAIL_FIELD_SUBJECT;
#line 114 "../src/engine/api/geary-email.vala"
	_tmp0_[5] = GEARY_EMAIL_FIELD_HEADER;
#line 114 "../src/engine/api/geary-email.vala"
	_tmp0_[6] = GEARY_EMAIL_FIELD_BODY;
#line 114 "../src/engine/api/geary-email.vala"
	_tmp0_[7] = GEARY_EMAIL_FIELD_PROPERTIES;
#line 114 "../src/engine/api/geary-email.vala"
	_tmp0_[8] = GEARY_EMAIL_FIELD_PREVIEW;
#line 114 "../src/engine/api/geary-email.vala"
	_tmp0_[9] = GEARY_EMAIL_FIELD_FLAGS;
#line 114 "../src/engine/api/geary-email.vala"
	_tmp1_ = _tmp0_;
#line 114 "../src/engine/api/geary-email.vala"
	_tmp1__length1 = 10;
#line 114 "../src/engine/api/geary-email.vala"
	if (result_length1) {
#line 114 "../src/engine/api/geary-email.vala"
		*result_length1 = _tmp1__length1;
#line 160 "geary-email.c"
	}
#line 114 "../src/engine/api/geary-email.vala"
	result = _tmp1_;
#line 114 "../src/engine/api/geary-email.vala"
	return result;
#line 166 "geary-email.c"
}

inline gboolean
geary_email_field_is_all_set (GearyEmailField self,
                              GearyEmailField required_fields)
{
	gboolean result;
#line 129 "../src/engine/api/geary-email.vala"
	result = (self & required_fields) == required_fields;
#line 129 "../src/engine/api/geary-email.vala"
	return result;
#line 178 "geary-email.c"
}

inline gboolean
geary_email_field_is_any_set (GearyEmailField self,
                              GearyEmailField required_fields)
{
	gboolean result;
#line 133 "../src/engine/api/geary-email.vala"
	result = (self & required_fields) != 0;
#line 133 "../src/engine/api/geary-email.vala"
	return result;
#line 190 "geary-email.c"
}

inline GearyEmailField
geary_email_field_set (GearyEmailField self,
                       GearyEmailField field)
{
	GearyEmailField result;
#line 137 "../src/engine/api/geary-email.vala"
	result = self | field;
#line 137 "../src/engine/api/geary-email.vala"
	return result;
#line 202 "geary-email.c"
}

inline GearyEmailField
geary_email_field_clear (GearyEmailField self,
                         GearyEmailField field)
{
	GearyEmailField result;
#line 141 "../src/engine/api/geary-email.vala"
	result = self & (~field);
#line 141 "../src/engine/api/geary-email.vala"
	return result;
#line 214 "geary-email.c"
}

inline gboolean
geary_email_field_fulfills (GearyEmailField self,
                            GearyEmailField required_fields)
{
	gboolean result;
#line 145 "../src/engine/api/geary-email.vala"
	result = geary_email_field_is_all_set (self, required_fields);
#line 145 "../src/engine/api/geary-email.vala"
	return result;
#line 226 "geary-email.c"
}

inline gboolean
geary_email_field_fulfills_any (GearyEmailField self,
                                GearyEmailField required_fields)
{
	gboolean result;
#line 149 "../src/engine/api/geary-email.vala"
	result = geary_email_field_is_any_set (self, required_fields);
#line 149 "../src/engine/api/geary-email.vala"
	return result;
#line 238 "geary-email.c"
}

inline gboolean
geary_email_field_require (GearyEmailField self,
                           GearyEmailField required_fields)
{
	gboolean result;
#line 153 "../src/engine/api/geary-email.vala"
	result = geary_email_field_is_all_set (self, required_fields);
#line 153 "../src/engine/api/geary-email.vala"
	return result;
#line 250 "geary-email.c"
}

inline gboolean
geary_email_field_requires_any (GearyEmailField self,
                                GearyEmailField required_fields)
{
	gboolean result;
#line 157 "../src/engine/api/geary-email.vala"
	result = geary_email_field_is_any_set (self, required_fields);
#line 157 "../src/engine/api/geary-email.vala"
	return result;
#line 262 "geary-email.c"
}

gchar*
geary_email_field_to_string (GearyEmailField self)
{
	gchar* value = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 161 "../src/engine/api/geary-email.vala"
	_tmp0_ = g_strdup ("NONE");
#line 161 "../src/engine/api/geary-email.vala"
	value = _tmp0_;
#line 162 "../src/engine/api/geary-email.vala"
	if (self == GEARY_EMAIL_FIELD_ALL) {
#line 277 "geary-email.c"
		gchar* _tmp1_;
#line 163 "../src/engine/api/geary-email.vala"
		_tmp1_ = g_strdup ("ALL");
#line 163 "../src/engine/api/geary-email.vala"
		_g_free0 (value);
#line 163 "../src/engine/api/geary-email.vala"
		value = _tmp1_;
#line 285 "geary-email.c"
	} else {
#line 164 "../src/engine/api/geary-email.vala"
		if (self > 0) {
#line 289 "geary-email.c"
			GString* builder = NULL;
			GString* _tmp2_;
			gint _tmp3_ = 0;
			GearyEmailField* _tmp4_;
			GString* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
#line 165 "../src/engine/api/geary-email.vala"
			_tmp2_ = g_string_new ("");
#line 165 "../src/engine/api/geary-email.vala"
			builder = _tmp2_;
#line 166 "../src/engine/api/geary-email.vala"
			_tmp4_ = geary_email_field_all (&_tmp3_);
#line 303 "geary-email.c"
			{
				GearyEmailField* f_collection = NULL;
				gint f_collection_length1 = 0;
				gint _f_collection_size_ = 0;
				gint f_it = 0;
#line 166 "../src/engine/api/geary-email.vala"
				f_collection = _tmp4_;
#line 166 "../src/engine/api/geary-email.vala"
				f_collection_length1 = _tmp3_;
#line 166 "../src/engine/api/geary-email.vala"
				for (f_it = 0; f_it < f_collection_length1; f_it = f_it + 1) {
#line 315 "geary-email.c"
					GearyEmailField f = 0;
#line 166 "../src/engine/api/geary-email.vala"
					f = f_collection[f_it];
#line 319 "geary-email.c"
					{
#line 167 "../src/engine/api/geary-email.vala"
						if (geary_email_field_is_all_set (self, f)) {
#line 323 "geary-email.c"
							GString* _tmp5_;
							const gchar* _tmp6_;
							GString* _tmp8_;
							gchar* _tmp9_;
							gchar* _tmp10_;
							gchar* _tmp11_;
							gchar* _tmp12_;
#line 168 "../src/engine/api/geary-email.vala"
							_tmp5_ = builder;
#line 168 "../src/engine/api/geary-email.vala"
							_tmp6_ = _tmp5_->str;
#line 168 "../src/engine/api/geary-email.vala"
							if (!geary_string_is_empty (_tmp6_)) {
#line 337 "geary-email.c"
								GString* _tmp7_;
#line 169 "../src/engine/api/geary-email.vala"
								_tmp7_ = builder;
#line 169 "../src/engine/api/geary-email.vala"
								g_string_append (_tmp7_, ",");
#line 343 "geary-email.c"
							}
#line 171 "../src/engine/api/geary-email.vala"
							_tmp8_ = builder;
#line 171 "../src/engine/api/geary-email.vala"
							_tmp9_ = geary_object_utils_to_enum_nick (GEARY_EMAIL_TYPE_FIELD, NULL, NULL, GEARY_EMAIL_TYPE_FIELD, (gpointer) ((gintptr) f));
#line 171 "../src/engine/api/geary-email.vala"
							_tmp10_ = _tmp9_;
#line 171 "../src/engine/api/geary-email.vala"
							_tmp11_ = g_utf8_strup (_tmp10_, (gssize) -1);
#line 171 "../src/engine/api/geary-email.vala"
							_tmp12_ = _tmp11_;
#line 171 "../src/engine/api/geary-email.vala"
							g_string_append (_tmp8_, _tmp12_);
#line 171 "../src/engine/api/geary-email.vala"
							_g_free0 (_tmp12_);
#line 171 "../src/engine/api/geary-email.vala"
							_g_free0 (_tmp10_);
#line 361 "geary-email.c"
						}
					}
				}
#line 166 "../src/engine/api/geary-email.vala"
				f_collection = (g_free (f_collection), NULL);
#line 367 "geary-email.c"
			}
#line 176 "../src/engine/api/geary-email.vala"
			_tmp13_ = builder;
#line 176 "../src/engine/api/geary-email.vala"
			_tmp14_ = _tmp13_->str;
#line 176 "../src/engine/api/geary-email.vala"
			_tmp15_ = g_strdup (_tmp14_);
#line 176 "../src/engine/api/geary-email.vala"
			_g_free0 (value);
#line 176 "../src/engine/api/geary-email.vala"
			value = _tmp15_;
#line 164 "../src/engine/api/geary-email.vala"
			_g_string_free0 (builder);
#line 381 "geary-email.c"
		}
	}
#line 178 "../src/engine/api/geary-email.vala"
	result = value;
#line 178 "../src/engine/api/geary-email.vala"
	return result;
#line 388 "geary-email.c"
}

 G_GNUC_NO_INLINE static GType
geary_email_field_get_type_once (void)
{
	static const GEnumValue values[] = {{GEARY_EMAIL_FIELD_NONE, "GEARY_EMAIL_FIELD_NONE", "none"}, {GEARY_EMAIL_FIELD_DATE, "GEARY_EMAIL_FIELD_DATE", "date"}, {GEARY_EMAIL_FIELD_ORIGINATORS, "GEARY_EMAIL_FIELD_ORIGINATORS", "originators"}, {GEARY_EMAIL_FIELD_RECEIVERS, "GEARY_EMAIL_FIELD_RECEIVERS", "receivers"}, {GEARY_EMAIL_FIELD_REFERENCES, "GEARY_EMAIL_FIELD_REFERENCES", "references"}, {GEARY_EMAIL_FIELD_SUBJECT, "GEARY_EMAIL_FIELD_SUBJECT", "subject"}, {GEARY_EMAIL_FIELD_HEADER, "GEARY_EMAIL_FIELD_HEADER", "header"}, {GEARY_EMAIL_FIELD_BODY, "GEARY_EMAIL_FIELD_BODY", "body"}, {GEARY_EMAIL_FIELD_PROPERTIES, "GEARY_EMAIL_FIELD_PROPERTIES", "properties"}, {GEARY_EMAIL_FIELD_PREVIEW, "GEARY_EMAIL_FIELD_PREVIEW", "preview"}, {GEARY_EMAIL_FIELD_FLAGS, "GEARY_EMAIL_FIELD_FLAGS", "flags"}, {GEARY_EMAIL_FIELD_ENVELOPE, "GEARY_EMAIL_FIELD_ENVELOPE", "envelope"}, {GEARY_EMAIL_FIELD_ALL, "GEARY_EMAIL_FIELD_ALL", "all"}, {0, NULL, NULL}};
	GType geary_email_field_type_id;
	geary_email_field_type_id = g_enum_register_static ("GearyEmailField", values);
	return geary_email_field_type_id;
}

GType
geary_email_field_get_type (void)
{
	static gsize geary_email_field_type_id__once = 0;
	if (g_once_init_enter (&geary_email_field_type_id__once)) {
		GType geary_email_field_type_id;
		geary_email_field_type_id = geary_email_field_get_type_once ();
		g_once_init_leave (&geary_email_field_type_id__once, geary_email_field_type_id);
	}
	return geary_email_field_type_id__once;
}

GearyEmailIdentifier*
geary_email_get_id (GearyEmail* self)
{
	GearyEmailIdentifier* result;
	GearyEmailIdentifier* _tmp0_;
#line 191 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (self), NULL);
#line 191 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_id;
#line 191 "../src/engine/api/geary-email.vala"
	result = _tmp0_;
#line 191 "../src/engine/api/geary-email.vala"
	return result;
#line 425 "geary-email.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 191 "../src/engine/api/geary-email.vala"
	return self ? g_object_ref (self) : NULL;
#line 433 "geary-email.c"
}

static void
geary_email_set_id (GearyEmail* self,
                    GearyEmailIdentifier* value)
{
	GearyEmailIdentifier* old_value;
#line 191 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_IS_EMAIL (self));
#line 191 "../src/engine/api/geary-email.vala"
	old_value = geary_email_get_id (self);
#line 191 "../src/engine/api/geary-email.vala"
	if (old_value != value) {
#line 447 "geary-email.c"
		GearyEmailIdentifier* _tmp0_;
#line 191 "../src/engine/api/geary-email.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 191 "../src/engine/api/geary-email.vala"
		_g_object_unref0 (self->priv->_id);
#line 191 "../src/engine/api/geary-email.vala"
		self->priv->_id = _tmp0_;
#line 191 "../src/engine/api/geary-email.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_email_properties[GEARY_EMAIL_ID_PROPERTY]);
#line 457 "geary-email.c"
	}
}

static GearyRFC822MailboxAddresses*
geary_email_real_get_from (GearyEmailHeaderSet* base)
{
	GearyRFC822MailboxAddresses* result;
	GearyEmail* self;
	GearyRFC822MailboxAddresses* _tmp0_;
#line 198 "../src/engine/api/geary-email.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_EMAIL, GearyEmail);
#line 198 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_from;
#line 198 "../src/engine/api/geary-email.vala"
	result = _tmp0_;
#line 198 "../src/engine/api/geary-email.vala"
	return result;
#line 475 "geary-email.c"
}

static GearyRFC822MailboxAddress*
geary_email_real_get_sender (GearyEmailHeaderSet* base)
{
	GearyRFC822MailboxAddress* result;
	GearyEmail* self;
	GearyRFC822MailboxAddress* _tmp0_;
#line 206 "../src/engine/api/geary-email.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_EMAIL, GearyEmail);
#line 206 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_sender;
#line 206 "../src/engine/api/geary-email.vala"
	result = _tmp0_;
#line 206 "../src/engine/api/geary-email.vala"
	return result;
#line 492 "geary-email.c"
}

static GearyRFC822MailboxAddresses*
geary_email_real_get_reply_to (GearyEmailHeaderSet* base)
{
	GearyRFC822MailboxAddresses* result;
	GearyEmail* self;
	GearyRFC822MailboxAddresses* _tmp0_;
#line 214 "../src/engine/api/geary-email.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_EMAIL, GearyEmail);
#line 214 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_reply_to;
#line 214 "../src/engine/api/geary-email.vala"
	result = _tmp0_;
#line 214 "../src/engine/api/geary-email.vala"
	return result;
#line 509 "geary-email.c"
}

static GearyRFC822MailboxAddresses*
geary_email_real_get_to (GearyEmailHeaderSet* base)
{
	GearyRFC822MailboxAddresses* result;
	GearyEmail* self;
	GearyRFC822MailboxAddresses* _tmp0_;
#line 222 "../src/engine/api/geary-email.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_EMAIL, GearyEmail);
#line 222 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_to;
#line 222 "../src/engine/api/geary-email.vala"
	result = _tmp0_;
#line 222 "../src/engine/api/geary-email.vala"
	return result;
#line 526 "geary-email.c"
}

static GearyRFC822MailboxAddresses*
geary_email_real_get_cc (GearyEmailHeaderSet* base)
{
	GearyRFC822MailboxAddresses* result;
	GearyEmail* self;
	GearyRFC822MailboxAddresses* _tmp0_;
#line 230 "../src/engine/api/geary-email.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_EMAIL, GearyEmail);
#line 230 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_cc;
#line 230 "../src/engine/api/geary-email.vala"
	result = _tmp0_;
#line 230 "../src/engine/api/geary-email.vala"
	return result;
#line 543 "geary-email.c"
}

static GearyRFC822MailboxAddresses*
geary_email_real_get_bcc (GearyEmailHeaderSet* base)
{
	GearyRFC822MailboxAddresses* result;
	GearyEmail* self;
	GearyRFC822MailboxAddresses* _tmp0_;
#line 238 "../src/engine/api/geary-email.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_EMAIL, GearyEmail);
#line 238 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_bcc;
#line 238 "../src/engine/api/geary-email.vala"
	result = _tmp0_;
#line 238 "../src/engine/api/geary-email.vala"
	return result;
#line 560 "geary-email.c"
}

static GearyRFC822MessageID*
geary_email_real_get_message_id (GearyEmailHeaderSet* base)
{
	GearyRFC822MessageID* result;
	GearyEmail* self;
	GearyRFC822MessageID* _tmp0_;
#line 246 "../src/engine/api/geary-email.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_EMAIL, GearyEmail);
#line 246 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_message_id;
#line 246 "../src/engine/api/geary-email.vala"
	result = _tmp0_;
#line 246 "../src/engine/api/geary-email.vala"
	return result;
#line 577 "geary-email.c"
}

static GearyRFC822MessageIDList*
geary_email_real_get_in_reply_to (GearyEmailHeaderSet* base)
{
	GearyRFC822MessageIDList* result;
	GearyEmail* self;
	GearyRFC822MessageIDList* _tmp0_;
#line 254 "../src/engine/api/geary-email.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_EMAIL, GearyEmail);
#line 254 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_in_reply_to;
#line 254 "../src/engine/api/geary-email.vala"
	result = _tmp0_;
#line 254 "../src/engine/api/geary-email.vala"
	return result;
#line 594 "geary-email.c"
}

static GearyRFC822MessageIDList*
geary_email_real_get_references (GearyEmailHeaderSet* base)
{
	GearyRFC822MessageIDList* result;
	GearyEmail* self;
	GearyRFC822MessageIDList* _tmp0_;
#line 262 "../src/engine/api/geary-email.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_EMAIL, GearyEmail);
#line 262 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_references;
#line 262 "../src/engine/api/geary-email.vala"
	result = _tmp0_;
#line 262 "../src/engine/api/geary-email.vala"
	return result;
#line 611 "geary-email.c"
}

static GearyRFC822Subject*
geary_email_real_get_subject (GearyEmailHeaderSet* base)
{
	GearyRFC822Subject* result;
	GearyEmail* self;
	GearyRFC822Subject* _tmp0_;
#line 270 "../src/engine/api/geary-email.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_EMAIL, GearyEmail);
#line 270 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_subject;
#line 270 "../src/engine/api/geary-email.vala"
	result = _tmp0_;
#line 270 "../src/engine/api/geary-email.vala"
	return result;
#line 628 "geary-email.c"
}

static GearyRFC822Date*
geary_email_real_get_date (GearyEmailHeaderSet* base)
{
	GearyRFC822Date* result;
	GearyEmail* self;
	GearyRFC822Date* _tmp0_;
#line 278 "../src/engine/api/geary-email.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_EMAIL, GearyEmail);
#line 278 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_date;
#line 278 "../src/engine/api/geary-email.vala"
	result = _tmp0_;
#line 278 "../src/engine/api/geary-email.vala"
	return result;
#line 645 "geary-email.c"
}

GearyRFC822Header*
geary_email_get_header (GearyEmail* self)
{
	GearyRFC822Header* result;
	GearyRFC822Header* _tmp0_;
#line 286 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (self), NULL);
#line 286 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_header;
#line 286 "../src/engine/api/geary-email.vala"
	result = _tmp0_;
#line 286 "../src/engine/api/geary-email.vala"
	return result;
#line 661 "geary-email.c"
}

void
geary_email_set_header (GearyEmail* self,
                        GearyRFC822Header* value)
{
	GearyRFC822Header* old_value;
#line 286 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_IS_EMAIL (self));
#line 286 "../src/engine/api/geary-email.vala"
	old_value = geary_email_get_header (self);
#line 286 "../src/engine/api/geary-email.vala"
	if (old_value != value) {
#line 675 "geary-email.c"
		GearyRFC822Header* _tmp0_;
#line 286 "../src/engine/api/geary-email.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 286 "../src/engine/api/geary-email.vala"
		_g_object_unref0 (self->priv->_header);
#line 286 "../src/engine/api/geary-email.vala"
		self->priv->_header = _tmp0_;
#line 286 "../src/engine/api/geary-email.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_email_properties[GEARY_EMAIL_HEADER_PROPERTY]);
#line 685 "geary-email.c"
	}
}

GearyRFC822Text*
geary_email_get_body (GearyEmail* self)
{
	GearyRFC822Text* result;
	GearyRFC822Text* _tmp0_;
#line 293 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (self), NULL);
#line 293 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_body;
#line 293 "../src/engine/api/geary-email.vala"
	result = _tmp0_;
#line 293 "../src/engine/api/geary-email.vala"
	return result;
#line 702 "geary-email.c"
}

static void
geary_email_set_body (GearyEmail* self,
                      GearyRFC822Text* value)
{
	GearyRFC822Text* old_value;
#line 293 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_IS_EMAIL (self));
#line 293 "../src/engine/api/geary-email.vala"
	old_value = geary_email_get_body (self);
#line 293 "../src/engine/api/geary-email.vala"
	if (old_value != value) {
#line 716 "geary-email.c"
		GearyRFC822Text* _tmp0_;
#line 293 "../src/engine/api/geary-email.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 293 "../src/engine/api/geary-email.vala"
		_g_object_unref0 (self->priv->_body);
#line 293 "../src/engine/api/geary-email.vala"
		self->priv->_body = _tmp0_;
#line 293 "../src/engine/api/geary-email.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_email_properties[GEARY_EMAIL_BODY_PROPERTY]);
#line 726 "geary-email.c"
	}
}

GeeList*
geary_email_get_attachments (GearyEmail* self)
{
	GeeList* result;
	GeeList* _tmp0_;
#line 300 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (self), NULL);
#line 300 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_attachments;
#line 300 "../src/engine/api/geary-email.vala"
	result = _tmp0_;
#line 300 "../src/engine/api/geary-email.vala"
	return result;
#line 743 "geary-email.c"
}

static void
geary_email_set_attachments (GearyEmail* self,
                             GeeList* value)
{
	GeeList* old_value;
#line 300 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_IS_EMAIL (self));
#line 300 "../src/engine/api/geary-email.vala"
	old_value = geary_email_get_attachments (self);
#line 300 "../src/engine/api/geary-email.vala"
	if (old_value != value) {
#line 757 "geary-email.c"
		GeeList* _tmp0_;
#line 300 "../src/engine/api/geary-email.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 300 "../src/engine/api/geary-email.vala"
		_g_object_unref0 (self->priv->_attachments);
#line 300 "../src/engine/api/geary-email.vala"
		self->priv->_attachments = _tmp0_;
#line 300 "../src/engine/api/geary-email.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_email_properties[GEARY_EMAIL_ATTACHMENTS_PROPERTY]);
#line 767 "geary-email.c"
	}
}

GearyRFC822PreviewText*
geary_email_get_preview (GearyEmail* self)
{
	GearyRFC822PreviewText* result;
	GearyRFC822PreviewText* _tmp0_;
#line 308 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (self), NULL);
#line 308 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_preview;
#line 308 "../src/engine/api/geary-email.vala"
	result = _tmp0_;
#line 308 "../src/engine/api/geary-email.vala"
	return result;
#line 784 "geary-email.c"
}

static void
geary_email_set_preview (GearyEmail* self,
                         GearyRFC822PreviewText* value)
{
	GearyRFC822PreviewText* old_value;
#line 308 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_IS_EMAIL (self));
#line 308 "../src/engine/api/geary-email.vala"
	old_value = geary_email_get_preview (self);
#line 308 "../src/engine/api/geary-email.vala"
	if (old_value != value) {
#line 798 "geary-email.c"
		GearyRFC822PreviewText* _tmp0_;
#line 308 "../src/engine/api/geary-email.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 308 "../src/engine/api/geary-email.vala"
		_g_object_unref0 (self->priv->_preview);
#line 308 "../src/engine/api/geary-email.vala"
		self->priv->_preview = _tmp0_;
#line 308 "../src/engine/api/geary-email.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_email_properties[GEARY_EMAIL_PREVIEW_PROPERTY]);
#line 808 "geary-email.c"
	}
}

GearyEmailProperties*
geary_email_get_properties (GearyEmail* self)
{
	GearyEmailProperties* result;
	GearyEmailProperties* _tmp0_;
#line 315 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (self), NULL);
#line 315 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_properties;
#line 315 "../src/engine/api/geary-email.vala"
	result = _tmp0_;
#line 315 "../src/engine/api/geary-email.vala"
	return result;
#line 825 "geary-email.c"
}

static void
geary_email_set_properties (GearyEmail* self,
                            GearyEmailProperties* value)
{
	GearyEmailProperties* old_value;
#line 315 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_IS_EMAIL (self));
#line 315 "../src/engine/api/geary-email.vala"
	old_value = geary_email_get_properties (self);
#line 315 "../src/engine/api/geary-email.vala"
	if (old_value != value) {
#line 839 "geary-email.c"
		GearyEmailProperties* _tmp0_;
#line 315 "../src/engine/api/geary-email.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 315 "../src/engine/api/geary-email.vala"
		_g_object_unref0 (self->priv->_properties);
#line 315 "../src/engine/api/geary-email.vala"
		self->priv->_properties = _tmp0_;
#line 315 "../src/engine/api/geary-email.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_email_properties[GEARY_EMAIL_PROPERTIES_PROPERTY]);
#line 849 "geary-email.c"
	}
}

GearyEmailFlags*
geary_email_get_email_flags (GearyEmail* self)
{
	GearyEmailFlags* result;
	GearyEmailFlags* _tmp0_;
#line 322 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (self), NULL);
#line 322 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_email_flags;
#line 322 "../src/engine/api/geary-email.vala"
	result = _tmp0_;
#line 322 "../src/engine/api/geary-email.vala"
	return result;
#line 866 "geary-email.c"
}

static void
geary_email_set_email_flags (GearyEmail* self,
                             GearyEmailFlags* value)
{
	GearyEmailFlags* old_value;
#line 322 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_IS_EMAIL (self));
#line 322 "../src/engine/api/geary-email.vala"
	old_value = geary_email_get_email_flags (self);
#line 322 "../src/engine/api/geary-email.vala"
	if (old_value != value) {
#line 880 "geary-email.c"
		GearyEmailFlags* _tmp0_;
#line 322 "../src/engine/api/geary-email.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 322 "../src/engine/api/geary-email.vala"
		_g_object_unref0 (self->priv->_email_flags);
#line 322 "../src/engine/api/geary-email.vala"
		self->priv->_email_flags = _tmp0_;
#line 322 "../src/engine/api/geary-email.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_email_properties[GEARY_EMAIL_EMAIL_FLAGS_PROPERTY]);
#line 890 "geary-email.c"
	}
}

GearyEmailField
geary_email_get_fields (GearyEmail* self)
{
	GearyEmailField result;
#line 338 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (self), 0);
#line 338 "../src/engine/api/geary-email.vala"
	result = self->priv->_fields;
#line 338 "../src/engine/api/geary-email.vala"
	return result;
#line 904 "geary-email.c"
}

static void
geary_email_set_fields (GearyEmail* self,
                        GearyEmailField value)
{
	GearyEmailField old_value;
#line 338 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_IS_EMAIL (self));
#line 338 "../src/engine/api/geary-email.vala"
	old_value = geary_email_get_fields (self);
#line 338 "../src/engine/api/geary-email.vala"
	if (old_value != value) {
#line 338 "../src/engine/api/geary-email.vala"
		self->priv->_fields = value;
#line 338 "../src/engine/api/geary-email.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_email_properties[GEARY_EMAIL_FIELDS_PROPERTY]);
#line 922 "geary-email.c"
	}
}

/** Constructs a new, empty email with the given id. */
GearyEmail*
geary_email_construct (GType object_type,
                       GearyEmailIdentifier* id)
{
	GearyEmail * self = NULL;
#line 345 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL_IDENTIFIER (id), NULL);
#line 345 "../src/engine/api/geary-email.vala"
	self = (GearyEmail*) geary_base_object_construct (object_type);
#line 346 "../src/engine/api/geary-email.vala"
	geary_email_set_id (self, id);
#line 345 "../src/engine/api/geary-email.vala"
	return self;
#line 940 "geary-email.c"
}

GearyEmail*
geary_email_new (GearyEmailIdentifier* id)
{
#line 345 "../src/engine/api/geary-email.vala"
	return geary_email_construct (GEARY_TYPE_EMAIL, id);
#line 948 "geary-email.c"
}

/**
     * Construct a Geary.Email from a complete RFC822 message.
     */
GearyEmail*
geary_email_construct_from_message (GType object_type,
                                    GearyEmailIdentifier* id,
                                    GearyRFC822Message* message,
                                    GError** error)
{
	GearyEmail * self = NULL;
	GearyRFC822Date* _tmp0_;
	GearyRFC822Date* _tmp1_;
	GearyRFC822MailboxAddresses* _tmp2_;
	GearyRFC822MailboxAddresses* _tmp3_;
	GearyRFC822MailboxAddress* _tmp4_;
	GearyRFC822MailboxAddress* _tmp5_;
	GearyRFC822MailboxAddresses* _tmp6_;
	GearyRFC822MailboxAddresses* _tmp7_;
	GearyRFC822MailboxAddresses* _tmp8_;
	GearyRFC822MailboxAddresses* _tmp9_;
	GearyRFC822MailboxAddresses* _tmp10_;
	GearyRFC822MailboxAddresses* _tmp11_;
	GearyRFC822MailboxAddresses* _tmp12_;
	GearyRFC822MailboxAddresses* _tmp13_;
	GearyRFC822MessageID* _tmp14_;
	GearyRFC822MessageID* _tmp15_;
	GearyRFC822MessageIDList* _tmp16_;
	GearyRFC822MessageIDList* _tmp17_;
	GearyRFC822MessageIDList* _tmp18_;
	GearyRFC822MessageIDList* _tmp19_;
	GearyRFC822Subject* _tmp20_;
	GearyRFC822Subject* _tmp21_;
	GearyRFC822Header* _tmp22_;
	GearyRFC822Header* _tmp23_;
	GearyRFC822Text* _tmp24_;
	GearyRFC822Text* _tmp25_;
	gchar* preview = NULL;
	gchar* _tmp26_;
	const gchar* _tmp27_;
	GearyRFC822Message* _tmp31_;
	GError* _inner_error0_ = NULL;
#line 352 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL_IDENTIFIER (id), NULL);
#line 352 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (message), NULL);
#line 354 "../src/engine/api/geary-email.vala"
	self = (GearyEmail*) geary_email_construct (object_type, id);
#line 355 "../src/engine/api/geary-email.vala"
	_tmp0_ = geary_email_header_set_get_date (G_TYPE_CHECK_INSTANCE_CAST (message, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 355 "../src/engine/api/geary-email.vala"
	_tmp1_ = _tmp0_;
#line 355 "../src/engine/api/geary-email.vala"
	geary_email_set_send_date (self, _tmp1_);
#line 356 "../src/engine/api/geary-email.vala"
	_tmp2_ = geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (message, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 356 "../src/engine/api/geary-email.vala"
	_tmp3_ = _tmp2_;
#line 356 "../src/engine/api/geary-email.vala"
	_tmp4_ = geary_email_header_set_get_sender (G_TYPE_CHECK_INSTANCE_CAST (message, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 356 "../src/engine/api/geary-email.vala"
	_tmp5_ = _tmp4_;
#line 356 "../src/engine/api/geary-email.vala"
	_tmp6_ = geary_email_header_set_get_reply_to (G_TYPE_CHECK_INSTANCE_CAST (message, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 356 "../src/engine/api/geary-email.vala"
	_tmp7_ = _tmp6_;
#line 356 "../src/engine/api/geary-email.vala"
	geary_email_set_originators (self, _tmp3_, _tmp5_, _tmp7_, &_inner_error0_);
#line 356 "../src/engine/api/geary-email.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 356 "../src/engine/api/geary-email.vala"
		g_propagate_error (error, _inner_error0_);
#line 356 "../src/engine/api/geary-email.vala"
		_g_object_unref0 (self);
#line 356 "../src/engine/api/geary-email.vala"
		return NULL;
#line 1026 "geary-email.c"
	}
#line 357 "../src/engine/api/geary-email.vala"
	_tmp8_ = geary_email_header_set_get_to (G_TYPE_CHECK_INSTANCE_CAST (message, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 357 "../src/engine/api/geary-email.vala"
	_tmp9_ = _tmp8_;
#line 357 "../src/engine/api/geary-email.vala"
	_tmp10_ = geary_email_header_set_get_cc (G_TYPE_CHECK_INSTANCE_CAST (message, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 357 "../src/engine/api/geary-email.vala"
	_tmp11_ = _tmp10_;
#line 357 "../src/engine/api/geary-email.vala"
	_tmp12_ = geary_email_header_set_get_bcc (G_TYPE_CHECK_INSTANCE_CAST (message, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 357 "../src/engine/api/geary-email.vala"
	_tmp13_ = _tmp12_;
#line 357 "../src/engine/api/geary-email.vala"
	geary_email_set_receivers (self, _tmp9_, _tmp11_, _tmp13_);
#line 358 "../src/engine/api/geary-email.vala"
	_tmp14_ = geary_email_header_set_get_message_id (G_TYPE_CHECK_INSTANCE_CAST (message, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 358 "../src/engine/api/geary-email.vala"
	_tmp15_ = _tmp14_;
#line 358 "../src/engine/api/geary-email.vala"
	_tmp16_ = geary_email_header_set_get_in_reply_to (G_TYPE_CHECK_INSTANCE_CAST (message, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 358 "../src/engine/api/geary-email.vala"
	_tmp17_ = _tmp16_;
#line 358 "../src/engine/api/geary-email.vala"
	_tmp18_ = geary_email_header_set_get_references (G_TYPE_CHECK_INSTANCE_CAST (message, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 358 "../src/engine/api/geary-email.vala"
	_tmp19_ = _tmp18_;
#line 358 "../src/engine/api/geary-email.vala"
	geary_email_set_full_references (self, _tmp15_, _tmp17_, _tmp19_);
#line 361 "../src/engine/api/geary-email.vala"
	_tmp20_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (message, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 361 "../src/engine/api/geary-email.vala"
	_tmp21_ = _tmp20_;
#line 361 "../src/engine/api/geary-email.vala"
	geary_email_set_message_subject (self, _tmp21_);
#line 362 "../src/engine/api/geary-email.vala"
	_tmp22_ = geary_rf_c822_message_get_header (message);
#line 362 "../src/engine/api/geary-email.vala"
	_tmp23_ = _tmp22_;
#line 362 "../src/engine/api/geary-email.vala"
	geary_email_set_message_header (self, _tmp23_);
#line 362 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (_tmp23_);
#line 363 "../src/engine/api/geary-email.vala"
	_tmp24_ = geary_rf_c822_message_get_body (message);
#line 363 "../src/engine/api/geary-email.vala"
	_tmp25_ = _tmp24_;
#line 363 "../src/engine/api/geary-email.vala"
	geary_email_set_message_body (self, _tmp25_);
#line 363 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (_tmp25_);
#line 364 "../src/engine/api/geary-email.vala"
	_tmp26_ = geary_rf_c822_message_get_preview (message);
#line 364 "../src/engine/api/geary-email.vala"
	preview = _tmp26_;
#line 365 "../src/engine/api/geary-email.vala"
	_tmp27_ = preview;
#line 365 "../src/engine/api/geary-email.vala"
	if (!geary_string_is_empty_or_whitespace (_tmp27_)) {
#line 1086 "geary-email.c"
		const gchar* _tmp28_;
		GearyRFC822PreviewText* _tmp29_;
		GearyRFC822PreviewText* _tmp30_;
#line 366 "../src/engine/api/geary-email.vala"
		_tmp28_ = preview;
#line 366 "../src/engine/api/geary-email.vala"
		_tmp29_ = geary_rf_c822_preview_text_new_from_string (_tmp28_);
#line 366 "../src/engine/api/geary-email.vala"
		_tmp30_ = _tmp29_;
#line 366 "../src/engine/api/geary-email.vala"
		geary_email_set_message_preview (self, _tmp30_);
#line 366 "../src/engine/api/geary-email.vala"
		_g_object_unref0 (_tmp30_);
#line 1100 "geary-email.c"
	}
#line 370 "../src/engine/api/geary-email.vala"
	_tmp31_ = _g_object_ref0 (message);
#line 370 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->message);
#line 370 "../src/engine/api/geary-email.vala"
	self->priv->message = _tmp31_;
#line 352 "../src/engine/api/geary-email.vala"
	_g_free0 (preview);
#line 352 "../src/engine/api/geary-email.vala"
	return self;
#line 1112 "geary-email.c"
}

GearyEmail*
geary_email_new_from_message (GearyEmailIdentifier* id,
                              GearyRFC822Message* message,
                              GError** error)
{
#line 352 "../src/engine/api/geary-email.vala"
	return geary_email_construct_from_message (GEARY_TYPE_EMAIL, id, message, error);
#line 1122 "geary-email.c"
}

/**
     * Determines if this message is unread from its flags.
     *
     * If {@link email_flags} is not null, returns the value of {@link
     * EmailFlags.is_unread}, otherwise returns {@link
     * Trillian.UNKNOWN}.
     */
inline GearyTrillian
geary_email_is_unread (GearyEmail* self)
{
	GearyTrillian _tmp0_ = 0;
	GearyEmailFlags* _tmp1_;
	GearyTrillian result;
#line 380 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (self), 0);
#line 381 "../src/engine/api/geary-email.vala"
	_tmp1_ = self->priv->_email_flags;
#line 381 "../src/engine/api/geary-email.vala"
	if (_tmp1_ != NULL) {
#line 1144 "geary-email.c"
		GearyEmailFlags* _tmp2_;
#line 381 "../src/engine/api/geary-email.vala"
		_tmp2_ = self->priv->_email_flags;
#line 381 "../src/engine/api/geary-email.vala"
		_tmp0_ = geary_trillian_from_boolean (geary_email_flags_is_unread (_tmp2_));
#line 1150 "geary-email.c"
	} else {
#line 381 "../src/engine/api/geary-email.vala"
		_tmp0_ = GEARY_TRILLIAN_UNKNOWN;
#line 1154 "geary-email.c"
	}
#line 381 "../src/engine/api/geary-email.vala"
	result = _tmp0_;
#line 381 "../src/engine/api/geary-email.vala"
	return result;
#line 1160 "geary-email.c"
}

/**
     * Determines if this message is flagged from its flags.
     *
     * If {@link email_flags} is not null, returns the value of {@link
     * EmailFlags.is_flagged}, otherwise returns {@link
     * Trillian.UNKNOWN}.
     */
inline GearyTrillian
geary_email_is_flagged (GearyEmail* self)
{
	GearyTrillian _tmp0_ = 0;
	GearyEmailFlags* _tmp1_;
	GearyTrillian result;
#line 391 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (self), 0);
#line 392 "../src/engine/api/geary-email.vala"
	_tmp1_ = self->priv->_email_flags;
#line 392 "../src/engine/api/geary-email.vala"
	if (_tmp1_ != NULL) {
#line 1182 "geary-email.c"
		GearyEmailFlags* _tmp2_;
#line 392 "../src/engine/api/geary-email.vala"
		_tmp2_ = self->priv->_email_flags;
#line 392 "../src/engine/api/geary-email.vala"
		_tmp0_ = geary_trillian_from_boolean (geary_email_flags_is_flagged (_tmp2_));
#line 1188 "geary-email.c"
	} else {
#line 392 "../src/engine/api/geary-email.vala"
		_tmp0_ = GEARY_TRILLIAN_UNKNOWN;
#line 1192 "geary-email.c"
	}
#line 392 "../src/engine/api/geary-email.vala"
	result = _tmp0_;
#line 392 "../src/engine/api/geary-email.vala"
	return result;
#line 1198 "geary-email.c"
}

/**
     * Determines if this message is flagged from its flags.
     *
     * If {@link email_flags} is not null, returns the value of {@link
     * EmailFlags.load_remote_images}, otherwise returns {@link
     * Trillian.UNKNOWN}.
     */
inline GearyTrillian
geary_email_load_remote_images (GearyEmail* self)
{
	GearyTrillian _tmp0_ = 0;
	GearyEmailFlags* _tmp1_;
	GearyTrillian result;
#line 402 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (self), 0);
#line 403 "../src/engine/api/geary-email.vala"
	_tmp1_ = self->priv->_email_flags;
#line 403 "../src/engine/api/geary-email.vala"
	if (_tmp1_ != NULL) {
#line 1220 "geary-email.c"
		GearyEmailFlags* _tmp2_;
#line 403 "../src/engine/api/geary-email.vala"
		_tmp2_ = self->priv->_email_flags;
#line 403 "../src/engine/api/geary-email.vala"
		_tmp0_ = geary_trillian_from_boolean (geary_email_flags_load_remote_images (_tmp2_));
#line 1226 "geary-email.c"
	} else {
#line 403 "../src/engine/api/geary-email.vala"
		_tmp0_ = GEARY_TRILLIAN_UNKNOWN;
#line 1230 "geary-email.c"
	}
#line 403 "../src/engine/api/geary-email.vala"
	result = _tmp0_;
#line 403 "../src/engine/api/geary-email.vala"
	return result;
#line 1236 "geary-email.c"
}

void
geary_email_set_send_date (GearyEmail* self,
                           GearyRFC822Date* date)
{
	GearyRFC822Date* _tmp0_;
	GearyEmailField _tmp1_;
#line 406 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_IS_EMAIL (self));
#line 406 "../src/engine/api/geary-email.vala"
	g_return_if_fail ((date == NULL) || GEARY_RF_C822_IS_DATE (date));
#line 407 "../src/engine/api/geary-email.vala"
	_tmp0_ = _g_object_ref0 (date);
#line 407 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_date);
#line 407 "../src/engine/api/geary-email.vala"
	self->priv->_date = _tmp0_;
#line 409 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->message);
#line 409 "../src/engine/api/geary-email.vala"
	self->priv->message = NULL;
#line 410 "../src/engine/api/geary-email.vala"
	_tmp1_ = self->priv->_fields;
#line 410 "../src/engine/api/geary-email.vala"
	geary_email_set_fields (self, _tmp1_ | GEARY_EMAIL_FIELD_DATE);
#line 1263 "geary-email.c"
}

/**
     * Sets the RFC822 originators for the message.
     *
     * RFC 2822 requires at least one From address, that the Sender
     * and From not be identical, and that both From and ReplyTo are
     * optional.
     */
void
geary_email_set_originators (GearyEmail* self,
                             GearyRFC822MailboxAddresses* from,
                             GearyRFC822MailboxAddress* sender,
                             GearyRFC822MailboxAddresses* reply_to,
                             GError** error)
{
	GearyRFC822MailboxAddresses* _tmp0_;
	GearyRFC822MailboxAddress* _tmp1_;
	GearyRFC822MailboxAddresses* _tmp2_;
	GearyEmailField _tmp3_;
#line 420 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_IS_EMAIL (self));
#line 420 "../src/engine/api/geary-email.vala"
	g_return_if_fail ((from == NULL) || GEARY_RF_C822_IS_MAILBOX_ADDRESSES (from));
#line 420 "../src/engine/api/geary-email.vala"
	g_return_if_fail ((sender == NULL) || GEARY_RF_C822_IS_MAILBOX_ADDRESS (sender));
#line 420 "../src/engine/api/geary-email.vala"
	g_return_if_fail ((reply_to == NULL) || GEARY_RF_C822_IS_MAILBOX_ADDRESSES (reply_to));
#line 426 "../src/engine/api/geary-email.vala"
	_tmp0_ = _g_object_ref0 (from);
#line 426 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_from);
#line 426 "../src/engine/api/geary-email.vala"
	self->priv->_from = _tmp0_;
#line 427 "../src/engine/api/geary-email.vala"
	_tmp1_ = _g_object_ref0 (sender);
#line 427 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_sender);
#line 427 "../src/engine/api/geary-email.vala"
	self->priv->_sender = _tmp1_;
#line 428 "../src/engine/api/geary-email.vala"
	_tmp2_ = _g_object_ref0 (reply_to);
#line 428 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_reply_to);
#line 428 "../src/engine/api/geary-email.vala"
	self->priv->_reply_to = _tmp2_;
#line 430 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->message);
#line 430 "../src/engine/api/geary-email.vala"
	self->priv->message = NULL;
#line 431 "../src/engine/api/geary-email.vala"
	_tmp3_ = self->priv->_fields;
#line 431 "../src/engine/api/geary-email.vala"
	geary_email_set_fields (self, _tmp3_ | GEARY_EMAIL_FIELD_ORIGINATORS);
#line 1318 "geary-email.c"
}

void
geary_email_set_receivers (GearyEmail* self,
                           GearyRFC822MailboxAddresses* to,
                           GearyRFC822MailboxAddresses* cc,
                           GearyRFC822MailboxAddresses* bcc)
{
	GearyRFC822MailboxAddresses* _tmp0_;
	GearyRFC822MailboxAddresses* _tmp1_;
	GearyRFC822MailboxAddresses* _tmp2_;
	GearyEmailField _tmp3_;
#line 434 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_IS_EMAIL (self));
#line 434 "../src/engine/api/geary-email.vala"
	g_return_if_fail ((to == NULL) || GEARY_RF_C822_IS_MAILBOX_ADDRESSES (to));
#line 434 "../src/engine/api/geary-email.vala"
	g_return_if_fail ((cc == NULL) || GEARY_RF_C822_IS_MAILBOX_ADDRESSES (cc));
#line 434 "../src/engine/api/geary-email.vala"
	g_return_if_fail ((bcc == NULL) || GEARY_RF_C822_IS_MAILBOX_ADDRESSES (bcc));
#line 437 "../src/engine/api/geary-email.vala"
	_tmp0_ = _g_object_ref0 (to);
#line 437 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_to);
#line 437 "../src/engine/api/geary-email.vala"
	self->priv->_to = _tmp0_;
#line 438 "../src/engine/api/geary-email.vala"
	_tmp1_ = _g_object_ref0 (cc);
#line 438 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_cc);
#line 438 "../src/engine/api/geary-email.vala"
	self->priv->_cc = _tmp1_;
#line 439 "../src/engine/api/geary-email.vala"
	_tmp2_ = _g_object_ref0 (bcc);
#line 439 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_bcc);
#line 439 "../src/engine/api/geary-email.vala"
	self->priv->_bcc = _tmp2_;
#line 441 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->message);
#line 441 "../src/engine/api/geary-email.vala"
	self->priv->message = NULL;
#line 442 "../src/engine/api/geary-email.vala"
	_tmp3_ = self->priv->_fields;
#line 442 "../src/engine/api/geary-email.vala"
	geary_email_set_fields (self, _tmp3_ | GEARY_EMAIL_FIELD_RECEIVERS);
#line 1365 "geary-email.c"
}

void
geary_email_set_full_references (GearyEmail* self,
                                 GearyRFC822MessageID* message_id,
                                 GearyRFC822MessageIDList* in_reply_to,
                                 GearyRFC822MessageIDList* references)
{
	GearyRFC822MessageID* _tmp0_;
	GearyRFC822MessageIDList* _tmp1_;
	GearyRFC822MessageIDList* _tmp2_;
	GearyEmailField _tmp3_;
#line 445 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_IS_EMAIL (self));
#line 445 "../src/engine/api/geary-email.vala"
	g_return_if_fail ((message_id == NULL) || GEARY_RF_C822_IS_MESSAGE_ID (message_id));
#line 445 "../src/engine/api/geary-email.vala"
	g_return_if_fail ((in_reply_to == NULL) || GEARY_RF_C822_IS_MESSAGE_ID_LIST (in_reply_to));
#line 445 "../src/engine/api/geary-email.vala"
	g_return_if_fail ((references == NULL) || GEARY_RF_C822_IS_MESSAGE_ID_LIST (references));
#line 448 "../src/engine/api/geary-email.vala"
	_tmp0_ = _g_object_ref0 (message_id);
#line 448 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_message_id);
#line 448 "../src/engine/api/geary-email.vala"
	self->priv->_message_id = _tmp0_;
#line 449 "../src/engine/api/geary-email.vala"
	_tmp1_ = _g_object_ref0 (in_reply_to);
#line 449 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_in_reply_to);
#line 449 "../src/engine/api/geary-email.vala"
	self->priv->_in_reply_to = _tmp1_;
#line 450 "../src/engine/api/geary-email.vala"
	_tmp2_ = _g_object_ref0 (references);
#line 450 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_references);
#line 450 "../src/engine/api/geary-email.vala"
	self->priv->_references = _tmp2_;
#line 452 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->message);
#line 452 "../src/engine/api/geary-email.vala"
	self->priv->message = NULL;
#line 453 "../src/engine/api/geary-email.vala"
	_tmp3_ = self->priv->_fields;
#line 453 "../src/engine/api/geary-email.vala"
	geary_email_set_fields (self, _tmp3_ | GEARY_EMAIL_FIELD_REFERENCES);
#line 1412 "geary-email.c"
}

void
geary_email_set_message_subject (GearyEmail* self,
                                 GearyRFC822Subject* subject)
{
	GearyRFC822Subject* _tmp0_;
	GearyEmailField _tmp1_;
#line 456 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_IS_EMAIL (self));
#line 456 "../src/engine/api/geary-email.vala"
	g_return_if_fail ((subject == NULL) || GEARY_RF_C822_IS_SUBJECT (subject));
#line 457 "../src/engine/api/geary-email.vala"
	_tmp0_ = _g_object_ref0 (subject);
#line 457 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_subject);
#line 457 "../src/engine/api/geary-email.vala"
	self->priv->_subject = _tmp0_;
#line 459 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->message);
#line 459 "../src/engine/api/geary-email.vala"
	self->priv->message = NULL;
#line 460 "../src/engine/api/geary-email.vala"
	_tmp1_ = self->priv->_fields;
#line 460 "../src/engine/api/geary-email.vala"
	geary_email_set_fields (self, _tmp1_ | GEARY_EMAIL_FIELD_SUBJECT);
#line 1439 "geary-email.c"
}

void
geary_email_set_message_header (GearyEmail* self,
                                GearyRFC822Header* header)
{
	GearyEmailField _tmp0_;
#line 463 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_IS_EMAIL (self));
#line 463 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_RF_C822_IS_HEADER (header));
#line 464 "../src/engine/api/geary-email.vala"
	geary_email_set_header (self, header);
#line 466 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->message);
#line 466 "../src/engine/api/geary-email.vala"
	self->priv->message = NULL;
#line 467 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_fields;
#line 467 "../src/engine/api/geary-email.vala"
	geary_email_set_fields (self, _tmp0_ | GEARY_EMAIL_FIELD_HEADER);
#line 1461 "geary-email.c"
}

void
geary_email_set_message_body (GearyEmail* self,
                              GearyRFC822Text* body)
{
	GearyEmailField _tmp0_;
#line 470 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_IS_EMAIL (self));
#line 470 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_RF_C822_IS_TEXT (body));
#line 471 "../src/engine/api/geary-email.vala"
	geary_email_set_body (self, body);
#line 473 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->message);
#line 473 "../src/engine/api/geary-email.vala"
	self->priv->message = NULL;
#line 474 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_fields;
#line 474 "../src/engine/api/geary-email.vala"
	geary_email_set_fields (self, _tmp0_ | GEARY_EMAIL_FIELD_BODY);
#line 1483 "geary-email.c"
}

void
geary_email_set_email_properties (GearyEmail* self,
                                  GearyEmailProperties* properties)
{
	GearyEmailField _tmp0_;
#line 477 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_IS_EMAIL (self));
#line 477 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_IS_EMAIL_PROPERTIES (properties));
#line 478 "../src/engine/api/geary-email.vala"
	geary_email_set_properties (self, properties);
#line 480 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_fields;
#line 480 "../src/engine/api/geary-email.vala"
	geary_email_set_fields (self, _tmp0_ | GEARY_EMAIL_FIELD_PROPERTIES);
#line 1501 "geary-email.c"
}

void
geary_email_set_message_preview (GearyEmail* self,
                                 GearyRFC822PreviewText* preview)
{
	GearyEmailField _tmp0_;
#line 483 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_IS_EMAIL (self));
#line 483 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_RF_C822_IS_PREVIEW_TEXT (preview));
#line 484 "../src/engine/api/geary-email.vala"
	geary_email_set_preview (self, preview);
#line 486 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_fields;
#line 486 "../src/engine/api/geary-email.vala"
	geary_email_set_fields (self, _tmp0_ | GEARY_EMAIL_FIELD_PREVIEW);
#line 1519 "geary-email.c"
}

void
geary_email_set_flags (GearyEmail* self,
                       GearyEmailFlags* email_flags)
{
	GearyEmailField _tmp0_;
#line 489 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_IS_EMAIL (self));
#line 489 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_IS_EMAIL_FLAGS (email_flags));
#line 490 "../src/engine/api/geary-email.vala"
	geary_email_set_email_flags (self, email_flags);
#line 492 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_fields;
#line 492 "../src/engine/api/geary-email.vala"
	geary_email_set_fields (self, _tmp0_ | GEARY_EMAIL_FIELD_FLAGS);
#line 1537 "geary-email.c"
}

void
geary_email_add_attachment (GearyEmail* self,
                            GearyAttachment* attachment)
{
	GeeList* _tmp0_;
#line 495 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_IS_EMAIL (self));
#line 495 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_IS_ATTACHMENT (attachment));
#line 496 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_attachments;
#line 496 "../src/engine/api/geary-email.vala"
	gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), attachment);
#line 1553 "geary-email.c"
}

void
geary_email_add_attachments (GearyEmail* self,
                             GeeCollection* attachments)
{
	GeeList* _tmp0_;
#line 499 "../src/engine/api/geary-email.vala"
	g_return_if_fail (GEARY_IS_EMAIL (self));
#line 499 "../src/engine/api/geary-email.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (attachments, GEE_TYPE_COLLECTION));
#line 500 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_attachments;
#line 500 "../src/engine/api/geary-email.vala"
	gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), attachments);
#line 1569 "geary-email.c"
}

gchar*
geary_email_get_searchable_attachment_list (GearyEmail* self)
{
	GString* search = NULL;
	GString* _tmp0_;
	GString* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* result;
#line 503 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (self), NULL);
#line 504 "../src/engine/api/geary-email.vala"
	_tmp0_ = g_string_new ("");
#line 504 "../src/engine/api/geary-email.vala"
	search = _tmp0_;
#line 1587 "geary-email.c"
	{
		GeeList* _attachment_list = NULL;
		GeeList* _tmp1_;
		gint _attachment_size = 0;
		GeeList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _attachment_index = 0;
#line 505 "../src/engine/api/geary-email.vala"
		_tmp1_ = self->priv->_attachments;
#line 505 "../src/engine/api/geary-email.vala"
		_attachment_list = _tmp1_;
#line 505 "../src/engine/api/geary-email.vala"
		_tmp2_ = _attachment_list;
#line 505 "../src/engine/api/geary-email.vala"
		_tmp3_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection));
#line 505 "../src/engine/api/geary-email.vala"
		_tmp4_ = _tmp3_;
#line 505 "../src/engine/api/geary-email.vala"
		_attachment_size = _tmp4_;
#line 505 "../src/engine/api/geary-email.vala"
		_attachment_index = -1;
#line 505 "../src/engine/api/geary-email.vala"
		while (TRUE) {
#line 1612 "geary-email.c"
			gint _tmp5_;
			gint _tmp6_;
			GearyAttachment* attachment = NULL;
			GeeList* _tmp7_;
			gpointer _tmp8_;
			GearyAttachment* _tmp9_;
			gboolean _tmp10_;
			gboolean _tmp11_;
#line 505 "../src/engine/api/geary-email.vala"
			_attachment_index = _attachment_index + 1;
#line 505 "../src/engine/api/geary-email.vala"
			_tmp5_ = _attachment_index;
#line 505 "../src/engine/api/geary-email.vala"
			_tmp6_ = _attachment_size;
#line 505 "../src/engine/api/geary-email.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 505 "../src/engine/api/geary-email.vala"
				break;
#line 1631 "geary-email.c"
			}
#line 505 "../src/engine/api/geary-email.vala"
			_tmp7_ = _attachment_list;
#line 505 "../src/engine/api/geary-email.vala"
			_tmp8_ = gee_list_get (_tmp7_, _attachment_index);
#line 505 "../src/engine/api/geary-email.vala"
			attachment = (GearyAttachment*) _tmp8_;
#line 506 "../src/engine/api/geary-email.vala"
			_tmp9_ = attachment;
#line 506 "../src/engine/api/geary-email.vala"
			_tmp10_ = geary_attachment_get_has_content_filename (_tmp9_);
#line 506 "../src/engine/api/geary-email.vala"
			_tmp11_ = _tmp10_;
#line 506 "../src/engine/api/geary-email.vala"
			if (_tmp11_) {
#line 1647 "geary-email.c"
				GString* _tmp12_;
				GearyAttachment* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
				GString* _tmp16_;
#line 507 "../src/engine/api/geary-email.vala"
				_tmp12_ = search;
#line 507 "../src/engine/api/geary-email.vala"
				_tmp13_ = attachment;
#line 507 "../src/engine/api/geary-email.vala"
				_tmp14_ = geary_attachment_get_content_filename (_tmp13_);
#line 507 "../src/engine/api/geary-email.vala"
				_tmp15_ = _tmp14_;
#line 507 "../src/engine/api/geary-email.vala"
				g_string_append (_tmp12_, _tmp15_);
#line 508 "../src/engine/api/geary-email.vala"
				_tmp16_ = search;
#line 508 "../src/engine/api/geary-email.vala"
				g_string_append (_tmp16_, "\n");
#line 1667 "geary-email.c"
			}
#line 505 "../src/engine/api/geary-email.vala"
			_g_object_unref0 (attachment);
#line 1671 "geary-email.c"
		}
	}
#line 511 "../src/engine/api/geary-email.vala"
	_tmp17_ = search;
#line 511 "../src/engine/api/geary-email.vala"
	_tmp18_ = _tmp17_->str;
#line 511 "../src/engine/api/geary-email.vala"
	_tmp19_ = g_strdup (_tmp18_);
#line 511 "../src/engine/api/geary-email.vala"
	result = _tmp19_;
#line 511 "../src/engine/api/geary-email.vala"
	_g_string_free0 (search);
#line 511 "../src/engine/api/geary-email.vala"
	return result;
#line 1686 "geary-email.c"
}

/**
     * Constructs a new RFC 822 message from this email.
     *
     * This method requires the {@link REQUIRED_FOR_MESSAGE} fields be
     * present. If not, {@link EngineError.INCOMPLETE_MESSAGE} is
     * thrown.
     */
GearyRFC822Message*
geary_email_get_message (GearyEmail* self,
                         GError** error)
{
	GearyRFC822Message* _tmp0_;
	GearyRFC822Message* _tmp8_;
	GearyRFC822Message* _tmp9_;
	GError* _inner_error0_ = NULL;
	GearyRFC822Message* result;
#line 521 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (self), NULL);
#line 522 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->message;
#line 522 "../src/engine/api/geary-email.vala"
	if (_tmp0_ == NULL) {
#line 1711 "geary-email.c"
		GearyEmailField _tmp1_;
		GearyRFC822Message* _tmp3_ = NULL;
		GearyRFC822Header* _tmp4_;
		GearyRFC822Text* _tmp5_;
		GearyRFC822Message* _tmp6_;
		GearyRFC822Message* _tmp7_;
#line 523 "../src/engine/api/geary-email.vala"
		_tmp1_ = self->priv->_fields;
#line 523 "../src/engine/api/geary-email.vala"
		if (!geary_email_field_fulfills (_tmp1_, GEARY_EMAIL_REQUIRED_FOR_MESSAGE)) {
#line 1722 "geary-email.c"
			GError* _tmp2_;
#line 524 "../src/engine/api/geary-email.vala"
			_tmp2_ = g_error_new_literal (GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_INCOMPLETE_MESSAGE, "Parsed email requires HEADER and BODY");
#line 524 "../src/engine/api/geary-email.vala"
			_inner_error0_ = _tmp2_;
#line 524 "../src/engine/api/geary-email.vala"
			g_propagate_error (error, _inner_error0_);
#line 524 "../src/engine/api/geary-email.vala"
			return NULL;
#line 1732 "geary-email.c"
		}
#line 528 "../src/engine/api/geary-email.vala"
		_tmp4_ = self->priv->_header;
#line 528 "../src/engine/api/geary-email.vala"
		_tmp5_ = self->priv->_body;
#line 528 "../src/engine/api/geary-email.vala"
		_tmp6_ = geary_rf_c822_message_new_from_parts (_tmp4_, _tmp5_, &_inner_error0_);
#line 528 "../src/engine/api/geary-email.vala"
		_tmp3_ = _tmp6_;
#line 528 "../src/engine/api/geary-email.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 528 "../src/engine/api/geary-email.vala"
			g_propagate_error (error, _inner_error0_);
#line 528 "../src/engine/api/geary-email.vala"
			return NULL;
#line 1748 "geary-email.c"
		}
#line 528 "../src/engine/api/geary-email.vala"
		_tmp7_ = _tmp3_;
#line 528 "../src/engine/api/geary-email.vala"
		_tmp3_ = NULL;
#line 528 "../src/engine/api/geary-email.vala"
		_g_object_unref0 (self->priv->message);
#line 528 "../src/engine/api/geary-email.vala"
		self->priv->message = _tmp7_;
#line 522 "../src/engine/api/geary-email.vala"
		_g_object_unref0 (_tmp3_);
#line 1760 "geary-email.c"
	}
#line 530 "../src/engine/api/geary-email.vala"
	_tmp8_ = self->priv->message;
#line 530 "../src/engine/api/geary-email.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 530 "../src/engine/api/geary-email.vala"
	result = _tmp9_;
#line 530 "../src/engine/api/geary-email.vala"
	return result;
#line 1770 "geary-email.c"
}

/**
     * Returns the attachment with the given MIME Content ID.
     *
     * Requires the REQUIRED_FOR_MESSAGE fields be present; else
     * EngineError.INCOMPLETE_MESSAGE is thrown.
     */
GearyAttachment*
geary_email_get_attachment_by_content_id (GearyEmail* self,
                                          const gchar* cid,
                                          GError** error)
{
	GearyEmailField _tmp0_;
	GError* _inner_error0_ = NULL;
	GearyAttachment* result;
#line 539 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (self), NULL);
#line 539 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (cid != NULL, NULL);
#line 541 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_fields;
#line 541 "../src/engine/api/geary-email.vala"
	if (!geary_email_field_fulfills (_tmp0_, GEARY_EMAIL_REQUIRED_FOR_MESSAGE)) {
#line 1795 "geary-email.c"
		GError* _tmp1_;
#line 542 "../src/engine/api/geary-email.vala"
		_tmp1_ = g_error_new_literal (GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_INCOMPLETE_MESSAGE, "Parsed email requires HEADER and BODY");
#line 542 "../src/engine/api/geary-email.vala"
		_inner_error0_ = _tmp1_;
#line 542 "../src/engine/api/geary-email.vala"
		if (_inner_error0_->domain == GEARY_ENGINE_ERROR) {
#line 542 "../src/engine/api/geary-email.vala"
			g_propagate_error (error, _inner_error0_);
#line 542 "../src/engine/api/geary-email.vala"
			return NULL;
#line 1807 "geary-email.c"
		} else {
#line 542 "../src/engine/api/geary-email.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 542 "../src/engine/api/geary-email.vala"
			g_clear_error (&_inner_error0_);
#line 542 "../src/engine/api/geary-email.vala"
			return NULL;
#line 1815 "geary-email.c"
		}
	}
	{
		GeeList* _attachment_list = NULL;
		GeeList* _tmp2_;
		gint _attachment_size = 0;
		GeeList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _attachment_index = 0;
#line 544 "../src/engine/api/geary-email.vala"
		_tmp2_ = self->priv->_attachments;
#line 544 "../src/engine/api/geary-email.vala"
		_attachment_list = _tmp2_;
#line 544 "../src/engine/api/geary-email.vala"
		_tmp3_ = _attachment_list;
#line 544 "../src/engine/api/geary-email.vala"
		_tmp4_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 544 "../src/engine/api/geary-email.vala"
		_tmp5_ = _tmp4_;
#line 544 "../src/engine/api/geary-email.vala"
		_attachment_size = _tmp5_;
#line 544 "../src/engine/api/geary-email.vala"
		_attachment_index = -1;
#line 544 "../src/engine/api/geary-email.vala"
		while (TRUE) {
#line 1842 "geary-email.c"
			gint _tmp6_;
			gint _tmp7_;
			GearyAttachment* attachment = NULL;
			GeeList* _tmp8_;
			gpointer _tmp9_;
			GearyAttachment* _tmp10_;
			const gchar* _tmp11_;
			const gchar* _tmp12_;
#line 544 "../src/engine/api/geary-email.vala"
			_attachment_index = _attachment_index + 1;
#line 544 "../src/engine/api/geary-email.vala"
			_tmp6_ = _attachment_index;
#line 544 "../src/engine/api/geary-email.vala"
			_tmp7_ = _attachment_size;
#line 544 "../src/engine/api/geary-email.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 544 "../src/engine/api/geary-email.vala"
				break;
#line 1861 "geary-email.c"
			}
#line 544 "../src/engine/api/geary-email.vala"
			_tmp8_ = _attachment_list;
#line 544 "../src/engine/api/geary-email.vala"
			_tmp9_ = gee_list_get (_tmp8_, _attachment_index);
#line 544 "../src/engine/api/geary-email.vala"
			attachment = (GearyAttachment*) _tmp9_;
#line 545 "../src/engine/api/geary-email.vala"
			_tmp10_ = attachment;
#line 545 "../src/engine/api/geary-email.vala"
			_tmp11_ = geary_attachment_get_content_id (_tmp10_);
#line 545 "../src/engine/api/geary-email.vala"
			_tmp12_ = _tmp11_;
#line 545 "../src/engine/api/geary-email.vala"
			if (g_strcmp0 (_tmp12_, cid) == 0) {
#line 546 "../src/engine/api/geary-email.vala"
				result = attachment;
#line 546 "../src/engine/api/geary-email.vala"
				return result;
#line 1881 "geary-email.c"
			}
#line 544 "../src/engine/api/geary-email.vala"
			_g_object_unref0 (attachment);
#line 1885 "geary-email.c"
		}
	}
#line 549 "../src/engine/api/geary-email.vala"
	result = NULL;
#line 549 "../src/engine/api/geary-email.vala"
	return result;
#line 1892 "geary-email.c"
}

/**
     * Returns a list of this email's ancestry by Message-ID.  IDs are not returned in any
     * particular order.  The ancestry is made up from this email's Message-ID, its References,
     * and its In-Reply-To.  Thus, this email must have been fetched with Field.REFERENCES for
     * this method to return a complete list.
     */
GeeSet*
geary_email_get_ancestors (GearyEmail* self)
{
	GeeSet* ancestors = NULL;
	GeeHashSet* _tmp0_;
	GearyRFC822MessageID* _tmp1_;
	GearyRFC822MessageID* _tmp2_;
	GearyRFC822MessageIDList* _tmp6_;
	GearyRFC822MessageIDList* _tmp7_;
	GearyRFC822MessageIDList* _tmp13_;
	GearyRFC822MessageIDList* _tmp14_;
	GeeSet* _tmp20_ = NULL;
	GeeSet* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	GeeSet* _tmp25_;
	GeeSet* result;
#line 558 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (self), NULL);
#line 559 "../src/engine/api/geary-email.vala"
	_tmp0_ = gee_hash_set_new (GEARY_RF_C822_TYPE_MESSAGE_ID, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 559 "../src/engine/api/geary-email.vala"
	ancestors = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_SET, GeeSet);
#line 562 "../src/engine/api/geary-email.vala"
	_tmp1_ = geary_email_header_set_get_message_id (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 562 "../src/engine/api/geary-email.vala"
	_tmp2_ = _tmp1_;
#line 562 "../src/engine/api/geary-email.vala"
	if (_tmp2_ != NULL) {
#line 1930 "geary-email.c"
		GeeSet* _tmp3_;
		GearyRFC822MessageID* _tmp4_;
		GearyRFC822MessageID* _tmp5_;
#line 563 "../src/engine/api/geary-email.vala"
		_tmp3_ = ancestors;
#line 563 "../src/engine/api/geary-email.vala"
		_tmp4_ = geary_email_header_set_get_message_id (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 563 "../src/engine/api/geary-email.vala"
		_tmp5_ = _tmp4_;
#line 563 "../src/engine/api/geary-email.vala"
		gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection), _tmp5_);
#line 1942 "geary-email.c"
	}
#line 566 "../src/engine/api/geary-email.vala"
	_tmp6_ = geary_email_header_set_get_references (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 566 "../src/engine/api/geary-email.vala"
	_tmp7_ = _tmp6_;
#line 566 "../src/engine/api/geary-email.vala"
	if (_tmp7_ != NULL) {
#line 1950 "geary-email.c"
		GeeSet* _tmp8_;
		GearyRFC822MessageIDList* _tmp9_;
		GearyRFC822MessageIDList* _tmp10_;
		GeeList* _tmp11_;
		GeeList* _tmp12_;
#line 567 "../src/engine/api/geary-email.vala"
		_tmp8_ = ancestors;
#line 567 "../src/engine/api/geary-email.vala"
		_tmp9_ = geary_email_header_set_get_references (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 567 "../src/engine/api/geary-email.vala"
		_tmp10_ = _tmp9_;
#line 567 "../src/engine/api/geary-email.vala"
		_tmp11_ = geary_rf_c822_message_id_list_get_all (_tmp10_);
#line 567 "../src/engine/api/geary-email.vala"
		_tmp12_ = _tmp11_;
#line 567 "../src/engine/api/geary-email.vala"
		gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_COLLECTION, GeeCollection));
#line 567 "../src/engine/api/geary-email.vala"
		_g_object_unref0 (_tmp12_);
#line 1970 "geary-email.c"
	}
#line 571 "../src/engine/api/geary-email.vala"
	_tmp13_ = geary_email_header_set_get_in_reply_to (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 571 "../src/engine/api/geary-email.vala"
	_tmp14_ = _tmp13_;
#line 571 "../src/engine/api/geary-email.vala"
	if (_tmp14_ != NULL) {
#line 1978 "geary-email.c"
		GeeSet* _tmp15_;
		GearyRFC822MessageIDList* _tmp16_;
		GearyRFC822MessageIDList* _tmp17_;
		GeeList* _tmp18_;
		GeeList* _tmp19_;
#line 572 "../src/engine/api/geary-email.vala"
		_tmp15_ = ancestors;
#line 572 "../src/engine/api/geary-email.vala"
		_tmp16_ = geary_email_header_set_get_in_reply_to (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 572 "../src/engine/api/geary-email.vala"
		_tmp17_ = _tmp16_;
#line 572 "../src/engine/api/geary-email.vala"
		_tmp18_ = geary_rf_c822_message_id_list_get_all (_tmp17_);
#line 572 "../src/engine/api/geary-email.vala"
		_tmp19_ = _tmp18_;
#line 572 "../src/engine/api/geary-email.vala"
		gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEE_TYPE_COLLECTION, GeeCollection));
#line 572 "../src/engine/api/geary-email.vala"
		_g_object_unref0 (_tmp19_);
#line 1998 "geary-email.c"
	}
#line 574 "../src/engine/api/geary-email.vala"
	_tmp21_ = ancestors;
#line 574 "../src/engine/api/geary-email.vala"
	_tmp22_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_COLLECTION, GeeCollection));
#line 574 "../src/engine/api/geary-email.vala"
	_tmp23_ = _tmp22_;
#line 574 "../src/engine/api/geary-email.vala"
	if (_tmp23_ > 0) {
#line 2008 "geary-email.c"
		GeeSet* _tmp24_;
#line 574 "../src/engine/api/geary-email.vala"
		_tmp24_ = ancestors;
#line 574 "../src/engine/api/geary-email.vala"
		_tmp20_ = _tmp24_;
#line 2014 "geary-email.c"
	} else {
#line 574 "../src/engine/api/geary-email.vala"
		_tmp20_ = NULL;
#line 2018 "geary-email.c"
	}
#line 574 "../src/engine/api/geary-email.vala"
	_tmp25_ = _g_object_ref0 (_tmp20_);
#line 574 "../src/engine/api/geary-email.vala"
	result = _tmp25_;
#line 574 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (ancestors);
#line 574 "../src/engine/api/geary-email.vala"
	return result;
#line 2028 "geary-email.c"
}

gchar*
geary_email_get_preview_as_string (GearyEmail* self)
{
	gchar* _tmp0_ = NULL;
	GearyRFC822PreviewText* _tmp1_;
	gchar* result;
#line 577 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (self), NULL);
#line 578 "../src/engine/api/geary-email.vala"
	_tmp1_ = self->priv->_preview;
#line 578 "../src/engine/api/geary-email.vala"
	if (_tmp1_ != NULL) {
#line 2043 "geary-email.c"
		GearyRFC822PreviewText* _tmp2_;
		GearyMemoryBuffer* _tmp3_;
		GearyMemoryBuffer* _tmp4_;
		gchar* _tmp5_;
#line 578 "../src/engine/api/geary-email.vala"
		_tmp2_ = self->priv->_preview;
#line 578 "../src/engine/api/geary-email.vala"
		_tmp3_ = geary_message_data_block_message_data_get_buffer (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEARY_MESSAGE_DATA_TYPE_BLOCK_MESSAGE_DATA, GearyMessageDataBlockMessageData));
#line 578 "../src/engine/api/geary-email.vala"
		_tmp4_ = _tmp3_;
#line 578 "../src/engine/api/geary-email.vala"
		_tmp5_ = geary_memory_buffer_to_string (_tmp4_);
#line 578 "../src/engine/api/geary-email.vala"
		_g_free0 (_tmp0_);
#line 578 "../src/engine/api/geary-email.vala"
		_tmp0_ = _tmp5_;
#line 2060 "geary-email.c"
	} else {
		gchar* _tmp6_;
#line 578 "../src/engine/api/geary-email.vala"
		_tmp6_ = g_strdup ("");
#line 578 "../src/engine/api/geary-email.vala"
		_g_free0 (_tmp0_);
#line 578 "../src/engine/api/geary-email.vala"
		_tmp0_ = _tmp6_;
#line 2069 "geary-email.c"
	}
#line 578 "../src/engine/api/geary-email.vala"
	result = _tmp0_;
#line 578 "../src/engine/api/geary-email.vala"
	return result;
#line 2075 "geary-email.c"
}

gchar*
geary_email_to_string (GearyEmail* self)
{
	GearyEmailIdentifier* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 581 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (self), NULL);
#line 582 "../src/engine/api/geary-email.vala"
	_tmp0_ = self->priv->_id;
#line 582 "../src/engine/api/geary-email.vala"
	_tmp1_ = geary_email_identifier_to_string (_tmp0_);
#line 582 "../src/engine/api/geary-email.vala"
	_tmp2_ = _tmp1_;
#line 582 "../src/engine/api/geary-email.vala"
	_tmp3_ = g_strdup_printf ("[%s] ", _tmp2_);
#line 582 "../src/engine/api/geary-email.vala"
	_tmp4_ = _tmp3_;
#line 582 "../src/engine/api/geary-email.vala"
	_g_free0 (_tmp2_);
#line 582 "../src/engine/api/geary-email.vala"
	result = _tmp4_;
#line 582 "../src/engine/api/geary-email.vala"
	return result;
#line 2105 "geary-email.c"
}

/**
     * Converts a Collection of {@link Email}s to a Map of Emails keyed by {@link EmailIdentifier}s.
     *
     * @return null if emails is empty or null.
     */
GeeMap*
geary_email_emails_to_map (GeeCollection* emails)
{
	gboolean _tmp0_ = FALSE;
	GeeMap* map = NULL;
	GeeHashMap* _tmp3_;
	GeeMap* result;
#line 590 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail ((emails == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (emails, GEE_TYPE_COLLECTION), NULL);
#line 591 "../src/engine/api/geary-email.vala"
	if (emails == NULL) {
#line 591 "../src/engine/api/geary-email.vala"
		_tmp0_ = TRUE;
#line 2126 "geary-email.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 591 "../src/engine/api/geary-email.vala"
		_tmp1_ = gee_collection_get_size (emails);
#line 591 "../src/engine/api/geary-email.vala"
		_tmp2_ = _tmp1_;
#line 591 "../src/engine/api/geary-email.vala"
		_tmp0_ = _tmp2_ == 0;
#line 2136 "geary-email.c"
	}
#line 591 "../src/engine/api/geary-email.vala"
	if (_tmp0_) {
#line 592 "../src/engine/api/geary-email.vala"
		result = NULL;
#line 592 "../src/engine/api/geary-email.vala"
		return result;
#line 2144 "geary-email.c"
	}
#line 594 "../src/engine/api/geary-email.vala"
	_tmp3_ = gee_hash_map_new (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GEARY_TYPE_EMAIL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 594 "../src/engine/api/geary-email.vala"
	map = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_MAP, GeeMap);
#line 2150 "geary-email.c"
	{
		GeeIterator* _email_it = NULL;
		GeeIterator* _tmp4_;
#line 596 "../src/engine/api/geary-email.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (emails, GEE_TYPE_ITERABLE, GeeIterable));
#line 596 "../src/engine/api/geary-email.vala"
		_email_it = _tmp4_;
#line 596 "../src/engine/api/geary-email.vala"
		while (TRUE) {
#line 2160 "geary-email.c"
			GeeIterator* _tmp5_;
			GearyEmail* email = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GeeMap* _tmp8_;
			GearyEmail* _tmp9_;
			GearyEmailIdentifier* _tmp10_;
			GearyEmail* _tmp11_;
#line 596 "../src/engine/api/geary-email.vala"
			_tmp5_ = _email_it;
#line 596 "../src/engine/api/geary-email.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 596 "../src/engine/api/geary-email.vala"
				break;
#line 2175 "geary-email.c"
			}
#line 596 "../src/engine/api/geary-email.vala"
			_tmp6_ = _email_it;
#line 596 "../src/engine/api/geary-email.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 596 "../src/engine/api/geary-email.vala"
			email = (GearyEmail*) _tmp7_;
#line 597 "../src/engine/api/geary-email.vala"
			_tmp8_ = map;
#line 597 "../src/engine/api/geary-email.vala"
			_tmp9_ = email;
#line 597 "../src/engine/api/geary-email.vala"
			_tmp10_ = _tmp9_->priv->_id;
#line 597 "../src/engine/api/geary-email.vala"
			_tmp11_ = email;
#line 597 "../src/engine/api/geary-email.vala"
			gee_map_set (_tmp8_, _tmp10_, _tmp11_);
#line 596 "../src/engine/api/geary-email.vala"
			_g_object_unref0 (email);
#line 2195 "geary-email.c"
		}
#line 596 "../src/engine/api/geary-email.vala"
		_g_object_unref0 (_email_it);
#line 2199 "geary-email.c"
	}
#line 599 "../src/engine/api/geary-email.vala"
	result = map;
#line 599 "../src/engine/api/geary-email.vala"
	return result;
#line 2205 "geary-email.c"
}

/**
     * CompareFunc to sort {@link Email} by {@link date} ascending.
     *
     * If the date field is unavailable on either Email, their identifiers are compared to
     * stabilize the sort.
     */
gint
geary_email_compare_sent_date_ascending (GearyEmail* aemail,
                                         GearyEmail* bemail)
{
	gboolean _tmp0_ = FALSE;
	GearyRFC822Date* _tmp1_;
	GearyRFC822Date* _tmp2_;
	gint compare = 0;
	GearyRFC822Date* _tmp5_;
	GearyRFC822Date* _tmp6_;
	GDateTime* _tmp7_;
	GDateTime* _tmp8_;
	GearyRFC822Date* _tmp9_;
	GearyRFC822Date* _tmp10_;
	GDateTime* _tmp11_;
	GDateTime* _tmp12_;
	gint _tmp13_ = 0;
	gint result;
#line 608 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (aemail), 0);
#line 608 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (bemail), 0);
#line 609 "../src/engine/api/geary-email.vala"
	_tmp1_ = geary_email_header_set_get_date (G_TYPE_CHECK_INSTANCE_CAST (aemail, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 609 "../src/engine/api/geary-email.vala"
	_tmp2_ = _tmp1_;
#line 609 "../src/engine/api/geary-email.vala"
	if (_tmp2_ == NULL) {
#line 609 "../src/engine/api/geary-email.vala"
		_tmp0_ = TRUE;
#line 2244 "geary-email.c"
	} else {
		GearyRFC822Date* _tmp3_;
		GearyRFC822Date* _tmp4_;
#line 609 "../src/engine/api/geary-email.vala"
		_tmp3_ = geary_email_header_set_get_date (G_TYPE_CHECK_INSTANCE_CAST (bemail, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 609 "../src/engine/api/geary-email.vala"
		_tmp4_ = _tmp3_;
#line 609 "../src/engine/api/geary-email.vala"
		_tmp0_ = _tmp4_ == NULL;
#line 2254 "geary-email.c"
	}
#line 609 "../src/engine/api/geary-email.vala"
	if (_tmp0_) {
#line 610 "../src/engine/api/geary-email.vala"
		g_message ("geary-email.vala:610: Warning: comparing email for sent date but no Da" \
"te: field loaded");
#line 612 "../src/engine/api/geary-email.vala"
		result = geary_email_compare_id_ascending (aemail, bemail);
#line 612 "../src/engine/api/geary-email.vala"
		return result;
#line 2264 "geary-email.c"
	}
#line 615 "../src/engine/api/geary-email.vala"
	_tmp5_ = geary_email_header_set_get_date (G_TYPE_CHECK_INSTANCE_CAST (aemail, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 615 "../src/engine/api/geary-email.vala"
	_tmp6_ = _tmp5_;
#line 615 "../src/engine/api/geary-email.vala"
	_tmp7_ = geary_rf_c822_date_get_value (_tmp6_);
#line 615 "../src/engine/api/geary-email.vala"
	_tmp8_ = _tmp7_;
#line 615 "../src/engine/api/geary-email.vala"
	_tmp9_ = geary_email_header_set_get_date (G_TYPE_CHECK_INSTANCE_CAST (bemail, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 615 "../src/engine/api/geary-email.vala"
	_tmp10_ = _tmp9_;
#line 615 "../src/engine/api/geary-email.vala"
	_tmp11_ = geary_rf_c822_date_get_value (_tmp10_);
#line 615 "../src/engine/api/geary-email.vala"
	_tmp12_ = _tmp11_;
#line 615 "../src/engine/api/geary-email.vala"
	compare = g_date_time_compare (_tmp8_, _tmp12_);
#line 618 "../src/engine/api/geary-email.vala"
	if (compare != 0) {
#line 618 "../src/engine/api/geary-email.vala"
		_tmp13_ = compare;
#line 2288 "geary-email.c"
	} else {
#line 618 "../src/engine/api/geary-email.vala"
		_tmp13_ = geary_email_compare_id_ascending (aemail, bemail);
#line 2292 "geary-email.c"
	}
#line 618 "../src/engine/api/geary-email.vala"
	result = _tmp13_;
#line 618 "../src/engine/api/geary-email.vala"
	return result;
#line 2298 "geary-email.c"
}

/**
     * CompareFunc to sort {@link Email} by {@link date} descending.
     *
     * If the date field is unavailable on either Email, their identifiers are compared to
     * stabilize the sort.
     */
gint
geary_email_compare_sent_date_descending (GearyEmail* aemail,
                                          GearyEmail* bemail)
{
	gint result;
#line 627 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (aemail), 0);
#line 627 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (bemail), 0);
#line 628 "../src/engine/api/geary-email.vala"
	result = geary_email_compare_sent_date_ascending (bemail, aemail);
#line 628 "../src/engine/api/geary-email.vala"
	return result;
#line 2320 "geary-email.c"
}

/**
     * CompareFunc to sort {@link Email} by {@link EmailProperties.date_received} ascending.
     *
     * If {@link properties} is unavailable on either Email, their identifiers are compared to
     * stabilize the sort.
     */
gint
geary_email_compare_recv_date_ascending (GearyEmail* aemail,
                                         GearyEmail* bemail)
{
	gboolean _tmp0_ = FALSE;
	GearyEmailProperties* _tmp1_;
	gint compare = 0;
	GearyEmailProperties* _tmp3_;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	GearyEmailProperties* _tmp6_;
	GDateTime* _tmp7_;
	GDateTime* _tmp8_;
	gint _tmp9_ = 0;
	gint result;
#line 637 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (aemail), 0);
#line 637 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (bemail), 0);
#line 638 "../src/engine/api/geary-email.vala"
	_tmp1_ = aemail->priv->_properties;
#line 638 "../src/engine/api/geary-email.vala"
	if (_tmp1_ == NULL) {
#line 638 "../src/engine/api/geary-email.vala"
		_tmp0_ = TRUE;
#line 2354 "geary-email.c"
	} else {
		GearyEmailProperties* _tmp2_;
#line 638 "../src/engine/api/geary-email.vala"
		_tmp2_ = bemail->priv->_properties;
#line 638 "../src/engine/api/geary-email.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 2361 "geary-email.c"
	}
#line 638 "../src/engine/api/geary-email.vala"
	if (_tmp0_) {
#line 639 "../src/engine/api/geary-email.vala"
		g_message ("geary-email.vala:639: Warning: comparing email for received date but e" \
"mail properties not loaded");
#line 641 "../src/engine/api/geary-email.vala"
		result = geary_email_compare_id_ascending (aemail, bemail);
#line 641 "../src/engine/api/geary-email.vala"
		return result;
#line 2371 "geary-email.c"
	}
#line 644 "../src/engine/api/geary-email.vala"
	_tmp3_ = aemail->priv->_properties;
#line 644 "../src/engine/api/geary-email.vala"
	_tmp4_ = geary_email_properties_get_date_received (_tmp3_);
#line 644 "../src/engine/api/geary-email.vala"
	_tmp5_ = _tmp4_;
#line 644 "../src/engine/api/geary-email.vala"
	_tmp6_ = bemail->priv->_properties;
#line 644 "../src/engine/api/geary-email.vala"
	_tmp7_ = geary_email_properties_get_date_received (_tmp6_);
#line 644 "../src/engine/api/geary-email.vala"
	_tmp8_ = _tmp7_;
#line 644 "../src/engine/api/geary-email.vala"
	compare = g_date_time_compare (_tmp5_, _tmp8_);
#line 647 "../src/engine/api/geary-email.vala"
	if (compare != 0) {
#line 647 "../src/engine/api/geary-email.vala"
		_tmp9_ = compare;
#line 2391 "geary-email.c"
	} else {
#line 647 "../src/engine/api/geary-email.vala"
		_tmp9_ = geary_email_compare_id_ascending (aemail, bemail);
#line 2395 "geary-email.c"
	}
#line 647 "../src/engine/api/geary-email.vala"
	result = _tmp9_;
#line 647 "../src/engine/api/geary-email.vala"
	return result;
#line 2401 "geary-email.c"
}

/**
     * CompareFunc to sort {@link Email} by {@link EmailProperties.date_received} descending.
     *
     * If {@link properties} is unavailable on either Email, their identifiers are compared to
     * stabilize the sort.
     */
gint
geary_email_compare_recv_date_descending (GearyEmail* aemail,
                                          GearyEmail* bemail)
{
	gint result;
#line 656 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (aemail), 0);
#line 656 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (bemail), 0);
#line 657 "../src/engine/api/geary-email.vala"
	result = geary_email_compare_recv_date_ascending (bemail, aemail);
#line 657 "../src/engine/api/geary-email.vala"
	return result;
#line 2423 "geary-email.c"
}

static gint
geary_email_compare_id_ascending (GearyEmail* aemail,
                                  GearyEmail* bemail)
{
	GearyEmailIdentifier* _tmp0_;
	GearyEmailIdentifier* _tmp1_;
	gint result;
#line 661 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (aemail), 0);
#line 661 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (bemail), 0);
#line 662 "../src/engine/api/geary-email.vala"
	_tmp0_ = aemail->priv->_id;
#line 662 "../src/engine/api/geary-email.vala"
	_tmp1_ = bemail->priv->_id;
#line 662 "../src/engine/api/geary-email.vala"
	result = geary_email_identifier_stable_sort_comparator (_tmp0_, _tmp1_);
#line 662 "../src/engine/api/geary-email.vala"
	return result;
#line 2445 "geary-email.c"
}

/**
     * CompareFunc to sort Email by EmailProperties.total_bytes.  If not available, emails are
     * compared by EmailIdentifier.
     */
gint
geary_email_compare_size_ascending (GearyEmail* aemail,
                                    GearyEmail* bemail)
{
	GearyEmailProperties* aprop = NULL;
	GearyEmailProperties* _tmp0_;
	GearyEmailProperties* _tmp1_;
	GearyEmailProperties* bprop = NULL;
	GearyEmailProperties* _tmp2_;
	GearyEmailProperties* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GearyEmailProperties* _tmp5_;
	gint cmp = 0;
	GearyEmailProperties* _tmp7_;
	gint64 _tmp8_;
	gint64 _tmp9_;
	GearyEmailProperties* _tmp10_;
	gint64 _tmp11_;
	gint64 _tmp12_;
	gint _tmp13_ = 0;
	gint result;
#line 669 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (aemail), 0);
#line 669 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (bemail), 0);
#line 670 "../src/engine/api/geary-email.vala"
	_tmp0_ = aemail->priv->_properties;
#line 670 "../src/engine/api/geary-email.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_TYPE_EMAIL_PROPERTIES, GearyEmailProperties));
#line 670 "../src/engine/api/geary-email.vala"
	aprop = _tmp1_;
#line 671 "../src/engine/api/geary-email.vala"
	_tmp2_ = bemail->priv->_properties;
#line 671 "../src/engine/api/geary-email.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEARY_TYPE_EMAIL_PROPERTIES, GearyEmailProperties));
#line 671 "../src/engine/api/geary-email.vala"
	bprop = _tmp3_;
#line 673 "../src/engine/api/geary-email.vala"
	_tmp5_ = aprop;
#line 673 "../src/engine/api/geary-email.vala"
	if (_tmp5_ == NULL) {
#line 673 "../src/engine/api/geary-email.vala"
		_tmp4_ = TRUE;
#line 2495 "geary-email.c"
	} else {
		GearyEmailProperties* _tmp6_;
#line 673 "../src/engine/api/geary-email.vala"
		_tmp6_ = bprop;
#line 673 "../src/engine/api/geary-email.vala"
		_tmp4_ = _tmp6_ == NULL;
#line 2502 "geary-email.c"
	}
#line 673 "../src/engine/api/geary-email.vala"
	if (_tmp4_) {
#line 674 "../src/engine/api/geary-email.vala"
		g_message ("geary-email.vala:674: Warning: comparing email by size but email prope" \
"rties not loaded");
#line 676 "../src/engine/api/geary-email.vala"
		result = geary_email_compare_id_ascending (aemail, bemail);
#line 676 "../src/engine/api/geary-email.vala"
		_g_object_unref0 (bprop);
#line 676 "../src/engine/api/geary-email.vala"
		_g_object_unref0 (aprop);
#line 676 "../src/engine/api/geary-email.vala"
		return result;
#line 2516 "geary-email.c"
	}
#line 679 "../src/engine/api/geary-email.vala"
	_tmp7_ = aprop;
#line 679 "../src/engine/api/geary-email.vala"
	_tmp8_ = geary_email_properties_get_total_bytes (_tmp7_);
#line 679 "../src/engine/api/geary-email.vala"
	_tmp9_ = _tmp8_;
#line 679 "../src/engine/api/geary-email.vala"
	_tmp10_ = bprop;
#line 679 "../src/engine/api/geary-email.vala"
	_tmp11_ = geary_email_properties_get_total_bytes (_tmp10_);
#line 679 "../src/engine/api/geary-email.vala"
	_tmp12_ = _tmp11_;
#line 679 "../src/engine/api/geary-email.vala"
	cmp = (gint) CLAMP (_tmp9_ - _tmp12_, (gint64) -1, (gint64) 1);
#line 681 "../src/engine/api/geary-email.vala"
	if (cmp != 0) {
#line 681 "../src/engine/api/geary-email.vala"
		_tmp13_ = cmp;
#line 2536 "geary-email.c"
	} else {
#line 681 "../src/engine/api/geary-email.vala"
		_tmp13_ = geary_email_compare_id_ascending (aemail, bemail);
#line 2540 "geary-email.c"
	}
#line 681 "../src/engine/api/geary-email.vala"
	result = _tmp13_;
#line 681 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (bprop);
#line 681 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (aprop);
#line 681 "../src/engine/api/geary-email.vala"
	return result;
#line 2550 "geary-email.c"
}

/**
     * CompareFunc to sort Email by EmailProperties.total_bytes.  If not available, emails are
     * compared by EmailIdentifier.
     */
gint
geary_email_compare_size_descending (GearyEmail* aemail,
                                     GearyEmail* bemail)
{
	gint result;
#line 688 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (aemail), 0);
#line 688 "../src/engine/api/geary-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (bemail), 0);
#line 689 "../src/engine/api/geary-email.vala"
	result = geary_email_compare_size_ascending (bemail, aemail);
#line 689 "../src/engine/api/geary-email.vala"
	return result;
#line 2570 "geary-email.c"
}

static void
geary_email_class_init (GearyEmailClass * klass,
                        gpointer klass_data)
{
#line 29 "../src/engine/api/geary-email.vala"
	geary_email_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/engine/api/geary-email.vala"
	g_type_class_adjust_private_offset (klass, &GearyEmail_private_offset);
#line 29 "../src/engine/api/geary-email.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_email_get_property;
#line 29 "../src/engine/api/geary-email.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_email_set_property;
#line 29 "../src/engine/api/geary-email.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_email_finalize;
#line 2587 "geary-email.c"
	/**
	     * A unique identifier for the Email in the Folder.
	     *
	     * This is is guaranteed to be unique for as long as the Folder is
	     * open. Once closed, guarantees are no longer made.
	     *
	     * This field is always returned, no matter what Fields are used
	     * to retrieve the Email.
	     */
#line 29 "../src/engine/api/geary-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_EMAIL_ID_PROPERTY, geary_email_properties[GEARY_EMAIL_ID_PROPERTY] = g_param_spec_object ("id", "id", "id", GEARY_TYPE_EMAIL_IDENTIFIER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2599 "geary-email.c"
	/**
	     * {@inheritDoc}
	     *
	     * Value will be valid if {@link Field.ORIGINATORS} is set.
	     */
#line 29 "../src/engine/api/geary-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_EMAIL_FROM_PROPERTY, geary_email_properties[GEARY_EMAIL_FROM_PROPERTY] = g_param_spec_object ("from", "from", "from", GEARY_RF_C822_TYPE_MAILBOX_ADDRESSES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2607 "geary-email.c"
	/**
	     * {@inheritDoc}
	     *
	     * Value will be valid if {@link Field.ORIGINATORS} is set.
	     */
#line 29 "../src/engine/api/geary-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_EMAIL_SENDER_PROPERTY, geary_email_properties[GEARY_EMAIL_SENDER_PROPERTY] = g_param_spec_object ("sender", "sender", "sender", GEARY_RF_C822_TYPE_MAILBOX_ADDRESS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2615 "geary-email.c"
	/**
	     * {@inheritDoc}
	     *
	     * Value will be valid if {@link Field.ORIGINATORS} is set.
	     */
#line 29 "../src/engine/api/geary-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_EMAIL_REPLY_TO_PROPERTY, geary_email_properties[GEARY_EMAIL_REPLY_TO_PROPERTY] = g_param_spec_object ("reply-to", "reply-to", "reply-to", GEARY_RF_C822_TYPE_MAILBOX_ADDRESSES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2623 "geary-email.c"
	/**
	     * {@inheritDoc}
	     *
	     * Value will be valid if {@link Field.RECEIVERS} is set.
	     */
#line 29 "../src/engine/api/geary-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_EMAIL_TO_PROPERTY, geary_email_properties[GEARY_EMAIL_TO_PROPERTY] = g_param_spec_object ("to", "to", "to", GEARY_RF_C822_TYPE_MAILBOX_ADDRESSES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2631 "geary-email.c"
	/**
	     * {@inheritDoc}
	     *
	     * Value will be valid if {@link Field.RECEIVERS} is set.
	     */
#line 29 "../src/engine/api/geary-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_EMAIL_CC_PROPERTY, geary_email_properties[GEARY_EMAIL_CC_PROPERTY] = g_param_spec_object ("cc", "cc", "cc", GEARY_RF_C822_TYPE_MAILBOX_ADDRESSES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2639 "geary-email.c"
	/**
	     * {@inheritDoc}
	     *
	     * Value will be valid if {@link Field.RECEIVERS} is set.
	     */
#line 29 "../src/engine/api/geary-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_EMAIL_BCC_PROPERTY, geary_email_properties[GEARY_EMAIL_BCC_PROPERTY] = g_param_spec_object ("bcc", "bcc", "bcc", GEARY_RF_C822_TYPE_MAILBOX_ADDRESSES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2647 "geary-email.c"
	/**
	     * {@inheritDoc}
	     *
	     * Value will be valid if {@link Field.REFERENCES} is set.
	     */
#line 29 "../src/engine/api/geary-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_EMAIL_MESSAGE_ID_PROPERTY, geary_email_properties[GEARY_EMAIL_MESSAGE_ID_PROPERTY] = g_param_spec_object ("message-id", "message-id", "message-id", GEARY_RF_C822_TYPE_MESSAGE_ID, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2655 "geary-email.c"
	/**
	     * {@inheritDoc}
	     *
	     * Value will be valid if {@link Field.REFERENCES} is set.
	     */
#line 29 "../src/engine/api/geary-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_EMAIL_IN_REPLY_TO_PROPERTY, geary_email_properties[GEARY_EMAIL_IN_REPLY_TO_PROPERTY] = g_param_spec_object ("in-reply-to", "in-reply-to", "in-reply-to", GEARY_RF_C822_TYPE_MESSAGE_ID_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2663 "geary-email.c"
	/**
	     * {@inheritDoc}
	     *
	     * Value will be valid if {@link Field.REFERENCES} is set.
	     */
#line 29 "../src/engine/api/geary-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_EMAIL_REFERENCES_PROPERTY, geary_email_properties[GEARY_EMAIL_REFERENCES_PROPERTY] = g_param_spec_object ("references", "references", "references", GEARY_RF_C822_TYPE_MESSAGE_ID_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2671 "geary-email.c"
	/**
	     * {@inheritDoc}
	     *
	     * Value will be valid if {@link Field.SUBJECT} is set.
	     */
#line 29 "../src/engine/api/geary-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_EMAIL_SUBJECT_PROPERTY, geary_email_properties[GEARY_EMAIL_SUBJECT_PROPERTY] = g_param_spec_object ("subject", "subject", "subject", GEARY_RF_C822_TYPE_SUBJECT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2679 "geary-email.c"
	/**
	     * {@inheritDoc}
	     *
	     * Value will be valid if {@link Field.DATE} is set.
	     */
#line 29 "../src/engine/api/geary-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_EMAIL_DATE_PROPERTY, geary_email_properties[GEARY_EMAIL_DATE_PROPERTY] = g_param_spec_object ("date", "date", "date", GEARY_RF_C822_TYPE_DATE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2687 "geary-email.c"
	/**
	     * {@inheritDoc}
	     *
	     * Value will be valid if {@link Field.HEADER} is set.
	     */
#line 29 "../src/engine/api/geary-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_EMAIL_HEADER_PROPERTY, geary_email_properties[GEARY_EMAIL_HEADER_PROPERTY] = g_param_spec_object ("header", "header", "header", GEARY_RF_C822_TYPE_HEADER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2695 "geary-email.c"
	/**
	     * The complete RFC 822 message body.
	     *
	     * Value will be valid if {@link Field.BODY} is set.
	     */
#line 29 "../src/engine/api/geary-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_EMAIL_BODY_PROPERTY, geary_email_properties[GEARY_EMAIL_BODY_PROPERTY] = g_param_spec_object ("body", "body", "body", GEARY_RF_C822_TYPE_TEXT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2703 "geary-email.c"
	/**
	     * MIME multipart body parts.
	     *
	     * Value will be valid if {@link Field.BODY} is set.
	     */
#line 29 "../src/engine/api/geary-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_EMAIL_ATTACHMENTS_PROPERTY, geary_email_properties[GEARY_EMAIL_ATTACHMENTS_PROPERTY] = g_param_spec_object ("attachments", "attachments", "attachments", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2711 "geary-email.c"
	/**
	     * A plain text prefix of the email's message body.
	     *
	     * Value will be valid if {@link Field.PREVIEW} is set.
	     */
#line 29 "../src/engine/api/geary-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_EMAIL_PREVIEW_PROPERTY, geary_email_properties[GEARY_EMAIL_PREVIEW_PROPERTY] = g_param_spec_object ("preview", "preview", "preview", GEARY_RF_C822_TYPE_PREVIEW_TEXT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2719 "geary-email.c"
	/**
	     * Set of immutable properties for the email.
	     *
	     * Value will be valid if {@link Field.PROPERTIES} is set.
	     */
#line 29 "../src/engine/api/geary-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_EMAIL_PROPERTIES_PROPERTY, geary_email_properties[GEARY_EMAIL_PROPERTIES_PROPERTY] = g_param_spec_object ("properties", "properties", "properties", GEARY_TYPE_EMAIL_PROPERTIES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2727 "geary-email.c"
	/**
	     * Set of mutable flags for the email.
	     *
	     * Value will be valid if {@link Field.FLAGS} is set.
	     */
#line 29 "../src/engine/api/geary-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_EMAIL_EMAIL_FLAGS_PROPERTY, geary_email_properties[GEARY_EMAIL_EMAIL_FLAGS_PROPERTY] = g_param_spec_object ("email-flags", "email-flags", "email-flags", GEARY_TYPE_EMAIL_FLAGS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2735 "geary-email.c"
	/**
	     * Specifies the properties that have been populated for this email.
	     *
	     * Since this email object may be a partial representation of a
	     * complete email message, this property lists all parts of the
	     * object that have actually been loaded, as opposed to parts that
	     * are simply missing from the email it represents.
	     *
	     * For example, if this property includes the {@link
	     * Field.SUBJECT} flag, then the {@link subject} property has been
	     * set to reflect the Subject header of the message. Of course,
	     * the subject may then still may be null or empty, if the email
	     * did not specify a subject header.
	     */
#line 29 "../src/engine/api/geary-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_EMAIL_FIELDS_PROPERTY, geary_email_properties[GEARY_EMAIL_FIELDS_PROPERTY] = g_param_spec_enum ("fields", "fields", "fields", GEARY_EMAIL_TYPE_FIELD, GEARY_EMAIL_FIELD_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2752 "geary-email.c"
}

static void
geary_email_geary_email_header_set_interface_init (GearyEmailHeaderSetIface * iface,
                                                   gpointer iface_data)
{
#line 29 "../src/engine/api/geary-email.vala"
	geary_email_geary_email_header_set_parent_iface = g_type_interface_peek_parent (iface);
#line 29 "../src/engine/api/geary-email.vala"
	iface->get_from = geary_email_real_get_from;
#line 29 "../src/engine/api/geary-email.vala"
	iface->get_sender = geary_email_real_get_sender;
#line 29 "../src/engine/api/geary-email.vala"
	iface->get_reply_to = geary_email_real_get_reply_to;
#line 29 "../src/engine/api/geary-email.vala"
	iface->get_to = geary_email_real_get_to;
#line 29 "../src/engine/api/geary-email.vala"
	iface->get_cc = geary_email_real_get_cc;
#line 29 "../src/engine/api/geary-email.vala"
	iface->get_bcc = geary_email_real_get_bcc;
#line 29 "../src/engine/api/geary-email.vala"
	iface->get_message_id = geary_email_real_get_message_id;
#line 29 "../src/engine/api/geary-email.vala"
	iface->get_in_reply_to = geary_email_real_get_in_reply_to;
#line 29 "../src/engine/api/geary-email.vala"
	iface->get_references = geary_email_real_get_references;
#line 29 "../src/engine/api/geary-email.vala"
	iface->get_subject = geary_email_real_get_subject;
#line 29 "../src/engine/api/geary-email.vala"
	iface->get_date = geary_email_real_get_date;
#line 2783 "geary-email.c"
}

static void
geary_email_instance_init (GearyEmail * self,
                           gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 29 "../src/engine/api/geary-email.vala"
	self->priv = geary_email_get_instance_private (self);
#line 199 "../src/engine/api/geary-email.vala"
	self->priv->_from = NULL;
#line 207 "../src/engine/api/geary-email.vala"
	self->priv->_sender = NULL;
#line 215 "../src/engine/api/geary-email.vala"
	self->priv->_reply_to = NULL;
#line 223 "../src/engine/api/geary-email.vala"
	self->priv->_to = NULL;
#line 231 "../src/engine/api/geary-email.vala"
	self->priv->_cc = NULL;
#line 239 "../src/engine/api/geary-email.vala"
	self->priv->_bcc = NULL;
#line 247 "../src/engine/api/geary-email.vala"
	self->priv->_message_id = NULL;
#line 255 "../src/engine/api/geary-email.vala"
	self->priv->_in_reply_to = NULL;
#line 263 "../src/engine/api/geary-email.vala"
	self->priv->_references = NULL;
#line 271 "../src/engine/api/geary-email.vala"
	self->priv->_subject = NULL;
#line 279 "../src/engine/api/geary-email.vala"
	self->priv->_date = NULL;
#line 286 "../src/engine/api/geary-email.vala"
	self->priv->_header = NULL;
#line 293 "../src/engine/api/geary-email.vala"
	self->priv->_body = NULL;
#line 300 "../src/engine/api/geary-email.vala"
	_tmp0_ = gee_array_list_new (GEARY_TYPE_ATTACHMENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 300 "../src/engine/api/geary-email.vala"
	self->priv->_attachments = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_LIST, GeeList);
#line 308 "../src/engine/api/geary-email.vala"
	self->priv->_preview = NULL;
#line 315 "../src/engine/api/geary-email.vala"
	self->priv->_properties = NULL;
#line 322 "../src/engine/api/geary-email.vala"
	self->priv->_email_flags = NULL;
#line 338 "../src/engine/api/geary-email.vala"
	self->priv->_fields = GEARY_EMAIL_FIELD_NONE;
#line 341 "../src/engine/api/geary-email.vala"
	self->priv->message = NULL;
#line 2833 "geary-email.c"
}

static void
geary_email_finalize (GObject * obj)
{
	GearyEmail * self;
#line 29 "../src/engine/api/geary-email.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_TYPE_EMAIL, GearyEmail);
#line 191 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_id);
#line 199 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_from);
#line 207 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_sender);
#line 215 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_reply_to);
#line 223 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_to);
#line 231 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_cc);
#line 239 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_bcc);
#line 247 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_message_id);
#line 255 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_in_reply_to);
#line 263 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_references);
#line 271 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_subject);
#line 279 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_date);
#line 286 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_header);
#line 293 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_body);
#line 300 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_attachments);
#line 308 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_preview);
#line 315 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_properties);
#line 322 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->_email_flags);
#line 341 "../src/engine/api/geary-email.vala"
	_g_object_unref0 (self->priv->message);
#line 29 "../src/engine/api/geary-email.vala"
	G_OBJECT_CLASS (geary_email_parent_class)->finalize (obj);
#line 2882 "geary-email.c"
}

/**
 * An Email represents a single RFC 822 style email message.
 *
 * This class provides a common abstraction over different
 * representations of email messages, allowing messages from different
 * mail systems, from both local and remote sources, and locally
 * composed email messages to all be represented by a single
 * object. While this object represents a RFC 822 message, it also
 * holds additional metadata about an email not specified by that
 * format, such as its unique {@link id}, and unread state and other
 * {@link email_flags}.
 *
 * Email objects may by constructed in many ways, but are usually
 * obtained via a {@link Folder}. Email objects may be partial
 * representations of messages, in cases where a remote message has
 * not been fully downloaded, or a local message not fully loaded from
 * a database. This can be checked via an email's {@link fields}
 * property, and if the currently loaded fields are not sufficient,
 * then additional fields can be loaded via a folder.
 */
 G_GNUC_NO_INLINE static GType
geary_email_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyEmailClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_email_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyEmail), 0, (GInstanceInitFunc) geary_email_instance_init, NULL };
	static const GInterfaceInfo geary_email_header_set_info = { (GInterfaceInitFunc) geary_email_geary_email_header_set_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType geary_email_type_id;
	geary_email_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyEmail", &g_define_type_info, 0);
	g_type_add_interface_static (geary_email_type_id, GEARY_TYPE_EMAIL_HEADER_SET, &geary_email_header_set_info);
	GearyEmail_private_offset = g_type_add_instance_private (geary_email_type_id, sizeof (GearyEmailPrivate));
	return geary_email_type_id;
}

GType
geary_email_get_type (void)
{
	static gsize geary_email_type_id__once = 0;
	if (g_once_init_enter (&geary_email_type_id__once)) {
		GType geary_email_type_id;
		geary_email_type_id = geary_email_get_type_once ();
		g_once_init_leave (&geary_email_type_id__once, geary_email_type_id);
	}
	return geary_email_type_id__once;
}

static void
_vala_geary_email_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	GearyEmail * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_EMAIL, GearyEmail);
#line 29 "../src/engine/api/geary-email.vala"
	switch (property_id) {
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_ID_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		g_value_set_object (value, geary_email_get_id (self));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_FROM_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		g_value_set_object (value, geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet)));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_SENDER_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		g_value_set_object (value, geary_email_header_set_get_sender (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet)));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_REPLY_TO_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		g_value_set_object (value, geary_email_header_set_get_reply_to (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet)));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_TO_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		g_value_set_object (value, geary_email_header_set_get_to (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet)));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_CC_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		g_value_set_object (value, geary_email_header_set_get_cc (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet)));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_BCC_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		g_value_set_object (value, geary_email_header_set_get_bcc (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet)));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_MESSAGE_ID_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		g_value_set_object (value, geary_email_header_set_get_message_id (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet)));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_IN_REPLY_TO_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		g_value_set_object (value, geary_email_header_set_get_in_reply_to (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet)));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_REFERENCES_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		g_value_set_object (value, geary_email_header_set_get_references (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet)));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_SUBJECT_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		g_value_set_object (value, geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet)));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_DATE_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		g_value_set_object (value, geary_email_header_set_get_date (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet)));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_HEADER_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		g_value_set_object (value, geary_email_get_header (self));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_BODY_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		g_value_set_object (value, geary_email_get_body (self));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_ATTACHMENTS_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		g_value_set_object (value, geary_email_get_attachments (self));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_PREVIEW_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		g_value_set_object (value, geary_email_get_preview (self));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_PROPERTIES_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		g_value_set_object (value, geary_email_get_properties (self));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_EMAIL_FLAGS_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		g_value_set_object (value, geary_email_get_email_flags (self));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_FIELDS_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		g_value_set_enum (value, geary_email_get_fields (self));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 3053 "geary-email.c"
		default:
#line 29 "../src/engine/api/geary-email.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 3059 "geary-email.c"
	}
}

static void
_vala_geary_email_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	GearyEmail * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_EMAIL, GearyEmail);
#line 29 "../src/engine/api/geary-email.vala"
	switch (property_id) {
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_ID_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		geary_email_set_id (self, g_value_get_object (value));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_HEADER_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		geary_email_set_header (self, g_value_get_object (value));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_BODY_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		geary_email_set_body (self, g_value_get_object (value));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_ATTACHMENTS_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		geary_email_set_attachments (self, g_value_get_object (value));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_PREVIEW_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		geary_email_set_preview (self, g_value_get_object (value));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_PROPERTIES_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		geary_email_set_properties (self, g_value_get_object (value));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_EMAIL_FLAGS_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		geary_email_set_email_flags (self, g_value_get_object (value));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 29 "../src/engine/api/geary-email.vala"
		case GEARY_EMAIL_FIELDS_PROPERTY:
#line 29 "../src/engine/api/geary-email.vala"
		geary_email_set_fields (self, g_value_get_enum (value));
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 3121 "geary-email.c"
		default:
#line 29 "../src/engine/api/geary-email.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/engine/api/geary-email.vala"
		break;
#line 3127 "geary-email.c"
	}
}

