/* geary-endpoint.c generated by valac 0.56.17, the Vala compiler
 * generated from geary-endpoint.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2018 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_ENDPOINT_0_PROPERTY,
	GEARY_ENDPOINT_REMOTE_PROPERTY,
	GEARY_ENDPOINT_CONNECTIVITY_PROPERTY,
	GEARY_ENDPOINT_TIMEOUT_SEC_PROPERTY,
	GEARY_ENDPOINT_TLS_METHOD_PROPERTY,
	GEARY_ENDPOINT_TLS_VALIDATION_WARNINGS_PROPERTY,
	GEARY_ENDPOINT_UNTRUSTED_CERTIFICATE_PROPERTY,
	GEARY_ENDPOINT_NUM_PROPERTIES
};
static GParamSpec* geary_endpoint_properties[GEARY_ENDPOINT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _GearyEndpointConnectAsyncData GearyEndpointConnectAsyncData;
typedef struct _GearyEndpointStarttlsHandshakeAsyncData GearyEndpointStarttlsHandshakeAsyncData;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _Block4Data Block4Data;
enum  {
	GEARY_ENDPOINT_UNTRUSTED_HOST_SIGNAL,
	GEARY_ENDPOINT_NUM_SIGNALS
};
static guint geary_endpoint_signals[GEARY_ENDPOINT_NUM_SIGNALS] = {0};

struct _GearyEndpointPrivate {
	GSocketConnectable* _remote;
	GearyConnectivityManager* _connectivity;
	guint _timeout_sec;
	GearyTlsNegotiationMethod _tls_method;
	GTlsCertificateFlags _tls_validation_warnings;
	GTlsCertificate* _untrusted_certificate;
	GSocketClient* socket_client;
};

struct _GearyEndpointConnectAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyEndpoint* self;
	GCancellable* cancellable;
	GSocketConnection* result;
	GSocketClient* client;
	GSocketClient* _tmp0_;
	GError* connect_error;
	GSocketConnection* _tmp1_;
	GSocketClient* _tmp2_;
	GSocketConnectable* _tmp3_;
	GSocketConnection* _tmp4_;
	GSocketConnection* _tmp5_;
	GError* err;
	GError* _tmp6_;
	GError* _tmp7_;
	GSocketAddressEnumerator* addrs;
	GSocketConnectable* _tmp8_;
	GSocketAddressEnumerator* _tmp9_;
	GSocketAddress* addr;
	GSocketAddressEnumerator* _tmp10_;
	GSocketAddress* _tmp11_;
	GSocketAddress* _tmp12_;
	GInetSocketAddress* inet_addr;
	GSocketAddress* _tmp13_;
	GInetSocketAddress* _tmp14_;
	GInetSocketAddress* _tmp15_;
	GSocketConnection* _tmp16_;
	GSocketClient* _tmp17_;
	GInetSocketAddress* _tmp18_;
	GInetAddress* _tmp19_;
	GInetAddress* _tmp20_;
	GInetSocketAddress* _tmp21_;
	guint _tmp22_;
	guint _tmp23_;
	GInetSocketAddress* _tmp24_;
	GInetSocketAddress* _tmp25_;
	GSocketConnection* _tmp26_;
	GSocketConnection* _tmp27_;
	GSocketConnection* _tmp28_;
	GSocketAddress* _tmp29_;
	GSocketAddressEnumerator* _tmp30_;
	GSocketAddress* _tmp31_;
	GSocketAddress* _tmp32_;
	GError* _tmp33_;
	GError* _tmp34_;
	GError* _inner_error0_;
};

struct _GearyEndpointStarttlsHandshakeAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyEndpoint* self;
	GIOStream* base_stream;
	GCancellable* cancellable;
	GTlsClientConnection* result;
	GTlsClientConnection* tls_cx;
	GSocketConnectable* _tmp0_;
	GTlsClientConnection* _tmp1_;
	GTlsClientConnection* _tmp2_;
	GTlsClientConnection* _tmp3_;
	GError* _inner_error0_;
};

struct _Block4Data {
	int _ref_count_;
	GearyEndpoint* self;
	GTlsConnection* cx;
	GTlsCertificate* cert;
	GTlsCertificateFlags flags;
};

static gint GearyEndpoint_private_offset;
static gpointer geary_endpoint_parent_class = NULL;
GTlsDatabase* geary_endpoint_default_tls_database = NULL;

static void geary_endpoint_set_remote (GearyEndpoint* self,
                                GSocketConnectable* value);
static void geary_endpoint_set_connectivity (GearyEndpoint* self,
                                      GearyConnectivityManager* value);
static void geary_endpoint_set_timeout_sec (GearyEndpoint* self,
                                     guint value);
static void geary_endpoint_set_tls_method (GearyEndpoint* self,
                                    GearyTlsNegotiationMethod value);
static void geary_endpoint_set_tls_validation_warnings (GearyEndpoint* self,
                                                 GTlsCertificateFlags value);
static void geary_endpoint_set_untrusted_certificate (GearyEndpoint* self,
                                               GTlsCertificate* value);
static void geary_endpoint_connect_async_data_free (gpointer _data);
static gboolean geary_endpoint_connect_async_co (GearyEndpointConnectAsyncData* _data_);
static GSocketClient* geary_endpoint_get_socket_client (GearyEndpoint* self);
static void geary_endpoint_connect_async_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_);
static void geary_endpoint_starttls_handshake_async_data_free (gpointer _data);
static gboolean geary_endpoint_starttls_handshake_async_co (GearyEndpointStarttlsHandshakeAsyncData* _data_);
static void geary_endpoint_prepare_tls_cx (GearyEndpoint* self,
                                    GTlsClientConnection* tls_cx);
static void geary_endpoint_starttls_handshake_async_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_);
static void geary_endpoint_on_socket_client_event (GearyEndpoint* self,
                                            GSocketClientEvent event,
                                            GSocketConnectable* connectable,
                                            GIOStream* ios);
static void _geary_endpoint_on_socket_client_event_g_socket_client_event (GSocketClient* _sender,
                                                                   GSocketClientEvent event,
                                                                   GSocketConnectable* connectable,
                                                                   GIOStream* connection,
                                                                   gpointer self);
static gboolean geary_endpoint_on_accept_certificate (GearyEndpoint* self,
                                               GTlsConnection* cx,
                                               GTlsCertificate* cert,
                                               GTlsCertificateFlags flags);
static gboolean _geary_endpoint_on_accept_certificate_g_tls_connection_accept_certificate (GTlsConnection* _sender,
                                                                                    GTlsCertificate* peer_cert,
                                                                                    GTlsCertificateFlags errors,
                                                                                    gpointer self);
static void geary_endpoint_report_tls_warnings (GearyEndpoint* self,
                                         GTlsConnection* cx,
                                         GTlsCertificate* cert,
                                         GTlsCertificateFlags warnings);
static gchar* geary_endpoint_tls_flags_to_string (GearyEndpoint* self,
                                           GTlsCertificateFlags flags);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static gboolean __lambda47_ (Block4Data* _data4_);
static gboolean ___lambda47__gsource_func (gpointer self);
static void geary_endpoint_finalize (GObject * obj);
static GType geary_endpoint_get_type_once (void);
static void _vala_geary_endpoint_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_geary_endpoint_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);

static inline gpointer
geary_endpoint_get_instance_private (GearyEndpoint* self)
{
	return G_STRUCT_MEMBER_P (self, GearyEndpoint_private_offset);
}

/** Returns {@link GLib.TlsCertificateFlags} as a string. */
gchar*
geary_endpoint_tls_flag_to_string (GTlsCertificateFlags flag)
{
	gchar* result;
#line 29 "../src/engine/api/geary-endpoint.vala"
	switch (flag) {
#line 29 "../src/engine/api/geary-endpoint.vala"
		case G_TLS_CERTIFICATE_BAD_IDENTITY:
#line 222 "geary-endpoint.c"
		{
			gchar* _tmp0_;
#line 31 "../src/engine/api/geary-endpoint.vala"
			_tmp0_ = g_strdup ("BAD_IDENTITY");
#line 31 "../src/engine/api/geary-endpoint.vala"
			result = _tmp0_;
#line 31 "../src/engine/api/geary-endpoint.vala"
			return result;
#line 231 "geary-endpoint.c"
		}
#line 29 "../src/engine/api/geary-endpoint.vala"
		case G_TLS_CERTIFICATE_EXPIRED:
#line 235 "geary-endpoint.c"
		{
			gchar* _tmp1_;
#line 34 "../src/engine/api/geary-endpoint.vala"
			_tmp1_ = g_strdup ("EXPIRED");
#line 34 "../src/engine/api/geary-endpoint.vala"
			result = _tmp1_;
#line 34 "../src/engine/api/geary-endpoint.vala"
			return result;
#line 244 "geary-endpoint.c"
		}
#line 29 "../src/engine/api/geary-endpoint.vala"
		case G_TLS_CERTIFICATE_GENERIC_ERROR:
#line 248 "geary-endpoint.c"
		{
			gchar* _tmp2_;
#line 37 "../src/engine/api/geary-endpoint.vala"
			_tmp2_ = g_strdup ("GENERIC_ERROR");
#line 37 "../src/engine/api/geary-endpoint.vala"
			result = _tmp2_;
#line 37 "../src/engine/api/geary-endpoint.vala"
			return result;
#line 257 "geary-endpoint.c"
		}
#line 29 "../src/engine/api/geary-endpoint.vala"
		case G_TLS_CERTIFICATE_INSECURE:
#line 261 "geary-endpoint.c"
		{
			gchar* _tmp3_;
#line 40 "../src/engine/api/geary-endpoint.vala"
			_tmp3_ = g_strdup ("INSECURE");
#line 40 "../src/engine/api/geary-endpoint.vala"
			result = _tmp3_;
#line 40 "../src/engine/api/geary-endpoint.vala"
			return result;
#line 270 "geary-endpoint.c"
		}
#line 29 "../src/engine/api/geary-endpoint.vala"
		case G_TLS_CERTIFICATE_NOT_ACTIVATED:
#line 274 "geary-endpoint.c"
		{
			gchar* _tmp4_;
#line 43 "../src/engine/api/geary-endpoint.vala"
			_tmp4_ = g_strdup ("NOT_ACTIVATED");
#line 43 "../src/engine/api/geary-endpoint.vala"
			result = _tmp4_;
#line 43 "../src/engine/api/geary-endpoint.vala"
			return result;
#line 283 "geary-endpoint.c"
		}
#line 29 "../src/engine/api/geary-endpoint.vala"
		case G_TLS_CERTIFICATE_REVOKED:
#line 287 "geary-endpoint.c"
		{
			gchar* _tmp5_;
#line 46 "../src/engine/api/geary-endpoint.vala"
			_tmp5_ = g_strdup ("REVOKED");
#line 46 "../src/engine/api/geary-endpoint.vala"
			result = _tmp5_;
#line 46 "../src/engine/api/geary-endpoint.vala"
			return result;
#line 296 "geary-endpoint.c"
		}
#line 29 "../src/engine/api/geary-endpoint.vala"
		case G_TLS_CERTIFICATE_UNKNOWN_CA:
#line 300 "geary-endpoint.c"
		{
			gchar* _tmp6_;
#line 49 "../src/engine/api/geary-endpoint.vala"
			_tmp6_ = g_strdup ("UNKNOWN_CA");
#line 49 "../src/engine/api/geary-endpoint.vala"
			result = _tmp6_;
#line 49 "../src/engine/api/geary-endpoint.vala"
			return result;
#line 309 "geary-endpoint.c"
		}
		default:
		{
			gchar* _tmp7_;
#line 52 "../src/engine/api/geary-endpoint.vala"
			_tmp7_ = g_strdup_printf ("(unknown=%Xh)", (guint) flag);
#line 52 "../src/engine/api/geary-endpoint.vala"
			result = _tmp7_;
#line 52 "../src/engine/api/geary-endpoint.vala"
			return result;
#line 320 "geary-endpoint.c"
		}
	}
}

GSocketConnectable*
geary_endpoint_get_remote (GearyEndpoint* self)
{
	GSocketConnectable* result;
	GSocketConnectable* _tmp0_;
#line 58 "../src/engine/api/geary-endpoint.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (self), NULL);
#line 58 "../src/engine/api/geary-endpoint.vala"
	_tmp0_ = self->priv->_remote;
#line 58 "../src/engine/api/geary-endpoint.vala"
	result = _tmp0_;
#line 58 "../src/engine/api/geary-endpoint.vala"
	return result;
#line 338 "geary-endpoint.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 58 "../src/engine/api/geary-endpoint.vala"
	return self ? g_object_ref (self) : NULL;
#line 346 "geary-endpoint.c"
}

static void
geary_endpoint_set_remote (GearyEndpoint* self,
                           GSocketConnectable* value)
{
	GSocketConnectable* old_value;
#line 58 "../src/engine/api/geary-endpoint.vala"
	g_return_if_fail (GEARY_IS_ENDPOINT (self));
#line 58 "../src/engine/api/geary-endpoint.vala"
	old_value = geary_endpoint_get_remote (self);
#line 58 "../src/engine/api/geary-endpoint.vala"
	if (old_value != value) {
#line 360 "geary-endpoint.c"
		GSocketConnectable* _tmp0_;
#line 58 "../src/engine/api/geary-endpoint.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 58 "../src/engine/api/geary-endpoint.vala"
		_g_object_unref0 (self->priv->_remote);
#line 58 "../src/engine/api/geary-endpoint.vala"
		self->priv->_remote = _tmp0_;
#line 58 "../src/engine/api/geary-endpoint.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_endpoint_properties[GEARY_ENDPOINT_REMOTE_PROPERTY]);
#line 370 "geary-endpoint.c"
	}
}

GearyConnectivityManager*
geary_endpoint_get_connectivity (GearyEndpoint* self)
{
	GearyConnectivityManager* result;
	GearyConnectivityManager* _tmp0_;
#line 61 "../src/engine/api/geary-endpoint.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (self), NULL);
#line 61 "../src/engine/api/geary-endpoint.vala"
	_tmp0_ = self->priv->_connectivity;
#line 61 "../src/engine/api/geary-endpoint.vala"
	result = _tmp0_;
#line 61 "../src/engine/api/geary-endpoint.vala"
	return result;
#line 387 "geary-endpoint.c"
}

static void
geary_endpoint_set_connectivity (GearyEndpoint* self,
                                 GearyConnectivityManager* value)
{
	GearyConnectivityManager* old_value;
#line 61 "../src/engine/api/geary-endpoint.vala"
	g_return_if_fail (GEARY_IS_ENDPOINT (self));
#line 61 "../src/engine/api/geary-endpoint.vala"
	old_value = geary_endpoint_get_connectivity (self);
#line 61 "../src/engine/api/geary-endpoint.vala"
	if (old_value != value) {
#line 401 "geary-endpoint.c"
		GearyConnectivityManager* _tmp0_;
#line 61 "../src/engine/api/geary-endpoint.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 61 "../src/engine/api/geary-endpoint.vala"
		_g_object_unref0 (self->priv->_connectivity);
#line 61 "../src/engine/api/geary-endpoint.vala"
		self->priv->_connectivity = _tmp0_;
#line 61 "../src/engine/api/geary-endpoint.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_endpoint_properties[GEARY_ENDPOINT_CONNECTIVITY_PROPERTY]);
#line 411 "geary-endpoint.c"
	}
}

guint
geary_endpoint_get_timeout_sec (GearyEndpoint* self)
{
	guint result;
#line 64 "../src/engine/api/geary-endpoint.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (self), 0U);
#line 64 "../src/engine/api/geary-endpoint.vala"
	result = self->priv->_timeout_sec;
#line 64 "../src/engine/api/geary-endpoint.vala"
	return result;
#line 425 "geary-endpoint.c"
}

static void
geary_endpoint_set_timeout_sec (GearyEndpoint* self,
                                guint value)
{
	guint old_value;
#line 64 "../src/engine/api/geary-endpoint.vala"
	g_return_if_fail (GEARY_IS_ENDPOINT (self));
#line 64 "../src/engine/api/geary-endpoint.vala"
	old_value = geary_endpoint_get_timeout_sec (self);
#line 64 "../src/engine/api/geary-endpoint.vala"
	if (old_value != value) {
#line 64 "../src/engine/api/geary-endpoint.vala"
		self->priv->_timeout_sec = value;
#line 64 "../src/engine/api/geary-endpoint.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_endpoint_properties[GEARY_ENDPOINT_TIMEOUT_SEC_PROPERTY]);
#line 443 "geary-endpoint.c"
	}
}

GearyTlsNegotiationMethod
geary_endpoint_get_tls_method (GearyEndpoint* self)
{
	GearyTlsNegotiationMethod result;
#line 67 "../src/engine/api/geary-endpoint.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (self), 0);
#line 67 "../src/engine/api/geary-endpoint.vala"
	result = self->priv->_tls_method;
#line 67 "../src/engine/api/geary-endpoint.vala"
	return result;
#line 457 "geary-endpoint.c"
}

static void
geary_endpoint_set_tls_method (GearyEndpoint* self,
                               GearyTlsNegotiationMethod value)
{
	GearyTlsNegotiationMethod old_value;
#line 67 "../src/engine/api/geary-endpoint.vala"
	g_return_if_fail (GEARY_IS_ENDPOINT (self));
#line 67 "../src/engine/api/geary-endpoint.vala"
	old_value = geary_endpoint_get_tls_method (self);
#line 67 "../src/engine/api/geary-endpoint.vala"
	if (old_value != value) {
#line 67 "../src/engine/api/geary-endpoint.vala"
		self->priv->_tls_method = value;
#line 67 "../src/engine/api/geary-endpoint.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_endpoint_properties[GEARY_ENDPOINT_TLS_METHOD_PROPERTY]);
#line 475 "geary-endpoint.c"
	}
}

GTlsCertificateFlags
geary_endpoint_get_tls_validation_warnings (GearyEndpoint* self)
{
	GTlsCertificateFlags result;
#line 74 "../src/engine/api/geary-endpoint.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (self), 0U);
#line 74 "../src/engine/api/geary-endpoint.vala"
	result = self->priv->_tls_validation_warnings;
#line 74 "../src/engine/api/geary-endpoint.vala"
	return result;
#line 489 "geary-endpoint.c"
}

static void
geary_endpoint_set_tls_validation_warnings (GearyEndpoint* self,
                                            GTlsCertificateFlags value)
{
	GTlsCertificateFlags old_value;
#line 74 "../src/engine/api/geary-endpoint.vala"
	g_return_if_fail (GEARY_IS_ENDPOINT (self));
#line 74 "../src/engine/api/geary-endpoint.vala"
	old_value = geary_endpoint_get_tls_validation_warnings (self);
#line 74 "../src/engine/api/geary-endpoint.vala"
	if (old_value != value) {
#line 74 "../src/engine/api/geary-endpoint.vala"
		self->priv->_tls_validation_warnings = value;
#line 74 "../src/engine/api/geary-endpoint.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_endpoint_properties[GEARY_ENDPOINT_TLS_VALIDATION_WARNINGS_PROPERTY]);
#line 507 "geary-endpoint.c"
	}
}

GTlsCertificate*
geary_endpoint_get_untrusted_certificate (GearyEndpoint* self)
{
	GTlsCertificate* result;
	GTlsCertificate* _tmp0_;
#line 79 "../src/engine/api/geary-endpoint.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (self), NULL);
#line 79 "../src/engine/api/geary-endpoint.vala"
	_tmp0_ = self->priv->_untrusted_certificate;
#line 79 "../src/engine/api/geary-endpoint.vala"
	result = _tmp0_;
#line 79 "../src/engine/api/geary-endpoint.vala"
	return result;
#line 524 "geary-endpoint.c"
}

static void
geary_endpoint_set_untrusted_certificate (GearyEndpoint* self,
                                          GTlsCertificate* value)
{
	GTlsCertificate* old_value;
#line 79 "../src/engine/api/geary-endpoint.vala"
	g_return_if_fail (GEARY_IS_ENDPOINT (self));
#line 79 "../src/engine/api/geary-endpoint.vala"
	old_value = geary_endpoint_get_untrusted_certificate (self);
#line 79 "../src/engine/api/geary-endpoint.vala"
	if (old_value != value) {
#line 538 "geary-endpoint.c"
		GTlsCertificate* _tmp0_;
#line 79 "../src/engine/api/geary-endpoint.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 79 "../src/engine/api/geary-endpoint.vala"
		_g_object_unref0 (self->priv->_untrusted_certificate);
#line 79 "../src/engine/api/geary-endpoint.vala"
		self->priv->_untrusted_certificate = _tmp0_;
#line 79 "../src/engine/api/geary-endpoint.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_endpoint_properties[GEARY_ENDPOINT_UNTRUSTED_CERTIFICATE_PROPERTY]);
#line 548 "geary-endpoint.c"
	}
}

GearyEndpoint*
geary_endpoint_construct (GType object_type,
                          GSocketConnectable* remote,
                          GearyTlsNegotiationMethod method,
                          guint timeout_sec)
{
	GearyEndpoint * self = NULL;
	GSocketConnectable* _tmp0_;
	GearyConnectivityManager* _tmp1_;
	GearyConnectivityManager* _tmp2_;
#line 100 "../src/engine/api/geary-endpoint.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (remote, g_socket_connectable_get_type ()), NULL);
#line 100 "../src/engine/api/geary-endpoint.vala"
	self = (GearyEndpoint*) geary_base_object_construct (object_type);
#line 103 "../src/engine/api/geary-endpoint.vala"
	geary_endpoint_set_remote (self, remote);
#line 104 "../src/engine/api/geary-endpoint.vala"
	_tmp0_ = self->priv->_remote;
#line 104 "../src/engine/api/geary-endpoint.vala"
	_tmp1_ = geary_connectivity_manager_new (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_network_address_get_type (), GNetworkAddress), g_socket_connectable_get_type (), GSocketConnectable));
#line 104 "../src/engine/api/geary-endpoint.vala"
	_tmp2_ = _tmp1_;
#line 104 "../src/engine/api/geary-endpoint.vala"
	geary_endpoint_set_connectivity (self, _tmp2_);
#line 104 "../src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (_tmp2_);
#line 105 "../src/engine/api/geary-endpoint.vala"
	geary_endpoint_set_timeout_sec (self, timeout_sec);
#line 106 "../src/engine/api/geary-endpoint.vala"
	geary_endpoint_set_tls_method (self, method);
#line 100 "../src/engine/api/geary-endpoint.vala"
	return self;
#line 584 "geary-endpoint.c"
}

GearyEndpoint*
geary_endpoint_new (GSocketConnectable* remote,
                    GearyTlsNegotiationMethod method,
                    guint timeout_sec)
{
#line 100 "../src/engine/api/geary-endpoint.vala"
	return geary_endpoint_construct (GEARY_TYPE_ENDPOINT, remote, method, timeout_sec);
#line 594 "geary-endpoint.c"
}

static void
geary_endpoint_connect_async_data_free (gpointer _data)
{
	GearyEndpointConnectAsyncData* _data_;
	_data_ = _data;
#line 12 "../src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (_data_->cancellable);
#line 12 "../src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (_data_->result);
#line 12 "../src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (_data_->self);
#line 12 "../src/engine/api/geary-endpoint.vala"
	g_slice_free (GearyEndpointConnectAsyncData, _data_);
#line 610 "geary-endpoint.c"
}

void
geary_endpoint_connect_async (GearyEndpoint* self,
                              GCancellable* cancellable,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	GearyEndpointConnectAsyncData* _data_;
	GearyEndpoint* _tmp0_;
	GCancellable* _tmp1_;
#line 12 "../src/engine/api/geary-endpoint.vala"
	g_return_if_fail (GEARY_IS_ENDPOINT (self));
#line 12 "../src/engine/api/geary-endpoint.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 12 "../src/engine/api/geary-endpoint.vala"
	_data_ = g_slice_new0 (GearyEndpointConnectAsyncData);
#line 12 "../src/engine/api/geary-endpoint.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 12 "../src/engine/api/geary-endpoint.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_endpoint_connect_async_data_free);
#line 12 "../src/engine/api/geary-endpoint.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 12 "../src/engine/api/geary-endpoint.vala"
	_data_->self = _tmp0_;
#line 12 "../src/engine/api/geary-endpoint.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 12 "../src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (_data_->cancellable);
#line 12 "../src/engine/api/geary-endpoint.vala"
	_data_->cancellable = _tmp1_;
#line 12 "../src/engine/api/geary-endpoint.vala"
	geary_endpoint_connect_async_co (_data_);
#line 644 "geary-endpoint.c"
}

GSocketConnection*
geary_endpoint_connect_finish (GearyEndpoint* self,
                               GAsyncResult* _res_,
                               GError** error)
{
	GSocketConnection* result;
	GearyEndpointConnectAsyncData* _data_;
#line 12 "../src/engine/api/geary-endpoint.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 12 "../src/engine/api/geary-endpoint.vala"
	if (NULL == _data_) {
#line 12 "../src/engine/api/geary-endpoint.vala"
		return NULL;
#line 660 "geary-endpoint.c"
	}
#line 12 "../src/engine/api/geary-endpoint.vala"
	result = _data_->result;
#line 12 "../src/engine/api/geary-endpoint.vala"
	_data_->result = NULL;
#line 12 "../src/engine/api/geary-endpoint.vala"
	return result;
#line 668 "geary-endpoint.c"
}

static void
geary_endpoint_connect_async_ready (GObject* source_object,
                                    GAsyncResult* _res_,
                                    gpointer _user_data_)
{
	GearyEndpointConnectAsyncData* _data_;
#line 114 "../src/engine/api/geary-endpoint.vala"
	_data_ = _user_data_;
#line 114 "../src/engine/api/geary-endpoint.vala"
	_data_->_source_object_ = source_object;
#line 114 "../src/engine/api/geary-endpoint.vala"
	_data_->_res_ = _res_;
#line 114 "../src/engine/api/geary-endpoint.vala"
	geary_endpoint_connect_async_co (_data_);
#line 685 "geary-endpoint.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 116 "../src/engine/api/geary-endpoint.vala"
	return self ? g_error_copy (self) : NULL;
#line 693 "geary-endpoint.c"
}

static gboolean
geary_endpoint_connect_async_co (GearyEndpointConnectAsyncData* _data_)
{
#line 109 "../src/engine/api/geary-endpoint.vala"
	switch (_data_->_state_) {
#line 109 "../src/engine/api/geary-endpoint.vala"
		case 0:
#line 703 "geary-endpoint.c"
		goto _state_0;
#line 109 "../src/engine/api/geary-endpoint.vala"
		case 1:
#line 707 "geary-endpoint.c"
		goto _state_1;
#line 109 "../src/engine/api/geary-endpoint.vala"
		case 2:
#line 711 "geary-endpoint.c"
		goto _state_2;
#line 109 "../src/engine/api/geary-endpoint.vala"
		case 3:
#line 715 "geary-endpoint.c"
		goto _state_3;
#line 109 "../src/engine/api/geary-endpoint.vala"
		case 4:
#line 719 "geary-endpoint.c"
		goto _state_4;
		default:
#line 109 "../src/engine/api/geary-endpoint.vala"
		g_assert_not_reached ();
#line 724 "geary-endpoint.c"
	}
	_state_0:
#line 111 "../src/engine/api/geary-endpoint.vala"
	_data_->_tmp0_ = geary_endpoint_get_socket_client (_data_->self);
#line 111 "../src/engine/api/geary-endpoint.vala"
	_data_->client = _data_->_tmp0_;
#line 112 "../src/engine/api/geary-endpoint.vala"
	_data_->connect_error = NULL;
#line 733 "geary-endpoint.c"
	{
#line 114 "../src/engine/api/geary-endpoint.vala"
		_data_->_tmp2_ = _data_->client;
#line 114 "../src/engine/api/geary-endpoint.vala"
		_data_->_tmp3_ = _data_->self->priv->_remote;
#line 114 "../src/engine/api/geary-endpoint.vala"
		_data_->_state_ = 1;
#line 114 "../src/engine/api/geary-endpoint.vala"
		g_socket_client_connect_async (_data_->_tmp2_, _data_->_tmp3_, _data_->cancellable, geary_endpoint_connect_async_ready, _data_);
#line 114 "../src/engine/api/geary-endpoint.vala"
		return FALSE;
#line 745 "geary-endpoint.c"
		_state_1:
#line 114 "../src/engine/api/geary-endpoint.vala"
		_data_->_tmp4_ = g_socket_client_connect_finish (_data_->_tmp2_, _data_->_res_, &_data_->_inner_error0_);
#line 114 "../src/engine/api/geary-endpoint.vala"
		_data_->_tmp1_ = _data_->_tmp4_;
#line 114 "../src/engine/api/geary-endpoint.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 114 "../src/engine/api/geary-endpoint.vala"
			if (g_error_matches (_data_->_inner_error0_, G_IO_ERROR, G_IO_ERROR_NETWORK_UNREACHABLE)) {
#line 755 "geary-endpoint.c"
				goto __catch0_g_io_error_network_unreachable;
			}
			goto __finally0;
		}
#line 114 "../src/engine/api/geary-endpoint.vala"
		_data_->_tmp5_ = _data_->_tmp1_;
#line 114 "../src/engine/api/geary-endpoint.vala"
		_data_->_tmp1_ = NULL;
#line 114 "../src/engine/api/geary-endpoint.vala"
		_data_->result = _data_->_tmp5_;
#line 114 "../src/engine/api/geary-endpoint.vala"
		_g_object_unref0 (_data_->_tmp1_);
#line 114 "../src/engine/api/geary-endpoint.vala"
		_g_error_free0 (_data_->connect_error);
#line 114 "../src/engine/api/geary-endpoint.vala"
		_g_object_unref0 (_data_->client);
#line 114 "../src/engine/api/geary-endpoint.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 114 "../src/engine/api/geary-endpoint.vala"
		if (_data_->_state_ != 0) {
#line 114 "../src/engine/api/geary-endpoint.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 114 "../src/engine/api/geary-endpoint.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 780 "geary-endpoint.c"
			}
		}
#line 114 "../src/engine/api/geary-endpoint.vala"
		g_object_unref (_data_->_async_result);
#line 114 "../src/engine/api/geary-endpoint.vala"
		return FALSE;
#line 787 "geary-endpoint.c"
	}
	goto __finally0;
	__catch0_g_io_error_network_unreachable:
	{
#line 113 "../src/engine/api/geary-endpoint.vala"
		_data_->err = _data_->_inner_error0_;
#line 113 "../src/engine/api/geary-endpoint.vala"
		_data_->_inner_error0_ = NULL;
#line 116 "../src/engine/api/geary-endpoint.vala"
		_data_->_tmp6_ = _data_->err;
#line 116 "../src/engine/api/geary-endpoint.vala"
		_data_->_tmp7_ = _g_error_copy0 (_data_->_tmp6_);
#line 116 "../src/engine/api/geary-endpoint.vala"
		_g_error_free0 (_data_->connect_error);
#line 116 "../src/engine/api/geary-endpoint.vala"
		_data_->connect_error = _data_->_tmp7_;
#line 113 "../src/engine/api/geary-endpoint.vala"
		_g_error_free0 (_data_->err);
#line 806 "geary-endpoint.c"
	}
	__finally0:
#line 113 "../src/engine/api/geary-endpoint.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 113 "../src/engine/api/geary-endpoint.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 113 "../src/engine/api/geary-endpoint.vala"
		_g_error_free0 (_data_->connect_error);
#line 113 "../src/engine/api/geary-endpoint.vala"
		_g_object_unref0 (_data_->client);
#line 113 "../src/engine/api/geary-endpoint.vala"
		g_object_unref (_data_->_async_result);
#line 113 "../src/engine/api/geary-endpoint.vala"
		return FALSE;
#line 821 "geary-endpoint.c"
	}
#line 124 "../src/engine/api/geary-endpoint.vala"
	_data_->_tmp8_ = _data_->self->priv->_remote;
#line 124 "../src/engine/api/geary-endpoint.vala"
	_data_->_tmp9_ = g_socket_connectable_enumerate (_data_->_tmp8_);
#line 124 "../src/engine/api/geary-endpoint.vala"
	_data_->addrs = _data_->_tmp9_;
#line 125 "../src/engine/api/geary-endpoint.vala"
	_data_->_tmp10_ = _data_->addrs;
#line 125 "../src/engine/api/geary-endpoint.vala"
	_data_->_state_ = 2;
#line 125 "../src/engine/api/geary-endpoint.vala"
	g_socket_address_enumerator_next_async (_data_->_tmp10_, _data_->cancellable, geary_endpoint_connect_async_ready, _data_);
#line 125 "../src/engine/api/geary-endpoint.vala"
	return FALSE;
#line 837 "geary-endpoint.c"
	_state_2:
#line 125 "../src/engine/api/geary-endpoint.vala"
	_data_->_tmp11_ = g_socket_address_enumerator_next_finish (_data_->_tmp10_, _data_->_res_, &_data_->_inner_error0_);
#line 125 "../src/engine/api/geary-endpoint.vala"
	_data_->addr = _data_->_tmp11_;
#line 125 "../src/engine/api/geary-endpoint.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 125 "../src/engine/api/geary-endpoint.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 125 "../src/engine/api/geary-endpoint.vala"
		_g_object_unref0 (_data_->addrs);
#line 125 "../src/engine/api/geary-endpoint.vala"
		_g_error_free0 (_data_->connect_error);
#line 125 "../src/engine/api/geary-endpoint.vala"
		_g_object_unref0 (_data_->client);
#line 125 "../src/engine/api/geary-endpoint.vala"
		g_object_unref (_data_->_async_result);
#line 125 "../src/engine/api/geary-endpoint.vala"
		return FALSE;
#line 857 "geary-endpoint.c"
	}
#line 126 "../src/engine/api/geary-endpoint.vala"
	while (TRUE) {
#line 126 "../src/engine/api/geary-endpoint.vala"
		_data_->_tmp12_ = _data_->addr;
#line 126 "../src/engine/api/geary-endpoint.vala"
		if (!(_data_->_tmp12_ != NULL)) {
#line 126 "../src/engine/api/geary-endpoint.vala"
			break;
#line 867 "geary-endpoint.c"
		}
#line 127 "../src/engine/api/geary-endpoint.vala"
		_data_->_tmp13_ = _data_->addr;
#line 127 "../src/engine/api/geary-endpoint.vala"
		_data_->_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp13_, g_inet_socket_address_get_type ()) ? ((GInetSocketAddress*) _data_->_tmp13_) : NULL);
#line 127 "../src/engine/api/geary-endpoint.vala"
		_data_->inet_addr = _data_->_tmp14_;
#line 128 "../src/engine/api/geary-endpoint.vala"
		_data_->_tmp15_ = _data_->inet_addr;
#line 128 "../src/engine/api/geary-endpoint.vala"
		if (_data_->_tmp15_ != NULL) {
#line 879 "geary-endpoint.c"
			{
#line 130 "../src/engine/api/geary-endpoint.vala"
				_data_->_tmp17_ = _data_->client;
#line 130 "../src/engine/api/geary-endpoint.vala"
				_data_->_tmp18_ = _data_->inet_addr;
#line 130 "../src/engine/api/geary-endpoint.vala"
				_data_->_tmp19_ = g_inet_socket_address_get_address (_data_->_tmp18_);
#line 130 "../src/engine/api/geary-endpoint.vala"
				_data_->_tmp20_ = _data_->_tmp19_;
#line 130 "../src/engine/api/geary-endpoint.vala"
				_data_->_tmp21_ = _data_->inet_addr;
#line 130 "../src/engine/api/geary-endpoint.vala"
				_data_->_tmp22_ = g_inet_socket_address_get_port (_data_->_tmp21_);
#line 130 "../src/engine/api/geary-endpoint.vala"
				_data_->_tmp23_ = _data_->_tmp22_;
#line 130 "../src/engine/api/geary-endpoint.vala"
				_data_->_tmp24_ = (GInetSocketAddress*) g_inet_socket_address_new (_data_->_tmp20_, (guint16) _data_->_tmp23_);
#line 130 "../src/engine/api/geary-endpoint.vala"
				_data_->_tmp25_ = _data_->_tmp24_;
#line 130 "../src/engine/api/geary-endpoint.vala"
				_data_->_state_ = 3;
#line 130 "../src/engine/api/geary-endpoint.vala"
				g_socket_client_connect_async (_data_->_tmp17_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp25_, g_socket_connectable_get_type (), GSocketConnectable), _data_->cancellable, geary_endpoint_connect_async_ready, _data_);
#line 130 "../src/engine/api/geary-endpoint.vala"
				return FALSE;
#line 905 "geary-endpoint.c"
				_state_3:
#line 130 "../src/engine/api/geary-endpoint.vala"
				_data_->_tmp26_ = g_socket_client_connect_finish (_data_->_tmp17_, _data_->_res_, &_data_->_inner_error0_);
#line 130 "../src/engine/api/geary-endpoint.vala"
				_data_->_tmp27_ = _data_->_tmp26_;
#line 130 "../src/engine/api/geary-endpoint.vala"
				_g_object_unref0 (_data_->_tmp25_);
#line 130 "../src/engine/api/geary-endpoint.vala"
				_data_->_tmp16_ = _data_->_tmp27_;
#line 130 "../src/engine/api/geary-endpoint.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 130 "../src/engine/api/geary-endpoint.vala"
					if (g_error_matches (_data_->_inner_error0_, G_IO_ERROR, G_IO_ERROR_NETWORK_UNREACHABLE)) {
#line 919 "geary-endpoint.c"
						goto __catch1_g_io_error_network_unreachable;
					}
					goto __finally1;
				}
#line 130 "../src/engine/api/geary-endpoint.vala"
				_data_->_tmp28_ = _data_->_tmp16_;
#line 130 "../src/engine/api/geary-endpoint.vala"
				_data_->_tmp16_ = NULL;
#line 130 "../src/engine/api/geary-endpoint.vala"
				_data_->result = _data_->_tmp28_;
#line 130 "../src/engine/api/geary-endpoint.vala"
				_g_object_unref0 (_data_->_tmp16_);
#line 130 "../src/engine/api/geary-endpoint.vala"
				_g_object_unref0 (_data_->inet_addr);
#line 130 "../src/engine/api/geary-endpoint.vala"
				_g_object_unref0 (_data_->addr);
#line 130 "../src/engine/api/geary-endpoint.vala"
				_g_object_unref0 (_data_->addrs);
#line 130 "../src/engine/api/geary-endpoint.vala"
				_g_error_free0 (_data_->connect_error);
#line 130 "../src/engine/api/geary-endpoint.vala"
				_g_object_unref0 (_data_->client);
#line 130 "../src/engine/api/geary-endpoint.vala"
				g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 130 "../src/engine/api/geary-endpoint.vala"
				if (_data_->_state_ != 0) {
#line 130 "../src/engine/api/geary-endpoint.vala"
					while (!g_task_get_completed (_data_->_async_result)) {
#line 130 "../src/engine/api/geary-endpoint.vala"
						g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 950 "geary-endpoint.c"
					}
				}
#line 130 "../src/engine/api/geary-endpoint.vala"
				g_object_unref (_data_->_async_result);
#line 130 "../src/engine/api/geary-endpoint.vala"
				return FALSE;
#line 957 "geary-endpoint.c"
			}
			goto __finally1;
			__catch1_g_io_error_network_unreachable:
			{
#line 129 "../src/engine/api/geary-endpoint.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 964 "geary-endpoint.c"
			}
			__finally1:
#line 129 "../src/engine/api/geary-endpoint.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 129 "../src/engine/api/geary-endpoint.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 129 "../src/engine/api/geary-endpoint.vala"
				_g_object_unref0 (_data_->inet_addr);
#line 129 "../src/engine/api/geary-endpoint.vala"
				_g_object_unref0 (_data_->addr);
#line 129 "../src/engine/api/geary-endpoint.vala"
				_g_object_unref0 (_data_->addrs);
#line 129 "../src/engine/api/geary-endpoint.vala"
				_g_error_free0 (_data_->connect_error);
#line 129 "../src/engine/api/geary-endpoint.vala"
				_g_object_unref0 (_data_->client);
#line 129 "../src/engine/api/geary-endpoint.vala"
				g_object_unref (_data_->_async_result);
#line 129 "../src/engine/api/geary-endpoint.vala"
				return FALSE;
#line 985 "geary-endpoint.c"
			}
		}
#line 140 "../src/engine/api/geary-endpoint.vala"
		_data_->_tmp30_ = _data_->addrs;
#line 140 "../src/engine/api/geary-endpoint.vala"
		_data_->_state_ = 4;
#line 140 "../src/engine/api/geary-endpoint.vala"
		g_socket_address_enumerator_next_async (_data_->_tmp30_, _data_->cancellable, geary_endpoint_connect_async_ready, _data_);
#line 140 "../src/engine/api/geary-endpoint.vala"
		return FALSE;
#line 996 "geary-endpoint.c"
		_state_4:
#line 140 "../src/engine/api/geary-endpoint.vala"
		_data_->_tmp31_ = g_socket_address_enumerator_next_finish (_data_->_tmp30_, _data_->_res_, &_data_->_inner_error0_);
#line 140 "../src/engine/api/geary-endpoint.vala"
		_data_->_tmp29_ = _data_->_tmp31_;
#line 140 "../src/engine/api/geary-endpoint.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 140 "../src/engine/api/geary-endpoint.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 140 "../src/engine/api/geary-endpoint.vala"
			_g_object_unref0 (_data_->inet_addr);
#line 140 "../src/engine/api/geary-endpoint.vala"
			_g_object_unref0 (_data_->addr);
#line 140 "../src/engine/api/geary-endpoint.vala"
			_g_object_unref0 (_data_->addrs);
#line 140 "../src/engine/api/geary-endpoint.vala"
			_g_error_free0 (_data_->connect_error);
#line 140 "../src/engine/api/geary-endpoint.vala"
			_g_object_unref0 (_data_->client);
#line 140 "../src/engine/api/geary-endpoint.vala"
			g_object_unref (_data_->_async_result);
#line 140 "../src/engine/api/geary-endpoint.vala"
			return FALSE;
#line 1020 "geary-endpoint.c"
		}
#line 140 "../src/engine/api/geary-endpoint.vala"
		_data_->_tmp32_ = _data_->_tmp29_;
#line 140 "../src/engine/api/geary-endpoint.vala"
		_data_->_tmp29_ = NULL;
#line 140 "../src/engine/api/geary-endpoint.vala"
		_g_object_unref0 (_data_->addr);
#line 140 "../src/engine/api/geary-endpoint.vala"
		_data_->addr = _data_->_tmp32_;
#line 126 "../src/engine/api/geary-endpoint.vala"
		_g_object_unref0 (_data_->_tmp29_);
#line 126 "../src/engine/api/geary-endpoint.vala"
		_g_object_unref0 (_data_->inet_addr);
#line 1034 "geary-endpoint.c"
	}
#line 143 "../src/engine/api/geary-endpoint.vala"
	_data_->_tmp33_ = _data_->connect_error;
#line 143 "../src/engine/api/geary-endpoint.vala"
	_data_->_tmp34_ = _g_error_copy0 (_data_->_tmp33_);
#line 143 "../src/engine/api/geary-endpoint.vala"
	_data_->_inner_error0_ = _data_->_tmp34_;
#line 143 "../src/engine/api/geary-endpoint.vala"
	g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 143 "../src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (_data_->addr);
#line 143 "../src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (_data_->addrs);
#line 143 "../src/engine/api/geary-endpoint.vala"
	_g_error_free0 (_data_->connect_error);
#line 143 "../src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (_data_->client);
#line 143 "../src/engine/api/geary-endpoint.vala"
	g_object_unref (_data_->_async_result);
#line 143 "../src/engine/api/geary-endpoint.vala"
	return FALSE;
#line 1056 "geary-endpoint.c"
}

static void
geary_endpoint_starttls_handshake_async_data_free (gpointer _data)
{
	GearyEndpointStarttlsHandshakeAsyncData* _data_;
	_data_ = _data;
#line 12 "../src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (_data_->base_stream);
#line 12 "../src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (_data_->cancellable);
#line 12 "../src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (_data_->result);
#line 12 "../src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (_data_->self);
#line 12 "../src/engine/api/geary-endpoint.vala"
	g_slice_free (GearyEndpointStarttlsHandshakeAsyncData, _data_);
#line 1074 "geary-endpoint.c"
}

void
geary_endpoint_starttls_handshake_async (GearyEndpoint* self,
                                         GIOStream* base_stream,
                                         GCancellable* cancellable,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	GearyEndpointStarttlsHandshakeAsyncData* _data_;
	GearyEndpoint* _tmp0_;
	GIOStream* _tmp1_;
	GCancellable* _tmp2_;
#line 12 "../src/engine/api/geary-endpoint.vala"
	g_return_if_fail (GEARY_IS_ENDPOINT (self));
#line 12 "../src/engine/api/geary-endpoint.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (base_stream, g_io_stream_get_type ()));
#line 12 "../src/engine/api/geary-endpoint.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 12 "../src/engine/api/geary-endpoint.vala"
	_data_ = g_slice_new0 (GearyEndpointStarttlsHandshakeAsyncData);
#line 12 "../src/engine/api/geary-endpoint.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 12 "../src/engine/api/geary-endpoint.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_endpoint_starttls_handshake_async_data_free);
#line 12 "../src/engine/api/geary-endpoint.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 12 "../src/engine/api/geary-endpoint.vala"
	_data_->self = _tmp0_;
#line 12 "../src/engine/api/geary-endpoint.vala"
	_tmp1_ = _g_object_ref0 (base_stream);
#line 12 "../src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (_data_->base_stream);
#line 12 "../src/engine/api/geary-endpoint.vala"
	_data_->base_stream = _tmp1_;
#line 12 "../src/engine/api/geary-endpoint.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 12 "../src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (_data_->cancellable);
#line 12 "../src/engine/api/geary-endpoint.vala"
	_data_->cancellable = _tmp2_;
#line 12 "../src/engine/api/geary-endpoint.vala"
	geary_endpoint_starttls_handshake_async_co (_data_);
#line 1118 "geary-endpoint.c"
}

GTlsClientConnection*
geary_endpoint_starttls_handshake_finish (GearyEndpoint* self,
                                          GAsyncResult* _res_,
                                          GError** error)
{
	GTlsClientConnection* result;
	GearyEndpointStarttlsHandshakeAsyncData* _data_;
#line 12 "../src/engine/api/geary-endpoint.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 12 "../src/engine/api/geary-endpoint.vala"
	if (NULL == _data_) {
#line 12 "../src/engine/api/geary-endpoint.vala"
		return NULL;
#line 1134 "geary-endpoint.c"
	}
#line 12 "../src/engine/api/geary-endpoint.vala"
	result = _data_->result;
#line 12 "../src/engine/api/geary-endpoint.vala"
	_data_->result = NULL;
#line 12 "../src/engine/api/geary-endpoint.vala"
	return result;
#line 1142 "geary-endpoint.c"
}

static void
geary_endpoint_starttls_handshake_async_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_)
{
	GearyEndpointStarttlsHandshakeAsyncData* _data_;
#line 153 "../src/engine/api/geary-endpoint.vala"
	_data_ = _user_data_;
#line 153 "../src/engine/api/geary-endpoint.vala"
	_data_->_source_object_ = source_object;
#line 153 "../src/engine/api/geary-endpoint.vala"
	_data_->_res_ = _res_;
#line 153 "../src/engine/api/geary-endpoint.vala"
	geary_endpoint_starttls_handshake_async_co (_data_);
#line 1159 "geary-endpoint.c"
}

static gboolean
geary_endpoint_starttls_handshake_async_co (GearyEndpointStarttlsHandshakeAsyncData* _data_)
{
#line 146 "../src/engine/api/geary-endpoint.vala"
	switch (_data_->_state_) {
#line 146 "../src/engine/api/geary-endpoint.vala"
		case 0:
#line 1169 "geary-endpoint.c"
		goto _state_0;
#line 146 "../src/engine/api/geary-endpoint.vala"
		case 1:
#line 1173 "geary-endpoint.c"
		goto _state_1;
		default:
#line 146 "../src/engine/api/geary-endpoint.vala"
		g_assert_not_reached ();
#line 1178 "geary-endpoint.c"
	}
	_state_0:
#line 148 "../src/engine/api/geary-endpoint.vala"
	_data_->_tmp0_ = _data_->self->priv->_remote;
#line 148 "../src/engine/api/geary-endpoint.vala"
	_data_->_tmp1_ = g_tls_client_connection_new (_data_->base_stream, _data_->_tmp0_, &_data_->_inner_error0_);
#line 148 "../src/engine/api/geary-endpoint.vala"
	_data_->tls_cx = _data_->_tmp1_;
#line 148 "../src/engine/api/geary-endpoint.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 148 "../src/engine/api/geary-endpoint.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 148 "../src/engine/api/geary-endpoint.vala"
		g_object_unref (_data_->_async_result);
#line 148 "../src/engine/api/geary-endpoint.vala"
		return FALSE;
#line 1195 "geary-endpoint.c"
	}
#line 151 "../src/engine/api/geary-endpoint.vala"
	_data_->_tmp2_ = _data_->tls_cx;
#line 151 "../src/engine/api/geary-endpoint.vala"
	geary_endpoint_prepare_tls_cx (_data_->self, _data_->_tmp2_);
#line 153 "../src/engine/api/geary-endpoint.vala"
	_data_->_tmp3_ = _data_->tls_cx;
#line 153 "../src/engine/api/geary-endpoint.vala"
	_data_->_state_ = 1;
#line 153 "../src/engine/api/geary-endpoint.vala"
	g_tls_connection_handshake_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, g_tls_connection_get_type (), GTlsConnection), G_PRIORITY_DEFAULT, _data_->cancellable, geary_endpoint_starttls_handshake_async_ready, _data_);
#line 153 "../src/engine/api/geary-endpoint.vala"
	return FALSE;
#line 1209 "geary-endpoint.c"
	_state_1:
#line 153 "../src/engine/api/geary-endpoint.vala"
	g_tls_connection_handshake_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, g_tls_connection_get_type (), GTlsConnection), _data_->_res_, &_data_->_inner_error0_);
#line 153 "../src/engine/api/geary-endpoint.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 153 "../src/engine/api/geary-endpoint.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 153 "../src/engine/api/geary-endpoint.vala"
		_g_object_unref0 (_data_->tls_cx);
#line 153 "../src/engine/api/geary-endpoint.vala"
		g_object_unref (_data_->_async_result);
#line 153 "../src/engine/api/geary-endpoint.vala"
		return FALSE;
#line 1223 "geary-endpoint.c"
	}
#line 155 "../src/engine/api/geary-endpoint.vala"
	_data_->result = _data_->tls_cx;
#line 155 "../src/engine/api/geary-endpoint.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 155 "../src/engine/api/geary-endpoint.vala"
	if (_data_->_state_ != 0) {
#line 155 "../src/engine/api/geary-endpoint.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 155 "../src/engine/api/geary-endpoint.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1235 "geary-endpoint.c"
		}
	}
#line 155 "../src/engine/api/geary-endpoint.vala"
	g_object_unref (_data_->_async_result);
#line 155 "../src/engine/api/geary-endpoint.vala"
	return FALSE;
#line 1242 "geary-endpoint.c"
}

gchar*
geary_endpoint_to_string (GearyEndpoint* self)
{
	GSocketConnectable* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 158 "../src/engine/api/geary-endpoint.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (self), NULL);
#line 159 "../src/engine/api/geary-endpoint.vala"
	_tmp0_ = self->priv->_remote;
#line 159 "../src/engine/api/geary-endpoint.vala"
	_tmp1_ = g_socket_connectable_to_string (_tmp0_);
#line 159 "../src/engine/api/geary-endpoint.vala"
	result = _tmp1_;
#line 159 "../src/engine/api/geary-endpoint.vala"
	return result;
#line 1261 "geary-endpoint.c"
}

static void
_geary_endpoint_on_socket_client_event_g_socket_client_event (GSocketClient* _sender,
                                                              GSocketClientEvent event,
                                                              GSocketConnectable* connectable,
                                                              GIOStream* connection,
                                                              gpointer self)
{
#line 170 "../src/engine/api/geary-endpoint.vala"
	geary_endpoint_on_socket_client_event ((GearyEndpoint*) self, event, connectable, connection);
#line 1273 "geary-endpoint.c"
}

static GSocketClient*
geary_endpoint_get_socket_client (GearyEndpoint* self)
{
	GSocketClient* _tmp0_;
	GSocketClient* _tmp3_;
	GearyTlsNegotiationMethod _tmp4_;
	GSocketClient* _tmp7_;
	guint _tmp8_;
	GSocketClient* _tmp9_;
	GSocketClient* _tmp10_;
	GSocketClient* result;
#line 162 "../src/engine/api/geary-endpoint.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (self), NULL);
#line 163 "../src/engine/api/geary-endpoint.vala"
	_tmp0_ = self->priv->socket_client;
#line 163 "../src/engine/api/geary-endpoint.vala"
	if (_tmp0_ != NULL) {
#line 1293 "geary-endpoint.c"
		GSocketClient* _tmp1_;
		GSocketClient* _tmp2_;
#line 164 "../src/engine/api/geary-endpoint.vala"
		_tmp1_ = self->priv->socket_client;
#line 164 "../src/engine/api/geary-endpoint.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 164 "../src/engine/api/geary-endpoint.vala"
		result = _tmp2_;
#line 164 "../src/engine/api/geary-endpoint.vala"
		return result;
#line 1304 "geary-endpoint.c"
	}
#line 166 "../src/engine/api/geary-endpoint.vala"
	_tmp3_ = g_socket_client_new ();
#line 166 "../src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (self->priv->socket_client);
#line 166 "../src/engine/api/geary-endpoint.vala"
	self->priv->socket_client = _tmp3_;
#line 168 "../src/engine/api/geary-endpoint.vala"
	_tmp4_ = self->priv->_tls_method;
#line 168 "../src/engine/api/geary-endpoint.vala"
	if (_tmp4_ == GEARY_TLS_NEGOTIATION_METHOD_TRANSPORT) {
#line 1316 "geary-endpoint.c"
		GSocketClient* _tmp5_;
		GSocketClient* _tmp6_;
#line 169 "../src/engine/api/geary-endpoint.vala"
		_tmp5_ = self->priv->socket_client;
#line 169 "../src/engine/api/geary-endpoint.vala"
		g_socket_client_set_tls (_tmp5_, TRUE);
#line 170 "../src/engine/api/geary-endpoint.vala"
		_tmp6_ = self->priv->socket_client;
#line 170 "../src/engine/api/geary-endpoint.vala"
		g_signal_connect_object (_tmp6_, "event", (GCallback) _geary_endpoint_on_socket_client_event_g_socket_client_event, self, 0);
#line 1327 "geary-endpoint.c"
	}
#line 173 "../src/engine/api/geary-endpoint.vala"
	_tmp7_ = self->priv->socket_client;
#line 173 "../src/engine/api/geary-endpoint.vala"
	_tmp8_ = self->priv->_timeout_sec;
#line 173 "../src/engine/api/geary-endpoint.vala"
	g_socket_client_set_timeout (_tmp7_, _tmp8_);
#line 175 "../src/engine/api/geary-endpoint.vala"
	_tmp9_ = self->priv->socket_client;
#line 175 "../src/engine/api/geary-endpoint.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 175 "../src/engine/api/geary-endpoint.vala"
	result = _tmp10_;
#line 175 "../src/engine/api/geary-endpoint.vala"
	return result;
#line 1343 "geary-endpoint.c"
}

static gboolean
_geary_endpoint_on_accept_certificate_g_tls_connection_accept_certificate (GTlsConnection* _sender,
                                                                           GTlsCertificate* peer_cert,
                                                                           GTlsCertificateFlags errors,
                                                                           gpointer self)
{
	gboolean result;
	result = geary_endpoint_on_accept_certificate ((GearyEndpoint*) self, _sender, peer_cert, errors);
#line 186 "../src/engine/api/geary-endpoint.vala"
	return result;
#line 1356 "geary-endpoint.c"
}

static void
geary_endpoint_prepare_tls_cx (GearyEndpoint* self,
                               GTlsClientConnection* tls_cx)
{
	GTlsDatabase* _tmp0_;
#line 178 "../src/engine/api/geary-endpoint.vala"
	g_return_if_fail (GEARY_IS_ENDPOINT (self));
#line 178 "../src/engine/api/geary-endpoint.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (tls_cx, g_tls_client_connection_get_type ()));
#line 182 "../src/engine/api/geary-endpoint.vala"
	_tmp0_ = geary_endpoint_default_tls_database;
#line 182 "../src/engine/api/geary-endpoint.vala"
	if (_tmp0_ != NULL) {
#line 1372 "geary-endpoint.c"
		GTlsDatabase* _tmp1_;
#line 183 "../src/engine/api/geary-endpoint.vala"
		_tmp1_ = geary_endpoint_default_tls_database;
#line 183 "../src/engine/api/geary-endpoint.vala"
		g_tls_connection_set_database (G_TYPE_CHECK_INSTANCE_CAST (tls_cx, g_tls_connection_get_type (), GTlsConnection), _tmp1_);
#line 1378 "geary-endpoint.c"
	}
#line 186 "../src/engine/api/geary-endpoint.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (tls_cx, g_tls_connection_get_type (), GTlsConnection), "accept-certificate", (GCallback) _geary_endpoint_on_accept_certificate_g_tls_connection_accept_certificate, self, 0);
#line 1382 "geary-endpoint.c"
}

static void
geary_endpoint_report_tls_warnings (GearyEndpoint* self,
                                    GTlsConnection* cx,
                                    GTlsCertificate* cert,
                                    GTlsCertificateFlags warnings)
{
	GearyTlsNegotiationMethod _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 189 "../src/engine/api/geary-endpoint.vala"
	g_return_if_fail (GEARY_IS_ENDPOINT (self));
#line 189 "../src/engine/api/geary-endpoint.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cx, g_tls_connection_get_type ()));
#line 189 "../src/engine/api/geary-endpoint.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cert, g_tls_certificate_get_type ()));
#line 194 "../src/engine/api/geary-endpoint.vala"
	_tmp0_ = self->priv->_tls_method;
#line 194 "../src/engine/api/geary-endpoint.vala"
	_tmp1_ = g_enum_to_string (GEARY_TYPE_TLS_NEGOTIATION_METHOD, _tmp0_);
#line 194 "../src/engine/api/geary-endpoint.vala"
	_tmp2_ = geary_endpoint_to_string (self);
#line 194 "../src/engine/api/geary-endpoint.vala"
	_tmp3_ = _tmp2_;
#line 194 "../src/engine/api/geary-endpoint.vala"
	_tmp4_ = geary_endpoint_tls_flags_to_string (self, warnings);
#line 194 "../src/engine/api/geary-endpoint.vala"
	_tmp5_ = _tmp4_;
#line 194 "../src/engine/api/geary-endpoint.vala"
	g_message ("geary-endpoint.vala:194: %s TLS warnings connecting to %s: %Xh (%s)", _tmp1_, _tmp3_, (guint) warnings, _tmp5_);
#line 194 "../src/engine/api/geary-endpoint.vala"
	_g_free0 (_tmp5_);
#line 194 "../src/engine/api/geary-endpoint.vala"
	_g_free0 (_tmp3_);
#line 194 "../src/engine/api/geary-endpoint.vala"
	_g_free0 (_tmp1_);
#line 200 "../src/engine/api/geary-endpoint.vala"
	geary_endpoint_set_tls_validation_warnings (self, warnings);
#line 201 "../src/engine/api/geary-endpoint.vala"
	geary_endpoint_set_untrusted_certificate (self, cert);
#line 203 "../src/engine/api/geary-endpoint.vala"
	g_signal_emit (self, geary_endpoint_signals[GEARY_ENDPOINT_UNTRUSTED_HOST_SIGNAL], 0, cx);
#line 1429 "geary-endpoint.c"
}

static gchar*
geary_endpoint_tls_flags_to_string (GearyEndpoint* self,
                                    GTlsCertificateFlags flags)
{
	GString* builder = NULL;
	GString* _tmp0_;
	const gchar* _tmp9_ = NULL;
	GString* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp14_;
	gchar* result;
#line 206 "../src/engine/api/geary-endpoint.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (self), NULL);
#line 207 "../src/engine/api/geary-endpoint.vala"
	_tmp0_ = g_string_new ("");
#line 207 "../src/engine/api/geary-endpoint.vala"
	builder = _tmp0_;
#line 1449 "geary-endpoint.c"
	{
		gint pos = 0;
#line 208 "../src/engine/api/geary-endpoint.vala"
		pos = 0;
#line 1454 "geary-endpoint.c"
		{
			gboolean _tmp1_ = FALSE;
#line 208 "../src/engine/api/geary-endpoint.vala"
			_tmp1_ = TRUE;
#line 208 "../src/engine/api/geary-endpoint.vala"
			while (TRUE) {
#line 1461 "geary-endpoint.c"
				GTlsCertificateFlags flag = 0U;
#line 208 "../src/engine/api/geary-endpoint.vala"
				if (!_tmp1_) {
#line 1465 "geary-endpoint.c"
					gint _tmp2_;
#line 208 "../src/engine/api/geary-endpoint.vala"
					_tmp2_ = pos;
#line 208 "../src/engine/api/geary-endpoint.vala"
					pos = _tmp2_ + 1;
#line 1471 "geary-endpoint.c"
				}
#line 208 "../src/engine/api/geary-endpoint.vala"
				_tmp1_ = FALSE;
#line 208 "../src/engine/api/geary-endpoint.vala"
				if (!(((gulong) pos) < (sizeof (GTlsCertificateFlags) * 8))) {
#line 208 "../src/engine/api/geary-endpoint.vala"
					break;
#line 1479 "geary-endpoint.c"
				}
#line 209 "../src/engine/api/geary-endpoint.vala"
				flag = flags & (1 << pos);
#line 210 "../src/engine/api/geary-endpoint.vala"
				if (flag != 0) {
#line 1485 "geary-endpoint.c"
					GString* _tmp3_;
					const gchar* _tmp4_;
					GString* _tmp6_;
					gchar* _tmp7_;
					gchar* _tmp8_;
#line 211 "../src/engine/api/geary-endpoint.vala"
					_tmp3_ = builder;
#line 211 "../src/engine/api/geary-endpoint.vala"
					_tmp4_ = _tmp3_->str;
#line 211 "../src/engine/api/geary-endpoint.vala"
					if (!geary_string_is_empty (_tmp4_)) {
#line 1497 "geary-endpoint.c"
						GString* _tmp5_;
#line 212 "../src/engine/api/geary-endpoint.vala"
						_tmp5_ = builder;
#line 212 "../src/engine/api/geary-endpoint.vala"
						g_string_append (_tmp5_, " | ");
#line 1503 "geary-endpoint.c"
					}
#line 214 "../src/engine/api/geary-endpoint.vala"
					_tmp6_ = builder;
#line 214 "../src/engine/api/geary-endpoint.vala"
					_tmp7_ = geary_endpoint_tls_flag_to_string (flag);
#line 214 "../src/engine/api/geary-endpoint.vala"
					_tmp8_ = _tmp7_;
#line 214 "../src/engine/api/geary-endpoint.vala"
					g_string_append (_tmp6_, _tmp8_);
#line 214 "../src/engine/api/geary-endpoint.vala"
					_g_free0 (_tmp8_);
#line 1515 "geary-endpoint.c"
				}
			}
		}
	}
#line 218 "../src/engine/api/geary-endpoint.vala"
	_tmp10_ = builder;
#line 218 "../src/engine/api/geary-endpoint.vala"
	_tmp11_ = _tmp10_->str;
#line 218 "../src/engine/api/geary-endpoint.vala"
	if (!geary_string_is_empty (_tmp11_)) {
#line 1526 "geary-endpoint.c"
		GString* _tmp12_;
		const gchar* _tmp13_;
#line 218 "../src/engine/api/geary-endpoint.vala"
		_tmp12_ = builder;
#line 218 "../src/engine/api/geary-endpoint.vala"
		_tmp13_ = _tmp12_->str;
#line 218 "../src/engine/api/geary-endpoint.vala"
		_tmp9_ = _tmp13_;
#line 1535 "geary-endpoint.c"
	} else {
#line 218 "../src/engine/api/geary-endpoint.vala"
		_tmp9_ = "(none)";
#line 1539 "geary-endpoint.c"
	}
#line 218 "../src/engine/api/geary-endpoint.vala"
	_tmp14_ = g_strdup (_tmp9_);
#line 218 "../src/engine/api/geary-endpoint.vala"
	result = _tmp14_;
#line 218 "../src/engine/api/geary-endpoint.vala"
	_g_string_free0 (builder);
#line 218 "../src/engine/api/geary-endpoint.vala"
	return result;
#line 1549 "geary-endpoint.c"
}

static void
geary_endpoint_on_socket_client_event (GearyEndpoint* self,
                                       GSocketClientEvent event,
                                       GSocketConnectable* connectable,
                                       GIOStream* ios)
{
#line 221 "../src/engine/api/geary-endpoint.vala"
	g_return_if_fail (GEARY_IS_ENDPOINT (self));
#line 221 "../src/engine/api/geary-endpoint.vala"
	g_return_if_fail ((connectable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (connectable, g_socket_connectable_get_type ()));
#line 221 "../src/engine/api/geary-endpoint.vala"
	g_return_if_fail ((ios == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (ios, g_io_stream_get_type ()));
#line 226 "../src/engine/api/geary-endpoint.vala"
	if (event == G_SOCKET_CLIENT_TLS_HANDSHAKING) {
#line 227 "../src/engine/api/geary-endpoint.vala"
		geary_endpoint_prepare_tls_cx (self, G_TYPE_CHECK_INSTANCE_CAST (ios, g_tls_client_connection_get_type (), GTlsClientConnection));
#line 1568 "geary-endpoint.c"
	}
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 231 "../src/engine/api/geary-endpoint.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 231 "../src/engine/api/geary-endpoint.vala"
	return _data4_;
#line 1579 "geary-endpoint.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 231 "../src/engine/api/geary-endpoint.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 1589 "geary-endpoint.c"
		GearyEndpoint* self;
#line 231 "../src/engine/api/geary-endpoint.vala"
		self = _data4_->self;
#line 231 "../src/engine/api/geary-endpoint.vala"
		_g_object_unref0 (_data4_->cx);
#line 231 "../src/engine/api/geary-endpoint.vala"
		_g_object_unref0 (_data4_->cert);
#line 231 "../src/engine/api/geary-endpoint.vala"
		_g_object_unref0 (self);
#line 231 "../src/engine/api/geary-endpoint.vala"
		g_slice_free (Block4Data, _data4_);
#line 1601 "geary-endpoint.c"
	}
}

static gboolean
__lambda47_ (Block4Data* _data4_)
{
	GearyEndpoint* self;
	gboolean result;
#line 236 "../src/engine/api/geary-endpoint.vala"
	self = _data4_->self;
#line 237 "../src/engine/api/geary-endpoint.vala"
	geary_endpoint_report_tls_warnings (self, _data4_->cx, _data4_->cert, _data4_->flags);
#line 238 "../src/engine/api/geary-endpoint.vala"
	result = G_SOURCE_REMOVE;
#line 238 "../src/engine/api/geary-endpoint.vala"
	return result;
#line 1618 "geary-endpoint.c"
}

static gboolean
___lambda47__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda47_ (self);
#line 236 "../src/engine/api/geary-endpoint.vala"
	return result;
#line 1628 "geary-endpoint.c"
}

static gboolean
geary_endpoint_on_accept_certificate (GearyEndpoint* self,
                                      GTlsConnection* cx,
                                      GTlsCertificate* cert,
                                      GTlsCertificateFlags flags)
{
	Block4Data* _data4_;
	GTlsConnection* _tmp0_;
	GTlsCertificate* _tmp1_;
	gboolean result;
#line 231 "../src/engine/api/geary-endpoint.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (self), FALSE);
#line 231 "../src/engine/api/geary-endpoint.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cx, g_tls_connection_get_type ()), FALSE);
#line 231 "../src/engine/api/geary-endpoint.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cert, g_tls_certificate_get_type ()), FALSE);
#line 231 "../src/engine/api/geary-endpoint.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 231 "../src/engine/api/geary-endpoint.vala"
	_data4_->_ref_count_ = 1;
#line 231 "../src/engine/api/geary-endpoint.vala"
	_data4_->self = g_object_ref (self);
#line 231 "../src/engine/api/geary-endpoint.vala"
	_tmp0_ = _g_object_ref0 (cx);
#line 231 "../src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (_data4_->cx);
#line 231 "../src/engine/api/geary-endpoint.vala"
	_data4_->cx = _tmp0_;
#line 231 "../src/engine/api/geary-endpoint.vala"
	_tmp1_ = _g_object_ref0 (cert);
#line 231 "../src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (_data4_->cert);
#line 231 "../src/engine/api/geary-endpoint.vala"
	_data4_->cert = _tmp1_;
#line 231 "../src/engine/api/geary-endpoint.vala"
	_data4_->flags = flags;
#line 236 "../src/engine/api/geary-endpoint.vala"
	g_idle_add_full (G_PRIORITY_HIGH, ___lambda47__gsource_func, block4_data_ref (_data4_), block4_data_unref);
#line 242 "../src/engine/api/geary-endpoint.vala"
	result = FALSE;
#line 242 "../src/engine/api/geary-endpoint.vala"
	block4_data_unref (_data4_);
#line 242 "../src/engine/api/geary-endpoint.vala"
	_data4_ = NULL;
#line 242 "../src/engine/api/geary-endpoint.vala"
	return result;
#line 1677 "geary-endpoint.c"
}

static void
geary_endpoint_class_init (GearyEndpointClass * klass,
                           gpointer klass_data)
{
#line 12 "../src/engine/api/geary-endpoint.vala"
	geary_endpoint_parent_class = g_type_class_peek_parent (klass);
#line 12 "../src/engine/api/geary-endpoint.vala"
	g_type_class_adjust_private_offset (klass, &GearyEndpoint_private_offset);
#line 12 "../src/engine/api/geary-endpoint.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_endpoint_get_property;
#line 12 "../src/engine/api/geary-endpoint.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_endpoint_set_property;
#line 12 "../src/engine/api/geary-endpoint.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_endpoint_finalize;
#line 1694 "geary-endpoint.c"
	/** Specifies how to connect to the remote endpoint. */
#line 12 "../src/engine/api/geary-endpoint.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ENDPOINT_REMOTE_PROPERTY, geary_endpoint_properties[GEARY_ENDPOINT_REMOTE_PROPERTY] = g_param_spec_object ("remote", "remote", "remote", g_socket_connectable_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1698 "geary-endpoint.c"
	/** A connectivity manager for this endpoint. */
#line 12 "../src/engine/api/geary-endpoint.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ENDPOINT_CONNECTIVITY_PROPERTY, geary_endpoint_properties[GEARY_ENDPOINT_CONNECTIVITY_PROPERTY] = g_param_spec_object ("connectivity", "connectivity", "connectivity", GEARY_TYPE_CONNECTIVITY_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1702 "geary-endpoint.c"
	/** Timeout for connection attempts, in seconds. */
#line 12 "../src/engine/api/geary-endpoint.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ENDPOINT_TIMEOUT_SEC_PROPERTY, geary_endpoint_properties[GEARY_ENDPOINT_TIMEOUT_SEC_PROPERTY] = g_param_spec_uint ("timeout-sec", "timeout-sec", "timeout-sec", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1706 "geary-endpoint.c"
	/** Transport security method to use when connecting. */
#line 12 "../src/engine/api/geary-endpoint.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ENDPOINT_TLS_METHOD_PROPERTY, geary_endpoint_properties[GEARY_ENDPOINT_TLS_METHOD_PROPERTY] = g_param_spec_enum ("tls-method", "tls-method", "tls-method", GEARY_TYPE_TLS_NEGOTIATION_METHOD, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1710 "geary-endpoint.c"
	/**
	     * When set, TLS has reported certificate issues.
	     *
	     * @see untrusted_host
	     */
#line 12 "../src/engine/api/geary-endpoint.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ENDPOINT_TLS_VALIDATION_WARNINGS_PROPERTY, geary_endpoint_properties[GEARY_ENDPOINT_TLS_VALIDATION_WARNINGS_PROPERTY] = g_param_spec_flags ("tls-validation-warnings", "tls-validation-warnings", "tls-validation-warnings", g_tls_certificate_flags_get_type (), 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1718 "geary-endpoint.c"
	/**
	     * The TLS certificate for an invalid or untrusted connection.
	     */
#line 12 "../src/engine/api/geary-endpoint.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ENDPOINT_UNTRUSTED_CERTIFICATE_PROPERTY, geary_endpoint_properties[GEARY_ENDPOINT_UNTRUSTED_CERTIFICATE_PROPERTY] = g_param_spec_object ("untrusted-certificate", "untrusted-certificate", "untrusted-certificate", g_tls_certificate_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1724 "geary-endpoint.c"
	/**
	     * Emitted when unexpected TLS certificate warnings are detected.
	     *
	     * This occurs when a connection receives a TLS certificate
	     * warning. The connection will be closed when this is fired. The
	     * caller should query the user about how to deal with the
	     * situation. If user wants to proceed, pin the certificate in a
	     * way such that it accessible to the connection via {@link
	     * default_tls_database}.
	     *
	     * @see AccountInformation.untrusted_host
	     * @see tls_validation_warnings
	     */
#line 12 "../src/engine/api/geary-endpoint.vala"
	geary_endpoint_signals[GEARY_ENDPOINT_UNTRUSTED_HOST_SIGNAL] = g_signal_new ("untrusted-host", GEARY_TYPE_ENDPOINT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_tls_connection_get_type ());
#line 1740 "geary-endpoint.c"
}

static void
geary_endpoint_instance_init (GearyEndpoint * self,
                              gpointer klass)
{
#line 12 "../src/engine/api/geary-endpoint.vala"
	self->priv = geary_endpoint_get_instance_private (self);
#line 74 "../src/engine/api/geary-endpoint.vala"
	self->priv->_tls_validation_warnings = 0;
#line 79 "../src/engine/api/geary-endpoint.vala"
	self->priv->_untrusted_certificate = NULL;
#line 81 "../src/engine/api/geary-endpoint.vala"
	self->priv->socket_client = NULL;
#line 1755 "geary-endpoint.c"
}

static void
geary_endpoint_finalize (GObject * obj)
{
	GearyEndpoint * self;
#line 12 "../src/engine/api/geary-endpoint.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_TYPE_ENDPOINT, GearyEndpoint);
#line 58 "../src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (self->priv->_remote);
#line 61 "../src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (self->priv->_connectivity);
#line 79 "../src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (self->priv->_untrusted_certificate);
#line 81 "../src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (self->priv->socket_client);
#line 12 "../src/engine/api/geary-endpoint.vala"
	G_OBJECT_CLASS (geary_endpoint_parent_class)->finalize (obj);
#line 1774 "geary-endpoint.c"
}

/**
 * Encapsulates network configuration and state for remote service.
 */
 G_GNUC_NO_INLINE static GType
geary_endpoint_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyEndpointClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_endpoint_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyEndpoint), 0, (GInstanceInitFunc) geary_endpoint_instance_init, NULL };
	GType geary_endpoint_type_id;
	geary_endpoint_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyEndpoint", &g_define_type_info, 0);
	GearyEndpoint_private_offset = g_type_add_instance_private (geary_endpoint_type_id, sizeof (GearyEndpointPrivate));
	return geary_endpoint_type_id;
}

GType
geary_endpoint_get_type (void)
{
	static gsize geary_endpoint_type_id__once = 0;
	if (g_once_init_enter (&geary_endpoint_type_id__once)) {
		GType geary_endpoint_type_id;
		geary_endpoint_type_id = geary_endpoint_get_type_once ();
		g_once_init_leave (&geary_endpoint_type_id__once, geary_endpoint_type_id);
	}
	return geary_endpoint_type_id__once;
}

static void
_vala_geary_endpoint_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	GearyEndpoint * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_ENDPOINT, GearyEndpoint);
#line 12 "../src/engine/api/geary-endpoint.vala"
	switch (property_id) {
#line 12 "../src/engine/api/geary-endpoint.vala"
		case GEARY_ENDPOINT_REMOTE_PROPERTY:
#line 12 "../src/engine/api/geary-endpoint.vala"
		g_value_set_object (value, geary_endpoint_get_remote (self));
#line 12 "../src/engine/api/geary-endpoint.vala"
		break;
#line 12 "../src/engine/api/geary-endpoint.vala"
		case GEARY_ENDPOINT_CONNECTIVITY_PROPERTY:
#line 12 "../src/engine/api/geary-endpoint.vala"
		g_value_set_object (value, geary_endpoint_get_connectivity (self));
#line 12 "../src/engine/api/geary-endpoint.vala"
		break;
#line 12 "../src/engine/api/geary-endpoint.vala"
		case GEARY_ENDPOINT_TIMEOUT_SEC_PROPERTY:
#line 12 "../src/engine/api/geary-endpoint.vala"
		g_value_set_uint (value, geary_endpoint_get_timeout_sec (self));
#line 12 "../src/engine/api/geary-endpoint.vala"
		break;
#line 12 "../src/engine/api/geary-endpoint.vala"
		case GEARY_ENDPOINT_TLS_METHOD_PROPERTY:
#line 12 "../src/engine/api/geary-endpoint.vala"
		g_value_set_enum (value, geary_endpoint_get_tls_method (self));
#line 12 "../src/engine/api/geary-endpoint.vala"
		break;
#line 12 "../src/engine/api/geary-endpoint.vala"
		case GEARY_ENDPOINT_TLS_VALIDATION_WARNINGS_PROPERTY:
#line 12 "../src/engine/api/geary-endpoint.vala"
		g_value_set_flags (value, geary_endpoint_get_tls_validation_warnings (self));
#line 12 "../src/engine/api/geary-endpoint.vala"
		break;
#line 12 "../src/engine/api/geary-endpoint.vala"
		case GEARY_ENDPOINT_UNTRUSTED_CERTIFICATE_PROPERTY:
#line 12 "../src/engine/api/geary-endpoint.vala"
		g_value_set_object (value, geary_endpoint_get_untrusted_certificate (self));
#line 12 "../src/engine/api/geary-endpoint.vala"
		break;
#line 1848 "geary-endpoint.c"
		default:
#line 12 "../src/engine/api/geary-endpoint.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "../src/engine/api/geary-endpoint.vala"
		break;
#line 1854 "geary-endpoint.c"
	}
}

static void
_vala_geary_endpoint_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	GearyEndpoint * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_ENDPOINT, GearyEndpoint);
#line 12 "../src/engine/api/geary-endpoint.vala"
	switch (property_id) {
#line 12 "../src/engine/api/geary-endpoint.vala"
		case GEARY_ENDPOINT_REMOTE_PROPERTY:
#line 12 "../src/engine/api/geary-endpoint.vala"
		geary_endpoint_set_remote (self, g_value_get_object (value));
#line 12 "../src/engine/api/geary-endpoint.vala"
		break;
#line 12 "../src/engine/api/geary-endpoint.vala"
		case GEARY_ENDPOINT_CONNECTIVITY_PROPERTY:
#line 12 "../src/engine/api/geary-endpoint.vala"
		geary_endpoint_set_connectivity (self, g_value_get_object (value));
#line 12 "../src/engine/api/geary-endpoint.vala"
		break;
#line 12 "../src/engine/api/geary-endpoint.vala"
		case GEARY_ENDPOINT_TIMEOUT_SEC_PROPERTY:
#line 12 "../src/engine/api/geary-endpoint.vala"
		geary_endpoint_set_timeout_sec (self, g_value_get_uint (value));
#line 12 "../src/engine/api/geary-endpoint.vala"
		break;
#line 12 "../src/engine/api/geary-endpoint.vala"
		case GEARY_ENDPOINT_TLS_METHOD_PROPERTY:
#line 12 "../src/engine/api/geary-endpoint.vala"
		geary_endpoint_set_tls_method (self, g_value_get_enum (value));
#line 12 "../src/engine/api/geary-endpoint.vala"
		break;
#line 12 "../src/engine/api/geary-endpoint.vala"
		case GEARY_ENDPOINT_TLS_VALIDATION_WARNINGS_PROPERTY:
#line 12 "../src/engine/api/geary-endpoint.vala"
		geary_endpoint_set_tls_validation_warnings (self, g_value_get_flags (value));
#line 12 "../src/engine/api/geary-endpoint.vala"
		break;
#line 12 "../src/engine/api/geary-endpoint.vala"
		case GEARY_ENDPOINT_UNTRUSTED_CERTIFICATE_PROPERTY:
#line 12 "../src/engine/api/geary-endpoint.vala"
		geary_endpoint_set_untrusted_certificate (self, g_value_get_object (value));
#line 12 "../src/engine/api/geary-endpoint.vala"
		break;
#line 1904 "geary-endpoint.c"
		default:
#line 12 "../src/engine/api/geary-endpoint.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "../src/engine/api/geary-endpoint.vala"
		break;
#line 1910 "geary-endpoint.c"
	}
}

