/* geary-folder-supports-remove.c generated by valac 0.56.17, the Vala compiler
 * generated from geary-folder-supports-remove.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

static GType geary_folder_support_remove_get_type_once (void);

void
geary_folder_support_remove_remove_email_async (GearyFolderSupportRemove* self,
                                                GeeCollection* email_ids,
                                                GCancellable* cancellable,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_)
{
	GearyFolderSupportRemoveIface* _iface_;
#line 25 "../src/engine/api/geary-folder-supports-remove.vala"
	_iface_ = GEARY_FOLDER_SUPPORT_REMOVE_GET_INTERFACE (self);
#line 25 "../src/engine/api/geary-folder-supports-remove.vala"
	if (_iface_->remove_email_async) {
#line 25 "../src/engine/api/geary-folder-supports-remove.vala"
		_iface_->remove_email_async (self, email_ids, cancellable, _callback_, _user_data_);
#line 43 "geary-folder-supports-remove.c"
	}
}

void
geary_folder_support_remove_remove_email_finish (GearyFolderSupportRemove* self,
                                                 GAsyncResult* _res_,
                                                 GError** error)
{
	GearyFolderSupportRemoveIface* _iface_;
#line 25 "../src/engine/api/geary-folder-supports-remove.vala"
	_iface_ = GEARY_FOLDER_SUPPORT_REMOVE_GET_INTERFACE (self);
#line 25 "../src/engine/api/geary-folder-supports-remove.vala"
	if (_iface_->remove_email_finish) {
#line 25 "../src/engine/api/geary-folder-supports-remove.vala"
		_iface_->remove_email_finish (self, _res_, error);
#line 59 "geary-folder-supports-remove.c"
	}
}

static void
geary_folder_support_remove_default_init (GearyFolderSupportRemoveIface * iface,
                                          gpointer iface_data)
{
}

/**
 * The addition of the Geary.FolderSupport.Remove interface to a
 * {@link Geary.Folder} indicates that it supports removing (deleting)
 * email.
 *
 * This generally means that the message is deleted from the server
 * and is not recoverable.  It _may_ mean the message is moved to a
 * Trash folder where it may or may not be automatically deleted some
 * time later; this behavior is server-specific and not always
 * determinable by Geary (or worked around, either).
 *
 * The remove operation is distinct from the archive operation,
 * available via {@link Geary.FolderSupport.Archive}.
 *
 * A Folder that does not support Remove does not imply that email
 * might not be removed later, such as by the server.
 */
 G_GNUC_NO_INLINE static GType
geary_folder_support_remove_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyFolderSupportRemoveIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_folder_support_remove_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType geary_folder_support_remove_type_id;
	geary_folder_support_remove_type_id = g_type_register_static (G_TYPE_INTERFACE, "GearyFolderSupportRemove", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (geary_folder_support_remove_type_id, GEARY_TYPE_FOLDER);
	return geary_folder_support_remove_type_id;
}

GType
geary_folder_support_remove_get_type (void)
{
	static gsize geary_folder_support_remove_type_id__once = 0;
	if (g_once_init_enter (&geary_folder_support_remove_type_id__once)) {
		GType geary_folder_support_remove_type_id;
		geary_folder_support_remove_type_id = geary_folder_support_remove_get_type_once ();
		g_once_init_leave (&geary_folder_support_remove_type_id__once, geary_folder_support_remove_type_id);
	}
	return geary_folder_support_remove_type_id__once;
}

