/* geary-search-query.c generated by valac 0.56.17, the Vala compiler
 * generated from geary-search-query.vala, do not modify */

/*
 * Copyright © 2016 Software Freedom Conservancy Inc.
 * Copyright © 2019-2020 Michael Gratton <mike@vee.met>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_SEARCH_QUERY_0_PROPERTY,
	GEARY_SEARCH_QUERY_EXPRESSION_PROPERTY,
	GEARY_SEARCH_QUERY_RAW_PROPERTY,
	GEARY_SEARCH_QUERY_NUM_PROPERTIES
};
static GParamSpec* geary_search_query_properties[GEARY_SEARCH_QUERY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
enum  {
	GEARY_SEARCH_QUERY_TERM_0_PROPERTY,
	GEARY_SEARCH_QUERY_TERM_IS_NEGATED_PROPERTY,
	GEARY_SEARCH_QUERY_TERM_NUM_PROPERTIES
};
static GParamSpec* geary_search_query_term_properties[GEARY_SEARCH_QUERY_TERM_NUM_PROPERTIES];
enum  {
	GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_0_PROPERTY,
	GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_TARGET_PROPERTY,
	GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_MATCHING_STRATEGY_PROPERTY,
	GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_TERMS_PROPERTY,
	GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_NUM_PROPERTIES
};
static GParamSpec* geary_search_query_email_text_term_properties[GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_NUM_PROPERTIES];
enum  {
	GEARY_SEARCH_QUERY_EMAIL_FLAG_TERM_0_PROPERTY,
	GEARY_SEARCH_QUERY_EMAIL_FLAG_TERM_VALUE_PROPERTY,
	GEARY_SEARCH_QUERY_EMAIL_FLAG_TERM_NUM_PROPERTIES
};
static GParamSpec* geary_search_query_email_flag_term_properties[GEARY_SEARCH_QUERY_EMAIL_FLAG_TERM_NUM_PROPERTIES];

struct _GearySearchQueryPrivate {
	GeeList* _expression;
	GeeList* _rw_expression;
	gchar* _raw;
};

struct _GearySearchQueryTermPrivate {
	gboolean _is_negated;
};

struct _GearySearchQueryEmailTextTermPrivate {
	GearySearchQueryEmailTextTermProperty _target;
	GearySearchQueryStrategy _matching_strategy;
	GeeList* _terms;
};

struct _GearySearchQueryEmailFlagTermPrivate {
	GearyNamedFlag* _value;
};

static gint GearySearchQuery_private_offset;
static gpointer geary_search_query_parent_class = NULL;
static gint GearySearchQueryTerm_private_offset;
static gpointer geary_search_query_term_parent_class = NULL;
static gint GearySearchQueryEmailTextTerm_private_offset;
static gpointer geary_search_query_email_text_term_parent_class = NULL;
static gint GearySearchQueryEmailFlagTerm_private_offset;
static gpointer geary_search_query_email_flag_term_parent_class = NULL;

VALA_EXTERN gboolean geary_search_query_strategy_is_stemming_enabled (GearySearchQueryStrategy self);
VALA_EXTERN gint geary_search_query_strategy_get_min_term_length_for_stemming (GearySearchQueryStrategy self);
VALA_EXTERN gint geary_search_query_strategy_get_max_difference_term_stem_lengths (GearySearchQueryStrategy self);
static void geary_search_query_set_expression (GearySearchQuery* self,
                                        GeeList* value);
static void geary_search_query_set_raw (GearySearchQuery* self,
                                 const gchar* value);
static gboolean geary_search_query_term_real_equal_to (GearySearchQueryTerm* self,
                                                GearySearchQueryTerm* other);
static gchar* geary_search_query_term_real_to_string (GearySearchQueryTerm* self);
static void geary_search_query_term_finalize (GObject * obj);
static GType geary_search_query_term_get_type_once (void);
static void _vala_geary_search_query_term_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_geary_search_query_term_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
static void geary_search_query_email_text_term_set_target (GearySearchQueryEmailTextTerm* self,
                                                    GearySearchQueryEmailTextTermProperty value);
static void geary_search_query_email_text_term_set_matching_strategy (GearySearchQueryEmailTextTerm* self,
                                                               GearySearchQueryStrategy value);
static void geary_search_query_email_text_term_set_terms (GearySearchQueryEmailTextTerm* self,
                                                   GeeList* value);
static gboolean geary_search_query_email_text_term_real_equal_to (GearySearchQueryTerm* base,
                                                           GearySearchQueryTerm* other);
static gchar* geary_search_query_email_text_term_real_to_string (GearySearchQueryTerm* base);
static void geary_search_query_email_text_term_finalize (GObject * obj);
static GType geary_search_query_email_text_term_get_type_once (void);
static void _vala_geary_search_query_email_text_term_get_property (GObject * object,
                                                            guint property_id,
                                                            GValue * value,
                                                            GParamSpec * pspec);
static void _vala_geary_search_query_email_text_term_set_property (GObject * object,
                                                            guint property_id,
                                                            const GValue * value,
                                                            GParamSpec * pspec);
static void geary_search_query_email_flag_term_set_value (GearySearchQueryEmailFlagTerm* self,
                                                   GearyNamedFlag* value);
static gboolean geary_search_query_email_flag_term_real_equal_to (GearySearchQueryTerm* base,
                                                           GearySearchQueryTerm* other);
static gchar* geary_search_query_email_flag_term_real_to_string (GearySearchQueryTerm* base);
static void geary_search_query_email_flag_term_finalize (GObject * obj);
static GType geary_search_query_email_flag_term_get_type_once (void);
static void _vala_geary_search_query_email_flag_term_get_property (GObject * object,
                                                            guint property_id,
                                                            GValue * value,
                                                            GParamSpec * pspec);
static void _vala_geary_search_query_email_flag_term_set_property (GObject * object,
                                                            guint property_id,
                                                            const GValue * value,
                                                            GParamSpec * pspec);
static void geary_search_query_finalize (GObject * obj);
static GType geary_search_query_get_type_once (void);
static void _vala_geary_search_query_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_geary_search_query_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);

static inline gpointer
geary_search_query_get_instance_private (GearySearchQuery* self)
{
	return G_STRUCT_MEMBER_P (self, GearySearchQuery_private_offset);
}

/**
     * An advisory parameter regarding search quality, scope, and breadth.
     *
     * The Engine can perform searches based on (unspecified, uncontracted) textual variations of
     * a query's search terms.  Some of those variations may produce undesirable results due to
     * "greedy" matching of terms.  The Strategy parameter allows for an advisory to the Engine
     * about how to use those textual variants, if any at all.
     *
     * This may be respected or ignored by the Engine.  In particular, there's no guarantee it will
     * have any effect on server search.
     */
/** Determines if stemming may be used for an operator. */
gboolean
geary_search_query_strategy_is_stemming_enabled (GearySearchQueryStrategy self)
{
	gboolean result;
#line 72 "../src/engine/api/geary-search-query.vala"
	result = self != GEARY_SEARCH_QUERY_STRATEGY_EXACT;
#line 72 "../src/engine/api/geary-search-query.vala"
	return result;
#line 180 "geary-search-query.c"
}

/**
         * The minimum term length before stemming is allowed.
         *
         * This prevents short words that might be stemmed from being stemmed.
         */
gint
geary_search_query_strategy_get_min_term_length_for_stemming (GearySearchQueryStrategy self)
{
	gint min = 0;
	gint result;
#line 81 "../src/engine/api/geary-search-query.vala"
	min = 0;
#line 82 "../src/engine/api/geary-search-query.vala"
	switch (self) {
#line 82 "../src/engine/api/geary-search-query.vala"
		case GEARY_SEARCH_QUERY_STRATEGY_EXACT:
#line 199 "geary-search-query.c"
		{
#line 84 "../src/engine/api/geary-search-query.vala"
			min = G_MAXINT;
#line 85 "../src/engine/api/geary-search-query.vala"
			break;
#line 205 "geary-search-query.c"
		}
#line 82 "../src/engine/api/geary-search-query.vala"
		case GEARY_SEARCH_QUERY_STRATEGY_CONSERVATIVE:
#line 209 "geary-search-query.c"
		{
#line 87 "../src/engine/api/geary-search-query.vala"
			min = 6;
#line 88 "../src/engine/api/geary-search-query.vala"
			break;
#line 215 "geary-search-query.c"
		}
#line 82 "../src/engine/api/geary-search-query.vala"
		case GEARY_SEARCH_QUERY_STRATEGY_AGGRESSIVE:
#line 219 "geary-search-query.c"
		{
#line 90 "../src/engine/api/geary-search-query.vala"
			min = 4;
#line 91 "../src/engine/api/geary-search-query.vala"
			break;
#line 225 "geary-search-query.c"
		}
#line 82 "../src/engine/api/geary-search-query.vala"
		case GEARY_SEARCH_QUERY_STRATEGY_HORIZON:
#line 229 "geary-search-query.c"
		{
#line 93 "../src/engine/api/geary-search-query.vala"
			min = 0;
#line 94 "../src/engine/api/geary-search-query.vala"
			break;
#line 235 "geary-search-query.c"
		}
		default:
#line 82 "../src/engine/api/geary-search-query.vala"
		break;
#line 240 "geary-search-query.c"
	}
#line 96 "../src/engine/api/geary-search-query.vala"
	result = min;
#line 96 "../src/engine/api/geary-search-query.vala"
	return result;
#line 246 "geary-search-query.c"
}

/**
         * Maximum difference in lengths between term and stemmed variant.
         *
         * This prevents long words from being stemmed to much shorter
         * words (which creates opportunities for greedy matching).
         */
gint
geary_search_query_strategy_get_max_difference_term_stem_lengths (GearySearchQueryStrategy self)
{
	gint max = 0;
	gint result;
#line 106 "../src/engine/api/geary-search-query.vala"
	max = 0;
#line 107 "../src/engine/api/geary-search-query.vala"
	switch (self) {
#line 107 "../src/engine/api/geary-search-query.vala"
		case GEARY_SEARCH_QUERY_STRATEGY_EXACT:
#line 266 "geary-search-query.c"
		{
#line 109 "../src/engine/api/geary-search-query.vala"
			max = 0;
#line 110 "../src/engine/api/geary-search-query.vala"
			break;
#line 272 "geary-search-query.c"
		}
#line 107 "../src/engine/api/geary-search-query.vala"
		case GEARY_SEARCH_QUERY_STRATEGY_CONSERVATIVE:
#line 276 "geary-search-query.c"
		{
#line 112 "../src/engine/api/geary-search-query.vala"
			max = 2;
#line 113 "../src/engine/api/geary-search-query.vala"
			break;
#line 282 "geary-search-query.c"
		}
#line 107 "../src/engine/api/geary-search-query.vala"
		case GEARY_SEARCH_QUERY_STRATEGY_AGGRESSIVE:
#line 286 "geary-search-query.c"
		{
#line 115 "../src/engine/api/geary-search-query.vala"
			max = 4;
#line 116 "../src/engine/api/geary-search-query.vala"
			break;
#line 292 "geary-search-query.c"
		}
#line 107 "../src/engine/api/geary-search-query.vala"
		case GEARY_SEARCH_QUERY_STRATEGY_HORIZON:
#line 296 "geary-search-query.c"
		{
#line 118 "../src/engine/api/geary-search-query.vala"
			max = G_MAXINT;
#line 119 "../src/engine/api/geary-search-query.vala"
			break;
#line 302 "geary-search-query.c"
		}
		default:
#line 107 "../src/engine/api/geary-search-query.vala"
		break;
#line 307 "geary-search-query.c"
	}
#line 121 "../src/engine/api/geary-search-query.vala"
	result = max;
#line 121 "../src/engine/api/geary-search-query.vala"
	return result;
#line 313 "geary-search-query.c"
}

 G_GNUC_NO_INLINE static GType
geary_search_query_strategy_get_type_once (void)
{
	static const GEnumValue values[] = {{GEARY_SEARCH_QUERY_STRATEGY_EXACT, "GEARY_SEARCH_QUERY_STRATEGY_EXACT", "exact"}, {GEARY_SEARCH_QUERY_STRATEGY_CONSERVATIVE, "GEARY_SEARCH_QUERY_STRATEGY_CONSERVATIVE", "conservative"}, {GEARY_SEARCH_QUERY_STRATEGY_AGGRESSIVE, "GEARY_SEARCH_QUERY_STRATEGY_AGGRESSIVE", "aggressive"}, {GEARY_SEARCH_QUERY_STRATEGY_HORIZON, "GEARY_SEARCH_QUERY_STRATEGY_HORIZON", "horizon"}, {0, NULL, NULL}};
	GType geary_search_query_strategy_type_id;
	geary_search_query_strategy_type_id = g_enum_register_static ("GearySearchQueryStrategy", values);
	return geary_search_query_strategy_type_id;
}

GType
geary_search_query_strategy_get_type (void)
{
	static gsize geary_search_query_strategy_type_id__once = 0;
	if (g_once_init_enter (&geary_search_query_strategy_type_id__once)) {
		GType geary_search_query_strategy_type_id;
		geary_search_query_strategy_type_id = geary_search_query_strategy_get_type_once ();
		g_once_init_leave (&geary_search_query_strategy_type_id__once, geary_search_query_strategy_type_id);
	}
	return geary_search_query_strategy_type_id__once;
}

GeeList*
geary_search_query_get_expression (GearySearchQuery* self)
{
	GeeList* result;
	GeeList* _tmp0_;
#line 315 "../src/engine/api/geary-search-query.vala"
	g_return_val_if_fail (GEARY_IS_SEARCH_QUERY (self), NULL);
#line 315 "../src/engine/api/geary-search-query.vala"
	_tmp0_ = self->priv->_expression;
#line 315 "../src/engine/api/geary-search-query.vala"
	result = _tmp0_;
#line 315 "../src/engine/api/geary-search-query.vala"
	return result;
#line 350 "geary-search-query.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 315 "../src/engine/api/geary-search-query.vala"
	return self ? g_object_ref (self) : NULL;
#line 358 "geary-search-query.c"
}

static void
geary_search_query_set_expression (GearySearchQuery* self,
                                   GeeList* value)
{
	GeeList* old_value;
#line 315 "../src/engine/api/geary-search-query.vala"
	g_return_if_fail (GEARY_IS_SEARCH_QUERY (self));
#line 315 "../src/engine/api/geary-search-query.vala"
	old_value = geary_search_query_get_expression (self);
#line 315 "../src/engine/api/geary-search-query.vala"
	if (old_value != value) {
#line 372 "geary-search-query.c"
		GeeList* _tmp0_;
#line 315 "../src/engine/api/geary-search-query.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 315 "../src/engine/api/geary-search-query.vala"
		_g_object_unref0 (self->priv->_expression);
#line 315 "../src/engine/api/geary-search-query.vala"
		self->priv->_expression = _tmp0_;
#line 315 "../src/engine/api/geary-search-query.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_search_query_properties[GEARY_SEARCH_QUERY_EXPRESSION_PROPERTY]);
#line 382 "geary-search-query.c"
	}
}

const gchar*
geary_search_query_get_raw (GearySearchQuery* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 323 "../src/engine/api/geary-search-query.vala"
	g_return_val_if_fail (GEARY_IS_SEARCH_QUERY (self), NULL);
#line 323 "../src/engine/api/geary-search-query.vala"
	_tmp0_ = self->priv->_raw;
#line 323 "../src/engine/api/geary-search-query.vala"
	result = _tmp0_;
#line 323 "../src/engine/api/geary-search-query.vala"
	return result;
#line 399 "geary-search-query.c"
}

static void
geary_search_query_set_raw (GearySearchQuery* self,
                            const gchar* value)
{
	gchar* old_value;
#line 323 "../src/engine/api/geary-search-query.vala"
	g_return_if_fail (GEARY_IS_SEARCH_QUERY (self));
#line 323 "../src/engine/api/geary-search-query.vala"
	old_value = geary_search_query_get_raw (self);
#line 323 "../src/engine/api/geary-search-query.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 413 "geary-search-query.c"
		gchar* _tmp0_;
#line 323 "../src/engine/api/geary-search-query.vala"
		_tmp0_ = g_strdup (value);
#line 323 "../src/engine/api/geary-search-query.vala"
		_g_free0 (self->priv->_raw);
#line 323 "../src/engine/api/geary-search-query.vala"
		self->priv->_raw = _tmp0_;
#line 323 "../src/engine/api/geary-search-query.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_search_query_properties[GEARY_SEARCH_QUERY_RAW_PROPERTY]);
#line 423 "geary-search-query.c"
	}
}

GearySearchQuery*
geary_search_query_construct (GType object_type,
                              GeeCollection* expression,
                              const gchar* raw)
{
	GearySearchQuery * self = NULL;
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
	GeeList* _tmp3_;
	GeeList* _tmp4_;
#line 326 "../src/engine/api/geary-search-query.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (expression, GEE_TYPE_COLLECTION), NULL);
#line 326 "../src/engine/api/geary-search-query.vala"
	g_return_val_if_fail (raw != NULL, NULL);
#line 326 "../src/engine/api/geary-search-query.vala"
	self = (GearySearchQuery*) geary_base_object_construct (object_type);
#line 328 "../src/engine/api/geary-search-query.vala"
	_tmp0_ = self->priv->_rw_expression;
#line 328 "../src/engine/api/geary-search-query.vala"
	gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), expression);
#line 329 "../src/engine/api/geary-search-query.vala"
	_tmp1_ = self->priv->_rw_expression;
#line 329 "../src/engine/api/geary-search-query.vala"
	_tmp2_ = gee_list_get_read_only_view (_tmp1_);
#line 329 "../src/engine/api/geary-search-query.vala"
	_tmp3_ = _tmp2_;
#line 329 "../src/engine/api/geary-search-query.vala"
	_tmp4_ = _tmp3_;
#line 329 "../src/engine/api/geary-search-query.vala"
	geary_search_query_set_expression (self, _tmp4_);
#line 329 "../src/engine/api/geary-search-query.vala"
	_g_object_unref0 (_tmp4_);
#line 330 "../src/engine/api/geary-search-query.vala"
	geary_search_query_set_raw (self, raw);
#line 326 "../src/engine/api/geary-search-query.vala"
	return self;
#line 464 "geary-search-query.c"
}

/** Determines if this query's expression is equal to another's. */
gboolean
geary_search_query_equal_to (GearySearchQuery* self,
                             GearySearchQuery* other)
{
	GeeList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gboolean result;
#line 334 "../src/engine/api/geary-search-query.vala"
	g_return_val_if_fail (GEARY_IS_SEARCH_QUERY (self), FALSE);
#line 334 "../src/engine/api/geary-search-query.vala"
	g_return_val_if_fail (GEARY_IS_SEARCH_QUERY (other), FALSE);
#line 335 "../src/engine/api/geary-search-query.vala"
	if (self == other) {
#line 336 "../src/engine/api/geary-search-query.vala"
		result = TRUE;
#line 336 "../src/engine/api/geary-search-query.vala"
		return result;
#line 489 "geary-search-query.c"
	}
#line 338 "../src/engine/api/geary-search-query.vala"
	_tmp0_ = self->priv->_expression;
#line 338 "../src/engine/api/geary-search-query.vala"
	_tmp1_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection));
#line 338 "../src/engine/api/geary-search-query.vala"
	_tmp2_ = _tmp1_;
#line 338 "../src/engine/api/geary-search-query.vala"
	_tmp3_ = other->priv->_expression;
#line 338 "../src/engine/api/geary-search-query.vala"
	_tmp4_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 338 "../src/engine/api/geary-search-query.vala"
	_tmp5_ = _tmp4_;
#line 338 "../src/engine/api/geary-search-query.vala"
	if (_tmp2_ != _tmp5_) {
#line 339 "../src/engine/api/geary-search-query.vala"
		result = FALSE;
#line 339 "../src/engine/api/geary-search-query.vala"
		return result;
#line 509 "geary-search-query.c"
	}
	{
		gint i = 0;
#line 341 "../src/engine/api/geary-search-query.vala"
		i = 0;
#line 515 "geary-search-query.c"
		{
			gboolean _tmp6_ = FALSE;
#line 341 "../src/engine/api/geary-search-query.vala"
			_tmp6_ = TRUE;
#line 341 "../src/engine/api/geary-search-query.vala"
			while (TRUE) {
#line 522 "geary-search-query.c"
				GeeList* _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
				GeeList* _tmp11_;
				gpointer _tmp12_;
				GearySearchQueryTerm* _tmp13_;
				GeeList* _tmp14_;
				gpointer _tmp15_;
				GearySearchQueryTerm* _tmp16_;
				gboolean _tmp17_;
#line 341 "../src/engine/api/geary-search-query.vala"
				if (!_tmp6_) {
#line 535 "geary-search-query.c"
					gint _tmp7_;
#line 341 "../src/engine/api/geary-search-query.vala"
					_tmp7_ = i;
#line 341 "../src/engine/api/geary-search-query.vala"
					i = _tmp7_ + 1;
#line 541 "geary-search-query.c"
				}
#line 341 "../src/engine/api/geary-search-query.vala"
				_tmp6_ = FALSE;
#line 341 "../src/engine/api/geary-search-query.vala"
				_tmp8_ = self->priv->_expression;
#line 341 "../src/engine/api/geary-search-query.vala"
				_tmp9_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_COLLECTION, GeeCollection));
#line 341 "../src/engine/api/geary-search-query.vala"
				_tmp10_ = _tmp9_;
#line 341 "../src/engine/api/geary-search-query.vala"
				if (!(i < _tmp10_)) {
#line 341 "../src/engine/api/geary-search-query.vala"
					break;
#line 555 "geary-search-query.c"
				}
#line 342 "../src/engine/api/geary-search-query.vala"
				_tmp11_ = self->priv->_expression;
#line 342 "../src/engine/api/geary-search-query.vala"
				_tmp12_ = gee_list_get (_tmp11_, i);
#line 342 "../src/engine/api/geary-search-query.vala"
				_tmp13_ = (GearySearchQueryTerm*) _tmp12_;
#line 342 "../src/engine/api/geary-search-query.vala"
				_tmp14_ = other->priv->_expression;
#line 342 "../src/engine/api/geary-search-query.vala"
				_tmp15_ = gee_list_get (_tmp14_, i);
#line 342 "../src/engine/api/geary-search-query.vala"
				_tmp16_ = (GearySearchQueryTerm*) _tmp15_;
#line 342 "../src/engine/api/geary-search-query.vala"
				_tmp17_ = !geary_search_query_term_equal_to (_tmp13_, _tmp16_);
#line 342 "../src/engine/api/geary-search-query.vala"
				_g_object_unref0 (_tmp16_);
#line 342 "../src/engine/api/geary-search-query.vala"
				_g_object_unref0 (_tmp13_);
#line 342 "../src/engine/api/geary-search-query.vala"
				if (_tmp17_) {
#line 343 "../src/engine/api/geary-search-query.vala"
					result = FALSE;
#line 343 "../src/engine/api/geary-search-query.vala"
					return result;
#line 581 "geary-search-query.c"
				}
			}
		}
	}
#line 346 "../src/engine/api/geary-search-query.vala"
	result = TRUE;
#line 346 "../src/engine/api/geary-search-query.vala"
	return result;
#line 590 "geary-search-query.c"
}

/** Returns a string representation of this query, for debugging. */
gchar*
geary_search_query_to_string (GearySearchQuery* self)
{
	GString* builder = NULL;
	GString* _tmp0_;
	GString* _tmp1_;
	const gchar* _tmp2_;
	GeeIterator* iter = NULL;
	GeeList* _tmp3_;
	GeeIterator* _tmp4_;
	GeeIterator* _tmp5_;
	GString* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* result;
#line 350 "../src/engine/api/geary-search-query.vala"
	g_return_val_if_fail (GEARY_IS_SEARCH_QUERY (self), NULL);
#line 351 "../src/engine/api/geary-search-query.vala"
	_tmp0_ = g_string_new ("");
#line 351 "../src/engine/api/geary-search-query.vala"
	builder = _tmp0_;
#line 352 "../src/engine/api/geary-search-query.vala"
	_tmp1_ = builder;
#line 352 "../src/engine/api/geary-search-query.vala"
	_tmp2_ = self->priv->_raw;
#line 352 "../src/engine/api/geary-search-query.vala"
	g_string_append_printf (_tmp1_, "\"%s\": ", _tmp2_);
#line 354 "../src/engine/api/geary-search-query.vala"
	_tmp3_ = self->priv->_expression;
#line 354 "../src/engine/api/geary-search-query.vala"
	_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 354 "../src/engine/api/geary-search-query.vala"
	iter = _tmp4_;
#line 355 "../src/engine/api/geary-search-query.vala"
	_tmp5_ = iter;
#line 355 "../src/engine/api/geary-search-query.vala"
	if (gee_iterator_next (_tmp5_)) {
#line 631 "geary-search-query.c"
		GString* _tmp6_;
		GeeIterator* _tmp7_;
		gpointer _tmp8_;
		GearySearchQueryTerm* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 356 "../src/engine/api/geary-search-query.vala"
		_tmp6_ = builder;
#line 356 "../src/engine/api/geary-search-query.vala"
		_tmp7_ = iter;
#line 356 "../src/engine/api/geary-search-query.vala"
		_tmp8_ = gee_iterator_get (_tmp7_);
#line 356 "../src/engine/api/geary-search-query.vala"
		_tmp9_ = (GearySearchQueryTerm*) _tmp8_;
#line 356 "../src/engine/api/geary-search-query.vala"
		_tmp10_ = geary_search_query_term_to_string (_tmp9_);
#line 356 "../src/engine/api/geary-search-query.vala"
		_tmp11_ = _tmp10_;
#line 356 "../src/engine/api/geary-search-query.vala"
		g_string_append (_tmp6_, _tmp11_);
#line 356 "../src/engine/api/geary-search-query.vala"
		_g_free0 (_tmp11_);
#line 356 "../src/engine/api/geary-search-query.vala"
		_g_object_unref0 (_tmp9_);
#line 656 "geary-search-query.c"
	}
#line 358 "../src/engine/api/geary-search-query.vala"
	while (TRUE) {
#line 660 "geary-search-query.c"
		GeeIterator* _tmp12_;
		GString* _tmp13_;
		GString* _tmp14_;
		GeeIterator* _tmp15_;
		gpointer _tmp16_;
		GearySearchQueryTerm* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 358 "../src/engine/api/geary-search-query.vala"
		_tmp12_ = iter;
#line 358 "../src/engine/api/geary-search-query.vala"
		if (!gee_iterator_next (_tmp12_)) {
#line 358 "../src/engine/api/geary-search-query.vala"
			break;
#line 675 "geary-search-query.c"
		}
#line 359 "../src/engine/api/geary-search-query.vala"
		_tmp13_ = builder;
#line 359 "../src/engine/api/geary-search-query.vala"
		g_string_append_c (_tmp13_, ',');
#line 360 "../src/engine/api/geary-search-query.vala"
		_tmp14_ = builder;
#line 360 "../src/engine/api/geary-search-query.vala"
		_tmp15_ = iter;
#line 360 "../src/engine/api/geary-search-query.vala"
		_tmp16_ = gee_iterator_get (_tmp15_);
#line 360 "../src/engine/api/geary-search-query.vala"
		_tmp17_ = (GearySearchQueryTerm*) _tmp16_;
#line 360 "../src/engine/api/geary-search-query.vala"
		_tmp18_ = geary_search_query_term_to_string (_tmp17_);
#line 360 "../src/engine/api/geary-search-query.vala"
		_tmp19_ = _tmp18_;
#line 360 "../src/engine/api/geary-search-query.vala"
		g_string_append (_tmp14_, _tmp19_);
#line 360 "../src/engine/api/geary-search-query.vala"
		_g_free0 (_tmp19_);
#line 360 "../src/engine/api/geary-search-query.vala"
		_g_object_unref0 (_tmp17_);
#line 699 "geary-search-query.c"
	}
#line 362 "../src/engine/api/geary-search-query.vala"
	_tmp20_ = builder;
#line 362 "../src/engine/api/geary-search-query.vala"
	_tmp21_ = _tmp20_->str;
#line 362 "../src/engine/api/geary-search-query.vala"
	_tmp22_ = g_strdup (_tmp21_);
#line 362 "../src/engine/api/geary-search-query.vala"
	result = _tmp22_;
#line 362 "../src/engine/api/geary-search-query.vala"
	_g_object_unref0 (iter);
#line 362 "../src/engine/api/geary-search-query.vala"
	_g_string_free0 (builder);
#line 362 "../src/engine/api/geary-search-query.vala"
	return result;
#line 715 "geary-search-query.c"
}

static inline gpointer
geary_search_query_term_get_instance_private (GearySearchQueryTerm* self)
{
	return G_STRUCT_MEMBER_P (self, GearySearchQueryTerm_private_offset);
}

gboolean
geary_search_query_term_get_is_negated (GearySearchQueryTerm* self)
{
	gboolean result;
#line 135 "../src/engine/api/geary-search-query.vala"
	g_return_val_if_fail (GEARY_SEARCH_QUERY_IS_TERM (self), FALSE);
#line 135 "../src/engine/api/geary-search-query.vala"
	result = self->priv->_is_negated;
#line 135 "../src/engine/api/geary-search-query.vala"
	return result;
#line 734 "geary-search-query.c"
}

void
geary_search_query_term_set_is_negated (GearySearchQueryTerm* self,
                                        gboolean value)
{
	gboolean old_value;
#line 135 "../src/engine/api/geary-search-query.vala"
	g_return_if_fail (GEARY_SEARCH_QUERY_IS_TERM (self));
#line 135 "../src/engine/api/geary-search-query.vala"
	old_value = geary_search_query_term_get_is_negated (self);
#line 135 "../src/engine/api/geary-search-query.vala"
	if (old_value != value) {
#line 135 "../src/engine/api/geary-search-query.vala"
		self->priv->_is_negated = value;
#line 135 "../src/engine/api/geary-search-query.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_search_query_term_properties[GEARY_SEARCH_QUERY_TERM_IS_NEGATED_PROPERTY]);
#line 752 "geary-search-query.c"
	}
}

/** Determines if this term is equal to another. */
static gboolean
geary_search_query_term_real_equal_to (GearySearchQueryTerm* self,
                                       GearySearchQueryTerm* other)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 138 "../src/engine/api/geary-search-query.vala"
	g_return_val_if_fail (GEARY_SEARCH_QUERY_IS_TERM (other), FALSE);
#line 139 "../src/engine/api/geary-search-query.vala"
	_tmp1_ = self->priv->_is_negated;
#line 139 "../src/engine/api/geary-search-query.vala"
	_tmp2_ = other->priv->_is_negated;
#line 139 "../src/engine/api/geary-search-query.vala"
	if (_tmp1_ == _tmp2_) {
#line 141 "../src/engine/api/geary-search-query.vala"
		_tmp0_ = G_TYPE_FROM_INSTANCE (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject)) == G_TYPE_FROM_INSTANCE (G_TYPE_CHECK_INSTANCE_CAST (other, G_TYPE_OBJECT, GObject));
#line 775 "geary-search-query.c"
	} else {
#line 140 "../src/engine/api/geary-search-query.vala"
		_tmp0_ = FALSE;
#line 779 "geary-search-query.c"
	}
#line 139 "../src/engine/api/geary-search-query.vala"
	result = _tmp0_;
#line 139 "../src/engine/api/geary-search-query.vala"
	return result;
#line 785 "geary-search-query.c"
}

gboolean
geary_search_query_term_equal_to (GearySearchQueryTerm* self,
                                  GearySearchQueryTerm* other)
{
	GearySearchQueryTermClass* _klass_;
#line 138 "../src/engine/api/geary-search-query.vala"
	g_return_val_if_fail (GEARY_SEARCH_QUERY_IS_TERM (self), FALSE);
#line 138 "../src/engine/api/geary-search-query.vala"
	_klass_ = GEARY_SEARCH_QUERY_TERM_GET_CLASS (self);
#line 138 "../src/engine/api/geary-search-query.vala"
	if (_klass_->equal_to) {
#line 138 "../src/engine/api/geary-search-query.vala"
		return _klass_->equal_to (self, other);
#line 801 "geary-search-query.c"
	}
#line 138 "../src/engine/api/geary-search-query.vala"
	return FALSE;
#line 805 "geary-search-query.c"
}

/** Returns a string representation, for debugging. */
static gchar*
geary_search_query_term_real_to_string (GearySearchQueryTerm* self)
{
#line 146 "../src/engine/api/geary-search-query.vala"
	g_critical ("Type `%s' does not implement abstract method `geary_search_query_term_to_string'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 146 "../src/engine/api/geary-search-query.vala"
	return NULL;
#line 816 "geary-search-query.c"
}

gchar*
geary_search_query_term_to_string (GearySearchQueryTerm* self)
{
	GearySearchQueryTermClass* _klass_;
#line 146 "../src/engine/api/geary-search-query.vala"
	g_return_val_if_fail (GEARY_SEARCH_QUERY_IS_TERM (self), NULL);
#line 146 "../src/engine/api/geary-search-query.vala"
	_klass_ = GEARY_SEARCH_QUERY_TERM_GET_CLASS (self);
#line 146 "../src/engine/api/geary-search-query.vala"
	if (_klass_->to_string) {
#line 146 "../src/engine/api/geary-search-query.vala"
		return _klass_->to_string (self);
#line 831 "geary-search-query.c"
	}
#line 146 "../src/engine/api/geary-search-query.vala"
	return NULL;
#line 835 "geary-search-query.c"
}

GearySearchQueryTerm*
geary_search_query_term_construct (GType object_type)
{
	GearySearchQueryTerm * self = NULL;
#line 132 "../src/engine/api/geary-search-query.vala"
	self = (GearySearchQueryTerm*) geary_base_object_construct (object_type);
#line 132 "../src/engine/api/geary-search-query.vala"
	return self;
#line 846 "geary-search-query.c"
}

static void
geary_search_query_term_class_init (GearySearchQueryTermClass * klass,
                                    gpointer klass_data)
{
#line 132 "../src/engine/api/geary-search-query.vala"
	geary_search_query_term_parent_class = g_type_class_peek_parent (klass);
#line 132 "../src/engine/api/geary-search-query.vala"
	g_type_class_adjust_private_offset (klass, &GearySearchQueryTerm_private_offset);
#line 132 "../src/engine/api/geary-search-query.vala"
	((GearySearchQueryTermClass *) klass)->equal_to = (gboolean (*) (GearySearchQueryTerm*, GearySearchQueryTerm*)) geary_search_query_term_real_equal_to;
#line 132 "../src/engine/api/geary-search-query.vala"
	((GearySearchQueryTermClass *) klass)->to_string = (gchar* (*) (GearySearchQueryTerm*)) geary_search_query_term_real_to_string;
#line 132 "../src/engine/api/geary-search-query.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_search_query_term_get_property;
#line 132 "../src/engine/api/geary-search-query.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_search_query_term_set_property;
#line 132 "../src/engine/api/geary-search-query.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_search_query_term_finalize;
#line 867 "geary-search-query.c"
	/** Determines opposite of the term is matched. */
#line 132 "../src/engine/api/geary-search-query.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SEARCH_QUERY_TERM_IS_NEGATED_PROPERTY, geary_search_query_term_properties[GEARY_SEARCH_QUERY_TERM_IS_NEGATED_PROPERTY] = g_param_spec_boolean ("is-negated", "is-negated", "is-negated", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 871 "geary-search-query.c"
}

static void
geary_search_query_term_instance_init (GearySearchQueryTerm * self,
                                       gpointer klass)
{
#line 132 "../src/engine/api/geary-search-query.vala"
	self->priv = geary_search_query_term_get_instance_private (self);
#line 135 "../src/engine/api/geary-search-query.vala"
	self->priv->_is_negated = FALSE;
#line 882 "geary-search-query.c"
}

static void
geary_search_query_term_finalize (GObject * obj)
{
	GearySearchQueryTerm * self;
#line 132 "../src/engine/api/geary-search-query.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_SEARCH_QUERY_TYPE_TERM, GearySearchQueryTerm);
#line 132 "../src/engine/api/geary-search-query.vala"
	G_OBJECT_CLASS (geary_search_query_term_parent_class)->finalize (obj);
#line 893 "geary-search-query.c"
}

/**
     * Parent class for terms that make up a search query's expression.
     *
     * @see SearchQuery.expression
     */
 G_GNUC_NO_INLINE static GType
geary_search_query_term_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearySearchQueryTermClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_search_query_term_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearySearchQueryTerm), 0, (GInstanceInitFunc) geary_search_query_term_instance_init, NULL };
	GType geary_search_query_term_type_id;
	geary_search_query_term_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearySearchQueryTerm", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	GearySearchQueryTerm_private_offset = g_type_add_instance_private (geary_search_query_term_type_id, sizeof (GearySearchQueryTermPrivate));
	return geary_search_query_term_type_id;
}

GType
geary_search_query_term_get_type (void)
{
	static gsize geary_search_query_term_type_id__once = 0;
	if (g_once_init_enter (&geary_search_query_term_type_id__once)) {
		GType geary_search_query_term_type_id;
		geary_search_query_term_type_id = geary_search_query_term_get_type_once ();
		g_once_init_leave (&geary_search_query_term_type_id__once, geary_search_query_term_type_id);
	}
	return geary_search_query_term_type_id__once;
}

static void
_vala_geary_search_query_term_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	GearySearchQueryTerm * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_SEARCH_QUERY_TYPE_TERM, GearySearchQueryTerm);
#line 132 "../src/engine/api/geary-search-query.vala"
	switch (property_id) {
#line 132 "../src/engine/api/geary-search-query.vala"
		case GEARY_SEARCH_QUERY_TERM_IS_NEGATED_PROPERTY:
#line 132 "../src/engine/api/geary-search-query.vala"
		g_value_set_boolean (value, geary_search_query_term_get_is_negated (self));
#line 132 "../src/engine/api/geary-search-query.vala"
		break;
#line 939 "geary-search-query.c"
		default:
#line 132 "../src/engine/api/geary-search-query.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 132 "../src/engine/api/geary-search-query.vala"
		break;
#line 945 "geary-search-query.c"
	}
}

static void
_vala_geary_search_query_term_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	GearySearchQueryTerm * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_SEARCH_QUERY_TYPE_TERM, GearySearchQueryTerm);
#line 132 "../src/engine/api/geary-search-query.vala"
	switch (property_id) {
#line 132 "../src/engine/api/geary-search-query.vala"
		case GEARY_SEARCH_QUERY_TERM_IS_NEGATED_PROPERTY:
#line 132 "../src/engine/api/geary-search-query.vala"
		geary_search_query_term_set_is_negated (self, g_value_get_boolean (value));
#line 132 "../src/engine/api/geary-search-query.vala"
		break;
#line 965 "geary-search-query.c"
		default:
#line 132 "../src/engine/api/geary-search-query.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 132 "../src/engine/api/geary-search-query.vala"
		break;
#line 971 "geary-search-query.c"
	}
}

static inline gpointer
geary_search_query_email_text_term_get_instance_private (GearySearchQueryEmailTextTerm* self)
{
	return G_STRUCT_MEMBER_P (self, GearySearchQueryEmailTextTerm_private_offset);
}

/**
         * Supported text email properties that can be queried.
         *
         * @see EmailTextTerm
         */
 G_GNUC_NO_INLINE static GType
geary_search_query_email_text_term_property_get_type_once (void)
{
	static const GEnumValue values[] = {{GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_PROPERTY_ALL, "GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_PROPERTY_ALL", "all"}, {GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_PROPERTY_TO, "GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_PROPERTY_TO", "to"}, {GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_PROPERTY_CC, "GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_PROPERTY_CC", "cc"}, {GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_PROPERTY_BCC, "GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_PROPERTY_BCC", "bcc"}, {GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_PROPERTY_FROM, "GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_PROPERTY_FROM", "from"}, {GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_PROPERTY_SUBJECT, "GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_PROPERTY_SUBJECT", "subject"}, {GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_PROPERTY_BODY, "GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_PROPERTY_BODY", "body"}, {GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_PROPERTY_ATTACHMENT_NAME, "GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_PROPERTY_ATTACHMENT_NAME", "attachment-name"}, {0, NULL, NULL}};
	GType geary_search_query_email_text_term_property_type_id;
	geary_search_query_email_text_term_property_type_id = g_enum_register_static ("GearySearchQueryEmailTextTermProperty", values);
	return geary_search_query_email_text_term_property_type_id;
}

GType
geary_search_query_email_text_term_property_get_type (void)
{
	static gsize geary_search_query_email_text_term_property_type_id__once = 0;
	if (g_once_init_enter (&geary_search_query_email_text_term_property_type_id__once)) {
		GType geary_search_query_email_text_term_property_type_id;
		geary_search_query_email_text_term_property_type_id = geary_search_query_email_text_term_property_get_type_once ();
		g_once_init_leave (&geary_search_query_email_text_term_property_type_id__once, geary_search_query_email_text_term_property_type_id);
	}
	return geary_search_query_email_text_term_property_type_id__once;
}

GearySearchQueryEmailTextTermProperty
geary_search_query_email_text_term_get_target (GearySearchQueryEmailTextTerm* self)
{
	GearySearchQueryEmailTextTermProperty result;
#line 189 "../src/engine/api/geary-search-query.vala"
	g_return_val_if_fail (GEARY_SEARCH_QUERY_IS_EMAIL_TEXT_TERM (self), 0);
#line 189 "../src/engine/api/geary-search-query.vala"
	result = self->priv->_target;
#line 189 "../src/engine/api/geary-search-query.vala"
	return result;
#line 1017 "geary-search-query.c"
}

static void
geary_search_query_email_text_term_set_target (GearySearchQueryEmailTextTerm* self,
                                               GearySearchQueryEmailTextTermProperty value)
{
	GearySearchQueryEmailTextTermProperty old_value;
#line 189 "../src/engine/api/geary-search-query.vala"
	g_return_if_fail (GEARY_SEARCH_QUERY_IS_EMAIL_TEXT_TERM (self));
#line 189 "../src/engine/api/geary-search-query.vala"
	old_value = geary_search_query_email_text_term_get_target (self);
#line 189 "../src/engine/api/geary-search-query.vala"
	if (old_value != value) {
#line 189 "../src/engine/api/geary-search-query.vala"
		self->priv->_target = value;
#line 189 "../src/engine/api/geary-search-query.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_search_query_email_text_term_properties[GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_TARGET_PROPERTY]);
#line 1035 "geary-search-query.c"
	}
}

GearySearchQueryStrategy
geary_search_query_email_text_term_get_matching_strategy (GearySearchQueryEmailTextTerm* self)
{
	GearySearchQueryStrategy result;
#line 192 "../src/engine/api/geary-search-query.vala"
	g_return_val_if_fail (GEARY_SEARCH_QUERY_IS_EMAIL_TEXT_TERM (self), 0);
#line 192 "../src/engine/api/geary-search-query.vala"
	result = self->priv->_matching_strategy;
#line 192 "../src/engine/api/geary-search-query.vala"
	return result;
#line 1049 "geary-search-query.c"
}

static void
geary_search_query_email_text_term_set_matching_strategy (GearySearchQueryEmailTextTerm* self,
                                                          GearySearchQueryStrategy value)
{
	GearySearchQueryStrategy old_value;
#line 192 "../src/engine/api/geary-search-query.vala"
	g_return_if_fail (GEARY_SEARCH_QUERY_IS_EMAIL_TEXT_TERM (self));
#line 192 "../src/engine/api/geary-search-query.vala"
	old_value = geary_search_query_email_text_term_get_matching_strategy (self);
#line 192 "../src/engine/api/geary-search-query.vala"
	if (old_value != value) {
#line 192 "../src/engine/api/geary-search-query.vala"
		self->priv->_matching_strategy = value;
#line 192 "../src/engine/api/geary-search-query.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_search_query_email_text_term_properties[GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_MATCHING_STRATEGY_PROPERTY]);
#line 1067 "geary-search-query.c"
	}
}

GeeList*
geary_search_query_email_text_term_get_terms (GearySearchQueryEmailTextTerm* self)
{
	GeeList* result;
	GeeList* _tmp0_;
#line 202 "../src/engine/api/geary-search-query.vala"
	g_return_val_if_fail (GEARY_SEARCH_QUERY_IS_EMAIL_TEXT_TERM (self), NULL);
#line 202 "../src/engine/api/geary-search-query.vala"
	_tmp0_ = self->priv->_terms;
#line 202 "../src/engine/api/geary-search-query.vala"
	result = _tmp0_;
#line 202 "../src/engine/api/geary-search-query.vala"
	return result;
#line 1084 "geary-search-query.c"
}

static void
geary_search_query_email_text_term_set_terms (GearySearchQueryEmailTextTerm* self,
                                              GeeList* value)
{
	GeeList* old_value;
#line 202 "../src/engine/api/geary-search-query.vala"
	g_return_if_fail (GEARY_SEARCH_QUERY_IS_EMAIL_TEXT_TERM (self));
#line 202 "../src/engine/api/geary-search-query.vala"
	old_value = geary_search_query_email_text_term_get_terms (self);
#line 202 "../src/engine/api/geary-search-query.vala"
	if (old_value != value) {
#line 1098 "geary-search-query.c"
		GeeList* _tmp0_;
#line 202 "../src/engine/api/geary-search-query.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 202 "../src/engine/api/geary-search-query.vala"
		_g_object_unref0 (self->priv->_terms);
#line 202 "../src/engine/api/geary-search-query.vala"
		self->priv->_terms = _tmp0_;
#line 202 "../src/engine/api/geary-search-query.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_search_query_email_text_term_properties[GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_TERMS_PROPERTY]);
#line 1108 "geary-search-query.c"
	}
}

GearySearchQueryEmailTextTerm*
geary_search_query_email_text_term_construct (GType object_type,
                                              GearySearchQueryEmailTextTermProperty target,
                                              GearySearchQueryStrategy matching_strategy,
                                              const gchar* term)
{
	GearySearchQueryEmailTextTerm * self = NULL;
	GeeList* _tmp0_;
#line 206 "../src/engine/api/geary-search-query.vala"
	g_return_val_if_fail (term != NULL, NULL);
#line 206 "../src/engine/api/geary-search-query.vala"
	self = (GearySearchQueryEmailTextTerm*) geary_search_query_term_construct (object_type);
#line 209 "../src/engine/api/geary-search-query.vala"
	geary_search_query_email_text_term_set_target (self, target);
#line 210 "../src/engine/api/geary-search-query.vala"
	geary_search_query_email_text_term_set_matching_strategy (self, matching_strategy);
#line 211 "../src/engine/api/geary-search-query.vala"
	_tmp0_ = self->priv->_terms;
#line 211 "../src/engine/api/geary-search-query.vala"
	gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), term);
#line 206 "../src/engine/api/geary-search-query.vala"
	return self;
#line 1134 "geary-search-query.c"
}

GearySearchQueryEmailTextTerm*
geary_search_query_email_text_term_new (GearySearchQueryEmailTextTermProperty target,
                                        GearySearchQueryStrategy matching_strategy,
                                        const gchar* term)
{
#line 206 "../src/engine/api/geary-search-query.vala"
	return geary_search_query_email_text_term_construct (GEARY_SEARCH_QUERY_TYPE_EMAIL_TEXT_TERM, target, matching_strategy, term);
#line 1144 "geary-search-query.c"
}

GearySearchQueryEmailTextTerm*
geary_search_query_email_text_term_construct_disjunction (GType object_type,
                                                          GearySearchQueryEmailTextTermProperty target,
                                                          GearySearchQueryStrategy matching_strategy,
                                                          GeeList* terms)
{
	GearySearchQueryEmailTextTerm * self = NULL;
	GeeList* _tmp0_;
#line 214 "../src/engine/api/geary-search-query.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (terms, GEE_TYPE_LIST), NULL);
#line 214 "../src/engine/api/geary-search-query.vala"
	self = (GearySearchQueryEmailTextTerm*) geary_search_query_term_construct (object_type);
#line 217 "../src/engine/api/geary-search-query.vala"
	geary_search_query_email_text_term_set_target (self, target);
#line 218 "../src/engine/api/geary-search-query.vala"
	geary_search_query_email_text_term_set_matching_strategy (self, matching_strategy);
#line 219 "../src/engine/api/geary-search-query.vala"
	_tmp0_ = self->priv->_terms;
#line 219 "../src/engine/api/geary-search-query.vala"
	gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (terms, GEE_TYPE_COLLECTION, GeeCollection));
#line 214 "../src/engine/api/geary-search-query.vala"
	return self;
#line 1169 "geary-search-query.c"
}

GearySearchQueryEmailTextTerm*
geary_search_query_email_text_term_new_disjunction (GearySearchQueryEmailTextTermProperty target,
                                                    GearySearchQueryStrategy matching_strategy,
                                                    GeeList* terms)
{
#line 214 "../src/engine/api/geary-search-query.vala"
	return geary_search_query_email_text_term_construct_disjunction (GEARY_SEARCH_QUERY_TYPE_EMAIL_TEXT_TERM, target, matching_strategy, terms);
#line 1179 "geary-search-query.c"
}

static gboolean
geary_search_query_email_text_term_real_equal_to (GearySearchQueryTerm* base,
                                                  GearySearchQueryTerm* other)
{
	GearySearchQueryEmailTextTerm * self;
	GearySearchQueryEmailTextTerm* text = NULL;
	GearySearchQueryEmailTextTerm* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GearySearchQueryEmailTextTermProperty _tmp3_;
	GearySearchQueryEmailTextTerm* _tmp4_;
	GearySearchQueryEmailTextTermProperty _tmp5_;
	gboolean result;
#line 222 "../src/engine/api/geary-search-query.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_SEARCH_QUERY_TYPE_EMAIL_TEXT_TERM, GearySearchQueryEmailTextTerm);
#line 222 "../src/engine/api/geary-search-query.vala"
	g_return_val_if_fail (GEARY_SEARCH_QUERY_IS_TERM (other), FALSE);
#line 223 "../src/engine/api/geary-search-query.vala"
	if (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_SEARCH_QUERY_TYPE_TERM, GearySearchQueryTerm) == other) {
#line 224 "../src/engine/api/geary-search-query.vala"
		result = TRUE;
#line 224 "../src/engine/api/geary-search-query.vala"
		return result;
#line 1205 "geary-search-query.c"
	}
#line 226 "../src/engine/api/geary-search-query.vala"
	if (!GEARY_SEARCH_QUERY_TERM_CLASS (geary_search_query_email_text_term_parent_class)->equal_to (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_SEARCH_QUERY_TYPE_TERM, GearySearchQueryTerm), other)) {
#line 227 "../src/engine/api/geary-search-query.vala"
		result = FALSE;
#line 227 "../src/engine/api/geary-search-query.vala"
		return result;
#line 1213 "geary-search-query.c"
	}
#line 229 "../src/engine/api/geary-search-query.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (other, GEARY_SEARCH_QUERY_TYPE_EMAIL_TEXT_TERM, GearySearchQueryEmailTextTerm));
#line 229 "../src/engine/api/geary-search-query.vala"
	text = _tmp0_;
#line 230 "../src/engine/api/geary-search-query.vala"
	_tmp3_ = self->priv->_target;
#line 230 "../src/engine/api/geary-search-query.vala"
	_tmp4_ = text;
#line 230 "../src/engine/api/geary-search-query.vala"
	_tmp5_ = _tmp4_->priv->_target;
#line 230 "../src/engine/api/geary-search-query.vala"
	if (_tmp3_ != _tmp5_) {
#line 230 "../src/engine/api/geary-search-query.vala"
		_tmp2_ = TRUE;
#line 1229 "geary-search-query.c"
	} else {
		GearySearchQueryStrategy _tmp6_;
		GearySearchQueryEmailTextTerm* _tmp7_;
		GearySearchQueryStrategy _tmp8_;
#line 231 "../src/engine/api/geary-search-query.vala"
		_tmp6_ = self->priv->_matching_strategy;
#line 231 "../src/engine/api/geary-search-query.vala"
		_tmp7_ = text;
#line 231 "../src/engine/api/geary-search-query.vala"
		_tmp8_ = _tmp7_->priv->_matching_strategy;
#line 231 "../src/engine/api/geary-search-query.vala"
		_tmp2_ = _tmp6_ != _tmp8_;
#line 1242 "geary-search-query.c"
	}
#line 230 "../src/engine/api/geary-search-query.vala"
	if (_tmp2_) {
#line 230 "../src/engine/api/geary-search-query.vala"
		_tmp1_ = TRUE;
#line 1248 "geary-search-query.c"
	} else {
		GeeList* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		GearySearchQueryEmailTextTerm* _tmp12_;
		GeeList* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
#line 232 "../src/engine/api/geary-search-query.vala"
		_tmp9_ = self->priv->_terms;
#line 232 "../src/engine/api/geary-search-query.vala"
		_tmp10_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_COLLECTION, GeeCollection));
#line 232 "../src/engine/api/geary-search-query.vala"
		_tmp11_ = _tmp10_;
#line 232 "../src/engine/api/geary-search-query.vala"
		_tmp12_ = text;
#line 232 "../src/engine/api/geary-search-query.vala"
		_tmp13_ = _tmp12_->priv->_terms;
#line 232 "../src/engine/api/geary-search-query.vala"
		_tmp14_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_COLLECTION, GeeCollection));
#line 232 "../src/engine/api/geary-search-query.vala"
		_tmp15_ = _tmp14_;
#line 232 "../src/engine/api/geary-search-query.vala"
		_tmp1_ = _tmp11_ != _tmp15_;
#line 1273 "geary-search-query.c"
	}
#line 230 "../src/engine/api/geary-search-query.vala"
	if (_tmp1_) {
#line 233 "../src/engine/api/geary-search-query.vala"
		result = FALSE;
#line 233 "../src/engine/api/geary-search-query.vala"
		_g_object_unref0 (text);
#line 233 "../src/engine/api/geary-search-query.vala"
		return result;
#line 1283 "geary-search-query.c"
	}
	{
		gint i = 0;
#line 235 "../src/engine/api/geary-search-query.vala"
		i = 0;
#line 1289 "geary-search-query.c"
		{
			gboolean _tmp16_ = FALSE;
#line 235 "../src/engine/api/geary-search-query.vala"
			_tmp16_ = TRUE;
#line 235 "../src/engine/api/geary-search-query.vala"
			while (TRUE) {
#line 1296 "geary-search-query.c"
				GeeList* _tmp18_;
				gint _tmp19_;
				gint _tmp20_;
				GeeList* _tmp21_;
				gpointer _tmp22_;
				gchar* _tmp23_;
				GearySearchQueryEmailTextTerm* _tmp24_;
				GeeList* _tmp25_;
				gpointer _tmp26_;
				gchar* _tmp27_;
				gboolean _tmp28_;
#line 235 "../src/engine/api/geary-search-query.vala"
				if (!_tmp16_) {
#line 1310 "geary-search-query.c"
					gint _tmp17_;
#line 235 "../src/engine/api/geary-search-query.vala"
					_tmp17_ = i;
#line 235 "../src/engine/api/geary-search-query.vala"
					i = _tmp17_ + 1;
#line 1316 "geary-search-query.c"
				}
#line 235 "../src/engine/api/geary-search-query.vala"
				_tmp16_ = FALSE;
#line 235 "../src/engine/api/geary-search-query.vala"
				_tmp18_ = self->priv->_terms;
#line 235 "../src/engine/api/geary-search-query.vala"
				_tmp19_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_COLLECTION, GeeCollection));
#line 235 "../src/engine/api/geary-search-query.vala"
				_tmp20_ = _tmp19_;
#line 235 "../src/engine/api/geary-search-query.vala"
				if (!(i < _tmp20_)) {
#line 235 "../src/engine/api/geary-search-query.vala"
					break;
#line 1330 "geary-search-query.c"
				}
#line 236 "../src/engine/api/geary-search-query.vala"
				_tmp21_ = self->priv->_terms;
#line 236 "../src/engine/api/geary-search-query.vala"
				_tmp22_ = gee_list_get (_tmp21_, i);
#line 236 "../src/engine/api/geary-search-query.vala"
				_tmp23_ = (gchar*) _tmp22_;
#line 236 "../src/engine/api/geary-search-query.vala"
				_tmp24_ = text;
#line 236 "../src/engine/api/geary-search-query.vala"
				_tmp25_ = _tmp24_->priv->_terms;
#line 236 "../src/engine/api/geary-search-query.vala"
				_tmp26_ = gee_list_get (_tmp25_, i);
#line 236 "../src/engine/api/geary-search-query.vala"
				_tmp27_ = (gchar*) _tmp26_;
#line 236 "../src/engine/api/geary-search-query.vala"
				_tmp28_ = g_strcmp0 (_tmp23_, _tmp27_) != 0;
#line 236 "../src/engine/api/geary-search-query.vala"
				_g_free0 (_tmp27_);
#line 236 "../src/engine/api/geary-search-query.vala"
				_g_free0 (_tmp23_);
#line 236 "../src/engine/api/geary-search-query.vala"
				if (_tmp28_) {
#line 237 "../src/engine/api/geary-search-query.vala"
					result = FALSE;
#line 237 "../src/engine/api/geary-search-query.vala"
					_g_object_unref0 (text);
#line 237 "../src/engine/api/geary-search-query.vala"
					return result;
#line 1360 "geary-search-query.c"
				}
			}
		}
	}
#line 240 "../src/engine/api/geary-search-query.vala"
	result = TRUE;
#line 240 "../src/engine/api/geary-search-query.vala"
	_g_object_unref0 (text);
#line 240 "../src/engine/api/geary-search-query.vala"
	return result;
#line 1371 "geary-search-query.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 1384 "geary-search-query.c"
}

static gchar*
geary_search_query_email_text_term_real_to_string (GearySearchQueryTerm* base)
{
	GearySearchQueryEmailTextTerm * self;
	GString* builder = NULL;
	GString* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GString* _tmp4_;
	GearySearchQueryEmailTextTermProperty _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GString* _tmp10_;
	GString* _tmp11_;
	GearySearchQueryStrategy _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	GString* _tmp17_;
	GeeIterator* iter = NULL;
	GeeList* _tmp18_;
	GeeIterator* _tmp19_;
	GeeIterator* _tmp20_;
	GString* _tmp33_;
	GString* _tmp34_;
	const gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* result;
#line 243 "../src/engine/api/geary-search-query.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_SEARCH_QUERY_TYPE_EMAIL_TEXT_TERM, GearySearchQueryEmailTextTerm);
#line 244 "../src/engine/api/geary-search-query.vala"
	_tmp0_ = g_string_new ("");
#line 244 "../src/engine/api/geary-search-query.vala"
	builder = _tmp0_;
#line 245 "../src/engine/api/geary-search-query.vala"
	_tmp1_ = geary_search_query_term_get_is_negated (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_SEARCH_QUERY_TYPE_TERM, GearySearchQueryTerm));
#line 245 "../src/engine/api/geary-search-query.vala"
	_tmp2_ = _tmp1_;
#line 245 "../src/engine/api/geary-search-query.vala"
	if (_tmp2_) {
#line 1430 "geary-search-query.c"
		GString* _tmp3_;
#line 246 "../src/engine/api/geary-search-query.vala"
		_tmp3_ = builder;
#line 246 "../src/engine/api/geary-search-query.vala"
		g_string_append_c (_tmp3_, '!');
#line 1436 "geary-search-query.c"
	}
#line 249 "../src/engine/api/geary-search-query.vala"
	_tmp4_ = builder;
#line 249 "../src/engine/api/geary-search-query.vala"
	_tmp5_ = self->priv->_target;
#line 249 "../src/engine/api/geary-search-query.vala"
	_tmp6_ = geary_object_utils_to_enum_nick (GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_TYPE_PROPERTY, NULL, NULL, GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_TYPE_PROPERTY, (gpointer) ((gintptr) _tmp5_));
#line 249 "../src/engine/api/geary-search-query.vala"
	_tmp7_ = _tmp6_;
#line 249 "../src/engine/api/geary-search-query.vala"
	_tmp8_ = g_utf8_strup (_tmp7_, (gssize) -1);
#line 249 "../src/engine/api/geary-search-query.vala"
	_tmp9_ = _tmp8_;
#line 249 "../src/engine/api/geary-search-query.vala"
	g_string_append (_tmp4_, _tmp9_);
#line 249 "../src/engine/api/geary-search-query.vala"
	_g_free0 (_tmp9_);
#line 249 "../src/engine/api/geary-search-query.vala"
	_g_free0 (_tmp7_);
#line 253 "../src/engine/api/geary-search-query.vala"
	_tmp10_ = builder;
#line 253 "../src/engine/api/geary-search-query.vala"
	g_string_append_c (_tmp10_, ':');
#line 254 "../src/engine/api/geary-search-query.vala"
	_tmp11_ = builder;
#line 254 "../src/engine/api/geary-search-query.vala"
	_tmp12_ = self->priv->_matching_strategy;
#line 254 "../src/engine/api/geary-search-query.vala"
	_tmp13_ = geary_object_utils_to_enum_nick (GEARY_SEARCH_QUERY_TYPE_STRATEGY, NULL, NULL, GEARY_SEARCH_QUERY_TYPE_STRATEGY, (gpointer) ((gintptr) _tmp12_));
#line 254 "../src/engine/api/geary-search-query.vala"
	_tmp14_ = _tmp13_;
#line 254 "../src/engine/api/geary-search-query.vala"
	_tmp15_ = g_utf8_strup (_tmp14_, (gssize) -1);
#line 254 "../src/engine/api/geary-search-query.vala"
	_tmp16_ = _tmp15_;
#line 254 "../src/engine/api/geary-search-query.vala"
	g_string_append (_tmp11_, _tmp16_);
#line 254 "../src/engine/api/geary-search-query.vala"
	_g_free0 (_tmp16_);
#line 254 "../src/engine/api/geary-search-query.vala"
	_g_free0 (_tmp14_);
#line 259 "../src/engine/api/geary-search-query.vala"
	_tmp17_ = builder;
#line 259 "../src/engine/api/geary-search-query.vala"
	g_string_append_c (_tmp17_, '(');
#line 261 "../src/engine/api/geary-search-query.vala"
	_tmp18_ = self->priv->_terms;
#line 261 "../src/engine/api/geary-search-query.vala"
	_tmp19_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_ITERABLE, GeeIterable));
#line 261 "../src/engine/api/geary-search-query.vala"
	iter = _tmp19_;
#line 262 "../src/engine/api/geary-search-query.vala"
	_tmp20_ = iter;
#line 262 "../src/engine/api/geary-search-query.vala"
	if (gee_iterator_next (_tmp20_)) {
#line 1492 "geary-search-query.c"
		GString* _tmp21_;
		GeeIterator* _tmp22_;
		gpointer _tmp23_;
		gchar* _tmp24_;
		const gchar* _tmp25_;
#line 263 "../src/engine/api/geary-search-query.vala"
		_tmp21_ = builder;
#line 263 "../src/engine/api/geary-search-query.vala"
		_tmp22_ = iter;
#line 263 "../src/engine/api/geary-search-query.vala"
		_tmp23_ = gee_iterator_get (_tmp22_);
#line 263 "../src/engine/api/geary-search-query.vala"
		_tmp24_ = (gchar*) _tmp23_;
#line 263 "../src/engine/api/geary-search-query.vala"
		_tmp25_ = string_to_string (_tmp24_);
#line 263 "../src/engine/api/geary-search-query.vala"
		g_string_append (_tmp21_, _tmp25_);
#line 263 "../src/engine/api/geary-search-query.vala"
		_g_free0 (_tmp24_);
#line 1512 "geary-search-query.c"
	}
#line 265 "../src/engine/api/geary-search-query.vala"
	while (TRUE) {
#line 1516 "geary-search-query.c"
		GeeIterator* _tmp26_;
		GString* _tmp27_;
		GString* _tmp28_;
		GeeIterator* _tmp29_;
		gpointer _tmp30_;
		gchar* _tmp31_;
		const gchar* _tmp32_;
#line 265 "../src/engine/api/geary-search-query.vala"
		_tmp26_ = iter;
#line 265 "../src/engine/api/geary-search-query.vala"
		if (!gee_iterator_next (_tmp26_)) {
#line 265 "../src/engine/api/geary-search-query.vala"
			break;
#line 1530 "geary-search-query.c"
		}
#line 266 "../src/engine/api/geary-search-query.vala"
		_tmp27_ = builder;
#line 266 "../src/engine/api/geary-search-query.vala"
		g_string_append_c (_tmp27_, ',');
#line 267 "../src/engine/api/geary-search-query.vala"
		_tmp28_ = builder;
#line 267 "../src/engine/api/geary-search-query.vala"
		_tmp29_ = iter;
#line 267 "../src/engine/api/geary-search-query.vala"
		_tmp30_ = gee_iterator_get (_tmp29_);
#line 267 "../src/engine/api/geary-search-query.vala"
		_tmp31_ = (gchar*) _tmp30_;
#line 267 "../src/engine/api/geary-search-query.vala"
		_tmp32_ = string_to_string (_tmp31_);
#line 267 "../src/engine/api/geary-search-query.vala"
		g_string_append (_tmp28_, _tmp32_);
#line 267 "../src/engine/api/geary-search-query.vala"
		_g_free0 (_tmp31_);
#line 1550 "geary-search-query.c"
	}
#line 269 "../src/engine/api/geary-search-query.vala"
	_tmp33_ = builder;
#line 269 "../src/engine/api/geary-search-query.vala"
	g_string_append_c (_tmp33_, ')');
#line 270 "../src/engine/api/geary-search-query.vala"
	_tmp34_ = builder;
#line 270 "../src/engine/api/geary-search-query.vala"
	_tmp35_ = _tmp34_->str;
#line 270 "../src/engine/api/geary-search-query.vala"
	_tmp36_ = g_strdup (_tmp35_);
#line 270 "../src/engine/api/geary-search-query.vala"
	result = _tmp36_;
#line 270 "../src/engine/api/geary-search-query.vala"
	_g_object_unref0 (iter);
#line 270 "../src/engine/api/geary-search-query.vala"
	_g_string_free0 (builder);
#line 270 "../src/engine/api/geary-search-query.vala"
	return result;
#line 1570 "geary-search-query.c"
}

static void
geary_search_query_email_text_term_class_init (GearySearchQueryEmailTextTermClass * klass,
                                               gpointer klass_data)
{
#line 153 "../src/engine/api/geary-search-query.vala"
	geary_search_query_email_text_term_parent_class = g_type_class_peek_parent (klass);
#line 153 "../src/engine/api/geary-search-query.vala"
	g_type_class_adjust_private_offset (klass, &GearySearchQueryEmailTextTerm_private_offset);
#line 153 "../src/engine/api/geary-search-query.vala"
	((GearySearchQueryTermClass *) klass)->equal_to = (gboolean (*) (GearySearchQueryTerm*, GearySearchQueryTerm*)) geary_search_query_email_text_term_real_equal_to;
#line 153 "../src/engine/api/geary-search-query.vala"
	((GearySearchQueryTermClass *) klass)->to_string = (gchar* (*) (GearySearchQueryTerm*)) geary_search_query_email_text_term_real_to_string;
#line 153 "../src/engine/api/geary-search-query.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_search_query_email_text_term_get_property;
#line 153 "../src/engine/api/geary-search-query.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_search_query_email_text_term_set_property;
#line 153 "../src/engine/api/geary-search-query.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_search_query_email_text_term_finalize;
#line 1591 "geary-search-query.c"
	/** The email property this term applies to. */
#line 153 "../src/engine/api/geary-search-query.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_TARGET_PROPERTY, geary_search_query_email_text_term_properties[GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_TARGET_PROPERTY] = g_param_spec_enum ("target", "target", "target", GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_TYPE_PROPERTY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1595 "geary-search-query.c"
	/** The strategy used for matching the given terms. */
#line 153 "../src/engine/api/geary-search-query.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_MATCHING_STRATEGY_PROPERTY, geary_search_query_email_text_term_properties[GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_MATCHING_STRATEGY_PROPERTY] = g_param_spec_enum ("matching-strategy", "matching-strategy", "matching-strategy", GEARY_SEARCH_QUERY_TYPE_STRATEGY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1599 "geary-search-query.c"
	/**
	         * The strings to match against the given target.
	         *
	         * If more than one term is given, they are treated as the
	         * disjunction of all, that is they are combined using the
	         * Boolean OR function.
	         */
#line 153 "../src/engine/api/geary-search-query.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_TERMS_PROPERTY, geary_search_query_email_text_term_properties[GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_TERMS_PROPERTY] = g_param_spec_object ("terms", "terms", "terms", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1609 "geary-search-query.c"
}

static void
geary_search_query_email_text_term_instance_init (GearySearchQueryEmailTextTerm * self,
                                                  gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 153 "../src/engine/api/geary-search-query.vala"
	self->priv = geary_search_query_email_text_term_get_instance_private (self);
#line 201 "../src/engine/api/geary-search-query.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 201 "../src/engine/api/geary-search-query.vala"
	self->priv->_terms = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_LIST, GeeList);
#line 1623 "geary-search-query.c"
}

static void
geary_search_query_email_text_term_finalize (GObject * obj)
{
	GearySearchQueryEmailTextTerm * self;
#line 153 "../src/engine/api/geary-search-query.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_SEARCH_QUERY_TYPE_EMAIL_TEXT_TERM, GearySearchQueryEmailTextTerm);
#line 201 "../src/engine/api/geary-search-query.vala"
	_g_object_unref0 (self->priv->_terms);
#line 153 "../src/engine/api/geary-search-query.vala"
	G_OBJECT_CLASS (geary_search_query_email_text_term_parent_class)->finalize (obj);
#line 1636 "geary-search-query.c"
}

/**
     * A term that matches text properties of an email.
     */
 G_GNUC_NO_INLINE static GType
geary_search_query_email_text_term_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearySearchQueryEmailTextTermClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_search_query_email_text_term_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearySearchQueryEmailTextTerm), 0, (GInstanceInitFunc) geary_search_query_email_text_term_instance_init, NULL };
	GType geary_search_query_email_text_term_type_id;
	geary_search_query_email_text_term_type_id = g_type_register_static (GEARY_SEARCH_QUERY_TYPE_TERM, "GearySearchQueryEmailTextTerm", &g_define_type_info, 0);
	GearySearchQueryEmailTextTerm_private_offset = g_type_add_instance_private (geary_search_query_email_text_term_type_id, sizeof (GearySearchQueryEmailTextTermPrivate));
	return geary_search_query_email_text_term_type_id;
}

GType
geary_search_query_email_text_term_get_type (void)
{
	static gsize geary_search_query_email_text_term_type_id__once = 0;
	if (g_once_init_enter (&geary_search_query_email_text_term_type_id__once)) {
		GType geary_search_query_email_text_term_type_id;
		geary_search_query_email_text_term_type_id = geary_search_query_email_text_term_get_type_once ();
		g_once_init_leave (&geary_search_query_email_text_term_type_id__once, geary_search_query_email_text_term_type_id);
	}
	return geary_search_query_email_text_term_type_id__once;
}

static void
_vala_geary_search_query_email_text_term_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec)
{
	GearySearchQueryEmailTextTerm * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_SEARCH_QUERY_TYPE_EMAIL_TEXT_TERM, GearySearchQueryEmailTextTerm);
#line 153 "../src/engine/api/geary-search-query.vala"
	switch (property_id) {
#line 153 "../src/engine/api/geary-search-query.vala"
		case GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_TARGET_PROPERTY:
#line 153 "../src/engine/api/geary-search-query.vala"
		g_value_set_enum (value, geary_search_query_email_text_term_get_target (self));
#line 153 "../src/engine/api/geary-search-query.vala"
		break;
#line 153 "../src/engine/api/geary-search-query.vala"
		case GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_MATCHING_STRATEGY_PROPERTY:
#line 153 "../src/engine/api/geary-search-query.vala"
		g_value_set_enum (value, geary_search_query_email_text_term_get_matching_strategy (self));
#line 153 "../src/engine/api/geary-search-query.vala"
		break;
#line 153 "../src/engine/api/geary-search-query.vala"
		case GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_TERMS_PROPERTY:
#line 153 "../src/engine/api/geary-search-query.vala"
		g_value_set_object (value, geary_search_query_email_text_term_get_terms (self));
#line 153 "../src/engine/api/geary-search-query.vala"
		break;
#line 1692 "geary-search-query.c"
		default:
#line 153 "../src/engine/api/geary-search-query.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 153 "../src/engine/api/geary-search-query.vala"
		break;
#line 1698 "geary-search-query.c"
	}
}

static void
_vala_geary_search_query_email_text_term_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec)
{
	GearySearchQueryEmailTextTerm * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_SEARCH_QUERY_TYPE_EMAIL_TEXT_TERM, GearySearchQueryEmailTextTerm);
#line 153 "../src/engine/api/geary-search-query.vala"
	switch (property_id) {
#line 153 "../src/engine/api/geary-search-query.vala"
		case GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_TARGET_PROPERTY:
#line 153 "../src/engine/api/geary-search-query.vala"
		geary_search_query_email_text_term_set_target (self, g_value_get_enum (value));
#line 153 "../src/engine/api/geary-search-query.vala"
		break;
#line 153 "../src/engine/api/geary-search-query.vala"
		case GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_MATCHING_STRATEGY_PROPERTY:
#line 153 "../src/engine/api/geary-search-query.vala"
		geary_search_query_email_text_term_set_matching_strategy (self, g_value_get_enum (value));
#line 153 "../src/engine/api/geary-search-query.vala"
		break;
#line 153 "../src/engine/api/geary-search-query.vala"
		case GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_TERMS_PROPERTY:
#line 153 "../src/engine/api/geary-search-query.vala"
		geary_search_query_email_text_term_set_terms (self, g_value_get_object (value));
#line 153 "../src/engine/api/geary-search-query.vala"
		break;
#line 1730 "geary-search-query.c"
		default:
#line 153 "../src/engine/api/geary-search-query.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 153 "../src/engine/api/geary-search-query.vala"
		break;
#line 1736 "geary-search-query.c"
	}
}

static inline gpointer
geary_search_query_email_flag_term_get_instance_private (GearySearchQueryEmailFlagTerm* self)
{
	return G_STRUCT_MEMBER_P (self, GearySearchQueryEmailFlagTerm_private_offset);
}

GearyNamedFlag*
geary_search_query_email_flag_term_get_value (GearySearchQueryEmailFlagTerm* self)
{
	GearyNamedFlag* result;
	GearyNamedFlag* _tmp0_;
#line 282 "../src/engine/api/geary-search-query.vala"
	g_return_val_if_fail (GEARY_SEARCH_QUERY_IS_EMAIL_FLAG_TERM (self), NULL);
#line 282 "../src/engine/api/geary-search-query.vala"
	_tmp0_ = self->priv->_value;
#line 282 "../src/engine/api/geary-search-query.vala"
	result = _tmp0_;
#line 282 "../src/engine/api/geary-search-query.vala"
	return result;
#line 1759 "geary-search-query.c"
}

static void
geary_search_query_email_flag_term_set_value (GearySearchQueryEmailFlagTerm* self,
                                              GearyNamedFlag* value)
{
	GearyNamedFlag* old_value;
#line 282 "../src/engine/api/geary-search-query.vala"
	g_return_if_fail (GEARY_SEARCH_QUERY_IS_EMAIL_FLAG_TERM (self));
#line 282 "../src/engine/api/geary-search-query.vala"
	old_value = geary_search_query_email_flag_term_get_value (self);
#line 282 "../src/engine/api/geary-search-query.vala"
	if (old_value != value) {
#line 1773 "geary-search-query.c"
		GearyNamedFlag* _tmp0_;
#line 282 "../src/engine/api/geary-search-query.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 282 "../src/engine/api/geary-search-query.vala"
		_g_object_unref0 (self->priv->_value);
#line 282 "../src/engine/api/geary-search-query.vala"
		self->priv->_value = _tmp0_;
#line 282 "../src/engine/api/geary-search-query.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_search_query_email_flag_term_properties[GEARY_SEARCH_QUERY_EMAIL_FLAG_TERM_VALUE_PROPERTY]);
#line 1783 "geary-search-query.c"
	}
}

GearySearchQueryEmailFlagTerm*
geary_search_query_email_flag_term_construct (GType object_type,
                                              GearyNamedFlag* value)
{
	GearySearchQueryEmailFlagTerm * self = NULL;
#line 285 "../src/engine/api/geary-search-query.vala"
	g_return_val_if_fail (GEARY_IS_NAMED_FLAG (value), NULL);
#line 285 "../src/engine/api/geary-search-query.vala"
	self = (GearySearchQueryEmailFlagTerm*) geary_search_query_term_construct (object_type);
#line 286 "../src/engine/api/geary-search-query.vala"
	geary_search_query_email_flag_term_set_value (self, value);
#line 285 "../src/engine/api/geary-search-query.vala"
	return self;
#line 1800 "geary-search-query.c"
}

GearySearchQueryEmailFlagTerm*
geary_search_query_email_flag_term_new (GearyNamedFlag* value)
{
#line 285 "../src/engine/api/geary-search-query.vala"
	return geary_search_query_email_flag_term_construct (GEARY_SEARCH_QUERY_TYPE_EMAIL_FLAG_TERM, value);
#line 1808 "geary-search-query.c"
}

static gboolean
geary_search_query_email_flag_term_real_equal_to (GearySearchQueryTerm* base,
                                                  GearySearchQueryTerm* other)
{
	GearySearchQueryEmailFlagTerm * self;
	GearyNamedFlag* _tmp0_;
	GearyNamedFlag* _tmp1_;
	gboolean result;
#line 289 "../src/engine/api/geary-search-query.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_SEARCH_QUERY_TYPE_EMAIL_FLAG_TERM, GearySearchQueryEmailFlagTerm);
#line 289 "../src/engine/api/geary-search-query.vala"
	g_return_val_if_fail (GEARY_SEARCH_QUERY_IS_TERM (other), FALSE);
#line 290 "../src/engine/api/geary-search-query.vala"
	if (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_SEARCH_QUERY_TYPE_TERM, GearySearchQueryTerm) == other) {
#line 291 "../src/engine/api/geary-search-query.vala"
		result = TRUE;
#line 291 "../src/engine/api/geary-search-query.vala"
		return result;
#line 1829 "geary-search-query.c"
	}
#line 293 "../src/engine/api/geary-search-query.vala"
	if (!GEARY_SEARCH_QUERY_TERM_CLASS (geary_search_query_email_flag_term_parent_class)->equal_to (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_SEARCH_QUERY_TYPE_TERM, GearySearchQueryTerm), other)) {
#line 294 "../src/engine/api/geary-search-query.vala"
		result = FALSE;
#line 294 "../src/engine/api/geary-search-query.vala"
		return result;
#line 1837 "geary-search-query.c"
	}
#line 296 "../src/engine/api/geary-search-query.vala"
	_tmp0_ = self->priv->_value;
#line 296 "../src/engine/api/geary-search-query.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (other, GEARY_SEARCH_QUERY_TYPE_EMAIL_FLAG_TERM, GearySearchQueryEmailFlagTerm)->priv->_value;
#line 296 "../src/engine/api/geary-search-query.vala"
	result = gee_hashable_equal_to (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_HASHABLE, GeeHashable), _tmp1_);
#line 296 "../src/engine/api/geary-search-query.vala"
	return result;
#line 1847 "geary-search-query.c"
}

static gchar*
geary_search_query_email_flag_term_real_to_string (GearySearchQueryTerm* base)
{
	GearySearchQueryEmailFlagTerm * self;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GearyNamedFlag* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result;
#line 299 "../src/engine/api/geary-search-query.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_SEARCH_QUERY_TYPE_EMAIL_FLAG_TERM, GearySearchQueryEmailFlagTerm);
#line 301 "../src/engine/api/geary-search-query.vala"
	_tmp1_ = geary_search_query_term_get_is_negated (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_SEARCH_QUERY_TYPE_TERM, GearySearchQueryTerm));
#line 301 "../src/engine/api/geary-search-query.vala"
	_tmp2_ = _tmp1_;
#line 301 "../src/engine/api/geary-search-query.vala"
	if (_tmp2_) {
#line 301 "../src/engine/api/geary-search-query.vala"
		_tmp0_ = "!";
#line 1873 "geary-search-query.c"
	} else {
#line 301 "../src/engine/api/geary-search-query.vala"
		_tmp0_ = "";
#line 1877 "geary-search-query.c"
	}
#line 300 "../src/engine/api/geary-search-query.vala"
	_tmp3_ = self->priv->_value;
#line 300 "../src/engine/api/geary-search-query.vala"
	_tmp4_ = geary_named_flag_to_string (_tmp3_);
#line 300 "../src/engine/api/geary-search-query.vala"
	_tmp5_ = _tmp4_;
#line 300 "../src/engine/api/geary-search-query.vala"
	_tmp6_ = g_strdup_printf ("%s(%s)", _tmp0_, _tmp5_);
#line 300 "../src/engine/api/geary-search-query.vala"
	_tmp7_ = _tmp6_;
#line 300 "../src/engine/api/geary-search-query.vala"
	_g_free0 (_tmp5_);
#line 300 "../src/engine/api/geary-search-query.vala"
	result = _tmp7_;
#line 300 "../src/engine/api/geary-search-query.vala"
	return result;
#line 1895 "geary-search-query.c"
}

static void
geary_search_query_email_flag_term_class_init (GearySearchQueryEmailFlagTermClass * klass,
                                               gpointer klass_data)
{
#line 279 "../src/engine/api/geary-search-query.vala"
	geary_search_query_email_flag_term_parent_class = g_type_class_peek_parent (klass);
#line 279 "../src/engine/api/geary-search-query.vala"
	g_type_class_adjust_private_offset (klass, &GearySearchQueryEmailFlagTerm_private_offset);
#line 279 "../src/engine/api/geary-search-query.vala"
	((GearySearchQueryTermClass *) klass)->equal_to = (gboolean (*) (GearySearchQueryTerm*, GearySearchQueryTerm*)) geary_search_query_email_flag_term_real_equal_to;
#line 279 "../src/engine/api/geary-search-query.vala"
	((GearySearchQueryTermClass *) klass)->to_string = (gchar* (*) (GearySearchQueryTerm*)) geary_search_query_email_flag_term_real_to_string;
#line 279 "../src/engine/api/geary-search-query.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_search_query_email_flag_term_get_property;
#line 279 "../src/engine/api/geary-search-query.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_search_query_email_flag_term_set_property;
#line 279 "../src/engine/api/geary-search-query.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_search_query_email_flag_term_finalize;
#line 279 "../src/engine/api/geary-search-query.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SEARCH_QUERY_EMAIL_FLAG_TERM_VALUE_PROPERTY, geary_search_query_email_flag_term_properties[GEARY_SEARCH_QUERY_EMAIL_FLAG_TERM_VALUE_PROPERTY] = g_param_spec_object ("value", "value", "value", GEARY_TYPE_NAMED_FLAG, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1918 "geary-search-query.c"
}

static void
geary_search_query_email_flag_term_instance_init (GearySearchQueryEmailFlagTerm * self,
                                                  gpointer klass)
{
#line 279 "../src/engine/api/geary-search-query.vala"
	self->priv = geary_search_query_email_flag_term_get_instance_private (self);
#line 1927 "geary-search-query.c"
}

static void
geary_search_query_email_flag_term_finalize (GObject * obj)
{
	GearySearchQueryEmailFlagTerm * self;
#line 279 "../src/engine/api/geary-search-query.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_SEARCH_QUERY_TYPE_EMAIL_FLAG_TERM, GearySearchQueryEmailFlagTerm);
#line 282 "../src/engine/api/geary-search-query.vala"
	_g_object_unref0 (self->priv->_value);
#line 279 "../src/engine/api/geary-search-query.vala"
	G_OBJECT_CLASS (geary_search_query_email_flag_term_parent_class)->finalize (obj);
#line 1940 "geary-search-query.c"
}

/**
     * A term that matches a given flag in an email.
     */
 G_GNUC_NO_INLINE static GType
geary_search_query_email_flag_term_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearySearchQueryEmailFlagTermClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_search_query_email_flag_term_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearySearchQueryEmailFlagTerm), 0, (GInstanceInitFunc) geary_search_query_email_flag_term_instance_init, NULL };
	GType geary_search_query_email_flag_term_type_id;
	geary_search_query_email_flag_term_type_id = g_type_register_static (GEARY_SEARCH_QUERY_TYPE_TERM, "GearySearchQueryEmailFlagTerm", &g_define_type_info, 0);
	GearySearchQueryEmailFlagTerm_private_offset = g_type_add_instance_private (geary_search_query_email_flag_term_type_id, sizeof (GearySearchQueryEmailFlagTermPrivate));
	return geary_search_query_email_flag_term_type_id;
}

GType
geary_search_query_email_flag_term_get_type (void)
{
	static gsize geary_search_query_email_flag_term_type_id__once = 0;
	if (g_once_init_enter (&geary_search_query_email_flag_term_type_id__once)) {
		GType geary_search_query_email_flag_term_type_id;
		geary_search_query_email_flag_term_type_id = geary_search_query_email_flag_term_get_type_once ();
		g_once_init_leave (&geary_search_query_email_flag_term_type_id__once, geary_search_query_email_flag_term_type_id);
	}
	return geary_search_query_email_flag_term_type_id__once;
}

static void
_vala_geary_search_query_email_flag_term_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec)
{
	GearySearchQueryEmailFlagTerm * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_SEARCH_QUERY_TYPE_EMAIL_FLAG_TERM, GearySearchQueryEmailFlagTerm);
#line 279 "../src/engine/api/geary-search-query.vala"
	switch (property_id) {
#line 279 "../src/engine/api/geary-search-query.vala"
		case GEARY_SEARCH_QUERY_EMAIL_FLAG_TERM_VALUE_PROPERTY:
#line 279 "../src/engine/api/geary-search-query.vala"
		g_value_set_object (value, geary_search_query_email_flag_term_get_value (self));
#line 279 "../src/engine/api/geary-search-query.vala"
		break;
#line 1984 "geary-search-query.c"
		default:
#line 279 "../src/engine/api/geary-search-query.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 279 "../src/engine/api/geary-search-query.vala"
		break;
#line 1990 "geary-search-query.c"
	}
}

static void
_vala_geary_search_query_email_flag_term_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec)
{
	GearySearchQueryEmailFlagTerm * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_SEARCH_QUERY_TYPE_EMAIL_FLAG_TERM, GearySearchQueryEmailFlagTerm);
#line 279 "../src/engine/api/geary-search-query.vala"
	switch (property_id) {
#line 279 "../src/engine/api/geary-search-query.vala"
		case GEARY_SEARCH_QUERY_EMAIL_FLAG_TERM_VALUE_PROPERTY:
#line 279 "../src/engine/api/geary-search-query.vala"
		geary_search_query_email_flag_term_set_value (self, g_value_get_object (value));
#line 279 "../src/engine/api/geary-search-query.vala"
		break;
#line 2010 "geary-search-query.c"
		default:
#line 279 "../src/engine/api/geary-search-query.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 279 "../src/engine/api/geary-search-query.vala"
		break;
#line 2016 "geary-search-query.c"
	}
}

static void
geary_search_query_class_init (GearySearchQueryClass * klass,
                               gpointer klass_data)
{
#line 32 "../src/engine/api/geary-search-query.vala"
	geary_search_query_parent_class = g_type_class_peek_parent (klass);
#line 32 "../src/engine/api/geary-search-query.vala"
	g_type_class_adjust_private_offset (klass, &GearySearchQuery_private_offset);
#line 32 "../src/engine/api/geary-search-query.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_search_query_get_property;
#line 32 "../src/engine/api/geary-search-query.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_search_query_set_property;
#line 32 "../src/engine/api/geary-search-query.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_search_query_finalize;
#line 2034 "geary-search-query.c"
	/**
	     * A read-only list of search terms to be evaluated.
	     *
	     * Each given term is used in a conjunction, that is combined
	     * using a Boolean `AND` operator.
	     */
#line 32 "../src/engine/api/geary-search-query.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SEARCH_QUERY_EXPRESSION_PROPERTY, geary_search_query_properties[GEARY_SEARCH_QUERY_EXPRESSION_PROPERTY] = g_param_spec_object ("expression", "expression", "expression", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2043 "geary-search-query.c"
	/**
	     * The original search text, if any.
	     *
	     * This is used mostly for debugging.
	     */
#line 32 "../src/engine/api/geary-search-query.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SEARCH_QUERY_RAW_PROPERTY, geary_search_query_properties[GEARY_SEARCH_QUERY_RAW_PROPERTY] = g_param_spec_string ("raw", "raw", "raw", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2051 "geary-search-query.c"
}

static void
geary_search_query_instance_init (GearySearchQuery * self,
                                  gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 32 "../src/engine/api/geary-search-query.vala"
	self->priv = geary_search_query_get_instance_private (self);
#line 316 "../src/engine/api/geary-search-query.vala"
	_tmp0_ = gee_array_list_new (GEARY_SEARCH_QUERY_TYPE_TERM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 316 "../src/engine/api/geary-search-query.vala"
	self->priv->_rw_expression = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_LIST, GeeList);
#line 2065 "geary-search-query.c"
}

static void
geary_search_query_finalize (GObject * obj)
{
	GearySearchQuery * self;
#line 32 "../src/engine/api/geary-search-query.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_TYPE_SEARCH_QUERY, GearySearchQuery);
#line 315 "../src/engine/api/geary-search-query.vala"
	_g_object_unref0 (self->priv->_expression);
#line 316 "../src/engine/api/geary-search-query.vala"
	_g_object_unref0 (self->priv->_rw_expression);
#line 323 "../src/engine/api/geary-search-query.vala"
	_g_free0 (self->priv->_raw);
#line 32 "../src/engine/api/geary-search-query.vala"
	G_OBJECT_CLASS (geary_search_query_parent_class)->finalize (obj);
#line 2082 "geary-search-query.c"
}

/**
 * Specifies an expression for searching email in a search folder.
 *
 * New instances can be constructed via {@link
 * Account.new_search_query} and then passed to search methods on
 * {@link Account} or {@link App.SearchFolder}.
 *
 * Actual search queries are specified by the given {@link
 * expression}, which is a list of {@link Term}. The expression
 * denotes the conjunction of all given terms, that is, each term is
 * combined by a Boolean AND function. While the order of the terms is
 * not important, the expression should attempt to reflect the
 * free-text search query it was built from (if any). A more
 * expressive language is not supported since it is designed to work
 * with both the Engine's built-in full text search system as well as
 * other server-based systems, including IMAP.
 *
 * @see Account.new_search_query
 * @see Account.local_search_async
 * @see Account.get_search_matches_async
 * @see App.SearchFolder.update_query
 */
 G_GNUC_NO_INLINE static GType
geary_search_query_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearySearchQueryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_search_query_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearySearchQuery), 0, (GInstanceInitFunc) geary_search_query_instance_init, NULL };
	GType geary_search_query_type_id;
	geary_search_query_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearySearchQuery", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	GearySearchQuery_private_offset = g_type_add_instance_private (geary_search_query_type_id, sizeof (GearySearchQueryPrivate));
	return geary_search_query_type_id;
}

GType
geary_search_query_get_type (void)
{
	static gsize geary_search_query_type_id__once = 0;
	if (g_once_init_enter (&geary_search_query_type_id__once)) {
		GType geary_search_query_type_id;
		geary_search_query_type_id = geary_search_query_get_type_once ();
		g_once_init_leave (&geary_search_query_type_id__once, geary_search_query_type_id);
	}
	return geary_search_query_type_id__once;
}

static void
_vala_geary_search_query_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	GearySearchQuery * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_SEARCH_QUERY, GearySearchQuery);
#line 32 "../src/engine/api/geary-search-query.vala"
	switch (property_id) {
#line 32 "../src/engine/api/geary-search-query.vala"
		case GEARY_SEARCH_QUERY_EXPRESSION_PROPERTY:
#line 32 "../src/engine/api/geary-search-query.vala"
		g_value_set_object (value, geary_search_query_get_expression (self));
#line 32 "../src/engine/api/geary-search-query.vala"
		break;
#line 32 "../src/engine/api/geary-search-query.vala"
		case GEARY_SEARCH_QUERY_RAW_PROPERTY:
#line 32 "../src/engine/api/geary-search-query.vala"
		g_value_set_string (value, geary_search_query_get_raw (self));
#line 32 "../src/engine/api/geary-search-query.vala"
		break;
#line 2151 "geary-search-query.c"
		default:
#line 32 "../src/engine/api/geary-search-query.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../src/engine/api/geary-search-query.vala"
		break;
#line 2157 "geary-search-query.c"
	}
}

static void
_vala_geary_search_query_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	GearySearchQuery * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_SEARCH_QUERY, GearySearchQuery);
#line 32 "../src/engine/api/geary-search-query.vala"
	switch (property_id) {
#line 32 "../src/engine/api/geary-search-query.vala"
		case GEARY_SEARCH_QUERY_EXPRESSION_PROPERTY:
#line 32 "../src/engine/api/geary-search-query.vala"
		geary_search_query_set_expression (self, g_value_get_object (value));
#line 32 "../src/engine/api/geary-search-query.vala"
		break;
#line 32 "../src/engine/api/geary-search-query.vala"
		case GEARY_SEARCH_QUERY_RAW_PROPERTY:
#line 32 "../src/engine/api/geary-search-query.vala"
		geary_search_query_set_raw (self, g_value_get_string (value));
#line 32 "../src/engine/api/geary-search-query.vala"
		break;
#line 2183 "geary-search-query.c"
		default:
#line 32 "../src/engine/api/geary-search-query.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../src/engine/api/geary-search-query.vala"
		break;
#line 2189 "geary-search-query.c"
	}
}

