/* geary-service-information.c generated by valac 0.56.17, the Vala compiler
 * generated from geary-service-information.vala, do not modify */

/*
 * Copyright 2017 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	GEARY_SERVICE_INFORMATION_0_PROPERTY,
	GEARY_SERVICE_INFORMATION_PROTOCOL_PROPERTY,
	GEARY_SERVICE_INFORMATION_HOST_PROPERTY,
	GEARY_SERVICE_INFORMATION_PORT_PROPERTY,
	GEARY_SERVICE_INFORMATION_TRANSPORT_SECURITY_PROPERTY,
	GEARY_SERVICE_INFORMATION_CREDENTIALS_REQUIREMENT_PROPERTY,
	GEARY_SERVICE_INFORMATION_CREDENTIALS_PROPERTY,
	GEARY_SERVICE_INFORMATION_REMEMBER_PASSWORD_PROPERTY,
	GEARY_SERVICE_INFORMATION_NUM_PROPERTIES
};
static GParamSpec* geary_service_information_properties[GEARY_SERVICE_INFORMATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _GearyServiceInformationPrivate {
	GearyProtocol _protocol;
	gchar* _host;
	guint16 _port;
	GearyTlsNegotiationMethod _transport_security;
	GearyCredentialsRequirement _credentials_requirement;
	GearyCredentials* _credentials;
	gboolean _remember_password;
};

static gint GearyServiceInformation_private_offset;
static gpointer geary_service_information_parent_class = NULL;

static void geary_service_information_set_protocol (GearyServiceInformation* self,
                                             GearyProtocol value);
static void geary_service_information_finalize (GObject * obj);
static GType geary_service_information_get_type_once (void);
static void _vala_geary_service_information_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_geary_service_information_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);

/**
 * The network protocols supported by the engine for email services.
 */
GearyProtocol
geary_protocol_for_value (const gchar* value,
                          GError** error)
{
	GearyProtocol _tmp0_ = 0;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gpointer _tmp3_;
	GearyProtocol _tmp4_;
	GError* _inner_error0_ = NULL;
	GearyProtocol result;
#line 16 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (value != NULL, 0);
#line 18 "../src/engine/api/geary-service-information.vala"
	_tmp1_ = g_ascii_strdown (value, (gssize) -1);
#line 18 "../src/engine/api/geary-service-information.vala"
	_tmp2_ = _tmp1_;
#line 18 "../src/engine/api/geary-service-information.vala"
	_tmp3_ = geary_object_utils_from_enum_nick (GEARY_TYPE_PROTOCOL, NULL, NULL, GEARY_TYPE_PROTOCOL, _tmp2_, &_inner_error0_);
#line 18 "../src/engine/api/geary-service-information.vala"
	_tmp4_ = (GearyProtocol) ((gintptr) _tmp3_);
#line 18 "../src/engine/api/geary-service-information.vala"
	_g_free0 (_tmp2_);
#line 18 "../src/engine/api/geary-service-information.vala"
	_tmp0_ = _tmp4_;
#line 18 "../src/engine/api/geary-service-information.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 18 "../src/engine/api/geary-service-information.vala"
		if (_inner_error0_->domain == GEARY_ENGINE_ERROR) {
#line 18 "../src/engine/api/geary-service-information.vala"
			g_propagate_error (error, _inner_error0_);
#line 18 "../src/engine/api/geary-service-information.vala"
			return 0;
#line 105 "geary-service-information.c"
		} else {
#line 18 "../src/engine/api/geary-service-information.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 18 "../src/engine/api/geary-service-information.vala"
			g_clear_error (&_inner_error0_);
#line 18 "../src/engine/api/geary-service-information.vala"
			return 0;
#line 113 "geary-service-information.c"
		}
	}
#line 18 "../src/engine/api/geary-service-information.vala"
	result = _tmp0_;
#line 18 "../src/engine/api/geary-service-information.vala"
	return result;
#line 120 "geary-service-information.c"
}

gchar*
geary_protocol_to_value (GearyProtocol self)
{
	gchar* _tmp0_;
	gchar* result;
#line 24 "../src/engine/api/geary-service-information.vala"
	_tmp0_ = geary_object_utils_to_enum_nick (GEARY_TYPE_PROTOCOL, NULL, NULL, GEARY_TYPE_PROTOCOL, (gpointer) ((gintptr) self));
#line 24 "../src/engine/api/geary-service-information.vala"
	result = _tmp0_;
#line 24 "../src/engine/api/geary-service-information.vala"
	return result;
#line 134 "geary-service-information.c"
}

 G_GNUC_NO_INLINE static GType
geary_protocol_get_type_once (void)
{
	static const GEnumValue values[] = {{GEARY_PROTOCOL_IMAP, "GEARY_PROTOCOL_IMAP", "imap"}, {GEARY_PROTOCOL_SMTP, "GEARY_PROTOCOL_SMTP", "smtp"}, {0, NULL, NULL}};
	GType geary_protocol_type_id;
	geary_protocol_type_id = g_enum_register_static ("GearyProtocol", values);
	return geary_protocol_type_id;
}

GType
geary_protocol_get_type (void)
{
	static gsize geary_protocol_type_id__once = 0;
	if (g_once_init_enter (&geary_protocol_type_id__once)) {
		GType geary_protocol_type_id;
		geary_protocol_type_id = geary_protocol_get_type_once ();
		g_once_init_leave (&geary_protocol_type_id__once, geary_protocol_type_id);
	}
	return geary_protocol_type_id__once;
}

/** The method used to negotiate a TLS session, if any. */
GearyTlsNegotiationMethod
geary_tls_negotiation_method_for_value (const gchar* value,
                                        GError** error)
{
	GearyTlsNegotiationMethod _tmp0_ = 0;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gpointer _tmp3_;
	GearyTlsNegotiationMethod _tmp4_;
	GError* _inner_error0_ = NULL;
	GearyTlsNegotiationMethod result;
#line 66 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (value != NULL, 0);
#line 68 "../src/engine/api/geary-service-information.vala"
	_tmp1_ = g_ascii_strdown (value, (gssize) -1);
#line 68 "../src/engine/api/geary-service-information.vala"
	_tmp2_ = _tmp1_;
#line 68 "../src/engine/api/geary-service-information.vala"
	_tmp3_ = geary_object_utils_from_enum_nick (GEARY_TYPE_TLS_NEGOTIATION_METHOD, NULL, NULL, GEARY_TYPE_TLS_NEGOTIATION_METHOD, _tmp2_, &_inner_error0_);
#line 68 "../src/engine/api/geary-service-information.vala"
	_tmp4_ = (GearyTlsNegotiationMethod) ((gintptr) _tmp3_);
#line 68 "../src/engine/api/geary-service-information.vala"
	_g_free0 (_tmp2_);
#line 68 "../src/engine/api/geary-service-information.vala"
	_tmp0_ = _tmp4_;
#line 68 "../src/engine/api/geary-service-information.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 68 "../src/engine/api/geary-service-information.vala"
		if (_inner_error0_->domain == GEARY_ENGINE_ERROR) {
#line 68 "../src/engine/api/geary-service-information.vala"
			g_propagate_error (error, _inner_error0_);
#line 68 "../src/engine/api/geary-service-information.vala"
			return 0;
#line 192 "geary-service-information.c"
		} else {
#line 68 "../src/engine/api/geary-service-information.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 68 "../src/engine/api/geary-service-information.vala"
			g_clear_error (&_inner_error0_);
#line 68 "../src/engine/api/geary-service-information.vala"
			return 0;
#line 200 "geary-service-information.c"
		}
	}
#line 68 "../src/engine/api/geary-service-information.vala"
	result = _tmp0_;
#line 68 "../src/engine/api/geary-service-information.vala"
	return result;
#line 207 "geary-service-information.c"
}

gchar*
geary_tls_negotiation_method_to_value (GearyTlsNegotiationMethod self)
{
	gchar* _tmp0_;
	gchar* result;
#line 74 "../src/engine/api/geary-service-information.vala"
	_tmp0_ = geary_object_utils_to_enum_nick (GEARY_TYPE_TLS_NEGOTIATION_METHOD, NULL, NULL, GEARY_TYPE_TLS_NEGOTIATION_METHOD, (gpointer) ((gintptr) self));
#line 74 "../src/engine/api/geary-service-information.vala"
	result = _tmp0_;
#line 74 "../src/engine/api/geary-service-information.vala"
	return result;
#line 221 "geary-service-information.c"
}

 G_GNUC_NO_INLINE static GType
geary_tls_negotiation_method_get_type_once (void)
{
	static const GEnumValue values[] = {{GEARY_TLS_NEGOTIATION_METHOD_NONE, "GEARY_TLS_NEGOTIATION_METHOD_NONE", "none"}, {GEARY_TLS_NEGOTIATION_METHOD_START_TLS, "GEARY_TLS_NEGOTIATION_METHOD_START_TLS", "start-tls"}, {GEARY_TLS_NEGOTIATION_METHOD_TRANSPORT, "GEARY_TLS_NEGOTIATION_METHOD_TRANSPORT", "transport"}, {0, NULL, NULL}};
	GType geary_tls_negotiation_method_type_id;
	geary_tls_negotiation_method_type_id = g_enum_register_static ("GearyTlsNegotiationMethod", values);
	return geary_tls_negotiation_method_type_id;
}

GType
geary_tls_negotiation_method_get_type (void)
{
	static gsize geary_tls_negotiation_method_type_id__once = 0;
	if (g_once_init_enter (&geary_tls_negotiation_method_type_id__once)) {
		GType geary_tls_negotiation_method_type_id;
		geary_tls_negotiation_method_type_id = geary_tls_negotiation_method_get_type_once ();
		g_once_init_leave (&geary_tls_negotiation_method_type_id__once, geary_tls_negotiation_method_type_id);
	}
	return geary_tls_negotiation_method_type_id__once;
}

static inline gpointer
geary_service_information_get_instance_private (GearyServiceInformation* self)
{
	return G_STRUCT_MEMBER_P (self, GearyServiceInformation_private_offset);
}

GearyProtocol
geary_service_information_get_protocol (GearyServiceInformation* self)
{
	GearyProtocol result;
#line 89 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (self), 0);
#line 89 "../src/engine/api/geary-service-information.vala"
	result = self->priv->_protocol;
#line 89 "../src/engine/api/geary-service-information.vala"
	return result;
#line 261 "geary-service-information.c"
}

static void
geary_service_information_set_protocol (GearyServiceInformation* self,
                                        GearyProtocol value)
{
	GearyProtocol old_value;
#line 89 "../src/engine/api/geary-service-information.vala"
	g_return_if_fail (GEARY_IS_SERVICE_INFORMATION (self));
#line 89 "../src/engine/api/geary-service-information.vala"
	old_value = geary_service_information_get_protocol (self);
#line 89 "../src/engine/api/geary-service-information.vala"
	if (old_value != value) {
#line 89 "../src/engine/api/geary-service-information.vala"
		self->priv->_protocol = value;
#line 89 "../src/engine/api/geary-service-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_service_information_properties[GEARY_SERVICE_INFORMATION_PROTOCOL_PROPERTY]);
#line 279 "geary-service-information.c"
	}
}

const gchar*
geary_service_information_get_host (GearyServiceInformation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 92 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (self), NULL);
#line 92 "../src/engine/api/geary-service-information.vala"
	_tmp0_ = self->priv->_host;
#line 92 "../src/engine/api/geary-service-information.vala"
	result = _tmp0_;
#line 92 "../src/engine/api/geary-service-information.vala"
	return result;
#line 296 "geary-service-information.c"
}

void
geary_service_information_set_host (GearyServiceInformation* self,
                                    const gchar* value)
{
	gchar* old_value;
#line 92 "../src/engine/api/geary-service-information.vala"
	g_return_if_fail (GEARY_IS_SERVICE_INFORMATION (self));
#line 92 "../src/engine/api/geary-service-information.vala"
	old_value = geary_service_information_get_host (self);
#line 92 "../src/engine/api/geary-service-information.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 310 "geary-service-information.c"
		gchar* _tmp0_;
#line 92 "../src/engine/api/geary-service-information.vala"
		_tmp0_ = g_strdup (value);
#line 92 "../src/engine/api/geary-service-information.vala"
		_g_free0 (self->priv->_host);
#line 92 "../src/engine/api/geary-service-information.vala"
		self->priv->_host = _tmp0_;
#line 92 "../src/engine/api/geary-service-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_service_information_properties[GEARY_SERVICE_INFORMATION_HOST_PROPERTY]);
#line 320 "geary-service-information.c"
	}
}

guint16
geary_service_information_get_port (GearyServiceInformation* self)
{
	guint16 result;
#line 95 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (self), 0U);
#line 95 "../src/engine/api/geary-service-information.vala"
	result = self->priv->_port;
#line 95 "../src/engine/api/geary-service-information.vala"
	return result;
#line 334 "geary-service-information.c"
}

void
geary_service_information_set_port (GearyServiceInformation* self,
                                    guint16 value)
{
	guint16 old_value;
#line 95 "../src/engine/api/geary-service-information.vala"
	g_return_if_fail (GEARY_IS_SERVICE_INFORMATION (self));
#line 95 "../src/engine/api/geary-service-information.vala"
	old_value = geary_service_information_get_port (self);
#line 95 "../src/engine/api/geary-service-information.vala"
	if (old_value != value) {
#line 95 "../src/engine/api/geary-service-information.vala"
		self->priv->_port = value;
#line 95 "../src/engine/api/geary-service-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_service_information_properties[GEARY_SERVICE_INFORMATION_PORT_PROPERTY]);
#line 352 "geary-service-information.c"
	}
}

GearyTlsNegotiationMethod
geary_service_information_get_transport_security (GearyServiceInformation* self)
{
	GearyTlsNegotiationMethod result;
#line 98 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (self), 0);
#line 98 "../src/engine/api/geary-service-information.vala"
	result = self->priv->_transport_security;
#line 98 "../src/engine/api/geary-service-information.vala"
	return result;
#line 366 "geary-service-information.c"
}

void
geary_service_information_set_transport_security (GearyServiceInformation* self,
                                                  GearyTlsNegotiationMethod value)
{
	GearyTlsNegotiationMethod old_value;
#line 98 "../src/engine/api/geary-service-information.vala"
	g_return_if_fail (GEARY_IS_SERVICE_INFORMATION (self));
#line 98 "../src/engine/api/geary-service-information.vala"
	old_value = geary_service_information_get_transport_security (self);
#line 98 "../src/engine/api/geary-service-information.vala"
	if (old_value != value) {
#line 98 "../src/engine/api/geary-service-information.vala"
		self->priv->_transport_security = value;
#line 98 "../src/engine/api/geary-service-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_service_information_properties[GEARY_SERVICE_INFORMATION_TRANSPORT_SECURITY_PROPERTY]);
#line 384 "geary-service-information.c"
	}
}

GearyCredentialsRequirement
geary_service_information_get_credentials_requirement (GearyServiceInformation* self)
{
	GearyCredentialsRequirement result;
#line 103 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (self), 0);
#line 103 "../src/engine/api/geary-service-information.vala"
	result = self->priv->_credentials_requirement;
#line 103 "../src/engine/api/geary-service-information.vala"
	return result;
#line 398 "geary-service-information.c"
}

void
geary_service_information_set_credentials_requirement (GearyServiceInformation* self,
                                                       GearyCredentialsRequirement value)
{
	GearyCredentialsRequirement old_value;
#line 103 "../src/engine/api/geary-service-information.vala"
	g_return_if_fail (GEARY_IS_SERVICE_INFORMATION (self));
#line 103 "../src/engine/api/geary-service-information.vala"
	old_value = geary_service_information_get_credentials_requirement (self);
#line 103 "../src/engine/api/geary-service-information.vala"
	if (old_value != value) {
#line 103 "../src/engine/api/geary-service-information.vala"
		self->priv->_credentials_requirement = value;
#line 103 "../src/engine/api/geary-service-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_service_information_properties[GEARY_SERVICE_INFORMATION_CREDENTIALS_REQUIREMENT_PROPERTY]);
#line 416 "geary-service-information.c"
	}
}

GearyCredentials*
geary_service_information_get_credentials (GearyServiceInformation* self)
{
	GearyCredentials* result;
	GearyCredentials* _tmp0_;
#line 106 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (self), NULL);
#line 106 "../src/engine/api/geary-service-information.vala"
	_tmp0_ = self->priv->_credentials;
#line 106 "../src/engine/api/geary-service-information.vala"
	result = _tmp0_;
#line 106 "../src/engine/api/geary-service-information.vala"
	return result;
#line 433 "geary-service-information.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 106 "../src/engine/api/geary-service-information.vala"
	return self ? g_object_ref (self) : NULL;
#line 441 "geary-service-information.c"
}

void
geary_service_information_set_credentials (GearyServiceInformation* self,
                                           GearyCredentials* value)
{
	GearyCredentials* old_value;
#line 106 "../src/engine/api/geary-service-information.vala"
	g_return_if_fail (GEARY_IS_SERVICE_INFORMATION (self));
#line 106 "../src/engine/api/geary-service-information.vala"
	old_value = geary_service_information_get_credentials (self);
#line 106 "../src/engine/api/geary-service-information.vala"
	if (old_value != value) {
#line 455 "geary-service-information.c"
		GearyCredentials* _tmp0_;
#line 106 "../src/engine/api/geary-service-information.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 106 "../src/engine/api/geary-service-information.vala"
		_g_object_unref0 (self->priv->_credentials);
#line 106 "../src/engine/api/geary-service-information.vala"
		self->priv->_credentials = _tmp0_;
#line 106 "../src/engine/api/geary-service-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_service_information_properties[GEARY_SERVICE_INFORMATION_CREDENTIALS_PROPERTY]);
#line 465 "geary-service-information.c"
	}
}

gboolean
geary_service_information_get_remember_password (GearyServiceInformation* self)
{
	gboolean result;
#line 114 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (self), FALSE);
#line 114 "../src/engine/api/geary-service-information.vala"
	result = self->priv->_remember_password;
#line 114 "../src/engine/api/geary-service-information.vala"
	return result;
#line 479 "geary-service-information.c"
}

void
geary_service_information_set_remember_password (GearyServiceInformation* self,
                                                 gboolean value)
{
	gboolean old_value;
#line 114 "../src/engine/api/geary-service-information.vala"
	g_return_if_fail (GEARY_IS_SERVICE_INFORMATION (self));
#line 114 "../src/engine/api/geary-service-information.vala"
	old_value = geary_service_information_get_remember_password (self);
#line 114 "../src/engine/api/geary-service-information.vala"
	if (old_value != value) {
#line 114 "../src/engine/api/geary-service-information.vala"
		self->priv->_remember_password = value;
#line 114 "../src/engine/api/geary-service-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_service_information_properties[GEARY_SERVICE_INFORMATION_REMEMBER_PASSWORD_PROPERTY]);
#line 497 "geary-service-information.c"
	}
}

/**
     * Constructs a new configuration for a specific service.
     */
GearyServiceInformation*
geary_service_information_construct (GType object_type,
                                     GearyProtocol proto,
                                     GearyServiceProvider provider)
{
	GearyServiceInformation * self = NULL;
	GearyTlsNegotiationMethod _tmp0_ = 0;
	GearyCredentialsRequirement _tmp1_ = 0;
#line 119 "../src/engine/api/geary-service-information.vala"
	self = (GearyServiceInformation*) g_object_new (object_type, NULL);
#line 120 "../src/engine/api/geary-service-information.vala"
	geary_service_information_set_protocol (self, proto);
#line 123 "../src/engine/api/geary-service-information.vala"
	if (proto == GEARY_PROTOCOL_SMTP) {
#line 124 "../src/engine/api/geary-service-information.vala"
		_tmp0_ = GEARY_TLS_NEGOTIATION_METHOD_START_TLS;
#line 520 "geary-service-information.c"
	} else {
#line 125 "../src/engine/api/geary-service-information.vala"
		_tmp0_ = GEARY_TLS_NEGOTIATION_METHOD_TRANSPORT;
#line 524 "geary-service-information.c"
	}
#line 123 "../src/engine/api/geary-service-information.vala"
	geary_service_information_set_transport_security (self, _tmp0_);
#line 126 "../src/engine/api/geary-service-information.vala"
	if (proto == GEARY_PROTOCOL_SMTP) {
#line 127 "../src/engine/api/geary-service-information.vala"
		_tmp1_ = GEARY_CREDENTIALS_REQUIREMENT_USE_INCOMING;
#line 532 "geary-service-information.c"
	} else {
#line 128 "../src/engine/api/geary-service-information.vala"
		_tmp1_ = GEARY_CREDENTIALS_REQUIREMENT_CUSTOM;
#line 536 "geary-service-information.c"
	}
#line 126 "../src/engine/api/geary-service-information.vala"
	geary_service_information_set_credentials_requirement (self, _tmp1_);
#line 130 "../src/engine/api/geary-service-information.vala"
	geary_service_provider_set_service_defaults (provider, self);
#line 119 "../src/engine/api/geary-service-information.vala"
	return self;
#line 544 "geary-service-information.c"
}

GearyServiceInformation*
geary_service_information_new (GearyProtocol proto,
                               GearyServiceProvider provider)
{
#line 119 "../src/engine/api/geary-service-information.vala"
	return geary_service_information_construct (GEARY_TYPE_SERVICE_INFORMATION, proto, provider);
#line 553 "geary-service-information.c"
}

/**
     * Constructs a copy of the given service configuration.
     */
GearyServiceInformation*
geary_service_information_construct_copy (GType object_type,
                                          GearyServiceInformation* other)
{
	GearyServiceInformation * self = NULL;
	GearyProtocol _tmp0_;
	const gchar* _tmp1_;
	guint16 _tmp2_;
	GearyTlsNegotiationMethod _tmp3_;
	GearyCredentials* _tmp4_ = NULL;
	GearyCredentials* _tmp5_;
	GearyCredentialsRequirement _tmp8_;
	gboolean _tmp9_;
#line 136 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (other), NULL);
#line 138 "../src/engine/api/geary-service-information.vala"
	_tmp0_ = other->priv->_protocol;
#line 138 "../src/engine/api/geary-service-information.vala"
	self = (GearyServiceInformation*) geary_service_information_construct (object_type, _tmp0_, GEARY_SERVICE_PROVIDER_OTHER);
#line 139 "../src/engine/api/geary-service-information.vala"
	_tmp1_ = other->priv->_host;
#line 139 "../src/engine/api/geary-service-information.vala"
	geary_service_information_set_host (self, _tmp1_);
#line 140 "../src/engine/api/geary-service-information.vala"
	_tmp2_ = other->priv->_port;
#line 140 "../src/engine/api/geary-service-information.vala"
	geary_service_information_set_port (self, _tmp2_);
#line 141 "../src/engine/api/geary-service-information.vala"
	_tmp3_ = other->priv->_transport_security;
#line 141 "../src/engine/api/geary-service-information.vala"
	geary_service_information_set_transport_security (self, _tmp3_);
#line 142 "../src/engine/api/geary-service-information.vala"
	_tmp5_ = other->priv->_credentials;
#line 142 "../src/engine/api/geary-service-information.vala"
	if (_tmp5_ != NULL) {
#line 594 "geary-service-information.c"
		GearyCredentials* _tmp6_;
		GearyCredentials* _tmp7_;
#line 143 "../src/engine/api/geary-service-information.vala"
		_tmp6_ = other->priv->_credentials;
#line 143 "../src/engine/api/geary-service-information.vala"
		_tmp7_ = geary_credentials_copy (_tmp6_);
#line 143 "../src/engine/api/geary-service-information.vala"
		_g_object_unref0 (_tmp4_);
#line 143 "../src/engine/api/geary-service-information.vala"
		_tmp4_ = _tmp7_;
#line 605 "geary-service-information.c"
	} else {
#line 143 "../src/engine/api/geary-service-information.vala"
		_g_object_unref0 (_tmp4_);
#line 143 "../src/engine/api/geary-service-information.vala"
		_tmp4_ = NULL;
#line 611 "geary-service-information.c"
	}
#line 142 "../src/engine/api/geary-service-information.vala"
	geary_service_information_set_credentials (self, _tmp4_);
#line 145 "../src/engine/api/geary-service-information.vala"
	_tmp8_ = other->priv->_credentials_requirement;
#line 145 "../src/engine/api/geary-service-information.vala"
	geary_service_information_set_credentials_requirement (self, _tmp8_);
#line 146 "../src/engine/api/geary-service-information.vala"
	_tmp9_ = other->priv->_remember_password;
#line 146 "../src/engine/api/geary-service-information.vala"
	geary_service_information_set_remember_password (self, _tmp9_);
#line 136 "../src/engine/api/geary-service-information.vala"
	_g_object_unref0 (_tmp4_);
#line 136 "../src/engine/api/geary-service-information.vala"
	return self;
#line 627 "geary-service-information.c"
}

GearyServiceInformation*
geary_service_information_new_copy (GearyServiceInformation* other)
{
#line 136 "../src/engine/api/geary-service-information.vala"
	return geary_service_information_construct_copy (GEARY_TYPE_SERVICE_INFORMATION, other);
#line 635 "geary-service-information.c"
}

/**
     * Returns the default port for this service type and settings.
     */
guint16
geary_service_information_get_default_port (GearyServiceInformation* self)
{
	guint16 port = 0U;
	GearyProtocol _tmp0_;
	guint16 result;
#line 153 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (self), 0U);
#line 154 "../src/engine/api/geary-service-information.vala"
	port = (guint16) 0;
#line 156 "../src/engine/api/geary-service-information.vala"
	_tmp0_ = self->priv->_protocol;
#line 156 "../src/engine/api/geary-service-information.vala"
	switch (_tmp0_) {
#line 156 "../src/engine/api/geary-service-information.vala"
		case GEARY_PROTOCOL_IMAP:
#line 657 "geary-service-information.c"
		{
			guint16 _tmp1_ = 0U;
			GearyTlsNegotiationMethod _tmp2_;
#line 158 "../src/engine/api/geary-service-information.vala"
			_tmp2_ = self->priv->_transport_security;
#line 158 "../src/engine/api/geary-service-information.vala"
			if (_tmp2_ == GEARY_TLS_NEGOTIATION_METHOD_TRANSPORT) {
#line 159 "../src/engine/api/geary-service-information.vala"
				_tmp1_ = GEARY_IMAP_IMAP_TLS_PORT;
#line 667 "geary-service-information.c"
			} else {
#line 160 "../src/engine/api/geary-service-information.vala"
				_tmp1_ = GEARY_IMAP_IMAP_PORT;
#line 671 "geary-service-information.c"
			}
#line 158 "../src/engine/api/geary-service-information.vala"
			port = _tmp1_;
#line 161 "../src/engine/api/geary-service-information.vala"
			break;
#line 677 "geary-service-information.c"
		}
#line 156 "../src/engine/api/geary-service-information.vala"
		case GEARY_PROTOCOL_SMTP:
#line 681 "geary-service-information.c"
		{
			GearyTlsNegotiationMethod _tmp3_;
#line 164 "../src/engine/api/geary-service-information.vala"
			_tmp3_ = self->priv->_transport_security;
#line 164 "../src/engine/api/geary-service-information.vala"
			if (_tmp3_ == GEARY_TLS_NEGOTIATION_METHOD_TRANSPORT) {
#line 165 "../src/engine/api/geary-service-information.vala"
				port = GEARY_SMTP_SUBMISSION_TLS_PORT;
#line 690 "geary-service-information.c"
			} else {
				GearyCredentialsRequirement _tmp4_;
#line 166 "../src/engine/api/geary-service-information.vala"
				_tmp4_ = self->priv->_credentials_requirement;
#line 166 "../src/engine/api/geary-service-information.vala"
				if (_tmp4_ == GEARY_CREDENTIALS_REQUIREMENT_NONE) {
#line 168 "../src/engine/api/geary-service-information.vala"
					port = GEARY_SMTP_SMTP_PORT;
#line 699 "geary-service-information.c"
				} else {
#line 170 "../src/engine/api/geary-service-information.vala"
					port = GEARY_SMTP_SUBMISSION_PORT;
#line 703 "geary-service-information.c"
				}
			}
#line 172 "../src/engine/api/geary-service-information.vala"
			break;
#line 708 "geary-service-information.c"
		}
		default:
#line 156 "../src/engine/api/geary-service-information.vala"
		break;
#line 713 "geary-service-information.c"
	}
#line 175 "../src/engine/api/geary-service-information.vala"
	result = port;
#line 175 "../src/engine/api/geary-service-information.vala"
	return result;
#line 719 "geary-service-information.c"
}

/**
     * Returns true if another object is equal to this one.
     */
gboolean
geary_service_information_equal_to (GearyServiceInformation* self,
                                    GearyServiceInformation* other)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 181 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (self), FALSE);
#line 181 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (other), FALSE);
#line 182 "../src/engine/api/geary-service-information.vala"
	if (self == other) {
#line 183 "../src/engine/api/geary-service-information.vala"
		_tmp0_ = TRUE;
#line 739 "geary-service-information.c"
	} else {
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 184 "../src/engine/api/geary-service-information.vala"
		_tmp6_ = self->priv->_host;
#line 184 "../src/engine/api/geary-service-information.vala"
		_tmp7_ = other->priv->_host;
#line 184 "../src/engine/api/geary-service-information.vala"
		if (g_strcmp0 (_tmp6_, _tmp7_) == 0) {
#line 754 "geary-service-information.c"
			guint16 _tmp8_;
			guint16 _tmp9_;
#line 185 "../src/engine/api/geary-service-information.vala"
			_tmp8_ = self->priv->_port;
#line 185 "../src/engine/api/geary-service-information.vala"
			_tmp9_ = other->priv->_port;
#line 185 "../src/engine/api/geary-service-information.vala"
			_tmp5_ = _tmp8_ == _tmp9_;
#line 763 "geary-service-information.c"
		} else {
#line 184 "../src/engine/api/geary-service-information.vala"
			_tmp5_ = FALSE;
#line 767 "geary-service-information.c"
		}
#line 184 "../src/engine/api/geary-service-information.vala"
		if (_tmp5_) {
#line 771 "geary-service-information.c"
			GearyTlsNegotiationMethod _tmp10_;
			GearyTlsNegotiationMethod _tmp11_;
#line 186 "../src/engine/api/geary-service-information.vala"
			_tmp10_ = self->priv->_transport_security;
#line 186 "../src/engine/api/geary-service-information.vala"
			_tmp11_ = other->priv->_transport_security;
#line 186 "../src/engine/api/geary-service-information.vala"
			_tmp4_ = _tmp10_ == _tmp11_;
#line 780 "geary-service-information.c"
		} else {
#line 184 "../src/engine/api/geary-service-information.vala"
			_tmp4_ = FALSE;
#line 784 "geary-service-information.c"
		}
#line 184 "../src/engine/api/geary-service-information.vala"
		if (_tmp4_) {
#line 788 "geary-service-information.c"
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_ = FALSE;
			GearyCredentials* _tmp14_;
#line 187 "../src/engine/api/geary-service-information.vala"
			_tmp14_ = self->priv->_credentials;
#line 187 "../src/engine/api/geary-service-information.vala"
			if (_tmp14_ == NULL) {
#line 796 "geary-service-information.c"
				GearyCredentials* _tmp15_;
#line 187 "../src/engine/api/geary-service-information.vala"
				_tmp15_ = other->priv->_credentials;
#line 187 "../src/engine/api/geary-service-information.vala"
				_tmp13_ = _tmp15_ == NULL;
#line 802 "geary-service-information.c"
			} else {
#line 187 "../src/engine/api/geary-service-information.vala"
				_tmp13_ = FALSE;
#line 806 "geary-service-information.c"
			}
#line 187 "../src/engine/api/geary-service-information.vala"
			if (_tmp13_) {
#line 187 "../src/engine/api/geary-service-information.vala"
				_tmp12_ = TRUE;
#line 812 "geary-service-information.c"
			} else {
				gboolean _tmp16_ = FALSE;
				gboolean _tmp17_ = FALSE;
				GearyCredentials* _tmp18_;
#line 188 "../src/engine/api/geary-service-information.vala"
				_tmp18_ = self->priv->_credentials;
#line 188 "../src/engine/api/geary-service-information.vala"
				if (_tmp18_ != NULL) {
#line 821 "geary-service-information.c"
					GearyCredentials* _tmp19_;
#line 188 "../src/engine/api/geary-service-information.vala"
					_tmp19_ = other->priv->_credentials;
#line 188 "../src/engine/api/geary-service-information.vala"
					_tmp17_ = _tmp19_ != NULL;
#line 827 "geary-service-information.c"
				} else {
#line 188 "../src/engine/api/geary-service-information.vala"
					_tmp17_ = FALSE;
#line 831 "geary-service-information.c"
				}
#line 188 "../src/engine/api/geary-service-information.vala"
				if (_tmp17_) {
#line 835 "geary-service-information.c"
					GearyCredentials* _tmp20_;
					GearyCredentials* _tmp21_;
#line 189 "../src/engine/api/geary-service-information.vala"
					_tmp20_ = self->priv->_credentials;
#line 189 "../src/engine/api/geary-service-information.vala"
					_tmp21_ = other->priv->_credentials;
#line 189 "../src/engine/api/geary-service-information.vala"
					_tmp16_ = gee_hashable_equal_to (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_HASHABLE, GeeHashable), _tmp21_);
#line 844 "geary-service-information.c"
				} else {
#line 188 "../src/engine/api/geary-service-information.vala"
					_tmp16_ = FALSE;
#line 848 "geary-service-information.c"
				}
#line 188 "../src/engine/api/geary-service-information.vala"
				_tmp12_ = _tmp16_;
#line 852 "geary-service-information.c"
			}
#line 187 "../src/engine/api/geary-service-information.vala"
			_tmp3_ = _tmp12_;
#line 856 "geary-service-information.c"
		} else {
#line 184 "../src/engine/api/geary-service-information.vala"
			_tmp3_ = FALSE;
#line 860 "geary-service-information.c"
		}
#line 184 "../src/engine/api/geary-service-information.vala"
		if (_tmp3_) {
#line 864 "geary-service-information.c"
			GearyCredentialsRequirement _tmp22_;
			GearyCredentialsRequirement _tmp23_;
#line 190 "../src/engine/api/geary-service-information.vala"
			_tmp22_ = self->priv->_credentials_requirement;
#line 190 "../src/engine/api/geary-service-information.vala"
			_tmp23_ = other->priv->_credentials_requirement;
#line 190 "../src/engine/api/geary-service-information.vala"
			_tmp2_ = _tmp22_ == _tmp23_;
#line 873 "geary-service-information.c"
		} else {
#line 184 "../src/engine/api/geary-service-information.vala"
			_tmp2_ = FALSE;
#line 877 "geary-service-information.c"
		}
#line 184 "../src/engine/api/geary-service-information.vala"
		if (_tmp2_) {
#line 881 "geary-service-information.c"
			gboolean _tmp24_;
			gboolean _tmp25_;
#line 191 "../src/engine/api/geary-service-information.vala"
			_tmp24_ = self->priv->_remember_password;
#line 191 "../src/engine/api/geary-service-information.vala"
			_tmp25_ = other->priv->_remember_password;
#line 191 "../src/engine/api/geary-service-information.vala"
			_tmp1_ = _tmp24_ == _tmp25_;
#line 890 "geary-service-information.c"
		} else {
#line 184 "../src/engine/api/geary-service-information.vala"
			_tmp1_ = FALSE;
#line 894 "geary-service-information.c"
		}
#line 184 "../src/engine/api/geary-service-information.vala"
		_tmp0_ = _tmp1_;
#line 898 "geary-service-information.c"
	}
#line 182 "../src/engine/api/geary-service-information.vala"
	result = _tmp0_;
#line 182 "../src/engine/api/geary-service-information.vala"
	return result;
#line 904 "geary-service-information.c"
}

static void
geary_service_information_class_init (GearyServiceInformationClass * klass,
                                      gpointer klass_data)
{
#line 85 "../src/engine/api/geary-service-information.vala"
	geary_service_information_parent_class = g_type_class_peek_parent (klass);
#line 85 "../src/engine/api/geary-service-information.vala"
	g_type_class_adjust_private_offset (klass, &GearyServiceInformation_private_offset);
#line 85 "../src/engine/api/geary-service-information.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_service_information_get_property;
#line 85 "../src/engine/api/geary-service-information.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_service_information_set_property;
#line 85 "../src/engine/api/geary-service-information.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_service_information_finalize;
#line 921 "geary-service-information.c"
	/** Specifies the network protocol for this service. */
#line 85 "../src/engine/api/geary-service-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SERVICE_INFORMATION_PROTOCOL_PROPERTY, geary_service_information_properties[GEARY_SERVICE_INFORMATION_PROTOCOL_PROPERTY] = g_param_spec_enum ("protocol", "protocol", "protocol", GEARY_TYPE_PROTOCOL, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 925 "geary-service-information.c"
	/** The server's address. */
#line 85 "../src/engine/api/geary-service-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SERVICE_INFORMATION_HOST_PROPERTY, geary_service_information_properties[GEARY_SERVICE_INFORMATION_HOST_PROPERTY] = g_param_spec_string ("host", "host", "host", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 929 "geary-service-information.c"
	/** The server's port. */
#line 85 "../src/engine/api/geary-service-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SERVICE_INFORMATION_PORT_PROPERTY, geary_service_information_properties[GEARY_SERVICE_INFORMATION_PORT_PROPERTY] = g_param_spec_uint ("port", "port", "port", 0, G_MAXUINT, (guint16) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 933 "geary-service-information.c"
	/** The transport security method to use */
#line 85 "../src/engine/api/geary-service-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SERVICE_INFORMATION_TRANSPORT_SECURITY_PROPERTY, geary_service_information_properties[GEARY_SERVICE_INFORMATION_TRANSPORT_SECURITY_PROPERTY] = g_param_spec_enum ("transport-security", "transport-security", "transport-security", GEARY_TYPE_TLS_NEGOTIATION_METHOD, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 937 "geary-service-information.c"
	/**
	     * Determines the source of auth credentials for SMTP services.
	     */
#line 85 "../src/engine/api/geary-service-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SERVICE_INFORMATION_CREDENTIALS_REQUIREMENT_PROPERTY, geary_service_information_properties[GEARY_SERVICE_INFORMATION_CREDENTIALS_REQUIREMENT_PROPERTY] = g_param_spec_enum ("credentials-requirement", "credentials-requirement", "credentials-requirement", GEARY_CREDENTIALS_TYPE_REQUIREMENT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 943 "geary-service-information.c"
	/** The credentials used for authenticating. */
#line 85 "../src/engine/api/geary-service-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SERVICE_INFORMATION_CREDENTIALS_PROPERTY, geary_service_information_properties[GEARY_SERVICE_INFORMATION_CREDENTIALS_PROPERTY] = g_param_spec_object ("credentials", "credentials", "credentials", GEARY_TYPE_CREDENTIALS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 947 "geary-service-information.c"
	/**
	     * Whether the password should be remembered.
	     *
	     * This only makes sense with providers that support saving the
	     * password.
	     */
#line 85 "../src/engine/api/geary-service-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SERVICE_INFORMATION_REMEMBER_PASSWORD_PROPERTY, geary_service_information_properties[GEARY_SERVICE_INFORMATION_REMEMBER_PASSWORD_PROPERTY] = g_param_spec_boolean ("remember-password", "remember-password", "remember-password", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 956 "geary-service-information.c"
}

static void
geary_service_information_instance_init (GearyServiceInformation * self,
                                         gpointer klass)
{
	gchar* _tmp0_;
#line 85 "../src/engine/api/geary-service-information.vala"
	self->priv = geary_service_information_get_instance_private (self);
#line 92 "../src/engine/api/geary-service-information.vala"
	_tmp0_ = g_strdup ("");
#line 92 "../src/engine/api/geary-service-information.vala"
	self->priv->_host = _tmp0_;
#line 95 "../src/engine/api/geary-service-information.vala"
	self->priv->_port = (guint16) 0;
#line 106 "../src/engine/api/geary-service-information.vala"
	self->priv->_credentials = NULL;
#line 114 "../src/engine/api/geary-service-information.vala"
	self->priv->_remember_password = TRUE;
#line 976 "geary-service-information.c"
}

static void
geary_service_information_finalize (GObject * obj)
{
	GearyServiceInformation * self;
#line 85 "../src/engine/api/geary-service-information.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_TYPE_SERVICE_INFORMATION, GearyServiceInformation);
#line 92 "../src/engine/api/geary-service-information.vala"
	_g_free0 (self->priv->_host);
#line 106 "../src/engine/api/geary-service-information.vala"
	_g_object_unref0 (self->priv->_credentials);
#line 85 "../src/engine/api/geary-service-information.vala"
	G_OBJECT_CLASS (geary_service_information_parent_class)->finalize (obj);
#line 991 "geary-service-information.c"
}

/**
 * Encapsulates configuration information for a network service.
 */
 G_GNUC_NO_INLINE static GType
geary_service_information_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyServiceInformationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_service_information_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyServiceInformation), 0, (GInstanceInitFunc) geary_service_information_instance_init, NULL };
	GType geary_service_information_type_id;
	geary_service_information_type_id = g_type_register_static (G_TYPE_OBJECT, "GearyServiceInformation", &g_define_type_info, 0);
	GearyServiceInformation_private_offset = g_type_add_instance_private (geary_service_information_type_id, sizeof (GearyServiceInformationPrivate));
	return geary_service_information_type_id;
}

GType
geary_service_information_get_type (void)
{
	static gsize geary_service_information_type_id__once = 0;
	if (g_once_init_enter (&geary_service_information_type_id__once)) {
		GType geary_service_information_type_id;
		geary_service_information_type_id = geary_service_information_get_type_once ();
		g_once_init_leave (&geary_service_information_type_id__once, geary_service_information_type_id);
	}
	return geary_service_information_type_id__once;
}

static void
_vala_geary_service_information_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	GearyServiceInformation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_SERVICE_INFORMATION, GearyServiceInformation);
#line 85 "../src/engine/api/geary-service-information.vala"
	switch (property_id) {
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_PROTOCOL_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		g_value_set_enum (value, geary_service_information_get_protocol (self));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_HOST_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		g_value_set_string (value, geary_service_information_get_host (self));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_PORT_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		g_value_set_uint (value, geary_service_information_get_port (self));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_TRANSPORT_SECURITY_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		g_value_set_enum (value, geary_service_information_get_transport_security (self));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_CREDENTIALS_REQUIREMENT_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		g_value_set_enum (value, geary_service_information_get_credentials_requirement (self));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_CREDENTIALS_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		g_value_set_object (value, geary_service_information_get_credentials (self));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_REMEMBER_PASSWORD_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		g_value_set_boolean (value, geary_service_information_get_remember_password (self));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 1071 "geary-service-information.c"
		default:
#line 85 "../src/engine/api/geary-service-information.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 1077 "geary-service-information.c"
	}
}

static void
_vala_geary_service_information_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	GearyServiceInformation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_SERVICE_INFORMATION, GearyServiceInformation);
#line 85 "../src/engine/api/geary-service-information.vala"
	switch (property_id) {
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_PROTOCOL_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		geary_service_information_set_protocol (self, g_value_get_enum (value));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_HOST_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		geary_service_information_set_host (self, g_value_get_string (value));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_PORT_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		geary_service_information_set_port (self, g_value_get_uint (value));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_TRANSPORT_SECURITY_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		geary_service_information_set_transport_security (self, g_value_get_enum (value));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_CREDENTIALS_REQUIREMENT_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		geary_service_information_set_credentials_requirement (self, g_value_get_enum (value));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_CREDENTIALS_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		geary_service_information_set_credentials (self, g_value_get_object (value));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_REMEMBER_PASSWORD_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		geary_service_information_set_remember_password (self, g_value_get_boolean (value));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 1133 "geary-service-information.c"
		default:
#line 85 "../src/engine/api/geary-service-information.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 1139 "geary-service-information.c"
	}
}

