/* app-conversation-set.c generated by valac 0.56.17, the Vala compiler
 * generated from app-conversation-set.vala, do not modify */

/*
 * Copyright © 2016 Software Freedom Conservancy Inc.
 * Copyright © 2017-2020 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib-object.h>
#include <gee.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define GEARY_APP_TYPE_CONVERSATION_SET (geary_app_conversation_set_get_type ())
#define GEARY_APP_CONVERSATION_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_APP_TYPE_CONVERSATION_SET, GearyAppConversationSet))
#define GEARY_APP_CONVERSATION_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_APP_TYPE_CONVERSATION_SET, GearyAppConversationSetClass))
#define GEARY_APP_IS_CONVERSATION_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_APP_TYPE_CONVERSATION_SET))
#define GEARY_APP_IS_CONVERSATION_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_APP_TYPE_CONVERSATION_SET))
#define GEARY_APP_CONVERSATION_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_APP_TYPE_CONVERSATION_SET, GearyAppConversationSetClass))

typedef struct _GearyAppConversationSet GearyAppConversationSet;
typedef struct _GearyAppConversationSetClass GearyAppConversationSetClass;
typedef struct _GearyAppConversationSetPrivate GearyAppConversationSetPrivate;
enum  {
	GEARY_APP_CONVERSATION_SET_0_PROPERTY,
	GEARY_APP_CONVERSATION_SET_BASE_FOLDER_PROPERTY,
	GEARY_APP_CONVERSATION_SET_SIZE_PROPERTY,
	GEARY_APP_CONVERSATION_SET_IS_EMPTY_PROPERTY,
	GEARY_APP_CONVERSATION_SET_READ_ONLY_VIEW_PROPERTY,
	GEARY_APP_CONVERSATION_SET_LOGGING_PARENT_PROPERTY,
	GEARY_APP_CONVERSATION_SET_NUM_PROPERTIES
};
static GParamSpec* geary_app_conversation_set_properties[GEARY_APP_CONVERSATION_SET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GearyAppConversationSet {
	GearyBaseObject parent_instance;
	GearyAppConversationSetPrivate * priv;
};

struct _GearyAppConversationSetClass {
	GearyBaseObjectClass parent_class;
};

struct _GearyAppConversationSetPrivate {
	GearyFolder* _base_folder;
	GeeSet* _conversations;
	GeeHashMap* email_id_map;
	GeeHashMap* logical_message_id_map;
};

static gint GearyAppConversationSet_private_offset;
static gpointer geary_app_conversation_set_parent_class = NULL;
static GearyLoggingSourceIface * geary_app_conversation_set_geary_logging_source_parent_iface = NULL;

VALA_EXTERN GType geary_app_conversation_set_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GearyFolder* geary_app_conversation_set_get_base_folder (GearyAppConversationSet* self);
static void geary_app_conversation_set_set_base_folder (GearyAppConversationSet* self,
                                                 GearyFolder* value);
VALA_EXTERN gint geary_app_conversation_set_get_size (GearyAppConversationSet* self);
VALA_EXTERN gboolean geary_app_conversation_set_get_is_empty (GearyAppConversationSet* self);
VALA_EXTERN GeeSet* geary_app_conversation_set_get_read_only_view (GearyAppConversationSet* self);
VALA_EXTERN GearyAppConversationSet* geary_app_conversation_set_new (GearyFolder* base_folder);
VALA_EXTERN GearyAppConversationSet* geary_app_conversation_set_construct (GType object_type,
                                                               GearyFolder* base_folder);
VALA_EXTERN gint geary_app_conversation_set_get_email_count (GearyAppConversationSet* self);
VALA_EXTERN gboolean geary_app_conversation_set_has_message_id (GearyAppConversationSet* self,
                                                    GearyRFC822MessageID* message_id);
VALA_EXTERN GearyAppConversation* geary_app_conversation_set_get_by_email_identifier (GearyAppConversationSet* self,
                                                                          GearyEmailIdentifier* id);
VALA_EXTERN void geary_app_conversation_set_add_all_emails (GearyAppConversationSet* self,
                                                GeeCollection* emails,
                                                GeeMultiMap* id_to_paths,
                                                GeeCollection** added,
                                                GeeMultiMap** appended,
                                                GeeCollection** removed_due_to_merge);
static GeeSet* geary_app_conversation_set_get_associated_conversations (GearyAppConversationSet* self,
                                                                 GearyEmail* email);
static GearyAppConversation* geary_app_conversation_set_merge_conversations (GearyAppConversationSet* self,
                                                                      GeeSet* conversations,
                                                                      GeeSet* moved_email);
static GearyAppConversation* geary_app_conversation_set_add_email (GearyAppConversationSet* self,
                                                            GearyEmail* email,
                                                            GeeCollection* known_paths,
                                                            gboolean* added_conversation);
VALA_EXTERN void geary_app_conversation_set_remove_all_emails_by_identifier (GearyAppConversationSet* self,
                                                                 GearyFolderPath* source_path,
                                                                 GeeCollection* ids,
                                                                 GeeCollection* removed,
                                                                 GeeMultiMap* trimmed);
static void geary_app_conversation_set_remove_email_from_conversation (GearyAppConversationSet* self,
                                                                GearyAppConversation* conversation,
                                                                GearyEmail* email);
VALA_EXTERN void geary_app_conversation_remove_path (GearyAppConversation* self,
                                         GearyEmailIdentifier* id,
                                         GearyFolderPath* path);
VALA_EXTERN void geary_app_conversation_set_remove_conversation (GearyAppConversationSet* self,
                                                     GearyAppConversation* conversation);
static GearyLoggingState* geary_app_conversation_set_real_to_logging_state (GearyLoggingSource* base);
static GearyAppConversation* ___lambda164_ (GearyAppConversationSet* self,
                                     GearyRFC822MessageID* a);
static gpointer ____lambda164__gee_map_func (gpointer g,
                                      gpointer self);
VALA_EXTERN gboolean geary_app_conversation_add (GearyAppConversation* self,
                                     GearyEmail* email,
                                     GeeCollection* known_paths);
VALA_EXTERN GearyAppConversation* geary_app_conversation_new (GearyFolder* base_folder);
VALA_EXTERN GearyAppConversation* geary_app_conversation_construct (GType object_type,
                                                        GearyFolder* base_folder);
static void geary_app_conversation_set_add_email_to_conversation (GearyAppConversationSet* self,
                                                           GearyAppConversation* conversation,
                                                           GearyEmail* email,
                                                           GeeCollection* known_paths);
VALA_EXTERN GeeHashMultiMap* geary_app_conversation_get_path_map (GearyAppConversation* self);
VALA_EXTERN GeeSet* geary_app_conversation_remove (GearyAppConversation* self,
                                       GearyEmail* email);
static void geary_app_conversation_set_finalize (GObject * obj);
static GType geary_app_conversation_set_get_type_once (void);
static void _vala_geary_app_conversation_set_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_geary_app_conversation_set_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);

static inline gpointer
geary_app_conversation_set_get_instance_private (GearyAppConversationSet* self)
{
	return G_STRUCT_MEMBER_P (self, GearyAppConversationSet_private_offset);
}

GearyFolder*
geary_app_conversation_set_get_base_folder (GearyAppConversationSet* self)
{
	GearyFolder* result;
	GearyFolder* _tmp0_;
#line 16 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION_SET (self), NULL);
#line 16 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp0_ = self->priv->_base_folder;
#line 16 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	result = _tmp0_;
#line 16 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	return result;
#line 167 "app-conversation-set.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 16 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	return self ? g_object_ref (self) : NULL;
#line 175 "app-conversation-set.c"
}

static void
geary_app_conversation_set_set_base_folder (GearyAppConversationSet* self,
                                            GearyFolder* value)
{
	GearyFolder* old_value;
#line 16 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_if_fail (GEARY_APP_IS_CONVERSATION_SET (self));
#line 16 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	old_value = geary_app_conversation_set_get_base_folder (self);
#line 16 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	if (old_value != value) {
#line 189 "app-conversation-set.c"
		GearyFolder* _tmp0_;
#line 16 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 16 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_g_object_unref0 (self->priv->_base_folder);
#line 16 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		self->priv->_base_folder = _tmp0_;
#line 16 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_app_conversation_set_properties[GEARY_APP_CONVERSATION_SET_BASE_FOLDER_PROPERTY]);
#line 199 "app-conversation-set.c"
	}
}

gint
geary_app_conversation_set_get_size (GearyAppConversationSet* self)
{
	gint result;
	GeeSet* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 19 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION_SET (self), 0);
#line 19 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp0_ = self->priv->_conversations;
#line 19 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp1_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection));
#line 19 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp2_ = _tmp1_;
#line 19 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	result = _tmp2_;
#line 19 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	return result;
#line 222 "app-conversation-set.c"
}

gboolean
geary_app_conversation_set_get_is_empty (GearyAppConversationSet* self)
{
	gboolean result;
	GeeSet* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 22 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION_SET (self), FALSE);
#line 22 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp0_ = self->priv->_conversations;
#line 22 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp1_ = gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection));
#line 22 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp2_ = _tmp1_;
#line 22 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	result = _tmp2_;
#line 22 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	return result;
#line 244 "app-conversation-set.c"
}

GeeSet*
geary_app_conversation_set_get_read_only_view (GearyAppConversationSet* self)
{
	GeeSet* result;
	GeeSet* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
#line 26 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION_SET (self), NULL);
#line 26 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp0_ = self->priv->_conversations;
#line 26 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp1_ = gee_set_get_read_only_view (_tmp0_);
#line 26 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp2_ = _tmp1_;
#line 26 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	result = _tmp2_;
#line 26 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	return result;
#line 266 "app-conversation-set.c"
}

static const gchar*
geary_app_conversation_set_real_get_logging_domain (GearyLoggingSource* base)
{
	const gchar* result;
	GearyAppConversationSet* self;
#line 31 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_APP_TYPE_CONVERSATION_SET, GearyAppConversationSet);
#line 31 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	result = GEARY_APP_CONVERSATION_MONITOR_LOGGING_DOMAIN;
#line 31 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	return result;
#line 280 "app-conversation-set.c"
}

static GearyLoggingSource*
geary_app_conversation_set_real_get_logging_parent (GearyLoggingSource* base)
{
	GearyLoggingSource* result;
	GearyAppConversationSet* self;
	GearyFolder* _tmp0_;
#line 36 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_APP_TYPE_CONVERSATION_SET, GearyAppConversationSet);
#line 36 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp0_ = self->priv->_base_folder;
#line 36 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource);
#line 36 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	return result;
#line 297 "app-conversation-set.c"
}

/**
     * Constructs a new conversation set.
     *
     * The `base_folder` argument is the base folder for the
     * conversation monitor that owns this set.
     */
GearyAppConversationSet*
geary_app_conversation_set_construct (GType object_type,
                                      GearyFolder* base_folder)
{
	GearyAppConversationSet * self = NULL;
#line 58 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_val_if_fail (GEARY_IS_FOLDER (base_folder), NULL);
#line 58 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	self = (GearyAppConversationSet*) geary_base_object_construct (object_type);
#line 59 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	geary_app_conversation_set_set_base_folder (self, base_folder);
#line 58 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	return self;
#line 319 "app-conversation-set.c"
}

GearyAppConversationSet*
geary_app_conversation_set_new (GearyFolder* base_folder)
{
#line 58 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	return geary_app_conversation_set_construct (GEARY_APP_TYPE_CONVERSATION_SET, base_folder);
#line 327 "app-conversation-set.c"
}

gint
geary_app_conversation_set_get_email_count (GearyAppConversationSet* self)
{
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result;
#line 62 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION_SET (self), 0);
#line 63 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp0_ = self->priv->email_id_map;
#line 63 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp1_ = gee_abstract_map_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 63 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp2_ = _tmp1_;
#line 63 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	result = _tmp2_;
#line 63 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	return result;
#line 349 "app-conversation-set.c"
}

/**
     * Return whether the set has the given Message ID.  If logical_set,
     * there's no requirement that any conversation actually contain a message
     * with a matching Message-ID header, and any Message ID matching any
     * ancestor of any message in any conversation will match.
     */
gboolean
geary_app_conversation_set_has_message_id (GearyAppConversationSet* self,
                                           GearyRFC822MessageID* message_id)
{
	GeeHashMap* _tmp0_;
	gboolean result;
#line 72 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION_SET (self), FALSE);
#line 72 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE_ID (message_id), FALSE);
#line 73 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp0_ = self->priv->logical_message_id_map;
#line 73 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	result = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), message_id);
#line 73 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	return result;
#line 374 "app-conversation-set.c"
}

GearyAppConversation*
geary_app_conversation_set_get_by_email_identifier (GearyAppConversationSet* self,
                                                    GearyEmailIdentifier* id)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GearyAppConversation* result;
#line 76 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION_SET (self), NULL);
#line 76 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL_IDENTIFIER (id), NULL);
#line 77 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp0_ = self->priv->email_id_map;
#line 77 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp1_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), id);
#line 77 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	result = (GearyAppConversation*) _tmp1_;
#line 77 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	return result;
#line 396 "app-conversation-set.c"
}

/**
     * Adds a collection of emails to conversations in this set.
     *
     * This method will create and/or merge conversations as
     * needed. The collection `emails` contains the messages to be
     * added, and for each email in the collection, there should be an
     * entry in `id_to_paths` that indicates the folders each message
     * is known to belong to.
     *
     * The three collections returned include any conversation that
     * were created, any that had email appended to them (and the
     * messages that were appended), and any that were removed due to
     * being merged into another.
     */
void
geary_app_conversation_set_add_all_emails (GearyAppConversationSet* self,
                                           GeeCollection* emails,
                                           GeeMultiMap* id_to_paths,
                                           GeeCollection** added,
                                           GeeMultiMap** appended,
                                           GeeCollection** removed_due_to_merge)
{
	GeeCollection* _vala_added = NULL;
	GeeMultiMap* _vala_appended = NULL;
	GeeCollection* _vala_removed_due_to_merge = NULL;
	GeeHashSet* _added = NULL;
	GeeHashSet* _tmp0_;
	GeeHashMultiMap* _appended = NULL;
	GeeHashMultiMap* _tmp1_;
	GeeHashSet* _removed_due_to_merge = NULL;
	GeeHashSet* _tmp2_;
	GeeHashSet* _tmp59_;
	GeeCollection* _tmp60_;
	GeeHashMultiMap* _tmp61_;
	GeeMultiMap* _tmp62_;
	GeeHashSet* _tmp63_;
	GeeCollection* _tmp64_;
#line 94 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_if_fail (GEARY_APP_IS_CONVERSATION_SET (self));
#line 94 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (emails, GEE_TYPE_COLLECTION));
#line 94 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (id_to_paths, GEE_TYPE_MULTI_MAP));
#line 99 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp0_ = gee_hash_set_new (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 99 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_added = _tmp0_;
#line 101 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp1_ = gee_hash_multi_map_new (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GEARY_TYPE_EMAIL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 101 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_appended = _tmp1_;
#line 103 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp2_ = gee_hash_set_new (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 103 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_removed_due_to_merge = _tmp2_;
#line 454 "app-conversation-set.c"
	{
		GeeIterator* _email_it = NULL;
		GeeIterator* _tmp3_;
#line 106 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (emails, GEE_TYPE_ITERABLE, GeeIterable));
#line 106 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_email_it = _tmp3_;
#line 106 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		while (TRUE) {
#line 464 "app-conversation-set.c"
			GeeIterator* _tmp4_;
			GearyEmail* email = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			GeeSet* associated = NULL;
			GearyEmail* _tmp7_;
			GeeSet* _tmp8_;
			GeeSet* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			GearyAppConversation* conversation = NULL;
			gboolean added_conversation = FALSE;
			GeeCollection* known_paths = NULL;
			GearyEmail* _tmp42_;
			GearyEmailIdentifier* _tmp43_;
			GearyEmailIdentifier* _tmp44_;
			GeeCollection* _tmp45_;
			GeeCollection* _tmp46_;
			GearyAppConversation* _tmp51_;
#line 106 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp4_ = _email_it;
#line 106 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 106 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				break;
#line 490 "app-conversation-set.c"
			}
#line 106 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp5_ = _email_it;
#line 106 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 106 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			email = (GearyEmail*) _tmp6_;
#line 107 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp7_ = email;
#line 107 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp8_ = geary_app_conversation_set_get_associated_conversations (self, _tmp7_);
#line 107 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			associated = _tmp8_;
#line 108 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp9_ = associated;
#line 108 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp10_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_COLLECTION, GeeCollection));
#line 108 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp11_ = _tmp10_;
#line 108 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			if (_tmp11_ > 1) {
#line 512 "app-conversation-set.c"
				GeeSet* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
				GeeSet* moved_email = NULL;
				GeeHashSet* _tmp15_;
				GearyAppConversation* dest = NULL;
				GeeSet* _tmp16_;
				GeeSet* _tmp17_;
				GearyAppConversation* _tmp18_;
				GeeSet* _tmp19_;
				GearyAppConversation* _tmp20_;
				GeeHashSet* _tmp21_;
				GeeSet* _tmp22_;
				GeeHashSet* _tmp30_;
				GeeSet* _tmp31_;
				GeeHashSet* _tmp32_;
				GearyAppConversation* _tmp33_;
#line 117 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp12_ = associated;
#line 117 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp13_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_COLLECTION, GeeCollection));
#line 117 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp14_ = _tmp13_;
#line 117 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Merging %d conversations due new email associating with all...", _tmp14_);
#line 121 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp15_ = gee_hash_set_new (GEARY_TYPE_EMAIL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 121 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				moved_email = G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_SET, GeeSet);
#line 122 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp16_ = associated;
#line 122 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp17_ = moved_email;
#line 122 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp18_ = geary_app_conversation_set_merge_conversations (self, _tmp16_, _tmp17_);
#line 122 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				dest = _tmp18_;
#line 125 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp19_ = associated;
#line 125 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp20_ = dest;
#line 125 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_vala_assert (!gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEE_TYPE_COLLECTION, GeeCollection), _tmp20_), "!associated.contains(dest)");
#line 128 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp21_ = _added;
#line 128 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp22_ = associated;
#line 128 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				gee_collection_remove_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GEE_TYPE_COLLECTION, GeeCollection));
#line 562 "app-conversation-set.c"
				{
					GeeIterator* _removed_conversation_it = NULL;
					GeeSet* _tmp23_;
					GeeIterator* _tmp24_;
#line 129 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp23_ = associated;
#line 129 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp24_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ITERABLE, GeeIterable));
#line 129 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_removed_conversation_it = _tmp24_;
#line 129 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					while (TRUE) {
#line 575 "app-conversation-set.c"
						GeeIterator* _tmp25_;
						GearyAppConversation* removed_conversation = NULL;
						GeeIterator* _tmp26_;
						gpointer _tmp27_;
						GeeHashMultiMap* _tmp28_;
						GearyAppConversation* _tmp29_;
#line 129 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						_tmp25_ = _removed_conversation_it;
#line 129 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						if (!gee_iterator_next (_tmp25_)) {
#line 129 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							break;
#line 588 "app-conversation-set.c"
						}
#line 129 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						_tmp26_ = _removed_conversation_it;
#line 129 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						_tmp27_ = gee_iterator_get (_tmp26_);
#line 129 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						removed_conversation = (GearyAppConversation*) _tmp27_;
#line 130 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						_tmp28_ = _appended;
#line 130 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						_tmp29_ = removed_conversation;
#line 130 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						gee_multi_map_remove_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp29_);
#line 129 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						_g_object_unref0 (removed_conversation);
#line 604 "app-conversation-set.c"
					}
#line 129 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_g_object_unref0 (_removed_conversation_it);
#line 608 "app-conversation-set.c"
				}
#line 133 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp30_ = _removed_due_to_merge;
#line 133 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp31_ = associated;
#line 133 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GEE_TYPE_COLLECTION, GeeCollection));
#line 136 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp32_ = _added;
#line 136 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp33_ = dest;
#line 136 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				if (!gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp33_)) {
#line 622 "app-conversation-set.c"
					{
						GeeIterator* _moved_it = NULL;
						GeeSet* _tmp34_;
						GeeIterator* _tmp35_;
#line 137 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						_tmp34_ = moved_email;
#line 137 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						_tmp35_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, GEE_TYPE_ITERABLE, GeeIterable));
#line 137 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						_moved_it = _tmp35_;
#line 137 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						while (TRUE) {
#line 635 "app-conversation-set.c"
							GeeIterator* _tmp36_;
							GearyEmail* moved = NULL;
							GeeIterator* _tmp37_;
							gpointer _tmp38_;
							GeeHashMultiMap* _tmp39_;
							GearyAppConversation* _tmp40_;
							GearyEmail* _tmp41_;
#line 137 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_tmp36_ = _moved_it;
#line 137 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							if (!gee_iterator_next (_tmp36_)) {
#line 137 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
								break;
#line 649 "app-conversation-set.c"
							}
#line 137 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_tmp37_ = _moved_it;
#line 137 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_tmp38_ = gee_iterator_get (_tmp37_);
#line 137 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							moved = (GearyEmail*) _tmp38_;
#line 138 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_tmp39_ = _appended;
#line 138 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_tmp40_ = dest;
#line 138 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_tmp41_ = moved;
#line 138 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							gee_multi_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp40_, _tmp41_);
#line 137 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_g_object_unref0 (moved);
#line 667 "app-conversation-set.c"
						}
#line 137 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						_g_object_unref0 (_moved_it);
#line 671 "app-conversation-set.c"
					}
				}
#line 108 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_g_object_unref0 (dest);
#line 108 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_g_object_unref0 (moved_email);
#line 678 "app-conversation-set.c"
			}
#line 142 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			conversation = NULL;
#line 143 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			added_conversation = FALSE;
#line 144 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp42_ = email;
#line 144 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp43_ = geary_email_get_id (_tmp42_);
#line 144 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp44_ = _tmp43_;
#line 144 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp45_ = gee_multi_map_get (id_to_paths, _tmp44_);
#line 144 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			known_paths = _tmp45_;
#line 145 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp46_ = known_paths;
#line 145 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			if (_tmp46_ != NULL) {
#line 698 "app-conversation-set.c"
				GearyEmail* _tmp47_;
				GeeCollection* _tmp48_;
				gboolean _tmp49_ = FALSE;
				GearyAppConversation* _tmp50_;
#line 148 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp47_ = email;
#line 148 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp48_ = known_paths;
#line 148 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp50_ = geary_app_conversation_set_add_email (self, _tmp47_, _tmp48_, &_tmp49_);
#line 148 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				added_conversation = _tmp49_;
#line 148 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_g_object_unref0 (conversation);
#line 148 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				conversation = _tmp50_;
#line 715 "app-conversation-set.c"
			}
#line 153 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp51_ = conversation;
#line 153 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			if (_tmp51_ != NULL) {
#line 154 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				if (added_conversation) {
#line 723 "app-conversation-set.c"
					GeeHashSet* _tmp52_;
					GearyAppConversation* _tmp53_;
#line 155 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp52_ = _added;
#line 155 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp53_ = conversation;
#line 155 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp53_);
#line 732 "app-conversation-set.c"
				} else {
					GeeHashSet* _tmp54_;
					GearyAppConversation* _tmp55_;
#line 157 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp54_ = _added;
#line 157 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp55_ = conversation;
#line 157 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					if (!gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp54_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp55_)) {
#line 742 "app-conversation-set.c"
						GeeHashMultiMap* _tmp56_;
						GearyAppConversation* _tmp57_;
						GearyEmail* _tmp58_;
#line 158 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						_tmp56_ = _appended;
#line 158 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						_tmp57_ = conversation;
#line 158 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						_tmp58_ = email;
#line 158 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						gee_multi_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp57_, _tmp58_);
#line 754 "app-conversation-set.c"
					}
				}
			}
#line 106 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_g_object_unref0 (known_paths);
#line 106 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_g_object_unref0 (conversation);
#line 106 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_g_object_unref0 (associated);
#line 106 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_g_object_unref0 (email);
#line 766 "app-conversation-set.c"
		}
#line 106 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_g_object_unref0 (_email_it);
#line 770 "app-conversation-set.c"
	}
#line 163 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp59_ = _added;
#line 163 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp60_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp59_, GEE_TYPE_COLLECTION, GeeCollection));
#line 163 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_g_object_unref0 (_vala_added);
#line 163 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_vala_added = _tmp60_;
#line 164 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp61_ = _appended;
#line 164 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp62_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, GEE_TYPE_MULTI_MAP, GeeMultiMap));
#line 164 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_g_object_unref0 (_vala_appended);
#line 164 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_vala_appended = _tmp62_;
#line 165 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp63_ = _removed_due_to_merge;
#line 165 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp64_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp63_, GEE_TYPE_COLLECTION, GeeCollection));
#line 165 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_g_object_unref0 (_vala_removed_due_to_merge);
#line 165 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_vala_removed_due_to_merge = _tmp64_;
#line 94 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_g_object_unref0 (_removed_due_to_merge);
#line 94 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_g_object_unref0 (_appended);
#line 94 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_g_object_unref0 (_added);
#line 94 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	if (added) {
#line 94 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		*added = _vala_added;
#line 806 "app-conversation-set.c"
	} else {
#line 94 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_g_object_unref0 (_vala_added);
#line 810 "app-conversation-set.c"
	}
#line 94 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	if (appended) {
#line 94 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		*appended = _vala_appended;
#line 816 "app-conversation-set.c"
	} else {
#line 94 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_g_object_unref0 (_vala_appended);
#line 820 "app-conversation-set.c"
	}
#line 94 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	if (removed_due_to_merge) {
#line 94 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		*removed_due_to_merge = _vala_removed_due_to_merge;
#line 826 "app-conversation-set.c"
	} else {
#line 94 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_g_object_unref0 (_vala_removed_due_to_merge);
#line 830 "app-conversation-set.c"
	}
}

/**
     * Removes a number of emails from conversations in this set.
     *
     * This method will remove and/or trim conversations as
     * needed. The collection `emails_ids` contains the identifiers
     * of emails to be removed.
     *
     * The returned collections include any conversations that were
     * removed (if all of their emails were removed), and any that
     * were trimmed and the emails that were trimmed from it,
     * respectively.
     */
void
geary_app_conversation_set_remove_all_emails_by_identifier (GearyAppConversationSet* self,
                                                            GearyFolderPath* source_path,
                                                            GeeCollection* ids,
                                                            GeeCollection* removed,
                                                            GeeMultiMap* trimmed)
{
	GeeSet* remaining = NULL;
	GeeHashSet* _tmp0_;
	GearyFolder* _tmp38_;
	GearyFolderPath* _tmp39_;
	GearyFolderPath* _tmp40_;
#line 180 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_if_fail (GEARY_APP_IS_CONVERSATION_SET (self));
#line 180 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_if_fail (GEARY_IS_FOLDER_PATH (source_path));
#line 180 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (ids, GEE_TYPE_COLLECTION));
#line 180 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (removed, GEE_TYPE_COLLECTION));
#line 180 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (trimmed, GEE_TYPE_MULTI_MAP));
#line 184 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp0_ = gee_hash_set_new (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 184 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	remaining = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_SET, GeeSet);
#line 872 "app-conversation-set.c"
	{
		GeeIterator* _id_it = NULL;
		GeeIterator* _tmp1_;
#line 186 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (ids, GEE_TYPE_ITERABLE, GeeIterable));
#line 186 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_id_it = _tmp1_;
#line 186 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		while (TRUE) {
#line 882 "app-conversation-set.c"
			GeeIterator* _tmp2_;
			GearyEmailIdentifier* id = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GearyAppConversation* conversation = NULL;
			GeeHashMap* _tmp5_;
			GearyEmailIdentifier* _tmp6_;
			gpointer _tmp7_;
			GearyAppConversation* _tmp8_;
#line 186 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp2_ = _id_it;
#line 186 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 186 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				break;
#line 898 "app-conversation-set.c"
			}
#line 186 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp3_ = _id_it;
#line 186 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 186 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			id = (GearyEmailIdentifier*) _tmp4_;
#line 187 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp5_ = self->priv->email_id_map;
#line 187 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp6_ = id;
#line 187 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp7_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp6_);
#line 187 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			conversation = (GearyAppConversation*) _tmp7_;
#line 192 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp8_ = conversation;
#line 192 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			if (_tmp8_ != NULL) {
#line 918 "app-conversation-set.c"
				GearyEmail* email = NULL;
				GearyAppConversation* _tmp9_;
				GearyEmailIdentifier* _tmp10_;
				GearyEmail* _tmp11_;
				GearyEmail* _tmp12_;
				GearyAppConversation* _tmp27_;
#line 194 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp9_ = conversation;
#line 194 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp10_ = id;
#line 194 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp11_ = geary_app_conversation_get_email_by_id (_tmp9_, _tmp10_);
#line 194 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				email = _tmp11_;
#line 195 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp12_ = email;
#line 195 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				if (_tmp12_ != NULL) {
#line 937 "app-conversation-set.c"
					GearyAppConversation* _tmp13_;
					GearyEmailIdentifier* _tmp14_;
#line 196 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp13_ = conversation;
#line 196 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp14_ = id;
#line 196 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					switch (geary_app_conversation_get_folder_count (_tmp13_, _tmp14_)) {
#line 196 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						case 0:
#line 948 "app-conversation-set.c"
						{
							GearyEmailIdentifier* _tmp15_;
							gchar* _tmp16_;
							gchar* _tmp17_;
							GearyAppConversation* _tmp18_;
							gchar* _tmp19_;
							gchar* _tmp20_;
#line 198 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_tmp15_ = id;
#line 198 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_tmp16_ = geary_email_identifier_to_string (_tmp15_);
#line 198 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_tmp17_ = _tmp16_;
#line 198 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_tmp18_ = conversation;
#line 198 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_tmp19_ = geary_app_conversation_to_string (_tmp18_);
#line 198 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_tmp20_ = _tmp19_;
#line 198 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Email %s conversation %s not in any folders", _tmp17_, _tmp20_);
#line 198 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_g_free0 (_tmp20_);
#line 198 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_g_free0 (_tmp17_);
#line 200 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							break;
#line 976 "app-conversation-set.c"
						}
#line 196 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						case 1:
#line 980 "app-conversation-set.c"
						{
							GearyAppConversation* _tmp21_;
							GearyEmail* _tmp22_;
							GearyAppConversation* _tmp23_;
							GearyEmail* _tmp24_;
#line 203 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_tmp21_ = conversation;
#line 203 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_tmp22_ = email;
#line 203 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							geary_app_conversation_set_remove_email_from_conversation (self, _tmp21_, _tmp22_);
#line 204 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_tmp23_ = conversation;
#line 204 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_tmp24_ = email;
#line 204 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							gee_multi_map_set (trimmed, _tmp23_, _tmp24_);
#line 205 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							break;
#line 1000 "app-conversation-set.c"
						}
						default:
						{
							GearyAppConversation* _tmp25_;
							GearyEmailIdentifier* _tmp26_;
#line 208 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_tmp25_ = conversation;
#line 208 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_tmp26_ = id;
#line 208 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							geary_app_conversation_remove_path (_tmp25_, _tmp26_, source_path);
#line 209 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							break;
#line 1014 "app-conversation-set.c"
						}
					}
				}
#line 213 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp27_ = conversation;
#line 213 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				if (geary_app_conversation_get_count (_tmp27_) == 0) {
#line 1022 "app-conversation-set.c"
					GearyAppConversation* _tmp28_;
					gchar* _tmp29_;
					gchar* _tmp30_;
					GearyAppConversation* _tmp31_;
					GeeSet* _tmp32_;
					GearyAppConversation* _tmp33_;
					GearyAppConversation* _tmp34_;
					GearyAppConversation* _tmp35_;
#line 214 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp28_ = conversation;
#line 214 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp29_ = geary_app_conversation_to_string (_tmp28_);
#line 214 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp30_ = _tmp29_;
#line 214 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Conversation %s evaporated: No messages remains", _tmp30_);
#line 214 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_g_free0 (_tmp30_);
#line 218 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp31_ = conversation;
#line 218 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					gee_collection_add (removed, _tmp31_);
#line 219 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp32_ = remaining;
#line 219 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp33_ = conversation;
#line 219 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					gee_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, GEE_TYPE_COLLECTION, GeeCollection), _tmp33_);
#line 220 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp34_ = conversation;
#line 220 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					gee_multi_map_remove_all (trimmed, _tmp34_);
#line 221 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp35_ = conversation;
#line 221 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					geary_app_conversation_set_remove_conversation (self, _tmp35_);
#line 1059 "app-conversation-set.c"
				} else {
					GeeSet* _tmp36_;
					GearyAppConversation* _tmp37_;
#line 223 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp36_ = remaining;
#line 223 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp37_ = conversation;
#line 223 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, GEE_TYPE_COLLECTION, GeeCollection), _tmp37_);
#line 1069 "app-conversation-set.c"
				}
#line 192 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_g_object_unref0 (email);
#line 1073 "app-conversation-set.c"
			}
#line 186 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_g_object_unref0 (conversation);
#line 186 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_g_object_unref0 (id);
#line 1079 "app-conversation-set.c"
		}
#line 186 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_g_object_unref0 (_id_it);
#line 1083 "app-conversation-set.c"
	}
#line 228 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp38_ = self->priv->_base_folder;
#line 228 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp39_ = geary_folder_get_path (_tmp38_);
#line 228 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp40_ = _tmp39_;
#line 228 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	if (gee_hashable_equal_to (G_TYPE_CHECK_INSTANCE_CAST (source_path, GEE_TYPE_HASHABLE, GeeHashable), _tmp40_)) {
#line 1093 "app-conversation-set.c"
		{
			GeeIterator* _conversation_it = NULL;
			GeeSet* _tmp41_;
			GeeIterator* _tmp42_;
#line 236 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp41_ = remaining;
#line 236 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp42_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, GEE_TYPE_ITERABLE, GeeIterable));
#line 236 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_conversation_it = _tmp42_;
#line 236 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			while (TRUE) {
#line 1106 "app-conversation-set.c"
				GeeIterator* _tmp43_;
				GearyAppConversation* conversation = NULL;
				GeeIterator* _tmp44_;
				gpointer _tmp45_;
				GearyAppConversation* _tmp46_;
#line 236 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp43_ = _conversation_it;
#line 236 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				if (!gee_iterator_next (_tmp43_)) {
#line 236 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					break;
#line 1118 "app-conversation-set.c"
				}
#line 236 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp44_ = _conversation_it;
#line 236 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp45_ = gee_iterator_get (_tmp44_);
#line 236 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				conversation = (GearyAppConversation*) _tmp45_;
#line 237 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp46_ = conversation;
#line 237 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				if (geary_app_conversation_get_count_in_folder (_tmp46_, source_path) == ((guint) 0)) {
#line 1130 "app-conversation-set.c"
					GearyAppConversation* _tmp47_;
					gchar* _tmp48_;
					gchar* _tmp49_;
					GearyAppConversation* _tmp50_;
					GearyAppConversation* _tmp51_;
					GearyAppConversation* _tmp52_;
#line 238 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp47_ = conversation;
#line 238 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp48_ = geary_app_conversation_to_string (_tmp47_);
#line 238 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp49_ = _tmp48_;
#line 238 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Conversation %s dropped: No messages in base folder remain", _tmp49_);
#line 238 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_g_free0 (_tmp49_);
#line 242 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp50_ = conversation;
#line 242 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					gee_collection_add (removed, _tmp50_);
#line 243 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp51_ = conversation;
#line 243 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					gee_multi_map_remove_all (trimmed, _tmp51_);
#line 244 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp52_ = conversation;
#line 244 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					geary_app_conversation_set_remove_conversation (self, _tmp52_);
#line 1159 "app-conversation-set.c"
				}
#line 236 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_g_object_unref0 (conversation);
#line 1163 "app-conversation-set.c"
			}
#line 236 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_g_object_unref0 (_conversation_it);
#line 1167 "app-conversation-set.c"
		}
	}
#line 180 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_g_object_unref0 (remaining);
#line 1172 "app-conversation-set.c"
}

/**
     * Removes a conversation from the set.
     */
void
geary_app_conversation_set_remove_conversation (GearyAppConversationSet* self,
                                                GearyAppConversation* conversation)
{
	GeeCollection* conversation_emails = NULL;
	GeeList* _tmp0_;
	GeeSet* _tmp7_;
#line 253 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_if_fail (GEARY_APP_IS_CONVERSATION_SET (self));
#line 253 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_if_fail (GEARY_APP_IS_CONVERSATION (conversation));
#line 254 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp0_ = geary_app_conversation_get_emails (conversation, GEARY_APP_CONVERSATION_ORDERING_NONE, GEARY_APP_CONVERSATION_LOCATION_ANYWHERE, NULL, FALSE);
#line 254 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	conversation_emails = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1193 "app-conversation-set.c"
	{
		GeeIterator* _conversation_email_it = NULL;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
#line 261 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp1_ = conversation_emails;
#line 261 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp2_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ITERABLE, GeeIterable));
#line 261 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_conversation_email_it = _tmp2_;
#line 261 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		while (TRUE) {
#line 1206 "app-conversation-set.c"
			GeeIterator* _tmp3_;
			GearyEmail* conversation_email = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			GearyEmail* _tmp6_;
#line 261 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp3_ = _conversation_email_it;
#line 261 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 261 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				break;
#line 1218 "app-conversation-set.c"
			}
#line 261 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp4_ = _conversation_email_it;
#line 261 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 261 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			conversation_email = (GearyEmail*) _tmp5_;
#line 262 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp6_ = conversation_email;
#line 262 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			geary_app_conversation_set_remove_email_from_conversation (self, conversation, _tmp6_);
#line 261 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_g_object_unref0 (conversation_email);
#line 1232 "app-conversation-set.c"
		}
#line 261 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_g_object_unref0 (_conversation_email_it);
#line 1236 "app-conversation-set.c"
	}
#line 264 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp7_ = self->priv->_conversations;
#line 264 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	if (!gee_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection), conversation)) {
#line 1242 "app-conversation-set.c"
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 265 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp8_ = geary_app_conversation_to_string (conversation);
#line 265 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp9_ = _tmp8_;
#line 265 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		geary_logging_source_error (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Conversation %s already removed from set", _tmp9_);
#line 265 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_g_free0 (_tmp9_);
#line 1253 "app-conversation-set.c"
	}
#line 253 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_g_object_unref0 (conversation_emails);
#line 1257 "app-conversation-set.c"
}

/** {@inheritDoc} */
static GearyLoggingState*
geary_app_conversation_set_real_to_logging_state (GearyLoggingSource* base)
{
	GearyAppConversationSet * self;
	gint _tmp0_;
	gint _tmp1_;
	GearyLoggingState* _tmp2_;
	GearyLoggingState* result;
#line 269 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_APP_TYPE_CONVERSATION_SET, GearyAppConversationSet);
#line 270 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp0_ = geary_app_conversation_set_get_size (self);
#line 270 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp1_ = _tmp0_;
#line 270 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp2_ = geary_logging_state_new (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "size=%d", _tmp1_);
#line 270 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	result = _tmp2_;
#line 270 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	return result;
#line 1281 "app-conversation-set.c"
}

static GearyAppConversation*
___lambda164_ (GearyAppConversationSet* self,
               GearyRFC822MessageID* a)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GearyAppConversation* result;
#line 280 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE_ID (a), NULL);
#line 280 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp0_ = self->priv->logical_message_id_map;
#line 280 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp1_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), a);
#line 280 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	result = (GearyAppConversation*) _tmp1_;
#line 280 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_g_object_unref0 (a);
#line 280 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	return result;
#line 1303 "app-conversation-set.c"
}

static gpointer
____lambda164__gee_map_func (gpointer g,
                             gpointer self)
{
	gpointer result;
	result = ___lambda164_ ((GearyAppConversationSet*) self, (GearyRFC822MessageID*) g);
#line 279 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	return result;
#line 1314 "app-conversation-set.c"
}

static GeeSet*
geary_app_conversation_set_get_associated_conversations (GearyAppConversationSet* self,
                                                         GearyEmail* email)
{
	GeeSet* ancestors = NULL;
	GeeSet* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp9_;
	GeeSet* result;
#line 276 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION_SET (self), NULL);
#line 276 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (email), NULL);
#line 277 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp0_ = geary_email_get_ancestors (email);
#line 277 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	ancestors = _tmp0_;
#line 278 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp1_ = ancestors;
#line 278 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	if (_tmp1_ != NULL) {
#line 1338 "app-conversation-set.c"
		GeeSet* _tmp2_;
		GearyIterable* _tmp3_;
		GearyIterable* _tmp4_;
		GearyIterable* _tmp5_;
		GearyIterable* _tmp6_;
		GeeHashSet* _tmp7_;
		GeeSet* _tmp8_;
#line 279 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp2_ = ancestors;
#line 279 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp3_ = geary_traverse (GEARY_RF_C822_TYPE_MESSAGE_ID, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 279 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp4_ = _tmp3_;
#line 279 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp5_ = geary_iterable_map_nonnull (_tmp4_, GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, ____lambda164__gee_map_func, self);
#line 279 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp6_ = _tmp5_;
#line 279 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp7_ = geary_iterable_to_hash_set (_tmp6_, NULL, NULL, NULL, NULL, NULL, NULL);
#line 279 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp8_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_SET, GeeSet);
#line 279 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_g_object_unref0 (_tmp6_);
#line 279 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_g_object_unref0 (_tmp4_);
#line 279 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		result = _tmp8_;
#line 279 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_g_object_unref0 (ancestors);
#line 279 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		return result;
#line 1370 "app-conversation-set.c"
	}
#line 284 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp9_ = gee_set_empty (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref);
#line 284 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	result = _tmp9_;
#line 284 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_g_object_unref0 (ancestors);
#line 284 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	return result;
#line 1380 "app-conversation-set.c"
}

/**
     * Conditionally adds an email to a conversation.
     *
     * The given email will be added to new conversation if there are
     * not any associated conversations, added to an existing
     * conversation if it does not exist in an associated
     * conversation, otherwise if in an existing conversation,
     * `known_paths` will be merged with the email's paths in that
     * conversation.
     *
     * Returns the conversation the email was strictly added to, else
     * `null` if the conversation was simply merged. The parameter
     * `added_conversation` is set `true` if the returned conversation
     * was created, else it is set to `false`.
     */
static GearyAppConversation*
geary_app_conversation_set_add_email (GearyAppConversationSet* self,
                                      GearyEmail* email,
                                      GeeCollection* known_paths,
                                      gboolean* added_conversation)
{
	gboolean _vala_added_conversation = FALSE;
	GearyAppConversation* conversation = NULL;
	GeeHashMap* _tmp0_;
	GearyEmailIdentifier* _tmp1_;
	GearyEmailIdentifier* _tmp2_;
	gpointer _tmp3_;
	GearyAppConversation* _tmp4_;
	GearyAppConversation* result;
#line 302 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION_SET (self), NULL);
#line 302 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (email), NULL);
#line 302 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_val_if_fail ((known_paths == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (known_paths, GEE_TYPE_COLLECTION), NULL);
#line 305 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_vala_added_conversation = FALSE;
#line 307 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp0_ = self->priv->email_id_map;
#line 307 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp1_ = geary_email_get_id (email);
#line 307 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp2_ = _tmp1_;
#line 307 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp3_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp2_);
#line 307 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	conversation = (GearyAppConversation*) _tmp3_;
#line 308 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp4_ = conversation;
#line 308 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	if (_tmp4_ != NULL) {
#line 1434 "app-conversation-set.c"
		GearyAppConversation* _tmp5_;
#line 311 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp5_ = conversation;
#line 311 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		geary_app_conversation_add (_tmp5_, email, known_paths);
#line 314 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_g_object_unref0 (conversation);
#line 314 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		conversation = NULL;
#line 1444 "app-conversation-set.c"
	} else {
		GeeSet* associated = NULL;
		GeeSet* _tmp6_;
		GeeSet* _tmp7_;
		gpointer _tmp8_;
		GearyAppConversation* _tmp9_;
		GearyAppConversation* _tmp14_;
#line 316 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp6_ = geary_app_conversation_set_get_associated_conversations (self, email);
#line 316 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		associated = _tmp6_;
#line 318 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp7_ = associated;
#line 318 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp8_ = geary_collection_first (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection));
#line 318 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_g_object_unref0 (conversation);
#line 318 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		conversation = (GearyAppConversation*) _tmp8_;
#line 319 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp9_ = conversation;
#line 319 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		if (_tmp9_ == NULL) {
#line 1468 "app-conversation-set.c"
			GearyFolder* _tmp10_;
			GearyAppConversation* _tmp11_;
			GeeSet* _tmp12_;
			GearyAppConversation* _tmp13_;
#line 322 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp10_ = self->priv->_base_folder;
#line 322 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp11_ = geary_app_conversation_new (_tmp10_);
#line 322 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_g_object_unref0 (conversation);
#line 322 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			conversation = _tmp11_;
#line 323 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp12_ = self->priv->_conversations;
#line 323 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp13_ = conversation;
#line 323 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_COLLECTION, GeeCollection), _tmp13_);
#line 324 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_vala_added_conversation = TRUE;
#line 1489 "app-conversation-set.c"
		}
#line 328 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp14_ = conversation;
#line 328 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		geary_app_conversation_set_add_email_to_conversation (self, _tmp14_, email, known_paths);
#line 308 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_g_object_unref0 (associated);
#line 1497 "app-conversation-set.c"
	}
#line 331 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	result = conversation;
#line 331 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	if (added_conversation) {
#line 331 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		*added_conversation = _vala_added_conversation;
#line 1505 "app-conversation-set.c"
	}
#line 331 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	return result;
#line 1509 "app-conversation-set.c"
}

/**
     * Unconditionally adds an email to a conversation.
     */
static void
geary_app_conversation_set_add_email_to_conversation (GearyAppConversationSet* self,
                                                      GearyAppConversation* conversation,
                                                      GearyEmail* email,
                                                      GeeCollection* known_paths)
{
	GeeHashMap* _tmp6_;
	GearyEmailIdentifier* _tmp7_;
	GearyEmailIdentifier* _tmp8_;
	GeeSet* ancestors = NULL;
	GeeSet* _tmp9_;
	GeeSet* _tmp10_;
#line 337 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_if_fail (GEARY_APP_IS_CONVERSATION_SET (self));
#line 337 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_if_fail (GEARY_APP_IS_CONVERSATION (conversation));
#line 337 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_if_fail (GEARY_IS_EMAIL (email));
#line 337 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_if_fail ((known_paths == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (known_paths, GEE_TYPE_COLLECTION));
#line 339 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	if (!geary_app_conversation_add (conversation, email, known_paths)) {
#line 1537 "app-conversation-set.c"
		GearyEmailIdentifier* _tmp0_;
		GearyEmailIdentifier* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 340 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp0_ = geary_email_get_id (email);
#line 340 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp1_ = _tmp0_;
#line 340 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp2_ = geary_email_identifier_to_string (_tmp1_);
#line 340 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp3_ = _tmp2_;
#line 340 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp4_ = geary_app_conversation_to_string (conversation);
#line 340 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp5_ = _tmp4_;
#line 340 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		geary_logging_source_error (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Couldn't add duplicate email %s to conversation %s", _tmp3_, _tmp5_);
#line 340 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_g_free0 (_tmp5_);
#line 340 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_g_free0 (_tmp3_);
#line 1562 "app-conversation-set.c"
	}
#line 344 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp6_ = self->priv->email_id_map;
#line 344 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp7_ = geary_email_get_id (email);
#line 344 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp8_ = _tmp7_;
#line 344 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp8_, conversation);
#line 346 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp9_ = geary_email_get_ancestors (email);
#line 346 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	ancestors = _tmp9_;
#line 347 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp10_ = ancestors;
#line 347 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	if (_tmp10_ != NULL) {
#line 1580 "app-conversation-set.c"
		{
			GeeIterator* _ancestor_it = NULL;
			GeeSet* _tmp11_;
			GeeIterator* _tmp12_;
#line 348 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp11_ = ancestors;
#line 348 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp12_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ITERABLE, GeeIterable));
#line 348 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_ancestor_it = _tmp12_;
#line 348 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			while (TRUE) {
#line 1593 "app-conversation-set.c"
				GeeIterator* _tmp13_;
				GearyRFC822MessageID* ancestor = NULL;
				GeeIterator* _tmp14_;
				gpointer _tmp15_;
				GeeHashMap* _tmp16_;
				GearyRFC822MessageID* _tmp17_;
#line 348 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp13_ = _ancestor_it;
#line 348 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				if (!gee_iterator_next (_tmp13_)) {
#line 348 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					break;
#line 1606 "app-conversation-set.c"
				}
#line 348 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp14_ = _ancestor_it;
#line 348 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp15_ = gee_iterator_get (_tmp14_);
#line 348 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				ancestor = (GearyRFC822MessageID*) _tmp15_;
#line 349 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp16_ = self->priv->logical_message_id_map;
#line 349 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp17_ = ancestor;
#line 349 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp17_, conversation);
#line 348 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_g_object_unref0 (ancestor);
#line 1622 "app-conversation-set.c"
			}
#line 348 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_g_object_unref0 (_ancestor_it);
#line 1626 "app-conversation-set.c"
		}
	}
#line 337 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_g_object_unref0 (ancestors);
#line 1631 "app-conversation-set.c"
}

static GearyAppConversation*
geary_app_conversation_set_merge_conversations (GearyAppConversationSet* self,
                                                GeeSet* conversations,
                                                GeeSet* moved_email)
{
	gint _tmp0_;
	gint _tmp1_;
	GearyAppConversation* dest = NULL;
	gboolean removed = FALSE;
	GearyAppConversation* _tmp12_;
	GeeMultiMap* id_to_paths = NULL;
	GeeHashMultiMap* _tmp13_;
	GearyAppConversation* result;
#line 355 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION_SET (self), NULL);
#line 355 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (conversations, GEE_TYPE_SET), NULL);
#line 355 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (moved_email, GEE_TYPE_SET), NULL);
#line 357 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp0_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (conversations, GEE_TYPE_COLLECTION, GeeCollection));
#line 357 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp1_ = _tmp0_;
#line 357 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_vala_assert (_tmp1_ > 0, "conversations.size > 0");
#line 360 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	dest = NULL;
#line 1661 "app-conversation-set.c"
	{
		GeeIterator* _conversation_it = NULL;
		GeeIterator* _tmp2_;
#line 361 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp2_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (conversations, GEE_TYPE_ITERABLE, GeeIterable));
#line 361 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_conversation_it = _tmp2_;
#line 361 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		while (TRUE) {
#line 1671 "app-conversation-set.c"
			GeeIterator* _tmp3_;
			GearyAppConversation* conversation = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			gboolean _tmp6_ = FALSE;
			GearyAppConversation* _tmp7_;
#line 361 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp3_ = _conversation_it;
#line 361 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 361 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				break;
#line 1684 "app-conversation-set.c"
			}
#line 361 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp4_ = _conversation_it;
#line 361 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 361 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			conversation = (GearyAppConversation*) _tmp5_;
#line 362 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp7_ = dest;
#line 362 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			if (_tmp7_ == NULL) {
#line 362 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp6_ = TRUE;
#line 1698 "app-conversation-set.c"
			} else {
				GearyAppConversation* _tmp8_;
				GearyAppConversation* _tmp9_;
#line 362 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp8_ = conversation;
#line 362 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp9_ = dest;
#line 362 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp6_ = geary_app_conversation_get_count (_tmp8_) > geary_app_conversation_get_count (_tmp9_);
#line 1708 "app-conversation-set.c"
			}
#line 362 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			if (_tmp6_) {
#line 1712 "app-conversation-set.c"
				GearyAppConversation* _tmp10_;
				GearyAppConversation* _tmp11_;
#line 363 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp10_ = conversation;
#line 363 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp11_ = _g_object_ref0 (_tmp10_);
#line 363 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_g_object_unref0 (dest);
#line 363 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				dest = _tmp11_;
#line 1723 "app-conversation-set.c"
			}
#line 361 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_g_object_unref0 (conversation);
#line 1727 "app-conversation-set.c"
		}
#line 361 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_g_object_unref0 (_conversation_it);
#line 1731 "app-conversation-set.c"
	}
#line 368 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp12_ = dest;
#line 368 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	removed = gee_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (conversations, GEE_TYPE_COLLECTION, GeeCollection), _tmp12_);
#line 369 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_vala_assert (removed, "removed");
#line 373 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp13_ = gee_hash_multi_map_new (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GEARY_TYPE_FOLDER_PATH, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 373 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	id_to_paths = G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_MULTI_MAP, GeeMultiMap);
#line 1743 "app-conversation-set.c"
	{
		GeeIterator* _conversation_it = NULL;
		GeeIterator* _tmp14_;
#line 375 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp14_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (conversations, GEE_TYPE_ITERABLE, GeeIterable));
#line 375 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_conversation_it = _tmp14_;
#line 375 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		while (TRUE) {
#line 1753 "app-conversation-set.c"
			GeeIterator* _tmp15_;
			GearyAppConversation* conversation = NULL;
			GeeIterator* _tmp16_;
			gpointer _tmp17_;
			GearyAppConversation* _tmp46_;
#line 375 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp15_ = _conversation_it;
#line 375 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			if (!gee_iterator_next (_tmp15_)) {
#line 375 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				break;
#line 1765 "app-conversation-set.c"
			}
#line 375 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp16_ = _conversation_it;
#line 375 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp17_ = gee_iterator_get (_tmp16_);
#line 375 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			conversation = (GearyAppConversation*) _tmp17_;
#line 1773 "app-conversation-set.c"
			{
				GeeIterator* _id_it = NULL;
				GearyAppConversation* _tmp18_;
				GeeHashMultiMap* _tmp19_;
				GeeHashMultiMap* _tmp20_;
				GeeSet* _tmp21_;
				GeeSet* _tmp22_;
				GeeIterator* _tmp23_;
				GeeIterator* _tmp24_;
#line 376 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp18_ = conversation;
#line 376 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp19_ = geary_app_conversation_get_path_map (_tmp18_);
#line 376 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp20_ = _tmp19_;
#line 376 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp21_ = gee_multi_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_MULTI_MAP, GeeMultiMap));
#line 376 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp22_ = _tmp21_;
#line 376 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp23_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GEE_TYPE_ITERABLE, GeeIterable));
#line 376 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp24_ = _tmp23_;
#line 376 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_g_object_unref0 (_tmp22_);
#line 376 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_id_it = _tmp24_;
#line 376 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				while (TRUE) {
#line 1803 "app-conversation-set.c"
					GeeIterator* _tmp25_;
					GearyEmailIdentifier* id = NULL;
					GeeIterator* _tmp26_;
					gpointer _tmp27_;
					GearyAppConversation* _tmp28_;
					GearyEmailIdentifier* _tmp29_;
					GearyEmail* _tmp30_;
					GearyEmail* _tmp31_;
#line 376 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp25_ = _id_it;
#line 376 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					if (!gee_iterator_next (_tmp25_)) {
#line 376 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						break;
#line 1818 "app-conversation-set.c"
					}
#line 376 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp26_ = _id_it;
#line 376 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp27_ = gee_iterator_get (_tmp26_);
#line 376 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					id = (GearyEmailIdentifier*) _tmp27_;
#line 377 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp28_ = conversation;
#line 377 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp29_ = id;
#line 377 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp30_ = geary_app_conversation_get_email_by_id (_tmp28_, _tmp29_);
#line 377 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp31_ = _tmp30_;
#line 377 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (moved_email, GEE_TYPE_COLLECTION, GeeCollection), _tmp31_);
#line 377 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_g_object_unref0 (_tmp31_);
#line 1838 "app-conversation-set.c"
					{
						GeeIterator* _path_it = NULL;
						GearyAppConversation* _tmp32_;
						GeeHashMultiMap* _tmp33_;
						GeeHashMultiMap* _tmp34_;
						GearyEmailIdentifier* _tmp35_;
						GeeCollection* _tmp36_;
						GeeCollection* _tmp37_;
						GeeIterator* _tmp38_;
						GeeIterator* _tmp39_;
#line 378 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						_tmp32_ = conversation;
#line 378 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						_tmp33_ = geary_app_conversation_get_path_map (_tmp32_);
#line 378 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						_tmp34_ = _tmp33_;
#line 378 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						_tmp35_ = id;
#line 378 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						_tmp36_ = gee_multi_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp35_);
#line 378 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						_tmp37_ = _tmp36_;
#line 378 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						_tmp38_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, GEE_TYPE_ITERABLE, GeeIterable));
#line 378 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						_tmp39_ = _tmp38_;
#line 378 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						_g_object_unref0 (_tmp37_);
#line 378 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						_path_it = _tmp39_;
#line 378 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						while (TRUE) {
#line 1871 "app-conversation-set.c"
							GeeIterator* _tmp40_;
							GearyFolderPath* path = NULL;
							GeeIterator* _tmp41_;
							gpointer _tmp42_;
							GeeMultiMap* _tmp43_;
							GearyEmailIdentifier* _tmp44_;
							GearyFolderPath* _tmp45_;
#line 378 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_tmp40_ = _path_it;
#line 378 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							if (!gee_iterator_next (_tmp40_)) {
#line 378 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
								break;
#line 1885 "app-conversation-set.c"
							}
#line 378 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_tmp41_ = _path_it;
#line 378 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_tmp42_ = gee_iterator_get (_tmp41_);
#line 378 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							path = (GearyFolderPath*) _tmp42_;
#line 379 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_tmp43_ = id_to_paths;
#line 379 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_tmp44_ = id;
#line 379 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_tmp45_ = path;
#line 379 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							gee_multi_map_set (_tmp43_, _tmp44_, _tmp45_);
#line 378 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
							_g_object_unref0 (path);
#line 1903 "app-conversation-set.c"
						}
#line 378 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
						_g_object_unref0 (_path_it);
#line 1907 "app-conversation-set.c"
					}
#line 376 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_g_object_unref0 (id);
#line 1911 "app-conversation-set.c"
				}
#line 376 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_g_object_unref0 (_id_it);
#line 1915 "app-conversation-set.c"
			}
#line 382 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp46_ = conversation;
#line 382 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			geary_app_conversation_set_remove_conversation (self, _tmp46_);
#line 375 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_g_object_unref0 (conversation);
#line 1923 "app-conversation-set.c"
		}
#line 375 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_g_object_unref0 (_conversation_it);
#line 1927 "app-conversation-set.c"
	}
	{
		GeeIterator* _moved_it = NULL;
		GeeIterator* _tmp47_;
#line 386 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp47_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (moved_email, GEE_TYPE_ITERABLE, GeeIterable));
#line 386 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_moved_it = _tmp47_;
#line 386 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		while (TRUE) {
#line 1938 "app-conversation-set.c"
			GeeIterator* _tmp48_;
			GearyEmail* moved = NULL;
			GeeIterator* _tmp49_;
			gpointer _tmp50_;
			GearyAppConversation* _tmp51_;
			GearyEmail* _tmp52_;
			GeeMultiMap* _tmp53_;
			GearyEmail* _tmp54_;
			GearyEmailIdentifier* _tmp55_;
			GearyEmailIdentifier* _tmp56_;
			GeeCollection* _tmp57_;
			GeeCollection* _tmp58_;
#line 386 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp48_ = _moved_it;
#line 386 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			if (!gee_iterator_next (_tmp48_)) {
#line 386 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				break;
#line 1957 "app-conversation-set.c"
			}
#line 386 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp49_ = _moved_it;
#line 386 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp50_ = gee_iterator_get (_tmp49_);
#line 386 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			moved = (GearyEmail*) _tmp50_;
#line 387 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp51_ = dest;
#line 387 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp52_ = moved;
#line 387 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp53_ = id_to_paths;
#line 387 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp54_ = moved;
#line 387 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp55_ = geary_email_get_id (_tmp54_);
#line 387 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp56_ = _tmp55_;
#line 387 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp57_ = gee_multi_map_get (_tmp53_, _tmp56_);
#line 387 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp58_ = _tmp57_;
#line 387 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			geary_app_conversation_set_add_email_to_conversation (self, _tmp51_, _tmp52_, _tmp58_);
#line 387 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_g_object_unref0 (_tmp58_);
#line 386 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_g_object_unref0 (moved);
#line 1987 "app-conversation-set.c"
		}
#line 386 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_g_object_unref0 (_moved_it);
#line 1991 "app-conversation-set.c"
	}
#line 390 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	result = dest;
#line 390 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_g_object_unref0 (id_to_paths);
#line 390 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	return result;
#line 1999 "app-conversation-set.c"
}

/**
     * Unconditionally removes an email from a conversation.
     */
static void
geary_app_conversation_set_remove_email_from_conversation (GearyAppConversationSet* self,
                                                           GearyAppConversation* conversation,
                                                           GearyEmail* email)
{
	GeeHashMap* _tmp0_;
	GearyEmailIdentifier* _tmp1_;
	GearyEmailIdentifier* _tmp2_;
	GeeSet* removed_message_ids = NULL;
	GeeSet* _tmp7_;
	gint _tmp8_ = 0;
	GeeSet* _tmp9_;
	GeeSet* _tmp13_;
#line 396 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_if_fail (GEARY_APP_IS_CONVERSATION_SET (self));
#line 396 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_if_fail (GEARY_APP_IS_CONVERSATION (conversation));
#line 396 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_return_if_fail (GEARY_IS_EMAIL (email));
#line 397 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp0_ = self->priv->email_id_map;
#line 397 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp1_ = geary_email_get_id (email);
#line 397 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp2_ = _tmp1_;
#line 397 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	if (!gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp2_, NULL)) {
#line 2032 "app-conversation-set.c"
		GearyEmailIdentifier* _tmp3_;
		GearyEmailIdentifier* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 398 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp3_ = geary_email_get_id (email);
#line 398 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp4_ = _tmp3_;
#line 398 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp5_ = geary_email_identifier_to_string (_tmp4_);
#line 398 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp6_ = _tmp5_;
#line 398 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Email %s already removed from conversation set", _tmp6_);
#line 398 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_g_free0 (_tmp6_);
#line 2049 "app-conversation-set.c"
	}
#line 402 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp7_ = geary_app_conversation_remove (conversation, email);
#line 402 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	removed_message_ids = _tmp7_;
#line 403 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp9_ = removed_message_ids;
#line 403 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	if (_tmp9_ != NULL) {
#line 2059 "app-conversation-set.c"
		GeeSet* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
#line 403 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp10_ = removed_message_ids;
#line 403 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp11_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_COLLECTION, GeeCollection));
#line 403 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp12_ = _tmp11_;
#line 403 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp8_ = _tmp12_;
#line 2071 "app-conversation-set.c"
	} else {
#line 403 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		_tmp8_ = 0;
#line 2075 "app-conversation-set.c"
	}
#line 403 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Removed %d messages from conversation", _tmp8_);
#line 404 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp13_ = removed_message_ids;
#line 404 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	if (_tmp13_ != NULL) {
#line 2083 "app-conversation-set.c"
		{
			GeeIterator* _removed_message_id_it = NULL;
			GeeSet* _tmp14_;
			GeeIterator* _tmp15_;
#line 405 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp14_ = removed_message_ids;
#line 405 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_tmp15_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_ITERABLE, GeeIterable));
#line 405 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_removed_message_id_it = _tmp15_;
#line 405 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			while (TRUE) {
#line 2096 "app-conversation-set.c"
				GeeIterator* _tmp16_;
				GearyRFC822MessageID* removed_message_id = NULL;
				GeeIterator* _tmp17_;
				gpointer _tmp18_;
				GeeHashMap* _tmp19_;
				GearyRFC822MessageID* _tmp20_;
#line 405 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp16_ = _removed_message_id_it;
#line 405 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				if (!gee_iterator_next (_tmp16_)) {
#line 405 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					break;
#line 2109 "app-conversation-set.c"
				}
#line 405 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp17_ = _removed_message_id_it;
#line 405 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp18_ = gee_iterator_get (_tmp17_);
#line 405 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				removed_message_id = (GearyRFC822MessageID*) _tmp18_;
#line 406 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp19_ = self->priv->logical_message_id_map;
#line 406 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_tmp20_ = removed_message_id;
#line 406 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				if (!gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp20_, NULL)) {
#line 2123 "app-conversation-set.c"
					GearyRFC822MessageID* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
#line 407 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp21_ = removed_message_id;
#line 407 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp22_ = geary_message_data_abstract_message_data_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA, GearyMessageDataAbstractMessageData));
#line 407 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_tmp23_ = _tmp22_;
#line 407 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					geary_logging_source_error (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Message ID %s already removed from conversation set logical map", _tmp23_);
#line 407 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
					_g_free0 (_tmp23_);
#line 2137 "app-conversation-set.c"
				}
#line 405 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
				_g_object_unref0 (removed_message_id);
#line 2141 "app-conversation-set.c"
			}
#line 405 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
			_g_object_unref0 (_removed_message_id_it);
#line 2145 "app-conversation-set.c"
		}
	}
#line 396 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_g_object_unref0 (removed_message_ids);
#line 2150 "app-conversation-set.c"
}

static void
geary_app_conversation_set_class_init (GearyAppConversationSetClass * klass,
                                       gpointer klass_data)
{
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	geary_app_conversation_set_parent_class = g_type_class_peek_parent (klass);
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_type_class_adjust_private_offset (klass, &GearyAppConversationSet_private_offset);
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_app_conversation_set_get_property;
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_app_conversation_set_set_property;
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_app_conversation_set_finalize;
#line 2167 "app-conversation-set.c"
	/** The base folder for this set of conversations. */
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_APP_CONVERSATION_SET_BASE_FOLDER_PROPERTY, geary_app_conversation_set_properties[GEARY_APP_CONVERSATION_SET_BASE_FOLDER_PROPERTY] = g_param_spec_object ("base-folder", "base-folder", "base-folder", GEARY_TYPE_FOLDER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2171 "app-conversation-set.c"
	/** Determines the number of conversations in the set. */
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_APP_CONVERSATION_SET_SIZE_PROPERTY, geary_app_conversation_set_properties[GEARY_APP_CONVERSATION_SET_SIZE_PROPERTY] = g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2175 "app-conversation-set.c"
	/** Determines the set contains no conversations.  */
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_APP_CONVERSATION_SET_IS_EMPTY_PROPERTY, geary_app_conversation_set_properties[GEARY_APP_CONVERSATION_SET_IS_EMPTY_PROPERTY] = g_param_spec_boolean ("is-empty", "is-empty", "is-empty", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2179 "app-conversation-set.c"
	/** Returns a read-only view of conversations in the set.  */
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_APP_CONVERSATION_SET_READ_ONLY_VIEW_PROPERTY, geary_app_conversation_set_properties[GEARY_APP_CONVERSATION_SET_READ_ONLY_VIEW_PROPERTY] = g_param_spec_object ("read-only-view", "read-only-view", "read-only-view", GEE_TYPE_SET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2183 "app-conversation-set.c"
	/** {@inheritDoc} */
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_APP_CONVERSATION_SET_LOGGING_PARENT_PROPERTY, geary_app_conversation_set_properties[GEARY_APP_CONVERSATION_SET_LOGGING_PARENT_PROPERTY] = g_param_spec_object ("logging-parent", "logging-parent", "logging-parent", GEARY_LOGGING_TYPE_SOURCE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2187 "app-conversation-set.c"
}

static void
geary_app_conversation_set_geary_logging_source_interface_init (GearyLoggingSourceIface * iface,
                                                                gpointer iface_data)
{
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	geary_app_conversation_set_geary_logging_source_parent_iface = g_type_interface_peek_parent (iface);
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	iface->to_logging_state = (GearyLoggingState* (*) (GearyLoggingSource*)) geary_app_conversation_set_real_to_logging_state;
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	iface->get_logging_domain = geary_app_conversation_set_real_get_logging_domain;
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	iface->get_logging_parent = geary_app_conversation_set_real_get_logging_parent;
#line 2202 "app-conversation-set.c"
}

static void
geary_app_conversation_set_instance_init (GearyAppConversationSet * self,
                                          gpointer klass)
{
	GeeHashSet* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	self->priv = geary_app_conversation_set_get_instance_private (self);
#line 40 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp0_ = gee_hash_set_new (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 40 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	self->priv->_conversations = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_SET, GeeSet);
#line 43 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp1_ = gee_hash_map_new (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 43 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	self->priv->email_id_map = _tmp1_;
#line 48 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_tmp2_ = gee_hash_map_new (GEARY_RF_C822_TYPE_MESSAGE_ID, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 48 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	self->priv->logical_message_id_map = _tmp2_;
#line 2226 "app-conversation-set.c"
}

static void
geary_app_conversation_set_finalize (GObject * obj)
{
	GearyAppConversationSet * self;
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_APP_TYPE_CONVERSATION_SET, GearyAppConversationSet);
#line 16 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_g_object_unref0 (self->priv->_base_folder);
#line 40 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_g_object_unref0 (self->priv->_conversations);
#line 43 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_g_object_unref0 (self->priv->email_id_map);
#line 48 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	_g_object_unref0 (self->priv->logical_message_id_map);
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	G_OBJECT_CLASS (geary_app_conversation_set_parent_class)->finalize (obj);
#line 2245 "app-conversation-set.c"
}

/**
 * Creates and maintains set of conversations by adding and removing email.
 */
 G_GNUC_NO_INLINE static GType
geary_app_conversation_set_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyAppConversationSetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_app_conversation_set_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyAppConversationSet), 0, (GInstanceInitFunc) geary_app_conversation_set_instance_init, NULL };
	static const GInterfaceInfo geary_logging_source_info = { (GInterfaceInitFunc) geary_app_conversation_set_geary_logging_source_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType geary_app_conversation_set_type_id;
	geary_app_conversation_set_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyAppConversationSet", &g_define_type_info, 0);
	g_type_add_interface_static (geary_app_conversation_set_type_id, GEARY_LOGGING_TYPE_SOURCE, &geary_logging_source_info);
	GearyAppConversationSet_private_offset = g_type_add_instance_private (geary_app_conversation_set_type_id, sizeof (GearyAppConversationSetPrivate));
	return geary_app_conversation_set_type_id;
}

GType
geary_app_conversation_set_get_type (void)
{
	static gsize geary_app_conversation_set_type_id__once = 0;
	if (g_once_init_enter (&geary_app_conversation_set_type_id__once)) {
		GType geary_app_conversation_set_type_id;
		geary_app_conversation_set_type_id = geary_app_conversation_set_get_type_once ();
		g_once_init_leave (&geary_app_conversation_set_type_id__once, geary_app_conversation_set_type_id);
	}
	return geary_app_conversation_set_type_id__once;
}

static void
_vala_geary_app_conversation_set_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	GearyAppConversationSet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_APP_TYPE_CONVERSATION_SET, GearyAppConversationSet);
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	switch (property_id) {
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		case GEARY_APP_CONVERSATION_SET_BASE_FOLDER_PROPERTY:
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		g_value_set_object (value, geary_app_conversation_set_get_base_folder (self));
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		break;
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		case GEARY_APP_CONVERSATION_SET_SIZE_PROPERTY:
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		g_value_set_int (value, geary_app_conversation_set_get_size (self));
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		break;
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		case GEARY_APP_CONVERSATION_SET_IS_EMPTY_PROPERTY:
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		g_value_set_boolean (value, geary_app_conversation_set_get_is_empty (self));
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		break;
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		case GEARY_APP_CONVERSATION_SET_READ_ONLY_VIEW_PROPERTY:
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		g_value_take_object (value, geary_app_conversation_set_get_read_only_view (self));
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		break;
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		case GEARY_APP_CONVERSATION_SET_LOGGING_PARENT_PROPERTY:
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		g_value_set_object (value, geary_logging_source_get_logging_parent (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource)));
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		break;
#line 2315 "app-conversation-set.c"
		default:
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		break;
#line 2321 "app-conversation-set.c"
	}
}

static void
_vala_geary_app_conversation_set_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	GearyAppConversationSet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_APP_TYPE_CONVERSATION_SET, GearyAppConversationSet);
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
	switch (property_id) {
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		case GEARY_APP_CONVERSATION_SET_BASE_FOLDER_PROPERTY:
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		geary_app_conversation_set_set_base_folder (self, g_value_get_object (value));
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		break;
#line 2341 "app-conversation-set.c"
		default:
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "../src/engine/app/conversation-monitor/app-conversation-set.vala"
		break;
#line 2347 "app-conversation-set.c"
	}
}

