/* common-contact-harvester.c generated by valac 0.56.17, the Vala compiler
 * generated from common-contact-harvester.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2019 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <gee.h>
#include "geary-engine.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#define GEARY_CONTACT_HARVESTER_IMPL_REQUIRED_FIELDS (GEARY_EMAIL_FIELD_ORIGINATORS | GEARY_EMAIL_FIELD_RECEIVERS)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define GEARY_TYPE_CONTACT_HARVESTER (geary_contact_harvester_get_type ())
#define GEARY_CONTACT_HARVESTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_CONTACT_HARVESTER, GearyContactHarvester))
#define GEARY_IS_CONTACT_HARVESTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_CONTACT_HARVESTER))
#define GEARY_CONTACT_HARVESTER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEARY_TYPE_CONTACT_HARVESTER, GearyContactHarvesterIface))

typedef struct _GearyContactHarvester GearyContactHarvester;
typedef struct _GearyContactHarvesterIface GearyContactHarvesterIface;

#define GEARY_TYPE_CONTACT_HARVESTER_IMPL (geary_contact_harvester_impl_get_type ())
#define GEARY_CONTACT_HARVESTER_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_CONTACT_HARVESTER_IMPL, GearyContactHarvesterImpl))
#define GEARY_CONTACT_HARVESTER_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_CONTACT_HARVESTER_IMPL, GearyContactHarvesterImplClass))
#define GEARY_IS_CONTACT_HARVESTER_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_CONTACT_HARVESTER_IMPL))
#define GEARY_IS_CONTACT_HARVESTER_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_CONTACT_HARVESTER_IMPL))
#define GEARY_CONTACT_HARVESTER_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_CONTACT_HARVESTER_IMPL, GearyContactHarvesterImplClass))

typedef struct _GearyContactHarvesterImpl GearyContactHarvesterImpl;
typedef struct _GearyContactHarvesterImplClass GearyContactHarvesterImplClass;
typedef struct _GearyContactHarvesterImplPrivate GearyContactHarvesterImplPrivate;
enum  {
	GEARY_CONTACT_HARVESTER_IMPL_0_PROPERTY,
	GEARY_CONTACT_HARVESTER_IMPL_NUM_PROPERTIES
};
static GParamSpec* geary_contact_harvester_impl_properties[GEARY_CONTACT_HARVESTER_IMPL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _GearyContactHarvesterImplHarvestFromEmailData GearyContactHarvesterImplHarvestFromEmailData;
typedef struct _GearyContactHarvesterImplAddContactsData GearyContactHarvesterImplAddContactsData;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _GearyContactHarvesterImplAddContactData GearyContactHarvesterImplAddContactData;

struct _GearyContactHarvesterIface {
	GTypeInterface parent_iface;
	void (*harvest_from_email) (GearyContactHarvester* self, GeeCollection* messages, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*harvest_from_email_finish) (GearyContactHarvester* self, GAsyncResult* _res_, GError** error);
};

struct _GearyContactHarvesterImpl {
	GearyBaseObject parent_instance;
	GearyContactHarvesterImplPrivate * priv;
};

struct _GearyContactHarvesterImplClass {
	GearyBaseObjectClass parent_class;
};

struct _GearyContactHarvesterImplPrivate {
	GearyContactStore* store;
	GeeCollection* owner_mailboxes;
	GearyFolderSpecialUse location;
	gboolean is_whitelisted;
};

struct _GearyContactHarvesterImplHarvestFromEmailData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyContactHarvesterImpl* self;
	GeeCollection* messages;
	GCancellable* cancellable;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GeeMap* contacts;
	GeeHashMap* _tmp3_;
	gint importance;
	GearyEmailField type;
	GeeIterator* _message_it;
	GeeIterator* _tmp4_;
	GeeIterator* _tmp5_;
	GearyEmail* message;
	GeeIterator* _tmp6_;
	gpointer _tmp7_;
	GearyEmail* _tmp8_;
	GearyEmailField _tmp9_;
	GearyEmailField _tmp10_;
	GeeMap* _tmp11_;
	GearyEmail* _tmp12_;
	GearyRFC822MailboxAddresses* _tmp13_;
	GearyRFC822MailboxAddresses* _tmp14_;
	GearyEmail* _tmp15_;
	GearyRFC822MailboxAddress* _tmp16_;
	GearyRFC822MailboxAddress* _tmp17_;
	GeeMap* _tmp18_;
	GearyEmail* _tmp19_;
	GearyRFC822MailboxAddress* _tmp20_;
	GearyRFC822MailboxAddress* _tmp21_;
	GeeMap* _tmp22_;
	GearyEmail* _tmp23_;
	GearyRFC822MailboxAddresses* _tmp24_;
	GearyRFC822MailboxAddresses* _tmp25_;
	GeeMap* _tmp26_;
	GearyEmail* _tmp27_;
	GearyRFC822MailboxAddresses* _tmp28_;
	GearyRFC822MailboxAddresses* _tmp29_;
	GeeMap* _tmp30_;
	GearyEmail* _tmp31_;
	GearyRFC822MailboxAddresses* _tmp32_;
	GearyRFC822MailboxAddresses* _tmp33_;
	GeeMap* _tmp34_;
	GearyEmail* _tmp35_;
	GearyRFC822MailboxAddresses* _tmp36_;
	GearyRFC822MailboxAddresses* _tmp37_;
	GearyContactStore* _tmp38_;
	GeeMap* _tmp39_;
	GeeCollection* _tmp40_;
	GeeCollection* _tmp41_;
	GeeCollection* _tmp42_;
	GError* _inner_error0_;
};

struct _GearyContactHarvesterImplAddContactsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyContactHarvesterImpl* self;
	GeeMap* contacts;
	GearyRFC822MailboxAddresses* addresses;
	GearyEmailField type;
	gint importance;
	GCancellable* cancellable;
	GearyRFC822MailboxAddresses* _address_list;
	gint _address_size;
	GearyRFC822MailboxAddresses* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _address_index;
	gint _tmp3_;
	gint _tmp4_;
	GearyRFC822MailboxAddress* address;
	GearyRFC822MailboxAddresses* _tmp5_;
	GearyRFC822MailboxAddress* _tmp6_;
	GearyRFC822MailboxAddress* _tmp7_;
	GError* _inner_error0_;
};

struct _GearyContactHarvesterImplAddContactData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyContactHarvesterImpl* self;
	GeeMap* contacts;
	GearyRFC822MailboxAddress* address;
	GearyEmailField type;
	gint importance;
	GCancellable* cancellable;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GeeCollection* _tmp2_;
	GearyContact* contact;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gpointer _tmp7_;
	GearyContact* _tmp8_;
	GearyContact* _tmp9_;
	GearyContact* _tmp10_;
	GearyContactStore* _tmp11_;
	GearyContact* _tmp12_;
	GearyContact* _tmp13_;
	GearyContact* _tmp14_;
	GearyContact* _tmp15_;
	GearyContact* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	GearyContact* _tmp19_;
	gboolean _tmp20_;
	GearyContact* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	GearyContact* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	GearyContact* _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	GearyContact* _tmp32_;
	GError* _inner_error0_;
};

static gint GearyContactHarvesterImpl_private_offset;
static gpointer geary_contact_harvester_impl_parent_class = NULL;
static GearyContactHarvesterIface * geary_contact_harvester_impl_geary_contact_harvester_parent_iface = NULL;

VALA_EXTERN GType geary_contact_harvester_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void geary_contact_harvester_harvest_from_email (GearyContactHarvester* self,
                                                 GeeCollection* messages,
                                                 GCancellable* cancellable,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
VALA_EXTERN void geary_contact_harvester_harvest_from_email_finish (GearyContactHarvester* self,
                                                        GAsyncResult* _res_,
                                                        GError** error);
static GType geary_contact_harvester_get_type_once (void);
VALA_EXTERN GType geary_contact_harvester_impl_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GearyContactHarvesterImpl* geary_contact_harvester_impl_new (GearyContactStore* store,
                                                             GearyFolderSpecialUse location,
                                                             GeeCollection* owners);
VALA_EXTERN GearyContactHarvesterImpl* geary_contact_harvester_impl_construct (GType object_type,
                                                                   GearyContactStore* store,
                                                                   GearyFolderSpecialUse location,
                                                                   GeeCollection* owners);
static gboolean _vala_geary_folder_special_use_array_contains (GearyFolderSpecialUse * stack,
                                                        gssize stack_length,
                                                        const GearyFolderSpecialUse needle);
static void geary_contact_harvester_impl_real_harvest_from_email_data_free (gpointer _data);
static void geary_contact_harvester_impl_real_harvest_from_email (GearyContactHarvester* base,
                                                           GeeCollection* messages,
                                                           GCancellable* cancellable,
                                                           GAsyncReadyCallback _callback_,
                                                           gpointer _user_data_);
static gboolean geary_contact_harvester_impl_real_harvest_from_email_co (GearyContactHarvesterImplHarvestFromEmailData* _data_);
static void geary_contact_harvester_impl_add_contacts (GearyContactHarvesterImpl* self,
                                                GeeMap* contacts,
                                                GearyRFC822MailboxAddresses* addresses,
                                                GearyEmailField type,
                                                gint importance,
                                                GCancellable* cancellable,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static void geary_contact_harvester_impl_add_contacts_finish (GearyContactHarvesterImpl* self,
                                                       GAsyncResult* _res_,
                                                       GError** error);
static void geary_contact_harvester_impl_harvest_from_email_ready (GObject* source_object,
                                                            GAsyncResult* _res_,
                                                            gpointer _user_data_);
static void geary_contact_harvester_impl_add_contact (GearyContactHarvesterImpl* self,
                                               GeeMap* contacts,
                                               GearyRFC822MailboxAddress* address,
                                               GearyEmailField type,
                                               gint importance,
                                               GCancellable* cancellable,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
static void geary_contact_harvester_impl_add_contact_finish (GearyContactHarvesterImpl* self,
                                                      GAsyncResult* _res_,
                                                      GError** error);
static void geary_contact_harvester_impl_add_contacts_data_free (gpointer _data);
static gboolean geary_contact_harvester_impl_add_contacts_co (GearyContactHarvesterImplAddContactsData* _data_);
static void geary_contact_harvester_impl_add_contacts_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
static void geary_contact_harvester_impl_add_contact_data_free (gpointer _data);
static gboolean geary_contact_harvester_impl_add_contact_co (GearyContactHarvesterImplAddContactData* _data_);
static void geary_contact_harvester_impl_add_contact_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_);
static void geary_contact_harvester_impl_finalize (GObject * obj);
static GType geary_contact_harvester_impl_get_type_once (void);

static const GearyFolderSpecialUse GEARY_CONTACT_HARVESTER_IMPL_FOLDER_WHITELIST[4] = {GEARY_FOLDER_SPECIAL_USE_INBOX, GEARY_FOLDER_SPECIAL_USE_ARCHIVE, GEARY_FOLDER_SPECIAL_USE_SENT, GEARY_FOLDER_SPECIAL_USE_NONE};

void
geary_contact_harvester_harvest_from_email (GearyContactHarvester* self,
                                            GeeCollection* messages,
                                            GCancellable* cancellable,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	GearyContactHarvesterIface* _iface_;
#line 10 "../src/engine/common/common-contact-harvester.vala"
	_iface_ = GEARY_CONTACT_HARVESTER_GET_INTERFACE (self);
#line 10 "../src/engine/common/common-contact-harvester.vala"
	if (_iface_->harvest_from_email) {
#line 10 "../src/engine/common/common-contact-harvester.vala"
		_iface_->harvest_from_email (self, messages, cancellable, _callback_, _user_data_);
#line 301 "common-contact-harvester.c"
	}
}

void
geary_contact_harvester_harvest_from_email_finish (GearyContactHarvester* self,
                                                   GAsyncResult* _res_,
                                                   GError** error)
{
	GearyContactHarvesterIface* _iface_;
#line 10 "../src/engine/common/common-contact-harvester.vala"
	_iface_ = GEARY_CONTACT_HARVESTER_GET_INTERFACE (self);
#line 10 "../src/engine/common/common-contact-harvester.vala"
	if (_iface_->harvest_from_email_finish) {
#line 10 "../src/engine/common/common-contact-harvester.vala"
		_iface_->harvest_from_email_finish (self, _res_, error);
#line 317 "common-contact-harvester.c"
	}
}

static void
geary_contact_harvester_default_init (GearyContactHarvesterIface * iface,
                                      gpointer iface_data)
{
}

/** Denotes objects that extract contacts from email meages. */
 G_GNUC_NO_INLINE static GType
geary_contact_harvester_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyContactHarvesterIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_contact_harvester_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType geary_contact_harvester_type_id;
	geary_contact_harvester_type_id = g_type_register_static (G_TYPE_INTERFACE, "GearyContactHarvester", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (geary_contact_harvester_type_id, G_TYPE_OBJECT);
	return geary_contact_harvester_type_id;
}

GType
geary_contact_harvester_get_type (void)
{
	static gsize geary_contact_harvester_type_id__once = 0;
	if (g_once_init_enter (&geary_contact_harvester_type_id__once)) {
		GType geary_contact_harvester_type_id;
		geary_contact_harvester_type_id = geary_contact_harvester_get_type_once ();
		g_once_init_leave (&geary_contact_harvester_type_id__once, geary_contact_harvester_type_id);
	}
	return geary_contact_harvester_type_id__once;
}

static inline gpointer
geary_contact_harvester_impl_get_instance_private (GearyContactHarvesterImpl* self)
{
	return G_STRUCT_MEMBER_P (self, GearyContactHarvesterImpl_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 40 "../src/engine/common/common-contact-harvester.vala"
	return self ? g_object_ref (self) : NULL;
#line 361 "common-contact-harvester.c"
}

static gboolean
_vala_geary_folder_special_use_array_contains (GearyFolderSpecialUse * stack,
                                               gssize stack_length,
                                               const GearyFolderSpecialUse needle)
{
	gssize i;
#line 43 "../src/engine/common/common-contact-harvester.vala"
	for (i = 0; i < stack_length; i++) {
#line 43 "../src/engine/common/common-contact-harvester.vala"
		if (needle == stack[i]) {
#line 43 "../src/engine/common/common-contact-harvester.vala"
			return TRUE;
#line 376 "common-contact-harvester.c"
		}
	}
#line 43 "../src/engine/common/common-contact-harvester.vala"
	return FALSE;
#line 381 "common-contact-harvester.c"
}

GearyContactHarvesterImpl*
geary_contact_harvester_impl_construct (GType object_type,
                                        GearyContactStore* store,
                                        GearyFolderSpecialUse location,
                                        GeeCollection* owners)
{
	GearyContactHarvesterImpl * self = NULL;
	GearyContactStore* _tmp0_;
	GeeCollection* _tmp1_;
#line 37 "../src/engine/common/common-contact-harvester.vala"
	g_return_val_if_fail (GEARY_IS_CONTACT_STORE (store), NULL);
#line 37 "../src/engine/common/common-contact-harvester.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (owners, GEE_TYPE_COLLECTION), NULL);
#line 37 "../src/engine/common/common-contact-harvester.vala"
	self = (GearyContactHarvesterImpl*) geary_base_object_construct (object_type);
#line 40 "../src/engine/common/common-contact-harvester.vala"
	_tmp0_ = _g_object_ref0 (store);
#line 40 "../src/engine/common/common-contact-harvester.vala"
	_g_object_unref0 (self->priv->store);
#line 40 "../src/engine/common/common-contact-harvester.vala"
	self->priv->store = _tmp0_;
#line 41 "../src/engine/common/common-contact-harvester.vala"
	_tmp1_ = _g_object_ref0 (owners);
#line 41 "../src/engine/common/common-contact-harvester.vala"
	_g_object_unref0 (self->priv->owner_mailboxes);
#line 41 "../src/engine/common/common-contact-harvester.vala"
	self->priv->owner_mailboxes = _tmp1_;
#line 42 "../src/engine/common/common-contact-harvester.vala"
	self->priv->location = location;
#line 43 "../src/engine/common/common-contact-harvester.vala"
	self->priv->is_whitelisted = _vala_geary_folder_special_use_array_contains (GEARY_CONTACT_HARVESTER_IMPL_FOLDER_WHITELIST, G_N_ELEMENTS (GEARY_CONTACT_HARVESTER_IMPL_FOLDER_WHITELIST), location);
#line 37 "../src/engine/common/common-contact-harvester.vala"
	return self;
#line 417 "common-contact-harvester.c"
}

GearyContactHarvesterImpl*
geary_contact_harvester_impl_new (GearyContactStore* store,
                                  GearyFolderSpecialUse location,
                                  GeeCollection* owners)
{
#line 37 "../src/engine/common/common-contact-harvester.vala"
	return geary_contact_harvester_impl_construct (GEARY_TYPE_CONTACT_HARVESTER_IMPL, store, location, owners);
#line 427 "common-contact-harvester.c"
}

static void
geary_contact_harvester_impl_real_harvest_from_email_data_free (gpointer _data)
{
	GearyContactHarvesterImplHarvestFromEmailData* _data_;
	_data_ = _data;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_g_object_unref0 (_data_->messages);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_g_object_unref0 (_data_->cancellable);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_g_object_unref0 (_data_->self);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	g_slice_free (GearyContactHarvesterImplHarvestFromEmailData, _data_);
#line 443 "common-contact-harvester.c"
}

static void
geary_contact_harvester_impl_real_harvest_from_email (GearyContactHarvester* base,
                                                      GeeCollection* messages,
                                                      GCancellable* cancellable,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_)
{
	GearyContactHarvesterImpl * self;
	GearyContactHarvesterImplHarvestFromEmailData* _data_;
	GearyContactHarvesterImpl* _tmp0_;
	GeeCollection* _tmp1_;
	GCancellable* _tmp2_;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (messages, GEE_TYPE_COLLECTION));
#line 19 "../src/engine/common/common-contact-harvester.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 19 "../src/engine/common/common-contact-harvester.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_CONTACT_HARVESTER_IMPL, GearyContactHarvesterImpl);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_data_ = g_slice_new0 (GearyContactHarvesterImplHarvestFromEmailData);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_contact_harvester_impl_real_harvest_from_email_data_free);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_data_->self = _tmp0_;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_tmp1_ = _g_object_ref0 (messages);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_g_object_unref0 (_data_->messages);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_data_->messages = _tmp1_;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_g_object_unref0 (_data_->cancellable);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_data_->cancellable = _tmp2_;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	geary_contact_harvester_impl_real_harvest_from_email_co (_data_);
#line 488 "common-contact-harvester.c"
}

static void
geary_contact_harvester_impl_harvest_from_email_finish (GearyContactHarvester* base,
                                                        GAsyncResult* _res_,
                                                        GError** error)
{
	GearyContactHarvesterImplHarvestFromEmailData* _data_;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	if (NULL == _data_) {
#line 19 "../src/engine/common/common-contact-harvester.vala"
		return;
#line 503 "common-contact-harvester.c"
	}
}

static void
geary_contact_harvester_impl_harvest_from_email_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_)
{
	GearyContactHarvesterImplHarvestFromEmailData* _data_;
#line 59 "../src/engine/common/common-contact-harvester.vala"
	_data_ = _user_data_;
#line 59 "../src/engine/common/common-contact-harvester.vala"
	_data_->_source_object_ = source_object;
#line 59 "../src/engine/common/common-contact-harvester.vala"
	_data_->_res_ = _res_;
#line 59 "../src/engine/common/common-contact-harvester.vala"
	geary_contact_harvester_impl_real_harvest_from_email_co (_data_);
#line 521 "common-contact-harvester.c"
}

static gboolean
geary_contact_harvester_impl_real_harvest_from_email_co (GearyContactHarvesterImplHarvestFromEmailData* _data_)
{
#line 46 "../src/engine/common/common-contact-harvester.vala"
	switch (_data_->_state_) {
#line 46 "../src/engine/common/common-contact-harvester.vala"
		case 0:
#line 531 "common-contact-harvester.c"
		goto _state_0;
#line 46 "../src/engine/common/common-contact-harvester.vala"
		case 1:
#line 535 "common-contact-harvester.c"
		goto _state_1;
#line 46 "../src/engine/common/common-contact-harvester.vala"
		case 2:
#line 539 "common-contact-harvester.c"
		goto _state_2;
#line 46 "../src/engine/common/common-contact-harvester.vala"
		case 3:
#line 543 "common-contact-harvester.c"
		goto _state_3;
#line 46 "../src/engine/common/common-contact-harvester.vala"
		case 4:
#line 547 "common-contact-harvester.c"
		goto _state_4;
#line 46 "../src/engine/common/common-contact-harvester.vala"
		case 5:
#line 551 "common-contact-harvester.c"
		goto _state_5;
#line 46 "../src/engine/common/common-contact-harvester.vala"
		case 6:
#line 555 "common-contact-harvester.c"
		goto _state_6;
#line 46 "../src/engine/common/common-contact-harvester.vala"
		case 7:
#line 559 "common-contact-harvester.c"
		goto _state_7;
		default:
#line 46 "../src/engine/common/common-contact-harvester.vala"
		g_assert_not_reached ();
#line 564 "common-contact-harvester.c"
	}
	_state_0:
#line 49 "../src/engine/common/common-contact-harvester.vala"
	if (_data_->self->priv->is_whitelisted) {
#line 49 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp1_ = gee_collection_get_is_empty (_data_->messages);
#line 49 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp2_ = _data_->_tmp1_;
#line 49 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp0_ = !_data_->_tmp2_;
#line 575 "common-contact-harvester.c"
	} else {
#line 49 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp0_ = FALSE;
#line 579 "common-contact-harvester.c"
	}
#line 49 "../src/engine/common/common-contact-harvester.vala"
	if (_data_->_tmp0_) {
#line 50 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp3_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEARY_TYPE_CONTACT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 50 "../src/engine/common/common-contact-harvester.vala"
		_data_->contacts = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, GEE_TYPE_MAP, GeeMap);
#line 51 "../src/engine/common/common-contact-harvester.vala"
		_data_->importance = (gint) GEARY_CONTACT_IMPORTANCE_SEEN;
#line 52 "../src/engine/common/common-contact-harvester.vala"
		if (_data_->self->priv->location == GEARY_FOLDER_SPECIAL_USE_SENT) {
#line 53 "../src/engine/common/common-contact-harvester.vala"
			_data_->importance = (gint) GEARY_CONTACT_IMPORTANCE_SENT_TO;
#line 593 "common-contact-harvester.c"
		}
#line 55 "../src/engine/common/common-contact-harvester.vala"
		_data_->type = 0;
#line 597 "common-contact-harvester.c"
		{
#line 56 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_data_->messages, GEE_TYPE_ITERABLE, GeeIterable));
#line 56 "../src/engine/common/common-contact-harvester.vala"
			_data_->_message_it = _data_->_tmp4_;
#line 56 "../src/engine/common/common-contact-harvester.vala"
			while (TRUE) {
#line 56 "../src/engine/common/common-contact-harvester.vala"
				_data_->_tmp5_ = _data_->_message_it;
#line 56 "../src/engine/common/common-contact-harvester.vala"
				if (!gee_iterator_next (_data_->_tmp5_)) {
#line 56 "../src/engine/common/common-contact-harvester.vala"
					break;
#line 611 "common-contact-harvester.c"
				}
#line 56 "../src/engine/common/common-contact-harvester.vala"
				_data_->_tmp6_ = _data_->_message_it;
#line 56 "../src/engine/common/common-contact-harvester.vala"
				_data_->_tmp7_ = gee_iterator_get (_data_->_tmp6_);
#line 56 "../src/engine/common/common-contact-harvester.vala"
				_data_->message = (GearyEmail*) _data_->_tmp7_;
#line 57 "../src/engine/common/common-contact-harvester.vala"
				_data_->_tmp8_ = _data_->message;
#line 57 "../src/engine/common/common-contact-harvester.vala"
				_data_->_tmp9_ = geary_email_get_fields (_data_->_tmp8_);
#line 57 "../src/engine/common/common-contact-harvester.vala"
				_data_->_tmp10_ = _data_->_tmp9_;
#line 57 "../src/engine/common/common-contact-harvester.vala"
				if (geary_email_field_fulfills (_data_->_tmp10_, GEARY_CONTACT_HARVESTER_IMPL_REQUIRED_FIELDS)) {
#line 58 "../src/engine/common/common-contact-harvester.vala"
					_data_->type = GEARY_EMAIL_FIELD_ORIGINATORS;
#line 59 "../src/engine/common/common-contact-harvester.vala"
					_data_->_tmp11_ = _data_->contacts;
#line 59 "../src/engine/common/common-contact-harvester.vala"
					_data_->_tmp12_ = _data_->message;
#line 59 "../src/engine/common/common-contact-harvester.vala"
					_data_->_tmp13_ = geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp12_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 59 "../src/engine/common/common-contact-harvester.vala"
					_data_->_tmp14_ = _data_->_tmp13_;
#line 59 "../src/engine/common/common-contact-harvester.vala"
					_data_->_state_ = 1;
#line 59 "../src/engine/common/common-contact-harvester.vala"
					geary_contact_harvester_impl_add_contacts (_data_->self, _data_->_tmp11_, _data_->_tmp14_, _data_->type, _data_->importance, _data_->cancellable, geary_contact_harvester_impl_harvest_from_email_ready, _data_);
#line 59 "../src/engine/common/common-contact-harvester.vala"
					return FALSE;
#line 643 "common-contact-harvester.c"
					_state_1:
#line 59 "../src/engine/common/common-contact-harvester.vala"
					geary_contact_harvester_impl_add_contacts_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 59 "../src/engine/common/common-contact-harvester.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 59 "../src/engine/common/common-contact-harvester.vala"
						g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 59 "../src/engine/common/common-contact-harvester.vala"
						_g_object_unref0 (_data_->message);
#line 59 "../src/engine/common/common-contact-harvester.vala"
						_g_object_unref0 (_data_->_message_it);
#line 59 "../src/engine/common/common-contact-harvester.vala"
						_g_object_unref0 (_data_->contacts);
#line 59 "../src/engine/common/common-contact-harvester.vala"
						g_object_unref (_data_->_async_result);
#line 59 "../src/engine/common/common-contact-harvester.vala"
						return FALSE;
#line 661 "common-contact-harvester.c"
					}
#line 62 "../src/engine/common/common-contact-harvester.vala"
					_data_->_tmp15_ = _data_->message;
#line 62 "../src/engine/common/common-contact-harvester.vala"
					_data_->_tmp16_ = geary_email_header_set_get_sender (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp15_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 62 "../src/engine/common/common-contact-harvester.vala"
					_data_->_tmp17_ = _data_->_tmp16_;
#line 62 "../src/engine/common/common-contact-harvester.vala"
					if (_data_->_tmp17_ != NULL) {
#line 63 "../src/engine/common/common-contact-harvester.vala"
						_data_->_tmp18_ = _data_->contacts;
#line 63 "../src/engine/common/common-contact-harvester.vala"
						_data_->_tmp19_ = _data_->message;
#line 63 "../src/engine/common/common-contact-harvester.vala"
						_data_->_tmp20_ = geary_email_header_set_get_sender (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp19_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 63 "../src/engine/common/common-contact-harvester.vala"
						_data_->_tmp21_ = _data_->_tmp20_;
#line 63 "../src/engine/common/common-contact-harvester.vala"
						_data_->_state_ = 2;
#line 63 "../src/engine/common/common-contact-harvester.vala"
						geary_contact_harvester_impl_add_contact (_data_->self, _data_->_tmp18_, _data_->_tmp21_, _data_->type, _data_->importance, _data_->cancellable, geary_contact_harvester_impl_harvest_from_email_ready, _data_);
#line 63 "../src/engine/common/common-contact-harvester.vala"
						return FALSE;
#line 685 "common-contact-harvester.c"
						_state_2:
#line 63 "../src/engine/common/common-contact-harvester.vala"
						geary_contact_harvester_impl_add_contact_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 63 "../src/engine/common/common-contact-harvester.vala"
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 63 "../src/engine/common/common-contact-harvester.vala"
							g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 63 "../src/engine/common/common-contact-harvester.vala"
							_g_object_unref0 (_data_->message);
#line 63 "../src/engine/common/common-contact-harvester.vala"
							_g_object_unref0 (_data_->_message_it);
#line 63 "../src/engine/common/common-contact-harvester.vala"
							_g_object_unref0 (_data_->contacts);
#line 63 "../src/engine/common/common-contact-harvester.vala"
							g_object_unref (_data_->_async_result);
#line 63 "../src/engine/common/common-contact-harvester.vala"
							return FALSE;
#line 703 "common-contact-harvester.c"
						}
					}
#line 67 "../src/engine/common/common-contact-harvester.vala"
					_data_->_tmp22_ = _data_->contacts;
#line 67 "../src/engine/common/common-contact-harvester.vala"
					_data_->_tmp23_ = _data_->message;
#line 67 "../src/engine/common/common-contact-harvester.vala"
					_data_->_tmp24_ = geary_email_header_set_get_bcc (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp23_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 67 "../src/engine/common/common-contact-harvester.vala"
					_data_->_tmp25_ = _data_->_tmp24_;
#line 67 "../src/engine/common/common-contact-harvester.vala"
					_data_->_state_ = 3;
#line 67 "../src/engine/common/common-contact-harvester.vala"
					geary_contact_harvester_impl_add_contacts (_data_->self, _data_->_tmp22_, _data_->_tmp25_, _data_->type, _data_->importance, _data_->cancellable, geary_contact_harvester_impl_harvest_from_email_ready, _data_);
#line 67 "../src/engine/common/common-contact-harvester.vala"
					return FALSE;
#line 720 "common-contact-harvester.c"
					_state_3:
#line 67 "../src/engine/common/common-contact-harvester.vala"
					geary_contact_harvester_impl_add_contacts_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 67 "../src/engine/common/common-contact-harvester.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 67 "../src/engine/common/common-contact-harvester.vala"
						g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 67 "../src/engine/common/common-contact-harvester.vala"
						_g_object_unref0 (_data_->message);
#line 67 "../src/engine/common/common-contact-harvester.vala"
						_g_object_unref0 (_data_->_message_it);
#line 67 "../src/engine/common/common-contact-harvester.vala"
						_g_object_unref0 (_data_->contacts);
#line 67 "../src/engine/common/common-contact-harvester.vala"
						g_object_unref (_data_->_async_result);
#line 67 "../src/engine/common/common-contact-harvester.vala"
						return FALSE;
#line 738 "common-contact-harvester.c"
					}
#line 71 "../src/engine/common/common-contact-harvester.vala"
					_data_->type = GEARY_EMAIL_FIELD_RECEIVERS;
#line 72 "../src/engine/common/common-contact-harvester.vala"
					_data_->_tmp26_ = _data_->contacts;
#line 72 "../src/engine/common/common-contact-harvester.vala"
					_data_->_tmp27_ = _data_->message;
#line 72 "../src/engine/common/common-contact-harvester.vala"
					_data_->_tmp28_ = geary_email_header_set_get_to (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp27_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 72 "../src/engine/common/common-contact-harvester.vala"
					_data_->_tmp29_ = _data_->_tmp28_;
#line 72 "../src/engine/common/common-contact-harvester.vala"
					_data_->_state_ = 4;
#line 72 "../src/engine/common/common-contact-harvester.vala"
					geary_contact_harvester_impl_add_contacts (_data_->self, _data_->_tmp26_, _data_->_tmp29_, _data_->type, _data_->importance, _data_->cancellable, geary_contact_harvester_impl_harvest_from_email_ready, _data_);
#line 72 "../src/engine/common/common-contact-harvester.vala"
					return FALSE;
#line 756 "common-contact-harvester.c"
					_state_4:
#line 72 "../src/engine/common/common-contact-harvester.vala"
					geary_contact_harvester_impl_add_contacts_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 72 "../src/engine/common/common-contact-harvester.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 72 "../src/engine/common/common-contact-harvester.vala"
						g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 72 "../src/engine/common/common-contact-harvester.vala"
						_g_object_unref0 (_data_->message);
#line 72 "../src/engine/common/common-contact-harvester.vala"
						_g_object_unref0 (_data_->_message_it);
#line 72 "../src/engine/common/common-contact-harvester.vala"
						_g_object_unref0 (_data_->contacts);
#line 72 "../src/engine/common/common-contact-harvester.vala"
						g_object_unref (_data_->_async_result);
#line 72 "../src/engine/common/common-contact-harvester.vala"
						return FALSE;
#line 774 "common-contact-harvester.c"
					}
#line 75 "../src/engine/common/common-contact-harvester.vala"
					_data_->_tmp30_ = _data_->contacts;
#line 75 "../src/engine/common/common-contact-harvester.vala"
					_data_->_tmp31_ = _data_->message;
#line 75 "../src/engine/common/common-contact-harvester.vala"
					_data_->_tmp32_ = geary_email_header_set_get_cc (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp31_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 75 "../src/engine/common/common-contact-harvester.vala"
					_data_->_tmp33_ = _data_->_tmp32_;
#line 75 "../src/engine/common/common-contact-harvester.vala"
					_data_->_state_ = 5;
#line 75 "../src/engine/common/common-contact-harvester.vala"
					geary_contact_harvester_impl_add_contacts (_data_->self, _data_->_tmp30_, _data_->_tmp33_, _data_->type, _data_->importance, _data_->cancellable, geary_contact_harvester_impl_harvest_from_email_ready, _data_);
#line 75 "../src/engine/common/common-contact-harvester.vala"
					return FALSE;
#line 790 "common-contact-harvester.c"
					_state_5:
#line 75 "../src/engine/common/common-contact-harvester.vala"
					geary_contact_harvester_impl_add_contacts_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 75 "../src/engine/common/common-contact-harvester.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 75 "../src/engine/common/common-contact-harvester.vala"
						g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 75 "../src/engine/common/common-contact-harvester.vala"
						_g_object_unref0 (_data_->message);
#line 75 "../src/engine/common/common-contact-harvester.vala"
						_g_object_unref0 (_data_->_message_it);
#line 75 "../src/engine/common/common-contact-harvester.vala"
						_g_object_unref0 (_data_->contacts);
#line 75 "../src/engine/common/common-contact-harvester.vala"
						g_object_unref (_data_->_async_result);
#line 75 "../src/engine/common/common-contact-harvester.vala"
						return FALSE;
#line 808 "common-contact-harvester.c"
					}
#line 78 "../src/engine/common/common-contact-harvester.vala"
					_data_->_tmp34_ = _data_->contacts;
#line 78 "../src/engine/common/common-contact-harvester.vala"
					_data_->_tmp35_ = _data_->message;
#line 78 "../src/engine/common/common-contact-harvester.vala"
					_data_->_tmp36_ = geary_email_header_set_get_bcc (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp35_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 78 "../src/engine/common/common-contact-harvester.vala"
					_data_->_tmp37_ = _data_->_tmp36_;
#line 78 "../src/engine/common/common-contact-harvester.vala"
					_data_->_state_ = 6;
#line 78 "../src/engine/common/common-contact-harvester.vala"
					geary_contact_harvester_impl_add_contacts (_data_->self, _data_->_tmp34_, _data_->_tmp37_, _data_->type, _data_->importance, _data_->cancellable, geary_contact_harvester_impl_harvest_from_email_ready, _data_);
#line 78 "../src/engine/common/common-contact-harvester.vala"
					return FALSE;
#line 824 "common-contact-harvester.c"
					_state_6:
#line 78 "../src/engine/common/common-contact-harvester.vala"
					geary_contact_harvester_impl_add_contacts_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 78 "../src/engine/common/common-contact-harvester.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 78 "../src/engine/common/common-contact-harvester.vala"
						g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 78 "../src/engine/common/common-contact-harvester.vala"
						_g_object_unref0 (_data_->message);
#line 78 "../src/engine/common/common-contact-harvester.vala"
						_g_object_unref0 (_data_->_message_it);
#line 78 "../src/engine/common/common-contact-harvester.vala"
						_g_object_unref0 (_data_->contacts);
#line 78 "../src/engine/common/common-contact-harvester.vala"
						g_object_unref (_data_->_async_result);
#line 78 "../src/engine/common/common-contact-harvester.vala"
						return FALSE;
#line 842 "common-contact-harvester.c"
					}
				}
#line 56 "../src/engine/common/common-contact-harvester.vala"
				_g_object_unref0 (_data_->message);
#line 847 "common-contact-harvester.c"
			}
#line 56 "../src/engine/common/common-contact-harvester.vala"
			_g_object_unref0 (_data_->_message_it);
#line 851 "common-contact-harvester.c"
		}
#line 84 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp38_ = _data_->self->priv->store;
#line 84 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp39_ = _data_->contacts;
#line 84 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp40_ = gee_map_get_values (_data_->_tmp39_);
#line 84 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp41_ = _data_->_tmp40_;
#line 84 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp42_ = _data_->_tmp41_;
#line 84 "../src/engine/common/common-contact-harvester.vala"
		_data_->_state_ = 7;
#line 84 "../src/engine/common/common-contact-harvester.vala"
		geary_contact_store_update_contacts (_data_->_tmp38_, _data_->_tmp42_, _data_->cancellable, geary_contact_harvester_impl_harvest_from_email_ready, _data_);
#line 84 "../src/engine/common/common-contact-harvester.vala"
		return FALSE;
#line 869 "common-contact-harvester.c"
		_state_7:
#line 84 "../src/engine/common/common-contact-harvester.vala"
		geary_contact_store_update_contacts_finish (_data_->_tmp38_, _data_->_res_, &_data_->_inner_error0_);
#line 84 "../src/engine/common/common-contact-harvester.vala"
		_g_object_unref0 (_data_->_tmp42_);
#line 84 "../src/engine/common/common-contact-harvester.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 84 "../src/engine/common/common-contact-harvester.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 84 "../src/engine/common/common-contact-harvester.vala"
			_g_object_unref0 (_data_->contacts);
#line 84 "../src/engine/common/common-contact-harvester.vala"
			g_object_unref (_data_->_async_result);
#line 84 "../src/engine/common/common-contact-harvester.vala"
			return FALSE;
#line 885 "common-contact-harvester.c"
		}
#line 49 "../src/engine/common/common-contact-harvester.vala"
		_g_object_unref0 (_data_->contacts);
#line 889 "common-contact-harvester.c"
	}
#line 46 "../src/engine/common/common-contact-harvester.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 46 "../src/engine/common/common-contact-harvester.vala"
	if (_data_->_state_ != 0) {
#line 46 "../src/engine/common/common-contact-harvester.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 46 "../src/engine/common/common-contact-harvester.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 899 "common-contact-harvester.c"
		}
	}
#line 46 "../src/engine/common/common-contact-harvester.vala"
	g_object_unref (_data_->_async_result);
#line 46 "../src/engine/common/common-contact-harvester.vala"
	return FALSE;
#line 906 "common-contact-harvester.c"
}

static void
geary_contact_harvester_impl_add_contacts_data_free (gpointer _data)
{
	GearyContactHarvesterImplAddContactsData* _data_;
	_data_ = _data;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_g_object_unref0 (_data_->contacts);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_g_object_unref0 (_data_->addresses);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_g_object_unref0 (_data_->cancellable);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_g_object_unref0 (_data_->self);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	g_slice_free (GearyContactHarvesterImplAddContactsData, _data_);
#line 924 "common-contact-harvester.c"
}

static void
geary_contact_harvester_impl_add_contacts (GearyContactHarvesterImpl* self,
                                           GeeMap* contacts,
                                           GearyRFC822MailboxAddresses* addresses,
                                           GearyEmailField type,
                                           gint importance,
                                           GCancellable* cancellable,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	GearyContactHarvesterImplAddContactsData* _data_;
	GearyContactHarvesterImpl* _tmp0_;
	GeeMap* _tmp1_;
	GearyRFC822MailboxAddresses* _tmp2_;
	GCancellable* _tmp3_;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	g_return_if_fail (GEARY_IS_CONTACT_HARVESTER_IMPL (self));
#line 19 "../src/engine/common/common-contact-harvester.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (contacts, GEE_TYPE_MAP));
#line 19 "../src/engine/common/common-contact-harvester.vala"
	g_return_if_fail ((addresses == NULL) || GEARY_RF_C822_IS_MAILBOX_ADDRESSES (addresses));
#line 19 "../src/engine/common/common-contact-harvester.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_data_ = g_slice_new0 (GearyContactHarvesterImplAddContactsData);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_contact_harvester_impl_add_contacts_data_free);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_data_->self = _tmp0_;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_tmp1_ = _g_object_ref0 (contacts);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_g_object_unref0 (_data_->contacts);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_data_->contacts = _tmp1_;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_tmp2_ = _g_object_ref0 (addresses);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_g_object_unref0 (_data_->addresses);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_data_->addresses = _tmp2_;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_data_->type = type;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_data_->importance = importance;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_g_object_unref0 (_data_->cancellable);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_data_->cancellable = _tmp3_;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	geary_contact_harvester_impl_add_contacts_co (_data_);
#line 984 "common-contact-harvester.c"
}

static void
geary_contact_harvester_impl_add_contacts_finish (GearyContactHarvesterImpl* self,
                                                  GAsyncResult* _res_,
                                                  GError** error)
{
	GearyContactHarvesterImplAddContactsData* _data_;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	if (NULL == _data_) {
#line 19 "../src/engine/common/common-contact-harvester.vala"
		return;
#line 999 "common-contact-harvester.c"
	}
}

static void
geary_contact_harvester_impl_add_contacts_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	GearyContactHarvesterImplAddContactsData* _data_;
#line 96 "../src/engine/common/common-contact-harvester.vala"
	_data_ = _user_data_;
#line 96 "../src/engine/common/common-contact-harvester.vala"
	_data_->_source_object_ = source_object;
#line 96 "../src/engine/common/common-contact-harvester.vala"
	_data_->_res_ = _res_;
#line 96 "../src/engine/common/common-contact-harvester.vala"
	geary_contact_harvester_impl_add_contacts_co (_data_);
#line 1017 "common-contact-harvester.c"
}

static gboolean
geary_contact_harvester_impl_add_contacts_co (GearyContactHarvesterImplAddContactsData* _data_)
{
#line 88 "../src/engine/common/common-contact-harvester.vala"
	switch (_data_->_state_) {
#line 88 "../src/engine/common/common-contact-harvester.vala"
		case 0:
#line 1027 "common-contact-harvester.c"
		goto _state_0;
#line 88 "../src/engine/common/common-contact-harvester.vala"
		case 1:
#line 1031 "common-contact-harvester.c"
		goto _state_1;
		default:
#line 88 "../src/engine/common/common-contact-harvester.vala"
		g_assert_not_reached ();
#line 1036 "common-contact-harvester.c"
	}
	_state_0:
#line 94 "../src/engine/common/common-contact-harvester.vala"
	if (_data_->addresses != NULL) {
#line 1041 "common-contact-harvester.c"
		{
#line 95 "../src/engine/common/common-contact-harvester.vala"
			_data_->_address_list = _data_->addresses;
#line 95 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp0_ = _data_->_address_list;
#line 95 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp1_ = geary_rf_c822_mailbox_addresses_get_size (_data_->_tmp0_);
#line 95 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp2_ = _data_->_tmp1_;
#line 95 "../src/engine/common/common-contact-harvester.vala"
			_data_->_address_size = _data_->_tmp2_;
#line 95 "../src/engine/common/common-contact-harvester.vala"
			_data_->_address_index = -1;
#line 95 "../src/engine/common/common-contact-harvester.vala"
			while (TRUE) {
#line 95 "../src/engine/common/common-contact-harvester.vala"
				_data_->_address_index = _data_->_address_index + 1;
#line 95 "../src/engine/common/common-contact-harvester.vala"
				_data_->_tmp3_ = _data_->_address_index;
#line 95 "../src/engine/common/common-contact-harvester.vala"
				_data_->_tmp4_ = _data_->_address_size;
#line 95 "../src/engine/common/common-contact-harvester.vala"
				if (!(_data_->_tmp3_ < _data_->_tmp4_)) {
#line 95 "../src/engine/common/common-contact-harvester.vala"
					break;
#line 1067 "common-contact-harvester.c"
				}
#line 95 "../src/engine/common/common-contact-harvester.vala"
				_data_->_tmp5_ = _data_->_address_list;
#line 95 "../src/engine/common/common-contact-harvester.vala"
				_data_->_tmp6_ = geary_rf_c822_mailbox_addresses_get (_data_->_tmp5_, _data_->_address_index);
#line 95 "../src/engine/common/common-contact-harvester.vala"
				_data_->address = _data_->_tmp6_;
#line 96 "../src/engine/common/common-contact-harvester.vala"
				_data_->_tmp7_ = _data_->address;
#line 96 "../src/engine/common/common-contact-harvester.vala"
				_data_->_state_ = 1;
#line 96 "../src/engine/common/common-contact-harvester.vala"
				geary_contact_harvester_impl_add_contact (_data_->self, _data_->contacts, _data_->_tmp7_, _data_->type, _data_->importance, _data_->cancellable, geary_contact_harvester_impl_add_contacts_ready, _data_);
#line 96 "../src/engine/common/common-contact-harvester.vala"
				return FALSE;
#line 1083 "common-contact-harvester.c"
				_state_1:
#line 96 "../src/engine/common/common-contact-harvester.vala"
				geary_contact_harvester_impl_add_contact_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 96 "../src/engine/common/common-contact-harvester.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 96 "../src/engine/common/common-contact-harvester.vala"
					g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 96 "../src/engine/common/common-contact-harvester.vala"
					_g_object_unref0 (_data_->address);
#line 96 "../src/engine/common/common-contact-harvester.vala"
					g_object_unref (_data_->_async_result);
#line 96 "../src/engine/common/common-contact-harvester.vala"
					return FALSE;
#line 1097 "common-contact-harvester.c"
				}
#line 95 "../src/engine/common/common-contact-harvester.vala"
				_g_object_unref0 (_data_->address);
#line 1101 "common-contact-harvester.c"
			}
		}
	}
#line 88 "../src/engine/common/common-contact-harvester.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 88 "../src/engine/common/common-contact-harvester.vala"
	if (_data_->_state_ != 0) {
#line 88 "../src/engine/common/common-contact-harvester.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 88 "../src/engine/common/common-contact-harvester.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1113 "common-contact-harvester.c"
		}
	}
#line 88 "../src/engine/common/common-contact-harvester.vala"
	g_object_unref (_data_->_async_result);
#line 88 "../src/engine/common/common-contact-harvester.vala"
	return FALSE;
#line 1120 "common-contact-harvester.c"
}

static void
geary_contact_harvester_impl_add_contact_data_free (gpointer _data)
{
	GearyContactHarvesterImplAddContactData* _data_;
	_data_ = _data;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_g_object_unref0 (_data_->contacts);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_g_object_unref0 (_data_->address);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_g_object_unref0 (_data_->cancellable);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_g_object_unref0 (_data_->self);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	g_slice_free (GearyContactHarvesterImplAddContactData, _data_);
#line 1138 "common-contact-harvester.c"
}

static void
geary_contact_harvester_impl_add_contact (GearyContactHarvesterImpl* self,
                                          GeeMap* contacts,
                                          GearyRFC822MailboxAddress* address,
                                          GearyEmailField type,
                                          gint importance,
                                          GCancellable* cancellable,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	GearyContactHarvesterImplAddContactData* _data_;
	GearyContactHarvesterImpl* _tmp0_;
	GeeMap* _tmp1_;
	GearyRFC822MailboxAddress* _tmp2_;
	GCancellable* _tmp3_;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	g_return_if_fail (GEARY_IS_CONTACT_HARVESTER_IMPL (self));
#line 19 "../src/engine/common/common-contact-harvester.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (contacts, GEE_TYPE_MAP));
#line 19 "../src/engine/common/common-contact-harvester.vala"
	g_return_if_fail (GEARY_RF_C822_IS_MAILBOX_ADDRESS (address));
#line 19 "../src/engine/common/common-contact-harvester.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_data_ = g_slice_new0 (GearyContactHarvesterImplAddContactData);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_contact_harvester_impl_add_contact_data_free);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_data_->self = _tmp0_;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_tmp1_ = _g_object_ref0 (contacts);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_g_object_unref0 (_data_->contacts);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_data_->contacts = _tmp1_;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_tmp2_ = _g_object_ref0 (address);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_g_object_unref0 (_data_->address);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_data_->address = _tmp2_;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_data_->type = type;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_data_->importance = importance;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_g_object_unref0 (_data_->cancellable);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_data_->cancellable = _tmp3_;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	geary_contact_harvester_impl_add_contact_co (_data_);
#line 1198 "common-contact-harvester.c"
}

static void
geary_contact_harvester_impl_add_contact_finish (GearyContactHarvesterImpl* self,
                                                 GAsyncResult* _res_,
                                                 GError** error)
{
	GearyContactHarvesterImplAddContactData* _data_;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	if (NULL == _data_) {
#line 19 "../src/engine/common/common-contact-harvester.vala"
		return;
#line 1213 "common-contact-harvester.c"
	}
}

static void
geary_contact_harvester_impl_add_contact_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_)
{
	GearyContactHarvesterImplAddContactData* _data_;
#line 118 "../src/engine/common/common-contact-harvester.vala"
	_data_ = _user_data_;
#line 118 "../src/engine/common/common-contact-harvester.vala"
	_data_->_source_object_ = source_object;
#line 118 "../src/engine/common/common-contact-harvester.vala"
	_data_->_res_ = _res_;
#line 118 "../src/engine/common/common-contact-harvester.vala"
	geary_contact_harvester_impl_add_contact_co (_data_);
#line 1231 "common-contact-harvester.c"
}

static gboolean
geary_contact_harvester_impl_add_contact_co (GearyContactHarvesterImplAddContactData* _data_)
{
#line 103 "../src/engine/common/common-contact-harvester.vala"
	switch (_data_->_state_) {
#line 103 "../src/engine/common/common-contact-harvester.vala"
		case 0:
#line 1241 "common-contact-harvester.c"
		goto _state_0;
#line 103 "../src/engine/common/common-contact-harvester.vala"
		case 1:
#line 1245 "common-contact-harvester.c"
		goto _state_1;
		default:
#line 103 "../src/engine/common/common-contact-harvester.vala"
		g_assert_not_reached ();
#line 1250 "common-contact-harvester.c"
	}
	_state_0:
#line 109 "../src/engine/common/common-contact-harvester.vala"
	if (geary_rf_c822_mailbox_address_is_valid (_data_->address)) {
#line 109 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp0_ = !geary_rf_c822_mailbox_address_is_spoofed (_data_->address);
#line 1257 "common-contact-harvester.c"
	} else {
#line 109 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp0_ = FALSE;
#line 1261 "common-contact-harvester.c"
	}
#line 109 "../src/engine/common/common-contact-harvester.vala"
	if (_data_->_tmp0_) {
#line 110 "../src/engine/common/common-contact-harvester.vala"
		if (_data_->type == GEARY_EMAIL_FIELD_RECEIVERS) {
#line 110 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp2_ = _data_->self->priv->owner_mailboxes;
#line 110 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp1_ = gee_collection_contains (_data_->_tmp2_, _data_->address);
#line 1271 "common-contact-harvester.c"
		} else {
#line 110 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp1_ = FALSE;
#line 1275 "common-contact-harvester.c"
		}
#line 110 "../src/engine/common/common-contact-harvester.vala"
		if (_data_->_tmp1_) {
#line 111 "../src/engine/common/common-contact-harvester.vala"
			_data_->importance = (gint) GEARY_CONTACT_IMPORTANCE_RECEIVED_FROM;
#line 1281 "common-contact-harvester.c"
		}
#line 114 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp3_ = geary_rf_c822_mailbox_address_get_address (_data_->address);
#line 114 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 114 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp5_ = geary_contact_normalise_email (_data_->_tmp4_);
#line 114 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 114 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp7_ = gee_map_get (_data_->contacts, _data_->_tmp6_);
#line 114 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp8_ = (GearyContact*) _data_->_tmp7_;
#line 114 "../src/engine/common/common-contact-harvester.vala"
		_g_free0 (_data_->_tmp6_);
#line 114 "../src/engine/common/common-contact-harvester.vala"
		_data_->contact = _data_->_tmp8_;
#line 117 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp9_ = _data_->contact;
#line 117 "../src/engine/common/common-contact-harvester.vala"
		if (_data_->_tmp9_ == NULL) {
#line 118 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp11_ = _data_->self->priv->store;
#line 118 "../src/engine/common/common-contact-harvester.vala"
			_data_->_state_ = 1;
#line 118 "../src/engine/common/common-contact-harvester.vala"
			geary_contact_store_get_by_rfc822 (_data_->_tmp11_, _data_->address, _data_->cancellable, geary_contact_harvester_impl_add_contact_ready, _data_);
#line 118 "../src/engine/common/common-contact-harvester.vala"
			return FALSE;
#line 1311 "common-contact-harvester.c"
			_state_1:
#line 118 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp12_ = geary_contact_store_get_by_rfc822_finish (_data_->_tmp11_, _data_->_res_, &_data_->_inner_error0_);
#line 118 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp10_ = _data_->_tmp12_;
#line 118 "../src/engine/common/common-contact-harvester.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 118 "../src/engine/common/common-contact-harvester.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 118 "../src/engine/common/common-contact-harvester.vala"
				_g_object_unref0 (_data_->contact);
#line 118 "../src/engine/common/common-contact-harvester.vala"
				g_object_unref (_data_->_async_result);
#line 118 "../src/engine/common/common-contact-harvester.vala"
				return FALSE;
#line 1327 "common-contact-harvester.c"
			}
#line 118 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp13_ = _data_->_tmp10_;
#line 118 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp10_ = NULL;
#line 118 "../src/engine/common/common-contact-harvester.vala"
			_g_object_unref0 (_data_->contact);
#line 118 "../src/engine/common/common-contact-harvester.vala"
			_data_->contact = _data_->_tmp13_;
#line 119 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp14_ = _data_->contact;
#line 119 "../src/engine/common/common-contact-harvester.vala"
			if (_data_->_tmp14_ == NULL) {
#line 120 "../src/engine/common/common-contact-harvester.vala"
				_data_->_tmp15_ = geary_contact_new_from_rfc822_address (_data_->address, _data_->importance);
#line 120 "../src/engine/common/common-contact-harvester.vala"
				_g_object_unref0 (_data_->contact);
#line 120 "../src/engine/common/common-contact-harvester.vala"
				_data_->contact = _data_->_tmp15_;
#line 1347 "common-contact-harvester.c"
			}
#line 124 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp16_ = _data_->contact;
#line 124 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp17_ = geary_contact_get_normalized_email (_data_->_tmp16_);
#line 124 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp18_ = _data_->_tmp17_;
#line 124 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp19_ = _data_->contact;
#line 124 "../src/engine/common/common-contact-harvester.vala"
			gee_map_set (_data_->contacts, _data_->_tmp18_, _data_->_tmp19_);
#line 117 "../src/engine/common/common-contact-harvester.vala"
			_g_object_unref0 (_data_->_tmp10_);
#line 1361 "common-contact-harvester.c"
		}
#line 130 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp21_ = _data_->contact;
#line 130 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp22_ = geary_contact_get_highest_importance (_data_->_tmp21_);
#line 130 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp23_ = _data_->_tmp22_;
#line 130 "../src/engine/common/common-contact-harvester.vala"
		if (_data_->_tmp23_ <= _data_->importance) {
#line 131 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp24_ = geary_rf_c822_mailbox_address_get_name (_data_->address);
#line 131 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp25_ = _data_->_tmp24_;
#line 131 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp20_ = !geary_string_is_empty_or_whitespace (_data_->_tmp25_);
#line 1377 "common-contact-harvester.c"
		} else {
#line 130 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp20_ = FALSE;
#line 1381 "common-contact-harvester.c"
		}
#line 130 "../src/engine/common/common-contact-harvester.vala"
		if (_data_->_tmp20_) {
#line 132 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp26_ = _data_->contact;
#line 132 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp27_ = geary_rf_c822_mailbox_address_get_name (_data_->address);
#line 132 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp28_ = _data_->_tmp27_;
#line 132 "../src/engine/common/common-contact-harvester.vala"
			geary_contact_set_real_name (_data_->_tmp26_, _data_->_tmp28_);
#line 1393 "common-contact-harvester.c"
		}
#line 135 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp29_ = _data_->contact;
#line 135 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp30_ = geary_contact_get_highest_importance (_data_->_tmp29_);
#line 135 "../src/engine/common/common-contact-harvester.vala"
		_data_->_tmp31_ = _data_->_tmp30_;
#line 135 "../src/engine/common/common-contact-harvester.vala"
		if (_data_->_tmp31_ < _data_->importance) {
#line 136 "../src/engine/common/common-contact-harvester.vala"
			_data_->_tmp32_ = _data_->contact;
#line 136 "../src/engine/common/common-contact-harvester.vala"
			geary_contact_set_highest_importance (_data_->_tmp32_, _data_->importance);
#line 1407 "common-contact-harvester.c"
		}
#line 109 "../src/engine/common/common-contact-harvester.vala"
		_g_object_unref0 (_data_->contact);
#line 1411 "common-contact-harvester.c"
	}
#line 103 "../src/engine/common/common-contact-harvester.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 103 "../src/engine/common/common-contact-harvester.vala"
	if (_data_->_state_ != 0) {
#line 103 "../src/engine/common/common-contact-harvester.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 103 "../src/engine/common/common-contact-harvester.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1421 "common-contact-harvester.c"
		}
	}
#line 103 "../src/engine/common/common-contact-harvester.vala"
	g_object_unref (_data_->_async_result);
#line 103 "../src/engine/common/common-contact-harvester.vala"
	return FALSE;
#line 1428 "common-contact-harvester.c"
}

static void
geary_contact_harvester_impl_class_init (GearyContactHarvesterImplClass * klass,
                                         gpointer klass_data)
{
#line 19 "../src/engine/common/common-contact-harvester.vala"
	geary_contact_harvester_impl_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	g_type_class_adjust_private_offset (klass, &GearyContactHarvesterImpl_private_offset);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_contact_harvester_impl_finalize;
#line 1441 "common-contact-harvester.c"
}

static void
geary_contact_harvester_impl_geary_contact_harvester_interface_init (GearyContactHarvesterIface * iface,
                                                                     gpointer iface_data)
{
#line 19 "../src/engine/common/common-contact-harvester.vala"
	geary_contact_harvester_impl_geary_contact_harvester_parent_iface = g_type_interface_peek_parent (iface);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	iface->harvest_from_email = (void (*) (GearyContactHarvester*, GeeCollection*, GCancellable*, GAsyncReadyCallback, gpointer)) geary_contact_harvester_impl_real_harvest_from_email;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	iface->harvest_from_email_finish = (void (*) (GearyContactHarvester*, GAsyncResult*, GError**)) geary_contact_harvester_impl_harvest_from_email_finish;
#line 1454 "common-contact-harvester.c"
}

static void
geary_contact_harvester_impl_instance_init (GearyContactHarvesterImpl * self,
                                            gpointer klass)
{
#line 19 "../src/engine/common/common-contact-harvester.vala"
	self->priv = geary_contact_harvester_impl_get_instance_private (self);
#line 1463 "common-contact-harvester.c"
}

static void
geary_contact_harvester_impl_finalize (GObject * obj)
{
	GearyContactHarvesterImpl * self;
#line 19 "../src/engine/common/common-contact-harvester.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_TYPE_CONTACT_HARVESTER_IMPL, GearyContactHarvesterImpl);
#line 31 "../src/engine/common/common-contact-harvester.vala"
	_g_object_unref0 (self->priv->store);
#line 32 "../src/engine/common/common-contact-harvester.vala"
	_g_object_unref0 (self->priv->owner_mailboxes);
#line 19 "../src/engine/common/common-contact-harvester.vala"
	G_OBJECT_CLASS (geary_contact_harvester_impl_parent_class)->finalize (obj);
#line 1478 "common-contact-harvester.c"
}

/** Default harvester that saves contacts in the contact store. */
 G_GNUC_NO_INLINE static GType
geary_contact_harvester_impl_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyContactHarvesterImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_contact_harvester_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyContactHarvesterImpl), 0, (GInstanceInitFunc) geary_contact_harvester_impl_instance_init, NULL };
	static const GInterfaceInfo geary_contact_harvester_info = { (GInterfaceInitFunc) geary_contact_harvester_impl_geary_contact_harvester_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType geary_contact_harvester_impl_type_id;
	geary_contact_harvester_impl_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyContactHarvesterImpl", &g_define_type_info, 0);
	g_type_add_interface_static (geary_contact_harvester_impl_type_id, GEARY_TYPE_CONTACT_HARVESTER, &geary_contact_harvester_info);
	GearyContactHarvesterImpl_private_offset = g_type_add_instance_private (geary_contact_harvester_impl_type_id, sizeof (GearyContactHarvesterImplPrivate));
	return geary_contact_harvester_impl_type_id;
}

GType
geary_contact_harvester_impl_get_type (void)
{
	static gsize geary_contact_harvester_impl_type_id__once = 0;
	if (g_once_init_enter (&geary_contact_harvester_impl_type_id__once)) {
		GType geary_contact_harvester_impl_type_id;
		geary_contact_harvester_impl_type_id = geary_contact_harvester_impl_get_type_once ();
		g_once_init_leave (&geary_contact_harvester_impl_type_id__once, geary_contact_harvester_impl_type_id);
	}
	return geary_contact_harvester_impl_type_id__once;
}

