/* common-fts-search-query.c generated by valac 0.56.17, the Vala compiler
 * generated from common-fts-search-query.vala, do not modify */

/*
 * Copyright © 2016 Software Freedom Conservancy Inc.
 * Copyright © 2019-2020 Michael Gratton <mike@vee.net>.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib-object.h>
#include <glib.h>
#include "libstemmer.h"
#include <stdlib.h>
#include <string.h>
#include <gee.h>

#define GEARY_FTS_SEARCH_QUERY_EMAIL_TEXT_STEMMED_TERMS "geary-stemmed-terms"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define GEARY_TYPE_FTS_SEARCH_QUERY (geary_fts_search_query_get_type ())
#define GEARY_FTS_SEARCH_QUERY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_FTS_SEARCH_QUERY, GearyFtsSearchQuery))
#define GEARY_FTS_SEARCH_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_FTS_SEARCH_QUERY, GearyFtsSearchQueryClass))
#define GEARY_IS_FTS_SEARCH_QUERY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_FTS_SEARCH_QUERY))
#define GEARY_IS_FTS_SEARCH_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_FTS_SEARCH_QUERY))
#define GEARY_FTS_SEARCH_QUERY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_FTS_SEARCH_QUERY, GearyFtsSearchQueryClass))

typedef struct _GearyFtsSearchQuery GearyFtsSearchQuery;
typedef struct _GearyFtsSearchQueryClass GearyFtsSearchQueryClass;
typedef struct _GearyFtsSearchQueryPrivate GearyFtsSearchQueryPrivate;
enum  {
	GEARY_FTS_SEARCH_QUERY_0_PROPERTY,
	GEARY_FTS_SEARCH_QUERY_HAS_STEMMED_TERMS_PROPERTY,
	GEARY_FTS_SEARCH_QUERY_NUM_PROPERTIES
};
static GParamSpec* geary_fts_search_query_properties[GEARY_FTS_SEARCH_QUERY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _GearyFtsSearchQuery {
	GearySearchQuery parent_instance;
	GearyFtsSearchQueryPrivate * priv;
};

struct _GearyFtsSearchQueryClass {
	GearySearchQueryClass parent_class;
};

struct _GearyFtsSearchQueryPrivate {
	gboolean _has_stemmed_terms;
	gboolean is_all_negated;
	struct sb_stemmer* stemmer;
};

static gint GearyFtsSearchQuery_private_offset;
static gpointer geary_fts_search_query_parent_class = NULL;

VALA_EXTERN GType geary_fts_search_query_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gboolean geary_fts_search_query_get_has_stemmed_terms (GearyFtsSearchQuery* self);
static void geary_fts_search_query_set_has_stemmed_terms (GearyFtsSearchQuery* self,
                                                   gboolean value);
VALA_EXTERN GearyFtsSearchQuery* geary_fts_search_query_new (GeeList* expression,
                                                 const gchar* raw,
                                                 struct sb_stemmer* stemmer);
VALA_EXTERN GearyFtsSearchQuery* geary_fts_search_query_construct (GType object_type,
                                                       GeeList* expression,
                                                       const gchar* raw,
                                                       struct sb_stemmer* stemmer);
VALA_EXTERN gboolean geary_search_query_strategy_is_stemming_enabled (GearySearchQueryStrategy self);
static void geary_fts_search_query_stem_search_terms (GearyFtsSearchQuery* self,
                                               GearySearchQueryEmailTextTerm* text);
VALA_EXTERN GearyDbStatement* geary_fts_search_query_get_search_query (GearyFtsSearchQuery* self,
                                                           GearyDbConnection* cx,
                                                           const gchar* search_ids_sql,
                                                           const gchar* excluded_folder_ids_sql,
                                                           gboolean exclude_folderless,
                                                           gint limit,
                                                           gint offset,
                                                           GError** error);
static gboolean geary_fts_search_query_sql_add_term_conditions (GearyFtsSearchQuery* self,
                                                         GString* sql,
                                                         gboolean have_added_sql_condition);
static gint geary_fts_search_query_sql_bind_term_conditions (GearyFtsSearchQuery* self,
                                                      GearyDbStatement* sql,
                                                      gint index,
                                                      GError** error);
VALA_EXTERN GearyDbStatement* geary_fts_search_query_get_match_query (GearyFtsSearchQuery* self,
                                                          GearyDbConnection* cx,
                                                          const gchar* search_ids_sql,
                                                          GError** error);
VALA_EXTERN gint geary_search_query_strategy_get_min_term_length_for_stemming (GearySearchQueryStrategy self);
VALA_EXTERN gint geary_search_query_strategy_get_max_difference_term_stem_lengths (GearySearchQueryStrategy self);
static inline void geary_fts_search_query_sql_add_term_condition (GearyFtsSearchQuery* self,
                                                    GString* sql,
                                                    GearySearchQueryTerm* term);
static inline void geary_fts_search_query_sql_add_email_text_term_conditions (GearyFtsSearchQuery* self,
                                                                GearySearchQueryEmailTextTerm* text,
                                                                GString* sql);
static inline gint geary_fts_search_query_sql_bind_term_condition (GearyFtsSearchQuery* self,
                                                     GearyDbStatement* sql,
                                                     GearySearchQueryTerm* term,
                                                     gint index,
                                                     GError** error);
static void geary_fts_search_query_finalize (GObject * obj);
static GType geary_fts_search_query_get_type_once (void);
static void _vala_geary_fts_search_query_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_geary_fts_search_query_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
geary_fts_search_query_get_instance_private (GearyFtsSearchQuery* self)
{
	return G_STRUCT_MEMBER_P (self, GearyFtsSearchQuery_private_offset);
}

gboolean
geary_fts_search_query_get_has_stemmed_terms (GearyFtsSearchQuery* self)
{
	gboolean result;
#line 18 "../src/engine/common/common-fts-search-query.vala"
	g_return_val_if_fail (GEARY_IS_FTS_SEARCH_QUERY (self), FALSE);
#line 18 "../src/engine/common/common-fts-search-query.vala"
	result = self->priv->_has_stemmed_terms;
#line 18 "../src/engine/common/common-fts-search-query.vala"
	return result;
#line 142 "common-fts-search-query.c"
}

static void
geary_fts_search_query_set_has_stemmed_terms (GearyFtsSearchQuery* self,
                                              gboolean value)
{
	gboolean old_value;
#line 18 "../src/engine/common/common-fts-search-query.vala"
	g_return_if_fail (GEARY_IS_FTS_SEARCH_QUERY (self));
#line 18 "../src/engine/common/common-fts-search-query.vala"
	old_value = geary_fts_search_query_get_has_stemmed_terms (self);
#line 18 "../src/engine/common/common-fts-search-query.vala"
	if (old_value != value) {
#line 18 "../src/engine/common/common-fts-search-query.vala"
		self->priv->_has_stemmed_terms = value;
#line 18 "../src/engine/common/common-fts-search-query.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_fts_search_query_properties[GEARY_FTS_SEARCH_QUERY_HAS_STEMMED_TERMS_PROPERTY]);
#line 160 "common-fts-search-query.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 39 "../src/engine/common/common-fts-search-query.vala"
	return self ? g_object_ref (self) : NULL;
#line 169 "common-fts-search-query.c"
}

GearyFtsSearchQuery*
geary_fts_search_query_construct (GType object_type,
                                  GeeList* expression,
                                  const gchar* raw,
                                  struct sb_stemmer* stemmer)
{
	GearyFtsSearchQuery * self = NULL;
#line 25 "../src/engine/common/common-fts-search-query.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (expression, GEE_TYPE_LIST), NULL);
#line 25 "../src/engine/common/common-fts-search-query.vala"
	g_return_val_if_fail (raw != NULL, NULL);
#line 25 "../src/engine/common/common-fts-search-query.vala"
	g_return_val_if_fail (stemmer != NULL, NULL);
#line 28 "../src/engine/common/common-fts-search-query.vala"
	self = (GearyFtsSearchQuery*) geary_search_query_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (expression, GEE_TYPE_COLLECTION, GeeCollection), raw);
#line 29 "../src/engine/common/common-fts-search-query.vala"
	self->priv->stemmer = stemmer;
#line 189 "common-fts-search-query.c"
	{
		GeeList* _term_list = NULL;
		GeeList* _tmp0_;
		GeeList* _tmp1_;
		gint _term_size = 0;
		GeeList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _term_index = 0;
#line 31 "../src/engine/common/common-fts-search-query.vala"
		_tmp0_ = geary_search_query_get_expression (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_SEARCH_QUERY, GearySearchQuery));
#line 31 "../src/engine/common/common-fts-search-query.vala"
		_tmp1_ = _tmp0_;
#line 31 "../src/engine/common/common-fts-search-query.vala"
		_term_list = _tmp1_;
#line 31 "../src/engine/common/common-fts-search-query.vala"
		_tmp2_ = _term_list;
#line 31 "../src/engine/common/common-fts-search-query.vala"
		_tmp3_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection));
#line 31 "../src/engine/common/common-fts-search-query.vala"
		_tmp4_ = _tmp3_;
#line 31 "../src/engine/common/common-fts-search-query.vala"
		_term_size = _tmp4_;
#line 31 "../src/engine/common/common-fts-search-query.vala"
		_term_index = -1;
#line 31 "../src/engine/common/common-fts-search-query.vala"
		while (TRUE) {
#line 217 "common-fts-search-query.c"
			gint _tmp5_;
			gint _tmp6_;
			GearySearchQueryTerm* term = NULL;
			GeeList* _tmp7_;
			gpointer _tmp8_;
			GearySearchQueryTerm* _tmp9_;
			GearySearchQueryTerm* _tmp16_;
			gboolean _tmp17_;
			gboolean _tmp18_;
#line 31 "../src/engine/common/common-fts-search-query.vala"
			_term_index = _term_index + 1;
#line 31 "../src/engine/common/common-fts-search-query.vala"
			_tmp5_ = _term_index;
#line 31 "../src/engine/common/common-fts-search-query.vala"
			_tmp6_ = _term_size;
#line 31 "../src/engine/common/common-fts-search-query.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 31 "../src/engine/common/common-fts-search-query.vala"
				break;
#line 237 "common-fts-search-query.c"
			}
#line 31 "../src/engine/common/common-fts-search-query.vala"
			_tmp7_ = _term_list;
#line 31 "../src/engine/common/common-fts-search-query.vala"
			_tmp8_ = gee_list_get (_tmp7_, _term_index);
#line 31 "../src/engine/common/common-fts-search-query.vala"
			term = (GearySearchQueryTerm*) _tmp8_;
#line 36 "../src/engine/common/common-fts-search-query.vala"
			_tmp9_ = term;
#line 36 "../src/engine/common/common-fts-search-query.vala"
			if (G_TYPE_FROM_INSTANCE (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, G_TYPE_OBJECT, GObject)) == GEARY_SEARCH_QUERY_TYPE_EMAIL_TEXT_TERM) {
#line 249 "common-fts-search-query.c"
				GearySearchQueryEmailTextTerm* text = NULL;
				GearySearchQueryTerm* _tmp10_;
				GearySearchQueryEmailTextTerm* _tmp11_;
				GearySearchQueryEmailTextTerm* _tmp12_;
				GearySearchQueryStrategy _tmp13_;
				GearySearchQueryStrategy _tmp14_;
#line 39 "../src/engine/common/common-fts-search-query.vala"
				_tmp10_ = term;
#line 39 "../src/engine/common/common-fts-search-query.vala"
				_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEARY_SEARCH_QUERY_TYPE_EMAIL_TEXT_TERM, GearySearchQueryEmailTextTerm));
#line 39 "../src/engine/common/common-fts-search-query.vala"
				text = _tmp11_;
#line 40 "../src/engine/common/common-fts-search-query.vala"
				_tmp12_ = text;
#line 40 "../src/engine/common/common-fts-search-query.vala"
				_tmp13_ = geary_search_query_email_text_term_get_matching_strategy (_tmp12_);
#line 40 "../src/engine/common/common-fts-search-query.vala"
				_tmp14_ = _tmp13_;
#line 40 "../src/engine/common/common-fts-search-query.vala"
				if (geary_search_query_strategy_is_stemming_enabled (_tmp14_)) {
#line 270 "common-fts-search-query.c"
					GearySearchQueryEmailTextTerm* _tmp15_;
#line 41 "../src/engine/common/common-fts-search-query.vala"
					_tmp15_ = text;
#line 41 "../src/engine/common/common-fts-search-query.vala"
					geary_fts_search_query_stem_search_terms (self, _tmp15_);
#line 276 "common-fts-search-query.c"
				}
#line 36 "../src/engine/common/common-fts-search-query.vala"
				_g_object_unref0 (text);
#line 280 "common-fts-search-query.c"
			}
#line 44 "../src/engine/common/common-fts-search-query.vala"
			_tmp16_ = term;
#line 44 "../src/engine/common/common-fts-search-query.vala"
			_tmp17_ = geary_search_query_term_get_is_negated (_tmp16_);
#line 44 "../src/engine/common/common-fts-search-query.vala"
			_tmp18_ = _tmp17_;
#line 44 "../src/engine/common/common-fts-search-query.vala"
			if (!_tmp18_) {
#line 45 "../src/engine/common/common-fts-search-query.vala"
				self->priv->is_all_negated = FALSE;
#line 292 "common-fts-search-query.c"
			}
#line 31 "../src/engine/common/common-fts-search-query.vala"
			_g_object_unref0 (term);
#line 296 "common-fts-search-query.c"
		}
	}
#line 25 "../src/engine/common/common-fts-search-query.vala"
	return self;
#line 301 "common-fts-search-query.c"
}

GearyFtsSearchQuery*
geary_fts_search_query_new (GeeList* expression,
                            const gchar* raw,
                            struct sb_stemmer* stemmer)
{
#line 25 "../src/engine/common/common-fts-search-query.vala"
	return geary_fts_search_query_construct (GEARY_TYPE_FTS_SEARCH_QUERY, expression, raw, stemmer);
#line 311 "common-fts-search-query.c"
}

GearyDbStatement*
geary_fts_search_query_get_search_query (GearyFtsSearchQuery* self,
                                         GearyDbConnection* cx,
                                         const gchar* search_ids_sql,
                                         const gchar* excluded_folder_ids_sql,
                                         gboolean exclude_folderless,
                                         gint limit,
                                         gint offset,
                                         GError** error)
{
	GString* sql = NULL;
	GString* _tmp0_;
	GString* _tmp1_;
	gboolean conditions_added = FALSE;
	GString* _tmp4_;
	GeeList* _tmp6_;
	GeeList* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	GString* _tmp21_;
	GString* _tmp22_;
	GearyDbStatement* stmt = NULL;
	GString* _tmp24_;
	const gchar* _tmp25_;
	GearyDbStatement* _tmp26_;
	gint bind_index = 0;
	GearyDbStatement* _tmp27_;
	GError* _inner_error0_ = NULL;
	GearyDbStatement* result;
#line 50 "../src/engine/common/common-fts-search-query.vala"
	g_return_val_if_fail (GEARY_IS_FTS_SEARCH_QUERY (self), NULL);
#line 50 "../src/engine/common/common-fts-search-query.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), NULL);
#line 58 "../src/engine/common/common-fts-search-query.vala"
	_tmp0_ = g_string_new ("");
#line 58 "../src/engine/common/common-fts-search-query.vala"
	sql = _tmp0_;
#line 62 "../src/engine/common/common-fts-search-query.vala"
	_tmp1_ = sql;
#line 62 "../src/engine/common/common-fts-search-query.vala"
	g_string_append (_tmp1_, "\n" \
"                SELECT DISTINCT mt.id\n" \
"                FROM MessageTable AS mt\n" \
"                INDEXED BY MessageTableInternalDateTimeTIndex");
#line 72 "../src/engine/common/common-fts-search-query.vala"
	if (exclude_folderless) {
#line 357 "common-fts-search-query.c"
		GString* _tmp2_;
#line 73 "../src/engine/common/common-fts-search-query.vala"
		_tmp2_ = sql;
#line 73 "../src/engine/common/common-fts-search-query.vala"
		g_string_append (_tmp2_, "\n" \
"                INNER JOIN MessageLocationTable AS mlt ON mt.id = mlt." \
"message_id");
#line 363 "common-fts-search-query.c"
	} else {
		GString* _tmp3_;
#line 76 "../src/engine/common/common-fts-search-query.vala"
		_tmp3_ = sql;
#line 76 "../src/engine/common/common-fts-search-query.vala"
		g_string_append (_tmp3_, "\n" \
"                LEFT JOIN MessageLocationTable AS mlt ON mt.id = mlt.m" \
"essage_id");
#line 370 "common-fts-search-query.c"
	}
#line 80 "../src/engine/common/common-fts-search-query.vala"
	conditions_added = FALSE;
#line 81 "../src/engine/common/common-fts-search-query.vala"
	_tmp4_ = sql;
#line 81 "../src/engine/common/common-fts-search-query.vala"
	g_string_append (_tmp4_, "\n                WHERE");
#line 85 "../src/engine/common/common-fts-search-query.vala"
	if (excluded_folder_ids_sql != NULL) {
#line 380 "common-fts-search-query.c"
		GString* _tmp5_;
#line 86 "../src/engine/common/common-fts-search-query.vala"
		_tmp5_ = sql;
#line 86 "../src/engine/common/common-fts-search-query.vala"
		g_string_append_printf (_tmp5_, " mlt.folder_id NOT IN (%s)", excluded_folder_ids_sql);
#line 90 "../src/engine/common/common-fts-search-query.vala"
		conditions_added = TRUE;
#line 388 "common-fts-search-query.c"
	}
#line 94 "../src/engine/common/common-fts-search-query.vala"
	_tmp6_ = geary_search_query_get_expression (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_SEARCH_QUERY, GearySearchQuery));
#line 94 "../src/engine/common/common-fts-search-query.vala"
	_tmp7_ = _tmp6_;
#line 94 "../src/engine/common/common-fts-search-query.vala"
	_tmp8_ = gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection));
#line 94 "../src/engine/common/common-fts-search-query.vala"
	_tmp9_ = _tmp8_;
#line 94 "../src/engine/common/common-fts-search-query.vala"
	if (!_tmp9_) {
#line 400 "common-fts-search-query.c"
		const gchar* _tmp11_ = NULL;
		GString* _tmp12_;
		GString* _tmp13_;
		GString* _tmp14_;
		GString* _tmp15_;
#line 95 "../src/engine/common/common-fts-search-query.vala"
		if (conditions_added) {
#line 408 "common-fts-search-query.c"
			GString* _tmp10_;
#line 96 "../src/engine/common/common-fts-search-query.vala"
			_tmp10_ = sql;
#line 96 "../src/engine/common/common-fts-search-query.vala"
			g_string_append (_tmp10_, " AND");
#line 414 "common-fts-search-query.c"
		}
#line 99 "../src/engine/common/common-fts-search-query.vala"
		if (self->priv->is_all_negated) {
#line 100 "../src/engine/common/common-fts-search-query.vala"
			_tmp11_ = " mt.id NOT IN";
#line 420 "common-fts-search-query.c"
		} else {
#line 101 "../src/engine/common/common-fts-search-query.vala"
			_tmp11_ = " mt.id IN";
#line 424 "common-fts-search-query.c"
		}
#line 98 "../src/engine/common/common-fts-search-query.vala"
		_tmp12_ = sql;
#line 98 "../src/engine/common/common-fts-search-query.vala"
		g_string_append (_tmp12_, _tmp11_);
#line 103 "../src/engine/common/common-fts-search-query.vala"
		_tmp13_ = sql;
#line 103 "../src/engine/common/common-fts-search-query.vala"
		g_string_append (_tmp13_, " (SELECT mst.rowid FROM MessageSearchTable as mst WHERE ");
#line 106 "../src/engine/common/common-fts-search-query.vala"
		_tmp14_ = sql;
#line 106 "../src/engine/common/common-fts-search-query.vala"
		geary_fts_search_query_sql_add_term_conditions (self, _tmp14_, FALSE);
#line 107 "../src/engine/common/common-fts-search-query.vala"
		_tmp15_ = sql;
#line 107 "../src/engine/common/common-fts-search-query.vala"
		g_string_append_c (_tmp15_, ')');
#line 108 "../src/engine/common/common-fts-search-query.vala"
		conditions_added = TRUE;
#line 444 "common-fts-search-query.c"
	}
#line 112 "../src/engine/common/common-fts-search-query.vala"
	if (!geary_string_is_empty (search_ids_sql)) {
#line 448 "common-fts-search-query.c"
		GString* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 113 "../src/engine/common/common-fts-search-query.vala"
		if (conditions_added) {
#line 454 "common-fts-search-query.c"
			GString* _tmp16_;
#line 114 "../src/engine/common/common-fts-search-query.vala"
			_tmp16_ = sql;
#line 114 "../src/engine/common/common-fts-search-query.vala"
			g_string_append (_tmp16_, " AND");
#line 460 "common-fts-search-query.c"
		}
#line 116 "../src/engine/common/common-fts-search-query.vala"
		_tmp17_ = sql;
#line 116 "../src/engine/common/common-fts-search-query.vala"
		_tmp18_ = g_strdup_printf (" mt.id IN (%s)", search_ids_sql);
#line 116 "../src/engine/common/common-fts-search-query.vala"
		_tmp19_ = _tmp18_;
#line 116 "../src/engine/common/common-fts-search-query.vala"
		g_string_append (_tmp17_, _tmp19_);
#line 116 "../src/engine/common/common-fts-search-query.vala"
		_g_free0 (_tmp19_);
#line 472 "common-fts-search-query.c"
	}
#line 120 "../src/engine/common/common-fts-search-query.vala"
	if (conditions_added) {
#line 476 "common-fts-search-query.c"
		GString* _tmp20_;
#line 121 "../src/engine/common/common-fts-search-query.vala"
		_tmp20_ = sql;
#line 121 "../src/engine/common/common-fts-search-query.vala"
		g_string_append (_tmp20_, " AND");
#line 482 "common-fts-search-query.c"
	}
#line 123 "../src/engine/common/common-fts-search-query.vala"
	_tmp21_ = sql;
#line 123 "../src/engine/common/common-fts-search-query.vala"
	g_string_append (_tmp21_, " mlt.remove_marker IN (0, null)");
#line 126 "../src/engine/common/common-fts-search-query.vala"
	_tmp22_ = sql;
#line 126 "../src/engine/common/common-fts-search-query.vala"
	g_string_append (_tmp22_, "\n                ORDER BY mt.internaldate_time_t DESC");
#line 130 "../src/engine/common/common-fts-search-query.vala"
	if (limit > 0) {
#line 494 "common-fts-search-query.c"
		GString* _tmp23_;
#line 131 "../src/engine/common/common-fts-search-query.vala"
		_tmp23_ = sql;
#line 131 "../src/engine/common/common-fts-search-query.vala"
		g_string_append (_tmp23_, "\n                LIMIT ? OFFSET ?");
#line 500 "common-fts-search-query.c"
	}
#line 135 "../src/engine/common/common-fts-search-query.vala"
	_tmp24_ = sql;
#line 135 "../src/engine/common/common-fts-search-query.vala"
	_tmp25_ = _tmp24_->str;
#line 135 "../src/engine/common/common-fts-search-query.vala"
	_tmp26_ = geary_db_connection_prepare (cx, _tmp25_, &_inner_error0_);
#line 135 "../src/engine/common/common-fts-search-query.vala"
	stmt = _tmp26_;
#line 135 "../src/engine/common/common-fts-search-query.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 135 "../src/engine/common/common-fts-search-query.vala"
		g_propagate_error (error, _inner_error0_);
#line 135 "../src/engine/common/common-fts-search-query.vala"
		_g_string_free0 (sql);
#line 135 "../src/engine/common/common-fts-search-query.vala"
		return NULL;
#line 518 "common-fts-search-query.c"
	}
#line 136 "../src/engine/common/common-fts-search-query.vala"
	_tmp27_ = stmt;
#line 136 "../src/engine/common/common-fts-search-query.vala"
	bind_index = geary_fts_search_query_sql_bind_term_conditions (self, _tmp27_, 0, &_inner_error0_);
#line 136 "../src/engine/common/common-fts-search-query.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 136 "../src/engine/common/common-fts-search-query.vala"
		g_propagate_error (error, _inner_error0_);
#line 136 "../src/engine/common/common-fts-search-query.vala"
		_g_object_unref0 (stmt);
#line 136 "../src/engine/common/common-fts-search-query.vala"
		_g_string_free0 (sql);
#line 136 "../src/engine/common/common-fts-search-query.vala"
		return NULL;
#line 534 "common-fts-search-query.c"
	}
#line 137 "../src/engine/common/common-fts-search-query.vala"
	if (limit > 0) {
#line 538 "common-fts-search-query.c"
		GearyDbStatement* _tmp28_;
		gint _tmp29_;
		gint _tmp30_;
		GearyDbStatement* _tmp31_;
		GearyDbStatement* _tmp32_;
		GearyDbStatement* _tmp33_;
		gint _tmp34_;
		gint _tmp35_;
		GearyDbStatement* _tmp36_;
		GearyDbStatement* _tmp37_;
#line 138 "../src/engine/common/common-fts-search-query.vala"
		_tmp28_ = stmt;
#line 138 "../src/engine/common/common-fts-search-query.vala"
		_tmp29_ = bind_index;
#line 138 "../src/engine/common/common-fts-search-query.vala"
		bind_index = _tmp29_ + 1;
#line 138 "../src/engine/common/common-fts-search-query.vala"
		_tmp30_ = limit;
#line 138 "../src/engine/common/common-fts-search-query.vala"
		_tmp31_ = geary_db_statement_bind_int (_tmp28_, _tmp29_, _tmp30_, &_inner_error0_);
#line 138 "../src/engine/common/common-fts-search-query.vala"
		_tmp32_ = _tmp31_;
#line 138 "../src/engine/common/common-fts-search-query.vala"
		_g_object_unref0 (_tmp32_);
#line 138 "../src/engine/common/common-fts-search-query.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 138 "../src/engine/common/common-fts-search-query.vala"
			g_propagate_error (error, _inner_error0_);
#line 138 "../src/engine/common/common-fts-search-query.vala"
			_g_object_unref0 (stmt);
#line 138 "../src/engine/common/common-fts-search-query.vala"
			_g_string_free0 (sql);
#line 138 "../src/engine/common/common-fts-search-query.vala"
			return NULL;
#line 573 "common-fts-search-query.c"
		}
#line 139 "../src/engine/common/common-fts-search-query.vala"
		_tmp33_ = stmt;
#line 139 "../src/engine/common/common-fts-search-query.vala"
		_tmp34_ = bind_index;
#line 139 "../src/engine/common/common-fts-search-query.vala"
		bind_index = _tmp34_ + 1;
#line 139 "../src/engine/common/common-fts-search-query.vala"
		_tmp35_ = offset;
#line 139 "../src/engine/common/common-fts-search-query.vala"
		_tmp36_ = geary_db_statement_bind_int (_tmp33_, _tmp34_, _tmp35_, &_inner_error0_);
#line 139 "../src/engine/common/common-fts-search-query.vala"
		_tmp37_ = _tmp36_;
#line 139 "../src/engine/common/common-fts-search-query.vala"
		_g_object_unref0 (_tmp37_);
#line 139 "../src/engine/common/common-fts-search-query.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 139 "../src/engine/common/common-fts-search-query.vala"
			g_propagate_error (error, _inner_error0_);
#line 139 "../src/engine/common/common-fts-search-query.vala"
			_g_object_unref0 (stmt);
#line 139 "../src/engine/common/common-fts-search-query.vala"
			_g_string_free0 (sql);
#line 139 "../src/engine/common/common-fts-search-query.vala"
			return NULL;
#line 599 "common-fts-search-query.c"
		}
	}
#line 142 "../src/engine/common/common-fts-search-query.vala"
	result = stmt;
#line 142 "../src/engine/common/common-fts-search-query.vala"
	_g_string_free0 (sql);
#line 142 "../src/engine/common/common-fts-search-query.vala"
	return result;
#line 608 "common-fts-search-query.c"
}

GearyDbStatement*
geary_fts_search_query_get_match_query (GearyFtsSearchQuery* self,
                                        GearyDbConnection* cx,
                                        const gchar* search_ids_sql,
                                        GError** error)
{
	GString* sql = NULL;
	GString* _tmp0_;
	GString* _tmp1_;
	GString* _tmp2_;
	GString* _tmp3_;
	GString* _tmp4_;
	GearyDbStatement* stmt = NULL;
	GString* _tmp5_;
	const gchar* _tmp6_;
	GearyDbStatement* _tmp7_;
	GearyDbStatement* _tmp8_;
	GError* _inner_error0_ = NULL;
	GearyDbStatement* result;
#line 145 "../src/engine/common/common-fts-search-query.vala"
	g_return_val_if_fail (GEARY_IS_FTS_SEARCH_QUERY (self), NULL);
#line 145 "../src/engine/common/common-fts-search-query.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), NULL);
#line 149 "../src/engine/common/common-fts-search-query.vala"
	_tmp0_ = g_string_new ("");
#line 149 "../src/engine/common/common-fts-search-query.vala"
	sql = _tmp0_;
#line 150 "../src/engine/common/common-fts-search-query.vala"
	_tmp1_ = sql;
#line 150 "../src/engine/common/common-fts-search-query.vala"
	g_string_append (_tmp1_, "\n" \
"            SELECT mst.rowid, geary_matches(MessageSearchTable)\n" \
"            FROM MessageSearchTable as mst\n" \
"            WHERE rowid IN (\n" \
"        ");
#line 155 "../src/engine/common/common-fts-search-query.vala"
	_tmp2_ = sql;
#line 155 "../src/engine/common/common-fts-search-query.vala"
	g_string_append (_tmp2_, search_ids_sql);
#line 156 "../src/engine/common/common-fts-search-query.vala"
	_tmp3_ = sql;
#line 156 "../src/engine/common/common-fts-search-query.vala"
	g_string_append (_tmp3_, ") AND ");
#line 157 "../src/engine/common/common-fts-search-query.vala"
	_tmp4_ = sql;
#line 157 "../src/engine/common/common-fts-search-query.vala"
	geary_fts_search_query_sql_add_term_conditions (self, _tmp4_, FALSE);
#line 159 "../src/engine/common/common-fts-search-query.vala"
	_tmp5_ = sql;
#line 159 "../src/engine/common/common-fts-search-query.vala"
	_tmp6_ = _tmp5_->str;
#line 159 "../src/engine/common/common-fts-search-query.vala"
	_tmp7_ = geary_db_connection_prepare (cx, _tmp6_, &_inner_error0_);
#line 159 "../src/engine/common/common-fts-search-query.vala"
	stmt = _tmp7_;
#line 159 "../src/engine/common/common-fts-search-query.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 159 "../src/engine/common/common-fts-search-query.vala"
		g_propagate_error (error, _inner_error0_);
#line 159 "../src/engine/common/common-fts-search-query.vala"
		_g_string_free0 (sql);
#line 159 "../src/engine/common/common-fts-search-query.vala"
		return NULL;
#line 670 "common-fts-search-query.c"
	}
#line 160 "../src/engine/common/common-fts-search-query.vala"
	_tmp8_ = stmt;
#line 160 "../src/engine/common/common-fts-search-query.vala"
	geary_fts_search_query_sql_bind_term_conditions (self, _tmp8_, 0, &_inner_error0_);
#line 160 "../src/engine/common/common-fts-search-query.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 160 "../src/engine/common/common-fts-search-query.vala"
		g_propagate_error (error, _inner_error0_);
#line 160 "../src/engine/common/common-fts-search-query.vala"
		_g_object_unref0 (stmt);
#line 160 "../src/engine/common/common-fts-search-query.vala"
		_g_string_free0 (sql);
#line 160 "../src/engine/common/common-fts-search-query.vala"
		return NULL;
#line 686 "common-fts-search-query.c"
	}
#line 161 "../src/engine/common/common-fts-search-query.vala"
	result = stmt;
#line 161 "../src/engine/common/common-fts-search-query.vala"
	_g_string_free0 (sql);
#line 161 "../src/engine/common/common-fts-search-query.vala"
	return result;
#line 694 "common-fts-search-query.c"
}

/**
     * Applies stemming for the given term to a specific term value.
     *
     * Prior experience with the Snowball stemmer indicates it is too
     * aggressive for our tastes when coupled with prefix-matching of
     * all unquoted terms. See
     * https://bugzilla.gnome.org/show_bug.cgi?id=713179 and
     * https://bugzilla.gnome.org/show_bug.cgi?id=720361
     *
     * This method is part of a larger strategy designed to dampen
     * that aggressiveness without losing the benefits of stemming
     * entirely: The database's FTS table uses no stemming, but
     * libstemmer is used to generate stemmed search terms.
     * Post-search processing is then to strip results which are too
     * "greedy" due to prefix-matching the stemmed variant.
     *
     * Some heuristics are in place simply to determine if stemming
     * should occur:
     *
     * # If stemming is unallowed, no stemming occurs.
     * # If the term is < min. term length for stemming, no stemming
     *   occurs.
     * # If the stemmer returns a stem that is the same as the
     *   original term, no stemming occurs.
     * # If the difference between the stemmed word and the original
     *   term is more than maximum allowed, no stemming occurs.  This
     *   works under the assumption that if the user has typed a long
     *   word, they do not want to "go back" to searching for a much
     *   shorter version of it.  (For example, "accountancies" stems
     *   to "account").
     *
     * Otherwise, the stem for the term is returned.
     */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 740 "common-fts-search-query.c"
}

static void
geary_fts_search_query_stem_search_terms (GearyFtsSearchQuery* self,
                                          GearySearchQueryEmailTextTerm* text)
{
	GeeArrayList* stemmed_terms = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp42_;
	GeeArrayList* _tmp43_;
#line 197 "../src/engine/common/common-fts-search-query.vala"
	g_return_if_fail (GEARY_IS_FTS_SEARCH_QUERY (self));
#line 197 "../src/engine/common/common-fts-search-query.vala"
	g_return_if_fail (GEARY_SEARCH_QUERY_IS_EMAIL_TEXT_TERM (text));
#line 198 "../src/engine/common/common-fts-search-query.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 198 "../src/engine/common/common-fts-search-query.vala"
	stemmed_terms = _tmp0_;
#line 759 "common-fts-search-query.c"
	{
		GeeList* _term_list = NULL;
		GeeList* _tmp1_;
		GeeList* _tmp2_;
		gint _term_size = 0;
		GeeList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _term_index = 0;
#line 199 "../src/engine/common/common-fts-search-query.vala"
		_tmp1_ = geary_search_query_email_text_term_get_terms (text);
#line 199 "../src/engine/common/common-fts-search-query.vala"
		_tmp2_ = _tmp1_;
#line 199 "../src/engine/common/common-fts-search-query.vala"
		_term_list = _tmp2_;
#line 199 "../src/engine/common/common-fts-search-query.vala"
		_tmp3_ = _term_list;
#line 199 "../src/engine/common/common-fts-search-query.vala"
		_tmp4_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 199 "../src/engine/common/common-fts-search-query.vala"
		_tmp5_ = _tmp4_;
#line 199 "../src/engine/common/common-fts-search-query.vala"
		_term_size = _tmp5_;
#line 199 "../src/engine/common/common-fts-search-query.vala"
		_term_index = -1;
#line 199 "../src/engine/common/common-fts-search-query.vala"
		while (TRUE) {
#line 787 "common-fts-search-query.c"
			gint _tmp6_;
			gint _tmp7_;
			gchar* term = NULL;
			GeeList* _tmp8_;
			gpointer _tmp9_;
			gint term_length = 0;
			const gchar* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gchar* stemmed = NULL;
			GearySearchQueryStrategy _tmp13_;
			GearySearchQueryStrategy _tmp14_;
			const gchar* _tmp29_;
			GeeArrayList* _tmp40_;
			const gchar* _tmp41_;
#line 199 "../src/engine/common/common-fts-search-query.vala"
			_term_index = _term_index + 1;
#line 199 "../src/engine/common/common-fts-search-query.vala"
			_tmp6_ = _term_index;
#line 199 "../src/engine/common/common-fts-search-query.vala"
			_tmp7_ = _term_size;
#line 199 "../src/engine/common/common-fts-search-query.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 199 "../src/engine/common/common-fts-search-query.vala"
				break;
#line 813 "common-fts-search-query.c"
			}
#line 199 "../src/engine/common/common-fts-search-query.vala"
			_tmp8_ = _term_list;
#line 199 "../src/engine/common/common-fts-search-query.vala"
			_tmp9_ = gee_list_get (_tmp8_, _term_index);
#line 199 "../src/engine/common/common-fts-search-query.vala"
			term = (gchar*) _tmp9_;
#line 200 "../src/engine/common/common-fts-search-query.vala"
			_tmp10_ = term;
#line 200 "../src/engine/common/common-fts-search-query.vala"
			_tmp11_ = strlen (_tmp10_);
#line 200 "../src/engine/common/common-fts-search-query.vala"
			_tmp12_ = _tmp11_;
#line 200 "../src/engine/common/common-fts-search-query.vala"
			term_length = _tmp12_;
#line 201 "../src/engine/common/common-fts-search-query.vala"
			stemmed = NULL;
#line 202 "../src/engine/common/common-fts-search-query.vala"
			_tmp13_ = geary_search_query_email_text_term_get_matching_strategy (text);
#line 202 "../src/engine/common/common-fts-search-query.vala"
			_tmp14_ = _tmp13_;
#line 202 "../src/engine/common/common-fts-search-query.vala"
			if (term_length > geary_search_query_strategy_get_min_term_length_for_stemming (_tmp14_)) {
#line 837 "common-fts-search-query.c"
				struct sb_stemmer* _tmp15_;
				const gchar* _tmp16_;
				const gchar* _tmp17_;
				gchar* _tmp18_;
				gboolean _tmp19_ = FALSE;
				gboolean _tmp20_ = FALSE;
				const gchar* _tmp21_;
#line 203 "../src/engine/common/common-fts-search-query.vala"
				_tmp15_ = self->priv->stemmer;
#line 203 "../src/engine/common/common-fts-search-query.vala"
				_tmp16_ = term;
#line 203 "../src/engine/common/common-fts-search-query.vala"
				_tmp17_ = sb_stemmer_stem (_tmp15_, _tmp16_, term_length);
#line 203 "../src/engine/common/common-fts-search-query.vala"
				_tmp18_ = g_strdup (_tmp17_);
#line 203 "../src/engine/common/common-fts-search-query.vala"
				_g_free0 (stemmed);
#line 203 "../src/engine/common/common-fts-search-query.vala"
				stemmed = _tmp18_;
#line 204 "../src/engine/common/common-fts-search-query.vala"
				_tmp21_ = stemmed;
#line 204 "../src/engine/common/common-fts-search-query.vala"
				if (geary_string_is_empty (_tmp21_)) {
#line 204 "../src/engine/common/common-fts-search-query.vala"
					_tmp20_ = TRUE;
#line 863 "common-fts-search-query.c"
				} else {
					const gchar* _tmp22_;
					const gchar* _tmp23_;
#line 205 "../src/engine/common/common-fts-search-query.vala"
					_tmp22_ = term;
#line 205 "../src/engine/common/common-fts-search-query.vala"
					_tmp23_ = stemmed;
#line 205 "../src/engine/common/common-fts-search-query.vala"
					_tmp20_ = g_strcmp0 (_tmp22_, _tmp23_) == 0;
#line 873 "common-fts-search-query.c"
				}
#line 204 "../src/engine/common/common-fts-search-query.vala"
				if (_tmp20_) {
#line 204 "../src/engine/common/common-fts-search-query.vala"
					_tmp19_ = TRUE;
#line 879 "common-fts-search-query.c"
				} else {
					const gchar* _tmp24_;
					gint _tmp25_;
					gint _tmp26_;
					GearySearchQueryStrategy _tmp27_;
					GearySearchQueryStrategy _tmp28_;
#line 206 "../src/engine/common/common-fts-search-query.vala"
					_tmp24_ = stemmed;
#line 206 "../src/engine/common/common-fts-search-query.vala"
					_tmp25_ = strlen (_tmp24_);
#line 206 "../src/engine/common/common-fts-search-query.vala"
					_tmp26_ = _tmp25_;
#line 206 "../src/engine/common/common-fts-search-query.vala"
					_tmp27_ = geary_search_query_email_text_term_get_matching_strategy (text);
#line 206 "../src/engine/common/common-fts-search-query.vala"
					_tmp28_ = _tmp27_;
#line 206 "../src/engine/common/common-fts-search-query.vala"
					_tmp19_ = (term_length - _tmp26_) > geary_search_query_strategy_get_max_difference_term_stem_lengths (_tmp28_);
#line 898 "common-fts-search-query.c"
				}
#line 204 "../src/engine/common/common-fts-search-query.vala"
				if (_tmp19_) {
#line 208 "../src/engine/common/common-fts-search-query.vala"
					_g_free0 (stemmed);
#line 208 "../src/engine/common/common-fts-search-query.vala"
					stemmed = NULL;
#line 906 "common-fts-search-query.c"
				}
			}
#line 211 "../src/engine/common/common-fts-search-query.vala"
			_tmp29_ = stemmed;
#line 211 "../src/engine/common/common-fts-search-query.vala"
			if (_tmp29_ != NULL) {
#line 913 "common-fts-search-query.c"
				const gchar* _tmp30_;
				const gchar* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
#line 212 "../src/engine/common/common-fts-search-query.vala"
				geary_fts_search_query_set_has_stemmed_terms (self, TRUE);
#line 213 "../src/engine/common/common-fts-search-query.vala"
				_tmp30_ = term;
#line 213 "../src/engine/common/common-fts-search-query.vala"
				_tmp31_ = string_to_string (_tmp30_);
#line 213 "../src/engine/common/common-fts-search-query.vala"
				_tmp32_ = stemmed;
#line 213 "../src/engine/common/common-fts-search-query.vala"
				_tmp33_ = string_to_string (_tmp32_);
#line 213 "../src/engine/common/common-fts-search-query.vala"
				_tmp34_ = g_strconcat ("Search term \"", _tmp31_, "\" stemmed to \"", _tmp33_, "\"", NULL);
#line 213 "../src/engine/common/common-fts-search-query.vala"
				_tmp35_ = _tmp34_;
#line 213 "../src/engine/common/common-fts-search-query.vala"
				g_debug ("common-fts-search-query.vala:213: %s", _tmp35_);
#line 213 "../src/engine/common/common-fts-search-query.vala"
				_g_free0 (_tmp35_);
#line 938 "common-fts-search-query.c"
			} else {
				const gchar* _tmp36_;
				const gchar* _tmp37_;
				gchar* _tmp38_;
				gchar* _tmp39_;
#line 215 "../src/engine/common/common-fts-search-query.vala"
				_tmp36_ = term;
#line 215 "../src/engine/common/common-fts-search-query.vala"
				_tmp37_ = string_to_string (_tmp36_);
#line 215 "../src/engine/common/common-fts-search-query.vala"
				_tmp38_ = g_strconcat ("Search term \"", _tmp37_, "\" not stemmed", NULL);
#line 215 "../src/engine/common/common-fts-search-query.vala"
				_tmp39_ = _tmp38_;
#line 215 "../src/engine/common/common-fts-search-query.vala"
				g_debug ("common-fts-search-query.vala:215: %s", _tmp39_);
#line 215 "../src/engine/common/common-fts-search-query.vala"
				_g_free0 (_tmp39_);
#line 956 "common-fts-search-query.c"
			}
#line 217 "../src/engine/common/common-fts-search-query.vala"
			_tmp40_ = stemmed_terms;
#line 217 "../src/engine/common/common-fts-search-query.vala"
			_tmp41_ = stemmed;
#line 217 "../src/engine/common/common-fts-search-query.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp41_);
#line 199 "../src/engine/common/common-fts-search-query.vala"
			_g_free0 (stemmed);
#line 199 "../src/engine/common/common-fts-search-query.vala"
			_g_free0 (term);
#line 968 "common-fts-search-query.c"
		}
	}
#line 219 "../src/engine/common/common-fts-search-query.vala"
	_tmp42_ = stemmed_terms;
#line 219 "../src/engine/common/common-fts-search-query.vala"
	_tmp43_ = _g_object_ref0 (_tmp42_);
#line 219 "../src/engine/common/common-fts-search-query.vala"
	g_object_set_data_full (G_TYPE_CHECK_INSTANCE_CAST (text, G_TYPE_OBJECT, GObject), GEARY_FTS_SEARCH_QUERY_EMAIL_TEXT_STEMMED_TERMS, _tmp43_, g_object_unref);
#line 197 "../src/engine/common/common-fts-search-query.vala"
	_g_object_unref0 (stemmed_terms);
#line 979 "common-fts-search-query.c"
}

static gboolean
geary_fts_search_query_sql_add_term_conditions (GearyFtsSearchQuery* self,
                                                GString* sql,
                                                gboolean have_added_sql_condition)
{
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 222 "../src/engine/common/common-fts-search-query.vala"
	g_return_val_if_fail (GEARY_IS_FTS_SEARCH_QUERY (self), FALSE);
#line 222 "../src/engine/common/common-fts-search-query.vala"
	g_return_val_if_fail (sql != NULL, FALSE);
#line 224 "../src/engine/common/common-fts-search-query.vala"
	_tmp0_ = geary_search_query_get_expression (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_SEARCH_QUERY, GearySearchQuery));
#line 224 "../src/engine/common/common-fts-search-query.vala"
	_tmp1_ = _tmp0_;
#line 224 "../src/engine/common/common-fts-search-query.vala"
	_tmp2_ = gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 224 "../src/engine/common/common-fts-search-query.vala"
	_tmp3_ = _tmp2_;
#line 224 "../src/engine/common/common-fts-search-query.vala"
	if (!_tmp3_) {
#line 1006 "common-fts-search-query.c"
		gboolean is_first_positive_term = FALSE;
		gboolean is_first_negated_term = FALSE;
#line 225 "../src/engine/common/common-fts-search-query.vala"
		if (have_added_sql_condition) {
#line 226 "../src/engine/common/common-fts-search-query.vala"
			g_string_append (sql, " AND");
#line 1013 "common-fts-search-query.c"
		}
#line 228 "../src/engine/common/common-fts-search-query.vala"
		have_added_sql_condition = TRUE;
#line 229 "../src/engine/common/common-fts-search-query.vala"
		g_string_append (sql, " MessageSearchTable MATCH '");
#line 238 "../src/engine/common/common-fts-search-query.vala"
		is_first_positive_term = TRUE;
#line 1021 "common-fts-search-query.c"
		{
			GeeList* _term_list = NULL;
			GeeList* _tmp4_;
			GeeList* _tmp5_;
			gint _term_size = 0;
			GeeList* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _term_index = 0;
#line 239 "../src/engine/common/common-fts-search-query.vala"
			_tmp4_ = geary_search_query_get_expression (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_SEARCH_QUERY, GearySearchQuery));
#line 239 "../src/engine/common/common-fts-search-query.vala"
			_tmp5_ = _tmp4_;
#line 239 "../src/engine/common/common-fts-search-query.vala"
			_term_list = _tmp5_;
#line 239 "../src/engine/common/common-fts-search-query.vala"
			_tmp6_ = _term_list;
#line 239 "../src/engine/common/common-fts-search-query.vala"
			_tmp7_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_COLLECTION, GeeCollection));
#line 239 "../src/engine/common/common-fts-search-query.vala"
			_tmp8_ = _tmp7_;
#line 239 "../src/engine/common/common-fts-search-query.vala"
			_term_size = _tmp8_;
#line 239 "../src/engine/common/common-fts-search-query.vala"
			_term_index = -1;
#line 239 "../src/engine/common/common-fts-search-query.vala"
			while (TRUE) {
#line 1049 "common-fts-search-query.c"
				gint _tmp9_;
				gint _tmp10_;
				GearySearchQueryTerm* term = NULL;
				GeeList* _tmp11_;
				gpointer _tmp12_;
				GearySearchQueryTerm* _tmp13_;
				gboolean _tmp14_;
				gboolean _tmp15_;
#line 239 "../src/engine/common/common-fts-search-query.vala"
				_term_index = _term_index + 1;
#line 239 "../src/engine/common/common-fts-search-query.vala"
				_tmp9_ = _term_index;
#line 239 "../src/engine/common/common-fts-search-query.vala"
				_tmp10_ = _term_size;
#line 239 "../src/engine/common/common-fts-search-query.vala"
				if (!(_tmp9_ < _tmp10_)) {
#line 239 "../src/engine/common/common-fts-search-query.vala"
					break;
#line 1068 "common-fts-search-query.c"
				}
#line 239 "../src/engine/common/common-fts-search-query.vala"
				_tmp11_ = _term_list;
#line 239 "../src/engine/common/common-fts-search-query.vala"
				_tmp12_ = gee_list_get (_tmp11_, _term_index);
#line 239 "../src/engine/common/common-fts-search-query.vala"
				term = (GearySearchQueryTerm*) _tmp12_;
#line 240 "../src/engine/common/common-fts-search-query.vala"
				_tmp13_ = term;
#line 240 "../src/engine/common/common-fts-search-query.vala"
				_tmp14_ = geary_search_query_term_get_is_negated (_tmp13_);
#line 240 "../src/engine/common/common-fts-search-query.vala"
				_tmp15_ = _tmp14_;
#line 240 "../src/engine/common/common-fts-search-query.vala"
				if (!_tmp15_) {
#line 1084 "common-fts-search-query.c"
					GearySearchQueryTerm* _tmp16_;
#line 241 "../src/engine/common/common-fts-search-query.vala"
					if (is_first_positive_term) {
#line 242 "../src/engine/common/common-fts-search-query.vala"
						g_string_append (sql, " (");
#line 1090 "common-fts-search-query.c"
					} else {
#line 244 "../src/engine/common/common-fts-search-query.vala"
						g_string_append (sql, " AND");
#line 1094 "common-fts-search-query.c"
					}
#line 246 "../src/engine/common/common-fts-search-query.vala"
					_tmp16_ = term;
#line 246 "../src/engine/common/common-fts-search-query.vala"
					geary_fts_search_query_sql_add_term_condition (self, sql, _tmp16_);
#line 247 "../src/engine/common/common-fts-search-query.vala"
					is_first_positive_term = FALSE;
#line 1102 "common-fts-search-query.c"
				}
#line 239 "../src/engine/common/common-fts-search-query.vala"
				_g_object_unref0 (term);
#line 1106 "common-fts-search-query.c"
			}
		}
#line 250 "../src/engine/common/common-fts-search-query.vala"
		if (!is_first_positive_term) {
#line 251 "../src/engine/common/common-fts-search-query.vala"
			g_string_append_c (sql, ')');
#line 1113 "common-fts-search-query.c"
		}
#line 254 "../src/engine/common/common-fts-search-query.vala"
		is_first_negated_term = TRUE;
#line 1117 "common-fts-search-query.c"
		{
			GeeList* _term_list = NULL;
			GeeList* _tmp17_;
			GeeList* _tmp18_;
			gint _term_size = 0;
			GeeList* _tmp19_;
			gint _tmp20_;
			gint _tmp21_;
			gint _term_index = 0;
#line 255 "../src/engine/common/common-fts-search-query.vala"
			_tmp17_ = geary_search_query_get_expression (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_SEARCH_QUERY, GearySearchQuery));
#line 255 "../src/engine/common/common-fts-search-query.vala"
			_tmp18_ = _tmp17_;
#line 255 "../src/engine/common/common-fts-search-query.vala"
			_term_list = _tmp18_;
#line 255 "../src/engine/common/common-fts-search-query.vala"
			_tmp19_ = _term_list;
#line 255 "../src/engine/common/common-fts-search-query.vala"
			_tmp20_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEE_TYPE_COLLECTION, GeeCollection));
#line 255 "../src/engine/common/common-fts-search-query.vala"
			_tmp21_ = _tmp20_;
#line 255 "../src/engine/common/common-fts-search-query.vala"
			_term_size = _tmp21_;
#line 255 "../src/engine/common/common-fts-search-query.vala"
			_term_index = -1;
#line 255 "../src/engine/common/common-fts-search-query.vala"
			while (TRUE) {
#line 1145 "common-fts-search-query.c"
				gint _tmp22_;
				gint _tmp23_;
				GearySearchQueryTerm* term = NULL;
				GeeList* _tmp24_;
				gpointer _tmp25_;
				GearySearchQueryTerm* _tmp26_;
				gboolean _tmp27_;
				gboolean _tmp28_;
#line 255 "../src/engine/common/common-fts-search-query.vala"
				_term_index = _term_index + 1;
#line 255 "../src/engine/common/common-fts-search-query.vala"
				_tmp22_ = _term_index;
#line 255 "../src/engine/common/common-fts-search-query.vala"
				_tmp23_ = _term_size;
#line 255 "../src/engine/common/common-fts-search-query.vala"
				if (!(_tmp22_ < _tmp23_)) {
#line 255 "../src/engine/common/common-fts-search-query.vala"
					break;
#line 1164 "common-fts-search-query.c"
				}
#line 255 "../src/engine/common/common-fts-search-query.vala"
				_tmp24_ = _term_list;
#line 255 "../src/engine/common/common-fts-search-query.vala"
				_tmp25_ = gee_list_get (_tmp24_, _term_index);
#line 255 "../src/engine/common/common-fts-search-query.vala"
				term = (GearySearchQueryTerm*) _tmp25_;
#line 256 "../src/engine/common/common-fts-search-query.vala"
				_tmp26_ = term;
#line 256 "../src/engine/common/common-fts-search-query.vala"
				_tmp27_ = geary_search_query_term_get_is_negated (_tmp26_);
#line 256 "../src/engine/common/common-fts-search-query.vala"
				_tmp28_ = _tmp27_;
#line 256 "../src/engine/common/common-fts-search-query.vala"
				if (_tmp28_) {
#line 1180 "common-fts-search-query.c"
					GearySearchQueryTerm* _tmp29_;
#line 257 "../src/engine/common/common-fts-search-query.vala"
					if (is_first_negated_term) {
#line 262 "../src/engine/common/common-fts-search-query.vala"
						if (!self->priv->is_all_negated) {
#line 263 "../src/engine/common/common-fts-search-query.vala"
							g_string_append (sql, " NOT (");
#line 1188 "common-fts-search-query.c"
						} else {
#line 265 "../src/engine/common/common-fts-search-query.vala"
							g_string_append (sql, " (");
#line 1192 "common-fts-search-query.c"
						}
					} else {
#line 268 "../src/engine/common/common-fts-search-query.vala"
						g_string_append (sql, " AND");
#line 1197 "common-fts-search-query.c"
					}
#line 270 "../src/engine/common/common-fts-search-query.vala"
					_tmp29_ = term;
#line 270 "../src/engine/common/common-fts-search-query.vala"
					geary_fts_search_query_sql_add_term_condition (self, sql, _tmp29_);
#line 271 "../src/engine/common/common-fts-search-query.vala"
					is_first_negated_term = FALSE;
#line 1205 "common-fts-search-query.c"
				}
#line 255 "../src/engine/common/common-fts-search-query.vala"
				_g_object_unref0 (term);
#line 1209 "common-fts-search-query.c"
			}
		}
#line 274 "../src/engine/common/common-fts-search-query.vala"
		if (!is_first_negated_term) {
#line 275 "../src/engine/common/common-fts-search-query.vala"
			g_string_append_c (sql, ')');
#line 1216 "common-fts-search-query.c"
		}
#line 278 "../src/engine/common/common-fts-search-query.vala"
		g_string_append (sql, "'");
#line 1220 "common-fts-search-query.c"
	}
#line 280 "../src/engine/common/common-fts-search-query.vala"
	result = have_added_sql_condition;
#line 280 "../src/engine/common/common-fts-search-query.vala"
	return result;
#line 1226 "common-fts-search-query.c"
}

static inline void
geary_fts_search_query_sql_add_term_condition (GearyFtsSearchQuery* self,
                                               GString* sql,
                                               GearySearchQueryTerm* term)
{
#line 283 "../src/engine/common/common-fts-search-query.vala"
	g_return_if_fail (GEARY_IS_FTS_SEARCH_QUERY (self));
#line 283 "../src/engine/common/common-fts-search-query.vala"
	g_return_if_fail (sql != NULL);
#line 283 "../src/engine/common/common-fts-search-query.vala"
	g_return_if_fail (GEARY_SEARCH_QUERY_IS_TERM (term));
#line 285 "../src/engine/common/common-fts-search-query.vala"
	if (G_TYPE_FROM_INSTANCE (G_TYPE_CHECK_INSTANCE_CAST (term, G_TYPE_OBJECT, GObject)) == GEARY_SEARCH_QUERY_TYPE_EMAIL_TEXT_TERM) {
#line 286 "../src/engine/common/common-fts-search-query.vala"
		geary_fts_search_query_sql_add_email_text_term_conditions (self, G_TYPE_CHECK_INSTANCE_CAST (term, GEARY_SEARCH_QUERY_TYPE_EMAIL_TEXT_TERM, GearySearchQueryEmailTextTerm), sql);
#line 1244 "common-fts-search-query.c"
	} else {
#line 287 "../src/engine/common/common-fts-search-query.vala"
		if (G_TYPE_FROM_INSTANCE (G_TYPE_CHECK_INSTANCE_CAST (term, G_TYPE_OBJECT, GObject)) == GEARY_SEARCH_QUERY_TYPE_EMAIL_FLAG_TERM) {
#line 288 "../src/engine/common/common-fts-search-query.vala"
			g_string_append (sql, " ({flags} : \"' || ? || '\")");
#line 1250 "common-fts-search-query.c"
		}
	}
}

static inline void
geary_fts_search_query_sql_add_email_text_term_conditions (GearyFtsSearchQuery* self,
                                                           GearySearchQueryEmailTextTerm* text,
                                                           GString* sql)
{
	gchar* target = NULL;
	gchar* _tmp0_;
	GearySearchQueryEmailTextTermProperty _tmp1_;
	GearySearchQueryEmailTextTermProperty _tmp2_;
	GeeList* values = NULL;
	GeeList* _tmp11_;
	GeeList* _tmp12_;
	GeeList* _tmp13_;
	GeeList* stemmed_values = NULL;
	gconstpointer _tmp14_;
	GeeList* _tmp15_;
	gboolean is_first_disjunct = FALSE;
#line 292 "../src/engine/common/common-fts-search-query.vala"
	g_return_if_fail (GEARY_IS_FTS_SEARCH_QUERY (self));
#line 292 "../src/engine/common/common-fts-search-query.vala"
	g_return_if_fail (GEARY_SEARCH_QUERY_IS_EMAIL_TEXT_TERM (text));
#line 292 "../src/engine/common/common-fts-search-query.vala"
	g_return_if_fail (sql != NULL);
#line 294 "../src/engine/common/common-fts-search-query.vala"
	_tmp0_ = g_strdup ("");
#line 294 "../src/engine/common/common-fts-search-query.vala"
	target = _tmp0_;
#line 295 "../src/engine/common/common-fts-search-query.vala"
	_tmp1_ = geary_search_query_email_text_term_get_target (text);
#line 295 "../src/engine/common/common-fts-search-query.vala"
	_tmp2_ = _tmp1_;
#line 295 "../src/engine/common/common-fts-search-query.vala"
	switch (_tmp2_) {
#line 295 "../src/engine/common/common-fts-search-query.vala"
		case GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_PROPERTY_ALL:
#line 1290 "common-fts-search-query.c"
		{
			gchar* _tmp3_;
#line 297 "../src/engine/common/common-fts-search-query.vala"
			_tmp3_ = g_strdup ("");
#line 297 "../src/engine/common/common-fts-search-query.vala"
			_g_free0 (target);
#line 297 "../src/engine/common/common-fts-search-query.vala"
			target = _tmp3_;
#line 298 "../src/engine/common/common-fts-search-query.vala"
			break;
#line 1301 "common-fts-search-query.c"
		}
#line 295 "../src/engine/common/common-fts-search-query.vala"
		case GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_PROPERTY_TO:
#line 1305 "common-fts-search-query.c"
		{
			gchar* _tmp4_;
#line 300 "../src/engine/common/common-fts-search-query.vala"
			_tmp4_ = g_strdup ("receivers");
#line 300 "../src/engine/common/common-fts-search-query.vala"
			_g_free0 (target);
#line 300 "../src/engine/common/common-fts-search-query.vala"
			target = _tmp4_;
#line 301 "../src/engine/common/common-fts-search-query.vala"
			break;
#line 1316 "common-fts-search-query.c"
		}
#line 295 "../src/engine/common/common-fts-search-query.vala"
		case GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_PROPERTY_CC:
#line 1320 "common-fts-search-query.c"
		{
			gchar* _tmp5_;
#line 303 "../src/engine/common/common-fts-search-query.vala"
			_tmp5_ = g_strdup ("cc");
#line 303 "../src/engine/common/common-fts-search-query.vala"
			_g_free0 (target);
#line 303 "../src/engine/common/common-fts-search-query.vala"
			target = _tmp5_;
#line 304 "../src/engine/common/common-fts-search-query.vala"
			break;
#line 1331 "common-fts-search-query.c"
		}
#line 295 "../src/engine/common/common-fts-search-query.vala"
		case GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_PROPERTY_BCC:
#line 1335 "common-fts-search-query.c"
		{
			gchar* _tmp6_;
#line 306 "../src/engine/common/common-fts-search-query.vala"
			_tmp6_ = g_strdup ("bcc");
#line 306 "../src/engine/common/common-fts-search-query.vala"
			_g_free0 (target);
#line 306 "../src/engine/common/common-fts-search-query.vala"
			target = _tmp6_;
#line 307 "../src/engine/common/common-fts-search-query.vala"
			break;
#line 1346 "common-fts-search-query.c"
		}
#line 295 "../src/engine/common/common-fts-search-query.vala"
		case GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_PROPERTY_FROM:
#line 1350 "common-fts-search-query.c"
		{
			gchar* _tmp7_;
#line 309 "../src/engine/common/common-fts-search-query.vala"
			_tmp7_ = g_strdup ("from");
#line 309 "../src/engine/common/common-fts-search-query.vala"
			_g_free0 (target);
#line 309 "../src/engine/common/common-fts-search-query.vala"
			target = _tmp7_;
#line 310 "../src/engine/common/common-fts-search-query.vala"
			break;
#line 1361 "common-fts-search-query.c"
		}
#line 295 "../src/engine/common/common-fts-search-query.vala"
		case GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_PROPERTY_SUBJECT:
#line 1365 "common-fts-search-query.c"
		{
			gchar* _tmp8_;
#line 312 "../src/engine/common/common-fts-search-query.vala"
			_tmp8_ = g_strdup ("subject");
#line 312 "../src/engine/common/common-fts-search-query.vala"
			_g_free0 (target);
#line 312 "../src/engine/common/common-fts-search-query.vala"
			target = _tmp8_;
#line 313 "../src/engine/common/common-fts-search-query.vala"
			break;
#line 1376 "common-fts-search-query.c"
		}
#line 295 "../src/engine/common/common-fts-search-query.vala"
		case GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_PROPERTY_BODY:
#line 1380 "common-fts-search-query.c"
		{
			gchar* _tmp9_;
#line 315 "../src/engine/common/common-fts-search-query.vala"
			_tmp9_ = g_strdup ("body");
#line 315 "../src/engine/common/common-fts-search-query.vala"
			_g_free0 (target);
#line 315 "../src/engine/common/common-fts-search-query.vala"
			target = _tmp9_;
#line 316 "../src/engine/common/common-fts-search-query.vala"
			break;
#line 1391 "common-fts-search-query.c"
		}
#line 295 "../src/engine/common/common-fts-search-query.vala"
		case GEARY_SEARCH_QUERY_EMAIL_TEXT_TERM_PROPERTY_ATTACHMENT_NAME:
#line 1395 "common-fts-search-query.c"
		{
			gchar* _tmp10_;
#line 318 "../src/engine/common/common-fts-search-query.vala"
			_tmp10_ = g_strdup ("attachments");
#line 318 "../src/engine/common/common-fts-search-query.vala"
			_g_free0 (target);
#line 318 "../src/engine/common/common-fts-search-query.vala"
			target = _tmp10_;
#line 319 "../src/engine/common/common-fts-search-query.vala"
			break;
#line 1406 "common-fts-search-query.c"
		}
		default:
#line 295 "../src/engine/common/common-fts-search-query.vala"
		break;
#line 1411 "common-fts-search-query.c"
	}
#line 322 "../src/engine/common/common-fts-search-query.vala"
	g_string_append (sql, " (");
#line 324 "../src/engine/common/common-fts-search-query.vala"
	_tmp11_ = geary_search_query_email_text_term_get_terms (text);
#line 324 "../src/engine/common/common-fts-search-query.vala"
	_tmp12_ = _tmp11_;
#line 324 "../src/engine/common/common-fts-search-query.vala"
	_tmp13_ = _g_object_ref0 (_tmp12_);
#line 324 "../src/engine/common/common-fts-search-query.vala"
	values = _tmp13_;
#line 325 "../src/engine/common/common-fts-search-query.vala"
	_tmp14_ = g_object_get_data (G_TYPE_CHECK_INSTANCE_CAST (text, G_TYPE_OBJECT, GObject), GEARY_FTS_SEARCH_QUERY_EMAIL_TEXT_STEMMED_TERMS);
#line 325 "../src/engine/common/common-fts-search-query.vala"
	_tmp15_ = _g_object_ref0 ((GeeList*) _tmp14_);
#line 325 "../src/engine/common/common-fts-search-query.vala"
	stemmed_values = _tmp15_;
#line 328 "../src/engine/common/common-fts-search-query.vala"
	is_first_disjunct = TRUE;
#line 1431 "common-fts-search-query.c"
	{
		gint i = 0;
#line 329 "../src/engine/common/common-fts-search-query.vala"
		i = 0;
#line 1436 "common-fts-search-query.c"
		{
			gboolean _tmp16_ = FALSE;
#line 329 "../src/engine/common/common-fts-search-query.vala"
			_tmp16_ = TRUE;
#line 329 "../src/engine/common/common-fts-search-query.vala"
			while (TRUE) {
#line 1443 "common-fts-search-query.c"
				GeeList* _tmp18_;
				gint _tmp19_;
				gint _tmp20_;
				const gchar* _tmp21_;
				gboolean _tmp23_ = FALSE;
				GeeList* _tmp24_;
#line 329 "../src/engine/common/common-fts-search-query.vala"
				if (!_tmp16_) {
#line 1452 "common-fts-search-query.c"
					gint _tmp17_;
#line 329 "../src/engine/common/common-fts-search-query.vala"
					_tmp17_ = i;
#line 329 "../src/engine/common/common-fts-search-query.vala"
					i = _tmp17_ + 1;
#line 1458 "common-fts-search-query.c"
				}
#line 329 "../src/engine/common/common-fts-search-query.vala"
				_tmp16_ = FALSE;
#line 329 "../src/engine/common/common-fts-search-query.vala"
				_tmp18_ = values;
#line 329 "../src/engine/common/common-fts-search-query.vala"
				_tmp19_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_COLLECTION, GeeCollection));
#line 329 "../src/engine/common/common-fts-search-query.vala"
				_tmp20_ = _tmp19_;
#line 329 "../src/engine/common/common-fts-search-query.vala"
				if (!(i < _tmp20_)) {
#line 329 "../src/engine/common/common-fts-search-query.vala"
					break;
#line 1472 "common-fts-search-query.c"
				}
#line 330 "../src/engine/common/common-fts-search-query.vala"
				if (!is_first_disjunct) {
#line 331 "../src/engine/common/common-fts-search-query.vala"
					g_string_append (sql, " OR");
#line 1478 "common-fts-search-query.c"
				}
#line 333 "../src/engine/common/common-fts-search-query.vala"
				_tmp21_ = target;
#line 333 "../src/engine/common/common-fts-search-query.vala"
				if (g_strcmp0 (_tmp21_, "") != 0) {
#line 1484 "common-fts-search-query.c"
					const gchar* _tmp22_;
#line 334 "../src/engine/common/common-fts-search-query.vala"
					_tmp22_ = target;
#line 334 "../src/engine/common/common-fts-search-query.vala"
					g_string_append_printf (sql, "{%s} :", _tmp22_);
#line 1490 "common-fts-search-query.c"
				}
#line 336 "../src/engine/common/common-fts-search-query.vala"
				_tmp24_ = stemmed_values;
#line 336 "../src/engine/common/common-fts-search-query.vala"
				if (_tmp24_ != NULL) {
#line 1496 "common-fts-search-query.c"
					GeeList* _tmp25_;
					gpointer _tmp26_;
					gchar* _tmp27_;
#line 336 "../src/engine/common/common-fts-search-query.vala"
					_tmp25_ = stemmed_values;
#line 336 "../src/engine/common/common-fts-search-query.vala"
					_tmp26_ = gee_list_get (_tmp25_, i);
#line 336 "../src/engine/common/common-fts-search-query.vala"
					_tmp27_ = (gchar*) _tmp26_;
#line 336 "../src/engine/common/common-fts-search-query.vala"
					_tmp23_ = _tmp27_ != NULL;
#line 336 "../src/engine/common/common-fts-search-query.vala"
					_g_free0 (_tmp27_);
#line 1510 "common-fts-search-query.c"
				} else {
#line 336 "../src/engine/common/common-fts-search-query.vala"
					_tmp23_ = FALSE;
#line 1514 "common-fts-search-query.c"
				}
#line 336 "../src/engine/common/common-fts-search-query.vala"
				if (_tmp23_) {
#line 338 "../src/engine/common/common-fts-search-query.vala"
					g_string_append (sql, " \"' || ? || '\" OR \"' || ? || '\"*");
#line 1520 "common-fts-search-query.c"
				} else {
					GearySearchQueryStrategy _tmp28_;
					GearySearchQueryStrategy _tmp29_;
#line 339 "../src/engine/common/common-fts-search-query.vala"
					_tmp28_ = geary_search_query_email_text_term_get_matching_strategy (text);
#line 339 "../src/engine/common/common-fts-search-query.vala"
					_tmp29_ = _tmp28_;
#line 339 "../src/engine/common/common-fts-search-query.vala"
					if (_tmp29_ != GEARY_SEARCH_QUERY_STRATEGY_EXACT) {
#line 341 "../src/engine/common/common-fts-search-query.vala"
						g_string_append (sql, " \"' || ? || '\"*");
#line 1532 "common-fts-search-query.c"
					} else {
#line 344 "../src/engine/common/common-fts-search-query.vala"
						g_string_append (sql, " \"' || ? || '\"");
#line 1536 "common-fts-search-query.c"
					}
				}
#line 346 "../src/engine/common/common-fts-search-query.vala"
				is_first_disjunct = FALSE;
#line 1541 "common-fts-search-query.c"
			}
		}
	}
#line 348 "../src/engine/common/common-fts-search-query.vala"
	g_string_append_c (sql, ')');
#line 292 "../src/engine/common/common-fts-search-query.vala"
	_g_object_unref0 (stemmed_values);
#line 292 "../src/engine/common/common-fts-search-query.vala"
	_g_object_unref0 (values);
#line 292 "../src/engine/common/common-fts-search-query.vala"
	_g_free0 (target);
#line 1553 "common-fts-search-query.c"
}

static gint
geary_fts_search_query_sql_bind_term_conditions (GearyFtsSearchQuery* self,
                                                 GearyDbStatement* sql,
                                                 gint index,
                                                 GError** error)
{
	gint next_index = 0;
	GError* _inner_error0_ = NULL;
	gint result;
#line 351 "../src/engine/common/common-fts-search-query.vala"
	g_return_val_if_fail (GEARY_IS_FTS_SEARCH_QUERY (self), 0);
#line 351 "../src/engine/common/common-fts-search-query.vala"
	g_return_val_if_fail (GEARY_DB_IS_STATEMENT (sql), 0);
#line 354 "../src/engine/common/common-fts-search-query.vala"
	next_index = index;
#line 1571 "common-fts-search-query.c"
	{
		GeeList* _term_list = NULL;
		GeeList* _tmp0_;
		GeeList* _tmp1_;
		gint _term_size = 0;
		GeeList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _term_index = 0;
#line 357 "../src/engine/common/common-fts-search-query.vala"
		_tmp0_ = geary_search_query_get_expression (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_SEARCH_QUERY, GearySearchQuery));
#line 357 "../src/engine/common/common-fts-search-query.vala"
		_tmp1_ = _tmp0_;
#line 357 "../src/engine/common/common-fts-search-query.vala"
		_term_list = _tmp1_;
#line 357 "../src/engine/common/common-fts-search-query.vala"
		_tmp2_ = _term_list;
#line 357 "../src/engine/common/common-fts-search-query.vala"
		_tmp3_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection));
#line 357 "../src/engine/common/common-fts-search-query.vala"
		_tmp4_ = _tmp3_;
#line 357 "../src/engine/common/common-fts-search-query.vala"
		_term_size = _tmp4_;
#line 357 "../src/engine/common/common-fts-search-query.vala"
		_term_index = -1;
#line 357 "../src/engine/common/common-fts-search-query.vala"
		while (TRUE) {
#line 1599 "common-fts-search-query.c"
			gint _tmp5_;
			gint _tmp6_;
			GearySearchQueryTerm* term = NULL;
			GeeList* _tmp7_;
			gpointer _tmp8_;
			GearySearchQueryTerm* _tmp9_;
			gboolean _tmp10_;
			gboolean _tmp11_;
#line 357 "../src/engine/common/common-fts-search-query.vala"
			_term_index = _term_index + 1;
#line 357 "../src/engine/common/common-fts-search-query.vala"
			_tmp5_ = _term_index;
#line 357 "../src/engine/common/common-fts-search-query.vala"
			_tmp6_ = _term_size;
#line 357 "../src/engine/common/common-fts-search-query.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 357 "../src/engine/common/common-fts-search-query.vala"
				break;
#line 1618 "common-fts-search-query.c"
			}
#line 357 "../src/engine/common/common-fts-search-query.vala"
			_tmp7_ = _term_list;
#line 357 "../src/engine/common/common-fts-search-query.vala"
			_tmp8_ = gee_list_get (_tmp7_, _term_index);
#line 357 "../src/engine/common/common-fts-search-query.vala"
			term = (GearySearchQueryTerm*) _tmp8_;
#line 358 "../src/engine/common/common-fts-search-query.vala"
			_tmp9_ = term;
#line 358 "../src/engine/common/common-fts-search-query.vala"
			_tmp10_ = geary_search_query_term_get_is_negated (_tmp9_);
#line 358 "../src/engine/common/common-fts-search-query.vala"
			_tmp11_ = _tmp10_;
#line 358 "../src/engine/common/common-fts-search-query.vala"
			if (!_tmp11_) {
#line 1634 "common-fts-search-query.c"
				gint _tmp12_ = 0;
				GearySearchQueryTerm* _tmp13_;
#line 359 "../src/engine/common/common-fts-search-query.vala"
				_tmp13_ = term;
#line 359 "../src/engine/common/common-fts-search-query.vala"
				_tmp12_ = geary_fts_search_query_sql_bind_term_condition (self, sql, _tmp13_, next_index, &_inner_error0_);
#line 359 "../src/engine/common/common-fts-search-query.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 359 "../src/engine/common/common-fts-search-query.vala"
					if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 1645 "common-fts-search-query.c"
						gint _tmp14_ = -1;
#line 359 "../src/engine/common/common-fts-search-query.vala"
						g_propagate_error (error, _inner_error0_);
#line 359 "../src/engine/common/common-fts-search-query.vala"
						_g_object_unref0 (term);
#line 359 "../src/engine/common/common-fts-search-query.vala"
						return _tmp14_;
#line 1653 "common-fts-search-query.c"
					} else {
						gint _tmp15_ = -1;
#line 359 "../src/engine/common/common-fts-search-query.vala"
						_g_object_unref0 (term);
#line 359 "../src/engine/common/common-fts-search-query.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 359 "../src/engine/common/common-fts-search-query.vala"
						g_clear_error (&_inner_error0_);
#line 359 "../src/engine/common/common-fts-search-query.vala"
						return _tmp15_;
#line 1664 "common-fts-search-query.c"
					}
				}
#line 359 "../src/engine/common/common-fts-search-query.vala"
				next_index = _tmp12_;
#line 1669 "common-fts-search-query.c"
			}
#line 357 "../src/engine/common/common-fts-search-query.vala"
			_g_object_unref0 (term);
#line 1673 "common-fts-search-query.c"
		}
	}
	{
		GeeList* _term_list = NULL;
		GeeList* _tmp16_;
		GeeList* _tmp17_;
		gint _term_size = 0;
		GeeList* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		gint _term_index = 0;
#line 362 "../src/engine/common/common-fts-search-query.vala"
		_tmp16_ = geary_search_query_get_expression (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_SEARCH_QUERY, GearySearchQuery));
#line 362 "../src/engine/common/common-fts-search-query.vala"
		_tmp17_ = _tmp16_;
#line 362 "../src/engine/common/common-fts-search-query.vala"
		_term_list = _tmp17_;
#line 362 "../src/engine/common/common-fts-search-query.vala"
		_tmp18_ = _term_list;
#line 362 "../src/engine/common/common-fts-search-query.vala"
		_tmp19_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_COLLECTION, GeeCollection));
#line 362 "../src/engine/common/common-fts-search-query.vala"
		_tmp20_ = _tmp19_;
#line 362 "../src/engine/common/common-fts-search-query.vala"
		_term_size = _tmp20_;
#line 362 "../src/engine/common/common-fts-search-query.vala"
		_term_index = -1;
#line 362 "../src/engine/common/common-fts-search-query.vala"
		while (TRUE) {
#line 1703 "common-fts-search-query.c"
			gint _tmp21_;
			gint _tmp22_;
			GearySearchQueryTerm* term = NULL;
			GeeList* _tmp23_;
			gpointer _tmp24_;
			GearySearchQueryTerm* _tmp25_;
			gboolean _tmp26_;
			gboolean _tmp27_;
#line 362 "../src/engine/common/common-fts-search-query.vala"
			_term_index = _term_index + 1;
#line 362 "../src/engine/common/common-fts-search-query.vala"
			_tmp21_ = _term_index;
#line 362 "../src/engine/common/common-fts-search-query.vala"
			_tmp22_ = _term_size;
#line 362 "../src/engine/common/common-fts-search-query.vala"
			if (!(_tmp21_ < _tmp22_)) {
#line 362 "../src/engine/common/common-fts-search-query.vala"
				break;
#line 1722 "common-fts-search-query.c"
			}
#line 362 "../src/engine/common/common-fts-search-query.vala"
			_tmp23_ = _term_list;
#line 362 "../src/engine/common/common-fts-search-query.vala"
			_tmp24_ = gee_list_get (_tmp23_, _term_index);
#line 362 "../src/engine/common/common-fts-search-query.vala"
			term = (GearySearchQueryTerm*) _tmp24_;
#line 363 "../src/engine/common/common-fts-search-query.vala"
			_tmp25_ = term;
#line 363 "../src/engine/common/common-fts-search-query.vala"
			_tmp26_ = geary_search_query_term_get_is_negated (_tmp25_);
#line 363 "../src/engine/common/common-fts-search-query.vala"
			_tmp27_ = _tmp26_;
#line 363 "../src/engine/common/common-fts-search-query.vala"
			if (_tmp27_) {
#line 1738 "common-fts-search-query.c"
				gint _tmp28_ = 0;
				GearySearchQueryTerm* _tmp29_;
#line 364 "../src/engine/common/common-fts-search-query.vala"
				_tmp29_ = term;
#line 364 "../src/engine/common/common-fts-search-query.vala"
				_tmp28_ = geary_fts_search_query_sql_bind_term_condition (self, sql, _tmp29_, next_index, &_inner_error0_);
#line 364 "../src/engine/common/common-fts-search-query.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 364 "../src/engine/common/common-fts-search-query.vala"
					if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 1749 "common-fts-search-query.c"
						gint _tmp30_ = -1;
#line 364 "../src/engine/common/common-fts-search-query.vala"
						g_propagate_error (error, _inner_error0_);
#line 364 "../src/engine/common/common-fts-search-query.vala"
						_g_object_unref0 (term);
#line 364 "../src/engine/common/common-fts-search-query.vala"
						return _tmp30_;
#line 1757 "common-fts-search-query.c"
					} else {
						gint _tmp31_ = -1;
#line 364 "../src/engine/common/common-fts-search-query.vala"
						_g_object_unref0 (term);
#line 364 "../src/engine/common/common-fts-search-query.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 364 "../src/engine/common/common-fts-search-query.vala"
						g_clear_error (&_inner_error0_);
#line 364 "../src/engine/common/common-fts-search-query.vala"
						return _tmp31_;
#line 1768 "common-fts-search-query.c"
					}
				}
#line 364 "../src/engine/common/common-fts-search-query.vala"
				next_index = _tmp28_;
#line 1773 "common-fts-search-query.c"
			}
#line 362 "../src/engine/common/common-fts-search-query.vala"
			_g_object_unref0 (term);
#line 1777 "common-fts-search-query.c"
		}
	}
#line 367 "../src/engine/common/common-fts-search-query.vala"
	result = next_index;
#line 367 "../src/engine/common/common-fts-search-query.vala"
	return result;
#line 1784 "common-fts-search-query.c"
}

static inline gint
geary_fts_search_query_sql_bind_term_condition (GearyFtsSearchQuery* self,
                                                GearyDbStatement* sql,
                                                GearySearchQueryTerm* term,
                                                gint index,
                                                GError** error)
{
	gint next_index = 0;
	GType type = 0UL;
	GError* _inner_error0_ = NULL;
	gint result;
#line 370 "../src/engine/common/common-fts-search-query.vala"
	g_return_val_if_fail (GEARY_IS_FTS_SEARCH_QUERY (self), 0);
#line 370 "../src/engine/common/common-fts-search-query.vala"
	g_return_val_if_fail (GEARY_DB_IS_STATEMENT (sql), 0);
#line 370 "../src/engine/common/common-fts-search-query.vala"
	g_return_val_if_fail (GEARY_SEARCH_QUERY_IS_TERM (term), 0);
#line 374 "../src/engine/common/common-fts-search-query.vala"
	next_index = index;
#line 375 "../src/engine/common/common-fts-search-query.vala"
	type = G_TYPE_FROM_INSTANCE (G_TYPE_CHECK_INSTANCE_CAST (term, G_TYPE_OBJECT, GObject));
#line 376 "../src/engine/common/common-fts-search-query.vala"
	if (type == GEARY_SEARCH_QUERY_TYPE_EMAIL_TEXT_TERM) {
#line 1810 "common-fts-search-query.c"
		GearySearchQueryEmailTextTerm* text = NULL;
		GearySearchQueryEmailTextTerm* _tmp0_;
		GeeList* stemmed_terms = NULL;
		GearySearchQueryEmailTextTerm* _tmp1_;
		gconstpointer _tmp2_;
		GeeList* _tmp3_;
#line 377 "../src/engine/common/common-fts-search-query.vala"
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (term, GEARY_SEARCH_QUERY_TYPE_EMAIL_TEXT_TERM, GearySearchQueryEmailTextTerm));
#line 377 "../src/engine/common/common-fts-search-query.vala"
		text = _tmp0_;
#line 378 "../src/engine/common/common-fts-search-query.vala"
		_tmp1_ = text;
#line 378 "../src/engine/common/common-fts-search-query.vala"
		_tmp2_ = g_object_get_data (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, G_TYPE_OBJECT, GObject), GEARY_FTS_SEARCH_QUERY_EMAIL_TEXT_STEMMED_TERMS);
#line 378 "../src/engine/common/common-fts-search-query.vala"
		_tmp3_ = _g_object_ref0 ((GeeList*) _tmp2_);
#line 378 "../src/engine/common/common-fts-search-query.vala"
		stemmed_terms = _tmp3_;
#line 1829 "common-fts-search-query.c"
		{
			gint i = 0;
#line 381 "../src/engine/common/common-fts-search-query.vala"
			i = 0;
#line 1834 "common-fts-search-query.c"
			{
				gboolean _tmp4_ = FALSE;
#line 381 "../src/engine/common/common-fts-search-query.vala"
				_tmp4_ = TRUE;
#line 381 "../src/engine/common/common-fts-search-query.vala"
				while (TRUE) {
#line 1841 "common-fts-search-query.c"
					GearySearchQueryEmailTextTerm* _tmp6_;
					GeeList* _tmp7_;
					GeeList* _tmp8_;
					gint _tmp9_;
					gint _tmp10_;
					gint _tmp11_;
					GearySearchQueryEmailTextTerm* _tmp12_;
					GeeList* _tmp13_;
					GeeList* _tmp14_;
					gpointer _tmp15_;
					gchar* _tmp16_;
					GearyDbStatement* _tmp17_;
					GearyDbStatement* _tmp18_;
					gboolean _tmp21_ = FALSE;
					GeeList* _tmp22_;
#line 381 "../src/engine/common/common-fts-search-query.vala"
					if (!_tmp4_) {
#line 1859 "common-fts-search-query.c"
						gint _tmp5_;
#line 381 "../src/engine/common/common-fts-search-query.vala"
						_tmp5_ = i;
#line 381 "../src/engine/common/common-fts-search-query.vala"
						i = _tmp5_ + 1;
#line 1865 "common-fts-search-query.c"
					}
#line 381 "../src/engine/common/common-fts-search-query.vala"
					_tmp4_ = FALSE;
#line 381 "../src/engine/common/common-fts-search-query.vala"
					_tmp6_ = text;
#line 381 "../src/engine/common/common-fts-search-query.vala"
					_tmp7_ = geary_search_query_email_text_term_get_terms (_tmp6_);
#line 381 "../src/engine/common/common-fts-search-query.vala"
					_tmp8_ = _tmp7_;
#line 381 "../src/engine/common/common-fts-search-query.vala"
					_tmp9_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_COLLECTION, GeeCollection));
#line 381 "../src/engine/common/common-fts-search-query.vala"
					_tmp10_ = _tmp9_;
#line 381 "../src/engine/common/common-fts-search-query.vala"
					if (!(i < _tmp10_)) {
#line 381 "../src/engine/common/common-fts-search-query.vala"
						break;
#line 1883 "common-fts-search-query.c"
					}
#line 382 "../src/engine/common/common-fts-search-query.vala"
					_tmp11_ = next_index;
#line 382 "../src/engine/common/common-fts-search-query.vala"
					next_index = _tmp11_ + 1;
#line 382 "../src/engine/common/common-fts-search-query.vala"
					_tmp12_ = text;
#line 382 "../src/engine/common/common-fts-search-query.vala"
					_tmp13_ = geary_search_query_email_text_term_get_terms (_tmp12_);
#line 382 "../src/engine/common/common-fts-search-query.vala"
					_tmp14_ = _tmp13_;
#line 382 "../src/engine/common/common-fts-search-query.vala"
					_tmp15_ = gee_list_get (_tmp14_, i);
#line 382 "../src/engine/common/common-fts-search-query.vala"
					_tmp16_ = (gchar*) _tmp15_;
#line 382 "../src/engine/common/common-fts-search-query.vala"
					_tmp17_ = geary_db_statement_bind_string (sql, _tmp11_, _tmp16_, &_inner_error0_);
#line 382 "../src/engine/common/common-fts-search-query.vala"
					_tmp18_ = _tmp17_;
#line 382 "../src/engine/common/common-fts-search-query.vala"
					_g_object_unref0 (_tmp18_);
#line 382 "../src/engine/common/common-fts-search-query.vala"
					_g_free0 (_tmp16_);
#line 382 "../src/engine/common/common-fts-search-query.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 382 "../src/engine/common/common-fts-search-query.vala"
						if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 1911 "common-fts-search-query.c"
							gint _tmp19_ = -1;
#line 382 "../src/engine/common/common-fts-search-query.vala"
							g_propagate_error (error, _inner_error0_);
#line 382 "../src/engine/common/common-fts-search-query.vala"
							_g_object_unref0 (stemmed_terms);
#line 382 "../src/engine/common/common-fts-search-query.vala"
							_g_object_unref0 (text);
#line 382 "../src/engine/common/common-fts-search-query.vala"
							return _tmp19_;
#line 1921 "common-fts-search-query.c"
						} else {
							gint _tmp20_ = -1;
#line 382 "../src/engine/common/common-fts-search-query.vala"
							_g_object_unref0 (stemmed_terms);
#line 382 "../src/engine/common/common-fts-search-query.vala"
							_g_object_unref0 (text);
#line 382 "../src/engine/common/common-fts-search-query.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 382 "../src/engine/common/common-fts-search-query.vala"
							g_clear_error (&_inner_error0_);
#line 382 "../src/engine/common/common-fts-search-query.vala"
							return _tmp20_;
#line 1934 "common-fts-search-query.c"
						}
					}
#line 383 "../src/engine/common/common-fts-search-query.vala"
					_tmp22_ = stemmed_terms;
#line 383 "../src/engine/common/common-fts-search-query.vala"
					if (_tmp22_ != NULL) {
#line 1941 "common-fts-search-query.c"
						GeeList* _tmp23_;
						gpointer _tmp24_;
						gchar* _tmp25_;
#line 383 "../src/engine/common/common-fts-search-query.vala"
						_tmp23_ = stemmed_terms;
#line 383 "../src/engine/common/common-fts-search-query.vala"
						_tmp24_ = gee_list_get (_tmp23_, i);
#line 383 "../src/engine/common/common-fts-search-query.vala"
						_tmp25_ = (gchar*) _tmp24_;
#line 383 "../src/engine/common/common-fts-search-query.vala"
						_tmp21_ = _tmp25_ != NULL;
#line 383 "../src/engine/common/common-fts-search-query.vala"
						_g_free0 (_tmp25_);
#line 1955 "common-fts-search-query.c"
					} else {
#line 383 "../src/engine/common/common-fts-search-query.vala"
						_tmp21_ = FALSE;
#line 1959 "common-fts-search-query.c"
					}
#line 383 "../src/engine/common/common-fts-search-query.vala"
					if (_tmp21_) {
#line 1963 "common-fts-search-query.c"
						gint _tmp26_;
						GeeList* _tmp27_;
						gpointer _tmp28_;
						gchar* _tmp29_;
						GearyDbStatement* _tmp30_;
						GearyDbStatement* _tmp31_;
#line 384 "../src/engine/common/common-fts-search-query.vala"
						_tmp26_ = next_index;
#line 384 "../src/engine/common/common-fts-search-query.vala"
						next_index = _tmp26_ + 1;
#line 384 "../src/engine/common/common-fts-search-query.vala"
						_tmp27_ = stemmed_terms;
#line 384 "../src/engine/common/common-fts-search-query.vala"
						_tmp28_ = gee_list_get (_tmp27_, i);
#line 384 "../src/engine/common/common-fts-search-query.vala"
						_tmp29_ = (gchar*) _tmp28_;
#line 384 "../src/engine/common/common-fts-search-query.vala"
						_tmp30_ = geary_db_statement_bind_string (sql, _tmp26_, _tmp29_, &_inner_error0_);
#line 384 "../src/engine/common/common-fts-search-query.vala"
						_tmp31_ = _tmp30_;
#line 384 "../src/engine/common/common-fts-search-query.vala"
						_g_object_unref0 (_tmp31_);
#line 384 "../src/engine/common/common-fts-search-query.vala"
						_g_free0 (_tmp29_);
#line 384 "../src/engine/common/common-fts-search-query.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 384 "../src/engine/common/common-fts-search-query.vala"
							if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 1992 "common-fts-search-query.c"
								gint _tmp32_ = -1;
#line 384 "../src/engine/common/common-fts-search-query.vala"
								g_propagate_error (error, _inner_error0_);
#line 384 "../src/engine/common/common-fts-search-query.vala"
								_g_object_unref0 (stemmed_terms);
#line 384 "../src/engine/common/common-fts-search-query.vala"
								_g_object_unref0 (text);
#line 384 "../src/engine/common/common-fts-search-query.vala"
								return _tmp32_;
#line 2002 "common-fts-search-query.c"
							} else {
								gint _tmp33_ = -1;
#line 384 "../src/engine/common/common-fts-search-query.vala"
								_g_object_unref0 (stemmed_terms);
#line 384 "../src/engine/common/common-fts-search-query.vala"
								_g_object_unref0 (text);
#line 384 "../src/engine/common/common-fts-search-query.vala"
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 384 "../src/engine/common/common-fts-search-query.vala"
								g_clear_error (&_inner_error0_);
#line 384 "../src/engine/common/common-fts-search-query.vala"
								return _tmp33_;
#line 2015 "common-fts-search-query.c"
							}
						}
					}
				}
			}
		}
#line 376 "../src/engine/common/common-fts-search-query.vala"
		_g_object_unref0 (stemmed_terms);
#line 376 "../src/engine/common/common-fts-search-query.vala"
		_g_object_unref0 (text);
#line 2026 "common-fts-search-query.c"
	} else {
#line 387 "../src/engine/common/common-fts-search-query.vala"
		if (type == GEARY_SEARCH_QUERY_TYPE_EMAIL_FLAG_TERM) {
#line 2030 "common-fts-search-query.c"
			GearySearchQueryEmailFlagTerm* flag = NULL;
			GearySearchQueryEmailFlagTerm* _tmp34_;
			gint _tmp35_;
			GearySearchQueryEmailFlagTerm* _tmp36_;
			GearyNamedFlag* _tmp37_;
			GearyNamedFlag* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			GearyDbStatement* _tmp41_;
			GearyDbStatement* _tmp42_;
#line 388 "../src/engine/common/common-fts-search-query.vala"
			_tmp34_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (term, GEARY_SEARCH_QUERY_TYPE_EMAIL_FLAG_TERM, GearySearchQueryEmailFlagTerm));
#line 388 "../src/engine/common/common-fts-search-query.vala"
			flag = _tmp34_;
#line 389 "../src/engine/common/common-fts-search-query.vala"
			_tmp35_ = next_index;
#line 389 "../src/engine/common/common-fts-search-query.vala"
			next_index = _tmp35_ + 1;
#line 389 "../src/engine/common/common-fts-search-query.vala"
			_tmp36_ = flag;
#line 389 "../src/engine/common/common-fts-search-query.vala"
			_tmp37_ = geary_search_query_email_flag_term_get_value (_tmp36_);
#line 389 "../src/engine/common/common-fts-search-query.vala"
			_tmp38_ = _tmp37_;
#line 389 "../src/engine/common/common-fts-search-query.vala"
			_tmp39_ = geary_named_flag_serialise (_tmp38_);
#line 389 "../src/engine/common/common-fts-search-query.vala"
			_tmp40_ = _tmp39_;
#line 389 "../src/engine/common/common-fts-search-query.vala"
			_tmp41_ = geary_db_statement_bind_string (sql, _tmp35_, _tmp40_, &_inner_error0_);
#line 389 "../src/engine/common/common-fts-search-query.vala"
			_tmp42_ = _tmp41_;
#line 389 "../src/engine/common/common-fts-search-query.vala"
			_g_object_unref0 (_tmp42_);
#line 389 "../src/engine/common/common-fts-search-query.vala"
			_g_free0 (_tmp40_);
#line 389 "../src/engine/common/common-fts-search-query.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 389 "../src/engine/common/common-fts-search-query.vala"
				if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 2071 "common-fts-search-query.c"
					gint _tmp43_ = -1;
#line 389 "../src/engine/common/common-fts-search-query.vala"
					g_propagate_error (error, _inner_error0_);
#line 389 "../src/engine/common/common-fts-search-query.vala"
					_g_object_unref0 (flag);
#line 389 "../src/engine/common/common-fts-search-query.vala"
					return _tmp43_;
#line 2079 "common-fts-search-query.c"
				} else {
					gint _tmp44_ = -1;
#line 389 "../src/engine/common/common-fts-search-query.vala"
					_g_object_unref0 (flag);
#line 389 "../src/engine/common/common-fts-search-query.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 389 "../src/engine/common/common-fts-search-query.vala"
					g_clear_error (&_inner_error0_);
#line 389 "../src/engine/common/common-fts-search-query.vala"
					return _tmp44_;
#line 2090 "common-fts-search-query.c"
				}
			}
#line 387 "../src/engine/common/common-fts-search-query.vala"
			_g_object_unref0 (flag);
#line 2095 "common-fts-search-query.c"
		}
	}
#line 391 "../src/engine/common/common-fts-search-query.vala"
	result = next_index;
#line 391 "../src/engine/common/common-fts-search-query.vala"
	return result;
#line 2102 "common-fts-search-query.c"
}

static void
geary_fts_search_query_class_init (GearyFtsSearchQueryClass * klass,
                                   gpointer klass_data)
{
#line 12 "../src/engine/common/common-fts-search-query.vala"
	geary_fts_search_query_parent_class = g_type_class_peek_parent (klass);
#line 12 "../src/engine/common/common-fts-search-query.vala"
	g_type_class_adjust_private_offset (klass, &GearyFtsSearchQuery_private_offset);
#line 12 "../src/engine/common/common-fts-search-query.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_fts_search_query_get_property;
#line 12 "../src/engine/common/common-fts-search-query.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_fts_search_query_set_property;
#line 12 "../src/engine/common/common-fts-search-query.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_fts_search_query_finalize;
#line 12 "../src/engine/common/common-fts-search-query.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_FTS_SEARCH_QUERY_HAS_STEMMED_TERMS_PROPERTY, geary_fts_search_query_properties[GEARY_FTS_SEARCH_QUERY_HAS_STEMMED_TERMS_PROPERTY] = g_param_spec_boolean ("has-stemmed-terms", "has-stemmed-terms", "has-stemmed-terms", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2121 "common-fts-search-query.c"
}

static void
geary_fts_search_query_instance_init (GearyFtsSearchQuery * self,
                                      gpointer klass)
{
#line 12 "../src/engine/common/common-fts-search-query.vala"
	self->priv = geary_fts_search_query_get_instance_private (self);
#line 18 "../src/engine/common/common-fts-search-query.vala"
	self->priv->_has_stemmed_terms = FALSE;
#line 20 "../src/engine/common/common-fts-search-query.vala"
	self->priv->is_all_negated = TRUE;
#line 2134 "common-fts-search-query.c"
}

static void
geary_fts_search_query_finalize (GObject * obj)
{
	GearyFtsSearchQuery * self;
#line 12 "../src/engine/common/common-fts-search-query.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_TYPE_FTS_SEARCH_QUERY, GearyFtsSearchQuery);
#line 12 "../src/engine/common/common-fts-search-query.vala"
	G_OBJECT_CLASS (geary_fts_search_query_parent_class)->finalize (obj);
#line 2145 "common-fts-search-query.c"
}

/**
 * A search query implementation that provides full-text search.
 */
 G_GNUC_NO_INLINE static GType
geary_fts_search_query_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyFtsSearchQueryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_fts_search_query_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyFtsSearchQuery), 0, (GInstanceInitFunc) geary_fts_search_query_instance_init, NULL };
	GType geary_fts_search_query_type_id;
	geary_fts_search_query_type_id = g_type_register_static (GEARY_TYPE_SEARCH_QUERY, "GearyFtsSearchQuery", &g_define_type_info, 0);
	GearyFtsSearchQuery_private_offset = g_type_add_instance_private (geary_fts_search_query_type_id, sizeof (GearyFtsSearchQueryPrivate));
	return geary_fts_search_query_type_id;
}

GType
geary_fts_search_query_get_type (void)
{
	static gsize geary_fts_search_query_type_id__once = 0;
	if (g_once_init_enter (&geary_fts_search_query_type_id__once)) {
		GType geary_fts_search_query_type_id;
		geary_fts_search_query_type_id = geary_fts_search_query_get_type_once ();
		g_once_init_leave (&geary_fts_search_query_type_id__once, geary_fts_search_query_type_id);
	}
	return geary_fts_search_query_type_id__once;
}

static void
_vala_geary_fts_search_query_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	GearyFtsSearchQuery * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_FTS_SEARCH_QUERY, GearyFtsSearchQuery);
#line 12 "../src/engine/common/common-fts-search-query.vala"
	switch (property_id) {
#line 12 "../src/engine/common/common-fts-search-query.vala"
		case GEARY_FTS_SEARCH_QUERY_HAS_STEMMED_TERMS_PROPERTY:
#line 12 "../src/engine/common/common-fts-search-query.vala"
		g_value_set_boolean (value, geary_fts_search_query_get_has_stemmed_terms (self));
#line 12 "../src/engine/common/common-fts-search-query.vala"
		break;
#line 2189 "common-fts-search-query.c"
		default:
#line 12 "../src/engine/common/common-fts-search-query.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "../src/engine/common/common-fts-search-query.vala"
		break;
#line 2195 "common-fts-search-query.c"
	}
}

static void
_vala_geary_fts_search_query_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	GearyFtsSearchQuery * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_FTS_SEARCH_QUERY, GearyFtsSearchQuery);
#line 12 "../src/engine/common/common-fts-search-query.vala"
	switch (property_id) {
#line 12 "../src/engine/common/common-fts-search-query.vala"
		case GEARY_FTS_SEARCH_QUERY_HAS_STEMMED_TERMS_PROPERTY:
#line 12 "../src/engine/common/common-fts-search-query.vala"
		geary_fts_search_query_set_has_stemmed_terms (self, g_value_get_boolean (value));
#line 12 "../src/engine/common/common-fts-search-query.vala"
		break;
#line 2215 "common-fts-search-query.c"
		default:
#line 12 "../src/engine/common/common-fts-search-query.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "../src/engine/common/common-fts-search-query.vala"
		break;
#line 2221 "common-fts-search-query.c"
	}
}

