/* db-context.c generated by valac 0.56.17, the Vala compiler
 * generated from db-context.vala, do not modify */

/*
 * Copyright © 2016 Software Freedom Conservancy Inc.
 * Copyright © 2020 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_DB_CONTEXT_0_PROPERTY,
	GEARY_DB_CONTEXT_LOGGING_PARENT_PROPERTY,
	GEARY_DB_CONTEXT_NUM_PROPERTIES
};
static GParamSpec* geary_db_context_properties[GEARY_DB_CONTEXT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

static gpointer geary_db_context_parent_class = NULL;
gboolean geary_db_context_enable_sql_logging = FALSE;
gboolean geary_db_context_enable_result_logging = FALSE;
static GearyLoggingSourceIface * geary_db_context_geary_logging_source_parent_iface = NULL;

VALA_EXTERN GearyDbDatabase* geary_db_context_get_database (GearyDbContext* self);
VALA_EXTERN GearyDbDatabaseConnection* geary_db_context_get_connection (GearyDbContext* self);
VALA_EXTERN GearyDbStatement* geary_db_context_get_statement (GearyDbContext* self);
VALA_EXTERN GearyDbResult* geary_db_context_get_result (GearyDbContext* self);
static GearyDbDatabase* geary_db_context_real_get_database (GearyDbContext* self);
static GearyDbDatabaseConnection* geary_db_context_real_get_connection (GearyDbContext* self);
VALA_EXTERN GearyDbDatabaseConnection* geary_db_statement_get_connection (GearyDbStatement* self);
static GearyDbStatement* geary_db_context_real_get_statement (GearyDbContext* self);
static GearyDbResult* geary_db_context_real_get_result (GearyDbContext* self);
static GearyLoggingState* geary_db_context_real_to_logging_state (GearyDbContext* self);
VALA_EXTERN gint geary_db_throw_on_error (GearyDbContext* ctx,
                              const gchar* method,
                              gint _result_,
                              const gchar* raw,
                              GError** error);
static void geary_db_context_finalize (GObject * obj);
static GType geary_db_context_get_type_once (void);
static void _vala_geary_db_context_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);

static const gchar*
geary_db_context_real_get_logging_domain (GearyLoggingSource* base)
{
	const gchar* result;
	GearyDbContext* self;
#line 41 "../src/engine/db/db-context.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_DB_TYPE_CONTEXT, GearyDbContext);
#line 41 "../src/engine/db/db-context.vala"
	result = GEARY_DB_CONTEXT_LOGGING_DOMAIN;
#line 41 "../src/engine/db/db-context.vala"
	return result;
#line 76 "db-context.c"
}

GearyLoggingSource*
geary_db_context_get_logging_parent (GearyDbContext* self)
{
	GearyDbContextClass* _klass_;
#line 45 "../src/engine/db/db-context.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONTEXT (self), NULL);
#line 45 "../src/engine/db/db-context.vala"
	_klass_ = GEARY_DB_CONTEXT_GET_CLASS (self);
#line 45 "../src/engine/db/db-context.vala"
	if (_klass_->get_logging_parent) {
#line 45 "../src/engine/db/db-context.vala"
		return _klass_->get_logging_parent (self);
#line 91 "db-context.c"
	}
#line 45 "../src/engine/db/db-context.vala"
	return NULL;
#line 95 "db-context.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 49 "../src/engine/db/db-context.vala"
	return self ? g_object_ref (self) : NULL;
#line 103 "db-context.c"
}

static GearyDbDatabase*
geary_db_context_real_get_database (GearyDbContext* self)
{
	GearyDbDatabase* _tmp0_ = NULL;
	GearyDbDatabaseConnection* _tmp1_;
	GearyDbDatabaseConnection* _tmp2_;
	gboolean _tmp3_;
	GearyDbDatabase* _tmp8_;
	GearyDbDatabase* result;
#line 49 "../src/engine/db/db-context.vala"
	_tmp1_ = geary_db_context_get_connection (self);
#line 49 "../src/engine/db/db-context.vala"
	_tmp2_ = _tmp1_;
#line 49 "../src/engine/db/db-context.vala"
	_tmp3_ = _tmp2_ != NULL;
#line 49 "../src/engine/db/db-context.vala"
	_g_object_unref0 (_tmp2_);
#line 49 "../src/engine/db/db-context.vala"
	if (_tmp3_) {
#line 125 "db-context.c"
		GearyDbDatabaseConnection* _tmp4_;
		GearyDbDatabaseConnection* _tmp5_;
		GearyDbDatabase* _tmp6_;
		GearyDbDatabase* _tmp7_;
#line 49 "../src/engine/db/db-context.vala"
		_tmp4_ = geary_db_context_get_connection (self);
#line 49 "../src/engine/db/db-context.vala"
		_tmp5_ = _tmp4_;
#line 49 "../src/engine/db/db-context.vala"
		_tmp6_ = geary_db_connection_get_database (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEARY_DB_TYPE_CONNECTION, GearyDbConnection));
#line 49 "../src/engine/db/db-context.vala"
		_tmp7_ = _tmp6_;
#line 49 "../src/engine/db/db-context.vala"
		_tmp0_ = _tmp7_;
#line 49 "../src/engine/db/db-context.vala"
		_g_object_unref0 (_tmp5_);
#line 142 "db-context.c"
	} else {
#line 49 "../src/engine/db/db-context.vala"
		_tmp0_ = NULL;
#line 146 "db-context.c"
	}
#line 49 "../src/engine/db/db-context.vala"
	_tmp8_ = _g_object_ref0 (_tmp0_);
#line 49 "../src/engine/db/db-context.vala"
	result = _tmp8_;
#line 49 "../src/engine/db/db-context.vala"
	return result;
#line 154 "db-context.c"
}

GearyDbDatabase*
geary_db_context_get_database (GearyDbContext* self)
{
	GearyDbContextClass* _klass_;
#line 48 "../src/engine/db/db-context.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONTEXT (self), NULL);
#line 48 "../src/engine/db/db-context.vala"
	_klass_ = GEARY_DB_CONTEXT_GET_CLASS (self);
#line 48 "../src/engine/db/db-context.vala"
	if (_klass_->get_database) {
#line 48 "../src/engine/db/db-context.vala"
		return _klass_->get_database (self);
#line 169 "db-context.c"
	}
#line 48 "../src/engine/db/db-context.vala"
	return NULL;
#line 173 "db-context.c"
}

static GearyDbDatabaseConnection*
geary_db_context_real_get_connection (GearyDbContext* self)
{
	GearyDbDatabaseConnection* _tmp0_ = NULL;
	GearyDbStatement* _tmp1_;
	GearyDbStatement* _tmp2_;
	gboolean _tmp3_;
	GearyDbDatabaseConnection* _tmp8_;
	GearyDbDatabaseConnection* result;
#line 53 "../src/engine/db/db-context.vala"
	_tmp1_ = geary_db_context_get_statement (self);
#line 53 "../src/engine/db/db-context.vala"
	_tmp2_ = _tmp1_;
#line 53 "../src/engine/db/db-context.vala"
	_tmp3_ = _tmp2_ != NULL;
#line 53 "../src/engine/db/db-context.vala"
	_g_object_unref0 (_tmp2_);
#line 53 "../src/engine/db/db-context.vala"
	if (_tmp3_) {
#line 195 "db-context.c"
		GearyDbStatement* _tmp4_;
		GearyDbStatement* _tmp5_;
		GearyDbDatabaseConnection* _tmp6_;
		GearyDbDatabaseConnection* _tmp7_;
#line 53 "../src/engine/db/db-context.vala"
		_tmp4_ = geary_db_context_get_statement (self);
#line 53 "../src/engine/db/db-context.vala"
		_tmp5_ = _tmp4_;
#line 53 "../src/engine/db/db-context.vala"
		_tmp6_ = geary_db_statement_get_connection (_tmp5_);
#line 53 "../src/engine/db/db-context.vala"
		_tmp7_ = _tmp6_;
#line 53 "../src/engine/db/db-context.vala"
		_tmp0_ = _tmp7_;
#line 53 "../src/engine/db/db-context.vala"
		_g_object_unref0 (_tmp5_);
#line 212 "db-context.c"
	} else {
#line 53 "../src/engine/db/db-context.vala"
		_tmp0_ = NULL;
#line 216 "db-context.c"
	}
#line 53 "../src/engine/db/db-context.vala"
	_tmp8_ = _g_object_ref0 (_tmp0_);
#line 53 "../src/engine/db/db-context.vala"
	result = _tmp8_;
#line 53 "../src/engine/db/db-context.vala"
	return result;
#line 224 "db-context.c"
}

GearyDbDatabaseConnection*
geary_db_context_get_connection (GearyDbContext* self)
{
	GearyDbContextClass* _klass_;
#line 52 "../src/engine/db/db-context.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONTEXT (self), NULL);
#line 52 "../src/engine/db/db-context.vala"
	_klass_ = GEARY_DB_CONTEXT_GET_CLASS (self);
#line 52 "../src/engine/db/db-context.vala"
	if (_klass_->get_connection) {
#line 52 "../src/engine/db/db-context.vala"
		return _klass_->get_connection (self);
#line 239 "db-context.c"
	}
#line 52 "../src/engine/db/db-context.vala"
	return NULL;
#line 243 "db-context.c"
}

static GearyDbStatement*
geary_db_context_real_get_statement (GearyDbContext* self)
{
	GearyDbStatement* _tmp0_ = NULL;
	GearyDbResult* _tmp1_;
	GearyDbResult* _tmp2_;
	gboolean _tmp3_;
	GearyDbStatement* _tmp8_;
	GearyDbStatement* result;
#line 57 "../src/engine/db/db-context.vala"
	_tmp1_ = geary_db_context_get_result (self);
#line 57 "../src/engine/db/db-context.vala"
	_tmp2_ = _tmp1_;
#line 57 "../src/engine/db/db-context.vala"
	_tmp3_ = _tmp2_ != NULL;
#line 57 "../src/engine/db/db-context.vala"
	_g_object_unref0 (_tmp2_);
#line 57 "../src/engine/db/db-context.vala"
	if (_tmp3_) {
#line 265 "db-context.c"
		GearyDbResult* _tmp4_;
		GearyDbResult* _tmp5_;
		GearyDbStatement* _tmp6_;
		GearyDbStatement* _tmp7_;
#line 57 "../src/engine/db/db-context.vala"
		_tmp4_ = geary_db_context_get_result (self);
#line 57 "../src/engine/db/db-context.vala"
		_tmp5_ = _tmp4_;
#line 57 "../src/engine/db/db-context.vala"
		_tmp6_ = geary_db_result_get_statement (_tmp5_);
#line 57 "../src/engine/db/db-context.vala"
		_tmp7_ = _tmp6_;
#line 57 "../src/engine/db/db-context.vala"
		_tmp0_ = _tmp7_;
#line 57 "../src/engine/db/db-context.vala"
		_g_object_unref0 (_tmp5_);
#line 282 "db-context.c"
	} else {
#line 57 "../src/engine/db/db-context.vala"
		_tmp0_ = NULL;
#line 286 "db-context.c"
	}
#line 57 "../src/engine/db/db-context.vala"
	_tmp8_ = _g_object_ref0 (_tmp0_);
#line 57 "../src/engine/db/db-context.vala"
	result = _tmp8_;
#line 57 "../src/engine/db/db-context.vala"
	return result;
#line 294 "db-context.c"
}

GearyDbStatement*
geary_db_context_get_statement (GearyDbContext* self)
{
	GearyDbContextClass* _klass_;
#line 56 "../src/engine/db/db-context.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONTEXT (self), NULL);
#line 56 "../src/engine/db/db-context.vala"
	_klass_ = GEARY_DB_CONTEXT_GET_CLASS (self);
#line 56 "../src/engine/db/db-context.vala"
	if (_klass_->get_statement) {
#line 56 "../src/engine/db/db-context.vala"
		return _klass_->get_statement (self);
#line 309 "db-context.c"
	}
#line 56 "../src/engine/db/db-context.vala"
	return NULL;
#line 313 "db-context.c"
}

static GearyDbResult*
geary_db_context_real_get_result (GearyDbContext* self)
{
	GearyDbResult* result;
#line 61 "../src/engine/db/db-context.vala"
	result = NULL;
#line 61 "../src/engine/db/db-context.vala"
	return result;
#line 324 "db-context.c"
}

GearyDbResult*
geary_db_context_get_result (GearyDbContext* self)
{
	GearyDbContextClass* _klass_;
#line 60 "../src/engine/db/db-context.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONTEXT (self), NULL);
#line 60 "../src/engine/db/db-context.vala"
	_klass_ = GEARY_DB_CONTEXT_GET_CLASS (self);
#line 60 "../src/engine/db/db-context.vala"
	if (_klass_->get_result) {
#line 60 "../src/engine/db/db-context.vala"
		return _klass_->get_result (self);
#line 339 "db-context.c"
	}
#line 60 "../src/engine/db/db-context.vala"
	return NULL;
#line 343 "db-context.c"
}

/** {@inheritDoc} */
static GearyLoggingState*
geary_db_context_real_to_logging_state (GearyDbContext* self)
{
#line 65 "../src/engine/db/db-context.vala"
	g_critical ("Type `%s' does not implement abstract method `geary_db_context_to_logging_state'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 65 "../src/engine/db/db-context.vala"
	return NULL;
#line 354 "db-context.c"
}

GearyLoggingState*
geary_db_context_to_logging_state (GearyDbContext* self)
{
	GearyDbContextClass* _klass_;
#line 65 "../src/engine/db/db-context.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONTEXT (self), NULL);
#line 65 "../src/engine/db/db-context.vala"
	_klass_ = GEARY_DB_CONTEXT_GET_CLASS (self);
#line 65 "../src/engine/db/db-context.vala"
	if (_klass_->to_logging_state) {
#line 65 "../src/engine/db/db-context.vala"
		return _klass_->to_logging_state (self);
#line 369 "db-context.c"
	}
#line 65 "../src/engine/db/db-context.vala"
	return NULL;
#line 373 "db-context.c"
}

inline void
geary_db_context_check_elapsed (GearyDbContext* self,
                                const gchar* message,
                                GTimer* timer,
                                GError** error)
{
	gdouble elapsed = 0.0;
	gdouble threshold = 0.0;
	GearyDbDatabaseConnection* _tmp0_;
	GearyDbDatabaseConnection* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gdouble _tmp4_;
	gboolean _tmp5_ = FALSE;
#line 68 "../src/engine/db/db-context.vala"
	g_return_if_fail (GEARY_DB_IS_CONTEXT (self));
#line 68 "../src/engine/db/db-context.vala"
	g_return_if_fail (message != NULL);
#line 68 "../src/engine/db/db-context.vala"
	g_return_if_fail (timer != NULL);
#line 71 "../src/engine/db/db-context.vala"
	elapsed = g_timer_elapsed (timer, NULL);
#line 72 "../src/engine/db/db-context.vala"
	_tmp0_ = geary_db_context_get_connection (self);
#line 72 "../src/engine/db/db-context.vala"
	_tmp1_ = _tmp0_;
#line 72 "../src/engine/db/db-context.vala"
	_tmp2_ = geary_db_database_connection_get_busy_timeout (_tmp1_);
#line 72 "../src/engine/db/db-context.vala"
	_tmp3_ = _tmp2_;
#line 72 "../src/engine/db/db-context.vala"
	_tmp4_ = (_tmp3_ * 1000.0) / 2.0;
#line 72 "../src/engine/db/db-context.vala"
	_g_object_unref0 (_tmp1_);
#line 72 "../src/engine/db/db-context.vala"
	threshold = _tmp4_;
#line 73 "../src/engine/db/db-context.vala"
	if (threshold > ((gdouble) 0)) {
#line 73 "../src/engine/db/db-context.vala"
		_tmp5_ = elapsed > threshold;
#line 416 "db-context.c"
	} else {
#line 73 "../src/engine/db/db-context.vala"
		_tmp5_ = FALSE;
#line 420 "db-context.c"
	}
#line 73 "../src/engine/db/db-context.vala"
	if (_tmp5_) {
#line 74 "../src/engine/db/db-context.vala"
		geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "%s: elapsed time: %lfs (>50%)", message, elapsed);
#line 426 "db-context.c"
	} else {
#line 75 "../src/engine/db/db-context.vala"
		if (elapsed > 1.0) {
#line 76 "../src/engine/db/db-context.vala"
			geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "%s: elapsed time: %lfs (>1s)", message, elapsed);
#line 432 "db-context.c"
		}
	}
}

inline gint
geary_db_context_throw_on_error (GearyDbContext* self,
                                 const gchar* method,
                                 gint _result_,
                                 const gchar* raw,
                                 GError** error)
{
	gint _tmp0_ = 0;
	GError* _inner_error0_ = NULL;
	gint result;
#line 80 "../src/engine/db/db-context.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONTEXT (self), 0);
#line 81 "../src/engine/db/db-context.vala"
	_tmp0_ = geary_db_throw_on_error (self, method, _result_, raw, &_inner_error0_);
#line 81 "../src/engine/db/db-context.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 81 "../src/engine/db/db-context.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 455 "db-context.c"
			gint _tmp1_ = -1;
#line 81 "../src/engine/db/db-context.vala"
			g_propagate_error (error, _inner_error0_);
#line 81 "../src/engine/db/db-context.vala"
			return _tmp1_;
#line 461 "db-context.c"
		} else {
			gint _tmp2_ = -1;
#line 81 "../src/engine/db/db-context.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 81 "../src/engine/db/db-context.vala"
			g_clear_error (&_inner_error0_);
#line 81 "../src/engine/db/db-context.vala"
			return _tmp2_;
#line 470 "db-context.c"
		}
	}
#line 81 "../src/engine/db/db-context.vala"
	result = _tmp0_;
#line 81 "../src/engine/db/db-context.vala"
	return result;
#line 477 "db-context.c"
}

GearyDbContext*
geary_db_context_construct (GType object_type)
{
	GearyDbContext * self = NULL;
#line 16 "../src/engine/db/db-context.vala"
	self = (GearyDbContext*) geary_base_object_construct (object_type);
#line 16 "../src/engine/db/db-context.vala"
	return self;
#line 488 "db-context.c"
}

static void
geary_db_context_class_init (GearyDbContextClass * klass,
                             gpointer klass_data)
{
#line 16 "../src/engine/db/db-context.vala"
	geary_db_context_parent_class = g_type_class_peek_parent (klass);
#line 16 "../src/engine/db/db-context.vala"
	((GearyDbContextClass *) klass)->get_database = (GearyDbDatabase* (*) (GearyDbContext*)) geary_db_context_real_get_database;
#line 16 "../src/engine/db/db-context.vala"
	((GearyDbContextClass *) klass)->get_connection = (GearyDbDatabaseConnection* (*) (GearyDbContext*)) geary_db_context_real_get_connection;
#line 16 "../src/engine/db/db-context.vala"
	((GearyDbContextClass *) klass)->get_statement = (GearyDbStatement* (*) (GearyDbContext*)) geary_db_context_real_get_statement;
#line 16 "../src/engine/db/db-context.vala"
	((GearyDbContextClass *) klass)->get_result = (GearyDbResult* (*) (GearyDbContext*)) geary_db_context_real_get_result;
#line 16 "../src/engine/db/db-context.vala"
	((GearyDbContextClass *) klass)->to_logging_state = (GearyLoggingState* (*) (GearyDbContext*)) geary_db_context_real_to_logging_state;
#line 16 "../src/engine/db/db-context.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_db_context_get_property;
#line 16 "../src/engine/db/db-context.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_db_context_finalize;
#line 511 "db-context.c"
	/** {@inheritDoc} */
#line 16 "../src/engine/db/db-context.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_DB_CONTEXT_LOGGING_PARENT_PROPERTY, geary_db_context_properties[GEARY_DB_CONTEXT_LOGGING_PARENT_PROPERTY] = g_param_spec_object ("logging-parent", "logging-parent", "logging-parent", GEARY_LOGGING_TYPE_SOURCE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 515 "db-context.c"
}

static void
geary_db_context_geary_logging_source_interface_init (GearyLoggingSourceIface * iface,
                                                      gpointer iface_data)
{
#line 16 "../src/engine/db/db-context.vala"
	geary_db_context_geary_logging_source_parent_iface = g_type_interface_peek_parent (iface);
#line 16 "../src/engine/db/db-context.vala"
	iface->to_logging_state = (GearyLoggingState* (*) (GearyLoggingSource*)) geary_db_context_to_logging_state;
#line 16 "../src/engine/db/db-context.vala"
	iface->get_logging_domain = geary_db_context_real_get_logging_domain;
#line 16 "../src/engine/db/db-context.vala"
	iface->get_logging_parent = (GearyLoggingSource* (*) (GearyLoggingSource*)) geary_db_context_get_logging_parent;
#line 530 "db-context.c"
}

static void
geary_db_context_instance_init (GearyDbContext * self,
                                gpointer klass)
{
}

static void
geary_db_context_finalize (GObject * obj)
{
	GearyDbContext * self;
#line 16 "../src/engine/db/db-context.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_DB_TYPE_CONTEXT, GearyDbContext);
#line 16 "../src/engine/db/db-context.vala"
	G_OBJECT_CLASS (geary_db_context_parent_class)->finalize (obj);
#line 547 "db-context.c"
}

/**
 * Context allows for an inspector or utility function to determine at runtime what Geary.Db
 * objects are available to it.  Primarily designed for logging, but could be used in other
 * circumstances.
 *
 * Geary.Db's major classes (Database, Connection, Statement, and Result) inherit from Context.
 */
 G_GNUC_NO_INLINE static GType
geary_db_context_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyDbContextClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_db_context_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyDbContext), 0, (GInstanceInitFunc) geary_db_context_instance_init, NULL };
	static const GInterfaceInfo geary_logging_source_info = { (GInterfaceInitFunc) geary_db_context_geary_logging_source_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType geary_db_context_type_id;
	geary_db_context_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyDbContext", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	g_type_add_interface_static (geary_db_context_type_id, GEARY_LOGGING_TYPE_SOURCE, &geary_logging_source_info);
	return geary_db_context_type_id;
}

GType
geary_db_context_get_type (void)
{
	static gsize geary_db_context_type_id__once = 0;
	if (g_once_init_enter (&geary_db_context_type_id__once)) {
		GType geary_db_context_type_id;
		geary_db_context_type_id = geary_db_context_get_type_once ();
		g_once_init_leave (&geary_db_context_type_id__once, geary_db_context_type_id);
	}
	return geary_db_context_type_id__once;
}

static void
_vala_geary_db_context_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	GearyDbContext * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_DB_TYPE_CONTEXT, GearyDbContext);
#line 16 "../src/engine/db/db-context.vala"
	switch (property_id) {
#line 590 "db-context.c"
		default:
#line 16 "../src/engine/db/db-context.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 16 "../src/engine/db/db-context.vala"
		break;
#line 596 "db-context.c"
	}
}

