/* db-result.c generated by valac 0.56.17, the Vala compiler
 * generated from db-result.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <sqlite3.h>
#include <float.h>
#include <math.h>
#include <stdarg.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_DB_RESULT_0_PROPERTY,
	GEARY_DB_RESULT_FINISHED_PROPERTY,
	GEARY_DB_RESULT_STATEMENT_PROPERTY,
	GEARY_DB_RESULT_ROW_PROPERTY,
	GEARY_DB_RESULT_LOGGING_PARENT_PROPERTY,
	GEARY_DB_RESULT_NUM_PROPERTIES
};
static GParamSpec* geary_db_result_properties[GEARY_DB_RESULT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GearyDbResultPrivate {
	gboolean _finished;
	GearyDbStatement* _statement;
	guint64 _row;
};

static gint GearyDbResult_private_offset;
static gpointer geary_db_result_parent_class = NULL;

VALA_EXTERN GearyDbResult* geary_db_context_get_result (GearyDbContext* self);
static void geary_db_result_on_query_finished (GearyDbResult* self);
static void _geary_db_result_on_query_finished_geary_db_statement_was_reset (GearyDbStatement* _sender,
                                                                      gpointer self);
static void _geary_db_result_on_query_finished_geary_db_statement_bindings_cleared (GearyDbStatement* _sender,
                                                                             gpointer self);
static void geary_db_result_set_finished (GearyDbResult* self,
                                   gboolean value);
static void geary_db_result_set_statement (GearyDbResult* self,
                                    GearyDbStatement* value);
static void geary_db_result_set_row (GearyDbResult* self,
                              guint64 value);
VALA_EXTERN GearyDbResult* geary_db_result_new (GearyDbStatement* statement,
                                    GCancellable* cancellable,
                                    GError** error);
VALA_EXTERN GearyDbResult* geary_db_result_construct (GType object_type,
                                          GearyDbStatement* statement,
                                          GCancellable* cancellable,
                                          GError** error);
VALA_EXTERN void geary_db_check_cancelled (const gchar* method,
                               GCancellable* cancellable,
                               GError** error);
static inline void geary_db_result_log_result (GearyDbResult* self,
                                 const gchar* fmt,
                                 ...)  G_GNUC_PRINTF(2,3) ;
static void geary_db_result_verify_at (GearyDbResult* self,
                                gint column,
                                GError** error);
static gint geary_db_result_convert_for (GearyDbResult* self,
                                  const gchar* name,
                                  GError** error);
static GearyLoggingState* geary_db_result_real_to_logging_state (GearyDbContext* base);
static GearyDbResult* geary_db_result_real_get_result (GearyDbContext* base);
static void geary_db_result_finalize (GObject * obj);
static GType geary_db_result_get_type_once (void);
static void _vala_geary_db_result_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_geary_db_result_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static inline gpointer
geary_db_result_get_instance_private (GearyDbResult* self)
{
	return G_STRUCT_MEMBER_P (self, GearyDbResult_private_offset);
}

static void
_geary_db_result_on_query_finished_geary_db_statement_was_reset (GearyDbStatement* _sender,
                                                                 gpointer self)
{
#line 32 "../src/engine/db/db-result.vala"
	geary_db_result_on_query_finished ((GearyDbResult*) self);
#line 109 "db-result.c"
}

static void
_geary_db_result_on_query_finished_geary_db_statement_bindings_cleared (GearyDbStatement* _sender,
                                                                        gpointer self)
{
#line 33 "../src/engine/db/db-result.vala"
	geary_db_result_on_query_finished ((GearyDbResult*) self);
#line 118 "db-result.c"
}

gboolean
geary_db_result_get_finished (GearyDbResult* self)
{
	gboolean result;
#line 8 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), FALSE);
#line 8 "../src/engine/db/db-result.vala"
	result = self->priv->_finished;
#line 8 "../src/engine/db/db-result.vala"
	return result;
#line 131 "db-result.c"
}

static void
geary_db_result_set_finished (GearyDbResult* self,
                              gboolean value)
{
	gboolean old_value;
#line 8 "../src/engine/db/db-result.vala"
	g_return_if_fail (GEARY_DB_IS_RESULT (self));
#line 8 "../src/engine/db/db-result.vala"
	old_value = geary_db_result_get_finished (self);
#line 8 "../src/engine/db/db-result.vala"
	if (old_value != value) {
#line 8 "../src/engine/db/db-result.vala"
		self->priv->_finished = value;
#line 8 "../src/engine/db/db-result.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_db_result_properties[GEARY_DB_RESULT_FINISHED_PROPERTY]);
#line 149 "db-result.c"
	}
}

GearyDbStatement*
geary_db_result_get_statement (GearyDbResult* self)
{
	GearyDbStatement* result;
	GearyDbStatement* _tmp0_;
#line 12 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), NULL);
#line 12 "../src/engine/db/db-result.vala"
	_tmp0_ = self->priv->_statement;
#line 12 "../src/engine/db/db-result.vala"
	result = _tmp0_;
#line 12 "../src/engine/db/db-result.vala"
	return result;
#line 166 "db-result.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 12 "../src/engine/db/db-result.vala"
	return self ? g_object_ref (self) : NULL;
#line 174 "db-result.c"
}

static void
geary_db_result_set_statement (GearyDbResult* self,
                               GearyDbStatement* value)
{
	GearyDbStatement* old_value;
#line 12 "../src/engine/db/db-result.vala"
	g_return_if_fail (GEARY_DB_IS_RESULT (self));
#line 12 "../src/engine/db/db-result.vala"
	old_value = geary_db_result_get_statement (self);
#line 12 "../src/engine/db/db-result.vala"
	if (old_value != value) {
#line 188 "db-result.c"
		GearyDbStatement* _tmp0_;
#line 12 "../src/engine/db/db-result.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 12 "../src/engine/db/db-result.vala"
		_g_object_unref0 (self->priv->_statement);
#line 12 "../src/engine/db/db-result.vala"
		self->priv->_statement = _tmp0_;
#line 12 "../src/engine/db/db-result.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_db_result_properties[GEARY_DB_RESULT_STATEMENT_PROPERTY]);
#line 198 "db-result.c"
	}
}

guint64
geary_db_result_get_row (GearyDbResult* self)
{
	guint64 result;
#line 15 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), 0ULL);
#line 15 "../src/engine/db/db-result.vala"
	result = self->priv->_row;
#line 15 "../src/engine/db/db-result.vala"
	return result;
#line 212 "db-result.c"
}

static void
geary_db_result_set_row (GearyDbResult* self,
                         guint64 value)
{
	guint64 old_value;
#line 15 "../src/engine/db/db-result.vala"
	g_return_if_fail (GEARY_DB_IS_RESULT (self));
#line 15 "../src/engine/db/db-result.vala"
	old_value = geary_db_result_get_row (self);
#line 15 "../src/engine/db/db-result.vala"
	if (old_value != value) {
#line 15 "../src/engine/db/db-result.vala"
		self->priv->_row = value;
#line 15 "../src/engine/db/db-result.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_db_result_properties[GEARY_DB_RESULT_ROW_PROPERTY]);
#line 230 "db-result.c"
	}
}

static GearyLoggingSource*
geary_db_result_real_get_logging_parent (GearyDbContext* base)
{
	GearyLoggingSource* result;
	GearyDbResult* self;
	GearyDbStatement* _tmp0_;
#line 19 "../src/engine/db/db-result.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_DB_TYPE_RESULT, GearyDbResult);
#line 19 "../src/engine/db/db-result.vala"
	_tmp0_ = self->priv->_statement;
#line 19 "../src/engine/db/db-result.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource);
#line 19 "../src/engine/db/db-result.vala"
	return result;
#line 248 "db-result.c"
}

GearyDbResult*
geary_db_result_construct (GType object_type,
                           GearyDbStatement* statement,
                           GCancellable* cancellable,
                           GError** error)
{
	GearyDbResult * self = NULL;
	GError* _inner_error0_ = NULL;
#line 23 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_STATEMENT (statement), NULL);
#line 23 "../src/engine/db/db-result.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), NULL);
#line 23 "../src/engine/db/db-result.vala"
	self = (GearyDbResult*) geary_db_context_construct (object_type);
#line 24 "../src/engine/db/db-result.vala"
	geary_db_result_set_statement (self, statement);
#line 25 "../src/engine/db/db-result.vala"
	g_signal_connect_object (statement, "was-reset", (GCallback) _geary_db_result_on_query_finished_geary_db_statement_was_reset, self, 0);
#line 26 "../src/engine/db/db-result.vala"
	g_signal_connect_object (statement, "bindings-cleared", (GCallback) _geary_db_result_on_query_finished_geary_db_statement_bindings_cleared, self, 0);
#line 28 "../src/engine/db/db-result.vala"
	geary_db_result_next (self, cancellable, &_inner_error0_);
#line 28 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 28 "../src/engine/db/db-result.vala"
		g_propagate_error (error, _inner_error0_);
#line 28 "../src/engine/db/db-result.vala"
		_g_object_unref0 (self);
#line 28 "../src/engine/db/db-result.vala"
		return NULL;
#line 281 "db-result.c"
	}
#line 23 "../src/engine/db/db-result.vala"
	return self;
#line 285 "db-result.c"
}

GearyDbResult*
geary_db_result_new (GearyDbStatement* statement,
                     GCancellable* cancellable,
                     GError** error)
{
#line 23 "../src/engine/db/db-result.vala"
	return geary_db_result_construct (GEARY_DB_TYPE_RESULT, statement, cancellable, error);
#line 295 "db-result.c"
}

static void
geary_db_result_on_query_finished (GearyDbResult* self)
{
#line 36 "../src/engine/db/db-result.vala"
	g_return_if_fail (GEARY_DB_IS_RESULT (self));
#line 37 "../src/engine/db/db-result.vala"
	geary_db_result_set_finished (self, TRUE);
#line 305 "db-result.c"
}

/**
     * Returns true if results are waiting, false if finished, or throws a DatabaseError.
     */
gboolean
geary_db_result_next (GearyDbResult* self,
                      GCancellable* cancellable,
                      GError** error)
{
	gboolean _tmp1_;
	gboolean _tmp15_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 43 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), FALSE);
#line 43 "../src/engine/db/db-result.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), FALSE);
#line 44 "../src/engine/db/db-result.vala"
	geary_db_check_cancelled ("Result.next", cancellable, &_inner_error0_);
#line 44 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 328 "db-result.c"
		gboolean _tmp0_ = FALSE;
#line 44 "../src/engine/db/db-result.vala"
		g_propagate_error (error, _inner_error0_);
#line 44 "../src/engine/db/db-result.vala"
		return _tmp0_;
#line 334 "db-result.c"
	}
#line 46 "../src/engine/db/db-result.vala"
	_tmp1_ = self->priv->_finished;
#line 46 "../src/engine/db/db-result.vala"
	if (!_tmp1_) {
#line 340 "db-result.c"
		guint64 _tmp2_;
		GTimer* timer = NULL;
		GTimer* _tmp3_;
		gint _tmp4_ = 0;
		GearyDbStatement* _tmp5_;
		sqlite3_stmt* _tmp6_;
		GearyDbStatement* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		GTimer* _tmp11_;
		const gchar* _tmp13_ = NULL;
		gboolean _tmp14_;
#line 47 "../src/engine/db/db-result.vala"
		_tmp2_ = self->priv->_row;
#line 47 "../src/engine/db/db-result.vala"
		geary_db_result_set_row (self, _tmp2_ + 1);
#line 48 "../src/engine/db/db-result.vala"
		_tmp3_ = g_timer_new ();
#line 48 "../src/engine/db/db-result.vala"
		timer = _tmp3_;
#line 49 "../src/engine/db/db-result.vala"
		_tmp5_ = self->priv->_statement;
#line 49 "../src/engine/db/db-result.vala"
		_tmp6_ = _tmp5_->stmt;
#line 49 "../src/engine/db/db-result.vala"
		_tmp7_ = self->priv->_statement;
#line 49 "../src/engine/db/db-result.vala"
		_tmp8_ = geary_db_statement_get_sql (_tmp7_);
#line 49 "../src/engine/db/db-result.vala"
		_tmp9_ = _tmp8_;
#line 49 "../src/engine/db/db-result.vala"
		_tmp4_ = geary_db_context_throw_on_error (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_DB_TYPE_CONTEXT, GearyDbContext), "Result.next", sqlite3_step (_tmp6_), _tmp9_, &_inner_error0_);
#line 49 "../src/engine/db/db-result.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 375 "db-result.c"
			gboolean _tmp10_ = FALSE;
#line 49 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 49 "../src/engine/db/db-result.vala"
			_g_timer_destroy0 (timer);
#line 49 "../src/engine/db/db-result.vala"
			return _tmp10_;
#line 383 "db-result.c"
		}
#line 49 "../src/engine/db/db-result.vala"
		geary_db_result_set_finished (self, _tmp4_ != SQLITE_ROW);
#line 52 "../src/engine/db/db-result.vala"
		_tmp11_ = timer;
#line 52 "../src/engine/db/db-result.vala"
		geary_db_context_check_elapsed (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_DB_TYPE_CONTEXT, GearyDbContext), "Result.next", _tmp11_, &_inner_error0_);
#line 52 "../src/engine/db/db-result.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 393 "db-result.c"
			gboolean _tmp12_ = FALSE;
#line 52 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 52 "../src/engine/db/db-result.vala"
			_g_timer_destroy0 (timer);
#line 52 "../src/engine/db/db-result.vala"
			return _tmp12_;
#line 401 "db-result.c"
		}
#line 53 "../src/engine/db/db-result.vala"
		_tmp14_ = self->priv->_finished;
#line 53 "../src/engine/db/db-result.vala"
		if (_tmp14_) {
#line 53 "../src/engine/db/db-result.vala"
			_tmp13_ = "NO ROW";
#line 409 "db-result.c"
		} else {
#line 53 "../src/engine/db/db-result.vala"
			_tmp13_ = "ROW";
#line 413 "db-result.c"
		}
#line 53 "../src/engine/db/db-result.vala"
		geary_db_result_log_result (self, "%s", _tmp13_);
#line 46 "../src/engine/db/db-result.vala"
		_g_timer_destroy0 (timer);
#line 419 "db-result.c"
	}
#line 56 "../src/engine/db/db-result.vala"
	_tmp15_ = self->priv->_finished;
#line 56 "../src/engine/db/db-result.vala"
	result = !_tmp15_;
#line 56 "../src/engine/db/db-result.vala"
	return result;
#line 427 "db-result.c"
}

/**
     * column is zero-based.
     */
static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 439 "db-result.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 447 "db-result.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 456 "db-result.c"
	}
}

gboolean
geary_db_result_is_null_at (GearyDbResult* self,
                            gint column,
                            GError** error)
{
	gboolean is_null = FALSE;
	GearyDbStatement* _tmp2_;
	sqlite3_stmt* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 62 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), FALSE);
#line 63 "../src/engine/db/db-result.vala"
	geary_db_result_verify_at (self, column, &_inner_error0_);
#line 63 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 63 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 480 "db-result.c"
			gboolean _tmp0_ = FALSE;
#line 63 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 63 "../src/engine/db/db-result.vala"
			return _tmp0_;
#line 486 "db-result.c"
		} else {
			gboolean _tmp1_ = FALSE;
#line 63 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 63 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 63 "../src/engine/db/db-result.vala"
			return _tmp1_;
#line 495 "db-result.c"
		}
	}
#line 65 "../src/engine/db/db-result.vala"
	_tmp2_ = self->priv->_statement;
#line 65 "../src/engine/db/db-result.vala"
	_tmp3_ = _tmp2_->stmt;
#line 65 "../src/engine/db/db-result.vala"
	is_null = sqlite3_column_type (_tmp3_, column) == SQLITE_NULL;
#line 66 "../src/engine/db/db-result.vala"
	_tmp4_ = bool_to_string (is_null);
#line 66 "../src/engine/db/db-result.vala"
	_tmp5_ = _tmp4_;
#line 66 "../src/engine/db/db-result.vala"
	geary_db_result_log_result (self, "is_null_at(%d) -> %s", column, _tmp5_);
#line 66 "../src/engine/db/db-result.vala"
	_g_free0 (_tmp5_);
#line 68 "../src/engine/db/db-result.vala"
	result = is_null;
#line 68 "../src/engine/db/db-result.vala"
	return result;
#line 516 "db-result.c"
}

/**
     * column is zero-based.
     */
gdouble
geary_db_result_double_at (GearyDbResult* self,
                           gint column,
                           GError** error)
{
	gdouble d = 0.0;
	GearyDbStatement* _tmp2_;
	sqlite3_stmt* _tmp3_;
	GError* _inner_error0_ = NULL;
	gdouble result;
#line 74 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), 0.0);
#line 75 "../src/engine/db/db-result.vala"
	geary_db_result_verify_at (self, column, &_inner_error0_);
#line 75 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 75 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 540 "db-result.c"
			gdouble _tmp0_ = -1.0;
#line 75 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 75 "../src/engine/db/db-result.vala"
			return _tmp0_;
#line 546 "db-result.c"
		} else {
			gdouble _tmp1_ = -1.0;
#line 75 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 75 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 75 "../src/engine/db/db-result.vala"
			return _tmp1_;
#line 555 "db-result.c"
		}
	}
#line 77 "../src/engine/db/db-result.vala"
	_tmp2_ = self->priv->_statement;
#line 77 "../src/engine/db/db-result.vala"
	_tmp3_ = _tmp2_->stmt;
#line 77 "../src/engine/db/db-result.vala"
	d = sqlite3_column_double (_tmp3_, column);
#line 78 "../src/engine/db/db-result.vala"
	geary_db_result_log_result (self, "double_at(%d) -> %lf", column, d);
#line 80 "../src/engine/db/db-result.vala"
	result = d;
#line 80 "../src/engine/db/db-result.vala"
	return result;
#line 570 "db-result.c"
}

/**
     * column is zero-based.
     */
gint
geary_db_result_int_at (GearyDbResult* self,
                        gint column,
                        GError** error)
{
	gint i = 0;
	GearyDbStatement* _tmp2_;
	sqlite3_stmt* _tmp3_;
	GError* _inner_error0_ = NULL;
	gint result;
#line 86 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), 0);
#line 87 "../src/engine/db/db-result.vala"
	geary_db_result_verify_at (self, column, &_inner_error0_);
#line 87 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 87 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 594 "db-result.c"
			gint _tmp0_ = -1;
#line 87 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 87 "../src/engine/db/db-result.vala"
			return _tmp0_;
#line 600 "db-result.c"
		} else {
			gint _tmp1_ = -1;
#line 87 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 87 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 87 "../src/engine/db/db-result.vala"
			return _tmp1_;
#line 609 "db-result.c"
		}
	}
#line 89 "../src/engine/db/db-result.vala"
	_tmp2_ = self->priv->_statement;
#line 89 "../src/engine/db/db-result.vala"
	_tmp3_ = _tmp2_->stmt;
#line 89 "../src/engine/db/db-result.vala"
	i = sqlite3_column_int (_tmp3_, column);
#line 90 "../src/engine/db/db-result.vala"
	geary_db_result_log_result (self, "int_at(%d) -> %d", column, i);
#line 92 "../src/engine/db/db-result.vala"
	result = i;
#line 92 "../src/engine/db/db-result.vala"
	return result;
#line 624 "db-result.c"
}

/**
     * column is zero-based.
     */
guint
geary_db_result_uint_at (GearyDbResult* self,
                         gint column,
                         GError** error)
{
	gint64 _tmp0_ = 0LL;
	GError* _inner_error0_ = NULL;
	guint result;
#line 98 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), 0U);
#line 99 "../src/engine/db/db-result.vala"
	_tmp0_ = geary_db_result_int64_at (self, column, &_inner_error0_);
#line 99 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 99 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 646 "db-result.c"
			guint _tmp1_ = 0U;
#line 99 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 99 "../src/engine/db/db-result.vala"
			return _tmp1_;
#line 652 "db-result.c"
		} else {
			guint _tmp2_ = 0U;
#line 99 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 99 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 99 "../src/engine/db/db-result.vala"
			return _tmp2_;
#line 661 "db-result.c"
		}
	}
#line 99 "../src/engine/db/db-result.vala"
	result = (guint) _tmp0_;
#line 99 "../src/engine/db/db-result.vala"
	return result;
#line 668 "db-result.c"
}

/**
     * column is zero-based.
     */
glong
geary_db_result_long_at (GearyDbResult* self,
                         gint column,
                         GError** error)
{
	gint64 _tmp0_ = 0LL;
	GError* _inner_error0_ = NULL;
	glong result;
#line 105 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), 0L);
#line 106 "../src/engine/db/db-result.vala"
	_tmp0_ = geary_db_result_int64_at (self, column, &_inner_error0_);
#line 106 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 106 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 690 "db-result.c"
			glong _tmp1_ = -1L;
#line 106 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 106 "../src/engine/db/db-result.vala"
			return _tmp1_;
#line 696 "db-result.c"
		} else {
			glong _tmp2_ = -1L;
#line 106 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 106 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 106 "../src/engine/db/db-result.vala"
			return _tmp2_;
#line 705 "db-result.c"
		}
	}
#line 106 "../src/engine/db/db-result.vala"
	result = (glong) _tmp0_;
#line 106 "../src/engine/db/db-result.vala"
	return result;
#line 712 "db-result.c"
}

/**
     * column is zero-based.
     */
gint64
geary_db_result_int64_at (GearyDbResult* self,
                          gint column,
                          GError** error)
{
	gint64 i64 = 0LL;
	GearyDbStatement* _tmp2_;
	sqlite3_stmt* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GError* _inner_error0_ = NULL;
	gint64 result;
#line 112 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), 0LL);
#line 113 "../src/engine/db/db-result.vala"
	geary_db_result_verify_at (self, column, &_inner_error0_);
#line 113 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 113 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 738 "db-result.c"
			gint64 _tmp0_ = -1LL;
#line 113 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 113 "../src/engine/db/db-result.vala"
			return _tmp0_;
#line 744 "db-result.c"
		} else {
			gint64 _tmp1_ = -1LL;
#line 113 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 113 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 113 "../src/engine/db/db-result.vala"
			return _tmp1_;
#line 753 "db-result.c"
		}
	}
#line 115 "../src/engine/db/db-result.vala"
	_tmp2_ = self->priv->_statement;
#line 115 "../src/engine/db/db-result.vala"
	_tmp3_ = _tmp2_->stmt;
#line 115 "../src/engine/db/db-result.vala"
	i64 = sqlite3_column_int64 (_tmp3_, column);
#line 116 "../src/engine/db/db-result.vala"
	_tmp4_ = g_strdup_printf ("%" G_GINT64_FORMAT, i64);
#line 116 "../src/engine/db/db-result.vala"
	_tmp5_ = _tmp4_;
#line 116 "../src/engine/db/db-result.vala"
	geary_db_result_log_result (self, "int64_at(%d) -> %s", column, _tmp5_);
#line 116 "../src/engine/db/db-result.vala"
	_g_free0 (_tmp5_);
#line 118 "../src/engine/db/db-result.vala"
	result = i64;
#line 118 "../src/engine/db/db-result.vala"
	return result;
#line 774 "db-result.c"
}

/**
     * Returns the column value as a bool.  The value is treated as an int and converted into a
     * bool: false == 0, true == !0.
     *
     * column is zero-based.
     */
gboolean
geary_db_result_bool_at (GearyDbResult* self,
                         gint column,
                         GError** error)
{
	gint _tmp0_ = 0;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 127 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), FALSE);
#line 128 "../src/engine/db/db-result.vala"
	_tmp0_ = geary_db_result_int_at (self, column, &_inner_error0_);
#line 128 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 128 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 799 "db-result.c"
			gboolean _tmp1_ = FALSE;
#line 128 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 128 "../src/engine/db/db-result.vala"
			return _tmp1_;
#line 805 "db-result.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 128 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 128 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 128 "../src/engine/db/db-result.vala"
			return _tmp2_;
#line 814 "db-result.c"
		}
	}
#line 128 "../src/engine/db/db-result.vala"
	result = _tmp0_ != 0;
#line 128 "../src/engine/db/db-result.vala"
	return result;
#line 821 "db-result.c"
}

/**
     * column is zero-based.
     *
     * This is merely a front for int64_at().  It's provided to make the caller's code more verbose.
     */
gint64
geary_db_result_rowid_at (GearyDbResult* self,
                          gint column,
                          GError** error)
{
	gint64 _tmp0_ = 0LL;
	GError* _inner_error0_ = NULL;
	gint64 result;
#line 136 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), 0LL);
#line 137 "../src/engine/db/db-result.vala"
	_tmp0_ = geary_db_result_int64_at (self, column, &_inner_error0_);
#line 137 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 137 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 845 "db-result.c"
			gint64 _tmp1_ = -1LL;
#line 137 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 137 "../src/engine/db/db-result.vala"
			return _tmp1_;
#line 851 "db-result.c"
		} else {
			gint64 _tmp2_ = -1LL;
#line 137 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 137 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 137 "../src/engine/db/db-result.vala"
			return _tmp2_;
#line 860 "db-result.c"
		}
	}
#line 137 "../src/engine/db/db-result.vala"
	result = _tmp0_;
#line 137 "../src/engine/db/db-result.vala"
	return result;
#line 867 "db-result.c"
}

/**
     * column is zero-based.
     *
     * Returns a null string if the element is NULL.
     *
     * @see nonnull_string_at
     */
const gchar*
geary_db_result_string_at (GearyDbResult* self,
                           gint column,
                           GError** error)
{
	const gchar* s = NULL;
	GearyDbStatement* _tmp0_;
	sqlite3_stmt* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_;
	const gchar* _tmp6_;
	GError* _inner_error0_ = NULL;
	const gchar* result;
#line 147 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), NULL);
#line 148 "../src/engine/db/db-result.vala"
	geary_db_result_verify_at (self, column, &_inner_error0_);
#line 148 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 148 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 148 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 148 "../src/engine/db/db-result.vala"
			return NULL;
#line 903 "db-result.c"
		} else {
#line 148 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 148 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 148 "../src/engine/db/db-result.vala"
			return NULL;
#line 911 "db-result.c"
		}
	}
#line 150 "../src/engine/db/db-result.vala"
	_tmp0_ = self->priv->_statement;
#line 150 "../src/engine/db/db-result.vala"
	_tmp1_ = _tmp0_->stmt;
#line 150 "../src/engine/db/db-result.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (_tmp1_, column);
#line 150 "../src/engine/db/db-result.vala"
	s = _tmp2_;
#line 151 "../src/engine/db/db-result.vala"
	_tmp4_ = s;
#line 151 "../src/engine/db/db-result.vala"
	if (_tmp4_ != NULL) {
#line 926 "db-result.c"
		const gchar* _tmp5_;
#line 151 "../src/engine/db/db-result.vala"
		_tmp5_ = s;
#line 151 "../src/engine/db/db-result.vala"
		_tmp3_ = _tmp5_;
#line 932 "db-result.c"
	} else {
#line 151 "../src/engine/db/db-result.vala"
		_tmp3_ = "(null)";
#line 936 "db-result.c"
	}
#line 151 "../src/engine/db/db-result.vala"
	geary_db_result_log_result (self, "string_at(%d) -> %s", column, _tmp3_);
#line 153 "../src/engine/db/db-result.vala"
	_tmp6_ = s;
#line 153 "../src/engine/db/db-result.vala"
	result = _tmp6_;
#line 153 "../src/engine/db/db-result.vala"
	return result;
#line 946 "db-result.c"
}

/**
     * column is zero-based.
     *
     * Returns an empty string if the element is NULL.
     *
     * @see string_at
     */
const gchar*
geary_db_result_nonnull_string_at (GearyDbResult* self,
                                   gint column,
                                   GError** error)
{
	const gchar* s = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	GError* _inner_error0_ = NULL;
	const gchar* result;
#line 163 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), NULL);
#line 164 "../src/engine/db/db-result.vala"
	_tmp0_ = geary_db_result_string_at (self, column, &_inner_error0_);
#line 164 "../src/engine/db/db-result.vala"
	s = _tmp0_;
#line 164 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 164 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 164 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 164 "../src/engine/db/db-result.vala"
			return NULL;
#line 980 "db-result.c"
		} else {
#line 164 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 164 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 164 "../src/engine/db/db-result.vala"
			return NULL;
#line 988 "db-result.c"
		}
	}
#line 166 "../src/engine/db/db-result.vala"
	if (s != NULL) {
#line 166 "../src/engine/db/db-result.vala"
		_tmp1_ = s;
#line 995 "db-result.c"
	} else {
#line 166 "../src/engine/db/db-result.vala"
		_tmp1_ = "";
#line 999 "db-result.c"
	}
#line 166 "../src/engine/db/db-result.vala"
	result = _tmp1_;
#line 166 "../src/engine/db/db-result.vala"
	return result;
#line 1005 "db-result.c"
}

/**
     * column is zero-based.
     */
static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 1045 "db-result.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 1051 "db-result.c"
}

GearyMemoryBuffer*
geary_db_result_string_buffer_at (GearyDbResult* self,
                                  gint column,
                                  GError** error)
{
	GearyMemoryGrowableBuffer* buffer = NULL;
	GearyMemoryGrowableBuffer* _tmp0_;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	gint _tmp4_ = 0;
	guint8* _tmp5_;
	gint _tmp5__length1;
	GError* _inner_error0_ = NULL;
	GearyMemoryBuffer* result;
#line 172 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), NULL);
#line 175 "../src/engine/db/db-result.vala"
	_tmp0_ = geary_memory_growable_buffer_new ();
#line 175 "../src/engine/db/db-result.vala"
	buffer = _tmp0_;
#line 176 "../src/engine/db/db-result.vala"
	_tmp2_ = geary_db_result_nonnull_string_at (self, column, &_inner_error0_);
#line 176 "../src/engine/db/db-result.vala"
	_tmp1_ = _tmp2_;
#line 176 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 176 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 176 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 176 "../src/engine/db/db-result.vala"
			_g_object_unref0 (buffer);
#line 176 "../src/engine/db/db-result.vala"
			return NULL;
#line 1090 "db-result.c"
		} else {
#line 176 "../src/engine/db/db-result.vala"
			_g_object_unref0 (buffer);
#line 176 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 176 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 176 "../src/engine/db/db-result.vala"
			return NULL;
#line 1100 "db-result.c"
		}
	}
#line 176 "../src/engine/db/db-result.vala"
	_tmp3_ = string_get_data (_tmp1_, &_tmp4_);
#line 176 "../src/engine/db/db-result.vala"
	_tmp3__length1 = _tmp4_;
#line 176 "../src/engine/db/db-result.vala"
	_tmp5_ = _tmp3_;
#line 176 "../src/engine/db/db-result.vala"
	_tmp5__length1 = _tmp3__length1;
#line 176 "../src/engine/db/db-result.vala"
	geary_memory_growable_buffer_append (buffer, _tmp5_, (gint) _tmp5__length1);
#line 178 "../src/engine/db/db-result.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (buffer, GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBuffer);
#line 178 "../src/engine/db/db-result.vala"
	return result;
#line 1117 "db-result.c"
}

static void
geary_db_result_verify_at (GearyDbResult* self,
                           gint column,
                           GError** error)
{
	gboolean _tmp0_;
	gint count = 0;
	GearyDbStatement* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 181 "../src/engine/db/db-result.vala"
	g_return_if_fail (GEARY_DB_IS_RESULT (self));
#line 182 "../src/engine/db/db-result.vala"
	_tmp0_ = self->priv->_finished;
#line 182 "../src/engine/db/db-result.vala"
	if (_tmp0_) {
#line 1135 "db-result.c"
		GError* _tmp1_;
#line 183 "../src/engine/db/db-result.vala"
		_tmp1_ = g_error_new_literal (GEARY_DATABASE_ERROR, GEARY_DATABASE_ERROR_FINISHED, "Query finished");
#line 183 "../src/engine/db/db-result.vala"
		_inner_error0_ = _tmp1_;
#line 183 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 183 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 183 "../src/engine/db/db-result.vala"
			return;
#line 1147 "db-result.c"
		} else {
#line 183 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 183 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 183 "../src/engine/db/db-result.vala"
			return;
#line 1155 "db-result.c"
		}
	}
#line 185 "../src/engine/db/db-result.vala"
	if (column < 0) {
#line 1160 "db-result.c"
		GError* _tmp2_;
#line 186 "../src/engine/db/db-result.vala"
		_tmp2_ = g_error_new (GEARY_DATABASE_ERROR, GEARY_DATABASE_ERROR_LIMITS, "column %d < 0", column);
#line 186 "../src/engine/db/db-result.vala"
		_inner_error0_ = _tmp2_;
#line 186 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 186 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 186 "../src/engine/db/db-result.vala"
			return;
#line 1172 "db-result.c"
		} else {
#line 186 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 186 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 186 "../src/engine/db/db-result.vala"
			return;
#line 1180 "db-result.c"
		}
	}
#line 188 "../src/engine/db/db-result.vala"
	_tmp3_ = self->priv->_statement;
#line 188 "../src/engine/db/db-result.vala"
	count = geary_db_statement_get_column_count (_tmp3_);
#line 189 "../src/engine/db/db-result.vala"
	if (column >= count) {
#line 1189 "db-result.c"
		GError* _tmp4_;
#line 190 "../src/engine/db/db-result.vala"
		_tmp4_ = g_error_new (GEARY_DATABASE_ERROR, GEARY_DATABASE_ERROR_LIMITS, "column %d >= %d", column, count);
#line 190 "../src/engine/db/db-result.vala"
		_inner_error0_ = _tmp4_;
#line 190 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 190 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 190 "../src/engine/db/db-result.vala"
			return;
#line 1201 "db-result.c"
		} else {
#line 190 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 190 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 190 "../src/engine/db/db-result.vala"
			return;
#line 1209 "db-result.c"
		}
	}
}

/**
     * name is the name of the column in the result set.  See Statement.get_column_index() for name
     * matching rules.
     */
gboolean
geary_db_result_is_null_for (GearyDbResult* self,
                             const gchar* name,
                             GError** error)
{
	gint _tmp0_ = 0;
	gboolean _tmp3_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 197 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), FALSE);
#line 197 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 198 "../src/engine/db/db-result.vala"
	_tmp0_ = geary_db_result_convert_for (self, name, &_inner_error0_);
#line 198 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 198 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 1237 "db-result.c"
			gboolean _tmp1_ = FALSE;
#line 198 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 198 "../src/engine/db/db-result.vala"
			return _tmp1_;
#line 1243 "db-result.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 198 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 198 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 198 "../src/engine/db/db-result.vala"
			return _tmp2_;
#line 1252 "db-result.c"
		}
	}
#line 198 "../src/engine/db/db-result.vala"
	_tmp3_ = geary_db_result_is_null_at (self, _tmp0_, &_inner_error0_);
#line 198 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 198 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 1261 "db-result.c"
			gboolean _tmp4_ = FALSE;
#line 198 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 198 "../src/engine/db/db-result.vala"
			return _tmp4_;
#line 1267 "db-result.c"
		} else {
			gboolean _tmp5_ = FALSE;
#line 198 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 198 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 198 "../src/engine/db/db-result.vala"
			return _tmp5_;
#line 1276 "db-result.c"
		}
	}
#line 198 "../src/engine/db/db-result.vala"
	result = _tmp3_;
#line 198 "../src/engine/db/db-result.vala"
	return result;
#line 1283 "db-result.c"
}

/**
     * name is the name of the column in the result set.  See Statement.get_column_index() for name
     * matching rules.
     */
gdouble
geary_db_result_double_for (GearyDbResult* self,
                            const gchar* name,
                            GError** error)
{
	gint _tmp0_ = 0;
	gdouble _tmp3_ = 0.0;
	GError* _inner_error0_ = NULL;
	gdouble result;
#line 205 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), 0.0);
#line 205 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (name != NULL, 0.0);
#line 206 "../src/engine/db/db-result.vala"
	_tmp0_ = geary_db_result_convert_for (self, name, &_inner_error0_);
#line 206 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 206 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 1309 "db-result.c"
			gdouble _tmp1_ = -1.0;
#line 206 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 206 "../src/engine/db/db-result.vala"
			return _tmp1_;
#line 1315 "db-result.c"
		} else {
			gdouble _tmp2_ = -1.0;
#line 206 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 206 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 206 "../src/engine/db/db-result.vala"
			return _tmp2_;
#line 1324 "db-result.c"
		}
	}
#line 206 "../src/engine/db/db-result.vala"
	_tmp3_ = geary_db_result_double_at (self, _tmp0_, &_inner_error0_);
#line 206 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 206 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 1333 "db-result.c"
			gdouble _tmp4_ = -1.0;
#line 206 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 206 "../src/engine/db/db-result.vala"
			return _tmp4_;
#line 1339 "db-result.c"
		} else {
			gdouble _tmp5_ = -1.0;
#line 206 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 206 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 206 "../src/engine/db/db-result.vala"
			return _tmp5_;
#line 1348 "db-result.c"
		}
	}
#line 206 "../src/engine/db/db-result.vala"
	result = _tmp3_;
#line 206 "../src/engine/db/db-result.vala"
	return result;
#line 1355 "db-result.c"
}

/**
     * name is the name of the column in the result set.  See Statement.get_column_index() for name
     * matching rules.
     */
gint
geary_db_result_int_for (GearyDbResult* self,
                         const gchar* name,
                         GError** error)
{
	gint _tmp0_ = 0;
	gint _tmp3_ = 0;
	GError* _inner_error0_ = NULL;
	gint result;
#line 213 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), 0);
#line 213 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (name != NULL, 0);
#line 214 "../src/engine/db/db-result.vala"
	_tmp0_ = geary_db_result_convert_for (self, name, &_inner_error0_);
#line 214 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 214 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 1381 "db-result.c"
			gint _tmp1_ = -1;
#line 214 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 214 "../src/engine/db/db-result.vala"
			return _tmp1_;
#line 1387 "db-result.c"
		} else {
			gint _tmp2_ = -1;
#line 214 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 214 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 214 "../src/engine/db/db-result.vala"
			return _tmp2_;
#line 1396 "db-result.c"
		}
	}
#line 214 "../src/engine/db/db-result.vala"
	_tmp3_ = geary_db_result_int_at (self, _tmp0_, &_inner_error0_);
#line 214 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 214 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 1405 "db-result.c"
			gint _tmp4_ = -1;
#line 214 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 214 "../src/engine/db/db-result.vala"
			return _tmp4_;
#line 1411 "db-result.c"
		} else {
			gint _tmp5_ = -1;
#line 214 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 214 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 214 "../src/engine/db/db-result.vala"
			return _tmp5_;
#line 1420 "db-result.c"
		}
	}
#line 214 "../src/engine/db/db-result.vala"
	result = _tmp3_;
#line 214 "../src/engine/db/db-result.vala"
	return result;
#line 1427 "db-result.c"
}

/**
     * name is the name of the column in the result set.  See Statement.get_column_index() for name
     * matching rules.
     */
guint
geary_db_result_uint_for (GearyDbResult* self,
                          const gchar* name,
                          GError** error)
{
	gint64 _tmp0_ = 0LL;
	GError* _inner_error0_ = NULL;
	guint result;
#line 221 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), 0U);
#line 221 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (name != NULL, 0U);
#line 222 "../src/engine/db/db-result.vala"
	_tmp0_ = geary_db_result_int64_for (self, name, &_inner_error0_);
#line 222 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 222 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 1452 "db-result.c"
			guint _tmp1_ = 0U;
#line 222 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 222 "../src/engine/db/db-result.vala"
			return _tmp1_;
#line 1458 "db-result.c"
		} else {
			guint _tmp2_ = 0U;
#line 222 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 222 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 222 "../src/engine/db/db-result.vala"
			return _tmp2_;
#line 1467 "db-result.c"
		}
	}
#line 222 "../src/engine/db/db-result.vala"
	result = (guint) _tmp0_;
#line 222 "../src/engine/db/db-result.vala"
	return result;
#line 1474 "db-result.c"
}

/**
     * name is the name of the column in the result set.  See Statement.get_column_index() for name
     * matching rules.
     */
glong
geary_db_result_long_for (GearyDbResult* self,
                          const gchar* name,
                          GError** error)
{
	gint _tmp0_ = 0;
	glong _tmp3_ = 0L;
	GError* _inner_error0_ = NULL;
	glong result;
#line 229 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), 0L);
#line 229 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (name != NULL, 0L);
#line 230 "../src/engine/db/db-result.vala"
	_tmp0_ = geary_db_result_convert_for (self, name, &_inner_error0_);
#line 230 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 230 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 1500 "db-result.c"
			glong _tmp1_ = -1L;
#line 230 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 230 "../src/engine/db/db-result.vala"
			return _tmp1_;
#line 1506 "db-result.c"
		} else {
			glong _tmp2_ = -1L;
#line 230 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 230 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 230 "../src/engine/db/db-result.vala"
			return _tmp2_;
#line 1515 "db-result.c"
		}
	}
#line 230 "../src/engine/db/db-result.vala"
	_tmp3_ = geary_db_result_long_at (self, _tmp0_, &_inner_error0_);
#line 230 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 230 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 1524 "db-result.c"
			glong _tmp4_ = -1L;
#line 230 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 230 "../src/engine/db/db-result.vala"
			return _tmp4_;
#line 1530 "db-result.c"
		} else {
			glong _tmp5_ = -1L;
#line 230 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 230 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 230 "../src/engine/db/db-result.vala"
			return _tmp5_;
#line 1539 "db-result.c"
		}
	}
#line 230 "../src/engine/db/db-result.vala"
	result = _tmp3_;
#line 230 "../src/engine/db/db-result.vala"
	return result;
#line 1546 "db-result.c"
}

/**
     * name is the name of the column in the result set.  See Statement.get_column_index() for name
     * matching rules.
     */
gint64
geary_db_result_int64_for (GearyDbResult* self,
                           const gchar* name,
                           GError** error)
{
	gint _tmp0_ = 0;
	gint64 _tmp3_ = 0LL;
	GError* _inner_error0_ = NULL;
	gint64 result;
#line 237 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), 0LL);
#line 237 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (name != NULL, 0LL);
#line 238 "../src/engine/db/db-result.vala"
	_tmp0_ = geary_db_result_convert_for (self, name, &_inner_error0_);
#line 238 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 238 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 1572 "db-result.c"
			gint64 _tmp1_ = -1LL;
#line 238 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 238 "../src/engine/db/db-result.vala"
			return _tmp1_;
#line 1578 "db-result.c"
		} else {
			gint64 _tmp2_ = -1LL;
#line 238 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 238 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 238 "../src/engine/db/db-result.vala"
			return _tmp2_;
#line 1587 "db-result.c"
		}
	}
#line 238 "../src/engine/db/db-result.vala"
	_tmp3_ = geary_db_result_int64_at (self, _tmp0_, &_inner_error0_);
#line 238 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 238 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 1596 "db-result.c"
			gint64 _tmp4_ = -1LL;
#line 238 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 238 "../src/engine/db/db-result.vala"
			return _tmp4_;
#line 1602 "db-result.c"
		} else {
			gint64 _tmp5_ = -1LL;
#line 238 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 238 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 238 "../src/engine/db/db-result.vala"
			return _tmp5_;
#line 1611 "db-result.c"
		}
	}
#line 238 "../src/engine/db/db-result.vala"
	result = _tmp3_;
#line 238 "../src/engine/db/db-result.vala"
	return result;
#line 1618 "db-result.c"
}

/**
     * name is the name of the column in the result set.  See Statement.get_column_index() for name
     * matching rules.
     *
     * See bool_at() for information on how the column's value is converted to a bool.
     */
gboolean
geary_db_result_bool_for (GearyDbResult* self,
                          const gchar* name,
                          GError** error)
{
	gint _tmp0_ = 0;
	gboolean _tmp3_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 247 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), FALSE);
#line 247 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 248 "../src/engine/db/db-result.vala"
	_tmp0_ = geary_db_result_convert_for (self, name, &_inner_error0_);
#line 248 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 248 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 1646 "db-result.c"
			gboolean _tmp1_ = FALSE;
#line 248 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 248 "../src/engine/db/db-result.vala"
			return _tmp1_;
#line 1652 "db-result.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 248 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 248 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 248 "../src/engine/db/db-result.vala"
			return _tmp2_;
#line 1661 "db-result.c"
		}
	}
#line 248 "../src/engine/db/db-result.vala"
	_tmp3_ = geary_db_result_bool_at (self, _tmp0_, &_inner_error0_);
#line 248 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 248 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 1670 "db-result.c"
			gboolean _tmp4_ = FALSE;
#line 248 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 248 "../src/engine/db/db-result.vala"
			return _tmp4_;
#line 1676 "db-result.c"
		} else {
			gboolean _tmp5_ = FALSE;
#line 248 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 248 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 248 "../src/engine/db/db-result.vala"
			return _tmp5_;
#line 1685 "db-result.c"
		}
	}
#line 248 "../src/engine/db/db-result.vala"
	result = _tmp3_;
#line 248 "../src/engine/db/db-result.vala"
	return result;
#line 1692 "db-result.c"
}

/**
     * name is the name of the column in the result set.  See Statement.get_column_index() for name
     * matching rules.
     *
     * This is merely a front for int64_at().  It's provided to make the caller's code more verbose.
     */
gint64
geary_db_result_rowid_for (GearyDbResult* self,
                           const gchar* name,
                           GError** error)
{
	gint64 _tmp0_ = 0LL;
	GError* _inner_error0_ = NULL;
	gint64 result;
#line 257 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), 0LL);
#line 257 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (name != NULL, 0LL);
#line 258 "../src/engine/db/db-result.vala"
	_tmp0_ = geary_db_result_int64_for (self, name, &_inner_error0_);
#line 258 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 258 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 1719 "db-result.c"
			gint64 _tmp1_ = -1LL;
#line 258 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 258 "../src/engine/db/db-result.vala"
			return _tmp1_;
#line 1725 "db-result.c"
		} else {
			gint64 _tmp2_ = -1LL;
#line 258 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 258 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 258 "../src/engine/db/db-result.vala"
			return _tmp2_;
#line 1734 "db-result.c"
		}
	}
#line 258 "../src/engine/db/db-result.vala"
	result = _tmp0_;
#line 258 "../src/engine/db/db-result.vala"
	return result;
#line 1741 "db-result.c"
}

/**
     * name is the name of the column in the result set.  See Statement.get_column_index() for name
     * matching rules.
     *
     * Returns a null string if the element is NULL.
     *
     * @see nonnull_string_for
     */
const gchar*
geary_db_result_string_for (GearyDbResult* self,
                            const gchar* name,
                            GError** error)
{
	gint _tmp0_ = 0;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
	const gchar* result;
#line 269 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), NULL);
#line 269 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 270 "../src/engine/db/db-result.vala"
	_tmp0_ = geary_db_result_convert_for (self, name, &_inner_error0_);
#line 270 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 270 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 270 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 270 "../src/engine/db/db-result.vala"
			return NULL;
#line 1776 "db-result.c"
		} else {
#line 270 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 270 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 270 "../src/engine/db/db-result.vala"
			return NULL;
#line 1784 "db-result.c"
		}
	}
#line 270 "../src/engine/db/db-result.vala"
	_tmp2_ = geary_db_result_string_at (self, _tmp0_, &_inner_error0_);
#line 270 "../src/engine/db/db-result.vala"
	_tmp1_ = _tmp2_;
#line 270 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 270 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 270 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 270 "../src/engine/db/db-result.vala"
			return NULL;
#line 1799 "db-result.c"
		} else {
#line 270 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 270 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 270 "../src/engine/db/db-result.vala"
			return NULL;
#line 1807 "db-result.c"
		}
	}
#line 270 "../src/engine/db/db-result.vala"
	result = _tmp1_;
#line 270 "../src/engine/db/db-result.vala"
	return result;
#line 1814 "db-result.c"
}

/**
     * name is the name of the column in the result set.  See Statement.get_column_index() for name
     * matching rules.
     *
     * Returns an empty string if the element is NULL.
     *
     * @see string_for
     */
const gchar*
geary_db_result_nonnull_string_for (GearyDbResult* self,
                                    const gchar* name,
                                    GError** error)
{
	gint _tmp0_ = 0;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
	const gchar* result;
#line 281 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), NULL);
#line 281 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 282 "../src/engine/db/db-result.vala"
	_tmp0_ = geary_db_result_convert_for (self, name, &_inner_error0_);
#line 282 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 282 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 282 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 282 "../src/engine/db/db-result.vala"
			return NULL;
#line 1849 "db-result.c"
		} else {
#line 282 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 282 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 282 "../src/engine/db/db-result.vala"
			return NULL;
#line 1857 "db-result.c"
		}
	}
#line 282 "../src/engine/db/db-result.vala"
	_tmp2_ = geary_db_result_nonnull_string_at (self, _tmp0_, &_inner_error0_);
#line 282 "../src/engine/db/db-result.vala"
	_tmp1_ = _tmp2_;
#line 282 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 282 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 282 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 282 "../src/engine/db/db-result.vala"
			return NULL;
#line 1872 "db-result.c"
		} else {
#line 282 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 282 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 282 "../src/engine/db/db-result.vala"
			return NULL;
#line 1880 "db-result.c"
		}
	}
#line 282 "../src/engine/db/db-result.vala"
	result = _tmp1_;
#line 282 "../src/engine/db/db-result.vala"
	return result;
#line 1887 "db-result.c"
}

/**
     * name is the name of the column in the result set.  See Statement.get_column_index() for name
     * matching rules.
     */
GearyMemoryBuffer*
geary_db_result_string_buffer_for (GearyDbResult* self,
                                   const gchar* name,
                                   GError** error)
{
	gint _tmp0_ = 0;
	GearyMemoryBuffer* _tmp1_ = NULL;
	GearyMemoryBuffer* _tmp2_;
	GearyMemoryBuffer* _tmp3_;
	GError* _inner_error0_ = NULL;
	GearyMemoryBuffer* result;
#line 289 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), NULL);
#line 289 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 290 "../src/engine/db/db-result.vala"
	_tmp0_ = geary_db_result_convert_for (self, name, &_inner_error0_);
#line 290 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 290 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 290 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 290 "../src/engine/db/db-result.vala"
			return NULL;
#line 1919 "db-result.c"
		} else {
#line 290 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 290 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 290 "../src/engine/db/db-result.vala"
			return NULL;
#line 1927 "db-result.c"
		}
	}
#line 290 "../src/engine/db/db-result.vala"
	_tmp2_ = geary_db_result_string_buffer_at (self, _tmp0_, &_inner_error0_);
#line 290 "../src/engine/db/db-result.vala"
	_tmp1_ = _tmp2_;
#line 290 "../src/engine/db/db-result.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 290 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 290 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 290 "../src/engine/db/db-result.vala"
			return NULL;
#line 1942 "db-result.c"
		} else {
#line 290 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 290 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 290 "../src/engine/db/db-result.vala"
			return NULL;
#line 1950 "db-result.c"
		}
	}
#line 290 "../src/engine/db/db-result.vala"
	_tmp3_ = _tmp1_;
#line 290 "../src/engine/db/db-result.vala"
	_tmp1_ = NULL;
#line 290 "../src/engine/db/db-result.vala"
	result = _tmp3_;
#line 290 "../src/engine/db/db-result.vala"
	_g_object_unref0 (_tmp1_);
#line 290 "../src/engine/db/db-result.vala"
	return result;
#line 1963 "db-result.c"
}

static gint
geary_db_result_convert_for (GearyDbResult* self,
                             const gchar* name,
                             GError** error)
{
	gboolean _tmp0_;
	gint column = 0;
	GearyDbStatement* _tmp4_;
	GError* _inner_error0_ = NULL;
	gint result;
#line 293 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (self), 0);
#line 293 "../src/engine/db/db-result.vala"
	g_return_val_if_fail (name != NULL, 0);
#line 294 "../src/engine/db/db-result.vala"
	_tmp0_ = self->priv->_finished;
#line 294 "../src/engine/db/db-result.vala"
	if (_tmp0_) {
#line 1984 "db-result.c"
		GError* _tmp1_;
#line 295 "../src/engine/db/db-result.vala"
		_tmp1_ = g_error_new_literal (GEARY_DATABASE_ERROR, GEARY_DATABASE_ERROR_FINISHED, "Query finished");
#line 295 "../src/engine/db/db-result.vala"
		_inner_error0_ = _tmp1_;
#line 295 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 1992 "db-result.c"
			gint _tmp2_ = -1;
#line 295 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 295 "../src/engine/db/db-result.vala"
			return _tmp2_;
#line 1998 "db-result.c"
		} else {
			gint _tmp3_ = -1;
#line 295 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 295 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 295 "../src/engine/db/db-result.vala"
			return _tmp3_;
#line 2007 "db-result.c"
		}
	}
#line 297 "../src/engine/db/db-result.vala"
	_tmp4_ = self->priv->_statement;
#line 297 "../src/engine/db/db-result.vala"
	column = geary_db_statement_get_column_index (_tmp4_, name);
#line 298 "../src/engine/db/db-result.vala"
	if (column < 0) {
#line 2016 "db-result.c"
		GError* _tmp5_;
#line 299 "../src/engine/db/db-result.vala"
		_tmp5_ = g_error_new (GEARY_DATABASE_ERROR, GEARY_DATABASE_ERROR_LIMITS, "column \"%s\" not in result set", name);
#line 299 "../src/engine/db/db-result.vala"
		_inner_error0_ = _tmp5_;
#line 299 "../src/engine/db/db-result.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 2024 "db-result.c"
			gint _tmp6_ = -1;
#line 299 "../src/engine/db/db-result.vala"
			g_propagate_error (error, _inner_error0_);
#line 299 "../src/engine/db/db-result.vala"
			return _tmp6_;
#line 2030 "db-result.c"
		} else {
			gint _tmp7_ = -1;
#line 299 "../src/engine/db/db-result.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 299 "../src/engine/db/db-result.vala"
			g_clear_error (&_inner_error0_);
#line 299 "../src/engine/db/db-result.vala"
			return _tmp7_;
#line 2039 "db-result.c"
		}
	}
#line 301 "../src/engine/db/db-result.vala"
	result = column;
#line 301 "../src/engine/db/db-result.vala"
	return result;
#line 2046 "db-result.c"
}

/** {@inheritDoc} */
static GearyLoggingState*
geary_db_result_real_to_logging_state (GearyDbContext* base)
{
	GearyDbResult * self;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	guint64 _tmp2_;
	GearyLoggingState* _tmp3_;
	GearyLoggingState* result;
#line 305 "../src/engine/db/db-result.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_DB_TYPE_RESULT, GearyDbResult);
#line 310 "../src/engine/db/db-result.vala"
	_tmp1_ = self->priv->_finished;
#line 310 "../src/engine/db/db-result.vala"
	if (_tmp1_) {
#line 310 "../src/engine/db/db-result.vala"
		_tmp0_ = "finished";
#line 2067 "db-result.c"
	} else {
#line 310 "../src/engine/db/db-result.vala"
		_tmp0_ = "!finished";
#line 2071 "db-result.c"
	}
#line 306 "../src/engine/db/db-result.vala"
	_tmp2_ = self->priv->_row;
#line 306 "../src/engine/db/db-result.vala"
	_tmp3_ = geary_logging_state_new (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "%llu, %s", _tmp2_, _tmp0_);
#line 306 "../src/engine/db/db-result.vala"
	result = _tmp3_;
#line 306 "../src/engine/db/db-result.vala"
	return result;
#line 2081 "db-result.c"
}

static GearyDbResult*
geary_db_result_real_get_result (GearyDbContext* base)
{
	GearyDbResult * self;
	GearyDbResult* _tmp0_;
	GearyDbResult* result;
#line 314 "../src/engine/db/db-result.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_DB_TYPE_RESULT, GearyDbResult);
#line 315 "../src/engine/db/db-result.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 315 "../src/engine/db/db-result.vala"
	result = _tmp0_;
#line 315 "../src/engine/db/db-result.vala"
	return result;
#line 2098 "db-result.c"
}

static inline void
geary_db_result_log_result (GearyDbResult* self,
                            const gchar* fmt,
                            ...)
{
#line 319 "../src/engine/db/db-result.vala"
	g_return_if_fail (GEARY_DB_IS_RESULT (self));
#line 319 "../src/engine/db/db-result.vala"
	g_return_if_fail (fmt != NULL);
#line 320 "../src/engine/db/db-result.vala"
	if (geary_db_context_enable_result_logging) {
#line 2112 "db-result.c"
		va_list _tmp0_ = {0};
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 321 "../src/engine/db/db-result.vala"
		va_start (_tmp0_, fmt);
#line 321 "../src/engine/db/db-result.vala"
		_tmp1_ = g_strdup_vprintf (fmt, _tmp0_);
#line 321 "../src/engine/db/db-result.vala"
		_tmp2_ = _tmp1_;
#line 321 "../src/engine/db/db-result.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "%s", _tmp2_);
#line 321 "../src/engine/db/db-result.vala"
		_g_free0 (_tmp2_);
#line 321 "../src/engine/db/db-result.vala"
		va_end (_tmp0_);
#line 2128 "db-result.c"
	}
}

static void
geary_db_result_class_init (GearyDbResultClass * klass,
                            gpointer klass_data)
{
#line 7 "../src/engine/db/db-result.vala"
	geary_db_result_parent_class = g_type_class_peek_parent (klass);
#line 7 "../src/engine/db/db-result.vala"
	g_type_class_adjust_private_offset (klass, &GearyDbResult_private_offset);
#line 7 "../src/engine/db/db-result.vala"
	((GearyDbContextClass *) klass)->to_logging_state = (GearyLoggingState* (*) (GearyDbContext*)) geary_db_result_real_to_logging_state;
#line 7 "../src/engine/db/db-result.vala"
	((GearyDbContextClass *) klass)->get_result = (GearyDbResult* (*) (GearyDbContext*)) geary_db_result_real_get_result;
#line 7 "../src/engine/db/db-result.vala"
	GEARY_DB_CONTEXT_CLASS (klass)->get_logging_parent = (GearyLoggingSource* (*) (GearyDbContext*)) geary_db_result_real_get_logging_parent;
#line 7 "../src/engine/db/db-result.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_db_result_get_property;
#line 7 "../src/engine/db/db-result.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_db_result_set_property;
#line 7 "../src/engine/db/db-result.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_db_result_finalize;
#line 7 "../src/engine/db/db-result.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_DB_RESULT_FINISHED_PROPERTY, geary_db_result_properties[GEARY_DB_RESULT_FINISHED_PROPERTY] = g_param_spec_boolean ("finished", "finished", "finished", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2154 "db-result.c"
	/** The statement this result was generated from. */
#line 7 "../src/engine/db/db-result.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_DB_RESULT_STATEMENT_PROPERTY, geary_db_result_properties[GEARY_DB_RESULT_STATEMENT_PROPERTY] = g_param_spec_object ("statement", "statement", "statement", GEARY_DB_TYPE_STATEMENT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2158 "db-result.c"
	/** The current row represented by this result. */
#line 7 "../src/engine/db/db-result.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_DB_RESULT_ROW_PROPERTY, geary_db_result_properties[GEARY_DB_RESULT_ROW_PROPERTY] = g_param_spec_uint64 ("row", "row", "row", 0, G_MAXUINT64, (guint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2162 "db-result.c"
	/** {@inheritDoc} */
#line 7 "../src/engine/db/db-result.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_DB_RESULT_LOGGING_PARENT_PROPERTY, geary_db_result_properties[GEARY_DB_RESULT_LOGGING_PARENT_PROPERTY] = g_param_spec_object ("logging-parent", "logging-parent", "logging-parent", GEARY_LOGGING_TYPE_SOURCE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2166 "db-result.c"
}

static void
geary_db_result_instance_init (GearyDbResult * self,
                               gpointer klass)
{
#line 7 "../src/engine/db/db-result.vala"
	self->priv = geary_db_result_get_instance_private (self);
#line 8 "../src/engine/db/db-result.vala"
	self->priv->_finished = FALSE;
#line 15 "../src/engine/db/db-result.vala"
	self->priv->_row = (guint64) 0;
#line 2179 "db-result.c"
}

static void
geary_db_result_finalize (GObject * obj)
{
	GearyDbResult * self;
	GearyDbStatement* _tmp0_;
	guint _tmp1_;
	GearyDbStatement* _tmp2_;
	guint _tmp3_;
#line 7 "../src/engine/db/db-result.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_DB_TYPE_RESULT, GearyDbResult);
#line 32 "../src/engine/db/db-result.vala"
	_tmp0_ = self->priv->_statement;
#line 32 "../src/engine/db/db-result.vala"
	g_signal_parse_name ("was-reset", GEARY_DB_TYPE_STATEMENT, &_tmp1_, NULL, FALSE);
#line 32 "../src/engine/db/db-result.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _geary_db_result_on_query_finished_geary_db_statement_was_reset, self);
#line 33 "../src/engine/db/db-result.vala"
	_tmp2_ = self->priv->_statement;
#line 33 "../src/engine/db/db-result.vala"
	g_signal_parse_name ("bindings-cleared", GEARY_DB_TYPE_STATEMENT, &_tmp3_, NULL, FALSE);
#line 33 "../src/engine/db/db-result.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _geary_db_result_on_query_finished_geary_db_statement_bindings_cleared, self);
#line 12 "../src/engine/db/db-result.vala"
	_g_object_unref0 (self->priv->_statement);
#line 7 "../src/engine/db/db-result.vala"
	G_OBJECT_CLASS (geary_db_result_parent_class)->finalize (obj);
#line 2208 "db-result.c"
}

 G_GNUC_NO_INLINE static GType
geary_db_result_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyDbResultClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_db_result_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyDbResult), 0, (GInstanceInitFunc) geary_db_result_instance_init, NULL };
	GType geary_db_result_type_id;
	geary_db_result_type_id = g_type_register_static (GEARY_DB_TYPE_CONTEXT, "GearyDbResult", &g_define_type_info, 0);
	GearyDbResult_private_offset = g_type_add_instance_private (geary_db_result_type_id, sizeof (GearyDbResultPrivate));
	return geary_db_result_type_id;
}

GType
geary_db_result_get_type (void)
{
	static gsize geary_db_result_type_id__once = 0;
	if (g_once_init_enter (&geary_db_result_type_id__once)) {
		GType geary_db_result_type_id;
		geary_db_result_type_id = geary_db_result_get_type_once ();
		g_once_init_leave (&geary_db_result_type_id__once, geary_db_result_type_id);
	}
	return geary_db_result_type_id__once;
}

static void
_vala_geary_db_result_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	GearyDbResult * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_DB_TYPE_RESULT, GearyDbResult);
#line 7 "../src/engine/db/db-result.vala"
	switch (property_id) {
#line 7 "../src/engine/db/db-result.vala"
		case GEARY_DB_RESULT_FINISHED_PROPERTY:
#line 7 "../src/engine/db/db-result.vala"
		g_value_set_boolean (value, geary_db_result_get_finished (self));
#line 7 "../src/engine/db/db-result.vala"
		break;
#line 7 "../src/engine/db/db-result.vala"
		case GEARY_DB_RESULT_STATEMENT_PROPERTY:
#line 7 "../src/engine/db/db-result.vala"
		g_value_set_object (value, geary_db_result_get_statement (self));
#line 7 "../src/engine/db/db-result.vala"
		break;
#line 7 "../src/engine/db/db-result.vala"
		case GEARY_DB_RESULT_ROW_PROPERTY:
#line 7 "../src/engine/db/db-result.vala"
		g_value_set_uint64 (value, geary_db_result_get_row (self));
#line 7 "../src/engine/db/db-result.vala"
		break;
#line 7 "../src/engine/db/db-result.vala"
		case GEARY_DB_RESULT_LOGGING_PARENT_PROPERTY:
#line 7 "../src/engine/db/db-result.vala"
		g_value_set_object (value, geary_db_context_get_logging_parent (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_DB_TYPE_CONTEXT, GearyDbContext)));
#line 7 "../src/engine/db/db-result.vala"
		break;
#line 2267 "db-result.c"
		default:
#line 7 "../src/engine/db/db-result.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/engine/db/db-result.vala"
		break;
#line 2273 "db-result.c"
	}
}

static void
_vala_geary_db_result_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	GearyDbResult * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_DB_TYPE_RESULT, GearyDbResult);
#line 7 "../src/engine/db/db-result.vala"
	switch (property_id) {
#line 7 "../src/engine/db/db-result.vala"
		case GEARY_DB_RESULT_FINISHED_PROPERTY:
#line 7 "../src/engine/db/db-result.vala"
		geary_db_result_set_finished (self, g_value_get_boolean (value));
#line 7 "../src/engine/db/db-result.vala"
		break;
#line 7 "../src/engine/db/db-result.vala"
		case GEARY_DB_RESULT_STATEMENT_PROPERTY:
#line 7 "../src/engine/db/db-result.vala"
		geary_db_result_set_statement (self, g_value_get_object (value));
#line 7 "../src/engine/db/db-result.vala"
		break;
#line 7 "../src/engine/db/db-result.vala"
		case GEARY_DB_RESULT_ROW_PROPERTY:
#line 7 "../src/engine/db/db-result.vala"
		geary_db_result_set_row (self, g_value_get_uint64 (value));
#line 7 "../src/engine/db/db-result.vala"
		break;
#line 2305 "db-result.c"
		default:
#line 7 "../src/engine/db/db-result.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/engine/db/db-result.vala"
		break;
#line 2311 "db-result.c"
	}
}

