/* db-statement.c generated by valac 0.56.17, the Vala compiler
 * generated from db-statement.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <sqlite3.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_DB_STATEMENT_0_PROPERTY,
	GEARY_DB_STATEMENT_SQL_PROPERTY,
	GEARY_DB_STATEMENT_LOGGING_PARENT_PROPERTY,
	GEARY_DB_STATEMENT_CONNECTION_PROPERTY,
	GEARY_DB_STATEMENT_NUM_PROPERTIES
};
static GParamSpec* geary_db_statement_properties[GEARY_DB_STATEMENT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
enum  {
	GEARY_DB_STATEMENT_EXECUTED_SIGNAL,
	GEARY_DB_STATEMENT_WAS_RESET_SIGNAL,
	GEARY_DB_STATEMENT_BINDINGS_CLEARED_SIGNAL,
	GEARY_DB_STATEMENT_NUM_SIGNALS
};
static guint geary_db_statement_signals[GEARY_DB_STATEMENT_NUM_SIGNALS] = {0};

struct _GearyDbStatementPrivate {
	gchar* _sql;
	GearyDbDatabaseConnection* _connection;
	GeeHashMap* column_map;
	GeeHashSet* held_buffers;
};

static gint GearyDbStatement_private_offset;
static gpointer geary_db_statement_parent_class = NULL;

VALA_EXTERN GearyDbStatement* geary_db_context_get_statement (GearyDbContext* self);
static void geary_db_statement_set_sql (GearyDbStatement* self,
                                 const gchar* value);
VALA_EXTERN GearyDbDatabaseConnection* geary_db_statement_get_connection (GearyDbStatement* self);
static void geary_db_statement_set_connection (GearyDbStatement* self,
                                        GearyDbDatabaseConnection* value);
VALA_EXTERN GearyDbStatement* geary_db_statement_new (GearyDbDatabaseConnection* connection,
                                          const gchar* sql,
                                          GError** error);
VALA_EXTERN GearyDbStatement* geary_db_statement_construct (GType object_type,
                                                GearyDbDatabaseConnection* connection,
                                                const gchar* sql,
                                                GError** error);
VALA_EXTERN sqlite3* geary_db_connection_get_db (GearyDbConnection* self);
static guint _geary_string_stri_hash_gee_hash_data_func (gconstpointer v,
                                                  gpointer self);
static gboolean _geary_string_stri_equal_gee_equal_data_func (gconstpointer a,
                                                       gconstpointer b,
                                                       gpointer self);
VALA_EXTERN GearyDbResult* geary_db_result_new (GearyDbStatement* statement,
                                    GCancellable* cancellable,
                                    GError** error);
VALA_EXTERN GearyDbResult* geary_db_result_construct (GType object_type,
                                          GearyDbStatement* statement,
                                          GCancellable* cancellable,
                                          GError** error);
static GearyLoggingState* geary_db_statement_real_to_logging_state (GearyDbContext* base);
static GearyDbStatement* geary_db_statement_real_get_statement (GearyDbContext* base);
static void geary_db_statement_finalize (GObject * obj);
static GType geary_db_statement_get_type_once (void);
static void _vala_geary_db_statement_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_geary_db_statement_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);

static inline gpointer
geary_db_statement_get_instance_private (GearyDbStatement* self)
{
	return G_STRUCT_MEMBER_P (self, GearyDbStatement_private_offset);
}

const gchar*
geary_db_statement_get_sql (GearyDbStatement* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 11 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail (GEARY_DB_IS_STATEMENT (self), NULL);
#line 11 "../src/engine/db/db-statement.vala"
	_tmp0_ = self->priv->_sql;
#line 11 "../src/engine/db/db-statement.vala"
	result = _tmp0_;
#line 11 "../src/engine/db/db-statement.vala"
	return result;
#line 118 "db-statement.c"
}

static void
geary_db_statement_set_sql (GearyDbStatement* self,
                            const gchar* value)
{
	gchar* old_value;
#line 11 "../src/engine/db/db-statement.vala"
	g_return_if_fail (GEARY_DB_IS_STATEMENT (self));
#line 11 "../src/engine/db/db-statement.vala"
	old_value = geary_db_statement_get_sql (self);
#line 11 "../src/engine/db/db-statement.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 132 "db-statement.c"
		gchar* _tmp0_;
#line 11 "../src/engine/db/db-statement.vala"
		_tmp0_ = g_strdup (value);
#line 11 "../src/engine/db/db-statement.vala"
		_g_free0 (self->priv->_sql);
#line 11 "../src/engine/db/db-statement.vala"
		self->priv->_sql = _tmp0_;
#line 11 "../src/engine/db/db-statement.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_db_statement_properties[GEARY_DB_STATEMENT_SQL_PROPERTY]);
#line 142 "db-statement.c"
	}
}

static GearyLoggingSource*
geary_db_statement_real_get_logging_parent (GearyDbContext* base)
{
	GearyLoggingSource* result;
	GearyDbStatement* self;
	GearyDbDatabaseConnection* _tmp0_;
#line 15 "../src/engine/db/db-statement.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_DB_TYPE_STATEMENT, GearyDbStatement);
#line 15 "../src/engine/db/db-statement.vala"
	_tmp0_ = self->priv->_connection;
#line 15 "../src/engine/db/db-statement.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource);
#line 15 "../src/engine/db/db-statement.vala"
	return result;
#line 160 "db-statement.c"
}

GearyDbDatabaseConnection*
geary_db_statement_get_connection (GearyDbStatement* self)
{
	GearyDbDatabaseConnection* result;
	GearyDbDatabaseConnection* _tmp0_;
#line 18 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail (GEARY_DB_IS_STATEMENT (self), NULL);
#line 18 "../src/engine/db/db-statement.vala"
	_tmp0_ = self->priv->_connection;
#line 18 "../src/engine/db/db-statement.vala"
	result = _tmp0_;
#line 18 "../src/engine/db/db-statement.vala"
	return result;
#line 176 "db-statement.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 18 "../src/engine/db/db-statement.vala"
	return self ? g_object_ref (self) : NULL;
#line 184 "db-statement.c"
}

static void
geary_db_statement_set_connection (GearyDbStatement* self,
                                   GearyDbDatabaseConnection* value)
{
	GearyDbDatabaseConnection* old_value;
#line 18 "../src/engine/db/db-statement.vala"
	g_return_if_fail (GEARY_DB_IS_STATEMENT (self));
#line 18 "../src/engine/db/db-statement.vala"
	old_value = geary_db_statement_get_connection (self);
#line 18 "../src/engine/db/db-statement.vala"
	if (old_value != value) {
#line 198 "db-statement.c"
		GearyDbDatabaseConnection* _tmp0_;
#line 18 "../src/engine/db/db-statement.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 18 "../src/engine/db/db-statement.vala"
		_g_object_unref0 (self->priv->_connection);
#line 18 "../src/engine/db/db-statement.vala"
		self->priv->_connection = _tmp0_;
#line 18 "../src/engine/db/db-statement.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_db_statement_properties[GEARY_DB_STATEMENT_CONNECTION_PROPERTY]);
#line 208 "db-statement.c"
	}
}

GearyDbStatement*
geary_db_statement_construct (GType object_type,
                              GearyDbDatabaseConnection* connection,
                              const gchar* sql,
                              GError** error)
{
	GearyDbStatement * self = NULL;
	sqlite3* _tmp0_;
	sqlite3* _tmp1_;
	sqlite3_stmt* _tmp2_ = NULL;
	gint _tmp3_;
	GError* _inner_error0_ = NULL;
#line 42 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail (GEARY_DB_IS_DATABASE_CONNECTION (connection), NULL);
#line 42 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail (sql != NULL, NULL);
#line 42 "../src/engine/db/db-statement.vala"
	self = (GearyDbStatement*) geary_db_context_construct (object_type);
#line 44 "../src/engine/db/db-statement.vala"
	geary_db_statement_set_connection (self, connection);
#line 45 "../src/engine/db/db-statement.vala"
	geary_db_statement_set_sql (self, sql);
#line 46 "../src/engine/db/db-statement.vala"
	_tmp0_ = geary_db_connection_get_db (G_TYPE_CHECK_INSTANCE_CAST (connection, GEARY_DB_TYPE_CONNECTION, GearyDbConnection));
#line 46 "../src/engine/db/db-statement.vala"
	_tmp1_ = _tmp0_;
#line 46 "../src/engine/db/db-statement.vala"
	_tmp3_ = sqlite3_prepare_v2 (_tmp1_, sql, -1, &_tmp2_, NULL);
#line 46 "../src/engine/db/db-statement.vala"
	_sqlite3_finalize0 (self->stmt);
#line 46 "../src/engine/db/db-statement.vala"
	self->stmt = _tmp2_;
#line 46 "../src/engine/db/db-statement.vala"
	geary_db_context_throw_on_error (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_DB_TYPE_CONTEXT, GearyDbContext), "Statement.ctor", _tmp3_, NULL, &_inner_error0_);
#line 46 "../src/engine/db/db-statement.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 46 "../src/engine/db/db-statement.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 46 "../src/engine/db/db-statement.vala"
			g_propagate_error (error, _inner_error0_);
#line 46 "../src/engine/db/db-statement.vala"
			_g_object_unref0 (self);
#line 46 "../src/engine/db/db-statement.vala"
			return NULL;
#line 256 "db-statement.c"
		} else {
#line 46 "../src/engine/db/db-statement.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 46 "../src/engine/db/db-statement.vala"
			g_clear_error (&_inner_error0_);
#line 46 "../src/engine/db/db-statement.vala"
			return NULL;
#line 264 "db-statement.c"
		}
	}
#line 42 "../src/engine/db/db-statement.vala"
	return self;
#line 269 "db-statement.c"
}

GearyDbStatement*
geary_db_statement_new (GearyDbDatabaseConnection* connection,
                        const gchar* sql,
                        GError** error)
{
#line 42 "../src/engine/db/db-statement.vala"
	return geary_db_statement_construct (GEARY_DB_TYPE_STATEMENT, connection, sql, error);
#line 279 "db-statement.c"
}

/** Returns SQL for the statement with bound parameters expanded. */
static gchar*
vala_sqlite3_expanded_sql (sqlite3_stmt* self)
{
	const gchar* sqlite = NULL;
	gchar* _tmp0_;
	gchar* sql = NULL;
	gchar* _tmp1_;
	gchar* result;
#line 408 "sqlite3.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 409 "sqlite3.vapi"
	_tmp0_ = sqlite3_expanded_sql (self);
#line 409 "sqlite3.vapi"
	sqlite = _tmp0_;
#line 410 "sqlite3.vapi"
	_tmp1_ = g_strdup ((gchar*) sqlite);
#line 410 "sqlite3.vapi"
	sql = _tmp1_;
#line 411 "sqlite3.vapi"
	sqlite3_free ((void*) sqlite);
#line 412 "sqlite3.vapi"
	result = sql;
#line 412 "sqlite3.vapi"
	return result;
#line 307 "db-statement.c"
}

gchar*
geary_db_statement_get_expanded_sql (GearyDbStatement* self)
{
	gchar* _tmp0_ = NULL;
	sqlite3_stmt* _tmp1_;
	gchar* result;
#line 53 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail (GEARY_DB_IS_STATEMENT (self), NULL);
#line 56 "../src/engine/db/db-statement.vala"
	_tmp1_ = self->stmt;
#line 56 "../src/engine/db/db-statement.vala"
	if (_tmp1_ != NULL) {
#line 322 "db-statement.c"
		sqlite3_stmt* _tmp2_;
		gchar* _tmp3_;
#line 56 "../src/engine/db/db-statement.vala"
		_tmp2_ = self->stmt;
#line 56 "../src/engine/db/db-statement.vala"
		_tmp3_ = vala_sqlite3_expanded_sql (_tmp2_);
#line 56 "../src/engine/db/db-statement.vala"
		_g_free0 (_tmp0_);
#line 56 "../src/engine/db/db-statement.vala"
		_tmp0_ = _tmp3_;
#line 333 "db-statement.c"
	} else {
#line 56 "../src/engine/db/db-statement.vala"
		_g_free0 (_tmp0_);
#line 56 "../src/engine/db/db-statement.vala"
		_tmp0_ = NULL;
#line 339 "db-statement.c"
	}
#line 56 "../src/engine/db/db-statement.vala"
	result = _tmp0_;
#line 56 "../src/engine/db/db-statement.vala"
	return result;
#line 345 "db-statement.c"
}

/**
     * Reset the Statement for reuse, optionally clearing all bindings as well.  If bindings are
     * not cleared, valued bound previously will be maintained.
     *
     * See http://www.sqlite.org/c3ref/reset.html and http://www.sqlite.org/c3ref/clear_bindings.html
     */
GearyDbStatement*
geary_db_statement_reset (GearyDbStatement* self,
                          GearyDbResetScope reset_scope,
                          GError** error)
{
	sqlite3_stmt* _tmp1_;
	GearyDbStatement* _tmp2_;
	GError* _inner_error0_ = NULL;
	GearyDbStatement* result;
#line 65 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail (GEARY_DB_IS_STATEMENT (self), NULL);
#line 66 "../src/engine/db/db-statement.vala"
	if (reset_scope == GEARY_DB_RESET_SCOPE_CLEAR_BINDINGS) {
#line 367 "db-statement.c"
		sqlite3_stmt* _tmp0_;
#line 67 "../src/engine/db/db-statement.vala"
		_tmp0_ = self->stmt;
#line 67 "../src/engine/db/db-statement.vala"
		geary_db_context_throw_on_error (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_DB_TYPE_CONTEXT, GearyDbContext), "Statement.clear_bindings", sqlite3_clear_bindings (_tmp0_), NULL, &_inner_error0_);
#line 67 "../src/engine/db/db-statement.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 67 "../src/engine/db/db-statement.vala"
			if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 67 "../src/engine/db/db-statement.vala"
				g_propagate_error (error, _inner_error0_);
#line 67 "../src/engine/db/db-statement.vala"
				return NULL;
#line 381 "db-statement.c"
			} else {
#line 67 "../src/engine/db/db-statement.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 67 "../src/engine/db/db-statement.vala"
				g_clear_error (&_inner_error0_);
#line 67 "../src/engine/db/db-statement.vala"
				return NULL;
#line 389 "db-statement.c"
			}
		}
	}
#line 69 "../src/engine/db/db-statement.vala"
	_tmp1_ = self->stmt;
#line 69 "../src/engine/db/db-statement.vala"
	geary_db_context_throw_on_error (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_DB_TYPE_CONTEXT, GearyDbContext), "Statement.reset", sqlite3_reset (_tmp1_), NULL, &_inner_error0_);
#line 69 "../src/engine/db/db-statement.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 69 "../src/engine/db/db-statement.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 69 "../src/engine/db/db-statement.vala"
			g_propagate_error (error, _inner_error0_);
#line 69 "../src/engine/db/db-statement.vala"
			return NULL;
#line 405 "db-statement.c"
		} else {
#line 69 "../src/engine/db/db-statement.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 69 "../src/engine/db/db-statement.vala"
			g_clear_error (&_inner_error0_);
#line 69 "../src/engine/db/db-statement.vala"
			return NULL;
#line 413 "db-statement.c"
		}
	}
#line 73 "../src/engine/db/db-statement.vala"
	if (reset_scope == GEARY_DB_RESET_SCOPE_CLEAR_BINDINGS) {
#line 74 "../src/engine/db/db-statement.vala"
		g_signal_emit (self, geary_db_statement_signals[GEARY_DB_STATEMENT_BINDINGS_CLEARED_SIGNAL], 0);
#line 420 "db-statement.c"
	}
#line 76 "../src/engine/db/db-statement.vala"
	g_signal_emit (self, geary_db_statement_signals[GEARY_DB_STATEMENT_WAS_RESET_SIGNAL], 0);
#line 78 "../src/engine/db/db-statement.vala"
	_tmp2_ = _g_object_ref0 (self);
#line 78 "../src/engine/db/db-statement.vala"
	result = _tmp2_;
#line 78 "../src/engine/db/db-statement.vala"
	return result;
#line 430 "db-statement.c"
}

/**
     * Returns the number of columns the Statement will return in a Result.
     */
gint
geary_db_statement_get_column_count (GearyDbStatement* self)
{
	sqlite3_stmt* _tmp0_;
	gint result;
#line 84 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail (GEARY_DB_IS_STATEMENT (self), 0);
#line 85 "../src/engine/db/db-statement.vala"
	_tmp0_ = self->stmt;
#line 85 "../src/engine/db/db-statement.vala"
	result = sqlite3_column_count (_tmp0_);
#line 85 "../src/engine/db/db-statement.vala"
	return result;
#line 449 "db-statement.c"
}

/**
     * Returns the column name for column at the zero-based index.
     *
     * The name may be used with Result.int_for() (and other *_for() variants).
     */
const gchar*
geary_db_statement_get_column_name (GearyDbStatement* self,
                                    gint index)
{
	sqlite3_stmt* _tmp0_;
	const gchar* _tmp1_;
	const gchar* result;
#line 93 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail (GEARY_DB_IS_STATEMENT (self), NULL);
#line 94 "../src/engine/db/db-statement.vala"
	_tmp0_ = self->stmt;
#line 94 "../src/engine/db/db-statement.vala"
	_tmp1_ = sqlite3_column_name (_tmp0_, index);
#line 94 "../src/engine/db/db-statement.vala"
	result = _tmp1_;
#line 94 "../src/engine/db/db-statement.vala"
	return result;
#line 474 "db-statement.c"
}

/**
     * Returns the zero-based column index matching the column name.  Column names are
     * case-insensitive.
     *
     * Returns -1 if column name is unknown.
     */
static guint
_geary_string_stri_hash_gee_hash_data_func (gconstpointer v,
                                            gpointer self)
{
	guint result;
	result = geary_string_stri_hash ((const gchar*) v);
#line 106 "../src/engine/db/db-statement.vala"
	return result;
#line 491 "db-statement.c"
}

static gboolean
_geary_string_stri_equal_gee_equal_data_func (gconstpointer a,
                                              gconstpointer b,
                                              gpointer self)
{
	gboolean result;
	result = geary_string_stri_equal ((const gchar*) a, (const gchar*) b);
#line 106 "../src/engine/db/db-statement.vala"
	return result;
#line 503 "db-statement.c"
}

gint
geary_db_statement_get_column_index (GearyDbStatement* self,
                                     const gchar* name)
{
	GeeHashMap* _tmp0_;
	gint _tmp11_ = 0;
	GeeHashMap* _tmp12_;
	gint result;
#line 103 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail (GEARY_DB_IS_STATEMENT (self), 0);
#line 103 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail (name != NULL, 0);
#line 105 "../src/engine/db/db-statement.vala"
	_tmp0_ = self->priv->column_map;
#line 105 "../src/engine/db/db-statement.vala"
	if (_tmp0_ == NULL) {
#line 522 "db-statement.c"
		GeeHashMap* _tmp1_;
		gint cols = 0;
		sqlite3_stmt* _tmp2_;
#line 106 "../src/engine/db/db-statement.vala"
		_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_INT, NULL, NULL, _geary_string_stri_hash_gee_hash_data_func, NULL, NULL, _geary_string_stri_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 106 "../src/engine/db/db-statement.vala"
		_g_object_unref0 (self->priv->column_map);
#line 106 "../src/engine/db/db-statement.vala"
		self->priv->column_map = _tmp1_;
#line 108 "../src/engine/db/db-statement.vala"
		_tmp2_ = self->stmt;
#line 108 "../src/engine/db/db-statement.vala"
		cols = sqlite3_column_count (_tmp2_);
#line 536 "db-statement.c"
		{
			gint ctr = 0;
#line 109 "../src/engine/db/db-statement.vala"
			ctr = 0;
#line 541 "db-statement.c"
			{
				gboolean _tmp3_ = FALSE;
#line 109 "../src/engine/db/db-statement.vala"
				_tmp3_ = TRUE;
#line 109 "../src/engine/db/db-statement.vala"
				while (TRUE) {
#line 548 "db-statement.c"
					gchar* column_name = NULL;
					sqlite3_stmt* _tmp5_;
					const gchar* _tmp6_;
					gchar* _tmp7_;
					const gchar* _tmp8_;
#line 109 "../src/engine/db/db-statement.vala"
					if (!_tmp3_) {
#line 556 "db-statement.c"
						gint _tmp4_;
#line 109 "../src/engine/db/db-statement.vala"
						_tmp4_ = ctr;
#line 109 "../src/engine/db/db-statement.vala"
						ctr = _tmp4_ + 1;
#line 562 "db-statement.c"
					}
#line 109 "../src/engine/db/db-statement.vala"
					_tmp3_ = FALSE;
#line 109 "../src/engine/db/db-statement.vala"
					if (!(ctr < cols)) {
#line 109 "../src/engine/db/db-statement.vala"
						break;
#line 570 "db-statement.c"
					}
#line 110 "../src/engine/db/db-statement.vala"
					_tmp5_ = self->stmt;
#line 110 "../src/engine/db/db-statement.vala"
					_tmp6_ = sqlite3_column_name (_tmp5_, ctr);
#line 110 "../src/engine/db/db-statement.vala"
					_tmp7_ = g_strdup (_tmp6_);
#line 110 "../src/engine/db/db-statement.vala"
					column_name = _tmp7_;
#line 111 "../src/engine/db/db-statement.vala"
					_tmp8_ = column_name;
#line 111 "../src/engine/db/db-statement.vala"
					if (!geary_string_is_empty (_tmp8_)) {
#line 584 "db-statement.c"
						GeeHashMap* _tmp9_;
						const gchar* _tmp10_;
#line 112 "../src/engine/db/db-statement.vala"
						_tmp9_ = self->priv->column_map;
#line 112 "../src/engine/db/db-statement.vala"
						_tmp10_ = column_name;
#line 112 "../src/engine/db/db-statement.vala"
						gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp10_, (gpointer) ((gintptr) ctr));
#line 593 "db-statement.c"
					}
#line 109 "../src/engine/db/db-statement.vala"
					_g_free0 (column_name);
#line 597 "db-statement.c"
				}
			}
		}
	}
#line 116 "../src/engine/db/db-statement.vala"
	_tmp12_ = self->priv->column_map;
#line 116 "../src/engine/db/db-statement.vala"
	if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), name)) {
#line 606 "db-statement.c"
		GeeHashMap* _tmp13_;
		gpointer _tmp14_;
#line 116 "../src/engine/db/db-statement.vala"
		_tmp13_ = self->priv->column_map;
#line 116 "../src/engine/db/db-statement.vala"
		_tmp14_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), name);
#line 116 "../src/engine/db/db-statement.vala"
		_tmp11_ = (gint) ((gintptr) _tmp14_);
#line 615 "db-statement.c"
	} else {
#line 116 "../src/engine/db/db-statement.vala"
		_tmp11_ = -1;
#line 619 "db-statement.c"
	}
#line 116 "../src/engine/db/db-statement.vala"
	result = _tmp11_;
#line 116 "../src/engine/db/db-statement.vala"
	return result;
#line 625 "db-statement.c"
}

/**
     * Executes the Statement and returns a Result object.  The Result starts pointing at the first
     * row in the result set.  If empty, Result.finished will be true.
     */
GearyDbResult*
geary_db_statement_exec (GearyDbStatement* self,
                         GCancellable* cancellable,
                         GError** error)
{
	GearyDbResult* results = NULL;
	GearyDbResult* _tmp2_;
	GError* _inner_error0_ = NULL;
	GearyDbResult* result;
#line 123 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail (GEARY_DB_IS_STATEMENT (self), NULL);
#line 123 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), NULL);
#line 124 "../src/engine/db/db-statement.vala"
	if (geary_db_context_enable_sql_logging) {
#line 647 "db-statement.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
#line 125 "../src/engine/db/db-statement.vala"
		_tmp0_ = geary_db_statement_get_expanded_sql (self);
#line 125 "../src/engine/db/db-statement.vala"
		_tmp1_ = _tmp0_;
#line 125 "../src/engine/db/db-statement.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "%s", _tmp1_);
#line 125 "../src/engine/db/db-statement.vala"
		_g_free0 (_tmp1_);
#line 658 "db-statement.c"
	}
#line 128 "../src/engine/db/db-statement.vala"
	_tmp2_ = geary_db_result_new (self, cancellable, &_inner_error0_);
#line 128 "../src/engine/db/db-statement.vala"
	results = _tmp2_;
#line 128 "../src/engine/db/db-statement.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 128 "../src/engine/db/db-statement.vala"
		g_propagate_error (error, _inner_error0_);
#line 128 "../src/engine/db/db-statement.vala"
		return NULL;
#line 670 "db-statement.c"
	}
#line 129 "../src/engine/db/db-statement.vala"
	g_signal_emit (self, geary_db_statement_signals[GEARY_DB_STATEMENT_EXECUTED_SIGNAL], 0);
#line 131 "../src/engine/db/db-statement.vala"
	result = results;
#line 131 "../src/engine/db/db-statement.vala"
	return result;
#line 678 "db-statement.c"
}

/**
     * Executes the Statement and returns the last inserted rowid.  If this Statement is not
     * an INSERT, it will return the rowid of the last prior INSERT.
     *
     * See Connection.last_insert_rowid.
     */
gint64
geary_db_statement_exec_insert (GearyDbStatement* self,
                                GCancellable* cancellable,
                                GError** error)
{
	GearyDbResult* _tmp2_;
	GearyDbResult* _tmp3_;
	gint64 rowid = 0LL;
	GearyDbDatabaseConnection* _tmp5_;
	gint64 _tmp6_;
	gint64 _tmp7_;
	GError* _inner_error0_ = NULL;
	gint64 result;
#line 140 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail (GEARY_DB_IS_STATEMENT (self), 0LL);
#line 140 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), 0LL);
#line 141 "../src/engine/db/db-statement.vala"
	if (geary_db_context_enable_sql_logging) {
#line 706 "db-statement.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
#line 142 "../src/engine/db/db-statement.vala"
		_tmp0_ = geary_db_statement_get_expanded_sql (self);
#line 142 "../src/engine/db/db-statement.vala"
		_tmp1_ = _tmp0_;
#line 142 "../src/engine/db/db-statement.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "%s", _tmp1_);
#line 142 "../src/engine/db/db-statement.vala"
		_g_free0 (_tmp1_);
#line 717 "db-statement.c"
	}
#line 145 "../src/engine/db/db-statement.vala"
	_tmp2_ = geary_db_result_new (self, cancellable, &_inner_error0_);
#line 145 "../src/engine/db/db-statement.vala"
	_tmp3_ = _tmp2_;
#line 145 "../src/engine/db/db-statement.vala"
	_g_object_unref0 (_tmp3_);
#line 145 "../src/engine/db/db-statement.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 727 "db-statement.c"
		gint64 _tmp4_ = -1LL;
#line 145 "../src/engine/db/db-statement.vala"
		g_propagate_error (error, _inner_error0_);
#line 145 "../src/engine/db/db-statement.vala"
		return _tmp4_;
#line 733 "db-statement.c"
	}
#line 146 "../src/engine/db/db-statement.vala"
	_tmp5_ = self->priv->_connection;
#line 146 "../src/engine/db/db-statement.vala"
	_tmp6_ = geary_db_connection_get_last_insert_rowid (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEARY_DB_TYPE_CONNECTION, GearyDbConnection));
#line 146 "../src/engine/db/db-statement.vala"
	_tmp7_ = _tmp6_;
#line 146 "../src/engine/db/db-statement.vala"
	rowid = _tmp7_;
#line 149 "../src/engine/db/db-statement.vala"
	g_signal_emit (self, geary_db_statement_signals[GEARY_DB_STATEMENT_EXECUTED_SIGNAL], 0);
#line 151 "../src/engine/db/db-statement.vala"
	result = rowid;
#line 151 "../src/engine/db/db-statement.vala"
	return result;
#line 749 "db-statement.c"
}

/**
     * Executes the Statement and returns the number of rows modified by the operation.  This
     * Statement should be an INSERT, UPDATE, or DELETE, otherwise this will return the number
     * of modified rows from the last INSERT, UPDATE, or DELETE.
     *
     * See Connection.last_modified_rows.
     */
gint
geary_db_statement_exec_get_modified (GearyDbStatement* self,
                                      GCancellable* cancellable,
                                      GError** error)
{
	GearyDbResult* _tmp2_;
	GearyDbResult* _tmp3_;
	gint modified = 0;
	GearyDbDatabaseConnection* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GError* _inner_error0_ = NULL;
	gint result;
#line 161 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail (GEARY_DB_IS_STATEMENT (self), 0);
#line 161 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), 0);
#line 162 "../src/engine/db/db-statement.vala"
	if (geary_db_context_enable_sql_logging) {
#line 778 "db-statement.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
#line 163 "../src/engine/db/db-statement.vala"
		_tmp0_ = geary_db_statement_get_expanded_sql (self);
#line 163 "../src/engine/db/db-statement.vala"
		_tmp1_ = _tmp0_;
#line 163 "../src/engine/db/db-statement.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "%s", _tmp1_);
#line 163 "../src/engine/db/db-statement.vala"
		_g_free0 (_tmp1_);
#line 789 "db-statement.c"
	}
#line 166 "../src/engine/db/db-statement.vala"
	_tmp2_ = geary_db_result_new (self, cancellable, &_inner_error0_);
#line 166 "../src/engine/db/db-statement.vala"
	_tmp3_ = _tmp2_;
#line 166 "../src/engine/db/db-statement.vala"
	_g_object_unref0 (_tmp3_);
#line 166 "../src/engine/db/db-statement.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 799 "db-statement.c"
		gint _tmp4_ = -1;
#line 166 "../src/engine/db/db-statement.vala"
		g_propagate_error (error, _inner_error0_);
#line 166 "../src/engine/db/db-statement.vala"
		return _tmp4_;
#line 805 "db-statement.c"
	}
#line 167 "../src/engine/db/db-statement.vala"
	_tmp5_ = self->priv->_connection;
#line 167 "../src/engine/db/db-statement.vala"
	_tmp6_ = geary_db_connection_get_last_modified_rows (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEARY_DB_TYPE_CONNECTION, GearyDbConnection));
#line 167 "../src/engine/db/db-statement.vala"
	_tmp7_ = _tmp6_;
#line 167 "../src/engine/db/db-statement.vala"
	modified = _tmp7_;
#line 170 "../src/engine/db/db-statement.vala"
	g_signal_emit (self, geary_db_statement_signals[GEARY_DB_STATEMENT_EXECUTED_SIGNAL], 0);
#line 172 "../src/engine/db/db-statement.vala"
	result = modified;
#line 172 "../src/engine/db/db-statement.vala"
	return result;
#line 821 "db-statement.c"
}

/**
     * index is zero-based.
     */
GearyDbStatement*
geary_db_statement_bind_double (GearyDbStatement* self,
                                gint index,
                                gdouble d,
                                GError** error)
{
	sqlite3_stmt* _tmp0_;
	GearyDbStatement* _tmp1_;
	GError* _inner_error0_ = NULL;
	GearyDbStatement* result;
#line 178 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail (GEARY_DB_IS_STATEMENT (self), NULL);
#line 179 "../src/engine/db/db-statement.vala"
	_tmp0_ = self->stmt;
#line 179 "../src/engine/db/db-statement.vala"
	geary_db_context_throw_on_error (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_DB_TYPE_CONTEXT, GearyDbContext), "Statement.bind_double", sqlite3_bind_double (_tmp0_, index + 1, d), NULL, &_inner_error0_);
#line 179 "../src/engine/db/db-statement.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 179 "../src/engine/db/db-statement.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 179 "../src/engine/db/db-statement.vala"
			g_propagate_error (error, _inner_error0_);
#line 179 "../src/engine/db/db-statement.vala"
			return NULL;
#line 851 "db-statement.c"
		} else {
#line 179 "../src/engine/db/db-statement.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 179 "../src/engine/db/db-statement.vala"
			g_clear_error (&_inner_error0_);
#line 179 "../src/engine/db/db-statement.vala"
			return NULL;
#line 859 "db-statement.c"
		}
	}
#line 181 "../src/engine/db/db-statement.vala"
	_tmp1_ = _g_object_ref0 (self);
#line 181 "../src/engine/db/db-statement.vala"
	result = _tmp1_;
#line 181 "../src/engine/db/db-statement.vala"
	return result;
#line 868 "db-statement.c"
}

/**
     * index is zero-based.
     */
GearyDbStatement*
geary_db_statement_bind_int (GearyDbStatement* self,
                             gint index,
                             gint i,
                             GError** error)
{
	sqlite3_stmt* _tmp0_;
	GearyDbStatement* _tmp1_;
	GError* _inner_error0_ = NULL;
	GearyDbStatement* result;
#line 187 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail (GEARY_DB_IS_STATEMENT (self), NULL);
#line 188 "../src/engine/db/db-statement.vala"
	_tmp0_ = self->stmt;
#line 188 "../src/engine/db/db-statement.vala"
	geary_db_context_throw_on_error (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_DB_TYPE_CONTEXT, GearyDbContext), "Statement.bind_int", sqlite3_bind_int (_tmp0_, index + 1, i), NULL, &_inner_error0_);
#line 188 "../src/engine/db/db-statement.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 188 "../src/engine/db/db-statement.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 188 "../src/engine/db/db-statement.vala"
			g_propagate_error (error, _inner_error0_);
#line 188 "../src/engine/db/db-statement.vala"
			return NULL;
#line 898 "db-statement.c"
		} else {
#line 188 "../src/engine/db/db-statement.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 188 "../src/engine/db/db-statement.vala"
			g_clear_error (&_inner_error0_);
#line 188 "../src/engine/db/db-statement.vala"
			return NULL;
#line 906 "db-statement.c"
		}
	}
#line 190 "../src/engine/db/db-statement.vala"
	_tmp1_ = _g_object_ref0 (self);
#line 190 "../src/engine/db/db-statement.vala"
	result = _tmp1_;
#line 190 "../src/engine/db/db-statement.vala"
	return result;
#line 915 "db-statement.c"
}

/**
     * index is zero-based.
     */
GearyDbStatement*
geary_db_statement_bind_uint (GearyDbStatement* self,
                              gint index,
                              guint u,
                              GError** error)
{
	GearyDbStatement* _tmp0_ = NULL;
	GearyDbStatement* _tmp1_;
	GearyDbStatement* _tmp2_;
	GError* _inner_error0_ = NULL;
	GearyDbStatement* result;
#line 196 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail (GEARY_DB_IS_STATEMENT (self), NULL);
#line 197 "../src/engine/db/db-statement.vala"
	_tmp1_ = geary_db_statement_bind_int64 (self, index, (gint64) u, &_inner_error0_);
#line 197 "../src/engine/db/db-statement.vala"
	_tmp0_ = _tmp1_;
#line 197 "../src/engine/db/db-statement.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 197 "../src/engine/db/db-statement.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 197 "../src/engine/db/db-statement.vala"
			g_propagate_error (error, _inner_error0_);
#line 197 "../src/engine/db/db-statement.vala"
			return NULL;
#line 946 "db-statement.c"
		} else {
#line 197 "../src/engine/db/db-statement.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 197 "../src/engine/db/db-statement.vala"
			g_clear_error (&_inner_error0_);
#line 197 "../src/engine/db/db-statement.vala"
			return NULL;
#line 954 "db-statement.c"
		}
	}
#line 197 "../src/engine/db/db-statement.vala"
	_tmp2_ = _tmp0_;
#line 197 "../src/engine/db/db-statement.vala"
	_tmp0_ = NULL;
#line 197 "../src/engine/db/db-statement.vala"
	result = _tmp2_;
#line 197 "../src/engine/db/db-statement.vala"
	_g_object_unref0 (_tmp0_);
#line 197 "../src/engine/db/db-statement.vala"
	return result;
#line 967 "db-statement.c"
}

/**
     * index is zero-based.
     */
GearyDbStatement*
geary_db_statement_bind_long (GearyDbStatement* self,
                              gint index,
                              glong l,
                              GError** error)
{
	GearyDbStatement* _tmp0_ = NULL;
	GearyDbStatement* _tmp1_;
	GearyDbStatement* _tmp2_;
	GError* _inner_error0_ = NULL;
	GearyDbStatement* result;
#line 203 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail (GEARY_DB_IS_STATEMENT (self), NULL);
#line 204 "../src/engine/db/db-statement.vala"
	_tmp1_ = geary_db_statement_bind_int64 (self, index, (gint64) l, &_inner_error0_);
#line 204 "../src/engine/db/db-statement.vala"
	_tmp0_ = _tmp1_;
#line 204 "../src/engine/db/db-statement.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 204 "../src/engine/db/db-statement.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 204 "../src/engine/db/db-statement.vala"
			g_propagate_error (error, _inner_error0_);
#line 204 "../src/engine/db/db-statement.vala"
			return NULL;
#line 998 "db-statement.c"
		} else {
#line 204 "../src/engine/db/db-statement.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 204 "../src/engine/db/db-statement.vala"
			g_clear_error (&_inner_error0_);
#line 204 "../src/engine/db/db-statement.vala"
			return NULL;
#line 1006 "db-statement.c"
		}
	}
#line 204 "../src/engine/db/db-statement.vala"
	_tmp2_ = _tmp0_;
#line 204 "../src/engine/db/db-statement.vala"
	_tmp0_ = NULL;
#line 204 "../src/engine/db/db-statement.vala"
	result = _tmp2_;
#line 204 "../src/engine/db/db-statement.vala"
	_g_object_unref0 (_tmp0_);
#line 204 "../src/engine/db/db-statement.vala"
	return result;
#line 1019 "db-statement.c"
}

/**
     * index is zero-based.
     */
GearyDbStatement*
geary_db_statement_bind_int64 (GearyDbStatement* self,
                               gint index,
                               gint64 i64,
                               GError** error)
{
	sqlite3_stmt* _tmp0_;
	GearyDbStatement* _tmp1_;
	GError* _inner_error0_ = NULL;
	GearyDbStatement* result;
#line 210 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail (GEARY_DB_IS_STATEMENT (self), NULL);
#line 211 "../src/engine/db/db-statement.vala"
	_tmp0_ = self->stmt;
#line 211 "../src/engine/db/db-statement.vala"
	geary_db_context_throw_on_error (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_DB_TYPE_CONTEXT, GearyDbContext), "Statement.bind_int64", sqlite3_bind_int64 (_tmp0_, index + 1, i64), NULL, &_inner_error0_);
#line 211 "../src/engine/db/db-statement.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 211 "../src/engine/db/db-statement.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 211 "../src/engine/db/db-statement.vala"
			g_propagate_error (error, _inner_error0_);
#line 211 "../src/engine/db/db-statement.vala"
			return NULL;
#line 1049 "db-statement.c"
		} else {
#line 211 "../src/engine/db/db-statement.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 211 "../src/engine/db/db-statement.vala"
			g_clear_error (&_inner_error0_);
#line 211 "../src/engine/db/db-statement.vala"
			return NULL;
#line 1057 "db-statement.c"
		}
	}
#line 213 "../src/engine/db/db-statement.vala"
	_tmp1_ = _g_object_ref0 (self);
#line 213 "../src/engine/db/db-statement.vala"
	result = _tmp1_;
#line 213 "../src/engine/db/db-statement.vala"
	return result;
#line 1066 "db-statement.c"
}

/**
     * Binds a bool to the column.  A bool is stored as an integer, false == 0, true == 1.  Note
     * that fetching a bool via Result is more lenient; see Result.bool_at() and Result.bool_from().
     *
     * index is zero-based.
     */
GearyDbStatement*
geary_db_statement_bind_bool (GearyDbStatement* self,
                              gint index,
                              gboolean b,
                              GError** error)
{
	gint _tmp0_ = 0;
	GearyDbStatement* _tmp1_ = NULL;
	GearyDbStatement* _tmp2_;
	GearyDbStatement* _tmp3_;
	GError* _inner_error0_ = NULL;
	GearyDbStatement* result;
#line 222 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail (GEARY_DB_IS_STATEMENT (self), NULL);
#line 223 "../src/engine/db/db-statement.vala"
	if (b) {
#line 223 "../src/engine/db/db-statement.vala"
		_tmp0_ = 1;
#line 1093 "db-statement.c"
	} else {
#line 223 "../src/engine/db/db-statement.vala"
		_tmp0_ = 0;
#line 1097 "db-statement.c"
	}
#line 223 "../src/engine/db/db-statement.vala"
	_tmp2_ = geary_db_statement_bind_int (self, index, _tmp0_, &_inner_error0_);
#line 223 "../src/engine/db/db-statement.vala"
	_tmp1_ = _tmp2_;
#line 223 "../src/engine/db/db-statement.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 223 "../src/engine/db/db-statement.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 223 "../src/engine/db/db-statement.vala"
			g_propagate_error (error, _inner_error0_);
#line 223 "../src/engine/db/db-statement.vala"
			return NULL;
#line 1111 "db-statement.c"
		} else {
#line 223 "../src/engine/db/db-statement.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 223 "../src/engine/db/db-statement.vala"
			g_clear_error (&_inner_error0_);
#line 223 "../src/engine/db/db-statement.vala"
			return NULL;
#line 1119 "db-statement.c"
		}
	}
#line 223 "../src/engine/db/db-statement.vala"
	_tmp3_ = _tmp1_;
#line 223 "../src/engine/db/db-statement.vala"
	_tmp1_ = NULL;
#line 223 "../src/engine/db/db-statement.vala"
	result = _tmp3_;
#line 223 "../src/engine/db/db-statement.vala"
	_g_object_unref0 (_tmp1_);
#line 223 "../src/engine/db/db-statement.vala"
	return result;
#line 1132 "db-statement.c"
}

/**
     * index is zero-based.
     *
     * This will bind the value to the column as an int64 unless it's INVALID_ROWID, in which case
     * the column is bound as NULL.  WARNING: This does *not* work in WHERE clauses. For WHERE, you
     * must use "field IS NULL".
     */
GearyDbStatement*
geary_db_statement_bind_rowid (GearyDbStatement* self,
                               gint index,
                               gint64 rowid,
                               GError** error)
{
	GearyDbStatement* _tmp0_ = NULL;
	GError* _inner_error0_ = NULL;
	GearyDbStatement* result;
#line 233 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail (GEARY_DB_IS_STATEMENT (self), NULL);
#line 234 "../src/engine/db/db-statement.vala"
	if (rowid != GEARY_DB_INVALID_ROWID) {
#line 1155 "db-statement.c"
		GearyDbStatement* _tmp1_;
#line 234 "../src/engine/db/db-statement.vala"
		_tmp1_ = geary_db_statement_bind_int64 (self, index, rowid, &_inner_error0_);
#line 234 "../src/engine/db/db-statement.vala"
		_g_object_unref0 (_tmp0_);
#line 234 "../src/engine/db/db-statement.vala"
		_tmp0_ = _tmp1_;
#line 234 "../src/engine/db/db-statement.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 234 "../src/engine/db/db-statement.vala"
			if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 234 "../src/engine/db/db-statement.vala"
				g_propagate_error (error, _inner_error0_);
#line 234 "../src/engine/db/db-statement.vala"
				_g_object_unref0 (_tmp0_);
#line 234 "../src/engine/db/db-statement.vala"
				return NULL;
#line 1173 "db-statement.c"
			} else {
#line 234 "../src/engine/db/db-statement.vala"
				_g_object_unref0 (_tmp0_);
#line 234 "../src/engine/db/db-statement.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 234 "../src/engine/db/db-statement.vala"
				g_clear_error (&_inner_error0_);
#line 234 "../src/engine/db/db-statement.vala"
				return NULL;
#line 1183 "db-statement.c"
			}
		}
	} else {
		GearyDbStatement* _tmp2_;
#line 234 "../src/engine/db/db-statement.vala"
		_tmp2_ = geary_db_statement_bind_null (self, index, &_inner_error0_);
#line 234 "../src/engine/db/db-statement.vala"
		_g_object_unref0 (_tmp0_);
#line 234 "../src/engine/db/db-statement.vala"
		_tmp0_ = _tmp2_;
#line 234 "../src/engine/db/db-statement.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 234 "../src/engine/db/db-statement.vala"
			if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 234 "../src/engine/db/db-statement.vala"
				g_propagate_error (error, _inner_error0_);
#line 234 "../src/engine/db/db-statement.vala"
				_g_object_unref0 (_tmp0_);
#line 234 "../src/engine/db/db-statement.vala"
				return NULL;
#line 1204 "db-statement.c"
			} else {
#line 234 "../src/engine/db/db-statement.vala"
				_g_object_unref0 (_tmp0_);
#line 234 "../src/engine/db/db-statement.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 234 "../src/engine/db/db-statement.vala"
				g_clear_error (&_inner_error0_);
#line 234 "../src/engine/db/db-statement.vala"
				return NULL;
#line 1214 "db-statement.c"
			}
		}
	}
#line 234 "../src/engine/db/db-statement.vala"
	result = _tmp0_;
#line 234 "../src/engine/db/db-statement.vala"
	return result;
#line 1222 "db-statement.c"
}

/**
     * index is zero-based.
     *
     * WARNING: This does *not* work in WHERE clauses. For WHERE, you must use "field IS NULL".
     */
GearyDbStatement*
geary_db_statement_bind_null (GearyDbStatement* self,
                              gint index,
                              GError** error)
{
	sqlite3_stmt* _tmp0_;
	GearyDbStatement* _tmp1_;
	GError* _inner_error0_ = NULL;
	GearyDbStatement* result;
#line 242 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail (GEARY_DB_IS_STATEMENT (self), NULL);
#line 243 "../src/engine/db/db-statement.vala"
	_tmp0_ = self->stmt;
#line 243 "../src/engine/db/db-statement.vala"
	geary_db_context_throw_on_error (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_DB_TYPE_CONTEXT, GearyDbContext), "Statement.bind_null", sqlite3_bind_null (_tmp0_, index + 1), NULL, &_inner_error0_);
#line 243 "../src/engine/db/db-statement.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 243 "../src/engine/db/db-statement.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 243 "../src/engine/db/db-statement.vala"
			g_propagate_error (error, _inner_error0_);
#line 243 "../src/engine/db/db-statement.vala"
			return NULL;
#line 1253 "db-statement.c"
		} else {
#line 243 "../src/engine/db/db-statement.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 243 "../src/engine/db/db-statement.vala"
			g_clear_error (&_inner_error0_);
#line 243 "../src/engine/db/db-statement.vala"
			return NULL;
#line 1261 "db-statement.c"
		}
	}
#line 245 "../src/engine/db/db-statement.vala"
	_tmp1_ = _g_object_ref0 (self);
#line 245 "../src/engine/db/db-statement.vala"
	result = _tmp1_;
#line 245 "../src/engine/db/db-statement.vala"
	return result;
#line 1270 "db-statement.c"
}

/**
     * index is zero-based.
     */
GearyDbStatement*
geary_db_statement_bind_string (GearyDbStatement* self,
                                gint index,
                                const gchar* s,
                                GError** error)
{
	sqlite3_stmt* _tmp0_;
	gchar* _tmp1_;
	GDestroyNotify _tmp2_;
	GearyDbStatement* _tmp3_;
	GError* _inner_error0_ = NULL;
	GearyDbStatement* result;
#line 251 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail (GEARY_DB_IS_STATEMENT (self), NULL);
#line 252 "../src/engine/db/db-statement.vala"
	_tmp0_ = self->stmt;
#line 252 "../src/engine/db/db-statement.vala"
	_tmp1_ = g_strdup (s);
#line 252 "../src/engine/db/db-statement.vala"
	_tmp2_ = g_free;
#line 252 "../src/engine/db/db-statement.vala"
	geary_db_context_throw_on_error (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_DB_TYPE_CONTEXT, GearyDbContext), "Statement.bind_string", sqlite3_bind_text (_tmp0_, index + 1, _tmp1_, -1, _tmp2_), NULL, &_inner_error0_);
#line 252 "../src/engine/db/db-statement.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 252 "../src/engine/db/db-statement.vala"
		if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 252 "../src/engine/db/db-statement.vala"
			g_propagate_error (error, _inner_error0_);
#line 252 "../src/engine/db/db-statement.vala"
			return NULL;
#line 1306 "db-statement.c"
		} else {
#line 252 "../src/engine/db/db-statement.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 252 "../src/engine/db/db-statement.vala"
			g_clear_error (&_inner_error0_);
#line 252 "../src/engine/db/db-statement.vala"
			return NULL;
#line 1314 "db-statement.c"
		}
	}
#line 254 "../src/engine/db/db-statement.vala"
	_tmp3_ = _g_object_ref0 (self);
#line 254 "../src/engine/db/db-statement.vala"
	result = _tmp3_;
#line 254 "../src/engine/db/db-statement.vala"
	return result;
#line 1323 "db-statement.c"
}

/**
     * Binds the string representation of a {@link Memory.Buffer} to the replacement value
     * in the {@link Statement}.
     *
     * If buffer supports {@link Memory.UnownedStringBuffer}, the unowned string will be used
     * to avoid a memory copy.  However, this means the Statement will hold a reference to the
     * buffer until the Statement is destroyed.
     *
     * index is zero-based.
     */
GearyDbStatement*
geary_db_statement_bind_string_buffer (GearyDbStatement* self,
                                       gint index,
                                       GearyMemoryBuffer* buffer,
                                       GError** error)
{
	GearyMemoryUnownedStringBuffer* unowned_buffer = NULL;
	GearyMemoryUnownedStringBuffer* _tmp3_;
	GearyMemoryUnownedStringBuffer* _tmp4_;
	GeeHashSet* _tmp9_;
	GearyMemoryUnownedStringBuffer* _tmp10_;
	sqlite3_stmt* _tmp11_;
	GearyMemoryUnownedStringBuffer* _tmp12_;
	const gchar* _tmp13_;
	GearyDbStatement* _tmp14_;
	GError* _inner_error0_ = NULL;
	GearyDbStatement* result;
#line 267 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail (GEARY_DB_IS_STATEMENT (self), NULL);
#line 267 "../src/engine/db/db-statement.vala"
	g_return_val_if_fail ((buffer == NULL) || GEARY_MEMORY_IS_BUFFER (buffer), NULL);
#line 268 "../src/engine/db/db-statement.vala"
	if (buffer == NULL) {
#line 1359 "db-statement.c"
		GearyDbStatement* _tmp0_ = NULL;
		GearyDbStatement* _tmp1_;
		GearyDbStatement* _tmp2_;
#line 269 "../src/engine/db/db-statement.vala"
		_tmp1_ = geary_db_statement_bind_string (self, index, NULL, &_inner_error0_);
#line 269 "../src/engine/db/db-statement.vala"
		_tmp0_ = _tmp1_;
#line 269 "../src/engine/db/db-statement.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 269 "../src/engine/db/db-statement.vala"
			if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 269 "../src/engine/db/db-statement.vala"
				g_propagate_error (error, _inner_error0_);
#line 269 "../src/engine/db/db-statement.vala"
				return NULL;
#line 1375 "db-statement.c"
			} else {
#line 269 "../src/engine/db/db-statement.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 269 "../src/engine/db/db-statement.vala"
				g_clear_error (&_inner_error0_);
#line 269 "../src/engine/db/db-statement.vala"
				return NULL;
#line 1383 "db-statement.c"
			}
		}
#line 269 "../src/engine/db/db-statement.vala"
		_tmp2_ = _tmp0_;
#line 269 "../src/engine/db/db-statement.vala"
		_tmp0_ = NULL;
#line 269 "../src/engine/db/db-statement.vala"
		result = _tmp2_;
#line 269 "../src/engine/db/db-statement.vala"
		_g_object_unref0 (_tmp0_);
#line 269 "../src/engine/db/db-statement.vala"
		return result;
#line 1396 "db-statement.c"
	}
#line 271 "../src/engine/db/db-statement.vala"
	_tmp3_ = _g_object_ref0 (GEARY_MEMORY_IS_UNOWNED_STRING_BUFFER (buffer) ? ((GearyMemoryUnownedStringBuffer*) buffer) : NULL);
#line 271 "../src/engine/db/db-statement.vala"
	unowned_buffer = _tmp3_;
#line 272 "../src/engine/db/db-statement.vala"
	_tmp4_ = unowned_buffer;
#line 272 "../src/engine/db/db-statement.vala"
	if (_tmp4_ == NULL) {
#line 1406 "db-statement.c"
		sqlite3_stmt* _tmp5_;
		gchar* _tmp6_;
		GDestroyNotify _tmp7_;
		GearyDbStatement* _tmp8_;
#line 273 "../src/engine/db/db-statement.vala"
		_tmp5_ = self->stmt;
#line 273 "../src/engine/db/db-statement.vala"
		_tmp6_ = geary_memory_buffer_to_string (buffer);
#line 273 "../src/engine/db/db-statement.vala"
		_tmp7_ = g_free;
#line 273 "../src/engine/db/db-statement.vala"
		geary_db_context_throw_on_error (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_DB_TYPE_CONTEXT, GearyDbContext), "Statement.bind_string_buffer", sqlite3_bind_text (_tmp5_, index + 1, _tmp6_, -1, _tmp7_), NULL, &_inner_error0_);
#line 273 "../src/engine/db/db-statement.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 273 "../src/engine/db/db-statement.vala"
			if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 273 "../src/engine/db/db-statement.vala"
				g_propagate_error (error, _inner_error0_);
#line 273 "../src/engine/db/db-statement.vala"
				_g_object_unref0 (unowned_buffer);
#line 273 "../src/engine/db/db-statement.vala"
				return NULL;
#line 1429 "db-statement.c"
			} else {
#line 273 "../src/engine/db/db-statement.vala"
				_g_object_unref0 (unowned_buffer);
#line 273 "../src/engine/db/db-statement.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 273 "../src/engine/db/db-statement.vala"
				g_clear_error (&_inner_error0_);
#line 273 "../src/engine/db/db-statement.vala"
				return NULL;
#line 1439 "db-statement.c"
			}
		}
#line 275 "../src/engine/db/db-statement.vala"
		_tmp8_ = _g_object_ref0 (self);
#line 275 "../src/engine/db/db-statement.vala"
		result = _tmp8_;
#line 275 "../src/engine/db/db-statement.vala"
		_g_object_unref0 (unowned_buffer);
#line 275 "../src/engine/db/db-statement.vala"
		return result;
#line 1450 "db-statement.c"
	}
#line 280 "../src/engine/db/db-statement.vala"
	_tmp9_ = self->priv->held_buffers;
#line 280 "../src/engine/db/db-statement.vala"
	_tmp10_ = unowned_buffer;
#line 280 "../src/engine/db/db-statement.vala"
	gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBuffer));
#line 284 "../src/engine/db/db-statement.vala"
	_tmp11_ = self->stmt;
#line 284 "../src/engine/db/db-statement.vala"
	_tmp12_ = unowned_buffer;
#line 284 "../src/engine/db/db-statement.vala"
	_tmp13_ = geary_memory_unowned_string_buffer_to_unowned_string (_tmp12_);
#line 284 "../src/engine/db/db-statement.vala"
	sqlite3_bind_text (_tmp11_, index + 1, _tmp13_, -1, NULL);
#line 286 "../src/engine/db/db-statement.vala"
	_tmp14_ = _g_object_ref0 (self);
#line 286 "../src/engine/db/db-statement.vala"
	result = _tmp14_;
#line 286 "../src/engine/db/db-statement.vala"
	_g_object_unref0 (unowned_buffer);
#line 286 "../src/engine/db/db-statement.vala"
	return result;
#line 1474 "db-statement.c"
}

/** {@inheritDoc} */
static GearyLoggingState*
geary_db_statement_real_to_logging_state (GearyDbContext* base)
{
	GearyDbStatement * self;
	const gchar* _tmp0_;
	GearyLoggingState* _tmp1_;
	GearyLoggingState* result;
#line 290 "../src/engine/db/db-statement.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_DB_TYPE_STATEMENT, GearyDbStatement);
#line 291 "../src/engine/db/db-statement.vala"
	_tmp0_ = self->priv->_sql;
#line 291 "../src/engine/db/db-statement.vala"
	_tmp1_ = geary_logging_state_new (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "%s", _tmp0_);
#line 291 "../src/engine/db/db-statement.vala"
	result = _tmp1_;
#line 291 "../src/engine/db/db-statement.vala"
	return result;
#line 1495 "db-statement.c"
}

static GearyDbStatement*
geary_db_statement_real_get_statement (GearyDbContext* base)
{
	GearyDbStatement * self;
	GearyDbStatement* _tmp0_;
	GearyDbStatement* result;
#line 294 "../src/engine/db/db-statement.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_DB_TYPE_STATEMENT, GearyDbStatement);
#line 295 "../src/engine/db/db-statement.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 295 "../src/engine/db/db-statement.vala"
	result = _tmp0_;
#line 295 "../src/engine/db/db-statement.vala"
	return result;
#line 1512 "db-statement.c"
}

static void
geary_db_statement_class_init (GearyDbStatementClass * klass,
                               gpointer klass_data)
{
#line 8 "../src/engine/db/db-statement.vala"
	geary_db_statement_parent_class = g_type_class_peek_parent (klass);
#line 8 "../src/engine/db/db-statement.vala"
	g_type_class_adjust_private_offset (klass, &GearyDbStatement_private_offset);
#line 8 "../src/engine/db/db-statement.vala"
	((GearyDbContextClass *) klass)->to_logging_state = (GearyLoggingState* (*) (GearyDbContext*)) geary_db_statement_real_to_logging_state;
#line 8 "../src/engine/db/db-statement.vala"
	((GearyDbContextClass *) klass)->get_statement = (GearyDbStatement* (*) (GearyDbContext*)) geary_db_statement_real_get_statement;
#line 8 "../src/engine/db/db-statement.vala"
	GEARY_DB_CONTEXT_CLASS (klass)->get_logging_parent = (GearyLoggingSource* (*) (GearyDbContext*)) geary_db_statement_real_get_logging_parent;
#line 8 "../src/engine/db/db-statement.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_db_statement_get_property;
#line 8 "../src/engine/db/db-statement.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_db_statement_set_property;
#line 8 "../src/engine/db/db-statement.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_db_statement_finalize;
#line 8 "../src/engine/db/db-statement.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_DB_STATEMENT_SQL_PROPERTY, geary_db_statement_properties[GEARY_DB_STATEMENT_SQL_PROPERTY] = g_param_spec_string ("sql", "sql", "sql", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1537 "db-statement.c"
	/** {@inheritDoc} */
#line 8 "../src/engine/db/db-statement.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_DB_STATEMENT_LOGGING_PARENT_PROPERTY, geary_db_statement_properties[GEARY_DB_STATEMENT_LOGGING_PARENT_PROPERTY] = g_param_spec_object ("logging-parent", "logging-parent", "logging-parent", GEARY_LOGGING_TYPE_SOURCE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8 "../src/engine/db/db-statement.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_DB_STATEMENT_CONNECTION_PROPERTY, geary_db_statement_properties[GEARY_DB_STATEMENT_CONNECTION_PROPERTY] = g_param_spec_object ("connection", "connection", "connection", GEARY_DB_TYPE_DATABASE_CONNECTION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1543 "db-statement.c"
	/**
	     * Fired when the Statement is executed the first time (after creation or after a reset).
	     */
#line 8 "../src/engine/db/db-statement.vala"
	geary_db_statement_signals[GEARY_DB_STATEMENT_EXECUTED_SIGNAL] = g_signal_new ("executed", GEARY_DB_TYPE_STATEMENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1549 "db-statement.c"
	/**
	     * Fired when the Statement is reset.
	     */
#line 8 "../src/engine/db/db-statement.vala"
	geary_db_statement_signals[GEARY_DB_STATEMENT_WAS_RESET_SIGNAL] = g_signal_new ("was-reset", GEARY_DB_TYPE_STATEMENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1555 "db-statement.c"
	/**
	     * Fired when the Statement's bindings are cleared.
	     */
#line 8 "../src/engine/db/db-statement.vala"
	geary_db_statement_signals[GEARY_DB_STATEMENT_BINDINGS_CLEARED_SIGNAL] = g_signal_new ("bindings-cleared", GEARY_DB_TYPE_STATEMENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1561 "db-statement.c"
}

static void
geary_db_statement_instance_init (GearyDbStatement * self,
                                  gpointer klass)
{
	GeeHashSet* _tmp0_;
#line 8 "../src/engine/db/db-statement.vala"
	self->priv = geary_db_statement_get_instance_private (self);
#line 22 "../src/engine/db/db-statement.vala"
	self->priv->column_map = NULL;
#line 23 "../src/engine/db/db-statement.vala"
	_tmp0_ = gee_hash_set_new (GEARY_MEMORY_TYPE_BUFFER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 23 "../src/engine/db/db-statement.vala"
	self->priv->held_buffers = _tmp0_;
#line 1577 "db-statement.c"
}

static void
geary_db_statement_finalize (GObject * obj)
{
	GearyDbStatement * self;
#line 8 "../src/engine/db/db-statement.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_DB_TYPE_STATEMENT, GearyDbStatement);
#line 11 "../src/engine/db/db-statement.vala"
	_g_free0 (self->priv->_sql);
#line 18 "../src/engine/db/db-statement.vala"
	_g_object_unref0 (self->priv->_connection);
#line 20 "../src/engine/db/db-statement.vala"
	_sqlite3_finalize0 (self->stmt);
#line 22 "../src/engine/db/db-statement.vala"
	_g_object_unref0 (self->priv->column_map);
#line 23 "../src/engine/db/db-statement.vala"
	_g_object_unref0 (self->priv->held_buffers);
#line 8 "../src/engine/db/db-statement.vala"
	G_OBJECT_CLASS (geary_db_statement_parent_class)->finalize (obj);
#line 1598 "db-statement.c"
}

 G_GNUC_NO_INLINE static GType
geary_db_statement_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyDbStatementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_db_statement_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyDbStatement), 0, (GInstanceInitFunc) geary_db_statement_instance_init, NULL };
	GType geary_db_statement_type_id;
	geary_db_statement_type_id = g_type_register_static (GEARY_DB_TYPE_CONTEXT, "GearyDbStatement", &g_define_type_info, 0);
	GearyDbStatement_private_offset = g_type_add_instance_private (geary_db_statement_type_id, sizeof (GearyDbStatementPrivate));
	return geary_db_statement_type_id;
}

GType
geary_db_statement_get_type (void)
{
	static gsize geary_db_statement_type_id__once = 0;
	if (g_once_init_enter (&geary_db_statement_type_id__once)) {
		GType geary_db_statement_type_id;
		geary_db_statement_type_id = geary_db_statement_get_type_once ();
		g_once_init_leave (&geary_db_statement_type_id__once, geary_db_statement_type_id);
	}
	return geary_db_statement_type_id__once;
}

static void
_vala_geary_db_statement_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	GearyDbStatement * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_DB_TYPE_STATEMENT, GearyDbStatement);
#line 8 "../src/engine/db/db-statement.vala"
	switch (property_id) {
#line 8 "../src/engine/db/db-statement.vala"
		case GEARY_DB_STATEMENT_SQL_PROPERTY:
#line 8 "../src/engine/db/db-statement.vala"
		g_value_set_string (value, geary_db_statement_get_sql (self));
#line 8 "../src/engine/db/db-statement.vala"
		break;
#line 8 "../src/engine/db/db-statement.vala"
		case GEARY_DB_STATEMENT_LOGGING_PARENT_PROPERTY:
#line 8 "../src/engine/db/db-statement.vala"
		g_value_set_object (value, geary_db_context_get_logging_parent (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_DB_TYPE_CONTEXT, GearyDbContext)));
#line 8 "../src/engine/db/db-statement.vala"
		break;
#line 8 "../src/engine/db/db-statement.vala"
		case GEARY_DB_STATEMENT_CONNECTION_PROPERTY:
#line 8 "../src/engine/db/db-statement.vala"
		g_value_set_object (value, geary_db_statement_get_connection (self));
#line 8 "../src/engine/db/db-statement.vala"
		break;
#line 1651 "db-statement.c"
		default:
#line 8 "../src/engine/db/db-statement.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/engine/db/db-statement.vala"
		break;
#line 1657 "db-statement.c"
	}
}

static void
_vala_geary_db_statement_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	GearyDbStatement * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_DB_TYPE_STATEMENT, GearyDbStatement);
#line 8 "../src/engine/db/db-statement.vala"
	switch (property_id) {
#line 8 "../src/engine/db/db-statement.vala"
		case GEARY_DB_STATEMENT_SQL_PROPERTY:
#line 8 "../src/engine/db/db-statement.vala"
		geary_db_statement_set_sql (self, g_value_get_string (value));
#line 8 "../src/engine/db/db-statement.vala"
		break;
#line 8 "../src/engine/db/db-statement.vala"
		case GEARY_DB_STATEMENT_CONNECTION_PROPERTY:
#line 8 "../src/engine/db/db-statement.vala"
		geary_db_statement_set_connection (self, g_value_get_object (value));
#line 8 "../src/engine/db/db-statement.vala"
		break;
#line 1683 "db-statement.c"
		default:
#line 8 "../src/engine/db/db-statement.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/engine/db/db-statement.vala"
		break;
#line 1689 "db-statement.c"
	}
}

