/* db-versioned-database.c generated by valac 0.56.17, the Vala compiler
 * generated from db-versioned-database.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2018 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <gio/gio.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_DB_VERSIONED_DATABASE_0_PROPERTY,
	GEARY_DB_VERSIONED_DATABASE_SCHEMA_DIR_PROPERTY,
	GEARY_DB_VERSIONED_DATABASE_NUM_PROPERTIES
};
static GParamSpec* geary_db_versioned_database_properties[GEARY_DB_VERSIONED_DATABASE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _GearyDbVersionedDatabasePreUpgradeData GearyDbVersionedDatabasePreUpgradeData;
typedef struct _GearyDbVersionedDatabasePostUpgradeData GearyDbVersionedDatabasePostUpgradeData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _GearyDbVersionedDatabaseOpenData GearyDbVersionedDatabaseOpenData;
typedef struct _Block24Data Block24Data;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _GearyDbVersionedDatabaseExecuteUpgradeData GearyDbVersionedDatabaseExecuteUpgradeData;
typedef struct _GearyDbVersionedDatabaseExistsData GearyDbVersionedDatabaseExistsData;

struct _GearyDbVersionedDatabasePrivate {
	GFile* _schema_dir;
};

struct _GearyDbVersionedDatabasePreUpgradeData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyDbVersionedDatabase* self;
	gint version;
	GCancellable* cancellable;
};

struct _GearyDbVersionedDatabasePostUpgradeData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyDbVersionedDatabase* self;
	gint version;
	GCancellable* cancellable;
};

struct _GearyDbVersionedDatabaseOpenData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyDbVersionedDatabase* self;
	GearyDbDatabaseFlags flags;
	GCancellable* cancellable;
	GearyDbDatabaseConnection* cx;
	GearyDbDatabaseConnection* _tmp0_;
	gint db_version;
	GearyDbDatabaseConnection* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean new_db;
	GFile* _tmp4_;
	GFile* _tmp5_;
	gboolean _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	GError* _tmp9_;
	gboolean started;
	gboolean _tmp10_;
	GFile* upgrade_script;
	gint _tmp11_;
	GFile* _tmp12_;
	GFile* _tmp13_;
	gint token;
	GearyNonblockingMutex* _tmp14_;
	GError* locked_err;
	GearyDbDatabaseConnection* _tmp15_;
	GFile* _tmp16_;
	GError* err;
	GError* _tmp17_;
	GError* _tmp18_;
	GearyNonblockingMutex* _tmp19_;
	GError* _tmp20_;
	GError* _tmp21_;
	GError* _tmp22_;
	GError* _inner_error0_;
};

struct _Block24Data {
	int _ref_count_;
	GearyDbVersionedDatabase* self;
	gint db_version;
	GFile* upgrade_script;
	GCancellable* cancellable;
	gpointer _async_data_;
};

struct _GearyDbVersionedDatabaseExecuteUpgradeData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyDbVersionedDatabase* self;
	GearyDbDatabaseConnection* cx;
	gint db_version;
	GFile* upgrade_script;
	GCancellable* cancellable;
	Block24Data* _data24_;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GError* err;
	GError* _tmp2_;
	GError* _tmp3_;
	const gchar* _tmp4_;
	GError* _tmp5_;
	GError* _tmp6_;
	GError* _vala1_err;
	GError* _tmp7_;
	GError* _tmp8_;
	const gchar* _tmp9_;
	GError* _tmp10_;
	GError* _tmp11_;
	GError* _vala2_err;
	GError* _tmp12_;
	GError* _tmp13_;
	const gchar* _tmp14_;
	GError* _tmp15_;
	GError* _tmp16_;
	GError* _inner_error0_;
};

struct _GearyDbVersionedDatabaseExistsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyDbVersionedDatabase* self;
	GFile* target;
	GCancellable* cancellable;
	gboolean result;
	gboolean ret;
	GFileInfo* _tmp0_;
	GFileInfo* _tmp1_;
	GError* _inner_error0_;
};

static gint GearyDbVersionedDatabase_private_offset;
static gpointer geary_db_versioned_database_parent_class = NULL;
static GearyNonblockingMutex* geary_db_versioned_database_upgrade_mutex;
static GearyNonblockingMutex* geary_db_versioned_database_upgrade_mutex = NULL;

static void geary_db_versioned_database_set_schema_dir (GearyDbVersionedDatabase* self,
                                                 GFile* value);
static void geary_db_versioned_database_real_starting_upgrade (GearyDbVersionedDatabase* self,
                                                        gint current_version,
                                                        gboolean new_db);
static void geary_db_versioned_database_real_pre_upgrade_data_free (gpointer _data);
static void geary_db_versioned_database_real_pre_upgrade (GearyDbVersionedDatabase* self,
                                                   gint version,
                                                   GCancellable* cancellable,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
static gboolean geary_db_versioned_database_real_pre_upgrade_co (GearyDbVersionedDatabasePreUpgradeData* _data_);
static void geary_db_versioned_database_real_post_upgrade_data_free (gpointer _data);
static void geary_db_versioned_database_real_post_upgrade (GearyDbVersionedDatabase* self,
                                                    gint version,
                                                    GCancellable* cancellable,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_);
static gboolean geary_db_versioned_database_real_post_upgrade_co (GearyDbVersionedDatabasePostUpgradeData* _data_);
static void geary_db_versioned_database_real_completed_upgrade (GearyDbVersionedDatabase* self,
                                                         gint final_version);
static void geary_db_versioned_database_real_open_data_free (gpointer _data);
static void geary_db_versioned_database_real_open (GearyDbDatabase* base,
                                            GearyDbDatabaseFlags flags,
                                            GCancellable* cancellable,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
static gboolean geary_db_versioned_database_real_open_co (GearyDbVersionedDatabaseOpenData* _data_);
static void geary_db_versioned_database_open_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_);
static void geary_db_versioned_database_exists (GearyDbVersionedDatabase* self,
                                         GFile* target,
                                         GCancellable* cancellable,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
static gboolean geary_db_versioned_database_exists_finish (GearyDbVersionedDatabase* self,
                                                    GAsyncResult* _res_);
static GFile* geary_db_versioned_database_get_schema_file (GearyDbVersionedDatabase* self,
                                                    gint db_version);
static void geary_db_versioned_database_execute_upgrade (GearyDbVersionedDatabase* self,
                                                  GearyDbDatabaseConnection* cx,
                                                  gint db_version,
                                                  GFile* upgrade_script,
                                                  GCancellable* cancellable,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
static void geary_db_versioned_database_execute_upgrade_finish (GearyDbVersionedDatabase* self,
                                                         GAsyncResult* _res_,
                                                         GError** error);
static void geary_db_versioned_database_execute_upgrade_data_free (gpointer _data);
static gboolean geary_db_versioned_database_execute_upgrade_co (GearyDbVersionedDatabaseExecuteUpgradeData* _data_);
static Block24Data* block24_data_ref (Block24Data* _data24_);
static void block24_data_unref (void * _userdata_);
VALA_EXTERN void geary_db_check_cancelled (const gchar* method,
                               GCancellable* cancellable,
                               GError** error);
static void geary_db_versioned_database_execute_upgrade_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_);
static GearyDbTransactionOutcome ___lambda24_ (Block24Data* _data24_,
                                        GearyDbConnection* cx,
                                        GError** error);
static GearyDbTransactionOutcome ____lambda24__geary_db_transaction_method (GearyDbConnection* cx,
                                                                     GCancellable* cancellable,
                                                                     gpointer self,
                                                                     GError** error);
static void geary_db_versioned_database_exists_data_free (gpointer _data);
static gboolean geary_db_versioned_database_exists_co (GearyDbVersionedDatabaseExistsData* _data_);
static void geary_db_versioned_database_exists_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static void geary_db_versioned_database_finalize (GObject * obj);
static GType geary_db_versioned_database_get_type_once (void);
static void _vala_geary_db_versioned_database_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_geary_db_versioned_database_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);

static inline gpointer
geary_db_versioned_database_get_instance_private (GearyDbVersionedDatabase* self)
{
	return G_STRUCT_MEMBER_P (self, GearyDbVersionedDatabase_private_offset);
}

GFile*
geary_db_versioned_database_get_schema_dir (GearyDbVersionedDatabase* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 31 "../src/engine/db/db-versioned-database.vala"
	g_return_val_if_fail (GEARY_DB_IS_VERSIONED_DATABASE (self), NULL);
#line 31 "../src/engine/db/db-versioned-database.vala"
	_tmp0_ = self->priv->_schema_dir;
#line 31 "../src/engine/db/db-versioned-database.vala"
	result = _tmp0_;
#line 31 "../src/engine/db/db-versioned-database.vala"
	return result;
#line 276 "db-versioned-database.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 31 "../src/engine/db/db-versioned-database.vala"
	return self ? g_object_ref (self) : NULL;
#line 284 "db-versioned-database.c"
}

static void
geary_db_versioned_database_set_schema_dir (GearyDbVersionedDatabase* self,
                                            GFile* value)
{
	GFile* old_value;
#line 31 "../src/engine/db/db-versioned-database.vala"
	g_return_if_fail (GEARY_DB_IS_VERSIONED_DATABASE (self));
#line 31 "../src/engine/db/db-versioned-database.vala"
	old_value = geary_db_versioned_database_get_schema_dir (self);
#line 31 "../src/engine/db/db-versioned-database.vala"
	if (old_value != value) {
#line 298 "db-versioned-database.c"
		GFile* _tmp0_;
#line 31 "../src/engine/db/db-versioned-database.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 31 "../src/engine/db/db-versioned-database.vala"
		_g_object_unref0 (self->priv->_schema_dir);
#line 31 "../src/engine/db/db-versioned-database.vala"
		self->priv->_schema_dir = _tmp0_;
#line 31 "../src/engine/db/db-versioned-database.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_db_versioned_database_properties[GEARY_DB_VERSIONED_DATABASE_SCHEMA_DIR_PROPERTY]);
#line 308 "db-versioned-database.c"
	}
}

/** {@inheritDoc} */
GearyDbVersionedDatabase*
geary_db_versioned_database_construct_persistent (GType object_type,
                                                  GFile* db_file,
                                                  GFile* schema_dir)
{
	GearyDbVersionedDatabase * self = NULL;
#line 34 "../src/engine/db/db-versioned-database.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (db_file, g_file_get_type ()), NULL);
#line 34 "../src/engine/db/db-versioned-database.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (schema_dir, g_file_get_type ()), NULL);
#line 35 "../src/engine/db/db-versioned-database.vala"
	self = (GearyDbVersionedDatabase*) geary_db_database_construct_persistent (object_type, db_file);
#line 36 "../src/engine/db/db-versioned-database.vala"
	geary_db_versioned_database_set_schema_dir (self, schema_dir);
#line 34 "../src/engine/db/db-versioned-database.vala"
	return self;
#line 329 "db-versioned-database.c"
}

GearyDbVersionedDatabase*
geary_db_versioned_database_new_persistent (GFile* db_file,
                                            GFile* schema_dir)
{
#line 34 "../src/engine/db/db-versioned-database.vala"
	return geary_db_versioned_database_construct_persistent (GEARY_DB_TYPE_VERSIONED_DATABASE, db_file, schema_dir);
#line 338 "db-versioned-database.c"
}

/** {@inheritDoc} */
GearyDbVersionedDatabase*
geary_db_versioned_database_construct_transient (GType object_type,
                                                 GFile* schema_dir)
{
	GearyDbVersionedDatabase * self = NULL;
#line 40 "../src/engine/db/db-versioned-database.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (schema_dir, g_file_get_type ()), NULL);
#line 41 "../src/engine/db/db-versioned-database.vala"
	self = (GearyDbVersionedDatabase*) geary_db_database_construct_transient (object_type);
#line 42 "../src/engine/db/db-versioned-database.vala"
	geary_db_versioned_database_set_schema_dir (self, schema_dir);
#line 40 "../src/engine/db/db-versioned-database.vala"
	return self;
#line 355 "db-versioned-database.c"
}

GearyDbVersionedDatabase*
geary_db_versioned_database_new_transient (GFile* schema_dir)
{
#line 40 "../src/engine/db/db-versioned-database.vala"
	return geary_db_versioned_database_construct_transient (GEARY_DB_TYPE_VERSIONED_DATABASE, schema_dir);
#line 363 "db-versioned-database.c"
}

/** Returns the current schema version number of this database. */
gint
geary_db_versioned_database_get_schema_version (GearyDbVersionedDatabase* self,
                                                GError** error)
{
	GearyDbDatabaseConnection* _tmp0_ = NULL;
	GearyDbDatabaseConnection* _tmp1_;
	gint _tmp3_ = 0;
	GError* _inner_error0_ = NULL;
	gint result;
#line 46 "../src/engine/db/db-versioned-database.vala"
	g_return_val_if_fail (GEARY_DB_IS_VERSIONED_DATABASE (self), 0);
#line 48 "../src/engine/db/db-versioned-database.vala"
	_tmp1_ = geary_db_database_get_primary_connection (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), &_inner_error0_);
#line 48 "../src/engine/db/db-versioned-database.vala"
	_tmp0_ = _tmp1_;
#line 48 "../src/engine/db/db-versioned-database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 384 "db-versioned-database.c"
		gint _tmp2_ = -1;
#line 48 "../src/engine/db/db-versioned-database.vala"
		g_propagate_error (error, _inner_error0_);
#line 48 "../src/engine/db/db-versioned-database.vala"
		return _tmp2_;
#line 390 "db-versioned-database.c"
	}
#line 48 "../src/engine/db/db-versioned-database.vala"
	_tmp3_ = geary_db_connection_get_user_version_number (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_DB_TYPE_CONNECTION, GearyDbConnection), &_inner_error0_);
#line 48 "../src/engine/db/db-versioned-database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 396 "db-versioned-database.c"
		gint _tmp4_ = -1;
#line 48 "../src/engine/db/db-versioned-database.vala"
		g_propagate_error (error, _inner_error0_);
#line 48 "../src/engine/db/db-versioned-database.vala"
		_g_object_unref0 (_tmp0_);
#line 48 "../src/engine/db/db-versioned-database.vala"
		return _tmp4_;
#line 404 "db-versioned-database.c"
	}
#line 48 "../src/engine/db/db-versioned-database.vala"
	result = _tmp3_;
#line 48 "../src/engine/db/db-versioned-database.vala"
	_g_object_unref0 (_tmp0_);
#line 48 "../src/engine/db/db-versioned-database.vala"
	return result;
#line 412 "db-versioned-database.c"
}

/**
     * Called by {@link open} if a schema upgrade is required and beginning.
     *
     * If new_db is set to true, the database is being created from scratch.
     */
static void
geary_db_versioned_database_real_starting_upgrade (GearyDbVersionedDatabase* self,
                                                   gint current_version,
                                                   gboolean new_db)
{
}

void
geary_db_versioned_database_starting_upgrade (GearyDbVersionedDatabase* self,
                                              gint current_version,
                                              gboolean new_db)
{
	GearyDbVersionedDatabaseClass* _klass_;
#line 56 "../src/engine/db/db-versioned-database.vala"
	g_return_if_fail (GEARY_DB_IS_VERSIONED_DATABASE (self));
#line 56 "../src/engine/db/db-versioned-database.vala"
	_klass_ = GEARY_DB_VERSIONED_DATABASE_GET_CLASS (self);
#line 56 "../src/engine/db/db-versioned-database.vala"
	if (_klass_->starting_upgrade) {
#line 56 "../src/engine/db/db-versioned-database.vala"
		_klass_->starting_upgrade (self, current_version, new_db);
#line 441 "db-versioned-database.c"
	}
}

static void
geary_db_versioned_database_real_pre_upgrade_data_free (gpointer _data)
{
	GearyDbVersionedDatabasePreUpgradeData* _data_;
	_data_ = _data;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/engine/db/db-versioned-database.vala"
	g_slice_free (GearyDbVersionedDatabasePreUpgradeData, _data_);
#line 456 "db-versioned-database.c"
}

static void
geary_db_versioned_database_real_pre_upgrade (GearyDbVersionedDatabase* self,
                                              gint version,
                                              GCancellable* cancellable,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	GearyDbVersionedDatabasePreUpgradeData* _data_;
	GearyDbVersionedDatabase* _tmp0_;
	GCancellable* _tmp1_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_ = g_slice_new0 (GearyDbVersionedDatabasePreUpgradeData);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/engine/db/db-versioned-database.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_db_versioned_database_real_pre_upgrade_data_free);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_->self = _tmp0_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_->version = version;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_->cancellable = _tmp1_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	geary_db_versioned_database_real_pre_upgrade_co (_data_);
#line 491 "db-versioned-database.c"
}

static void
geary_db_versioned_database_real_pre_upgrade_finish (GearyDbVersionedDatabase* self,
                                                     GAsyncResult* _res_,
                                                     GError** error)
{
	GearyDbVersionedDatabasePreUpgradeData* _data_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/engine/db/db-versioned-database.vala"
	if (NULL == _data_) {
#line 24 "../src/engine/db/db-versioned-database.vala"
		return;
#line 506 "db-versioned-database.c"
	}
}

/**
     * Called by {@link open} just before performing a schema upgrade step.
     */
static gboolean
geary_db_versioned_database_real_pre_upgrade_co (GearyDbVersionedDatabasePreUpgradeData* _data_)
{
#line 62 "../src/engine/db/db-versioned-database.vala"
	switch (_data_->_state_) {
#line 62 "../src/engine/db/db-versioned-database.vala"
		case 0:
#line 520 "db-versioned-database.c"
		goto _state_0;
		default:
#line 62 "../src/engine/db/db-versioned-database.vala"
		g_assert_not_reached ();
#line 525 "db-versioned-database.c"
	}
	_state_0:
#line 62 "../src/engine/db/db-versioned-database.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 62 "../src/engine/db/db-versioned-database.vala"
	if (_data_->_state_ != 0) {
#line 62 "../src/engine/db/db-versioned-database.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 62 "../src/engine/db/db-versioned-database.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 536 "db-versioned-database.c"
		}
	}
#line 62 "../src/engine/db/db-versioned-database.vala"
	g_object_unref (_data_->_async_result);
#line 62 "../src/engine/db/db-versioned-database.vala"
	return FALSE;
#line 543 "db-versioned-database.c"
}

void
geary_db_versioned_database_pre_upgrade (GearyDbVersionedDatabase* self,
                                         gint version,
                                         GCancellable* cancellable,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	GearyDbVersionedDatabaseClass* _klass_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_klass_ = GEARY_DB_VERSIONED_DATABASE_GET_CLASS (self);
#line 24 "../src/engine/db/db-versioned-database.vala"
	if (_klass_->pre_upgrade) {
#line 24 "../src/engine/db/db-versioned-database.vala"
		_klass_->pre_upgrade (self, version, cancellable, _callback_, _user_data_);
#line 560 "db-versioned-database.c"
	}
}

void
geary_db_versioned_database_pre_upgrade_finish (GearyDbVersionedDatabase* self,
                                                GAsyncResult* _res_,
                                                GError** error)
{
	GearyDbVersionedDatabaseClass* _klass_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_klass_ = GEARY_DB_VERSIONED_DATABASE_GET_CLASS (self);
#line 24 "../src/engine/db/db-versioned-database.vala"
	if (_klass_->pre_upgrade_finish) {
#line 24 "../src/engine/db/db-versioned-database.vala"
		_klass_->pre_upgrade_finish (self, _res_, error);
#line 576 "db-versioned-database.c"
	}
}

static void
geary_db_versioned_database_real_post_upgrade_data_free (gpointer _data)
{
	GearyDbVersionedDatabasePostUpgradeData* _data_;
	_data_ = _data;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/engine/db/db-versioned-database.vala"
	g_slice_free (GearyDbVersionedDatabasePostUpgradeData, _data_);
#line 591 "db-versioned-database.c"
}

static void
geary_db_versioned_database_real_post_upgrade (GearyDbVersionedDatabase* self,
                                               gint version,
                                               GCancellable* cancellable,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
	GearyDbVersionedDatabasePostUpgradeData* _data_;
	GearyDbVersionedDatabase* _tmp0_;
	GCancellable* _tmp1_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_ = g_slice_new0 (GearyDbVersionedDatabasePostUpgradeData);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/engine/db/db-versioned-database.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_db_versioned_database_real_post_upgrade_data_free);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_->self = _tmp0_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_->version = version;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_->cancellable = _tmp1_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	geary_db_versioned_database_real_post_upgrade_co (_data_);
#line 626 "db-versioned-database.c"
}

static void
geary_db_versioned_database_real_post_upgrade_finish (GearyDbVersionedDatabase* self,
                                                      GAsyncResult* _res_,
                                                      GError** error)
{
	GearyDbVersionedDatabasePostUpgradeData* _data_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/engine/db/db-versioned-database.vala"
	if (NULL == _data_) {
#line 24 "../src/engine/db/db-versioned-database.vala"
		return;
#line 641 "db-versioned-database.c"
	}
}

/**
     * Called by {@link open} just after performing a schema upgrade step.
     */
static gboolean
geary_db_versioned_database_real_post_upgrade_co (GearyDbVersionedDatabasePostUpgradeData* _data_)
{
#line 69 "../src/engine/db/db-versioned-database.vala"
	switch (_data_->_state_) {
#line 69 "../src/engine/db/db-versioned-database.vala"
		case 0:
#line 655 "db-versioned-database.c"
		goto _state_0;
		default:
#line 69 "../src/engine/db/db-versioned-database.vala"
		g_assert_not_reached ();
#line 660 "db-versioned-database.c"
	}
	_state_0:
#line 69 "../src/engine/db/db-versioned-database.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 69 "../src/engine/db/db-versioned-database.vala"
	if (_data_->_state_ != 0) {
#line 69 "../src/engine/db/db-versioned-database.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 69 "../src/engine/db/db-versioned-database.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 671 "db-versioned-database.c"
		}
	}
#line 69 "../src/engine/db/db-versioned-database.vala"
	g_object_unref (_data_->_async_result);
#line 69 "../src/engine/db/db-versioned-database.vala"
	return FALSE;
#line 678 "db-versioned-database.c"
}

void
geary_db_versioned_database_post_upgrade (GearyDbVersionedDatabase* self,
                                          gint version,
                                          GCancellable* cancellable,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	GearyDbVersionedDatabaseClass* _klass_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_klass_ = GEARY_DB_VERSIONED_DATABASE_GET_CLASS (self);
#line 24 "../src/engine/db/db-versioned-database.vala"
	if (_klass_->post_upgrade) {
#line 24 "../src/engine/db/db-versioned-database.vala"
		_klass_->post_upgrade (self, version, cancellable, _callback_, _user_data_);
#line 695 "db-versioned-database.c"
	}
}

void
geary_db_versioned_database_post_upgrade_finish (GearyDbVersionedDatabase* self,
                                                 GAsyncResult* _res_,
                                                 GError** error)
{
	GearyDbVersionedDatabaseClass* _klass_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_klass_ = GEARY_DB_VERSIONED_DATABASE_GET_CLASS (self);
#line 24 "../src/engine/db/db-versioned-database.vala"
	if (_klass_->post_upgrade_finish) {
#line 24 "../src/engine/db/db-versioned-database.vala"
		_klass_->post_upgrade_finish (self, _res_, error);
#line 711 "db-versioned-database.c"
	}
}

/**
     * Called by {@link open} if a schema upgrade was required and has now completed.
     */
static void
geary_db_versioned_database_real_completed_upgrade (GearyDbVersionedDatabase* self,
                                                    gint final_version)
{
}

void
geary_db_versioned_database_completed_upgrade (GearyDbVersionedDatabase* self,
                                               gint final_version)
{
	GearyDbVersionedDatabaseClass* _klass_;
#line 76 "../src/engine/db/db-versioned-database.vala"
	g_return_if_fail (GEARY_DB_IS_VERSIONED_DATABASE (self));
#line 76 "../src/engine/db/db-versioned-database.vala"
	_klass_ = GEARY_DB_VERSIONED_DATABASE_GET_CLASS (self);
#line 76 "../src/engine/db/db-versioned-database.vala"
	if (_klass_->completed_upgrade) {
#line 76 "../src/engine/db/db-versioned-database.vala"
		_klass_->completed_upgrade (self, final_version);
#line 737 "db-versioned-database.c"
	}
}

static void
geary_db_versioned_database_real_open_data_free (gpointer _data)
{
	GearyDbVersionedDatabaseOpenData* _data_;
	_data_ = _data;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/engine/db/db-versioned-database.vala"
	g_slice_free (GearyDbVersionedDatabaseOpenData, _data_);
#line 752 "db-versioned-database.c"
}

static void
geary_db_versioned_database_real_open (GearyDbDatabase* base,
                                       GearyDbDatabaseFlags flags,
                                       GCancellable* cancellable,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	GearyDbVersionedDatabase * self;
	GearyDbVersionedDatabaseOpenData* _data_;
	GearyDbVersionedDatabase* _tmp0_;
	GCancellable* _tmp1_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 24 "../src/engine/db/db-versioned-database.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_DB_TYPE_VERSIONED_DATABASE, GearyDbVersionedDatabase);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_ = g_slice_new0 (GearyDbVersionedDatabaseOpenData);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/engine/db/db-versioned-database.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_db_versioned_database_real_open_data_free);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_->self = _tmp0_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_->flags = flags;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_->cancellable = _tmp1_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	geary_db_versioned_database_real_open_co (_data_);
#line 790 "db-versioned-database.c"
}

static void
geary_db_versioned_database_open_finish (GearyDbDatabase* base,
                                         GAsyncResult* _res_,
                                         GError** error)
{
	GearyDbVersionedDatabaseOpenData* _data_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/engine/db/db-versioned-database.vala"
	if (NULL == _data_) {
#line 24 "../src/engine/db/db-versioned-database.vala"
		return;
#line 805 "db-versioned-database.c"
	}
}

/**
     * Prepares the database for use, initializing and upgrading the schema.
     *
     * If it's detected that the database has a schema version that's
     * unavailable in the schema directory, throws {@link
     * DatabaseError.SCHEMA_VERSION}.  Generally this indicates the
     * user attempted to load the database with an older version of
     * the application.
     */
static void
geary_db_versioned_database_open_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_)
{
	GearyDbVersionedDatabaseOpenData* _data_;
#line 91 "../src/engine/db/db-versioned-database.vala"
	_data_ = _user_data_;
#line 91 "../src/engine/db/db-versioned-database.vala"
	_data_->_source_object_ = source_object;
#line 91 "../src/engine/db/db-versioned-database.vala"
	_data_->_res_ = _res_;
#line 91 "../src/engine/db/db-versioned-database.vala"
	geary_db_versioned_database_real_open_co (_data_);
#line 832 "db-versioned-database.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 160 "../src/engine/db/db-versioned-database.vala"
	return self ? g_error_copy (self) : NULL;
#line 840 "db-versioned-database.c"
}

static gboolean
geary_db_versioned_database_real_open_co (GearyDbVersionedDatabaseOpenData* _data_)
{
#line 88 "../src/engine/db/db-versioned-database.vala"
	switch (_data_->_state_) {
#line 88 "../src/engine/db/db-versioned-database.vala"
		case 0:
#line 850 "db-versioned-database.c"
		goto _state_0;
#line 88 "../src/engine/db/db-versioned-database.vala"
		case 1:
#line 854 "db-versioned-database.c"
		goto _state_1;
#line 88 "../src/engine/db/db-versioned-database.vala"
		case 2:
#line 858 "db-versioned-database.c"
		goto _state_2;
#line 88 "../src/engine/db/db-versioned-database.vala"
		case 3:
#line 862 "db-versioned-database.c"
		goto _state_3;
#line 88 "../src/engine/db/db-versioned-database.vala"
		case 4:
#line 866 "db-versioned-database.c"
		goto _state_4;
#line 88 "../src/engine/db/db-versioned-database.vala"
		case 5:
#line 870 "db-versioned-database.c"
		goto _state_5;
#line 88 "../src/engine/db/db-versioned-database.vala"
		case 6:
#line 874 "db-versioned-database.c"
		goto _state_6;
		default:
#line 88 "../src/engine/db/db-versioned-database.vala"
		g_assert_not_reached ();
#line 879 "db-versioned-database.c"
	}
	_state_0:
#line 91 "../src/engine/db/db-versioned-database.vala"
	_data_->_state_ = 1;
#line 91 "../src/engine/db/db-versioned-database.vala"
	GEARY_DB_DATABASE_CLASS (geary_db_versioned_database_parent_class)->open (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->flags, _data_->cancellable, geary_db_versioned_database_open_ready, _data_);
#line 91 "../src/engine/db/db-versioned-database.vala"
	return FALSE;
#line 888 "db-versioned-database.c"
	_state_1:
#line 91 "../src/engine/db/db-versioned-database.vala"
	GEARY_DB_DATABASE_CLASS (geary_db_versioned_database_parent_class)->open_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error0_);
#line 91 "../src/engine/db/db-versioned-database.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 91 "../src/engine/db/db-versioned-database.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 91 "../src/engine/db/db-versioned-database.vala"
		g_object_unref (_data_->_async_result);
#line 91 "../src/engine/db/db-versioned-database.vala"
		return FALSE;
#line 900 "db-versioned-database.c"
	}
#line 94 "../src/engine/db/db-versioned-database.vala"
	_data_->_state_ = 2;
#line 94 "../src/engine/db/db-versioned-database.vala"
	geary_db_database_open_connection (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->cancellable, geary_db_versioned_database_open_ready, _data_);
#line 94 "../src/engine/db/db-versioned-database.vala"
	return FALSE;
#line 908 "db-versioned-database.c"
	_state_2:
#line 94 "../src/engine/db/db-versioned-database.vala"
	_data_->_tmp0_ = geary_db_database_open_connection_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error0_);
#line 94 "../src/engine/db/db-versioned-database.vala"
	_data_->cx = _data_->_tmp0_;
#line 94 "../src/engine/db/db-versioned-database.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 94 "../src/engine/db/db-versioned-database.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 94 "../src/engine/db/db-versioned-database.vala"
		g_object_unref (_data_->_async_result);
#line 94 "../src/engine/db/db-versioned-database.vala"
		return FALSE;
#line 922 "db-versioned-database.c"
	}
#line 96 "../src/engine/db/db-versioned-database.vala"
	_data_->_tmp1_ = _data_->cx;
#line 96 "../src/engine/db/db-versioned-database.vala"
	_data_->db_version = geary_db_connection_get_user_version_number (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp1_, GEARY_DB_TYPE_CONNECTION, GearyDbConnection), &_data_->_inner_error0_);
#line 96 "../src/engine/db/db-versioned-database.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 96 "../src/engine/db/db-versioned-database.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 96 "../src/engine/db/db-versioned-database.vala"
		_g_object_unref0 (_data_->cx);
#line 96 "../src/engine/db/db-versioned-database.vala"
		g_object_unref (_data_->_async_result);
#line 96 "../src/engine/db/db-versioned-database.vala"
		return FALSE;
#line 938 "db-versioned-database.c"
	}
#line 97 "../src/engine/db/db-versioned-database.vala"
	_data_->_tmp2_ = geary_db_database_get_path (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_DB_TYPE_DATABASE, GearyDbDatabase));
#line 97 "../src/engine/db/db-versioned-database.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 97 "../src/engine/db/db-versioned-database.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "VersionedDatabase.upgrade: current database schema for %s: %d", _data_->_tmp3_, _data_->db_version);
#line 102 "../src/engine/db/db-versioned-database.vala"
	_data_->new_db = _data_->db_version <= 0;
#line 105 "../src/engine/db/db-versioned-database.vala"
	if (_data_->db_version < 0) {
#line 106 "../src/engine/db/db-versioned-database.vala"
		_data_->db_version = 0;
#line 952 "db-versioned-database.c"
	}
#line 108 "../src/engine/db/db-versioned-database.vala"
	if (_data_->db_version > 0) {
#line 120 "../src/engine/db/db-versioned-database.vala"
		_data_->_tmp4_ = geary_db_versioned_database_get_schema_file (_data_->self, _data_->db_version);
#line 120 "../src/engine/db/db-versioned-database.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 120 "../src/engine/db/db-versioned-database.vala"
		_data_->_state_ = 3;
#line 120 "../src/engine/db/db-versioned-database.vala"
		geary_db_versioned_database_exists (_data_->self, _data_->_tmp5_, _data_->cancellable, geary_db_versioned_database_open_ready, _data_);
#line 120 "../src/engine/db/db-versioned-database.vala"
		return FALSE;
#line 966 "db-versioned-database.c"
		_state_3:
#line 120 "../src/engine/db/db-versioned-database.vala"
		_data_->_tmp6_ = !geary_db_versioned_database_exists_finish (_data_->self, _data_->_res_);
#line 120 "../src/engine/db/db-versioned-database.vala"
		_g_object_unref0 (_data_->_tmp5_);
#line 120 "../src/engine/db/db-versioned-database.vala"
		if (_data_->_tmp6_) {
#line 121 "../src/engine/db/db-versioned-database.vala"
			_data_->_tmp7_ = geary_db_database_get_path (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_DB_TYPE_DATABASE, GearyDbDatabase));
#line 121 "../src/engine/db/db-versioned-database.vala"
			_data_->_tmp8_ = _data_->_tmp7_;
#line 121 "../src/engine/db/db-versioned-database.vala"
			_data_->_tmp9_ = g_error_new (GEARY_DATABASE_ERROR, GEARY_DATABASE_ERROR_SCHEMA_VERSION, "%s schema %d unknown to current schema plan", _data_->_tmp8_, _data_->db_version);
#line 121 "../src/engine/db/db-versioned-database.vala"
			_data_->_inner_error0_ = _data_->_tmp9_;
#line 121 "../src/engine/db/db-versioned-database.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 121 "../src/engine/db/db-versioned-database.vala"
			_g_object_unref0 (_data_->cx);
#line 121 "../src/engine/db/db-versioned-database.vala"
			g_object_unref (_data_->_async_result);
#line 121 "../src/engine/db/db-versioned-database.vala"
			return FALSE;
#line 990 "db-versioned-database.c"
		}
	}
#line 129 "../src/engine/db/db-versioned-database.vala"
	_data_->started = FALSE;
#line 995 "db-versioned-database.c"
	{
#line 130 "../src/engine/db/db-versioned-database.vala"
		_data_->_tmp10_ = TRUE;
#line 130 "../src/engine/db/db-versioned-database.vala"
		while (TRUE) {
#line 130 "../src/engine/db/db-versioned-database.vala"
			if (!_data_->_tmp10_) {
#line 1003 "db-versioned-database.c"
			}
#line 130 "../src/engine/db/db-versioned-database.vala"
			_data_->_tmp10_ = FALSE;
#line 131 "../src/engine/db/db-versioned-database.vala"
			_data_->db_version = _data_->db_version + 1;
#line 131 "../src/engine/db/db-versioned-database.vala"
			_data_->_tmp11_ = _data_->db_version;
#line 131 "../src/engine/db/db-versioned-database.vala"
			_data_->_tmp12_ = geary_db_versioned_database_get_schema_file (_data_->self, _data_->_tmp11_);
#line 131 "../src/engine/db/db-versioned-database.vala"
			_data_->upgrade_script = _data_->_tmp12_;
#line 132 "../src/engine/db/db-versioned-database.vala"
			_data_->_tmp13_ = _data_->upgrade_script;
#line 132 "../src/engine/db/db-versioned-database.vala"
			_data_->_state_ = 4;
#line 132 "../src/engine/db/db-versioned-database.vala"
			geary_db_versioned_database_exists (_data_->self, _data_->_tmp13_, _data_->cancellable, geary_db_versioned_database_open_ready, _data_);
#line 132 "../src/engine/db/db-versioned-database.vala"
			return FALSE;
#line 1023 "db-versioned-database.c"
			_state_4:
#line 132 "../src/engine/db/db-versioned-database.vala"
			if (!geary_db_versioned_database_exists_finish (_data_->self, _data_->_res_)) {
#line 133 "../src/engine/db/db-versioned-database.vala"
				_g_object_unref0 (_data_->upgrade_script);
#line 133 "../src/engine/db/db-versioned-database.vala"
				break;
#line 1031 "db-versioned-database.c"
			}
#line 136 "../src/engine/db/db-versioned-database.vala"
			if (!_data_->started) {
#line 137 "../src/engine/db/db-versioned-database.vala"
				geary_db_versioned_database_starting_upgrade (_data_->self, _data_->db_version, _data_->new_db);
#line 138 "../src/engine/db/db-versioned-database.vala"
				_data_->started = TRUE;
#line 1039 "db-versioned-database.c"
			}
#line 150 "../src/engine/db/db-versioned-database.vala"
			_data_->_tmp14_ = geary_db_versioned_database_upgrade_mutex;
#line 150 "../src/engine/db/db-versioned-database.vala"
			_data_->_state_ = 5;
#line 150 "../src/engine/db/db-versioned-database.vala"
			geary_nonblocking_mutex_claim_async (_data_->_tmp14_, _data_->cancellable, geary_db_versioned_database_open_ready, _data_);
#line 150 "../src/engine/db/db-versioned-database.vala"
			return FALSE;
#line 1049 "db-versioned-database.c"
			_state_5:
#line 150 "../src/engine/db/db-versioned-database.vala"
			_data_->token = geary_nonblocking_mutex_claim_finish (_data_->_tmp14_, _data_->_res_, &_data_->_inner_error0_);
#line 150 "../src/engine/db/db-versioned-database.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 150 "../src/engine/db/db-versioned-database.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 150 "../src/engine/db/db-versioned-database.vala"
				_g_object_unref0 (_data_->upgrade_script);
#line 150 "../src/engine/db/db-versioned-database.vala"
				_g_object_unref0 (_data_->cx);
#line 150 "../src/engine/db/db-versioned-database.vala"
				g_object_unref (_data_->_async_result);
#line 150 "../src/engine/db/db-versioned-database.vala"
				return FALSE;
#line 1065 "db-versioned-database.c"
			}
#line 154 "../src/engine/db/db-versioned-database.vala"
			_data_->locked_err = NULL;
#line 1069 "db-versioned-database.c"
			{
#line 156 "../src/engine/db/db-versioned-database.vala"
				_data_->_tmp15_ = _data_->cx;
#line 156 "../src/engine/db/db-versioned-database.vala"
				_data_->_tmp16_ = _data_->upgrade_script;
#line 156 "../src/engine/db/db-versioned-database.vala"
				_data_->_state_ = 6;
#line 156 "../src/engine/db/db-versioned-database.vala"
				geary_db_versioned_database_execute_upgrade (_data_->self, _data_->_tmp15_, _data_->db_version, _data_->_tmp16_, _data_->cancellable, geary_db_versioned_database_open_ready, _data_);
#line 156 "../src/engine/db/db-versioned-database.vala"
				return FALSE;
#line 1081 "db-versioned-database.c"
				_state_6:
#line 156 "../src/engine/db/db-versioned-database.vala"
				geary_db_versioned_database_execute_upgrade_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 156 "../src/engine/db/db-versioned-database.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1087 "db-versioned-database.c"
					goto __catch0_g_error;
				}
			}
			goto __finally0;
			__catch0_g_error:
			{
#line 155 "../src/engine/db/db-versioned-database.vala"
				_data_->err = _data_->_inner_error0_;
#line 155 "../src/engine/db/db-versioned-database.vala"
				_data_->_inner_error0_ = NULL;
#line 160 "../src/engine/db/db-versioned-database.vala"
				_data_->_tmp17_ = _data_->err;
#line 160 "../src/engine/db/db-versioned-database.vala"
				_data_->_tmp18_ = _g_error_copy0 (_data_->_tmp17_);
#line 160 "../src/engine/db/db-versioned-database.vala"
				_g_error_free0 (_data_->locked_err);
#line 160 "../src/engine/db/db-versioned-database.vala"
				_data_->locked_err = _data_->_tmp18_;
#line 155 "../src/engine/db/db-versioned-database.vala"
				_g_error_free0 (_data_->err);
#line 1108 "db-versioned-database.c"
			}
			__finally0:
#line 155 "../src/engine/db/db-versioned-database.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 155 "../src/engine/db/db-versioned-database.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 155 "../src/engine/db/db-versioned-database.vala"
				_g_error_free0 (_data_->locked_err);
#line 155 "../src/engine/db/db-versioned-database.vala"
				_g_object_unref0 (_data_->upgrade_script);
#line 155 "../src/engine/db/db-versioned-database.vala"
				_g_object_unref0 (_data_->cx);
#line 155 "../src/engine/db/db-versioned-database.vala"
				g_object_unref (_data_->_async_result);
#line 155 "../src/engine/db/db-versioned-database.vala"
				return FALSE;
#line 1125 "db-versioned-database.c"
			}
#line 163 "../src/engine/db/db-versioned-database.vala"
			_data_->_tmp19_ = geary_db_versioned_database_upgrade_mutex;
#line 163 "../src/engine/db/db-versioned-database.vala"
			geary_nonblocking_mutex_release (_data_->_tmp19_, &_data_->token, &_data_->_inner_error0_);
#line 163 "../src/engine/db/db-versioned-database.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 163 "../src/engine/db/db-versioned-database.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 163 "../src/engine/db/db-versioned-database.vala"
				_g_error_free0 (_data_->locked_err);
#line 163 "../src/engine/db/db-versioned-database.vala"
				_g_object_unref0 (_data_->upgrade_script);
#line 163 "../src/engine/db/db-versioned-database.vala"
				_g_object_unref0 (_data_->cx);
#line 163 "../src/engine/db/db-versioned-database.vala"
				g_object_unref (_data_->_async_result);
#line 163 "../src/engine/db/db-versioned-database.vala"
				return FALSE;
#line 1145 "db-versioned-database.c"
			}
#line 165 "../src/engine/db/db-versioned-database.vala"
			_data_->_tmp20_ = _data_->locked_err;
#line 165 "../src/engine/db/db-versioned-database.vala"
			if (_data_->_tmp20_ != NULL) {
#line 166 "../src/engine/db/db-versioned-database.vala"
				_data_->_tmp21_ = _data_->locked_err;
#line 166 "../src/engine/db/db-versioned-database.vala"
				_data_->_tmp22_ = _g_error_copy0 (_data_->_tmp21_);
#line 166 "../src/engine/db/db-versioned-database.vala"
				_data_->_inner_error0_ = _data_->_tmp22_;
#line 166 "../src/engine/db/db-versioned-database.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 166 "../src/engine/db/db-versioned-database.vala"
				_g_error_free0 (_data_->locked_err);
#line 166 "../src/engine/db/db-versioned-database.vala"
				_g_object_unref0 (_data_->upgrade_script);
#line 166 "../src/engine/db/db-versioned-database.vala"
				_g_object_unref0 (_data_->cx);
#line 166 "../src/engine/db/db-versioned-database.vala"
				g_object_unref (_data_->_async_result);
#line 166 "../src/engine/db/db-versioned-database.vala"
				return FALSE;
#line 1169 "db-versioned-database.c"
			}
#line 130 "../src/engine/db/db-versioned-database.vala"
			_g_error_free0 (_data_->locked_err);
#line 130 "../src/engine/db/db-versioned-database.vala"
			_g_object_unref0 (_data_->upgrade_script);
#line 1175 "db-versioned-database.c"
		}
	}
#line 170 "../src/engine/db/db-versioned-database.vala"
	if (_data_->started) {
#line 171 "../src/engine/db/db-versioned-database.vala"
		geary_db_versioned_database_completed_upgrade (_data_->self, _data_->db_version);
#line 1182 "db-versioned-database.c"
	}
#line 88 "../src/engine/db/db-versioned-database.vala"
	_g_object_unref0 (_data_->cx);
#line 88 "../src/engine/db/db-versioned-database.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 88 "../src/engine/db/db-versioned-database.vala"
	if (_data_->_state_ != 0) {
#line 88 "../src/engine/db/db-versioned-database.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 88 "../src/engine/db/db-versioned-database.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1194 "db-versioned-database.c"
		}
	}
#line 88 "../src/engine/db/db-versioned-database.vala"
	g_object_unref (_data_->_async_result);
#line 88 "../src/engine/db/db-versioned-database.vala"
	return FALSE;
#line 1201 "db-versioned-database.c"
}

static void
geary_db_versioned_database_execute_upgrade_data_free (gpointer _data)
{
	GearyDbVersionedDatabaseExecuteUpgradeData* _data_;
	_data_ = _data;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_g_object_unref0 (_data_->cx);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/engine/db/db-versioned-database.vala"
	g_slice_free (GearyDbVersionedDatabaseExecuteUpgradeData, _data_);
#line 1215 "db-versioned-database.c"
}

static void
geary_db_versioned_database_execute_upgrade (GearyDbVersionedDatabase* self,
                                             GearyDbDatabaseConnection* cx,
                                             gint db_version,
                                             GFile* upgrade_script,
                                             GCancellable* cancellable,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_)
{
	GearyDbVersionedDatabaseExecuteUpgradeData* _data_;
	GearyDbVersionedDatabase* _tmp0_;
	GearyDbDatabaseConnection* _tmp1_;
	GFile* _tmp2_;
	GCancellable* _tmp3_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	g_return_if_fail (GEARY_DB_IS_VERSIONED_DATABASE (self));
#line 24 "../src/engine/db/db-versioned-database.vala"
	g_return_if_fail (GEARY_DB_IS_DATABASE_CONNECTION (cx));
#line 24 "../src/engine/db/db-versioned-database.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (upgrade_script, g_file_get_type ()));
#line 24 "../src/engine/db/db-versioned-database.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_ = g_slice_new0 (GearyDbVersionedDatabaseExecuteUpgradeData);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/engine/db/db-versioned-database.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_db_versioned_database_execute_upgrade_data_free);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_->self = _tmp0_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_tmp1_ = _g_object_ref0 (cx);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_g_object_unref0 (_data_->cx);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_->cx = _tmp1_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_->db_version = db_version;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_tmp2_ = _g_object_ref0 (upgrade_script);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_g_object_unref0 (_data_->upgrade_script);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_->upgrade_script = _tmp2_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_->cancellable = _tmp3_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	geary_db_versioned_database_execute_upgrade_co (_data_);
#line 1272 "db-versioned-database.c"
}

static void
geary_db_versioned_database_execute_upgrade_finish (GearyDbVersionedDatabase* self,
                                                    GAsyncResult* _res_,
                                                    GError** error)
{
	GearyDbVersionedDatabaseExecuteUpgradeData* _data_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/engine/db/db-versioned-database.vala"
	if (NULL == _data_) {
#line 24 "../src/engine/db/db-versioned-database.vala"
		return;
#line 1287 "db-versioned-database.c"
	}
}

static Block24Data*
block24_data_ref (Block24Data* _data24_)
{
#line 174 "../src/engine/db/db-versioned-database.vala"
	g_atomic_int_inc (&_data24_->_ref_count_);
#line 174 "../src/engine/db/db-versioned-database.vala"
	return _data24_;
#line 1298 "db-versioned-database.c"
}

static void
block24_data_unref (void * _userdata_)
{
	Block24Data* _data24_;
	_data24_ = (Block24Data*) _userdata_;
#line 174 "../src/engine/db/db-versioned-database.vala"
	if (g_atomic_int_dec_and_test (&_data24_->_ref_count_)) {
#line 1308 "db-versioned-database.c"
		GearyDbVersionedDatabase* self;
#line 174 "../src/engine/db/db-versioned-database.vala"
		self = _data24_->self;
#line 174 "../src/engine/db/db-versioned-database.vala"
		_g_object_unref0 (_data24_->upgrade_script);
#line 174 "../src/engine/db/db-versioned-database.vala"
		_g_object_unref0 (_data24_->cancellable);
#line 174 "../src/engine/db/db-versioned-database.vala"
		_g_object_unref0 (self);
#line 174 "../src/engine/db/db-versioned-database.vala"
		g_slice_free (Block24Data, _data24_);
#line 1320 "db-versioned-database.c"
	}
}

static void
geary_db_versioned_database_execute_upgrade_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_)
{
	GearyDbVersionedDatabaseExecuteUpgradeData* _data_;
#line 184 "../src/engine/db/db-versioned-database.vala"
	_data_ = _user_data_;
#line 184 "../src/engine/db/db-versioned-database.vala"
	_data_->_source_object_ = source_object;
#line 184 "../src/engine/db/db-versioned-database.vala"
	_data_->_res_ = _res_;
#line 184 "../src/engine/db/db-versioned-database.vala"
	geary_db_versioned_database_execute_upgrade_co (_data_);
#line 1338 "db-versioned-database.c"
}

static GearyDbTransactionOutcome
___lambda24_ (Block24Data* _data24_,
              GearyDbConnection* cx,
              GError** error)
{
	GearyDbVersionedDatabase* self;
	GError* _inner_error0_ = NULL;
	GearyDbTransactionOutcome result;
#line 195 "../src/engine/db/db-versioned-database.vala"
	self = _data24_->self;
#line 195 "../src/engine/db/db-versioned-database.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 196 "../src/engine/db/db-versioned-database.vala"
	geary_db_connection_exec_file (cx, _data24_->upgrade_script, _data24_->cancellable, &_inner_error0_);
#line 196 "../src/engine/db/db-versioned-database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 196 "../src/engine/db/db-versioned-database.vala"
		g_propagate_error (error, _inner_error0_);
#line 196 "../src/engine/db/db-versioned-database.vala"
		return 0;
#line 1361 "db-versioned-database.c"
	}
#line 197 "../src/engine/db/db-versioned-database.vala"
	geary_db_connection_set_user_version_number (cx, _data24_->db_version, &_inner_error0_);
#line 197 "../src/engine/db/db-versioned-database.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 197 "../src/engine/db/db-versioned-database.vala"
		g_propagate_error (error, _inner_error0_);
#line 197 "../src/engine/db/db-versioned-database.vala"
		return 0;
#line 1371 "db-versioned-database.c"
	}
#line 199 "../src/engine/db/db-versioned-database.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_COMMIT;
#line 199 "../src/engine/db/db-versioned-database.vala"
	return result;
#line 1377 "db-versioned-database.c"
}

static GearyDbTransactionOutcome
____lambda24__geary_db_transaction_method (GearyDbConnection* cx,
                                           GCancellable* cancellable,
                                           gpointer self,
                                           GError** error)
{
	GearyDbTransactionOutcome result;
	result = ___lambda24_ (self, cx, error);
#line 195 "../src/engine/db/db-versioned-database.vala"
	return result;
#line 1390 "db-versioned-database.c"
}

static gboolean
geary_db_versioned_database_execute_upgrade_co (GearyDbVersionedDatabaseExecuteUpgradeData* _data_)
{
#line 174 "../src/engine/db/db-versioned-database.vala"
	switch (_data_->_state_) {
#line 174 "../src/engine/db/db-versioned-database.vala"
		case 0:
#line 1400 "db-versioned-database.c"
		goto _state_0;
#line 174 "../src/engine/db/db-versioned-database.vala"
		case 1:
#line 1404 "db-versioned-database.c"
		goto _state_1;
#line 174 "../src/engine/db/db-versioned-database.vala"
		case 2:
#line 1408 "db-versioned-database.c"
		goto _state_2;
#line 174 "../src/engine/db/db-versioned-database.vala"
		case 3:
#line 1412 "db-versioned-database.c"
		goto _state_3;
		default:
#line 174 "../src/engine/db/db-versioned-database.vala"
		g_assert_not_reached ();
#line 1417 "db-versioned-database.c"
	}
	_state_0:
#line 174 "../src/engine/db/db-versioned-database.vala"
	_data_->_data24_ = g_slice_new0 (Block24Data);
#line 174 "../src/engine/db/db-versioned-database.vala"
	_data_->_data24_->_ref_count_ = 1;
#line 174 "../src/engine/db/db-versioned-database.vala"
	_data_->_data24_->self = g_object_ref (_data_->self);
#line 174 "../src/engine/db/db-versioned-database.vala"
	_data_->_data24_->db_version = _data_->db_version;
#line 174 "../src/engine/db/db-versioned-database.vala"
	_g_object_unref0 (_data_->_data24_->upgrade_script);
#line 174 "../src/engine/db/db-versioned-database.vala"
	_data_->_data24_->upgrade_script = _data_->upgrade_script;
#line 174 "../src/engine/db/db-versioned-database.vala"
	_g_object_unref0 (_data_->_data24_->cancellable);
#line 174 "../src/engine/db/db-versioned-database.vala"
	_data_->_data24_->cancellable = _data_->cancellable;
#line 174 "../src/engine/db/db-versioned-database.vala"
	_data_->_data24_->_async_data_ = _data_;
#line 179 "../src/engine/db/db-versioned-database.vala"
	_data_->_tmp0_ = g_file_get_path (_data_->_data24_->upgrade_script);
#line 179 "../src/engine/db/db-versioned-database.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 179 "../src/engine/db/db-versioned-database.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Upgrading database to version %d with %s", _data_->_data24_->db_version, _data_->_tmp1_);
#line 179 "../src/engine/db/db-versioned-database.vala"
	_g_free0 (_data_->_tmp1_);
#line 182 "../src/engine/db/db-versioned-database.vala"
	geary_db_check_cancelled ("VersionedDatabase.open", _data_->_data24_->cancellable, &_data_->_inner_error0_);
#line 182 "../src/engine/db/db-versioned-database.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 182 "../src/engine/db/db-versioned-database.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 182 "../src/engine/db/db-versioned-database.vala"
		block24_data_unref (_data_->_data24_);
#line 182 "../src/engine/db/db-versioned-database.vala"
		_data_->_data24_ = NULL;
#line 182 "../src/engine/db/db-versioned-database.vala"
		g_object_unref (_data_->_async_result);
#line 182 "../src/engine/db/db-versioned-database.vala"
		return FALSE;
#line 1460 "db-versioned-database.c"
	}
	{
#line 184 "../src/engine/db/db-versioned-database.vala"
		_data_->_state_ = 1;
#line 184 "../src/engine/db/db-versioned-database.vala"
		geary_db_versioned_database_pre_upgrade (_data_->self, _data_->_data24_->db_version, _data_->_data24_->cancellable, geary_db_versioned_database_execute_upgrade_ready, _data_);
#line 184 "../src/engine/db/db-versioned-database.vala"
		return FALSE;
#line 1469 "db-versioned-database.c"
		_state_1:
#line 184 "../src/engine/db/db-versioned-database.vala"
		geary_db_versioned_database_pre_upgrade_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 184 "../src/engine/db/db-versioned-database.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1475 "db-versioned-database.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 183 "../src/engine/db/db-versioned-database.vala"
		_data_->err = _data_->_inner_error0_;
#line 183 "../src/engine/db/db-versioned-database.vala"
		_data_->_inner_error0_ = NULL;
#line 186 "../src/engine/db/db-versioned-database.vala"
		_data_->_tmp2_ = _data_->err;
#line 186 "../src/engine/db/db-versioned-database.vala"
		if (!g_error_matches (_data_->_tmp2_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 187 "../src/engine/db/db-versioned-database.vala"
			_data_->_tmp3_ = _data_->err;
#line 187 "../src/engine/db/db-versioned-database.vala"
			_data_->_tmp4_ = _data_->_tmp3_->message;
#line 187 "../src/engine/db/db-versioned-database.vala"
			geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Error executing pre-upgrade for version %d: %s", _data_->_data24_->db_version, _data_->_tmp4_);
#line 1496 "db-versioned-database.c"
		}
#line 190 "../src/engine/db/db-versioned-database.vala"
		_data_->_tmp5_ = _data_->err;
#line 190 "../src/engine/db/db-versioned-database.vala"
		_data_->_tmp6_ = _g_error_copy0 (_data_->_tmp5_);
#line 190 "../src/engine/db/db-versioned-database.vala"
		_data_->_inner_error0_ = _data_->_tmp6_;
#line 190 "../src/engine/db/db-versioned-database.vala"
		_g_error_free0 (_data_->err);
#line 1506 "db-versioned-database.c"
		goto __finally0;
	}
	__finally0:
#line 183 "../src/engine/db/db-versioned-database.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 183 "../src/engine/db/db-versioned-database.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 183 "../src/engine/db/db-versioned-database.vala"
		block24_data_unref (_data_->_data24_);
#line 183 "../src/engine/db/db-versioned-database.vala"
		_data_->_data24_ = NULL;
#line 183 "../src/engine/db/db-versioned-database.vala"
		g_object_unref (_data_->_async_result);
#line 183 "../src/engine/db/db-versioned-database.vala"
		return FALSE;
#line 1522 "db-versioned-database.c"
	}
#line 193 "../src/engine/db/db-versioned-database.vala"
	geary_db_check_cancelled ("VersionedDatabase.open", _data_->_data24_->cancellable, &_data_->_inner_error0_);
#line 193 "../src/engine/db/db-versioned-database.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 193 "../src/engine/db/db-versioned-database.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 193 "../src/engine/db/db-versioned-database.vala"
		block24_data_unref (_data_->_data24_);
#line 193 "../src/engine/db/db-versioned-database.vala"
		_data_->_data24_ = NULL;
#line 193 "../src/engine/db/db-versioned-database.vala"
		g_object_unref (_data_->_async_result);
#line 193 "../src/engine/db/db-versioned-database.vala"
		return FALSE;
#line 1538 "db-versioned-database.c"
	}
	{
#line 195 "../src/engine/db/db-versioned-database.vala"
		_data_->_state_ = 2;
#line 195 "../src/engine/db/db-versioned-database.vala"
		geary_db_database_connection_exec_transaction_async (_data_->cx, GEARY_DB_TRANSACTION_TYPE_EXCLUSIVE, ____lambda24__geary_db_transaction_method, _data_->_data24_, _data_->_data24_->cancellable, geary_db_versioned_database_execute_upgrade_ready, _data_);
#line 195 "../src/engine/db/db-versioned-database.vala"
		return FALSE;
#line 1547 "db-versioned-database.c"
		_state_2:
#line 195 "../src/engine/db/db-versioned-database.vala"
		geary_db_database_connection_exec_transaction_finish (_data_->cx, _data_->_res_, &_data_->_inner_error0_);
#line 195 "../src/engine/db/db-versioned-database.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1553 "db-versioned-database.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
#line 194 "../src/engine/db/db-versioned-database.vala"
		_data_->_vala1_err = _data_->_inner_error0_;
#line 194 "../src/engine/db/db-versioned-database.vala"
		_data_->_inner_error0_ = NULL;
#line 202 "../src/engine/db/db-versioned-database.vala"
		_data_->_tmp7_ = _data_->_vala1_err;
#line 202 "../src/engine/db/db-versioned-database.vala"
		if (!g_error_matches (_data_->_tmp7_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 203 "../src/engine/db/db-versioned-database.vala"
			_data_->_tmp8_ = _data_->_vala1_err;
#line 203 "../src/engine/db/db-versioned-database.vala"
			_data_->_tmp9_ = _data_->_tmp8_->message;
#line 203 "../src/engine/db/db-versioned-database.vala"
			geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Error upgrading database to version %d: %s", _data_->_data24_->db_version, _data_->_tmp9_);
#line 1574 "db-versioned-database.c"
		}
#line 206 "../src/engine/db/db-versioned-database.vala"
		_data_->_tmp10_ = _data_->_vala1_err;
#line 206 "../src/engine/db/db-versioned-database.vala"
		_data_->_tmp11_ = _g_error_copy0 (_data_->_tmp10_);
#line 206 "../src/engine/db/db-versioned-database.vala"
		_data_->_inner_error0_ = _data_->_tmp11_;
#line 206 "../src/engine/db/db-versioned-database.vala"
		_g_error_free0 (_data_->_vala1_err);
#line 1584 "db-versioned-database.c"
		goto __finally1;
	}
	__finally1:
#line 194 "../src/engine/db/db-versioned-database.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 194 "../src/engine/db/db-versioned-database.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 194 "../src/engine/db/db-versioned-database.vala"
		block24_data_unref (_data_->_data24_);
#line 194 "../src/engine/db/db-versioned-database.vala"
		_data_->_data24_ = NULL;
#line 194 "../src/engine/db/db-versioned-database.vala"
		g_object_unref (_data_->_async_result);
#line 194 "../src/engine/db/db-versioned-database.vala"
		return FALSE;
#line 1600 "db-versioned-database.c"
	}
#line 209 "../src/engine/db/db-versioned-database.vala"
	geary_db_check_cancelled ("VersionedDatabase.open", _data_->_data24_->cancellable, &_data_->_inner_error0_);
#line 209 "../src/engine/db/db-versioned-database.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 209 "../src/engine/db/db-versioned-database.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 209 "../src/engine/db/db-versioned-database.vala"
		block24_data_unref (_data_->_data24_);
#line 209 "../src/engine/db/db-versioned-database.vala"
		_data_->_data24_ = NULL;
#line 209 "../src/engine/db/db-versioned-database.vala"
		g_object_unref (_data_->_async_result);
#line 209 "../src/engine/db/db-versioned-database.vala"
		return FALSE;
#line 1616 "db-versioned-database.c"
	}
	{
#line 211 "../src/engine/db/db-versioned-database.vala"
		_data_->_state_ = 3;
#line 211 "../src/engine/db/db-versioned-database.vala"
		geary_db_versioned_database_post_upgrade (_data_->self, _data_->_data24_->db_version, _data_->_data24_->cancellable, geary_db_versioned_database_execute_upgrade_ready, _data_);
#line 211 "../src/engine/db/db-versioned-database.vala"
		return FALSE;
#line 1625 "db-versioned-database.c"
		_state_3:
#line 211 "../src/engine/db/db-versioned-database.vala"
		geary_db_versioned_database_post_upgrade_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 211 "../src/engine/db/db-versioned-database.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1631 "db-versioned-database.c"
			goto __catch2_g_error;
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
#line 210 "../src/engine/db/db-versioned-database.vala"
		_data_->_vala2_err = _data_->_inner_error0_;
#line 210 "../src/engine/db/db-versioned-database.vala"
		_data_->_inner_error0_ = NULL;
#line 213 "../src/engine/db/db-versioned-database.vala"
		_data_->_tmp12_ = _data_->_vala2_err;
#line 213 "../src/engine/db/db-versioned-database.vala"
		if (!g_error_matches (_data_->_tmp12_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 214 "../src/engine/db/db-versioned-database.vala"
			_data_->_tmp13_ = _data_->_vala2_err;
#line 214 "../src/engine/db/db-versioned-database.vala"
			_data_->_tmp14_ = _data_->_tmp13_->message;
#line 214 "../src/engine/db/db-versioned-database.vala"
			geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Error executing post-upgrade for version %d: %s", _data_->_data24_->db_version, _data_->_tmp14_);
#line 1652 "db-versioned-database.c"
		}
#line 217 "../src/engine/db/db-versioned-database.vala"
		_data_->_tmp15_ = _data_->_vala2_err;
#line 217 "../src/engine/db/db-versioned-database.vala"
		_data_->_tmp16_ = _g_error_copy0 (_data_->_tmp15_);
#line 217 "../src/engine/db/db-versioned-database.vala"
		_data_->_inner_error0_ = _data_->_tmp16_;
#line 217 "../src/engine/db/db-versioned-database.vala"
		_g_error_free0 (_data_->_vala2_err);
#line 1662 "db-versioned-database.c"
		goto __finally2;
	}
	__finally2:
#line 210 "../src/engine/db/db-versioned-database.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 210 "../src/engine/db/db-versioned-database.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 210 "../src/engine/db/db-versioned-database.vala"
		block24_data_unref (_data_->_data24_);
#line 210 "../src/engine/db/db-versioned-database.vala"
		_data_->_data24_ = NULL;
#line 210 "../src/engine/db/db-versioned-database.vala"
		g_object_unref (_data_->_async_result);
#line 210 "../src/engine/db/db-versioned-database.vala"
		return FALSE;
#line 1678 "db-versioned-database.c"
	}
#line 174 "../src/engine/db/db-versioned-database.vala"
	block24_data_unref (_data_->_data24_);
#line 174 "../src/engine/db/db-versioned-database.vala"
	_data_->_data24_ = NULL;
#line 174 "../src/engine/db/db-versioned-database.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 174 "../src/engine/db/db-versioned-database.vala"
	if (_data_->_state_ != 0) {
#line 174 "../src/engine/db/db-versioned-database.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 174 "../src/engine/db/db-versioned-database.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1692 "db-versioned-database.c"
		}
	}
#line 174 "../src/engine/db/db-versioned-database.vala"
	g_object_unref (_data_->_async_result);
#line 174 "../src/engine/db/db-versioned-database.vala"
	return FALSE;
#line 1699 "db-versioned-database.c"
}

static GFile*
geary_db_versioned_database_get_schema_file (GearyDbVersionedDatabase* self,
                                             gint db_version)
{
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* result;
#line 221 "../src/engine/db/db-versioned-database.vala"
	g_return_val_if_fail (GEARY_DB_IS_VERSIONED_DATABASE (self), NULL);
#line 222 "../src/engine/db/db-versioned-database.vala"
	_tmp0_ = self->priv->_schema_dir;
#line 222 "../src/engine/db/db-versioned-database.vala"
	_tmp1_ = g_strdup_printf ("version-%03d.sql", db_version);
#line 222 "../src/engine/db/db-versioned-database.vala"
	_tmp2_ = _tmp1_;
#line 222 "../src/engine/db/db-versioned-database.vala"
	_tmp3_ = g_file_get_child (_tmp0_, _tmp2_);
#line 222 "../src/engine/db/db-versioned-database.vala"
	_tmp4_ = _tmp3_;
#line 222 "../src/engine/db/db-versioned-database.vala"
	_g_free0 (_tmp2_);
#line 222 "../src/engine/db/db-versioned-database.vala"
	result = _tmp4_;
#line 222 "../src/engine/db/db-versioned-database.vala"
	return result;
#line 1730 "db-versioned-database.c"
}

static void
geary_db_versioned_database_exists_data_free (gpointer _data)
{
	GearyDbVersionedDatabaseExistsData* _data_;
	_data_ = _data;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_g_object_unref0 (_data_->target);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/engine/db/db-versioned-database.vala"
	g_slice_free (GearyDbVersionedDatabaseExistsData, _data_);
#line 1746 "db-versioned-database.c"
}

static void
geary_db_versioned_database_exists (GearyDbVersionedDatabase* self,
                                    GFile* target,
                                    GCancellable* cancellable,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	GearyDbVersionedDatabaseExistsData* _data_;
	GearyDbVersionedDatabase* _tmp0_;
	GFile* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	g_return_if_fail (GEARY_DB_IS_VERSIONED_DATABASE (self));
#line 24 "../src/engine/db/db-versioned-database.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (target, g_file_get_type ()));
#line 24 "../src/engine/db/db-versioned-database.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_ = g_slice_new0 (GearyDbVersionedDatabaseExistsData);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/engine/db/db-versioned-database.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_db_versioned_database_exists_data_free);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_->self = _tmp0_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_tmp1_ = _g_object_ref0 (target);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_g_object_unref0 (_data_->target);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_->target = _tmp1_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	geary_db_versioned_database_exists_co (_data_);
#line 1790 "db-versioned-database.c"
}

static gboolean
geary_db_versioned_database_exists_finish (GearyDbVersionedDatabase* self,
                                           GAsyncResult* _res_)
{
	gboolean result;
	GearyDbVersionedDatabaseExistsData* _data_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 24 "../src/engine/db/db-versioned-database.vala"
	if (NULL == _data_) {
#line 1803 "db-versioned-database.c"
		gboolean _tmp0_ = FALSE;
#line 24 "../src/engine/db/db-versioned-database.vala"
		return _tmp0_;
#line 1807 "db-versioned-database.c"
	}
#line 24 "../src/engine/db/db-versioned-database.vala"
	result = _data_->result;
#line 24 "../src/engine/db/db-versioned-database.vala"
	return result;
#line 1813 "db-versioned-database.c"
}

static void
geary_db_versioned_database_exists_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	GearyDbVersionedDatabaseExistsData* _data_;
#line 228 "../src/engine/db/db-versioned-database.vala"
	_data_ = _user_data_;
#line 228 "../src/engine/db/db-versioned-database.vala"
	_data_->_source_object_ = source_object;
#line 228 "../src/engine/db/db-versioned-database.vala"
	_data_->_res_ = _res_;
#line 228 "../src/engine/db/db-versioned-database.vala"
	geary_db_versioned_database_exists_co (_data_);
#line 1830 "db-versioned-database.c"
}

static gboolean
geary_db_versioned_database_exists_co (GearyDbVersionedDatabaseExistsData* _data_)
{
#line 225 "../src/engine/db/db-versioned-database.vala"
	switch (_data_->_state_) {
#line 225 "../src/engine/db/db-versioned-database.vala"
		case 0:
#line 1840 "db-versioned-database.c"
		goto _state_0;
#line 225 "../src/engine/db/db-versioned-database.vala"
		case 1:
#line 1844 "db-versioned-database.c"
		goto _state_1;
		default:
#line 225 "../src/engine/db/db-versioned-database.vala"
		g_assert_not_reached ();
#line 1849 "db-versioned-database.c"
	}
	_state_0:
#line 226 "../src/engine/db/db-versioned-database.vala"
	_data_->ret = TRUE;
#line 1854 "db-versioned-database.c"
	{
#line 228 "../src/engine/db/db-versioned-database.vala"
		_data_->_state_ = 1;
#line 228 "../src/engine/db/db-versioned-database.vala"
		g_file_query_info_async (_data_->target, G_FILE_ATTRIBUTE_STANDARD_TYPE, G_FILE_QUERY_INFO_NONE, G_PRIORITY_DEFAULT, _data_->cancellable, geary_db_versioned_database_exists_ready, _data_);
#line 228 "../src/engine/db/db-versioned-database.vala"
		return FALSE;
#line 1862 "db-versioned-database.c"
		_state_1:
#line 228 "../src/engine/db/db-versioned-database.vala"
		_data_->_tmp0_ = g_file_query_info_finish (_data_->target, _data_->_res_, &_data_->_inner_error0_);
#line 228 "../src/engine/db/db-versioned-database.vala"
		_data_->_tmp1_ = _data_->_tmp0_;
#line 228 "../src/engine/db/db-versioned-database.vala"
		_g_object_unref0 (_data_->_tmp1_);
#line 228 "../src/engine/db/db-versioned-database.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1872 "db-versioned-database.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 227 "../src/engine/db/db-versioned-database.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 235 "../src/engine/db/db-versioned-database.vala"
		_data_->ret = FALSE;
#line 1883 "db-versioned-database.c"
	}
	__finally0:
#line 227 "../src/engine/db/db-versioned-database.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 227 "../src/engine/db/db-versioned-database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 227 "../src/engine/db/db-versioned-database.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 227 "../src/engine/db/db-versioned-database.vala"
		g_object_unref (_data_->_async_result);
#line 227 "../src/engine/db/db-versioned-database.vala"
		return FALSE;
#line 1896 "db-versioned-database.c"
	}
#line 237 "../src/engine/db/db-versioned-database.vala"
	_data_->result = _data_->ret;
#line 237 "../src/engine/db/db-versioned-database.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 237 "../src/engine/db/db-versioned-database.vala"
	if (_data_->_state_ != 0) {
#line 237 "../src/engine/db/db-versioned-database.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 237 "../src/engine/db/db-versioned-database.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1908 "db-versioned-database.c"
		}
	}
#line 237 "../src/engine/db/db-versioned-database.vala"
	g_object_unref (_data_->_async_result);
#line 237 "../src/engine/db/db-versioned-database.vala"
	return FALSE;
#line 1915 "db-versioned-database.c"
}

GearyDbVersionedDatabase*
geary_db_versioned_database_construct (GType object_type)
{
	GearyDbVersionedDatabase * self = NULL;
#line 24 "../src/engine/db/db-versioned-database.vala"
	self = (GearyDbVersionedDatabase*) geary_db_database_construct (object_type);
#line 24 "../src/engine/db/db-versioned-database.vala"
	return self;
#line 1926 "db-versioned-database.c"
}

GearyDbVersionedDatabase*
geary_db_versioned_database_new (void)
{
#line 24 "../src/engine/db/db-versioned-database.vala"
	return geary_db_versioned_database_construct (GEARY_DB_TYPE_VERSIONED_DATABASE);
#line 1934 "db-versioned-database.c"
}

static void
geary_db_versioned_database_class_init (GearyDbVersionedDatabaseClass * klass,
                                        gpointer klass_data)
{
	GearyNonblockingMutex* _tmp0_;
#line 24 "../src/engine/db/db-versioned-database.vala"
	geary_db_versioned_database_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/engine/db/db-versioned-database.vala"
	g_type_class_adjust_private_offset (klass, &GearyDbVersionedDatabase_private_offset);
#line 24 "../src/engine/db/db-versioned-database.vala"
	((GearyDbVersionedDatabaseClass *) klass)->starting_upgrade = (void (*) (GearyDbVersionedDatabase*, gint, gboolean)) geary_db_versioned_database_real_starting_upgrade;
#line 24 "../src/engine/db/db-versioned-database.vala"
	((GearyDbVersionedDatabaseClass *) klass)->pre_upgrade = (void (*) (GearyDbVersionedDatabase*, gint, GCancellable*, GAsyncReadyCallback, gpointer)) geary_db_versioned_database_real_pre_upgrade;
#line 24 "../src/engine/db/db-versioned-database.vala"
	((GearyDbVersionedDatabaseClass *) klass)->pre_upgrade_finish = (void (*) (GearyDbVersionedDatabase*, GAsyncResult*, GError**)) geary_db_versioned_database_real_pre_upgrade_finish;
#line 24 "../src/engine/db/db-versioned-database.vala"
	((GearyDbVersionedDatabaseClass *) klass)->post_upgrade = (void (*) (GearyDbVersionedDatabase*, gint, GCancellable*, GAsyncReadyCallback, gpointer)) geary_db_versioned_database_real_post_upgrade;
#line 24 "../src/engine/db/db-versioned-database.vala"
	((GearyDbVersionedDatabaseClass *) klass)->post_upgrade_finish = (void (*) (GearyDbVersionedDatabase*, GAsyncResult*, GError**)) geary_db_versioned_database_real_post_upgrade_finish;
#line 24 "../src/engine/db/db-versioned-database.vala"
	((GearyDbVersionedDatabaseClass *) klass)->completed_upgrade = (void (*) (GearyDbVersionedDatabase*, gint)) geary_db_versioned_database_real_completed_upgrade;
#line 24 "../src/engine/db/db-versioned-database.vala"
	((GearyDbDatabaseClass *) klass)->open = (void (*) (GearyDbDatabase*, GearyDbDatabaseFlags, GCancellable*, GAsyncReadyCallback, gpointer)) geary_db_versioned_database_real_open;
#line 24 "../src/engine/db/db-versioned-database.vala"
	((GearyDbDatabaseClass *) klass)->open_finish = (void (*) (GearyDbDatabase*, GAsyncResult*, GError**)) geary_db_versioned_database_open_finish;
#line 24 "../src/engine/db/db-versioned-database.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_db_versioned_database_get_property;
#line 24 "../src/engine/db/db-versioned-database.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_db_versioned_database_set_property;
#line 24 "../src/engine/db/db-versioned-database.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_db_versioned_database_finalize;
#line 24 "../src/engine/db/db-versioned-database.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_DB_VERSIONED_DATABASE_SCHEMA_DIR_PROPERTY, geary_db_versioned_database_properties[GEARY_DB_VERSIONED_DATABASE_SCHEMA_DIR_PROPERTY] = g_param_spec_object ("schema-dir", "schema-dir", "schema-dir", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 27 "../src/engine/db/db-versioned-database.vala"
	_tmp0_ = geary_nonblocking_mutex_new ();
#line 27 "../src/engine/db/db-versioned-database.vala"
	geary_db_versioned_database_upgrade_mutex = _tmp0_;
#line 1974 "db-versioned-database.c"
}

static void
geary_db_versioned_database_instance_init (GearyDbVersionedDatabase * self,
                                           gpointer klass)
{
#line 24 "../src/engine/db/db-versioned-database.vala"
	self->priv = geary_db_versioned_database_get_instance_private (self);
#line 1983 "db-versioned-database.c"
}

static void
geary_db_versioned_database_finalize (GObject * obj)
{
	GearyDbVersionedDatabase * self;
#line 24 "../src/engine/db/db-versioned-database.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_DB_TYPE_VERSIONED_DATABASE, GearyDbVersionedDatabase);
#line 31 "../src/engine/db/db-versioned-database.vala"
	_g_object_unref0 (self->priv->_schema_dir);
#line 24 "../src/engine/db/db-versioned-database.vala"
	G_OBJECT_CLASS (geary_db_versioned_database_parent_class)->finalize (obj);
#line 1996 "db-versioned-database.c"
}

/**
 * A SQLite database with a versioned, upgradeable schema.
 *
 * This class uses the SQLite user version pragma to track the current
 * version of a database, and a set of SQL scripts (one per version)
 * to manage updating from one version to another. When the database
 * is first opened by a call to {@link open}, its current version is
 * checked against the set of available scripts, and each available
 * version script above the current version is applied in
 * order. Derived classes may override the {@link pre_upgrade} and
 * {@link post_upgrade} methods to perform additional work before and
 * after an upgrade script is executed, and {@link starting_upgrade}
 * and {@link completed_upgrade} to be notified of the upgrade process
 * starting and finishing.
 */
 G_GNUC_NO_INLINE static GType
geary_db_versioned_database_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyDbVersionedDatabaseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_db_versioned_database_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyDbVersionedDatabase), 0, (GInstanceInitFunc) geary_db_versioned_database_instance_init, NULL };
	GType geary_db_versioned_database_type_id;
	geary_db_versioned_database_type_id = g_type_register_static (GEARY_DB_TYPE_DATABASE, "GearyDbVersionedDatabase", &g_define_type_info, 0);
	GearyDbVersionedDatabase_private_offset = g_type_add_instance_private (geary_db_versioned_database_type_id, sizeof (GearyDbVersionedDatabasePrivate));
	return geary_db_versioned_database_type_id;
}

GType
geary_db_versioned_database_get_type (void)
{
	static gsize geary_db_versioned_database_type_id__once = 0;
	if (g_once_init_enter (&geary_db_versioned_database_type_id__once)) {
		GType geary_db_versioned_database_type_id;
		geary_db_versioned_database_type_id = geary_db_versioned_database_get_type_once ();
		g_once_init_leave (&geary_db_versioned_database_type_id__once, geary_db_versioned_database_type_id);
	}
	return geary_db_versioned_database_type_id__once;
}

static void
_vala_geary_db_versioned_database_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	GearyDbVersionedDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_DB_TYPE_VERSIONED_DATABASE, GearyDbVersionedDatabase);
#line 24 "../src/engine/db/db-versioned-database.vala"
	switch (property_id) {
#line 24 "../src/engine/db/db-versioned-database.vala"
		case GEARY_DB_VERSIONED_DATABASE_SCHEMA_DIR_PROPERTY:
#line 24 "../src/engine/db/db-versioned-database.vala"
		g_value_set_object (value, geary_db_versioned_database_get_schema_dir (self));
#line 24 "../src/engine/db/db-versioned-database.vala"
		break;
#line 2052 "db-versioned-database.c"
		default:
#line 24 "../src/engine/db/db-versioned-database.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/engine/db/db-versioned-database.vala"
		break;
#line 2058 "db-versioned-database.c"
	}
}

static void
_vala_geary_db_versioned_database_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	GearyDbVersionedDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_DB_TYPE_VERSIONED_DATABASE, GearyDbVersionedDatabase);
#line 24 "../src/engine/db/db-versioned-database.vala"
	switch (property_id) {
#line 24 "../src/engine/db/db-versioned-database.vala"
		case GEARY_DB_VERSIONED_DATABASE_SCHEMA_DIR_PROPERTY:
#line 24 "../src/engine/db/db-versioned-database.vala"
		geary_db_versioned_database_set_schema_dir (self, g_value_get_object (value));
#line 24 "../src/engine/db/db-versioned-database.vala"
		break;
#line 2078 "db-versioned-database.c"
		default:
#line 24 "../src/engine/db/db-versioned-database.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/engine/db/db-versioned-database.vala"
		break;
#line 2084 "db-versioned-database.c"
	}
}

