/* db.c generated by valac 0.56.17, the Vala compiler
 * generated from db.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib.h>
#include "geary-engine.h"
#include <sqlite3.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

typedef gint (*GearyDbSqliteExecOperation) (gpointer user_data);
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

gint sqlite3_enable_shared_cache (gint enabled);
VALA_EXTERN void geary_db_check_cancelled (const gchar* method,
                               GCancellable* cancellable,
                               GError** error);
VALA_EXTERN gint geary_db_throw_on_error (GearyDbContext* ctx,
                              const gchar* method,
                              gint _result_,
                              const gchar* raw,
                              GError** error);
VALA_EXTERN GearyDbDatabase* geary_db_context_get_database (GearyDbContext* self);
VALA_EXTERN GearyDbDatabaseConnection* geary_db_context_get_connection (GearyDbContext* self);
VALA_EXTERN sqlite3* geary_db_connection_get_db (GearyDbConnection* self);
VALA_EXTERN GearyDbStatement* geary_db_context_get_statement (GearyDbContext* self);

 G_GNUC_NO_INLINE static GType
geary_db_database_flags_get_type_once (void)
{
	static const GFlagsValue values[] = {{GEARY_DB_DATABASE_FLAGS_NONE, "GEARY_DB_DATABASE_FLAGS_NONE", "none"}, {GEARY_DB_DATABASE_FLAGS_CREATE_DIRECTORY, "GEARY_DB_DATABASE_FLAGS_CREATE_DIRECTORY", "create-directory"}, {GEARY_DB_DATABASE_FLAGS_CREATE_FILE, "GEARY_DB_DATABASE_FLAGS_CREATE_FILE", "create-file"}, {GEARY_DB_DATABASE_FLAGS_READ_ONLY, "GEARY_DB_DATABASE_FLAGS_READ_ONLY", "read-only"}, {GEARY_DB_DATABASE_FLAGS_CHECK_CORRUPTION, "GEARY_DB_DATABASE_FLAGS_CHECK_CORRUPTION", "check-corruption"}, {0, NULL, NULL}};
	GType geary_db_database_flags_type_id;
	geary_db_database_flags_type_id = g_flags_register_static ("GearyDbDatabaseFlags", values);
	return geary_db_database_flags_type_id;
}

GType
geary_db_database_flags_get_type (void)
{
	static gsize geary_db_database_flags_type_id__once = 0;
	if (g_once_init_enter (&geary_db_database_flags_type_id__once)) {
		GType geary_db_database_flags_type_id;
		geary_db_database_flags_type_id = geary_db_database_flags_get_type_once ();
		g_once_init_leave (&geary_db_database_flags_type_id__once, geary_db_database_flags_type_id);
	}
	return geary_db_database_flags_type_id__once;
}

 G_GNUC_NO_INLINE static GType
geary_db_reset_scope_get_type_once (void)
{
	static const GEnumValue values[] = {{GEARY_DB_RESET_SCOPE_SAVE_BINDINGS, "GEARY_DB_RESET_SCOPE_SAVE_BINDINGS", "save-bindings"}, {GEARY_DB_RESET_SCOPE_CLEAR_BINDINGS, "GEARY_DB_RESET_SCOPE_CLEAR_BINDINGS", "clear-bindings"}, {0, NULL, NULL}};
	GType geary_db_reset_scope_type_id;
	geary_db_reset_scope_type_id = g_enum_register_static ("GearyDbResetScope", values);
	return geary_db_reset_scope_type_id;
}

GType
geary_db_reset_scope_get_type (void)
{
	static gsize geary_db_reset_scope_type_id__once = 0;
	if (g_once_init_enter (&geary_db_reset_scope_type_id__once)) {
		GType geary_db_reset_scope_type_id;
		geary_db_reset_scope_type_id = geary_db_reset_scope_get_type_once ();
		g_once_init_leave (&geary_db_reset_scope_type_id__once, geary_db_reset_scope_type_id);
	}
	return geary_db_reset_scope_type_id__once;
}

/**
 * See [[http://www.sqlite.org/c3ref/threadsafe.html]]
 */
gboolean
geary_db_threadsafe (void)
{
	gboolean result;
#line 63 "../src/engine/db/db.vala"
	result = sqlite3_threadsafe () != 0;
#line 63 "../src/engine/db/db.vala"
	return result;
#line 99 "db.c"
}

/**
 * See [[http://www.sqlite.org/c3ref/libversion.html]]
 */
const gchar*
geary_db_sqlite_version (void)
{
	const gchar* _tmp0_;
	const gchar* result;
#line 70 "../src/engine/db/db.vala"
	_tmp0_ = sqlite3_libversion ();
#line 70 "../src/engine/db/db.vala"
	result = _tmp0_;
#line 70 "../src/engine/db/db.vala"
	return result;
#line 116 "db.c"
}

/**
 * See [[http://www.sqlite.org/c3ref/libversion.html]]
 */
gint
geary_db_sqlite_version_number (void)
{
	gint result;
#line 77 "../src/engine/db/db.vala"
	result = sqlite3_libversion_number ();
#line 77 "../src/engine/db/db.vala"
	return result;
#line 130 "db.c"
}

/**
 * See [[http://www.sqlite.org/c3ref/enable_shared_cache.html]]
 */
gboolean
geary_db_set_shared_cache_mode (gboolean enabled)
{
	gint _tmp0_ = 0;
	gboolean result;
#line 84 "../src/engine/db/db.vala"
	if (enabled) {
#line 84 "../src/engine/db/db.vala"
		_tmp0_ = 1;
#line 145 "db.c"
	} else {
#line 84 "../src/engine/db/db.vala"
		_tmp0_ = 0;
#line 149 "db.c"
	}
#line 84 "../src/engine/db/db.vala"
	result = sqlite3_enable_shared_cache (_tmp0_) == SQLITE_OK;
#line 84 "../src/engine/db/db.vala"
	return result;
#line 155 "db.c"
}

/** Standard transformation for case-insensitive string values. */
inline gchar*
geary_db_normalise_case_insensitive_query (const gchar* text)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 88 "../src/engine/db/db.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 95 "../src/engine/db/db.vala"
	_tmp0_ = g_utf8_normalize (text, (gssize) -1, G_NORMALIZE_DEFAULT);
#line 95 "../src/engine/db/db.vala"
	_tmp1_ = _tmp0_;
#line 95 "../src/engine/db/db.vala"
	_tmp2_ = g_utf8_casefold (_tmp1_, (gssize) -1);
#line 95 "../src/engine/db/db.vala"
	_tmp3_ = _tmp2_;
#line 95 "../src/engine/db/db.vala"
	_g_free0 (_tmp1_);
#line 95 "../src/engine/db/db.vala"
	result = _tmp3_;
#line 95 "../src/engine/db/db.vala"
	return result;
#line 183 "db.c"
}

void
geary_db_check_cancelled (const gchar* method,
                          GCancellable* cancellable,
                          GError** error)
{
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 98 "../src/engine/db/db.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 99 "../src/engine/db/db.vala"
	if (cancellable != NULL) {
#line 99 "../src/engine/db/db.vala"
		_tmp0_ = g_cancellable_is_cancelled (cancellable);
#line 199 "db.c"
	} else {
#line 99 "../src/engine/db/db.vala"
		_tmp0_ = FALSE;
#line 203 "db.c"
	}
#line 99 "../src/engine/db/db.vala"
	if (_tmp0_) {
#line 207 "db.c"
		const gchar* _tmp1_ = NULL;
		GError* _tmp2_;
#line 100 "../src/engine/db/db.vala"
		if (!geary_string_is_empty (method)) {
#line 100 "../src/engine/db/db.vala"
			_tmp1_ = method;
#line 214 "db.c"
		} else {
#line 100 "../src/engine/db/db.vala"
			_tmp1_ = "Operation";
#line 218 "db.c"
		}
#line 100 "../src/engine/db/db.vala"
		_tmp2_ = g_error_new (G_IO_ERROR, G_IO_ERROR_CANCELLED, "%s cancelled", _tmp1_);
#line 100 "../src/engine/db/db.vala"
		_inner_error0_ = _tmp2_;
#line 100 "../src/engine/db/db.vala"
		if (_inner_error0_->domain == G_IO_ERROR) {
#line 100 "../src/engine/db/db.vala"
			g_propagate_error (error, _inner_error0_);
#line 100 "../src/engine/db/db.vala"
			return;
#line 230 "db.c"
		} else {
#line 100 "../src/engine/db/db.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 100 "../src/engine/db/db.vala"
			g_clear_error (&_inner_error0_);
#line 100 "../src/engine/db/db.vala"
			return;
#line 238 "db.c"
		}
	}
}

gint
geary_db_throw_on_error (GearyDbContext* ctx,
                         const gchar* method,
                         gint _result_,
                         const gchar* raw,
                         GError** error)
{
	gchar* _tmp0_ = NULL;
	gchar* location = NULL;
	gchar* _tmp11_;
	gchar* _tmp12_ = NULL;
	GearyDbDatabaseConnection* _tmp13_;
	GearyDbDatabaseConnection* _tmp14_;
	gboolean _tmp15_;
	gchar* errmsg = NULL;
	gchar* _tmp23_;
	gchar* sql = NULL;
	GearyDbStatement* statement = NULL;
	GearyDbStatement* _tmp24_;
	GearyDbStatement* _tmp25_;
	gchar* msg = NULL;
	const gchar* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	gchar* _tmp40_;
	GError* _inner_error0_ = NULL;
	gint result;
#line 104 "../src/engine/db/db.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONTEXT (ctx), 0);
#line 106 "../src/engine/db/db.vala"
	switch (_result_) {
#line 106 "../src/engine/db/db.vala"
		case SQLITE_OK:
#line 106 "../src/engine/db/db.vala"
		case SQLITE_DONE:
#line 106 "../src/engine/db/db.vala"
		case SQLITE_ROW:
#line 280 "db.c"
		{
#line 110 "../src/engine/db/db.vala"
			result = _result_;
#line 110 "../src/engine/db/db.vala"
			return result;
#line 286 "db.c"
		}
		default:
#line 106 "../src/engine/db/db.vala"
		break;
#line 291 "db.c"
	}
#line 113 "../src/engine/db/db.vala"
	if (!geary_string_is_empty (method)) {
#line 295 "db.c"
		GearyDbDatabase* _tmp1_;
		GearyDbDatabase* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 114 "../src/engine/db/db.vala"
		_tmp1_ = geary_db_context_get_database (ctx);
#line 114 "../src/engine/db/db.vala"
		_tmp2_ = _tmp1_;
#line 114 "../src/engine/db/db.vala"
		_tmp3_ = geary_db_database_get_path (_tmp2_);
#line 114 "../src/engine/db/db.vala"
		_tmp4_ = _tmp3_;
#line 114 "../src/engine/db/db.vala"
		_tmp5_ = g_strdup_printf ("(%s %s) ", method, _tmp4_);
#line 114 "../src/engine/db/db.vala"
		_g_free0 (_tmp0_);
#line 114 "../src/engine/db/db.vala"
		_tmp0_ = _tmp5_;
#line 114 "../src/engine/db/db.vala"
		_g_object_unref0 (_tmp2_);
#line 317 "db.c"
	} else {
		GearyDbDatabase* _tmp6_;
		GearyDbDatabase* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 115 "../src/engine/db/db.vala"
		_tmp6_ = geary_db_context_get_database (ctx);
#line 115 "../src/engine/db/db.vala"
		_tmp7_ = _tmp6_;
#line 115 "../src/engine/db/db.vala"
		_tmp8_ = geary_db_database_get_path (_tmp7_);
#line 115 "../src/engine/db/db.vala"
		_tmp9_ = _tmp8_;
#line 115 "../src/engine/db/db.vala"
		_tmp10_ = g_strdup_printf ("(%s) ", _tmp9_);
#line 115 "../src/engine/db/db.vala"
		_g_free0 (_tmp0_);
#line 115 "../src/engine/db/db.vala"
		_tmp0_ = _tmp10_;
#line 115 "../src/engine/db/db.vala"
		_g_object_unref0 (_tmp7_);
#line 340 "db.c"
	}
#line 113 "../src/engine/db/db.vala"
	_tmp11_ = g_strdup (_tmp0_);
#line 113 "../src/engine/db/db.vala"
	location = _tmp11_;
#line 116 "../src/engine/db/db.vala"
	_tmp13_ = geary_db_context_get_connection (ctx);
#line 116 "../src/engine/db/db.vala"
	_tmp14_ = _tmp13_;
#line 116 "../src/engine/db/db.vala"
	_tmp15_ = _tmp14_ != NULL;
#line 116 "../src/engine/db/db.vala"
	_g_object_unref0 (_tmp14_);
#line 116 "../src/engine/db/db.vala"
	if (_tmp15_) {
#line 356 "db.c"
		GearyDbDatabaseConnection* _tmp16_;
		GearyDbDatabaseConnection* _tmp17_;
		sqlite3* _tmp18_;
		sqlite3* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
#line 116 "../src/engine/db/db.vala"
		_tmp16_ = geary_db_context_get_connection (ctx);
#line 116 "../src/engine/db/db.vala"
		_tmp17_ = _tmp16_;
#line 116 "../src/engine/db/db.vala"
		_tmp18_ = geary_db_connection_get_db (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEARY_DB_TYPE_CONNECTION, GearyDbConnection));
#line 116 "../src/engine/db/db.vala"
		_tmp19_ = _tmp18_;
#line 116 "../src/engine/db/db.vala"
		_tmp20_ = sqlite3_errmsg (_tmp19_);
#line 116 "../src/engine/db/db.vala"
		_tmp21_ = g_strdup_printf (" - %s", _tmp20_);
#line 116 "../src/engine/db/db.vala"
		_g_free0 (_tmp12_);
#line 116 "../src/engine/db/db.vala"
		_tmp12_ = _tmp21_;
#line 116 "../src/engine/db/db.vala"
		_g_object_unref0 (_tmp17_);
#line 381 "db.c"
	} else {
		gchar* _tmp22_;
#line 116 "../src/engine/db/db.vala"
		_tmp22_ = g_strdup ("");
#line 116 "../src/engine/db/db.vala"
		_g_free0 (_tmp12_);
#line 116 "../src/engine/db/db.vala"
		_tmp12_ = _tmp22_;
#line 390 "db.c"
	}
#line 116 "../src/engine/db/db.vala"
	_tmp23_ = g_strdup (_tmp12_);
#line 116 "../src/engine/db/db.vala"
	errmsg = _tmp23_;
#line 117 "../src/engine/db/db.vala"
	sql = NULL;
#line 118 "../src/engine/db/db.vala"
	_tmp24_ = geary_db_context_get_statement (ctx);
#line 118 "../src/engine/db/db.vala"
	statement = _tmp24_;
#line 119 "../src/engine/db/db.vala"
	_tmp25_ = statement;
#line 119 "../src/engine/db/db.vala"
	if (_tmp25_ != NULL) {
#line 406 "db.c"
		GearyDbStatement* _tmp26_;
		gchar* _tmp27_;
		const gchar* _tmp28_;
		const gchar* _tmp33_;
		gchar* _tmp34_;
#line 120 "../src/engine/db/db.vala"
		_tmp26_ = statement;
#line 120 "../src/engine/db/db.vala"
		_tmp27_ = geary_db_statement_get_expanded_sql (_tmp26_);
#line 120 "../src/engine/db/db.vala"
		_g_free0 (sql);
#line 120 "../src/engine/db/db.vala"
		sql = _tmp27_;
#line 121 "../src/engine/db/db.vala"
		_tmp28_ = sql;
#line 121 "../src/engine/db/db.vala"
		if (_tmp28_ == NULL) {
#line 424 "db.c"
			GearyDbStatement* _tmp29_;
			const gchar* _tmp30_;
			const gchar* _tmp31_;
			gchar* _tmp32_;
#line 122 "../src/engine/db/db.vala"
			_tmp29_ = statement;
#line 122 "../src/engine/db/db.vala"
			_tmp30_ = geary_db_statement_get_sql (_tmp29_);
#line 122 "../src/engine/db/db.vala"
			_tmp31_ = _tmp30_;
#line 122 "../src/engine/db/db.vala"
			_tmp32_ = g_strdup (_tmp31_);
#line 122 "../src/engine/db/db.vala"
			_g_free0 (sql);
#line 122 "../src/engine/db/db.vala"
			sql = _tmp32_;
#line 441 "db.c"
		}
#line 124 "../src/engine/db/db.vala"
		_tmp33_ = sql;
#line 124 "../src/engine/db/db.vala"
		_tmp34_ = g_strdup_printf (" (%s)", _tmp33_);
#line 124 "../src/engine/db/db.vala"
		_g_free0 (sql);
#line 124 "../src/engine/db/db.vala"
		sql = _tmp34_;
#line 451 "db.c"
	} else {
#line 125 "../src/engine/db/db.vala"
		if (!geary_string_is_empty (raw)) {
#line 455 "db.c"
			gchar* _tmp35_;
#line 126 "../src/engine/db/db.vala"
			_tmp35_ = g_strdup_printf (" (%s)", raw);
#line 126 "../src/engine/db/db.vala"
			_g_free0 (sql);
#line 126 "../src/engine/db/db.vala"
			sql = _tmp35_;
#line 463 "db.c"
		} else {
			gchar* _tmp36_;
#line 128 "../src/engine/db/db.vala"
			_tmp36_ = g_strdup ("");
#line 128 "../src/engine/db/db.vala"
			_g_free0 (sql);
#line 128 "../src/engine/db/db.vala"
			sql = _tmp36_;
#line 472 "db.c"
		}
	}
#line 131 "../src/engine/db/db.vala"
	_tmp37_ = location;
#line 131 "../src/engine/db/db.vala"
	_tmp38_ = errmsg;
#line 131 "../src/engine/db/db.vala"
	_tmp39_ = sql;
#line 131 "../src/engine/db/db.vala"
	_tmp40_ = g_strdup_printf ("%s[err=%d]%s%s", _tmp37_, _result_, _tmp38_, _tmp39_);
#line 131 "../src/engine/db/db.vala"
	msg = _tmp40_;
#line 133 "../src/engine/db/db.vala"
	switch (_result_) {
#line 133 "../src/engine/db/db.vala"
		case SQLITE_BUSY:
#line 133 "../src/engine/db/db.vala"
		case SQLITE_LOCKED:
#line 491 "db.c"
		{
			const gchar* _tmp41_;
			GError* _tmp42_;
#line 136 "../src/engine/db/db.vala"
			_tmp41_ = msg;
#line 136 "../src/engine/db/db.vala"
			_tmp42_ = g_error_new_literal (GEARY_DATABASE_ERROR, GEARY_DATABASE_ERROR_BUSY, _tmp41_);
#line 136 "../src/engine/db/db.vala"
			_inner_error0_ = _tmp42_;
#line 136 "../src/engine/db/db.vala"
			if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 503 "db.c"
				gint _tmp43_ = -1;
#line 136 "../src/engine/db/db.vala"
				g_propagate_error (error, _inner_error0_);
#line 136 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 136 "../src/engine/db/db.vala"
				_g_object_unref0 (statement);
#line 136 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 136 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 136 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 136 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 136 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 136 "../src/engine/db/db.vala"
				return _tmp43_;
#line 523 "db.c"
			} else {
				gint _tmp44_ = -1;
#line 136 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 136 "../src/engine/db/db.vala"
				_g_object_unref0 (statement);
#line 136 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 136 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 136 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 136 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 136 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 136 "../src/engine/db/db.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 136 "../src/engine/db/db.vala"
				g_clear_error (&_inner_error0_);
#line 136 "../src/engine/db/db.vala"
				return _tmp44_;
#line 546 "db.c"
			}
		}
#line 133 "../src/engine/db/db.vala"
		case SQLITE_IOERR:
#line 133 "../src/engine/db/db.vala"
		case SQLITE_PERM:
#line 133 "../src/engine/db/db.vala"
		case SQLITE_READONLY:
#line 133 "../src/engine/db/db.vala"
		case SQLITE_CANTOPEN:
#line 133 "../src/engine/db/db.vala"
		case SQLITE_NOLFS:
#line 133 "../src/engine/db/db.vala"
		case SQLITE_AUTH:
#line 561 "db.c"
		{
			const gchar* _tmp45_;
			GError* _tmp46_;
#line 144 "../src/engine/db/db.vala"
			_tmp45_ = msg;
#line 144 "../src/engine/db/db.vala"
			_tmp46_ = g_error_new_literal (GEARY_DATABASE_ERROR, GEARY_DATABASE_ERROR_ACCESS, _tmp45_);
#line 144 "../src/engine/db/db.vala"
			_inner_error0_ = _tmp46_;
#line 144 "../src/engine/db/db.vala"
			if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 573 "db.c"
				gint _tmp47_ = -1;
#line 144 "../src/engine/db/db.vala"
				g_propagate_error (error, _inner_error0_);
#line 144 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 144 "../src/engine/db/db.vala"
				_g_object_unref0 (statement);
#line 144 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 144 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 144 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 144 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 144 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 144 "../src/engine/db/db.vala"
				return _tmp47_;
#line 593 "db.c"
			} else {
				gint _tmp48_ = -1;
#line 144 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 144 "../src/engine/db/db.vala"
				_g_object_unref0 (statement);
#line 144 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 144 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 144 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 144 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 144 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 144 "../src/engine/db/db.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 144 "../src/engine/db/db.vala"
				g_clear_error (&_inner_error0_);
#line 144 "../src/engine/db/db.vala"
				return _tmp48_;
#line 616 "db.c"
			}
		}
#line 133 "../src/engine/db/db.vala"
		case SQLITE_CORRUPT:
#line 133 "../src/engine/db/db.vala"
		case SQLITE_FORMAT:
#line 133 "../src/engine/db/db.vala"
		case SQLITE_NOTADB:
#line 625 "db.c"
		{
			const gchar* _tmp49_;
			GError* _tmp50_;
#line 149 "../src/engine/db/db.vala"
			_tmp49_ = msg;
#line 149 "../src/engine/db/db.vala"
			_tmp50_ = g_error_new_literal (GEARY_DATABASE_ERROR, GEARY_DATABASE_ERROR_CORRUPT, _tmp49_);
#line 149 "../src/engine/db/db.vala"
			_inner_error0_ = _tmp50_;
#line 149 "../src/engine/db/db.vala"
			if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 637 "db.c"
				gint _tmp51_ = -1;
#line 149 "../src/engine/db/db.vala"
				g_propagate_error (error, _inner_error0_);
#line 149 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 149 "../src/engine/db/db.vala"
				_g_object_unref0 (statement);
#line 149 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 149 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 149 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 149 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 149 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 149 "../src/engine/db/db.vala"
				return _tmp51_;
#line 657 "db.c"
			} else {
				gint _tmp52_ = -1;
#line 149 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 149 "../src/engine/db/db.vala"
				_g_object_unref0 (statement);
#line 149 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 149 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 149 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 149 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 149 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 149 "../src/engine/db/db.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 149 "../src/engine/db/db.vala"
				g_clear_error (&_inner_error0_);
#line 149 "../src/engine/db/db.vala"
				return _tmp52_;
#line 680 "db.c"
			}
		}
#line 133 "../src/engine/db/db.vala"
		case SQLITE_NOMEM:
#line 685 "db.c"
		{
			const gchar* _tmp53_;
			GError* _tmp54_;
#line 152 "../src/engine/db/db.vala"
			_tmp53_ = msg;
#line 152 "../src/engine/db/db.vala"
			_tmp54_ = g_error_new_literal (GEARY_DATABASE_ERROR, GEARY_DATABASE_ERROR_MEMORY, _tmp53_);
#line 152 "../src/engine/db/db.vala"
			_inner_error0_ = _tmp54_;
#line 152 "../src/engine/db/db.vala"
			if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 697 "db.c"
				gint _tmp55_ = -1;
#line 152 "../src/engine/db/db.vala"
				g_propagate_error (error, _inner_error0_);
#line 152 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 152 "../src/engine/db/db.vala"
				_g_object_unref0 (statement);
#line 152 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 152 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 152 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 152 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 152 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 152 "../src/engine/db/db.vala"
				return _tmp55_;
#line 717 "db.c"
			} else {
				gint _tmp56_ = -1;
#line 152 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 152 "../src/engine/db/db.vala"
				_g_object_unref0 (statement);
#line 152 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 152 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 152 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 152 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 152 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 152 "../src/engine/db/db.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 152 "../src/engine/db/db.vala"
				g_clear_error (&_inner_error0_);
#line 152 "../src/engine/db/db.vala"
				return _tmp56_;
#line 740 "db.c"
			}
		}
#line 133 "../src/engine/db/db.vala"
		case SQLITE_ABORT:
#line 745 "db.c"
		{
			const gchar* _tmp57_;
			GError* _tmp58_;
#line 155 "../src/engine/db/db.vala"
			_tmp57_ = msg;
#line 155 "../src/engine/db/db.vala"
			_tmp58_ = g_error_new_literal (GEARY_DATABASE_ERROR, GEARY_DATABASE_ERROR_ABORT, _tmp57_);
#line 155 "../src/engine/db/db.vala"
			_inner_error0_ = _tmp58_;
#line 155 "../src/engine/db/db.vala"
			if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 757 "db.c"
				gint _tmp59_ = -1;
#line 155 "../src/engine/db/db.vala"
				g_propagate_error (error, _inner_error0_);
#line 155 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 155 "../src/engine/db/db.vala"
				_g_object_unref0 (statement);
#line 155 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 155 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 155 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 155 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 155 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 155 "../src/engine/db/db.vala"
				return _tmp59_;
#line 777 "db.c"
			} else {
				gint _tmp60_ = -1;
#line 155 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 155 "../src/engine/db/db.vala"
				_g_object_unref0 (statement);
#line 155 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 155 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 155 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 155 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 155 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 155 "../src/engine/db/db.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 155 "../src/engine/db/db.vala"
				g_clear_error (&_inner_error0_);
#line 155 "../src/engine/db/db.vala"
				return _tmp60_;
#line 800 "db.c"
			}
		}
#line 133 "../src/engine/db/db.vala"
		case SQLITE_INTERRUPT:
#line 805 "db.c"
		{
			const gchar* _tmp61_;
			GError* _tmp62_;
#line 158 "../src/engine/db/db.vala"
			_tmp61_ = msg;
#line 158 "../src/engine/db/db.vala"
			_tmp62_ = g_error_new_literal (GEARY_DATABASE_ERROR, GEARY_DATABASE_ERROR_INTERRUPT, _tmp61_);
#line 158 "../src/engine/db/db.vala"
			_inner_error0_ = _tmp62_;
#line 158 "../src/engine/db/db.vala"
			if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 817 "db.c"
				gint _tmp63_ = -1;
#line 158 "../src/engine/db/db.vala"
				g_propagate_error (error, _inner_error0_);
#line 158 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 158 "../src/engine/db/db.vala"
				_g_object_unref0 (statement);
#line 158 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 158 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 158 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 158 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 158 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 158 "../src/engine/db/db.vala"
				return _tmp63_;
#line 837 "db.c"
			} else {
				gint _tmp64_ = -1;
#line 158 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 158 "../src/engine/db/db.vala"
				_g_object_unref0 (statement);
#line 158 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 158 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 158 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 158 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 158 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 158 "../src/engine/db/db.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 158 "../src/engine/db/db.vala"
				g_clear_error (&_inner_error0_);
#line 158 "../src/engine/db/db.vala"
				return _tmp64_;
#line 860 "db.c"
			}
		}
#line 133 "../src/engine/db/db.vala"
		case SQLITE_FULL:
#line 133 "../src/engine/db/db.vala"
		case SQLITE_EMPTY:
#line 133 "../src/engine/db/db.vala"
		case SQLITE_TOOBIG:
#line 133 "../src/engine/db/db.vala"
		case SQLITE_CONSTRAINT:
#line 133 "../src/engine/db/db.vala"
		case SQLITE_RANGE:
#line 873 "db.c"
		{
			const gchar* _tmp65_;
			GError* _tmp66_;
#line 165 "../src/engine/db/db.vala"
			_tmp65_ = msg;
#line 165 "../src/engine/db/db.vala"
			_tmp66_ = g_error_new_literal (GEARY_DATABASE_ERROR, GEARY_DATABASE_ERROR_LIMITS, _tmp65_);
#line 165 "../src/engine/db/db.vala"
			_inner_error0_ = _tmp66_;
#line 165 "../src/engine/db/db.vala"
			if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 885 "db.c"
				gint _tmp67_ = -1;
#line 165 "../src/engine/db/db.vala"
				g_propagate_error (error, _inner_error0_);
#line 165 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 165 "../src/engine/db/db.vala"
				_g_object_unref0 (statement);
#line 165 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 165 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 165 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 165 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 165 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 165 "../src/engine/db/db.vala"
				return _tmp67_;
#line 905 "db.c"
			} else {
				gint _tmp68_ = -1;
#line 165 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 165 "../src/engine/db/db.vala"
				_g_object_unref0 (statement);
#line 165 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 165 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 165 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 165 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 165 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 165 "../src/engine/db/db.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 165 "../src/engine/db/db.vala"
				g_clear_error (&_inner_error0_);
#line 165 "../src/engine/db/db.vala"
				return _tmp68_;
#line 928 "db.c"
			}
		}
#line 133 "../src/engine/db/db.vala"
		case SQLITE_SCHEMA:
#line 133 "../src/engine/db/db.vala"
		case SQLITE_MISMATCH:
#line 935 "db.c"
		{
			const gchar* _tmp69_;
			GError* _tmp70_;
#line 169 "../src/engine/db/db.vala"
			_tmp69_ = msg;
#line 169 "../src/engine/db/db.vala"
			_tmp70_ = g_error_new_literal (GEARY_DATABASE_ERROR, GEARY_DATABASE_ERROR_TYPESPEC, _tmp69_);
#line 169 "../src/engine/db/db.vala"
			_inner_error0_ = _tmp70_;
#line 169 "../src/engine/db/db.vala"
			if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 947 "db.c"
				gint _tmp71_ = -1;
#line 169 "../src/engine/db/db.vala"
				g_propagate_error (error, _inner_error0_);
#line 169 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 169 "../src/engine/db/db.vala"
				_g_object_unref0 (statement);
#line 169 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 169 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 169 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 169 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 169 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 169 "../src/engine/db/db.vala"
				return _tmp71_;
#line 967 "db.c"
			} else {
				gint _tmp72_ = -1;
#line 169 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 169 "../src/engine/db/db.vala"
				_g_object_unref0 (statement);
#line 169 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 169 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 169 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 169 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 169 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 169 "../src/engine/db/db.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 169 "../src/engine/db/db.vala"
				g_clear_error (&_inner_error0_);
#line 169 "../src/engine/db/db.vala"
				return _tmp72_;
#line 990 "db.c"
			}
		}
		default:
#line 133 "../src/engine/db/db.vala"
		case SQLITE_ERROR:
#line 133 "../src/engine/db/db.vala"
		case SQLITE_INTERNAL:
#line 133 "../src/engine/db/db.vala"
		case SQLITE_MISUSE:
#line 1000 "db.c"
		{
			const gchar* _tmp73_;
			GError* _tmp74_;
#line 175 "../src/engine/db/db.vala"
			_tmp73_ = msg;
#line 175 "../src/engine/db/db.vala"
			_tmp74_ = g_error_new_literal (GEARY_DATABASE_ERROR, GEARY_DATABASE_ERROR_GENERAL, _tmp73_);
#line 175 "../src/engine/db/db.vala"
			_inner_error0_ = _tmp74_;
#line 175 "../src/engine/db/db.vala"
			if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 1012 "db.c"
				gint _tmp75_ = -1;
#line 175 "../src/engine/db/db.vala"
				g_propagate_error (error, _inner_error0_);
#line 175 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 175 "../src/engine/db/db.vala"
				_g_object_unref0 (statement);
#line 175 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 175 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 175 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 175 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 175 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 175 "../src/engine/db/db.vala"
				return _tmp75_;
#line 1032 "db.c"
			} else {
				gint _tmp76_ = -1;
#line 175 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 175 "../src/engine/db/db.vala"
				_g_object_unref0 (statement);
#line 175 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 175 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 175 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 175 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 175 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 175 "../src/engine/db/db.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 175 "../src/engine/db/db.vala"
				g_clear_error (&_inner_error0_);
#line 175 "../src/engine/db/db.vala"
				return _tmp76_;
#line 1055 "db.c"
			}
		}
	}
}

