/* imap-db-attachment.c generated by valac 0.56.17, the Vala compiler
 * generated from imap-db-attachment.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gmime/gmime.h>
#include <gee.h>

#define GEARY_IMAP_DB_ATTACHMENT_REQUIRED_FIELDS GEARY_EMAIL_REQUIRED_FOR_MESSAGE
#define GEARY_IMAP_DB_ATTACHMENT_NULL_FILE_NAME "none"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define GEARY_IMAP_DB_TYPE_ATTACHMENT (geary_imap_db_attachment_get_type ())
#define GEARY_IMAP_DB_ATTACHMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_IMAP_DB_TYPE_ATTACHMENT, GearyImapDBAttachment))
#define GEARY_IMAP_DB_ATTACHMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_IMAP_DB_TYPE_ATTACHMENT, GearyImapDBAttachmentClass))
#define GEARY_IMAP_DB_IS_ATTACHMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_IMAP_DB_TYPE_ATTACHMENT))
#define GEARY_IMAP_DB_IS_ATTACHMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_IMAP_DB_TYPE_ATTACHMENT))
#define GEARY_IMAP_DB_ATTACHMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_IMAP_DB_TYPE_ATTACHMENT, GearyImapDBAttachmentClass))

typedef struct _GearyImapDBAttachment GearyImapDBAttachment;
typedef struct _GearyImapDBAttachmentClass GearyImapDBAttachmentClass;
typedef struct _GearyImapDBAttachmentPrivate GearyImapDBAttachmentPrivate;
enum  {
	GEARY_IMAP_DB_ATTACHMENT_0_PROPERTY,
	GEARY_IMAP_DB_ATTACHMENT_MESSAGE_ID_PROPERTY,
	GEARY_IMAP_DB_ATTACHMENT_NUM_PROPERTIES
};
static GParamSpec* geary_imap_db_attachment_properties[GEARY_IMAP_DB_ATTACHMENT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _GearyImapDBAttachment {
	GearyAttachment parent_instance;
	GearyImapDBAttachmentPrivate * priv;
};

struct _GearyImapDBAttachmentClass {
	GearyAttachmentClass parent_class;
};

struct _GearyImapDBAttachmentPrivate {
	gint64 _message_id;
	gint64 attachment_id;
};

static gint GearyImapDBAttachment_private_offset;
static gpointer geary_imap_db_attachment_parent_class = NULL;

VALA_EXTERN GType geary_imap_db_attachment_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gint64 geary_imap_db_attachment_get_message_id (GearyImapDBAttachment* self);
static void geary_imap_db_attachment_set_message_id (GearyImapDBAttachment* self,
                                              gint64 value);
static GearyImapDBAttachment* geary_imap_db_attachment_new (gint64 message_id,
                                                     GearyMimeContentType* content_type,
                                                     const gchar* content_id,
                                                     const gchar* content_description,
                                                     GearyMimeContentDisposition* content_disposition,
                                                     const gchar* content_filename);
static GearyImapDBAttachment* geary_imap_db_attachment_construct (GType object_type,
                                                           gint64 message_id,
                                                           GearyMimeContentType* content_type,
                                                           const gchar* content_id,
                                                           const gchar* content_description,
                                                           GearyMimeContentDisposition* content_disposition,
                                                           const gchar* content_filename);
VALA_EXTERN GearyImapDBAttachment* geary_imap_db_attachment_new_from_part (gint64 message_id,
                                                               GearyRFC822Part* part,
                                                               GError** error);
VALA_EXTERN GearyImapDBAttachment* geary_imap_db_attachment_construct_from_part (GType object_type,
                                                                     gint64 message_id,
                                                                     GearyRFC822Part* part,
                                                                     GError** error);
VALA_EXTERN GearyImapDBAttachment* geary_imap_db_attachment_new_from_row (GearyDbResult* _result_,
                                                              GFile* attachments_dir,
                                                              GError** error);
VALA_EXTERN GearyImapDBAttachment* geary_imap_db_attachment_construct_from_row (GType object_type,
                                                                    GearyDbResult* _result_,
                                                                    GFile* attachments_dir,
                                                                    GError** error);
VALA_EXTERN GearyMimeDispositionType geary_mime_disposition_type_from_int (gint i);
static GFile* geary_imap_db_attachment_generate_file (GearyImapDBAttachment* self,
                                               GFile* attachments_dir);
VALA_EXTERN void geary_imap_db_attachment_save (GearyImapDBAttachment* self,
                                    GearyDbConnection* cx,
                                    GearyRFC822Part* part,
                                    GFile* attachments_dir,
                                    GCancellable* cancellable,
                                    GError** error);
static void geary_imap_db_attachment_insert_db (GearyImapDBAttachment* self,
                                         GearyDbConnection* cx,
                                         GCancellable* cancellable,
                                         GError** error);
static void geary_imap_db_attachment_save_file (GearyImapDBAttachment* self,
                                         GearyRFC822Part* part,
                                         GFile* attachments_dir,
                                         GCancellable* cancellable,
                                         GError** error);
static void geary_imap_db_attachment_update_db (GearyImapDBAttachment* self,
                                         GearyDbConnection* cx,
                                         GCancellable* cancellable,
                                         GError** error);
VALA_EXTERN void geary_imap_db_attachment_delete (GearyImapDBAttachment* self,
                                      GearyDbConnection* cx,
                                      GCancellable* cancellable);
VALA_EXTERN void geary_rf_c822_part_write_to_stream (GearyRFC822Part* self,
                                         GMimeStream* destination,
                                         GearyRFC822PartEncodingConversion conversion,
                                         GearyRFC822PartBodyFormatting format,
                                         GError** error);
VALA_EXTERN GeeList* geary_imap_db_attachment_save_attachments (GearyDbConnection* cx,
                                                    GFile* attachments_path,
                                                    gint64 message_id,
                                                    GeeList* attachments,
                                                    GCancellable* cancellable,
                                                    GError** error);
VALA_EXTERN void geary_imap_db_attachment_delete_attachments (GearyDbConnection* cx,
                                                  GFile* attachments_path,
                                                  gint64 message_id,
                                                  GCancellable* cancellable,
                                                  GError** error);
VALA_EXTERN GeeList* geary_imap_db_attachment_list_attachments (GearyDbConnection* cx,
                                                    GFile* attachments_path,
                                                    gint64 message_id,
                                                    GCancellable* cancellable,
                                                    GError** error);
VALA_EXTERN void geary_imap_db_attachment_add_attachments (GearyDbConnection* cx,
                                               GFile* attachments_path,
                                               GearyEmail* email,
                                               gint64 message_id,
                                               GCancellable* cancellable,
                                               GError** error);
static void geary_imap_db_attachment_finalize (GObject * obj);
static GType geary_imap_db_attachment_get_type_once (void);
static void _vala_geary_imap_db_attachment_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_geary_imap_db_attachment_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);

static inline gpointer
geary_imap_db_attachment_get_instance_private (GearyImapDBAttachment* self)
{
	return G_STRUCT_MEMBER_P (self, GearyImapDBAttachment_private_offset);
}

gint64
geary_imap_db_attachment_get_message_id (GearyImapDBAttachment* self)
{
	gint64 result;
#line 16 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_val_if_fail (GEARY_IMAP_DB_IS_ATTACHMENT (self), 0LL);
#line 16 "../src/engine/imap-db/imap-db-attachment.vala"
	result = self->priv->_message_id;
#line 16 "../src/engine/imap-db/imap-db-attachment.vala"
	return result;
#line 179 "imap-db-attachment.c"
}

static void
geary_imap_db_attachment_set_message_id (GearyImapDBAttachment* self,
                                         gint64 value)
{
	gint64 old_value;
#line 16 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail (GEARY_IMAP_DB_IS_ATTACHMENT (self));
#line 16 "../src/engine/imap-db/imap-db-attachment.vala"
	old_value = geary_imap_db_attachment_get_message_id (self);
#line 16 "../src/engine/imap-db/imap-db-attachment.vala"
	if (old_value != value) {
#line 16 "../src/engine/imap-db/imap-db-attachment.vala"
		self->priv->_message_id = value;
#line 16 "../src/engine/imap-db/imap-db-attachment.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_imap_db_attachment_properties[GEARY_IMAP_DB_ATTACHMENT_MESSAGE_ID_PROPERTY]);
#line 197 "imap-db-attachment.c"
	}
}

static GearyImapDBAttachment*
geary_imap_db_attachment_construct (GType object_type,
                                    gint64 message_id,
                                    GearyMimeContentType* content_type,
                                    const gchar* content_id,
                                    const gchar* content_description,
                                    GearyMimeContentDisposition* content_disposition,
                                    const gchar* content_filename)
{
	GearyImapDBAttachment * self = NULL;
#line 21 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (content_type), NULL);
#line 21 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_DISPOSITION (content_disposition), NULL);
#line 27 "../src/engine/imap-db/imap-db-attachment.vala"
	self = (GearyImapDBAttachment*) geary_attachment_construct (object_type, content_type, content_id, content_description, content_disposition, content_filename);
#line 35 "../src/engine/imap-db/imap-db-attachment.vala"
	geary_imap_db_attachment_set_message_id (self, message_id);
#line 21 "../src/engine/imap-db/imap-db-attachment.vala"
	return self;
#line 221 "imap-db-attachment.c"
}

static GearyImapDBAttachment*
geary_imap_db_attachment_new (gint64 message_id,
                              GearyMimeContentType* content_type,
                              const gchar* content_id,
                              const gchar* content_description,
                              GearyMimeContentDisposition* content_disposition,
                              const gchar* content_filename)
{
#line 21 "../src/engine/imap-db/imap-db-attachment.vala"
	return geary_imap_db_attachment_construct (GEARY_IMAP_DB_TYPE_ATTACHMENT, message_id, content_type, content_id, content_description, content_disposition, content_filename);
#line 234 "imap-db-attachment.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 40 "../src/engine/imap-db/imap-db-attachment.vala"
	return self ? g_object_ref (self) : NULL;
#line 242 "imap-db-attachment.c"
}

GearyImapDBAttachment*
geary_imap_db_attachment_construct_from_part (GType object_type,
                                              gint64 message_id,
                                              GearyRFC822Part* part,
                                              GError** error)
{
	GearyImapDBAttachment * self = NULL;
	GearyMimeContentDisposition* disposition = NULL;
	GearyMimeContentDisposition* _tmp0_;
	GearyMimeContentDisposition* _tmp1_;
	GearyMimeContentDisposition* _tmp2_;
	GearyMimeContentDisposition* _tmp3_;
	GearyMimeContentType* _tmp5_;
	GearyMimeContentType* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	GearyMimeContentDisposition* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
#line 38 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_PART (part), NULL);
#line 40 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp0_ = geary_rf_c822_part_get_content_disposition (part);
#line 40 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp1_ = _tmp0_;
#line 40 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 40 "../src/engine/imap-db/imap-db-attachment.vala"
	disposition = _tmp2_;
#line 41 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp3_ = disposition;
#line 41 "../src/engine/imap-db/imap-db-attachment.vala"
	if (_tmp3_ == NULL) {
#line 280 "imap-db-attachment.c"
		GearyMimeContentDisposition* _tmp4_;
#line 42 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp4_ = geary_mime_content_disposition_new_simple (GEARY_MIME_DISPOSITION_TYPE_UNSPECIFIED);
#line 42 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (disposition);
#line 42 "../src/engine/imap-db/imap-db-attachment.vala"
		disposition = _tmp4_;
#line 288 "imap-db-attachment.c"
	}
#line 47 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp5_ = geary_rf_c822_part_get_content_type (part);
#line 47 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp6_ = _tmp5_;
#line 47 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp7_ = geary_rf_c822_part_get_content_id (part);
#line 47 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp8_ = _tmp7_;
#line 47 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp9_ = geary_rf_c822_part_get_content_description (part);
#line 47 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp10_ = _tmp9_;
#line 47 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp11_ = disposition;
#line 47 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp12_ = geary_rf_c822_part_get_clean_filename (part);
#line 47 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp13_ = _tmp12_;
#line 47 "../src/engine/imap-db/imap-db-attachment.vala"
	self = (GearyImapDBAttachment*) geary_imap_db_attachment_construct (object_type, message_id, _tmp6_, _tmp8_, _tmp10_, _tmp11_, _tmp13_);
#line 47 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_free0 (_tmp13_);
#line 38 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (disposition);
#line 38 "../src/engine/imap-db/imap-db-attachment.vala"
	return self;
#line 316 "imap-db-attachment.c"
}

GearyImapDBAttachment*
geary_imap_db_attachment_new_from_part (gint64 message_id,
                                        GearyRFC822Part* part,
                                        GError** error)
{
#line 38 "../src/engine/imap-db/imap-db-attachment.vala"
	return geary_imap_db_attachment_construct_from_part (GEARY_IMAP_DB_TYPE_ATTACHMENT, message_id, part, error);
#line 326 "imap-db-attachment.c"
}

GearyImapDBAttachment*
geary_imap_db_attachment_construct_from_row (GType object_type,
                                             GearyDbResult* _result_,
                                             GFile* attachments_dir,
                                             GError** error)
{
	GearyImapDBAttachment * self = NULL;
	gchar* content_filename = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_ = 0;
	GearyMimeContentDisposition* disposition = NULL;
	GearyMimeContentDisposition* _tmp4_;
	gint64 _tmp5_ = 0LL;
	const gchar* _tmp6_ = NULL;
	const gchar* _tmp7_;
	GearyMimeContentType* _tmp8_ = NULL;
	GearyMimeContentType* _tmp9_;
	const gchar* _tmp10_ = NULL;
	const gchar* _tmp11_;
	const gchar* _tmp12_ = NULL;
	const gchar* _tmp13_;
	GearyMimeContentDisposition* _tmp14_;
	const gchar* _tmp15_;
	gint64 _tmp16_ = 0LL;
	gint64 _tmp17_ = 0LL;
	GFile* _tmp18_;
	GFile* _tmp19_;
	GError* _inner_error0_ = NULL;
#line 57 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_val_if_fail (GEARY_DB_IS_RESULT (_result_), NULL);
#line 57 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (attachments_dir, g_file_get_type ()), NULL);
#line 59 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp0_ = geary_db_result_string_for (_result_, "filename", &_inner_error0_);
#line 59 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 59 "../src/engine/imap-db/imap-db-attachment.vala"
	content_filename = _tmp1_;
#line 59 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 59 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 59 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (self);
#line 59 "../src/engine/imap-db/imap-db-attachment.vala"
		return NULL;
#line 377 "imap-db-attachment.c"
	}
#line 60 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp2_ = content_filename;
#line 60 "../src/engine/imap-db/imap-db-attachment.vala"
	if (g_strcmp0 (_tmp2_, GEARY_IMAP_DB_ATTACHMENT_NULL_FILE_NAME) == 0) {
#line 65 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_free0 (content_filename);
#line 65 "../src/engine/imap-db/imap-db-attachment.vala"
		content_filename = NULL;
#line 387 "imap-db-attachment.c"
	}
#line 69 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp3_ = geary_db_result_int_for (_result_, "disposition", &_inner_error0_);
#line 69 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 69 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 69 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_free0 (content_filename);
#line 69 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (self);
#line 69 "../src/engine/imap-db/imap-db-attachment.vala"
		return NULL;
#line 401 "imap-db-attachment.c"
	}
#line 68 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp4_ = geary_mime_content_disposition_new_simple (geary_mime_disposition_type_from_int (_tmp3_));
#line 68 "../src/engine/imap-db/imap-db-attachment.vala"
	disposition = _tmp4_;
#line 73 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp5_ = geary_db_result_rowid_for (_result_, "message_id", &_inner_error0_);
#line 73 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 73 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 73 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (disposition);
#line 73 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_free0 (content_filename);
#line 73 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (self);
#line 73 "../src/engine/imap-db/imap-db-attachment.vala"
		return NULL;
#line 421 "imap-db-attachment.c"
	}
#line 74 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp7_ = geary_db_result_nonnull_string_for (_result_, "mime_type", &_inner_error0_);
#line 74 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp6_ = _tmp7_;
#line 74 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 74 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 74 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (disposition);
#line 74 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_free0 (content_filename);
#line 74 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (self);
#line 74 "../src/engine/imap-db/imap-db-attachment.vala"
		return NULL;
#line 439 "imap-db-attachment.c"
	}
#line 74 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp9_ = geary_mime_content_type_parse (_tmp6_, &_inner_error0_);
#line 74 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp8_ = _tmp9_;
#line 74 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 74 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 74 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (disposition);
#line 74 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_free0 (content_filename);
#line 74 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (self);
#line 74 "../src/engine/imap-db/imap-db-attachment.vala"
		return NULL;
#line 457 "imap-db-attachment.c"
	}
#line 75 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp11_ = geary_db_result_string_for (_result_, "content_id", &_inner_error0_);
#line 75 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp10_ = _tmp11_;
#line 75 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 75 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 75 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (_tmp8_);
#line 75 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (disposition);
#line 75 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_free0 (content_filename);
#line 75 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (self);
#line 75 "../src/engine/imap-db/imap-db-attachment.vala"
		return NULL;
#line 477 "imap-db-attachment.c"
	}
#line 76 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp13_ = geary_db_result_string_for (_result_, "description", &_inner_error0_);
#line 76 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp12_ = _tmp13_;
#line 76 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 76 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 76 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (_tmp8_);
#line 76 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (disposition);
#line 76 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_free0 (content_filename);
#line 76 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (self);
#line 76 "../src/engine/imap-db/imap-db-attachment.vala"
		return NULL;
#line 497 "imap-db-attachment.c"
	}
#line 72 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp14_ = disposition;
#line 72 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp15_ = content_filename;
#line 72 "../src/engine/imap-db/imap-db-attachment.vala"
	self = (GearyImapDBAttachment*) geary_imap_db_attachment_construct (object_type, _tmp5_, _tmp8_, _tmp10_, _tmp12_, _tmp14_, _tmp15_);
#line 81 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp16_ = geary_db_result_rowid_for (_result_, "id", &_inner_error0_);
#line 81 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 81 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 81 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (_tmp8_);
#line 81 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (disposition);
#line 81 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_free0 (content_filename);
#line 81 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (self);
#line 81 "../src/engine/imap-db/imap-db-attachment.vala"
		return NULL;
#line 521 "imap-db-attachment.c"
	}
#line 81 "../src/engine/imap-db/imap-db-attachment.vala"
	self->priv->attachment_id = _tmp16_;
#line 84 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp17_ = geary_db_result_int64_for (_result_, "filesize", &_inner_error0_);
#line 84 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 84 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 84 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (_tmp8_);
#line 84 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (disposition);
#line 84 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_free0 (content_filename);
#line 84 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (self);
#line 84 "../src/engine/imap-db/imap-db-attachment.vala"
		return NULL;
#line 541 "imap-db-attachment.c"
	}
#line 83 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp18_ = geary_imap_db_attachment_generate_file (self, attachments_dir);
#line 83 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp19_ = _tmp18_;
#line 83 "../src/engine/imap-db/imap-db-attachment.vala"
	geary_attachment_set_file_info (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_ATTACHMENT, GearyAttachment), _tmp19_, _tmp17_);
#line 83 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (_tmp19_);
#line 57 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (_tmp8_);
#line 57 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (disposition);
#line 57 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_free0 (content_filename);
#line 57 "../src/engine/imap-db/imap-db-attachment.vala"
	return self;
#line 559 "imap-db-attachment.c"
}

GearyImapDBAttachment*
geary_imap_db_attachment_new_from_row (GearyDbResult* _result_,
                                       GFile* attachments_dir,
                                       GError** error)
{
#line 57 "../src/engine/imap-db/imap-db-attachment.vala"
	return geary_imap_db_attachment_construct_from_row (GEARY_IMAP_DB_TYPE_ATTACHMENT, _result_, attachments_dir, error);
#line 569 "imap-db-attachment.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 101 "../src/engine/imap-db/imap-db-attachment.vala"
	return self ? g_error_copy (self) : NULL;
#line 577 "imap-db-attachment.c"
}

void
geary_imap_db_attachment_save (GearyImapDBAttachment* self,
                               GearyDbConnection* cx,
                               GearyRFC822Part* part,
                               GFile* attachments_dir,
                               GCancellable* cancellable,
                               GError** error)
{
	GError* _inner_error0_ = NULL;
#line 88 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail (GEARY_IMAP_DB_IS_ATTACHMENT (self));
#line 88 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail (GEARY_DB_IS_CONNECTION (cx));
#line 88 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail (GEARY_RF_C822_IS_PART (part));
#line 88 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (attachments_dir, g_file_get_type ()));
#line 88 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 93 "../src/engine/imap-db/imap-db-attachment.vala"
	geary_imap_db_attachment_insert_db (self, cx, cancellable, &_inner_error0_);
#line 93 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 93 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 93 "../src/engine/imap-db/imap-db-attachment.vala"
		return;
#line 607 "imap-db-attachment.c"
	}
	{
#line 95 "../src/engine/imap-db/imap-db-attachment.vala"
		geary_imap_db_attachment_save_file (self, part, attachments_dir, cancellable, &_inner_error0_);
#line 95 "../src/engine/imap-db/imap-db-attachment.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 614 "imap-db-attachment.c"
			goto __catch0_g_error;
		}
#line 96 "../src/engine/imap-db/imap-db-attachment.vala"
		geary_imap_db_attachment_update_db (self, cx, cancellable, &_inner_error0_);
#line 96 "../src/engine/imap-db/imap-db-attachment.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 621 "imap-db-attachment.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp0_;
		GError* _tmp1_;
#line 94 "../src/engine/imap-db/imap-db-attachment.vala"
		err = _inner_error0_;
#line 94 "../src/engine/imap-db/imap-db-attachment.vala"
		_inner_error0_ = NULL;
#line 100 "../src/engine/imap-db/imap-db-attachment.vala"
		geary_imap_db_attachment_delete (self, cx, NULL);
#line 101 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp0_ = err;
#line 101 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp1_ = _g_error_copy0 (_tmp0_);
#line 101 "../src/engine/imap-db/imap-db-attachment.vala"
		_inner_error0_ = _tmp1_;
#line 101 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_error_free0 (err);
#line 645 "imap-db-attachment.c"
		goto __finally0;
	}
	__finally0:
#line 94 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 94 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 94 "../src/engine/imap-db/imap-db-attachment.vala"
		return;
#line 655 "imap-db-attachment.c"
	}
}

void
geary_imap_db_attachment_delete (GearyImapDBAttachment* self,
                                 GearyDbConnection* cx,
                                 GCancellable* cancellable)
{
	GFile* _tmp13_;
	GFile* _tmp14_;
	GError* _inner_error0_ = NULL;
#line 107 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail (GEARY_IMAP_DB_IS_ATTACHMENT (self));
#line 107 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail (GEARY_DB_IS_CONNECTION (cx));
#line 107 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 108 "../src/engine/imap-db/imap-db-attachment.vala"
	if (self->priv->attachment_id >= ((gint64) 0)) {
#line 675 "imap-db-attachment.c"
		{
			GearyDbStatement* remove_stmt = NULL;
			GearyDbStatement* _tmp0_;
			GearyDbStatement* _tmp1_;
			GearyDbStatement* _tmp2_;
			GearyDbStatement* _tmp3_;
			GearyDbStatement* _tmp4_;
			GearyDbResult* _tmp5_;
			GearyDbResult* _tmp6_;
#line 110 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp0_ = geary_db_connection_prepare (cx, "DELETE FROM MessageAttachmentTable WHERE id=?", &_inner_error0_);
#line 110 "../src/engine/imap-db/imap-db-attachment.vala"
			remove_stmt = _tmp0_;
#line 110 "../src/engine/imap-db/imap-db-attachment.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 691 "imap-db-attachment.c"
				goto __catch0_g_error;
			}
#line 112 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp1_ = remove_stmt;
#line 112 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp2_ = geary_db_statement_bind_rowid (_tmp1_, 0, self->priv->attachment_id, &_inner_error0_);
#line 112 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp3_ = _tmp2_;
#line 112 "../src/engine/imap-db/imap-db-attachment.vala"
			_g_object_unref0 (_tmp3_);
#line 112 "../src/engine/imap-db/imap-db-attachment.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 112 "../src/engine/imap-db/imap-db-attachment.vala"
				_g_object_unref0 (remove_stmt);
#line 706 "imap-db-attachment.c"
				goto __catch0_g_error;
			}
#line 114 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp4_ = remove_stmt;
#line 114 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp5_ = geary_db_statement_exec (_tmp4_, NULL, &_inner_error0_);
#line 114 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp6_ = _tmp5_;
#line 114 "../src/engine/imap-db/imap-db-attachment.vala"
			_g_object_unref0 (_tmp6_);
#line 114 "../src/engine/imap-db/imap-db-attachment.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 114 "../src/engine/imap-db/imap-db-attachment.vala"
				_g_object_unref0 (remove_stmt);
#line 721 "imap-db-attachment.c"
				goto __catch0_g_error;
			}
#line 109 "../src/engine/imap-db/imap-db-attachment.vala"
			_g_object_unref0 (remove_stmt);
#line 726 "imap-db-attachment.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			GFile* _tmp7_;
			GFile* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			GError* _tmp11_;
			const gchar* _tmp12_;
#line 109 "../src/engine/imap-db/imap-db-attachment.vala"
			err = _inner_error0_;
#line 109 "../src/engine/imap-db/imap-db-attachment.vala"
			_inner_error0_ = NULL;
#line 116 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp7_ = geary_attachment_get_file (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_ATTACHMENT, GearyAttachment));
#line 116 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp8_ = _tmp7_;
#line 116 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp9_ = g_file_get_path (_tmp8_);
#line 116 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp10_ = _tmp9_;
#line 116 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp11_ = err;
#line 116 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp12_ = _tmp11_->message;
#line 116 "../src/engine/imap-db/imap-db-attachment.vala"
			g_debug ("imap-db-attachment.vala:116: Error attempting to remove added attachme" \
"nt row for %s: %s", _tmp10_, _tmp12_);
#line 116 "../src/engine/imap-db/imap-db-attachment.vala"
			_g_free0 (_tmp10_);
#line 109 "../src/engine/imap-db/imap-db-attachment.vala"
			_g_error_free0 (err);
#line 760 "imap-db-attachment.c"
		}
		__finally0:
#line 109 "../src/engine/imap-db/imap-db-attachment.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 109 "../src/engine/imap-db/imap-db-attachment.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 109 "../src/engine/imap-db/imap-db-attachment.vala"
			g_clear_error (&_inner_error0_);
#line 109 "../src/engine/imap-db/imap-db-attachment.vala"
			return;
#line 771 "imap-db-attachment.c"
		}
	}
#line 121 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp13_ = geary_attachment_get_file (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_ATTACHMENT, GearyAttachment));
#line 121 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp14_ = _tmp13_;
#line 121 "../src/engine/imap-db/imap-db-attachment.vala"
	if (_tmp14_ != NULL) {
#line 780 "imap-db-attachment.c"
		{
			GFile* _tmp15_;
			GFile* _tmp16_;
#line 123 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp15_ = geary_attachment_get_file (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_ATTACHMENT, GearyAttachment));
#line 123 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp16_ = _tmp15_;
#line 123 "../src/engine/imap-db/imap-db-attachment.vala"
			g_file_delete (_tmp16_, cancellable, &_inner_error0_);
#line 123 "../src/engine/imap-db/imap-db-attachment.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 792 "imap-db-attachment.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* err = NULL;
			GFile* _tmp17_;
			GFile* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			GError* _tmp21_;
			const gchar* _tmp22_;
#line 122 "../src/engine/imap-db/imap-db-attachment.vala"
			err = _inner_error0_;
#line 122 "../src/engine/imap-db/imap-db-attachment.vala"
			_inner_error0_ = NULL;
#line 125 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp17_ = geary_attachment_get_file (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_ATTACHMENT, GearyAttachment));
#line 125 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp18_ = _tmp17_;
#line 125 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp19_ = g_file_get_path (_tmp18_);
#line 125 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp20_ = _tmp19_;
#line 125 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp21_ = err;
#line 125 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp22_ = _tmp21_->message;
#line 125 "../src/engine/imap-db/imap-db-attachment.vala"
			g_debug ("imap-db-attachment.vala:125: Error attempting to remove attachment fil" \
"e %s: %s", _tmp20_, _tmp22_);
#line 125 "../src/engine/imap-db/imap-db-attachment.vala"
			_g_free0 (_tmp20_);
#line 122 "../src/engine/imap-db/imap-db-attachment.vala"
			_g_error_free0 (err);
#line 828 "imap-db-attachment.c"
		}
		__finally1:
#line 122 "../src/engine/imap-db/imap-db-attachment.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 122 "../src/engine/imap-db/imap-db-attachment.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 122 "../src/engine/imap-db/imap-db-attachment.vala"
			g_clear_error (&_inner_error0_);
#line 122 "../src/engine/imap-db/imap-db-attachment.vala"
			return;
#line 839 "imap-db-attachment.c"
		}
	}
}

static void
geary_imap_db_attachment_insert_db (GearyImapDBAttachment* self,
                                    GearyDbConnection* cx,
                                    GCancellable* cancellable,
                                    GError** error)
{
	GearyDbStatement* stmt = NULL;
	GearyDbStatement* _tmp0_;
	GearyDbStatement* _tmp1_;
	gint64 _tmp2_;
	GearyDbStatement* _tmp3_;
	GearyDbStatement* _tmp4_;
	GearyDbStatement* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	GearyDbStatement* _tmp8_;
	GearyDbStatement* _tmp9_;
	GearyDbStatement* _tmp10_;
	GearyMimeContentType* _tmp11_;
	GearyMimeContentType* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GearyDbStatement* _tmp15_;
	GearyDbStatement* _tmp16_;
	GearyDbStatement* _tmp17_;
	GearyDbStatement* _tmp18_;
	GearyDbStatement* _tmp19_;
	GearyDbStatement* _tmp20_;
	GearyMimeContentDisposition* _tmp21_;
	GearyMimeContentDisposition* _tmp22_;
	GearyMimeDispositionType _tmp23_;
	GearyMimeDispositionType _tmp24_;
	GearyDbStatement* _tmp25_;
	GearyDbStatement* _tmp26_;
	GearyDbStatement* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	GearyDbStatement* _tmp30_;
	GearyDbStatement* _tmp31_;
	GearyDbStatement* _tmp32_;
	const gchar* _tmp33_;
	const gchar* _tmp34_;
	GearyDbStatement* _tmp35_;
	GearyDbStatement* _tmp36_;
	gint64 _tmp37_ = 0LL;
	GearyDbStatement* _tmp38_;
	GError* _inner_error0_ = NULL;
#line 131 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail (GEARY_IMAP_DB_IS_ATTACHMENT (self));
#line 131 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail (GEARY_DB_IS_CONNECTION (cx));
#line 131 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 134 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp0_ = geary_db_connection_prepare (cx, "\n" \
"                INSERT INTO MessageAttachmentTable (message_id, filena" \
"me, mime_type, filesize, disposition, content_id, description)\n" \
"                VALUES (?, ?, ?, ?, ?, ?, ?)\n" \
"                ", &_inner_error0_);
#line 134 "../src/engine/imap-db/imap-db-attachment.vala"
	stmt = _tmp0_;
#line 134 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 134 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 134 "../src/engine/imap-db/imap-db-attachment.vala"
		return;
#line 907 "imap-db-attachment.c"
	}
#line 138 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp1_ = stmt;
#line 138 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp2_ = self->priv->_message_id;
#line 138 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp3_ = geary_db_statement_bind_rowid (_tmp1_, 0, _tmp2_, &_inner_error0_);
#line 138 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp4_ = _tmp3_;
#line 138 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (_tmp4_);
#line 138 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 138 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 138 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (stmt);
#line 138 "../src/engine/imap-db/imap-db-attachment.vala"
		return;
#line 927 "imap-db-attachment.c"
	}
#line 139 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp5_ = stmt;
#line 139 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp6_ = geary_attachment_get_content_filename (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_ATTACHMENT, GearyAttachment));
#line 139 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp7_ = _tmp6_;
#line 139 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp8_ = geary_db_statement_bind_string (_tmp5_, 1, _tmp7_, &_inner_error0_);
#line 139 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp9_ = _tmp8_;
#line 139 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (_tmp9_);
#line 139 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 139 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 139 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (stmt);
#line 139 "../src/engine/imap-db/imap-db-attachment.vala"
		return;
#line 949 "imap-db-attachment.c"
	}
#line 140 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp10_ = stmt;
#line 140 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp11_ = geary_attachment_get_content_type (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_ATTACHMENT, GearyAttachment));
#line 140 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp12_ = _tmp11_;
#line 140 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp13_ = geary_mime_content_type_to_string (_tmp12_);
#line 140 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp14_ = _tmp13_;
#line 140 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp15_ = geary_db_statement_bind_string (_tmp10_, 2, _tmp14_, &_inner_error0_);
#line 140 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp16_ = _tmp15_;
#line 140 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (_tmp16_);
#line 140 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_free0 (_tmp14_);
#line 140 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 140 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 140 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (stmt);
#line 140 "../src/engine/imap-db/imap-db-attachment.vala"
		return;
#line 977 "imap-db-attachment.c"
	}
#line 141 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp17_ = stmt;
#line 141 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp18_ = geary_db_statement_bind_int64 (_tmp17_, 3, (gint64) 0, &_inner_error0_);
#line 141 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp19_ = _tmp18_;
#line 141 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (_tmp19_);
#line 141 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 141 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 141 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (stmt);
#line 141 "../src/engine/imap-db/imap-db-attachment.vala"
		return;
#line 995 "imap-db-attachment.c"
	}
#line 142 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp20_ = stmt;
#line 142 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp21_ = geary_attachment_get_content_disposition (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_ATTACHMENT, GearyAttachment));
#line 142 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp22_ = _tmp21_;
#line 142 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp23_ = geary_mime_content_disposition_get_disposition_type (_tmp22_);
#line 142 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp24_ = _tmp23_;
#line 142 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp25_ = geary_db_statement_bind_int (_tmp20_, 4, (gint) _tmp24_, &_inner_error0_);
#line 142 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp26_ = _tmp25_;
#line 142 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (_tmp26_);
#line 142 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 142 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 142 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (stmt);
#line 142 "../src/engine/imap-db/imap-db-attachment.vala"
		return;
#line 1021 "imap-db-attachment.c"
	}
#line 143 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp27_ = stmt;
#line 143 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp28_ = geary_attachment_get_content_id (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_ATTACHMENT, GearyAttachment));
#line 143 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp29_ = _tmp28_;
#line 143 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp30_ = geary_db_statement_bind_string (_tmp27_, 5, _tmp29_, &_inner_error0_);
#line 143 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp31_ = _tmp30_;
#line 143 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (_tmp31_);
#line 143 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 143 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 143 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (stmt);
#line 143 "../src/engine/imap-db/imap-db-attachment.vala"
		return;
#line 1043 "imap-db-attachment.c"
	}
#line 144 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp32_ = stmt;
#line 144 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp33_ = geary_attachment_get_content_description (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_ATTACHMENT, GearyAttachment));
#line 144 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp34_ = _tmp33_;
#line 144 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp35_ = geary_db_statement_bind_string (_tmp32_, 6, _tmp34_, &_inner_error0_);
#line 144 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp36_ = _tmp35_;
#line 144 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (_tmp36_);
#line 144 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 144 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 144 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (stmt);
#line 144 "../src/engine/imap-db/imap-db-attachment.vala"
		return;
#line 1065 "imap-db-attachment.c"
	}
#line 146 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp38_ = stmt;
#line 146 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp37_ = geary_db_statement_exec_insert (_tmp38_, cancellable, &_inner_error0_);
#line 146 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 146 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 146 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (stmt);
#line 146 "../src/engine/imap-db/imap-db-attachment.vala"
		return;
#line 1079 "imap-db-attachment.c"
	}
#line 146 "../src/engine/imap-db/imap-db-attachment.vala"
	self->priv->attachment_id = _tmp37_;
#line 131 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (stmt);
#line 1085 "imap-db-attachment.c"
}

static void
geary_imap_db_attachment_save_file (GearyImapDBAttachment* self,
                                    GearyRFC822Part* part,
                                    GFile* attachments_dir,
                                    GCancellable* cancellable,
                                    GError** error)
{
	GFile* target = NULL;
	GFile* _tmp1_;
	GOutputStream* target_stream = NULL;
	GFile* _tmp6_;
	GFileOutputStream* _tmp7_;
	GMimeStream* stream = NULL;
	GOutputStream* _tmp8_;
	GearyStreamMimeOutputStream* _tmp9_;
	GMimeStream* _tmp10_;
	GMimeStreamBuffer* _tmp11_;
	GMimeStream* _tmp12_;
	gint64 file_size = 0LL;
	GMimeStream* _tmp13_;
	GMimeStream* _tmp14_;
	GFile* _tmp15_;
	GError* _inner_error0_ = NULL;
#line 151 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail (GEARY_IMAP_DB_IS_ATTACHMENT (self));
#line 151 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail (GEARY_RF_C822_IS_PART (part));
#line 151 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (attachments_dir, g_file_get_type ()));
#line 151 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 155 "../src/engine/imap-db/imap-db-attachment.vala"
	if (self->priv->attachment_id < ((gint64) 0)) {
#line 1121 "imap-db-attachment.c"
		GError* _tmp0_;
#line 156 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp0_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_FOUND, "No attachment id assigned");
#line 156 "../src/engine/imap-db/imap-db-attachment.vala"
		_inner_error0_ = _tmp0_;
#line 156 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 156 "../src/engine/imap-db/imap-db-attachment.vala"
		return;
#line 1131 "imap-db-attachment.c"
	}
#line 159 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp1_ = geary_imap_db_attachment_generate_file (self, attachments_dir);
#line 159 "../src/engine/imap-db/imap-db-attachment.vala"
	target = _tmp1_;
#line 1137 "imap-db-attachment.c"
	{
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
#line 163 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp2_ = target;
#line 163 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp3_ = g_file_get_parent (_tmp2_);
#line 163 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp4_ = _tmp3_;
#line 163 "../src/engine/imap-db/imap-db-attachment.vala"
		g_file_make_directory_with_parents (_tmp4_, cancellable, &_inner_error0_);
#line 163 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (_tmp4_);
#line 163 "../src/engine/imap-db/imap-db-attachment.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 163 "../src/engine/imap-db/imap-db-attachment.vala"
			if (g_error_matches (_inner_error0_, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
#line 1156 "imap-db-attachment.c"
				goto __catch0_g_io_error_exists;
			}
			goto __finally0;
		}
	}
	goto __finally0;
	__catch0_g_io_error_exists:
	{
#line 162 "../src/engine/imap-db/imap-db-attachment.vala"
		g_clear_error (&_inner_error0_);
#line 1167 "imap-db-attachment.c"
	}
	__finally0:
#line 162 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 162 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 162 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (target);
#line 162 "../src/engine/imap-db/imap-db-attachment.vala"
		return;
#line 1178 "imap-db-attachment.c"
	}
	{
		GFile* _tmp5_;
#line 171 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp5_ = target;
#line 171 "../src/engine/imap-db/imap-db-attachment.vala"
		g_file_delete (_tmp5_, cancellable, &_inner_error0_);
#line 171 "../src/engine/imap-db/imap-db-attachment.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 171 "../src/engine/imap-db/imap-db-attachment.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 1190 "imap-db-attachment.c"
				goto __catch1_g_io_error;
			}
			goto __finally1;
		}
	}
	goto __finally1;
	__catch1_g_io_error:
	{
#line 170 "../src/engine/imap-db/imap-db-attachment.vala"
		g_clear_error (&_inner_error0_);
#line 1201 "imap-db-attachment.c"
	}
	__finally1:
#line 170 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 170 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 170 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (target);
#line 170 "../src/engine/imap-db/imap-db-attachment.vala"
		return;
#line 1212 "imap-db-attachment.c"
	}
#line 176 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp6_ = target;
#line 176 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp7_ = g_file_create (_tmp6_, G_FILE_CREATE_NONE, cancellable, &_inner_error0_);
#line 176 "../src/engine/imap-db/imap-db-attachment.vala"
	target_stream = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, g_output_stream_get_type (), GOutputStream);
#line 176 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 176 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 176 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (target);
#line 176 "../src/engine/imap-db/imap-db-attachment.vala"
		return;
#line 1228 "imap-db-attachment.c"
	}
#line 179 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp8_ = target_stream;
#line 179 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp9_ = geary_stream_mime_output_stream_new (_tmp8_);
#line 179 "../src/engine/imap-db/imap-db-attachment.vala"
	stream = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, g_mime_stream_get_type (), GMimeStream);
#line 182 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp10_ = stream;
#line 182 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp11_ = (GMimeStreamBuffer*) g_mime_stream_buffer_new (_tmp10_, GMIME_STREAM_BUFFER_BLOCK_WRITE);
#line 182 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (stream);
#line 182 "../src/engine/imap-db/imap-db-attachment.vala"
	stream = G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, g_mime_stream_get_type (), GMimeStream);
#line 186 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp12_ = stream;
#line 186 "../src/engine/imap-db/imap-db-attachment.vala"
	geary_rf_c822_part_write_to_stream (part, _tmp12_, GEARY_RF_C822_PART_ENCODING_CONVERSION_NONE, GEARY_RF_C822_PART_BODY_FORMATTING_NONE, &_inner_error0_);
#line 186 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 186 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 186 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (stream);
#line 186 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (target_stream);
#line 186 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (target);
#line 186 "../src/engine/imap-db/imap-db-attachment.vala"
		return;
#line 1260 "imap-db-attachment.c"
	}
#line 191 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp13_ = stream;
#line 191 "../src/engine/imap-db/imap-db-attachment.vala"
	file_size = g_mime_stream_length (_tmp13_);
#line 193 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp14_ = stream;
#line 193 "../src/engine/imap-db/imap-db-attachment.vala"
	g_mime_stream_close (_tmp14_);
#line 195 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp15_ = target;
#line 195 "../src/engine/imap-db/imap-db-attachment.vala"
	geary_attachment_set_file_info (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_ATTACHMENT, GearyAttachment), _tmp15_, file_size);
#line 151 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (stream);
#line 151 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (target_stream);
#line 151 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (target);
#line 1280 "imap-db-attachment.c"
}

static void
geary_imap_db_attachment_update_db (GearyImapDBAttachment* self,
                                    GearyDbConnection* cx,
                                    GCancellable* cancellable,
                                    GError** error)
{
	GearyDbStatement* stmt = NULL;
	GearyDbStatement* _tmp0_;
	GearyDbStatement* _tmp1_;
	gint64 _tmp2_;
	gint64 _tmp3_;
	GearyDbStatement* _tmp4_;
	GearyDbStatement* _tmp5_;
	GearyDbStatement* _tmp6_;
	GearyDbStatement* _tmp7_;
	GearyDbStatement* _tmp8_;
	GearyDbStatement* _tmp9_;
	GearyDbResult* _tmp10_;
	GearyDbResult* _tmp11_;
	GError* _inner_error0_ = NULL;
#line 198 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail (GEARY_IMAP_DB_IS_ATTACHMENT (self));
#line 198 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail (GEARY_DB_IS_CONNECTION (cx));
#line 198 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 201 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp0_ = geary_db_connection_prepare (cx, "\n" \
"            UPDATE MessageAttachmentTable\n" \
"            SET filesize = ?\n" \
"            WHERE id = ?\n" \
"        ", &_inner_error0_);
#line 201 "../src/engine/imap-db/imap-db-attachment.vala"
	stmt = _tmp0_;
#line 201 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 201 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 201 "../src/engine/imap-db/imap-db-attachment.vala"
		return;
#line 1319 "imap-db-attachment.c"
	}
#line 206 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp1_ = stmt;
#line 206 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp2_ = geary_attachment_get_filesize (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_ATTACHMENT, GearyAttachment));
#line 206 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp3_ = _tmp2_;
#line 206 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp4_ = geary_db_statement_bind_int64 (_tmp1_, 0, _tmp3_, &_inner_error0_);
#line 206 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp5_ = _tmp4_;
#line 206 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (_tmp5_);
#line 206 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 206 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 206 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (stmt);
#line 206 "../src/engine/imap-db/imap-db-attachment.vala"
		return;
#line 1341 "imap-db-attachment.c"
	}
#line 207 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp6_ = stmt;
#line 207 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp7_ = geary_db_statement_bind_rowid (_tmp6_, 1, self->priv->attachment_id, &_inner_error0_);
#line 207 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp8_ = _tmp7_;
#line 207 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (_tmp8_);
#line 207 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 207 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 207 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (stmt);
#line 207 "../src/engine/imap-db/imap-db-attachment.vala"
		return;
#line 1359 "imap-db-attachment.c"
	}
#line 209 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp9_ = stmt;
#line 209 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp10_ = geary_db_statement_exec (_tmp9_, cancellable, &_inner_error0_);
#line 209 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp11_ = _tmp10_;
#line 209 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (_tmp11_);
#line 209 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 209 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 209 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (stmt);
#line 209 "../src/engine/imap-db/imap-db-attachment.vala"
		return;
#line 1377 "imap-db-attachment.c"
	}
#line 198 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (stmt);
#line 1381 "imap-db-attachment.c"
}

static GFile*
geary_imap_db_attachment_generate_file (GearyImapDBAttachment* self,
                                        GFile* attachments_dir)
{
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gint64 _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GFile* _tmp13_;
	GFile* result;
#line 212 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_val_if_fail (GEARY_IMAP_DB_IS_ATTACHMENT (self), NULL);
#line 212 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (attachments_dir, g_file_get_type ()), NULL);
#line 216 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp1_ = geary_attachment_get_content_filename (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_ATTACHMENT, GearyAttachment));
#line 216 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp2_ = _tmp1_;
#line 216 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp0_ = _tmp2_;
#line 216 "../src/engine/imap-db/imap-db-attachment.vala"
	if (_tmp0_ == NULL) {
#line 216 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp0_ = GEARY_IMAP_DB_ATTACHMENT_NULL_FILE_NAME;
#line 1417 "imap-db-attachment.c"
	}
#line 213 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp3_ = self->priv->_message_id;
#line 213 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp4_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp3_);
#line 213 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp5_ = _tmp4_;
#line 213 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp6_ = g_file_get_child (attachments_dir, _tmp5_);
#line 213 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp7_ = _tmp6_;
#line 213 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp8_ = g_strdup_printf ("%" G_GINT64_FORMAT, self->priv->attachment_id);
#line 213 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp9_ = _tmp8_;
#line 213 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp10_ = g_file_get_child (_tmp7_, _tmp9_);
#line 213 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp11_ = _tmp10_;
#line 213 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp12_ = g_file_get_child (_tmp11_, _tmp0_);
#line 213 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp13_ = _tmp12_;
#line 213 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (_tmp11_);
#line 213 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_free0 (_tmp9_);
#line 213 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (_tmp7_);
#line 213 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_free0 (_tmp5_);
#line 213 "../src/engine/imap-db/imap-db-attachment.vala"
	result = _tmp13_;
#line 213 "../src/engine/imap-db/imap-db-attachment.vala"
	return result;
#line 1453 "imap-db-attachment.c"
}

GeeList*
geary_imap_db_attachment_save_attachments (GearyDbConnection* cx,
                                           GFile* attachments_path,
                                           gint64 message_id,
                                           GeeList* attachments,
                                           GCancellable* cancellable,
                                           GError** error)
{
	GeeList* list = NULL;
	GeeLinkedList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeList* result;
#line 220 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), NULL);
#line 220 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (attachments_path, g_file_get_type ()), NULL);
#line 220 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (attachments, GEE_TYPE_LIST), NULL);
#line 220 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), NULL);
#line 226 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp0_ = gee_linked_list_new (GEARY_IMAP_DB_TYPE_ATTACHMENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 226 "../src/engine/imap-db/imap-db-attachment.vala"
	list = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_LIST, GeeList);
#line 1480 "imap-db-attachment.c"
	{
		GeeList* _part_list = NULL;
		gint _part_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _part_index = 0;
#line 227 "../src/engine/imap-db/imap-db-attachment.vala"
		_part_list = attachments;
#line 227 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp1_ = _part_list;
#line 227 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp2_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 227 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp3_ = _tmp2_;
#line 227 "../src/engine/imap-db/imap-db-attachment.vala"
		_part_size = _tmp3_;
#line 227 "../src/engine/imap-db/imap-db-attachment.vala"
		_part_index = -1;
#line 227 "../src/engine/imap-db/imap-db-attachment.vala"
		while (TRUE) {
#line 1502 "imap-db-attachment.c"
			gint _tmp4_;
			gint _tmp5_;
			GearyRFC822Part* part = NULL;
			GeeList* _tmp6_;
			gpointer _tmp7_;
			GearyImapDBAttachment* attachment = NULL;
			GearyRFC822Part* _tmp8_;
			GearyImapDBAttachment* _tmp9_;
			GearyImapDBAttachment* _tmp10_;
			GearyRFC822Part* _tmp11_;
			GeeList* _tmp12_;
			GearyImapDBAttachment* _tmp13_;
#line 227 "../src/engine/imap-db/imap-db-attachment.vala"
			_part_index = _part_index + 1;
#line 227 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp4_ = _part_index;
#line 227 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp5_ = _part_size;
#line 227 "../src/engine/imap-db/imap-db-attachment.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 227 "../src/engine/imap-db/imap-db-attachment.vala"
				break;
#line 1525 "imap-db-attachment.c"
			}
#line 227 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp6_ = _part_list;
#line 227 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp7_ = gee_list_get (_tmp6_, _part_index);
#line 227 "../src/engine/imap-db/imap-db-attachment.vala"
			part = (GearyRFC822Part*) _tmp7_;
#line 228 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp8_ = part;
#line 228 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp9_ = geary_imap_db_attachment_new_from_part (message_id, _tmp8_, &_inner_error0_);
#line 228 "../src/engine/imap-db/imap-db-attachment.vala"
			attachment = _tmp9_;
#line 228 "../src/engine/imap-db/imap-db-attachment.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 228 "../src/engine/imap-db/imap-db-attachment.vala"
				g_propagate_error (error, _inner_error0_);
#line 228 "../src/engine/imap-db/imap-db-attachment.vala"
				_g_object_unref0 (part);
#line 228 "../src/engine/imap-db/imap-db-attachment.vala"
				_g_object_unref0 (list);
#line 228 "../src/engine/imap-db/imap-db-attachment.vala"
				return NULL;
#line 1549 "imap-db-attachment.c"
			}
#line 229 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp10_ = attachment;
#line 229 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp11_ = part;
#line 229 "../src/engine/imap-db/imap-db-attachment.vala"
			geary_imap_db_attachment_save (_tmp10_, cx, _tmp11_, attachments_path, cancellable, &_inner_error0_);
#line 229 "../src/engine/imap-db/imap-db-attachment.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 229 "../src/engine/imap-db/imap-db-attachment.vala"
				g_propagate_error (error, _inner_error0_);
#line 229 "../src/engine/imap-db/imap-db-attachment.vala"
				_g_object_unref0 (attachment);
#line 229 "../src/engine/imap-db/imap-db-attachment.vala"
				_g_object_unref0 (part);
#line 229 "../src/engine/imap-db/imap-db-attachment.vala"
				_g_object_unref0 (list);
#line 229 "../src/engine/imap-db/imap-db-attachment.vala"
				return NULL;
#line 1569 "imap-db-attachment.c"
			}
#line 230 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp12_ = list;
#line 230 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp13_ = attachment;
#line 230 "../src/engine/imap-db/imap-db-attachment.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_COLLECTION, GeeCollection), _tmp13_);
#line 227 "../src/engine/imap-db/imap-db-attachment.vala"
			_g_object_unref0 (attachment);
#line 227 "../src/engine/imap-db/imap-db-attachment.vala"
			_g_object_unref0 (part);
#line 1581 "imap-db-attachment.c"
		}
	}
#line 232 "../src/engine/imap-db/imap-db-attachment.vala"
	result = list;
#line 232 "../src/engine/imap-db/imap-db-attachment.vala"
	return result;
#line 1588 "imap-db-attachment.c"
}

void
geary_imap_db_attachment_delete_attachments (GearyDbConnection* cx,
                                             GFile* attachments_path,
                                             gint64 message_id,
                                             GCancellable* cancellable,
                                             GError** error)
{
	GeeList* attachments = NULL;
	GeeList* _tmp0_;
	GearyDbStatement* stmt = NULL;
	GearyDbStatement* _tmp10_;
	GearyDbStatement* _tmp11_;
	GearyDbStatement* _tmp12_;
	GearyDbStatement* _tmp13_;
	GearyDbStatement* _tmp14_;
	GearyDbResult* _tmp15_;
	GearyDbResult* _tmp16_;
	GError* _inner_error0_ = NULL;
#line 235 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail (GEARY_DB_IS_CONNECTION (cx));
#line 235 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (attachments_path, g_file_get_type ()));
#line 235 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 240 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp0_ = geary_imap_db_attachment_list_attachments (cx, attachments_path, message_id, cancellable, &_inner_error0_);
#line 240 "../src/engine/imap-db/imap-db-attachment.vala"
	attachments = _tmp0_;
#line 240 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 240 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 240 "../src/engine/imap-db/imap-db-attachment.vala"
		return;
#line 1625 "imap-db-attachment.c"
	}
	{
		GeeList* _attachment_list = NULL;
		GeeList* _tmp1_;
		gint _attachment_size = 0;
		GeeList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _attachment_index = 0;
#line 243 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp1_ = attachments;
#line 243 "../src/engine/imap-db/imap-db-attachment.vala"
		_attachment_list = _tmp1_;
#line 243 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp2_ = _attachment_list;
#line 243 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp3_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection));
#line 243 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp4_ = _tmp3_;
#line 243 "../src/engine/imap-db/imap-db-attachment.vala"
		_attachment_size = _tmp4_;
#line 243 "../src/engine/imap-db/imap-db-attachment.vala"
		_attachment_index = -1;
#line 243 "../src/engine/imap-db/imap-db-attachment.vala"
		while (TRUE) {
#line 1651 "imap-db-attachment.c"
			gint _tmp5_;
			gint _tmp6_;
			GearyImapDBAttachment* attachment = NULL;
			GeeList* _tmp7_;
			gpointer _tmp8_;
			GearyImapDBAttachment* _tmp9_;
#line 243 "../src/engine/imap-db/imap-db-attachment.vala"
			_attachment_index = _attachment_index + 1;
#line 243 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp5_ = _attachment_index;
#line 243 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp6_ = _attachment_size;
#line 243 "../src/engine/imap-db/imap-db-attachment.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 243 "../src/engine/imap-db/imap-db-attachment.vala"
				break;
#line 1668 "imap-db-attachment.c"
			}
#line 243 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp7_ = _attachment_list;
#line 243 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp8_ = gee_list_get (_tmp7_, _attachment_index);
#line 243 "../src/engine/imap-db/imap-db-attachment.vala"
			attachment = (GearyImapDBAttachment*) _tmp8_;
#line 244 "../src/engine/imap-db/imap-db-attachment.vala"
			_tmp9_ = attachment;
#line 244 "../src/engine/imap-db/imap-db-attachment.vala"
			geary_imap_db_attachment_delete (_tmp9_, cx, cancellable);
#line 243 "../src/engine/imap-db/imap-db-attachment.vala"
			_g_object_unref0 (attachment);
#line 1682 "imap-db-attachment.c"
		}
	}
#line 248 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp10_ = geary_db_connection_prepare (cx, "\n" \
"            DELETE FROM MessageAttachmentTable WHERE message_id = ?\n" \
"        ", &_inner_error0_);
#line 248 "../src/engine/imap-db/imap-db-attachment.vala"
	stmt = _tmp10_;
#line 248 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 248 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 248 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (attachments);
#line 248 "../src/engine/imap-db/imap-db-attachment.vala"
		return;
#line 1697 "imap-db-attachment.c"
	}
#line 251 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp11_ = stmt;
#line 251 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp12_ = geary_db_statement_bind_rowid (_tmp11_, 0, message_id, &_inner_error0_);
#line 251 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp13_ = _tmp12_;
#line 251 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (_tmp13_);
#line 251 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 251 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 251 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (stmt);
#line 251 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (attachments);
#line 251 "../src/engine/imap-db/imap-db-attachment.vala"
		return;
#line 1717 "imap-db-attachment.c"
	}
#line 252 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp14_ = stmt;
#line 252 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp15_ = geary_db_statement_exec (_tmp14_, NULL, &_inner_error0_);
#line 252 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp16_ = _tmp15_;
#line 252 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (_tmp16_);
#line 252 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 252 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 252 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (stmt);
#line 252 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (attachments);
#line 252 "../src/engine/imap-db/imap-db-attachment.vala"
		return;
#line 1737 "imap-db-attachment.c"
	}
#line 235 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (stmt);
#line 235 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (attachments);
#line 1743 "imap-db-attachment.c"
}

void
geary_imap_db_attachment_add_attachments (GearyDbConnection* cx,
                                          GFile* attachments_path,
                                          GearyEmail* email,
                                          gint64 message_id,
                                          GCancellable* cancellable,
                                          GError** error)
{
	GearyEmailField _tmp0_;
	GearyEmailField _tmp1_;
	GError* _inner_error0_ = NULL;
#line 257 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail (GEARY_DB_IS_CONNECTION (cx));
#line 257 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (attachments_path, g_file_get_type ()));
#line 257 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail (GEARY_IS_EMAIL (email));
#line 257 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 263 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp0_ = geary_email_get_fields (email);
#line 263 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp1_ = _tmp0_;
#line 263 "../src/engine/imap-db/imap-db-attachment.vala"
	if (geary_email_field_fulfills (_tmp1_, GEARY_IMAP_DB_ATTACHMENT_REQUIRED_FIELDS)) {
#line 1771 "imap-db-attachment.c"
		GeeList* _tmp2_ = NULL;
		GeeList* _tmp3_;
#line 265 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp3_ = geary_imap_db_attachment_list_attachments (cx, attachments_path, message_id, cancellable, &_inner_error0_);
#line 265 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp2_ = _tmp3_;
#line 265 "../src/engine/imap-db/imap-db-attachment.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 265 "../src/engine/imap-db/imap-db-attachment.vala"
			g_propagate_error (error, _inner_error0_);
#line 265 "../src/engine/imap-db/imap-db-attachment.vala"
			return;
#line 1784 "imap-db-attachment.c"
		}
#line 264 "../src/engine/imap-db/imap-db-attachment.vala"
		geary_email_add_attachments (email, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection));
#line 263 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (_tmp2_);
#line 1790 "imap-db-attachment.c"
	}
}

GeeList*
geary_imap_db_attachment_list_attachments (GearyDbConnection* cx,
                                           GFile* attachments_path,
                                           gint64 message_id,
                                           GCancellable* cancellable,
                                           GError** error)
{
	GearyDbStatement* stmt = NULL;
	GearyDbStatement* _tmp0_;
	GearyDbStatement* _tmp1_;
	GearyDbStatement* _tmp2_;
	GearyDbStatement* _tmp3_;
	GearyDbResult* results = NULL;
	GearyDbStatement* _tmp4_;
	GearyDbResult* _tmp5_;
	GeeList* list = NULL;
	GeeLinkedList* _tmp6_;
	GError* _inner_error0_ = NULL;
	GeeList* result;
#line 272 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), NULL);
#line 272 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (attachments_path, g_file_get_type ()), NULL);
#line 272 "../src/engine/imap-db/imap-db-attachment.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), NULL);
#line 277 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp0_ = geary_db_connection_prepare (cx, "\n" \
"            SELECT *\n" \
"            FROM MessageAttachmentTable\n" \
"            WHERE message_id = ?\n" \
"            ORDER BY id\n" \
"            ", &_inner_error0_);
#line 277 "../src/engine/imap-db/imap-db-attachment.vala"
	stmt = _tmp0_;
#line 277 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 277 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 277 "../src/engine/imap-db/imap-db-attachment.vala"
		return NULL;
#line 1829 "imap-db-attachment.c"
	}
#line 283 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp1_ = stmt;
#line 283 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp2_ = geary_db_statement_bind_rowid (_tmp1_, 0, message_id, &_inner_error0_);
#line 283 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp3_ = _tmp2_;
#line 283 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (_tmp3_);
#line 283 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 283 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 283 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (stmt);
#line 283 "../src/engine/imap-db/imap-db-attachment.vala"
		return NULL;
#line 1847 "imap-db-attachment.c"
	}
#line 284 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp4_ = stmt;
#line 284 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp5_ = geary_db_statement_exec (_tmp4_, cancellable, &_inner_error0_);
#line 284 "../src/engine/imap-db/imap-db-attachment.vala"
	results = _tmp5_;
#line 284 "../src/engine/imap-db/imap-db-attachment.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 284 "../src/engine/imap-db/imap-db-attachment.vala"
		g_propagate_error (error, _inner_error0_);
#line 284 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (stmt);
#line 284 "../src/engine/imap-db/imap-db-attachment.vala"
		return NULL;
#line 1863 "imap-db-attachment.c"
	}
#line 286 "../src/engine/imap-db/imap-db-attachment.vala"
	_tmp6_ = gee_linked_list_new (GEARY_IMAP_DB_TYPE_ATTACHMENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 286 "../src/engine/imap-db/imap-db-attachment.vala"
	list = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_LIST, GeeList);
#line 287 "../src/engine/imap-db/imap-db-attachment.vala"
	while (TRUE) {
#line 1871 "imap-db-attachment.c"
		GearyDbResult* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
		GearyImapDBAttachment* _tmp10_ = NULL;
		GearyDbResult* _tmp11_;
		GearyImapDBAttachment* _tmp12_;
		GeeList* _tmp13_;
		GearyDbResult* _tmp14_;
#line 287 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp7_ = results;
#line 287 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp8_ = geary_db_result_get_finished (_tmp7_);
#line 287 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp9_ = _tmp8_;
#line 287 "../src/engine/imap-db/imap-db-attachment.vala"
		if (!(!_tmp9_)) {
#line 287 "../src/engine/imap-db/imap-db-attachment.vala"
			break;
#line 1890 "imap-db-attachment.c"
		}
#line 288 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp11_ = results;
#line 288 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp12_ = geary_imap_db_attachment_new_from_row (_tmp11_, attachments_path, &_inner_error0_);
#line 288 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp10_ = _tmp12_;
#line 288 "../src/engine/imap-db/imap-db-attachment.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 288 "../src/engine/imap-db/imap-db-attachment.vala"
			g_propagate_error (error, _inner_error0_);
#line 288 "../src/engine/imap-db/imap-db-attachment.vala"
			_g_object_unref0 (list);
#line 288 "../src/engine/imap-db/imap-db-attachment.vala"
			_g_object_unref0 (results);
#line 288 "../src/engine/imap-db/imap-db-attachment.vala"
			_g_object_unref0 (stmt);
#line 288 "../src/engine/imap-db/imap-db-attachment.vala"
			return NULL;
#line 1910 "imap-db-attachment.c"
		}
#line 288 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp13_ = list;
#line 288 "../src/engine/imap-db/imap-db-attachment.vala"
		gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_COLLECTION, GeeCollection), _tmp10_);
#line 289 "../src/engine/imap-db/imap-db-attachment.vala"
		_tmp14_ = results;
#line 289 "../src/engine/imap-db/imap-db-attachment.vala"
		geary_db_result_next (_tmp14_, cancellable, &_inner_error0_);
#line 289 "../src/engine/imap-db/imap-db-attachment.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 289 "../src/engine/imap-db/imap-db-attachment.vala"
			g_propagate_error (error, _inner_error0_);
#line 289 "../src/engine/imap-db/imap-db-attachment.vala"
			_g_object_unref0 (_tmp10_);
#line 289 "../src/engine/imap-db/imap-db-attachment.vala"
			_g_object_unref0 (list);
#line 289 "../src/engine/imap-db/imap-db-attachment.vala"
			_g_object_unref0 (results);
#line 289 "../src/engine/imap-db/imap-db-attachment.vala"
			_g_object_unref0 (stmt);
#line 289 "../src/engine/imap-db/imap-db-attachment.vala"
			return NULL;
#line 1934 "imap-db-attachment.c"
		}
#line 287 "../src/engine/imap-db/imap-db-attachment.vala"
		_g_object_unref0 (_tmp10_);
#line 1938 "imap-db-attachment.c"
	}
#line 291 "../src/engine/imap-db/imap-db-attachment.vala"
	result = list;
#line 291 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (results);
#line 291 "../src/engine/imap-db/imap-db-attachment.vala"
	_g_object_unref0 (stmt);
#line 291 "../src/engine/imap-db/imap-db-attachment.vala"
	return result;
#line 1948 "imap-db-attachment.c"
}

static void
geary_imap_db_attachment_class_init (GearyImapDBAttachmentClass * klass,
                                     gpointer klass_data)
{
#line 8 "../src/engine/imap-db/imap-db-attachment.vala"
	geary_imap_db_attachment_parent_class = g_type_class_peek_parent (klass);
#line 8 "../src/engine/imap-db/imap-db-attachment.vala"
	g_type_class_adjust_private_offset (klass, &GearyImapDBAttachment_private_offset);
#line 8 "../src/engine/imap-db/imap-db-attachment.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_imap_db_attachment_get_property;
#line 8 "../src/engine/imap-db/imap-db-attachment.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_imap_db_attachment_set_property;
#line 8 "../src/engine/imap-db/imap-db-attachment.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_imap_db_attachment_finalize;
#line 8 "../src/engine/imap-db/imap-db-attachment.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_DB_ATTACHMENT_MESSAGE_ID_PROPERTY, geary_imap_db_attachment_properties[GEARY_IMAP_DB_ATTACHMENT_MESSAGE_ID_PROPERTY] = g_param_spec_int64 ("message-id", "message-id", "message-id", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1967 "imap-db-attachment.c"
}

static void
geary_imap_db_attachment_instance_init (GearyImapDBAttachment * self,
                                        gpointer klass)
{
#line 8 "../src/engine/imap-db/imap-db-attachment.vala"
	self->priv = geary_imap_db_attachment_get_instance_private (self);
#line 18 "../src/engine/imap-db/imap-db-attachment.vala"
	self->priv->attachment_id = (gint64) -1;
#line 1978 "imap-db-attachment.c"
}

static void
geary_imap_db_attachment_finalize (GObject * obj)
{
	GearyImapDBAttachment * self;
#line 8 "../src/engine/imap-db/imap-db-attachment.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_IMAP_DB_TYPE_ATTACHMENT, GearyImapDBAttachment);
#line 8 "../src/engine/imap-db/imap-db-attachment.vala"
	G_OBJECT_CLASS (geary_imap_db_attachment_parent_class)->finalize (obj);
#line 1989 "imap-db-attachment.c"
}

 G_GNUC_NO_INLINE static GType
geary_imap_db_attachment_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyImapDBAttachmentClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_imap_db_attachment_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyImapDBAttachment), 0, (GInstanceInitFunc) geary_imap_db_attachment_instance_init, NULL };
	GType geary_imap_db_attachment_type_id;
	geary_imap_db_attachment_type_id = g_type_register_static (GEARY_TYPE_ATTACHMENT, "GearyImapDBAttachment", &g_define_type_info, 0);
	GearyImapDBAttachment_private_offset = g_type_add_instance_private (geary_imap_db_attachment_type_id, sizeof (GearyImapDBAttachmentPrivate));
	return geary_imap_db_attachment_type_id;
}

GType
geary_imap_db_attachment_get_type (void)
{
	static gsize geary_imap_db_attachment_type_id__once = 0;
	if (g_once_init_enter (&geary_imap_db_attachment_type_id__once)) {
		GType geary_imap_db_attachment_type_id;
		geary_imap_db_attachment_type_id = geary_imap_db_attachment_get_type_once ();
		g_once_init_leave (&geary_imap_db_attachment_type_id__once, geary_imap_db_attachment_type_id);
	}
	return geary_imap_db_attachment_type_id__once;
}

static void
_vala_geary_imap_db_attachment_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	GearyImapDBAttachment * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_DB_TYPE_ATTACHMENT, GearyImapDBAttachment);
#line 8 "../src/engine/imap-db/imap-db-attachment.vala"
	switch (property_id) {
#line 8 "../src/engine/imap-db/imap-db-attachment.vala"
		case GEARY_IMAP_DB_ATTACHMENT_MESSAGE_ID_PROPERTY:
#line 8 "../src/engine/imap-db/imap-db-attachment.vala"
		g_value_set_int64 (value, geary_imap_db_attachment_get_message_id (self));
#line 8 "../src/engine/imap-db/imap-db-attachment.vala"
		break;
#line 2030 "imap-db-attachment.c"
		default:
#line 8 "../src/engine/imap-db/imap-db-attachment.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/engine/imap-db/imap-db-attachment.vala"
		break;
#line 2036 "imap-db-attachment.c"
	}
}

static void
_vala_geary_imap_db_attachment_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	GearyImapDBAttachment * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_DB_TYPE_ATTACHMENT, GearyImapDBAttachment);
#line 8 "../src/engine/imap-db/imap-db-attachment.vala"
	switch (property_id) {
#line 8 "../src/engine/imap-db/imap-db-attachment.vala"
		case GEARY_IMAP_DB_ATTACHMENT_MESSAGE_ID_PROPERTY:
#line 8 "../src/engine/imap-db/imap-db-attachment.vala"
		geary_imap_db_attachment_set_message_id (self, g_value_get_int64 (value));
#line 8 "../src/engine/imap-db/imap-db-attachment.vala"
		break;
#line 2056 "imap-db-attachment.c"
		default:
#line 8 "../src/engine/imap-db/imap-db-attachment.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/engine/imap-db/imap-db-attachment.vala"
		break;
#line 2062 "imap-db-attachment.c"
	}
}

