/* imap-engine.c generated by valac 0.56.17, the Vala compiler
 * generated from imap-engine.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib.h>
#include "geary-engine.h"
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

VALA_EXTERN gboolean geary_imap_engine_is_recoverable_failure (GError* err);
VALA_EXTERN gboolean geary_imap_engine_is_remote_error (GError* err);

/**
     * Determines if retrying an operation might succeed or not.
     *
     * A recoverable failure is defined as one that may not occur
     * again if the operation that caused it is retried, without
     * needing to make some change in the mean time. For example,
     * recoverable failures may occur due to transient network
     * connectivity issues or server rate limiting. On the other hand,
     * an unrecoverable failure is due to some problem that will not
     * succeed if tried again unless some action is taken, such as
     * authentication failures, protocol parsing errors, and so on.
     */
gboolean
geary_imap_engine_is_recoverable_failure (GError* err)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean result;
#line 21 "../src/engine/imap-engine/imap-engine.vala"
	g_return_val_if_fail (err != NULL, FALSE);
#line 23 "../src/engine/imap-engine/imap-engine.vala"
	if (g_error_matches (err, GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_SERVER_UNAVAILABLE)) {
#line 23 "../src/engine/imap-engine/imap-engine.vala"
		_tmp7_ = TRUE;
#line 57 "imap-engine.c"
	} else {
#line 24 "../src/engine/imap-engine/imap-engine.vala"
		_tmp7_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_BROKEN_PIPE);
#line 61 "imap-engine.c"
	}
#line 23 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp7_) {
#line 23 "../src/engine/imap-engine/imap-engine.vala"
		_tmp6_ = TRUE;
#line 67 "imap-engine.c"
	} else {
#line 25 "../src/engine/imap-engine/imap-engine.vala"
		_tmp6_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_BUSY);
#line 71 "imap-engine.c"
	}
#line 23 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp6_) {
#line 23 "../src/engine/imap-engine/imap-engine.vala"
		_tmp5_ = TRUE;
#line 77 "imap-engine.c"
	} else {
#line 26 "../src/engine/imap-engine/imap-engine.vala"
		_tmp5_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_CONNECTION_CLOSED);
#line 81 "imap-engine.c"
	}
#line 23 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp5_) {
#line 23 "../src/engine/imap-engine/imap-engine.vala"
		_tmp4_ = TRUE;
#line 87 "imap-engine.c"
	} else {
#line 27 "../src/engine/imap-engine/imap-engine.vala"
		_tmp4_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_NOT_CONNECTED);
#line 91 "imap-engine.c"
	}
#line 23 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp4_) {
#line 23 "../src/engine/imap-engine/imap-engine.vala"
		_tmp3_ = TRUE;
#line 97 "imap-engine.c"
	} else {
#line 28 "../src/engine/imap-engine/imap-engine.vala"
		_tmp3_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_TIMED_OUT);
#line 101 "imap-engine.c"
	}
#line 23 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp3_) {
#line 23 "../src/engine/imap-engine/imap-engine.vala"
		_tmp2_ = TRUE;
#line 107 "imap-engine.c"
	} else {
#line 29 "../src/engine/imap-engine/imap-engine.vala"
		_tmp2_ = g_error_matches (err, GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_NOT_CONNECTED);
#line 111 "imap-engine.c"
	}
#line 23 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp2_) {
#line 23 "../src/engine/imap-engine/imap-engine.vala"
		_tmp1_ = TRUE;
#line 117 "imap-engine.c"
	} else {
#line 30 "../src/engine/imap-engine/imap-engine.vala"
		_tmp1_ = g_error_matches (err, GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_TIMED_OUT);
#line 121 "imap-engine.c"
	}
#line 22 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp1_) {
#line 23 "../src/engine/imap-engine/imap-engine.vala"
		_tmp0_ = TRUE;
#line 127 "imap-engine.c"
	} else {
#line 31 "../src/engine/imap-engine/imap-engine.vala"
		_tmp0_ = g_error_matches (err, GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_UNAVAILABLE);
#line 131 "imap-engine.c"
	}
#line 22 "../src/engine/imap-engine/imap-engine.vala"
	result = _tmp0_;
#line 22 "../src/engine/imap-engine/imap-engine.vala"
	return result;
#line 137 "imap-engine.c"
}

/**
     * Determines if an error was caused by the remote host or not.
     */
gboolean
geary_imap_engine_is_remote_error (GError* err)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean result;
#line 38 "../src/engine/imap-engine/imap-engine.vala"
	g_return_val_if_fail (err != NULL, FALSE);
#line 40 "../src/engine/imap-engine/imap-engine.vala"
	if (g_error_matches (err, GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_NOT_FOUND)) {
#line 40 "../src/engine/imap-engine/imap-engine.vala"
		_tmp11_ = TRUE;
#line 165 "imap-engine.c"
	} else {
#line 41 "../src/engine/imap-engine/imap-engine.vala"
		_tmp11_ = g_error_matches (err, GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_SERVER_UNAVAILABLE);
#line 169 "imap-engine.c"
	}
#line 40 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp11_) {
#line 40 "../src/engine/imap-engine/imap-engine.vala"
		_tmp10_ = TRUE;
#line 175 "imap-engine.c"
	} else {
#line 42 "../src/engine/imap-engine/imap-engine.vala"
		_tmp10_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_CONNECTION_CLOSED);
#line 179 "imap-engine.c"
	}
#line 40 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp10_) {
#line 40 "../src/engine/imap-engine/imap-engine.vala"
		_tmp9_ = TRUE;
#line 185 "imap-engine.c"
	} else {
#line 43 "../src/engine/imap-engine/imap-engine.vala"
		_tmp9_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_CONNECTION_REFUSED);
#line 189 "imap-engine.c"
	}
#line 40 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp9_) {
#line 40 "../src/engine/imap-engine/imap-engine.vala"
		_tmp8_ = TRUE;
#line 195 "imap-engine.c"
	} else {
#line 44 "../src/engine/imap-engine/imap-engine.vala"
		_tmp8_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_HOST_UNREACHABLE);
#line 199 "imap-engine.c"
	}
#line 40 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp8_) {
#line 40 "../src/engine/imap-engine/imap-engine.vala"
		_tmp7_ = TRUE;
#line 205 "imap-engine.c"
	} else {
#line 45 "../src/engine/imap-engine/imap-engine.vala"
		_tmp7_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_MESSAGE_TOO_LARGE);
#line 209 "imap-engine.c"
	}
#line 40 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp7_) {
#line 40 "../src/engine/imap-engine/imap-engine.vala"
		_tmp6_ = TRUE;
#line 215 "imap-engine.c"
	} else {
#line 46 "../src/engine/imap-engine/imap-engine.vala"
		_tmp6_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_NETWORK_UNREACHABLE);
#line 219 "imap-engine.c"
	}
#line 40 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp6_) {
#line 40 "../src/engine/imap-engine/imap-engine.vala"
		_tmp5_ = TRUE;
#line 225 "imap-engine.c"
	} else {
#line 47 "../src/engine/imap-engine/imap-engine.vala"
		_tmp5_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_NOT_CONNECTED);
#line 229 "imap-engine.c"
	}
#line 40 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp5_) {
#line 40 "../src/engine/imap-engine/imap-engine.vala"
		_tmp4_ = TRUE;
#line 235 "imap-engine.c"
	} else {
#line 48 "../src/engine/imap-engine/imap-engine.vala"
		_tmp4_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_PROXY_AUTH_FAILED);
#line 239 "imap-engine.c"
	}
#line 40 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp4_) {
#line 40 "../src/engine/imap-engine/imap-engine.vala"
		_tmp3_ = TRUE;
#line 245 "imap-engine.c"
	} else {
#line 49 "../src/engine/imap-engine/imap-engine.vala"
		_tmp3_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_PROXY_FAILED);
#line 249 "imap-engine.c"
	}
#line 40 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp3_) {
#line 40 "../src/engine/imap-engine/imap-engine.vala"
		_tmp2_ = TRUE;
#line 255 "imap-engine.c"
	} else {
#line 50 "../src/engine/imap-engine/imap-engine.vala"
		_tmp2_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_PROXY_NEED_AUTH);
#line 259 "imap-engine.c"
	}
#line 40 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp2_) {
#line 40 "../src/engine/imap-engine/imap-engine.vala"
		_tmp1_ = TRUE;
#line 265 "imap-engine.c"
	} else {
#line 51 "../src/engine/imap-engine/imap-engine.vala"
		_tmp1_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_PROXY_NOT_ALLOWED);
#line 269 "imap-engine.c"
	}
#line 39 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp1_) {
#line 40 "../src/engine/imap-engine/imap-engine.vala"
		_tmp0_ = TRUE;
#line 275 "imap-engine.c"
	} else {
#line 52 "../src/engine/imap-engine/imap-engine.vala"
		_tmp0_ = err->domain == GEARY_IMAP_ERROR;
#line 279 "imap-engine.c"
	}
#line 39 "../src/engine/imap-engine/imap-engine.vala"
	result = _tmp0_;
#line 39 "../src/engine/imap-engine/imap-engine.vala"
	return result;
#line 285 "imap-engine.c"
}

