/* imap-command.c generated by valac 0.56.17, the Vala compiler
 * generated from imap-command.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2018 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_IMAP_COMMAND_0_PROPERTY,
	GEARY_IMAP_COMMAND_TAG_PROPERTY,
	GEARY_IMAP_COMMAND_NAME_PROPERTY,
	GEARY_IMAP_COMMAND_RESPONSE_TIMEOUT_PROPERTY,
	GEARY_IMAP_COMMAND_STATUS_PROPERTY,
	GEARY_IMAP_COMMAND_SHOULD_SEND_PROPERTY,
	GEARY_IMAP_COMMAND_ARGS_PROPERTY,
	GEARY_IMAP_COMMAND_RESPONSE_TIMER_PROPERTY,
	GEARY_IMAP_COMMAND_NUM_PROPERTIES
};
static GParamSpec* geary_imap_command_properties[GEARY_IMAP_COMMAND_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _GearyImapCommandSendData GearyImapCommandSendData;
typedef struct _GearyImapCommandSendWaitData GearyImapCommandSendWaitData;
typedef struct _GearyImapCommandWaitUntilCompleteData GearyImapCommandWaitUntilCompleteData;
enum  {
	GEARY_IMAP_COMMAND_RESPONSE_TIMED_OUT_SIGNAL,
	GEARY_IMAP_COMMAND_NUM_SIGNALS
};
static guint geary_imap_command_signals[GEARY_IMAP_COMMAND_NUM_SIGNALS] = {0};

struct _GearyImapCommandPrivate {
	GearyImapTag* _tag;
	gchar* _name;
	guint _response_timeout;
	GearyImapStatusResponse* _status;
	GCancellable* _should_send;
	GearyImapListParameter* _args;
	GearyTimeoutManager* _response_timer;
	GearyNonblockingSemaphore* complete_lock;
	GError* cancelled_cause;
	GearyNonblockingSpinlock* literal_spinlock;
	GCancellable* literal_cancellable;
};

struct _GearyImapCommandSendData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapCommand* self;
	GearyImapSerializer* ser;
	GCancellable* cancellable;
	GearyTimeoutManager* _tmp0_;
	GearyImapTag* _tmp1_;
	const gchar* _tmp2_;
	GearyImapListParameter* _tmp3_;
	GeeList* _arg_list;
	GearyImapListParameter* _tmp4_;
	GeeList* _tmp5_;
	gint _arg_size;
	GeeList* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _arg_index;
	gint _tmp9_;
	gint _tmp10_;
	GearyImapParameter* arg;
	GeeList* _tmp11_;
	gpointer _tmp12_;
	GearyImapParameter* _tmp13_;
	GearyImapLiteralParameter* literal;
	GearyImapParameter* _tmp14_;
	GearyImapLiteralParameter* _tmp15_;
	GearyImapLiteralParameter* _tmp16_;
	GearyNonblockingSpinlock* _tmp17_;
	GCancellable* _tmp18_;
	GCancellable* _tmp19_;
	GearyNonblockingSpinlock* _tmp20_;
	GearyNonblockingSpinlock* _tmp21_;
	guint buf_size;
	guint _tmp22_;
	guint _tmp23_;
	guint8* buf;
	guint8* _tmp24_;
	gint buf_length1;
	gint _buf_size_;
	GInputStream* data;
	GearyImapLiteralParameter* _tmp25_;
	GearyMemoryBuffer* _tmp26_;
	GearyMemoryBuffer* _tmp27_;
	GInputStream* _tmp28_;
	gsize read;
	GInputStream* _tmp29_;
	guint8* _tmp30_;
	gint _tmp30__length1;
	gsize _tmp31_;
	guint8* _tmp32_;
	gint _tmp32__length1;
	GearyTimeoutManager* _tmp33_;
	GError* _inner_error1_;
	GInputStream* _tmp34_;
	GError* _inner_error0_;
};

struct _GearyImapCommandSendWaitData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapCommand* self;
	GearyImapSerializer* ser;
	GCancellable* cancellable;
};

struct _GearyImapCommandWaitUntilCompleteData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapCommand* self;
	GCancellable* cancellable;
	GearyNonblockingSemaphore* _tmp0_;
	GError* _tmp1_;
	GError* _tmp2_;
	GError* _tmp3_;
	gboolean _tmp4_;
	GCancellable* _tmp5_;
	GCancellable* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GError* _tmp9_;
	GError* _tmp10_;
	GearyImapStatusResponse* _tmp11_;
	GearyImapStatus _tmp12_;
	GearyImapStatus _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GearyImapStatusResponse* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GError* _tmp19_;
	GError* _tmp20_;
	GError* _inner_error0_;
};

static gint GearyImapCommand_private_offset;
static gpointer geary_imap_command_parent_class = NULL;

VALA_EXTERN void geary_imap_command_send (GearyImapCommand* self,
                              GearyImapSerializer* ser,
                              GCancellable* cancellable,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_);
VALA_EXTERN void geary_imap_command_send_finish (GearyImapCommand* self,
                                     GAsyncResult* _res_,
                                     GError** error);
VALA_EXTERN void geary_imap_command_send_wait (GearyImapCommand* self,
                                   GearyImapSerializer* ser,
                                   GCancellable* cancellable,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
VALA_EXTERN void geary_imap_command_send_wait_finish (GearyImapCommand* self,
                                          GAsyncResult* _res_,
                                          GError** error);
VALA_EXTERN void geary_imap_command_update_response_timer (GearyImapCommand* self);
VALA_EXTERN void geary_imap_command_completed (GearyImapCommand* self,
                                   GearyImapStatusResponse* new_status,
                                   GError** error);
VALA_EXTERN void geary_imap_command_cancelled_before_send (GearyImapCommand* self);
VALA_EXTERN void geary_imap_command_disconnected (GearyImapCommand* self,
                                      const gchar* reason);
VALA_EXTERN void geary_imap_command_data_received (GearyImapCommand* self,
                                       GearyImapServerData* data,
                                       GError** error);
VALA_EXTERN void geary_imap_command_continuation_requested (GearyImapCommand* self,
                                                GearyImapContinuationResponse* continuation,
                                                GError** error);
static void geary_imap_command_set_tag (GearyImapCommand* self,
                                 GearyImapTag* value);
static void geary_imap_command_set_name (GearyImapCommand* self,
                                  const gchar* value);
static void geary_imap_command_set_status (GearyImapCommand* self,
                                    GearyImapStatusResponse* value);
static void geary_imap_command_set_should_send (GearyImapCommand* self,
                                         GCancellable* value);
static void geary_imap_command_set_args (GearyImapCommand* self,
                                  GearyImapListParameter* value);
static void geary_imap_command_set_response_timer (GearyImapCommand* self,
                                            GearyTimeoutManager* value);
static void geary_imap_command_on_response_timeout (GearyImapCommand* self);
static void _geary_imap_command_on_response_timeout_geary_timeout_manager_timeout_func (GearyTimeoutManager* manager,
                                                                                 gpointer self);
VALA_EXTERN void geary_imap_command_assign_tag (GearyImapCommand* self,
                                    GearyImapTag* new_tag,
                                    GError** error);
VALA_EXTERN gchar* geary_imap_command_to_brief_string (GearyImapCommand* self);
static void geary_imap_command_real_send_data_free (gpointer _data);
static void geary_imap_command_real_send (GearyImapCommand* self,
                                   GearyImapSerializer* ser,
                                   GCancellable* cancellable,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
static gboolean geary_imap_command_real_send_co (GearyImapCommandSendData* _data_);
static void geary_imap_command_send_ready (GObject* source_object,
                                    GAsyncResult* _res_,
                                    gpointer _user_data_);
static void geary_imap_command_real_send_wait_data_free (gpointer _data);
static void geary_imap_command_real_send_wait (GearyImapCommand* self,
                                        GearyImapSerializer* ser,
                                        GCancellable* cancellable,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
static gboolean geary_imap_command_real_send_wait_co (GearyImapCommandSendWaitData* _data_);
static void geary_imap_command_wait_until_complete_data_free (gpointer _data);
static gboolean geary_imap_command_wait_until_complete_co (GearyImapCommandWaitUntilCompleteData* _data_);
static void geary_imap_command_wait_until_complete_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_);
static void geary_imap_command_check_has_status (GearyImapCommand* self,
                                          GError** error);
static gchar* geary_imap_command_real_to_string (GearyImapCommand* self);
static void geary_imap_command_real_update_response_timer (GearyImapCommand* self);
static void geary_imap_command_real_completed (GearyImapCommand* self,
                                        GearyImapStatusResponse* new_status,
                                        GError** error);
static void geary_imap_command_real_cancelled_before_send (GearyImapCommand* self);
static void geary_imap_command_cancel (GearyImapCommand* self,
                                GError* cause);
static void geary_imap_command_real_disconnected (GearyImapCommand* self,
                                           const gchar* reason);
static void geary_imap_command_real_data_received (GearyImapCommand* self,
                                            GearyImapServerData* data,
                                            GError** error);
static void geary_imap_command_real_continuation_requested (GearyImapCommand* self,
                                                     GearyImapContinuationResponse* continuation,
                                                     GError** error);
static void geary_imap_command_real_stop_serialisation (GearyImapCommand* self);
static void geary_imap_command_finalize (GObject * obj);
static GType geary_imap_command_get_type_once (void);
static void _vala_geary_imap_command_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_geary_imap_command_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);

static inline gpointer
geary_imap_command_get_instance_private (GearyImapCommand* self)
{
	return G_STRUCT_MEMBER_P (self, GearyImapCommand_private_offset);
}

GearyImapTag*
geary_imap_command_get_tag (GearyImapCommand* self)
{
	GearyImapTag* result;
	GearyImapTag* _tmp0_;
#line 39 "../src/engine/imap/command/imap-command.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_COMMAND (self), NULL);
#line 39 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = self->priv->_tag;
#line 39 "../src/engine/imap/command/imap-command.vala"
	result = _tmp0_;
#line 39 "../src/engine/imap/command/imap-command.vala"
	return result;
#line 291 "imap-command.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 39 "../src/engine/imap/command/imap-command.vala"
	return self ? g_object_ref (self) : NULL;
#line 299 "imap-command.c"
}

static void
geary_imap_command_set_tag (GearyImapCommand* self,
                            GearyImapTag* value)
{
	GearyImapTag* old_value;
#line 39 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (self));
#line 39 "../src/engine/imap/command/imap-command.vala"
	old_value = geary_imap_command_get_tag (self);
#line 39 "../src/engine/imap/command/imap-command.vala"
	if (old_value != value) {
#line 313 "imap-command.c"
		GearyImapTag* _tmp0_;
#line 39 "../src/engine/imap/command/imap-command.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 39 "../src/engine/imap/command/imap-command.vala"
		_g_object_unref0 (self->priv->_tag);
#line 39 "../src/engine/imap/command/imap-command.vala"
		self->priv->_tag = _tmp0_;
#line 39 "../src/engine/imap/command/imap-command.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_imap_command_properties[GEARY_IMAP_COMMAND_TAG_PROPERTY]);
#line 323 "imap-command.c"
	}
}

const gchar*
geary_imap_command_get_name (GearyImapCommand* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 44 "../src/engine/imap/command/imap-command.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_COMMAND (self), NULL);
#line 44 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = self->priv->_name;
#line 44 "../src/engine/imap/command/imap-command.vala"
	result = _tmp0_;
#line 44 "../src/engine/imap/command/imap-command.vala"
	return result;
#line 340 "imap-command.c"
}

static void
geary_imap_command_set_name (GearyImapCommand* self,
                             const gchar* value)
{
	gchar* old_value;
#line 44 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (self));
#line 44 "../src/engine/imap/command/imap-command.vala"
	old_value = geary_imap_command_get_name (self);
#line 44 "../src/engine/imap/command/imap-command.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 354 "imap-command.c"
		gchar* _tmp0_;
#line 44 "../src/engine/imap/command/imap-command.vala"
		_tmp0_ = g_strdup (value);
#line 44 "../src/engine/imap/command/imap-command.vala"
		_g_free0 (self->priv->_name);
#line 44 "../src/engine/imap/command/imap-command.vala"
		self->priv->_name = _tmp0_;
#line 44 "../src/engine/imap/command/imap-command.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_imap_command_properties[GEARY_IMAP_COMMAND_NAME_PROPERTY]);
#line 364 "imap-command.c"
	}
}

guint
geary_imap_command_get_response_timeout (GearyImapCommand* self)
{
	guint result;
#line 50 "../src/engine/imap/command/imap-command.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_COMMAND (self), 0U);
#line 51 "../src/engine/imap/command/imap-command.vala"
	result = self->priv->_response_timeout;
#line 51 "../src/engine/imap/command/imap-command.vala"
	return result;
#line 378 "imap-command.c"
}

void
geary_imap_command_set_response_timeout (GearyImapCommand* self,
                                         guint value)
{
	GearyTimeoutManager* _tmp0_;
#line 53 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (self));
#line 54 "../src/engine/imap/command/imap-command.vala"
	self->priv->_response_timeout = value;
#line 55 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = self->priv->_response_timer;
#line 55 "../src/engine/imap/command/imap-command.vala"
	_tmp0_->interval = value;
#line 53 "../src/engine/imap/command/imap-command.vala"
	g_object_notify_by_pspec ((GObject *) self, geary_imap_command_properties[GEARY_IMAP_COMMAND_RESPONSE_TIMEOUT_PROPERTY]);
#line 396 "imap-command.c"
}

GearyImapStatusResponse*
geary_imap_command_get_status (GearyImapCommand* self)
{
	GearyImapStatusResponse* result;
	GearyImapStatusResponse* _tmp0_;
#line 61 "../src/engine/imap/command/imap-command.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_COMMAND (self), NULL);
#line 61 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = self->priv->_status;
#line 61 "../src/engine/imap/command/imap-command.vala"
	result = _tmp0_;
#line 61 "../src/engine/imap/command/imap-command.vala"
	return result;
#line 412 "imap-command.c"
}

static void
geary_imap_command_set_status (GearyImapCommand* self,
                               GearyImapStatusResponse* value)
{
	GearyImapStatusResponse* old_value;
#line 61 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (self));
#line 61 "../src/engine/imap/command/imap-command.vala"
	old_value = geary_imap_command_get_status (self);
#line 61 "../src/engine/imap/command/imap-command.vala"
	if (old_value != value) {
#line 426 "imap-command.c"
		GearyImapStatusResponse* _tmp0_;
#line 61 "../src/engine/imap/command/imap-command.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 61 "../src/engine/imap/command/imap-command.vala"
		_g_object_unref0 (self->priv->_status);
#line 61 "../src/engine/imap/command/imap-command.vala"
		self->priv->_status = _tmp0_;
#line 61 "../src/engine/imap/command/imap-command.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_imap_command_properties[GEARY_IMAP_COMMAND_STATUS_PROPERTY]);
#line 436 "imap-command.c"
	}
}

GCancellable*
geary_imap_command_get_should_send (GearyImapCommand* self)
{
	GCancellable* result;
	GCancellable* _tmp0_;
#line 75 "../src/engine/imap/command/imap-command.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_COMMAND (self), NULL);
#line 75 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = self->priv->_should_send;
#line 75 "../src/engine/imap/command/imap-command.vala"
	result = _tmp0_;
#line 75 "../src/engine/imap/command/imap-command.vala"
	return result;
#line 453 "imap-command.c"
}

static void
geary_imap_command_set_should_send (GearyImapCommand* self,
                                    GCancellable* value)
{
	GCancellable* old_value;
#line 75 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (self));
#line 75 "../src/engine/imap/command/imap-command.vala"
	old_value = geary_imap_command_get_should_send (self);
#line 75 "../src/engine/imap/command/imap-command.vala"
	if (old_value != value) {
#line 467 "imap-command.c"
		GCancellable* _tmp0_;
#line 75 "../src/engine/imap/command/imap-command.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 75 "../src/engine/imap/command/imap-command.vala"
		_g_object_unref0 (self->priv->_should_send);
#line 75 "../src/engine/imap/command/imap-command.vala"
		self->priv->_should_send = _tmp0_;
#line 75 "../src/engine/imap/command/imap-command.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_imap_command_properties[GEARY_IMAP_COMMAND_SHOULD_SEND_PROPERTY]);
#line 477 "imap-command.c"
	}
}

GearyImapListParameter*
geary_imap_command_get_args (GearyImapCommand* self)
{
	GearyImapListParameter* result;
	GearyImapListParameter* _tmp0_;
#line 84 "../src/engine/imap/command/imap-command.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_COMMAND (self), NULL);
#line 84 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = self->priv->_args;
#line 84 "../src/engine/imap/command/imap-command.vala"
	result = _tmp0_;
#line 84 "../src/engine/imap/command/imap-command.vala"
	return result;
#line 494 "imap-command.c"
}

static void
geary_imap_command_set_args (GearyImapCommand* self,
                             GearyImapListParameter* value)
{
	GearyImapListParameter* old_value;
#line 84 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (self));
#line 84 "../src/engine/imap/command/imap-command.vala"
	old_value = geary_imap_command_get_args (self);
#line 84 "../src/engine/imap/command/imap-command.vala"
	if (old_value != value) {
#line 508 "imap-command.c"
		GearyImapListParameter* _tmp0_;
#line 84 "../src/engine/imap/command/imap-command.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 84 "../src/engine/imap/command/imap-command.vala"
		_g_object_unref0 (self->priv->_args);
#line 84 "../src/engine/imap/command/imap-command.vala"
		self->priv->_args = _tmp0_;
#line 84 "../src/engine/imap/command/imap-command.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_imap_command_properties[GEARY_IMAP_COMMAND_ARGS_PROPERTY]);
#line 518 "imap-command.c"
	}
}

GearyTimeoutManager*
geary_imap_command_get_response_timer (GearyImapCommand* self)
{
	GearyTimeoutManager* result;
	GearyTimeoutManager* _tmp0_;
#line 90 "../src/engine/imap/command/imap-command.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_COMMAND (self), NULL);
#line 90 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = self->priv->_response_timer;
#line 90 "../src/engine/imap/command/imap-command.vala"
	result = _tmp0_;
#line 90 "../src/engine/imap/command/imap-command.vala"
	return result;
#line 535 "imap-command.c"
}

static void
geary_imap_command_set_response_timer (GearyImapCommand* self,
                                       GearyTimeoutManager* value)
{
	GearyTimeoutManager* old_value;
#line 90 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (self));
#line 90 "../src/engine/imap/command/imap-command.vala"
	old_value = geary_imap_command_get_response_timer (self);
#line 90 "../src/engine/imap/command/imap-command.vala"
	if (old_value != value) {
#line 549 "imap-command.c"
		GearyTimeoutManager* _tmp0_;
#line 90 "../src/engine/imap/command/imap-command.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 90 "../src/engine/imap/command/imap-command.vala"
		_g_object_unref0 (self->priv->_response_timer);
#line 90 "../src/engine/imap/command/imap-command.vala"
		self->priv->_response_timer = _tmp0_;
#line 90 "../src/engine/imap/command/imap-command.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_imap_command_properties[GEARY_IMAP_COMMAND_RESPONSE_TIMER_PROPERTY]);
#line 559 "imap-command.c"
	}
}

/**
     * Constructs a new command with an unassigned tag.
     *
     * Any arguments provided here will be converted to appropriate
     * string arguments. The given cancellable will be set as {@link
     * should_send}.
     *
     * @see Tag
     * @see should_send
     */
static void
_geary_imap_command_on_response_timeout_geary_timeout_manager_timeout_func (GearyTimeoutManager* manager,
                                                                            gpointer self)
{
#line 128 "../src/engine/imap/command/imap-command.vala"
	geary_imap_command_on_response_timeout ((GearyImapCommand*) self);
#line 579 "imap-command.c"
}

GearyImapCommand*
geary_imap_command_construct (GType object_type,
                              const gchar* name,
                              gchar** args,
                              gint args_length1,
                              GCancellable* should_send)
{
	GearyImapCommand * self = NULL;
	GearyImapTag* _tmp0_;
	GearyImapTag* _tmp1_;
	GearyTimeoutManager* _tmp7_;
	GearyTimeoutManager* _tmp8_;
#line 116 "../src/engine/imap/command/imap-command.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 116 "../src/engine/imap/command/imap-command.vala"
	g_return_val_if_fail ((should_send == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (should_send, g_cancellable_get_type ()), NULL);
#line 116 "../src/engine/imap/command/imap-command.vala"
	self = (GearyImapCommand*) geary_base_object_construct (object_type);
#line 119 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = geary_imap_tag_get_unassigned ();
#line 119 "../src/engine/imap/command/imap-command.vala"
	_tmp1_ = _tmp0_;
#line 119 "../src/engine/imap/command/imap-command.vala"
	geary_imap_command_set_tag (self, _tmp1_);
#line 119 "../src/engine/imap/command/imap-command.vala"
	_g_object_unref0 (_tmp1_);
#line 120 "../src/engine/imap/command/imap-command.vala"
	geary_imap_command_set_name (self, name);
#line 121 "../src/engine/imap/command/imap-command.vala"
	if (args != NULL) {
#line 612 "imap-command.c"
		{
			gchar** arg_collection = NULL;
			gint arg_collection_length1 = 0;
			gint _arg_collection_size_ = 0;
			gint arg_it = 0;
#line 122 "../src/engine/imap/command/imap-command.vala"
			arg_collection = args;
#line 122 "../src/engine/imap/command/imap-command.vala"
			arg_collection_length1 = args_length1;
#line 122 "../src/engine/imap/command/imap-command.vala"
			for (arg_it = 0; arg_it < arg_collection_length1; arg_it = arg_it + 1) {
#line 624 "imap-command.c"
				gchar* _tmp2_;
				gchar* arg = NULL;
#line 122 "../src/engine/imap/command/imap-command.vala"
				_tmp2_ = g_strdup (arg_collection[arg_it]);
#line 122 "../src/engine/imap/command/imap-command.vala"
				arg = _tmp2_;
#line 631 "imap-command.c"
				{
					GearyImapListParameter* _tmp3_;
					const gchar* _tmp4_;
					GearyImapParameter* _tmp5_;
					GearyImapParameter* _tmp6_;
#line 123 "../src/engine/imap/command/imap-command.vala"
					_tmp3_ = self->priv->_args;
#line 123 "../src/engine/imap/command/imap-command.vala"
					_tmp4_ = arg;
#line 123 "../src/engine/imap/command/imap-command.vala"
					_tmp5_ = geary_imap_parameter_get_for_string (_tmp4_);
#line 123 "../src/engine/imap/command/imap-command.vala"
					_tmp6_ = _tmp5_;
#line 123 "../src/engine/imap/command/imap-command.vala"
					geary_imap_list_parameter_add (_tmp3_, _tmp6_);
#line 123 "../src/engine/imap/command/imap-command.vala"
					_g_object_unref0 (_tmp6_);
#line 122 "../src/engine/imap/command/imap-command.vala"
					_g_free0 (arg);
#line 651 "imap-command.c"
				}
			}
		}
	}
#line 126 "../src/engine/imap/command/imap-command.vala"
	geary_imap_command_set_should_send (self, should_send);
#line 128 "../src/engine/imap/command/imap-command.vala"
	_tmp7_ = geary_timeout_manager_new_seconds (self->priv->_response_timeout, _geary_imap_command_on_response_timeout_geary_timeout_manager_timeout_func, self);
#line 128 "../src/engine/imap/command/imap-command.vala"
	_tmp8_ = _tmp7_;
#line 128 "../src/engine/imap/command/imap-command.vala"
	geary_imap_command_set_response_timer (self, _tmp8_);
#line 128 "../src/engine/imap/command/imap-command.vala"
	_g_object_unref0 (_tmp8_);
#line 116 "../src/engine/imap/command/imap-command.vala"
	return self;
#line 668 "imap-command.c"
}

gboolean
geary_imap_command_has_name (GearyImapCommand* self,
                             const gchar* name)
{
	const gchar* _tmp0_;
	gboolean result;
#line 133 "../src/engine/imap/command/imap-command.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_COMMAND (self), FALSE);
#line 133 "../src/engine/imap/command/imap-command.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 134 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = self->priv->_name;
#line 134 "../src/engine/imap/command/imap-command.vala"
	result = geary_ascii_stri_equal (_tmp0_, name);
#line 134 "../src/engine/imap/command/imap-command.vala"
	return result;
#line 687 "imap-command.c"
}

/**
     * Assign a Tag to this command, if currently unassigned.
     *
     * Can only be called on a Command that holds an unassigned tag,
     * and hence this can only be called once at most. Throws an error
     * if already assigned or if the supplied tag is unassigned.
     */
void
geary_imap_command_assign_tag (GearyImapCommand* self,
                               GearyImapTag* new_tag,
                               GError** error)
{
	GearyImapTag* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 144 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (self));
#line 144 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_TAG (new_tag));
#line 145 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = self->priv->_tag;
#line 145 "../src/engine/imap/command/imap-command.vala"
	if (geary_imap_tag_is_assigned (_tmp0_)) {
#line 712 "imap-command.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
		GError* _tmp3_;
		GError* _tmp4_;
#line 146 "../src/engine/imap/command/imap-command.vala"
		_tmp1_ = geary_imap_command_to_brief_string (self);
#line 146 "../src/engine/imap/command/imap-command.vala"
		_tmp2_ = _tmp1_;
#line 146 "../src/engine/imap/command/imap-command.vala"
		_tmp3_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_NOT_SUPPORTED, "%s: Command tag is already assigned", _tmp2_);
#line 146 "../src/engine/imap/command/imap-command.vala"
		_tmp4_ = _tmp3_;
#line 146 "../src/engine/imap/command/imap-command.vala"
		_g_free0 (_tmp2_);
#line 146 "../src/engine/imap/command/imap-command.vala"
		_inner_error0_ = _tmp4_;
#line 146 "../src/engine/imap/command/imap-command.vala"
		if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 146 "../src/engine/imap/command/imap-command.vala"
			g_propagate_error (error, _inner_error0_);
#line 146 "../src/engine/imap/command/imap-command.vala"
			return;
#line 735 "imap-command.c"
		} else {
#line 146 "../src/engine/imap/command/imap-command.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 146 "../src/engine/imap/command/imap-command.vala"
			g_clear_error (&_inner_error0_);
#line 146 "../src/engine/imap/command/imap-command.vala"
			return;
#line 743 "imap-command.c"
		}
	}
#line 150 "../src/engine/imap/command/imap-command.vala"
	if (!geary_imap_tag_is_assigned (new_tag)) {
#line 748 "imap-command.c"
		gchar* _tmp5_;
		gchar* _tmp6_;
		GError* _tmp7_;
		GError* _tmp8_;
#line 151 "../src/engine/imap/command/imap-command.vala"
		_tmp5_ = geary_imap_command_to_brief_string (self);
#line 151 "../src/engine/imap/command/imap-command.vala"
		_tmp6_ = _tmp5_;
#line 151 "../src/engine/imap/command/imap-command.vala"
		_tmp7_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_NOT_SUPPORTED, "%s: New tag is not assigned", _tmp6_);
#line 151 "../src/engine/imap/command/imap-command.vala"
		_tmp8_ = _tmp7_;
#line 151 "../src/engine/imap/command/imap-command.vala"
		_g_free0 (_tmp6_);
#line 151 "../src/engine/imap/command/imap-command.vala"
		_inner_error0_ = _tmp8_;
#line 151 "../src/engine/imap/command/imap-command.vala"
		if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 151 "../src/engine/imap/command/imap-command.vala"
			g_propagate_error (error, _inner_error0_);
#line 151 "../src/engine/imap/command/imap-command.vala"
			return;
#line 771 "imap-command.c"
		} else {
#line 151 "../src/engine/imap/command/imap-command.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 151 "../src/engine/imap/command/imap-command.vala"
			g_clear_error (&_inner_error0_);
#line 151 "../src/engine/imap/command/imap-command.vala"
			return;
#line 779 "imap-command.c"
		}
	}
#line 156 "../src/engine/imap/command/imap-command.vala"
	geary_imap_command_set_tag (self, new_tag);
#line 784 "imap-command.c"
}

static void
geary_imap_command_real_send_data_free (gpointer _data)
{
	GearyImapCommandSendData* _data_;
	_data_ = _data;
#line 20 "../src/engine/imap/command/imap-command.vala"
	_g_object_unref0 (_data_->ser);
#line 20 "../src/engine/imap/command/imap-command.vala"
	_g_object_unref0 (_data_->cancellable);
#line 20 "../src/engine/imap/command/imap-command.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/engine/imap/command/imap-command.vala"
	g_slice_free (GearyImapCommandSendData, _data_);
#line 800 "imap-command.c"
}

static void
geary_imap_command_real_send (GearyImapCommand* self,
                              GearyImapSerializer* ser,
                              GCancellable* cancellable,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	GearyImapCommandSendData* _data_;
	GearyImapCommand* _tmp0_;
	GearyImapSerializer* _tmp1_;
	GCancellable* _tmp2_;
#line 20 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_SERIALIZER (ser));
#line 20 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 20 "../src/engine/imap/command/imap-command.vala"
	_data_ = g_slice_new0 (GearyImapCommandSendData);
#line 20 "../src/engine/imap/command/imap-command.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 20 "../src/engine/imap/command/imap-command.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_command_real_send_data_free);
#line 20 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/engine/imap/command/imap-command.vala"
	_data_->self = _tmp0_;
#line 20 "../src/engine/imap/command/imap-command.vala"
	_tmp1_ = _g_object_ref0 (ser);
#line 20 "../src/engine/imap/command/imap-command.vala"
	_g_object_unref0 (_data_->ser);
#line 20 "../src/engine/imap/command/imap-command.vala"
	_data_->ser = _tmp1_;
#line 20 "../src/engine/imap/command/imap-command.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 20 "../src/engine/imap/command/imap-command.vala"
	_g_object_unref0 (_data_->cancellable);
#line 20 "../src/engine/imap/command/imap-command.vala"
	_data_->cancellable = _tmp2_;
#line 20 "../src/engine/imap/command/imap-command.vala"
	geary_imap_command_real_send_co (_data_);
#line 842 "imap-command.c"
}

static void
geary_imap_command_real_send_finish (GearyImapCommand* self,
                                     GAsyncResult* _res_,
                                     GError** error)
{
	GearyImapCommandSendData* _data_;
#line 20 "../src/engine/imap/command/imap-command.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 20 "../src/engine/imap/command/imap-command.vala"
	if (NULL == _data_) {
#line 20 "../src/engine/imap/command/imap-command.vala"
		return;
#line 857 "imap-command.c"
	}
}

/**
     * Serialises this command for transmission to the server.
     *
     * This will serialise its tag, name and arguments (if
     * any). Arguments are treated as strings and escaped as needed,
     * including being encoded as a literal. If any literals are
     * required, this method will yield until a command continuation
     * has been received, when it will resume the same process.
     */
static void
geary_imap_command_send_ready (GObject* source_object,
                               GAsyncResult* _res_,
                               gpointer _user_data_)
{
	GearyImapCommandSendData* _data_;
#line 186 "../src/engine/imap/command/imap-command.vala"
	_data_ = _user_data_;
#line 186 "../src/engine/imap/command/imap-command.vala"
	_data_->_source_object_ = source_object;
#line 186 "../src/engine/imap/command/imap-command.vala"
	_data_->_res_ = _res_;
#line 186 "../src/engine/imap/command/imap-command.vala"
	geary_imap_command_real_send_co (_data_);
#line 884 "imap-command.c"
}

static gboolean
geary_imap_command_real_send_co (GearyImapCommandSendData* _data_)
{
#line 168 "../src/engine/imap/command/imap-command.vala"
	switch (_data_->_state_) {
#line 168 "../src/engine/imap/command/imap-command.vala"
		case 0:
#line 894 "imap-command.c"
		goto _state_0;
#line 168 "../src/engine/imap/command/imap-command.vala"
		case 1:
#line 898 "imap-command.c"
		goto _state_1;
#line 168 "../src/engine/imap/command/imap-command.vala"
		case 2:
#line 902 "imap-command.c"
		goto _state_2;
#line 168 "../src/engine/imap/command/imap-command.vala"
		case 3:
#line 906 "imap-command.c"
		goto _state_3;
#line 168 "../src/engine/imap/command/imap-command.vala"
		case 4:
#line 910 "imap-command.c"
		goto _state_4;
#line 168 "../src/engine/imap/command/imap-command.vala"
		case 5:
#line 914 "imap-command.c"
		goto _state_5;
		default:
#line 168 "../src/engine/imap/command/imap-command.vala"
		g_assert_not_reached ();
#line 919 "imap-command.c"
	}
	_state_0:
#line 171 "../src/engine/imap/command/imap-command.vala"
	_data_->_tmp0_ = _data_->self->priv->_response_timer;
#line 171 "../src/engine/imap/command/imap-command.vala"
	geary_timeout_manager_start (_data_->_tmp0_);
#line 172 "../src/engine/imap/command/imap-command.vala"
	_data_->_tmp1_ = _data_->self->priv->_tag;
#line 172 "../src/engine/imap/command/imap-command.vala"
	geary_imap_parameter_serialize (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp1_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter), _data_->ser, _data_->cancellable, &_data_->_inner_error0_);
#line 172 "../src/engine/imap/command/imap-command.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 172 "../src/engine/imap/command/imap-command.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 172 "../src/engine/imap/command/imap-command.vala"
		g_object_unref (_data_->_async_result);
#line 172 "../src/engine/imap/command/imap-command.vala"
		return FALSE;
#line 938 "imap-command.c"
	}
#line 173 "../src/engine/imap/command/imap-command.vala"
	geary_imap_serializer_push_space (_data_->ser, _data_->cancellable, &_data_->_inner_error0_);
#line 173 "../src/engine/imap/command/imap-command.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 173 "../src/engine/imap/command/imap-command.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 173 "../src/engine/imap/command/imap-command.vala"
		g_object_unref (_data_->_async_result);
#line 173 "../src/engine/imap/command/imap-command.vala"
		return FALSE;
#line 950 "imap-command.c"
	}
#line 174 "../src/engine/imap/command/imap-command.vala"
	_data_->_tmp2_ = _data_->self->priv->_name;
#line 174 "../src/engine/imap/command/imap-command.vala"
	geary_imap_serializer_push_unquoted_string (_data_->ser, _data_->_tmp2_, _data_->cancellable, &_data_->_inner_error0_);
#line 174 "../src/engine/imap/command/imap-command.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 174 "../src/engine/imap/command/imap-command.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 174 "../src/engine/imap/command/imap-command.vala"
		g_object_unref (_data_->_async_result);
#line 174 "../src/engine/imap/command/imap-command.vala"
		return FALSE;
#line 964 "imap-command.c"
	}
#line 176 "../src/engine/imap/command/imap-command.vala"
	_data_->_tmp3_ = _data_->self->priv->_args;
#line 176 "../src/engine/imap/command/imap-command.vala"
	if (_data_->_tmp3_ != NULL) {
#line 970 "imap-command.c"
		{
#line 177 "../src/engine/imap/command/imap-command.vala"
			_data_->_tmp4_ = _data_->self->priv->_args;
#line 177 "../src/engine/imap/command/imap-command.vala"
			_data_->_tmp5_ = geary_imap_list_parameter_get_all (_data_->_tmp4_);
#line 177 "../src/engine/imap/command/imap-command.vala"
			_data_->_arg_list = _data_->_tmp5_;
#line 177 "../src/engine/imap/command/imap-command.vala"
			_data_->_tmp6_ = _data_->_arg_list;
#line 177 "../src/engine/imap/command/imap-command.vala"
			_data_->_tmp7_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, GEE_TYPE_COLLECTION, GeeCollection));
#line 177 "../src/engine/imap/command/imap-command.vala"
			_data_->_tmp8_ = _data_->_tmp7_;
#line 177 "../src/engine/imap/command/imap-command.vala"
			_data_->_arg_size = _data_->_tmp8_;
#line 177 "../src/engine/imap/command/imap-command.vala"
			_data_->_arg_index = -1;
#line 177 "../src/engine/imap/command/imap-command.vala"
			while (TRUE) {
#line 177 "../src/engine/imap/command/imap-command.vala"
				_data_->_arg_index = _data_->_arg_index + 1;
#line 177 "../src/engine/imap/command/imap-command.vala"
				_data_->_tmp9_ = _data_->_arg_index;
#line 177 "../src/engine/imap/command/imap-command.vala"
				_data_->_tmp10_ = _data_->_arg_size;
#line 177 "../src/engine/imap/command/imap-command.vala"
				if (!(_data_->_tmp9_ < _data_->_tmp10_)) {
#line 177 "../src/engine/imap/command/imap-command.vala"
					break;
#line 1000 "imap-command.c"
				}
#line 177 "../src/engine/imap/command/imap-command.vala"
				_data_->_tmp11_ = _data_->_arg_list;
#line 177 "../src/engine/imap/command/imap-command.vala"
				_data_->_tmp12_ = gee_list_get (_data_->_tmp11_, _data_->_arg_index);
#line 177 "../src/engine/imap/command/imap-command.vala"
				_data_->arg = (GearyImapParameter*) _data_->_tmp12_;
#line 178 "../src/engine/imap/command/imap-command.vala"
				geary_imap_serializer_push_space (_data_->ser, _data_->cancellable, &_data_->_inner_error0_);
#line 178 "../src/engine/imap/command/imap-command.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 178 "../src/engine/imap/command/imap-command.vala"
					g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 178 "../src/engine/imap/command/imap-command.vala"
					_g_object_unref0 (_data_->arg);
#line 178 "../src/engine/imap/command/imap-command.vala"
					_g_object_unref0 (_data_->_arg_list);
#line 178 "../src/engine/imap/command/imap-command.vala"
					g_object_unref (_data_->_async_result);
#line 178 "../src/engine/imap/command/imap-command.vala"
					return FALSE;
#line 1022 "imap-command.c"
				}
#line 179 "../src/engine/imap/command/imap-command.vala"
				_data_->_tmp13_ = _data_->arg;
#line 179 "../src/engine/imap/command/imap-command.vala"
				geary_imap_parameter_serialize (_data_->_tmp13_, _data_->ser, _data_->cancellable, &_data_->_inner_error0_);
#line 179 "../src/engine/imap/command/imap-command.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 179 "../src/engine/imap/command/imap-command.vala"
					g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 179 "../src/engine/imap/command/imap-command.vala"
					_g_object_unref0 (_data_->arg);
#line 179 "../src/engine/imap/command/imap-command.vala"
					_g_object_unref0 (_data_->_arg_list);
#line 179 "../src/engine/imap/command/imap-command.vala"
					g_object_unref (_data_->_async_result);
#line 179 "../src/engine/imap/command/imap-command.vala"
					return FALSE;
#line 1040 "imap-command.c"
				}
#line 181 "../src/engine/imap/command/imap-command.vala"
				_data_->_tmp14_ = _data_->arg;
#line 181 "../src/engine/imap/command/imap-command.vala"
				_data_->_tmp15_ = _g_object_ref0 (GEARY_IMAP_IS_LITERAL_PARAMETER (_data_->_tmp14_) ? ((GearyImapLiteralParameter*) _data_->_tmp14_) : NULL);
#line 181 "../src/engine/imap/command/imap-command.vala"
				_data_->literal = _data_->_tmp15_;
#line 182 "../src/engine/imap/command/imap-command.vala"
				_data_->_tmp16_ = _data_->literal;
#line 182 "../src/engine/imap/command/imap-command.vala"
				if (_data_->_tmp16_ != NULL) {
#line 186 "../src/engine/imap/command/imap-command.vala"
					_data_->_state_ = 1;
#line 186 "../src/engine/imap/command/imap-command.vala"
					geary_imap_serializer_flush_stream (_data_->ser, _data_->cancellable, geary_imap_command_send_ready, _data_);
#line 186 "../src/engine/imap/command/imap-command.vala"
					return FALSE;
#line 1058 "imap-command.c"
					_state_1:
#line 186 "../src/engine/imap/command/imap-command.vala"
					geary_imap_serializer_flush_stream_finish (_data_->ser, _data_->_res_, &_data_->_inner_error0_);
#line 186 "../src/engine/imap/command/imap-command.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 186 "../src/engine/imap/command/imap-command.vala"
						g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 186 "../src/engine/imap/command/imap-command.vala"
						_g_object_unref0 (_data_->literal);
#line 186 "../src/engine/imap/command/imap-command.vala"
						_g_object_unref0 (_data_->arg);
#line 186 "../src/engine/imap/command/imap-command.vala"
						_g_object_unref0 (_data_->_arg_list);
#line 186 "../src/engine/imap/command/imap-command.vala"
						g_object_unref (_data_->_async_result);
#line 186 "../src/engine/imap/command/imap-command.vala"
						return FALSE;
#line 1076 "imap-command.c"
					}
#line 188 "../src/engine/imap/command/imap-command.vala"
					_data_->_tmp17_ = _data_->self->priv->literal_spinlock;
#line 188 "../src/engine/imap/command/imap-command.vala"
					if (_data_->_tmp17_ == NULL) {
#line 191 "../src/engine/imap/command/imap-command.vala"
						_data_->_tmp18_ = g_cancellable_new ();
#line 191 "../src/engine/imap/command/imap-command.vala"
						_g_object_unref0 (_data_->self->priv->literal_cancellable);
#line 191 "../src/engine/imap/command/imap-command.vala"
						_data_->self->priv->literal_cancellable = _data_->_tmp18_;
#line 192 "../src/engine/imap/command/imap-command.vala"
						_data_->_tmp19_ = _data_->self->priv->literal_cancellable;
#line 192 "../src/engine/imap/command/imap-command.vala"
						_data_->_tmp20_ = geary_nonblocking_spinlock_new (_data_->_tmp19_);
#line 192 "../src/engine/imap/command/imap-command.vala"
						_g_object_unref0 (_data_->self->priv->literal_spinlock);
#line 192 "../src/engine/imap/command/imap-command.vala"
						_data_->self->priv->literal_spinlock = _data_->_tmp20_;
#line 1096 "imap-command.c"
					}
#line 199 "../src/engine/imap/command/imap-command.vala"
					_data_->_tmp21_ = _data_->self->priv->literal_spinlock;
#line 199 "../src/engine/imap/command/imap-command.vala"
					_data_->_state_ = 2;
#line 199 "../src/engine/imap/command/imap-command.vala"
					geary_nonblocking_lock_wait_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp21_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock), _data_->cancellable, geary_imap_command_send_ready, _data_);
#line 199 "../src/engine/imap/command/imap-command.vala"
					return FALSE;
#line 1106 "imap-command.c"
					_state_2:
#line 199 "../src/engine/imap/command/imap-command.vala"
					geary_nonblocking_lock_wait_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp21_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock), _data_->_res_, &_data_->_inner_error0_);
#line 199 "../src/engine/imap/command/imap-command.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 199 "../src/engine/imap/command/imap-command.vala"
						g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 199 "../src/engine/imap/command/imap-command.vala"
						_g_object_unref0 (_data_->literal);
#line 199 "../src/engine/imap/command/imap-command.vala"
						_g_object_unref0 (_data_->arg);
#line 199 "../src/engine/imap/command/imap-command.vala"
						_g_object_unref0 (_data_->_arg_list);
#line 199 "../src/engine/imap/command/imap-command.vala"
						g_object_unref (_data_->_async_result);
#line 199 "../src/engine/imap/command/imap-command.vala"
						return FALSE;
#line 1124 "imap-command.c"
					}
#line 210 "../src/engine/imap/command/imap-command.vala"
					_data_->buf_size = (guint) 1;
#line 211 "../src/engine/imap/command/imap-command.vala"
					while (TRUE) {
#line 211 "../src/engine/imap/command/imap-command.vala"
						_data_->_tmp22_ = geary_imap_command_get_response_timeout (_data_->self);
#line 211 "../src/engine/imap/command/imap-command.vala"
						_data_->_tmp23_ = _data_->_tmp22_;
#line 211 "../src/engine/imap/command/imap-command.vala"
						if (!(_data_->buf_size <= _data_->_tmp23_)) {
#line 211 "../src/engine/imap/command/imap-command.vala"
							break;
#line 1138 "imap-command.c"
						}
#line 212 "../src/engine/imap/command/imap-command.vala"
						_data_->buf_size <<= (guint) 1;
#line 1142 "imap-command.c"
					}
#line 214 "../src/engine/imap/command/imap-command.vala"
					_data_->buf_size >>= (guint) 1;
#line 216 "../src/engine/imap/command/imap-command.vala"
					_data_->_tmp24_ = g_new0 (guint8, _data_->buf_size * 1024);
#line 216 "../src/engine/imap/command/imap-command.vala"
					_data_->buf = _data_->_tmp24_;
#line 216 "../src/engine/imap/command/imap-command.vala"
					_data_->buf_length1 = _data_->buf_size * 1024;
#line 216 "../src/engine/imap/command/imap-command.vala"
					_data_->_buf_size_ = _data_->buf_length1;
#line 217 "../src/engine/imap/command/imap-command.vala"
					_data_->_tmp25_ = _data_->literal;
#line 217 "../src/engine/imap/command/imap-command.vala"
					_data_->_tmp26_ = geary_imap_literal_parameter_get_value (_data_->_tmp25_);
#line 217 "../src/engine/imap/command/imap-command.vala"
					_data_->_tmp27_ = _data_->_tmp26_;
#line 217 "../src/engine/imap/command/imap-command.vala"
					_data_->_tmp28_ = geary_memory_buffer_get_input_stream (_data_->_tmp27_);
#line 217 "../src/engine/imap/command/imap-command.vala"
					_data_->data = _data_->_tmp28_;
#line 1164 "imap-command.c"
					{
#line 219 "../src/engine/imap/command/imap-command.vala"
						while (TRUE) {
#line 221 "../src/engine/imap/command/imap-command.vala"
							_data_->_tmp29_ = _data_->data;
#line 221 "../src/engine/imap/command/imap-command.vala"
							_data_->_tmp30_ = _data_->buf;
#line 221 "../src/engine/imap/command/imap-command.vala"
							_data_->_tmp30__length1 = _data_->buf_length1;
#line 221 "../src/engine/imap/command/imap-command.vala"
							_data_->_tmp31_ = 0UL;
#line 221 "../src/engine/imap/command/imap-command.vala"
							_data_->_state_ = 3;
#line 221 "../src/engine/imap/command/imap-command.vala"
							g_input_stream_read_all_async (_data_->_tmp29_, _data_->_tmp30_, (gsize) _data_->_tmp30__length1, G_PRIORITY_DEFAULT, _data_->cancellable, geary_imap_command_send_ready, _data_);
#line 221 "../src/engine/imap/command/imap-command.vala"
							return FALSE;
#line 1182 "imap-command.c"
							_state_3:
#line 221 "../src/engine/imap/command/imap-command.vala"
							g_input_stream_read_all_finish (_data_->_tmp29_, _data_->_res_, &_data_->_tmp31_, &_data_->_inner_error0_);
#line 221 "../src/engine/imap/command/imap-command.vala"
							_data_->read = _data_->_tmp31_;
#line 221 "../src/engine/imap/command/imap-command.vala"
							if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1190 "imap-command.c"
								goto __finally0;
							}
#line 224 "../src/engine/imap/command/imap-command.vala"
							if (_data_->read <= ((gsize) 0)) {
#line 225 "../src/engine/imap/command/imap-command.vala"
								break;
#line 1197 "imap-command.c"
							}
#line 228 "../src/engine/imap/command/imap-command.vala"
							_data_->buf_length1 = (gint) _data_->read;
#line 229 "../src/engine/imap/command/imap-command.vala"
							_data_->_tmp32_ = _data_->buf;
#line 229 "../src/engine/imap/command/imap-command.vala"
							_data_->_tmp32__length1 = _data_->buf_length1;
#line 229 "../src/engine/imap/command/imap-command.vala"
							_data_->_state_ = 4;
#line 229 "../src/engine/imap/command/imap-command.vala"
							geary_imap_serializer_push_literal_data (_data_->ser, _data_->_tmp32_, (gint) _data_->_tmp32__length1, _data_->cancellable, geary_imap_command_send_ready, _data_);
#line 229 "../src/engine/imap/command/imap-command.vala"
							return FALSE;
#line 1211 "imap-command.c"
							_state_4:
#line 229 "../src/engine/imap/command/imap-command.vala"
							geary_imap_serializer_push_literal_data_finish (_data_->ser, _data_->_res_, &_data_->_inner_error0_);
#line 229 "../src/engine/imap/command/imap-command.vala"
							if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1217 "imap-command.c"
								goto __finally0;
							}
#line 230 "../src/engine/imap/command/imap-command.vala"
							_data_->_tmp33_ = _data_->self->priv->_response_timer;
#line 230 "../src/engine/imap/command/imap-command.vala"
							geary_timeout_manager_start (_data_->_tmp33_);
#line 1224 "imap-command.c"
						}
					}
					__finally0:
					{
						{
#line 234 "../src/engine/imap/command/imap-command.vala"
							_data_->_tmp34_ = _data_->data;
#line 234 "../src/engine/imap/command/imap-command.vala"
							_data_->_state_ = 5;
#line 234 "../src/engine/imap/command/imap-command.vala"
							g_input_stream_close_async (_data_->_tmp34_, G_PRIORITY_DEFAULT, NULL, geary_imap_command_send_ready, _data_);
#line 234 "../src/engine/imap/command/imap-command.vala"
							return FALSE;
#line 1238 "imap-command.c"
							_state_5:
#line 234 "../src/engine/imap/command/imap-command.vala"
							g_input_stream_close_finish (_data_->_tmp34_, _data_->_res_, &_data_->_inner_error1_);
#line 234 "../src/engine/imap/command/imap-command.vala"
							if (G_UNLIKELY (_data_->_inner_error1_ != NULL)) {
#line 1244 "imap-command.c"
								goto __catch1_g_error;
							}
						}
						goto __finally1;
						__catch1_g_error:
						{
#line 233 "../src/engine/imap/command/imap-command.vala"
							g_clear_error (&_data_->_inner_error1_);
#line 1253 "imap-command.c"
						}
						__finally1:
#line 233 "../src/engine/imap/command/imap-command.vala"
						if (G_UNLIKELY (_data_->_inner_error1_ != NULL)) {
#line 233 "../src/engine/imap/command/imap-command.vala"
							g_task_return_error (_data_->_async_result, _data_->_inner_error1_);
#line 233 "../src/engine/imap/command/imap-command.vala"
							_g_object_unref0 (_data_->data);
#line 233 "../src/engine/imap/command/imap-command.vala"
							_data_->buf = (g_free (_data_->buf), NULL);
#line 233 "../src/engine/imap/command/imap-command.vala"
							_g_object_unref0 (_data_->literal);
#line 233 "../src/engine/imap/command/imap-command.vala"
							_g_object_unref0 (_data_->arg);
#line 233 "../src/engine/imap/command/imap-command.vala"
							_g_object_unref0 (_data_->_arg_list);
#line 233 "../src/engine/imap/command/imap-command.vala"
							g_object_unref (_data_->_async_result);
#line 233 "../src/engine/imap/command/imap-command.vala"
							return FALSE;
#line 1274 "imap-command.c"
						}
					}
#line 218 "../src/engine/imap/command/imap-command.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 218 "../src/engine/imap/command/imap-command.vala"
						g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 218 "../src/engine/imap/command/imap-command.vala"
						_g_object_unref0 (_data_->data);
#line 218 "../src/engine/imap/command/imap-command.vala"
						_data_->buf = (g_free (_data_->buf), NULL);
#line 218 "../src/engine/imap/command/imap-command.vala"
						_g_object_unref0 (_data_->literal);
#line 218 "../src/engine/imap/command/imap-command.vala"
						_g_object_unref0 (_data_->arg);
#line 218 "../src/engine/imap/command/imap-command.vala"
						_g_object_unref0 (_data_->_arg_list);
#line 218 "../src/engine/imap/command/imap-command.vala"
						g_object_unref (_data_->_async_result);
#line 218 "../src/engine/imap/command/imap-command.vala"
						return FALSE;
#line 1295 "imap-command.c"
					}
#line 182 "../src/engine/imap/command/imap-command.vala"
					_g_object_unref0 (_data_->data);
#line 182 "../src/engine/imap/command/imap-command.vala"
					_data_->buf = (g_free (_data_->buf), NULL);
#line 1301 "imap-command.c"
				}
#line 177 "../src/engine/imap/command/imap-command.vala"
				_g_object_unref0 (_data_->literal);
#line 177 "../src/engine/imap/command/imap-command.vala"
				_g_object_unref0 (_data_->arg);
#line 1307 "imap-command.c"
			}
#line 177 "../src/engine/imap/command/imap-command.vala"
			_g_object_unref0 (_data_->_arg_list);
#line 1311 "imap-command.c"
		}
	}
#line 243 "../src/engine/imap/command/imap-command.vala"
	geary_imap_serializer_push_eol (_data_->ser, _data_->cancellable, &_data_->_inner_error0_);
#line 243 "../src/engine/imap/command/imap-command.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 243 "../src/engine/imap/command/imap-command.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 243 "../src/engine/imap/command/imap-command.vala"
		g_object_unref (_data_->_async_result);
#line 243 "../src/engine/imap/command/imap-command.vala"
		return FALSE;
#line 1324 "imap-command.c"
	}
#line 168 "../src/engine/imap/command/imap-command.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 168 "../src/engine/imap/command/imap-command.vala"
	if (_data_->_state_ != 0) {
#line 168 "../src/engine/imap/command/imap-command.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 168 "../src/engine/imap/command/imap-command.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1334 "imap-command.c"
		}
	}
#line 168 "../src/engine/imap/command/imap-command.vala"
	g_object_unref (_data_->_async_result);
#line 168 "../src/engine/imap/command/imap-command.vala"
	return FALSE;
#line 1341 "imap-command.c"
}

void
geary_imap_command_send (GearyImapCommand* self,
                         GearyImapSerializer* ser,
                         GCancellable* cancellable,
                         GAsyncReadyCallback _callback_,
                         gpointer _user_data_)
{
	GearyImapCommandClass* _klass_;
#line 20 "../src/engine/imap/command/imap-command.vala"
	_klass_ = GEARY_IMAP_COMMAND_GET_CLASS (self);
#line 20 "../src/engine/imap/command/imap-command.vala"
	if (_klass_->send) {
#line 20 "../src/engine/imap/command/imap-command.vala"
		_klass_->send (self, ser, cancellable, _callback_, _user_data_);
#line 1358 "imap-command.c"
	}
}

void
geary_imap_command_send_finish (GearyImapCommand* self,
                                GAsyncResult* _res_,
                                GError** error)
{
	GearyImapCommandClass* _klass_;
#line 20 "../src/engine/imap/command/imap-command.vala"
	_klass_ = GEARY_IMAP_COMMAND_GET_CLASS (self);
#line 20 "../src/engine/imap/command/imap-command.vala"
	if (_klass_->send_finish) {
#line 20 "../src/engine/imap/command/imap-command.vala"
		_klass_->send_finish (self, _res_, error);
#line 1374 "imap-command.c"
	}
}

static void
geary_imap_command_real_send_wait_data_free (gpointer _data)
{
	GearyImapCommandSendWaitData* _data_;
	_data_ = _data;
#line 20 "../src/engine/imap/command/imap-command.vala"
	_g_object_unref0 (_data_->ser);
#line 20 "../src/engine/imap/command/imap-command.vala"
	_g_object_unref0 (_data_->cancellable);
#line 20 "../src/engine/imap/command/imap-command.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/engine/imap/command/imap-command.vala"
	g_slice_free (GearyImapCommandSendWaitData, _data_);
#line 1391 "imap-command.c"
}

static void
geary_imap_command_real_send_wait (GearyImapCommand* self,
                                   GearyImapSerializer* ser,
                                   GCancellable* cancellable,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	GearyImapCommandSendWaitData* _data_;
	GearyImapCommand* _tmp0_;
	GearyImapSerializer* _tmp1_;
	GCancellable* _tmp2_;
#line 20 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_SERIALIZER (ser));
#line 20 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 20 "../src/engine/imap/command/imap-command.vala"
	_data_ = g_slice_new0 (GearyImapCommandSendWaitData);
#line 20 "../src/engine/imap/command/imap-command.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 20 "../src/engine/imap/command/imap-command.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_command_real_send_wait_data_free);
#line 20 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/engine/imap/command/imap-command.vala"
	_data_->self = _tmp0_;
#line 20 "../src/engine/imap/command/imap-command.vala"
	_tmp1_ = _g_object_ref0 (ser);
#line 20 "../src/engine/imap/command/imap-command.vala"
	_g_object_unref0 (_data_->ser);
#line 20 "../src/engine/imap/command/imap-command.vala"
	_data_->ser = _tmp1_;
#line 20 "../src/engine/imap/command/imap-command.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 20 "../src/engine/imap/command/imap-command.vala"
	_g_object_unref0 (_data_->cancellable);
#line 20 "../src/engine/imap/command/imap-command.vala"
	_data_->cancellable = _tmp2_;
#line 20 "../src/engine/imap/command/imap-command.vala"
	geary_imap_command_real_send_wait_co (_data_);
#line 1433 "imap-command.c"
}

static void
geary_imap_command_real_send_wait_finish (GearyImapCommand* self,
                                          GAsyncResult* _res_,
                                          GError** error)
{
	GearyImapCommandSendWaitData* _data_;
#line 20 "../src/engine/imap/command/imap-command.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 20 "../src/engine/imap/command/imap-command.vala"
	if (NULL == _data_) {
#line 20 "../src/engine/imap/command/imap-command.vala"
		return;
#line 1448 "imap-command.c"
	}
}

/**
     * Check for command-specific server responses after sending.
     *
     * This method is called after {@link send} and after {@link
     * ClientSession} has signalled the command has been sent, but
     * before the next command is processed. It allows command
     * implementations (e.g. {@link IdleCommand}) to asynchronously
     * wait for some kind of response from the server before allowing
     * additional commands to be sent.
     *
     * Most commands will not need to override this, and it by default
     * does nothing.
     */
static gboolean
geary_imap_command_real_send_wait_co (GearyImapCommandSendWaitData* _data_)
{
#line 259 "../src/engine/imap/command/imap-command.vala"
	switch (_data_->_state_) {
#line 259 "../src/engine/imap/command/imap-command.vala"
		case 0:
#line 1472 "imap-command.c"
		goto _state_0;
		default:
#line 259 "../src/engine/imap/command/imap-command.vala"
		g_assert_not_reached ();
#line 1477 "imap-command.c"
	}
	_state_0:
#line 259 "../src/engine/imap/command/imap-command.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 259 "../src/engine/imap/command/imap-command.vala"
	if (_data_->_state_ != 0) {
#line 259 "../src/engine/imap/command/imap-command.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 259 "../src/engine/imap/command/imap-command.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1488 "imap-command.c"
		}
	}
#line 259 "../src/engine/imap/command/imap-command.vala"
	g_object_unref (_data_->_async_result);
#line 259 "../src/engine/imap/command/imap-command.vala"
	return FALSE;
#line 1495 "imap-command.c"
}

void
geary_imap_command_send_wait (GearyImapCommand* self,
                              GearyImapSerializer* ser,
                              GCancellable* cancellable,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	GearyImapCommandClass* _klass_;
#line 20 "../src/engine/imap/command/imap-command.vala"
	_klass_ = GEARY_IMAP_COMMAND_GET_CLASS (self);
#line 20 "../src/engine/imap/command/imap-command.vala"
	if (_klass_->send_wait) {
#line 20 "../src/engine/imap/command/imap-command.vala"
		_klass_->send_wait (self, ser, cancellable, _callback_, _user_data_);
#line 1512 "imap-command.c"
	}
}

void
geary_imap_command_send_wait_finish (GearyImapCommand* self,
                                     GAsyncResult* _res_,
                                     GError** error)
{
	GearyImapCommandClass* _klass_;
#line 20 "../src/engine/imap/command/imap-command.vala"
	_klass_ = GEARY_IMAP_COMMAND_GET_CLASS (self);
#line 20 "../src/engine/imap/command/imap-command.vala"
	if (_klass_->send_wait_finish) {
#line 20 "../src/engine/imap/command/imap-command.vala"
		_klass_->send_wait_finish (self, _res_, error);
#line 1528 "imap-command.c"
	}
}

static void
geary_imap_command_wait_until_complete_data_free (gpointer _data)
{
	GearyImapCommandWaitUntilCompleteData* _data_;
	_data_ = _data;
#line 20 "../src/engine/imap/command/imap-command.vala"
	_g_object_unref0 (_data_->cancellable);
#line 20 "../src/engine/imap/command/imap-command.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/engine/imap/command/imap-command.vala"
	g_slice_free (GearyImapCommandWaitUntilCompleteData, _data_);
#line 1543 "imap-command.c"
}

void
geary_imap_command_wait_until_complete (GearyImapCommand* self,
                                        GCancellable* cancellable,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	GearyImapCommandWaitUntilCompleteData* _data_;
	GearyImapCommand* _tmp0_;
	GCancellable* _tmp1_;
#line 20 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (self));
#line 20 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 20 "../src/engine/imap/command/imap-command.vala"
	_data_ = g_slice_new0 (GearyImapCommandWaitUntilCompleteData);
#line 20 "../src/engine/imap/command/imap-command.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 20 "../src/engine/imap/command/imap-command.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_command_wait_until_complete_data_free);
#line 20 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/engine/imap/command/imap-command.vala"
	_data_->self = _tmp0_;
#line 20 "../src/engine/imap/command/imap-command.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 20 "../src/engine/imap/command/imap-command.vala"
	_g_object_unref0 (_data_->cancellable);
#line 20 "../src/engine/imap/command/imap-command.vala"
	_data_->cancellable = _tmp1_;
#line 20 "../src/engine/imap/command/imap-command.vala"
	geary_imap_command_wait_until_complete_co (_data_);
#line 1577 "imap-command.c"
}

void
geary_imap_command_wait_until_complete_finish (GearyImapCommand* self,
                                               GAsyncResult* _res_,
                                               GError** error)
{
	GearyImapCommandWaitUntilCompleteData* _data_;
#line 20 "../src/engine/imap/command/imap-command.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 20 "../src/engine/imap/command/imap-command.vala"
	if (NULL == _data_) {
#line 20 "../src/engine/imap/command/imap-command.vala"
		return;
#line 1592 "imap-command.c"
	}
}

/**
     * Yields until the command has been completed or cancelled.
     *
     * Throws an error if the command or the cancellable argument is
     * cancelled, if the command timed out, or if the command's
     * response was bad.
     */
static void
geary_imap_command_wait_until_complete_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_)
{
	GearyImapCommandWaitUntilCompleteData* _data_;
#line 274 "../src/engine/imap/command/imap-command.vala"
	_data_ = _user_data_;
#line 274 "../src/engine/imap/command/imap-command.vala"
	_data_->_source_object_ = source_object;
#line 274 "../src/engine/imap/command/imap-command.vala"
	_data_->_res_ = _res_;
#line 274 "../src/engine/imap/command/imap-command.vala"
	geary_imap_command_wait_until_complete_co (_data_);
#line 1617 "imap-command.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 277 "../src/engine/imap/command/imap-command.vala"
	return self ? g_error_copy (self) : NULL;
#line 1625 "imap-command.c"
}

static gboolean
geary_imap_command_wait_until_complete_co (GearyImapCommandWaitUntilCompleteData* _data_)
{
#line 272 "../src/engine/imap/command/imap-command.vala"
	switch (_data_->_state_) {
#line 272 "../src/engine/imap/command/imap-command.vala"
		case 0:
#line 1635 "imap-command.c"
		goto _state_0;
#line 272 "../src/engine/imap/command/imap-command.vala"
		case 1:
#line 1639 "imap-command.c"
		goto _state_1;
		default:
#line 272 "../src/engine/imap/command/imap-command.vala"
		g_assert_not_reached ();
#line 1644 "imap-command.c"
	}
	_state_0:
#line 274 "../src/engine/imap/command/imap-command.vala"
	_data_->_tmp0_ = _data_->self->priv->complete_lock;
#line 274 "../src/engine/imap/command/imap-command.vala"
	_data_->_state_ = 1;
#line 274 "../src/engine/imap/command/imap-command.vala"
	geary_nonblocking_lock_wait_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock), _data_->cancellable, geary_imap_command_wait_until_complete_ready, _data_);
#line 274 "../src/engine/imap/command/imap-command.vala"
	return FALSE;
#line 1655 "imap-command.c"
	_state_1:
#line 274 "../src/engine/imap/command/imap-command.vala"
	geary_nonblocking_lock_wait_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock), _data_->_res_, &_data_->_inner_error0_);
#line 274 "../src/engine/imap/command/imap-command.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 274 "../src/engine/imap/command/imap-command.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 274 "../src/engine/imap/command/imap-command.vala"
		g_object_unref (_data_->_async_result);
#line 274 "../src/engine/imap/command/imap-command.vala"
		return FALSE;
#line 1667 "imap-command.c"
	}
#line 276 "../src/engine/imap/command/imap-command.vala"
	_data_->_tmp1_ = _data_->self->priv->cancelled_cause;
#line 276 "../src/engine/imap/command/imap-command.vala"
	if (_data_->_tmp1_ != NULL) {
#line 277 "../src/engine/imap/command/imap-command.vala"
		_data_->_tmp2_ = _data_->self->priv->cancelled_cause;
#line 277 "../src/engine/imap/command/imap-command.vala"
		_data_->_tmp3_ = _g_error_copy0 (_data_->_tmp2_);
#line 277 "../src/engine/imap/command/imap-command.vala"
		_data_->_inner_error0_ = _data_->_tmp3_;
#line 277 "../src/engine/imap/command/imap-command.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 277 "../src/engine/imap/command/imap-command.vala"
		g_object_unref (_data_->_async_result);
#line 277 "../src/engine/imap/command/imap-command.vala"
		return FALSE;
#line 1685 "imap-command.c"
	}
#line 283 "../src/engine/imap/command/imap-command.vala"
	_data_->_tmp5_ = _data_->self->priv->_should_send;
#line 283 "../src/engine/imap/command/imap-command.vala"
	if (_data_->_tmp5_ != NULL) {
#line 284 "../src/engine/imap/command/imap-command.vala"
		_data_->_tmp6_ = _data_->self->priv->_should_send;
#line 284 "../src/engine/imap/command/imap-command.vala"
		_data_->_tmp4_ = g_cancellable_is_cancelled (_data_->_tmp6_);
#line 1695 "imap-command.c"
	} else {
#line 283 "../src/engine/imap/command/imap-command.vala"
		_data_->_tmp4_ = FALSE;
#line 1699 "imap-command.c"
	}
#line 283 "../src/engine/imap/command/imap-command.vala"
	if (_data_->_tmp4_) {
#line 285 "../src/engine/imap/command/imap-command.vala"
		_data_->_tmp7_ = geary_imap_command_to_brief_string (_data_->self);
#line 285 "../src/engine/imap/command/imap-command.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 285 "../src/engine/imap/command/imap-command.vala"
		_data_->_tmp9_ = g_error_new (G_IO_ERROR, G_IO_ERROR_CANCELLED, "Command was cancelled after sending: %s", _data_->_tmp8_);
#line 285 "../src/engine/imap/command/imap-command.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 285 "../src/engine/imap/command/imap-command.vala"
		_g_free0 (_data_->_tmp8_);
#line 285 "../src/engine/imap/command/imap-command.vala"
		_data_->_inner_error0_ = _data_->_tmp10_;
#line 285 "../src/engine/imap/command/imap-command.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 285 "../src/engine/imap/command/imap-command.vala"
		g_object_unref (_data_->_async_result);
#line 285 "../src/engine/imap/command/imap-command.vala"
		return FALSE;
#line 1721 "imap-command.c"
	}
#line 290 "../src/engine/imap/command/imap-command.vala"
	geary_imap_command_check_has_status (_data_->self, &_data_->_inner_error0_);
#line 290 "../src/engine/imap/command/imap-command.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 290 "../src/engine/imap/command/imap-command.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 290 "../src/engine/imap/command/imap-command.vala"
		g_object_unref (_data_->_async_result);
#line 290 "../src/engine/imap/command/imap-command.vala"
		return FALSE;
#line 1733 "imap-command.c"
	}
#line 294 "../src/engine/imap/command/imap-command.vala"
	_data_->_tmp11_ = _data_->self->priv->_status;
#line 294 "../src/engine/imap/command/imap-command.vala"
	_data_->_tmp12_ = geary_imap_status_response_get_status (_data_->_tmp11_);
#line 294 "../src/engine/imap/command/imap-command.vala"
	_data_->_tmp13_ = _data_->_tmp12_;
#line 294 "../src/engine/imap/command/imap-command.vala"
	if (_data_->_tmp13_ == GEARY_IMAP_STATUS_BAD) {
#line 295 "../src/engine/imap/command/imap-command.vala"
		_data_->_tmp14_ = geary_imap_command_to_brief_string (_data_->self);
#line 295 "../src/engine/imap/command/imap-command.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 295 "../src/engine/imap/command/imap-command.vala"
		_data_->_tmp16_ = _data_->self->priv->_status;
#line 295 "../src/engine/imap/command/imap-command.vala"
		_data_->_tmp17_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp16_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 295 "../src/engine/imap/command/imap-command.vala"
		_data_->_tmp18_ = _data_->_tmp17_;
#line 295 "../src/engine/imap/command/imap-command.vala"
		_data_->_tmp19_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_SERVER_ERROR, "%s: Command failed: %s", _data_->_tmp15_, _data_->_tmp18_);
#line 295 "../src/engine/imap/command/imap-command.vala"
		_data_->_tmp20_ = _data_->_tmp19_;
#line 295 "../src/engine/imap/command/imap-command.vala"
		_g_free0 (_data_->_tmp18_);
#line 295 "../src/engine/imap/command/imap-command.vala"
		_g_free0 (_data_->_tmp15_);
#line 295 "../src/engine/imap/command/imap-command.vala"
		_data_->_inner_error0_ = _data_->_tmp20_;
#line 295 "../src/engine/imap/command/imap-command.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 295 "../src/engine/imap/command/imap-command.vala"
		g_object_unref (_data_->_async_result);
#line 295 "../src/engine/imap/command/imap-command.vala"
		return FALSE;
#line 1769 "imap-command.c"
	}
#line 272 "../src/engine/imap/command/imap-command.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 272 "../src/engine/imap/command/imap-command.vala"
	if (_data_->_state_ != 0) {
#line 272 "../src/engine/imap/command/imap-command.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 272 "../src/engine/imap/command/imap-command.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1779 "imap-command.c"
		}
	}
#line 272 "../src/engine/imap/command/imap-command.vala"
	g_object_unref (_data_->_async_result);
#line 272 "../src/engine/imap/command/imap-command.vala"
	return FALSE;
#line 1786 "imap-command.c"
}

static gchar*
geary_imap_command_real_to_string (GearyImapCommand* self)
{
	gchar* args = NULL;
	GearyImapListParameter* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	gchar* result;
#line 304 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = self->priv->_args;
#line 304 "../src/engine/imap/command/imap-command.vala"
	_tmp1_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 304 "../src/engine/imap/command/imap-command.vala"
	args = _tmp1_;
#line 305 "../src/engine/imap/command/imap-command.vala"
	_tmp3_ = args;
#line 305 "../src/engine/imap/command/imap-command.vala"
	if (geary_string_is_empty (_tmp3_)) {
#line 1808 "imap-command.c"
		GearyImapTag* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 306 "../src/engine/imap/command/imap-command.vala"
		_tmp4_ = self->priv->_tag;
#line 306 "../src/engine/imap/command/imap-command.vala"
		_tmp5_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 306 "../src/engine/imap/command/imap-command.vala"
		_tmp6_ = _tmp5_;
#line 306 "../src/engine/imap/command/imap-command.vala"
		_tmp7_ = self->priv->_name;
#line 306 "../src/engine/imap/command/imap-command.vala"
		_tmp8_ = g_strdup_printf ("%s %s", _tmp6_, _tmp7_);
#line 306 "../src/engine/imap/command/imap-command.vala"
		_g_free0 (_tmp2_);
#line 306 "../src/engine/imap/command/imap-command.vala"
		_tmp2_ = _tmp8_;
#line 306 "../src/engine/imap/command/imap-command.vala"
		_g_free0 (_tmp6_);
#line 1830 "imap-command.c"
	} else {
		GearyImapTag* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
#line 307 "../src/engine/imap/command/imap-command.vala"
		_tmp9_ = self->priv->_tag;
#line 307 "../src/engine/imap/command/imap-command.vala"
		_tmp10_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 307 "../src/engine/imap/command/imap-command.vala"
		_tmp11_ = _tmp10_;
#line 307 "../src/engine/imap/command/imap-command.vala"
		_tmp12_ = self->priv->_name;
#line 307 "../src/engine/imap/command/imap-command.vala"
		_tmp13_ = args;
#line 307 "../src/engine/imap/command/imap-command.vala"
		_tmp14_ = g_strdup_printf ("%s %s %s", _tmp11_, _tmp12_, _tmp13_);
#line 307 "../src/engine/imap/command/imap-command.vala"
		_g_free0 (_tmp2_);
#line 307 "../src/engine/imap/command/imap-command.vala"
		_tmp2_ = _tmp14_;
#line 307 "../src/engine/imap/command/imap-command.vala"
		_g_free0 (_tmp11_);
#line 1856 "imap-command.c"
	}
#line 305 "../src/engine/imap/command/imap-command.vala"
	result = _tmp2_;
#line 305 "../src/engine/imap/command/imap-command.vala"
	_g_free0 (args);
#line 305 "../src/engine/imap/command/imap-command.vala"
	return result;
#line 1864 "imap-command.c"
}

gchar*
geary_imap_command_to_string (GearyImapCommand* self)
{
	GearyImapCommandClass* _klass_;
#line 303 "../src/engine/imap/command/imap-command.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_COMMAND (self), NULL);
#line 303 "../src/engine/imap/command/imap-command.vala"
	_klass_ = GEARY_IMAP_COMMAND_GET_CLASS (self);
#line 303 "../src/engine/imap/command/imap-command.vala"
	if (_klass_->to_string) {
#line 303 "../src/engine/imap/command/imap-command.vala"
		return _klass_->to_string (self);
#line 1879 "imap-command.c"
	}
#line 303 "../src/engine/imap/command/imap-command.vala"
	return NULL;
#line 1883 "imap-command.c"
}

/**
     * Updates the commands response timer, if running.
     *
     * This will reset the command's response timer, preventing the
     * command from timing out for another {@link response_timeout}
     * seconds.
     */
static void
geary_imap_command_real_update_response_timer (GearyImapCommand* self)
{
	GearyTimeoutManager* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 318 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = self->priv->_response_timer;
#line 318 "../src/engine/imap/command/imap-command.vala"
	_tmp1_ = geary_timeout_manager_get_is_running (_tmp0_);
#line 318 "../src/engine/imap/command/imap-command.vala"
	_tmp2_ = _tmp1_;
#line 318 "../src/engine/imap/command/imap-command.vala"
	if (_tmp2_) {
#line 1907 "imap-command.c"
		GearyTimeoutManager* _tmp3_;
#line 319 "../src/engine/imap/command/imap-command.vala"
		_tmp3_ = self->priv->_response_timer;
#line 319 "../src/engine/imap/command/imap-command.vala"
		geary_timeout_manager_start (_tmp3_);
#line 1913 "imap-command.c"
	}
}

void
geary_imap_command_update_response_timer (GearyImapCommand* self)
{
	GearyImapCommandClass* _klass_;
#line 317 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (self));
#line 317 "../src/engine/imap/command/imap-command.vala"
	_klass_ = GEARY_IMAP_COMMAND_GET_CLASS (self);
#line 317 "../src/engine/imap/command/imap-command.vala"
	if (_klass_->update_response_timer) {
#line 317 "../src/engine/imap/command/imap-command.vala"
		_klass_->update_response_timer (self);
#line 1929 "imap-command.c"
	}
}

/**
     * Called when a tagged status response is received for this command.
     *
     * This will update the command's {@link status} property, then
     * throw an error if it does not indicate a successful completion.
     */
static void
geary_imap_command_real_completed (GearyImapCommand* self,
                                   GearyImapStatusResponse* new_status,
                                   GError** error)
{
	GearyImapStatusResponse* _tmp0_;
	GearyTimeoutManager* _tmp8_;
	GearyNonblockingSemaphore* _tmp9_;
	GError* _inner_error0_ = NULL;
#line 329 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_STATUS_RESPONSE (new_status));
#line 331 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = self->priv->_status;
#line 331 "../src/engine/imap/command/imap-command.vala"
	if (_tmp0_ != NULL) {
#line 1954 "imap-command.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
		GearyImapStatusResponse* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GError* _tmp6_;
		GError* _tmp7_;
#line 332 "../src/engine/imap/command/imap-command.vala"
		geary_imap_command_stop_serialisation (self);
#line 333 "../src/engine/imap/command/imap-command.vala"
		_tmp1_ = geary_imap_command_to_brief_string (self);
#line 333 "../src/engine/imap/command/imap-command.vala"
		_tmp2_ = _tmp1_;
#line 333 "../src/engine/imap/command/imap-command.vala"
		_tmp3_ = self->priv->_status;
#line 333 "../src/engine/imap/command/imap-command.vala"
		_tmp4_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 333 "../src/engine/imap/command/imap-command.vala"
		_tmp5_ = _tmp4_;
#line 333 "../src/engine/imap/command/imap-command.vala"
		_tmp6_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_SERVER_ERROR, "%s: Duplicate status response received: %s", _tmp2_, _tmp5_);
#line 333 "../src/engine/imap/command/imap-command.vala"
		_tmp7_ = _tmp6_;
#line 333 "../src/engine/imap/command/imap-command.vala"
		_g_free0 (_tmp5_);
#line 333 "../src/engine/imap/command/imap-command.vala"
		_g_free0 (_tmp2_);
#line 333 "../src/engine/imap/command/imap-command.vala"
		_inner_error0_ = _tmp7_;
#line 333 "../src/engine/imap/command/imap-command.vala"
		if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 333 "../src/engine/imap/command/imap-command.vala"
			g_propagate_error (error, _inner_error0_);
#line 333 "../src/engine/imap/command/imap-command.vala"
			return;
#line 1990 "imap-command.c"
		} else {
#line 333 "../src/engine/imap/command/imap-command.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 333 "../src/engine/imap/command/imap-command.vala"
			g_clear_error (&_inner_error0_);
#line 333 "../src/engine/imap/command/imap-command.vala"
			return;
#line 1998 "imap-command.c"
		}
	}
#line 340 "../src/engine/imap/command/imap-command.vala"
	geary_imap_command_set_status (self, new_status);
#line 341 "../src/engine/imap/command/imap-command.vala"
	_tmp8_ = self->priv->_response_timer;
#line 341 "../src/engine/imap/command/imap-command.vala"
	geary_timeout_manager_reset (_tmp8_);
#line 342 "../src/engine/imap/command/imap-command.vala"
	_tmp9_ = self->priv->complete_lock;
#line 342 "../src/engine/imap/command/imap-command.vala"
	geary_nonblocking_lock_blind_notify (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock));
#line 343 "../src/engine/imap/command/imap-command.vala"
	geary_imap_command_stop_serialisation (self);
#line 345 "../src/engine/imap/command/imap-command.vala"
	geary_imap_command_check_has_status (self, &_inner_error0_);
#line 345 "../src/engine/imap/command/imap-command.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 345 "../src/engine/imap/command/imap-command.vala"
		if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 345 "../src/engine/imap/command/imap-command.vala"
			g_propagate_error (error, _inner_error0_);
#line 345 "../src/engine/imap/command/imap-command.vala"
			return;
#line 2023 "imap-command.c"
		} else {
#line 345 "../src/engine/imap/command/imap-command.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 345 "../src/engine/imap/command/imap-command.vala"
			g_clear_error (&_inner_error0_);
#line 345 "../src/engine/imap/command/imap-command.vala"
			return;
#line 2031 "imap-command.c"
		}
	}
}

void
geary_imap_command_completed (GearyImapCommand* self,
                              GearyImapStatusResponse* new_status,
                              GError** error)
{
	GearyImapCommandClass* _klass_;
#line 329 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (self));
#line 329 "../src/engine/imap/command/imap-command.vala"
	_klass_ = GEARY_IMAP_COMMAND_GET_CLASS (self);
#line 329 "../src/engine/imap/command/imap-command.vala"
	if (_klass_->completed) {
#line 329 "../src/engine/imap/command/imap-command.vala"
		_klass_->completed (self, new_status, error);
#line 2050 "imap-command.c"
	}
}

/**
     * Marks this command as being cancelled before being sent.
     *
     * When this method is called, all locks will be released,
     * including {@link wait_until_complete}, which will then throw a
     * `GLib.IOError.CANCELLED` error.
     */
static void
geary_imap_command_real_cancelled_before_send (GearyImapCommand* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _tmp2_;
	GError* _tmp3_;
#line 356 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = geary_imap_command_to_brief_string (self);
#line 356 "../src/engine/imap/command/imap-command.vala"
	_tmp1_ = _tmp0_;
#line 356 "../src/engine/imap/command/imap-command.vala"
	_tmp2_ = g_error_new (G_IO_ERROR, G_IO_ERROR_CANCELLED, "Command was cancelled before sending: %s", _tmp1_);
#line 356 "../src/engine/imap/command/imap-command.vala"
	_tmp3_ = _tmp2_;
#line 356 "../src/engine/imap/command/imap-command.vala"
	geary_imap_command_cancel (self, _tmp3_);
#line 356 "../src/engine/imap/command/imap-command.vala"
	_g_error_free0 (_tmp3_);
#line 356 "../src/engine/imap/command/imap-command.vala"
	_g_free0 (_tmp1_);
#line 2082 "imap-command.c"
}

void
geary_imap_command_cancelled_before_send (GearyImapCommand* self)
{
	GearyImapCommandClass* _klass_;
#line 355 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (self));
#line 355 "../src/engine/imap/command/imap-command.vala"
	_klass_ = GEARY_IMAP_COMMAND_GET_CLASS (self);
#line 355 "../src/engine/imap/command/imap-command.vala"
	if (_klass_->cancelled_before_send) {
#line 355 "../src/engine/imap/command/imap-command.vala"
		_klass_->cancelled_before_send (self);
#line 2097 "imap-command.c"
	}
}

/**
     * Cancels this command due to a network or server disconnect.
     *
     * When this method is called, all locks will be released,
     * including {@link wait_until_complete}, which will then throw a
     * `ImapError.NOT_CONNECTED` error.
     */
static void
geary_imap_command_real_disconnected (GearyImapCommand* self,
                                      const gchar* reason)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _tmp2_;
	GError* _tmp3_;
#line 370 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (reason != NULL);
#line 371 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = geary_imap_command_to_brief_string (self);
#line 371 "../src/engine/imap/command/imap-command.vala"
	_tmp1_ = _tmp0_;
#line 371 "../src/engine/imap/command/imap-command.vala"
	_tmp2_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_NOT_CONNECTED, "%s: %s", _tmp1_, reason);
#line 371 "../src/engine/imap/command/imap-command.vala"
	_tmp3_ = _tmp2_;
#line 371 "../src/engine/imap/command/imap-command.vala"
	geary_imap_command_cancel (self, _tmp3_);
#line 371 "../src/engine/imap/command/imap-command.vala"
	_g_error_free0 (_tmp3_);
#line 371 "../src/engine/imap/command/imap-command.vala"
	_g_free0 (_tmp1_);
#line 2132 "imap-command.c"
}

void
geary_imap_command_disconnected (GearyImapCommand* self,
                                 const gchar* reason)
{
	GearyImapCommandClass* _klass_;
#line 370 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (self));
#line 370 "../src/engine/imap/command/imap-command.vala"
	_klass_ = GEARY_IMAP_COMMAND_GET_CLASS (self);
#line 370 "../src/engine/imap/command/imap-command.vala"
	if (_klass_->disconnected) {
#line 370 "../src/engine/imap/command/imap-command.vala"
		_klass_->disconnected (self, reason);
#line 2148 "imap-command.c"
	}
}

/**
     * Called when tagged server data is received for this command.
     */
static void
geary_imap_command_real_data_received (GearyImapCommand* self,
                                       GearyImapServerData* data,
                                       GError** error)
{
	GearyImapStatusResponse* _tmp0_;
	GearyTimeoutManager* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 377 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_SERVER_DATA (data));
#line 379 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = self->priv->_status;
#line 379 "../src/engine/imap/command/imap-command.vala"
	if (_tmp0_ != NULL) {
#line 2169 "imap-command.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GError* _tmp5_;
		GError* _tmp6_;
#line 380 "../src/engine/imap/command/imap-command.vala"
		geary_imap_command_stop_serialisation (self);
#line 381 "../src/engine/imap/command/imap-command.vala"
		_tmp1_ = geary_imap_command_to_brief_string (self);
#line 381 "../src/engine/imap/command/imap-command.vala"
		_tmp2_ = _tmp1_;
#line 381 "../src/engine/imap/command/imap-command.vala"
		_tmp3_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (data, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 381 "../src/engine/imap/command/imap-command.vala"
		_tmp4_ = _tmp3_;
#line 381 "../src/engine/imap/command/imap-command.vala"
		_tmp5_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_SERVER_ERROR, "%s: Server data received when command already complete: %s", _tmp2_, _tmp4_);
#line 381 "../src/engine/imap/command/imap-command.vala"
		_tmp6_ = _tmp5_;
#line 381 "../src/engine/imap/command/imap-command.vala"
		_g_free0 (_tmp4_);
#line 381 "../src/engine/imap/command/imap-command.vala"
		_g_free0 (_tmp2_);
#line 381 "../src/engine/imap/command/imap-command.vala"
		_inner_error0_ = _tmp6_;
#line 381 "../src/engine/imap/command/imap-command.vala"
		if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 381 "../src/engine/imap/command/imap-command.vala"
			g_propagate_error (error, _inner_error0_);
#line 381 "../src/engine/imap/command/imap-command.vala"
			return;
#line 2202 "imap-command.c"
		} else {
#line 381 "../src/engine/imap/command/imap-command.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 381 "../src/engine/imap/command/imap-command.vala"
			g_clear_error (&_inner_error0_);
#line 381 "../src/engine/imap/command/imap-command.vala"
			return;
#line 2210 "imap-command.c"
		}
	}
#line 388 "../src/engine/imap/command/imap-command.vala"
	_tmp7_ = self->priv->_response_timer;
#line 388 "../src/engine/imap/command/imap-command.vala"
	geary_timeout_manager_start (_tmp7_);
#line 2217 "imap-command.c"
}

void
geary_imap_command_data_received (GearyImapCommand* self,
                                  GearyImapServerData* data,
                                  GError** error)
{
	GearyImapCommandClass* _klass_;
#line 377 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (self));
#line 377 "../src/engine/imap/command/imap-command.vala"
	_klass_ = GEARY_IMAP_COMMAND_GET_CLASS (self);
#line 377 "../src/engine/imap/command/imap-command.vala"
	if (_klass_->data_received) {
#line 377 "../src/engine/imap/command/imap-command.vala"
		_klass_->data_received (self, data, error);
#line 2234 "imap-command.c"
	}
}

/**
     * Called when a continuation was requested by the server.
     *
     * This will notify the command's literal spinlock so that if
     * {@link send} is waiting to send a literal, it will do so
     * now.
     */
static void
geary_imap_command_real_continuation_requested (GearyImapCommand* self,
                                                GearyImapContinuationResponse* continuation,
                                                GError** error)
{
	GearyImapStatusResponse* _tmp0_;
	GearyNonblockingSpinlock* _tmp5_;
	GearyTimeoutManager* _tmp10_;
	GearyNonblockingSpinlock* _tmp11_;
	GError* _inner_error0_ = NULL;
#line 398 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_CONTINUATION_RESPONSE (continuation));
#line 401 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = self->priv->_status;
#line 401 "../src/engine/imap/command/imap-command.vala"
	if (_tmp0_ != NULL) {
#line 2261 "imap-command.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
		GError* _tmp3_;
		GError* _tmp4_;
#line 402 "../src/engine/imap/command/imap-command.vala"
		geary_imap_command_stop_serialisation (self);
#line 403 "../src/engine/imap/command/imap-command.vala"
		_tmp1_ = geary_imap_command_to_brief_string (self);
#line 403 "../src/engine/imap/command/imap-command.vala"
		_tmp2_ = _tmp1_;
#line 403 "../src/engine/imap/command/imap-command.vala"
		_tmp3_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_SERVER_ERROR, "%s: Continuation requested when command already complete", _tmp2_);
#line 403 "../src/engine/imap/command/imap-command.vala"
		_tmp4_ = _tmp3_;
#line 403 "../src/engine/imap/command/imap-command.vala"
		_g_free0 (_tmp2_);
#line 403 "../src/engine/imap/command/imap-command.vala"
		_inner_error0_ = _tmp4_;
#line 403 "../src/engine/imap/command/imap-command.vala"
		if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 403 "../src/engine/imap/command/imap-command.vala"
			g_propagate_error (error, _inner_error0_);
#line 403 "../src/engine/imap/command/imap-command.vala"
			return;
#line 2286 "imap-command.c"
		} else {
#line 403 "../src/engine/imap/command/imap-command.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 403 "../src/engine/imap/command/imap-command.vala"
			g_clear_error (&_inner_error0_);
#line 403 "../src/engine/imap/command/imap-command.vala"
			return;
#line 2294 "imap-command.c"
		}
	}
#line 409 "../src/engine/imap/command/imap-command.vala"
	_tmp5_ = self->priv->literal_spinlock;
#line 409 "../src/engine/imap/command/imap-command.vala"
	if (_tmp5_ == NULL) {
#line 2301 "imap-command.c"
		gchar* _tmp6_;
		gchar* _tmp7_;
		GError* _tmp8_;
		GError* _tmp9_;
#line 410 "../src/engine/imap/command/imap-command.vala"
		geary_imap_command_stop_serialisation (self);
#line 411 "../src/engine/imap/command/imap-command.vala"
		_tmp6_ = geary_imap_command_to_brief_string (self);
#line 411 "../src/engine/imap/command/imap-command.vala"
		_tmp7_ = _tmp6_;
#line 411 "../src/engine/imap/command/imap-command.vala"
		_tmp8_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_SERVER_ERROR, "%s: Continuation requested but no literals available", _tmp7_);
#line 411 "../src/engine/imap/command/imap-command.vala"
		_tmp9_ = _tmp8_;
#line 411 "../src/engine/imap/command/imap-command.vala"
		_g_free0 (_tmp7_);
#line 411 "../src/engine/imap/command/imap-command.vala"
		_inner_error0_ = _tmp9_;
#line 411 "../src/engine/imap/command/imap-command.vala"
		if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 411 "../src/engine/imap/command/imap-command.vala"
			g_propagate_error (error, _inner_error0_);
#line 411 "../src/engine/imap/command/imap-command.vala"
			return;
#line 2326 "imap-command.c"
		} else {
#line 411 "../src/engine/imap/command/imap-command.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 411 "../src/engine/imap/command/imap-command.vala"
			g_clear_error (&_inner_error0_);
#line 411 "../src/engine/imap/command/imap-command.vala"
			return;
#line 2334 "imap-command.c"
		}
	}
#line 417 "../src/engine/imap/command/imap-command.vala"
	_tmp10_ = self->priv->_response_timer;
#line 417 "../src/engine/imap/command/imap-command.vala"
	geary_timeout_manager_start (_tmp10_);
#line 418 "../src/engine/imap/command/imap-command.vala"
	_tmp11_ = self->priv->literal_spinlock;
#line 418 "../src/engine/imap/command/imap-command.vala"
	geary_nonblocking_lock_blind_notify (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock));
#line 2345 "imap-command.c"
}

void
geary_imap_command_continuation_requested (GearyImapCommand* self,
                                           GearyImapContinuationResponse* continuation,
                                           GError** error)
{
	GearyImapCommandClass* _klass_;
#line 398 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (self));
#line 398 "../src/engine/imap/command/imap-command.vala"
	_klass_ = GEARY_IMAP_COMMAND_GET_CLASS (self);
#line 398 "../src/engine/imap/command/imap-command.vala"
	if (_klass_->continuation_requested) {
#line 398 "../src/engine/imap/command/imap-command.vala"
		_klass_->continuation_requested (self, continuation, error);
#line 2362 "imap-command.c"
	}
}

/** Returns the command tag and name for debugging. */
gchar*
geary_imap_command_to_brief_string (GearyImapCommand* self)
{
	GearyImapTag* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result;
#line 422 "../src/engine/imap/command/imap-command.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_COMMAND (self), NULL);
#line 423 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = self->priv->_tag;
#line 423 "../src/engine/imap/command/imap-command.vala"
	_tmp1_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 423 "../src/engine/imap/command/imap-command.vala"
	_tmp2_ = _tmp1_;
#line 423 "../src/engine/imap/command/imap-command.vala"
	_tmp3_ = self->priv->_name;
#line 423 "../src/engine/imap/command/imap-command.vala"
	_tmp4_ = g_strdup_printf ("%s %s", _tmp2_, _tmp3_);
#line 423 "../src/engine/imap/command/imap-command.vala"
	_tmp5_ = _tmp4_;
#line 423 "../src/engine/imap/command/imap-command.vala"
	_g_free0 (_tmp2_);
#line 423 "../src/engine/imap/command/imap-command.vala"
	result = _tmp5_;
#line 423 "../src/engine/imap/command/imap-command.vala"
	return result;
#line 2397 "imap-command.c"
}

/**
     * Stops any existing serialisation in progress.
     *
     * When this method is called, any non I/O related process
     * blocking the blocking {@link send} must be cancelled.
     */
static void
geary_imap_command_real_stop_serialisation (GearyImapCommand* self)
{
	GCancellable* _tmp0_;
#line 433 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = self->priv->literal_cancellable;
#line 433 "../src/engine/imap/command/imap-command.vala"
	if (_tmp0_ != NULL) {
#line 2414 "imap-command.c"
		GCancellable* _tmp1_;
#line 434 "../src/engine/imap/command/imap-command.vala"
		_tmp1_ = self->priv->literal_cancellable;
#line 434 "../src/engine/imap/command/imap-command.vala"
		g_cancellable_cancel (_tmp1_);
#line 2420 "imap-command.c"
	}
}

void
geary_imap_command_stop_serialisation (GearyImapCommand* self)
{
	GearyImapCommandClass* _klass_;
#line 432 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (self));
#line 432 "../src/engine/imap/command/imap-command.vala"
	_klass_ = GEARY_IMAP_COMMAND_GET_CLASS (self);
#line 432 "../src/engine/imap/command/imap-command.vala"
	if (_klass_->stop_serialisation) {
#line 432 "../src/engine/imap/command/imap-command.vala"
		_klass_->stop_serialisation (self);
#line 2436 "imap-command.c"
	}
}

static void
geary_imap_command_cancel (GearyImapCommand* self,
                           GError* cause)
{
	GError* _tmp0_;
	GearyTimeoutManager* _tmp1_;
	GearyNonblockingSemaphore* _tmp2_;
#line 438 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (self));
#line 438 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (cause != NULL);
#line 439 "../src/engine/imap/command/imap-command.vala"
	geary_imap_command_stop_serialisation (self);
#line 440 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = _g_error_copy0 (cause);
#line 440 "../src/engine/imap/command/imap-command.vala"
	_g_error_free0 (self->priv->cancelled_cause);
#line 440 "../src/engine/imap/command/imap-command.vala"
	self->priv->cancelled_cause = _tmp0_;
#line 441 "../src/engine/imap/command/imap-command.vala"
	_tmp1_ = self->priv->_response_timer;
#line 441 "../src/engine/imap/command/imap-command.vala"
	geary_timeout_manager_reset (_tmp1_);
#line 442 "../src/engine/imap/command/imap-command.vala"
	_tmp2_ = self->priv->complete_lock;
#line 442 "../src/engine/imap/command/imap-command.vala"
	geary_nonblocking_lock_blind_notify (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock));
#line 2467 "imap-command.c"
}

static void
geary_imap_command_check_has_status (GearyImapCommand* self,
                                     GError** error)
{
	GearyImapStatusResponse* _tmp0_;
	GearyImapStatusResponse* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	GError* _inner_error0_ = NULL;
#line 445 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (self));
#line 446 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = self->priv->_status;
#line 446 "../src/engine/imap/command/imap-command.vala"
	if (_tmp0_ == NULL) {
#line 2485 "imap-command.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
		GError* _tmp3_;
		GError* _tmp4_;
#line 447 "../src/engine/imap/command/imap-command.vala"
		_tmp1_ = geary_imap_command_to_brief_string (self);
#line 447 "../src/engine/imap/command/imap-command.vala"
		_tmp2_ = _tmp1_;
#line 447 "../src/engine/imap/command/imap-command.vala"
		_tmp3_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_SERVER_ERROR, "%s: No command response was received", _tmp2_);
#line 447 "../src/engine/imap/command/imap-command.vala"
		_tmp4_ = _tmp3_;
#line 447 "../src/engine/imap/command/imap-command.vala"
		_g_free0 (_tmp2_);
#line 447 "../src/engine/imap/command/imap-command.vala"
		_inner_error0_ = _tmp4_;
#line 447 "../src/engine/imap/command/imap-command.vala"
		if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 447 "../src/engine/imap/command/imap-command.vala"
			g_propagate_error (error, _inner_error0_);
#line 447 "../src/engine/imap/command/imap-command.vala"
			return;
#line 2508 "imap-command.c"
		} else {
#line 447 "../src/engine/imap/command/imap-command.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 447 "../src/engine/imap/command/imap-command.vala"
			g_clear_error (&_inner_error0_);
#line 447 "../src/engine/imap/command/imap-command.vala"
			return;
#line 2516 "imap-command.c"
		}
	}
#line 453 "../src/engine/imap/command/imap-command.vala"
	_tmp5_ = self->priv->_status;
#line 453 "../src/engine/imap/command/imap-command.vala"
	_tmp6_ = geary_imap_status_response_get_is_completion (_tmp5_);
#line 453 "../src/engine/imap/command/imap-command.vala"
	_tmp7_ = _tmp6_;
#line 453 "../src/engine/imap/command/imap-command.vala"
	if (!_tmp7_) {
#line 2527 "imap-command.c"
		gchar* _tmp8_;
		gchar* _tmp9_;
		GearyImapStatusResponse* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		GError* _tmp13_;
		GError* _tmp14_;
#line 454 "../src/engine/imap/command/imap-command.vala"
		_tmp8_ = geary_imap_command_to_brief_string (self);
#line 454 "../src/engine/imap/command/imap-command.vala"
		_tmp9_ = _tmp8_;
#line 454 "../src/engine/imap/command/imap-command.vala"
		_tmp10_ = self->priv->_status;
#line 454 "../src/engine/imap/command/imap-command.vala"
		_tmp11_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 454 "../src/engine/imap/command/imap-command.vala"
		_tmp12_ = _tmp11_;
#line 454 "../src/engine/imap/command/imap-command.vala"
		_tmp13_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_SERVER_ERROR, "%s: Command status response is not a completion: %s", _tmp9_, _tmp12_);
#line 454 "../src/engine/imap/command/imap-command.vala"
		_tmp14_ = _tmp13_;
#line 454 "../src/engine/imap/command/imap-command.vala"
		_g_free0 (_tmp12_);
#line 454 "../src/engine/imap/command/imap-command.vala"
		_g_free0 (_tmp9_);
#line 454 "../src/engine/imap/command/imap-command.vala"
		_inner_error0_ = _tmp14_;
#line 454 "../src/engine/imap/command/imap-command.vala"
		if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 454 "../src/engine/imap/command/imap-command.vala"
			g_propagate_error (error, _inner_error0_);
#line 454 "../src/engine/imap/command/imap-command.vala"
			return;
#line 2561 "imap-command.c"
		} else {
#line 454 "../src/engine/imap/command/imap-command.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 454 "../src/engine/imap/command/imap-command.vala"
			g_clear_error (&_inner_error0_);
#line 454 "../src/engine/imap/command/imap-command.vala"
			return;
#line 2569 "imap-command.c"
		}
	}
}

static void
geary_imap_command_on_response_timeout (GearyImapCommand* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _tmp2_;
	GError* _tmp3_;
#line 462 "../src/engine/imap/command/imap-command.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (self));
#line 463 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = geary_imap_command_to_brief_string (self);
#line 463 "../src/engine/imap/command/imap-command.vala"
	_tmp1_ = _tmp0_;
#line 463 "../src/engine/imap/command/imap-command.vala"
	_tmp2_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_TIMED_OUT, "%s: Command timed out", _tmp1_);
#line 463 "../src/engine/imap/command/imap-command.vala"
	_tmp3_ = _tmp2_;
#line 463 "../src/engine/imap/command/imap-command.vala"
	geary_imap_command_cancel (self, _tmp3_);
#line 463 "../src/engine/imap/command/imap-command.vala"
	_g_error_free0 (_tmp3_);
#line 463 "../src/engine/imap/command/imap-command.vala"
	_g_free0 (_tmp1_);
#line 466 "../src/engine/imap/command/imap-command.vala"
	g_signal_emit (self, geary_imap_command_signals[GEARY_IMAP_COMMAND_RESPONSE_TIMED_OUT_SIGNAL], 0);
#line 2599 "imap-command.c"
}

static void
geary_imap_command_class_init (GearyImapCommandClass * klass,
                               gpointer klass_data)
{
#line 20 "../src/engine/imap/command/imap-command.vala"
	geary_imap_command_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/engine/imap/command/imap-command.vala"
	g_type_class_adjust_private_offset (klass, &GearyImapCommand_private_offset);
#line 20 "../src/engine/imap/command/imap-command.vala"
	((GearyImapCommandClass *) klass)->send = (void (*) (GearyImapCommand*, GearyImapSerializer*, GCancellable*, GAsyncReadyCallback, gpointer)) geary_imap_command_real_send;
#line 20 "../src/engine/imap/command/imap-command.vala"
	((GearyImapCommandClass *) klass)->send_finish = (void (*) (GearyImapCommand*, GAsyncResult*, GError**)) geary_imap_command_real_send_finish;
#line 20 "../src/engine/imap/command/imap-command.vala"
	((GearyImapCommandClass *) klass)->send_wait = (void (*) (GearyImapCommand*, GearyImapSerializer*, GCancellable*, GAsyncReadyCallback, gpointer)) geary_imap_command_real_send_wait;
#line 20 "../src/engine/imap/command/imap-command.vala"
	((GearyImapCommandClass *) klass)->send_wait_finish = (void (*) (GearyImapCommand*, GAsyncResult*, GError**)) geary_imap_command_real_send_wait_finish;
#line 20 "../src/engine/imap/command/imap-command.vala"
	((GearyImapCommandClass *) klass)->to_string = (gchar* (*) (GearyImapCommand*)) geary_imap_command_real_to_string;
#line 20 "../src/engine/imap/command/imap-command.vala"
	((GearyImapCommandClass *) klass)->update_response_timer = (void (*) (GearyImapCommand*)) geary_imap_command_real_update_response_timer;
#line 20 "../src/engine/imap/command/imap-command.vala"
	((GearyImapCommandClass *) klass)->completed = (void (*) (GearyImapCommand*, GearyImapStatusResponse*, GError**)) geary_imap_command_real_completed;
#line 20 "../src/engine/imap/command/imap-command.vala"
	((GearyImapCommandClass *) klass)->cancelled_before_send = (void (*) (GearyImapCommand*)) geary_imap_command_real_cancelled_before_send;
#line 20 "../src/engine/imap/command/imap-command.vala"
	((GearyImapCommandClass *) klass)->disconnected = (void (*) (GearyImapCommand*, const gchar*)) geary_imap_command_real_disconnected;
#line 20 "../src/engine/imap/command/imap-command.vala"
	((GearyImapCommandClass *) klass)->data_received = (void (*) (GearyImapCommand*, GearyImapServerData*, GError**)) geary_imap_command_real_data_received;
#line 20 "../src/engine/imap/command/imap-command.vala"
	((GearyImapCommandClass *) klass)->continuation_requested = (void (*) (GearyImapCommand*, GearyImapContinuationResponse*, GError**)) geary_imap_command_real_continuation_requested;
#line 20 "../src/engine/imap/command/imap-command.vala"
	((GearyImapCommandClass *) klass)->stop_serialisation = (void (*) (GearyImapCommand*)) geary_imap_command_real_stop_serialisation;
#line 20 "../src/engine/imap/command/imap-command.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_imap_command_get_property;
#line 20 "../src/engine/imap/command/imap-command.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_imap_command_set_property;
#line 20 "../src/engine/imap/command/imap-command.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_imap_command_finalize;
#line 2640 "imap-command.c"
	/**
	     * All IMAP commands are tagged with an identifier assigned by the client.
	     *
	     * Note that this is not immutable.  The general practice is to use an unassigned Tag
	     * up until the {@link Command} is about to be transmitted, at which point a Tag is
	     * assigned.  This allows for all commands to be issued in Tag "order".  This generally makes
	     * tracing network traffic easier.
	     *
	     * @see Tag.get_unassigned
	     * @see assign_tag
	     */
#line 20 "../src/engine/imap/command/imap-command.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_COMMAND_TAG_PROPERTY, geary_imap_command_properties[GEARY_IMAP_COMMAND_TAG_PROPERTY] = g_param_spec_object ("tag", "tag", "tag", GEARY_IMAP_TYPE_TAG, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2654 "imap-command.c"
	/**
	     * The name (or "verb") of this command.
	     */
#line 20 "../src/engine/imap/command/imap-command.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_COMMAND_NAME_PROPERTY, geary_imap_command_properties[GEARY_IMAP_COMMAND_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2660 "imap-command.c"
	/**
	     * Number of seconds to wait for a server response to this command.
	     */
#line 20 "../src/engine/imap/command/imap-command.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_COMMAND_RESPONSE_TIMEOUT_PROPERTY, geary_imap_command_properties[GEARY_IMAP_COMMAND_RESPONSE_TIMEOUT_PROPERTY] = g_param_spec_uint ("response-timeout", "response-timeout", "response-timeout", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2666 "imap-command.c"
	/** The status response for the command, once it has been received. */
#line 20 "../src/engine/imap/command/imap-command.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_COMMAND_STATUS_PROPERTY, geary_imap_command_properties[GEARY_IMAP_COMMAND_STATUS_PROPERTY] = g_param_spec_object ("status", "status", "status", GEARY_IMAP_TYPE_STATUS_RESPONSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2670 "imap-command.c"
	/**
	     * A guard to allow cancelling a command before it is sent.
	     *
	     * Since IMAP does not allow commands that have been sent to the
	     * server to be cancelled, cancelling a command before sending it
	     * is the last opportunity to prevent it from being executed. A
	     * command queued to be sent will be sent as long as the
	     * connection it was queued is open and this cancellable is null
	     * or is not cancelled.
	     *
	     * @see Command.Command
	     */
#line 20 "../src/engine/imap/command/imap-command.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_COMMAND_SHOULD_SEND_PROPERTY, geary_imap_command_properties[GEARY_IMAP_COMMAND_SHOULD_SEND_PROPERTY] = g_param_spec_object ("should-send", "should-send", "should-send", g_cancellable_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2685 "imap-command.c"
	/**
	     * The command's arguments as parameters.
	     *
	     * Subclassess may append arguments to this before {@link send} is
	     * called, ideally from their constructors.
	     */
#line 20 "../src/engine/imap/command/imap-command.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_COMMAND_ARGS_PROPERTY, geary_imap_command_properties[GEARY_IMAP_COMMAND_ARGS_PROPERTY] = g_param_spec_object ("args", "args", "args", GEARY_IMAP_TYPE_LIST_PARAMETER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2694 "imap-command.c"
	/**
	     * Timer used to check for a response within {@link response_timeout}.
	     */
#line 20 "../src/engine/imap/command/imap-command.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_COMMAND_RESPONSE_TIMER_PROPERTY, geary_imap_command_properties[GEARY_IMAP_COMMAND_RESPONSE_TIMER_PROPERTY] = g_param_spec_object ("response-timer", "response-timer", "response-timer", GEARY_TYPE_TIMEOUT_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2700 "imap-command.c"
	/**
	     * Fired when the response timeout for this command has been reached.
	     */
#line 20 "../src/engine/imap/command/imap-command.vala"
	geary_imap_command_signals[GEARY_IMAP_COMMAND_RESPONSE_TIMED_OUT_SIGNAL] = g_signal_new ("response-timed-out", GEARY_IMAP_TYPE_COMMAND, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2706 "imap-command.c"
}

static void
geary_imap_command_instance_init (GearyImapCommand * self,
                                  gpointer klass)
{
	GearyImapRootParameters* _tmp0_;
	GearyNonblockingSemaphore* _tmp1_;
#line 20 "../src/engine/imap/command/imap-command.vala"
	self->priv = geary_imap_command_get_instance_private (self);
#line 58 "../src/engine/imap/command/imap-command.vala"
	self->priv->_response_timeout = GEARY_IMAP_COMMAND_DEFAULT_RESPONSE_TIMEOUT_SEC;
#line 61 "../src/engine/imap/command/imap-command.vala"
	self->priv->_status = NULL;
#line 75 "../src/engine/imap/command/imap-command.vala"
	self->priv->_should_send = NULL;
#line 83 "../src/engine/imap/command/imap-command.vala"
	_tmp0_ = geary_imap_root_parameters_new ();
#line 83 "../src/engine/imap/command/imap-command.vala"
	self->priv->_args = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_IMAP_TYPE_LIST_PARAMETER, GearyImapListParameter);
#line 92 "../src/engine/imap/command/imap-command.vala"
	_tmp1_ = geary_nonblocking_semaphore_new (NULL);
#line 92 "../src/engine/imap/command/imap-command.vala"
	self->priv->complete_lock = _tmp1_;
#line 95 "../src/engine/imap/command/imap-command.vala"
	self->priv->cancelled_cause = NULL;
#line 97 "../src/engine/imap/command/imap-command.vala"
	self->priv->literal_spinlock = NULL;
#line 98 "../src/engine/imap/command/imap-command.vala"
	self->priv->literal_cancellable = NULL;
#line 2737 "imap-command.c"
}

static void
geary_imap_command_finalize (GObject * obj)
{
	GearyImapCommand * self;
#line 20 "../src/engine/imap/command/imap-command.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_IMAP_TYPE_COMMAND, GearyImapCommand);
#line 39 "../src/engine/imap/command/imap-command.vala"
	_g_object_unref0 (self->priv->_tag);
#line 44 "../src/engine/imap/command/imap-command.vala"
	_g_free0 (self->priv->_name);
#line 61 "../src/engine/imap/command/imap-command.vala"
	_g_object_unref0 (self->priv->_status);
#line 75 "../src/engine/imap/command/imap-command.vala"
	_g_object_unref0 (self->priv->_should_send);
#line 83 "../src/engine/imap/command/imap-command.vala"
	_g_object_unref0 (self->priv->_args);
#line 90 "../src/engine/imap/command/imap-command.vala"
	_g_object_unref0 (self->priv->_response_timer);
#line 92 "../src/engine/imap/command/imap-command.vala"
	_g_object_unref0 (self->priv->complete_lock);
#line 95 "../src/engine/imap/command/imap-command.vala"
	_g_error_free0 (self->priv->cancelled_cause);
#line 97 "../src/engine/imap/command/imap-command.vala"
	_g_object_unref0 (self->priv->literal_spinlock);
#line 98 "../src/engine/imap/command/imap-command.vala"
	_g_object_unref0 (self->priv->literal_cancellable);
#line 20 "../src/engine/imap/command/imap-command.vala"
	G_OBJECT_CLASS (geary_imap_command_parent_class)->finalize (obj);
#line 2768 "imap-command.c"
}

/**
 * A representation of an IMAP command (request).
 *
 * A Command is created by the caller and then submitted to a {@link ClientSession} or
 * {@link ClientConnection} for transmission to the server.  In response, one or more
 * {@link ServerResponse}s are returned, generally zero or more {@link ServerData}s followed by
 * a completion {@link StatusResponse}.  Untagged {@link StatusResponse}s may also be returned,
 * depending on the Command.
 *
 * See [[http://tools.ietf.org/html/rfc3501#section-6]]
 */
 G_GNUC_NO_INLINE static GType
geary_imap_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyImapCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_imap_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyImapCommand), 0, (GInstanceInitFunc) geary_imap_command_instance_init, NULL };
	GType geary_imap_command_type_id;
	geary_imap_command_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyImapCommand", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	GearyImapCommand_private_offset = g_type_add_instance_private (geary_imap_command_type_id, sizeof (GearyImapCommandPrivate));
	return geary_imap_command_type_id;
}

GType
geary_imap_command_get_type (void)
{
	static gsize geary_imap_command_type_id__once = 0;
	if (g_once_init_enter (&geary_imap_command_type_id__once)) {
		GType geary_imap_command_type_id;
		geary_imap_command_type_id = geary_imap_command_get_type_once ();
		g_once_init_leave (&geary_imap_command_type_id__once, geary_imap_command_type_id);
	}
	return geary_imap_command_type_id__once;
}

static void
_vala_geary_imap_command_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	GearyImapCommand * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_TYPE_COMMAND, GearyImapCommand);
#line 20 "../src/engine/imap/command/imap-command.vala"
	switch (property_id) {
#line 20 "../src/engine/imap/command/imap-command.vala"
		case GEARY_IMAP_COMMAND_TAG_PROPERTY:
#line 20 "../src/engine/imap/command/imap-command.vala"
		g_value_set_object (value, geary_imap_command_get_tag (self));
#line 20 "../src/engine/imap/command/imap-command.vala"
		break;
#line 20 "../src/engine/imap/command/imap-command.vala"
		case GEARY_IMAP_COMMAND_NAME_PROPERTY:
#line 20 "../src/engine/imap/command/imap-command.vala"
		g_value_set_string (value, geary_imap_command_get_name (self));
#line 20 "../src/engine/imap/command/imap-command.vala"
		break;
#line 20 "../src/engine/imap/command/imap-command.vala"
		case GEARY_IMAP_COMMAND_RESPONSE_TIMEOUT_PROPERTY:
#line 20 "../src/engine/imap/command/imap-command.vala"
		g_value_set_uint (value, geary_imap_command_get_response_timeout (self));
#line 20 "../src/engine/imap/command/imap-command.vala"
		break;
#line 20 "../src/engine/imap/command/imap-command.vala"
		case GEARY_IMAP_COMMAND_STATUS_PROPERTY:
#line 20 "../src/engine/imap/command/imap-command.vala"
		g_value_set_object (value, geary_imap_command_get_status (self));
#line 20 "../src/engine/imap/command/imap-command.vala"
		break;
#line 20 "../src/engine/imap/command/imap-command.vala"
		case GEARY_IMAP_COMMAND_SHOULD_SEND_PROPERTY:
#line 20 "../src/engine/imap/command/imap-command.vala"
		g_value_set_object (value, geary_imap_command_get_should_send (self));
#line 20 "../src/engine/imap/command/imap-command.vala"
		break;
#line 20 "../src/engine/imap/command/imap-command.vala"
		case GEARY_IMAP_COMMAND_ARGS_PROPERTY:
#line 20 "../src/engine/imap/command/imap-command.vala"
		g_value_set_object (value, geary_imap_command_get_args (self));
#line 20 "../src/engine/imap/command/imap-command.vala"
		break;
#line 20 "../src/engine/imap/command/imap-command.vala"
		case GEARY_IMAP_COMMAND_RESPONSE_TIMER_PROPERTY:
#line 20 "../src/engine/imap/command/imap-command.vala"
		g_value_set_object (value, geary_imap_command_get_response_timer (self));
#line 20 "../src/engine/imap/command/imap-command.vala"
		break;
#line 2856 "imap-command.c"
		default:
#line 20 "../src/engine/imap/command/imap-command.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/engine/imap/command/imap-command.vala"
		break;
#line 2862 "imap-command.c"
	}
}

static void
_vala_geary_imap_command_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	GearyImapCommand * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_TYPE_COMMAND, GearyImapCommand);
#line 20 "../src/engine/imap/command/imap-command.vala"
	switch (property_id) {
#line 20 "../src/engine/imap/command/imap-command.vala"
		case GEARY_IMAP_COMMAND_TAG_PROPERTY:
#line 20 "../src/engine/imap/command/imap-command.vala"
		geary_imap_command_set_tag (self, g_value_get_object (value));
#line 20 "../src/engine/imap/command/imap-command.vala"
		break;
#line 20 "../src/engine/imap/command/imap-command.vala"
		case GEARY_IMAP_COMMAND_NAME_PROPERTY:
#line 20 "../src/engine/imap/command/imap-command.vala"
		geary_imap_command_set_name (self, g_value_get_string (value));
#line 20 "../src/engine/imap/command/imap-command.vala"
		break;
#line 20 "../src/engine/imap/command/imap-command.vala"
		case GEARY_IMAP_COMMAND_RESPONSE_TIMEOUT_PROPERTY:
#line 20 "../src/engine/imap/command/imap-command.vala"
		geary_imap_command_set_response_timeout (self, g_value_get_uint (value));
#line 20 "../src/engine/imap/command/imap-command.vala"
		break;
#line 20 "../src/engine/imap/command/imap-command.vala"
		case GEARY_IMAP_COMMAND_STATUS_PROPERTY:
#line 20 "../src/engine/imap/command/imap-command.vala"
		geary_imap_command_set_status (self, g_value_get_object (value));
#line 20 "../src/engine/imap/command/imap-command.vala"
		break;
#line 20 "../src/engine/imap/command/imap-command.vala"
		case GEARY_IMAP_COMMAND_SHOULD_SEND_PROPERTY:
#line 20 "../src/engine/imap/command/imap-command.vala"
		geary_imap_command_set_should_send (self, g_value_get_object (value));
#line 20 "../src/engine/imap/command/imap-command.vala"
		break;
#line 20 "../src/engine/imap/command/imap-command.vala"
		case GEARY_IMAP_COMMAND_ARGS_PROPERTY:
#line 20 "../src/engine/imap/command/imap-command.vala"
		geary_imap_command_set_args (self, g_value_get_object (value));
#line 20 "../src/engine/imap/command/imap-command.vala"
		break;
#line 20 "../src/engine/imap/command/imap-command.vala"
		case GEARY_IMAP_COMMAND_RESPONSE_TIMER_PROPERTY:
#line 20 "../src/engine/imap/command/imap-command.vala"
		geary_imap_command_set_response_timer (self, g_value_get_object (value));
#line 20 "../src/engine/imap/command/imap-command.vala"
		break;
#line 2918 "imap-command.c"
		default:
#line 20 "../src/engine/imap/command/imap-command.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/engine/imap/command/imap-command.vala"
		break;
#line 2924 "imap-command.c"
	}
}

