/* imap-message-set.c generated by valac 0.56.17, the Vala compiler
 * generated from imap-message-set.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gee.h>

#define GEARY_IMAP_MESSAGE_SET_MAX_SPARSE_VALUES_PER_SET 50
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_IMAP_MESSAGE_SET_0_PROPERTY,
	GEARY_IMAP_MESSAGE_SET_IS_UID_PROPERTY,
	GEARY_IMAP_MESSAGE_SET_NUM_PROPERTIES
};
static GParamSpec* geary_imap_message_set_properties[GEARY_IMAP_MESSAGE_SET_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block29Data Block29Data;
typedef void (*GearyImapMessageSetParserCallback) (gint64 value, gpointer user_data, GError** error);
typedef struct _Block30Data Block30Data;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GearyImapMessageSetPrivate {
	gboolean _is_uid;
	gchar* _value;
};

struct _Block29Data {
	int _ref_count_;
	GeeList* seq_nums;
};

struct _Block30Data {
	int _ref_count_;
	GeeList* uids;
};

static gint GearyImapMessageSet_private_offset;
static gpointer geary_imap_message_set_parent_class = NULL;

static void geary_imap_message_set_set_is_uid (GearyImapMessageSet* self,
                                        gboolean value);
static const gchar* geary_imap_message_set_get_value (GearyImapMessageSet* self);
static void geary_imap_message_set_set_value (GearyImapMessageSet* self,
                                       const gchar* value);
static Block29Data* block29_data_ref (Block29Data* _data29_);
static void block29_data_unref (void * _userdata_);
static void geary_imap_message_set_parse_string (const gchar* str,
                                          GearyImapMessageSetParserCallback cb,
                                          gpointer cb_target,
                                          GError** error);
static void __lambda42_ (Block29Data* _data29_,
                  gint64 value,
                  GError** error);
static void ___lambda42__geary_imap_message_set_parser_callback (gint64 value,
                                                          gpointer self,
                                                          GError** error);
static Block30Data* block30_data_ref (Block30Data* _data30_);
static void block30_data_unref (void * _userdata_);
static void __lambda43_ (Block30Data* _data30_,
                  gint64 value,
                  GError** error);
static void ___lambda43__geary_imap_message_set_parser_callback (gint64 value,
                                                          gpointer self,
                                                          GError** error);
static void geary_imap_message_set_process_range (gint64 start,
                                           gint64 end,
                                           GearyImapMessageSetParserCallback cb,
                                           gpointer cb_target,
                                           GError** error);
static GeeList* geary_imap_message_set_build_sparse_sets (gint64* sorted,
                                                   gint sorted_length1,
                                                   gboolean is_uid);
static gint64* geary_imap_message_set_seq_array_to_int64 (GeeCollection* seq_nums,
                                                   gint* result_length1);
static gint64* geary_imap_message_set_uid_array_to_int64 (GeeCollection* msg_uids,
                                                   gint* result_length1);
static gchar* geary_imap_message_set_build_sparse_range (gint64* seq_nums,
                                                  gint seq_nums_length1);
static gint __lambda44_ (GearyImapSequenceNumber* a,
                  GearyImapSequenceNumber* b);
static gint ___lambda44__gcompare_data_func (gconstpointer a,
                                      gconstpointer b,
                                      gpointer self);
static gint __lambda45_ (GearyImapUID* a,
                  GearyImapUID* b);
static gint ___lambda45__gcompare_data_func (gconstpointer a,
                                      gconstpointer b,
                                      gpointer self);
static void geary_imap_message_set_finalize (GObject * obj);
static GType geary_imap_message_set_get_type_once (void);
static void _vala_geary_imap_message_set_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_geary_imap_message_set_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
geary_imap_message_set_get_instance_private (GearyImapMessageSet* self)
{
	return G_STRUCT_MEMBER_P (self, GearyImapMessageSet_private_offset);
}

gboolean
geary_imap_message_set_get_is_uid (GearyImapMessageSet* self)
{
	gboolean result;
#line 30 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_MESSAGE_SET (self), FALSE);
#line 30 "../src/engine/imap/command/imap-message-set.vala"
	result = self->priv->_is_uid;
#line 30 "../src/engine/imap/command/imap-message-set.vala"
	return result;
#line 139 "imap-message-set.c"
}

static void
geary_imap_message_set_set_is_uid (GearyImapMessageSet* self,
                                   gboolean value)
{
	gboolean old_value;
#line 30 "../src/engine/imap/command/imap-message-set.vala"
	g_return_if_fail (GEARY_IMAP_IS_MESSAGE_SET (self));
#line 30 "../src/engine/imap/command/imap-message-set.vala"
	old_value = geary_imap_message_set_get_is_uid (self);
#line 30 "../src/engine/imap/command/imap-message-set.vala"
	if (old_value != value) {
#line 30 "../src/engine/imap/command/imap-message-set.vala"
		self->priv->_is_uid = value;
#line 30 "../src/engine/imap/command/imap-message-set.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_imap_message_set_properties[GEARY_IMAP_MESSAGE_SET_IS_UID_PROPERTY]);
#line 157 "imap-message-set.c"
	}
}

static const gchar*
geary_imap_message_set_get_value (GearyImapMessageSet* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_MESSAGE_SET (self), NULL);
#line 32 "../src/engine/imap/command/imap-message-set.vala"
	_tmp0_ = self->priv->_value;
#line 32 "../src/engine/imap/command/imap-message-set.vala"
	result = _tmp0_;
#line 32 "../src/engine/imap/command/imap-message-set.vala"
	return result;
#line 174 "imap-message-set.c"
}

static void
geary_imap_message_set_set_value (GearyImapMessageSet* self,
                                  const gchar* value)
{
	gchar* _tmp0_;
#line 32 "../src/engine/imap/command/imap-message-set.vala"
	g_return_if_fail (GEARY_IMAP_IS_MESSAGE_SET (self));
#line 32 "../src/engine/imap/command/imap-message-set.vala"
	_tmp0_ = g_strdup (value);
#line 32 "../src/engine/imap/command/imap-message-set.vala"
	_g_free0 (self->priv->_value);
#line 32 "../src/engine/imap/command/imap-message-set.vala"
	self->priv->_value = _tmp0_;
#line 190 "imap-message-set.c"
}

GearyImapMessageSet*
geary_imap_message_set_construct (GType object_type,
                                  GearyImapSequenceNumber* seq_num)
{
	GearyImapMessageSet * self = NULL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 34 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_SEQUENCE_NUMBER (seq_num), NULL);
#line 34 "../src/engine/imap/command/imap-message-set.vala"
	self = (GearyImapMessageSet*) geary_base_object_construct (object_type);
#line 35 "../src/engine/imap/command/imap-message-set.vala"
	_tmp0_ = geary_message_data_int64_message_data_get_value (G_TYPE_CHECK_INSTANCE_CAST (seq_num, GEARY_MESSAGE_DATA_TYPE_INT64_MESSAGE_DATA, GearyMessageDataInt64MessageData));
#line 35 "../src/engine/imap/command/imap-message-set.vala"
	_tmp1_ = _tmp0_;
#line 35 "../src/engine/imap/command/imap-message-set.vala"
	_vala_assert (_tmp1_ > ((gint64) 0), "seq_num.value > 0");
#line 37 "../src/engine/imap/command/imap-message-set.vala"
	_tmp2_ = geary_imap_sequence_number_serialize (seq_num);
#line 37 "../src/engine/imap/command/imap-message-set.vala"
	_tmp3_ = _tmp2_;
#line 37 "../src/engine/imap/command/imap-message-set.vala"
	geary_imap_message_set_set_value (self, _tmp3_);
#line 37 "../src/engine/imap/command/imap-message-set.vala"
	_g_free0 (_tmp3_);
#line 34 "../src/engine/imap/command/imap-message-set.vala"
	return self;
#line 222 "imap-message-set.c"
}

GearyImapMessageSet*
geary_imap_message_set_new (GearyImapSequenceNumber* seq_num)
{
#line 34 "../src/engine/imap/command/imap-message-set.vala"
	return geary_imap_message_set_construct (GEARY_IMAP_TYPE_MESSAGE_SET, seq_num);
#line 230 "imap-message-set.c"
}

GearyImapMessageSet*
geary_imap_message_set_construct_uid (GType object_type,
                                      GearyImapUID* uid)
{
	GearyImapMessageSet * self = NULL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 40 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_UID (uid), NULL);
#line 40 "../src/engine/imap/command/imap-message-set.vala"
	self = (GearyImapMessageSet*) geary_base_object_construct (object_type);
#line 41 "../src/engine/imap/command/imap-message-set.vala"
	_tmp0_ = geary_message_data_int64_message_data_get_value (G_TYPE_CHECK_INSTANCE_CAST (uid, GEARY_MESSAGE_DATA_TYPE_INT64_MESSAGE_DATA, GearyMessageDataInt64MessageData));
#line 41 "../src/engine/imap/command/imap-message-set.vala"
	_tmp1_ = _tmp0_;
#line 41 "../src/engine/imap/command/imap-message-set.vala"
	_vala_assert (_tmp1_ > ((gint64) 0), "uid.value > 0");
#line 43 "../src/engine/imap/command/imap-message-set.vala"
	_tmp2_ = geary_imap_uid_serialize (uid);
#line 43 "../src/engine/imap/command/imap-message-set.vala"
	_tmp3_ = _tmp2_;
#line 43 "../src/engine/imap/command/imap-message-set.vala"
	geary_imap_message_set_set_value (self, _tmp3_);
#line 43 "../src/engine/imap/command/imap-message-set.vala"
	_g_free0 (_tmp3_);
#line 44 "../src/engine/imap/command/imap-message-set.vala"
	geary_imap_message_set_set_is_uid (self, TRUE);
#line 40 "../src/engine/imap/command/imap-message-set.vala"
	return self;
#line 264 "imap-message-set.c"
}

GearyImapMessageSet*
geary_imap_message_set_new_uid (GearyImapUID* uid)
{
#line 40 "../src/engine/imap/command/imap-message-set.vala"
	return geary_imap_message_set_construct_uid (GEARY_IMAP_TYPE_MESSAGE_SET, uid);
#line 272 "imap-message-set.c"
}

GearyImapMessageSet*
geary_imap_message_set_construct_range_by_count (GType object_type,
                                                 GearyImapSequenceNumber* low_seq_num,
                                                 gint count)
{
	GearyImapMessageSet * self = NULL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	gchar* _tmp2_ = NULL;
#line 47 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_SEQUENCE_NUMBER (low_seq_num), NULL);
#line 47 "../src/engine/imap/command/imap-message-set.vala"
	self = (GearyImapMessageSet*) geary_base_object_construct (object_type);
#line 48 "../src/engine/imap/command/imap-message-set.vala"
	_tmp0_ = geary_message_data_int64_message_data_get_value (G_TYPE_CHECK_INSTANCE_CAST (low_seq_num, GEARY_MESSAGE_DATA_TYPE_INT64_MESSAGE_DATA, GearyMessageDataInt64MessageData));
#line 48 "../src/engine/imap/command/imap-message-set.vala"
	_tmp1_ = _tmp0_;
#line 48 "../src/engine/imap/command/imap-message-set.vala"
	_vala_assert (_tmp1_ > ((gint64) 0), "low_seq_num.value > 0");
#line 49 "../src/engine/imap/command/imap-message-set.vala"
	_vala_assert (count > 0, "count > 0");
#line 51 "../src/engine/imap/command/imap-message-set.vala"
	if (count > 1) {
#line 298 "imap-message-set.c"
		gint64 _tmp3_;
		gint64 _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gint64 _tmp7_;
		gint64 _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 52 "../src/engine/imap/command/imap-message-set.vala"
		_tmp3_ = geary_message_data_int64_message_data_get_value (G_TYPE_CHECK_INSTANCE_CAST (low_seq_num, GEARY_MESSAGE_DATA_TYPE_INT64_MESSAGE_DATA, GearyMessageDataInt64MessageData));
#line 52 "../src/engine/imap/command/imap-message-set.vala"
		_tmp4_ = _tmp3_;
#line 52 "../src/engine/imap/command/imap-message-set.vala"
		_tmp5_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp4_);
#line 52 "../src/engine/imap/command/imap-message-set.vala"
		_tmp6_ = _tmp5_;
#line 52 "../src/engine/imap/command/imap-message-set.vala"
		_tmp7_ = geary_message_data_int64_message_data_get_value (G_TYPE_CHECK_INSTANCE_CAST (low_seq_num, GEARY_MESSAGE_DATA_TYPE_INT64_MESSAGE_DATA, GearyMessageDataInt64MessageData));
#line 52 "../src/engine/imap/command/imap-message-set.vala"
		_tmp8_ = _tmp7_;
#line 52 "../src/engine/imap/command/imap-message-set.vala"
		_tmp9_ = g_strdup_printf ("%" G_GINT64_FORMAT, (_tmp8_ + count) - 1);
#line 52 "../src/engine/imap/command/imap-message-set.vala"
		_tmp10_ = _tmp9_;
#line 52 "../src/engine/imap/command/imap-message-set.vala"
		_tmp11_ = g_strdup_printf ("%s:%s", _tmp6_, _tmp10_);
#line 52 "../src/engine/imap/command/imap-message-set.vala"
		_g_free0 (_tmp2_);
#line 52 "../src/engine/imap/command/imap-message-set.vala"
		_tmp2_ = _tmp11_;
#line 52 "../src/engine/imap/command/imap-message-set.vala"
		_g_free0 (_tmp10_);
#line 52 "../src/engine/imap/command/imap-message-set.vala"
		_g_free0 (_tmp6_);
#line 334 "imap-message-set.c"
	} else {
		gchar* _tmp12_;
#line 53 "../src/engine/imap/command/imap-message-set.vala"
		_tmp12_ = geary_imap_sequence_number_serialize (low_seq_num);
#line 53 "../src/engine/imap/command/imap-message-set.vala"
		_g_free0 (_tmp2_);
#line 53 "../src/engine/imap/command/imap-message-set.vala"
		_tmp2_ = _tmp12_;
#line 343 "imap-message-set.c"
	}
#line 51 "../src/engine/imap/command/imap-message-set.vala"
	geary_imap_message_set_set_value (self, _tmp2_);
#line 47 "../src/engine/imap/command/imap-message-set.vala"
	_g_free0 (_tmp2_);
#line 47 "../src/engine/imap/command/imap-message-set.vala"
	return self;
#line 351 "imap-message-set.c"
}

GearyImapMessageSet*
geary_imap_message_set_new_range_by_count (GearyImapSequenceNumber* low_seq_num,
                                           gint count)
{
#line 47 "../src/engine/imap/command/imap-message-set.vala"
	return geary_imap_message_set_construct_range_by_count (GEARY_IMAP_TYPE_MESSAGE_SET, low_seq_num, count);
#line 360 "imap-message-set.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 62 "../src/engine/imap/command/imap-message-set.vala"
	return self ? g_object_ref (self) : NULL;
#line 368 "imap-message-set.c"
}

GearyImapMessageSet*
geary_imap_message_set_construct_range_by_first_last (GType object_type,
                                                      GearyImapSequenceNumber* low_seq_num,
                                                      GearyImapSequenceNumber* high_seq_num)
{
	GearyImapMessageSet * self = NULL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	gint64 _tmp2_;
	gint64 _tmp3_;
	gint64 _tmp4_;
	gint64 _tmp5_;
	gint64 _tmp6_;
	gint64 _tmp7_;
	gchar* _tmp10_ = NULL;
#line 56 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_SEQUENCE_NUMBER (low_seq_num), NULL);
#line 56 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_SEQUENCE_NUMBER (high_seq_num), NULL);
#line 56 "../src/engine/imap/command/imap-message-set.vala"
	self = (GearyImapMessageSet*) geary_base_object_construct (object_type);
#line 57 "../src/engine/imap/command/imap-message-set.vala"
	_tmp0_ = geary_message_data_int64_message_data_get_value (G_TYPE_CHECK_INSTANCE_CAST (low_seq_num, GEARY_MESSAGE_DATA_TYPE_INT64_MESSAGE_DATA, GearyMessageDataInt64MessageData));
#line 57 "../src/engine/imap/command/imap-message-set.vala"
	_tmp1_ = _tmp0_;
#line 57 "../src/engine/imap/command/imap-message-set.vala"
	_vala_assert (_tmp1_ > ((gint64) 0), "low_seq_num.value > 0");
#line 58 "../src/engine/imap/command/imap-message-set.vala"
	_tmp2_ = geary_message_data_int64_message_data_get_value (G_TYPE_CHECK_INSTANCE_CAST (high_seq_num, GEARY_MESSAGE_DATA_TYPE_INT64_MESSAGE_DATA, GearyMessageDataInt64MessageData));
#line 58 "../src/engine/imap/command/imap-message-set.vala"
	_tmp3_ = _tmp2_;
#line 58 "../src/engine/imap/command/imap-message-set.vala"
	_vala_assert (_tmp3_ > ((gint64) 0), "high_seq_num.value > 0");
#line 61 "../src/engine/imap/command/imap-message-set.vala"
	_tmp4_ = geary_message_data_int64_message_data_get_value (G_TYPE_CHECK_INSTANCE_CAST (low_seq_num, GEARY_MESSAGE_DATA_TYPE_INT64_MESSAGE_DATA, GearyMessageDataInt64MessageData));
#line 61 "../src/engine/imap/command/imap-message-set.vala"
	_tmp5_ = _tmp4_;
#line 61 "../src/engine/imap/command/imap-message-set.vala"
	_tmp6_ = geary_message_data_int64_message_data_get_value (G_TYPE_CHECK_INSTANCE_CAST (high_seq_num, GEARY_MESSAGE_DATA_TYPE_INT64_MESSAGE_DATA, GearyMessageDataInt64MessageData));
#line 61 "../src/engine/imap/command/imap-message-set.vala"
	_tmp7_ = _tmp6_;
#line 61 "../src/engine/imap/command/imap-message-set.vala"
	if (_tmp5_ > _tmp7_) {
#line 414 "imap-message-set.c"
		GearyImapSequenceNumber* swap = NULL;
		GearyImapSequenceNumber* _tmp8_;
		GearyImapSequenceNumber* _tmp9_;
#line 62 "../src/engine/imap/command/imap-message-set.vala"
		_tmp8_ = _g_object_ref0 (low_seq_num);
#line 62 "../src/engine/imap/command/imap-message-set.vala"
		swap = _tmp8_;
#line 63 "../src/engine/imap/command/imap-message-set.vala"
		low_seq_num = high_seq_num;
#line 64 "../src/engine/imap/command/imap-message-set.vala"
		_tmp9_ = swap;
#line 64 "../src/engine/imap/command/imap-message-set.vala"
		high_seq_num = _tmp9_;
#line 61 "../src/engine/imap/command/imap-message-set.vala"
		_g_object_unref0 (swap);
#line 430 "imap-message-set.c"
	}
#line 67 "../src/engine/imap/command/imap-message-set.vala"
	if (!geary_message_data_int64_message_data_equal_to (G_TYPE_CHECK_INSTANCE_CAST (low_seq_num, GEARY_MESSAGE_DATA_TYPE_INT64_MESSAGE_DATA, GearyMessageDataInt64MessageData), G_TYPE_CHECK_INSTANCE_CAST (high_seq_num, GEARY_MESSAGE_DATA_TYPE_INT64_MESSAGE_DATA, GearyMessageDataInt64MessageData))) {
#line 434 "imap-message-set.c"
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 68 "../src/engine/imap/command/imap-message-set.vala"
		_tmp11_ = geary_imap_sequence_number_serialize (low_seq_num);
#line 68 "../src/engine/imap/command/imap-message-set.vala"
		_tmp12_ = _tmp11_;
#line 68 "../src/engine/imap/command/imap-message-set.vala"
		_tmp13_ = geary_imap_sequence_number_serialize (high_seq_num);
#line 68 "../src/engine/imap/command/imap-message-set.vala"
		_tmp14_ = _tmp13_;
#line 68 "../src/engine/imap/command/imap-message-set.vala"
		_tmp15_ = g_strdup_printf ("%s:%s", _tmp12_, _tmp14_);
#line 68 "../src/engine/imap/command/imap-message-set.vala"
		_g_free0 (_tmp10_);
#line 68 "../src/engine/imap/command/imap-message-set.vala"
		_tmp10_ = _tmp15_;
#line 68 "../src/engine/imap/command/imap-message-set.vala"
		_g_free0 (_tmp14_);
#line 68 "../src/engine/imap/command/imap-message-set.vala"
		_g_free0 (_tmp12_);
#line 458 "imap-message-set.c"
	} else {
		gchar* _tmp16_;
#line 69 "../src/engine/imap/command/imap-message-set.vala"
		_tmp16_ = geary_imap_sequence_number_serialize (low_seq_num);
#line 69 "../src/engine/imap/command/imap-message-set.vala"
		_g_free0 (_tmp10_);
#line 69 "../src/engine/imap/command/imap-message-set.vala"
		_tmp10_ = _tmp16_;
#line 467 "imap-message-set.c"
	}
#line 67 "../src/engine/imap/command/imap-message-set.vala"
	geary_imap_message_set_set_value (self, _tmp10_);
#line 56 "../src/engine/imap/command/imap-message-set.vala"
	_g_free0 (_tmp10_);
#line 56 "../src/engine/imap/command/imap-message-set.vala"
	return self;
#line 475 "imap-message-set.c"
}

GearyImapMessageSet*
geary_imap_message_set_new_range_by_first_last (GearyImapSequenceNumber* low_seq_num,
                                                GearyImapSequenceNumber* high_seq_num)
{
#line 56 "../src/engine/imap/command/imap-message-set.vala"
	return geary_imap_message_set_construct_range_by_first_last (GEARY_IMAP_TYPE_MESSAGE_SET, low_seq_num, high_seq_num);
#line 484 "imap-message-set.c"
}

GearyImapMessageSet*
geary_imap_message_set_construct_uid_range (GType object_type,
                                            GearyImapUID* low,
                                            GearyImapUID* high)
{
	GearyImapMessageSet * self = NULL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	gint64 _tmp2_;
	gint64 _tmp3_;
	gint64 _tmp4_;
	gint64 _tmp5_;
	gint64 _tmp6_;
	gint64 _tmp7_;
#line 72 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_UID (low), NULL);
#line 72 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_UID (high), NULL);
#line 72 "../src/engine/imap/command/imap-message-set.vala"
	self = (GearyImapMessageSet*) geary_base_object_construct (object_type);
#line 73 "../src/engine/imap/command/imap-message-set.vala"
	_tmp0_ = geary_message_data_int64_message_data_get_value (G_TYPE_CHECK_INSTANCE_CAST (low, GEARY_MESSAGE_DATA_TYPE_INT64_MESSAGE_DATA, GearyMessageDataInt64MessageData));
#line 73 "../src/engine/imap/command/imap-message-set.vala"
	_tmp1_ = _tmp0_;
#line 73 "../src/engine/imap/command/imap-message-set.vala"
	_vala_assert (_tmp1_ > ((gint64) 0), "low.value > 0");
#line 74 "../src/engine/imap/command/imap-message-set.vala"
	_tmp2_ = geary_message_data_int64_message_data_get_value (G_TYPE_CHECK_INSTANCE_CAST (high, GEARY_MESSAGE_DATA_TYPE_INT64_MESSAGE_DATA, GearyMessageDataInt64MessageData));
#line 74 "../src/engine/imap/command/imap-message-set.vala"
	_tmp3_ = _tmp2_;
#line 74 "../src/engine/imap/command/imap-message-set.vala"
	_vala_assert (_tmp3_ > ((gint64) 0), "high.value > 0");
#line 77 "../src/engine/imap/command/imap-message-set.vala"
	_tmp4_ = geary_message_data_int64_message_data_get_value (G_TYPE_CHECK_INSTANCE_CAST (low, GEARY_MESSAGE_DATA_TYPE_INT64_MESSAGE_DATA, GearyMessageDataInt64MessageData));
#line 77 "../src/engine/imap/command/imap-message-set.vala"
	_tmp5_ = _tmp4_;
#line 77 "../src/engine/imap/command/imap-message-set.vala"
	_tmp6_ = geary_message_data_int64_message_data_get_value (G_TYPE_CHECK_INSTANCE_CAST (high, GEARY_MESSAGE_DATA_TYPE_INT64_MESSAGE_DATA, GearyMessageDataInt64MessageData));
#line 77 "../src/engine/imap/command/imap-message-set.vala"
	_tmp7_ = _tmp6_;
#line 77 "../src/engine/imap/command/imap-message-set.vala"
	if (_tmp5_ > _tmp7_) {
#line 529 "imap-message-set.c"
		GearyImapUID* swap = NULL;
		GearyImapUID* _tmp8_;
		GearyImapUID* _tmp9_;
#line 78 "../src/engine/imap/command/imap-message-set.vala"
		_tmp8_ = _g_object_ref0 (low);
#line 78 "../src/engine/imap/command/imap-message-set.vala"
		swap = _tmp8_;
#line 79 "../src/engine/imap/command/imap-message-set.vala"
		low = high;
#line 80 "../src/engine/imap/command/imap-message-set.vala"
		_tmp9_ = swap;
#line 80 "../src/engine/imap/command/imap-message-set.vala"
		high = _tmp9_;
#line 77 "../src/engine/imap/command/imap-message-set.vala"
		_g_object_unref0 (swap);
#line 545 "imap-message-set.c"
	}
#line 83 "../src/engine/imap/command/imap-message-set.vala"
	if (geary_message_data_int64_message_data_equal_to (G_TYPE_CHECK_INSTANCE_CAST (low, GEARY_MESSAGE_DATA_TYPE_INT64_MESSAGE_DATA, GearyMessageDataInt64MessageData), G_TYPE_CHECK_INSTANCE_CAST (high, GEARY_MESSAGE_DATA_TYPE_INT64_MESSAGE_DATA, GearyMessageDataInt64MessageData))) {
#line 549 "imap-message-set.c"
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 84 "../src/engine/imap/command/imap-message-set.vala"
		_tmp10_ = geary_imap_uid_serialize (low);
#line 84 "../src/engine/imap/command/imap-message-set.vala"
		_tmp11_ = _tmp10_;
#line 84 "../src/engine/imap/command/imap-message-set.vala"
		geary_imap_message_set_set_value (self, _tmp11_);
#line 84 "../src/engine/imap/command/imap-message-set.vala"
		_g_free0 (_tmp11_);
#line 560 "imap-message-set.c"
	} else {
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 86 "../src/engine/imap/command/imap-message-set.vala"
		_tmp12_ = geary_imap_uid_serialize (low);
#line 86 "../src/engine/imap/command/imap-message-set.vala"
		_tmp13_ = _tmp12_;
#line 86 "../src/engine/imap/command/imap-message-set.vala"
		_tmp14_ = geary_imap_uid_serialize (high);
#line 86 "../src/engine/imap/command/imap-message-set.vala"
		_tmp15_ = _tmp14_;
#line 86 "../src/engine/imap/command/imap-message-set.vala"
		_tmp16_ = g_strdup_printf ("%s:%s", _tmp13_, _tmp15_);
#line 86 "../src/engine/imap/command/imap-message-set.vala"
		_tmp17_ = _tmp16_;
#line 86 "../src/engine/imap/command/imap-message-set.vala"
		geary_imap_message_set_set_value (self, _tmp17_);
#line 86 "../src/engine/imap/command/imap-message-set.vala"
		_g_free0 (_tmp17_);
#line 86 "../src/engine/imap/command/imap-message-set.vala"
		_g_free0 (_tmp15_);
#line 86 "../src/engine/imap/command/imap-message-set.vala"
		_g_free0 (_tmp13_);
#line 588 "imap-message-set.c"
	}
#line 88 "../src/engine/imap/command/imap-message-set.vala"
	geary_imap_message_set_set_is_uid (self, TRUE);
#line 72 "../src/engine/imap/command/imap-message-set.vala"
	return self;
#line 594 "imap-message-set.c"
}

GearyImapMessageSet*
geary_imap_message_set_new_uid_range (GearyImapUID* low,
                                      GearyImapUID* high)
{
#line 72 "../src/engine/imap/command/imap-message-set.vala"
	return geary_imap_message_set_construct_uid_range (GEARY_IMAP_TYPE_MESSAGE_SET, low, high);
#line 603 "imap-message-set.c"
}

GearyImapMessageSet*
geary_imap_message_set_construct_range_to_highest (GType object_type,
                                                   GearyImapSequenceNumber* low_seq_num)
{
	GearyImapMessageSet * self = NULL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 91 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_SEQUENCE_NUMBER (low_seq_num), NULL);
#line 91 "../src/engine/imap/command/imap-message-set.vala"
	self = (GearyImapMessageSet*) geary_base_object_construct (object_type);
#line 92 "../src/engine/imap/command/imap-message-set.vala"
	_tmp0_ = geary_message_data_int64_message_data_get_value (G_TYPE_CHECK_INSTANCE_CAST (low_seq_num, GEARY_MESSAGE_DATA_TYPE_INT64_MESSAGE_DATA, GearyMessageDataInt64MessageData));
#line 92 "../src/engine/imap/command/imap-message-set.vala"
	_tmp1_ = _tmp0_;
#line 92 "../src/engine/imap/command/imap-message-set.vala"
	_vala_assert (_tmp1_ > ((gint64) 0), "low_seq_num.value > 0");
#line 94 "../src/engine/imap/command/imap-message-set.vala"
	_tmp2_ = geary_imap_sequence_number_serialize (low_seq_num);
#line 94 "../src/engine/imap/command/imap-message-set.vala"
	_tmp3_ = _tmp2_;
#line 94 "../src/engine/imap/command/imap-message-set.vala"
	_tmp4_ = g_strdup_printf ("%s:*", _tmp3_);
#line 94 "../src/engine/imap/command/imap-message-set.vala"
	_tmp5_ = _tmp4_;
#line 94 "../src/engine/imap/command/imap-message-set.vala"
	geary_imap_message_set_set_value (self, _tmp5_);
#line 94 "../src/engine/imap/command/imap-message-set.vala"
	_g_free0 (_tmp5_);
#line 94 "../src/engine/imap/command/imap-message-set.vala"
	_g_free0 (_tmp3_);
#line 91 "../src/engine/imap/command/imap-message-set.vala"
	return self;
#line 643 "imap-message-set.c"
}

GearyImapMessageSet*
geary_imap_message_set_new_range_to_highest (GearyImapSequenceNumber* low_seq_num)
{
#line 91 "../src/engine/imap/command/imap-message-set.vala"
	return geary_imap_message_set_construct_range_to_highest (GEARY_IMAP_TYPE_MESSAGE_SET, low_seq_num);
#line 651 "imap-message-set.c"
}

GearyImapMessageSet*
geary_imap_message_set_construct_uid_range_to_highest (GType object_type,
                                                       GearyImapUID* low)
{
	GearyImapMessageSet * self = NULL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 97 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_UID (low), NULL);
#line 97 "../src/engine/imap/command/imap-message-set.vala"
	self = (GearyImapMessageSet*) geary_base_object_construct (object_type);
#line 98 "../src/engine/imap/command/imap-message-set.vala"
	_tmp0_ = geary_message_data_int64_message_data_get_value (G_TYPE_CHECK_INSTANCE_CAST (low, GEARY_MESSAGE_DATA_TYPE_INT64_MESSAGE_DATA, GearyMessageDataInt64MessageData));
#line 98 "../src/engine/imap/command/imap-message-set.vala"
	_tmp1_ = _tmp0_;
#line 98 "../src/engine/imap/command/imap-message-set.vala"
	_vala_assert (_tmp1_ > ((gint64) 0), "low.value > 0");
#line 100 "../src/engine/imap/command/imap-message-set.vala"
	_tmp2_ = geary_imap_uid_serialize (low);
#line 100 "../src/engine/imap/command/imap-message-set.vala"
	_tmp3_ = _tmp2_;
#line 100 "../src/engine/imap/command/imap-message-set.vala"
	_tmp4_ = g_strdup_printf ("%s:*", _tmp3_);
#line 100 "../src/engine/imap/command/imap-message-set.vala"
	_tmp5_ = _tmp4_;
#line 100 "../src/engine/imap/command/imap-message-set.vala"
	geary_imap_message_set_set_value (self, _tmp5_);
#line 100 "../src/engine/imap/command/imap-message-set.vala"
	_g_free0 (_tmp5_);
#line 100 "../src/engine/imap/command/imap-message-set.vala"
	_g_free0 (_tmp3_);
#line 101 "../src/engine/imap/command/imap-message-set.vala"
	geary_imap_message_set_set_is_uid (self, TRUE);
#line 97 "../src/engine/imap/command/imap-message-set.vala"
	return self;
#line 693 "imap-message-set.c"
}

GearyImapMessageSet*
geary_imap_message_set_new_uid_range_to_highest (GearyImapUID* low)
{
#line 97 "../src/engine/imap/command/imap-message-set.vala"
	return geary_imap_message_set_construct_uid_range_to_highest (GEARY_IMAP_TYPE_MESSAGE_SET, low);
#line 701 "imap-message-set.c"
}

GearyImapMessageSet*
geary_imap_message_set_construct_custom (GType object_type,
                                         const gchar* custom)
{
	GearyImapMessageSet * self = NULL;
#line 104 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (custom != NULL, NULL);
#line 104 "../src/engine/imap/command/imap-message-set.vala"
	self = (GearyImapMessageSet*) geary_base_object_construct (object_type);
#line 105 "../src/engine/imap/command/imap-message-set.vala"
	geary_imap_message_set_set_value (self, custom);
#line 104 "../src/engine/imap/command/imap-message-set.vala"
	return self;
#line 717 "imap-message-set.c"
}

GearyImapMessageSet*
geary_imap_message_set_new_custom (const gchar* custom)
{
#line 104 "../src/engine/imap/command/imap-message-set.vala"
	return geary_imap_message_set_construct_custom (GEARY_IMAP_TYPE_MESSAGE_SET, custom);
#line 725 "imap-message-set.c"
}

GearyImapMessageSet*
geary_imap_message_set_construct_uid_custom (GType object_type,
                                             const gchar* custom)
{
	GearyImapMessageSet * self = NULL;
#line 108 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (custom != NULL, NULL);
#line 108 "../src/engine/imap/command/imap-message-set.vala"
	self = (GearyImapMessageSet*) geary_base_object_construct (object_type);
#line 109 "../src/engine/imap/command/imap-message-set.vala"
	geary_imap_message_set_set_value (self, custom);
#line 110 "../src/engine/imap/command/imap-message-set.vala"
	geary_imap_message_set_set_is_uid (self, TRUE);
#line 108 "../src/engine/imap/command/imap-message-set.vala"
	return self;
#line 743 "imap-message-set.c"
}

GearyImapMessageSet*
geary_imap_message_set_new_uid_custom (const gchar* custom)
{
#line 108 "../src/engine/imap/command/imap-message-set.vala"
	return geary_imap_message_set_construct_uid_custom (GEARY_IMAP_TYPE_MESSAGE_SET, custom);
#line 751 "imap-message-set.c"
}

/**
     * Parses a string representing a {@link MessageSet} into a List of {@link SequenceNumber}s.
     *
     * See the note at {@link uid_parse} about limitations of this method.
     *
     * Returns null if the string or parsed set is empty.
     *
     * @see uid_parse
     */
static Block29Data*
block29_data_ref (Block29Data* _data29_)
{
#line 122 "../src/engine/imap/command/imap-message-set.vala"
	g_atomic_int_inc (&_data29_->_ref_count_);
#line 122 "../src/engine/imap/command/imap-message-set.vala"
	return _data29_;
#line 770 "imap-message-set.c"
}

static void
block29_data_unref (void * _userdata_)
{
	Block29Data* _data29_;
	_data29_ = (Block29Data*) _userdata_;
#line 122 "../src/engine/imap/command/imap-message-set.vala"
	if (g_atomic_int_dec_and_test (&_data29_->_ref_count_)) {
#line 122 "../src/engine/imap/command/imap-message-set.vala"
		_g_object_unref0 (_data29_->seq_nums);
#line 122 "../src/engine/imap/command/imap-message-set.vala"
		g_slice_free (Block29Data, _data29_);
#line 784 "imap-message-set.c"
	}
}

static void
__lambda42_ (Block29Data* _data29_,
             gint64 value,
             GError** error)
{
	GearyImapSequenceNumber* _tmp0_ = NULL;
	GearyImapSequenceNumber* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 124 "../src/engine/imap/command/imap-message-set.vala"
	_tmp1_ = geary_imap_sequence_number_new_checked (value, &_inner_error0_);
#line 124 "../src/engine/imap/command/imap-message-set.vala"
	_tmp0_ = _tmp1_;
#line 124 "../src/engine/imap/command/imap-message-set.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 124 "../src/engine/imap/command/imap-message-set.vala"
		if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 124 "../src/engine/imap/command/imap-message-set.vala"
			g_propagate_error (error, _inner_error0_);
#line 124 "../src/engine/imap/command/imap-message-set.vala"
			return;
#line 808 "imap-message-set.c"
		} else {
#line 124 "../src/engine/imap/command/imap-message-set.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 124 "../src/engine/imap/command/imap-message-set.vala"
			g_clear_error (&_inner_error0_);
#line 124 "../src/engine/imap/command/imap-message-set.vala"
			return;
#line 816 "imap-message-set.c"
		}
	}
#line 124 "../src/engine/imap/command/imap-message-set.vala"
	gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data29_->seq_nums, GEE_TYPE_COLLECTION, GeeCollection), _tmp0_);
#line 124 "../src/engine/imap/command/imap-message-set.vala"
	_g_object_unref0 (_tmp0_);
#line 823 "imap-message-set.c"
}

static void
___lambda42__geary_imap_message_set_parser_callback (gint64 value,
                                                     gpointer self,
                                                     GError** error)
{
#line 124 "../src/engine/imap/command/imap-message-set.vala"
	__lambda42_ (self, value, error);
#line 833 "imap-message-set.c"
}

GeeList*
geary_imap_message_set_parse (const gchar* str,
                              GError** error)
{
	Block29Data* _data29_;
	GeeArrayList* _tmp0_;
	GeeList* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	GeeList* _tmp4_;
	GError* _inner_error0_ = NULL;
	GeeList* result;
#line 122 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 122 "../src/engine/imap/command/imap-message-set.vala"
	_data29_ = g_slice_new0 (Block29Data);
#line 122 "../src/engine/imap/command/imap-message-set.vala"
	_data29_->_ref_count_ = 1;
#line 123 "../src/engine/imap/command/imap-message-set.vala"
	_tmp0_ = gee_array_list_new (GEARY_IMAP_TYPE_SEQUENCE_NUMBER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 123 "../src/engine/imap/command/imap-message-set.vala"
	_data29_->seq_nums = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_LIST, GeeList);
#line 124 "../src/engine/imap/command/imap-message-set.vala"
	geary_imap_message_set_parse_string (str, ___lambda42__geary_imap_message_set_parser_callback, _data29_, &_inner_error0_);
#line 124 "../src/engine/imap/command/imap-message-set.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 124 "../src/engine/imap/command/imap-message-set.vala"
		if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 124 "../src/engine/imap/command/imap-message-set.vala"
			g_propagate_error (error, _inner_error0_);
#line 124 "../src/engine/imap/command/imap-message-set.vala"
			block29_data_unref (_data29_);
#line 124 "../src/engine/imap/command/imap-message-set.vala"
			_data29_ = NULL;
#line 124 "../src/engine/imap/command/imap-message-set.vala"
			return NULL;
#line 872 "imap-message-set.c"
		} else {
#line 124 "../src/engine/imap/command/imap-message-set.vala"
			block29_data_unref (_data29_);
#line 124 "../src/engine/imap/command/imap-message-set.vala"
			_data29_ = NULL;
#line 124 "../src/engine/imap/command/imap-message-set.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 124 "../src/engine/imap/command/imap-message-set.vala"
			g_clear_error (&_inner_error0_);
#line 124 "../src/engine/imap/command/imap-message-set.vala"
			return NULL;
#line 884 "imap-message-set.c"
		}
	}
#line 126 "../src/engine/imap/command/imap-message-set.vala"
	_tmp2_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data29_->seq_nums, GEE_TYPE_COLLECTION, GeeCollection));
#line 126 "../src/engine/imap/command/imap-message-set.vala"
	_tmp3_ = _tmp2_;
#line 126 "../src/engine/imap/command/imap-message-set.vala"
	if (_tmp3_ > 0) {
#line 126 "../src/engine/imap/command/imap-message-set.vala"
		_tmp1_ = _data29_->seq_nums;
#line 895 "imap-message-set.c"
	} else {
#line 126 "../src/engine/imap/command/imap-message-set.vala"
		_tmp1_ = NULL;
#line 899 "imap-message-set.c"
	}
#line 126 "../src/engine/imap/command/imap-message-set.vala"
	_tmp4_ = _g_object_ref0 (_tmp1_);
#line 126 "../src/engine/imap/command/imap-message-set.vala"
	result = _tmp4_;
#line 126 "../src/engine/imap/command/imap-message-set.vala"
	block29_data_unref (_data29_);
#line 126 "../src/engine/imap/command/imap-message-set.vala"
	_data29_ = NULL;
#line 126 "../src/engine/imap/command/imap-message-set.vala"
	return result;
#line 911 "imap-message-set.c"
}

/**
     * Parses a string representing a {@link MessageSet} into a List of {@link UID}s.
     *
     * Note that this is currently designed for parsing message set responses from the server,
     * specifically for COPYUID, which has some limitations in what may be returned.  Notably, the
     * asterisk ("*") symbol may not be returned.  Thus, this method does not properly parse
     * the full range of message set notation and can't even be trusted to reverse-parse the output
     * of this class.  A full implementation might be considered later.
     *
     * Because COPYUID returns values in the order copied, this method returns a List, not a Set,
     * of values.  They are in the order received (and properly deal with ranges in backwards
     * order, i.e. "12:10").  This means duplicates may be encountered multiple times if the server
     * returns those values.
     *
     * Returns null if the string or parsed set is empty.
     */
static Block30Data*
block30_data_ref (Block30Data* _data30_)
{
#line 145 "../src/engine/imap/command/imap-message-set.vala"
	g_atomic_int_inc (&_data30_->_ref_count_);
#line 145 "../src/engine/imap/command/imap-message-set.vala"
	return _data30_;
#line 937 "imap-message-set.c"
}

static void
block30_data_unref (void * _userdata_)
{
	Block30Data* _data30_;
	_data30_ = (Block30Data*) _userdata_;
#line 145 "../src/engine/imap/command/imap-message-set.vala"
	if (g_atomic_int_dec_and_test (&_data30_->_ref_count_)) {
#line 145 "../src/engine/imap/command/imap-message-set.vala"
		_g_object_unref0 (_data30_->uids);
#line 145 "../src/engine/imap/command/imap-message-set.vala"
		g_slice_free (Block30Data, _data30_);
#line 951 "imap-message-set.c"
	}
}

static void
__lambda43_ (Block30Data* _data30_,
             gint64 value,
             GError** error)
{
	GearyImapUID* _tmp0_ = NULL;
	GearyImapUID* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 147 "../src/engine/imap/command/imap-message-set.vala"
	_tmp1_ = geary_imap_uid_new_checked (value, &_inner_error0_);
#line 147 "../src/engine/imap/command/imap-message-set.vala"
	_tmp0_ = _tmp1_;
#line 147 "../src/engine/imap/command/imap-message-set.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 147 "../src/engine/imap/command/imap-message-set.vala"
		if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 147 "../src/engine/imap/command/imap-message-set.vala"
			g_propagate_error (error, _inner_error0_);
#line 147 "../src/engine/imap/command/imap-message-set.vala"
			return;
#line 975 "imap-message-set.c"
		} else {
#line 147 "../src/engine/imap/command/imap-message-set.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 147 "../src/engine/imap/command/imap-message-set.vala"
			g_clear_error (&_inner_error0_);
#line 147 "../src/engine/imap/command/imap-message-set.vala"
			return;
#line 983 "imap-message-set.c"
		}
	}
#line 147 "../src/engine/imap/command/imap-message-set.vala"
	gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data30_->uids, GEE_TYPE_COLLECTION, GeeCollection), _tmp0_);
#line 147 "../src/engine/imap/command/imap-message-set.vala"
	_g_object_unref0 (_tmp0_);
#line 990 "imap-message-set.c"
}

static void
___lambda43__geary_imap_message_set_parser_callback (gint64 value,
                                                     gpointer self,
                                                     GError** error)
{
#line 147 "../src/engine/imap/command/imap-message-set.vala"
	__lambda43_ (self, value, error);
#line 1000 "imap-message-set.c"
}

GeeList*
geary_imap_message_set_uid_parse (const gchar* str,
                                  GError** error)
{
	Block30Data* _data30_;
	GeeArrayList* _tmp0_;
	GeeList* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	GeeList* _tmp4_;
	GError* _inner_error0_ = NULL;
	GeeList* result;
#line 145 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 145 "../src/engine/imap/command/imap-message-set.vala"
	_data30_ = g_slice_new0 (Block30Data);
#line 145 "../src/engine/imap/command/imap-message-set.vala"
	_data30_->_ref_count_ = 1;
#line 146 "../src/engine/imap/command/imap-message-set.vala"
	_tmp0_ = gee_array_list_new (GEARY_IMAP_TYPE_UID, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 146 "../src/engine/imap/command/imap-message-set.vala"
	_data30_->uids = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_LIST, GeeList);
#line 147 "../src/engine/imap/command/imap-message-set.vala"
	geary_imap_message_set_parse_string (str, ___lambda43__geary_imap_message_set_parser_callback, _data30_, &_inner_error0_);
#line 147 "../src/engine/imap/command/imap-message-set.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 147 "../src/engine/imap/command/imap-message-set.vala"
		if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 147 "../src/engine/imap/command/imap-message-set.vala"
			g_propagate_error (error, _inner_error0_);
#line 147 "../src/engine/imap/command/imap-message-set.vala"
			block30_data_unref (_data30_);
#line 147 "../src/engine/imap/command/imap-message-set.vala"
			_data30_ = NULL;
#line 147 "../src/engine/imap/command/imap-message-set.vala"
			return NULL;
#line 1039 "imap-message-set.c"
		} else {
#line 147 "../src/engine/imap/command/imap-message-set.vala"
			block30_data_unref (_data30_);
#line 147 "../src/engine/imap/command/imap-message-set.vala"
			_data30_ = NULL;
#line 147 "../src/engine/imap/command/imap-message-set.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 147 "../src/engine/imap/command/imap-message-set.vala"
			g_clear_error (&_inner_error0_);
#line 147 "../src/engine/imap/command/imap-message-set.vala"
			return NULL;
#line 1051 "imap-message-set.c"
		}
	}
#line 149 "../src/engine/imap/command/imap-message-set.vala"
	_tmp2_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data30_->uids, GEE_TYPE_COLLECTION, GeeCollection));
#line 149 "../src/engine/imap/command/imap-message-set.vala"
	_tmp3_ = _tmp2_;
#line 149 "../src/engine/imap/command/imap-message-set.vala"
	if (_tmp3_ > 0) {
#line 149 "../src/engine/imap/command/imap-message-set.vala"
		_tmp1_ = _data30_->uids;
#line 1062 "imap-message-set.c"
	} else {
#line 149 "../src/engine/imap/command/imap-message-set.vala"
		_tmp1_ = NULL;
#line 1066 "imap-message-set.c"
	}
#line 149 "../src/engine/imap/command/imap-message-set.vala"
	_tmp4_ = _g_object_ref0 (_tmp1_);
#line 149 "../src/engine/imap/command/imap-message-set.vala"
	result = _tmp4_;
#line 149 "../src/engine/imap/command/imap-message-set.vala"
	block30_data_unref (_data30_);
#line 149 "../src/engine/imap/command/imap-message-set.vala"
	_data30_ = NULL;
#line 149 "../src/engine/imap/command/imap-message-set.vala"
	return result;
#line 1078 "imap-message-set.c"
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1302 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1303 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1304 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 1094 "imap-message-set.c"
		gchar* _tmp0_;
#line 1305 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1305 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1306 "glib-2.0.vapi"
		result = TRUE;
#line 1306 "glib-2.0.vapi"
		if (c) {
#line 1306 "glib-2.0.vapi"
			*c = _vala_c;
#line 1106 "imap-message-set.c"
		}
#line 1306 "glib-2.0.vapi"
		return result;
#line 1110 "imap-message-set.c"
	} else {
#line 1308 "glib-2.0.vapi"
		result = FALSE;
#line 1308 "glib-2.0.vapi"
		if (c) {
#line 1308 "glib-2.0.vapi"
			*c = _vala_c;
#line 1118 "imap-message-set.c"
		}
#line 1308 "glib-2.0.vapi"
		return result;
#line 1122 "imap-message-set.c"
	}
}

static gint64
int64_parse (const gchar* str,
             guint _base)
{
	gint64 result;
#line 778 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 779 "glib-2.0.vapi"
	result = g_ascii_strtoll (str, NULL, _base);
#line 779 "glib-2.0.vapi"
	return result;
#line 1137 "imap-message-set.c"
}

static gchar*
g_unichar_to_string (gunichar self)
{
	gchar* str = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1122 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, 7);
#line 1122 "glib-2.0.vapi"
	str = (gchar*) _tmp0_;
#line 1123 "glib-2.0.vapi"
	g_unichar_to_utf8 (self, str);
#line 1124 "glib-2.0.vapi"
	result = str;
#line 1124 "glib-2.0.vapi"
	return result;
#line 1156 "imap-message-set.c"
}

static void
geary_imap_message_set_parse_string (const gchar* str,
                                     GearyImapMessageSetParserCallback cb,
                                     gpointer cb_target,
                                     GError** error)
{
	GString* acc = NULL;
	GString* _tmp0_;
	gint64 start_range = 0LL;
	gboolean in_range = FALSE;
	gunichar ch = 0U;
	gint index = 0;
	GString* _tmp22_;
	const gchar* _tmp23_;
	GError* _inner_error0_ = NULL;
#line 152 "../src/engine/imap/command/imap-message-set.vala"
	g_return_if_fail (str != NULL);
#line 153 "../src/engine/imap/command/imap-message-set.vala"
	_tmp0_ = g_string_new ("");
#line 153 "../src/engine/imap/command/imap-message-set.vala"
	acc = _tmp0_;
#line 154 "../src/engine/imap/command/imap-message-set.vala"
	start_range = (gint64) -1;
#line 155 "../src/engine/imap/command/imap-message-set.vala"
	in_range = FALSE;
#line 158 "../src/engine/imap/command/imap-message-set.vala"
	index = 0;
#line 159 "../src/engine/imap/command/imap-message-set.vala"
	while (TRUE) {
#line 1188 "imap-message-set.c"
		gunichar _tmp1_ = 0U;
		gboolean _tmp2_;
#line 159 "../src/engine/imap/command/imap-message-set.vala"
		_tmp2_ = string_get_next_char (str, &index, &_tmp1_);
#line 159 "../src/engine/imap/command/imap-message-set.vala"
		ch = _tmp1_;
#line 159 "../src/engine/imap/command/imap-message-set.vala"
		if (!_tmp2_) {
#line 159 "../src/engine/imap/command/imap-message-set.vala"
			break;
#line 1199 "imap-message-set.c"
		}
#line 161 "../src/engine/imap/command/imap-message-set.vala"
		if (g_unichar_isdigit (ch)) {
#line 1203 "imap-message-set.c"
			GString* _tmp3_;
#line 162 "../src/engine/imap/command/imap-message-set.vala"
			_tmp3_ = acc;
#line 162 "../src/engine/imap/command/imap-message-set.vala"
			g_string_append_unichar (_tmp3_, ch);
#line 164 "../src/engine/imap/command/imap-message-set.vala"
			continue;
#line 1211 "imap-message-set.c"
		}
#line 168 "../src/engine/imap/command/imap-message-set.vala"
		switch (ch) {
#line 168 "../src/engine/imap/command/imap-message-set.vala"
			case ':':
#line 1217 "imap-message-set.c"
			{
				GString* _tmp5_;
				const gchar* _tmp6_;
				GString* _tmp7_;
#line 171 "../src/engine/imap/command/imap-message-set.vala"
				if (in_range) {
#line 1224 "imap-message-set.c"
					GError* _tmp4_;
#line 172 "../src/engine/imap/command/imap-message-set.vala"
					_tmp4_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_INVALID, "Bad range specifier in message set \"%s\"", str);
#line 172 "../src/engine/imap/command/imap-message-set.vala"
					_inner_error0_ = _tmp4_;
#line 172 "../src/engine/imap/command/imap-message-set.vala"
					if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 172 "../src/engine/imap/command/imap-message-set.vala"
						g_propagate_error (error, _inner_error0_);
#line 172 "../src/engine/imap/command/imap-message-set.vala"
						_g_string_free0 (acc);
#line 172 "../src/engine/imap/command/imap-message-set.vala"
						return;
#line 1238 "imap-message-set.c"
					} else {
#line 172 "../src/engine/imap/command/imap-message-set.vala"
						_g_string_free0 (acc);
#line 172 "../src/engine/imap/command/imap-message-set.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 172 "../src/engine/imap/command/imap-message-set.vala"
						g_clear_error (&_inner_error0_);
#line 172 "../src/engine/imap/command/imap-message-set.vala"
						return;
#line 1248 "imap-message-set.c"
					}
				}
#line 174 "../src/engine/imap/command/imap-message-set.vala"
				in_range = TRUE;
#line 177 "../src/engine/imap/command/imap-message-set.vala"
				_tmp5_ = acc;
#line 177 "../src/engine/imap/command/imap-message-set.vala"
				_tmp6_ = _tmp5_->str;
#line 177 "../src/engine/imap/command/imap-message-set.vala"
				start_range = int64_parse (_tmp6_, (guint) 0);
#line 178 "../src/engine/imap/command/imap-message-set.vala"
				_tmp7_ = g_string_new ("");
#line 178 "../src/engine/imap/command/imap-message-set.vala"
				_g_string_free0 (acc);
#line 178 "../src/engine/imap/command/imap-message-set.vala"
				acc = _tmp7_;
#line 179 "../src/engine/imap/command/imap-message-set.vala"
				break;
#line 1267 "imap-message-set.c"
			}
#line 168 "../src/engine/imap/command/imap-message-set.vala"
			case ',':
#line 1271 "imap-message-set.c"
			{
				GString* _tmp17_;
#line 185 "../src/engine/imap/command/imap-message-set.vala"
				if (in_range) {
#line 1276 "imap-message-set.c"
					GString* _tmp8_;
					const gchar* _tmp9_;
					GString* _tmp11_;
					const gchar* _tmp12_;
#line 187 "../src/engine/imap/command/imap-message-set.vala"
					_tmp8_ = acc;
#line 187 "../src/engine/imap/command/imap-message-set.vala"
					_tmp9_ = _tmp8_->str;
#line 187 "../src/engine/imap/command/imap-message-set.vala"
					if (geary_string_is_empty (_tmp9_)) {
#line 1287 "imap-message-set.c"
						GError* _tmp10_;
#line 188 "../src/engine/imap/command/imap-message-set.vala"
						_tmp10_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_INVALID, "Bad range specifier in message set \"%s\"", str);
#line 188 "../src/engine/imap/command/imap-message-set.vala"
						_inner_error0_ = _tmp10_;
#line 188 "../src/engine/imap/command/imap-message-set.vala"
						if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 188 "../src/engine/imap/command/imap-message-set.vala"
							g_propagate_error (error, _inner_error0_);
#line 188 "../src/engine/imap/command/imap-message-set.vala"
							_g_string_free0 (acc);
#line 188 "../src/engine/imap/command/imap-message-set.vala"
							return;
#line 1301 "imap-message-set.c"
						} else {
#line 188 "../src/engine/imap/command/imap-message-set.vala"
							_g_string_free0 (acc);
#line 188 "../src/engine/imap/command/imap-message-set.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 188 "../src/engine/imap/command/imap-message-set.vala"
							g_clear_error (&_inner_error0_);
#line 188 "../src/engine/imap/command/imap-message-set.vala"
							return;
#line 1311 "imap-message-set.c"
						}
					}
#line 190 "../src/engine/imap/command/imap-message-set.vala"
					_tmp11_ = acc;
#line 190 "../src/engine/imap/command/imap-message-set.vala"
					_tmp12_ = _tmp11_->str;
#line 190 "../src/engine/imap/command/imap-message-set.vala"
					geary_imap_message_set_process_range (start_range, int64_parse (_tmp12_, (guint) 0), cb, cb_target, &_inner_error0_);
#line 190 "../src/engine/imap/command/imap-message-set.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 190 "../src/engine/imap/command/imap-message-set.vala"
						if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 190 "../src/engine/imap/command/imap-message-set.vala"
							g_propagate_error (error, _inner_error0_);
#line 190 "../src/engine/imap/command/imap-message-set.vala"
							_g_string_free0 (acc);
#line 190 "../src/engine/imap/command/imap-message-set.vala"
							return;
#line 1330 "imap-message-set.c"
						} else {
#line 190 "../src/engine/imap/command/imap-message-set.vala"
							_g_string_free0 (acc);
#line 190 "../src/engine/imap/command/imap-message-set.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 190 "../src/engine/imap/command/imap-message-set.vala"
							g_clear_error (&_inner_error0_);
#line 190 "../src/engine/imap/command/imap-message-set.vala"
							return;
#line 1340 "imap-message-set.c"
						}
					}
#line 191 "../src/engine/imap/command/imap-message-set.vala"
					in_range = FALSE;
#line 1345 "imap-message-set.c"
				} else {
					GString* _tmp13_;
					const gchar* _tmp14_;
					GString* _tmp15_;
					const gchar* _tmp16_;
#line 194 "../src/engine/imap/command/imap-message-set.vala"
					_tmp13_ = acc;
#line 194 "../src/engine/imap/command/imap-message-set.vala"
					_tmp14_ = _tmp13_->str;
#line 194 "../src/engine/imap/command/imap-message-set.vala"
					if (geary_string_is_empty (_tmp14_)) {
#line 195 "../src/engine/imap/command/imap-message-set.vala"
						continue;
#line 1359 "imap-message-set.c"
					}
#line 197 "../src/engine/imap/command/imap-message-set.vala"
					_tmp15_ = acc;
#line 197 "../src/engine/imap/command/imap-message-set.vala"
					_tmp16_ = _tmp15_->str;
#line 197 "../src/engine/imap/command/imap-message-set.vala"
					cb (int64_parse (_tmp16_, (guint) 0), cb_target, &_inner_error0_);
#line 197 "../src/engine/imap/command/imap-message-set.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 197 "../src/engine/imap/command/imap-message-set.vala"
						if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 197 "../src/engine/imap/command/imap-message-set.vala"
							g_propagate_error (error, _inner_error0_);
#line 197 "../src/engine/imap/command/imap-message-set.vala"
							_g_string_free0 (acc);
#line 197 "../src/engine/imap/command/imap-message-set.vala"
							return;
#line 1377 "imap-message-set.c"
						} else {
#line 197 "../src/engine/imap/command/imap-message-set.vala"
							_g_string_free0 (acc);
#line 197 "../src/engine/imap/command/imap-message-set.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 197 "../src/engine/imap/command/imap-message-set.vala"
							g_clear_error (&_inner_error0_);
#line 197 "../src/engine/imap/command/imap-message-set.vala"
							return;
#line 1387 "imap-message-set.c"
						}
					}
				}
#line 201 "../src/engine/imap/command/imap-message-set.vala"
				_tmp17_ = g_string_new ("");
#line 201 "../src/engine/imap/command/imap-message-set.vala"
				_g_string_free0 (acc);
#line 201 "../src/engine/imap/command/imap-message-set.vala"
				acc = _tmp17_;
#line 202 "../src/engine/imap/command/imap-message-set.vala"
				break;
#line 1399 "imap-message-set.c"
			}
			default:
			{
				gchar* _tmp18_;
				gchar* _tmp19_;
				GError* _tmp20_;
				GError* _tmp21_;
#line 206 "../src/engine/imap/command/imap-message-set.vala"
				_tmp18_ = g_unichar_to_string (ch);
#line 206 "../src/engine/imap/command/imap-message-set.vala"
				_tmp19_ = _tmp18_;
#line 206 "../src/engine/imap/command/imap-message-set.vala"
				_tmp20_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_INVALID, "Bad character '%s' in message set \"%s\"", _tmp19_, str);
#line 206 "../src/engine/imap/command/imap-message-set.vala"
				_tmp21_ = _tmp20_;
#line 206 "../src/engine/imap/command/imap-message-set.vala"
				_g_free0 (_tmp19_);
#line 206 "../src/engine/imap/command/imap-message-set.vala"
				_inner_error0_ = _tmp21_;
#line 206 "../src/engine/imap/command/imap-message-set.vala"
				if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 206 "../src/engine/imap/command/imap-message-set.vala"
					g_propagate_error (error, _inner_error0_);
#line 206 "../src/engine/imap/command/imap-message-set.vala"
					_g_string_free0 (acc);
#line 206 "../src/engine/imap/command/imap-message-set.vala"
					return;
#line 1427 "imap-message-set.c"
				} else {
#line 206 "../src/engine/imap/command/imap-message-set.vala"
					_g_string_free0 (acc);
#line 206 "../src/engine/imap/command/imap-message-set.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 206 "../src/engine/imap/command/imap-message-set.vala"
					g_clear_error (&_inner_error0_);
#line 206 "../src/engine/imap/command/imap-message-set.vala"
					return;
#line 1437 "imap-message-set.c"
				}
			}
		}
	}
#line 212 "../src/engine/imap/command/imap-message-set.vala"
	_tmp22_ = acc;
#line 212 "../src/engine/imap/command/imap-message-set.vala"
	_tmp23_ = _tmp22_->str;
#line 212 "../src/engine/imap/command/imap-message-set.vala"
	if (!geary_string_is_empty (_tmp23_)) {
#line 213 "../src/engine/imap/command/imap-message-set.vala"
		if (in_range) {
#line 1450 "imap-message-set.c"
			GString* _tmp24_;
			const gchar* _tmp25_;
#line 214 "../src/engine/imap/command/imap-message-set.vala"
			_tmp24_ = acc;
#line 214 "../src/engine/imap/command/imap-message-set.vala"
			_tmp25_ = _tmp24_->str;
#line 214 "../src/engine/imap/command/imap-message-set.vala"
			geary_imap_message_set_process_range (start_range, int64_parse (_tmp25_, (guint) 0), cb, cb_target, &_inner_error0_);
#line 214 "../src/engine/imap/command/imap-message-set.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 214 "../src/engine/imap/command/imap-message-set.vala"
				if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 214 "../src/engine/imap/command/imap-message-set.vala"
					g_propagate_error (error, _inner_error0_);
#line 214 "../src/engine/imap/command/imap-message-set.vala"
					_g_string_free0 (acc);
#line 214 "../src/engine/imap/command/imap-message-set.vala"
					return;
#line 1469 "imap-message-set.c"
				} else {
#line 214 "../src/engine/imap/command/imap-message-set.vala"
					_g_string_free0 (acc);
#line 214 "../src/engine/imap/command/imap-message-set.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 214 "../src/engine/imap/command/imap-message-set.vala"
					g_clear_error (&_inner_error0_);
#line 214 "../src/engine/imap/command/imap-message-set.vala"
					return;
#line 1479 "imap-message-set.c"
				}
			}
		} else {
			GString* _tmp26_;
			const gchar* _tmp27_;
#line 216 "../src/engine/imap/command/imap-message-set.vala"
			_tmp26_ = acc;
#line 216 "../src/engine/imap/command/imap-message-set.vala"
			_tmp27_ = _tmp26_->str;
#line 216 "../src/engine/imap/command/imap-message-set.vala"
			cb (int64_parse (_tmp27_, (guint) 0), cb_target, &_inner_error0_);
#line 216 "../src/engine/imap/command/imap-message-set.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 216 "../src/engine/imap/command/imap-message-set.vala"
				if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 216 "../src/engine/imap/command/imap-message-set.vala"
					g_propagate_error (error, _inner_error0_);
#line 216 "../src/engine/imap/command/imap-message-set.vala"
					_g_string_free0 (acc);
#line 216 "../src/engine/imap/command/imap-message-set.vala"
					return;
#line 1501 "imap-message-set.c"
				} else {
#line 216 "../src/engine/imap/command/imap-message-set.vala"
					_g_string_free0 (acc);
#line 216 "../src/engine/imap/command/imap-message-set.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 216 "../src/engine/imap/command/imap-message-set.vala"
					g_clear_error (&_inner_error0_);
#line 216 "../src/engine/imap/command/imap-message-set.vala"
					return;
#line 1511 "imap-message-set.c"
				}
			}
		}
	} else {
#line 217 "../src/engine/imap/command/imap-message-set.vala"
		if (in_range) {
#line 1518 "imap-message-set.c"
			GError* _tmp28_;
#line 218 "../src/engine/imap/command/imap-message-set.vala"
			_tmp28_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_INVALID, "Incomplete range specifier in message set \"%s\"", str);
#line 218 "../src/engine/imap/command/imap-message-set.vala"
			_inner_error0_ = _tmp28_;
#line 218 "../src/engine/imap/command/imap-message-set.vala"
			if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 218 "../src/engine/imap/command/imap-message-set.vala"
				g_propagate_error (error, _inner_error0_);
#line 218 "../src/engine/imap/command/imap-message-set.vala"
				_g_string_free0 (acc);
#line 218 "../src/engine/imap/command/imap-message-set.vala"
				return;
#line 1532 "imap-message-set.c"
			} else {
#line 218 "../src/engine/imap/command/imap-message-set.vala"
				_g_string_free0 (acc);
#line 218 "../src/engine/imap/command/imap-message-set.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 218 "../src/engine/imap/command/imap-message-set.vala"
				g_clear_error (&_inner_error0_);
#line 218 "../src/engine/imap/command/imap-message-set.vala"
				return;
#line 1542 "imap-message-set.c"
			}
		}
	}
#line 152 "../src/engine/imap/command/imap-message-set.vala"
	_g_string_free0 (acc);
#line 1548 "imap-message-set.c"
}

static void
geary_imap_message_set_process_range (gint64 start,
                                      gint64 end,
                                      GearyImapMessageSetParserCallback cb,
                                      gpointer cb_target,
                                      GError** error)
{
	gint _tmp0_ = 0;
	gint64 count_by = 0LL;
	GError* _inner_error0_ = NULL;
#line 223 "../src/engine/imap/command/imap-message-set.vala"
	if (start <= end) {
#line 223 "../src/engine/imap/command/imap-message-set.vala"
		_tmp0_ = 1;
#line 1565 "imap-message-set.c"
	} else {
#line 223 "../src/engine/imap/command/imap-message-set.vala"
		_tmp0_ = -1;
#line 1569 "imap-message-set.c"
	}
#line 223 "../src/engine/imap/command/imap-message-set.vala"
	count_by = (gint64) _tmp0_;
#line 1573 "imap-message-set.c"
	{
		gint64 ctr = 0LL;
#line 224 "../src/engine/imap/command/imap-message-set.vala"
		ctr = start;
#line 1578 "imap-message-set.c"
		{
			gboolean _tmp1_ = FALSE;
#line 224 "../src/engine/imap/command/imap-message-set.vala"
			_tmp1_ = TRUE;
#line 224 "../src/engine/imap/command/imap-message-set.vala"
			while (TRUE) {
#line 224 "../src/engine/imap/command/imap-message-set.vala"
				if (!_tmp1_) {
#line 224 "../src/engine/imap/command/imap-message-set.vala"
					ctr += count_by;
#line 1589 "imap-message-set.c"
				}
#line 224 "../src/engine/imap/command/imap-message-set.vala"
				_tmp1_ = FALSE;
#line 224 "../src/engine/imap/command/imap-message-set.vala"
				if (!(ctr != (end + count_by))) {
#line 224 "../src/engine/imap/command/imap-message-set.vala"
					break;
#line 1597 "imap-message-set.c"
				}
#line 225 "../src/engine/imap/command/imap-message-set.vala"
				cb (ctr, cb_target, &_inner_error0_);
#line 225 "../src/engine/imap/command/imap-message-set.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 225 "../src/engine/imap/command/imap-message-set.vala"
					if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 225 "../src/engine/imap/command/imap-message-set.vala"
						g_propagate_error (error, _inner_error0_);
#line 225 "../src/engine/imap/command/imap-message-set.vala"
						return;
#line 1609 "imap-message-set.c"
					} else {
#line 225 "../src/engine/imap/command/imap-message-set.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 225 "../src/engine/imap/command/imap-message-set.vala"
						g_clear_error (&_inner_error0_);
#line 225 "../src/engine/imap/command/imap-message-set.vala"
						return;
#line 1617 "imap-message-set.c"
					}
				}
			}
		}
	}
}

/**
     * Convert a collection of {@link SequenceNumber}s into a list of {@link MessageSet}s.
     *
     * Although this could return a single MessageSet, large collections could create an IMAP
     * command beyond the server maximum, and so they will be broken up into multiple sets.
     */
GeeList*
geary_imap_message_set_sparse (GeeCollection* seq_nums)
{
	gint _tmp0_ = 0;
	gint64* _tmp1_;
	gint64* _tmp2_;
	gint _tmp2__length1;
	GeeList* _tmp3_;
	GeeList* _tmp4_;
	GeeList* result;
#line 234 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (seq_nums, GEE_TYPE_COLLECTION), NULL);
#line 235 "../src/engine/imap/command/imap-message-set.vala"
	_tmp1_ = geary_imap_message_set_seq_array_to_int64 (seq_nums, &_tmp0_);
#line 235 "../src/engine/imap/command/imap-message-set.vala"
	_tmp2_ = _tmp1_;
#line 235 "../src/engine/imap/command/imap-message-set.vala"
	_tmp2__length1 = _tmp0_;
#line 235 "../src/engine/imap/command/imap-message-set.vala"
	_tmp3_ = geary_imap_message_set_build_sparse_sets (_tmp2_, (gint) _tmp0_, FALSE);
#line 235 "../src/engine/imap/command/imap-message-set.vala"
	_tmp4_ = _tmp3_;
#line 235 "../src/engine/imap/command/imap-message-set.vala"
	_tmp2_ = (g_free (_tmp2_), NULL);
#line 235 "../src/engine/imap/command/imap-message-set.vala"
	result = _tmp4_;
#line 235 "../src/engine/imap/command/imap-message-set.vala"
	return result;
#line 1659 "imap-message-set.c"
}

/**
     * Convert a collection of {@link UID}s into a list of {@link MessageSet}s.
     *
     * Although this could return a single MessageSet, large collections could create an IMAP
     * command beyond the server maximum, and so they will be broken up into multiple sets.
     */
GeeList*
geary_imap_message_set_uid_sparse (GeeCollection* msg_uids)
{
	gint _tmp0_ = 0;
	gint64* _tmp1_;
	gint64* _tmp2_;
	gint _tmp2__length1;
	GeeList* _tmp3_;
	GeeList* _tmp4_;
	GeeList* result;
#line 244 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (msg_uids, GEE_TYPE_COLLECTION), NULL);
#line 245 "../src/engine/imap/command/imap-message-set.vala"
	_tmp1_ = geary_imap_message_set_uid_array_to_int64 (msg_uids, &_tmp0_);
#line 245 "../src/engine/imap/command/imap-message-set.vala"
	_tmp2_ = _tmp1_;
#line 245 "../src/engine/imap/command/imap-message-set.vala"
	_tmp2__length1 = _tmp0_;
#line 245 "../src/engine/imap/command/imap-message-set.vala"
	_tmp3_ = geary_imap_message_set_build_sparse_sets (_tmp2_, (gint) _tmp0_, TRUE);
#line 245 "../src/engine/imap/command/imap-message-set.vala"
	_tmp4_ = _tmp3_;
#line 245 "../src/engine/imap/command/imap-message-set.vala"
	_tmp2_ = (g_free (_tmp2_), NULL);
#line 245 "../src/engine/imap/command/imap-message-set.vala"
	result = _tmp4_;
#line 245 "../src/engine/imap/command/imap-message-set.vala"
	return result;
#line 1696 "imap-message-set.c"
}

static GeeList*
geary_imap_message_set_build_sparse_sets (gint64* sorted,
                                          gint sorted_length1,
                                          gboolean is_uid)
{
	GeeList* list = NULL;
	GeeArrayList* _tmp0_;
	gint start = 0;
	GeeList* result;
#line 251 "../src/engine/imap/command/imap-message-set.vala"
	_tmp0_ = gee_array_list_new (GEARY_IMAP_TYPE_MESSAGE_SET, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 251 "../src/engine/imap/command/imap-message-set.vala"
	list = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_LIST, GeeList);
#line 253 "../src/engine/imap/command/imap-message-set.vala"
	start = 0;
#line 1714 "imap-message-set.c"
	{
		gboolean _tmp1_ = FALSE;
#line 254 "../src/engine/imap/command/imap-message-set.vala"
		_tmp1_ = TRUE;
#line 254 "../src/engine/imap/command/imap-message-set.vala"
		while (TRUE) {
#line 1721 "imap-message-set.c"
			gint end = 0;
			gint64* slice = NULL;
			gint slice_length1;
			gint _slice_size_;
			gchar* sparse_range = NULL;
			gint64* _tmp2_;
			gint _tmp2__length1;
			gchar* _tmp3_;
			GearyImapMessageSet* _tmp4_ = NULL;
			GeeList* _tmp9_;
#line 254 "../src/engine/imap/command/imap-message-set.vala"
			if (!_tmp1_) {
#line 1734 "imap-message-set.c"
			}
#line 254 "../src/engine/imap/command/imap-message-set.vala"
			_tmp1_ = FALSE;
#line 255 "../src/engine/imap/command/imap-message-set.vala"
			if (start >= sorted_length1) {
#line 256 "../src/engine/imap/command/imap-message-set.vala"
				break;
#line 1742 "imap-message-set.c"
			}
#line 258 "../src/engine/imap/command/imap-message-set.vala"
			end = CLAMP (start + GEARY_IMAP_MESSAGE_SET_MAX_SPARSE_VALUES_PER_SET, 0, sorted_length1);
#line 259 "../src/engine/imap/command/imap-message-set.vala"
			slice = sorted + start;
#line 259 "../src/engine/imap/command/imap-message-set.vala"
			slice_length1 = end - start;
#line 259 "../src/engine/imap/command/imap-message-set.vala"
			_slice_size_ = slice_length1;
#line 261 "../src/engine/imap/command/imap-message-set.vala"
			_tmp2_ = slice;
#line 261 "../src/engine/imap/command/imap-message-set.vala"
			_tmp2__length1 = slice_length1;
#line 261 "../src/engine/imap/command/imap-message-set.vala"
			_tmp3_ = geary_imap_message_set_build_sparse_range (_tmp2_, (gint) _tmp2__length1);
#line 261 "../src/engine/imap/command/imap-message-set.vala"
			sparse_range = _tmp3_;
#line 262 "../src/engine/imap/command/imap-message-set.vala"
			if (is_uid) {
#line 1762 "imap-message-set.c"
				const gchar* _tmp5_;
				GearyImapMessageSet* _tmp6_;
#line 262 "../src/engine/imap/command/imap-message-set.vala"
				_tmp5_ = sparse_range;
#line 262 "../src/engine/imap/command/imap-message-set.vala"
				_tmp6_ = geary_imap_message_set_new_uid_custom (_tmp5_);
#line 262 "../src/engine/imap/command/imap-message-set.vala"
				_g_object_unref0 (_tmp4_);
#line 262 "../src/engine/imap/command/imap-message-set.vala"
				_tmp4_ = _tmp6_;
#line 1773 "imap-message-set.c"
			} else {
				const gchar* _tmp7_;
				GearyImapMessageSet* _tmp8_;
#line 262 "../src/engine/imap/command/imap-message-set.vala"
				_tmp7_ = sparse_range;
#line 262 "../src/engine/imap/command/imap-message-set.vala"
				_tmp8_ = geary_imap_message_set_new_custom (_tmp7_);
#line 262 "../src/engine/imap/command/imap-message-set.vala"
				_g_object_unref0 (_tmp4_);
#line 262 "../src/engine/imap/command/imap-message-set.vala"
				_tmp4_ = _tmp8_;
#line 1785 "imap-message-set.c"
			}
#line 262 "../src/engine/imap/command/imap-message-set.vala"
			_tmp9_ = list;
#line 262 "../src/engine/imap/command/imap-message-set.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_COLLECTION, GeeCollection), _tmp4_);
#line 264 "../src/engine/imap/command/imap-message-set.vala"
			start = end;
#line 254 "../src/engine/imap/command/imap-message-set.vala"
			_g_object_unref0 (_tmp4_);
#line 254 "../src/engine/imap/command/imap-message-set.vala"
			_g_free0 (sparse_range);
#line 1797 "imap-message-set.c"
		}
	}
#line 267 "../src/engine/imap/command/imap-message-set.vala"
	result = list;
#line 267 "../src/engine/imap/command/imap-message-set.vala"
	return result;
#line 1804 "imap-message-set.c"
}

static gchar*
geary_imap_message_set_build_sparse_range (gint64* seq_nums,
                                           gint seq_nums_length1)
{
	gint64 start_of_span = 0LL;
	gint64 last_seq_num = 0LL;
	gint span_count = 0;
	GString* builder = NULL;
	GString* _tmp0_;
	GString* _tmp24_;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* result;
#line 273 "../src/engine/imap/command/imap-message-set.vala"
	_vala_assert (seq_nums_length1 > 0, "seq_nums.length > 0");
#line 275 "../src/engine/imap/command/imap-message-set.vala"
	start_of_span = (gint64) -1;
#line 276 "../src/engine/imap/command/imap-message-set.vala"
	last_seq_num = (gint64) -1;
#line 277 "../src/engine/imap/command/imap-message-set.vala"
	span_count = 0;
#line 278 "../src/engine/imap/command/imap-message-set.vala"
	_tmp0_ = g_string_new ("");
#line 278 "../src/engine/imap/command/imap-message-set.vala"
	builder = _tmp0_;
#line 1832 "imap-message-set.c"
	{
		gint64* seq_num_collection = NULL;
		gint seq_num_collection_length1 = 0;
		gint _seq_num_collection_size_ = 0;
		gint seq_num_it = 0;
#line 279 "../src/engine/imap/command/imap-message-set.vala"
		seq_num_collection = seq_nums;
#line 279 "../src/engine/imap/command/imap-message-set.vala"
		seq_num_collection_length1 = seq_nums_length1;
#line 279 "../src/engine/imap/command/imap-message-set.vala"
		for (seq_num_it = 0; seq_num_it < seq_num_collection_length1; seq_num_it = seq_num_it + 1) {
#line 1844 "imap-message-set.c"
			gint64 seq_num = 0LL;
#line 279 "../src/engine/imap/command/imap-message-set.vala"
			seq_num = seq_num_collection[seq_num_it];
#line 1848 "imap-message-set.c"
			{
#line 280 "../src/engine/imap/command/imap-message-set.vala"
				_vala_assert (seq_num >= ((gint64) 0), "seq_num >= 0");
#line 285 "../src/engine/imap/command/imap-message-set.vala"
				if (start_of_span < ((gint64) 0)) {
#line 1854 "imap-message-set.c"
					GString* _tmp1_;
					gchar* _tmp2_;
					gchar* _tmp3_;
#line 287 "../src/engine/imap/command/imap-message-set.vala"
					_tmp1_ = builder;
#line 287 "../src/engine/imap/command/imap-message-set.vala"
					_tmp2_ = g_strdup_printf ("%" G_GINT64_FORMAT, seq_num);
#line 287 "../src/engine/imap/command/imap-message-set.vala"
					_tmp3_ = _tmp2_;
#line 287 "../src/engine/imap/command/imap-message-set.vala"
					g_string_append (_tmp1_, _tmp3_);
#line 287 "../src/engine/imap/command/imap-message-set.vala"
					_g_free0 (_tmp3_);
#line 289 "../src/engine/imap/command/imap-message-set.vala"
					start_of_span = seq_num;
#line 290 "../src/engine/imap/command/imap-message-set.vala"
					span_count = 1;
#line 1872 "imap-message-set.c"
				} else {
#line 291 "../src/engine/imap/command/imap-message-set.vala"
					if ((start_of_span + span_count) == seq_num) {
#line 1876 "imap-message-set.c"
						gint _tmp4_;
#line 293 "../src/engine/imap/command/imap-message-set.vala"
						_tmp4_ = span_count;
#line 293 "../src/engine/imap/command/imap-message-set.vala"
						span_count = _tmp4_ + 1;
#line 1882 "imap-message-set.c"
					} else {
#line 295 "../src/engine/imap/command/imap-message-set.vala"
						_vala_assert (span_count >= 1, "span_count >= 1");
#line 298 "../src/engine/imap/command/imap-message-set.vala"
						if (span_count == 1) {
#line 1888 "imap-message-set.c"
							GString* _tmp5_;
							gchar* _tmp6_;
							gchar* _tmp7_;
#line 299 "../src/engine/imap/command/imap-message-set.vala"
							_tmp5_ = builder;
#line 299 "../src/engine/imap/command/imap-message-set.vala"
							_tmp6_ = g_strdup_printf ("%" G_GINT64_FORMAT, seq_num);
#line 299 "../src/engine/imap/command/imap-message-set.vala"
							_tmp7_ = _tmp6_;
#line 299 "../src/engine/imap/command/imap-message-set.vala"
							g_string_append_printf (_tmp5_, ",%s", _tmp7_);
#line 299 "../src/engine/imap/command/imap-message-set.vala"
							_g_free0 (_tmp7_);
#line 1902 "imap-message-set.c"
						} else {
#line 300 "../src/engine/imap/command/imap-message-set.vala"
							if (span_count == 2) {
#line 1906 "imap-message-set.c"
								GString* _tmp8_;
								gchar* _tmp9_;
								gchar* _tmp10_;
								gchar* _tmp11_;
								gchar* _tmp12_;
#line 301 "../src/engine/imap/command/imap-message-set.vala"
								_tmp8_ = builder;
#line 301 "../src/engine/imap/command/imap-message-set.vala"
								_tmp9_ = g_strdup_printf ("%" G_GINT64_FORMAT, start_of_span + 1);
#line 301 "../src/engine/imap/command/imap-message-set.vala"
								_tmp10_ = _tmp9_;
#line 301 "../src/engine/imap/command/imap-message-set.vala"
								_tmp11_ = g_strdup_printf ("%" G_GINT64_FORMAT, seq_num);
#line 301 "../src/engine/imap/command/imap-message-set.vala"
								_tmp12_ = _tmp11_;
#line 301 "../src/engine/imap/command/imap-message-set.vala"
								g_string_append_printf (_tmp8_, ",%s,%s", _tmp10_, _tmp12_);
#line 301 "../src/engine/imap/command/imap-message-set.vala"
								_g_free0 (_tmp12_);
#line 301 "../src/engine/imap/command/imap-message-set.vala"
								_g_free0 (_tmp10_);
#line 1928 "imap-message-set.c"
							} else {
								GString* _tmp13_;
								gchar* _tmp14_;
								gchar* _tmp15_;
								gchar* _tmp16_;
								gchar* _tmp17_;
#line 304 "../src/engine/imap/command/imap-message-set.vala"
								_tmp13_ = builder;
#line 304 "../src/engine/imap/command/imap-message-set.vala"
								_tmp14_ = g_strdup_printf ("%" G_GINT64_FORMAT, (start_of_span + span_count) - 1);
#line 304 "../src/engine/imap/command/imap-message-set.vala"
								_tmp15_ = _tmp14_;
#line 304 "../src/engine/imap/command/imap-message-set.vala"
								_tmp16_ = g_strdup_printf ("%" G_GINT64_FORMAT, seq_num);
#line 304 "../src/engine/imap/command/imap-message-set.vala"
								_tmp17_ = _tmp16_;
#line 304 "../src/engine/imap/command/imap-message-set.vala"
								g_string_append_printf (_tmp13_, ":%s,%s", _tmp15_, _tmp17_);
#line 304 "../src/engine/imap/command/imap-message-set.vala"
								_g_free0 (_tmp17_);
#line 304 "../src/engine/imap/command/imap-message-set.vala"
								_g_free0 (_tmp15_);
#line 1951 "imap-message-set.c"
							}
						}
#line 308 "../src/engine/imap/command/imap-message-set.vala"
						start_of_span = seq_num;
#line 309 "../src/engine/imap/command/imap-message-set.vala"
						span_count = 1;
#line 1958 "imap-message-set.c"
					}
				}
#line 312 "../src/engine/imap/command/imap-message-set.vala"
				last_seq_num = seq_num;
#line 1963 "imap-message-set.c"
			}
		}
	}
#line 316 "../src/engine/imap/command/imap-message-set.vala"
	_vala_assert (start_of_span >= ((gint64) 0), "start_of_span >= 0");
#line 317 "../src/engine/imap/command/imap-message-set.vala"
	_vala_assert (span_count > 0, "span_count > 0");
#line 318 "../src/engine/imap/command/imap-message-set.vala"
	_vala_assert (last_seq_num >= ((gint64) 0), "last_seq_num >= 0");
#line 321 "../src/engine/imap/command/imap-message-set.vala"
	if (span_count == 2) {
#line 1975 "imap-message-set.c"
		GString* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
#line 322 "../src/engine/imap/command/imap-message-set.vala"
		_tmp18_ = builder;
#line 322 "../src/engine/imap/command/imap-message-set.vala"
		_tmp19_ = g_strdup_printf ("%" G_GINT64_FORMAT, last_seq_num);
#line 322 "../src/engine/imap/command/imap-message-set.vala"
		_tmp20_ = _tmp19_;
#line 322 "../src/engine/imap/command/imap-message-set.vala"
		g_string_append_printf (_tmp18_, ",%s", _tmp20_);
#line 322 "../src/engine/imap/command/imap-message-set.vala"
		_g_free0 (_tmp20_);
#line 1989 "imap-message-set.c"
	} else {
#line 323 "../src/engine/imap/command/imap-message-set.vala"
		if (last_seq_num != start_of_span) {
#line 1993 "imap-message-set.c"
			GString* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
#line 324 "../src/engine/imap/command/imap-message-set.vala"
			_tmp21_ = builder;
#line 324 "../src/engine/imap/command/imap-message-set.vala"
			_tmp22_ = g_strdup_printf ("%" G_GINT64_FORMAT, last_seq_num);
#line 324 "../src/engine/imap/command/imap-message-set.vala"
			_tmp23_ = _tmp22_;
#line 324 "../src/engine/imap/command/imap-message-set.vala"
			g_string_append_printf (_tmp21_, ":%s", _tmp23_);
#line 324 "../src/engine/imap/command/imap-message-set.vala"
			_g_free0 (_tmp23_);
#line 2007 "imap-message-set.c"
		}
	}
#line 326 "../src/engine/imap/command/imap-message-set.vala"
	_tmp24_ = builder;
#line 326 "../src/engine/imap/command/imap-message-set.vala"
	_tmp25_ = _tmp24_->str;
#line 326 "../src/engine/imap/command/imap-message-set.vala"
	_tmp26_ = g_strdup (_tmp25_);
#line 326 "../src/engine/imap/command/imap-message-set.vala"
	result = _tmp26_;
#line 326 "../src/engine/imap/command/imap-message-set.vala"
	_g_string_free0 (builder);
#line 326 "../src/engine/imap/command/imap-message-set.vala"
	return result;
#line 2022 "imap-message-set.c"
}

static gint
__lambda44_ (GearyImapSequenceNumber* a,
             GearyImapSequenceNumber* b)
{
	gint result;
#line 331 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_SEQUENCE_NUMBER (a), 0);
#line 331 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_SEQUENCE_NUMBER (b), 0);
#line 331 "../src/engine/imap/command/imap-message-set.vala"
	result = geary_imap_sequence_number_compare_to (a, b);
#line 331 "../src/engine/imap/command/imap-message-set.vala"
	return result;
#line 2038 "imap-message-set.c"
}

static gint
___lambda44__gcompare_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gint result;
	result = __lambda44_ ((GearyImapSequenceNumber*) a, (GearyImapSequenceNumber*) b);
#line 331 "../src/engine/imap/command/imap-message-set.vala"
	return result;
#line 2050 "imap-message-set.c"
}

static gint64*
geary_imap_message_set_seq_array_to_int64 (GeeCollection* seq_nums,
                                           gint* result_length1)
{
	GeeArrayList* sorted = NULL;
	GearyIterable* _tmp0_;
	GearyIterable* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	gint64* ret = NULL;
	GeeArrayList* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint64* _tmp7_;
	gint ret_length1;
	gint _ret_size_;
	gint index = 0;
	gint64* _tmp21_;
	gint _tmp21__length1;
	gint64* result;
#line 329 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (seq_nums, GEE_TYPE_COLLECTION), NULL);
#line 331 "../src/engine/imap/command/imap-message-set.vala"
	_tmp0_ = geary_traverse (GEARY_IMAP_TYPE_SEQUENCE_NUMBER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_CHECK_INSTANCE_CAST (seq_nums, GEE_TYPE_ITERABLE, GeeIterable));
#line 331 "../src/engine/imap/command/imap-message-set.vala"
	_tmp1_ = _tmp0_;
#line 331 "../src/engine/imap/command/imap-message-set.vala"
	_tmp2_ = geary_iterable_to_sorted_list (_tmp1_, ___lambda44__gcompare_data_func, NULL, NULL, NULL, NULL, NULL);
#line 331 "../src/engine/imap/command/imap-message-set.vala"
	_tmp3_ = _tmp2_;
#line 331 "../src/engine/imap/command/imap-message-set.vala"
	_g_object_unref0 (_tmp1_);
#line 331 "../src/engine/imap/command/imap-message-set.vala"
	sorted = _tmp3_;
#line 334 "../src/engine/imap/command/imap-message-set.vala"
	_tmp4_ = sorted;
#line 334 "../src/engine/imap/command/imap-message-set.vala"
	_tmp5_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 334 "../src/engine/imap/command/imap-message-set.vala"
	_tmp6_ = _tmp5_;
#line 334 "../src/engine/imap/command/imap-message-set.vala"
	_tmp7_ = g_new0 (gint64, _tmp6_);
#line 334 "../src/engine/imap/command/imap-message-set.vala"
	ret = _tmp7_;
#line 334 "../src/engine/imap/command/imap-message-set.vala"
	ret_length1 = _tmp6_;
#line 334 "../src/engine/imap/command/imap-message-set.vala"
	_ret_size_ = ret_length1;
#line 335 "../src/engine/imap/command/imap-message-set.vala"
	index = 0;
#line 2103 "imap-message-set.c"
	{
		GeeArrayList* _seq_num_list = NULL;
		GeeArrayList* _tmp8_;
		gint _seq_num_size = 0;
		GeeArrayList* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gint _seq_num_index = 0;
#line 336 "../src/engine/imap/command/imap-message-set.vala"
		_tmp8_ = sorted;
#line 336 "../src/engine/imap/command/imap-message-set.vala"
		_seq_num_list = _tmp8_;
#line 336 "../src/engine/imap/command/imap-message-set.vala"
		_tmp9_ = _seq_num_list;
#line 336 "../src/engine/imap/command/imap-message-set.vala"
		_tmp10_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 336 "../src/engine/imap/command/imap-message-set.vala"
		_tmp11_ = _tmp10_;
#line 336 "../src/engine/imap/command/imap-message-set.vala"
		_seq_num_size = _tmp11_;
#line 336 "../src/engine/imap/command/imap-message-set.vala"
		_seq_num_index = -1;
#line 336 "../src/engine/imap/command/imap-message-set.vala"
		while (TRUE) {
#line 2128 "imap-message-set.c"
			gint _tmp12_;
			gint _tmp13_;
			GearyImapSequenceNumber* seq_num = NULL;
			GeeArrayList* _tmp14_;
			gpointer _tmp15_;
			gint64* _tmp16_;
			gint _tmp16__length1;
			gint _tmp17_;
			GearyImapSequenceNumber* _tmp18_;
			gint64 _tmp19_;
			gint64 _tmp20_;
#line 336 "../src/engine/imap/command/imap-message-set.vala"
			_seq_num_index = _seq_num_index + 1;
#line 336 "../src/engine/imap/command/imap-message-set.vala"
			_tmp12_ = _seq_num_index;
#line 336 "../src/engine/imap/command/imap-message-set.vala"
			_tmp13_ = _seq_num_size;
#line 336 "../src/engine/imap/command/imap-message-set.vala"
			if (!(_tmp12_ < _tmp13_)) {
#line 336 "../src/engine/imap/command/imap-message-set.vala"
				break;
#line 2150 "imap-message-set.c"
			}
#line 336 "../src/engine/imap/command/imap-message-set.vala"
			_tmp14_ = _seq_num_list;
#line 336 "../src/engine/imap/command/imap-message-set.vala"
			_tmp15_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _seq_num_index);
#line 336 "../src/engine/imap/command/imap-message-set.vala"
			seq_num = (GearyImapSequenceNumber*) _tmp15_;
#line 337 "../src/engine/imap/command/imap-message-set.vala"
			_tmp16_ = ret;
#line 337 "../src/engine/imap/command/imap-message-set.vala"
			_tmp16__length1 = ret_length1;
#line 337 "../src/engine/imap/command/imap-message-set.vala"
			_tmp17_ = index;
#line 337 "../src/engine/imap/command/imap-message-set.vala"
			index = _tmp17_ + 1;
#line 337 "../src/engine/imap/command/imap-message-set.vala"
			_tmp18_ = seq_num;
#line 337 "../src/engine/imap/command/imap-message-set.vala"
			_tmp19_ = geary_message_data_int64_message_data_get_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEARY_MESSAGE_DATA_TYPE_INT64_MESSAGE_DATA, GearyMessageDataInt64MessageData));
#line 337 "../src/engine/imap/command/imap-message-set.vala"
			_tmp20_ = _tmp19_;
#line 337 "../src/engine/imap/command/imap-message-set.vala"
			_tmp16_[_tmp17_] = (gint64) _tmp20_;
#line 336 "../src/engine/imap/command/imap-message-set.vala"
			_g_object_unref0 (seq_num);
#line 2176 "imap-message-set.c"
		}
	}
#line 339 "../src/engine/imap/command/imap-message-set.vala"
	_tmp21_ = ret;
#line 339 "../src/engine/imap/command/imap-message-set.vala"
	_tmp21__length1 = ret_length1;
#line 339 "../src/engine/imap/command/imap-message-set.vala"
	if (result_length1) {
#line 339 "../src/engine/imap/command/imap-message-set.vala"
		*result_length1 = _tmp21__length1;
#line 2187 "imap-message-set.c"
	}
#line 339 "../src/engine/imap/command/imap-message-set.vala"
	result = _tmp21_;
#line 339 "../src/engine/imap/command/imap-message-set.vala"
	_g_object_unref0 (sorted);
#line 339 "../src/engine/imap/command/imap-message-set.vala"
	return result;
#line 2195 "imap-message-set.c"
}

static gint
__lambda45_ (GearyImapUID* a,
             GearyImapUID* b)
{
	gint result;
#line 344 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_UID (a), 0);
#line 344 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_UID (b), 0);
#line 344 "../src/engine/imap/command/imap-message-set.vala"
	result = geary_imap_uid_compare_to (a, b);
#line 344 "../src/engine/imap/command/imap-message-set.vala"
	return result;
#line 2211 "imap-message-set.c"
}

static gint
___lambda45__gcompare_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gint result;
	result = __lambda45_ ((GearyImapUID*) a, (GearyImapUID*) b);
#line 344 "../src/engine/imap/command/imap-message-set.vala"
	return result;
#line 2223 "imap-message-set.c"
}

static gint64*
geary_imap_message_set_uid_array_to_int64 (GeeCollection* msg_uids,
                                           gint* result_length1)
{
	GeeArrayList* sorted = NULL;
	GearyIterable* _tmp0_;
	GearyIterable* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	gint64* ret = NULL;
	GeeArrayList* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint64* _tmp7_;
	gint ret_length1;
	gint _ret_size_;
	gint index = 0;
	gint64* _tmp21_;
	gint _tmp21__length1;
	gint64* result;
#line 342 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (msg_uids, GEE_TYPE_COLLECTION), NULL);
#line 344 "../src/engine/imap/command/imap-message-set.vala"
	_tmp0_ = geary_traverse (GEARY_IMAP_TYPE_UID, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_CHECK_INSTANCE_CAST (msg_uids, GEE_TYPE_ITERABLE, GeeIterable));
#line 344 "../src/engine/imap/command/imap-message-set.vala"
	_tmp1_ = _tmp0_;
#line 344 "../src/engine/imap/command/imap-message-set.vala"
	_tmp2_ = geary_iterable_to_sorted_list (_tmp1_, ___lambda45__gcompare_data_func, NULL, NULL, NULL, NULL, NULL);
#line 344 "../src/engine/imap/command/imap-message-set.vala"
	_tmp3_ = _tmp2_;
#line 344 "../src/engine/imap/command/imap-message-set.vala"
	_g_object_unref0 (_tmp1_);
#line 344 "../src/engine/imap/command/imap-message-set.vala"
	sorted = _tmp3_;
#line 347 "../src/engine/imap/command/imap-message-set.vala"
	_tmp4_ = sorted;
#line 347 "../src/engine/imap/command/imap-message-set.vala"
	_tmp5_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 347 "../src/engine/imap/command/imap-message-set.vala"
	_tmp6_ = _tmp5_;
#line 347 "../src/engine/imap/command/imap-message-set.vala"
	_tmp7_ = g_new0 (gint64, _tmp6_);
#line 347 "../src/engine/imap/command/imap-message-set.vala"
	ret = _tmp7_;
#line 347 "../src/engine/imap/command/imap-message-set.vala"
	ret_length1 = _tmp6_;
#line 347 "../src/engine/imap/command/imap-message-set.vala"
	_ret_size_ = ret_length1;
#line 348 "../src/engine/imap/command/imap-message-set.vala"
	index = 0;
#line 2276 "imap-message-set.c"
	{
		GeeArrayList* _uid_list = NULL;
		GeeArrayList* _tmp8_;
		gint _uid_size = 0;
		GeeArrayList* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gint _uid_index = 0;
#line 349 "../src/engine/imap/command/imap-message-set.vala"
		_tmp8_ = sorted;
#line 349 "../src/engine/imap/command/imap-message-set.vala"
		_uid_list = _tmp8_;
#line 349 "../src/engine/imap/command/imap-message-set.vala"
		_tmp9_ = _uid_list;
#line 349 "../src/engine/imap/command/imap-message-set.vala"
		_tmp10_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 349 "../src/engine/imap/command/imap-message-set.vala"
		_tmp11_ = _tmp10_;
#line 349 "../src/engine/imap/command/imap-message-set.vala"
		_uid_size = _tmp11_;
#line 349 "../src/engine/imap/command/imap-message-set.vala"
		_uid_index = -1;
#line 349 "../src/engine/imap/command/imap-message-set.vala"
		while (TRUE) {
#line 2301 "imap-message-set.c"
			gint _tmp12_;
			gint _tmp13_;
			GearyImapUID* uid = NULL;
			GeeArrayList* _tmp14_;
			gpointer _tmp15_;
			gint64* _tmp16_;
			gint _tmp16__length1;
			gint _tmp17_;
			GearyImapUID* _tmp18_;
			gint64 _tmp19_;
			gint64 _tmp20_;
#line 349 "../src/engine/imap/command/imap-message-set.vala"
			_uid_index = _uid_index + 1;
#line 349 "../src/engine/imap/command/imap-message-set.vala"
			_tmp12_ = _uid_index;
#line 349 "../src/engine/imap/command/imap-message-set.vala"
			_tmp13_ = _uid_size;
#line 349 "../src/engine/imap/command/imap-message-set.vala"
			if (!(_tmp12_ < _tmp13_)) {
#line 349 "../src/engine/imap/command/imap-message-set.vala"
				break;
#line 2323 "imap-message-set.c"
			}
#line 349 "../src/engine/imap/command/imap-message-set.vala"
			_tmp14_ = _uid_list;
#line 349 "../src/engine/imap/command/imap-message-set.vala"
			_tmp15_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _uid_index);
#line 349 "../src/engine/imap/command/imap-message-set.vala"
			uid = (GearyImapUID*) _tmp15_;
#line 350 "../src/engine/imap/command/imap-message-set.vala"
			_tmp16_ = ret;
#line 350 "../src/engine/imap/command/imap-message-set.vala"
			_tmp16__length1 = ret_length1;
#line 350 "../src/engine/imap/command/imap-message-set.vala"
			_tmp17_ = index;
#line 350 "../src/engine/imap/command/imap-message-set.vala"
			index = _tmp17_ + 1;
#line 350 "../src/engine/imap/command/imap-message-set.vala"
			_tmp18_ = uid;
#line 350 "../src/engine/imap/command/imap-message-set.vala"
			_tmp19_ = geary_message_data_int64_message_data_get_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEARY_MESSAGE_DATA_TYPE_INT64_MESSAGE_DATA, GearyMessageDataInt64MessageData));
#line 350 "../src/engine/imap/command/imap-message-set.vala"
			_tmp20_ = _tmp19_;
#line 350 "../src/engine/imap/command/imap-message-set.vala"
			_tmp16_[_tmp17_] = _tmp20_;
#line 349 "../src/engine/imap/command/imap-message-set.vala"
			_g_object_unref0 (uid);
#line 2349 "imap-message-set.c"
		}
	}
#line 352 "../src/engine/imap/command/imap-message-set.vala"
	_tmp21_ = ret;
#line 352 "../src/engine/imap/command/imap-message-set.vala"
	_tmp21__length1 = ret_length1;
#line 352 "../src/engine/imap/command/imap-message-set.vala"
	if (result_length1) {
#line 352 "../src/engine/imap/command/imap-message-set.vala"
		*result_length1 = _tmp21__length1;
#line 2360 "imap-message-set.c"
	}
#line 352 "../src/engine/imap/command/imap-message-set.vala"
	result = _tmp21_;
#line 352 "../src/engine/imap/command/imap-message-set.vala"
	_g_object_unref0 (sorted);
#line 352 "../src/engine/imap/command/imap-message-set.vala"
	return result;
#line 2368 "imap-message-set.c"
}

/**
     * Returns the {@link MessageSet} as a {@link Parameter} suitable for inclusion in a
     * {@link Command}.
     */
GearyImapParameter*
geary_imap_message_set_to_parameter (GearyImapMessageSet* self)
{
	const gchar* _tmp0_;
	GearyImapUnquotedStringParameter* _tmp1_;
	GearyImapParameter* result;
#line 359 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_MESSAGE_SET (self), NULL);
#line 362 "../src/engine/imap/command/imap-message-set.vala"
	_tmp0_ = self->priv->_value;
#line 362 "../src/engine/imap/command/imap-message-set.vala"
	_tmp1_ = geary_imap_unquoted_string_parameter_new (_tmp0_);
#line 362 "../src/engine/imap/command/imap-message-set.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter);
#line 362 "../src/engine/imap/command/imap-message-set.vala"
	return result;
#line 2391 "imap-message-set.c"
}

/**
     * Returns the {@link MessageSet} in a Gee.List.
     */
GeeList*
geary_imap_message_set_to_list (GearyImapMessageSet* self)
{
	GearyIterable* _tmp0_;
	GearyIterable* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeList* _tmp3_;
	GeeList* result;
#line 368 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_MESSAGE_SET (self), NULL);
#line 369 "../src/engine/imap/command/imap-message-set.vala"
	_tmp0_ = geary_iterate (GEARY_IMAP_TYPE_MESSAGE_SET, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, self, NULL);
#line 369 "../src/engine/imap/command/imap-message-set.vala"
	_tmp1_ = _tmp0_;
#line 369 "../src/engine/imap/command/imap-message-set.vala"
	_tmp2_ = geary_iterable_to_array_list (_tmp1_, NULL, NULL, NULL);
#line 369 "../src/engine/imap/command/imap-message-set.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_LIST, GeeList);
#line 369 "../src/engine/imap/command/imap-message-set.vala"
	_g_object_unref0 (_tmp1_);
#line 369 "../src/engine/imap/command/imap-message-set.vala"
	result = _tmp3_;
#line 369 "../src/engine/imap/command/imap-message-set.vala"
	return result;
#line 2421 "imap-message-set.c"
}

gchar*
geary_imap_message_set_to_string (GearyImapMessageSet* self)
{
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 372 "../src/engine/imap/command/imap-message-set.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_MESSAGE_SET (self), NULL);
#line 373 "../src/engine/imap/command/imap-message-set.vala"
	_tmp1_ = self->priv->_is_uid;
#line 373 "../src/engine/imap/command/imap-message-set.vala"
	if (_tmp1_) {
#line 373 "../src/engine/imap/command/imap-message-set.vala"
		_tmp0_ = "UID";
#line 2440 "imap-message-set.c"
	} else {
#line 373 "../src/engine/imap/command/imap-message-set.vala"
		_tmp0_ = "pos";
#line 2444 "imap-message-set.c"
	}
#line 373 "../src/engine/imap/command/imap-message-set.vala"
	_tmp2_ = self->priv->_value;
#line 373 "../src/engine/imap/command/imap-message-set.vala"
	_tmp3_ = g_strdup_printf ("%s::%s", _tmp0_, _tmp2_);
#line 373 "../src/engine/imap/command/imap-message-set.vala"
	result = _tmp3_;
#line 373 "../src/engine/imap/command/imap-message-set.vala"
	return result;
#line 2454 "imap-message-set.c"
}

static void
geary_imap_message_set_class_init (GearyImapMessageSetClass * klass,
                                   gpointer klass_data)
{
#line 16 "../src/engine/imap/command/imap-message-set.vala"
	geary_imap_message_set_parent_class = g_type_class_peek_parent (klass);
#line 16 "../src/engine/imap/command/imap-message-set.vala"
	g_type_class_adjust_private_offset (klass, &GearyImapMessageSet_private_offset);
#line 16 "../src/engine/imap/command/imap-message-set.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_imap_message_set_get_property;
#line 16 "../src/engine/imap/command/imap-message-set.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_imap_message_set_set_property;
#line 16 "../src/engine/imap/command/imap-message-set.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_imap_message_set_finalize;
#line 2471 "imap-message-set.c"
	/**
	     * True if the {@link MessageSet} was created with a UID or a UID range.
	     *
	     * For {@link Command}s that accept MessageSets, they will use a UID variant
	     */
#line 16 "../src/engine/imap/command/imap-message-set.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_MESSAGE_SET_IS_UID_PROPERTY, geary_imap_message_set_properties[GEARY_IMAP_MESSAGE_SET_IS_UID_PROPERTY] = g_param_spec_boolean ("is-uid", "is-uid", "is-uid", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2479 "imap-message-set.c"
}

static void
geary_imap_message_set_instance_init (GearyImapMessageSet * self,
                                      gpointer klass)
{
#line 16 "../src/engine/imap/command/imap-message-set.vala"
	self->priv = geary_imap_message_set_get_instance_private (self);
#line 30 "../src/engine/imap/command/imap-message-set.vala"
	self->priv->_is_uid = FALSE;
#line 2490 "imap-message-set.c"
}

static void
geary_imap_message_set_finalize (GObject * obj)
{
	GearyImapMessageSet * self;
#line 16 "../src/engine/imap/command/imap-message-set.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_IMAP_TYPE_MESSAGE_SET, GearyImapMessageSet);
#line 32 "../src/engine/imap/command/imap-message-set.vala"
	_g_free0 (self->priv->_value);
#line 16 "../src/engine/imap/command/imap-message-set.vala"
	G_OBJECT_CLASS (geary_imap_message_set_parent_class)->finalize (obj);
#line 2503 "imap-message-set.c"
}

/**
 * A representation of an IMAP message range specifier.
 *
 * A MessageSet can be for {@link SequenceNumber}s (which use positional addressing) or
 * {@link UID}s.
 *
 * See [[http://tools.ietf.org/html/rfc3501#section-9]], "sequence-set" and "seq-range".
 */
 G_GNUC_NO_INLINE static GType
geary_imap_message_set_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyImapMessageSetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_imap_message_set_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyImapMessageSet), 0, (GInstanceInitFunc) geary_imap_message_set_instance_init, NULL };
	GType geary_imap_message_set_type_id;
	geary_imap_message_set_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyImapMessageSet", &g_define_type_info, 0);
	GearyImapMessageSet_private_offset = g_type_add_instance_private (geary_imap_message_set_type_id, sizeof (GearyImapMessageSetPrivate));
	return geary_imap_message_set_type_id;
}

GType
geary_imap_message_set_get_type (void)
{
	static gsize geary_imap_message_set_type_id__once = 0;
	if (g_once_init_enter (&geary_imap_message_set_type_id__once)) {
		GType geary_imap_message_set_type_id;
		geary_imap_message_set_type_id = geary_imap_message_set_get_type_once ();
		g_once_init_leave (&geary_imap_message_set_type_id__once, geary_imap_message_set_type_id);
	}
	return geary_imap_message_set_type_id__once;
}

static void
_vala_geary_imap_message_set_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	GearyImapMessageSet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_TYPE_MESSAGE_SET, GearyImapMessageSet);
#line 16 "../src/engine/imap/command/imap-message-set.vala"
	switch (property_id) {
#line 16 "../src/engine/imap/command/imap-message-set.vala"
		case GEARY_IMAP_MESSAGE_SET_IS_UID_PROPERTY:
#line 16 "../src/engine/imap/command/imap-message-set.vala"
		g_value_set_boolean (value, geary_imap_message_set_get_is_uid (self));
#line 16 "../src/engine/imap/command/imap-message-set.vala"
		break;
#line 2552 "imap-message-set.c"
		default:
#line 16 "../src/engine/imap/command/imap-message-set.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 16 "../src/engine/imap/command/imap-message-set.vala"
		break;
#line 2558 "imap-message-set.c"
	}
}

static void
_vala_geary_imap_message_set_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	GearyImapMessageSet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_TYPE_MESSAGE_SET, GearyImapMessageSet);
#line 16 "../src/engine/imap/command/imap-message-set.vala"
	switch (property_id) {
#line 16 "../src/engine/imap/command/imap-message-set.vala"
		case GEARY_IMAP_MESSAGE_SET_IS_UID_PROPERTY:
#line 16 "../src/engine/imap/command/imap-message-set.vala"
		geary_imap_message_set_set_is_uid (self, g_value_get_boolean (value));
#line 16 "../src/engine/imap/command/imap-message-set.vala"
		break;
#line 2578 "imap-message-set.c"
		default:
#line 16 "../src/engine/imap/command/imap-message-set.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 16 "../src/engine/imap/command/imap-message-set.vala"
		break;
#line 2584 "imap-message-set.c"
	}
}

