/* imap-data-format.c generated by valac 0.56.17, the Vala compiler
 * generated from imap-data-format.vala, do not modify */

/*
 * Copyright © 2016 Software Freedom Conservancy Inc.
 * Copyright © 2020 Micahel Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include <glib.h>
#include "geary-engine.h"
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

VALA_EXTERN gboolean geary_imap_data_format_is_special_char (gchar ch,
                                                 gchar* ar,
                                                 gint ar_length1,
                                                 const gchar* exceptions);
static gboolean _vala_char_array_contains (gchar * stack,
                                    gssize stack_length,
                                    const gchar needle);

const gchar GEARY_IMAP_DATA_FORMAT_ATOM_SPECIALS[9] = {'(', ')', '{', ' ', '%', '*', '"', '\\', ']'};
const gchar GEARY_IMAP_DATA_FORMAT_TAG_SPECIALS[9] = {'(', ')', '{', ' ', '%', '*', '"', '\\', '+'};

 G_GNUC_NO_INLINE static GType
geary_imap_data_format_quoting_get_type_once (void)
{
	static const GEnumValue values[] = {{GEARY_IMAP_DATA_FORMAT_QUOTING_REQUIRED, "GEARY_IMAP_DATA_FORMAT_QUOTING_REQUIRED", "required"}, {GEARY_IMAP_DATA_FORMAT_QUOTING_OPTIONAL, "GEARY_IMAP_DATA_FORMAT_QUOTING_OPTIONAL", "optional"}, {GEARY_IMAP_DATA_FORMAT_QUOTING_UNALLOWED, "GEARY_IMAP_DATA_FORMAT_QUOTING_UNALLOWED", "unallowed"}, {0, NULL, NULL}};
	GType geary_imap_data_format_quoting_type_id;
	geary_imap_data_format_quoting_type_id = g_enum_register_static ("GearyImapDataFormatQuoting", values);
	return geary_imap_data_format_quoting_type_id;
}

GType
geary_imap_data_format_quoting_get_type (void)
{
	static gsize geary_imap_data_format_quoting_type_id__once = 0;
	if (g_once_init_enter (&geary_imap_data_format_quoting_type_id__once)) {
		GType geary_imap_data_format_quoting_type_id;
		geary_imap_data_format_quoting_type_id = geary_imap_data_format_quoting_get_type_once ();
		g_once_init_leave (&geary_imap_data_format_quoting_type_id__once, geary_imap_data_format_quoting_type_id);
	}
	return geary_imap_data_format_quoting_type_id__once;
}

/**
     * Returns true if the character is considered an atom-special.
     *
     * Note that while documentation indicates that the backslash
     * cannot be used in an atom, they *are* used for message flags
     * and thus must be special cased by the caller.
     */
gboolean
geary_imap_data_format_is_atom_special (gchar ch,
                                        const gchar* exceptions)
{
	gboolean result;
#line 51 "../src/engine/imap/message/imap-data-format.vala"
	result = geary_imap_data_format_is_special_char (ch, GEARY_IMAP_DATA_FORMAT_ATOM_SPECIALS, (gint) G_N_ELEMENTS (GEARY_IMAP_DATA_FORMAT_ATOM_SPECIALS), exceptions);
#line 51 "../src/engine/imap/message/imap-data-format.vala"
	return result;
#line 75 "imap-data-format.c"
}

/**
     * Returns true if the character is considered a tag-special.
     *
     * Tag specials are like atom specials but include the
     * continuation character ('+'). Also, the star character is
     * allowed, although technically only correct in the context of a
     * status response; it's the responsibility of the caller to catch
     * this.
     */
gboolean
geary_imap_data_format_is_tag_special (gchar ch,
                                       const gchar* exceptions)
{
	gboolean result;
#line 64 "../src/engine/imap/message/imap-data-format.vala"
	result = geary_imap_data_format_is_special_char (ch, GEARY_IMAP_DATA_FORMAT_TAG_SPECIALS, (gint) G_N_ELEMENTS (GEARY_IMAP_DATA_FORMAT_TAG_SPECIALS), exceptions);
#line 64 "../src/engine/imap/message/imap-data-format.vala"
	return result;
#line 96 "imap-data-format.c"
}

/**
     * Determines quoting policy for a string to be sent over the wire.
     */
static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 116 "imap-data-format.c"
}

GearyImapDataFormatQuoting
geary_imap_data_format_is_quoting_required (const gchar* str)
{
	gint index = 0;
	GearyImapDataFormatQuoting result;
#line 70 "../src/engine/imap/message/imap-data-format.vala"
	g_return_val_if_fail (str != NULL, 0);
#line 71 "../src/engine/imap/message/imap-data-format.vala"
	if (geary_string_is_empty (str)) {
#line 72 "../src/engine/imap/message/imap-data-format.vala"
		result = GEARY_IMAP_DATA_FORMAT_QUOTING_REQUIRED;
#line 72 "../src/engine/imap/message/imap-data-format.vala"
		return result;
#line 132 "imap-data-format.c"
	}
#line 74 "../src/engine/imap/message/imap-data-format.vala"
	index = 0;
#line 136 "imap-data-format.c"
	{
		gboolean _tmp0_ = FALSE;
#line 75 "../src/engine/imap/message/imap-data-format.vala"
		_tmp0_ = TRUE;
#line 75 "../src/engine/imap/message/imap-data-format.vala"
		while (TRUE) {
#line 143 "imap-data-format.c"
			gchar ch = '\0';
			gint _tmp1_;
#line 75 "../src/engine/imap/message/imap-data-format.vala"
			if (!_tmp0_) {
#line 148 "imap-data-format.c"
			}
#line 75 "../src/engine/imap/message/imap-data-format.vala"
			_tmp0_ = FALSE;
#line 76 "../src/engine/imap/message/imap-data-format.vala"
			_tmp1_ = index;
#line 76 "../src/engine/imap/message/imap-data-format.vala"
			index = _tmp1_ + 1;
#line 76 "../src/engine/imap/message/imap-data-format.vala"
			ch = string_get (str, (glong) _tmp1_);
#line 77 "../src/engine/imap/message/imap-data-format.vala"
			if (ch == GEARY_STRING_EOS) {
#line 78 "../src/engine/imap/message/imap-data-format.vala"
				break;
#line 162 "imap-data-format.c"
			}
#line 80 "../src/engine/imap/message/imap-data-format.vala"
			if (((gint) ch) > 0x7F) {
#line 81 "../src/engine/imap/message/imap-data-format.vala"
				result = GEARY_IMAP_DATA_FORMAT_QUOTING_UNALLOWED;
#line 81 "../src/engine/imap/message/imap-data-format.vala"
				return result;
#line 170 "imap-data-format.c"
			}
#line 83 "../src/engine/imap/message/imap-data-format.vala"
			switch (ch) {
#line 83 "../src/engine/imap/message/imap-data-format.vala"
				case '\n':
#line 83 "../src/engine/imap/message/imap-data-format.vala"
				case '\r':
#line 178 "imap-data-format.c"
				{
#line 86 "../src/engine/imap/message/imap-data-format.vala"
					result = GEARY_IMAP_DATA_FORMAT_QUOTING_UNALLOWED;
#line 86 "../src/engine/imap/message/imap-data-format.vala"
					return result;
#line 184 "imap-data-format.c"
				}
				default:
				{
#line 89 "../src/engine/imap/message/imap-data-format.vala"
					if (geary_imap_data_format_is_atom_special (ch, NULL)) {
#line 90 "../src/engine/imap/message/imap-data-format.vala"
						result = GEARY_IMAP_DATA_FORMAT_QUOTING_REQUIRED;
#line 90 "../src/engine/imap/message/imap-data-format.vala"
						return result;
#line 194 "imap-data-format.c"
					}
#line 91 "../src/engine/imap/message/imap-data-format.vala"
					break;
#line 198 "imap-data-format.c"
				}
			}
		}
	}
#line 95 "../src/engine/imap/message/imap-data-format.vala"
	result = GEARY_IMAP_DATA_FORMAT_QUOTING_OPTIONAL;
#line 95 "../src/engine/imap/message/imap-data-format.vala"
	return result;
#line 207 "imap-data-format.c"
}

static gboolean
_vala_char_array_contains (gchar * stack,
                           gssize stack_length,
                           const gchar needle)
{
	gssize i;
#line 104 "../src/engine/imap/message/imap-data-format.vala"
	for (i = 0; i < stack_length; i++) {
#line 104 "../src/engine/imap/message/imap-data-format.vala"
		if (needle == stack[i]) {
#line 104 "../src/engine/imap/message/imap-data-format.vala"
			return TRUE;
#line 222 "imap-data-format.c"
		}
	}
#line 104 "../src/engine/imap/message/imap-data-format.vala"
	return FALSE;
#line 227 "imap-data-format.c"
}

inline gboolean
geary_imap_data_format_is_special_char (gchar ch,
                                        gchar* ar,
                                        gint ar_length1,
                                        const gchar* exceptions)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 100 "../src/engine/imap/message/imap-data-format.vala"
	if (((gint) ch) <= 0x1F) {
#line 100 "../src/engine/imap/message/imap-data-format.vala"
		_tmp0_ = TRUE;
#line 242 "imap-data-format.c"
	} else {
#line 100 "../src/engine/imap/message/imap-data-format.vala"
		_tmp0_ = ((gint) ch) >= 0x7F;
#line 246 "imap-data-format.c"
	}
#line 100 "../src/engine/imap/message/imap-data-format.vala"
	if (_tmp0_) {
#line 101 "../src/engine/imap/message/imap-data-format.vala"
		result = TRUE;
#line 101 "../src/engine/imap/message/imap-data-format.vala"
		return result;
#line 254 "imap-data-format.c"
	}
#line 104 "../src/engine/imap/message/imap-data-format.vala"
	if (_vala_char_array_contains (ar, ar_length1, ch)) {
#line 258 "imap-data-format.c"
		gboolean _tmp1_ = FALSE;
#line 105 "../src/engine/imap/message/imap-data-format.vala"
		if (exceptions != NULL) {
#line 105 "../src/engine/imap/message/imap-data-format.vala"
			_tmp1_ = geary_ascii_index_of (exceptions, ch) < 0;
#line 264 "imap-data-format.c"
		} else {
#line 105 "../src/engine/imap/message/imap-data-format.vala"
			_tmp1_ = TRUE;
#line 268 "imap-data-format.c"
		}
#line 105 "../src/engine/imap/message/imap-data-format.vala"
		result = _tmp1_;
#line 105 "../src/engine/imap/message/imap-data-format.vala"
		return result;
#line 274 "imap-data-format.c"
	}
#line 108 "../src/engine/imap/message/imap-data-format.vala"
	result = FALSE;
#line 108 "../src/engine/imap/message/imap-data-format.vala"
	return result;
#line 280 "imap-data-format.c"
}

