/* imap-fetch-data-specifier.c generated by valac 0.56.17, the Vala compiler
 * generated from imap-fetch-data-specifier.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))

/**
 * A symbolic representation of IMAP FETCH's specifier parameter.
 *
 * Most FETCH requests can use this simple specifier to return various parts of the message.
 * More complicated requests (and requests for partial header or body sections) must use a
 * {@link FetchBodyDataSpecifier} specifier.
 *
 * See [[http://tools.ietf.org/html/rfc3501#section-6.4.5]]
 *
 * @see FetchBodyDataSpecifier
 */
gchar*
geary_imap_fetch_data_specifier_to_string (GearyImapFetchDataSpecifier self)
{
	gchar* result;
#line 35 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	switch (self) {
#line 35 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		case GEARY_IMAP_FETCH_DATA_SPECIFIER_UID:
#line 46 "imap-fetch-data-specifier.c"
		{
			gchar* _tmp0_;
#line 37 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			_tmp0_ = g_strdup ("uid");
#line 37 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			result = _tmp0_;
#line 37 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			return result;
#line 55 "imap-fetch-data-specifier.c"
		}
#line 35 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		case GEARY_IMAP_FETCH_DATA_SPECIFIER_FLAGS:
#line 59 "imap-fetch-data-specifier.c"
		{
			gchar* _tmp1_;
#line 40 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			_tmp1_ = g_strdup ("flags");
#line 40 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			result = _tmp1_;
#line 40 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			return result;
#line 68 "imap-fetch-data-specifier.c"
		}
#line 35 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		case GEARY_IMAP_FETCH_DATA_SPECIFIER_INTERNALDATE:
#line 72 "imap-fetch-data-specifier.c"
		{
			gchar* _tmp2_;
#line 43 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			_tmp2_ = g_strdup ("internaldate");
#line 43 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			result = _tmp2_;
#line 43 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			return result;
#line 81 "imap-fetch-data-specifier.c"
		}
#line 35 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		case GEARY_IMAP_FETCH_DATA_SPECIFIER_ENVELOPE:
#line 85 "imap-fetch-data-specifier.c"
		{
			gchar* _tmp3_;
#line 46 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			_tmp3_ = g_strdup ("envelope");
#line 46 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			result = _tmp3_;
#line 46 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			return result;
#line 94 "imap-fetch-data-specifier.c"
		}
#line 35 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		case GEARY_IMAP_FETCH_DATA_SPECIFIER_BODYSTRUCTURE:
#line 98 "imap-fetch-data-specifier.c"
		{
			gchar* _tmp4_;
#line 49 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			_tmp4_ = g_strdup ("bodystructure");
#line 49 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			result = _tmp4_;
#line 49 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			return result;
#line 107 "imap-fetch-data-specifier.c"
		}
#line 35 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		case GEARY_IMAP_FETCH_DATA_SPECIFIER_BODY:
#line 111 "imap-fetch-data-specifier.c"
		{
			gchar* _tmp5_;
#line 52 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			_tmp5_ = g_strdup ("body");
#line 52 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			result = _tmp5_;
#line 52 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			return result;
#line 120 "imap-fetch-data-specifier.c"
		}
#line 35 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		case GEARY_IMAP_FETCH_DATA_SPECIFIER_RFC822:
#line 124 "imap-fetch-data-specifier.c"
		{
			gchar* _tmp6_;
#line 55 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			_tmp6_ = g_strdup ("rfc822");
#line 55 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			result = _tmp6_;
#line 55 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			return result;
#line 133 "imap-fetch-data-specifier.c"
		}
#line 35 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		case GEARY_IMAP_FETCH_DATA_SPECIFIER_RFC822_HEADER:
#line 137 "imap-fetch-data-specifier.c"
		{
			gchar* _tmp7_;
#line 58 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			_tmp7_ = g_strdup ("rfc822.header");
#line 58 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			result = _tmp7_;
#line 58 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			return result;
#line 146 "imap-fetch-data-specifier.c"
		}
#line 35 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		case GEARY_IMAP_FETCH_DATA_SPECIFIER_RFC822_SIZE:
#line 150 "imap-fetch-data-specifier.c"
		{
			gchar* _tmp8_;
#line 61 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			_tmp8_ = g_strdup ("rfc822.size");
#line 61 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			result = _tmp8_;
#line 61 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			return result;
#line 159 "imap-fetch-data-specifier.c"
		}
#line 35 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		case GEARY_IMAP_FETCH_DATA_SPECIFIER_RFC822_TEXT:
#line 163 "imap-fetch-data-specifier.c"
		{
			gchar* _tmp9_;
#line 64 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			_tmp9_ = g_strdup ("rfc822.text");
#line 64 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			result = _tmp9_;
#line 64 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			return result;
#line 172 "imap-fetch-data-specifier.c"
		}
#line 35 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		case GEARY_IMAP_FETCH_DATA_SPECIFIER_FAST:
#line 176 "imap-fetch-data-specifier.c"
		{
			gchar* _tmp10_;
#line 67 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			_tmp10_ = g_strdup ("fast");
#line 67 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			result = _tmp10_;
#line 67 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			return result;
#line 185 "imap-fetch-data-specifier.c"
		}
#line 35 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		case GEARY_IMAP_FETCH_DATA_SPECIFIER_ALL:
#line 189 "imap-fetch-data-specifier.c"
		{
			gchar* _tmp11_;
#line 70 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			_tmp11_ = g_strdup ("all");
#line 70 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			result = _tmp11_;
#line 70 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			return result;
#line 198 "imap-fetch-data-specifier.c"
		}
#line 35 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		case GEARY_IMAP_FETCH_DATA_SPECIFIER_FULL:
#line 202 "imap-fetch-data-specifier.c"
		{
			gchar* _tmp12_;
#line 73 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			_tmp12_ = g_strdup ("full");
#line 73 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			result = _tmp12_;
#line 73 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			return result;
#line 211 "imap-fetch-data-specifier.c"
		}
		default:
		{
#line 76 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			g_assert_not_reached ();
#line 217 "imap-fetch-data-specifier.c"
		}
	}
}

/**
     * Decodes a {@link StringParameter} into a {@link FetchDataSpecifier}.
     */
GearyImapFetchDataSpecifier
geary_imap_fetch_data_specifier_from_parameter (GearyImapStringParameter* strparam,
                                                GError** error)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	static GQuark _tmp2_label0 = 0;
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	static GQuark _tmp2_label1 = 0;
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	static GQuark _tmp2_label2 = 0;
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	static GQuark _tmp2_label3 = 0;
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	static GQuark _tmp2_label4 = 0;
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	static GQuark _tmp2_label5 = 0;
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	static GQuark _tmp2_label6 = 0;
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	static GQuark _tmp2_label7 = 0;
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	static GQuark _tmp2_label8 = 0;
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	static GQuark _tmp2_label9 = 0;
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	static GQuark _tmp2_label10 = 0;
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	static GQuark _tmp2_label11 = 0;
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	static GQuark _tmp2_label12 = 0;
#line 258 "imap-fetch-data-specifier.c"
	GError* _inner_error0_ = NULL;
	GearyImapFetchDataSpecifier result;
#line 83 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_STRING_PARAMETER (strparam), 0);
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	_tmp0_ = geary_imap_string_parameter_as_lower (strparam);
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	_tmp1_ = _tmp0_;
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	g_free (_tmp1_);
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("uid")))) {
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		switch (0) {
#line 275 "imap-fetch-data-specifier.c"
			default:
			{
#line 86 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				result = GEARY_IMAP_FETCH_DATA_SPECIFIER_UID;
#line 86 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				return result;
#line 282 "imap-fetch-data-specifier.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("flags")))) {
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		switch (0) {
#line 288 "imap-fetch-data-specifier.c"
			default:
			{
#line 89 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				result = GEARY_IMAP_FETCH_DATA_SPECIFIER_FLAGS;
#line 89 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				return result;
#line 295 "imap-fetch-data-specifier.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("internaldate")))) {
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		switch (0) {
#line 301 "imap-fetch-data-specifier.c"
			default:
			{
#line 92 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				result = GEARY_IMAP_FETCH_DATA_SPECIFIER_INTERNALDATE;
#line 92 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				return result;
#line 308 "imap-fetch-data-specifier.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("envelope")))) {
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		switch (0) {
#line 314 "imap-fetch-data-specifier.c"
			default:
			{
#line 95 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				result = GEARY_IMAP_FETCH_DATA_SPECIFIER_ENVELOPE;
#line 95 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				return result;
#line 321 "imap-fetch-data-specifier.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("bodystructure")))) {
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		switch (0) {
#line 327 "imap-fetch-data-specifier.c"
			default:
			{
#line 98 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				result = GEARY_IMAP_FETCH_DATA_SPECIFIER_BODYSTRUCTURE;
#line 98 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				return result;
#line 334 "imap-fetch-data-specifier.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("body")))) {
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		switch (0) {
#line 340 "imap-fetch-data-specifier.c"
			default:
			{
#line 101 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				result = GEARY_IMAP_FETCH_DATA_SPECIFIER_BODY;
#line 101 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				return result;
#line 347 "imap-fetch-data-specifier.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("rfc822")))) {
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		switch (0) {
#line 353 "imap-fetch-data-specifier.c"
			default:
			{
#line 104 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				result = GEARY_IMAP_FETCH_DATA_SPECIFIER_RFC822;
#line 104 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				return result;
#line 360 "imap-fetch-data-specifier.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label7) ? _tmp2_label7 : (_tmp2_label7 = g_quark_from_static_string ("rfc822.header")))) {
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		switch (0) {
#line 366 "imap-fetch-data-specifier.c"
			default:
			{
#line 107 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				result = GEARY_IMAP_FETCH_DATA_SPECIFIER_RFC822_HEADER;
#line 107 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				return result;
#line 373 "imap-fetch-data-specifier.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label8) ? _tmp2_label8 : (_tmp2_label8 = g_quark_from_static_string ("rfc822.size")))) {
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		switch (0) {
#line 379 "imap-fetch-data-specifier.c"
			default:
			{
#line 110 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				result = GEARY_IMAP_FETCH_DATA_SPECIFIER_RFC822_SIZE;
#line 110 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				return result;
#line 386 "imap-fetch-data-specifier.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label9) ? _tmp2_label9 : (_tmp2_label9 = g_quark_from_static_string ("rfc822.text")))) {
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		switch (0) {
#line 392 "imap-fetch-data-specifier.c"
			default:
			{
#line 113 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				result = GEARY_IMAP_FETCH_DATA_SPECIFIER_RFC822_TEXT;
#line 113 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				return result;
#line 399 "imap-fetch-data-specifier.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label10) ? _tmp2_label10 : (_tmp2_label10 = g_quark_from_static_string ("fast")))) {
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		switch (0) {
#line 405 "imap-fetch-data-specifier.c"
			default:
			{
#line 116 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				result = GEARY_IMAP_FETCH_DATA_SPECIFIER_FAST;
#line 116 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				return result;
#line 412 "imap-fetch-data-specifier.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label11) ? _tmp2_label11 : (_tmp2_label11 = g_quark_from_static_string ("all")))) {
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		switch (0) {
#line 418 "imap-fetch-data-specifier.c"
			default:
			{
#line 119 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				result = GEARY_IMAP_FETCH_DATA_SPECIFIER_ALL;
#line 119 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				return result;
#line 425 "imap-fetch-data-specifier.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label12) ? _tmp2_label12 : (_tmp2_label12 = g_quark_from_static_string ("full")))) {
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		switch (0) {
#line 431 "imap-fetch-data-specifier.c"
			default:
			{
#line 122 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				result = GEARY_IMAP_FETCH_DATA_SPECIFIER_FULL;
#line 122 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				return result;
#line 438 "imap-fetch-data-specifier.c"
			}
		}
	} else {
#line 84 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		switch (0) {
#line 444 "imap-fetch-data-specifier.c"
			default:
			{
				gchar* _tmp4_;
				gchar* _tmp5_;
				GError* _tmp6_;
				GError* _tmp7_;
#line 125 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				_tmp4_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (strparam, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 125 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				_tmp5_ = _tmp4_;
#line 125 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				_tmp6_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_PARSE_ERROR, "\"%s\" is not a valid fetch-command data item", _tmp5_);
#line 125 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				_tmp7_ = _tmp6_;
#line 125 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				_g_free0 (_tmp5_);
#line 125 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				_inner_error0_ = _tmp7_;
#line 125 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
				if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 125 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
					g_propagate_error (error, _inner_error0_);
#line 125 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
					return 0;
#line 469 "imap-fetch-data-specifier.c"
				} else {
#line 125 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 125 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
					g_clear_error (&_inner_error0_);
#line 125 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
					return 0;
#line 477 "imap-fetch-data-specifier.c"
				}
			}
		}
	}
}

/**
     * Turns this {@link FetchDataSpecifier} into a {@link StringParameter} for transmission.
     */
GearyImapStringParameter*
geary_imap_fetch_data_specifier_to_parameter (GearyImapFetchDataSpecifier self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GearyImapAtomParameter* _tmp2_;
	GearyImapStringParameter* _tmp3_;
	GearyImapStringParameter* result;
#line 134 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	_tmp0_ = geary_imap_fetch_data_specifier_to_string (self);
#line 134 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	_tmp1_ = _tmp0_;
#line 134 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	_tmp2_ = geary_imap_atom_parameter_new (_tmp1_);
#line 134 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEARY_IMAP_TYPE_STRING_PARAMETER, GearyImapStringParameter);
#line 134 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	_g_free0 (_tmp1_);
#line 134 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	result = _tmp3_;
#line 134 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	return result;
#line 509 "imap-fetch-data-specifier.c"
}

/**
     * Returns the appropriate {@link FetchDataDecoder} for this {@link FetchDataSpecifier}.
     *
     * The FetchDataDecoder can then be used to convert the associated {@link Parameter}s into
     * {@link Imap.MessageData}.
     *
     * @return null if no FetchDataDecoder is associated with this value, or an invalid value.
     */
GearyImapFetchDataDecoder*
geary_imap_fetch_data_specifier_get_decoder (GearyImapFetchDataSpecifier self,
                                             GearyImapQuirks* quirks)
{
	GearyImapFetchDataDecoder* result;
#line 145 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_QUIRKS (quirks), NULL);
#line 146 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
	switch (self) {
#line 146 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		case GEARY_IMAP_FETCH_DATA_SPECIFIER_UID:
#line 531 "imap-fetch-data-specifier.c"
		{
			GearyImapUIDDecoder* _tmp0_;
#line 148 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			_tmp0_ = geary_imap_uid_decoder_new ();
#line 148 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_IMAP_TYPE_FETCH_DATA_DECODER, GearyImapFetchDataDecoder);
#line 148 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			return result;
#line 540 "imap-fetch-data-specifier.c"
		}
#line 146 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		case GEARY_IMAP_FETCH_DATA_SPECIFIER_FLAGS:
#line 544 "imap-fetch-data-specifier.c"
		{
			GearyImapMessageFlagsDecoder* _tmp1_;
#line 151 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			_tmp1_ = geary_imap_message_flags_decoder_new ();
#line 151 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_IMAP_TYPE_FETCH_DATA_DECODER, GearyImapFetchDataDecoder);
#line 151 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			return result;
#line 553 "imap-fetch-data-specifier.c"
		}
#line 146 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		case GEARY_IMAP_FETCH_DATA_SPECIFIER_ENVELOPE:
#line 557 "imap-fetch-data-specifier.c"
		{
			GearyImapEnvelopeDecoder* _tmp2_;
#line 154 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			_tmp2_ = geary_imap_envelope_decoder_new (quirks);
#line 154 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			result = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEARY_IMAP_TYPE_FETCH_DATA_DECODER, GearyImapFetchDataDecoder);
#line 154 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			return result;
#line 566 "imap-fetch-data-specifier.c"
		}
#line 146 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		case GEARY_IMAP_FETCH_DATA_SPECIFIER_INTERNALDATE:
#line 570 "imap-fetch-data-specifier.c"
		{
			GearyImapInternalDateDecoder* _tmp3_;
#line 157 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			_tmp3_ = geary_imap_internal_date_decoder_new ();
#line 157 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			result = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEARY_IMAP_TYPE_FETCH_DATA_DECODER, GearyImapFetchDataDecoder);
#line 157 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			return result;
#line 579 "imap-fetch-data-specifier.c"
		}
#line 146 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		case GEARY_IMAP_FETCH_DATA_SPECIFIER_RFC822_SIZE:
#line 583 "imap-fetch-data-specifier.c"
		{
			GearyImapRFC822SizeDecoder* _tmp4_;
#line 160 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			_tmp4_ = geary_imap_rf_c822_size_decoder_new ();
#line 160 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			result = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEARY_IMAP_TYPE_FETCH_DATA_DECODER, GearyImapFetchDataDecoder);
#line 160 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			return result;
#line 592 "imap-fetch-data-specifier.c"
		}
#line 146 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		case GEARY_IMAP_FETCH_DATA_SPECIFIER_RFC822_HEADER:
#line 596 "imap-fetch-data-specifier.c"
		{
			GearyImapRFC822HeaderDecoder* _tmp5_;
#line 163 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			_tmp5_ = geary_imap_rf_c822_header_decoder_new ();
#line 163 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			result = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEARY_IMAP_TYPE_FETCH_DATA_DECODER, GearyImapFetchDataDecoder);
#line 163 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			return result;
#line 605 "imap-fetch-data-specifier.c"
		}
#line 146 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		case GEARY_IMAP_FETCH_DATA_SPECIFIER_RFC822_TEXT:
#line 609 "imap-fetch-data-specifier.c"
		{
			GearyImapRFC822TextDecoder* _tmp6_;
#line 166 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			_tmp6_ = geary_imap_rf_c822_text_decoder_new ();
#line 166 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			result = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEARY_IMAP_TYPE_FETCH_DATA_DECODER, GearyImapFetchDataDecoder);
#line 166 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			return result;
#line 618 "imap-fetch-data-specifier.c"
		}
#line 146 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
		case GEARY_IMAP_FETCH_DATA_SPECIFIER_RFC822:
#line 622 "imap-fetch-data-specifier.c"
		{
			GearyImapRFC822FullDecoder* _tmp7_;
#line 169 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			_tmp7_ = geary_imap_rf_c822_full_decoder_new ();
#line 169 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			result = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEARY_IMAP_TYPE_FETCH_DATA_DECODER, GearyImapFetchDataDecoder);
#line 169 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			return result;
#line 631 "imap-fetch-data-specifier.c"
		}
		default:
		{
#line 172 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			result = NULL;
#line 172 "../src/engine/imap/message/imap-fetch-data-specifier.vala"
			return result;
#line 639 "imap-fetch-data-specifier.c"
		}
	}
}

 G_GNUC_NO_INLINE static GType
geary_imap_fetch_data_specifier_get_type_once (void)
{
	static const GEnumValue values[] = {{GEARY_IMAP_FETCH_DATA_SPECIFIER_UID, "GEARY_IMAP_FETCH_DATA_SPECIFIER_UID", "uid"}, {GEARY_IMAP_FETCH_DATA_SPECIFIER_FLAGS, "GEARY_IMAP_FETCH_DATA_SPECIFIER_FLAGS", "flags"}, {GEARY_IMAP_FETCH_DATA_SPECIFIER_INTERNALDATE, "GEARY_IMAP_FETCH_DATA_SPECIFIER_INTERNALDATE", "internaldate"}, {GEARY_IMAP_FETCH_DATA_SPECIFIER_ENVELOPE, "GEARY_IMAP_FETCH_DATA_SPECIFIER_ENVELOPE", "envelope"}, {GEARY_IMAP_FETCH_DATA_SPECIFIER_BODYSTRUCTURE, "GEARY_IMAP_FETCH_DATA_SPECIFIER_BODYSTRUCTURE", "bodystructure"}, {GEARY_IMAP_FETCH_DATA_SPECIFIER_BODY, "GEARY_IMAP_FETCH_DATA_SPECIFIER_BODY", "body"}, {GEARY_IMAP_FETCH_DATA_SPECIFIER_RFC822, "GEARY_IMAP_FETCH_DATA_SPECIFIER_RFC822", "rfc822"}, {GEARY_IMAP_FETCH_DATA_SPECIFIER_RFC822_HEADER, "GEARY_IMAP_FETCH_DATA_SPECIFIER_RFC822_HEADER", "rfc822-header"}, {GEARY_IMAP_FETCH_DATA_SPECIFIER_RFC822_SIZE, "GEARY_IMAP_FETCH_DATA_SPECIFIER_RFC822_SIZE", "rfc822-size"}, {GEARY_IMAP_FETCH_DATA_SPECIFIER_RFC822_TEXT, "GEARY_IMAP_FETCH_DATA_SPECIFIER_RFC822_TEXT", "rfc822-text"}, {GEARY_IMAP_FETCH_DATA_SPECIFIER_FAST, "GEARY_IMAP_FETCH_DATA_SPECIFIER_FAST", "fast"}, {GEARY_IMAP_FETCH_DATA_SPECIFIER_ALL, "GEARY_IMAP_FETCH_DATA_SPECIFIER_ALL", "all"}, {GEARY_IMAP_FETCH_DATA_SPECIFIER_FULL, "GEARY_IMAP_FETCH_DATA_SPECIFIER_FULL", "full"}, {0, NULL, NULL}};
	GType geary_imap_fetch_data_specifier_type_id;
	geary_imap_fetch_data_specifier_type_id = g_enum_register_static ("GearyImapFetchDataSpecifier", values);
	return geary_imap_fetch_data_specifier_type_id;
}

GType
geary_imap_fetch_data_specifier_get_type (void)
{
	static gsize geary_imap_fetch_data_specifier_type_id__once = 0;
	if (g_once_init_enter (&geary_imap_fetch_data_specifier_type_id__once)) {
		GType geary_imap_fetch_data_specifier_type_id;
		geary_imap_fetch_data_specifier_type_id = geary_imap_fetch_data_specifier_get_type_once ();
		g_once_init_leave (&geary_imap_fetch_data_specifier_type_id__once, geary_imap_fetch_data_specifier_type_id);
	}
	return geary_imap_fetch_data_specifier_type_id__once;
}

