/* imap-status-data-type.c generated by valac 0.56.17, the Vala compiler
 * generated from imap-status-data-type.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))

/**
 * A representation of the types of data to be found in a STATUS response.
 *
 * See [[http://tools.ietf.org/html/rfc3501#section-7.2.4]]
 *
 * @see StatusData
 */
GearyImapStatusDataType*
geary_imap_status_data_type_all (gint* result_length1)
{
	GearyImapStatusDataType* _tmp0_;
	GearyImapStatusDataType* _tmp1_;
	gint _tmp1__length1;
	GearyImapStatusDataType* result;
#line 22 "../src/engine/imap/message/imap-status-data-type.vala"
	_tmp0_ = g_new0 (GearyImapStatusDataType, 5);
#line 22 "../src/engine/imap/message/imap-status-data-type.vala"
	_tmp0_[0] = GEARY_IMAP_STATUS_DATA_TYPE_MESSAGES;
#line 22 "../src/engine/imap/message/imap-status-data-type.vala"
	_tmp0_[1] = GEARY_IMAP_STATUS_DATA_TYPE_RECENT;
#line 22 "../src/engine/imap/message/imap-status-data-type.vala"
	_tmp0_[2] = GEARY_IMAP_STATUS_DATA_TYPE_UIDNEXT;
#line 22 "../src/engine/imap/message/imap-status-data-type.vala"
	_tmp0_[3] = GEARY_IMAP_STATUS_DATA_TYPE_UIDVALIDITY;
#line 22 "../src/engine/imap/message/imap-status-data-type.vala"
	_tmp0_[4] = GEARY_IMAP_STATUS_DATA_TYPE_UNSEEN;
#line 22 "../src/engine/imap/message/imap-status-data-type.vala"
	_tmp1_ = _tmp0_;
#line 22 "../src/engine/imap/message/imap-status-data-type.vala"
	_tmp1__length1 = 5;
#line 22 "../src/engine/imap/message/imap-status-data-type.vala"
	if (result_length1) {
#line 22 "../src/engine/imap/message/imap-status-data-type.vala"
		*result_length1 = _tmp1__length1;
#line 61 "imap-status-data-type.c"
	}
#line 22 "../src/engine/imap/message/imap-status-data-type.vala"
	result = _tmp1_;
#line 22 "../src/engine/imap/message/imap-status-data-type.vala"
	return result;
#line 67 "imap-status-data-type.c"
}

gchar*
geary_imap_status_data_type_to_string (GearyImapStatusDataType self)
{
	gchar* result;
#line 26 "../src/engine/imap/message/imap-status-data-type.vala"
	switch (self) {
#line 26 "../src/engine/imap/message/imap-status-data-type.vala"
		case GEARY_IMAP_STATUS_DATA_TYPE_MESSAGES:
#line 78 "imap-status-data-type.c"
		{
			gchar* _tmp0_;
#line 28 "../src/engine/imap/message/imap-status-data-type.vala"
			_tmp0_ = g_strdup ("MESSAGES");
#line 28 "../src/engine/imap/message/imap-status-data-type.vala"
			result = _tmp0_;
#line 28 "../src/engine/imap/message/imap-status-data-type.vala"
			return result;
#line 87 "imap-status-data-type.c"
		}
#line 26 "../src/engine/imap/message/imap-status-data-type.vala"
		case GEARY_IMAP_STATUS_DATA_TYPE_RECENT:
#line 91 "imap-status-data-type.c"
		{
			gchar* _tmp1_;
#line 31 "../src/engine/imap/message/imap-status-data-type.vala"
			_tmp1_ = g_strdup ("RECENT");
#line 31 "../src/engine/imap/message/imap-status-data-type.vala"
			result = _tmp1_;
#line 31 "../src/engine/imap/message/imap-status-data-type.vala"
			return result;
#line 100 "imap-status-data-type.c"
		}
#line 26 "../src/engine/imap/message/imap-status-data-type.vala"
		case GEARY_IMAP_STATUS_DATA_TYPE_UIDNEXT:
#line 104 "imap-status-data-type.c"
		{
			gchar* _tmp2_;
#line 34 "../src/engine/imap/message/imap-status-data-type.vala"
			_tmp2_ = g_strdup ("UIDNEXT");
#line 34 "../src/engine/imap/message/imap-status-data-type.vala"
			result = _tmp2_;
#line 34 "../src/engine/imap/message/imap-status-data-type.vala"
			return result;
#line 113 "imap-status-data-type.c"
		}
#line 26 "../src/engine/imap/message/imap-status-data-type.vala"
		case GEARY_IMAP_STATUS_DATA_TYPE_UIDVALIDITY:
#line 117 "imap-status-data-type.c"
		{
			gchar* _tmp3_;
#line 37 "../src/engine/imap/message/imap-status-data-type.vala"
			_tmp3_ = g_strdup ("UIDVALIDITY");
#line 37 "../src/engine/imap/message/imap-status-data-type.vala"
			result = _tmp3_;
#line 37 "../src/engine/imap/message/imap-status-data-type.vala"
			return result;
#line 126 "imap-status-data-type.c"
		}
#line 26 "../src/engine/imap/message/imap-status-data-type.vala"
		case GEARY_IMAP_STATUS_DATA_TYPE_UNSEEN:
#line 130 "imap-status-data-type.c"
		{
			gchar* _tmp4_;
#line 40 "../src/engine/imap/message/imap-status-data-type.vala"
			_tmp4_ = g_strdup ("UNSEEN");
#line 40 "../src/engine/imap/message/imap-status-data-type.vala"
			result = _tmp4_;
#line 40 "../src/engine/imap/message/imap-status-data-type.vala"
			return result;
#line 139 "imap-status-data-type.c"
		}
		default:
		{
#line 43 "../src/engine/imap/message/imap-status-data-type.vala"
			g_assert_not_reached ();
#line 145 "imap-status-data-type.c"
		}
	}
}

GearyImapStatusDataType
geary_imap_status_data_type_from_parameter (GearyImapStringParameter* stringp,
                                            GError** error)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 48 "../src/engine/imap/message/imap-status-data-type.vala"
	static GQuark _tmp2_label0 = 0;
#line 48 "../src/engine/imap/message/imap-status-data-type.vala"
	static GQuark _tmp2_label1 = 0;
#line 48 "../src/engine/imap/message/imap-status-data-type.vala"
	static GQuark _tmp2_label2 = 0;
#line 48 "../src/engine/imap/message/imap-status-data-type.vala"
	static GQuark _tmp2_label3 = 0;
#line 48 "../src/engine/imap/message/imap-status-data-type.vala"
	static GQuark _tmp2_label4 = 0;
#line 167 "imap-status-data-type.c"
	GError* _inner_error0_ = NULL;
	GearyImapStatusDataType result;
#line 47 "../src/engine/imap/message/imap-status-data-type.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_STRING_PARAMETER (stringp), 0);
#line 48 "../src/engine/imap/message/imap-status-data-type.vala"
	_tmp0_ = geary_imap_string_parameter_as_lower (stringp);
#line 48 "../src/engine/imap/message/imap-status-data-type.vala"
	_tmp1_ = _tmp0_;
#line 48 "../src/engine/imap/message/imap-status-data-type.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 48 "../src/engine/imap/message/imap-status-data-type.vala"
	g_free (_tmp1_);
#line 48 "../src/engine/imap/message/imap-status-data-type.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("messages")))) {
#line 48 "../src/engine/imap/message/imap-status-data-type.vala"
		switch (0) {
#line 184 "imap-status-data-type.c"
			default:
			{
#line 50 "../src/engine/imap/message/imap-status-data-type.vala"
				result = GEARY_IMAP_STATUS_DATA_TYPE_MESSAGES;
#line 50 "../src/engine/imap/message/imap-status-data-type.vala"
				return result;
#line 191 "imap-status-data-type.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("recent")))) {
#line 48 "../src/engine/imap/message/imap-status-data-type.vala"
		switch (0) {
#line 197 "imap-status-data-type.c"
			default:
			{
#line 53 "../src/engine/imap/message/imap-status-data-type.vala"
				result = GEARY_IMAP_STATUS_DATA_TYPE_RECENT;
#line 53 "../src/engine/imap/message/imap-status-data-type.vala"
				return result;
#line 204 "imap-status-data-type.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("uidnext")))) {
#line 48 "../src/engine/imap/message/imap-status-data-type.vala"
		switch (0) {
#line 210 "imap-status-data-type.c"
			default:
			{
#line 56 "../src/engine/imap/message/imap-status-data-type.vala"
				result = GEARY_IMAP_STATUS_DATA_TYPE_UIDNEXT;
#line 56 "../src/engine/imap/message/imap-status-data-type.vala"
				return result;
#line 217 "imap-status-data-type.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("uidvalidity")))) {
#line 48 "../src/engine/imap/message/imap-status-data-type.vala"
		switch (0) {
#line 223 "imap-status-data-type.c"
			default:
			{
#line 59 "../src/engine/imap/message/imap-status-data-type.vala"
				result = GEARY_IMAP_STATUS_DATA_TYPE_UIDVALIDITY;
#line 59 "../src/engine/imap/message/imap-status-data-type.vala"
				return result;
#line 230 "imap-status-data-type.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("unseen")))) {
#line 48 "../src/engine/imap/message/imap-status-data-type.vala"
		switch (0) {
#line 236 "imap-status-data-type.c"
			default:
			{
#line 62 "../src/engine/imap/message/imap-status-data-type.vala"
				result = GEARY_IMAP_STATUS_DATA_TYPE_UNSEEN;
#line 62 "../src/engine/imap/message/imap-status-data-type.vala"
				return result;
#line 243 "imap-status-data-type.c"
			}
		}
	} else {
#line 48 "../src/engine/imap/message/imap-status-data-type.vala"
		switch (0) {
#line 249 "imap-status-data-type.c"
			default:
			{
				gchar* _tmp4_;
				gchar* _tmp5_;
				GError* _tmp6_;
				GError* _tmp7_;
#line 65 "../src/engine/imap/message/imap-status-data-type.vala"
				_tmp4_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (stringp, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 65 "../src/engine/imap/message/imap-status-data-type.vala"
				_tmp5_ = _tmp4_;
#line 65 "../src/engine/imap/message/imap-status-data-type.vala"
				_tmp6_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_PARSE_ERROR, "Unknown status data type \"%s\"", _tmp5_);
#line 65 "../src/engine/imap/message/imap-status-data-type.vala"
				_tmp7_ = _tmp6_;
#line 65 "../src/engine/imap/message/imap-status-data-type.vala"
				_g_free0 (_tmp5_);
#line 65 "../src/engine/imap/message/imap-status-data-type.vala"
				_inner_error0_ = _tmp7_;
#line 65 "../src/engine/imap/message/imap-status-data-type.vala"
				if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 65 "../src/engine/imap/message/imap-status-data-type.vala"
					g_propagate_error (error, _inner_error0_);
#line 65 "../src/engine/imap/message/imap-status-data-type.vala"
					return 0;
#line 274 "imap-status-data-type.c"
				} else {
#line 65 "../src/engine/imap/message/imap-status-data-type.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 65 "../src/engine/imap/message/imap-status-data-type.vala"
					g_clear_error (&_inner_error0_);
#line 65 "../src/engine/imap/message/imap-status-data-type.vala"
					return 0;
#line 282 "imap-status-data-type.c"
				}
			}
		}
	}
}

GearyImapStringParameter*
geary_imap_status_data_type_to_parameter (GearyImapStatusDataType self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GearyImapAtomParameter* _tmp2_;
	GearyImapStringParameter* _tmp3_;
	GearyImapStringParameter* result;
#line 70 "../src/engine/imap/message/imap-status-data-type.vala"
	_tmp0_ = geary_imap_status_data_type_to_string (self);
#line 70 "../src/engine/imap/message/imap-status-data-type.vala"
	_tmp1_ = _tmp0_;
#line 70 "../src/engine/imap/message/imap-status-data-type.vala"
	_tmp2_ = geary_imap_atom_parameter_new (_tmp1_);
#line 70 "../src/engine/imap/message/imap-status-data-type.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEARY_IMAP_TYPE_STRING_PARAMETER, GearyImapStringParameter);
#line 70 "../src/engine/imap/message/imap-status-data-type.vala"
	_g_free0 (_tmp1_);
#line 70 "../src/engine/imap/message/imap-status-data-type.vala"
	result = _tmp3_;
#line 70 "../src/engine/imap/message/imap-status-data-type.vala"
	return result;
#line 311 "imap-status-data-type.c"
}

 G_GNUC_NO_INLINE static GType
geary_imap_status_data_type_get_type_once (void)
{
	static const GEnumValue values[] = {{GEARY_IMAP_STATUS_DATA_TYPE_MESSAGES, "GEARY_IMAP_STATUS_DATA_TYPE_MESSAGES", "messages"}, {GEARY_IMAP_STATUS_DATA_TYPE_RECENT, "GEARY_IMAP_STATUS_DATA_TYPE_RECENT", "recent"}, {GEARY_IMAP_STATUS_DATA_TYPE_UIDNEXT, "GEARY_IMAP_STATUS_DATA_TYPE_UIDNEXT", "uidnext"}, {GEARY_IMAP_STATUS_DATA_TYPE_UIDVALIDITY, "GEARY_IMAP_STATUS_DATA_TYPE_UIDVALIDITY", "uidvalidity"}, {GEARY_IMAP_STATUS_DATA_TYPE_UNSEEN, "GEARY_IMAP_STATUS_DATA_TYPE_UNSEEN", "unseen"}, {0, NULL, NULL}};
	GType geary_imap_status_data_type_type_id;
	geary_imap_status_data_type_type_id = g_enum_register_static ("GearyImapStatusDataType", values);
	return geary_imap_status_data_type_type_id;
}

GType
geary_imap_status_data_type_get_type (void)
{
	static gsize geary_imap_status_data_type_type_id__once = 0;
	if (g_once_init_enter (&geary_imap_status_data_type_type_id__once)) {
		GType geary_imap_status_data_type_type_id;
		geary_imap_status_data_type_type_id = geary_imap_status_data_type_get_type_once ();
		g_once_init_leave (&geary_imap_status_data_type_type_id__once, geary_imap_status_data_type_type_id);
	}
	return geary_imap_status_data_type_type_id__once;
}

