/* imap-parameter.c generated by valac 0.56.17, the Vala compiler
 * generated from imap-parameter.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_IMAP_PARAMETER_0_PROPERTY,
	GEARY_IMAP_PARAMETER_NUM_PROPERTIES
};
static GParamSpec* geary_imap_parameter_properties[GEARY_IMAP_PARAMETER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

static gpointer geary_imap_parameter_parent_class = NULL;

static void geary_imap_parameter_real_serialize (GearyImapParameter* self,
                                          GearyImapSerializer* ser,
                                          GCancellable* cancellable,
                                          GError** error);
static gchar* geary_imap_parameter_real_to_string (GearyImapParameter* self);
static GType geary_imap_parameter_get_type_once (void);

/**
     * Returns an appropriate {@link Parameter} for the string.
     *
     * get_for_string() goes from simple to complexity in terms of parameter encoding.  It uses
     * {@link StringParameter.get_best_for} first to attempt to produced an unquoted, then unquoted,
     * string.  (It will also produce a {@link NumberParameter} if appropriate.)  If the string
     * cannot be held in those forms, it returns a {@link LiteralParameter}, which is capable of
     * transmitting 8-bit data.
     */
GearyImapParameter*
geary_imap_parameter_get_for_string (const gchar* value)
{
	GError* _inner_error0_ = NULL;
	GearyImapParameter* result;
#line 25 "../src/engine/imap/parameter/imap-parameter.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 59 "imap-parameter.c"
	{
		GearyImapStringParameter* _tmp0_ = NULL;
		GearyImapStringParameter* _tmp1_;
		GearyImapStringParameter* _tmp2_;
#line 27 "../src/engine/imap/parameter/imap-parameter.vala"
		_tmp1_ = geary_imap_string_parameter_get_best_for (value, &_inner_error0_);
#line 27 "../src/engine/imap/parameter/imap-parameter.vala"
		_tmp0_ = _tmp1_;
#line 27 "../src/engine/imap/parameter/imap-parameter.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27 "../src/engine/imap/parameter/imap-parameter.vala"
			if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 72 "imap-parameter.c"
				goto __catch0_geary_imap_error;
			}
#line 27 "../src/engine/imap/parameter/imap-parameter.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 27 "../src/engine/imap/parameter/imap-parameter.vala"
			g_clear_error (&_inner_error0_);
#line 27 "../src/engine/imap/parameter/imap-parameter.vala"
			return NULL;
#line 81 "imap-parameter.c"
		}
#line 27 "../src/engine/imap/parameter/imap-parameter.vala"
		_tmp2_ = _tmp0_;
#line 27 "../src/engine/imap/parameter/imap-parameter.vala"
		_tmp0_ = NULL;
#line 27 "../src/engine/imap/parameter/imap-parameter.vala"
		result = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter);
#line 27 "../src/engine/imap/parameter/imap-parameter.vala"
		_g_object_unref0 (_tmp0_);
#line 27 "../src/engine/imap/parameter/imap-parameter.vala"
		return result;
#line 93 "imap-parameter.c"
	}
	goto __finally0;
	__catch0_geary_imap_error:
	{
		GearyMemoryStringBuffer* _tmp3_;
		GearyMemoryStringBuffer* _tmp4_;
		GearyImapLiteralParameter* _tmp5_;
		GearyImapParameter* _tmp6_;
#line 26 "../src/engine/imap/parameter/imap-parameter.vala"
		g_clear_error (&_inner_error0_);
#line 29 "../src/engine/imap/parameter/imap-parameter.vala"
		_tmp3_ = geary_memory_string_buffer_new (value);
#line 29 "../src/engine/imap/parameter/imap-parameter.vala"
		_tmp4_ = _tmp3_;
#line 29 "../src/engine/imap/parameter/imap-parameter.vala"
		_tmp5_ = geary_imap_literal_parameter_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBuffer));
#line 29 "../src/engine/imap/parameter/imap-parameter.vala"
		_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter);
#line 29 "../src/engine/imap/parameter/imap-parameter.vala"
		_g_object_unref0 (_tmp4_);
#line 29 "../src/engine/imap/parameter/imap-parameter.vala"
		result = _tmp6_;
#line 29 "../src/engine/imap/parameter/imap-parameter.vala"
		return result;
#line 118 "imap-parameter.c"
	}
	__finally0:
#line 26 "../src/engine/imap/parameter/imap-parameter.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 26 "../src/engine/imap/parameter/imap-parameter.vala"
	g_clear_error (&_inner_error0_);
#line 26 "../src/engine/imap/parameter/imap-parameter.vala"
	return NULL;
#line 127 "imap-parameter.c"
}

/**
     * Invoked when this parameter is to be serialized out to the network.
     *
     * This method is intended to be used for serialising IMAP command
     * lines, which are typically short, single lines. Hence this
     * method is not asynchronous since the serialiser will buffer
     * writes to it. Any parameters with large volumes of data to
     * serialise (typically {@link LiteralParameter}) are specially
     * handled by {@link Command} when serialising.
     */
static void
geary_imap_parameter_real_serialize (GearyImapParameter* self,
                                     GearyImapSerializer* ser,
                                     GCancellable* cancellable,
                                     GError** error)
{
#line 43 "../src/engine/imap/parameter/imap-parameter.vala"
	g_critical ("Type `%s' does not implement abstract method `geary_imap_parameter_serialize'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 43 "../src/engine/imap/parameter/imap-parameter.vala"
	return;
#line 150 "imap-parameter.c"
}

void
geary_imap_parameter_serialize (GearyImapParameter* self,
                                GearyImapSerializer* ser,
                                GCancellable* cancellable,
                                GError** error)
{
	GearyImapParameterClass* _klass_;
#line 43 "../src/engine/imap/parameter/imap-parameter.vala"
	g_return_if_fail (GEARY_IMAP_IS_PARAMETER (self));
#line 43 "../src/engine/imap/parameter/imap-parameter.vala"
	_klass_ = GEARY_IMAP_PARAMETER_GET_CLASS (self);
#line 43 "../src/engine/imap/parameter/imap-parameter.vala"
	if (_klass_->serialize) {
#line 43 "../src/engine/imap/parameter/imap-parameter.vala"
		_klass_->serialize (self, ser, cancellable, error);
#line 168 "imap-parameter.c"
	}
}

/**
     * Returns a representation of the {@link Parameter} suitable for logging and debugging,
     * but should not be relied upon for wire or persistent representation.
     */
static gchar*
geary_imap_parameter_real_to_string (GearyImapParameter* self)
{
#line 50 "../src/engine/imap/parameter/imap-parameter.vala"
	g_critical ("Type `%s' does not implement abstract method `geary_imap_parameter_to_string'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 50 "../src/engine/imap/parameter/imap-parameter.vala"
	return NULL;
#line 183 "imap-parameter.c"
}

gchar*
geary_imap_parameter_to_string (GearyImapParameter* self)
{
	GearyImapParameterClass* _klass_;
#line 50 "../src/engine/imap/parameter/imap-parameter.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_PARAMETER (self), NULL);
#line 50 "../src/engine/imap/parameter/imap-parameter.vala"
	_klass_ = GEARY_IMAP_PARAMETER_GET_CLASS (self);
#line 50 "../src/engine/imap/parameter/imap-parameter.vala"
	if (_klass_->to_string) {
#line 50 "../src/engine/imap/parameter/imap-parameter.vala"
		return _klass_->to_string (self);
#line 198 "imap-parameter.c"
	}
#line 50 "../src/engine/imap/parameter/imap-parameter.vala"
	return NULL;
#line 202 "imap-parameter.c"
}

GearyImapParameter*
geary_imap_parameter_construct (GType object_type)
{
	GearyImapParameter * self = NULL;
#line 15 "../src/engine/imap/parameter/imap-parameter.vala"
	self = (GearyImapParameter*) geary_base_object_construct (object_type);
#line 15 "../src/engine/imap/parameter/imap-parameter.vala"
	return self;
#line 213 "imap-parameter.c"
}

static void
geary_imap_parameter_class_init (GearyImapParameterClass * klass,
                                 gpointer klass_data)
{
#line 15 "../src/engine/imap/parameter/imap-parameter.vala"
	geary_imap_parameter_parent_class = g_type_class_peek_parent (klass);
#line 15 "../src/engine/imap/parameter/imap-parameter.vala"
	((GearyImapParameterClass *) klass)->serialize = (void (*) (GearyImapParameter*, GearyImapSerializer*, GCancellable*, GError**)) geary_imap_parameter_real_serialize;
#line 15 "../src/engine/imap/parameter/imap-parameter.vala"
	((GearyImapParameterClass *) klass)->to_string = (gchar* (*) (GearyImapParameter*)) geary_imap_parameter_real_to_string;
#line 226 "imap-parameter.c"
}

static void
geary_imap_parameter_instance_init (GearyImapParameter * self,
                                    gpointer klass)
{
}

/**
 * The basic abstraction of a single IMAP parameter that may be serialized and deserialized to and
 * from the network.
 *
 * @see Serializer
 * @see Deserializer
 */
 G_GNUC_NO_INLINE static GType
geary_imap_parameter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyImapParameterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_imap_parameter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyImapParameter), 0, (GInstanceInitFunc) geary_imap_parameter_instance_init, NULL };
	GType geary_imap_parameter_type_id;
	geary_imap_parameter_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyImapParameter", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return geary_imap_parameter_type_id;
}

GType
geary_imap_parameter_get_type (void)
{
	static gsize geary_imap_parameter_type_id__once = 0;
	if (g_once_init_enter (&geary_imap_parameter_type_id__once)) {
		GType geary_imap_parameter_type_id;
		geary_imap_parameter_type_id = geary_imap_parameter_get_type_once ();
		g_once_init_leave (&geary_imap_parameter_type_id__once, geary_imap_parameter_type_id);
	}
	return geary_imap_parameter_type_id__once;
}

