/* imap-status.c generated by valac 0.56.17, the Vala compiler
 * generated from imap-status.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))

/**
 * An optional status code accompanying a {@link ServerResponse}.
 *
 * See [[http://tools.ietf.org/html/rfc3501#section-7.1]] for more information.
 */
gchar*
geary_imap_status_to_string (GearyImapStatus self)
{
	gchar* result;
#line 21 "../src/engine/imap/response/imap-status.vala"
	switch (self) {
#line 21 "../src/engine/imap/response/imap-status.vala"
		case GEARY_IMAP_STATUS_OK:
#line 40 "imap-status.c"
		{
			gchar* _tmp0_;
#line 23 "../src/engine/imap/response/imap-status.vala"
			_tmp0_ = g_strdup ("ok");
#line 23 "../src/engine/imap/response/imap-status.vala"
			result = _tmp0_;
#line 23 "../src/engine/imap/response/imap-status.vala"
			return result;
#line 49 "imap-status.c"
		}
#line 21 "../src/engine/imap/response/imap-status.vala"
		case GEARY_IMAP_STATUS_NO:
#line 53 "imap-status.c"
		{
			gchar* _tmp1_;
#line 26 "../src/engine/imap/response/imap-status.vala"
			_tmp1_ = g_strdup ("no");
#line 26 "../src/engine/imap/response/imap-status.vala"
			result = _tmp1_;
#line 26 "../src/engine/imap/response/imap-status.vala"
			return result;
#line 62 "imap-status.c"
		}
#line 21 "../src/engine/imap/response/imap-status.vala"
		case GEARY_IMAP_STATUS_BAD:
#line 66 "imap-status.c"
		{
			gchar* _tmp2_;
#line 29 "../src/engine/imap/response/imap-status.vala"
			_tmp2_ = g_strdup ("bad");
#line 29 "../src/engine/imap/response/imap-status.vala"
			result = _tmp2_;
#line 29 "../src/engine/imap/response/imap-status.vala"
			return result;
#line 75 "imap-status.c"
		}
#line 21 "../src/engine/imap/response/imap-status.vala"
		case GEARY_IMAP_STATUS_PREAUTH:
#line 79 "imap-status.c"
		{
			gchar* _tmp3_;
#line 32 "../src/engine/imap/response/imap-status.vala"
			_tmp3_ = g_strdup ("preauth");
#line 32 "../src/engine/imap/response/imap-status.vala"
			result = _tmp3_;
#line 32 "../src/engine/imap/response/imap-status.vala"
			return result;
#line 88 "imap-status.c"
		}
#line 21 "../src/engine/imap/response/imap-status.vala"
		case GEARY_IMAP_STATUS_BYE:
#line 92 "imap-status.c"
		{
			gchar* _tmp4_;
#line 35 "../src/engine/imap/response/imap-status.vala"
			_tmp4_ = g_strdup ("bye");
#line 35 "../src/engine/imap/response/imap-status.vala"
			result = _tmp4_;
#line 35 "../src/engine/imap/response/imap-status.vala"
			return result;
#line 101 "imap-status.c"
		}
		default:
		{
#line 38 "../src/engine/imap/response/imap-status.vala"
			g_assert_not_reached ();
#line 107 "imap-status.c"
		}
	}
}

GearyImapStatus
geary_imap_status_from_parameter (GearyImapStringParameter* strparam,
                                  GError** error)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 43 "../src/engine/imap/response/imap-status.vala"
	static GQuark _tmp2_label0 = 0;
#line 43 "../src/engine/imap/response/imap-status.vala"
	static GQuark _tmp2_label1 = 0;
#line 43 "../src/engine/imap/response/imap-status.vala"
	static GQuark _tmp2_label2 = 0;
#line 43 "../src/engine/imap/response/imap-status.vala"
	static GQuark _tmp2_label3 = 0;
#line 43 "../src/engine/imap/response/imap-status.vala"
	static GQuark _tmp2_label4 = 0;
#line 129 "imap-status.c"
	GError* _inner_error0_ = NULL;
	GearyImapStatus result;
#line 42 "../src/engine/imap/response/imap-status.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_STRING_PARAMETER (strparam), 0);
#line 43 "../src/engine/imap/response/imap-status.vala"
	_tmp0_ = geary_imap_string_parameter_as_lower (strparam);
#line 43 "../src/engine/imap/response/imap-status.vala"
	_tmp1_ = _tmp0_;
#line 43 "../src/engine/imap/response/imap-status.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 43 "../src/engine/imap/response/imap-status.vala"
	g_free (_tmp1_);
#line 43 "../src/engine/imap/response/imap-status.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("ok")))) {
#line 43 "../src/engine/imap/response/imap-status.vala"
		switch (0) {
#line 146 "imap-status.c"
			default:
			{
#line 45 "../src/engine/imap/response/imap-status.vala"
				result = GEARY_IMAP_STATUS_OK;
#line 45 "../src/engine/imap/response/imap-status.vala"
				return result;
#line 153 "imap-status.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("no")))) {
#line 43 "../src/engine/imap/response/imap-status.vala"
		switch (0) {
#line 159 "imap-status.c"
			default:
			{
#line 48 "../src/engine/imap/response/imap-status.vala"
				result = GEARY_IMAP_STATUS_NO;
#line 48 "../src/engine/imap/response/imap-status.vala"
				return result;
#line 166 "imap-status.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("bad")))) {
#line 43 "../src/engine/imap/response/imap-status.vala"
		switch (0) {
#line 172 "imap-status.c"
			default:
			{
#line 51 "../src/engine/imap/response/imap-status.vala"
				result = GEARY_IMAP_STATUS_BAD;
#line 51 "../src/engine/imap/response/imap-status.vala"
				return result;
#line 179 "imap-status.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("preauth")))) {
#line 43 "../src/engine/imap/response/imap-status.vala"
		switch (0) {
#line 185 "imap-status.c"
			default:
			{
#line 54 "../src/engine/imap/response/imap-status.vala"
				result = GEARY_IMAP_STATUS_PREAUTH;
#line 54 "../src/engine/imap/response/imap-status.vala"
				return result;
#line 192 "imap-status.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("bye")))) {
#line 43 "../src/engine/imap/response/imap-status.vala"
		switch (0) {
#line 198 "imap-status.c"
			default:
			{
#line 57 "../src/engine/imap/response/imap-status.vala"
				result = GEARY_IMAP_STATUS_BYE;
#line 57 "../src/engine/imap/response/imap-status.vala"
				return result;
#line 205 "imap-status.c"
			}
		}
	} else {
#line 43 "../src/engine/imap/response/imap-status.vala"
		switch (0) {
#line 211 "imap-status.c"
			default:
			{
				gchar* _tmp4_;
				gchar* _tmp5_;
				GError* _tmp6_;
				GError* _tmp7_;
#line 60 "../src/engine/imap/response/imap-status.vala"
				_tmp4_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (strparam, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 60 "../src/engine/imap/response/imap-status.vala"
				_tmp5_ = _tmp4_;
#line 60 "../src/engine/imap/response/imap-status.vala"
				_tmp6_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_PARSE_ERROR, "Unrecognized status response \"%s\"", _tmp5_);
#line 60 "../src/engine/imap/response/imap-status.vala"
				_tmp7_ = _tmp6_;
#line 60 "../src/engine/imap/response/imap-status.vala"
				_g_free0 (_tmp5_);
#line 60 "../src/engine/imap/response/imap-status.vala"
				_inner_error0_ = _tmp7_;
#line 60 "../src/engine/imap/response/imap-status.vala"
				if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 60 "../src/engine/imap/response/imap-status.vala"
					g_propagate_error (error, _inner_error0_);
#line 60 "../src/engine/imap/response/imap-status.vala"
					return 0;
#line 236 "imap-status.c"
				} else {
#line 60 "../src/engine/imap/response/imap-status.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 60 "../src/engine/imap/response/imap-status.vala"
					g_clear_error (&_inner_error0_);
#line 60 "../src/engine/imap/response/imap-status.vala"
					return 0;
#line 244 "imap-status.c"
				}
			}
		}
	}
}

GearyImapParameter*
geary_imap_status_to_parameter (GearyImapStatus self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GearyImapAtomParameter* _tmp2_;
	GearyImapParameter* _tmp3_;
	GearyImapParameter* result;
#line 65 "../src/engine/imap/response/imap-status.vala"
	_tmp0_ = geary_imap_status_to_string (self);
#line 65 "../src/engine/imap/response/imap-status.vala"
	_tmp1_ = _tmp0_;
#line 65 "../src/engine/imap/response/imap-status.vala"
	_tmp2_ = geary_imap_atom_parameter_new (_tmp1_);
#line 65 "../src/engine/imap/response/imap-status.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter);
#line 65 "../src/engine/imap/response/imap-status.vala"
	_g_free0 (_tmp1_);
#line 65 "../src/engine/imap/response/imap-status.vala"
	result = _tmp3_;
#line 65 "../src/engine/imap/response/imap-status.vala"
	return result;
#line 273 "imap-status.c"
}

 G_GNUC_NO_INLINE static GType
geary_imap_status_get_type_once (void)
{
	static const GEnumValue values[] = {{GEARY_IMAP_STATUS_OK, "GEARY_IMAP_STATUS_OK", "ok"}, {GEARY_IMAP_STATUS_NO, "GEARY_IMAP_STATUS_NO", "no"}, {GEARY_IMAP_STATUS_BAD, "GEARY_IMAP_STATUS_BAD", "bad"}, {GEARY_IMAP_STATUS_PREAUTH, "GEARY_IMAP_STATUS_PREAUTH", "preauth"}, {GEARY_IMAP_STATUS_BYE, "GEARY_IMAP_STATUS_BYE", "bye"}, {0, NULL, NULL}};
	GType geary_imap_status_type_id;
	geary_imap_status_type_id = g_enum_register_static ("GearyImapStatus", values);
	return geary_imap_status_type_id;
}

GType
geary_imap_status_get_type (void)
{
	static gsize geary_imap_status_type_id__once = 0;
	if (g_once_init_enter (&geary_imap_status_type_id__once)) {
		GType geary_imap_status_type_id;
		geary_imap_status_type_id = geary_imap_status_get_type_once ();
		g_once_init_leave (&geary_imap_status_type_id__once, geary_imap_status_type_id);
	}
	return geary_imap_status_type_id__once;
}

