/* imap-serializer.c generated by valac 0.56.17, the Vala compiler
 * generated from imap-serializer.vala, do not modify */

/*
 * Copyright © 2016 Software Freedom Conservancy Inc.
 * Copyright © 2018, 2020 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

#define GEARY_IMAP_SERIALIZER_EOL "\r\n"
#define GEARY_IMAP_SERIALIZER_SPACE " "
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_IMAP_SERIALIZER_0_PROPERTY,
	GEARY_IMAP_SERIALIZER_NUM_PROPERTIES
};
static GParamSpec* geary_imap_serializer_properties[GEARY_IMAP_SERIALIZER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _GearyImapSerializerPushLiteralDataData GearyImapSerializerPushLiteralDataData;
typedef struct _GearyImapSerializerFlushStreamData GearyImapSerializerFlushStreamData;
typedef struct _GearyImapSerializerCloseStreamData GearyImapSerializerCloseStreamData;

struct _GearyImapSerializerPrivate {
	GOutputStream* output;
};

struct _GearyImapSerializerPushLiteralDataData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapSerializer* self;
	guint8* buffer;
	gint buffer_length1;
	GCancellable* cancellable;
	GOutputStream* _tmp0_;
	GError* _inner_error0_;
};

struct _GearyImapSerializerFlushStreamData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapSerializer* self;
	GCancellable* cancellable;
	GOutputStream* _tmp0_;
	GError* _inner_error0_;
};

struct _GearyImapSerializerCloseStreamData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapSerializer* self;
	GCancellable* cancellable;
	GOutputStream* _tmp0_;
	GError* _inner_error0_;
};

static gint GearyImapSerializer_private_offset;
static gpointer geary_imap_serializer_parent_class = NULL;

static void geary_imap_serializer_push_literal_data_data_free (gpointer _data);
static gboolean geary_imap_serializer_push_literal_data_co (GearyImapSerializerPushLiteralDataData* _data_);
static void geary_imap_serializer_push_literal_data_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_);
static void geary_imap_serializer_flush_stream_data_free (gpointer _data);
static gboolean geary_imap_serializer_flush_stream_co (GearyImapSerializerFlushStreamData* _data_);
static void geary_imap_serializer_flush_stream_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static void geary_imap_serializer_close_stream_data_free (gpointer _data);
static gboolean geary_imap_serializer_close_stream_co (GearyImapSerializerCloseStreamData* _data_);
static void geary_imap_serializer_close_stream_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static void geary_imap_serializer_finalize (GObject * obj);
static GType geary_imap_serializer_get_type_once (void);

static inline gpointer
geary_imap_serializer_get_instance_private (GearyImapSerializer* self)
{
	return G_STRUCT_MEMBER_P (self, GearyImapSerializer_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 32 "../src/engine/imap/transport/imap-serializer.vala"
	return self ? g_object_ref (self) : NULL;
#line 113 "imap-serializer.c"
}

GearyImapSerializer*
geary_imap_serializer_construct (GType object_type,
                                 GOutputStream* output)
{
	GearyImapSerializer * self = NULL;
	GOutputStream* _tmp0_;
#line 31 "../src/engine/imap/transport/imap-serializer.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (output, g_output_stream_get_type ()), NULL);
#line 31 "../src/engine/imap/transport/imap-serializer.vala"
	self = (GearyImapSerializer*) geary_base_object_construct (object_type);
#line 32 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp0_ = _g_object_ref0 (output);
#line 32 "../src/engine/imap/transport/imap-serializer.vala"
	_g_object_unref0 (self->priv->output);
#line 32 "../src/engine/imap/transport/imap-serializer.vala"
	self->priv->output = _tmp0_;
#line 31 "../src/engine/imap/transport/imap-serializer.vala"
	return self;
#line 134 "imap-serializer.c"
}

GearyImapSerializer*
geary_imap_serializer_new (GOutputStream* output)
{
#line 31 "../src/engine/imap/transport/imap-serializer.vala"
	return geary_imap_serializer_construct (GEARY_IMAP_TYPE_SERIALIZER, output);
#line 142 "imap-serializer.c"
}

/**
     * Writes a string without quoting.
     *
     * It is the caller's responsibility to ensure that the value is
     * valid to be written as an unquoted string, instead of with
     * quoting or as a literal.
     */
static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 186 "imap-serializer.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 192 "imap-serializer.c"
}

void
geary_imap_serializer_push_unquoted_string (GearyImapSerializer* self,
                                            const gchar* str,
                                            GCancellable* cancellable,
                                            GError** error)
{
	GOutputStream* _tmp0_;
	guint8* _tmp1_;
	gint _tmp1__length1;
	gint _tmp2_ = 0;
	guint8* _tmp3_;
	gint _tmp3__length1;
	GError* _inner_error0_ = NULL;
#line 42 "../src/engine/imap/transport/imap-serializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_SERIALIZER (self));
#line 42 "../src/engine/imap/transport/imap-serializer.vala"
	g_return_if_fail (str != NULL);
#line 42 "../src/engine/imap/transport/imap-serializer.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 45 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp0_ = self->priv->output;
#line 45 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp1_ = string_get_data (str, &_tmp2_);
#line 45 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp1__length1 = _tmp2_;
#line 45 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp3_ = _tmp1_;
#line 45 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp3__length1 = _tmp1__length1;
#line 45 "../src/engine/imap/transport/imap-serializer.vala"
	g_output_stream_write_all (_tmp0_, _tmp3_, (gsize) _tmp3__length1, NULL, cancellable, &_inner_error0_);
#line 45 "../src/engine/imap/transport/imap-serializer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 45 "../src/engine/imap/transport/imap-serializer.vala"
		g_propagate_error (error, _inner_error0_);
#line 45 "../src/engine/imap/transport/imap-serializer.vala"
		return;
#line 232 "imap-serializer.c"
	}
}

/**
     * Writes a string with quoting.
     *
     * It is the caller's responsibility to ensure that the value is
     * valid to be written as a quoted string, instead of as a
     * literal.
     */
static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 257 "imap-serializer.c"
}

static guint8*
g_string_get_data (GString* self,
                   gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	const gchar* _tmp0_;
	gint res_length1;
	gint _res_size_;
	guint8* _tmp1_;
	gint _tmp1__length1;
#line 5821 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 5822 "glib-2.0.vapi"
	_tmp0_ = self->str;
#line 5822 "glib-2.0.vapi"
	res = (guint8*) _tmp0_;
#line 5822 "glib-2.0.vapi"
	res_length1 = -1;
#line 5822 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 5823 "glib-2.0.vapi"
	res_length1 = (gint) self->len;
#line 5824 "glib-2.0.vapi"
	_tmp1_ = res;
#line 5824 "glib-2.0.vapi"
	_tmp1__length1 = res_length1;
#line 5824 "glib-2.0.vapi"
	if (result_length1) {
#line 5824 "glib-2.0.vapi"
		*result_length1 = _tmp1__length1;
#line 291 "imap-serializer.c"
	}
#line 5824 "glib-2.0.vapi"
	result = _tmp1_;
#line 5824 "glib-2.0.vapi"
	return result;
#line 297 "imap-serializer.c"
}

void
geary_imap_serializer_push_quoted_string (GearyImapSerializer* self,
                                          const gchar* str,
                                          GCancellable* cancellable,
                                          GError** error)
{
	GString* buf = NULL;
	gint _tmp0_;
	gint _tmp1_;
	GString* _tmp2_;
	GString* _tmp3_;
	gint index = 0;
	gchar ch = '\0';
	GString* _tmp8_;
	GOutputStream* _tmp9_;
	GString* _tmp10_;
	guint8* _tmp11_;
	gint _tmp11__length1;
	gint _tmp12_ = 0;
	guint8* _tmp13_;
	gint _tmp13__length1;
	GError* _inner_error0_ = NULL;
#line 55 "../src/engine/imap/transport/imap-serializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_SERIALIZER (self));
#line 55 "../src/engine/imap/transport/imap-serializer.vala"
	g_return_if_fail (str != NULL);
#line 55 "../src/engine/imap/transport/imap-serializer.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 58 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp0_ = strlen (str);
#line 58 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp1_ = _tmp0_;
#line 58 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp2_ = g_string_sized_new ((gsize) (_tmp1_ + 2));
#line 58 "../src/engine/imap/transport/imap-serializer.vala"
	buf = _tmp2_;
#line 59 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp3_ = buf;
#line 59 "../src/engine/imap/transport/imap-serializer.vala"
	g_string_append_c (_tmp3_, '"');
#line 60 "../src/engine/imap/transport/imap-serializer.vala"
	index = 0;
#line 61 "../src/engine/imap/transport/imap-serializer.vala"
	ch = string_get (str, (glong) index);
#line 62 "../src/engine/imap/transport/imap-serializer.vala"
	while (TRUE) {
#line 346 "imap-serializer.c"
		gboolean _tmp4_ = FALSE;
		GString* _tmp6_;
		gint _tmp7_;
#line 62 "../src/engine/imap/transport/imap-serializer.vala"
		if (!(ch != GEARY_STRING_EOS)) {
#line 62 "../src/engine/imap/transport/imap-serializer.vala"
			break;
#line 354 "imap-serializer.c"
		}
#line 63 "../src/engine/imap/transport/imap-serializer.vala"
		if (ch == '"') {
#line 63 "../src/engine/imap/transport/imap-serializer.vala"
			_tmp4_ = TRUE;
#line 360 "imap-serializer.c"
		} else {
#line 63 "../src/engine/imap/transport/imap-serializer.vala"
			_tmp4_ = ch == '\\';
#line 364 "imap-serializer.c"
		}
#line 63 "../src/engine/imap/transport/imap-serializer.vala"
		if (_tmp4_) {
#line 368 "imap-serializer.c"
			GString* _tmp5_;
#line 64 "../src/engine/imap/transport/imap-serializer.vala"
			_tmp5_ = buf;
#line 64 "../src/engine/imap/transport/imap-serializer.vala"
			g_string_append_c (_tmp5_, '\\');
#line 374 "imap-serializer.c"
		}
#line 66 "../src/engine/imap/transport/imap-serializer.vala"
		_tmp6_ = buf;
#line 66 "../src/engine/imap/transport/imap-serializer.vala"
		g_string_append_c (_tmp6_, ch);
#line 67 "../src/engine/imap/transport/imap-serializer.vala"
		index = index + 1;
#line 67 "../src/engine/imap/transport/imap-serializer.vala"
		_tmp7_ = index;
#line 67 "../src/engine/imap/transport/imap-serializer.vala"
		ch = string_get (str, (glong) _tmp7_);
#line 386 "imap-serializer.c"
	}
#line 69 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp8_ = buf;
#line 69 "../src/engine/imap/transport/imap-serializer.vala"
	g_string_append_c (_tmp8_, '"');
#line 70 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp9_ = self->priv->output;
#line 70 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp10_ = buf;
#line 70 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp11_ = g_string_get_data (_tmp10_, &_tmp12_);
#line 70 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp11__length1 = _tmp12_;
#line 70 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp13_ = _tmp11_;
#line 70 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp13__length1 = _tmp11__length1;
#line 70 "../src/engine/imap/transport/imap-serializer.vala"
	g_output_stream_write_all (_tmp9_, _tmp13_, (gsize) _tmp13__length1, NULL, cancellable, &_inner_error0_);
#line 70 "../src/engine/imap/transport/imap-serializer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 70 "../src/engine/imap/transport/imap-serializer.vala"
		g_propagate_error (error, _inner_error0_);
#line 70 "../src/engine/imap/transport/imap-serializer.vala"
		_g_string_free0 (buf);
#line 70 "../src/engine/imap/transport/imap-serializer.vala"
		return;
#line 414 "imap-serializer.c"
	}
#line 55 "../src/engine/imap/transport/imap-serializer.vala"
	_g_string_free0 (buf);
#line 418 "imap-serializer.c"
}

/**
     * Writes a single ASCII character.
     *
     * It is the caller's responsibility to ensure that the value is
     * valid to be written as-is.
     */
void
geary_imap_serializer_push_ascii (GearyImapSerializer* self,
                                  gchar ch,
                                  GCancellable* cancellable,
                                  GError** error)
{
	guint8 buf[1] = {0};
	guint8 _tmp0_[1] = {0};
	GOutputStream* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 79 "../src/engine/imap/transport/imap-serializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_SERIALIZER (self));
#line 79 "../src/engine/imap/transport/imap-serializer.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 82 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp0_[0] = (guint8) ch;
#line 82 "../src/engine/imap/transport/imap-serializer.vala"
	memcpy (buf, _tmp0_, 1 * sizeof (guint8));
#line 83 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp1_ = self->priv->output;
#line 83 "../src/engine/imap/transport/imap-serializer.vala"
	g_output_stream_write_all (_tmp1_, buf, (gsize) 1, NULL, cancellable, &_inner_error0_);
#line 83 "../src/engine/imap/transport/imap-serializer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 83 "../src/engine/imap/transport/imap-serializer.vala"
		g_propagate_error (error, _inner_error0_);
#line 83 "../src/engine/imap/transport/imap-serializer.vala"
		return;
#line 455 "imap-serializer.c"
	}
}

/**
     * Writes a ASCII space character.
     */
void
geary_imap_serializer_push_space (GearyImapSerializer* self,
                                  GCancellable* cancellable,
                                  GError** error)
{
	GOutputStream* _tmp0_;
	guint8* _tmp1_;
	gint _tmp1__length1;
	gint _tmp2_ = 0;
	guint8* _tmp3_;
	gint _tmp3__length1;
	GError* _inner_error0_ = NULL;
#line 89 "../src/engine/imap/transport/imap-serializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_SERIALIZER (self));
#line 89 "../src/engine/imap/transport/imap-serializer.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 91 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp0_ = self->priv->output;
#line 91 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp1_ = string_get_data (GEARY_IMAP_SERIALIZER_SPACE, &_tmp2_);
#line 91 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp1__length1 = _tmp2_;
#line 91 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp3_ = _tmp1_;
#line 91 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp3__length1 = _tmp1__length1;
#line 91 "../src/engine/imap/transport/imap-serializer.vala"
	g_output_stream_write_all (_tmp0_, _tmp3_, (gsize) _tmp3__length1, NULL, cancellable, &_inner_error0_);
#line 91 "../src/engine/imap/transport/imap-serializer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 91 "../src/engine/imap/transport/imap-serializer.vala"
		g_propagate_error (error, _inner_error0_);
#line 91 "../src/engine/imap/transport/imap-serializer.vala"
		return;
#line 496 "imap-serializer.c"
	}
}

/**
     * Writes a NIL atom.
     */
void
geary_imap_serializer_push_nil (GearyImapSerializer* self,
                                GCancellable* cancellable,
                                GError** error)
{
	GOutputStream* _tmp0_;
	guint8* _tmp1_;
	gint _tmp1__length1;
	gint _tmp2_ = 0;
	guint8* _tmp3_;
	gint _tmp3__length1;
	GError* _inner_error0_ = NULL;
#line 97 "../src/engine/imap/transport/imap-serializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_SERIALIZER (self));
#line 97 "../src/engine/imap/transport/imap-serializer.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 99 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp0_ = self->priv->output;
#line 99 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp1_ = string_get_data (GEARY_IMAP_NIL_PARAMETER_VALUE, &_tmp2_);
#line 99 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp1__length1 = _tmp2_;
#line 99 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp3_ = _tmp1_;
#line 99 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp3__length1 = _tmp1__length1;
#line 99 "../src/engine/imap/transport/imap-serializer.vala"
	g_output_stream_write_all (_tmp0_, _tmp3_, (gsize) _tmp3__length1, NULL, cancellable, &_inner_error0_);
#line 99 "../src/engine/imap/transport/imap-serializer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 99 "../src/engine/imap/transport/imap-serializer.vala"
		g_propagate_error (error, _inner_error0_);
#line 99 "../src/engine/imap/transport/imap-serializer.vala"
		return;
#line 537 "imap-serializer.c"
	}
}

/**
     * Writes a CRLF sequence.
     */
void
geary_imap_serializer_push_eol (GearyImapSerializer* self,
                                GCancellable* cancellable,
                                GError** error)
{
	GOutputStream* _tmp0_;
	guint8* _tmp1_;
	gint _tmp1__length1;
	gint _tmp2_ = 0;
	guint8* _tmp3_;
	gint _tmp3__length1;
	GError* _inner_error0_ = NULL;
#line 105 "../src/engine/imap/transport/imap-serializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_SERIALIZER (self));
#line 105 "../src/engine/imap/transport/imap-serializer.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 107 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp0_ = self->priv->output;
#line 107 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp1_ = string_get_data (GEARY_IMAP_SERIALIZER_EOL, &_tmp2_);
#line 107 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp1__length1 = _tmp2_;
#line 107 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp3_ = _tmp1_;
#line 107 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp3__length1 = _tmp1__length1;
#line 107 "../src/engine/imap/transport/imap-serializer.vala"
	g_output_stream_write_all (_tmp0_, _tmp3_, (gsize) _tmp3__length1, NULL, cancellable, &_inner_error0_);
#line 107 "../src/engine/imap/transport/imap-serializer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 107 "../src/engine/imap/transport/imap-serializer.vala"
		g_propagate_error (error, _inner_error0_);
#line 107 "../src/engine/imap/transport/imap-serializer.vala"
		return;
#line 578 "imap-serializer.c"
	}
}

static void
geary_imap_serializer_push_literal_data_data_free (gpointer _data)
{
	GearyImapSerializerPushLiteralDataData* _data_;
	_data_ = _data;
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_g_object_unref0 (_data_->cancellable);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	g_slice_free (GearyImapSerializerPushLiteralDataData, _data_);
#line 593 "imap-serializer.c"
}

void
geary_imap_serializer_push_literal_data (GearyImapSerializer* self,
                                         guint8* buffer,
                                         gint buffer_length1,
                                         GCancellable* cancellable,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	GearyImapSerializerPushLiteralDataData* _data_;
	GearyImapSerializer* _tmp0_;
	GCancellable* _tmp1_;
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_SERIALIZER (self));
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_data_ = g_slice_new0 (GearyImapSerializerPushLiteralDataData);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_serializer_push_literal_data_data_free);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_data_->self = _tmp0_;
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_data_->buffer = buffer;
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_data_->buffer_length1 = buffer_length1;
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_g_object_unref0 (_data_->cancellable);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_data_->cancellable = _tmp1_;
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	geary_imap_serializer_push_literal_data_co (_data_);
#line 633 "imap-serializer.c"
}

void
geary_imap_serializer_push_literal_data_finish (GearyImapSerializer* self,
                                                GAsyncResult* _res_,
                                                GError** error)
{
	GearyImapSerializerPushLiteralDataData* _data_;
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	if (NULL == _data_) {
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
		return;
#line 648 "imap-serializer.c"
	}
}

/**
     * Writes literal data to the output stream.
     */
static void
geary_imap_serializer_push_literal_data_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_)
{
	GearyImapSerializerPushLiteralDataData* _data_;
#line 117 "../src/engine/imap/transport/imap-serializer.vala"
	_data_ = _user_data_;
#line 117 "../src/engine/imap/transport/imap-serializer.vala"
	_data_->_source_object_ = source_object;
#line 117 "../src/engine/imap/transport/imap-serializer.vala"
	_data_->_res_ = _res_;
#line 117 "../src/engine/imap/transport/imap-serializer.vala"
	geary_imap_serializer_push_literal_data_co (_data_);
#line 669 "imap-serializer.c"
}

static gboolean
geary_imap_serializer_push_literal_data_co (GearyImapSerializerPushLiteralDataData* _data_)
{
#line 113 "../src/engine/imap/transport/imap-serializer.vala"
	switch (_data_->_state_) {
#line 113 "../src/engine/imap/transport/imap-serializer.vala"
		case 0:
#line 679 "imap-serializer.c"
		goto _state_0;
#line 113 "../src/engine/imap/transport/imap-serializer.vala"
		case 1:
#line 683 "imap-serializer.c"
		goto _state_1;
		default:
#line 113 "../src/engine/imap/transport/imap-serializer.vala"
		g_assert_not_reached ();
#line 688 "imap-serializer.c"
	}
	_state_0:
#line 116 "../src/engine/imap/transport/imap-serializer.vala"
	if (_data_->buffer_length1 > 0) {
#line 117 "../src/engine/imap/transport/imap-serializer.vala"
		_data_->_tmp0_ = _data_->self->priv->output;
#line 117 "../src/engine/imap/transport/imap-serializer.vala"
		_data_->_state_ = 1;
#line 117 "../src/engine/imap/transport/imap-serializer.vala"
		g_output_stream_write_all_async (_data_->_tmp0_, _data_->buffer, (gsize) _data_->buffer_length1, G_PRIORITY_DEFAULT, _data_->cancellable, geary_imap_serializer_push_literal_data_ready, _data_);
#line 117 "../src/engine/imap/transport/imap-serializer.vala"
		return FALSE;
#line 701 "imap-serializer.c"
		_state_1:
#line 117 "../src/engine/imap/transport/imap-serializer.vala"
		g_output_stream_write_all_finish (_data_->_tmp0_, _data_->_res_, NULL, &_data_->_inner_error0_);
#line 117 "../src/engine/imap/transport/imap-serializer.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 117 "../src/engine/imap/transport/imap-serializer.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 117 "../src/engine/imap/transport/imap-serializer.vala"
			g_object_unref (_data_->_async_result);
#line 117 "../src/engine/imap/transport/imap-serializer.vala"
			return FALSE;
#line 713 "imap-serializer.c"
		}
	}
#line 113 "../src/engine/imap/transport/imap-serializer.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 113 "../src/engine/imap/transport/imap-serializer.vala"
	if (_data_->_state_ != 0) {
#line 113 "../src/engine/imap/transport/imap-serializer.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 113 "../src/engine/imap/transport/imap-serializer.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 724 "imap-serializer.c"
		}
	}
#line 113 "../src/engine/imap/transport/imap-serializer.vala"
	g_object_unref (_data_->_async_result);
#line 113 "../src/engine/imap/transport/imap-serializer.vala"
	return FALSE;
#line 731 "imap-serializer.c"
}

static void
geary_imap_serializer_flush_stream_data_free (gpointer _data)
{
	GearyImapSerializerFlushStreamData* _data_;
	_data_ = _data;
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_g_object_unref0 (_data_->cancellable);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	g_slice_free (GearyImapSerializerFlushStreamData, _data_);
#line 745 "imap-serializer.c"
}

void
geary_imap_serializer_flush_stream (GearyImapSerializer* self,
                                    GCancellable* cancellable,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	GearyImapSerializerFlushStreamData* _data_;
	GearyImapSerializer* _tmp0_;
	GCancellable* _tmp1_;
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_SERIALIZER (self));
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_data_ = g_slice_new0 (GearyImapSerializerFlushStreamData);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_serializer_flush_stream_data_free);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_data_->self = _tmp0_;
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_g_object_unref0 (_data_->cancellable);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_data_->cancellable = _tmp1_;
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	geary_imap_serializer_flush_stream_co (_data_);
#line 779 "imap-serializer.c"
}

void
geary_imap_serializer_flush_stream_finish (GearyImapSerializer* self,
                                           GAsyncResult* _res_,
                                           GError** error)
{
	GearyImapSerializerFlushStreamData* _data_;
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	if (NULL == _data_) {
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
		return;
#line 794 "imap-serializer.c"
	}
}

/**
     * Flushes the output stream, ensuring a command has been sent.
     */
static void
geary_imap_serializer_flush_stream_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	GearyImapSerializerFlushStreamData* _data_;
#line 131 "../src/engine/imap/transport/imap-serializer.vala"
	_data_ = _user_data_;
#line 131 "../src/engine/imap/transport/imap-serializer.vala"
	_data_->_source_object_ = source_object;
#line 131 "../src/engine/imap/transport/imap-serializer.vala"
	_data_->_res_ = _res_;
#line 131 "../src/engine/imap/transport/imap-serializer.vala"
	geary_imap_serializer_flush_stream_co (_data_);
#line 815 "imap-serializer.c"
}

static gboolean
geary_imap_serializer_flush_stream_co (GearyImapSerializerFlushStreamData* _data_)
{
#line 129 "../src/engine/imap/transport/imap-serializer.vala"
	switch (_data_->_state_) {
#line 129 "../src/engine/imap/transport/imap-serializer.vala"
		case 0:
#line 825 "imap-serializer.c"
		goto _state_0;
#line 129 "../src/engine/imap/transport/imap-serializer.vala"
		case 1:
#line 829 "imap-serializer.c"
		goto _state_1;
		default:
#line 129 "../src/engine/imap/transport/imap-serializer.vala"
		g_assert_not_reached ();
#line 834 "imap-serializer.c"
	}
	_state_0:
#line 131 "../src/engine/imap/transport/imap-serializer.vala"
	_data_->_tmp0_ = _data_->self->priv->output;
#line 131 "../src/engine/imap/transport/imap-serializer.vala"
	_data_->_state_ = 1;
#line 131 "../src/engine/imap/transport/imap-serializer.vala"
	g_output_stream_flush_async (_data_->_tmp0_, G_PRIORITY_DEFAULT, _data_->cancellable, geary_imap_serializer_flush_stream_ready, _data_);
#line 131 "../src/engine/imap/transport/imap-serializer.vala"
	return FALSE;
#line 845 "imap-serializer.c"
	_state_1:
#line 131 "../src/engine/imap/transport/imap-serializer.vala"
	g_output_stream_flush_finish (_data_->_tmp0_, _data_->_res_, &_data_->_inner_error0_);
#line 131 "../src/engine/imap/transport/imap-serializer.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 131 "../src/engine/imap/transport/imap-serializer.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 131 "../src/engine/imap/transport/imap-serializer.vala"
		g_object_unref (_data_->_async_result);
#line 131 "../src/engine/imap/transport/imap-serializer.vala"
		return FALSE;
#line 857 "imap-serializer.c"
	}
#line 129 "../src/engine/imap/transport/imap-serializer.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 129 "../src/engine/imap/transport/imap-serializer.vala"
	if (_data_->_state_ != 0) {
#line 129 "../src/engine/imap/transport/imap-serializer.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 129 "../src/engine/imap/transport/imap-serializer.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 867 "imap-serializer.c"
		}
	}
#line 129 "../src/engine/imap/transport/imap-serializer.vala"
	g_object_unref (_data_->_async_result);
#line 129 "../src/engine/imap/transport/imap-serializer.vala"
	return FALSE;
#line 874 "imap-serializer.c"
}

static void
geary_imap_serializer_close_stream_data_free (gpointer _data)
{
	GearyImapSerializerCloseStreamData* _data_;
	_data_ = _data;
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_g_object_unref0 (_data_->cancellable);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	g_slice_free (GearyImapSerializerCloseStreamData, _data_);
#line 888 "imap-serializer.c"
}

void
geary_imap_serializer_close_stream (GearyImapSerializer* self,
                                    GCancellable* cancellable,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	GearyImapSerializerCloseStreamData* _data_;
	GearyImapSerializer* _tmp0_;
	GCancellable* _tmp1_;
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_SERIALIZER (self));
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_data_ = g_slice_new0 (GearyImapSerializerCloseStreamData);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_serializer_close_stream_data_free);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_data_->self = _tmp0_;
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_g_object_unref0 (_data_->cancellable);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_data_->cancellable = _tmp1_;
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	geary_imap_serializer_close_stream_co (_data_);
#line 922 "imap-serializer.c"
}

void
geary_imap_serializer_close_stream_finish (GearyImapSerializer* self,
                                           GAsyncResult* _res_,
                                           GError** error)
{
	GearyImapSerializerCloseStreamData* _data_;
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	if (NULL == _data_) {
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
		return;
#line 937 "imap-serializer.c"
	}
}

/**
     * Closes the stream, ensuring a command has been sent.
     */
static void
geary_imap_serializer_close_stream_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	GearyImapSerializerCloseStreamData* _data_;
#line 139 "../src/engine/imap/transport/imap-serializer.vala"
	_data_ = _user_data_;
#line 139 "../src/engine/imap/transport/imap-serializer.vala"
	_data_->_source_object_ = source_object;
#line 139 "../src/engine/imap/transport/imap-serializer.vala"
	_data_->_res_ = _res_;
#line 139 "../src/engine/imap/transport/imap-serializer.vala"
	geary_imap_serializer_close_stream_co (_data_);
#line 958 "imap-serializer.c"
}

static gboolean
geary_imap_serializer_close_stream_co (GearyImapSerializerCloseStreamData* _data_)
{
#line 137 "../src/engine/imap/transport/imap-serializer.vala"
	switch (_data_->_state_) {
#line 137 "../src/engine/imap/transport/imap-serializer.vala"
		case 0:
#line 968 "imap-serializer.c"
		goto _state_0;
#line 137 "../src/engine/imap/transport/imap-serializer.vala"
		case 1:
#line 972 "imap-serializer.c"
		goto _state_1;
		default:
#line 137 "../src/engine/imap/transport/imap-serializer.vala"
		g_assert_not_reached ();
#line 977 "imap-serializer.c"
	}
	_state_0:
#line 139 "../src/engine/imap/transport/imap-serializer.vala"
	_data_->_tmp0_ = _data_->self->priv->output;
#line 139 "../src/engine/imap/transport/imap-serializer.vala"
	_data_->_state_ = 1;
#line 139 "../src/engine/imap/transport/imap-serializer.vala"
	g_output_stream_close_async (_data_->_tmp0_, G_PRIORITY_DEFAULT, _data_->cancellable, geary_imap_serializer_close_stream_ready, _data_);
#line 139 "../src/engine/imap/transport/imap-serializer.vala"
	return FALSE;
#line 988 "imap-serializer.c"
	_state_1:
#line 139 "../src/engine/imap/transport/imap-serializer.vala"
	g_output_stream_close_finish (_data_->_tmp0_, _data_->_res_, &_data_->_inner_error0_);
#line 139 "../src/engine/imap/transport/imap-serializer.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 139 "../src/engine/imap/transport/imap-serializer.vala"
		if (_data_->_inner_error0_->domain == G_IO_ERROR) {
#line 139 "../src/engine/imap/transport/imap-serializer.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 139 "../src/engine/imap/transport/imap-serializer.vala"
			g_object_unref (_data_->_async_result);
#line 139 "../src/engine/imap/transport/imap-serializer.vala"
			return FALSE;
#line 1002 "imap-serializer.c"
		} else {
#line 139 "../src/engine/imap/transport/imap-serializer.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 139 "../src/engine/imap/transport/imap-serializer.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 139 "../src/engine/imap/transport/imap-serializer.vala"
			g_object_unref (_data_->_async_result);
#line 139 "../src/engine/imap/transport/imap-serializer.vala"
			return FALSE;
#line 1012 "imap-serializer.c"
		}
	}
#line 137 "../src/engine/imap/transport/imap-serializer.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 137 "../src/engine/imap/transport/imap-serializer.vala"
	if (_data_->_state_ != 0) {
#line 137 "../src/engine/imap/transport/imap-serializer.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 137 "../src/engine/imap/transport/imap-serializer.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1023 "imap-serializer.c"
		}
	}
#line 137 "../src/engine/imap/transport/imap-serializer.vala"
	g_object_unref (_data_->_async_result);
#line 137 "../src/engine/imap/transport/imap-serializer.vala"
	return FALSE;
#line 1030 "imap-serializer.c"
}

static void
geary_imap_serializer_class_init (GearyImapSerializerClass * klass,
                                  gpointer klass_data)
{
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	geary_imap_serializer_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	g_type_class_adjust_private_offset (klass, &GearyImapSerializer_private_offset);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_imap_serializer_finalize;
#line 1043 "imap-serializer.c"
}

static void
geary_imap_serializer_instance_init (GearyImapSerializer * self,
                                     gpointer klass)
{
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	self->priv = geary_imap_serializer_get_instance_private (self);
#line 1052 "imap-serializer.c"
}

static void
geary_imap_serializer_finalize (GObject * obj)
{
	GearyImapSerializer * self;
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_IMAP_TYPE_SERIALIZER, GearyImapSerializer);
#line 28 "../src/engine/imap/transport/imap-serializer.vala"
	_g_object_unref0 (self->priv->output);
#line 22 "../src/engine/imap/transport/imap-serializer.vala"
	G_OBJECT_CLASS (geary_imap_serializer_parent_class)->finalize (obj);
#line 1065 "imap-serializer.c"
}

/**
 * Writes IMAP protocol strings to the supplied output stream.
 *
 * Since most IMAP commands are small (with the exception of literal
 * data) this class writes directly, synchronously to the given
 * stream. Thus it is highly desirable that the stream passed to the
 * constructor is buffered, either a {@link
 * GLib.BufferedOutputStream}, or some other type that uses a memory
 * buffer large enough to write a typical command completely without
 * causing disk or network I/O.
 *
 * @see Deserializer
 */
 G_GNUC_NO_INLINE static GType
geary_imap_serializer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyImapSerializerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_imap_serializer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyImapSerializer), 0, (GInstanceInitFunc) geary_imap_serializer_instance_init, NULL };
	GType geary_imap_serializer_type_id;
	geary_imap_serializer_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyImapSerializer", &g_define_type_info, 0);
	GearyImapSerializer_private_offset = g_type_add_instance_private (geary_imap_serializer_type_id, sizeof (GearyImapSerializerPrivate));
	return geary_imap_serializer_type_id;
}

GType
geary_imap_serializer_get_type (void)
{
	static gsize geary_imap_serializer_type_id__once = 0;
	if (g_once_init_enter (&geary_imap_serializer_type_id__once)) {
		GType geary_imap_serializer_type_id;
		geary_imap_serializer_type_id = geary_imap_serializer_get_type_once ();
		g_once_init_leave (&geary_imap_serializer_type_id__once, geary_imap_serializer_type_id);
	}
	return geary_imap_serializer_type_id__once;
}

