/* memory-buffer.c generated by valac 0.56.17, the Vala compiler
 * generated from memory-buffer.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_MEMORY_BUFFER_0_PROPERTY,
	GEARY_MEMORY_BUFFER_SIZE_PROPERTY,
	GEARY_MEMORY_BUFFER_ALLOCATED_SIZE_PROPERTY,
	GEARY_MEMORY_BUFFER_NUM_PROPERTIES
};
static GParamSpec* geary_memory_buffer_properties[GEARY_MEMORY_BUFFER_NUM_PROPERTIES];
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

static gpointer geary_memory_buffer_parent_class = NULL;

static GBytes* geary_memory_buffer_real_get_bytes (GearyMemoryBuffer* self);
static GInputStream* geary_memory_buffer_real_get_input_stream (GearyMemoryBuffer* self);
static GByteArray* geary_memory_buffer_real_get_byte_array (GearyMemoryBuffer* self);
static guint8* geary_memory_buffer_real_get_uint8_array (GearyMemoryBuffer* self,
                                                  gint* result_length1);
static guint8* _vala_array_dup8 (guint8* self,
                          gssize length);
static gchar* geary_memory_buffer_real_to_string (GearyMemoryBuffer* self);
static void _vala_array_add7 (guint8* * array,
                       gint* length,
                       gint* size,
                       guint8 value);
static gchar* geary_memory_buffer_real_get_valid_utf8 (GearyMemoryBuffer* self);
static GType geary_memory_buffer_get_type_once (void);
static void _vala_geary_memory_buffer_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);

gsize
geary_memory_buffer_get_size (GearyMemoryBuffer* self)
{
	GearyMemoryBufferClass* _klass_;
#line 28 "../src/engine/memory/memory-buffer.vala"
	g_return_val_if_fail (GEARY_MEMORY_IS_BUFFER (self), 0UL);
#line 28 "../src/engine/memory/memory-buffer.vala"
	_klass_ = GEARY_MEMORY_BUFFER_GET_CLASS (self);
#line 28 "../src/engine/memory/memory-buffer.vala"
	if (_klass_->get_size) {
#line 28 "../src/engine/memory/memory-buffer.vala"
		return _klass_->get_size (self);
#line 70 "memory-buffer.c"
	}
#line 28 "../src/engine/memory/memory-buffer.vala"
	return 0UL;
#line 74 "memory-buffer.c"
}

gsize
geary_memory_buffer_get_allocated_size (GearyMemoryBuffer* self)
{
	GearyMemoryBufferClass* _klass_;
#line 33 "../src/engine/memory/memory-buffer.vala"
	g_return_val_if_fail (GEARY_MEMORY_IS_BUFFER (self), 0UL);
#line 33 "../src/engine/memory/memory-buffer.vala"
	_klass_ = GEARY_MEMORY_BUFFER_GET_CLASS (self);
#line 33 "../src/engine/memory/memory-buffer.vala"
	if (_klass_->get_allocated_size) {
#line 33 "../src/engine/memory/memory-buffer.vala"
		return _klass_->get_allocated_size (self);
#line 89 "memory-buffer.c"
	}
#line 33 "../src/engine/memory/memory-buffer.vala"
	return 0UL;
#line 93 "memory-buffer.c"
}

/**
     * Returns a Bytes object holding the buffer's contents.
     *
     * Since Bytes is immutable, the caller will need to make its own copy if it wants to modify
     * the data.
     */
static GBytes*
geary_memory_buffer_real_get_bytes (GearyMemoryBuffer* self)
{
#line 41 "../src/engine/memory/memory-buffer.vala"
	g_critical ("Type `%s' does not implement abstract method `geary_memory_buffer_get_bytes'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 41 "../src/engine/memory/memory-buffer.vala"
	return NULL;
#line 109 "memory-buffer.c"
}

GBytes*
geary_memory_buffer_get_bytes (GearyMemoryBuffer* self)
{
	GearyMemoryBufferClass* _klass_;
#line 41 "../src/engine/memory/memory-buffer.vala"
	g_return_val_if_fail (GEARY_MEMORY_IS_BUFFER (self), NULL);
#line 41 "../src/engine/memory/memory-buffer.vala"
	_klass_ = GEARY_MEMORY_BUFFER_GET_CLASS (self);
#line 41 "../src/engine/memory/memory-buffer.vala"
	if (_klass_->get_bytes) {
#line 41 "../src/engine/memory/memory-buffer.vala"
		return _klass_->get_bytes (self);
#line 124 "memory-buffer.c"
	}
#line 41 "../src/engine/memory/memory-buffer.vala"
	return NULL;
#line 128 "memory-buffer.c"
}

/**
     * Returns an InputStream that can read the buffer in its current entirety.
     *
     * Note that the InputStream may share its memory buffer(s) with the Buffer but does
     * not hold references to them or the Buffer itself.  Thus, the Buffer should
     * only be destroyed after all InputStreams are destroyed or exhausted.
     *
     * The base class implementation uses {@link get_bytes} to create the InputStream.  Subclasses
     * should look for more optimal implementations.
     */
static GInputStream*
geary_memory_buffer_real_get_input_stream (GearyMemoryBuffer* self)
{
	GBytes* _tmp0_;
	GBytes* _tmp1_;
	GMemoryInputStream* _tmp2_;
	GInputStream* _tmp3_;
	GInputStream* result;
#line 54 "../src/engine/memory/memory-buffer.vala"
	_tmp0_ = geary_memory_buffer_get_bytes (self);
#line 54 "../src/engine/memory/memory-buffer.vala"
	_tmp1_ = _tmp0_;
#line 54 "../src/engine/memory/memory-buffer.vala"
	_tmp2_ = (GMemoryInputStream*) g_memory_input_stream_new_from_bytes (_tmp1_);
#line 54 "../src/engine/memory/memory-buffer.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, g_input_stream_get_type (), GInputStream);
#line 54 "../src/engine/memory/memory-buffer.vala"
	_g_bytes_unref0 (_tmp1_);
#line 54 "../src/engine/memory/memory-buffer.vala"
	result = _tmp3_;
#line 54 "../src/engine/memory/memory-buffer.vala"
	return result;
#line 163 "memory-buffer.c"
}

GInputStream*
geary_memory_buffer_get_input_stream (GearyMemoryBuffer* self)
{
	GearyMemoryBufferClass* _klass_;
#line 53 "../src/engine/memory/memory-buffer.vala"
	g_return_val_if_fail (GEARY_MEMORY_IS_BUFFER (self), NULL);
#line 53 "../src/engine/memory/memory-buffer.vala"
	_klass_ = GEARY_MEMORY_BUFFER_GET_CLASS (self);
#line 53 "../src/engine/memory/memory-buffer.vala"
	if (_klass_->get_input_stream) {
#line 53 "../src/engine/memory/memory-buffer.vala"
		return _klass_->get_input_stream (self);
#line 178 "memory-buffer.c"
	}
#line 53 "../src/engine/memory/memory-buffer.vala"
	return NULL;
#line 182 "memory-buffer.c"
}

/**
     * Returns a ByteArray storing the buffer in its entirety.
     *
     * A copy of the backing buffer is returned.
     *
     * The base class implementation uses {@link get_bytes} to create the InputStream.  Subclasses
     * should look for more optimal implementations.
     */
static GByteArray*
geary_memory_buffer_real_get_byte_array (GearyMemoryBuffer* self)
{
	GByteArray* byte_array = NULL;
	GByteArray* _tmp0_;
	GBytes* _tmp1_;
	GBytes* _tmp2_;
	gsize _tmp3_ = 0;
	guint8* _tmp4_;
	GByteArray* result;
#line 66 "../src/engine/memory/memory-buffer.vala"
	_tmp0_ = g_byte_array_new ();
#line 66 "../src/engine/memory/memory-buffer.vala"
	byte_array = _tmp0_;
#line 67 "../src/engine/memory/memory-buffer.vala"
	_tmp1_ = geary_memory_buffer_get_bytes (self);
#line 67 "../src/engine/memory/memory-buffer.vala"
	_tmp2_ = _tmp1_;
#line 67 "../src/engine/memory/memory-buffer.vala"
	_tmp4_ = g_bytes_get_data (_tmp2_, &_tmp3_);
#line 67 "../src/engine/memory/memory-buffer.vala"
	g_byte_array_append (byte_array, _tmp4_, (gint) _tmp3_);
#line 67 "../src/engine/memory/memory-buffer.vala"
	_g_bytes_unref0 (_tmp2_);
#line 69 "../src/engine/memory/memory-buffer.vala"
	result = byte_array;
#line 69 "../src/engine/memory/memory-buffer.vala"
	return result;
#line 221 "memory-buffer.c"
}

GByteArray*
geary_memory_buffer_get_byte_array (GearyMemoryBuffer* self)
{
	GearyMemoryBufferClass* _klass_;
#line 65 "../src/engine/memory/memory-buffer.vala"
	g_return_val_if_fail (GEARY_MEMORY_IS_BUFFER (self), NULL);
#line 65 "../src/engine/memory/memory-buffer.vala"
	_klass_ = GEARY_MEMORY_BUFFER_GET_CLASS (self);
#line 65 "../src/engine/memory/memory-buffer.vala"
	if (_klass_->get_byte_array) {
#line 65 "../src/engine/memory/memory-buffer.vala"
		return _klass_->get_byte_array (self);
#line 236 "memory-buffer.c"
	}
#line 65 "../src/engine/memory/memory-buffer.vala"
	return NULL;
#line 240 "memory-buffer.c"
}

/**
     * Returns an array of uint8 storing the buffer in its entirety.
     *
     * A copy of the backing buffer is returned.
     *
     * The base class implementation uses {@link get_bytes} to create the InputStream.  Subclasses
     * should look for more optimal implementations.
     *
     * @see UnownedBytesBuffer
     */
static guint8*
_vala_array_dup8 (guint8* self,
                  gssize length)
{
#line 83 "../src/engine/memory/memory-buffer.vala"
	if (length > 0) {
#line 83 "../src/engine/memory/memory-buffer.vala"
		return g_memdup2 (self, length * sizeof (guint8));
#line 261 "memory-buffer.c"
	}
#line 83 "../src/engine/memory/memory-buffer.vala"
	return NULL;
#line 265 "memory-buffer.c"
}

static guint8*
geary_memory_buffer_real_get_uint8_array (GearyMemoryBuffer* self,
                                          gint* result_length1)
{
	GBytes* _tmp0_;
	GBytes* _tmp1_;
	gsize _tmp2_ = 0;
	guint8* _tmp3_;
	guint8* _tmp4_;
	gint _tmp4__length1;
	guint8* _tmp5_;
	gint _tmp5__length1;
	guint8* _tmp6_;
	gint _tmp6__length1;
	guint8* result;
#line 83 "../src/engine/memory/memory-buffer.vala"
	_tmp0_ = geary_memory_buffer_get_bytes (self);
#line 83 "../src/engine/memory/memory-buffer.vala"
	_tmp1_ = _tmp0_;
#line 83 "../src/engine/memory/memory-buffer.vala"
	_tmp3_ = g_bytes_get_data (_tmp1_, &_tmp2_);
#line 83 "../src/engine/memory/memory-buffer.vala"
	_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup8 (_tmp3_, _tmp2_) : _tmp3_;
#line 83 "../src/engine/memory/memory-buffer.vala"
	_tmp4__length1 = _tmp2_;
#line 83 "../src/engine/memory/memory-buffer.vala"
	_tmp5_ = _tmp4_;
#line 83 "../src/engine/memory/memory-buffer.vala"
	_tmp5__length1 = _tmp4__length1;
#line 83 "../src/engine/memory/memory-buffer.vala"
	_g_bytes_unref0 (_tmp1_);
#line 83 "../src/engine/memory/memory-buffer.vala"
	_tmp6_ = _tmp5_;
#line 83 "../src/engine/memory/memory-buffer.vala"
	_tmp6__length1 = _tmp5__length1;
#line 83 "../src/engine/memory/memory-buffer.vala"
	if (result_length1) {
#line 83 "../src/engine/memory/memory-buffer.vala"
		*result_length1 = _tmp6__length1;
#line 307 "memory-buffer.c"
	}
#line 83 "../src/engine/memory/memory-buffer.vala"
	result = _tmp6_;
#line 83 "../src/engine/memory/memory-buffer.vala"
	return result;
#line 313 "memory-buffer.c"
}

guint8*
geary_memory_buffer_get_uint8_array (GearyMemoryBuffer* self,
                                     gint* result_length1)
{
	GearyMemoryBufferClass* _klass_;
#line 82 "../src/engine/memory/memory-buffer.vala"
	g_return_val_if_fail (GEARY_MEMORY_IS_BUFFER (self), NULL);
#line 82 "../src/engine/memory/memory-buffer.vala"
	_klass_ = GEARY_MEMORY_BUFFER_GET_CLASS (self);
#line 82 "../src/engine/memory/memory-buffer.vala"
	if (_klass_->get_uint8_array) {
#line 82 "../src/engine/memory/memory-buffer.vala"
		return _klass_->get_uint8_array (self, result_length1);
#line 329 "memory-buffer.c"
	}
#line 82 "../src/engine/memory/memory-buffer.vala"
	return NULL;
#line 333 "memory-buffer.c"
}

/**
     * Returns a copy of the contents of the buffer as though it was a null terminated string.
     *
     * The base class implementation uses {@link get_bytes} to create the InputStream.  Subclasses
     * should look for more optimal implementations.
     *
     * No validation is made on the string.  See {@link get_valid_utf8}.
     *
     * @see UnownedStringBuffer
     */
static void
_vala_array_add7 (guint8* * array,
                  gint* length,
                  gint* size,
                  guint8 value)
{
#line 98 "../src/engine/memory/memory-buffer.vala"
	if ((*length) == (*size)) {
#line 98 "../src/engine/memory/memory-buffer.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 98 "../src/engine/memory/memory-buffer.vala"
		*array = g_renew (guint8, *array, *size);
#line 358 "memory-buffer.c"
	}
#line 98 "../src/engine/memory/memory-buffer.vala"
	(*array)[(*length)++] = value;
#line 362 "memory-buffer.c"
}

static gchar*
geary_memory_buffer_real_to_string (GearyMemoryBuffer* self)
{
	guint8* buffer = NULL;
	gint _tmp0_ = 0;
	guint8* _tmp1_;
	gint buffer_length1;
	gint _buffer_size_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	gchar* _tmp3_;
	gchar* result;
#line 97 "../src/engine/memory/memory-buffer.vala"
	_tmp1_ = geary_memory_buffer_get_uint8_array (self, &_tmp0_);
#line 97 "../src/engine/memory/memory-buffer.vala"
	buffer = _tmp1_;
#line 97 "../src/engine/memory/memory-buffer.vala"
	buffer_length1 = _tmp0_;
#line 97 "../src/engine/memory/memory-buffer.vala"
	_buffer_size_ = buffer_length1;
#line 98 "../src/engine/memory/memory-buffer.vala"
	_vala_array_add7 (&buffer, &buffer_length1, &_buffer_size_, (guint8) '\0');
#line 100 "../src/engine/memory/memory-buffer.vala"
	_tmp2_ = buffer;
#line 100 "../src/engine/memory/memory-buffer.vala"
	_tmp2__length1 = buffer_length1;
#line 100 "../src/engine/memory/memory-buffer.vala"
	_tmp3_ = g_strdup ((const gchar*) _tmp2_);
#line 100 "../src/engine/memory/memory-buffer.vala"
	result = _tmp3_;
#line 100 "../src/engine/memory/memory-buffer.vala"
	buffer = (g_free (buffer), NULL);
#line 100 "../src/engine/memory/memory-buffer.vala"
	return result;
#line 399 "memory-buffer.c"
}

gchar*
geary_memory_buffer_to_string (GearyMemoryBuffer* self)
{
	GearyMemoryBufferClass* _klass_;
#line 96 "../src/engine/memory/memory-buffer.vala"
	g_return_val_if_fail (GEARY_MEMORY_IS_BUFFER (self), NULL);
#line 96 "../src/engine/memory/memory-buffer.vala"
	_klass_ = GEARY_MEMORY_BUFFER_GET_CLASS (self);
#line 96 "../src/engine/memory/memory-buffer.vala"
	if (_klass_->to_string) {
#line 96 "../src/engine/memory/memory-buffer.vala"
		return _klass_->to_string (self);
#line 414 "memory-buffer.c"
	}
#line 96 "../src/engine/memory/memory-buffer.vala"
	return NULL;
#line 418 "memory-buffer.c"
}

/**
     * Returns a copy of the contents of the buffer as a UTF-8 string.
     *
     * The base class implementation uses {@link to_string} to create
     * the string and and {@link string.make_valid} to perform the
     * validation. Subclasses should look for more optimal
     * implementations.
     */
static gchar*
geary_memory_buffer_real_get_valid_utf8 (GearyMemoryBuffer* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 112 "../src/engine/memory/memory-buffer.vala"
	_tmp0_ = geary_memory_buffer_to_string (self);
#line 112 "../src/engine/memory/memory-buffer.vala"
	_tmp1_ = _tmp0_;
#line 112 "../src/engine/memory/memory-buffer.vala"
	_tmp2_ = g_utf8_make_valid (_tmp1_, (gssize) -1);
#line 112 "../src/engine/memory/memory-buffer.vala"
	_tmp3_ = _tmp2_;
#line 112 "../src/engine/memory/memory-buffer.vala"
	_g_free0 (_tmp1_);
#line 112 "../src/engine/memory/memory-buffer.vala"
	result = _tmp3_;
#line 112 "../src/engine/memory/memory-buffer.vala"
	return result;
#line 451 "memory-buffer.c"
}

gchar*
geary_memory_buffer_get_valid_utf8 (GearyMemoryBuffer* self)
{
	GearyMemoryBufferClass* _klass_;
#line 111 "../src/engine/memory/memory-buffer.vala"
	g_return_val_if_fail (GEARY_MEMORY_IS_BUFFER (self), NULL);
#line 111 "../src/engine/memory/memory-buffer.vala"
	_klass_ = GEARY_MEMORY_BUFFER_GET_CLASS (self);
#line 111 "../src/engine/memory/memory-buffer.vala"
	if (_klass_->get_valid_utf8) {
#line 111 "../src/engine/memory/memory-buffer.vala"
		return _klass_->get_valid_utf8 (self);
#line 466 "memory-buffer.c"
	}
#line 111 "../src/engine/memory/memory-buffer.vala"
	return NULL;
#line 470 "memory-buffer.c"
}

GearyMemoryBuffer*
geary_memory_buffer_construct (GType object_type)
{
	GearyMemoryBuffer * self = NULL;
#line 24 "../src/engine/memory/memory-buffer.vala"
	self = (GearyMemoryBuffer*) geary_base_object_construct (object_type);
#line 24 "../src/engine/memory/memory-buffer.vala"
	return self;
#line 481 "memory-buffer.c"
}

static void
geary_memory_buffer_class_init (GearyMemoryBufferClass * klass,
                                gpointer klass_data)
{
#line 24 "../src/engine/memory/memory-buffer.vala"
	geary_memory_buffer_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/engine/memory/memory-buffer.vala"
	((GearyMemoryBufferClass *) klass)->get_bytes = (GBytes* (*) (GearyMemoryBuffer*)) geary_memory_buffer_real_get_bytes;
#line 24 "../src/engine/memory/memory-buffer.vala"
	((GearyMemoryBufferClass *) klass)->get_input_stream = (GInputStream* (*) (GearyMemoryBuffer*)) geary_memory_buffer_real_get_input_stream;
#line 24 "../src/engine/memory/memory-buffer.vala"
	((GearyMemoryBufferClass *) klass)->get_byte_array = (GByteArray* (*) (GearyMemoryBuffer*)) geary_memory_buffer_real_get_byte_array;
#line 24 "../src/engine/memory/memory-buffer.vala"
	((GearyMemoryBufferClass *) klass)->get_uint8_array = (guint8* (*) (GearyMemoryBuffer*, gint*)) geary_memory_buffer_real_get_uint8_array;
#line 24 "../src/engine/memory/memory-buffer.vala"
	((GearyMemoryBufferClass *) klass)->to_string = (gchar* (*) (GearyMemoryBuffer*)) geary_memory_buffer_real_to_string;
#line 24 "../src/engine/memory/memory-buffer.vala"
	((GearyMemoryBufferClass *) klass)->get_valid_utf8 = (gchar* (*) (GearyMemoryBuffer*)) geary_memory_buffer_real_get_valid_utf8;
#line 24 "../src/engine/memory/memory-buffer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_memory_buffer_get_property;
#line 504 "memory-buffer.c"
	/**
	     * Returns the number of valid (usable) bytes in the buffer.
	     */
#line 24 "../src/engine/memory/memory-buffer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_MEMORY_BUFFER_SIZE_PROPERTY, geary_memory_buffer_properties[GEARY_MEMORY_BUFFER_SIZE_PROPERTY] = g_param_spec_ulong ("size", "size", "size", 0, G_MAXULONG, 0UL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 510 "memory-buffer.c"
	/**
	     * Returns the number of bytes allocated (usable and unusable) for the buffer.
	     */
#line 24 "../src/engine/memory/memory-buffer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_MEMORY_BUFFER_ALLOCATED_SIZE_PROPERTY, geary_memory_buffer_properties[GEARY_MEMORY_BUFFER_ALLOCATED_SIZE_PROPERTY] = g_param_spec_ulong ("allocated-size", "allocated-size", "allocated-size", 0, G_MAXULONG, 0UL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 516 "memory-buffer.c"
}

static void
geary_memory_buffer_instance_init (GearyMemoryBuffer * self,
                                   gpointer klass)
{
}

/**
 * Represents an interface to a variety of backing buffers.
 *
 * A Buffer may be an in-memory or on-disk block of bytes.  Buffer allows for a
 * uniform interface to these blocks and makes it easy to move them around and avoiding copies.
 *
 * Questions of mutability are left to the implementation and users of Buffer.  In general,
 * AbstractBuffers should be built and modified before allowing other callers to access it.
 *
 * @see ByteBuffer
 * @see EmptyBuffer
 * @see GrowableBuffer
 * @see StringBuffer
 * @see UnownedStringBuffer
 * @see UnownedBytesBuffer
 */
 G_GNUC_NO_INLINE static GType
geary_memory_buffer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyMemoryBufferClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_memory_buffer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyMemoryBuffer), 0, (GInstanceInitFunc) geary_memory_buffer_instance_init, NULL };
	GType geary_memory_buffer_type_id;
	geary_memory_buffer_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyMemoryBuffer", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return geary_memory_buffer_type_id;
}

GType
geary_memory_buffer_get_type (void)
{
	static gsize geary_memory_buffer_type_id__once = 0;
	if (g_once_init_enter (&geary_memory_buffer_type_id__once)) {
		GType geary_memory_buffer_type_id;
		geary_memory_buffer_type_id = geary_memory_buffer_get_type_once ();
		g_once_init_leave (&geary_memory_buffer_type_id__once, geary_memory_buffer_type_id);
	}
	return geary_memory_buffer_type_id__once;
}

static void
_vala_geary_memory_buffer_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	GearyMemoryBuffer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBuffer);
#line 24 "../src/engine/memory/memory-buffer.vala"
	switch (property_id) {
#line 572 "memory-buffer.c"
		default:
#line 24 "../src/engine/memory/memory-buffer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/engine/memory/memory-buffer.vala"
		break;
#line 578 "memory-buffer.c"
	}
}

