/* mime-content-disposition.c generated by valac 0.56.17, the Vala compiler
 * generated from mime-content-disposition.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gmime/gmime.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_MIME_CONTENT_DISPOSITION_0_PROPERTY,
	GEARY_MIME_CONTENT_DISPOSITION_DISPOSITION_TYPE_PROPERTY,
	GEARY_MIME_CONTENT_DISPOSITION_IS_UNKNOWN_DISPOSITION_TYPE_PROPERTY,
	GEARY_MIME_CONTENT_DISPOSITION_ORIGINAL_DISPOSITION_TYPE_STRING_PROPERTY,
	GEARY_MIME_CONTENT_DISPOSITION_PARAMS_PROPERTY,
	GEARY_MIME_CONTENT_DISPOSITION_NUM_PROPERTIES
};
static GParamSpec* geary_mime_content_disposition_properties[GEARY_MIME_CONTENT_DISPOSITION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _GearyMimeContentDispositionPrivate {
	GearyMimeDispositionType _disposition_type;
	gboolean _is_unknown_disposition_type;
	gchar* _original_disposition_type_string;
	GearyMimeContentParameters* _params;
};

static gint GearyMimeContentDisposition_private_offset;
static gpointer geary_mime_content_disposition_parent_class = NULL;

static void geary_mime_content_disposition_set_disposition_type (GearyMimeContentDisposition* self,
                                                          GearyMimeDispositionType value);
static void geary_mime_content_disposition_set_is_unknown_disposition_type (GearyMimeContentDisposition* self,
                                                                     gboolean value);
static void geary_mime_content_disposition_set_original_disposition_type_string (GearyMimeContentDisposition* self,
                                                                          const gchar* value);
static void geary_mime_content_disposition_set_params (GearyMimeContentDisposition* self,
                                                GearyMimeContentParameters* value);
VALA_EXTERN GearyMimeContentDisposition* geary_mime_content_disposition_new_from_gmime (GMimeContentDisposition* content_disposition);
VALA_EXTERN GearyMimeContentDisposition* geary_mime_content_disposition_construct_from_gmime (GType object_type,
                                                                                  GMimeContentDisposition* content_disposition);
VALA_EXTERN GearyMimeContentParameters* geary_mime_content_parameters_new_from_gmime (GMimeParamList* gmime);
VALA_EXTERN GearyMimeContentParameters* geary_mime_content_parameters_construct_from_gmime (GType object_type,
                                                                                GMimeParamList* gmime);
static void geary_mime_content_disposition_finalize (GObject * obj);
static GType geary_mime_content_disposition_get_type_once (void);
static void _vala_geary_mime_content_disposition_get_property (GObject * object,
                                                        guint property_id,
                                                        GValue * value,
                                                        GParamSpec * pspec);
static void _vala_geary_mime_content_disposition_set_property (GObject * object,
                                                        guint property_id,
                                                        const GValue * value,
                                                        GParamSpec * pspec);

static inline gpointer
geary_mime_content_disposition_get_instance_private (GearyMimeContentDisposition* self)
{
	return G_STRUCT_MEMBER_P (self, GearyMimeContentDisposition_private_offset);
}

GearyMimeDispositionType
geary_mime_content_disposition_get_disposition_type (GearyMimeContentDisposition* self)
{
	GearyMimeDispositionType result;
#line 52 "../src/engine/mime/mime-content-disposition.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_DISPOSITION (self), 0);
#line 52 "../src/engine/mime/mime-content-disposition.vala"
	result = self->priv->_disposition_type;
#line 52 "../src/engine/mime/mime-content-disposition.vala"
	return result;
#line 90 "mime-content-disposition.c"
}

static void
geary_mime_content_disposition_set_disposition_type (GearyMimeContentDisposition* self,
                                                     GearyMimeDispositionType value)
{
	GearyMimeDispositionType old_value;
#line 52 "../src/engine/mime/mime-content-disposition.vala"
	g_return_if_fail (GEARY_MIME_IS_CONTENT_DISPOSITION (self));
#line 52 "../src/engine/mime/mime-content-disposition.vala"
	old_value = geary_mime_content_disposition_get_disposition_type (self);
#line 52 "../src/engine/mime/mime-content-disposition.vala"
	if (old_value != value) {
#line 52 "../src/engine/mime/mime-content-disposition.vala"
		self->priv->_disposition_type = value;
#line 52 "../src/engine/mime/mime-content-disposition.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_mime_content_disposition_properties[GEARY_MIME_CONTENT_DISPOSITION_DISPOSITION_TYPE_PROPERTY]);
#line 108 "mime-content-disposition.c"
	}
}

gboolean
geary_mime_content_disposition_get_is_unknown_disposition_type (GearyMimeContentDisposition* self)
{
	gboolean result;
#line 57 "../src/engine/mime/mime-content-disposition.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_DISPOSITION (self), FALSE);
#line 57 "../src/engine/mime/mime-content-disposition.vala"
	result = self->priv->_is_unknown_disposition_type;
#line 57 "../src/engine/mime/mime-content-disposition.vala"
	return result;
#line 122 "mime-content-disposition.c"
}

static void
geary_mime_content_disposition_set_is_unknown_disposition_type (GearyMimeContentDisposition* self,
                                                                gboolean value)
{
	gboolean old_value;
#line 57 "../src/engine/mime/mime-content-disposition.vala"
	g_return_if_fail (GEARY_MIME_IS_CONTENT_DISPOSITION (self));
#line 57 "../src/engine/mime/mime-content-disposition.vala"
	old_value = geary_mime_content_disposition_get_is_unknown_disposition_type (self);
#line 57 "../src/engine/mime/mime-content-disposition.vala"
	if (old_value != value) {
#line 57 "../src/engine/mime/mime-content-disposition.vala"
		self->priv->_is_unknown_disposition_type = value;
#line 57 "../src/engine/mime/mime-content-disposition.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_mime_content_disposition_properties[GEARY_MIME_CONTENT_DISPOSITION_IS_UNKNOWN_DISPOSITION_TYPE_PROPERTY]);
#line 140 "mime-content-disposition.c"
	}
}

const gchar*
geary_mime_content_disposition_get_original_disposition_type_string (GearyMimeContentDisposition* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 62 "../src/engine/mime/mime-content-disposition.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_DISPOSITION (self), NULL);
#line 62 "../src/engine/mime/mime-content-disposition.vala"
	_tmp0_ = self->priv->_original_disposition_type_string;
#line 62 "../src/engine/mime/mime-content-disposition.vala"
	result = _tmp0_;
#line 62 "../src/engine/mime/mime-content-disposition.vala"
	return result;
#line 157 "mime-content-disposition.c"
}

static void
geary_mime_content_disposition_set_original_disposition_type_string (GearyMimeContentDisposition* self,
                                                                     const gchar* value)
{
	gchar* old_value;
#line 62 "../src/engine/mime/mime-content-disposition.vala"
	g_return_if_fail (GEARY_MIME_IS_CONTENT_DISPOSITION (self));
#line 62 "../src/engine/mime/mime-content-disposition.vala"
	old_value = geary_mime_content_disposition_get_original_disposition_type_string (self);
#line 62 "../src/engine/mime/mime-content-disposition.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 171 "mime-content-disposition.c"
		gchar* _tmp0_;
#line 62 "../src/engine/mime/mime-content-disposition.vala"
		_tmp0_ = g_strdup (value);
#line 62 "../src/engine/mime/mime-content-disposition.vala"
		_g_free0 (self->priv->_original_disposition_type_string);
#line 62 "../src/engine/mime/mime-content-disposition.vala"
		self->priv->_original_disposition_type_string = _tmp0_;
#line 62 "../src/engine/mime/mime-content-disposition.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_mime_content_disposition_properties[GEARY_MIME_CONTENT_DISPOSITION_ORIGINAL_DISPOSITION_TYPE_STRING_PROPERTY]);
#line 181 "mime-content-disposition.c"
	}
}

GearyMimeContentParameters*
geary_mime_content_disposition_get_params (GearyMimeContentDisposition* self)
{
	GearyMimeContentParameters* result;
	GearyMimeContentParameters* _tmp0_;
#line 76 "../src/engine/mime/mime-content-disposition.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_DISPOSITION (self), NULL);
#line 76 "../src/engine/mime/mime-content-disposition.vala"
	_tmp0_ = self->priv->_params;
#line 76 "../src/engine/mime/mime-content-disposition.vala"
	result = _tmp0_;
#line 76 "../src/engine/mime/mime-content-disposition.vala"
	return result;
#line 198 "mime-content-disposition.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 76 "../src/engine/mime/mime-content-disposition.vala"
	return self ? g_object_ref (self) : NULL;
#line 206 "mime-content-disposition.c"
}

static void
geary_mime_content_disposition_set_params (GearyMimeContentDisposition* self,
                                           GearyMimeContentParameters* value)
{
	GearyMimeContentParameters* old_value;
#line 76 "../src/engine/mime/mime-content-disposition.vala"
	g_return_if_fail (GEARY_MIME_IS_CONTENT_DISPOSITION (self));
#line 76 "../src/engine/mime/mime-content-disposition.vala"
	old_value = geary_mime_content_disposition_get_params (self);
#line 76 "../src/engine/mime/mime-content-disposition.vala"
	if (old_value != value) {
#line 220 "mime-content-disposition.c"
		GearyMimeContentParameters* _tmp0_;
#line 76 "../src/engine/mime/mime-content-disposition.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 76 "../src/engine/mime/mime-content-disposition.vala"
		_g_object_unref0 (self->priv->_params);
#line 76 "../src/engine/mime/mime-content-disposition.vala"
		self->priv->_params = _tmp0_;
#line 76 "../src/engine/mime/mime-content-disposition.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_mime_content_disposition_properties[GEARY_MIME_CONTENT_DISPOSITION_PARAMS_PROPERTY]);
#line 230 "mime-content-disposition.c"
	}
}

/**
     * Create a Content-Disposition representation
     */
GearyMimeContentDisposition*
geary_mime_content_disposition_construct (GType object_type,
                                          const gchar* disposition,
                                          GearyMimeContentParameters* params)
{
	GearyMimeContentDisposition * self = NULL;
	gboolean is_unknown = FALSE;
	gboolean _tmp0_ = FALSE;
	GearyMimeDispositionType _tmp1_;
	GearyMimeContentParameters* _tmp2_ = NULL;
	GearyMimeContentParameters* _tmp3_;
#line 81 "../src/engine/mime/mime-content-disposition.vala"
	g_return_val_if_fail ((params == NULL) || GEARY_MIME_IS_CONTENT_PARAMETERS (params), NULL);
#line 81 "../src/engine/mime/mime-content-disposition.vala"
	self = (GearyMimeContentDisposition*) geary_base_object_construct (object_type);
#line 83 "../src/engine/mime/mime-content-disposition.vala"
	_tmp1_ = geary_mime_disposition_type_deserialize (disposition, &_tmp0_);
#line 83 "../src/engine/mime/mime-content-disposition.vala"
	is_unknown = _tmp0_;
#line 83 "../src/engine/mime/mime-content-disposition.vala"
	geary_mime_content_disposition_set_disposition_type (self, _tmp1_);
#line 84 "../src/engine/mime/mime-content-disposition.vala"
	geary_mime_content_disposition_set_is_unknown_disposition_type (self, is_unknown);
#line 85 "../src/engine/mime/mime-content-disposition.vala"
	geary_mime_content_disposition_set_original_disposition_type_string (self, disposition);
#line 86 "../src/engine/mime/mime-content-disposition.vala"
	_tmp3_ = _g_object_ref0 (params);
#line 86 "../src/engine/mime/mime-content-disposition.vala"
	_tmp2_ = _tmp3_;
#line 86 "../src/engine/mime/mime-content-disposition.vala"
	if (_tmp2_ == NULL) {
#line 268 "mime-content-disposition.c"
		GearyMimeContentParameters* _tmp4_;
#line 86 "../src/engine/mime/mime-content-disposition.vala"
		_tmp4_ = geary_mime_content_parameters_new (NULL);
#line 86 "../src/engine/mime/mime-content-disposition.vala"
		_g_object_unref0 (_tmp2_);
#line 86 "../src/engine/mime/mime-content-disposition.vala"
		_tmp2_ = _tmp4_;
#line 276 "mime-content-disposition.c"
	}
#line 86 "../src/engine/mime/mime-content-disposition.vala"
	geary_mime_content_disposition_set_params (self, _tmp2_);
#line 81 "../src/engine/mime/mime-content-disposition.vala"
	_g_object_unref0 (_tmp2_);
#line 81 "../src/engine/mime/mime-content-disposition.vala"
	return self;
#line 284 "mime-content-disposition.c"
}

GearyMimeContentDisposition*
geary_mime_content_disposition_new (const gchar* disposition,
                                    GearyMimeContentParameters* params)
{
#line 81 "../src/engine/mime/mime-content-disposition.vala"
	return geary_mime_content_disposition_construct (GEARY_MIME_TYPE_CONTENT_DISPOSITION, disposition, params);
#line 293 "mime-content-disposition.c"
}

/**
     * Create a simplified Content-Disposition representation.
     */
GearyMimeContentDisposition*
geary_mime_content_disposition_construct_simple (GType object_type,
                                                 GearyMimeDispositionType disposition_type)
{
	GearyMimeContentDisposition * self = NULL;
	GearyMimeContentParameters* _tmp0_;
	GearyMimeContentParameters* _tmp1_;
#line 92 "../src/engine/mime/mime-content-disposition.vala"
	self = (GearyMimeContentDisposition*) geary_base_object_construct (object_type);
#line 93 "../src/engine/mime/mime-content-disposition.vala"
	geary_mime_content_disposition_set_disposition_type (self, disposition_type);
#line 94 "../src/engine/mime/mime-content-disposition.vala"
	geary_mime_content_disposition_set_is_unknown_disposition_type (self, FALSE);
#line 95 "../src/engine/mime/mime-content-disposition.vala"
	geary_mime_content_disposition_set_original_disposition_type_string (self, NULL);
#line 96 "../src/engine/mime/mime-content-disposition.vala"
	_tmp0_ = geary_mime_content_parameters_new (NULL);
#line 96 "../src/engine/mime/mime-content-disposition.vala"
	_tmp1_ = _tmp0_;
#line 96 "../src/engine/mime/mime-content-disposition.vala"
	geary_mime_content_disposition_set_params (self, _tmp1_);
#line 96 "../src/engine/mime/mime-content-disposition.vala"
	_g_object_unref0 (_tmp1_);
#line 92 "../src/engine/mime/mime-content-disposition.vala"
	return self;
#line 324 "mime-content-disposition.c"
}

GearyMimeContentDisposition*
geary_mime_content_disposition_new_simple (GearyMimeDispositionType disposition_type)
{
#line 92 "../src/engine/mime/mime-content-disposition.vala"
	return geary_mime_content_disposition_construct_simple (GEARY_MIME_TYPE_CONTENT_DISPOSITION, disposition_type);
#line 332 "mime-content-disposition.c"
}

GearyMimeContentDisposition*
geary_mime_content_disposition_construct_from_gmime (GType object_type,
                                                     GMimeContentDisposition* content_disposition)
{
	GearyMimeContentDisposition * self = NULL;
	gboolean is_unknown = FALSE;
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GearyMimeDispositionType _tmp2_;
	const gchar* _tmp3_;
	GMimeParamList* _tmp4_;
	GearyMimeContentParameters* _tmp5_;
	GearyMimeContentParameters* _tmp6_;
#line 99 "../src/engine/mime/mime-content-disposition.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (content_disposition, g_mime_content_disposition_get_type ()), NULL);
#line 99 "../src/engine/mime/mime-content-disposition.vala"
	self = (GearyMimeContentDisposition*) geary_base_object_construct (object_type);
#line 101 "../src/engine/mime/mime-content-disposition.vala"
	_tmp0_ = g_mime_content_disposition_get_disposition (content_disposition);
#line 101 "../src/engine/mime/mime-content-disposition.vala"
	_tmp2_ = geary_mime_disposition_type_deserialize (_tmp0_, &_tmp1_);
#line 101 "../src/engine/mime/mime-content-disposition.vala"
	is_unknown = _tmp1_;
#line 101 "../src/engine/mime/mime-content-disposition.vala"
	geary_mime_content_disposition_set_disposition_type (self, _tmp2_);
#line 103 "../src/engine/mime/mime-content-disposition.vala"
	geary_mime_content_disposition_set_is_unknown_disposition_type (self, is_unknown);
#line 104 "../src/engine/mime/mime-content-disposition.vala"
	_tmp3_ = g_mime_content_disposition_get_disposition (content_disposition);
#line 104 "../src/engine/mime/mime-content-disposition.vala"
	geary_mime_content_disposition_set_original_disposition_type_string (self, _tmp3_);
#line 105 "../src/engine/mime/mime-content-disposition.vala"
	_tmp4_ = g_mime_content_disposition_get_parameters (content_disposition);
#line 105 "../src/engine/mime/mime-content-disposition.vala"
	_tmp5_ = geary_mime_content_parameters_new_from_gmime (_tmp4_);
#line 105 "../src/engine/mime/mime-content-disposition.vala"
	_tmp6_ = _tmp5_;
#line 105 "../src/engine/mime/mime-content-disposition.vala"
	geary_mime_content_disposition_set_params (self, _tmp6_);
#line 105 "../src/engine/mime/mime-content-disposition.vala"
	_g_object_unref0 (_tmp6_);
#line 99 "../src/engine/mime/mime-content-disposition.vala"
	return self;
#line 378 "mime-content-disposition.c"
}

GearyMimeContentDisposition*
geary_mime_content_disposition_new_from_gmime (GMimeContentDisposition* content_disposition)
{
#line 99 "../src/engine/mime/mime-content-disposition.vala"
	return geary_mime_content_disposition_construct_from_gmime (GEARY_MIME_TYPE_CONTENT_DISPOSITION, content_disposition);
#line 386 "mime-content-disposition.c"
}

static void
geary_mime_content_disposition_class_init (GearyMimeContentDispositionClass * klass,
                                           gpointer klass_data)
{
#line 13 "../src/engine/mime/mime-content-disposition.vala"
	geary_mime_content_disposition_parent_class = g_type_class_peek_parent (klass);
#line 13 "../src/engine/mime/mime-content-disposition.vala"
	g_type_class_adjust_private_offset (klass, &GearyMimeContentDisposition_private_offset);
#line 13 "../src/engine/mime/mime-content-disposition.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_mime_content_disposition_get_property;
#line 13 "../src/engine/mime/mime-content-disposition.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_mime_content_disposition_set_property;
#line 13 "../src/engine/mime/mime-content-disposition.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_mime_content_disposition_finalize;
#line 403 "mime-content-disposition.c"
	/**
	     * The {@link DispositionType}, which is {@link DispositionType.UNSPECIFIED} if not specified.
	     */
#line 13 "../src/engine/mime/mime-content-disposition.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_MIME_CONTENT_DISPOSITION_DISPOSITION_TYPE_PROPERTY, geary_mime_content_disposition_properties[GEARY_MIME_CONTENT_DISPOSITION_DISPOSITION_TYPE_PROPERTY] = g_param_spec_enum ("disposition-type", "disposition-type", "disposition-type", GEARY_MIME_TYPE_DISPOSITION_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 409 "mime-content-disposition.c"
	/**
	     * True if the original DispositionType was unknown.
	     */
#line 13 "../src/engine/mime/mime-content-disposition.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_MIME_CONTENT_DISPOSITION_IS_UNKNOWN_DISPOSITION_TYPE_PROPERTY, geary_mime_content_disposition_properties[GEARY_MIME_CONTENT_DISPOSITION_IS_UNKNOWN_DISPOSITION_TYPE_PROPERTY] = g_param_spec_boolean ("is-unknown-disposition-type", "is-unknown-disposition-type", "is-unknown-disposition-type", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 415 "mime-content-disposition.c"
	/**
	     * The original disposition type string.
	     */
#line 13 "../src/engine/mime/mime-content-disposition.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_MIME_CONTENT_DISPOSITION_ORIGINAL_DISPOSITION_TYPE_STRING_PROPERTY, geary_mime_content_disposition_properties[GEARY_MIME_CONTENT_DISPOSITION_ORIGINAL_DISPOSITION_TYPE_STRING_PROPERTY] = g_param_spec_string ("original-disposition-type-string", "original-disposition-type-string", "original-disposition-type-string", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 421 "mime-content-disposition.c"
	/**
	     * Various parameters associated with the content's disposition.
	     *
	     * This is never null.  Rather, an empty ContentParameters is held if the Content-Type has
	     * no parameters.
	     *
	     * @see FILENAME
	     * @see CREATION_DATE
	     * @see MODIFICATION_DATE
	     * @see READ_DATE
	     * @see SIZE
	     */
#line 13 "../src/engine/mime/mime-content-disposition.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_MIME_CONTENT_DISPOSITION_PARAMS_PROPERTY, geary_mime_content_disposition_properties[GEARY_MIME_CONTENT_DISPOSITION_PARAMS_PROPERTY] = g_param_spec_object ("params", "params", "params", GEARY_MIME_TYPE_CONTENT_PARAMETERS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 436 "mime-content-disposition.c"
}

static void
geary_mime_content_disposition_instance_init (GearyMimeContentDisposition * self,
                                              gpointer klass)
{
#line 13 "../src/engine/mime/mime-content-disposition.vala"
	self->priv = geary_mime_content_disposition_get_instance_private (self);
#line 445 "mime-content-disposition.c"
}

static void
geary_mime_content_disposition_finalize (GObject * obj)
{
	GearyMimeContentDisposition * self;
#line 13 "../src/engine/mime/mime-content-disposition.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_MIME_TYPE_CONTENT_DISPOSITION, GearyMimeContentDisposition);
#line 62 "../src/engine/mime/mime-content-disposition.vala"
	_g_free0 (self->priv->_original_disposition_type_string);
#line 76 "../src/engine/mime/mime-content-disposition.vala"
	_g_object_unref0 (self->priv->_params);
#line 13 "../src/engine/mime/mime-content-disposition.vala"
	G_OBJECT_CLASS (geary_mime_content_disposition_parent_class)->finalize (obj);
#line 460 "mime-content-disposition.c"
}

/**
 * A representation of the RFC 2183 Content-Disposition field.
 *
 * See [[https://tools.ietf.org/html/rfc2183]]
 */
 G_GNUC_NO_INLINE static GType
geary_mime_content_disposition_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyMimeContentDispositionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_mime_content_disposition_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyMimeContentDisposition), 0, (GInstanceInitFunc) geary_mime_content_disposition_instance_init, NULL };
	GType geary_mime_content_disposition_type_id;
	geary_mime_content_disposition_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyMimeContentDisposition", &g_define_type_info, 0);
	GearyMimeContentDisposition_private_offset = g_type_add_instance_private (geary_mime_content_disposition_type_id, sizeof (GearyMimeContentDispositionPrivate));
	return geary_mime_content_disposition_type_id;
}

GType
geary_mime_content_disposition_get_type (void)
{
	static gsize geary_mime_content_disposition_type_id__once = 0;
	if (g_once_init_enter (&geary_mime_content_disposition_type_id__once)) {
		GType geary_mime_content_disposition_type_id;
		geary_mime_content_disposition_type_id = geary_mime_content_disposition_get_type_once ();
		g_once_init_leave (&geary_mime_content_disposition_type_id__once, geary_mime_content_disposition_type_id);
	}
	return geary_mime_content_disposition_type_id__once;
}

static void
_vala_geary_mime_content_disposition_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec)
{
	GearyMimeContentDisposition * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_MIME_TYPE_CONTENT_DISPOSITION, GearyMimeContentDisposition);
#line 13 "../src/engine/mime/mime-content-disposition.vala"
	switch (property_id) {
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		case GEARY_MIME_CONTENT_DISPOSITION_DISPOSITION_TYPE_PROPERTY:
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		g_value_set_enum (value, geary_mime_content_disposition_get_disposition_type (self));
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		break;
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		case GEARY_MIME_CONTENT_DISPOSITION_IS_UNKNOWN_DISPOSITION_TYPE_PROPERTY:
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		g_value_set_boolean (value, geary_mime_content_disposition_get_is_unknown_disposition_type (self));
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		break;
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		case GEARY_MIME_CONTENT_DISPOSITION_ORIGINAL_DISPOSITION_TYPE_STRING_PROPERTY:
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		g_value_set_string (value, geary_mime_content_disposition_get_original_disposition_type_string (self));
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		break;
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		case GEARY_MIME_CONTENT_DISPOSITION_PARAMS_PROPERTY:
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		g_value_set_object (value, geary_mime_content_disposition_get_params (self));
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		break;
#line 524 "mime-content-disposition.c"
		default:
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		break;
#line 530 "mime-content-disposition.c"
	}
}

static void
_vala_geary_mime_content_disposition_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec)
{
	GearyMimeContentDisposition * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_MIME_TYPE_CONTENT_DISPOSITION, GearyMimeContentDisposition);
#line 13 "../src/engine/mime/mime-content-disposition.vala"
	switch (property_id) {
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		case GEARY_MIME_CONTENT_DISPOSITION_DISPOSITION_TYPE_PROPERTY:
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		geary_mime_content_disposition_set_disposition_type (self, g_value_get_enum (value));
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		break;
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		case GEARY_MIME_CONTENT_DISPOSITION_IS_UNKNOWN_DISPOSITION_TYPE_PROPERTY:
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		geary_mime_content_disposition_set_is_unknown_disposition_type (self, g_value_get_boolean (value));
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		break;
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		case GEARY_MIME_CONTENT_DISPOSITION_ORIGINAL_DISPOSITION_TYPE_STRING_PROPERTY:
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		geary_mime_content_disposition_set_original_disposition_type_string (self, g_value_get_string (value));
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		break;
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		case GEARY_MIME_CONTENT_DISPOSITION_PARAMS_PROPERTY:
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		geary_mime_content_disposition_set_params (self, g_value_get_object (value));
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		break;
#line 568 "mime-content-disposition.c"
		default:
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 13 "../src/engine/mime/mime-content-disposition.vala"
		break;
#line 574 "mime-content-disposition.c"
	}
}

