/* mime-content-type.c generated by valac 0.56.17, the Vala compiler
 * generated from mime-content-type.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <gmime/gmime.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_MIME_CONTENT_TYPE_0_PROPERTY,
	GEARY_MIME_CONTENT_TYPE_MEDIA_TYPE_PROPERTY,
	GEARY_MIME_CONTENT_TYPE_MEDIA_SUBTYPE_PROPERTY,
	GEARY_MIME_CONTENT_TYPE_PARAMS_PROPERTY,
	GEARY_MIME_CONTENT_TYPE_NUM_PROPERTIES
};
static GParamSpec* geary_mime_content_type_properties[GEARY_MIME_CONTENT_TYPE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GMimeParserOptions_free0(var) ((var == NULL) ? NULL : (var = (_vala_GMimeParserOptions_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _GearyMimeContentTypePrivate {
	gchar* _media_type;
	gchar* _media_subtype;
	GearyMimeContentParameters* _params;
};

static gint GearyMimeContentType_private_offset;
static gpointer geary_mime_content_type_parent_class = NULL;
GearyMimeContentType* geary_mime_content_type_DISPLAY_DEFAULT = NULL;
GearyMimeContentType* geary_mime_content_type_ATTACHMENT_DEFAULT = NULL;
static GeeMap* geary_mime_content_type_TYPES_TO_EXTENSIONS;
static GeeMap* geary_mime_content_type_TYPES_TO_EXTENSIONS = NULL;

VALA_EXTERN GearyMimeContentType* geary_mime_content_type_new_from_gmime (GMimeContentType* content_type);
VALA_EXTERN GearyMimeContentType* geary_mime_content_type_construct_from_gmime (GType object_type,
                                                                    GMimeContentType* content_type);
static void _vala_GMimeParserOptions_free (GMimeParserOptions* self);
static guint8* _vala_array_dup11 (guint8* self,
                           gssize length);
static guint8* _vala_array_dup12 (guint8* self,
                           gssize length);
static void geary_mime_content_type_set_media_type (GearyMimeContentType* self,
                                             const gchar* value);
static void geary_mime_content_type_set_media_subtype (GearyMimeContentType* self,
                                                const gchar* value);
static void geary_mime_content_type_set_params (GearyMimeContentType* self,
                                         GearyMimeContentParameters* value);
VALA_EXTERN GearyMimeContentParameters* geary_mime_content_parameters_new_from_gmime (GMimeParamList* gmime);
VALA_EXTERN GearyMimeContentParameters* geary_mime_content_parameters_construct_from_gmime (GType object_type,
                                                                                GMimeParamList* gmime);
static void geary_mime_content_type_finalize (GObject * obj);
static GType geary_mime_content_type_get_type_once (void);
static void _vala_geary_mime_content_type_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_geary_mime_content_type_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
geary_mime_content_type_get_instance_private (GearyMimeContentType* self)
{
	return G_STRUCT_MEMBER_P (self, GearyMimeContentType_private_offset);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 112 "mime-content-type.c"
}

static void
_vala_GMimeParserOptions_free (GMimeParserOptions* self)
{
#line 77 "../src/engine/mime/mime-content-type.vala"
	g_boxed_free (g_mime_parser_options_get_type (), self);
#line 120 "mime-content-type.c"
}

GearyMimeContentType*
geary_mime_content_type_parse (const gchar* str,
                               GError** error)
{
	GMimeParserOptions* _tmp2_;
	GMimeParserOptions* _tmp3_;
	GMimeContentType* _tmp4_;
	GMimeContentType* _tmp5_;
	GearyMimeContentType* _tmp6_;
	GearyMimeContentType* _tmp7_;
	GError* _inner_error0_ = NULL;
	GearyMimeContentType* result;
#line 68 "../src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 71 "../src/engine/mime/mime-content-type.vala"
	if (geary_string_is_empty (str)) {
#line 139 "mime-content-type.c"
		GError* _tmp0_;
#line 72 "../src/engine/mime/mime-content-type.vala"
		_tmp0_ = g_error_new_literal (GEARY_MIME_ERROR, GEARY_MIME_ERROR_PARSE, "Empty MIME Content-Type");
#line 72 "../src/engine/mime/mime-content-type.vala"
		_inner_error0_ = _tmp0_;
#line 72 "../src/engine/mime/mime-content-type.vala"
		if (_inner_error0_->domain == GEARY_MIME_ERROR) {
#line 72 "../src/engine/mime/mime-content-type.vala"
			g_propagate_error (error, _inner_error0_);
#line 72 "../src/engine/mime/mime-content-type.vala"
			return NULL;
#line 151 "mime-content-type.c"
		} else {
#line 72 "../src/engine/mime/mime-content-type.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 72 "../src/engine/mime/mime-content-type.vala"
			g_clear_error (&_inner_error0_);
#line 72 "../src/engine/mime/mime-content-type.vala"
			return NULL;
#line 159 "mime-content-type.c"
		}
	}
#line 74 "../src/engine/mime/mime-content-type.vala"
	if (!string_contains (str, "/")) {
#line 164 "mime-content-type.c"
		GError* _tmp1_;
#line 75 "../src/engine/mime/mime-content-type.vala"
		_tmp1_ = g_error_new (GEARY_MIME_ERROR, GEARY_MIME_ERROR_PARSE, "Invalid MIME Content-Type: %s", str);
#line 75 "../src/engine/mime/mime-content-type.vala"
		_inner_error0_ = _tmp1_;
#line 75 "../src/engine/mime/mime-content-type.vala"
		if (_inner_error0_->domain == GEARY_MIME_ERROR) {
#line 75 "../src/engine/mime/mime-content-type.vala"
			g_propagate_error (error, _inner_error0_);
#line 75 "../src/engine/mime/mime-content-type.vala"
			return NULL;
#line 176 "mime-content-type.c"
		} else {
#line 75 "../src/engine/mime/mime-content-type.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 75 "../src/engine/mime/mime-content-type.vala"
			g_clear_error (&_inner_error0_);
#line 75 "../src/engine/mime/mime-content-type.vala"
			return NULL;
#line 184 "mime-content-type.c"
		}
	}
#line 77 "../src/engine/mime/mime-content-type.vala"
	_tmp2_ = geary_rf_c822_get_parser_options ();
#line 77 "../src/engine/mime/mime-content-type.vala"
	_tmp3_ = _tmp2_;
#line 77 "../src/engine/mime/mime-content-type.vala"
	_tmp4_ = g_mime_content_type_parse (_tmp3_, str);
#line 77 "../src/engine/mime/mime-content-type.vala"
	_tmp5_ = _tmp4_;
#line 77 "../src/engine/mime/mime-content-type.vala"
	_tmp6_ = geary_mime_content_type_new_from_gmime (_tmp5_);
#line 77 "../src/engine/mime/mime-content-type.vala"
	_tmp7_ = _tmp6_;
#line 77 "../src/engine/mime/mime-content-type.vala"
	_g_object_unref0 (_tmp5_);
#line 77 "../src/engine/mime/mime-content-type.vala"
	__vala_GMimeParserOptions_free0 (_tmp3_);
#line 77 "../src/engine/mime/mime-content-type.vala"
	result = _tmp7_;
#line 77 "../src/engine/mime/mime-content-type.vala"
	return result;
#line 207 "mime-content-type.c"
}

/**
     * Attempts to guess the content type for a buffer using GIO sniffing.
     *
     * Returns null if it could not be guessed.
     */
static GBytes*
_vala_g_bytes_slice (GBytes* self,
                     gsize start,
                     gsize end)
{
	GBytes* _tmp0_;
	GBytes* result;
#line 5994 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 5995 "glib-2.0.vapi"
	_tmp0_ = g_bytes_new_from_bytes (self, start, end - start);
#line 5995 "glib-2.0.vapi"
	result = _tmp0_;
#line 5995 "glib-2.0.vapi"
	return result;
#line 230 "mime-content-type.c"
}

static guint8*
_vala_array_dup11 (guint8* self,
                   gssize length)
{
#line 108 "../src/engine/mime/mime-content-type.vala"
	if (length > 0) {
#line 108 "../src/engine/mime/mime-content-type.vala"
		return g_memdup2 (self, length * sizeof (guint8));
#line 241 "mime-content-type.c"
	}
#line 108 "../src/engine/mime/mime-content-type.vala"
	return NULL;
#line 245 "mime-content-type.c"
}

static guint8*
_vala_array_dup12 (guint8* self,
                   gssize length)
{
#line 106 "../src/engine/mime/mime-content-type.vala"
	if (length > 0) {
#line 106 "../src/engine/mime/mime-content-type.vala"
		return g_memdup2 (self, length * sizeof (guint8));
#line 256 "mime-content-type.c"
	}
#line 106 "../src/engine/mime/mime-content-type.vala"
	return NULL;
#line 260 "mime-content-type.c"
}

GearyMimeContentType*
geary_mime_content_type_guess_type (const gchar* file_name,
                                    GearyMemoryBuffer* buf,
                                    GError** error)
{
	gchar* mime_type = NULL;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	GearyMimeContentType* _tmp23_ = NULL;
	const gchar* _tmp24_;
	GError* _inner_error0_ = NULL;
	GearyMimeContentType* result;
#line 88 "../src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail ((buf == NULL) || GEARY_MEMORY_IS_BUFFER (buf), NULL);
#line 90 "../src/engine/mime/mime-content-type.vala"
	mime_type = NULL;
#line 92 "../src/engine/mime/mime-content-type.vala"
	if (file_name != NULL) {
#line 281 "mime-content-type.c"
		gchar* glib_type = NULL;
		gchar* _tmp0_;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
#line 95 "../src/engine/mime/mime-content-type.vala"
		_tmp0_ = g_content_type_guess (file_name, NULL, (gsize) 0, NULL);
#line 95 "../src/engine/mime/mime-content-type.vala"
		glib_type = _tmp0_;
#line 96 "../src/engine/mime/mime-content-type.vala"
		_tmp1_ = glib_type;
#line 96 "../src/engine/mime/mime-content-type.vala"
		_tmp2_ = g_content_type_get_mime_type (_tmp1_);
#line 96 "../src/engine/mime/mime-content-type.vala"
		_g_free0 (mime_type);
#line 96 "../src/engine/mime/mime-content-type.vala"
		mime_type = _tmp2_;
#line 97 "../src/engine/mime/mime-content-type.vala"
		_tmp3_ = mime_type;
#line 97 "../src/engine/mime/mime-content-type.vala"
		if (geary_string_is_empty (_tmp3_)) {
#line 98 "../src/engine/mime/mime-content-type.vala"
			_g_free0 (mime_type);
#line 98 "../src/engine/mime/mime-content-type.vala"
			mime_type = NULL;
#line 307 "mime-content-type.c"
		}
#line 92 "../src/engine/mime/mime-content-type.vala"
		_g_free0 (glib_type);
#line 311 "mime-content-type.c"
	}
#line 102 "../src/engine/mime/mime-content-type.vala"
	_tmp5_ = mime_type;
#line 102 "../src/engine/mime/mime-content-type.vala"
	if (_tmp5_ == NULL) {
#line 102 "../src/engine/mime/mime-content-type.vala"
		_tmp4_ = buf != NULL;
#line 319 "mime-content-type.c"
	} else {
#line 102 "../src/engine/mime/mime-content-type.vala"
		_tmp4_ = FALSE;
#line 323 "mime-content-type.c"
	}
#line 102 "../src/engine/mime/mime-content-type.vala"
	if (_tmp4_) {
#line 327 "mime-content-type.c"
		gint max_len = 0;
		guint8* _tmp6_ = NULL;
		gint _tmp6__length1 = 0;
		gint __tmp6__size_ = 0;
		gsize _tmp7_;
		gsize _tmp8_;
		guint8* data = NULL;
		guint8* _tmp18_;
		gint _tmp18__length1;
		gint data_length1;
		gint _data_size_;
		gchar* glib_type = NULL;
		guint8* _tmp19_;
		gint _tmp19__length1;
		gchar* _tmp20_;
		const gchar* _tmp21_;
		gchar* _tmp22_;
#line 103 "../src/engine/mime/mime-content-type.vala"
		max_len = 4096;
#line 106 "../src/engine/mime/mime-content-type.vala"
		_tmp7_ = geary_memory_buffer_get_size (buf);
#line 106 "../src/engine/mime/mime-content-type.vala"
		_tmp8_ = _tmp7_;
#line 106 "../src/engine/mime/mime-content-type.vala"
		if (_tmp8_ <= ((gsize) max_len)) {
#line 353 "mime-content-type.c"
			gint _tmp9_ = 0;
			guint8* _tmp10_;
#line 107 "../src/engine/mime/mime-content-type.vala"
			_tmp10_ = geary_memory_buffer_get_uint8_array (buf, &_tmp9_);
#line 107 "../src/engine/mime/mime-content-type.vala"
			_tmp6_ = (g_free (_tmp6_), NULL);
#line 107 "../src/engine/mime/mime-content-type.vala"
			_tmp6_ = _tmp10_;
#line 107 "../src/engine/mime/mime-content-type.vala"
			_tmp6__length1 = _tmp9_;
#line 107 "../src/engine/mime/mime-content-type.vala"
			__tmp6__size_ = _tmp6__length1;
#line 366 "mime-content-type.c"
		} else {
			GBytes* _tmp11_;
			GBytes* _tmp12_;
			GBytes* _tmp13_;
			GBytes* _tmp14_;
			gsize _tmp15_ = 0;
			guint8* _tmp16_;
			guint8* _tmp17_;
			gint _tmp17__length1;
#line 108 "../src/engine/mime/mime-content-type.vala"
			_tmp11_ = geary_memory_buffer_get_bytes (buf);
#line 108 "../src/engine/mime/mime-content-type.vala"
			_tmp12_ = _tmp11_;
#line 108 "../src/engine/mime/mime-content-type.vala"
			_tmp13_ = _vala_g_bytes_slice (_tmp12_, (gsize) 0, (gsize) max_len);
#line 108 "../src/engine/mime/mime-content-type.vala"
			_tmp14_ = _tmp13_;
#line 108 "../src/engine/mime/mime-content-type.vala"
			_tmp16_ = g_bytes_get_data (_tmp14_, &_tmp15_);
#line 108 "../src/engine/mime/mime-content-type.vala"
			_tmp17_ = (_tmp16_ != NULL) ? _vala_array_dup11 (_tmp16_, _tmp15_) : _tmp16_;
#line 108 "../src/engine/mime/mime-content-type.vala"
			_tmp17__length1 = _tmp15_;
#line 108 "../src/engine/mime/mime-content-type.vala"
			_tmp6_ = (g_free (_tmp6_), NULL);
#line 108 "../src/engine/mime/mime-content-type.vala"
			_tmp6_ = _tmp17_;
#line 108 "../src/engine/mime/mime-content-type.vala"
			_tmp6__length1 = _tmp17__length1;
#line 108 "../src/engine/mime/mime-content-type.vala"
			__tmp6__size_ = _tmp6__length1;
#line 108 "../src/engine/mime/mime-content-type.vala"
			_g_bytes_unref0 (_tmp14_);
#line 108 "../src/engine/mime/mime-content-type.vala"
			_g_bytes_unref0 (_tmp12_);
#line 402 "mime-content-type.c"
		}
#line 106 "../src/engine/mime/mime-content-type.vala"
		_tmp18_ = (_tmp6_ != NULL) ? _vala_array_dup12 (_tmp6_, _tmp6__length1) : _tmp6_;
#line 106 "../src/engine/mime/mime-content-type.vala"
		_tmp18__length1 = _tmp6__length1;
#line 106 "../src/engine/mime/mime-content-type.vala"
		data = _tmp18_;
#line 106 "../src/engine/mime/mime-content-type.vala"
		data_length1 = _tmp18__length1;
#line 106 "../src/engine/mime/mime-content-type.vala"
		_data_size_ = data_length1;
#line 112 "../src/engine/mime/mime-content-type.vala"
		_tmp19_ = data;
#line 112 "../src/engine/mime/mime-content-type.vala"
		_tmp19__length1 = data_length1;
#line 112 "../src/engine/mime/mime-content-type.vala"
		_tmp20_ = g_content_type_guess (NULL, _tmp19_, (gsize) _tmp19__length1, NULL);
#line 112 "../src/engine/mime/mime-content-type.vala"
		glib_type = _tmp20_;
#line 113 "../src/engine/mime/mime-content-type.vala"
		_tmp21_ = glib_type;
#line 113 "../src/engine/mime/mime-content-type.vala"
		_tmp22_ = g_content_type_get_mime_type (_tmp21_);
#line 113 "../src/engine/mime/mime-content-type.vala"
		_g_free0 (mime_type);
#line 113 "../src/engine/mime/mime-content-type.vala"
		mime_type = _tmp22_;
#line 102 "../src/engine/mime/mime-content-type.vala"
		_g_free0 (glib_type);
#line 102 "../src/engine/mime/mime-content-type.vala"
		data = (g_free (data), NULL);
#line 102 "../src/engine/mime/mime-content-type.vala"
		_tmp6_ = (g_free (_tmp6_), NULL);
#line 436 "mime-content-type.c"
	}
#line 116 "../src/engine/mime/mime-content-type.vala"
	_tmp24_ = mime_type;
#line 116 "../src/engine/mime/mime-content-type.vala"
	if (!geary_string_is_empty_or_whitespace (_tmp24_)) {
#line 442 "mime-content-type.c"
		const gchar* _tmp25_;
		GearyMimeContentType* _tmp26_;
#line 118 "../src/engine/mime/mime-content-type.vala"
		_tmp25_ = mime_type;
#line 118 "../src/engine/mime/mime-content-type.vala"
		_tmp26_ = geary_mime_content_type_parse (_tmp25_, &_inner_error0_);
#line 118 "../src/engine/mime/mime-content-type.vala"
		_g_object_unref0 (_tmp23_);
#line 118 "../src/engine/mime/mime-content-type.vala"
		_tmp23_ = _tmp26_;
#line 118 "../src/engine/mime/mime-content-type.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 118 "../src/engine/mime/mime-content-type.vala"
			g_propagate_error (error, _inner_error0_);
#line 118 "../src/engine/mime/mime-content-type.vala"
			_g_object_unref0 (_tmp23_);
#line 118 "../src/engine/mime/mime-content-type.vala"
			_g_free0 (mime_type);
#line 118 "../src/engine/mime/mime-content-type.vala"
			return NULL;
#line 463 "mime-content-type.c"
		}
	} else {
#line 119 "../src/engine/mime/mime-content-type.vala"
		_g_object_unref0 (_tmp23_);
#line 119 "../src/engine/mime/mime-content-type.vala"
		_tmp23_ = NULL;
#line 470 "mime-content-type.c"
	}
#line 116 "../src/engine/mime/mime-content-type.vala"
	result = _tmp23_;
#line 116 "../src/engine/mime/mime-content-type.vala"
	_g_free0 (mime_type);
#line 116 "../src/engine/mime/mime-content-type.vala"
	return result;
#line 478 "mime-content-type.c"
}

const gchar*
geary_mime_content_type_get_media_type (GearyMimeContentType* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 134 "../src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self), NULL);
#line 134 "../src/engine/mime/mime-content-type.vala"
	_tmp0_ = self->priv->_media_type;
#line 134 "../src/engine/mime/mime-content-type.vala"
	result = _tmp0_;
#line 134 "../src/engine/mime/mime-content-type.vala"
	return result;
#line 494 "mime-content-type.c"
}

static void
geary_mime_content_type_set_media_type (GearyMimeContentType* self,
                                        const gchar* value)
{
	gchar* old_value;
#line 134 "../src/engine/mime/mime-content-type.vala"
	g_return_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self));
#line 134 "../src/engine/mime/mime-content-type.vala"
	old_value = geary_mime_content_type_get_media_type (self);
#line 134 "../src/engine/mime/mime-content-type.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 508 "mime-content-type.c"
		gchar* _tmp0_;
#line 134 "../src/engine/mime/mime-content-type.vala"
		_tmp0_ = g_strdup (value);
#line 134 "../src/engine/mime/mime-content-type.vala"
		_g_free0 (self->priv->_media_type);
#line 134 "../src/engine/mime/mime-content-type.vala"
		self->priv->_media_type = _tmp0_;
#line 134 "../src/engine/mime/mime-content-type.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_mime_content_type_properties[GEARY_MIME_CONTENT_TYPE_MEDIA_TYPE_PROPERTY]);
#line 518 "mime-content-type.c"
	}
}

const gchar*
geary_mime_content_type_get_media_subtype (GearyMimeContentType* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 146 "../src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self), NULL);
#line 146 "../src/engine/mime/mime-content-type.vala"
	_tmp0_ = self->priv->_media_subtype;
#line 146 "../src/engine/mime/mime-content-type.vala"
	result = _tmp0_;
#line 146 "../src/engine/mime/mime-content-type.vala"
	return result;
#line 535 "mime-content-type.c"
}

static void
geary_mime_content_type_set_media_subtype (GearyMimeContentType* self,
                                           const gchar* value)
{
	gchar* old_value;
#line 146 "../src/engine/mime/mime-content-type.vala"
	g_return_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self));
#line 146 "../src/engine/mime/mime-content-type.vala"
	old_value = geary_mime_content_type_get_media_subtype (self);
#line 146 "../src/engine/mime/mime-content-type.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 549 "mime-content-type.c"
		gchar* _tmp0_;
#line 146 "../src/engine/mime/mime-content-type.vala"
		_tmp0_ = g_strdup (value);
#line 146 "../src/engine/mime/mime-content-type.vala"
		_g_free0 (self->priv->_media_subtype);
#line 146 "../src/engine/mime/mime-content-type.vala"
		self->priv->_media_subtype = _tmp0_;
#line 146 "../src/engine/mime/mime-content-type.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_mime_content_type_properties[GEARY_MIME_CONTENT_TYPE_MEDIA_SUBTYPE_PROPERTY]);
#line 559 "mime-content-type.c"
	}
}

GearyMimeContentParameters*
geary_mime_content_type_get_params (GearyMimeContentType* self)
{
	GearyMimeContentParameters* result;
	GearyMimeContentParameters* _tmp0_;
#line 154 "../src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self), NULL);
#line 154 "../src/engine/mime/mime-content-type.vala"
	_tmp0_ = self->priv->_params;
#line 154 "../src/engine/mime/mime-content-type.vala"
	result = _tmp0_;
#line 154 "../src/engine/mime/mime-content-type.vala"
	return result;
#line 576 "mime-content-type.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 154 "../src/engine/mime/mime-content-type.vala"
	return self ? g_object_ref (self) : NULL;
#line 584 "mime-content-type.c"
}

static void
geary_mime_content_type_set_params (GearyMimeContentType* self,
                                    GearyMimeContentParameters* value)
{
	GearyMimeContentParameters* old_value;
#line 154 "../src/engine/mime/mime-content-type.vala"
	g_return_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self));
#line 154 "../src/engine/mime/mime-content-type.vala"
	old_value = geary_mime_content_type_get_params (self);
#line 154 "../src/engine/mime/mime-content-type.vala"
	if (old_value != value) {
#line 598 "mime-content-type.c"
		GearyMimeContentParameters* _tmp0_;
#line 154 "../src/engine/mime/mime-content-type.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 154 "../src/engine/mime/mime-content-type.vala"
		_g_object_unref0 (self->priv->_params);
#line 154 "../src/engine/mime/mime-content-type.vala"
		self->priv->_params = _tmp0_;
#line 154 "../src/engine/mime/mime-content-type.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_mime_content_type_properties[GEARY_MIME_CONTENT_TYPE_PARAMS_PROPERTY]);
#line 608 "mime-content-type.c"
	}
}

/**
     * Create a MIME Content-Type representative object.
     */
static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 633 "mime-content-type.c"
}

GearyMimeContentType*
geary_mime_content_type_construct (GType object_type,
                                   const gchar* media_type,
                                   const gchar* media_subtype,
                                   GearyMimeContentParameters* params)
{
	GearyMimeContentType * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GearyMimeContentParameters* _tmp4_ = NULL;
	GearyMimeContentParameters* _tmp5_;
#line 159 "../src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (media_type != NULL, NULL);
#line 159 "../src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (media_subtype != NULL, NULL);
#line 159 "../src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail ((params == NULL) || GEARY_MIME_IS_CONTENT_PARAMETERS (params), NULL);
#line 159 "../src/engine/mime/mime-content-type.vala"
	self = (GearyMimeContentType*) geary_base_object_construct (object_type);
#line 160 "../src/engine/mime/mime-content-type.vala"
	_tmp0_ = string_strip (media_type);
#line 160 "../src/engine/mime/mime-content-type.vala"
	_tmp1_ = _tmp0_;
#line 160 "../src/engine/mime/mime-content-type.vala"
	geary_mime_content_type_set_media_type (self, _tmp1_);
#line 160 "../src/engine/mime/mime-content-type.vala"
	_g_free0 (_tmp1_);
#line 161 "../src/engine/mime/mime-content-type.vala"
	_tmp2_ = string_strip (media_subtype);
#line 161 "../src/engine/mime/mime-content-type.vala"
	_tmp3_ = _tmp2_;
#line 161 "../src/engine/mime/mime-content-type.vala"
	geary_mime_content_type_set_media_subtype (self, _tmp3_);
#line 161 "../src/engine/mime/mime-content-type.vala"
	_g_free0 (_tmp3_);
#line 162 "../src/engine/mime/mime-content-type.vala"
	_tmp5_ = _g_object_ref0 (params);
#line 162 "../src/engine/mime/mime-content-type.vala"
	_tmp4_ = _tmp5_;
#line 162 "../src/engine/mime/mime-content-type.vala"
	if (_tmp4_ == NULL) {
#line 679 "mime-content-type.c"
		GearyMimeContentParameters* _tmp6_;
#line 162 "../src/engine/mime/mime-content-type.vala"
		_tmp6_ = geary_mime_content_parameters_new (NULL);
#line 162 "../src/engine/mime/mime-content-type.vala"
		_g_object_unref0 (_tmp4_);
#line 162 "../src/engine/mime/mime-content-type.vala"
		_tmp4_ = _tmp6_;
#line 687 "mime-content-type.c"
	}
#line 162 "../src/engine/mime/mime-content-type.vala"
	geary_mime_content_type_set_params (self, _tmp4_);
#line 159 "../src/engine/mime/mime-content-type.vala"
	_g_object_unref0 (_tmp4_);
#line 159 "../src/engine/mime/mime-content-type.vala"
	return self;
#line 695 "mime-content-type.c"
}

GearyMimeContentType*
geary_mime_content_type_new (const gchar* media_type,
                             const gchar* media_subtype,
                             GearyMimeContentParameters* params)
{
#line 159 "../src/engine/mime/mime-content-type.vala"
	return geary_mime_content_type_construct (GEARY_MIME_TYPE_CONTENT_TYPE, media_type, media_subtype, params);
#line 705 "mime-content-type.c"
}

GearyMimeContentType*
geary_mime_content_type_construct_from_gmime (GType object_type,
                                              GMimeContentType* content_type)
{
	GearyMimeContentType * self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GMimeParamList* _tmp6_;
	GearyMimeContentParameters* _tmp7_;
	GearyMimeContentParameters* _tmp8_;
#line 165 "../src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (content_type, g_mime_content_type_get_type ()), NULL);
#line 165 "../src/engine/mime/mime-content-type.vala"
	self = (GearyMimeContentType*) geary_base_object_construct (object_type);
#line 166 "../src/engine/mime/mime-content-type.vala"
	_tmp0_ = g_mime_content_type_get_media_type (content_type);
#line 166 "../src/engine/mime/mime-content-type.vala"
	_tmp1_ = string_strip (_tmp0_);
#line 166 "../src/engine/mime/mime-content-type.vala"
	_tmp2_ = _tmp1_;
#line 166 "../src/engine/mime/mime-content-type.vala"
	geary_mime_content_type_set_media_type (self, _tmp2_);
#line 166 "../src/engine/mime/mime-content-type.vala"
	_g_free0 (_tmp2_);
#line 167 "../src/engine/mime/mime-content-type.vala"
	_tmp3_ = g_mime_content_type_get_media_subtype (content_type);
#line 167 "../src/engine/mime/mime-content-type.vala"
	_tmp4_ = string_strip (_tmp3_);
#line 167 "../src/engine/mime/mime-content-type.vala"
	_tmp5_ = _tmp4_;
#line 167 "../src/engine/mime/mime-content-type.vala"
	geary_mime_content_type_set_media_subtype (self, _tmp5_);
#line 167 "../src/engine/mime/mime-content-type.vala"
	_g_free0 (_tmp5_);
#line 168 "../src/engine/mime/mime-content-type.vala"
	_tmp6_ = g_mime_content_type_get_parameters (content_type);
#line 168 "../src/engine/mime/mime-content-type.vala"
	_tmp7_ = geary_mime_content_parameters_new_from_gmime (_tmp6_);
#line 168 "../src/engine/mime/mime-content-type.vala"
	_tmp8_ = _tmp7_;
#line 168 "../src/engine/mime/mime-content-type.vala"
	geary_mime_content_type_set_params (self, _tmp8_);
#line 168 "../src/engine/mime/mime-content-type.vala"
	_g_object_unref0 (_tmp8_);
#line 165 "../src/engine/mime/mime-content-type.vala"
	return self;
#line 758 "mime-content-type.c"
}

GearyMimeContentType*
geary_mime_content_type_new_from_gmime (GMimeContentType* content_type)
{
#line 165 "../src/engine/mime/mime-content-type.vala"
	return geary_mime_content_type_construct_from_gmime (GEARY_MIME_TYPE_CONTENT_TYPE, content_type);
#line 766 "mime-content-type.c"
}

/**
     * Compares the {@link media_type} with the supplied type.
     *
     * An asterisk ("*") or {@link WILDCARD} are accepted, which will always return true.
     *
     * @see is_type
     */
gboolean
geary_mime_content_type_has_media_type (GearyMimeContentType* self,
                                        const gchar* media_type)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 178 "../src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self), FALSE);
#line 178 "../src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (media_type != NULL, FALSE);
#line 179 "../src/engine/mime/mime-content-type.vala"
	if (g_strcmp0 (media_type, GEARY_MIME_CONTENT_TYPE_WILDCARD) != 0) {
#line 788 "mime-content-type.c"
		const gchar* _tmp1_;
#line 179 "../src/engine/mime/mime-content-type.vala"
		_tmp1_ = self->priv->_media_type;
#line 179 "../src/engine/mime/mime-content-type.vala"
		_tmp0_ = geary_ascii_stri_equal (_tmp1_, media_type);
#line 794 "mime-content-type.c"
	} else {
#line 179 "../src/engine/mime/mime-content-type.vala"
		_tmp0_ = TRUE;
#line 798 "mime-content-type.c"
	}
#line 179 "../src/engine/mime/mime-content-type.vala"
	result = _tmp0_;
#line 179 "../src/engine/mime/mime-content-type.vala"
	return result;
#line 804 "mime-content-type.c"
}

/**
     * Compares the {@link media_subtype} with the supplied subtype.
     *
     * An asterisk ("*") or {@link WILDCARD} are accepted, which will always return true.
     *
     * @see is_type
     */
gboolean
geary_mime_content_type_has_media_subtype (GearyMimeContentType* self,
                                           const gchar* media_subtype)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 189 "../src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self), FALSE);
#line 189 "../src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (media_subtype != NULL, FALSE);
#line 190 "../src/engine/mime/mime-content-type.vala"
	if (g_strcmp0 (media_subtype, GEARY_MIME_CONTENT_TYPE_WILDCARD) != 0) {
#line 826 "mime-content-type.c"
		const gchar* _tmp1_;
#line 190 "../src/engine/mime/mime-content-type.vala"
		_tmp1_ = self->priv->_media_subtype;
#line 190 "../src/engine/mime/mime-content-type.vala"
		_tmp0_ = geary_ascii_stri_equal (_tmp1_, media_subtype);
#line 832 "mime-content-type.c"
	} else {
#line 190 "../src/engine/mime/mime-content-type.vala"
		_tmp0_ = TRUE;
#line 836 "mime-content-type.c"
	}
#line 190 "../src/engine/mime/mime-content-type.vala"
	result = _tmp0_;
#line 190 "../src/engine/mime/mime-content-type.vala"
	return result;
#line 842 "mime-content-type.c"
}

/**
     * Returns the {@link ContentType}'s media content type (its "MIME type").
     *
     * This returns the bare MIME content type description lacking all parameters.  For example,
     * "image/jpeg; name='photo.JPG'" will be returned as "image/jpeg".
     *
     * @see serialize
     */
gchar*
geary_mime_content_type_get_mime_type (GearyMimeContentType* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 201 "../src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self), NULL);
#line 202 "../src/engine/mime/mime-content-type.vala"
	_tmp0_ = self->priv->_media_type;
#line 202 "../src/engine/mime/mime-content-type.vala"
	_tmp1_ = self->priv->_media_subtype;
#line 202 "../src/engine/mime/mime-content-type.vala"
	_tmp2_ = g_strdup_printf ("%s/%s", _tmp0_, _tmp1_);
#line 202 "../src/engine/mime/mime-content-type.vala"
	result = _tmp2_;
#line 202 "../src/engine/mime/mime-content-type.vala"
	return result;
#line 872 "mime-content-type.c"
}

/**
     * Returns the file name extension for this type, if known.
     */
gchar*
geary_mime_content_type_get_file_name_extension (GearyMimeContentType* self)
{
	GeeMap* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gpointer _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 208 "../src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self), NULL);
#line 209 "../src/engine/mime/mime-content-type.vala"
	_tmp0_ = geary_mime_content_type_TYPES_TO_EXTENSIONS;
#line 209 "../src/engine/mime/mime-content-type.vala"
	_tmp1_ = geary_mime_content_type_get_mime_type (self);
#line 209 "../src/engine/mime/mime-content-type.vala"
	_tmp2_ = _tmp1_;
#line 209 "../src/engine/mime/mime-content-type.vala"
	_tmp3_ = gee_map_get (_tmp0_, _tmp2_);
#line 209 "../src/engine/mime/mime-content-type.vala"
	_tmp4_ = (gchar*) _tmp3_;
#line 209 "../src/engine/mime/mime-content-type.vala"
	_g_free0 (_tmp2_);
#line 209 "../src/engine/mime/mime-content-type.vala"
	result = _tmp4_;
#line 209 "../src/engine/mime/mime-content-type.vala"
	return result;
#line 905 "mime-content-type.c"
}

/**
     * Compares the supplied type and subtype with this instance's.
     *
     * Asterisks (or {@link WILDCARD}) may be supplied for either field.
     *
     * @see is_same
     */
gboolean
geary_mime_content_type_is_type (GearyMimeContentType* self,
                                 const gchar* media_type,
                                 const gchar* media_subtype)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 219 "../src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self), FALSE);
#line 219 "../src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (media_type != NULL, FALSE);
#line 219 "../src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (media_subtype != NULL, FALSE);
#line 220 "../src/engine/mime/mime-content-type.vala"
	if (geary_mime_content_type_has_media_type (self, media_type)) {
#line 220 "../src/engine/mime/mime-content-type.vala"
		_tmp0_ = geary_mime_content_type_has_media_subtype (self, media_subtype);
#line 932 "mime-content-type.c"
	} else {
#line 220 "../src/engine/mime/mime-content-type.vala"
		_tmp0_ = FALSE;
#line 936 "mime-content-type.c"
	}
#line 220 "../src/engine/mime/mime-content-type.vala"
	result = _tmp0_;
#line 220 "../src/engine/mime/mime-content-type.vala"
	return result;
#line 942 "mime-content-type.c"
}

/**
     * Compares this {@link ContentType} with another instance.
     *
     * This is slightly different than the notion of "equal to", as it's possible for
     * {@link ContentType} to hold {@link WILDCARD}s, which don't imply equality.
     *
     * @see is_type
     */
gboolean
geary_mime_content_type_is_same (GearyMimeContentType* self,
                                 GearyMimeContentType* other)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean result;
#line 231 "../src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self), FALSE);
#line 231 "../src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (other), FALSE);
#line 232 "../src/engine/mime/mime-content-type.vala"
	_tmp0_ = other->priv->_media_type;
#line 232 "../src/engine/mime/mime-content-type.vala"
	_tmp1_ = other->priv->_media_subtype;
#line 232 "../src/engine/mime/mime-content-type.vala"
	result = geary_mime_content_type_is_type (self, _tmp0_, _tmp1_);
#line 232 "../src/engine/mime/mime-content-type.vala"
	return result;
#line 972 "mime-content-type.c"
}

/**
     * Compares the supplied MIME type (i.e. "image/jpeg") with this instance.
     *
     * As in {@link get_mime_type}, this method is only worried about the media type and subtype
     * in the supplied string.  Parameters are ignored.
     *
     * Throws {@link MimeError} if the supplied string doesn't look like a MIME type.
     */
static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1204 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1205 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1205 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1207 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1207 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1002 "mime-content-type.c"
		gchar* _tmp2_;
#line 1208 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1208 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1208 "glib-2.0.vapi"
		return result;
#line 1010 "mime-content-type.c"
	} else {
#line 1210 "glib-2.0.vapi"
		result = -1;
#line 1210 "glib-2.0.vapi"
		return result;
#line 1016 "mime-content-type.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 1040 "mime-content-type.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 1049 "mime-content-type.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 1068 "mime-content-type.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1072 "mime-content-type.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1078 "mime-content-type.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1088 "mime-content-type.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1096 "mime-content-type.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1100 "mime-content-type.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 1106 "mime-content-type.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 1116 "mime-content-type.c"
}

gboolean
geary_mime_content_type_is_mime_type (GearyMimeContentType* self,
                                      const gchar* mime_type,
                                      GError** error)
{
	gint index = 0;
	gchar* mime_media_type = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* mime_media_subtype = NULL;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gboolean _tmp13_ = FALSE;
	const gchar* _tmp14_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 243 "../src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self), FALSE);
#line 243 "../src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (mime_type != NULL, FALSE);
#line 244 "../src/engine/mime/mime-content-type.vala"
	index = string_index_of_char (mime_type, (gunichar) '/', 0);
#line 245 "../src/engine/mime/mime-content-type.vala"
	if (index < 0) {
#line 1149 "mime-content-type.c"
		GError* _tmp0_;
#line 246 "../src/engine/mime/mime-content-type.vala"
		_tmp0_ = g_error_new (GEARY_MIME_ERROR, GEARY_MIME_ERROR_PARSE, "Invalid MIME type: %s", mime_type);
#line 246 "../src/engine/mime/mime-content-type.vala"
		_inner_error0_ = _tmp0_;
#line 246 "../src/engine/mime/mime-content-type.vala"
		if (_inner_error0_->domain == GEARY_MIME_ERROR) {
#line 1157 "mime-content-type.c"
			gboolean _tmp1_ = FALSE;
#line 246 "../src/engine/mime/mime-content-type.vala"
			g_propagate_error (error, _inner_error0_);
#line 246 "../src/engine/mime/mime-content-type.vala"
			return _tmp1_;
#line 1163 "mime-content-type.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 246 "../src/engine/mime/mime-content-type.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 246 "../src/engine/mime/mime-content-type.vala"
			g_clear_error (&_inner_error0_);
#line 246 "../src/engine/mime/mime-content-type.vala"
			return _tmp2_;
#line 1172 "mime-content-type.c"
		}
	}
#line 248 "../src/engine/mime/mime-content-type.vala"
	_tmp3_ = string_substring (mime_type, (glong) 0, (glong) index);
#line 248 "../src/engine/mime/mime-content-type.vala"
	_tmp4_ = _tmp3_;
#line 248 "../src/engine/mime/mime-content-type.vala"
	_tmp5_ = string_strip (_tmp4_);
#line 248 "../src/engine/mime/mime-content-type.vala"
	_tmp6_ = _tmp5_;
#line 248 "../src/engine/mime/mime-content-type.vala"
	_g_free0 (_tmp4_);
#line 248 "../src/engine/mime/mime-content-type.vala"
	mime_media_type = _tmp6_;
#line 250 "../src/engine/mime/mime-content-type.vala"
	_tmp7_ = string_substring (mime_type, (glong) (index + 1), (glong) -1);
#line 250 "../src/engine/mime/mime-content-type.vala"
	mime_media_subtype = _tmp7_;
#line 251 "../src/engine/mime/mime-content-type.vala"
	_tmp8_ = mime_media_subtype;
#line 251 "../src/engine/mime/mime-content-type.vala"
	index = string_index_of_char (_tmp8_, (gunichar) ';', 0);
#line 252 "../src/engine/mime/mime-content-type.vala"
	if (index >= 0) {
#line 1197 "mime-content-type.c"
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 253 "../src/engine/mime/mime-content-type.vala"
		_tmp9_ = mime_media_subtype;
#line 253 "../src/engine/mime/mime-content-type.vala"
		_tmp10_ = string_substring (_tmp9_, (glong) 0, (glong) index);
#line 253 "../src/engine/mime/mime-content-type.vala"
		_g_free0 (mime_media_subtype);
#line 253 "../src/engine/mime/mime-content-type.vala"
		mime_media_subtype = _tmp10_;
#line 1208 "mime-content-type.c"
	}
#line 254 "../src/engine/mime/mime-content-type.vala"
	_tmp11_ = mime_media_subtype;
#line 254 "../src/engine/mime/mime-content-type.vala"
	_tmp12_ = string_strip (_tmp11_);
#line 254 "../src/engine/mime/mime-content-type.vala"
	_g_free0 (mime_media_subtype);
#line 254 "../src/engine/mime/mime-content-type.vala"
	mime_media_subtype = _tmp12_;
#line 256 "../src/engine/mime/mime-content-type.vala"
	_tmp14_ = mime_media_type;
#line 256 "../src/engine/mime/mime-content-type.vala"
	if (geary_string_is_empty (_tmp14_)) {
#line 256 "../src/engine/mime/mime-content-type.vala"
		_tmp13_ = TRUE;
#line 1224 "mime-content-type.c"
	} else {
		const gchar* _tmp15_;
#line 256 "../src/engine/mime/mime-content-type.vala"
		_tmp15_ = mime_media_subtype;
#line 256 "../src/engine/mime/mime-content-type.vala"
		_tmp13_ = geary_string_is_empty (_tmp15_);
#line 1231 "mime-content-type.c"
	}
#line 256 "../src/engine/mime/mime-content-type.vala"
	if (_tmp13_) {
#line 1235 "mime-content-type.c"
		GError* _tmp16_;
#line 257 "../src/engine/mime/mime-content-type.vala"
		_tmp16_ = g_error_new (GEARY_MIME_ERROR, GEARY_MIME_ERROR_PARSE, "Invalid MIME type: %s", mime_type);
#line 257 "../src/engine/mime/mime-content-type.vala"
		_inner_error0_ = _tmp16_;
#line 257 "../src/engine/mime/mime-content-type.vala"
		if (_inner_error0_->domain == GEARY_MIME_ERROR) {
#line 1243 "mime-content-type.c"
			gboolean _tmp17_ = FALSE;
#line 257 "../src/engine/mime/mime-content-type.vala"
			g_propagate_error (error, _inner_error0_);
#line 257 "../src/engine/mime/mime-content-type.vala"
			_g_free0 (mime_media_subtype);
#line 257 "../src/engine/mime/mime-content-type.vala"
			_g_free0 (mime_media_type);
#line 257 "../src/engine/mime/mime-content-type.vala"
			return _tmp17_;
#line 1253 "mime-content-type.c"
		} else {
			gboolean _tmp18_ = FALSE;
#line 257 "../src/engine/mime/mime-content-type.vala"
			_g_free0 (mime_media_subtype);
#line 257 "../src/engine/mime/mime-content-type.vala"
			_g_free0 (mime_media_type);
#line 257 "../src/engine/mime/mime-content-type.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 257 "../src/engine/mime/mime-content-type.vala"
			g_clear_error (&_inner_error0_);
#line 257 "../src/engine/mime/mime-content-type.vala"
			return _tmp18_;
#line 1266 "mime-content-type.c"
		}
	}
#line 259 "../src/engine/mime/mime-content-type.vala"
	_tmp19_ = mime_media_type;
#line 259 "../src/engine/mime/mime-content-type.vala"
	_tmp20_ = mime_media_subtype;
#line 259 "../src/engine/mime/mime-content-type.vala"
	result = geary_mime_content_type_is_type (self, _tmp19_, _tmp20_);
#line 259 "../src/engine/mime/mime-content-type.vala"
	_g_free0 (mime_media_subtype);
#line 259 "../src/engine/mime/mime-content-type.vala"
	_g_free0 (mime_media_type);
#line 259 "../src/engine/mime/mime-content-type.vala"
	return result;
#line 1281 "mime-content-type.c"
}

gchar*
geary_mime_content_type_serialize (GearyMimeContentType* self)
{
	GString* builder = NULL;
	GString* _tmp0_;
	GString* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GearyMimeContentParameters* _tmp5_;
	GString* _tmp30_;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* result;
#line 262 "../src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self), NULL);
#line 263 "../src/engine/mime/mime-content-type.vala"
	_tmp0_ = g_string_new ("");
#line 263 "../src/engine/mime/mime-content-type.vala"
	builder = _tmp0_;
#line 264 "../src/engine/mime/mime-content-type.vala"
	_tmp1_ = builder;
#line 264 "../src/engine/mime/mime-content-type.vala"
	_tmp2_ = self->priv->_media_type;
#line 264 "../src/engine/mime/mime-content-type.vala"
	_tmp3_ = self->priv->_media_subtype;
#line 264 "../src/engine/mime/mime-content-type.vala"
	g_string_append_printf (_tmp1_, "%s/%s", _tmp2_, _tmp3_);
#line 266 "../src/engine/mime/mime-content-type.vala"
	_tmp5_ = self->priv->_params;
#line 266 "../src/engine/mime/mime-content-type.vala"
	if (_tmp5_ != NULL) {
#line 1316 "mime-content-type.c"
		GearyMimeContentParameters* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 266 "../src/engine/mime/mime-content-type.vala"
		_tmp6_ = self->priv->_params;
#line 266 "../src/engine/mime/mime-content-type.vala"
		_tmp7_ = geary_mime_content_parameters_get_size (_tmp6_);
#line 266 "../src/engine/mime/mime-content-type.vala"
		_tmp8_ = _tmp7_;
#line 266 "../src/engine/mime/mime-content-type.vala"
		_tmp4_ = _tmp8_ > 0;
#line 1328 "mime-content-type.c"
	} else {
#line 266 "../src/engine/mime/mime-content-type.vala"
		_tmp4_ = FALSE;
#line 1332 "mime-content-type.c"
	}
#line 266 "../src/engine/mime/mime-content-type.vala"
	if (_tmp4_) {
#line 1336 "mime-content-type.c"
		{
			GeeIterator* _attribute_it = NULL;
			GearyMimeContentParameters* _tmp9_;
			GeeCollection* _tmp10_;
			GeeCollection* _tmp11_;
			GeeCollection* _tmp12_;
			GeeIterator* _tmp13_;
			GeeIterator* _tmp14_;
#line 267 "../src/engine/mime/mime-content-type.vala"
			_tmp9_ = self->priv->_params;
#line 267 "../src/engine/mime/mime-content-type.vala"
			_tmp10_ = geary_mime_content_parameters_get_attributes (_tmp9_);
#line 267 "../src/engine/mime/mime-content-type.vala"
			_tmp11_ = _tmp10_;
#line 267 "../src/engine/mime/mime-content-type.vala"
			_tmp12_ = _tmp11_;
#line 267 "../src/engine/mime/mime-content-type.vala"
			_tmp13_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ITERABLE, GeeIterable));
#line 267 "../src/engine/mime/mime-content-type.vala"
			_tmp14_ = _tmp13_;
#line 267 "../src/engine/mime/mime-content-type.vala"
			_g_object_unref0 (_tmp12_);
#line 267 "../src/engine/mime/mime-content-type.vala"
			_attribute_it = _tmp14_;
#line 267 "../src/engine/mime/mime-content-type.vala"
			while (TRUE) {
#line 1363 "mime-content-type.c"
				GeeIterator* _tmp15_;
				gchar* attribute = NULL;
				GeeIterator* _tmp16_;
				gpointer _tmp17_;
				gchar* value = NULL;
				GearyMimeContentParameters* _tmp18_;
				const gchar* _tmp19_;
				gchar* _tmp20_;
				const gchar* _tmp21_;
#line 267 "../src/engine/mime/mime-content-type.vala"
				_tmp15_ = _attribute_it;
#line 267 "../src/engine/mime/mime-content-type.vala"
				if (!gee_iterator_next (_tmp15_)) {
#line 267 "../src/engine/mime/mime-content-type.vala"
					break;
#line 1379 "mime-content-type.c"
				}
#line 267 "../src/engine/mime/mime-content-type.vala"
				_tmp16_ = _attribute_it;
#line 267 "../src/engine/mime/mime-content-type.vala"
				_tmp17_ = gee_iterator_get (_tmp16_);
#line 267 "../src/engine/mime/mime-content-type.vala"
				attribute = (gchar*) _tmp17_;
#line 268 "../src/engine/mime/mime-content-type.vala"
				_tmp18_ = self->priv->_params;
#line 268 "../src/engine/mime/mime-content-type.vala"
				_tmp19_ = attribute;
#line 268 "../src/engine/mime/mime-content-type.vala"
				_tmp20_ = geary_mime_content_parameters_get_value (_tmp18_, _tmp19_);
#line 268 "../src/engine/mime/mime-content-type.vala"
				value = _tmp20_;
#line 270 "../src/engine/mime/mime-content-type.vala"
				_tmp21_ = value;
#line 270 "../src/engine/mime/mime-content-type.vala"
				switch (geary_mime_data_format_get_encoding_requirement (_tmp21_)) {
#line 270 "../src/engine/mime/mime-content-type.vala"
					case GEARY_MIME_DATA_FORMAT_ENCODING_QUOTING_OPTIONAL:
#line 1401 "mime-content-type.c"
					{
						GString* _tmp22_;
						const gchar* _tmp23_;
						const gchar* _tmp24_;
#line 272 "../src/engine/mime/mime-content-type.vala"
						_tmp22_ = builder;
#line 272 "../src/engine/mime/mime-content-type.vala"
						_tmp23_ = attribute;
#line 272 "../src/engine/mime/mime-content-type.vala"
						_tmp24_ = value;
#line 272 "../src/engine/mime/mime-content-type.vala"
						g_string_append_printf (_tmp22_, "; %s=%s", _tmp23_, _tmp24_);
#line 273 "../src/engine/mime/mime-content-type.vala"
						break;
#line 1416 "mime-content-type.c"
					}
#line 270 "../src/engine/mime/mime-content-type.vala"
					case GEARY_MIME_DATA_FORMAT_ENCODING_QUOTING_REQUIRED:
#line 1420 "mime-content-type.c"
					{
						GString* _tmp25_;
						const gchar* _tmp26_;
						const gchar* _tmp27_;
#line 276 "../src/engine/mime/mime-content-type.vala"
						_tmp25_ = builder;
#line 276 "../src/engine/mime/mime-content-type.vala"
						_tmp26_ = attribute;
#line 276 "../src/engine/mime/mime-content-type.vala"
						_tmp27_ = value;
#line 276 "../src/engine/mime/mime-content-type.vala"
						g_string_append_printf (_tmp25_, "; %s=\"%s\"", _tmp26_, _tmp27_);
#line 277 "../src/engine/mime/mime-content-type.vala"
						break;
#line 1435 "mime-content-type.c"
					}
#line 270 "../src/engine/mime/mime-content-type.vala"
					case GEARY_MIME_DATA_FORMAT_ENCODING_UNALLOWED:
#line 1439 "mime-content-type.c"
					{
						const gchar* _tmp28_;
						const gchar* _tmp29_;
#line 280 "../src/engine/mime/mime-content-type.vala"
						_tmp28_ = attribute;
#line 280 "../src/engine/mime/mime-content-type.vala"
						_tmp29_ = value;
#line 280 "../src/engine/mime/mime-content-type.vala"
						g_message ("mime-content-type.vala:280: Cannot encode ContentType param value %s=\"" \
"%s\": unallowed", _tmp28_, _tmp29_);
#line 282 "../src/engine/mime/mime-content-type.vala"
						break;
#line 1451 "mime-content-type.c"
					}
					default:
					{
#line 285 "../src/engine/mime/mime-content-type.vala"
						g_assert_not_reached ();
#line 1457 "mime-content-type.c"
					}
				}
#line 267 "../src/engine/mime/mime-content-type.vala"
				_g_free0 (value);
#line 267 "../src/engine/mime/mime-content-type.vala"
				_g_free0 (attribute);
#line 1464 "mime-content-type.c"
			}
#line 267 "../src/engine/mime/mime-content-type.vala"
			_g_object_unref0 (_attribute_it);
#line 1468 "mime-content-type.c"
		}
	}
#line 290 "../src/engine/mime/mime-content-type.vala"
	_tmp30_ = builder;
#line 290 "../src/engine/mime/mime-content-type.vala"
	_tmp31_ = _tmp30_->str;
#line 290 "../src/engine/mime/mime-content-type.vala"
	_tmp32_ = g_strdup (_tmp31_);
#line 290 "../src/engine/mime/mime-content-type.vala"
	result = _tmp32_;
#line 290 "../src/engine/mime/mime-content-type.vala"
	_g_string_free0 (builder);
#line 290 "../src/engine/mime/mime-content-type.vala"
	return result;
#line 1483 "mime-content-type.c"
}

gchar*
geary_mime_content_type_to_string (GearyMimeContentType* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 293 "../src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self), NULL);
#line 294 "../src/engine/mime/mime-content-type.vala"
	_tmp0_ = geary_mime_content_type_serialize (self);
#line 294 "../src/engine/mime/mime-content-type.vala"
	result = _tmp0_;
#line 294 "../src/engine/mime/mime-content-type.vala"
	return result;
#line 1499 "mime-content-type.c"
}

static void
geary_mime_content_type_class_init (GearyMimeContentTypeClass * klass,
                                    gpointer klass_data)
{
	GeeHashMap* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	GearyMimeContentParameters* _tmp5_;
	GearyMimeContentParameters* _tmp6_;
	GearyMimeContentType* _tmp7_;
	GearyMimeContentType* _tmp8_;
	GeeMap* _tmp9_;
	GeeMap* _tmp10_;
	GeeMap* _tmp11_;
	GeeMap* _tmp12_;
	GeeMap* _tmp13_;
	GeeMap* _tmp14_;
#line 14 "../src/engine/mime/mime-content-type.vala"
	geary_mime_content_type_parent_class = g_type_class_peek_parent (klass);
#line 14 "../src/engine/mime/mime-content-type.vala"
	g_type_class_adjust_private_offset (klass, &GearyMimeContentType_private_offset);
#line 14 "../src/engine/mime/mime-content-type.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_mime_content_type_get_property;
#line 14 "../src/engine/mime/mime-content-type.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_mime_content_type_set_property;
#line 14 "../src/engine/mime/mime-content-type.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_mime_content_type_finalize;
#line 1533 "mime-content-type.c"
	/**
	     * The type (discrete or concrete) portion of the Content-Type field.
	     *
	     * It's highly recommended the caller use the various ''has'' and ''is'' methods when performing
	     * comparisons rather than direct string operations.
	     *
	     * media_type may be {@link WILDCARD}, in which case it matches with any other media_type.
	     *
	     * @see has_media_type
	     */
#line 14 "../src/engine/mime/mime-content-type.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_MIME_CONTENT_TYPE_MEDIA_TYPE_PROPERTY, geary_mime_content_type_properties[GEARY_MIME_CONTENT_TYPE_MEDIA_TYPE_PROPERTY] = g_param_spec_string ("media-type", "media-type", "media-type", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1546 "mime-content-type.c"
	/**
	     * The subtype (extension-token or iana-token) portion of the Content-Type field.
	     *
	     * It's highly recommended the caller use the various ''has'' and ''is'' methods when performing
	     * comparisons rather than direct string operations.
	     *
	     * media_subtype may be {@link WILDCARD}, in which case it matches with any other media_subtype.
	     *
	     * @see has_media_subtype
	     */
#line 14 "../src/engine/mime/mime-content-type.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_MIME_CONTENT_TYPE_MEDIA_SUBTYPE_PROPERTY, geary_mime_content_type_properties[GEARY_MIME_CONTENT_TYPE_MEDIA_SUBTYPE_PROPERTY] = g_param_spec_string ("media-subtype", "media-subtype", "media-subtype", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1559 "mime-content-type.c"
	/**
	     * Content parameters, if any, in the Content-Type field.
	     *
	     * This is never null.  Rather, an empty ContentParameters is held if the Content-Type has
	     * no parameters.
	     */
#line 14 "../src/engine/mime/mime-content-type.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_MIME_CONTENT_TYPE_PARAMS_PROPERTY, geary_mime_content_type_properties[GEARY_MIME_CONTENT_TYPE_PARAMS_PROPERTY] = g_param_spec_object ("params", "params", "params", GEARY_MIME_TYPE_CONTENT_PARAMETERS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 40 "../src/engine/mime/mime-content-type.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 40 "../src/engine/mime/mime-content-type.vala"
	geary_mime_content_type_TYPES_TO_EXTENSIONS = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_MAP, GeeMap);
#line 44 "../src/engine/mime/mime-content-type.vala"
	_tmp1_ = g_strdup ("charset");
#line 44 "../src/engine/mime/mime-content-type.vala"
	_tmp2_ = g_strdup ("us-ascii");
#line 44 "../src/engine/mime/mime-content-type.vala"
	_tmp3_ = g_new0 (gchar*, (1 * 2) + 1);
#line 44 "../src/engine/mime/mime-content-type.vala"
	_tmp3_[0] = _tmp1_;
#line 44 "../src/engine/mime/mime-content-type.vala"
	_tmp3_[1] = _tmp2_;
#line 44 "../src/engine/mime/mime-content-type.vala"
	_tmp4_ = _tmp3_;
#line 44 "../src/engine/mime/mime-content-type.vala"
	_tmp4__length1 = 1;
#line 44 "../src/engine/mime/mime-content-type.vala"
	_tmp4__length2 = 2;
#line 44 "../src/engine/mime/mime-content-type.vala"
	_tmp5_ = geary_mime_content_parameters_new_from_array (_tmp4_, 1, 2);
#line 44 "../src/engine/mime/mime-content-type.vala"
	_tmp6_ = _tmp5_;
#line 44 "../src/engine/mime/mime-content-type.vala"
	_tmp7_ = geary_mime_content_type_new ("text", "plain", _tmp6_);
#line 44 "../src/engine/mime/mime-content-type.vala"
	_g_object_unref0 (geary_mime_content_type_DISPLAY_DEFAULT);
#line 44 "../src/engine/mime/mime-content-type.vala"
	geary_mime_content_type_DISPLAY_DEFAULT = _tmp7_;
#line 44 "../src/engine/mime/mime-content-type.vala"
	_g_object_unref0 (_tmp6_);
#line 44 "../src/engine/mime/mime-content-type.vala"
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1 * _tmp4__length2, (GDestroyNotify) g_free), NULL);
#line 48 "../src/engine/mime/mime-content-type.vala"
	_tmp8_ = geary_mime_content_type_new ("application", "octet-stream", NULL);
#line 48 "../src/engine/mime/mime-content-type.vala"
	_g_object_unref0 (geary_mime_content_type_ATTACHMENT_DEFAULT);
#line 48 "../src/engine/mime/mime-content-type.vala"
	geary_mime_content_type_ATTACHMENT_DEFAULT = _tmp8_;
#line 60 "../src/engine/mime/mime-content-type.vala"
	_tmp9_ = geary_mime_content_type_TYPES_TO_EXTENSIONS;
#line 60 "../src/engine/mime/mime-content-type.vala"
	gee_map_set (_tmp9_, "image/jpeg", ".jpeg");
#line 61 "../src/engine/mime/mime-content-type.vala"
	_tmp10_ = geary_mime_content_type_TYPES_TO_EXTENSIONS;
#line 61 "../src/engine/mime/mime-content-type.vala"
	gee_map_set (_tmp10_, "image/png", ".png");
#line 62 "../src/engine/mime/mime-content-type.vala"
	_tmp11_ = geary_mime_content_type_TYPES_TO_EXTENSIONS;
#line 62 "../src/engine/mime/mime-content-type.vala"
	gee_map_set (_tmp11_, "image/gif", ".gif");
#line 63 "../src/engine/mime/mime-content-type.vala"
	_tmp12_ = geary_mime_content_type_TYPES_TO_EXTENSIONS;
#line 63 "../src/engine/mime/mime-content-type.vala"
	gee_map_set (_tmp12_, "image/svg+xml", ".svg");
#line 64 "../src/engine/mime/mime-content-type.vala"
	_tmp13_ = geary_mime_content_type_TYPES_TO_EXTENSIONS;
#line 64 "../src/engine/mime/mime-content-type.vala"
	gee_map_set (_tmp13_, "image/bmp", ".bmp");
#line 65 "../src/engine/mime/mime-content-type.vala"
	_tmp14_ = geary_mime_content_type_TYPES_TO_EXTENSIONS;
#line 65 "../src/engine/mime/mime-content-type.vala"
	gee_map_set (_tmp14_, "image/x-bmp", ".bmp");
#line 1632 "mime-content-type.c"
}

static void
geary_mime_content_type_instance_init (GearyMimeContentType * self,
                                       gpointer klass)
{
#line 14 "../src/engine/mime/mime-content-type.vala"
	self->priv = geary_mime_content_type_get_instance_private (self);
#line 1641 "mime-content-type.c"
}

static void
geary_mime_content_type_finalize (GObject * obj)
{
	GearyMimeContentType * self;
#line 14 "../src/engine/mime/mime-content-type.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_MIME_TYPE_CONTENT_TYPE, GearyMimeContentType);
#line 134 "../src/engine/mime/mime-content-type.vala"
	_g_free0 (self->priv->_media_type);
#line 146 "../src/engine/mime/mime-content-type.vala"
	_g_free0 (self->priv->_media_subtype);
#line 154 "../src/engine/mime/mime-content-type.vala"
	_g_object_unref0 (self->priv->_params);
#line 14 "../src/engine/mime/mime-content-type.vala"
	G_OBJECT_CLASS (geary_mime_content_type_parent_class)->finalize (obj);
#line 1658 "mime-content-type.c"
}

/**
 * A representation of an RFC 2045 MIME Content-Type field.
 *
 * See [[https://tools.ietf.org/html/rfc2045#section-5]]
 *
 * This class is immutable.
 */
 G_GNUC_NO_INLINE static GType
geary_mime_content_type_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyMimeContentTypeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_mime_content_type_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyMimeContentType), 0, (GInstanceInitFunc) geary_mime_content_type_instance_init, NULL };
	GType geary_mime_content_type_type_id;
	geary_mime_content_type_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyMimeContentType", &g_define_type_info, 0);
	GearyMimeContentType_private_offset = g_type_add_instance_private (geary_mime_content_type_type_id, sizeof (GearyMimeContentTypePrivate));
	return geary_mime_content_type_type_id;
}

GType
geary_mime_content_type_get_type (void)
{
	static gsize geary_mime_content_type_type_id__once = 0;
	if (g_once_init_enter (&geary_mime_content_type_type_id__once)) {
		GType geary_mime_content_type_type_id;
		geary_mime_content_type_type_id = geary_mime_content_type_get_type_once ();
		g_once_init_leave (&geary_mime_content_type_type_id__once, geary_mime_content_type_type_id);
	}
	return geary_mime_content_type_type_id__once;
}

static void
_vala_geary_mime_content_type_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	GearyMimeContentType * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_MIME_TYPE_CONTENT_TYPE, GearyMimeContentType);
#line 14 "../src/engine/mime/mime-content-type.vala"
	switch (property_id) {
#line 14 "../src/engine/mime/mime-content-type.vala"
		case GEARY_MIME_CONTENT_TYPE_MEDIA_TYPE_PROPERTY:
#line 14 "../src/engine/mime/mime-content-type.vala"
		g_value_set_string (value, geary_mime_content_type_get_media_type (self));
#line 14 "../src/engine/mime/mime-content-type.vala"
		break;
#line 14 "../src/engine/mime/mime-content-type.vala"
		case GEARY_MIME_CONTENT_TYPE_MEDIA_SUBTYPE_PROPERTY:
#line 14 "../src/engine/mime/mime-content-type.vala"
		g_value_set_string (value, geary_mime_content_type_get_media_subtype (self));
#line 14 "../src/engine/mime/mime-content-type.vala"
		break;
#line 14 "../src/engine/mime/mime-content-type.vala"
		case GEARY_MIME_CONTENT_TYPE_PARAMS_PROPERTY:
#line 14 "../src/engine/mime/mime-content-type.vala"
		g_value_set_object (value, geary_mime_content_type_get_params (self));
#line 14 "../src/engine/mime/mime-content-type.vala"
		break;
#line 1718 "mime-content-type.c"
		default:
#line 14 "../src/engine/mime/mime-content-type.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/engine/mime/mime-content-type.vala"
		break;
#line 1724 "mime-content-type.c"
	}
}

static void
_vala_geary_mime_content_type_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	GearyMimeContentType * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_MIME_TYPE_CONTENT_TYPE, GearyMimeContentType);
#line 14 "../src/engine/mime/mime-content-type.vala"
	switch (property_id) {
#line 14 "../src/engine/mime/mime-content-type.vala"
		case GEARY_MIME_CONTENT_TYPE_MEDIA_TYPE_PROPERTY:
#line 14 "../src/engine/mime/mime-content-type.vala"
		geary_mime_content_type_set_media_type (self, g_value_get_string (value));
#line 14 "../src/engine/mime/mime-content-type.vala"
		break;
#line 14 "../src/engine/mime/mime-content-type.vala"
		case GEARY_MIME_CONTENT_TYPE_MEDIA_SUBTYPE_PROPERTY:
#line 14 "../src/engine/mime/mime-content-type.vala"
		geary_mime_content_type_set_media_subtype (self, g_value_get_string (value));
#line 14 "../src/engine/mime/mime-content-type.vala"
		break;
#line 14 "../src/engine/mime/mime-content-type.vala"
		case GEARY_MIME_CONTENT_TYPE_PARAMS_PROPERTY:
#line 14 "../src/engine/mime/mime-content-type.vala"
		geary_mime_content_type_set_params (self, g_value_get_object (value));
#line 14 "../src/engine/mime/mime-content-type.vala"
		break;
#line 1756 "mime-content-type.c"
		default:
#line 14 "../src/engine/mime/mime-content-type.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/engine/mime/mime-content-type.vala"
		break;
#line 1762 "mime-content-type.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

