/* mime-data-format.c generated by valac 0.56.17, the Vala compiler
 * generated from mime-data-format.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib.h>
#include "geary-engine.h"
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

static gboolean _vala_char_array_contains (gchar * stack,
                                    gssize stack_length,
                                    const gchar needle);

const gchar GEARY_MIME_DATA_FORMAT_CONTENT_TYPE_TOKEN_SPECIALS[15] = {'(', ')', '<', '>', '@', ',', ';', ':', '\\', '"', '/', '[', ']', '?', '='};

 G_GNUC_NO_INLINE static GType
geary_mime_data_format_encoding_get_type_once (void)
{
	static const GEnumValue values[] = {{GEARY_MIME_DATA_FORMAT_ENCODING_QUOTING_REQUIRED, "GEARY_MIME_DATA_FORMAT_ENCODING_QUOTING_REQUIRED", "quoting-required"}, {GEARY_MIME_DATA_FORMAT_ENCODING_QUOTING_OPTIONAL, "GEARY_MIME_DATA_FORMAT_ENCODING_QUOTING_OPTIONAL", "quoting-optional"}, {GEARY_MIME_DATA_FORMAT_ENCODING_UNALLOWED, "GEARY_MIME_DATA_FORMAT_ENCODING_UNALLOWED", "unallowed"}, {0, NULL, NULL}};
	GType geary_mime_data_format_encoding_type_id;
	geary_mime_data_format_encoding_type_id = g_enum_register_static ("GearyMimeDataFormatEncoding", values);
	return geary_mime_data_format_encoding_type_id;
}

GType
geary_mime_data_format_encoding_get_type (void)
{
	static gsize geary_mime_data_format_encoding_type_id__once = 0;
	if (g_once_init_enter (&geary_mime_data_format_encoding_type_id__once)) {
		GType geary_mime_data_format_encoding_type_id;
		geary_mime_data_format_encoding_type_id = geary_mime_data_format_encoding_get_type_once ();
		g_once_init_leave (&geary_mime_data_format_encoding_type_id__once, geary_mime_data_format_encoding_type_id);
	}
	return geary_mime_data_format_encoding_type_id__once;
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 66 "mime-data-format.c"
}

static gboolean
_vala_char_array_contains (gchar * stack,
                           gssize stack_length,
                           const gchar needle)
{
	gssize i;
#line 38 "../src/engine/mime/mime-data-format.vala"
	for (i = 0; i < stack_length; i++) {
#line 38 "../src/engine/mime/mime-data-format.vala"
		if (needle == stack[i]) {
#line 38 "../src/engine/mime/mime-data-format.vala"
			return TRUE;
#line 81 "mime-data-format.c"
		}
	}
#line 38 "../src/engine/mime/mime-data-format.vala"
	return FALSE;
#line 86 "mime-data-format.c"
}

GearyMimeDataFormatEncoding
geary_mime_data_format_get_encoding_requirement (const gchar* str)
{
	GearyMimeDataFormatEncoding encoding = 0;
	gint index = 0;
	GearyMimeDataFormatEncoding result;
#line 23 "../src/engine/mime/mime-data-format.vala"
	g_return_val_if_fail (str != NULL, 0);
#line 24 "../src/engine/mime/mime-data-format.vala"
	if (geary_string_is_empty (str)) {
#line 25 "../src/engine/mime/mime-data-format.vala"
		result = GEARY_MIME_DATA_FORMAT_ENCODING_QUOTING_REQUIRED;
#line 25 "../src/engine/mime/mime-data-format.vala"
		return result;
#line 103 "mime-data-format.c"
	}
#line 27 "../src/engine/mime/mime-data-format.vala"
	encoding = GEARY_MIME_DATA_FORMAT_ENCODING_QUOTING_OPTIONAL;
#line 28 "../src/engine/mime/mime-data-format.vala"
	index = 0;
#line 109 "mime-data-format.c"
	{
		gboolean _tmp0_ = FALSE;
#line 29 "../src/engine/mime/mime-data-format.vala"
		_tmp0_ = TRUE;
#line 29 "../src/engine/mime/mime-data-format.vala"
		while (TRUE) {
#line 116 "mime-data-format.c"
			gchar ch = '\0';
			gint _tmp1_;
			gboolean _tmp2_ = FALSE;
#line 29 "../src/engine/mime/mime-data-format.vala"
			if (!_tmp0_) {
#line 122 "mime-data-format.c"
			}
#line 29 "../src/engine/mime/mime-data-format.vala"
			_tmp0_ = FALSE;
#line 30 "../src/engine/mime/mime-data-format.vala"
			_tmp1_ = index;
#line 30 "../src/engine/mime/mime-data-format.vala"
			index = _tmp1_ + 1;
#line 30 "../src/engine/mime/mime-data-format.vala"
			ch = string_get (str, (glong) _tmp1_);
#line 31 "../src/engine/mime/mime-data-format.vala"
			if (ch == GEARY_STRING_EOS) {
#line 32 "../src/engine/mime/mime-data-format.vala"
				break;
#line 136 "mime-data-format.c"
			}
#line 34 "../src/engine/mime/mime-data-format.vala"
			if (g_ascii_iscntrl (ch)) {
#line 35 "../src/engine/mime/mime-data-format.vala"
				result = GEARY_MIME_DATA_FORMAT_ENCODING_UNALLOWED;
#line 35 "../src/engine/mime/mime-data-format.vala"
				return result;
#line 144 "mime-data-format.c"
			}
#line 38 "../src/engine/mime/mime-data-format.vala"
			if (g_ascii_isspace (ch)) {
#line 38 "../src/engine/mime/mime-data-format.vala"
				_tmp2_ = TRUE;
#line 150 "mime-data-format.c"
			} else {
#line 38 "../src/engine/mime/mime-data-format.vala"
				_tmp2_ = _vala_char_array_contains (GEARY_MIME_DATA_FORMAT_CONTENT_TYPE_TOKEN_SPECIALS, G_N_ELEMENTS (GEARY_MIME_DATA_FORMAT_CONTENT_TYPE_TOKEN_SPECIALS), ch);
#line 154 "mime-data-format.c"
			}
#line 38 "../src/engine/mime/mime-data-format.vala"
			if (_tmp2_) {
#line 39 "../src/engine/mime/mime-data-format.vala"
				encoding = GEARY_MIME_DATA_FORMAT_ENCODING_QUOTING_REQUIRED;
#line 160 "mime-data-format.c"
			}
		}
	}
#line 42 "../src/engine/mime/mime-data-format.vala"
	result = encoding;
#line 42 "../src/engine/mime/mime-data-format.vala"
	return result;
#line 168 "mime-data-format.c"
}

