/* mime-multipart-subtype.c generated by valac 0.56.17, the Vala compiler
 * generated from mime-multipart-subtype.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

/**
 * A representation of a MIME multipart Content-Type subtype.
 *
 * See [[https://tools.ietf.org/html/rfc2046#section-5.1]]
 */
/**
     * Converts a {@link ContentType} into a {@link MultipartSubtype}.
     *
     * If unknown, {@link MIXED} is returned but is_unknown will be true.
     */
GearyMimeMultipartSubtype
geary_mime_multipart_subtype_from_content_type (GearyMimeContentType* content_type,
                                                gboolean* is_unknown)
{
	gboolean _vala_is_unknown = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GQuark _tmp6_ = 0U;
#line 56 "../src/engine/mime/mime-multipart-subtype.vala"
	static GQuark _tmp5_label0 = 0;
#line 56 "../src/engine/mime/mime-multipart-subtype.vala"
	static GQuark _tmp5_label1 = 0;
#line 56 "../src/engine/mime/mime-multipart-subtype.vala"
	static GQuark _tmp5_label2 = 0;
#line 52 "mime-multipart-subtype.c"
	GearyMimeMultipartSubtype result;
#line 48 "../src/engine/mime/mime-multipart-subtype.vala"
	g_return_val_if_fail ((content_type == NULL) || GEARY_MIME_IS_CONTENT_TYPE (content_type), 0);
#line 49 "../src/engine/mime/mime-multipart-subtype.vala"
	if (content_type == NULL) {
#line 49 "../src/engine/mime/mime-multipart-subtype.vala"
		_tmp0_ = TRUE;
#line 60 "mime-multipart-subtype.c"
	} else {
#line 49 "../src/engine/mime/mime-multipart-subtype.vala"
		_tmp0_ = !geary_mime_content_type_has_media_type (content_type, "multipart");
#line 64 "mime-multipart-subtype.c"
	}
#line 49 "../src/engine/mime/mime-multipart-subtype.vala"
	if (_tmp0_) {
#line 50 "../src/engine/mime/mime-multipart-subtype.vala"
		_vala_is_unknown = TRUE;
#line 52 "../src/engine/mime/mime-multipart-subtype.vala"
		result = GEARY_MIME_MULTIPART_SUBTYPE_MIXED;
#line 52 "../src/engine/mime/mime-multipart-subtype.vala"
		if (is_unknown) {
#line 52 "../src/engine/mime/mime-multipart-subtype.vala"
			*is_unknown = _vala_is_unknown;
#line 76 "mime-multipart-subtype.c"
		}
#line 52 "../src/engine/mime/mime-multipart-subtype.vala"
		return result;
#line 80 "mime-multipart-subtype.c"
	}
#line 55 "../src/engine/mime/mime-multipart-subtype.vala"
	_vala_is_unknown = FALSE;
#line 56 "../src/engine/mime/mime-multipart-subtype.vala"
	_tmp1_ = geary_mime_content_type_get_media_subtype (content_type);
#line 56 "../src/engine/mime/mime-multipart-subtype.vala"
	_tmp2_ = _tmp1_;
#line 56 "../src/engine/mime/mime-multipart-subtype.vala"
	_tmp3_ = geary_ascii_strdown (_tmp2_);
#line 56 "../src/engine/mime/mime-multipart-subtype.vala"
	_tmp4_ = _tmp3_;
#line 56 "../src/engine/mime/mime-multipart-subtype.vala"
	_tmp6_ = (NULL == _tmp4_) ? 0 : g_quark_from_string (_tmp4_);
#line 56 "../src/engine/mime/mime-multipart-subtype.vala"
	g_free (_tmp4_);
#line 56 "../src/engine/mime/mime-multipart-subtype.vala"
	if (_tmp6_ == ((0 != _tmp5_label0) ? _tmp5_label0 : (_tmp5_label0 = g_quark_from_static_string ("mixed")))) {
#line 56 "../src/engine/mime/mime-multipart-subtype.vala"
		switch (0) {
#line 100 "mime-multipart-subtype.c"
			default:
			{
#line 58 "../src/engine/mime/mime-multipart-subtype.vala"
				result = GEARY_MIME_MULTIPART_SUBTYPE_MIXED;
#line 58 "../src/engine/mime/mime-multipart-subtype.vala"
				if (is_unknown) {
#line 58 "../src/engine/mime/mime-multipart-subtype.vala"
					*is_unknown = _vala_is_unknown;
#line 109 "mime-multipart-subtype.c"
				}
#line 58 "../src/engine/mime/mime-multipart-subtype.vala"
				return result;
#line 113 "mime-multipart-subtype.c"
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label1) ? _tmp5_label1 : (_tmp5_label1 = g_quark_from_static_string ("alternative")))) {
#line 56 "../src/engine/mime/mime-multipart-subtype.vala"
		switch (0) {
#line 119 "mime-multipart-subtype.c"
			default:
			{
#line 61 "../src/engine/mime/mime-multipart-subtype.vala"
				result = GEARY_MIME_MULTIPART_SUBTYPE_ALTERNATIVE;
#line 61 "../src/engine/mime/mime-multipart-subtype.vala"
				if (is_unknown) {
#line 61 "../src/engine/mime/mime-multipart-subtype.vala"
					*is_unknown = _vala_is_unknown;
#line 128 "mime-multipart-subtype.c"
				}
#line 61 "../src/engine/mime/mime-multipart-subtype.vala"
				return result;
#line 132 "mime-multipart-subtype.c"
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label2) ? _tmp5_label2 : (_tmp5_label2 = g_quark_from_static_string ("related")))) {
#line 56 "../src/engine/mime/mime-multipart-subtype.vala"
		switch (0) {
#line 138 "mime-multipart-subtype.c"
			default:
			{
#line 64 "../src/engine/mime/mime-multipart-subtype.vala"
				result = GEARY_MIME_MULTIPART_SUBTYPE_RELATED;
#line 64 "../src/engine/mime/mime-multipart-subtype.vala"
				if (is_unknown) {
#line 64 "../src/engine/mime/mime-multipart-subtype.vala"
					*is_unknown = _vala_is_unknown;
#line 147 "mime-multipart-subtype.c"
				}
#line 64 "../src/engine/mime/mime-multipart-subtype.vala"
				return result;
#line 151 "mime-multipart-subtype.c"
			}
		}
	} else {
#line 56 "../src/engine/mime/mime-multipart-subtype.vala"
		switch (0) {
#line 157 "mime-multipart-subtype.c"
			default:
			{
#line 67 "../src/engine/mime/mime-multipart-subtype.vala"
				_vala_is_unknown = TRUE;
#line 69 "../src/engine/mime/mime-multipart-subtype.vala"
				result = GEARY_MIME_MULTIPART_SUBTYPE_MIXED;
#line 69 "../src/engine/mime/mime-multipart-subtype.vala"
				if (is_unknown) {
#line 69 "../src/engine/mime/mime-multipart-subtype.vala"
					*is_unknown = _vala_is_unknown;
#line 168 "mime-multipart-subtype.c"
				}
#line 69 "../src/engine/mime/mime-multipart-subtype.vala"
				return result;
#line 172 "mime-multipart-subtype.c"
			}
		}
	}
}

 G_GNUC_NO_INLINE static GType
geary_mime_multipart_subtype_get_type_once (void)
{
	static const GEnumValue values[] = {{GEARY_MIME_MULTIPART_SUBTYPE_UNSPECIFIED, "GEARY_MIME_MULTIPART_SUBTYPE_UNSPECIFIED", "unspecified"}, {GEARY_MIME_MULTIPART_SUBTYPE_MIXED, "GEARY_MIME_MULTIPART_SUBTYPE_MIXED", "mixed"}, {GEARY_MIME_MULTIPART_SUBTYPE_ALTERNATIVE, "GEARY_MIME_MULTIPART_SUBTYPE_ALTERNATIVE", "alternative"}, {GEARY_MIME_MULTIPART_SUBTYPE_RELATED, "GEARY_MIME_MULTIPART_SUBTYPE_RELATED", "related"}, {0, NULL, NULL}};
	GType geary_mime_multipart_subtype_type_id;
	geary_mime_multipart_subtype_type_id = g_enum_register_static ("GearyMimeMultipartSubtype", values);
	return geary_mime_multipart_subtype_type_id;
}

GType
geary_mime_multipart_subtype_get_type (void)
{
	static gsize geary_mime_multipart_subtype_type_id__once = 0;
	if (g_once_init_enter (&geary_mime_multipart_subtype_type_id__once)) {
		GType geary_mime_multipart_subtype_type_id;
		geary_mime_multipart_subtype_type_id = geary_mime_multipart_subtype_get_type_once ();
		g_once_init_leave (&geary_mime_multipart_subtype_type_id__once, geary_mime_multipart_subtype_type_id);
	}
	return geary_mime_multipart_subtype_type_id__once;
}

