/* nonblocking-queue.c generated by valac 0.56.17, the Vala compiler
 * generated from nonblocking-queue.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2017 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_NONBLOCKING_QUEUE_0_PROPERTY,
	GEARY_NONBLOCKING_QUEUE_G_TYPE,
	GEARY_NONBLOCKING_QUEUE_G_DUP_FUNC,
	GEARY_NONBLOCKING_QUEUE_G_DESTROY_FUNC,
	GEARY_NONBLOCKING_QUEUE_SIZE_PROPERTY,
	GEARY_NONBLOCKING_QUEUE_IS_EMPTY_PROPERTY,
	GEARY_NONBLOCKING_QUEUE_ALLOW_DUPLICATES_PROPERTY,
	GEARY_NONBLOCKING_QUEUE_REQUEUE_DUPLICATE_PROPERTY,
	GEARY_NONBLOCKING_QUEUE_IS_PAUSED_PROPERTY,
	GEARY_NONBLOCKING_QUEUE_NUM_PROPERTIES
};
static GParamSpec* geary_nonblocking_queue_properties[GEARY_NONBLOCKING_QUEUE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _GearyNonblockingQueueReceiveData GearyNonblockingQueueReceiveData;
typedef struct _GearyNonblockingQueuePeekData GearyNonblockingQueuePeekData;

struct _GearyNonblockingQueuePrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	gboolean _allow_duplicates;
	gboolean _requeue_duplicate;
	gboolean _is_paused;
	GeeQueue* queue;
	GearyNonblockingSpinlock* spinlock;
};

struct _GearyNonblockingQueueReceiveData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyNonblockingQueue* self;
	GCancellable* cancellable;
	gpointer result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GeeQueue* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	GeeQueue* _tmp7_;
	gpointer _tmp8_;
	GearyNonblockingSpinlock* _tmp9_;
	GError* _inner_error0_;
};

struct _GearyNonblockingQueuePeekData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyNonblockingQueue* self;
	GCancellable* cancellable;
	gpointer result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GeeQueue* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	GeeQueue* _tmp7_;
	gpointer _tmp8_;
	GearyNonblockingSpinlock* _tmp9_;
	GError* _inner_error0_;
};

static gint GearyNonblockingQueue_private_offset;
static gpointer geary_nonblocking_queue_parent_class = NULL;

static void geary_nonblocking_queue_receive_data_free (gpointer _data);
static gboolean geary_nonblocking_queue_receive_co (GearyNonblockingQueueReceiveData* _data_);
static void geary_nonblocking_queue_receive_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
static void geary_nonblocking_queue_peek_data_free (gpointer _data);
static gboolean geary_nonblocking_queue_peek_co (GearyNonblockingQueuePeekData* _data_);
static void geary_nonblocking_queue_peek_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_);
static void geary_nonblocking_queue_finalize (GObject * obj);
static GType geary_nonblocking_queue_get_type_once (void);
static void _vala_geary_nonblocking_queue_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_geary_nonblocking_queue_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
geary_nonblocking_queue_get_instance_private (GearyNonblockingQueue* self)
{
	return G_STRUCT_MEMBER_P (self, GearyNonblockingQueue_private_offset);
}

gint
geary_nonblocking_queue_get_size (GearyNonblockingQueue* self)
{
	gint result;
	GeeQueue* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 22 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_return_val_if_fail (GEARY_NONBLOCKING_IS_QUEUE (self), 0);
#line 22 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp0_ = self->priv->queue;
#line 22 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp1_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection));
#line 22 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp2_ = _tmp1_;
#line 22 "../src/engine/nonblocking/nonblocking-queue.vala"
	result = _tmp2_;
#line 22 "../src/engine/nonblocking/nonblocking-queue.vala"
	return result;
#line 153 "nonblocking-queue.c"
}

gboolean
geary_nonblocking_queue_get_is_empty (GearyNonblockingQueue* self)
{
	gboolean result;
	GeeQueue* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 25 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_return_val_if_fail (GEARY_NONBLOCKING_IS_QUEUE (self), FALSE);
#line 25 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp0_ = self->priv->queue;
#line 25 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp1_ = gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection));
#line 25 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp2_ = _tmp1_;
#line 25 "../src/engine/nonblocking/nonblocking-queue.vala"
	result = _tmp2_;
#line 25 "../src/engine/nonblocking/nonblocking-queue.vala"
	return result;
#line 175 "nonblocking-queue.c"
}

gboolean
geary_nonblocking_queue_get_allow_duplicates (GearyNonblockingQueue* self)
{
	gboolean result;
#line 33 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_return_val_if_fail (GEARY_NONBLOCKING_IS_QUEUE (self), FALSE);
#line 33 "../src/engine/nonblocking/nonblocking-queue.vala"
	result = self->priv->_allow_duplicates;
#line 33 "../src/engine/nonblocking/nonblocking-queue.vala"
	return result;
#line 188 "nonblocking-queue.c"
}

void
geary_nonblocking_queue_set_allow_duplicates (GearyNonblockingQueue* self,
                                              gboolean value)
{
	gboolean old_value;
#line 33 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_return_if_fail (GEARY_NONBLOCKING_IS_QUEUE (self));
#line 33 "../src/engine/nonblocking/nonblocking-queue.vala"
	old_value = geary_nonblocking_queue_get_allow_duplicates (self);
#line 33 "../src/engine/nonblocking/nonblocking-queue.vala"
	if (old_value != value) {
#line 33 "../src/engine/nonblocking/nonblocking-queue.vala"
		self->priv->_allow_duplicates = value;
#line 33 "../src/engine/nonblocking/nonblocking-queue.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_nonblocking_queue_properties[GEARY_NONBLOCKING_QUEUE_ALLOW_DUPLICATES_PROPERTY]);
#line 206 "nonblocking-queue.c"
	}
}

gboolean
geary_nonblocking_queue_get_requeue_duplicate (GearyNonblockingQueue* self)
{
	gboolean result;
#line 41 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_return_val_if_fail (GEARY_NONBLOCKING_IS_QUEUE (self), FALSE);
#line 41 "../src/engine/nonblocking/nonblocking-queue.vala"
	result = self->priv->_requeue_duplicate;
#line 41 "../src/engine/nonblocking/nonblocking-queue.vala"
	return result;
#line 220 "nonblocking-queue.c"
}

void
geary_nonblocking_queue_set_requeue_duplicate (GearyNonblockingQueue* self,
                                               gboolean value)
{
	gboolean old_value;
#line 41 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_return_if_fail (GEARY_NONBLOCKING_IS_QUEUE (self));
#line 41 "../src/engine/nonblocking/nonblocking-queue.vala"
	old_value = geary_nonblocking_queue_get_requeue_duplicate (self);
#line 41 "../src/engine/nonblocking/nonblocking-queue.vala"
	if (old_value != value) {
#line 41 "../src/engine/nonblocking/nonblocking-queue.vala"
		self->priv->_requeue_duplicate = value;
#line 41 "../src/engine/nonblocking/nonblocking-queue.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_nonblocking_queue_properties[GEARY_NONBLOCKING_QUEUE_REQUEUE_DUPLICATE_PROPERTY]);
#line 238 "nonblocking-queue.c"
	}
}

gboolean
geary_nonblocking_queue_get_is_paused (GearyNonblockingQueue* self)
{
	gboolean result;
#line 47 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_return_val_if_fail (GEARY_NONBLOCKING_IS_QUEUE (self), FALSE);
#line 47 "../src/engine/nonblocking/nonblocking-queue.vala"
	result = self->priv->_is_paused;
#line 47 "../src/engine/nonblocking/nonblocking-queue.vala"
	return result;
#line 252 "nonblocking-queue.c"
}

void
geary_nonblocking_queue_set_is_paused (GearyNonblockingQueue* self,
                                       gboolean value)
{
	gboolean _tmp0_ = FALSE;
#line 49 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_return_if_fail (GEARY_NONBLOCKING_IS_QUEUE (self));
#line 51 "../src/engine/nonblocking/nonblocking-queue.vala"
	if (self->priv->_is_paused) {
#line 51 "../src/engine/nonblocking/nonblocking-queue.vala"
		_tmp0_ = !value;
#line 266 "nonblocking-queue.c"
	} else {
#line 51 "../src/engine/nonblocking/nonblocking-queue.vala"
		_tmp0_ = FALSE;
#line 270 "nonblocking-queue.c"
	}
#line 51 "../src/engine/nonblocking/nonblocking-queue.vala"
	if (_tmp0_) {
#line 274 "nonblocking-queue.c"
		GearyNonblockingSpinlock* _tmp1_;
#line 52 "../src/engine/nonblocking/nonblocking-queue.vala"
		_tmp1_ = self->priv->spinlock;
#line 52 "../src/engine/nonblocking/nonblocking-queue.vala"
		geary_nonblocking_lock_blind_notify (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock));
#line 280 "nonblocking-queue.c"
	}
#line 54 "../src/engine/nonblocking/nonblocking-queue.vala"
	self->priv->_is_paused = value;
#line 49 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_object_notify_by_pspec ((GObject *) self, geary_nonblocking_queue_properties[GEARY_NONBLOCKING_QUEUE_IS_PAUSED_PROPERTY]);
#line 286 "nonblocking-queue.c"
}

/**
     * Constructs a new first-in first-out (FIFO) queue.
     *
     * If `equalator` is not null it will be used to determine the
     * identity of objects in the queue, else the items' natural
     * identity will be used.
     */
GearyNonblockingQueue*
geary_nonblocking_queue_construct_fifo (GType object_type,
                                        GType g_type,
                                        GBoxedCopyFunc g_dup_func,
                                        GDestroyNotify g_destroy_func,
                                        GeeEqualDataFunc equalator,
                                        gpointer equalator_target,
                                        GDestroyNotify equalator_target_destroy_notify)
{
	GearyNonblockingQueue * self = NULL;
	GeeEqualDataFunc _tmp0_;
	gpointer _tmp0__target;
	GDestroyNotify _tmp0__target_destroy_notify;
	GeeLinkedList* _tmp1_;
	GeeLinkedList* _tmp2_;
#line 71 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp0_ = equalator;
#line 71 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp0__target = equalator_target;
#line 71 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp0__target_destroy_notify = equalator_target_destroy_notify;
#line 71 "../src/engine/nonblocking/nonblocking-queue.vala"
	equalator = NULL;
#line 71 "../src/engine/nonblocking/nonblocking-queue.vala"
	equalator_target = NULL;
#line 71 "../src/engine/nonblocking/nonblocking-queue.vala"
	equalator_target_destroy_notify = NULL;
#line 71 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp1_ = gee_linked_list_new (g_type, (GBoxedCopyFunc) g_dup_func, (GDestroyNotify) g_destroy_func, _tmp0_, _tmp0__target, _tmp0__target_destroy_notify);
#line 71 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp2_ = _tmp1_;
#line 71 "../src/engine/nonblocking/nonblocking-queue.vala"
	self = (GearyNonblockingQueue*) geary_nonblocking_queue_construct (object_type, g_type, g_dup_func, g_destroy_func, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_QUEUE, GeeQueue));
#line 71 "../src/engine/nonblocking/nonblocking-queue.vala"
	self->priv->g_type = g_type;
#line 71 "../src/engine/nonblocking/nonblocking-queue.vala"
	self->priv->g_dup_func = g_dup_func;
#line 71 "../src/engine/nonblocking/nonblocking-queue.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 71 "../src/engine/nonblocking/nonblocking-queue.vala"
	_g_object_unref0 (_tmp2_);
#line 70 "../src/engine/nonblocking/nonblocking-queue.vala"
	(equalator_target_destroy_notify == NULL) ? NULL : (equalator_target_destroy_notify (equalator_target), NULL);
#line 70 "../src/engine/nonblocking/nonblocking-queue.vala"
	equalator = NULL;
#line 70 "../src/engine/nonblocking/nonblocking-queue.vala"
	equalator_target = NULL;
#line 70 "../src/engine/nonblocking/nonblocking-queue.vala"
	equalator_target_destroy_notify = NULL;
#line 70 "../src/engine/nonblocking/nonblocking-queue.vala"
	return self;
#line 347 "nonblocking-queue.c"
}

GearyNonblockingQueue*
geary_nonblocking_queue_new_fifo (GType g_type,
                                  GBoxedCopyFunc g_dup_func,
                                  GDestroyNotify g_destroy_func,
                                  GeeEqualDataFunc equalator,
                                  gpointer equalator_target,
                                  GDestroyNotify equalator_target_destroy_notify)
{
#line 70 "../src/engine/nonblocking/nonblocking-queue.vala"
	return geary_nonblocking_queue_construct_fifo (GEARY_NONBLOCKING_TYPE_QUEUE, g_type, g_dup_func, g_destroy_func, equalator, equalator_target, equalator_target_destroy_notify);
#line 360 "nonblocking-queue.c"
}

/**
     * Constructs a new priority queue.
     *
     * If `comparator` is not null it will be used to determine the
     * ordering of objects in the queue, else the items' natural
     * ordering will be used.
     */
GearyNonblockingQueue*
geary_nonblocking_queue_construct_priority (GType object_type,
                                            GType g_type,
                                            GBoxedCopyFunc g_dup_func,
                                            GDestroyNotify g_destroy_func,
                                            GCompareDataFunc comparator,
                                            gpointer comparator_target,
                                            GDestroyNotify comparator_target_destroy_notify)
{
	GearyNonblockingQueue * self = NULL;
	GCompareDataFunc _tmp0_;
	gpointer _tmp0__target;
	GDestroyNotify _tmp0__target_destroy_notify;
	GeePriorityQueue* _tmp1_;
	GeePriorityQueue* _tmp2_;
#line 82 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp0_ = comparator;
#line 82 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp0__target = comparator_target;
#line 82 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp0__target_destroy_notify = comparator_target_destroy_notify;
#line 82 "../src/engine/nonblocking/nonblocking-queue.vala"
	comparator = NULL;
#line 82 "../src/engine/nonblocking/nonblocking-queue.vala"
	comparator_target = NULL;
#line 82 "../src/engine/nonblocking/nonblocking-queue.vala"
	comparator_target_destroy_notify = NULL;
#line 82 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp1_ = gee_priority_queue_new (g_type, (GBoxedCopyFunc) g_dup_func, (GDestroyNotify) g_destroy_func, _tmp0_, _tmp0__target, _tmp0__target_destroy_notify);
#line 82 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp2_ = _tmp1_;
#line 82 "../src/engine/nonblocking/nonblocking-queue.vala"
	self = (GearyNonblockingQueue*) geary_nonblocking_queue_construct (object_type, g_type, g_dup_func, g_destroy_func, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_QUEUE, GeeQueue));
#line 82 "../src/engine/nonblocking/nonblocking-queue.vala"
	self->priv->g_type = g_type;
#line 82 "../src/engine/nonblocking/nonblocking-queue.vala"
	self->priv->g_dup_func = g_dup_func;
#line 82 "../src/engine/nonblocking/nonblocking-queue.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 82 "../src/engine/nonblocking/nonblocking-queue.vala"
	_g_object_unref0 (_tmp2_);
#line 81 "../src/engine/nonblocking/nonblocking-queue.vala"
	(comparator_target_destroy_notify == NULL) ? NULL : (comparator_target_destroy_notify (comparator_target), NULL);
#line 81 "../src/engine/nonblocking/nonblocking-queue.vala"
	comparator = NULL;
#line 81 "../src/engine/nonblocking/nonblocking-queue.vala"
	comparator_target = NULL;
#line 81 "../src/engine/nonblocking/nonblocking-queue.vala"
	comparator_target_destroy_notify = NULL;
#line 81 "../src/engine/nonblocking/nonblocking-queue.vala"
	return self;
#line 421 "nonblocking-queue.c"
}

GearyNonblockingQueue*
geary_nonblocking_queue_new_priority (GType g_type,
                                      GBoxedCopyFunc g_dup_func,
                                      GDestroyNotify g_destroy_func,
                                      GCompareDataFunc comparator,
                                      gpointer comparator_target,
                                      GDestroyNotify comparator_target_destroy_notify)
{
#line 81 "../src/engine/nonblocking/nonblocking-queue.vala"
	return geary_nonblocking_queue_construct_priority (GEARY_NONBLOCKING_TYPE_QUEUE, g_type, g_dup_func, g_destroy_func, comparator, comparator_target, comparator_target_destroy_notify);
#line 434 "nonblocking-queue.c"
}

/**
     * Constructs a new queue.
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 89 "../src/engine/nonblocking/nonblocking-queue.vala"
	return self ? g_object_ref (self) : NULL;
#line 445 "nonblocking-queue.c"
}

GearyNonblockingQueue*
geary_nonblocking_queue_construct (GType object_type,
                                   GType g_type,
                                   GBoxedCopyFunc g_dup_func,
                                   GDestroyNotify g_destroy_func,
                                   GeeQueue* queue)
{
	GearyNonblockingQueue * self = NULL;
	GeeQueue* _tmp0_;
#line 88 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (queue, GEE_TYPE_QUEUE), NULL);
#line 88 "../src/engine/nonblocking/nonblocking-queue.vala"
	self = (GearyNonblockingQueue*) geary_base_object_construct (object_type);
#line 88 "../src/engine/nonblocking/nonblocking-queue.vala"
	self->priv->g_type = g_type;
#line 88 "../src/engine/nonblocking/nonblocking-queue.vala"
	self->priv->g_dup_func = g_dup_func;
#line 88 "../src/engine/nonblocking/nonblocking-queue.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 89 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp0_ = _g_object_ref0 (queue);
#line 89 "../src/engine/nonblocking/nonblocking-queue.vala"
	_g_object_unref0 (self->priv->queue);
#line 89 "../src/engine/nonblocking/nonblocking-queue.vala"
	self->priv->queue = _tmp0_;
#line 88 "../src/engine/nonblocking/nonblocking-queue.vala"
	return self;
#line 475 "nonblocking-queue.c"
}

GearyNonblockingQueue*
geary_nonblocking_queue_new (GType g_type,
                             GBoxedCopyFunc g_dup_func,
                             GDestroyNotify g_destroy_func,
                             GeeQueue* queue)
{
#line 88 "../src/engine/nonblocking/nonblocking-queue.vala"
	return geary_nonblocking_queue_construct (GEARY_NONBLOCKING_TYPE_QUEUE, g_type, g_dup_func, g_destroy_func, queue);
#line 486 "nonblocking-queue.c"
}

/**
     * Adds an item to the queue.
     *
     * If the queue is a priority queue, it is added according to its
     * relative priority, else it is added to the end.
     *
     * Returns `true` if the item was added to the queue.
     */
gboolean
geary_nonblocking_queue_send (GearyNonblockingQueue* self,
                              gconstpointer msg)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	GeeQueue* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	gboolean result;
#line 100 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_return_val_if_fail (GEARY_NONBLOCKING_IS_QUEUE (self), FALSE);
#line 101 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp1_ = self->priv->_allow_duplicates;
#line 101 "../src/engine/nonblocking/nonblocking-queue.vala"
	if (!_tmp1_) {
#line 513 "nonblocking-queue.c"
		GeeQueue* _tmp2_;
#line 101 "../src/engine/nonblocking/nonblocking-queue.vala"
		_tmp2_ = self->priv->queue;
#line 101 "../src/engine/nonblocking/nonblocking-queue.vala"
		_tmp0_ = gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection), msg);
#line 519 "nonblocking-queue.c"
	} else {
#line 101 "../src/engine/nonblocking/nonblocking-queue.vala"
		_tmp0_ = FALSE;
#line 523 "nonblocking-queue.c"
	}
#line 101 "../src/engine/nonblocking/nonblocking-queue.vala"
	if (_tmp0_) {
#line 527 "nonblocking-queue.c"
		gboolean _tmp3_;
#line 102 "../src/engine/nonblocking/nonblocking-queue.vala"
		_tmp3_ = self->priv->_requeue_duplicate;
#line 102 "../src/engine/nonblocking/nonblocking-queue.vala"
		if (_tmp3_) {
#line 533 "nonblocking-queue.c"
			GeeQueue* _tmp4_;
#line 103 "../src/engine/nonblocking/nonblocking-queue.vala"
			_tmp4_ = self->priv->queue;
#line 103 "../src/engine/nonblocking/nonblocking-queue.vala"
			gee_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_COLLECTION, GeeCollection), msg);
#line 539 "nonblocking-queue.c"
		} else {
#line 105 "../src/engine/nonblocking/nonblocking-queue.vala"
			result = FALSE;
#line 105 "../src/engine/nonblocking/nonblocking-queue.vala"
			return result;
#line 545 "nonblocking-queue.c"
		}
	}
#line 108 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp5_ = self->priv->queue;
#line 108 "../src/engine/nonblocking/nonblocking-queue.vala"
	if (!gee_queue_offer (_tmp5_, msg)) {
#line 109 "../src/engine/nonblocking/nonblocking-queue.vala"
		result = FALSE;
#line 109 "../src/engine/nonblocking/nonblocking-queue.vala"
		return result;
#line 556 "nonblocking-queue.c"
	}
#line 111 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp6_ = geary_nonblocking_queue_get_is_paused (self);
#line 111 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp7_ = _tmp6_;
#line 111 "../src/engine/nonblocking/nonblocking-queue.vala"
	if (!_tmp7_) {
#line 564 "nonblocking-queue.c"
		GearyNonblockingSpinlock* _tmp8_;
#line 112 "../src/engine/nonblocking/nonblocking-queue.vala"
		_tmp8_ = self->priv->spinlock;
#line 112 "../src/engine/nonblocking/nonblocking-queue.vala"
		geary_nonblocking_lock_blind_notify (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock));
#line 570 "nonblocking-queue.c"
	}
#line 114 "../src/engine/nonblocking/nonblocking-queue.vala"
	result = TRUE;
#line 114 "../src/engine/nonblocking/nonblocking-queue.vala"
	return result;
#line 576 "nonblocking-queue.c"
}

static void
geary_nonblocking_queue_receive_data_free (gpointer _data)
{
	GearyNonblockingQueueReceiveData* _data_;
	_data_ = _data;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	_g_object_unref0 (_data_->cancellable);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	((_data_->result == NULL) || (_data_->self->priv->g_destroy_func == NULL)) ? NULL : (_data_->result = (_data_->self->priv->g_destroy_func (_data_->result), NULL));
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	_g_object_unref0 (_data_->self);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_slice_free (GearyNonblockingQueueReceiveData, _data_);
#line 592 "nonblocking-queue.c"
}

void
geary_nonblocking_queue_receive (GearyNonblockingQueue* self,
                                 GCancellable* cancellable,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	GearyNonblockingQueueReceiveData* _data_;
	GearyNonblockingQueue* _tmp0_;
	GCancellable* _tmp1_;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_return_if_fail (GEARY_NONBLOCKING_IS_QUEUE (self));
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	_data_ = g_slice_new0 (GearyNonblockingQueueReceiveData);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_nonblocking_queue_receive_data_free);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	_data_->self = _tmp0_;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	_g_object_unref0 (_data_->cancellable);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	_data_->cancellable = _tmp1_;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	geary_nonblocking_queue_receive_co (_data_);
#line 626 "nonblocking-queue.c"
}

gpointer
geary_nonblocking_queue_receive_finish (GearyNonblockingQueue* self,
                                        GAsyncResult* _res_,
                                        GError** error)
{
	gpointer result;
	GearyNonblockingQueueReceiveData* _data_;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	if (NULL == _data_) {
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		return NULL;
#line 642 "nonblocking-queue.c"
	}
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	result = _data_->result;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	_data_->result = NULL;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	return result;
#line 650 "nonblocking-queue.c"
}

/**
     * Removes and returns the next queued item, blocking until available.
     *
     * If the queue is paused, this will continue to wait until
     * unpaused and an item is ready. If `cancellable` is non-null,
     * when used will cancel this call.
     */
static void
geary_nonblocking_queue_receive_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	GearyNonblockingQueueReceiveData* _data_;
#line 129 "../src/engine/nonblocking/nonblocking-queue.vala"
	_data_ = _user_data_;
#line 129 "../src/engine/nonblocking/nonblocking-queue.vala"
	_data_->_source_object_ = source_object;
#line 129 "../src/engine/nonblocking/nonblocking-queue.vala"
	_data_->_res_ = _res_;
#line 129 "../src/engine/nonblocking/nonblocking-queue.vala"
	geary_nonblocking_queue_receive_co (_data_);
#line 674 "nonblocking-queue.c"
}

static gboolean
geary_nonblocking_queue_receive_co (GearyNonblockingQueueReceiveData* _data_)
{
#line 124 "../src/engine/nonblocking/nonblocking-queue.vala"
	switch (_data_->_state_) {
#line 124 "../src/engine/nonblocking/nonblocking-queue.vala"
		case 0:
#line 684 "nonblocking-queue.c"
		goto _state_0;
#line 124 "../src/engine/nonblocking/nonblocking-queue.vala"
		case 1:
#line 688 "nonblocking-queue.c"
		goto _state_1;
		default:
#line 124 "../src/engine/nonblocking/nonblocking-queue.vala"
		g_assert_not_reached ();
#line 693 "nonblocking-queue.c"
	}
	_state_0:
	{
#line 125 "../src/engine/nonblocking/nonblocking-queue.vala"
		_data_->_tmp0_ = TRUE;
#line 125 "../src/engine/nonblocking/nonblocking-queue.vala"
		while (TRUE) {
#line 125 "../src/engine/nonblocking/nonblocking-queue.vala"
			if (!_data_->_tmp0_) {
#line 703 "nonblocking-queue.c"
			}
#line 125 "../src/engine/nonblocking/nonblocking-queue.vala"
			_data_->_tmp0_ = FALSE;
#line 126 "../src/engine/nonblocking/nonblocking-queue.vala"
			_data_->_tmp2_ = _data_->self->priv->queue;
#line 126 "../src/engine/nonblocking/nonblocking-queue.vala"
			_data_->_tmp3_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, GEE_TYPE_COLLECTION, GeeCollection));
#line 126 "../src/engine/nonblocking/nonblocking-queue.vala"
			_data_->_tmp4_ = _data_->_tmp3_;
#line 126 "../src/engine/nonblocking/nonblocking-queue.vala"
			if (_data_->_tmp4_ > 0) {
#line 126 "../src/engine/nonblocking/nonblocking-queue.vala"
				_data_->_tmp5_ = geary_nonblocking_queue_get_is_paused (_data_->self);
#line 126 "../src/engine/nonblocking/nonblocking-queue.vala"
				_data_->_tmp6_ = _data_->_tmp5_;
#line 126 "../src/engine/nonblocking/nonblocking-queue.vala"
				_data_->_tmp1_ = !_data_->_tmp6_;
#line 721 "nonblocking-queue.c"
			} else {
#line 126 "../src/engine/nonblocking/nonblocking-queue.vala"
				_data_->_tmp1_ = FALSE;
#line 725 "nonblocking-queue.c"
			}
#line 126 "../src/engine/nonblocking/nonblocking-queue.vala"
			if (_data_->_tmp1_) {
#line 127 "../src/engine/nonblocking/nonblocking-queue.vala"
				_data_->_tmp7_ = _data_->self->priv->queue;
#line 127 "../src/engine/nonblocking/nonblocking-queue.vala"
				_data_->_tmp8_ = gee_queue_poll (_data_->_tmp7_);
#line 127 "../src/engine/nonblocking/nonblocking-queue.vala"
				_data_->result = _data_->_tmp8_;
#line 127 "../src/engine/nonblocking/nonblocking-queue.vala"
				g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 127 "../src/engine/nonblocking/nonblocking-queue.vala"
				if (_data_->_state_ != 0) {
#line 127 "../src/engine/nonblocking/nonblocking-queue.vala"
					while (!g_task_get_completed (_data_->_async_result)) {
#line 127 "../src/engine/nonblocking/nonblocking-queue.vala"
						g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 743 "nonblocking-queue.c"
					}
				}
#line 127 "../src/engine/nonblocking/nonblocking-queue.vala"
				g_object_unref (_data_->_async_result);
#line 127 "../src/engine/nonblocking/nonblocking-queue.vala"
				return FALSE;
#line 750 "nonblocking-queue.c"
			}
#line 129 "../src/engine/nonblocking/nonblocking-queue.vala"
			_data_->_tmp9_ = _data_->self->priv->spinlock;
#line 129 "../src/engine/nonblocking/nonblocking-queue.vala"
			_data_->_state_ = 1;
#line 129 "../src/engine/nonblocking/nonblocking-queue.vala"
			geary_nonblocking_lock_wait_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp9_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock), _data_->cancellable, geary_nonblocking_queue_receive_ready, _data_);
#line 129 "../src/engine/nonblocking/nonblocking-queue.vala"
			return FALSE;
#line 760 "nonblocking-queue.c"
			_state_1:
#line 129 "../src/engine/nonblocking/nonblocking-queue.vala"
			geary_nonblocking_lock_wait_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp9_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock), _data_->_res_, &_data_->_inner_error0_);
#line 129 "../src/engine/nonblocking/nonblocking-queue.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 129 "../src/engine/nonblocking/nonblocking-queue.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 129 "../src/engine/nonblocking/nonblocking-queue.vala"
				g_object_unref (_data_->_async_result);
#line 129 "../src/engine/nonblocking/nonblocking-queue.vala"
				return FALSE;
#line 772 "nonblocking-queue.c"
			}
		}
	}
}

static void
geary_nonblocking_queue_peek_data_free (gpointer _data)
{
	GearyNonblockingQueuePeekData* _data_;
	_data_ = _data;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	_g_object_unref0 (_data_->cancellable);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	((_data_->result == NULL) || (_data_->self->priv->g_destroy_func == NULL)) ? NULL : (_data_->result = (_data_->self->priv->g_destroy_func (_data_->result), NULL));
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	_g_object_unref0 (_data_->self);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_slice_free (GearyNonblockingQueuePeekData, _data_);
#line 791 "nonblocking-queue.c"
}

void
geary_nonblocking_queue_peek (GearyNonblockingQueue* self,
                              GCancellable* cancellable,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	GearyNonblockingQueuePeekData* _data_;
	GearyNonblockingQueue* _tmp0_;
	GCancellable* _tmp1_;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_return_if_fail (GEARY_NONBLOCKING_IS_QUEUE (self));
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	_data_ = g_slice_new0 (GearyNonblockingQueuePeekData);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_nonblocking_queue_peek_data_free);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	_data_->self = _tmp0_;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	_g_object_unref0 (_data_->cancellable);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	_data_->cancellable = _tmp1_;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	geary_nonblocking_queue_peek_co (_data_);
#line 825 "nonblocking-queue.c"
}

gpointer
geary_nonblocking_queue_peek_finish (GearyNonblockingQueue* self,
                                     GAsyncResult* _res_,
                                     GError** error)
{
	gpointer result;
	GearyNonblockingQueuePeekData* _data_;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	if (NULL == _data_) {
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		return NULL;
#line 841 "nonblocking-queue.c"
	}
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	result = _data_->result;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	_data_->result = NULL;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	return result;
#line 849 "nonblocking-queue.c"
}

/**
     * Returns the next queued item without removal, blocking until available.
     *
     * If the queue is paused, this will continue to wait until
     * unpaused and an item is ready. If `cancellable` is non-null,
     * when used will cancel this call.
     */
static void
geary_nonblocking_queue_peek_ready (GObject* source_object,
                                    GAsyncResult* _res_,
                                    gpointer _user_data_)
{
	GearyNonblockingQueuePeekData* _data_;
#line 145 "../src/engine/nonblocking/nonblocking-queue.vala"
	_data_ = _user_data_;
#line 145 "../src/engine/nonblocking/nonblocking-queue.vala"
	_data_->_source_object_ = source_object;
#line 145 "../src/engine/nonblocking/nonblocking-queue.vala"
	_data_->_res_ = _res_;
#line 145 "../src/engine/nonblocking/nonblocking-queue.vala"
	geary_nonblocking_queue_peek_co (_data_);
#line 873 "nonblocking-queue.c"
}

static gboolean
geary_nonblocking_queue_peek_co (GearyNonblockingQueuePeekData* _data_)
{
#line 140 "../src/engine/nonblocking/nonblocking-queue.vala"
	switch (_data_->_state_) {
#line 140 "../src/engine/nonblocking/nonblocking-queue.vala"
		case 0:
#line 883 "nonblocking-queue.c"
		goto _state_0;
#line 140 "../src/engine/nonblocking/nonblocking-queue.vala"
		case 1:
#line 887 "nonblocking-queue.c"
		goto _state_1;
		default:
#line 140 "../src/engine/nonblocking/nonblocking-queue.vala"
		g_assert_not_reached ();
#line 892 "nonblocking-queue.c"
	}
	_state_0:
	{
#line 141 "../src/engine/nonblocking/nonblocking-queue.vala"
		_data_->_tmp0_ = TRUE;
#line 141 "../src/engine/nonblocking/nonblocking-queue.vala"
		while (TRUE) {
#line 141 "../src/engine/nonblocking/nonblocking-queue.vala"
			if (!_data_->_tmp0_) {
#line 902 "nonblocking-queue.c"
			}
#line 141 "../src/engine/nonblocking/nonblocking-queue.vala"
			_data_->_tmp0_ = FALSE;
#line 142 "../src/engine/nonblocking/nonblocking-queue.vala"
			_data_->_tmp2_ = _data_->self->priv->queue;
#line 142 "../src/engine/nonblocking/nonblocking-queue.vala"
			_data_->_tmp3_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, GEE_TYPE_COLLECTION, GeeCollection));
#line 142 "../src/engine/nonblocking/nonblocking-queue.vala"
			_data_->_tmp4_ = _data_->_tmp3_;
#line 142 "../src/engine/nonblocking/nonblocking-queue.vala"
			if (_data_->_tmp4_ > 0) {
#line 142 "../src/engine/nonblocking/nonblocking-queue.vala"
				_data_->_tmp5_ = geary_nonblocking_queue_get_is_paused (_data_->self);
#line 142 "../src/engine/nonblocking/nonblocking-queue.vala"
				_data_->_tmp6_ = _data_->_tmp5_;
#line 142 "../src/engine/nonblocking/nonblocking-queue.vala"
				_data_->_tmp1_ = !_data_->_tmp6_;
#line 920 "nonblocking-queue.c"
			} else {
#line 142 "../src/engine/nonblocking/nonblocking-queue.vala"
				_data_->_tmp1_ = FALSE;
#line 924 "nonblocking-queue.c"
			}
#line 142 "../src/engine/nonblocking/nonblocking-queue.vala"
			if (_data_->_tmp1_) {
#line 143 "../src/engine/nonblocking/nonblocking-queue.vala"
				_data_->_tmp7_ = _data_->self->priv->queue;
#line 143 "../src/engine/nonblocking/nonblocking-queue.vala"
				_data_->_tmp8_ = gee_queue_peek (_data_->_tmp7_);
#line 143 "../src/engine/nonblocking/nonblocking-queue.vala"
				_data_->result = _data_->_tmp8_;
#line 143 "../src/engine/nonblocking/nonblocking-queue.vala"
				g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 143 "../src/engine/nonblocking/nonblocking-queue.vala"
				if (_data_->_state_ != 0) {
#line 143 "../src/engine/nonblocking/nonblocking-queue.vala"
					while (!g_task_get_completed (_data_->_async_result)) {
#line 143 "../src/engine/nonblocking/nonblocking-queue.vala"
						g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 942 "nonblocking-queue.c"
					}
				}
#line 143 "../src/engine/nonblocking/nonblocking-queue.vala"
				g_object_unref (_data_->_async_result);
#line 143 "../src/engine/nonblocking/nonblocking-queue.vala"
				return FALSE;
#line 949 "nonblocking-queue.c"
			}
#line 145 "../src/engine/nonblocking/nonblocking-queue.vala"
			_data_->_tmp9_ = _data_->self->priv->spinlock;
#line 145 "../src/engine/nonblocking/nonblocking-queue.vala"
			_data_->_state_ = 1;
#line 145 "../src/engine/nonblocking/nonblocking-queue.vala"
			geary_nonblocking_lock_wait_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp9_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock), _data_->cancellable, geary_nonblocking_queue_peek_ready, _data_);
#line 145 "../src/engine/nonblocking/nonblocking-queue.vala"
			return FALSE;
#line 959 "nonblocking-queue.c"
			_state_1:
#line 145 "../src/engine/nonblocking/nonblocking-queue.vala"
			geary_nonblocking_lock_wait_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp9_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock), _data_->_res_, &_data_->_inner_error0_);
#line 145 "../src/engine/nonblocking/nonblocking-queue.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 145 "../src/engine/nonblocking/nonblocking-queue.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 145 "../src/engine/nonblocking/nonblocking-queue.vala"
				g_object_unref (_data_->_async_result);
#line 145 "../src/engine/nonblocking/nonblocking-queue.vala"
				return FALSE;
#line 971 "nonblocking-queue.c"
			}
		}
	}
}

/**
     * Removes all items in queue, returning the number of removed items.
     */
gint
geary_nonblocking_queue_clear (GearyNonblockingQueue* self)
{
	gint count = 0;
	GeeQueue* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result;
#line 152 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_return_val_if_fail (GEARY_NONBLOCKING_IS_QUEUE (self), 0);
#line 153 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp0_ = self->priv->queue;
#line 153 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp1_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection));
#line 153 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp2_ = _tmp1_;
#line 153 "../src/engine/nonblocking/nonblocking-queue.vala"
	count = _tmp2_;
#line 154 "../src/engine/nonblocking/nonblocking-queue.vala"
	if (count != 0) {
#line 1000 "nonblocking-queue.c"
		GeeQueue* _tmp3_;
#line 155 "../src/engine/nonblocking/nonblocking-queue.vala"
		_tmp3_ = self->priv->queue;
#line 155 "../src/engine/nonblocking/nonblocking-queue.vala"
		gee_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1006 "nonblocking-queue.c"
	}
#line 157 "../src/engine/nonblocking/nonblocking-queue.vala"
	result = count;
#line 157 "../src/engine/nonblocking/nonblocking-queue.vala"
	return result;
#line 1012 "nonblocking-queue.c"
}

/**
     * Removes an item from the queue, returning `true` if removed.
     */
gboolean
geary_nonblocking_queue_revoke (GearyNonblockingQueue* self,
                                gconstpointer msg)
{
	GeeQueue* _tmp0_;
	gboolean result;
#line 163 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_return_val_if_fail (GEARY_NONBLOCKING_IS_QUEUE (self), FALSE);
#line 164 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp0_ = self->priv->queue;
#line 164 "../src/engine/nonblocking/nonblocking-queue.vala"
	result = gee_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), msg);
#line 164 "../src/engine/nonblocking/nonblocking-queue.vala"
	return result;
#line 1032 "nonblocking-queue.c"
}

/**
     * Remove items matching the given predicate, returning those removed.
     */
GeeCollection*
geary_nonblocking_queue_revoke_matching (GearyNonblockingQueue* self,
                                         GeePredicate predicate,
                                         gpointer predicate_target,
                                         GDestroyNotify predicate_target_destroy_notify)
{
	GeeArrayList* removed = NULL;
	GeeArrayList* _tmp0_;
	GeeQueue* _tmp1_;
	gint _tmp2_ = 0;
	gpointer* _tmp3_;
	GeeCollection* result;
#line 170 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_return_val_if_fail (GEARY_NONBLOCKING_IS_QUEUE (self), NULL);
#line 171 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp0_ = gee_array_list_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, (GDestroyNotify) self->priv->g_destroy_func, NULL, NULL, NULL);
#line 171 "../src/engine/nonblocking/nonblocking-queue.vala"
	removed = _tmp0_;
#line 173 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp1_ = self->priv->queue;
#line 173 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp3_ = gee_collection_to_array (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection), &_tmp2_);
#line 1060 "nonblocking-queue.c"
	{
		gpointer* msg_collection = NULL;
		gint msg_collection_length1 = 0;
		gint _msg_collection_size_ = 0;
		gint msg_it = 0;
#line 173 "../src/engine/nonblocking/nonblocking-queue.vala"
		msg_collection = _tmp3_;
#line 173 "../src/engine/nonblocking/nonblocking-queue.vala"
		msg_collection_length1 = _tmp2_;
#line 173 "../src/engine/nonblocking/nonblocking-queue.vala"
		for (msg_it = 0; msg_it < msg_collection_length1; msg_it = msg_it + 1) {
#line 1072 "nonblocking-queue.c"
			gpointer _tmp4_;
			gpointer msg = NULL;
#line 173 "../src/engine/nonblocking/nonblocking-queue.vala"
			_tmp4_ = ((msg_collection[msg_it] != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) msg_collection[msg_it]) : ((gpointer) msg_collection[msg_it]);
#line 173 "../src/engine/nonblocking/nonblocking-queue.vala"
			msg = _tmp4_;
#line 1079 "nonblocking-queue.c"
			{
				gconstpointer _tmp5_;
#line 174 "../src/engine/nonblocking/nonblocking-queue.vala"
				_tmp5_ = msg;
#line 174 "../src/engine/nonblocking/nonblocking-queue.vala"
				if (predicate (_tmp5_, predicate_target)) {
#line 1086 "nonblocking-queue.c"
					GeeQueue* _tmp6_;
					gconstpointer _tmp7_;
					GeeArrayList* _tmp8_;
					gconstpointer _tmp9_;
#line 175 "../src/engine/nonblocking/nonblocking-queue.vala"
					_tmp6_ = self->priv->queue;
#line 175 "../src/engine/nonblocking/nonblocking-queue.vala"
					_tmp7_ = msg;
#line 175 "../src/engine/nonblocking/nonblocking-queue.vala"
					gee_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_COLLECTION, GeeCollection), _tmp7_);
#line 176 "../src/engine/nonblocking/nonblocking-queue.vala"
					_tmp8_ = removed;
#line 176 "../src/engine/nonblocking/nonblocking-queue.vala"
					_tmp9_ = msg;
#line 176 "../src/engine/nonblocking/nonblocking-queue.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp9_);
#line 1103 "nonblocking-queue.c"
				}
#line 173 "../src/engine/nonblocking/nonblocking-queue.vala"
				((msg == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (msg = (self->priv->g_destroy_func (msg), NULL));
#line 1107 "nonblocking-queue.c"
			}
		}
#line 173 "../src/engine/nonblocking/nonblocking-queue.vala"
		msg_collection = (_vala_array_free (msg_collection, msg_collection_length1, (GDestroyNotify) self->priv->g_destroy_func), NULL);
#line 1112 "nonblocking-queue.c"
	}
#line 180 "../src/engine/nonblocking/nonblocking-queue.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_COLLECTION, GeeCollection);
#line 180 "../src/engine/nonblocking/nonblocking-queue.vala"
	(predicate_target_destroy_notify == NULL) ? NULL : (predicate_target_destroy_notify (predicate_target), NULL);
#line 180 "../src/engine/nonblocking/nonblocking-queue.vala"
	predicate = NULL;
#line 180 "../src/engine/nonblocking/nonblocking-queue.vala"
	predicate_target = NULL;
#line 180 "../src/engine/nonblocking/nonblocking-queue.vala"
	predicate_target_destroy_notify = NULL;
#line 180 "../src/engine/nonblocking/nonblocking-queue.vala"
	return result;
#line 1126 "nonblocking-queue.c"
}

/**
     * Returns a read-only version of the queue queue.
     *
     * Since the queue could potentially alter when the main loop
     * runs, it's important to only examine the queue when not
     * allowing other operations to process.
     */
GeeCollection*
geary_nonblocking_queue_get_all (GearyNonblockingQueue* self)
{
	GeeQueue* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* result;
#line 190 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_return_val_if_fail (GEARY_NONBLOCKING_IS_QUEUE (self), NULL);
#line 191 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp0_ = self->priv->queue;
#line 191 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp1_ = gee_collection_get_read_only_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection));
#line 191 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp2_ = _tmp1_;
#line 191 "../src/engine/nonblocking/nonblocking-queue.vala"
	result = _tmp2_;
#line 191 "../src/engine/nonblocking/nonblocking-queue.vala"
	return result;
#line 1155 "nonblocking-queue.c"
}

static void
geary_nonblocking_queue_class_init (GearyNonblockingQueueClass * klass,
                                    gpointer klass_data)
{
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	geary_nonblocking_queue_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_type_class_adjust_private_offset (klass, &GearyNonblockingQueue_private_offset);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_nonblocking_queue_get_property;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_nonblocking_queue_set_property;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_nonblocking_queue_finalize;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_NONBLOCKING_QUEUE_G_TYPE, g_param_spec_gtype ("g-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READWRITE | G_PARAM_CONSTRUCT_ONLY));
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_NONBLOCKING_QUEUE_G_DUP_FUNC, g_param_spec_pointer ("g-dup-func", "dup func", "dup func", G_PARAM_STATIC_STRINGS | G_PARAM_READWRITE | G_PARAM_CONSTRUCT_ONLY));
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_NONBLOCKING_QUEUE_G_DESTROY_FUNC, g_param_spec_pointer ("g-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_STRINGS | G_PARAM_READWRITE | G_PARAM_CONSTRUCT_ONLY));
#line 1178 "nonblocking-queue.c"
	/** Returns the number of items currently in the queue. */
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_NONBLOCKING_QUEUE_SIZE_PROPERTY, geary_nonblocking_queue_properties[GEARY_NONBLOCKING_QUEUE_SIZE_PROPERTY] = g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1182 "nonblocking-queue.c"
	/** Determines if any items are in the queue. */
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_NONBLOCKING_QUEUE_IS_EMPTY_PROPERTY, geary_nonblocking_queue_properties[GEARY_NONBLOCKING_QUEUE_IS_EMPTY_PROPERTY] = g_param_spec_boolean ("is-empty", "is-empty", "is-empty", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1186 "nonblocking-queue.c"
	/**
	     * Determines if duplicate items can be added to the queue.
	     *
	     * If a priory queue, this applies to items of the same priority,
	     * otherwise uses the item's natural identity.
	     */
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_NONBLOCKING_QUEUE_ALLOW_DUPLICATES_PROPERTY, geary_nonblocking_queue_properties[GEARY_NONBLOCKING_QUEUE_ALLOW_DUPLICATES_PROPERTY] = g_param_spec_boolean ("allow-duplicates", "allow-duplicates", "allow-duplicates", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1195 "nonblocking-queue.c"
	/**
	     * Determines if duplicate items will be added to the queue.
	     *
	     * If {@link allow_duplicates} is `true` and an item is already in
	     * the queue, this determines if it will be added again.
	     */
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_NONBLOCKING_QUEUE_REQUEUE_DUPLICATE_PROPERTY, geary_nonblocking_queue_properties[GEARY_NONBLOCKING_QUEUE_REQUEUE_DUPLICATE_PROPERTY] = g_param_spec_boolean ("requeue-duplicate", "requeue-duplicate", "requeue-duplicate", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1204 "nonblocking-queue.c"
	/**
	     * Determines if the queue is currently running.
	     */
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_NONBLOCKING_QUEUE_IS_PAUSED_PROPERTY, geary_nonblocking_queue_properties[GEARY_NONBLOCKING_QUEUE_IS_PAUSED_PROPERTY] = g_param_spec_boolean ("is-paused", "is-paused", "is-paused", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1210 "nonblocking-queue.c"
}

static void
geary_nonblocking_queue_instance_init (GearyNonblockingQueue * self,
                                       gpointer klass)
{
	GearyNonblockingSpinlock* _tmp0_;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	self->priv = geary_nonblocking_queue_get_instance_private (self);
#line 33 "../src/engine/nonblocking/nonblocking-queue.vala"
	self->priv->_allow_duplicates = TRUE;
#line 41 "../src/engine/nonblocking/nonblocking-queue.vala"
	self->priv->_requeue_duplicate = FALSE;
#line 57 "../src/engine/nonblocking/nonblocking-queue.vala"
	self->priv->_is_paused = FALSE;
#line 60 "../src/engine/nonblocking/nonblocking-queue.vala"
	_tmp0_ = geary_nonblocking_spinlock_new (NULL);
#line 60 "../src/engine/nonblocking/nonblocking-queue.vala"
	self->priv->spinlock = _tmp0_;
#line 1230 "nonblocking-queue.c"
}

static void
geary_nonblocking_queue_finalize (GObject * obj)
{
	GearyNonblockingQueue * self;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_NONBLOCKING_TYPE_QUEUE, GearyNonblockingQueue);
#line 59 "../src/engine/nonblocking/nonblocking-queue.vala"
	_g_object_unref0 (self->priv->queue);
#line 60 "../src/engine/nonblocking/nonblocking-queue.vala"
	_g_object_unref0 (self->priv->spinlock);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	G_OBJECT_CLASS (geary_nonblocking_queue_parent_class)->finalize (obj);
#line 1245 "nonblocking-queue.c"
}

/**
 * An asynchronous queue, first-in first-out (FIFO) or priority.
 *
 * This class can be used to asynchronously wait for items to be added
 * to the queue, the asynchronous call blocking until an item is
 * ready. Multiple asynchronous tasks can queue objects via {@link
 * send}, and tasks can wait for items via {@link receive}. If there
 * are multiple tasks waiting for items, the first to wait will
 * receive the next item.
 */
 G_GNUC_NO_INLINE static GType
geary_nonblocking_queue_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyNonblockingQueueClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_nonblocking_queue_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyNonblockingQueue), 0, (GInstanceInitFunc) geary_nonblocking_queue_instance_init, NULL };
	GType geary_nonblocking_queue_type_id;
	geary_nonblocking_queue_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyNonblockingQueue", &g_define_type_info, 0);
	GearyNonblockingQueue_private_offset = g_type_add_instance_private (geary_nonblocking_queue_type_id, sizeof (GearyNonblockingQueuePrivate));
	return geary_nonblocking_queue_type_id;
}

GType
geary_nonblocking_queue_get_type (void)
{
	static gsize geary_nonblocking_queue_type_id__once = 0;
	if (g_once_init_enter (&geary_nonblocking_queue_type_id__once)) {
		GType geary_nonblocking_queue_type_id;
		geary_nonblocking_queue_type_id = geary_nonblocking_queue_get_type_once ();
		g_once_init_leave (&geary_nonblocking_queue_type_id__once, geary_nonblocking_queue_type_id);
	}
	return geary_nonblocking_queue_type_id__once;
}

static void
_vala_geary_nonblocking_queue_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	GearyNonblockingQueue * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_NONBLOCKING_TYPE_QUEUE, GearyNonblockingQueue);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	switch (property_id) {
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		case GEARY_NONBLOCKING_QUEUE_SIZE_PROPERTY:
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		g_value_set_int (value, geary_nonblocking_queue_get_size (self));
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		break;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		case GEARY_NONBLOCKING_QUEUE_IS_EMPTY_PROPERTY:
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		g_value_set_boolean (value, geary_nonblocking_queue_get_is_empty (self));
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		break;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		case GEARY_NONBLOCKING_QUEUE_ALLOW_DUPLICATES_PROPERTY:
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		g_value_set_boolean (value, geary_nonblocking_queue_get_allow_duplicates (self));
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		break;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		case GEARY_NONBLOCKING_QUEUE_REQUEUE_DUPLICATE_PROPERTY:
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		g_value_set_boolean (value, geary_nonblocking_queue_get_requeue_duplicate (self));
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		break;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		case GEARY_NONBLOCKING_QUEUE_IS_PAUSED_PROPERTY:
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		g_value_set_boolean (value, geary_nonblocking_queue_get_is_paused (self));
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		break;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		case GEARY_NONBLOCKING_QUEUE_G_TYPE:
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		g_value_set_gtype (value, self->priv->g_type);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		break;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		case GEARY_NONBLOCKING_QUEUE_G_DUP_FUNC:
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		g_value_set_pointer (value, self->priv->g_dup_func);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		break;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		case GEARY_NONBLOCKING_QUEUE_G_DESTROY_FUNC:
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		g_value_set_pointer (value, self->priv->g_destroy_func);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		break;
#line 1338 "nonblocking-queue.c"
		default:
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		break;
#line 1344 "nonblocking-queue.c"
	}
}

static void
_vala_geary_nonblocking_queue_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	GearyNonblockingQueue * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_NONBLOCKING_TYPE_QUEUE, GearyNonblockingQueue);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
	switch (property_id) {
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		case GEARY_NONBLOCKING_QUEUE_ALLOW_DUPLICATES_PROPERTY:
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		geary_nonblocking_queue_set_allow_duplicates (self, g_value_get_boolean (value));
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		break;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		case GEARY_NONBLOCKING_QUEUE_REQUEUE_DUPLICATE_PROPERTY:
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		geary_nonblocking_queue_set_requeue_duplicate (self, g_value_get_boolean (value));
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		break;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		case GEARY_NONBLOCKING_QUEUE_IS_PAUSED_PROPERTY:
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		geary_nonblocking_queue_set_is_paused (self, g_value_get_boolean (value));
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		break;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		case GEARY_NONBLOCKING_QUEUE_G_TYPE:
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		self->priv->g_type = g_value_get_gtype (value);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		break;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		case GEARY_NONBLOCKING_QUEUE_G_DUP_FUNC:
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		self->priv->g_dup_func = g_value_get_pointer (value);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		break;
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		case GEARY_NONBLOCKING_QUEUE_G_DESTROY_FUNC:
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		self->priv->g_destroy_func = g_value_get_pointer (value);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		break;
#line 1394 "nonblocking-queue.c"
		default:
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/engine/nonblocking/nonblocking-queue.vala"
		break;
#line 1400 "nonblocking-queue.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

