/* smtp-authenticator.c generated by valac 0.56.17, the Vala compiler
 * generated from smtp-authenticator.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_SMTP_AUTHENTICATOR_0_PROPERTY,
	GEARY_SMTP_AUTHENTICATOR_NAME_PROPERTY,
	GEARY_SMTP_AUTHENTICATOR_CREDENTIALS_PROPERTY,
	GEARY_SMTP_AUTHENTICATOR_NUM_PROPERTIES
};
static GParamSpec* geary_smtp_authenticator_properties[GEARY_SMTP_AUTHENTICATOR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _GearySmtpAuthenticatorPrivate {
	gchar* _name;
	GearyCredentials* _credentials;
};

static gint GearySmtpAuthenticator_private_offset;
static gpointer geary_smtp_authenticator_parent_class = NULL;

static void geary_smtp_authenticator_set_name (GearySmtpAuthenticator* self,
                                        const gchar* value);
static void geary_smtp_authenticator_set_credentials (GearySmtpAuthenticator* self,
                                               GearyCredentials* value);
static GearySmtpRequest* geary_smtp_authenticator_real_initiate (GearySmtpAuthenticator* self);
static GearyMemoryBuffer* geary_smtp_authenticator_real_challenge (GearySmtpAuthenticator* self,
                                                            gint step,
                                                            GearySmtpResponse* response,
                                                            GError** error);
static gchar* geary_smtp_authenticator_real_to_string (GearySmtpAuthenticator* self);
static void geary_smtp_authenticator_finalize (GObject * obj);
static GType geary_smtp_authenticator_get_type_once (void);
static void _vala_geary_smtp_authenticator_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_geary_smtp_authenticator_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);

static inline gpointer
geary_smtp_authenticator_get_instance_private (GearySmtpAuthenticator* self)
{
	return G_STRUCT_MEMBER_P (self, GearySmtpAuthenticator_private_offset);
}

const gchar*
geary_smtp_authenticator_get_name (GearySmtpAuthenticator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 17 "../src/engine/smtp/smtp-authenticator.vala"
	g_return_val_if_fail (GEARY_SMTP_IS_AUTHENTICATOR (self), NULL);
#line 17 "../src/engine/smtp/smtp-authenticator.vala"
	_tmp0_ = self->priv->_name;
#line 17 "../src/engine/smtp/smtp-authenticator.vala"
	result = _tmp0_;
#line 17 "../src/engine/smtp/smtp-authenticator.vala"
	return result;
#line 84 "smtp-authenticator.c"
}

static void
geary_smtp_authenticator_set_name (GearySmtpAuthenticator* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 17 "../src/engine/smtp/smtp-authenticator.vala"
	g_return_if_fail (GEARY_SMTP_IS_AUTHENTICATOR (self));
#line 17 "../src/engine/smtp/smtp-authenticator.vala"
	old_value = geary_smtp_authenticator_get_name (self);
#line 17 "../src/engine/smtp/smtp-authenticator.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 98 "smtp-authenticator.c"
		gchar* _tmp0_;
#line 17 "../src/engine/smtp/smtp-authenticator.vala"
		_tmp0_ = g_strdup (value);
#line 17 "../src/engine/smtp/smtp-authenticator.vala"
		_g_free0 (self->priv->_name);
#line 17 "../src/engine/smtp/smtp-authenticator.vala"
		self->priv->_name = _tmp0_;
#line 17 "../src/engine/smtp/smtp-authenticator.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_smtp_authenticator_properties[GEARY_SMTP_AUTHENTICATOR_NAME_PROPERTY]);
#line 108 "smtp-authenticator.c"
	}
}

GearyCredentials*
geary_smtp_authenticator_get_credentials (GearySmtpAuthenticator* self)
{
	GearyCredentials* result;
	GearyCredentials* _tmp0_;
#line 19 "../src/engine/smtp/smtp-authenticator.vala"
	g_return_val_if_fail (GEARY_SMTP_IS_AUTHENTICATOR (self), NULL);
#line 19 "../src/engine/smtp/smtp-authenticator.vala"
	_tmp0_ = self->priv->_credentials;
#line 19 "../src/engine/smtp/smtp-authenticator.vala"
	result = _tmp0_;
#line 19 "../src/engine/smtp/smtp-authenticator.vala"
	return result;
#line 125 "smtp-authenticator.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 19 "../src/engine/smtp/smtp-authenticator.vala"
	return self ? g_object_ref (self) : NULL;
#line 133 "smtp-authenticator.c"
}

static void
geary_smtp_authenticator_set_credentials (GearySmtpAuthenticator* self,
                                          GearyCredentials* value)
{
	GearyCredentials* old_value;
#line 19 "../src/engine/smtp/smtp-authenticator.vala"
	g_return_if_fail (GEARY_SMTP_IS_AUTHENTICATOR (self));
#line 19 "../src/engine/smtp/smtp-authenticator.vala"
	old_value = geary_smtp_authenticator_get_credentials (self);
#line 19 "../src/engine/smtp/smtp-authenticator.vala"
	if (old_value != value) {
#line 147 "smtp-authenticator.c"
		GearyCredentials* _tmp0_;
#line 19 "../src/engine/smtp/smtp-authenticator.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 19 "../src/engine/smtp/smtp-authenticator.vala"
		_g_object_unref0 (self->priv->_credentials);
#line 19 "../src/engine/smtp/smtp-authenticator.vala"
		self->priv->_credentials = _tmp0_;
#line 19 "../src/engine/smtp/smtp-authenticator.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_smtp_authenticator_properties[GEARY_SMTP_AUTHENTICATOR_CREDENTIALS_PROPERTY]);
#line 157 "smtp-authenticator.c"
	}
}

GearySmtpAuthenticator*
geary_smtp_authenticator_construct (GType object_type,
                                    const gchar* name,
                                    GearyCredentials* credentials)
{
	GearySmtpAuthenticator * self = NULL;
#line 21 "../src/engine/smtp/smtp-authenticator.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 21 "../src/engine/smtp/smtp-authenticator.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS (credentials), NULL);
#line 21 "../src/engine/smtp/smtp-authenticator.vala"
	self = (GearySmtpAuthenticator*) geary_base_object_construct (object_type);
#line 22 "../src/engine/smtp/smtp-authenticator.vala"
	geary_smtp_authenticator_set_name (self, name);
#line 23 "../src/engine/smtp/smtp-authenticator.vala"
	geary_smtp_authenticator_set_credentials (self, credentials);
#line 25 "../src/engine/smtp/smtp-authenticator.vala"
	if (!geary_credentials_is_complete (credentials)) {
#line 26 "../src/engine/smtp/smtp-authenticator.vala"
		g_message ("smtp-authenticator.vala:26: Incomplete credentials supplied to SMTP au" \
"thenticator %s", name);
#line 181 "smtp-authenticator.c"
	}
#line 21 "../src/engine/smtp/smtp-authenticator.vala"
	return self;
#line 185 "smtp-authenticator.c"
}

/**
     * Returns a Request that is used to initiate the challenge-response.
     */
static GearySmtpRequest*
geary_smtp_authenticator_real_initiate (GearySmtpAuthenticator* self)
{
#line 32 "../src/engine/smtp/smtp-authenticator.vala"
	g_critical ("Type `%s' does not implement abstract method `geary_smtp_authenticator_initiate'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 32 "../src/engine/smtp/smtp-authenticator.vala"
	return NULL;
#line 198 "smtp-authenticator.c"
}

GearySmtpRequest*
geary_smtp_authenticator_initiate (GearySmtpAuthenticator* self)
{
	GearySmtpAuthenticatorClass* _klass_;
#line 32 "../src/engine/smtp/smtp-authenticator.vala"
	g_return_val_if_fail (GEARY_SMTP_IS_AUTHENTICATOR (self), NULL);
#line 32 "../src/engine/smtp/smtp-authenticator.vala"
	_klass_ = GEARY_SMTP_AUTHENTICATOR_GET_CLASS (self);
#line 32 "../src/engine/smtp/smtp-authenticator.vala"
	if (_klass_->initiate) {
#line 32 "../src/engine/smtp/smtp-authenticator.vala"
		return _klass_->initiate (self);
#line 213 "smtp-authenticator.c"
	}
#line 32 "../src/engine/smtp/smtp-authenticator.vala"
	return NULL;
#line 217 "smtp-authenticator.c"
}

/**
     * Returns a block of data that will be sent for that stage of the authentication challenge.
     * No line terminators should be present.  Various authentication schemes may also have their
     * own requirements.
     *
     * step is the zero-based step number of the challenge-response.  Response is the *last*
     * SMTP response from the server from the prior step (or from the initiate() request).
     *
     * Returns null if the Authenticator chooses to end the process in an orderly fashion.
     *
     * If an error is thrown, the entire process is aborted without any further I/O with the
     * server.  Generally this leaves the connection in a bad state and should be closed.
     */
static GearyMemoryBuffer*
geary_smtp_authenticator_real_challenge (GearySmtpAuthenticator* self,
                                         gint step,
                                         GearySmtpResponse* response,
                                         GError** error)
{
#line 47 "../src/engine/smtp/smtp-authenticator.vala"
	g_critical ("Type `%s' does not implement abstract method `geary_smtp_authenticator_challenge'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 47 "../src/engine/smtp/smtp-authenticator.vala"
	return NULL;
#line 243 "smtp-authenticator.c"
}

GearyMemoryBuffer*
geary_smtp_authenticator_challenge (GearySmtpAuthenticator* self,
                                    gint step,
                                    GearySmtpResponse* response,
                                    GError** error)
{
	GearySmtpAuthenticatorClass* _klass_;
#line 47 "../src/engine/smtp/smtp-authenticator.vala"
	g_return_val_if_fail (GEARY_SMTP_IS_AUTHENTICATOR (self), NULL);
#line 47 "../src/engine/smtp/smtp-authenticator.vala"
	_klass_ = GEARY_SMTP_AUTHENTICATOR_GET_CLASS (self);
#line 47 "../src/engine/smtp/smtp-authenticator.vala"
	if (_klass_->challenge) {
#line 47 "../src/engine/smtp/smtp-authenticator.vala"
		return _klass_->challenge (self, step, response, error);
#line 261 "smtp-authenticator.c"
	}
#line 47 "../src/engine/smtp/smtp-authenticator.vala"
	return NULL;
#line 265 "smtp-authenticator.c"
}

static gchar*
geary_smtp_authenticator_real_to_string (GearySmtpAuthenticator* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 50 "../src/engine/smtp/smtp-authenticator.vala"
	_tmp0_ = self->priv->_name;
#line 50 "../src/engine/smtp/smtp-authenticator.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 50 "../src/engine/smtp/smtp-authenticator.vala"
	result = _tmp1_;
#line 50 "../src/engine/smtp/smtp-authenticator.vala"
	return result;
#line 282 "smtp-authenticator.c"
}

gchar*
geary_smtp_authenticator_to_string (GearySmtpAuthenticator* self)
{
	GearySmtpAuthenticatorClass* _klass_;
#line 49 "../src/engine/smtp/smtp-authenticator.vala"
	g_return_val_if_fail (GEARY_SMTP_IS_AUTHENTICATOR (self), NULL);
#line 49 "../src/engine/smtp/smtp-authenticator.vala"
	_klass_ = GEARY_SMTP_AUTHENTICATOR_GET_CLASS (self);
#line 49 "../src/engine/smtp/smtp-authenticator.vala"
	if (_klass_->to_string) {
#line 49 "../src/engine/smtp/smtp-authenticator.vala"
		return _klass_->to_string (self);
#line 297 "smtp-authenticator.c"
	}
#line 49 "../src/engine/smtp/smtp-authenticator.vala"
	return NULL;
#line 301 "smtp-authenticator.c"
}

static void
geary_smtp_authenticator_class_init (GearySmtpAuthenticatorClass * klass,
                                     gpointer klass_data)
{
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
	geary_smtp_authenticator_parent_class = g_type_class_peek_parent (klass);
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
	g_type_class_adjust_private_offset (klass, &GearySmtpAuthenticator_private_offset);
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
	((GearySmtpAuthenticatorClass *) klass)->initiate = (GearySmtpRequest* (*) (GearySmtpAuthenticator*)) geary_smtp_authenticator_real_initiate;
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
	((GearySmtpAuthenticatorClass *) klass)->challenge = (GearyMemoryBuffer* (*) (GearySmtpAuthenticator*, gint, GearySmtpResponse*, GError**)) geary_smtp_authenticator_real_challenge;
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
	((GearySmtpAuthenticatorClass *) klass)->to_string = (gchar* (*) (GearySmtpAuthenticator*)) geary_smtp_authenticator_real_to_string;
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_smtp_authenticator_get_property;
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_smtp_authenticator_set_property;
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_smtp_authenticator_finalize;
#line 324 "smtp-authenticator.c"
	/**
	     * The user-visible name for this {@link Authenticator}.
	     */
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SMTP_AUTHENTICATOR_NAME_PROPERTY, geary_smtp_authenticator_properties[GEARY_SMTP_AUTHENTICATOR_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SMTP_AUTHENTICATOR_CREDENTIALS_PROPERTY, geary_smtp_authenticator_properties[GEARY_SMTP_AUTHENTICATOR_CREDENTIALS_PROPERTY] = g_param_spec_object ("credentials", "credentials", "credentials", GEARY_TYPE_CREDENTIALS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 332 "smtp-authenticator.c"
}

static void
geary_smtp_authenticator_instance_init (GearySmtpAuthenticator * self,
                                        gpointer klass)
{
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
	self->priv = geary_smtp_authenticator_get_instance_private (self);
#line 341 "smtp-authenticator.c"
}

static void
geary_smtp_authenticator_finalize (GObject * obj)
{
	GearySmtpAuthenticator * self;
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_SMTP_TYPE_AUTHENTICATOR, GearySmtpAuthenticator);
#line 17 "../src/engine/smtp/smtp-authenticator.vala"
	_g_free0 (self->priv->_name);
#line 19 "../src/engine/smtp/smtp-authenticator.vala"
	_g_object_unref0 (self->priv->_credentials);
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
	G_OBJECT_CLASS (geary_smtp_authenticator_parent_class)->finalize (obj);
#line 356 "smtp-authenticator.c"
}

/**
 * An abstract class describing a process for going through an SASL authentication transaction.
 *
 * Authenticators expect to use complete {@link Credentials}, i.e. user and pass must not be null.
 */
 G_GNUC_NO_INLINE static GType
geary_smtp_authenticator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearySmtpAuthenticatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_smtp_authenticator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearySmtpAuthenticator), 0, (GInstanceInitFunc) geary_smtp_authenticator_instance_init, NULL };
	GType geary_smtp_authenticator_type_id;
	geary_smtp_authenticator_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearySmtpAuthenticator", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	GearySmtpAuthenticator_private_offset = g_type_add_instance_private (geary_smtp_authenticator_type_id, sizeof (GearySmtpAuthenticatorPrivate));
	return geary_smtp_authenticator_type_id;
}

GType
geary_smtp_authenticator_get_type (void)
{
	static gsize geary_smtp_authenticator_type_id__once = 0;
	if (g_once_init_enter (&geary_smtp_authenticator_type_id__once)) {
		GType geary_smtp_authenticator_type_id;
		geary_smtp_authenticator_type_id = geary_smtp_authenticator_get_type_once ();
		g_once_init_leave (&geary_smtp_authenticator_type_id__once, geary_smtp_authenticator_type_id);
	}
	return geary_smtp_authenticator_type_id__once;
}

static void
_vala_geary_smtp_authenticator_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	GearySmtpAuthenticator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_SMTP_TYPE_AUTHENTICATOR, GearySmtpAuthenticator);
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
	switch (property_id) {
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
		case GEARY_SMTP_AUTHENTICATOR_NAME_PROPERTY:
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
		g_value_set_string (value, geary_smtp_authenticator_get_name (self));
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
		break;
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
		case GEARY_SMTP_AUTHENTICATOR_CREDENTIALS_PROPERTY:
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
		g_value_set_object (value, geary_smtp_authenticator_get_credentials (self));
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
		break;
#line 408 "smtp-authenticator.c"
		default:
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
		break;
#line 414 "smtp-authenticator.c"
	}
}

static void
_vala_geary_smtp_authenticator_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	GearySmtpAuthenticator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_SMTP_TYPE_AUTHENTICATOR, GearySmtpAuthenticator);
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
	switch (property_id) {
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
		case GEARY_SMTP_AUTHENTICATOR_NAME_PROPERTY:
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
		geary_smtp_authenticator_set_name (self, g_value_get_string (value));
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
		break;
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
		case GEARY_SMTP_AUTHENTICATOR_CREDENTIALS_PROPERTY:
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
		geary_smtp_authenticator_set_credentials (self, g_value_get_object (value));
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
		break;
#line 440 "smtp-authenticator.c"
		default:
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 13 "../src/engine/smtp/smtp-authenticator.vala"
		break;
#line 446 "smtp-authenticator.c"
	}
}

