/* smtp-login-authenticator.c generated by valac 0.56.17, the Vala compiler
 * generated from smtp-login-authenticator.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_SMTP_LOGIN_AUTHENTICATOR_0_PROPERTY,
	GEARY_SMTP_LOGIN_AUTHENTICATOR_NUM_PROPERTIES
};
static GParamSpec* geary_smtp_login_authenticator_properties[GEARY_SMTP_LOGIN_AUTHENTICATOR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

static gpointer geary_smtp_login_authenticator_parent_class = NULL;

static GearySmtpRequest* geary_smtp_login_authenticator_real_initiate (GearySmtpAuthenticator* base);
static GearyMemoryBuffer* geary_smtp_login_authenticator_real_challenge (GearySmtpAuthenticator* base,
                                                                  gint step,
                                                                  GearySmtpResponse* response,
                                                                  GError** error);
static GType geary_smtp_login_authenticator_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

GearySmtpLoginAuthenticator*
geary_smtp_login_authenticator_construct (GType object_type,
                                          GearyCredentials* credentials)
{
	GearySmtpLoginAuthenticator * self = NULL;
#line 16 "../src/engine/smtp/smtp-login-authenticator.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS (credentials), NULL);
#line 17 "../src/engine/smtp/smtp-login-authenticator.vala"
	self = (GearySmtpLoginAuthenticator*) geary_smtp_authenticator_construct (object_type, "LOGIN", credentials);
#line 16 "../src/engine/smtp/smtp-login-authenticator.vala"
	return self;
#line 59 "smtp-login-authenticator.c"
}

GearySmtpLoginAuthenticator*
geary_smtp_login_authenticator_new (GearyCredentials* credentials)
{
#line 16 "../src/engine/smtp/smtp-login-authenticator.vala"
	return geary_smtp_login_authenticator_construct (GEARY_SMTP_TYPE_LOGIN_AUTHENTICATOR, credentials);
#line 67 "smtp-login-authenticator.c"
}

static GearySmtpRequest*
geary_smtp_login_authenticator_real_initiate (GearySmtpAuthenticator* base)
{
	GearySmtpLoginAuthenticator * self;
	gchar* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	GearySmtpRequest* _tmp3_;
	GearySmtpRequest* _tmp4_;
	GearySmtpRequest* result;
#line 20 "../src/engine/smtp/smtp-login-authenticator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_SMTP_TYPE_LOGIN_AUTHENTICATOR, GearySmtpLoginAuthenticator);
#line 21 "../src/engine/smtp/smtp-login-authenticator.vala"
	_tmp0_ = g_strdup ("login");
#line 21 "../src/engine/smtp/smtp-login-authenticator.vala"
	_tmp1_ = g_new0 (gchar*, 1 + 1);
#line 21 "../src/engine/smtp/smtp-login-authenticator.vala"
	_tmp1_[0] = _tmp0_;
#line 21 "../src/engine/smtp/smtp-login-authenticator.vala"
	_tmp2_ = _tmp1_;
#line 21 "../src/engine/smtp/smtp-login-authenticator.vala"
	_tmp2__length1 = 1;
#line 21 "../src/engine/smtp/smtp-login-authenticator.vala"
	_tmp3_ = geary_smtp_request_new (GEARY_SMTP_COMMAND_AUTH, _tmp2_, 1);
#line 21 "../src/engine/smtp/smtp-login-authenticator.vala"
	_tmp4_ = _tmp3_;
#line 21 "../src/engine/smtp/smtp-login-authenticator.vala"
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
#line 21 "../src/engine/smtp/smtp-login-authenticator.vala"
	result = _tmp4_;
#line 21 "../src/engine/smtp/smtp-login-authenticator.vala"
	return result;
#line 103 "smtp-login-authenticator.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 140 "smtp-login-authenticator.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 146 "smtp-login-authenticator.c"
}

static GearyMemoryBuffer*
geary_smtp_login_authenticator_real_challenge (GearySmtpAuthenticator* base,
                                               gint step,
                                               GearySmtpResponse* response,
                                               GError** error)
{
	GearySmtpLoginAuthenticator * self;
	GearyMemoryBuffer* result;
#line 24 "../src/engine/smtp/smtp-login-authenticator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_SMTP_TYPE_LOGIN_AUTHENTICATOR, GearySmtpLoginAuthenticator);
#line 24 "../src/engine/smtp/smtp-login-authenticator.vala"
	g_return_val_if_fail (GEARY_SMTP_IS_RESPONSE (response), NULL);
#line 25 "../src/engine/smtp/smtp-login-authenticator.vala"
	switch (step) {
#line 25 "../src/engine/smtp/smtp-login-authenticator.vala"
		case 0:
#line 165 "smtp-login-authenticator.c"
		{
			GearyCredentials* _tmp0_;
			GearyCredentials* _tmp1_;
			const gchar* _tmp2_;
			const gchar* _tmp3_;
			guint8* _tmp4_;
			gint _tmp4__length1;
			gint _tmp5_ = 0;
			guint8* _tmp6_;
			gint _tmp6__length1;
			gchar* _tmp7_;
			gchar* _tmp8_;
			GearyMemoryStringBuffer* _tmp9_;
			GearyMemoryBuffer* _tmp10_;
#line 27 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp0_ = geary_smtp_authenticator_get_credentials (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_SMTP_TYPE_AUTHENTICATOR, GearySmtpAuthenticator));
#line 27 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp1_ = _tmp0_;
#line 27 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp2_ = geary_credentials_get_user (_tmp1_);
#line 27 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp3_ = _tmp2_;
#line 27 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp4_ = string_get_data (_tmp3_, &_tmp5_);
#line 27 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp4__length1 = _tmp5_;
#line 27 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp6_ = _tmp4_;
#line 27 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp6__length1 = _tmp4__length1;
#line 27 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp7_ = g_base64_encode (_tmp6_, (gint) _tmp6__length1);
#line 27 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp8_ = _tmp7_;
#line 27 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp9_ = geary_memory_string_buffer_new (_tmp8_);
#line 27 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp10_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBuffer);
#line 27 "../src/engine/smtp/smtp-login-authenticator.vala"
			_g_free0 (_tmp8_);
#line 27 "../src/engine/smtp/smtp-login-authenticator.vala"
			result = _tmp10_;
#line 27 "../src/engine/smtp/smtp-login-authenticator.vala"
			return result;
#line 210 "smtp-login-authenticator.c"
		}
#line 25 "../src/engine/smtp/smtp-login-authenticator.vala"
		case 1:
#line 214 "smtp-login-authenticator.c"
		{
			const gchar* _tmp11_ = NULL;
			GearyCredentials* _tmp12_;
			GearyCredentials* _tmp13_;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
			guint8* _tmp16_;
			gint _tmp16__length1;
			gint _tmp17_ = 0;
			guint8* _tmp18_;
			gint _tmp18__length1;
			gchar* _tmp19_;
			gchar* _tmp20_;
			GearyMemoryStringBuffer* _tmp21_;
			GearyMemoryBuffer* _tmp22_;
#line 30 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp12_ = geary_smtp_authenticator_get_credentials (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_SMTP_TYPE_AUTHENTICATOR, GearySmtpAuthenticator));
#line 30 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp13_ = _tmp12_;
#line 30 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp14_ = geary_credentials_get_token (_tmp13_);
#line 30 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp15_ = _tmp14_;
#line 30 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp11_ = _tmp15_;
#line 30 "../src/engine/smtp/smtp-login-authenticator.vala"
			if (_tmp11_ == NULL) {
#line 30 "../src/engine/smtp/smtp-login-authenticator.vala"
				_tmp11_ = "";
#line 244 "smtp-login-authenticator.c"
			}
#line 30 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp16_ = string_get_data (_tmp11_, &_tmp17_);
#line 30 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp16__length1 = _tmp17_;
#line 30 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp18_ = _tmp16_;
#line 30 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp18__length1 = _tmp16__length1;
#line 30 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp19_ = g_base64_encode (_tmp18_, (gint) _tmp18__length1);
#line 30 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp20_ = _tmp19_;
#line 30 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp21_ = geary_memory_string_buffer_new (_tmp20_);
#line 30 "../src/engine/smtp/smtp-login-authenticator.vala"
			_tmp22_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBuffer);
#line 30 "../src/engine/smtp/smtp-login-authenticator.vala"
			_g_free0 (_tmp20_);
#line 30 "../src/engine/smtp/smtp-login-authenticator.vala"
			result = _tmp22_;
#line 30 "../src/engine/smtp/smtp-login-authenticator.vala"
			return result;
#line 268 "smtp-login-authenticator.c"
		}
		default:
		{
#line 33 "../src/engine/smtp/smtp-login-authenticator.vala"
			result = NULL;
#line 33 "../src/engine/smtp/smtp-login-authenticator.vala"
			return result;
#line 276 "smtp-login-authenticator.c"
		}
	}
}

static void
geary_smtp_login_authenticator_class_init (GearySmtpLoginAuthenticatorClass * klass,
                                           gpointer klass_data)
{
#line 15 "../src/engine/smtp/smtp-login-authenticator.vala"
	geary_smtp_login_authenticator_parent_class = g_type_class_peek_parent (klass);
#line 15 "../src/engine/smtp/smtp-login-authenticator.vala"
	((GearySmtpAuthenticatorClass *) klass)->initiate = (GearySmtpRequest* (*) (GearySmtpAuthenticator*)) geary_smtp_login_authenticator_real_initiate;
#line 15 "../src/engine/smtp/smtp-login-authenticator.vala"
	((GearySmtpAuthenticatorClass *) klass)->challenge = (GearyMemoryBuffer* (*) (GearySmtpAuthenticator*, gint, GearySmtpResponse*, GError**)) geary_smtp_login_authenticator_real_challenge;
#line 291 "smtp-login-authenticator.c"
}

static void
geary_smtp_login_authenticator_instance_init (GearySmtpLoginAuthenticator * self,
                                              gpointer klass)
{
}

/**
 * SASL's LOGIN authentication schema implemented as an {@link Authenticator}.
 *
 * LOGIN is obsolete but still widely in use and provided for backward compatibility.
 *
 * See [[https://tools.ietf.org/html/draft-murchison-sasl-login-00]]
 */
 G_GNUC_NO_INLINE static GType
geary_smtp_login_authenticator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearySmtpLoginAuthenticatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_smtp_login_authenticator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearySmtpLoginAuthenticator), 0, (GInstanceInitFunc) geary_smtp_login_authenticator_instance_init, NULL };
	GType geary_smtp_login_authenticator_type_id;
	geary_smtp_login_authenticator_type_id = g_type_register_static (GEARY_SMTP_TYPE_AUTHENTICATOR, "GearySmtpLoginAuthenticator", &g_define_type_info, 0);
	return geary_smtp_login_authenticator_type_id;
}

GType
geary_smtp_login_authenticator_get_type (void)
{
	static gsize geary_smtp_login_authenticator_type_id__once = 0;
	if (g_once_init_enter (&geary_smtp_login_authenticator_type_id__once)) {
		GType geary_smtp_login_authenticator_type_id;
		geary_smtp_login_authenticator_type_id = geary_smtp_login_authenticator_get_type_once ();
		g_once_init_leave (&geary_smtp_login_authenticator_type_id__once, geary_smtp_login_authenticator_type_id);
	}
	return geary_smtp_login_authenticator_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

