/* smtp-oauth2-authenticator.c generated by valac 0.56.17, the Vala compiler
 * generated from smtp-oauth2-authenticator.vala, do not modify */

/*
 * Copyright 2018 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>

#define GEARY_SMTP_OAUTH2_AUTHENTICATOR_OAUTH2_RESP "user=%s\001auth=Bearer %s\001\001"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_SMTP_OAUTH2_AUTHENTICATOR_0_PROPERTY,
	GEARY_SMTP_OAUTH2_AUTHENTICATOR_NUM_PROPERTIES
};
static GParamSpec* geary_smtp_oauth2_authenticator_properties[GEARY_SMTP_OAUTH2_AUTHENTICATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

static gpointer geary_smtp_oauth2_authenticator_parent_class = NULL;

static GearySmtpRequest* geary_smtp_oauth2_authenticator_real_initiate (GearySmtpAuthenticator* base);
static GearyMemoryBuffer* geary_smtp_oauth2_authenticator_real_challenge (GearySmtpAuthenticator* base,
                                                                   gint step,
                                                                   GearySmtpResponse* response,
                                                                   GError** error);
static GType geary_smtp_oauth2_authenticator_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

GearySmtpOAuth2Authenticator*
geary_smtp_oauth2_authenticator_construct (GType object_type,
                                           GearyCredentials* credentials)
{
	GearySmtpOAuth2Authenticator * self = NULL;
#line 20 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS (credentials), NULL);
#line 21 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
	self = (GearySmtpOAuth2Authenticator*) geary_smtp_authenticator_construct (object_type, "XOAUTH2", credentials);
#line 20 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
	return self;
#line 62 "smtp-oauth2-authenticator.c"
}

GearySmtpOAuth2Authenticator*
geary_smtp_oauth2_authenticator_new (GearyCredentials* credentials)
{
#line 20 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
	return geary_smtp_oauth2_authenticator_construct (GEARY_SMTP_TYPE_OAUTH2_AUTHENTICATOR, credentials);
#line 70 "smtp-oauth2-authenticator.c"
}

static GearySmtpRequest*
geary_smtp_oauth2_authenticator_real_initiate (GearySmtpAuthenticator* base)
{
	GearySmtpOAuth2Authenticator * self;
	gchar* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	GearySmtpRequest* _tmp3_;
	GearySmtpRequest* _tmp4_;
	GearySmtpRequest* result;
#line 24 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_SMTP_TYPE_OAUTH2_AUTHENTICATOR, GearySmtpOAuth2Authenticator);
#line 25 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
	_tmp0_ = g_strdup ("xoauth2");
#line 25 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
	_tmp1_ = g_new0 (gchar*, 1 + 1);
#line 25 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
	_tmp1_[0] = _tmp0_;
#line 25 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
	_tmp2_ = _tmp1_;
#line 25 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
	_tmp2__length1 = 1;
#line 25 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
	_tmp3_ = geary_smtp_request_new (GEARY_SMTP_COMMAND_AUTH, _tmp2_, 1);
#line 25 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
	_tmp4_ = _tmp3_;
#line 25 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
#line 25 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
	result = _tmp4_;
#line 25 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
	return result;
#line 106 "smtp-oauth2-authenticator.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 143 "smtp-oauth2-authenticator.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 149 "smtp-oauth2-authenticator.c"
}

static GearyMemoryBuffer*
geary_smtp_oauth2_authenticator_real_challenge (GearySmtpAuthenticator* base,
                                                gint step,
                                                GearySmtpResponse* response,
                                                GError** error)
{
	GearySmtpOAuth2Authenticator * self;
	GearyMemoryBuffer* buf = NULL;
	GearyMemoryBuffer* result;
#line 28 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_SMTP_TYPE_OAUTH2_AUTHENTICATOR, GearySmtpOAuth2Authenticator);
#line 28 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
	g_return_val_if_fail (GEARY_SMTP_IS_RESPONSE (response), NULL);
#line 30 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
	buf = NULL;
#line 31 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
	switch (step) {
#line 31 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
		case 0:
#line 171 "smtp-oauth2-authenticator.c"
		{
			const gchar* _tmp0_ = NULL;
			GearyCredentials* _tmp1_;
			GearyCredentials* _tmp2_;
			const gchar* _tmp3_;
			const gchar* _tmp4_;
			const gchar* _tmp5_ = NULL;
			GearyCredentials* _tmp6_;
			GearyCredentials* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			guint8* _tmp12_;
			gint _tmp12__length1;
			gint _tmp13_ = 0;
			guint8* _tmp14_;
			gint _tmp14__length1;
			gchar* _tmp15_;
			gchar* _tmp16_;
			GearyMemoryStringBuffer* _tmp17_;
#line 37 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			_tmp1_ = geary_smtp_authenticator_get_credentials (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_SMTP_TYPE_AUTHENTICATOR, GearySmtpAuthenticator));
#line 37 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			_tmp2_ = _tmp1_;
#line 37 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			_tmp3_ = geary_credentials_get_user (_tmp2_);
#line 37 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			_tmp4_ = _tmp3_;
#line 37 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			_tmp0_ = _tmp4_;
#line 37 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			if (_tmp0_ == NULL) {
#line 37 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
				_tmp0_ = "";
#line 207 "smtp-oauth2-authenticator.c"
			}
#line 38 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			_tmp6_ = geary_smtp_authenticator_get_credentials (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_SMTP_TYPE_AUTHENTICATOR, GearySmtpAuthenticator));
#line 38 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			_tmp7_ = _tmp6_;
#line 38 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			_tmp8_ = geary_credentials_get_token (_tmp7_);
#line 38 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			_tmp9_ = _tmp8_;
#line 38 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			_tmp5_ = _tmp9_;
#line 38 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			if (_tmp5_ == NULL) {
#line 38 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
				_tmp5_ = "";
#line 223 "smtp-oauth2-authenticator.c"
			}
#line 34 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			_tmp10_ = g_strdup_printf (GEARY_SMTP_OAUTH2_AUTHENTICATOR_OAUTH2_RESP, _tmp0_, _tmp5_);
#line 34 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			_tmp11_ = _tmp10_;
#line 34 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			_tmp12_ = string_get_data (_tmp11_, &_tmp13_);
#line 34 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			_tmp12__length1 = _tmp13_;
#line 34 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			_tmp14_ = _tmp12_;
#line 34 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			_tmp14__length1 = _tmp12__length1;
#line 34 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			_tmp15_ = g_base64_encode (_tmp14_, (gint) _tmp14__length1);
#line 34 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			_tmp16_ = _tmp15_;
#line 34 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			_tmp17_ = geary_memory_string_buffer_new (_tmp16_);
#line 34 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			_g_object_unref0 (buf);
#line 34 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			buf = G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBuffer);
#line 34 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			_g_free0 (_tmp16_);
#line 34 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			_g_free0 (_tmp11_);
#line 42 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			break;
#line 253 "smtp-oauth2-authenticator.c"
		}
#line 31 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
		case 1:
#line 257 "smtp-oauth2-authenticator.c"
		{
			GearyMemoryStringBuffer* _tmp18_;
#line 50 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			_tmp18_ = geary_memory_string_buffer_new ("");
#line 50 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			_g_object_unref0 (buf);
#line 50 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			buf = G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBuffer);
#line 51 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
			break;
#line 268 "smtp-oauth2-authenticator.c"
		}
		default:
#line 31 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
		break;
#line 273 "smtp-oauth2-authenticator.c"
	}
#line 53 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
	result = buf;
#line 53 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
	return result;
#line 279 "smtp-oauth2-authenticator.c"
}

static void
geary_smtp_oauth2_authenticator_class_init (GearySmtpOAuth2AuthenticatorClass * klass,
                                            gpointer klass_data)
{
#line 14 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
	geary_smtp_oauth2_authenticator_parent_class = g_type_class_peek_parent (klass);
#line 14 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
	((GearySmtpAuthenticatorClass *) klass)->initiate = (GearySmtpRequest* (*) (GearySmtpAuthenticator*)) geary_smtp_oauth2_authenticator_real_initiate;
#line 14 "../src/engine/smtp/smtp-oauth2-authenticator.vala"
	((GearySmtpAuthenticatorClass *) klass)->challenge = (GearyMemoryBuffer* (*) (GearySmtpAuthenticator*, gint, GearySmtpResponse*, GError**)) geary_smtp_oauth2_authenticator_real_challenge;
#line 292 "smtp-oauth2-authenticator.c"
}

static void
geary_smtp_oauth2_authenticator_instance_init (GearySmtpOAuth2Authenticator * self,
                                               gpointer klass)
{
}

/**
 * Google's proprietary OAuth 2 authentication.
 *
 * See [[http://tools.ietf.org/html/rfc4616]]
 */
 G_GNUC_NO_INLINE static GType
geary_smtp_oauth2_authenticator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearySmtpOAuth2AuthenticatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_smtp_oauth2_authenticator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearySmtpOAuth2Authenticator), 0, (GInstanceInitFunc) geary_smtp_oauth2_authenticator_instance_init, NULL };
	GType geary_smtp_oauth2_authenticator_type_id;
	geary_smtp_oauth2_authenticator_type_id = g_type_register_static (GEARY_SMTP_TYPE_AUTHENTICATOR, "GearySmtpOAuth2Authenticator", &g_define_type_info, 0);
	return geary_smtp_oauth2_authenticator_type_id;
}

GType
geary_smtp_oauth2_authenticator_get_type (void)
{
	static gsize geary_smtp_oauth2_authenticator_type_id__once = 0;
	if (g_once_init_enter (&geary_smtp_oauth2_authenticator_type_id__once)) {
		GType geary_smtp_oauth2_authenticator_type_id;
		geary_smtp_oauth2_authenticator_type_id = geary_smtp_oauth2_authenticator_get_type_once ();
		g_once_init_leave (&geary_smtp_oauth2_authenticator_type_id__once, geary_smtp_oauth2_authenticator_type_id);
	}
	return geary_smtp_oauth2_authenticator_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

