/* util-collection.c generated by valac 0.56.17, the Vala compiler
 * generated from util-collection.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib-object.h>
#include <gee.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

/** Returns a modifiable collection containing a single element. */
GeeCollection*
geary_collection_single (GType t_type,
                         GBoxedCopyFunc t_dup_func,
                         GDestroyNotify t_destroy_func,
                         gconstpointer element)
{
	GeeCollection* single = NULL;
	GeeLinkedList* _tmp0_;
	GeeCollection* result;
#line 14 "../src/engine/util/util-collection.vala"
	_tmp0_ = gee_linked_list_new (t_type, (GBoxedCopyFunc) t_dup_func, (GDestroyNotify) t_destroy_func, NULL, NULL, NULL);
#line 14 "../src/engine/util/util-collection.vala"
	single = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection);
#line 15 "../src/engine/util/util-collection.vala"
	gee_collection_add (single, element);
#line 16 "../src/engine/util/util-collection.vala"
	result = single;
#line 16 "../src/engine/util/util-collection.vala"
	return result;
#line 47 "util-collection.c"
}

/** Returns a modifiable map containing a single entry. */
GeeMap*
geary_collection_single_map (GType k_type,
                             GBoxedCopyFunc k_dup_func,
                             GDestroyNotify k_destroy_func,
                             GType v_type,
                             GBoxedCopyFunc v_dup_func,
                             GDestroyNotify v_destroy_func,
                             gconstpointer key,
                             gconstpointer value)
{
	GeeMap* single = NULL;
	GeeHashMap* _tmp0_;
	GeeMap* result;
#line 21 "../src/engine/util/util-collection.vala"
	_tmp0_ = gee_hash_map_new (k_type, (GBoxedCopyFunc) k_dup_func, (GDestroyNotify) k_destroy_func, v_type, (GBoxedCopyFunc) v_dup_func, (GDestroyNotify) v_destroy_func, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 21 "../src/engine/util/util-collection.vala"
	single = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_MAP, GeeMap);
#line 22 "../src/engine/util/util-collection.vala"
	gee_map_set (single, key, value);
#line 23 "../src/engine/util/util-collection.vala"
	result = single;
#line 23 "../src/engine/util/util-collection.vala"
	return result;
#line 74 "util-collection.c"
}

/** Returns a copy of the given collection in a new collection. */
GeeCollection*
geary_collection_copy (GType v_type,
                       GBoxedCopyFunc v_dup_func,
                       GDestroyNotify v_destroy_func,
                       GeeCollection* original)
{
	GeeLinkedList* copy = NULL;
	GeeLinkedList* _tmp0_;
	GeeCollection* result;
#line 27 "../src/engine/util/util-collection.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (original, GEE_TYPE_COLLECTION), NULL);
#line 30 "../src/engine/util/util-collection.vala"
	_tmp0_ = gee_linked_list_new (v_type, (GBoxedCopyFunc) v_dup_func, (GDestroyNotify) v_destroy_func, NULL, NULL, NULL);
#line 30 "../src/engine/util/util-collection.vala"
	copy = _tmp0_;
#line 31 "../src/engine/util/util-collection.vala"
	gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (copy, GEE_TYPE_COLLECTION, GeeCollection), original);
#line 32 "../src/engine/util/util-collection.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (copy, GEE_TYPE_COLLECTION, GeeCollection);
#line 32 "../src/engine/util/util-collection.vala"
	return result;
#line 99 "util-collection.c"
}

/** Returns the first element from a collection. */
gpointer
geary_collection_first (GType g_type,
                        GBoxedCopyFunc g_dup_func,
                        GDestroyNotify g_destroy_func,
                        GeeCollection* c)
{
	GeeIterator* iter = NULL;
	GeeIterator* _tmp0_;
	gpointer _tmp1_ = NULL;
	GeeIterator* _tmp2_;
	gpointer result;
#line 36 "../src/engine/util/util-collection.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (c, GEE_TYPE_COLLECTION), NULL);
#line 37 "../src/engine/util/util-collection.vala"
	_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (c, GEE_TYPE_ITERABLE, GeeIterable));
#line 37 "../src/engine/util/util-collection.vala"
	iter = _tmp0_;
#line 38 "../src/engine/util/util-collection.vala"
	_tmp2_ = iter;
#line 38 "../src/engine/util/util-collection.vala"
	if (gee_iterator_next (_tmp2_)) {
#line 124 "util-collection.c"
		GeeIterator* _tmp3_;
		gpointer _tmp4_;
#line 38 "../src/engine/util/util-collection.vala"
		_tmp3_ = iter;
#line 38 "../src/engine/util/util-collection.vala"
		_tmp4_ = gee_iterator_get (_tmp3_);
#line 38 "../src/engine/util/util-collection.vala"
		((_tmp1_ == NULL) || (g_destroy_func == NULL)) ? NULL : (_tmp1_ = (g_destroy_func (_tmp1_), NULL));
#line 38 "../src/engine/util/util-collection.vala"
		_tmp1_ = _tmp4_;
#line 135 "util-collection.c"
	} else {
#line 38 "../src/engine/util/util-collection.vala"
		((_tmp1_ == NULL) || (g_destroy_func == NULL)) ? NULL : (_tmp1_ = (g_destroy_func (_tmp1_), NULL));
#line 38 "../src/engine/util/util-collection.vala"
		_tmp1_ = NULL;
#line 141 "util-collection.c"
	}
#line 38 "../src/engine/util/util-collection.vala"
	result = _tmp1_;
#line 38 "../src/engine/util/util-collection.vala"
	_g_object_unref0 (iter);
#line 38 "../src/engine/util/util-collection.vala"
	return result;
#line 149 "util-collection.c"
}

/**
     * Removes all elements that pass the given predicate.
     *
     * Note that this modifies the supplied Collection.
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 54 "../src/engine/util/util-collection.vala"
	return self ? g_object_ref (self) : NULL;
#line 162 "util-collection.c"
}

GeeCollection*
geary_collection_remove_if (GType g_type,
                            GBoxedCopyFunc g_dup_func,
                            GDestroyNotify g_destroy_func,
                            GeeCollection* c,
                            GeePredicate pred,
                            gpointer pred_target,
                            GDestroyNotify pred_target_destroy_notify)
{
	GeeIterator* iter = NULL;
	GeeIterator* _tmp0_;
	GeeCollection* _tmp7_;
	GeeCollection* result;
#line 46 "../src/engine/util/util-collection.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (c, GEE_TYPE_COLLECTION), NULL);
#line 48 "../src/engine/util/util-collection.vala"
	_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (c, GEE_TYPE_ITERABLE, GeeIterable));
#line 48 "../src/engine/util/util-collection.vala"
	iter = _tmp0_;
#line 49 "../src/engine/util/util-collection.vala"
	while (TRUE) {
#line 186 "util-collection.c"
		GeeIterator* _tmp1_;
		GeeIterator* _tmp2_;
		gpointer _tmp3_;
		gpointer _tmp4_;
		gboolean _tmp5_;
#line 49 "../src/engine/util/util-collection.vala"
		_tmp1_ = iter;
#line 49 "../src/engine/util/util-collection.vala"
		if (!gee_iterator_next (_tmp1_)) {
#line 49 "../src/engine/util/util-collection.vala"
			break;
#line 198 "util-collection.c"
		}
#line 50 "../src/engine/util/util-collection.vala"
		_tmp2_ = iter;
#line 50 "../src/engine/util/util-collection.vala"
		_tmp3_ = gee_iterator_get (_tmp2_);
#line 50 "../src/engine/util/util-collection.vala"
		_tmp4_ = _tmp3_;
#line 50 "../src/engine/util/util-collection.vala"
		_tmp5_ = pred (_tmp4_, pred_target);
#line 50 "../src/engine/util/util-collection.vala"
		((_tmp4_ == NULL) || (g_destroy_func == NULL)) ? NULL : (_tmp4_ = (g_destroy_func (_tmp4_), NULL));
#line 50 "../src/engine/util/util-collection.vala"
		if (_tmp5_) {
#line 212 "util-collection.c"
			GeeIterator* _tmp6_;
#line 51 "../src/engine/util/util-collection.vala"
			_tmp6_ = iter;
#line 51 "../src/engine/util/util-collection.vala"
			gee_iterator_remove (_tmp6_);
#line 218 "util-collection.c"
		}
	}
#line 54 "../src/engine/util/util-collection.vala"
	_tmp7_ = _g_object_ref0 (c);
#line 54 "../src/engine/util/util-collection.vala"
	result = _tmp7_;
#line 54 "../src/engine/util/util-collection.vala"
	_g_object_unref0 (iter);
#line 54 "../src/engine/util/util-collection.vala"
	(pred_target_destroy_notify == NULL) ? NULL : (pred_target_destroy_notify (pred_target), NULL);
#line 54 "../src/engine/util/util-collection.vala"
	pred = NULL;
#line 54 "../src/engine/util/util-collection.vala"
	pred_target = NULL;
#line 54 "../src/engine/util/util-collection.vala"
	pred_target_destroy_notify = NULL;
#line 54 "../src/engine/util/util-collection.vala"
	return result;
#line 237 "util-collection.c"
}

/**
     * Sets the dest Map with all keys and values in src.
     */
void
geary_collection_map_set_all (GType k_type,
                              GBoxedCopyFunc k_dup_func,
                              GDestroyNotify k_destroy_func,
                              GType v_type,
                              GBoxedCopyFunc v_dup_func,
                              GDestroyNotify v_destroy_func,
                              GeeMap* dest,
                              GeeMap* src)
{
#line 60 "../src/engine/util/util-collection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dest, GEE_TYPE_MAP));
#line 60 "../src/engine/util/util-collection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (src, GEE_TYPE_MAP));
#line 257 "util-collection.c"
	{
		GeeIterator* _key_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 61 "../src/engine/util/util-collection.vala"
		_tmp0_ = gee_map_get_keys (src);
#line 61 "../src/engine/util/util-collection.vala"
		_tmp1_ = _tmp0_;
#line 61 "../src/engine/util/util-collection.vala"
		_tmp2_ = _tmp1_;
#line 61 "../src/engine/util/util-collection.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 61 "../src/engine/util/util-collection.vala"
		_tmp4_ = _tmp3_;
#line 61 "../src/engine/util/util-collection.vala"
		_g_object_unref0 (_tmp2_);
#line 61 "../src/engine/util/util-collection.vala"
		_key_it = _tmp4_;
#line 61 "../src/engine/util/util-collection.vala"
		while (TRUE) {
#line 281 "util-collection.c"
			GeeIterator* _tmp5_;
			gpointer key = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			gconstpointer _tmp8_;
			gconstpointer _tmp9_;
			gpointer _tmp10_;
			gpointer _tmp11_;
#line 61 "../src/engine/util/util-collection.vala"
			_tmp5_ = _key_it;
#line 61 "../src/engine/util/util-collection.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 61 "../src/engine/util/util-collection.vala"
				break;
#line 296 "util-collection.c"
			}
#line 61 "../src/engine/util/util-collection.vala"
			_tmp6_ = _key_it;
#line 61 "../src/engine/util/util-collection.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 61 "../src/engine/util/util-collection.vala"
			key = _tmp7_;
#line 62 "../src/engine/util/util-collection.vala"
			_tmp8_ = key;
#line 62 "../src/engine/util/util-collection.vala"
			_tmp9_ = key;
#line 62 "../src/engine/util/util-collection.vala"
			_tmp10_ = gee_map_get (src, _tmp9_);
#line 62 "../src/engine/util/util-collection.vala"
			_tmp11_ = _tmp10_;
#line 62 "../src/engine/util/util-collection.vala"
			gee_map_set (dest, _tmp8_, _tmp11_);
#line 62 "../src/engine/util/util-collection.vala"
			((_tmp11_ == NULL) || (v_destroy_func == NULL)) ? NULL : (_tmp11_ = (v_destroy_func (_tmp11_), NULL));
#line 61 "../src/engine/util/util-collection.vala"
			((key == NULL) || (k_destroy_func == NULL)) ? NULL : (key = (k_destroy_func (key), NULL));
#line 318 "util-collection.c"
		}
#line 61 "../src/engine/util/util-collection.vala"
		_g_object_unref0 (_key_it);
#line 322 "util-collection.c"
	}
}

/**
     * Sets multiple elements with the same key in a MultiMap.
     */
void
geary_collection_multi_map_set_all (GType k_type,
                                    GBoxedCopyFunc k_dup_func,
                                    GDestroyNotify k_destroy_func,
                                    GType v_type,
                                    GBoxedCopyFunc v_dup_func,
                                    GDestroyNotify v_destroy_func,
                                    GeeMultiMap* dest,
                                    gconstpointer key,
                                    GeeCollection* values)
{
#line 69 "../src/engine/util/util-collection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dest, GEE_TYPE_MULTI_MAP));
#line 69 "../src/engine/util/util-collection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (values, GEE_TYPE_COLLECTION));
#line 344 "util-collection.c"
	{
		GeeIterator* _value_it = NULL;
		GeeIterator* _tmp0_;
#line 70 "../src/engine/util/util-collection.vala"
		_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (values, GEE_TYPE_ITERABLE, GeeIterable));
#line 70 "../src/engine/util/util-collection.vala"
		_value_it = _tmp0_;
#line 70 "../src/engine/util/util-collection.vala"
		while (TRUE) {
#line 354 "util-collection.c"
			GeeIterator* _tmp1_;
			gpointer value = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			gconstpointer _tmp4_;
#line 70 "../src/engine/util/util-collection.vala"
			_tmp1_ = _value_it;
#line 70 "../src/engine/util/util-collection.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 70 "../src/engine/util/util-collection.vala"
				break;
#line 366 "util-collection.c"
			}
#line 70 "../src/engine/util/util-collection.vala"
			_tmp2_ = _value_it;
#line 70 "../src/engine/util/util-collection.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 70 "../src/engine/util/util-collection.vala"
			value = _tmp3_;
#line 71 "../src/engine/util/util-collection.vala"
			_tmp4_ = value;
#line 71 "../src/engine/util/util-collection.vala"
			gee_multi_map_set (dest, key, _tmp4_);
#line 70 "../src/engine/util/util-collection.vala"
			((value == NULL) || (v_destroy_func == NULL)) ? NULL : (value = (v_destroy_func (value), NULL));
#line 380 "util-collection.c"
		}
#line 70 "../src/engine/util/util-collection.vala"
		_g_object_unref0 (_value_it);
#line 384 "util-collection.c"
	}
}

/**
     * Removes all keys from the Map.
     */
void
geary_collection_map_unset_all_keys (GType k_type,
                                     GBoxedCopyFunc k_dup_func,
                                     GDestroyNotify k_destroy_func,
                                     GType v_type,
                                     GBoxedCopyFunc v_dup_func,
                                     GDestroyNotify v_destroy_func,
                                     GeeMap* map,
                                     GeeCollection* keys)
{
#line 78 "../src/engine/util/util-collection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (map, GEE_TYPE_MAP));
#line 78 "../src/engine/util/util-collection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (keys, GEE_TYPE_COLLECTION));
#line 405 "util-collection.c"
	{
		GeeIterator* _key_it = NULL;
		GeeIterator* _tmp0_;
#line 79 "../src/engine/util/util-collection.vala"
		_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (keys, GEE_TYPE_ITERABLE, GeeIterable));
#line 79 "../src/engine/util/util-collection.vala"
		_key_it = _tmp0_;
#line 79 "../src/engine/util/util-collection.vala"
		while (TRUE) {
#line 415 "util-collection.c"
			GeeIterator* _tmp1_;
			gpointer key = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			gconstpointer _tmp4_;
#line 79 "../src/engine/util/util-collection.vala"
			_tmp1_ = _key_it;
#line 79 "../src/engine/util/util-collection.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 79 "../src/engine/util/util-collection.vala"
				break;
#line 427 "util-collection.c"
			}
#line 79 "../src/engine/util/util-collection.vala"
			_tmp2_ = _key_it;
#line 79 "../src/engine/util/util-collection.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 79 "../src/engine/util/util-collection.vala"
			key = _tmp3_;
#line 80 "../src/engine/util/util-collection.vala"
			_tmp4_ = key;
#line 80 "../src/engine/util/util-collection.vala"
			gee_map_unset (map, _tmp4_, NULL);
#line 79 "../src/engine/util/util-collection.vala"
			((key == NULL) || (k_destroy_func == NULL)) ? NULL : (key = (k_destroy_func (key), NULL));
#line 441 "util-collection.c"
		}
#line 79 "../src/engine/util/util-collection.vala"
		_g_object_unref0 (_key_it);
#line 445 "util-collection.c"
	}
}

/**
     * Return a MultiMap of value => key of the input map's key => values.
     */
GeeMultiMap*
geary_collection_reverse_multi_map (GType k_type,
                                    GBoxedCopyFunc k_dup_func,
                                    GDestroyNotify k_destroy_func,
                                    GType v_type,
                                    GBoxedCopyFunc v_dup_func,
                                    GDestroyNotify v_destroy_func,
                                    GeeMultiMap* map)
{
	GeeHashMultiMap* reverse = NULL;
	GeeHashMultiMap* _tmp0_;
	GeeMultiMap* result;
#line 87 "../src/engine/util/util-collection.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (map, GEE_TYPE_MULTI_MAP), NULL);
#line 88 "../src/engine/util/util-collection.vala"
	_tmp0_ = gee_hash_multi_map_new (v_type, (GBoxedCopyFunc) v_dup_func, (GDestroyNotify) v_destroy_func, k_type, (GBoxedCopyFunc) k_dup_func, (GDestroyNotify) k_destroy_func, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 88 "../src/engine/util/util-collection.vala"
	reverse = _tmp0_;
#line 470 "util-collection.c"
	{
		GeeIterator* _key_it = NULL;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 89 "../src/engine/util/util-collection.vala"
		_tmp1_ = gee_multi_map_get_keys (map);
#line 89 "../src/engine/util/util-collection.vala"
		_tmp2_ = _tmp1_;
#line 89 "../src/engine/util/util-collection.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 89 "../src/engine/util/util-collection.vala"
		_tmp4_ = _tmp3_;
#line 89 "../src/engine/util/util-collection.vala"
		_g_object_unref0 (_tmp2_);
#line 89 "../src/engine/util/util-collection.vala"
		_key_it = _tmp4_;
#line 89 "../src/engine/util/util-collection.vala"
		while (TRUE) {
#line 491 "util-collection.c"
			GeeIterator* _tmp5_;
			gpointer key = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
#line 89 "../src/engine/util/util-collection.vala"
			_tmp5_ = _key_it;
#line 89 "../src/engine/util/util-collection.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 89 "../src/engine/util/util-collection.vala"
				break;
#line 502 "util-collection.c"
			}
#line 89 "../src/engine/util/util-collection.vala"
			_tmp6_ = _key_it;
#line 89 "../src/engine/util/util-collection.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 89 "../src/engine/util/util-collection.vala"
			key = _tmp7_;
#line 510 "util-collection.c"
			{
				GeeIterator* _value_it = NULL;
				gconstpointer _tmp8_;
				GeeCollection* _tmp9_;
				GeeCollection* _tmp10_;
				GeeIterator* _tmp11_;
				GeeIterator* _tmp12_;
#line 90 "../src/engine/util/util-collection.vala"
				_tmp8_ = key;
#line 90 "../src/engine/util/util-collection.vala"
				_tmp9_ = gee_multi_map_get (map, _tmp8_);
#line 90 "../src/engine/util/util-collection.vala"
				_tmp10_ = _tmp9_;
#line 90 "../src/engine/util/util-collection.vala"
				_tmp11_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_ITERABLE, GeeIterable));
#line 90 "../src/engine/util/util-collection.vala"
				_tmp12_ = _tmp11_;
#line 90 "../src/engine/util/util-collection.vala"
				_g_object_unref0 (_tmp10_);
#line 90 "../src/engine/util/util-collection.vala"
				_value_it = _tmp12_;
#line 90 "../src/engine/util/util-collection.vala"
				while (TRUE) {
#line 534 "util-collection.c"
					GeeIterator* _tmp13_;
					gpointer value = NULL;
					GeeIterator* _tmp14_;
					gpointer _tmp15_;
					GeeHashMultiMap* _tmp16_;
					gconstpointer _tmp17_;
					gconstpointer _tmp18_;
#line 90 "../src/engine/util/util-collection.vala"
					_tmp13_ = _value_it;
#line 90 "../src/engine/util/util-collection.vala"
					if (!gee_iterator_next (_tmp13_)) {
#line 90 "../src/engine/util/util-collection.vala"
						break;
#line 548 "util-collection.c"
					}
#line 90 "../src/engine/util/util-collection.vala"
					_tmp14_ = _value_it;
#line 90 "../src/engine/util/util-collection.vala"
					_tmp15_ = gee_iterator_get (_tmp14_);
#line 90 "../src/engine/util/util-collection.vala"
					value = _tmp15_;
#line 91 "../src/engine/util/util-collection.vala"
					_tmp16_ = reverse;
#line 91 "../src/engine/util/util-collection.vala"
					_tmp17_ = value;
#line 91 "../src/engine/util/util-collection.vala"
					_tmp18_ = key;
#line 91 "../src/engine/util/util-collection.vala"
					gee_multi_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp17_, _tmp18_);
#line 90 "../src/engine/util/util-collection.vala"
					((value == NULL) || (v_destroy_func == NULL)) ? NULL : (value = (v_destroy_func (value), NULL));
#line 566 "util-collection.c"
				}
#line 90 "../src/engine/util/util-collection.vala"
				_g_object_unref0 (_value_it);
#line 570 "util-collection.c"
			}
#line 89 "../src/engine/util/util-collection.vala"
			((key == NULL) || (k_destroy_func == NULL)) ? NULL : (key = (k_destroy_func (key), NULL));
#line 574 "util-collection.c"
		}
#line 89 "../src/engine/util/util-collection.vala"
		_g_object_unref0 (_key_it);
#line 578 "util-collection.c"
	}
#line 95 "../src/engine/util/util-collection.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (reverse, GEE_TYPE_MULTI_MAP, GeeMultiMap);
#line 95 "../src/engine/util/util-collection.vala"
	return result;
#line 584 "util-collection.c"
}

/**
     * To be used by a Hashable's to_hash() method.
     */
inline guint
geary_collection_int64_hash (gint64 value)
{
	guint result;
#line 102 "../src/engine/util/util-collection.vala"
	result = geary_collection_hash_memory (&value, (gsize) sizeof (gint64));
#line 102 "../src/engine/util/util-collection.vala"
	return result;
#line 598 "util-collection.c"
}

/**
     * To be used as hash_func for Gee collections.
     */
inline guint
geary_collection_int64_hash_func (gint64* n)
{
	guint result;
#line 109 "../src/engine/util/util-collection.vala"
	result = geary_collection_hash_memory ((guint8*) n, (gsize) sizeof (gint64));
#line 109 "../src/engine/util/util-collection.vala"
	return result;
#line 612 "util-collection.c"
}

/**
     * To be used as equal_func for Gee collections.
     */
gboolean
geary_collection_int64_equal_func (gint64* a,
                                   gint64* b)
{
	gint64* bia = NULL;
	gint64* bib = NULL;
	gboolean result;
#line 116 "../src/engine/util/util-collection.vala"
	bia = (gint64*) a;
#line 117 "../src/engine/util/util-collection.vala"
	bib = (gint64*) b;
#line 119 "../src/engine/util/util-collection.vala"
	result = (*bia) == (*bib);
#line 119 "../src/engine/util/util-collection.vala"
	return result;
#line 633 "util-collection.c"
}

/**
     * A rotating-XOR hash that can be used to hash memory buffers of any size.
     */
guint
geary_collection_hash_memory (void* ptr,
                              gsize bytes)
{
	gboolean _tmp0_ = FALSE;
	guint8* u8 = NULL;
	guint hash = 0U;
	guint8* _tmp1_;
	guint result;
#line 126 "../src/engine/util/util-collection.vala"
	if (ptr == NULL) {
#line 126 "../src/engine/util/util-collection.vala"
		_tmp0_ = TRUE;
#line 652 "util-collection.c"
	} else {
#line 126 "../src/engine/util/util-collection.vala"
		_tmp0_ = bytes == ((gsize) 0);
#line 656 "util-collection.c"
	}
#line 126 "../src/engine/util/util-collection.vala"
	if (_tmp0_) {
#line 127 "../src/engine/util/util-collection.vala"
		result = (guint) 0;
#line 127 "../src/engine/util/util-collection.vala"
		return result;
#line 664 "util-collection.c"
	}
#line 130 "../src/engine/util/util-collection.vala"
	u8 = (guint8*) ptr;
#line 133 "../src/engine/util/util-collection.vala"
	_tmp1_ = u8;
#line 133 "../src/engine/util/util-collection.vala"
	hash = (guint) (*_tmp1_);
#line 672 "util-collection.c"
	{
		gint ctr = 0;
#line 134 "../src/engine/util/util-collection.vala"
		ctr = 1;
#line 677 "util-collection.c"
		{
			gboolean _tmp2_ = FALSE;
#line 134 "../src/engine/util/util-collection.vala"
			_tmp2_ = TRUE;
#line 134 "../src/engine/util/util-collection.vala"
			while (TRUE) {
#line 684 "util-collection.c"
				guint _tmp4_;
				guint _tmp5_;
				guint8* _tmp6_;
#line 134 "../src/engine/util/util-collection.vala"
				if (!_tmp2_) {
#line 690 "util-collection.c"
					gint _tmp3_;
#line 134 "../src/engine/util/util-collection.vala"
					_tmp3_ = ctr;
#line 134 "../src/engine/util/util-collection.vala"
					ctr = _tmp3_ + 1;
#line 696 "util-collection.c"
				}
#line 134 "../src/engine/util/util-collection.vala"
				_tmp2_ = FALSE;
#line 134 "../src/engine/util/util-collection.vala"
				if (!(((gsize) ctr) < bytes)) {
#line 134 "../src/engine/util/util-collection.vala"
					break;
#line 704 "util-collection.c"
				}
#line 135 "../src/engine/util/util-collection.vala"
				_tmp4_ = hash;
#line 135 "../src/engine/util/util-collection.vala"
				_tmp5_ = hash;
#line 135 "../src/engine/util/util-collection.vala"
				_tmp6_ = u8;
#line 135 "../src/engine/util/util-collection.vala"
				u8 = _tmp6_ + 1;
#line 135 "../src/engine/util/util-collection.vala"
				hash = ((_tmp4_ << 4) ^ (_tmp5_ >> 28)) ^ (*_tmp6_);
#line 716 "util-collection.c"
			}
		}
	}
#line 138 "../src/engine/util/util-collection.vala"
	result = hash;
#line 138 "../src/engine/util/util-collection.vala"
	return result;
#line 724 "util-collection.c"
}

/**
     * A rotating-XOR hash that can be used to hash memory buffers of any size until a terminator byte
     * is found.
     *
     * A {@link ByteTransformer} may be supplied to convert bytes before they are hashed.
     *
     * Returns zero if the initial byte is the terminator.
     */
guint
geary_collection_hash_memory_stream (void* ptr,
                                     guint8 terminator,
                                     GearyCollectionByteTransformer cb,
                                     gpointer cb_target)
{
	guint8* u8 = NULL;
	guint hash = 0U;
	guint result;
#line 150 "../src/engine/util/util-collection.vala"
	u8 = (guint8*) ptr;
#line 152 "../src/engine/util/util-collection.vala"
	hash = (guint) 0;
#line 748 "util-collection.c"
	{
		gboolean _tmp0_ = FALSE;
#line 153 "../src/engine/util/util-collection.vala"
		_tmp0_ = TRUE;
#line 153 "../src/engine/util/util-collection.vala"
		while (TRUE) {
#line 755 "util-collection.c"
			guint8 b = 0U;
			guint8* _tmp1_;
#line 153 "../src/engine/util/util-collection.vala"
			if (!_tmp0_) {
#line 760 "util-collection.c"
			}
#line 153 "../src/engine/util/util-collection.vala"
			_tmp0_ = FALSE;
#line 154 "../src/engine/util/util-collection.vala"
			_tmp1_ = u8;
#line 154 "../src/engine/util/util-collection.vala"
			u8 = _tmp1_ + 1;
#line 154 "../src/engine/util/util-collection.vala"
			b = *_tmp1_;
#line 155 "../src/engine/util/util-collection.vala"
			if (b == terminator) {
#line 156 "../src/engine/util/util-collection.vala"
				break;
#line 774 "util-collection.c"
			}
#line 159 "../src/engine/util/util-collection.vala"
			if (cb != NULL) {
#line 160 "../src/engine/util/util-collection.vala"
				b = cb (b, cb_target);
#line 780 "util-collection.c"
			}
#line 163 "../src/engine/util/util-collection.vala"
			hash = ((hash << 4) ^ (hash >> 28)) ^ b;
#line 784 "util-collection.c"
		}
	}
#line 166 "../src/engine/util/util-collection.vala"
	result = hash;
#line 166 "../src/engine/util/util-collection.vala"
	return result;
#line 791 "util-collection.c"
}

