/* util-error-context.c generated by valac 0.56.17, the Vala compiler
 * generated from util-error-context.vala, do not modify */

/*
 * Copyright 2019 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include "libunwind.h"
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_ERROR_CONTEXT_0_PROPERTY,
	GEARY_ERROR_CONTEXT_THROWN_PROPERTY,
	GEARY_ERROR_CONTEXT_BACKTRACE_PROPERTY,
	GEARY_ERROR_CONTEXT_NUM_PROPERTIES
};
static GParamSpec* geary_error_context_properties[GEARY_ERROR_CONTEXT_NUM_PROPERTIES];
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _geary_error_context_stack_frame_unref0(var) ((var == NULL) ? NULL : (var = (geary_error_context_stack_frame_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _GearyErrorContextParamSpecStackFrame GearyErrorContextParamSpecStackFrame;

struct _GearyErrorContextPrivate {
	GError* _thrown;
	GeeList* _backtrace;
};

struct _GearyErrorContextParamSpecStackFrame {
	GParamSpec parent_instance;
};

static gint GearyErrorContext_private_offset;
static gpointer geary_error_context_parent_class = NULL;
static gpointer geary_error_context_stack_frame_parent_class = NULL;

static void geary_error_context_set_thrown (GearyErrorContext* self,
                                     GError* value);
static void geary_error_context_set_backtrace (GearyErrorContext* self,
                                        GeeList* value);
VALA_EXTERN GearyErrorContextStackFrame* geary_error_context_stack_frame_new (unw_cursor_t* frame);
VALA_EXTERN GearyErrorContextStackFrame* geary_error_context_stack_frame_construct (GType object_type,
                                                                        unw_cursor_t* frame);
static void geary_error_context_stack_frame_finalize (GearyErrorContextStackFrame * obj);
static GType geary_error_context_stack_frame_get_type_once (void);
static void geary_error_context_finalize (GObject * obj);
static GType geary_error_context_get_type_once (void);
static void _vala_geary_error_context_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_geary_error_context_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
geary_error_context_get_instance_private (GearyErrorContext* self)
{
	return G_STRUCT_MEMBER_P (self, GearyErrorContext_private_offset);
}

GError*
geary_error_context_get_thrown (GearyErrorContext* self)
{
	GError* result;
	GError* _tmp0_;
#line 50 "../src/engine/util/util-error-context.vala"
	g_return_val_if_fail (GEARY_IS_ERROR_CONTEXT (self), NULL);
#line 50 "../src/engine/util/util-error-context.vala"
	_tmp0_ = self->priv->_thrown;
#line 50 "../src/engine/util/util-error-context.vala"
	result = _tmp0_;
#line 50 "../src/engine/util/util-error-context.vala"
	return result;
#line 103 "util-error-context.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 50 "../src/engine/util/util-error-context.vala"
	return self ? g_error_copy (self) : NULL;
#line 111 "util-error-context.c"
}

static void
geary_error_context_set_thrown (GearyErrorContext* self,
                                GError* value)
{
	GError* old_value;
#line 50 "../src/engine/util/util-error-context.vala"
	g_return_if_fail (GEARY_IS_ERROR_CONTEXT (self));
#line 50 "../src/engine/util/util-error-context.vala"
	old_value = geary_error_context_get_thrown (self);
#line 50 "../src/engine/util/util-error-context.vala"
	if (old_value != value) {
#line 125 "util-error-context.c"
		GError* _tmp0_;
#line 50 "../src/engine/util/util-error-context.vala"
		_tmp0_ = _g_error_copy0 (value);
#line 50 "../src/engine/util/util-error-context.vala"
		_g_error_free0 (self->priv->_thrown);
#line 50 "../src/engine/util/util-error-context.vala"
		self->priv->_thrown = _tmp0_;
#line 50 "../src/engine/util/util-error-context.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_error_context_properties[GEARY_ERROR_CONTEXT_THROWN_PROPERTY]);
#line 135 "util-error-context.c"
	}
}

GeeList*
geary_error_context_get_backtrace (GearyErrorContext* self)
{
	GeeList* result;
	GeeList* _tmp0_;
#line 54 "../src/engine/util/util-error-context.vala"
	g_return_val_if_fail (GEARY_IS_ERROR_CONTEXT (self), NULL);
#line 54 "../src/engine/util/util-error-context.vala"
	_tmp0_ = self->priv->_backtrace;
#line 54 "../src/engine/util/util-error-context.vala"
	result = _tmp0_;
#line 54 "../src/engine/util/util-error-context.vala"
	return result;
#line 152 "util-error-context.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 54 "../src/engine/util/util-error-context.vala"
	return self ? g_object_ref (self) : NULL;
#line 160 "util-error-context.c"
}

static void
geary_error_context_set_backtrace (GearyErrorContext* self,
                                   GeeList* value)
{
	GeeList* old_value;
#line 54 "../src/engine/util/util-error-context.vala"
	g_return_if_fail (GEARY_IS_ERROR_CONTEXT (self));
#line 54 "../src/engine/util/util-error-context.vala"
	old_value = geary_error_context_get_backtrace (self);
#line 54 "../src/engine/util/util-error-context.vala"
	if (old_value != value) {
#line 174 "util-error-context.c"
		GeeList* _tmp0_;
#line 54 "../src/engine/util/util-error-context.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 54 "../src/engine/util/util-error-context.vala"
		_g_object_unref0 (self->priv->_backtrace);
#line 54 "../src/engine/util/util-error-context.vala"
		self->priv->_backtrace = _tmp0_;
#line 54 "../src/engine/util/util-error-context.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_error_context_properties[GEARY_ERROR_CONTEXT_BACKTRACE_PROPERTY]);
#line 184 "util-error-context.c"
	}
}

GearyErrorContext*
geary_error_context_construct (GType object_type,
                               GError* thrown)
{
	GearyErrorContext * self = NULL;
	unw_context_t trace = {0};
	unw_cursor_t cursor = {0};
	unw_context_t _tmp0_;
#line 58 "../src/engine/util/util-error-context.vala"
	g_return_val_if_fail (thrown != NULL, NULL);
#line 58 "../src/engine/util/util-error-context.vala"
	self = (GearyErrorContext*) geary_base_object_construct (object_type);
#line 59 "../src/engine/util/util-error-context.vala"
	geary_error_context_set_thrown (self, thrown);
#line 62 "../src/engine/util/util-error-context.vala"
	unw_getcontext (&trace);
#line 63 "../src/engine/util/util-error-context.vala"
	_tmp0_ = trace;
#line 63 "../src/engine/util/util-error-context.vala"
	unw_init_local (&cursor, &_tmp0_);
#line 67 "../src/engine/util/util-error-context.vala"
	while (TRUE) {
#line 210 "util-error-context.c"
		GeeList* _tmp1_;
		unw_cursor_t _tmp2_;
		GearyErrorContextStackFrame* _tmp3_;
		GearyErrorContextStackFrame* _tmp4_;
#line 67 "../src/engine/util/util-error-context.vala"
		if (!(unw_step (&cursor) != 0)) {
#line 67 "../src/engine/util/util-error-context.vala"
			break;
#line 219 "util-error-context.c"
		}
#line 68 "../src/engine/util/util-error-context.vala"
		_tmp1_ = self->priv->_backtrace;
#line 68 "../src/engine/util/util-error-context.vala"
		_tmp2_ = cursor;
#line 68 "../src/engine/util/util-error-context.vala"
		_tmp3_ = geary_error_context_stack_frame_new (&_tmp2_);
#line 68 "../src/engine/util/util-error-context.vala"
		_tmp4_ = _tmp3_;
#line 68 "../src/engine/util/util-error-context.vala"
		gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection), _tmp4_);
#line 68 "../src/engine/util/util-error-context.vala"
		_geary_error_context_stack_frame_unref0 (_tmp4_);
#line 233 "util-error-context.c"
	}
#line 58 "../src/engine/util/util-error-context.vala"
	return self;
#line 237 "util-error-context.c"
}

GearyErrorContext*
geary_error_context_new (GError* thrown)
{
#line 58 "../src/engine/util/util-error-context.vala"
	return geary_error_context_construct (GEARY_TYPE_ERROR_CONTEXT, thrown);
#line 245 "util-error-context.c"
}

/** Returns a string representation of the error type, for debugging. */
static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 269 "util-error-context.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 278 "util-error-context.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 297 "util-error-context.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 301 "util-error-context.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 307 "util-error-context.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 317 "util-error-context.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 325 "util-error-context.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 329 "util-error-context.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 335 "util-error-context.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 345 "util-error-context.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1184 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1184 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1185 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1185 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1187 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1187 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 369 "util-error-context.c"
		gchar* _tmp2_;
#line 1188 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1188 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1188 "glib-2.0.vapi"
		return result;
#line 377 "util-error-context.c"
	} else {
#line 1190 "glib-2.0.vapi"
		result = -1;
#line 1190 "glib-2.0.vapi"
		return result;
#line 383 "util-error-context.c"
	}
}

gchar*
geary_error_context_format_error_type (GearyErrorContext* self)
{
	gchar* type = NULL;
	GError* _tmp0_;
	gchar* result;
#line 74 "../src/engine/util/util-error-context.vala"
	g_return_val_if_fail (GEARY_IS_ERROR_CONTEXT (self), NULL);
#line 75 "../src/engine/util/util-error-context.vala"
	type = NULL;
#line 76 "../src/engine/util/util-error-context.vala"
	_tmp0_ = self->priv->_thrown;
#line 76 "../src/engine/util/util-error-context.vala"
	if (_tmp0_ != NULL) {
#line 77 "../src/engine/util/util-error-context.vala"
		static const char QUARK_SUFFIX[] = "-quark";
#line 403 "util-error-context.c"
		gchar* ugly_domain = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		GString* nice_domain = NULL;
		GString* _tmp12_;
		const gchar* _tmp13_ = NULL;
		const gchar* _tmp14_;
		gchar* separator = NULL;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		gchar** _tmp18_;
		gchar** _tmp19_;
		GString* _tmp34_;
		const gchar* _tmp35_;
		GError* _tmp36_;
		gchar* _tmp37_;
#line 78 "../src/engine/util/util-error-context.vala"
		_tmp1_ = self->priv->_thrown;
#line 78 "../src/engine/util/util-error-context.vala"
		_tmp2_ = g_quark_to_string (_tmp1_->domain);
#line 78 "../src/engine/util/util-error-context.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 78 "../src/engine/util/util-error-context.vala"
		ugly_domain = _tmp3_;
#line 79 "../src/engine/util/util-error-context.vala"
		_tmp4_ = ugly_domain;
#line 79 "../src/engine/util/util-error-context.vala"
		if (g_str_has_suffix (_tmp4_, QUARK_SUFFIX)) {
#line 435 "util-error-context.c"
			const gchar* _tmp5_;
			const gchar* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			gchar* _tmp11_;
#line 80 "../src/engine/util/util-error-context.vala"
			_tmp5_ = ugly_domain;
#line 80 "../src/engine/util/util-error-context.vala"
			_tmp6_ = ugly_domain;
#line 80 "../src/engine/util/util-error-context.vala"
			_tmp7_ = strlen (_tmp6_);
#line 80 "../src/engine/util/util-error-context.vala"
			_tmp8_ = _tmp7_;
#line 80 "../src/engine/util/util-error-context.vala"
			_tmp9_ = strlen (QUARK_SUFFIX);
#line 80 "../src/engine/util/util-error-context.vala"
			_tmp10_ = _tmp9_;
#line 80 "../src/engine/util/util-error-context.vala"
			_tmp11_ = string_substring (_tmp5_, (glong) 0, (glong) (_tmp8_ - _tmp10_));
#line 80 "../src/engine/util/util-error-context.vala"
			_g_free0 (ugly_domain);
#line 80 "../src/engine/util/util-error-context.vala"
			ugly_domain = _tmp11_;
#line 461 "util-error-context.c"
		}
#line 84 "../src/engine/util/util-error-context.vala"
		_tmp12_ = g_string_new ("");
#line 84 "../src/engine/util/util-error-context.vala"
		nice_domain = _tmp12_;
#line 85 "../src/engine/util/util-error-context.vala"
		_tmp14_ = ugly_domain;
#line 85 "../src/engine/util/util-error-context.vala"
		if (string_index_of (_tmp14_, "_", 0) != -1) {
#line 85 "../src/engine/util/util-error-context.vala"
			_tmp13_ = "_";
#line 473 "util-error-context.c"
		} else {
#line 85 "../src/engine/util/util-error-context.vala"
			_tmp13_ = "-";
#line 477 "util-error-context.c"
		}
#line 85 "../src/engine/util/util-error-context.vala"
		_tmp15_ = g_strdup (_tmp13_);
#line 85 "../src/engine/util/util-error-context.vala"
		separator = _tmp15_;
#line 86 "../src/engine/util/util-error-context.vala"
		_tmp16_ = ugly_domain;
#line 86 "../src/engine/util/util-error-context.vala"
		_tmp17_ = separator;
#line 86 "../src/engine/util/util-error-context.vala"
		_tmp19_ = _tmp18_ = g_strsplit (_tmp16_, _tmp17_, 0);
#line 489 "util-error-context.c"
		{
			gchar** part_collection = NULL;
			gint part_collection_length1 = 0;
			gint _part_collection_size_ = 0;
			gint part_it = 0;
#line 86 "../src/engine/util/util-error-context.vala"
			part_collection = _tmp19_;
#line 86 "../src/engine/util/util-error-context.vala"
			part_collection_length1 = _vala_array_length (_tmp18_);
#line 86 "../src/engine/util/util-error-context.vala"
			for (part_it = 0; part_it < part_collection_length1; part_it = part_it + 1) {
#line 501 "util-error-context.c"
				gchar* _tmp20_;
				gchar* part = NULL;
#line 86 "../src/engine/util/util-error-context.vala"
				_tmp20_ = g_strdup (part_collection[part_it]);
#line 86 "../src/engine/util/util-error-context.vala"
				part = _tmp20_;
#line 508 "util-error-context.c"
				{
					const gchar* _tmp21_;
					gint _tmp22_;
					gint _tmp23_;
#line 87 "../src/engine/util/util-error-context.vala"
					_tmp21_ = part;
#line 87 "../src/engine/util/util-error-context.vala"
					_tmp22_ = strlen (_tmp21_);
#line 87 "../src/engine/util/util-error-context.vala"
					_tmp23_ = _tmp22_;
#line 87 "../src/engine/util/util-error-context.vala"
					if (_tmp23_ > 0) {
#line 521 "util-error-context.c"
						const gchar* _tmp24_;
#line 88 "../src/engine/util/util-error-context.vala"
						_tmp24_ = part;
#line 88 "../src/engine/util/util-error-context.vala"
						if (g_strcmp0 (_tmp24_, "io") == 0) {
#line 527 "util-error-context.c"
							GString* _tmp25_;
#line 89 "../src/engine/util/util-error-context.vala"
							_tmp25_ = nice_domain;
#line 89 "../src/engine/util/util-error-context.vala"
							g_string_append (_tmp25_, "IO");
#line 533 "util-error-context.c"
						} else {
							GString* _tmp26_;
							const gchar* _tmp27_;
							gchar* _tmp28_;
							gchar* _tmp29_;
							GString* _tmp30_;
							const gchar* _tmp31_;
							gchar* _tmp32_;
							gchar* _tmp33_;
#line 91 "../src/engine/util/util-error-context.vala"
							_tmp26_ = nice_domain;
#line 91 "../src/engine/util/util-error-context.vala"
							_tmp27_ = part;
#line 91 "../src/engine/util/util-error-context.vala"
							_tmp28_ = g_utf8_strup (_tmp27_, (gssize) 1);
#line 91 "../src/engine/util/util-error-context.vala"
							_tmp29_ = _tmp28_;
#line 91 "../src/engine/util/util-error-context.vala"
							g_string_append (_tmp26_, _tmp29_);
#line 91 "../src/engine/util/util-error-context.vala"
							_g_free0 (_tmp29_);
#line 92 "../src/engine/util/util-error-context.vala"
							_tmp30_ = nice_domain;
#line 92 "../src/engine/util/util-error-context.vala"
							_tmp31_ = part;
#line 92 "../src/engine/util/util-error-context.vala"
							_tmp32_ = string_substring (_tmp31_, (glong) 1, (glong) -1);
#line 92 "../src/engine/util/util-error-context.vala"
							_tmp33_ = _tmp32_;
#line 92 "../src/engine/util/util-error-context.vala"
							g_string_append (_tmp30_, _tmp33_);
#line 92 "../src/engine/util/util-error-context.vala"
							_g_free0 (_tmp33_);
#line 567 "util-error-context.c"
						}
					}
#line 86 "../src/engine/util/util-error-context.vala"
					_g_free0 (part);
#line 572 "util-error-context.c"
				}
			}
#line 86 "../src/engine/util/util-error-context.vala"
			part_collection = (_vala_array_free (part_collection, part_collection_length1, (GDestroyNotify) g_free), NULL);
#line 577 "util-error-context.c"
		}
#line 97 "../src/engine/util/util-error-context.vala"
		_tmp34_ = nice_domain;
#line 97 "../src/engine/util/util-error-context.vala"
		_tmp35_ = _tmp34_->str;
#line 97 "../src/engine/util/util-error-context.vala"
		_tmp36_ = self->priv->_thrown;
#line 97 "../src/engine/util/util-error-context.vala"
		_tmp37_ = g_strdup_printf ("%s %i", _tmp35_, _tmp36_->code);
#line 97 "../src/engine/util/util-error-context.vala"
		_g_free0 (type);
#line 97 "../src/engine/util/util-error-context.vala"
		type = _tmp37_;
#line 76 "../src/engine/util/util-error-context.vala"
		_g_free0 (separator);
#line 76 "../src/engine/util/util-error-context.vala"
		_g_string_free0 (nice_domain);
#line 76 "../src/engine/util/util-error-context.vala"
		_g_free0 (ugly_domain);
#line 597 "util-error-context.c"
	}
#line 99 "../src/engine/util/util-error-context.vala"
	result = type;
#line 99 "../src/engine/util/util-error-context.vala"
	return result;
#line 603 "util-error-context.c"
}

/** Returns a string representation of the complete error, for debugging. */
gchar*
geary_error_context_format_full_error (GearyErrorContext* self)
{
	gchar* _error_ = NULL;
	GError* _tmp0_;
	gchar* result;
#line 103 "../src/engine/util/util-error-context.vala"
	g_return_val_if_fail (GEARY_IS_ERROR_CONTEXT (self), NULL);
#line 104 "../src/engine/util/util-error-context.vala"
	_error_ = NULL;
#line 105 "../src/engine/util/util-error-context.vala"
	_tmp0_ = self->priv->_thrown;
#line 105 "../src/engine/util/util-error-context.vala"
	if (_tmp0_ != NULL) {
#line 621 "util-error-context.c"
		gchar* _tmp1_ = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp12_;
#line 106 "../src/engine/util/util-error-context.vala"
		_tmp2_ = self->priv->_thrown;
#line 106 "../src/engine/util/util-error-context.vala"
		_tmp3_ = _tmp2_->message;
#line 106 "../src/engine/util/util-error-context.vala"
		if (geary_string_is_empty (_tmp3_)) {
#line 632 "util-error-context.c"
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
#line 107 "../src/engine/util/util-error-context.vala"
			_tmp4_ = geary_error_context_format_error_type (self);
#line 107 "../src/engine/util/util-error-context.vala"
			_tmp5_ = _tmp4_;
#line 107 "../src/engine/util/util-error-context.vala"
			_tmp6_ = g_strdup_printf ("%s: no message specified", _tmp5_);
#line 107 "../src/engine/util/util-error-context.vala"
			_g_free0 (_tmp1_);
#line 107 "../src/engine/util/util-error-context.vala"
			_tmp1_ = _tmp6_;
#line 107 "../src/engine/util/util-error-context.vala"
			_g_free0 (_tmp5_);
#line 648 "util-error-context.c"
		} else {
			gchar* _tmp7_;
			gchar* _tmp8_;
			GError* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 108 "../src/engine/util/util-error-context.vala"
			_tmp7_ = geary_error_context_format_error_type (self);
#line 108 "../src/engine/util/util-error-context.vala"
			_tmp8_ = _tmp7_;
#line 108 "../src/engine/util/util-error-context.vala"
			_tmp9_ = self->priv->_thrown;
#line 108 "../src/engine/util/util-error-context.vala"
			_tmp10_ = _tmp9_->message;
#line 108 "../src/engine/util/util-error-context.vala"
			_tmp11_ = g_strdup_printf ("%s: \"%s\"", _tmp8_, _tmp10_);
#line 108 "../src/engine/util/util-error-context.vala"
			_g_free0 (_tmp1_);
#line 108 "../src/engine/util/util-error-context.vala"
			_tmp1_ = _tmp11_;
#line 108 "../src/engine/util/util-error-context.vala"
			_g_free0 (_tmp8_);
#line 671 "util-error-context.c"
		}
#line 106 "../src/engine/util/util-error-context.vala"
		_tmp12_ = g_strdup (_tmp1_);
#line 106 "../src/engine/util/util-error-context.vala"
		_g_free0 (_error_);
#line 106 "../src/engine/util/util-error-context.vala"
		_error_ = _tmp12_;
#line 105 "../src/engine/util/util-error-context.vala"
		_g_free0 (_tmp1_);
#line 681 "util-error-context.c"
	}
#line 112 "../src/engine/util/util-error-context.vala"
	result = _error_;
#line 112 "../src/engine/util/util-error-context.vala"
	return result;
#line 687 "util-error-context.c"
}

GearyErrorContextStackFrame*
geary_error_context_stack_frame_construct (GType object_type,
                                           unw_cursor_t* frame)
{
	GearyErrorContextStackFrame* self = NULL;
	guint8 proc_name[256] = {0};
	gint ret = 0;
	gboolean _tmp0_ = FALSE;
#line 32 "../src/engine/util/util-error-context.vala"
	g_return_val_if_fail (frame != NULL, NULL);
#line 32 "../src/engine/util/util-error-context.vala"
	self = (GearyErrorContextStackFrame*) g_type_create_instance (object_type);
#line 34 "../src/engine/util/util-error-context.vala"
	ret = -unw_get_proc_name (frame, proc_name, (gint) 256, NULL);
#line 35 "../src/engine/util/util-error-context.vala"
	if (ret == ((gint) UNW_ESUCCESS)) {
#line 35 "../src/engine/util/util-error-context.vala"
		_tmp0_ = TRUE;
#line 708 "util-error-context.c"
	} else {
#line 36 "../src/engine/util/util-error-context.vala"
		_tmp0_ = ret == ((gint) UNW_ENOMEM);
#line 712 "util-error-context.c"
	}
#line 35 "../src/engine/util/util-error-context.vala"
	if (_tmp0_) {
#line 716 "util-error-context.c"
		gchar* _tmp1_;
#line 37 "../src/engine/util/util-error-context.vala"
		_tmp1_ = g_strdup ((const gchar*) proc_name);
#line 37 "../src/engine/util/util-error-context.vala"
		_g_free0 (self->name);
#line 37 "../src/engine/util/util-error-context.vala"
		self->name = _tmp1_;
#line 724 "util-error-context.c"
	}
#line 32 "../src/engine/util/util-error-context.vala"
	return self;
#line 728 "util-error-context.c"
}

GearyErrorContextStackFrame*
geary_error_context_stack_frame_new (unw_cursor_t* frame)
{
#line 32 "../src/engine/util/util-error-context.vala"
	return geary_error_context_stack_frame_construct (GEARY_ERROR_CONTEXT_TYPE_STACK_FRAME, frame);
#line 736 "util-error-context.c"
}

gchar*
geary_error_context_stack_frame_to_string (GearyErrorContextStackFrame* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 42 "../src/engine/util/util-error-context.vala"
	g_return_val_if_fail (GEARY_ERROR_CONTEXT_IS_STACK_FRAME (self), NULL);
#line 43 "../src/engine/util/util-error-context.vala"
	_tmp0_ = self->name;
#line 43 "../src/engine/util/util-error-context.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 43 "../src/engine/util/util-error-context.vala"
	result = _tmp1_;
#line 43 "../src/engine/util/util-error-context.vala"
	return result;
#line 755 "util-error-context.c"
}

static void
geary_error_context_value_stack_frame_init (GValue* value)
{
#line 24 "../src/engine/util/util-error-context.vala"
	value->data[0].v_pointer = NULL;
#line 763 "util-error-context.c"
}

static void
geary_error_context_value_stack_frame_free_value (GValue* value)
{
#line 24 "../src/engine/util/util-error-context.vala"
	if (value->data[0].v_pointer) {
#line 24 "../src/engine/util/util-error-context.vala"
		geary_error_context_stack_frame_unref (value->data[0].v_pointer);
#line 773 "util-error-context.c"
	}
}

static void
geary_error_context_value_stack_frame_copy_value (const GValue* src_value,
                                                  GValue* dest_value)
{
#line 24 "../src/engine/util/util-error-context.vala"
	if (src_value->data[0].v_pointer) {
#line 24 "../src/engine/util/util-error-context.vala"
		dest_value->data[0].v_pointer = geary_error_context_stack_frame_ref (src_value->data[0].v_pointer);
#line 785 "util-error-context.c"
	} else {
#line 24 "../src/engine/util/util-error-context.vala"
		dest_value->data[0].v_pointer = NULL;
#line 789 "util-error-context.c"
	}
}

static gpointer
geary_error_context_value_stack_frame_peek_pointer (const GValue* value)
{
#line 24 "../src/engine/util/util-error-context.vala"
	return value->data[0].v_pointer;
#line 798 "util-error-context.c"
}

static gchar*
geary_error_context_value_stack_frame_collect_value (GValue* value,
                                                     guint n_collect_values,
                                                     GTypeCValue* collect_values,
                                                     guint collect_flags)
{
#line 24 "../src/engine/util/util-error-context.vala"
	if (collect_values[0].v_pointer) {
#line 809 "util-error-context.c"
		GearyErrorContextStackFrame * object;
		object = collect_values[0].v_pointer;
#line 24 "../src/engine/util/util-error-context.vala"
		if (object->parent_instance.g_class == NULL) {
#line 24 "../src/engine/util/util-error-context.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 816 "util-error-context.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 24 "../src/engine/util/util-error-context.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 820 "util-error-context.c"
		}
#line 24 "../src/engine/util/util-error-context.vala"
		value->data[0].v_pointer = geary_error_context_stack_frame_ref (object);
#line 824 "util-error-context.c"
	} else {
#line 24 "../src/engine/util/util-error-context.vala"
		value->data[0].v_pointer = NULL;
#line 828 "util-error-context.c"
	}
#line 24 "../src/engine/util/util-error-context.vala"
	return NULL;
#line 832 "util-error-context.c"
}

static gchar*
geary_error_context_value_stack_frame_lcopy_value (const GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
	GearyErrorContextStackFrame ** object_p;
	object_p = collect_values[0].v_pointer;
#line 24 "../src/engine/util/util-error-context.vala"
	if (!object_p) {
#line 24 "../src/engine/util/util-error-context.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 847 "util-error-context.c"
	}
#line 24 "../src/engine/util/util-error-context.vala"
	if (!value->data[0].v_pointer) {
#line 24 "../src/engine/util/util-error-context.vala"
		*object_p = NULL;
#line 853 "util-error-context.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 24 "../src/engine/util/util-error-context.vala"
		*object_p = value->data[0].v_pointer;
#line 857 "util-error-context.c"
	} else {
#line 24 "../src/engine/util/util-error-context.vala"
		*object_p = geary_error_context_stack_frame_ref (value->data[0].v_pointer);
#line 861 "util-error-context.c"
	}
#line 24 "../src/engine/util/util-error-context.vala"
	return NULL;
#line 865 "util-error-context.c"
}

GParamSpec*
geary_error_context_param_spec_stack_frame (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags)
{
	GearyErrorContextParamSpecStackFrame* spec;
#line 24 "../src/engine/util/util-error-context.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GEARY_ERROR_CONTEXT_TYPE_STACK_FRAME), NULL);
#line 24 "../src/engine/util/util-error-context.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 24 "../src/engine/util/util-error-context.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 24 "../src/engine/util/util-error-context.vala"
	return G_PARAM_SPEC (spec);
#line 884 "util-error-context.c"
}

gpointer
geary_error_context_value_get_stack_frame (const GValue* value)
{
#line 24 "../src/engine/util/util-error-context.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_ERROR_CONTEXT_TYPE_STACK_FRAME), NULL);
#line 24 "../src/engine/util/util-error-context.vala"
	return value->data[0].v_pointer;
#line 894 "util-error-context.c"
}

void
geary_error_context_value_set_stack_frame (GValue* value,
                                           gpointer v_object)
{
	GearyErrorContextStackFrame * old;
#line 24 "../src/engine/util/util-error-context.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_ERROR_CONTEXT_TYPE_STACK_FRAME));
#line 24 "../src/engine/util/util-error-context.vala"
	old = value->data[0].v_pointer;
#line 24 "../src/engine/util/util-error-context.vala"
	if (v_object) {
#line 24 "../src/engine/util/util-error-context.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GEARY_ERROR_CONTEXT_TYPE_STACK_FRAME));
#line 24 "../src/engine/util/util-error-context.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "../src/engine/util/util-error-context.vala"
		value->data[0].v_pointer = v_object;
#line 24 "../src/engine/util/util-error-context.vala"
		geary_error_context_stack_frame_ref (value->data[0].v_pointer);
#line 916 "util-error-context.c"
	} else {
#line 24 "../src/engine/util/util-error-context.vala"
		value->data[0].v_pointer = NULL;
#line 920 "util-error-context.c"
	}
#line 24 "../src/engine/util/util-error-context.vala"
	if (old) {
#line 24 "../src/engine/util/util-error-context.vala"
		geary_error_context_stack_frame_unref (old);
#line 926 "util-error-context.c"
	}
}

void
geary_error_context_value_take_stack_frame (GValue* value,
                                            gpointer v_object)
{
	GearyErrorContextStackFrame * old;
#line 24 "../src/engine/util/util-error-context.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_ERROR_CONTEXT_TYPE_STACK_FRAME));
#line 24 "../src/engine/util/util-error-context.vala"
	old = value->data[0].v_pointer;
#line 24 "../src/engine/util/util-error-context.vala"
	if (v_object) {
#line 24 "../src/engine/util/util-error-context.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GEARY_ERROR_CONTEXT_TYPE_STACK_FRAME));
#line 24 "../src/engine/util/util-error-context.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "../src/engine/util/util-error-context.vala"
		value->data[0].v_pointer = v_object;
#line 947 "util-error-context.c"
	} else {
#line 24 "../src/engine/util/util-error-context.vala"
		value->data[0].v_pointer = NULL;
#line 951 "util-error-context.c"
	}
#line 24 "../src/engine/util/util-error-context.vala"
	if (old) {
#line 24 "../src/engine/util/util-error-context.vala"
		geary_error_context_stack_frame_unref (old);
#line 957 "util-error-context.c"
	}
}

static void
geary_error_context_stack_frame_class_init (GearyErrorContextStackFrameClass * klass,
                                            gpointer klass_data)
{
#line 24 "../src/engine/util/util-error-context.vala"
	geary_error_context_stack_frame_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/engine/util/util-error-context.vala"
	((GearyErrorContextStackFrameClass *) klass)->finalize = geary_error_context_stack_frame_finalize;
#line 969 "util-error-context.c"
}

static void
geary_error_context_stack_frame_instance_init (GearyErrorContextStackFrame * self,
                                               gpointer klass)
{
	gchar* _tmp0_;
#line 28 "../src/engine/util/util-error-context.vala"
	_tmp0_ = g_strdup ("unknown");
#line 28 "../src/engine/util/util-error-context.vala"
	self->name = _tmp0_;
#line 24 "../src/engine/util/util-error-context.vala"
	self->ref_count = 1;
#line 983 "util-error-context.c"
}

static void
geary_error_context_stack_frame_finalize (GearyErrorContextStackFrame * obj)
{
	GearyErrorContextStackFrame * self;
#line 24 "../src/engine/util/util-error-context.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_ERROR_CONTEXT_TYPE_STACK_FRAME, GearyErrorContextStackFrame);
#line 24 "../src/engine/util/util-error-context.vala"
	g_signal_handlers_destroy (self);
#line 28 "../src/engine/util/util-error-context.vala"
	_g_free0 (self->name);
#line 996 "util-error-context.c"
}

/** Represents an individual stack frame in a call back-trace. */
 G_GNUC_NO_INLINE static GType
geary_error_context_stack_frame_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { geary_error_context_value_stack_frame_init, geary_error_context_value_stack_frame_free_value, geary_error_context_value_stack_frame_copy_value, geary_error_context_value_stack_frame_peek_pointer, "p", geary_error_context_value_stack_frame_collect_value, "p", geary_error_context_value_stack_frame_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GearyErrorContextStackFrameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_error_context_stack_frame_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyErrorContextStackFrame), 0, (GInstanceInitFunc) geary_error_context_stack_frame_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType geary_error_context_stack_frame_type_id;
	geary_error_context_stack_frame_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GearyErrorContextStackFrame", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return geary_error_context_stack_frame_type_id;
}

GType
geary_error_context_stack_frame_get_type (void)
{
	static gsize geary_error_context_stack_frame_type_id__once = 0;
	if (g_once_init_enter (&geary_error_context_stack_frame_type_id__once)) {
		GType geary_error_context_stack_frame_type_id;
		geary_error_context_stack_frame_type_id = geary_error_context_stack_frame_get_type_once ();
		g_once_init_leave (&geary_error_context_stack_frame_type_id__once, geary_error_context_stack_frame_type_id);
	}
	return geary_error_context_stack_frame_type_id__once;
}

gpointer
geary_error_context_stack_frame_ref (gpointer instance)
{
	GearyErrorContextStackFrame * self;
	self = instance;
#line 24 "../src/engine/util/util-error-context.vala"
	g_atomic_int_inc (&self->ref_count);
#line 24 "../src/engine/util/util-error-context.vala"
	return instance;
#line 1032 "util-error-context.c"
}

void
geary_error_context_stack_frame_unref (gpointer instance)
{
	GearyErrorContextStackFrame * self;
	self = instance;
#line 24 "../src/engine/util/util-error-context.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 24 "../src/engine/util/util-error-context.vala"
		GEARY_ERROR_CONTEXT_STACK_FRAME_GET_CLASS (self)->finalize (self);
#line 24 "../src/engine/util/util-error-context.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1046 "util-error-context.c"
	}
}

static void
geary_error_context_class_init (GearyErrorContextClass * klass,
                                gpointer klass_data)
{
#line 20 "../src/engine/util/util-error-context.vala"
	geary_error_context_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/engine/util/util-error-context.vala"
	g_type_class_adjust_private_offset (klass, &GearyErrorContext_private_offset);
#line 20 "../src/engine/util/util-error-context.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_error_context_get_property;
#line 20 "../src/engine/util/util-error-context.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_error_context_set_property;
#line 20 "../src/engine/util/util-error-context.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_error_context_finalize;
#line 1064 "util-error-context.c"
	/** The error thrown that this context is describing. */
#line 20 "../src/engine/util/util-error-context.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ERROR_CONTEXT_THROWN_PROPERTY, geary_error_context_properties[GEARY_ERROR_CONTEXT_THROWN_PROPERTY] = g_param_spec_boxed ("thrown", "thrown", "thrown", G_TYPE_ERROR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1068 "util-error-context.c"
	/** A back trace from when the context was constructed. */
#line 20 "../src/engine/util/util-error-context.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ERROR_CONTEXT_BACKTRACE_PROPERTY, geary_error_context_properties[GEARY_ERROR_CONTEXT_BACKTRACE_PROPERTY] = g_param_spec_object ("backtrace", "backtrace", "backtrace", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1072 "util-error-context.c"
}

static void
geary_error_context_instance_init (GearyErrorContext * self,
                                   gpointer klass)
{
	GeeLinkedList* _tmp0_;
#line 20 "../src/engine/util/util-error-context.vala"
	self->priv = geary_error_context_get_instance_private (self);
#line 53 "../src/engine/util/util-error-context.vala"
	_tmp0_ = gee_linked_list_new (GEARY_ERROR_CONTEXT_TYPE_STACK_FRAME, (GBoxedCopyFunc) geary_error_context_stack_frame_ref, (GDestroyNotify) geary_error_context_stack_frame_unref, NULL, NULL, NULL);
#line 53 "../src/engine/util/util-error-context.vala"
	self->priv->_backtrace = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_LIST, GeeList);
#line 1086 "util-error-context.c"
}

static void
geary_error_context_finalize (GObject * obj)
{
	GearyErrorContext * self;
#line 20 "../src/engine/util/util-error-context.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_TYPE_ERROR_CONTEXT, GearyErrorContext);
#line 50 "../src/engine/util/util-error-context.vala"
	_g_error_free0 (self->priv->_thrown);
#line 53 "../src/engine/util/util-error-context.vala"
	_g_object_unref0 (self->priv->_backtrace);
#line 20 "../src/engine/util/util-error-context.vala"
	G_OBJECT_CLASS (geary_error_context_parent_class)->finalize (obj);
#line 1101 "util-error-context.c"
}

/**
 * Provides additional context information for an error when thrown.
 *
 * This class allows the engine to provide additional context
 * information such as stack traces, the cause of this error, or
 * engine state when an error is thrown. A stack trace will be
 * generated for the context when instantiated, so context instances
 * should be constructed as close to when the error was thrown as
 * possible.
 *
 * This works around the GLib error system's lack of extensibility.
 */
 G_GNUC_NO_INLINE static GType
geary_error_context_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyErrorContextClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_error_context_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyErrorContext), 0, (GInstanceInitFunc) geary_error_context_instance_init, NULL };
	GType geary_error_context_type_id;
	geary_error_context_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyErrorContext", &g_define_type_info, 0);
	GearyErrorContext_private_offset = g_type_add_instance_private (geary_error_context_type_id, sizeof (GearyErrorContextPrivate));
	return geary_error_context_type_id;
}

GType
geary_error_context_get_type (void)
{
	static gsize geary_error_context_type_id__once = 0;
	if (g_once_init_enter (&geary_error_context_type_id__once)) {
		GType geary_error_context_type_id;
		geary_error_context_type_id = geary_error_context_get_type_once ();
		g_once_init_leave (&geary_error_context_type_id__once, geary_error_context_type_id);
	}
	return geary_error_context_type_id__once;
}

static void
_vala_geary_error_context_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	GearyErrorContext * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_ERROR_CONTEXT, GearyErrorContext);
#line 20 "../src/engine/util/util-error-context.vala"
	switch (property_id) {
#line 20 "../src/engine/util/util-error-context.vala"
		case GEARY_ERROR_CONTEXT_THROWN_PROPERTY:
#line 20 "../src/engine/util/util-error-context.vala"
		g_value_set_boxed (value, geary_error_context_get_thrown (self));
#line 20 "../src/engine/util/util-error-context.vala"
		break;
#line 20 "../src/engine/util/util-error-context.vala"
		case GEARY_ERROR_CONTEXT_BACKTRACE_PROPERTY:
#line 20 "../src/engine/util/util-error-context.vala"
		g_value_set_object (value, geary_error_context_get_backtrace (self));
#line 20 "../src/engine/util/util-error-context.vala"
		break;
#line 1160 "util-error-context.c"
		default:
#line 20 "../src/engine/util/util-error-context.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/engine/util/util-error-context.vala"
		break;
#line 1166 "util-error-context.c"
	}
}

static void
_vala_geary_error_context_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	GearyErrorContext * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_ERROR_CONTEXT, GearyErrorContext);
#line 20 "../src/engine/util/util-error-context.vala"
	switch (property_id) {
#line 20 "../src/engine/util/util-error-context.vala"
		case GEARY_ERROR_CONTEXT_THROWN_PROPERTY:
#line 20 "../src/engine/util/util-error-context.vala"
		geary_error_context_set_thrown (self, g_value_get_boxed (value));
#line 20 "../src/engine/util/util-error-context.vala"
		break;
#line 20 "../src/engine/util/util-error-context.vala"
		case GEARY_ERROR_CONTEXT_BACKTRACE_PROPERTY:
#line 20 "../src/engine/util/util-error-context.vala"
		geary_error_context_set_backtrace (self, g_value_get_object (value));
#line 20 "../src/engine/util/util-error-context.vala"
		break;
#line 1192 "util-error-context.c"
		default:
#line 20 "../src/engine/util/util-error-context.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/engine/util/util-error-context.vala"
		break;
#line 1198 "util-error-context.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

