/* util-inet.c generated by valac 0.56.17, the Vala compiler
 * generated from util-inet.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "geary-engine.h"
#include <gio/gio.h>

#define GEARY_INET_HOST_PART_REGEX "^(?!-)[\\p{L}\\p{N}-]{1,63}(?<!-)$"
#define GEARY_INET_IPv6_REGEX "^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][" \
"0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$|^(([a-zA-Z]|[a-zA-Z][a-zA-Z0-9\\-" \
"]*[a-zA-Z0-9])\\.)*([A-Za-z]|[A-Za-z][A-Za-z0-9\\-]*[A-Za-z0-9])$|^\\s" \
"*((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}" \
"(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|" \
"2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A" \
"-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]" \
"|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9" \
"A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]\\d|1\\d\\d|" \
"[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3}))|:))|(([0-9A-" \
"Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:(" \
"(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1" \
"-9]?\\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|" \
"((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(2" \
"5[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(" \
"((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]\\" \
"d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3}))|:)" \
")|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[" \
"0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3" \
"}))|:)))(%.+)?\\s*$"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

/**
 * Formats a socket address as a "name:port" string.
 */
gchar*
geary_inet_address_to_string (GInetSocketAddress* addr)
{
	GInetAddress* _tmp0_;
	GInetAddress* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result;
#line 15 "../src/engine/util/util-inet.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (addr, g_inet_socket_address_get_type ()), NULL);
#line 16 "../src/engine/util/util-inet.vala"
	_tmp0_ = g_inet_socket_address_get_address (addr);
#line 16 "../src/engine/util/util-inet.vala"
	_tmp1_ = _tmp0_;
#line 16 "../src/engine/util/util-inet.vala"
	_tmp2_ = g_inet_address_to_string (_tmp1_);
#line 16 "../src/engine/util/util-inet.vala"
	_tmp3_ = _tmp2_;
#line 16 "../src/engine/util/util-inet.vala"
	_tmp4_ = g_inet_socket_address_get_port (addr);
#line 16 "../src/engine/util/util-inet.vala"
	_tmp5_ = _tmp4_;
#line 16 "../src/engine/util/util-inet.vala"
	_tmp6_ = g_strdup_printf ("%s:%u", _tmp3_, _tmp5_);
#line 16 "../src/engine/util/util-inet.vala"
	_tmp7_ = _tmp6_;
#line 16 "../src/engine/util/util-inet.vala"
	_g_free0 (_tmp3_);
#line 16 "../src/engine/util/util-inet.vala"
	result = _tmp7_;
#line 16 "../src/engine/util/util-inet.vala"
	return result;
#line 79 "util-inet.c"
}

/**
 * Determines if a string represents a valid host name or IP address.
 *
 * This function validates a host name or IP address for display,
 * i.e. without IDN or URI encoding. It simply performs a syntactic
 * check, it does not attempt to resolve the host name. Note that both
 * valid IPv4 addresses (such as "123.0.10.100") and invalid IPv4
 * addresses (such as "123" or "555.123.456.789") are valid host
 * names, so it is not possible to determine if an IPv4 address is
 * invalid.
 */
static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 107 "util-inet.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 134 "util-inet.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 140 "util-inet.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 146 "util-inet.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 150 "util-inet.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 158 "util-inet.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 162 "util-inet.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 174 "util-inet.c"
}

gboolean
geary_inet_is_valid_display_host (gchar* name)
{
	gboolean is_valid = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 31 "../src/engine/util/util-inet.vala"
	is_valid = FALSE;
#line 32 "../src/engine/util/util-inet.vala"
	if (!geary_string_is_empty (name)) {
#line 187 "util-inet.c"
		gint _tmp0_;
		gint _tmp1_;
#line 35 "../src/engine/util/util-inet.vala"
		_tmp0_ = strlen (name);
#line 35 "../src/engine/util/util-inet.vala"
		_tmp1_ = _tmp0_;
#line 35 "../src/engine/util/util-inet.vala"
		if (_tmp1_ <= 253) {
#line 196 "util-inet.c"
			gint _tmp2_;
			gint _tmp3_;
#line 36 "../src/engine/util/util-inet.vala"
			_tmp2_ = strlen (name);
#line 36 "../src/engine/util/util-inet.vala"
			_tmp3_ = _tmp2_;
#line 36 "../src/engine/util/util-inet.vala"
			if (string_get (name, (glong) (_tmp3_ - 1)) == '.') {
#line 205 "util-inet.c"
				gchar* _tmp4_;
#line 37 "../src/engine/util/util-inet.vala"
				_tmp4_ = string_slice (name, (glong) 0, (glong) -1);
#line 37 "../src/engine/util/util-inet.vala"
				_g_free0 (name);
#line 37 "../src/engine/util/util-inet.vala"
				name = _tmp4_;
#line 213 "util-inet.c"
			}
			{
				GRegex* part_regex = NULL;
				GRegex* _tmp5_;
				gchar** _tmp6_;
				gchar** _tmp7_;
#line 39 "../src/engine/util/util-inet.vala"
				_tmp5_ = g_regex_new (GEARY_INET_HOST_PART_REGEX, 0, 0, &_inner_error0_);
#line 39 "../src/engine/util/util-inet.vala"
				part_regex = _tmp5_;
#line 39 "../src/engine/util/util-inet.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 226 "util-inet.c"
					goto __catch0_g_error;
				}
#line 40 "../src/engine/util/util-inet.vala"
				is_valid = TRUE;
#line 41 "../src/engine/util/util-inet.vala"
				_tmp7_ = _tmp6_ = g_strsplit (name, ".", 0);
#line 233 "util-inet.c"
				{
					gchar** part_collection = NULL;
					gint part_collection_length1 = 0;
					gint _part_collection_size_ = 0;
					gint part_it = 0;
#line 41 "../src/engine/util/util-inet.vala"
					part_collection = _tmp7_;
#line 41 "../src/engine/util/util-inet.vala"
					part_collection_length1 = _vala_array_length (_tmp6_);
#line 41 "../src/engine/util/util-inet.vala"
					for (part_it = 0; part_it < part_collection_length1; part_it = part_it + 1) {
#line 245 "util-inet.c"
						gchar* _tmp8_;
						gchar* part = NULL;
#line 41 "../src/engine/util/util-inet.vala"
						_tmp8_ = g_strdup (part_collection[part_it]);
#line 41 "../src/engine/util/util-inet.vala"
						part = _tmp8_;
#line 252 "util-inet.c"
						{
							GRegex* _tmp9_;
							const gchar* _tmp10_;
#line 42 "../src/engine/util/util-inet.vala"
							_tmp9_ = part_regex;
#line 42 "../src/engine/util/util-inet.vala"
							_tmp10_ = part;
#line 42 "../src/engine/util/util-inet.vala"
							if (!g_regex_match (_tmp9_, _tmp10_, 0, NULL)) {
#line 43 "../src/engine/util/util-inet.vala"
								is_valid = FALSE;
#line 44 "../src/engine/util/util-inet.vala"
								_g_free0 (part);
#line 44 "../src/engine/util/util-inet.vala"
								break;
#line 268 "util-inet.c"
							}
#line 41 "../src/engine/util/util-inet.vala"
							_g_free0 (part);
#line 272 "util-inet.c"
						}
					}
#line 41 "../src/engine/util/util-inet.vala"
					part_collection = (_vala_array_free (part_collection, part_collection_length1, (GDestroyNotify) g_free), NULL);
#line 277 "util-inet.c"
				}
#line 38 "../src/engine/util/util-inet.vala"
				_g_regex_unref0 (part_regex);
#line 281 "util-inet.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* err = NULL;
				GError* _tmp11_;
				const gchar* _tmp12_;
#line 38 "../src/engine/util/util-inet.vala"
				err = _inner_error0_;
#line 38 "../src/engine/util/util-inet.vala"
				_inner_error0_ = NULL;
#line 48 "../src/engine/util/util-inet.vala"
				_tmp11_ = err;
#line 48 "../src/engine/util/util-inet.vala"
				_tmp12_ = _tmp11_->message;
#line 48 "../src/engine/util/util-inet.vala"
				g_debug ("util-inet.vala:48: Error validating as host name: %s", _tmp12_);
#line 38 "../src/engine/util/util-inet.vala"
				_g_error_free0 (err);
#line 301 "util-inet.c"
			}
			__finally0:
#line 38 "../src/engine/util/util-inet.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 306 "util-inet.c"
				gboolean _tmp13_ = FALSE;
#line 38 "../src/engine/util/util-inet.vala"
				_g_free0 (name);
#line 38 "../src/engine/util/util-inet.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 38 "../src/engine/util/util-inet.vala"
				g_clear_error (&_inner_error0_);
#line 38 "../src/engine/util/util-inet.vala"
				return _tmp13_;
#line 316 "util-inet.c"
			}
		}
#line 53 "../src/engine/util/util-inet.vala"
		if (!is_valid) {
#line 321 "util-inet.c"
			{
				GRegex* address_regex = NULL;
				GRegex* _tmp14_;
				GRegex* _tmp15_;
#line 55 "../src/engine/util/util-inet.vala"
				_tmp14_ = g_regex_new (GEARY_INET_IPv6_REGEX, G_REGEX_CASELESS, 0, &_inner_error0_);
#line 55 "../src/engine/util/util-inet.vala"
				address_regex = _tmp14_;
#line 55 "../src/engine/util/util-inet.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 332 "util-inet.c"
					goto __catch1_g_error;
				}
#line 58 "../src/engine/util/util-inet.vala"
				_tmp15_ = address_regex;
#line 58 "../src/engine/util/util-inet.vala"
				is_valid = g_regex_match (_tmp15_, name, 0, NULL);
#line 54 "../src/engine/util/util-inet.vala"
				_g_regex_unref0 (address_regex);
#line 341 "util-inet.c"
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* err = NULL;
				GError* _tmp16_;
				const gchar* _tmp17_;
#line 54 "../src/engine/util/util-inet.vala"
				err = _inner_error0_;
#line 54 "../src/engine/util/util-inet.vala"
				_inner_error0_ = NULL;
#line 60 "../src/engine/util/util-inet.vala"
				_tmp16_ = err;
#line 60 "../src/engine/util/util-inet.vala"
				_tmp17_ = _tmp16_->message;
#line 60 "../src/engine/util/util-inet.vala"
				g_debug ("util-inet.vala:60: Error validating as IPv6 address: %s", _tmp17_);
#line 54 "../src/engine/util/util-inet.vala"
				_g_error_free0 (err);
#line 361 "util-inet.c"
			}
			__finally1:
#line 54 "../src/engine/util/util-inet.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 366 "util-inet.c"
				gboolean _tmp18_ = FALSE;
#line 54 "../src/engine/util/util-inet.vala"
				_g_free0 (name);
#line 54 "../src/engine/util/util-inet.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 54 "../src/engine/util/util-inet.vala"
				g_clear_error (&_inner_error0_);
#line 54 "../src/engine/util/util-inet.vala"
				return _tmp18_;
#line 376 "util-inet.c"
			}
		}
	}
#line 64 "../src/engine/util/util-inet.vala"
	result = is_valid;
#line 64 "../src/engine/util/util-inet.vala"
	_g_free0 (name);
#line 64 "../src/engine/util/util-inet.vala"
	return result;
#line 386 "util-inet.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

