/* util-logging.c generated by valac 0.56.17, the Vala compiler
 * generated from util-logging.vala, do not modify */

/*
 * Copyright © 2016 Software Freedom Conservancy Inc.
 * Copyright © 2018-2020 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib.h>
#include <stdio.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <gobject/gvaluecollector.h>
#include <float.h>
#include <math.h>

#define GEARY_LOGGING_SOURCE_CONTEXT_FIELD_COUNT ((guint8) 8)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _geary_logging_record_unref0(var) ((var == NULL) ? NULL : (var = (geary_logging_record_unref (var), NULL)))
#define _geary_logging_state_unref0(var) ((var == NULL) ? NULL : (var = (geary_logging_state_unref (var), NULL)))
typedef struct _GearyLoggingParamSpecState GearyLoggingParamSpecState;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _GearyLoggingParamSpecRecord GearyLoggingParamSpecRecord;

struct _GearyLoggingStatePrivate {
	GearyLoggingSource* _source;
	gchar* message;
};

struct _GearyLoggingParamSpecState {
	GParamSpec parent_instance;
};

struct _GearyLoggingRecordPrivate {
	gchar* _domain;
	GearyAccount* _account;
	GearyClientService* _service;
	GearyFolder* _folder;
	GearyLoggingRecord* _next;
	gchar** states;
	gint states_length1;
	gint _states_size_;
	gboolean filled;
	gboolean old_log_api;
};

struct _GearyLoggingParamSpecRecord {
	GParamSpec parent_instance;
};

VALA_EXTERN gboolean geary_logging_was_init;
gboolean geary_logging_was_init = FALSE;
VALA_EXTERN GMutex geary_logging_record_lock;
GMutex geary_logging_record_lock = {0};
VALA_EXTERN GearyLoggingRecord* geary_logging_first_record;
GearyLoggingRecord* geary_logging_first_record = NULL;
VALA_EXTERN GearyLoggingRecord* geary_logging_last_record;
GearyLoggingRecord* geary_logging_last_record = NULL;
VALA_EXTERN guint geary_logging_log_length;
guint geary_logging_log_length = (guint) 0;
VALA_EXTERN guint geary_logging_max_log_length;
guint geary_logging_max_log_length = (guint) 0;
VALA_EXTERN GearyLoggingLogRecord geary_logging_listener;
VALA_EXTERN gpointer geary_logging_listener_target;
GearyLoggingLogRecord geary_logging_listener = NULL;
gpointer geary_logging_listener_target = NULL;
VALA_EXTERN GMutex geary_logging_writer_lock;
GMutex geary_logging_writer_lock = {0};
VALA_EXTERN FILE* geary_logging_stream;
FILE* geary_logging_stream = NULL;
VALA_EXTERN GLogLevelFlags geary_logging_set_breakpoint_on;
GLogLevelFlags geary_logging_set_breakpoint_on = 0;
VALA_EXTERN GeeSet* geary_logging_suppressed_domains;
GeeSet* geary_logging_suppressed_domains = NULL;
static gint GearyLoggingState_private_offset;
static gpointer geary_logging_state_parent_class = NULL;
static gint GearyLoggingRecord_private_offset;
static gpointer geary_logging_record_parent_class = NULL;

static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
VALA_EXTERN void geary_logging_write_record (GearyLoggingRecord* record,
                                 GLogLevelFlags levels);
VALA_EXTERN GearyLoggingRecord* geary_logging_record_new (GLogField* fields,
                                              gint fields_length1,
                                              GLogLevelFlags levels,
                                              gint64 timestamp);
VALA_EXTERN GearyLoggingRecord* geary_logging_record_construct (GType object_type,
                                                    GLogField* fields,
                                                    gint fields_length1,
                                                    GLogLevelFlags levels,
                                                    gint64 timestamp);
VALA_EXTERN gboolean geary_logging_should_blacklist (GearyLoggingRecord* record);
VALA_EXTERN void geary_logging_record_set_next (GearyLoggingRecord* self,
                                    GearyLoggingRecord* value);
VALA_EXTERN gchar* geary_logging_to_prefix (GLogLevelFlags level);
VALA_EXTERN gchar* geary_logging_field_to_string (GLogField* field);
static gchar* geary_logging_source_log_level_to_priority (GLogLevelFlags level);
static gchar* geary_logging_source_real_to_string (GearyLoggingSource* self);
static inline void geary_logging_source_log_structured (GearyLoggingSource* self,
                                          GLogLevelFlags levels,
                                          const gchar* fmt,
                                          va_list args);
static void geary_logging_source_context_init (GearyLoggingSourceContext *self,
                                        const gchar* domain,
                                        GLogLevelFlags level,
                                        const gchar* message,
                                        va_list args);
static GLogField* _vala_array_dup17 (GLogField* self,
                              gssize length);
static GLogField* _vala_array_dup18 (GLogField* self,
                              gssize length);
static GType geary_logging_source_get_type_once (void);
static void geary_logging_state_set_source (GearyLoggingState* self,
                                     GearyLoggingSource* value);
static void geary_logging_state_finalize (GearyLoggingState * obj);
static GType geary_logging_state_get_type_once (void);
static void geary_logging_record_set_domain (GearyLoggingRecord* self,
                                      const gchar* value);
static void geary_logging_record_set_account (GearyLoggingRecord* self,
                                       GearyAccount* value);
static void geary_logging_record_set_service (GearyLoggingRecord* self,
                                       GearyClientService* value);
static void geary_logging_record_set_folder (GearyLoggingRecord* self,
                                      GearyFolder* value);
static GType* _g_type_dup (GType* self);
static gchar** _vala_array_dup19 (gchar** self,
                           gssize length);
static void geary_logging_record_finalize (GearyLoggingRecord * obj);
static GType geary_logging_record_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static void _vala_clear_GMutex (GMutex * mutex);
static void _vala_clear_GRecMutex (GRecMutex * mutex);
static void _vala_clear_GRWLock (GRWLock * mutex);
static void _vala_clear_GCond (GCond * mutex);

/**
     * Must be called before ''any'' call to the Logging namespace.
     *
     * This will be initialized by the Engine when it's opened, but
     * applications may want to set up logging before that, in which case,
     * call this directly.
     */
static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 79 "../src/engine/util/util-logging.vala"
	for (i = 0; i < stack_length; i++) {
#line 79 "../src/engine/util/util-logging.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 79 "../src/engine/util/util-logging.vala"
			return TRUE;
#line 182 "util-logging.c"
		}
	}
#line 79 "../src/engine/util/util-logging.vala"
	return FALSE;
#line 187 "util-logging.c"
}

void
geary_logging_init (void)
{
#line 69 "../src/engine/util/util-logging.vala"
	if (!geary_logging_was_init) {
#line 195 "util-logging.c"
		GeeHashSet* _tmp0_;
		gchar* debug_var = NULL;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
#line 70 "../src/engine/util/util-logging.vala"
		geary_logging_was_init = TRUE;
#line 71 "../src/engine/util/util-logging.vala"
		_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 71 "../src/engine/util/util-logging.vala"
		_g_object_unref0 (geary_logging_suppressed_domains);
#line 71 "../src/engine/util/util-logging.vala"
		geary_logging_suppressed_domains = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_SET, GeeSet);
#line 72 "../src/engine/util/util-logging.vala"
		_vala_clear_GMutex (&geary_logging_record_lock);
#line 72 "../src/engine/util/util-logging.vala"
		g_mutex_init (&geary_logging_record_lock);
#line 73 "../src/engine/util/util-logging.vala"
		_vala_clear_GMutex (&geary_logging_writer_lock);
#line 73 "../src/engine/util/util-logging.vala"
		g_mutex_init (&geary_logging_writer_lock);
#line 74 "../src/engine/util/util-logging.vala"
		geary_logging_max_log_length = GEARY_LOGGING_DEFAULT_MAX_LOG_BUFFER_LENGTH;
#line 76 "../src/engine/util/util-logging.vala"
		_tmp1_ = g_getenv ("G_DEBUG");
#line 76 "../src/engine/util/util-logging.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 76 "../src/engine/util/util-logging.vala"
		debug_var = _tmp2_;
#line 77 "../src/engine/util/util-logging.vala"
		_tmp3_ = debug_var;
#line 77 "../src/engine/util/util-logging.vala"
		if (_tmp3_ != NULL) {
#line 229 "util-logging.c"
			gchar** parts = NULL;
			const gchar* _tmp4_;
			gchar** _tmp5_;
			gchar** _tmp6_;
			gint parts_length1;
			gint _parts_size_;
			gchar** _tmp7_;
			gint _tmp7__length1;
			gchar** _tmp8_;
			gint _tmp8__length1;
#line 78 "../src/engine/util/util-logging.vala"
			_tmp4_ = debug_var;
#line 78 "../src/engine/util/util-logging.vala"
			_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, ",", 0);
#line 78 "../src/engine/util/util-logging.vala"
			parts = _tmp6_;
#line 78 "../src/engine/util/util-logging.vala"
			parts_length1 = _vala_array_length (_tmp5_);
#line 78 "../src/engine/util/util-logging.vala"
			_parts_size_ = parts_length1;
#line 79 "../src/engine/util/util-logging.vala"
			_tmp7_ = parts;
#line 79 "../src/engine/util/util-logging.vala"
			_tmp7__length1 = parts_length1;
#line 79 "../src/engine/util/util-logging.vala"
			if (_vala_string_array_contains (_tmp7_, _tmp7__length1, "fatal-warnings")) {
#line 80 "../src/engine/util/util-logging.vala"
				geary_logging_set_breakpoint_on = geary_logging_set_breakpoint_on | G_LOG_LEVEL_WARNING;
#line 81 "../src/engine/util/util-logging.vala"
				geary_logging_set_breakpoint_on = geary_logging_set_breakpoint_on | G_LOG_LEVEL_CRITICAL;
#line 260 "util-logging.c"
			}
#line 83 "../src/engine/util/util-logging.vala"
			_tmp8_ = parts;
#line 83 "../src/engine/util/util-logging.vala"
			_tmp8__length1 = parts_length1;
#line 83 "../src/engine/util/util-logging.vala"
			if (_vala_string_array_contains (_tmp8_, _tmp8__length1, "fatal-criticals")) {
#line 84 "../src/engine/util/util-logging.vala"
				geary_logging_set_breakpoint_on = geary_logging_set_breakpoint_on | G_LOG_LEVEL_CRITICAL;
#line 270 "util-logging.c"
			}
#line 77 "../src/engine/util/util-logging.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 274 "util-logging.c"
		}
#line 69 "../src/engine/util/util-logging.vala"
		_g_free0 (debug_var);
#line 278 "util-logging.c"
	}
}

/**
     * Sets a function to be called when a new log record is created.
     *
     * For any log records to be created, {@link default_log_writer}
     * must be set as the GLib structured log writer.
     *
     * Note that the given function *must* be thread-safe, since
     * logging can occur on multiple threads at once.
     *
     * @see default_log_writer
     */
void
geary_logging_set_log_listener (GearyLoggingLogRecord new_listener,
                                gpointer new_listener_target)
{
#line 102 "../src/engine/util/util-logging.vala"
	geary_logging_listener = new_listener;
#line 102 "../src/engine/util/util-logging.vala"
	geary_logging_listener_target = new_listener_target;
#line 301 "util-logging.c"
}

/**
     * Returns the oldest log record in the logging system's buffer.
     *
     * For any log records to be created, {@link default_log_writer}
     * must be set as the GLib structured log writer.
     *
     * @see default_log_writer
     */
static gpointer
_geary_logging_record_ref0 (gpointer self)
{
#line 114 "../src/engine/util/util-logging.vala"
	return self ? geary_logging_record_ref (self) : NULL;
#line 317 "util-logging.c"
}

GearyLoggingRecord*
geary_logging_get_earliest_record (void)
{
	GearyLoggingRecord* _tmp0_;
	GearyLoggingRecord* _tmp1_;
	GearyLoggingRecord* result;
#line 114 "../src/engine/util/util-logging.vala"
	_tmp0_ = geary_logging_first_record;
#line 114 "../src/engine/util/util-logging.vala"
	_tmp1_ = _geary_logging_record_ref0 (_tmp0_);
#line 114 "../src/engine/util/util-logging.vala"
	result = _tmp1_;
#line 114 "../src/engine/util/util-logging.vala"
	return result;
#line 334 "util-logging.c"
}

/**
     * Returns the most recent log record in the logging system's buffer.
     *
     * For any log records to be created, {@link default_log_writer}
     * must be set as the GLib structured log writer.
     *
     * @see default_log_writer
     */
GearyLoggingRecord*
geary_logging_get_latest_record (void)
{
	GearyLoggingRecord* _tmp0_;
	GearyLoggingRecord* _tmp1_;
	GearyLoggingRecord* result;
#line 126 "../src/engine/util/util-logging.vala"
	_tmp0_ = geary_logging_last_record;
#line 126 "../src/engine/util/util-logging.vala"
	_tmp1_ = _geary_logging_record_ref0 (_tmp0_);
#line 126 "../src/engine/util/util-logging.vala"
	result = _tmp1_;
#line 126 "../src/engine/util/util-logging.vala"
	return result;
#line 359 "util-logging.c"
}

/**
     * Clears all log records.
     *
     * Since log records hold references to Geary engine objects, it may
     * be desirable to clear the records prior to shutdown so that the
     * objects can be destroyed.
     */
void
geary_logging_clear (void)
{
	GearyLoggingRecord* old_first = NULL;
	GearyLoggingRecord* _tmp0_;
	GearyLoggingRecord* _tmp1_;
#line 140 "../src/engine/util/util-logging.vala"
	old_first = NULL;
#line 144 "../src/engine/util/util-logging.vala"
	g_mutex_lock (&geary_logging_record_lock);
#line 145 "../src/engine/util/util-logging.vala"
	_tmp0_ = geary_logging_first_record;
#line 145 "../src/engine/util/util-logging.vala"
	_tmp1_ = _geary_logging_record_ref0 (_tmp0_);
#line 145 "../src/engine/util/util-logging.vala"
	_geary_logging_record_unref0 (old_first);
#line 145 "../src/engine/util/util-logging.vala"
	old_first = _tmp1_;
#line 146 "../src/engine/util/util-logging.vala"
	_geary_logging_record_unref0 (geary_logging_first_record);
#line 146 "../src/engine/util/util-logging.vala"
	geary_logging_first_record = NULL;
#line 147 "../src/engine/util/util-logging.vala"
	_geary_logging_record_unref0 (geary_logging_last_record);
#line 147 "../src/engine/util/util-logging.vala"
	geary_logging_last_record = NULL;
#line 148 "../src/engine/util/util-logging.vala"
	geary_logging_log_length = (guint) 0;
#line 149 "../src/engine/util/util-logging.vala"
	g_mutex_unlock (&geary_logging_record_lock);
#line 157 "../src/engine/util/util-logging.vala"
	while (TRUE) {
#line 401 "util-logging.c"
		GearyLoggingRecord* _tmp2_;
		GearyLoggingRecord* _tmp3_;
		GearyLoggingRecord* _tmp4_;
		GearyLoggingRecord* _tmp5_;
		GearyLoggingRecord* _tmp6_;
#line 157 "../src/engine/util/util-logging.vala"
		_tmp2_ = old_first;
#line 157 "../src/engine/util/util-logging.vala"
		if (!(_tmp2_ != NULL)) {
#line 157 "../src/engine/util/util-logging.vala"
			break;
#line 413 "util-logging.c"
		}
#line 158 "../src/engine/util/util-logging.vala"
		_tmp3_ = old_first;
#line 158 "../src/engine/util/util-logging.vala"
		_tmp4_ = geary_logging_record_get_next (_tmp3_);
#line 158 "../src/engine/util/util-logging.vala"
		_tmp5_ = _tmp4_;
#line 158 "../src/engine/util/util-logging.vala"
		_tmp6_ = _geary_logging_record_ref0 (_tmp5_);
#line 158 "../src/engine/util/util-logging.vala"
		_geary_logging_record_unref0 (old_first);
#line 158 "../src/engine/util/util-logging.vala"
		old_first = _tmp6_;
#line 427 "util-logging.c"
	}
#line 136 "../src/engine/util/util-logging.vala"
	_geary_logging_record_unref0 (old_first);
#line 431 "util-logging.c"
}

/**
     * Suppresses printing of debug logging for a given logging domain.
     *
     * If a logging domain is suppressed, DEBUG-level logging will not
     * be printed by {@link default_log_writer}.
     *
     * @return true if the domain was suppressed
     * @see unsuppress_domain
     */
gboolean
geary_logging_suppress_domain (const gchar* domain)
{
	GeeSet* _tmp0_;
	gboolean result;
#line 171 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (domain != NULL, FALSE);
#line 172 "../src/engine/util/util-logging.vala"
	_tmp0_ = geary_logging_suppressed_domains;
#line 172 "../src/engine/util/util-logging.vala"
	result = gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), domain);
#line 172 "../src/engine/util/util-logging.vala"
	return result;
#line 456 "util-logging.c"
}

/**
     * Determines if given logging domain is suppressed.
     *
     * @return true if the domain is suppressed
     */
gboolean
geary_logging_is_suppressed_domain (const gchar* domain)
{
	GeeSet* _tmp0_;
	gboolean result;
#line 180 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (domain != NULL, FALSE);
#line 181 "../src/engine/util/util-logging.vala"
	_tmp0_ = geary_logging_suppressed_domains;
#line 181 "../src/engine/util/util-logging.vala"
	result = gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), domain);
#line 181 "../src/engine/util/util-logging.vala"
	return result;
#line 477 "util-logging.c"
}

/**
     * Un-suppresses printing debug logging for a given logging domain.
     *
     * Un-suppressing a suppressed logging domain will cause it to be
     * printed by {@link default_log_writer} again.
     *
     * @return true if the domain was unsuppressed
     * @see suppress_domain
     */
gboolean
geary_logging_unsuppress_domain (const gchar* domain)
{
	GeeSet* _tmp0_;
	gboolean result;
#line 193 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (domain != NULL, FALSE);
#line 194 "../src/engine/util/util-logging.vala"
	_tmp0_ = geary_logging_suppressed_domains;
#line 194 "../src/engine/util/util-logging.vala"
	result = gee_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), domain);
#line 194 "../src/engine/util/util-logging.vala"
	return result;
#line 502 "util-logging.c"
}

/**
     * Registers a stream for log output from {@link default_log_writer}.
     *
     * If stream is null, no logging of then DEBUG-level,
     * INFORMATION-level, and MESSAGE-level structured log messages
     * occurs (the default). If non-null and the stream was previously
     * null, all pending log records will be output before proceeding.
     *
     * This only has effect if {@link default_log_writer} has been set
     * as the GLib structured log writer via a call to {@link
     * GLib.Log.set_writer_func}.
     */
void
geary_logging_log_to (FILE* stream)
{
	gboolean _tmp0_ = FALSE;
	gboolean catch_up = FALSE;
#line 210 "../src/engine/util/util-logging.vala"
	if (stream != NULL) {
#line 524 "util-logging.c"
		FILE* _tmp1_;
#line 210 "../src/engine/util/util-logging.vala"
		_tmp1_ = geary_logging_stream;
#line 210 "../src/engine/util/util-logging.vala"
		_tmp0_ = _tmp1_ == NULL;
#line 530 "util-logging.c"
	} else {
#line 210 "../src/engine/util/util-logging.vala"
		_tmp0_ = FALSE;
#line 534 "util-logging.c"
	}
#line 210 "../src/engine/util/util-logging.vala"
	catch_up = _tmp0_;
#line 211 "../src/engine/util/util-logging.vala"
	geary_logging_stream = stream;
#line 212 "../src/engine/util/util-logging.vala"
	if (catch_up) {
#line 542 "util-logging.c"
		GearyLoggingRecord* record = NULL;
		GearyLoggingRecord* _tmp2_;
		GearyLoggingRecord* _tmp3_;
#line 213 "../src/engine/util/util-logging.vala"
		_tmp2_ = geary_logging_first_record;
#line 213 "../src/engine/util/util-logging.vala"
		_tmp3_ = _geary_logging_record_ref0 (_tmp2_);
#line 213 "../src/engine/util/util-logging.vala"
		record = _tmp3_;
#line 214 "../src/engine/util/util-logging.vala"
		while (TRUE) {
#line 554 "util-logging.c"
			GearyLoggingRecord* _tmp4_;
			GearyLoggingRecord* _tmp5_;
			GearyLoggingRecord* _tmp6_;
			GearyLoggingRecord* _tmp7_;
			GearyLoggingRecord* _tmp8_;
			GearyLoggingRecord* _tmp9_;
			GearyLoggingRecord* _tmp10_;
#line 214 "../src/engine/util/util-logging.vala"
			_tmp4_ = record;
#line 214 "../src/engine/util/util-logging.vala"
			if (!(_tmp4_ != NULL)) {
#line 214 "../src/engine/util/util-logging.vala"
				break;
#line 568 "util-logging.c"
			}
#line 215 "../src/engine/util/util-logging.vala"
			_tmp5_ = record;
#line 215 "../src/engine/util/util-logging.vala"
			_tmp6_ = record;
#line 215 "../src/engine/util/util-logging.vala"
			geary_logging_write_record (_tmp5_, _tmp6_->levels);
#line 216 "../src/engine/util/util-logging.vala"
			_tmp7_ = record;
#line 216 "../src/engine/util/util-logging.vala"
			_tmp8_ = geary_logging_record_get_next (_tmp7_);
#line 216 "../src/engine/util/util-logging.vala"
			_tmp9_ = _tmp8_;
#line 216 "../src/engine/util/util-logging.vala"
			_tmp10_ = _geary_logging_record_ref0 (_tmp9_);
#line 216 "../src/engine/util/util-logging.vala"
			_geary_logging_record_unref0 (record);
#line 216 "../src/engine/util/util-logging.vala"
			record = _tmp10_;
#line 588 "util-logging.c"
		}
#line 212 "../src/engine/util/util-logging.vala"
		_geary_logging_record_unref0 (record);
#line 592 "util-logging.c"
	}
}

/**
     * A GLib structured logging writer that records logging messages.
     *
     * Installing this function as the GLib structured log writer by
     * passing it in a call to {@link GLib.Log.set_writer_func} will
     * enable the engine's log record keeping and printing services.
     *
     * Instances of {@link Record} will be created for each structured
     * logging message received, and made available to applications
     * via {@link get_earliest_record}, {@link get_latest_record}, and
     * {@link set_log_listener}.
     *
     * Further, if a destination stream has been set via a call to
     * {@link log_to}, structured log messages will be printed to the
     * given stream.
     */
GLogWriterOutput
geary_logging_default_log_writer (GLogLevelFlags levels,
                                  GLogField* fields,
                                  gint fields_length1)
{
	GearyLoggingRecord* record = NULL;
	GearyLoggingRecord* _tmp0_;
	GearyLoggingRecord* _tmp1_;
	GLogWriterOutput result;
#line 240 "../src/engine/util/util-logging.vala"
	_tmp0_ = geary_logging_record_new (fields, fields_length1, levels, g_get_real_time ());
#line 240 "../src/engine/util/util-logging.vala"
	record = _tmp0_;
#line 241 "../src/engine/util/util-logging.vala"
	_tmp1_ = record;
#line 241 "../src/engine/util/util-logging.vala"
	if (!geary_logging_should_blacklist (_tmp1_)) {
#line 629 "util-logging.c"
		GearyLoggingRecord* old_record = NULL;
		GearyLoggingRecord* _tmp2_;
		GearyLoggingRecord* _tmp3_;
		GearyLoggingRecord* _tmp4_;
		GearyLoggingLogRecord _tmp18_;
		gpointer _tmp18__target;
		GearyLoggingRecord* _tmp21_;
#line 246 "../src/engine/util/util-logging.vala"
		old_record = NULL;
#line 250 "../src/engine/util/util-logging.vala"
		g_mutex_lock (&geary_logging_record_lock);
#line 251 "../src/engine/util/util-logging.vala"
		_tmp2_ = geary_logging_first_record;
#line 251 "../src/engine/util/util-logging.vala"
		_tmp3_ = _geary_logging_record_ref0 (_tmp2_);
#line 251 "../src/engine/util/util-logging.vala"
		_geary_logging_record_unref0 (old_record);
#line 251 "../src/engine/util/util-logging.vala"
		old_record = _tmp3_;
#line 252 "../src/engine/util/util-logging.vala"
		_tmp4_ = geary_logging_first_record;
#line 252 "../src/engine/util/util-logging.vala"
		if (_tmp4_ == NULL) {
#line 653 "util-logging.c"
			GearyLoggingRecord* _tmp5_;
			GearyLoggingRecord* _tmp6_;
			GearyLoggingRecord* _tmp7_;
			GearyLoggingRecord* _tmp8_;
#line 253 "../src/engine/util/util-logging.vala"
			_tmp5_ = record;
#line 253 "../src/engine/util/util-logging.vala"
			_tmp6_ = _geary_logging_record_ref0 (_tmp5_);
#line 253 "../src/engine/util/util-logging.vala"
			_geary_logging_record_unref0 (geary_logging_first_record);
#line 253 "../src/engine/util/util-logging.vala"
			geary_logging_first_record = _tmp6_;
#line 254 "../src/engine/util/util-logging.vala"
			_tmp7_ = record;
#line 254 "../src/engine/util/util-logging.vala"
			_tmp8_ = _geary_logging_record_ref0 (_tmp7_);
#line 254 "../src/engine/util/util-logging.vala"
			_geary_logging_record_unref0 (geary_logging_last_record);
#line 254 "../src/engine/util/util-logging.vala"
			geary_logging_last_record = _tmp8_;
#line 674 "util-logging.c"
		} else {
			GearyLoggingRecord* _tmp9_;
			GearyLoggingRecord* _tmp10_;
			GearyLoggingRecord* _tmp11_;
			GearyLoggingRecord* _tmp12_;
#line 256 "../src/engine/util/util-logging.vala"
			_tmp9_ = geary_logging_last_record;
#line 256 "../src/engine/util/util-logging.vala"
			_tmp10_ = record;
#line 256 "../src/engine/util/util-logging.vala"
			geary_logging_record_set_next (_tmp9_, _tmp10_);
#line 257 "../src/engine/util/util-logging.vala"
			_tmp11_ = record;
#line 257 "../src/engine/util/util-logging.vala"
			_tmp12_ = _geary_logging_record_ref0 (_tmp11_);
#line 257 "../src/engine/util/util-logging.vala"
			_geary_logging_record_unref0 (geary_logging_last_record);
#line 257 "../src/engine/util/util-logging.vala"
			geary_logging_last_record = _tmp12_;
#line 694 "util-logging.c"
		}
#line 260 "../src/engine/util/util-logging.vala"
		if (geary_logging_log_length == geary_logging_max_log_length) {
#line 698 "util-logging.c"
			GearyLoggingRecord* _tmp13_;
			GearyLoggingRecord* _tmp14_;
			GearyLoggingRecord* _tmp15_;
			GearyLoggingRecord* _tmp16_;
#line 261 "../src/engine/util/util-logging.vala"
			_tmp13_ = geary_logging_first_record;
#line 261 "../src/engine/util/util-logging.vala"
			_tmp14_ = geary_logging_record_get_next (_tmp13_);
#line 261 "../src/engine/util/util-logging.vala"
			_tmp15_ = _tmp14_;
#line 261 "../src/engine/util/util-logging.vala"
			_tmp16_ = _geary_logging_record_ref0 (_tmp15_);
#line 261 "../src/engine/util/util-logging.vala"
			_geary_logging_record_unref0 (geary_logging_first_record);
#line 261 "../src/engine/util/util-logging.vala"
			geary_logging_first_record = _tmp16_;
#line 715 "util-logging.c"
		} else {
			guint _tmp17_;
#line 263 "../src/engine/util/util-logging.vala"
			_tmp17_ = geary_logging_log_length;
#line 263 "../src/engine/util/util-logging.vala"
			geary_logging_log_length = _tmp17_ + 1;
#line 722 "util-logging.c"
		}
#line 265 "../src/engine/util/util-logging.vala"
		g_mutex_unlock (&geary_logging_record_lock);
#line 269 "../src/engine/util/util-logging.vala"
		_geary_logging_record_unref0 (old_record);
#line 269 "../src/engine/util/util-logging.vala"
		old_record = NULL;
#line 271 "../src/engine/util/util-logging.vala"
		_tmp18_ = geary_logging_listener;
#line 271 "../src/engine/util/util-logging.vala"
		_tmp18__target = geary_logging_listener_target;
#line 271 "../src/engine/util/util-logging.vala"
		if (_tmp18_ != NULL) {
#line 736 "util-logging.c"
			GearyLoggingLogRecord _tmp19_;
			gpointer _tmp19__target;
			GearyLoggingRecord* _tmp20_;
#line 272 "../src/engine/util/util-logging.vala"
			_tmp19_ = geary_logging_listener;
#line 272 "../src/engine/util/util-logging.vala"
			_tmp19__target = geary_logging_listener_target;
#line 272 "../src/engine/util/util-logging.vala"
			_tmp20_ = record;
#line 272 "../src/engine/util/util-logging.vala"
			_tmp19_ (_tmp20_, _tmp19__target);
#line 748 "util-logging.c"
		}
#line 275 "../src/engine/util/util-logging.vala"
		_tmp21_ = record;
#line 275 "../src/engine/util/util-logging.vala"
		geary_logging_write_record (_tmp21_, levels);
#line 241 "../src/engine/util/util-logging.vala"
		_geary_logging_record_unref0 (old_record);
#line 756 "util-logging.c"
	}
#line 278 "../src/engine/util/util-logging.vala"
	result = G_LOG_WRITER_HANDLED;
#line 278 "../src/engine/util/util-logging.vala"
	_geary_logging_record_unref0 (record);
#line 278 "../src/engine/util/util-logging.vala"
	return result;
#line 764 "util-logging.c"
}

inline gboolean
geary_logging_should_blacklist (GearyLoggingRecord* record)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result;
#line 281 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (GEARY_LOGGING_IS_RECORD (record), FALSE);
#line 288 "../src/engine/util/util-logging.vala"
	if (record->levels == G_LOG_LEVEL_WARNING) {
#line 778 "util-logging.c"
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 289 "../src/engine/util/util-logging.vala"
		_tmp3_ = geary_logging_record_get_domain (record);
#line 289 "../src/engine/util/util-logging.vala"
		_tmp4_ = _tmp3_;
#line 289 "../src/engine/util/util-logging.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "Gtk") == 0;
#line 787 "util-logging.c"
	} else {
#line 288 "../src/engine/util/util-logging.vala"
		_tmp2_ = FALSE;
#line 791 "util-logging.c"
	}
#line 288 "../src/engine/util/util-logging.vala"
	if (_tmp2_) {
#line 795 "util-logging.c"
		const gchar* _tmp5_;
#line 290 "../src/engine/util/util-logging.vala"
		_tmp5_ = record->message;
#line 290 "../src/engine/util/util-logging.vala"
		_tmp1_ = g_str_has_prefix (_tmp5_, "actionhelper:");
#line 801 "util-logging.c"
	} else {
#line 288 "../src/engine/util/util-logging.vala"
		_tmp1_ = FALSE;
#line 805 "util-logging.c"
	}
#line 282 "../src/engine/util/util-logging.vala"
	if (_tmp1_) {
#line 809 "util-logging.c"
		const gchar* _tmp6_;
#line 291 "../src/engine/util/util-logging.vala"
		_tmp6_ = record->message;
#line 291 "../src/engine/util/util-logging.vala"
		_tmp0_ = g_str_has_suffix (_tmp6_, "target type NULL)");
#line 815 "util-logging.c"
	} else {
#line 288 "../src/engine/util/util-logging.vala"
		_tmp0_ = FALSE;
#line 819 "util-logging.c"
	}
#line 282 "../src/engine/util/util-logging.vala"
	result = _tmp0_;
#line 282 "../src/engine/util/util-logging.vala"
	return result;
#line 825 "util-logging.c"
}

inline void
geary_logging_write_record (GearyLoggingRecord* record,
                            GLogLevelFlags levels)
{
	FILE* out = NULL;
	FILE* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	FILE* _tmp5_;
#line 295 "../src/engine/util/util-logging.vala"
	g_return_if_fail (GEARY_LOGGING_IS_RECORD (record));
#line 299 "../src/engine/util/util-logging.vala"
	_tmp0_ = geary_logging_stream;
#line 299 "../src/engine/util/util-logging.vala"
	out = _tmp0_;
#line 300 "../src/engine/util/util-logging.vala"
	_tmp5_ = out;
#line 300 "../src/engine/util/util-logging.vala"
	if (_tmp5_ != NULL) {
#line 849 "util-logging.c"
		GeeSet* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
#line 300 "../src/engine/util/util-logging.vala"
		_tmp6_ = geary_logging_suppressed_domains;
#line 300 "../src/engine/util/util-logging.vala"
		_tmp7_ = geary_logging_record_get_domain (record);
#line 300 "../src/engine/util/util-logging.vala"
		_tmp8_ = _tmp7_;
#line 300 "../src/engine/util/util-logging.vala"
		_tmp4_ = !gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_COLLECTION, GeeCollection), _tmp8_);
#line 861 "util-logging.c"
	} else {
#line 300 "../src/engine/util/util-logging.vala"
		_tmp4_ = FALSE;
#line 865 "util-logging.c"
	}
#line 300 "../src/engine/util/util-logging.vala"
	if (_tmp4_) {
#line 300 "../src/engine/util/util-logging.vala"
		_tmp3_ = TRUE;
#line 871 "util-logging.c"
	} else {
#line 301 "../src/engine/util/util-logging.vala"
		_tmp3_ = (levels & G_LOG_LEVEL_WARNING) == G_LOG_LEVEL_WARNING;
#line 875 "util-logging.c"
	}
#line 300 "../src/engine/util/util-logging.vala"
	if (_tmp3_) {
#line 300 "../src/engine/util/util-logging.vala"
		_tmp2_ = TRUE;
#line 881 "util-logging.c"
	} else {
#line 302 "../src/engine/util/util-logging.vala"
		_tmp2_ = (levels & G_LOG_LEVEL_CRITICAL) == G_LOG_LEVEL_CRITICAL;
#line 885 "util-logging.c"
	}
#line 300 "../src/engine/util/util-logging.vala"
	if (_tmp2_) {
#line 300 "../src/engine/util/util-logging.vala"
		_tmp1_ = TRUE;
#line 891 "util-logging.c"
	} else {
#line 303 "../src/engine/util/util-logging.vala"
		_tmp1_ = (levels & G_LOG_LEVEL_ERROR) == G_LOG_LEVEL_ERROR;
#line 895 "util-logging.c"
	}
#line 300 "../src/engine/util/util-logging.vala"
	if (_tmp1_) {
#line 899 "util-logging.c"
		FILE* _tmp9_;
		FILE* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		FILE* _tmp14_;
#line 305 "../src/engine/util/util-logging.vala"
		_tmp9_ = out;
#line 305 "../src/engine/util/util-logging.vala"
		if (_tmp9_ == NULL) {
#line 909 "util-logging.c"
			FILE* _tmp10_;
#line 306 "../src/engine/util/util-logging.vala"
			_tmp10_ = stderr;
#line 306 "../src/engine/util/util-logging.vala"
			out = _tmp10_;
#line 915 "util-logging.c"
		}
#line 311 "../src/engine/util/util-logging.vala"
		g_mutex_lock (&geary_logging_writer_lock);
#line 312 "../src/engine/util/util-logging.vala"
		_tmp11_ = out;
#line 312 "../src/engine/util/util-logging.vala"
		_tmp12_ = geary_logging_record_format (record);
#line 312 "../src/engine/util/util-logging.vala"
		_tmp13_ = _tmp12_;
#line 312 "../src/engine/util/util-logging.vala"
		fputs (_tmp13_, _tmp11_);
#line 312 "../src/engine/util/util-logging.vala"
		_g_free0 (_tmp13_);
#line 313 "../src/engine/util/util-logging.vala"
		_tmp14_ = out;
#line 313 "../src/engine/util/util-logging.vala"
		fputc ('\n', _tmp14_);
#line 314 "../src/engine/util/util-logging.vala"
		g_mutex_unlock (&geary_logging_writer_lock);
#line 316 "../src/engine/util/util-logging.vala"
		if ((geary_logging_set_breakpoint_on & levels) == levels) {
#line 317 "../src/engine/util/util-logging.vala"
			G_BREAKPOINT ();
#line 939 "util-logging.c"
		}
	}
}

inline gchar*
geary_logging_to_prefix (GLogLevelFlags level)
{
	gchar* result;
#line 324 "../src/engine/util/util-logging.vala"
	switch (level) {
#line 324 "../src/engine/util/util-logging.vala"
		case G_LOG_LEVEL_ERROR:
#line 952 "util-logging.c"
		{
			gchar* _tmp0_;
#line 326 "../src/engine/util/util-logging.vala"
			_tmp0_ = g_strdup ("![err]");
#line 326 "../src/engine/util/util-logging.vala"
			result = _tmp0_;
#line 326 "../src/engine/util/util-logging.vala"
			return result;
#line 961 "util-logging.c"
		}
#line 324 "../src/engine/util/util-logging.vala"
		case G_LOG_LEVEL_CRITICAL:
#line 965 "util-logging.c"
		{
			gchar* _tmp1_;
#line 329 "../src/engine/util/util-logging.vala"
			_tmp1_ = g_strdup ("![crt]");
#line 329 "../src/engine/util/util-logging.vala"
			result = _tmp1_;
#line 329 "../src/engine/util/util-logging.vala"
			return result;
#line 974 "util-logging.c"
		}
#line 324 "../src/engine/util/util-logging.vala"
		case G_LOG_LEVEL_WARNING:
#line 978 "util-logging.c"
		{
			gchar* _tmp2_;
#line 332 "../src/engine/util/util-logging.vala"
			_tmp2_ = g_strdup ("*[wrn]");
#line 332 "../src/engine/util/util-logging.vala"
			result = _tmp2_;
#line 332 "../src/engine/util/util-logging.vala"
			return result;
#line 987 "util-logging.c"
		}
#line 324 "../src/engine/util/util-logging.vala"
		case G_LOG_LEVEL_MESSAGE:
#line 991 "util-logging.c"
		{
			gchar* _tmp3_;
#line 335 "../src/engine/util/util-logging.vala"
			_tmp3_ = g_strdup (" [msg]");
#line 335 "../src/engine/util/util-logging.vala"
			result = _tmp3_;
#line 335 "../src/engine/util/util-logging.vala"
			return result;
#line 1000 "util-logging.c"
		}
#line 324 "../src/engine/util/util-logging.vala"
		case G_LOG_LEVEL_INFO:
#line 1004 "util-logging.c"
		{
			gchar* _tmp4_;
#line 338 "../src/engine/util/util-logging.vala"
			_tmp4_ = g_strdup (" [inf]");
#line 338 "../src/engine/util/util-logging.vala"
			result = _tmp4_;
#line 338 "../src/engine/util/util-logging.vala"
			return result;
#line 1013 "util-logging.c"
		}
#line 324 "../src/engine/util/util-logging.vala"
		case G_LOG_LEVEL_DEBUG:
#line 1017 "util-logging.c"
		{
			gchar* _tmp5_;
#line 341 "../src/engine/util/util-logging.vala"
			_tmp5_ = g_strdup (" [deb]");
#line 341 "../src/engine/util/util-logging.vala"
			result = _tmp5_;
#line 341 "../src/engine/util/util-logging.vala"
			return result;
#line 1026 "util-logging.c"
		}
#line 324 "../src/engine/util/util-logging.vala"
		case G_LOG_LEVEL_MASK:
#line 1030 "util-logging.c"
		{
			gchar* _tmp6_;
#line 344 "../src/engine/util/util-logging.vala"
			_tmp6_ = g_strdup ("![***]");
#line 344 "../src/engine/util/util-logging.vala"
			result = _tmp6_;
#line 344 "../src/engine/util/util-logging.vala"
			return result;
#line 1039 "util-logging.c"
		}
		default:
		{
			gchar* _tmp7_;
#line 347 "../src/engine/util/util-logging.vala"
			_tmp7_ = g_strdup ("![???]");
#line 347 "../src/engine/util/util-logging.vala"
			result = _tmp7_;
#line 347 "../src/engine/util/util-logging.vala"
			return result;
#line 1050 "util-logging.c"
		}
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 1075 "util-logging.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 1084 "util-logging.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 1103 "util-logging.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1107 "util-logging.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1113 "util-logging.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1123 "util-logging.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1131 "util-logging.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1135 "util-logging.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 1141 "util-logging.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 1151 "util-logging.c"
}

inline gchar*
geary_logging_field_to_string (GLogField* field)
{
	gchar* value = NULL;
	GLogField _tmp0_;
	gchar* result;
#line 352 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (field != NULL, NULL);
#line 353 "../src/engine/util/util-logging.vala"
	value = NULL;
#line 354 "../src/engine/util/util-logging.vala"
	_tmp0_ = *field;
#line 354 "../src/engine/util/util-logging.vala"
	if (_tmp0_.length < ((gssize) 0)) {
#line 1168 "util-logging.c"
		GLogField _tmp1_;
		gconstpointer _tmp2_;
		gchar* _tmp3_;
#line 355 "../src/engine/util/util-logging.vala"
		_tmp1_ = *field;
#line 355 "../src/engine/util/util-logging.vala"
		_tmp2_ = _tmp1_.value;
#line 355 "../src/engine/util/util-logging.vala"
		_tmp3_ = g_strdup ((const gchar*) _tmp2_);
#line 355 "../src/engine/util/util-logging.vala"
		_g_free0 (value);
#line 355 "../src/engine/util/util-logging.vala"
		value = _tmp3_;
#line 1182 "util-logging.c"
	} else {
		GLogField _tmp4_;
#line 356 "../src/engine/util/util-logging.vala"
		_tmp4_ = *field;
#line 356 "../src/engine/util/util-logging.vala"
		if (_tmp4_.length > ((gssize) 0)) {
#line 1189 "util-logging.c"
			GLogField _tmp5_;
			gconstpointer _tmp6_;
			GLogField _tmp7_;
			gchar* _tmp8_;
#line 357 "../src/engine/util/util-logging.vala"
			_tmp5_ = *field;
#line 357 "../src/engine/util/util-logging.vala"
			_tmp6_ = _tmp5_.value;
#line 357 "../src/engine/util/util-logging.vala"
			_tmp7_ = *field;
#line 357 "../src/engine/util/util-logging.vala"
			_tmp8_ = string_substring ((const gchar*) _tmp6_, (glong) 0, (glong) _tmp7_.length);
#line 357 "../src/engine/util/util-logging.vala"
			_g_free0 (value);
#line 357 "../src/engine/util/util-logging.vala"
			value = _tmp8_;
#line 1206 "util-logging.c"
		}
	}
#line 359 "../src/engine/util/util-logging.vala"
	result = value;
#line 359 "../src/engine/util/util-logging.vala"
	return result;
#line 1213 "util-logging.c"
}

/**
     * Returns a string representation of a source based on its state.
     *
     * The string returned will include the source's type name, the
     * its current logging state, and the value of extra_values, if
     * any.
     */
gchar*
geary_logging_source_default_to_string (GearyLoggingSource* source,
                                        const gchar* extra_values)
{
	const gchar* _tmp0_;
	GearyLoggingState* _tmp1_;
	GearyLoggingState* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* result;
#line 384 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (GEARY_LOGGING_IS_SOURCE (source), NULL);
#line 384 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (extra_values != NULL, NULL);
#line 386 "../src/engine/util/util-logging.vala"
	_tmp0_ = g_type_name (G_TYPE_FROM_INSTANCE (G_TYPE_CHECK_INSTANCE_CAST (source, G_TYPE_OBJECT, GObject)));
#line 386 "../src/engine/util/util-logging.vala"
	_tmp1_ = geary_logging_source_to_logging_state (source);
#line 386 "../src/engine/util/util-logging.vala"
	_tmp2_ = _tmp1_;
#line 386 "../src/engine/util/util-logging.vala"
	_tmp3_ = geary_logging_state_format_message (_tmp2_);
#line 386 "../src/engine/util/util-logging.vala"
	_tmp4_ = _tmp3_;
#line 386 "../src/engine/util/util-logging.vala"
	_tmp5_ = g_strdup_printf ("%s(%s%s)", _tmp0_, _tmp4_, extra_values);
#line 386 "../src/engine/util/util-logging.vala"
	_tmp6_ = _tmp5_;
#line 386 "../src/engine/util/util-logging.vala"
	_g_free0 (_tmp4_);
#line 386 "../src/engine/util/util-logging.vala"
	_geary_logging_state_unref0 (_tmp2_);
#line 386 "../src/engine/util/util-logging.vala"
	result = _tmp6_;
#line 386 "../src/engine/util/util-logging.vala"
	return result;
#line 1261 "util-logging.c"
}

static gchar*
geary_logging_source_log_level_to_priority (GLogLevelFlags level)
{
	gchar* _tmp6_;
	gchar* result;
#line 398 "../src/engine/util/util-logging.vala"
	if ((level & G_LOG_LEVEL_ERROR) == G_LOG_LEVEL_ERROR) {
#line 1271 "util-logging.c"
		gchar* _tmp0_;
#line 399 "../src/engine/util/util-logging.vala"
		_tmp0_ = g_strdup ("3");
#line 399 "../src/engine/util/util-logging.vala"
		result = _tmp0_;
#line 399 "../src/engine/util/util-logging.vala"
		return result;
#line 1279 "util-logging.c"
	}
#line 401 "../src/engine/util/util-logging.vala"
	if ((level & G_LOG_LEVEL_CRITICAL) == G_LOG_LEVEL_CRITICAL) {
#line 1283 "util-logging.c"
		gchar* _tmp1_;
#line 402 "../src/engine/util/util-logging.vala"
		_tmp1_ = g_strdup ("4");
#line 402 "../src/engine/util/util-logging.vala"
		result = _tmp1_;
#line 402 "../src/engine/util/util-logging.vala"
		return result;
#line 1291 "util-logging.c"
	}
#line 404 "../src/engine/util/util-logging.vala"
	if ((level & G_LOG_LEVEL_WARNING) == G_LOG_LEVEL_WARNING) {
#line 1295 "util-logging.c"
		gchar* _tmp2_;
#line 405 "../src/engine/util/util-logging.vala"
		_tmp2_ = g_strdup ("4");
#line 405 "../src/engine/util/util-logging.vala"
		result = _tmp2_;
#line 405 "../src/engine/util/util-logging.vala"
		return result;
#line 1303 "util-logging.c"
	}
#line 407 "../src/engine/util/util-logging.vala"
	if ((level & G_LOG_LEVEL_MESSAGE) == G_LOG_LEVEL_MESSAGE) {
#line 1307 "util-logging.c"
		gchar* _tmp3_;
#line 408 "../src/engine/util/util-logging.vala"
		_tmp3_ = g_strdup ("5");
#line 408 "../src/engine/util/util-logging.vala"
		result = _tmp3_;
#line 408 "../src/engine/util/util-logging.vala"
		return result;
#line 1315 "util-logging.c"
	}
#line 410 "../src/engine/util/util-logging.vala"
	if ((level & G_LOG_LEVEL_INFO) == G_LOG_LEVEL_INFO) {
#line 1319 "util-logging.c"
		gchar* _tmp4_;
#line 411 "../src/engine/util/util-logging.vala"
		_tmp4_ = g_strdup ("6");
#line 411 "../src/engine/util/util-logging.vala"
		result = _tmp4_;
#line 411 "../src/engine/util/util-logging.vala"
		return result;
#line 1327 "util-logging.c"
	}
#line 413 "../src/engine/util/util-logging.vala"
	if ((level & G_LOG_LEVEL_DEBUG) == G_LOG_LEVEL_DEBUG) {
#line 1331 "util-logging.c"
		gchar* _tmp5_;
#line 414 "../src/engine/util/util-logging.vala"
		_tmp5_ = g_strdup ("7");
#line 414 "../src/engine/util/util-logging.vala"
		result = _tmp5_;
#line 414 "../src/engine/util/util-logging.vala"
		return result;
#line 1339 "util-logging.c"
	}
#line 418 "../src/engine/util/util-logging.vala"
	_tmp6_ = g_strdup ("5");
#line 418 "../src/engine/util/util-logging.vala"
	result = _tmp6_;
#line 418 "../src/engine/util/util-logging.vala"
	return result;
#line 1347 "util-logging.c"
}

const gchar*
geary_logging_source_get_logging_domain (GearyLoggingSource* self)
{
	GearyLoggingSourceIface* _iface_;
#line 479 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (GEARY_LOGGING_IS_SOURCE (self), NULL);
#line 479 "../src/engine/util/util-logging.vala"
	_iface_ = GEARY_LOGGING_SOURCE_GET_INTERFACE (self);
#line 479 "../src/engine/util/util-logging.vala"
	if (_iface_->get_logging_domain) {
#line 479 "../src/engine/util/util-logging.vala"
		return _iface_->get_logging_domain (self);
#line 1362 "util-logging.c"
	}
#line 479 "../src/engine/util/util-logging.vala"
	return NULL;
#line 1366 "util-logging.c"
}

static const gchar*
geary_logging_source_real_get_logging_domain (GearyLoggingSource* base)
{
	const gchar* result;
	GearyLoggingSource* self;
#line 479 "../src/engine/util/util-logging.vala"
	self = base;
#line 479 "../src/engine/util/util-logging.vala"
	result = GEARY_LOGGING_DOMAIN;
#line 479 "../src/engine/util/util-logging.vala"
	return result;
#line 1380 "util-logging.c"
}

GearyLoggingSource*
geary_logging_source_get_logging_parent (GearyLoggingSource* self)
{
	GearyLoggingSourceIface* _iface_;
#line 488 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (GEARY_LOGGING_IS_SOURCE (self), NULL);
#line 488 "../src/engine/util/util-logging.vala"
	_iface_ = GEARY_LOGGING_SOURCE_GET_INTERFACE (self);
#line 488 "../src/engine/util/util-logging.vala"
	if (_iface_->get_logging_parent) {
#line 488 "../src/engine/util/util-logging.vala"
		return _iface_->get_logging_parent (self);
#line 1395 "util-logging.c"
	}
#line 488 "../src/engine/util/util-logging.vala"
	return NULL;
#line 1399 "util-logging.c"
}

/**
     * Returns a loggable representation of this source's current state.
     *
     * Since this source's internal state may change between being
     * logged and being used from a log record, this records relevant
     * state at the time when it was logged so it may be displayed or
     * recorded as it is right now.
     */
GearyLoggingState*
geary_logging_source_to_logging_state (GearyLoggingSource* self)
{
	GearyLoggingSourceIface* _iface_;
#line 498 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (GEARY_LOGGING_IS_SOURCE (self), NULL);
#line 498 "../src/engine/util/util-logging.vala"
	_iface_ = GEARY_LOGGING_SOURCE_GET_INTERFACE (self);
#line 498 "../src/engine/util/util-logging.vala"
	if (_iface_->to_logging_state) {
#line 498 "../src/engine/util/util-logging.vala"
		return _iface_->to_logging_state (self);
#line 1422 "util-logging.c"
	}
#line 498 "../src/engine/util/util-logging.vala"
	return NULL;
#line 1426 "util-logging.c"
}

/**
     * Returns a string representation of this source based on its state.
     *
     * This simply calls {@link default_to_string} with this source
     * and the empty string, returning the result. Implementations of
     * this interface can call that method if they need to override
     * the default behaviour of this method.
     */
static gchar*
geary_logging_source_real_to_string (GearyLoggingSource* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 509 "../src/engine/util/util-logging.vala"
	_tmp0_ = geary_logging_source_default_to_string (self, "");
#line 509 "../src/engine/util/util-logging.vala"
	result = _tmp0_;
#line 509 "../src/engine/util/util-logging.vala"
	return result;
#line 1448 "util-logging.c"
}

gchar*
geary_logging_source_to_string (GearyLoggingSource* self)
{
	GearyLoggingSourceIface* _iface_;
#line 508 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (GEARY_LOGGING_IS_SOURCE (self), NULL);
#line 508 "../src/engine/util/util-logging.vala"
	_iface_ = GEARY_LOGGING_SOURCE_GET_INTERFACE (self);
#line 508 "../src/engine/util/util-logging.vala"
	if (_iface_->to_string) {
#line 508 "../src/engine/util/util-logging.vala"
		return _iface_->to_string (self);
#line 1463 "util-logging.c"
	}
#line 508 "../src/engine/util/util-logging.vala"
	return NULL;
#line 1467 "util-logging.c"
}

/**
     * Logs a debug-level log message with this object as context.
     */
inline void
geary_logging_source_debug (GearyLoggingSource* self,
                            const gchar* fmt,
                            ...)
{
	va_list _tmp0_ = {0};
#line 516 "../src/engine/util/util-logging.vala"
	g_return_if_fail (fmt != NULL);
#line 517 "../src/engine/util/util-logging.vala"
	va_start (_tmp0_, fmt);
#line 517 "../src/engine/util/util-logging.vala"
	geary_logging_source_log_structured (self, G_LOG_LEVEL_DEBUG, fmt, _tmp0_);
#line 517 "../src/engine/util/util-logging.vala"
	va_end (_tmp0_);
#line 1487 "util-logging.c"
}

/**
     * Logs a message-level log message with this object as context.
     */
inline void
geary_logging_source_message (GearyLoggingSource* self,
                              const gchar* fmt,
                              ...)
{
	va_list _tmp0_ = {0};
#line 524 "../src/engine/util/util-logging.vala"
	g_return_if_fail (fmt != NULL);
#line 525 "../src/engine/util/util-logging.vala"
	va_start (_tmp0_, fmt);
#line 525 "../src/engine/util/util-logging.vala"
	geary_logging_source_log_structured (self, G_LOG_LEVEL_MESSAGE, fmt, _tmp0_);
#line 525 "../src/engine/util/util-logging.vala"
	va_end (_tmp0_);
#line 1507 "util-logging.c"
}

/**
     * Logs a warning-level log message with this object as context.
     */
inline void
geary_logging_source_warning (GearyLoggingSource* self,
                              const gchar* fmt,
                              ...)
{
	va_list _tmp0_ = {0};
#line 532 "../src/engine/util/util-logging.vala"
	g_return_if_fail (fmt != NULL);
#line 533 "../src/engine/util/util-logging.vala"
	va_start (_tmp0_, fmt);
#line 533 "../src/engine/util/util-logging.vala"
	geary_logging_source_log_structured (self, G_LOG_LEVEL_WARNING, fmt, _tmp0_);
#line 533 "../src/engine/util/util-logging.vala"
	va_end (_tmp0_);
#line 1527 "util-logging.c"
}

/**
     * Logs a error-level log message with this object as context.
     */
inline void
geary_logging_source_error (GearyLoggingSource* self,
                            const gchar* fmt,
                            ...)
{
	va_list _tmp0_ = {0};
#line 541 "../src/engine/util/util-logging.vala"
	g_return_if_fail (fmt != NULL);
#line 542 "../src/engine/util/util-logging.vala"
	va_start (_tmp0_, fmt);
#line 542 "../src/engine/util/util-logging.vala"
	geary_logging_source_log_structured (self, G_LOG_LEVEL_ERROR, fmt, _tmp0_);
#line 542 "../src/engine/util/util-logging.vala"
	va_end (_tmp0_);
#line 1547 "util-logging.c"
}

/**
     * Logs a critical-level log message with this object as context.
     */
inline void
geary_logging_source_critical (GearyLoggingSource* self,
                               const gchar* fmt,
                               ...)
{
	va_list _tmp0_ = {0};
#line 549 "../src/engine/util/util-logging.vala"
	g_return_if_fail (fmt != NULL);
#line 550 "../src/engine/util/util-logging.vala"
	va_start (_tmp0_, fmt);
#line 550 "../src/engine/util/util-logging.vala"
	geary_logging_source_log_structured (self, G_LOG_LEVEL_CRITICAL, fmt, _tmp0_);
#line 550 "../src/engine/util/util-logging.vala"
	va_end (_tmp0_);
#line 1567 "util-logging.c"
}

static inline void
geary_logging_source_log_structured (GearyLoggingSource* self,
                                     GLogLevelFlags levels,
                                     const gchar* fmt,
                                     va_list args)
{
	GearyLoggingSourceContext context = {0};
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GearyLoggingSource* decorated = NULL;
	gint _tmp8_ = 0;
	GLogField* _tmp9_;
	GLogField* _tmp10_;
	gint _tmp10__length1;
#line 553 "../src/engine/util/util-logging.vala"
	g_return_if_fail (fmt != NULL);
#line 556 "../src/engine/util/util-logging.vala"
	_tmp0_ = geary_logging_source_get_logging_domain (self);
#line 556 "../src/engine/util/util-logging.vala"
	_tmp1_ = _tmp0_;
#line 556 "../src/engine/util/util-logging.vala"
	geary_logging_source_context_init (&context, _tmp1_, levels, fmt, args);
#line 558 "../src/engine/util/util-logging.vala"
	decorated = self;
#line 559 "../src/engine/util/util-logging.vala"
	while (TRUE) {
#line 1596 "util-logging.c"
		GearyLoggingSource* _tmp2_;
		GearyLoggingSource* _tmp3_;
		GearyLoggingSource* _tmp5_;
		GearyLoggingSource* _tmp6_;
		GearyLoggingSource* _tmp7_;
#line 559 "../src/engine/util/util-logging.vala"
		_tmp2_ = decorated;
#line 559 "../src/engine/util/util-logging.vala"
		if (!(_tmp2_ != NULL)) {
#line 559 "../src/engine/util/util-logging.vala"
			break;
#line 1608 "util-logging.c"
		}
#line 563 "../src/engine/util/util-logging.vala"
		_tmp3_ = decorated;
#line 563 "../src/engine/util/util-logging.vala"
		if (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, G_TYPE_OBJECT, GObject)->ref_count > ((guint) 0)) {
#line 1614 "util-logging.c"
			GearyLoggingSource* _tmp4_;
#line 564 "../src/engine/util/util-logging.vala"
			_tmp4_ = decorated;
#line 564 "../src/engine/util/util-logging.vala"
			geary_logging_source_context_append_source (&context, _tmp4_);
#line 1620 "util-logging.c"
		}
#line 566 "../src/engine/util/util-logging.vala"
		_tmp5_ = decorated;
#line 566 "../src/engine/util/util-logging.vala"
		_tmp6_ = geary_logging_source_get_logging_parent (_tmp5_);
#line 566 "../src/engine/util/util-logging.vala"
		_tmp7_ = _tmp6_;
#line 566 "../src/engine/util/util-logging.vala"
		decorated = _tmp7_;
#line 1630 "util-logging.c"
	}
#line 569 "../src/engine/util/util-logging.vala"
	_tmp9_ = geary_logging_source_context_to_array (&context, &_tmp8_);
#line 569 "../src/engine/util/util-logging.vala"
	_tmp10_ = _tmp9_;
#line 569 "../src/engine/util/util-logging.vala"
	_tmp10__length1 = _tmp8_;
#line 569 "../src/engine/util/util-logging.vala"
	g_log_structured_array (levels, _tmp10_, (gint) _tmp8_);
#line 569 "../src/engine/util/util-logging.vala"
	_tmp10_ = (g_free (_tmp10_), NULL);
#line 553 "../src/engine/util/util-logging.vala"
	geary_logging_source_context_destroy (&context);
#line 1644 "util-logging.c"
}

static void
geary_logging_source_context_init (GearyLoggingSourceContext *self,
                                   const gchar* domain,
                                   GLogLevelFlags level,
                                   const gchar* message,
                                   va_list args)
{
	GLogField* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	va_list _tmp3_ = {0};
	gchar* _tmp4_;
#line 434 "../src/engine/util/util-logging.vala"
	g_return_if_fail (domain != NULL);
#line 434 "../src/engine/util/util-logging.vala"
	g_return_if_fail (message != NULL);
#line 434 "../src/engine/util/util-logging.vala"
	memset (self, 0, sizeof (GearyLoggingSourceContext));
#line 438 "../src/engine/util/util-logging.vala"
	_tmp0_ = g_new0 (GLogField, GEARY_LOGGING_SOURCE_CONTEXT_FIELD_COUNT);
#line 438 "../src/engine/util/util-logging.vala"
	(*self).fields = (g_free ((*self).fields), NULL);
#line 438 "../src/engine/util/util-logging.vala"
	(*self).fields = _tmp0_;
#line 438 "../src/engine/util/util-logging.vala"
	(*self).fields_length1 = GEARY_LOGGING_SOURCE_CONTEXT_FIELD_COUNT;
#line 439 "../src/engine/util/util-logging.vala"
	(*self).len = GEARY_LOGGING_SOURCE_CONTEXT_FIELD_COUNT;
#line 440 "../src/engine/util/util-logging.vala"
	(*self).count = (guint8) 0;
#line 441 "../src/engine/util/util-logging.vala"
	_tmp1_ = geary_logging_source_log_level_to_priority (level);
#line 441 "../src/engine/util/util-logging.vala"
	_tmp2_ = _tmp1_;
#line 441 "../src/engine/util/util-logging.vala"
	geary_logging_source_context_append (&(*self), G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, "PRIORITY", _tmp2_);
#line 441 "../src/engine/util/util-logging.vala"
	_g_free0 (_tmp2_);
#line 442 "../src/engine/util/util-logging.vala"
	geary_logging_source_context_append (&(*self), G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, "GLIB_DOMAIN", domain);
#line 444 "../src/engine/util/util-logging.vala"
	va_copy (_tmp3_, args);
#line 444 "../src/engine/util/util-logging.vala"
	_tmp4_ = g_strdup_vprintf (message, _tmp3_);
#line 444 "../src/engine/util/util-logging.vala"
	_g_free0 ((*self).message);
#line 444 "../src/engine/util/util-logging.vala"
	(*self).message = _tmp4_;
#line 444 "../src/engine/util/util-logging.vala"
	va_end (_tmp3_);
#line 1697 "util-logging.c"
}

void
geary_logging_source_context_append (GearyLoggingSourceContext *self,
                                     GType t_type,
                                     GBoxedCopyFunc t_dup_func,
                                     GDestroyNotify t_destroy_func,
                                     const gchar* key,
                                     gconstpointer value)
{
	guint8 count = 0U;
	GLogField* _tmp1_;
	gint _tmp1__length1;
	GLogField* _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_ = 0;
	GLogField* _tmp4_;
	gint _tmp4__length1;
	guint8 _tmp5_;
#line 447 "../src/engine/util/util-logging.vala"
	g_return_if_fail (key != NULL);
#line 448 "../src/engine/util/util-logging.vala"
	count = (*self).count;
#line 449 "../src/engine/util/util-logging.vala"
	if ((count + 1) >= ((gint) (*self).len)) {
#line 1723 "util-logging.c"
		gint _tmp0_;
#line 450 "../src/engine/util/util-logging.vala"
		_tmp0_ = (gint) ((*self).len + GEARY_LOGGING_SOURCE_CONTEXT_FIELD_COUNT);
#line 450 "../src/engine/util/util-logging.vala"
		(*self).fields = g_renew (GLogField, (*self).fields, (gint) ((*self).len + GEARY_LOGGING_SOURCE_CONTEXT_FIELD_COUNT));
#line 450 "../src/engine/util/util-logging.vala"
		(_tmp0_ > (*self).fields_length1) ? memset ((*self).fields + (*self).fields_length1, 0, sizeof (GLogField) * (_tmp0_ - (*self).fields_length1)) : NULL;
#line 450 "../src/engine/util/util-logging.vala"
		(*self).fields_length1 = _tmp0_;
#line 1733 "util-logging.c"
	}
#line 453 "../src/engine/util/util-logging.vala"
	_tmp1_ = (*self).fields;
#line 453 "../src/engine/util/util-logging.vala"
	_tmp1__length1 = (*self).fields_length1;
#line 453 "../src/engine/util/util-logging.vala"
	_tmp1_[count].key = key;
#line 454 "../src/engine/util/util-logging.vala"
	_tmp2_ = (*self).fields;
#line 454 "../src/engine/util/util-logging.vala"
	_tmp2__length1 = (*self).fields_length1;
#line 454 "../src/engine/util/util-logging.vala"
	_tmp2_[count].value = value;
#line 455 "../src/engine/util/util-logging.vala"
	if (t_type == G_TYPE_STRING) {
#line 455 "../src/engine/util/util-logging.vala"
		_tmp3_ = -1;
#line 1751 "util-logging.c"
	} else {
#line 455 "../src/engine/util/util-logging.vala"
		_tmp3_ = 0;
#line 1755 "util-logging.c"
	}
#line 455 "../src/engine/util/util-logging.vala"
	_tmp4_ = (*self).fields;
#line 455 "../src/engine/util/util-logging.vala"
	_tmp4__length1 = (*self).fields_length1;
#line 455 "../src/engine/util/util-logging.vala"
	_tmp4_[count].length = (gssize) _tmp3_;
#line 457 "../src/engine/util/util-logging.vala"
	_tmp5_ = (*self).count;
#line 457 "../src/engine/util/util-logging.vala"
	(*self).count = _tmp5_ + 1;
#line 1767 "util-logging.c"
}

inline void
geary_logging_source_context_append_source (GearyLoggingSourceContext *self,
                                            GearyLoggingSource* value)
{
#line 460 "../src/engine/util/util-logging.vala"
	g_return_if_fail (GEARY_LOGGING_IS_SOURCE (value));
#line 461 "../src/engine/util/util-logging.vala"
	geary_logging_source_context_append (&(*self), GEARY_LOGGING_TYPE_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, "GEARY_LOGGING_SOURCE", value);
#line 1778 "util-logging.c"
}

static GLogField*
_vala_array_dup17 (GLogField* self,
                   gssize length)
{
#line 467 "../src/engine/util/util-logging.vala"
	if (length > 0) {
#line 467 "../src/engine/util/util-logging.vala"
		return g_memdup2 (self, length * sizeof (GLogField));
#line 1789 "util-logging.c"
	}
#line 467 "../src/engine/util/util-logging.vala"
	return NULL;
#line 1793 "util-logging.c"
}

GLogField*
geary_logging_source_context_to_array (GearyLoggingSourceContext *self,
                                       gint* result_length1)
{
	const gchar* _tmp0_;
	GLogField* _tmp1_;
	gint _tmp1__length1;
	GLogField* _tmp2_;
	gint _tmp2__length1;
	GLogField* _tmp3_;
	gint _tmp3__length1;
	GLogField* result;
#line 466 "../src/engine/util/util-logging.vala"
	_tmp0_ = (*self).message;
#line 466 "../src/engine/util/util-logging.vala"
	geary_logging_source_context_append (&(*self), G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, "MESSAGE", _tmp0_);
#line 467 "../src/engine/util/util-logging.vala"
	_tmp1_ = (*self).fields;
#line 467 "../src/engine/util/util-logging.vala"
	_tmp1__length1 = (*self).fields_length1;
#line 467 "../src/engine/util/util-logging.vala"
	_tmp2_ = (_tmp1_ != NULL) ? _vala_array_dup17 (_tmp1_ + 0, ((gint) (*self).count) - 0) : _tmp1_;
#line 467 "../src/engine/util/util-logging.vala"
	_tmp2__length1 = ((gint) (*self).count) - 0;
#line 467 "../src/engine/util/util-logging.vala"
	_tmp3_ = _tmp2_;
#line 467 "../src/engine/util/util-logging.vala"
	_tmp3__length1 = _tmp2__length1;
#line 467 "../src/engine/util/util-logging.vala"
	if (result_length1) {
#line 467 "../src/engine/util/util-logging.vala"
		*result_length1 = _tmp3__length1;
#line 1828 "util-logging.c"
	}
#line 467 "../src/engine/util/util-logging.vala"
	result = _tmp3_;
#line 467 "../src/engine/util/util-logging.vala"
	return result;
#line 1834 "util-logging.c"
}

static GLogField*
_vala_array_dup18 (GLogField* self,
                   gssize length)
{
#line 422 "../src/engine/util/util-logging.vala"
	if (length > 0) {
#line 422 "../src/engine/util/util-logging.vala"
		return g_memdup2 (self, length * sizeof (GLogField));
#line 1845 "util-logging.c"
	}
#line 422 "../src/engine/util/util-logging.vala"
	return NULL;
#line 1849 "util-logging.c"
}

void
geary_logging_source_context_copy (const GearyLoggingSourceContext* self,
                                   GearyLoggingSourceContext* dest)
{
	GLogField* _tmp0_;
	gint _tmp0__length1;
	GLogField* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 422 "../src/engine/util/util-logging.vala"
	_tmp0_ = (*self).fields;
#line 422 "../src/engine/util/util-logging.vala"
	_tmp0__length1 = (*self).fields_length1;
#line 422 "../src/engine/util/util-logging.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup18 (_tmp0_, _tmp0__length1) : _tmp0_;
#line 422 "../src/engine/util/util-logging.vala"
	_tmp1__length1 = _tmp0__length1;
#line 422 "../src/engine/util/util-logging.vala"
	(*dest).fields = (g_free ((*dest).fields), NULL);
#line 422 "../src/engine/util/util-logging.vala"
	(*dest).fields = _tmp1_;
#line 422 "../src/engine/util/util-logging.vala"
	(*dest).fields_length1 = _tmp1__length1;
#line 422 "../src/engine/util/util-logging.vala"
	(*dest).len = (*self).len;
#line 422 "../src/engine/util/util-logging.vala"
	(*dest).count = (*self).count;
#line 422 "../src/engine/util/util-logging.vala"
	_tmp2_ = (*self).message;
#line 422 "../src/engine/util/util-logging.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 422 "../src/engine/util/util-logging.vala"
	_g_free0 ((*dest).message);
#line 422 "../src/engine/util/util-logging.vala"
	(*dest).message = _tmp3_;
#line 1888 "util-logging.c"
}

void
geary_logging_source_context_destroy (GearyLoggingSourceContext* self)
{
#line 427 "../src/engine/util/util-logging.vala"
	(*self).fields = (g_free ((*self).fields), NULL);
#line 431 "../src/engine/util/util-logging.vala"
	_g_free0 ((*self).message);
#line 1898 "util-logging.c"
}

GearyLoggingSourceContext*
geary_logging_source_context_dup (const GearyLoggingSourceContext* self)
{
	GearyLoggingSourceContext* dup;
#line 422 "../src/engine/util/util-logging.vala"
	dup = g_new0 (GearyLoggingSourceContext, 1);
#line 422 "../src/engine/util/util-logging.vala"
	geary_logging_source_context_copy (self, dup);
#line 422 "../src/engine/util/util-logging.vala"
	return dup;
#line 1911 "util-logging.c"
}

void
geary_logging_source_context_free (GearyLoggingSourceContext* self)
{
#line 422 "../src/engine/util/util-logging.vala"
	geary_logging_source_context_destroy (self);
#line 422 "../src/engine/util/util-logging.vala"
	g_free (self);
#line 1921 "util-logging.c"
}

 G_GNUC_NO_INLINE static GType
geary_logging_source_context_get_type_once (void)
{
	GType geary_logging_source_context_type_id;
	geary_logging_source_context_type_id = g_boxed_type_register_static ("GearyLoggingSourceContext", (GBoxedCopyFunc) geary_logging_source_context_dup, (GBoxedFreeFunc) geary_logging_source_context_free);
	return geary_logging_source_context_type_id;
}

GType
geary_logging_source_context_get_type (void)
{
	static gsize geary_logging_source_context_type_id__once = 0;
	if (g_once_init_enter (&geary_logging_source_context_type_id__once)) {
		GType geary_logging_source_context_type_id;
		geary_logging_source_context_type_id = geary_logging_source_context_get_type_once ();
		g_once_init_leave (&geary_logging_source_context_type_id__once, geary_logging_source_context_type_id);
	}
	return geary_logging_source_context_type_id__once;
}

static void
geary_logging_source_default_init (GearyLoggingSourceIface * iface,
                                   gpointer iface_data)
{
	/**
	     * The parent of this source.
	     *
	     * If not null, the parent and its ancestors recursively will be
	     * added to to log message context.
	     */
#line 374 "../src/engine/util/util-logging.vala"
	g_object_interface_install_property (iface, g_param_spec_object ("logging-parent", "logging-parent", "logging-parent", GEARY_LOGGING_TYPE_SOURCE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 374 "../src/engine/util/util-logging.vala"
	iface->to_string = geary_logging_source_real_to_string;
#line 374 "../src/engine/util/util-logging.vala"
	iface->get_logging_domain = geary_logging_source_real_get_logging_domain;
#line 1960 "util-logging.c"
}

/**
 * Mixin interface for objects that support structured logging.
 *
 * Logging sources provide both a standard means to obtain a string
 * representation of the object for display to humans, and keep a weak
 * reference to some parent source, enabling context to be
 * automatically added to logging calls. For example, if a Foo object
 * is the logging source parent of a Bar object, log calls made by Bar
 * will automatically be decorated with Foo.
 */
 G_GNUC_NO_INLINE static GType
geary_logging_source_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyLoggingSourceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_logging_source_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType geary_logging_source_type_id;
	geary_logging_source_type_id = g_type_register_static (G_TYPE_INTERFACE, "GearyLoggingSource", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (geary_logging_source_type_id, G_TYPE_OBJECT);
	return geary_logging_source_type_id;
}

GType
geary_logging_source_get_type (void)
{
	static gsize geary_logging_source_type_id__once = 0;
	if (g_once_init_enter (&geary_logging_source_type_id__once)) {
		GType geary_logging_source_type_id;
		geary_logging_source_type_id = geary_logging_source_get_type_once ();
		g_once_init_leave (&geary_logging_source_type_id__once, geary_logging_source_type_id);
	}
	return geary_logging_source_type_id__once;
}

static inline gpointer
geary_logging_state_get_instance_private (GearyLoggingState* self)
{
	return G_STRUCT_MEMBER_P (self, GearyLoggingState_private_offset);
}

GearyLoggingSource*
geary_logging_state_get_source (GearyLoggingState* self)
{
	GearyLoggingSource* result;
	GearyLoggingSource* _tmp0_;
#line 584 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (GEARY_LOGGING_IS_STATE (self), NULL);
#line 584 "../src/engine/util/util-logging.vala"
	_tmp0_ = self->priv->_source;
#line 584 "../src/engine/util/util-logging.vala"
	result = _tmp0_;
#line 584 "../src/engine/util/util-logging.vala"
	return result;
#line 2014 "util-logging.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 584 "../src/engine/util/util-logging.vala"
	return self ? g_object_ref (self) : NULL;
#line 2022 "util-logging.c"
}

static void
geary_logging_state_set_source (GearyLoggingState* self,
                                GearyLoggingSource* value)
{
	GearyLoggingSource* _tmp0_;
#line 584 "../src/engine/util/util-logging.vala"
	g_return_if_fail (GEARY_LOGGING_IS_STATE (self));
#line 584 "../src/engine/util/util-logging.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 584 "../src/engine/util/util-logging.vala"
	_g_object_unref0 (self->priv->_source);
#line 584 "../src/engine/util/util-logging.vala"
	self->priv->_source = _tmp0_;
#line 2038 "util-logging.c"
}

GearyLoggingState*
geary_logging_state_constructv (GType object_type,
                                GearyLoggingSource* source,
                                const gchar* message,
                                va_list _vala_va_list)
{
	GearyLoggingState* self = NULL;
	gchar* _tmp0_;
	va_list _tmp1_ = {0};
	gchar* _tmp2_;
#line 600 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (GEARY_LOGGING_IS_SOURCE (source), NULL);
#line 600 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (message != NULL, NULL);
#line 600 "../src/engine/util/util-logging.vala"
	self = (GearyLoggingState*) g_type_create_instance (object_type);
#line 601 "../src/engine/util/util-logging.vala"
	geary_logging_state_set_source (self, source);
#line 602 "../src/engine/util/util-logging.vala"
	_tmp0_ = g_strdup (message);
#line 602 "../src/engine/util/util-logging.vala"
	_g_free0 (self->priv->message);
#line 602 "../src/engine/util/util-logging.vala"
	self->priv->message = _tmp0_;
#line 605 "../src/engine/util/util-logging.vala"
	va_copy (_tmp1_, _vala_va_list);
#line 605 "../src/engine/util/util-logging.vala"
	_tmp2_ = g_strdup_vprintf (message, _tmp1_);
#line 605 "../src/engine/util/util-logging.vala"
	_g_free0 (self->priv->message);
#line 605 "../src/engine/util/util-logging.vala"
	self->priv->message = _tmp2_;
#line 605 "../src/engine/util/util-logging.vala"
	va_end (_tmp1_);
#line 600 "../src/engine/util/util-logging.vala"
	return self;
#line 2077 "util-logging.c"
}

GearyLoggingState*
geary_logging_state_new (GearyLoggingSource* source,
                         const gchar* message,
                         ...)
{
	va_list _vala_va_list_obj;
#line 600 "../src/engine/util/util-logging.vala"
	va_start (_vala_va_list_obj, message);
#line 600 "../src/engine/util/util-logging.vala"
	return geary_logging_state_constructv (GEARY_LOGGING_TYPE_STATE, source, message, _vala_va_list_obj);
#line 2090 "util-logging.c"
}

GearyLoggingState*
geary_logging_state_construct (GType object_type,
                               GearyLoggingSource* source,
                               const gchar* message,
                               ...)
{
	va_list _vala_va_list_obj;
#line 600 "../src/engine/util/util-logging.vala"
	va_start (_vala_va_list_obj, message);
#line 600 "../src/engine/util/util-logging.vala"
	return geary_logging_state_constructv (object_type, source, message, _vala_va_list_obj);
#line 2104 "util-logging.c"
}

gchar*
geary_logging_state_format_message (GearyLoggingState* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 608 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (GEARY_LOGGING_IS_STATE (self), NULL);
#line 611 "../src/engine/util/util-logging.vala"
	_tmp0_ = self->priv->message;
#line 611 "../src/engine/util/util-logging.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 611 "../src/engine/util/util-logging.vala"
	result = _tmp1_;
#line 611 "../src/engine/util/util-logging.vala"
	return result;
#line 2123 "util-logging.c"
}

static void
geary_logging_value_state_init (GValue* value)
{
#line 581 "../src/engine/util/util-logging.vala"
	value->data[0].v_pointer = NULL;
#line 2131 "util-logging.c"
}

static void
geary_logging_value_state_free_value (GValue* value)
{
#line 581 "../src/engine/util/util-logging.vala"
	if (value->data[0].v_pointer) {
#line 581 "../src/engine/util/util-logging.vala"
		geary_logging_state_unref (value->data[0].v_pointer);
#line 2141 "util-logging.c"
	}
}

static void
geary_logging_value_state_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 581 "../src/engine/util/util-logging.vala"
	if (src_value->data[0].v_pointer) {
#line 581 "../src/engine/util/util-logging.vala"
		dest_value->data[0].v_pointer = geary_logging_state_ref (src_value->data[0].v_pointer);
#line 2153 "util-logging.c"
	} else {
#line 581 "../src/engine/util/util-logging.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2157 "util-logging.c"
	}
}

static gpointer
geary_logging_value_state_peek_pointer (const GValue* value)
{
#line 581 "../src/engine/util/util-logging.vala"
	return value->data[0].v_pointer;
#line 2166 "util-logging.c"
}

static gchar*
geary_logging_value_state_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 581 "../src/engine/util/util-logging.vala"
	if (collect_values[0].v_pointer) {
#line 2177 "util-logging.c"
		GearyLoggingState * object;
		object = collect_values[0].v_pointer;
#line 581 "../src/engine/util/util-logging.vala"
		if (object->parent_instance.g_class == NULL) {
#line 581 "../src/engine/util/util-logging.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2184 "util-logging.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 581 "../src/engine/util/util-logging.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2188 "util-logging.c"
		}
#line 581 "../src/engine/util/util-logging.vala"
		value->data[0].v_pointer = geary_logging_state_ref (object);
#line 2192 "util-logging.c"
	} else {
#line 581 "../src/engine/util/util-logging.vala"
		value->data[0].v_pointer = NULL;
#line 2196 "util-logging.c"
	}
#line 581 "../src/engine/util/util-logging.vala"
	return NULL;
#line 2200 "util-logging.c"
}

static gchar*
geary_logging_value_state_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	GearyLoggingState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 581 "../src/engine/util/util-logging.vala"
	if (!object_p) {
#line 581 "../src/engine/util/util-logging.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2215 "util-logging.c"
	}
#line 581 "../src/engine/util/util-logging.vala"
	if (!value->data[0].v_pointer) {
#line 581 "../src/engine/util/util-logging.vala"
		*object_p = NULL;
#line 2221 "util-logging.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 581 "../src/engine/util/util-logging.vala"
		*object_p = value->data[0].v_pointer;
#line 2225 "util-logging.c"
	} else {
#line 581 "../src/engine/util/util-logging.vala"
		*object_p = geary_logging_state_ref (value->data[0].v_pointer);
#line 2229 "util-logging.c"
	}
#line 581 "../src/engine/util/util-logging.vala"
	return NULL;
#line 2233 "util-logging.c"
}

GParamSpec*
geary_logging_param_spec_state (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	GearyLoggingParamSpecState* spec;
#line 581 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GEARY_LOGGING_TYPE_STATE), NULL);
#line 581 "../src/engine/util/util-logging.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 581 "../src/engine/util/util-logging.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 581 "../src/engine/util/util-logging.vala"
	return G_PARAM_SPEC (spec);
#line 2252 "util-logging.c"
}

gpointer
geary_logging_value_get_state (const GValue* value)
{
#line 581 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_LOGGING_TYPE_STATE), NULL);
#line 581 "../src/engine/util/util-logging.vala"
	return value->data[0].v_pointer;
#line 2262 "util-logging.c"
}

void
geary_logging_value_set_state (GValue* value,
                               gpointer v_object)
{
	GearyLoggingState * old;
#line 581 "../src/engine/util/util-logging.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_LOGGING_TYPE_STATE));
#line 581 "../src/engine/util/util-logging.vala"
	old = value->data[0].v_pointer;
#line 581 "../src/engine/util/util-logging.vala"
	if (v_object) {
#line 581 "../src/engine/util/util-logging.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GEARY_LOGGING_TYPE_STATE));
#line 581 "../src/engine/util/util-logging.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 581 "../src/engine/util/util-logging.vala"
		value->data[0].v_pointer = v_object;
#line 581 "../src/engine/util/util-logging.vala"
		geary_logging_state_ref (value->data[0].v_pointer);
#line 2284 "util-logging.c"
	} else {
#line 581 "../src/engine/util/util-logging.vala"
		value->data[0].v_pointer = NULL;
#line 2288 "util-logging.c"
	}
#line 581 "../src/engine/util/util-logging.vala"
	if (old) {
#line 581 "../src/engine/util/util-logging.vala"
		geary_logging_state_unref (old);
#line 2294 "util-logging.c"
	}
}

void
geary_logging_value_take_state (GValue* value,
                                gpointer v_object)
{
	GearyLoggingState * old;
#line 581 "../src/engine/util/util-logging.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_LOGGING_TYPE_STATE));
#line 581 "../src/engine/util/util-logging.vala"
	old = value->data[0].v_pointer;
#line 581 "../src/engine/util/util-logging.vala"
	if (v_object) {
#line 581 "../src/engine/util/util-logging.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GEARY_LOGGING_TYPE_STATE));
#line 581 "../src/engine/util/util-logging.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 581 "../src/engine/util/util-logging.vala"
		value->data[0].v_pointer = v_object;
#line 2315 "util-logging.c"
	} else {
#line 581 "../src/engine/util/util-logging.vala"
		value->data[0].v_pointer = NULL;
#line 2319 "util-logging.c"
	}
#line 581 "../src/engine/util/util-logging.vala"
	if (old) {
#line 581 "../src/engine/util/util-logging.vala"
		geary_logging_state_unref (old);
#line 2325 "util-logging.c"
	}
}

static void
geary_logging_state_class_init (GearyLoggingStateClass * klass,
                                gpointer klass_data)
{
#line 581 "../src/engine/util/util-logging.vala"
	geary_logging_state_parent_class = g_type_class_peek_parent (klass);
#line 581 "../src/engine/util/util-logging.vala"
	((GearyLoggingStateClass *) klass)->finalize = geary_logging_state_finalize;
#line 581 "../src/engine/util/util-logging.vala"
	g_type_class_adjust_private_offset (klass, &GearyLoggingState_private_offset);
#line 2339 "util-logging.c"
}

static void
geary_logging_state_instance_init (GearyLoggingState * self,
                                   gpointer klass)
{
#line 581 "../src/engine/util/util-logging.vala"
	self->priv = geary_logging_state_get_instance_private (self);
#line 581 "../src/engine/util/util-logging.vala"
	self->ref_count = 1;
#line 2350 "util-logging.c"
}

static void
geary_logging_state_finalize (GearyLoggingState * obj)
{
	GearyLoggingState * self;
#line 581 "../src/engine/util/util-logging.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_LOGGING_TYPE_STATE, GearyLoggingState);
#line 581 "../src/engine/util/util-logging.vala"
	g_signal_handlers_destroy (self);
#line 584 "../src/engine/util/util-logging.vala"
	_g_object_unref0 (self->priv->_source);
#line 587 "../src/engine/util/util-logging.vala"
	_g_free0 (self->priv->message);
#line 2365 "util-logging.c"
}

/**
 * A record of the state of a logging source to be recorded.
 *
 * @see Source.to_logging_state
 */
 G_GNUC_NO_INLINE static GType
geary_logging_state_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { geary_logging_value_state_init, geary_logging_value_state_free_value, geary_logging_value_state_copy_value, geary_logging_value_state_peek_pointer, "p", geary_logging_value_state_collect_value, "p", geary_logging_value_state_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GearyLoggingStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_logging_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyLoggingState), 0, (GInstanceInitFunc) geary_logging_state_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType geary_logging_state_type_id;
	geary_logging_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GearyLoggingState", &g_define_type_info, &g_define_type_fundamental_info, 0);
	GearyLoggingState_private_offset = g_type_add_instance_private (geary_logging_state_type_id, sizeof (GearyLoggingStatePrivate));
	return geary_logging_state_type_id;
}

GType
geary_logging_state_get_type (void)
{
	static gsize geary_logging_state_type_id__once = 0;
	if (g_once_init_enter (&geary_logging_state_type_id__once)) {
		GType geary_logging_state_type_id;
		geary_logging_state_type_id = geary_logging_state_get_type_once ();
		g_once_init_leave (&geary_logging_state_type_id__once, geary_logging_state_type_id);
	}
	return geary_logging_state_type_id__once;
}

gpointer
geary_logging_state_ref (gpointer instance)
{
	GearyLoggingState * self;
	self = instance;
#line 581 "../src/engine/util/util-logging.vala"
	g_atomic_int_inc (&self->ref_count);
#line 581 "../src/engine/util/util-logging.vala"
	return instance;
#line 2406 "util-logging.c"
}

void
geary_logging_state_unref (gpointer instance)
{
	GearyLoggingState * self;
	self = instance;
#line 581 "../src/engine/util/util-logging.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 581 "../src/engine/util/util-logging.vala"
		GEARY_LOGGING_STATE_GET_CLASS (self)->finalize (self);
#line 581 "../src/engine/util/util-logging.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2420 "util-logging.c"
	}
}

static inline gpointer
geary_logging_record_get_instance_private (GearyLoggingRecord* self)
{
	return G_STRUCT_MEMBER_P (self, GearyLoggingRecord_private_offset);
}

const gchar*
geary_logging_record_get_domain (GearyLoggingRecord* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 628 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (GEARY_LOGGING_IS_RECORD (self), NULL);
#line 628 "../src/engine/util/util-logging.vala"
	_tmp0_ = self->priv->_domain;
#line 628 "../src/engine/util/util-logging.vala"
	result = _tmp0_;
#line 628 "../src/engine/util/util-logging.vala"
	return result;
#line 2443 "util-logging.c"
}

static void
geary_logging_record_set_domain (GearyLoggingRecord* self,
                                 const gchar* value)
{
	gchar* _tmp0_;
#line 628 "../src/engine/util/util-logging.vala"
	g_return_if_fail (GEARY_LOGGING_IS_RECORD (self));
#line 628 "../src/engine/util/util-logging.vala"
	_tmp0_ = g_strdup (value);
#line 628 "../src/engine/util/util-logging.vala"
	_g_free0 (self->priv->_domain);
#line 628 "../src/engine/util/util-logging.vala"
	self->priv->_domain = _tmp0_;
#line 2459 "util-logging.c"
}

GearyAccount*
geary_logging_record_get_account (GearyLoggingRecord* self)
{
	GearyAccount* result;
	GearyAccount* _tmp0_;
#line 631 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (GEARY_LOGGING_IS_RECORD (self), NULL);
#line 631 "../src/engine/util/util-logging.vala"
	_tmp0_ = self->priv->_account;
#line 631 "../src/engine/util/util-logging.vala"
	result = _tmp0_;
#line 631 "../src/engine/util/util-logging.vala"
	return result;
#line 2475 "util-logging.c"
}

static void
geary_logging_record_set_account (GearyLoggingRecord* self,
                                  GearyAccount* value)
{
	GearyAccount* _tmp0_;
#line 631 "../src/engine/util/util-logging.vala"
	g_return_if_fail (GEARY_LOGGING_IS_RECORD (self));
#line 631 "../src/engine/util/util-logging.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 631 "../src/engine/util/util-logging.vala"
	_g_object_unref0 (self->priv->_account);
#line 631 "../src/engine/util/util-logging.vala"
	self->priv->_account = _tmp0_;
#line 2491 "util-logging.c"
}

GearyClientService*
geary_logging_record_get_service (GearyLoggingRecord* self)
{
	GearyClientService* result;
	GearyClientService* _tmp0_;
#line 634 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (GEARY_LOGGING_IS_RECORD (self), NULL);
#line 634 "../src/engine/util/util-logging.vala"
	_tmp0_ = self->priv->_service;
#line 634 "../src/engine/util/util-logging.vala"
	result = _tmp0_;
#line 634 "../src/engine/util/util-logging.vala"
	return result;
#line 2507 "util-logging.c"
}

static void
geary_logging_record_set_service (GearyLoggingRecord* self,
                                  GearyClientService* value)
{
	GearyClientService* _tmp0_;
#line 634 "../src/engine/util/util-logging.vala"
	g_return_if_fail (GEARY_LOGGING_IS_RECORD (self));
#line 634 "../src/engine/util/util-logging.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 634 "../src/engine/util/util-logging.vala"
	_g_object_unref0 (self->priv->_service);
#line 634 "../src/engine/util/util-logging.vala"
	self->priv->_service = _tmp0_;
#line 2523 "util-logging.c"
}

GearyFolder*
geary_logging_record_get_folder (GearyLoggingRecord* self)
{
	GearyFolder* result;
	GearyFolder* _tmp0_;
#line 637 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (GEARY_LOGGING_IS_RECORD (self), NULL);
#line 637 "../src/engine/util/util-logging.vala"
	_tmp0_ = self->priv->_folder;
#line 637 "../src/engine/util/util-logging.vala"
	result = _tmp0_;
#line 637 "../src/engine/util/util-logging.vala"
	return result;
#line 2539 "util-logging.c"
}

static void
geary_logging_record_set_folder (GearyLoggingRecord* self,
                                 GearyFolder* value)
{
	GearyFolder* _tmp0_;
#line 637 "../src/engine/util/util-logging.vala"
	g_return_if_fail (GEARY_LOGGING_IS_RECORD (self));
#line 637 "../src/engine/util/util-logging.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 637 "../src/engine/util/util-logging.vala"
	_g_object_unref0 (self->priv->_folder);
#line 637 "../src/engine/util/util-logging.vala"
	self->priv->_folder = _tmp0_;
#line 2555 "util-logging.c"
}

GearyLoggingRecord*
geary_logging_record_get_next (GearyLoggingRecord* self)
{
	GearyLoggingRecord* result;
	GearyLoggingRecord* _tmp0_;
#line 661 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (GEARY_LOGGING_IS_RECORD (self), NULL);
#line 661 "../src/engine/util/util-logging.vala"
	_tmp0_ = self->priv->_next;
#line 661 "../src/engine/util/util-logging.vala"
	result = _tmp0_;
#line 661 "../src/engine/util/util-logging.vala"
	return result;
#line 2571 "util-logging.c"
}

void
geary_logging_record_set_next (GearyLoggingRecord* self,
                               GearyLoggingRecord* value)
{
	GearyLoggingRecord* _tmp0_;
#line 661 "../src/engine/util/util-logging.vala"
	g_return_if_fail (GEARY_LOGGING_IS_RECORD (self));
#line 661 "../src/engine/util/util-logging.vala"
	_tmp0_ = _geary_logging_record_ref0 (value);
#line 661 "../src/engine/util/util-logging.vala"
	_geary_logging_record_unref0 (self->priv->_next);
#line 661 "../src/engine/util/util-logging.vala"
	self->priv->_next = _tmp0_;
#line 2587 "util-logging.c"
}

static GType*
_g_type_dup (GType* self)
{
	GType* dup;
#line 688 "../src/engine/util/util-logging.vala"
	dup = g_new0 (GType, 1);
#line 688 "../src/engine/util/util-logging.vala"
	memcpy (dup, self, sizeof (GType));
#line 688 "../src/engine/util/util-logging.vala"
	return dup;
#line 2600 "util-logging.c"
}

static gpointer
__g_type_dup0 (gpointer self)
{
#line 688 "../src/engine/util/util-logging.vala"
	return self ? _g_type_dup (self) : NULL;
#line 2608 "util-logging.c"
}

GearyLoggingRecord*
geary_logging_record_construct (GType object_type,
                                GLogField* fields,
                                gint fields_length1,
                                GLogLevelFlags levels,
                                gint64 timestamp)
{
	GearyLoggingRecord* self = NULL;
	gboolean _tmp0_ = FALSE;
	gchar** _tmp3_;
	gint state_count = 0;
#line 668 "../src/engine/util/util-logging.vala"
	self = (GearyLoggingRecord*) g_type_create_instance (object_type);
#line 671 "../src/engine/util/util-logging.vala"
	self->levels = levels;
#line 672 "../src/engine/util/util-logging.vala"
	self->timestamp = timestamp;
#line 673 "../src/engine/util/util-logging.vala"
	if (fields_length1 > 0) {
#line 2630 "util-logging.c"
		GLogField _tmp1_;
		const gchar* _tmp2_;
#line 675 "../src/engine/util/util-logging.vala"
		_tmp1_ = fields[0];
#line 675 "../src/engine/util/util-logging.vala"
		_tmp2_ = _tmp1_.key;
#line 675 "../src/engine/util/util-logging.vala"
		_tmp0_ = g_strcmp0 (_tmp2_, "GLIB_OLD_LOG_API") == 0;
#line 2639 "util-logging.c"
	} else {
#line 674 "../src/engine/util/util-logging.vala"
		_tmp0_ = FALSE;
#line 2643 "util-logging.c"
	}
#line 673 "../src/engine/util/util-logging.vala"
	self->priv->old_log_api = _tmp0_;
#line 680 "../src/engine/util/util-logging.vala"
	_tmp3_ = g_new0 (gchar*, fields_length1 + 1);
#line 680 "../src/engine/util/util-logging.vala"
	self->priv->states = (_vala_array_free (self->priv->states, self->priv->states_length1, (GDestroyNotify) g_free), NULL);
#line 680 "../src/engine/util/util-logging.vala"
	self->priv->states = _tmp3_;
#line 680 "../src/engine/util/util-logging.vala"
	self->priv->states_length1 = fields_length1;
#line 680 "../src/engine/util/util-logging.vala"
	self->priv->_states_size_ = self->priv->states_length1;
#line 681 "../src/engine/util/util-logging.vala"
	state_count = 0;
#line 2659 "util-logging.c"
	{
		GLogField* field_collection = NULL;
		gint field_collection_length1 = 0;
		gint _field_collection_size_ = 0;
		gint field_it = 0;
#line 682 "../src/engine/util/util-logging.vala"
		field_collection = fields;
#line 682 "../src/engine/util/util-logging.vala"
		field_collection_length1 = fields_length1;
#line 682 "../src/engine/util/util-logging.vala"
		for (field_it = 0; field_it < field_collection_length1; field_it = field_it + 1) {
#line 2671 "util-logging.c"
			GLogField field = {0};
#line 682 "../src/engine/util/util-logging.vala"
			field = field_collection[field_it];
#line 2675 "util-logging.c"
			{
				GLogField _tmp4_;
				const gchar* _tmp5_;
				const gchar* _tmp6_;
				GQuark _tmp8_ = 0U;
#line 683 "../src/engine/util/util-logging.vala"
				static GQuark _tmp7_label0 = 0;
#line 683 "../src/engine/util/util-logging.vala"
				static GQuark _tmp7_label1 = 0;
#line 683 "../src/engine/util/util-logging.vala"
				static GQuark _tmp7_label2 = 0;
#line 683 "../src/engine/util/util-logging.vala"
				static GQuark _tmp7_label3 = 0;
#line 683 "../src/engine/util/util-logging.vala"
				static GQuark _tmp7_label4 = 0;
#line 683 "../src/engine/util/util-logging.vala"
				static GQuark _tmp7_label5 = 0;
#line 683 "../src/engine/util/util-logging.vala"
				_tmp4_ = field;
#line 683 "../src/engine/util/util-logging.vala"
				_tmp5_ = _tmp4_.key;
#line 683 "../src/engine/util/util-logging.vala"
				_tmp6_ = _tmp5_;
#line 683 "../src/engine/util/util-logging.vala"
				_tmp8_ = (NULL == _tmp6_) ? 0 : g_quark_from_string (_tmp6_);
#line 683 "../src/engine/util/util-logging.vala"
				if (_tmp8_ == ((0 != _tmp7_label0) ? _tmp7_label0 : (_tmp7_label0 = g_quark_from_static_string ("GEARY_LOGGING_SOURCE")))) {
#line 683 "../src/engine/util/util-logging.vala"
					switch (0) {
#line 2705 "util-logging.c"
						default:
						{
							GearyLoggingState* state = NULL;
							GLogField _tmp9_;
							gconstpointer _tmp10_;
							GearyLoggingState* _tmp11_;
							GType type = 0UL;
							GearyLoggingState* _tmp12_;
							GearyLoggingSource* _tmp13_;
							GearyLoggingSource* _tmp14_;
							gchar** _tmp16_;
							gint _tmp16__length1;
							gint _tmp17_;
							GearyLoggingState* _tmp18_;
							gchar* _tmp19_;
#line 685 "../src/engine/util/util-logging.vala"
							_tmp9_ = field;
#line 685 "../src/engine/util/util-logging.vala"
							_tmp10_ = _tmp9_.value;
#line 685 "../src/engine/util/util-logging.vala"
							_tmp11_ = geary_logging_source_to_logging_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 685 "../src/engine/util/util-logging.vala"
							state = _tmp11_;
#line 686 "../src/engine/util/util-logging.vala"
							_tmp12_ = state;
#line 686 "../src/engine/util/util-logging.vala"
							_tmp13_ = geary_logging_state_get_source (_tmp12_);
#line 686 "../src/engine/util/util-logging.vala"
							_tmp14_ = _tmp13_;
#line 686 "../src/engine/util/util-logging.vala"
							type = G_TYPE_FROM_INSTANCE (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, G_TYPE_OBJECT, GObject));
#line 687 "../src/engine/util/util-logging.vala"
							if (state_count == 0) {
#line 2739 "util-logging.c"
								GType* _tmp15_;
#line 688 "../src/engine/util/util-logging.vala"
								_tmp15_ = __g_type_dup0 (&type);
#line 688 "../src/engine/util/util-logging.vala"
								_g_free0 (self->source_type);
#line 688 "../src/engine/util/util-logging.vala"
								self->source_type = _tmp15_;
#line 2747 "util-logging.c"
							}
#line 690 "../src/engine/util/util-logging.vala"
							_tmp16_ = self->priv->states;
#line 690 "../src/engine/util/util-logging.vala"
							_tmp16__length1 = self->priv->states_length1;
#line 690 "../src/engine/util/util-logging.vala"
							_tmp17_ = state_count;
#line 690 "../src/engine/util/util-logging.vala"
							state_count = _tmp17_ + 1;
#line 690 "../src/engine/util/util-logging.vala"
							_tmp18_ = state;
#line 690 "../src/engine/util/util-logging.vala"
							_tmp19_ = geary_logging_state_format_message (_tmp18_);
#line 690 "../src/engine/util/util-logging.vala"
							_g_free0 (_tmp16_[_tmp17_]);
#line 690 "../src/engine/util/util-logging.vala"
							_tmp16_[_tmp17_] = _tmp19_;
#line 691 "../src/engine/util/util-logging.vala"
							if (g_type_is_a (type, GEARY_TYPE_ACCOUNT)) {
#line 2767 "util-logging.c"
								GearyLoggingState* _tmp20_;
								GearyLoggingSource* _tmp21_;
								GearyLoggingSource* _tmp22_;
#line 692 "../src/engine/util/util-logging.vala"
								_tmp20_ = state;
#line 692 "../src/engine/util/util-logging.vala"
								_tmp21_ = geary_logging_state_get_source (_tmp20_);
#line 692 "../src/engine/util/util-logging.vala"
								_tmp22_ = _tmp21_;
#line 692 "../src/engine/util/util-logging.vala"
								geary_logging_record_set_account (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GEARY_TYPE_ACCOUNT, GearyAccount));
#line 2779 "util-logging.c"
							} else {
#line 693 "../src/engine/util/util-logging.vala"
								if (g_type_is_a (type, GEARY_TYPE_CLIENT_SERVICE)) {
#line 2783 "util-logging.c"
									GearyLoggingState* _tmp23_;
									GearyLoggingSource* _tmp24_;
									GearyLoggingSource* _tmp25_;
#line 694 "../src/engine/util/util-logging.vala"
									_tmp23_ = state;
#line 694 "../src/engine/util/util-logging.vala"
									_tmp24_ = geary_logging_state_get_source (_tmp23_);
#line 694 "../src/engine/util/util-logging.vala"
									_tmp25_ = _tmp24_;
#line 694 "../src/engine/util/util-logging.vala"
									geary_logging_record_set_service (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 2795 "util-logging.c"
								} else {
#line 695 "../src/engine/util/util-logging.vala"
									if (g_type_is_a (type, GEARY_TYPE_FOLDER)) {
#line 2799 "util-logging.c"
										GearyLoggingState* _tmp26_;
										GearyLoggingSource* _tmp27_;
										GearyLoggingSource* _tmp28_;
#line 696 "../src/engine/util/util-logging.vala"
										_tmp26_ = state;
#line 696 "../src/engine/util/util-logging.vala"
										_tmp27_ = geary_logging_state_get_source (_tmp26_);
#line 696 "../src/engine/util/util-logging.vala"
										_tmp28_ = _tmp27_;
#line 696 "../src/engine/util/util-logging.vala"
										geary_logging_record_set_folder (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEARY_TYPE_FOLDER, GearyFolder));
#line 2811 "util-logging.c"
									}
								}
							}
#line 698 "../src/engine/util/util-logging.vala"
							_geary_logging_state_unref0 (state);
#line 698 "../src/engine/util/util-logging.vala"
							break;
#line 2819 "util-logging.c"
						}
					}
				} else if (_tmp8_ == ((0 != _tmp7_label1) ? _tmp7_label1 : (_tmp7_label1 = g_quark_from_static_string ("GLIB_DOMAIN")))) {
#line 683 "../src/engine/util/util-logging.vala"
					switch (0) {
#line 2825 "util-logging.c"
						default:
						{
							GLogField _tmp29_;
							gchar* _tmp30_;
							gchar* _tmp31_;
#line 701 "../src/engine/util/util-logging.vala"
							_tmp29_ = field;
#line 701 "../src/engine/util/util-logging.vala"
							_tmp30_ = geary_logging_field_to_string (&_tmp29_);
#line 701 "../src/engine/util/util-logging.vala"
							_tmp31_ = _tmp30_;
#line 701 "../src/engine/util/util-logging.vala"
							geary_logging_record_set_domain (self, _tmp31_);
#line 701 "../src/engine/util/util-logging.vala"
							_g_free0 (_tmp31_);
#line 702 "../src/engine/util/util-logging.vala"
							break;
#line 2843 "util-logging.c"
						}
					}
				} else if (_tmp8_ == ((0 != _tmp7_label2) ? _tmp7_label2 : (_tmp7_label2 = g_quark_from_static_string ("MESSAGE")))) {
#line 683 "../src/engine/util/util-logging.vala"
					switch (0) {
#line 2849 "util-logging.c"
						default:
						{
							GLogField _tmp32_;
							gchar* _tmp33_;
#line 705 "../src/engine/util/util-logging.vala"
							_tmp32_ = field;
#line 705 "../src/engine/util/util-logging.vala"
							_tmp33_ = geary_logging_field_to_string (&_tmp32_);
#line 705 "../src/engine/util/util-logging.vala"
							_g_free0 (self->message);
#line 705 "../src/engine/util/util-logging.vala"
							self->message = _tmp33_;
#line 706 "../src/engine/util/util-logging.vala"
							break;
#line 2864 "util-logging.c"
						}
					}
				} else if (_tmp8_ == ((0 != _tmp7_label3) ? _tmp7_label3 : (_tmp7_label3 = g_quark_from_static_string ("CODE_FILE")))) {
#line 683 "../src/engine/util/util-logging.vala"
					switch (0) {
#line 2870 "util-logging.c"
						default:
						{
							GLogField _tmp34_;
							gchar* _tmp35_;
#line 709 "../src/engine/util/util-logging.vala"
							_tmp34_ = field;
#line 709 "../src/engine/util/util-logging.vala"
							_tmp35_ = geary_logging_field_to_string (&_tmp34_);
#line 709 "../src/engine/util/util-logging.vala"
							_g_free0 (self->source_filename);
#line 709 "../src/engine/util/util-logging.vala"
							self->source_filename = _tmp35_;
#line 710 "../src/engine/util/util-logging.vala"
							break;
#line 2885 "util-logging.c"
						}
					}
				} else if (_tmp8_ == ((0 != _tmp7_label4) ? _tmp7_label4 : (_tmp7_label4 = g_quark_from_static_string ("CODE_LINE")))) {
#line 683 "../src/engine/util/util-logging.vala"
					switch (0) {
#line 2891 "util-logging.c"
						default:
						{
							GLogField _tmp36_;
							gchar* _tmp37_;
#line 713 "../src/engine/util/util-logging.vala"
							_tmp36_ = field;
#line 713 "../src/engine/util/util-logging.vala"
							_tmp37_ = geary_logging_field_to_string (&_tmp36_);
#line 713 "../src/engine/util/util-logging.vala"
							_g_free0 (self->source_line_number);
#line 713 "../src/engine/util/util-logging.vala"
							self->source_line_number = _tmp37_;
#line 714 "../src/engine/util/util-logging.vala"
							break;
#line 2906 "util-logging.c"
						}
					}
				} else if (_tmp8_ == ((0 != _tmp7_label5) ? _tmp7_label5 : (_tmp7_label5 = g_quark_from_static_string ("CODE_FUNC")))) {
#line 683 "../src/engine/util/util-logging.vala"
					switch (0) {
#line 2912 "util-logging.c"
						default:
						{
							GLogField _tmp38_;
							gchar* _tmp39_;
#line 717 "../src/engine/util/util-logging.vala"
							_tmp38_ = field;
#line 717 "../src/engine/util/util-logging.vala"
							_tmp39_ = geary_logging_field_to_string (&_tmp38_);
#line 717 "../src/engine/util/util-logging.vala"
							_g_free0 (self->source_function);
#line 717 "../src/engine/util/util-logging.vala"
							self->source_function = _tmp39_;
#line 718 "../src/engine/util/util-logging.vala"
							break;
#line 2927 "util-logging.c"
						}
					}
				}
			}
		}
	}
#line 722 "../src/engine/util/util-logging.vala"
	self->priv->states_length1 = state_count;
#line 668 "../src/engine/util/util-logging.vala"
	return self;
#line 2938 "util-logging.c"
}

GearyLoggingRecord*
geary_logging_record_new (GLogField* fields,
                          gint fields_length1,
                          GLogLevelFlags levels,
                          gint64 timestamp)
{
#line 668 "../src/engine/util/util-logging.vala"
	return geary_logging_record_construct (GEARY_LOGGING_TYPE_RECORD, fields, fields_length1, levels, timestamp);
#line 2949 "util-logging.c"
}

/**
     * Copy constructor.
     *
     * Copies all properties of the given record except its next
     * record.
     */
static gchar**
_vala_array_dup19 (gchar** self,
                   gssize length)
{
#line 750 "../src/engine/util/util-logging.vala"
	if (length >= 0) {
#line 2964 "util-logging.c"
		gchar** result;
		gssize i;
#line 750 "../src/engine/util/util-logging.vala"
		result = g_new0 (gchar*, length + 1);
#line 750 "../src/engine/util/util-logging.vala"
		for (i = 0; i < length; i++) {
#line 2971 "util-logging.c"
			gchar* _tmp0_;
#line 750 "../src/engine/util/util-logging.vala"
			_tmp0_ = g_strdup (self[i]);
#line 750 "../src/engine/util/util-logging.vala"
			result[i] = _tmp0_;
#line 2977 "util-logging.c"
		}
#line 750 "../src/engine/util/util-logging.vala"
		return result;
#line 2981 "util-logging.c"
	}
#line 750 "../src/engine/util/util-logging.vala"
	return NULL;
#line 2985 "util-logging.c"
}

GearyLoggingRecord*
geary_logging_record_construct_copy (GType object_type,
                                     GearyLoggingRecord* other)
{
	GearyLoggingRecord* self = NULL;
	const gchar* _tmp0_;
	GearyAccount* _tmp1_;
	GearyClientService* _tmp2_;
	GearyFolder* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	GType* _tmp6_;
	GType* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	gchar** _tmp15_;
	gint _tmp15__length1;
#line 731 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (GEARY_LOGGING_IS_RECORD (other), NULL);
#line 731 "../src/engine/util/util-logging.vala"
	self = (GearyLoggingRecord*) g_type_create_instance (object_type);
#line 732 "../src/engine/util/util-logging.vala"
	_tmp0_ = other->priv->_domain;
#line 732 "../src/engine/util/util-logging.vala"
	geary_logging_record_set_domain (self, _tmp0_);
#line 733 "../src/engine/util/util-logging.vala"
	_tmp1_ = other->priv->_account;
#line 733 "../src/engine/util/util-logging.vala"
	geary_logging_record_set_account (self, _tmp1_);
#line 734 "../src/engine/util/util-logging.vala"
	_tmp2_ = other->priv->_service;
#line 734 "../src/engine/util/util-logging.vala"
	geary_logging_record_set_service (self, _tmp2_);
#line 735 "../src/engine/util/util-logging.vala"
	_tmp3_ = other->priv->_folder;
#line 735 "../src/engine/util/util-logging.vala"
	geary_logging_record_set_folder (self, _tmp3_);
#line 736 "../src/engine/util/util-logging.vala"
	_tmp4_ = other->message;
#line 736 "../src/engine/util/util-logging.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 736 "../src/engine/util/util-logging.vala"
	_g_free0 (self->message);
#line 736 "../src/engine/util/util-logging.vala"
	self->message = _tmp5_;
#line 737 "../src/engine/util/util-logging.vala"
	_tmp6_ = other->source_type;
#line 737 "../src/engine/util/util-logging.vala"
	_tmp7_ = __g_type_dup0 (_tmp6_);
#line 737 "../src/engine/util/util-logging.vala"
	_g_free0 (self->source_type);
#line 737 "../src/engine/util/util-logging.vala"
	self->source_type = _tmp7_;
#line 738 "../src/engine/util/util-logging.vala"
	_tmp8_ = other->source_filename;
#line 738 "../src/engine/util/util-logging.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 738 "../src/engine/util/util-logging.vala"
	_g_free0 (self->source_filename);
#line 738 "../src/engine/util/util-logging.vala"
	self->source_filename = _tmp9_;
#line 739 "../src/engine/util/util-logging.vala"
	_tmp10_ = other->source_line_number;
#line 739 "../src/engine/util/util-logging.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 739 "../src/engine/util/util-logging.vala"
	_g_free0 (self->source_line_number);
#line 739 "../src/engine/util/util-logging.vala"
	self->source_line_number = _tmp11_;
#line 740 "../src/engine/util/util-logging.vala"
	_tmp12_ = other->source_function;
#line 740 "../src/engine/util/util-logging.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 740 "../src/engine/util/util-logging.vala"
	_g_free0 (self->source_function);
#line 740 "../src/engine/util/util-logging.vala"
	self->source_function = _tmp13_;
#line 741 "../src/engine/util/util-logging.vala"
	self->levels = other->levels;
#line 742 "../src/engine/util/util-logging.vala"
	self->timestamp = other->timestamp;
#line 748 "../src/engine/util/util-logging.vala"
	geary_logging_record_set_next (self, NULL);
#line 750 "../src/engine/util/util-logging.vala"
	_tmp14_ = other->priv->states;
#line 750 "../src/engine/util/util-logging.vala"
	_tmp14__length1 = other->priv->states_length1;
#line 750 "../src/engine/util/util-logging.vala"
	_tmp15_ = (_tmp14_ != NULL) ? _vala_array_dup19 (_tmp14_, _tmp14__length1) : _tmp14_;
#line 750 "../src/engine/util/util-logging.vala"
	_tmp15__length1 = _tmp14__length1;
#line 750 "../src/engine/util/util-logging.vala"
	self->priv->states = (_vala_array_free (self->priv->states, self->priv->states_length1, (GDestroyNotify) g_free), NULL);
#line 750 "../src/engine/util/util-logging.vala"
	self->priv->states = _tmp15_;
#line 750 "../src/engine/util/util-logging.vala"
	self->priv->states_length1 = _tmp15__length1;
#line 750 "../src/engine/util/util-logging.vala"
	self->priv->_states_size_ = self->priv->states_length1;
#line 751 "../src/engine/util/util-logging.vala"
	self->priv->filled = other->priv->filled;
#line 752 "../src/engine/util/util-logging.vala"
	self->priv->old_log_api = other->priv->old_log_api;
#line 731 "../src/engine/util/util-logging.vala"
	return self;
#line 3099 "util-logging.c"
}

GearyLoggingRecord*
geary_logging_record_new_copy (GearyLoggingRecord* other)
{
#line 731 "../src/engine/util/util-logging.vala"
	return geary_logging_record_construct_copy (GEARY_LOGGING_TYPE_RECORD, other);
#line 3107 "util-logging.c"
}

/**
     * Sets the well-known logging source properties.
     *
     * Call this before trying to access {@link account}, {@link
     * folder} and {@link service}. Determining these can be
     * computationally complex and hence is not done by default.
     */
void
geary_logging_record_fill_well_known_sources (GearyLoggingRecord* self)
{
#line 763 "../src/engine/util/util-logging.vala"
	g_return_if_fail (GEARY_LOGGING_IS_RECORD (self));
#line 3122 "util-logging.c"
}

/** Returns a formatted string representation of this record. */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 3136 "util-logging.c"
}

gchar*
geary_logging_record_format (GearyLoggingRecord* self)
{
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* domain = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_;
	gchar* message = NULL;
	gchar* _tmp5_;
	gdouble float_secs = 0.0;
	gdouble floor_secs = 0.0;
	gint ms = 0;
	GDateTime* time = NULL;
	GDateTime* _tmp6_;
	GDateTime* _tmp7_;
	GDateTime* _tmp8_;
	GDateTime* _tmp9_;
	GString* str = NULL;
	GString* _tmp10_;
	GString* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GDateTime* _tmp14_;
	GDateTime* _tmp15_;
	GDateTime* _tmp16_;
	const gchar* _tmp17_;
	gboolean disabled = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp27_ = FALSE;
	GString* _tmp50_;
	const gchar* _tmp51_;
	GString* _tmp52_;
	const gchar* _tmp53_;
	gchar* _tmp54_;
	gchar* result;
#line 767 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (GEARY_LOGGING_IS_RECORD (self), NULL);
#line 768 "../src/engine/util/util-logging.vala"
	geary_logging_record_fill_well_known_sources (self);
#line 770 "../src/engine/util/util-logging.vala"
	_tmp1_ = self->priv->_domain;
#line 770 "../src/engine/util/util-logging.vala"
	_tmp0_ = _tmp1_;
#line 770 "../src/engine/util/util-logging.vala"
	if (_tmp0_ == NULL) {
#line 770 "../src/engine/util/util-logging.vala"
		_tmp0_ = "[no domain]";
#line 3188 "util-logging.c"
	}
#line 770 "../src/engine/util/util-logging.vala"
	_tmp2_ = g_strdup (_tmp0_);
#line 770 "../src/engine/util/util-logging.vala"
	domain = _tmp2_;
#line 771 "../src/engine/util/util-logging.vala"
	_tmp4_ = self->message;
#line 771 "../src/engine/util/util-logging.vala"
	_tmp3_ = _tmp4_;
#line 771 "../src/engine/util/util-logging.vala"
	if (_tmp3_ == NULL) {
#line 771 "../src/engine/util/util-logging.vala"
		_tmp3_ = "[no message]";
#line 3202 "util-logging.c"
	}
#line 771 "../src/engine/util/util-logging.vala"
	_tmp5_ = g_strdup (_tmp3_);
#line 771 "../src/engine/util/util-logging.vala"
	message = _tmp5_;
#line 772 "../src/engine/util/util-logging.vala"
	float_secs = (self->timestamp / 1000.0) / 1000.0;
#line 773 "../src/engine/util/util-logging.vala"
	floor_secs = floor (float_secs);
#line 774 "../src/engine/util/util-logging.vala"
	ms = (gint) round ((float_secs - floor_secs) * 1000.0);
#line 775 "../src/engine/util/util-logging.vala"
	_tmp6_ = g_date_time_new_from_unix_utc ((gint64) float_secs);
#line 775 "../src/engine/util/util-logging.vala"
	_tmp7_ = _tmp6_;
#line 775 "../src/engine/util/util-logging.vala"
	_tmp8_ = g_date_time_to_local (_tmp7_);
#line 775 "../src/engine/util/util-logging.vala"
	_tmp9_ = _tmp8_;
#line 775 "../src/engine/util/util-logging.vala"
	_g_date_time_unref0 (_tmp7_);
#line 775 "../src/engine/util/util-logging.vala"
	time = _tmp9_;
#line 778 "../src/engine/util/util-logging.vala"
	_tmp10_ = g_string_sized_new ((gsize) 128);
#line 778 "../src/engine/util/util-logging.vala"
	str = _tmp10_;
#line 779 "../src/engine/util/util-logging.vala"
	_tmp11_ = str;
#line 779 "../src/engine/util/util-logging.vala"
	_tmp12_ = geary_logging_to_prefix (self->levels);
#line 779 "../src/engine/util/util-logging.vala"
	_tmp13_ = _tmp12_;
#line 779 "../src/engine/util/util-logging.vala"
	_tmp14_ = time;
#line 779 "../src/engine/util/util-logging.vala"
	_tmp15_ = time;
#line 779 "../src/engine/util/util-logging.vala"
	_tmp16_ = time;
#line 779 "../src/engine/util/util-logging.vala"
	_tmp17_ = domain;
#line 779 "../src/engine/util/util-logging.vala"
	g_string_printf (_tmp11_, "%s %02d:%02d:%02d.%04d %s:", _tmp13_, g_date_time_get_hour (_tmp14_), g_date_time_get_minute (_tmp15_), g_date_time_get_second (_tmp16_), ms, _tmp17_);
#line 779 "../src/engine/util/util-logging.vala"
	_g_free0 (_tmp13_);
#line 3248 "util-logging.c"
	{
		gint i = 0;
		gchar** _tmp18_;
		gint _tmp18__length1;
#line 790 "../src/engine/util/util-logging.vala"
		_tmp18_ = self->priv->states;
#line 790 "../src/engine/util/util-logging.vala"
		_tmp18__length1 = self->priv->states_length1;
#line 790 "../src/engine/util/util-logging.vala"
		i = _tmp18__length1 - 1;
#line 3259 "util-logging.c"
		{
			gboolean _tmp19_ = FALSE;
#line 790 "../src/engine/util/util-logging.vala"
			_tmp19_ = TRUE;
#line 790 "../src/engine/util/util-logging.vala"
			while (TRUE) {
#line 3266 "util-logging.c"
				GString* _tmp21_;
				GString* _tmp22_;
				gchar** _tmp23_;
				gint _tmp23__length1;
				const gchar* _tmp24_;
				GString* _tmp25_;
#line 790 "../src/engine/util/util-logging.vala"
				if (!_tmp19_) {
#line 3275 "util-logging.c"
					gint _tmp20_;
#line 790 "../src/engine/util/util-logging.vala"
					_tmp20_ = i;
#line 790 "../src/engine/util/util-logging.vala"
					i = _tmp20_ - 1;
#line 3281 "util-logging.c"
				}
#line 790 "../src/engine/util/util-logging.vala"
				_tmp19_ = FALSE;
#line 790 "../src/engine/util/util-logging.vala"
				if (!(i >= 0)) {
#line 790 "../src/engine/util/util-logging.vala"
					break;
#line 3289 "util-logging.c"
				}
#line 791 "../src/engine/util/util-logging.vala"
				_tmp21_ = str;
#line 791 "../src/engine/util/util-logging.vala"
				g_string_append (_tmp21_, " [");
#line 792 "../src/engine/util/util-logging.vala"
				_tmp22_ = str;
#line 792 "../src/engine/util/util-logging.vala"
				_tmp23_ = self->priv->states;
#line 792 "../src/engine/util/util-logging.vala"
				_tmp23__length1 = self->priv->states_length1;
#line 792 "../src/engine/util/util-logging.vala"
				_tmp24_ = _tmp23_[i];
#line 792 "../src/engine/util/util-logging.vala"
				g_string_append (_tmp22_, _tmp24_);
#line 793 "../src/engine/util/util-logging.vala"
				_tmp25_ = str;
#line 793 "../src/engine/util/util-logging.vala"
				g_string_append (_tmp25_, "]");
#line 3309 "util-logging.c"
			}
		}
	}
#line 798 "../src/engine/util/util-logging.vala"
	disabled = TRUE;
#line 799 "../src/engine/util/util-logging.vala"
	if (!disabled) {
#line 799 "../src/engine/util/util-logging.vala"
		_tmp27_ = !self->priv->old_log_api;
#line 3319 "util-logging.c"
	} else {
#line 799 "../src/engine/util/util-logging.vala"
		_tmp27_ = FALSE;
#line 3323 "util-logging.c"
	}
#line 799 "../src/engine/util/util-logging.vala"
	if (_tmp27_) {
#line 3327 "util-logging.c"
		const gchar* _tmp28_;
#line 799 "../src/engine/util/util-logging.vala"
		_tmp28_ = self->source_filename;
#line 799 "../src/engine/util/util-logging.vala"
		_tmp26_ = _tmp28_ != NULL;
#line 3333 "util-logging.c"
	} else {
#line 799 "../src/engine/util/util-logging.vala"
		_tmp26_ = FALSE;
#line 3337 "util-logging.c"
	}
#line 799 "../src/engine/util/util-logging.vala"
	if (_tmp26_) {
#line 3341 "util-logging.c"
		GString* _tmp29_;
		GString* _tmp30_;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		const gchar* _tmp34_;
		const gchar* _tmp38_;
		GString* _tmp43_;
#line 800 "../src/engine/util/util-logging.vala"
		_tmp29_ = str;
#line 800 "../src/engine/util/util-logging.vala"
		g_string_append (_tmp29_, " [");
#line 801 "../src/engine/util/util-logging.vala"
		_tmp30_ = str;
#line 801 "../src/engine/util/util-logging.vala"
		_tmp31_ = self->source_filename;
#line 801 "../src/engine/util/util-logging.vala"
		_tmp32_ = g_path_get_basename (_tmp31_);
#line 801 "../src/engine/util/util-logging.vala"
		_tmp33_ = _tmp32_;
#line 801 "../src/engine/util/util-logging.vala"
		g_string_append (_tmp30_, _tmp33_);
#line 801 "../src/engine/util/util-logging.vala"
		_g_free0 (_tmp33_);
#line 802 "../src/engine/util/util-logging.vala"
		_tmp34_ = self->source_line_number;
#line 802 "../src/engine/util/util-logging.vala"
		if (_tmp34_ != NULL) {
#line 3370 "util-logging.c"
			GString* _tmp35_;
			GString* _tmp36_;
			const gchar* _tmp37_;
#line 803 "../src/engine/util/util-logging.vala"
			_tmp35_ = str;
#line 803 "../src/engine/util/util-logging.vala"
			g_string_append_c (_tmp35_, ':');
#line 804 "../src/engine/util/util-logging.vala"
			_tmp36_ = str;
#line 804 "../src/engine/util/util-logging.vala"
			_tmp37_ = self->source_line_number;
#line 804 "../src/engine/util/util-logging.vala"
			g_string_append (_tmp36_, _tmp37_);
#line 3384 "util-logging.c"
		}
#line 806 "../src/engine/util/util-logging.vala"
		_tmp38_ = self->source_function;
#line 806 "../src/engine/util/util-logging.vala"
		if (_tmp38_ != NULL) {
#line 3390 "util-logging.c"
			GString* _tmp39_;
			GString* _tmp40_;
			const gchar* _tmp41_;
			const gchar* _tmp42_;
#line 807 "../src/engine/util/util-logging.vala"
			_tmp39_ = str;
#line 807 "../src/engine/util/util-logging.vala"
			g_string_append_c (_tmp39_, ':');
#line 808 "../src/engine/util/util-logging.vala"
			_tmp40_ = str;
#line 808 "../src/engine/util/util-logging.vala"
			_tmp41_ = self->source_function;
#line 808 "../src/engine/util/util-logging.vala"
			_tmp42_ = string_to_string (_tmp41_);
#line 808 "../src/engine/util/util-logging.vala"
			g_string_append (_tmp40_, _tmp42_);
#line 3407 "util-logging.c"
		}
#line 810 "../src/engine/util/util-logging.vala"
		_tmp43_ = str;
#line 810 "../src/engine/util/util-logging.vala"
		g_string_append (_tmp43_, "]: ");
#line 3413 "util-logging.c"
	} else {
		GType* _tmp44_;
#line 811 "../src/engine/util/util-logging.vala"
		_tmp44_ = self->source_type;
#line 811 "../src/engine/util/util-logging.vala"
		if (_tmp44_ != NULL) {
#line 3420 "util-logging.c"
			GString* _tmp45_;
			GString* _tmp46_;
			GType* _tmp47_;
			const gchar* _tmp48_;
			GString* _tmp49_;
#line 815 "../src/engine/util/util-logging.vala"
			_tmp45_ = str;
#line 815 "../src/engine/util/util-logging.vala"
			g_string_append (_tmp45_, " ");
#line 816 "../src/engine/util/util-logging.vala"
			_tmp46_ = str;
#line 816 "../src/engine/util/util-logging.vala"
			_tmp47_ = self->source_type;
#line 816 "../src/engine/util/util-logging.vala"
			_tmp48_ = g_type_name (*_tmp47_);
#line 816 "../src/engine/util/util-logging.vala"
			g_string_append (_tmp46_, _tmp48_);
#line 817 "../src/engine/util/util-logging.vala"
			_tmp49_ = str;
#line 817 "../src/engine/util/util-logging.vala"
			g_string_append (_tmp49_, ": ");
#line 3442 "util-logging.c"
		}
	}
#line 820 "../src/engine/util/util-logging.vala"
	_tmp50_ = str;
#line 820 "../src/engine/util/util-logging.vala"
	_tmp51_ = message;
#line 820 "../src/engine/util/util-logging.vala"
	g_string_append (_tmp50_, _tmp51_);
#line 822 "../src/engine/util/util-logging.vala"
	_tmp52_ = str;
#line 822 "../src/engine/util/util-logging.vala"
	_tmp53_ = _tmp52_->str;
#line 822 "../src/engine/util/util-logging.vala"
	_tmp54_ = g_strdup (_tmp53_);
#line 822 "../src/engine/util/util-logging.vala"
	result = _tmp54_;
#line 822 "../src/engine/util/util-logging.vala"
	_g_string_free0 (str);
#line 822 "../src/engine/util/util-logging.vala"
	_g_date_time_unref0 (time);
#line 822 "../src/engine/util/util-logging.vala"
	_g_free0 (message);
#line 822 "../src/engine/util/util-logging.vala"
	_g_free0 (domain);
#line 822 "../src/engine/util/util-logging.vala"
	return result;
#line 3469 "util-logging.c"
}

static void
geary_logging_value_record_init (GValue* value)
{
#line 624 "../src/engine/util/util-logging.vala"
	value->data[0].v_pointer = NULL;
#line 3477 "util-logging.c"
}

static void
geary_logging_value_record_free_value (GValue* value)
{
#line 624 "../src/engine/util/util-logging.vala"
	if (value->data[0].v_pointer) {
#line 624 "../src/engine/util/util-logging.vala"
		geary_logging_record_unref (value->data[0].v_pointer);
#line 3487 "util-logging.c"
	}
}

static void
geary_logging_value_record_copy_value (const GValue* src_value,
                                       GValue* dest_value)
{
#line 624 "../src/engine/util/util-logging.vala"
	if (src_value->data[0].v_pointer) {
#line 624 "../src/engine/util/util-logging.vala"
		dest_value->data[0].v_pointer = geary_logging_record_ref (src_value->data[0].v_pointer);
#line 3499 "util-logging.c"
	} else {
#line 624 "../src/engine/util/util-logging.vala"
		dest_value->data[0].v_pointer = NULL;
#line 3503 "util-logging.c"
	}
}

static gpointer
geary_logging_value_record_peek_pointer (const GValue* value)
{
#line 624 "../src/engine/util/util-logging.vala"
	return value->data[0].v_pointer;
#line 3512 "util-logging.c"
}

static gchar*
geary_logging_value_record_collect_value (GValue* value,
                                          guint n_collect_values,
                                          GTypeCValue* collect_values,
                                          guint collect_flags)
{
#line 624 "../src/engine/util/util-logging.vala"
	if (collect_values[0].v_pointer) {
#line 3523 "util-logging.c"
		GearyLoggingRecord * object;
		object = collect_values[0].v_pointer;
#line 624 "../src/engine/util/util-logging.vala"
		if (object->parent_instance.g_class == NULL) {
#line 624 "../src/engine/util/util-logging.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3530 "util-logging.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 624 "../src/engine/util/util-logging.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3534 "util-logging.c"
		}
#line 624 "../src/engine/util/util-logging.vala"
		value->data[0].v_pointer = geary_logging_record_ref (object);
#line 3538 "util-logging.c"
	} else {
#line 624 "../src/engine/util/util-logging.vala"
		value->data[0].v_pointer = NULL;
#line 3542 "util-logging.c"
	}
#line 624 "../src/engine/util/util-logging.vala"
	return NULL;
#line 3546 "util-logging.c"
}

static gchar*
geary_logging_value_record_lcopy_value (const GValue* value,
                                        guint n_collect_values,
                                        GTypeCValue* collect_values,
                                        guint collect_flags)
{
	GearyLoggingRecord ** object_p;
	object_p = collect_values[0].v_pointer;
#line 624 "../src/engine/util/util-logging.vala"
	if (!object_p) {
#line 624 "../src/engine/util/util-logging.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 3561 "util-logging.c"
	}
#line 624 "../src/engine/util/util-logging.vala"
	if (!value->data[0].v_pointer) {
#line 624 "../src/engine/util/util-logging.vala"
		*object_p = NULL;
#line 3567 "util-logging.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 624 "../src/engine/util/util-logging.vala"
		*object_p = value->data[0].v_pointer;
#line 3571 "util-logging.c"
	} else {
#line 624 "../src/engine/util/util-logging.vala"
		*object_p = geary_logging_record_ref (value->data[0].v_pointer);
#line 3575 "util-logging.c"
	}
#line 624 "../src/engine/util/util-logging.vala"
	return NULL;
#line 3579 "util-logging.c"
}

GParamSpec*
geary_logging_param_spec_record (const gchar* name,
                                 const gchar* nick,
                                 const gchar* blurb,
                                 GType object_type,
                                 GParamFlags flags)
{
	GearyLoggingParamSpecRecord* spec;
#line 624 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GEARY_LOGGING_TYPE_RECORD), NULL);
#line 624 "../src/engine/util/util-logging.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 624 "../src/engine/util/util-logging.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 624 "../src/engine/util/util-logging.vala"
	return G_PARAM_SPEC (spec);
#line 3598 "util-logging.c"
}

gpointer
geary_logging_value_get_record (const GValue* value)
{
#line 624 "../src/engine/util/util-logging.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_LOGGING_TYPE_RECORD), NULL);
#line 624 "../src/engine/util/util-logging.vala"
	return value->data[0].v_pointer;
#line 3608 "util-logging.c"
}

void
geary_logging_value_set_record (GValue* value,
                                gpointer v_object)
{
	GearyLoggingRecord * old;
#line 624 "../src/engine/util/util-logging.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_LOGGING_TYPE_RECORD));
#line 624 "../src/engine/util/util-logging.vala"
	old = value->data[0].v_pointer;
#line 624 "../src/engine/util/util-logging.vala"
	if (v_object) {
#line 624 "../src/engine/util/util-logging.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GEARY_LOGGING_TYPE_RECORD));
#line 624 "../src/engine/util/util-logging.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 624 "../src/engine/util/util-logging.vala"
		value->data[0].v_pointer = v_object;
#line 624 "../src/engine/util/util-logging.vala"
		geary_logging_record_ref (value->data[0].v_pointer);
#line 3630 "util-logging.c"
	} else {
#line 624 "../src/engine/util/util-logging.vala"
		value->data[0].v_pointer = NULL;
#line 3634 "util-logging.c"
	}
#line 624 "../src/engine/util/util-logging.vala"
	if (old) {
#line 624 "../src/engine/util/util-logging.vala"
		geary_logging_record_unref (old);
#line 3640 "util-logging.c"
	}
}

void
geary_logging_value_take_record (GValue* value,
                                 gpointer v_object)
{
	GearyLoggingRecord * old;
#line 624 "../src/engine/util/util-logging.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_LOGGING_TYPE_RECORD));
#line 624 "../src/engine/util/util-logging.vala"
	old = value->data[0].v_pointer;
#line 624 "../src/engine/util/util-logging.vala"
	if (v_object) {
#line 624 "../src/engine/util/util-logging.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GEARY_LOGGING_TYPE_RECORD));
#line 624 "../src/engine/util/util-logging.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 624 "../src/engine/util/util-logging.vala"
		value->data[0].v_pointer = v_object;
#line 3661 "util-logging.c"
	} else {
#line 624 "../src/engine/util/util-logging.vala"
		value->data[0].v_pointer = NULL;
#line 3665 "util-logging.c"
	}
#line 624 "../src/engine/util/util-logging.vala"
	if (old) {
#line 624 "../src/engine/util/util-logging.vala"
		geary_logging_record_unref (old);
#line 3671 "util-logging.c"
	}
}

static void
geary_logging_record_class_init (GearyLoggingRecordClass * klass,
                                 gpointer klass_data)
{
#line 624 "../src/engine/util/util-logging.vala"
	geary_logging_record_parent_class = g_type_class_peek_parent (klass);
#line 624 "../src/engine/util/util-logging.vala"
	((GearyLoggingRecordClass *) klass)->finalize = geary_logging_record_finalize;
#line 624 "../src/engine/util/util-logging.vala"
	g_type_class_adjust_private_offset (klass, &GearyLoggingRecord_private_offset);
#line 3685 "util-logging.c"
}

static void
geary_logging_record_instance_init (GearyLoggingRecord * self,
                                    gpointer klass)
{
#line 624 "../src/engine/util/util-logging.vala"
	self->priv = geary_logging_record_get_instance_private (self);
#line 628 "../src/engine/util/util-logging.vala"
	self->priv->_domain = NULL;
#line 631 "../src/engine/util/util-logging.vala"
	self->priv->_account = NULL;
#line 634 "../src/engine/util/util-logging.vala"
	self->priv->_service = NULL;
#line 637 "../src/engine/util/util-logging.vala"
	self->priv->_folder = NULL;
#line 640 "../src/engine/util/util-logging.vala"
	self->message = NULL;
#line 643 "../src/engine/util/util-logging.vala"
	self->source_type = NULL;
#line 646 "../src/engine/util/util-logging.vala"
	self->source_filename = NULL;
#line 649 "../src/engine/util/util-logging.vala"
	self->source_line_number = NULL;
#line 652 "../src/engine/util/util-logging.vala"
	self->source_function = NULL;
#line 661 "../src/engine/util/util-logging.vala"
	self->priv->_next = NULL;
#line 664 "../src/engine/util/util-logging.vala"
	self->priv->filled = FALSE;
#line 665 "../src/engine/util/util-logging.vala"
	self->priv->old_log_api = FALSE;
#line 624 "../src/engine/util/util-logging.vala"
	self->ref_count = 1;
#line 3720 "util-logging.c"
}

static void
geary_logging_record_finalize (GearyLoggingRecord * obj)
{
	GearyLoggingRecord * self;
#line 624 "../src/engine/util/util-logging.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_LOGGING_TYPE_RECORD, GearyLoggingRecord);
#line 624 "../src/engine/util/util-logging.vala"
	g_signal_handlers_destroy (self);
#line 628 "../src/engine/util/util-logging.vala"
	_g_free0 (self->priv->_domain);
#line 631 "../src/engine/util/util-logging.vala"
	_g_object_unref0 (self->priv->_account);
#line 634 "../src/engine/util/util-logging.vala"
	_g_object_unref0 (self->priv->_service);
#line 637 "../src/engine/util/util-logging.vala"
	_g_object_unref0 (self->priv->_folder);
#line 640 "../src/engine/util/util-logging.vala"
	_g_free0 (self->message);
#line 643 "../src/engine/util/util-logging.vala"
	_g_free0 (self->source_type);
#line 646 "../src/engine/util/util-logging.vala"
	_g_free0 (self->source_filename);
#line 649 "../src/engine/util/util-logging.vala"
	_g_free0 (self->source_line_number);
#line 652 "../src/engine/util/util-logging.vala"
	_g_free0 (self->source_function);
#line 661 "../src/engine/util/util-logging.vala"
	_geary_logging_record_unref0 (self->priv->_next);
#line 663 "../src/engine/util/util-logging.vala"
	self->priv->states = (_vala_array_free (self->priv->states, self->priv->states_length1, (GDestroyNotify) g_free), NULL);
#line 3753 "util-logging.c"
}

/**
 * A record of a single message sent to the logging system.
 *
 * A record is created for each message logged, and stored in a
 * limited-length, singly-linked buffer. Applications can retrieve
 * this by calling {@link get_earliest_record} and then {get_next},
 * and can be notified of new records via {@link set_log_listener}.
 */
 G_GNUC_NO_INLINE static GType
geary_logging_record_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { geary_logging_value_record_init, geary_logging_value_record_free_value, geary_logging_value_record_copy_value, geary_logging_value_record_peek_pointer, "p", geary_logging_value_record_collect_value, "p", geary_logging_value_record_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GearyLoggingRecordClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_logging_record_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyLoggingRecord), 0, (GInstanceInitFunc) geary_logging_record_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType geary_logging_record_type_id;
	geary_logging_record_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GearyLoggingRecord", &g_define_type_info, &g_define_type_fundamental_info, 0);
	GearyLoggingRecord_private_offset = g_type_add_instance_private (geary_logging_record_type_id, sizeof (GearyLoggingRecordPrivate));
	return geary_logging_record_type_id;
}

GType
geary_logging_record_get_type (void)
{
	static gsize geary_logging_record_type_id__once = 0;
	if (g_once_init_enter (&geary_logging_record_type_id__once)) {
		GType geary_logging_record_type_id;
		geary_logging_record_type_id = geary_logging_record_get_type_once ();
		g_once_init_leave (&geary_logging_record_type_id__once, geary_logging_record_type_id);
	}
	return geary_logging_record_type_id__once;
}

gpointer
geary_logging_record_ref (gpointer instance)
{
	GearyLoggingRecord * self;
	self = instance;
#line 624 "../src/engine/util/util-logging.vala"
	g_atomic_int_inc (&self->ref_count);
#line 624 "../src/engine/util/util-logging.vala"
	return instance;
#line 3797 "util-logging.c"
}

void
geary_logging_record_unref (gpointer instance)
{
	GearyLoggingRecord * self;
	self = instance;
#line 624 "../src/engine/util/util-logging.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 624 "../src/engine/util/util-logging.vala"
		GEARY_LOGGING_RECORD_GET_CLASS (self)->finalize (self);
#line 624 "../src/engine/util/util-logging.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 3811 "util-logging.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static void
_vala_clear_GMutex (GMutex * mutex)
{
	GMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GMutex))) {
		g_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GMutex));
	}
}

static void
_vala_clear_GRecMutex (GRecMutex * mutex)
{
	GRecMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRecMutex))) {
		g_rec_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GRecMutex));
	}
}

static void
_vala_clear_GRWLock (GRWLock * mutex)
{
	GRWLock zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRWLock))) {
		g_rw_lock_clear (mutex);
		memset (mutex, 0, sizeof (GRWLock));
	}
}

static void
_vala_clear_GCond (GCond * mutex)
{
	GCond zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GCond))) {
		g_cond_clear (mutex);
		memset (mutex, 0, sizeof (GCond));
	}
}

