/* util-stream.c generated by valac 0.56.17, the Vala compiler
 * generated from util-stream.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <gio/gio.h>
#include "geary-engine.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gmime/gmime.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
typedef struct _GearyStreamWriteAllAsyncData GearyStreamWriteAllAsyncData;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _GearyStreamWriteStringAsyncData GearyStreamWriteStringAsyncData;
enum  {
	GEARY_STREAM_MIME_OUTPUT_STREAM_0_PROPERTY,
	GEARY_STREAM_MIME_OUTPUT_STREAM_NUM_PROPERTIES
};
static GParamSpec* geary_stream_mime_output_stream_properties[GEARY_STREAM_MIME_OUTPUT_STREAM_NUM_PROPERTIES];

struct _GearyStreamWriteAllAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GOutputStream* outs;
	GearyMemoryBuffer* buffer;
	GCancellable* cancellable;
	gsize _tmp0_;
	gsize _tmp1_;
	GBytes* bytes;
	guint8* data;
	gint data_length1;
	gint _data_size_;
	GearyMemoryUnownedBytesBuffer* unowned_bytes;
	GearyMemoryUnownedBytesBuffer* _tmp2_;
	GearyMemoryUnownedBytesBuffer* _tmp3_;
	GearyMemoryUnownedBytesBuffer* _tmp4_;
	gint _tmp5_;
	guint8* _tmp6_;
	GBytes* _tmp7_;
	GBytes* _tmp8_;
	gsize _tmp9_;
	guint8* _tmp10_;
	gssize offset;
	gboolean _tmp11_;
	guint8* _tmp12_;
	gint _tmp12__length1;
	gssize _tmp13_;
	guint8* _tmp14_;
	gint _tmp14__length1;
	guint8* _tmp15_;
	gint _tmp15__length1;
	GError* _inner_error0_;
};

struct _GearyStreamWriteStringAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GOutputStream* outs;
	gchar* str;
	GCancellable* cancellable;
	GearyMemoryStringBuffer* _tmp0_;
	GearyMemoryStringBuffer* _tmp1_;
	GError* _inner_error0_;
};

struct _GearyStreamMimeOutputStreamPrivate {
	GOutputStream* dest;
	gint64 written;
};

static gint GearyStreamMimeOutputStream_private_offset;
static gpointer geary_stream_mime_output_stream_parent_class = NULL;

static void geary_stream_write_all_async_data_free (gpointer _data);
static gboolean geary_stream_write_all_async_co (GearyStreamWriteAllAsyncData* _data_);
static void geary_stream_write_all_async_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_);
static void geary_stream_write_string_async_data_free (gpointer _data);
static gboolean geary_stream_write_string_async_co (GearyStreamWriteStringAsyncData* _data_);
static void geary_stream_write_string_async_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
static gint64 geary_stream_mime_output_stream_real_length (GMimeStream* base);
static gssize geary_stream_mime_output_stream_real_write (GMimeStream* base,
                                                   guint8* buf,
                                                   gsize buf_length1);
static gint geary_stream_mime_output_stream_real_close (GMimeStream* base);
static gint geary_stream_mime_output_stream_real_flush (GMimeStream* base);
static gboolean geary_stream_mime_output_stream_real_eos (GMimeStream* base);
static void geary_stream_mime_output_stream_finalize (GObject * obj);
static GType geary_stream_mime_output_stream_get_type_once (void);

static void
geary_stream_write_all_async_data_free (gpointer _data)
{
	GearyStreamWriteAllAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->outs);
	_g_object_unref0 (_data_->buffer);
	_g_object_unref0 (_data_->cancellable);
	g_slice_free (GearyStreamWriteAllAsyncData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
geary_stream_write_all_async (GOutputStream* outs,
                              GearyMemoryBuffer* buffer,
                              GCancellable* cancellable,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	GearyStreamWriteAllAsyncData* _data_;
	GOutputStream* _tmp0_;
	GearyMemoryBuffer* _tmp1_;
	GCancellable* _tmp2_;
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (outs, g_output_stream_get_type ()));
	g_return_if_fail (GEARY_MEMORY_IS_BUFFER (buffer));
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
	_data_ = g_slice_new0 (GearyStreamWriteAllAsyncData);
	_data_->_async_result = g_task_new (NULL, cancellable, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, geary_stream_write_all_async_data_free);
	_tmp0_ = _g_object_ref0 (outs);
	_g_object_unref0 (_data_->outs);
	_data_->outs = _tmp0_;
	_tmp1_ = _g_object_ref0 (buffer);
	_g_object_unref0 (_data_->buffer);
	_data_->buffer = _tmp1_;
	_tmp2_ = _g_object_ref0 (cancellable);
	_g_object_unref0 (_data_->cancellable);
	_data_->cancellable = _tmp2_;
	geary_stream_write_all_async_co (_data_);
}

void
geary_stream_write_all_finish (GAsyncResult* _res_,
                               GError** error)
{
	GearyStreamWriteAllAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return;
	}
}

/**
     * Provides an asynchronous version of OutputStream.write_all().
     */
static void
geary_stream_write_all_async_ready (GObject* source_object,
                                    GAsyncResult* _res_,
                                    gpointer _user_data_)
{
	GearyStreamWriteAllAsyncData* _data_;
#line 31 "../src/engine/util/util-stream.vala"
	_data_ = _user_data_;
#line 31 "../src/engine/util/util-stream.vala"
	_data_->_source_object_ = source_object;
#line 31 "../src/engine/util/util-stream.vala"
	_data_->_res_ = _res_;
#line 31 "../src/engine/util/util-stream.vala"
	geary_stream_write_all_async_co (_data_);
#line 190 "util-stream.c"
}

static gboolean
geary_stream_write_all_async_co (GearyStreamWriteAllAsyncData* _data_)
{
#line 12 "../src/engine/util/util-stream.vala"
	switch (_data_->_state_) {
#line 12 "../src/engine/util/util-stream.vala"
		case 0:
#line 200 "util-stream.c"
		goto _state_0;
#line 12 "../src/engine/util/util-stream.vala"
		case 1:
#line 204 "util-stream.c"
		goto _state_1;
		default:
#line 12 "../src/engine/util/util-stream.vala"
		g_assert_not_reached ();
#line 209 "util-stream.c"
	}
	_state_0:
#line 14 "../src/engine/util/util-stream.vala"
	_data_->_tmp0_ = geary_memory_buffer_get_size (_data_->buffer);
#line 14 "../src/engine/util/util-stream.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 14 "../src/engine/util/util-stream.vala"
	if (_data_->_tmp1_ == ((gsize) 0)) {
#line 15 "../src/engine/util/util-stream.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 15 "../src/engine/util/util-stream.vala"
		if (_data_->_state_ != 0) {
#line 15 "../src/engine/util/util-stream.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 15 "../src/engine/util/util-stream.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 226 "util-stream.c"
			}
		}
#line 15 "../src/engine/util/util-stream.vala"
		g_object_unref (_data_->_async_result);
#line 15 "../src/engine/util/util-stream.vala"
		return FALSE;
#line 233 "util-stream.c"
	}
#line 18 "../src/engine/util/util-stream.vala"
	_data_->bytes = NULL;
#line 19 "../src/engine/util/util-stream.vala"
	_data_->data_length1 = 0;
#line 19 "../src/engine/util/util-stream.vala"
	_data_->_data_size_ = 0;
#line 20 "../src/engine/util/util-stream.vala"
	_data_->_tmp2_ = _g_object_ref0 (GEARY_MEMORY_IS_UNOWNED_BYTES_BUFFER (_data_->buffer) ? ((GearyMemoryUnownedBytesBuffer*) _data_->buffer) : NULL);
#line 20 "../src/engine/util/util-stream.vala"
	_data_->unowned_bytes = _data_->_tmp2_;
#line 21 "../src/engine/util/util-stream.vala"
	_data_->_tmp3_ = _data_->unowned_bytes;
#line 21 "../src/engine/util/util-stream.vala"
	if (_data_->_tmp3_ != NULL) {
#line 22 "../src/engine/util/util-stream.vala"
		_data_->_tmp4_ = _data_->unowned_bytes;
#line 22 "../src/engine/util/util-stream.vala"
		_data_->_tmp5_ = 0;
#line 22 "../src/engine/util/util-stream.vala"
		_data_->_tmp6_ = geary_memory_unowned_bytes_buffer_to_unowned_uint8_array (_data_->_tmp4_, &_data_->_tmp5_);
#line 22 "../src/engine/util/util-stream.vala"
		_data_->data = _data_->_tmp6_;
#line 22 "../src/engine/util/util-stream.vala"
		_data_->data_length1 = _data_->_tmp5_;
#line 22 "../src/engine/util/util-stream.vala"
		_data_->_data_size_ = _data_->data_length1;
#line 261 "util-stream.c"
	} else {
#line 25 "../src/engine/util/util-stream.vala"
		_data_->_tmp7_ = geary_memory_buffer_get_bytes (_data_->buffer);
#line 25 "../src/engine/util/util-stream.vala"
		_g_bytes_unref0 (_data_->bytes);
#line 25 "../src/engine/util/util-stream.vala"
		_data_->bytes = _data_->_tmp7_;
#line 26 "../src/engine/util/util-stream.vala"
		_data_->_tmp8_ = _data_->bytes;
#line 26 "../src/engine/util/util-stream.vala"
		_data_->_tmp9_ = 0;
#line 26 "../src/engine/util/util-stream.vala"
		_data_->_tmp10_ = g_bytes_get_data (_data_->_tmp8_, &_data_->_tmp9_);
#line 26 "../src/engine/util/util-stream.vala"
		_data_->data = _data_->_tmp10_;
#line 26 "../src/engine/util/util-stream.vala"
		_data_->data_length1 = _data_->_tmp9_;
#line 26 "../src/engine/util/util-stream.vala"
		_data_->_data_size_ = _data_->data_length1;
#line 281 "util-stream.c"
	}
#line 29 "../src/engine/util/util-stream.vala"
	_data_->offset = (gssize) 0;
#line 285 "util-stream.c"
	{
#line 30 "../src/engine/util/util-stream.vala"
		_data_->_tmp11_ = TRUE;
#line 30 "../src/engine/util/util-stream.vala"
		while (TRUE) {
#line 30 "../src/engine/util/util-stream.vala"
			if (!_data_->_tmp11_) {
#line 32 "../src/engine/util/util-stream.vala"
				_data_->_tmp12_ = _data_->data;
#line 32 "../src/engine/util/util-stream.vala"
				_data_->_tmp12__length1 = _data_->data_length1;
#line 32 "../src/engine/util/util-stream.vala"
				if (!(_data_->offset < ((gssize) _data_->_tmp12__length1))) {
#line 32 "../src/engine/util/util-stream.vala"
					break;
#line 301 "util-stream.c"
				}
			}
#line 30 "../src/engine/util/util-stream.vala"
			_data_->_tmp11_ = FALSE;
#line 31 "../src/engine/util/util-stream.vala"
			_data_->_tmp14_ = _data_->data;
#line 31 "../src/engine/util/util-stream.vala"
			_data_->_tmp14__length1 = _data_->data_length1;
#line 31 "../src/engine/util/util-stream.vala"
			_data_->_tmp15_ = _data_->data;
#line 31 "../src/engine/util/util-stream.vala"
			_data_->_tmp15__length1 = _data_->data_length1;
#line 31 "../src/engine/util/util-stream.vala"
			_data_->_state_ = 1;
#line 31 "../src/engine/util/util-stream.vala"
			g_output_stream_write_async (_data_->outs, _data_->_tmp14_ + ((gint) _data_->offset), (gsize) (_data_->_tmp15__length1 - ((gint) _data_->offset)), G_PRIORITY_DEFAULT, _data_->cancellable, geary_stream_write_all_async_ready, _data_);
#line 31 "../src/engine/util/util-stream.vala"
			return FALSE;
#line 320 "util-stream.c"
			_state_1:
#line 31 "../src/engine/util/util-stream.vala"
			_data_->_tmp13_ = g_output_stream_write_finish (_data_->outs, _data_->_res_, &_data_->_inner_error0_);
#line 31 "../src/engine/util/util-stream.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 31 "../src/engine/util/util-stream.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 31 "../src/engine/util/util-stream.vala"
				_g_object_unref0 (_data_->unowned_bytes);
#line 31 "../src/engine/util/util-stream.vala"
				_g_bytes_unref0 (_data_->bytes);
#line 31 "../src/engine/util/util-stream.vala"
				g_object_unref (_data_->_async_result);
#line 31 "../src/engine/util/util-stream.vala"
				return FALSE;
#line 336 "util-stream.c"
			}
#line 31 "../src/engine/util/util-stream.vala"
			_data_->offset += _data_->_tmp13_;
#line 340 "util-stream.c"
		}
	}
#line 12 "../src/engine/util/util-stream.vala"
	_g_object_unref0 (_data_->unowned_bytes);
#line 12 "../src/engine/util/util-stream.vala"
	_g_bytes_unref0 (_data_->bytes);
#line 12 "../src/engine/util/util-stream.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 12 "../src/engine/util/util-stream.vala"
	if (_data_->_state_ != 0) {
#line 12 "../src/engine/util/util-stream.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 12 "../src/engine/util/util-stream.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 355 "util-stream.c"
		}
	}
#line 12 "../src/engine/util/util-stream.vala"
	g_object_unref (_data_->_async_result);
#line 12 "../src/engine/util/util-stream.vala"
	return FALSE;
#line 362 "util-stream.c"
}

static void
geary_stream_write_string_async_data_free (gpointer _data)
{
	GearyStreamWriteStringAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->outs);
	_g_free0 (_data_->str);
	_g_object_unref0 (_data_->cancellable);
	g_slice_free (GearyStreamWriteStringAsyncData, _data_);
}

void
geary_stream_write_string_async (GOutputStream* outs,
                                 const gchar* str,
                                 GCancellable* cancellable,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	GearyStreamWriteStringAsyncData* _data_;
	GOutputStream* _tmp0_;
	gchar* _tmp1_;
	GCancellable* _tmp2_;
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (outs, g_output_stream_get_type ()));
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
	_data_ = g_slice_new0 (GearyStreamWriteStringAsyncData);
	_data_->_async_result = g_task_new (NULL, cancellable, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, geary_stream_write_string_async_data_free);
	_tmp0_ = _g_object_ref0 (outs);
	_g_object_unref0 (_data_->outs);
	_data_->outs = _tmp0_;
	_tmp1_ = g_strdup (str);
	_g_free0 (_data_->str);
	_data_->str = _tmp1_;
	_tmp2_ = _g_object_ref0 (cancellable);
	_g_object_unref0 (_data_->cancellable);
	_data_->cancellable = _tmp2_;
	geary_stream_write_string_async_co (_data_);
}

void
geary_stream_write_string_finish (GAsyncResult* _res_,
                                  GError** error)
{
	GearyStreamWriteStringAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return;
	}
}

/**
     * Asynchronously writes the entire string to the OutputStream.
     */
static void
geary_stream_write_string_async_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	GearyStreamWriteStringAsyncData* _data_;
#line 41 "../src/engine/util/util-stream.vala"
	_data_ = _user_data_;
#line 41 "../src/engine/util/util-stream.vala"
	_data_->_source_object_ = source_object;
#line 41 "../src/engine/util/util-stream.vala"
	_data_->_res_ = _res_;
#line 41 "../src/engine/util/util-stream.vala"
	geary_stream_write_string_async_co (_data_);
#line 432 "util-stream.c"
}

static gboolean
geary_stream_write_string_async_co (GearyStreamWriteStringAsyncData* _data_)
{
#line 38 "../src/engine/util/util-stream.vala"
	switch (_data_->_state_) {
#line 38 "../src/engine/util/util-stream.vala"
		case 0:
#line 442 "util-stream.c"
		goto _state_0;
#line 38 "../src/engine/util/util-stream.vala"
		case 1:
#line 446 "util-stream.c"
		goto _state_1;
		default:
#line 38 "../src/engine/util/util-stream.vala"
		g_assert_not_reached ();
#line 451 "util-stream.c"
	}
	_state_0:
#line 40 "../src/engine/util/util-stream.vala"
	if (!geary_string_is_empty (_data_->str)) {
#line 41 "../src/engine/util/util-stream.vala"
		_data_->_tmp0_ = geary_memory_string_buffer_new (_data_->str);
#line 41 "../src/engine/util/util-stream.vala"
		_data_->_tmp1_ = _data_->_tmp0_;
#line 41 "../src/engine/util/util-stream.vala"
		_data_->_state_ = 1;
#line 41 "../src/engine/util/util-stream.vala"
		geary_stream_write_all_async (_data_->outs, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp1_, GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBuffer), _data_->cancellable, geary_stream_write_string_async_ready, _data_);
#line 41 "../src/engine/util/util-stream.vala"
		return FALSE;
#line 466 "util-stream.c"
		_state_1:
#line 41 "../src/engine/util/util-stream.vala"
		geary_stream_write_all_finish (_data_->_res_, &_data_->_inner_error0_);
#line 41 "../src/engine/util/util-stream.vala"
		_g_object_unref0 (_data_->_tmp1_);
#line 41 "../src/engine/util/util-stream.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 41 "../src/engine/util/util-stream.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 41 "../src/engine/util/util-stream.vala"
			g_object_unref (_data_->_async_result);
#line 41 "../src/engine/util/util-stream.vala"
			return FALSE;
#line 480 "util-stream.c"
		}
	}
#line 38 "../src/engine/util/util-stream.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 38 "../src/engine/util/util-stream.vala"
	if (_data_->_state_ != 0) {
#line 38 "../src/engine/util/util-stream.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 38 "../src/engine/util/util-stream.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 491 "util-stream.c"
		}
	}
#line 38 "../src/engine/util/util-stream.vala"
	g_object_unref (_data_->_async_result);
#line 38 "../src/engine/util/util-stream.vala"
	return FALSE;
#line 498 "util-stream.c"
}

static inline gpointer
geary_stream_mime_output_stream_get_instance_private (GearyStreamMimeOutputStream* self)
{
	return G_STRUCT_MEMBER_P (self, GearyStreamMimeOutputStream_private_offset);
}

GearyStreamMimeOutputStream*
geary_stream_mime_output_stream_construct (GType object_type,
                                           GOutputStream* dest)
{
	GearyStreamMimeOutputStream * self = NULL;
	GOutputStream* _tmp0_;
#line 53 "../src/engine/util/util-stream.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dest, g_output_stream_get_type ()), NULL);
#line 53 "../src/engine/util/util-stream.vala"
	self = (GearyStreamMimeOutputStream*) g_object_new (object_type, NULL);
#line 54 "../src/engine/util/util-stream.vala"
	_tmp0_ = _g_object_ref0 (dest);
#line 54 "../src/engine/util/util-stream.vala"
	_g_object_unref0 (self->priv->dest);
#line 54 "../src/engine/util/util-stream.vala"
	self->priv->dest = _tmp0_;
#line 53 "../src/engine/util/util-stream.vala"
	return self;
#line 525 "util-stream.c"
}

GearyStreamMimeOutputStream*
geary_stream_mime_output_stream_new (GOutputStream* dest)
{
#line 53 "../src/engine/util/util-stream.vala"
	return geary_stream_mime_output_stream_construct (GEARY_STREAM_TYPE_MIME_OUTPUT_STREAM, dest);
#line 533 "util-stream.c"
}

static gint64
geary_stream_mime_output_stream_real_length (GMimeStream* base)
{
	GearyStreamMimeOutputStream * self;
	gint64 result;
#line 57 "../src/engine/util/util-stream.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_STREAM_TYPE_MIME_OUTPUT_STREAM, GearyStreamMimeOutputStream);
#line 60 "../src/engine/util/util-stream.vala"
	result = self->priv->written;
#line 60 "../src/engine/util/util-stream.vala"
	return result;
#line 547 "util-stream.c"
}

static gssize
geary_stream_mime_output_stream_real_write (GMimeStream* base,
                                            guint8* buf,
                                            gsize buf_length1)
{
	GearyStreamMimeOutputStream * self;
	gssize _tmp2_ = -1L;
	GError* _inner_error0_ = NULL;
	gssize result;
#line 68 "../src/engine/util/util-stream.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_STREAM_TYPE_MIME_OUTPUT_STREAM, GearyStreamMimeOutputStream);
#line 561 "util-stream.c"
	{
		gssize ret = 0L;
		GOutputStream* _tmp0_;
#line 70 "../src/engine/util/util-stream.vala"
		_tmp0_ = self->priv->dest;
#line 70 "../src/engine/util/util-stream.vala"
		ret = g_output_stream_write (_tmp0_, buf, (gsize) buf_length1, NULL, &_inner_error0_);
#line 70 "../src/engine/util/util-stream.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 571 "util-stream.c"
			gssize _tmp1_ = -1L;
#line 70 "../src/engine/util/util-stream.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 575 "util-stream.c"
				goto __catch0_g_io_error;
			}
#line 70 "../src/engine/util/util-stream.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 70 "../src/engine/util/util-stream.vala"
			g_clear_error (&_inner_error0_);
#line 70 "../src/engine/util/util-stream.vala"
			return _tmp1_;
#line 584 "util-stream.c"
		}
#line 72 "../src/engine/util/util-stream.vala"
		if (ret > ((gssize) 0)) {
#line 73 "../src/engine/util/util-stream.vala"
			self->priv->written = self->priv->written + ret;
#line 590 "util-stream.c"
		}
#line 75 "../src/engine/util/util-stream.vala"
		result = ret;
#line 75 "../src/engine/util/util-stream.vala"
		return result;
#line 596 "util-stream.c"
	}
	goto __finally0;
	__catch0_g_io_error:
	{
#line 69 "../src/engine/util/util-stream.vala"
		g_clear_error (&_inner_error0_);
#line 78 "../src/engine/util/util-stream.vala"
		result = (gssize) -1;
#line 78 "../src/engine/util/util-stream.vala"
		return result;
#line 607 "util-stream.c"
	}
	__finally0:
#line 69 "../src/engine/util/util-stream.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 69 "../src/engine/util/util-stream.vala"
	g_clear_error (&_inner_error0_);
#line 69 "../src/engine/util/util-stream.vala"
	return _tmp2_;
#line 616 "util-stream.c"
}

static gint
geary_stream_mime_output_stream_real_close (GMimeStream* base)
{
	GearyStreamMimeOutputStream * self;
	gint ret = 0;
	GError* _inner_error0_ = NULL;
	gint result;
#line 82 "../src/engine/util/util-stream.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_STREAM_TYPE_MIME_OUTPUT_STREAM, GearyStreamMimeOutputStream);
#line 83 "../src/engine/util/util-stream.vala"
	ret = -1;
#line 630 "util-stream.c"
	{
		gint _tmp0_ = 0;
		gboolean _tmp1_ = FALSE;
		GOutputStream* _tmp2_;
#line 85 "../src/engine/util/util-stream.vala"
		_tmp2_ = self->priv->dest;
#line 85 "../src/engine/util/util-stream.vala"
		_tmp1_ = g_output_stream_close (_tmp2_, NULL, &_inner_error0_);
#line 85 "../src/engine/util/util-stream.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 641 "util-stream.c"
			gint _tmp3_ = -1;
#line 85 "../src/engine/util/util-stream.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 645 "util-stream.c"
				goto __catch0_g_io_error;
			}
#line 85 "../src/engine/util/util-stream.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 85 "../src/engine/util/util-stream.vala"
			g_clear_error (&_inner_error0_);
#line 85 "../src/engine/util/util-stream.vala"
			return _tmp3_;
#line 654 "util-stream.c"
		}
#line 85 "../src/engine/util/util-stream.vala"
		if (_tmp1_) {
#line 85 "../src/engine/util/util-stream.vala"
			_tmp0_ = 0;
#line 660 "util-stream.c"
		} else {
#line 85 "../src/engine/util/util-stream.vala"
			_tmp0_ = -1;
#line 664 "util-stream.c"
		}
#line 85 "../src/engine/util/util-stream.vala"
		ret = _tmp0_;
#line 668 "util-stream.c"
	}
	goto __finally0;
	__catch0_g_io_error:
	{
#line 84 "../src/engine/util/util-stream.vala"
		g_clear_error (&_inner_error0_);
#line 675 "util-stream.c"
	}
	__finally0:
#line 84 "../src/engine/util/util-stream.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 680 "util-stream.c"
		gint _tmp4_ = -1;
#line 84 "../src/engine/util/util-stream.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 84 "../src/engine/util/util-stream.vala"
		g_clear_error (&_inner_error0_);
#line 84 "../src/engine/util/util-stream.vala"
		return _tmp4_;
#line 688 "util-stream.c"
	}
#line 89 "../src/engine/util/util-stream.vala"
	result = ret;
#line 89 "../src/engine/util/util-stream.vala"
	return result;
#line 694 "util-stream.c"
}

static gint
geary_stream_mime_output_stream_real_flush (GMimeStream* base)
{
	GearyStreamMimeOutputStream * self;
	gint ret = 0;
	GError* _inner_error0_ = NULL;
	gint result;
#line 92 "../src/engine/util/util-stream.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_STREAM_TYPE_MIME_OUTPUT_STREAM, GearyStreamMimeOutputStream);
#line 93 "../src/engine/util/util-stream.vala"
	ret = -1;
#line 708 "util-stream.c"
	{
		gint _tmp0_ = 0;
		gboolean _tmp1_ = FALSE;
		GOutputStream* _tmp2_;
#line 95 "../src/engine/util/util-stream.vala"
		_tmp2_ = self->priv->dest;
#line 95 "../src/engine/util/util-stream.vala"
		_tmp1_ = g_output_stream_flush (_tmp2_, NULL, &_inner_error0_);
#line 95 "../src/engine/util/util-stream.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 719 "util-stream.c"
			goto __catch0_g_error;
		}
#line 95 "../src/engine/util/util-stream.vala"
		if (_tmp1_) {
#line 95 "../src/engine/util/util-stream.vala"
			_tmp0_ = 0;
#line 726 "util-stream.c"
		} else {
#line 95 "../src/engine/util/util-stream.vala"
			_tmp0_ = -1;
#line 730 "util-stream.c"
		}
#line 95 "../src/engine/util/util-stream.vala"
		ret = _tmp0_;
#line 734 "util-stream.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 94 "../src/engine/util/util-stream.vala"
		g_clear_error (&_inner_error0_);
#line 741 "util-stream.c"
	}
	__finally0:
#line 94 "../src/engine/util/util-stream.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 746 "util-stream.c"
		gint _tmp3_ = -1;
#line 94 "../src/engine/util/util-stream.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 94 "../src/engine/util/util-stream.vala"
		g_clear_error (&_inner_error0_);
#line 94 "../src/engine/util/util-stream.vala"
		return _tmp3_;
#line 754 "util-stream.c"
	}
#line 99 "../src/engine/util/util-stream.vala"
	result = ret;
#line 99 "../src/engine/util/util-stream.vala"
	return result;
#line 760 "util-stream.c"
}

static gboolean
geary_stream_mime_output_stream_real_eos (GMimeStream* base)
{
	GearyStreamMimeOutputStream * self;
	gboolean _tmp0_ = FALSE;
	GOutputStream* _tmp1_;
	gboolean result;
#line 102 "../src/engine/util/util-stream.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_STREAM_TYPE_MIME_OUTPUT_STREAM, GearyStreamMimeOutputStream);
#line 103 "../src/engine/util/util-stream.vala"
	_tmp1_ = self->priv->dest;
#line 103 "../src/engine/util/util-stream.vala"
	if (g_output_stream_is_closed (_tmp1_)) {
#line 103 "../src/engine/util/util-stream.vala"
		_tmp0_ = TRUE;
#line 778 "util-stream.c"
	} else {
		GOutputStream* _tmp2_;
#line 103 "../src/engine/util/util-stream.vala"
		_tmp2_ = self->priv->dest;
#line 103 "../src/engine/util/util-stream.vala"
		_tmp0_ = g_output_stream_is_closing (_tmp2_);
#line 785 "util-stream.c"
	}
#line 103 "../src/engine/util/util-stream.vala"
	result = _tmp0_;
#line 103 "../src/engine/util/util-stream.vala"
	return result;
#line 791 "util-stream.c"
}

static void
geary_stream_mime_output_stream_class_init (GearyStreamMimeOutputStreamClass * klass,
                                            gpointer klass_data)
{
#line 47 "../src/engine/util/util-stream.vala"
	geary_stream_mime_output_stream_parent_class = g_type_class_peek_parent (klass);
#line 47 "../src/engine/util/util-stream.vala"
	g_type_class_adjust_private_offset (klass, &GearyStreamMimeOutputStream_private_offset);
#line 47 "../src/engine/util/util-stream.vala"
	((GMimeStreamClass *) klass)->length = (gint64 (*) (GMimeStream*)) geary_stream_mime_output_stream_real_length;
#line 47 "../src/engine/util/util-stream.vala"
	((GMimeStreamClass *) klass)->write = (gssize (*) (GMimeStream*, guint8*, gsize)) geary_stream_mime_output_stream_real_write;
#line 47 "../src/engine/util/util-stream.vala"
	((GMimeStreamClass *) klass)->close = (gint (*) (GMimeStream*)) geary_stream_mime_output_stream_real_close;
#line 47 "../src/engine/util/util-stream.vala"
	((GMimeStreamClass *) klass)->flush = (gint (*) (GMimeStream*)) geary_stream_mime_output_stream_real_flush;
#line 47 "../src/engine/util/util-stream.vala"
	((GMimeStreamClass *) klass)->eos = (gboolean (*) (GMimeStream*)) geary_stream_mime_output_stream_real_eos;
#line 47 "../src/engine/util/util-stream.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_stream_mime_output_stream_finalize;
#line 814 "util-stream.c"
}

static void
geary_stream_mime_output_stream_instance_init (GearyStreamMimeOutputStream * self,
                                               gpointer klass)
{
#line 47 "../src/engine/util/util-stream.vala"
	self->priv = geary_stream_mime_output_stream_get_instance_private (self);
#line 50 "../src/engine/util/util-stream.vala"
	self->priv->written = (gint64) 0;
#line 825 "util-stream.c"
}

static void
geary_stream_mime_output_stream_finalize (GObject * obj)
{
	GearyStreamMimeOutputStream * self;
#line 47 "../src/engine/util/util-stream.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_STREAM_TYPE_MIME_OUTPUT_STREAM, GearyStreamMimeOutputStream);
#line 49 "../src/engine/util/util-stream.vala"
	_g_object_unref0 (self->priv->dest);
#line 47 "../src/engine/util/util-stream.vala"
	G_OBJECT_CLASS (geary_stream_mime_output_stream_parent_class)->finalize (obj);
#line 838 "util-stream.c"
}

/**
     * Adaptor from a GMime stream to a GLib OutputStream.
     */
 G_GNUC_NO_INLINE static GType
geary_stream_mime_output_stream_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyStreamMimeOutputStreamClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_stream_mime_output_stream_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyStreamMimeOutputStream), 0, (GInstanceInitFunc) geary_stream_mime_output_stream_instance_init, NULL };
	GType geary_stream_mime_output_stream_type_id;
	geary_stream_mime_output_stream_type_id = g_type_register_static (g_mime_stream_get_type (), "GearyStreamMimeOutputStream", &g_define_type_info, 0);
	GearyStreamMimeOutputStream_private_offset = g_type_add_instance_private (geary_stream_mime_output_stream_type_id, sizeof (GearyStreamMimeOutputStreamPrivate));
	return geary_stream_mime_output_stream_type_id;
}

GType
geary_stream_mime_output_stream_get_type (void)
{
	static gsize geary_stream_mime_output_stream_type_id__once = 0;
	if (g_once_init_enter (&geary_stream_mime_output_stream_type_id__once)) {
		GType geary_stream_mime_output_stream_type_id;
		geary_stream_mime_output_stream_type_id = geary_stream_mime_output_stream_get_type_once ();
		g_once_init_leave (&geary_stream_mime_output_stream_type_id__once, geary_stream_mime_output_stream_type_id);
	}
	return geary_stream_mime_output_stream_type_id__once;
}

