/* accounts-manager.c generated by valac 0.56.17, the Vala compiler
 * generated from accounts-manager.vala, do not modify */

/*
 * Copyright 2017 Software Freedom Conservancy Inc.
 * Copyright 2018 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-client-46.0.h"
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "geary-engine.h"
#include <goa/goa.h>
#include <gobject/gvaluecollector.h>

#define ACCOUNTS_MANAGER_LOCAL_ID_PREFIX "account_"
#define ACCOUNTS_MANAGER_LOCAL_ID_FORMAT "account_%02u"
#define ACCOUNTS_MANAGER_GOA_ID_PREFIX "goa_"
#define ACCOUNTS_MANAGER_CONFIG_VERSION 1
#define ACCOUNTS_MANAGER_GROUP_METADATA "Metadata"
#define ACCOUNTS_MANAGER_METADATA_STATUS "status"
#define ACCOUNTS_MANAGER_METADATA_VERSION "version"
#define ACCOUNTS_MANAGER_METADATA_GOA "goa_id"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_GROUP_ACCOUNT "Account"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_GROUP_FOLDERS "Folders"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_LABEL "label"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_ORDINAL "ordinal"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_PREFETCH "prefetch_days"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_PROVIDER "service_provider"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_SAVE_DRAFTS "save_drafts"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_SAVE_SENT "save_sent"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_SENDERS "sender_mailboxes"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_SIG "signature"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_USE_SIG "use_signature"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_ARCHIVE "archive_folder"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_DRAFTS "drafts_folder"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_JUNK "junk_folder"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_SENT "sent_folder"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_SPAM "spam_folder"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_TRASH "trash_folder"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_GROUP "AccountInformation"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_ALTERNATE_EMAILS_KEY "alternate_emails"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_ARCHIVE_FOLDER_KEY "archive_folder"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_CREDENTIALS_METHOD_KEY "credentials_method"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_CREDENTIALS_PROVIDER_KEY "credentials_provider"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_DRAFTS_FOLDER_KEY "drafts_folder"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_EMAIL_SIGNATURE_KEY "email_signature"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_NICKNAME_KEY "nickname"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_ORDINAL_KEY "ordinal"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_PREFETCH_PERIOD_DAYS_KEY "prefetch_period_days"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_PRIMARY_EMAIL_KEY "primary_email"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_REAL_NAME_KEY "real_name"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SAVE_DRAFTS_KEY "save_drafts"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SAVE_SENT_MAIL_KEY "save_sent_mail"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SENT_MAIL_FOLDER_KEY "sent_mail_folder"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SERVICE_PROVIDER_KEY "service_provider"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SPAM_FOLDER_KEY "spam_folder"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_TRASH_FOLDER_KEY "trash_folder"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_USE_EMAIL_SIGNATURE_KEY "use_email_signature"
#define ACCOUNTS_SERVICE_CONFIG_V1_GROUP_INCOMING "Incoming"
#define ACCOUNTS_SERVICE_CONFIG_V1_GROUP_OUTGOING "Outgoing"
#define ACCOUNTS_SERVICE_CONFIG_V1_CREDENTIALS "credentials"
#define ACCOUNTS_SERVICE_CONFIG_V1_HOST "host"
#define ACCOUNTS_SERVICE_CONFIG_V1_LOGIN "login"
#define ACCOUNTS_SERVICE_CONFIG_V1_PORT "port"
#define ACCOUNTS_SERVICE_CONFIG_V1_REMEMBER_PASSWORD "remember_password"
#define ACCOUNTS_SERVICE_CONFIG_V1_SECURITY "transport_security"
#define ACCOUNTS_SERVICE_CONFIG_LEGACY_HOST "host"
#define ACCOUNTS_SERVICE_CONFIG_LEGACY_PORT "port"
#define ACCOUNTS_SERVICE_CONFIG_LEGACY_REMEMBER_PASSWORD "remember_password"
#define ACCOUNTS_SERVICE_CONFIG_LEGACY_SSL "ssl"
#define ACCOUNTS_SERVICE_CONFIG_LEGACY_STARTTLS "starttls"
#define ACCOUNTS_SERVICE_CONFIG_LEGACY_USERNAME "username"
#define ACCOUNTS_SERVICE_CONFIG_LEGACY_SMTP_NOAUTH "smtp_noauth"
#define ACCOUNTS_SERVICE_CONFIG_LEGACY_SMTP_USE_IMAP_CREDENTIALS "smtp_use_imap_credentials"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE (accounts_manager_account_state_get_type ())
#define ACCOUNTS_MANAGER_ACCOUNT_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE, AccountsManagerAccountState))
#define ACCOUNTS_MANAGER_ACCOUNT_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE, AccountsManagerAccountStateClass))
#define ACCOUNTS_MANAGER_IS_ACCOUNT_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE))
#define ACCOUNTS_MANAGER_IS_ACCOUNT_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE))
#define ACCOUNTS_MANAGER_ACCOUNT_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE, AccountsManagerAccountStateClass))

typedef struct _AccountsManagerAccountState AccountsManagerAccountState;
typedef struct _AccountsManagerAccountStateClass AccountsManagerAccountStateClass;
enum  {
	ACCOUNTS_MANAGER_0_PROPERTY,
	ACCOUNTS_MANAGER_SIZE_PROPERTY,
	ACCOUNTS_MANAGER_CONFIG_DIR_PROPERTY,
	ACCOUNTS_MANAGER_DATA_DIR_PROPERTY,
	ACCOUNTS_MANAGER_NUM_PROPERTIES
};
static GParamSpec* accounts_manager_properties[ACCOUNTS_MANAGER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _AccountsManagerConnectGoaData AccountsManagerConnectGoaData;
#define _accounts_manager_account_state_unref0(var) ((var == NULL) ? NULL : (var = (accounts_manager_account_state_unref (var), NULL)))
typedef struct _AccountsManagerNewOrphanAccountData AccountsManagerNewOrphanAccountData;
typedef struct _AccountsManagerCreateAccountData AccountsManagerCreateAccountData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _AccountsManagerLoadAccountsData AccountsManagerLoadAccountsData;
typedef struct _AccountsManagerRemoveAccountData AccountsManagerRemoveAccountData;
typedef struct _AccountsManagerRestoreAccountData AccountsManagerRestoreAccountData;
typedef struct _AccountsManagerExpungeAccountsData AccountsManagerExpungeAccountsData;
typedef struct _AccountsManagerSaveAccountData AccountsManagerSaveAccountData;
typedef struct _AccountsManagerUpdateLocalCredentialsData AccountsManagerUpdateLocalCredentialsData;
typedef struct _AccountsManagerAddGoaAccountData AccountsManagerAddGoaAccountData;
typedef struct _AccountsManagerShowGoaAccountData AccountsManagerShowGoaAccountData;
typedef struct _AccountsManagerNextIdData AccountsManagerNextIdData;
#define _geary_config_file_unref0(var) ((var == NULL) ? NULL : (var = (geary_config_file_unref (var), NULL)))
#define _geary_config_file_group_unref0(var) ((var == NULL) ? NULL : (var = (geary_config_file_group_unref (var), NULL)))
typedef struct _AccountsManagerLoadAccountData AccountsManagerLoadAccountData;
typedef struct _AccountsManagerSaveAccountLockedData AccountsManagerSaveAccountLockedData;
typedef struct _AccountsManagerDeleteAccountData AccountsManagerDeleteAccountData;
typedef struct _AccountsManagerCreateAccountDirsData AccountsManagerCreateAccountDirsData;
typedef struct _AccountsManagerCreateGoaAccountData AccountsManagerCreateGoaAccountData;
typedef struct _AccountsManagerUpdateGoaAccountData AccountsManagerUpdateGoaAccountData;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _AccountsManagerOpenGoaSettingsData AccountsManagerOpenGoaSettingsData;
typedef struct _Block50Data Block50Data;
typedef struct _AccountsManagerAccountStatePrivate AccountsManagerAccountStatePrivate;
typedef struct _AccountsManagerParamSpecAccountState AccountsManagerParamSpecAccountState;
enum  {
	ACCOUNTS_MANAGER_ACCOUNT_ADDED_SIGNAL,
	ACCOUNTS_MANAGER_ACCOUNT_STATUS_CHANGED_SIGNAL,
	ACCOUNTS_MANAGER_ACCOUNT_REMOVED_SIGNAL,
	ACCOUNTS_MANAGER_REPORT_PROBLEM_SIGNAL,
	ACCOUNTS_MANAGER_NUM_SIGNALS
};
static guint accounts_manager_signals[ACCOUNTS_MANAGER_NUM_SIGNALS] = {0};
enum  {
	ACCOUNTS_ACCOUNT_CONFIG_V1_0_PROPERTY,
	ACCOUNTS_ACCOUNT_CONFIG_V1_NUM_PROPERTIES
};
static GParamSpec* accounts_account_config_v1_properties[ACCOUNTS_ACCOUNT_CONFIG_V1_NUM_PROPERTIES];
enum  {
	ACCOUNTS_ACCOUNT_CONFIG_LEGACY_0_PROPERTY,
	ACCOUNTS_ACCOUNT_CONFIG_LEGACY_NUM_PROPERTIES
};
static GParamSpec* accounts_account_config_legacy_properties[ACCOUNTS_ACCOUNT_CONFIG_LEGACY_NUM_PROPERTIES];
enum  {
	ACCOUNTS_SERVICE_CONFIG_V1_0_PROPERTY,
	ACCOUNTS_SERVICE_CONFIG_V1_NUM_PROPERTIES
};
static GParamSpec* accounts_service_config_v1_properties[ACCOUNTS_SERVICE_CONFIG_V1_NUM_PROPERTIES];
enum  {
	ACCOUNTS_SERVICE_CONFIG_LEGACY_0_PROPERTY,
	ACCOUNTS_SERVICE_CONFIG_LEGACY_NUM_PROPERTIES
};
static GParamSpec* accounts_service_config_legacy_properties[ACCOUNTS_SERVICE_CONFIG_LEGACY_NUM_PROPERTIES];

struct _AccountsManagerPrivate {
	GFile* _config_dir;
	GFile* _data_dir;
	GeeMap* accounts;
	GeeLinkedList* removed;
	GearyCredentialsMediator* local_mediator;
	GoaClient* goa_service;
};

struct _AccountsManagerConnectGoaData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GCancellable* cancellable;
	GoaClient* _tmp0_;
	GoaClient* _tmp1_;
	GoaClient* _tmp2_;
	GoaClient* _tmp3_;
	GoaClient* _tmp4_;
	GoaClient* _tmp5_;
	GError* _inner_error0_;
};

struct _AccountsManagerNewOrphanAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GearyServiceProvider provider;
	GearyRFC822MailboxAddress* primary_mailbox;
	GCancellable* cancellable;
	GearyAccountInformation* result;
	gchar* id;
	gchar* _tmp0_;
	GearyCredentialsMediator* _tmp1_;
	GearyAccountInformation* _tmp2_;
};

struct _AccountsManagerCreateAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GearyAccountInformation* account;
	GCancellable* cancellable;
	SecretMediator* mediator;
	GearyCredentialsMediator* _tmp0_;
	GearyCredentialsMediator* _tmp1_;
	SecretMediator* _tmp2_;
	SecretMediator* _tmp3_;
	SecretMediator* _tmp4_;
	GearyServiceInformation* _tmp5_;
	GearyServiceInformation* _tmp6_;
	SecretMediator* _tmp7_;
	GearyServiceInformation* _tmp8_;
	GearyServiceInformation* _tmp9_;
	GError* _inner_error0_;
};

struct _AccountsManagerLoadAccountsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GCancellable* cancellable;
	GFileEnumerator* enumerator;
	GFileEnumerator* _tmp0_;
	GFile* _tmp1_;
	GFileEnumerator* _tmp2_;
	GFileEnumerator* _tmp3_;
	gboolean _tmp4_;
	GFileEnumerator* _tmp5_;
	GList* info_list;
	GFileEnumerator* _tmp6_;
	GList* _tmp7_;
	guint len;
	GList* _tmp8_;
	guint i;
	gboolean _tmp9_;
	guint _tmp10_;
	gboolean _tmp11_;
	GFileInfo* file;
	GList* _tmp12_;
	gconstpointer _tmp13_;
	GFileInfo* _tmp14_;
	GFileInfo* _tmp15_;
	gchar* id;
	GFileInfo* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	GearyAccountInformation* info;
	const gchar* _tmp19_;
	GearyAccountInformation* _tmp20_;
	GearyAccountInformation* _tmp21_;
	GError* err;
	const gchar* _tmp22_;
	GError* _tmp23_;
	GearyProblemReport* _tmp24_;
	GearyProblemReport* _tmp25_;
	GoaClient* _tmp26_;
	GList* list;
	GoaClient* _tmp27_;
	GList* _tmp28_;
	gint _vala1_i;
	gboolean _tmp29_;
	gint _tmp30_;
	gboolean _tmp31_;
	GList* _tmp32_;
	GoaObject* account;
	GList* _tmp33_;
	gconstpointer _tmp34_;
	GoaObject* _tmp35_;
	gchar* _vala1_id;
	GoaObject* _tmp36_;
	gchar* _tmp37_;
	GeeMap* _tmp38_;
	const gchar* _tmp39_;
	GoaObject* _tmp40_;
	GError* _inner_error0_;
};

struct _AccountsManagerRemoveAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GearyAccountInformation* account;
	GCancellable* cancellable;
	GeeMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GeeLinkedList* _tmp3_;
	guint _tmp4_;
	GError* _inner_error0_;
};

struct _AccountsManagerRestoreAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GearyAccountInformation* account;
	GCancellable* cancellable;
	GeeLinkedList* _tmp0_;
	GError* _inner_error0_;
};

struct _AccountsManagerExpungeAccountsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GCancellable* cancellable;
	gboolean _tmp0_;
	GeeLinkedList* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GeeLinkedList* _tmp4_;
	gpointer _tmp5_;
	GearyAccountInformation* _tmp6_;
	GError* _inner_error0_;
};

struct _AccountsManagerSaveAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GearyAccountInformation* info;
	GCancellable* cancellable;
	gint token;
	GearyNonblockingMutex* _tmp0_;
	GearyNonblockingMutex* _tmp1_;
	GError* thrown;
	GError* err;
	GError* _tmp2_;
	GError* _tmp3_;
	GearyNonblockingMutex* _tmp4_;
	GearyNonblockingMutex* _tmp5_;
	GError* _tmp6_;
	GError* _tmp7_;
	GError* _tmp8_;
	GError* _inner_error0_;
};

struct _AccountsManagerUpdateLocalCredentialsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GearyAccountInformation* account;
	GearyServiceInformation* old_service;
	GearyServiceInformation* new_service;
	GCancellable* cancellable;
	SecretMediator* mediator;
	GearyCredentialsMediator* _tmp0_;
	GearyCredentialsMediator* _tmp1_;
	SecretMediator* _tmp2_;
	SecretMediator* _tmp3_;
	GearyCredentials* _tmp4_;
	GearyCredentials* _tmp5_;
	SecretMediator* _tmp6_;
	gboolean _tmp7_;
	GearyCredentials* _tmp8_;
	GearyCredentials* _tmp9_;
	gboolean _tmp10_;
	GearyCredentials* _tmp11_;
	GearyCredentials* _tmp12_;
	gboolean _tmp13_;
	GearyCredentials* _tmp14_;
	GearyCredentials* _tmp15_;
	GearyCredentials* _tmp16_;
	GearyCredentials* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	GearyCredentials* _tmp20_;
	GearyCredentials* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	SecretMediator* _tmp24_;
	GError* _inner_error0_;
};

struct _AccountsManagerAddGoaAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GearyServiceProvider type;
	GCancellable* cancellable;
	GError* _tmp0_;
	GError* _inner_error0_;
};

struct _AccountsManagerShowGoaAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GearyAccountInformation* account;
	GCancellable* cancellable;
	GError* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GError* _inner_error0_;
};

struct _AccountsManagerNextIdData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GCancellable* cancellable;
	gchar* result;
	gchar* last_account;
	GeeMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
	gpointer _tmp4_;
	gchar* _tmp5_;
	guint next_id;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* id;
	gchar* _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp14_;
	GFile* _tmp15_;
	const gchar* _tmp16_;
	GFile* _tmp17_;
	GFile* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
	GFile* _tmp21_;
	const gchar* _tmp22_;
	GFile* _tmp23_;
	GFile* _tmp24_;
	gboolean _tmp25_;
	guint _tmp26_;
	gchar* _tmp27_;
	GError* err;
	GError* _tmp28_;
	const gchar* _tmp29_;
	GError* _inner_error0_;
};

struct _AccountsManagerLoadAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	gchar* id;
	GCancellable* cancellable;
	GearyAccountInformation* result;
	GFile* config_dir;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* data_dir;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GearyConfigFile* config;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GearyConfigFile* _tmp7_;
	GearyConfigFile* _tmp8_;
	GearyConfigFile* _tmp9_;
	GError* err;
	GError* _tmp10_;
	const gchar* _tmp11_;
	GError* _tmp12_;
	GError* _vala1_err;
	GError* _tmp13_;
	const gchar* _tmp14_;
	GError* _tmp15_;
	GearyConfigFileGroup* metadata_config;
	GearyConfigFile* _tmp16_;
	GearyConfigFileGroup* _tmp17_;
	gint version;
	GearyConfigFileGroup* _tmp18_;
	AccountsManagerStatus status;
	AccountsManagerStatus _tmp19_;
	GearyConfigFileGroup* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	AccountsManagerStatus _tmp25_;
	GError* _tmp26_;
	gchar* goa_id;
	GearyConfigFileGroup* _tmp27_;
	gchar* _tmp28_;
	gboolean is_goa;
	const gchar* _tmp29_;
	gboolean _tmp30_;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	GoaObject* goa_handle;
	GoaMediator* goa_mediator;
	GearyServiceProvider* default_provider;
	GearyCredentialsMediator* mediator;
	GearyCredentialsMediator* _tmp33_;
	GearyCredentialsMediator* _tmp34_;
	GoaClient* _tmp35_;
	GError* _tmp36_;
	GoaClient* _tmp37_;
	const gchar* _tmp38_;
	GoaObject* _tmp39_;
	GoaObject* _tmp40_;
	GoaObject* _tmp41_;
	GoaMediator* _tmp42_;
	GoaMediator* _tmp43_;
	GearyCredentialsMediator* _tmp44_;
	GoaMediator* _tmp45_;
	GearyServiceProvider _tmp46_;
	GearyServiceProvider* _tmp47_;
	const gchar* _tmp48_;
	GearyServiceProvider _tmp49_;
	GearyServiceProvider* _tmp50_;
	AccountsAccountConfig* accounts;
	AccountsServiceConfig* services;
	AccountsAccountConfigLegacy* _tmp51_;
	AccountsServiceConfigLegacy* _tmp52_;
	AccountsAccountConfigV1* _tmp53_;
	AccountsServiceConfigV1* _tmp54_;
	GError* _tmp55_;
	GearyAccountInformation* account;
	GearyAccountInformation* _tmp56_;
	AccountsAccountConfig* _tmp57_;
	GearyConfigFile* _tmp58_;
	GearyCredentialsMediator* _tmp59_;
	GearyServiceProvider* _tmp60_;
	gchar* _tmp61_;
	gchar* _tmp62_;
	GearyAccountInformation* _tmp63_;
	GearyAccountInformation* _tmp64_;
	GearyAccountInformation* _tmp65_;
	GearyAccountInformation* _tmp66_;
	GFile* _tmp67_;
	GFile* _tmp68_;
	GError* _vala2_err;
	GError* _tmp69_;
	const gchar* _tmp70_;
	GError* _tmp71_;
	GeeLinkedList* _tmp72_;
	GearyAccountInformation* _tmp73_;
	GError* _tmp74_;
	AccountsServiceConfig* _tmp75_;
	GearyConfigFile* _tmp76_;
	GearyAccountInformation* _tmp77_;
	GearyAccountInformation* _tmp78_;
	GearyServiceInformation* _tmp79_;
	GearyServiceInformation* _tmp80_;
	AccountsServiceConfig* _tmp81_;
	GearyConfigFile* _tmp82_;
	GearyAccountInformation* _tmp83_;
	GearyAccountInformation* _tmp84_;
	GearyServiceInformation* _tmp85_;
	GearyServiceInformation* _tmp86_;
	GError* _vala3_err;
	GError* _tmp87_;
	const gchar* _tmp88_;
	GError* _tmp89_;
	GearyAccountInformation* _tmp90_;
	GoaMediator* _tmp91_;
	gchar* _tmp92_;
	gchar* _tmp93_;
	GoaMediator* _tmp94_;
	GearyAccountInformation* _tmp95_;
	GError* _vala4_err;
	GError* _tmp96_;
	const gchar* _tmp97_;
	GError* _tmp98_;
	GoaObject* _tmp99_;
	GearyAccountInformation* _tmp100_;
	GError* _tmp101_;
	GearyAccountInformation* _tmp102_;
	GError* _tmp103_;
	GError* _inner_error0_;
};

struct _AccountsManagerSaveAccountLockedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GearyAccountInformation* account;
	GCancellable* cancellable;
	GFile* _tmp0_;
	GFile* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GError* _tmp4_;
	GearyConfigFile* config;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GearyConfigFile* _tmp9_;
	GearyConfigFile* _tmp10_;
	GError* err;
	GError* _tmp11_;
	const gchar* _tmp12_;
	GearyConfigFileGroup* metadata_config;
	GearyConfigFileGroup* _tmp13_;
	GearyConfigFileGroup* _tmp14_;
	GearyConfigFileGroup* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gboolean is_goa;
	GearyConfigFileGroup* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	AccountsAccountConfig* accounts;
	AccountsAccountConfigV1* _tmp23_;
	AccountsAccountConfig* _tmp24_;
	AccountsServiceConfig* services;
	AccountsServiceConfigV1* _tmp25_;
	AccountsServiceConfig* _tmp26_;
	GearyServiceInformation* _tmp27_;
	GearyServiceInformation* _tmp28_;
	AccountsServiceConfig* _tmp29_;
	GearyServiceInformation* _tmp30_;
	GearyServiceInformation* _tmp31_;
	GFile* _tmp32_;
	GFile* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	GError* _inner_error0_;
};

struct _AccountsManagerDeleteAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GearyAccountInformation* info;
	GCancellable* cancellable;
	SecretMediator* mediator;
	GearyCredentialsMediator* _tmp0_;
	GearyCredentialsMediator* _tmp1_;
	SecretMediator* _tmp2_;
	SecretMediator* _tmp3_;
	SecretMediator* _tmp4_;
	GearyServiceInformation* _tmp5_;
	GearyServiceInformation* _tmp6_;
	GError* e;
	GError* _tmp7_;
	const gchar* _tmp8_;
	SecretMediator* _tmp9_;
	GearyServiceInformation* _tmp10_;
	GearyServiceInformation* _tmp11_;
	GError* _vala1_e;
	GError* _tmp12_;
	const gchar* _tmp13_;
	GFile* _tmp14_;
	GFile* _tmp15_;
	GFile* _tmp16_;
	GFile* _tmp17_;
	GFile* _tmp18_;
	GFile* _tmp19_;
	GFile* _tmp20_;
	GFile* _tmp21_;
	GError* _inner_error0_;
};

struct _AccountsManagerCreateAccountDirsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GearyAccountInformation* info;
	GCancellable* cancellable;
	GFile* config;
	GFile* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* data;
	GFile* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	GError* _inner_error0_;
};

struct _AccountsManagerCreateGoaAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GoaObject* account;
	GCancellable* cancellable;
	GoaMail* mail;
	GoaMail* _tmp0_;
	gchar* name;
	GoaMail* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	GoaMediator* mediator;
	GoaMediator* _tmp6_;
	GearyAccountInformation* info;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GoaMediator* _tmp9_;
	GoaMediator* _tmp10_;
	const gchar* _tmp11_;
	GoaMail* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GearyRFC822MailboxAddress* _tmp16_;
	GearyRFC822MailboxAddress* _tmp17_;
	GearyAccountInformation* _tmp18_;
	GearyAccountInformation* _tmp19_;
	GearyAccountInformation* _tmp20_;
	gint _tmp21_;
	GearyAccountInformation* _tmp22_;
	GoaMediator* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	GearyAccountInformation* _tmp26_;
	GoaAccount* _tmp27_;
	GoaAccount* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	GearyAccountInformation* _tmp32_;
	GearyAccountInformation* _tmp33_;
	GoaMediator* _tmp34_;
	GearyAccountInformation* _tmp35_;
	GError* err;
	GError* _tmp36_;
	GearyProblemReport* _tmp37_;
	GearyProblemReport* _tmp38_;
	GearyAccountInformation* _tmp39_;
	GoaAccount* _tmp40_;
	GoaAccount* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	GoaAccount* _tmp45_;
	GoaAccount* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	GError* _inner_error0_;
};

struct _AccountsManagerUpdateGoaAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GearyAccountInformation* account;
	gboolean is_available;
	GCancellable* cancellable;
	GoaMediator* mediator;
	GearyCredentialsMediator* _tmp0_;
	GearyCredentialsMediator* _tmp1_;
	GoaMediator* _tmp2_;
	GoaMediator* _tmp3_;
	GError* err;
	GError* _tmp4_;
	GearyAccountProblemReport* _tmp5_;
	GearyAccountProblemReport* _tmp6_;
	GError* _inner_error0_;
};

struct _AccountsManagerOpenGoaSettingsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	gchar* action;
	gchar* param;
	GCancellable* cancellable;
	GDBusProxy* settings;
	GDBusProxy* _tmp0_;
	GVariant** args;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant** _tmp4_;
	GVariant** _tmp5_;
	gint _tmp5__length1;
	gint args_length1;
	gint _args_size_;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	GVariant* _tmp8_;
	GVariant* command;
	GVariant* _tmp9_;
	const GVariantType* _tmp10_;
	GVariant** _tmp11_;
	gint _tmp11__length1;
	GVariant* _tmp12_;
	GVariant** _tmp13_;
	GVariant** _tmp14_;
	gint _tmp14__length1;
	GVariant* _tmp15_;
	GVariant* _tmp16_;
	GVariant* params;
	GVariant* _tmp17_;
	const GVariantType* _tmp18_;
	GVariant* _tmp19_;
	GVariant* _tmp20_;
	GVariant** _tmp21_;
	GVariant** _tmp22_;
	gint _tmp22__length1;
	GVariant* _tmp23_;
	GVariant* _tmp24_;
	GVariant** _tmp25_;
	GVariant** _tmp26_;
	gint _tmp26__length1;
	GVariant* _tmp27_;
	GVariant* _tmp28_;
	GDBusProxy* _tmp29_;
	GVariant* _tmp30_;
	GVariant* _tmp31_;
	GVariant* _tmp32_;
	GError* _inner_error0_;
};

struct _Block50Data {
	int _ref_count_;
	AccountsManager* self;
	GearyAccountInformation* account;
};

struct _AccountsManagerAccountState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	AccountsManagerAccountStatePrivate * priv;
};

struct _AccountsManagerAccountStateClass {
	GTypeClass parent_class;
	void (*finalize) (AccountsManagerAccountState *self);
};

struct _AccountsManagerAccountStatePrivate {
	GearyAccountInformation* _account;
	gboolean _enabled;
	gboolean _available;
};

struct _AccountsManagerParamSpecAccountState {
	GParamSpec parent_instance;
};

struct _AccountsAccountConfigV1Private {
	gboolean is_managed;
};

static gint AccountsManager_private_offset;
static gpointer accounts_manager_parent_class = NULL;
static gint AccountsManagerAccountState_private_offset;
static gpointer accounts_manager_account_state_parent_class = NULL;
static gint AccountsAccountConfigV1_private_offset;
static gpointer accounts_account_config_v1_parent_class = NULL;
static AccountsAccountConfigIface * accounts_account_config_v1_accounts_account_config_parent_iface = NULL;
static gpointer accounts_account_config_legacy_parent_class = NULL;
static AccountsAccountConfigIface * accounts_account_config_legacy_accounts_account_config_parent_iface = NULL;
static gpointer accounts_service_config_v1_parent_class = NULL;
static AccountsServiceConfigIface * accounts_service_config_v1_accounts_service_config_parent_iface = NULL;
static gpointer accounts_service_config_legacy_parent_class = NULL;
static AccountsServiceConfigIface * accounts_service_config_legacy_accounts_service_config_parent_iface = NULL;

static gpointer accounts_manager_account_state_ref (gpointer instance);
static void accounts_manager_account_state_unref (gpointer instance);
static GParamSpec* accounts_manager_param_spec_account_state (const gchar* name,
                                                       const gchar* nick,
                                                       const gchar* blurb,
                                                       GType object_type,
                                                       GParamFlags flags) G_GNUC_UNUSED ;
static void accounts_manager_value_set_account_state (GValue* value,
                                               gpointer v_object) G_GNUC_UNUSED ;
static void accounts_manager_value_take_account_state (GValue* value,
                                                gpointer v_object) G_GNUC_UNUSED ;
static gpointer accounts_manager_value_get_account_state (const GValue* value) G_GNUC_UNUSED ;
static GType accounts_manager_account_state_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void accounts_manager_set_config_dir (AccountsManager* self,
                                      GFile* value);
static void accounts_manager_set_data_dir (AccountsManager* self,
                                    GFile* value);
static void g_cclosure_user_marshal_VOID__OBJECT_ENUM (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void accounts_manager_connect_goa_data_free (gpointer _data);
static gboolean accounts_manager_connect_goa_co (AccountsManagerConnectGoaData* _data_);
static void accounts_manager_connect_goa_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_);
static void accounts_manager_on_goa_account_added (AccountsManager* self,
                                            GoaObject* account);
static void _accounts_manager_on_goa_account_added_goa_client_account_added (GoaClient* _sender,
                                                                      GoaObject* object,
                                                                      gpointer self);
static void accounts_manager_on_goa_account_changed (AccountsManager* self,
                                              GoaObject* account);
static void _accounts_manager_on_goa_account_changed_goa_client_account_changed (GoaClient* _sender,
                                                                          GoaObject* object,
                                                                          gpointer self);
static void accounts_manager_on_goa_account_removed (AccountsManager* self,
                                              GoaObject* account);
static void _accounts_manager_on_goa_account_removed_goa_client_account_removed (GoaClient* _sender,
                                                                          GoaObject* object,
                                                                          gpointer self);
static GearyAccountInformation* accounts_manager_account_state_get_account (AccountsManagerAccountState* self);
static AccountsManagerStatus accounts_manager_account_state_get_status (AccountsManagerAccountState* self);
static GearyAccountInformation* __lambda12_ (AccountsManager* self,
                                      AccountsManagerAccountState* state);
static gpointer ___lambda12__gee_map_func (gpointer g,
                                    gpointer self);
static void accounts_manager_new_orphan_account_data_free (gpointer _data);
static gboolean accounts_manager_new_orphan_account_co (AccountsManagerNewOrphanAccountData* _data_);
static void accounts_manager_next_id (AccountsManager* self,
                               GCancellable* cancellable,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
static gchar* accounts_manager_next_id_finish (AccountsManager* self,
                                        GAsyncResult* _res_);
static void accounts_manager_new_orphan_account_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_);
static void accounts_manager_create_account_data_free (gpointer _data);
static gboolean accounts_manager_create_account_co (AccountsManagerCreateAccountData* _data_);
static void accounts_manager_create_account_dirs (AccountsManager* self,
                                           GearyAccountInformation* info,
                                           GCancellable* cancellable,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
static void accounts_manager_create_account_dirs_finish (AccountsManager* self,
                                                  GAsyncResult* _res_,
                                                  GError** error);
static void accounts_manager_create_account_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
static gboolean accounts_manager_set_enabled (AccountsManager* self,
                                       GearyAccountInformation* account,
                                       gboolean is_enabled);
static void accounts_manager_load_accounts_data_free (gpointer _data);
static gboolean accounts_manager_load_accounts_co (AccountsManagerLoadAccountsData* _data_);
static void accounts_manager_load_accounts_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_);
static void accounts_manager_load_account (AccountsManager* self,
                                    const gchar* id,
                                    GCancellable* cancellable,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
static GearyAccountInformation* accounts_manager_load_account_finish (AccountsManager* self,
                                                               GAsyncResult* _res_,
                                                               GError** error);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static inline gchar* accounts_manager_to_geary_id (AccountsManager* self,
                                     GoaObject* account);
static void accounts_manager_create_goa_account (AccountsManager* self,
                                          GoaObject* account,
                                          GCancellable* cancellable,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
static void accounts_manager_create_goa_account_finish (AccountsManager* self,
                                                 GAsyncResult* _res_);
static gboolean accounts_manager_set_available (AccountsManager* self,
                                         GearyAccountInformation* account,
                                         gboolean is_available);
static void accounts_manager_remove_account_data_free (gpointer _data);
static gboolean accounts_manager_remove_account_co (AccountsManagerRemoveAccountData* _data_);
static void accounts_manager_on_account_changed (AccountsManager* self,
                                          GearyAccountInformation* account);
static void _accounts_manager_on_account_changed_geary_account_information_changed (GearyAccountInformation* _sender,
                                                                             gpointer self);
static void accounts_manager_remove_account_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
static void accounts_manager_restore_account_data_free (gpointer _data);
static gboolean accounts_manager_restore_account_co (AccountsManagerRestoreAccountData* _data_);
static void accounts_manager_restore_account_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_);
static void accounts_manager_expunge_accounts_data_free (gpointer _data);
static gboolean accounts_manager_expunge_accounts_co (AccountsManagerExpungeAccountsData* _data_);
static void accounts_manager_delete_account (AccountsManager* self,
                                      GearyAccountInformation* info,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static void accounts_manager_delete_account_finish (AccountsManager* self,
                                             GAsyncResult* _res_,
                                             GError** error);
static void accounts_manager_expunge_accounts_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_);
static void accounts_manager_save_account_data_free (gpointer _data);
static gboolean accounts_manager_save_account_co (AccountsManagerSaveAccountData* _data_);
static void accounts_manager_save_account_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_);
static void accounts_manager_save_account_locked (AccountsManager* self,
                                           GearyAccountInformation* account,
                                           GCancellable* cancellable,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
static void accounts_manager_save_account_locked_finish (AccountsManager* self,
                                                  GAsyncResult* _res_,
                                                  GError** error);
static void accounts_manager_update_local_credentials_data_free (gpointer _data);
static gboolean accounts_manager_update_local_credentials_co (AccountsManagerUpdateLocalCredentialsData* _data_);
static void accounts_manager_update_local_credentials_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
static void accounts_manager_add_goa_account_data_free (gpointer _data);
static gboolean accounts_manager_add_goa_account_co (AccountsManagerAddGoaAccountData* _data_);
static void accounts_manager_open_goa_settings (AccountsManager* self,
                                         const gchar* action,
                                         const gchar* param,
                                         GCancellable* cancellable,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
static void accounts_manager_open_goa_settings_finish (AccountsManager* self,
                                                GAsyncResult* _res_,
                                                GError** error);
static void accounts_manager_add_goa_account_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_);
static void accounts_manager_show_goa_account_data_free (gpointer _data);
static gboolean accounts_manager_show_goa_account_co (AccountsManagerShowGoaAccountData* _data_);
static inline gchar* accounts_manager_to_goa_id (AccountsManager* self,
                                   const gchar* id);
static void accounts_manager_show_goa_account_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_);
static void accounts_manager_next_id_data_free (gpointer _data);
static gboolean accounts_manager_next_id_co (AccountsManagerNextIdData* _data_);
static gchar* __lambda13_ (AccountsManager* self,
                    gchar* next,
                    gchar* last);
static gpointer ___lambda13__gee_fold_func (gpointer g,
                                     gpointer a,
                                     gpointer self);
static void accounts_manager_next_id_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_);
static void accounts_manager_load_account_data_free (gpointer _data);
static gboolean accounts_manager_load_account_co (AccountsManagerLoadAccountData* _data_);
static void accounts_manager_load_account_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_);
static GearyServiceProvider* _geary_service_provider_dup (GearyServiceProvider* self);
static gboolean accounts_manager_is_valid_goa_account (AccountsManager* self,
                                                GoaObject* handle);
static void accounts_manager_save_account_locked_data_free (gpointer _data);
static gboolean accounts_manager_save_account_locked_co (AccountsManagerSaveAccountLockedData* _data_);
static void accounts_manager_save_account_locked_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_);
static void accounts_manager_delete_account_data_free (gpointer _data);
static gboolean accounts_manager_delete_account_co (AccountsManagerDeleteAccountData* _data_);
static void accounts_manager_delete_account_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
static inline AccountsManagerAccountState* accounts_manager_lookup_state (AccountsManager* self,
                                                            GearyAccountInformation* account);
static AccountsManagerAccountState* accounts_manager_account_state_new (GearyAccountInformation* account);
static AccountsManagerAccountState* accounts_manager_account_state_construct (GType object_type,
                                                                       GearyAccountInformation* account);
static void accounts_manager_account_state_set_enabled (AccountsManagerAccountState* self,
                                                 gboolean value);
static void accounts_manager_account_state_set_available (AccountsManagerAccountState* self,
                                                   gboolean value);
static void accounts_manager_create_account_dirs_data_free (gpointer _data);
static gboolean accounts_manager_create_account_dirs_co (AccountsManagerCreateAccountDirsData* _data_);
static void accounts_manager_create_account_dirs_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_);
static void accounts_manager_create_goa_account_data_free (gpointer _data);
static gboolean accounts_manager_create_goa_account_co (AccountsManagerCreateGoaAccountData* _data_);
static void accounts_manager_create_goa_account_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_);
static void accounts_manager_update_goa_account_data_free (gpointer _data);
static void accounts_manager_update_goa_account (AccountsManager* self,
                                          GearyAccountInformation* account,
                                          gboolean is_available,
                                          GCancellable* cancellable,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
static void accounts_manager_update_goa_account_finish (AccountsManager* self,
                                                 GAsyncResult* _res_);
static gboolean accounts_manager_update_goa_account_co (AccountsManagerUpdateGoaAccountData* _data_);
static void accounts_manager_update_goa_account_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_);
static void accounts_manager_open_goa_settings_data_free (gpointer _data);
static gboolean accounts_manager_open_goa_settings_co (AccountsManagerOpenGoaSettingsData* _data_);
static void accounts_manager_open_goa_settings_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static void _vala_array_add11 (GVariant** * array,
                        gint* length,
                        gint* size,
                        GVariant* value);
static Block50Data* block50_data_ref (Block50Data* _data50_);
static void block50_data_unref (void * _userdata_);
static void __lambda11_ (Block50Data* _data50_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda11__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void accounts_manager_account_state_set_account (AccountsManagerAccountState* self,
                                                 GearyAccountInformation* value);
static gboolean accounts_manager_account_state_get_enabled (AccountsManagerAccountState* self);
static gboolean accounts_manager_account_state_get_available (AccountsManagerAccountState* self);
static void accounts_manager_account_state_finalize (AccountsManagerAccountState * obj);
static GType accounts_manager_account_state_get_type_once (void);
static void accounts_manager_finalize (GObject * obj);
static GType accounts_manager_get_type_once (void);
static void _vala_accounts_manager_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_accounts_manager_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
static GType accounts_account_config_get_type_once (void);
static GType accounts_service_config_get_type_once (void);
static GearyAccountInformation* accounts_account_config_v1_real_load (AccountsAccountConfig* base,
                                                               GearyConfigFile* config,
                                                               const gchar* id,
                                                               GearyCredentialsMediator* mediator,
                                                               GearyServiceProvider* default_provider,
                                                               const gchar* default_name,
                                                               GError** error);
static GearyServiceProvider ___lambda7_ (AccountsAccountConfigV1* self,
                                  const gchar* value,
                                  GError** error);
static gpointer ____lambda7__geary_config_file_parser (const gchar* value,
                                                gpointer self,
                                                GError** error);
static void accounts_account_config_v1_real_save (AccountsAccountConfig* base,
                                           GearyAccountInformation* account,
                                           GearyConfigFile* config);
static gchar* __lambda8_ (AccountsAccountConfigV1* self,
                   GearyRFC822MailboxAddress* sender);
static gpointer ___lambda8__gee_map_func (gpointer g,
                                   gpointer self);
static inline void accounts_account_config_v1_save_folder (AccountsAccountConfigV1* self,
                                             GearyConfigFileGroup* config,
                                             const gchar* key,
                                             GeeList* steps);
static void accounts_account_config_v1_finalize (GObject * obj);
static GType accounts_account_config_v1_get_type_once (void);
static GearyAccountInformation* accounts_account_config_legacy_real_load (AccountsAccountConfig* base,
                                                                   GearyConfigFile* config_file,
                                                                   const gchar* id,
                                                                   GearyCredentialsMediator* mediator,
                                                                   GearyServiceProvider* default_provider,
                                                                   const gchar* default_name,
                                                                   GError** error);
static GearyServiceProvider ___lambda14_ (AccountsAccountConfigLegacy* self,
                                   const gchar* value,
                                   GError** error);
static gpointer ____lambda14__geary_config_file_parser (const gchar* value,
                                                 gpointer self,
                                                 GError** error);
static void accounts_account_config_legacy_real_save (AccountsAccountConfig* base,
                                               GearyAccountInformation* info,
                                               GearyConfigFile* config_file);
static gchar* ___lambda15_ (AccountsAccountConfigLegacy* self,
                     GearyRFC822MailboxAddress* alt);
static gpointer ____lambda15__gee_map_func (gpointer g,
                                     gpointer self);
static GType accounts_account_config_legacy_get_type_once (void);
static void accounts_service_config_v1_real_load (AccountsServiceConfig* base,
                                           GearyConfigFile* config,
                                           GearyAccountInformation* account,
                                           GearyServiceInformation* service,
                                           GError** error);
static GearyTlsNegotiationMethod ___lambda9_ (AccountsServiceConfigV1* self,
                                       const gchar* value,
                                       GError** error);
static gpointer ____lambda9__geary_config_file_parser (const gchar* value,
                                                gpointer self,
                                                GError** error);
static GearyCredentialsRequirement ___lambda10_ (AccountsServiceConfigV1* self,
                                          const gchar* value,
                                          GError** error);
static gpointer ____lambda10__geary_config_file_parser (const gchar* value,
                                                 gpointer self,
                                                 GError** error);
static void accounts_service_config_v1_real_save (AccountsServiceConfig* base,
                                           GearyAccountInformation* account,
                                           GearyServiceInformation* service,
                                           GearyConfigFile* config);
static GType accounts_service_config_v1_get_type_once (void);
static void accounts_service_config_legacy_real_load (AccountsServiceConfig* base,
                                               GearyConfigFile* config,
                                               GearyAccountInformation* account,
                                               GearyServiceInformation* service,
                                               GError** error);
static void accounts_service_config_legacy_real_save (AccountsServiceConfig* base,
                                               GearyAccountInformation* account,
                                               GearyServiceInformation* service,
                                               GearyConfigFile* config);
static GType accounts_service_config_legacy_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
accounts_manager_get_instance_private (AccountsManager* self)
{
	return G_STRUCT_MEMBER_P (self, AccountsManager_private_offset);
}

/**
     * Specifies the overall status of an account.
     */
AccountsManagerStatus
accounts_manager_status_for_value (const gchar* value,
                                   GError** error)
{
	AccountsManagerStatus _tmp0_ = 0;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gpointer _tmp3_;
	AccountsManagerStatus _tmp4_;
	GError* _inner_error0_ = NULL;
	AccountsManagerStatus result;
#line 59 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (value != NULL, 0);
#line 61 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = g_ascii_strdown (value, (gssize) -1);
#line 61 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _tmp1_;
#line 61 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = geary_object_utils_from_enum_nick (ACCOUNTS_MANAGER_TYPE_STATUS, NULL, NULL, ACCOUNTS_MANAGER_TYPE_STATUS, _tmp2_, &_inner_error0_);
#line 61 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = (AccountsManagerStatus) ((gintptr) _tmp3_);
#line 61 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp2_);
#line 61 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _tmp4_;
#line 61 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 61 "../src/client/accounts/accounts-manager.vala"
		if (_inner_error0_->domain == GEARY_ENGINE_ERROR) {
#line 61 "../src/client/accounts/accounts-manager.vala"
			g_propagate_error (error, _inner_error0_);
#line 61 "../src/client/accounts/accounts-manager.vala"
			return 0;
#line 1305 "accounts-manager.c"
		} else {
#line 61 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 61 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_inner_error0_);
#line 61 "../src/client/accounts/accounts-manager.vala"
			return 0;
#line 1313 "accounts-manager.c"
		}
	}
#line 61 "../src/client/accounts/accounts-manager.vala"
	result = _tmp0_;
#line 61 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 1320 "accounts-manager.c"
}

gchar*
accounts_manager_status_to_value (AccountsManagerStatus self)
{
	gchar* _tmp0_;
	gchar* result;
#line 67 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = geary_object_utils_to_enum_nick (ACCOUNTS_MANAGER_TYPE_STATUS, NULL, NULL, ACCOUNTS_MANAGER_TYPE_STATUS, (gpointer) ((gintptr) self));
#line 67 "../src/client/accounts/accounts-manager.vala"
	result = _tmp0_;
#line 67 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 1334 "accounts-manager.c"
}

static GType
accounts_manager_status_get_type_once (void)
{
	static const GEnumValue values[] = {{ACCOUNTS_MANAGER_STATUS_ENABLED, "ACCOUNTS_MANAGER_STATUS_ENABLED", "enabled"}, {ACCOUNTS_MANAGER_STATUS_DISABLED, "ACCOUNTS_MANAGER_STATUS_DISABLED", "disabled"}, {ACCOUNTS_MANAGER_STATUS_UNAVAILABLE, "ACCOUNTS_MANAGER_STATUS_UNAVAILABLE", "unavailable"}, {ACCOUNTS_MANAGER_STATUS_REMOVED, "ACCOUNTS_MANAGER_STATUS_REMOVED", "removed"}, {0, NULL, NULL}};
	GType accounts_manager_status_type_id;
	accounts_manager_status_type_id = g_enum_register_static ("AccountsManagerStatus", values);
	return accounts_manager_status_type_id;
}

GType
accounts_manager_status_get_type (void)
{
	static volatile gsize accounts_manager_status_type_id__once = 0;
	if (g_once_init_enter (&accounts_manager_status_type_id__once)) {
		GType accounts_manager_status_type_id;
		accounts_manager_status_type_id = accounts_manager_status_get_type_once ();
		g_once_init_leave (&accounts_manager_status_type_id__once, accounts_manager_status_type_id);
	}
	return accounts_manager_status_type_id__once;
}

gint
accounts_manager_get_size (AccountsManager* self)
{
	gint result;
	GeeMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 110 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), 0);
#line 110 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->accounts;
#line 110 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = gee_map_get_size (_tmp0_);
#line 110 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _tmp1_;
#line 110 "../src/client/accounts/accounts-manager.vala"
	result = _tmp2_;
#line 110 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 1377 "accounts-manager.c"
}

GFile*
accounts_manager_get_config_dir (AccountsManager* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 113 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), NULL);
#line 113 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->_config_dir;
#line 113 "../src/client/accounts/accounts-manager.vala"
	result = _tmp0_;
#line 113 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 1393 "accounts-manager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 113 "../src/client/accounts/accounts-manager.vala"
	return self ? g_object_ref (self) : NULL;
#line 1401 "accounts-manager.c"
}

static void
accounts_manager_set_config_dir (AccountsManager* self,
                                 GFile* value)
{
	GFile* old_value;
#line 113 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 113 "../src/client/accounts/accounts-manager.vala"
	old_value = accounts_manager_get_config_dir (self);
#line 113 "../src/client/accounts/accounts-manager.vala"
	if (old_value != value) {
#line 1415 "accounts-manager.c"
		GFile* _tmp0_;
#line 113 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 113 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (self->priv->_config_dir);
#line 113 "../src/client/accounts/accounts-manager.vala"
		self->priv->_config_dir = _tmp0_;
#line 113 "../src/client/accounts/accounts-manager.vala"
		g_object_notify_by_pspec ((GObject *) self, accounts_manager_properties[ACCOUNTS_MANAGER_CONFIG_DIR_PROPERTY]);
#line 1425 "accounts-manager.c"
	}
}

GFile*
accounts_manager_get_data_dir (AccountsManager* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 116 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), NULL);
#line 116 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->_data_dir;
#line 116 "../src/client/accounts/accounts-manager.vala"
	result = _tmp0_;
#line 116 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 1442 "accounts-manager.c"
}

static void
accounts_manager_set_data_dir (AccountsManager* self,
                               GFile* value)
{
	GFile* old_value;
#line 116 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 116 "../src/client/accounts/accounts-manager.vala"
	old_value = accounts_manager_get_data_dir (self);
#line 116 "../src/client/accounts/accounts-manager.vala"
	if (old_value != value) {
#line 1456 "accounts-manager.c"
		GFile* _tmp0_;
#line 116 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 116 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (self->priv->_data_dir);
#line 116 "../src/client/accounts/accounts-manager.vala"
		self->priv->_data_dir = _tmp0_;
#line 116 "../src/client/accounts/accounts-manager.vala"
		g_object_notify_by_pspec ((GObject *) self, accounts_manager_properties[ACCOUNTS_MANAGER_DATA_DIR_PROPERTY]);
#line 1466 "accounts-manager.c"
	}
}

static void
g_cclosure_user_marshal_VOID__OBJECT_ENUM (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_ENUM) (gpointer data1, gpointer arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (n_param_values == 3);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		data1 = closure->data;
#line 24 "../src/client/accounts/accounts-manager.vala"
		data2 = param_values->data[0].v_pointer;
#line 1492 "accounts-manager.c"
	} else {
#line 24 "../src/client/accounts/accounts-manager.vala"
		data1 = param_values->data[0].v_pointer;
#line 24 "../src/client/accounts/accounts-manager.vala"
		data2 = closure->data;
#line 1498 "accounts-manager.c"
	}
#line 24 "../src/client/accounts/accounts-manager.vala"
	callback = (GMarshalFunc_VOID__OBJECT_ENUM) (marshal_data ? marshal_data : cc->callback);
#line 24 "../src/client/accounts/accounts-manager.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_enum (param_values + 2), data2);
#line 1504 "accounts-manager.c"
}

AccountsManager*
accounts_manager_construct (GType object_type,
                            GearyCredentialsMediator* local_mediator,
                            GFile* config_dir,
                            GFile* data_dir)
{
	AccountsManager * self = NULL;
	GearyCredentialsMediator* _tmp0_;
#line 144 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (local_mediator, GEARY_TYPE_CREDENTIALS_MEDIATOR), NULL);
#line 144 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (config_dir, g_file_get_type ()), NULL);
#line 144 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (data_dir, g_file_get_type ()), NULL);
#line 144 "../src/client/accounts/accounts-manager.vala"
	self = (AccountsManager*) g_object_new (object_type, NULL);
#line 147 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (local_mediator);
#line 147 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (self->priv->local_mediator);
#line 147 "../src/client/accounts/accounts-manager.vala"
	self->priv->local_mediator = _tmp0_;
#line 148 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_set_config_dir (self, config_dir);
#line 149 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_set_data_dir (self, data_dir);
#line 144 "../src/client/accounts/accounts-manager.vala"
	return self;
#line 1535 "accounts-manager.c"
}

AccountsManager*
accounts_manager_new (GearyCredentialsMediator* local_mediator,
                      GFile* config_dir,
                      GFile* data_dir)
{
#line 144 "../src/client/accounts/accounts-manager.vala"
	return accounts_manager_construct (ACCOUNTS_TYPE_MANAGER, local_mediator, config_dir, data_dir);
#line 1545 "accounts-manager.c"
}

static void
accounts_manager_connect_goa_data_free (gpointer _data)
{
	AccountsManagerConnectGoaData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerConnectGoaData, _data_);
#line 1559 "accounts-manager.c"
}

void
accounts_manager_connect_goa (AccountsManager* self,
                              GCancellable* cancellable,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	AccountsManagerConnectGoaData* _data_;
	AccountsManager* _tmp0_;
	GCancellable* _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerConnectGoaData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_connect_goa_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_connect_goa_co (_data_);
#line 1593 "accounts-manager.c"
}

void
accounts_manager_connect_goa_finish (AccountsManager* self,
                                     GAsyncResult* _res_,
                                     GError** error)
{
	AccountsManagerConnectGoaData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 1608 "accounts-manager.c"
	}
}

static void
accounts_manager_connect_goa_ready (GObject* source_object,
                                    GAsyncResult* _res_,
                                    gpointer _user_data_)
{
	AccountsManagerConnectGoaData* _data_;
#line 154 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 154 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 154 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 154 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_connect_goa_co (_data_);
#line 1626 "accounts-manager.c"
}

static void
_accounts_manager_on_goa_account_added_goa_client_account_added (GoaClient* _sender,
                                                                 GoaObject* object,
                                                                 gpointer self)
{
#line 155 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_on_goa_account_added ((AccountsManager*) self, object);
#line 1636 "accounts-manager.c"
}

static void
_accounts_manager_on_goa_account_changed_goa_client_account_changed (GoaClient* _sender,
                                                                     GoaObject* object,
                                                                     gpointer self)
{
#line 156 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_on_goa_account_changed ((AccountsManager*) self, object);
#line 1646 "accounts-manager.c"
}

static void
_accounts_manager_on_goa_account_removed_goa_client_account_removed (GoaClient* _sender,
                                                                     GoaObject* object,
                                                                     gpointer self)
{
#line 157 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_on_goa_account_removed ((AccountsManager*) self, object);
#line 1656 "accounts-manager.c"
}

static gboolean
accounts_manager_connect_goa_co (AccountsManagerConnectGoaData* _data_)
{
#line 152 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 152 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 1666 "accounts-manager.c"
		goto _state_0;
#line 152 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 1670 "accounts-manager.c"
		goto _state_1;
		default:
#line 152 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 1675 "accounts-manager.c"
	}
	_state_0:
#line 154 "../src/client/accounts/accounts-manager.vala"
	_data_->_state_ = 1;
#line 154 "../src/client/accounts/accounts-manager.vala"
	goa_client_new (_data_->cancellable, accounts_manager_connect_goa_ready, _data_);
#line 154 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 1684 "accounts-manager.c"
	_state_1:
#line 154 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = goa_client_new_finish (_data_->_res_, &_data_->_inner_error0_);
#line 154 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = _data_->_tmp1_;
#line 154 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 154 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 154 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 154 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 1698 "accounts-manager.c"
	}
#line 154 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp2_ = _data_->_tmp0_;
#line 154 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = NULL;
#line 154 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self->priv->goa_service);
#line 154 "../src/client/accounts/accounts-manager.vala"
	_data_->self->priv->goa_service = _data_->_tmp2_;
#line 155 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp3_ = _data_->self->priv->goa_service;
#line 155 "../src/client/accounts/accounts-manager.vala"
	g_signal_connect_object (_data_->_tmp3_, "account-added", (GCallback) _accounts_manager_on_goa_account_added_goa_client_account_added, _data_->self, 0);
#line 156 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp4_ = _data_->self->priv->goa_service;
#line 156 "../src/client/accounts/accounts-manager.vala"
	g_signal_connect_object (_data_->_tmp4_, "account-changed", (GCallback) _accounts_manager_on_goa_account_changed_goa_client_account_changed, _data_->self, 0);
#line 157 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp5_ = _data_->self->priv->goa_service;
#line 157 "../src/client/accounts/accounts-manager.vala"
	g_signal_connect_object (_data_->_tmp5_, "account-removed", (GCallback) _accounts_manager_on_goa_account_removed_goa_client_account_removed, _data_->self, 0);
#line 152 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->_tmp0_);
#line 152 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 152 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 152 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 152 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1730 "accounts-manager.c"
		}
	}
#line 152 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 152 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 1737 "accounts-manager.c"
}

/** Returns the account with the given id. */
GearyAccountInformation*
accounts_manager_get_account (AccountsManager* self,
                              const gchar* id)
{
	AccountsManagerAccountState* state = NULL;
	GeeMap* _tmp0_;
	gpointer _tmp1_;
	GearyAccountInformation* _tmp2_ = NULL;
	AccountsManagerAccountState* _tmp3_;
	GearyAccountInformation* _tmp7_;
	GearyAccountInformation* result;
#line 161 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), NULL);
#line 161 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 162 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->accounts;
#line 162 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = gee_map_get (_tmp0_, id);
#line 162 "../src/client/accounts/accounts-manager.vala"
	state = (AccountsManagerAccountState*) _tmp1_;
#line 163 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = state;
#line 163 "../src/client/accounts/accounts-manager.vala"
	if (_tmp3_ != NULL) {
#line 1766 "accounts-manager.c"
		AccountsManagerAccountState* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GearyAccountInformation* _tmp6_;
#line 163 "../src/client/accounts/accounts-manager.vala"
		_tmp4_ = state;
#line 163 "../src/client/accounts/accounts-manager.vala"
		_tmp5_ = accounts_manager_account_state_get_account (_tmp4_);
#line 163 "../src/client/accounts/accounts-manager.vala"
		_tmp6_ = _tmp5_;
#line 163 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = _tmp6_;
#line 1778 "accounts-manager.c"
	} else {
#line 163 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = NULL;
#line 1782 "accounts-manager.c"
	}
#line 163 "../src/client/accounts/accounts-manager.vala"
	_tmp7_ = _g_object_ref0 (_tmp2_);
#line 163 "../src/client/accounts/accounts-manager.vala"
	result = _tmp7_;
#line 163 "../src/client/accounts/accounts-manager.vala"
	_accounts_manager_account_state_unref0 (state);
#line 163 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 1792 "accounts-manager.c"
}

/** Returns the status for the given account. */
AccountsManagerStatus
accounts_manager_get_status (AccountsManager* self,
                             GearyAccountInformation* account)
{
	AccountsManagerAccountState* state = NULL;
	GeeMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gpointer _tmp3_;
	AccountsManagerStatus _tmp4_ = 0;
	AccountsManagerAccountState* _tmp5_;
	AccountsManagerStatus result;
#line 167 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), 0);
#line 167 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION), 0);
#line 168 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->accounts;
#line 168 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = geary_account_information_get_id (account);
#line 168 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _tmp1_;
#line 168 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = gee_map_get (_tmp0_, _tmp2_);
#line 168 "../src/client/accounts/accounts-manager.vala"
	state = (AccountsManagerAccountState*) _tmp3_;
#line 169 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = state;
#line 169 "../src/client/accounts/accounts-manager.vala"
	if (_tmp5_ != NULL) {
#line 1826 "accounts-manager.c"
		AccountsManagerAccountState* _tmp6_;
		AccountsManagerStatus _tmp7_;
		AccountsManagerStatus _tmp8_;
#line 169 "../src/client/accounts/accounts-manager.vala"
		_tmp6_ = state;
#line 169 "../src/client/accounts/accounts-manager.vala"
		_tmp7_ = accounts_manager_account_state_get_status (_tmp6_);
#line 169 "../src/client/accounts/accounts-manager.vala"
		_tmp8_ = _tmp7_;
#line 169 "../src/client/accounts/accounts-manager.vala"
		_tmp4_ = _tmp8_;
#line 1838 "accounts-manager.c"
	} else {
#line 169 "../src/client/accounts/accounts-manager.vala"
		_tmp4_ = ACCOUNTS_MANAGER_STATUS_UNAVAILABLE;
#line 1842 "accounts-manager.c"
	}
#line 169 "../src/client/accounts/accounts-manager.vala"
	result = _tmp4_;
#line 169 "../src/client/accounts/accounts-manager.vala"
	_accounts_manager_account_state_unref0 (state);
#line 169 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 1850 "accounts-manager.c"
}

/** Returns a read-only iterable of all currently known accounts. */
static GearyAccountInformation*
__lambda12_ (AccountsManager* self,
             AccountsManagerAccountState* state)
{
	GearyAccountInformation* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GearyAccountInformation* _tmp2_;
	GearyAccountInformation* result;
#line 177 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_MANAGER_IS_ACCOUNT_STATE (state), NULL);
#line 177 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = accounts_manager_account_state_get_account (state);
#line 177 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _tmp0_;
#line 177 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 177 "../src/client/accounts/accounts-manager.vala"
	result = _tmp2_;
#line 177 "../src/client/accounts/accounts-manager.vala"
	_accounts_manager_account_state_unref0 (state);
#line 177 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 1876 "accounts-manager.c"
}

static gpointer
___lambda12__gee_map_func (gpointer g,
                           gpointer self)
{
	gpointer result;
	result = __lambda12_ ((AccountsManager*) self, (AccountsManagerAccountState*) g);
#line 174 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 1887 "accounts-manager.c"
}

GearyIterable*
accounts_manager_iterable (AccountsManager* self)
{
	GeeMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GearyIterable* _tmp4_;
	GearyIterable* _tmp5_;
	GearyIterable* _tmp6_;
	GearyIterable* _tmp7_;
	GearyIterable* result;
#line 173 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), NULL);
#line 174 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->accounts;
#line 174 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = gee_map_get_values (_tmp0_);
#line 174 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _tmp1_;
#line 174 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = _tmp2_;
#line 174 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = geary_traverse (ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE, (GBoxedCopyFunc) accounts_manager_account_state_ref, (GDestroyNotify) accounts_manager_account_state_unref, G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 174 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = _tmp4_;
#line 174 "../src/client/accounts/accounts-manager.vala"
	_tmp6_ = geary_iterable_map (_tmp5_, GEARY_TYPE_ACCOUNT_INFORMATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, ___lambda12__gee_map_func, self);
#line 174 "../src/client/accounts/accounts-manager.vala"
	_tmp7_ = _tmp6_;
#line 174 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp5_);
#line 174 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp3_);
#line 174 "../src/client/accounts/accounts-manager.vala"
	result = _tmp7_;
#line 174 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 1928 "accounts-manager.c"
}

/**
     * Returns the display name for the current desktop login session.
     */
gchar*
accounts_manager_get_account_name (AccountsManager* self)
{
	gchar* name = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gchar* result;
#line 184 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), NULL);
#line 185 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = g_get_real_name ();
#line 185 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 185 "../src/client/accounts/accounts-manager.vala"
	name = _tmp1_;
#line 186 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = name;
#line 186 "../src/client/accounts/accounts-manager.vala"
	if (geary_string_is_empty (_tmp3_)) {
#line 186 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = TRUE;
#line 1957 "accounts-manager.c"
	} else {
		const gchar* _tmp4_;
#line 186 "../src/client/accounts/accounts-manager.vala"
		_tmp4_ = name;
#line 186 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "Unknown") == 0;
#line 1964 "accounts-manager.c"
	}
#line 186 "../src/client/accounts/accounts-manager.vala"
	if (_tmp2_) {
#line 187 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (name);
#line 187 "../src/client/accounts/accounts-manager.vala"
		name = NULL;
#line 1972 "accounts-manager.c"
	}
#line 189 "../src/client/accounts/accounts-manager.vala"
	result = name;
#line 189 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 1978 "accounts-manager.c"
}

static void
accounts_manager_new_orphan_account_data_free (gpointer _data)
{
	AccountsManagerNewOrphanAccountData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->primary_mailbox);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->result);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerNewOrphanAccountData, _data_);
#line 1996 "accounts-manager.c"
}

void
accounts_manager_new_orphan_account (AccountsManager* self,
                                     GearyServiceProvider provider,
                                     GearyRFC822MailboxAddress* primary_mailbox,
                                     GCancellable* cancellable,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	AccountsManagerNewOrphanAccountData* _data_;
	AccountsManager* _tmp0_;
	GearyRFC822MailboxAddress* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (primary_mailbox, GEARY_RF_C822_TYPE_MAILBOX_ADDRESS));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerNewOrphanAccountData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_new_orphan_account_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->provider = provider;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (primary_mailbox);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->primary_mailbox);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->primary_mailbox = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_new_orphan_account_co (_data_);
#line 2043 "accounts-manager.c"
}

GearyAccountInformation*
accounts_manager_new_orphan_account_finish (AccountsManager* self,
                                            GAsyncResult* _res_)
{
	GearyAccountInformation* result;
	AccountsManagerNewOrphanAccountData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return NULL;
#line 2058 "accounts-manager.c"
	}
#line 24 "../src/client/accounts/accounts-manager.vala"
	result = _data_->result;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->result = NULL;
#line 24 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 2066 "accounts-manager.c"
}

/**
     * Returns a new account, not yet stored on disk.
     */
static void
accounts_manager_new_orphan_account_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_)
{
	AccountsManagerNewOrphanAccountData* _data_;
#line 199 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 199 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 199 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 199 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_new_orphan_account_co (_data_);
#line 2086 "accounts-manager.c"
}

static gboolean
accounts_manager_new_orphan_account_co (AccountsManagerNewOrphanAccountData* _data_)
{
#line 195 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 195 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 2096 "accounts-manager.c"
		goto _state_0;
#line 195 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 2100 "accounts-manager.c"
		goto _state_1;
		default:
#line 195 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 2105 "accounts-manager.c"
	}
	_state_0:
#line 199 "../src/client/accounts/accounts-manager.vala"
	_data_->_state_ = 1;
#line 199 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_next_id (_data_->self, _data_->cancellable, accounts_manager_new_orphan_account_ready, _data_);
#line 199 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 2114 "accounts-manager.c"
	_state_1:
#line 199 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = accounts_manager_next_id_finish (_data_->self, _data_->_res_);
#line 199 "../src/client/accounts/accounts-manager.vala"
	_data_->id = _data_->_tmp0_;
#line 200 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = _data_->self->priv->local_mediator;
#line 200 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp2_ = geary_account_information_new (_data_->id, _data_->provider, _data_->_tmp1_, _data_->primary_mailbox);
#line 200 "../src/client/accounts/accounts-manager.vala"
	_data_->result = _data_->_tmp2_;
#line 200 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->id);
#line 200 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 200 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 200 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 200 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2136 "accounts-manager.c"
		}
	}
#line 200 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 200 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 2143 "accounts-manager.c"
}

static void
accounts_manager_create_account_data_free (gpointer _data)
{
	AccountsManagerCreateAccountData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerCreateAccountData, _data_);
#line 2159 "accounts-manager.c"
}

void
accounts_manager_create_account (AccountsManager* self,
                                 GearyAccountInformation* account,
                                 GCancellable* cancellable,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	AccountsManagerCreateAccountData* _data_;
	AccountsManager* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerCreateAccountData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_create_account_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->account = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_create_account_co (_data_);
#line 2203 "accounts-manager.c"
}

void
accounts_manager_create_account_finish (AccountsManager* self,
                                        GAsyncResult* _res_,
                                        GError** error)
{
	AccountsManagerCreateAccountData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 2218 "accounts-manager.c"
	}
}

/**
     * Creates new account's disk and credential storage as needed.
     */
static void
accounts_manager_create_account_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	AccountsManagerCreateAccountData* _data_;
#line 211 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 211 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 211 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 211 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_create_account_co (_data_);
#line 2239 "accounts-manager.c"
}

static gboolean
accounts_manager_create_account_co (AccountsManagerCreateAccountData* _data_)
{
#line 208 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 208 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 2249 "accounts-manager.c"
		goto _state_0;
#line 208 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 2253 "accounts-manager.c"
		goto _state_1;
#line 208 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 2257 "accounts-manager.c"
		goto _state_2;
#line 208 "../src/client/accounts/accounts-manager.vala"
		case 3:
#line 2261 "accounts-manager.c"
		goto _state_3;
#line 208 "../src/client/accounts/accounts-manager.vala"
		case 4:
#line 2265 "accounts-manager.c"
		goto _state_4;
		default:
#line 208 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 2270 "accounts-manager.c"
	}
	_state_0:
#line 211 "../src/client/accounts/accounts-manager.vala"
	_data_->_state_ = 1;
#line 211 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_create_account_dirs (_data_->self, _data_->account, _data_->cancellable, accounts_manager_create_account_ready, _data_);
#line 211 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 2279 "accounts-manager.c"
	_state_1:
#line 211 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_create_account_dirs_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 211 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 211 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 211 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 211 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 2291 "accounts-manager.c"
	}
#line 212 "../src/client/accounts/accounts-manager.vala"
	_data_->_state_ = 2;
#line 212 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_save_account (_data_->self, _data_->account, _data_->cancellable, accounts_manager_create_account_ready, _data_);
#line 212 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 2299 "accounts-manager.c"
	_state_2:
#line 212 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_save_account_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 212 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 212 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 212 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 212 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 2311 "accounts-manager.c"
	}
#line 213 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_set_enabled (_data_->self, _data_->account, TRUE);
#line 216 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = geary_account_information_get_mediator (_data_->account);
#line 216 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 216 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp2_ = _g_object_ref0 (IS_SECRET_MEDIATOR (_data_->_tmp1_) ? ((SecretMediator*) _data_->_tmp1_) : NULL);
#line 216 "../src/client/accounts/accounts-manager.vala"
	_data_->mediator = _data_->_tmp2_;
#line 217 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp3_ = _data_->mediator;
#line 217 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp3_ != NULL) {
#line 218 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp4_ = _data_->mediator;
#line 218 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp5_ = geary_account_information_get_incoming (_data_->account);
#line 218 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 218 "../src/client/accounts/accounts-manager.vala"
		_data_->_state_ = 3;
#line 218 "../src/client/accounts/accounts-manager.vala"
		secret_mediator_update_token (_data_->_tmp4_, _data_->account, _data_->_tmp6_, _data_->cancellable, accounts_manager_create_account_ready, _data_);
#line 218 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 2339 "accounts-manager.c"
		_state_3:
#line 218 "../src/client/accounts/accounts-manager.vala"
		secret_mediator_update_token_finish (_data_->_tmp4_, _data_->_res_, &_data_->_inner_error0_);
#line 218 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 218 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 218 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 218 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 218 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 2353 "accounts-manager.c"
		}
#line 219 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp7_ = _data_->mediator;
#line 219 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp8_ = geary_account_information_get_outgoing (_data_->account);
#line 219 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 219 "../src/client/accounts/accounts-manager.vala"
		_data_->_state_ = 4;
#line 219 "../src/client/accounts/accounts-manager.vala"
		secret_mediator_update_token (_data_->_tmp7_, _data_->account, _data_->_tmp9_, _data_->cancellable, accounts_manager_create_account_ready, _data_);
#line 219 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 2367 "accounts-manager.c"
		_state_4:
#line 219 "../src/client/accounts/accounts-manager.vala"
		secret_mediator_update_token_finish (_data_->_tmp7_, _data_->_res_, &_data_->_inner_error0_);
#line 219 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 219 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 219 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 219 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 219 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 2381 "accounts-manager.c"
		}
	}
#line 208 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->mediator);
#line 208 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 208 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 208 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 208 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2394 "accounts-manager.c"
		}
	}
#line 208 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 208 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 2401 "accounts-manager.c"
}

static void
accounts_manager_load_accounts_data_free (gpointer _data)
{
	AccountsManagerLoadAccountsData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerLoadAccountsData, _data_);
#line 2415 "accounts-manager.c"
}

void
accounts_manager_load_accounts (AccountsManager* self,
                                GCancellable* cancellable,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
	AccountsManagerLoadAccountsData* _data_;
	AccountsManager* _tmp0_;
	GCancellable* _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerLoadAccountsData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_load_accounts_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_load_accounts_co (_data_);
#line 2449 "accounts-manager.c"
}

void
accounts_manager_load_accounts_finish (AccountsManager* self,
                                       GAsyncResult* _res_,
                                       GError** error)
{
	AccountsManagerLoadAccountsData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 2464 "accounts-manager.c"
	}
}

static void
accounts_manager_load_accounts_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_)
{
	AccountsManagerLoadAccountsData* _data_;
#line 228 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 228 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 228 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 228 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_load_accounts_co (_data_);
#line 2482 "accounts-manager.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 250 "../src/client/accounts/accounts-manager.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 2490 "accounts-manager.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 250 "../src/client/accounts/accounts-manager.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 2498 "accounts-manager.c"
}

static gboolean
accounts_manager_load_accounts_co (AccountsManagerLoadAccountsData* _data_)
{
#line 223 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 223 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 2508 "accounts-manager.c"
		goto _state_0;
#line 223 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 2512 "accounts-manager.c"
		goto _state_1;
#line 223 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 2516 "accounts-manager.c"
		goto _state_2;
#line 223 "../src/client/accounts/accounts-manager.vala"
		case 3:
#line 2520 "accounts-manager.c"
		goto _state_3;
#line 223 "../src/client/accounts/accounts-manager.vala"
		case 4:
#line 2524 "accounts-manager.c"
		goto _state_4;
		default:
#line 223 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 2529 "accounts-manager.c"
	}
	_state_0:
#line 226 "../src/client/accounts/accounts-manager.vala"
	_data_->enumerator = NULL;
#line 2534 "accounts-manager.c"
	{
#line 228 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp1_ = _data_->self->priv->_config_dir;
#line 228 "../src/client/accounts/accounts-manager.vala"
		_data_->_state_ = 1;
#line 228 "../src/client/accounts/accounts-manager.vala"
		g_file_enumerate_children_async (_data_->_tmp1_, "standard::*", G_FILE_QUERY_INFO_NONE, G_PRIORITY_DEFAULT, _data_->cancellable, accounts_manager_load_accounts_ready, _data_);
#line 228 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 2544 "accounts-manager.c"
		_state_1:
#line 228 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp2_ = g_file_enumerate_children_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error0_);
#line 228 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp0_ = _data_->_tmp2_;
#line 228 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 228 "../src/client/accounts/accounts-manager.vala"
			if (g_error_matches (_data_->_inner_error0_, G_IO_ERROR, G_IO_ERROR_NOT_FOUND)) {
#line 2554 "accounts-manager.c"
				goto __catch0_g_io_error_not_found;
			}
			goto __finally0;
		}
#line 228 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp3_ = _data_->_tmp0_;
#line 228 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp0_ = NULL;
#line 228 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->enumerator);
#line 228 "../src/client/accounts/accounts-manager.vala"
		_data_->enumerator = _data_->_tmp3_;
#line 227 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 2569 "accounts-manager.c"
	}
	goto __finally0;
	__catch0_g_io_error_not_found:
	{
#line 227 "../src/client/accounts/accounts-manager.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 2576 "accounts-manager.c"
	}
	__finally0:
#line 227 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 227 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 227 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->enumerator);
#line 227 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 227 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 2589 "accounts-manager.c"
	}
#line 239 "../src/client/accounts/accounts-manager.vala"
	while (TRUE) {
#line 239 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp5_ = _data_->enumerator;
#line 239 "../src/client/accounts/accounts-manager.vala"
		if (_data_->_tmp5_ != NULL) {
#line 239 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp4_ = !g_cancellable_is_cancelled (_data_->cancellable);
#line 2599 "accounts-manager.c"
		} else {
#line 239 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp4_ = FALSE;
#line 2603 "accounts-manager.c"
		}
#line 239 "../src/client/accounts/accounts-manager.vala"
		if (!_data_->_tmp4_) {
#line 239 "../src/client/accounts/accounts-manager.vala"
			break;
#line 2609 "accounts-manager.c"
		}
#line 241 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp6_ = _data_->enumerator;
#line 241 "../src/client/accounts/accounts-manager.vala"
		_data_->_state_ = 2;
#line 241 "../src/client/accounts/accounts-manager.vala"
		g_file_enumerator_next_files_async (_data_->_tmp6_, 10, G_PRIORITY_DEFAULT, _data_->cancellable, accounts_manager_load_accounts_ready, _data_);
#line 241 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 2619 "accounts-manager.c"
		_state_2:
#line 241 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp7_ = g_file_enumerator_next_files_finish (_data_->_tmp6_, _data_->_res_, &_data_->_inner_error0_);
#line 241 "../src/client/accounts/accounts-manager.vala"
		_data_->info_list = _data_->_tmp7_;
#line 241 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 241 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 241 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->enumerator);
#line 241 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 241 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 2635 "accounts-manager.c"
		}
#line 245 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp8_ = _data_->info_list;
#line 245 "../src/client/accounts/accounts-manager.vala"
		_data_->len = g_list_length (_data_->_tmp8_);
#line 2641 "accounts-manager.c"
		{
#line 246 "../src/client/accounts/accounts-manager.vala"
			_data_->i = (guint) 0;
#line 2645 "accounts-manager.c"
			{
#line 246 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp9_ = TRUE;
#line 246 "../src/client/accounts/accounts-manager.vala"
				while (TRUE) {
#line 246 "../src/client/accounts/accounts-manager.vala"
					if (!_data_->_tmp9_) {
#line 246 "../src/client/accounts/accounts-manager.vala"
						_data_->_tmp10_ = _data_->i;
#line 246 "../src/client/accounts/accounts-manager.vala"
						_data_->i = _data_->_tmp10_ + 1;
#line 2657 "accounts-manager.c"
					}
#line 246 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp9_ = FALSE;
#line 246 "../src/client/accounts/accounts-manager.vala"
					if (_data_->i < _data_->len) {
#line 246 "../src/client/accounts/accounts-manager.vala"
						_data_->_tmp11_ = !g_cancellable_is_cancelled (_data_->cancellable);
#line 2665 "accounts-manager.c"
					} else {
#line 246 "../src/client/accounts/accounts-manager.vala"
						_data_->_tmp11_ = FALSE;
#line 2669 "accounts-manager.c"
					}
#line 246 "../src/client/accounts/accounts-manager.vala"
					if (!_data_->_tmp11_) {
#line 246 "../src/client/accounts/accounts-manager.vala"
						break;
#line 2675 "accounts-manager.c"
					}
#line 247 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp12_ = _data_->info_list;
#line 247 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp13_ = g_list_nth_data (_data_->_tmp12_, _data_->i);
#line 247 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp14_ = _g_object_ref0 ((GFileInfo*) _data_->_tmp13_);
#line 247 "../src/client/accounts/accounts-manager.vala"
					_data_->file = _data_->_tmp14_;
#line 248 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp15_ = _data_->file;
#line 248 "../src/client/accounts/accounts-manager.vala"
					if (g_file_info_get_file_type (_data_->_tmp15_) == G_FILE_TYPE_DIRECTORY) {
#line 249 "../src/client/accounts/accounts-manager.vala"
						_data_->_tmp16_ = _data_->file;
#line 249 "../src/client/accounts/accounts-manager.vala"
						_data_->_tmp17_ = g_file_info_get_name (_data_->_tmp16_);
#line 249 "../src/client/accounts/accounts-manager.vala"
						_data_->_tmp18_ = g_strdup (_data_->_tmp17_);
#line 249 "../src/client/accounts/accounts-manager.vala"
						_data_->id = _data_->_tmp18_;
#line 2697 "accounts-manager.c"
						{
#line 251 "../src/client/accounts/accounts-manager.vala"
							_data_->_tmp19_ = _data_->id;
#line 251 "../src/client/accounts/accounts-manager.vala"
							_data_->_state_ = 3;
#line 251 "../src/client/accounts/accounts-manager.vala"
							accounts_manager_load_account (_data_->self, _data_->_tmp19_, _data_->cancellable, accounts_manager_load_accounts_ready, _data_);
#line 251 "../src/client/accounts/accounts-manager.vala"
							return FALSE;
#line 2707 "accounts-manager.c"
							_state_3:
#line 251 "../src/client/accounts/accounts-manager.vala"
							_data_->_tmp20_ = accounts_manager_load_account_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 251 "../src/client/accounts/accounts-manager.vala"
							_data_->info = _data_->_tmp20_;
#line 251 "../src/client/accounts/accounts-manager.vala"
							if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 251 "../src/client/accounts/accounts-manager.vala"
								if (g_error_matches (_data_->_inner_error0_, ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_UNAVAILABLE)) {
#line 2717 "accounts-manager.c"
									goto __catch1_accounts_config_error_unavailable;
								}
#line 251 "../src/client/accounts/accounts-manager.vala"
								if (g_error_matches (_data_->_inner_error0_, ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_REMOVED)) {
#line 2722 "accounts-manager.c"
									goto __catch1_accounts_config_error_removed;
								}
								goto __catch1_g_error;
							}
#line 254 "../src/client/accounts/accounts-manager.vala"
							_data_->_tmp21_ = _data_->info;
#line 254 "../src/client/accounts/accounts-manager.vala"
							accounts_manager_set_enabled (_data_->self, _data_->_tmp21_, TRUE);
#line 250 "../src/client/accounts/accounts-manager.vala"
							_g_object_unref0 (_data_->info);
#line 2733 "accounts-manager.c"
						}
						goto __finally1;
						__catch1_accounts_config_error_unavailable:
						{
#line 250 "../src/client/accounts/accounts-manager.vala"
							g_clear_error (&_data_->_inner_error0_);
#line 2740 "accounts-manager.c"
						}
						goto __finally1;
						__catch1_accounts_config_error_removed:
						{
#line 250 "../src/client/accounts/accounts-manager.vala"
							g_clear_error (&_data_->_inner_error0_);
#line 2747 "accounts-manager.c"
						}
						goto __finally1;
						__catch1_g_error:
						{
#line 250 "../src/client/accounts/accounts-manager.vala"
							_data_->err = _data_->_inner_error0_;
#line 250 "../src/client/accounts/accounts-manager.vala"
							_data_->_inner_error0_ = NULL;
#line 262 "../src/client/accounts/accounts-manager.vala"
							_data_->_tmp22_ = _data_->id;
#line 262 "../src/client/accounts/accounts-manager.vala"
							g_debug ("accounts-manager.vala:262: Error loading account %s", _data_->_tmp22_);
#line 263 "../src/client/accounts/accounts-manager.vala"
							_data_->_tmp23_ = _data_->err;
#line 263 "../src/client/accounts/accounts-manager.vala"
							_data_->_tmp24_ = geary_problem_report_new (_data_->_tmp23_);
#line 263 "../src/client/accounts/accounts-manager.vala"
							_data_->_tmp25_ = _data_->_tmp24_;
#line 263 "../src/client/accounts/accounts-manager.vala"
							g_signal_emit (_data_->self, accounts_manager_signals[ACCOUNTS_MANAGER_REPORT_PROBLEM_SIGNAL], 0, _data_->_tmp25_);
#line 263 "../src/client/accounts/accounts-manager.vala"
							_g_object_unref0 (_data_->_tmp25_);
#line 250 "../src/client/accounts/accounts-manager.vala"
							_g_error_free0 (_data_->err);
#line 2772 "accounts-manager.c"
						}
						__finally1:
#line 250 "../src/client/accounts/accounts-manager.vala"
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 250 "../src/client/accounts/accounts-manager.vala"
							g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 250 "../src/client/accounts/accounts-manager.vala"
							_g_free0 (_data_->id);
#line 250 "../src/client/accounts/accounts-manager.vala"
							_g_object_unref0 (_data_->file);
#line 250 "../src/client/accounts/accounts-manager.vala"
							(_data_->info_list == NULL) ? NULL : (_data_->info_list = (_g_list_free__g_object_unref0_ (_data_->info_list), NULL));
#line 250 "../src/client/accounts/accounts-manager.vala"
							_g_object_unref0 (_data_->enumerator);
#line 250 "../src/client/accounts/accounts-manager.vala"
							g_object_unref (_data_->_async_result);
#line 250 "../src/client/accounts/accounts-manager.vala"
							return FALSE;
#line 2791 "accounts-manager.c"
						}
#line 248 "../src/client/accounts/accounts-manager.vala"
						_g_free0 (_data_->id);
#line 2795 "accounts-manager.c"
					}
#line 246 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (_data_->file);
#line 2799 "accounts-manager.c"
				}
			}
		}
#line 268 "../src/client/accounts/accounts-manager.vala"
		if (_data_->len == ((guint) 0)) {
#line 270 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->enumerator);
#line 270 "../src/client/accounts/accounts-manager.vala"
			_data_->enumerator = NULL;
#line 2809 "accounts-manager.c"
		}
#line 239 "../src/client/accounts/accounts-manager.vala"
		(_data_->info_list == NULL) ? NULL : (_data_->info_list = (_g_list_free__g_object_unref0_ (_data_->info_list), NULL));
#line 2813 "accounts-manager.c"
	}
#line 275 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp26_ = _data_->self->priv->goa_service;
#line 275 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp26_ != NULL) {
#line 276 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp27_ = _data_->self->priv->goa_service;
#line 276 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp28_ = goa_client_get_accounts (_data_->_tmp27_);
#line 276 "../src/client/accounts/accounts-manager.vala"
		_data_->list = _data_->_tmp28_;
#line 2825 "accounts-manager.c"
		{
#line 277 "../src/client/accounts/accounts-manager.vala"
			_data_->_vala1_i = 0;
#line 2829 "accounts-manager.c"
			{
#line 277 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp29_ = TRUE;
#line 277 "../src/client/accounts/accounts-manager.vala"
				while (TRUE) {
#line 277 "../src/client/accounts/accounts-manager.vala"
					if (!_data_->_tmp29_) {
#line 277 "../src/client/accounts/accounts-manager.vala"
						_data_->_tmp30_ = _data_->_vala1_i;
#line 277 "../src/client/accounts/accounts-manager.vala"
						_data_->_vala1_i = _data_->_tmp30_ + 1;
#line 2841 "accounts-manager.c"
					}
#line 277 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp29_ = FALSE;
#line 277 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp32_ = _data_->list;
#line 277 "../src/client/accounts/accounts-manager.vala"
					if (((guint) _data_->_vala1_i) < g_list_length (_data_->_tmp32_)) {
#line 277 "../src/client/accounts/accounts-manager.vala"
						_data_->_tmp31_ = !g_cancellable_is_cancelled (_data_->cancellable);
#line 2851 "accounts-manager.c"
					} else {
#line 277 "../src/client/accounts/accounts-manager.vala"
						_data_->_tmp31_ = FALSE;
#line 2855 "accounts-manager.c"
					}
#line 277 "../src/client/accounts/accounts-manager.vala"
					if (!_data_->_tmp31_) {
#line 277 "../src/client/accounts/accounts-manager.vala"
						break;
#line 2861 "accounts-manager.c"
					}
#line 278 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp33_ = _data_->list;
#line 278 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp34_ = g_list_nth_data (_data_->_tmp33_, (guint) _data_->_vala1_i);
#line 278 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp35_ = _g_object_ref0 ((GoaObject*) _data_->_tmp34_);
#line 278 "../src/client/accounts/accounts-manager.vala"
					_data_->account = _data_->_tmp35_;
#line 279 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp36_ = _data_->account;
#line 279 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp37_ = accounts_manager_to_geary_id (_data_->self, _data_->_tmp36_);
#line 279 "../src/client/accounts/accounts-manager.vala"
					_data_->_vala1_id = _data_->_tmp37_;
#line 280 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp38_ = _data_->self->priv->accounts;
#line 280 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp39_ = _data_->_vala1_id;
#line 280 "../src/client/accounts/accounts-manager.vala"
					if (!gee_map_has_key (_data_->_tmp38_, _data_->_tmp39_)) {
#line 281 "../src/client/accounts/accounts-manager.vala"
						_data_->_tmp40_ = _data_->account;
#line 281 "../src/client/accounts/accounts-manager.vala"
						_data_->_state_ = 4;
#line 281 "../src/client/accounts/accounts-manager.vala"
						accounts_manager_create_goa_account (_data_->self, _data_->_tmp40_, _data_->cancellable, accounts_manager_load_accounts_ready, _data_);
#line 281 "../src/client/accounts/accounts-manager.vala"
						return FALSE;
#line 2891 "accounts-manager.c"
						_state_4:
#line 281 "../src/client/accounts/accounts-manager.vala"
						accounts_manager_create_goa_account_finish (_data_->self, _data_->_res_);
#line 2895 "accounts-manager.c"
					}
#line 277 "../src/client/accounts/accounts-manager.vala"
					_g_free0 (_data_->_vala1_id);
#line 277 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (_data_->account);
#line 2901 "accounts-manager.c"
				}
			}
		}
#line 275 "../src/client/accounts/accounts-manager.vala"
		(_data_->list == NULL) ? NULL : (_data_->list = (_g_list_free__g_object_unref0_ (_data_->list), NULL));
#line 2907 "accounts-manager.c"
	}
#line 223 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->enumerator);
#line 223 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 223 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 223 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 223 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2919 "accounts-manager.c"
		}
	}
#line 223 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 223 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 2926 "accounts-manager.c"
}

/**
     * Marks an existing account as being unavailable.
     *
     * This keeps the account in the known set, but marks it as being
     * unavailable.
     */
void
accounts_manager_disable_account (AccountsManager* self,
                                  GearyAccountInformation* account)
{
	GeeMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 293 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 293 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 294 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->accounts;
#line 294 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = geary_account_information_get_id (account);
#line 294 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _tmp1_;
#line 294 "../src/client/accounts/accounts-manager.vala"
	if (gee_map_has_key (_tmp0_, _tmp2_)) {
#line 295 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_set_available (self, account, FALSE);
#line 2956 "accounts-manager.c"
	}
}

static void
accounts_manager_remove_account_data_free (gpointer _data)
{
	AccountsManagerRemoveAccountData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerRemoveAccountData, _data_);
#line 2973 "accounts-manager.c"
}

void
accounts_manager_remove_account (AccountsManager* self,
                                 GearyAccountInformation* account,
                                 GCancellable* cancellable,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	AccountsManagerRemoveAccountData* _data_;
	AccountsManager* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerRemoveAccountData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_remove_account_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->account = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_remove_account_co (_data_);
#line 3017 "accounts-manager.c"
}

void
accounts_manager_remove_account_finish (AccountsManager* self,
                                        GAsyncResult* _res_,
                                        GError** error)
{
	AccountsManagerRemoveAccountData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 3032 "accounts-manager.c"
	}
}

/**
     * Removes an account from the manager's set of known accounts.
     *
     * This removes the account from the known set, marks the account
     * as deleted, and queues it for deletion. The account will not
     * actually be deleted until {@link expunge_accounts} is called,
     * and until then the account can be re-added using {@link
     * restore_account}.
     */
static void
_accounts_manager_on_account_changed_geary_account_information_changed (GearyAccountInformation* _sender,
                                                                        gpointer self)
{
#line 313 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_on_account_changed ((AccountsManager*) self, _sender);
#line 3051 "accounts-manager.c"
}

static void
accounts_manager_remove_account_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	AccountsManagerRemoveAccountData* _data_;
#line 314 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 314 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 314 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 314 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_remove_account_co (_data_);
#line 3068 "accounts-manager.c"
}

static gboolean
accounts_manager_remove_account_co (AccountsManagerRemoveAccountData* _data_)
{
#line 308 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 308 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 3078 "accounts-manager.c"
		goto _state_0;
#line 308 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 3082 "accounts-manager.c"
		goto _state_1;
		default:
#line 308 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 3087 "accounts-manager.c"
	}
	_state_0:
#line 311 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = _data_->self->priv->accounts;
#line 311 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = geary_account_information_get_id (_data_->account);
#line 311 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 311 "../src/client/accounts/accounts-manager.vala"
	gee_map_unset (_data_->_tmp0_, _data_->_tmp2_, NULL);
#line 312 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp3_ = _data_->self->priv->removed;
#line 312 "../src/client/accounts/accounts-manager.vala"
	gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _data_->account);
#line 313 "../src/client/accounts/accounts-manager.vala"
	g_signal_parse_name ("changed", GEARY_TYPE_ACCOUNT_INFORMATION, &_data_->_tmp4_, NULL, FALSE);
#line 313 "../src/client/accounts/accounts-manager.vala"
	g_signal_handlers_disconnect_matched (_data_->account, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _data_->_tmp4_, 0, NULL, (GCallback) _accounts_manager_on_account_changed_geary_account_information_changed, _data_->self);
#line 314 "../src/client/accounts/accounts-manager.vala"
	_data_->_state_ = 1;
#line 314 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_save_account (_data_->self, _data_->account, _data_->cancellable, accounts_manager_remove_account_ready, _data_);
#line 314 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 3112 "accounts-manager.c"
	_state_1:
#line 314 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_save_account_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 314 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 314 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 314 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 314 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 3124 "accounts-manager.c"
	}
#line 315 "../src/client/accounts/accounts-manager.vala"
	g_signal_emit (_data_->self, accounts_manager_signals[ACCOUNTS_MANAGER_ACCOUNT_REMOVED_SIGNAL], 0, _data_->account);
#line 308 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 308 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 308 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 308 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3136 "accounts-manager.c"
		}
	}
#line 308 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 308 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 3143 "accounts-manager.c"
}

static void
accounts_manager_restore_account_data_free (gpointer _data)
{
	AccountsManagerRestoreAccountData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerRestoreAccountData, _data_);
#line 3159 "accounts-manager.c"
}

void
accounts_manager_restore_account (AccountsManager* self,
                                  GearyAccountInformation* account,
                                  GCancellable* cancellable,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	AccountsManagerRestoreAccountData* _data_;
	AccountsManager* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerRestoreAccountData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_restore_account_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->account = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_restore_account_co (_data_);
#line 3203 "accounts-manager.c"
}

void
accounts_manager_restore_account_finish (AccountsManager* self,
                                         GAsyncResult* _res_,
                                         GError** error)
{
	AccountsManagerRestoreAccountData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 3218 "accounts-manager.c"
	}
}

/**
     * Restores an account that has previously been removed.
     *
     * This restores an account previously removed via a call to
     * {@link remove_account}, adding it back to the known set, as
     * long as {@link expunge_accounts} has not been called since
     * he account was removed.
     */
static void
accounts_manager_restore_account_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_)
{
	AccountsManagerRestoreAccountData* _data_;
#line 330 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 330 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 330 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 330 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_restore_account_co (_data_);
#line 3244 "accounts-manager.c"
}

static gboolean
accounts_manager_restore_account_co (AccountsManagerRestoreAccountData* _data_)
{
#line 326 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 326 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 3254 "accounts-manager.c"
		goto _state_0;
#line 326 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 3258 "accounts-manager.c"
		goto _state_1;
		default:
#line 326 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 3263 "accounts-manager.c"
	}
	_state_0:
#line 329 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = _data_->self->priv->removed;
#line 329 "../src/client/accounts/accounts-manager.vala"
	if (gee_abstract_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _data_->account)) {
#line 330 "../src/client/accounts/accounts-manager.vala"
		_data_->_state_ = 1;
#line 330 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_save_account (_data_->self, _data_->account, _data_->cancellable, accounts_manager_restore_account_ready, _data_);
#line 330 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 3276 "accounts-manager.c"
		_state_1:
#line 330 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_save_account_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 330 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 330 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 330 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 330 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 3288 "accounts-manager.c"
		}
#line 331 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_set_enabled (_data_->self, _data_->account, TRUE);
#line 3292 "accounts-manager.c"
	}
#line 326 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 326 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 326 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 326 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3302 "accounts-manager.c"
		}
	}
#line 326 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 326 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 3309 "accounts-manager.c"
}

static void
accounts_manager_expunge_accounts_data_free (gpointer _data)
{
	AccountsManagerExpungeAccountsData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerExpungeAccountsData, _data_);
#line 3323 "accounts-manager.c"
}

void
accounts_manager_expunge_accounts (AccountsManager* self,
                                   GCancellable* cancellable,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	AccountsManagerExpungeAccountsData* _data_;
	AccountsManager* _tmp0_;
	GCancellable* _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerExpungeAccountsData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_expunge_accounts_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_expunge_accounts_co (_data_);
#line 3357 "accounts-manager.c"
}

void
accounts_manager_expunge_accounts_finish (AccountsManager* self,
                                          GAsyncResult* _res_,
                                          GError** error)
{
	AccountsManagerExpungeAccountsData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 3372 "accounts-manager.c"
	}
}

/**
     * Deletes all local data for all accounts that have been removed.
     */
static void
accounts_manager_expunge_accounts_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_)
{
	AccountsManagerExpungeAccountsData* _data_;
#line 341 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 341 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 341 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 341 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_expunge_accounts_co (_data_);
#line 3393 "accounts-manager.c"
}

static gboolean
accounts_manager_expunge_accounts_co (AccountsManagerExpungeAccountsData* _data_)
{
#line 338 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 338 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 3403 "accounts-manager.c"
		goto _state_0;
#line 338 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 3407 "accounts-manager.c"
		goto _state_1;
		default:
#line 338 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 3412 "accounts-manager.c"
	}
	_state_0:
#line 340 "../src/client/accounts/accounts-manager.vala"
	while (TRUE) {
#line 340 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp1_ = _data_->self->priv->removed;
#line 340 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp2_ = gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 340 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 340 "../src/client/accounts/accounts-manager.vala"
		if (!_data_->_tmp3_) {
#line 340 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp0_ = !g_cancellable_is_cancelled (_data_->cancellable);
#line 3427 "accounts-manager.c"
		} else {
#line 340 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp0_ = FALSE;
#line 3431 "accounts-manager.c"
		}
#line 340 "../src/client/accounts/accounts-manager.vala"
		if (!_data_->_tmp0_) {
#line 340 "../src/client/accounts/accounts-manager.vala"
			break;
#line 3437 "accounts-manager.c"
		}
#line 341 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp4_ = _data_->self->priv->removed;
#line 341 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp5_ = gee_abstract_list_remove_at (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp4_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), 0);
#line 341 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp6_ = (GearyAccountInformation*) _data_->_tmp5_;
#line 341 "../src/client/accounts/accounts-manager.vala"
		_data_->_state_ = 1;
#line 341 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_delete_account (_data_->self, _data_->_tmp6_, _data_->cancellable, accounts_manager_expunge_accounts_ready, _data_);
#line 341 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 3451 "accounts-manager.c"
		_state_1:
#line 341 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_delete_account_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 341 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->_tmp6_);
#line 341 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 341 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 341 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 341 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 3465 "accounts-manager.c"
		}
	}
#line 338 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 338 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 338 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 338 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3476 "accounts-manager.c"
		}
	}
#line 338 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 338 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 3483 "accounts-manager.c"
}

static void
accounts_manager_save_account_data_free (gpointer _data)
{
	AccountsManagerSaveAccountData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->info);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerSaveAccountData, _data_);
#line 3499 "accounts-manager.c"
}

void
accounts_manager_save_account (AccountsManager* self,
                               GearyAccountInformation* info,
                               GCancellable* cancellable,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	AccountsManagerSaveAccountData* _data_;
	AccountsManager* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerSaveAccountData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_save_account_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (info);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->info);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->info = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_save_account_co (_data_);
#line 3543 "accounts-manager.c"
}

void
accounts_manager_save_account_finish (AccountsManager* self,
                                      GAsyncResult* _res_,
                                      GError** error)
{
	AccountsManagerSaveAccountData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 3558 "accounts-manager.c"
	}
}

/**
     * Saves an account's configuration data to disk.
     */
static void
accounts_manager_save_account_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_)
{
	AccountsManagerSaveAccountData* _data_;
#line 354 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 354 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 354 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 354 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_save_account_co (_data_);
#line 3579 "accounts-manager.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 360 "../src/client/accounts/accounts-manager.vala"
	return self ? g_error_copy (self) : NULL;
#line 3587 "accounts-manager.c"
}

static gboolean
accounts_manager_save_account_co (AccountsManagerSaveAccountData* _data_)
{
#line 348 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 348 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 3597 "accounts-manager.c"
		goto _state_0;
#line 348 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 3601 "accounts-manager.c"
		goto _state_1;
#line 348 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 3605 "accounts-manager.c"
		goto _state_2;
		default:
#line 348 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 3610 "accounts-manager.c"
	}
	_state_0:
#line 354 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = geary_account_information_get_write_lock (_data_->info);
#line 354 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 354 "../src/client/accounts/accounts-manager.vala"
	_data_->_state_ = 1;
#line 354 "../src/client/accounts/accounts-manager.vala"
	geary_nonblocking_mutex_claim_async (_data_->_tmp1_, _data_->cancellable, accounts_manager_save_account_ready, _data_);
#line 354 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 3623 "accounts-manager.c"
	_state_1:
#line 354 "../src/client/accounts/accounts-manager.vala"
	_data_->token = geary_nonblocking_mutex_claim_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error0_);
#line 354 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 354 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 354 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 354 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 3635 "accounts-manager.c"
	}
#line 356 "../src/client/accounts/accounts-manager.vala"
	_data_->thrown = NULL;
#line 3639 "accounts-manager.c"
	{
#line 358 "../src/client/accounts/accounts-manager.vala"
		_data_->_state_ = 2;
#line 358 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_save_account_locked (_data_->self, _data_->info, _data_->cancellable, accounts_manager_save_account_ready, _data_);
#line 358 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 3647 "accounts-manager.c"
		_state_2:
#line 358 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_save_account_locked_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 358 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3653 "accounts-manager.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 357 "../src/client/accounts/accounts-manager.vala"
		_data_->err = _data_->_inner_error0_;
#line 357 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error0_ = NULL;
#line 360 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp2_ = _data_->err;
#line 360 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp3_ = _g_error_copy0 (_data_->_tmp2_);
#line 360 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (_data_->thrown);
#line 360 "../src/client/accounts/accounts-manager.vala"
		_data_->thrown = _data_->_tmp3_;
#line 357 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (_data_->err);
#line 3674 "accounts-manager.c"
	}
	__finally0:
#line 357 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 357 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 357 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (_data_->thrown);
#line 357 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 357 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 3687 "accounts-manager.c"
	}
#line 363 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp4_ = geary_account_information_get_write_lock (_data_->info);
#line 363 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 363 "../src/client/accounts/accounts-manager.vala"
	geary_nonblocking_mutex_release (_data_->_tmp5_, &_data_->token, &_data_->_inner_error0_);
#line 363 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 363 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 363 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (_data_->thrown);
#line 363 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 363 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 3705 "accounts-manager.c"
	}
#line 365 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp6_ = _data_->thrown;
#line 365 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp6_ != NULL) {
#line 366 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp7_ = _data_->thrown;
#line 366 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp8_ = _g_error_copy0 (_data_->_tmp7_);
#line 366 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error0_ = _data_->_tmp8_;
#line 366 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 366 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (_data_->thrown);
#line 366 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 366 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 3725 "accounts-manager.c"
	}
#line 348 "../src/client/accounts/accounts-manager.vala"
	_g_error_free0 (_data_->thrown);
#line 348 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 348 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 348 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 348 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3737 "accounts-manager.c"
		}
	}
#line 348 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 348 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 3744 "accounts-manager.c"
}

static void
accounts_manager_update_local_credentials_data_free (gpointer _data)
{
	AccountsManagerUpdateLocalCredentialsData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->old_service);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->new_service);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerUpdateLocalCredentialsData, _data_);
#line 3764 "accounts-manager.c"
}

void
accounts_manager_update_local_credentials (AccountsManager* self,
                                           GearyAccountInformation* account,
                                           GearyServiceInformation* old_service,
                                           GearyServiceInformation* new_service,
                                           GCancellable* cancellable,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	AccountsManagerUpdateLocalCredentialsData* _data_;
	AccountsManager* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GearyServiceInformation* _tmp2_;
	GearyServiceInformation* _tmp3_;
	GCancellable* _tmp4_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (old_service, GEARY_TYPE_SERVICE_INFORMATION));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_service, GEARY_TYPE_SERVICE_INFORMATION));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerUpdateLocalCredentialsData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_update_local_credentials_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->account = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (old_service);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->old_service);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->old_service = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = _g_object_ref0 (new_service);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->new_service);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->new_service = _tmp3_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp4_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_update_local_credentials_co (_data_);
#line 3828 "accounts-manager.c"
}

void
accounts_manager_update_local_credentials_finish (AccountsManager* self,
                                                  GAsyncResult* _res_,
                                                  GError** error)
{
	AccountsManagerUpdateLocalCredentialsData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 3843 "accounts-manager.c"
	}
}

/** Updates a local account service's credentials. */
static void
accounts_manager_update_local_credentials_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	AccountsManagerUpdateLocalCredentialsData* _data_;
#line 379 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 379 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 379 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 379 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_update_local_credentials_co (_data_);
#line 3862 "accounts-manager.c"
}

static gboolean
accounts_manager_update_local_credentials_co (AccountsManagerUpdateLocalCredentialsData* _data_)
{
#line 371 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 371 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 3872 "accounts-manager.c"
		goto _state_0;
#line 371 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 3876 "accounts-manager.c"
		goto _state_1;
#line 371 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 3880 "accounts-manager.c"
		goto _state_2;
		default:
#line 371 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 3885 "accounts-manager.c"
	}
	_state_0:
#line 376 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = geary_account_information_get_mediator (_data_->account);
#line 376 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 376 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp2_ = _g_object_ref0 (IS_SECRET_MEDIATOR (_data_->_tmp1_) ? ((SecretMediator*) _data_->_tmp1_) : NULL);
#line 376 "../src/client/accounts/accounts-manager.vala"
	_data_->mediator = _data_->_tmp2_;
#line 377 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp3_ = _data_->mediator;
#line 377 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp3_ != NULL) {
#line 378 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp4_ = geary_service_information_get_credentials (_data_->new_service);
#line 378 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 378 "../src/client/accounts/accounts-manager.vala"
		if (_data_->_tmp5_ != NULL) {
#line 379 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp6_ = _data_->mediator;
#line 379 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 1;
#line 379 "../src/client/accounts/accounts-manager.vala"
			secret_mediator_update_token (_data_->_tmp6_, _data_->account, _data_->new_service, _data_->cancellable, accounts_manager_update_local_credentials_ready, _data_);
#line 379 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 3914 "accounts-manager.c"
			_state_1:
#line 379 "../src/client/accounts/accounts-manager.vala"
			secret_mediator_update_token_finish (_data_->_tmp6_, _data_->_res_, &_data_->_inner_error0_);
#line 379 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 379 "../src/client/accounts/accounts-manager.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 379 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->mediator);
#line 379 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 379 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 3928 "accounts-manager.c"
			}
		}
#line 382 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp8_ = geary_service_information_get_credentials (_data_->old_service);
#line 382 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 382 "../src/client/accounts/accounts-manager.vala"
		if (_data_->_tmp9_ != NULL) {
#line 383 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp11_ = geary_service_information_get_credentials (_data_->new_service);
#line 383 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp12_ = _data_->_tmp11_;
#line 383 "../src/client/accounts/accounts-manager.vala"
			if (_data_->_tmp12_ == NULL) {
#line 383 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp10_ = TRUE;
#line 3945 "accounts-manager.c"
			} else {
#line 384 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp14_ = geary_service_information_get_credentials (_data_->new_service);
#line 384 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp15_ = _data_->_tmp14_;
#line 384 "../src/client/accounts/accounts-manager.vala"
				if (_data_->_tmp15_ != NULL) {
#line 385 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp16_ = geary_service_information_get_credentials (_data_->old_service);
#line 385 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp17_ = _data_->_tmp16_;
#line 385 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp18_ = geary_credentials_get_user (_data_->_tmp17_);
#line 385 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp19_ = _data_->_tmp18_;
#line 385 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp20_ = geary_service_information_get_credentials (_data_->old_service);
#line 385 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp21_ = _data_->_tmp20_;
#line 385 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp22_ = geary_credentials_get_user (_data_->_tmp21_);
#line 385 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp23_ = _data_->_tmp22_;
#line 385 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp13_ = g_strcmp0 (_data_->_tmp19_, _data_->_tmp23_) != 0;
#line 3971 "accounts-manager.c"
				} else {
#line 384 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp13_ = FALSE;
#line 3975 "accounts-manager.c"
				}
#line 384 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp10_ = _data_->_tmp13_;
#line 3979 "accounts-manager.c"
			}
#line 383 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp7_ = _data_->_tmp10_;
#line 3983 "accounts-manager.c"
		} else {
#line 382 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp7_ = FALSE;
#line 3987 "accounts-manager.c"
		}
#line 382 "../src/client/accounts/accounts-manager.vala"
		if (_data_->_tmp7_) {
#line 386 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp24_ = _data_->mediator;
#line 386 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 2;
#line 386 "../src/client/accounts/accounts-manager.vala"
			secret_mediator_clear_token (_data_->_tmp24_, _data_->account, _data_->old_service, _data_->cancellable, accounts_manager_update_local_credentials_ready, _data_);
#line 386 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 3999 "accounts-manager.c"
			_state_2:
#line 386 "../src/client/accounts/accounts-manager.vala"
			secret_mediator_clear_token_finish (_data_->_tmp24_, _data_->_res_, &_data_->_inner_error0_);
#line 386 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 386 "../src/client/accounts/accounts-manager.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 386 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->mediator);
#line 386 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 386 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 4013 "accounts-manager.c"
			}
		}
	}
#line 371 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->mediator);
#line 371 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 371 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 371 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 371 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4027 "accounts-manager.c"
		}
	}
#line 371 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 371 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 4034 "accounts-manager.c"
}

/**
     * Determines if an account is a GOA account or not.
     */
gboolean
accounts_manager_is_goa_account (AccountsManager* self,
                                 GearyAccountInformation* account)
{
	GearyCredentialsMediator* _tmp0_;
	GearyCredentialsMediator* _tmp1_;
	gboolean result;
#line 394 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), FALSE);
#line 394 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION), FALSE);
#line 395 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = geary_account_information_get_mediator (account);
#line 395 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _tmp0_;
#line 395 "../src/client/accounts/accounts-manager.vala"
	result = IS_GOA_MEDIATOR (_tmp1_);
#line 395 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 4059 "accounts-manager.c"
}

static void
accounts_manager_add_goa_account_data_free (gpointer _data)
{
	AccountsManagerAddGoaAccountData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerAddGoaAccountData, _data_);
#line 4073 "accounts-manager.c"
}

void
accounts_manager_add_goa_account (AccountsManager* self,
                                  GearyServiceProvider type,
                                  GCancellable* cancellable,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	AccountsManagerAddGoaAccountData* _data_;
	AccountsManager* _tmp0_;
	GCancellable* _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerAddGoaAccountData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_add_goa_account_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->type = type;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_add_goa_account_co (_data_);
#line 4110 "accounts-manager.c"
}

void
accounts_manager_add_goa_account_finish (AccountsManager* self,
                                         GAsyncResult* _res_,
                                         GError** error)
{
	AccountsManagerAddGoaAccountData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 4125 "accounts-manager.c"
	}
}

/**
     * Opens GNOME Settings to add an account of a particular type.
     *
     * Throws an error if it was not possible to open GNOME Settings,
     * or if the given type is not supported for by GOA.
     */
static void
accounts_manager_add_goa_account_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_)
{
	AccountsManagerAddGoaAccountData* _data_;
#line 409 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 409 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 409 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 409 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_add_goa_account_co (_data_);
#line 4149 "accounts-manager.c"
}

static gboolean
accounts_manager_add_goa_account_co (AccountsManagerAddGoaAccountData* _data_)
{
#line 404 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 404 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 4159 "accounts-manager.c"
		goto _state_0;
#line 404 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 4163 "accounts-manager.c"
		goto _state_1;
#line 404 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 4167 "accounts-manager.c"
		goto _state_2;
		default:
#line 404 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 4172 "accounts-manager.c"
	}
	_state_0:
#line 407 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->type) {
#line 407 "../src/client/accounts/accounts-manager.vala"
		case GEARY_SERVICE_PROVIDER_GMAIL:
#line 4179 "accounts-manager.c"
		{
#line 409 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 1;
#line 409 "../src/client/accounts/accounts-manager.vala"
			accounts_manager_open_goa_settings (_data_->self, "add", "google", _data_->cancellable, accounts_manager_add_goa_account_ready, _data_);
#line 409 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 4187 "accounts-manager.c"
			_state_1:
#line 409 "../src/client/accounts/accounts-manager.vala"
			accounts_manager_open_goa_settings_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 409 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 409 "../src/client/accounts/accounts-manager.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 409 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 409 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 4199 "accounts-manager.c"
			}
#line 410 "../src/client/accounts/accounts-manager.vala"
			break;
#line 4203 "accounts-manager.c"
		}
#line 407 "../src/client/accounts/accounts-manager.vala"
		case GEARY_SERVICE_PROVIDER_OUTLOOK:
#line 4207 "accounts-manager.c"
		{
#line 413 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 2;
#line 413 "../src/client/accounts/accounts-manager.vala"
			accounts_manager_open_goa_settings (_data_->self, "add", "windows_live", _data_->cancellable, accounts_manager_add_goa_account_ready, _data_);
#line 413 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 4215 "accounts-manager.c"
			_state_2:
#line 413 "../src/client/accounts/accounts-manager.vala"
			accounts_manager_open_goa_settings_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 413 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 413 "../src/client/accounts/accounts-manager.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 413 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 413 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 4227 "accounts-manager.c"
			}
#line 414 "../src/client/accounts/accounts-manager.vala"
			break;
#line 4231 "accounts-manager.c"
		}
		default:
		{
#line 417 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp0_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_SUPPORTED, "Not supported for GOA");
#line 417 "../src/client/accounts/accounts-manager.vala"
			_data_->_inner_error0_ = _data_->_tmp0_;
#line 417 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 417 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 417 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 4245 "accounts-manager.c"
		}
	}
#line 404 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 404 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 404 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 404 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4256 "accounts-manager.c"
		}
	}
#line 404 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 404 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 4263 "accounts-manager.c"
}

static void
accounts_manager_show_goa_account_data_free (gpointer _data)
{
	AccountsManagerShowGoaAccountData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerShowGoaAccountData, _data_);
#line 4279 "accounts-manager.c"
}

void
accounts_manager_show_goa_account (AccountsManager* self,
                                   GearyAccountInformation* account,
                                   GCancellable* cancellable,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	AccountsManagerShowGoaAccountData* _data_;
	AccountsManager* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerShowGoaAccountData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_show_goa_account_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->account = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_show_goa_account_co (_data_);
#line 4323 "accounts-manager.c"
}

void
accounts_manager_show_goa_account_finish (AccountsManager* self,
                                          GAsyncResult* _res_,
                                          GError** error)
{
	AccountsManagerShowGoaAccountData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 4338 "accounts-manager.c"
	}
}

/**
     * Opens GOA settings for the given account in GNOME Settings.
     *
     * Throws an error if it was not possible to open GNOME Settings,
     * or if the given account is not backed by GOA.
     */
static void
accounts_manager_show_goa_account_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_)
{
	AccountsManagerShowGoaAccountData* _data_;
#line 434 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 434 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 434 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 434 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_show_goa_account_co (_data_);
#line 4362 "accounts-manager.c"
}

static gboolean
accounts_manager_show_goa_account_co (AccountsManagerShowGoaAccountData* _data_)
{
#line 427 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 427 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 4372 "accounts-manager.c"
		goto _state_0;
#line 427 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 4376 "accounts-manager.c"
		goto _state_1;
		default:
#line 427 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 4381 "accounts-manager.c"
	}
	_state_0:
#line 430 "../src/client/accounts/accounts-manager.vala"
	if (!accounts_manager_is_goa_account (_data_->self, _data_->account)) {
#line 431 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp0_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_SUPPORTED, "Not a GOA Account");
#line 431 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error0_ = _data_->_tmp0_;
#line 431 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 431 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 431 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 4396 "accounts-manager.c"
	}
#line 434 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = geary_account_information_get_id (_data_->account);
#line 434 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 434 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp3_ = accounts_manager_to_goa_id (_data_->self, _data_->_tmp2_);
#line 434 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 434 "../src/client/accounts/accounts-manager.vala"
	_data_->_state_ = 1;
#line 434 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_open_goa_settings (_data_->self, _data_->_tmp4_, NULL, _data_->cancellable, accounts_manager_show_goa_account_ready, _data_);
#line 434 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 4412 "accounts-manager.c"
	_state_1:
#line 434 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_open_goa_settings_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 434 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->_tmp4_);
#line 434 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 434 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 434 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 434 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 4426 "accounts-manager.c"
	}
#line 427 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 427 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 427 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 427 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4436 "accounts-manager.c"
		}
	}
#line 427 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 427 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 4443 "accounts-manager.c"
}

static void
accounts_manager_next_id_data_free (gpointer _data)
{
	AccountsManagerNextIdData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->result);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerNextIdData, _data_);
#line 4459 "accounts-manager.c"
}

static void
accounts_manager_next_id (AccountsManager* self,
                          GCancellable* cancellable,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_)
{
	AccountsManagerNextIdData* _data_;
	AccountsManager* _tmp0_;
	GCancellable* _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerNextIdData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_next_id_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_next_id_co (_data_);
#line 4493 "accounts-manager.c"
}

static gchar*
accounts_manager_next_id_finish (AccountsManager* self,
                                 GAsyncResult* _res_)
{
	gchar* result;
	AccountsManagerNextIdData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return NULL;
#line 4508 "accounts-manager.c"
	}
#line 24 "../src/client/accounts/accounts-manager.vala"
	result = _data_->result;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->result = NULL;
#line 24 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 4516 "accounts-manager.c"
}

/** Returns the next id for a new local account. */
static gchar*
__lambda13_ (AccountsManager* self,
             gchar* next,
             gchar* last)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 442 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (next != NULL, NULL);
#line 443 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = g_strdup (last);
#line 443 "../src/client/accounts/accounts-manager.vala"
	_result_ = _tmp0_;
#line 444 "../src/client/accounts/accounts-manager.vala"
	if (g_str_has_prefix (next, ACCOUNTS_MANAGER_LOCAL_ID_PREFIX)) {
#line 4536 "accounts-manager.c"
		const gchar* _tmp1_ = NULL;
		gboolean _tmp2_ = FALSE;
		gchar* _tmp4_;
#line 445 "../src/client/accounts/accounts-manager.vala"
		if (last == NULL) {
#line 445 "../src/client/accounts/accounts-manager.vala"
			_tmp2_ = TRUE;
#line 4544 "accounts-manager.c"
		} else {
			GCompareFunc _tmp3_;
#line 445 "../src/client/accounts/accounts-manager.vala"
			_tmp3_ = ((GCompareFunc) g_strcmp0);
#line 445 "../src/client/accounts/accounts-manager.vala"
			_tmp2_ = _tmp3_ (last, next) < 0;
#line 4551 "accounts-manager.c"
		}
#line 445 "../src/client/accounts/accounts-manager.vala"
		if (_tmp2_) {
#line 445 "../src/client/accounts/accounts-manager.vala"
			_tmp1_ = next;
#line 4557 "accounts-manager.c"
		} else {
#line 445 "../src/client/accounts/accounts-manager.vala"
			_tmp1_ = last;
#line 4561 "accounts-manager.c"
		}
#line 445 "../src/client/accounts/accounts-manager.vala"
		_tmp4_ = g_strdup (_tmp1_);
#line 445 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_result_);
#line 445 "../src/client/accounts/accounts-manager.vala"
		_result_ = _tmp4_;
#line 4569 "accounts-manager.c"
	}
#line 447 "../src/client/accounts/accounts-manager.vala"
	result = _result_;
#line 447 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (next);
#line 447 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (last);
#line 447 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 4579 "accounts-manager.c"
}

static gpointer
___lambda13__gee_fold_func (gpointer g,
                            gpointer a,
                            gpointer self)
{
	gpointer result;
	result = __lambda13_ ((AccountsManager*) self, (gchar*) g, (gchar*) a);
#line 442 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 4591 "accounts-manager.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 4614 "accounts-manager.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 4623 "accounts-manager.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 4642 "accounts-manager.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 4646 "accounts-manager.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 4652 "accounts-manager.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 4662 "accounts-manager.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 4670 "accounts-manager.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 4674 "accounts-manager.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 4680 "accounts-manager.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 4690 "accounts-manager.c"
}

static void
accounts_manager_next_id_ready (GObject* source_object,
                                GAsyncResult* _res_,
                                gpointer _user_data_)
{
	AccountsManagerNextIdData* _data_;
#line 461 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 461 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 461 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 461 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_next_id_co (_data_);
#line 4707 "accounts-manager.c"
}

static gboolean
accounts_manager_next_id_co (AccountsManagerNextIdData* _data_)
{
#line 440 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 440 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 4717 "accounts-manager.c"
		goto _state_0;
#line 440 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 4721 "accounts-manager.c"
		goto _state_1;
#line 440 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 4725 "accounts-manager.c"
		goto _state_2;
		default:
#line 440 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 4730 "accounts-manager.c"
	}
	_state_0:
#line 442 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = _data_->self->priv->accounts;
#line 442 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = gee_map_get_keys (_data_->_tmp0_);
#line 442 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 442 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 442 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp4_ = gee_traversable_fold (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, GEE_TYPE_TRAVERSABLE, GeeTraversable), G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, ___lambda13__gee_fold_func, _data_->self, NULL);
#line 442 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp5_ = (gchar*) _data_->_tmp4_;
#line 442 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->_tmp3_);
#line 442 "../src/client/accounts/accounts-manager.vala"
	_data_->last_account = _data_->_tmp5_;
#line 451 "../src/client/accounts/accounts-manager.vala"
	_data_->next_id = (guint) 1;
#line 452 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp6_ = _data_->last_account;
#line 452 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp6_ != NULL) {
#line 453 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp7_ = _data_->last_account;
#line 453 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp8_ = strlen (ACCOUNTS_MANAGER_LOCAL_ID_PREFIX);
#line 453 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 453 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp10_ = string_substring (_data_->_tmp7_, (glong) _data_->_tmp9_, (glong) -1);
#line 453 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp11_ = _data_->_tmp10_;
#line 453 "../src/client/accounts/accounts-manager.vala"
		_data_->next_id = (guint) (atoi (_data_->_tmp11_) + 1);
#line 453 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->_tmp11_);
#line 4769 "accounts-manager.c"
	}
#line 459 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp12_ = g_strdup_printf (ACCOUNTS_MANAGER_LOCAL_ID_FORMAT, _data_->next_id);
#line 459 "../src/client/accounts/accounts-manager.vala"
	_data_->id = _data_->_tmp12_;
#line 4775 "accounts-manager.c"
	{
#line 461 "../src/client/accounts/accounts-manager.vala"
		while (TRUE) {
#line 461 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp15_ = _data_->self->priv->_config_dir;
#line 461 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp16_ = _data_->id;
#line 461 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp17_ = g_file_get_child (_data_->_tmp15_, _data_->_tmp16_);
#line 461 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp18_ = _data_->_tmp17_;
#line 461 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 1;
#line 461 "../src/client/accounts/accounts-manager.vala"
			geary_files_query_exists_async (_data_->_tmp18_, _data_->cancellable, accounts_manager_next_id_ready, _data_);
#line 461 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 4793 "accounts-manager.c"
			_state_1:
#line 461 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp19_ = geary_files_query_exists_finish (_data_->_res_, &_data_->_inner_error0_);
#line 461 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->_tmp18_);
#line 461 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp14_ = _data_->_tmp19_;
#line 461 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 4803 "accounts-manager.c"
				goto __catch0_g_error;
			}
#line 461 "../src/client/accounts/accounts-manager.vala"
			if (_data_->_tmp14_) {
#line 461 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp13_ = TRUE;
#line 4810 "accounts-manager.c"
			} else {
#line 463 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp21_ = _data_->self->priv->_data_dir;
#line 463 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp22_ = _data_->id;
#line 463 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp23_ = g_file_get_child (_data_->_tmp21_, _data_->_tmp22_);
#line 463 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp24_ = _data_->_tmp23_;
#line 463 "../src/client/accounts/accounts-manager.vala"
				_data_->_state_ = 2;
#line 463 "../src/client/accounts/accounts-manager.vala"
				geary_files_query_exists_async (_data_->_tmp24_, _data_->cancellable, accounts_manager_next_id_ready, _data_);
#line 463 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 4826 "accounts-manager.c"
				_state_2:
#line 463 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp25_ = geary_files_query_exists_finish (_data_->_res_, &_data_->_inner_error0_);
#line 463 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->_tmp24_);
#line 463 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp20_ = _data_->_tmp25_;
#line 463 "../src/client/accounts/accounts-manager.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 4836 "accounts-manager.c"
					goto __catch0_g_error;
				}
#line 463 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp13_ = _data_->_tmp20_;
#line 4841 "accounts-manager.c"
			}
#line 461 "../src/client/accounts/accounts-manager.vala"
			if (!_data_->_tmp13_) {
#line 461 "../src/client/accounts/accounts-manager.vala"
				break;
#line 4847 "accounts-manager.c"
			}
#line 465 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp26_ = _data_->next_id;
#line 465 "../src/client/accounts/accounts-manager.vala"
			_data_->next_id = _data_->_tmp26_ + 1;
#line 466 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp27_ = g_strdup_printf (ACCOUNTS_MANAGER_LOCAL_ID_FORMAT, _data_->next_id);
#line 466 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->id);
#line 466 "../src/client/accounts/accounts-manager.vala"
			_data_->id = _data_->_tmp27_;
#line 4859 "accounts-manager.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 460 "../src/client/accounts/accounts-manager.vala"
		_data_->err = _data_->_inner_error0_;
#line 460 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error0_ = NULL;
#line 470 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp28_ = _data_->err;
#line 470 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp29_ = _data_->_tmp28_->message;
#line 470 "../src/client/accounts/accounts-manager.vala"
		g_debug ("accounts-manager.vala:470: Error checking for a free id on disk: %s", _data_->_tmp29_);
#line 460 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (_data_->err);
#line 4877 "accounts-manager.c"
	}
	__finally0:
#line 460 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 460 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->id);
#line 460 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->last_account);
#line 460 "../src/client/accounts/accounts-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 460 "../src/client/accounts/accounts-manager.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 460 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 460 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 4894 "accounts-manager.c"
	}
#line 473 "../src/client/accounts/accounts-manager.vala"
	_data_->result = _data_->id;
#line 473 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->last_account);
#line 473 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 473 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 473 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 473 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4908 "accounts-manager.c"
		}
	}
#line 473 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 473 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 4915 "accounts-manager.c"
}

static void
accounts_manager_load_account_data_free (gpointer _data)
{
	AccountsManagerLoadAccountData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->id);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->result);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerLoadAccountData, _data_);
#line 4933 "accounts-manager.c"
}

static void
accounts_manager_load_account (AccountsManager* self,
                               const gchar* id,
                               GCancellable* cancellable,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	AccountsManagerLoadAccountData* _data_;
	AccountsManager* _tmp0_;
	gchar* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (id != NULL);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerLoadAccountData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_load_account_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = g_strdup (id);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->id);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->id = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_load_account_co (_data_);
#line 4977 "accounts-manager.c"
}

static GearyAccountInformation*
accounts_manager_load_account_finish (AccountsManager* self,
                                      GAsyncResult* _res_,
                                      GError** error)
{
	GearyAccountInformation* result;
	AccountsManagerLoadAccountData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return NULL;
#line 4993 "accounts-manager.c"
	}
#line 24 "../src/client/accounts/accounts-manager.vala"
	result = _data_->result;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->result = NULL;
#line 24 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 5001 "accounts-manager.c"
}

/**
     * Loads an account info from a config directory.
     *
     * Throws an error if the config file was not found, could not be
     * parsed, or doesn't have all required fields.
     */
static void
accounts_manager_load_account_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_)
{
	AccountsManagerLoadAccountData* _data_;
#line 493 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 493 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 493 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 493 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_load_account_co (_data_);
#line 5024 "accounts-manager.c"
}

static GearyServiceProvider*
_geary_service_provider_dup (GearyServiceProvider* self)
{
	GearyServiceProvider* dup;
#line 537 "../src/client/accounts/accounts-manager.vala"
	dup = g_new0 (GearyServiceProvider, 1);
#line 537 "../src/client/accounts/accounts-manager.vala"
	memcpy (dup, self, sizeof (GearyServiceProvider));
#line 537 "../src/client/accounts/accounts-manager.vala"
	return dup;
#line 5037 "accounts-manager.c"
}

static gpointer
__geary_service_provider_dup0 (gpointer self)
{
#line 537 "../src/client/accounts/accounts-manager.vala"
	return self ? _geary_service_provider_dup (self) : NULL;
#line 5045 "accounts-manager.c"
}

static gboolean
accounts_manager_load_account_co (AccountsManagerLoadAccountData* _data_)
{
#line 482 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 482 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 5055 "accounts-manager.c"
		goto _state_0;
#line 482 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 5059 "accounts-manager.c"
		goto _state_1;
#line 482 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 5063 "accounts-manager.c"
		goto _state_2;
		default:
#line 482 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 5068 "accounts-manager.c"
	}
	_state_0:
#line 485 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = _data_->self->priv->_config_dir;
#line 485 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = g_file_get_child (_data_->_tmp0_, _data_->id);
#line 485 "../src/client/accounts/accounts-manager.vala"
	_data_->config_dir = _data_->_tmp1_;
#line 486 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp2_ = _data_->self->priv->_data_dir;
#line 486 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp3_ = g_file_get_child (_data_->_tmp2_, _data_->id);
#line 486 "../src/client/accounts/accounts-manager.vala"
	_data_->data_dir = _data_->_tmp3_;
#line 488 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp4_ = _data_->config_dir;
#line 488 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp5_ = g_file_get_child (_data_->_tmp4_, ACCOUNTS_MANAGER_SETTINGS_FILENAME);
#line 488 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 488 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp7_ = geary_config_file_new (_data_->_tmp6_);
#line 488 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 488 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->_tmp6_);
#line 488 "../src/client/accounts/accounts-manager.vala"
	_data_->config = _data_->_tmp8_;
#line 5097 "accounts-manager.c"
	{
#line 493 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp9_ = _data_->config;
#line 493 "../src/client/accounts/accounts-manager.vala"
		_data_->_state_ = 1;
#line 493 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_load (_data_->_tmp9_, _data_->cancellable, accounts_manager_load_account_ready, _data_);
#line 493 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 5107 "accounts-manager.c"
		_state_1:
#line 493 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_load_finish (_data_->_tmp9_, _data_->_res_, &_data_->_inner_error0_);
#line 493 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 493 "../src/client/accounts/accounts-manager.vala"
			if (_data_->_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 5115 "accounts-manager.c"
				goto __catch0_g_key_file_error;
			}
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
#line 492 "../src/client/accounts/accounts-manager.vala"
		_data_->err = _data_->_inner_error0_;
#line 492 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error0_ = NULL;
#line 495 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp10_ = _data_->err;
#line 495 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp11_ = _data_->_tmp10_->message;
#line 495 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp12_ = g_error_new_literal (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_SYNTAX, _data_->_tmp11_);
#line 495 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error0_ = _data_->_tmp12_;
#line 495 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (_data_->err);
#line 5138 "accounts-manager.c"
		goto __finally0;
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 492 "../src/client/accounts/accounts-manager.vala"
		_data_->_vala1_err = _data_->_inner_error0_;
#line 492 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error0_ = NULL;
#line 497 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp13_ = _data_->_vala1_err;
#line 497 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp14_ = _data_->_tmp13_->message;
#line 497 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp15_ = g_error_new_literal (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_IO, _data_->_tmp14_);
#line 497 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error0_ = _data_->_tmp15_;
#line 497 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (_data_->_vala1_err);
#line 5158 "accounts-manager.c"
		goto __finally0;
	}
	__finally0:
#line 492 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 492 "../src/client/accounts/accounts-manager.vala"
		if (_data_->_inner_error0_->domain == ACCOUNTS_CONFIG_ERROR) {
#line 492 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 492 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_unref0 (_data_->config);
#line 492 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->data_dir);
#line 492 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->config_dir);
#line 492 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 492 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 5178 "accounts-manager.c"
		} else {
#line 492 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_unref0 (_data_->config);
#line 492 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->data_dir);
#line 492 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->config_dir);
#line 492 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 492 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 492 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 492 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 5194 "accounts-manager.c"
		}
	}
#line 500 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp16_ = _data_->config;
#line 500 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp17_ = geary_config_file_get_group (_data_->_tmp16_, ACCOUNTS_MANAGER_GROUP_METADATA);
#line 500 "../src/client/accounts/accounts-manager.vala"
	_data_->metadata_config = _data_->_tmp17_;
#line 502 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp18_ = _data_->metadata_config;
#line 502 "../src/client/accounts/accounts-manager.vala"
	_data_->version = geary_config_file_group_get_int (_data_->_tmp18_, ACCOUNTS_MANAGER_METADATA_VERSION, 0);
#line 503 "../src/client/accounts/accounts-manager.vala"
	_data_->status = ACCOUNTS_MANAGER_STATUS_ENABLED;
#line 5209 "accounts-manager.c"
	{
#line 505 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp20_ = _data_->metadata_config;
#line 505 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp21_ = accounts_manager_status_to_value (_data_->status);
#line 505 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp22_ = _data_->_tmp21_;
#line 505 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp23_ = geary_config_file_group_get_string (_data_->_tmp20_, ACCOUNTS_MANAGER_METADATA_STATUS, _data_->_tmp22_);
#line 505 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp24_ = _data_->_tmp23_;
#line 505 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp25_ = accounts_manager_status_for_value (_data_->_tmp24_, &_data_->_inner_error0_);
#line 505 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->_tmp24_);
#line 505 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->_tmp22_);
#line 505 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp19_ = _data_->_tmp25_;
#line 505 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 505 "../src/client/accounts/accounts-manager.vala"
			if (_data_->_inner_error0_->domain == GEARY_ENGINE_ERROR) {
#line 5233 "accounts-manager.c"
				goto __catch1_geary_engine_error;
			}
#line 505 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (_data_->metadata_config);
#line 505 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_unref0 (_data_->config);
#line 505 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->data_dir);
#line 505 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->config_dir);
#line 505 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 505 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 505 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 505 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 5252 "accounts-manager.c"
		}
#line 505 "../src/client/accounts/accounts-manager.vala"
		_data_->status = _data_->_tmp19_;
#line 5256 "accounts-manager.c"
	}
	goto __finally1;
	__catch1_geary_engine_error:
	{
#line 504 "../src/client/accounts/accounts-manager.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 510 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp26_ = g_error_new (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_SYNTAX, "%s: Invalid status value", _data_->id);
#line 510 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error0_ = _data_->_tmp26_;
#line 5267 "accounts-manager.c"
		goto __finally1;
	}
	__finally1:
#line 504 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 504 "../src/client/accounts/accounts-manager.vala"
		if (_data_->_inner_error0_->domain == ACCOUNTS_CONFIG_ERROR) {
#line 504 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 504 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (_data_->metadata_config);
#line 504 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_unref0 (_data_->config);
#line 504 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->data_dir);
#line 504 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->config_dir);
#line 504 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 504 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 5289 "accounts-manager.c"
		} else {
#line 504 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (_data_->metadata_config);
#line 504 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_unref0 (_data_->config);
#line 504 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->data_dir);
#line 504 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->config_dir);
#line 504 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 504 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 504 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 504 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 5307 "accounts-manager.c"
		}
	}
#line 513 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp27_ = _data_->metadata_config;
#line 513 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp28_ = geary_config_file_group_get_string (_data_->_tmp27_, ACCOUNTS_MANAGER_METADATA_GOA, NULL);
#line 513 "../src/client/accounts/accounts-manager.vala"
	_data_->goa_id = _data_->_tmp28_;
#line 514 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp29_ = _data_->goa_id;
#line 514 "../src/client/accounts/accounts-manager.vala"
	_data_->is_goa = _data_->_tmp29_ != NULL;
#line 519 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp31_ = _data_->goa_id;
#line 519 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp31_ == NULL) {
#line 519 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp30_ = g_str_has_prefix (_data_->id, ACCOUNTS_MANAGER_GOA_ID_PREFIX);
#line 5326 "accounts-manager.c"
	} else {
#line 519 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp30_ = FALSE;
#line 5330 "accounts-manager.c"
	}
#line 519 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp30_) {
#line 520 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp32_ = accounts_manager_to_goa_id (_data_->self, _data_->id);
#line 520 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->goa_id);
#line 520 "../src/client/accounts/accounts-manager.vala"
		_data_->goa_id = _data_->_tmp32_;
#line 521 "../src/client/accounts/accounts-manager.vala"
		_data_->is_goa = TRUE;
#line 5342 "accounts-manager.c"
	}
#line 524 "../src/client/accounts/accounts-manager.vala"
	_data_->goa_handle = NULL;
#line 525 "../src/client/accounts/accounts-manager.vala"
	_data_->goa_mediator = NULL;
#line 526 "../src/client/accounts/accounts-manager.vala"
	_data_->default_provider = NULL;
#line 527 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp33_ = _data_->self->priv->local_mediator;
#line 527 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp34_ = _g_object_ref0 (_data_->_tmp33_);
#line 527 "../src/client/accounts/accounts-manager.vala"
	_data_->mediator = _data_->_tmp34_;
#line 529 "../src/client/accounts/accounts-manager.vala"
	if (_data_->is_goa) {
#line 530 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp35_ = _data_->self->priv->goa_service;
#line 530 "../src/client/accounts/accounts-manager.vala"
		if (_data_->_tmp35_ == NULL) {
#line 531 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp36_ = g_error_new_literal (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_MANAGEMENT, "GOA service not available");
#line 531 "../src/client/accounts/accounts-manager.vala"
			_data_->_inner_error0_ = _data_->_tmp36_;
#line 531 "../src/client/accounts/accounts-manager.vala"
			if (_data_->_inner_error0_->domain == ACCOUNTS_CONFIG_ERROR) {
#line 531 "../src/client/accounts/accounts-manager.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 531 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->mediator);
#line 531 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->default_provider);
#line 531 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_mediator);
#line 531 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_handle);
#line 531 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->goa_id);
#line 531 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (_data_->metadata_config);
#line 531 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_unref0 (_data_->config);
#line 531 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->data_dir);
#line 531 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->config_dir);
#line 531 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 531 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 5392 "accounts-manager.c"
			} else {
#line 531 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->mediator);
#line 531 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->default_provider);
#line 531 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_mediator);
#line 531 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_handle);
#line 531 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->goa_id);
#line 531 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (_data_->metadata_config);
#line 531 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_unref0 (_data_->config);
#line 531 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->data_dir);
#line 531 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->config_dir);
#line 531 "../src/client/accounts/accounts-manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 531 "../src/client/accounts/accounts-manager.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 531 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 531 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 5420 "accounts-manager.c"
			}
		}
#line 534 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp37_ = _data_->self->priv->goa_service;
#line 534 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp38_ = _data_->goa_id;
#line 534 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp39_ = goa_client_lookup_by_id (_data_->_tmp37_, _data_->_tmp38_);
#line 534 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->goa_handle);
#line 534 "../src/client/accounts/accounts-manager.vala"
		_data_->goa_handle = _data_->_tmp39_;
#line 535 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp40_ = _data_->goa_handle;
#line 535 "../src/client/accounts/accounts-manager.vala"
		if (_data_->_tmp40_ != NULL) {
#line 536 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp41_ = _data_->goa_handle;
#line 536 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp42_ = goa_mediator_new (_data_->_tmp41_);
#line 536 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_mediator);
#line 536 "../src/client/accounts/accounts-manager.vala"
			_data_->goa_mediator = _data_->_tmp42_;
#line 536 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp43_ = _data_->goa_mediator;
#line 536 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp44_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp43_, GEARY_TYPE_CREDENTIALS_MEDIATOR, GearyCredentialsMediator));
#line 536 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 536 "../src/client/accounts/accounts-manager.vala"
			_data_->mediator = _data_->_tmp44_;
#line 537 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp45_ = _data_->goa_mediator;
#line 537 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp46_ = goa_mediator_get_service_provider (_data_->_tmp45_);
#line 537 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp47_ = __geary_service_provider_dup0 (&_data_->_tmp46_);
#line 537 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->default_provider);
#line 537 "../src/client/accounts/accounts-manager.vala"
			_data_->default_provider = _data_->_tmp47_;
#line 5463 "accounts-manager.c"
		} else {
#line 541 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp48_ = _data_->goa_id;
#line 541 "../src/client/accounts/accounts-manager.vala"
			g_info ("accounts-manager.vala:541: %s: GOA account %s has been removed, removi" \
"ng local data", _data_->id, _data_->_tmp48_);
#line 545 "../src/client/accounts/accounts-manager.vala"
			_data_->status = ACCOUNTS_MANAGER_STATUS_REMOVED;
#line 549 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp49_ = GEARY_SERVICE_PROVIDER_OTHER;
#line 549 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp50_ = __geary_service_provider_dup0 (&_data_->_tmp49_);
#line 549 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->default_provider);
#line 549 "../src/client/accounts/accounts-manager.vala"
			_data_->default_provider = _data_->_tmp50_;
#line 5479 "accounts-manager.c"
		}
	}
#line 553 "../src/client/accounts/accounts-manager.vala"
	_data_->accounts = NULL;
#line 554 "../src/client/accounts/accounts-manager.vala"
	_data_->services = NULL;
#line 555 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->version) {
#line 555 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 5490 "accounts-manager.c"
		{
#line 557 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp51_ = accounts_account_config_legacy_new ();
#line 557 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->accounts);
#line 557 "../src/client/accounts/accounts-manager.vala"
			_data_->accounts = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp51_, ACCOUNTS_TYPE_ACCOUNT_CONFIG, AccountsAccountConfig);
#line 558 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp52_ = accounts_service_config_legacy_new ();
#line 558 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->services);
#line 558 "../src/client/accounts/accounts-manager.vala"
			_data_->services = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp52_, ACCOUNTS_TYPE_SERVICE_CONFIG, AccountsServiceConfig);
#line 559 "../src/client/accounts/accounts-manager.vala"
			break;
#line 5506 "accounts-manager.c"
		}
#line 555 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 5510 "accounts-manager.c"
		{
#line 562 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp53_ = accounts_account_config_v1_new (_data_->is_goa);
#line 562 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->accounts);
#line 562 "../src/client/accounts/accounts-manager.vala"
			_data_->accounts = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp53_, ACCOUNTS_TYPE_ACCOUNT_CONFIG, AccountsAccountConfig);
#line 563 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp54_ = accounts_service_config_v1_new ();
#line 563 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->services);
#line 563 "../src/client/accounts/accounts-manager.vala"
			_data_->services = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp54_, ACCOUNTS_TYPE_SERVICE_CONFIG, AccountsServiceConfig);
#line 564 "../src/client/accounts/accounts-manager.vala"
			break;
#line 5526 "accounts-manager.c"
		}
		default:
		{
#line 567 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp55_ = g_error_new (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_VERSION, "Unsupported config version: %d", _data_->version);
#line 567 "../src/client/accounts/accounts-manager.vala"
			_data_->_inner_error0_ = _data_->_tmp55_;
#line 567 "../src/client/accounts/accounts-manager.vala"
			if (_data_->_inner_error0_->domain == ACCOUNTS_CONFIG_ERROR) {
#line 567 "../src/client/accounts/accounts-manager.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 567 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->services);
#line 567 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->accounts);
#line 567 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->mediator);
#line 567 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->default_provider);
#line 567 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_mediator);
#line 567 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_handle);
#line 567 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->goa_id);
#line 567 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (_data_->metadata_config);
#line 567 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_unref0 (_data_->config);
#line 567 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->data_dir);
#line 567 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->config_dir);
#line 567 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 567 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 5564 "accounts-manager.c"
			} else {
#line 567 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->services);
#line 567 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->accounts);
#line 567 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->mediator);
#line 567 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->default_provider);
#line 567 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_mediator);
#line 567 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_handle);
#line 567 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->goa_id);
#line 567 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (_data_->metadata_config);
#line 567 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_unref0 (_data_->config);
#line 567 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->data_dir);
#line 567 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->config_dir);
#line 567 "../src/client/accounts/accounts-manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 567 "../src/client/accounts/accounts-manager.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 567 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 567 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 5596 "accounts-manager.c"
			}
		}
	}
#line 572 "../src/client/accounts/accounts-manager.vala"
	_data_->account = NULL;
#line 5602 "accounts-manager.c"
	{
#line 574 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp57_ = _data_->accounts;
#line 574 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp58_ = _data_->config;
#line 574 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp59_ = _data_->mediator;
#line 574 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp60_ = _data_->default_provider;
#line 574 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp61_ = accounts_manager_get_account_name (_data_->self);
#line 574 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp62_ = _data_->_tmp61_;
#line 574 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp63_ = accounts_account_config_load (_data_->_tmp57_, _data_->_tmp58_, _data_->id, _data_->_tmp59_, _data_->_tmp60_, _data_->_tmp62_, &_data_->_inner_error0_);
#line 574 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp64_ = _data_->_tmp63_;
#line 574 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->_tmp62_);
#line 574 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp56_ = _data_->_tmp64_;
#line 574 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 574 "../src/client/accounts/accounts-manager.vala"
			if (_data_->_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 5628 "accounts-manager.c"
				goto __catch2_g_key_file_error;
			}
			goto __finally2;
		}
#line 574 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp65_ = _data_->_tmp56_;
#line 574 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp56_ = NULL;
#line 574 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->account);
#line 574 "../src/client/accounts/accounts-manager.vala"
		_data_->account = _data_->_tmp65_;
#line 581 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp66_ = _data_->account;
#line 581 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp67_ = _data_->config_dir;
#line 581 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp68_ = _data_->data_dir;
#line 581 "../src/client/accounts/accounts-manager.vala"
		geary_account_information_set_account_directories (_data_->_tmp66_, _data_->_tmp67_, _data_->_tmp68_);
#line 573 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->_tmp56_);
#line 5651 "accounts-manager.c"
	}
	goto __finally2;
	__catch2_g_key_file_error:
	{
#line 573 "../src/client/accounts/accounts-manager.vala"
		_data_->_vala2_err = _data_->_inner_error0_;
#line 573 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error0_ = NULL;
#line 583 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp69_ = _data_->_vala2_err;
#line 583 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp70_ = _data_->_tmp69_->message;
#line 583 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp71_ = g_error_new_literal (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_SYNTAX, _data_->_tmp70_);
#line 583 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error0_ = _data_->_tmp71_;
#line 583 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (_data_->_vala2_err);
#line 5670 "accounts-manager.c"
		goto __finally2;
	}
	__finally2:
#line 573 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 573 "../src/client/accounts/accounts-manager.vala"
		if (_data_->_inner_error0_->domain == ACCOUNTS_CONFIG_ERROR) {
#line 573 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 573 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->account);
#line 573 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->services);
#line 573 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->accounts);
#line 573 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 573 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->default_provider);
#line 573 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_mediator);
#line 573 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_handle);
#line 573 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->goa_id);
#line 573 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (_data_->metadata_config);
#line 573 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_unref0 (_data_->config);
#line 573 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->data_dir);
#line 573 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->config_dir);
#line 573 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 573 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 5708 "accounts-manager.c"
		} else {
#line 573 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->account);
#line 573 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->services);
#line 573 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->accounts);
#line 573 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 573 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->default_provider);
#line 573 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_mediator);
#line 573 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_handle);
#line 573 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->goa_id);
#line 573 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (_data_->metadata_config);
#line 573 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_unref0 (_data_->config);
#line 573 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->data_dir);
#line 573 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->config_dir);
#line 573 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 573 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 573 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 573 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 5742 "accounts-manager.c"
		}
	}
#line 589 "../src/client/accounts/accounts-manager.vala"
	if (_data_->status == ACCOUNTS_MANAGER_STATUS_REMOVED) {
#line 590 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp72_ = _data_->self->priv->removed;
#line 590 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp73_ = _data_->account;
#line 590 "../src/client/accounts/accounts-manager.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp72_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _data_->_tmp73_);
#line 591 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp74_ = g_error_new_literal (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_REMOVED, "Account marked for removal");
#line 591 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error0_ = _data_->_tmp74_;
#line 591 "../src/client/accounts/accounts-manager.vala"
		if (_data_->_inner_error0_->domain == ACCOUNTS_CONFIG_ERROR) {
#line 591 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 591 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->account);
#line 591 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->services);
#line 591 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->accounts);
#line 591 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 591 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->default_provider);
#line 591 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_mediator);
#line 591 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_handle);
#line 591 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->goa_id);
#line 591 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (_data_->metadata_config);
#line 591 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_unref0 (_data_->config);
#line 591 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->data_dir);
#line 591 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->config_dir);
#line 591 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 591 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 5789 "accounts-manager.c"
		} else {
#line 591 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->account);
#line 591 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->services);
#line 591 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->accounts);
#line 591 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 591 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->default_provider);
#line 591 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_mediator);
#line 591 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_handle);
#line 591 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->goa_id);
#line 591 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (_data_->metadata_config);
#line 591 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_unref0 (_data_->config);
#line 591 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->data_dir);
#line 591 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->config_dir);
#line 591 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 591 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 591 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 591 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 5823 "accounts-manager.c"
		}
	}
#line 594 "../src/client/accounts/accounts-manager.vala"
	if (!_data_->is_goa) {
#line 5828 "accounts-manager.c"
		{
#line 596 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp75_ = _data_->services;
#line 596 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp76_ = _data_->config;
#line 596 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp77_ = _data_->account;
#line 596 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp78_ = _data_->account;
#line 596 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp79_ = geary_account_information_get_incoming (_data_->_tmp78_);
#line 596 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp80_ = _data_->_tmp79_;
#line 596 "../src/client/accounts/accounts-manager.vala"
			accounts_service_config_load (_data_->_tmp75_, _data_->_tmp76_, _data_->_tmp77_, _data_->_tmp80_, &_data_->_inner_error0_);
#line 596 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 596 "../src/client/accounts/accounts-manager.vala"
				if (_data_->_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 5848 "accounts-manager.c"
					goto __catch3_g_key_file_error;
				}
				goto __finally3;
			}
#line 597 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp81_ = _data_->services;
#line 597 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp82_ = _data_->config;
#line 597 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp83_ = _data_->account;
#line 597 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp84_ = _data_->account;
#line 597 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp85_ = geary_account_information_get_outgoing (_data_->_tmp84_);
#line 597 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp86_ = _data_->_tmp85_;
#line 597 "../src/client/accounts/accounts-manager.vala"
			accounts_service_config_load (_data_->_tmp81_, _data_->_tmp82_, _data_->_tmp83_, _data_->_tmp86_, &_data_->_inner_error0_);
#line 597 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 597 "../src/client/accounts/accounts-manager.vala"
				if (_data_->_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 5871 "accounts-manager.c"
					goto __catch3_g_key_file_error;
				}
				goto __finally3;
			}
		}
		goto __finally3;
		__catch3_g_key_file_error:
		{
#line 595 "../src/client/accounts/accounts-manager.vala"
			_data_->_vala3_err = _data_->_inner_error0_;
#line 595 "../src/client/accounts/accounts-manager.vala"
			_data_->_inner_error0_ = NULL;
#line 599 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp87_ = _data_->_vala3_err;
#line 599 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp88_ = _data_->_tmp87_->message;
#line 599 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp89_ = g_error_new_literal (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_SYNTAX, _data_->_tmp88_);
#line 599 "../src/client/accounts/accounts-manager.vala"
			_data_->_inner_error0_ = _data_->_tmp89_;
#line 599 "../src/client/accounts/accounts-manager.vala"
			_g_error_free0 (_data_->_vala3_err);
#line 5894 "accounts-manager.c"
			goto __finally3;
		}
		__finally3:
#line 595 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 595 "../src/client/accounts/accounts-manager.vala"
			if (_data_->_inner_error0_->domain == ACCOUNTS_CONFIG_ERROR) {
#line 595 "../src/client/accounts/accounts-manager.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 595 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->account);
#line 595 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->services);
#line 595 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->accounts);
#line 595 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->mediator);
#line 595 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->default_provider);
#line 595 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_mediator);
#line 595 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_handle);
#line 595 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->goa_id);
#line 595 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (_data_->metadata_config);
#line 595 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_unref0 (_data_->config);
#line 595 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->data_dir);
#line 595 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->config_dir);
#line 595 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 595 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 5932 "accounts-manager.c"
			} else {
#line 595 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->account);
#line 595 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->services);
#line 595 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->accounts);
#line 595 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->mediator);
#line 595 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->default_provider);
#line 595 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_mediator);
#line 595 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_handle);
#line 595 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->goa_id);
#line 595 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (_data_->metadata_config);
#line 595 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_unref0 (_data_->config);
#line 595 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->data_dir);
#line 595 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->config_dir);
#line 595 "../src/client/accounts/accounts-manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 595 "../src/client/accounts/accounts-manager.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 595 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 595 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 5966 "accounts-manager.c"
			}
		}
	} else {
#line 602 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp90_ = _data_->account;
#line 602 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp91_ = _data_->goa_mediator;
#line 602 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp92_ = goa_mediator_get_service_label (_data_->_tmp91_);
#line 602 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp93_ = _data_->_tmp92_;
#line 602 "../src/client/accounts/accounts-manager.vala"
		geary_account_information_set_service_label (_data_->_tmp90_, _data_->_tmp93_);
#line 602 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->_tmp93_);
#line 5982 "accounts-manager.c"
		{
#line 604 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp94_ = _data_->goa_mediator;
#line 604 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp95_ = _data_->account;
#line 604 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 2;
#line 604 "../src/client/accounts/accounts-manager.vala"
			goa_mediator_update (_data_->_tmp94_, _data_->_tmp95_, _data_->cancellable, accounts_manager_load_account_ready, _data_);
#line 604 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 5994 "accounts-manager.c"
			_state_2:
#line 604 "../src/client/accounts/accounts-manager.vala"
			goa_mediator_update_finish (_data_->_tmp94_, _data_->_res_, &_data_->_inner_error0_);
#line 604 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 6000 "accounts-manager.c"
				goto __catch4_g_error;
			}
		}
		goto __finally4;
		__catch4_g_error:
		{
#line 603 "../src/client/accounts/accounts-manager.vala"
			_data_->_vala4_err = _data_->_inner_error0_;
#line 603 "../src/client/accounts/accounts-manager.vala"
			_data_->_inner_error0_ = NULL;
#line 606 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp96_ = _data_->_vala4_err;
#line 606 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp97_ = _data_->_tmp96_->message;
#line 606 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp98_ = g_error_new_literal (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_MANAGEMENT, _data_->_tmp97_);
#line 606 "../src/client/accounts/accounts-manager.vala"
			_data_->_inner_error0_ = _data_->_tmp98_;
#line 606 "../src/client/accounts/accounts-manager.vala"
			_g_error_free0 (_data_->_vala4_err);
#line 6021 "accounts-manager.c"
			goto __finally4;
		}
		__finally4:
#line 603 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 603 "../src/client/accounts/accounts-manager.vala"
			if (_data_->_inner_error0_->domain == ACCOUNTS_CONFIG_ERROR) {
#line 603 "../src/client/accounts/accounts-manager.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 603 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->account);
#line 603 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->services);
#line 603 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->accounts);
#line 603 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->mediator);
#line 603 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->default_provider);
#line 603 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_mediator);
#line 603 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_handle);
#line 603 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->goa_id);
#line 603 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (_data_->metadata_config);
#line 603 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_unref0 (_data_->config);
#line 603 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->data_dir);
#line 603 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->config_dir);
#line 603 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 603 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 6059 "accounts-manager.c"
			} else {
#line 603 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->account);
#line 603 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->services);
#line 603 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->accounts);
#line 603 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->mediator);
#line 603 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->default_provider);
#line 603 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_mediator);
#line 603 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_handle);
#line 603 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->goa_id);
#line 603 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (_data_->metadata_config);
#line 603 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_unref0 (_data_->config);
#line 603 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->data_dir);
#line 603 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->config_dir);
#line 603 "../src/client/accounts/accounts-manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 603 "../src/client/accounts/accounts-manager.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 603 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 603 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 6093 "accounts-manager.c"
			}
		}
#line 609 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp99_ = _data_->goa_handle;
#line 609 "../src/client/accounts/accounts-manager.vala"
		if (!accounts_manager_is_valid_goa_account (_data_->self, _data_->_tmp99_)) {
#line 614 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp100_ = _data_->account;
#line 614 "../src/client/accounts/accounts-manager.vala"
			accounts_manager_set_available (_data_->self, _data_->_tmp100_, FALSE);
#line 615 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp101_ = g_error_new_literal (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_UNAVAILABLE, "GOA Mail service not available");
#line 615 "../src/client/accounts/accounts-manager.vala"
			_data_->_inner_error0_ = _data_->_tmp101_;
#line 615 "../src/client/accounts/accounts-manager.vala"
			if (_data_->_inner_error0_->domain == ACCOUNTS_CONFIG_ERROR) {
#line 615 "../src/client/accounts/accounts-manager.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 615 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->account);
#line 615 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->services);
#line 615 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->accounts);
#line 615 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->mediator);
#line 615 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->default_provider);
#line 615 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_mediator);
#line 615 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_handle);
#line 615 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->goa_id);
#line 615 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (_data_->metadata_config);
#line 615 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_unref0 (_data_->config);
#line 615 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->data_dir);
#line 615 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->config_dir);
#line 615 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 615 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 6140 "accounts-manager.c"
			} else {
#line 615 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->account);
#line 615 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->services);
#line 615 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->accounts);
#line 615 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->mediator);
#line 615 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->default_provider);
#line 615 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_mediator);
#line 615 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_handle);
#line 615 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->goa_id);
#line 615 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (_data_->metadata_config);
#line 615 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_unref0 (_data_->config);
#line 615 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->data_dir);
#line 615 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->config_dir);
#line 615 "../src/client/accounts/accounts-manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 615 "../src/client/accounts/accounts-manager.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 615 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 615 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 6174 "accounts-manager.c"
			}
		}
	}
#line 623 "../src/client/accounts/accounts-manager.vala"
	if (_data_->status == ACCOUNTS_MANAGER_STATUS_DISABLED) {
#line 624 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp102_ = _data_->account;
#line 624 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_set_enabled (_data_->self, _data_->_tmp102_, FALSE);
#line 625 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp103_ = g_error_new_literal (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_UNAVAILABLE, "Account disabled");
#line 625 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error0_ = _data_->_tmp103_;
#line 625 "../src/client/accounts/accounts-manager.vala"
		if (_data_->_inner_error0_->domain == ACCOUNTS_CONFIG_ERROR) {
#line 625 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 625 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->account);
#line 625 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->services);
#line 625 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->accounts);
#line 625 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 625 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->default_provider);
#line 625 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_mediator);
#line 625 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_handle);
#line 625 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->goa_id);
#line 625 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (_data_->metadata_config);
#line 625 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_unref0 (_data_->config);
#line 625 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->data_dir);
#line 625 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->config_dir);
#line 625 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 625 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 6220 "accounts-manager.c"
		} else {
#line 625 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->account);
#line 625 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->services);
#line 625 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->accounts);
#line 625 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 625 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->default_provider);
#line 625 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_mediator);
#line 625 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_handle);
#line 625 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->goa_id);
#line 625 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (_data_->metadata_config);
#line 625 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_unref0 (_data_->config);
#line 625 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->data_dir);
#line 625 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->config_dir);
#line 625 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 625 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 625 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 625 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 6254 "accounts-manager.c"
		}
	}
#line 628 "../src/client/accounts/accounts-manager.vala"
	_data_->result = _data_->account;
#line 628 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->services);
#line 628 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->accounts);
#line 628 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->mediator);
#line 628 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->default_provider);
#line 628 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->goa_mediator);
#line 628 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->goa_handle);
#line 628 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->goa_id);
#line 628 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_group_unref0 (_data_->metadata_config);
#line 628 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_unref0 (_data_->config);
#line 628 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->data_dir);
#line 628 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->config_dir);
#line 628 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 628 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 628 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 628 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 6289 "accounts-manager.c"
		}
	}
#line 628 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 628 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 6296 "accounts-manager.c"
}

static void
accounts_manager_save_account_locked_data_free (gpointer _data)
{
	AccountsManagerSaveAccountLockedData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerSaveAccountLockedData, _data_);
#line 6312 "accounts-manager.c"
}

static void
accounts_manager_save_account_locked (AccountsManager* self,
                                      GearyAccountInformation* account,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	AccountsManagerSaveAccountLockedData* _data_;
	AccountsManager* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerSaveAccountLockedData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_save_account_locked_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->account = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_save_account_locked_co (_data_);
#line 6356 "accounts-manager.c"
}

static void
accounts_manager_save_account_locked_finish (AccountsManager* self,
                                             GAsyncResult* _res_,
                                             GError** error)
{
	AccountsManagerSaveAccountLockedData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 6371 "accounts-manager.c"
	}
}

static void
accounts_manager_save_account_locked_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_)
{
	AccountsManagerSaveAccountLockedData* _data_;
#line 646 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 646 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 646 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 646 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_save_account_locked_co (_data_);
#line 6389 "accounts-manager.c"
}

static gboolean
accounts_manager_save_account_locked_co (AccountsManagerSaveAccountLockedData* _data_)
{
#line 631 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 631 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 6399 "accounts-manager.c"
		goto _state_0;
#line 631 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 6403 "accounts-manager.c"
		goto _state_1;
#line 631 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 6407 "accounts-manager.c"
		goto _state_2;
		default:
#line 631 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 6412 "accounts-manager.c"
	}
	_state_0:
#line 634 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = geary_account_information_get_config_dir (_data_->account);
#line 634 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 634 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp1_ == NULL) {
#line 635 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp2_ = geary_account_information_get_id (_data_->account);
#line 635 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 635 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp4_ = g_error_new (G_IO_ERROR, G_IO_ERROR_NOT_SUPPORTED, "Account %s does not have a config directory", _data_->_tmp3_);
#line 635 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error0_ = _data_->_tmp4_;
#line 635 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 635 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 635 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 6435 "accounts-manager.c"
	}
#line 640 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp5_ = geary_account_information_get_config_dir (_data_->account);
#line 640 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 640 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp7_ = g_file_get_child (_data_->_tmp6_, ACCOUNTS_MANAGER_SETTINGS_FILENAME);
#line 640 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 640 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp9_ = geary_config_file_new (_data_->_tmp8_);
#line 640 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 640 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->_tmp8_);
#line 640 "../src/client/accounts/accounts-manager.vala"
	_data_->config = _data_->_tmp10_;
#line 6453 "accounts-manager.c"
	{
#line 646 "../src/client/accounts/accounts-manager.vala"
		_data_->_state_ = 1;
#line 646 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_load (_data_->config, _data_->cancellable, accounts_manager_save_account_locked_ready, _data_);
#line 646 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 6461 "accounts-manager.c"
		_state_1:
#line 646 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_load_finish (_data_->config, _data_->_res_, &_data_->_inner_error0_);
#line 646 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 6467 "accounts-manager.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 645 "../src/client/accounts/accounts-manager.vala"
		_data_->err = _data_->_inner_error0_;
#line 645 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error0_ = NULL;
#line 649 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp11_ = _data_->err;
#line 649 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp12_ = _data_->_tmp11_->message;
#line 649 "../src/client/accounts/accounts-manager.vala"
		g_debug ("accounts-manager.vala:649: Could not load existing config file: %s", _data_->_tmp12_);
#line 645 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (_data_->err);
#line 6486 "accounts-manager.c"
	}
	__finally0:
#line 645 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 645 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 645 "../src/client/accounts/accounts-manager.vala"
		_geary_config_file_unref0 (_data_->config);
#line 645 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 645 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 6499 "accounts-manager.c"
	}
#line 652 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp13_ = geary_config_file_get_group (_data_->config, ACCOUNTS_MANAGER_GROUP_METADATA);
#line 652 "../src/client/accounts/accounts-manager.vala"
	_data_->metadata_config = _data_->_tmp13_;
#line 654 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp14_ = _data_->metadata_config;
#line 654 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_int (_data_->_tmp14_, ACCOUNTS_MANAGER_METADATA_VERSION, ACCOUNTS_MANAGER_CONFIG_VERSION);
#line 657 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp15_ = _data_->metadata_config;
#line 657 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp16_ = accounts_manager_status_to_value (accounts_manager_get_status (_data_->self, _data_->account));
#line 657 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp17_ = _data_->_tmp16_;
#line 657 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string (_data_->_tmp15_, ACCOUNTS_MANAGER_METADATA_STATUS, _data_->_tmp17_);
#line 657 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->_tmp17_);
#line 661 "../src/client/accounts/accounts-manager.vala"
	_data_->is_goa = accounts_manager_is_goa_account (_data_->self, _data_->account);
#line 662 "../src/client/accounts/accounts-manager.vala"
	if (_data_->is_goa) {
#line 663 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp18_ = _data_->metadata_config;
#line 663 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp19_ = geary_account_information_get_id (_data_->account);
#line 663 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp20_ = _data_->_tmp19_;
#line 663 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp21_ = accounts_manager_to_goa_id (_data_->self, _data_->_tmp20_);
#line 663 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp22_ = _data_->_tmp21_;
#line 663 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_group_set_string (_data_->_tmp18_, ACCOUNTS_MANAGER_METADATA_GOA, _data_->_tmp22_);
#line 663 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->_tmp22_);
#line 6537 "accounts-manager.c"
	}
#line 666 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp23_ = accounts_account_config_v1_new (_data_->is_goa);
#line 666 "../src/client/accounts/accounts-manager.vala"
	_data_->accounts = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp23_, ACCOUNTS_TYPE_ACCOUNT_CONFIG, AccountsAccountConfig);
#line 667 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp24_ = _data_->accounts;
#line 667 "../src/client/accounts/accounts-manager.vala"
	accounts_account_config_save (_data_->_tmp24_, _data_->account, _data_->config);
#line 669 "../src/client/accounts/accounts-manager.vala"
	if (!_data_->is_goa) {
#line 670 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp25_ = accounts_service_config_v1_new ();
#line 670 "../src/client/accounts/accounts-manager.vala"
		_data_->services = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp25_, ACCOUNTS_TYPE_SERVICE_CONFIG, AccountsServiceConfig);
#line 671 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp26_ = _data_->services;
#line 671 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp27_ = geary_account_information_get_incoming (_data_->account);
#line 671 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp28_ = _data_->_tmp27_;
#line 671 "../src/client/accounts/accounts-manager.vala"
		accounts_service_config_save (_data_->_tmp26_, _data_->account, _data_->_tmp28_, _data_->config);
#line 672 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp29_ = _data_->services;
#line 672 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp30_ = geary_account_information_get_outgoing (_data_->account);
#line 672 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp31_ = _data_->_tmp30_;
#line 672 "../src/client/accounts/accounts-manager.vala"
		accounts_service_config_save (_data_->_tmp29_, _data_->account, _data_->_tmp31_, _data_->config);
#line 669 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->services);
#line 6571 "accounts-manager.c"
	}
#line 675 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp32_ = geary_config_file_get_file (_data_->config);
#line 675 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp33_ = _data_->_tmp32_;
#line 675 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp34_ = g_file_get_path (_data_->_tmp33_);
#line 675 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp35_ = _data_->_tmp34_;
#line 675 "../src/client/accounts/accounts-manager.vala"
	g_debug ("accounts-manager.vala:675: Writing config to: %s", _data_->_tmp35_);
#line 675 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->_tmp35_);
#line 676 "../src/client/accounts/accounts-manager.vala"
	_data_->_state_ = 2;
#line 676 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_save (_data_->config, _data_->cancellable, accounts_manager_save_account_locked_ready, _data_);
#line 676 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 6591 "accounts-manager.c"
	_state_2:
#line 676 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_save_finish (_data_->config, _data_->_res_, &_data_->_inner_error0_);
#line 676 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 676 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 676 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->accounts);
#line 676 "../src/client/accounts/accounts-manager.vala"
		_geary_config_file_group_unref0 (_data_->metadata_config);
#line 676 "../src/client/accounts/accounts-manager.vala"
		_geary_config_file_unref0 (_data_->config);
#line 676 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 676 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 6609 "accounts-manager.c"
	}
#line 631 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->accounts);
#line 631 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_group_unref0 (_data_->metadata_config);
#line 631 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_unref0 (_data_->config);
#line 631 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 631 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 631 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 631 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 6625 "accounts-manager.c"
		}
	}
#line 631 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 631 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 6632 "accounts-manager.c"
}

static void
accounts_manager_delete_account_data_free (gpointer _data)
{
	AccountsManagerDeleteAccountData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->info);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerDeleteAccountData, _data_);
#line 6648 "accounts-manager.c"
}

static void
accounts_manager_delete_account (AccountsManager* self,
                                 GearyAccountInformation* info,
                                 GCancellable* cancellable,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	AccountsManagerDeleteAccountData* _data_;
	AccountsManager* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerDeleteAccountData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_delete_account_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (info);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->info);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->info = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_delete_account_co (_data_);
#line 6692 "accounts-manager.c"
}

static void
accounts_manager_delete_account_finish (AccountsManager* self,
                                        GAsyncResult* _res_,
                                        GError** error)
{
	AccountsManagerDeleteAccountData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 6707 "accounts-manager.c"
	}
}

static void
accounts_manager_delete_account_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	AccountsManagerDeleteAccountData* _data_;
#line 688 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 688 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 688 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 688 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_delete_account_co (_data_);
#line 6725 "accounts-manager.c"
}

static gboolean
accounts_manager_delete_account_co (AccountsManagerDeleteAccountData* _data_)
{
#line 679 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 679 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 6735 "accounts-manager.c"
		goto _state_0;
#line 679 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 6739 "accounts-manager.c"
		goto _state_1;
#line 679 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 6743 "accounts-manager.c"
		goto _state_2;
#line 679 "../src/client/accounts/accounts-manager.vala"
		case 3:
#line 6747 "accounts-manager.c"
		goto _state_3;
#line 679 "../src/client/accounts/accounts-manager.vala"
		case 4:
#line 6751 "accounts-manager.c"
		goto _state_4;
		default:
#line 679 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 6756 "accounts-manager.c"
	}
	_state_0:
#line 685 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = geary_account_information_get_mediator (_data_->info);
#line 685 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 685 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp2_ = _g_object_ref0 (IS_SECRET_MEDIATOR (_data_->_tmp1_) ? ((SecretMediator*) _data_->_tmp1_) : NULL);
#line 685 "../src/client/accounts/accounts-manager.vala"
	_data_->mediator = _data_->_tmp2_;
#line 686 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp3_ = _data_->mediator;
#line 686 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp3_ != NULL) {
#line 6771 "accounts-manager.c"
		{
#line 688 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp4_ = _data_->mediator;
#line 688 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp5_ = geary_account_information_get_incoming (_data_->info);
#line 688 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp6_ = _data_->_tmp5_;
#line 688 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 1;
#line 688 "../src/client/accounts/accounts-manager.vala"
			secret_mediator_clear_token (_data_->_tmp4_, _data_->info, _data_->_tmp6_, _data_->cancellable, accounts_manager_delete_account_ready, _data_);
#line 688 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 6785 "accounts-manager.c"
			_state_1:
#line 688 "../src/client/accounts/accounts-manager.vala"
			secret_mediator_clear_token_finish (_data_->_tmp4_, _data_->_res_, &_data_->_inner_error0_);
#line 688 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 6791 "accounts-manager.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 687 "../src/client/accounts/accounts-manager.vala"
			_data_->e = _data_->_inner_error0_;
#line 687 "../src/client/accounts/accounts-manager.vala"
			_data_->_inner_error0_ = NULL;
#line 690 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp7_ = _data_->e;
#line 690 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp8_ = _data_->_tmp7_->message;
#line 690 "../src/client/accounts/accounts-manager.vala"
			g_debug ("accounts-manager.vala:690: Error clearing IMAP password: %s", _data_->_tmp8_);
#line 687 "../src/client/accounts/accounts-manager.vala"
			_g_error_free0 (_data_->e);
#line 6810 "accounts-manager.c"
		}
		__finally0:
#line 687 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 687 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 687 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 687 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 687 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 6823 "accounts-manager.c"
		}
		{
#line 694 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp9_ = _data_->mediator;
#line 694 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp10_ = geary_account_information_get_outgoing (_data_->info);
#line 694 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp11_ = _data_->_tmp10_;
#line 694 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 2;
#line 694 "../src/client/accounts/accounts-manager.vala"
			secret_mediator_clear_token (_data_->_tmp9_, _data_->info, _data_->_tmp11_, _data_->cancellable, accounts_manager_delete_account_ready, _data_);
#line 694 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 6838 "accounts-manager.c"
			_state_2:
#line 694 "../src/client/accounts/accounts-manager.vala"
			secret_mediator_clear_token_finish (_data_->_tmp9_, _data_->_res_, &_data_->_inner_error0_);
#line 694 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 6844 "accounts-manager.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
#line 693 "../src/client/accounts/accounts-manager.vala"
			_data_->_vala1_e = _data_->_inner_error0_;
#line 693 "../src/client/accounts/accounts-manager.vala"
			_data_->_inner_error0_ = NULL;
#line 696 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp12_ = _data_->_vala1_e;
#line 696 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp13_ = _data_->_tmp12_->message;
#line 696 "../src/client/accounts/accounts-manager.vala"
			g_debug ("accounts-manager.vala:696: Error clearing IMAP password: %s", _data_->_tmp13_);
#line 693 "../src/client/accounts/accounts-manager.vala"
			_g_error_free0 (_data_->_vala1_e);
#line 6863 "accounts-manager.c"
		}
		__finally1:
#line 693 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 693 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 693 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 693 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 693 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 6876 "accounts-manager.c"
		}
	}
#line 700 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp14_ = geary_account_information_get_data_dir (_data_->info);
#line 700 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp15_ = _data_->_tmp14_;
#line 700 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp15_ != NULL) {
#line 701 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp16_ = geary_account_information_get_data_dir (_data_->info);
#line 701 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp17_ = _data_->_tmp16_;
#line 701 "../src/client/accounts/accounts-manager.vala"
		_data_->_state_ = 3;
#line 701 "../src/client/accounts/accounts-manager.vala"
		geary_files_recursive_delete_async (_data_->_tmp17_, G_PRIORITY_LOW, _data_->cancellable, accounts_manager_delete_account_ready, _data_);
#line 701 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 6895 "accounts-manager.c"
		_state_3:
#line 701 "../src/client/accounts/accounts-manager.vala"
		geary_files_recursive_delete_finish (_data_->_res_, &_data_->_inner_error0_);
#line 701 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 701 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 701 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 701 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 701 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 6909 "accounts-manager.c"
		}
	}
#line 708 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp18_ = geary_account_information_get_config_dir (_data_->info);
#line 708 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp19_ = _data_->_tmp18_;
#line 708 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp19_ != NULL) {
#line 709 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp20_ = geary_account_information_get_config_dir (_data_->info);
#line 709 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp21_ = _data_->_tmp20_;
#line 709 "../src/client/accounts/accounts-manager.vala"
		_data_->_state_ = 4;
#line 709 "../src/client/accounts/accounts-manager.vala"
		geary_files_recursive_delete_async (_data_->_tmp21_, G_PRIORITY_LOW, _data_->cancellable, accounts_manager_delete_account_ready, _data_);
#line 709 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 6928 "accounts-manager.c"
		_state_4:
#line 709 "../src/client/accounts/accounts-manager.vala"
		geary_files_recursive_delete_finish (_data_->_res_, &_data_->_inner_error0_);
#line 709 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 709 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 709 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 709 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 709 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 6942 "accounts-manager.c"
		}
	}
#line 679 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->mediator);
#line 679 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 679 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 679 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 679 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 6955 "accounts-manager.c"
		}
	}
#line 679 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 679 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 6962 "accounts-manager.c"
}

static inline AccountsManagerAccountState*
accounts_manager_lookup_state (AccountsManager* self,
                               GearyAccountInformation* account)
{
	AccountsManagerAccountState* state = NULL;
	GeeMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gpointer _tmp3_;
	AccountsManagerAccountState* _tmp4_;
	AccountsManagerAccountState* result;
#line 715 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), NULL);
#line 715 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION), NULL);
#line 716 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->accounts;
#line 716 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = geary_account_information_get_id (account);
#line 716 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _tmp1_;
#line 716 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = gee_map_get (_tmp0_, _tmp2_);
#line 716 "../src/client/accounts/accounts-manager.vala"
	state = (AccountsManagerAccountState*) _tmp3_;
#line 717 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = state;
#line 717 "../src/client/accounts/accounts-manager.vala"
	if (_tmp4_ == NULL) {
#line 6994 "accounts-manager.c"
		AccountsManagerAccountState* _tmp5_;
		GeeMap* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		AccountsManagerAccountState* _tmp9_;
#line 718 "../src/client/accounts/accounts-manager.vala"
		_tmp5_ = accounts_manager_account_state_new (account);
#line 718 "../src/client/accounts/accounts-manager.vala"
		_accounts_manager_account_state_unref0 (state);
#line 718 "../src/client/accounts/accounts-manager.vala"
		state = _tmp5_;
#line 719 "../src/client/accounts/accounts-manager.vala"
		_tmp6_ = self->priv->accounts;
#line 719 "../src/client/accounts/accounts-manager.vala"
		_tmp7_ = geary_account_information_get_id (account);
#line 719 "../src/client/accounts/accounts-manager.vala"
		_tmp8_ = _tmp7_;
#line 719 "../src/client/accounts/accounts-manager.vala"
		_tmp9_ = state;
#line 719 "../src/client/accounts/accounts-manager.vala"
		gee_map_set (_tmp6_, _tmp8_, _tmp9_);
#line 7016 "accounts-manager.c"
	}
#line 721 "../src/client/accounts/accounts-manager.vala"
	result = state;
#line 721 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 7022 "accounts-manager.c"
}

static gboolean
accounts_manager_set_enabled (AccountsManager* self,
                              GearyAccountInformation* account,
                              gboolean is_enabled)
{
	gboolean was_added = FALSE;
	GeeMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	AccountsManagerAccountState* state = NULL;
	AccountsManagerAccountState* _tmp3_;
	AccountsManagerStatus existing_status = 0;
	AccountsManagerAccountState* _tmp4_;
	AccountsManagerStatus _tmp5_;
	AccountsManagerStatus _tmp6_;
	AccountsManagerAccountState* _tmp7_;
	gboolean ret = FALSE;
	gboolean result;
#line 724 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), FALSE);
#line 724 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION), FALSE);
#line 725 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->accounts;
#line 725 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = geary_account_information_get_id (account);
#line 725 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _tmp1_;
#line 725 "../src/client/accounts/accounts-manager.vala"
	was_added = !gee_map_has_key (_tmp0_, _tmp2_);
#line 726 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = accounts_manager_lookup_state (self, account);
#line 726 "../src/client/accounts/accounts-manager.vala"
	state = _tmp3_;
#line 727 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = state;
#line 727 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = accounts_manager_account_state_get_status (_tmp4_);
#line 727 "../src/client/accounts/accounts-manager.vala"
	_tmp6_ = _tmp5_;
#line 727 "../src/client/accounts/accounts-manager.vala"
	existing_status = _tmp6_;
#line 728 "../src/client/accounts/accounts-manager.vala"
	_tmp7_ = state;
#line 728 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_account_state_set_enabled (_tmp7_, is_enabled);
#line 730 "../src/client/accounts/accounts-manager.vala"
	ret = FALSE;
#line 731 "../src/client/accounts/accounts-manager.vala"
	if (was_added) {
#line 7075 "accounts-manager.c"
		AccountsManagerAccountState* _tmp8_;
		GearyAccountInformation* _tmp9_;
		GearyAccountInformation* _tmp10_;
		AccountsManagerAccountState* _tmp11_;
		AccountsManagerStatus _tmp12_;
		AccountsManagerStatus _tmp13_;
#line 732 "../src/client/accounts/accounts-manager.vala"
		_tmp8_ = state;
#line 732 "../src/client/accounts/accounts-manager.vala"
		_tmp9_ = accounts_manager_account_state_get_account (_tmp8_);
#line 732 "../src/client/accounts/accounts-manager.vala"
		_tmp10_ = _tmp9_;
#line 732 "../src/client/accounts/accounts-manager.vala"
		_tmp11_ = state;
#line 732 "../src/client/accounts/accounts-manager.vala"
		_tmp12_ = accounts_manager_account_state_get_status (_tmp11_);
#line 732 "../src/client/accounts/accounts-manager.vala"
		_tmp13_ = _tmp12_;
#line 732 "../src/client/accounts/accounts-manager.vala"
		g_signal_emit (self, accounts_manager_signals[ACCOUNTS_MANAGER_ACCOUNT_ADDED_SIGNAL], 0, _tmp10_, _tmp13_);
#line 733 "../src/client/accounts/accounts-manager.vala"
		g_signal_connect_object (account, "changed", (GCallback) _accounts_manager_on_account_changed_geary_account_information_changed, self, 0);
#line 734 "../src/client/accounts/accounts-manager.vala"
		ret = TRUE;
#line 7100 "accounts-manager.c"
	} else {
		AccountsManagerAccountState* _tmp14_;
		AccountsManagerStatus _tmp15_;
		AccountsManagerStatus _tmp16_;
#line 735 "../src/client/accounts/accounts-manager.vala"
		_tmp14_ = state;
#line 735 "../src/client/accounts/accounts-manager.vala"
		_tmp15_ = accounts_manager_account_state_get_status (_tmp14_);
#line 735 "../src/client/accounts/accounts-manager.vala"
		_tmp16_ = _tmp15_;
#line 735 "../src/client/accounts/accounts-manager.vala"
		if (_tmp16_ != existing_status) {
#line 7113 "accounts-manager.c"
			AccountsManagerAccountState* _tmp17_;
			GearyAccountInformation* _tmp18_;
			GearyAccountInformation* _tmp19_;
			AccountsManagerAccountState* _tmp20_;
			AccountsManagerStatus _tmp21_;
			AccountsManagerStatus _tmp22_;
#line 736 "../src/client/accounts/accounts-manager.vala"
			_tmp17_ = state;
#line 736 "../src/client/accounts/accounts-manager.vala"
			_tmp18_ = accounts_manager_account_state_get_account (_tmp17_);
#line 736 "../src/client/accounts/accounts-manager.vala"
			_tmp19_ = _tmp18_;
#line 736 "../src/client/accounts/accounts-manager.vala"
			_tmp20_ = state;
#line 736 "../src/client/accounts/accounts-manager.vala"
			_tmp21_ = accounts_manager_account_state_get_status (_tmp20_);
#line 736 "../src/client/accounts/accounts-manager.vala"
			_tmp22_ = _tmp21_;
#line 736 "../src/client/accounts/accounts-manager.vala"
			g_signal_emit (self, accounts_manager_signals[ACCOUNTS_MANAGER_ACCOUNT_STATUS_CHANGED_SIGNAL], 0, _tmp19_, _tmp22_);
#line 737 "../src/client/accounts/accounts-manager.vala"
			ret = TRUE;
#line 7136 "accounts-manager.c"
		}
	}
#line 739 "../src/client/accounts/accounts-manager.vala"
	result = ret;
#line 739 "../src/client/accounts/accounts-manager.vala"
	_accounts_manager_account_state_unref0 (state);
#line 739 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 7145 "accounts-manager.c"
}

static gboolean
accounts_manager_set_available (AccountsManager* self,
                                GearyAccountInformation* account,
                                gboolean is_available)
{
	gboolean was_added = FALSE;
	GeeMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	AccountsManagerAccountState* state = NULL;
	AccountsManagerAccountState* _tmp3_;
	AccountsManagerStatus existing_status = 0;
	AccountsManagerAccountState* _tmp4_;
	AccountsManagerStatus _tmp5_;
	AccountsManagerStatus _tmp6_;
	AccountsManagerAccountState* _tmp7_;
	gboolean ret = FALSE;
	gboolean result;
#line 742 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), FALSE);
#line 742 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION), FALSE);
#line 743 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->accounts;
#line 743 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = geary_account_information_get_id (account);
#line 743 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _tmp1_;
#line 743 "../src/client/accounts/accounts-manager.vala"
	was_added = !gee_map_has_key (_tmp0_, _tmp2_);
#line 744 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = accounts_manager_lookup_state (self, account);
#line 744 "../src/client/accounts/accounts-manager.vala"
	state = _tmp3_;
#line 745 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = state;
#line 745 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = accounts_manager_account_state_get_status (_tmp4_);
#line 745 "../src/client/accounts/accounts-manager.vala"
	_tmp6_ = _tmp5_;
#line 745 "../src/client/accounts/accounts-manager.vala"
	existing_status = _tmp6_;
#line 746 "../src/client/accounts/accounts-manager.vala"
	_tmp7_ = state;
#line 746 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_account_state_set_available (_tmp7_, is_available);
#line 748 "../src/client/accounts/accounts-manager.vala"
	ret = FALSE;
#line 749 "../src/client/accounts/accounts-manager.vala"
	if (was_added) {
#line 7198 "accounts-manager.c"
		AccountsManagerAccountState* _tmp8_;
		GearyAccountInformation* _tmp9_;
		GearyAccountInformation* _tmp10_;
		AccountsManagerAccountState* _tmp11_;
		AccountsManagerStatus _tmp12_;
		AccountsManagerStatus _tmp13_;
#line 750 "../src/client/accounts/accounts-manager.vala"
		_tmp8_ = state;
#line 750 "../src/client/accounts/accounts-manager.vala"
		_tmp9_ = accounts_manager_account_state_get_account (_tmp8_);
#line 750 "../src/client/accounts/accounts-manager.vala"
		_tmp10_ = _tmp9_;
#line 750 "../src/client/accounts/accounts-manager.vala"
		_tmp11_ = state;
#line 750 "../src/client/accounts/accounts-manager.vala"
		_tmp12_ = accounts_manager_account_state_get_status (_tmp11_);
#line 750 "../src/client/accounts/accounts-manager.vala"
		_tmp13_ = _tmp12_;
#line 750 "../src/client/accounts/accounts-manager.vala"
		g_signal_emit (self, accounts_manager_signals[ACCOUNTS_MANAGER_ACCOUNT_ADDED_SIGNAL], 0, _tmp10_, _tmp13_);
#line 751 "../src/client/accounts/accounts-manager.vala"
		g_signal_connect_object (account, "changed", (GCallback) _accounts_manager_on_account_changed_geary_account_information_changed, self, 0);
#line 752 "../src/client/accounts/accounts-manager.vala"
		ret = TRUE;
#line 7223 "accounts-manager.c"
	} else {
		AccountsManagerAccountState* _tmp14_;
		AccountsManagerStatus _tmp15_;
		AccountsManagerStatus _tmp16_;
#line 753 "../src/client/accounts/accounts-manager.vala"
		_tmp14_ = state;
#line 753 "../src/client/accounts/accounts-manager.vala"
		_tmp15_ = accounts_manager_account_state_get_status (_tmp14_);
#line 753 "../src/client/accounts/accounts-manager.vala"
		_tmp16_ = _tmp15_;
#line 753 "../src/client/accounts/accounts-manager.vala"
		if (_tmp16_ != existing_status) {
#line 7236 "accounts-manager.c"
			AccountsManagerAccountState* _tmp17_;
			GearyAccountInformation* _tmp18_;
			GearyAccountInformation* _tmp19_;
			AccountsManagerAccountState* _tmp20_;
			AccountsManagerStatus _tmp21_;
			AccountsManagerStatus _tmp22_;
#line 754 "../src/client/accounts/accounts-manager.vala"
			_tmp17_ = state;
#line 754 "../src/client/accounts/accounts-manager.vala"
			_tmp18_ = accounts_manager_account_state_get_account (_tmp17_);
#line 754 "../src/client/accounts/accounts-manager.vala"
			_tmp19_ = _tmp18_;
#line 754 "../src/client/accounts/accounts-manager.vala"
			_tmp20_ = state;
#line 754 "../src/client/accounts/accounts-manager.vala"
			_tmp21_ = accounts_manager_account_state_get_status (_tmp20_);
#line 754 "../src/client/accounts/accounts-manager.vala"
			_tmp22_ = _tmp21_;
#line 754 "../src/client/accounts/accounts-manager.vala"
			g_signal_emit (self, accounts_manager_signals[ACCOUNTS_MANAGER_ACCOUNT_STATUS_CHANGED_SIGNAL], 0, _tmp19_, _tmp22_);
#line 755 "../src/client/accounts/accounts-manager.vala"
			ret = TRUE;
#line 7259 "accounts-manager.c"
		}
	}
#line 757 "../src/client/accounts/accounts-manager.vala"
	result = ret;
#line 757 "../src/client/accounts/accounts-manager.vala"
	_accounts_manager_account_state_unref0 (state);
#line 757 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 7268 "accounts-manager.c"
}

static void
accounts_manager_create_account_dirs_data_free (gpointer _data)
{
	AccountsManagerCreateAccountDirsData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->info);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerCreateAccountDirsData, _data_);
#line 7284 "accounts-manager.c"
}

static void
accounts_manager_create_account_dirs (AccountsManager* self,
                                      GearyAccountInformation* info,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	AccountsManagerCreateAccountDirsData* _data_;
	AccountsManager* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerCreateAccountDirsData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_create_account_dirs_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (info);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->info);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->info = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_create_account_dirs_co (_data_);
#line 7328 "accounts-manager.c"
}

static void
accounts_manager_create_account_dirs_finish (AccountsManager* self,
                                             GAsyncResult* _res_,
                                             GError** error)
{
	AccountsManagerCreateAccountDirsData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 7343 "accounts-manager.c"
	}
}

static void
accounts_manager_create_account_dirs_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_)
{
	AccountsManagerCreateAccountDirsData* _data_;
#line 766 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 766 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 766 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 766 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_create_account_dirs_co (_data_);
#line 7361 "accounts-manager.c"
}

static gboolean
accounts_manager_create_account_dirs_co (AccountsManagerCreateAccountDirsData* _data_)
{
#line 760 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 760 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 7371 "accounts-manager.c"
		goto _state_0;
#line 760 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 7375 "accounts-manager.c"
		goto _state_1;
#line 760 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 7379 "accounts-manager.c"
		goto _state_2;
		default:
#line 760 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 7384 "accounts-manager.c"
	}
	_state_0:
#line 763 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = _data_->self->priv->_config_dir;
#line 763 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = geary_account_information_get_id (_data_->info);
#line 763 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 763 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp3_ = g_file_get_child (_data_->_tmp0_, _data_->_tmp2_);
#line 763 "../src/client/accounts/accounts-manager.vala"
	_data_->config = _data_->_tmp3_;
#line 764 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp4_ = _data_->self->priv->_data_dir;
#line 764 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp5_ = geary_account_information_get_id (_data_->info);
#line 764 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 764 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp7_ = g_file_get_child (_data_->_tmp4_, _data_->_tmp6_);
#line 764 "../src/client/accounts/accounts-manager.vala"
	_data_->data = _data_->_tmp7_;
#line 766 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp8_ = _data_->config;
#line 766 "../src/client/accounts/accounts-manager.vala"
	_data_->_state_ = 1;
#line 766 "../src/client/accounts/accounts-manager.vala"
	geary_files_make_directory_with_parents (_data_->_tmp8_, _data_->cancellable, accounts_manager_create_account_dirs_ready, _data_);
#line 766 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 7415 "accounts-manager.c"
	_state_1:
#line 766 "../src/client/accounts/accounts-manager.vala"
	geary_files_make_directory_with_parents_finish (_data_->_res_, &_data_->_inner_error0_);
#line 766 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 766 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 766 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->data);
#line 766 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->config);
#line 766 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 766 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 7431 "accounts-manager.c"
	}
#line 767 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp9_ = _data_->data;
#line 767 "../src/client/accounts/accounts-manager.vala"
	_data_->_state_ = 2;
#line 767 "../src/client/accounts/accounts-manager.vala"
	geary_files_make_directory_with_parents (_data_->_tmp9_, _data_->cancellable, accounts_manager_create_account_dirs_ready, _data_);
#line 767 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 7441 "accounts-manager.c"
	_state_2:
#line 767 "../src/client/accounts/accounts-manager.vala"
	geary_files_make_directory_with_parents_finish (_data_->_res_, &_data_->_inner_error0_);
#line 767 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 767 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 767 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->data);
#line 767 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->config);
#line 767 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 767 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 7457 "accounts-manager.c"
	}
#line 769 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp10_ = _data_->config;
#line 769 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp11_ = _data_->data;
#line 769 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_account_directories (_data_->info, _data_->_tmp10_, _data_->_tmp11_);
#line 760 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->data);
#line 760 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->config);
#line 760 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 760 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 760 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 760 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7477 "accounts-manager.c"
		}
	}
#line 760 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 760 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 7484 "accounts-manager.c"
}

static inline gchar*
accounts_manager_to_geary_id (AccountsManager* self,
                              GoaObject* account)
{
	GoaAccount* _tmp0_;
	GoaAccount* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* result;
#line 772 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), NULL);
#line 772 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, goa_object_get_type ()), NULL);
#line 773 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = goa_object_get_account (account);
#line 773 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _tmp0_;
#line 773 "../src/client/accounts/accounts-manager.vala"
	g_object_get (_tmp1_, "id", &_tmp2_, NULL);
#line 773 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = _tmp2_;
#line 773 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = _tmp3_;
#line 773 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = g_strconcat (ACCOUNTS_MANAGER_GOA_ID_PREFIX, _tmp4_, NULL);
#line 773 "../src/client/accounts/accounts-manager.vala"
	_tmp6_ = _tmp5_;
#line 773 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp4_);
#line 773 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp1_);
#line 773 "../src/client/accounts/accounts-manager.vala"
	result = _tmp6_;
#line 773 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 7525 "accounts-manager.c"
}

static inline gchar*
accounts_manager_to_goa_id (AccountsManager* self,
                            const gchar* id)
{
	gchar* _tmp0_ = NULL;
	gchar* result;
#line 776 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), NULL);
#line 776 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 777 "../src/client/accounts/accounts-manager.vala"
	if (g_str_has_prefix (id, ACCOUNTS_MANAGER_GOA_ID_PREFIX)) {
#line 7540 "accounts-manager.c"
		gint _tmp1_;
		gint _tmp2_;
		gchar* _tmp3_;
#line 778 "../src/client/accounts/accounts-manager.vala"
		_tmp1_ = strlen (ACCOUNTS_MANAGER_GOA_ID_PREFIX);
#line 778 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = _tmp1_;
#line 778 "../src/client/accounts/accounts-manager.vala"
		_tmp3_ = string_substring (id, (glong) _tmp2_, (glong) -1);
#line 778 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp0_);
#line 778 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = _tmp3_;
#line 7554 "accounts-manager.c"
	} else {
		gchar* _tmp4_;
#line 779 "../src/client/accounts/accounts-manager.vala"
		_tmp4_ = g_strdup (id);
#line 779 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp0_);
#line 779 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = _tmp4_;
#line 7563 "accounts-manager.c"
	}
#line 777 "../src/client/accounts/accounts-manager.vala"
	result = _tmp0_;
#line 777 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 7569 "accounts-manager.c"
}

static gboolean
accounts_manager_is_valid_goa_account (AccountsManager* self,
                                       GoaObject* handle)
{
	GoaMail* mail = NULL;
	GoaMail* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	GoaMail* _tmp4_;
	gboolean result;
#line 782 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), FALSE);
#line 782 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (handle, goa_object_get_type ()), FALSE);
#line 783 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = goa_object_get_mail (handle);
#line 783 "../src/client/accounts/accounts-manager.vala"
	mail = _tmp0_;
#line 785 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = mail;
#line 785 "../src/client/accounts/accounts-manager.vala"
	if (_tmp4_ != NULL) {
#line 7595 "accounts-manager.c"
		GoaAccount* _tmp5_;
		GoaAccount* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 786 "../src/client/accounts/accounts-manager.vala"
		_tmp5_ = goa_object_get_account (handle);
#line 786 "../src/client/accounts/accounts-manager.vala"
		_tmp6_ = _tmp5_;
#line 786 "../src/client/accounts/accounts-manager.vala"
		g_object_get (_tmp6_, "mail-disabled", &_tmp7_, NULL);
#line 786 "../src/client/accounts/accounts-manager.vala"
		_tmp8_ = _tmp7_;
#line 786 "../src/client/accounts/accounts-manager.vala"
		_tmp3_ = !_tmp8_;
#line 786 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp6_);
#line 7612 "accounts-manager.c"
	} else {
#line 785 "../src/client/accounts/accounts-manager.vala"
		_tmp3_ = FALSE;
#line 7616 "accounts-manager.c"
	}
#line 785 "../src/client/accounts/accounts-manager.vala"
	if (_tmp3_) {
#line 7620 "accounts-manager.c"
		GoaMail* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 787 "../src/client/accounts/accounts-manager.vala"
		_tmp9_ = mail;
#line 787 "../src/client/accounts/accounts-manager.vala"
		g_object_get (_tmp9_, "imap-host", &_tmp10_, NULL);
#line 787 "../src/client/accounts/accounts-manager.vala"
		_tmp11_ = _tmp10_;
#line 787 "../src/client/accounts/accounts-manager.vala"
		_tmp12_ = _tmp11_;
#line 787 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = !geary_string_is_empty (_tmp12_);
#line 787 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp12_);
#line 7637 "accounts-manager.c"
	} else {
#line 785 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = FALSE;
#line 7641 "accounts-manager.c"
	}
#line 784 "../src/client/accounts/accounts-manager.vala"
	if (_tmp2_) {
#line 7645 "accounts-manager.c"
		GoaMail* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 788 "../src/client/accounts/accounts-manager.vala"
		_tmp13_ = mail;
#line 788 "../src/client/accounts/accounts-manager.vala"
		g_object_get (_tmp13_, "smtp-host", &_tmp14_, NULL);
#line 788 "../src/client/accounts/accounts-manager.vala"
		_tmp15_ = _tmp14_;
#line 788 "../src/client/accounts/accounts-manager.vala"
		_tmp16_ = _tmp15_;
#line 788 "../src/client/accounts/accounts-manager.vala"
		_tmp1_ = !geary_string_is_empty (_tmp16_);
#line 788 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp16_);
#line 7662 "accounts-manager.c"
	} else {
#line 785 "../src/client/accounts/accounts-manager.vala"
		_tmp1_ = FALSE;
#line 7666 "accounts-manager.c"
	}
#line 784 "../src/client/accounts/accounts-manager.vala"
	result = _tmp1_;
#line 784 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (mail);
#line 784 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 7674 "accounts-manager.c"
}

static void
accounts_manager_create_goa_account_data_free (gpointer _data)
{
	AccountsManagerCreateGoaAccountData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerCreateGoaAccountData, _data_);
#line 7690 "accounts-manager.c"
}

static void
accounts_manager_create_goa_account (AccountsManager* self,
                                     GoaObject* account,
                                     GCancellable* cancellable,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	AccountsManagerCreateGoaAccountData* _data_;
	AccountsManager* _tmp0_;
	GoaObject* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, goa_object_get_type ()));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerCreateGoaAccountData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_create_goa_account_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->account = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_create_goa_account_co (_data_);
#line 7734 "accounts-manager.c"
}

static void
accounts_manager_create_goa_account_finish (AccountsManager* self,
                                            GAsyncResult* _res_)
{
	AccountsManagerCreateGoaAccountData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 7748 "accounts-manager.c"
	}
}

static void
accounts_manager_create_goa_account_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_)
{
	AccountsManagerCreateGoaAccountData* _data_;
#line 814 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 814 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 814 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 814 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_create_goa_account_co (_data_);
#line 7766 "accounts-manager.c"
}

static gboolean
accounts_manager_create_goa_account_co (AccountsManagerCreateGoaAccountData* _data_)
{
#line 792 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 792 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 7776 "accounts-manager.c"
		goto _state_0;
#line 792 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 7780 "accounts-manager.c"
		goto _state_1;
#line 792 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 7784 "accounts-manager.c"
		goto _state_2;
#line 792 "../src/client/accounts/accounts-manager.vala"
		case 3:
#line 7788 "accounts-manager.c"
		goto _state_3;
		default:
#line 792 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 7793 "accounts-manager.c"
	}
	_state_0:
#line 794 "../src/client/accounts/accounts-manager.vala"
	if (accounts_manager_is_valid_goa_account (_data_->self, _data_->account)) {
#line 795 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp0_ = goa_object_get_mail (_data_->account);
#line 795 "../src/client/accounts/accounts-manager.vala"
		_data_->mail = _data_->_tmp0_;
#line 796 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp1_ = _data_->mail;
#line 796 "../src/client/accounts/accounts-manager.vala"
		g_object_get (_data_->_tmp1_, "name", &_data_->_tmp2_, NULL);
#line 796 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 796 "../src/client/accounts/accounts-manager.vala"
		_data_->name = _data_->_tmp3_;
#line 797 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp4_ = _data_->name;
#line 797 "../src/client/accounts/accounts-manager.vala"
		if (geary_string_is_empty_or_whitespace (_data_->_tmp4_)) {
#line 798 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp5_ = accounts_manager_get_account_name (_data_->self);
#line 798 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->name);
#line 798 "../src/client/accounts/accounts-manager.vala"
			_data_->name = _data_->_tmp5_;
#line 7820 "accounts-manager.c"
		}
#line 801 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp6_ = goa_mediator_new (_data_->account);
#line 801 "../src/client/accounts/accounts-manager.vala"
		_data_->mediator = _data_->_tmp6_;
#line 802 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp7_ = accounts_manager_to_geary_id (_data_->self, _data_->account);
#line 802 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 802 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp9_ = _data_->mediator;
#line 802 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp10_ = _data_->mediator;
#line 802 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp11_ = _data_->name;
#line 802 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp12_ = _data_->mail;
#line 802 "../src/client/accounts/accounts-manager.vala"
		g_object_get (_data_->_tmp12_, "email-address", &_data_->_tmp13_, NULL);
#line 802 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp14_ = _data_->_tmp13_;
#line 802 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 802 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp16_ = geary_rf_c822_mailbox_address_new (_data_->_tmp11_, _data_->_tmp15_);
#line 802 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp17_ = _data_->_tmp16_;
#line 802 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp18_ = geary_account_information_new (_data_->_tmp8_, goa_mediator_get_service_provider (_data_->_tmp9_), G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp10_, GEARY_TYPE_CREDENTIALS_MEDIATOR, GearyCredentialsMediator), _data_->_tmp17_);
#line 802 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp19_ = _data_->_tmp18_;
#line 802 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->_tmp17_);
#line 802 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->_tmp15_);
#line 802 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->_tmp8_);
#line 802 "../src/client/accounts/accounts-manager.vala"
		_data_->info = _data_->_tmp19_;
#line 809 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp20_ = _data_->info;
#line 809 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp21_ = geary_account_information_next_ordinal;
#line 809 "../src/client/accounts/accounts-manager.vala"
		geary_account_information_next_ordinal = _data_->_tmp21_ + 1;
#line 809 "../src/client/accounts/accounts-manager.vala"
		geary_account_information_set_ordinal (_data_->_tmp20_, _data_->_tmp21_);
#line 810 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp22_ = _data_->info;
#line 810 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp23_ = _data_->mediator;
#line 810 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp24_ = goa_mediator_get_service_label (_data_->_tmp23_);
#line 810 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp25_ = _data_->_tmp24_;
#line 810 "../src/client/accounts/accounts-manager.vala"
		geary_account_information_set_service_label (_data_->_tmp22_, _data_->_tmp25_);
#line 810 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->_tmp25_);
#line 811 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp26_ = _data_->info;
#line 811 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp27_ = goa_object_get_account (_data_->account);
#line 811 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp28_ = _data_->_tmp27_;
#line 811 "../src/client/accounts/accounts-manager.vala"
		g_object_get (_data_->_tmp28_, "presentation-identity", &_data_->_tmp29_, NULL);
#line 811 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp30_ = _data_->_tmp29_;
#line 811 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp31_ = _data_->_tmp30_;
#line 811 "../src/client/accounts/accounts-manager.vala"
		geary_account_information_set_label (_data_->_tmp26_, _data_->_tmp31_);
#line 811 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->_tmp31_);
#line 811 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->_tmp28_);
#line 7898 "accounts-manager.c"
		{
#line 814 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp32_ = _data_->info;
#line 814 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 1;
#line 814 "../src/client/accounts/accounts-manager.vala"
			accounts_manager_create_account_dirs (_data_->self, _data_->_tmp32_, _data_->cancellable, accounts_manager_create_goa_account_ready, _data_);
#line 814 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 7908 "accounts-manager.c"
			_state_1:
#line 814 "../src/client/accounts/accounts-manager.vala"
			accounts_manager_create_account_dirs_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 814 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 7914 "accounts-manager.c"
				goto __catch0_g_error;
			}
#line 815 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp33_ = _data_->info;
#line 815 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 2;
#line 815 "../src/client/accounts/accounts-manager.vala"
			accounts_manager_save_account (_data_->self, _data_->_tmp33_, _data_->cancellable, accounts_manager_create_goa_account_ready, _data_);
#line 815 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 7925 "accounts-manager.c"
			_state_2:
#line 815 "../src/client/accounts/accounts-manager.vala"
			accounts_manager_save_account_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 815 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 7931 "accounts-manager.c"
				goto __catch0_g_error;
			}
#line 816 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp34_ = _data_->mediator;
#line 816 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp35_ = _data_->info;
#line 816 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 3;
#line 816 "../src/client/accounts/accounts-manager.vala"
			goa_mediator_update (_data_->_tmp34_, _data_->_tmp35_, _data_->cancellable, accounts_manager_create_goa_account_ready, _data_);
#line 816 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 7944 "accounts-manager.c"
			_state_3:
#line 816 "../src/client/accounts/accounts-manager.vala"
			goa_mediator_update_finish (_data_->_tmp34_, _data_->_res_, &_data_->_inner_error0_);
#line 816 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 7950 "accounts-manager.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 813 "../src/client/accounts/accounts-manager.vala"
			_data_->err = _data_->_inner_error0_;
#line 813 "../src/client/accounts/accounts-manager.vala"
			_data_->_inner_error0_ = NULL;
#line 818 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp36_ = _data_->err;
#line 818 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp37_ = geary_problem_report_new (_data_->_tmp36_);
#line 818 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp38_ = _data_->_tmp37_;
#line 818 "../src/client/accounts/accounts-manager.vala"
			g_signal_emit (_data_->self, accounts_manager_signals[ACCOUNTS_MANAGER_REPORT_PROBLEM_SIGNAL], 0, _data_->_tmp38_);
#line 818 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->_tmp38_);
#line 813 "../src/client/accounts/accounts-manager.vala"
			_g_error_free0 (_data_->err);
#line 7973 "accounts-manager.c"
		}
		__finally0:
#line 813 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 813 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->info);
#line 813 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 813 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->name);
#line 813 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mail);
#line 813 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 813 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 813 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 813 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 7994 "accounts-manager.c"
		}
#line 821 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp39_ = _data_->info;
#line 821 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_set_enabled (_data_->self, _data_->_tmp39_, TRUE);
#line 794 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->info);
#line 794 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->mediator);
#line 794 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->name);
#line 794 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->mail);
#line 8008 "accounts-manager.c"
	} else {
#line 823 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp40_ = goa_object_get_account (_data_->account);
#line 823 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp41_ = _data_->_tmp40_;
#line 823 "../src/client/accounts/accounts-manager.vala"
		g_object_get (_data_->_tmp41_, "provider-type", &_data_->_tmp42_, NULL);
#line 823 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp43_ = _data_->_tmp42_;
#line 823 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp44_ = _data_->_tmp43_;
#line 823 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp45_ = goa_object_get_account (_data_->account);
#line 823 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp46_ = _data_->_tmp45_;
#line 823 "../src/client/accounts/accounts-manager.vala"
		g_object_get (_data_->_tmp46_, "id", &_data_->_tmp47_, NULL);
#line 823 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp48_ = _data_->_tmp47_;
#line 823 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp49_ = _data_->_tmp48_;
#line 823 "../src/client/accounts/accounts-manager.vala"
		g_debug ("accounts-manager.vala:823: Ignoring GOA %s account %s, mail service no" \
"t enabled", _data_->_tmp44_, _data_->_tmp49_);
#line 823 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->_tmp49_);
#line 823 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->_tmp46_);
#line 823 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->_tmp44_);
#line 823 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->_tmp41_);
#line 8040 "accounts-manager.c"
	}
#line 792 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 792 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 792 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 792 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8050 "accounts-manager.c"
		}
	}
#line 792 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 792 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 8057 "accounts-manager.c"
}

static void
accounts_manager_update_goa_account_data_free (gpointer _data)
{
	AccountsManagerUpdateGoaAccountData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerUpdateGoaAccountData, _data_);
#line 8073 "accounts-manager.c"
}

static void
accounts_manager_update_goa_account (AccountsManager* self,
                                     GearyAccountInformation* account,
                                     gboolean is_available,
                                     GCancellable* cancellable,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	AccountsManagerUpdateGoaAccountData* _data_;
	AccountsManager* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerUpdateGoaAccountData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_update_goa_account_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->account = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->is_available = is_available;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_update_goa_account_co (_data_);
#line 8120 "accounts-manager.c"
}

static void
accounts_manager_update_goa_account_finish (AccountsManager* self,
                                            GAsyncResult* _res_)
{
	AccountsManagerUpdateGoaAccountData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 8134 "accounts-manager.c"
	}
}

static void
accounts_manager_update_goa_account_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_)
{
	AccountsManagerUpdateGoaAccountData* _data_;
#line 836 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 836 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 836 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 836 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_update_goa_account_co (_data_);
#line 8152 "accounts-manager.c"
}

static gboolean
accounts_manager_update_goa_account_co (AccountsManagerUpdateGoaAccountData* _data_)
{
#line 831 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 831 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 8162 "accounts-manager.c"
		goto _state_0;
#line 831 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 8166 "accounts-manager.c"
		goto _state_1;
#line 831 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 8170 "accounts-manager.c"
		goto _state_2;
#line 831 "../src/client/accounts/accounts-manager.vala"
		case 3:
#line 8174 "accounts-manager.c"
		goto _state_3;
		default:
#line 831 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 8179 "accounts-manager.c"
	}
	_state_0:
#line 834 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = geary_account_information_get_mediator (_data_->account);
#line 834 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 834 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp1_, TYPE_GOA_MEDIATOR, GoaMediator));
#line 834 "../src/client/accounts/accounts-manager.vala"
	_data_->mediator = _data_->_tmp2_;
#line 8190 "accounts-manager.c"
	{
#line 836 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp3_ = _data_->mediator;
#line 836 "../src/client/accounts/accounts-manager.vala"
		_data_->_state_ = 1;
#line 836 "../src/client/accounts/accounts-manager.vala"
		goa_mediator_update (_data_->_tmp3_, _data_->account, _data_->cancellable, accounts_manager_update_goa_account_ready, _data_);
#line 836 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 8200 "accounts-manager.c"
		_state_1:
#line 836 "../src/client/accounts/accounts-manager.vala"
		goa_mediator_update_finish (_data_->_tmp3_, _data_->_res_, &_data_->_inner_error0_);
#line 836 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 8206 "accounts-manager.c"
			goto __catch0_g_error;
		}
#line 838 "../src/client/accounts/accounts-manager.vala"
		if (_data_->is_available) {
#line 841 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 2;
#line 841 "../src/client/accounts/accounts-manager.vala"
			geary_account_information_load_outgoing_credentials (_data_->account, _data_->cancellable, accounts_manager_update_goa_account_ready, _data_);
#line 841 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 8217 "accounts-manager.c"
			_state_2:
#line 841 "../src/client/accounts/accounts-manager.vala"
			geary_account_information_load_outgoing_credentials_finish (_data_->account, _data_->_res_, &_data_->_inner_error0_);
#line 841 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 8223 "accounts-manager.c"
				goto __catch0_g_error;
			}
#line 842 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 3;
#line 842 "../src/client/accounts/accounts-manager.vala"
			geary_account_information_load_incoming_credentials (_data_->account, _data_->cancellable, accounts_manager_update_goa_account_ready, _data_);
#line 842 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 8232 "accounts-manager.c"
			_state_3:
#line 842 "../src/client/accounts/accounts-manager.vala"
			geary_account_information_load_incoming_credentials_finish (_data_->account, _data_->_res_, &_data_->_inner_error0_);
#line 842 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 8238 "accounts-manager.c"
				goto __catch0_g_error;
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 835 "../src/client/accounts/accounts-manager.vala"
		_data_->err = _data_->_inner_error0_;
#line 835 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error0_ = NULL;
#line 845 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp4_ = _data_->err;
#line 845 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp5_ = geary_account_problem_report_new (_data_->account, _data_->_tmp4_);
#line 845 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 845 "../src/client/accounts/accounts-manager.vala"
		g_signal_emit (_data_->self, accounts_manager_signals[ACCOUNTS_MANAGER_REPORT_PROBLEM_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, GEARY_TYPE_PROBLEM_REPORT, GearyProblemReport));
#line 845 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->_tmp6_);
#line 835 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (_data_->err);
#line 8262 "accounts-manager.c"
	}
	__finally0:
#line 835 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 835 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->mediator);
#line 835 "../src/client/accounts/accounts-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 835 "../src/client/accounts/accounts-manager.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 835 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 835 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 8277 "accounts-manager.c"
	}
#line 848 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_set_available (_data_->self, _data_->account, _data_->is_available);
#line 831 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->mediator);
#line 831 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 831 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 831 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 831 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8291 "accounts-manager.c"
		}
	}
#line 831 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 831 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 8298 "accounts-manager.c"
}

static void
accounts_manager_open_goa_settings_data_free (gpointer _data)
{
	AccountsManagerOpenGoaSettingsData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->action);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->param);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerOpenGoaSettingsData, _data_);
#line 8316 "accounts-manager.c"
}

static void
accounts_manager_open_goa_settings (AccountsManager* self,
                                    const gchar* action,
                                    const gchar* param,
                                    GCancellable* cancellable,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	AccountsManagerOpenGoaSettingsData* _data_;
	AccountsManager* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GCancellable* _tmp3_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (action != NULL);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerOpenGoaSettingsData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_open_goa_settings_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = g_strdup (action);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->action);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->action = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = g_strdup (param);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->param);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->param = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp3_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_open_goa_settings_co (_data_);
#line 8368 "accounts-manager.c"
}

static void
accounts_manager_open_goa_settings_finish (AccountsManager* self,
                                           GAsyncResult* _res_,
                                           GError** error)
{
	AccountsManagerOpenGoaSettingsData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 8383 "accounts-manager.c"
	}
}

static void
accounts_manager_open_goa_settings_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	AccountsManagerOpenGoaSettingsData* _data_;
#line 859 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 859 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 859 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 859 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_open_goa_settings_co (_data_);
#line 8401 "accounts-manager.c"
}

static void
_vala_array_add11 (GVariant** * array,
                   gint* length,
                   gint* size,
                   GVariant* value)
{
#line 877 "../src/client/accounts/accounts-manager.vala"
	if ((*length) == (*size)) {
#line 877 "../src/client/accounts/accounts-manager.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 877 "../src/client/accounts/accounts-manager.vala"
		*array = g_renew (GVariant*, *array, (*size) + 1);
#line 8416 "accounts-manager.c"
	}
#line 877 "../src/client/accounts/accounts-manager.vala"
	(*array)[(*length)++] = value;
#line 877 "../src/client/accounts/accounts-manager.vala"
	(*array)[*length] = NULL;
#line 8422 "accounts-manager.c"
}

static gboolean
accounts_manager_open_goa_settings_co (AccountsManagerOpenGoaSettingsData* _data_)
{
#line 852 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 852 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 8432 "accounts-manager.c"
		goto _state_0;
#line 852 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 8436 "accounts-manager.c"
		goto _state_1;
#line 852 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 8440 "accounts-manager.c"
		goto _state_2;
		default:
#line 852 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 8445 "accounts-manager.c"
	}
	_state_0:
#line 859 "../src/client/accounts/accounts-manager.vala"
	_data_->_state_ = 1;
#line 859 "../src/client/accounts/accounts-manager.vala"
	g_dbus_proxy_new_for_bus (G_BUS_TYPE_SESSION, G_DBUS_PROXY_FLAGS_NONE, NULL, "org.gnome.Settings", "/org/gnome/Settings", "org.gtk.Actions", _data_->cancellable, accounts_manager_open_goa_settings_ready, _data_);
#line 859 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 8454 "accounts-manager.c"
	_state_1:
#line 859 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = g_dbus_proxy_new_for_bus_finish (_data_->_res_, &_data_->_inner_error0_);
#line 859 "../src/client/accounts/accounts-manager.vala"
	_data_->settings = _data_->_tmp0_;
#line 859 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 859 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 859 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 859 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 8468 "accounts-manager.c"
	}
#line 873 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = g_variant_new_string (_data_->action);
#line 873 "../src/client/accounts/accounts-manager.vala"
	g_variant_ref_sink (_data_->_tmp1_);
#line 873 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 873 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp3_ = g_variant_new_variant (_data_->_tmp2_);
#line 873 "../src/client/accounts/accounts-manager.vala"
	g_variant_ref_sink (_data_->_tmp3_);
#line 873 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp4_ = g_new0 (GVariant*, 1 + 1);
#line 873 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp4_[0] = _data_->_tmp3_;
#line 873 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 873 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp5__length1 = 1;
#line 873 "../src/client/accounts/accounts-manager.vala"
	_g_variant_unref0 (_data_->_tmp2_);
#line 873 "../src/client/accounts/accounts-manager.vala"
	_data_->args = _data_->_tmp5_;
#line 873 "../src/client/accounts/accounts-manager.vala"
	_data_->args_length1 = _data_->_tmp5__length1;
#line 873 "../src/client/accounts/accounts-manager.vala"
	_data_->_args_size_ = _data_->args_length1;
#line 876 "../src/client/accounts/accounts-manager.vala"
	if (_data_->param != NULL) {
#line 877 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp6_ = g_variant_new_string (_data_->param);
#line 877 "../src/client/accounts/accounts-manager.vala"
		g_variant_ref_sink (_data_->_tmp6_);
#line 877 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 877 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp8_ = g_variant_new_variant (_data_->_tmp7_);
#line 877 "../src/client/accounts/accounts-manager.vala"
		g_variant_ref_sink (_data_->_tmp8_);
#line 877 "../src/client/accounts/accounts-manager.vala"
		_vala_array_add11 (&_data_->args, &_data_->args_length1, &_data_->_args_size_, _data_->_tmp8_);
#line 877 "../src/client/accounts/accounts-manager.vala"
		_g_variant_unref0 (_data_->_tmp7_);
#line 8512 "accounts-manager.c"
	}
#line 880 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp9_ = g_variant_new_string ("online-accounts");
#line 880 "../src/client/accounts/accounts-manager.vala"
	g_variant_ref_sink (_data_->_tmp9_);
#line 880 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp10_ = G_VARIANT_TYPE_VARIANT;
#line 880 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp11_ = _data_->args;
#line 880 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp11__length1 = _data_->args_length1;
#line 880 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp12_ = g_variant_new_array (_data_->_tmp10_, _data_->_tmp11_, _data_->_tmp11__length1);
#line 880 "../src/client/accounts/accounts-manager.vala"
	g_variant_ref_sink (_data_->_tmp12_);
#line 880 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp13_ = g_new0 (GVariant*, 2 + 1);
#line 880 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp13_[0] = _data_->_tmp9_;
#line 880 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp13_[1] = _data_->_tmp12_;
#line 880 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp14_ = _data_->_tmp13_;
#line 880 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp14__length1 = 2;
#line 880 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp15_ = g_variant_new_tuple (_data_->_tmp14_, 2);
#line 880 "../src/client/accounts/accounts-manager.vala"
	g_variant_ref_sink (_data_->_tmp15_);
#line 880 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp16_ = _data_->_tmp15_;
#line 880 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp14_ = (_vala_array_free (_data_->_tmp14_, _data_->_tmp14__length1, (GDestroyNotify) g_variant_unref), NULL);
#line 880 "../src/client/accounts/accounts-manager.vala"
	_data_->command = _data_->_tmp16_;
#line 887 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp17_ = g_variant_new_string ("launch-panel");
#line 887 "../src/client/accounts/accounts-manager.vala"
	g_variant_ref_sink (_data_->_tmp17_);
#line 887 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp18_ = G_VARIANT_TYPE_VARIANT;
#line 887 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp19_ = _data_->command;
#line 887 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp20_ = g_variant_new_variant (_data_->_tmp19_);
#line 887 "../src/client/accounts/accounts-manager.vala"
	g_variant_ref_sink (_data_->_tmp20_);
#line 887 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp21_ = g_new0 (GVariant*, 1 + 1);
#line 887 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp21_[0] = _data_->_tmp20_;
#line 887 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp22_ = _data_->_tmp21_;
#line 887 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp22__length1 = 1;
#line 887 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp23_ = g_variant_new_array (_data_->_tmp18_, _data_->_tmp22_, 1);
#line 887 "../src/client/accounts/accounts-manager.vala"
	g_variant_ref_sink (_data_->_tmp23_);
#line 887 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp24_ = g_variant_new ("a{sv}", NULL);
#line 887 "../src/client/accounts/accounts-manager.vala"
	g_variant_ref_sink (_data_->_tmp24_);
#line 887 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp25_ = g_new0 (GVariant*, 3 + 1);
#line 887 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp25_[0] = _data_->_tmp17_;
#line 887 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp25_[1] = _data_->_tmp23_;
#line 887 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp25_[2] = _data_->_tmp24_;
#line 887 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp26_ = _data_->_tmp25_;
#line 887 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp26__length1 = 3;
#line 887 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp27_ = g_variant_new_tuple (_data_->_tmp26_, 3);
#line 887 "../src/client/accounts/accounts-manager.vala"
	g_variant_ref_sink (_data_->_tmp27_);
#line 887 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp28_ = _data_->_tmp27_;
#line 887 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp26_ = (_vala_array_free (_data_->_tmp26_, _data_->_tmp26__length1, (GDestroyNotify) g_variant_unref), NULL);
#line 887 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp22_ = (_vala_array_free (_data_->_tmp22_, _data_->_tmp22__length1, (GDestroyNotify) g_variant_unref), NULL);
#line 887 "../src/client/accounts/accounts-manager.vala"
	_data_->params = _data_->_tmp28_;
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp29_ = _data_->settings;
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp30_ = _data_->params;
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_state_ = 2;
#line 900 "../src/client/accounts/accounts-manager.vala"
	g_dbus_proxy_call (_data_->_tmp29_, "Activate", _data_->_tmp30_, G_DBUS_CALL_FLAGS_NONE, -1, _data_->cancellable, accounts_manager_open_goa_settings_ready, _data_);
#line 900 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 8610 "accounts-manager.c"
	_state_2:
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp31_ = g_dbus_proxy_call_finish (_data_->_tmp29_, _data_->_res_, &_data_->_inner_error0_);
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp32_ = _data_->_tmp31_;
#line 900 "../src/client/accounts/accounts-manager.vala"
	_g_variant_unref0 (_data_->_tmp32_);
#line 900 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 900 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 900 "../src/client/accounts/accounts-manager.vala"
		_g_variant_unref0 (_data_->params);
#line 900 "../src/client/accounts/accounts-manager.vala"
		_g_variant_unref0 (_data_->command);
#line 900 "../src/client/accounts/accounts-manager.vala"
		_data_->args = (_vala_array_free (_data_->args, _data_->args_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 900 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->settings);
#line 900 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 900 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 8634 "accounts-manager.c"
	}
#line 852 "../src/client/accounts/accounts-manager.vala"
	_g_variant_unref0 (_data_->params);
#line 852 "../src/client/accounts/accounts-manager.vala"
	_g_variant_unref0 (_data_->command);
#line 852 "../src/client/accounts/accounts-manager.vala"
	_data_->args = (_vala_array_free (_data_->args, _data_->args_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 852 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->settings);
#line 852 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 852 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 852 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 852 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8652 "accounts-manager.c"
		}
	}
#line 852 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 852 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 8659 "accounts-manager.c"
}

static void
accounts_manager_on_goa_account_added (AccountsManager* self,
                                       GoaObject* account)
{
	GoaAccount* _tmp0_;
	GoaAccount* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 905 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 905 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, goa_object_get_type ()));
#line 906 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = goa_object_get_account (account);
#line 906 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _tmp0_;
#line 906 "../src/client/accounts/accounts-manager.vala"
	g_object_get (_tmp1_, "id", &_tmp2_, NULL);
#line 906 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = _tmp2_;
#line 906 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = _tmp3_;
#line 906 "../src/client/accounts/accounts-manager.vala"
	g_debug ("accounts-manager.vala:906: GOA account added: %s", _tmp4_);
#line 906 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp4_);
#line 906 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp1_);
#line 908 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_create_goa_account (self, account, NULL, NULL, NULL);
#line 8693 "accounts-manager.c"
}

static void
accounts_manager_on_goa_account_changed (AccountsManager* self,
                                         GoaObject* account)
{
	GoaAccount* _tmp0_;
	GoaAccount* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	AccountsManagerAccountState* state = NULL;
	GeeMap* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gpointer _tmp8_;
	AccountsManagerAccountState* _tmp9_;
	AccountsManagerAccountState* _tmp10_;
#line 911 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 911 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, goa_object_get_type ()));
#line 912 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = goa_object_get_account (account);
#line 912 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _tmp0_;
#line 912 "../src/client/accounts/accounts-manager.vala"
	g_object_get (_tmp1_, "id", &_tmp2_, NULL);
#line 912 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = _tmp2_;
#line 912 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = _tmp3_;
#line 912 "../src/client/accounts/accounts-manager.vala"
	g_debug ("accounts-manager.vala:912: GOA account changed: %s", _tmp4_);
#line 912 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp4_);
#line 912 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp1_);
#line 913 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = self->priv->accounts;
#line 913 "../src/client/accounts/accounts-manager.vala"
	_tmp6_ = accounts_manager_to_geary_id (self, account);
#line 913 "../src/client/accounts/accounts-manager.vala"
	_tmp7_ = _tmp6_;
#line 913 "../src/client/accounts/accounts-manager.vala"
	_tmp8_ = gee_map_get (_tmp5_, _tmp7_);
#line 913 "../src/client/accounts/accounts-manager.vala"
	_tmp9_ = (AccountsManagerAccountState*) _tmp8_;
#line 913 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp7_);
#line 913 "../src/client/accounts/accounts-manager.vala"
	state = _tmp9_;
#line 915 "../src/client/accounts/accounts-manager.vala"
	_tmp10_ = state;
#line 915 "../src/client/accounts/accounts-manager.vala"
	if (_tmp10_ != NULL) {
#line 8750 "accounts-manager.c"
		AccountsManagerAccountState* _tmp11_;
		GearyAccountInformation* _tmp12_;
		GearyAccountInformation* _tmp13_;
#line 919 "../src/client/accounts/accounts-manager.vala"
		_tmp11_ = state;
#line 919 "../src/client/accounts/accounts-manager.vala"
		_tmp12_ = accounts_manager_account_state_get_account (_tmp11_);
#line 919 "../src/client/accounts/accounts-manager.vala"
		_tmp13_ = _tmp12_;
#line 919 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_update_goa_account (self, _tmp13_, accounts_manager_is_valid_goa_account (self, account), NULL, NULL, NULL);
#line 8762 "accounts-manager.c"
	} else {
#line 929 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_create_goa_account (self, account, NULL, NULL, NULL);
#line 8766 "accounts-manager.c"
	}
#line 911 "../src/client/accounts/accounts-manager.vala"
	_accounts_manager_account_state_unref0 (state);
#line 8770 "accounts-manager.c"
}

static void
accounts_manager_on_goa_account_removed (AccountsManager* self,
                                         GoaObject* account)
{
	GoaAccount* _tmp0_;
	GoaAccount* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	AccountsManagerAccountState* state = NULL;
	GeeMap* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gpointer _tmp8_;
	AccountsManagerAccountState* _tmp9_;
	AccountsManagerAccountState* _tmp10_;
#line 933 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 933 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, goa_object_get_type ()));
#line 934 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = goa_object_get_account (account);
#line 934 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _tmp0_;
#line 934 "../src/client/accounts/accounts-manager.vala"
	g_object_get (_tmp1_, "id", &_tmp2_, NULL);
#line 934 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = _tmp2_;
#line 934 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = _tmp3_;
#line 934 "../src/client/accounts/accounts-manager.vala"
	g_debug ("accounts-manager.vala:934: GOA account removed: %s", _tmp4_);
#line 934 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp4_);
#line 934 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp1_);
#line 935 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = self->priv->accounts;
#line 935 "../src/client/accounts/accounts-manager.vala"
	_tmp6_ = accounts_manager_to_geary_id (self, account);
#line 935 "../src/client/accounts/accounts-manager.vala"
	_tmp7_ = _tmp6_;
#line 935 "../src/client/accounts/accounts-manager.vala"
	_tmp8_ = gee_map_get (_tmp5_, _tmp7_);
#line 935 "../src/client/accounts/accounts-manager.vala"
	_tmp9_ = (AccountsManagerAccountState*) _tmp8_;
#line 935 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp7_);
#line 935 "../src/client/accounts/accounts-manager.vala"
	state = _tmp9_;
#line 936 "../src/client/accounts/accounts-manager.vala"
	_tmp10_ = state;
#line 936 "../src/client/accounts/accounts-manager.vala"
	if (_tmp10_ != NULL) {
#line 8827 "accounts-manager.c"
		AccountsManagerAccountState* _tmp11_;
		GearyAccountInformation* _tmp12_;
		GearyAccountInformation* _tmp13_;
#line 939 "../src/client/accounts/accounts-manager.vala"
		_tmp11_ = state;
#line 939 "../src/client/accounts/accounts-manager.vala"
		_tmp12_ = accounts_manager_account_state_get_account (_tmp11_);
#line 939 "../src/client/accounts/accounts-manager.vala"
		_tmp13_ = _tmp12_;
#line 939 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_set_available (self, _tmp13_, FALSE);
#line 8839 "accounts-manager.c"
	}
#line 933 "../src/client/accounts/accounts-manager.vala"
	_accounts_manager_account_state_unref0 (state);
#line 8843 "accounts-manager.c"
}

static Block50Data*
block50_data_ref (Block50Data* _data50_)
{
#line 943 "../src/client/accounts/accounts-manager.vala"
	g_atomic_int_inc (&_data50_->_ref_count_);
#line 943 "../src/client/accounts/accounts-manager.vala"
	return _data50_;
#line 8853 "accounts-manager.c"
}

static void
block50_data_unref (void * _userdata_)
{
	Block50Data* _data50_;
	_data50_ = (Block50Data*) _userdata_;
#line 943 "../src/client/accounts/accounts-manager.vala"
	if (g_atomic_int_dec_and_test (&_data50_->_ref_count_)) {
#line 8863 "accounts-manager.c"
		AccountsManager* self;
#line 943 "../src/client/accounts/accounts-manager.vala"
		self = _data50_->self;
#line 943 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data50_->account);
#line 943 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (self);
#line 943 "../src/client/accounts/accounts-manager.vala"
		g_slice_free (Block50Data, _data50_);
#line 8873 "accounts-manager.c"
	}
}

static void
__lambda11_ (Block50Data* _data50_,
             GObject* obj,
             GAsyncResult* res)
{
	AccountsManager* self;
	GError* _inner_error0_ = NULL;
#line 946 "../src/client/accounts/accounts-manager.vala"
	self = _data50_->self;
#line 946 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 946 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 8890 "accounts-manager.c"
	{
#line 948 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_save_account_finish (self, res, &_inner_error0_);
#line 948 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8896 "accounts-manager.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp0_;
		GearyAccountProblemReport* _tmp1_;
		GearyAccountProblemReport* _tmp2_;
#line 947 "../src/client/accounts/accounts-manager.vala"
		err = _inner_error0_;
#line 947 "../src/client/accounts/accounts-manager.vala"
		_inner_error0_ = NULL;
#line 950 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = err;
#line 950 "../src/client/accounts/accounts-manager.vala"
		_tmp1_ = geary_account_problem_report_new (_data50_->account, _tmp0_);
#line 950 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = _tmp1_;
#line 950 "../src/client/accounts/accounts-manager.vala"
		g_signal_emit (self, accounts_manager_signals[ACCOUNTS_MANAGER_REPORT_PROBLEM_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEARY_TYPE_PROBLEM_REPORT, GearyProblemReport));
#line 950 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp2_);
#line 947 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (err);
#line 8923 "accounts-manager.c"
	}
	__finally0:
#line 947 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 947 "../src/client/accounts/accounts-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 947 "../src/client/accounts/accounts-manager.vala"
		g_clear_error (&_inner_error0_);
#line 947 "../src/client/accounts/accounts-manager.vala"
		return;
#line 8934 "accounts-manager.c"
	}
}

static void
___lambda11__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 944 "../src/client/accounts/accounts-manager.vala"
	__lambda11_ (self, source_object, res);
#line 944 "../src/client/accounts/accounts-manager.vala"
	block50_data_unref (self);
#line 8947 "accounts-manager.c"
}

static void
accounts_manager_on_account_changed (AccountsManager* self,
                                     GearyAccountInformation* account)
{
	Block50Data* _data50_;
	GearyAccountInformation* _tmp0_;
#line 943 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 943 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 943 "../src/client/accounts/accounts-manager.vala"
	_data50_ = g_slice_new0 (Block50Data);
#line 943 "../src/client/accounts/accounts-manager.vala"
	_data50_->_ref_count_ = 1;
#line 943 "../src/client/accounts/accounts-manager.vala"
	_data50_->self = g_object_ref (self);
#line 943 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (account);
#line 943 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data50_->account);
#line 943 "../src/client/accounts/accounts-manager.vala"
	_data50_->account = _tmp0_;
#line 944 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_save_account (self, _data50_->account, NULL, ___lambda11__gasync_ready_callback, block50_data_ref (_data50_));
#line 943 "../src/client/accounts/accounts-manager.vala"
	block50_data_unref (_data50_);
#line 943 "../src/client/accounts/accounts-manager.vala"
	_data50_ = NULL;
#line 8978 "accounts-manager.c"
}

static inline gpointer
accounts_manager_account_state_get_instance_private (AccountsManagerAccountState* self)
{
	return G_STRUCT_MEMBER_P (self, AccountsManagerAccountState_private_offset);
}

static GearyAccountInformation*
accounts_manager_account_state_get_account (AccountsManagerAccountState* self)
{
	GearyAccountInformation* result;
	GearyAccountInformation* _tmp0_;
#line 79 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_MANAGER_IS_ACCOUNT_STATE (self), NULL);
#line 79 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->_account;
#line 79 "../src/client/accounts/accounts-manager.vala"
	result = _tmp0_;
#line 79 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 9000 "accounts-manager.c"
}

static void
accounts_manager_account_state_set_account (AccountsManagerAccountState* self,
                                            GearyAccountInformation* value)
{
	GearyAccountInformation* _tmp0_;
#line 79 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_MANAGER_IS_ACCOUNT_STATE (self));
#line 79 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 79 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (self->priv->_account);
#line 79 "../src/client/accounts/accounts-manager.vala"
	self->priv->_account = _tmp0_;
#line 9016 "accounts-manager.c"
}

static AccountsManagerStatus
accounts_manager_account_state_get_status (AccountsManagerAccountState* self)
{
	AccountsManagerStatus result;
	AccountsManagerStatus status = 0;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 83 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_MANAGER_IS_ACCOUNT_STATE (self), 0);
#line 84 "../src/client/accounts/accounts-manager.vala"
	status = ACCOUNTS_MANAGER_STATUS_ENABLED;
#line 85 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->_enabled;
#line 85 "../src/client/accounts/accounts-manager.vala"
	if (!_tmp0_) {
#line 86 "../src/client/accounts/accounts-manager.vala"
		status = ACCOUNTS_MANAGER_STATUS_DISABLED;
#line 9036 "accounts-manager.c"
	}
#line 88 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = self->priv->_available;
#line 88 "../src/client/accounts/accounts-manager.vala"
	if (!_tmp1_) {
#line 89 "../src/client/accounts/accounts-manager.vala"
		status = ACCOUNTS_MANAGER_STATUS_UNAVAILABLE;
#line 9044 "accounts-manager.c"
	}
#line 91 "../src/client/accounts/accounts-manager.vala"
	result = status;
#line 91 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 9050 "accounts-manager.c"
}

static gboolean
accounts_manager_account_state_get_enabled (AccountsManagerAccountState* self)
{
	gboolean result;
#line 96 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_MANAGER_IS_ACCOUNT_STATE (self), FALSE);
#line 96 "../src/client/accounts/accounts-manager.vala"
	result = self->priv->_enabled;
#line 96 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 9063 "accounts-manager.c"
}

static void
accounts_manager_account_state_set_enabled (AccountsManagerAccountState* self,
                                            gboolean value)
{
#line 96 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_MANAGER_IS_ACCOUNT_STATE (self));
#line 96 "../src/client/accounts/accounts-manager.vala"
	self->priv->_enabled = value;
#line 9074 "accounts-manager.c"
}

static gboolean
accounts_manager_account_state_get_available (AccountsManagerAccountState* self)
{
	gboolean result;
#line 99 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_MANAGER_IS_ACCOUNT_STATE (self), FALSE);
#line 99 "../src/client/accounts/accounts-manager.vala"
	result = self->priv->_available;
#line 99 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 9087 "accounts-manager.c"
}

static void
accounts_manager_account_state_set_available (AccountsManagerAccountState* self,
                                              gboolean value)
{
#line 99 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_MANAGER_IS_ACCOUNT_STATE (self));
#line 99 "../src/client/accounts/accounts-manager.vala"
	self->priv->_available = value;
#line 9098 "accounts-manager.c"
}

static AccountsManagerAccountState*
accounts_manager_account_state_construct (GType object_type,
                                          GearyAccountInformation* account)
{
	AccountsManagerAccountState* self = NULL;
#line 102 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION), NULL);
#line 102 "../src/client/accounts/accounts-manager.vala"
	self = (AccountsManagerAccountState*) g_type_create_instance (object_type);
#line 103 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_account_state_set_account (self, account);
#line 102 "../src/client/accounts/accounts-manager.vala"
	return self;
#line 9114 "accounts-manager.c"
}

static AccountsManagerAccountState*
accounts_manager_account_state_new (GearyAccountInformation* account)
{
#line 102 "../src/client/accounts/accounts-manager.vala"
	return accounts_manager_account_state_construct (ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE, account);
#line 9122 "accounts-manager.c"
}

static void
accounts_manager_value_account_state_init (GValue* value)
{
#line 75 "../src/client/accounts/accounts-manager.vala"
	value->data[0].v_pointer = NULL;
#line 9130 "accounts-manager.c"
}

static void
accounts_manager_value_account_state_free_value (GValue* value)
{
#line 75 "../src/client/accounts/accounts-manager.vala"
	if (value->data[0].v_pointer) {
#line 75 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_account_state_unref (value->data[0].v_pointer);
#line 9140 "accounts-manager.c"
	}
}

static void
accounts_manager_value_account_state_copy_value (const GValue* src_value,
                                                 GValue* dest_value)
{
#line 75 "../src/client/accounts/accounts-manager.vala"
	if (src_value->data[0].v_pointer) {
#line 75 "../src/client/accounts/accounts-manager.vala"
		dest_value->data[0].v_pointer = accounts_manager_account_state_ref (src_value->data[0].v_pointer);
#line 9152 "accounts-manager.c"
	} else {
#line 75 "../src/client/accounts/accounts-manager.vala"
		dest_value->data[0].v_pointer = NULL;
#line 9156 "accounts-manager.c"
	}
}

static gpointer
accounts_manager_value_account_state_peek_pointer (const GValue* value)
{
#line 75 "../src/client/accounts/accounts-manager.vala"
	return value->data[0].v_pointer;
#line 9165 "accounts-manager.c"
}

static gchar*
accounts_manager_value_account_state_collect_value (GValue* value,
                                                    guint n_collect_values,
                                                    GTypeCValue* collect_values,
                                                    guint collect_flags)
{
#line 75 "../src/client/accounts/accounts-manager.vala"
	if (collect_values[0].v_pointer) {
#line 9176 "accounts-manager.c"
		AccountsManagerAccountState * object;
		object = collect_values[0].v_pointer;
#line 75 "../src/client/accounts/accounts-manager.vala"
		if (object->parent_instance.g_class == NULL) {
#line 75 "../src/client/accounts/accounts-manager.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 9183 "accounts-manager.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 75 "../src/client/accounts/accounts-manager.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 9187 "accounts-manager.c"
		}
#line 75 "../src/client/accounts/accounts-manager.vala"
		value->data[0].v_pointer = accounts_manager_account_state_ref (object);
#line 9191 "accounts-manager.c"
	} else {
#line 75 "../src/client/accounts/accounts-manager.vala"
		value->data[0].v_pointer = NULL;
#line 9195 "accounts-manager.c"
	}
#line 75 "../src/client/accounts/accounts-manager.vala"
	return NULL;
#line 9199 "accounts-manager.c"
}

static gchar*
accounts_manager_value_account_state_lcopy_value (const GValue* value,
                                                  guint n_collect_values,
                                                  GTypeCValue* collect_values,
                                                  guint collect_flags)
{
	AccountsManagerAccountState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 75 "../src/client/accounts/accounts-manager.vala"
	if (!object_p) {
#line 75 "../src/client/accounts/accounts-manager.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 9214 "accounts-manager.c"
	}
#line 75 "../src/client/accounts/accounts-manager.vala"
	if (!value->data[0].v_pointer) {
#line 75 "../src/client/accounts/accounts-manager.vala"
		*object_p = NULL;
#line 9220 "accounts-manager.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 75 "../src/client/accounts/accounts-manager.vala"
		*object_p = value->data[0].v_pointer;
#line 9224 "accounts-manager.c"
	} else {
#line 75 "../src/client/accounts/accounts-manager.vala"
		*object_p = accounts_manager_account_state_ref (value->data[0].v_pointer);
#line 9228 "accounts-manager.c"
	}
#line 75 "../src/client/accounts/accounts-manager.vala"
	return NULL;
#line 9232 "accounts-manager.c"
}

static GParamSpec*
accounts_manager_param_spec_account_state (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags)
{
	AccountsManagerParamSpecAccountState* spec;
#line 75 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (g_type_is_a (object_type, ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE), NULL);
#line 75 "../src/client/accounts/accounts-manager.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 75 "../src/client/accounts/accounts-manager.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 75 "../src/client/accounts/accounts-manager.vala"
	return G_PARAM_SPEC (spec);
#line 9251 "accounts-manager.c"
}

static gpointer
accounts_manager_value_get_account_state (const GValue* value)
{
#line 75 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE), NULL);
#line 75 "../src/client/accounts/accounts-manager.vala"
	return value->data[0].v_pointer;
#line 9261 "accounts-manager.c"
}

static void
accounts_manager_value_set_account_state (GValue* value,
                                          gpointer v_object)
{
	AccountsManagerAccountState * old;
#line 75 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE));
#line 75 "../src/client/accounts/accounts-manager.vala"
	old = value->data[0].v_pointer;
#line 75 "../src/client/accounts/accounts-manager.vala"
	if (v_object) {
#line 75 "../src/client/accounts/accounts-manager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE));
#line 75 "../src/client/accounts/accounts-manager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 75 "../src/client/accounts/accounts-manager.vala"
		value->data[0].v_pointer = v_object;
#line 75 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_account_state_ref (value->data[0].v_pointer);
#line 9283 "accounts-manager.c"
	} else {
#line 75 "../src/client/accounts/accounts-manager.vala"
		value->data[0].v_pointer = NULL;
#line 9287 "accounts-manager.c"
	}
#line 75 "../src/client/accounts/accounts-manager.vala"
	if (old) {
#line 75 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_account_state_unref (old);
#line 9293 "accounts-manager.c"
	}
}

static void
accounts_manager_value_take_account_state (GValue* value,
                                           gpointer v_object)
{
	AccountsManagerAccountState * old;
#line 75 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE));
#line 75 "../src/client/accounts/accounts-manager.vala"
	old = value->data[0].v_pointer;
#line 75 "../src/client/accounts/accounts-manager.vala"
	if (v_object) {
#line 75 "../src/client/accounts/accounts-manager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE));
#line 75 "../src/client/accounts/accounts-manager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 75 "../src/client/accounts/accounts-manager.vala"
		value->data[0].v_pointer = v_object;
#line 9314 "accounts-manager.c"
	} else {
#line 75 "../src/client/accounts/accounts-manager.vala"
		value->data[0].v_pointer = NULL;
#line 9318 "accounts-manager.c"
	}
#line 75 "../src/client/accounts/accounts-manager.vala"
	if (old) {
#line 75 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_account_state_unref (old);
#line 9324 "accounts-manager.c"
	}
}

static void
accounts_manager_account_state_class_init (AccountsManagerAccountStateClass * klass,
                                           gpointer klass_data)
{
#line 75 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_account_state_parent_class = g_type_class_peek_parent (klass);
#line 75 "../src/client/accounts/accounts-manager.vala"
	((AccountsManagerAccountStateClass *) klass)->finalize = accounts_manager_account_state_finalize;
#line 75 "../src/client/accounts/accounts-manager.vala"
	g_type_class_adjust_private_offset (klass, &AccountsManagerAccountState_private_offset);
#line 9338 "accounts-manager.c"
}

static void
accounts_manager_account_state_instance_init (AccountsManagerAccountState * self,
                                              gpointer klass)
{
#line 75 "../src/client/accounts/accounts-manager.vala"
	self->priv = accounts_manager_account_state_get_instance_private (self);
#line 96 "../src/client/accounts/accounts-manager.vala"
	self->priv->_enabled = TRUE;
#line 99 "../src/client/accounts/accounts-manager.vala"
	self->priv->_available = TRUE;
#line 75 "../src/client/accounts/accounts-manager.vala"
	self->ref_count = 1;
#line 9353 "accounts-manager.c"
}

static void
accounts_manager_account_state_finalize (AccountsManagerAccountState * obj)
{
	AccountsManagerAccountState * self;
#line 75 "../src/client/accounts/accounts-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE, AccountsManagerAccountState);
#line 75 "../src/client/accounts/accounts-manager.vala"
	g_signal_handlers_destroy (self);
#line 79 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (self->priv->_account);
#line 9366 "accounts-manager.c"
}

/** Specifies an account's current state. */
static GType
accounts_manager_account_state_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { accounts_manager_value_account_state_init, accounts_manager_value_account_state_free_value, accounts_manager_value_account_state_copy_value, accounts_manager_value_account_state_peek_pointer, "p", accounts_manager_value_account_state_collect_value, "p", accounts_manager_value_account_state_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (AccountsManagerAccountStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) accounts_manager_account_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AccountsManagerAccountState), 0, (GInstanceInitFunc) accounts_manager_account_state_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType accounts_manager_account_state_type_id;
	accounts_manager_account_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "AccountsManagerAccountState", &g_define_type_info, &g_define_type_fundamental_info, 0);
	AccountsManagerAccountState_private_offset = g_type_add_instance_private (accounts_manager_account_state_type_id, sizeof (AccountsManagerAccountStatePrivate));
	return accounts_manager_account_state_type_id;
}

static GType
accounts_manager_account_state_get_type (void)
{
	static volatile gsize accounts_manager_account_state_type_id__once = 0;
	if (g_once_init_enter (&accounts_manager_account_state_type_id__once)) {
		GType accounts_manager_account_state_type_id;
		accounts_manager_account_state_type_id = accounts_manager_account_state_get_type_once ();
		g_once_init_leave (&accounts_manager_account_state_type_id__once, accounts_manager_account_state_type_id);
	}
	return accounts_manager_account_state_type_id__once;
}

static gpointer
accounts_manager_account_state_ref (gpointer instance)
{
	AccountsManagerAccountState * self;
	self = instance;
#line 75 "../src/client/accounts/accounts-manager.vala"
	g_atomic_int_inc (&self->ref_count);
#line 75 "../src/client/accounts/accounts-manager.vala"
	return instance;
#line 9403 "accounts-manager.c"
}

static void
accounts_manager_account_state_unref (gpointer instance)
{
	AccountsManagerAccountState * self;
	self = instance;
#line 75 "../src/client/accounts/accounts-manager.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 75 "../src/client/accounts/accounts-manager.vala"
		ACCOUNTS_MANAGER_ACCOUNT_STATE_GET_CLASS (self)->finalize (self);
#line 75 "../src/client/accounts/accounts-manager.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 9417 "accounts-manager.c"
	}
}

static void
accounts_manager_class_init (AccountsManagerClass * klass,
                             gpointer klass_data)
{
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_type_class_adjust_private_offset (klass, &AccountsManager_private_offset);
#line 24 "../src/client/accounts/accounts-manager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_accounts_manager_get_property;
#line 24 "../src/client/accounts/accounts-manager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_accounts_manager_set_property;
#line 24 "../src/client/accounts/accounts-manager.vala"
	G_OBJECT_CLASS (klass)->finalize = accounts_manager_finalize;
#line 9435 "accounts-manager.c"
	/** Returns the number of currently known accounts. */
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACCOUNTS_MANAGER_SIZE_PROPERTY, accounts_manager_properties[ACCOUNTS_MANAGER_SIZE_PROPERTY] = g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 9439 "accounts-manager.c"
	/** Returns the base directory for account configuration. */
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACCOUNTS_MANAGER_CONFIG_DIR_PROPERTY, accounts_manager_properties[ACCOUNTS_MANAGER_CONFIG_DIR_PROPERTY] = g_param_spec_object ("config-dir", "config-dir", "config-dir", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 9443 "accounts-manager.c"
	/** Returns the base directory for account data. */
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACCOUNTS_MANAGER_DATA_DIR_PROPERTY, accounts_manager_properties[ACCOUNTS_MANAGER_DATA_DIR_PROPERTY] = g_param_spec_object ("data-dir", "data-dir", "data-dir", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 9447 "accounts-manager.c"
	/** Fired when a new account is created. */
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_signals[ACCOUNTS_MANAGER_ACCOUNT_ADDED_SIGNAL] = g_signal_new ("account-added", ACCOUNTS_TYPE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_ENUM, G_TYPE_NONE, 2, GEARY_TYPE_ACCOUNT_INFORMATION, ACCOUNTS_MANAGER_TYPE_STATUS);
#line 9451 "accounts-manager.c"
	/** Fired when an existing account's state has changed. */
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_signals[ACCOUNTS_MANAGER_ACCOUNT_STATUS_CHANGED_SIGNAL] = g_signal_new ("account-status-changed", ACCOUNTS_TYPE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_ENUM, G_TYPE_NONE, 2, GEARY_TYPE_ACCOUNT_INFORMATION, ACCOUNTS_MANAGER_TYPE_STATUS);
#line 9455 "accounts-manager.c"
	/** Fired when an account is deleted. */
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_signals[ACCOUNTS_MANAGER_ACCOUNT_REMOVED_SIGNAL] = g_signal_new ("account-removed", ACCOUNTS_TYPE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_TYPE_ACCOUNT_INFORMATION);
#line 9459 "accounts-manager.c"
	/** Emitted to notify an account problem has occurred. */
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_signals[ACCOUNTS_MANAGER_REPORT_PROBLEM_SIGNAL] = g_signal_new ("report-problem", ACCOUNTS_TYPE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_TYPE_PROBLEM_REPORT);
#line 9463 "accounts-manager.c"
}

static void
accounts_manager_instance_init (AccountsManager * self,
                                gpointer klass)
{
	GeeHashMap* _tmp0_;
	GeeLinkedList* _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	self->priv = accounts_manager_get_instance_private (self);
#line 119 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE, (GBoxedCopyFunc) accounts_manager_account_state_ref, (GDestroyNotify) accounts_manager_account_state_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 119 "../src/client/accounts/accounts-manager.vala"
	self->priv->accounts = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_MAP, GeeMap);
#line 122 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = gee_linked_list_new (GEARY_TYPE_ACCOUNT_INFORMATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 122 "../src/client/accounts/accounts-manager.vala"
	self->priv->removed = _tmp1_;
#line 127 "../src/client/accounts/accounts-manager.vala"
	self->priv->goa_service = NULL;
#line 9484 "accounts-manager.c"
}

static void
accounts_manager_finalize (GObject * obj)
{
	AccountsManager * self;
#line 24 "../src/client/accounts/accounts-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ACCOUNTS_TYPE_MANAGER, AccountsManager);
#line 113 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (self->priv->_config_dir);
#line 116 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (self->priv->_data_dir);
#line 119 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (self->priv->accounts);
#line 122 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (self->priv->removed);
#line 126 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (self->priv->local_mediator);
#line 127 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (self->priv->goa_service);
#line 24 "../src/client/accounts/accounts-manager.vala"
	G_OBJECT_CLASS (accounts_manager_parent_class)->finalize (obj);
#line 9507 "accounts-manager.c"
}

/**
 * Manages email account lifecycle for Geary.
 *
 * This class is responsible for creating, loading, saving and
 * removing accounts and their persisted data (configuration,
 * databases, caches, authentication tokens). The manager supports
 * both locally-specified accounts (i.e. those created by the user in
 * the app) and from SSO systems such as GOA via the Accounts.Provider
 * interface.
 *
 * Newly loaded and newly created accounts are first added to the
 * manager with a particular status (enabled, disabled, etc). Accounts
 * can have their enabled or disabled status updated manually,
 */
static GType
accounts_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AccountsManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) accounts_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AccountsManager), 0, (GInstanceInitFunc) accounts_manager_instance_init, NULL };
	GType accounts_manager_type_id;
	accounts_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "AccountsManager", &g_define_type_info, 0);
	AccountsManager_private_offset = g_type_add_instance_private (accounts_manager_type_id, sizeof (AccountsManagerPrivate));
	return accounts_manager_type_id;
}

GType
accounts_manager_get_type (void)
{
	static volatile gsize accounts_manager_type_id__once = 0;
	if (g_once_init_enter (&accounts_manager_type_id__once)) {
		GType accounts_manager_type_id;
		accounts_manager_type_id = accounts_manager_get_type_once ();
		g_once_init_leave (&accounts_manager_type_id__once, accounts_manager_type_id);
	}
	return accounts_manager_type_id__once;
}

static void
_vala_accounts_manager_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	AccountsManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ACCOUNTS_TYPE_MANAGER, AccountsManager);
#line 24 "../src/client/accounts/accounts-manager.vala"
	switch (property_id) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		case ACCOUNTS_MANAGER_SIZE_PROPERTY:
#line 24 "../src/client/accounts/accounts-manager.vala"
		g_value_set_int (value, accounts_manager_get_size (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
		break;
#line 24 "../src/client/accounts/accounts-manager.vala"
		case ACCOUNTS_MANAGER_CONFIG_DIR_PROPERTY:
#line 24 "../src/client/accounts/accounts-manager.vala"
		g_value_set_object (value, accounts_manager_get_config_dir (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
		break;
#line 24 "../src/client/accounts/accounts-manager.vala"
		case ACCOUNTS_MANAGER_DATA_DIR_PROPERTY:
#line 24 "../src/client/accounts/accounts-manager.vala"
		g_value_set_object (value, accounts_manager_get_data_dir (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
		break;
#line 9574 "accounts-manager.c"
		default:
#line 24 "../src/client/accounts/accounts-manager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/client/accounts/accounts-manager.vala"
		break;
#line 9580 "accounts-manager.c"
	}
}

static void
_vala_accounts_manager_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	AccountsManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ACCOUNTS_TYPE_MANAGER, AccountsManager);
#line 24 "../src/client/accounts/accounts-manager.vala"
	switch (property_id) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		case ACCOUNTS_MANAGER_CONFIG_DIR_PROPERTY:
#line 24 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_set_config_dir (self, g_value_get_object (value));
#line 24 "../src/client/accounts/accounts-manager.vala"
		break;
#line 24 "../src/client/accounts/accounts-manager.vala"
		case ACCOUNTS_MANAGER_DATA_DIR_PROPERTY:
#line 24 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_set_data_dir (self, g_value_get_object (value));
#line 24 "../src/client/accounts/accounts-manager.vala"
		break;
#line 9606 "accounts-manager.c"
		default:
#line 24 "../src/client/accounts/accounts-manager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/client/accounts/accounts-manager.vala"
		break;
#line 9612 "accounts-manager.c"
	}
}

/** Loads a supported account from a config file. */
GearyAccountInformation*
accounts_account_config_load (AccountsAccountConfig* self,
                              GearyConfigFile* config,
                              const gchar* id,
                              GearyCredentialsMediator* mediator,
                              GearyServiceProvider* default_provider,
                              const gchar* default_name,
                              GError** error)
{
	AccountsAccountConfigIface* _iface_;
#line 962 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_ACCOUNT_CONFIG (self), NULL);
#line 962 "../src/client/accounts/accounts-manager.vala"
	_iface_ = ACCOUNTS_ACCOUNT_CONFIG_GET_INTERFACE (self);
#line 962 "../src/client/accounts/accounts-manager.vala"
	if (_iface_->load) {
#line 962 "../src/client/accounts/accounts-manager.vala"
		return _iface_->load (self, config, id, mediator, default_provider, default_name, error);
#line 9635 "accounts-manager.c"
	}
#line 962 "../src/client/accounts/accounts-manager.vala"
	return NULL;
#line 9639 "accounts-manager.c"
}

/** Saves an account to a config file. */
void
accounts_account_config_save (AccountsAccountConfig* self,
                              GearyAccountInformation* account,
                              GearyConfigFile* config)
{
	AccountsAccountConfigIface* _iface_;
#line 971 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_ACCOUNT_CONFIG (self));
#line 971 "../src/client/accounts/accounts-manager.vala"
	_iface_ = ACCOUNTS_ACCOUNT_CONFIG_GET_INTERFACE (self);
#line 971 "../src/client/accounts/accounts-manager.vala"
	if (_iface_->save) {
#line 971 "../src/client/accounts/accounts-manager.vala"
		_iface_->save (self, account, config);
#line 9657 "accounts-manager.c"
	}
}

static void
accounts_account_config_default_init (AccountsAccountConfigIface * iface,
                                      gpointer iface_data)
{
}

/** Objects that can be used to load/save account configuration. */
static GType
accounts_account_config_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AccountsAccountConfigIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) accounts_account_config_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType accounts_account_config_type_id;
	accounts_account_config_type_id = g_type_register_static (G_TYPE_INTERFACE, "AccountsAccountConfig", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (accounts_account_config_type_id, G_TYPE_OBJECT);
	return accounts_account_config_type_id;
}

GType
accounts_account_config_get_type (void)
{
	static volatile gsize accounts_account_config_type_id__once = 0;
	if (g_once_init_enter (&accounts_account_config_type_id__once)) {
		GType accounts_account_config_type_id;
		accounts_account_config_type_id = accounts_account_config_get_type_once ();
		g_once_init_leave (&accounts_account_config_type_id__once, accounts_account_config_type_id);
	}
	return accounts_account_config_type_id__once;
}

/** Loads a service from a config file. */
void
accounts_service_config_load (AccountsServiceConfig* self,
                              GearyConfigFile* config,
                              GearyAccountInformation* account,
                              GearyServiceInformation* service,
                              GError** error)
{
	AccountsServiceConfigIface* _iface_;
#line 981 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_SERVICE_CONFIG (self));
#line 981 "../src/client/accounts/accounts-manager.vala"
	_iface_ = ACCOUNTS_SERVICE_CONFIG_GET_INTERFACE (self);
#line 981 "../src/client/accounts/accounts-manager.vala"
	if (_iface_->load) {
#line 981 "../src/client/accounts/accounts-manager.vala"
		_iface_->load (self, config, account, service, error);
#line 9707 "accounts-manager.c"
	}
}

/** Saves a service to a config file. */
void
accounts_service_config_save (AccountsServiceConfig* self,
                              GearyAccountInformation* account,
                              GearyServiceInformation* service,
                              GearyConfigFile* config)
{
	AccountsServiceConfigIface* _iface_;
#line 987 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_SERVICE_CONFIG (self));
#line 987 "../src/client/accounts/accounts-manager.vala"
	_iface_ = ACCOUNTS_SERVICE_CONFIG_GET_INTERFACE (self);
#line 987 "../src/client/accounts/accounts-manager.vala"
	if (_iface_->save) {
#line 987 "../src/client/accounts/accounts-manager.vala"
		_iface_->save (self, account, service, config);
#line 9727 "accounts-manager.c"
	}
}

static void
accounts_service_config_default_init (AccountsServiceConfigIface * iface,
                                      gpointer iface_data)
{
}

/** Objects that can be used to load/save service configuration. */
static GType
accounts_service_config_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AccountsServiceConfigIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) accounts_service_config_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType accounts_service_config_type_id;
	accounts_service_config_type_id = g_type_register_static (G_TYPE_INTERFACE, "AccountsServiceConfig", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (accounts_service_config_type_id, G_TYPE_OBJECT);
	return accounts_service_config_type_id;
}

GType
accounts_service_config_get_type (void)
{
	static volatile gsize accounts_service_config_type_id__once = 0;
	if (g_once_init_enter (&accounts_service_config_type_id__once)) {
		GType accounts_service_config_type_id;
		accounts_service_config_type_id = accounts_service_config_get_type_once ();
		g_once_init_leave (&accounts_service_config_type_id__once, accounts_service_config_type_id);
	}
	return accounts_service_config_type_id__once;
}

GQuark
accounts_config_error_quark (void)
{
	return g_quark_from_static_string ("accounts-config-error-quark");
}

static GType
accounts_config_error_get_type_once (void)
{
	static const GEnumValue values[] = {{ACCOUNTS_CONFIG_ERROR_IO, "ACCOUNTS_CONFIG_ERROR_IO", "io"}, {ACCOUNTS_CONFIG_ERROR_MANAGEMENT, "ACCOUNTS_CONFIG_ERROR_MANAGEMENT", "management"}, {ACCOUNTS_CONFIG_ERROR_SYNTAX, "ACCOUNTS_CONFIG_ERROR_SYNTAX", "syntax"}, {ACCOUNTS_CONFIG_ERROR_VERSION, "ACCOUNTS_CONFIG_ERROR_VERSION", "version"}, {ACCOUNTS_CONFIG_ERROR_UNAVAILABLE, "ACCOUNTS_CONFIG_ERROR_UNAVAILABLE", "unavailable"}, {ACCOUNTS_CONFIG_ERROR_REMOVED, "ACCOUNTS_CONFIG_ERROR_REMOVED", "removed"}, {0, NULL, NULL}};
	GType accounts_config_error_type_id;
	accounts_config_error_type_id = g_enum_register_static ("AccountsConfigError", values);
	return accounts_config_error_type_id;
}

GType
accounts_config_error_get_type (void)
{
	static volatile gsize accounts_config_error_type_id__once = 0;
	if (g_once_init_enter (&accounts_config_error_type_id__once)) {
		GType accounts_config_error_type_id;
		accounts_config_error_type_id = accounts_config_error_get_type_once ();
		g_once_init_leave (&accounts_config_error_type_id__once, accounts_config_error_type_id);
	}
	return accounts_config_error_type_id__once;
}

static inline gpointer
accounts_account_config_v1_get_instance_private (AccountsAccountConfigV1* self)
{
	return G_STRUCT_MEMBER_P (self, AccountsAccountConfigV1_private_offset);
}

AccountsAccountConfigV1*
accounts_account_config_v1_construct (GType object_type,
                                      gboolean is_managed)
{
	AccountsAccountConfigV1 * self = NULL;
#line 1033 "../src/client/accounts/accounts-manager.vala"
	self = (AccountsAccountConfigV1*) g_object_new (object_type, NULL);
#line 1034 "../src/client/accounts/accounts-manager.vala"
	self->priv->is_managed = is_managed;
#line 1033 "../src/client/accounts/accounts-manager.vala"
	return self;
#line 9804 "accounts-manager.c"
}

AccountsAccountConfigV1*
accounts_account_config_v1_new (gboolean is_managed)
{
#line 1033 "../src/client/accounts/accounts-manager.vala"
	return accounts_account_config_v1_construct (ACCOUNTS_TYPE_ACCOUNT_CONFIG_V1, is_managed);
#line 9812 "accounts-manager.c"
}

static GearyServiceProvider
___lambda7_ (AccountsAccountConfigV1* self,
             const gchar* value,
             GError** error)
{
	GError* _inner_error0_ = NULL;
	GearyServiceProvider result;
#line 1070 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (value != NULL, 0);
#line 9824 "accounts-manager.c"
	{
		GearyServiceProvider _tmp0_ = 0;
#line 1072 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = geary_service_provider_for_value (value, &_inner_error0_);
#line 1072 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1072 "../src/client/accounts/accounts-manager.vala"
			if (_inner_error0_->domain == GEARY_ENGINE_ERROR) {
#line 9833 "accounts-manager.c"
				goto __catch0_geary_engine_error;
			}
#line 1072 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1072 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_inner_error0_);
#line 1072 "../src/client/accounts/accounts-manager.vala"
			return 0;
#line 9842 "accounts-manager.c"
		}
#line 1072 "../src/client/accounts/accounts-manager.vala"
		result = _tmp0_;
#line 1072 "../src/client/accounts/accounts-manager.vala"
		return result;
#line 9848 "accounts-manager.c"
	}
	goto __finally0;
	__catch0_geary_engine_error:
	{
		GError* err = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		GError* _tmp3_;
#line 1071 "../src/client/accounts/accounts-manager.vala"
		err = _inner_error0_;
#line 1071 "../src/client/accounts/accounts-manager.vala"
		_inner_error0_ = NULL;
#line 1074 "../src/client/accounts/accounts-manager.vala"
		_tmp1_ = err;
#line 1074 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = _tmp1_->message;
#line 1074 "../src/client/accounts/accounts-manager.vala"
		_tmp3_ = g_error_new_literal (G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_INVALID_VALUE, _tmp2_);
#line 1074 "../src/client/accounts/accounts-manager.vala"
		_inner_error0_ = _tmp3_;
#line 1074 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (err);
#line 9871 "accounts-manager.c"
		goto __finally0;
	}
	__finally0:
#line 1071 "../src/client/accounts/accounts-manager.vala"
	if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1071 "../src/client/accounts/accounts-manager.vala"
		g_propagate_error (error, _inner_error0_);
#line 1071 "../src/client/accounts/accounts-manager.vala"
		return 0;
#line 9881 "accounts-manager.c"
	} else {
#line 1071 "../src/client/accounts/accounts-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1071 "../src/client/accounts/accounts-manager.vala"
		g_clear_error (&_inner_error0_);
#line 1071 "../src/client/accounts/accounts-manager.vala"
		return 0;
#line 9889 "accounts-manager.c"
	}
}

static gpointer
____lambda7__geary_config_file_parser (const gchar* value,
                                       gpointer self,
                                       GError** error)
{
	gpointer result;
	result = (gpointer) ((gintptr) ___lambda7_ ((AccountsAccountConfigV1*) self, value, error));
#line 1068 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 9902 "accounts-manager.c"
}

static GearyAccountInformation*
accounts_account_config_v1_real_load (AccountsAccountConfig* base,
                                      GearyConfigFile* config,
                                      const gchar* id,
                                      GearyCredentialsMediator* mediator,
                                      GearyServiceProvider* default_provider,
                                      const gchar* default_name,
                                      GError** error)
{
	AccountsAccountConfigV1 * self;
	GearyConfigFileGroup* account_config = NULL;
	GearyConfigFileGroup* _tmp0_;
	GeeList* senders = NULL;
	GeeLinkedList* _tmp1_;
	GeeList* _tmp2_ = NULL;
	GearyConfigFileGroup* _tmp3_;
	GeeList* _tmp4_;
	GeeList* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
	GearyServiceProvider* _tmp22_ = NULL;
	GearyServiceProvider provider = 0;
	GearyAccountInformation* account = NULL;
	GeeList* _tmp28_;
	gpointer _tmp29_;
	GearyRFC822MailboxAddress* _tmp30_;
	GearyAccountInformation* _tmp31_;
	GearyAccountInformation* _tmp32_;
	GearyAccountInformation* _tmp33_;
	GearyConfigFileGroup* _tmp34_;
	gint _tmp35_;
	GearyAccountInformation* _tmp36_;
	GearyConfigFileGroup* _tmp37_;
	GearyAccountInformation* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	GearyAccountInformation* _tmp43_;
	GearyConfigFileGroup* _tmp44_;
	GearyAccountInformation* _tmp45_;
	gint _tmp46_;
	gint _tmp47_;
	GearyAccountInformation* _tmp48_;
	GearyConfigFileGroup* _tmp49_;
	GearyAccountInformation* _tmp50_;
	gboolean _tmp51_;
	gboolean _tmp52_;
	GearyAccountInformation* _tmp53_;
	GearyConfigFileGroup* _tmp54_;
	GearyAccountInformation* _tmp55_;
	gboolean _tmp56_;
	gboolean _tmp57_;
	GearyAccountInformation* _tmp58_;
	GearyConfigFileGroup* _tmp59_;
	GearyAccountInformation* _tmp60_;
	gboolean _tmp61_;
	gboolean _tmp62_;
	GearyAccountInformation* _tmp63_;
	GearyConfigFileGroup* _tmp64_;
	GearyAccountInformation* _tmp65_;
	const gchar* _tmp66_;
	const gchar* _tmp67_;
	gchar* _tmp68_;
	gchar* _tmp69_;
	GearyConfigFileGroup* folder_config = NULL;
	GearyConfigFileGroup* _tmp80_;
	GearyAccountInformation* _tmp81_;
	GearyConfigFileGroup* _tmp82_;
	GeeList* _tmp83_;
	GeeList* _tmp84_;
	GearyAccountInformation* _tmp85_;
	GearyConfigFileGroup* _tmp86_;
	GeeList* _tmp87_;
	GeeList* _tmp88_;
	GearyAccountInformation* _tmp89_;
	GearyConfigFileGroup* _tmp90_;
	GeeList* _tmp91_;
	GeeList* _tmp92_;
	GearyConfigFileGroup* _tmp93_;
	GearyConfigFileGroup* _tmp98_;
	GearyAccountInformation* _tmp103_;
	GearyConfigFileGroup* _tmp104_;
	GeeList* _tmp105_;
	GeeList* _tmp106_;
	GError* _inner_error0_ = NULL;
	GearyAccountInformation* result;
#line 1037 "../src/client/accounts/accounts-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, ACCOUNTS_TYPE_ACCOUNT_CONFIG_V1, AccountsAccountConfigV1);
#line 1037 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (config, GEARY_TYPE_CONFIG_FILE), NULL);
#line 1037 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 1037 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (mediator, GEARY_TYPE_CREDENTIALS_MEDIATOR), NULL);
#line 1043 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = geary_config_file_get_group (config, ACCOUNTS_ACCOUNT_CONFIG_V1_GROUP_ACCOUNT);
#line 1043 "../src/client/accounts/accounts-manager.vala"
	account_config = _tmp0_;
#line 1046 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = gee_linked_list_new (GEARY_RF_C822_TYPE_MAILBOX_ADDRESS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1046 "../src/client/accounts/accounts-manager.vala"
	senders = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_LIST, GeeList);
#line 1049 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = account_config;
#line 1049 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = geary_config_file_group_get_required_string_list (_tmp3_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_SENDERS, &_inner_error0_);
#line 1049 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _tmp4_;
#line 1049 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1049 "../src/client/accounts/accounts-manager.vala"
		if ((_inner_error0_->domain == ACCOUNTS_CONFIG_ERROR) || (_inner_error0_->domain == G_KEY_FILE_ERROR)) {
#line 1049 "../src/client/accounts/accounts-manager.vala"
			g_propagate_error (error, _inner_error0_);
#line 1049 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (senders);
#line 1049 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (account_config);
#line 1049 "../src/client/accounts/accounts-manager.vala"
			return NULL;
#line 10026 "accounts-manager.c"
		} else {
#line 1049 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (senders);
#line 1049 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (account_config);
#line 1049 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1049 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_inner_error0_);
#line 1049 "../src/client/accounts/accounts-manager.vala"
			return NULL;
#line 10038 "accounts-manager.c"
		}
	}
	{
		GeeList* _sender_list = NULL;
		gint _sender_size = 0;
		GeeList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _sender_index = 0;
#line 1048 "../src/client/accounts/accounts-manager.vala"
		_sender_list = _tmp2_;
#line 1048 "../src/client/accounts/accounts-manager.vala"
		_tmp5_ = _sender_list;
#line 1048 "../src/client/accounts/accounts-manager.vala"
		_tmp6_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1048 "../src/client/accounts/accounts-manager.vala"
		_tmp7_ = _tmp6_;
#line 1048 "../src/client/accounts/accounts-manager.vala"
		_sender_size = _tmp7_;
#line 1048 "../src/client/accounts/accounts-manager.vala"
		_sender_index = -1;
#line 1048 "../src/client/accounts/accounts-manager.vala"
		while (TRUE) {
#line 10062 "accounts-manager.c"
			gint _tmp8_;
			gint _tmp9_;
			gchar* sender = NULL;
			GeeList* _tmp10_;
			gpointer _tmp11_;
#line 1048 "../src/client/accounts/accounts-manager.vala"
			_sender_index = _sender_index + 1;
#line 1048 "../src/client/accounts/accounts-manager.vala"
			_tmp8_ = _sender_index;
#line 1048 "../src/client/accounts/accounts-manager.vala"
			_tmp9_ = _sender_size;
#line 1048 "../src/client/accounts/accounts-manager.vala"
			if (!(_tmp8_ < _tmp9_)) {
#line 1048 "../src/client/accounts/accounts-manager.vala"
				break;
#line 10078 "accounts-manager.c"
			}
#line 1048 "../src/client/accounts/accounts-manager.vala"
			_tmp10_ = _sender_list;
#line 1048 "../src/client/accounts/accounts-manager.vala"
			_tmp11_ = gee_list_get (_tmp10_, _sender_index);
#line 1048 "../src/client/accounts/accounts-manager.vala"
			sender = (gchar*) _tmp11_;
#line 10086 "accounts-manager.c"
			{
				GearyRFC822MailboxAddress* _tmp12_ = NULL;
				const gchar* _tmp13_;
				GearyRFC822MailboxAddress* _tmp14_;
				GeeList* _tmp15_;
#line 1052 "../src/client/accounts/accounts-manager.vala"
				_tmp13_ = sender;
#line 1052 "../src/client/accounts/accounts-manager.vala"
				_tmp14_ = geary_rf_c822_mailbox_address_new_from_rfc822_string (_tmp13_, &_inner_error0_);
#line 1052 "../src/client/accounts/accounts-manager.vala"
				_tmp12_ = _tmp14_;
#line 1052 "../src/client/accounts/accounts-manager.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1052 "../src/client/accounts/accounts-manager.vala"
					if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 10102 "accounts-manager.c"
						goto __catch0_geary_rf_c822_error;
					}
#line 1052 "../src/client/accounts/accounts-manager.vala"
					_g_free0 (sender);
#line 1052 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (_tmp2_);
#line 1052 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (senders);
#line 1052 "../src/client/accounts/accounts-manager.vala"
					_geary_config_file_group_unref0 (account_config);
#line 1052 "../src/client/accounts/accounts-manager.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1052 "../src/client/accounts/accounts-manager.vala"
					g_clear_error (&_inner_error0_);
#line 1052 "../src/client/accounts/accounts-manager.vala"
					return NULL;
#line 10119 "accounts-manager.c"
				}
#line 1051 "../src/client/accounts/accounts-manager.vala"
				_tmp15_ = senders;
#line 1051 "../src/client/accounts/accounts-manager.vala"
				gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_COLLECTION, GeeCollection), _tmp12_);
#line 1050 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_tmp12_);
#line 10127 "accounts-manager.c"
			}
			goto __finally0;
			__catch0_geary_rf_c822_error:
			{
				const gchar* _tmp16_;
				GError* _tmp17_;
#line 1050 "../src/client/accounts/accounts-manager.vala"
				g_clear_error (&_inner_error0_);
#line 1055 "../src/client/accounts/accounts-manager.vala"
				_tmp16_ = sender;
#line 1055 "../src/client/accounts/accounts-manager.vala"
				_tmp17_ = g_error_new (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_SYNTAX, "%s: Invalid sender address: %s", id, _tmp16_);
#line 1055 "../src/client/accounts/accounts-manager.vala"
				_inner_error0_ = _tmp17_;
#line 10142 "accounts-manager.c"
				goto __finally0;
			}
			__finally0:
#line 1050 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1050 "../src/client/accounts/accounts-manager.vala"
				if ((_inner_error0_->domain == ACCOUNTS_CONFIG_ERROR) || (_inner_error0_->domain == G_KEY_FILE_ERROR)) {
#line 1050 "../src/client/accounts/accounts-manager.vala"
					g_propagate_error (error, _inner_error0_);
#line 1050 "../src/client/accounts/accounts-manager.vala"
					_g_free0 (sender);
#line 1050 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (_tmp2_);
#line 1050 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (senders);
#line 1050 "../src/client/accounts/accounts-manager.vala"
					_geary_config_file_group_unref0 (account_config);
#line 1050 "../src/client/accounts/accounts-manager.vala"
					return NULL;
#line 10162 "accounts-manager.c"
				} else {
#line 1050 "../src/client/accounts/accounts-manager.vala"
					_g_free0 (sender);
#line 1050 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (_tmp2_);
#line 1050 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (senders);
#line 1050 "../src/client/accounts/accounts-manager.vala"
					_geary_config_file_group_unref0 (account_config);
#line 1050 "../src/client/accounts/accounts-manager.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1050 "../src/client/accounts/accounts-manager.vala"
					g_clear_error (&_inner_error0_);
#line 1050 "../src/client/accounts/accounts-manager.vala"
					return NULL;
#line 10178 "accounts-manager.c"
				}
			}
#line 1048 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (sender);
#line 10183 "accounts-manager.c"
		}
	}
#line 1061 "../src/client/accounts/accounts-manager.vala"
	_tmp18_ = senders;
#line 1061 "../src/client/accounts/accounts-manager.vala"
	_tmp19_ = gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1061 "../src/client/accounts/accounts-manager.vala"
	_tmp20_ = _tmp19_;
#line 1061 "../src/client/accounts/accounts-manager.vala"
	if (_tmp20_) {
#line 10194 "accounts-manager.c"
		GError* _tmp21_;
#line 1062 "../src/client/accounts/accounts-manager.vala"
		_tmp21_ = g_error_new (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_SYNTAX, "%s: No sender addresses found", id);
#line 1062 "../src/client/accounts/accounts-manager.vala"
		_inner_error0_ = _tmp21_;
#line 1062 "../src/client/accounts/accounts-manager.vala"
		if ((_inner_error0_->domain == ACCOUNTS_CONFIG_ERROR) || (_inner_error0_->domain == G_KEY_FILE_ERROR)) {
#line 1062 "../src/client/accounts/accounts-manager.vala"
			g_propagate_error (error, _inner_error0_);
#line 1062 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_tmp2_);
#line 1062 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (senders);
#line 1062 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (account_config);
#line 1062 "../src/client/accounts/accounts-manager.vala"
			return NULL;
#line 10212 "accounts-manager.c"
		} else {
#line 1062 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_tmp2_);
#line 1062 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (senders);
#line 1062 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (account_config);
#line 1062 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1062 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_inner_error0_);
#line 1062 "../src/client/accounts/accounts-manager.vala"
			return NULL;
#line 10226 "accounts-manager.c"
		}
	}
#line 1065 "../src/client/accounts/accounts-manager.vala"
	if (default_provider != NULL) {
#line 10231 "accounts-manager.c"
		GearyServiceProvider* _tmp23_;
#line 1067 "../src/client/accounts/accounts-manager.vala"
		_tmp23_ = __geary_service_provider_dup0 (default_provider);
#line 1067 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp22_);
#line 1067 "../src/client/accounts/accounts-manager.vala"
		_tmp22_ = _tmp23_;
#line 10239 "accounts-manager.c"
	} else {
		GearyConfigFileGroup* _tmp24_;
		gpointer _tmp25_;
		GearyServiceProvider _tmp26_;
		GearyServiceProvider* _tmp27_;
#line 1068 "../src/client/accounts/accounts-manager.vala"
		_tmp24_ = account_config;
#line 1068 "../src/client/accounts/accounts-manager.vala"
		_tmp25_ = geary_config_file_group_parse_required_value (_tmp24_, GEARY_TYPE_SERVICE_PROVIDER, NULL, NULL, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_PROVIDER, ____lambda7__geary_config_file_parser, self, &_inner_error0_);
#line 1068 "../src/client/accounts/accounts-manager.vala"
		_tmp26_ = (GearyServiceProvider) ((gintptr) _tmp25_);
#line 1068 "../src/client/accounts/accounts-manager.vala"
		_tmp27_ = __geary_service_provider_dup0 (&_tmp26_);
#line 1068 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp22_);
#line 1068 "../src/client/accounts/accounts-manager.vala"
		_tmp22_ = _tmp27_;
#line 1068 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1068 "../src/client/accounts/accounts-manager.vala"
			if ((_inner_error0_->domain == ACCOUNTS_CONFIG_ERROR) || (_inner_error0_->domain == G_KEY_FILE_ERROR)) {
#line 1068 "../src/client/accounts/accounts-manager.vala"
				g_propagate_error (error, _inner_error0_);
#line 1068 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp22_);
#line 1068 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_tmp2_);
#line 1068 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (senders);
#line 1068 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (account_config);
#line 1068 "../src/client/accounts/accounts-manager.vala"
				return NULL;
#line 10273 "accounts-manager.c"
			} else {
#line 1068 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp22_);
#line 1068 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_tmp2_);
#line 1068 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (senders);
#line 1068 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (account_config);
#line 1068 "../src/client/accounts/accounts-manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1068 "../src/client/accounts/accounts-manager.vala"
				g_clear_error (&_inner_error0_);
#line 1068 "../src/client/accounts/accounts-manager.vala"
				return NULL;
#line 10289 "accounts-manager.c"
			}
		}
	}
#line 1065 "../src/client/accounts/accounts-manager.vala"
	provider = *_tmp22_;
#line 1080 "../src/client/accounts/accounts-manager.vala"
	_tmp28_ = senders;
#line 1080 "../src/client/accounts/accounts-manager.vala"
	_tmp29_ = gee_list_remove_at (_tmp28_, 0);
#line 1080 "../src/client/accounts/accounts-manager.vala"
	_tmp30_ = (GearyRFC822MailboxAddress*) _tmp29_;
#line 1080 "../src/client/accounts/accounts-manager.vala"
	_tmp31_ = geary_account_information_new (id, provider, mediator, _tmp30_);
#line 1080 "../src/client/accounts/accounts-manager.vala"
	_tmp32_ = _tmp31_;
#line 1080 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp30_);
#line 1080 "../src/client/accounts/accounts-manager.vala"
	account = _tmp32_;
#line 1084 "../src/client/accounts/accounts-manager.vala"
	_tmp33_ = account;
#line 1084 "../src/client/accounts/accounts-manager.vala"
	_tmp34_ = account_config;
#line 1084 "../src/client/accounts/accounts-manager.vala"
	_tmp35_ = geary_account_information_next_ordinal;
#line 1084 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_next_ordinal = _tmp35_ + 1;
#line 1084 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_ordinal (_tmp33_, geary_config_file_group_get_int (_tmp34_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_ORDINAL, _tmp35_));
#line 1087 "../src/client/accounts/accounts-manager.vala"
	_tmp36_ = account;
#line 1087 "../src/client/accounts/accounts-manager.vala"
	_tmp37_ = account_config;
#line 1087 "../src/client/accounts/accounts-manager.vala"
	_tmp38_ = account;
#line 1087 "../src/client/accounts/accounts-manager.vala"
	_tmp39_ = geary_account_information_get_label (_tmp38_);
#line 1087 "../src/client/accounts/accounts-manager.vala"
	_tmp40_ = _tmp39_;
#line 1087 "../src/client/accounts/accounts-manager.vala"
	_tmp41_ = geary_config_file_group_get_string (_tmp37_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_LABEL, _tmp40_);
#line 1087 "../src/client/accounts/accounts-manager.vala"
	_tmp42_ = _tmp41_;
#line 1087 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_label (_tmp36_, _tmp42_);
#line 1087 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp42_);
#line 1090 "../src/client/accounts/accounts-manager.vala"
	_tmp43_ = account;
#line 1090 "../src/client/accounts/accounts-manager.vala"
	_tmp44_ = account_config;
#line 1090 "../src/client/accounts/accounts-manager.vala"
	_tmp45_ = account;
#line 1090 "../src/client/accounts/accounts-manager.vala"
	_tmp46_ = geary_account_information_get_prefetch_period_days (_tmp45_);
#line 1090 "../src/client/accounts/accounts-manager.vala"
	_tmp47_ = _tmp46_;
#line 1090 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_prefetch_period_days (_tmp43_, geary_config_file_group_get_int (_tmp44_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_PREFETCH, _tmp47_));
#line 1093 "../src/client/accounts/accounts-manager.vala"
	_tmp48_ = account;
#line 1093 "../src/client/accounts/accounts-manager.vala"
	_tmp49_ = account_config;
#line 1093 "../src/client/accounts/accounts-manager.vala"
	_tmp50_ = account;
#line 1093 "../src/client/accounts/accounts-manager.vala"
	_tmp51_ = geary_account_information_get_save_drafts (_tmp50_);
#line 1093 "../src/client/accounts/accounts-manager.vala"
	_tmp52_ = _tmp51_;
#line 1093 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_save_drafts (_tmp48_, geary_config_file_group_get_bool (_tmp49_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_SAVE_DRAFTS, _tmp52_));
#line 1096 "../src/client/accounts/accounts-manager.vala"
	_tmp53_ = account;
#line 1096 "../src/client/accounts/accounts-manager.vala"
	_tmp54_ = account_config;
#line 1096 "../src/client/accounts/accounts-manager.vala"
	_tmp55_ = account;
#line 1096 "../src/client/accounts/accounts-manager.vala"
	_tmp56_ = geary_account_information_get_save_sent (_tmp55_);
#line 1096 "../src/client/accounts/accounts-manager.vala"
	_tmp57_ = _tmp56_;
#line 1096 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_save_sent (_tmp53_, geary_config_file_group_get_bool (_tmp54_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_SAVE_SENT, _tmp57_));
#line 1099 "../src/client/accounts/accounts-manager.vala"
	_tmp58_ = account;
#line 1099 "../src/client/accounts/accounts-manager.vala"
	_tmp59_ = account_config;
#line 1099 "../src/client/accounts/accounts-manager.vala"
	_tmp60_ = account;
#line 1099 "../src/client/accounts/accounts-manager.vala"
	_tmp61_ = geary_account_information_get_use_signature (_tmp60_);
#line 1099 "../src/client/accounts/accounts-manager.vala"
	_tmp62_ = _tmp61_;
#line 1099 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_use_signature (_tmp58_, geary_config_file_group_get_bool (_tmp59_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_USE_SIG, _tmp62_));
#line 1102 "../src/client/accounts/accounts-manager.vala"
	_tmp63_ = account;
#line 1102 "../src/client/accounts/accounts-manager.vala"
	_tmp64_ = account_config;
#line 1102 "../src/client/accounts/accounts-manager.vala"
	_tmp65_ = account;
#line 1102 "../src/client/accounts/accounts-manager.vala"
	_tmp66_ = geary_account_information_get_signature (_tmp65_);
#line 1102 "../src/client/accounts/accounts-manager.vala"
	_tmp67_ = _tmp66_;
#line 1102 "../src/client/accounts/accounts-manager.vala"
	_tmp68_ = geary_config_file_group_get_string (_tmp64_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_SIG, _tmp67_);
#line 1102 "../src/client/accounts/accounts-manager.vala"
	_tmp69_ = _tmp68_;
#line 1102 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_signature (_tmp63_, _tmp69_);
#line 1102 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp69_);
#line 10403 "accounts-manager.c"
	{
		GeeList* _sender_list = NULL;
		GeeList* _tmp70_;
		gint _sender_size = 0;
		GeeList* _tmp71_;
		gint _tmp72_;
		gint _tmp73_;
		gint _sender_index = 0;
#line 1105 "../src/client/accounts/accounts-manager.vala"
		_tmp70_ = senders;
#line 1105 "../src/client/accounts/accounts-manager.vala"
		_sender_list = _tmp70_;
#line 1105 "../src/client/accounts/accounts-manager.vala"
		_tmp71_ = _sender_list;
#line 1105 "../src/client/accounts/accounts-manager.vala"
		_tmp72_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp71_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1105 "../src/client/accounts/accounts-manager.vala"
		_tmp73_ = _tmp72_;
#line 1105 "../src/client/accounts/accounts-manager.vala"
		_sender_size = _tmp73_;
#line 1105 "../src/client/accounts/accounts-manager.vala"
		_sender_index = -1;
#line 1105 "../src/client/accounts/accounts-manager.vala"
		while (TRUE) {
#line 10428 "accounts-manager.c"
			gint _tmp74_;
			gint _tmp75_;
			GearyRFC822MailboxAddress* sender = NULL;
			GeeList* _tmp76_;
			gpointer _tmp77_;
			GearyAccountInformation* _tmp78_;
			GearyRFC822MailboxAddress* _tmp79_;
#line 1105 "../src/client/accounts/accounts-manager.vala"
			_sender_index = _sender_index + 1;
#line 1105 "../src/client/accounts/accounts-manager.vala"
			_tmp74_ = _sender_index;
#line 1105 "../src/client/accounts/accounts-manager.vala"
			_tmp75_ = _sender_size;
#line 1105 "../src/client/accounts/accounts-manager.vala"
			if (!(_tmp74_ < _tmp75_)) {
#line 1105 "../src/client/accounts/accounts-manager.vala"
				break;
#line 10446 "accounts-manager.c"
			}
#line 1105 "../src/client/accounts/accounts-manager.vala"
			_tmp76_ = _sender_list;
#line 1105 "../src/client/accounts/accounts-manager.vala"
			_tmp77_ = gee_list_get (_tmp76_, _sender_index);
#line 1105 "../src/client/accounts/accounts-manager.vala"
			sender = (GearyRFC822MailboxAddress*) _tmp77_;
#line 1106 "../src/client/accounts/accounts-manager.vala"
			_tmp78_ = account;
#line 1106 "../src/client/accounts/accounts-manager.vala"
			_tmp79_ = sender;
#line 1106 "../src/client/accounts/accounts-manager.vala"
			geary_account_information_append_sender (_tmp78_, _tmp79_);
#line 1105 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (sender);
#line 10462 "accounts-manager.c"
		}
	}
#line 1109 "../src/client/accounts/accounts-manager.vala"
	_tmp80_ = geary_config_file_get_group (config, ACCOUNTS_ACCOUNT_CONFIG_V1_GROUP_FOLDERS);
#line 1109 "../src/client/accounts/accounts-manager.vala"
	folder_config = _tmp80_;
#line 1111 "../src/client/accounts/accounts-manager.vala"
	_tmp81_ = account;
#line 1111 "../src/client/accounts/accounts-manager.vala"
	_tmp82_ = folder_config;
#line 1111 "../src/client/accounts/accounts-manager.vala"
	_tmp83_ = geary_config_file_group_get_string_list (_tmp82_, ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_ARCHIVE);
#line 1111 "../src/client/accounts/accounts-manager.vala"
	_tmp84_ = _tmp83_;
#line 1111 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_folder_steps_for_use (_tmp81_, GEARY_FOLDER_SPECIAL_USE_ARCHIVE, _tmp84_);
#line 1111 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp84_);
#line 1114 "../src/client/accounts/accounts-manager.vala"
	_tmp85_ = account;
#line 1114 "../src/client/accounts/accounts-manager.vala"
	_tmp86_ = folder_config;
#line 1114 "../src/client/accounts/accounts-manager.vala"
	_tmp87_ = geary_config_file_group_get_string_list (_tmp86_, ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_DRAFTS);
#line 1114 "../src/client/accounts/accounts-manager.vala"
	_tmp88_ = _tmp87_;
#line 1114 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_folder_steps_for_use (_tmp85_, GEARY_FOLDER_SPECIAL_USE_DRAFTS, _tmp88_);
#line 1114 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp88_);
#line 1117 "../src/client/accounts/accounts-manager.vala"
	_tmp89_ = account;
#line 1117 "../src/client/accounts/accounts-manager.vala"
	_tmp90_ = folder_config;
#line 1117 "../src/client/accounts/accounts-manager.vala"
	_tmp91_ = geary_config_file_group_get_string_list (_tmp90_, ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_SENT);
#line 1117 "../src/client/accounts/accounts-manager.vala"
	_tmp92_ = _tmp91_;
#line 1117 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_folder_steps_for_use (_tmp89_, GEARY_FOLDER_SPECIAL_USE_SENT, _tmp92_);
#line 1117 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp92_);
#line 1121 "../src/client/accounts/accounts-manager.vala"
	_tmp93_ = folder_config;
#line 1121 "../src/client/accounts/accounts-manager.vala"
	if (geary_config_file_group_has_key (_tmp93_, ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_SPAM)) {
#line 10509 "accounts-manager.c"
		GearyAccountInformation* _tmp94_;
		GearyConfigFileGroup* _tmp95_;
		GeeList* _tmp96_;
		GeeList* _tmp97_;
#line 1122 "../src/client/accounts/accounts-manager.vala"
		_tmp94_ = account;
#line 1122 "../src/client/accounts/accounts-manager.vala"
		_tmp95_ = folder_config;
#line 1122 "../src/client/accounts/accounts-manager.vala"
		_tmp96_ = geary_config_file_group_get_string_list (_tmp95_, ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_SPAM);
#line 1122 "../src/client/accounts/accounts-manager.vala"
		_tmp97_ = _tmp96_;
#line 1122 "../src/client/accounts/accounts-manager.vala"
		geary_account_information_set_folder_steps_for_use (_tmp94_, GEARY_FOLDER_SPECIAL_USE_JUNK, _tmp97_);
#line 1122 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp97_);
#line 10526 "accounts-manager.c"
	}
#line 1126 "../src/client/accounts/accounts-manager.vala"
	_tmp98_ = folder_config;
#line 1126 "../src/client/accounts/accounts-manager.vala"
	if (geary_config_file_group_has_key (_tmp98_, ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_JUNK)) {
#line 10532 "accounts-manager.c"
		GearyAccountInformation* _tmp99_;
		GearyConfigFileGroup* _tmp100_;
		GeeList* _tmp101_;
		GeeList* _tmp102_;
#line 1127 "../src/client/accounts/accounts-manager.vala"
		_tmp99_ = account;
#line 1127 "../src/client/accounts/accounts-manager.vala"
		_tmp100_ = folder_config;
#line 1127 "../src/client/accounts/accounts-manager.vala"
		_tmp101_ = geary_config_file_group_get_string_list (_tmp100_, ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_JUNK);
#line 1127 "../src/client/accounts/accounts-manager.vala"
		_tmp102_ = _tmp101_;
#line 1127 "../src/client/accounts/accounts-manager.vala"
		geary_account_information_set_folder_steps_for_use (_tmp99_, GEARY_FOLDER_SPECIAL_USE_JUNK, _tmp102_);
#line 1127 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp102_);
#line 10549 "accounts-manager.c"
	}
#line 1131 "../src/client/accounts/accounts-manager.vala"
	_tmp103_ = account;
#line 1131 "../src/client/accounts/accounts-manager.vala"
	_tmp104_ = folder_config;
#line 1131 "../src/client/accounts/accounts-manager.vala"
	_tmp105_ = geary_config_file_group_get_string_list (_tmp104_, ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_TRASH);
#line 1131 "../src/client/accounts/accounts-manager.vala"
	_tmp106_ = _tmp105_;
#line 1131 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_folder_steps_for_use (_tmp103_, GEARY_FOLDER_SPECIAL_USE_TRASH, _tmp106_);
#line 1131 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp106_);
#line 1135 "../src/client/accounts/accounts-manager.vala"
	result = account;
#line 1135 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_group_unref0 (folder_config);
#line 1135 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp22_);
#line 1135 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp2_);
#line 1135 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (senders);
#line 1135 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_group_unref0 (account_config);
#line 1135 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 10577 "accounts-manager.c"
}

/** Saves an account to a config file. */
static gchar*
__lambda8_ (AccountsAccountConfigV1* self,
            GearyRFC822MailboxAddress* sender)
{
	gchar* _tmp0_;
	gchar* result;
#line 1153 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (sender, GEARY_RF_C822_TYPE_MAILBOX_ADDRESS), NULL);
#line 1153 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = geary_rf_c822_decoded_message_data_to_rfc822_string (G_TYPE_CHECK_INSTANCE_CAST (sender, GEARY_RF_C822_TYPE_DECODED_MESSAGE_DATA, GearyRFC822DecodedMessageData));
#line 1153 "../src/client/accounts/accounts-manager.vala"
	result = _tmp0_;
#line 1153 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (sender);
#line 1153 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 10597 "accounts-manager.c"
}

static gpointer
___lambda8__gee_map_func (gpointer g,
                          gpointer self)
{
	gpointer result;
	result = __lambda8_ ((AccountsAccountConfigV1*) self, (GearyRFC822MailboxAddress*) g);
#line 1150 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 10608 "accounts-manager.c"
}

static void
accounts_account_config_v1_real_save (AccountsAccountConfig* base,
                                      GearyAccountInformation* account,
                                      GearyConfigFile* config)
{
	AccountsAccountConfigV1 * self;
	GearyConfigFileGroup* account_config = NULL;
	GearyConfigFileGroup* _tmp0_;
	GearyConfigFileGroup* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GearyConfigFileGroup* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GearyConfigFileGroup* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	GearyConfigFileGroup* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	GearyConfigFileGroup* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	GearyConfigFileGroup* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	GearyConfigFileGroup* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	GearyConfigFileGroup* _tmp22_;
	GeeList* _tmp23_;
	GeeList* _tmp24_;
	GeeList* _tmp25_;
	GearyIterable* _tmp26_;
	GearyIterable* _tmp27_;
	GearyIterable* _tmp28_;
	GearyIterable* _tmp29_;
	GeeArrayList* _tmp30_;
	GeeArrayList* _tmp31_;
	GearyConfigFileGroup* folder_config = NULL;
	GearyConfigFileGroup* _tmp37_;
	GeeList* _tmp38_;
	GeeList* _tmp39_;
	GeeList* _tmp40_;
	GeeList* _tmp41_;
	GeeList* _tmp42_;
	GeeList* _tmp43_;
	GeeList* _tmp44_;
	GeeList* _tmp45_;
	GeeList* _tmp46_;
	GeeList* _tmp47_;
#line 1139 "../src/client/accounts/accounts-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, ACCOUNTS_TYPE_ACCOUNT_CONFIG_V1, AccountsAccountConfigV1);
#line 1139 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 1139 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (config, GEARY_TYPE_CONFIG_FILE));
#line 1141 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = geary_config_file_get_group (config, ACCOUNTS_ACCOUNT_CONFIG_V1_GROUP_ACCOUNT);
#line 1141 "../src/client/accounts/accounts-manager.vala"
	account_config = _tmp0_;
#line 1143 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = account_config;
#line 1143 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = geary_account_information_get_ordinal (account);
#line 1143 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = _tmp2_;
#line 1143 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_int (_tmp1_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_ORDINAL, _tmp3_);
#line 1144 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = account_config;
#line 1144 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = geary_account_information_get_label (account);
#line 1144 "../src/client/accounts/accounts-manager.vala"
	_tmp6_ = _tmp5_;
#line 1144 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string (_tmp4_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_LABEL, _tmp6_);
#line 1145 "../src/client/accounts/accounts-manager.vala"
	_tmp7_ = account_config;
#line 1145 "../src/client/accounts/accounts-manager.vala"
	_tmp8_ = geary_account_information_get_prefetch_period_days (account);
#line 1145 "../src/client/accounts/accounts-manager.vala"
	_tmp9_ = _tmp8_;
#line 1145 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_int (_tmp7_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_PREFETCH, _tmp9_);
#line 1146 "../src/client/accounts/accounts-manager.vala"
	_tmp10_ = account_config;
#line 1146 "../src/client/accounts/accounts-manager.vala"
	_tmp11_ = geary_account_information_get_save_drafts (account);
#line 1146 "../src/client/accounts/accounts-manager.vala"
	_tmp12_ = _tmp11_;
#line 1146 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_bool (_tmp10_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_SAVE_DRAFTS, _tmp12_);
#line 1147 "../src/client/accounts/accounts-manager.vala"
	_tmp13_ = account_config;
#line 1147 "../src/client/accounts/accounts-manager.vala"
	_tmp14_ = geary_account_information_get_save_sent (account);
#line 1147 "../src/client/accounts/accounts-manager.vala"
	_tmp15_ = _tmp14_;
#line 1147 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_bool (_tmp13_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_SAVE_SENT, _tmp15_);
#line 1148 "../src/client/accounts/accounts-manager.vala"
	_tmp16_ = account_config;
#line 1148 "../src/client/accounts/accounts-manager.vala"
	_tmp17_ = geary_account_information_get_use_signature (account);
#line 1148 "../src/client/accounts/accounts-manager.vala"
	_tmp18_ = _tmp17_;
#line 1148 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_bool (_tmp16_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_USE_SIG, _tmp18_);
#line 1149 "../src/client/accounts/accounts-manager.vala"
	_tmp19_ = account_config;
#line 1149 "../src/client/accounts/accounts-manager.vala"
	_tmp20_ = geary_account_information_get_signature (account);
#line 1149 "../src/client/accounts/accounts-manager.vala"
	_tmp21_ = _tmp20_;
#line 1149 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string (_tmp19_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_SIG, _tmp21_);
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_tmp22_ = account_config;
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_tmp23_ = geary_account_information_get_sender_mailboxes (account);
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_tmp24_ = _tmp23_;
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_tmp25_ = _tmp24_;
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_tmp26_ = geary_traverse (GEARY_RF_C822_TYPE_MAILBOX_ADDRESS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_tmp27_ = _tmp26_;
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_tmp28_ = geary_iterable_map (_tmp27_, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, ___lambda8__gee_map_func, self);
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_tmp29_ = _tmp28_;
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_tmp30_ = geary_iterable_to_array_list (_tmp29_, NULL, NULL, NULL);
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_tmp31_ = _tmp30_;
#line 1150 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string_list (_tmp22_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_SENDERS, G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GEE_TYPE_LIST, GeeList));
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp31_);
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp29_);
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp27_);
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp25_);
#line 1157 "../src/client/accounts/accounts-manager.vala"
	if (!self->priv->is_managed) {
#line 10760 "accounts-manager.c"
		GearyConfigFileGroup* _tmp32_;
		GearyServiceProvider _tmp33_;
		GearyServiceProvider _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
#line 1158 "../src/client/accounts/accounts-manager.vala"
		_tmp32_ = account_config;
#line 1158 "../src/client/accounts/accounts-manager.vala"
		_tmp33_ = geary_account_information_get_service_provider (account);
#line 1158 "../src/client/accounts/accounts-manager.vala"
		_tmp34_ = _tmp33_;
#line 1158 "../src/client/accounts/accounts-manager.vala"
		_tmp35_ = geary_service_provider_to_value (_tmp34_);
#line 1158 "../src/client/accounts/accounts-manager.vala"
		_tmp36_ = _tmp35_;
#line 1158 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_group_set_string (_tmp32_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_PROVIDER, _tmp36_);
#line 1158 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp36_);
#line 10780 "accounts-manager.c"
	}
#line 1163 "../src/client/accounts/accounts-manager.vala"
	_tmp37_ = geary_config_file_get_group (config, ACCOUNTS_ACCOUNT_CONFIG_V1_GROUP_FOLDERS);
#line 1163 "../src/client/accounts/accounts-manager.vala"
	folder_config = _tmp37_;
#line 1165 "../src/client/accounts/accounts-manager.vala"
	_tmp38_ = geary_account_information_get_folder_steps_for_use (account, GEARY_FOLDER_SPECIAL_USE_ARCHIVE);
#line 1165 "../src/client/accounts/accounts-manager.vala"
	_tmp39_ = _tmp38_;
#line 1165 "../src/client/accounts/accounts-manager.vala"
	accounts_account_config_v1_save_folder (self, folder_config, ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_ARCHIVE, _tmp39_);
#line 1165 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp39_);
#line 1170 "../src/client/accounts/accounts-manager.vala"
	_tmp40_ = geary_account_information_get_folder_steps_for_use (account, GEARY_FOLDER_SPECIAL_USE_DRAFTS);
#line 1170 "../src/client/accounts/accounts-manager.vala"
	_tmp41_ = _tmp40_;
#line 1170 "../src/client/accounts/accounts-manager.vala"
	accounts_account_config_v1_save_folder (self, folder_config, ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_DRAFTS, _tmp41_);
#line 1170 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp41_);
#line 1175 "../src/client/accounts/accounts-manager.vala"
	_tmp42_ = geary_account_information_get_folder_steps_for_use (account, GEARY_FOLDER_SPECIAL_USE_SENT);
#line 1175 "../src/client/accounts/accounts-manager.vala"
	_tmp43_ = _tmp42_;
#line 1175 "../src/client/accounts/accounts-manager.vala"
	accounts_account_config_v1_save_folder (self, folder_config, ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_SENT, _tmp43_);
#line 1175 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp43_);
#line 1180 "../src/client/accounts/accounts-manager.vala"
	_tmp44_ = geary_account_information_get_folder_steps_for_use (account, GEARY_FOLDER_SPECIAL_USE_JUNK);
#line 1180 "../src/client/accounts/accounts-manager.vala"
	_tmp45_ = _tmp44_;
#line 1180 "../src/client/accounts/accounts-manager.vala"
	accounts_account_config_v1_save_folder (self, folder_config, ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_JUNK, _tmp45_);
#line 1180 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp45_);
#line 1185 "../src/client/accounts/accounts-manager.vala"
	_tmp46_ = geary_account_information_get_folder_steps_for_use (account, GEARY_FOLDER_SPECIAL_USE_TRASH);
#line 1185 "../src/client/accounts/accounts-manager.vala"
	_tmp47_ = _tmp46_;
#line 1185 "../src/client/accounts/accounts-manager.vala"
	accounts_account_config_v1_save_folder (self, folder_config, ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_TRASH, _tmp47_);
#line 1185 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp47_);
#line 1139 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_group_unref0 (folder_config);
#line 1139 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_group_unref0 (account_config);
#line 10830 "accounts-manager.c"
}

static inline void
accounts_account_config_v1_save_folder (AccountsAccountConfigV1* self,
                                        GearyConfigFileGroup* config,
                                        const gchar* key,
                                        GeeList* steps)
{
#line 1192 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_ACCOUNT_CONFIG_V1 (self));
#line 1192 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (config, GEARY_CONFIG_FILE_TYPE_GROUP));
#line 1192 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (key != NULL);
#line 1192 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail ((steps == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (steps, GEE_TYPE_LIST));
#line 1195 "../src/client/accounts/accounts-manager.vala"
	if (steps != NULL) {
#line 1196 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_group_set_string_list (config, key, steps);
#line 10851 "accounts-manager.c"
	}
}

static void
accounts_account_config_v1_class_init (AccountsAccountConfigV1Class * klass,
                                       gpointer klass_data)
{
#line 1007 "../src/client/accounts/accounts-manager.vala"
	accounts_account_config_v1_parent_class = g_type_class_peek_parent (klass);
#line 1007 "../src/client/accounts/accounts-manager.vala"
	g_type_class_adjust_private_offset (klass, &AccountsAccountConfigV1_private_offset);
#line 1007 "../src/client/accounts/accounts-manager.vala"
	G_OBJECT_CLASS (klass)->finalize = accounts_account_config_v1_finalize;
#line 10865 "accounts-manager.c"
}

static void
accounts_account_config_v1_accounts_account_config_interface_init (AccountsAccountConfigIface * iface,
                                                                   gpointer iface_data)
{
#line 1007 "../src/client/accounts/accounts-manager.vala"
	accounts_account_config_v1_accounts_account_config_parent_iface = g_type_interface_peek_parent (iface);
#line 1007 "../src/client/accounts/accounts-manager.vala"
	iface->load = (GearyAccountInformation* (*) (AccountsAccountConfig*, GearyConfigFile*, const gchar*, GearyCredentialsMediator*, GearyServiceProvider*, const gchar*, GError**)) accounts_account_config_v1_real_load;
#line 1007 "../src/client/accounts/accounts-manager.vala"
	iface->save = (void (*) (AccountsAccountConfig*, GearyAccountInformation*, GearyConfigFile*)) accounts_account_config_v1_real_save;
#line 10878 "accounts-manager.c"
}

static void
accounts_account_config_v1_instance_init (AccountsAccountConfigV1 * self,
                                          gpointer klass)
{
#line 1007 "../src/client/accounts/accounts-manager.vala"
	self->priv = accounts_account_config_v1_get_instance_private (self);
#line 10887 "accounts-manager.c"
}

static void
accounts_account_config_v1_finalize (GObject * obj)
{
	AccountsAccountConfigV1 * self;
#line 1007 "../src/client/accounts/accounts-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ACCOUNTS_TYPE_ACCOUNT_CONFIG_V1, AccountsAccountConfigV1);
#line 1007 "../src/client/accounts/accounts-manager.vala"
	G_OBJECT_CLASS (accounts_account_config_v1_parent_class)->finalize (obj);
#line 10898 "accounts-manager.c"
}

/**
 * Manages persistence for version 1 config files.
 */
static GType
accounts_account_config_v1_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AccountsAccountConfigV1Class), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) accounts_account_config_v1_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AccountsAccountConfigV1), 0, (GInstanceInitFunc) accounts_account_config_v1_instance_init, NULL };
	static const GInterfaceInfo accounts_account_config_info = { (GInterfaceInitFunc) accounts_account_config_v1_accounts_account_config_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType accounts_account_config_v1_type_id;
	accounts_account_config_v1_type_id = g_type_register_static (G_TYPE_OBJECT, "AccountsAccountConfigV1", &g_define_type_info, 0);
	g_type_add_interface_static (accounts_account_config_v1_type_id, ACCOUNTS_TYPE_ACCOUNT_CONFIG, &accounts_account_config_info);
	AccountsAccountConfigV1_private_offset = g_type_add_instance_private (accounts_account_config_v1_type_id, sizeof (AccountsAccountConfigV1Private));
	return accounts_account_config_v1_type_id;
}

GType
accounts_account_config_v1_get_type (void)
{
	static volatile gsize accounts_account_config_v1_type_id__once = 0;
	if (g_once_init_enter (&accounts_account_config_v1_type_id__once)) {
		GType accounts_account_config_v1_type_id;
		accounts_account_config_v1_type_id = accounts_account_config_v1_get_type_once ();
		g_once_init_leave (&accounts_account_config_v1_type_id__once, accounts_account_config_v1_type_id);
	}
	return accounts_account_config_v1_type_id__once;
}

static GearyServiceProvider
___lambda14_ (AccountsAccountConfigLegacy* self,
              const gchar* value,
              GError** error)
{
	GError* _inner_error0_ = NULL;
	GearyServiceProvider result;
#line 1246 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (value != NULL, 0);
#line 10937 "accounts-manager.c"
	{
		GearyServiceProvider _tmp0_ = 0;
#line 1248 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = geary_service_provider_for_value (value, &_inner_error0_);
#line 1248 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1248 "../src/client/accounts/accounts-manager.vala"
			if (_inner_error0_->domain == GEARY_ENGINE_ERROR) {
#line 10946 "accounts-manager.c"
				goto __catch0_geary_engine_error;
			}
#line 1248 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1248 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_inner_error0_);
#line 1248 "../src/client/accounts/accounts-manager.vala"
			return 0;
#line 10955 "accounts-manager.c"
		}
#line 1248 "../src/client/accounts/accounts-manager.vala"
		result = _tmp0_;
#line 1248 "../src/client/accounts/accounts-manager.vala"
		return result;
#line 10961 "accounts-manager.c"
	}
	goto __finally0;
	__catch0_geary_engine_error:
	{
		GError* err = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		GError* _tmp3_;
#line 1247 "../src/client/accounts/accounts-manager.vala"
		err = _inner_error0_;
#line 1247 "../src/client/accounts/accounts-manager.vala"
		_inner_error0_ = NULL;
#line 1250 "../src/client/accounts/accounts-manager.vala"
		_tmp1_ = err;
#line 1250 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = _tmp1_->message;
#line 1250 "../src/client/accounts/accounts-manager.vala"
		_tmp3_ = g_error_new_literal (G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_INVALID_VALUE, _tmp2_);
#line 1250 "../src/client/accounts/accounts-manager.vala"
		_inner_error0_ = _tmp3_;
#line 1250 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (err);
#line 10984 "accounts-manager.c"
		goto __finally0;
	}
	__finally0:
#line 1247 "../src/client/accounts/accounts-manager.vala"
	if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1247 "../src/client/accounts/accounts-manager.vala"
		g_propagate_error (error, _inner_error0_);
#line 1247 "../src/client/accounts/accounts-manager.vala"
		return 0;
#line 10994 "accounts-manager.c"
	} else {
#line 1247 "../src/client/accounts/accounts-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1247 "../src/client/accounts/accounts-manager.vala"
		g_clear_error (&_inner_error0_);
#line 1247 "../src/client/accounts/accounts-manager.vala"
		return 0;
#line 11002 "accounts-manager.c"
	}
}

static gpointer
____lambda14__geary_config_file_parser (const gchar* value,
                                        gpointer self,
                                        GError** error)
{
	gpointer result;
	result = (gpointer) ((gintptr) ___lambda14_ ((AccountsAccountConfigLegacy*) self, value, error));
#line 1244 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 11015 "accounts-manager.c"
}

static GearyAccountInformation*
accounts_account_config_legacy_real_load (AccountsAccountConfig* base,
                                          GearyConfigFile* config_file,
                                          const gchar* id,
                                          GearyCredentialsMediator* mediator,
                                          GearyServiceProvider* default_provider,
                                          const gchar* default_name,
                                          GError** error)
{
	AccountsAccountConfigLegacy * self;
	GearyConfigFileGroup* config = NULL;
	GearyConfigFileGroup* _tmp0_;
	gchar* primary_email = NULL;
	GearyConfigFileGroup* _tmp1_;
	gchar* _tmp2_;
	gchar* real_name = NULL;
	GearyConfigFileGroup* _tmp3_;
	gchar* _tmp4_;
	GearyServiceProvider* _tmp5_ = NULL;
	GearyServiceProvider provider = 0;
	GearyAccountInformation* info = NULL;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	GearyRFC822MailboxAddress* _tmp13_;
	GearyRFC822MailboxAddress* _tmp14_;
	GearyAccountInformation* _tmp15_;
	GearyAccountInformation* _tmp16_;
	GearyAccountInformation* _tmp17_;
	GearyConfigFileGroup* _tmp18_;
	GearyAccountInformation* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	GearyAccountInformation* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	GearyAccountInformation* _tmp28_;
	GearyConfigFileGroup* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	const gchar* _tmp32_;
	GearyRFC822MailboxAddress* _tmp33_;
	GearyRFC822MailboxAddress* _tmp34_;
	GearyAccountInformation* _tmp35_;
	GearyConfigFileGroup* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	GeeList* alt_email_list = NULL;
	GearyConfigFileGroup* _tmp39_;
	GeeList* _tmp40_;
	GearyAccountInformation* _tmp65_;
	GearyConfigFileGroup* _tmp66_;
	GearyAccountInformation* _tmp67_;
	gint _tmp68_;
	gint _tmp69_;
	GearyAccountInformation* _tmp70_;
	GearyConfigFileGroup* _tmp71_;
	GearyAccountInformation* _tmp72_;
	gboolean _tmp73_;
	gboolean _tmp74_;
	GearyAccountInformation* _tmp75_;
	GearyConfigFileGroup* _tmp76_;
	GearyAccountInformation* _tmp77_;
	gboolean _tmp78_;
	gboolean _tmp79_;
	GearyAccountInformation* _tmp80_;
	GearyConfigFileGroup* _tmp81_;
	GearyAccountInformation* _tmp82_;
	const gchar* _tmp83_;
	const gchar* _tmp84_;
	gchar* _tmp85_;
	gchar* _tmp86_;
	GearyAccountInformation* _tmp87_;
	GearyConfigFileGroup* _tmp88_;
	GeeList* _tmp89_;
	GeeList* _tmp90_;
	GearyAccountInformation* _tmp91_;
	GearyConfigFileGroup* _tmp92_;
	GeeList* _tmp93_;
	GeeList* _tmp94_;
	GearyAccountInformation* _tmp95_;
	GearyConfigFileGroup* _tmp96_;
	GeeList* _tmp97_;
	GeeList* _tmp98_;
	GearyAccountInformation* _tmp99_;
	GearyConfigFileGroup* _tmp100_;
	GeeList* _tmp101_;
	GeeList* _tmp102_;
	GearyAccountInformation* _tmp103_;
	GearyConfigFileGroup* _tmp104_;
	GeeList* _tmp105_;
	GeeList* _tmp106_;
	GearyAccountInformation* _tmp107_;
	GearyConfigFileGroup* _tmp108_;
	GError* _inner_error0_ = NULL;
	GearyAccountInformation* result;
#line 1230 "../src/client/accounts/accounts-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, ACCOUNTS_TYPE_ACCOUNT_CONFIG_LEGACY, AccountsAccountConfigLegacy);
#line 1230 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (config_file, GEARY_TYPE_CONFIG_FILE), NULL);
#line 1230 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 1230 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (mediator, GEARY_TYPE_CREDENTIALS_MEDIATOR), NULL);
#line 1236 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = geary_config_file_get_group (config_file, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_GROUP);
#line 1236 "../src/client/accounts/accounts-manager.vala"
	config = _tmp0_;
#line 1238 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = config;
#line 1238 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = geary_config_file_group_get_required_string (_tmp1_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_PRIMARY_EMAIL_KEY, &_inner_error0_);
#line 1238 "../src/client/accounts/accounts-manager.vala"
	primary_email = _tmp2_;
#line 1238 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1238 "../src/client/accounts/accounts-manager.vala"
		if ((_inner_error0_->domain == ACCOUNTS_CONFIG_ERROR) || (_inner_error0_->domain == G_KEY_FILE_ERROR)) {
#line 1238 "../src/client/accounts/accounts-manager.vala"
			g_propagate_error (error, _inner_error0_);
#line 1238 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (config);
#line 1238 "../src/client/accounts/accounts-manager.vala"
			return NULL;
#line 11141 "accounts-manager.c"
		} else {
#line 1238 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (config);
#line 1238 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1238 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_inner_error0_);
#line 1238 "../src/client/accounts/accounts-manager.vala"
			return NULL;
#line 11151 "accounts-manager.c"
		}
	}
#line 1239 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = config;
#line 1239 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = geary_config_file_group_get_string (_tmp3_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_REAL_NAME_KEY, default_name);
#line 1239 "../src/client/accounts/accounts-manager.vala"
	real_name = _tmp4_;
#line 1241 "../src/client/accounts/accounts-manager.vala"
	if (default_provider != NULL) {
#line 11162 "accounts-manager.c"
		GearyServiceProvider* _tmp6_;
#line 1243 "../src/client/accounts/accounts-manager.vala"
		_tmp6_ = __geary_service_provider_dup0 (default_provider);
#line 1243 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp5_);
#line 1243 "../src/client/accounts/accounts-manager.vala"
		_tmp5_ = _tmp6_;
#line 11170 "accounts-manager.c"
	} else {
		GearyConfigFileGroup* _tmp7_;
		gpointer _tmp8_;
		GearyServiceProvider _tmp9_;
		GearyServiceProvider* _tmp10_;
#line 1244 "../src/client/accounts/accounts-manager.vala"
		_tmp7_ = config;
#line 1244 "../src/client/accounts/accounts-manager.vala"
		_tmp8_ = geary_config_file_group_parse_required_value (_tmp7_, GEARY_TYPE_SERVICE_PROVIDER, NULL, NULL, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SERVICE_PROVIDER_KEY, ____lambda14__geary_config_file_parser, self, &_inner_error0_);
#line 1244 "../src/client/accounts/accounts-manager.vala"
		_tmp9_ = (GearyServiceProvider) ((gintptr) _tmp8_);
#line 1244 "../src/client/accounts/accounts-manager.vala"
		_tmp10_ = __geary_service_provider_dup0 (&_tmp9_);
#line 1244 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp5_);
#line 1244 "../src/client/accounts/accounts-manager.vala"
		_tmp5_ = _tmp10_;
#line 1244 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1244 "../src/client/accounts/accounts-manager.vala"
			if ((_inner_error0_->domain == ACCOUNTS_CONFIG_ERROR) || (_inner_error0_->domain == G_KEY_FILE_ERROR)) {
#line 1244 "../src/client/accounts/accounts-manager.vala"
				g_propagate_error (error, _inner_error0_);
#line 1244 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp5_);
#line 1244 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (real_name);
#line 1244 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (primary_email);
#line 1244 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (config);
#line 1244 "../src/client/accounts/accounts-manager.vala"
				return NULL;
#line 11204 "accounts-manager.c"
			} else {
#line 1244 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp5_);
#line 1244 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (real_name);
#line 1244 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (primary_email);
#line 1244 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (config);
#line 1244 "../src/client/accounts/accounts-manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1244 "../src/client/accounts/accounts-manager.vala"
				g_clear_error (&_inner_error0_);
#line 1244 "../src/client/accounts/accounts-manager.vala"
				return NULL;
#line 11220 "accounts-manager.c"
			}
		}
	}
#line 1241 "../src/client/accounts/accounts-manager.vala"
	provider = *_tmp5_;
#line 1256 "../src/client/accounts/accounts-manager.vala"
	_tmp11_ = real_name;
#line 1256 "../src/client/accounts/accounts-manager.vala"
	_tmp12_ = primary_email;
#line 1256 "../src/client/accounts/accounts-manager.vala"
	_tmp13_ = geary_rf_c822_mailbox_address_new (_tmp11_, _tmp12_);
#line 1256 "../src/client/accounts/accounts-manager.vala"
	_tmp14_ = _tmp13_;
#line 1256 "../src/client/accounts/accounts-manager.vala"
	_tmp15_ = geary_account_information_new (id, provider, mediator, _tmp14_);
#line 1256 "../src/client/accounts/accounts-manager.vala"
	_tmp16_ = _tmp15_;
#line 1256 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp14_);
#line 1256 "../src/client/accounts/accounts-manager.vala"
	info = _tmp16_;
#line 1261 "../src/client/accounts/accounts-manager.vala"
	_tmp17_ = info;
#line 1261 "../src/client/accounts/accounts-manager.vala"
	_tmp18_ = config;
#line 1261 "../src/client/accounts/accounts-manager.vala"
	_tmp19_ = info;
#line 1261 "../src/client/accounts/accounts-manager.vala"
	_tmp20_ = geary_account_information_get_ordinal (_tmp19_);
#line 1261 "../src/client/accounts/accounts-manager.vala"
	_tmp21_ = _tmp20_;
#line 1261 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_ordinal (_tmp17_, geary_config_file_group_get_int (_tmp18_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_ORDINAL_KEY, _tmp21_));
#line 1262 "../src/client/accounts/accounts-manager.vala"
	_tmp22_ = info;
#line 1262 "../src/client/accounts/accounts-manager.vala"
	_tmp23_ = geary_account_information_get_ordinal (_tmp22_);
#line 1262 "../src/client/accounts/accounts-manager.vala"
	_tmp24_ = _tmp23_;
#line 1262 "../src/client/accounts/accounts-manager.vala"
	if (_tmp24_ >= geary_account_information_next_ordinal) {
#line 11262 "accounts-manager.c"
		GearyAccountInformation* _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
#line 1263 "../src/client/accounts/accounts-manager.vala"
		_tmp25_ = info;
#line 1263 "../src/client/accounts/accounts-manager.vala"
		_tmp26_ = geary_account_information_get_ordinal (_tmp25_);
#line 1263 "../src/client/accounts/accounts-manager.vala"
		_tmp27_ = _tmp26_;
#line 1263 "../src/client/accounts/accounts-manager.vala"
		geary_account_information_next_ordinal = _tmp27_ + 1;
#line 11274 "accounts-manager.c"
	}
#line 1266 "../src/client/accounts/accounts-manager.vala"
	_tmp28_ = info;
#line 1266 "../src/client/accounts/accounts-manager.vala"
	_tmp29_ = config;
#line 1266 "../src/client/accounts/accounts-manager.vala"
	_tmp30_ = geary_config_file_group_get_string (_tmp29_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_REAL_NAME_KEY, NULL);
#line 1266 "../src/client/accounts/accounts-manager.vala"
	_tmp31_ = _tmp30_;
#line 1266 "../src/client/accounts/accounts-manager.vala"
	_tmp32_ = primary_email;
#line 1266 "../src/client/accounts/accounts-manager.vala"
	_tmp33_ = geary_rf_c822_mailbox_address_new (_tmp31_, _tmp32_);
#line 1266 "../src/client/accounts/accounts-manager.vala"
	_tmp34_ = _tmp33_;
#line 1266 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_append_sender (_tmp28_, _tmp34_);
#line 1266 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp34_);
#line 1266 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp31_);
#line 1270 "../src/client/accounts/accounts-manager.vala"
	_tmp35_ = info;
#line 1270 "../src/client/accounts/accounts-manager.vala"
	_tmp36_ = config;
#line 1270 "../src/client/accounts/accounts-manager.vala"
	_tmp37_ = geary_config_file_group_get_string (_tmp36_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_NICKNAME_KEY, NULL);
#line 1270 "../src/client/accounts/accounts-manager.vala"
	_tmp38_ = _tmp37_;
#line 1270 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_label (_tmp35_, _tmp38_);
#line 1270 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp38_);
#line 1273 "../src/client/accounts/accounts-manager.vala"
	_tmp39_ = config;
#line 1273 "../src/client/accounts/accounts-manager.vala"
	_tmp40_ = geary_config_file_group_get_string_list (_tmp39_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_ALTERNATE_EMAILS_KEY);
#line 1273 "../src/client/accounts/accounts-manager.vala"
	alt_email_list = _tmp40_;
#line 11314 "accounts-manager.c"
	{
		GeeList* _alt_email_list = NULL;
		GeeList* _tmp41_;
		gint _alt_email_size = 0;
		GeeList* _tmp42_;
		gint _tmp43_;
		gint _tmp44_;
		gint _alt_email_index = 0;
#line 1276 "../src/client/accounts/accounts-manager.vala"
		_tmp41_ = alt_email_list;
#line 1276 "../src/client/accounts/accounts-manager.vala"
		_alt_email_list = _tmp41_;
#line 1276 "../src/client/accounts/accounts-manager.vala"
		_tmp42_ = _alt_email_list;
#line 1276 "../src/client/accounts/accounts-manager.vala"
		_tmp43_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1276 "../src/client/accounts/accounts-manager.vala"
		_tmp44_ = _tmp43_;
#line 1276 "../src/client/accounts/accounts-manager.vala"
		_alt_email_size = _tmp44_;
#line 1276 "../src/client/accounts/accounts-manager.vala"
		_alt_email_index = -1;
#line 1276 "../src/client/accounts/accounts-manager.vala"
		while (TRUE) {
#line 11339 "accounts-manager.c"
			gint _tmp45_;
			gint _tmp46_;
			gchar* alt_email = NULL;
			GeeList* _tmp47_;
			gpointer _tmp48_;
#line 1276 "../src/client/accounts/accounts-manager.vala"
			_alt_email_index = _alt_email_index + 1;
#line 1276 "../src/client/accounts/accounts-manager.vala"
			_tmp45_ = _alt_email_index;
#line 1276 "../src/client/accounts/accounts-manager.vala"
			_tmp46_ = _alt_email_size;
#line 1276 "../src/client/accounts/accounts-manager.vala"
			if (!(_tmp45_ < _tmp46_)) {
#line 1276 "../src/client/accounts/accounts-manager.vala"
				break;
#line 11355 "accounts-manager.c"
			}
#line 1276 "../src/client/accounts/accounts-manager.vala"
			_tmp47_ = _alt_email_list;
#line 1276 "../src/client/accounts/accounts-manager.vala"
			_tmp48_ = gee_list_get (_tmp47_, _alt_email_index);
#line 1276 "../src/client/accounts/accounts-manager.vala"
			alt_email = (gchar*) _tmp48_;
#line 11363 "accounts-manager.c"
			{
				GearyRFC822MailboxAddresses* mailboxes = NULL;
				const gchar* _tmp49_;
				GearyRFC822MailboxAddresses* _tmp50_;
#line 1278 "../src/client/accounts/accounts-manager.vala"
				_tmp49_ = alt_email;
#line 1278 "../src/client/accounts/accounts-manager.vala"
				_tmp50_ = geary_rf_c822_mailbox_addresses_new_from_rfc822_string (_tmp49_, &_inner_error0_);
#line 1278 "../src/client/accounts/accounts-manager.vala"
				mailboxes = _tmp50_;
#line 1278 "../src/client/accounts/accounts-manager.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1278 "../src/client/accounts/accounts-manager.vala"
					if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 11378 "accounts-manager.c"
						goto __catch0_geary_rf_c822_error;
					}
#line 1278 "../src/client/accounts/accounts-manager.vala"
					_g_free0 (alt_email);
#line 1278 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (alt_email_list);
#line 1278 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (info);
#line 1278 "../src/client/accounts/accounts-manager.vala"
					_g_free0 (_tmp5_);
#line 1278 "../src/client/accounts/accounts-manager.vala"
					_g_free0 (real_name);
#line 1278 "../src/client/accounts/accounts-manager.vala"
					_g_free0 (primary_email);
#line 1278 "../src/client/accounts/accounts-manager.vala"
					_geary_config_file_group_unref0 (config);
#line 1278 "../src/client/accounts/accounts-manager.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1278 "../src/client/accounts/accounts-manager.vala"
					g_clear_error (&_inner_error0_);
#line 1278 "../src/client/accounts/accounts-manager.vala"
					return NULL;
#line 11401 "accounts-manager.c"
				}
				{
					GeeList* _mailbox_list = NULL;
					GearyRFC822MailboxAddresses* _tmp51_;
					GeeList* _tmp52_;
					gint _mailbox_size = 0;
					GeeList* _tmp53_;
					gint _tmp54_;
					gint _tmp55_;
					gint _mailbox_index = 0;
#line 1279 "../src/client/accounts/accounts-manager.vala"
					_tmp51_ = mailboxes;
#line 1279 "../src/client/accounts/accounts-manager.vala"
					_tmp52_ = geary_rf_c822_mailbox_addresses_get_all (_tmp51_);
#line 1279 "../src/client/accounts/accounts-manager.vala"
					_mailbox_list = _tmp52_;
#line 1279 "../src/client/accounts/accounts-manager.vala"
					_tmp53_ = _mailbox_list;
#line 1279 "../src/client/accounts/accounts-manager.vala"
					_tmp54_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1279 "../src/client/accounts/accounts-manager.vala"
					_tmp55_ = _tmp54_;
#line 1279 "../src/client/accounts/accounts-manager.vala"
					_mailbox_size = _tmp55_;
#line 1279 "../src/client/accounts/accounts-manager.vala"
					_mailbox_index = -1;
#line 1279 "../src/client/accounts/accounts-manager.vala"
					while (TRUE) {
#line 11430 "accounts-manager.c"
						gint _tmp56_;
						gint _tmp57_;
						GearyRFC822MailboxAddress* mailbox = NULL;
						GeeList* _tmp58_;
						gpointer _tmp59_;
						GearyAccountInformation* _tmp60_;
						GearyRFC822MailboxAddress* _tmp61_;
#line 1279 "../src/client/accounts/accounts-manager.vala"
						_mailbox_index = _mailbox_index + 1;
#line 1279 "../src/client/accounts/accounts-manager.vala"
						_tmp56_ = _mailbox_index;
#line 1279 "../src/client/accounts/accounts-manager.vala"
						_tmp57_ = _mailbox_size;
#line 1279 "../src/client/accounts/accounts-manager.vala"
						if (!(_tmp56_ < _tmp57_)) {
#line 1279 "../src/client/accounts/accounts-manager.vala"
							break;
#line 11448 "accounts-manager.c"
						}
#line 1279 "../src/client/accounts/accounts-manager.vala"
						_tmp58_ = _mailbox_list;
#line 1279 "../src/client/accounts/accounts-manager.vala"
						_tmp59_ = gee_list_get (_tmp58_, _mailbox_index);
#line 1279 "../src/client/accounts/accounts-manager.vala"
						mailbox = (GearyRFC822MailboxAddress*) _tmp59_;
#line 1280 "../src/client/accounts/accounts-manager.vala"
						_tmp60_ = info;
#line 1280 "../src/client/accounts/accounts-manager.vala"
						_tmp61_ = mailbox;
#line 1280 "../src/client/accounts/accounts-manager.vala"
						geary_account_information_append_sender (_tmp60_, _tmp61_);
#line 1279 "../src/client/accounts/accounts-manager.vala"
						_g_object_unref0 (mailbox);
#line 11464 "accounts-manager.c"
					}
#line 1279 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (_mailbox_list);
#line 11468 "accounts-manager.c"
				}
#line 1277 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (mailboxes);
#line 11472 "accounts-manager.c"
			}
			goto __finally0;
			__catch0_geary_rf_c822_error:
			{
				GError* _error_ = NULL;
				GError* _tmp62_;
				const gchar* _tmp63_;
				GError* _tmp64_;
#line 1277 "../src/client/accounts/accounts-manager.vala"
				_error_ = _inner_error0_;
#line 1277 "../src/client/accounts/accounts-manager.vala"
				_inner_error0_ = NULL;
#line 1283 "../src/client/accounts/accounts-manager.vala"
				_tmp62_ = _error_;
#line 1283 "../src/client/accounts/accounts-manager.vala"
				_tmp63_ = _tmp62_->message;
#line 1283 "../src/client/accounts/accounts-manager.vala"
				_tmp64_ = g_error_new (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_SYNTAX, "Invalid alternate email: %s", _tmp63_);
#line 1283 "../src/client/accounts/accounts-manager.vala"
				_inner_error0_ = _tmp64_;
#line 1283 "../src/client/accounts/accounts-manager.vala"
				_g_error_free0 (_error_);
#line 11495 "accounts-manager.c"
				goto __finally0;
			}
			__finally0:
#line 1277 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1277 "../src/client/accounts/accounts-manager.vala"
				if ((_inner_error0_->domain == ACCOUNTS_CONFIG_ERROR) || (_inner_error0_->domain == G_KEY_FILE_ERROR)) {
#line 1277 "../src/client/accounts/accounts-manager.vala"
					g_propagate_error (error, _inner_error0_);
#line 1277 "../src/client/accounts/accounts-manager.vala"
					_g_free0 (alt_email);
#line 1277 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (alt_email_list);
#line 1277 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (info);
#line 1277 "../src/client/accounts/accounts-manager.vala"
					_g_free0 (_tmp5_);
#line 1277 "../src/client/accounts/accounts-manager.vala"
					_g_free0 (real_name);
#line 1277 "../src/client/accounts/accounts-manager.vala"
					_g_free0 (primary_email);
#line 1277 "../src/client/accounts/accounts-manager.vala"
					_geary_config_file_group_unref0 (config);
#line 1277 "../src/client/accounts/accounts-manager.vala"
					return NULL;
#line 11521 "accounts-manager.c"
				} else {
#line 1277 "../src/client/accounts/accounts-manager.vala"
					_g_free0 (alt_email);
#line 1277 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (alt_email_list);
#line 1277 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (info);
#line 1277 "../src/client/accounts/accounts-manager.vala"
					_g_free0 (_tmp5_);
#line 1277 "../src/client/accounts/accounts-manager.vala"
					_g_free0 (real_name);
#line 1277 "../src/client/accounts/accounts-manager.vala"
					_g_free0 (primary_email);
#line 1277 "../src/client/accounts/accounts-manager.vala"
					_geary_config_file_group_unref0 (config);
#line 1277 "../src/client/accounts/accounts-manager.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1277 "../src/client/accounts/accounts-manager.vala"
					g_clear_error (&_inner_error0_);
#line 1277 "../src/client/accounts/accounts-manager.vala"
					return NULL;
#line 11543 "accounts-manager.c"
				}
			}
#line 1276 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (alt_email);
#line 11548 "accounts-manager.c"
		}
	}
#line 1289 "../src/client/accounts/accounts-manager.vala"
	_tmp65_ = info;
#line 1289 "../src/client/accounts/accounts-manager.vala"
	_tmp66_ = config;
#line 1289 "../src/client/accounts/accounts-manager.vala"
	_tmp67_ = info;
#line 1289 "../src/client/accounts/accounts-manager.vala"
	_tmp68_ = geary_account_information_get_prefetch_period_days (_tmp67_);
#line 1289 "../src/client/accounts/accounts-manager.vala"
	_tmp69_ = _tmp68_;
#line 1289 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_prefetch_period_days (_tmp65_, geary_config_file_group_get_int (_tmp66_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_PREFETCH_PERIOD_DAYS_KEY, _tmp69_));
#line 1292 "../src/client/accounts/accounts-manager.vala"
	_tmp70_ = info;
#line 1292 "../src/client/accounts/accounts-manager.vala"
	_tmp71_ = config;
#line 1292 "../src/client/accounts/accounts-manager.vala"
	_tmp72_ = info;
#line 1292 "../src/client/accounts/accounts-manager.vala"
	_tmp73_ = geary_account_information_get_save_sent (_tmp72_);
#line 1292 "../src/client/accounts/accounts-manager.vala"
	_tmp74_ = _tmp73_;
#line 1292 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_save_sent (_tmp70_, geary_config_file_group_get_bool (_tmp71_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SAVE_SENT_MAIL_KEY, _tmp74_));
#line 1295 "../src/client/accounts/accounts-manager.vala"
	_tmp75_ = info;
#line 1295 "../src/client/accounts/accounts-manager.vala"
	_tmp76_ = config;
#line 1295 "../src/client/accounts/accounts-manager.vala"
	_tmp77_ = info;
#line 1295 "../src/client/accounts/accounts-manager.vala"
	_tmp78_ = geary_account_information_get_use_signature (_tmp77_);
#line 1295 "../src/client/accounts/accounts-manager.vala"
	_tmp79_ = _tmp78_;
#line 1295 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_use_signature (_tmp75_, geary_config_file_group_get_bool (_tmp76_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_USE_EMAIL_SIGNATURE_KEY, _tmp79_));
#line 1298 "../src/client/accounts/accounts-manager.vala"
	_tmp80_ = info;
#line 1298 "../src/client/accounts/accounts-manager.vala"
	_tmp81_ = config;
#line 1298 "../src/client/accounts/accounts-manager.vala"
	_tmp82_ = info;
#line 1298 "../src/client/accounts/accounts-manager.vala"
	_tmp83_ = geary_account_information_get_signature (_tmp82_);
#line 1298 "../src/client/accounts/accounts-manager.vala"
	_tmp84_ = _tmp83_;
#line 1298 "../src/client/accounts/accounts-manager.vala"
	_tmp85_ = geary_config_file_group_get_string (_tmp81_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_EMAIL_SIGNATURE_KEY, _tmp84_);
#line 1298 "../src/client/accounts/accounts-manager.vala"
	_tmp86_ = _tmp85_;
#line 1298 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_signature (_tmp80_, _tmp86_);
#line 1298 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp86_);
#line 1302 "../src/client/accounts/accounts-manager.vala"
	_tmp87_ = info;
#line 1302 "../src/client/accounts/accounts-manager.vala"
	_tmp88_ = config;
#line 1302 "../src/client/accounts/accounts-manager.vala"
	_tmp89_ = geary_config_file_group_get_string_list (_tmp88_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_DRAFTS_FOLDER_KEY);
#line 1302 "../src/client/accounts/accounts-manager.vala"
	_tmp90_ = _tmp89_;
#line 1302 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_folder_steps_for_use (_tmp87_, GEARY_FOLDER_SPECIAL_USE_DRAFTS, _tmp90_);
#line 1302 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp90_);
#line 1305 "../src/client/accounts/accounts-manager.vala"
	_tmp91_ = info;
#line 1305 "../src/client/accounts/accounts-manager.vala"
	_tmp92_ = config;
#line 1305 "../src/client/accounts/accounts-manager.vala"
	_tmp93_ = geary_config_file_group_get_string_list (_tmp92_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SENT_MAIL_FOLDER_KEY);
#line 1305 "../src/client/accounts/accounts-manager.vala"
	_tmp94_ = _tmp93_;
#line 1305 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_folder_steps_for_use (_tmp91_, GEARY_FOLDER_SPECIAL_USE_SENT, _tmp94_);
#line 1305 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp94_);
#line 1308 "../src/client/accounts/accounts-manager.vala"
	_tmp95_ = info;
#line 1308 "../src/client/accounts/accounts-manager.vala"
	_tmp96_ = config;
#line 1308 "../src/client/accounts/accounts-manager.vala"
	_tmp97_ = geary_config_file_group_get_string_list (_tmp96_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SPAM_FOLDER_KEY);
#line 1308 "../src/client/accounts/accounts-manager.vala"
	_tmp98_ = _tmp97_;
#line 1308 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_folder_steps_for_use (_tmp95_, GEARY_FOLDER_SPECIAL_USE_JUNK, _tmp98_);
#line 1308 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp98_);
#line 1311 "../src/client/accounts/accounts-manager.vala"
	_tmp99_ = info;
#line 1311 "../src/client/accounts/accounts-manager.vala"
	_tmp100_ = config;
#line 1311 "../src/client/accounts/accounts-manager.vala"
	_tmp101_ = geary_config_file_group_get_string_list (_tmp100_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_TRASH_FOLDER_KEY);
#line 1311 "../src/client/accounts/accounts-manager.vala"
	_tmp102_ = _tmp101_;
#line 1311 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_folder_steps_for_use (_tmp99_, GEARY_FOLDER_SPECIAL_USE_TRASH, _tmp102_);
#line 1311 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp102_);
#line 1314 "../src/client/accounts/accounts-manager.vala"
	_tmp103_ = info;
#line 1314 "../src/client/accounts/accounts-manager.vala"
	_tmp104_ = config;
#line 1314 "../src/client/accounts/accounts-manager.vala"
	_tmp105_ = geary_config_file_group_get_string_list (_tmp104_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_ARCHIVE_FOLDER_KEY);
#line 1314 "../src/client/accounts/accounts-manager.vala"
	_tmp106_ = _tmp105_;
#line 1314 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_folder_steps_for_use (_tmp103_, GEARY_FOLDER_SPECIAL_USE_ARCHIVE, _tmp106_);
#line 1314 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp106_);
#line 1318 "../src/client/accounts/accounts-manager.vala"
	_tmp107_ = info;
#line 1318 "../src/client/accounts/accounts-manager.vala"
	_tmp108_ = config;
#line 1318 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_save_drafts (_tmp107_, geary_config_file_group_get_bool (_tmp108_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SAVE_DRAFTS_KEY, TRUE));
#line 1320 "../src/client/accounts/accounts-manager.vala"
	result = info;
#line 1320 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (alt_email_list);
#line 1320 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp5_);
#line 1320 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (real_name);
#line 1320 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (primary_email);
#line 1320 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_group_unref0 (config);
#line 1320 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 11685 "accounts-manager.c"
}

static gchar*
___lambda15_ (AccountsAccountConfigLegacy* self,
              GearyRFC822MailboxAddress* alt)
{
	gchar* _tmp0_;
	gchar* result;
#line 1345 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (alt, GEARY_RF_C822_TYPE_MAILBOX_ADDRESS), NULL);
#line 1345 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = geary_rf_c822_decoded_message_data_to_rfc822_string (G_TYPE_CHECK_INSTANCE_CAST (alt, GEARY_RF_C822_TYPE_DECODED_MESSAGE_DATA, GearyRFC822DecodedMessageData));
#line 1345 "../src/client/accounts/accounts-manager.vala"
	result = _tmp0_;
#line 1345 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (alt);
#line 1345 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 11704 "accounts-manager.c"
}

static gpointer
____lambda15__gee_map_func (gpointer g,
                            gpointer self)
{
	gpointer result;
	result = ___lambda15_ ((AccountsAccountConfigLegacy*) self, (GearyRFC822MailboxAddress*) g);
#line 1342 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 11715 "accounts-manager.c"
}

static void
accounts_account_config_legacy_real_save (AccountsAccountConfig* base,
                                          GearyAccountInformation* info,
                                          GearyConfigFile* config_file)
{
	AccountsAccountConfigLegacy * self;
	GearyConfigFileGroup* config = NULL;
	GearyConfigFileGroup* _tmp0_;
	const gchar* _tmp1_ = NULL;
	GearyRFC822MailboxAddress* _tmp2_;
	GearyRFC822MailboxAddress* _tmp3_;
	GearyRFC822MailboxAddress* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	GearyConfigFileGroup* _tmp8_;
	GearyConfigFileGroup* _tmp9_;
	GearyRFC822MailboxAddress* _tmp10_;
	GearyRFC822MailboxAddress* _tmp11_;
	GearyRFC822MailboxAddress* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	GearyConfigFileGroup* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	GearyConfigFileGroup* _tmp18_;
	GearyServiceProvider _tmp19_;
	GearyServiceProvider _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	GearyConfigFileGroup* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	GearyConfigFileGroup* _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	GearyConfigFileGroup* _tmp29_;
	gboolean _tmp30_;
	gboolean _tmp31_;
	GearyConfigFileGroup* _tmp32_;
	gboolean _tmp33_;
	gboolean _tmp34_;
	GearyConfigFileGroup* _tmp35_;
	const gchar* _tmp36_;
	const gchar* _tmp37_;
	gboolean _tmp38_;
	gboolean _tmp39_;
	GeeList* empty = NULL;
	GeeArrayList* _tmp53_;
	GeeList* steps = NULL;
	GeeList* _tmp54_;
	GeeList* _tmp55_ = NULL;
	GeeList* _tmp56_;
	GearyConfigFileGroup* _tmp59_;
	GeeList* _tmp60_;
	GeeList* _tmp61_ = NULL;
	GeeList* _tmp62_;
	GearyConfigFileGroup* _tmp65_;
	GeeList* _tmp66_;
	GeeList* _tmp67_ = NULL;
	GeeList* _tmp68_;
	GearyConfigFileGroup* _tmp71_;
	GeeList* _tmp72_;
	GeeList* _tmp73_ = NULL;
	GeeList* _tmp74_;
	GearyConfigFileGroup* _tmp77_;
	GeeList* _tmp78_;
	GeeList* _tmp79_ = NULL;
	GeeList* _tmp80_;
	GearyConfigFileGroup* _tmp83_;
	GearyConfigFileGroup* _tmp84_;
	gboolean _tmp85_;
	gboolean _tmp86_;
#line 1323 "../src/client/accounts/accounts-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, ACCOUNTS_TYPE_ACCOUNT_CONFIG_LEGACY, AccountsAccountConfigLegacy);
#line 1323 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 1323 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (config_file, GEARY_TYPE_CONFIG_FILE));
#line 1326 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = geary_config_file_get_group (config_file, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_GROUP);
#line 1326 "../src/client/accounts/accounts-manager.vala"
	config = _tmp0_;
#line 1328 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = geary_account_information_get_primary_mailbox (info);
#line 1328 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = _tmp2_;
#line 1328 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = _tmp3_;
#line 1328 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = geary_rf_c822_mailbox_address_get_name (_tmp4_);
#line 1328 "../src/client/accounts/accounts-manager.vala"
	_tmp6_ = _tmp5_;
#line 1328 "../src/client/accounts/accounts-manager.vala"
	_tmp7_ = _tmp6_;
#line 1328 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp4_);
#line 1328 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _tmp7_;
#line 1328 "../src/client/accounts/accounts-manager.vala"
	if (_tmp1_ == NULL) {
#line 1328 "../src/client/accounts/accounts-manager.vala"
		_tmp1_ = "";
#line 11821 "accounts-manager.c"
	}
#line 1328 "../src/client/accounts/accounts-manager.vala"
	_tmp8_ = config;
#line 1328 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string (_tmp8_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_REAL_NAME_KEY, _tmp1_);
#line 1329 "../src/client/accounts/accounts-manager.vala"
	_tmp9_ = config;
#line 1329 "../src/client/accounts/accounts-manager.vala"
	_tmp10_ = geary_account_information_get_primary_mailbox (info);
#line 1329 "../src/client/accounts/accounts-manager.vala"
	_tmp11_ = _tmp10_;
#line 1329 "../src/client/accounts/accounts-manager.vala"
	_tmp12_ = _tmp11_;
#line 1329 "../src/client/accounts/accounts-manager.vala"
	_tmp13_ = geary_rf_c822_mailbox_address_get_address (_tmp12_);
#line 1329 "../src/client/accounts/accounts-manager.vala"
	_tmp14_ = _tmp13_;
#line 1329 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string (_tmp9_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_PRIMARY_EMAIL_KEY, _tmp14_);
#line 1329 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp12_);
#line 1330 "../src/client/accounts/accounts-manager.vala"
	_tmp15_ = config;
#line 1330 "../src/client/accounts/accounts-manager.vala"
	_tmp16_ = geary_account_information_get_label (info);
#line 1330 "../src/client/accounts/accounts-manager.vala"
	_tmp17_ = _tmp16_;
#line 1330 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string (_tmp15_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_NICKNAME_KEY, _tmp17_);
#line 1331 "../src/client/accounts/accounts-manager.vala"
	_tmp18_ = config;
#line 1331 "../src/client/accounts/accounts-manager.vala"
	_tmp19_ = geary_account_information_get_service_provider (info);
#line 1331 "../src/client/accounts/accounts-manager.vala"
	_tmp20_ = _tmp19_;
#line 1331 "../src/client/accounts/accounts-manager.vala"
	_tmp21_ = geary_service_provider_to_value (_tmp20_);
#line 1331 "../src/client/accounts/accounts-manager.vala"
	_tmp22_ = _tmp21_;
#line 1331 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string (_tmp18_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SERVICE_PROVIDER_KEY, _tmp22_);
#line 1331 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp22_);
#line 1332 "../src/client/accounts/accounts-manager.vala"
	_tmp23_ = config;
#line 1332 "../src/client/accounts/accounts-manager.vala"
	_tmp24_ = geary_account_information_get_ordinal (info);
#line 1332 "../src/client/accounts/accounts-manager.vala"
	_tmp25_ = _tmp24_;
#line 1332 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_int (_tmp23_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_ORDINAL_KEY, _tmp25_);
#line 1333 "../src/client/accounts/accounts-manager.vala"
	_tmp26_ = config;
#line 1333 "../src/client/accounts/accounts-manager.vala"
	_tmp27_ = geary_account_information_get_prefetch_period_days (info);
#line 1333 "../src/client/accounts/accounts-manager.vala"
	_tmp28_ = _tmp27_;
#line 1333 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_int (_tmp26_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_PREFETCH_PERIOD_DAYS_KEY, _tmp28_);
#line 1334 "../src/client/accounts/accounts-manager.vala"
	_tmp29_ = config;
#line 1334 "../src/client/accounts/accounts-manager.vala"
	_tmp30_ = geary_account_information_get_save_sent (info);
#line 1334 "../src/client/accounts/accounts-manager.vala"
	_tmp31_ = _tmp30_;
#line 1334 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_bool (_tmp29_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SAVE_SENT_MAIL_KEY, _tmp31_);
#line 1335 "../src/client/accounts/accounts-manager.vala"
	_tmp32_ = config;
#line 1335 "../src/client/accounts/accounts-manager.vala"
	_tmp33_ = geary_account_information_get_use_signature (info);
#line 1335 "../src/client/accounts/accounts-manager.vala"
	_tmp34_ = _tmp33_;
#line 1335 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_bool (_tmp32_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_USE_EMAIL_SIGNATURE_KEY, _tmp34_);
#line 1336 "../src/client/accounts/accounts-manager.vala"
	_tmp35_ = config;
#line 1336 "../src/client/accounts/accounts-manager.vala"
	_tmp36_ = geary_account_information_get_signature (info);
#line 1336 "../src/client/accounts/accounts-manager.vala"
	_tmp37_ = _tmp36_;
#line 1336 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string (_tmp35_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_EMAIL_SIGNATURE_KEY, _tmp37_);
#line 1337 "../src/client/accounts/accounts-manager.vala"
	_tmp38_ = geary_account_information_get_has_sender_aliases (info);
#line 1337 "../src/client/accounts/accounts-manager.vala"
	_tmp39_ = _tmp38_;
#line 1337 "../src/client/accounts/accounts-manager.vala"
	if (_tmp39_) {
#line 11911 "accounts-manager.c"
		GeeList* alts = NULL;
		GeeList* _tmp40_;
		GeeList* _tmp41_;
		GeeList* _tmp42_;
		gpointer _tmp43_;
		GearyRFC822MailboxAddress* _tmp44_;
		GearyConfigFileGroup* _tmp45_;
		GeeList* _tmp46_;
		GearyIterable* _tmp47_;
		GearyIterable* _tmp48_;
		GearyIterable* _tmp49_;
		GearyIterable* _tmp50_;
		GeeArrayList* _tmp51_;
		GeeArrayList* _tmp52_;
#line 1338 "../src/client/accounts/accounts-manager.vala"
		_tmp40_ = geary_account_information_get_sender_mailboxes (info);
#line 1338 "../src/client/accounts/accounts-manager.vala"
		_tmp41_ = _tmp40_;
#line 1338 "../src/client/accounts/accounts-manager.vala"
		alts = _tmp41_;
#line 1340 "../src/client/accounts/accounts-manager.vala"
		_tmp42_ = alts;
#line 1340 "../src/client/accounts/accounts-manager.vala"
		_tmp43_ = gee_list_remove_at (_tmp42_, 0);
#line 1340 "../src/client/accounts/accounts-manager.vala"
		_tmp44_ = (GearyRFC822MailboxAddress*) _tmp43_;
#line 1340 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp44_);
#line 1342 "../src/client/accounts/accounts-manager.vala"
		_tmp45_ = config;
#line 1342 "../src/client/accounts/accounts-manager.vala"
		_tmp46_ = alts;
#line 1342 "../src/client/accounts/accounts-manager.vala"
		_tmp47_ = geary_traverse (GEARY_RF_C822_TYPE_MAILBOX_ADDRESS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1342 "../src/client/accounts/accounts-manager.vala"
		_tmp48_ = _tmp47_;
#line 1342 "../src/client/accounts/accounts-manager.vala"
		_tmp49_ = geary_iterable_map (_tmp48_, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, ____lambda15__gee_map_func, self);
#line 1342 "../src/client/accounts/accounts-manager.vala"
		_tmp50_ = _tmp49_;
#line 1342 "../src/client/accounts/accounts-manager.vala"
		_tmp51_ = geary_iterable_to_array_list (_tmp50_, NULL, NULL, NULL);
#line 1342 "../src/client/accounts/accounts-manager.vala"
		_tmp52_ = _tmp51_;
#line 1342 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_group_set_string_list (_tmp45_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_ALTERNATE_EMAILS_KEY, G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, GEE_TYPE_LIST, GeeList));
#line 1342 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp52_);
#line 1342 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp50_);
#line 1342 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp48_);
#line 1337 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (alts);
#line 11966 "accounts-manager.c"
	}
#line 1350 "../src/client/accounts/accounts-manager.vala"
	_tmp53_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 1350 "../src/client/accounts/accounts-manager.vala"
	empty = G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, GEE_TYPE_LIST, GeeList);
#line 1351 "../src/client/accounts/accounts-manager.vala"
	steps = NULL;
#line 1353 "../src/client/accounts/accounts-manager.vala"
	_tmp54_ = geary_account_information_get_folder_steps_for_use (info, GEARY_FOLDER_SPECIAL_USE_DRAFTS);
#line 1353 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (steps);
#line 1353 "../src/client/accounts/accounts-manager.vala"
	steps = _tmp54_;
#line 1356 "../src/client/accounts/accounts-manager.vala"
	_tmp56_ = steps;
#line 1356 "../src/client/accounts/accounts-manager.vala"
	if (_tmp56_ != NULL) {
#line 11984 "accounts-manager.c"
		GeeList* _tmp57_;
#line 1356 "../src/client/accounts/accounts-manager.vala"
		_tmp57_ = steps;
#line 1356 "../src/client/accounts/accounts-manager.vala"
		_tmp55_ = _tmp57_;
#line 11990 "accounts-manager.c"
	} else {
		GeeList* _tmp58_;
#line 1356 "../src/client/accounts/accounts-manager.vala"
		_tmp58_ = empty;
#line 1356 "../src/client/accounts/accounts-manager.vala"
		_tmp55_ = _tmp58_;
#line 11997 "accounts-manager.c"
	}
#line 1354 "../src/client/accounts/accounts-manager.vala"
	_tmp59_ = config;
#line 1354 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string_list (_tmp59_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_DRAFTS_FOLDER_KEY, _tmp55_);
#line 1359 "../src/client/accounts/accounts-manager.vala"
	_tmp60_ = geary_account_information_get_folder_steps_for_use (info, GEARY_FOLDER_SPECIAL_USE_SENT);
#line 1359 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (steps);
#line 1359 "../src/client/accounts/accounts-manager.vala"
	steps = _tmp60_;
#line 1362 "../src/client/accounts/accounts-manager.vala"
	_tmp62_ = steps;
#line 1362 "../src/client/accounts/accounts-manager.vala"
	if (_tmp62_ != NULL) {
#line 12013 "accounts-manager.c"
		GeeList* _tmp63_;
#line 1362 "../src/client/accounts/accounts-manager.vala"
		_tmp63_ = steps;
#line 1362 "../src/client/accounts/accounts-manager.vala"
		_tmp61_ = _tmp63_;
#line 12019 "accounts-manager.c"
	} else {
		GeeList* _tmp64_;
#line 1362 "../src/client/accounts/accounts-manager.vala"
		_tmp64_ = empty;
#line 1362 "../src/client/accounts/accounts-manager.vala"
		_tmp61_ = _tmp64_;
#line 12026 "accounts-manager.c"
	}
#line 1360 "../src/client/accounts/accounts-manager.vala"
	_tmp65_ = config;
#line 1360 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string_list (_tmp65_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SENT_MAIL_FOLDER_KEY, _tmp61_);
#line 1364 "../src/client/accounts/accounts-manager.vala"
	_tmp66_ = geary_account_information_get_folder_steps_for_use (info, GEARY_FOLDER_SPECIAL_USE_JUNK);
#line 1364 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (steps);
#line 1364 "../src/client/accounts/accounts-manager.vala"
	steps = _tmp66_;
#line 1367 "../src/client/accounts/accounts-manager.vala"
	_tmp68_ = steps;
#line 1367 "../src/client/accounts/accounts-manager.vala"
	if (_tmp68_ != NULL) {
#line 12042 "accounts-manager.c"
		GeeList* _tmp69_;
#line 1367 "../src/client/accounts/accounts-manager.vala"
		_tmp69_ = steps;
#line 1367 "../src/client/accounts/accounts-manager.vala"
		_tmp67_ = _tmp69_;
#line 12048 "accounts-manager.c"
	} else {
		GeeList* _tmp70_;
#line 1367 "../src/client/accounts/accounts-manager.vala"
		_tmp70_ = empty;
#line 1367 "../src/client/accounts/accounts-manager.vala"
		_tmp67_ = _tmp70_;
#line 12055 "accounts-manager.c"
	}
#line 1365 "../src/client/accounts/accounts-manager.vala"
	_tmp71_ = config;
#line 1365 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string_list (_tmp71_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SPAM_FOLDER_KEY, _tmp67_);
#line 1369 "../src/client/accounts/accounts-manager.vala"
	_tmp72_ = geary_account_information_get_folder_steps_for_use (info, GEARY_FOLDER_SPECIAL_USE_TRASH);
#line 1369 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (steps);
#line 1369 "../src/client/accounts/accounts-manager.vala"
	steps = _tmp72_;
#line 1372 "../src/client/accounts/accounts-manager.vala"
	_tmp74_ = steps;
#line 1372 "../src/client/accounts/accounts-manager.vala"
	if (_tmp74_ != NULL) {
#line 12071 "accounts-manager.c"
		GeeList* _tmp75_;
#line 1372 "../src/client/accounts/accounts-manager.vala"
		_tmp75_ = steps;
#line 1372 "../src/client/accounts/accounts-manager.vala"
		_tmp73_ = _tmp75_;
#line 12077 "accounts-manager.c"
	} else {
		GeeList* _tmp76_;
#line 1372 "../src/client/accounts/accounts-manager.vala"
		_tmp76_ = empty;
#line 1372 "../src/client/accounts/accounts-manager.vala"
		_tmp73_ = _tmp76_;
#line 12084 "accounts-manager.c"
	}
#line 1370 "../src/client/accounts/accounts-manager.vala"
	_tmp77_ = config;
#line 1370 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string_list (_tmp77_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_TRASH_FOLDER_KEY, _tmp73_);
#line 1374 "../src/client/accounts/accounts-manager.vala"
	_tmp78_ = geary_account_information_get_folder_steps_for_use (info, GEARY_FOLDER_SPECIAL_USE_ARCHIVE);
#line 1374 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (steps);
#line 1374 "../src/client/accounts/accounts-manager.vala"
	steps = _tmp78_;
#line 1377 "../src/client/accounts/accounts-manager.vala"
	_tmp80_ = steps;
#line 1377 "../src/client/accounts/accounts-manager.vala"
	if (_tmp80_ != NULL) {
#line 12100 "accounts-manager.c"
		GeeList* _tmp81_;
#line 1377 "../src/client/accounts/accounts-manager.vala"
		_tmp81_ = steps;
#line 1377 "../src/client/accounts/accounts-manager.vala"
		_tmp79_ = _tmp81_;
#line 12106 "accounts-manager.c"
	} else {
		GeeList* _tmp82_;
#line 1377 "../src/client/accounts/accounts-manager.vala"
		_tmp82_ = empty;
#line 1377 "../src/client/accounts/accounts-manager.vala"
		_tmp79_ = _tmp82_;
#line 12113 "accounts-manager.c"
	}
#line 1375 "../src/client/accounts/accounts-manager.vala"
	_tmp83_ = config;
#line 1375 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string_list (_tmp83_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_ARCHIVE_FOLDER_KEY, _tmp79_);
#line 1380 "../src/client/accounts/accounts-manager.vala"
	_tmp84_ = config;
#line 1380 "../src/client/accounts/accounts-manager.vala"
	_tmp85_ = geary_account_information_get_save_drafts (info);
#line 1380 "../src/client/accounts/accounts-manager.vala"
	_tmp86_ = _tmp85_;
#line 1380 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_bool (_tmp84_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SAVE_DRAFTS_KEY, _tmp86_);
#line 1323 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (steps);
#line 1323 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (empty);
#line 1323 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_group_unref0 (config);
#line 12133 "accounts-manager.c"
}

AccountsAccountConfigLegacy*
accounts_account_config_legacy_construct (GType object_type)
{
	AccountsAccountConfigLegacy * self = NULL;
#line 1206 "../src/client/accounts/accounts-manager.vala"
	self = (AccountsAccountConfigLegacy*) g_object_new (object_type, NULL);
#line 1206 "../src/client/accounts/accounts-manager.vala"
	return self;
#line 12144 "accounts-manager.c"
}

AccountsAccountConfigLegacy*
accounts_account_config_legacy_new (void)
{
#line 1206 "../src/client/accounts/accounts-manager.vala"
	return accounts_account_config_legacy_construct (ACCOUNTS_TYPE_ACCOUNT_CONFIG_LEGACY);
#line 12152 "accounts-manager.c"
}

static void
accounts_account_config_legacy_class_init (AccountsAccountConfigLegacyClass * klass,
                                           gpointer klass_data)
{
#line 1206 "../src/client/accounts/accounts-manager.vala"
	accounts_account_config_legacy_parent_class = g_type_class_peek_parent (klass);
#line 12161 "accounts-manager.c"
}

static void
accounts_account_config_legacy_accounts_account_config_interface_init (AccountsAccountConfigIface * iface,
                                                                       gpointer iface_data)
{
#line 1206 "../src/client/accounts/accounts-manager.vala"
	accounts_account_config_legacy_accounts_account_config_parent_iface = g_type_interface_peek_parent (iface);
#line 1206 "../src/client/accounts/accounts-manager.vala"
	iface->load = (GearyAccountInformation* (*) (AccountsAccountConfig*, GearyConfigFile*, const gchar*, GearyCredentialsMediator*, GearyServiceProvider*, const gchar*, GError**)) accounts_account_config_legacy_real_load;
#line 1206 "../src/client/accounts/accounts-manager.vala"
	iface->save = (void (*) (AccountsAccountConfig*, GearyAccountInformation*, GearyConfigFile*)) accounts_account_config_legacy_real_save;
#line 12174 "accounts-manager.c"
}

static void
accounts_account_config_legacy_instance_init (AccountsAccountConfigLegacy * self,
                                              gpointer klass)
{
}

/**
 * Manages persistence for un-versioned account configuration.
 */
static GType
accounts_account_config_legacy_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AccountsAccountConfigLegacyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) accounts_account_config_legacy_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AccountsAccountConfigLegacy), 0, (GInstanceInitFunc) accounts_account_config_legacy_instance_init, NULL };
	static const GInterfaceInfo accounts_account_config_info = { (GInterfaceInitFunc) accounts_account_config_legacy_accounts_account_config_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType accounts_account_config_legacy_type_id;
	accounts_account_config_legacy_type_id = g_type_register_static (G_TYPE_OBJECT, "AccountsAccountConfigLegacy", &g_define_type_info, 0);
	g_type_add_interface_static (accounts_account_config_legacy_type_id, ACCOUNTS_TYPE_ACCOUNT_CONFIG, &accounts_account_config_info);
	return accounts_account_config_legacy_type_id;
}

GType
accounts_account_config_legacy_get_type (void)
{
	static volatile gsize accounts_account_config_legacy_type_id__once = 0;
	if (g_once_init_enter (&accounts_account_config_legacy_type_id__once)) {
		GType accounts_account_config_legacy_type_id;
		accounts_account_config_legacy_type_id = accounts_account_config_legacy_get_type_once ();
		g_once_init_leave (&accounts_account_config_legacy_type_id__once, accounts_account_config_legacy_type_id);
	}
	return accounts_account_config_legacy_type_id__once;
}

/** Loads a supported service from a config file. */
static GearyTlsNegotiationMethod
___lambda9_ (AccountsServiceConfigV1* self,
             const gchar* value,
             GError** error)
{
	GError* _inner_error0_ = NULL;
	GearyTlsNegotiationMethod result;
#line 1429 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (value != NULL, 0);
#line 12219 "accounts-manager.c"
	{
		GearyTlsNegotiationMethod _tmp0_ = 0;
#line 1431 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = geary_tls_negotiation_method_for_value (value, &_inner_error0_);
#line 1431 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 12226 "accounts-manager.c"
			goto __catch0_g_error;
		}
#line 1431 "../src/client/accounts/accounts-manager.vala"
		result = _tmp0_;
#line 1431 "../src/client/accounts/accounts-manager.vala"
		return result;
#line 12233 "accounts-manager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		GError* _tmp3_;
#line 1430 "../src/client/accounts/accounts-manager.vala"
		err = _inner_error0_;
#line 1430 "../src/client/accounts/accounts-manager.vala"
		_inner_error0_ = NULL;
#line 1433 "../src/client/accounts/accounts-manager.vala"
		_tmp1_ = err;
#line 1433 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = _tmp1_->message;
#line 1433 "../src/client/accounts/accounts-manager.vala"
		_tmp3_ = g_error_new_literal (G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_INVALID_VALUE, _tmp2_);
#line 1433 "../src/client/accounts/accounts-manager.vala"
		_inner_error0_ = _tmp3_;
#line 1433 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (err);
#line 12256 "accounts-manager.c"
		goto __finally0;
	}
	__finally0:
#line 1430 "../src/client/accounts/accounts-manager.vala"
	if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1430 "../src/client/accounts/accounts-manager.vala"
		g_propagate_error (error, _inner_error0_);
#line 1430 "../src/client/accounts/accounts-manager.vala"
		return 0;
#line 12266 "accounts-manager.c"
	} else {
#line 1430 "../src/client/accounts/accounts-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1430 "../src/client/accounts/accounts-manager.vala"
		g_clear_error (&_inner_error0_);
#line 1430 "../src/client/accounts/accounts-manager.vala"
		return 0;
#line 12274 "accounts-manager.c"
	}
}

static gpointer
____lambda9__geary_config_file_parser (const gchar* value,
                                       gpointer self,
                                       GError** error)
{
	gpointer result;
	result = (gpointer) ((gintptr) ___lambda9_ ((AccountsServiceConfigV1*) self, value, error));
#line 1426 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 12287 "accounts-manager.c"
}

static GearyCredentialsRequirement
___lambda10_ (AccountsServiceConfigV1* self,
              const gchar* value,
              GError** error)
{
	GError* _inner_error0_ = NULL;
	GearyCredentialsRequirement result;
#line 1441 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (value != NULL, 0);
#line 12299 "accounts-manager.c"
	{
		GearyCredentialsRequirement _tmp0_ = 0;
#line 1443 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = geary_credentials_requirement_for_value (value, &_inner_error0_);
#line 1443 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 12306 "accounts-manager.c"
			goto __catch0_g_error;
		}
#line 1443 "../src/client/accounts/accounts-manager.vala"
		result = _tmp0_;
#line 1443 "../src/client/accounts/accounts-manager.vala"
		return result;
#line 12313 "accounts-manager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		GError* _tmp3_;
#line 1442 "../src/client/accounts/accounts-manager.vala"
		err = _inner_error0_;
#line 1442 "../src/client/accounts/accounts-manager.vala"
		_inner_error0_ = NULL;
#line 1445 "../src/client/accounts/accounts-manager.vala"
		_tmp1_ = err;
#line 1445 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = _tmp1_->message;
#line 1445 "../src/client/accounts/accounts-manager.vala"
		_tmp3_ = g_error_new_literal (G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_INVALID_VALUE, _tmp2_);
#line 1445 "../src/client/accounts/accounts-manager.vala"
		_inner_error0_ = _tmp3_;
#line 1445 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (err);
#line 12336 "accounts-manager.c"
		goto __finally0;
	}
	__finally0:
#line 1442 "../src/client/accounts/accounts-manager.vala"
	if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1442 "../src/client/accounts/accounts-manager.vala"
		g_propagate_error (error, _inner_error0_);
#line 1442 "../src/client/accounts/accounts-manager.vala"
		return 0;
#line 12346 "accounts-manager.c"
	} else {
#line 1442 "../src/client/accounts/accounts-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1442 "../src/client/accounts/accounts-manager.vala"
		g_clear_error (&_inner_error0_);
#line 1442 "../src/client/accounts/accounts-manager.vala"
		return 0;
#line 12354 "accounts-manager.c"
	}
}

static gpointer
____lambda10__geary_config_file_parser (const gchar* value,
                                        gpointer self,
                                        GError** error)
{
	gpointer result;
	result = (gpointer) ((gintptr) ___lambda10_ ((AccountsServiceConfigV1*) self, value, error));
#line 1438 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 12367 "accounts-manager.c"
}

static void
accounts_service_config_v1_real_load (AccountsServiceConfig* base,
                                      GearyConfigFile* config,
                                      GearyAccountInformation* account,
                                      GearyServiceInformation* service,
                                      GError** error)
{
	AccountsServiceConfigV1 * self;
	const gchar* _tmp0_ = NULL;
	GearyProtocol _tmp1_;
	GearyProtocol _tmp2_;
	GearyConfigFileGroup* service_config = NULL;
	GearyConfigFileGroup* _tmp3_;
	gchar* login = NULL;
	GearyConfigFileGroup* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	GearyConfigFileGroup* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	GearyServiceProvider _tmp13_;
	GearyServiceProvider _tmp14_;
	GError* _inner_error0_ = NULL;
#line 1403 "../src/client/accounts/accounts-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, ACCOUNTS_TYPE_SERVICE_CONFIG_V1, AccountsServiceConfigV1);
#line 1403 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (config, GEARY_TYPE_CONFIG_FILE));
#line 1403 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 1403 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (service, GEARY_TYPE_SERVICE_INFORMATION));
#line 1408 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = geary_service_information_get_protocol (service);
#line 1408 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _tmp1_;
#line 1408 "../src/client/accounts/accounts-manager.vala"
	if (_tmp2_ == GEARY_PROTOCOL_IMAP) {
#line 1408 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = ACCOUNTS_SERVICE_CONFIG_V1_GROUP_INCOMING;
#line 12409 "accounts-manager.c"
	} else {
#line 1408 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = ACCOUNTS_SERVICE_CONFIG_V1_GROUP_OUTGOING;
#line 12413 "accounts-manager.c"
	}
#line 1407 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = geary_config_file_get_group (config, _tmp0_);
#line 1407 "../src/client/accounts/accounts-manager.vala"
	service_config = _tmp3_;
#line 1411 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = service_config;
#line 1411 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = geary_config_file_group_get_string (_tmp4_, ACCOUNTS_SERVICE_CONFIG_V1_LOGIN, NULL);
#line 1411 "../src/client/accounts/accounts-manager.vala"
	login = _tmp5_;
#line 1412 "../src/client/accounts/accounts-manager.vala"
	_tmp6_ = login;
#line 1412 "../src/client/accounts/accounts-manager.vala"
	if (_tmp6_ != NULL) {
#line 12429 "accounts-manager.c"
		const gchar* _tmp7_;
		GearyCredentials* _tmp8_;
		GearyCredentials* _tmp9_;
#line 1413 "../src/client/accounts/accounts-manager.vala"
		_tmp7_ = login;
#line 1413 "../src/client/accounts/accounts-manager.vala"
		_tmp8_ = geary_credentials_new (GEARY_CREDENTIALS_METHOD_PASSWORD, _tmp7_, NULL);
#line 1413 "../src/client/accounts/accounts-manager.vala"
		_tmp9_ = _tmp8_;
#line 1413 "../src/client/accounts/accounts-manager.vala"
		geary_service_information_set_credentials (service, _tmp9_);
#line 1413 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp9_);
#line 12443 "accounts-manager.c"
	}
#line 1417 "../src/client/accounts/accounts-manager.vala"
	_tmp10_ = service_config;
#line 1417 "../src/client/accounts/accounts-manager.vala"
	_tmp11_ = geary_service_information_get_remember_password (service);
#line 1417 "../src/client/accounts/accounts-manager.vala"
	_tmp12_ = _tmp11_;
#line 1417 "../src/client/accounts/accounts-manager.vala"
	geary_service_information_set_remember_password (service, geary_config_file_group_get_bool (_tmp10_, ACCOUNTS_SERVICE_CONFIG_V1_REMEMBER_PASSWORD, _tmp12_));
#line 1422 "../src/client/accounts/accounts-manager.vala"
	_tmp13_ = geary_account_information_get_service_provider (account);
#line 1422 "../src/client/accounts/accounts-manager.vala"
	_tmp14_ = _tmp13_;
#line 1422 "../src/client/accounts/accounts-manager.vala"
	if (_tmp14_ == GEARY_SERVICE_PROVIDER_OTHER) {
#line 12459 "accounts-manager.c"
		gchar* _tmp15_ = NULL;
		GearyConfigFileGroup* _tmp16_;
		gchar* _tmp17_;
		GearyConfigFileGroup* _tmp18_;
		guint16 _tmp19_;
		guint16 _tmp20_;
		GearyTlsNegotiationMethod _tmp21_ = 0;
		GearyConfigFileGroup* _tmp22_;
		gpointer _tmp23_;
		GearyCredentialsRequirement _tmp24_ = 0;
		GearyConfigFileGroup* _tmp25_;
		gpointer _tmp26_;
		guint16 _tmp27_;
		guint16 _tmp28_;
#line 1423 "../src/client/accounts/accounts-manager.vala"
		_tmp16_ = service_config;
#line 1423 "../src/client/accounts/accounts-manager.vala"
		_tmp17_ = geary_config_file_group_get_required_string (_tmp16_, ACCOUNTS_SERVICE_CONFIG_V1_HOST, &_inner_error0_);
#line 1423 "../src/client/accounts/accounts-manager.vala"
		_tmp15_ = _tmp17_;
#line 1423 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1423 "../src/client/accounts/accounts-manager.vala"
			if ((_inner_error0_->domain == ACCOUNTS_CONFIG_ERROR) || (_inner_error0_->domain == G_KEY_FILE_ERROR)) {
#line 1423 "../src/client/accounts/accounts-manager.vala"
				g_propagate_error (error, _inner_error0_);
#line 1423 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (login);
#line 1423 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (service_config);
#line 1423 "../src/client/accounts/accounts-manager.vala"
				return;
#line 12492 "accounts-manager.c"
			} else {
#line 1423 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (login);
#line 1423 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (service_config);
#line 1423 "../src/client/accounts/accounts-manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1423 "../src/client/accounts/accounts-manager.vala"
				g_clear_error (&_inner_error0_);
#line 1423 "../src/client/accounts/accounts-manager.vala"
				return;
#line 12504 "accounts-manager.c"
			}
		}
#line 1423 "../src/client/accounts/accounts-manager.vala"
		geary_service_information_set_host (service, _tmp15_);
#line 1424 "../src/client/accounts/accounts-manager.vala"
		_tmp18_ = service_config;
#line 1424 "../src/client/accounts/accounts-manager.vala"
		_tmp19_ = geary_service_information_get_port (service);
#line 1424 "../src/client/accounts/accounts-manager.vala"
		_tmp20_ = _tmp19_;
#line 1424 "../src/client/accounts/accounts-manager.vala"
		geary_service_information_set_port (service, (guint16) geary_config_file_group_get_int (_tmp18_, ACCOUNTS_SERVICE_CONFIG_V1_PORT, (gint) _tmp20_));
#line 1426 "../src/client/accounts/accounts-manager.vala"
		_tmp22_ = service_config;
#line 1426 "../src/client/accounts/accounts-manager.vala"
		_tmp23_ = geary_config_file_group_parse_required_value (_tmp22_, GEARY_TYPE_TLS_NEGOTIATION_METHOD, NULL, NULL, ACCOUNTS_SERVICE_CONFIG_V1_SECURITY, ____lambda9__geary_config_file_parser, self, &_inner_error0_);
#line 1426 "../src/client/accounts/accounts-manager.vala"
		_tmp21_ = (GearyTlsNegotiationMethod) ((gintptr) _tmp23_);
#line 1426 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1426 "../src/client/accounts/accounts-manager.vala"
			if ((_inner_error0_->domain == ACCOUNTS_CONFIG_ERROR) || (_inner_error0_->domain == G_KEY_FILE_ERROR)) {
#line 1426 "../src/client/accounts/accounts-manager.vala"
				g_propagate_error (error, _inner_error0_);
#line 1426 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp15_);
#line 1426 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (login);
#line 1426 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (service_config);
#line 1426 "../src/client/accounts/accounts-manager.vala"
				return;
#line 12537 "accounts-manager.c"
			} else {
#line 1426 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp15_);
#line 1426 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (login);
#line 1426 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (service_config);
#line 1426 "../src/client/accounts/accounts-manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1426 "../src/client/accounts/accounts-manager.vala"
				g_clear_error (&_inner_error0_);
#line 1426 "../src/client/accounts/accounts-manager.vala"
				return;
#line 12551 "accounts-manager.c"
			}
		}
#line 1426 "../src/client/accounts/accounts-manager.vala"
		geary_service_information_set_transport_security (service, _tmp21_);
#line 1438 "../src/client/accounts/accounts-manager.vala"
		_tmp25_ = service_config;
#line 1438 "../src/client/accounts/accounts-manager.vala"
		_tmp26_ = geary_config_file_group_parse_required_value (_tmp25_, GEARY_CREDENTIALS_TYPE_REQUIREMENT, NULL, NULL, ACCOUNTS_SERVICE_CONFIG_V1_CREDENTIALS, ____lambda10__geary_config_file_parser, self, &_inner_error0_);
#line 1438 "../src/client/accounts/accounts-manager.vala"
		_tmp24_ = (GearyCredentialsRequirement) ((gintptr) _tmp26_);
#line 1438 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1438 "../src/client/accounts/accounts-manager.vala"
			if ((_inner_error0_->domain == ACCOUNTS_CONFIG_ERROR) || (_inner_error0_->domain == G_KEY_FILE_ERROR)) {
#line 1438 "../src/client/accounts/accounts-manager.vala"
				g_propagate_error (error, _inner_error0_);
#line 1438 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp15_);
#line 1438 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (login);
#line 1438 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (service_config);
#line 1438 "../src/client/accounts/accounts-manager.vala"
				return;
#line 12576 "accounts-manager.c"
			} else {
#line 1438 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp15_);
#line 1438 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (login);
#line 1438 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (service_config);
#line 1438 "../src/client/accounts/accounts-manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1438 "../src/client/accounts/accounts-manager.vala"
				g_clear_error (&_inner_error0_);
#line 1438 "../src/client/accounts/accounts-manager.vala"
				return;
#line 12590 "accounts-manager.c"
			}
		}
#line 1438 "../src/client/accounts/accounts-manager.vala"
		geary_service_information_set_credentials_requirement (service, _tmp24_);
#line 1450 "../src/client/accounts/accounts-manager.vala"
		_tmp27_ = geary_service_information_get_port (service);
#line 1450 "../src/client/accounts/accounts-manager.vala"
		_tmp28_ = _tmp27_;
#line 1450 "../src/client/accounts/accounts-manager.vala"
		if (((gint) _tmp28_) == 0) {
#line 1451 "../src/client/accounts/accounts-manager.vala"
			geary_service_information_set_port (service, geary_service_information_get_default_port (service));
#line 12603 "accounts-manager.c"
		}
#line 1422 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp15_);
#line 12607 "accounts-manager.c"
	}
#line 1403 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (login);
#line 1403 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_group_unref0 (service_config);
#line 12613 "accounts-manager.c"
}

/** Saves an service to a config file. */
static void
accounts_service_config_v1_real_save (AccountsServiceConfig* base,
                                      GearyAccountInformation* account,
                                      GearyServiceInformation* service,
                                      GearyConfigFile* config)
{
	AccountsServiceConfigV1 * self;
	const gchar* _tmp0_ = NULL;
	GearyProtocol _tmp1_;
	GearyProtocol _tmp2_;
	GearyConfigFileGroup* service_config = NULL;
	GearyConfigFileGroup* _tmp3_;
	GearyCredentials* _tmp4_;
	GearyCredentials* _tmp5_;
	GearyConfigFileGroup* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
	GearyServiceProvider _tmp14_;
	GearyServiceProvider _tmp15_;
#line 1457 "../src/client/accounts/accounts-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, ACCOUNTS_TYPE_SERVICE_CONFIG_V1, AccountsServiceConfigV1);
#line 1457 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 1457 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (service, GEARY_TYPE_SERVICE_INFORMATION));
#line 1457 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (config, GEARY_TYPE_CONFIG_FILE));
#line 1461 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = geary_service_information_get_protocol (service);
#line 1461 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _tmp1_;
#line 1461 "../src/client/accounts/accounts-manager.vala"
	if (_tmp2_ == GEARY_PROTOCOL_IMAP) {
#line 1461 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = ACCOUNTS_SERVICE_CONFIG_V1_GROUP_INCOMING;
#line 12652 "accounts-manager.c"
	} else {
#line 1461 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = ACCOUNTS_SERVICE_CONFIG_V1_GROUP_OUTGOING;
#line 12656 "accounts-manager.c"
	}
#line 1460 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = geary_config_file_get_group (config, _tmp0_);
#line 1460 "../src/client/accounts/accounts-manager.vala"
	service_config = _tmp3_;
#line 1464 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = geary_service_information_get_credentials (service);
#line 1464 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = _tmp4_;
#line 1464 "../src/client/accounts/accounts-manager.vala"
	if (_tmp5_ != NULL) {
#line 12668 "accounts-manager.c"
		GearyConfigFileGroup* _tmp6_;
		GearyCredentials* _tmp7_;
		GearyCredentials* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
#line 1465 "../src/client/accounts/accounts-manager.vala"
		_tmp6_ = service_config;
#line 1465 "../src/client/accounts/accounts-manager.vala"
		_tmp7_ = geary_service_information_get_credentials (service);
#line 1465 "../src/client/accounts/accounts-manager.vala"
		_tmp8_ = _tmp7_;
#line 1465 "../src/client/accounts/accounts-manager.vala"
		_tmp9_ = geary_credentials_get_user (_tmp8_);
#line 1465 "../src/client/accounts/accounts-manager.vala"
		_tmp10_ = _tmp9_;
#line 1465 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_group_set_string (_tmp6_, ACCOUNTS_SERVICE_CONFIG_V1_LOGIN, _tmp10_);
#line 12686 "accounts-manager.c"
	}
#line 1467 "../src/client/accounts/accounts-manager.vala"
	_tmp11_ = service_config;
#line 1467 "../src/client/accounts/accounts-manager.vala"
	_tmp12_ = geary_service_information_get_remember_password (service);
#line 1467 "../src/client/accounts/accounts-manager.vala"
	_tmp13_ = _tmp12_;
#line 1467 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_bool (_tmp11_, ACCOUNTS_SERVICE_CONFIG_V1_REMEMBER_PASSWORD, _tmp13_);
#line 1469 "../src/client/accounts/accounts-manager.vala"
	_tmp14_ = geary_account_information_get_service_provider (account);
#line 1469 "../src/client/accounts/accounts-manager.vala"
	_tmp15_ = _tmp14_;
#line 1469 "../src/client/accounts/accounts-manager.vala"
	if (_tmp15_ == GEARY_SERVICE_PROVIDER_OTHER) {
#line 12702 "accounts-manager.c"
		GearyConfigFileGroup* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		GearyConfigFileGroup* _tmp19_;
		guint16 _tmp20_;
		guint16 _tmp21_;
		GearyConfigFileGroup* _tmp22_;
		GearyTlsNegotiationMethod _tmp23_;
		GearyTlsNegotiationMethod _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		GearyConfigFileGroup* _tmp27_;
		GearyCredentialsRequirement _tmp28_;
		GearyCredentialsRequirement _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
#line 1470 "../src/client/accounts/accounts-manager.vala"
		_tmp16_ = service_config;
#line 1470 "../src/client/accounts/accounts-manager.vala"
		_tmp17_ = geary_service_information_get_host (service);
#line 1470 "../src/client/accounts/accounts-manager.vala"
		_tmp18_ = _tmp17_;
#line 1470 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_group_set_string (_tmp16_, ACCOUNTS_SERVICE_CONFIG_V1_HOST, _tmp18_);
#line 1471 "../src/client/accounts/accounts-manager.vala"
		_tmp19_ = service_config;
#line 1471 "../src/client/accounts/accounts-manager.vala"
		_tmp20_ = geary_service_information_get_port (service);
#line 1471 "../src/client/accounts/accounts-manager.vala"
		_tmp21_ = _tmp20_;
#line 1471 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_group_set_int (_tmp19_, ACCOUNTS_SERVICE_CONFIG_V1_PORT, (gint) _tmp21_);
#line 1472 "../src/client/accounts/accounts-manager.vala"
		_tmp22_ = service_config;
#line 1472 "../src/client/accounts/accounts-manager.vala"
		_tmp23_ = geary_service_information_get_transport_security (service);
#line 1472 "../src/client/accounts/accounts-manager.vala"
		_tmp24_ = _tmp23_;
#line 1472 "../src/client/accounts/accounts-manager.vala"
		_tmp25_ = geary_tls_negotiation_method_to_value (_tmp24_);
#line 1472 "../src/client/accounts/accounts-manager.vala"
		_tmp26_ = _tmp25_;
#line 1472 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_group_set_string (_tmp22_, ACCOUNTS_SERVICE_CONFIG_V1_SECURITY, _tmp26_);
#line 1472 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp26_);
#line 1476 "../src/client/accounts/accounts-manager.vala"
		_tmp27_ = service_config;
#line 1476 "../src/client/accounts/accounts-manager.vala"
		_tmp28_ = geary_service_information_get_credentials_requirement (service);
#line 1476 "../src/client/accounts/accounts-manager.vala"
		_tmp29_ = _tmp28_;
#line 1476 "../src/client/accounts/accounts-manager.vala"
		_tmp30_ = geary_credentials_requirement_to_value (_tmp29_);
#line 1476 "../src/client/accounts/accounts-manager.vala"
		_tmp31_ = _tmp30_;
#line 1476 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_group_set_string (_tmp27_, ACCOUNTS_SERVICE_CONFIG_V1_CREDENTIALS, _tmp31_);
#line 1476 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp31_);
#line 12763 "accounts-manager.c"
	}
#line 1457 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_group_unref0 (service_config);
#line 12767 "accounts-manager.c"
}

AccountsServiceConfigV1*
accounts_service_config_v1_construct (GType object_type)
{
	AccountsServiceConfigV1 * self = NULL;
#line 1389 "../src/client/accounts/accounts-manager.vala"
	self = (AccountsServiceConfigV1*) g_object_new (object_type, NULL);
#line 1389 "../src/client/accounts/accounts-manager.vala"
	return self;
#line 12778 "accounts-manager.c"
}

AccountsServiceConfigV1*
accounts_service_config_v1_new (void)
{
#line 1389 "../src/client/accounts/accounts-manager.vala"
	return accounts_service_config_v1_construct (ACCOUNTS_TYPE_SERVICE_CONFIG_V1);
#line 12786 "accounts-manager.c"
}

static void
accounts_service_config_v1_class_init (AccountsServiceConfigV1Class * klass,
                                       gpointer klass_data)
{
#line 1389 "../src/client/accounts/accounts-manager.vala"
	accounts_service_config_v1_parent_class = g_type_class_peek_parent (klass);
#line 12795 "accounts-manager.c"
}

static void
accounts_service_config_v1_accounts_service_config_interface_init (AccountsServiceConfigIface * iface,
                                                                   gpointer iface_data)
{
#line 1389 "../src/client/accounts/accounts-manager.vala"
	accounts_service_config_v1_accounts_service_config_parent_iface = g_type_interface_peek_parent (iface);
#line 1389 "../src/client/accounts/accounts-manager.vala"
	iface->load = (void (*) (AccountsServiceConfig*, GearyConfigFile*, GearyAccountInformation*, GearyServiceInformation*, GError**)) accounts_service_config_v1_real_load;
#line 1389 "../src/client/accounts/accounts-manager.vala"
	iface->save = (void (*) (AccountsServiceConfig*, GearyAccountInformation*, GearyServiceInformation*, GearyConfigFile*)) accounts_service_config_v1_real_save;
#line 12808 "accounts-manager.c"
}

static void
accounts_service_config_v1_instance_init (AccountsServiceConfigV1 * self,
                                          gpointer klass)
{
}

/**
 * Manages persistence for version 1 service configuration.
 */
static GType
accounts_service_config_v1_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AccountsServiceConfigV1Class), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) accounts_service_config_v1_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AccountsServiceConfigV1), 0, (GInstanceInitFunc) accounts_service_config_v1_instance_init, NULL };
	static const GInterfaceInfo accounts_service_config_info = { (GInterfaceInitFunc) accounts_service_config_v1_accounts_service_config_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType accounts_service_config_v1_type_id;
	accounts_service_config_v1_type_id = g_type_register_static (G_TYPE_OBJECT, "AccountsServiceConfigV1", &g_define_type_info, 0);
	g_type_add_interface_static (accounts_service_config_v1_type_id, ACCOUNTS_TYPE_SERVICE_CONFIG, &accounts_service_config_info);
	return accounts_service_config_v1_type_id;
}

GType
accounts_service_config_v1_get_type (void)
{
	static volatile gsize accounts_service_config_v1_type_id__once = 0;
	if (g_once_init_enter (&accounts_service_config_v1_type_id__once)) {
		GType accounts_service_config_v1_type_id;
		accounts_service_config_v1_type_id = accounts_service_config_v1_get_type_once ();
		g_once_init_leave (&accounts_service_config_v1_type_id__once, accounts_service_config_v1_type_id);
	}
	return accounts_service_config_v1_type_id__once;
}

/** Loads a supported service from a config file. */
static void
accounts_service_config_legacy_real_load (AccountsServiceConfig* base,
                                          GearyConfigFile* config,
                                          GearyAccountInformation* account,
                                          GearyServiceInformation* service,
                                          GError** error)
{
	AccountsServiceConfigLegacy * self;
	GearyConfigFileGroup* service_config = NULL;
	GearyConfigFileGroup* _tmp0_;
	const gchar* _tmp1_ = NULL;
	GearyProtocol _tmp2_;
	GearyProtocol _tmp3_;
	gchar* prefix = NULL;
	gchar* _tmp4_;
	gchar* login = NULL;
	GearyConfigFileGroup* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GearyRFC822MailboxAddress* _tmp9_;
	GearyRFC822MailboxAddress* _tmp10_;
	GearyRFC822MailboxAddress* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	GearyConfigFileGroup* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gboolean _tmp24_;
	gboolean _tmp25_;
	GearyServiceProvider _tmp26_;
	GearyServiceProvider _tmp27_;
#line 1503 "../src/client/accounts/accounts-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, ACCOUNTS_TYPE_SERVICE_CONFIG_LEGACY, AccountsServiceConfigLegacy);
#line 1503 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (config, GEARY_TYPE_CONFIG_FILE));
#line 1503 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 1503 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (service, GEARY_TYPE_SERVICE_INFORMATION));
#line 1507 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = geary_config_file_get_group (config, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_GROUP);
#line 1507 "../src/client/accounts/accounts-manager.vala"
	service_config = _tmp0_;
#line 1510 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = geary_service_information_get_protocol (service);
#line 1510 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = _tmp2_;
#line 1510 "../src/client/accounts/accounts-manager.vala"
	if (_tmp3_ == GEARY_PROTOCOL_IMAP) {
#line 1511 "../src/client/accounts/accounts-manager.vala"
		_tmp1_ = "imap_";
#line 12900 "accounts-manager.c"
	} else {
#line 1511 "../src/client/accounts/accounts-manager.vala"
		_tmp1_ = "smtp_";
#line 12904 "accounts-manager.c"
	}
#line 1510 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = g_strdup (_tmp1_);
#line 1510 "../src/client/accounts/accounts-manager.vala"
	prefix = _tmp4_;
#line 1513 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = service_config;
#line 1513 "../src/client/accounts/accounts-manager.vala"
	_tmp6_ = prefix;
#line 1513 "../src/client/accounts/accounts-manager.vala"
	_tmp7_ = g_strconcat (_tmp6_, ACCOUNTS_SERVICE_CONFIG_LEGACY_USERNAME, NULL);
#line 1513 "../src/client/accounts/accounts-manager.vala"
	_tmp8_ = _tmp7_;
#line 1513 "../src/client/accounts/accounts-manager.vala"
	_tmp9_ = geary_account_information_get_primary_mailbox (account);
#line 1513 "../src/client/accounts/accounts-manager.vala"
	_tmp10_ = _tmp9_;
#line 1513 "../src/client/accounts/accounts-manager.vala"
	_tmp11_ = _tmp10_;
#line 1513 "../src/client/accounts/accounts-manager.vala"
	_tmp12_ = geary_rf_c822_mailbox_address_get_address (_tmp11_);
#line 1513 "../src/client/accounts/accounts-manager.vala"
	_tmp13_ = _tmp12_;
#line 1513 "../src/client/accounts/accounts-manager.vala"
	_tmp14_ = geary_config_file_group_get_string (_tmp5_, _tmp8_, _tmp13_);
#line 1513 "../src/client/accounts/accounts-manager.vala"
	_tmp15_ = _tmp14_;
#line 1513 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp11_);
#line 1513 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp8_);
#line 1513 "../src/client/accounts/accounts-manager.vala"
	login = _tmp15_;
#line 1516 "../src/client/accounts/accounts-manager.vala"
	_tmp16_ = login;
#line 1516 "../src/client/accounts/accounts-manager.vala"
	if (_tmp16_ != NULL) {
#line 12942 "accounts-manager.c"
		const gchar* _tmp17_;
		GearyCredentials* _tmp18_;
		GearyCredentials* _tmp19_;
#line 1517 "../src/client/accounts/accounts-manager.vala"
		_tmp17_ = login;
#line 1517 "../src/client/accounts/accounts-manager.vala"
		_tmp18_ = geary_credentials_new (GEARY_CREDENTIALS_METHOD_PASSWORD, _tmp17_, NULL);
#line 1517 "../src/client/accounts/accounts-manager.vala"
		_tmp19_ = _tmp18_;
#line 1517 "../src/client/accounts/accounts-manager.vala"
		geary_service_information_set_credentials (service, _tmp19_);
#line 1517 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp19_);
#line 12956 "accounts-manager.c"
	}
#line 1521 "../src/client/accounts/accounts-manager.vala"
	_tmp20_ = service_config;
#line 1521 "../src/client/accounts/accounts-manager.vala"
	_tmp21_ = prefix;
#line 1521 "../src/client/accounts/accounts-manager.vala"
	_tmp22_ = g_strconcat (_tmp21_, ACCOUNTS_SERVICE_CONFIG_LEGACY_REMEMBER_PASSWORD, NULL);
#line 1521 "../src/client/accounts/accounts-manager.vala"
	_tmp23_ = _tmp22_;
#line 1521 "../src/client/accounts/accounts-manager.vala"
	_tmp24_ = geary_service_information_get_remember_password (service);
#line 1521 "../src/client/accounts/accounts-manager.vala"
	_tmp25_ = _tmp24_;
#line 1521 "../src/client/accounts/accounts-manager.vala"
	geary_service_information_set_remember_password (service, geary_config_file_group_get_bool (_tmp20_, _tmp23_, _tmp25_));
#line 1521 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp23_);
#line 1525 "../src/client/accounts/accounts-manager.vala"
	_tmp26_ = geary_account_information_get_service_provider (account);
#line 1525 "../src/client/accounts/accounts-manager.vala"
	_tmp27_ = _tmp26_;
#line 1525 "../src/client/accounts/accounts-manager.vala"
	if (_tmp27_ == GEARY_SERVICE_PROVIDER_OTHER) {
#line 12980 "accounts-manager.c"
		GearyConfigFileGroup* _tmp28_;
		const gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		const gchar* _tmp32_;
		const gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		GearyConfigFileGroup* _tmp36_;
		const gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		guint16 _tmp40_;
		guint16 _tmp41_;
		gboolean use_tls = FALSE;
		GearyConfigFileGroup* _tmp42_;
		const gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		GearyProtocol _tmp46_;
		GearyProtocol _tmp47_;
		gboolean _tmp48_;
		gboolean use_starttls = FALSE;
		GearyConfigFileGroup* _tmp49_;
		const gchar* _tmp50_;
		gchar* _tmp51_;
		gchar* _tmp52_;
		gboolean _tmp53_;
		GearyProtocol _tmp54_;
		GearyProtocol _tmp55_;
#line 1526 "../src/client/accounts/accounts-manager.vala"
		_tmp28_ = service_config;
#line 1526 "../src/client/accounts/accounts-manager.vala"
		_tmp29_ = prefix;
#line 1526 "../src/client/accounts/accounts-manager.vala"
		_tmp30_ = g_strconcat (_tmp29_, ACCOUNTS_SERVICE_CONFIG_LEGACY_HOST, NULL);
#line 1526 "../src/client/accounts/accounts-manager.vala"
		_tmp31_ = _tmp30_;
#line 1526 "../src/client/accounts/accounts-manager.vala"
		_tmp32_ = geary_service_information_get_host (service);
#line 1526 "../src/client/accounts/accounts-manager.vala"
		_tmp33_ = _tmp32_;
#line 1526 "../src/client/accounts/accounts-manager.vala"
		_tmp34_ = geary_config_file_group_get_string (_tmp28_, _tmp31_, _tmp33_);
#line 1526 "../src/client/accounts/accounts-manager.vala"
		_tmp35_ = _tmp34_;
#line 1526 "../src/client/accounts/accounts-manager.vala"
		geary_service_information_set_host (service, _tmp35_);
#line 1526 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp35_);
#line 1526 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp31_);
#line 1527 "../src/client/accounts/accounts-manager.vala"
		_tmp36_ = service_config;
#line 1527 "../src/client/accounts/accounts-manager.vala"
		_tmp37_ = prefix;
#line 1527 "../src/client/accounts/accounts-manager.vala"
		_tmp38_ = g_strconcat (_tmp37_, ACCOUNTS_SERVICE_CONFIG_LEGACY_PORT, NULL);
#line 1527 "../src/client/accounts/accounts-manager.vala"
		_tmp39_ = _tmp38_;
#line 1527 "../src/client/accounts/accounts-manager.vala"
		_tmp40_ = geary_service_information_get_port (service);
#line 1527 "../src/client/accounts/accounts-manager.vala"
		_tmp41_ = _tmp40_;
#line 1527 "../src/client/accounts/accounts-manager.vala"
		geary_service_information_set_port (service, (guint16) geary_config_file_group_get_int (_tmp36_, _tmp39_, (gint) _tmp41_));
#line 1527 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp39_);
#line 1531 "../src/client/accounts/accounts-manager.vala"
		_tmp42_ = service_config;
#line 1531 "../src/client/accounts/accounts-manager.vala"
		_tmp43_ = prefix;
#line 1531 "../src/client/accounts/accounts-manager.vala"
		_tmp44_ = g_strconcat (_tmp43_, ACCOUNTS_SERVICE_CONFIG_LEGACY_SSL, NULL);
#line 1531 "../src/client/accounts/accounts-manager.vala"
		_tmp45_ = _tmp44_;
#line 1531 "../src/client/accounts/accounts-manager.vala"
		_tmp46_ = geary_service_information_get_protocol (service);
#line 1531 "../src/client/accounts/accounts-manager.vala"
		_tmp47_ = _tmp46_;
#line 1531 "../src/client/accounts/accounts-manager.vala"
		_tmp48_ = geary_config_file_group_get_bool (_tmp42_, _tmp45_, _tmp47_ == GEARY_PROTOCOL_IMAP);
#line 1531 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp45_);
#line 1531 "../src/client/accounts/accounts-manager.vala"
		use_tls = _tmp48_;
#line 1534 "../src/client/accounts/accounts-manager.vala"
		_tmp49_ = service_config;
#line 1534 "../src/client/accounts/accounts-manager.vala"
		_tmp50_ = prefix;
#line 1534 "../src/client/accounts/accounts-manager.vala"
		_tmp51_ = g_strconcat (_tmp50_, ACCOUNTS_SERVICE_CONFIG_LEGACY_STARTTLS, NULL);
#line 1534 "../src/client/accounts/accounts-manager.vala"
		_tmp52_ = _tmp51_;
#line 1534 "../src/client/accounts/accounts-manager.vala"
		_tmp53_ = geary_config_file_group_get_bool (_tmp49_, _tmp52_, TRUE);
#line 1534 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp52_);
#line 1534 "../src/client/accounts/accounts-manager.vala"
		use_starttls = _tmp53_;
#line 1537 "../src/client/accounts/accounts-manager.vala"
		if (use_tls) {
#line 1538 "../src/client/accounts/accounts-manager.vala"
			geary_service_information_set_transport_security (service, GEARY_TLS_NEGOTIATION_METHOD_TRANSPORT);
#line 13085 "accounts-manager.c"
		} else {
#line 1539 "../src/client/accounts/accounts-manager.vala"
			if (use_starttls) {
#line 1540 "../src/client/accounts/accounts-manager.vala"
				geary_service_information_set_transport_security (service, GEARY_TLS_NEGOTIATION_METHOD_START_TLS);
#line 13091 "accounts-manager.c"
			} else {
#line 1542 "../src/client/accounts/accounts-manager.vala"
				geary_service_information_set_transport_security (service, GEARY_TLS_NEGOTIATION_METHOD_NONE);
#line 13095 "accounts-manager.c"
			}
		}
#line 1545 "../src/client/accounts/accounts-manager.vala"
		_tmp54_ = geary_service_information_get_protocol (service);
#line 1545 "../src/client/accounts/accounts-manager.vala"
		_tmp55_ = _tmp54_;
#line 1545 "../src/client/accounts/accounts-manager.vala"
		if (_tmp55_ == GEARY_PROTOCOL_SMTP) {
#line 13104 "accounts-manager.c"
			gboolean use_imap = FALSE;
			GearyConfigFileGroup* _tmp56_;
			GearyCredentials* _tmp57_;
			GearyCredentials* _tmp58_;
			gboolean no_auth = FALSE;
			GearyConfigFileGroup* _tmp59_;
#line 1546 "../src/client/accounts/accounts-manager.vala"
			_tmp56_ = service_config;
#line 1546 "../src/client/accounts/accounts-manager.vala"
			_tmp57_ = geary_service_information_get_credentials (service);
#line 1546 "../src/client/accounts/accounts-manager.vala"
			_tmp58_ = _tmp57_;
#line 1546 "../src/client/accounts/accounts-manager.vala"
			use_imap = geary_config_file_group_get_bool (_tmp56_, ACCOUNTS_SERVICE_CONFIG_LEGACY_SMTP_USE_IMAP_CREDENTIALS, _tmp58_ != NULL);
#line 1549 "../src/client/accounts/accounts-manager.vala"
			_tmp59_ = service_config;
#line 1549 "../src/client/accounts/accounts-manager.vala"
			no_auth = geary_config_file_group_get_bool (_tmp59_, ACCOUNTS_SERVICE_CONFIG_LEGACY_SMTP_NOAUTH, FALSE);
#line 1552 "../src/client/accounts/accounts-manager.vala"
			if (use_imap) {
#line 1553 "../src/client/accounts/accounts-manager.vala"
				geary_service_information_set_credentials_requirement (service, GEARY_CREDENTIALS_REQUIREMENT_USE_INCOMING);
#line 13127 "accounts-manager.c"
			} else {
#line 1555 "../src/client/accounts/accounts-manager.vala"
				if (!no_auth) {
#line 1556 "../src/client/accounts/accounts-manager.vala"
					geary_service_information_set_credentials_requirement (service, GEARY_CREDENTIALS_REQUIREMENT_CUSTOM);
#line 13133 "accounts-manager.c"
				} else {
#line 1559 "../src/client/accounts/accounts-manager.vala"
					geary_service_information_set_credentials_requirement (service, GEARY_CREDENTIALS_REQUIREMENT_NONE);
#line 13137 "accounts-manager.c"
				}
			}
		}
	}
#line 1503 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (login);
#line 1503 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (prefix);
#line 1503 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_group_unref0 (service_config);
#line 13148 "accounts-manager.c"
}

/** Saves an service to a config file. */
static void
accounts_service_config_legacy_real_save (AccountsServiceConfig* base,
                                          GearyAccountInformation* account,
                                          GearyServiceInformation* service,
                                          GearyConfigFile* config)
{
	AccountsServiceConfigLegacy * self;
	GearyConfigFileGroup* service_config = NULL;
	GearyConfigFileGroup* _tmp0_;
	gchar* prefix = NULL;
	GearyProtocol _tmp1_;
	GearyProtocol _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GearyCredentials* _tmp9_;
	GearyCredentials* _tmp10_;
	GearyConfigFileGroup* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	GearyServiceProvider _tmp25_;
	GearyServiceProvider _tmp26_;
#line 1567 "../src/client/accounts/accounts-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, ACCOUNTS_TYPE_SERVICE_CONFIG_LEGACY, AccountsServiceConfigLegacy);
#line 1567 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 1567 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (service, GEARY_TYPE_SERVICE_INFORMATION));
#line 1567 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (config, GEARY_TYPE_CONFIG_FILE));
#line 1570 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = geary_config_file_get_group (config, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_GROUP);
#line 1570 "../src/client/accounts/accounts-manager.vala"
	service_config = _tmp0_;
#line 1573 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = geary_service_information_get_protocol (service);
#line 1573 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _tmp1_;
#line 1573 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = geary_protocol_to_value (_tmp2_);
#line 1573 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = _tmp3_;
#line 1573 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = g_ascii_strdown (_tmp4_, (gssize) -1);
#line 1573 "../src/client/accounts/accounts-manager.vala"
	_tmp6_ = _tmp5_;
#line 1573 "../src/client/accounts/accounts-manager.vala"
	_tmp7_ = g_strconcat (_tmp6_, "_", NULL);
#line 1573 "../src/client/accounts/accounts-manager.vala"
	_tmp8_ = _tmp7_;
#line 1573 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp6_);
#line 1573 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp4_);
#line 1573 "../src/client/accounts/accounts-manager.vala"
	prefix = _tmp8_;
#line 1575 "../src/client/accounts/accounts-manager.vala"
	_tmp9_ = geary_service_information_get_credentials (service);
#line 1575 "../src/client/accounts/accounts-manager.vala"
	_tmp10_ = _tmp9_;
#line 1575 "../src/client/accounts/accounts-manager.vala"
	if (_tmp10_ != NULL) {
#line 13220 "accounts-manager.c"
		GearyConfigFileGroup* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		GearyCredentials* _tmp15_;
		GearyCredentials* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
#line 1576 "../src/client/accounts/accounts-manager.vala"
		_tmp11_ = service_config;
#line 1576 "../src/client/accounts/accounts-manager.vala"
		_tmp12_ = prefix;
#line 1576 "../src/client/accounts/accounts-manager.vala"
		_tmp13_ = g_strconcat (_tmp12_, ACCOUNTS_SERVICE_CONFIG_LEGACY_USERNAME, NULL);
#line 1576 "../src/client/accounts/accounts-manager.vala"
		_tmp14_ = _tmp13_;
#line 1576 "../src/client/accounts/accounts-manager.vala"
		_tmp15_ = geary_service_information_get_credentials (service);
#line 1576 "../src/client/accounts/accounts-manager.vala"
		_tmp16_ = _tmp15_;
#line 1576 "../src/client/accounts/accounts-manager.vala"
		_tmp17_ = geary_credentials_get_user (_tmp16_);
#line 1576 "../src/client/accounts/accounts-manager.vala"
		_tmp18_ = _tmp17_;
#line 1576 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_group_set_string (_tmp11_, _tmp14_, _tmp18_);
#line 1576 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp14_);
#line 13249 "accounts-manager.c"
	}
#line 1580 "../src/client/accounts/accounts-manager.vala"
	_tmp19_ = service_config;
#line 1580 "../src/client/accounts/accounts-manager.vala"
	_tmp20_ = prefix;
#line 1580 "../src/client/accounts/accounts-manager.vala"
	_tmp21_ = g_strconcat (_tmp20_, ACCOUNTS_SERVICE_CONFIG_LEGACY_REMEMBER_PASSWORD, NULL);
#line 1580 "../src/client/accounts/accounts-manager.vala"
	_tmp22_ = _tmp21_;
#line 1580 "../src/client/accounts/accounts-manager.vala"
	_tmp23_ = geary_service_information_get_remember_password (service);
#line 1580 "../src/client/accounts/accounts-manager.vala"
	_tmp24_ = _tmp23_;
#line 1580 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_bool (_tmp19_, _tmp22_, _tmp24_);
#line 1580 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp22_);
#line 1584 "../src/client/accounts/accounts-manager.vala"
	_tmp25_ = geary_account_information_get_service_provider (account);
#line 1584 "../src/client/accounts/accounts-manager.vala"
	_tmp26_ = _tmp25_;
#line 1584 "../src/client/accounts/accounts-manager.vala"
	if (_tmp26_ == GEARY_SERVICE_PROVIDER_OTHER) {
#line 13273 "accounts-manager.c"
		GearyConfigFileGroup* _tmp27_;
		const gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		const gchar* _tmp31_;
		const gchar* _tmp32_;
		GearyConfigFileGroup* _tmp33_;
		const gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		guint16 _tmp37_;
		guint16 _tmp38_;
		GearyTlsNegotiationMethod _tmp39_;
		GearyTlsNegotiationMethod _tmp40_;
		GearyProtocol _tmp65_;
		GearyProtocol _tmp66_;
#line 1585 "../src/client/accounts/accounts-manager.vala"
		_tmp27_ = service_config;
#line 1585 "../src/client/accounts/accounts-manager.vala"
		_tmp28_ = prefix;
#line 1585 "../src/client/accounts/accounts-manager.vala"
		_tmp29_ = g_strconcat (_tmp28_, ACCOUNTS_SERVICE_CONFIG_LEGACY_HOST, NULL);
#line 1585 "../src/client/accounts/accounts-manager.vala"
		_tmp30_ = _tmp29_;
#line 1585 "../src/client/accounts/accounts-manager.vala"
		_tmp31_ = geary_service_information_get_host (service);
#line 1585 "../src/client/accounts/accounts-manager.vala"
		_tmp32_ = _tmp31_;
#line 1585 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_group_set_string (_tmp27_, _tmp30_, _tmp32_);
#line 1585 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp30_);
#line 1586 "../src/client/accounts/accounts-manager.vala"
		_tmp33_ = service_config;
#line 1586 "../src/client/accounts/accounts-manager.vala"
		_tmp34_ = prefix;
#line 1586 "../src/client/accounts/accounts-manager.vala"
		_tmp35_ = g_strconcat (_tmp34_, ACCOUNTS_SERVICE_CONFIG_LEGACY_PORT, NULL);
#line 1586 "../src/client/accounts/accounts-manager.vala"
		_tmp36_ = _tmp35_;
#line 1586 "../src/client/accounts/accounts-manager.vala"
		_tmp37_ = geary_service_information_get_port (service);
#line 1586 "../src/client/accounts/accounts-manager.vala"
		_tmp38_ = _tmp37_;
#line 1586 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_group_set_int (_tmp33_, _tmp36_, (gint) _tmp38_);
#line 1586 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp36_);
#line 1588 "../src/client/accounts/accounts-manager.vala"
		_tmp39_ = geary_service_information_get_transport_security (service);
#line 1588 "../src/client/accounts/accounts-manager.vala"
		_tmp40_ = _tmp39_;
#line 1588 "../src/client/accounts/accounts-manager.vala"
		switch (_tmp40_) {
#line 1588 "../src/client/accounts/accounts-manager.vala"
			case GEARY_TLS_NEGOTIATION_METHOD_NONE:
#line 13330 "accounts-manager.c"
			{
				GearyConfigFileGroup* _tmp41_;
				const gchar* _tmp42_;
				gchar* _tmp43_;
				gchar* _tmp44_;
				GearyConfigFileGroup* _tmp45_;
				const gchar* _tmp46_;
				gchar* _tmp47_;
				gchar* _tmp48_;
#line 1590 "../src/client/accounts/accounts-manager.vala"
				_tmp41_ = service_config;
#line 1590 "../src/client/accounts/accounts-manager.vala"
				_tmp42_ = prefix;
#line 1590 "../src/client/accounts/accounts-manager.vala"
				_tmp43_ = g_strconcat (_tmp42_, ACCOUNTS_SERVICE_CONFIG_LEGACY_SSL, NULL);
#line 1590 "../src/client/accounts/accounts-manager.vala"
				_tmp44_ = _tmp43_;
#line 1590 "../src/client/accounts/accounts-manager.vala"
				geary_config_file_group_set_bool (_tmp41_, _tmp44_, FALSE);
#line 1590 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp44_);
#line 1591 "../src/client/accounts/accounts-manager.vala"
				_tmp45_ = service_config;
#line 1591 "../src/client/accounts/accounts-manager.vala"
				_tmp46_ = prefix;
#line 1591 "../src/client/accounts/accounts-manager.vala"
				_tmp47_ = g_strconcat (_tmp46_, ACCOUNTS_SERVICE_CONFIG_LEGACY_STARTTLS, NULL);
#line 1591 "../src/client/accounts/accounts-manager.vala"
				_tmp48_ = _tmp47_;
#line 1591 "../src/client/accounts/accounts-manager.vala"
				geary_config_file_group_set_bool (_tmp45_, _tmp48_, FALSE);
#line 1591 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp48_);
#line 1592 "../src/client/accounts/accounts-manager.vala"
				break;
#line 13366 "accounts-manager.c"
			}
#line 1588 "../src/client/accounts/accounts-manager.vala"
			case GEARY_TLS_NEGOTIATION_METHOD_START_TLS:
#line 13370 "accounts-manager.c"
			{
				GearyConfigFileGroup* _tmp49_;
				const gchar* _tmp50_;
				gchar* _tmp51_;
				gchar* _tmp52_;
				GearyConfigFileGroup* _tmp53_;
				const gchar* _tmp54_;
				gchar* _tmp55_;
				gchar* _tmp56_;
#line 1595 "../src/client/accounts/accounts-manager.vala"
				_tmp49_ = service_config;
#line 1595 "../src/client/accounts/accounts-manager.vala"
				_tmp50_ = prefix;
#line 1595 "../src/client/accounts/accounts-manager.vala"
				_tmp51_ = g_strconcat (_tmp50_, ACCOUNTS_SERVICE_CONFIG_LEGACY_SSL, NULL);
#line 1595 "../src/client/accounts/accounts-manager.vala"
				_tmp52_ = _tmp51_;
#line 1595 "../src/client/accounts/accounts-manager.vala"
				geary_config_file_group_set_bool (_tmp49_, _tmp52_, FALSE);
#line 1595 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp52_);
#line 1596 "../src/client/accounts/accounts-manager.vala"
				_tmp53_ = service_config;
#line 1596 "../src/client/accounts/accounts-manager.vala"
				_tmp54_ = prefix;
#line 1596 "../src/client/accounts/accounts-manager.vala"
				_tmp55_ = g_strconcat (_tmp54_, ACCOUNTS_SERVICE_CONFIG_LEGACY_STARTTLS, NULL);
#line 1596 "../src/client/accounts/accounts-manager.vala"
				_tmp56_ = _tmp55_;
#line 1596 "../src/client/accounts/accounts-manager.vala"
				geary_config_file_group_set_bool (_tmp53_, _tmp56_, TRUE);
#line 1596 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp56_);
#line 1597 "../src/client/accounts/accounts-manager.vala"
				break;
#line 13406 "accounts-manager.c"
			}
#line 1588 "../src/client/accounts/accounts-manager.vala"
			case GEARY_TLS_NEGOTIATION_METHOD_TRANSPORT:
#line 13410 "accounts-manager.c"
			{
				GearyConfigFileGroup* _tmp57_;
				const gchar* _tmp58_;
				gchar* _tmp59_;
				gchar* _tmp60_;
				GearyConfigFileGroup* _tmp61_;
				const gchar* _tmp62_;
				gchar* _tmp63_;
				gchar* _tmp64_;
#line 1600 "../src/client/accounts/accounts-manager.vala"
				_tmp57_ = service_config;
#line 1600 "../src/client/accounts/accounts-manager.vala"
				_tmp58_ = prefix;
#line 1600 "../src/client/accounts/accounts-manager.vala"
				_tmp59_ = g_strconcat (_tmp58_, ACCOUNTS_SERVICE_CONFIG_LEGACY_SSL, NULL);
#line 1600 "../src/client/accounts/accounts-manager.vala"
				_tmp60_ = _tmp59_;
#line 1600 "../src/client/accounts/accounts-manager.vala"
				geary_config_file_group_set_bool (_tmp57_, _tmp60_, TRUE);
#line 1600 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp60_);
#line 1601 "../src/client/accounts/accounts-manager.vala"
				_tmp61_ = service_config;
#line 1601 "../src/client/accounts/accounts-manager.vala"
				_tmp62_ = prefix;
#line 1601 "../src/client/accounts/accounts-manager.vala"
				_tmp63_ = g_strconcat (_tmp62_, ACCOUNTS_SERVICE_CONFIG_LEGACY_STARTTLS, NULL);
#line 1601 "../src/client/accounts/accounts-manager.vala"
				_tmp64_ = _tmp63_;
#line 1601 "../src/client/accounts/accounts-manager.vala"
				geary_config_file_group_set_bool (_tmp61_, _tmp64_, FALSE);
#line 1601 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp64_);
#line 1602 "../src/client/accounts/accounts-manager.vala"
				break;
#line 13446 "accounts-manager.c"
			}
			default:
#line 1588 "../src/client/accounts/accounts-manager.vala"
			break;
#line 13451 "accounts-manager.c"
		}
#line 1605 "../src/client/accounts/accounts-manager.vala"
		_tmp65_ = geary_service_information_get_protocol (service);
#line 1605 "../src/client/accounts/accounts-manager.vala"
		_tmp66_ = _tmp65_;
#line 1605 "../src/client/accounts/accounts-manager.vala"
		if (_tmp66_ == GEARY_PROTOCOL_SMTP) {
#line 13459 "accounts-manager.c"
			GearyCredentialsRequirement _tmp67_;
			GearyCredentialsRequirement _tmp68_;
#line 1606 "../src/client/accounts/accounts-manager.vala"
			_tmp67_ = geary_service_information_get_credentials_requirement (service);
#line 1606 "../src/client/accounts/accounts-manager.vala"
			_tmp68_ = _tmp67_;
#line 1606 "../src/client/accounts/accounts-manager.vala"
			switch (_tmp68_) {
#line 1606 "../src/client/accounts/accounts-manager.vala"
				case GEARY_CREDENTIALS_REQUIREMENT_NONE:
#line 13470 "accounts-manager.c"
				{
					GearyConfigFileGroup* _tmp69_;
					GearyConfigFileGroup* _tmp70_;
#line 1608 "../src/client/accounts/accounts-manager.vala"
					_tmp69_ = service_config;
#line 1608 "../src/client/accounts/accounts-manager.vala"
					geary_config_file_group_set_bool (_tmp69_, ACCOUNTS_SERVICE_CONFIG_LEGACY_SMTP_USE_IMAP_CREDENTIALS, FALSE);
#line 1609 "../src/client/accounts/accounts-manager.vala"
					_tmp70_ = service_config;
#line 1609 "../src/client/accounts/accounts-manager.vala"
					geary_config_file_group_set_bool (_tmp70_, ACCOUNTS_SERVICE_CONFIG_LEGACY_SMTP_NOAUTH, TRUE);
#line 1610 "../src/client/accounts/accounts-manager.vala"
					break;
#line 13484 "accounts-manager.c"
				}
#line 1606 "../src/client/accounts/accounts-manager.vala"
				case GEARY_CREDENTIALS_REQUIREMENT_USE_INCOMING:
#line 13488 "accounts-manager.c"
				{
					GearyConfigFileGroup* _tmp71_;
					GearyConfigFileGroup* _tmp72_;
#line 1613 "../src/client/accounts/accounts-manager.vala"
					_tmp71_ = service_config;
#line 1613 "../src/client/accounts/accounts-manager.vala"
					geary_config_file_group_set_bool (_tmp71_, ACCOUNTS_SERVICE_CONFIG_LEGACY_SMTP_USE_IMAP_CREDENTIALS, TRUE);
#line 1614 "../src/client/accounts/accounts-manager.vala"
					_tmp72_ = service_config;
#line 1614 "../src/client/accounts/accounts-manager.vala"
					geary_config_file_group_set_bool (_tmp72_, ACCOUNTS_SERVICE_CONFIG_LEGACY_SMTP_NOAUTH, FALSE);
#line 1615 "../src/client/accounts/accounts-manager.vala"
					break;
#line 13502 "accounts-manager.c"
				}
#line 1606 "../src/client/accounts/accounts-manager.vala"
				case GEARY_CREDENTIALS_REQUIREMENT_CUSTOM:
#line 13506 "accounts-manager.c"
				{
					GearyConfigFileGroup* _tmp73_;
					GearyConfigFileGroup* _tmp74_;
#line 1618 "../src/client/accounts/accounts-manager.vala"
					_tmp73_ = service_config;
#line 1618 "../src/client/accounts/accounts-manager.vala"
					geary_config_file_group_set_bool (_tmp73_, ACCOUNTS_SERVICE_CONFIG_LEGACY_SMTP_USE_IMAP_CREDENTIALS, FALSE);
#line 1619 "../src/client/accounts/accounts-manager.vala"
					_tmp74_ = service_config;
#line 1619 "../src/client/accounts/accounts-manager.vala"
					geary_config_file_group_set_bool (_tmp74_, ACCOUNTS_SERVICE_CONFIG_LEGACY_SMTP_NOAUTH, FALSE);
#line 1620 "../src/client/accounts/accounts-manager.vala"
					break;
#line 13520 "accounts-manager.c"
				}
				default:
#line 1606 "../src/client/accounts/accounts-manager.vala"
				break;
#line 13525 "accounts-manager.c"
			}
		}
	}
#line 1567 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (prefix);
#line 1567 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_group_unref0 (service_config);
#line 13533 "accounts-manager.c"
}

AccountsServiceConfigLegacy*
accounts_service_config_legacy_construct (GType object_type)
{
	AccountsServiceConfigLegacy * self = NULL;
#line 1488 "../src/client/accounts/accounts-manager.vala"
	self = (AccountsServiceConfigLegacy*) g_object_new (object_type, NULL);
#line 1488 "../src/client/accounts/accounts-manager.vala"
	return self;
#line 13544 "accounts-manager.c"
}

AccountsServiceConfigLegacy*
accounts_service_config_legacy_new (void)
{
#line 1488 "../src/client/accounts/accounts-manager.vala"
	return accounts_service_config_legacy_construct (ACCOUNTS_TYPE_SERVICE_CONFIG_LEGACY);
#line 13552 "accounts-manager.c"
}

static void
accounts_service_config_legacy_class_init (AccountsServiceConfigLegacyClass * klass,
                                           gpointer klass_data)
{
#line 1488 "../src/client/accounts/accounts-manager.vala"
	accounts_service_config_legacy_parent_class = g_type_class_peek_parent (klass);
#line 13561 "accounts-manager.c"
}

static void
accounts_service_config_legacy_accounts_service_config_interface_init (AccountsServiceConfigIface * iface,
                                                                       gpointer iface_data)
{
#line 1488 "../src/client/accounts/accounts-manager.vala"
	accounts_service_config_legacy_accounts_service_config_parent_iface = g_type_interface_peek_parent (iface);
#line 1488 "../src/client/accounts/accounts-manager.vala"
	iface->load = (void (*) (AccountsServiceConfig*, GearyConfigFile*, GearyAccountInformation*, GearyServiceInformation*, GError**)) accounts_service_config_legacy_real_load;
#line 1488 "../src/client/accounts/accounts-manager.vala"
	iface->save = (void (*) (AccountsServiceConfig*, GearyAccountInformation*, GearyServiceInformation*, GearyConfigFile*)) accounts_service_config_legacy_real_save;
#line 13574 "accounts-manager.c"
}

static void
accounts_service_config_legacy_instance_init (AccountsServiceConfigLegacy * self,
                                              gpointer klass)
{
}

/**
 * Manages persistence for un-versioned service configuration.
 */
static GType
accounts_service_config_legacy_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AccountsServiceConfigLegacyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) accounts_service_config_legacy_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AccountsServiceConfigLegacy), 0, (GInstanceInitFunc) accounts_service_config_legacy_instance_init, NULL };
	static const GInterfaceInfo accounts_service_config_info = { (GInterfaceInitFunc) accounts_service_config_legacy_accounts_service_config_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType accounts_service_config_legacy_type_id;
	accounts_service_config_legacy_type_id = g_type_register_static (G_TYPE_OBJECT, "AccountsServiceConfigLegacy", &g_define_type_info, 0);
	g_type_add_interface_static (accounts_service_config_legacy_type_id, ACCOUNTS_TYPE_SERVICE_CONFIG, &accounts_service_config_info);
	return accounts_service_config_legacy_type_id;
}

GType
accounts_service_config_legacy_get_type (void)
{
	static volatile gsize accounts_service_config_legacy_type_id__once = 0;
	if (g_once_init_enter (&accounts_service_config_legacy_type_id__once)) {
		GType accounts_service_config_legacy_type_id;
		accounts_service_config_legacy_type_id = accounts_service_config_legacy_get_type_once ();
		g_once_init_leave (&accounts_service_config_legacy_type_id__once, accounts_service_config_legacy_type_id);
	}
	return accounts_service_config_legacy_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

