/* application-certificate-manager.c generated by valac 0.56.17, the Vala compiler
 * generated from application-certificate-manager.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2019 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* All of the code below basically exists since cert pinning using GCR*/
/* stopped working (GNOME/gcr#10) after gnome-keyring stopped*/
/* advertising its PKCS11 module (GNOME/gnome-keyring#20). To work*/
/* around, this piggy-backs off of the GIO infrastructure and adds a*/
/* custom pinned cert store.*/

#include "geary-client-46.0.h"
#include <gio/gio.h>
#include <glib-object.h>
#include <glib.h>
#include "geary-engine.h"
#include <gcr/gcr-base.h>
#include <stdlib.h>
#include <string.h>
#include <gck/gck.h>
#include <gtk/gtk.h>
#include <gee.h>

#define APPLICATION_CERTIFICATE_MANAGER_CKF_WRITE_PROTECTED (1UL << 1)
#define APPLICATION_TLS_DATABASE_TRUST_CONTEXT_IO_PRIO G_PRIORITY_HIGH
#define APPLICATION_TLS_DATABASE_TRUST_CONTEXT_ID_TYPE G_CHECKSUM_SHA384
#define APPLICATION_TLS_DATABASE_TRUST_CONTEXT_FILENAME_FORMAT "%s.pem"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define APPLICATION_TYPE_TLS_DATABASE (application_tls_database_get_type ())
#define APPLICATION_TLS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLICATION_TYPE_TLS_DATABASE, ApplicationTlsDatabase))
#define APPLICATION_TLS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APPLICATION_TYPE_TLS_DATABASE, ApplicationTlsDatabaseClass))
#define APPLICATION_IS_TLS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLICATION_TYPE_TLS_DATABASE))
#define APPLICATION_IS_TLS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLICATION_TYPE_TLS_DATABASE))
#define APPLICATION_TLS_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLICATION_TYPE_TLS_DATABASE, ApplicationTlsDatabaseClass))

typedef struct _ApplicationTlsDatabase ApplicationTlsDatabase;
typedef struct _ApplicationTlsDatabaseClass ApplicationTlsDatabaseClass;
enum  {
	APPLICATION_CERTIFICATE_MANAGER_0_PROPERTY,
	APPLICATION_CERTIFICATE_MANAGER_NUM_PROPERTIES
};
static GParamSpec* application_certificate_manager_properties[APPLICATION_CERTIFICATE_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ApplicationCertificateManagerIsGcrEnabledData ApplicationCertificateManagerIsGcrEnabledData;
typedef struct _ApplicationCertificateManagerNewData ApplicationCertificateManagerNewData;
#define _certificate_warning_dialog_unref0(var) ((var == NULL) ? NULL : (var = (certificate_warning_dialog_unref (var), NULL)))
typedef struct _ApplicationCertificateManagerPromptPinCertificateData ApplicationCertificateManagerPromptPinCertificateData;
typedef struct _ApplicationTlsDatabasePrivate ApplicationTlsDatabasePrivate;

#define APPLICATION_TLS_DATABASE_TYPE_TRUST_CONTEXT (application_tls_database_trust_context_get_type ())
#define APPLICATION_TLS_DATABASE_TRUST_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLICATION_TLS_DATABASE_TYPE_TRUST_CONTEXT, ApplicationTlsDatabaseTrustContext))
#define APPLICATION_TLS_DATABASE_TRUST_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APPLICATION_TLS_DATABASE_TYPE_TRUST_CONTEXT, ApplicationTlsDatabaseTrustContextClass))
#define APPLICATION_TLS_DATABASE_IS_TRUST_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLICATION_TLS_DATABASE_TYPE_TRUST_CONTEXT))
#define APPLICATION_TLS_DATABASE_IS_TRUST_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLICATION_TLS_DATABASE_TYPE_TRUST_CONTEXT))
#define APPLICATION_TLS_DATABASE_TRUST_CONTEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLICATION_TLS_DATABASE_TYPE_TRUST_CONTEXT, ApplicationTlsDatabaseTrustContextClass))

typedef struct _ApplicationTlsDatabaseTrustContext ApplicationTlsDatabaseTrustContext;
typedef struct _ApplicationTlsDatabaseTrustContextClass ApplicationTlsDatabaseTrustContextClass;
enum  {
	APPLICATION_TLS_DATABASE_0_PROPERTY,
	APPLICATION_TLS_DATABASE_NUM_PROPERTIES
};
static GParamSpec* application_tls_database_properties[APPLICATION_TLS_DATABASE_NUM_PROPERTIES];
#define _g_byte_array_unref0(var) ((var == NULL) ? NULL : (var = (g_byte_array_unref (var), NULL)))
typedef struct _ApplicationTlsDatabasePinCertificateData ApplicationTlsDatabasePinCertificateData;
typedef struct _ApplicationTlsDatabaseTrustContextPrivate ApplicationTlsDatabaseTrustContextPrivate;
typedef struct _ApplicationTlsDatabaseLookupCertificateForHandleAsyncData ApplicationTlsDatabaseLookupCertificateForHandleAsyncData;
typedef struct _ApplicationTlsDatabaseLookupCertificateIssuerAsyncData ApplicationTlsDatabaseLookupCertificateIssuerAsyncData;
typedef struct _ApplicationTlsDatabaseLookupCertificatesIssuedByAsyncData ApplicationTlsDatabaseLookupCertificatesIssuedByAsyncData;
typedef struct _ApplicationTlsDatabaseVerifyChainAsyncData ApplicationTlsDatabaseVerifyChainAsyncData;
typedef struct _Block2Data Block2Data;
typedef struct _ApplicationTlsDatabaseIsPinnedAsyncData ApplicationTlsDatabaseIsPinnedAsyncData;
typedef struct _Block3Data Block3Data;
typedef struct _Block4Data Block4Data;
enum  {
	APPLICATION_TLS_DATABASE_TRUST_CONTEXT_0_PROPERTY,
	APPLICATION_TLS_DATABASE_TRUST_CONTEXT_NUM_PROPERTIES
};
static GParamSpec* application_tls_database_trust_context_properties[APPLICATION_TLS_DATABASE_TRUST_CONTEXT_NUM_PROPERTIES];
typedef struct _ApplicationTlsDatabaseTrustContextSaveData ApplicationTlsDatabaseTrustContextSaveData;

/** Errors thrown by {@link CertificateManager}. */
struct _ApplicationCertificateManagerPrivate {
	ApplicationTlsDatabase* pinning_database;
};

struct _ApplicationCertificateManagerIsGcrEnabledData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GCancellable* cancellable;
	gboolean result;
	gboolean init_okay;
	gboolean _tmp0_;
	GError* err;
	GError* _tmp1_;
	const gchar* _tmp2_;
	gboolean has_uris;
	gboolean _tmp3_;
	const gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gboolean has_rw_store;
	GckSlot* store;
	GckSlot* _tmp9_;
	GckSlot* _tmp10_;
	GckSlot* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GError* _inner_error0_;
};

struct _ApplicationCertificateManagerNewData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GType object_type;
	ApplicationCertificateManager* self;
	GFile* store_dir;
	GCancellable* cancellable;
	gboolean use_gcr;
	GTlsBackend* _tmp0_;
	GTlsDatabase* _tmp1_;
	GTlsDatabase* _tmp2_;
	ApplicationTlsDatabase* _tmp3_;
	ApplicationTlsDatabase* _tmp4_;
	GTlsDatabase* _tmp5_;
};

struct _ApplicationCertificateManagerPromptPinCertificateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationCertificateManager* self;
	GtkWindow* parent;
	GearyAccountInformation* account;
	GearyServiceInformation* service;
	GearyEndpoint* endpoint;
	gboolean is_validation;
	GCancellable* cancellable;
	CertificateWarningDialog* dialog;
	CertificateWarningDialog* _tmp0_;
	gboolean save;
	CertificateWarningDialog* _tmp1_;
	GError* _tmp2_;
	GSocketConnectable* _tmp3_;
	GSocketConnectable* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	ApplicationTlsDatabase* _tmp7_;
	GTlsCertificate* _tmp8_;
	GTlsCertificate* _tmp9_;
	GSocketConnectable* _tmp10_;
	GSocketConnectable* _tmp11_;
	GError* err;
	GError* _tmp12_;
	const gchar* _tmp13_;
	GError* _tmp14_;
	GError* _inner_error0_;
};

struct _ApplicationTlsDatabase {
	GTlsDatabase parent_instance;
	ApplicationTlsDatabasePrivate * priv;
};

struct _ApplicationTlsDatabaseClass {
	GTlsDatabaseClass parent_class;
};

struct _ApplicationTlsDatabasePrivate {
	GTlsDatabase* _parent;
	GFile* store_dir;
	gboolean use_gcr;
	GeeMap* pinned_certs;
	GRecMutex __lock_pinned_certs;
};

struct _ApplicationTlsDatabasePinCertificateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationTlsDatabase* self;
	GTlsCertificate* certificate;
	GSocketConnectable* identity;
	gboolean save;
	GCancellable* cancellable;
	gchar* id;
	gchar* _tmp0_;
	ApplicationTlsDatabaseTrustContext* context;
	ApplicationTlsDatabaseTrustContext* _tmp1_;
	GeeMap* _tmp2_;
	GeeMap* _tmp3_;
	const gchar* _tmp4_;
	ApplicationTlsDatabaseTrustContext* _tmp5_;
	GeeMap* _tmp6_;
	GByteArray* _tmp7_;
	GByteArray* _tmp8_;
	GByteArray* _tmp9_;
	guint8* _tmp10_;
	gint _tmp10__length1;
	GcrSimpleCertificate* _tmp11_;
	GcrSimpleCertificate* _tmp12_;
	const gchar* _tmp13_;
	ApplicationTlsDatabaseTrustContext* _tmp14_;
	GFile* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GError* _inner_error0_;
};

struct _ApplicationTlsDatabaseTrustContext {
	GearyBaseObject parent_instance;
	gchar* id;
	GTlsCertificate* certificate;
	ApplicationTlsDatabaseTrustContextPrivate * priv;
};

struct _ApplicationTlsDatabaseTrustContextClass {
	GearyBaseObjectClass parent_class;
};

struct _ApplicationTlsDatabaseLookupCertificateForHandleAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationTlsDatabase* self;
	gchar* handle;
	GTlsInteraction* interaction;
	GTlsDatabaseLookupFlags flags;
	GCancellable* cancellable;
	GTlsCertificate* result;
	ApplicationTlsDatabaseTrustContext* context;
	ApplicationTlsDatabaseTrustContext* _tmp0_;
	GTlsCertificate* _tmp1_;
	ApplicationTlsDatabaseTrustContext* _tmp2_;
	ApplicationTlsDatabaseTrustContext* _tmp3_;
	GTlsCertificate* _tmp4_;
	GTlsCertificate* _tmp5_;
	GTlsDatabase* _tmp6_;
	GTlsCertificate* _tmp7_;
	GError* _inner_error0_;
};

struct _ApplicationTlsDatabaseLookupCertificateIssuerAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationTlsDatabase* self;
	GTlsCertificate* certificate;
	GTlsInteraction* interaction;
	GTlsDatabaseLookupFlags flags;
	GCancellable* cancellable;
	GTlsCertificate* result;
	GTlsCertificate* _tmp0_;
	GTlsDatabase* _tmp1_;
	GTlsCertificate* _tmp2_;
	GTlsCertificate* _tmp3_;
	GError* _inner_error0_;
};

struct _ApplicationTlsDatabaseLookupCertificatesIssuedByAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationTlsDatabase* self;
	GByteArray* issuer_raw_dn;
	GTlsInteraction* interaction;
	GTlsDatabaseLookupFlags flags;
	GCancellable* cancellable;
	GList* result;
	GList* _tmp0_;
	GTlsDatabase* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	GError* _inner_error0_;
};

struct _ApplicationTlsDatabaseVerifyChainAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationTlsDatabase* self;
	GTlsCertificate* chain;
	gchar* purpose;
	GSocketConnectable* identity;
	GTlsInteraction* interaction;
	GTlsDatabaseVerifyFlags flags;
	GCancellable* cancellable;
	GTlsCertificateFlags result;
	GTlsCertificateFlags ret;
	GTlsDatabase* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GError* _inner_error0_;
};

struct _Block2Data {
	int _ref_count_;
	ApplicationTlsDatabase* self;
	gboolean pinned;
	GTlsCertificate* chain;
	GSocketConnectable* identity;
	GCancellable* cancellable;
	gpointer _async_data_;
};

struct _ApplicationTlsDatabaseIsPinnedAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationTlsDatabase* self;
	GTlsCertificate* chain;
	GSocketConnectable* identity;
	GCancellable* cancellable;
	gboolean result;
	Block2Data* _data2_;
	GearyNonblockingConcurrent* _tmp0_;
	GearyNonblockingConcurrent* _tmp1_;
	GError* _inner_error0_;
};

struct _Block3Data {
	int _ref_count_;
	ApplicationTlsDatabase* self;
	gchar* id;
};

struct _Block4Data {
	int _ref_count_;
	ApplicationTlsDatabase* self;
	GTlsCertificate* cert;
};

struct _ApplicationTlsDatabaseTrustContextSaveData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationTlsDatabaseTrustContext* self;
	GFile* dir;
	gchar* identity;
	GCancellable* cancellable;
	GFile* storage;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFileOutputStream* f_out;
	GFile* _tmp4_;
	GFileOutputStream* _tmp5_;
	GBufferedOutputStream* buf;
	GFileOutputStream* _tmp6_;
	GBufferedOutputStream* _tmp7_;
	gsize written;
	GBufferedOutputStream* _tmp8_;
	GTlsCertificate* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	guint8* _tmp13_;
	gint _tmp13__length1;
	gint _tmp14_;
	guint8* _tmp15_;
	gint _tmp15__length1;
	gsize _tmp16_;
	GBufferedOutputStream* _tmp17_;
	GError* _inner_error0_;
};

static gint ApplicationCertificateManager_private_offset;
static gpointer application_certificate_manager_parent_class = NULL;
static gint ApplicationTlsDatabase_private_offset;
static gpointer application_tls_database_parent_class = NULL;
static gpointer application_tls_database_trust_context_parent_class = NULL;

VALA_EXTERN GType application_tls_database_get_type (void) G_GNUC_CONST ;
static void application_certificate_manager_is_gcr_enabled_data_free (gpointer _data);
static void application_certificate_manager_is_gcr_enabled (GCancellable* cancellable,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_);
static gboolean application_certificate_manager_is_gcr_enabled_finish (GAsyncResult* _res_);
static gboolean application_certificate_manager_is_gcr_enabled_co (ApplicationCertificateManagerIsGcrEnabledData* _data_);
static void application_certificate_manager_is_gcr_enabled_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_);
static void application_certificate_manager_construct_data_free (gpointer _data);
static gboolean application_certificate_manager_construct_co (ApplicationCertificateManagerNewData* _data_);
static void application_certificate_manager_new_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_);
VALA_EXTERN ApplicationTlsDatabase* application_tls_database_new (GTlsDatabase* parent,
                                                      GFile* store_dir,
                                                      gboolean use_gcr);
VALA_EXTERN ApplicationTlsDatabase* application_tls_database_construct (GType object_type,
                                                            GTlsDatabase* parent,
                                                            GFile* store_dir,
                                                            gboolean use_gcr);
static void application_certificate_manager_prompt_pin_certificate_data_free (gpointer _data);
static gboolean application_certificate_manager_prompt_pin_certificate_co (ApplicationCertificateManagerPromptPinCertificateData* _data_);
VALA_EXTERN void application_tls_database_pin_certificate (ApplicationTlsDatabase* self,
                                               GTlsCertificate* certificate,
                                               GSocketConnectable* identity,
                                               gboolean save,
                                               GCancellable* cancellable,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
VALA_EXTERN void application_tls_database_pin_certificate_finish (ApplicationTlsDatabase* self,
                                                      GAsyncResult* _res_,
                                                      GError** error);
static void application_certificate_manager_prompt_pin_certificate_ready (GObject* source_object,
                                                                   GAsyncResult* _res_,
                                                                   gpointer _user_data_);
static void application_certificate_manager_finalize (GObject * obj);
static GType application_certificate_manager_get_type_once (void);
static GType application_tls_database_trust_context_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static gchar* application_tls_database_to_name (GSocketConnectable* id);
static GTlsDatabase* application_tls_database_get_parent (ApplicationTlsDatabase* self);
static void application_tls_database_set_parent (ApplicationTlsDatabase* self,
                                          GTlsDatabase* value);
static void application_tls_database_pin_certificate_data_free (gpointer _data);
static gboolean application_tls_database_pin_certificate_co (ApplicationTlsDatabasePinCertificateData* _data_);
static ApplicationTlsDatabaseTrustContext* application_tls_database_trust_context_new (GTlsCertificate* certificate);
static ApplicationTlsDatabaseTrustContext* application_tls_database_trust_context_construct (GType object_type,
                                                                                      GTlsCertificate* certificate);
static void application_tls_database_pin_certificate_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_);
static void application_tls_database_trust_context_save (ApplicationTlsDatabaseTrustContext* self,
                                                  GFile* dir,
                                                  const gchar* identity,
                                                  GCancellable* cancellable,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
static void application_tls_database_trust_context_save_finish (ApplicationTlsDatabaseTrustContext* self,
                                                         GAsyncResult* _res_,
                                                         GError** error);
static gchar* application_tls_database_real_create_certificate_handle (GTlsDatabase* base,
                                                                GTlsCertificate* certificate);
static ApplicationTlsDatabaseTrustContext* application_tls_database_lookup_tls_certificate (ApplicationTlsDatabase* self,
                                                                                     GTlsCertificate* cert);
static GTlsCertificate* application_tls_database_real_lookup_certificate_for_handle (GTlsDatabase* base,
                                                                              const gchar* handle,
                                                                              GTlsInteraction* interaction,
                                                                              GTlsDatabaseLookupFlags flags,
                                                                              GCancellable* cancellable,
                                                                              GError** error);
static ApplicationTlsDatabaseTrustContext* application_tls_database_lookup_id (ApplicationTlsDatabase* self,
                                                                        const gchar* id);
static void application_tls_database_real_lookup_certificate_for_handle_async_data_free (gpointer _data);
static void application_tls_database_real_lookup_certificate_for_handle_async (GTlsDatabase* base,
                                                                        const gchar* handle,
                                                                        GTlsInteraction* interaction,
                                                                        GTlsDatabaseLookupFlags flags,
                                                                        GCancellable* cancellable,
                                                                        GAsyncReadyCallback _callback_,
                                                                        gpointer _user_data_);
static gboolean application_tls_database_real_lookup_certificate_for_handle_async_co (ApplicationTlsDatabaseLookupCertificateForHandleAsyncData* _data_);
static void application_tls_database_lookup_certificate_for_handle_async_ready (GObject* source_object,
                                                                         GAsyncResult* _res_,
                                                                         gpointer _user_data_);
static GTlsCertificate* application_tls_database_real_lookup_certificate_issuer (GTlsDatabase* base,
                                                                          GTlsCertificate* certificate,
                                                                          GTlsInteraction* interaction,
                                                                          GTlsDatabaseLookupFlags flags,
                                                                          GCancellable* cancellable,
                                                                          GError** error);
static void application_tls_database_real_lookup_certificate_issuer_async_data_free (gpointer _data);
static void application_tls_database_real_lookup_certificate_issuer_async (GTlsDatabase* base,
                                                                    GTlsCertificate* certificate,
                                                                    GTlsInteraction* interaction,
                                                                    GTlsDatabaseLookupFlags flags,
                                                                    GCancellable* cancellable,
                                                                    GAsyncReadyCallback _callback_,
                                                                    gpointer _user_data_);
static gboolean application_tls_database_real_lookup_certificate_issuer_async_co (ApplicationTlsDatabaseLookupCertificateIssuerAsyncData* _data_);
static void application_tls_database_lookup_certificate_issuer_async_ready (GObject* source_object,
                                                                     GAsyncResult* _res_,
                                                                     gpointer _user_data_);
static GList* application_tls_database_real_lookup_certificates_issued_by (GTlsDatabase* base,
                                                                    GByteArray* issuer_raw_dn,
                                                                    GTlsInteraction* interaction,
                                                                    GTlsDatabaseLookupFlags flags,
                                                                    GCancellable* cancellable,
                                                                    GError** error);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void application_tls_database_real_lookup_certificates_issued_by_async_data_free (gpointer _data);
static void application_tls_database_real_lookup_certificates_issued_by_async (GTlsDatabase* base,
                                                                        GByteArray* issuer_raw_dn,
                                                                        GTlsInteraction* interaction,
                                                                        GTlsDatabaseLookupFlags flags,
                                                                        GCancellable* cancellable,
                                                                        GAsyncReadyCallback _callback_,
                                                                        gpointer _user_data_);
static gboolean application_tls_database_real_lookup_certificates_issued_by_async_co (ApplicationTlsDatabaseLookupCertificatesIssuedByAsyncData* _data_);
static void application_tls_database_lookup_certificates_issued_by_async_ready (GObject* source_object,
                                                                         GAsyncResult* _res_,
                                                                         gpointer _user_data_);
static GTlsCertificateFlags application_tls_database_real_verify_chain (GTlsDatabase* base,
                                                                 GTlsCertificate* chain,
                                                                 const gchar* purpose,
                                                                 GSocketConnectable* identity,
                                                                 GTlsInteraction* interaction,
                                                                 GTlsDatabaseVerifyFlags flags,
                                                                 GCancellable* cancellable,
                                                                 GError** error);
static inline gboolean application_tls_database_check_pinned (ApplicationTlsDatabase* self,
                                                GTlsCertificateFlags parent_ret,
                                                const gchar* purpose,
                                                GSocketConnectable* identity);
static gboolean application_tls_database_is_pinned (ApplicationTlsDatabase* self,
                                             GTlsCertificate* chain,
                                             GSocketConnectable* identity,
                                             GCancellable* cancellable,
                                             GError** error);
static void application_tls_database_real_verify_chain_async_data_free (gpointer _data);
static void application_tls_database_real_verify_chain_async (GTlsDatabase* base,
                                                       GTlsCertificate* chain,
                                                       const gchar* purpose,
                                                       GSocketConnectable* identity,
                                                       GTlsInteraction* interaction,
                                                       GTlsDatabaseVerifyFlags flags,
                                                       GCancellable* cancellable,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_);
static gboolean application_tls_database_real_verify_chain_async_co (ApplicationTlsDatabaseVerifyChainAsyncData* _data_);
static void application_tls_database_verify_chain_async_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_);
static void application_tls_database_is_pinned_async (ApplicationTlsDatabase* self,
                                               GTlsCertificate* chain,
                                               GSocketConnectable* identity,
                                               GCancellable* cancellable,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
static gboolean application_tls_database_is_pinned_finish (ApplicationTlsDatabase* self,
                                                    GAsyncResult* _res_,
                                                    GError** error);
static ApplicationTlsDatabaseTrustContext* application_tls_database_trust_context_new_lookup (GFile* dir,
                                                                                       const gchar* identity,
                                                                                       GCancellable* cancellable,
                                                                                       GError** error);
static ApplicationTlsDatabaseTrustContext* application_tls_database_trust_context_construct_lookup (GType object_type,
                                                                                             GFile* dir,
                                                                                             const gchar* identity,
                                                                                             GCancellable* cancellable,
                                                                                             GError** error);
static void application_tls_database_is_pinned_async_data_free (gpointer _data);
static gboolean application_tls_database_is_pinned_async_co (ApplicationTlsDatabaseIsPinnedAsyncData* _data_);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda52_ (Block2Data* _data2_,
                  GError** error);
static void ___lambda52__geary_nonblocking_concurrent_concurrent_callback (GCancellable* cancellable,
                                                                    gpointer self,
                                                                    GError** error);
static void application_tls_database_is_pinned_async_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static gboolean ___lambda51_ (Block3Data* _data3_,
                       ApplicationTlsDatabaseTrustContext* ctx);
static gboolean ____lambda51__gee_predicate (gconstpointer g,
                                      gpointer self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static gboolean ___lambda50_ (Block4Data* _data4_,
                       ApplicationTlsDatabaseTrustContext* ctx);
static gboolean ____lambda50__gee_predicate (gconstpointer g,
                                      gpointer self);
static void application_tls_database_trust_context_save_data_free (gpointer _data);
static gboolean application_tls_database_trust_context_save_co (ApplicationTlsDatabaseTrustContextSaveData* _data_);
static void application_tls_database_trust_context_save_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_);
static void application_tls_database_trust_context_finalize (GObject * obj);
static GType application_tls_database_trust_context_get_type_once (void);
static void application_tls_database_finalize (GObject * obj);
static GType application_tls_database_get_type_once (void);
static void _vala_application_tls_database_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_application_tls_database_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static gssize _vala_array_length (gpointer array);

GQuark
application_certificate_manager_error_quark (void)
{
	return g_quark_from_static_string ("application-certificate-manager-error-quark");
}

static GType
application_certificate_manager_error_get_type_once (void)
{
	static const GEnumValue values[] = {{APPLICATION_CERTIFICATE_MANAGER_ERROR_UNTRUSTED, "APPLICATION_CERTIFICATE_MANAGER_ERROR_UNTRUSTED", "untrusted"}, {APPLICATION_CERTIFICATE_MANAGER_ERROR_STORE_FAILED, "APPLICATION_CERTIFICATE_MANAGER_ERROR_STORE_FAILED", "store-failed"}, {0, NULL, NULL}};
	GType application_certificate_manager_error_type_id;
	application_certificate_manager_error_type_id = g_enum_register_static ("ApplicationCertificateManagerError", values);
	return application_certificate_manager_error_type_id;
}

GType
application_certificate_manager_error_get_type (void)
{
	static volatile gsize application_certificate_manager_error_type_id__once = 0;
	if (g_once_init_enter (&application_certificate_manager_error_type_id__once)) {
		GType application_certificate_manager_error_type_id;
		application_certificate_manager_error_type_id = application_certificate_manager_error_get_type_once ();
		g_once_init_leave (&application_certificate_manager_error_type_id__once, application_certificate_manager_error_type_id);
	}
	return application_certificate_manager_error_type_id__once;
}

static inline gpointer
application_certificate_manager_get_instance_private (ApplicationCertificateManager* self)
{
	return G_STRUCT_MEMBER_P (self, ApplicationCertificateManager_private_offset);
}

static void
application_certificate_manager_is_gcr_enabled_data_free (gpointer _data)
{
	ApplicationCertificateManagerIsGcrEnabledData* _data_;
	_data_ = _data;
#line 29 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 29 "../src/client/application/application-certificate-manager.vala"
	g_slice_free (ApplicationCertificateManagerIsGcrEnabledData, _data_);
#line 661 "application-certificate-manager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 29 "../src/client/application/application-certificate-manager.vala"
	return self ? g_object_ref (self) : NULL;
#line 669 "application-certificate-manager.c"
}

static void
application_certificate_manager_is_gcr_enabled (GCancellable* cancellable,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_)
{
	ApplicationCertificateManagerIsGcrEnabledData* _data_;
	GCancellable* _tmp0_;
#line 29 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 29 "../src/client/application/application-certificate-manager.vala"
	_data_ = g_slice_new0 (ApplicationCertificateManagerIsGcrEnabledData);
#line 29 "../src/client/application/application-certificate-manager.vala"
	_data_->_async_result = g_task_new (NULL, cancellable, _callback_, _user_data_);
#line 29 "../src/client/application/application-certificate-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_certificate_manager_is_gcr_enabled_data_free);
#line 29 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = _g_object_ref0 (cancellable);
#line 29 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 29 "../src/client/application/application-certificate-manager.vala"
	_data_->cancellable = _tmp0_;
#line 29 "../src/client/application/application-certificate-manager.vala"
	application_certificate_manager_is_gcr_enabled_co (_data_);
#line 695 "application-certificate-manager.c"
}

static gboolean
application_certificate_manager_is_gcr_enabled_finish (GAsyncResult* _res_)
{
	gboolean result;
	ApplicationCertificateManagerIsGcrEnabledData* _data_;
#line 29 "../src/client/application/application-certificate-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 29 "../src/client/application/application-certificate-manager.vala"
	if (NULL == _data_) {
#line 707 "application-certificate-manager.c"
		gboolean _tmp0_ = FALSE;
#line 29 "../src/client/application/application-certificate-manager.vala"
		return _tmp0_;
#line 711 "application-certificate-manager.c"
	}
#line 29 "../src/client/application/application-certificate-manager.vala"
	result = _data_->result;
#line 29 "../src/client/application/application-certificate-manager.vala"
	return result;
#line 717 "application-certificate-manager.c"
}

static void
application_certificate_manager_is_gcr_enabled_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_)
{
	ApplicationCertificateManagerIsGcrEnabledData* _data_;
#line 44 "../src/client/application/application-certificate-manager.vala"
	_data_ = _user_data_;
#line 44 "../src/client/application/application-certificate-manager.vala"
	_data_->_source_object_ = source_object;
#line 44 "../src/client/application/application-certificate-manager.vala"
	_data_->_res_ = _res_;
#line 44 "../src/client/application/application-certificate-manager.vala"
	application_certificate_manager_is_gcr_enabled_co (_data_);
#line 734 "application-certificate-manager.c"
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 743 "application-certificate-manager.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 751 "application-certificate-manager.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 760 "application-certificate-manager.c"
	}
}

static gboolean
application_certificate_manager_is_gcr_enabled_co (ApplicationCertificateManagerIsGcrEnabledData* _data_)
{
#line 36 "../src/client/application/application-certificate-manager.vala"
	switch (_data_->_state_) {
#line 36 "../src/client/application/application-certificate-manager.vala"
		case 0:
#line 771 "application-certificate-manager.c"
		goto _state_0;
#line 36 "../src/client/application/application-certificate-manager.vala"
		case 1:
#line 775 "application-certificate-manager.c"
		goto _state_1;
		default:
#line 36 "../src/client/application/application-certificate-manager.vala"
		g_assert_not_reached ();
#line 780 "application-certificate-manager.c"
	}
	_state_0:
#line 42 "../src/client/application/application-certificate-manager.vala"
	_data_->init_okay = FALSE;
#line 785 "application-certificate-manager.c"
	{
#line 44 "../src/client/application/application-certificate-manager.vala"
		_data_->_state_ = 1;
#line 44 "../src/client/application/application-certificate-manager.vala"
		gcr_pkcs11_initialize_async (_data_->cancellable, application_certificate_manager_is_gcr_enabled_ready, _data_);
#line 44 "../src/client/application/application-certificate-manager.vala"
		return FALSE;
#line 793 "application-certificate-manager.c"
		_state_1:
#line 44 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp0_ = gcr_pkcs11_initialize_finish (_data_->_res_, &_data_->_inner_error0_);
#line 44 "../src/client/application/application-certificate-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 799 "application-certificate-manager.c"
			goto __catch0_g_error;
		}
#line 44 "../src/client/application/application-certificate-manager.vala"
		_data_->init_okay = _data_->_tmp0_;
#line 804 "application-certificate-manager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 43 "../src/client/application/application-certificate-manager.vala"
		_data_->err = _data_->_inner_error0_;
#line 43 "../src/client/application/application-certificate-manager.vala"
		_data_->_inner_error0_ = NULL;
#line 46 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp1_ = _data_->err;
#line 46 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp2_ = _data_->_tmp1_->message;
#line 46 "../src/client/application/application-certificate-manager.vala"
		g_warning ("application-certificate-manager.vala:46: Failed to initialise GCR PCKS" \
"#11 modules: %s", _data_->_tmp2_);
#line 43 "../src/client/application/application-certificate-manager.vala"
		_g_error_free0 (_data_->err);
#line 821 "application-certificate-manager.c"
	}
	__finally0:
#line 43 "../src/client/application/application-certificate-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 43 "../src/client/application/application-certificate-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 43 "../src/client/application/application-certificate-manager.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 43 "../src/client/application/application-certificate-manager.vala"
		g_object_unref (_data_->_async_result);
#line 43 "../src/client/application/application-certificate-manager.vala"
		return FALSE;
#line 834 "application-certificate-manager.c"
	}
#line 49 "../src/client/application/application-certificate-manager.vala"
	_data_->has_uris = FALSE;
#line 50 "../src/client/application/application-certificate-manager.vala"
	if (_data_->init_okay) {
#line 51 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp4_ = gcr_pkcs11_get_trust_store_uri ();
#line 51 "../src/client/application/application-certificate-manager.vala"
		if (!geary_string_is_empty (_data_->_tmp4_)) {
#line 53 "../src/client/application/application-certificate-manager.vala"
			_data_->_tmp6_ = _data_->_tmp5_ = gcr_pkcs11_get_trust_lookup_uris ();
#line 53 "../src/client/application/application-certificate-manager.vala"
			_data_->_tmp3_ = _vala_array_length (_data_->_tmp5_) > 0;
#line 848 "application-certificate-manager.c"
		} else {
#line 52 "../src/client/application/application-certificate-manager.vala"
			_data_->_tmp3_ = FALSE;
#line 852 "application-certificate-manager.c"
		}
#line 51 "../src/client/application/application-certificate-manager.vala"
		_data_->has_uris = _data_->_tmp3_;
#line 55 "../src/client/application/application-certificate-manager.vala"
		if (_data_->has_uris) {
#line 56 "../src/client/application/application-certificate-manager.vala"
			_data_->_tmp7_ = bool_to_string (_data_->has_uris);
#line 56 "../src/client/application/application-certificate-manager.vala"
			_data_->_tmp8_ = _data_->_tmp7_;
#line 56 "../src/client/application/application-certificate-manager.vala"
			g_debug ("application-certificate-manager.vala:56: GCR slot URIs found: %s", _data_->_tmp8_);
#line 56 "../src/client/application/application-certificate-manager.vala"
			_g_free0 (_data_->_tmp8_);
#line 866 "application-certificate-manager.c"
		} else {
#line 58 "../src/client/application/application-certificate-manager.vala"
			g_warning ("application-certificate-manager.vala:58: No GCR slot URIs found, GCR c" \
"ertificate pinning unavailable");
#line 870 "application-certificate-manager.c"
		}
	}
#line 64 "../src/client/application/application-certificate-manager.vala"
	_data_->has_rw_store = FALSE;
#line 65 "../src/client/application/application-certificate-manager.vala"
	if (_data_->has_uris) {
#line 66 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp9_ = gcr_pkcs11_get_trust_store_slot ();
#line 66 "../src/client/application/application-certificate-manager.vala"
		_data_->store = _data_->_tmp9_;
#line 67 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp10_ = _data_->store;
#line 67 "../src/client/application/application-certificate-manager.vala"
		if (_data_->_tmp10_ != NULL) {
#line 68 "../src/client/application/application-certificate-manager.vala"
			_data_->_tmp11_ = _data_->store;
#line 68 "../src/client/application/application-certificate-manager.vala"
			_data_->has_rw_store = !gck_slot_has_flags (_data_->_tmp11_, APPLICATION_CERTIFICATE_MANAGER_CKF_WRITE_PROTECTED);
#line 69 "../src/client/application/application-certificate-manager.vala"
			_data_->_tmp12_ = bool_to_string (_data_->has_rw_store);
#line 69 "../src/client/application/application-certificate-manager.vala"
			_data_->_tmp13_ = _data_->_tmp12_;
#line 69 "../src/client/application/application-certificate-manager.vala"
			g_debug ("application-certificate-manager.vala:69: GCR store is R/W: %s", _data_->_tmp13_);
#line 69 "../src/client/application/application-certificate-manager.vala"
			_g_free0 (_data_->_tmp13_);
#line 897 "application-certificate-manager.c"
		} else {
#line 71 "../src/client/application/application-certificate-manager.vala"
			g_warning ("application-certificate-manager.vala:71: No GCR store found, GCR certi" \
"ficate pinning unavailable");
#line 901 "application-certificate-manager.c"
		}
#line 74 "../src/client/application/application-certificate-manager.vala"
		if (!_data_->has_rw_store) {
#line 75 "../src/client/application/application-certificate-manager.vala"
			g_warning ("application-certificate-manager.vala:75: GCR store is not RW, GCR cert" \
"ificate pinning unavailable");
#line 907 "application-certificate-manager.c"
		}
#line 65 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (_data_->store);
#line 911 "application-certificate-manager.c"
	}
#line 79 "../src/client/application/application-certificate-manager.vala"
	_data_->result = _data_->has_rw_store;
#line 79 "../src/client/application/application-certificate-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 79 "../src/client/application/application-certificate-manager.vala"
	if (_data_->_state_ != 0) {
#line 79 "../src/client/application/application-certificate-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 79 "../src/client/application/application-certificate-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 923 "application-certificate-manager.c"
		}
	}
#line 79 "../src/client/application/application-certificate-manager.vala"
	g_object_unref (_data_->_async_result);
#line 79 "../src/client/application/application-certificate-manager.vala"
	return FALSE;
#line 930 "application-certificate-manager.c"
}

static void
application_certificate_manager_construct_data_free (gpointer _data)
{
	ApplicationCertificateManagerNewData* _data_;
	_data_ = _data;
#line 89 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->store_dir);
#line 89 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 89 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->self);
#line 89 "../src/client/application/application-certificate-manager.vala"
	g_slice_free (ApplicationCertificateManagerNewData, _data_);
#line 946 "application-certificate-manager.c"
}

void
application_certificate_manager_construct (GType object_type,
                                           GFile* store_dir,
                                           GCancellable* cancellable,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	ApplicationCertificateManagerNewData* _data_;
	GFile* _tmp0_;
	GCancellable* _tmp1_;
#line 89 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (store_dir, g_file_get_type ()));
#line 89 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 89 "../src/client/application/application-certificate-manager.vala"
	_data_ = g_slice_new0 (ApplicationCertificateManagerNewData);
#line 89 "../src/client/application/application-certificate-manager.vala"
	_data_->_async_result = g_task_new (NULL, cancellable, _callback_, _user_data_);
#line 89 "../src/client/application/application-certificate-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_certificate_manager_construct_data_free);
#line 89 "../src/client/application/application-certificate-manager.vala"
	_data_->object_type = object_type;
#line 89 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = _g_object_ref0 (store_dir);
#line 89 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->store_dir);
#line 89 "../src/client/application/application-certificate-manager.vala"
	_data_->store_dir = _tmp0_;
#line 89 "../src/client/application/application-certificate-manager.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 89 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 89 "../src/client/application/application-certificate-manager.vala"
	_data_->cancellable = _tmp1_;
#line 89 "../src/client/application/application-certificate-manager.vala"
	application_certificate_manager_construct_co (_data_);
#line 985 "application-certificate-manager.c"
}

ApplicationCertificateManager*
application_certificate_manager_construct_finish (GAsyncResult* _res_)
{
	ApplicationCertificateManager* result;
	ApplicationCertificateManagerNewData* _data_;
#line 89 "../src/client/application/application-certificate-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 89 "../src/client/application/application-certificate-manager.vala"
	if (NULL == _data_) {
#line 89 "../src/client/application/application-certificate-manager.vala"
		return NULL;
#line 999 "application-certificate-manager.c"
	}
#line 89 "../src/client/application/application-certificate-manager.vala"
	result = _data_->self;
#line 89 "../src/client/application/application-certificate-manager.vala"
	_data_->self = NULL;
#line 89 "../src/client/application/application-certificate-manager.vala"
	return result;
#line 1007 "application-certificate-manager.c"
}

/**
     * Constructs a new instance, globally installing the pinning database.
     */
static void
application_certificate_manager_new_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_)
{
	ApplicationCertificateManagerNewData* _data_;
#line 91 "../src/client/application/application-certificate-manager.vala"
	_data_ = _user_data_;
#line 91 "../src/client/application/application-certificate-manager.vala"
	_data_->_source_object_ = source_object;
#line 91 "../src/client/application/application-certificate-manager.vala"
	_data_->_res_ = _res_;
#line 91 "../src/client/application/application-certificate-manager.vala"
	application_certificate_manager_construct_co (_data_);
#line 1027 "application-certificate-manager.c"
}

static gboolean
application_certificate_manager_construct_co (ApplicationCertificateManagerNewData* _data_)
{
#line 89 "../src/client/application/application-certificate-manager.vala"
	switch (_data_->_state_) {
#line 89 "../src/client/application/application-certificate-manager.vala"
		case 0:
#line 1037 "application-certificate-manager.c"
		goto _state_0;
#line 89 "../src/client/application/application-certificate-manager.vala"
		case 1:
#line 1041 "application-certificate-manager.c"
		goto _state_1;
		default:
#line 89 "../src/client/application/application-certificate-manager.vala"
		g_assert_not_reached ();
#line 1046 "application-certificate-manager.c"
	}
	_state_0:
#line 89 "../src/client/application/application-certificate-manager.vala"
	_data_->self = (ApplicationCertificateManager*) g_object_new (_data_->object_type, NULL);
#line 91 "../src/client/application/application-certificate-manager.vala"
	_data_->_state_ = 1;
#line 91 "../src/client/application/application-certificate-manager.vala"
	application_certificate_manager_is_gcr_enabled (_data_->cancellable, application_certificate_manager_new_ready, _data_);
#line 91 "../src/client/application/application-certificate-manager.vala"
	return FALSE;
#line 1057 "application-certificate-manager.c"
	_state_1:
#line 91 "../src/client/application/application-certificate-manager.vala"
	_data_->use_gcr = application_certificate_manager_is_gcr_enabled_finish (_data_->_res_);
#line 92 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp0_ = g_tls_backend_get_default ();
#line 92 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp1_ = g_tls_backend_get_default_database (_data_->_tmp0_);
#line 92 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 92 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp3_ = application_tls_database_new (_data_->_tmp2_, _data_->store_dir, _data_->use_gcr);
#line 92 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->self->priv->pinning_database);
#line 92 "../src/client/application/application-certificate-manager.vala"
	_data_->self->priv->pinning_database = _data_->_tmp3_;
#line 92 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->_tmp2_);
#line 97 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp4_ = _data_->self->priv->pinning_database;
#line 97 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp4_, g_tls_database_get_type (), GTlsDatabase));
#line 97 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (geary_endpoint_default_tls_database);
#line 97 "../src/client/application/application-certificate-manager.vala"
	geary_endpoint_default_tls_database = _data_->_tmp5_;
#line 89 "../src/client/application/application-certificate-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 89 "../src/client/application/application-certificate-manager.vala"
	if (_data_->_state_ != 0) {
#line 89 "../src/client/application/application-certificate-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 89 "../src/client/application/application-certificate-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1091 "application-certificate-manager.c"
		}
	}
#line 89 "../src/client/application/application-certificate-manager.vala"
	g_object_unref (_data_->_async_result);
#line 89 "../src/client/application/application-certificate-manager.vala"
	return FALSE;
#line 1098 "application-certificate-manager.c"
}

void
application_certificate_manager_new (GFile* store_dir,
                                     GCancellable* cancellable,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
#line 89 "../src/client/application/application-certificate-manager.vala"
	application_certificate_manager_construct (APPLICATION_TYPE_CERTIFICATE_MANAGER, store_dir, cancellable, _callback_, _user_data_);
#line 1109 "application-certificate-manager.c"
}

ApplicationCertificateManager*
application_certificate_manager_new_finish (GAsyncResult* _res_)
{
#line 89 "../src/client/application/application-certificate-manager.vala"
	return application_certificate_manager_construct_finish (_res_);
#line 1117 "application-certificate-manager.c"
}

static void
application_certificate_manager_prompt_pin_certificate_data_free (gpointer _data)
{
	ApplicationCertificateManagerPromptPinCertificateData* _data_;
	_data_ = _data;
#line 29 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->parent);
#line 29 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->account);
#line 29 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->service);
#line 29 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->endpoint);
#line 29 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 29 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/client/application/application-certificate-manager.vala"
	g_slice_free (ApplicationCertificateManagerPromptPinCertificateData, _data_);
#line 1139 "application-certificate-manager.c"
}

void
application_certificate_manager_prompt_pin_certificate (ApplicationCertificateManager* self,
                                                        GtkWindow* parent,
                                                        GearyAccountInformation* account,
                                                        GearyServiceInformation* service,
                                                        GearyEndpoint* endpoint,
                                                        gboolean is_validation,
                                                        GCancellable* cancellable,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_)
{
	ApplicationCertificateManagerPromptPinCertificateData* _data_;
	ApplicationCertificateManager* _tmp0_;
	GtkWindow* _tmp1_;
	GearyAccountInformation* _tmp2_;
	GearyServiceInformation* _tmp3_;
	GearyEndpoint* _tmp4_;
	GCancellable* _tmp5_;
#line 29 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail (APPLICATION_IS_CERTIFICATE_MANAGER (self));
#line 29 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (parent, gtk_window_get_type ()));
#line 29 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 29 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (service, GEARY_TYPE_SERVICE_INFORMATION));
#line 29 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (endpoint, GEARY_TYPE_ENDPOINT));
#line 29 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 29 "../src/client/application/application-certificate-manager.vala"
	_data_ = g_slice_new0 (ApplicationCertificateManagerPromptPinCertificateData);
#line 29 "../src/client/application/application-certificate-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 29 "../src/client/application/application-certificate-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_certificate_manager_prompt_pin_certificate_data_free);
#line 29 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/client/application/application-certificate-manager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/client/application/application-certificate-manager.vala"
	_tmp1_ = _g_object_ref0 (parent);
#line 29 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->parent);
#line 29 "../src/client/application/application-certificate-manager.vala"
	_data_->parent = _tmp1_;
#line 29 "../src/client/application/application-certificate-manager.vala"
	_tmp2_ = _g_object_ref0 (account);
#line 29 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->account);
#line 29 "../src/client/application/application-certificate-manager.vala"
	_data_->account = _tmp2_;
#line 29 "../src/client/application/application-certificate-manager.vala"
	_tmp3_ = _g_object_ref0 (service);
#line 29 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->service);
#line 29 "../src/client/application/application-certificate-manager.vala"
	_data_->service = _tmp3_;
#line 29 "../src/client/application/application-certificate-manager.vala"
	_tmp4_ = _g_object_ref0 (endpoint);
#line 29 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->endpoint);
#line 29 "../src/client/application/application-certificate-manager.vala"
	_data_->endpoint = _tmp4_;
#line 29 "../src/client/application/application-certificate-manager.vala"
	_data_->is_validation = is_validation;
#line 29 "../src/client/application/application-certificate-manager.vala"
	_tmp5_ = _g_object_ref0 (cancellable);
#line 29 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 29 "../src/client/application/application-certificate-manager.vala"
	_data_->cancellable = _tmp5_;
#line 29 "../src/client/application/application-certificate-manager.vala"
	application_certificate_manager_prompt_pin_certificate_co (_data_);
#line 1216 "application-certificate-manager.c"
}

void
application_certificate_manager_prompt_pin_certificate_finish (ApplicationCertificateManager* self,
                                                               GAsyncResult* _res_,
                                                               GError** error)
{
	ApplicationCertificateManagerPromptPinCertificateData* _data_;
#line 29 "../src/client/application/application-certificate-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 29 "../src/client/application/application-certificate-manager.vala"
	if (NULL == _data_) {
#line 29 "../src/client/application/application-certificate-manager.vala"
		return;
#line 1231 "application-certificate-manager.c"
	}
}

/**
     * Prompts the user to trust the certificate for a service.
     *
     * Returns true if the user accepted the certificate.
     */
static void
application_certificate_manager_prompt_pin_certificate_ready (GObject* source_object,
                                                              GAsyncResult* _res_,
                                                              gpointer _user_data_)
{
	ApplicationCertificateManagerPromptPinCertificateData* _data_;
#line 140 "../src/client/application/application-certificate-manager.vala"
	_data_ = _user_data_;
#line 140 "../src/client/application/application-certificate-manager.vala"
	_data_->_source_object_ = source_object;
#line 140 "../src/client/application/application-certificate-manager.vala"
	_data_->_res_ = _res_;
#line 140 "../src/client/application/application-certificate-manager.vala"
	application_certificate_manager_prompt_pin_certificate_co (_data_);
#line 1254 "application-certificate-manager.c"
}

static gboolean
application_certificate_manager_prompt_pin_certificate_co (ApplicationCertificateManagerPromptPinCertificateData* _data_)
{
#line 113 "../src/client/application/application-certificate-manager.vala"
	switch (_data_->_state_) {
#line 113 "../src/client/application/application-certificate-manager.vala"
		case 0:
#line 1264 "application-certificate-manager.c"
		goto _state_0;
#line 113 "../src/client/application/application-certificate-manager.vala"
		case 1:
#line 1268 "application-certificate-manager.c"
		goto _state_1;
		default:
#line 113 "../src/client/application/application-certificate-manager.vala"
		g_assert_not_reached ();
#line 1273 "application-certificate-manager.c"
	}
	_state_0:
#line 120 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp0_ = certificate_warning_dialog_new (_data_->parent, _data_->account, _data_->service, _data_->endpoint, _data_->is_validation);
#line 120 "../src/client/application/application-certificate-manager.vala"
	_data_->dialog = _data_->_tmp0_;
#line 124 "../src/client/application/application-certificate-manager.vala"
	_data_->save = FALSE;
#line 125 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp1_ = _data_->dialog;
#line 125 "../src/client/application/application-certificate-manager.vala"
	switch (certificate_warning_dialog_run (_data_->_tmp1_)) {
#line 125 "../src/client/application/application-certificate-manager.vala"
		case CERTIFICATE_WARNING_DIALOG_RESULT_TRUST:
#line 1288 "application-certificate-manager.c"
		{
#line 128 "../src/client/application/application-certificate-manager.vala"
			break;
#line 1292 "application-certificate-manager.c"
		}
#line 125 "../src/client/application/application-certificate-manager.vala"
		case CERTIFICATE_WARNING_DIALOG_RESULT_ALWAYS_TRUST:
#line 1296 "application-certificate-manager.c"
		{
#line 131 "../src/client/application/application-certificate-manager.vala"
			_data_->save = TRUE;
#line 132 "../src/client/application/application-certificate-manager.vala"
			break;
#line 1302 "application-certificate-manager.c"
		}
		default:
		{
#line 135 "../src/client/application/application-certificate-manager.vala"
			_data_->_tmp2_ = g_error_new_literal (APPLICATION_CERTIFICATE_MANAGER_ERROR, APPLICATION_CERTIFICATE_MANAGER_ERROR_UNTRUSTED, "User declined");
#line 135 "../src/client/application/application-certificate-manager.vala"
			_data_->_inner_error0_ = _data_->_tmp2_;
#line 135 "../src/client/application/application-certificate-manager.vala"
			if (_data_->_inner_error0_->domain == APPLICATION_CERTIFICATE_MANAGER_ERROR) {
#line 135 "../src/client/application/application-certificate-manager.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 135 "../src/client/application/application-certificate-manager.vala"
				_certificate_warning_dialog_unref0 (_data_->dialog);
#line 135 "../src/client/application/application-certificate-manager.vala"
				g_object_unref (_data_->_async_result);
#line 135 "../src/client/application/application-certificate-manager.vala"
				return FALSE;
#line 1320 "application-certificate-manager.c"
			} else {
#line 135 "../src/client/application/application-certificate-manager.vala"
				_certificate_warning_dialog_unref0 (_data_->dialog);
#line 135 "../src/client/application/application-certificate-manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 135 "../src/client/application/application-certificate-manager.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 135 "../src/client/application/application-certificate-manager.vala"
				g_object_unref (_data_->_async_result);
#line 135 "../src/client/application/application-certificate-manager.vala"
				return FALSE;
#line 1332 "application-certificate-manager.c"
			}
		}
	}
#line 138 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp3_ = geary_endpoint_get_remote (_data_->endpoint);
#line 138 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 138 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp5_ = g_socket_connectable_to_string (_data_->_tmp4_);
#line 138 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 138 "../src/client/application/application-certificate-manager.vala"
	g_debug ("application-certificate-manager.vala:138: Pinning certificate for %s.." \
".", _data_->_tmp6_);
#line 138 "../src/client/application/application-certificate-manager.vala"
	_g_free0 (_data_->_tmp6_);
#line 1348 "application-certificate-manager.c"
	{
#line 140 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp7_ = _data_->self->priv->pinning_database;
#line 140 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp8_ = geary_endpoint_get_untrusted_certificate (_data_->endpoint);
#line 140 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 140 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp10_ = geary_endpoint_get_remote (_data_->endpoint);
#line 140 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp11_ = _data_->_tmp10_;
#line 140 "../src/client/application/application-certificate-manager.vala"
		_data_->_state_ = 1;
#line 140 "../src/client/application/application-certificate-manager.vala"
		application_tls_database_pin_certificate (_data_->_tmp7_, _data_->_tmp9_, _data_->_tmp11_, _data_->save, _data_->cancellable, application_certificate_manager_prompt_pin_certificate_ready, _data_);
#line 140 "../src/client/application/application-certificate-manager.vala"
		return FALSE;
#line 1366 "application-certificate-manager.c"
		_state_1:
#line 140 "../src/client/application/application-certificate-manager.vala"
		application_tls_database_pin_certificate_finish (_data_->_tmp7_, _data_->_res_, &_data_->_inner_error0_);
#line 140 "../src/client/application/application-certificate-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1372 "application-certificate-manager.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 139 "../src/client/application/application-certificate-manager.vala"
		_data_->err = _data_->_inner_error0_;
#line 139 "../src/client/application/application-certificate-manager.vala"
		_data_->_inner_error0_ = NULL;
#line 147 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp12_ = _data_->err;
#line 147 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp13_ = _data_->_tmp12_->message;
#line 147 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp14_ = g_error_new_literal (APPLICATION_CERTIFICATE_MANAGER_ERROR, APPLICATION_CERTIFICATE_MANAGER_ERROR_STORE_FAILED, _data_->_tmp13_);
#line 147 "../src/client/application/application-certificate-manager.vala"
		_data_->_inner_error0_ = _data_->_tmp14_;
#line 147 "../src/client/application/application-certificate-manager.vala"
		_g_error_free0 (_data_->err);
#line 1393 "application-certificate-manager.c"
		goto __finally0;
	}
	__finally0:
#line 139 "../src/client/application/application-certificate-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 139 "../src/client/application/application-certificate-manager.vala"
		if (_data_->_inner_error0_->domain == APPLICATION_CERTIFICATE_MANAGER_ERROR) {
#line 139 "../src/client/application/application-certificate-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 139 "../src/client/application/application-certificate-manager.vala"
			_certificate_warning_dialog_unref0 (_data_->dialog);
#line 139 "../src/client/application/application-certificate-manager.vala"
			g_object_unref (_data_->_async_result);
#line 139 "../src/client/application/application-certificate-manager.vala"
			return FALSE;
#line 1409 "application-certificate-manager.c"
		} else {
#line 139 "../src/client/application/application-certificate-manager.vala"
			_certificate_warning_dialog_unref0 (_data_->dialog);
#line 139 "../src/client/application/application-certificate-manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 139 "../src/client/application/application-certificate-manager.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 139 "../src/client/application/application-certificate-manager.vala"
			g_object_unref (_data_->_async_result);
#line 139 "../src/client/application/application-certificate-manager.vala"
			return FALSE;
#line 1421 "application-certificate-manager.c"
		}
	}
#line 113 "../src/client/application/application-certificate-manager.vala"
	_certificate_warning_dialog_unref0 (_data_->dialog);
#line 113 "../src/client/application/application-certificate-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 113 "../src/client/application/application-certificate-manager.vala"
	if (_data_->_state_ != 0) {
#line 113 "../src/client/application/application-certificate-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 113 "../src/client/application/application-certificate-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1434 "application-certificate-manager.c"
		}
	}
#line 113 "../src/client/application/application-certificate-manager.vala"
	g_object_unref (_data_->_async_result);
#line 113 "../src/client/application/application-certificate-manager.vala"
	return FALSE;
#line 1441 "application-certificate-manager.c"
}

static void
application_certificate_manager_class_init (ApplicationCertificateManagerClass * klass,
                                            gpointer klass_data)
{
#line 29 "../src/client/application/application-certificate-manager.vala"
	application_certificate_manager_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/client/application/application-certificate-manager.vala"
	g_type_class_adjust_private_offset (klass, &ApplicationCertificateManager_private_offset);
#line 29 "../src/client/application/application-certificate-manager.vala"
	G_OBJECT_CLASS (klass)->finalize = application_certificate_manager_finalize;
#line 1454 "application-certificate-manager.c"
}

static void
application_certificate_manager_instance_init (ApplicationCertificateManager * self,
                                               gpointer klass)
{
#line 29 "../src/client/application/application-certificate-manager.vala"
	self->priv = application_certificate_manager_get_instance_private (self);
#line 1463 "application-certificate-manager.c"
}

static void
application_certificate_manager_finalize (GObject * obj)
{
	ApplicationCertificateManager * self;
#line 29 "../src/client/application/application-certificate-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APPLICATION_TYPE_CERTIFICATE_MANAGER, ApplicationCertificateManager);
#line 104 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (geary_endpoint_default_tls_database);
#line 104 "../src/client/application/application-certificate-manager.vala"
	geary_endpoint_default_tls_database = NULL;
#line 83 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (self->priv->pinning_database);
#line 29 "../src/client/application/application-certificate-manager.vala"
	G_OBJECT_CLASS (application_certificate_manager_parent_class)->finalize (obj);
#line 1480 "application-certificate-manager.c"
}

/**
 * Managing TLS certificate prompting and storage.
 */
static GType
application_certificate_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ApplicationCertificateManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) application_certificate_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ApplicationCertificateManager), 0, (GInstanceInitFunc) application_certificate_manager_instance_init, NULL };
	GType application_certificate_manager_type_id;
	application_certificate_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "ApplicationCertificateManager", &g_define_type_info, 0);
	ApplicationCertificateManager_private_offset = g_type_add_instance_private (application_certificate_manager_type_id, sizeof (ApplicationCertificateManagerPrivate));
	return application_certificate_manager_type_id;
}

GType
application_certificate_manager_get_type (void)
{
	static volatile gsize application_certificate_manager_type_id__once = 0;
	if (g_once_init_enter (&application_certificate_manager_type_id__once)) {
		GType application_certificate_manager_type_id;
		application_certificate_manager_type_id = application_certificate_manager_get_type_once ();
		g_once_init_leave (&application_certificate_manager_type_id__once, application_certificate_manager_type_id);
	}
	return application_certificate_manager_type_id__once;
}

static inline gpointer
application_tls_database_get_instance_private (ApplicationTlsDatabase* self)
{
	return G_STRUCT_MEMBER_P (self, ApplicationTlsDatabase_private_offset);
}

static gchar*
application_tls_database_to_name (GSocketConnectable* id)
{
	GNetworkAddress* name = NULL;
	GNetworkAddress* _tmp0_;
	GNetworkAddress* _tmp1_;
	GNetworkService* service = NULL;
	GNetworkService* _tmp6_;
	GNetworkService* _tmp7_;
	GInetSocketAddress* inet = NULL;
	GInetSocketAddress* _tmp12_;
	GInetSocketAddress* _tmp13_;
	gchar* _tmp18_;
	gchar* result;
#line 234 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (id, g_socket_connectable_get_type ()), NULL);
#line 235 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (id, g_network_address_get_type ()) ? ((GNetworkAddress*) id) : NULL);
#line 235 "../src/client/application/application-certificate-manager.vala"
	name = _tmp0_;
#line 236 "../src/client/application/application-certificate-manager.vala"
	_tmp1_ = name;
#line 236 "../src/client/application/application-certificate-manager.vala"
	if (_tmp1_ != NULL) {
#line 1538 "application-certificate-manager.c"
		GNetworkAddress* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 237 "../src/client/application/application-certificate-manager.vala"
		_tmp2_ = name;
#line 237 "../src/client/application/application-certificate-manager.vala"
		_tmp3_ = g_network_address_get_hostname (_tmp2_);
#line 237 "../src/client/application/application-certificate-manager.vala"
		_tmp4_ = _tmp3_;
#line 237 "../src/client/application/application-certificate-manager.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 237 "../src/client/application/application-certificate-manager.vala"
		result = _tmp5_;
#line 237 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (name);
#line 237 "../src/client/application/application-certificate-manager.vala"
		return result;
#line 1557 "application-certificate-manager.c"
	}
#line 240 "../src/client/application/application-certificate-manager.vala"
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (id, g_network_service_get_type ()) ? ((GNetworkService*) id) : NULL);
#line 240 "../src/client/application/application-certificate-manager.vala"
	service = _tmp6_;
#line 241 "../src/client/application/application-certificate-manager.vala"
	_tmp7_ = service;
#line 241 "../src/client/application/application-certificate-manager.vala"
	if (_tmp7_ != NULL) {
#line 1567 "application-certificate-manager.c"
		GNetworkService* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 242 "../src/client/application/application-certificate-manager.vala"
		_tmp8_ = service;
#line 242 "../src/client/application/application-certificate-manager.vala"
		_tmp9_ = g_network_service_get_domain (_tmp8_);
#line 242 "../src/client/application/application-certificate-manager.vala"
		_tmp10_ = _tmp9_;
#line 242 "../src/client/application/application-certificate-manager.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 242 "../src/client/application/application-certificate-manager.vala"
		result = _tmp11_;
#line 242 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (service);
#line 242 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (name);
#line 242 "../src/client/application/application-certificate-manager.vala"
		return result;
#line 1588 "application-certificate-manager.c"
	}
#line 245 "../src/client/application/application-certificate-manager.vala"
	_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (id, g_inet_socket_address_get_type ()) ? ((GInetSocketAddress*) id) : NULL);
#line 245 "../src/client/application/application-certificate-manager.vala"
	inet = _tmp12_;
#line 246 "../src/client/application/application-certificate-manager.vala"
	_tmp13_ = inet;
#line 246 "../src/client/application/application-certificate-manager.vala"
	if (_tmp13_ != NULL) {
#line 1598 "application-certificate-manager.c"
		GInetSocketAddress* _tmp14_;
		GInetAddress* _tmp15_;
		GInetAddress* _tmp16_;
		gchar* _tmp17_;
#line 247 "../src/client/application/application-certificate-manager.vala"
		_tmp14_ = inet;
#line 247 "../src/client/application/application-certificate-manager.vala"
		_tmp15_ = g_inet_socket_address_get_address (_tmp14_);
#line 247 "../src/client/application/application-certificate-manager.vala"
		_tmp16_ = _tmp15_;
#line 247 "../src/client/application/application-certificate-manager.vala"
		_tmp17_ = g_inet_address_to_string (_tmp16_);
#line 247 "../src/client/application/application-certificate-manager.vala"
		result = _tmp17_;
#line 247 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (inet);
#line 247 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (service);
#line 247 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (name);
#line 247 "../src/client/application/application-certificate-manager.vala"
		return result;
#line 1621 "application-certificate-manager.c"
	}
#line 250 "../src/client/application/application-certificate-manager.vala"
	_tmp18_ = g_socket_connectable_to_string (id);
#line 250 "../src/client/application/application-certificate-manager.vala"
	result = _tmp18_;
#line 250 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (inet);
#line 250 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (service);
#line 250 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (name);
#line 250 "../src/client/application/application-certificate-manager.vala"
	return result;
#line 1635 "application-certificate-manager.c"
}

static GTlsDatabase*
application_tls_database_get_parent (ApplicationTlsDatabase* self)
{
	GTlsDatabase* result;
	GTlsDatabase* _tmp0_;
#line 254 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail (APPLICATION_IS_TLS_DATABASE (self), NULL);
#line 254 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = self->priv->_parent;
#line 254 "../src/client/application/application-certificate-manager.vala"
	result = _tmp0_;
#line 254 "../src/client/application/application-certificate-manager.vala"
	return result;
#line 1651 "application-certificate-manager.c"
}

static void
application_tls_database_set_parent (ApplicationTlsDatabase* self,
                                     GTlsDatabase* value)
{
	GTlsDatabase* _tmp0_;
#line 254 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail (APPLICATION_IS_TLS_DATABASE (self));
#line 254 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 254 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (self->priv->_parent);
#line 254 "../src/client/application/application-certificate-manager.vala"
	self->priv->_parent = _tmp0_;
#line 1667 "application-certificate-manager.c"
}

ApplicationTlsDatabase*
application_tls_database_construct (GType object_type,
                                    GTlsDatabase* parent,
                                    GFile* store_dir,
                                    gboolean use_gcr)
{
	ApplicationTlsDatabase * self = NULL;
	GFile* _tmp0_;
#line 262 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (parent, g_tls_database_get_type ()), NULL);
#line 262 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (store_dir, g_file_get_type ()), NULL);
#line 262 "../src/client/application/application-certificate-manager.vala"
	self = (ApplicationTlsDatabase*) g_object_new (object_type, NULL);
#line 265 "../src/client/application/application-certificate-manager.vala"
	application_tls_database_set_parent (self, parent);
#line 266 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = _g_object_ref0 (store_dir);
#line 266 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (self->priv->store_dir);
#line 266 "../src/client/application/application-certificate-manager.vala"
	self->priv->store_dir = _tmp0_;
#line 267 "../src/client/application/application-certificate-manager.vala"
	self->priv->use_gcr = use_gcr;
#line 262 "../src/client/application/application-certificate-manager.vala"
	return self;
#line 1696 "application-certificate-manager.c"
}

ApplicationTlsDatabase*
application_tls_database_new (GTlsDatabase* parent,
                              GFile* store_dir,
                              gboolean use_gcr)
{
#line 262 "../src/client/application/application-certificate-manager.vala"
	return application_tls_database_construct (APPLICATION_TYPE_TLS_DATABASE, parent, store_dir, use_gcr);
#line 1706 "application-certificate-manager.c"
}

static void
application_tls_database_pin_certificate_data_free (gpointer _data)
{
	ApplicationTlsDatabasePinCertificateData* _data_;
	_data_ = _data;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->certificate);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->identity);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->self);
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_slice_free (ApplicationTlsDatabasePinCertificateData, _data_);
#line 1724 "application-certificate-manager.c"
}

void
application_tls_database_pin_certificate (ApplicationTlsDatabase* self,
                                          GTlsCertificate* certificate,
                                          GSocketConnectable* identity,
                                          gboolean save,
                                          GCancellable* cancellable,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	ApplicationTlsDatabasePinCertificateData* _data_;
	ApplicationTlsDatabase* _tmp0_;
	GTlsCertificate* _tmp1_;
	GSocketConnectable* _tmp2_;
	GCancellable* _tmp3_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail (APPLICATION_IS_TLS_DATABASE (self));
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (certificate, g_tls_certificate_get_type ()));
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (identity, g_socket_connectable_get_type ()));
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_ = g_slice_new0 (ApplicationTlsDatabasePinCertificateData);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_tls_database_pin_certificate_data_free);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->self = _tmp0_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp1_ = _g_object_ref0 (certificate);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->certificate);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->certificate = _tmp1_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp2_ = _g_object_ref0 (identity);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->identity);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->identity = _tmp2_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->save = save;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->cancellable = _tmp3_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	application_tls_database_pin_certificate_co (_data_);
#line 1781 "application-certificate-manager.c"
}

void
application_tls_database_pin_certificate_finish (ApplicationTlsDatabase* self,
                                                 GAsyncResult* _res_,
                                                 GError** error)
{
	ApplicationTlsDatabasePinCertificateData* _data_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 160 "../src/client/application/application-certificate-manager.vala"
	if (NULL == _data_) {
#line 160 "../src/client/application/application-certificate-manager.vala"
		return;
#line 1796 "application-certificate-manager.c"
	}
}

static void
application_tls_database_pin_certificate_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_)
{
	ApplicationTlsDatabasePinCertificateData* _data_;
#line 282 "../src/client/application/application-certificate-manager.vala"
	_data_ = _user_data_;
#line 282 "../src/client/application/application-certificate-manager.vala"
	_data_->_source_object_ = source_object;
#line 282 "../src/client/application/application-certificate-manager.vala"
	_data_->_res_ = _res_;
#line 282 "../src/client/application/application-certificate-manager.vala"
	application_tls_database_pin_certificate_co (_data_);
#line 1814 "application-certificate-manager.c"
}

static gboolean
application_tls_database_pin_certificate_co (ApplicationTlsDatabasePinCertificateData* _data_)
{
#line 270 "../src/client/application/application-certificate-manager.vala"
	switch (_data_->_state_) {
#line 270 "../src/client/application/application-certificate-manager.vala"
		case 0:
#line 1824 "application-certificate-manager.c"
		goto _state_0;
#line 270 "../src/client/application/application-certificate-manager.vala"
		case 1:
#line 1828 "application-certificate-manager.c"
		goto _state_1;
#line 270 "../src/client/application/application-certificate-manager.vala"
		case 2:
#line 1832 "application-certificate-manager.c"
		goto _state_2;
		default:
#line 270 "../src/client/application/application-certificate-manager.vala"
		g_assert_not_reached ();
#line 1837 "application-certificate-manager.c"
	}
	_state_0:
#line 275 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp0_ = application_tls_database_to_name (_data_->identity);
#line 275 "../src/client/application/application-certificate-manager.vala"
	_data_->id = _data_->_tmp0_;
#line 276 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp1_ = application_tls_database_trust_context_new (_data_->certificate);
#line 276 "../src/client/application/application-certificate-manager.vala"
	_data_->context = _data_->_tmp1_;
#line 1848 "application-certificate-manager.c"
	{
#line 277 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp2_ = _data_->self->priv->pinned_certs;
#line 277 "../src/client/application/application-certificate-manager.vala"
		g_rec_mutex_lock (&_data_->self->priv->__lock_pinned_certs);
#line 1854 "application-certificate-manager.c"
		{
#line 278 "../src/client/application/application-certificate-manager.vala"
			_data_->_tmp3_ = _data_->self->priv->pinned_certs;
#line 278 "../src/client/application/application-certificate-manager.vala"
			_data_->_tmp4_ = _data_->id;
#line 278 "../src/client/application/application-certificate-manager.vala"
			_data_->_tmp5_ = _data_->context;
#line 278 "../src/client/application/application-certificate-manager.vala"
			gee_map_set (_data_->_tmp3_, _data_->_tmp4_, _data_->_tmp5_);
#line 1864 "application-certificate-manager.c"
		}
		__finally0:
		{
#line 277 "../src/client/application/application-certificate-manager.vala"
			_data_->_tmp6_ = _data_->self->priv->pinned_certs;
#line 277 "../src/client/application/application-certificate-manager.vala"
			g_rec_mutex_unlock (&_data_->self->priv->__lock_pinned_certs);
#line 1872 "application-certificate-manager.c"
		}
#line 277 "../src/client/application/application-certificate-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 277 "../src/client/application/application-certificate-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 277 "../src/client/application/application-certificate-manager.vala"
			_g_object_unref0 (_data_->context);
#line 277 "../src/client/application/application-certificate-manager.vala"
			_g_free0 (_data_->id);
#line 277 "../src/client/application/application-certificate-manager.vala"
			g_object_unref (_data_->_async_result);
#line 277 "../src/client/application/application-certificate-manager.vala"
			return FALSE;
#line 1886 "application-certificate-manager.c"
		}
	}
#line 280 "../src/client/application/application-certificate-manager.vala"
	if (_data_->save) {
#line 281 "../src/client/application/application-certificate-manager.vala"
		if (_data_->self->priv->use_gcr) {
#line 282 "../src/client/application/application-certificate-manager.vala"
			g_object_get (_data_->certificate, "certificate", &_data_->_tmp7_, NULL);
#line 282 "../src/client/application/application-certificate-manager.vala"
			_data_->_tmp8_ = _data_->_tmp7_;
#line 282 "../src/client/application/application-certificate-manager.vala"
			_data_->_tmp9_ = _data_->_tmp8_;
#line 282 "../src/client/application/application-certificate-manager.vala"
			_data_->_tmp10_ = _data_->_tmp9_->data;
#line 282 "../src/client/application/application-certificate-manager.vala"
			_data_->_tmp10__length1 = _data_->_tmp9_->len;
#line 282 "../src/client/application/application-certificate-manager.vala"
			_data_->_tmp11_ = (GcrSimpleCertificate*) gcr_simple_certificate_new (_data_->_tmp10_, _data_->_tmp10__length1);
#line 282 "../src/client/application/application-certificate-manager.vala"
			_data_->_tmp12_ = _data_->_tmp11_;
#line 282 "../src/client/application/application-certificate-manager.vala"
			_data_->_tmp13_ = _data_->id;
#line 282 "../src/client/application/application-certificate-manager.vala"
			_data_->_state_ = 1;
#line 282 "../src/client/application/application-certificate-manager.vala"
			gcr_trust_add_pinned_certificate_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp12_, gcr_certificate_get_type (), GcrCertificate), G_TLS_DATABASE_PURPOSE_AUTHENTICATE_SERVER, _data_->_tmp13_, _data_->cancellable, application_tls_database_pin_certificate_ready, _data_);
#line 282 "../src/client/application/application-certificate-manager.vala"
			return FALSE;
#line 1915 "application-certificate-manager.c"
			_state_1:
#line 282 "../src/client/application/application-certificate-manager.vala"
			gcr_trust_add_pinned_certificate_finish (_data_->_res_, &_data_->_inner_error0_);
#line 282 "../src/client/application/application-certificate-manager.vala"
			_g_object_unref0 (_data_->_tmp12_);
#line 282 "../src/client/application/application-certificate-manager.vala"
			_g_byte_array_unref0 (_data_->_tmp9_);
#line 282 "../src/client/application/application-certificate-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 282 "../src/client/application/application-certificate-manager.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 282 "../src/client/application/application-certificate-manager.vala"
				_g_object_unref0 (_data_->context);
#line 282 "../src/client/application/application-certificate-manager.vala"
				_g_free0 (_data_->id);
#line 282 "../src/client/application/application-certificate-manager.vala"
				g_object_unref (_data_->_async_result);
#line 282 "../src/client/application/application-certificate-manager.vala"
				return FALSE;
#line 1935 "application-certificate-manager.c"
			}
		} else {
#line 289 "../src/client/application/application-certificate-manager.vala"
			_data_->_tmp14_ = _data_->context;
#line 289 "../src/client/application/application-certificate-manager.vala"
			_data_->_tmp15_ = _data_->self->priv->store_dir;
#line 289 "../src/client/application/application-certificate-manager.vala"
			_data_->_tmp16_ = application_tls_database_to_name (_data_->identity);
#line 289 "../src/client/application/application-certificate-manager.vala"
			_data_->_tmp17_ = _data_->_tmp16_;
#line 289 "../src/client/application/application-certificate-manager.vala"
			_data_->_state_ = 2;
#line 289 "../src/client/application/application-certificate-manager.vala"
			application_tls_database_trust_context_save (_data_->_tmp14_, _data_->_tmp15_, _data_->_tmp17_, _data_->cancellable, application_tls_database_pin_certificate_ready, _data_);
#line 289 "../src/client/application/application-certificate-manager.vala"
			return FALSE;
#line 1952 "application-certificate-manager.c"
			_state_2:
#line 289 "../src/client/application/application-certificate-manager.vala"
			application_tls_database_trust_context_save_finish (_data_->_tmp14_, _data_->_res_, &_data_->_inner_error0_);
#line 289 "../src/client/application/application-certificate-manager.vala"
			_g_free0 (_data_->_tmp17_);
#line 289 "../src/client/application/application-certificate-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 289 "../src/client/application/application-certificate-manager.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 289 "../src/client/application/application-certificate-manager.vala"
				_g_object_unref0 (_data_->context);
#line 289 "../src/client/application/application-certificate-manager.vala"
				_g_free0 (_data_->id);
#line 289 "../src/client/application/application-certificate-manager.vala"
				g_object_unref (_data_->_async_result);
#line 289 "../src/client/application/application-certificate-manager.vala"
				return FALSE;
#line 1970 "application-certificate-manager.c"
			}
		}
	}
#line 270 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->context);
#line 270 "../src/client/application/application-certificate-manager.vala"
	_g_free0 (_data_->id);
#line 270 "../src/client/application/application-certificate-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 270 "../src/client/application/application-certificate-manager.vala"
	if (_data_->_state_ != 0) {
#line 270 "../src/client/application/application-certificate-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 270 "../src/client/application/application-certificate-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1986 "application-certificate-manager.c"
		}
	}
#line 270 "../src/client/application/application-certificate-manager.vala"
	g_object_unref (_data_->_async_result);
#line 270 "../src/client/application/application-certificate-manager.vala"
	return FALSE;
#line 1993 "application-certificate-manager.c"
}

static gchar*
application_tls_database_real_create_certificate_handle (GTlsDatabase* base,
                                                         GTlsCertificate* certificate)
{
	ApplicationTlsDatabase * self;
	ApplicationTlsDatabaseTrustContext* context = NULL;
	ApplicationTlsDatabaseTrustContext* _tmp0_;
	gchar* _tmp1_ = NULL;
	ApplicationTlsDatabaseTrustContext* _tmp2_;
	gchar* result;
#line 296 "../src/client/application/application-certificate-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_TLS_DATABASE, ApplicationTlsDatabase);
#line 296 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (certificate, g_tls_certificate_get_type ()), NULL);
#line 298 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = application_tls_database_lookup_tls_certificate (self, certificate);
#line 298 "../src/client/application/application-certificate-manager.vala"
	context = _tmp0_;
#line 299 "../src/client/application/application-certificate-manager.vala"
	_tmp2_ = context;
#line 299 "../src/client/application/application-certificate-manager.vala"
	if (_tmp2_ != NULL) {
#line 2018 "application-certificate-manager.c"
		ApplicationTlsDatabaseTrustContext* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 300 "../src/client/application/application-certificate-manager.vala"
		_tmp3_ = context;
#line 300 "../src/client/application/application-certificate-manager.vala"
		_tmp4_ = _tmp3_->id;
#line 300 "../src/client/application/application-certificate-manager.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 300 "../src/client/application/application-certificate-manager.vala"
		_g_free0 (_tmp1_);
#line 300 "../src/client/application/application-certificate-manager.vala"
		_tmp1_ = _tmp5_;
#line 2032 "application-certificate-manager.c"
	} else {
		GTlsDatabase* _tmp6_;
		gchar* _tmp7_;
#line 301 "../src/client/application/application-certificate-manager.vala"
		_tmp6_ = self->priv->_parent;
#line 301 "../src/client/application/application-certificate-manager.vala"
		_tmp7_ = g_tls_database_create_certificate_handle (_tmp6_, certificate);
#line 301 "../src/client/application/application-certificate-manager.vala"
		_g_free0 (_tmp1_);
#line 301 "../src/client/application/application-certificate-manager.vala"
		_tmp1_ = _tmp7_;
#line 2044 "application-certificate-manager.c"
	}
#line 299 "../src/client/application/application-certificate-manager.vala"
	result = _tmp1_;
#line 299 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (context);
#line 299 "../src/client/application/application-certificate-manager.vala"
	return result;
#line 2052 "application-certificate-manager.c"
}

static GTlsCertificate*
application_tls_database_real_lookup_certificate_for_handle (GTlsDatabase* base,
                                                             const gchar* handle,
                                                             GTlsInteraction* interaction,
                                                             GTlsDatabaseLookupFlags flags,
                                                             GCancellable* cancellable,
                                                             GError** error)
{
	ApplicationTlsDatabase * self;
	ApplicationTlsDatabaseTrustContext* context = NULL;
	ApplicationTlsDatabaseTrustContext* _tmp0_;
	GTlsCertificate* _tmp1_ = NULL;
	ApplicationTlsDatabaseTrustContext* _tmp2_;
	GError* _inner_error0_ = NULL;
	GTlsCertificate* result;
#line 304 "../src/client/application/application-certificate-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_TLS_DATABASE, ApplicationTlsDatabase);
#line 304 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail (handle != NULL, NULL);
#line 304 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail ((interaction == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (interaction, g_tls_interaction_get_type ()), NULL);
#line 304 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), NULL);
#line 310 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = application_tls_database_lookup_id (self, handle);
#line 310 "../src/client/application/application-certificate-manager.vala"
	context = _tmp0_;
#line 311 "../src/client/application/application-certificate-manager.vala"
	_tmp2_ = context;
#line 311 "../src/client/application/application-certificate-manager.vala"
	if (_tmp2_ != NULL) {
#line 2086 "application-certificate-manager.c"
		ApplicationTlsDatabaseTrustContext* _tmp3_;
		GTlsCertificate* _tmp4_;
		GTlsCertificate* _tmp5_;
#line 312 "../src/client/application/application-certificate-manager.vala"
		_tmp3_ = context;
#line 312 "../src/client/application/application-certificate-manager.vala"
		_tmp4_ = _tmp3_->certificate;
#line 312 "../src/client/application/application-certificate-manager.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 312 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (_tmp1_);
#line 312 "../src/client/application/application-certificate-manager.vala"
		_tmp1_ = _tmp5_;
#line 2100 "application-certificate-manager.c"
	} else {
		GTlsDatabase* _tmp6_;
		GTlsCertificate* _tmp7_;
#line 313 "../src/client/application/application-certificate-manager.vala"
		_tmp6_ = self->priv->_parent;
#line 313 "../src/client/application/application-certificate-manager.vala"
		_tmp7_ = g_tls_database_lookup_certificate_for_handle (_tmp6_, handle, interaction, flags, cancellable, &_inner_error0_);
#line 313 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (_tmp1_);
#line 313 "../src/client/application/application-certificate-manager.vala"
		_tmp1_ = _tmp7_;
#line 313 "../src/client/application/application-certificate-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 313 "../src/client/application/application-certificate-manager.vala"
			g_propagate_error (error, _inner_error0_);
#line 313 "../src/client/application/application-certificate-manager.vala"
			_g_object_unref0 (_tmp1_);
#line 313 "../src/client/application/application-certificate-manager.vala"
			_g_object_unref0 (context);
#line 313 "../src/client/application/application-certificate-manager.vala"
			return NULL;
#line 2122 "application-certificate-manager.c"
		}
	}
#line 311 "../src/client/application/application-certificate-manager.vala"
	result = _tmp1_;
#line 311 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (context);
#line 311 "../src/client/application/application-certificate-manager.vala"
	return result;
#line 2131 "application-certificate-manager.c"
}

static void
application_tls_database_real_lookup_certificate_for_handle_async_data_free (gpointer _data)
{
	ApplicationTlsDatabaseLookupCertificateForHandleAsyncData* _data_;
	_data_ = _data;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_free0 (_data_->handle);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->interaction);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->result);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->self);
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_slice_free (ApplicationTlsDatabaseLookupCertificateForHandleAsyncData, _data_);
#line 2151 "application-certificate-manager.c"
}

static void
application_tls_database_real_lookup_certificate_for_handle_async (GTlsDatabase* base,
                                                                   const gchar* handle,
                                                                   GTlsInteraction* interaction,
                                                                   GTlsDatabaseLookupFlags flags,
                                                                   GCancellable* cancellable,
                                                                   GAsyncReadyCallback _callback_,
                                                                   gpointer _user_data_)
{
	ApplicationTlsDatabase * self;
	ApplicationTlsDatabaseLookupCertificateForHandleAsyncData* _data_;
	ApplicationTlsDatabase* _tmp0_;
	gchar* _tmp1_;
	GTlsInteraction* _tmp2_;
	GCancellable* _tmp3_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail (handle != NULL);
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail ((interaction == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (interaction, g_tls_interaction_get_type ()));
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 160 "../src/client/application/application-certificate-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_TLS_DATABASE, ApplicationTlsDatabase);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_ = g_slice_new0 (ApplicationTlsDatabaseLookupCertificateForHandleAsyncData);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_tls_database_real_lookup_certificate_for_handle_async_data_free);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->self = _tmp0_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp1_ = g_strdup (handle);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_free0 (_data_->handle);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->handle = _tmp1_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp2_ = _g_object_ref0 (interaction);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->interaction);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->interaction = _tmp2_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->flags = flags;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->cancellable = _tmp3_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	application_tls_database_real_lookup_certificate_for_handle_async_co (_data_);
#line 2209 "application-certificate-manager.c"
}

static GTlsCertificate*
application_tls_database_lookup_certificate_for_handle_finish (GTlsDatabase* base,
                                                               GAsyncResult* _res_,
                                                               GError** error)
{
	GTlsCertificate* result;
	ApplicationTlsDatabaseLookupCertificateForHandleAsyncData* _data_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 160 "../src/client/application/application-certificate-manager.vala"
	if (NULL == _data_) {
#line 160 "../src/client/application/application-certificate-manager.vala"
		return NULL;
#line 2225 "application-certificate-manager.c"
	}
#line 160 "../src/client/application/application-certificate-manager.vala"
	result = _data_->result;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->result = NULL;
#line 160 "../src/client/application/application-certificate-manager.vala"
	return result;
#line 2233 "application-certificate-manager.c"
}

static void
application_tls_database_lookup_certificate_for_handle_async_ready (GObject* source_object,
                                                                    GAsyncResult* _res_,
                                                                    gpointer _user_data_)
{
	ApplicationTlsDatabaseLookupCertificateForHandleAsyncData* _data_;
#line 327 "../src/client/application/application-certificate-manager.vala"
	_data_ = _user_data_;
#line 327 "../src/client/application/application-certificate-manager.vala"
	_data_->_source_object_ = source_object;
#line 327 "../src/client/application/application-certificate-manager.vala"
	_data_->_res_ = _res_;
#line 327 "../src/client/application/application-certificate-manager.vala"
	application_tls_database_real_lookup_certificate_for_handle_async_co (_data_);
#line 2250 "application-certificate-manager.c"
}

static gboolean
application_tls_database_real_lookup_certificate_for_handle_async_co (ApplicationTlsDatabaseLookupCertificateForHandleAsyncData* _data_)
{
#line 318 "../src/client/application/application-certificate-manager.vala"
	switch (_data_->_state_) {
#line 318 "../src/client/application/application-certificate-manager.vala"
		case 0:
#line 2260 "application-certificate-manager.c"
		goto _state_0;
#line 318 "../src/client/application/application-certificate-manager.vala"
		case 1:
#line 2264 "application-certificate-manager.c"
		goto _state_1;
		default:
#line 318 "../src/client/application/application-certificate-manager.vala"
		g_assert_not_reached ();
#line 2269 "application-certificate-manager.c"
	}
	_state_0:
#line 324 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp0_ = application_tls_database_lookup_id (_data_->self, _data_->handle);
#line 324 "../src/client/application/application-certificate-manager.vala"
	_data_->context = _data_->_tmp0_;
#line 325 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp2_ = _data_->context;
#line 325 "../src/client/application/application-certificate-manager.vala"
	if (_data_->_tmp2_ != NULL) {
#line 326 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp3_ = _data_->context;
#line 326 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp4_ = _data_->_tmp3_->certificate;
#line 326 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp5_ = _g_object_ref0 (_data_->_tmp4_);
#line 326 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (_data_->_tmp1_);
#line 326 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp1_ = _data_->_tmp5_;
#line 2290 "application-certificate-manager.c"
	} else {
#line 327 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp6_ = _data_->self->priv->_parent;
#line 327 "../src/client/application/application-certificate-manager.vala"
		_data_->_state_ = 1;
#line 327 "../src/client/application/application-certificate-manager.vala"
		g_tls_database_lookup_certificate_for_handle_async (_data_->_tmp6_, _data_->handle, _data_->interaction, _data_->flags, _data_->cancellable, application_tls_database_lookup_certificate_for_handle_async_ready, _data_);
#line 327 "../src/client/application/application-certificate-manager.vala"
		return FALSE;
#line 2300 "application-certificate-manager.c"
		_state_1:
#line 327 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp7_ = g_tls_database_lookup_certificate_for_handle_finish (_data_->_tmp6_, _data_->_res_, &_data_->_inner_error0_);
#line 327 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (_data_->_tmp1_);
#line 327 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp1_ = _data_->_tmp7_;
#line 327 "../src/client/application/application-certificate-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 327 "../src/client/application/application-certificate-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 327 "../src/client/application/application-certificate-manager.vala"
			_g_object_unref0 (_data_->_tmp1_);
#line 327 "../src/client/application/application-certificate-manager.vala"
			_g_object_unref0 (_data_->context);
#line 327 "../src/client/application/application-certificate-manager.vala"
			g_object_unref (_data_->_async_result);
#line 327 "../src/client/application/application-certificate-manager.vala"
			return FALSE;
#line 2320 "application-certificate-manager.c"
		}
	}
#line 325 "../src/client/application/application-certificate-manager.vala"
	_data_->result = _data_->_tmp1_;
#line 325 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->context);
#line 325 "../src/client/application/application-certificate-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 325 "../src/client/application/application-certificate-manager.vala"
	if (_data_->_state_ != 0) {
#line 325 "../src/client/application/application-certificate-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 325 "../src/client/application/application-certificate-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2335 "application-certificate-manager.c"
		}
	}
#line 325 "../src/client/application/application-certificate-manager.vala"
	g_object_unref (_data_->_async_result);
#line 325 "../src/client/application/application-certificate-manager.vala"
	return FALSE;
#line 2342 "application-certificate-manager.c"
}

static GTlsCertificate*
application_tls_database_real_lookup_certificate_issuer (GTlsDatabase* base,
                                                         GTlsCertificate* certificate,
                                                         GTlsInteraction* interaction,
                                                         GTlsDatabaseLookupFlags flags,
                                                         GCancellable* cancellable,
                                                         GError** error)
{
	ApplicationTlsDatabase * self;
	GTlsCertificate* _tmp0_ = NULL;
	GTlsDatabase* _tmp1_;
	GTlsCertificate* _tmp2_;
	GTlsCertificate* _tmp3_;
	GError* _inner_error0_ = NULL;
	GTlsCertificate* result;
#line 332 "../src/client/application/application-certificate-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_TLS_DATABASE, ApplicationTlsDatabase);
#line 332 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (certificate, g_tls_certificate_get_type ()), NULL);
#line 332 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail ((interaction == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (interaction, g_tls_interaction_get_type ()), NULL);
#line 332 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), NULL);
#line 338 "../src/client/application/application-certificate-manager.vala"
	_tmp1_ = self->priv->_parent;
#line 338 "../src/client/application/application-certificate-manager.vala"
	_tmp2_ = g_tls_database_lookup_certificate_issuer (_tmp1_, certificate, interaction, flags, cancellable, &_inner_error0_);
#line 338 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = _tmp2_;
#line 338 "../src/client/application/application-certificate-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 338 "../src/client/application/application-certificate-manager.vala"
		g_propagate_error (error, _inner_error0_);
#line 338 "../src/client/application/application-certificate-manager.vala"
		return NULL;
#line 2380 "application-certificate-manager.c"
	}
#line 338 "../src/client/application/application-certificate-manager.vala"
	_tmp3_ = _tmp0_;
#line 338 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = NULL;
#line 338 "../src/client/application/application-certificate-manager.vala"
	result = _tmp3_;
#line 338 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_tmp0_);
#line 338 "../src/client/application/application-certificate-manager.vala"
	return result;
#line 2392 "application-certificate-manager.c"
}

static void
application_tls_database_real_lookup_certificate_issuer_async_data_free (gpointer _data)
{
	ApplicationTlsDatabaseLookupCertificateIssuerAsyncData* _data_;
	_data_ = _data;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->certificate);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->interaction);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->result);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->self);
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_slice_free (ApplicationTlsDatabaseLookupCertificateIssuerAsyncData, _data_);
#line 2412 "application-certificate-manager.c"
}

static void
application_tls_database_real_lookup_certificate_issuer_async (GTlsDatabase* base,
                                                               GTlsCertificate* certificate,
                                                               GTlsInteraction* interaction,
                                                               GTlsDatabaseLookupFlags flags,
                                                               GCancellable* cancellable,
                                                               GAsyncReadyCallback _callback_,
                                                               gpointer _user_data_)
{
	ApplicationTlsDatabase * self;
	ApplicationTlsDatabaseLookupCertificateIssuerAsyncData* _data_;
	ApplicationTlsDatabase* _tmp0_;
	GTlsCertificate* _tmp1_;
	GTlsInteraction* _tmp2_;
	GCancellable* _tmp3_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (certificate, g_tls_certificate_get_type ()));
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail ((interaction == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (interaction, g_tls_interaction_get_type ()));
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 160 "../src/client/application/application-certificate-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_TLS_DATABASE, ApplicationTlsDatabase);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_ = g_slice_new0 (ApplicationTlsDatabaseLookupCertificateIssuerAsyncData);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_tls_database_real_lookup_certificate_issuer_async_data_free);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->self = _tmp0_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp1_ = _g_object_ref0 (certificate);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->certificate);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->certificate = _tmp1_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp2_ = _g_object_ref0 (interaction);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->interaction);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->interaction = _tmp2_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->flags = flags;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->cancellable = _tmp3_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	application_tls_database_real_lookup_certificate_issuer_async_co (_data_);
#line 2470 "application-certificate-manager.c"
}

static GTlsCertificate*
application_tls_database_lookup_certificate_issuer_finish (GTlsDatabase* base,
                                                           GAsyncResult* _res_,
                                                           GError** error)
{
	GTlsCertificate* result;
	ApplicationTlsDatabaseLookupCertificateIssuerAsyncData* _data_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 160 "../src/client/application/application-certificate-manager.vala"
	if (NULL == _data_) {
#line 160 "../src/client/application/application-certificate-manager.vala"
		return NULL;
#line 2486 "application-certificate-manager.c"
	}
#line 160 "../src/client/application/application-certificate-manager.vala"
	result = _data_->result;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->result = NULL;
#line 160 "../src/client/application/application-certificate-manager.vala"
	return result;
#line 2494 "application-certificate-manager.c"
}

static void
application_tls_database_lookup_certificate_issuer_async_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_)
{
	ApplicationTlsDatabaseLookupCertificateIssuerAsyncData* _data_;
#line 349 "../src/client/application/application-certificate-manager.vala"
	_data_ = _user_data_;
#line 349 "../src/client/application/application-certificate-manager.vala"
	_data_->_source_object_ = source_object;
#line 349 "../src/client/application/application-certificate-manager.vala"
	_data_->_res_ = _res_;
#line 349 "../src/client/application/application-certificate-manager.vala"
	application_tls_database_real_lookup_certificate_issuer_async_co (_data_);
#line 2511 "application-certificate-manager.c"
}

static gboolean
application_tls_database_real_lookup_certificate_issuer_async_co (ApplicationTlsDatabaseLookupCertificateIssuerAsyncData* _data_)
{
#line 343 "../src/client/application/application-certificate-manager.vala"
	switch (_data_->_state_) {
#line 343 "../src/client/application/application-certificate-manager.vala"
		case 0:
#line 2521 "application-certificate-manager.c"
		goto _state_0;
#line 343 "../src/client/application/application-certificate-manager.vala"
		case 1:
#line 2525 "application-certificate-manager.c"
		goto _state_1;
		default:
#line 343 "../src/client/application/application-certificate-manager.vala"
		g_assert_not_reached ();
#line 2530 "application-certificate-manager.c"
	}
	_state_0:
#line 349 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp1_ = _data_->self->priv->_parent;
#line 349 "../src/client/application/application-certificate-manager.vala"
	_data_->_state_ = 1;
#line 349 "../src/client/application/application-certificate-manager.vala"
	g_tls_database_lookup_certificate_issuer_async (_data_->_tmp1_, _data_->certificate, _data_->interaction, _data_->flags, _data_->cancellable, application_tls_database_lookup_certificate_issuer_async_ready, _data_);
#line 349 "../src/client/application/application-certificate-manager.vala"
	return FALSE;
#line 2541 "application-certificate-manager.c"
	_state_1:
#line 349 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp2_ = g_tls_database_lookup_certificate_issuer_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error0_);
#line 349 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp0_ = _data_->_tmp2_;
#line 349 "../src/client/application/application-certificate-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 349 "../src/client/application/application-certificate-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 349 "../src/client/application/application-certificate-manager.vala"
		g_object_unref (_data_->_async_result);
#line 349 "../src/client/application/application-certificate-manager.vala"
		return FALSE;
#line 2555 "application-certificate-manager.c"
	}
#line 349 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp3_ = _data_->_tmp0_;
#line 349 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp0_ = NULL;
#line 349 "../src/client/application/application-certificate-manager.vala"
	_data_->result = _data_->_tmp3_;
#line 349 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->_tmp0_);
#line 349 "../src/client/application/application-certificate-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 349 "../src/client/application/application-certificate-manager.vala"
	if (_data_->_state_ != 0) {
#line 349 "../src/client/application/application-certificate-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 349 "../src/client/application/application-certificate-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2573 "application-certificate-manager.c"
		}
	}
#line 349 "../src/client/application/application-certificate-manager.vala"
	g_object_unref (_data_->_async_result);
#line 349 "../src/client/application/application-certificate-manager.vala"
	return FALSE;
#line 2580 "application-certificate-manager.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 360 "../src/client/application/application-certificate-manager.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 2588 "application-certificate-manager.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 360 "../src/client/application/application-certificate-manager.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 2596 "application-certificate-manager.c"
}

static GList*
application_tls_database_real_lookup_certificates_issued_by (GTlsDatabase* base,
                                                             GByteArray* issuer_raw_dn,
                                                             GTlsInteraction* interaction,
                                                             GTlsDatabaseLookupFlags flags,
                                                             GCancellable* cancellable,
                                                             GError** error)
{
	ApplicationTlsDatabase * self;
	GList* _tmp0_ = NULL;
	GTlsDatabase* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	GError* _inner_error0_ = NULL;
	GList* result;
#line 354 "../src/client/application/application-certificate-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_TLS_DATABASE, ApplicationTlsDatabase);
#line 354 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail (issuer_raw_dn != NULL, NULL);
#line 354 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail ((interaction == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (interaction, g_tls_interaction_get_type ()), NULL);
#line 354 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), NULL);
#line 360 "../src/client/application/application-certificate-manager.vala"
	_tmp1_ = self->priv->_parent;
#line 360 "../src/client/application/application-certificate-manager.vala"
	_tmp2_ = g_tls_database_lookup_certificates_issued_by (_tmp1_, issuer_raw_dn, interaction, flags, cancellable, &_inner_error0_);
#line 360 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = _tmp2_;
#line 360 "../src/client/application/application-certificate-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 360 "../src/client/application/application-certificate-manager.vala"
		g_propagate_error (error, _inner_error0_);
#line 360 "../src/client/application/application-certificate-manager.vala"
		return NULL;
#line 2634 "application-certificate-manager.c"
	}
#line 360 "../src/client/application/application-certificate-manager.vala"
	_tmp3_ = _tmp0_;
#line 360 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = NULL;
#line 360 "../src/client/application/application-certificate-manager.vala"
	result = _tmp3_;
#line 360 "../src/client/application/application-certificate-manager.vala"
	(_tmp0_ == NULL) ? NULL : (_tmp0_ = (_g_list_free__g_object_unref0_ (_tmp0_), NULL));
#line 360 "../src/client/application/application-certificate-manager.vala"
	return result;
#line 2646 "application-certificate-manager.c"
}

static void
application_tls_database_real_lookup_certificates_issued_by_async_data_free (gpointer _data)
{
	ApplicationTlsDatabaseLookupCertificatesIssuedByAsyncData* _data_;
	_data_ = _data;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_byte_array_unref0 (_data_->issuer_raw_dn);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->interaction);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 160 "../src/client/application/application-certificate-manager.vala"
	(_data_->result == NULL) ? NULL : (_data_->result = (_g_list_free__g_object_unref0_ (_data_->result), NULL));
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->self);
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_slice_free (ApplicationTlsDatabaseLookupCertificatesIssuedByAsyncData, _data_);
#line 2666 "application-certificate-manager.c"
}

static gpointer
_g_byte_array_ref0 (gpointer self)
{
#line 160 "../src/client/application/application-certificate-manager.vala"
	return self ? g_byte_array_ref (self) : NULL;
#line 2674 "application-certificate-manager.c"
}

static void
application_tls_database_real_lookup_certificates_issued_by_async (GTlsDatabase* base,
                                                                   GByteArray* issuer_raw_dn,
                                                                   GTlsInteraction* interaction,
                                                                   GTlsDatabaseLookupFlags flags,
                                                                   GCancellable* cancellable,
                                                                   GAsyncReadyCallback _callback_,
                                                                   gpointer _user_data_)
{
	ApplicationTlsDatabase * self;
	ApplicationTlsDatabaseLookupCertificatesIssuedByAsyncData* _data_;
	ApplicationTlsDatabase* _tmp0_;
	GByteArray* _tmp1_;
	GTlsInteraction* _tmp2_;
	GCancellable* _tmp3_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail (issuer_raw_dn != NULL);
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail ((interaction == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (interaction, g_tls_interaction_get_type ()));
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 160 "../src/client/application/application-certificate-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_TLS_DATABASE, ApplicationTlsDatabase);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_ = g_slice_new0 (ApplicationTlsDatabaseLookupCertificatesIssuedByAsyncData);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_tls_database_real_lookup_certificates_issued_by_async_data_free);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->self = _tmp0_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp1_ = _g_byte_array_ref0 (issuer_raw_dn);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_byte_array_unref0 (_data_->issuer_raw_dn);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->issuer_raw_dn = _tmp1_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp2_ = _g_object_ref0 (interaction);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->interaction);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->interaction = _tmp2_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->flags = flags;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->cancellable = _tmp3_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	application_tls_database_real_lookup_certificates_issued_by_async_co (_data_);
#line 2732 "application-certificate-manager.c"
}

static GList*
application_tls_database_lookup_certificates_issued_by_finish (GTlsDatabase* base,
                                                               GAsyncResult* _res_,
                                                               GError** error)
{
	GList* result;
	ApplicationTlsDatabaseLookupCertificatesIssuedByAsyncData* _data_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 160 "../src/client/application/application-certificate-manager.vala"
	if (NULL == _data_) {
#line 160 "../src/client/application/application-certificate-manager.vala"
		return NULL;
#line 2748 "application-certificate-manager.c"
	}
#line 160 "../src/client/application/application-certificate-manager.vala"
	result = _data_->result;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->result = NULL;
#line 160 "../src/client/application/application-certificate-manager.vala"
	return result;
#line 2756 "application-certificate-manager.c"
}

static void
application_tls_database_lookup_certificates_issued_by_async_ready (GObject* source_object,
                                                                    GAsyncResult* _res_,
                                                                    gpointer _user_data_)
{
	ApplicationTlsDatabaseLookupCertificatesIssuedByAsyncData* _data_;
#line 371 "../src/client/application/application-certificate-manager.vala"
	_data_ = _user_data_;
#line 371 "../src/client/application/application-certificate-manager.vala"
	_data_->_source_object_ = source_object;
#line 371 "../src/client/application/application-certificate-manager.vala"
	_data_->_res_ = _res_;
#line 371 "../src/client/application/application-certificate-manager.vala"
	application_tls_database_real_lookup_certificates_issued_by_async_co (_data_);
#line 2773 "application-certificate-manager.c"
}

static gboolean
application_tls_database_real_lookup_certificates_issued_by_async_co (ApplicationTlsDatabaseLookupCertificatesIssuedByAsyncData* _data_)
{
#line 365 "../src/client/application/application-certificate-manager.vala"
	switch (_data_->_state_) {
#line 365 "../src/client/application/application-certificate-manager.vala"
		case 0:
#line 2783 "application-certificate-manager.c"
		goto _state_0;
#line 365 "../src/client/application/application-certificate-manager.vala"
		case 1:
#line 2787 "application-certificate-manager.c"
		goto _state_1;
		default:
#line 365 "../src/client/application/application-certificate-manager.vala"
		g_assert_not_reached ();
#line 2792 "application-certificate-manager.c"
	}
	_state_0:
#line 371 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp1_ = _data_->self->priv->_parent;
#line 371 "../src/client/application/application-certificate-manager.vala"
	_data_->_state_ = 1;
#line 371 "../src/client/application/application-certificate-manager.vala"
	g_tls_database_lookup_certificates_issued_by_async (_data_->_tmp1_, _data_->issuer_raw_dn, _data_->interaction, _data_->flags, _data_->cancellable, application_tls_database_lookup_certificates_issued_by_async_ready, _data_);
#line 371 "../src/client/application/application-certificate-manager.vala"
	return FALSE;
#line 2803 "application-certificate-manager.c"
	_state_1:
#line 371 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp2_ = g_tls_database_lookup_certificates_issued_by_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error0_);
#line 371 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp0_ = _data_->_tmp2_;
#line 371 "../src/client/application/application-certificate-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 371 "../src/client/application/application-certificate-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 371 "../src/client/application/application-certificate-manager.vala"
		g_object_unref (_data_->_async_result);
#line 371 "../src/client/application/application-certificate-manager.vala"
		return FALSE;
#line 2817 "application-certificate-manager.c"
	}
#line 371 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp3_ = _data_->_tmp0_;
#line 371 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp0_ = NULL;
#line 371 "../src/client/application/application-certificate-manager.vala"
	_data_->result = _data_->_tmp3_;
#line 371 "../src/client/application/application-certificate-manager.vala"
	(_data_->_tmp0_ == NULL) ? NULL : (_data_->_tmp0_ = (_g_list_free__g_object_unref0_ (_data_->_tmp0_), NULL));
#line 371 "../src/client/application/application-certificate-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 371 "../src/client/application/application-certificate-manager.vala"
	if (_data_->_state_ != 0) {
#line 371 "../src/client/application/application-certificate-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 371 "../src/client/application/application-certificate-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2835 "application-certificate-manager.c"
		}
	}
#line 371 "../src/client/application/application-certificate-manager.vala"
	g_object_unref (_data_->_async_result);
#line 371 "../src/client/application/application-certificate-manager.vala"
	return FALSE;
#line 2842 "application-certificate-manager.c"
}

static GTlsCertificateFlags
application_tls_database_real_verify_chain (GTlsDatabase* base,
                                            GTlsCertificate* chain,
                                            const gchar* purpose,
                                            GSocketConnectable* identity,
                                            GTlsInteraction* interaction,
                                            GTlsDatabaseVerifyFlags flags,
                                            GCancellable* cancellable,
                                            GError** error)
{
	ApplicationTlsDatabase * self;
	GTlsCertificateFlags ret = 0U;
	GTlsDatabase* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	GTlsCertificateFlags result;
#line 376 "../src/client/application/application-certificate-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_TLS_DATABASE, ApplicationTlsDatabase);
#line 376 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (chain, g_tls_certificate_get_type ()), 0U);
#line 376 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail (purpose != NULL, 0U);
#line 376 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail ((identity == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (identity, g_socket_connectable_get_type ()), 0U);
#line 376 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail ((interaction == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (interaction, g_tls_interaction_get_type ()), 0U);
#line 376 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), 0U);
#line 384 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = self->priv->_parent;
#line 384 "../src/client/application/application-certificate-manager.vala"
	ret = g_tls_database_verify_chain (_tmp0_, chain, purpose, identity, interaction, flags, cancellable, &_inner_error0_);
#line 384 "../src/client/application/application-certificate-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 384 "../src/client/application/application-certificate-manager.vala"
		g_propagate_error (error, _inner_error0_);
#line 384 "../src/client/application/application-certificate-manager.vala"
		return 0U;
#line 2883 "application-certificate-manager.c"
	}
#line 387 "../src/client/application/application-certificate-manager.vala"
	if (application_tls_database_check_pinned (self, ret, purpose, identity)) {
#line 2887 "application-certificate-manager.c"
		gboolean _tmp2_ = FALSE;
#line 388 "../src/client/application/application-certificate-manager.vala"
		_tmp2_ = application_tls_database_is_pinned (self, chain, identity, cancellable, &_inner_error0_);
#line 388 "../src/client/application/application-certificate-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 388 "../src/client/application/application-certificate-manager.vala"
			g_propagate_error (error, _inner_error0_);
#line 388 "../src/client/application/application-certificate-manager.vala"
			return 0U;
#line 2897 "application-certificate-manager.c"
		}
#line 388 "../src/client/application/application-certificate-manager.vala"
		_tmp1_ = _tmp2_;
#line 2901 "application-certificate-manager.c"
	} else {
#line 387 "../src/client/application/application-certificate-manager.vala"
		_tmp1_ = FALSE;
#line 2905 "application-certificate-manager.c"
	}
#line 387 "../src/client/application/application-certificate-manager.vala"
	if (_tmp1_) {
#line 389 "../src/client/application/application-certificate-manager.vala"
		ret = 0;
#line 2911 "application-certificate-manager.c"
	}
#line 391 "../src/client/application/application-certificate-manager.vala"
	result = ret;
#line 391 "../src/client/application/application-certificate-manager.vala"
	return result;
#line 2917 "application-certificate-manager.c"
}

static void
application_tls_database_real_verify_chain_async_data_free (gpointer _data)
{
	ApplicationTlsDatabaseVerifyChainAsyncData* _data_;
	_data_ = _data;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->chain);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_free0 (_data_->purpose);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->identity);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->interaction);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->self);
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_slice_free (ApplicationTlsDatabaseVerifyChainAsyncData, _data_);
#line 2939 "application-certificate-manager.c"
}

static void
application_tls_database_real_verify_chain_async (GTlsDatabase* base,
                                                  GTlsCertificate* chain,
                                                  const gchar* purpose,
                                                  GSocketConnectable* identity,
                                                  GTlsInteraction* interaction,
                                                  GTlsDatabaseVerifyFlags flags,
                                                  GCancellable* cancellable,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_)
{
	ApplicationTlsDatabase * self;
	ApplicationTlsDatabaseVerifyChainAsyncData* _data_;
	ApplicationTlsDatabase* _tmp0_;
	GTlsCertificate* _tmp1_;
	gchar* _tmp2_;
	GSocketConnectable* _tmp3_;
	GTlsInteraction* _tmp4_;
	GCancellable* _tmp5_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (chain, g_tls_certificate_get_type ()));
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail (purpose != NULL);
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail ((identity == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (identity, g_socket_connectable_get_type ()));
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail ((interaction == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (interaction, g_tls_interaction_get_type ()));
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 160 "../src/client/application/application-certificate-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_TLS_DATABASE, ApplicationTlsDatabase);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_ = g_slice_new0 (ApplicationTlsDatabaseVerifyChainAsyncData);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_tls_database_real_verify_chain_async_data_free);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->self = _tmp0_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp1_ = _g_object_ref0 (chain);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->chain);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->chain = _tmp1_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp2_ = g_strdup (purpose);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_free0 (_data_->purpose);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->purpose = _tmp2_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp3_ = _g_object_ref0 (identity);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->identity);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->identity = _tmp3_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp4_ = _g_object_ref0 (interaction);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->interaction);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->interaction = _tmp4_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->flags = flags;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp5_ = _g_object_ref0 (cancellable);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->cancellable = _tmp5_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	application_tls_database_real_verify_chain_async_co (_data_);
#line 3017 "application-certificate-manager.c"
}

static GTlsCertificateFlags
application_tls_database_verify_chain_finish (GTlsDatabase* base,
                                              GAsyncResult* _res_,
                                              GError** error)
{
	GTlsCertificateFlags result;
	ApplicationTlsDatabaseVerifyChainAsyncData* _data_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 160 "../src/client/application/application-certificate-manager.vala"
	if (NULL == _data_) {
#line 160 "../src/client/application/application-certificate-manager.vala"
		return 0U;
#line 3033 "application-certificate-manager.c"
	}
#line 160 "../src/client/application/application-certificate-manager.vala"
	result = _data_->result;
#line 160 "../src/client/application/application-certificate-manager.vala"
	return result;
#line 3039 "application-certificate-manager.c"
}

static void
application_tls_database_verify_chain_async_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_)
{
	ApplicationTlsDatabaseVerifyChainAsyncData* _data_;
#line 402 "../src/client/application/application-certificate-manager.vala"
	_data_ = _user_data_;
#line 402 "../src/client/application/application-certificate-manager.vala"
	_data_->_source_object_ = source_object;
#line 402 "../src/client/application/application-certificate-manager.vala"
	_data_->_res_ = _res_;
#line 402 "../src/client/application/application-certificate-manager.vala"
	application_tls_database_real_verify_chain_async_co (_data_);
#line 3056 "application-certificate-manager.c"
}

static gboolean
application_tls_database_real_verify_chain_async_co (ApplicationTlsDatabaseVerifyChainAsyncData* _data_)
{
#line 394 "../src/client/application/application-certificate-manager.vala"
	switch (_data_->_state_) {
#line 394 "../src/client/application/application-certificate-manager.vala"
		case 0:
#line 3066 "application-certificate-manager.c"
		goto _state_0;
#line 394 "../src/client/application/application-certificate-manager.vala"
		case 1:
#line 3070 "application-certificate-manager.c"
		goto _state_1;
#line 394 "../src/client/application/application-certificate-manager.vala"
		case 2:
#line 3074 "application-certificate-manager.c"
		goto _state_2;
		default:
#line 394 "../src/client/application/application-certificate-manager.vala"
		g_assert_not_reached ();
#line 3079 "application-certificate-manager.c"
	}
	_state_0:
#line 402 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp0_ = _data_->self->priv->_parent;
#line 402 "../src/client/application/application-certificate-manager.vala"
	_data_->_state_ = 1;
#line 402 "../src/client/application/application-certificate-manager.vala"
	g_tls_database_verify_chain_async (_data_->_tmp0_, _data_->chain, _data_->purpose, _data_->identity, _data_->interaction, _data_->flags, _data_->cancellable, application_tls_database_verify_chain_async_ready, _data_);
#line 402 "../src/client/application/application-certificate-manager.vala"
	return FALSE;
#line 3090 "application-certificate-manager.c"
	_state_1:
#line 402 "../src/client/application/application-certificate-manager.vala"
	_data_->ret = g_tls_database_verify_chain_finish (_data_->_tmp0_, _data_->_res_, &_data_->_inner_error0_);
#line 402 "../src/client/application/application-certificate-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 402 "../src/client/application/application-certificate-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 402 "../src/client/application/application-certificate-manager.vala"
		g_object_unref (_data_->_async_result);
#line 402 "../src/client/application/application-certificate-manager.vala"
		return FALSE;
#line 3102 "application-certificate-manager.c"
	}
#line 405 "../src/client/application/application-certificate-manager.vala"
	if (application_tls_database_check_pinned (_data_->self, _data_->ret, _data_->purpose, _data_->identity)) {
#line 406 "../src/client/application/application-certificate-manager.vala"
		_data_->_state_ = 2;
#line 406 "../src/client/application/application-certificate-manager.vala"
		application_tls_database_is_pinned_async (_data_->self, _data_->chain, _data_->identity, _data_->cancellable, application_tls_database_verify_chain_async_ready, _data_);
#line 406 "../src/client/application/application-certificate-manager.vala"
		return FALSE;
#line 3112 "application-certificate-manager.c"
		_state_2:
#line 406 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp2_ = application_tls_database_is_pinned_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 406 "../src/client/application/application-certificate-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 406 "../src/client/application/application-certificate-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 406 "../src/client/application/application-certificate-manager.vala"
			g_object_unref (_data_->_async_result);
#line 406 "../src/client/application/application-certificate-manager.vala"
			return FALSE;
#line 3124 "application-certificate-manager.c"
		}
#line 406 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp1_ = _data_->_tmp2_;
#line 3128 "application-certificate-manager.c"
	} else {
#line 405 "../src/client/application/application-certificate-manager.vala"
		_data_->_tmp1_ = FALSE;
#line 3132 "application-certificate-manager.c"
	}
#line 405 "../src/client/application/application-certificate-manager.vala"
	if (_data_->_tmp1_) {
#line 407 "../src/client/application/application-certificate-manager.vala"
		_data_->ret = 0;
#line 3138 "application-certificate-manager.c"
	}
#line 409 "../src/client/application/application-certificate-manager.vala"
	_data_->result = _data_->ret;
#line 409 "../src/client/application/application-certificate-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 409 "../src/client/application/application-certificate-manager.vala"
	if (_data_->_state_ != 0) {
#line 409 "../src/client/application/application-certificate-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 409 "../src/client/application/application-certificate-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3150 "application-certificate-manager.c"
		}
	}
#line 409 "../src/client/application/application-certificate-manager.vala"
	g_object_unref (_data_->_async_result);
#line 409 "../src/client/application/application-certificate-manager.vala"
	return FALSE;
#line 3157 "application-certificate-manager.c"
}

static inline gboolean
application_tls_database_check_pinned (ApplicationTlsDatabase* self,
                                       GTlsCertificateFlags parent_ret,
                                       const gchar* purpose,
                                       GSocketConnectable* identity)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result;
#line 412 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail (APPLICATION_IS_TLS_DATABASE (self), FALSE);
#line 412 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail (purpose != NULL, FALSE);
#line 412 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail ((identity == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (identity, g_socket_connectable_get_type ()), FALSE);
#line 419 "../src/client/application/application-certificate-manager.vala"
	if (parent_ret != 0) {
#line 420 "../src/client/application/application-certificate-manager.vala"
		_tmp2_ = !((parent_ret & G_TLS_CERTIFICATE_REVOKED) == G_TLS_CERTIFICATE_REVOKED);
#line 3180 "application-certificate-manager.c"
	} else {
#line 419 "../src/client/application/application-certificate-manager.vala"
		_tmp2_ = FALSE;
#line 3184 "application-certificate-manager.c"
	}
#line 419 "../src/client/application/application-certificate-manager.vala"
	if (_tmp2_) {
#line 421 "../src/client/application/application-certificate-manager.vala"
		_tmp1_ = g_strcmp0 (purpose, G_TLS_DATABASE_PURPOSE_AUTHENTICATE_SERVER) == 0;
#line 3190 "application-certificate-manager.c"
	} else {
#line 419 "../src/client/application/application-certificate-manager.vala"
		_tmp1_ = FALSE;
#line 3194 "application-certificate-manager.c"
	}
#line 418 "../src/client/application/application-certificate-manager.vala"
	if (_tmp1_) {
#line 422 "../src/client/application/application-certificate-manager.vala"
		_tmp0_ = identity != NULL;
#line 3200 "application-certificate-manager.c"
	} else {
#line 419 "../src/client/application/application-certificate-manager.vala"
		_tmp0_ = FALSE;
#line 3204 "application-certificate-manager.c"
	}
#line 418 "../src/client/application/application-certificate-manager.vala"
	result = _tmp0_;
#line 418 "../src/client/application/application-certificate-manager.vala"
	return result;
#line 3210 "application-certificate-manager.c"
}

static gboolean
application_tls_database_is_pinned (ApplicationTlsDatabase* self,
                                    GTlsCertificate* chain,
                                    GSocketConnectable* identity,
                                    GCancellable* cancellable,
                                    GError** error)
{
	gboolean is_pinned = FALSE;
	gchar* id = NULL;
	gchar* _tmp0_;
	ApplicationTlsDatabaseTrustContext* context = NULL;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 426 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail (APPLICATION_IS_TLS_DATABASE (self), FALSE);
#line 426 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (chain, g_tls_certificate_get_type ()), FALSE);
#line 426 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (identity, g_socket_connectable_get_type ()), FALSE);
#line 426 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), FALSE);
#line 430 "../src/client/application/application-certificate-manager.vala"
	is_pinned = FALSE;
#line 431 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = application_tls_database_to_name (identity);
#line 431 "../src/client/application/application-certificate-manager.vala"
	id = _tmp0_;
#line 432 "../src/client/application/application-certificate-manager.vala"
	context = NULL;
#line 3242 "application-certificate-manager.c"
	{
		GeeMap* _tmp1_;
#line 433 "../src/client/application/application-certificate-manager.vala"
		_tmp1_ = self->priv->pinned_certs;
#line 433 "../src/client/application/application-certificate-manager.vala"
		g_rec_mutex_lock (&self->priv->__lock_pinned_certs);
#line 3249 "application-certificate-manager.c"
		{
			GeeMap* _tmp2_;
			const gchar* _tmp3_;
			gpointer _tmp4_;
			ApplicationTlsDatabaseTrustContext* _tmp5_;
#line 434 "../src/client/application/application-certificate-manager.vala"
			_tmp2_ = self->priv->pinned_certs;
#line 434 "../src/client/application/application-certificate-manager.vala"
			_tmp3_ = id;
#line 434 "../src/client/application/application-certificate-manager.vala"
			_tmp4_ = gee_map_get (_tmp2_, _tmp3_);
#line 434 "../src/client/application/application-certificate-manager.vala"
			_g_object_unref0 (context);
#line 434 "../src/client/application/application-certificate-manager.vala"
			context = (ApplicationTlsDatabaseTrustContext*) _tmp4_;
#line 435 "../src/client/application/application-certificate-manager.vala"
			_tmp5_ = context;
#line 435 "../src/client/application/application-certificate-manager.vala"
			if (_tmp5_ != NULL) {
#line 3269 "application-certificate-manager.c"
				ApplicationTlsDatabaseTrustContext* _tmp6_;
				GTlsCertificate* _tmp7_;
#line 436 "../src/client/application/application-certificate-manager.vala"
				_tmp6_ = context;
#line 436 "../src/client/application/application-certificate-manager.vala"
				_tmp7_ = _tmp6_->certificate;
#line 436 "../src/client/application/application-certificate-manager.vala"
				is_pinned = g_tls_certificate_is_same (_tmp7_, chain);
#line 3278 "application-certificate-manager.c"
			} else {
#line 440 "../src/client/application/application-certificate-manager.vala"
				if (self->priv->use_gcr) {
#line 3282 "application-certificate-manager.c"
					gboolean _tmp8_ = FALSE;
					GByteArray* _tmp9_;
					GByteArray* _tmp10_;
					GByteArray* _tmp11_;
					guint8* _tmp12_;
					gint _tmp12__length1;
					GcrSimpleCertificate* _tmp13_;
					GcrSimpleCertificate* _tmp14_;
					const gchar* _tmp15_;
					gboolean _tmp16_;
#line 441 "../src/client/application/application-certificate-manager.vala"
					g_object_get (chain, "certificate", &_tmp9_, NULL);
#line 441 "../src/client/application/application-certificate-manager.vala"
					_tmp10_ = _tmp9_;
#line 441 "../src/client/application/application-certificate-manager.vala"
					_tmp11_ = _tmp10_;
#line 441 "../src/client/application/application-certificate-manager.vala"
					_tmp12_ = _tmp11_->data;
#line 441 "../src/client/application/application-certificate-manager.vala"
					_tmp12__length1 = _tmp11_->len;
#line 441 "../src/client/application/application-certificate-manager.vala"
					_tmp13_ = (GcrSimpleCertificate*) gcr_simple_certificate_new (_tmp12_, _tmp12__length1);
#line 441 "../src/client/application/application-certificate-manager.vala"
					_tmp14_ = _tmp13_;
#line 441 "../src/client/application/application-certificate-manager.vala"
					_tmp15_ = id;
#line 441 "../src/client/application/application-certificate-manager.vala"
					_tmp16_ = gcr_trust_is_certificate_pinned (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gcr_certificate_get_type (), GcrCertificate), G_TLS_DATABASE_PURPOSE_AUTHENTICATE_SERVER, _tmp15_, cancellable, &_inner_error0_);
#line 441 "../src/client/application/application-certificate-manager.vala"
					_g_object_unref0 (_tmp14_);
#line 441 "../src/client/application/application-certificate-manager.vala"
					_g_byte_array_unref0 (_tmp11_);
#line 441 "../src/client/application/application-certificate-manager.vala"
					_tmp8_ = _tmp16_;
#line 441 "../src/client/application/application-certificate-manager.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3319 "application-certificate-manager.c"
						goto __catch0_g_error;
					}
#line 441 "../src/client/application/application-certificate-manager.vala"
					is_pinned = _tmp8_;
#line 3324 "application-certificate-manager.c"
				}
#line 449 "../src/client/application/application-certificate-manager.vala"
				if (!is_pinned) {
#line 3328 "application-certificate-manager.c"
					{
						ApplicationTlsDatabaseTrustContext* _tmp17_ = NULL;
						GFile* _tmp18_;
						const gchar* _tmp19_;
						ApplicationTlsDatabaseTrustContext* _tmp20_;
						ApplicationTlsDatabaseTrustContext* _tmp21_;
						GeeMap* _tmp22_;
						const gchar* _tmp23_;
						ApplicationTlsDatabaseTrustContext* _tmp24_;
						ApplicationTlsDatabaseTrustContext* _tmp25_;
						GTlsCertificate* _tmp26_;
#line 455 "../src/client/application/application-certificate-manager.vala"
						_tmp18_ = self->priv->store_dir;
#line 455 "../src/client/application/application-certificate-manager.vala"
						_tmp19_ = id;
#line 455 "../src/client/application/application-certificate-manager.vala"
						_tmp20_ = application_tls_database_trust_context_new_lookup (_tmp18_, _tmp19_, cancellable, &_inner_error0_);
#line 455 "../src/client/application/application-certificate-manager.vala"
						_tmp17_ = _tmp20_;
#line 455 "../src/client/application/application-certificate-manager.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 455 "../src/client/application/application-certificate-manager.vala"
							if (g_error_matches (_inner_error0_, G_IO_ERROR, G_IO_ERROR_NOT_FOUND)) {
#line 3352 "application-certificate-manager.c"
								goto __catch1_g_io_error_not_found;
							}
							goto __catch1_g_error;
						}
#line 455 "../src/client/application/application-certificate-manager.vala"
						_tmp21_ = _tmp17_;
#line 455 "../src/client/application/application-certificate-manager.vala"
						_tmp17_ = NULL;
#line 455 "../src/client/application/application-certificate-manager.vala"
						_g_object_unref0 (context);
#line 455 "../src/client/application/application-certificate-manager.vala"
						context = _tmp21_;
#line 458 "../src/client/application/application-certificate-manager.vala"
						_tmp22_ = self->priv->pinned_certs;
#line 458 "../src/client/application/application-certificate-manager.vala"
						_tmp23_ = id;
#line 458 "../src/client/application/application-certificate-manager.vala"
						_tmp24_ = context;
#line 458 "../src/client/application/application-certificate-manager.vala"
						gee_map_set (_tmp22_, _tmp23_, _tmp24_);
#line 459 "../src/client/application/application-certificate-manager.vala"
						_tmp25_ = context;
#line 459 "../src/client/application/application-certificate-manager.vala"
						_tmp26_ = _tmp25_->certificate;
#line 459 "../src/client/application/application-certificate-manager.vala"
						is_pinned = g_tls_certificate_is_same (_tmp26_, chain);
#line 454 "../src/client/application/application-certificate-manager.vala"
						_g_object_unref0 (_tmp17_);
#line 3381 "application-certificate-manager.c"
					}
					goto __finally1;
					__catch1_g_io_error_not_found:
					{
#line 454 "../src/client/application/application-certificate-manager.vala"
						g_clear_error (&_inner_error0_);
#line 3388 "application-certificate-manager.c"
					}
					goto __finally1;
					__catch1_g_error:
					{
						GError* err = NULL;
						GearyErrorContext* err_context = NULL;
						GError* _tmp27_;
						GearyErrorContext* _tmp28_;
						GearyErrorContext* _tmp29_;
						gchar* _tmp30_;
						gchar* _tmp31_;
#line 454 "../src/client/application/application-certificate-manager.vala"
						err = _inner_error0_;
#line 454 "../src/client/application/application-certificate-manager.vala"
						_inner_error0_ = NULL;
#line 463 "../src/client/application/application-certificate-manager.vala"
						_tmp27_ = err;
#line 463 "../src/client/application/application-certificate-manager.vala"
						_tmp28_ = geary_error_context_new (_tmp27_);
#line 463 "../src/client/application/application-certificate-manager.vala"
						err_context = _tmp28_;
#line 465 "../src/client/application/application-certificate-manager.vala"
						_tmp29_ = err_context;
#line 465 "../src/client/application/application-certificate-manager.vala"
						_tmp30_ = geary_error_context_format_full_error (_tmp29_);
#line 465 "../src/client/application/application-certificate-manager.vala"
						_tmp31_ = _tmp30_;
#line 465 "../src/client/application/application-certificate-manager.vala"
						g_debug ("application-certificate-manager.vala:465: Error loading pinned certifi" \
"cate: %s", _tmp31_);
#line 465 "../src/client/application/application-certificate-manager.vala"
						_g_free0 (_tmp31_);
#line 454 "../src/client/application/application-certificate-manager.vala"
						_g_object_unref0 (err_context);
#line 454 "../src/client/application/application-certificate-manager.vala"
						_g_error_free0 (err);
#line 3424 "application-certificate-manager.c"
					}
					__finally1:
#line 454 "../src/client/application/application-certificate-manager.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3429 "application-certificate-manager.c"
						goto __catch0_g_error;
					}
				}
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* _lock_error_ = NULL;
			GError* _tmp32_;
#line 433 "../src/client/application/application-certificate-manager.vala"
			_lock_error_ = _inner_error0_;
#line 433 "../src/client/application/application-certificate-manager.vala"
			_inner_error0_ = NULL;
#line 433 "../src/client/application/application-certificate-manager.vala"
			_tmp32_ = _lock_error_;
#line 433 "../src/client/application/application-certificate-manager.vala"
			_lock_error_ = NULL;
#line 433 "../src/client/application/application-certificate-manager.vala"
			_inner_error0_ = _tmp32_;
#line 433 "../src/client/application/application-certificate-manager.vala"
			_g_error_free0 (_lock_error_);
#line 3452 "application-certificate-manager.c"
			goto __finally0;
		}
		__finally0:
		{
			GError* _inner_error1_ = NULL;
			GeeMap* _tmp33_;
#line 433 "../src/client/application/application-certificate-manager.vala"
			_tmp33_ = self->priv->pinned_certs;
#line 433 "../src/client/application/application-certificate-manager.vala"
			g_rec_mutex_unlock (&self->priv->__lock_pinned_certs);
#line 3463 "application-certificate-manager.c"
		}
#line 433 "../src/client/application/application-certificate-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3467 "application-certificate-manager.c"
			gboolean _tmp34_ = FALSE;
#line 433 "../src/client/application/application-certificate-manager.vala"
			g_propagate_error (error, _inner_error0_);
#line 433 "../src/client/application/application-certificate-manager.vala"
			_g_object_unref0 (context);
#line 433 "../src/client/application/application-certificate-manager.vala"
			_g_free0 (id);
#line 433 "../src/client/application/application-certificate-manager.vala"
			return _tmp34_;
#line 3477 "application-certificate-manager.c"
		}
	}
#line 471 "../src/client/application/application-certificate-manager.vala"
	result = is_pinned;
#line 471 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (context);
#line 471 "../src/client/application/application-certificate-manager.vala"
	_g_free0 (id);
#line 471 "../src/client/application/application-certificate-manager.vala"
	return result;
#line 3488 "application-certificate-manager.c"
}

static void
application_tls_database_is_pinned_async_data_free (gpointer _data)
{
	ApplicationTlsDatabaseIsPinnedAsyncData* _data_;
	_data_ = _data;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->self);
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_slice_free (ApplicationTlsDatabaseIsPinnedAsyncData, _data_);
#line 3500 "application-certificate-manager.c"
}

static void
application_tls_database_is_pinned_async (ApplicationTlsDatabase* self,
                                          GTlsCertificate* chain,
                                          GSocketConnectable* identity,
                                          GCancellable* cancellable,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	ApplicationTlsDatabaseIsPinnedAsyncData* _data_;
	ApplicationTlsDatabase* _tmp0_;
	GTlsCertificate* _tmp1_;
	GSocketConnectable* _tmp2_;
	GCancellable* _tmp3_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail (APPLICATION_IS_TLS_DATABASE (self));
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (chain, g_tls_certificate_get_type ()));
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (identity, g_socket_connectable_get_type ()));
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_ = g_slice_new0 (ApplicationTlsDatabaseIsPinnedAsyncData);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_tls_database_is_pinned_async_data_free);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->self = _tmp0_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp1_ = _g_object_ref0 (chain);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->chain);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->chain = _tmp1_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp2_ = _g_object_ref0 (identity);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->identity);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->identity = _tmp2_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_->cancellable = _tmp3_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	application_tls_database_is_pinned_async_co (_data_);
#line 3554 "application-certificate-manager.c"
}

static gboolean
application_tls_database_is_pinned_finish (ApplicationTlsDatabase* self,
                                           GAsyncResult* _res_,
                                           GError** error)
{
	gboolean result;
	ApplicationTlsDatabaseIsPinnedAsyncData* _data_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 160 "../src/client/application/application-certificate-manager.vala"
	if (NULL == _data_) {
#line 3568 "application-certificate-manager.c"
		gboolean _tmp0_ = FALSE;
#line 160 "../src/client/application/application-certificate-manager.vala"
		return _tmp0_;
#line 3572 "application-certificate-manager.c"
	}
#line 160 "../src/client/application/application-certificate-manager.vala"
	result = _data_->result;
#line 160 "../src/client/application/application-certificate-manager.vala"
	return result;
#line 3578 "application-certificate-manager.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 474 "../src/client/application/application-certificate-manager.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 474 "../src/client/application/application-certificate-manager.vala"
	return _data2_;
#line 3588 "application-certificate-manager.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 474 "../src/client/application/application-certificate-manager.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 3598 "application-certificate-manager.c"
		ApplicationTlsDatabase* self;
#line 474 "../src/client/application/application-certificate-manager.vala"
		self = _data2_->self;
#line 474 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (_data2_->chain);
#line 474 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (_data2_->identity);
#line 474 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (_data2_->cancellable);
#line 474 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (self);
#line 474 "../src/client/application/application-certificate-manager.vala"
		g_slice_free (Block2Data, _data2_);
#line 3612 "application-certificate-manager.c"
	}
}

static void
__lambda52_ (Block2Data* _data2_,
             GError** error)
{
	ApplicationTlsDatabase* self;
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 479 "../src/client/application/application-certificate-manager.vala"
	self = _data2_->self;
#line 480 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = application_tls_database_is_pinned (self, _data2_->chain, _data2_->identity, _data2_->cancellable, &_inner_error0_);
#line 480 "../src/client/application/application-certificate-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 480 "../src/client/application/application-certificate-manager.vala"
		g_propagate_error (error, _inner_error0_);
#line 480 "../src/client/application/application-certificate-manager.vala"
		return;
#line 3633 "application-certificate-manager.c"
	}
#line 480 "../src/client/application/application-certificate-manager.vala"
	_data2_->pinned = _tmp0_;
#line 3637 "application-certificate-manager.c"
}

static void
___lambda52__geary_nonblocking_concurrent_concurrent_callback (GCancellable* cancellable,
                                                               gpointer self,
                                                               GError** error)
{
#line 479 "../src/client/application/application-certificate-manager.vala"
	__lambda52_ (self, error);
#line 3647 "application-certificate-manager.c"
}

static void
application_tls_database_is_pinned_async_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_)
{
	ApplicationTlsDatabaseIsPinnedAsyncData* _data_;
#line 479 "../src/client/application/application-certificate-manager.vala"
	_data_ = _user_data_;
#line 479 "../src/client/application/application-certificate-manager.vala"
	_data_->_source_object_ = source_object;
#line 479 "../src/client/application/application-certificate-manager.vala"
	_data_->_res_ = _res_;
#line 479 "../src/client/application/application-certificate-manager.vala"
	application_tls_database_is_pinned_async_co (_data_);
#line 3664 "application-certificate-manager.c"
}

static gboolean
application_tls_database_is_pinned_async_co (ApplicationTlsDatabaseIsPinnedAsyncData* _data_)
{
#line 474 "../src/client/application/application-certificate-manager.vala"
	switch (_data_->_state_) {
#line 474 "../src/client/application/application-certificate-manager.vala"
		case 0:
#line 3674 "application-certificate-manager.c"
		goto _state_0;
#line 474 "../src/client/application/application-certificate-manager.vala"
		case 1:
#line 3678 "application-certificate-manager.c"
		goto _state_1;
		default:
#line 474 "../src/client/application/application-certificate-manager.vala"
		g_assert_not_reached ();
#line 3683 "application-certificate-manager.c"
	}
	_state_0:
#line 474 "../src/client/application/application-certificate-manager.vala"
	_data_->_data2_ = g_slice_new0 (Block2Data);
#line 474 "../src/client/application/application-certificate-manager.vala"
	_data_->_data2_->_ref_count_ = 1;
#line 474 "../src/client/application/application-certificate-manager.vala"
	_data_->_data2_->self = g_object_ref (_data_->self);
#line 474 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->_data2_->chain);
#line 474 "../src/client/application/application-certificate-manager.vala"
	_data_->_data2_->chain = _data_->chain;
#line 474 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->_data2_->identity);
#line 474 "../src/client/application/application-certificate-manager.vala"
	_data_->_data2_->identity = _data_->identity;
#line 474 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->_data2_->cancellable);
#line 474 "../src/client/application/application-certificate-manager.vala"
	_data_->_data2_->cancellable = _data_->cancellable;
#line 474 "../src/client/application/application-certificate-manager.vala"
	_data_->_data2_->_async_data_ = _data_;
#line 478 "../src/client/application/application-certificate-manager.vala"
	_data_->_data2_->pinned = FALSE;
#line 479 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp0_ = geary_nonblocking_concurrent_get_global ();
#line 479 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 479 "../src/client/application/application-certificate-manager.vala"
	_data_->_state_ = 1;
#line 479 "../src/client/application/application-certificate-manager.vala"
	geary_nonblocking_concurrent_schedule_async (_data_->_tmp1_, ___lambda52__geary_nonblocking_concurrent_concurrent_callback, _data_->_data2_, _data_->_data2_->cancellable, application_tls_database_is_pinned_async_ready, _data_);
#line 479 "../src/client/application/application-certificate-manager.vala"
	return FALSE;
#line 3718 "application-certificate-manager.c"
	_state_1:
#line 479 "../src/client/application/application-certificate-manager.vala"
	geary_nonblocking_concurrent_schedule_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error0_);
#line 479 "../src/client/application/application-certificate-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 479 "../src/client/application/application-certificate-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 479 "../src/client/application/application-certificate-manager.vala"
		block2_data_unref (_data_->_data2_);
#line 479 "../src/client/application/application-certificate-manager.vala"
		_data_->_data2_ = NULL;
#line 479 "../src/client/application/application-certificate-manager.vala"
		g_object_unref (_data_->_async_result);
#line 479 "../src/client/application/application-certificate-manager.vala"
		return FALSE;
#line 3734 "application-certificate-manager.c"
	}
#line 482 "../src/client/application/application-certificate-manager.vala"
	_data_->result = _data_->_data2_->pinned;
#line 482 "../src/client/application/application-certificate-manager.vala"
	block2_data_unref (_data_->_data2_);
#line 482 "../src/client/application/application-certificate-manager.vala"
	_data_->_data2_ = NULL;
#line 482 "../src/client/application/application-certificate-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 482 "../src/client/application/application-certificate-manager.vala"
	if (_data_->_state_ != 0) {
#line 482 "../src/client/application/application-certificate-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 482 "../src/client/application/application-certificate-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3750 "application-certificate-manager.c"
		}
	}
#line 482 "../src/client/application/application-certificate-manager.vala"
	g_object_unref (_data_->_async_result);
#line 482 "../src/client/application/application-certificate-manager.vala"
	return FALSE;
#line 3757 "application-certificate-manager.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 485 "../src/client/application/application-certificate-manager.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 485 "../src/client/application/application-certificate-manager.vala"
	return _data3_;
#line 3767 "application-certificate-manager.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 485 "../src/client/application/application-certificate-manager.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 3777 "application-certificate-manager.c"
		ApplicationTlsDatabase* self;
#line 485 "../src/client/application/application-certificate-manager.vala"
		self = _data3_->self;
#line 485 "../src/client/application/application-certificate-manager.vala"
		_g_free0 (_data3_->id);
#line 485 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (self);
#line 485 "../src/client/application/application-certificate-manager.vala"
		g_slice_free (Block3Data, _data3_);
#line 3787 "application-certificate-manager.c"
	}
}

static gboolean
___lambda51_ (Block3Data* _data3_,
              ApplicationTlsDatabaseTrustContext* ctx)
{
	ApplicationTlsDatabase* self;
	const gchar* _tmp0_;
	gboolean result;
#line 488 "../src/client/application/application-certificate-manager.vala"
	self = _data3_->self;
#line 488 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail (APPLICATION_TLS_DATABASE_IS_TRUST_CONTEXT (ctx), FALSE);
#line 488 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = ctx->id;
#line 488 "../src/client/application/application-certificate-manager.vala"
	result = g_strcmp0 (_tmp0_, _data3_->id) == 0;
#line 488 "../src/client/application/application-certificate-manager.vala"
	return result;
#line 3808 "application-certificate-manager.c"
}

static gboolean
____lambda51__gee_predicate (gconstpointer g,
                             gpointer self)
{
	gboolean result;
	result = ___lambda51_ (self, (ApplicationTlsDatabaseTrustContext*) g);
#line 487 "../src/client/application/application-certificate-manager.vala"
	return result;
#line 3819 "application-certificate-manager.c"
}

static ApplicationTlsDatabaseTrustContext*
application_tls_database_lookup_id (ApplicationTlsDatabase* self,
                                    const gchar* id)
{
	Block3Data* _data3_;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
	ApplicationTlsDatabaseTrustContext* result;
#line 485 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail (APPLICATION_IS_TLS_DATABASE (self), NULL);
#line 485 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 485 "../src/client/application/application-certificate-manager.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 485 "../src/client/application/application-certificate-manager.vala"
	_data3_->_ref_count_ = 1;
#line 485 "../src/client/application/application-certificate-manager.vala"
	_data3_->self = g_object_ref (self);
#line 485 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = g_strdup (id);
#line 485 "../src/client/application/application-certificate-manager.vala"
	_g_free0 (_data3_->id);
#line 485 "../src/client/application/application-certificate-manager.vala"
	_data3_->id = _tmp0_;
#line 3846 "application-certificate-manager.c"
	{
		GeeMap* _tmp1_;
#line 486 "../src/client/application/application-certificate-manager.vala"
		_tmp1_ = self->priv->pinned_certs;
#line 486 "../src/client/application/application-certificate-manager.vala"
		g_rec_mutex_lock (&self->priv->__lock_pinned_certs);
#line 3853 "application-certificate-manager.c"
		{
			GeeMap* _tmp2_;
			GeeCollection* _tmp3_;
			GeeCollection* _tmp4_;
			GeeCollection* _tmp5_;
			GearyIterable* _tmp6_;
			GearyIterable* _tmp7_;
			gpointer _tmp8_;
			ApplicationTlsDatabaseTrustContext* _tmp9_;
#line 487 "../src/client/application/application-certificate-manager.vala"
			_tmp2_ = self->priv->pinned_certs;
#line 487 "../src/client/application/application-certificate-manager.vala"
			_tmp3_ = gee_map_get_values (_tmp2_);
#line 487 "../src/client/application/application-certificate-manager.vala"
			_tmp4_ = _tmp3_;
#line 487 "../src/client/application/application-certificate-manager.vala"
			_tmp5_ = _tmp4_;
#line 487 "../src/client/application/application-certificate-manager.vala"
			_tmp6_ = geary_traverse (APPLICATION_TLS_DATABASE_TYPE_TRUST_CONTEXT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ITERABLE, GeeIterable));
#line 487 "../src/client/application/application-certificate-manager.vala"
			_tmp7_ = _tmp6_;
#line 487 "../src/client/application/application-certificate-manager.vala"
			_tmp8_ = geary_iterable_first_matching (_tmp7_, ____lambda51__gee_predicate, block3_data_ref (_data3_), block3_data_unref);
#line 487 "../src/client/application/application-certificate-manager.vala"
			_tmp9_ = (ApplicationTlsDatabaseTrustContext*) _tmp8_;
#line 487 "../src/client/application/application-certificate-manager.vala"
			_g_object_unref0 (_tmp7_);
#line 487 "../src/client/application/application-certificate-manager.vala"
			_g_object_unref0 (_tmp5_);
#line 487 "../src/client/application/application-certificate-manager.vala"
			result = _tmp9_;
#line 3885 "application-certificate-manager.c"
			{
				GeeMap* _tmp10_;
#line 486 "../src/client/application/application-certificate-manager.vala"
				_tmp10_ = self->priv->pinned_certs;
#line 486 "../src/client/application/application-certificate-manager.vala"
				g_rec_mutex_unlock (&self->priv->__lock_pinned_certs);
#line 3892 "application-certificate-manager.c"
			}
#line 487 "../src/client/application/application-certificate-manager.vala"
			block3_data_unref (_data3_);
#line 487 "../src/client/application/application-certificate-manager.vala"
			_data3_ = NULL;
#line 487 "../src/client/application/application-certificate-manager.vala"
			return result;
#line 3900 "application-certificate-manager.c"
		}
		__finally0:
		{
			GeeMap* _tmp11_;
#line 486 "../src/client/application/application-certificate-manager.vala"
			_tmp11_ = self->priv->pinned_certs;
#line 486 "../src/client/application/application-certificate-manager.vala"
			g_rec_mutex_unlock (&self->priv->__lock_pinned_certs);
#line 3909 "application-certificate-manager.c"
		}
#line 486 "../src/client/application/application-certificate-manager.vala"
		block3_data_unref (_data3_);
#line 486 "../src/client/application/application-certificate-manager.vala"
		_data3_ = NULL;
#line 486 "../src/client/application/application-certificate-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 486 "../src/client/application/application-certificate-manager.vala"
		g_clear_error (&_inner_error0_);
#line 486 "../src/client/application/application-certificate-manager.vala"
		return NULL;
#line 3921 "application-certificate-manager.c"
	}
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 493 "../src/client/application/application-certificate-manager.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 493 "../src/client/application/application-certificate-manager.vala"
	return _data4_;
#line 3932 "application-certificate-manager.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 493 "../src/client/application/application-certificate-manager.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 3942 "application-certificate-manager.c"
		ApplicationTlsDatabase* self;
#line 493 "../src/client/application/application-certificate-manager.vala"
		self = _data4_->self;
#line 493 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (_data4_->cert);
#line 493 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (self);
#line 493 "../src/client/application/application-certificate-manager.vala"
		g_slice_free (Block4Data, _data4_);
#line 3952 "application-certificate-manager.c"
	}
}

static gboolean
___lambda50_ (Block4Data* _data4_,
              ApplicationTlsDatabaseTrustContext* ctx)
{
	ApplicationTlsDatabase* self;
	GTlsCertificate* _tmp0_;
	gboolean result;
#line 496 "../src/client/application/application-certificate-manager.vala"
	self = _data4_->self;
#line 496 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail (APPLICATION_TLS_DATABASE_IS_TRUST_CONTEXT (ctx), FALSE);
#line 496 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = ctx->certificate;
#line 496 "../src/client/application/application-certificate-manager.vala"
	result = g_tls_certificate_is_same (_tmp0_, _data4_->cert);
#line 496 "../src/client/application/application-certificate-manager.vala"
	return result;
#line 3973 "application-certificate-manager.c"
}

static gboolean
____lambda50__gee_predicate (gconstpointer g,
                             gpointer self)
{
	gboolean result;
	result = ___lambda50_ (self, (ApplicationTlsDatabaseTrustContext*) g);
#line 495 "../src/client/application/application-certificate-manager.vala"
	return result;
#line 3984 "application-certificate-manager.c"
}

static ApplicationTlsDatabaseTrustContext*
application_tls_database_lookup_tls_certificate (ApplicationTlsDatabase* self,
                                                 GTlsCertificate* cert)
{
	Block4Data* _data4_;
	GTlsCertificate* _tmp0_;
	GError* _inner_error0_ = NULL;
	ApplicationTlsDatabaseTrustContext* result;
#line 493 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail (APPLICATION_IS_TLS_DATABASE (self), NULL);
#line 493 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cert, g_tls_certificate_get_type ()), NULL);
#line 493 "../src/client/application/application-certificate-manager.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 493 "../src/client/application/application-certificate-manager.vala"
	_data4_->_ref_count_ = 1;
#line 493 "../src/client/application/application-certificate-manager.vala"
	_data4_->self = g_object_ref (self);
#line 493 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = _g_object_ref0 (cert);
#line 493 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data4_->cert);
#line 493 "../src/client/application/application-certificate-manager.vala"
	_data4_->cert = _tmp0_;
#line 4011 "application-certificate-manager.c"
	{
		GeeMap* _tmp1_;
#line 494 "../src/client/application/application-certificate-manager.vala"
		_tmp1_ = self->priv->pinned_certs;
#line 494 "../src/client/application/application-certificate-manager.vala"
		g_rec_mutex_lock (&self->priv->__lock_pinned_certs);
#line 4018 "application-certificate-manager.c"
		{
			GeeMap* _tmp2_;
			GeeCollection* _tmp3_;
			GeeCollection* _tmp4_;
			GeeCollection* _tmp5_;
			GearyIterable* _tmp6_;
			GearyIterable* _tmp7_;
			gpointer _tmp8_;
			ApplicationTlsDatabaseTrustContext* _tmp9_;
#line 495 "../src/client/application/application-certificate-manager.vala"
			_tmp2_ = self->priv->pinned_certs;
#line 495 "../src/client/application/application-certificate-manager.vala"
			_tmp3_ = gee_map_get_values (_tmp2_);
#line 495 "../src/client/application/application-certificate-manager.vala"
			_tmp4_ = _tmp3_;
#line 495 "../src/client/application/application-certificate-manager.vala"
			_tmp5_ = _tmp4_;
#line 495 "../src/client/application/application-certificate-manager.vala"
			_tmp6_ = geary_traverse (APPLICATION_TLS_DATABASE_TYPE_TRUST_CONTEXT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ITERABLE, GeeIterable));
#line 495 "../src/client/application/application-certificate-manager.vala"
			_tmp7_ = _tmp6_;
#line 495 "../src/client/application/application-certificate-manager.vala"
			_tmp8_ = geary_iterable_first_matching (_tmp7_, ____lambda50__gee_predicate, block4_data_ref (_data4_), block4_data_unref);
#line 495 "../src/client/application/application-certificate-manager.vala"
			_tmp9_ = (ApplicationTlsDatabaseTrustContext*) _tmp8_;
#line 495 "../src/client/application/application-certificate-manager.vala"
			_g_object_unref0 (_tmp7_);
#line 495 "../src/client/application/application-certificate-manager.vala"
			_g_object_unref0 (_tmp5_);
#line 495 "../src/client/application/application-certificate-manager.vala"
			result = _tmp9_;
#line 4050 "application-certificate-manager.c"
			{
				GeeMap* _tmp10_;
#line 494 "../src/client/application/application-certificate-manager.vala"
				_tmp10_ = self->priv->pinned_certs;
#line 494 "../src/client/application/application-certificate-manager.vala"
				g_rec_mutex_unlock (&self->priv->__lock_pinned_certs);
#line 4057 "application-certificate-manager.c"
			}
#line 495 "../src/client/application/application-certificate-manager.vala"
			block4_data_unref (_data4_);
#line 495 "../src/client/application/application-certificate-manager.vala"
			_data4_ = NULL;
#line 495 "../src/client/application/application-certificate-manager.vala"
			return result;
#line 4065 "application-certificate-manager.c"
		}
		__finally0:
		{
			GeeMap* _tmp11_;
#line 494 "../src/client/application/application-certificate-manager.vala"
			_tmp11_ = self->priv->pinned_certs;
#line 494 "../src/client/application/application-certificate-manager.vala"
			g_rec_mutex_unlock (&self->priv->__lock_pinned_certs);
#line 4074 "application-certificate-manager.c"
		}
#line 494 "../src/client/application/application-certificate-manager.vala"
		block4_data_unref (_data4_);
#line 494 "../src/client/application/application-certificate-manager.vala"
		_data4_ = NULL;
#line 494 "../src/client/application/application-certificate-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 494 "../src/client/application/application-certificate-manager.vala"
		g_clear_error (&_inner_error0_);
#line 494 "../src/client/application/application-certificate-manager.vala"
		return NULL;
#line 4086 "application-certificate-manager.c"
	}
}

static ApplicationTlsDatabaseTrustContext*
application_tls_database_trust_context_construct (GType object_type,
                                                  GTlsCertificate* certificate)
{
	ApplicationTlsDatabaseTrustContext * self = NULL;
	GByteArray* _tmp0_;
	GByteArray* _tmp1_;
	GByteArray* _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	GTlsCertificate* _tmp5_;
#line 178 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (certificate, g_tls_certificate_get_type ()), NULL);
#line 178 "../src/client/application/application-certificate-manager.vala"
	self = (ApplicationTlsDatabaseTrustContext*) geary_base_object_construct (object_type);
#line 179 "../src/client/application/application-certificate-manager.vala"
	g_object_get (certificate, "certificate", &_tmp0_, NULL);
#line 179 "../src/client/application/application-certificate-manager.vala"
	_tmp1_ = _tmp0_;
#line 179 "../src/client/application/application-certificate-manager.vala"
	_tmp2_ = _tmp1_;
#line 179 "../src/client/application/application-certificate-manager.vala"
	_tmp3_ = _tmp2_->data;
#line 179 "../src/client/application/application-certificate-manager.vala"
	_tmp3__length1 = _tmp2_->len;
#line 179 "../src/client/application/application-certificate-manager.vala"
	_tmp4_ = g_compute_checksum_for_data (APPLICATION_TLS_DATABASE_TRUST_CONTEXT_ID_TYPE, _tmp3_, (gint) _tmp3__length1);
#line 179 "../src/client/application/application-certificate-manager.vala"
	_g_free0 (self->id);
#line 179 "../src/client/application/application-certificate-manager.vala"
	self->id = _tmp4_;
#line 179 "../src/client/application/application-certificate-manager.vala"
	_g_byte_array_unref0 (_tmp2_);
#line 182 "../src/client/application/application-certificate-manager.vala"
	_tmp5_ = _g_object_ref0 (certificate);
#line 182 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (self->certificate);
#line 182 "../src/client/application/application-certificate-manager.vala"
	self->certificate = _tmp5_;
#line 178 "../src/client/application/application-certificate-manager.vala"
	return self;
#line 4132 "application-certificate-manager.c"
}

static ApplicationTlsDatabaseTrustContext*
application_tls_database_trust_context_new (GTlsCertificate* certificate)
{
#line 178 "../src/client/application/application-certificate-manager.vala"
	return application_tls_database_trust_context_construct (APPLICATION_TLS_DATABASE_TYPE_TRUST_CONTEXT, certificate);
#line 4140 "application-certificate-manager.c"
}

static ApplicationTlsDatabaseTrustContext*
application_tls_database_trust_context_construct_lookup (GType object_type,
                                                         GFile* dir,
                                                         const gchar* identity,
                                                         GCancellable* cancellable,
                                                         GError** error)
{
	ApplicationTlsDatabaseTrustContext * self = NULL;
	GFile* storage = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFileInputStream* f_in = NULL;
	GFile* _tmp4_;
	GFileInputStream* _tmp5_;
	GBufferedInputStream* buf = NULL;
	GFileInputStream* _tmp6_;
	GBufferedInputStream* _tmp7_;
	GByteArray* cert_pem = NULL;
	GBufferedInputStream* _tmp8_;
	guint _tmp9_;
	guint _tmp10_;
	GByteArray* _tmp11_;
	gboolean eof = FALSE;
	GBufferedInputStream* _tmp18_;
	GTlsCertificate* _tmp19_ = NULL;
	GByteArray* _tmp20_;
	guint8* _tmp21_;
	gint _tmp21__length1;
	GTlsCertificate* _tmp22_;
	GError* _inner_error0_ = NULL;
#line 185 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()), NULL);
#line 185 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail (identity != NULL, NULL);
#line 185 "../src/client/application/application-certificate-manager.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), NULL);
#line 191 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = g_strdup_printf (APPLICATION_TLS_DATABASE_TRUST_CONTEXT_FILENAME_FORMAT, identity);
#line 191 "../src/client/application/application-certificate-manager.vala"
	_tmp1_ = _tmp0_;
#line 191 "../src/client/application/application-certificate-manager.vala"
	_tmp2_ = g_file_get_child (dir, _tmp1_);
#line 191 "../src/client/application/application-certificate-manager.vala"
	_tmp3_ = _tmp2_;
#line 191 "../src/client/application/application-certificate-manager.vala"
	_g_free0 (_tmp1_);
#line 191 "../src/client/application/application-certificate-manager.vala"
	storage = _tmp3_;
#line 192 "../src/client/application/application-certificate-manager.vala"
	_tmp4_ = storage;
#line 192 "../src/client/application/application-certificate-manager.vala"
	_tmp5_ = g_file_read (_tmp4_, cancellable, &_inner_error0_);
#line 192 "../src/client/application/application-certificate-manager.vala"
	f_in = _tmp5_;
#line 192 "../src/client/application/application-certificate-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 192 "../src/client/application/application-certificate-manager.vala"
		g_propagate_error (error, _inner_error0_);
#line 192 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (storage);
#line 192 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (self);
#line 192 "../src/client/application/application-certificate-manager.vala"
		return NULL;
#line 4209 "application-certificate-manager.c"
	}
#line 193 "../src/client/application/application-certificate-manager.vala"
	_tmp6_ = f_in;
#line 193 "../src/client/application/application-certificate-manager.vala"
	_tmp7_ = (GBufferedInputStream*) g_buffered_input_stream_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, g_input_stream_get_type (), GInputStream));
#line 193 "../src/client/application/application-certificate-manager.vala"
	buf = _tmp7_;
#line 194 "../src/client/application/application-certificate-manager.vala"
	_tmp8_ = buf;
#line 194 "../src/client/application/application-certificate-manager.vala"
	_tmp9_ = g_buffered_input_stream_get_buffer_size (_tmp8_);
#line 194 "../src/client/application/application-certificate-manager.vala"
	_tmp10_ = _tmp9_;
#line 194 "../src/client/application/application-certificate-manager.vala"
	_tmp11_ = g_byte_array_sized_new (_tmp10_);
#line 194 "../src/client/application/application-certificate-manager.vala"
	cert_pem = _tmp11_;
#line 195 "../src/client/application/application-certificate-manager.vala"
	eof = FALSE;
#line 196 "../src/client/application/application-certificate-manager.vala"
	while (TRUE) {
#line 4231 "application-certificate-manager.c"
		gsize filled = 0UL;
		GBufferedInputStream* _tmp12_;
#line 196 "../src/client/application/application-certificate-manager.vala"
		if (!(!eof)) {
#line 196 "../src/client/application/application-certificate-manager.vala"
			break;
#line 4238 "application-certificate-manager.c"
		}
#line 197 "../src/client/application/application-certificate-manager.vala"
		_tmp12_ = buf;
#line 197 "../src/client/application/application-certificate-manager.vala"
		filled = (gsize) g_buffered_input_stream_fill (_tmp12_, (gssize) -1, cancellable, &_inner_error0_);
#line 197 "../src/client/application/application-certificate-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 197 "../src/client/application/application-certificate-manager.vala"
			g_propagate_error (error, _inner_error0_);
#line 197 "../src/client/application/application-certificate-manager.vala"
			_g_byte_array_unref0 (cert_pem);
#line 197 "../src/client/application/application-certificate-manager.vala"
			_g_object_unref0 (buf);
#line 197 "../src/client/application/application-certificate-manager.vala"
			_g_object_unref0 (f_in);
#line 197 "../src/client/application/application-certificate-manager.vala"
			_g_object_unref0 (storage);
#line 197 "../src/client/application/application-certificate-manager.vala"
			_g_object_unref0 (self);
#line 197 "../src/client/application/application-certificate-manager.vala"
			return NULL;
#line 4260 "application-certificate-manager.c"
		}
#line 198 "../src/client/application/application-certificate-manager.vala"
		if (filled > ((gsize) 0)) {
#line 4264 "application-certificate-manager.c"
			GByteArray* _tmp13_;
			GBufferedInputStream* _tmp14_;
			gsize _tmp15_ = 0;
			guint8* _tmp16_;
			GBufferedInputStream* _tmp17_;
#line 199 "../src/client/application/application-certificate-manager.vala"
			_tmp13_ = cert_pem;
#line 199 "../src/client/application/application-certificate-manager.vala"
			_tmp14_ = buf;
#line 199 "../src/client/application/application-certificate-manager.vala"
			_tmp16_ = g_buffered_input_stream_peek_buffer (_tmp14_, &_tmp15_);
#line 199 "../src/client/application/application-certificate-manager.vala"
			g_byte_array_append (_tmp13_, _tmp16_, (gint) _tmp15_);
#line 200 "../src/client/application/application-certificate-manager.vala"
			_tmp17_ = buf;
#line 200 "../src/client/application/application-certificate-manager.vala"
			g_input_stream_skip (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, g_input_stream_get_type (), GInputStream), filled, cancellable, &_inner_error0_);
#line 200 "../src/client/application/application-certificate-manager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 200 "../src/client/application/application-certificate-manager.vala"
				g_propagate_error (error, _inner_error0_);
#line 200 "../src/client/application/application-certificate-manager.vala"
				_g_byte_array_unref0 (cert_pem);
#line 200 "../src/client/application/application-certificate-manager.vala"
				_g_object_unref0 (buf);
#line 200 "../src/client/application/application-certificate-manager.vala"
				_g_object_unref0 (f_in);
#line 200 "../src/client/application/application-certificate-manager.vala"
				_g_object_unref0 (storage);
#line 200 "../src/client/application/application-certificate-manager.vala"
				_g_object_unref0 (self);
#line 200 "../src/client/application/application-certificate-manager.vala"
				return NULL;
#line 4298 "application-certificate-manager.c"
			}
		} else {
#line 202 "../src/client/application/application-certificate-manager.vala"
			eof = TRUE;
#line 4303 "application-certificate-manager.c"
		}
	}
#line 205 "../src/client/application/application-certificate-manager.vala"
	_tmp18_ = buf;
#line 205 "../src/client/application/application-certificate-manager.vala"
	g_input_stream_close (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, g_input_stream_get_type (), GInputStream), cancellable, &_inner_error0_);
#line 205 "../src/client/application/application-certificate-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 205 "../src/client/application/application-certificate-manager.vala"
		g_propagate_error (error, _inner_error0_);
#line 205 "../src/client/application/application-certificate-manager.vala"
		_g_byte_array_unref0 (cert_pem);
#line 205 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (buf);
#line 205 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (f_in);
#line 205 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (storage);
#line 205 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (self);
#line 205 "../src/client/application/application-certificate-manager.vala"
		return NULL;
#line 4326 "application-certificate-manager.c"
	}
#line 207 "../src/client/application/application-certificate-manager.vala"
	_tmp20_ = cert_pem;
#line 207 "../src/client/application/application-certificate-manager.vala"
	_tmp21_ = _tmp20_->data;
#line 207 "../src/client/application/application-certificate-manager.vala"
	_tmp21__length1 = _tmp20_->len;
#line 207 "../src/client/application/application-certificate-manager.vala"
	_tmp22_ = g_tls_certificate_new_from_pem ((const gchar*) _tmp21_, (gssize) -1, &_inner_error0_);
#line 207 "../src/client/application/application-certificate-manager.vala"
	_tmp19_ = _tmp22_;
#line 207 "../src/client/application/application-certificate-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 207 "../src/client/application/application-certificate-manager.vala"
		g_propagate_error (error, _inner_error0_);
#line 207 "../src/client/application/application-certificate-manager.vala"
		_g_byte_array_unref0 (cert_pem);
#line 207 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (buf);
#line 207 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (f_in);
#line 207 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (storage);
#line 207 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (self);
#line 207 "../src/client/application/application-certificate-manager.vala"
		return NULL;
#line 4354 "application-certificate-manager.c"
	}
#line 207 "../src/client/application/application-certificate-manager.vala"
	self = (ApplicationTlsDatabaseTrustContext*) application_tls_database_trust_context_construct (object_type, _tmp19_);
#line 185 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_tmp19_);
#line 185 "../src/client/application/application-certificate-manager.vala"
	_g_byte_array_unref0 (cert_pem);
#line 185 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (buf);
#line 185 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (f_in);
#line 185 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (storage);
#line 185 "../src/client/application/application-certificate-manager.vala"
	return self;
#line 4370 "application-certificate-manager.c"
}

static ApplicationTlsDatabaseTrustContext*
application_tls_database_trust_context_new_lookup (GFile* dir,
                                                   const gchar* identity,
                                                   GCancellable* cancellable,
                                                   GError** error)
{
#line 185 "../src/client/application/application-certificate-manager.vala"
	return application_tls_database_trust_context_construct_lookup (APPLICATION_TLS_DATABASE_TYPE_TRUST_CONTEXT, dir, identity, cancellable, error);
#line 4381 "application-certificate-manager.c"
}

static void
application_tls_database_trust_context_save_data_free (gpointer _data)
{
	ApplicationTlsDatabaseTrustContextSaveData* _data_;
	_data_ = _data;
#line 164 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->dir);
#line 164 "../src/client/application/application-certificate-manager.vala"
	_g_free0 (_data_->identity);
#line 164 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 164 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->self);
#line 164 "../src/client/application/application-certificate-manager.vala"
	g_slice_free (ApplicationTlsDatabaseTrustContextSaveData, _data_);
#line 4399 "application-certificate-manager.c"
}

static void
application_tls_database_trust_context_save (ApplicationTlsDatabaseTrustContext* self,
                                             GFile* dir,
                                             const gchar* identity,
                                             GCancellable* cancellable,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_)
{
	ApplicationTlsDatabaseTrustContextSaveData* _data_;
	ApplicationTlsDatabaseTrustContext* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	GCancellable* _tmp3_;
#line 164 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail (APPLICATION_TLS_DATABASE_IS_TRUST_CONTEXT (self));
#line 164 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()));
#line 164 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail (identity != NULL);
#line 164 "../src/client/application/application-certificate-manager.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 164 "../src/client/application/application-certificate-manager.vala"
	_data_ = g_slice_new0 (ApplicationTlsDatabaseTrustContextSaveData);
#line 164 "../src/client/application/application-certificate-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 164 "../src/client/application/application-certificate-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_tls_database_trust_context_save_data_free);
#line 164 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 164 "../src/client/application/application-certificate-manager.vala"
	_data_->self = _tmp0_;
#line 164 "../src/client/application/application-certificate-manager.vala"
	_tmp1_ = _g_object_ref0 (dir);
#line 164 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->dir);
#line 164 "../src/client/application/application-certificate-manager.vala"
	_data_->dir = _tmp1_;
#line 164 "../src/client/application/application-certificate-manager.vala"
	_tmp2_ = g_strdup (identity);
#line 164 "../src/client/application/application-certificate-manager.vala"
	_g_free0 (_data_->identity);
#line 164 "../src/client/application/application-certificate-manager.vala"
	_data_->identity = _tmp2_;
#line 164 "../src/client/application/application-certificate-manager.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 164 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 164 "../src/client/application/application-certificate-manager.vala"
	_data_->cancellable = _tmp3_;
#line 164 "../src/client/application/application-certificate-manager.vala"
	application_tls_database_trust_context_save_co (_data_);
#line 4453 "application-certificate-manager.c"
}

static void
application_tls_database_trust_context_save_finish (ApplicationTlsDatabaseTrustContext* self,
                                                    GAsyncResult* _res_,
                                                    GError** error)
{
	ApplicationTlsDatabaseTrustContextSaveData* _data_;
#line 164 "../src/client/application/application-certificate-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 164 "../src/client/application/application-certificate-manager.vala"
	if (NULL == _data_) {
#line 164 "../src/client/application/application-certificate-manager.vala"
		return;
#line 4468 "application-certificate-manager.c"
	}
}

static void
application_tls_database_trust_context_save_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_)
{
	ApplicationTlsDatabaseTrustContextSaveData* _data_;
#line 214 "../src/client/application/application-certificate-manager.vala"
	_data_ = _user_data_;
#line 214 "../src/client/application/application-certificate-manager.vala"
	_data_->_source_object_ = source_object;
#line 214 "../src/client/application/application-certificate-manager.vala"
	_data_->_res_ = _res_;
#line 214 "../src/client/application/application-certificate-manager.vala"
	application_tls_database_trust_context_save_co (_data_);
#line 4486 "application-certificate-manager.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 4523 "application-certificate-manager.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 4529 "application-certificate-manager.c"
}

static gboolean
application_tls_database_trust_context_save_co (ApplicationTlsDatabaseTrustContextSaveData* _data_)
{
#line 210 "../src/client/application/application-certificate-manager.vala"
	switch (_data_->_state_) {
#line 210 "../src/client/application/application-certificate-manager.vala"
		case 0:
#line 4539 "application-certificate-manager.c"
		goto _state_0;
#line 210 "../src/client/application/application-certificate-manager.vala"
		case 1:
#line 4543 "application-certificate-manager.c"
		goto _state_1;
#line 210 "../src/client/application/application-certificate-manager.vala"
		case 2:
#line 4547 "application-certificate-manager.c"
		goto _state_2;
#line 210 "../src/client/application/application-certificate-manager.vala"
		case 3:
#line 4551 "application-certificate-manager.c"
		goto _state_3;
#line 210 "../src/client/application/application-certificate-manager.vala"
		case 4:
#line 4555 "application-certificate-manager.c"
		goto _state_4;
		default:
#line 210 "../src/client/application/application-certificate-manager.vala"
		g_assert_not_reached ();
#line 4560 "application-certificate-manager.c"
	}
	_state_0:
#line 214 "../src/client/application/application-certificate-manager.vala"
	_data_->_state_ = 1;
#line 214 "../src/client/application/application-certificate-manager.vala"
	geary_files_make_directory_with_parents (_data_->dir, _data_->cancellable, application_tls_database_trust_context_save_ready, _data_);
#line 214 "../src/client/application/application-certificate-manager.vala"
	return FALSE;
#line 4569 "application-certificate-manager.c"
	_state_1:
#line 214 "../src/client/application/application-certificate-manager.vala"
	geary_files_make_directory_with_parents_finish (_data_->_res_, &_data_->_inner_error0_);
#line 214 "../src/client/application/application-certificate-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 214 "../src/client/application/application-certificate-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 214 "../src/client/application/application-certificate-manager.vala"
		g_object_unref (_data_->_async_result);
#line 214 "../src/client/application/application-certificate-manager.vala"
		return FALSE;
#line 4581 "application-certificate-manager.c"
	}
#line 215 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp0_ = g_strdup_printf (APPLICATION_TLS_DATABASE_TRUST_CONTEXT_FILENAME_FORMAT, _data_->identity);
#line 215 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 215 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp2_ = g_file_get_child (_data_->dir, _data_->_tmp1_);
#line 215 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 215 "../src/client/application/application-certificate-manager.vala"
	_g_free0 (_data_->_tmp1_);
#line 215 "../src/client/application/application-certificate-manager.vala"
	_data_->storage = _data_->_tmp3_;
#line 216 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp4_ = _data_->storage;
#line 216 "../src/client/application/application-certificate-manager.vala"
	_data_->_state_ = 2;
#line 216 "../src/client/application/application-certificate-manager.vala"
	g_file_replace_async (_data_->_tmp4_, NULL, FALSE, G_FILE_CREATE_NONE, APPLICATION_TLS_DATABASE_TRUST_CONTEXT_IO_PRIO, _data_->cancellable, application_tls_database_trust_context_save_ready, _data_);
#line 216 "../src/client/application/application-certificate-manager.vala"
	return FALSE;
#line 4603 "application-certificate-manager.c"
	_state_2:
#line 216 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp5_ = g_file_replace_finish (_data_->_tmp4_, _data_->_res_, &_data_->_inner_error0_);
#line 216 "../src/client/application/application-certificate-manager.vala"
	_data_->f_out = _data_->_tmp5_;
#line 216 "../src/client/application/application-certificate-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 216 "../src/client/application/application-certificate-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 216 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (_data_->storage);
#line 216 "../src/client/application/application-certificate-manager.vala"
		g_object_unref (_data_->_async_result);
#line 216 "../src/client/application/application-certificate-manager.vala"
		return FALSE;
#line 4619 "application-certificate-manager.c"
	}
#line 219 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp6_ = _data_->f_out;
#line 219 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp7_ = (GBufferedOutputStream*) g_buffered_output_stream_new (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, g_output_stream_get_type (), GOutputStream));
#line 219 "../src/client/application/application-certificate-manager.vala"
	_data_->buf = _data_->_tmp7_;
#line 221 "../src/client/application/application-certificate-manager.vala"
	_data_->written = (gsize) 0;
#line 222 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp8_ = _data_->buf;
#line 222 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp9_ = _data_->self->certificate;
#line 222 "../src/client/application/application-certificate-manager.vala"
	g_object_get (_data_->_tmp9_, "certificate-pem", &_data_->_tmp10_, NULL);
#line 222 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp11_ = _data_->_tmp10_;
#line 222 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 222 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp14_ = 0;
#line 222 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp13_ = string_get_data (_data_->_tmp12_, &_data_->_tmp14_);
#line 222 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp13__length1 = _data_->_tmp14_;
#line 222 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp15_ = _data_->_tmp13_;
#line 222 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp15__length1 = _data_->_tmp13__length1;
#line 222 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp16_ = 0UL;
#line 222 "../src/client/application/application-certificate-manager.vala"
	_data_->_state_ = 3;
#line 222 "../src/client/application/application-certificate-manager.vala"
	g_output_stream_write_all_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp8_, g_output_stream_get_type (), GOutputStream), _data_->_tmp15_, (gsize) _data_->_tmp15__length1, APPLICATION_TLS_DATABASE_TRUST_CONTEXT_IO_PRIO, _data_->cancellable, application_tls_database_trust_context_save_ready, _data_);
#line 222 "../src/client/application/application-certificate-manager.vala"
	return FALSE;
#line 4657 "application-certificate-manager.c"
	_state_3:
#line 222 "../src/client/application/application-certificate-manager.vala"
	g_output_stream_write_all_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp8_, g_output_stream_get_type (), GOutputStream), _data_->_res_, &_data_->_tmp16_, &_data_->_inner_error0_);
#line 222 "../src/client/application/application-certificate-manager.vala"
	_data_->written = _data_->_tmp16_;
#line 222 "../src/client/application/application-certificate-manager.vala"
	_g_free0 (_data_->_tmp12_);
#line 222 "../src/client/application/application-certificate-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 222 "../src/client/application/application-certificate-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 222 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (_data_->buf);
#line 222 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (_data_->f_out);
#line 222 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (_data_->storage);
#line 222 "../src/client/application/application-certificate-manager.vala"
		g_object_unref (_data_->_async_result);
#line 222 "../src/client/application/application-certificate-manager.vala"
		return FALSE;
#line 4679 "application-certificate-manager.c"
	}
#line 228 "../src/client/application/application-certificate-manager.vala"
	_data_->_tmp17_ = _data_->buf;
#line 228 "../src/client/application/application-certificate-manager.vala"
	_data_->_state_ = 4;
#line 228 "../src/client/application/application-certificate-manager.vala"
	g_output_stream_close_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp17_, g_output_stream_get_type (), GOutputStream), APPLICATION_TLS_DATABASE_TRUST_CONTEXT_IO_PRIO, _data_->cancellable, application_tls_database_trust_context_save_ready, _data_);
#line 228 "../src/client/application/application-certificate-manager.vala"
	return FALSE;
#line 4689 "application-certificate-manager.c"
	_state_4:
#line 228 "../src/client/application/application-certificate-manager.vala"
	g_output_stream_close_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp17_, g_output_stream_get_type (), GOutputStream), _data_->_res_, &_data_->_inner_error0_);
#line 228 "../src/client/application/application-certificate-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 228 "../src/client/application/application-certificate-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 228 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (_data_->buf);
#line 228 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (_data_->f_out);
#line 228 "../src/client/application/application-certificate-manager.vala"
		_g_object_unref0 (_data_->storage);
#line 228 "../src/client/application/application-certificate-manager.vala"
		g_object_unref (_data_->_async_result);
#line 228 "../src/client/application/application-certificate-manager.vala"
		return FALSE;
#line 4707 "application-certificate-manager.c"
	}
#line 210 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->buf);
#line 210 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->f_out);
#line 210 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (_data_->storage);
#line 210 "../src/client/application/application-certificate-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 210 "../src/client/application/application-certificate-manager.vala"
	if (_data_->_state_ != 0) {
#line 210 "../src/client/application/application-certificate-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 210 "../src/client/application/application-certificate-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4723 "application-certificate-manager.c"
		}
	}
#line 210 "../src/client/application/application-certificate-manager.vala"
	g_object_unref (_data_->_async_result);
#line 210 "../src/client/application/application-certificate-manager.vala"
	return FALSE;
#line 4730 "application-certificate-manager.c"
}

static void
application_tls_database_trust_context_class_init (ApplicationTlsDatabaseTrustContextClass * klass,
                                                   gpointer klass_data)
{
#line 164 "../src/client/application/application-certificate-manager.vala"
	application_tls_database_trust_context_parent_class = g_type_class_peek_parent (klass);
#line 164 "../src/client/application/application-certificate-manager.vala"
	G_OBJECT_CLASS (klass)->finalize = application_tls_database_trust_context_finalize;
#line 4741 "application-certificate-manager.c"
}

static void
application_tls_database_trust_context_instance_init (ApplicationTlsDatabaseTrustContext * self,
                                                      gpointer klass)
{
}

static void
application_tls_database_trust_context_finalize (GObject * obj)
{
	ApplicationTlsDatabaseTrustContext * self;
#line 164 "../src/client/application/application-certificate-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APPLICATION_TLS_DATABASE_TYPE_TRUST_CONTEXT, ApplicationTlsDatabaseTrustContext);
#line 174 "../src/client/application/application-certificate-manager.vala"
	_g_free0 (self->id);
#line 175 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (self->certificate);
#line 164 "../src/client/application/application-certificate-manager.vala"
	G_OBJECT_CLASS (application_tls_database_trust_context_parent_class)->finalize (obj);
#line 4762 "application-certificate-manager.c"
}

/** A certificate and the identities it is trusted for. */
static GType
application_tls_database_trust_context_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ApplicationTlsDatabaseTrustContextClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) application_tls_database_trust_context_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ApplicationTlsDatabaseTrustContext), 0, (GInstanceInitFunc) application_tls_database_trust_context_instance_init, NULL };
	GType application_tls_database_trust_context_type_id;
	application_tls_database_trust_context_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "ApplicationTlsDatabaseTrustContext", &g_define_type_info, 0);
	return application_tls_database_trust_context_type_id;
}

static GType
application_tls_database_trust_context_get_type (void)
{
	static volatile gsize application_tls_database_trust_context_type_id__once = 0;
	if (g_once_init_enter (&application_tls_database_trust_context_type_id__once)) {
		GType application_tls_database_trust_context_type_id;
		application_tls_database_trust_context_type_id = application_tls_database_trust_context_get_type_once ();
		g_once_init_leave (&application_tls_database_trust_context_type_id__once, application_tls_database_trust_context_type_id);
	}
	return application_tls_database_trust_context_type_id__once;
}

static void
application_tls_database_class_init (ApplicationTlsDatabaseClass * klass,
                                     gpointer klass_data)
{
#line 160 "../src/client/application/application-certificate-manager.vala"
	application_tls_database_parent_class = g_type_class_peek_parent (klass);
#line 160 "../src/client/application/application-certificate-manager.vala"
	g_type_class_adjust_private_offset (klass, &ApplicationTlsDatabase_private_offset);
#line 160 "../src/client/application/application-certificate-manager.vala"
	((GTlsDatabaseClass *) klass)->create_certificate_handle = (gchar* (*) (GTlsDatabase*, GTlsCertificate*)) application_tls_database_real_create_certificate_handle;
#line 160 "../src/client/application/application-certificate-manager.vala"
	((GTlsDatabaseClass *) klass)->lookup_certificate_for_handle = (GTlsCertificate* (*) (GTlsDatabase*, const gchar*, GTlsInteraction*, GTlsDatabaseLookupFlags, GCancellable*, GError**)) application_tls_database_real_lookup_certificate_for_handle;
#line 160 "../src/client/application/application-certificate-manager.vala"
	((GTlsDatabaseClass *) klass)->lookup_certificate_for_handle_async = (void (*) (GTlsDatabase*, const gchar*, GTlsInteraction*, GTlsDatabaseLookupFlags, GCancellable*, GAsyncReadyCallback, gpointer)) application_tls_database_real_lookup_certificate_for_handle_async;
#line 160 "../src/client/application/application-certificate-manager.vala"
	((GTlsDatabaseClass *) klass)->lookup_certificate_for_handle_finish = (GTlsCertificate* (*) (GTlsDatabase*, GAsyncResult*, GError**)) application_tls_database_lookup_certificate_for_handle_finish;
#line 160 "../src/client/application/application-certificate-manager.vala"
	((GTlsDatabaseClass *) klass)->lookup_certificate_issuer = (GTlsCertificate* (*) (GTlsDatabase*, GTlsCertificate*, GTlsInteraction*, GTlsDatabaseLookupFlags, GCancellable*, GError**)) application_tls_database_real_lookup_certificate_issuer;
#line 160 "../src/client/application/application-certificate-manager.vala"
	((GTlsDatabaseClass *) klass)->lookup_certificate_issuer_async = (void (*) (GTlsDatabase*, GTlsCertificate*, GTlsInteraction*, GTlsDatabaseLookupFlags, GCancellable*, GAsyncReadyCallback, gpointer)) application_tls_database_real_lookup_certificate_issuer_async;
#line 160 "../src/client/application/application-certificate-manager.vala"
	((GTlsDatabaseClass *) klass)->lookup_certificate_issuer_finish = (GTlsCertificate* (*) (GTlsDatabase*, GAsyncResult*, GError**)) application_tls_database_lookup_certificate_issuer_finish;
#line 160 "../src/client/application/application-certificate-manager.vala"
	((GTlsDatabaseClass *) klass)->lookup_certificates_issued_by = (GList* (*) (GTlsDatabase*, GByteArray*, GTlsInteraction*, GTlsDatabaseLookupFlags, GCancellable*, GError**)) application_tls_database_real_lookup_certificates_issued_by;
#line 160 "../src/client/application/application-certificate-manager.vala"
	((GTlsDatabaseClass *) klass)->lookup_certificates_issued_by_async = (void (*) (GTlsDatabase*, GByteArray*, GTlsInteraction*, GTlsDatabaseLookupFlags, GCancellable*, GAsyncReadyCallback, gpointer)) application_tls_database_real_lookup_certificates_issued_by_async;
#line 160 "../src/client/application/application-certificate-manager.vala"
	((GTlsDatabaseClass *) klass)->lookup_certificates_issued_by_finish = (GList* (*) (GTlsDatabase*, GAsyncResult*, GError**)) application_tls_database_lookup_certificates_issued_by_finish;
#line 160 "../src/client/application/application-certificate-manager.vala"
	((GTlsDatabaseClass *) klass)->verify_chain = (GTlsCertificateFlags (*) (GTlsDatabase*, GTlsCertificate*, const gchar*, GSocketConnectable*, GTlsInteraction*, GTlsDatabaseVerifyFlags, GCancellable*, GError**)) application_tls_database_real_verify_chain;
#line 160 "../src/client/application/application-certificate-manager.vala"
	((GTlsDatabaseClass *) klass)->verify_chain_async = (void (*) (GTlsDatabase*, GTlsCertificate*, const gchar*, GSocketConnectable*, GTlsInteraction*, GTlsDatabaseVerifyFlags, GCancellable*, GAsyncReadyCallback, gpointer)) application_tls_database_real_verify_chain_async;
#line 160 "../src/client/application/application-certificate-manager.vala"
	((GTlsDatabaseClass *) klass)->verify_chain_finish = (GTlsCertificateFlags (*) (GTlsDatabase*, GAsyncResult*, GError**)) application_tls_database_verify_chain_finish;
#line 160 "../src/client/application/application-certificate-manager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_application_tls_database_get_property;
#line 160 "../src/client/application/application-certificate-manager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_application_tls_database_set_property;
#line 160 "../src/client/application/application-certificate-manager.vala"
	G_OBJECT_CLASS (klass)->finalize = application_tls_database_finalize;
#line 4827 "application-certificate-manager.c"
}

static void
application_tls_database_instance_init (ApplicationTlsDatabase * self,
                                        gpointer klass)
{
	GeeHashMap* _tmp0_;
#line 160 "../src/client/application/application-certificate-manager.vala"
	self->priv = application_tls_database_get_instance_private (self);
#line 258 "../src/client/application/application-certificate-manager.vala"
	g_rec_mutex_init (&self->priv->__lock_pinned_certs);
#line 258 "../src/client/application/application-certificate-manager.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, APPLICATION_TLS_DATABASE_TYPE_TRUST_CONTEXT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 258 "../src/client/application/application-certificate-manager.vala"
	self->priv->pinned_certs = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_MAP, GeeMap);
#line 4843 "application-certificate-manager.c"
}

static void
application_tls_database_finalize (GObject * obj)
{
	ApplicationTlsDatabase * self;
#line 160 "../src/client/application/application-certificate-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APPLICATION_TYPE_TLS_DATABASE, ApplicationTlsDatabase);
#line 254 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (self->priv->_parent);
#line 255 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (self->priv->store_dir);
#line 258 "../src/client/application/application-certificate-manager.vala"
	g_rec_mutex_clear (&self->priv->__lock_pinned_certs);
#line 258 "../src/client/application/application-certificate-manager.vala"
	_g_object_unref0 (self->priv->pinned_certs);
#line 160 "../src/client/application/application-certificate-manager.vala"
	G_OBJECT_CLASS (application_tls_database_parent_class)->finalize (obj);
#line 4862 "application-certificate-manager.c"
}

/**
 * TLS database that observes locally pinned certs.
 *
 * An instance of this is managed by {@link CertificateManager}, the
 * application should simply construct an instance of that.
 */
static GType
application_tls_database_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ApplicationTlsDatabaseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) application_tls_database_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ApplicationTlsDatabase), 0, (GInstanceInitFunc) application_tls_database_instance_init, NULL };
	GType application_tls_database_type_id;
	application_tls_database_type_id = g_type_register_static (g_tls_database_get_type (), "ApplicationTlsDatabase", &g_define_type_info, 0);
	ApplicationTlsDatabase_private_offset = g_type_add_instance_private (application_tls_database_type_id, sizeof (ApplicationTlsDatabasePrivate));
	return application_tls_database_type_id;
}

GType
application_tls_database_get_type (void)
{
	static volatile gsize application_tls_database_type_id__once = 0;
	if (g_once_init_enter (&application_tls_database_type_id__once)) {
		GType application_tls_database_type_id;
		application_tls_database_type_id = application_tls_database_get_type_once ();
		g_once_init_leave (&application_tls_database_type_id__once, application_tls_database_type_id);
	}
	return application_tls_database_type_id__once;
}

static void
_vala_application_tls_database_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	ApplicationTlsDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APPLICATION_TYPE_TLS_DATABASE, ApplicationTlsDatabase);
#line 160 "../src/client/application/application-certificate-manager.vala"
	switch (property_id) {
#line 4903 "application-certificate-manager.c"
		default:
#line 160 "../src/client/application/application-certificate-manager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 160 "../src/client/application/application-certificate-manager.vala"
		break;
#line 4909 "application-certificate-manager.c"
	}
}

static void
_vala_application_tls_database_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	ApplicationTlsDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APPLICATION_TYPE_TLS_DATABASE, ApplicationTlsDatabase);
#line 160 "../src/client/application/application-certificate-manager.vala"
	switch (property_id) {
#line 4923 "application-certificate-manager.c"
		default:
#line 160 "../src/client/application/application-certificate-manager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 160 "../src/client/application/application-certificate-manager.vala"
		break;
#line 4929 "application-certificate-manager.c"
	}
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

