/* application-main-window.c generated by valac 0.56.17, the Vala compiler
 * generated from application-main-window.vala, do not modify */

/*
 * Copyright © 2016 Software Freedom Conservancy Inc.
 * Copyright © 2016, 2019-2021 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-client-46.0.h"
#include "geary-engine.h"
#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <gio/gio.h>
#include <handy.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <cairo-gobject.h>

#define APPLICATION_MAIN_WINDOW_INNER_LEAFLET "inner_leaflet"
#define APPLICATION_MAIN_WINDOW_FOLDER_LIST "folder_list"
#define APPLICATION_MAIN_WINDOW_CONVERSATION_LIST "conversation_list"
#define APPLICATION_MAIN_WINDOW_CONVERSATION_VIEWER "conversation_viewer"
#define APPLICATION_MAIN_WINDOW_UPDATE_UI_INTERVAL 60
#define APPLICATION_MAIN_WINDOW_MIN_CONVERSATION_COUNT 50
#define CONVERSATION_EMAIL_REQUIRED_FOR_CONSTRUCT ((GEARY_EMAIL_FIELD_ENVELOPE | GEARY_EMAIL_FIELD_PREVIEW) | GEARY_EMAIL_FIELD_FLAGS)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define APPLICATION_TYPE_CONTROLLER (application_controller_get_type ())
#define APPLICATION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLICATION_TYPE_CONTROLLER, ApplicationController))
#define APPLICATION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APPLICATION_TYPE_CONTROLLER, ApplicationControllerClass))
#define APPLICATION_IS_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLICATION_TYPE_CONTROLLER))
#define APPLICATION_IS_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLICATION_TYPE_CONTROLLER))
#define APPLICATION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLICATION_TYPE_CONTROLLER, ApplicationControllerClass))

typedef struct _ApplicationController ApplicationController;
typedef struct _ApplicationControllerClass ApplicationControllerClass;
enum  {
	APPLICATION_MAIN_WINDOW_0_PROPERTY,
	APPLICATION_MAIN_WINDOW_APPLICATION_PROPERTY,
	APPLICATION_MAIN_WINDOW_SELECTED_ACCOUNT_PROPERTY,
	APPLICATION_MAIN_WINDOW_SELECTED_FOLDER_PROPERTY,
	APPLICATION_MAIN_WINDOW_CONVERSATIONS_PROPERTY,
	APPLICATION_MAIN_WINDOW_IS_FOLDER_LIST_SHOWN_PROPERTY,
	APPLICATION_MAIN_WINDOW_IS_CONVERSATION_LIST_SHOWN_PROPERTY,
	APPLICATION_MAIN_WINDOW_IS_CONVERSATION_VIEWER_SHOWN_PROPERTY,
	APPLICATION_MAIN_WINDOW_ATTACHMENTS_PROPERTY,
	APPLICATION_MAIN_WINDOW_SELECTED_FOLDER_SUPPORTS_TRASH_PROPERTY,
	APPLICATION_MAIN_WINDOW_HAS_COMPOSER_PROPERTY,
	APPLICATION_MAIN_WINDOW_IS_SHIFT_DOWN_PROPERTY,
	APPLICATION_MAIN_WINDOW_WINDOW_WIDTH_PROPERTY,
	APPLICATION_MAIN_WINDOW_WINDOW_HEIGHT_PROPERTY,
	APPLICATION_MAIN_WINDOW_WINDOW_MAXIMIZED_PROPERTY,
	APPLICATION_MAIN_WINDOW_FOLDER_LIST_PROPERTY,
	APPLICATION_MAIN_WINDOW_SEARCH_BAR_PROPERTY,
	APPLICATION_MAIN_WINDOW_CONVERSATION_LIST_VIEW_PROPERTY,
	APPLICATION_MAIN_WINDOW_CONVERSATION_VIEWER_PROPERTY,
	APPLICATION_MAIN_WINDOW_CONVERSATION_LIST_INFO_BARS_PROPERTY,
	APPLICATION_MAIN_WINDOW_NUM_PROPERTIES
};
static GParamSpec* application_main_window_properties[APPLICATION_MAIN_WINDOW_NUM_PROPERTIES];
typedef enum  {
	APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_NONE,
	APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_SINGLE,
	APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_MULTIPLE
} ApplicationMainWindowConversationCount;

#define APPLICATION_MAIN_WINDOW_TYPE_CONVERSATION_COUNT (application_main_window_conversation_count_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block14Data Block14Data;

#define APPLICATION_TYPE_ACCOUNT_INTERFACE (application_account_interface_get_type ())
#define APPLICATION_ACCOUNT_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface))
#define APPLICATION_IS_ACCOUNT_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLICATION_TYPE_ACCOUNT_INTERFACE))
#define APPLICATION_ACCOUNT_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterfaceIface))

typedef struct _ApplicationAccountInterface ApplicationAccountInterface;
typedef struct _ApplicationAccountInterfaceIface ApplicationAccountInterfaceIface;
typedef struct _ApplicationMainWindowSelectFolderData ApplicationMainWindowSelectFolderData;
typedef struct _ApplicationMainWindowShowConversationsData ApplicationMainWindowShowConversationsData;
typedef struct _ApplicationMainWindowShowEmailData ApplicationMainWindowShowEmailData;
typedef struct _Block15Data Block15Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ApplicationMainWindowRemoveAccountData ApplicationMainWindowRemoveAccountData;

#define TYPE_ALERT_DIALOG (alert_dialog_get_type ())
#define ALERT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALERT_DIALOG, AlertDialog))
#define ALERT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALERT_DIALOG, AlertDialogClass))
#define IS_ALERT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALERT_DIALOG))
#define IS_ALERT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALERT_DIALOG))
#define ALERT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALERT_DIALOG, AlertDialogClass))

typedef struct _AlertDialog AlertDialog;
typedef struct _AlertDialogClass AlertDialogClass;

#define TYPE_CONFIRMATION_DIALOG (confirmation_dialog_get_type ())
#define CONFIRMATION_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIRMATION_DIALOG, ConfirmationDialog))
#define CONFIRMATION_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIRMATION_DIALOG, ConfirmationDialogClass))
#define IS_CONFIRMATION_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIRMATION_DIALOG))
#define IS_CONFIRMATION_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIRMATION_DIALOG))
#define CONFIRMATION_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIRMATION_DIALOG, ConfirmationDialogClass))

typedef struct _ConfirmationDialog ConfirmationDialog;
typedef struct _ConfirmationDialogClass ConfirmationDialogClass;
typedef struct _Block16Data Block16Data;
typedef struct _ApplicationMainWindowUndoData ApplicationMainWindowUndoData;
typedef struct _Block17Data Block17Data;
typedef struct _ApplicationMainWindowRedoData ApplicationMainWindowRedoData;
typedef struct _ApplicationMainWindowLoadConversationsForEmailData ApplicationMainWindowLoadConversationsForEmailData;

#define COMPOSER_TYPE_APPLICATION_INTERFACE (composer_application_interface_get_type ())
#define COMPOSER_APPLICATION_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), COMPOSER_TYPE_APPLICATION_INTERFACE, ComposerApplicationInterface))
#define COMPOSER_IS_APPLICATION_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), COMPOSER_TYPE_APPLICATION_INTERFACE))
#define COMPOSER_APPLICATION_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), COMPOSER_TYPE_APPLICATION_INTERFACE, ComposerApplicationInterfaceIface))

typedef struct _ComposerApplicationInterface ComposerApplicationInterface;
typedef struct _ComposerApplicationInterfaceIface ComposerApplicationInterfaceIface;
typedef struct _ApplicationMainWindowSelectConversationsData ApplicationMainWindowSelectConversationsData;
typedef struct _Block18Data Block18Data;
typedef struct _ApplicationMainWindowOpenConversationMonitorData ApplicationMainWindowOpenConversationMonitorData;
typedef struct _Block19Data Block19Data;
typedef struct _ApplicationMainWindowCreateComposerData ApplicationMainWindowCreateComposerData;
typedef struct _ApplicationMainWindowCreateComposerFromViewerData ApplicationMainWindowCreateComposerFromViewerData;
typedef struct _ApplicationMainWindowUpdateContextDependentActionsData ApplicationMainWindowUpdateContextDependentActionsData;
typedef struct _Block20Data Block20Data;
typedef struct _Block21Data Block21Data;
typedef struct _Block22Data Block22Data;
typedef struct _Block23Data Block23Data;
typedef struct _Block24Data Block24Data;
typedef struct _Block25Data Block25Data;
typedef struct _Block26Data Block26Data;
typedef struct _Block27Data Block27Data;
typedef struct _Block28Data Block28Data;
typedef struct _Block29Data Block29Data;
typedef struct _Block30Data Block30Data;
typedef struct _Block31Data Block31Data;
typedef struct _Block32Data Block32Data;
typedef struct _Block33Data Block33Data;
typedef struct _Block34Data Block34Data;
#define _g_type_class_unref0(var) ((var == NULL) ? NULL : (var = (g_type_class_unref (var), NULL)))
enum  {
	APPLICATION_MAIN_WINDOW_RETRY_SERVICE_PROBLEM_SIGNAL,
	APPLICATION_MAIN_WINDOW_REPLY_CONVERSATION_SENDER_SIGNAL,
	APPLICATION_MAIN_WINDOW_REPLY_CONVERSATION_ALL_SIGNAL,
	APPLICATION_MAIN_WINDOW_FORWARD_CONVERSATION_SIGNAL,
	APPLICATION_MAIN_WINDOW_MARK_CONVERSATIONS_READ_SIGNAL,
	APPLICATION_MAIN_WINDOW_MARK_CONVERSATIONS_STARRED_SIGNAL,
	APPLICATION_MAIN_WINDOW_SHOW_COPY_MENU_SIGNAL,
	APPLICATION_MAIN_WINDOW_ARCHIVE_CONVERSATIONS_SIGNAL,
	APPLICATION_MAIN_WINDOW_JUNK_CONVERSATIONS_SIGNAL,
	APPLICATION_MAIN_WINDOW_TRASH_CONVERSATIONS_SIGNAL,
	APPLICATION_MAIN_WINDOW_DELETE_CONVERSATIONS_SIGNAL,
	APPLICATION_MAIN_WINDOW_SEARCH_SIGNAL,
	APPLICATION_MAIN_WINDOW_FIND_SIGNAL,
	APPLICATION_MAIN_WINDOW_ESCAPE_SIGNAL,
	APPLICATION_MAIN_WINDOW_SELECT_ALL_SIGNAL,
	APPLICATION_MAIN_WINDOW_NAVIGATE_SIGNAL,
	APPLICATION_MAIN_WINDOW_NUM_SIGNALS
};
static guint application_main_window_signals[APPLICATION_MAIN_WINDOW_NUM_SIGNALS] = {0};

struct _ApplicationMainWindowPrivate {
	GearyAccount* _selected_account;
	GearyFolder* _selected_folder;
	GearyAppConversationMonitor* _conversations;
	ApplicationAttachmentManager* _attachments;
	gboolean _is_shift_down;
	gint _window_width;
	gint _window_height;
	gboolean _window_maximized;
	FolderListTree* _folder_list;
	SearchBar* _search_bar;
	ConversationListView* _conversation_list_view;
	ConversationViewer* _conversation_viewer;
	ComponentsInfoBarStack* _conversation_list_info_bars;
	ApplicationController* controller;
	GeeSet* accounts;
	GSimpleActionGroup* edit_actions;
	gboolean previous_selection_was_interactive;
	GearyFolder* previous_non_search_folder;
	GearyAggregateProgressMonitor* progress_monitor;
	GCancellable* action_update_cancellable;
	GCancellable* folder_open;
	GearyTimeoutManager* update_ui_timeout;
	gint64 update_ui_last;
	ComponentsApplicationHeaderBar* application_headerbar;
	ComponentsConversationListHeaderBar* conversation_list_headerbar;
	HdyLeaflet* outer_leaflet;
	HdyLeaflet* inner_leaflet;
	GtkScrolledWindow* folder_list_scrolled;
	GtkBox* conversation_list_box;
	GtkRevealer* conversation_list_actions_revealer;
	ComponentsConversationActions* conversation_list_actions;
	ComponentsConversationActions* conversation_viewer_actions;
	GtkBox* conversation_viewer_box;
	GtkRevealer* conversation_viewer_actions_revealer;
	GtkOverlay* overlay;
	ComponentsInfoBarStack* info_bars;
	ComponentsConversationActions** folder_conversation_actions;
	gint folder_conversation_actions_length1;
	gint _folder_conversation_actions_size_;
	ComponentsInfoBar* offline_infobar;
	ComponentsInfoBar* cert_problem_infobar;
	ComponentsInfoBar* auth_problem_infobar;
	ComponentsProblemReportInfoBar* service_problem_infobar;
};

struct _Block14Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	ApplicationClient* application;
};

struct _ApplicationAccountInterfaceIface {
	GTypeInterface parent_iface;
	ApplicationAccountContext* (*get_context_for_account) (ApplicationAccountInterface* self, GearyAccountInformation* account);
	GeeCollection* (*get_account_contexts) (ApplicationAccountInterface* self);
};

struct _ApplicationMainWindowSelectFolderData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationMainWindow* self;
	GearyFolder* to_select;
	gboolean is_interactive;
	gboolean inhibit_autoselect;
	GearyFolder* _tmp0_;
	GCancellable* _tmp1_;
	GCancellable* cancellable;
	GCancellable* _tmp2_;
	GCancellable* _tmp3_;
	GCancellable* _tmp4_;
	ComponentsConversationListHeaderBar* _tmp5_;
	GearyFolder* _tmp6_;
	GearyAggregateProgressMonitor* _tmp7_;
	GearyFolder* _tmp8_;
	GearyProgressMonitor* _tmp9_;
	GearyProgressMonitor* _tmp10_;
	GearyFolder* _tmp11_;
	GearyFolderProperties* _tmp12_;
	GearyFolderProperties* _tmp13_;
	guint _tmp14_;
	GearyAppConversationMonitor* _tmp15_;
	GearyAggregateProgressMonitor* _tmp16_;
	GearyAppConversationMonitor* _tmp17_;
	GearyProgressMonitor* _tmp18_;
	GearyProgressMonitor* _tmp19_;
	GearyAppConversationMonitor* _tmp20_;
	ConversationListView* _tmp21_;
	ComponentsInfoBarStack* _tmp22_;
	GearyAccount* _tmp23_;
	GearyAccount* _tmp24_;
	GearyAccount* _tmp25_;
	gboolean _tmp26_;
	gboolean _tmp27_;
	GearyFolderSpecialUse _tmp28_;
	GearyFolderSpecialUse _tmp29_;
	FolderListTree* _tmp30_;
	GearyAccount* _tmp31_;
	GearyAccount* _tmp32_;
	FolderListTree* _tmp33_;
	FolderListTree* _tmp34_;
	ConversationViewer* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	GearyAggregateProgressMonitor* _tmp39_;
	GearyProgressMonitor* _tmp40_;
	GearyProgressMonitor* _tmp41_;
	GearyFolderProperties* _tmp42_;
	GearyFolderProperties* _tmp43_;
	GearyAppConversationMonitor* _tmp44_;
	GearyAppConversationMonitor* _tmp45_;
	GearyAggregateProgressMonitor* _tmp46_;
	GearyAppConversationMonitor* _tmp47_;
	GearyProgressMonitor* _tmp48_;
	GearyProgressMonitor* _tmp49_;
	ConversationListView* _tmp50_;
	ConversationListView* _tmp51_;
	GearyAppConversationMonitor* _tmp52_;
	GearyAppConversationMonitor* _tmp53_;
	GCancellable* _tmp54_;
	ApplicationController* _tmp55_;
};

struct _ApplicationMainWindowShowConversationsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationMainWindow* self;
	GearyFolder* location;
	GeeCollection* to_show;
	gboolean is_interactive;
	gboolean inhibit_autoselect;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GeeHashSet* latest_email;
	GeeHashSet* _tmp2_;
	GeeIterator* _stale_it;
	GeeIterator* _tmp3_;
	GeeIterator* _tmp4_;
	GearyAppConversation* stale;
	GeeIterator* _tmp5_;
	gpointer _tmp6_;
	GearyEmail* first;
	GearyAppConversation* _tmp7_;
	GearyEmail* _tmp8_;
	GearyEmail* _tmp9_;
	GeeHashSet* _tmp10_;
	GearyEmail* _tmp11_;
	GearyEmailIdentifier* _tmp12_;
	GearyEmailIdentifier* _tmp13_;
	GeeCollection* loaded;
	GeeHashSet* _tmp14_;
	GeeCollection* _tmp15_;
	GeeCollection* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	GeeCollection* _tmp19_;
	GeeCollection* _tmp20_;
	GeeCollection* _tmp21_;
};

struct _ApplicationMainWindowShowEmailData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationMainWindow* self;
	GearyFolder* location;
	GeeCollection* to_show;
	gboolean is_interactive;
	gboolean inhibit_autoselect;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GeeCollection* loaded;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GearyAppConversation* target;
	GeeCollection* _tmp6_;
	gpointer _tmp7_;
	ConversationListBox* current_list;
	ConversationViewer* _tmp8_;
	ConversationListBox* _tmp9_;
	ConversationListBox* _tmp10_;
	ConversationListBox* _tmp11_;
	gboolean _tmp12_;
	ConversationListBox* _tmp13_;
	ConversationListBox* _tmp14_;
	GearyAppConversation* _tmp15_;
	GearyAppConversation* _tmp16_;
	GearyAppConversation* _tmp17_;
	ConversationListBox* _tmp18_;
	GeeCollection* _tmp19_;
	GeeCollection* _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp22_;
	GeeCollection* _tmp23_;
	GeeCollection* _tmp24_;
	GeeCollection* _tmp25_;
};

struct _Block15Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GeeCollection* referrants;
};

struct _ApplicationMainWindowRemoveAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationMainWindow* self;
	ApplicationAccountContext* to_remove;
	GearyFolder* to_select;
	GeeSet* _tmp0_;
	gboolean _tmp1_;
	GearyFolder* _tmp2_;
	GearyFolder* _tmp3_;
	GearyAccount* _tmp4_;
	GearyAccount* _tmp5_;
	GearyAccount* _tmp6_;
	GearyAccount* _tmp7_;
	gboolean is_account_search_active;
	GearyFolder* _tmp8_;
	GearyFolderSpecialUse _tmp9_;
	GearyFolderSpecialUse _tmp10_;
	SearchBar* _tmp11_;
	GtkSearchEntry* _tmp12_;
	GtkSearchEntry* _tmp13_;
	SearchBar* _tmp14_;
	ApplicationCommandStack* _tmp15_;
	ApplicationCommandStack* _tmp16_;
	guint _tmp17_;
	ApplicationCommandStack* _tmp18_;
	ApplicationCommandStack* _tmp19_;
	guint _tmp20_;
	ApplicationCommandStack* _tmp21_;
	ApplicationCommandStack* _tmp22_;
	guint _tmp23_;
	guint _tmp24_;
	guint _tmp25_;
	GearyAggregateProgressMonitor* _tmp26_;
	GearyAccount* _tmp27_;
	GearyAccount* _tmp28_;
	GearyProgressMonitor* _tmp29_;
	GearyProgressMonitor* _tmp30_;
	GearySmtpClientService* smtp;
	GearyAccount* _tmp31_;
	GearyAccount* _tmp32_;
	GearyClientService* _tmp33_;
	GearyClientService* _tmp34_;
	GearySmtpClientService* _tmp35_;
	GearySmtpClientService* _tmp36_;
	GearyAggregateProgressMonitor* _tmp37_;
	GearySmtpClientService* _tmp38_;
	GearyProgressMonitor* _tmp39_;
	GearyProgressMonitor* _tmp40_;
	GeeCollection* _tmp41_;
	GeeCollection* _tmp42_;
	FolderListTree* _tmp43_;
	GearyAccount* _tmp44_;
	GearyAccount* _tmp45_;
	GeeSet* _tmp46_;
};

struct _Block16Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	ApplicationAccountContext* selected;
	gpointer _async_data_;
};

struct _ApplicationMainWindowUndoData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationMainWindow* self;
	Block16Data* _data16_;
	ApplicationAccountContext* _tmp0_;
	ApplicationAccountContext* _tmp1_;
	ApplicationAccountContext* _tmp2_;
	ApplicationCommandStack* _tmp3_;
	ApplicationCommandStack* _tmp4_;
	ApplicationAccountContext* _tmp5_;
	GCancellable* _tmp6_;
	GCancellable* _tmp7_;
};

struct _Block17Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	ApplicationAccountContext* selected;
	gpointer _async_data_;
};

struct _ApplicationMainWindowRedoData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationMainWindow* self;
	Block17Data* _data17_;
	ApplicationAccountContext* _tmp0_;
	ApplicationAccountContext* _tmp1_;
	ApplicationAccountContext* _tmp2_;
	ApplicationCommandStack* _tmp3_;
	ApplicationCommandStack* _tmp4_;
	ApplicationAccountContext* _tmp5_;
	GCancellable* _tmp6_;
	GCancellable* _tmp7_;
};

struct _ApplicationMainWindowLoadConversationsForEmailData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationMainWindow* self;
	GearyFolder* location;
	GeeCollection* to_load;
	GeeCollection* result;
	gboolean was_loaded;
	gboolean _tmp0_;
	GearyAppConversationMonitor* _tmp1_;
	GearyAppConversationMonitor* _tmp2_;
	GearyFolder* _tmp3_;
	GearyFolder* _tmp4_;
	GearyAppConversationMonitor* _tmp5_;
	GCancellable* _tmp6_;
	GError* err;
	GError* _tmp7_;
	const gchar* _tmp8_;
	GeeHashSet* loaded;
	GeeHashSet* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	GearyAppConversationMonitor* _tmp12_;
	GearyAppConversationMonitor* _tmp13_;
	GearyFolder* _tmp14_;
	GearyFolder* _tmp15_;
	GeeIterator* _id_it;
	GeeIterator* _tmp16_;
	GeeIterator* _tmp17_;
	GearyEmailIdentifier* id;
	GeeIterator* _tmp18_;
	gpointer _tmp19_;
	GearyAppConversation* conversation;
	GearyAppConversationMonitor* _tmp20_;
	GearyEmailIdentifier* _tmp21_;
	GearyAppConversation* _tmp22_;
	GearyAppConversation* _tmp23_;
	GeeHashSet* _tmp24_;
	GearyAppConversation* _tmp25_;
	GError* _inner_error0_;
};

struct _ComposerApplicationInterfaceIface {
	GTypeInterface parent_iface;
	void (*report_problem) (ComposerApplicationInterface* self, GearyProblemReport* report);
	void (*send_composed_email) (ComposerApplicationInterface* self, ComposerWidget* composer, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*send_composed_email_finish) (ComposerApplicationInterface* self, GAsyncResult* _res_);
	void (*save_composed_email) (ComposerApplicationInterface* self, ComposerWidget* composer, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*save_composed_email_finish) (ComposerApplicationInterface* self, GAsyncResult* _res_);
	void (*discard_composed_email) (ComposerApplicationInterface* self, ComposerWidget* composer, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*discard_composed_email_finish) (ComposerApplicationInterface* self, GAsyncResult* _res_);
};

struct _ApplicationMainWindowSelectConversationsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationMainWindow* self;
	GeeCollection* to_select;
	GeeCollection* scroll_to;
	gboolean is_interactive;
	gboolean _tmp0_;
	gboolean start_mark_timer;
	ConversationListView* _tmp1_;
	ComponentsConversationActions* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	ComponentsConversationHeaderBar* _tmp5_;
	ComponentsConversationActions* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	ComponentsConversationHeaderBar* _tmp9_;
	ComponentsConversationActions* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gboolean _tmp13_;
	GearyFolder* _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	ConversationViewer* _tmp19_;
	GearyAppConversation* convo;
	gpointer _tmp20_;
	ApplicationAccountContext* context;
	ApplicationAccountContext* _tmp21_;
	gboolean _tmp22_;
	ApplicationAccountContext* _tmp23_;
	GearyAppConversation* _tmp24_;
	ConversationViewer* _tmp25_;
	GearyAppConversation* _tmp26_;
	ApplicationAccountContext* _tmp27_;
	GearyAppEmailStore* _tmp28_;
	GearyAppEmailStore* _tmp29_;
	ApplicationAccountContext* _tmp30_;
	ApplicationContactStore* _tmp31_;
	ApplicationContactStore* _tmp32_;
	GError* err;
	GError* _tmp33_;
	const gchar* _tmp34_;
	GError* _vala1_err;
	GearyAppConversation* _tmp35_;
	GearyFolder* _tmp36_;
	GearyFolder* _tmp37_;
	GearyAccount* _tmp38_;
	GearyAccount* _tmp39_;
	GearyAccountInformation* _tmp40_;
	GearyAccountInformation* _tmp41_;
	GError* _tmp42_;
	ConversationViewer* _tmp43_;
	GError* _inner_error0_;
};

struct _Block18Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyAppConversationMonitor* to_open;
	gpointer _async_data_;
};

struct _ApplicationMainWindowOpenConversationMonitorData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationMainWindow* self;
	GearyAppConversationMonitor* to_open;
	GCancellable* cancellable;
	Block18Data* _data18_;
};

struct _Block19Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyAppConversationMonitor* to_close;
};

struct _ApplicationMainWindowCreateComposerData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationMainWindow* self;
	GearyAccount* send_context;
	ComposerWidgetContextType type;
	GearyEmail* context;
	gchar* quote;
	const gchar* _tmp0_;
	ComposerWidget* composer;
	ApplicationController* _tmp1_;
	ApplicationController* _tmp2_;
	GearyAccountInformation* _tmp3_;
	GearyAccountInformation* _tmp4_;
	ApplicationAccountContext* _tmp5_;
	ApplicationAccountContext* _tmp6_;
	ComposerWidget* _tmp7_;
	ComposerWidget* _tmp8_;
	ApplicationController* _tmp9_;
};

struct _ApplicationMainWindowCreateComposerFromViewerData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationMainWindow* self;
	ComposerWidgetContextType type;
	GearyAccount* account;
	GearyAccount* _tmp0_;
	GearyAccount* _tmp1_;
	ConversationEmail* email_view;
	ConversationListBox* list_view;
	ConversationViewer* _tmp2_;
	ConversationListBox* _tmp3_;
	ConversationListBox* _tmp4_;
	ConversationListBox* _tmp5_;
	ConversationListBox* _tmp6_;
	ConversationListBox* _tmp7_;
	ConversationEmail* _tmp8_;
	gboolean _tmp9_;
	GearyAccount* _tmp10_;
	ConversationEmail* _tmp11_;
	gchar* quote;
	ConversationEmail* _tmp12_;
	gchar* _tmp13_;
	GearyAccount* _tmp14_;
	ConversationEmail* _tmp15_;
	GearyEmail* _tmp16_;
	GearyEmail* _tmp17_;
	const gchar* _tmp18_;
};

struct _ApplicationMainWindowUpdateContextDependentActionsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationMainWindow* self;
	gboolean sensitive;
	GCancellable* _tmp0_;
	GCancellable* cancellable;
	GCancellable* _tmp1_;
	GCancellable* _tmp2_;
	GCancellable* _tmp3_;
	GeeMultiMap* selected_operations;
	GearyFolder* _tmp4_;
	ApplicationAccountContext* context;
	ApplicationController* _tmp5_;
	GearyFolder* _tmp6_;
	GearyAccount* _tmp7_;
	GearyAccount* _tmp8_;
	GearyAccountInformation* _tmp9_;
	GearyAccountInformation* _tmp10_;
	ApplicationAccountContext* _tmp11_;
	ApplicationAccountContext* _tmp12_;
	GeeCollection* ids;
	GeeLinkedList* _tmp13_;
	GeeIterator* _convo_it;
	ConversationListView* _tmp14_;
	GeeSet* _tmp15_;
	GeeSet* _tmp16_;
	GeeIterator* _tmp17_;
	GeeIterator* _tmp18_;
	GearyAppConversation* convo;
	GeeIterator* _tmp19_;
	gpointer _tmp20_;
	GeeCollection* _tmp21_;
	GearyAppConversation* _tmp22_;
	GeeCollection* _tmp23_;
	GeeCollection* _tmp24_;
	GeeMultiMap* _tmp25_;
	ApplicationAccountContext* _tmp26_;
	GearyAppEmailStore* _tmp27_;
	GearyAppEmailStore* _tmp28_;
	GeeCollection* _tmp29_;
	GCancellable* _tmp30_;
	GeeMultiMap* _tmp31_;
	GeeMultiMap* _tmp32_;
	GError* e;
	GError* _tmp33_;
	const gchar* _tmp34_;
	GCancellable* _tmp35_;
	GeeHashSet* supported_operations;
	GeeHashSet* _tmp36_;
	GeeMultiMap* _tmp37_;
	GeeHashSet* _tmp38_;
	GeeMultiMap* _tmp39_;
	GeeCollection* _tmp40_;
	GeeCollection* _tmp41_;
	gboolean _tmp42_;
	GeeHashSet* _tmp43_;
	GSimpleAction* _tmp44_;
	GSimpleAction* _tmp45_;
	GError* _inner_error0_;
};

struct _Block20Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	ComposerWidgetContextType context_type;
};

struct _Block21Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolder* location;
};

struct _Block22Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolder* location;
};

struct _Block23Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolder* location;
};

struct _Block24Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolder* location;
};

struct _Block25Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolder* location;
};

struct _Block26Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolder* source;
};

struct _Block27Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolderSupportMove* source;
};

struct _Block28Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolderSupportCopy* source;
};

struct _Block29Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolder* source;
};

struct _Block30Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolder* source;
};

struct _Block31Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolderSupportRemove* target;
};

struct _Block32Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolder* location;
};

struct _Block33Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolder* source;
};

struct _Block34Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolderSupportRemove* source;
};

static gint ApplicationMainWindow_private_offset;
static gpointer application_main_window_parent_class = NULL;
static GearyBaseInterfaceIface * application_main_window_geary_base_interface_parent_iface = NULL;

VALA_EXTERN GType application_controller_get_type (void) G_GNUC_CONST ;
static GType application_main_window_conversation_count_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static ApplicationMainWindowConversationCount application_main_window_conversation_count_for_size (gint size);
static void application_main_window_on_undo (ApplicationMainWindow* self);
static void _application_main_window_on_undo_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
static void application_main_window_on_redo (ApplicationMainWindow* self);
static void _application_main_window_on_redo_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
static void application_main_window_on_close (ApplicationMainWindow* self);
static void _application_main_window_on_close_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self);
static void application_main_window_on_show_help_overlay (ApplicationMainWindow* self);
static void _application_main_window_on_show_help_overlay_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                     GVariant* parameter,
                                                                                     gpointer self);
static void application_main_window_on_show_window_menu (ApplicationMainWindow* self);
static void _application_main_window_on_show_window_menu_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                    GVariant* parameter,
                                                                                    gpointer self);
static void application_main_window_on_find_in_conversation_action (ApplicationMainWindow* self);
static void _application_main_window_on_find_in_conversation_action_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                               GVariant* parameter,
                                                                                               gpointer self);
static void application_main_window_on_search_activated (ApplicationMainWindow* self);
static void _application_main_window_on_search_activated_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                    GVariant* parameter,
                                                                                    gpointer self);
static void application_main_window_on_select_inbox (ApplicationMainWindow* self,
                                              GSimpleAction* action,
                                              GVariant* parameter);
static void _application_main_window_on_select_inbox_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self);
static void application_main_window_go_to_previous_pane (ApplicationMainWindow* self);
static void _application_main_window_go_to_previous_pane_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                    GVariant* parameter,
                                                                                    gpointer self);
static void application_main_window_on_reply_conversation (ApplicationMainWindow* self);
static void _application_main_window_on_reply_conversation_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                      GVariant* parameter,
                                                                                      gpointer self);
static void application_main_window_on_reply_all_conversation (ApplicationMainWindow* self);
static void _application_main_window_on_reply_all_conversation_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                          GVariant* parameter,
                                                                                          gpointer self);
static void application_main_window_on_forward_conversation (ApplicationMainWindow* self);
static void _application_main_window_on_forward_conversation_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                        GVariant* parameter,
                                                                                        gpointer self);
static void application_main_window_on_archive_conversation (ApplicationMainWindow* self);
static void _application_main_window_on_archive_conversation_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                        GVariant* parameter,
                                                                                        gpointer self);
static void application_main_window_on_trash_conversation (ApplicationMainWindow* self);
static void _application_main_window_on_trash_conversation_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                      GVariant* parameter,
                                                                                      gpointer self);
static void application_main_window_on_delete_conversation (ApplicationMainWindow* self);
static void _application_main_window_on_delete_conversation_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                       GVariant* parameter,
                                                                                       gpointer self);
static void application_main_window_on_show_copy_menu (ApplicationMainWindow* self);
static void _application_main_window_on_show_copy_menu_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self);
static void application_main_window_on_conversation_up (ApplicationMainWindow* self);
static void _application_main_window_on_conversation_up_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self);
static void application_main_window_on_conversation_down (ApplicationMainWindow* self);
static void _application_main_window_on_conversation_down_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                     GVariant* parameter,
                                                                                     gpointer self);
static void application_main_window_on_mark_as_read (ApplicationMainWindow* self);
static void _application_main_window_on_mark_as_read_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self);
static void application_main_window_on_mark_as_unread (ApplicationMainWindow* self);
static void _application_main_window_on_mark_as_unread_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self);
static void application_main_window_on_mark_as_starred (ApplicationMainWindow* self);
static void _application_main_window_on_mark_as_starred_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self);
static void application_main_window_on_mark_as_unstarred (ApplicationMainWindow* self);
static void _application_main_window_on_mark_as_unstarred_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                     GVariant* parameter,
                                                                                     gpointer self);
static void application_main_window_on_mark_as_junk_toggle (ApplicationMainWindow* self);
static void _application_main_window_on_mark_as_junk_toggle_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                       GVariant* parameter,
                                                                                       gpointer self);
static void application_main_window_on_zoom (ApplicationMainWindow* self,
                                      GSimpleAction* action,
                                      GVariant* parameter);
static void _application_main_window_on_zoom_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
static void application_main_window_set_selected_account (ApplicationMainWindow* self,
                                                   GearyAccount* value);
static void application_main_window_set_selected_folder (ApplicationMainWindow* self,
                                                  GearyFolder* value);
static void application_main_window_set_conversations (ApplicationMainWindow* self,
                                                GearyAppConversationMonitor* value);
static void application_main_window_set_attachments (ApplicationMainWindow* self,
                                              ApplicationAttachmentManager* value);
VALA_EXTERN gboolean application_controller_does_folder_support_trash (GearyFolder* target);
static void application_main_window_set_is_shift_down (ApplicationMainWindow* self,
                                                gboolean value);
static void application_main_window_set_folder_list (ApplicationMainWindow* self,
                                              FolderListTree* value);
static void application_main_window_set_search_bar (ApplicationMainWindow* self,
                                             SearchBar* value);
static void application_main_window_set_conversation_list_view (ApplicationMainWindow* self,
                                                         ConversationListView* value);
static void application_main_window_set_conversation_viewer (ApplicationMainWindow* self,
                                                      ConversationViewer* value);
static void application_main_window_set_conversation_list_info_bars (ApplicationMainWindow* self,
                                                              ComponentsInfoBarStack* value);
static void application_main_window_real_reply_conversation_sender (ApplicationMainWindow* self);
static void application_main_window_activate_action (ApplicationMainWindow* self,
                                              GAction* action);
static GSimpleAction* application_main_window_get_window_action (ApplicationMainWindow* self,
                                                          const gchar* name);
static void application_main_window_real_reply_conversation_all (ApplicationMainWindow* self);
static void application_main_window_real_forward_conversation (ApplicationMainWindow* self);
static void application_main_window_real_mark_conversations_read (ApplicationMainWindow* self,
                                                           gboolean prefer_read);
static void application_main_window_real_mark_conversations_starred (ApplicationMainWindow* self,
                                                              gboolean prefer_starred);
static void application_main_window_real_show_copy_menu (ApplicationMainWindow* self);
static void application_main_window_real_archive_conversations (ApplicationMainWindow* self);
static void application_main_window_real_junk_conversations (ApplicationMainWindow* self);
static void application_main_window_real_trash_conversations (ApplicationMainWindow* self);
static void application_main_window_real_delete_conversations (ApplicationMainWindow* self);
static void application_main_window_real_search (ApplicationMainWindow* self);
static void application_main_window_real_find (ApplicationMainWindow* self);
static void application_main_window_real_escape (ApplicationMainWindow* self);
static void application_main_window_navigate_previous_pane (ApplicationMainWindow* self);
static void application_main_window_real_select_all (ApplicationMainWindow* self);
static void application_main_window_real_navigate (ApplicationMainWindow* self,
                                            GtkScrollType type);
static void application_main_window_go_to_next_pane (ApplicationMainWindow* self,
                                              gboolean only_if_folded);
VALA_EXTERN ApplicationMainWindow* application_main_window_new (ApplicationClient* application);
VALA_EXTERN ApplicationMainWindow* application_main_window_construct (GType object_type,
                                                          ApplicationClient* application);
static Block14Data* block14_data_ref (Block14Data* _data14_);
static void block14_data_unref (void * _userdata_);
VALA_EXTERN ApplicationController* application_client_get_controller (ApplicationClient* self);
static void application_main_window_load_config (ApplicationMainWindow* self,
                                          ApplicationConfiguration* config);
static void application_main_window_restore_saved_window_state (ApplicationMainWindow* self);
static gboolean __lambda206_ (Block14Data* _data14_,
                       GtkWidget* w,
                       GdkEventFocus* e);
VALA_EXTERN void application_controller_window_focus_in (ApplicationController* self);
static gboolean ___lambda206__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                  GdkEventFocus* event,
                                                  gpointer self);
static gboolean __lambda207_ (Block14Data* _data14_,
                       GtkWidget* w,
                       GdkEventFocus* e);
VALA_EXTERN void application_controller_window_focus_out (ApplicationController* self);
static gboolean ___lambda207__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                   GdkEventFocus* event,
                                                   gpointer self);
static void application_main_window_setup_layout (ApplicationMainWindow* self,
                                           ApplicationConfiguration* config);
static void application_main_window_update_command_actions (ApplicationMainWindow* self);
static void application_main_window_update_conversation_actions (ApplicationMainWindow* self,
                                                          ApplicationMainWindowConversationCount count);
static void application_main_window_on_update_ui_timeout (ApplicationMainWindow* self);
static void _application_main_window_on_update_ui_timeout_geary_timeout_manager_timeout_func (GearyTimeoutManager* manager,
                                                                                       gpointer self);
VALA_EXTERN GType application_account_interface_get_type (void) G_GNUC_CONST ;
static void application_main_window_on_account_available (ApplicationMainWindow* self,
                                                   ApplicationAccountContext* account);
static void _application_main_window_on_account_available_application_account_interface_account_available (ApplicationAccountInterface* _sender,
                                                                                                    ApplicationAccountContext* context,
                                                                                                    gboolean is_startup,
                                                                                                    gpointer self);
static void application_main_window_on_account_unavailable (ApplicationMainWindow* self,
                                                     ApplicationAccountContext* account,
                                                     gboolean is_shutdown);
static void _application_main_window_on_account_unavailable_application_account_interface_account_unavailable (ApplicationAccountInterface* _sender,
                                                                                                        ApplicationAccountContext* context,
                                                                                                        gboolean is_shutdown,
                                                                                                        gpointer self);
VALA_EXTERN GeeCollection* application_account_interface_get_account_contexts (ApplicationAccountInterface* self);
static void application_main_window_add_account (ApplicationMainWindow* self,
                                          ApplicationAccountContext* to_add);
static void application_main_window_on_offline_infobar_response (ApplicationMainWindow* self);
static void _application_main_window_on_offline_infobar_response_components_info_bar_response (ComponentsInfoBar* _sender,
                                                                                        gint response_id,
                                                                                        gpointer self);
static void application_main_window_on_auth_problem_retry (ApplicationMainWindow* self);
static void _application_main_window_on_auth_problem_retry_gtk_button_clicked (GtkButton* _sender,
                                                                        gpointer self);
static void application_main_window_on_cert_problem_retry (ApplicationMainWindow* self);
static void _application_main_window_on_cert_problem_retry_gtk_button_clicked (GtkButton* _sender,
                                                                        gpointer self);
static void __lambda216_ (ApplicationMainWindow* self);
static void ___lambda216__gtk_widget_map (GtkWidget* _sender,
                                   gpointer self);
static void application_main_window_on_show_mark_menu (ApplicationMainWindow* self);
static void _application_main_window_on_show_mark_menu_components_conversation_actions_mark_message_button_toggled (ComponentsConversationActions* _sender,
                                                                                                             gpointer self);
static void application_main_window_on_gtk_decoration_layout_changed (ApplicationMainWindow* self);
static void _application_main_window_on_gtk_decoration_layout_changed_g_object_notify (GObject* _sender,
                                                                                GParamSpec* pspec,
                                                                                gpointer self);
static void application_main_window_update_close_button_position (ApplicationMainWindow* self);
static void application_main_window_real_destroy (GtkWidget* base);
static ApplicationAccountContext* application_main_window_get_selected_account_context (ApplicationMainWindow* self);
static void application_main_window_on_service_problem_retry (ApplicationMainWindow* self);
static void _application_main_window_on_service_problem_retry_components_problem_report_info_bar_retry (ComponentsProblemReportInfoBar* _sender,
                                                                                                 gpointer self);
static void application_main_window_select_folder_data_free (gpointer _data);
static gboolean application_main_window_select_folder_co (ApplicationMainWindowSelectFolderData* _data_);
static void application_main_window_update_headerbar (ApplicationMainWindow* self);
static void _application_main_window_update_headerbar_g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self);
static void application_main_window_close_conversation_monitor (ApplicationMainWindow* self,
                                                         GearyAppConversationMonitor* to_close);
static void application_main_window_select_account (ApplicationMainWindow* self,
                                             GearyAccount* account);
static void application_main_window_update_trash_action (ApplicationMainWindow* self);
static void application_main_window_open_conversation_monitor (ApplicationMainWindow* self,
                                                        GearyAppConversationMonitor* to_open,
                                                        GCancellable* cancellable,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_);
static void application_main_window_open_conversation_monitor_finish (ApplicationMainWindow* self,
                                                               GAsyncResult* _res_);
static void application_main_window_select_folder_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
VALA_EXTERN void application_controller_process_pending_composers (ApplicationController* self,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_);
VALA_EXTERN void application_controller_process_pending_composers_finish (ApplicationController* self,
                                                              GAsyncResult* _res_);
static void application_main_window_show_conversations_data_free (gpointer _data);
static gboolean application_main_window_show_conversations_co (ApplicationMainWindowShowConversationsData* _data_);
static void application_main_window_show_conversations_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_);
static void application_main_window_navigate_next_pane (ApplicationMainWindow* self);
static void application_main_window_load_conversations_for_email (ApplicationMainWindow* self,
                                                           GearyFolder* location,
                                                           GeeCollection* to_load,
                                                           GAsyncReadyCallback _callback_,
                                                           gpointer _user_data_);
static GeeCollection* application_main_window_load_conversations_for_email_finish (ApplicationMainWindow* self,
                                                                            GAsyncResult* _res_);
static void application_main_window_select_conversations (ApplicationMainWindow* self,
                                                   GeeCollection* to_select,
                                                   GeeCollection* scroll_to,
                                                   gboolean is_interactive,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
static void application_main_window_select_conversations_finish (ApplicationMainWindow* self,
                                                          GAsyncResult* _res_);
static void application_main_window_show_email_data_free (gpointer _data);
static gboolean application_main_window_show_email_co (ApplicationMainWindowShowEmailData* _data_);
static void application_main_window_show_email_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
VALA_EXTERN void application_main_window_show_composer (ApplicationMainWindow* self,
                                            ComposerWidget* composer);
static Block15Data* block15_data_ref (Block15Data* _data15_);
static void block15_data_unref (void * _userdata_);
static gboolean ____lambda144_ (Block15Data* _data15_,
                         GearyEmail* email);
static gboolean _____lambda144__gee_predicate (gconstpointer g,
                                        gpointer self);
VALA_EXTERN gboolean application_main_window_close_composer (ApplicationMainWindow* self,
                                                 gboolean should_prompt,
                                                 gboolean is_shutdown);
VALA_EXTERN void application_main_window_start_search (ApplicationMainWindow* self,
                                           const gchar* query_text,
                                           gboolean is_interactive);
static inline void application_main_window_handle_error (ApplicationMainWindow* self,
                                           GearyAccountInformation* account,
                                           GError* _error_);
VALA_EXTERN void application_main_window_stop_search (ApplicationMainWindow* self,
                                          gboolean is_interactive);
VALA_EXTERN gboolean application_main_window_select_first_inbox (ApplicationMainWindow* self,
                                                     gboolean is_interactive);
static GearyFolder* application_main_window_get_first_inbox (ApplicationMainWindow* self);
static void application_main_window_on_folders_available (ApplicationMainWindow* self,
                                                   GeeCollection* available);
static void _application_main_window_on_folders_available_application_account_context_folders_available (ApplicationAccountContext* _sender,
                                                                                                  GeeCollection* available,
                                                                                                  gpointer self);
static void application_main_window_on_folders_unavailable (ApplicationMainWindow* self,
                                                     GeeCollection* unavailable);
static void _application_main_window_on_folders_unavailable_application_account_context_folders_unavailable (ApplicationAccountContext* _sender,
                                                                                                      GeeCollection* unavailable,
                                                                                                      gpointer self);
static void application_main_window_on_command_execute (ApplicationMainWindow* self,
                                                 ApplicationCommand* command);
static void _application_main_window_on_command_execute_application_command_stack_executed (ApplicationCommandStack* _sender,
                                                                                     ApplicationCommand* command,
                                                                                     gpointer self);
static void application_main_window_on_command_undo (ApplicationMainWindow* self,
                                              ApplicationCommand* command);
static void _application_main_window_on_command_undo_application_command_stack_undone (ApplicationCommandStack* _sender,
                                                                                ApplicationCommand* command,
                                                                                gpointer self);
static void application_main_window_on_command_redo (ApplicationMainWindow* self,
                                              ApplicationCommand* command);
static void _application_main_window_on_command_redo_application_command_stack_redone (ApplicationCommandStack* _sender,
                                                                                ApplicationCommand* command,
                                                                                gpointer self);
static void application_main_window_add_folders (ApplicationMainWindow* self,
                                          GeeCollection* to_add);
static void application_main_window_remove_account_data_free (gpointer _data);
static void application_main_window_remove_account (ApplicationMainWindow* self,
                                             ApplicationAccountContext* to_remove,
                                             GearyFolder* to_select,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
static void application_main_window_remove_account_finish (ApplicationMainWindow* self,
                                                    GAsyncResult* _res_);
static gboolean application_main_window_remove_account_co (ApplicationMainWindowRemoveAccountData* _data_);
static void application_main_window_remove_account_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_);
static void _application_main_window_on_folders_unavailable_application_account_context_folders_available (ApplicationAccountContext* _sender,
                                                                                                    GeeCollection* available,
                                                                                                    gpointer self);
static void application_main_window_remove_folders (ApplicationMainWindow* self,
                                             GeeCollection* to_remove,
                                             gboolean update_selecton);
static void application_main_window_on_use_changed (ApplicationMainWindow* self,
                                             GearyFolder* folder,
                                             GearyFolderSpecialUse old_type,
                                             GearyFolderSpecialUse new_type);
static void _application_main_window_on_use_changed_geary_folder_use_changed (GearyFolder* _sender,
                                                                       GearyFolderSpecialUse old_use,
                                                                       GearyFolderSpecialUse new_use,
                                                                       gpointer self);
VALA_EXTERN ApplicationAccountContext* application_account_interface_get_context_for_account (ApplicationAccountInterface* self,
                                                                                  GearyAccountInformation* account);
static gboolean application_main_window_real_window_state_event (GtkWidget* base,
                                                          GdkEventWindowState* event);
static void application_main_window_real_size_allocate (GtkWidget* base,
                                                 GtkAllocation* allocation);
static void application_main_window_on_has_toplevel_focus (ApplicationMainWindow* self);
static void _application_main_window_on_has_toplevel_focus_g_object_notify (GObject* _sender,
                                                                     GParamSpec* pspec,
                                                                     gpointer self);
static void application_main_window_on_search (ApplicationMainWindow* self,
                                        const gchar* text);
static void _application_main_window_on_search_search_bar_search_text_changed (SearchBar* _sender,
                                                                        const gchar* search_text,
                                                                        gpointer self);
static void application_main_window_on_folder_selected (ApplicationMainWindow* self,
                                                 GearyFolder* folder);
static void _application_main_window_on_folder_selected_folder_list_tree_folder_selected (FolderListTree* _sender,
                                                                                   GearyFolder* folder,
                                                                                   gpointer self);
static void application_main_window_on_move_conversation (ApplicationMainWindow* self,
                                                   GearyFolder* destination);
static void _application_main_window_on_move_conversation_folder_list_tree_move_conversation (FolderListTree* _sender,
                                                                                       GearyFolder* folder,
                                                                                       gpointer self);
static void application_main_window_on_copy_conversation (ApplicationMainWindow* self,
                                                   GearyFolder* destination);
static void _application_main_window_on_copy_conversation_folder_list_tree_copy_conversation (FolderListTree* _sender,
                                                                                       GearyFolder* folder,
                                                                                       gpointer self);
static void application_main_window_on_folder_activated (ApplicationMainWindow* self,
                                                  GearyFolder* folder);
static void _application_main_window_on_folder_activated_folder_list_tree_folder_activated (FolderListTree* _sender,
                                                                                     GearyFolder* folder,
                                                                                     gpointer self);
static void application_main_window_on_mark_conversations (ApplicationMainWindow* self,
                                                    GeeCollection* conversations,
                                                    GearyNamedFlag* flag);
static void _application_main_window_on_mark_conversations_conversation_list_view_mark_conversations (ConversationListView* _sender,
                                                                                               GeeCollection* conversations,
                                                                                               GearyNamedFlag* flag,
                                                                                               gpointer self);
static void application_main_window_on_conversations_selected (ApplicationMainWindow* self,
                                                        GeeSet* selected);
static void _application_main_window_on_conversations_selected_conversation_list_view_conversations_selected (ConversationListView* _sender,
                                                                                                       GeeSet* selected,
                                                                                                       gpointer self);
static void application_main_window_on_conversation_activated (ApplicationMainWindow* self,
                                                        GearyAppConversation* activated,
                                                        guint button);
static void _application_main_window_on_conversation_activated_conversation_list_view_conversation_activated (ConversationListView* _sender,
                                                                                                       GearyAppConversation* activated,
                                                                                                       guint button,
                                                                                                       gpointer self);
static void application_main_window_on_visible_conversations_changed (ApplicationMainWindow* self);
static void _application_main_window_on_visible_conversations_changed_g_object_notify (GObject* _sender,
                                                                                GParamSpec* pspec,
                                                                                gpointer self);
static void application_main_window_on_conversation_view_added (ApplicationMainWindow* self,
                                                         ConversationListBox* list);
static void _application_main_window_on_conversation_view_added_conversation_viewer_conversation_added (ConversationViewer* _sender,
                                                                                                 ConversationListBox* list,
                                                                                                 gpointer self);
static void __lambda214_ (ApplicationMainWindow* self);
static void ___lambda214__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void __lambda215_ (ApplicationMainWindow* self);
static void ___lambda215__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void _application_main_window_on_copy_conversation_folder_popover_copy_conversation (FolderPopover* _sender,
                                                                                     GearyFolder* folder,
                                                                                     gpointer self);
static void _application_main_window_on_move_conversation_folder_popover_move_conversation (FolderPopover* _sender,
                                                                                     GearyFolder* folder,
                                                                                     gpointer self);
static gboolean application_main_window_real_key_press_event (GtkWidget* base,
                                                       GdkEventKey* event);
static inline void application_main_window_check_shift_event (ApplicationMainWindow* self,
                                                GdkEventKey* event);
static gboolean application_main_window_real_key_release_event (GtkWidget* base,
                                                         GdkEventKey* event);
VALA_EXTERN gboolean application_main_window_prompt_empty_folder (ApplicationMainWindow* self,
                                                      GearyFolderSpecialUse type);
VALA_EXTERN GType alert_dialog_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType confirmation_dialog_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ConfirmationDialog* confirmation_dialog_new (GtkWindow* parent,
                                             const gchar* title,
                                             const gchar* description,
                                             const gchar* ok_button,
                                             const gchar* ok_action_type);
VALA_EXTERN ConfirmationDialog* confirmation_dialog_construct (GType object_type,
                                                   GtkWindow* parent,
                                                   const gchar* title,
                                                   const gchar* description,
                                                   const gchar* ok_button,
                                                   const gchar* ok_action_type);
VALA_EXTERN void alert_dialog_use_secondary_markup (AlertDialog* self,
                                        gboolean markup);
VALA_EXTERN void alert_dialog_set_focus_response (AlertDialog* self,
                                      GtkResponseType response);
VALA_EXTERN GtkResponseType alert_dialog_run (AlertDialog* self);
static void application_main_window_undo_data_free (gpointer _data);
static void application_main_window_undo (ApplicationMainWindow* self,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
static void application_main_window_undo_finish (ApplicationMainWindow* self,
                                          GAsyncResult* _res_);
static gboolean application_main_window_undo_co (ApplicationMainWindowUndoData* _data_);
static Block16Data* block16_data_ref (Block16Data* _data16_);
static void block16_data_unref (void * _userdata_);
static void ___lambda195_ (Block16Data* _data16_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda195__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static void application_main_window_redo_data_free (gpointer _data);
static void application_main_window_redo (ApplicationMainWindow* self,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
static void application_main_window_redo_finish (ApplicationMainWindow* self,
                                          GAsyncResult* _res_);
static gboolean application_main_window_redo_co (ApplicationMainWindowRedoData* _data_);
static Block17Data* block17_data_ref (Block17Data* _data17_);
static void block17_data_unref (void * _userdata_);
static void ___lambda196_ (Block17Data* _data17_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda196__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static GSimpleAction* application_main_window_get_edit_action (ApplicationMainWindow* self,
                                                        const gchar* name);
static gboolean application_main_window_prompt_delete_conversations (ApplicationMainWindow* self,
                                                              gint count);
static gboolean application_main_window_prompt_delete_messages (ApplicationMainWindow* self,
                                                         gint count);
static void application_main_window_load_conversations_for_email_data_free (gpointer _data);
static gboolean application_main_window_load_conversations_for_email_co (ApplicationMainWindowLoadConversationsForEmailData* _data_);
static void application_main_window_load_conversations_for_email_ready (GObject* source_object,
                                                                 GAsyncResult* _res_,
                                                                 gpointer _user_data_);
VALA_EXTERN GType composer_application_interface_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void composer_application_interface_report_problem (ComposerApplicationInterface* self,
                                                    GearyProblemReport* report);
static void application_main_window_update_ui (ApplicationMainWindow* self);
static void application_main_window_select_conversations_data_free (gpointer _data);
static gboolean application_main_window_select_conversations_co (ApplicationMainWindowSelectConversationsData* _data_);
static void application_main_window_select_conversations_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_);
static void application_main_window_open_conversation_monitor_data_free (gpointer _data);
static gboolean application_main_window_open_conversation_monitor_co (ApplicationMainWindowOpenConversationMonitorData* _data_);
static Block18Data* block18_data_ref (Block18Data* _data18_);
static void block18_data_unref (void * _userdata_);
static void application_main_window_on_scan_completed (ApplicationMainWindow* self,
                                                GearyAppConversationMonitor* monitor);
static void _application_main_window_on_scan_completed_geary_app_conversation_monitor_scan_completed (GearyAppConversationMonitor* _sender,
                                                                                               gpointer self);
static void application_main_window_on_scan_error (ApplicationMainWindow* self,
                                            GearyAppConversationMonitor* monitor,
                                            GError* err);
static void _application_main_window_on_scan_error_geary_app_conversation_monitor_scan_error (GearyAppConversationMonitor* _sender,
                                                                                       GError* err,
                                                                                       gpointer self);
static void application_main_window_on_conversation_count_changed (ApplicationMainWindow* self);
static void _application_main_window_on_conversation_count_changed_geary_app_conversation_monitor_scan_completed (GearyAppConversationMonitor* _sender,
                                                                                                           gpointer self);
static void _application_main_window_on_conversation_count_changed_geary_app_conversation_monitor_conversations_added (GearyAppConversationMonitor* _sender,
                                                                                                                GeeCollection* conversations,
                                                                                                                gpointer self);
static void _application_main_window_on_conversation_count_changed_geary_app_conversation_monitor_conversations_removed (GearyAppConversationMonitor* _sender,
                                                                                                                  GeeCollection* conversations,
                                                                                                                  gpointer self);
static void __lambda141_ (Block18Data* _data18_,
                   GObject* obj,
                   GAsyncResult* res);
static void ___lambda141__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static Block19Data* block19_data_ref (Block19Data* _data19_);
static void block19_data_unref (void * _userdata_);
static void __lambda140_ (Block19Data* _data19_,
                   GObject* obj,
                   GAsyncResult* res);
static void ___lambda140__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void application_main_window_create_composer_data_free (gpointer _data);
static void application_main_window_create_composer (ApplicationMainWindow* self,
                                              GearyAccount* send_context,
                                              ComposerWidgetContextType type,
                                              GearyEmail* context,
                                              const gchar* quote,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
static void application_main_window_create_composer_finish (ApplicationMainWindow* self,
                                                     GAsyncResult* _res_);
static gboolean application_main_window_create_composer_co (ApplicationMainWindowCreateComposerData* _data_);
VALA_EXTERN void application_controller_compose_with_context (ApplicationController* self,
                                                  ApplicationAccountContext* send_context,
                                                  ComposerWidgetContextType type,
                                                  GearyEmail* context,
                                                  const gchar* quote,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
VALA_EXTERN ComposerWidget* application_controller_compose_with_context_finish (ApplicationController* self,
                                                                    GAsyncResult* _res_);
static void application_main_window_create_composer_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_);
VALA_EXTERN void application_controller_present_composer (ApplicationController* self,
                                              ComposerWidget* composer);
static void application_main_window_create_composer_from_viewer_data_free (gpointer _data);
static void application_main_window_create_composer_from_viewer (ApplicationMainWindow* self,
                                                          ComposerWidgetContextType type,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
static void application_main_window_create_composer_from_viewer_finish (ApplicationMainWindow* self,
                                                                 GAsyncResult* _res_);
static gboolean application_main_window_create_composer_from_viewer_co (ApplicationMainWindowCreateComposerFromViewerData* _data_);
static void application_main_window_create_composer_from_viewer_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_);
VALA_EXTERN gboolean util_gtk_close_button_at_end (void);
static void application_main_window_update_context_dependent_actions (ApplicationMainWindow* self,
                                                               gboolean sensitive,
                                                               GAsyncReadyCallback _callback_,
                                                               gpointer _user_data_);
static void application_main_window_update_context_dependent_actions_finish (ApplicationMainWindow* self,
                                                                      GAsyncResult* _res_);
static void application_main_window_update_context_dependent_actions_data_free (gpointer _data);
static gboolean application_main_window_update_context_dependent_actions_co (ApplicationMainWindowUpdateContextDependentActionsData* _data_);
static void application_main_window_update_context_dependent_actions_ready (GObject* source_object,
                                                                     GAsyncResult* _res_,
                                                                     gpointer _user_data_);
static void application_main_window_set_shift_key_down (ApplicationMainWindow* self,
                                                 gboolean down);
static void application_main_window_focus_widget (ApplicationMainWindow* self,
                                           GtkWidget* widget);
static void application_main_window_focus_next_pane (ApplicationMainWindow* self);
static void application_main_window_focus_previous_pane (ApplicationMainWindow* self);
static void application_main_window_reply_conversation (ApplicationMainWindow* self,
                                                 ComposerWidgetContextType context_type);
static Block20Data* block20_data_ref (Block20Data* _data20_);
static void block20_data_unref (void * _userdata_);
static gboolean ___lambda197_ (Block20Data* _data20_);
static gboolean ____lambda197__gsource_func (gpointer self);
static void application_main_window_on_map (ApplicationMainWindow* self);
static void _application_main_window_on_map_gtk_widget_map (GtkWidget* _sender,
                                                     gpointer self);
static void application_main_window_on_unmap (ApplicationMainWindow* self);
static void _application_main_window_on_unmap_gtk_widget_unmap (GtkWidget* _sender,
                                                         gpointer self);
static gboolean application_main_window_on_focus_event (ApplicationMainWindow* self);
static gboolean _application_main_window_on_focus_event_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                             GdkEventFocus* event,
                                                                             gpointer self);
static gboolean application_main_window_on_delete_event (ApplicationMainWindow* self);
static void ___lambda217_ (ApplicationMainWindow* self,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda217__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static gboolean _application_main_window_on_delete_event_gtk_widget_delete_event (GtkWidget* _sender,
                                                                           GdkEventAny* event,
                                                                           gpointer self);
static void application_main_window_on_outer_leaflet_changed (ApplicationMainWindow* self);
static void _application_main_window_on_outer_leaflet_changed_g_object_notify (GObject* _sender,
                                                                        GParamSpec* pspec,
                                                                        gpointer self);
static void application_main_window_on_inner_leaflet_changed (ApplicationMainWindow* self);
static void _application_main_window_on_inner_leaflet_changed_g_object_notify (GObject* _sender,
                                                                        GParamSpec* pspec,
                                                                        gpointer self);
static void application_main_window_on_email_loaded (ApplicationMainWindow* self,
                                              ConversationListBox* view,
                                              GearyEmail* loaded);
static void _application_main_window_on_email_loaded_conversation_list_box_email_loaded (ConversationListBox* _sender,
                                                                                  GearyEmail* email,
                                                                                  gpointer self);
static void application_main_window_on_email_mark (ApplicationMainWindow* self,
                                            ConversationListBox* view,
                                            GeeCollection* messages,
                                            GearyNamedFlag* to_add,
                                            GearyNamedFlag* to_remove);
static void _application_main_window_on_email_mark_conversation_list_box_mark_email (ConversationListBox* _sender,
                                                                              GeeCollection* email,
                                                                              GearyNamedFlag* to_add,
                                                                              GearyNamedFlag* to_remove,
                                                                              gpointer self);
static void application_main_window_on_email_reply_to_all (ApplicationMainWindow* self,
                                                    GearyEmail* target,
                                                    const gchar* quote);
static void _application_main_window_on_email_reply_to_all_conversation_list_box_reply_to_all_email (ConversationListBox* _sender,
                                                                                              GearyEmail* email,
                                                                                              const gchar* quote,
                                                                                              gpointer self);
static void application_main_window_on_email_reply_to_sender (ApplicationMainWindow* self,
                                                       GearyEmail* target,
                                                       const gchar* quote);
static void _application_main_window_on_email_reply_to_sender_conversation_list_box_reply_to_sender_email (ConversationListBox* _sender,
                                                                                                    GearyEmail* email,
                                                                                                    const gchar* quote,
                                                                                                    gpointer self);
static void application_main_window_on_email_forward (ApplicationMainWindow* self,
                                               GearyEmail* target,
                                               const gchar* quote);
static void _application_main_window_on_email_forward_conversation_list_box_forward_email (ConversationListBox* _sender,
                                                                                    GearyEmail* email,
                                                                                    const gchar* quote,
                                                                                    gpointer self);
static void application_main_window_on_email_trash (ApplicationMainWindow* self,
                                             ConversationListBox* view,
                                             GearyEmail* target);
static void _application_main_window_on_email_trash_conversation_list_box_trash_email (ConversationListBox* _sender,
                                                                                GearyEmail* email,
                                                                                gpointer self);
static void application_main_window_on_email_delete (ApplicationMainWindow* self,
                                              ConversationListBox* view,
                                              GearyEmail* target);
static void _application_main_window_on_email_delete_conversation_list_box_delete_email (ConversationListBox* _sender,
                                                                                  GearyEmail* email,
                                                                                  gpointer self);
VALA_EXTERN void application_controller_clear_new_messages (ApplicationController* self,
                                                GearyFolder* source,
                                                GeeSet* visible);
static Block21Data* block21_data_ref (Block21Data* _data21_);
static void block21_data_unref (void * _userdata_);
VALA_EXTERN void application_controller_mark_conversations (ApplicationController* self,
                                                GearyFolder* location,
                                                GeeCollection* conversations,
                                                GearyNamedFlag* flag,
                                                gboolean prefer_adding,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
VALA_EXTERN void application_controller_mark_conversations_finish (ApplicationController* self,
                                                       GAsyncResult* _res_,
                                                       GError** error);
static void ___lambda210_ (Block21Data* _data21_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda210__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block22Data* block22_data_ref (Block22Data* _data22_);
static void block22_data_unref (void * _userdata_);
static void ___lambda201_ (Block22Data* _data22_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda201__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block23Data* block23_data_ref (Block23Data* _data23_);
static void block23_data_unref (void * _userdata_);
static void ___lambda202_ (Block23Data* _data23_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda202__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block24Data* block24_data_ref (Block24Data* _data24_);
static void block24_data_unref (void * _userdata_);
static void ___lambda203_ (Block24Data* _data24_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda203__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block25Data* block25_data_ref (Block25Data* _data25_);
static void block25_data_unref (void * _userdata_);
static void ___lambda204_ (Block25Data* _data25_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda204__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block26Data* block26_data_ref (Block26Data* _data26_);
static void block26_data_unref (void * _userdata_);
VALA_EXTERN void application_controller_move_conversations_special (ApplicationController* self,
                                                        GearyFolder* source,
                                                        GearyFolderSpecialUse destination,
                                                        GeeCollection* conversations,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_);
VALA_EXTERN void application_controller_move_conversations_special_finish (ApplicationController* self,
                                                               GAsyncResult* _res_,
                                                               GError** error);
static void ___lambda205_ (Block26Data* _data26_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda205__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block27Data* block27_data_ref (Block27Data* _data27_);
static void block27_data_unref (void * _userdata_);
VALA_EXTERN void application_controller_move_conversations (ApplicationController* self,
                                                GearyFolderSupportMove* source,
                                                GearyFolder* destination,
                                                GeeCollection* conversations,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
VALA_EXTERN void application_controller_move_conversations_finish (ApplicationController* self,
                                                       GAsyncResult* _res_,
                                                       GError** error);
static void ___lambda208_ (Block27Data* _data27_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda208__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block28Data* block28_data_ref (Block28Data* _data28_);
static void block28_data_unref (void * _userdata_);
VALA_EXTERN void application_controller_copy_conversations (ApplicationController* self,
                                                GearyFolderSupportCopy* source,
                                                GearyFolder* destination,
                                                GeeCollection* conversations,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
VALA_EXTERN void application_controller_copy_conversations_finish (ApplicationController* self,
                                                       GAsyncResult* _res_,
                                                       GError** error);
static void ___lambda209_ (Block28Data* _data28_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda209__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block29Data* block29_data_ref (Block29Data* _data29_);
static void block29_data_unref (void * _userdata_);
static void ___lambda198_ (Block29Data* _data29_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda198__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block30Data* block30_data_ref (Block30Data* _data30_);
static void block30_data_unref (void * _userdata_);
static void ___lambda199_ (Block30Data* _data30_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda199__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block31Data* block31_data_ref (Block31Data* _data31_);
static void block31_data_unref (void * _userdata_);
VALA_EXTERN void application_controller_delete_conversations (ApplicationController* self,
                                                  GearyFolderSupportRemove* target,
                                                  GeeCollection* conversations,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
VALA_EXTERN void application_controller_delete_conversations_finish (ApplicationController* self,
                                                         GAsyncResult* _res_,
                                                         GError** error);
static void ___lambda200_ (Block31Data* _data31_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda200__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
VALA_EXTERN void application_controller_email_loaded (ApplicationController* self,
                                          GearyAccountInformation* account,
                                          GearyEmail* loaded);
static Block32Data* block32_data_ref (Block32Data* _data32_);
static void block32_data_unref (void * _userdata_);
VALA_EXTERN void application_controller_mark_messages (ApplicationController* self,
                                           GearyFolder* location,
                                           GeeCollection* conversations,
                                           GeeCollection* messages,
                                           GearyEmailFlags* to_add,
                                           GearyEmailFlags* to_remove,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
VALA_EXTERN void application_controller_mark_messages_finish (ApplicationController* self,
                                                  GAsyncResult* _res_,
                                                  GError** error);
static void ___lambda211_ (Block32Data* _data32_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda211__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block33Data* block33_data_ref (Block33Data* _data33_);
static void block33_data_unref (void * _userdata_);
VALA_EXTERN void application_controller_move_messages_special (ApplicationController* self,
                                                   GearyFolder* source,
                                                   GearyFolderSpecialUse destination,
                                                   GeeCollection* conversations,
                                                   GeeCollection* messages,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
VALA_EXTERN void application_controller_move_messages_special_finish (ApplicationController* self,
                                                          GAsyncResult* _res_,
                                                          GError** error);
static void ___lambda212_ (Block33Data* _data33_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda212__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block34Data* block34_data_ref (Block34Data* _data34_);
static void block34_data_unref (void * _userdata_);
VALA_EXTERN void application_controller_delete_messages (ApplicationController* self,
                                             GearyFolderSupportRemove* target,
                                             GeeCollection* conversations,
                                             GeeCollection* messages,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
VALA_EXTERN void application_controller_delete_messages_finish (ApplicationController* self,
                                                    GAsyncResult* _res_,
                                                    GError** error);
static void ___lambda213_ (Block34Data* _data34_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda213__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static void application_main_window_finalize (GObject * obj);
static GType application_main_window_get_type_once (void);
static void _vala_application_main_window_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_application_main_window_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GActionEntry APPLICATION_MAIN_WINDOW_EDIT_ACTIONS[2] = {{ACTION_EDIT_UNDO, _application_main_window_on_undo_gsimple_action_activate_callback}, {ACTION_EDIT_REDO, _application_main_window_on_redo_gsimple_action_activate_callback}};
static const GActionEntry APPLICATION_MAIN_WINDOW_WINDOW_ACTIONS[22] = {{ACTION_WINDOW_CLOSE, _application_main_window_on_close_gsimple_action_activate_callback}, {ACTION_WINDOW_SHOW_HELP_OVERLAY, _application_main_window_on_show_help_overlay_gsimple_action_activate_callback}, {ACTION_WINDOW_SHOW_MENU, _application_main_window_on_show_window_menu_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_FIND_IN_CONVERSATION, _application_main_window_on_find_in_conversation_action_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_SEARCH, _application_main_window_on_search_activated_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_SELECT_INBOX, _application_main_window_on_select_inbox_gsimple_action_activate_callback, "i"}, {APPLICATION_MAIN_WINDOW_ACTION_NAVIGATION_BACK, _application_main_window_go_to_previous_pane_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_REPLY_CONVERSATION, _application_main_window_on_reply_conversation_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_REPLY_ALL_CONVERSATION, _application_main_window_on_reply_all_conversation_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_FORWARD_CONVERSATION, _application_main_window_on_forward_conversation_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_ARCHIVE_CONVERSATION, _application_main_window_on_archive_conversation_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_TRASH_CONVERSATION, _application_main_window_on_trash_conversation_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_DELETE_CONVERSATION, _application_main_window_on_delete_conversation_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_SHOW_COPY_MENU, _application_main_window_on_show_copy_menu_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_CONVERSATION_UP, _application_main_window_on_conversation_up_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_CONVERSATION_DOWN, _application_main_window_on_conversation_down_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_READ, _application_main_window_on_mark_as_read_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_UNREAD, _application_main_window_on_mark_as_unread_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_STARRED, _application_main_window_on_mark_as_starred_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_UNSTARRED, _application_main_window_on_mark_as_unstarred_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_TOGGLE_JUNK, _application_main_window_on_mark_as_junk_toggle_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_ZOOM, _application_main_window_on_zoom_gsimple_action_activate_callback, "s"}};

static inline gpointer
application_main_window_get_instance_private (ApplicationMainWindow* self)
{
	return G_STRUCT_MEMBER_P (self, ApplicationMainWindow_private_offset);
}

static ApplicationMainWindowConversationCount
application_main_window_conversation_count_for_size (gint size)
{
	ApplicationMainWindowConversationCount _tmp0_ = 0;
	ApplicationMainWindowConversationCount result;
#line 273 "../src/client/application/application-main-window.vala"
	if (size == 0) {
#line 275 "../src/client/application/application-main-window.vala"
		_tmp0_ = APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_NONE;
#line 1754 "application-main-window.c"
	} else {
		ApplicationMainWindowConversationCount _tmp1_ = 0;
#line 276 "../src/client/application/application-main-window.vala"
		if (size == 1) {
#line 277 "../src/client/application/application-main-window.vala"
			_tmp1_ = APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_SINGLE;
#line 1761 "application-main-window.c"
		} else {
#line 278 "../src/client/application/application-main-window.vala"
			_tmp1_ = APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_MULTIPLE;
#line 1765 "application-main-window.c"
		}
#line 276 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp1_;
#line 1769 "application-main-window.c"
	}
#line 273 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 273 "../src/client/application/application-main-window.vala"
	return result;
#line 1775 "application-main-window.c"
}

static GType
application_main_window_conversation_count_get_type_once (void)
{
	static const GEnumValue values[] = {{APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_NONE, "APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_NONE", "none"}, {APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_SINGLE, "APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_SINGLE", "single"}, {APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_MULTIPLE, "APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_MULTIPLE", "multiple"}, {0, NULL, NULL}};
	GType application_main_window_conversation_count_type_id;
	application_main_window_conversation_count_type_id = g_enum_register_static ("ApplicationMainWindowConversationCount", values);
	return application_main_window_conversation_count_type_id;
}

static GType
application_main_window_conversation_count_get_type (void)
{
	static volatile gsize application_main_window_conversation_count_type_id__once = 0;
	if (g_once_init_enter (&application_main_window_conversation_count_type_id__once)) {
		GType application_main_window_conversation_count_type_id;
		application_main_window_conversation_count_type_id = application_main_window_conversation_count_get_type_once ();
		g_once_init_leave (&application_main_window_conversation_count_type_id__once, application_main_window_conversation_count_type_id);
	}
	return application_main_window_conversation_count_type_id__once;
}

static void
_application_main_window_on_undo_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
#line 35 "../src/client/application/application-main-window.vala"
	application_main_window_on_undo ((ApplicationMainWindow*) self);
#line 1806 "application-main-window.c"
}

static void
_application_main_window_on_redo_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
#line 35 "../src/client/application/application-main-window.vala"
	application_main_window_on_redo ((ApplicationMainWindow*) self);
#line 1816 "application-main-window.c"
}

static void
_application_main_window_on_close_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self)
{
#line 40 "../src/client/application/application-main-window.vala"
	application_main_window_on_close ((ApplicationMainWindow*) self);
#line 1826 "application-main-window.c"
}

static void
_application_main_window_on_show_help_overlay_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self)
{
#line 40 "../src/client/application/application-main-window.vala"
	application_main_window_on_show_help_overlay ((ApplicationMainWindow*) self);
#line 1836 "application-main-window.c"
}

static void
_application_main_window_on_show_window_menu_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self)
{
#line 40 "../src/client/application/application-main-window.vala"
	application_main_window_on_show_window_menu ((ApplicationMainWindow*) self);
#line 1846 "application-main-window.c"
}

static void
_application_main_window_on_find_in_conversation_action_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                          GVariant* parameter,
                                                                                          gpointer self)
{
#line 40 "../src/client/application/application-main-window.vala"
	application_main_window_on_find_in_conversation_action ((ApplicationMainWindow*) self);
#line 1856 "application-main-window.c"
}

static void
_application_main_window_on_search_activated_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self)
{
#line 40 "../src/client/application/application-main-window.vala"
	application_main_window_on_search_activated ((ApplicationMainWindow*) self);
#line 1866 "application-main-window.c"
}

static void
_application_main_window_on_select_inbox_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self)
{
#line 40 "../src/client/application/application-main-window.vala"
	application_main_window_on_select_inbox ((ApplicationMainWindow*) self, action, parameter);
#line 1876 "application-main-window.c"
}

static void
_application_main_window_go_to_previous_pane_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self)
{
#line 40 "../src/client/application/application-main-window.vala"
	application_main_window_go_to_previous_pane ((ApplicationMainWindow*) self);
#line 1886 "application-main-window.c"
}

static void
_application_main_window_on_reply_conversation_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self)
{
#line 40 "../src/client/application/application-main-window.vala"
	application_main_window_on_reply_conversation ((ApplicationMainWindow*) self);
#line 1896 "application-main-window.c"
}

static void
_application_main_window_on_reply_all_conversation_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                     GVariant* parameter,
                                                                                     gpointer self)
{
#line 40 "../src/client/application/application-main-window.vala"
	application_main_window_on_reply_all_conversation ((ApplicationMainWindow*) self);
#line 1906 "application-main-window.c"
}

static void
_application_main_window_on_forward_conversation_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self)
{
#line 40 "../src/client/application/application-main-window.vala"
	application_main_window_on_forward_conversation ((ApplicationMainWindow*) self);
#line 1916 "application-main-window.c"
}

static void
_application_main_window_on_archive_conversation_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self)
{
#line 40 "../src/client/application/application-main-window.vala"
	application_main_window_on_archive_conversation ((ApplicationMainWindow*) self);
#line 1926 "application-main-window.c"
}

static void
_application_main_window_on_trash_conversation_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self)
{
#line 40 "../src/client/application/application-main-window.vala"
	application_main_window_on_trash_conversation ((ApplicationMainWindow*) self);
#line 1936 "application-main-window.c"
}

static void
_application_main_window_on_delete_conversation_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self)
{
#line 40 "../src/client/application/application-main-window.vala"
	application_main_window_on_delete_conversation ((ApplicationMainWindow*) self);
#line 1946 "application-main-window.c"
}

static void
_application_main_window_on_show_copy_menu_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self)
{
#line 40 "../src/client/application/application-main-window.vala"
	application_main_window_on_show_copy_menu ((ApplicationMainWindow*) self);
#line 1956 "application-main-window.c"
}

static void
_application_main_window_on_conversation_up_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self)
{
#line 40 "../src/client/application/application-main-window.vala"
	application_main_window_on_conversation_up ((ApplicationMainWindow*) self);
#line 1966 "application-main-window.c"
}

static void
_application_main_window_on_conversation_down_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self)
{
#line 40 "../src/client/application/application-main-window.vala"
	application_main_window_on_conversation_down ((ApplicationMainWindow*) self);
#line 1976 "application-main-window.c"
}

static void
_application_main_window_on_mark_as_read_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self)
{
#line 40 "../src/client/application/application-main-window.vala"
	application_main_window_on_mark_as_read ((ApplicationMainWindow*) self);
#line 1986 "application-main-window.c"
}

static void
_application_main_window_on_mark_as_unread_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self)
{
#line 40 "../src/client/application/application-main-window.vala"
	application_main_window_on_mark_as_unread ((ApplicationMainWindow*) self);
#line 1996 "application-main-window.c"
}

static void
_application_main_window_on_mark_as_starred_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self)
{
#line 40 "../src/client/application/application-main-window.vala"
	application_main_window_on_mark_as_starred ((ApplicationMainWindow*) self);
#line 2006 "application-main-window.c"
}

static void
_application_main_window_on_mark_as_unstarred_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self)
{
#line 40 "../src/client/application/application-main-window.vala"
	application_main_window_on_mark_as_unstarred ((ApplicationMainWindow*) self);
#line 2016 "application-main-window.c"
}

static void
_application_main_window_on_mark_as_junk_toggle_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self)
{
#line 40 "../src/client/application/application-main-window.vala"
	application_main_window_on_mark_as_junk_toggle ((ApplicationMainWindow*) self);
#line 2026 "application-main-window.c"
}

static void
_application_main_window_on_zoom_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
#line 40 "../src/client/application/application-main-window.vala"
	application_main_window_on_zoom ((ApplicationMainWindow*) self, action, parameter);
#line 2036 "application-main-window.c"
}

void
application_main_window_add_accelerators (ApplicationClient* owner)
{
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar** _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gchar* _tmp13_;
	gchar** _tmp14_;
	gchar** _tmp15_;
	gint _tmp15__length1;
	gchar* _tmp16_;
	gchar** _tmp17_;
	gchar** _tmp18_;
	gint _tmp18__length1;
#line 249 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (owner));
#line 2057 "application-main-window.c"
	{
		gint i = 0;
#line 250 "../src/client/application/application-main-window.vala"
		i = 1;
#line 2062 "application-main-window.c"
		{
			gboolean _tmp0_ = FALSE;
#line 250 "../src/client/application/application-main-window.vala"
			_tmp0_ = TRUE;
#line 250 "../src/client/application/application-main-window.vala"
			while (TRUE) {
#line 2069 "application-main-window.c"
				gchar* _tmp2_;
				gchar* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				gchar* _tmp6_;
				gchar** _tmp7_;
				gchar** _tmp8_;
				gint _tmp8__length1;
#line 250 "../src/client/application/application-main-window.vala"
				if (!_tmp0_) {
#line 2080 "application-main-window.c"
					gint _tmp1_;
#line 250 "../src/client/application/application-main-window.vala"
					_tmp1_ = i;
#line 250 "../src/client/application/application-main-window.vala"
					i = _tmp1_ + 1;
#line 2086 "application-main-window.c"
				}
#line 250 "../src/client/application/application-main-window.vala"
				_tmp0_ = FALSE;
#line 250 "../src/client/application/application-main-window.vala"
				if (!(i <= 9)) {
#line 250 "../src/client/application/application-main-window.vala"
					break;
#line 2094 "application-main-window.c"
				}
#line 251 "../src/client/application/application-main-window.vala"
				_tmp2_ = g_strdup_printf ("(%d)", i - 1);
#line 251 "../src/client/application/application-main-window.vala"
				_tmp3_ = _tmp2_;
#line 251 "../src/client/application/application-main-window.vala"
				_tmp4_ = g_strconcat (APPLICATION_MAIN_WINDOW_ACTION_SELECT_INBOX, _tmp3_, NULL);
#line 251 "../src/client/application/application-main-window.vala"
				_tmp5_ = _tmp4_;
#line 251 "../src/client/application/application-main-window.vala"
				_tmp6_ = g_strdup_printf ("<ALT>%d", i);
#line 251 "../src/client/application/application-main-window.vala"
				_tmp7_ = g_new0 (gchar*, 1 + 1);
#line 251 "../src/client/application/application-main-window.vala"
				_tmp7_[0] = _tmp6_;
#line 251 "../src/client/application/application-main-window.vala"
				_tmp8_ = _tmp7_;
#line 251 "../src/client/application/application-main-window.vala"
				_tmp8__length1 = 1;
#line 251 "../src/client/application/application-main-window.vala"
				application_client_add_window_accelerators (owner, _tmp5_, _tmp8_, (gint) 1, NULL);
#line 251 "../src/client/application/application-main-window.vala"
				_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 251 "../src/client/application/application-main-window.vala"
				_g_free0 (_tmp5_);
#line 251 "../src/client/application/application-main-window.vala"
				_g_free0 (_tmp3_);
#line 2122 "application-main-window.c"
			}
		}
	}
#line 257 "../src/client/application/application-main-window.vala"
	_tmp9_ = g_strdup ("<Ctrl>equal");
#line 257 "../src/client/application/application-main-window.vala"
	_tmp10_ = g_strdup ("<Ctrl>plus");
#line 257 "../src/client/application/application-main-window.vala"
	_tmp11_ = g_new0 (gchar*, 2 + 1);
#line 257 "../src/client/application/application-main-window.vala"
	_tmp11_[0] = _tmp9_;
#line 257 "../src/client/application/application-main-window.vala"
	_tmp11_[1] = _tmp10_;
#line 257 "../src/client/application/application-main-window.vala"
	_tmp12_ = _tmp11_;
#line 257 "../src/client/application/application-main-window.vala"
	_tmp12__length1 = 2;
#line 257 "../src/client/application/application-main-window.vala"
	application_client_add_window_accelerators (owner, APPLICATION_MAIN_WINDOW_ACTION_ZOOM "('in')", _tmp12_, (gint) 2, NULL);
#line 257 "../src/client/application/application-main-window.vala"
	_tmp12_ = (_vala_array_free (_tmp12_, _tmp12__length1, (GDestroyNotify) g_free), NULL);
#line 260 "../src/client/application/application-main-window.vala"
	_tmp13_ = g_strdup ("<Ctrl>minus");
#line 260 "../src/client/application/application-main-window.vala"
	_tmp14_ = g_new0 (gchar*, 1 + 1);
#line 260 "../src/client/application/application-main-window.vala"
	_tmp14_[0] = _tmp13_;
#line 260 "../src/client/application/application-main-window.vala"
	_tmp15_ = _tmp14_;
#line 260 "../src/client/application/application-main-window.vala"
	_tmp15__length1 = 1;
#line 260 "../src/client/application/application-main-window.vala"
	application_client_add_window_accelerators (owner, APPLICATION_MAIN_WINDOW_ACTION_ZOOM "('out')", _tmp15_, (gint) 1, NULL);
#line 260 "../src/client/application/application-main-window.vala"
	_tmp15_ = (_vala_array_free (_tmp15_, _tmp15__length1, (GDestroyNotify) g_free), NULL);
#line 263 "../src/client/application/application-main-window.vala"
	_tmp16_ = g_strdup ("<Ctrl>0");
#line 263 "../src/client/application/application-main-window.vala"
	_tmp17_ = g_new0 (gchar*, 1 + 1);
#line 263 "../src/client/application/application-main-window.vala"
	_tmp17_[0] = _tmp16_;
#line 263 "../src/client/application/application-main-window.vala"
	_tmp18_ = _tmp17_;
#line 263 "../src/client/application/application-main-window.vala"
	_tmp18__length1 = 1;
#line 263 "../src/client/application/application-main-window.vala"
	application_client_add_window_accelerators (owner, APPLICATION_MAIN_WINDOW_ACTION_ZOOM "('normal')", _tmp18_, (gint) 1, NULL);
#line 263 "../src/client/application/application-main-window.vala"
	_tmp18_ = (_vala_array_free (_tmp18_, _tmp18__length1, (GDestroyNotify) g_free), NULL);
#line 2172 "application-main-window.c"
}

ApplicationClient*
application_main_window_get_application (ApplicationMainWindow* self)
{
	ApplicationClient* result;
	GtkApplication* _tmp0_;
#line 286 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 286 "../src/client/application/application-main-window.vala"
	_tmp0_ = gtk_window_get_application (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), gtk_window_get_type (), GtkWindow));
#line 286 "../src/client/application/application-main-window.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, APPLICATION_TYPE_CLIENT, ApplicationClient);
#line 286 "../src/client/application/application-main-window.vala"
	return result;
#line 2188 "application-main-window.c"
}

void
application_main_window_set_application (ApplicationMainWindow* self,
                                         ApplicationClient* value)
{
#line 287 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 287 "../src/client/application/application-main-window.vala"
	gtk_window_set_application (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), gtk_window_get_type (), GtkWindow), G_TYPE_CHECK_INSTANCE_CAST (value, gtk_application_get_type (), GtkApplication));
#line 287 "../src/client/application/application-main-window.vala"
	g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_APPLICATION_PROPERTY]);
#line 2201 "application-main-window.c"
}

GearyAccount*
application_main_window_get_selected_account (ApplicationMainWindow* self)
{
	GearyAccount* result;
	GearyAccount* _tmp0_;
#line 291 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 291 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_account;
#line 291 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 291 "../src/client/application/application-main-window.vala"
	return result;
#line 2217 "application-main-window.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 291 "../src/client/application/application-main-window.vala"
	return self ? g_object_ref (self) : NULL;
#line 2225 "application-main-window.c"
}

static void
application_main_window_set_selected_account (ApplicationMainWindow* self,
                                              GearyAccount* value)
{
	GearyAccount* old_value;
#line 291 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 291 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_selected_account (self);
#line 291 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 2239 "application-main-window.c"
		GearyAccount* _tmp0_;
#line 291 "../src/client/application/application-main-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 291 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self->priv->_selected_account);
#line 291 "../src/client/application/application-main-window.vala"
		self->priv->_selected_account = _tmp0_;
#line 291 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_SELECTED_ACCOUNT_PROPERTY]);
#line 2249 "application-main-window.c"
	}
}

GearyFolder*
application_main_window_get_selected_folder (ApplicationMainWindow* self)
{
	GearyFolder* result;
	GearyFolder* _tmp0_;
#line 294 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 294 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 294 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 294 "../src/client/application/application-main-window.vala"
	return result;
#line 2266 "application-main-window.c"
}

static void
application_main_window_set_selected_folder (ApplicationMainWindow* self,
                                             GearyFolder* value)
{
	GearyFolder* old_value;
#line 294 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 294 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_selected_folder (self);
#line 294 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 2280 "application-main-window.c"
		GearyFolder* _tmp0_;
#line 294 "../src/client/application/application-main-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 294 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self->priv->_selected_folder);
#line 294 "../src/client/application/application-main-window.vala"
		self->priv->_selected_folder = _tmp0_;
#line 294 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_SELECTED_FOLDER_PROPERTY]);
#line 2290 "application-main-window.c"
	}
}

GearyAppConversationMonitor*
application_main_window_get_conversations (ApplicationMainWindow* self)
{
	GearyAppConversationMonitor* result;
	GearyAppConversationMonitor* _tmp0_;
#line 298 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 298 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversations;
#line 298 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 298 "../src/client/application/application-main-window.vala"
	return result;
#line 2307 "application-main-window.c"
}

static void
application_main_window_set_conversations (ApplicationMainWindow* self,
                                           GearyAppConversationMonitor* value)
{
	GearyAppConversationMonitor* old_value;
#line 298 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 298 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_conversations (self);
#line 298 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 2321 "application-main-window.c"
		GearyAppConversationMonitor* _tmp0_;
#line 298 "../src/client/application/application-main-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 298 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self->priv->_conversations);
#line 298 "../src/client/application/application-main-window.vala"
		self->priv->_conversations = _tmp0_;
#line 298 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_CONVERSATIONS_PROPERTY]);
#line 2331 "application-main-window.c"
	}
}

gboolean
application_main_window_get_is_folder_list_shown (ApplicationMainWindow* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	HdyLeaflet* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 303 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 305 "../src/client/application/application-main-window.vala"
	_tmp2_ = self->priv->outer_leaflet;
#line 305 "../src/client/application/application-main-window.vala"
	_tmp3_ = hdy_leaflet_get_folded (_tmp2_);
#line 305 "../src/client/application/application-main-window.vala"
	_tmp4_ = _tmp3_;
#line 305 "../src/client/application/application-main-window.vala"
	if (!_tmp4_) {
#line 305 "../src/client/application/application-main-window.vala"
		_tmp1_ = TRUE;
#line 2356 "application-main-window.c"
	} else {
		HdyLeaflet* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 306 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->outer_leaflet;
#line 306 "../src/client/application/application-main-window.vala"
		_tmp6_ = hdy_leaflet_get_visible_child_name (_tmp5_);
#line 306 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 306 "../src/client/application/application-main-window.vala"
		_tmp1_ = g_strcmp0 (_tmp7_, APPLICATION_MAIN_WINDOW_INNER_LEAFLET) == 0;
#line 2369 "application-main-window.c"
	}
#line 304 "../src/client/application/application-main-window.vala"
	if (_tmp1_) {
#line 2373 "application-main-window.c"
		gboolean _tmp8_ = FALSE;
		HdyLeaflet* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
#line 307 "../src/client/application/application-main-window.vala"
		_tmp9_ = self->priv->inner_leaflet;
#line 307 "../src/client/application/application-main-window.vala"
		_tmp10_ = hdy_leaflet_get_folded (_tmp9_);
#line 307 "../src/client/application/application-main-window.vala"
		_tmp11_ = _tmp10_;
#line 307 "../src/client/application/application-main-window.vala"
		if (!_tmp11_) {
#line 307 "../src/client/application/application-main-window.vala"
			_tmp8_ = TRUE;
#line 2388 "application-main-window.c"
		} else {
			HdyLeaflet* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
#line 308 "../src/client/application/application-main-window.vala"
			_tmp12_ = self->priv->inner_leaflet;
#line 308 "../src/client/application/application-main-window.vala"
			_tmp13_ = hdy_leaflet_get_visible_child_name (_tmp12_);
#line 308 "../src/client/application/application-main-window.vala"
			_tmp14_ = _tmp13_;
#line 308 "../src/client/application/application-main-window.vala"
			_tmp8_ = g_strcmp0 (_tmp14_, APPLICATION_MAIN_WINDOW_FOLDER_LIST) == 0;
#line 2401 "application-main-window.c"
		}
#line 307 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp8_;
#line 2405 "application-main-window.c"
	} else {
#line 305 "../src/client/application/application-main-window.vala"
		_tmp0_ = FALSE;
#line 2409 "application-main-window.c"
	}
#line 304 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 304 "../src/client/application/application-main-window.vala"
	return result;
#line 2415 "application-main-window.c"
}

gboolean
application_main_window_get_is_conversation_list_shown (ApplicationMainWindow* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	HdyLeaflet* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 315 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 317 "../src/client/application/application-main-window.vala"
	_tmp2_ = self->priv->outer_leaflet;
#line 317 "../src/client/application/application-main-window.vala"
	_tmp3_ = hdy_leaflet_get_folded (_tmp2_);
#line 317 "../src/client/application/application-main-window.vala"
	_tmp4_ = _tmp3_;
#line 317 "../src/client/application/application-main-window.vala"
	if (!_tmp4_) {
#line 317 "../src/client/application/application-main-window.vala"
		_tmp1_ = TRUE;
#line 2439 "application-main-window.c"
	} else {
		HdyLeaflet* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 318 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->outer_leaflet;
#line 318 "../src/client/application/application-main-window.vala"
		_tmp6_ = hdy_leaflet_get_visible_child_name (_tmp5_);
#line 318 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 318 "../src/client/application/application-main-window.vala"
		_tmp1_ = g_strcmp0 (_tmp7_, APPLICATION_MAIN_WINDOW_INNER_LEAFLET) == 0;
#line 2452 "application-main-window.c"
	}
#line 316 "../src/client/application/application-main-window.vala"
	if (_tmp1_) {
#line 2456 "application-main-window.c"
		gboolean _tmp8_ = FALSE;
		HdyLeaflet* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
#line 319 "../src/client/application/application-main-window.vala"
		_tmp9_ = self->priv->inner_leaflet;
#line 319 "../src/client/application/application-main-window.vala"
		_tmp10_ = hdy_leaflet_get_folded (_tmp9_);
#line 319 "../src/client/application/application-main-window.vala"
		_tmp11_ = _tmp10_;
#line 319 "../src/client/application/application-main-window.vala"
		if (!_tmp11_) {
#line 319 "../src/client/application/application-main-window.vala"
			_tmp8_ = TRUE;
#line 2471 "application-main-window.c"
		} else {
			HdyLeaflet* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
#line 320 "../src/client/application/application-main-window.vala"
			_tmp12_ = self->priv->inner_leaflet;
#line 320 "../src/client/application/application-main-window.vala"
			_tmp13_ = hdy_leaflet_get_visible_child_name (_tmp12_);
#line 320 "../src/client/application/application-main-window.vala"
			_tmp14_ = _tmp13_;
#line 320 "../src/client/application/application-main-window.vala"
			_tmp8_ = g_strcmp0 (_tmp14_, APPLICATION_MAIN_WINDOW_CONVERSATION_LIST) == 0;
#line 2484 "application-main-window.c"
		}
#line 319 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp8_;
#line 2488 "application-main-window.c"
	} else {
#line 317 "../src/client/application/application-main-window.vala"
		_tmp0_ = FALSE;
#line 2492 "application-main-window.c"
	}
#line 316 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 316 "../src/client/application/application-main-window.vala"
	return result;
#line 2498 "application-main-window.c"
}

gboolean
application_main_window_get_is_conversation_viewer_shown (ApplicationMainWindow* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	HdyLeaflet* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 327 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 329 "../src/client/application/application-main-window.vala"
	_tmp2_ = self->priv->outer_leaflet;
#line 329 "../src/client/application/application-main-window.vala"
	_tmp3_ = hdy_leaflet_get_folded (_tmp2_);
#line 329 "../src/client/application/application-main-window.vala"
	_tmp4_ = _tmp3_;
#line 329 "../src/client/application/application-main-window.vala"
	if (!_tmp4_) {
#line 329 "../src/client/application/application-main-window.vala"
		_tmp1_ = TRUE;
#line 2522 "application-main-window.c"
	} else {
		HdyLeaflet* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 330 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->outer_leaflet;
#line 330 "../src/client/application/application-main-window.vala"
		_tmp6_ = hdy_leaflet_get_visible_child_name (_tmp5_);
#line 330 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 330 "../src/client/application/application-main-window.vala"
		_tmp1_ = g_strcmp0 (_tmp7_, APPLICATION_MAIN_WINDOW_CONVERSATION_VIEWER) == 0;
#line 2535 "application-main-window.c"
	}
#line 328 "../src/client/application/application-main-window.vala"
	if (_tmp1_) {
#line 2539 "application-main-window.c"
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 331 "../src/client/application/application-main-window.vala"
		_tmp8_ = application_main_window_get_has_composer (self);
#line 331 "../src/client/application/application-main-window.vala"
		_tmp9_ = _tmp8_;
#line 331 "../src/client/application/application-main-window.vala"
		_tmp0_ = !_tmp9_;
#line 2548 "application-main-window.c"
	} else {
#line 329 "../src/client/application/application-main-window.vala"
		_tmp0_ = FALSE;
#line 2552 "application-main-window.c"
	}
#line 328 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 328 "../src/client/application/application-main-window.vala"
	return result;
#line 2558 "application-main-window.c"
}

ApplicationAttachmentManager*
application_main_window_get_attachments (ApplicationMainWindow* self)
{
	ApplicationAttachmentManager* result;
	ApplicationAttachmentManager* _tmp0_;
#line 337 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 337 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_attachments;
#line 337 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 337 "../src/client/application/application-main-window.vala"
	return result;
#line 2574 "application-main-window.c"
}

static void
application_main_window_set_attachments (ApplicationMainWindow* self,
                                         ApplicationAttachmentManager* value)
{
	ApplicationAttachmentManager* old_value;
#line 337 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 337 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_attachments (self);
#line 337 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 2588 "application-main-window.c"
		ApplicationAttachmentManager* _tmp0_;
#line 337 "../src/client/application/application-main-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 337 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self->priv->_attachments);
#line 337 "../src/client/application/application-main-window.vala"
		self->priv->_attachments = _tmp0_;
#line 337 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_ATTACHMENTS_PROPERTY]);
#line 2598 "application-main-window.c"
	}
}

gboolean
application_main_window_get_selected_folder_supports_trash (ApplicationMainWindow* self)
{
	gboolean result;
	GearyFolder* _tmp0_;
#line 341 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 342 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 342 "../src/client/application/application-main-window.vala"
	result = application_controller_does_folder_support_trash (_tmp0_);
#line 342 "../src/client/application/application-main-window.vala"
	return result;
#line 2615 "application-main-window.c"
}

gboolean
application_main_window_get_has_composer (ApplicationMainWindow* self)
{
	gboolean result;
	ConversationViewer* _tmp0_;
	ComposerWidget* _tmp1_;
	ComposerWidget* _tmp2_;
#line 348 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 349 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversation_viewer;
#line 349 "../src/client/application/application-main-window.vala"
	_tmp1_ = conversation_viewer_get_current_composer (_tmp0_);
#line 349 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 349 "../src/client/application/application-main-window.vala"
	result = _tmp2_ != NULL;
#line 349 "../src/client/application/application-main-window.vala"
	return result;
#line 2637 "application-main-window.c"
}

gboolean
application_main_window_get_is_shift_down (ApplicationMainWindow* self)
{
	gboolean result;
#line 354 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 354 "../src/client/application/application-main-window.vala"
	result = self->priv->_is_shift_down;
#line 354 "../src/client/application/application-main-window.vala"
	return result;
#line 2650 "application-main-window.c"
}

static void
application_main_window_set_is_shift_down (ApplicationMainWindow* self,
                                           gboolean value)
{
	gboolean old_value;
#line 354 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 354 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_is_shift_down (self);
#line 354 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 354 "../src/client/application/application-main-window.vala"
		self->priv->_is_shift_down = value;
#line 354 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_IS_SHIFT_DOWN_PROPERTY]);
#line 2668 "application-main-window.c"
	}
}

gint
application_main_window_get_window_width (ApplicationMainWindow* self)
{
	gint result;
#line 357 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), 0);
#line 357 "../src/client/application/application-main-window.vala"
	result = self->priv->_window_width;
#line 357 "../src/client/application/application-main-window.vala"
	return result;
#line 2682 "application-main-window.c"
}

void
application_main_window_set_window_width (ApplicationMainWindow* self,
                                          gint value)
{
	gint old_value;
#line 357 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 357 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_window_width (self);
#line 357 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 357 "../src/client/application/application-main-window.vala"
		self->priv->_window_width = value;
#line 357 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_WINDOW_WIDTH_PROPERTY]);
#line 2700 "application-main-window.c"
	}
}

gint
application_main_window_get_window_height (ApplicationMainWindow* self)
{
	gint result;
#line 358 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), 0);
#line 358 "../src/client/application/application-main-window.vala"
	result = self->priv->_window_height;
#line 358 "../src/client/application/application-main-window.vala"
	return result;
#line 2714 "application-main-window.c"
}

void
application_main_window_set_window_height (ApplicationMainWindow* self,
                                           gint value)
{
	gint old_value;
#line 358 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 358 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_window_height (self);
#line 358 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 358 "../src/client/application/application-main-window.vala"
		self->priv->_window_height = value;
#line 358 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_WINDOW_HEIGHT_PROPERTY]);
#line 2732 "application-main-window.c"
	}
}

gboolean
application_main_window_get_window_maximized (ApplicationMainWindow* self)
{
	gboolean result;
#line 359 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 359 "../src/client/application/application-main-window.vala"
	result = self->priv->_window_maximized;
#line 359 "../src/client/application/application-main-window.vala"
	return result;
#line 2746 "application-main-window.c"
}

void
application_main_window_set_window_maximized (ApplicationMainWindow* self,
                                              gboolean value)
{
	gboolean old_value;
#line 359 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 359 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_window_maximized (self);
#line 359 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 359 "../src/client/application/application-main-window.vala"
		self->priv->_window_maximized = value;
#line 359 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_WINDOW_MAXIMIZED_PROPERTY]);
#line 2764 "application-main-window.c"
	}
}

FolderListTree*
application_main_window_get_folder_list (ApplicationMainWindow* self)
{
	FolderListTree* result;
	FolderListTree* _tmp0_;
#line 362 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 362 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_folder_list;
#line 362 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 362 "../src/client/application/application-main-window.vala"
	return result;
#line 2781 "application-main-window.c"
}

static void
application_main_window_set_folder_list (ApplicationMainWindow* self,
                                         FolderListTree* value)
{
	FolderListTree* old_value;
#line 362 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 362 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_folder_list (self);
#line 362 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 2795 "application-main-window.c"
		FolderListTree* _tmp0_;
#line 362 "../src/client/application/application-main-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 362 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self->priv->_folder_list);
#line 362 "../src/client/application/application-main-window.vala"
		self->priv->_folder_list = _tmp0_;
#line 362 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_FOLDER_LIST_PROPERTY]);
#line 2805 "application-main-window.c"
	}
}

SearchBar*
application_main_window_get_search_bar (ApplicationMainWindow* self)
{
	SearchBar* result;
	SearchBar* _tmp0_;
#line 363 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 363 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_search_bar;
#line 363 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 363 "../src/client/application/application-main-window.vala"
	return result;
#line 2822 "application-main-window.c"
}

static void
application_main_window_set_search_bar (ApplicationMainWindow* self,
                                        SearchBar* value)
{
	SearchBar* old_value;
#line 363 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 363 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_search_bar (self);
#line 363 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 2836 "application-main-window.c"
		SearchBar* _tmp0_;
#line 363 "../src/client/application/application-main-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 363 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self->priv->_search_bar);
#line 363 "../src/client/application/application-main-window.vala"
		self->priv->_search_bar = _tmp0_;
#line 363 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_SEARCH_BAR_PROPERTY]);
#line 2846 "application-main-window.c"
	}
}

ConversationListView*
application_main_window_get_conversation_list_view (ApplicationMainWindow* self)
{
	ConversationListView* result;
	ConversationListView* _tmp0_;
#line 364 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 364 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversation_list_view;
#line 364 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 364 "../src/client/application/application-main-window.vala"
	return result;
#line 2863 "application-main-window.c"
}

static void
application_main_window_set_conversation_list_view (ApplicationMainWindow* self,
                                                    ConversationListView* value)
{
	ConversationListView* old_value;
#line 364 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 364 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_conversation_list_view (self);
#line 364 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 2877 "application-main-window.c"
		ConversationListView* _tmp0_;
#line 364 "../src/client/application/application-main-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 364 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self->priv->_conversation_list_view);
#line 364 "../src/client/application/application-main-window.vala"
		self->priv->_conversation_list_view = _tmp0_;
#line 364 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_CONVERSATION_LIST_VIEW_PROPERTY]);
#line 2887 "application-main-window.c"
	}
}

ConversationViewer*
application_main_window_get_conversation_viewer (ApplicationMainWindow* self)
{
	ConversationViewer* result;
	ConversationViewer* _tmp0_;
#line 365 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 365 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversation_viewer;
#line 365 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 365 "../src/client/application/application-main-window.vala"
	return result;
#line 2904 "application-main-window.c"
}

static void
application_main_window_set_conversation_viewer (ApplicationMainWindow* self,
                                                 ConversationViewer* value)
{
	ConversationViewer* old_value;
#line 365 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 365 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_conversation_viewer (self);
#line 365 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 2918 "application-main-window.c"
		ConversationViewer* _tmp0_;
#line 365 "../src/client/application/application-main-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 365 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self->priv->_conversation_viewer);
#line 365 "../src/client/application/application-main-window.vala"
		self->priv->_conversation_viewer = _tmp0_;
#line 365 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_CONVERSATION_VIEWER_PROPERTY]);
#line 2928 "application-main-window.c"
	}
}

ComponentsInfoBarStack*
application_main_window_get_conversation_list_info_bars (ApplicationMainWindow* self)
{
	ComponentsInfoBarStack* result;
	ComponentsInfoBarStack* _tmp0_;
#line 368 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 368 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversation_list_info_bars;
#line 368 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 368 "../src/client/application/application-main-window.vala"
	return result;
#line 2945 "application-main-window.c"
}

static void
application_main_window_set_conversation_list_info_bars (ApplicationMainWindow* self,
                                                         ComponentsInfoBarStack* value)
{
	ComponentsInfoBarStack* old_value;
#line 368 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 368 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_conversation_list_info_bars (self);
#line 368 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 2959 "application-main-window.c"
		ComponentsInfoBarStack* _tmp0_;
#line 368 "../src/client/application/application-main-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 368 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self->priv->_conversation_list_info_bars);
#line 368 "../src/client/application/application-main-window.vala"
		self->priv->_conversation_list_info_bars = _tmp0_;
#line 368 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_CONVERSATION_LIST_INFO_BARS_PROPERTY]);
#line 2969 "application-main-window.c"
	}
}

static void
application_main_window_real_reply_conversation_sender (ApplicationMainWindow* self)
{
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
#line 431 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_REPLY_CONVERSATION);
#line 431 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 431 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_action_get_type (), GAction));
#line 431 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp1_);
#line 2986 "application-main-window.c"
}

static void
application_main_window_real_reply_conversation_all (ApplicationMainWindow* self)
{
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
#line 437 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_REPLY_ALL_CONVERSATION);
#line 437 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 437 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_action_get_type (), GAction));
#line 437 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp1_);
#line 3002 "application-main-window.c"
}

static void
application_main_window_real_forward_conversation (ApplicationMainWindow* self)
{
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
#line 443 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_FORWARD_CONVERSATION);
#line 443 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 443 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_action_get_type (), GAction));
#line 443 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp1_);
#line 3018 "application-main-window.c"
}

static void
application_main_window_real_mark_conversations_read (ApplicationMainWindow* self,
                                                      gboolean prefer_read)
{
	GSimpleAction* _tmp0_ = NULL;
#line 450 "../src/client/application/application-main-window.vala"
	if (prefer_read) {
#line 3028 "application-main-window.c"
		GSimpleAction* _tmp1_;
#line 451 "../src/client/application/application-main-window.vala"
		_tmp1_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_READ);
#line 451 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp0_);
#line 451 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp1_;
#line 3036 "application-main-window.c"
	} else {
		GSimpleAction* _tmp2_;
#line 452 "../src/client/application/application-main-window.vala"
		_tmp2_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_UNREAD);
#line 452 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp0_);
#line 452 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp2_;
#line 3045 "application-main-window.c"
	}
#line 449 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_action_get_type (), GAction));
#line 448 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp0_);
#line 3051 "application-main-window.c"
}

static void
application_main_window_real_mark_conversations_starred (ApplicationMainWindow* self,
                                                         gboolean prefer_starred)
{
	GSimpleAction* _tmp0_ = NULL;
#line 460 "../src/client/application/application-main-window.vala"
	if (prefer_starred) {
#line 3061 "application-main-window.c"
		GSimpleAction* _tmp1_;
#line 461 "../src/client/application/application-main-window.vala"
		_tmp1_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_STARRED);
#line 461 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp0_);
#line 461 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp1_;
#line 3069 "application-main-window.c"
	} else {
		GSimpleAction* _tmp2_;
#line 462 "../src/client/application/application-main-window.vala"
		_tmp2_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_UNSTARRED);
#line 462 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp0_);
#line 462 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp2_;
#line 3078 "application-main-window.c"
	}
#line 459 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_action_get_type (), GAction));
#line 458 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp0_);
#line 3084 "application-main-window.c"
}

static void
application_main_window_real_show_copy_menu (ApplicationMainWindow* self)
{
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
#line 469 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_SHOW_COPY_MENU);
#line 469 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 469 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_action_get_type (), GAction));
#line 469 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp1_);
#line 3100 "application-main-window.c"
}

static void
application_main_window_real_archive_conversations (ApplicationMainWindow* self)
{
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
#line 475 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_ARCHIVE_CONVERSATION);
#line 475 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 475 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_action_get_type (), GAction));
#line 475 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp1_);
#line 3116 "application-main-window.c"
}

static void
application_main_window_real_junk_conversations (ApplicationMainWindow* self)
{
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
#line 481 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_TOGGLE_JUNK);
#line 481 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 481 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_action_get_type (), GAction));
#line 481 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp1_);
#line 3132 "application-main-window.c"
}

static void
application_main_window_real_trash_conversations (ApplicationMainWindow* self)
{
	GSimpleAction* _tmp0_ = NULL;
	gboolean _tmp1_;
#line 490 "../src/client/application/application-main-window.vala"
	_tmp1_ = self->priv->_is_shift_down;
#line 490 "../src/client/application/application-main-window.vala"
	if (!_tmp1_) {
#line 3144 "application-main-window.c"
		GSimpleAction* _tmp2_;
#line 491 "../src/client/application/application-main-window.vala"
		_tmp2_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_TRASH_CONVERSATION);
#line 491 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp0_);
#line 491 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp2_;
#line 3152 "application-main-window.c"
	} else {
		GSimpleAction* _tmp3_;
#line 492 "../src/client/application/application-main-window.vala"
		_tmp3_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_DELETE_CONVERSATION);
#line 492 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp0_);
#line 492 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp3_;
#line 3161 "application-main-window.c"
	}
#line 489 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_action_get_type (), GAction));
#line 486 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp0_);
#line 3167 "application-main-window.c"
}

static void
application_main_window_real_delete_conversations (ApplicationMainWindow* self)
{
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
#line 499 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_DELETE_CONVERSATION);
#line 499 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 499 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_action_get_type (), GAction));
#line 499 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp1_);
#line 3183 "application-main-window.c"
}

static void
application_main_window_real_search (ApplicationMainWindow* self)
{
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
#line 505 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_SEARCH);
#line 505 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 505 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_action_get_type (), GAction));
#line 505 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp1_);
#line 3199 "application-main-window.c"
}

static void
application_main_window_real_find (ApplicationMainWindow* self)
{
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
#line 511 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_FIND_IN_CONVERSATION);
#line 511 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 511 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_action_get_type (), GAction));
#line 511 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp1_);
#line 3215 "application-main-window.c"
}

static void
application_main_window_real_escape (ApplicationMainWindow* self)
{
#line 517 "../src/client/application/application-main-window.vala"
	application_main_window_navigate_previous_pane (self);
#line 3223 "application-main-window.c"
}

static void
application_main_window_real_select_all (ApplicationMainWindow* self)
{
	ConversationListView* _tmp0_;
#line 523 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversation_list_view;
#line 523 "../src/client/application/application-main-window.vala"
	conversation_list_view_select_all (_tmp0_);
#line 3234 "application-main-window.c"
}

static void
application_main_window_real_navigate (ApplicationMainWindow* self,
                                       GtkScrollType type)
{
#line 529 "../src/client/application/application-main-window.vala"
	switch (type) {
#line 529 "../src/client/application/application-main-window.vala"
		case GTK_SCROLL_PAGE_LEFT:
#line 3245 "application-main-window.c"
		{
#line 531 "../src/client/application/application-main-window.vala"
			if (gtk_widget_get_direction (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget)) != GTK_TEXT_DIR_RTL) {
#line 532 "../src/client/application/application-main-window.vala"
				application_main_window_go_to_previous_pane (self);
#line 3251 "application-main-window.c"
			} else {
#line 534 "../src/client/application/application-main-window.vala"
				application_main_window_go_to_next_pane (self, FALSE);
#line 3255 "application-main-window.c"
			}
#line 536 "../src/client/application/application-main-window.vala"
			break;
#line 3259 "application-main-window.c"
		}
#line 529 "../src/client/application/application-main-window.vala"
		case GTK_SCROLL_PAGE_RIGHT:
#line 3263 "application-main-window.c"
		{
#line 538 "../src/client/application/application-main-window.vala"
			if (gtk_widget_get_direction (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget)) != GTK_TEXT_DIR_RTL) {
#line 539 "../src/client/application/application-main-window.vala"
				application_main_window_go_to_next_pane (self, FALSE);
#line 3269 "application-main-window.c"
			} else {
#line 541 "../src/client/application/application-main-window.vala"
				application_main_window_go_to_previous_pane (self);
#line 3273 "application-main-window.c"
			}
#line 543 "../src/client/application/application-main-window.vala"
			break;
#line 3277 "application-main-window.c"
		}
#line 529 "../src/client/application/application-main-window.vala"
		case GTK_SCROLL_STEP_UP:
#line 3281 "application-main-window.c"
		{
			GSimpleAction* _tmp0_;
			GSimpleAction* _tmp1_;
#line 545 "../src/client/application/application-main-window.vala"
			_tmp0_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_CONVERSATION_UP);
#line 545 "../src/client/application/application-main-window.vala"
			_tmp1_ = _tmp0_;
#line 545 "../src/client/application/application-main-window.vala"
			application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_action_get_type (), GAction));
#line 545 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_tmp1_);
#line 546 "../src/client/application/application-main-window.vala"
			break;
#line 3295 "application-main-window.c"
		}
#line 529 "../src/client/application/application-main-window.vala"
		case GTK_SCROLL_STEP_DOWN:
#line 3299 "application-main-window.c"
		{
			GSimpleAction* _tmp2_;
			GSimpleAction* _tmp3_;
#line 548 "../src/client/application/application-main-window.vala"
			_tmp2_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_CONVERSATION_DOWN);
#line 548 "../src/client/application/application-main-window.vala"
			_tmp3_ = _tmp2_;
#line 548 "../src/client/application/application-main-window.vala"
			application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_action_get_type (), GAction));
#line 548 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_tmp3_);
#line 549 "../src/client/application/application-main-window.vala"
			break;
#line 3313 "application-main-window.c"
		}
		default:
		{
#line 551 "../src/client/application/application-main-window.vala"
			gtk_widget_error_bell (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 552 "../src/client/application/application-main-window.vala"
			break;
#line 3321 "application-main-window.c"
		}
	}
}

static Block14Data*
block14_data_ref (Block14Data* _data14_)
{
#line 557 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data14_->_ref_count_);
#line 557 "../src/client/application/application-main-window.vala"
	return _data14_;
#line 3333 "application-main-window.c"
}

static void
block14_data_unref (void * _userdata_)
{
	Block14Data* _data14_;
	_data14_ = (Block14Data*) _userdata_;
#line 557 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data14_->_ref_count_)) {
#line 3343 "application-main-window.c"
		ApplicationMainWindow* self;
#line 557 "../src/client/application/application-main-window.vala"
		self = _data14_->self;
#line 557 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data14_->application);
#line 557 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 557 "../src/client/application/application-main-window.vala"
		g_slice_free (Block14Data, _data14_);
#line 3353 "application-main-window.c"
	}
}

static gboolean
__lambda206_ (Block14Data* _data14_,
              GtkWidget* w,
              GdkEventFocus* e)
{
	ApplicationMainWindow* self;
	ApplicationController* _tmp0_;
	ApplicationController* _tmp1_;
	gboolean result;
#line 593 "../src/client/application/application-main-window.vala"
	self = _data14_->self;
#line 593 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (w, gtk_widget_get_type ()), FALSE);
#line 593 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 594 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_client_get_controller (_data14_->application);
#line 594 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 594 "../src/client/application/application-main-window.vala"
	application_controller_window_focus_in (_tmp1_);
#line 595 "../src/client/application/application-main-window.vala"
	result = FALSE;
#line 595 "../src/client/application/application-main-window.vala"
	return result;
#line 3382 "application-main-window.c"
}

static gboolean
___lambda206__gtk_widget_focus_in_event (GtkWidget* _sender,
                                         GdkEventFocus* event,
                                         gpointer self)
{
	gboolean result;
	result = __lambda206_ (self, _sender, event);
#line 593 "../src/client/application/application-main-window.vala"
	return result;
#line 3394 "application-main-window.c"
}

static gboolean
__lambda207_ (Block14Data* _data14_,
              GtkWidget* w,
              GdkEventFocus* e)
{
	ApplicationMainWindow* self;
	ApplicationController* _tmp0_;
	ApplicationController* _tmp1_;
	gboolean result;
#line 597 "../src/client/application/application-main-window.vala"
	self = _data14_->self;
#line 597 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (w, gtk_widget_get_type ()), FALSE);
#line 597 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 598 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_client_get_controller (_data14_->application);
#line 598 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 598 "../src/client/application/application-main-window.vala"
	application_controller_window_focus_out (_tmp1_);
#line 599 "../src/client/application/application-main-window.vala"
	result = FALSE;
#line 599 "../src/client/application/application-main-window.vala"
	return result;
#line 3422 "application-main-window.c"
}

static gboolean
___lambda207__gtk_widget_focus_out_event (GtkWidget* _sender,
                                          GdkEventFocus* event,
                                          gpointer self)
{
	gboolean result;
	result = __lambda207_ (self, _sender, event);
#line 597 "../src/client/application/application-main-window.vala"
	return result;
#line 3434 "application-main-window.c"
}

static void
_application_main_window_on_update_ui_timeout_geary_timeout_manager_timeout_func (GearyTimeoutManager* manager,
                                                                                  gpointer self)
{
#line 609 "../src/client/application/application-main-window.vala"
	application_main_window_on_update_ui_timeout ((ApplicationMainWindow*) self);
#line 3443 "application-main-window.c"
}

static void
_application_main_window_on_account_available_application_account_interface_account_available (ApplicationAccountInterface* _sender,
                                                                                               ApplicationAccountContext* context,
                                                                                               gboolean is_startup,
                                                                                               gpointer self)
{
#line 615 "../src/client/application/application-main-window.vala"
	application_main_window_on_account_available ((ApplicationMainWindow*) self, context);
#line 3454 "application-main-window.c"
}

static void
_application_main_window_on_account_unavailable_application_account_interface_account_unavailable (ApplicationAccountInterface* _sender,
                                                                                                   ApplicationAccountContext* context,
                                                                                                   gboolean is_shutdown,
                                                                                                   gpointer self)
{
#line 618 "../src/client/application/application-main-window.vala"
	application_main_window_on_account_unavailable ((ApplicationMainWindow*) self, context, is_shutdown);
#line 3465 "application-main-window.c"
}

static void
_application_main_window_on_offline_infobar_response_components_info_bar_response (ComponentsInfoBar* _sender,
                                                                                   gint response_id,
                                                                                   gpointer self)
{
#line 633 "../src/client/application/application-main-window.vala"
	application_main_window_on_offline_infobar_response ((ApplicationMainWindow*) self);
#line 3475 "application-main-window.c"
}

static void
_application_main_window_on_auth_problem_retry_gtk_button_clicked (GtkButton* _sender,
                                                                   gpointer self)
{
#line 648 "../src/client/application/application-main-window.vala"
	application_main_window_on_auth_problem_retry ((ApplicationMainWindow*) self);
#line 3484 "application-main-window.c"
}

static void
_application_main_window_on_cert_problem_retry_gtk_button_clicked (GtkButton* _sender,
                                                                   gpointer self)
{
#line 664 "../src/client/application/application-main-window.vala"
	application_main_window_on_cert_problem_retry ((ApplicationMainWindow*) self);
#line 3493 "application-main-window.c"
}

static void
__lambda216_ (ApplicationMainWindow* self)
{
	FolderListTree* _tmp0_;
#line 668 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_folder_list;
#line 668 "../src/client/application/application-main-window.vala"
	gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 3504 "application-main-window.c"
}

static void
___lambda216__gtk_widget_map (GtkWidget* _sender,
                              gpointer self)
{
#line 667 "../src/client/application/application-main-window.vala"
	__lambda216_ ((ApplicationMainWindow*) self);
#line 3513 "application-main-window.c"
}

static void
_application_main_window_on_show_mark_menu_components_conversation_actions_mark_message_button_toggled (ComponentsConversationActions* _sender,
                                                                                                        gpointer self)
{
#line 672 "../src/client/application/application-main-window.vala"
	application_main_window_on_show_mark_menu ((ApplicationMainWindow*) self);
#line 3522 "application-main-window.c"
}

static void
_application_main_window_on_gtk_decoration_layout_changed_g_object_notify (GObject* _sender,
                                                                           GParamSpec* pspec,
                                                                           gpointer self)
{
#line 675 "../src/client/application/application-main-window.vala"
	application_main_window_on_gtk_decoration_layout_changed ((ApplicationMainWindow*) self);
#line 3532 "application-main-window.c"
}

ApplicationMainWindow*
application_main_window_construct (GType object_type,
                                   ApplicationClient* application)
{
	ApplicationMainWindow * self = NULL;
	Block14Data* _data14_;
	ApplicationClient* _tmp0_;
	ApplicationController* _tmp1_;
	ApplicationController* _tmp2_;
	ApplicationController* _tmp3_;
	GtkWindowGroup* group = NULL;
	GtkWindowGroup* _tmp4_;
	GtkWindowGroup* _tmp5_;
	ApplicationConfiguration* _tmp6_;
	ApplicationConfiguration* _tmp7_;
	ComponentsInfoBarStack* _tmp9_;
	ComponentsInfoBarStack* _tmp10_;
	GSimpleActionGroup* _tmp11_;
	GSimpleActionGroup* _tmp12_;
	ApplicationConfiguration* _tmp13_;
	ApplicationConfiguration* _tmp14_;
	ApplicationAttachmentManager* _tmp15_;
	ApplicationAttachmentManager* _tmp16_;
	GearyTimeoutManager* _tmp17_;
	GearyTimeoutManager* _tmp18_;
	ApplicationController* _tmp19_;
	ApplicationController* _tmp20_;
	ComponentsInfoBar* _tmp30_;
	ComponentsInfoBar* _tmp31_;
	ComponentsInfoBar* _tmp32_;
	ComponentsInfoBar* _tmp33_;
	GtkButton* auth_retry = NULL;
	GtkButton* _tmp34_;
	GtkButton* _tmp35_;
	GtkButton* _tmp36_;
	GtkButton* _tmp37_;
	ComponentsInfoBar* _tmp38_;
	GtkBox* _tmp39_;
	GtkBox* _tmp40_;
	GtkButton* _tmp41_;
	ComponentsInfoBar* _tmp42_;
	GtkButton* cert_retry = NULL;
	GtkButton* _tmp43_;
	GtkButton* _tmp44_;
	GtkButton* _tmp45_;
	GtkButton* _tmp46_;
	ComponentsInfoBar* _tmp47_;
	GtkBox* _tmp48_;
	GtkBox* _tmp49_;
	GtkButton* _tmp50_;
	ComponentsConversationActions** _tmp51_;
	gint _tmp51__length1;
	GtkSettings* _tmp54_;
#line 557 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (application), NULL);
#line 557 "../src/client/application/application-main-window.vala"
	_data14_ = g_slice_new0 (Block14Data);
#line 557 "../src/client/application/application-main-window.vala"
	_data14_->_ref_count_ = 1;
#line 557 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (application);
#line 557 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data14_->application);
#line 557 "../src/client/application/application-main-window.vala"
	_data14_->application = _tmp0_;
#line 558 "../src/client/application/application-main-window.vala"
	self = (ApplicationMainWindow*) g_object_new (object_type, "application", _data14_->application, "show-menubar", FALSE, NULL);
#line 558 "../src/client/application/application-main-window.vala"
	_data14_->self = g_object_ref (self);
#line 562 "../src/client/application/application-main-window.vala"
	geary_base_interface_base_ref (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_BASE_INTERFACE, GearyBaseInterface));
#line 568 "../src/client/application/application-main-window.vala"
	_tmp1_ = application_client_get_controller (_data14_->application);
#line 568 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 568 "../src/client/application/application-main-window.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 568 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->controller);
#line 568 "../src/client/application/application-main-window.vala"
	self->priv->controller = _tmp3_;
#line 573 "../src/client/application/application-main-window.vala"
	_tmp4_ = gtk_window_group_new ();
#line 573 "../src/client/application/application-main-window.vala"
	group = _tmp4_;
#line 574 "../src/client/application/application-main-window.vala"
	_tmp5_ = group;
#line 574 "../src/client/application/application-main-window.vala"
	gtk_window_group_add_window (_tmp5_, G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
#line 576 "../src/client/application/application-main-window.vala"
	_tmp6_ = application_client_get_config (_data14_->application);
#line 576 "../src/client/application/application-main-window.vala"
	_tmp7_ = _tmp6_;
#line 576 "../src/client/application/application-main-window.vala"
	application_main_window_load_config (self, _tmp7_);
#line 577 "../src/client/application/application-main-window.vala"
	application_main_window_restore_saved_window_state (self);
#line 579 "../src/client/application/application-main-window.vala"
	if (g_strcmp0 (_PROFILE, APPLICATION_CLIENT_PROFILE_RELEASE) != 0) {
#line 3634 "application-main-window.c"
		GtkStyleContext* _tmp8_;
#line 580 "../src/client/application/application-main-window.vala"
		_tmp8_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 580 "../src/client/application/application-main-window.vala"
		gtk_style_context_add_class (_tmp8_, "devel");
#line 3640 "application-main-window.c"
	}
#line 583 "../src/client/application/application-main-window.vala"
	_tmp9_ = self->priv->info_bars;
#line 583 "../src/client/application/application-main-window.vala"
	gtk_frame_set_shadow_type (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_frame_get_type (), GtkFrame), GTK_SHADOW_IN);
#line 584 "../src/client/application/application-main-window.vala"
	_tmp10_ = self->priv->_conversation_list_info_bars;
#line 584 "../src/client/application/application-main-window.vala"
	gtk_frame_set_shadow_type (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_frame_get_type (), GtkFrame), GTK_SHADOW_IN);
#line 587 "../src/client/application/application-main-window.vala"
	_tmp11_ = self->priv->edit_actions;
#line 587 "../src/client/application/application-main-window.vala"
	g_action_map_add_action_entries (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, g_action_map_get_type (), GActionMap), APPLICATION_MAIN_WINDOW_EDIT_ACTIONS, (gint) G_N_ELEMENTS (APPLICATION_MAIN_WINDOW_EDIT_ACTIONS), self);
#line 588 "../src/client/application/application-main-window.vala"
	_tmp12_ = self->priv->edit_actions;
#line 588 "../src/client/application/application-main-window.vala"
	gtk_widget_insert_action_group (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), ACTION_EDIT_GROUP_NAME, G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, g_action_group_get_type (), GActionGroup));
#line 591 "../src/client/application/application-main-window.vala"
	g_action_map_add_action_entries (G_TYPE_CHECK_INSTANCE_CAST (self, g_action_map_get_type (), GActionMap), APPLICATION_MAIN_WINDOW_WINDOW_ACTIONS, (gint) G_N_ELEMENTS (APPLICATION_MAIN_WINDOW_WINDOW_ACTIONS), self);
#line 593 "../src/client/application/application-main-window.vala"
	g_signal_connect_data (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "focus-in-event", (GCallback) ___lambda206__gtk_widget_focus_in_event, block14_data_ref (_data14_), (GClosureNotify) block14_data_unref, 0);
#line 597 "../src/client/application/application-main-window.vala"
	g_signal_connect_data (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "focus-out-event", (GCallback) ___lambda207__gtk_widget_focus_out_event, block14_data_ref (_data14_), (GClosureNotify) block14_data_unref, 0);
#line 602 "../src/client/application/application-main-window.vala"
	_tmp13_ = application_client_get_config (_data14_->application);
#line 602 "../src/client/application/application-main-window.vala"
	_tmp14_ = _tmp13_;
#line 602 "../src/client/application/application-main-window.vala"
	application_main_window_setup_layout (self, _tmp14_);
#line 604 "../src/client/application/application-main-window.vala"
	application_main_window_update_command_actions (self);
#line 605 "../src/client/application/application-main-window.vala"
	application_main_window_update_conversation_actions (self, APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_NONE);
#line 607 "../src/client/application/application-main-window.vala"
	_tmp15_ = application_attachment_manager_new (self);
#line 607 "../src/client/application/application-main-window.vala"
	_tmp16_ = _tmp15_;
#line 607 "../src/client/application/application-main-window.vala"
	application_main_window_set_attachments (self, _tmp16_);
#line 607 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp16_);
#line 609 "../src/client/application/application-main-window.vala"
	_tmp17_ = geary_timeout_manager_new_seconds ((guint) APPLICATION_MAIN_WINDOW_UPDATE_UI_INTERVAL, _application_main_window_on_update_ui_timeout_geary_timeout_manager_timeout_func, self);
#line 609 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->update_ui_timeout);
#line 609 "../src/client/application/application-main-window.vala"
	self->priv->update_ui_timeout = _tmp17_;
#line 612 "../src/client/application/application-main-window.vala"
	_tmp18_ = self->priv->update_ui_timeout;
#line 612 "../src/client/application/application-main-window.vala"
	_tmp18_->repetition = GEARY_TIMEOUT_MANAGER_REPEAT_FOREVER;
#line 615 "../src/client/application/application-main-window.vala"
	_tmp19_ = self->priv->controller;
#line 615 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface), "account-available", (GCallback) _application_main_window_on_account_available_application_account_interface_account_available, self, 0);
#line 618 "../src/client/application/application-main-window.vala"
	_tmp20_ = self->priv->controller;
#line 618 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface), "account-unavailable", (GCallback) _application_main_window_on_account_unavailable_application_account_interface_account_unavailable, self, 0);
#line 3700 "application-main-window.c"
	{
		GeeIterator* _context_it = NULL;
		ApplicationController* _tmp21_;
		GeeCollection* _tmp22_;
		GeeCollection* _tmp23_;
		GeeIterator* _tmp24_;
		GeeIterator* _tmp25_;
#line 621 "../src/client/application/application-main-window.vala"
		_tmp21_ = self->priv->controller;
#line 621 "../src/client/application/application-main-window.vala"
		_tmp22_ = application_account_interface_get_account_contexts (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface));
#line 621 "../src/client/application/application-main-window.vala"
		_tmp23_ = _tmp22_;
#line 621 "../src/client/application/application-main-window.vala"
		_tmp24_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ITERABLE, GeeIterable));
#line 621 "../src/client/application/application-main-window.vala"
		_tmp25_ = _tmp24_;
#line 621 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp23_);
#line 621 "../src/client/application/application-main-window.vala"
		_context_it = _tmp25_;
#line 621 "../src/client/application/application-main-window.vala"
		while (TRUE) {
#line 3724 "application-main-window.c"
			GeeIterator* _tmp26_;
			ApplicationAccountContext* context = NULL;
			GeeIterator* _tmp27_;
			gpointer _tmp28_;
			ApplicationAccountContext* _tmp29_;
#line 621 "../src/client/application/application-main-window.vala"
			_tmp26_ = _context_it;
#line 621 "../src/client/application/application-main-window.vala"
			if (!gee_iterator_next (_tmp26_)) {
#line 621 "../src/client/application/application-main-window.vala"
				break;
#line 3736 "application-main-window.c"
			}
#line 621 "../src/client/application/application-main-window.vala"
			_tmp27_ = _context_it;
#line 621 "../src/client/application/application-main-window.vala"
			_tmp28_ = gee_iterator_get (_tmp27_);
#line 621 "../src/client/application/application-main-window.vala"
			context = (ApplicationAccountContext*) _tmp28_;
#line 623 "../src/client/application/application-main-window.vala"
			_tmp29_ = context;
#line 623 "../src/client/application/application-main-window.vala"
			application_main_window_add_account (self, _tmp29_);
#line 621 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (context);
#line 3750 "application-main-window.c"
		}
#line 621 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_context_it);
#line 3754 "application-main-window.c"
	}
#line 626 "../src/client/application/application-main-window.vala"
	_tmp30_ = components_info_bar_new (_ ("Working offline"), _ ("You will not be able to send or receive email until re-connected."));
#line 626 "../src/client/application/application-main-window.vala"
	g_object_ref_sink (_tmp30_);
#line 626 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->offline_infobar);
#line 626 "../src/client/application/application-main-window.vala"
	self->priv->offline_infobar = _tmp30_;
#line 632 "../src/client/application/application-main-window.vala"
	_tmp31_ = self->priv->offline_infobar;
#line 632 "../src/client/application/application-main-window.vala"
	components_info_bar_set_show_close_button (_tmp31_, TRUE);
#line 633 "../src/client/application/application-main-window.vala"
	_tmp32_ = self->priv->offline_infobar;
#line 633 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp32_, "response", (GCallback) _application_main_window_on_offline_infobar_response_components_info_bar_response, self, 0);
#line 635 "../src/client/application/application-main-window.vala"
	_tmp33_ = components_info_bar_new (_ ("Login problem"), _ ("An account has reported an incorrect login or password."));
#line 635 "../src/client/application/application-main-window.vala"
	g_object_ref_sink (_tmp33_);
#line 635 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->auth_problem_infobar);
#line 635 "../src/client/application/application-main-window.vala"
	self->priv->auth_problem_infobar = _tmp33_;
#line 642 "../src/client/application/application-main-window.vala"
	_tmp34_ = (GtkButton*) gtk_button_new_with_label (_ ("Login"));
#line 642 "../src/client/application/application-main-window.vala"
	g_object_ref_sink (_tmp34_);
#line 642 "../src/client/application/application-main-window.vala"
	auth_retry = _tmp34_;
#line 643 "../src/client/application/application-main-window.vala"
	_tmp35_ = auth_retry;
#line 643 "../src/client/application/application-main-window.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, gtk_widget_get_type (), GtkWidget));
#line 645 "../src/client/application/application-main-window.vala"
	_tmp36_ = auth_retry;
#line 645 "../src/client/application/application-main-window.vala"
	gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, gtk_widget_get_type (), GtkWidget), _ ("Retry login, you will be prompted for your password"));
#line 648 "../src/client/application/application-main-window.vala"
	_tmp37_ = auth_retry;
#line 648 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp37_, "clicked", (GCallback) _application_main_window_on_auth_problem_retry_gtk_button_clicked, self, 0);
#line 649 "../src/client/application/application-main-window.vala"
	_tmp38_ = self->priv->auth_problem_infobar;
#line 649 "../src/client/application/application-main-window.vala"
	_tmp39_ = components_info_bar_get_action_area (_tmp38_);
#line 649 "../src/client/application/application-main-window.vala"
	_tmp40_ = _tmp39_;
#line 649 "../src/client/application/application-main-window.vala"
	_tmp41_ = auth_retry;
#line 649 "../src/client/application/application-main-window.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, gtk_widget_get_type (), GtkWidget));
#line 649 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp40_);
#line 651 "../src/client/application/application-main-window.vala"
	_tmp42_ = components_info_bar_new (_ ("Security problem"), _ ("An account has reported an untrusted server."));
#line 651 "../src/client/application/application-main-window.vala"
	g_object_ref_sink (_tmp42_);
#line 651 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->cert_problem_infobar);
#line 651 "../src/client/application/application-main-window.vala"
	self->priv->cert_problem_infobar = _tmp42_;
#line 658 "../src/client/application/application-main-window.vala"
	_tmp43_ = (GtkButton*) gtk_button_new_with_label (_ ("Check"));
#line 658 "../src/client/application/application-main-window.vala"
	g_object_ref_sink (_tmp43_);
#line 658 "../src/client/application/application-main-window.vala"
	cert_retry = _tmp43_;
#line 659 "../src/client/application/application-main-window.vala"
	_tmp44_ = cert_retry;
#line 659 "../src/client/application/application-main-window.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, gtk_widget_get_type (), GtkWidget));
#line 661 "../src/client/application/application-main-window.vala"
	_tmp45_ = cert_retry;
#line 661 "../src/client/application/application-main-window.vala"
	gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, gtk_widget_get_type (), GtkWidget), _ ("Check the security details for the connection"));
#line 664 "../src/client/application/application-main-window.vala"
	_tmp46_ = cert_retry;
#line 664 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp46_, "clicked", (GCallback) _application_main_window_on_cert_problem_retry_gtk_button_clicked, self, 0);
#line 665 "../src/client/application/application-main-window.vala"
	_tmp47_ = self->priv->cert_problem_infobar;
#line 665 "../src/client/application/application-main-window.vala"
	_tmp48_ = components_info_bar_get_action_area (_tmp47_);
#line 665 "../src/client/application/application-main-window.vala"
	_tmp49_ = _tmp48_;
#line 665 "../src/client/application/application-main-window.vala"
	_tmp50_ = cert_retry;
#line 665 "../src/client/application/application-main-window.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, gtk_widget_get_type (), GtkWidget));
#line 665 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp49_);
#line 667 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "map", (GCallback) ___lambda216__gtk_widget_map, self, 0);
#line 671 "../src/client/application/application-main-window.vala"
	_tmp51_ = self->priv->folder_conversation_actions;
#line 671 "../src/client/application/application-main-window.vala"
	_tmp51__length1 = self->priv->folder_conversation_actions_length1;
#line 3854 "application-main-window.c"
	{
		ComponentsConversationActions** actions_collection = NULL;
		gint actions_collection_length1 = 0;
		gint _actions_collection_size_ = 0;
		gint actions_it = 0;
#line 671 "../src/client/application/application-main-window.vala"
		actions_collection = _tmp51_;
#line 671 "../src/client/application/application-main-window.vala"
		actions_collection_length1 = _tmp51__length1;
#line 671 "../src/client/application/application-main-window.vala"
		for (actions_it = 0; actions_it < actions_collection_length1; actions_it = actions_it + 1) {
#line 3866 "application-main-window.c"
			ComponentsConversationActions* _tmp52_;
			ComponentsConversationActions* actions = NULL;
#line 671 "../src/client/application/application-main-window.vala"
			_tmp52_ = _g_object_ref0 (actions_collection[actions_it]);
#line 671 "../src/client/application/application-main-window.vala"
			actions = _tmp52_;
#line 3873 "application-main-window.c"
			{
				ComponentsConversationActions* _tmp53_;
#line 672 "../src/client/application/application-main-window.vala"
				_tmp53_ = actions;
#line 672 "../src/client/application/application-main-window.vala"
				g_signal_connect_object (_tmp53_, "mark-message-button-toggled", (GCallback) _application_main_window_on_show_mark_menu_components_conversation_actions_mark_message_button_toggled, self, 0);
#line 671 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (actions);
#line 3882 "application-main-window.c"
			}
		}
	}
#line 675 "../src/client/application/application-main-window.vala"
	_tmp54_ = gtk_settings_get_default ();
#line 675 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp54_, G_TYPE_OBJECT, GObject), "notify::gtk-decoration-layout", (GCallback) _application_main_window_on_gtk_decoration_layout_changed_g_object_notify, self, 0);
#line 678 "../src/client/application/application-main-window.vala"
	application_main_window_update_close_button_position (self);
#line 557 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (cert_retry);
#line 557 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (auth_retry);
#line 557 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (group);
#line 557 "../src/client/application/application-main-window.vala"
	block14_data_unref (_data14_);
#line 557 "../src/client/application/application-main-window.vala"
	_data14_ = NULL;
#line 557 "../src/client/application/application-main-window.vala"
	return self;
#line 3904 "application-main-window.c"
}

ApplicationMainWindow*
application_main_window_new (ApplicationClient* application)
{
#line 557 "../src/client/application/application-main-window.vala"
	return application_main_window_construct (APPLICATION_TYPE_MAIN_WINDOW, application);
#line 3912 "application-main-window.c"
}

/** {@inheritDoc} */
static void
application_main_window_real_destroy (GtkWidget* base)
{
	ApplicationMainWindow * self;
	ApplicationClient* _tmp0_;
	ApplicationClient* _tmp1_;
	GearyTimeoutManager* _tmp6_;
	GtkSettings* _tmp7_;
	guint _tmp8_;
	GQuark _tmp9_;
#line 686 "../src/client/application/application-main-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_MAIN_WINDOW, ApplicationMainWindow);
#line 687 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_application (self);
#line 687 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 687 "../src/client/application/application-main-window.vala"
	if (_tmp1_ != NULL) {
#line 3934 "application-main-window.c"
		ApplicationController* _tmp2_;
		guint _tmp3_;
		ApplicationController* _tmp4_;
		guint _tmp5_;
#line 688 "../src/client/application/application-main-window.vala"
		_tmp2_ = self->priv->controller;
#line 688 "../src/client/application/application-main-window.vala"
		g_signal_parse_name ("account-available", APPLICATION_TYPE_ACCOUNT_INTERFACE, &_tmp3_, NULL, FALSE);
#line 688 "../src/client/application/application-main-window.vala"
		g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _application_main_window_on_account_available_application_account_interface_account_available, self);
#line 691 "../src/client/application/application-main-window.vala"
		_tmp4_ = self->priv->controller;
#line 691 "../src/client/application/application-main-window.vala"
		g_signal_parse_name ("account-unavailable", APPLICATION_TYPE_ACCOUNT_INTERFACE, &_tmp5_, NULL, FALSE);
#line 691 "../src/client/application/application-main-window.vala"
		g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _application_main_window_on_account_unavailable_application_account_interface_account_unavailable, self);
#line 3951 "application-main-window.c"
	}
#line 695 "../src/client/application/application-main-window.vala"
	_tmp6_ = self->priv->update_ui_timeout;
#line 695 "../src/client/application/application-main-window.vala"
	geary_timeout_manager_reset (_tmp6_);
#line 696 "../src/client/application/application-main-window.vala"
	_tmp7_ = gtk_settings_get_default ();
#line 696 "../src/client/application/application-main-window.vala"
	g_signal_parse_name ("notify::gtk-decoration-layout", G_TYPE_OBJECT, &_tmp8_, &_tmp9_, TRUE);
#line 696 "../src/client/application/application-main-window.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, G_TYPE_OBJECT, GObject), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, _tmp9_, NULL, (GCallback) _application_main_window_on_gtk_decoration_layout_changed_g_object_notify, self);
#line 699 "../src/client/application/application-main-window.vala"
	GTK_WIDGET_CLASS (application_main_window_parent_class)->destroy (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), gtk_widget_get_type (), GtkWidget));
#line 3965 "application-main-window.c"
}

/** Updates the window's title and headerbar titles. */
void
application_main_window_update_title (ApplicationMainWindow* self)
{
	ApplicationAccountContext* account = NULL;
	ApplicationAccountContext* _tmp0_;
	ApplicationFolderContext* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	ApplicationAccountContext* _tmp3_;
	ApplicationFolderContext* folder = NULL;
	ApplicationFolderContext* _tmp8_;
	gchar* title = NULL;
	gchar* _tmp9_;
	gchar* account_name = NULL;
	gchar* folder_name = NULL;
	gboolean _tmp10_ = FALSE;
	ApplicationAccountContext* _tmp11_;
	const gchar* _tmp28_;
	const gchar* _tmp29_ = NULL;
	const gchar* _tmp30_;
	ComponentsConversationListHeaderBar* _tmp31_;
	const gchar* _tmp32_ = NULL;
	const gchar* _tmp33_;
	ComponentsConversationListHeaderBar* _tmp34_;
#line 703 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 704 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_selected_account_context (self);
#line 704 "../src/client/application/application-main-window.vala"
	account = _tmp0_;
#line 706 "../src/client/application/application-main-window.vala"
	_tmp3_ = account;
#line 706 "../src/client/application/application-main-window.vala"
	if (_tmp3_ != NULL) {
#line 4002 "application-main-window.c"
		GearyFolder* _tmp4_;
#line 706 "../src/client/application/application-main-window.vala"
		_tmp4_ = self->priv->_selected_folder;
#line 706 "../src/client/application/application-main-window.vala"
		_tmp2_ = _tmp4_ != NULL;
#line 4008 "application-main-window.c"
	} else {
#line 706 "../src/client/application/application-main-window.vala"
		_tmp2_ = FALSE;
#line 4012 "application-main-window.c"
	}
#line 705 "../src/client/application/application-main-window.vala"
	if (_tmp2_) {
#line 4016 "application-main-window.c"
		ApplicationAccountContext* _tmp5_;
		GearyFolder* _tmp6_;
		ApplicationFolderContext* _tmp7_;
#line 707 "../src/client/application/application-main-window.vala"
		_tmp5_ = account;
#line 707 "../src/client/application/application-main-window.vala"
		_tmp6_ = self->priv->_selected_folder;
#line 707 "../src/client/application/application-main-window.vala"
		_tmp7_ = application_account_context_get_folder (_tmp5_, _tmp6_);
#line 707 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp1_);
#line 707 "../src/client/application/application-main-window.vala"
		_tmp1_ = _tmp7_;
#line 4030 "application-main-window.c"
	} else {
#line 708 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp1_);
#line 708 "../src/client/application/application-main-window.vala"
		_tmp1_ = NULL;
#line 4036 "application-main-window.c"
	}
#line 705 "../src/client/application/application-main-window.vala"
	_tmp8_ = _g_object_ref0 (_tmp1_);
#line 705 "../src/client/application/application-main-window.vala"
	folder = _tmp8_;
#line 710 "../src/client/application/application-main-window.vala"
	_tmp9_ = g_strdup (_ ("Geary"));
#line 710 "../src/client/application/application-main-window.vala"
	title = _tmp9_;
#line 711 "../src/client/application/application-main-window.vala"
	account_name = NULL;
#line 712 "../src/client/application/application-main-window.vala"
	folder_name = NULL;
#line 713 "../src/client/application/application-main-window.vala"
	_tmp11_ = account;
#line 713 "../src/client/application/application-main-window.vala"
	if (_tmp11_ != NULL) {
#line 4054 "application-main-window.c"
		ApplicationFolderContext* _tmp12_;
#line 713 "../src/client/application/application-main-window.vala"
		_tmp12_ = folder;
#line 713 "../src/client/application/application-main-window.vala"
		_tmp10_ = _tmp12_ != NULL;
#line 4060 "application-main-window.c"
	} else {
#line 713 "../src/client/application/application-main-window.vala"
		_tmp10_ = FALSE;
#line 4064 "application-main-window.c"
	}
#line 713 "../src/client/application/application-main-window.vala"
	if (_tmp10_) {
#line 4068 "application-main-window.c"
		ApplicationAccountContext* _tmp13_;
		GearyAccount* _tmp14_;
		GearyAccount* _tmp15_;
		GearyAccountInformation* _tmp16_;
		GearyAccountInformation* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		ApplicationFolderContext* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		gchar* _tmp27_;
#line 714 "../src/client/application/application-main-window.vala"
		_tmp13_ = account;
#line 714 "../src/client/application/application-main-window.vala"
		_tmp14_ = application_account_context_get_account (_tmp13_);
#line 714 "../src/client/application/application-main-window.vala"
		_tmp15_ = _tmp14_;
#line 714 "../src/client/application/application-main-window.vala"
		_tmp16_ = geary_account_get_information (_tmp15_);
#line 714 "../src/client/application/application-main-window.vala"
		_tmp17_ = _tmp16_;
#line 714 "../src/client/application/application-main-window.vala"
		_tmp18_ = geary_account_information_get_display_name (_tmp17_);
#line 714 "../src/client/application/application-main-window.vala"
		_tmp19_ = _tmp18_;
#line 714 "../src/client/application/application-main-window.vala"
		_tmp20_ = g_strdup (_tmp19_);
#line 714 "../src/client/application/application-main-window.vala"
		_g_free0 (account_name);
#line 714 "../src/client/application/application-main-window.vala"
		account_name = _tmp20_;
#line 715 "../src/client/application/application-main-window.vala"
		_tmp21_ = folder;
#line 715 "../src/client/application/application-main-window.vala"
		_tmp22_ = application_folder_context_get_display_name (_tmp21_);
#line 715 "../src/client/application/application-main-window.vala"
		_tmp23_ = _tmp22_;
#line 715 "../src/client/application/application-main-window.vala"
		_tmp24_ = g_strdup (_tmp23_);
#line 715 "../src/client/application/application-main-window.vala"
		_g_free0 (folder_name);
#line 715 "../src/client/application/application-main-window.vala"
		folder_name = _tmp24_;
#line 719 "../src/client/application/application-main-window.vala"
		_tmp25_ = folder_name;
#line 719 "../src/client/application/application-main-window.vala"
		_tmp26_ = account_name;
#line 719 "../src/client/application/application-main-window.vala"
		_tmp27_ = g_strdup_printf (_ ("%s — %s"), _tmp25_, _tmp26_);
#line 719 "../src/client/application/application-main-window.vala"
		_g_free0 (title);
#line 719 "../src/client/application/application-main-window.vala"
		title = _tmp27_;
#line 4126 "application-main-window.c"
	}
#line 721 "../src/client/application/application-main-window.vala"
	_tmp28_ = title;
#line 721 "../src/client/application/application-main-window.vala"
	gtk_window_set_title (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), _tmp28_);
#line 722 "../src/client/application/application-main-window.vala"
	_tmp30_ = account_name;
#line 722 "../src/client/application/application-main-window.vala"
	_tmp29_ = _tmp30_;
#line 722 "../src/client/application/application-main-window.vala"
	if (_tmp29_ == NULL) {
#line 722 "../src/client/application/application-main-window.vala"
		_tmp29_ = "";
#line 4140 "application-main-window.c"
	}
#line 722 "../src/client/application/application-main-window.vala"
	_tmp31_ = self->priv->conversation_list_headerbar;
#line 722 "../src/client/application/application-main-window.vala"
	components_conversation_list_header_bar_set_account (_tmp31_, _tmp29_);
#line 723 "../src/client/application/application-main-window.vala"
	_tmp33_ = folder_name;
#line 723 "../src/client/application/application-main-window.vala"
	_tmp32_ = _tmp33_;
#line 723 "../src/client/application/application-main-window.vala"
	if (_tmp32_ == NULL) {
#line 723 "../src/client/application/application-main-window.vala"
		_tmp32_ = "";
#line 4154 "application-main-window.c"
	}
#line 723 "../src/client/application/application-main-window.vala"
	_tmp34_ = self->priv->conversation_list_headerbar;
#line 723 "../src/client/application/application-main-window.vala"
	components_conversation_list_header_bar_set_folder (_tmp34_, _tmp32_);
#line 703 "../src/client/application/application-main-window.vala"
	_g_free0 (folder_name);
#line 703 "../src/client/application/application-main-window.vala"
	_g_free0 (account_name);
#line 703 "../src/client/application/application-main-window.vala"
	_g_free0 (title);
#line 703 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (folder);
#line 703 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp1_);
#line 703 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (account);
#line 4172 "application-main-window.c"
}

/** Updates the window's account status info bars. */
static void
_application_main_window_on_service_problem_retry_components_problem_report_info_bar_retry (ComponentsProblemReportInfoBar* _sender,
                                                                                            gpointer self)
{
#line 752 "../src/client/application/application-main-window.vala"
	application_main_window_on_service_problem_retry ((ApplicationMainWindow*) self);
#line 4182 "application-main-window.c"
}

void
application_main_window_update_account_status (ApplicationMainWindow* self,
                                               GearyAccountStatus status,
                                               gboolean has_auth_error,
                                               gboolean has_cert_error,
                                               GearyAccount* problem_source)
{
#line 727 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 727 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((problem_source == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (problem_source, GEARY_TYPE_ACCOUNT));
#line 737 "../src/client/application/application-main-window.vala"
	if (!geary_account_status_is_online (status)) {
#line 4198 "application-main-window.c"
		ComponentsInfoBarStack* _tmp0_;
		ComponentsInfoBar* _tmp1_;
#line 738 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->info_bars;
#line 738 "../src/client/application/application-main-window.vala"
		_tmp1_ = self->priv->offline_infobar;
#line 738 "../src/client/application/application-main-window.vala"
		components_info_bar_stack_add (_tmp0_, _tmp1_);
#line 4207 "application-main-window.c"
	} else {
#line 739 "../src/client/application/application-main-window.vala"
		if (geary_account_status_has_service_problem (status)) {
#line 4211 "application-main-window.c"
			GearyClientService* _tmp2_ = NULL;
			GearyClientService* _tmp3_;
			GearyClientService* _tmp4_;
			GearyErrorContext* _tmp5_;
			GearyErrorContext* _tmp6_;
			GearyClientService* service = NULL;
			GearyClientService* _tmp11_;
			GearyAccountInformation* _tmp12_;
			GearyAccountInformation* _tmp13_;
			GearyClientService* _tmp14_;
			GearyServiceInformation* _tmp15_;
			GearyServiceInformation* _tmp16_;
			GearyClientService* _tmp17_;
			GearyErrorContext* _tmp18_;
			GearyErrorContext* _tmp19_;
			GError* _tmp20_;
			GError* _tmp21_;
			GearyServiceProblemReport* _tmp22_;
			GearyServiceProblemReport* _tmp23_;
			ComponentsProblemReportInfoBar* _tmp24_;
			ComponentsProblemReportInfoBar* _tmp25_;
			ComponentsInfoBarStack* _tmp26_;
			ComponentsProblemReportInfoBar* _tmp27_;
#line 740 "../src/client/application/application-main-window.vala"
			_tmp3_ = geary_account_get_incoming (problem_source);
#line 740 "../src/client/application/application-main-window.vala"
			_tmp4_ = _tmp3_;
#line 740 "../src/client/application/application-main-window.vala"
			_tmp5_ = geary_client_service_get_last_error (_tmp4_);
#line 740 "../src/client/application/application-main-window.vala"
			_tmp6_ = _tmp5_;
#line 740 "../src/client/application/application-main-window.vala"
			if (_tmp6_ != NULL) {
#line 4245 "application-main-window.c"
				GearyClientService* _tmp7_;
				GearyClientService* _tmp8_;
#line 742 "../src/client/application/application-main-window.vala"
				_tmp7_ = geary_account_get_incoming (problem_source);
#line 742 "../src/client/application/application-main-window.vala"
				_tmp8_ = _tmp7_;
#line 742 "../src/client/application/application-main-window.vala"
				_tmp2_ = _tmp8_;
#line 4254 "application-main-window.c"
			} else {
				GearyClientService* _tmp9_;
				GearyClientService* _tmp10_;
#line 743 "../src/client/application/application-main-window.vala"
				_tmp9_ = geary_account_get_outgoing (problem_source);
#line 743 "../src/client/application/application-main-window.vala"
				_tmp10_ = _tmp9_;
#line 743 "../src/client/application/application-main-window.vala"
				_tmp2_ = _tmp10_;
#line 4264 "application-main-window.c"
			}
#line 740 "../src/client/application/application-main-window.vala"
			_tmp11_ = _g_object_ref0 (_tmp2_);
#line 740 "../src/client/application/application-main-window.vala"
			service = _tmp11_;
#line 745 "../src/client/application/application-main-window.vala"
			_tmp12_ = geary_account_get_information (problem_source);
#line 745 "../src/client/application/application-main-window.vala"
			_tmp13_ = _tmp12_;
#line 745 "../src/client/application/application-main-window.vala"
			_tmp14_ = service;
#line 745 "../src/client/application/application-main-window.vala"
			_tmp15_ = geary_client_service_get_configuration (_tmp14_);
#line 745 "../src/client/application/application-main-window.vala"
			_tmp16_ = _tmp15_;
#line 745 "../src/client/application/application-main-window.vala"
			_tmp17_ = service;
#line 745 "../src/client/application/application-main-window.vala"
			_tmp18_ = geary_client_service_get_last_error (_tmp17_);
#line 745 "../src/client/application/application-main-window.vala"
			_tmp19_ = _tmp18_;
#line 745 "../src/client/application/application-main-window.vala"
			_tmp20_ = geary_error_context_get_thrown (_tmp19_);
#line 745 "../src/client/application/application-main-window.vala"
			_tmp21_ = _tmp20_;
#line 745 "../src/client/application/application-main-window.vala"
			_tmp22_ = geary_service_problem_report_new (_tmp13_, _tmp16_, _tmp21_);
#line 745 "../src/client/application/application-main-window.vala"
			_tmp23_ = _tmp22_;
#line 745 "../src/client/application/application-main-window.vala"
			_tmp24_ = components_problem_report_info_bar_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEARY_TYPE_PROBLEM_REPORT, GearyProblemReport));
#line 745 "../src/client/application/application-main-window.vala"
			g_object_ref_sink (_tmp24_);
#line 745 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (self->priv->service_problem_infobar);
#line 745 "../src/client/application/application-main-window.vala"
			self->priv->service_problem_infobar = _tmp24_;
#line 745 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_tmp23_);
#line 752 "../src/client/application/application-main-window.vala"
			_tmp25_ = self->priv->service_problem_infobar;
#line 752 "../src/client/application/application-main-window.vala"
			g_signal_connect_object (_tmp25_, "retry", (GCallback) _application_main_window_on_service_problem_retry_components_problem_report_info_bar_retry, self, 0);
#line 753 "../src/client/application/application-main-window.vala"
			_tmp26_ = self->priv->info_bars;
#line 753 "../src/client/application/application-main-window.vala"
			_tmp27_ = self->priv->service_problem_infobar;
#line 753 "../src/client/application/application-main-window.vala"
			components_info_bar_stack_add (_tmp26_, G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, COMPONENTS_TYPE_INFO_BAR, ComponentsInfoBar));
#line 739 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (service);
#line 4316 "application-main-window.c"
		} else {
#line 754 "../src/client/application/application-main-window.vala"
			if (has_cert_error) {
#line 4320 "application-main-window.c"
				ComponentsInfoBarStack* _tmp28_;
				ComponentsInfoBar* _tmp29_;
#line 755 "../src/client/application/application-main-window.vala"
				_tmp28_ = self->priv->info_bars;
#line 755 "../src/client/application/application-main-window.vala"
				_tmp29_ = self->priv->cert_problem_infobar;
#line 755 "../src/client/application/application-main-window.vala"
				components_info_bar_stack_add (_tmp28_, _tmp29_);
#line 4329 "application-main-window.c"
			} else {
#line 756 "../src/client/application/application-main-window.vala"
				if (has_auth_error) {
#line 4333 "application-main-window.c"
					ComponentsInfoBarStack* _tmp30_;
					ComponentsInfoBar* _tmp31_;
#line 757 "../src/client/application/application-main-window.vala"
					_tmp30_ = self->priv->info_bars;
#line 757 "../src/client/application/application-main-window.vala"
					_tmp31_ = self->priv->auth_problem_infobar;
#line 757 "../src/client/application/application-main-window.vala"
					components_info_bar_stack_add (_tmp30_, _tmp31_);
#line 4342 "application-main-window.c"
				} else {
					ComponentsInfoBarStack* _tmp32_;
#line 759 "../src/client/application/application-main-window.vala"
					_tmp32_ = self->priv->info_bars;
#line 759 "../src/client/application/application-main-window.vala"
					components_info_bar_stack_remove_all (_tmp32_);
#line 4349 "application-main-window.c"
				}
			}
		}
	}
}

static void
application_main_window_select_folder_data_free (gpointer _data)
{
	ApplicationMainWindowSelectFolderData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_select);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/application-main-window.vala"
	g_slice_free (ApplicationMainWindowSelectFolderData, _data_);
#line 4367 "application-main-window.c"
}

void
application_main_window_select_folder (ApplicationMainWindow* self,
                                       GearyFolder* to_select,
                                       gboolean is_interactive,
                                       gboolean inhibit_autoselect,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	ApplicationMainWindowSelectFolderData* _data_;
	ApplicationMainWindow* _tmp0_;
	GearyFolder* _tmp1_;
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((to_select == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (to_select, GEARY_TYPE_FOLDER));
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_slice_new0 (ApplicationMainWindowSelectFolderData);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 10 "../src/client/application/application-main-window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_main_window_select_folder_data_free);
#line 10 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (to_select);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_select);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->to_select = _tmp1_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_->is_interactive = is_interactive;
#line 10 "../src/client/application/application-main-window.vala"
	_data_->inhibit_autoselect = inhibit_autoselect;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_select_folder_co (_data_);
#line 4407 "application-main-window.c"
}

void
application_main_window_select_folder_finish (ApplicationMainWindow* self,
                                              GAsyncResult* _res_)
{
	ApplicationMainWindowSelectFolderData* _data_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 4417 "application-main-window.c"
}

/**
     * Selects and open the given folder.
     *
     * If is_interactive is true, the selection is treated as being
     * caused directly by human request (e.g. clicking on a folder in
     * the folder list), as opposed to some side effect.
     */
static void
_application_main_window_update_headerbar_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self)
{
#line 785 "../src/client/application/application-main-window.vala"
	application_main_window_update_headerbar ((ApplicationMainWindow*) self);
#line 4434 "application-main-window.c"
}

static void
application_main_window_select_folder_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	ApplicationMainWindowSelectFolderData* _data_;
#line 853 "../src/client/application/application-main-window.vala"
	_data_ = _user_data_;
#line 853 "../src/client/application/application-main-window.vala"
	_data_->_source_object_ = source_object;
#line 853 "../src/client/application/application-main-window.vala"
	_data_->_res_ = _res_;
#line 853 "../src/client/application/application-main-window.vala"
	application_main_window_select_folder_co (_data_);
#line 4451 "application-main-window.c"
}

static gboolean
application_main_window_select_folder_co (ApplicationMainWindowSelectFolderData* _data_)
{
#line 770 "../src/client/application/application-main-window.vala"
	switch (_data_->_state_) {
#line 770 "../src/client/application/application-main-window.vala"
		case 0:
#line 4461 "application-main-window.c"
		goto _state_0;
#line 770 "../src/client/application/application-main-window.vala"
		case 1:
#line 4465 "application-main-window.c"
		goto _state_1;
#line 770 "../src/client/application/application-main-window.vala"
		case 2:
#line 4469 "application-main-window.c"
		goto _state_2;
		default:
#line 770 "../src/client/application/application-main-window.vala"
		g_assert_not_reached ();
#line 4474 "application-main-window.c"
	}
	_state_0:
#line 773 "../src/client/application/application-main-window.vala"
	_data_->_tmp0_ = _data_->self->priv->_selected_folder;
#line 773 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp0_ != _data_->to_select) {
#line 775 "../src/client/application/application-main-window.vala"
		_data_->_tmp1_ = _data_->self->priv->folder_open;
#line 775 "../src/client/application/application-main-window.vala"
		g_cancellable_cancel (_data_->_tmp1_);
#line 776 "../src/client/application/application-main-window.vala"
		_data_->_tmp2_ = g_cancellable_new ();
#line 776 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data_->self->priv->folder_open);
#line 776 "../src/client/application/application-main-window.vala"
		_data_->self->priv->folder_open = _data_->_tmp2_;
#line 776 "../src/client/application/application-main-window.vala"
		_data_->_tmp3_ = _data_->self->priv->folder_open;
#line 776 "../src/client/application/application-main-window.vala"
		_data_->_tmp4_ = _g_object_ref0 (_data_->_tmp3_);
#line 776 "../src/client/application/application-main-window.vala"
		_data_->cancellable = _data_->_tmp4_;
#line 778 "../src/client/application/application-main-window.vala"
		_data_->_tmp5_ = _data_->self->priv->conversation_list_headerbar;
#line 778 "../src/client/application/application-main-window.vala"
		components_conversation_list_header_bar_set_selection_open (_data_->_tmp5_, FALSE);
#line 783 "../src/client/application/application-main-window.vala"
		_data_->_tmp6_ = _data_->self->priv->_selected_folder;
#line 783 "../src/client/application/application-main-window.vala"
		if (_data_->_tmp6_ != NULL) {
#line 784 "../src/client/application/application-main-window.vala"
			_data_->_tmp7_ = _data_->self->priv->progress_monitor;
#line 784 "../src/client/application/application-main-window.vala"
			_data_->_tmp8_ = _data_->self->priv->_selected_folder;
#line 784 "../src/client/application/application-main-window.vala"
			_data_->_tmp9_ = geary_folder_get_opening_monitor (_data_->_tmp8_);
#line 784 "../src/client/application/application-main-window.vala"
			_data_->_tmp10_ = _data_->_tmp9_;
#line 784 "../src/client/application/application-main-window.vala"
			geary_aggregate_progress_monitor_remove (_data_->_tmp7_, _data_->_tmp10_);
#line 785 "../src/client/application/application-main-window.vala"
			_data_->_tmp11_ = _data_->self->priv->_selected_folder;
#line 785 "../src/client/application/application-main-window.vala"
			_data_->_tmp12_ = geary_folder_get_properties (_data_->_tmp11_);
#line 785 "../src/client/application/application-main-window.vala"
			_data_->_tmp13_ = _data_->_tmp12_;
#line 785 "../src/client/application/application-main-window.vala"
			g_signal_parse_name ("notify", G_TYPE_OBJECT, &_data_->_tmp14_, NULL, FALSE);
#line 785 "../src/client/application/application-main-window.vala"
			g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp13_, G_TYPE_OBJECT, GObject), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _data_->_tmp14_, 0, NULL, (GCallback) _application_main_window_update_headerbar_g_object_notify, _data_->self);
#line 786 "../src/client/application/application-main-window.vala"
			application_main_window_set_selected_folder (_data_->self, NULL);
#line 4527 "application-main-window.c"
		}
#line 788 "../src/client/application/application-main-window.vala"
		_data_->_tmp15_ = _data_->self->priv->_conversations;
#line 788 "../src/client/application/application-main-window.vala"
		if (_data_->_tmp15_ != NULL) {
#line 789 "../src/client/application/application-main-window.vala"
			_data_->_tmp16_ = _data_->self->priv->progress_monitor;
#line 789 "../src/client/application/application-main-window.vala"
			_data_->_tmp17_ = _data_->self->priv->_conversations;
#line 789 "../src/client/application/application-main-window.vala"
			_data_->_tmp18_ = geary_app_conversation_monitor_get_progress_monitor (_data_->_tmp17_);
#line 789 "../src/client/application/application-main-window.vala"
			_data_->_tmp19_ = _data_->_tmp18_;
#line 789 "../src/client/application/application-main-window.vala"
			geary_aggregate_progress_monitor_remove (_data_->_tmp16_, _data_->_tmp19_);
#line 790 "../src/client/application/application-main-window.vala"
			_data_->_tmp20_ = _data_->self->priv->_conversations;
#line 790 "../src/client/application/application-main-window.vala"
			application_main_window_close_conversation_monitor (_data_->self, _data_->_tmp20_);
#line 791 "../src/client/application/application-main-window.vala"
			application_main_window_set_conversations (_data_->self, NULL);
#line 792 "../src/client/application/application-main-window.vala"
			_data_->_tmp21_ = _data_->self->priv->_conversation_list_view;
#line 792 "../src/client/application/application-main-window.vala"
			conversation_list_view_set_monitor (_data_->_tmp21_, NULL);
#line 4553 "application-main-window.c"
		}
#line 795 "../src/client/application/application-main-window.vala"
		_data_->_tmp22_ = _data_->self->priv->_conversation_list_info_bars;
#line 795 "../src/client/application/application-main-window.vala"
		components_info_bar_stack_remove_all (_data_->_tmp22_);
#line 800 "../src/client/application/application-main-window.vala"
		if (_data_->to_select != NULL) {
#line 800 "../src/client/application/application-main-window.vala"
			_data_->_tmp24_ = geary_folder_get_account (_data_->to_select);
#line 800 "../src/client/application/application-main-window.vala"
			_data_->_tmp25_ = _data_->_tmp24_;
#line 800 "../src/client/application/application-main-window.vala"
			_data_->_tmp23_ = _data_->_tmp25_;
#line 4567 "application-main-window.c"
		} else {
#line 800 "../src/client/application/application-main-window.vala"
			_data_->_tmp23_ = NULL;
#line 4571 "application-main-window.c"
		}
#line 800 "../src/client/application/application-main-window.vala"
		application_main_window_select_account (_data_->self, _data_->_tmp23_);
#line 801 "../src/client/application/application-main-window.vala"
		application_main_window_set_selected_folder (_data_->self, _data_->to_select);
#line 807 "../src/client/application/application-main-window.vala"
		if (_data_->to_select != NULL) {
#line 810 "../src/client/application/application-main-window.vala"
			if (_data_->is_interactive) {
#line 810 "../src/client/application/application-main-window.vala"
				_data_->_tmp26_ = TRUE;
#line 4583 "application-main-window.c"
			} else {
#line 811 "../src/client/application/application-main-window.vala"
				_data_->_tmp28_ = geary_folder_get_used_as (_data_->to_select);
#line 811 "../src/client/application/application-main-window.vala"
				_data_->_tmp29_ = _data_->_tmp28_;
#line 811 "../src/client/application/application-main-window.vala"
				if (_data_->_tmp29_ != GEARY_FOLDER_SPECIAL_USE_INBOX) {
#line 811 "../src/client/application/application-main-window.vala"
					_data_->_tmp27_ = TRUE;
#line 4593 "application-main-window.c"
				} else {
#line 812 "../src/client/application/application-main-window.vala"
					_data_->_tmp30_ = _data_->self->priv->_folder_list;
#line 812 "../src/client/application/application-main-window.vala"
					_data_->_tmp31_ = geary_folder_get_account (_data_->to_select);
#line 812 "../src/client/application/application-main-window.vala"
					_data_->_tmp32_ = _data_->_tmp31_;
#line 812 "../src/client/application/application-main-window.vala"
					_data_->_tmp27_ = !folder_list_tree_select_inbox (_data_->_tmp30_, _data_->_tmp32_);
#line 4603 "application-main-window.c"
				}
#line 811 "../src/client/application/application-main-window.vala"
				_data_->_tmp26_ = _data_->_tmp27_;
#line 4607 "application-main-window.c"
			}
#line 810 "../src/client/application/application-main-window.vala"
			if (_data_->_tmp26_) {
#line 813 "../src/client/application/application-main-window.vala"
				_data_->_tmp33_ = _data_->self->priv->_folder_list;
#line 813 "../src/client/application/application-main-window.vala"
				folder_list_tree_select_folder (_data_->_tmp33_, _data_->to_select);
#line 4615 "application-main-window.c"
			}
		} else {
#line 816 "../src/client/application/application-main-window.vala"
			_data_->_tmp34_ = _data_->self->priv->_folder_list;
#line 816 "../src/client/application/application-main-window.vala"
			folder_list_tree_deselect_folder (_data_->_tmp34_);
#line 4622 "application-main-window.c"
		}
#line 819 "../src/client/application/application-main-window.vala"
		application_main_window_update_title (_data_->self);
#line 820 "../src/client/application/application-main-window.vala"
		application_main_window_update_conversation_actions (_data_->self, APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_NONE);
#line 821 "../src/client/application/application-main-window.vala"
		application_main_window_update_trash_action (_data_->self);
#line 823 "../src/client/application/application-main-window.vala"
		_data_->_tmp35_ = _data_->self->priv->_conversation_viewer;
#line 823 "../src/client/application/application-main-window.vala"
		conversation_viewer_show_loading (_data_->_tmp35_);
#line 824 "../src/client/application/application-main-window.vala"
		_data_->self->priv->previous_selection_was_interactive = _data_->is_interactive;
#line 827 "../src/client/application/application-main-window.vala"
		if (_data_->to_select != NULL) {
#line 827 "../src/client/application/application-main-window.vala"
			_data_->_tmp37_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->to_select, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 827 "../src/client/application/application-main-window.vala"
			_g_free0 (_data_->_tmp36_);
#line 827 "../src/client/application/application-main-window.vala"
			_data_->_tmp36_ = _data_->_tmp37_;
#line 4644 "application-main-window.c"
		} else {
#line 827 "../src/client/application/application-main-window.vala"
			_data_->_tmp38_ = g_strdup ("(null)");
#line 827 "../src/client/application/application-main-window.vala"
			_g_free0 (_data_->_tmp36_);
#line 827 "../src/client/application/application-main-window.vala"
			_data_->_tmp36_ = _data_->_tmp38_;
#line 4652 "application-main-window.c"
		}
#line 826 "../src/client/application/application-main-window.vala"
		g_debug ("application-main-window.vala:826: Folder selected: %s", _data_->_tmp36_);
#line 832 "../src/client/application/application-main-window.vala"
		if (_data_->to_select != NULL) {
#line 833 "../src/client/application/application-main-window.vala"
			_data_->_tmp39_ = _data_->self->priv->progress_monitor;
#line 833 "../src/client/application/application-main-window.vala"
			_data_->_tmp40_ = geary_folder_get_opening_monitor (_data_->to_select);
#line 833 "../src/client/application/application-main-window.vala"
			_data_->_tmp41_ = _data_->_tmp40_;
#line 833 "../src/client/application/application-main-window.vala"
			geary_aggregate_progress_monitor_add (_data_->_tmp39_, _data_->_tmp41_);
#line 834 "../src/client/application/application-main-window.vala"
			_data_->_tmp42_ = geary_folder_get_properties (_data_->to_select);
#line 834 "../src/client/application/application-main-window.vala"
			_data_->_tmp43_ = _data_->_tmp42_;
#line 834 "../src/client/application/application-main-window.vala"
			g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp43_, G_TYPE_OBJECT, GObject), "notify", (GCallback) _application_main_window_update_headerbar_g_object_notify, _data_->self, 0);
#line 836 "../src/client/application/application-main-window.vala"
			_data_->_tmp44_ = geary_app_conversation_monitor_new (_data_->to_select, (CONVERSATION_LIST_VIEW_REQUIRED_FIELDS | CONVERSATION_LIST_BOX_REQUIRED_FIELDS) | CONVERSATION_EMAIL_REQUIRED_FOR_CONSTRUCT, APPLICATION_MAIN_WINDOW_MIN_CONVERSATION_COUNT);
#line 836 "../src/client/application/application-main-window.vala"
			_data_->_tmp45_ = _data_->_tmp44_;
#line 836 "../src/client/application/application-main-window.vala"
			application_main_window_set_conversations (_data_->self, _data_->_tmp45_);
#line 836 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_data_->_tmp45_);
#line 846 "../src/client/application/application-main-window.vala"
			_data_->_tmp46_ = _data_->self->priv->progress_monitor;
#line 846 "../src/client/application/application-main-window.vala"
			_data_->_tmp47_ = _data_->self->priv->_conversations;
#line 846 "../src/client/application/application-main-window.vala"
			_data_->_tmp48_ = geary_app_conversation_monitor_get_progress_monitor (_data_->_tmp47_);
#line 846 "../src/client/application/application-main-window.vala"
			_data_->_tmp49_ = _data_->_tmp48_;
#line 846 "../src/client/application/application-main-window.vala"
			geary_aggregate_progress_monitor_add (_data_->_tmp46_, _data_->_tmp49_);
#line 848 "../src/client/application/application-main-window.vala"
			if (_data_->inhibit_autoselect) {
#line 849 "../src/client/application/application-main-window.vala"
				_data_->_tmp50_ = _data_->self->priv->_conversation_list_view;
#line 849 "../src/client/application/application-main-window.vala"
				conversation_list_view_inhibit_next_autoselect (_data_->_tmp50_);
#line 4696 "application-main-window.c"
			}
#line 851 "../src/client/application/application-main-window.vala"
			_data_->_tmp51_ = _data_->self->priv->_conversation_list_view;
#line 851 "../src/client/application/application-main-window.vala"
			_data_->_tmp52_ = _data_->self->priv->_conversations;
#line 851 "../src/client/application/application-main-window.vala"
			conversation_list_view_set_monitor (_data_->_tmp51_, _data_->_tmp52_);
#line 853 "../src/client/application/application-main-window.vala"
			_data_->_tmp53_ = _data_->self->priv->_conversations;
#line 853 "../src/client/application/application-main-window.vala"
			_data_->_tmp54_ = _data_->cancellable;
#line 853 "../src/client/application/application-main-window.vala"
			_data_->_state_ = 1;
#line 853 "../src/client/application/application-main-window.vala"
			application_main_window_open_conversation_monitor (_data_->self, _data_->_tmp53_, _data_->_tmp54_, application_main_window_select_folder_ready, _data_);
#line 853 "../src/client/application/application-main-window.vala"
			return FALSE;
#line 4714 "application-main-window.c"
			_state_1:
#line 853 "../src/client/application/application-main-window.vala"
			application_main_window_open_conversation_monitor_finish (_data_->self, _data_->_res_);
#line 854 "../src/client/application/application-main-window.vala"
			_data_->_tmp55_ = _data_->self->priv->controller;
#line 854 "../src/client/application/application-main-window.vala"
			_data_->_state_ = 2;
#line 854 "../src/client/application/application-main-window.vala"
			application_controller_process_pending_composers (_data_->_tmp55_, application_main_window_select_folder_ready, _data_);
#line 854 "../src/client/application/application-main-window.vala"
			return FALSE;
#line 4726 "application-main-window.c"
			_state_2:
#line 854 "../src/client/application/application-main-window.vala"
			application_controller_process_pending_composers_finish (_data_->_tmp55_, _data_->_res_);
#line 4730 "application-main-window.c"
		}
#line 773 "../src/client/application/application-main-window.vala"
		_g_free0 (_data_->_tmp36_);
#line 773 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data_->cancellable);
#line 4736 "application-main-window.c"
	}
#line 858 "../src/client/application/application-main-window.vala"
	application_main_window_update_headerbar (_data_->self);
#line 770 "../src/client/application/application-main-window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 770 "../src/client/application/application-main-window.vala"
	if (_data_->_state_ != 0) {
#line 770 "../src/client/application/application-main-window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 770 "../src/client/application/application-main-window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4748 "application-main-window.c"
		}
	}
#line 770 "../src/client/application/application-main-window.vala"
	g_object_unref (_data_->_async_result);
#line 770 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 4755 "application-main-window.c"
}

static void
application_main_window_show_conversations_data_free (gpointer _data)
{
	ApplicationMainWindowShowConversationsData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->location);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_show);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/application-main-window.vala"
	g_slice_free (ApplicationMainWindowShowConversationsData, _data_);
#line 4771 "application-main-window.c"
}

void
application_main_window_show_conversations (ApplicationMainWindow* self,
                                            GearyFolder* location,
                                            GeeCollection* to_show,
                                            gboolean is_interactive,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	ApplicationMainWindowShowConversationsData* _data_;
	ApplicationMainWindow* _tmp0_;
	GearyFolder* _tmp1_;
	GeeCollection* _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (location, GEARY_TYPE_FOLDER));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (to_show, GEE_TYPE_COLLECTION));
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_slice_new0 (ApplicationMainWindowShowConversationsData);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 10 "../src/client/application/application-main-window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_main_window_show_conversations_data_free);
#line 10 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (location);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->location);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->location = _tmp1_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp2_ = _g_object_ref0 (to_show);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_show);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->to_show = _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_->is_interactive = is_interactive;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_show_conversations_co (_data_);
#line 4818 "application-main-window.c"
}

void
application_main_window_show_conversations_finish (ApplicationMainWindow* self,
                                                   GAsyncResult* _res_)
{
	ApplicationMainWindowShowConversationsData* _data_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 4828 "application-main-window.c"
}

/** Selects the given account, folder and conversations. */
static void
application_main_window_show_conversations_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_)
{
	ApplicationMainWindowShowConversationsData* _data_;
#line 866 "../src/client/application/application-main-window.vala"
	_data_ = _user_data_;
#line 866 "../src/client/application/application-main-window.vala"
	_data_->_source_object_ = source_object;
#line 866 "../src/client/application/application-main-window.vala"
	_data_->_res_ = _res_;
#line 866 "../src/client/application/application-main-window.vala"
	application_main_window_show_conversations_co (_data_);
#line 4846 "application-main-window.c"
}

static gboolean
application_main_window_show_conversations_co (ApplicationMainWindowShowConversationsData* _data_)
{
#line 862 "../src/client/application/application-main-window.vala"
	switch (_data_->_state_) {
#line 862 "../src/client/application/application-main-window.vala"
		case 0:
#line 4856 "application-main-window.c"
		goto _state_0;
#line 862 "../src/client/application/application-main-window.vala"
		case 1:
#line 4860 "application-main-window.c"
		goto _state_1;
#line 862 "../src/client/application/application-main-window.vala"
		case 2:
#line 4864 "application-main-window.c"
		goto _state_2;
#line 862 "../src/client/application/application-main-window.vala"
		case 3:
#line 4868 "application-main-window.c"
		goto _state_3;
		default:
#line 862 "../src/client/application/application-main-window.vala"
		g_assert_not_reached ();
#line 4873 "application-main-window.c"
	}
	_state_0:
#line 865 "../src/client/application/application-main-window.vala"
	_data_->_tmp0_ = _data_->self->priv->_selected_folder;
#line 865 "../src/client/application/application-main-window.vala"
	_data_->inhibit_autoselect = _data_->location != _data_->_tmp0_;
#line 866 "../src/client/application/application-main-window.vala"
	_data_->_state_ = 1;
#line 866 "../src/client/application/application-main-window.vala"
	application_main_window_select_folder (_data_->self, _data_->location, _data_->is_interactive, _data_->inhibit_autoselect, application_main_window_show_conversations_ready, _data_);
#line 866 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 4886 "application-main-window.c"
	_state_1:
#line 866 "../src/client/application/application-main-window.vala"
	application_main_window_select_folder_finish (_data_->self, _data_->_res_);
#line 869 "../src/client/application/application-main-window.vala"
	_data_->_tmp1_ = _data_->self->priv->_selected_folder;
#line 869 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp1_ == _data_->location) {
#line 870 "../src/client/application/application-main-window.vala"
		application_main_window_navigate_next_pane (_data_->self);
#line 874 "../src/client/application/application-main-window.vala"
		_data_->_tmp2_ = gee_hash_set_new (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 874 "../src/client/application/application-main-window.vala"
		_data_->latest_email = _data_->_tmp2_;
#line 4900 "application-main-window.c"
		{
#line 875 "../src/client/application/application-main-window.vala"
			_data_->_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_data_->to_show, GEE_TYPE_ITERABLE, GeeIterable));
#line 875 "../src/client/application/application-main-window.vala"
			_data_->_stale_it = _data_->_tmp3_;
#line 875 "../src/client/application/application-main-window.vala"
			while (TRUE) {
#line 875 "../src/client/application/application-main-window.vala"
				_data_->_tmp4_ = _data_->_stale_it;
#line 875 "../src/client/application/application-main-window.vala"
				if (!gee_iterator_next (_data_->_tmp4_)) {
#line 875 "../src/client/application/application-main-window.vala"
					break;
#line 4914 "application-main-window.c"
				}
#line 875 "../src/client/application/application-main-window.vala"
				_data_->_tmp5_ = _data_->_stale_it;
#line 875 "../src/client/application/application-main-window.vala"
				_data_->_tmp6_ = gee_iterator_get (_data_->_tmp5_);
#line 875 "../src/client/application/application-main-window.vala"
				_data_->stale = (GearyAppConversation*) _data_->_tmp6_;
#line 876 "../src/client/application/application-main-window.vala"
				_data_->_tmp7_ = _data_->stale;
#line 876 "../src/client/application/application-main-window.vala"
				_data_->_tmp8_ = geary_app_conversation_get_latest_recv_email (_data_->_tmp7_, GEARY_APP_CONVERSATION_LOCATION_IN_FOLDER, NULL);
#line 876 "../src/client/application/application-main-window.vala"
				_data_->first = _data_->_tmp8_;
#line 877 "../src/client/application/application-main-window.vala"
				_data_->_tmp9_ = _data_->first;
#line 877 "../src/client/application/application-main-window.vala"
				if (_data_->_tmp9_ != NULL) {
#line 878 "../src/client/application/application-main-window.vala"
					_data_->_tmp10_ = _data_->latest_email;
#line 878 "../src/client/application/application-main-window.vala"
					_data_->_tmp11_ = _data_->first;
#line 878 "../src/client/application/application-main-window.vala"
					_data_->_tmp12_ = geary_email_get_id (_data_->_tmp11_);
#line 878 "../src/client/application/application-main-window.vala"
					_data_->_tmp13_ = _data_->_tmp12_;
#line 878 "../src/client/application/application-main-window.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp10_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _data_->_tmp13_);
#line 4942 "application-main-window.c"
				}
#line 875 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->first);
#line 875 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->stale);
#line 4948 "application-main-window.c"
			}
#line 875 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_data_->_stale_it);
#line 4952 "application-main-window.c"
		}
#line 881 "../src/client/application/application-main-window.vala"
		_data_->_tmp14_ = _data_->latest_email;
#line 881 "../src/client/application/application-main-window.vala"
		_data_->_state_ = 2;
#line 881 "../src/client/application/application-main-window.vala"
		application_main_window_load_conversations_for_email (_data_->self, _data_->location, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp14_, GEE_TYPE_COLLECTION, GeeCollection), application_main_window_show_conversations_ready, _data_);
#line 881 "../src/client/application/application-main-window.vala"
		return FALSE;
#line 4962 "application-main-window.c"
		_state_2:
#line 881 "../src/client/application/application-main-window.vala"
		_data_->_tmp15_ = application_main_window_load_conversations_for_email_finish (_data_->self, _data_->_res_);
#line 881 "../src/client/application/application-main-window.vala"
		_data_->loaded = _data_->_tmp15_;
#line 884 "../src/client/application/application-main-window.vala"
		_data_->_tmp16_ = _data_->loaded;
#line 884 "../src/client/application/application-main-window.vala"
		_data_->_tmp17_ = gee_collection_get_is_empty (_data_->_tmp16_);
#line 884 "../src/client/application/application-main-window.vala"
		_data_->_tmp18_ = _data_->_tmp17_;
#line 884 "../src/client/application/application-main-window.vala"
		if (!_data_->_tmp18_) {
#line 885 "../src/client/application/application-main-window.vala"
			_data_->_tmp19_ = _data_->loaded;
#line 885 "../src/client/application/application-main-window.vala"
			_data_->_tmp20_ = gee_collection_empty (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref);
#line 885 "../src/client/application/application-main-window.vala"
			_data_->_tmp21_ = _data_->_tmp20_;
#line 885 "../src/client/application/application-main-window.vala"
			_data_->_state_ = 3;
#line 885 "../src/client/application/application-main-window.vala"
			application_main_window_select_conversations (_data_->self, _data_->_tmp19_, _data_->_tmp21_, _data_->is_interactive, application_main_window_show_conversations_ready, _data_);
#line 885 "../src/client/application/application-main-window.vala"
			return FALSE;
#line 4988 "application-main-window.c"
			_state_3:
#line 885 "../src/client/application/application-main-window.vala"
			application_main_window_select_conversations_finish (_data_->self, _data_->_res_);
#line 885 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_data_->_tmp21_);
#line 4994 "application-main-window.c"
		}
#line 869 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data_->loaded);
#line 869 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data_->latest_email);
#line 5000 "application-main-window.c"
	}
#line 862 "../src/client/application/application-main-window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 862 "../src/client/application/application-main-window.vala"
	if (_data_->_state_ != 0) {
#line 862 "../src/client/application/application-main-window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 862 "../src/client/application/application-main-window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5010 "application-main-window.c"
		}
	}
#line 862 "../src/client/application/application-main-window.vala"
	g_object_unref (_data_->_async_result);
#line 862 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 5017 "application-main-window.c"
}

static void
application_main_window_show_email_data_free (gpointer _data)
{
	ApplicationMainWindowShowEmailData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->location);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_show);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/application-main-window.vala"
	g_slice_free (ApplicationMainWindowShowEmailData, _data_);
#line 5033 "application-main-window.c"
}

void
application_main_window_show_email (ApplicationMainWindow* self,
                                    GearyFolder* location,
                                    GeeCollection* to_show,
                                    gboolean is_interactive,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	ApplicationMainWindowShowEmailData* _data_;
	ApplicationMainWindow* _tmp0_;
	GearyFolder* _tmp1_;
	GeeCollection* _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (location, GEARY_TYPE_FOLDER));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (to_show, GEE_TYPE_COLLECTION));
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_slice_new0 (ApplicationMainWindowShowEmailData);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 10 "../src/client/application/application-main-window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_main_window_show_email_data_free);
#line 10 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (location);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->location);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->location = _tmp1_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp2_ = _g_object_ref0 (to_show);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_show);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->to_show = _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_->is_interactive = is_interactive;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_show_email_co (_data_);
#line 5080 "application-main-window.c"
}

void
application_main_window_show_email_finish (ApplicationMainWindow* self,
                                           GAsyncResult* _res_)
{
	ApplicationMainWindowShowEmailData* _data_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 5090 "application-main-window.c"
}

/** Selects the given account, folder and email. */
static void
application_main_window_show_email_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	ApplicationMainWindowShowEmailData* _data_;
#line 899 "../src/client/application/application-main-window.vala"
	_data_ = _user_data_;
#line 899 "../src/client/application/application-main-window.vala"
	_data_->_source_object_ = source_object;
#line 899 "../src/client/application/application-main-window.vala"
	_data_->_res_ = _res_;
#line 899 "../src/client/application/application-main-window.vala"
	application_main_window_show_email_co (_data_);
#line 5108 "application-main-window.c"
}

static gboolean
application_main_window_show_email_co (ApplicationMainWindowShowEmailData* _data_)
{
#line 895 "../src/client/application/application-main-window.vala"
	switch (_data_->_state_) {
#line 895 "../src/client/application/application-main-window.vala"
		case 0:
#line 5118 "application-main-window.c"
		goto _state_0;
#line 895 "../src/client/application/application-main-window.vala"
		case 1:
#line 5122 "application-main-window.c"
		goto _state_1;
#line 895 "../src/client/application/application-main-window.vala"
		case 2:
#line 5126 "application-main-window.c"
		goto _state_2;
#line 895 "../src/client/application/application-main-window.vala"
		case 3:
#line 5130 "application-main-window.c"
		goto _state_3;
#line 895 "../src/client/application/application-main-window.vala"
		case 4:
#line 5134 "application-main-window.c"
		goto _state_4;
		default:
#line 895 "../src/client/application/application-main-window.vala"
		g_assert_not_reached ();
#line 5139 "application-main-window.c"
	}
	_state_0:
#line 898 "../src/client/application/application-main-window.vala"
	_data_->_tmp0_ = _data_->self->priv->_selected_folder;
#line 898 "../src/client/application/application-main-window.vala"
	_data_->inhibit_autoselect = _data_->location != _data_->_tmp0_;
#line 899 "../src/client/application/application-main-window.vala"
	_data_->_state_ = 1;
#line 899 "../src/client/application/application-main-window.vala"
	application_main_window_select_folder (_data_->self, _data_->location, _data_->is_interactive, _data_->inhibit_autoselect, application_main_window_show_email_ready, _data_);
#line 899 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 5152 "application-main-window.c"
	_state_1:
#line 899 "../src/client/application/application-main-window.vala"
	application_main_window_select_folder_finish (_data_->self, _data_->_res_);
#line 902 "../src/client/application/application-main-window.vala"
	_data_->_tmp1_ = _data_->self->priv->_selected_folder;
#line 902 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp1_ == _data_->location) {
#line 903 "../src/client/application/application-main-window.vala"
		_data_->_state_ = 2;
#line 903 "../src/client/application/application-main-window.vala"
		application_main_window_load_conversations_for_email (_data_->self, _data_->location, _data_->to_show, application_main_window_show_email_ready, _data_);
#line 903 "../src/client/application/application-main-window.vala"
		return FALSE;
#line 5166 "application-main-window.c"
		_state_2:
#line 903 "../src/client/application/application-main-window.vala"
		_data_->_tmp2_ = application_main_window_load_conversations_for_email_finish (_data_->self, _data_->_res_);
#line 903 "../src/client/application/application-main-window.vala"
		_data_->loaded = _data_->_tmp2_;
#line 905 "../src/client/application/application-main-window.vala"
		application_main_window_navigate_next_pane (_data_->self);
#line 906 "../src/client/application/application-main-window.vala"
		_data_->_tmp3_ = _data_->loaded;
#line 906 "../src/client/application/application-main-window.vala"
		_data_->_tmp4_ = gee_collection_get_size (_data_->_tmp3_);
#line 906 "../src/client/application/application-main-window.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 906 "../src/client/application/application-main-window.vala"
		if (_data_->_tmp5_ == 1) {
#line 909 "../src/client/application/application-main-window.vala"
			_data_->_tmp6_ = _data_->loaded;
#line 909 "../src/client/application/application-main-window.vala"
			_data_->_tmp7_ = geary_collection_first (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _data_->_tmp6_);
#line 909 "../src/client/application/application-main-window.vala"
			_data_->target = (GearyAppConversation*) _data_->_tmp7_;
#line 910 "../src/client/application/application-main-window.vala"
			_data_->_tmp8_ = _data_->self->priv->_conversation_viewer;
#line 910 "../src/client/application/application-main-window.vala"
			_data_->_tmp9_ = conversation_viewer_get_current_list (_data_->_tmp8_);
#line 910 "../src/client/application/application-main-window.vala"
			_data_->_tmp10_ = _data_->_tmp9_;
#line 910 "../src/client/application/application-main-window.vala"
			_data_->_tmp11_ = _g_object_ref0 (_data_->_tmp10_);
#line 910 "../src/client/application/application-main-window.vala"
			_data_->current_list = _data_->_tmp11_;
#line 912 "../src/client/application/application-main-window.vala"
			_data_->_tmp13_ = _data_->current_list;
#line 912 "../src/client/application/application-main-window.vala"
			if (_data_->_tmp13_ != NULL) {
#line 913 "../src/client/application/application-main-window.vala"
				_data_->_tmp14_ = _data_->current_list;
#line 913 "../src/client/application/application-main-window.vala"
				_data_->_tmp15_ = conversation_list_box_get_conversation (_data_->_tmp14_);
#line 913 "../src/client/application/application-main-window.vala"
				_data_->_tmp16_ = _data_->_tmp15_;
#line 913 "../src/client/application/application-main-window.vala"
				_data_->_tmp17_ = _data_->target;
#line 913 "../src/client/application/application-main-window.vala"
				_data_->_tmp12_ = _data_->_tmp16_ == _data_->_tmp17_;
#line 5212 "application-main-window.c"
			} else {
#line 912 "../src/client/application/application-main-window.vala"
				_data_->_tmp12_ = FALSE;
#line 5216 "application-main-window.c"
			}
#line 912 "../src/client/application/application-main-window.vala"
			if (_data_->_tmp12_) {
#line 921 "../src/client/application/application-main-window.vala"
				_data_->_tmp18_ = _data_->current_list;
#line 921 "../src/client/application/application-main-window.vala"
				conversation_list_box_scroll_to_messages (_data_->_tmp18_, _data_->to_show);
#line 5224 "application-main-window.c"
			} else {
#line 925 "../src/client/application/application-main-window.vala"
				_data_->_tmp19_ = _data_->loaded;
#line 925 "../src/client/application/application-main-window.vala"
				_data_->_state_ = 3;
#line 925 "../src/client/application/application-main-window.vala"
				application_main_window_select_conversations (_data_->self, _data_->_tmp19_, _data_->to_show, _data_->is_interactive, application_main_window_show_email_ready, _data_);
#line 925 "../src/client/application/application-main-window.vala"
				return FALSE;
#line 5234 "application-main-window.c"
				_state_3:
#line 925 "../src/client/application/application-main-window.vala"
				application_main_window_select_conversations_finish (_data_->self, _data_->_res_);
#line 5238 "application-main-window.c"
			}
#line 906 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_data_->current_list);
#line 906 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_data_->target);
#line 5244 "application-main-window.c"
		} else {
#line 927 "../src/client/application/application-main-window.vala"
			_data_->_tmp20_ = _data_->loaded;
#line 927 "../src/client/application/application-main-window.vala"
			_data_->_tmp21_ = gee_collection_get_is_empty (_data_->_tmp20_);
#line 927 "../src/client/application/application-main-window.vala"
			_data_->_tmp22_ = _data_->_tmp21_;
#line 927 "../src/client/application/application-main-window.vala"
			if (!_data_->_tmp22_) {
#line 929 "../src/client/application/application-main-window.vala"
				_data_->_tmp23_ = _data_->loaded;
#line 929 "../src/client/application/application-main-window.vala"
				_data_->_tmp24_ = gee_collection_empty (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref);
#line 929 "../src/client/application/application-main-window.vala"
				_data_->_tmp25_ = _data_->_tmp24_;
#line 929 "../src/client/application/application-main-window.vala"
				_data_->_state_ = 4;
#line 929 "../src/client/application/application-main-window.vala"
				application_main_window_select_conversations (_data_->self, _data_->_tmp23_, _data_->_tmp25_, _data_->is_interactive, application_main_window_show_email_ready, _data_);
#line 929 "../src/client/application/application-main-window.vala"
				return FALSE;
#line 5266 "application-main-window.c"
				_state_4:
#line 929 "../src/client/application/application-main-window.vala"
				application_main_window_select_conversations_finish (_data_->self, _data_->_res_);
#line 929 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->_tmp25_);
#line 5272 "application-main-window.c"
			}
		}
#line 902 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data_->loaded);
#line 5277 "application-main-window.c"
	}
#line 895 "../src/client/application/application-main-window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 895 "../src/client/application/application-main-window.vala"
	if (_data_->_state_ != 0) {
#line 895 "../src/client/application/application-main-window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 895 "../src/client/application/application-main-window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5287 "application-main-window.c"
		}
	}
#line 895 "../src/client/application/application-main-window.vala"
	g_object_unref (_data_->_async_result);
#line 895 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 5294 "application-main-window.c"
}

/** Shows the appopriate window menu, if any. */
void
application_main_window_show_window_menu (ApplicationMainWindow* self)
{
	HdyLeaflet* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	HdyLeaflet* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	ComponentsApplicationHeaderBar* _tmp8_;
#line 939 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 940 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->outer_leaflet;
#line 940 "../src/client/application/application-main-window.vala"
	_tmp1_ = hdy_leaflet_get_folded (_tmp0_);
#line 940 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 940 "../src/client/application/application-main-window.vala"
	if (_tmp2_) {
#line 5318 "application-main-window.c"
		HdyLeaflet* _tmp3_;
#line 941 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->outer_leaflet;
#line 941 "../src/client/application/application-main-window.vala"
		hdy_leaflet_navigate (_tmp3_, HDY_NAVIGATION_DIRECTION_BACK);
#line 5324 "application-main-window.c"
	}
#line 943 "../src/client/application/application-main-window.vala"
	_tmp4_ = self->priv->inner_leaflet;
#line 943 "../src/client/application/application-main-window.vala"
	_tmp5_ = hdy_leaflet_get_folded (_tmp4_);
#line 943 "../src/client/application/application-main-window.vala"
	_tmp6_ = _tmp5_;
#line 943 "../src/client/application/application-main-window.vala"
	if (_tmp6_) {
#line 5334 "application-main-window.c"
		HdyLeaflet* _tmp7_;
#line 944 "../src/client/application/application-main-window.vala"
		_tmp7_ = self->priv->inner_leaflet;
#line 944 "../src/client/application/application-main-window.vala"
		hdy_leaflet_navigate (_tmp7_, HDY_NAVIGATION_DIRECTION_BACK);
#line 5340 "application-main-window.c"
	}
#line 946 "../src/client/application/application-main-window.vala"
	_tmp8_ = self->priv->application_headerbar;
#line 946 "../src/client/application/application-main-window.vala"
	components_application_header_bar_show_app_menu (_tmp8_);
#line 5346 "application-main-window.c"
}

/** Displays and focuses the search bar for the window. */
void
application_main_window_show_search_bar (ApplicationMainWindow* self,
                                         const gchar* text)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	SearchBar* _tmp7_;
#line 950 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 951 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_is_conversation_list_shown (self);
#line 951 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 951 "../src/client/application/application-main-window.vala"
	if (!_tmp1_) {
#line 5365 "application-main-window.c"
		HdyLeaflet* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
		HdyLeaflet* _tmp6_;
#line 952 "../src/client/application/application-main-window.vala"
		_tmp2_ = self->priv->outer_leaflet;
#line 952 "../src/client/application/application-main-window.vala"
		_tmp3_ = hdy_leaflet_get_folded (_tmp2_);
#line 952 "../src/client/application/application-main-window.vala"
		_tmp4_ = _tmp3_;
#line 952 "../src/client/application/application-main-window.vala"
		if (_tmp4_) {
#line 5378 "application-main-window.c"
			HdyLeaflet* _tmp5_;
#line 953 "../src/client/application/application-main-window.vala"
			_tmp5_ = self->priv->outer_leaflet;
#line 953 "../src/client/application/application-main-window.vala"
			hdy_leaflet_set_visible_child_name (_tmp5_, APPLICATION_MAIN_WINDOW_INNER_LEAFLET);
#line 5384 "application-main-window.c"
		}
#line 955 "../src/client/application/application-main-window.vala"
		_tmp6_ = self->priv->inner_leaflet;
#line 955 "../src/client/application/application-main-window.vala"
		hdy_leaflet_set_visible_child_name (_tmp6_, APPLICATION_MAIN_WINDOW_CONVERSATION_LIST);
#line 5390 "application-main-window.c"
	}
#line 958 "../src/client/application/application-main-window.vala"
	_tmp7_ = self->priv->_search_bar;
#line 958 "../src/client/application/application-main-window.vala"
	gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget));
#line 959 "../src/client/application/application-main-window.vala"
	if (text != NULL) {
#line 5398 "application-main-window.c"
		SearchBar* _tmp8_;
		GtkSearchEntry* _tmp9_;
		GtkSearchEntry* _tmp10_;
#line 960 "../src/client/application/application-main-window.vala"
		_tmp8_ = self->priv->_search_bar;
#line 960 "../src/client/application/application-main-window.vala"
		_tmp9_ = search_bar_get_entry (_tmp8_);
#line 960 "../src/client/application/application-main-window.vala"
		_tmp10_ = _tmp9_;
#line 960 "../src/client/application/application-main-window.vala"
		gtk_entry_set_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_entry_get_type (), GtkEntry), text);
#line 5410 "application-main-window.c"
	}
}

/** Displays an infobar in the window. */
void
application_main_window_show_info_bar (ApplicationMainWindow* self,
                                       ComponentsInfoBar* info_bar)
{
	ComponentsInfoBarStack* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 965 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 965 "../src/client/application/application-main-window.vala"
	g_return_if_fail (COMPONENTS_IS_INFO_BAR (info_bar));
#line 966 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->info_bars;
#line 966 "../src/client/application/application-main-window.vala"
	_tmp1_ = components_info_bar_stack_get_has_current (_tmp0_);
#line 966 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 966 "../src/client/application/application-main-window.vala"
	if (!_tmp2_) {
#line 5434 "application-main-window.c"
		ComponentsInfoBarStack* _tmp3_;
#line 967 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->info_bars;
#line 967 "../src/client/application/application-main-window.vala"
		components_info_bar_stack_add (_tmp3_, info_bar);
#line 5440 "application-main-window.c"
	}
}

/**
     * Displays a composer in the window if possible, else in a new window.
     */
static Block15Data*
block15_data_ref (Block15Data* _data15_)
{
#line 983 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data15_->_ref_count_);
#line 983 "../src/client/application/application-main-window.vala"
	return _data15_;
#line 5454 "application-main-window.c"
}

static void
block15_data_unref (void * _userdata_)
{
	Block15Data* _data15_;
	_data15_ = (Block15Data*) _userdata_;
#line 983 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data15_->_ref_count_)) {
#line 5464 "application-main-window.c"
		ApplicationMainWindow* self;
#line 983 "../src/client/application/application-main-window.vala"
		self = _data15_->self;
#line 983 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data15_->referrants);
#line 983 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 983 "../src/client/application/application-main-window.vala"
		g_slice_free (Block15Data, _data15_);
#line 5474 "application-main-window.c"
	}
}

static gboolean
____lambda144_ (Block15Data* _data15_,
                GearyEmail* email)
{
	ApplicationMainWindow* self;
	GeeCollection* _tmp0_;
	GearyEmailIdentifier* _tmp1_;
	GearyEmailIdentifier* _tmp2_;
	gboolean result;
#line 991 "../src/client/application/application-main-window.vala"
	self = _data15_->self;
#line 991 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (email, GEARY_TYPE_EMAIL), FALSE);
#line 991 "../src/client/application/application-main-window.vala"
	_tmp0_ = _data15_->referrants;
#line 991 "../src/client/application/application-main-window.vala"
	_tmp1_ = geary_email_get_id (email);
#line 991 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 991 "../src/client/application/application-main-window.vala"
	result = gee_collection_contains (_tmp0_, _tmp2_);
#line 991 "../src/client/application/application-main-window.vala"
	return result;
#line 5501 "application-main-window.c"
}

static gboolean
_____lambda144__gee_predicate (gconstpointer g,
                               gpointer self)
{
	gboolean result;
	result = ____lambda144_ (self, (GearyEmail*) g);
#line 988 "../src/client/application/application-main-window.vala"
	return result;
#line 5512 "application-main-window.c"
}

void
application_main_window_show_composer (ApplicationMainWindow* self,
                                       ComposerWidget* composer)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 974 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 974 "../src/client/application/application-main-window.vala"
	g_return_if_fail (COMPOSER_IS_WIDGET (composer));
#line 975 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_has_composer (self);
#line 975 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 975 "../src/client/application/application-main-window.vala"
	if (_tmp1_) {
#line 5531 "application-main-window.c"
		ApplicationClient* _tmp2_;
		ApplicationClient* _tmp3_;
#line 976 "../src/client/application/application-main-window.vala"
		_tmp2_ = application_main_window_get_application (self);
#line 976 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 976 "../src/client/application/application-main-window.vala"
		composer_widget_detach (composer, _tmp3_);
#line 5540 "application-main-window.c"
	} else {
		GearyEmail* latest_referred = NULL;
		ConversationViewer* _tmp4_;
		ConversationListBox* _tmp5_;
		ConversationListBox* _tmp6_;
		GearyEmail* _tmp18_;
		HdyLeaflet* _tmp22_;
#line 982 "../src/client/application/application-main-window.vala"
		latest_referred = NULL;
#line 983 "../src/client/application/application-main-window.vala"
		_tmp4_ = self->priv->_conversation_viewer;
#line 983 "../src/client/application/application-main-window.vala"
		_tmp5_ = conversation_viewer_get_current_list (_tmp4_);
#line 983 "../src/client/application/application-main-window.vala"
		_tmp6_ = _tmp5_;
#line 983 "../src/client/application/application-main-window.vala"
		if (_tmp6_ != NULL) {
#line 5558 "application-main-window.c"
			Block15Data* _data15_;
			GeeSet* _tmp7_;
			GearyAppConversation* selected = NULL;
			ConversationViewer* _tmp8_;
			ConversationListBox* _tmp9_;
			ConversationListBox* _tmp10_;
			GearyAppConversation* _tmp11_;
			GearyAppConversation* _tmp12_;
			GearyAppConversation* _tmp13_;
			GearyAppConversation* _tmp14_;
			GeeList* _tmp15_;
			GeeList* _tmp16_;
			gpointer _tmp17_;
#line 983 "../src/client/application/application-main-window.vala"
			_data15_ = g_slice_new0 (Block15Data);
#line 983 "../src/client/application/application-main-window.vala"
			_data15_->_ref_count_ = 1;
#line 983 "../src/client/application/application-main-window.vala"
			_data15_->self = g_object_ref (self);
#line 984 "../src/client/application/application-main-window.vala"
			_tmp7_ = composer_widget_get_referred_ids (composer);
#line 984 "../src/client/application/application-main-window.vala"
			_data15_->referrants = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection);
#line 986 "../src/client/application/application-main-window.vala"
			_tmp8_ = self->priv->_conversation_viewer;
#line 986 "../src/client/application/application-main-window.vala"
			_tmp9_ = conversation_viewer_get_current_list (_tmp8_);
#line 986 "../src/client/application/application-main-window.vala"
			_tmp10_ = _tmp9_;
#line 986 "../src/client/application/application-main-window.vala"
			_tmp11_ = conversation_list_box_get_conversation (_tmp10_);
#line 986 "../src/client/application/application-main-window.vala"
			_tmp12_ = _tmp11_;
#line 986 "../src/client/application/application-main-window.vala"
			_tmp13_ = _g_object_ref0 (_tmp12_);
#line 986 "../src/client/application/application-main-window.vala"
			selected = _tmp13_;
#line 988 "../src/client/application/application-main-window.vala"
			_tmp14_ = selected;
#line 988 "../src/client/application/application-main-window.vala"
			_tmp15_ = geary_app_conversation_get_emails (_tmp14_, GEARY_APP_CONVERSATION_ORDERING_RECV_DATE_DESCENDING, GEARY_APP_CONVERSATION_LOCATION_ANYWHERE, NULL, TRUE);
#line 988 "../src/client/application/application-main-window.vala"
			_tmp16_ = _tmp15_;
#line 988 "../src/client/application/application-main-window.vala"
			_tmp17_ = gee_traversable_first_match (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_TRAVERSABLE, GeeTraversable), _____lambda144__gee_predicate, block15_data_ref (_data15_), block15_data_unref);
#line 988 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (latest_referred);
#line 988 "../src/client/application/application-main-window.vala"
			latest_referred = (GearyEmail*) _tmp17_;
#line 988 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_tmp16_);
#line 983 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (selected);
#line 983 "../src/client/application/application-main-window.vala"
			block15_data_unref (_data15_);
#line 983 "../src/client/application/application-main-window.vala"
			_data15_ = NULL;
#line 5616 "application-main-window.c"
		}
#line 995 "../src/client/application/application-main-window.vala"
		_tmp18_ = latest_referred;
#line 995 "../src/client/application/application-main-window.vala"
		if (_tmp18_ != NULL) {
#line 5622 "application-main-window.c"
			ConversationViewer* _tmp19_;
			GearyEmail* _tmp20_;
#line 996 "../src/client/application/application-main-window.vala"
			_tmp19_ = self->priv->_conversation_viewer;
#line 996 "../src/client/application/application-main-window.vala"
			_tmp20_ = latest_referred;
#line 996 "../src/client/application/application-main-window.vala"
			conversation_viewer_do_compose_embedded (_tmp19_, composer, _tmp20_);
#line 5631 "application-main-window.c"
		} else {
			ConversationViewer* _tmp21_;
#line 1000 "../src/client/application/application-main-window.vala"
			_tmp21_ = self->priv->_conversation_viewer;
#line 1000 "../src/client/application/application-main-window.vala"
			conversation_viewer_do_compose (_tmp21_, composer);
#line 5638 "application-main-window.c"
		}
#line 1003 "../src/client/application/application-main-window.vala"
		_tmp22_ = self->priv->outer_leaflet;
#line 1003 "../src/client/application/application-main-window.vala"
		hdy_leaflet_set_visible_child_name (_tmp22_, APPLICATION_MAIN_WINDOW_CONVERSATION_VIEWER);
#line 975 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (latest_referred);
#line 5646 "application-main-window.c"
	}
}

/**
     * Closes any open composers, after prompting the user if requested.
     *
     * Returns true if none were open or the user approved closing
     * them.
     */
gboolean
application_main_window_close_composer (ApplicationMainWindow* self,
                                        gboolean should_prompt,
                                        gboolean is_shutdown)
{
	gboolean closed = FALSE;
	ComposerWidget* composer = NULL;
	ConversationViewer* _tmp0_;
	ComposerWidget* _tmp1_;
	ComposerWidget* _tmp2_;
	ComposerWidget* _tmp3_;
	gboolean _tmp4_ = FALSE;
	ComposerWidget* _tmp5_;
	gboolean result;
#line 1013 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 1014 "../src/client/application/application-main-window.vala"
	closed = TRUE;
#line 1015 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversation_viewer;
#line 1015 "../src/client/application/application-main-window.vala"
	_tmp1_ = conversation_viewer_get_current_composer (_tmp0_);
#line 1015 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 1015 "../src/client/application/application-main-window.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 1015 "../src/client/application/application-main-window.vala"
	composer = _tmp3_;
#line 1016 "../src/client/application/application-main-window.vala"
	_tmp5_ = composer;
#line 1016 "../src/client/application/application-main-window.vala"
	if (_tmp5_ != NULL) {
#line 5688 "application-main-window.c"
		ComposerWidget* _tmp6_;
#line 1017 "../src/client/application/application-main-window.vala"
		_tmp6_ = composer;
#line 1017 "../src/client/application/application-main-window.vala"
		_tmp4_ = composer_widget_conditional_close (_tmp6_, should_prompt, is_shutdown) == COMPOSER_WIDGET_CLOSE_STATUS_CANCELLED;
#line 5694 "application-main-window.c"
	} else {
#line 1016 "../src/client/application/application-main-window.vala"
		_tmp4_ = FALSE;
#line 5698 "application-main-window.c"
	}
#line 1016 "../src/client/application/application-main-window.vala"
	if (_tmp4_) {
#line 1018 "../src/client/application/application-main-window.vala"
		closed = FALSE;
#line 5704 "application-main-window.c"
	}
#line 1020 "../src/client/application/application-main-window.vala"
	result = closed;
#line 1020 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (composer);
#line 1020 "../src/client/application/application-main-window.vala"
	return result;
#line 5712 "application-main-window.c"
}

void
application_main_window_start_search (ApplicationMainWindow* self,
                                      const gchar* query_text,
                                      gboolean is_interactive)
{
	ApplicationAccountContext* context = NULL;
	ApplicationAccountContext* _tmp0_;
	ApplicationAccountContext* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 1023 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1023 "../src/client/application/application-main-window.vala"
	g_return_if_fail (query_text != NULL);
#line 1024 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_selected_account_context (self);
#line 1024 "../src/client/application/application-main-window.vala"
	context = _tmp0_;
#line 1025 "../src/client/application/application-main-window.vala"
	_tmp1_ = context;
#line 1025 "../src/client/application/application-main-window.vala"
	if (_tmp1_ != NULL) {
#line 5736 "application-main-window.c"
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		GearyFolder* _tmp4_;
#line 1028 "../src/client/application/application-main-window.vala"
		_tmp4_ = self->priv->previous_non_search_folder;
#line 1028 "../src/client/application/application-main-window.vala"
		if (_tmp4_ == NULL) {
#line 5744 "application-main-window.c"
			GearyFolder* _tmp5_;
#line 1029 "../src/client/application/application-main-window.vala"
			_tmp5_ = self->priv->_selected_folder;
#line 1029 "../src/client/application/application-main-window.vala"
			_tmp3_ = _tmp5_ != NULL;
#line 5750 "application-main-window.c"
		} else {
#line 1028 "../src/client/application/application-main-window.vala"
			_tmp3_ = FALSE;
#line 5754 "application-main-window.c"
		}
#line 1028 "../src/client/application/application-main-window.vala"
		if (_tmp3_) {
#line 5758 "application-main-window.c"
			GearyFolder* _tmp6_;
			GearyFolderSpecialUse _tmp7_;
			GearyFolderSpecialUse _tmp8_;
#line 1030 "../src/client/application/application-main-window.vala"
			_tmp6_ = self->priv->_selected_folder;
#line 1030 "../src/client/application/application-main-window.vala"
			_tmp7_ = geary_folder_get_used_as (_tmp6_);
#line 1030 "../src/client/application/application-main-window.vala"
			_tmp8_ = _tmp7_;
#line 1030 "../src/client/application/application-main-window.vala"
			_tmp2_ = _tmp8_ != GEARY_FOLDER_SPECIAL_USE_SEARCH;
#line 5770 "application-main-window.c"
		} else {
#line 1028 "../src/client/application/application-main-window.vala"
			_tmp2_ = FALSE;
#line 5774 "application-main-window.c"
		}
#line 1028 "../src/client/application/application-main-window.vala"
		if (_tmp2_) {
#line 5778 "application-main-window.c"
			GearyFolder* _tmp9_;
			GearyFolder* _tmp10_;
#line 1031 "../src/client/application/application-main-window.vala"
			_tmp9_ = self->priv->_selected_folder;
#line 1031 "../src/client/application/application-main-window.vala"
			_tmp10_ = _g_object_ref0 (_tmp9_);
#line 1031 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (self->priv->previous_non_search_folder);
#line 1031 "../src/client/application/application-main-window.vala"
			self->priv->previous_non_search_folder = _tmp10_;
#line 5789 "application-main-window.c"
		}
		{
			UtilEmailSearchExpressionFactory* expr_factory = NULL;
			ApplicationClient* _tmp11_;
			ApplicationClient* _tmp12_;
			ApplicationConfiguration* _tmp13_;
			ApplicationConfiguration* _tmp14_;
			ApplicationAccountContext* _tmp15_;
			GearyAccount* _tmp16_;
			GearyAccount* _tmp17_;
			GearyAccountInformation* _tmp18_;
			GearyAccountInformation* _tmp19_;
			UtilEmailSearchExpressionFactory* _tmp20_;
			GearySearchQuery* query = NULL;
			ApplicationAccountContext* _tmp21_;
			GearyAccount* _tmp22_;
			GearyAccount* _tmp23_;
			UtilEmailSearchExpressionFactory* _tmp24_;
			GeeList* _tmp25_;
			GeeList* _tmp26_;
			GearySearchQuery* _tmp27_;
			GearySearchQuery* _tmp28_;
			FolderListTree* _tmp29_;
			ApplicationClient* _tmp30_;
			ApplicationClient* _tmp31_;
			GearyEngine* _tmp32_;
			GearyEngine* _tmp33_;
			ApplicationAccountContext* _tmp34_;
			GearyAppSearchFolder* _tmp35_;
			ApplicationAccountContext* _tmp36_;
			GearyAppSearchFolder* _tmp37_;
			GearySearchQuery* _tmp38_;
#line 1035 "../src/client/application/application-main-window.vala"
			_tmp11_ = application_main_window_get_application (self);
#line 1035 "../src/client/application/application-main-window.vala"
			_tmp12_ = _tmp11_;
#line 1035 "../src/client/application/application-main-window.vala"
			_tmp13_ = application_client_get_config (_tmp12_);
#line 1035 "../src/client/application/application-main-window.vala"
			_tmp14_ = _tmp13_;
#line 1035 "../src/client/application/application-main-window.vala"
			_tmp15_ = context;
#line 1035 "../src/client/application/application-main-window.vala"
			_tmp16_ = application_account_context_get_account (_tmp15_);
#line 1035 "../src/client/application/application-main-window.vala"
			_tmp17_ = _tmp16_;
#line 1035 "../src/client/application/application-main-window.vala"
			_tmp18_ = geary_account_get_information (_tmp17_);
#line 1035 "../src/client/application/application-main-window.vala"
			_tmp19_ = _tmp18_;
#line 1035 "../src/client/application/application-main-window.vala"
			_tmp20_ = util_email_search_expression_factory_new (application_configuration_get_search_strategy (_tmp14_), _tmp19_);
#line 1035 "../src/client/application/application-main-window.vala"
			expr_factory = _tmp20_;
#line 1039 "../src/client/application/application-main-window.vala"
			_tmp21_ = context;
#line 1039 "../src/client/application/application-main-window.vala"
			_tmp22_ = application_account_context_get_account (_tmp21_);
#line 1039 "../src/client/application/application-main-window.vala"
			_tmp23_ = _tmp22_;
#line 1039 "../src/client/application/application-main-window.vala"
			_tmp24_ = expr_factory;
#line 1039 "../src/client/application/application-main-window.vala"
			_tmp25_ = util_email_search_expression_factory_parse_query (_tmp24_, query_text);
#line 1039 "../src/client/application/application-main-window.vala"
			_tmp26_ = _tmp25_;
#line 1039 "../src/client/application/application-main-window.vala"
			_tmp27_ = geary_account_new_search_query (_tmp23_, _tmp26_, query_text, &_inner_error0_);
#line 1039 "../src/client/application/application-main-window.vala"
			_tmp28_ = _tmp27_;
#line 1039 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_tmp26_);
#line 1039 "../src/client/application/application-main-window.vala"
			query = _tmp28_;
#line 1039 "../src/client/application/application-main-window.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1039 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (expr_factory);
#line 5868 "application-main-window.c"
				goto __catch0_g_error;
			}
#line 1043 "../src/client/application/application-main-window.vala"
			_tmp29_ = self->priv->_folder_list;
#line 1043 "../src/client/application/application-main-window.vala"
			_tmp30_ = application_main_window_get_application (self);
#line 1043 "../src/client/application/application-main-window.vala"
			_tmp31_ = _tmp30_;
#line 1043 "../src/client/application/application-main-window.vala"
			_tmp32_ = application_client_get_engine (_tmp31_);
#line 1043 "../src/client/application/application-main-window.vala"
			_tmp33_ = _tmp32_;
#line 1043 "../src/client/application/application-main-window.vala"
			_tmp34_ = context;
#line 1043 "../src/client/application/application-main-window.vala"
			_tmp35_ = _tmp34_->search;
#line 1043 "../src/client/application/application-main-window.vala"
			folder_list_tree_set_search (_tmp29_, _tmp33_, _tmp35_);
#line 1046 "../src/client/application/application-main-window.vala"
			_tmp36_ = context;
#line 1046 "../src/client/application/application-main-window.vala"
			_tmp37_ = _tmp36_->search;
#line 1046 "../src/client/application/application-main-window.vala"
			_tmp38_ = query;
#line 1046 "../src/client/application/application-main-window.vala"
			geary_app_search_folder_update_query (_tmp37_, _tmp38_);
#line 1034 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (query);
#line 1034 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (expr_factory);
#line 5899 "application-main-window.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* _error_ = NULL;
			ApplicationAccountContext* _tmp39_;
			GearyAccount* _tmp40_;
			GearyAccount* _tmp41_;
			GearyAccountInformation* _tmp42_;
			GearyAccountInformation* _tmp43_;
			GError* _tmp44_;
#line 1034 "../src/client/application/application-main-window.vala"
			_error_ = _inner_error0_;
#line 1034 "../src/client/application/application-main-window.vala"
			_inner_error0_ = NULL;
#line 1048 "../src/client/application/application-main-window.vala"
			_tmp39_ = context;
#line 1048 "../src/client/application/application-main-window.vala"
			_tmp40_ = application_account_context_get_account (_tmp39_);
#line 1048 "../src/client/application/application-main-window.vala"
			_tmp41_ = _tmp40_;
#line 1048 "../src/client/application/application-main-window.vala"
			_tmp42_ = geary_account_get_information (_tmp41_);
#line 1048 "../src/client/application/application-main-window.vala"
			_tmp43_ = _tmp42_;
#line 1048 "../src/client/application/application-main-window.vala"
			_tmp44_ = _error_;
#line 1048 "../src/client/application/application-main-window.vala"
			application_main_window_handle_error (self, _tmp43_, _tmp44_);
#line 1034 "../src/client/application/application-main-window.vala"
			_g_error_free0 (_error_);
#line 5931 "application-main-window.c"
		}
		__finally0:
#line 1034 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1034 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (context);
#line 1034 "../src/client/application/application-main-window.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1034 "../src/client/application/application-main-window.vala"
			g_clear_error (&_inner_error0_);
#line 1034 "../src/client/application/application-main-window.vala"
			return;
#line 5944 "application-main-window.c"
		}
	}
#line 1023 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (context);
#line 5949 "application-main-window.c"
}

void
application_main_window_stop_search (ApplicationMainWindow* self,
                                     gboolean is_interactive)
{
	gboolean _tmp0_ = FALSE;
	GearyFolder* _tmp1_;
	FolderListTree* _tmp15_;
#line 1053 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1056 "../src/client/application/application-main-window.vala"
	_tmp1_ = self->priv->_selected_folder;
#line 1056 "../src/client/application/application-main-window.vala"
	if (_tmp1_ == NULL) {
#line 1056 "../src/client/application/application-main-window.vala"
		_tmp0_ = TRUE;
#line 5967 "application-main-window.c"
	} else {
		GearyFolder* _tmp2_;
		GearyFolderSpecialUse _tmp3_;
		GearyFolderSpecialUse _tmp4_;
#line 1057 "../src/client/application/application-main-window.vala"
		_tmp2_ = self->priv->_selected_folder;
#line 1057 "../src/client/application/application-main-window.vala"
		_tmp3_ = geary_folder_get_used_as (_tmp2_);
#line 1057 "../src/client/application/application-main-window.vala"
		_tmp4_ = _tmp3_;
#line 1057 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp4_ == GEARY_FOLDER_SPECIAL_USE_SEARCH;
#line 5980 "application-main-window.c"
	}
#line 1056 "../src/client/application/application-main-window.vala"
	if (_tmp0_) {
#line 5984 "application-main-window.c"
		GearyFolder* to_select = NULL;
		GearyFolder* _tmp5_;
		GearyFolder* _tmp6_;
		GearyFolder* _tmp7_;
		GearyFolder* _tmp13_;
#line 1058 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->previous_non_search_folder;
#line 1058 "../src/client/application/application-main-window.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 1058 "../src/client/application/application-main-window.vala"
		to_select = _tmp6_;
#line 1059 "../src/client/application/application-main-window.vala"
		_tmp7_ = to_select;
#line 1059 "../src/client/application/application-main-window.vala"
		if (_tmp7_ == NULL) {
#line 6000 "application-main-window.c"
			ApplicationAccountContext* account = NULL;
			ApplicationAccountContext* _tmp8_;
			ApplicationAccountContext* _tmp9_;
#line 1060 "../src/client/application/application-main-window.vala"
			_tmp8_ = application_main_window_get_selected_account_context (self);
#line 1060 "../src/client/application/application-main-window.vala"
			account = _tmp8_;
#line 1061 "../src/client/application/application-main-window.vala"
			_tmp9_ = account;
#line 1061 "../src/client/application/application-main-window.vala"
			if (_tmp9_ != NULL) {
#line 6012 "application-main-window.c"
				ApplicationAccountContext* _tmp10_;
				GearyFolder* _tmp11_;
				GearyFolder* _tmp12_;
#line 1062 "../src/client/application/application-main-window.vala"
				_tmp10_ = account;
#line 1062 "../src/client/application/application-main-window.vala"
				_tmp11_ = _tmp10_->inbox;
#line 1062 "../src/client/application/application-main-window.vala"
				_tmp12_ = _g_object_ref0 (_tmp11_);
#line 1062 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (to_select);
#line 1062 "../src/client/application/application-main-window.vala"
				to_select = _tmp12_;
#line 6026 "application-main-window.c"
			}
#line 1059 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (account);
#line 6030 "application-main-window.c"
		}
#line 1066 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self->priv->previous_non_search_folder);
#line 1066 "../src/client/application/application-main-window.vala"
		self->priv->previous_non_search_folder = NULL;
#line 1067 "../src/client/application/application-main-window.vala"
		_tmp13_ = to_select;
#line 1067 "../src/client/application/application-main-window.vala"
		if (_tmp13_ != NULL) {
#line 6040 "application-main-window.c"
			GearyFolder* _tmp14_;
#line 1068 "../src/client/application/application-main-window.vala"
			_tmp14_ = to_select;
#line 1068 "../src/client/application/application-main-window.vala"
			application_main_window_select_folder (self, _tmp14_, is_interactive, FALSE, NULL, NULL);
#line 6046 "application-main-window.c"
		} else {
#line 1072 "../src/client/application/application-main-window.vala"
			application_main_window_select_first_inbox (self, is_interactive);
#line 6050 "application-main-window.c"
		}
#line 1056 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (to_select);
#line 6054 "application-main-window.c"
	}
#line 1075 "../src/client/application/application-main-window.vala"
	_tmp15_ = self->priv->_folder_list;
#line 1075 "../src/client/application/application-main-window.vala"
	folder_list_tree_remove_search (_tmp15_);
#line 6060 "application-main-window.c"
	{
		GeeIterator* _context_it = NULL;
		ApplicationController* _tmp16_;
		GeeCollection* _tmp17_;
		GeeCollection* _tmp18_;
		GeeIterator* _tmp19_;
		GeeIterator* _tmp20_;
#line 1077 "../src/client/application/application-main-window.vala"
		_tmp16_ = self->priv->controller;
#line 1077 "../src/client/application/application-main-window.vala"
		_tmp17_ = application_account_interface_get_account_contexts (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface));
#line 1077 "../src/client/application/application-main-window.vala"
		_tmp18_ = _tmp17_;
#line 1077 "../src/client/application/application-main-window.vala"
		_tmp19_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1077 "../src/client/application/application-main-window.vala"
		_tmp20_ = _tmp19_;
#line 1077 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp18_);
#line 1077 "../src/client/application/application-main-window.vala"
		_context_it = _tmp20_;
#line 1077 "../src/client/application/application-main-window.vala"
		while (TRUE) {
#line 6084 "application-main-window.c"
			GeeIterator* _tmp21_;
			ApplicationAccountContext* context = NULL;
			GeeIterator* _tmp22_;
			gpointer _tmp23_;
			ApplicationAccountContext* _tmp24_;
			GearyAppSearchFolder* _tmp25_;
#line 1077 "../src/client/application/application-main-window.vala"
			_tmp21_ = _context_it;
#line 1077 "../src/client/application/application-main-window.vala"
			if (!gee_iterator_next (_tmp21_)) {
#line 1077 "../src/client/application/application-main-window.vala"
				break;
#line 6097 "application-main-window.c"
			}
#line 1077 "../src/client/application/application-main-window.vala"
			_tmp22_ = _context_it;
#line 1077 "../src/client/application/application-main-window.vala"
			_tmp23_ = gee_iterator_get (_tmp22_);
#line 1077 "../src/client/application/application-main-window.vala"
			context = (ApplicationAccountContext*) _tmp23_;
#line 1078 "../src/client/application/application-main-window.vala"
			_tmp24_ = context;
#line 1078 "../src/client/application/application-main-window.vala"
			_tmp25_ = _tmp24_->search;
#line 1078 "../src/client/application/application-main-window.vala"
			geary_app_search_folder_clear_query (_tmp25_);
#line 1077 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (context);
#line 6113 "application-main-window.c"
		}
#line 1077 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_context_it);
#line 6117 "application-main-window.c"
	}
}

gboolean
application_main_window_select_first_inbox (ApplicationMainWindow* self,
                                            gboolean is_interactive)
{
	gboolean success = FALSE;
	GearyFolder* inbox = NULL;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	gboolean result;
#line 1082 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 1083 "../src/client/application/application-main-window.vala"
	success = FALSE;
#line 1084 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_first_inbox (self);
#line 1084 "../src/client/application/application-main-window.vala"
	inbox = _tmp0_;
#line 1085 "../src/client/application/application-main-window.vala"
	_tmp1_ = inbox;
#line 1085 "../src/client/application/application-main-window.vala"
	if (_tmp1_ != NULL) {
#line 6142 "application-main-window.c"
		GearyFolder* _tmp2_;
#line 1086 "../src/client/application/application-main-window.vala"
		_tmp2_ = inbox;
#line 1086 "../src/client/application/application-main-window.vala"
		application_main_window_select_folder (self, _tmp2_, is_interactive, FALSE, NULL, NULL);
#line 1087 "../src/client/application/application-main-window.vala"
		success = TRUE;
#line 6150 "application-main-window.c"
	}
#line 1089 "../src/client/application/application-main-window.vala"
	result = success;
#line 1089 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (inbox);
#line 1089 "../src/client/application/application-main-window.vala"
	return result;
#line 6158 "application-main-window.c"
}

static void
_application_main_window_on_folders_available_application_account_context_folders_available (ApplicationAccountContext* _sender,
                                                                                             GeeCollection* available,
                                                                                             gpointer self)
{
#line 1106 "../src/client/application/application-main-window.vala"
	application_main_window_on_folders_available ((ApplicationMainWindow*) self, available);
#line 6168 "application-main-window.c"
}

static void
_application_main_window_on_folders_unavailable_application_account_context_folders_unavailable (ApplicationAccountContext* _sender,
                                                                                                 GeeCollection* unavailable,
                                                                                                 gpointer self)
{
#line 1107 "../src/client/application/application-main-window.vala"
	application_main_window_on_folders_unavailable ((ApplicationMainWindow*) self, unavailable);
#line 6178 "application-main-window.c"
}

static void
_application_main_window_on_command_execute_application_command_stack_executed (ApplicationCommandStack* _sender,
                                                                                ApplicationCommand* command,
                                                                                gpointer self)
{
#line 1108 "../src/client/application/application-main-window.vala"
	application_main_window_on_command_execute ((ApplicationMainWindow*) self, command);
#line 6188 "application-main-window.c"
}

static void
_application_main_window_on_command_undo_application_command_stack_undone (ApplicationCommandStack* _sender,
                                                                           ApplicationCommand* command,
                                                                           gpointer self)
{
#line 1109 "../src/client/application/application-main-window.vala"
	application_main_window_on_command_undo ((ApplicationMainWindow*) self, command);
#line 6198 "application-main-window.c"
}

static void
_application_main_window_on_command_redo_application_command_stack_redone (ApplicationCommandStack* _sender,
                                                                           ApplicationCommand* command,
                                                                           gpointer self)
{
#line 1110 "../src/client/application/application-main-window.vala"
	application_main_window_on_command_redo ((ApplicationMainWindow*) self, command);
#line 6208 "application-main-window.c"
}

static void
application_main_window_add_account (ApplicationMainWindow* self,
                                     ApplicationAccountContext* to_add)
{
	GeeSet* _tmp0_;
#line 1092 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1092 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_ACCOUNT_CONTEXT (to_add));
#line 1093 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->accounts;
#line 1093 "../src/client/application/application-main-window.vala"
	if (!gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), to_add)) {
#line 6224 "application-main-window.c"
		FolderListTree* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAggregateProgressMonitor* _tmp4_;
		GearyAccount* _tmp5_;
		GearyAccount* _tmp6_;
		GearyProgressMonitor* _tmp7_;
		GearyProgressMonitor* _tmp8_;
		GearySmtpClientService* smtp = NULL;
		GearyAccount* _tmp9_;
		GearyAccount* _tmp10_;
		GearyClientService* _tmp11_;
		GearyClientService* _tmp12_;
		GearySmtpClientService* _tmp13_;
		GearySmtpClientService* _tmp14_;
		ApplicationCommandStack* _tmp19_;
		ApplicationCommandStack* _tmp20_;
		ApplicationCommandStack* _tmp21_;
		ApplicationCommandStack* _tmp22_;
		ApplicationCommandStack* _tmp23_;
		ApplicationCommandStack* _tmp24_;
		GeeTreeSet* added = NULL;
		GeeTreeSet* _tmp25_;
		GeeTreeSet* _tmp26_;
		GeeCollection* _tmp27_;
		GeeCollection* _tmp28_;
		GeeTreeSet* _tmp29_;
		GeeSet* _tmp30_;
#line 1094 "../src/client/application/application-main-window.vala"
		_tmp1_ = self->priv->_folder_list;
#line 1094 "../src/client/application/application-main-window.vala"
		_tmp2_ = application_account_context_get_account (to_add);
#line 1094 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 1094 "../src/client/application/application-main-window.vala"
		folder_list_tree_set_user_folders_root_name (_tmp1_, _tmp3_, _ ("Labels"));
#line 1098 "../src/client/application/application-main-window.vala"
		_tmp4_ = self->priv->progress_monitor;
#line 1098 "../src/client/application/application-main-window.vala"
		_tmp5_ = application_account_context_get_account (to_add);
#line 1098 "../src/client/application/application-main-window.vala"
		_tmp6_ = _tmp5_;
#line 1098 "../src/client/application/application-main-window.vala"
		_tmp7_ = geary_account_get_background_progress (_tmp6_);
#line 1098 "../src/client/application/application-main-window.vala"
		_tmp8_ = _tmp7_;
#line 1098 "../src/client/application/application-main-window.vala"
		geary_aggregate_progress_monitor_add (_tmp4_, _tmp8_);
#line 1099 "../src/client/application/application-main-window.vala"
		_tmp9_ = application_account_context_get_account (to_add);
#line 1099 "../src/client/application/application-main-window.vala"
		_tmp10_ = _tmp9_;
#line 1099 "../src/client/application/application-main-window.vala"
		_tmp11_ = geary_account_get_outgoing (_tmp10_);
#line 1099 "../src/client/application/application-main-window.vala"
		_tmp12_ = _tmp11_;
#line 1099 "../src/client/application/application-main-window.vala"
		_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, GEARY_SMTP_TYPE_CLIENT_SERVICE) ? ((GearySmtpClientService*) _tmp12_) : NULL);
#line 1099 "../src/client/application/application-main-window.vala"
		smtp = _tmp13_;
#line 1102 "../src/client/application/application-main-window.vala"
		_tmp14_ = smtp;
#line 1102 "../src/client/application/application-main-window.vala"
		if (_tmp14_ != NULL) {
#line 6289 "application-main-window.c"
			GearyAggregateProgressMonitor* _tmp15_;
			GearySmtpClientService* _tmp16_;
			GearyProgressMonitor* _tmp17_;
			GearyProgressMonitor* _tmp18_;
#line 1103 "../src/client/application/application-main-window.vala"
			_tmp15_ = self->priv->progress_monitor;
#line 1103 "../src/client/application/application-main-window.vala"
			_tmp16_ = smtp;
#line 1103 "../src/client/application/application-main-window.vala"
			_tmp17_ = geary_smtp_client_service_get_sending_monitor (_tmp16_);
#line 1103 "../src/client/application/application-main-window.vala"
			_tmp18_ = _tmp17_;
#line 1103 "../src/client/application/application-main-window.vala"
			geary_aggregate_progress_monitor_add (_tmp15_, _tmp18_);
#line 6304 "application-main-window.c"
		}
#line 1106 "../src/client/application/application-main-window.vala"
		g_signal_connect_object (to_add, "folders-available", (GCallback) _application_main_window_on_folders_available_application_account_context_folders_available, self, 0);
#line 1107 "../src/client/application/application-main-window.vala"
		g_signal_connect_object (to_add, "folders-unavailable", (GCallback) _application_main_window_on_folders_unavailable_application_account_context_folders_unavailable, self, 0);
#line 1108 "../src/client/application/application-main-window.vala"
		_tmp19_ = application_account_context_get_commands (to_add);
#line 1108 "../src/client/application/application-main-window.vala"
		_tmp20_ = _tmp19_;
#line 1108 "../src/client/application/application-main-window.vala"
		g_signal_connect_object (_tmp20_, "executed", (GCallback) _application_main_window_on_command_execute_application_command_stack_executed, self, 0);
#line 1109 "../src/client/application/application-main-window.vala"
		_tmp21_ = application_account_context_get_commands (to_add);
#line 1109 "../src/client/application/application-main-window.vala"
		_tmp22_ = _tmp21_;
#line 1109 "../src/client/application/application-main-window.vala"
		g_signal_connect_object (_tmp22_, "undone", (GCallback) _application_main_window_on_command_undo_application_command_stack_undone, self, 0);
#line 1110 "../src/client/application/application-main-window.vala"
		_tmp23_ = application_account_context_get_commands (to_add);
#line 1110 "../src/client/application/application-main-window.vala"
		_tmp24_ = _tmp23_;
#line 1110 "../src/client/application/application-main-window.vala"
		g_signal_connect_object (_tmp24_, "redone", (GCallback) _application_main_window_on_command_redo_application_command_stack_redone, self, 0);
#line 1114 "../src/client/application/application-main-window.vala"
		_tmp25_ = gee_tree_set_new (APPLICATION_TYPE_FOLDER_CONTEXT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1114 "../src/client/application/application-main-window.vala"
		added = _tmp25_;
#line 1115 "../src/client/application/application-main-window.vala"
		_tmp26_ = added;
#line 1115 "../src/client/application/application-main-window.vala"
		_tmp27_ = application_account_context_get_folders (to_add);
#line 1115 "../src/client/application/application-main-window.vala"
		_tmp28_ = _tmp27_;
#line 1115 "../src/client/application/application-main-window.vala"
		gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_COLLECTION, GeeCollection), _tmp28_);
#line 1115 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp28_);
#line 1117 "../src/client/application/application-main-window.vala"
		_tmp29_ = added;
#line 1117 "../src/client/application/application-main-window.vala"
		application_main_window_add_folders (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1118 "../src/client/application/application-main-window.vala"
		_tmp30_ = self->priv->accounts;
#line 1118 "../src/client/application/application-main-window.vala"
		gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GEE_TYPE_COLLECTION, GeeCollection), to_add);
#line 1093 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (added);
#line 1093 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (smtp);
#line 6354 "application-main-window.c"
	}
}

static void
application_main_window_remove_account_data_free (gpointer _data)
{
	ApplicationMainWindowRemoveAccountData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_remove);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_select);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/application-main-window.vala"
	g_slice_free (ApplicationMainWindowRemoveAccountData, _data_);
#line 6371 "application-main-window.c"
}

static void
application_main_window_remove_account (ApplicationMainWindow* self,
                                        ApplicationAccountContext* to_remove,
                                        GearyFolder* to_select,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	ApplicationMainWindowRemoveAccountData* _data_;
	ApplicationMainWindow* _tmp0_;
	ApplicationAccountContext* _tmp1_;
	GearyFolder* _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_ACCOUNT_CONTEXT (to_remove));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((to_select == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (to_select, GEARY_TYPE_FOLDER));
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_slice_new0 (ApplicationMainWindowRemoveAccountData);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 10 "../src/client/application/application-main-window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_main_window_remove_account_data_free);
#line 10 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (to_remove);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_remove);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->to_remove = _tmp1_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp2_ = _g_object_ref0 (to_select);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_select);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->to_select = _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_remove_account_co (_data_);
#line 6415 "application-main-window.c"
}

static void
application_main_window_remove_account_finish (ApplicationMainWindow* self,
                                               GAsyncResult* _res_)
{
	ApplicationMainWindowRemoveAccountData* _data_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 6425 "application-main-window.c"
}

/**
     * Removes the given account from the main window.
     *
     * If `to_select` is not null, the given folder will be selected,
     * otherwise no folder will be.
     */
static void
application_main_window_remove_account_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_)
{
	ApplicationMainWindowRemoveAccountData* _data_;
#line 1141 "../src/client/application/application-main-window.vala"
	_data_ = _user_data_;
#line 1141 "../src/client/application/application-main-window.vala"
	_data_->_source_object_ = source_object;
#line 1141 "../src/client/application/application-main-window.vala"
	_data_->_res_ = _res_;
#line 1141 "../src/client/application/application-main-window.vala"
	application_main_window_remove_account_co (_data_);
#line 6448 "application-main-window.c"
}

static void
_application_main_window_on_folders_unavailable_application_account_context_folders_available (ApplicationAccountContext* _sender,
                                                                                               GeeCollection* available,
                                                                                               gpointer self)
{
#line 1153 "../src/client/application/application-main-window.vala"
	application_main_window_on_folders_unavailable ((ApplicationMainWindow*) self, available);
#line 6458 "application-main-window.c"
}

static gboolean
application_main_window_remove_account_co (ApplicationMainWindowRemoveAccountData* _data_)
{
#line 1128 "../src/client/application/application-main-window.vala"
	switch (_data_->_state_) {
#line 1128 "../src/client/application/application-main-window.vala"
		case 0:
#line 6468 "application-main-window.c"
		goto _state_0;
#line 1128 "../src/client/application/application-main-window.vala"
		case 1:
#line 6472 "application-main-window.c"
		goto _state_1;
		default:
#line 1128 "../src/client/application/application-main-window.vala"
		g_assert_not_reached ();
#line 6477 "application-main-window.c"
	}
	_state_0:
#line 1130 "../src/client/application/application-main-window.vala"
	_data_->_tmp0_ = _data_->self->priv->accounts;
#line 1130 "../src/client/application/application-main-window.vala"
	if (gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), _data_->to_remove)) {
#line 1135 "../src/client/application/application-main-window.vala"
		_data_->_tmp2_ = _data_->self->priv->_selected_folder;
#line 1135 "../src/client/application/application-main-window.vala"
		if (_data_->_tmp2_ != NULL) {
#line 1136 "../src/client/application/application-main-window.vala"
			_data_->_tmp3_ = _data_->self->priv->_selected_folder;
#line 1136 "../src/client/application/application-main-window.vala"
			_data_->_tmp4_ = geary_folder_get_account (_data_->_tmp3_);
#line 1136 "../src/client/application/application-main-window.vala"
			_data_->_tmp5_ = _data_->_tmp4_;
#line 1136 "../src/client/application/application-main-window.vala"
			_data_->_tmp6_ = application_account_context_get_account (_data_->to_remove);
#line 1136 "../src/client/application/application-main-window.vala"
			_data_->_tmp7_ = _data_->_tmp6_;
#line 1136 "../src/client/application/application-main-window.vala"
			_data_->_tmp1_ = _data_->_tmp5_ == _data_->_tmp7_;
#line 6500 "application-main-window.c"
		} else {
#line 1135 "../src/client/application/application-main-window.vala"
			_data_->_tmp1_ = FALSE;
#line 6504 "application-main-window.c"
		}
#line 1135 "../src/client/application/application-main-window.vala"
		if (_data_->_tmp1_) {
#line 1137 "../src/client/application/application-main-window.vala"
			_data_->_tmp8_ = _data_->self->priv->_selected_folder;
#line 1137 "../src/client/application/application-main-window.vala"
			_data_->_tmp9_ = geary_folder_get_used_as (_data_->_tmp8_);
#line 1137 "../src/client/application/application-main-window.vala"
			_data_->_tmp10_ = _data_->_tmp9_;
#line 1137 "../src/client/application/application-main-window.vala"
			_data_->is_account_search_active = _data_->_tmp10_ == GEARY_FOLDER_SPECIAL_USE_SEARCH;
#line 1141 "../src/client/application/application-main-window.vala"
			_data_->_state_ = 1;
#line 1141 "../src/client/application/application-main-window.vala"
			application_main_window_select_folder (_data_->self, _data_->to_select, FALSE, FALSE, application_main_window_remove_account_ready, _data_);
#line 1141 "../src/client/application/application-main-window.vala"
			return FALSE;
#line 6522 "application-main-window.c"
			_state_1:
#line 1141 "../src/client/application/application-main-window.vala"
			application_main_window_select_folder_finish (_data_->self, _data_->_res_);
#line 1143 "../src/client/application/application-main-window.vala"
			if (_data_->is_account_search_active) {
#line 1144 "../src/client/application/application-main-window.vala"
				_data_->_tmp11_ = _data_->self->priv->_search_bar;
#line 1144 "../src/client/application/application-main-window.vala"
				_data_->_tmp12_ = search_bar_get_entry (_data_->_tmp11_);
#line 1144 "../src/client/application/application-main-window.vala"
				_data_->_tmp13_ = _data_->_tmp12_;
#line 1144 "../src/client/application/application-main-window.vala"
				gtk_entry_set_text (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp13_, gtk_entry_get_type (), GtkEntry), "");
#line 1145 "../src/client/application/application-main-window.vala"
				_data_->_tmp14_ = _data_->self->priv->_search_bar;
#line 1145 "../src/client/application/application-main-window.vala"
				g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp14_, hdy_search_bar_get_type (), HdySearchBar), "search-mode-enabled", FALSE, NULL);
#line 6540 "application-main-window.c"
			}
		}
#line 1149 "../src/client/application/application-main-window.vala"
		_data_->_tmp15_ = application_account_context_get_commands (_data_->to_remove);
#line 1149 "../src/client/application/application-main-window.vala"
		_data_->_tmp16_ = _data_->_tmp15_;
#line 1149 "../src/client/application/application-main-window.vala"
		g_signal_parse_name ("executed", APPLICATION_TYPE_COMMAND_STACK, &_data_->_tmp17_, NULL, FALSE);
#line 1149 "../src/client/application/application-main-window.vala"
		g_signal_handlers_disconnect_matched (_data_->_tmp16_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _data_->_tmp17_, 0, NULL, (GCallback) _application_main_window_on_command_execute_application_command_stack_executed, _data_->self);
#line 1150 "../src/client/application/application-main-window.vala"
		_data_->_tmp18_ = application_account_context_get_commands (_data_->to_remove);
#line 1150 "../src/client/application/application-main-window.vala"
		_data_->_tmp19_ = _data_->_tmp18_;
#line 1150 "../src/client/application/application-main-window.vala"
		g_signal_parse_name ("undone", APPLICATION_TYPE_COMMAND_STACK, &_data_->_tmp20_, NULL, FALSE);
#line 1150 "../src/client/application/application-main-window.vala"
		g_signal_handlers_disconnect_matched (_data_->_tmp19_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _data_->_tmp20_, 0, NULL, (GCallback) _application_main_window_on_command_undo_application_command_stack_undone, _data_->self);
#line 1151 "../src/client/application/application-main-window.vala"
		_data_->_tmp21_ = application_account_context_get_commands (_data_->to_remove);
#line 1151 "../src/client/application/application-main-window.vala"
		_data_->_tmp22_ = _data_->_tmp21_;
#line 1151 "../src/client/application/application-main-window.vala"
		g_signal_parse_name ("redone", APPLICATION_TYPE_COMMAND_STACK, &_data_->_tmp23_, NULL, FALSE);
#line 1151 "../src/client/application/application-main-window.vala"
		g_signal_handlers_disconnect_matched (_data_->_tmp22_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _data_->_tmp23_, 0, NULL, (GCallback) _application_main_window_on_command_redo_application_command_stack_redone, _data_->self);
#line 1152 "../src/client/application/application-main-window.vala"
		g_signal_parse_name ("folders-available", APPLICATION_TYPE_ACCOUNT_CONTEXT, &_data_->_tmp24_, NULL, FALSE);
#line 1152 "../src/client/application/application-main-window.vala"
		g_signal_handlers_disconnect_matched (_data_->to_remove, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _data_->_tmp24_, 0, NULL, (GCallback) _application_main_window_on_folders_available_application_account_context_folders_available, _data_->self);
#line 1153 "../src/client/application/application-main-window.vala"
		g_signal_parse_name ("folders-available", APPLICATION_TYPE_ACCOUNT_CONTEXT, &_data_->_tmp25_, NULL, FALSE);
#line 1153 "../src/client/application/application-main-window.vala"
		g_signal_handlers_disconnect_matched (_data_->to_remove, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _data_->_tmp25_, 0, NULL, (GCallback) _application_main_window_on_folders_unavailable_application_account_context_folders_available, _data_->self);
#line 1155 "../src/client/application/application-main-window.vala"
		_data_->_tmp26_ = _data_->self->priv->progress_monitor;
#line 1155 "../src/client/application/application-main-window.vala"
		_data_->_tmp27_ = application_account_context_get_account (_data_->to_remove);
#line 1155 "../src/client/application/application-main-window.vala"
		_data_->_tmp28_ = _data_->_tmp27_;
#line 1155 "../src/client/application/application-main-window.vala"
		_data_->_tmp29_ = geary_account_get_background_progress (_data_->_tmp28_);
#line 1155 "../src/client/application/application-main-window.vala"
		_data_->_tmp30_ = _data_->_tmp29_;
#line 1155 "../src/client/application/application-main-window.vala"
		geary_aggregate_progress_monitor_remove (_data_->_tmp26_, _data_->_tmp30_);
#line 1156 "../src/client/application/application-main-window.vala"
		_data_->_tmp31_ = application_account_context_get_account (_data_->to_remove);
#line 1156 "../src/client/application/application-main-window.vala"
		_data_->_tmp32_ = _data_->_tmp31_;
#line 1156 "../src/client/application/application-main-window.vala"
		_data_->_tmp33_ = geary_account_get_outgoing (_data_->_tmp32_);
#line 1156 "../src/client/application/application-main-window.vala"
		_data_->_tmp34_ = _data_->_tmp33_;
#line 1156 "../src/client/application/application-main-window.vala"
		_data_->_tmp35_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp34_, GEARY_SMTP_TYPE_CLIENT_SERVICE) ? ((GearySmtpClientService*) _data_->_tmp34_) : NULL);
#line 1156 "../src/client/application/application-main-window.vala"
		_data_->smtp = _data_->_tmp35_;
#line 1159 "../src/client/application/application-main-window.vala"
		_data_->_tmp36_ = _data_->smtp;
#line 1159 "../src/client/application/application-main-window.vala"
		if (_data_->_tmp36_ != NULL) {
#line 1160 "../src/client/application/application-main-window.vala"
			_data_->_tmp37_ = _data_->self->priv->progress_monitor;
#line 1160 "../src/client/application/application-main-window.vala"
			_data_->_tmp38_ = _data_->smtp;
#line 1160 "../src/client/application/application-main-window.vala"
			_data_->_tmp39_ = geary_smtp_client_service_get_sending_monitor (_data_->_tmp38_);
#line 1160 "../src/client/application/application-main-window.vala"
			_data_->_tmp40_ = _data_->_tmp39_;
#line 1160 "../src/client/application/application-main-window.vala"
			geary_aggregate_progress_monitor_remove (_data_->_tmp37_, _data_->_tmp40_);
#line 6613 "application-main-window.c"
		}
#line 1164 "../src/client/application/application-main-window.vala"
		_data_->_tmp41_ = application_account_context_get_folders (_data_->to_remove);
#line 1164 "../src/client/application/application-main-window.vala"
		_data_->_tmp42_ = _data_->_tmp41_;
#line 1164 "../src/client/application/application-main-window.vala"
		application_main_window_remove_folders (_data_->self, _data_->_tmp42_, FALSE);
#line 1164 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data_->_tmp42_);
#line 1165 "../src/client/application/application-main-window.vala"
		_data_->_tmp43_ = _data_->self->priv->_folder_list;
#line 1165 "../src/client/application/application-main-window.vala"
		_data_->_tmp44_ = application_account_context_get_account (_data_->to_remove);
#line 1165 "../src/client/application/application-main-window.vala"
		_data_->_tmp45_ = _data_->_tmp44_;
#line 1165 "../src/client/application/application-main-window.vala"
		folder_list_tree_remove_account (_data_->_tmp43_, _data_->_tmp45_);
#line 1166 "../src/client/application/application-main-window.vala"
		_data_->_tmp46_ = _data_->self->priv->accounts;
#line 1166 "../src/client/application/application-main-window.vala"
		gee_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp46_, GEE_TYPE_COLLECTION, GeeCollection), _data_->to_remove);
#line 1130 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data_->smtp);
#line 6637 "application-main-window.c"
	}
#line 1128 "../src/client/application/application-main-window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1128 "../src/client/application/application-main-window.vala"
	if (_data_->_state_ != 0) {
#line 1128 "../src/client/application/application-main-window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1128 "../src/client/application/application-main-window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 6647 "application-main-window.c"
		}
	}
#line 1128 "../src/client/application/application-main-window.vala"
	g_object_unref (_data_->_async_result);
#line 1128 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 6654 "application-main-window.c"
}

/** Adds a folder to the window. */
static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 6678 "application-main-window.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 6687 "application-main-window.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 6706 "application-main-window.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 6710 "application-main-window.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 6716 "application-main-window.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 6726 "application-main-window.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 6734 "application-main-window.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 6738 "application-main-window.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 6744 "application-main-window.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 6754 "application-main-window.c"
}

static void
_application_main_window_on_use_changed_geary_folder_use_changed (GearyFolder* _sender,
                                                                  GearyFolderSpecialUse old_use,
                                                                  GearyFolderSpecialUse new_use,
                                                                  gpointer self)
{
#line 1186 "../src/client/application/application-main-window.vala"
	application_main_window_on_use_changed ((ApplicationMainWindow*) self, _sender, old_use, new_use);
#line 6765 "application-main-window.c"
}

static void
application_main_window_add_folders (ApplicationMainWindow* self,
                                     GeeCollection* to_add)
{
	GeeHashMap* map = NULL;
	GeeHashMap* _tmp0_;
#line 1171 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1171 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (to_add, GEE_TYPE_COLLECTION));
#line 1174 "../src/client/application/application-main-window.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1174 "../src/client/application/application-main-window.vala"
	map = _tmp0_;
#line 6782 "application-main-window.c"
	{
		GeeIterator* _context_it = NULL;
		GeeIterator* _tmp1_;
#line 1175 "../src/client/application/application-main-window.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (to_add, GEE_TYPE_ITERABLE, GeeIterable));
#line 1175 "../src/client/application/application-main-window.vala"
		_context_it = _tmp1_;
#line 1175 "../src/client/application/application-main-window.vala"
		while (TRUE) {
#line 6792 "application-main-window.c"
			GeeIterator* _tmp2_;
			ApplicationFolderContext* context = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GearyFolder* folder = NULL;
			ApplicationFolderContext* _tmp5_;
			GearyFolder* _tmp6_;
			GearyFolder* _tmp7_;
			GearyFolder* _tmp8_;
			GearyFolder* _tmp9_;
			GearyFolderSpecialUse _tmp10_;
			GearyFolderSpecialUse _tmp11_;
			GeeHashMap* _tmp12_;
			GearyFolder* _tmp13_;
			GearyFolderPath* _tmp14_;
			GearyFolderPath* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			ApplicationFolderContext* _tmp20_;
			const gchar* _tmp21_;
			const gchar* _tmp22_;
#line 1175 "../src/client/application/application-main-window.vala"
			_tmp2_ = _context_it;
#line 1175 "../src/client/application/application-main-window.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 1175 "../src/client/application/application-main-window.vala"
				break;
#line 6822 "application-main-window.c"
			}
#line 1175 "../src/client/application/application-main-window.vala"
			_tmp3_ = _context_it;
#line 1175 "../src/client/application/application-main-window.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 1175 "../src/client/application/application-main-window.vala"
			context = (ApplicationFolderContext*) _tmp4_;
#line 1176 "../src/client/application/application-main-window.vala"
			_tmp5_ = context;
#line 1176 "../src/client/application/application-main-window.vala"
			_tmp6_ = application_folder_context_get_folder (_tmp5_);
#line 1176 "../src/client/application/application-main-window.vala"
			_tmp7_ = _tmp6_;
#line 1176 "../src/client/application/application-main-window.vala"
			_tmp8_ = _g_object_ref0 (_tmp7_);
#line 1176 "../src/client/application/application-main-window.vala"
			folder = _tmp8_;
#line 1177 "../src/client/application/application-main-window.vala"
			_tmp9_ = folder;
#line 1177 "../src/client/application/application-main-window.vala"
			_tmp10_ = geary_folder_get_used_as (_tmp9_);
#line 1177 "../src/client/application/application-main-window.vala"
			_tmp11_ = _tmp10_;
#line 1177 "../src/client/application/application-main-window.vala"
			if (_tmp11_ == GEARY_FOLDER_SPECIAL_USE_NONE) {
#line 1178 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (folder);
#line 1178 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (context);
#line 1178 "../src/client/application/application-main-window.vala"
				continue;
#line 6854 "application-main-window.c"
			}
#line 1179 "../src/client/application/application-main-window.vala"
			_tmp12_ = map;
#line 1179 "../src/client/application/application-main-window.vala"
			_tmp13_ = folder;
#line 1179 "../src/client/application/application-main-window.vala"
			_tmp14_ = geary_folder_get_path (_tmp13_);
#line 1179 "../src/client/application/application-main-window.vala"
			_tmp15_ = _tmp14_;
#line 1179 "../src/client/application/application-main-window.vala"
			_tmp16_ = geary_folder_path_to_string (_tmp15_);
#line 1179 "../src/client/application/application-main-window.vala"
			_tmp17_ = _tmp16_;
#line 1179 "../src/client/application/application-main-window.vala"
			_tmp18_ = string_substring (_tmp17_, (glong) 1, (glong) -1);
#line 1179 "../src/client/application/application-main-window.vala"
			_tmp19_ = _tmp18_;
#line 1179 "../src/client/application/application-main-window.vala"
			_tmp20_ = context;
#line 1179 "../src/client/application/application-main-window.vala"
			_tmp21_ = application_folder_context_get_display_name (_tmp20_);
#line 1179 "../src/client/application/application-main-window.vala"
			_tmp22_ = _tmp21_;
#line 1179 "../src/client/application/application-main-window.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp19_, _tmp22_);
#line 1179 "../src/client/application/application-main-window.vala"
			_g_free0 (_tmp19_);
#line 1179 "../src/client/application/application-main-window.vala"
			_g_free0 (_tmp17_);
#line 1175 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (folder);
#line 1175 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (context);
#line 6888 "application-main-window.c"
		}
#line 1175 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_context_it);
#line 6892 "application-main-window.c"
	}
	{
		GeeIterator* _context_it = NULL;
		GeeIterator* _tmp23_;
#line 1184 "../src/client/application/application-main-window.vala"
		_tmp23_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (to_add, GEE_TYPE_ITERABLE, GeeIterable));
#line 1184 "../src/client/application/application-main-window.vala"
		_context_it = _tmp23_;
#line 1184 "../src/client/application/application-main-window.vala"
		while (TRUE) {
#line 6903 "application-main-window.c"
			GeeIterator* _tmp24_;
			ApplicationFolderContext* context = NULL;
			GeeIterator* _tmp25_;
			gpointer _tmp26_;
			FolderListTree* _tmp27_;
			ApplicationFolderContext* _tmp28_;
			ApplicationFolderContext* _tmp29_;
			GearyFolder* _tmp30_;
			GearyFolder* _tmp31_;
#line 1184 "../src/client/application/application-main-window.vala"
			_tmp24_ = _context_it;
#line 1184 "../src/client/application/application-main-window.vala"
			if (!gee_iterator_next (_tmp24_)) {
#line 1184 "../src/client/application/application-main-window.vala"
				break;
#line 6919 "application-main-window.c"
			}
#line 1184 "../src/client/application/application-main-window.vala"
			_tmp25_ = _context_it;
#line 1184 "../src/client/application/application-main-window.vala"
			_tmp26_ = gee_iterator_get (_tmp25_);
#line 1184 "../src/client/application/application-main-window.vala"
			context = (ApplicationFolderContext*) _tmp26_;
#line 1185 "../src/client/application/application-main-window.vala"
			_tmp27_ = self->priv->_folder_list;
#line 1185 "../src/client/application/application-main-window.vala"
			_tmp28_ = context;
#line 1185 "../src/client/application/application-main-window.vala"
			folder_list_tree_add_folder (_tmp27_, _tmp28_);
#line 1186 "../src/client/application/application-main-window.vala"
			_tmp29_ = context;
#line 1186 "../src/client/application/application-main-window.vala"
			_tmp30_ = application_folder_context_get_folder (_tmp29_);
#line 1186 "../src/client/application/application-main-window.vala"
			_tmp31_ = _tmp30_;
#line 1186 "../src/client/application/application-main-window.vala"
			g_signal_connect_object (_tmp31_, "use-changed", (GCallback) _application_main_window_on_use_changed_geary_folder_use_changed, self, 0);
#line 1184 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (context);
#line 6943 "application-main-window.c"
		}
#line 1184 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_context_it);
#line 6947 "application-main-window.c"
	}
#line 1171 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (map);
#line 6951 "application-main-window.c"
}

/** Removes a folder from the window. */
static void
application_main_window_remove_folders (ApplicationMainWindow* self,
                                        GeeCollection* to_remove,
                                        gboolean update_selecton)
{
#line 1191 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1191 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (to_remove, GEE_TYPE_COLLECTION));
#line 6964 "application-main-window.c"
	{
		GeeIterator* _context_it = NULL;
		GeeIterator* _tmp0_;
#line 1193 "../src/client/application/application-main-window.vala"
		_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (to_remove, GEE_TYPE_ITERABLE, GeeIterable));
#line 1193 "../src/client/application/application-main-window.vala"
		_context_it = _tmp0_;
#line 1193 "../src/client/application/application-main-window.vala"
		while (TRUE) {
#line 6974 "application-main-window.c"
			GeeIterator* _tmp1_;
			ApplicationFolderContext* context = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			GearyFolder* folder = NULL;
			ApplicationFolderContext* _tmp4_;
			GearyFolder* _tmp5_;
			GearyFolder* _tmp6_;
			GearyFolder* _tmp7_;
			GearyFolder* _tmp8_;
			GearyFolder* _tmp9_;
			GearyFolder* _tmp14_;
			guint _tmp15_;
			FolderListTree* _tmp16_;
			ApplicationFolderContext* _tmp17_;
#line 1193 "../src/client/application/application-main-window.vala"
			_tmp1_ = _context_it;
#line 1193 "../src/client/application/application-main-window.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 1193 "../src/client/application/application-main-window.vala"
				break;
#line 6996 "application-main-window.c"
			}
#line 1193 "../src/client/application/application-main-window.vala"
			_tmp2_ = _context_it;
#line 1193 "../src/client/application/application-main-window.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 1193 "../src/client/application/application-main-window.vala"
			context = (ApplicationFolderContext*) _tmp3_;
#line 1194 "../src/client/application/application-main-window.vala"
			_tmp4_ = context;
#line 1194 "../src/client/application/application-main-window.vala"
			_tmp5_ = application_folder_context_get_folder (_tmp4_);
#line 1194 "../src/client/application/application-main-window.vala"
			_tmp6_ = _tmp5_;
#line 1194 "../src/client/application/application-main-window.vala"
			_tmp7_ = _g_object_ref0 (_tmp6_);
#line 1194 "../src/client/application/application-main-window.vala"
			folder = _tmp7_;
#line 1195 "../src/client/application/application-main-window.vala"
			_tmp8_ = self->priv->_selected_folder;
#line 1195 "../src/client/application/application-main-window.vala"
			_tmp9_ = folder;
#line 1195 "../src/client/application/application-main-window.vala"
			if (_tmp8_ == _tmp9_) {
#line 7020 "application-main-window.c"
				ApplicationAccountContext* account = NULL;
				ApplicationAccountContext* _tmp10_;
				ApplicationAccountContext* _tmp11_;
#line 1196 "../src/client/application/application-main-window.vala"
				_tmp10_ = application_main_window_get_selected_account_context (self);
#line 1196 "../src/client/application/application-main-window.vala"
				account = _tmp10_;
#line 1197 "../src/client/application/application-main-window.vala"
				_tmp11_ = account;
#line 1197 "../src/client/application/application-main-window.vala"
				if (_tmp11_ != NULL) {
#line 7032 "application-main-window.c"
					ApplicationAccountContext* _tmp12_;
					GearyFolder* _tmp13_;
#line 1198 "../src/client/application/application-main-window.vala"
					_tmp12_ = account;
#line 1198 "../src/client/application/application-main-window.vala"
					_tmp13_ = _tmp12_->inbox;
#line 1198 "../src/client/application/application-main-window.vala"
					application_main_window_select_folder (self, _tmp13_, TRUE, FALSE, NULL, NULL);
#line 7041 "application-main-window.c"
				}
#line 1195 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (account);
#line 7045 "application-main-window.c"
			}
#line 1202 "../src/client/application/application-main-window.vala"
			_tmp14_ = folder;
#line 1202 "../src/client/application/application-main-window.vala"
			g_signal_parse_name ("use-changed", GEARY_TYPE_FOLDER, &_tmp15_, NULL, FALSE);
#line 1202 "../src/client/application/application-main-window.vala"
			g_signal_handlers_disconnect_matched (_tmp14_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp15_, 0, NULL, (GCallback) _application_main_window_on_use_changed_geary_folder_use_changed, self);
#line 1203 "../src/client/application/application-main-window.vala"
			_tmp16_ = self->priv->_folder_list;
#line 1203 "../src/client/application/application-main-window.vala"
			_tmp17_ = context;
#line 1203 "../src/client/application/application-main-window.vala"
			folder_list_tree_remove_folder (_tmp16_, _tmp17_);
#line 1193 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (folder);
#line 1193 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (context);
#line 7063 "application-main-window.c"
		}
#line 1193 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_context_it);
#line 7067 "application-main-window.c"
	}
}

static ApplicationAccountContext*
application_main_window_get_selected_account_context (ApplicationMainWindow* self)
{
	ApplicationAccountContext* context = NULL;
	GearyAccount* _tmp0_;
	ApplicationAccountContext* result;
#line 1207 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 1208 "../src/client/application/application-main-window.vala"
	context = NULL;
#line 1209 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_account;
#line 1209 "../src/client/application/application-main-window.vala"
	if (_tmp0_ != NULL) {
#line 7085 "application-main-window.c"
		ApplicationController* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccountInformation* _tmp3_;
		GearyAccountInformation* _tmp4_;
		ApplicationAccountContext* _tmp5_;
#line 1210 "../src/client/application/application-main-window.vala"
		_tmp1_ = self->priv->controller;
#line 1210 "../src/client/application/application-main-window.vala"
		_tmp2_ = self->priv->_selected_account;
#line 1210 "../src/client/application/application-main-window.vala"
		_tmp3_ = geary_account_get_information (_tmp2_);
#line 1210 "../src/client/application/application-main-window.vala"
		_tmp4_ = _tmp3_;
#line 1210 "../src/client/application/application-main-window.vala"
		_tmp5_ = application_account_interface_get_context_for_account (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface), _tmp4_);
#line 1210 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (context);
#line 1210 "../src/client/application/application-main-window.vala"
		context = _tmp5_;
#line 7105 "application-main-window.c"
	}
#line 1214 "../src/client/application/application-main-window.vala"
	result = context;
#line 1214 "../src/client/application/application-main-window.vala"
	return result;
#line 7111 "application-main-window.c"
}

static GearyFolder*
application_main_window_get_first_inbox (ApplicationMainWindow* self)
{
	GearyFolder* inbox = NULL;
	GError* _inner_error0_ = NULL;
	GearyFolder* result;
#line 1217 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 1218 "../src/client/application/application-main-window.vala"
	inbox = NULL;
#line 7124 "application-main-window.c"
	{
		GeeCollection* _tmp0_ = NULL;
		ApplicationClient* _tmp1_;
		ApplicationClient* _tmp2_;
		GearyEngine* _tmp3_;
		GearyEngine* _tmp4_;
		GeeCollection* _tmp5_;
		GearyAccount* first = NULL;
		gpointer _tmp6_;
		GearyAccount* _tmp7_;
#line 1221 "../src/client/application/application-main-window.vala"
		_tmp1_ = application_main_window_get_application (self);
#line 1221 "../src/client/application/application-main-window.vala"
		_tmp2_ = _tmp1_;
#line 1221 "../src/client/application/application-main-window.vala"
		_tmp3_ = application_client_get_engine (_tmp2_);
#line 1221 "../src/client/application/application-main-window.vala"
		_tmp4_ = _tmp3_;
#line 1221 "../src/client/application/application-main-window.vala"
		_tmp5_ = geary_engine_get_accounts (_tmp4_, &_inner_error0_);
#line 1221 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp5_;
#line 1221 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7149 "application-main-window.c"
			goto __catch0_g_error;
		}
#line 1220 "../src/client/application/application-main-window.vala"
		_tmp6_ = geary_collection_first (GEARY_TYPE_ACCOUNT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp0_);
#line 1220 "../src/client/application/application-main-window.vala"
		first = (GearyAccount*) _tmp6_;
#line 1223 "../src/client/application/application-main-window.vala"
		_tmp7_ = first;
#line 1223 "../src/client/application/application-main-window.vala"
		if (_tmp7_ != NULL) {
#line 7160 "application-main-window.c"
			GearyAccount* _tmp8_;
			GearyFolder* _tmp9_;
#line 1224 "../src/client/application/application-main-window.vala"
			_tmp8_ = first;
#line 1224 "../src/client/application/application-main-window.vala"
			_tmp9_ = geary_account_get_special_folder (_tmp8_, GEARY_FOLDER_SPECIAL_USE_INBOX);
#line 1224 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (inbox);
#line 1224 "../src/client/application/application-main-window.vala"
			inbox = _tmp9_;
#line 7171 "application-main-window.c"
		}
#line 1219 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (first);
#line 1219 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp0_);
#line 7177 "application-main-window.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 1219 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 1227 "../src/client/application/application-main-window.vala"
		g_debug ("application-main-window.vala:1227: Error getting inbox for first accou" \
"nt");
#line 7186 "application-main-window.c"
	}
	__finally0:
#line 1219 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1219 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (inbox);
#line 1219 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1219 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 1219 "../src/client/application/application-main-window.vala"
		return NULL;
#line 7199 "application-main-window.c"
	}
#line 1229 "../src/client/application/application-main-window.vala"
	result = inbox;
#line 1229 "../src/client/application/application-main-window.vala"
	return result;
#line 7205 "application-main-window.c"
}

static void
application_main_window_load_config (ApplicationMainWindow* self,
                                     ApplicationConfiguration* config)
{
#line 1232 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1232 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (config));
#line 1236 "../src/client/application/application-main-window.vala"
	application_configuration_bind (config, APPLICATION_CONFIGURATION_WINDOW_WIDTH_KEY, G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "window-width", G_SETTINGS_BIND_DEFAULT);
#line 1237 "../src/client/application/application-main-window.vala"
	application_configuration_bind (config, APPLICATION_CONFIGURATION_WINDOW_HEIGHT_KEY, G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "window-height", G_SETTINGS_BIND_DEFAULT);
#line 1238 "../src/client/application/application-main-window.vala"
	application_configuration_bind (config, APPLICATION_CONFIGURATION_WINDOW_MAXIMIZE_KEY, G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "window-maximized", G_SETTINGS_BIND_DEFAULT);
#line 7222 "application-main-window.c"
}

static void
application_main_window_restore_saved_window_state (ApplicationMainWindow* self)
{
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkDisplay* _tmp2_;
	gboolean _tmp23_;
#line 1241 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1242 "../src/client/application/application-main-window.vala"
	_tmp0_ = gdk_display_get_default ();
#line 1242 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1242 "../src/client/application/application-main-window.vala"
	display = _tmp1_;
#line 1243 "../src/client/application/application-main-window.vala"
	_tmp2_ = display;
#line 1243 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 7245 "application-main-window.c"
		GdkMonitor* monitor = NULL;
		GdkDisplay* _tmp3_;
		GdkMonitor* _tmp4_;
		GdkMonitor* _tmp5_;
		GdkMonitor* _tmp6_;
		gboolean _tmp10_ = FALSE;
		gboolean _tmp11_ = FALSE;
		GdkMonitor* _tmp12_;
#line 1244 "../src/client/application/application-main-window.vala"
		_tmp3_ = display;
#line 1244 "../src/client/application/application-main-window.vala"
		_tmp4_ = gdk_display_get_primary_monitor (_tmp3_);
#line 1244 "../src/client/application/application-main-window.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 1244 "../src/client/application/application-main-window.vala"
		monitor = _tmp5_;
#line 1245 "../src/client/application/application-main-window.vala"
		_tmp6_ = monitor;
#line 1245 "../src/client/application/application-main-window.vala"
		if (_tmp6_ == NULL) {
#line 7266 "application-main-window.c"
			GdkDisplay* _tmp7_;
			GdkMonitor* _tmp8_;
			GdkMonitor* _tmp9_;
#line 1246 "../src/client/application/application-main-window.vala"
			_tmp7_ = display;
#line 1246 "../src/client/application/application-main-window.vala"
			_tmp8_ = gdk_display_get_monitor_at_point (_tmp7_, 1, 1);
#line 1246 "../src/client/application/application-main-window.vala"
			_tmp9_ = _g_object_ref0 (_tmp8_);
#line 1246 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (monitor);
#line 1246 "../src/client/application/application-main-window.vala"
			monitor = _tmp9_;
#line 7280 "application-main-window.c"
		}
#line 1248 "../src/client/application/application-main-window.vala"
		_tmp12_ = monitor;
#line 1248 "../src/client/application/application-main-window.vala"
		if (_tmp12_ != NULL) {
#line 7286 "application-main-window.c"
			gint _tmp13_;
			GdkMonitor* _tmp14_;
			GdkRectangle _tmp15_ = {0};
			GdkRectangle _tmp16_;
#line 1249 "../src/client/application/application-main-window.vala"
			_tmp13_ = self->priv->_window_width;
#line 1249 "../src/client/application/application-main-window.vala"
			_tmp14_ = monitor;
#line 1249 "../src/client/application/application-main-window.vala"
			gdk_monitor_get_geometry (_tmp14_, &_tmp15_);
#line 1249 "../src/client/application/application-main-window.vala"
			_tmp16_ = _tmp15_;
#line 1249 "../src/client/application/application-main-window.vala"
			_tmp11_ = _tmp13_ <= _tmp16_.width;
#line 7301 "application-main-window.c"
		} else {
#line 1248 "../src/client/application/application-main-window.vala"
			_tmp11_ = FALSE;
#line 7305 "application-main-window.c"
		}
#line 1248 "../src/client/application/application-main-window.vala"
		if (_tmp11_) {
#line 7309 "application-main-window.c"
			gint _tmp17_;
			GdkMonitor* _tmp18_;
			GdkRectangle _tmp19_ = {0};
			GdkRectangle _tmp20_;
#line 1250 "../src/client/application/application-main-window.vala"
			_tmp17_ = self->priv->_window_height;
#line 1250 "../src/client/application/application-main-window.vala"
			_tmp18_ = monitor;
#line 1250 "../src/client/application/application-main-window.vala"
			gdk_monitor_get_geometry (_tmp18_, &_tmp19_);
#line 1250 "../src/client/application/application-main-window.vala"
			_tmp20_ = _tmp19_;
#line 1250 "../src/client/application/application-main-window.vala"
			_tmp10_ = _tmp17_ <= _tmp20_.height;
#line 7324 "application-main-window.c"
		} else {
#line 1248 "../src/client/application/application-main-window.vala"
			_tmp10_ = FALSE;
#line 7328 "application-main-window.c"
		}
#line 1248 "../src/client/application/application-main-window.vala"
		if (_tmp10_) {
#line 7332 "application-main-window.c"
			gint _tmp21_;
			gint _tmp22_;
#line 1251 "../src/client/application/application-main-window.vala"
			_tmp21_ = self->priv->_window_width;
#line 1251 "../src/client/application/application-main-window.vala"
			_tmp22_ = self->priv->_window_height;
#line 1251 "../src/client/application/application-main-window.vala"
			gtk_window_set_default_size (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), _tmp21_, _tmp22_);
#line 7341 "application-main-window.c"
		}
#line 1243 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (monitor);
#line 7345 "application-main-window.c"
	}
#line 1254 "../src/client/application/application-main-window.vala"
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), "window-position", GTK_WIN_POS_CENTER, NULL);
#line 1255 "../src/client/application/application-main-window.vala"
	_tmp23_ = self->priv->_window_maximized;
#line 1255 "../src/client/application/application-main-window.vala"
	if (_tmp23_) {
#line 1256 "../src/client/application/application-main-window.vala"
		gtk_window_maximize (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
#line 7355 "application-main-window.c"
	}
#line 1241 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (display);
#line 7359 "application-main-window.c"
}

static gboolean
application_main_window_real_window_state_event (GtkWidget* base,
                                                 GdkEventWindowState* event)
{
	ApplicationMainWindow * self;
	gboolean result;
#line 1262 "../src/client/application/application-main-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_MAIN_WINDOW, ApplicationMainWindow);
#line 1262 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 1263 "../src/client/application/application-main-window.vala"
	if ((event->new_window_state & GDK_WINDOW_STATE_WITHDRAWN) == 0) {
#line 7374 "application-main-window.c"
		gboolean maximized = FALSE;
		gboolean _tmp0_;
#line 1264 "../src/client/application/application-main-window.vala"
		maximized = (event->new_window_state & GDK_WINDOW_STATE_MAXIMIZED) != 0;
#line 1267 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->_window_maximized;
#line 1267 "../src/client/application/application-main-window.vala"
		if (_tmp0_ != maximized) {
#line 1268 "../src/client/application/application-main-window.vala"
			application_main_window_set_window_maximized (self, maximized);
#line 7385 "application-main-window.c"
		}
	}
#line 1271 "../src/client/application/application-main-window.vala"
	result = GTK_WIDGET_CLASS (application_main_window_parent_class)->window_state_event (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), gtk_widget_get_type (), GtkWidget), event);
#line 1271 "../src/client/application/application-main-window.vala"
	return result;
#line 7392 "application-main-window.c"
}

static void
application_main_window_real_size_allocate (GtkWidget* base,
                                            GtkAllocation* allocation)
{
	ApplicationMainWindow * self;
	GtkAllocation _tmp0_;
	gboolean _tmp1_;
#line 1275 "../src/client/application/application-main-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_MAIN_WINDOW, ApplicationMainWindow);
#line 1275 "../src/client/application/application-main-window.vala"
	g_return_if_fail (allocation != NULL);
#line 1276 "../src/client/application/application-main-window.vala"
	_tmp0_ = *allocation;
#line 1276 "../src/client/application/application-main-window.vala"
	GTK_WIDGET_CLASS (application_main_window_parent_class)->size_allocate (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), gtk_widget_get_type (), GtkWidget), &_tmp0_);
#line 1278 "../src/client/application/application-main-window.vala"
	_tmp1_ = self->priv->_window_maximized;
#line 1278 "../src/client/application/application-main-window.vala"
	if (!_tmp1_) {
#line 7414 "application-main-window.c"
		GdkDisplay* display = NULL;
		GdkDisplay* _tmp2_;
		GdkDisplay* _tmp3_;
		GdkWindow* window = NULL;
		GdkWindow* _tmp4_;
		GdkWindow* _tmp5_;
		gboolean _tmp6_ = FALSE;
		GdkDisplay* _tmp7_;
#line 1279 "../src/client/application/application-main-window.vala"
		_tmp2_ = gtk_widget_get_display (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 1279 "../src/client/application/application-main-window.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 1279 "../src/client/application/application-main-window.vala"
		display = _tmp3_;
#line 1280 "../src/client/application/application-main-window.vala"
		_tmp4_ = gtk_widget_get_window (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 1280 "../src/client/application/application-main-window.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 1280 "../src/client/application/application-main-window.vala"
		window = _tmp5_;
#line 1281 "../src/client/application/application-main-window.vala"
		_tmp7_ = display;
#line 1281 "../src/client/application/application-main-window.vala"
		if (_tmp7_ != NULL) {
#line 7439 "application-main-window.c"
			GdkWindow* _tmp8_;
#line 1281 "../src/client/application/application-main-window.vala"
			_tmp8_ = window;
#line 1281 "../src/client/application/application-main-window.vala"
			_tmp6_ = _tmp8_ != NULL;
#line 7445 "application-main-window.c"
		} else {
#line 1281 "../src/client/application/application-main-window.vala"
			_tmp6_ = FALSE;
#line 7449 "application-main-window.c"
		}
#line 1281 "../src/client/application/application-main-window.vala"
		if (_tmp6_) {
#line 7453 "application-main-window.c"
			GdkMonitor* monitor = NULL;
			GdkDisplay* _tmp9_;
			GdkWindow* _tmp10_;
			GdkMonitor* _tmp11_;
			GdkMonitor* _tmp12_;
			gint width = 0;
			gint height = 0;
			gint _tmp13_ = 0;
			gint _tmp14_ = 0;
			gboolean _tmp15_ = FALSE;
			gboolean _tmp16_ = FALSE;
			gint _tmp17_;
			gboolean _tmp21_ = FALSE;
			gboolean _tmp22_ = FALSE;
			gint _tmp23_;
#line 1282 "../src/client/application/application-main-window.vala"
			_tmp9_ = display;
#line 1282 "../src/client/application/application-main-window.vala"
			_tmp10_ = window;
#line 1282 "../src/client/application/application-main-window.vala"
			_tmp11_ = gdk_display_get_monitor_at_window (_tmp9_, _tmp10_);
#line 1282 "../src/client/application/application-main-window.vala"
			_tmp12_ = _g_object_ref0 (_tmp11_);
#line 1282 "../src/client/application/application-main-window.vala"
			monitor = _tmp12_;
#line 1286 "../src/client/application/application-main-window.vala"
			width = 0;
#line 1287 "../src/client/application/application-main-window.vala"
			height = 0;
#line 1288 "../src/client/application/application-main-window.vala"
			gtk_window_get_size (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), &_tmp13_, &_tmp14_);
#line 1288 "../src/client/application/application-main-window.vala"
			width = _tmp13_;
#line 1288 "../src/client/application/application-main-window.vala"
			height = _tmp14_;
#line 1292 "../src/client/application/application-main-window.vala"
			_tmp17_ = self->priv->_window_width;
#line 1292 "../src/client/application/application-main-window.vala"
			if (_tmp17_ != width) {
#line 1293 "../src/client/application/application-main-window.vala"
				_tmp16_ = width > 0;
#line 7495 "application-main-window.c"
			} else {
#line 1292 "../src/client/application/application-main-window.vala"
				_tmp16_ = FALSE;
#line 7499 "application-main-window.c"
			}
#line 1292 "../src/client/application/application-main-window.vala"
			if (_tmp16_) {
#line 7503 "application-main-window.c"
				GdkMonitor* _tmp18_;
				GdkRectangle _tmp19_ = {0};
				GdkRectangle _tmp20_;
#line 1293 "../src/client/application/application-main-window.vala"
				_tmp18_ = monitor;
#line 1293 "../src/client/application/application-main-window.vala"
				gdk_monitor_get_geometry (_tmp18_, &_tmp19_);
#line 1293 "../src/client/application/application-main-window.vala"
				_tmp20_ = _tmp19_;
#line 1293 "../src/client/application/application-main-window.vala"
				_tmp15_ = width <= _tmp20_.width;
#line 7515 "application-main-window.c"
			} else {
#line 1292 "../src/client/application/application-main-window.vala"
				_tmp15_ = FALSE;
#line 7519 "application-main-window.c"
			}
#line 1292 "../src/client/application/application-main-window.vala"
			if (_tmp15_) {
#line 1294 "../src/client/application/application-main-window.vala"
				application_main_window_set_window_width (self, width);
#line 7525 "application-main-window.c"
			}
#line 1296 "../src/client/application/application-main-window.vala"
			_tmp23_ = self->priv->_window_height;
#line 1296 "../src/client/application/application-main-window.vala"
			if (_tmp23_ != height) {
#line 1297 "../src/client/application/application-main-window.vala"
				_tmp22_ = height > 0;
#line 7533 "application-main-window.c"
			} else {
#line 1296 "../src/client/application/application-main-window.vala"
				_tmp22_ = FALSE;
#line 7537 "application-main-window.c"
			}
#line 1296 "../src/client/application/application-main-window.vala"
			if (_tmp22_) {
#line 7541 "application-main-window.c"
				GdkMonitor* _tmp24_;
				GdkRectangle _tmp25_ = {0};
				GdkRectangle _tmp26_;
#line 1297 "../src/client/application/application-main-window.vala"
				_tmp24_ = monitor;
#line 1297 "../src/client/application/application-main-window.vala"
				gdk_monitor_get_geometry (_tmp24_, &_tmp25_);
#line 1297 "../src/client/application/application-main-window.vala"
				_tmp26_ = _tmp25_;
#line 1297 "../src/client/application/application-main-window.vala"
				_tmp21_ = height <= _tmp26_.height;
#line 7553 "application-main-window.c"
			} else {
#line 1296 "../src/client/application/application-main-window.vala"
				_tmp21_ = FALSE;
#line 7557 "application-main-window.c"
			}
#line 1296 "../src/client/application/application-main-window.vala"
			if (_tmp21_) {
#line 1298 "../src/client/application/application-main-window.vala"
				application_main_window_set_window_height (self, height);
#line 7563 "application-main-window.c"
			}
#line 1281 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (monitor);
#line 7567 "application-main-window.c"
		}
#line 1278 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (window);
#line 1278 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (display);
#line 7573 "application-main-window.c"
	}
}

void
application_main_window_add_notification (ApplicationMainWindow* self,
                                          ComponentsInAppNotification* notification)
{
	GtkOverlay* _tmp0_;
#line 1304 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1304 "../src/client/application/application-main-window.vala"
	g_return_if_fail (COMPONENTS_IS_IN_APP_NOTIFICATION (notification));
#line 1305 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->overlay;
#line 1305 "../src/client/application/application-main-window.vala"
	gtk_overlay_add_overlay (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (notification, gtk_widget_get_type (), GtkWidget));
#line 1306 "../src/client/application/application-main-window.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (notification, gtk_widget_get_type (), GtkWidget));
#line 7592 "application-main-window.c"
}

static void
_application_main_window_on_has_toplevel_focus_g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self)
{
#line 1310 "../src/client/application/application-main-window.vala"
	application_main_window_on_has_toplevel_focus ((ApplicationMainWindow*) self);
#line 7602 "application-main-window.c"
}

static void
_application_main_window_on_search_search_bar_search_text_changed (SearchBar* _sender,
                                                                   const gchar* search_text,
                                                                   gpointer self)
{
#line 1314 "../src/client/application/application-main-window.vala"
	application_main_window_on_search ((ApplicationMainWindow*) self, search_text);
#line 7612 "application-main-window.c"
}

static void
_application_main_window_on_folder_selected_folder_list_tree_folder_selected (FolderListTree* _sender,
                                                                              GearyFolder* folder,
                                                                              gpointer self)
{
#line 1319 "../src/client/application/application-main-window.vala"
	application_main_window_on_folder_selected ((ApplicationMainWindow*) self, folder);
#line 7622 "application-main-window.c"
}

static void
_application_main_window_on_move_conversation_folder_list_tree_move_conversation (FolderListTree* _sender,
                                                                                  GearyFolder* folder,
                                                                                  gpointer self)
{
#line 1320 "../src/client/application/application-main-window.vala"
	application_main_window_on_move_conversation ((ApplicationMainWindow*) self, folder);
#line 7632 "application-main-window.c"
}

static void
_application_main_window_on_copy_conversation_folder_list_tree_copy_conversation (FolderListTree* _sender,
                                                                                  GearyFolder* folder,
                                                                                  gpointer self)
{
#line 1321 "../src/client/application/application-main-window.vala"
	application_main_window_on_copy_conversation ((ApplicationMainWindow*) self, folder);
#line 7642 "application-main-window.c"
}

static void
_application_main_window_on_folder_activated_folder_list_tree_folder_activated (FolderListTree* _sender,
                                                                                GearyFolder* folder,
                                                                                gpointer self)
{
#line 1322 "../src/client/application/application-main-window.vala"
	application_main_window_on_folder_activated ((ApplicationMainWindow*) self, folder);
#line 7652 "application-main-window.c"
}

static void
_application_main_window_on_mark_conversations_conversation_list_view_mark_conversations (ConversationListView* _sender,
                                                                                          GeeCollection* conversations,
                                                                                          GearyNamedFlag* flag,
                                                                                          gpointer self)
{
#line 1331 "../src/client/application/application-main-window.vala"
	application_main_window_on_mark_conversations ((ApplicationMainWindow*) self, conversations, flag);
#line 7663 "application-main-window.c"
}

static void
_application_main_window_on_conversations_selected_conversation_list_view_conversations_selected (ConversationListView* _sender,
                                                                                                  GeeSet* selected,
                                                                                                  gpointer self)
{
#line 1332 "../src/client/application/application-main-window.vala"
	application_main_window_on_conversations_selected ((ApplicationMainWindow*) self, selected);
#line 7673 "application-main-window.c"
}

static void
_application_main_window_on_conversation_activated_conversation_list_view_conversation_activated (ConversationListView* _sender,
                                                                                                  GearyAppConversation* activated,
                                                                                                  guint button,
                                                                                                  gpointer self)
{
#line 1333 "../src/client/application/application-main-window.vala"
	application_main_window_on_conversation_activated ((ApplicationMainWindow*) self, activated, button);
#line 7684 "application-main-window.c"
}

static void
_application_main_window_on_visible_conversations_changed_g_object_notify (GObject* _sender,
                                                                           GParamSpec* pspec,
                                                                           gpointer self)
{
#line 1334 "../src/client/application/application-main-window.vala"
	application_main_window_on_visible_conversations_changed ((ApplicationMainWindow*) self);
#line 7694 "application-main-window.c"
}

static void
_application_main_window_on_conversation_view_added_conversation_viewer_conversation_added (ConversationViewer* _sender,
                                                                                            ConversationListBox* list,
                                                                                            gpointer self)
{
#line 1344 "../src/client/application/application-main-window.vala"
	application_main_window_on_conversation_view_added ((ApplicationMainWindow*) self, list);
#line 7704 "application-main-window.c"
}

static void
__lambda214_ (ApplicationMainWindow* self)
{
	ConversationListView* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 1368 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversation_list_view;
#line 1368 "../src/client/application/application-main-window.vala"
	_tmp1_ = conversation_list_view_get_selection_mode_enabled (_tmp0_);
#line 1368 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 1368 "../src/client/application/application-main-window.vala"
	if (_tmp2_) {
#line 7721 "application-main-window.c"
		GtkRevealer* _tmp3_;
		HdyLeaflet* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 1369 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->conversation_list_actions_revealer;
#line 1369 "../src/client/application/application-main-window.vala"
		_tmp4_ = self->priv->outer_leaflet;
#line 1369 "../src/client/application/application-main-window.vala"
		_tmp5_ = hdy_leaflet_get_folded (_tmp4_);
#line 1369 "../src/client/application/application-main-window.vala"
		_tmp6_ = _tmp5_;
#line 1369 "../src/client/application/application-main-window.vala"
		gtk_revealer_set_reveal_child (_tmp3_, _tmp6_);
#line 7736 "application-main-window.c"
	} else {
		GtkRevealer* _tmp7_;
#line 1372 "../src/client/application/application-main-window.vala"
		_tmp7_ = self->priv->conversation_list_actions_revealer;
#line 1372 "../src/client/application/application-main-window.vala"
		gtk_revealer_set_reveal_child (_tmp7_, FALSE);
#line 7743 "application-main-window.c"
	}
}

static void
___lambda214__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 1366 "../src/client/application/application-main-window.vala"
	__lambda214_ ((ApplicationMainWindow*) self);
#line 7754 "application-main-window.c"
}

static void
__lambda215_ (ApplicationMainWindow* self)
{
	GtkRevealer* _tmp0_;
	ComponentsConversationHeaderBar* _tmp1_;
	ComponentsConversationActions* _tmp2_;
	ComponentsConversationActions* _tmp3_;
	ComponentsConversationHeaderBar* _tmp4_;
	ComponentsConversationActions* _tmp5_;
#line 1377 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->conversation_viewer_actions_revealer;
#line 1377 "../src/client/application/application-main-window.vala"
	_tmp1_ = self->conversation_headerbar;
#line 1377 "../src/client/application/application-main-window.vala"
	_tmp2_ = components_conversation_header_bar_get_shown_actions (_tmp1_);
#line 1377 "../src/client/application/application-main-window.vala"
	_tmp3_ = _tmp2_;
#line 1377 "../src/client/application/application-main-window.vala"
	_tmp4_ = self->conversation_headerbar;
#line 1377 "../src/client/application/application-main-window.vala"
	_tmp5_ = _tmp4_->compact_actions;
#line 1377 "../src/client/application/application-main-window.vala"
	gtk_revealer_set_reveal_child (_tmp0_, _tmp3_ == _tmp5_);
#line 7780 "application-main-window.c"
}

static void
___lambda215__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 1375 "../src/client/application/application-main-window.vala"
	__lambda215_ ((ApplicationMainWindow*) self);
#line 7790 "application-main-window.c"
}

static void
_application_main_window_on_copy_conversation_folder_popover_copy_conversation (FolderPopover* _sender,
                                                                                GearyFolder* folder,
                                                                                gpointer self)
{
#line 1400 "../src/client/application/application-main-window.vala"
	application_main_window_on_copy_conversation ((ApplicationMainWindow*) self, folder);
#line 7800 "application-main-window.c"
}

static void
_application_main_window_on_move_conversation_folder_popover_move_conversation (FolderPopover* _sender,
                                                                                GearyFolder* folder,
                                                                                gpointer self)
{
#line 1401 "../src/client/application/application-main-window.vala"
	application_main_window_on_move_conversation ((ApplicationMainWindow*) self, folder);
#line 7810 "application-main-window.c"
}

static void
application_main_window_setup_layout (ApplicationMainWindow* self,
                                      ApplicationConfiguration* config)
{
	ApplicationClient* _tmp0_;
	ApplicationClient* _tmp1_;
	GearyEngine* _tmp2_;
	GearyEngine* _tmp3_;
	SearchBar* _tmp4_;
	SearchBar* _tmp5_;
	SearchBar* _tmp6_;
	GtkBox* _tmp7_;
	SearchBar* _tmp8_;
	FolderListTree* _tmp9_;
	FolderListTree* _tmp10_;
	FolderListTree* _tmp11_;
	FolderListTree* _tmp12_;
	GtkScrolledWindow* _tmp13_;
	FolderListTree* _tmp14_;
	GtkBox* _tmp15_;
	ComponentsInfoBarStack* _tmp16_;
	ApplicationClient* _tmp17_;
	ApplicationClient* _tmp18_;
	ApplicationConfiguration* _tmp19_;
	ApplicationConfiguration* _tmp20_;
	ConversationListView* _tmp21_;
	ConversationListView* _tmp22_;
	ConversationListView* _tmp23_;
	ConversationListView* _tmp24_;
	ConversationListView* _tmp25_;
	ConversationListView* _tmp26_;
	GeeSet* _tmp27_;
	GeeSet* _tmp28_;
	GtkBox* _tmp29_;
	ConversationListView* _tmp30_;
	ApplicationClient* _tmp31_;
	ApplicationClient* _tmp32_;
	ApplicationConfiguration* _tmp33_;
	ApplicationConfiguration* _tmp34_;
	ConversationViewer* _tmp35_;
	ConversationViewer* _tmp36_;
	ConversationViewer* _tmp37_;
	ConversationViewer* _tmp38_;
	GtkBox* _tmp39_;
	ConversationViewer* _tmp40_;
	ComponentsConversationListHeaderBar* _tmp41_;
	SearchBar* _tmp42_;
	ComponentsConversationListHeaderBar* _tmp43_;
	ConversationListView* _tmp44_;
	ComponentsConversationHeaderBar* _tmp45_;
	ConversationViewer* _tmp46_;
	GtkSearchBar* _tmp47_;
	ComponentsConversationListHeaderBar* _tmp48_;
	ComponentsConversationHeaderBar* _tmp49_;
	ComponentsApplicationHeaderBar* _tmp50_;
	MonitoredSpinner* _tmp51_;
	GearyAggregateProgressMonitor* _tmp52_;
	ComponentsConversationActions* _tmp53_;
	ComponentsConversationHeaderBar* _tmp54_;
	ComponentsConversationActions* _tmp55_;
	ApplicationClient* _tmp56_;
	ApplicationClient* _tmp57_;
	ApplicationConfiguration* _tmp58_;
	ApplicationConfiguration* _tmp59_;
	ComponentsConversationActions* _tmp60_;
	ApplicationClient* _tmp61_;
	ApplicationClient* _tmp62_;
	ApplicationConfiguration* _tmp63_;
	ApplicationConfiguration* _tmp64_;
	ComponentsConversationActions* _tmp65_;
	ApplicationClient* _tmp66_;
	ApplicationClient* _tmp67_;
	ApplicationConfiguration* _tmp68_;
	ApplicationConfiguration* _tmp69_;
	ComponentsConversationHeaderBar* _tmp70_;
	ComponentsConversationActions* _tmp71_;
	ComponentsConversationActions* _tmp72_;
	ComponentsConversationActions* _tmp73_;
	ComponentsConversationActions* _tmp74_;
	ComponentsConversationActions* _tmp75_;
	ComponentsConversationActions* _tmp76_;
	ComponentsConversationActions** _tmp77_;
	ComponentsConversationActions** _tmp78_;
	gint _tmp78__length1;
#line 1309 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1309 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (config));
#line 1310 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "notify::has-toplevel-focus", (GCallback) _application_main_window_on_has_toplevel_focus_g_object_notify, self, 0);
#line 1313 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_application (self);
#line 1313 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 1313 "../src/client/application/application-main-window.vala"
	_tmp2_ = application_client_get_engine (_tmp1_);
#line 1313 "../src/client/application/application-main-window.vala"
	_tmp3_ = _tmp2_;
#line 1313 "../src/client/application/application-main-window.vala"
	_tmp4_ = search_bar_new (_tmp3_);
#line 1313 "../src/client/application/application-main-window.vala"
	g_object_ref_sink (_tmp4_);
#line 1313 "../src/client/application/application-main-window.vala"
	_tmp5_ = _tmp4_;
#line 1313 "../src/client/application/application-main-window.vala"
	application_main_window_set_search_bar (self, _tmp5_);
#line 1313 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp5_);
#line 1314 "../src/client/application/application-main-window.vala"
	_tmp6_ = self->priv->_search_bar;
#line 1314 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp6_, "search-text-changed", (GCallback) _application_main_window_on_search_search_bar_search_text_changed, self, 0);
#line 1315 "../src/client/application/application-main-window.vala"
	_tmp7_ = self->priv->conversation_list_box;
#line 1315 "../src/client/application/application-main-window.vala"
	_tmp8_ = self->priv->_search_bar;
#line 1315 "../src/client/application/application-main-window.vala"
	gtk_box_pack_start (_tmp7_, G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget), FALSE, FALSE, (guint) 0);
#line 1319 "../src/client/application/application-main-window.vala"
	_tmp9_ = self->priv->_folder_list;
#line 1319 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp9_, "folder-selected", (GCallback) _application_main_window_on_folder_selected_folder_list_tree_folder_selected, self, 0);
#line 1320 "../src/client/application/application-main-window.vala"
	_tmp10_ = self->priv->_folder_list;
#line 1320 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp10_, "move-conversation", (GCallback) _application_main_window_on_move_conversation_folder_list_tree_move_conversation, self, 0);
#line 1321 "../src/client/application/application-main-window.vala"
	_tmp11_ = self->priv->_folder_list;
#line 1321 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp11_, "copy-conversation", (GCallback) _application_main_window_on_copy_conversation_folder_list_tree_copy_conversation, self, 0);
#line 1322 "../src/client/application/application-main-window.vala"
	_tmp12_ = self->priv->_folder_list;
#line 1322 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp12_, "folder-activated", (GCallback) _application_main_window_on_folder_activated_folder_list_tree_folder_activated, self, 0);
#line 1323 "../src/client/application/application-main-window.vala"
	_tmp13_ = self->priv->folder_list_scrolled;
#line 1323 "../src/client/application/application-main-window.vala"
	_tmp14_ = self->priv->_folder_list;
#line 1323 "../src/client/application/application-main-window.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_widget_get_type (), GtkWidget));
#line 1326 "../src/client/application/application-main-window.vala"
	_tmp15_ = self->priv->conversation_list_box;
#line 1326 "../src/client/application/application-main-window.vala"
	_tmp16_ = self->priv->_conversation_list_info_bars;
#line 1326 "../src/client/application/application-main-window.vala"
	gtk_box_pack_start (_tmp15_, G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_widget_get_type (), GtkWidget), FALSE, FALSE, (guint) 0);
#line 1330 "../src/client/application/application-main-window.vala"
	_tmp17_ = application_main_window_get_application (self);
#line 1330 "../src/client/application/application-main-window.vala"
	_tmp18_ = _tmp17_;
#line 1330 "../src/client/application/application-main-window.vala"
	_tmp19_ = application_client_get_config (_tmp18_);
#line 1330 "../src/client/application/application-main-window.vala"
	_tmp20_ = _tmp19_;
#line 1330 "../src/client/application/application-main-window.vala"
	_tmp21_ = conversation_list_view_new (_tmp20_);
#line 1330 "../src/client/application/application-main-window.vala"
	g_object_ref_sink (_tmp21_);
#line 1330 "../src/client/application/application-main-window.vala"
	_tmp22_ = _tmp21_;
#line 1330 "../src/client/application/application-main-window.vala"
	application_main_window_set_conversation_list_view (self, _tmp22_);
#line 1330 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp22_);
#line 1331 "../src/client/application/application-main-window.vala"
	_tmp23_ = self->priv->_conversation_list_view;
#line 1331 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp23_, "mark-conversations", (GCallback) _application_main_window_on_mark_conversations_conversation_list_view_mark_conversations, self, 0);
#line 1332 "../src/client/application/application-main-window.vala"
	_tmp24_ = self->priv->_conversation_list_view;
#line 1332 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp24_, "conversations-selected", (GCallback) _application_main_window_on_conversations_selected_conversation_list_view_conversations_selected, self, 0);
#line 1333 "../src/client/application/application-main-window.vala"
	_tmp25_ = self->priv->_conversation_list_view;
#line 1333 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp25_, "conversation-activated", (GCallback) _application_main_window_on_conversation_activated_conversation_list_view_conversation_activated, self, 0);
#line 1334 "../src/client/application/application-main-window.vala"
	_tmp26_ = self->priv->_conversation_list_view;
#line 1334 "../src/client/application/application-main-window.vala"
	_tmp27_ = conversation_list_view_get_visible_conversations (_tmp26_);
#line 1334 "../src/client/application/application-main-window.vala"
	_tmp28_ = _tmp27_;
#line 1334 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, G_TYPE_OBJECT, GObject), "notify", (GCallback) _application_main_window_on_visible_conversations_changed_g_object_notify, self, 0);
#line 1336 "../src/client/application/application-main-window.vala"
	_tmp29_ = self->priv->conversation_list_box;
#line 1336 "../src/client/application/application-main-window.vala"
	_tmp30_ = self->priv->_conversation_list_view;
#line 1336 "../src/client/application/application-main-window.vala"
	gtk_box_pack_start (_tmp29_, G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, gtk_widget_get_type (), GtkWidget), TRUE, TRUE, (guint) 0);
#line 1341 "../src/client/application/application-main-window.vala"
	_tmp31_ = application_main_window_get_application (self);
#line 1341 "../src/client/application/application-main-window.vala"
	_tmp32_ = _tmp31_;
#line 1341 "../src/client/application/application-main-window.vala"
	_tmp33_ = application_client_get_config (_tmp32_);
#line 1341 "../src/client/application/application-main-window.vala"
	_tmp34_ = _tmp33_;
#line 1341 "../src/client/application/application-main-window.vala"
	_tmp35_ = conversation_viewer_new (_tmp34_);
#line 1341 "../src/client/application/application-main-window.vala"
	g_object_ref_sink (_tmp35_);
#line 1341 "../src/client/application/application-main-window.vala"
	_tmp36_ = _tmp35_;
#line 1341 "../src/client/application/application-main-window.vala"
	application_main_window_set_conversation_viewer (self, _tmp36_);
#line 1341 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp36_);
#line 1344 "../src/client/application/application-main-window.vala"
	_tmp37_ = self->priv->_conversation_viewer;
#line 1344 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp37_, "conversation-added", (GCallback) _application_main_window_on_conversation_view_added_conversation_viewer_conversation_added, self, 0);
#line 1348 "../src/client/application/application-main-window.vala"
	_tmp38_ = self->priv->_conversation_viewer;
#line 1348 "../src/client/application/application-main-window.vala"
	gtk_widget_set_hexpand (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, gtk_widget_get_type (), GtkWidget), TRUE);
#line 1349 "../src/client/application/application-main-window.vala"
	_tmp39_ = self->priv->conversation_viewer_box;
#line 1349 "../src/client/application/application-main-window.vala"
	_tmp40_ = self->priv->_conversation_viewer;
#line 1349 "../src/client/application/application-main-window.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, gtk_widget_get_type (), GtkWidget));
#line 1351 "../src/client/application/application-main-window.vala"
	_tmp41_ = self->priv->conversation_list_headerbar;
#line 1351 "../src/client/application/application-main-window.vala"
	_tmp42_ = self->priv->_search_bar;
#line 1351 "../src/client/application/application-main-window.vala"
	g_object_bind_property_with_closures (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, G_TYPE_OBJECT, GObject), "search-open", G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, G_TYPE_OBJECT, GObject), "search-mode-enabled", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 1356 "../src/client/application/application-main-window.vala"
	_tmp43_ = self->priv->conversation_list_headerbar;
#line 1356 "../src/client/application/application-main-window.vala"
	_tmp44_ = self->priv->_conversation_list_view;
#line 1356 "../src/client/application/application-main-window.vala"
	g_object_bind_property_with_closures (G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, G_TYPE_OBJECT, GObject), "selection-open", G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, G_TYPE_OBJECT, GObject), "selection-mode-enabled", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 1361 "../src/client/application/application-main-window.vala"
	_tmp45_ = self->conversation_headerbar;
#line 1361 "../src/client/application/application-main-window.vala"
	_tmp46_ = self->priv->_conversation_viewer;
#line 1361 "../src/client/application/application-main-window.vala"
	_tmp47_ = _tmp46_->conversation_find_bar;
#line 1361 "../src/client/application/application-main-window.vala"
	g_object_bind_property_with_closures (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, G_TYPE_OBJECT, GObject), "find-open", G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, G_TYPE_OBJECT, GObject), "search-mode-enabled", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 1366 "../src/client/application/application-main-window.vala"
	_tmp48_ = self->priv->conversation_list_headerbar;
#line 1366 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, G_TYPE_OBJECT, GObject), "notify::selection-open", (GCallback) ___lambda214__g_object_notify, self, 0);
#line 1375 "../src/client/application/application-main-window.vala"
	_tmp49_ = self->conversation_headerbar;
#line 1375 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, G_TYPE_OBJECT, GObject), "notify::shown-actions", (GCallback) ___lambda215__g_object_notify, self, 0);
#line 1384 "../src/client/application/application-main-window.vala"
	_tmp50_ = self->priv->application_headerbar;
#line 1384 "../src/client/application/application-main-window.vala"
	_tmp51_ = _tmp50_->spinner;
#line 1384 "../src/client/application/application-main-window.vala"
	_tmp52_ = self->priv->progress_monitor;
#line 1384 "../src/client/application/application-main-window.vala"
	monitored_spinner_set_progress_monitor (_tmp51_, G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, GEARY_TYPE_PROGRESS_MONITOR, GearyProgressMonitor));
#line 1386 "../src/client/application/application-main-window.vala"
	_tmp53_ = self->priv->conversation_list_actions;
#line 1386 "../src/client/application/application-main-window.vala"
	components_conversation_actions_set_mark_inverted (_tmp53_);
#line 1388 "../src/client/application/application-main-window.vala"
	_tmp54_ = self->conversation_headerbar;
#line 1388 "../src/client/application/application-main-window.vala"
	_tmp55_ = _tmp54_->full_actions;
#line 1388 "../src/client/application/application-main-window.vala"
	_tmp56_ = application_main_window_get_application (self);
#line 1388 "../src/client/application/application-main-window.vala"
	_tmp57_ = _tmp56_;
#line 1388 "../src/client/application/application-main-window.vala"
	_tmp58_ = application_client_get_config (_tmp57_);
#line 1388 "../src/client/application/application-main-window.vala"
	_tmp59_ = _tmp58_;
#line 1388 "../src/client/application/application-main-window.vala"
	components_conversation_actions_init (_tmp55_, _tmp59_);
#line 1389 "../src/client/application/application-main-window.vala"
	_tmp60_ = self->priv->conversation_list_actions;
#line 1389 "../src/client/application/application-main-window.vala"
	_tmp61_ = application_main_window_get_application (self);
#line 1389 "../src/client/application/application-main-window.vala"
	_tmp62_ = _tmp61_;
#line 1389 "../src/client/application/application-main-window.vala"
	_tmp63_ = application_client_get_config (_tmp62_);
#line 1389 "../src/client/application/application-main-window.vala"
	_tmp64_ = _tmp63_;
#line 1389 "../src/client/application/application-main-window.vala"
	components_conversation_actions_init (_tmp60_, _tmp64_);
#line 1390 "../src/client/application/application-main-window.vala"
	_tmp65_ = self->priv->conversation_viewer_actions;
#line 1390 "../src/client/application/application-main-window.vala"
	_tmp66_ = application_main_window_get_application (self);
#line 1390 "../src/client/application/application-main-window.vala"
	_tmp67_ = _tmp66_;
#line 1390 "../src/client/application/application-main-window.vala"
	_tmp68_ = application_client_get_config (_tmp67_);
#line 1390 "../src/client/application/application-main-window.vala"
	_tmp69_ = _tmp68_;
#line 1390 "../src/client/application/application-main-window.vala"
	components_conversation_actions_init (_tmp65_, _tmp69_);
#line 1392 "../src/client/application/application-main-window.vala"
	_tmp70_ = self->conversation_headerbar;
#line 1392 "../src/client/application/application-main-window.vala"
	_tmp71_ = _tmp70_->full_actions;
#line 1392 "../src/client/application/application-main-window.vala"
	_tmp72_ = _g_object_ref0 (_tmp71_);
#line 1392 "../src/client/application/application-main-window.vala"
	_tmp73_ = self->priv->conversation_list_actions;
#line 1392 "../src/client/application/application-main-window.vala"
	_tmp74_ = _g_object_ref0 (_tmp73_);
#line 1392 "../src/client/application/application-main-window.vala"
	_tmp75_ = self->priv->conversation_viewer_actions;
#line 1392 "../src/client/application/application-main-window.vala"
	_tmp76_ = _g_object_ref0 (_tmp75_);
#line 1392 "../src/client/application/application-main-window.vala"
	_tmp77_ = g_new0 (ComponentsConversationActions*, 3 + 1);
#line 1392 "../src/client/application/application-main-window.vala"
	_tmp77_[0] = _tmp72_;
#line 1392 "../src/client/application/application-main-window.vala"
	_tmp77_[1] = _tmp74_;
#line 1392 "../src/client/application/application-main-window.vala"
	_tmp77_[2] = _tmp76_;
#line 1392 "../src/client/application/application-main-window.vala"
	self->priv->folder_conversation_actions = (_vala_array_free (self->priv->folder_conversation_actions, self->priv->folder_conversation_actions_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1392 "../src/client/application/application-main-window.vala"
	self->priv->folder_conversation_actions = _tmp77_;
#line 1392 "../src/client/application/application-main-window.vala"
	self->priv->folder_conversation_actions_length1 = 3;
#line 1392 "../src/client/application/application-main-window.vala"
	self->priv->_folder_conversation_actions_size_ = self->priv->folder_conversation_actions_length1;
#line 1398 "../src/client/application/application-main-window.vala"
	_tmp78_ = self->priv->folder_conversation_actions;
#line 1398 "../src/client/application/application-main-window.vala"
	_tmp78__length1 = self->priv->folder_conversation_actions_length1;
#line 8147 "application-main-window.c"
	{
		ComponentsConversationActions** actions_collection = NULL;
		gint actions_collection_length1 = 0;
		gint _actions_collection_size_ = 0;
		gint actions_it = 0;
#line 1398 "../src/client/application/application-main-window.vala"
		actions_collection = _tmp78_;
#line 1398 "../src/client/application/application-main-window.vala"
		actions_collection_length1 = _tmp78__length1;
#line 1398 "../src/client/application/application-main-window.vala"
		for (actions_it = 0; actions_it < actions_collection_length1; actions_it = actions_it + 1) {
#line 8159 "application-main-window.c"
			ComponentsConversationActions* _tmp79_;
			ComponentsConversationActions* actions = NULL;
#line 1398 "../src/client/application/application-main-window.vala"
			_tmp79_ = _g_object_ref0 (actions_collection[actions_it]);
#line 1398 "../src/client/application/application-main-window.vala"
			actions = _tmp79_;
#line 8166 "application-main-window.c"
			{
				FolderPopover* popover = NULL;
				ComponentsConversationActions* _tmp80_;
				FolderPopover* _tmp81_;
				FolderPopover* _tmp82_;
				FolderPopover* _tmp83_;
				FolderPopover* _tmp84_;
				FolderPopover* _tmp85_;
#line 1399 "../src/client/application/application-main-window.vala"
				_tmp80_ = actions;
#line 1399 "../src/client/application/application-main-window.vala"
				_tmp81_ = components_conversation_actions_get_copy_move_popover (_tmp80_);
#line 1399 "../src/client/application/application-main-window.vala"
				_tmp82_ = _tmp81_;
#line 1399 "../src/client/application/application-main-window.vala"
				_tmp83_ = _g_object_ref0 (_tmp82_);
#line 1399 "../src/client/application/application-main-window.vala"
				popover = _tmp83_;
#line 1400 "../src/client/application/application-main-window.vala"
				_tmp84_ = popover;
#line 1400 "../src/client/application/application-main-window.vala"
				g_signal_connect_object (_tmp84_, "copy-conversation", (GCallback) _application_main_window_on_copy_conversation_folder_popover_copy_conversation, self, 0);
#line 1401 "../src/client/application/application-main-window.vala"
				_tmp85_ = popover;
#line 1401 "../src/client/application/application-main-window.vala"
				g_signal_connect_object (_tmp85_, "move-conversation", (GCallback) _application_main_window_on_move_conversation_folder_popover_move_conversation, self, 0);
#line 1398 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (popover);
#line 1398 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (actions);
#line 8197 "application-main-window.c"
			}
		}
	}
}

/** {@inheritDoc} */
static gboolean
application_main_window_real_key_press_event (GtkWidget* base,
                                              GdkEventKey* event)
{
	ApplicationMainWindow * self;
	gboolean result;
#line 1406 "../src/client/application/application-main-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_MAIN_WINDOW, ApplicationMainWindow);
#line 1406 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 1407 "../src/client/application/application-main-window.vala"
	application_main_window_check_shift_event (self, event);
#line 1408 "../src/client/application/application-main-window.vala"
	result = GTK_WIDGET_CLASS (application_main_window_parent_class)->key_press_event (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), gtk_widget_get_type (), GtkWidget), event);
#line 1408 "../src/client/application/application-main-window.vala"
	return result;
#line 8220 "application-main-window.c"
}

/** {@inheritDoc} */
static gboolean
application_main_window_real_key_release_event (GtkWidget* base,
                                                GdkEventKey* event)
{
	ApplicationMainWindow * self;
	gboolean result;
#line 1412 "../src/client/application/application-main-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_MAIN_WINDOW, ApplicationMainWindow);
#line 1412 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 1413 "../src/client/application/application-main-window.vala"
	application_main_window_check_shift_event (self, event);
#line 1414 "../src/client/application/application-main-window.vala"
	result = GTK_WIDGET_CLASS (application_main_window_parent_class)->key_release_event (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), gtk_widget_get_type (), GtkWidget), event);
#line 1414 "../src/client/application/application-main-window.vala"
	return result;
#line 8240 "application-main-window.c"
}

gboolean
application_main_window_prompt_empty_folder (ApplicationMainWindow* self,
                                             GearyFolderSpecialUse type)
{
	gchar* folder_name = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	ConfirmationDialog* dialog = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	ConfirmationDialog* _tmp12_;
	ConfirmationDialog* _tmp13_;
	gboolean result;
#line 1417 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 1418 "../src/client/application/application-main-window.vala"
	_tmp0_ = util_i18n_to_folder_type_display_name (type);
#line 1418 "../src/client/application/application-main-window.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1418 "../src/client/application/application-main-window.vala"
	folder_name = _tmp1_;
#line 1419 "../src/client/application/application-main-window.vala"
	_tmp2_ = g_strdup_printf (_ ("Empty all email from your %s folder?"), folder_name);
#line 1419 "../src/client/application/application-main-window.vala"
	_tmp3_ = _tmp2_;
#line 1419 "../src/client/application/application-main-window.vala"
	_tmp4_ = g_strconcat (_ ("This removes the email from Geary and your email server."), "  <b>", NULL);
#line 1419 "../src/client/application/application-main-window.vala"
	_tmp5_ = _tmp4_;
#line 1419 "../src/client/application/application-main-window.vala"
	_tmp6_ = g_strconcat (_tmp5_, _ ("This cannot be undone."), NULL);
#line 1419 "../src/client/application/application-main-window.vala"
	_tmp7_ = _tmp6_;
#line 1419 "../src/client/application/application-main-window.vala"
	_tmp8_ = g_strconcat (_tmp7_, "</b>", NULL);
#line 1419 "../src/client/application/application-main-window.vala"
	_tmp9_ = _tmp8_;
#line 1419 "../src/client/application/application-main-window.vala"
	_tmp10_ = g_strdup_printf (_ ("Empty %s"), folder_name);
#line 1419 "../src/client/application/application-main-window.vala"
	_tmp11_ = _tmp10_;
#line 1419 "../src/client/application/application-main-window.vala"
	_tmp12_ = confirmation_dialog_new (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), _tmp3_, _tmp9_, _tmp11_, "destructive-action");
#line 1419 "../src/client/application/application-main-window.vala"
	_tmp13_ = _tmp12_;
#line 1419 "../src/client/application/application-main-window.vala"
	_g_free0 (_tmp11_);
#line 1419 "../src/client/application/application-main-window.vala"
	_g_free0 (_tmp9_);
#line 1419 "../src/client/application/application-main-window.vala"
	_g_free0 (_tmp7_);
#line 1419 "../src/client/application/application-main-window.vala"
	_g_free0 (_tmp5_);
#line 1419 "../src/client/application/application-main-window.vala"
	_g_free0 (_tmp3_);
#line 1419 "../src/client/application/application-main-window.vala"
	dialog = _tmp13_;
#line 1427 "../src/client/application/application-main-window.vala"
	alert_dialog_use_secondary_markup (G_TYPE_CHECK_INSTANCE_CAST (dialog, TYPE_ALERT_DIALOG, AlertDialog), TRUE);
#line 1428 "../src/client/application/application-main-window.vala"
	alert_dialog_set_focus_response (G_TYPE_CHECK_INSTANCE_CAST (dialog, TYPE_ALERT_DIALOG, AlertDialog), GTK_RESPONSE_CANCEL);
#line 1429 "../src/client/application/application-main-window.vala"
	result = alert_dialog_run (G_TYPE_CHECK_INSTANCE_CAST (dialog, TYPE_ALERT_DIALOG, AlertDialog)) == GTK_RESPONSE_OK;
#line 1429 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (dialog);
#line 1429 "../src/client/application/application-main-window.vala"
	_g_free0 (folder_name);
#line 1429 "../src/client/application/application-main-window.vala"
	return result;
#line 8320 "application-main-window.c"
}

static void
application_main_window_undo_data_free (gpointer _data)
{
	ApplicationMainWindowUndoData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/application-main-window.vala"
	g_slice_free (ApplicationMainWindowUndoData, _data_);
#line 8332 "application-main-window.c"
}

static void
application_main_window_undo (ApplicationMainWindow* self,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	ApplicationMainWindowUndoData* _data_;
	ApplicationMainWindow* _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_slice_new0 (ApplicationMainWindowUndoData);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 10 "../src/client/application/application-main-window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_main_window_undo_data_free);
#line 10 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_undo_co (_data_);
#line 8356 "application-main-window.c"
}

static void
application_main_window_undo_finish (ApplicationMainWindow* self,
                                     GAsyncResult* _res_)
{
	ApplicationMainWindowUndoData* _data_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 8366 "application-main-window.c"
}

/** Un-does the last executed application command, if any. */
static Block16Data*
block16_data_ref (Block16Data* _data16_)
{
#line 1433 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data16_->_ref_count_);
#line 1433 "../src/client/application/application-main-window.vala"
	return _data16_;
#line 8377 "application-main-window.c"
}

static void
block16_data_unref (void * _userdata_)
{
	Block16Data* _data16_;
	_data16_ = (Block16Data*) _userdata_;
#line 1433 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data16_->_ref_count_)) {
#line 8387 "application-main-window.c"
		ApplicationMainWindow* self;
#line 1433 "../src/client/application/application-main-window.vala"
		self = _data16_->self;
#line 1433 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data16_->selected);
#line 1433 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 1433 "../src/client/application/application-main-window.vala"
		g_slice_free (Block16Data, _data16_);
#line 8397 "application-main-window.c"
	}
}

static void
___lambda195_ (Block16Data* _data16_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 1438 "../src/client/application/application-main-window.vala"
	self = _data16_->self;
#line 1438 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 1438 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 8414 "application-main-window.c"
	{
		ApplicationAccountContext* _tmp0_;
		ApplicationCommandStack* _tmp1_;
		ApplicationCommandStack* _tmp2_;
#line 1440 "../src/client/application/application-main-window.vala"
		_tmp0_ = _data16_->selected;
#line 1440 "../src/client/application/application-main-window.vala"
		_tmp1_ = application_account_context_get_commands (_tmp0_);
#line 1440 "../src/client/application/application-main-window.vala"
		_tmp2_ = _tmp1_;
#line 1440 "../src/client/application/application-main-window.vala"
		application_command_stack_undo_finish (_tmp2_, res, &_inner_error0_);
#line 1440 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8429 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		ApplicationAccountContext* _tmp3_;
		GearyAccount* _tmp4_;
		GearyAccount* _tmp5_;
		GearyAccountInformation* _tmp6_;
		GearyAccountInformation* _tmp7_;
		GError* _tmp8_;
#line 1439 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 1439 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 1442 "../src/client/application/application-main-window.vala"
		_tmp3_ = _data16_->selected;
#line 1442 "../src/client/application/application-main-window.vala"
		_tmp4_ = application_account_context_get_account (_tmp3_);
#line 1442 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 1442 "../src/client/application/application-main-window.vala"
		_tmp6_ = geary_account_get_information (_tmp5_);
#line 1442 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 1442 "../src/client/application/application-main-window.vala"
		_tmp8_ = err;
#line 1442 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp7_, _tmp8_);
#line 1439 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 8463 "application-main-window.c"
	}
	__finally0:
#line 1439 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1439 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1439 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 1439 "../src/client/application/application-main-window.vala"
		return;
#line 8474 "application-main-window.c"
	}
}

static void
____lambda195__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 1436 "../src/client/application/application-main-window.vala"
	___lambda195_ (self, source_object, res);
#line 1436 "../src/client/application/application-main-window.vala"
	block16_data_unref (self);
#line 8487 "application-main-window.c"
}

static gboolean
application_main_window_undo_co (ApplicationMainWindowUndoData* _data_)
{
#line 1433 "../src/client/application/application-main-window.vala"
	switch (_data_->_state_) {
#line 1433 "../src/client/application/application-main-window.vala"
		case 0:
#line 8497 "application-main-window.c"
		goto _state_0;
		default:
#line 1433 "../src/client/application/application-main-window.vala"
		g_assert_not_reached ();
#line 8502 "application-main-window.c"
	}
	_state_0:
#line 1433 "../src/client/application/application-main-window.vala"
	_data_->_data16_ = g_slice_new0 (Block16Data);
#line 1433 "../src/client/application/application-main-window.vala"
	_data_->_data16_->_ref_count_ = 1;
#line 1433 "../src/client/application/application-main-window.vala"
	_data_->_data16_->self = g_object_ref (_data_->self);
#line 1433 "../src/client/application/application-main-window.vala"
	_data_->_data16_->_async_data_ = _data_;
#line 1434 "../src/client/application/application-main-window.vala"
	_data_->_tmp0_ = application_main_window_get_selected_account_context (_data_->self);
#line 1434 "../src/client/application/application-main-window.vala"
	_data_->_data16_->selected = _data_->_tmp0_;
#line 1435 "../src/client/application/application-main-window.vala"
	_data_->_tmp1_ = _data_->_data16_->selected;
#line 1435 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp1_ != NULL) {
#line 1436 "../src/client/application/application-main-window.vala"
		_data_->_tmp2_ = _data_->_data16_->selected;
#line 1436 "../src/client/application/application-main-window.vala"
		_data_->_tmp3_ = application_account_context_get_commands (_data_->_tmp2_);
#line 1436 "../src/client/application/application-main-window.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 1436 "../src/client/application/application-main-window.vala"
		_data_->_tmp5_ = _data_->_data16_->selected;
#line 1436 "../src/client/application/application-main-window.vala"
		_data_->_tmp6_ = application_account_context_get_cancellable (_data_->_tmp5_);
#line 1436 "../src/client/application/application-main-window.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 1436 "../src/client/application/application-main-window.vala"
		application_command_stack_undo (_data_->_tmp4_, _data_->_tmp7_, ____lambda195__gasync_ready_callback, block16_data_ref (_data_->_data16_));
#line 8535 "application-main-window.c"
	}
#line 1433 "../src/client/application/application-main-window.vala"
	block16_data_unref (_data_->_data16_);
#line 1433 "../src/client/application/application-main-window.vala"
	_data_->_data16_ = NULL;
#line 1433 "../src/client/application/application-main-window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1433 "../src/client/application/application-main-window.vala"
	if (_data_->_state_ != 0) {
#line 1433 "../src/client/application/application-main-window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1433 "../src/client/application/application-main-window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8549 "application-main-window.c"
		}
	}
#line 1433 "../src/client/application/application-main-window.vala"
	g_object_unref (_data_->_async_result);
#line 1433 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 8556 "application-main-window.c"
}

static void
application_main_window_redo_data_free (gpointer _data)
{
	ApplicationMainWindowRedoData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/application-main-window.vala"
	g_slice_free (ApplicationMainWindowRedoData, _data_);
#line 8568 "application-main-window.c"
}

static void
application_main_window_redo (ApplicationMainWindow* self,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	ApplicationMainWindowRedoData* _data_;
	ApplicationMainWindow* _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_slice_new0 (ApplicationMainWindowRedoData);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 10 "../src/client/application/application-main-window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_main_window_redo_data_free);
#line 10 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_redo_co (_data_);
#line 8592 "application-main-window.c"
}

static void
application_main_window_redo_finish (ApplicationMainWindow* self,
                                     GAsyncResult* _res_)
{
	ApplicationMainWindowRedoData* _data_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 8602 "application-main-window.c"
}

/** Re-does the last undone application command, if any. */
static Block17Data*
block17_data_ref (Block17Data* _data17_)
{
#line 1450 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data17_->_ref_count_);
#line 1450 "../src/client/application/application-main-window.vala"
	return _data17_;
#line 8613 "application-main-window.c"
}

static void
block17_data_unref (void * _userdata_)
{
	Block17Data* _data17_;
	_data17_ = (Block17Data*) _userdata_;
#line 1450 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data17_->_ref_count_)) {
#line 8623 "application-main-window.c"
		ApplicationMainWindow* self;
#line 1450 "../src/client/application/application-main-window.vala"
		self = _data17_->self;
#line 1450 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data17_->selected);
#line 1450 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 1450 "../src/client/application/application-main-window.vala"
		g_slice_free (Block17Data, _data17_);
#line 8633 "application-main-window.c"
	}
}

static void
___lambda196_ (Block17Data* _data17_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 1455 "../src/client/application/application-main-window.vala"
	self = _data17_->self;
#line 1455 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 1455 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 8650 "application-main-window.c"
	{
		ApplicationAccountContext* _tmp0_;
		ApplicationCommandStack* _tmp1_;
		ApplicationCommandStack* _tmp2_;
#line 1457 "../src/client/application/application-main-window.vala"
		_tmp0_ = _data17_->selected;
#line 1457 "../src/client/application/application-main-window.vala"
		_tmp1_ = application_account_context_get_commands (_tmp0_);
#line 1457 "../src/client/application/application-main-window.vala"
		_tmp2_ = _tmp1_;
#line 1457 "../src/client/application/application-main-window.vala"
		application_command_stack_redo_finish (_tmp2_, res, &_inner_error0_);
#line 1457 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8665 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		ApplicationAccountContext* _tmp3_;
		GearyAccount* _tmp4_;
		GearyAccount* _tmp5_;
		GearyAccountInformation* _tmp6_;
		GearyAccountInformation* _tmp7_;
		GError* _tmp8_;
#line 1456 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 1456 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 1459 "../src/client/application/application-main-window.vala"
		_tmp3_ = _data17_->selected;
#line 1459 "../src/client/application/application-main-window.vala"
		_tmp4_ = application_account_context_get_account (_tmp3_);
#line 1459 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 1459 "../src/client/application/application-main-window.vala"
		_tmp6_ = geary_account_get_information (_tmp5_);
#line 1459 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 1459 "../src/client/application/application-main-window.vala"
		_tmp8_ = err;
#line 1459 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp7_, _tmp8_);
#line 1456 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 8699 "application-main-window.c"
	}
	__finally0:
#line 1456 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1456 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1456 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 1456 "../src/client/application/application-main-window.vala"
		return;
#line 8710 "application-main-window.c"
	}
}

static void
____lambda196__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 1453 "../src/client/application/application-main-window.vala"
	___lambda196_ (self, source_object, res);
#line 1453 "../src/client/application/application-main-window.vala"
	block17_data_unref (self);
#line 8723 "application-main-window.c"
}

static gboolean
application_main_window_redo_co (ApplicationMainWindowRedoData* _data_)
{
#line 1450 "../src/client/application/application-main-window.vala"
	switch (_data_->_state_) {
#line 1450 "../src/client/application/application-main-window.vala"
		case 0:
#line 8733 "application-main-window.c"
		goto _state_0;
		default:
#line 1450 "../src/client/application/application-main-window.vala"
		g_assert_not_reached ();
#line 8738 "application-main-window.c"
	}
	_state_0:
#line 1450 "../src/client/application/application-main-window.vala"
	_data_->_data17_ = g_slice_new0 (Block17Data);
#line 1450 "../src/client/application/application-main-window.vala"
	_data_->_data17_->_ref_count_ = 1;
#line 1450 "../src/client/application/application-main-window.vala"
	_data_->_data17_->self = g_object_ref (_data_->self);
#line 1450 "../src/client/application/application-main-window.vala"
	_data_->_data17_->_async_data_ = _data_;
#line 1451 "../src/client/application/application-main-window.vala"
	_data_->_tmp0_ = application_main_window_get_selected_account_context (_data_->self);
#line 1451 "../src/client/application/application-main-window.vala"
	_data_->_data17_->selected = _data_->_tmp0_;
#line 1452 "../src/client/application/application-main-window.vala"
	_data_->_tmp1_ = _data_->_data17_->selected;
#line 1452 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp1_ != NULL) {
#line 1453 "../src/client/application/application-main-window.vala"
		_data_->_tmp2_ = _data_->_data17_->selected;
#line 1453 "../src/client/application/application-main-window.vala"
		_data_->_tmp3_ = application_account_context_get_commands (_data_->_tmp2_);
#line 1453 "../src/client/application/application-main-window.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 1453 "../src/client/application/application-main-window.vala"
		_data_->_tmp5_ = _data_->_data17_->selected;
#line 1453 "../src/client/application/application-main-window.vala"
		_data_->_tmp6_ = application_account_context_get_cancellable (_data_->_tmp5_);
#line 1453 "../src/client/application/application-main-window.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 1453 "../src/client/application/application-main-window.vala"
		application_command_stack_redo (_data_->_tmp4_, _data_->_tmp7_, ____lambda196__gasync_ready_callback, block17_data_ref (_data_->_data17_));
#line 8771 "application-main-window.c"
	}
#line 1450 "../src/client/application/application-main-window.vala"
	block17_data_unref (_data_->_data17_);
#line 1450 "../src/client/application/application-main-window.vala"
	_data_->_data17_ = NULL;
#line 1450 "../src/client/application/application-main-window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1450 "../src/client/application/application-main-window.vala"
	if (_data_->_state_ != 0) {
#line 1450 "../src/client/application/application-main-window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1450 "../src/client/application/application-main-window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8785 "application-main-window.c"
		}
	}
#line 1450 "../src/client/application/application-main-window.vala"
	g_object_unref (_data_->_async_result);
#line 1450 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 8792 "application-main-window.c"
}

static void
application_main_window_update_command_actions (ApplicationMainWindow* self)
{
	ApplicationAccountContext* selected = NULL;
	ApplicationAccountContext* _tmp0_;
	gboolean _tmp1_ = FALSE;
	ApplicationAccountContext* _tmp2_;
	GSimpleAction* _tmp8_;
	GSimpleAction* _tmp9_;
	gboolean _tmp10_ = FALSE;
	ApplicationAccountContext* _tmp11_;
	GSimpleAction* _tmp17_;
	GSimpleAction* _tmp18_;
#line 1466 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1467 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_selected_account_context (self);
#line 1467 "../src/client/application/application-main-window.vala"
	selected = _tmp0_;
#line 1469 "../src/client/application/application-main-window.vala"
	_tmp2_ = selected;
#line 1469 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 8818 "application-main-window.c"
		ApplicationAccountContext* _tmp3_;
		ApplicationCommandStack* _tmp4_;
		ApplicationCommandStack* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 1469 "../src/client/application/application-main-window.vala"
		_tmp3_ = selected;
#line 1469 "../src/client/application/application-main-window.vala"
		_tmp4_ = application_account_context_get_commands (_tmp3_);
#line 1469 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 1469 "../src/client/application/application-main-window.vala"
		_tmp6_ = application_command_stack_get_can_undo (_tmp5_);
#line 1469 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 1469 "../src/client/application/application-main-window.vala"
		_tmp1_ = _tmp7_;
#line 8836 "application-main-window.c"
	} else {
#line 1469 "../src/client/application/application-main-window.vala"
		_tmp1_ = FALSE;
#line 8840 "application-main-window.c"
	}
#line 1468 "../src/client/application/application-main-window.vala"
	_tmp8_ = application_main_window_get_edit_action (self, ACTION_EDIT_UNDO);
#line 1468 "../src/client/application/application-main-window.vala"
	_tmp9_ = _tmp8_;
#line 1468 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp9_, _tmp1_);
#line 1468 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp9_);
#line 1472 "../src/client/application/application-main-window.vala"
	_tmp11_ = selected;
#line 1472 "../src/client/application/application-main-window.vala"
	if (_tmp11_ != NULL) {
#line 8854 "application-main-window.c"
		ApplicationAccountContext* _tmp12_;
		ApplicationCommandStack* _tmp13_;
		ApplicationCommandStack* _tmp14_;
		gboolean _tmp15_;
		gboolean _tmp16_;
#line 1472 "../src/client/application/application-main-window.vala"
		_tmp12_ = selected;
#line 1472 "../src/client/application/application-main-window.vala"
		_tmp13_ = application_account_context_get_commands (_tmp12_);
#line 1472 "../src/client/application/application-main-window.vala"
		_tmp14_ = _tmp13_;
#line 1472 "../src/client/application/application-main-window.vala"
		_tmp15_ = application_command_stack_get_can_redo (_tmp14_);
#line 1472 "../src/client/application/application-main-window.vala"
		_tmp16_ = _tmp15_;
#line 1472 "../src/client/application/application-main-window.vala"
		_tmp10_ = _tmp16_;
#line 8872 "application-main-window.c"
	} else {
#line 1472 "../src/client/application/application-main-window.vala"
		_tmp10_ = FALSE;
#line 8876 "application-main-window.c"
	}
#line 1471 "../src/client/application/application-main-window.vala"
	_tmp17_ = application_main_window_get_edit_action (self, ACTION_EDIT_REDO);
#line 1471 "../src/client/application/application-main-window.vala"
	_tmp18_ = _tmp17_;
#line 1471 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp18_, _tmp10_);
#line 1471 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp18_);
#line 1466 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (selected);
#line 8888 "application-main-window.c"
}

static gboolean
application_main_window_prompt_delete_conversations (ApplicationMainWindow* self,
                                                     gint count)
{
	ConfirmationDialog* dialog = NULL;
	ConfirmationDialog* _tmp0_;
	gboolean result;
#line 1476 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 1477 "../src/client/application/application-main-window.vala"
	_tmp0_ = confirmation_dialog_new (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), ngettext ("Do you want to permanently delete this conversation?", "Do you want to permanently delete these conversations?", (gulong) count), NULL, _ ("Delete"), "destructive-action");
#line 1477 "../src/client/application/application-main-window.vala"
	dialog = _tmp0_;
#line 1488 "../src/client/application/application-main-window.vala"
	result = alert_dialog_run (G_TYPE_CHECK_INSTANCE_CAST (dialog, TYPE_ALERT_DIALOG, AlertDialog)) == GTK_RESPONSE_OK;
#line 1488 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (dialog);
#line 1488 "../src/client/application/application-main-window.vala"
	return result;
#line 8910 "application-main-window.c"
}

static gboolean
application_main_window_prompt_delete_messages (ApplicationMainWindow* self,
                                                gint count)
{
	ConfirmationDialog* dialog = NULL;
	ConfirmationDialog* _tmp0_;
	gboolean result;
#line 1491 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 1492 "../src/client/application/application-main-window.vala"
	_tmp0_ = confirmation_dialog_new (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), ngettext ("Do you want to permanently delete this message?", "Do you want to permanently delete these messages?", (gulong) count), NULL, _ ("Delete"), "destructive-action");
#line 1492 "../src/client/application/application-main-window.vala"
	dialog = _tmp0_;
#line 1503 "../src/client/application/application-main-window.vala"
	result = alert_dialog_run (G_TYPE_CHECK_INSTANCE_CAST (dialog, TYPE_ALERT_DIALOG, AlertDialog)) == GTK_RESPONSE_OK;
#line 1503 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (dialog);
#line 1503 "../src/client/application/application-main-window.vala"
	return result;
#line 8932 "application-main-window.c"
}

static void
application_main_window_load_conversations_for_email_data_free (gpointer _data)
{
	ApplicationMainWindowLoadConversationsForEmailData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->location);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_load);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->result);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/application-main-window.vala"
	g_slice_free (ApplicationMainWindowLoadConversationsForEmailData, _data_);
#line 8950 "application-main-window.c"
}

static void
application_main_window_load_conversations_for_email (ApplicationMainWindow* self,
                                                      GearyFolder* location,
                                                      GeeCollection* to_load,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_)
{
	ApplicationMainWindowLoadConversationsForEmailData* _data_;
	ApplicationMainWindow* _tmp0_;
	GearyFolder* _tmp1_;
	GeeCollection* _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (location, GEARY_TYPE_FOLDER));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (to_load, GEE_TYPE_COLLECTION));
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_slice_new0 (ApplicationMainWindowLoadConversationsForEmailData);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 10 "../src/client/application/application-main-window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_main_window_load_conversations_for_email_data_free);
#line 10 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (location);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->location);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->location = _tmp1_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp2_ = _g_object_ref0 (to_load);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_load);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->to_load = _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_load_conversations_for_email_co (_data_);
#line 8994 "application-main-window.c"
}

static GeeCollection*
application_main_window_load_conversations_for_email_finish (ApplicationMainWindow* self,
                                                             GAsyncResult* _res_)
{
	GeeCollection* result;
	ApplicationMainWindowLoadConversationsForEmailData* _data_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 10 "../src/client/application/application-main-window.vala"
	result = _data_->result;
#line 10 "../src/client/application/application-main-window.vala"
	_data_->result = NULL;
#line 10 "../src/client/application/application-main-window.vala"
	return result;
#line 9011 "application-main-window.c"
}

static void
application_main_window_load_conversations_for_email_ready (GObject* source_object,
                                                            GAsyncResult* _res_,
                                                            gpointer _user_data_)
{
	ApplicationMainWindowLoadConversationsForEmailData* _data_;
#line 1516 "../src/client/application/application-main-window.vala"
	_data_ = _user_data_;
#line 1516 "../src/client/application/application-main-window.vala"
	_data_->_source_object_ = source_object;
#line 1516 "../src/client/application/application-main-window.vala"
	_data_->_res_ = _res_;
#line 1516 "../src/client/application/application-main-window.vala"
	application_main_window_load_conversations_for_email_co (_data_);
#line 9028 "application-main-window.c"
}

static gboolean
application_main_window_load_conversations_for_email_co (ApplicationMainWindowLoadConversationsForEmailData* _data_)
{
#line 1506 "../src/client/application/application-main-window.vala"
	switch (_data_->_state_) {
#line 1506 "../src/client/application/application-main-window.vala"
		case 0:
#line 9038 "application-main-window.c"
		goto _state_0;
#line 1506 "../src/client/application/application-main-window.vala"
		case 1:
#line 9042 "application-main-window.c"
		goto _state_1;
		default:
#line 1506 "../src/client/application/application-main-window.vala"
		g_assert_not_reached ();
#line 9047 "application-main-window.c"
	}
	_state_0:
#line 1510 "../src/client/application/application-main-window.vala"
	_data_->was_loaded = FALSE;
#line 1513 "../src/client/application/application-main-window.vala"
	_data_->_tmp1_ = _data_->self->priv->_conversations;
#line 1513 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp1_ != NULL) {
#line 1514 "../src/client/application/application-main-window.vala"
		_data_->_tmp2_ = _data_->self->priv->_conversations;
#line 1514 "../src/client/application/application-main-window.vala"
		_data_->_tmp3_ = geary_app_conversation_monitor_get_base_folder (_data_->_tmp2_);
#line 1514 "../src/client/application/application-main-window.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 1514 "../src/client/application/application-main-window.vala"
		_data_->_tmp0_ = _data_->_tmp4_ == _data_->location;
#line 9064 "application-main-window.c"
	} else {
#line 1513 "../src/client/application/application-main-window.vala"
		_data_->_tmp0_ = FALSE;
#line 9068 "application-main-window.c"
	}
#line 1513 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp0_) {
#line 9072 "application-main-window.c"
		{
#line 1516 "../src/client/application/application-main-window.vala"
			_data_->_tmp5_ = _data_->self->priv->_conversations;
#line 1516 "../src/client/application/application-main-window.vala"
			_data_->_tmp6_ = _data_->self->priv->folder_open;
#line 1516 "../src/client/application/application-main-window.vala"
			_data_->_state_ = 1;
#line 1516 "../src/client/application/application-main-window.vala"
			geary_app_conversation_monitor_load_email (_data_->_tmp5_, _data_->to_load, _data_->_tmp6_, application_main_window_load_conversations_for_email_ready, _data_);
#line 1516 "../src/client/application/application-main-window.vala"
			return FALSE;
#line 9084 "application-main-window.c"
			_state_1:
#line 1516 "../src/client/application/application-main-window.vala"
			geary_app_conversation_monitor_load_email_finish (_data_->_tmp5_, _data_->_res_, &_data_->_inner_error0_);
#line 1516 "../src/client/application/application-main-window.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 9090 "application-main-window.c"
				goto __catch0_g_error;
			}
#line 1517 "../src/client/application/application-main-window.vala"
			_data_->was_loaded = TRUE;
#line 9095 "application-main-window.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 1515 "../src/client/application/application-main-window.vala"
			_data_->err = _data_->_inner_error0_;
#line 1515 "../src/client/application/application-main-window.vala"
			_data_->_inner_error0_ = NULL;
#line 1519 "../src/client/application/application-main-window.vala"
			_data_->_tmp7_ = _data_->err;
#line 1519 "../src/client/application/application-main-window.vala"
			_data_->_tmp8_ = _data_->_tmp7_->message;
#line 1519 "../src/client/application/application-main-window.vala"
			g_debug ("application-main-window.vala:1519: Error loading conversations to show" \
" them: %s", _data_->_tmp8_);
#line 1515 "../src/client/application/application-main-window.vala"
			_g_error_free0 (_data_->err);
#line 9112 "application-main-window.c"
		}
		__finally0:
#line 1515 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1515 "../src/client/application/application-main-window.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 1515 "../src/client/application/application-main-window.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 1515 "../src/client/application/application-main-window.vala"
			g_object_unref (_data_->_async_result);
#line 1515 "../src/client/application/application-main-window.vala"
			return FALSE;
#line 9125 "application-main-window.c"
		}
	}
#line 1526 "../src/client/application/application-main-window.vala"
	_data_->_tmp9_ = gee_hash_set_new (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1526 "../src/client/application/application-main-window.vala"
	_data_->loaded = _data_->_tmp9_;
#line 1527 "../src/client/application/application-main-window.vala"
	if (_data_->was_loaded) {
#line 1528 "../src/client/application/application-main-window.vala"
		_data_->_tmp12_ = _data_->self->priv->_conversations;
#line 1528 "../src/client/application/application-main-window.vala"
		_data_->_tmp11_ = _data_->_tmp12_ != NULL;
#line 9138 "application-main-window.c"
	} else {
#line 1527 "../src/client/application/application-main-window.vala"
		_data_->_tmp11_ = FALSE;
#line 9142 "application-main-window.c"
	}
#line 1527 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp11_) {
#line 1529 "../src/client/application/application-main-window.vala"
		_data_->_tmp13_ = _data_->self->priv->_conversations;
#line 1529 "../src/client/application/application-main-window.vala"
		_data_->_tmp14_ = geary_app_conversation_monitor_get_base_folder (_data_->_tmp13_);
#line 1529 "../src/client/application/application-main-window.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 1529 "../src/client/application/application-main-window.vala"
		_data_->_tmp10_ = _data_->_tmp15_ == _data_->location;
#line 9154 "application-main-window.c"
	} else {
#line 1527 "../src/client/application/application-main-window.vala"
		_data_->_tmp10_ = FALSE;
#line 9158 "application-main-window.c"
	}
#line 1527 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp10_) {
#line 9162 "application-main-window.c"
		{
#line 1530 "../src/client/application/application-main-window.vala"
			_data_->_tmp16_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_data_->to_load, GEE_TYPE_ITERABLE, GeeIterable));
#line 1530 "../src/client/application/application-main-window.vala"
			_data_->_id_it = _data_->_tmp16_;
#line 1530 "../src/client/application/application-main-window.vala"
			while (TRUE) {
#line 1530 "../src/client/application/application-main-window.vala"
				_data_->_tmp17_ = _data_->_id_it;
#line 1530 "../src/client/application/application-main-window.vala"
				if (!gee_iterator_next (_data_->_tmp17_)) {
#line 1530 "../src/client/application/application-main-window.vala"
					break;
#line 9176 "application-main-window.c"
				}
#line 1530 "../src/client/application/application-main-window.vala"
				_data_->_tmp18_ = _data_->_id_it;
#line 1530 "../src/client/application/application-main-window.vala"
				_data_->_tmp19_ = gee_iterator_get (_data_->_tmp18_);
#line 1530 "../src/client/application/application-main-window.vala"
				_data_->id = (GearyEmailIdentifier*) _data_->_tmp19_;
#line 1531 "../src/client/application/application-main-window.vala"
				_data_->_tmp20_ = _data_->self->priv->_conversations;
#line 1531 "../src/client/application/application-main-window.vala"
				_data_->_tmp21_ = _data_->id;
#line 1531 "../src/client/application/application-main-window.vala"
				_data_->_tmp22_ = geary_app_conversation_monitor_get_by_email_identifier (_data_->_tmp20_, _data_->_tmp21_);
#line 1531 "../src/client/application/application-main-window.vala"
				_data_->conversation = _data_->_tmp22_;
#line 1533 "../src/client/application/application-main-window.vala"
				_data_->_tmp23_ = _data_->conversation;
#line 1533 "../src/client/application/application-main-window.vala"
				if (_data_->_tmp23_ != NULL) {
#line 1534 "../src/client/application/application-main-window.vala"
					_data_->_tmp24_ = _data_->loaded;
#line 1534 "../src/client/application/application-main-window.vala"
					_data_->_tmp25_ = _data_->conversation;
#line 1534 "../src/client/application/application-main-window.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp24_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _data_->_tmp25_);
#line 9202 "application-main-window.c"
				}
#line 1530 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->conversation);
#line 1530 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->id);
#line 9208 "application-main-window.c"
			}
#line 1530 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_data_->_id_it);
#line 9212 "application-main-window.c"
		}
	}
#line 1538 "../src/client/application/application-main-window.vala"
	_data_->result = G_TYPE_CHECK_INSTANCE_CAST (_data_->loaded, GEE_TYPE_COLLECTION, GeeCollection);
#line 1538 "../src/client/application/application-main-window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1538 "../src/client/application/application-main-window.vala"
	if (_data_->_state_ != 0) {
#line 1538 "../src/client/application/application-main-window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1538 "../src/client/application/application-main-window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 9225 "application-main-window.c"
		}
	}
#line 1538 "../src/client/application/application-main-window.vala"
	g_object_unref (_data_->_async_result);
#line 1538 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 9232 "application-main-window.c"
}

static inline void
application_main_window_handle_error (ApplicationMainWindow* self,
                                      GearyAccountInformation* account,
                                      GError* _error_)
{
	GearyProblemReport* _tmp0_ = NULL;
	GearyProblemReport* report = NULL;
	GearyProblemReport* _tmp3_;
	ApplicationController* _tmp4_;
#line 1541 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1541 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((account == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 1541 "../src/client/application/application-main-window.vala"
	g_return_if_fail (_error_ != NULL);
#line 1543 "../src/client/application/application-main-window.vala"
	if (account != NULL) {
#line 9252 "application-main-window.c"
		GearyAccountProblemReport* _tmp1_;
#line 1544 "../src/client/application/application-main-window.vala"
		_tmp1_ = geary_account_problem_report_new (account, _error_);
#line 1544 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp0_);
#line 1544 "../src/client/application/application-main-window.vala"
		_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_TYPE_PROBLEM_REPORT, GearyProblemReport);
#line 9260 "application-main-window.c"
	} else {
		GearyProblemReport* _tmp2_;
#line 1545 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_problem_report_new (_error_);
#line 1545 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp0_);
#line 1545 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp2_;
#line 9269 "application-main-window.c"
	}
#line 1543 "../src/client/application/application-main-window.vala"
	_tmp3_ = _g_object_ref0 (_tmp0_);
#line 1543 "../src/client/application/application-main-window.vala"
	report = _tmp3_;
#line 1546 "../src/client/application/application-main-window.vala"
	_tmp4_ = self->priv->controller;
#line 1546 "../src/client/application/application-main-window.vala"
	composer_application_interface_report_problem (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, COMPOSER_TYPE_APPLICATION_INTERFACE, ComposerApplicationInterface), report);
#line 1541 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (report);
#line 1541 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp0_);
#line 9283 "application-main-window.c"
}

static void
application_main_window_update_ui (ApplicationMainWindow* self)
{
	gint64 now = 0LL;
#line 1549 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1551 "../src/client/application/application-main-window.vala"
	now = g_get_monotonic_time () / (1000 * 1000);
#line 1552 "../src/client/application/application-main-window.vala"
	if ((self->priv->update_ui_last + APPLICATION_MAIN_WINDOW_UPDATE_UI_INTERVAL) < now) {
#line 9296 "application-main-window.c"
		ConversationViewer* _tmp0_;
		ConversationListBox* _tmp1_;
		ConversationListBox* _tmp2_;
		ConversationListView* _tmp6_;
#line 1553 "../src/client/application/application-main-window.vala"
		self->priv->update_ui_last = now;
#line 1555 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->_conversation_viewer;
#line 1555 "../src/client/application/application-main-window.vala"
		_tmp1_ = conversation_viewer_get_current_list (_tmp0_);
#line 1555 "../src/client/application/application-main-window.vala"
		_tmp2_ = _tmp1_;
#line 1555 "../src/client/application/application-main-window.vala"
		if (_tmp2_ != NULL) {
#line 9311 "application-main-window.c"
			ConversationViewer* _tmp3_;
			ConversationListBox* _tmp4_;
			ConversationListBox* _tmp5_;
#line 1556 "../src/client/application/application-main-window.vala"
			_tmp3_ = self->priv->_conversation_viewer;
#line 1556 "../src/client/application/application-main-window.vala"
			_tmp4_ = conversation_viewer_get_current_list (_tmp3_);
#line 1556 "../src/client/application/application-main-window.vala"
			_tmp5_ = _tmp4_;
#line 1556 "../src/client/application/application-main-window.vala"
			conversation_list_box_update_display (_tmp5_);
#line 9323 "application-main-window.c"
		}
#line 1559 "../src/client/application/application-main-window.vala"
		_tmp6_ = self->priv->_conversation_list_view;
#line 1559 "../src/client/application/application-main-window.vala"
		conversation_list_view_refresh_times (_tmp6_);
#line 9329 "application-main-window.c"
	}
}

static void
application_main_window_select_account (ApplicationMainWindow* self,
                                        GearyAccount* account)
{
	GearyAccount* _tmp0_;
#line 1563 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1563 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((account == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT));
#line 1564 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_account;
#line 1564 "../src/client/application/application-main-window.vala"
	if (_tmp0_ != account) {
#line 9346 "application-main-window.c"
		SearchBar* _tmp1_;
#line 1565 "../src/client/application/application-main-window.vala"
		application_main_window_set_selected_account (self, account);
#line 1566 "../src/client/application/application-main-window.vala"
		_tmp1_ = self->priv->_search_bar;
#line 1566 "../src/client/application/application-main-window.vala"
		search_bar_set_account (_tmp1_, account);
#line 1568 "../src/client/application/application-main-window.vala"
		if (account != NULL) {
#line 9356 "application-main-window.c"
			ComponentsConversationActions* _tmp2_;
			ComponentsConversationActions* _tmp3_;
			ComponentsConversationHeaderBar* _tmp4_;
			ComponentsConversationActions* _tmp5_;
			ComponentsConversationHeaderBar* _tmp6_;
			ComponentsConversationActions* _tmp7_;
#line 1569 "../src/client/application/application-main-window.vala"
			_tmp2_ = self->priv->conversation_list_actions;
#line 1569 "../src/client/application/application-main-window.vala"
			components_conversation_actions_set_account (_tmp2_, account);
#line 1570 "../src/client/application/application-main-window.vala"
			_tmp3_ = self->priv->conversation_viewer_actions;
#line 1570 "../src/client/application/application-main-window.vala"
			components_conversation_actions_set_account (_tmp3_, account);
#line 1571 "../src/client/application/application-main-window.vala"
			_tmp4_ = self->conversation_headerbar;
#line 1571 "../src/client/application/application-main-window.vala"
			_tmp5_ = _tmp4_->full_actions;
#line 1571 "../src/client/application/application-main-window.vala"
			components_conversation_actions_set_account (_tmp5_, account);
#line 1572 "../src/client/application/application-main-window.vala"
			_tmp6_ = self->conversation_headerbar;
#line 1572 "../src/client/application/application-main-window.vala"
			_tmp7_ = _tmp6_->compact_actions;
#line 1572 "../src/client/application/application-main-window.vala"
			components_conversation_actions_set_account (_tmp7_, account);
#line 9383 "application-main-window.c"
		}
#line 1575 "../src/client/application/application-main-window.vala"
		application_main_window_update_command_actions (self);
#line 9387 "application-main-window.c"
	}
}

static void
application_main_window_select_conversations_data_free (gpointer _data)
{
	ApplicationMainWindowSelectConversationsData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_select);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->scroll_to);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/application-main-window.vala"
	g_slice_free (ApplicationMainWindowSelectConversationsData, _data_);
#line 9404 "application-main-window.c"
}

static void
application_main_window_select_conversations (ApplicationMainWindow* self,
                                              GeeCollection* to_select,
                                              GeeCollection* scroll_to,
                                              gboolean is_interactive,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	ApplicationMainWindowSelectConversationsData* _data_;
	ApplicationMainWindow* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (to_select, GEE_TYPE_COLLECTION));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (scroll_to, GEE_TYPE_COLLECTION));
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_slice_new0 (ApplicationMainWindowSelectConversationsData);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 10 "../src/client/application/application-main-window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_main_window_select_conversations_data_free);
#line 10 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (to_select);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_select);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->to_select = _tmp1_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp2_ = _g_object_ref0 (scroll_to);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->scroll_to);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->scroll_to = _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_->is_interactive = is_interactive;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_select_conversations_co (_data_);
#line 9451 "application-main-window.c"
}

static void
application_main_window_select_conversations_finish (ApplicationMainWindow* self,
                                                     GAsyncResult* _res_)
{
	ApplicationMainWindowSelectConversationsData* _data_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 9461 "application-main-window.c"
}

static void
application_main_window_select_conversations_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_)
{
	ApplicationMainWindowSelectConversationsData* _data_;
#line 1616 "../src/client/application/application-main-window.vala"
	_data_ = _user_data_;
#line 1616 "../src/client/application/application-main-window.vala"
	_data_->_source_object_ = source_object;
#line 1616 "../src/client/application/application-main-window.vala"
	_data_->_res_ = _res_;
#line 1616 "../src/client/application/application-main-window.vala"
	application_main_window_select_conversations_co (_data_);
#line 9478 "application-main-window.c"
}

static gboolean
application_main_window_select_conversations_co (ApplicationMainWindowSelectConversationsData* _data_)
{
#line 1579 "../src/client/application/application-main-window.vala"
	switch (_data_->_state_) {
#line 1579 "../src/client/application/application-main-window.vala"
		case 0:
#line 9488 "application-main-window.c"
		goto _state_0;
#line 1579 "../src/client/application/application-main-window.vala"
		case 1:
#line 9492 "application-main-window.c"
		goto _state_1;
		default:
#line 1579 "../src/client/application/application-main-window.vala"
		g_assert_not_reached ();
#line 9497 "application-main-window.c"
	}
	_state_0:
#line 1582 "../src/client/application/application-main-window.vala"
	if (_data_->self->priv->previous_selection_was_interactive) {
#line 1583 "../src/client/application/application-main-window.vala"
		_data_->_tmp0_ = _data_->is_interactive;
#line 9504 "application-main-window.c"
	} else {
#line 1583 "../src/client/application/application-main-window.vala"
		_data_->_tmp0_ = FALSE;
#line 9508 "application-main-window.c"
	}
#line 1582 "../src/client/application/application-main-window.vala"
	_data_->start_mark_timer = _data_->_tmp0_;
#line 1585 "../src/client/application/application-main-window.vala"
	_data_->self->priv->previous_selection_was_interactive = _data_->is_interactive;
#line 1591 "../src/client/application/application-main-window.vala"
	_data_->_tmp1_ = _data_->self->priv->_conversation_list_view;
#line 1591 "../src/client/application/application-main-window.vala"
	conversation_list_view_select_conversations (_data_->_tmp1_, _data_->to_select);
#line 1593 "../src/client/application/application-main-window.vala"
	_data_->_tmp2_ = _data_->self->priv->conversation_list_actions;
#line 1593 "../src/client/application/application-main-window.vala"
	_data_->_tmp3_ = gee_collection_get_size (_data_->to_select);
#line 1593 "../src/client/application/application-main-window.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 1593 "../src/client/application/application-main-window.vala"
	components_conversation_actions_set_selected_conversations (_data_->_tmp2_, _data_->_tmp4_);
#line 1594 "../src/client/application/application-main-window.vala"
	_data_->_tmp5_ = _data_->self->conversation_headerbar;
#line 1594 "../src/client/application/application-main-window.vala"
	_data_->_tmp6_ = _data_->_tmp5_->full_actions;
#line 1594 "../src/client/application/application-main-window.vala"
	_data_->_tmp7_ = gee_collection_get_size (_data_->to_select);
#line 1594 "../src/client/application/application-main-window.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 1594 "../src/client/application/application-main-window.vala"
	components_conversation_actions_set_selected_conversations (_data_->_tmp6_, _data_->_tmp8_);
#line 1595 "../src/client/application/application-main-window.vala"
	_data_->_tmp9_ = _data_->self->conversation_headerbar;
#line 1595 "../src/client/application/application-main-window.vala"
	_data_->_tmp10_ = _data_->_tmp9_->compact_actions;
#line 1595 "../src/client/application/application-main-window.vala"
	_data_->_tmp11_ = gee_collection_get_size (_data_->to_select);
#line 1595 "../src/client/application/application-main-window.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 1595 "../src/client/application/application-main-window.vala"
	components_conversation_actions_set_selected_conversations (_data_->_tmp10_, _data_->_tmp12_);
#line 1597 "../src/client/application/application-main-window.vala"
	_data_->_tmp14_ = _data_->self->priv->_selected_folder;
#line 1597 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp14_ != NULL) {
#line 1597 "../src/client/application/application-main-window.vala"
		_data_->_tmp15_ = application_main_window_get_has_composer (_data_->self);
#line 1597 "../src/client/application/application-main-window.vala"
		_data_->_tmp16_ = _data_->_tmp15_;
#line 1597 "../src/client/application/application-main-window.vala"
		_data_->_tmp13_ = !_data_->_tmp16_;
#line 9556 "application-main-window.c"
	} else {
#line 1597 "../src/client/application/application-main-window.vala"
		_data_->_tmp13_ = FALSE;
#line 9560 "application-main-window.c"
	}
#line 1597 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp13_) {
#line 1598 "../src/client/application/application-main-window.vala"
		_data_->_tmp17_ = gee_collection_get_size (_data_->to_select);
#line 1598 "../src/client/application/application-main-window.vala"
		_data_->_tmp18_ = _data_->_tmp17_;
#line 1598 "../src/client/application/application-main-window.vala"
		switch (_data_->_tmp18_) {
#line 1598 "../src/client/application/application-main-window.vala"
			case 0:
#line 9572 "application-main-window.c"
			{
#line 1600 "../src/client/application/application-main-window.vala"
				application_main_window_update_conversation_actions (_data_->self, APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_NONE);
#line 1601 "../src/client/application/application-main-window.vala"
				_data_->_tmp19_ = _data_->self->priv->_conversation_viewer;
#line 1601 "../src/client/application/application-main-window.vala"
				conversation_viewer_show_none_selected (_data_->_tmp19_);
#line 1602 "../src/client/application/application-main-window.vala"
				break;
#line 9582 "application-main-window.c"
			}
#line 1598 "../src/client/application/application-main-window.vala"
			case 1:
#line 9586 "application-main-window.c"
			{
#line 1605 "../src/client/application/application-main-window.vala"
				application_main_window_update_conversation_actions (_data_->self, APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_SINGLE);
#line 1606 "../src/client/application/application-main-window.vala"
				_data_->_tmp20_ = geary_collection_first (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _data_->to_select);
#line 1606 "../src/client/application/application-main-window.vala"
				_data_->convo = (GearyAppConversation*) _data_->_tmp20_;
#line 1613 "../src/client/application/application-main-window.vala"
				_data_->_tmp21_ = application_main_window_get_selected_account_context (_data_->self);
#line 1613 "../src/client/application/application-main-window.vala"
				_data_->context = _data_->_tmp21_;
#line 1614 "../src/client/application/application-main-window.vala"
				_data_->_tmp23_ = _data_->context;
#line 1614 "../src/client/application/application-main-window.vala"
				if (_data_->_tmp23_ != NULL) {
#line 1614 "../src/client/application/application-main-window.vala"
					_data_->_tmp24_ = _data_->convo;
#line 1614 "../src/client/application/application-main-window.vala"
					_data_->_tmp22_ = geary_app_conversation_get_count (_data_->_tmp24_) > 0;
#line 9606 "application-main-window.c"
				} else {
#line 1614 "../src/client/application/application-main-window.vala"
					_data_->_tmp22_ = FALSE;
#line 9610 "application-main-window.c"
				}
#line 1614 "../src/client/application/application-main-window.vala"
				if (_data_->_tmp22_) {
#line 9614 "application-main-window.c"
					{
#line 1616 "../src/client/application/application-main-window.vala"
						_data_->_tmp25_ = _data_->self->priv->_conversation_viewer;
#line 1616 "../src/client/application/application-main-window.vala"
						_data_->_tmp26_ = _data_->convo;
#line 1616 "../src/client/application/application-main-window.vala"
						_data_->_tmp27_ = _data_->context;
#line 1616 "../src/client/application/application-main-window.vala"
						_data_->_tmp28_ = application_account_context_get_emails (_data_->_tmp27_);
#line 1616 "../src/client/application/application-main-window.vala"
						_data_->_tmp29_ = _data_->_tmp28_;
#line 1616 "../src/client/application/application-main-window.vala"
						_data_->_tmp30_ = _data_->context;
#line 1616 "../src/client/application/application-main-window.vala"
						_data_->_tmp31_ = application_account_context_get_contacts (_data_->_tmp30_);
#line 1616 "../src/client/application/application-main-window.vala"
						_data_->_tmp32_ = _data_->_tmp31_;
#line 1616 "../src/client/application/application-main-window.vala"
						_data_->_state_ = 1;
#line 1616 "../src/client/application/application-main-window.vala"
						conversation_viewer_load_conversation (_data_->_tmp25_, _data_->_tmp26_, _data_->scroll_to, _data_->_tmp29_, _data_->_tmp32_, _data_->start_mark_timer, application_main_window_select_conversations_ready, _data_);
#line 1616 "../src/client/application/application-main-window.vala"
						return FALSE;
#line 9638 "application-main-window.c"
						_state_1:
#line 1616 "../src/client/application/application-main-window.vala"
						conversation_viewer_load_conversation_finish (_data_->_tmp25_, _data_->_res_, &_data_->_inner_error0_);
#line 1616 "../src/client/application/application-main-window.vala"
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1616 "../src/client/application/application-main-window.vala"
							if (g_error_matches (_data_->_inner_error0_, GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_NOT_FOUND)) {
#line 9646 "application-main-window.c"
								goto __catch0_geary_engine_error_not_found;
							}
#line 1616 "../src/client/application/application-main-window.vala"
							if (g_error_matches (_data_->_inner_error0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 9651 "application-main-window.c"
								goto __catch0_g_io_error_cancelled;
							}
							goto __catch0_g_error;
						}
					}
					goto __finally0;
					__catch0_geary_engine_error_not_found:
					{
#line 1615 "../src/client/application/application-main-window.vala"
						_data_->err = _data_->_inner_error0_;
#line 1615 "../src/client/application/application-main-window.vala"
						_data_->_inner_error0_ = NULL;
#line 1631 "../src/client/application/application-main-window.vala"
						_data_->_tmp33_ = _data_->err;
#line 1631 "../src/client/application/application-main-window.vala"
						_data_->_tmp34_ = _data_->_tmp33_->message;
#line 1631 "../src/client/application/application-main-window.vala"
						g_debug ("application-main-window.vala:1631: Ignoring not found error: %s", _data_->_tmp34_);
#line 1615 "../src/client/application/application-main-window.vala"
						_g_error_free0 (_data_->err);
#line 9672 "application-main-window.c"
					}
					goto __finally0;
					__catch0_g_io_error_cancelled:
					{
#line 1615 "../src/client/application/application-main-window.vala"
						g_clear_error (&_data_->_inner_error0_);
#line 9679 "application-main-window.c"
					}
					goto __finally0;
					__catch0_g_error:
					{
#line 1615 "../src/client/application/application-main-window.vala"
						_data_->_vala1_err = _data_->_inner_error0_;
#line 1615 "../src/client/application/application-main-window.vala"
						_data_->_inner_error0_ = NULL;
#line 1635 "../src/client/application/application-main-window.vala"
						_data_->_tmp35_ = _data_->convo;
#line 1635 "../src/client/application/application-main-window.vala"
						_data_->_tmp36_ = geary_app_conversation_get_base_folder (_data_->_tmp35_);
#line 1635 "../src/client/application/application-main-window.vala"
						_data_->_tmp37_ = _data_->_tmp36_;
#line 1635 "../src/client/application/application-main-window.vala"
						_data_->_tmp38_ = geary_folder_get_account (_data_->_tmp37_);
#line 1635 "../src/client/application/application-main-window.vala"
						_data_->_tmp39_ = _data_->_tmp38_;
#line 1635 "../src/client/application/application-main-window.vala"
						_data_->_tmp40_ = geary_account_get_information (_data_->_tmp39_);
#line 1635 "../src/client/application/application-main-window.vala"
						_data_->_tmp41_ = _data_->_tmp40_;
#line 1635 "../src/client/application/application-main-window.vala"
						_data_->_tmp42_ = _data_->_vala1_err;
#line 1635 "../src/client/application/application-main-window.vala"
						application_main_window_handle_error (_data_->self, _data_->_tmp41_, _data_->_tmp42_);
#line 1615 "../src/client/application/application-main-window.vala"
						_g_error_free0 (_data_->_vala1_err);
#line 9708 "application-main-window.c"
					}
					__finally0:
#line 1615 "../src/client/application/application-main-window.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1615 "../src/client/application/application-main-window.vala"
						_g_object_unref0 (_data_->context);
#line 1615 "../src/client/application/application-main-window.vala"
						_g_object_unref0 (_data_->convo);
#line 1615 "../src/client/application/application-main-window.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 1615 "../src/client/application/application-main-window.vala"
						g_clear_error (&_data_->_inner_error0_);
#line 1615 "../src/client/application/application-main-window.vala"
						g_object_unref (_data_->_async_result);
#line 1615 "../src/client/application/application-main-window.vala"
						return FALSE;
#line 9725 "application-main-window.c"
					}
				}
#line 1638 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->context);
#line 1638 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->convo);
#line 1638 "../src/client/application/application-main-window.vala"
				break;
#line 9734 "application-main-window.c"
			}
			default:
			{
#line 1641 "../src/client/application/application-main-window.vala"
				application_main_window_update_conversation_actions (_data_->self, APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_MULTIPLE);
#line 1642 "../src/client/application/application-main-window.vala"
				_data_->_tmp43_ = _data_->self->priv->_conversation_viewer;
#line 1642 "../src/client/application/application-main-window.vala"
				conversation_viewer_show_multiple_selected (_data_->_tmp43_);
#line 1643 "../src/client/application/application-main-window.vala"
				break;
#line 9746 "application-main-window.c"
			}
		}
	}
#line 1579 "../src/client/application/application-main-window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1579 "../src/client/application/application-main-window.vala"
	if (_data_->_state_ != 0) {
#line 1579 "../src/client/application/application-main-window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1579 "../src/client/application/application-main-window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 9758 "application-main-window.c"
		}
	}
#line 1579 "../src/client/application/application-main-window.vala"
	g_object_unref (_data_->_async_result);
#line 1579 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 9765 "application-main-window.c"
}

static void
application_main_window_open_conversation_monitor_data_free (gpointer _data)
{
	ApplicationMainWindowOpenConversationMonitorData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/application-main-window.vala"
	g_slice_free (ApplicationMainWindowOpenConversationMonitorData, _data_);
#line 9779 "application-main-window.c"
}

static void
application_main_window_open_conversation_monitor (ApplicationMainWindow* self,
                                                   GearyAppConversationMonitor* to_open,
                                                   GCancellable* cancellable,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_)
{
	ApplicationMainWindowOpenConversationMonitorData* _data_;
	ApplicationMainWindow* _tmp0_;
	GearyAppConversationMonitor* _tmp1_;
	GCancellable* _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (to_open, GEARY_APP_TYPE_CONVERSATION_MONITOR));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_slice_new0 (ApplicationMainWindowOpenConversationMonitorData);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 10 "../src/client/application/application-main-window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_main_window_open_conversation_monitor_data_free);
#line 10 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (to_open);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_open);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->to_open = _tmp1_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->cancellable = _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_open_conversation_monitor_co (_data_);
#line 9823 "application-main-window.c"
}

static void
application_main_window_open_conversation_monitor_finish (ApplicationMainWindow* self,
                                                          GAsyncResult* _res_)
{
	ApplicationMainWindowOpenConversationMonitorData* _data_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 10 "../src/client/application/application-main-window.vala"
	if (NULL == _data_) {
#line 10 "../src/client/application/application-main-window.vala"
		return;
#line 9837 "application-main-window.c"
	}
}

static Block18Data*
block18_data_ref (Block18Data* _data18_)
{
#line 1648 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data18_->_ref_count_);
#line 1648 "../src/client/application/application-main-window.vala"
	return _data18_;
#line 9848 "application-main-window.c"
}

static void
block18_data_unref (void * _userdata_)
{
	Block18Data* _data18_;
	_data18_ = (Block18Data*) _userdata_;
#line 1648 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data18_->_ref_count_)) {
#line 9858 "application-main-window.c"
		ApplicationMainWindow* self;
#line 1648 "../src/client/application/application-main-window.vala"
		self = _data18_->self;
#line 1648 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data18_->to_open);
#line 1648 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 1648 "../src/client/application/application-main-window.vala"
		g_slice_free (Block18Data, _data18_);
#line 9868 "application-main-window.c"
	}
}

static void
_application_main_window_on_scan_completed_geary_app_conversation_monitor_scan_completed (GearyAppConversationMonitor* _sender,
                                                                                          gpointer self)
{
#line 1650 "../src/client/application/application-main-window.vala"
	application_main_window_on_scan_completed ((ApplicationMainWindow*) self, _sender);
#line 9878 "application-main-window.c"
}

static void
_application_main_window_on_scan_error_geary_app_conversation_monitor_scan_error (GearyAppConversationMonitor* _sender,
                                                                                  GError* err,
                                                                                  gpointer self)
{
#line 1651 "../src/client/application/application-main-window.vala"
	application_main_window_on_scan_error ((ApplicationMainWindow*) self, _sender, err);
#line 9888 "application-main-window.c"
}

static void
_application_main_window_on_conversation_count_changed_geary_app_conversation_monitor_scan_completed (GearyAppConversationMonitor* _sender,
                                                                                                      gpointer self)
{
#line 1653 "../src/client/application/application-main-window.vala"
	application_main_window_on_conversation_count_changed ((ApplicationMainWindow*) self);
#line 9897 "application-main-window.c"
}

static void
_application_main_window_on_conversation_count_changed_geary_app_conversation_monitor_conversations_added (GearyAppConversationMonitor* _sender,
                                                                                                           GeeCollection* conversations,
                                                                                                           gpointer self)
{
#line 1654 "../src/client/application/application-main-window.vala"
	application_main_window_on_conversation_count_changed ((ApplicationMainWindow*) self);
#line 9907 "application-main-window.c"
}

static void
_application_main_window_on_conversation_count_changed_geary_app_conversation_monitor_conversations_removed (GearyAppConversationMonitor* _sender,
                                                                                                             GeeCollection* conversations,
                                                                                                             gpointer self)
{
#line 1655 "../src/client/application/application-main-window.vala"
	application_main_window_on_conversation_count_changed ((ApplicationMainWindow*) self);
#line 9917 "application-main-window.c"
}

static void
__lambda141_ (Block18Data* _data18_,
              GObject* obj,
              GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 1660 "../src/client/application/application-main-window.vala"
	self = _data18_->self;
#line 1660 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 1660 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 9933 "application-main-window.c"
	{
#line 1662 "../src/client/application/application-main-window.vala"
		geary_app_conversation_monitor_start_monitoring_finish (_data18_->to_open, res, &_inner_error0_);
#line 1662 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9939 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolder* _tmp0_;
		GearyFolder* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 1661 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 1661 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 1664 "../src/client/application/application-main-window.vala"
		_tmp0_ = geary_app_conversation_monitor_get_base_folder (_data18_->to_open);
#line 1664 "../src/client/application/application-main-window.vala"
		_tmp1_ = _tmp0_;
#line 1664 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (_tmp1_);
#line 1664 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 1664 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 1664 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 1664 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 1664 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 1661 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 9976 "application-main-window.c"
	}
	__finally0:
#line 1661 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1661 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1661 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 1661 "../src/client/application/application-main-window.vala"
		return;
#line 9987 "application-main-window.c"
	}
}

static void
___lambda141__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 1657 "../src/client/application/application-main-window.vala"
	__lambda141_ (self, source_object, res);
#line 1657 "../src/client/application/application-main-window.vala"
	block18_data_unref (self);
#line 10000 "application-main-window.c"
}

static gboolean
application_main_window_open_conversation_monitor_co (ApplicationMainWindowOpenConversationMonitorData* _data_)
{
#line 1648 "../src/client/application/application-main-window.vala"
	switch (_data_->_state_) {
#line 1648 "../src/client/application/application-main-window.vala"
		case 0:
#line 10010 "application-main-window.c"
		goto _state_0;
		default:
#line 1648 "../src/client/application/application-main-window.vala"
		g_assert_not_reached ();
#line 10015 "application-main-window.c"
	}
	_state_0:
#line 1648 "../src/client/application/application-main-window.vala"
	_data_->_data18_ = g_slice_new0 (Block18Data);
#line 1648 "../src/client/application/application-main-window.vala"
	_data_->_data18_->_ref_count_ = 1;
#line 1648 "../src/client/application/application-main-window.vala"
	_data_->_data18_->self = g_object_ref (_data_->self);
#line 1648 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->_data18_->to_open);
#line 1648 "../src/client/application/application-main-window.vala"
	_data_->_data18_->to_open = _data_->to_open;
#line 1648 "../src/client/application/application-main-window.vala"
	_data_->_data18_->_async_data_ = _data_;
#line 1650 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_data_->_data18_->to_open, "scan-completed", (GCallback) _application_main_window_on_scan_completed_geary_app_conversation_monitor_scan_completed, _data_->self, 0);
#line 1651 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_data_->_data18_->to_open, "scan-error", (GCallback) _application_main_window_on_scan_error_geary_app_conversation_monitor_scan_error, _data_->self, 0);
#line 1653 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_data_->_data18_->to_open, "scan-completed", (GCallback) _application_main_window_on_conversation_count_changed_geary_app_conversation_monitor_scan_completed, _data_->self, 0);
#line 1654 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_data_->_data18_->to_open, "conversations-added", (GCallback) _application_main_window_on_conversation_count_changed_geary_app_conversation_monitor_conversations_added, _data_->self, 0);
#line 1655 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_data_->_data18_->to_open, "conversations-removed", (GCallback) _application_main_window_on_conversation_count_changed_geary_app_conversation_monitor_conversations_removed, _data_->self, 0);
#line 1657 "../src/client/application/application-main-window.vala"
	geary_app_conversation_monitor_start_monitoring (_data_->_data18_->to_open, GEARY_FOLDER_OPEN_FLAGS_NO_DELAY, _data_->cancellable, ___lambda141__gasync_ready_callback, block18_data_ref (_data_->_data18_));
#line 1648 "../src/client/application/application-main-window.vala"
	block18_data_unref (_data_->_data18_);
#line 1648 "../src/client/application/application-main-window.vala"
	_data_->_data18_ = NULL;
#line 1648 "../src/client/application/application-main-window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1648 "../src/client/application/application-main-window.vala"
	if (_data_->_state_ != 0) {
#line 1648 "../src/client/application/application-main-window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1648 "../src/client/application/application-main-window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 10054 "application-main-window.c"
		}
	}
#line 1648 "../src/client/application/application-main-window.vala"
	g_object_unref (_data_->_async_result);
#line 1648 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 10061 "application-main-window.c"
}

static Block19Data*
block19_data_ref (Block19Data* _data19_)
{
#line 1670 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data19_->_ref_count_);
#line 1670 "../src/client/application/application-main-window.vala"
	return _data19_;
#line 10071 "application-main-window.c"
}

static void
block19_data_unref (void * _userdata_)
{
	Block19Data* _data19_;
	_data19_ = (Block19Data*) _userdata_;
#line 1670 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data19_->_ref_count_)) {
#line 10081 "application-main-window.c"
		ApplicationMainWindow* self;
#line 1670 "../src/client/application/application-main-window.vala"
		self = _data19_->self;
#line 1670 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data19_->to_close);
#line 1670 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 1670 "../src/client/application/application-main-window.vala"
		g_slice_free (Block19Data, _data19_);
#line 10091 "application-main-window.c"
	}
}

static void
__lambda140_ (Block19Data* _data19_,
              GObject* obj,
              GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 1680 "../src/client/application/application-main-window.vala"
	self = _data19_->self;
#line 1680 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 1680 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 10108 "application-main-window.c"
	{
#line 1682 "../src/client/application/application-main-window.vala"
		geary_app_conversation_monitor_stop_monitoring_finish (_data19_->to_close, res, &_inner_error0_);
#line 1682 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10114 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolder* _tmp0_;
		GearyFolder* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 1681 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 1681 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 1684 "../src/client/application/application-main-window.vala"
		_tmp0_ = geary_app_conversation_monitor_get_base_folder (_data19_->to_close);
#line 1684 "../src/client/application/application-main-window.vala"
		_tmp1_ = _tmp0_;
#line 1684 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 1684 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 1684 "../src/client/application/application-main-window.vala"
		_tmp4_ = err;
#line 1684 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_->message;
#line 1684 "../src/client/application/application-main-window.vala"
		g_warning ("application-main-window.vala:1684: Error closing conversation monitor " \
"%s: %s", _tmp3_, _tmp5_);
#line 1684 "../src/client/application/application-main-window.vala"
		_g_free0 (_tmp3_);
#line 1681 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 10150 "application-main-window.c"
	}
	__finally0:
#line 1681 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1681 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1681 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 1681 "../src/client/application/application-main-window.vala"
		return;
#line 10161 "application-main-window.c"
	}
}

static void
___lambda140__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 1678 "../src/client/application/application-main-window.vala"
	__lambda140_ (self, source_object, res);
#line 1678 "../src/client/application/application-main-window.vala"
	block19_data_unref (self);
#line 10174 "application-main-window.c"
}

static void
application_main_window_close_conversation_monitor (ApplicationMainWindow* self,
                                                    GearyAppConversationMonitor* to_close)
{
	Block19Data* _data19_;
	GearyAppConversationMonitor* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
#line 1670 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1670 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (to_close, GEARY_APP_TYPE_CONVERSATION_MONITOR));
#line 1670 "../src/client/application/application-main-window.vala"
	_data19_ = g_slice_new0 (Block19Data);
#line 1670 "../src/client/application/application-main-window.vala"
	_data19_->_ref_count_ = 1;
#line 1670 "../src/client/application/application-main-window.vala"
	_data19_->self = g_object_ref (self);
#line 1670 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (to_close);
#line 1670 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data19_->to_close);
#line 1670 "../src/client/application/application-main-window.vala"
	_data19_->to_close = _tmp0_;
#line 1671 "../src/client/application/application-main-window.vala"
	g_signal_parse_name ("scan-completed", GEARY_APP_TYPE_CONVERSATION_MONITOR, &_tmp1_, NULL, FALSE);
#line 1671 "../src/client/application/application-main-window.vala"
	g_signal_handlers_disconnect_matched (_data19_->to_close, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _application_main_window_on_scan_completed_geary_app_conversation_monitor_scan_completed, self);
#line 1672 "../src/client/application/application-main-window.vala"
	g_signal_parse_name ("scan-error", GEARY_APP_TYPE_CONVERSATION_MONITOR, &_tmp2_, NULL, FALSE);
#line 1672 "../src/client/application/application-main-window.vala"
	g_signal_handlers_disconnect_matched (_data19_->to_close, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _application_main_window_on_scan_error_geary_app_conversation_monitor_scan_error, self);
#line 1674 "../src/client/application/application-main-window.vala"
	g_signal_parse_name ("scan-completed", GEARY_APP_TYPE_CONVERSATION_MONITOR, &_tmp3_, NULL, FALSE);
#line 1674 "../src/client/application/application-main-window.vala"
	g_signal_handlers_disconnect_matched (_data19_->to_close, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _application_main_window_on_conversation_count_changed_geary_app_conversation_monitor_scan_completed, self);
#line 1675 "../src/client/application/application-main-window.vala"
	g_signal_parse_name ("conversations-added", GEARY_APP_TYPE_CONVERSATION_MONITOR, &_tmp4_, NULL, FALSE);
#line 1675 "../src/client/application/application-main-window.vala"
	g_signal_handlers_disconnect_matched (_data19_->to_close, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _application_main_window_on_conversation_count_changed_geary_app_conversation_monitor_conversations_added, self);
#line 1676 "../src/client/application/application-main-window.vala"
	g_signal_parse_name ("conversations-removed", GEARY_APP_TYPE_CONVERSATION_MONITOR, &_tmp5_, NULL, FALSE);
#line 1676 "../src/client/application/application-main-window.vala"
	g_signal_handlers_disconnect_matched (_data19_->to_close, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _application_main_window_on_conversation_count_changed_geary_app_conversation_monitor_conversations_removed, self);
#line 1678 "../src/client/application/application-main-window.vala"
	geary_app_conversation_monitor_stop_monitoring (_data19_->to_close, NULL, ___lambda140__gasync_ready_callback, block19_data_ref (_data19_));
#line 1670 "../src/client/application/application-main-window.vala"
	block19_data_unref (_data19_);
#line 1670 "../src/client/application/application-main-window.vala"
	_data19_ = NULL;
#line 10230 "application-main-window.c"
}

static void
application_main_window_create_composer_data_free (gpointer _data)
{
	ApplicationMainWindowCreateComposerData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->send_context);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->context);
#line 10 "../src/client/application/application-main-window.vala"
	_g_free0 (_data_->quote);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/application-main-window.vala"
	g_slice_free (ApplicationMainWindowCreateComposerData, _data_);
#line 10248 "application-main-window.c"
}

static void
application_main_window_create_composer (ApplicationMainWindow* self,
                                         GearyAccount* send_context,
                                         ComposerWidgetContextType type,
                                         GearyEmail* context,
                                         const gchar* quote,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	ApplicationMainWindowCreateComposerData* _data_;
	ApplicationMainWindow* _tmp0_;
	GearyAccount* _tmp1_;
	GearyEmail* _tmp2_;
	gchar* _tmp3_;
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (send_context, GEARY_TYPE_ACCOUNT));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (context, GEARY_TYPE_EMAIL));
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_slice_new0 (ApplicationMainWindowCreateComposerData);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 10 "../src/client/application/application-main-window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_main_window_create_composer_data_free);
#line 10 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (send_context);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->send_context);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->send_context = _tmp1_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_->type = type;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp2_ = _g_object_ref0 (context);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->context);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->context = _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp3_ = g_strdup (quote);
#line 10 "../src/client/application/application-main-window.vala"
	_g_free0 (_data_->quote);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->quote = _tmp3_;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_create_composer_co (_data_);
#line 10303 "application-main-window.c"
}

static void
application_main_window_create_composer_finish (ApplicationMainWindow* self,
                                                GAsyncResult* _res_)
{
	ApplicationMainWindowCreateComposerData* _data_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 10313 "application-main-window.c"
}

static void
application_main_window_create_composer_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_)
{
	ApplicationMainWindowCreateComposerData* _data_;
#line 1698 "../src/client/application/application-main-window.vala"
	_data_ = _user_data_;
#line 1698 "../src/client/application/application-main-window.vala"
	_data_->_source_object_ = source_object;
#line 1698 "../src/client/application/application-main-window.vala"
	_data_->_res_ = _res_;
#line 1698 "../src/client/application/application-main-window.vala"
	application_main_window_create_composer_co (_data_);
#line 10330 "application-main-window.c"
}

static gboolean
application_main_window_create_composer_co (ApplicationMainWindowCreateComposerData* _data_)
{
#line 1694 "../src/client/application/application-main-window.vala"
	switch (_data_->_state_) {
#line 1694 "../src/client/application/application-main-window.vala"
		case 0:
#line 10340 "application-main-window.c"
		goto _state_0;
#line 1694 "../src/client/application/application-main-window.vala"
		case 1:
#line 10344 "application-main-window.c"
		goto _state_1;
		default:
#line 1694 "../src/client/application/application-main-window.vala"
		g_assert_not_reached ();
#line 10349 "application-main-window.c"
	}
	_state_0:
#line 1702 "../src/client/application/application-main-window.vala"
	_data_->_tmp0_ = _data_->quote;
#line 1702 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp0_ == NULL) {
#line 1702 "../src/client/application/application-main-window.vala"
		_data_->_tmp0_ = "";
#line 10358 "application-main-window.c"
	}
#line 1698 "../src/client/application/application-main-window.vala"
	_data_->_tmp1_ = _data_->self->priv->controller;
#line 1698 "../src/client/application/application-main-window.vala"
	_data_->_tmp2_ = _data_->self->priv->controller;
#line 1698 "../src/client/application/application-main-window.vala"
	_data_->_tmp3_ = geary_account_get_information (_data_->send_context);
#line 1698 "../src/client/application/application-main-window.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 1698 "../src/client/application/application-main-window.vala"
	_data_->_tmp5_ = application_account_interface_get_context_for_account (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface), _data_->_tmp4_);
#line 1698 "../src/client/application/application-main-window.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 1698 "../src/client/application/application-main-window.vala"
	_data_->_state_ = 1;
#line 1698 "../src/client/application/application-main-window.vala"
	application_controller_compose_with_context (_data_->_tmp1_, _data_->_tmp6_, _data_->type, _data_->context, _data_->_tmp0_, application_main_window_create_composer_ready, _data_);
#line 1698 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 10378 "application-main-window.c"
	_state_1:
#line 1698 "../src/client/application/application-main-window.vala"
	_data_->_tmp7_ = application_controller_compose_with_context_finish (_data_->_tmp1_, _data_->_res_);
#line 1698 "../src/client/application/application-main-window.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 1698 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->_tmp6_);
#line 1698 "../src/client/application/application-main-window.vala"
	_data_->composer = _data_->_tmp8_;
#line 1704 "../src/client/application/application-main-window.vala"
	_data_->_tmp9_ = _data_->self->priv->controller;
#line 1704 "../src/client/application/application-main-window.vala"
	application_controller_present_composer (_data_->_tmp9_, _data_->composer);
#line 1694 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->composer);
#line 1694 "../src/client/application/application-main-window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1694 "../src/client/application/application-main-window.vala"
	if (_data_->_state_ != 0) {
#line 1694 "../src/client/application/application-main-window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1694 "../src/client/application/application-main-window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 10402 "application-main-window.c"
		}
	}
#line 1694 "../src/client/application/application-main-window.vala"
	g_object_unref (_data_->_async_result);
#line 1694 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 10409 "application-main-window.c"
}

static void
application_main_window_create_composer_from_viewer_data_free (gpointer _data)
{
	ApplicationMainWindowCreateComposerFromViewerData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/application-main-window.vala"
	g_slice_free (ApplicationMainWindowCreateComposerFromViewerData, _data_);
#line 10421 "application-main-window.c"
}

static void
application_main_window_create_composer_from_viewer (ApplicationMainWindow* self,
                                                     ComposerWidgetContextType type,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	ApplicationMainWindowCreateComposerFromViewerData* _data_;
	ApplicationMainWindow* _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_slice_new0 (ApplicationMainWindowCreateComposerFromViewerData);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 10 "../src/client/application/application-main-window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_main_window_create_composer_from_viewer_data_free);
#line 10 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_->type = type;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_create_composer_from_viewer_co (_data_);
#line 10448 "application-main-window.c"
}

static void
application_main_window_create_composer_from_viewer_finish (ApplicationMainWindow* self,
                                                            GAsyncResult* _res_)
{
	ApplicationMainWindowCreateComposerFromViewerData* _data_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 10458 "application-main-window.c"
}

static void
application_main_window_create_composer_from_viewer_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_)
{
	ApplicationMainWindowCreateComposerFromViewerData* _data_;
#line 1715 "../src/client/application/application-main-window.vala"
	_data_ = _user_data_;
#line 1715 "../src/client/application/application-main-window.vala"
	_data_->_source_object_ = source_object;
#line 1715 "../src/client/application/application-main-window.vala"
	_data_->_res_ = _res_;
#line 1715 "../src/client/application/application-main-window.vala"
	application_main_window_create_composer_from_viewer_co (_data_);
#line 10475 "application-main-window.c"
}

static gboolean
application_main_window_create_composer_from_viewer_co (ApplicationMainWindowCreateComposerFromViewerData* _data_)
{
#line 1707 "../src/client/application/application-main-window.vala"
	switch (_data_->_state_) {
#line 1707 "../src/client/application/application-main-window.vala"
		case 0:
#line 10485 "application-main-window.c"
		goto _state_0;
#line 1707 "../src/client/application/application-main-window.vala"
		case 1:
#line 10489 "application-main-window.c"
		goto _state_1;
#line 1707 "../src/client/application/application-main-window.vala"
		case 2:
#line 10493 "application-main-window.c"
		goto _state_2;
		default:
#line 1707 "../src/client/application/application-main-window.vala"
		g_assert_not_reached ();
#line 10498 "application-main-window.c"
	}
	_state_0:
#line 1708 "../src/client/application/application-main-window.vala"
	_data_->_tmp0_ = _data_->self->priv->_selected_account;
#line 1708 "../src/client/application/application-main-window.vala"
	_data_->_tmp1_ = _g_object_ref0 (_data_->_tmp0_);
#line 1708 "../src/client/application/application-main-window.vala"
	_data_->account = _data_->_tmp1_;
#line 1709 "../src/client/application/application-main-window.vala"
	_data_->email_view = NULL;
#line 1710 "../src/client/application/application-main-window.vala"
	_data_->_tmp2_ = _data_->self->priv->_conversation_viewer;
#line 1710 "../src/client/application/application-main-window.vala"
	_data_->_tmp3_ = conversation_viewer_get_current_list (_data_->_tmp2_);
#line 1710 "../src/client/application/application-main-window.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 1710 "../src/client/application/application-main-window.vala"
	_data_->_tmp5_ = _g_object_ref0 (_data_->_tmp4_);
#line 1710 "../src/client/application/application-main-window.vala"
	_data_->list_view = _data_->_tmp5_;
#line 1711 "../src/client/application/application-main-window.vala"
	_data_->_tmp6_ = _data_->list_view;
#line 1711 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp6_ != NULL) {
#line 1712 "../src/client/application/application-main-window.vala"
		_data_->_tmp7_ = _data_->list_view;
#line 1712 "../src/client/application/application-main-window.vala"
		_data_->_tmp8_ = conversation_list_box_get_reply_target (_data_->_tmp7_);
#line 1712 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data_->email_view);
#line 1712 "../src/client/application/application-main-window.vala"
		_data_->email_view = _data_->_tmp8_;
#line 10531 "application-main-window.c"
	}
#line 1714 "../src/client/application/application-main-window.vala"
	_data_->_tmp10_ = _data_->account;
#line 1714 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp10_ != NULL) {
#line 1714 "../src/client/application/application-main-window.vala"
		_data_->_tmp11_ = _data_->email_view;
#line 1714 "../src/client/application/application-main-window.vala"
		_data_->_tmp9_ = _data_->_tmp11_ != NULL;
#line 10541 "application-main-window.c"
	} else {
#line 1714 "../src/client/application/application-main-window.vala"
		_data_->_tmp9_ = FALSE;
#line 10545 "application-main-window.c"
	}
#line 1714 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp9_) {
#line 1715 "../src/client/application/application-main-window.vala"
		_data_->_tmp12_ = _data_->email_view;
#line 1715 "../src/client/application/application-main-window.vala"
		_data_->_state_ = 1;
#line 1715 "../src/client/application/application-main-window.vala"
		conversation_email_get_selection_for_quoting (_data_->_tmp12_, application_main_window_create_composer_from_viewer_ready, _data_);
#line 1715 "../src/client/application/application-main-window.vala"
		return FALSE;
#line 10557 "application-main-window.c"
		_state_1:
#line 1715 "../src/client/application/application-main-window.vala"
		_data_->_tmp13_ = conversation_email_get_selection_for_quoting_finish (_data_->_tmp12_, _data_->_res_);
#line 1715 "../src/client/application/application-main-window.vala"
		_data_->quote = _data_->_tmp13_;
#line 1716 "../src/client/application/application-main-window.vala"
		_data_->_tmp14_ = _data_->account;
#line 1716 "../src/client/application/application-main-window.vala"
		_data_->_tmp15_ = _data_->email_view;
#line 1716 "../src/client/application/application-main-window.vala"
		_data_->_tmp16_ = conversation_email_get_email (_data_->_tmp15_);
#line 1716 "../src/client/application/application-main-window.vala"
		_data_->_tmp17_ = _data_->_tmp16_;
#line 1716 "../src/client/application/application-main-window.vala"
		_data_->_tmp18_ = _data_->quote;
#line 1716 "../src/client/application/application-main-window.vala"
		_data_->_state_ = 2;
#line 1716 "../src/client/application/application-main-window.vala"
		application_main_window_create_composer (_data_->self, _data_->_tmp14_, _data_->type, _data_->_tmp17_, _data_->_tmp18_, application_main_window_create_composer_from_viewer_ready, _data_);
#line 1716 "../src/client/application/application-main-window.vala"
		return FALSE;
#line 10579 "application-main-window.c"
		_state_2:
#line 1716 "../src/client/application/application-main-window.vala"
		application_main_window_create_composer_finish (_data_->self, _data_->_res_);
#line 1714 "../src/client/application/application-main-window.vala"
		_g_free0 (_data_->quote);
#line 10585 "application-main-window.c"
	}
#line 1707 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->list_view);
#line 1707 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->email_view);
#line 1707 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->account);
#line 1707 "../src/client/application/application-main-window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1707 "../src/client/application/application-main-window.vala"
	if (_data_->_state_ != 0) {
#line 1707 "../src/client/application/application-main-window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1707 "../src/client/application/application-main-window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 10601 "application-main-window.c"
		}
	}
#line 1707 "../src/client/application/application-main-window.vala"
	g_object_unref (_data_->_async_result);
#line 1707 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 10608 "application-main-window.c"
}

static void
application_main_window_on_conversations_selected (ApplicationMainWindow* self,
                                                   GeeSet* selected)
{
	gboolean folded = FALSE;
	HdyLeaflet* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	gint _tmp4_;
	gint _tmp5_;
	ConversationListView* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
#line 1720 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1720 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (selected, GEE_TYPE_SET));
#line 1721 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->outer_leaflet;
#line 1721 "../src/client/application/application-main-window.vala"
	_tmp1_ = hdy_leaflet_get_folded (_tmp0_);
#line 1721 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 1721 "../src/client/application/application-main-window.vala"
	folded = _tmp2_;
#line 1723 "../src/client/application/application-main-window.vala"
	_tmp4_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (selected, GEE_TYPE_COLLECTION, GeeCollection));
#line 1723 "../src/client/application/application-main-window.vala"
	_tmp5_ = _tmp4_;
#line 1723 "../src/client/application/application-main-window.vala"
	if (_tmp5_ > 1) {
#line 1723 "../src/client/application/application-main-window.vala"
		_tmp3_ = TRUE;
#line 10645 "application-main-window.c"
	} else {
#line 1723 "../src/client/application/application-main-window.vala"
		_tmp3_ = !folded;
#line 10649 "application-main-window.c"
	}
#line 1723 "../src/client/application/application-main-window.vala"
	if (_tmp3_) {
#line 10653 "application-main-window.c"
		GeeCollection* _tmp6_;
		GeeCollection* _tmp7_;
#line 1724 "../src/client/application/application-main-window.vala"
		_tmp6_ = gee_collection_empty (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref);
#line 1724 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 1724 "../src/client/application/application-main-window.vala"
		application_main_window_select_conversations (self, G_TYPE_CHECK_INSTANCE_CAST (selected, GEE_TYPE_COLLECTION, GeeCollection), _tmp7_, TRUE, NULL, NULL);
#line 1724 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp7_);
#line 10664 "application-main-window.c"
	} else {
#line 1725 "../src/client/application/application-main-window.vala"
		if (folded) {
#line 10668 "application-main-window.c"
			gint _tmp8_;
			gint _tmp9_;
#line 1726 "../src/client/application/application-main-window.vala"
			_tmp8_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (selected, GEE_TYPE_COLLECTION, GeeCollection));
#line 1726 "../src/client/application/application-main-window.vala"
			_tmp9_ = _tmp8_;
#line 1726 "../src/client/application/application-main-window.vala"
			switch (_tmp9_) {
#line 1726 "../src/client/application/application-main-window.vala"
				case 0:
#line 10679 "application-main-window.c"
				{
#line 1728 "../src/client/application/application-main-window.vala"
					application_main_window_update_conversation_actions (self, APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_NONE);
#line 1729 "../src/client/application/application-main-window.vala"
					break;
#line 10685 "application-main-window.c"
				}
#line 1726 "../src/client/application/application-main-window.vala"
				case 1:
#line 10689 "application-main-window.c"
				{
#line 1731 "../src/client/application/application-main-window.vala"
					application_main_window_update_conversation_actions (self, APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_SINGLE);
#line 1732 "../src/client/application/application-main-window.vala"
					break;
#line 10695 "application-main-window.c"
				}
				default:
				{
#line 1734 "../src/client/application/application-main-window.vala"
					application_main_window_update_conversation_actions (self, APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_MULTIPLE);
#line 1735 "../src/client/application/application-main-window.vala"
					break;
#line 10703 "application-main-window.c"
				}
			}
		}
	}
#line 1739 "../src/client/application/application-main-window.vala"
	_tmp10_ = self->priv->_conversation_list_view;
#line 1739 "../src/client/application/application-main-window.vala"
	_tmp11_ = conversation_list_view_get_selection_mode_enabled (_tmp10_);
#line 1739 "../src/client/application/application-main-window.vala"
	_tmp12_ = _tmp11_;
#line 1739 "../src/client/application/application-main-window.vala"
	if (_tmp12_) {
#line 10716 "application-main-window.c"
		gint _tmp13_;
		gint _tmp14_;
#line 1740 "../src/client/application/application-main-window.vala"
		_tmp13_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (selected, GEE_TYPE_COLLECTION, GeeCollection));
#line 1740 "../src/client/application/application-main-window.vala"
		_tmp14_ = _tmp13_;
#line 1740 "../src/client/application/application-main-window.vala"
		if (_tmp14_ > 0) {
#line 10725 "application-main-window.c"
			GtkRevealer* _tmp15_;
#line 1741 "../src/client/application/application-main-window.vala"
			_tmp15_ = self->priv->conversation_list_actions_revealer;
#line 1741 "../src/client/application/application-main-window.vala"
			gtk_revealer_set_reveal_child (_tmp15_, folded);
#line 10731 "application-main-window.c"
		} else {
			GtkRevealer* _tmp16_;
#line 1743 "../src/client/application/application-main-window.vala"
			_tmp16_ = self->priv->conversation_list_actions_revealer;
#line 1743 "../src/client/application/application-main-window.vala"
			gtk_revealer_set_reveal_child (_tmp16_, FALSE);
#line 10738 "application-main-window.c"
		}
	}
}

static void
application_main_window_update_close_button_position (ApplicationMainWindow* self)
{
	gboolean at_end = FALSE;
	gboolean _tmp0_ = FALSE;
	HdyLeaflet* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	ComponentsApplicationHeaderBar* _tmp4_;
	gboolean _tmp5_ = FALSE;
	HdyLeaflet* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	ComponentsConversationListHeaderBar* _tmp13_;
	gboolean _tmp14_ = FALSE;
	HdyLeaflet* _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
	ComponentsConversationHeaderBar* _tmp18_;
#line 1748 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1749 "../src/client/application/application-main-window.vala"
	at_end = util_gtk_close_button_at_end ();
#line 1751 "../src/client/application/application-main-window.vala"
	_tmp1_ = self->priv->inner_leaflet;
#line 1751 "../src/client/application/application-main-window.vala"
	_tmp2_ = hdy_leaflet_get_folded (_tmp1_);
#line 1751 "../src/client/application/application-main-window.vala"
	_tmp3_ = _tmp2_;
#line 1751 "../src/client/application/application-main-window.vala"
	if (_tmp3_) {
#line 1752 "../src/client/application/application-main-window.vala"
		_tmp0_ = TRUE;
#line 10776 "application-main-window.c"
	} else {
#line 1752 "../src/client/application/application-main-window.vala"
		_tmp0_ = !at_end;
#line 10780 "application-main-window.c"
	}
#line 1751 "../src/client/application/application-main-window.vala"
	_tmp4_ = self->priv->application_headerbar;
#line 1751 "../src/client/application/application-main-window.vala"
	hdy_header_bar_set_show_close_button (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, hdy_header_bar_get_type (), HdyHeaderBar), _tmp0_);
#line 1754 "../src/client/application/application-main-window.vala"
	_tmp6_ = self->priv->inner_leaflet;
#line 1754 "../src/client/application/application-main-window.vala"
	_tmp7_ = hdy_leaflet_get_folded (_tmp6_);
#line 1754 "../src/client/application/application-main-window.vala"
	_tmp8_ = _tmp7_;
#line 1754 "../src/client/application/application-main-window.vala"
	if (_tmp8_) {
#line 1755 "../src/client/application/application-main-window.vala"
		_tmp5_ = TRUE;
#line 10796 "application-main-window.c"
	} else {
		gboolean _tmp9_ = FALSE;
#line 1755 "../src/client/application/application-main-window.vala"
		if (at_end) {
#line 10801 "application-main-window.c"
			HdyLeaflet* _tmp10_;
			gboolean _tmp11_;
			gboolean _tmp12_;
#line 1755 "../src/client/application/application-main-window.vala"
			_tmp10_ = self->priv->outer_leaflet;
#line 1755 "../src/client/application/application-main-window.vala"
			_tmp11_ = hdy_leaflet_get_folded (_tmp10_);
#line 1755 "../src/client/application/application-main-window.vala"
			_tmp12_ = _tmp11_;
#line 1755 "../src/client/application/application-main-window.vala"
			_tmp9_ = _tmp12_;
#line 10813 "application-main-window.c"
		} else {
#line 1755 "../src/client/application/application-main-window.vala"
			_tmp9_ = FALSE;
#line 10817 "application-main-window.c"
		}
#line 1755 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp9_;
#line 10821 "application-main-window.c"
	}
#line 1754 "../src/client/application/application-main-window.vala"
	_tmp13_ = self->priv->conversation_list_headerbar;
#line 1754 "../src/client/application/application-main-window.vala"
	hdy_header_bar_set_show_close_button (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, hdy_header_bar_get_type (), HdyHeaderBar), _tmp5_);
#line 1757 "../src/client/application/application-main-window.vala"
	_tmp15_ = self->priv->outer_leaflet;
#line 1757 "../src/client/application/application-main-window.vala"
	_tmp16_ = hdy_leaflet_get_folded (_tmp15_);
#line 1757 "../src/client/application/application-main-window.vala"
	_tmp17_ = _tmp16_;
#line 1757 "../src/client/application/application-main-window.vala"
	if (_tmp17_) {
#line 1758 "../src/client/application/application-main-window.vala"
		_tmp14_ = TRUE;
#line 10837 "application-main-window.c"
	} else {
#line 1758 "../src/client/application/application-main-window.vala"
		_tmp14_ = at_end;
#line 10841 "application-main-window.c"
	}
#line 1757 "../src/client/application/application-main-window.vala"
	_tmp18_ = self->conversation_headerbar;
#line 1757 "../src/client/application/application-main-window.vala"
	components_conversation_header_bar_set_show_close_button (_tmp18_, _tmp14_);
#line 10847 "application-main-window.c"
}

static void
application_main_window_on_conversation_activated (ApplicationMainWindow* self,
                                                   GearyAppConversation* activated,
                                                   guint button)
{
#line 1762 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1762 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (activated, GEARY_APP_TYPE_CONVERSATION));
#line 1763 "../src/client/application/application-main-window.vala"
	if (button == ((guint) 1)) {
#line 10861 "application-main-window.c"
		gboolean folded = FALSE;
		HdyLeaflet* _tmp0_;
		gboolean _tmp1_;
		gboolean _tmp2_;
#line 1764 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->outer_leaflet;
#line 1764 "../src/client/application/application-main-window.vala"
		_tmp1_ = hdy_leaflet_get_folded (_tmp0_);
#line 1764 "../src/client/application/application-main-window.vala"
		_tmp2_ = _tmp1_;
#line 1764 "../src/client/application/application-main-window.vala"
		folded = _tmp2_;
#line 1765 "../src/client/application/application-main-window.vala"
		application_main_window_go_to_next_pane (self, TRUE);
#line 1766 "../src/client/application/application-main-window.vala"
		if (folded) {
#line 10878 "application-main-window.c"
			GeeCollection* selected = NULL;
			GeeArrayList* _tmp3_;
			GeeCollection* _tmp4_;
			GeeCollection* _tmp5_;
			GeeCollection* _tmp6_;
			GeeCollection* _tmp7_;
#line 1767 "../src/client/application/application-main-window.vala"
			_tmp3_ = gee_array_list_new (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1767 "../src/client/application/application-main-window.vala"
			selected = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1769 "../src/client/application/application-main-window.vala"
			_tmp4_ = selected;
#line 1769 "../src/client/application/application-main-window.vala"
			gee_collection_add (_tmp4_, activated);
#line 1770 "../src/client/application/application-main-window.vala"
			_tmp5_ = selected;
#line 1770 "../src/client/application/application-main-window.vala"
			_tmp6_ = gee_collection_empty (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref);
#line 1770 "../src/client/application/application-main-window.vala"
			_tmp7_ = _tmp6_;
#line 1770 "../src/client/application/application-main-window.vala"
			application_main_window_select_conversations (self, _tmp5_, _tmp7_, TRUE, NULL, NULL);
#line 1770 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_tmp7_);
#line 1766 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (selected);
#line 10905 "application-main-window.c"
		}
	} else {
		GearyFolder* _tmp8_;
#line 1772 "../src/client/application/application-main-window.vala"
		_tmp8_ = self->priv->_selected_folder;
#line 1772 "../src/client/application/application-main-window.vala"
		if (_tmp8_ != NULL) {
#line 10913 "application-main-window.c"
			GearyFolder* _tmp9_;
			GearyFolderSpecialUse _tmp10_;
			GearyFolderSpecialUse _tmp11_;
#line 1773 "../src/client/application/application-main-window.vala"
			_tmp9_ = self->priv->_selected_folder;
#line 1773 "../src/client/application/application-main-window.vala"
			_tmp10_ = geary_folder_get_used_as (_tmp9_);
#line 1773 "../src/client/application/application-main-window.vala"
			_tmp11_ = _tmp10_;
#line 1773 "../src/client/application/application-main-window.vala"
			if (_tmp11_ != GEARY_FOLDER_SPECIAL_USE_DRAFTS) {
#line 10925 "application-main-window.c"
				ApplicationClient* _tmp12_;
				ApplicationClient* _tmp13_;
				GearyFolder* _tmp14_;
				ConversationListView* _tmp15_;
				GeeSet* _tmp16_;
				GeeSet* _tmp17_;
#line 1774 "../src/client/application/application-main-window.vala"
				_tmp12_ = application_main_window_get_application (self);
#line 1774 "../src/client/application/application-main-window.vala"
				_tmp13_ = _tmp12_;
#line 1774 "../src/client/application/application-main-window.vala"
				_tmp14_ = self->priv->_selected_folder;
#line 1774 "../src/client/application/application-main-window.vala"
				_tmp15_ = self->priv->_conversation_list_view;
#line 1774 "../src/client/application/application-main-window.vala"
				_tmp16_ = conversation_list_view_get_selected (_tmp15_);
#line 1774 "../src/client/application/application-main-window.vala"
				_tmp17_ = _tmp16_;
#line 1774 "../src/client/application/application-main-window.vala"
				application_client_new_window (_tmp13_, _tmp14_, G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_COLLECTION, GeeCollection), NULL, NULL);
#line 10946 "application-main-window.c"
			} else {
				GearyEmail* draft = NULL;
				GearyEmail* _tmp18_;
				GearyFolder* _tmp19_;
				GearyAccount* _tmp20_;
				GearyAccount* _tmp21_;
				GearyEmail* _tmp22_;
#line 1781 "../src/client/application/application-main-window.vala"
				_tmp18_ = geary_app_conversation_get_latest_recv_email (activated, GEARY_APP_CONVERSATION_LOCATION_IN_FOLDER, NULL);
#line 1781 "../src/client/application/application-main-window.vala"
				draft = _tmp18_;
#line 1782 "../src/client/application/application-main-window.vala"
				_tmp19_ = self->priv->_selected_folder;
#line 1782 "../src/client/application/application-main-window.vala"
				_tmp20_ = geary_folder_get_account (_tmp19_);
#line 1782 "../src/client/application/application-main-window.vala"
				_tmp21_ = _tmp20_;
#line 1782 "../src/client/application/application-main-window.vala"
				_tmp22_ = draft;
#line 1782 "../src/client/application/application-main-window.vala"
				application_main_window_create_composer (self, _tmp21_, COMPOSER_WIDGET_CONTEXT_TYPE_EDIT, _tmp22_, NULL, NULL, NULL);
#line 1773 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (draft);
#line 10970 "application-main-window.c"
			}
		}
	}
}

static void
application_main_window_on_conversation_count_changed (ApplicationMainWindow* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 1792 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1795 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_has_composer (self);
#line 1795 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 1795 "../src/client/application/application-main-window.vala"
	if (!_tmp1_) {
#line 10989 "application-main-window.c"
		GearyAppConversationMonitor* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 1796 "../src/client/application/application-main-window.vala"
		_tmp2_ = self->priv->_conversations;
#line 1796 "../src/client/application/application-main-window.vala"
		_tmp3_ = geary_app_conversation_monitor_get_size (_tmp2_);
#line 1796 "../src/client/application/application-main-window.vala"
		_tmp4_ = _tmp3_;
#line 1796 "../src/client/application/application-main-window.vala"
		if (_tmp4_ == 0) {
#line 11001 "application-main-window.c"
			GearyFolder* _tmp5_;
			GearyFolderSpecialUse _tmp6_;
			GearyFolderSpecialUse _tmp7_;
#line 1798 "../src/client/application/application-main-window.vala"
			_tmp5_ = self->priv->_selected_folder;
#line 1798 "../src/client/application/application-main-window.vala"
			_tmp6_ = geary_folder_get_used_as (_tmp5_);
#line 1798 "../src/client/application/application-main-window.vala"
			_tmp7_ = _tmp6_;
#line 1798 "../src/client/application/application-main-window.vala"
			if (_tmp7_ == GEARY_FOLDER_SPECIAL_USE_SEARCH) {
#line 11013 "application-main-window.c"
				ConversationViewer* _tmp8_;
#line 1799 "../src/client/application/application-main-window.vala"
				_tmp8_ = self->priv->_conversation_viewer;
#line 1799 "../src/client/application/application-main-window.vala"
				conversation_viewer_show_empty_search (_tmp8_);
#line 11019 "application-main-window.c"
			} else {
				ConversationViewer* _tmp9_;
#line 1801 "../src/client/application/application-main-window.vala"
				_tmp9_ = self->priv->_conversation_viewer;
#line 1801 "../src/client/application/application-main-window.vala"
				conversation_viewer_show_empty_folder (_tmp9_);
#line 11026 "application-main-window.c"
			}
#line 1803 "../src/client/application/application-main-window.vala"
			application_main_window_update_conversation_actions (self, APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_NONE);
#line 11030 "application-main-window.c"
		} else {
			gboolean _tmp10_ = FALSE;
			ApplicationClient* _tmp11_;
			ApplicationClient* _tmp12_;
			ApplicationConfiguration* _tmp13_;
			ApplicationConfiguration* _tmp14_;
			gboolean _tmp15_;
			gboolean _tmp16_;
#line 1808 "../src/client/application/application-main-window.vala"
			_tmp11_ = application_main_window_get_application (self);
#line 1808 "../src/client/application/application-main-window.vala"
			_tmp12_ = _tmp11_;
#line 1808 "../src/client/application/application-main-window.vala"
			_tmp13_ = application_client_get_config (_tmp12_);
#line 1808 "../src/client/application/application-main-window.vala"
			_tmp14_ = _tmp13_;
#line 1808 "../src/client/application/application-main-window.vala"
			_tmp15_ = application_configuration_get_autoselect (_tmp14_);
#line 1808 "../src/client/application/application-main-window.vala"
			_tmp16_ = _tmp15_;
#line 1808 "../src/client/application/application-main-window.vala"
			if (!_tmp16_) {
#line 11053 "application-main-window.c"
				ConversationListView* _tmp17_;
				GeeSet* _tmp18_;
				GeeSet* _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
#line 1809 "../src/client/application/application-main-window.vala"
				_tmp17_ = self->priv->_conversation_list_view;
#line 1809 "../src/client/application/application-main-window.vala"
				_tmp18_ = conversation_list_view_get_selected (_tmp17_);
#line 1809 "../src/client/application/application-main-window.vala"
				_tmp19_ = _tmp18_;
#line 1809 "../src/client/application/application-main-window.vala"
				_tmp20_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1809 "../src/client/application/application-main-window.vala"
				_tmp21_ = _tmp20_;
#line 1809 "../src/client/application/application-main-window.vala"
				_tmp10_ = _tmp21_ == 0;
#line 11071 "application-main-window.c"
			} else {
#line 1808 "../src/client/application/application-main-window.vala"
				_tmp10_ = FALSE;
#line 11075 "application-main-window.c"
			}
#line 1808 "../src/client/application/application-main-window.vala"
			if (_tmp10_) {
#line 11079 "application-main-window.c"
				ConversationViewer* _tmp22_;
#line 1810 "../src/client/application/application-main-window.vala"
				_tmp22_ = self->priv->_conversation_viewer;
#line 1810 "../src/client/application/application-main-window.vala"
				conversation_viewer_show_none_selected (_tmp22_);
#line 1811 "../src/client/application/application-main-window.vala"
				application_main_window_update_conversation_actions (self, APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_NONE);
#line 11087 "application-main-window.c"
			}
		}
	}
}

static void
application_main_window_update_headerbar (ApplicationMainWindow* self)
{
	GearyFolder* _tmp0_;
#line 1817 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1818 "../src/client/application/application-main-window.vala"
	application_main_window_update_title (self);
#line 1819 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 1819 "../src/client/application/application-main-window.vala"
	if (_tmp0_ != NULL) {
#line 11105 "application-main-window.c"
		gint count = 0;
		GearyFolder* _tmp1_;
		GearyFolderSpecialUse _tmp2_;
		GearyFolderSpecialUse _tmp3_;
#line 1824 "../src/client/application/application-main-window.vala"
		_tmp1_ = self->priv->_selected_folder;
#line 1824 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_used_as (_tmp1_);
#line 1824 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 1824 "../src/client/application/application-main-window.vala"
		switch (_tmp3_) {
#line 1824 "../src/client/application/application-main-window.vala"
			case GEARY_FOLDER_SPECIAL_USE_DRAFTS:
#line 1824 "../src/client/application/application-main-window.vala"
			case GEARY_FOLDER_SPECIAL_USE_OUTBOX:
#line 11122 "application-main-window.c"
			{
				GearyFolder* _tmp4_;
				GearyFolderProperties* _tmp5_;
				GearyFolderProperties* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 1827 "../src/client/application/application-main-window.vala"
				_tmp4_ = self->priv->_selected_folder;
#line 1827 "../src/client/application/application-main-window.vala"
				_tmp5_ = geary_folder_get_properties (_tmp4_);
#line 1827 "../src/client/application/application-main-window.vala"
				_tmp6_ = _tmp5_;
#line 1827 "../src/client/application/application-main-window.vala"
				_tmp7_ = geary_folder_properties_get_email_total (_tmp6_);
#line 1827 "../src/client/application/application-main-window.vala"
				_tmp8_ = _tmp7_;
#line 1827 "../src/client/application/application-main-window.vala"
				count = _tmp8_;
#line 1828 "../src/client/application/application-main-window.vala"
				break;
#line 11143 "application-main-window.c"
			}
			default:
			{
				GearyFolder* _tmp9_;
				GearyFolderProperties* _tmp10_;
				GearyFolderProperties* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
#line 1831 "../src/client/application/application-main-window.vala"
				_tmp9_ = self->priv->_selected_folder;
#line 1831 "../src/client/application/application-main-window.vala"
				_tmp10_ = geary_folder_get_properties (_tmp9_);
#line 1831 "../src/client/application/application-main-window.vala"
				_tmp11_ = _tmp10_;
#line 1831 "../src/client/application/application-main-window.vala"
				_tmp12_ = geary_folder_properties_get_email_unread (_tmp11_);
#line 1831 "../src/client/application/application-main-window.vala"
				_tmp13_ = _tmp12_;
#line 1831 "../src/client/application/application-main-window.vala"
				count = _tmp13_;
#line 1832 "../src/client/application/application-main-window.vala"
				break;
#line 11166 "application-main-window.c"
			}
		}
#line 1835 "../src/client/application/application-main-window.vala"
		if (count > 0) {
#line 11171 "application-main-window.c"
			ComponentsConversationListHeaderBar* _tmp14_;
			ComponentsConversationListHeaderBar* _tmp15_;
			const gchar* _tmp16_;
			const gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
#line 1836 "../src/client/application/application-main-window.vala"
			_tmp14_ = self->priv->conversation_list_headerbar;
#line 1836 "../src/client/application/application-main-window.vala"
			_tmp15_ = self->priv->conversation_list_headerbar;
#line 1836 "../src/client/application/application-main-window.vala"
			_tmp16_ = components_conversation_list_header_bar_get_folder (_tmp15_);
#line 1836 "../src/client/application/application-main-window.vala"
			_tmp17_ = _tmp16_;
#line 1836 "../src/client/application/application-main-window.vala"
			_tmp18_ = g_strdup_printf (_ ("%s (%d)"), _tmp17_, count);
#line 1836 "../src/client/application/application-main-window.vala"
			_tmp19_ = _tmp18_;
#line 1836 "../src/client/application/application-main-window.vala"
			components_conversation_list_header_bar_set_folder (_tmp14_, _tmp19_);
#line 1836 "../src/client/application/application-main-window.vala"
			_g_free0 (_tmp19_);
#line 11194 "application-main-window.c"
		}
	}
}

static void
application_main_window_update_conversation_actions (ApplicationMainWindow* self,
                                                     ApplicationMainWindowConversationCount count)
{
	gboolean sensitive = FALSE;
	gboolean multiple = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean find_in_enabled = FALSE;
	GSimpleAction* _tmp4_;
	GSimpleAction* _tmp5_;
	ComponentsConversationHeaderBar* _tmp6_;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean reply_sensitive = FALSE;
	GSimpleAction* _tmp14_;
	GSimpleAction* _tmp15_;
	GSimpleAction* _tmp16_;
	GSimpleAction* _tmp17_;
	GSimpleAction* _tmp18_;
	GSimpleAction* _tmp19_;
	gboolean _tmp20_ = FALSE;
	gboolean copy_enabled = FALSE;
	GSimpleAction* _tmp22_;
	GSimpleAction* _tmp23_;
	ComponentsConversationActions** _tmp24_;
	gint _tmp24__length1;
	gboolean _tmp27_ = FALSE;
	gboolean mark_enabled = FALSE;
	ComponentsConversationActions** _tmp29_;
	gint _tmp29__length1;
	gboolean _tmp32_ = FALSE;
	GSimpleAction* _tmp34_;
	GSimpleAction* _tmp35_;
	gboolean _tmp36_ = FALSE;
	GSimpleAction* _tmp39_;
	GSimpleAction* _tmp40_;
	gboolean _tmp41_ = FALSE;
	GSimpleAction* _tmp43_;
	GSimpleAction* _tmp44_;
#line 1843 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1844 "../src/client/application/application-main-window.vala"
	sensitive = count != APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_NONE;
#line 1845 "../src/client/application/application-main-window.vala"
	multiple = count == APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_MULTIPLE;
#line 1848 "../src/client/application/application-main-window.vala"
	if (sensitive) {
#line 1848 "../src/client/application/application-main-window.vala"
		_tmp1_ = !multiple;
#line 11250 "application-main-window.c"
	} else {
#line 1848 "../src/client/application/application-main-window.vala"
		_tmp1_ = FALSE;
#line 11254 "application-main-window.c"
	}
#line 1847 "../src/client/application/application-main-window.vala"
	if (_tmp1_) {
#line 11258 "application-main-window.c"
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 1848 "../src/client/application/application-main-window.vala"
		_tmp2_ = application_main_window_get_is_conversation_viewer_shown (self);
#line 1848 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 1848 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp3_;
#line 11267 "application-main-window.c"
	} else {
#line 1848 "../src/client/application/application-main-window.vala"
		_tmp0_ = FALSE;
#line 11271 "application-main-window.c"
	}
#line 1847 "../src/client/application/application-main-window.vala"
	find_in_enabled = _tmp0_;
#line 1850 "../src/client/application/application-main-window.vala"
	_tmp4_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_FIND_IN_CONVERSATION);
#line 1850 "../src/client/application/application-main-window.vala"
	_tmp5_ = _tmp4_;
#line 1850 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp5_, find_in_enabled);
#line 1850 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp5_);
#line 1851 "../src/client/application/application-main-window.vala"
	_tmp6_ = self->conversation_headerbar;
#line 1851 "../src/client/application/application-main-window.vala"
	components_conversation_header_bar_set_find_sensitive (_tmp6_, find_in_enabled);
#line 1854 "../src/client/application/application-main-window.vala"
	if (sensitive) {
#line 1855 "../src/client/application/application-main-window.vala"
		_tmp9_ = !multiple;
#line 11291 "application-main-window.c"
	} else {
#line 1854 "../src/client/application/application-main-window.vala"
		_tmp9_ = FALSE;
#line 11295 "application-main-window.c"
	}
#line 1854 "../src/client/application/application-main-window.vala"
	if (_tmp9_) {
#line 11299 "application-main-window.c"
		GearyFolder* _tmp10_;
#line 1856 "../src/client/application/application-main-window.vala"
		_tmp10_ = self->priv->_selected_folder;
#line 1856 "../src/client/application/application-main-window.vala"
		_tmp8_ = _tmp10_ != NULL;
#line 11305 "application-main-window.c"
	} else {
#line 1854 "../src/client/application/application-main-window.vala"
		_tmp8_ = FALSE;
#line 11309 "application-main-window.c"
	}
#line 1853 "../src/client/application/application-main-window.vala"
	if (_tmp8_) {
#line 11313 "application-main-window.c"
		GearyFolder* _tmp11_;
		GearyFolderSpecialUse _tmp12_;
		GearyFolderSpecialUse _tmp13_;
#line 1857 "../src/client/application/application-main-window.vala"
		_tmp11_ = self->priv->_selected_folder;
#line 1857 "../src/client/application/application-main-window.vala"
		_tmp12_ = geary_folder_get_used_as (_tmp11_);
#line 1857 "../src/client/application/application-main-window.vala"
		_tmp13_ = _tmp12_;
#line 1857 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp13_ != GEARY_FOLDER_SPECIAL_USE_DRAFTS;
#line 11325 "application-main-window.c"
	} else {
#line 1854 "../src/client/application/application-main-window.vala"
		_tmp7_ = FALSE;
#line 11329 "application-main-window.c"
	}
#line 1853 "../src/client/application/application-main-window.vala"
	reply_sensitive = _tmp7_;
#line 1859 "../src/client/application/application-main-window.vala"
	_tmp14_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_REPLY_CONVERSATION);
#line 1859 "../src/client/application/application-main-window.vala"
	_tmp15_ = _tmp14_;
#line 1859 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp15_, reply_sensitive);
#line 1859 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp15_);
#line 1860 "../src/client/application/application-main-window.vala"
	_tmp16_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_REPLY_ALL_CONVERSATION);
#line 1860 "../src/client/application/application-main-window.vala"
	_tmp17_ = _tmp16_;
#line 1860 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp17_, reply_sensitive);
#line 1860 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp17_);
#line 1861 "../src/client/application/application-main-window.vala"
	_tmp18_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_FORWARD_CONVERSATION);
#line 1861 "../src/client/application/application-main-window.vala"
	_tmp19_ = _tmp18_;
#line 1861 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp19_, reply_sensitive);
#line 1861 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp19_);
#line 1863 "../src/client/application/application-main-window.vala"
	if (sensitive) {
#line 11359 "application-main-window.c"
		GearyFolder* _tmp21_;
#line 1864 "../src/client/application/application-main-window.vala"
		_tmp21_ = self->priv->_selected_folder;
#line 1864 "../src/client/application/application-main-window.vala"
		_tmp20_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp21_, GEARY_FOLDER_SUPPORT_TYPE_COPY);
#line 11365 "application-main-window.c"
	} else {
#line 1864 "../src/client/application/application-main-window.vala"
		_tmp20_ = FALSE;
#line 11369 "application-main-window.c"
	}
#line 1863 "../src/client/application/application-main-window.vala"
	copy_enabled = _tmp20_;
#line 1866 "../src/client/application/application-main-window.vala"
	_tmp22_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_SHOW_COPY_MENU);
#line 1866 "../src/client/application/application-main-window.vala"
	_tmp23_ = _tmp22_;
#line 1866 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp23_, copy_enabled);
#line 1866 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp23_);
#line 1867 "../src/client/application/application-main-window.vala"
	_tmp24_ = self->priv->folder_conversation_actions;
#line 1867 "../src/client/application/application-main-window.vala"
	_tmp24__length1 = self->priv->folder_conversation_actions_length1;
#line 11385 "application-main-window.c"
	{
		ComponentsConversationActions** actions_collection = NULL;
		gint actions_collection_length1 = 0;
		gint _actions_collection_size_ = 0;
		gint actions_it = 0;
#line 1867 "../src/client/application/application-main-window.vala"
		actions_collection = _tmp24_;
#line 1867 "../src/client/application/application-main-window.vala"
		actions_collection_length1 = _tmp24__length1;
#line 1867 "../src/client/application/application-main-window.vala"
		for (actions_it = 0; actions_it < actions_collection_length1; actions_it = actions_it + 1) {
#line 11397 "application-main-window.c"
			ComponentsConversationActions* _tmp25_;
			ComponentsConversationActions* actions = NULL;
#line 1867 "../src/client/application/application-main-window.vala"
			_tmp25_ = _g_object_ref0 (actions_collection[actions_it]);
#line 1867 "../src/client/application/application-main-window.vala"
			actions = _tmp25_;
#line 11404 "application-main-window.c"
			{
				ComponentsConversationActions* _tmp26_;
#line 1868 "../src/client/application/application-main-window.vala"
				_tmp26_ = actions;
#line 1868 "../src/client/application/application-main-window.vala"
				components_conversation_actions_set_copy_sensitive (_tmp26_, copy_enabled);
#line 1867 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (actions);
#line 11413 "application-main-window.c"
			}
		}
	}
#line 1871 "../src/client/application/application-main-window.vala"
	if (sensitive) {
#line 11419 "application-main-window.c"
		GearyFolder* _tmp28_;
#line 1872 "../src/client/application/application-main-window.vala"
		_tmp28_ = self->priv->_selected_folder;
#line 1872 "../src/client/application/application-main-window.vala"
		_tmp27_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp28_, GEARY_FOLDER_SUPPORT_TYPE_MARK);
#line 11425 "application-main-window.c"
	} else {
#line 1872 "../src/client/application/application-main-window.vala"
		_tmp27_ = FALSE;
#line 11429 "application-main-window.c"
	}
#line 1871 "../src/client/application/application-main-window.vala"
	mark_enabled = _tmp27_;
#line 1874 "../src/client/application/application-main-window.vala"
	_tmp29_ = self->priv->folder_conversation_actions;
#line 1874 "../src/client/application/application-main-window.vala"
	_tmp29__length1 = self->priv->folder_conversation_actions_length1;
#line 11437 "application-main-window.c"
	{
		ComponentsConversationActions** actions_collection = NULL;
		gint actions_collection_length1 = 0;
		gint _actions_collection_size_ = 0;
		gint actions_it = 0;
#line 1874 "../src/client/application/application-main-window.vala"
		actions_collection = _tmp29_;
#line 1874 "../src/client/application/application-main-window.vala"
		actions_collection_length1 = _tmp29__length1;
#line 1874 "../src/client/application/application-main-window.vala"
		for (actions_it = 0; actions_it < actions_collection_length1; actions_it = actions_it + 1) {
#line 11449 "application-main-window.c"
			ComponentsConversationActions* _tmp30_;
			ComponentsConversationActions* actions = NULL;
#line 1874 "../src/client/application/application-main-window.vala"
			_tmp30_ = _g_object_ref0 (actions_collection[actions_it]);
#line 1874 "../src/client/application/application-main-window.vala"
			actions = _tmp30_;
#line 11456 "application-main-window.c"
			{
				ComponentsConversationActions* _tmp31_;
#line 1875 "../src/client/application/application-main-window.vala"
				_tmp31_ = actions;
#line 1875 "../src/client/application/application-main-window.vala"
				components_conversation_actions_set_mark_sensitive (_tmp31_, mark_enabled);
#line 1874 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (actions);
#line 11465 "application-main-window.c"
			}
		}
	}
#line 1879 "../src/client/application/application-main-window.vala"
	if (sensitive) {
#line 11471 "application-main-window.c"
		GearyFolder* _tmp33_;
#line 1879 "../src/client/application/application-main-window.vala"
		_tmp33_ = self->priv->_selected_folder;
#line 1879 "../src/client/application/application-main-window.vala"
		_tmp32_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp33_, GEARY_FOLDER_SUPPORT_TYPE_ARCHIVE);
#line 11477 "application-main-window.c"
	} else {
#line 1879 "../src/client/application/application-main-window.vala"
		_tmp32_ = FALSE;
#line 11481 "application-main-window.c"
	}
#line 1878 "../src/client/application/application-main-window.vala"
	_tmp34_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_ARCHIVE_CONVERSATION);
#line 1878 "../src/client/application/application-main-window.vala"
	_tmp35_ = _tmp34_;
#line 1878 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp35_, _tmp32_);
#line 1878 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp35_);
#line 1882 "../src/client/application/application-main-window.vala"
	if (sensitive) {
#line 11493 "application-main-window.c"
		gboolean _tmp37_;
		gboolean _tmp38_;
#line 1882 "../src/client/application/application-main-window.vala"
		_tmp37_ = application_main_window_get_selected_folder_supports_trash (self);
#line 1882 "../src/client/application/application-main-window.vala"
		_tmp38_ = _tmp37_;
#line 1882 "../src/client/application/application-main-window.vala"
		_tmp36_ = _tmp38_;
#line 11502 "application-main-window.c"
	} else {
#line 1882 "../src/client/application/application-main-window.vala"
		_tmp36_ = FALSE;
#line 11506 "application-main-window.c"
	}
#line 1881 "../src/client/application/application-main-window.vala"
	_tmp39_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_TRASH_CONVERSATION);
#line 1881 "../src/client/application/application-main-window.vala"
	_tmp40_ = _tmp39_;
#line 1881 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp40_, _tmp36_);
#line 1881 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp40_);
#line 1885 "../src/client/application/application-main-window.vala"
	if (sensitive) {
#line 11518 "application-main-window.c"
		GearyFolder* _tmp42_;
#line 1885 "../src/client/application/application-main-window.vala"
		_tmp42_ = self->priv->_selected_folder;
#line 1885 "../src/client/application/application-main-window.vala"
		_tmp41_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp42_, GEARY_FOLDER_SUPPORT_TYPE_REMOVE);
#line 11524 "application-main-window.c"
	} else {
#line 1885 "../src/client/application/application-main-window.vala"
		_tmp41_ = FALSE;
#line 11528 "application-main-window.c"
	}
#line 1884 "../src/client/application/application-main-window.vala"
	_tmp43_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_DELETE_CONVERSATION);
#line 1884 "../src/client/application/application-main-window.vala"
	_tmp44_ = _tmp43_;
#line 1884 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp44_, _tmp41_);
#line 1884 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp44_);
#line 1888 "../src/client/application/application-main-window.vala"
	application_main_window_update_context_dependent_actions (self, sensitive, NULL, NULL);
#line 11540 "application-main-window.c"
}

static void
application_main_window_update_trash_action (ApplicationMainWindow* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean show_trash = FALSE;
	ComponentsConversationActions* _tmp4_;
	ComponentsConversationHeaderBar* _tmp5_;
	ComponentsConversationActions* _tmp6_;
#line 1891 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1892 "../src/client/application/application-main-window.vala"
	_tmp1_ = self->priv->_is_shift_down;
#line 1892 "../src/client/application/application-main-window.vala"
	if (!_tmp1_) {
#line 11558 "application-main-window.c"
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 1894 "../src/client/application/application-main-window.vala"
		_tmp2_ = application_main_window_get_selected_folder_supports_trash (self);
#line 1894 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 1894 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp3_;
#line 11567 "application-main-window.c"
	} else {
#line 1893 "../src/client/application/application-main-window.vala"
		_tmp0_ = FALSE;
#line 11571 "application-main-window.c"
	}
#line 1892 "../src/client/application/application-main-window.vala"
	show_trash = _tmp0_;
#line 1896 "../src/client/application/application-main-window.vala"
	_tmp4_ = self->priv->conversation_list_actions;
#line 1896 "../src/client/application/application-main-window.vala"
	components_conversation_actions_update_trash_button (_tmp4_, show_trash);
#line 1897 "../src/client/application/application-main-window.vala"
	_tmp5_ = self->conversation_headerbar;
#line 1897 "../src/client/application/application-main-window.vala"
	_tmp6_ = _tmp5_->full_actions;
#line 1897 "../src/client/application/application-main-window.vala"
	components_conversation_actions_update_trash_button (_tmp6_, show_trash);
#line 11585 "application-main-window.c"
}

static void
application_main_window_update_context_dependent_actions_data_free (gpointer _data)
{
	ApplicationMainWindowUpdateContextDependentActionsData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/application-main-window.vala"
	g_slice_free (ApplicationMainWindowUpdateContextDependentActionsData, _data_);
#line 11597 "application-main-window.c"
}

static void
application_main_window_update_context_dependent_actions (ApplicationMainWindow* self,
                                                          gboolean sensitive,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_)
{
	ApplicationMainWindowUpdateContextDependentActionsData* _data_;
	ApplicationMainWindow* _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_slice_new0 (ApplicationMainWindowUpdateContextDependentActionsData);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 10 "../src/client/application/application-main-window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_main_window_update_context_dependent_actions_data_free);
#line 10 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_->sensitive = sensitive;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_update_context_dependent_actions_co (_data_);
#line 11624 "application-main-window.c"
}

static void
application_main_window_update_context_dependent_actions_finish (ApplicationMainWindow* self,
                                                                 GAsyncResult* _res_)
{
	ApplicationMainWindowUpdateContextDependentActionsData* _data_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 11634 "application-main-window.c"
}

static void
application_main_window_update_context_dependent_actions_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_)
{
	ApplicationMainWindowUpdateContextDependentActionsData* _data_;
#line 1920 "../src/client/application/application-main-window.vala"
	_data_ = _user_data_;
#line 1920 "../src/client/application/application-main-window.vala"
	_data_->_source_object_ = source_object;
#line 1920 "../src/client/application/application-main-window.vala"
	_data_->_res_ = _res_;
#line 1920 "../src/client/application/application-main-window.vala"
	application_main_window_update_context_dependent_actions_co (_data_);
#line 11651 "application-main-window.c"
}

static gboolean
application_main_window_update_context_dependent_actions_co (ApplicationMainWindowUpdateContextDependentActionsData* _data_)
{
#line 1900 "../src/client/application/application-main-window.vala"
	switch (_data_->_state_) {
#line 1900 "../src/client/application/application-main-window.vala"
		case 0:
#line 11661 "application-main-window.c"
		goto _state_0;
#line 1900 "../src/client/application/application-main-window.vala"
		case 1:
#line 11665 "application-main-window.c"
		goto _state_1;
		default:
#line 1900 "../src/client/application/application-main-window.vala"
		g_assert_not_reached ();
#line 11670 "application-main-window.c"
	}
	_state_0:
#line 1902 "../src/client/application/application-main-window.vala"
	_data_->_tmp0_ = _data_->self->priv->action_update_cancellable;
#line 1902 "../src/client/application/application-main-window.vala"
	g_cancellable_cancel (_data_->_tmp0_);
#line 1903 "../src/client/application/application-main-window.vala"
	_data_->_tmp1_ = g_cancellable_new ();
#line 1903 "../src/client/application/application-main-window.vala"
	_data_->cancellable = _data_->_tmp1_;
#line 1904 "../src/client/application/application-main-window.vala"
	_data_->_tmp2_ = _data_->cancellable;
#line 1904 "../src/client/application/application-main-window.vala"
	_data_->_tmp3_ = _g_object_ref0 (_data_->_tmp2_);
#line 1904 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self->priv->action_update_cancellable);
#line 1904 "../src/client/application/application-main-window.vala"
	_data_->self->priv->action_update_cancellable = _data_->_tmp3_;
#line 1906 "../src/client/application/application-main-window.vala"
	_data_->selected_operations = NULL;
#line 1907 "../src/client/application/application-main-window.vala"
	_data_->_tmp4_ = _data_->self->priv->_selected_folder;
#line 1907 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp4_ != NULL) {
#line 1908 "../src/client/application/application-main-window.vala"
		_data_->_tmp5_ = _data_->self->priv->controller;
#line 1908 "../src/client/application/application-main-window.vala"
		_data_->_tmp6_ = _data_->self->priv->_selected_folder;
#line 1908 "../src/client/application/application-main-window.vala"
		_data_->_tmp7_ = geary_folder_get_account (_data_->_tmp6_);
#line 1908 "../src/client/application/application-main-window.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 1908 "../src/client/application/application-main-window.vala"
		_data_->_tmp9_ = geary_account_get_information (_data_->_tmp8_);
#line 1908 "../src/client/application/application-main-window.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 1908 "../src/client/application/application-main-window.vala"
		_data_->_tmp11_ = application_account_interface_get_context_for_account (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp5_, APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface), _data_->_tmp10_);
#line 1908 "../src/client/application/application-main-window.vala"
		_data_->context = _data_->_tmp11_;
#line 1912 "../src/client/application/application-main-window.vala"
		_data_->_tmp12_ = _data_->context;
#line 1912 "../src/client/application/application-main-window.vala"
		if (_data_->_tmp12_ != NULL) {
#line 1913 "../src/client/application/application-main-window.vala"
			_data_->_tmp13_ = gee_linked_list_new (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1913 "../src/client/application/application-main-window.vala"
			_data_->ids = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp13_, GEE_TYPE_COLLECTION, GeeCollection);
#line 11719 "application-main-window.c"
			{
#line 1915 "../src/client/application/application-main-window.vala"
				_data_->_tmp14_ = _data_->self->priv->_conversation_list_view;
#line 1915 "../src/client/application/application-main-window.vala"
				_data_->_tmp15_ = conversation_list_view_get_selected (_data_->_tmp14_);
#line 1915 "../src/client/application/application-main-window.vala"
				_data_->_tmp16_ = _data_->_tmp15_;
#line 1915 "../src/client/application/application-main-window.vala"
				_data_->_tmp17_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp16_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1915 "../src/client/application/application-main-window.vala"
				_data_->_convo_it = _data_->_tmp17_;
#line 1915 "../src/client/application/application-main-window.vala"
				while (TRUE) {
#line 1915 "../src/client/application/application-main-window.vala"
					_data_->_tmp18_ = _data_->_convo_it;
#line 1915 "../src/client/application/application-main-window.vala"
					if (!gee_iterator_next (_data_->_tmp18_)) {
#line 1915 "../src/client/application/application-main-window.vala"
						break;
#line 11739 "application-main-window.c"
					}
#line 1915 "../src/client/application/application-main-window.vala"
					_data_->_tmp19_ = _data_->_convo_it;
#line 1915 "../src/client/application/application-main-window.vala"
					_data_->_tmp20_ = gee_iterator_get (_data_->_tmp19_);
#line 1915 "../src/client/application/application-main-window.vala"
					_data_->convo = (GearyAppConversation*) _data_->_tmp20_;
#line 1917 "../src/client/application/application-main-window.vala"
					_data_->_tmp21_ = _data_->ids;
#line 1917 "../src/client/application/application-main-window.vala"
					_data_->_tmp22_ = _data_->convo;
#line 1917 "../src/client/application/application-main-window.vala"
					_data_->_tmp23_ = geary_app_conversation_get_email_ids (_data_->_tmp22_);
#line 1917 "../src/client/application/application-main-window.vala"
					_data_->_tmp24_ = _data_->_tmp23_;
#line 1917 "../src/client/application/application-main-window.vala"
					gee_collection_add_all (_data_->_tmp21_, _data_->_tmp24_);
#line 1917 "../src/client/application/application-main-window.vala"
					_g_object_unref0 (_data_->_tmp24_);
#line 1915 "../src/client/application/application-main-window.vala"
					_g_object_unref0 (_data_->convo);
#line 11761 "application-main-window.c"
				}
#line 1915 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->_convo_it);
#line 11765 "application-main-window.c"
			}
			{
#line 1920 "../src/client/application/application-main-window.vala"
				_data_->_tmp26_ = _data_->context;
#line 1920 "../src/client/application/application-main-window.vala"
				_data_->_tmp27_ = application_account_context_get_emails (_data_->_tmp26_);
#line 1920 "../src/client/application/application-main-window.vala"
				_data_->_tmp28_ = _data_->_tmp27_;
#line 1920 "../src/client/application/application-main-window.vala"
				_data_->_tmp29_ = _data_->ids;
#line 1920 "../src/client/application/application-main-window.vala"
				_data_->_tmp30_ = _data_->cancellable;
#line 1920 "../src/client/application/application-main-window.vala"
				_data_->_state_ = 1;
#line 1920 "../src/client/application/application-main-window.vala"
				geary_app_email_store_get_supported_operations_async (_data_->_tmp28_, _data_->_tmp29_, _data_->_tmp30_, application_main_window_update_context_dependent_actions_ready, _data_);
#line 1920 "../src/client/application/application-main-window.vala"
				return FALSE;
#line 11784 "application-main-window.c"
				_state_1:
#line 1920 "../src/client/application/application-main-window.vala"
				_data_->_tmp31_ = geary_app_email_store_get_supported_operations_finish (_data_->_tmp28_, _data_->_res_, &_data_->_inner_error0_);
#line 1920 "../src/client/application/application-main-window.vala"
				_data_->_tmp25_ = _data_->_tmp31_;
#line 1920 "../src/client/application/application-main-window.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 11792 "application-main-window.c"
					goto __catch0_g_error;
				}
#line 1920 "../src/client/application/application-main-window.vala"
				_data_->_tmp32_ = _data_->_tmp25_;
#line 1920 "../src/client/application/application-main-window.vala"
				_data_->_tmp25_ = NULL;
#line 1920 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->selected_operations);
#line 1920 "../src/client/application/application-main-window.vala"
				_data_->selected_operations = _data_->_tmp32_;
#line 1919 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->_tmp25_);
#line 11805 "application-main-window.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
#line 1919 "../src/client/application/application-main-window.vala"
				_data_->e = _data_->_inner_error0_;
#line 1919 "../src/client/application/application-main-window.vala"
				_data_->_inner_error0_ = NULL;
#line 1924 "../src/client/application/application-main-window.vala"
				_data_->_tmp33_ = _data_->e;
#line 1924 "../src/client/application/application-main-window.vala"
				_data_->_tmp34_ = _data_->_tmp33_->message;
#line 1924 "../src/client/application/application-main-window.vala"
				g_debug ("application-main-window.vala:1924: Error checking for what operations " \
"are supported in the selected conversations: %s", _data_->_tmp34_);
#line 1919 "../src/client/application/application-main-window.vala"
				_g_error_free0 (_data_->e);
#line 11822 "application-main-window.c"
			}
			__finally0:
#line 1919 "../src/client/application/application-main-window.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1919 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->ids);
#line 1919 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->context);
#line 1919 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->selected_operations);
#line 1919 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->cancellable);
#line 1919 "../src/client/application/application-main-window.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 1919 "../src/client/application/application-main-window.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 1919 "../src/client/application/application-main-window.vala"
				g_object_unref (_data_->_async_result);
#line 1919 "../src/client/application/application-main-window.vala"
				return FALSE;
#line 11843 "application-main-window.c"
			}
#line 1912 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_data_->ids);
#line 11847 "application-main-window.c"
		}
#line 1907 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data_->context);
#line 11851 "application-main-window.c"
	}
#line 1930 "../src/client/application/application-main-window.vala"
	_data_->_tmp35_ = _data_->cancellable;
#line 1930 "../src/client/application/application-main-window.vala"
	if (!g_cancellable_is_cancelled (_data_->_tmp35_)) {
#line 1931 "../src/client/application/application-main-window.vala"
		_data_->_tmp36_ = gee_hash_set_new (G_TYPE_GTYPE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1931 "../src/client/application/application-main-window.vala"
		_data_->supported_operations = _data_->_tmp36_;
#line 1932 "../src/client/application/application-main-window.vala"
		_data_->_tmp37_ = _data_->selected_operations;
#line 1932 "../src/client/application/application-main-window.vala"
		if (_data_->_tmp37_ != NULL) {
#line 1933 "../src/client/application/application-main-window.vala"
			_data_->_tmp38_ = _data_->supported_operations;
#line 1933 "../src/client/application/application-main-window.vala"
			_data_->_tmp39_ = _data_->selected_operations;
#line 1933 "../src/client/application/application-main-window.vala"
			_data_->_tmp40_ = gee_multi_map_get_values (_data_->_tmp39_);
#line 1933 "../src/client/application/application-main-window.vala"
			_data_->_tmp41_ = _data_->_tmp40_;
#line 1933 "../src/client/application/application-main-window.vala"
			gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp38_, GEE_TYPE_COLLECTION, GeeCollection), _data_->_tmp41_);
#line 1933 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_data_->_tmp41_);
#line 11877 "application-main-window.c"
		}
#line 1937 "../src/client/application/application-main-window.vala"
		if (_data_->sensitive) {
#line 1938 "../src/client/application/application-main-window.vala"
			_data_->_tmp43_ = _data_->supported_operations;
#line 1938 "../src/client/application/application-main-window.vala"
			_data_->_tmp42_ = gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp43_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), (gpointer) ((gintptr) GEARY_FOLDER_SUPPORT_TYPE_COPY));
#line 11885 "application-main-window.c"
		} else {
#line 1937 "../src/client/application/application-main-window.vala"
			_data_->_tmp42_ = FALSE;
#line 11889 "application-main-window.c"
		}
#line 1936 "../src/client/application/application-main-window.vala"
		_data_->_tmp44_ = application_main_window_get_window_action (_data_->self, APPLICATION_MAIN_WINDOW_ACTION_SHOW_COPY_MENU);
#line 1936 "../src/client/application/application-main-window.vala"
		_data_->_tmp45_ = _data_->_tmp44_;
#line 1936 "../src/client/application/application-main-window.vala"
		g_simple_action_set_enabled (_data_->_tmp45_, _data_->_tmp42_);
#line 1936 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data_->_tmp45_);
#line 1930 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data_->supported_operations);
#line 11901 "application-main-window.c"
	}
#line 1900 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->selected_operations);
#line 1900 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->cancellable);
#line 1900 "../src/client/application/application-main-window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1900 "../src/client/application/application-main-window.vala"
	if (_data_->_state_ != 0) {
#line 1900 "../src/client/application/application-main-window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1900 "../src/client/application/application-main-window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 11915 "application-main-window.c"
		}
	}
#line 1900 "../src/client/application/application-main-window.vala"
	g_object_unref (_data_->_async_result);
#line 1900 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 11922 "application-main-window.c"
}

static void
application_main_window_set_shift_key_down (ApplicationMainWindow* self,
                                            gboolean down)
{
#line 1943 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1944 "../src/client/application/application-main-window.vala"
	application_main_window_set_is_shift_down (self, down);
#line 1945 "../src/client/application/application-main-window.vala"
	application_main_window_update_trash_action (self);
#line 11935 "application-main-window.c"
}

static inline void
application_main_window_check_shift_event (ApplicationMainWindow* self,
                                           GdkEventKey* event)
{
	gboolean _tmp0_ = FALSE;
#line 1948 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1948 "../src/client/application/application-main-window.vala"
	g_return_if_fail (event != NULL);
#line 1952 "../src/client/application/application-main-window.vala"
	if (event->keyval == GDK_KEY_Shift_L) {
#line 1952 "../src/client/application/application-main-window.vala"
		_tmp0_ = TRUE;
#line 11951 "application-main-window.c"
	} else {
#line 1952 "../src/client/application/application-main-window.vala"
		_tmp0_ = event->keyval == GDK_KEY_Shift_R;
#line 11955 "application-main-window.c"
	}
#line 1952 "../src/client/application/application-main-window.vala"
	if (_tmp0_) {
#line 11959 "application-main-window.c"
		GtkWidget* focus = NULL;
		GtkWidget* _tmp1_;
		GtkWidget* _tmp2_;
		gboolean _tmp3_ = FALSE;
		GtkWidget* _tmp4_;
#line 1953 "../src/client/application/application-main-window.vala"
		_tmp1_ = gtk_window_get_focus (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
#line 1953 "../src/client/application/application-main-window.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1953 "../src/client/application/application-main-window.vala"
		focus = _tmp2_;
#line 1954 "../src/client/application/application-main-window.vala"
		_tmp4_ = focus;
#line 1954 "../src/client/application/application-main-window.vala"
		if (_tmp4_ == NULL) {
#line 1954 "../src/client/application/application-main-window.vala"
			_tmp3_ = TRUE;
#line 11977 "application-main-window.c"
		} else {
			gboolean _tmp5_ = FALSE;
			GtkWidget* _tmp6_;
#line 1955 "../src/client/application/application-main-window.vala"
			_tmp6_ = focus;
#line 1955 "../src/client/application/application-main-window.vala"
			if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, gtk_entry_get_type ())) {
#line 11985 "application-main-window.c"
				GtkWidget* _tmp7_;
#line 1955 "../src/client/application/application-main-window.vala"
				_tmp7_ = focus;
#line 1955 "../src/client/application/application-main-window.vala"
				_tmp5_ = !COMPOSER_IS_WEB_VIEW (_tmp7_);
#line 11991 "application-main-window.c"
			} else {
#line 1955 "../src/client/application/application-main-window.vala"
				_tmp5_ = FALSE;
#line 11995 "application-main-window.c"
			}
#line 1955 "../src/client/application/application-main-window.vala"
			_tmp3_ = _tmp5_;
#line 11999 "application-main-window.c"
		}
#line 1954 "../src/client/application/application-main-window.vala"
		if (_tmp3_) {
#line 1956 "../src/client/application/application-main-window.vala"
			application_main_window_set_shift_key_down (self, event->type == GDK_KEY_PRESS);
#line 12005 "application-main-window.c"
		}
#line 1952 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (focus);
#line 12009 "application-main-window.c"
	}
}

static void
application_main_window_focus_widget (ApplicationMainWindow* self,
                                      GtkWidget* widget)
{
#line 1961 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1961 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((widget == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_widget_get_type ()));
#line 1962 "../src/client/application/application-main-window.vala"
	if (widget != NULL) {
#line 12023 "application-main-window.c"
		gboolean _tmp0_ = FALSE;
#line 1963 "../src/client/application/application-main-window.vala"
		g_signal_emit_by_name (widget, "focus", GTK_DIR_TAB_FORWARD, &_tmp0_);
#line 12027 "application-main-window.c"
	} else {
#line 1965 "../src/client/application/application-main-window.vala"
		gtk_widget_error_bell (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 12031 "application-main-window.c"
	}
}

static void
application_main_window_navigate_next_pane (ApplicationMainWindow* self)
{
	GtkWidget* focus = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	HdyLeaflet* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GtkWidget* _tmp34_;
#line 1969 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1970 "../src/client/application/application-main-window.vala"
	_tmp0_ = gtk_window_get_focus (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
#line 1970 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1970 "../src/client/application/application-main-window.vala"
	focus = _tmp1_;
#line 1971 "../src/client/application/application-main-window.vala"
	_tmp2_ = self->priv->outer_leaflet;
#line 1971 "../src/client/application/application-main-window.vala"
	_tmp3_ = hdy_leaflet_get_visible_child_name (_tmp2_);
#line 1971 "../src/client/application/application-main-window.vala"
	_tmp4_ = _tmp3_;
#line 1971 "../src/client/application/application-main-window.vala"
	if (g_strcmp0 (_tmp4_, APPLICATION_MAIN_WINDOW_INNER_LEAFLET) == 0) {
#line 12061 "application-main-window.c"
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
		HdyLeaflet* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 1972 "../src/client/application/application-main-window.vala"
		_tmp7_ = self->priv->inner_leaflet;
#line 1972 "../src/client/application/application-main-window.vala"
		_tmp8_ = hdy_leaflet_get_folded (_tmp7_);
#line 1972 "../src/client/application/application-main-window.vala"
		_tmp9_ = _tmp8_;
#line 1972 "../src/client/application/application-main-window.vala"
		if (_tmp9_) {
#line 12075 "application-main-window.c"
			HdyLeaflet* _tmp10_;
			const gchar* _tmp11_;
			const gchar* _tmp12_;
#line 1973 "../src/client/application/application-main-window.vala"
			_tmp10_ = self->priv->inner_leaflet;
#line 1973 "../src/client/application/application-main-window.vala"
			_tmp11_ = hdy_leaflet_get_visible_child_name (_tmp10_);
#line 1973 "../src/client/application/application-main-window.vala"
			_tmp12_ = _tmp11_;
#line 1973 "../src/client/application/application-main-window.vala"
			_tmp6_ = g_strcmp0 (_tmp12_, APPLICATION_MAIN_WINDOW_FOLDER_LIST) == 0;
#line 12087 "application-main-window.c"
		} else {
#line 1972 "../src/client/application/application-main-window.vala"
			_tmp6_ = FALSE;
#line 12091 "application-main-window.c"
		}
#line 1972 "../src/client/application/application-main-window.vala"
		if (_tmp6_) {
#line 1972 "../src/client/application/application-main-window.vala"
			_tmp5_ = TRUE;
#line 12097 "application-main-window.c"
		} else {
			GtkWidget* _tmp13_;
			FolderListTree* _tmp14_;
#line 1974 "../src/client/application/application-main-window.vala"
			_tmp13_ = focus;
#line 1974 "../src/client/application/application-main-window.vala"
			_tmp14_ = self->priv->_folder_list;
#line 1974 "../src/client/application/application-main-window.vala"
			_tmp5_ = _tmp13_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_widget_get_type (), GtkWidget);
#line 12107 "application-main-window.c"
		}
#line 1972 "../src/client/application/application-main-window.vala"
		if (_tmp5_) {
#line 12111 "application-main-window.c"
			HdyLeaflet* _tmp15_;
			ConversationListView* _tmp16_;
			GtkWidget* _tmp17_;
#line 1975 "../src/client/application/application-main-window.vala"
			_tmp15_ = self->priv->inner_leaflet;
#line 1975 "../src/client/application/application-main-window.vala"
			hdy_leaflet_navigate (_tmp15_, HDY_NAVIGATION_DIRECTION_FORWARD);
#line 1976 "../src/client/application/application-main-window.vala"
			_tmp16_ = self->priv->_conversation_list_view;
#line 1976 "../src/client/application/application-main-window.vala"
			_tmp17_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_widget_get_type (), GtkWidget));
#line 1976 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (focus);
#line 1976 "../src/client/application/application-main-window.vala"
			focus = _tmp17_;
#line 12127 "application-main-window.c"
		} else {
			gboolean _tmp18_ = FALSE;
			ConversationListView* _tmp19_;
			GeeSet* _tmp20_;
			GeeSet* _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
#line 1978 "../src/client/application/application-main-window.vala"
			_tmp19_ = self->priv->_conversation_list_view;
#line 1978 "../src/client/application/application-main-window.vala"
			_tmp20_ = conversation_list_view_get_selected (_tmp19_);
#line 1978 "../src/client/application/application-main-window.vala"
			_tmp21_ = _tmp20_;
#line 1978 "../src/client/application/application-main-window.vala"
			_tmp22_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1978 "../src/client/application/application-main-window.vala"
			_tmp23_ = _tmp22_;
#line 1978 "../src/client/application/application-main-window.vala"
			if (_tmp23_ == 1) {
#line 12147 "application-main-window.c"
				GearyFolder* _tmp24_;
				GearyFolderProperties* _tmp25_;
				GearyFolderProperties* _tmp26_;
				gint _tmp27_;
				gint _tmp28_;
#line 1979 "../src/client/application/application-main-window.vala"
				_tmp24_ = self->priv->_selected_folder;
#line 1979 "../src/client/application/application-main-window.vala"
				_tmp25_ = geary_folder_get_properties (_tmp24_);
#line 1979 "../src/client/application/application-main-window.vala"
				_tmp26_ = _tmp25_;
#line 1979 "../src/client/application/application-main-window.vala"
				_tmp27_ = geary_folder_properties_get_email_total (_tmp26_);
#line 1979 "../src/client/application/application-main-window.vala"
				_tmp28_ = _tmp27_;
#line 1979 "../src/client/application/application-main-window.vala"
				_tmp18_ = _tmp28_ > 0;
#line 12165 "application-main-window.c"
			} else {
#line 1978 "../src/client/application/application-main-window.vala"
				_tmp18_ = FALSE;
#line 12169 "application-main-window.c"
			}
#line 1978 "../src/client/application/application-main-window.vala"
			if (_tmp18_) {
#line 12173 "application-main-window.c"
				HdyLeaflet* _tmp29_;
				ConversationViewer* _tmp30_;
				GtkWidget* _tmp31_;
				GtkWidget* _tmp32_;
				GtkWidget* _tmp33_;
#line 1980 "../src/client/application/application-main-window.vala"
				_tmp29_ = self->priv->outer_leaflet;
#line 1980 "../src/client/application/application-main-window.vala"
				hdy_leaflet_navigate (_tmp29_, HDY_NAVIGATION_DIRECTION_FORWARD);
#line 1981 "../src/client/application/application-main-window.vala"
				_tmp30_ = self->priv->_conversation_viewer;
#line 1981 "../src/client/application/application-main-window.vala"
				_tmp31_ = gtk_stack_get_visible_child (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, gtk_stack_get_type (), GtkStack));
#line 1981 "../src/client/application/application-main-window.vala"
				_tmp32_ = _tmp31_;
#line 1981 "../src/client/application/application-main-window.vala"
				_tmp33_ = _g_object_ref0 (_tmp32_);
#line 1981 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (focus);
#line 1981 "../src/client/application/application-main-window.vala"
				focus = _tmp33_;
#line 12195 "application-main-window.c"
			}
		}
	}
#line 1985 "../src/client/application/application-main-window.vala"
	_tmp34_ = focus;
#line 1985 "../src/client/application/application-main-window.vala"
	application_main_window_focus_widget (self, _tmp34_);
#line 1969 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (focus);
#line 12205 "application-main-window.c"
}

static void
application_main_window_focus_next_pane (ApplicationMainWindow* self)
{
	GtkWidget* focus = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp26_;
#line 1988 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1989 "../src/client/application/application-main-window.vala"
	_tmp0_ = gtk_window_get_focus (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
#line 1989 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1989 "../src/client/application/application-main-window.vala"
	focus = _tmp1_;
#line 1990 "../src/client/application/application-main-window.vala"
	_tmp2_ = focus;
#line 1990 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 12228 "application-main-window.c"
		gboolean _tmp3_ = FALSE;
		GtkWidget* _tmp4_;
		FolderListTree* _tmp5_;
#line 1991 "../src/client/application/application-main-window.vala"
		_tmp4_ = focus;
#line 1991 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->_folder_list;
#line 1991 "../src/client/application/application-main-window.vala"
		if (_tmp4_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_widget_get_type (), GtkWidget)) {
#line 1991 "../src/client/application/application-main-window.vala"
			_tmp3_ = TRUE;
#line 12240 "application-main-window.c"
		} else {
			GtkWidget* _tmp6_;
			FolderListTree* _tmp7_;
#line 1992 "../src/client/application/application-main-window.vala"
			_tmp6_ = focus;
#line 1992 "../src/client/application/application-main-window.vala"
			_tmp7_ = self->priv->_folder_list;
#line 1992 "../src/client/application/application-main-window.vala"
			_tmp3_ = gtk_widget_is_ancestor (_tmp6_, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget));
#line 12250 "application-main-window.c"
		}
#line 1991 "../src/client/application/application-main-window.vala"
		if (_tmp3_) {
#line 12254 "application-main-window.c"
			ConversationListView* _tmp8_;
			GtkWidget* _tmp9_;
#line 1993 "../src/client/application/application-main-window.vala"
			_tmp8_ = self->priv->_conversation_list_view;
#line 1993 "../src/client/application/application-main-window.vala"
			_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget));
#line 1993 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (focus);
#line 1993 "../src/client/application/application-main-window.vala"
			focus = _tmp9_;
#line 12265 "application-main-window.c"
		} else {
			gboolean _tmp10_ = FALSE;
			GtkWidget* _tmp11_;
			ConversationListView* _tmp12_;
#line 1994 "../src/client/application/application-main-window.vala"
			_tmp11_ = focus;
#line 1994 "../src/client/application/application-main-window.vala"
			_tmp12_ = self->priv->_conversation_list_view;
#line 1994 "../src/client/application/application-main-window.vala"
			if (_tmp11_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_widget_get_type (), GtkWidget)) {
#line 1994 "../src/client/application/application-main-window.vala"
				_tmp10_ = TRUE;
#line 12278 "application-main-window.c"
			} else {
				GtkWidget* _tmp13_;
				ConversationListView* _tmp14_;
#line 1995 "../src/client/application/application-main-window.vala"
				_tmp13_ = focus;
#line 1995 "../src/client/application/application-main-window.vala"
				_tmp14_ = self->priv->_conversation_list_view;
#line 1995 "../src/client/application/application-main-window.vala"
				_tmp10_ = gtk_widget_is_ancestor (_tmp13_, G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_widget_get_type (), GtkWidget));
#line 12288 "application-main-window.c"
			}
#line 1994 "../src/client/application/application-main-window.vala"
			if (_tmp10_) {
#line 12292 "application-main-window.c"
				ConversationViewer* _tmp15_;
				GtkWidget* _tmp16_;
				GtkWidget* _tmp17_;
				GtkWidget* _tmp18_;
#line 1996 "../src/client/application/application-main-window.vala"
				_tmp15_ = self->priv->_conversation_viewer;
#line 1996 "../src/client/application/application-main-window.vala"
				_tmp16_ = gtk_stack_get_visible_child (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_stack_get_type (), GtkStack));
#line 1996 "../src/client/application/application-main-window.vala"
				_tmp17_ = _tmp16_;
#line 1996 "../src/client/application/application-main-window.vala"
				_tmp18_ = _g_object_ref0 (_tmp17_);
#line 1996 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (focus);
#line 1996 "../src/client/application/application-main-window.vala"
				focus = _tmp18_;
#line 12309 "application-main-window.c"
			} else {
				gboolean _tmp19_ = FALSE;
				GtkWidget* _tmp20_;
				ConversationViewer* _tmp21_;
#line 1997 "../src/client/application/application-main-window.vala"
				_tmp20_ = focus;
#line 1997 "../src/client/application/application-main-window.vala"
				_tmp21_ = self->priv->_conversation_viewer;
#line 1997 "../src/client/application/application-main-window.vala"
				if (_tmp20_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, gtk_widget_get_type (), GtkWidget)) {
#line 1997 "../src/client/application/application-main-window.vala"
					_tmp19_ = TRUE;
#line 12322 "application-main-window.c"
				} else {
					GtkWidget* _tmp22_;
					ConversationViewer* _tmp23_;
#line 1998 "../src/client/application/application-main-window.vala"
					_tmp22_ = focus;
#line 1998 "../src/client/application/application-main-window.vala"
					_tmp23_ = self->priv->_conversation_viewer;
#line 1998 "../src/client/application/application-main-window.vala"
					_tmp19_ = gtk_widget_is_ancestor (_tmp22_, G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, gtk_widget_get_type (), GtkWidget));
#line 12332 "application-main-window.c"
				}
#line 1997 "../src/client/application/application-main-window.vala"
				if (_tmp19_) {
#line 12336 "application-main-window.c"
					FolderListTree* _tmp24_;
					GtkWidget* _tmp25_;
#line 1999 "../src/client/application/application-main-window.vala"
					_tmp24_ = self->priv->_folder_list;
#line 1999 "../src/client/application/application-main-window.vala"
					_tmp25_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, gtk_widget_get_type (), GtkWidget));
#line 1999 "../src/client/application/application-main-window.vala"
					_g_object_unref0 (focus);
#line 1999 "../src/client/application/application-main-window.vala"
					focus = _tmp25_;
#line 12347 "application-main-window.c"
				}
			}
		}
	}
#line 2002 "../src/client/application/application-main-window.vala"
	_tmp26_ = focus;
#line 2002 "../src/client/application/application-main-window.vala"
	application_main_window_focus_widget (self, _tmp26_);
#line 1988 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (focus);
#line 12358 "application-main-window.c"
}

static void
application_main_window_go_to_next_pane (ApplicationMainWindow* self,
                                         gboolean only_if_folded)
{
	HdyLeaflet* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 2005 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2006 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->outer_leaflet;
#line 2006 "../src/client/application/application-main-window.vala"
	_tmp1_ = hdy_leaflet_get_folded (_tmp0_);
#line 2006 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 2006 "../src/client/application/application-main-window.vala"
	if (_tmp2_) {
#line 2007 "../src/client/application/application-main-window.vala"
		application_main_window_navigate_next_pane (self);
#line 12380 "application-main-window.c"
	} else {
#line 2008 "../src/client/application/application-main-window.vala"
		if (!only_if_folded) {
#line 2009 "../src/client/application/application-main-window.vala"
			application_main_window_focus_next_pane (self);
#line 12386 "application-main-window.c"
		}
	}
}

static void
application_main_window_navigate_previous_pane (ApplicationMainWindow* self)
{
	GtkWidget* focus = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	HdyLeaflet* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GtkWidget* _tmp26_;
#line 2013 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2014 "../src/client/application/application-main-window.vala"
	_tmp0_ = gtk_window_get_focus (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
#line 2014 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2014 "../src/client/application/application-main-window.vala"
	focus = _tmp1_;
#line 2015 "../src/client/application/application-main-window.vala"
	_tmp2_ = self->priv->outer_leaflet;
#line 2015 "../src/client/application/application-main-window.vala"
	_tmp3_ = hdy_leaflet_get_visible_child_name (_tmp2_);
#line 2015 "../src/client/application/application-main-window.vala"
	_tmp4_ = _tmp3_;
#line 2015 "../src/client/application/application-main-window.vala"
	if (g_strcmp0 (_tmp4_, APPLICATION_MAIN_WINDOW_INNER_LEAFLET) == 0) {
#line 12417 "application-main-window.c"
		HdyLeaflet* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 2016 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->inner_leaflet;
#line 2016 "../src/client/application/application-main-window.vala"
		_tmp6_ = hdy_leaflet_get_folded (_tmp5_);
#line 2016 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 2016 "../src/client/application/application-main-window.vala"
		if (_tmp7_) {
#line 12429 "application-main-window.c"
			HdyLeaflet* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
#line 2017 "../src/client/application/application-main-window.vala"
			_tmp8_ = self->priv->inner_leaflet;
#line 2017 "../src/client/application/application-main-window.vala"
			_tmp9_ = hdy_leaflet_get_visible_child_name (_tmp8_);
#line 2017 "../src/client/application/application-main-window.vala"
			_tmp10_ = _tmp9_;
#line 2017 "../src/client/application/application-main-window.vala"
			if (g_strcmp0 (_tmp10_, APPLICATION_MAIN_WINDOW_CONVERSATION_LIST) == 0) {
#line 12441 "application-main-window.c"
				HdyLeaflet* _tmp11_;
				FolderListTree* _tmp12_;
				GtkWidget* _tmp13_;
#line 2018 "../src/client/application/application-main-window.vala"
				_tmp11_ = self->priv->inner_leaflet;
#line 2018 "../src/client/application/application-main-window.vala"
				hdy_leaflet_navigate (_tmp11_, HDY_NAVIGATION_DIRECTION_BACK);
#line 2019 "../src/client/application/application-main-window.vala"
				_tmp12_ = self->priv->_folder_list;
#line 2019 "../src/client/application/application-main-window.vala"
				_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_widget_get_type (), GtkWidget));
#line 2019 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (focus);
#line 2019 "../src/client/application/application-main-window.vala"
				focus = _tmp13_;
#line 12457 "application-main-window.c"
			}
		} else {
			gboolean _tmp14_ = FALSE;
			GtkWidget* _tmp15_;
			ConversationListView* _tmp16_;
#line 2022 "../src/client/application/application-main-window.vala"
			_tmp15_ = focus;
#line 2022 "../src/client/application/application-main-window.vala"
			_tmp16_ = self->priv->_conversation_list_view;
#line 2022 "../src/client/application/application-main-window.vala"
			if (_tmp15_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_widget_get_type (), GtkWidget)) {
#line 2022 "../src/client/application/application-main-window.vala"
				_tmp14_ = TRUE;
#line 12471 "application-main-window.c"
			} else {
				GtkWidget* _tmp17_;
				ConversationListView* _tmp18_;
#line 2023 "../src/client/application/application-main-window.vala"
				_tmp17_ = focus;
#line 2023 "../src/client/application/application-main-window.vala"
				_tmp18_ = self->priv->_conversation_list_view;
#line 2023 "../src/client/application/application-main-window.vala"
				_tmp14_ = gtk_widget_is_ancestor (_tmp17_, G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, gtk_widget_get_type (), GtkWidget));
#line 12481 "application-main-window.c"
			}
#line 2022 "../src/client/application/application-main-window.vala"
			if (_tmp14_) {
#line 12485 "application-main-window.c"
				FolderListTree* _tmp19_;
				GtkWidget* _tmp20_;
#line 2024 "../src/client/application/application-main-window.vala"
				_tmp19_ = self->priv->_folder_list;
#line 2024 "../src/client/application/application-main-window.vala"
				_tmp20_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_widget_get_type (), GtkWidget));
#line 2024 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (focus);
#line 2024 "../src/client/application/application-main-window.vala"
				focus = _tmp20_;
#line 12496 "application-main-window.c"
			} else {
				ConversationListView* _tmp21_;
				GtkWidget* _tmp22_;
#line 2026 "../src/client/application/application-main-window.vala"
				_tmp21_ = self->priv->_conversation_list_view;
#line 2026 "../src/client/application/application-main-window.vala"
				_tmp22_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, gtk_widget_get_type (), GtkWidget));
#line 2026 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (focus);
#line 2026 "../src/client/application/application-main-window.vala"
				focus = _tmp22_;
#line 12508 "application-main-window.c"
			}
		}
	} else {
		HdyLeaflet* _tmp23_;
		ConversationListView* _tmp24_;
		GtkWidget* _tmp25_;
#line 2029 "../src/client/application/application-main-window.vala"
		_tmp23_ = self->priv->outer_leaflet;
#line 2029 "../src/client/application/application-main-window.vala"
		hdy_leaflet_navigate (_tmp23_, HDY_NAVIGATION_DIRECTION_BACK);
#line 2030 "../src/client/application/application-main-window.vala"
		_tmp24_ = self->priv->_conversation_list_view;
#line 2030 "../src/client/application/application-main-window.vala"
		_tmp25_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, gtk_widget_get_type (), GtkWidget));
#line 2030 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (focus);
#line 2030 "../src/client/application/application-main-window.vala"
		focus = _tmp25_;
#line 12527 "application-main-window.c"
	}
#line 2032 "../src/client/application/application-main-window.vala"
	_tmp26_ = focus;
#line 2032 "../src/client/application/application-main-window.vala"
	application_main_window_focus_widget (self, _tmp26_);
#line 2013 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (focus);
#line 12535 "application-main-window.c"
}

static void
application_main_window_focus_previous_pane (ApplicationMainWindow* self)
{
	GtkWidget* focus = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp26_;
#line 2035 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2036 "../src/client/application/application-main-window.vala"
	_tmp0_ = gtk_window_get_focus (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
#line 2036 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2036 "../src/client/application/application-main-window.vala"
	focus = _tmp1_;
#line 2037 "../src/client/application/application-main-window.vala"
	_tmp2_ = focus;
#line 2037 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 12558 "application-main-window.c"
		gboolean _tmp3_ = FALSE;
		GtkWidget* _tmp4_;
		FolderListTree* _tmp5_;
#line 2038 "../src/client/application/application-main-window.vala"
		_tmp4_ = focus;
#line 2038 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->_folder_list;
#line 2038 "../src/client/application/application-main-window.vala"
		if (_tmp4_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_widget_get_type (), GtkWidget)) {
#line 2038 "../src/client/application/application-main-window.vala"
			_tmp3_ = TRUE;
#line 12570 "application-main-window.c"
		} else {
			GtkWidget* _tmp6_;
			FolderListTree* _tmp7_;
#line 2039 "../src/client/application/application-main-window.vala"
			_tmp6_ = focus;
#line 2039 "../src/client/application/application-main-window.vala"
			_tmp7_ = self->priv->_folder_list;
#line 2039 "../src/client/application/application-main-window.vala"
			_tmp3_ = gtk_widget_is_ancestor (_tmp6_, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget));
#line 12580 "application-main-window.c"
		}
#line 2038 "../src/client/application/application-main-window.vala"
		if (_tmp3_) {
#line 12584 "application-main-window.c"
			ConversationViewer* _tmp8_;
			GtkWidget* _tmp9_;
			GtkWidget* _tmp10_;
			GtkWidget* _tmp11_;
#line 2040 "../src/client/application/application-main-window.vala"
			_tmp8_ = self->priv->_conversation_viewer;
#line 2040 "../src/client/application/application-main-window.vala"
			_tmp9_ = gtk_stack_get_visible_child (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_stack_get_type (), GtkStack));
#line 2040 "../src/client/application/application-main-window.vala"
			_tmp10_ = _tmp9_;
#line 2040 "../src/client/application/application-main-window.vala"
			_tmp11_ = _g_object_ref0 (_tmp10_);
#line 2040 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (focus);
#line 2040 "../src/client/application/application-main-window.vala"
			focus = _tmp11_;
#line 12601 "application-main-window.c"
		} else {
			gboolean _tmp12_ = FALSE;
			GtkWidget* _tmp13_;
			ConversationListView* _tmp14_;
#line 2041 "../src/client/application/application-main-window.vala"
			_tmp13_ = focus;
#line 2041 "../src/client/application/application-main-window.vala"
			_tmp14_ = self->priv->_conversation_list_view;
#line 2041 "../src/client/application/application-main-window.vala"
			if (_tmp13_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_widget_get_type (), GtkWidget)) {
#line 2041 "../src/client/application/application-main-window.vala"
				_tmp12_ = TRUE;
#line 12614 "application-main-window.c"
			} else {
				GtkWidget* _tmp15_;
				ConversationListView* _tmp16_;
#line 2042 "../src/client/application/application-main-window.vala"
				_tmp15_ = focus;
#line 2042 "../src/client/application/application-main-window.vala"
				_tmp16_ = self->priv->_conversation_list_view;
#line 2042 "../src/client/application/application-main-window.vala"
				_tmp12_ = gtk_widget_is_ancestor (_tmp15_, G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_widget_get_type (), GtkWidget));
#line 12624 "application-main-window.c"
			}
#line 2041 "../src/client/application/application-main-window.vala"
			if (_tmp12_) {
#line 12628 "application-main-window.c"
				FolderListTree* _tmp17_;
				GtkWidget* _tmp18_;
#line 2043 "../src/client/application/application-main-window.vala"
				_tmp17_ = self->priv->_folder_list;
#line 2043 "../src/client/application/application-main-window.vala"
				_tmp18_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, gtk_widget_get_type (), GtkWidget));
#line 2043 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (focus);
#line 2043 "../src/client/application/application-main-window.vala"
				focus = _tmp18_;
#line 12639 "application-main-window.c"
			} else {
				gboolean _tmp19_ = FALSE;
				GtkWidget* _tmp20_;
				ConversationViewer* _tmp21_;
#line 2044 "../src/client/application/application-main-window.vala"
				_tmp20_ = focus;
#line 2044 "../src/client/application/application-main-window.vala"
				_tmp21_ = self->priv->_conversation_viewer;
#line 2044 "../src/client/application/application-main-window.vala"
				if (_tmp20_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, gtk_widget_get_type (), GtkWidget)) {
#line 2044 "../src/client/application/application-main-window.vala"
					_tmp19_ = TRUE;
#line 12652 "application-main-window.c"
				} else {
					GtkWidget* _tmp22_;
					ConversationViewer* _tmp23_;
#line 2045 "../src/client/application/application-main-window.vala"
					_tmp22_ = focus;
#line 2045 "../src/client/application/application-main-window.vala"
					_tmp23_ = self->priv->_conversation_viewer;
#line 2045 "../src/client/application/application-main-window.vala"
					_tmp19_ = gtk_widget_is_ancestor (_tmp22_, G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, gtk_widget_get_type (), GtkWidget));
#line 12662 "application-main-window.c"
				}
#line 2044 "../src/client/application/application-main-window.vala"
				if (_tmp19_) {
#line 12666 "application-main-window.c"
					ConversationListView* _tmp24_;
					GtkWidget* _tmp25_;
#line 2046 "../src/client/application/application-main-window.vala"
					_tmp24_ = self->priv->_conversation_list_view;
#line 2046 "../src/client/application/application-main-window.vala"
					_tmp25_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, gtk_widget_get_type (), GtkWidget));
#line 2046 "../src/client/application/application-main-window.vala"
					_g_object_unref0 (focus);
#line 2046 "../src/client/application/application-main-window.vala"
					focus = _tmp25_;
#line 12677 "application-main-window.c"
				}
			}
		}
	}
#line 2049 "../src/client/application/application-main-window.vala"
	_tmp26_ = focus;
#line 2049 "../src/client/application/application-main-window.vala"
	application_main_window_focus_widget (self, _tmp26_);
#line 2035 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (focus);
#line 12688 "application-main-window.c"
}

static void
application_main_window_go_to_previous_pane (ApplicationMainWindow* self)
{
	HdyLeaflet* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 2052 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2053 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->outer_leaflet;
#line 2053 "../src/client/application/application-main-window.vala"
	_tmp1_ = hdy_leaflet_get_folded (_tmp0_);
#line 2053 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 2053 "../src/client/application/application-main-window.vala"
	if (_tmp2_) {
#line 2054 "../src/client/application/application-main-window.vala"
		application_main_window_navigate_previous_pane (self);
#line 12709 "application-main-window.c"
	} else {
#line 2056 "../src/client/application/application-main-window.vala"
		application_main_window_focus_previous_pane (self);
#line 12713 "application-main-window.c"
	}
}

static GSimpleAction*
application_main_window_get_window_action (ApplicationMainWindow* self,
                                           const gchar* name)
{
	GAction* _tmp0_;
	GSimpleAction* _tmp1_;
	GSimpleAction* result;
#line 2060 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 2060 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 2061 "../src/client/application/application-main-window.vala"
	_tmp0_ = g_action_map_lookup_action (G_TYPE_CHECK_INSTANCE_CAST (self, g_action_map_get_type (), GActionMap), name);
#line 2061 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_simple_action_get_type (), GSimpleAction));
#line 2061 "../src/client/application/application-main-window.vala"
	result = _tmp1_;
#line 2061 "../src/client/application/application-main-window.vala"
	return result;
#line 12736 "application-main-window.c"
}

static GSimpleAction*
application_main_window_get_edit_action (ApplicationMainWindow* self,
                                         const gchar* name)
{
	GSimpleActionGroup* _tmp0_;
	GAction* _tmp1_;
	GSimpleAction* _tmp2_;
	GSimpleAction* result;
#line 2064 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 2064 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 2065 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->edit_actions;
#line 2065 "../src/client/application/application-main-window.vala"
	_tmp1_ = g_action_map_lookup_action (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_action_map_get_type (), GActionMap), name);
#line 2065 "../src/client/application/application-main-window.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_simple_action_get_type (), GSimpleAction));
#line 2065 "../src/client/application/application-main-window.vala"
	result = _tmp2_;
#line 2065 "../src/client/application/application-main-window.vala"
	return result;
#line 12761 "application-main-window.c"
}

static void
application_main_window_activate_action (ApplicationMainWindow* self,
                                         GAction* action)
{
	gboolean _tmp0_ = FALSE;
#line 2068 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2068 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((action == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (action, g_action_get_type ()));
#line 2069 "../src/client/application/application-main-window.vala"
	if (action != NULL) {
#line 2069 "../src/client/application/application-main-window.vala"
		_tmp0_ = g_action_get_enabled (action);
#line 12777 "application-main-window.c"
	} else {
#line 2069 "../src/client/application/application-main-window.vala"
		_tmp0_ = FALSE;
#line 12781 "application-main-window.c"
	}
#line 2069 "../src/client/application/application-main-window.vala"
	if (_tmp0_) {
#line 2070 "../src/client/application/application-main-window.vala"
		g_action_activate (action, NULL);
#line 12787 "application-main-window.c"
	} else {
#line 2072 "../src/client/application/application-main-window.vala"
		gtk_widget_error_bell (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 12791 "application-main-window.c"
	}
}

static Block20Data*
block20_data_ref (Block20Data* _data20_)
{
#line 2076 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data20_->_ref_count_);
#line 2076 "../src/client/application/application-main-window.vala"
	return _data20_;
#line 12802 "application-main-window.c"
}

static void
block20_data_unref (void * _userdata_)
{
	Block20Data* _data20_;
	_data20_ = (Block20Data*) _userdata_;
#line 2076 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data20_->_ref_count_)) {
#line 12812 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2076 "../src/client/application/application-main-window.vala"
		self = _data20_->self;
#line 2076 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2076 "../src/client/application/application-main-window.vala"
		g_slice_free (Block20Data, _data20_);
#line 12820 "application-main-window.c"
	}
}

static gboolean
___lambda197_ (Block20Data* _data20_)
{
	ApplicationMainWindow* self;
	gboolean result;
#line 2081 "../src/client/application/application-main-window.vala"
	self = _data20_->self;
#line 2082 "../src/client/application/application-main-window.vala"
	application_main_window_create_composer_from_viewer (self, _data20_->context_type, NULL, NULL);
#line 2083 "../src/client/application/application-main-window.vala"
	result = G_SOURCE_REMOVE;
#line 2083 "../src/client/application/application-main-window.vala"
	return result;
#line 12837 "application-main-window.c"
}

static gboolean
____lambda197__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda197_ (self);
#line 2081 "../src/client/application/application-main-window.vala"
	return result;
#line 12847 "application-main-window.c"
}

static void
application_main_window_reply_conversation (ApplicationMainWindow* self,
                                            ComposerWidgetContextType context_type)
{
	Block20Data* _data20_;
	HdyLeaflet* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 2076 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2076 "../src/client/application/application-main-window.vala"
	_data20_ = g_slice_new0 (Block20Data);
#line 2076 "../src/client/application/application-main-window.vala"
	_data20_->_ref_count_ = 1;
#line 2076 "../src/client/application/application-main-window.vala"
	_data20_->self = g_object_ref (self);
#line 2076 "../src/client/application/application-main-window.vala"
	_data20_->context_type = context_type;
#line 2077 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->outer_leaflet;
#line 2077 "../src/client/application/application-main-window.vala"
	_tmp1_ = hdy_leaflet_get_folded (_tmp0_);
#line 2077 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 2077 "../src/client/application/application-main-window.vala"
	if (_tmp2_) {
#line 12876 "application-main-window.c"
		ConversationListView* _tmp3_;
#line 2078 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->_conversation_list_view;
#line 2078 "../src/client/application/application-main-window.vala"
		conversation_list_view_activate_selected (_tmp3_);
#line 2079 "../src/client/application/application-main-window.vala"
		application_main_window_navigate_next_pane (self);
#line 2081 "../src/client/application/application-main-window.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, ____lambda197__gsource_func, block20_data_ref (_data20_), block20_data_unref);
#line 12886 "application-main-window.c"
	} else {
#line 2086 "../src/client/application/application-main-window.vala"
		application_main_window_create_composer_from_viewer (self, _data20_->context_type, NULL, NULL);
#line 12890 "application-main-window.c"
	}
#line 2076 "../src/client/application/application-main-window.vala"
	block20_data_unref (_data20_);
#line 2076 "../src/client/application/application-main-window.vala"
	_data20_ = NULL;
#line 12896 "application-main-window.c"
}

static void
application_main_window_on_scan_completed (ApplicationMainWindow* self,
                                           GearyAppConversationMonitor* monitor)
{
	GtkScrollbar* scrollbar = NULL;
	ConversationListView* _tmp0_;
	GtkWidget* _tmp1_;
	GtkScrollbar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
#line 2090 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2090 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (monitor, GEARY_APP_TYPE_CONVERSATION_MONITOR));
#line 2093 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversation_list_view;
#line 2093 "../src/client/application/application-main-window.vala"
	_tmp1_ = gtk_scrolled_window_get_vscrollbar (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_scrolled_window_get_type (), GtkScrolledWindow));
#line 2093 "../src/client/application/application-main-window.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_scrollbar_get_type ()) ? ((GtkScrollbar*) _tmp1_) : NULL);
#line 2093 "../src/client/application/application-main-window.vala"
	scrollbar = _tmp2_;
#line 2096 "../src/client/application/application-main-window.vala"
	if (gtk_widget_is_visible (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget))) {
#line 12924 "application-main-window.c"
		gboolean _tmp6_ = FALSE;
		GtkScrollbar* _tmp7_;
#line 2097 "../src/client/application/application-main-window.vala"
		_tmp7_ = scrollbar;
#line 2097 "../src/client/application/application-main-window.vala"
		if (_tmp7_ == NULL) {
#line 2097 "../src/client/application/application-main-window.vala"
			_tmp6_ = TRUE;
#line 12933 "application-main-window.c"
		} else {
			GtkScrollbar* _tmp8_;
#line 2097 "../src/client/application/application-main-window.vala"
			_tmp8_ = scrollbar;
#line 2097 "../src/client/application/application-main-window.vala"
			_tmp6_ = !gtk_widget_get_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget));
#line 12940 "application-main-window.c"
		}
#line 2097 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp6_;
#line 12944 "application-main-window.c"
	} else {
#line 2096 "../src/client/application/application-main-window.vala"
		_tmp5_ = FALSE;
#line 12948 "application-main-window.c"
	}
#line 2096 "../src/client/application/application-main-window.vala"
	if (_tmp5_) {
#line 12952 "application-main-window.c"
		GearyAppConversationMonitor* _tmp9_;
#line 2098 "../src/client/application/application-main-window.vala"
		_tmp9_ = self->priv->_conversations;
#line 2098 "../src/client/application/application-main-window.vala"
		_tmp4_ = monitor == _tmp9_;
#line 12958 "application-main-window.c"
	} else {
#line 2096 "../src/client/application/application-main-window.vala"
		_tmp4_ = FALSE;
#line 12962 "application-main-window.c"
	}
#line 2096 "../src/client/application/application-main-window.vala"
	if (_tmp4_) {
#line 12966 "application-main-window.c"
		gboolean _tmp10_;
		gboolean _tmp11_;
#line 2099 "../src/client/application/application-main-window.vala"
		_tmp10_ = geary_app_conversation_monitor_get_can_load_more (monitor);
#line 2099 "../src/client/application/application-main-window.vala"
		_tmp11_ = _tmp10_;
#line 2099 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp11_;
#line 12975 "application-main-window.c"
	} else {
#line 2096 "../src/client/application/application-main-window.vala"
		_tmp3_ = FALSE;
#line 12979 "application-main-window.c"
	}
#line 2096 "../src/client/application/application-main-window.vala"
	if (_tmp3_) {
#line 12983 "application-main-window.c"
		GearyFolder* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		ConversationListView* _tmp15_;
#line 2100 "../src/client/application/application-main-window.vala"
		_tmp12_ = self->priv->_selected_folder;
#line 2100 "../src/client/application/application-main-window.vala"
		_tmp13_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 2100 "../src/client/application/application-main-window.vala"
		_tmp14_ = _tmp13_;
#line 2100 "../src/client/application/application-main-window.vala"
		g_debug ("application-main-window.vala:2100: Not enough messages, loading more f" \
"or folder %s", _tmp14_);
#line 2100 "../src/client/application/application-main-window.vala"
		_g_free0 (_tmp14_);
#line 2102 "../src/client/application/application-main-window.vala"
		_tmp15_ = self->priv->_conversation_list_view;
#line 2102 "../src/client/application/application-main-window.vala"
		conversation_list_view_load_more (_tmp15_, APPLICATION_MAIN_WINDOW_MIN_CONVERSATION_COUNT);
#line 13002 "application-main-window.c"
	}
#line 2090 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (scrollbar);
#line 13006 "application-main-window.c"
}

static void
application_main_window_on_scan_error (ApplicationMainWindow* self,
                                       GearyAppConversationMonitor* monitor,
                                       GError* err)
{
	GearyAccountInformation* account = NULL;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GearyAccount* _tmp2_;
	GearyAccount* _tmp3_;
	GearyAccountInformation* _tmp4_;
	GearyAccountInformation* _tmp5_;
	GearyAccountInformation* _tmp6_;
	ApplicationController* _tmp7_;
	GearyServiceInformation* _tmp8_;
	GearyServiceInformation* _tmp9_;
	GearyServiceProblemReport* _tmp10_;
	GearyServiceProblemReport* _tmp11_;
#line 2106 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2106 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (monitor, GEARY_APP_TYPE_CONVERSATION_MONITOR));
#line 2106 "../src/client/application/application-main-window.vala"
	g_return_if_fail (err != NULL);
#line 2108 "../src/client/application/application-main-window.vala"
	_tmp0_ = geary_app_conversation_monitor_get_base_folder (monitor);
#line 2108 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 2108 "../src/client/application/application-main-window.vala"
	_tmp2_ = geary_folder_get_account (_tmp1_);
#line 2108 "../src/client/application/application-main-window.vala"
	_tmp3_ = _tmp2_;
#line 2108 "../src/client/application/application-main-window.vala"
	_tmp4_ = geary_account_get_information (_tmp3_);
#line 2108 "../src/client/application/application-main-window.vala"
	_tmp5_ = _tmp4_;
#line 2108 "../src/client/application/application-main-window.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 2108 "../src/client/application/application-main-window.vala"
	account = _tmp6_;
#line 2110 "../src/client/application/application-main-window.vala"
	_tmp7_ = self->priv->controller;
#line 2110 "../src/client/application/application-main-window.vala"
	_tmp8_ = geary_account_information_get_incoming (account);
#line 2110 "../src/client/application/application-main-window.vala"
	_tmp9_ = _tmp8_;
#line 2110 "../src/client/application/application-main-window.vala"
	_tmp10_ = geary_service_problem_report_new (account, _tmp9_, err);
#line 2110 "../src/client/application/application-main-window.vala"
	_tmp11_ = _tmp10_;
#line 2110 "../src/client/application/application-main-window.vala"
	composer_application_interface_report_problem (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, COMPOSER_TYPE_APPLICATION_INTERFACE, ComposerApplicationInterface), G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEARY_TYPE_PROBLEM_REPORT, GearyProblemReport));
#line 2110 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp11_);
#line 2106 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (account);
#line 13065 "application-main-window.c"
}

static void
application_main_window_on_map (ApplicationMainWindow* self)
{
	GearyTimeoutManager* _tmp0_;
#line 2116 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2117 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->update_ui_timeout;
#line 2117 "../src/client/application/application-main-window.vala"
	geary_timeout_manager_start (_tmp0_);
#line 2118 "../src/client/application/application-main-window.vala"
	application_main_window_update_ui (self);
#line 13080 "application-main-window.c"
}

static void
_application_main_window_on_map_gtk_widget_map (GtkWidget* _sender,
                                                gpointer self)
{
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_on_map ((ApplicationMainWindow*) self);
#line 13089 "application-main-window.c"
}

static void
application_main_window_on_unmap (ApplicationMainWindow* self)
{
	GearyTimeoutManager* _tmp0_;
#line 2122 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2123 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->update_ui_timeout;
#line 2123 "../src/client/application/application-main-window.vala"
	geary_timeout_manager_reset (_tmp0_);
#line 13102 "application-main-window.c"
}

static void
_application_main_window_on_unmap_gtk_widget_unmap (GtkWidget* _sender,
                                                    gpointer self)
{
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_on_unmap ((ApplicationMainWindow*) self);
#line 13111 "application-main-window.c"
}

static gboolean
application_main_window_on_focus_event (ApplicationMainWindow* self)
{
	gboolean result;
#line 2127 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 2128 "../src/client/application/application-main-window.vala"
	application_main_window_set_shift_key_down (self, FALSE);
#line 2129 "../src/client/application/application-main-window.vala"
	result = FALSE;
#line 2129 "../src/client/application/application-main-window.vala"
	return result;
#line 13126 "application-main-window.c"
}

static gboolean
_application_main_window_on_focus_event_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                    GdkEventFocus* event,
                                                                    gpointer self)
{
	gboolean result;
	result = application_main_window_on_focus_event ((ApplicationMainWindow*) self);
#line 10 "../src/client/application/application-main-window.vala"
	return result;
#line 13138 "application-main-window.c"
}

static void
___lambda217_ (ApplicationMainWindow* self,
               GObject* obj,
               GAsyncResult* res)
{
#line 2140 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2140 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 2141 "../src/client/application/application-main-window.vala"
	application_main_window_select_folder_finish (self, res);
#line 2142 "../src/client/application/application-main-window.vala"
	gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 13154 "application-main-window.c"
}

static void
____lambda217__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2136 "../src/client/application/application-main-window.vala"
	___lambda217_ ((ApplicationMainWindow*) self, source_object, res);
#line 2136 "../src/client/application/application-main-window.vala"
	g_object_unref (self);
#line 13166 "application-main-window.c"
}

static gboolean
application_main_window_on_delete_event (ApplicationMainWindow* self)
{
	gboolean result;
#line 2133 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 2134 "../src/client/application/application-main-window.vala"
	if (application_main_window_close_composer (self, TRUE, FALSE)) {
#line 2135 "../src/client/application/application-main-window.vala"
		gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), FALSE);
#line 2136 "../src/client/application/application-main-window.vala"
		application_main_window_select_folder (self, NULL, FALSE, TRUE, ____lambda217__gasync_ready_callback, g_object_ref (self));
#line 13181 "application-main-window.c"
	}
#line 2146 "../src/client/application/application-main-window.vala"
	result = GDK_EVENT_STOP;
#line 2146 "../src/client/application/application-main-window.vala"
	return result;
#line 13187 "application-main-window.c"
}

static gboolean
_application_main_window_on_delete_event_gtk_widget_delete_event (GtkWidget* _sender,
                                                                  GdkEventAny* event,
                                                                  gpointer self)
{
	gboolean result;
	result = application_main_window_on_delete_event ((ApplicationMainWindow*) self);
#line 10 "../src/client/application/application-main-window.vala"
	return result;
#line 13199 "application-main-window.c"
}

static void
application_main_window_on_outer_leaflet_changed (ApplicationMainWindow* self)
{
	gint selected = 0;
	ConversationListView* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	HdyLeaflet* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
#line 2150 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2151 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversation_list_view;
#line 2151 "../src/client/application/application-main-window.vala"
	_tmp1_ = conversation_list_view_get_selected (_tmp0_);
#line 2151 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 2151 "../src/client/application/application-main-window.vala"
	_tmp3_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection));
#line 2151 "../src/client/application/application-main-window.vala"
	_tmp4_ = _tmp3_;
#line 2151 "../src/client/application/application-main-window.vala"
	selected = _tmp4_;
#line 2152 "../src/client/application/application-main-window.vala"
	application_main_window_update_conversation_actions (self, application_main_window_conversation_count_for_size (selected));
#line 2155 "../src/client/application/application-main-window.vala"
	application_main_window_update_close_button_position (self);
#line 2156 "../src/client/application/application-main-window.vala"
	_tmp5_ = self->priv->outer_leaflet;
#line 2156 "../src/client/application/application-main-window.vala"
	_tmp6_ = hdy_leaflet_get_folded (_tmp5_);
#line 2156 "../src/client/application/application-main-window.vala"
	_tmp7_ = _tmp6_;
#line 2156 "../src/client/application/application-main-window.vala"
	if (_tmp7_) {
#line 13240 "application-main-window.c"
		gboolean _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_;
		gboolean _tmp18_;
#line 2159 "../src/client/application/application-main-window.vala"
		_tmp8_ = application_main_window_get_is_conversation_list_shown (self);
#line 2159 "../src/client/application/application-main-window.vala"
		_tmp9_ = _tmp8_;
#line 2159 "../src/client/application/application-main-window.vala"
		if (_tmp9_) {
#line 13252 "application-main-window.c"
			ConversationListView* _tmp10_;
#line 2160 "../src/client/application/application-main-window.vala"
			_tmp10_ = self->priv->_conversation_list_view;
#line 2160 "../src/client/application/application-main-window.vala"
			gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_widget_get_type (), GtkWidget));
#line 13258 "application-main-window.c"
		} else {
			gboolean _tmp11_;
			gboolean _tmp12_;
#line 2161 "../src/client/application/application-main-window.vala"
			_tmp11_ = application_main_window_get_is_folder_list_shown (self);
#line 2161 "../src/client/application/application-main-window.vala"
			_tmp12_ = _tmp11_;
#line 2161 "../src/client/application/application-main-window.vala"
			if (_tmp12_) {
#line 13268 "application-main-window.c"
				FolderListTree* _tmp13_;
#line 2162 "../src/client/application/application-main-window.vala"
				_tmp13_ = self->priv->_folder_list;
#line 2162 "../src/client/application/application-main-window.vala"
				gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_widget_get_type (), GtkWidget));
#line 13274 "application-main-window.c"
			} else {
				ComponentsConversationHeaderBar* _tmp14_;
				GtkButton* _tmp15_;
#line 2164 "../src/client/application/application-main-window.vala"
				_tmp14_ = self->conversation_headerbar;
#line 2164 "../src/client/application/application-main-window.vala"
				_tmp15_ = _tmp14_->back_button;
#line 2164 "../src/client/application/application-main-window.vala"
				gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_widget_get_type (), GtkWidget), TRUE);
#line 13284 "application-main-window.c"
			}
		}
#line 2168 "../src/client/application/application-main-window.vala"
		_tmp17_ = application_main_window_get_has_composer (self);
#line 2168 "../src/client/application/application-main-window.vala"
		_tmp18_ = _tmp17_;
#line 2168 "../src/client/application/application-main-window.vala"
		if (_tmp18_) {
#line 13293 "application-main-window.c"
			gboolean _tmp19_ = FALSE;
			gboolean _tmp20_;
			gboolean _tmp21_;
#line 2169 "../src/client/application/application-main-window.vala"
			_tmp20_ = application_main_window_get_is_folder_list_shown (self);
#line 2169 "../src/client/application/application-main-window.vala"
			_tmp21_ = _tmp20_;
#line 2169 "../src/client/application/application-main-window.vala"
			if (_tmp21_) {
#line 2169 "../src/client/application/application-main-window.vala"
				_tmp19_ = TRUE;
#line 13305 "application-main-window.c"
			} else {
				gboolean _tmp22_;
				gboolean _tmp23_;
#line 2169 "../src/client/application/application-main-window.vala"
				_tmp22_ = application_main_window_get_is_conversation_list_shown (self);
#line 2169 "../src/client/application/application-main-window.vala"
				_tmp23_ = _tmp22_;
#line 2169 "../src/client/application/application-main-window.vala"
				_tmp19_ = _tmp23_;
#line 13315 "application-main-window.c"
			}
#line 2169 "../src/client/application/application-main-window.vala"
			_tmp16_ = _tmp19_;
#line 13319 "application-main-window.c"
		} else {
#line 2168 "../src/client/application/application-main-window.vala"
			_tmp16_ = FALSE;
#line 13323 "application-main-window.c"
		}
#line 2168 "../src/client/application/application-main-window.vala"
		if (_tmp16_) {
#line 2170 "../src/client/application/application-main-window.vala"
			application_main_window_close_composer (self, FALSE, FALSE);
#line 13329 "application-main-window.c"
		}
	} else {
		ComponentsConversationHeaderBar* _tmp24_;
		GtkButton* _tmp25_;
#line 2173 "../src/client/application/application-main-window.vala"
		_tmp24_ = self->conversation_headerbar;
#line 2173 "../src/client/application/application-main-window.vala"
		_tmp25_ = _tmp24_->back_button;
#line 2173 "../src/client/application/application-main-window.vala"
		gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 2174 "../src/client/application/application-main-window.vala"
		if (selected > 0) {
#line 13342 "application-main-window.c"
			ConversationListView* _tmp26_;
			GeeSet* _tmp27_;
			GeeSet* _tmp28_;
			GeeCollection* _tmp29_;
			GeeCollection* _tmp30_;
#line 2175 "../src/client/application/application-main-window.vala"
			_tmp26_ = self->priv->_conversation_list_view;
#line 2175 "../src/client/application/application-main-window.vala"
			_tmp27_ = conversation_list_view_get_selected (_tmp26_);
#line 2175 "../src/client/application/application-main-window.vala"
			_tmp28_ = _tmp27_;
#line 2175 "../src/client/application/application-main-window.vala"
			_tmp29_ = gee_collection_empty (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref);
#line 2175 "../src/client/application/application-main-window.vala"
			_tmp30_ = _tmp29_;
#line 2175 "../src/client/application/application-main-window.vala"
			application_main_window_select_conversations (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEE_TYPE_COLLECTION, GeeCollection), _tmp30_, FALSE, NULL, NULL);
#line 2175 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_tmp30_);
#line 13362 "application-main-window.c"
		}
	}
}

static void
_application_main_window_on_outer_leaflet_changed_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self)
{
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_on_outer_leaflet_changed ((ApplicationMainWindow*) self);
#line 13374 "application-main-window.c"
}

static void
application_main_window_on_inner_leaflet_changed (ApplicationMainWindow* self)
{
	HdyLeaflet* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 2185 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2186 "../src/client/application/application-main-window.vala"
	application_main_window_update_close_button_position (self);
#line 2187 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->inner_leaflet;
#line 2187 "../src/client/application/application-main-window.vala"
	_tmp1_ = hdy_leaflet_get_folded (_tmp0_);
#line 2187 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 2187 "../src/client/application/application-main-window.vala"
	if (_tmp2_) {
#line 13395 "application-main-window.c"
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 2190 "../src/client/application/application-main-window.vala"
		_tmp3_ = application_main_window_get_is_conversation_list_shown (self);
#line 2190 "../src/client/application/application-main-window.vala"
		_tmp4_ = _tmp3_;
#line 2190 "../src/client/application/application-main-window.vala"
		if (_tmp4_) {
#line 13404 "application-main-window.c"
			ComponentsConversationListHeaderBar* _tmp5_;
			GtkButton* _tmp6_;
			ConversationListView* _tmp7_;
#line 2191 "../src/client/application/application-main-window.vala"
			_tmp5_ = self->priv->conversation_list_headerbar;
#line 2191 "../src/client/application/application-main-window.vala"
			_tmp6_ = _tmp5_->back_button;
#line 2191 "../src/client/application/application-main-window.vala"
			gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget), TRUE);
#line 2192 "../src/client/application/application-main-window.vala"
			_tmp7_ = self->priv->_conversation_list_view;
#line 2192 "../src/client/application/application-main-window.vala"
			gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget));
#line 13418 "application-main-window.c"
		} else {
			gboolean _tmp8_;
			gboolean _tmp9_;
#line 2193 "../src/client/application/application-main-window.vala"
			_tmp8_ = application_main_window_get_is_folder_list_shown (self);
#line 2193 "../src/client/application/application-main-window.vala"
			_tmp9_ = _tmp8_;
#line 2193 "../src/client/application/application-main-window.vala"
			if (_tmp9_) {
#line 13428 "application-main-window.c"
				FolderListTree* _tmp10_;
#line 2194 "../src/client/application/application-main-window.vala"
				_tmp10_ = self->priv->_folder_list;
#line 2194 "../src/client/application/application-main-window.vala"
				gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_widget_get_type (), GtkWidget));
#line 13434 "application-main-window.c"
			}
		}
	} else {
		ComponentsConversationListHeaderBar* _tmp11_;
		GtkButton* _tmp12_;
#line 2197 "../src/client/application/application-main-window.vala"
		_tmp11_ = self->priv->conversation_list_headerbar;
#line 2197 "../src/client/application/application-main-window.vala"
		_tmp12_ = _tmp11_->back_button;
#line 2197 "../src/client/application/application-main-window.vala"
		gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 13446 "application-main-window.c"
	}
}

static void
_application_main_window_on_inner_leaflet_changed_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self)
{
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_on_inner_leaflet_changed ((ApplicationMainWindow*) self);
#line 13457 "application-main-window.c"
}

static void
application_main_window_on_offline_infobar_response (ApplicationMainWindow* self)
{
	ComponentsInfoBarStack* _tmp0_;
	ComponentsInfoBar* _tmp1_;
#line 2201 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2202 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->info_bars;
#line 2202 "../src/client/application/application-main-window.vala"
	_tmp1_ = self->priv->offline_infobar;
#line 2202 "../src/client/application/application-main-window.vala"
	components_info_bar_stack_remove (_tmp0_, _tmp1_);
#line 13473 "application-main-window.c"
}

static void
application_main_window_on_service_problem_retry (ApplicationMainWindow* self)
{
	ComponentsInfoBarStack* _tmp0_;
	ComponentsProblemReportInfoBar* _tmp1_;
#line 2205 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2206 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->info_bars;
#line 2206 "../src/client/application/application-main-window.vala"
	_tmp1_ = self->priv->service_problem_infobar;
#line 2206 "../src/client/application/application-main-window.vala"
	components_info_bar_stack_remove (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, COMPONENTS_TYPE_INFO_BAR, ComponentsInfoBar));
#line 2207 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->service_problem_infobar);
#line 2207 "../src/client/application/application-main-window.vala"
	self->priv->service_problem_infobar = NULL;
#line 2208 "../src/client/application/application-main-window.vala"
	g_signal_emit (self, application_main_window_signals[APPLICATION_MAIN_WINDOW_RETRY_SERVICE_PROBLEM_SIGNAL], 0, GEARY_CLIENT_SERVICE_STATUS_CONNECTION_FAILED);
#line 13495 "application-main-window.c"
}

static void
application_main_window_on_cert_problem_retry (ApplicationMainWindow* self)
{
	ComponentsInfoBarStack* _tmp0_;
	ComponentsInfoBar* _tmp1_;
#line 2211 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2212 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->info_bars;
#line 2212 "../src/client/application/application-main-window.vala"
	_tmp1_ = self->priv->cert_problem_infobar;
#line 2212 "../src/client/application/application-main-window.vala"
	components_info_bar_stack_remove (_tmp0_, _tmp1_);
#line 2213 "../src/client/application/application-main-window.vala"
	g_signal_emit (self, application_main_window_signals[APPLICATION_MAIN_WINDOW_RETRY_SERVICE_PROBLEM_SIGNAL], 0, GEARY_CLIENT_SERVICE_STATUS_TLS_VALIDATION_FAILED);
#line 13513 "application-main-window.c"
}

static void
application_main_window_on_auth_problem_retry (ApplicationMainWindow* self)
{
	ComponentsInfoBarStack* _tmp0_;
	ComponentsInfoBar* _tmp1_;
#line 2216 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2217 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->info_bars;
#line 2217 "../src/client/application/application-main-window.vala"
	_tmp1_ = self->priv->auth_problem_infobar;
#line 2217 "../src/client/application/application-main-window.vala"
	components_info_bar_stack_remove (_tmp0_, _tmp1_);
#line 2218 "../src/client/application/application-main-window.vala"
	g_signal_emit (self, application_main_window_signals[APPLICATION_MAIN_WINDOW_RETRY_SERVICE_PROBLEM_SIGNAL], 0, GEARY_CLIENT_SERVICE_STATUS_AUTHENTICATION_FAILED);
#line 13531 "application-main-window.c"
}

static void
application_main_window_on_update_ui_timeout (ApplicationMainWindow* self)
{
#line 2221 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2222 "../src/client/application/application-main-window.vala"
	application_main_window_update_ui (self);
#line 13541 "application-main-window.c"
}

static void
application_main_window_on_account_available (ApplicationMainWindow* self,
                                              ApplicationAccountContext* account)
{
#line 2225 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2225 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_ACCOUNT_CONTEXT (account));
#line 2226 "../src/client/application/application-main-window.vala"
	application_main_window_add_account (self, account);
#line 13554 "application-main-window.c"
}

static void
application_main_window_on_account_unavailable (ApplicationMainWindow* self,
                                                ApplicationAccountContext* account,
                                                gboolean is_shutdown)
{
	GearyFolder* to_select = NULL;
	GearyFolder* _tmp1_;
#line 2229 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2229 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_ACCOUNT_CONTEXT (account));
#line 2234 "../src/client/application/application-main-window.vala"
	to_select = NULL;
#line 2235 "../src/client/application/application-main-window.vala"
	if (!is_shutdown) {
#line 13572 "application-main-window.c"
		GearyFolder* _tmp0_;
#line 2236 "../src/client/application/application-main-window.vala"
		_tmp0_ = application_main_window_get_first_inbox (self);
#line 2236 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (to_select);
#line 2236 "../src/client/application/application-main-window.vala"
		to_select = _tmp0_;
#line 13580 "application-main-window.c"
	}
#line 2238 "../src/client/application/application-main-window.vala"
	_tmp1_ = to_select;
#line 2238 "../src/client/application/application-main-window.vala"
	application_main_window_remove_account (self, account, _tmp1_, NULL, NULL);
#line 2229 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (to_select);
#line 13588 "application-main-window.c"
}

static void
application_main_window_on_folders_available (ApplicationMainWindow* self,
                                              GeeCollection* available)
{
#line 2241 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2241 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (available, GEE_TYPE_COLLECTION));
#line 2242 "../src/client/application/application-main-window.vala"
	application_main_window_add_folders (self, available);
#line 13601 "application-main-window.c"
}

static void
application_main_window_on_folders_unavailable (ApplicationMainWindow* self,
                                                GeeCollection* unavailable)
{
#line 2245 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2245 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (unavailable, GEE_TYPE_COLLECTION));
#line 2246 "../src/client/application/application-main-window.vala"
	application_main_window_remove_folders (self, unavailable, TRUE);
#line 13614 "application-main-window.c"
}

static void
application_main_window_on_use_changed (ApplicationMainWindow* self,
                                        GearyFolder* folder,
                                        GearyFolderSpecialUse old_type,
                                        GearyFolderSpecialUse new_type)
{
	ApplicationAccountContext* context = NULL;
	ApplicationController* _tmp0_;
	GearyAccount* _tmp1_;
	GearyAccount* _tmp2_;
	GearyAccountInformation* _tmp3_;
	GearyAccountInformation* _tmp4_;
	ApplicationAccountContext* _tmp5_;
	ApplicationAccountContext* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 2249 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2249 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (folder, GEARY_TYPE_FOLDER));
#line 2253 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->controller;
#line 2253 "../src/client/application/application-main-window.vala"
	_tmp1_ = geary_folder_get_account (folder);
#line 2253 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 2253 "../src/client/application/application-main-window.vala"
	_tmp3_ = geary_account_get_information (_tmp2_);
#line 2253 "../src/client/application/application-main-window.vala"
	_tmp4_ = _tmp3_;
#line 2253 "../src/client/application/application-main-window.vala"
	_tmp5_ = application_account_interface_get_context_for_account (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface), _tmp4_);
#line 2253 "../src/client/application/application-main-window.vala"
	context = _tmp5_;
#line 2256 "../src/client/application/application-main-window.vala"
	_tmp6_ = context;
#line 2256 "../src/client/application/application-main-window.vala"
	if (_tmp6_ != NULL) {
#line 13654 "application-main-window.c"
		ApplicationFolderContext* folder_context = NULL;
		ApplicationAccountContext* _tmp7_;
		ApplicationFolderContext* _tmp8_;
		ApplicationFolderContext* _tmp9_;
#line 2257 "../src/client/application/application-main-window.vala"
		_tmp7_ = context;
#line 2257 "../src/client/application/application-main-window.vala"
		_tmp8_ = application_account_context_get_folder (_tmp7_, folder);
#line 2257 "../src/client/application/application-main-window.vala"
		folder_context = _tmp8_;
#line 2258 "../src/client/application/application-main-window.vala"
		_tmp9_ = folder_context;
#line 2258 "../src/client/application/application-main-window.vala"
		if (_tmp9_ != NULL) {
#line 13669 "application-main-window.c"
			FolderListTree* _tmp10_;
			ApplicationFolderContext* _tmp11_;
			FolderListTree* _tmp12_;
			ApplicationFolderContext* _tmp13_;
#line 2259 "../src/client/application/application-main-window.vala"
			_tmp10_ = self->priv->_folder_list;
#line 2259 "../src/client/application/application-main-window.vala"
			_tmp11_ = folder_context;
#line 2259 "../src/client/application/application-main-window.vala"
			folder_list_tree_remove_folder (_tmp10_, _tmp11_);
#line 2260 "../src/client/application/application-main-window.vala"
			_tmp12_ = self->priv->_folder_list;
#line 2260 "../src/client/application/application-main-window.vala"
			_tmp13_ = folder_context;
#line 2260 "../src/client/application/application-main-window.vala"
			folder_list_tree_add_folder (_tmp12_, _tmp13_);
#line 13686 "application-main-window.c"
			{
				GeeCollection* _tmp14_ = NULL;
				GearyAccount* _tmp15_;
				GearyAccount* _tmp16_;
				GearyFolderPath* _tmp17_;
				GearyFolderPath* _tmp18_;
				GeeCollection* _tmp19_;
#line 2267 "../src/client/application/application-main-window.vala"
				_tmp15_ = geary_folder_get_account (folder);
#line 2267 "../src/client/application/application-main-window.vala"
				_tmp16_ = _tmp15_;
#line 2267 "../src/client/application/application-main-window.vala"
				_tmp17_ = geary_folder_get_path (folder);
#line 2267 "../src/client/application/application-main-window.vala"
				_tmp18_ = _tmp17_;
#line 2267 "../src/client/application/application-main-window.vala"
				_tmp19_ = geary_account_list_matching_folders (_tmp16_, _tmp18_, &_inner_error0_);
#line 2267 "../src/client/application/application-main-window.vala"
				_tmp14_ = _tmp19_;
#line 2267 "../src/client/application/application-main-window.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13708 "application-main-window.c"
					goto __catch0_g_error;
				}
				{
					GeeIterator* _child_it = NULL;
					GeeIterator* _tmp20_;
#line 2266 "../src/client/application/application-main-window.vala"
					_tmp20_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2266 "../src/client/application/application-main-window.vala"
					_child_it = _tmp20_;
#line 2266 "../src/client/application/application-main-window.vala"
					while (TRUE) {
#line 13720 "application-main-window.c"
						GeeIterator* _tmp21_;
						GearyFolder* child = NULL;
						GeeIterator* _tmp22_;
						gpointer _tmp23_;
						ApplicationFolderContext* child_context = NULL;
						ApplicationAccountContext* _tmp24_;
						GearyFolder* _tmp25_;
						ApplicationFolderContext* _tmp26_;
						ApplicationFolderContext* _tmp27_;
#line 2266 "../src/client/application/application-main-window.vala"
						_tmp21_ = _child_it;
#line 2266 "../src/client/application/application-main-window.vala"
						if (!gee_iterator_next (_tmp21_)) {
#line 2266 "../src/client/application/application-main-window.vala"
							break;
#line 13736 "application-main-window.c"
						}
#line 2266 "../src/client/application/application-main-window.vala"
						_tmp22_ = _child_it;
#line 2266 "../src/client/application/application-main-window.vala"
						_tmp23_ = gee_iterator_get (_tmp22_);
#line 2266 "../src/client/application/application-main-window.vala"
						child = (GearyFolder*) _tmp23_;
#line 2268 "../src/client/application/application-main-window.vala"
						_tmp24_ = context;
#line 2268 "../src/client/application/application-main-window.vala"
						_tmp25_ = child;
#line 2268 "../src/client/application/application-main-window.vala"
						_tmp26_ = application_account_context_get_folder (_tmp24_, _tmp25_);
#line 2268 "../src/client/application/application-main-window.vala"
						child_context = _tmp26_;
#line 2269 "../src/client/application/application-main-window.vala"
						_tmp27_ = child_context;
#line 2269 "../src/client/application/application-main-window.vala"
						if (_tmp27_ != NULL) {
#line 13756 "application-main-window.c"
							FolderListTree* _tmp28_;
							ApplicationFolderContext* _tmp29_;
#line 2270 "../src/client/application/application-main-window.vala"
							_tmp28_ = self->priv->_folder_list;
#line 2270 "../src/client/application/application-main-window.vala"
							_tmp29_ = child_context;
#line 2270 "../src/client/application/application-main-window.vala"
							folder_list_tree_add_folder (_tmp28_, _tmp29_);
#line 13765 "application-main-window.c"
						}
#line 2266 "../src/client/application/application-main-window.vala"
						_g_object_unref0 (child_context);
#line 2266 "../src/client/application/application-main-window.vala"
						_g_object_unref0 (child);
#line 13771 "application-main-window.c"
					}
#line 2266 "../src/client/application/application-main-window.vala"
					_g_object_unref0 (_child_it);
#line 13775 "application-main-window.c"
				}
#line 2265 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_tmp14_);
#line 13779 "application-main-window.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
#line 2265 "../src/client/application/application-main-window.vala"
				g_clear_error (&_inner_error0_);
#line 13786 "application-main-window.c"
			}
			__finally0:
#line 2265 "../src/client/application/application-main-window.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2265 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (folder_context);
#line 2265 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (context);
#line 2265 "../src/client/application/application-main-window.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2265 "../src/client/application/application-main-window.vala"
				g_clear_error (&_inner_error0_);
#line 2265 "../src/client/application/application-main-window.vala"
				return;
#line 13801 "application-main-window.c"
			}
		}
#line 2256 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (folder_context);
#line 13806 "application-main-window.c"
	}
#line 2249 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (context);
#line 13810 "application-main-window.c"
}

static void
application_main_window_on_command_execute (ApplicationMainWindow* self,
                                            ApplicationCommand* command)
{
#line 2280 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2280 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_COMMAND (command));
#line 2281 "../src/client/application/application-main-window.vala"
	if (!APPLICATION_IS_TRIVIAL_COMMAND (command)) {
#line 2284 "../src/client/application/application-main-window.vala"
		application_main_window_on_command_redo (self, command);
#line 13825 "application-main-window.c"
	} else {
#line 2288 "../src/client/application/application-main-window.vala"
		application_main_window_update_command_actions (self);
#line 13829 "application-main-window.c"
	}
}

static void
application_main_window_on_command_undo (ApplicationMainWindow* self,
                                         ApplicationCommand* command)
{
	ApplicationEmailCommand* email = NULL;
	ApplicationEmailCommand* _tmp0_;
	ApplicationEmailCommand* _tmp1_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
#line 2292 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2292 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_COMMAND (command));
#line 2293 "../src/client/application/application-main-window.vala"
	application_main_window_update_command_actions (self);
#line 2294 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (APPLICATION_IS_EMAIL_COMMAND (command) ? ((ApplicationEmailCommand*) command) : NULL);
#line 2294 "../src/client/application/application-main-window.vala"
	email = _tmp0_;
#line 2295 "../src/client/application/application-main-window.vala"
	_tmp1_ = email;
#line 2295 "../src/client/application/application-main-window.vala"
	if (_tmp1_ != NULL) {
#line 13856 "application-main-window.c"
		ApplicationEmailCommand* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 2296 "../src/client/application/application-main-window.vala"
		_tmp2_ = email;
#line 2296 "../src/client/application/application-main-window.vala"
		_tmp3_ = application_email_command_get_conversations (_tmp2_);
#line 2296 "../src/client/application/application-main-window.vala"
		_tmp4_ = _tmp3_;
#line 2296 "../src/client/application/application-main-window.vala"
		_tmp5_ = gee_collection_get_size (_tmp4_);
#line 2296 "../src/client/application/application-main-window.vala"
		_tmp6_ = _tmp5_;
#line 2296 "../src/client/application/application-main-window.vala"
		if (_tmp6_ > 1) {
#line 13874 "application-main-window.c"
			ApplicationEmailCommand* _tmp7_;
			GearyFolder* _tmp8_;
			GearyFolder* _tmp9_;
			ApplicationEmailCommand* _tmp10_;
			GeeCollection* _tmp11_;
			GeeCollection* _tmp12_;
#line 2297 "../src/client/application/application-main-window.vala"
			_tmp7_ = email;
#line 2297 "../src/client/application/application-main-window.vala"
			_tmp8_ = application_email_command_get_location (_tmp7_);
#line 2297 "../src/client/application/application-main-window.vala"
			_tmp9_ = _tmp8_;
#line 2297 "../src/client/application/application-main-window.vala"
			_tmp10_ = email;
#line 2297 "../src/client/application/application-main-window.vala"
			_tmp11_ = application_email_command_get_conversations (_tmp10_);
#line 2297 "../src/client/application/application-main-window.vala"
			_tmp12_ = _tmp11_;
#line 2297 "../src/client/application/application-main-window.vala"
			application_main_window_show_conversations (self, _tmp9_, _tmp12_, FALSE, NULL, NULL);
#line 13895 "application-main-window.c"
		} else {
			ApplicationEmailCommand* _tmp13_;
			GearyFolder* _tmp14_;
			GearyFolder* _tmp15_;
			ApplicationEmailCommand* _tmp16_;
			GeeCollection* _tmp17_;
			GeeCollection* _tmp18_;
#line 2301 "../src/client/application/application-main-window.vala"
			_tmp13_ = email;
#line 2301 "../src/client/application/application-main-window.vala"
			_tmp14_ = application_email_command_get_location (_tmp13_);
#line 2301 "../src/client/application/application-main-window.vala"
			_tmp15_ = _tmp14_;
#line 2301 "../src/client/application/application-main-window.vala"
			_tmp16_ = email;
#line 2301 "../src/client/application/application-main-window.vala"
			_tmp17_ = application_email_command_get_email (_tmp16_);
#line 2301 "../src/client/application/application-main-window.vala"
			_tmp18_ = _tmp17_;
#line 2301 "../src/client/application/application-main-window.vala"
			application_main_window_show_email (self, _tmp15_, _tmp18_, FALSE, NULL, NULL);
#line 13917 "application-main-window.c"
		}
	}
#line 2306 "../src/client/application/application-main-window.vala"
	_tmp19_ = application_command_get_undone_label (command);
#line 2306 "../src/client/application/application-main-window.vala"
	_tmp20_ = _tmp19_;
#line 2306 "../src/client/application/application-main-window.vala"
	if (_tmp20_ != NULL) {
#line 13926 "application-main-window.c"
		ComponentsInAppNotification* ian = NULL;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		ComponentsInAppNotification* _tmp23_;
		ComponentsInAppNotification* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		ComponentsInAppNotification* _tmp27_;
#line 2307 "../src/client/application/application-main-window.vala"
		_tmp21_ = application_command_get_undone_label (command);
#line 2307 "../src/client/application/application-main-window.vala"
		_tmp22_ = _tmp21_;
#line 2307 "../src/client/application/application-main-window.vala"
		_tmp23_ = components_in_app_notification_new (_tmp22_, COMPONENTS_IN_APP_NOTIFICATION_DEFAULT_DURATION);
#line 2307 "../src/client/application/application-main-window.vala"
		g_object_ref_sink (_tmp23_);
#line 2307 "../src/client/application/application-main-window.vala"
		ian = _tmp23_;
#line 2309 "../src/client/application/application-main-window.vala"
		_tmp24_ = ian;
#line 2309 "../src/client/application/application-main-window.vala"
		_tmp25_ = action_edit_prefix (ACTION_EDIT_REDO);
#line 2309 "../src/client/application/application-main-window.vala"
		_tmp26_ = _tmp25_;
#line 2309 "../src/client/application/application-main-window.vala"
		components_in_app_notification_set_button (_tmp24_, _ ("Redo"), _tmp26_);
#line 2309 "../src/client/application/application-main-window.vala"
		_g_free0 (_tmp26_);
#line 2310 "../src/client/application/application-main-window.vala"
		_tmp27_ = ian;
#line 2310 "../src/client/application/application-main-window.vala"
		application_main_window_add_notification (self, _tmp27_);
#line 2306 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (ian);
#line 13961 "application-main-window.c"
	}
#line 2292 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (email);
#line 13965 "application-main-window.c"
}

static void
application_main_window_on_command_redo (ApplicationMainWindow* self,
                                         ApplicationCommand* command)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 2314 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2314 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_COMMAND (command));
#line 2315 "../src/client/application/application-main-window.vala"
	application_main_window_update_command_actions (self);
#line 2316 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_command_get_executed_label (command);
#line 2316 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 2316 "../src/client/application/application-main-window.vala"
	if (_tmp1_ != NULL) {
#line 13986 "application-main-window.c"
		guint notification_time = 0U;
		gboolean _tmp2_;
		gboolean _tmp3_;
		ComponentsInAppNotification* ian = NULL;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		ComponentsInAppNotification* _tmp12_;
		ComponentsInAppNotification* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		ComponentsInAppNotification* _tmp16_;
#line 2317 "../src/client/application/application-main-window.vala"
		notification_time = COMPONENTS_IN_APP_NOTIFICATION_DEFAULT_DURATION;
#line 2319 "../src/client/application/application-main-window.vala"
		_tmp2_ = application_command_get_executed_notification_brief (command);
#line 2319 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2319 "../src/client/application/application-main-window.vala"
		if (_tmp3_) {
#line 14006 "application-main-window.c"
			ApplicationClient* _tmp4_;
			ApplicationClient* _tmp5_;
			ApplicationConfiguration* _tmp6_;
			ApplicationConfiguration* _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
#line 2320 "../src/client/application/application-main-window.vala"
			_tmp4_ = application_main_window_get_application (self);
#line 2320 "../src/client/application/application-main-window.vala"
			_tmp5_ = _tmp4_;
#line 2320 "../src/client/application/application-main-window.vala"
			_tmp6_ = application_client_get_config (_tmp5_);
#line 2320 "../src/client/application/application-main-window.vala"
			_tmp7_ = _tmp6_;
#line 2320 "../src/client/application/application-main-window.vala"
			_tmp8_ = application_configuration_get_brief_notification_duration (_tmp7_);
#line 2320 "../src/client/application/application-main-window.vala"
			_tmp9_ = _tmp8_;
#line 2320 "../src/client/application/application-main-window.vala"
			notification_time = (guint) _tmp9_;
#line 14027 "application-main-window.c"
		}
#line 2323 "../src/client/application/application-main-window.vala"
		_tmp10_ = application_command_get_executed_label (command);
#line 2323 "../src/client/application/application-main-window.vala"
		_tmp11_ = _tmp10_;
#line 2323 "../src/client/application/application-main-window.vala"
		_tmp12_ = components_in_app_notification_new (_tmp11_, notification_time);
#line 2323 "../src/client/application/application-main-window.vala"
		g_object_ref_sink (_tmp12_);
#line 2323 "../src/client/application/application-main-window.vala"
		ian = _tmp12_;
#line 2326 "../src/client/application/application-main-window.vala"
		_tmp13_ = ian;
#line 2326 "../src/client/application/application-main-window.vala"
		_tmp14_ = action_edit_prefix (ACTION_EDIT_UNDO);
#line 2326 "../src/client/application/application-main-window.vala"
		_tmp15_ = _tmp14_;
#line 2326 "../src/client/application/application-main-window.vala"
		components_in_app_notification_set_button (_tmp13_, _ ("Undo"), _tmp15_);
#line 2326 "../src/client/application/application-main-window.vala"
		_g_free0 (_tmp15_);
#line 2327 "../src/client/application/application-main-window.vala"
		_tmp16_ = ian;
#line 2327 "../src/client/application/application-main-window.vala"
		application_main_window_add_notification (self, _tmp16_);
#line 2316 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (ian);
#line 14055 "application-main-window.c"
	}
}

static void
_application_main_window_on_email_loaded_conversation_list_box_email_loaded (ConversationListBox* _sender,
                                                                             GearyEmail* email,
                                                                             gpointer self)
{
#line 2332 "../src/client/application/application-main-window.vala"
	application_main_window_on_email_loaded ((ApplicationMainWindow*) self, _sender, email);
#line 14066 "application-main-window.c"
}

static void
_application_main_window_on_email_mark_conversation_list_box_mark_email (ConversationListBox* _sender,
                                                                         GeeCollection* email,
                                                                         GearyNamedFlag* to_add,
                                                                         GearyNamedFlag* to_remove,
                                                                         gpointer self)
{
#line 2333 "../src/client/application/application-main-window.vala"
	application_main_window_on_email_mark ((ApplicationMainWindow*) self, _sender, email, to_add, to_remove);
#line 14078 "application-main-window.c"
}

static void
_application_main_window_on_email_reply_to_all_conversation_list_box_reply_to_all_email (ConversationListBox* _sender,
                                                                                         GearyEmail* email,
                                                                                         const gchar* quote,
                                                                                         gpointer self)
{
#line 2334 "../src/client/application/application-main-window.vala"
	application_main_window_on_email_reply_to_all ((ApplicationMainWindow*) self, email, quote);
#line 14089 "application-main-window.c"
}

static void
_application_main_window_on_email_reply_to_sender_conversation_list_box_reply_to_sender_email (ConversationListBox* _sender,
                                                                                               GearyEmail* email,
                                                                                               const gchar* quote,
                                                                                               gpointer self)
{
#line 2335 "../src/client/application/application-main-window.vala"
	application_main_window_on_email_reply_to_sender ((ApplicationMainWindow*) self, email, quote);
#line 14100 "application-main-window.c"
}

static void
_application_main_window_on_email_forward_conversation_list_box_forward_email (ConversationListBox* _sender,
                                                                               GearyEmail* email,
                                                                               const gchar* quote,
                                                                               gpointer self)
{
#line 2336 "../src/client/application/application-main-window.vala"
	application_main_window_on_email_forward ((ApplicationMainWindow*) self, email, quote);
#line 14111 "application-main-window.c"
}

static void
_application_main_window_on_email_trash_conversation_list_box_trash_email (ConversationListBox* _sender,
                                                                           GearyEmail* email,
                                                                           gpointer self)
{
#line 2337 "../src/client/application/application-main-window.vala"
	application_main_window_on_email_trash ((ApplicationMainWindow*) self, _sender, email);
#line 14121 "application-main-window.c"
}

static void
_application_main_window_on_email_delete_conversation_list_box_delete_email (ConversationListBox* _sender,
                                                                             GearyEmail* email,
                                                                             gpointer self)
{
#line 2338 "../src/client/application/application-main-window.vala"
	application_main_window_on_email_delete ((ApplicationMainWindow*) self, _sender, email);
#line 14131 "application-main-window.c"
}

static void
application_main_window_on_conversation_view_added (ApplicationMainWindow* self,
                                                    ConversationListBox* list)
{
#line 2331 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2331 "../src/client/application/application-main-window.vala"
	g_return_if_fail (IS_CONVERSATION_LIST_BOX (list));
#line 2332 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (list, "email-loaded", (GCallback) _application_main_window_on_email_loaded_conversation_list_box_email_loaded, self, 0);
#line 2333 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (list, "mark-email", (GCallback) _application_main_window_on_email_mark_conversation_list_box_mark_email, self, 0);
#line 2334 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (list, "reply-to-all-email", (GCallback) _application_main_window_on_email_reply_to_all_conversation_list_box_reply_to_all_email, self, 0);
#line 2335 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (list, "reply-to-sender-email", (GCallback) _application_main_window_on_email_reply_to_sender_conversation_list_box_reply_to_sender_email, self, 0);
#line 2336 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (list, "forward-email", (GCallback) _application_main_window_on_email_forward_conversation_list_box_forward_email, self, 0);
#line 2337 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (list, "trash-email", (GCallback) _application_main_window_on_email_trash_conversation_list_box_trash_email, self, 0);
#line 2338 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (list, "delete-email", (GCallback) _application_main_window_on_email_delete_conversation_list_box_delete_email, self, 0);
#line 14156 "application-main-window.c"
}

static void
application_main_window_on_undo (ApplicationMainWindow* self)
{
#line 2343 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2344 "../src/client/application/application-main-window.vala"
	application_main_window_undo (self, NULL, NULL);
#line 14166 "application-main-window.c"
}

static void
application_main_window_on_redo (ApplicationMainWindow* self)
{
#line 2347 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2348 "../src/client/application/application-main-window.vala"
	application_main_window_redo (self, NULL, NULL);
#line 14176 "application-main-window.c"
}

static void
application_main_window_on_close (ApplicationMainWindow* self)
{
#line 2351 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2352 "../src/client/application/application-main-window.vala"
	gtk_window_close (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
#line 14186 "application-main-window.c"
}

static void
application_main_window_on_has_toplevel_focus (ApplicationMainWindow* self)
{
	GearyFolder* _tmp0_;
#line 2357 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2358 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2358 "../src/client/application/application-main-window.vala"
	if (_tmp0_ != NULL) {
#line 14199 "application-main-window.c"
		ApplicationController* _tmp1_;
		GearyFolder* _tmp2_;
		ConversationListView* _tmp3_;
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
#line 2359 "../src/client/application/application-main-window.vala"
		_tmp1_ = self->priv->controller;
#line 2359 "../src/client/application/application-main-window.vala"
		_tmp2_ = self->priv->_selected_folder;
#line 2359 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->_conversation_list_view;
#line 2359 "../src/client/application/application-main-window.vala"
		_tmp4_ = conversation_list_view_get_visible_conversations (_tmp3_);
#line 2359 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2359 "../src/client/application/application-main-window.vala"
		application_controller_clear_new_messages (_tmp1_, _tmp2_, _tmp5_);
#line 14217 "application-main-window.c"
	}
}

static void
application_main_window_on_folder_selected (ApplicationMainWindow* self,
                                            GearyFolder* folder)
{
#line 2366 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2366 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((folder == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (folder, GEARY_TYPE_FOLDER));
#line 2367 "../src/client/application/application-main-window.vala"
	application_main_window_select_folder (self, folder, TRUE, FALSE, NULL, NULL);
#line 14231 "application-main-window.c"
}

static void
application_main_window_on_select_inbox (ApplicationMainWindow* self,
                                         GSimpleAction* action,
                                         GVariant* parameter)
{
	GError* _inner_error0_ = NULL;
#line 2370 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2370 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_simple_action_get_type ()));
#line 2371 "../src/client/application/application-main-window.vala"
	if (parameter != NULL) {
#line 14246 "application-main-window.c"
		gint account_number = 0;
#line 2372 "../src/client/application/application-main-window.vala"
		account_number = (gint) g_variant_get_int32 (parameter);
#line 14250 "application-main-window.c"
		{
			GeeCollection* accounts = NULL;
			ApplicationClient* _tmp0_;
			ApplicationClient* _tmp1_;
			GearyEngine* _tmp2_;
			GearyEngine* _tmp3_;
			GeeCollection* _tmp4_;
			GeeCollection* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
#line 2374 "../src/client/application/application-main-window.vala"
			_tmp0_ = application_main_window_get_application (self);
#line 2374 "../src/client/application/application-main-window.vala"
			_tmp1_ = _tmp0_;
#line 2374 "../src/client/application/application-main-window.vala"
			_tmp2_ = application_client_get_engine (_tmp1_);
#line 2374 "../src/client/application/application-main-window.vala"
			_tmp3_ = _tmp2_;
#line 2374 "../src/client/application/application-main-window.vala"
			_tmp4_ = geary_engine_get_accounts (_tmp3_, &_inner_error0_);
#line 2374 "../src/client/application/application-main-window.vala"
			accounts = _tmp4_;
#line 2374 "../src/client/application/application-main-window.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14275 "application-main-window.c"
				goto __catch0_g_error;
			}
#line 2376 "../src/client/application/application-main-window.vala"
			_tmp5_ = accounts;
#line 2376 "../src/client/application/application-main-window.vala"
			_tmp6_ = gee_collection_get_size (_tmp5_);
#line 2376 "../src/client/application/application-main-window.vala"
			_tmp7_ = _tmp6_;
#line 2376 "../src/client/application/application-main-window.vala"
			if (account_number < _tmp7_) {
#line 14286 "application-main-window.c"
				GearyAccount* account = NULL;
				GeeCollection* _tmp8_;
				gint _tmp9_ = 0;
				gpointer* _tmp10_;
				GearyAccount** _tmp11_;
				gint _tmp11__length1;
				GearyAccount* _tmp12_;
				GearyAccount* _tmp13_;
				GearyAccount* _tmp14_;
				GearyFolder* inbox = NULL;
				GearyAccount* _tmp15_;
				GearyFolder* _tmp16_;
				GearyFolder* _tmp17_;
#line 2377 "../src/client/application/application-main-window.vala"
				_tmp8_ = accounts;
#line 2377 "../src/client/application/application-main-window.vala"
				_tmp10_ = gee_collection_to_array (_tmp8_, &_tmp9_);
#line 2377 "../src/client/application/application-main-window.vala"
				_tmp11_ = _tmp10_;
#line 2377 "../src/client/application/application-main-window.vala"
				_tmp11__length1 = _tmp9_;
#line 2377 "../src/client/application/application-main-window.vala"
				_tmp12_ = _tmp11_[account_number];
#line 2377 "../src/client/application/application-main-window.vala"
				_tmp13_ = _g_object_ref0 (_tmp12_);
#line 2377 "../src/client/application/application-main-window.vala"
				_tmp14_ = _tmp13_;
#line 2377 "../src/client/application/application-main-window.vala"
				_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_object_unref), NULL);
#line 2377 "../src/client/application/application-main-window.vala"
				account = _tmp14_;
#line 2378 "../src/client/application/application-main-window.vala"
				_tmp15_ = account;
#line 2378 "../src/client/application/application-main-window.vala"
				_tmp16_ = geary_account_get_special_folder (_tmp15_, GEARY_FOLDER_SPECIAL_USE_INBOX);
#line 2378 "../src/client/application/application-main-window.vala"
				inbox = _tmp16_;
#line 2379 "../src/client/application/application-main-window.vala"
				_tmp17_ = inbox;
#line 2379 "../src/client/application/application-main-window.vala"
				application_main_window_select_folder (self, _tmp17_, TRUE, FALSE, NULL, NULL);
#line 2376 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (inbox);
#line 2376 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (account);
#line 14332 "application-main-window.c"
			}
#line 2373 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (accounts);
#line 14336 "application-main-window.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 2373 "../src/client/application/application-main-window.vala"
			g_clear_error (&_inner_error0_);
#line 2382 "../src/client/application/application-main-window.vala"
			g_debug ("application-main-window.vala:2382: Error getting accounts");
#line 14345 "application-main-window.c"
		}
		__finally0:
#line 2373 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2373 "../src/client/application/application-main-window.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2373 "../src/client/application/application-main-window.vala"
			g_clear_error (&_inner_error0_);
#line 2373 "../src/client/application/application-main-window.vala"
			return;
#line 14356 "application-main-window.c"
		}
	}
}

static void
application_main_window_on_search (ApplicationMainWindow* self,
                                   const gchar* text)
{
#line 2387 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2387 "../src/client/application/application-main-window.vala"
	g_return_if_fail (text != NULL);
#line 2388 "../src/client/application/application-main-window.vala"
	if (geary_string_is_empty_or_whitespace (text)) {
#line 2389 "../src/client/application/application-main-window.vala"
		application_main_window_stop_search (self, TRUE);
#line 14373 "application-main-window.c"
	} else {
#line 2391 "../src/client/application/application-main-window.vala"
		application_main_window_start_search (self, text, TRUE);
#line 14377 "application-main-window.c"
	}
}

static void
application_main_window_on_visible_conversations_changed (ApplicationMainWindow* self)
{
	GearyFolder* _tmp0_;
#line 2395 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2396 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2396 "../src/client/application/application-main-window.vala"
	if (_tmp0_ != NULL) {
#line 14391 "application-main-window.c"
		ApplicationController* _tmp1_;
		GearyFolder* _tmp2_;
		ConversationListView* _tmp3_;
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
#line 2397 "../src/client/application/application-main-window.vala"
		_tmp1_ = self->priv->controller;
#line 2397 "../src/client/application/application-main-window.vala"
		_tmp2_ = self->priv->_selected_folder;
#line 2397 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->_conversation_list_view;
#line 2397 "../src/client/application/application-main-window.vala"
		_tmp4_ = conversation_list_view_get_visible_conversations (_tmp3_);
#line 2397 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2397 "../src/client/application/application-main-window.vala"
		application_controller_clear_new_messages (_tmp1_, _tmp2_, _tmp5_);
#line 14409 "application-main-window.c"
	}
}

static void
application_main_window_on_folder_activated (ApplicationMainWindow* self,
                                             GearyFolder* folder)
{
#line 2401 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2401 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((folder == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (folder, GEARY_TYPE_FOLDER));
#line 2402 "../src/client/application/application-main-window.vala"
	if (folder != NULL) {
#line 14423 "application-main-window.c"
		ApplicationClient* _tmp0_;
		ApplicationClient* _tmp1_;
		ApplicationConfiguration* _tmp2_;
		ApplicationConfiguration* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 2404 "../src/client/application/application-main-window.vala"
		_tmp0_ = application_main_window_get_application (self);
#line 2404 "../src/client/application/application-main-window.vala"
		_tmp1_ = _tmp0_;
#line 2404 "../src/client/application/application-main-window.vala"
		_tmp2_ = application_client_get_config (_tmp1_);
#line 2404 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2404 "../src/client/application/application-main-window.vala"
		_tmp4_ = application_configuration_get_autoselect (_tmp3_);
#line 2404 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2404 "../src/client/application/application-main-window.vala"
		application_main_window_go_to_next_pane (self, !_tmp5_);
#line 14444 "application-main-window.c"
	}
}

static void
application_main_window_on_find_in_conversation_action (ApplicationMainWindow* self)
{
	ConversationViewer* _tmp0_;
#line 2408 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2409 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversation_viewer;
#line 2409 "../src/client/application/application-main-window.vala"
	conversation_viewer_enable_find (_tmp0_);
#line 14458 "application-main-window.c"
}

static void
application_main_window_on_search_activated (ApplicationMainWindow* self)
{
#line 2412 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2413 "../src/client/application/application-main-window.vala"
	application_main_window_show_search_bar (self, NULL);
#line 14468 "application-main-window.c"
}

static void
application_main_window_on_zoom (ApplicationMainWindow* self,
                                 GSimpleAction* action,
                                 GVariant* parameter)
{
	ConversationListBox* view = NULL;
	ConversationViewer* _tmp0_;
	ConversationListBox* _tmp1_;
	ConversationListBox* _tmp2_;
	ConversationListBox* _tmp3_;
	gboolean _tmp4_ = FALSE;
	ConversationListBox* _tmp5_;
#line 2416 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2416 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_simple_action_get_type ()));
#line 2417 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversation_viewer;
#line 2417 "../src/client/application/application-main-window.vala"
	_tmp1_ = conversation_viewer_get_current_list (_tmp0_);
#line 2417 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 2417 "../src/client/application/application-main-window.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 2417 "../src/client/application/application-main-window.vala"
	view = _tmp3_;
#line 2418 "../src/client/application/application-main-window.vala"
	_tmp5_ = view;
#line 2418 "../src/client/application/application-main-window.vala"
	if (_tmp5_ != NULL) {
#line 2418 "../src/client/application/application-main-window.vala"
		_tmp4_ = parameter != NULL;
#line 14503 "application-main-window.c"
	} else {
#line 2418 "../src/client/application/application-main-window.vala"
		_tmp4_ = FALSE;
#line 14507 "application-main-window.c"
	}
#line 2418 "../src/client/application/application-main-window.vala"
	if (_tmp4_) {
#line 14511 "application-main-window.c"
		gchar* zoom_action = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
#line 2419 "../src/client/application/application-main-window.vala"
		_tmp6_ = g_variant_get_string (parameter, NULL);
#line 2419 "../src/client/application/application-main-window.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 2419 "../src/client/application/application-main-window.vala"
		zoom_action = _tmp7_;
#line 2420 "../src/client/application/application-main-window.vala"
		_tmp8_ = zoom_action;
#line 2420 "../src/client/application/application-main-window.vala"
		if (g_strcmp0 (_tmp8_, "in") == 0) {
#line 14526 "application-main-window.c"
			ConversationListBox* _tmp9_;
#line 2421 "../src/client/application/application-main-window.vala"
			_tmp9_ = view;
#line 2421 "../src/client/application/application-main-window.vala"
			conversation_list_box_zoom_in (_tmp9_);
#line 14532 "application-main-window.c"
		} else {
			const gchar* _tmp10_;
#line 2422 "../src/client/application/application-main-window.vala"
			_tmp10_ = zoom_action;
#line 2422 "../src/client/application/application-main-window.vala"
			if (g_strcmp0 (_tmp10_, "out") == 0) {
#line 14539 "application-main-window.c"
				ConversationListBox* _tmp11_;
#line 2423 "../src/client/application/application-main-window.vala"
				_tmp11_ = view;
#line 2423 "../src/client/application/application-main-window.vala"
				conversation_list_box_zoom_out (_tmp11_);
#line 14545 "application-main-window.c"
			} else {
				ConversationListBox* _tmp12_;
#line 2425 "../src/client/application/application-main-window.vala"
				_tmp12_ = view;
#line 2425 "../src/client/application/application-main-window.vala"
				conversation_list_box_zoom_reset (_tmp12_);
#line 14552 "application-main-window.c"
			}
		}
#line 2418 "../src/client/application/application-main-window.vala"
		_g_free0 (zoom_action);
#line 14557 "application-main-window.c"
	}
#line 2416 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (view);
#line 14561 "application-main-window.c"
}

static void
application_main_window_on_reply_conversation (ApplicationMainWindow* self)
{
#line 2429 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2430 "../src/client/application/application-main-window.vala"
	application_main_window_reply_conversation (self, COMPOSER_WIDGET_CONTEXT_TYPE_REPLY_SENDER);
#line 14571 "application-main-window.c"
}

static void
application_main_window_on_reply_all_conversation (ApplicationMainWindow* self)
{
#line 2433 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2434 "../src/client/application/application-main-window.vala"
	application_main_window_reply_conversation (self, COMPOSER_WIDGET_CONTEXT_TYPE_REPLY_ALL);
#line 14581 "application-main-window.c"
}

static void
application_main_window_on_forward_conversation (ApplicationMainWindow* self)
{
#line 2437 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2438 "../src/client/application/application-main-window.vala"
	application_main_window_reply_conversation (self, COMPOSER_WIDGET_CONTEXT_TYPE_FORWARD);
#line 14591 "application-main-window.c"
}

static void
application_main_window_on_show_window_menu (ApplicationMainWindow* self)
{
#line 2441 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2442 "../src/client/application/application-main-window.vala"
	application_main_window_show_window_menu (self);
#line 14601 "application-main-window.c"
}

static void
application_main_window_on_show_help_overlay (ApplicationMainWindow* self)
{
	GtkShortcutsWindow* overlay = NULL;
	GtkShortcutsWindow* _tmp0_;
	GtkShortcutsWindow* _tmp1_;
#line 2445 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2446 "../src/client/application/application-main-window.vala"
	_tmp0_ = gtk_application_window_get_help_overlay (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_window_get_type (), GtkApplicationWindow));
#line 2446 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2446 "../src/client/application/application-main-window.vala"
	overlay = _tmp1_;
#line 2447 "../src/client/application/application-main-window.vala"
	g_object_set (overlay, "section-name", "conversation", NULL);
#line 2448 "../src/client/application/application-main-window.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (overlay, gtk_widget_get_type (), GtkWidget));
#line 2445 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (overlay);
#line 14624 "application-main-window.c"
}

static void
application_main_window_on_show_copy_menu (ApplicationMainWindow* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 2451 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2452 "../src/client/application/application-main-window.vala"
	_tmp1_ = application_main_window_get_is_conversation_list_shown (self);
#line 2452 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 2452 "../src/client/application/application-main-window.vala"
	if (_tmp2_) {
#line 14641 "application-main-window.c"
		GtkRevealer* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 2453 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->conversation_list_actions_revealer;
#line 2453 "../src/client/application/application-main-window.vala"
		_tmp4_ = gtk_revealer_get_child_revealed (_tmp3_);
#line 2453 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2453 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp5_;
#line 14653 "application-main-window.c"
	} else {
#line 2452 "../src/client/application/application-main-window.vala"
		_tmp0_ = FALSE;
#line 14657 "application-main-window.c"
	}
#line 2452 "../src/client/application/application-main-window.vala"
	if (_tmp0_) {
#line 14661 "application-main-window.c"
		ComponentsConversationActions* _tmp6_;
#line 2454 "../src/client/application/application-main-window.vala"
		_tmp6_ = self->priv->conversation_list_actions;
#line 2454 "../src/client/application/application-main-window.vala"
		components_conversation_actions_show_copy_menu (_tmp6_);
#line 14667 "application-main-window.c"
	} else {
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 2455 "../src/client/application/application-main-window.vala"
		_tmp7_ = application_main_window_get_is_conversation_viewer_shown (self);
#line 2455 "../src/client/application/application-main-window.vala"
		_tmp8_ = _tmp7_;
#line 2455 "../src/client/application/application-main-window.vala"
		if (_tmp8_) {
#line 14677 "application-main-window.c"
			ComponentsConversationHeaderBar* _tmp9_;
			ComponentsConversationActions* _tmp10_;
			ComponentsConversationActions* _tmp11_;
#line 2456 "../src/client/application/application-main-window.vala"
			_tmp9_ = self->conversation_headerbar;
#line 2456 "../src/client/application/application-main-window.vala"
			_tmp10_ = components_conversation_header_bar_get_shown_actions (_tmp9_);
#line 2456 "../src/client/application/application-main-window.vala"
			_tmp11_ = _tmp10_;
#line 2456 "../src/client/application/application-main-window.vala"
			components_conversation_actions_show_copy_menu (_tmp11_);
#line 14689 "application-main-window.c"
		} else {
#line 2458 "../src/client/application/application-main-window.vala"
			gtk_widget_error_bell (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 14693 "application-main-window.c"
		}
	}
}

static void
application_main_window_on_conversation_up (ApplicationMainWindow* self)
{
	ConversationListView* _tmp0_;
#line 2462 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2463 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversation_list_view;
#line 2463 "../src/client/application/application-main-window.vala"
	conversation_list_view_scroll (_tmp0_, GTK_SCROLL_STEP_UP);
#line 14708 "application-main-window.c"
}

static void
application_main_window_on_conversation_down (ApplicationMainWindow* self)
{
	ConversationListView* _tmp0_;
#line 2466 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2467 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversation_list_view;
#line 2467 "../src/client/application/application-main-window.vala"
	conversation_list_view_scroll (_tmp0_, GTK_SCROLL_STEP_DOWN);
#line 14721 "application-main-window.c"
}

static void
application_main_window_on_show_mark_menu (ApplicationMainWindow* self)
{
	gboolean unread_selected = FALSE;
	gboolean read_selected = FALSE;
	gboolean starred_selected = FALSE;
	gboolean unstarred_selected = FALSE;
	GSimpleAction* _tmp23_;
	GSimpleAction* _tmp24_;
	GSimpleAction* _tmp25_;
	GSimpleAction* _tmp26_;
	GSimpleAction* _tmp27_;
	GSimpleAction* _tmp28_;
	GSimpleAction* _tmp29_;
	GSimpleAction* _tmp30_;
	gboolean in_junk_folder = FALSE;
	GearyFolder* _tmp31_;
	GearyFolderSpecialUse _tmp32_;
	GearyFolderSpecialUse _tmp33_;
	gboolean _tmp34_ = FALSE;
	gboolean _tmp35_ = FALSE;
	GSimpleAction* _tmp42_;
	GSimpleAction* _tmp43_;
#line 2470 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2471 "../src/client/application/application-main-window.vala"
	unread_selected = FALSE;
#line 2472 "../src/client/application/application-main-window.vala"
	read_selected = FALSE;
#line 2473 "../src/client/application/application-main-window.vala"
	starred_selected = FALSE;
#line 2474 "../src/client/application/application-main-window.vala"
	unstarred_selected = FALSE;
#line 14757 "application-main-window.c"
	{
		GeeIterator* _conversation_it = NULL;
		ConversationListView* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
#line 2475 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->_conversation_list_view;
#line 2475 "../src/client/application/application-main-window.vala"
		_tmp1_ = conversation_list_view_get_selected (_tmp0_);
#line 2475 "../src/client/application/application-main-window.vala"
		_tmp2_ = _tmp1_;
#line 2475 "../src/client/application/application-main-window.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2475 "../src/client/application/application-main-window.vala"
		_conversation_it = _tmp3_;
#line 2475 "../src/client/application/application-main-window.vala"
		while (TRUE) {
#line 14776 "application-main-window.c"
			GeeIterator* _tmp4_;
			GearyAppConversation* conversation = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			GearyAppConversation* _tmp7_;
			GearyEmail* latest = NULL;
			GearyAppConversation* _tmp8_;
			GearyEmail* _tmp9_;
			gboolean _tmp10_ = FALSE;
			gboolean _tmp11_ = FALSE;
			GearyEmail* _tmp12_;
			GearyAppConversation* _tmp22_;
#line 2475 "../src/client/application/application-main-window.vala"
			_tmp4_ = _conversation_it;
#line 2475 "../src/client/application/application-main-window.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 2475 "../src/client/application/application-main-window.vala"
				break;
#line 14795 "application-main-window.c"
			}
#line 2475 "../src/client/application/application-main-window.vala"
			_tmp5_ = _conversation_it;
#line 2475 "../src/client/application/application-main-window.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 2475 "../src/client/application/application-main-window.vala"
			conversation = (GearyAppConversation*) _tmp6_;
#line 2477 "../src/client/application/application-main-window.vala"
			_tmp7_ = conversation;
#line 2477 "../src/client/application/application-main-window.vala"
			if (geary_app_conversation_is_unread (_tmp7_)) {
#line 2478 "../src/client/application/application-main-window.vala"
				unread_selected = TRUE;
#line 14809 "application-main-window.c"
			}
#line 2484 "../src/client/application/application-main-window.vala"
			_tmp8_ = conversation;
#line 2484 "../src/client/application/application-main-window.vala"
			_tmp9_ = geary_app_conversation_get_latest_sent_email (_tmp8_, GEARY_APP_CONVERSATION_LOCATION_IN_FOLDER_OUT_OF_FOLDER, NULL);
#line 2484 "../src/client/application/application-main-window.vala"
			latest = _tmp9_;
#line 2486 "../src/client/application/application-main-window.vala"
			_tmp12_ = latest;
#line 2486 "../src/client/application/application-main-window.vala"
			if (_tmp12_ != NULL) {
#line 14821 "application-main-window.c"
				GearyEmail* _tmp13_;
				GearyEmailFlags* _tmp14_;
				GearyEmailFlags* _tmp15_;
#line 2486 "../src/client/application/application-main-window.vala"
				_tmp13_ = latest;
#line 2486 "../src/client/application/application-main-window.vala"
				_tmp14_ = geary_email_get_email_flags (_tmp13_);
#line 2486 "../src/client/application/application-main-window.vala"
				_tmp15_ = _tmp14_;
#line 2486 "../src/client/application/application-main-window.vala"
				_tmp11_ = _tmp15_ != NULL;
#line 14833 "application-main-window.c"
			} else {
#line 2486 "../src/client/application/application-main-window.vala"
				_tmp11_ = FALSE;
#line 14837 "application-main-window.c"
			}
#line 2486 "../src/client/application/application-main-window.vala"
			if (_tmp11_) {
#line 14841 "application-main-window.c"
				GearyEmail* _tmp16_;
				GearyEmailFlags* _tmp17_;
				GearyEmailFlags* _tmp18_;
				GearyNamedFlag* _tmp19_;
				GearyNamedFlag* _tmp20_;
				GearyNamedFlag* _tmp21_;
#line 2487 "../src/client/application/application-main-window.vala"
				_tmp16_ = latest;
#line 2487 "../src/client/application/application-main-window.vala"
				_tmp17_ = geary_email_get_email_flags (_tmp16_);
#line 2487 "../src/client/application/application-main-window.vala"
				_tmp18_ = _tmp17_;
#line 2487 "../src/client/application/application-main-window.vala"
				_tmp19_ = geary_email_flags_get_UNREAD ();
#line 2487 "../src/client/application/application-main-window.vala"
				_tmp20_ = _tmp19_;
#line 2487 "../src/client/application/application-main-window.vala"
				_tmp21_ = _tmp20_;
#line 2487 "../src/client/application/application-main-window.vala"
				_tmp10_ = !geary_named_flags_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEARY_TYPE_NAMED_FLAGS, GearyNamedFlags), _tmp21_);
#line 2487 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_tmp21_);
#line 14864 "application-main-window.c"
			} else {
#line 2486 "../src/client/application/application-main-window.vala"
				_tmp10_ = FALSE;
#line 14868 "application-main-window.c"
			}
#line 2486 "../src/client/application/application-main-window.vala"
			if (_tmp10_) {
#line 2488 "../src/client/application/application-main-window.vala"
				read_selected = TRUE;
#line 14874 "application-main-window.c"
			}
#line 2490 "../src/client/application/application-main-window.vala"
			_tmp22_ = conversation;
#line 2490 "../src/client/application/application-main-window.vala"
			if (geary_app_conversation_is_flagged (_tmp22_)) {
#line 2491 "../src/client/application/application-main-window.vala"
				starred_selected = TRUE;
#line 14882 "application-main-window.c"
			} else {
#line 2493 "../src/client/application/application-main-window.vala"
				unstarred_selected = TRUE;
#line 14886 "application-main-window.c"
			}
#line 2475 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (latest);
#line 2475 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (conversation);
#line 14892 "application-main-window.c"
		}
#line 2475 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_conversation_it);
#line 14896 "application-main-window.c"
	}
#line 2496 "../src/client/application/application-main-window.vala"
	_tmp23_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_READ);
#line 2496 "../src/client/application/application-main-window.vala"
	_tmp24_ = _tmp23_;
#line 2496 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp24_, unread_selected);
#line 2496 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp24_);
#line 2497 "../src/client/application/application-main-window.vala"
	_tmp25_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_UNREAD);
#line 2497 "../src/client/application/application-main-window.vala"
	_tmp26_ = _tmp25_;
#line 2497 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp26_, read_selected);
#line 2497 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp26_);
#line 2498 "../src/client/application/application-main-window.vala"
	_tmp27_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_STARRED);
#line 2498 "../src/client/application/application-main-window.vala"
	_tmp28_ = _tmp27_;
#line 2498 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp28_, unstarred_selected);
#line 2498 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp28_);
#line 2499 "../src/client/application/application-main-window.vala"
	_tmp29_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_UNSTARRED);
#line 2499 "../src/client/application/application-main-window.vala"
	_tmp30_ = _tmp29_;
#line 2499 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp30_, starred_selected);
#line 2499 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp30_);
#line 2502 "../src/client/application/application-main-window.vala"
	_tmp31_ = self->priv->_selected_folder;
#line 2502 "../src/client/application/application-main-window.vala"
	_tmp32_ = geary_folder_get_used_as (_tmp31_);
#line 2502 "../src/client/application/application-main-window.vala"
	_tmp33_ = _tmp32_;
#line 2502 "../src/client/application/application-main-window.vala"
	in_junk_folder = _tmp33_ == GEARY_FOLDER_SPECIAL_USE_JUNK;
#line 2504 "../src/client/application/application-main-window.vala"
	if (!in_junk_folder) {
#line 14940 "application-main-window.c"
		GearyFolder* _tmp36_;
		GearyFolderSpecialUse _tmp37_;
		GearyFolderSpecialUse _tmp38_;
#line 2505 "../src/client/application/application-main-window.vala"
		_tmp36_ = self->priv->_selected_folder;
#line 2505 "../src/client/application/application-main-window.vala"
		_tmp37_ = geary_folder_get_used_as (_tmp36_);
#line 2505 "../src/client/application/application-main-window.vala"
		_tmp38_ = _tmp37_;
#line 2505 "../src/client/application/application-main-window.vala"
		_tmp35_ = _tmp38_ != GEARY_FOLDER_SPECIAL_USE_DRAFTS;
#line 14952 "application-main-window.c"
	} else {
#line 2504 "../src/client/application/application-main-window.vala"
		_tmp35_ = FALSE;
#line 14956 "application-main-window.c"
	}
#line 2504 "../src/client/application/application-main-window.vala"
	if (_tmp35_) {
#line 14960 "application-main-window.c"
		GearyFolder* _tmp39_;
		GearyFolderSpecialUse _tmp40_;
		GearyFolderSpecialUse _tmp41_;
#line 2506 "../src/client/application/application-main-window.vala"
		_tmp39_ = self->priv->_selected_folder;
#line 2506 "../src/client/application/application-main-window.vala"
		_tmp40_ = geary_folder_get_used_as (_tmp39_);
#line 2506 "../src/client/application/application-main-window.vala"
		_tmp41_ = _tmp40_;
#line 2506 "../src/client/application/application-main-window.vala"
		_tmp34_ = _tmp41_ != GEARY_FOLDER_SPECIAL_USE_OUTBOX;
#line 14972 "application-main-window.c"
	} else {
#line 2504 "../src/client/application/application-main-window.vala"
		_tmp34_ = FALSE;
#line 14976 "application-main-window.c"
	}
#line 2503 "../src/client/application/application-main-window.vala"
	_tmp42_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_TOGGLE_JUNK);
#line 2503 "../src/client/application/application-main-window.vala"
	_tmp43_ = _tmp42_;
#line 2503 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp43_, _tmp34_);
#line 2503 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp43_);
#line 14986 "application-main-window.c"
}

static Block21Data*
block21_data_ref (Block21Data* _data21_)
{
#line 2510 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data21_->_ref_count_);
#line 2510 "../src/client/application/application-main-window.vala"
	return _data21_;
#line 14996 "application-main-window.c"
}

static void
block21_data_unref (void * _userdata_)
{
	Block21Data* _data21_;
	_data21_ = (Block21Data*) _userdata_;
#line 2510 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data21_->_ref_count_)) {
#line 15006 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2510 "../src/client/application/application-main-window.vala"
		self = _data21_->self;
#line 2510 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data21_->location);
#line 2510 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2510 "../src/client/application/application-main-window.vala"
		g_slice_free (Block21Data, _data21_);
#line 15016 "application-main-window.c"
	}
}

static void
___lambda210_ (Block21Data* _data21_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2519 "../src/client/application/application-main-window.vala"
	self = _data21_->self;
#line 2519 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2519 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 15033 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2521 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2521 "../src/client/application/application-main-window.vala"
		application_controller_mark_conversations_finish (_tmp0_, res, &_inner_error0_);
#line 2521 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15042 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolder* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2520 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2520 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2523 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data21_->location;
#line 2523 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (_tmp1_);
#line 2523 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2523 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2523 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2523 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2523 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2520 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 15076 "application-main-window.c"
	}
	__finally0:
#line 2520 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2520 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2520 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2520 "../src/client/application/application-main-window.vala"
		return;
#line 15087 "application-main-window.c"
	}
}

static void
____lambda210__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2514 "../src/client/application/application-main-window.vala"
	___lambda210_ (self, source_object, res);
#line 2514 "../src/client/application/application-main-window.vala"
	block21_data_unref (self);
#line 15100 "application-main-window.c"
}

static void
application_main_window_on_mark_conversations (ApplicationMainWindow* self,
                                               GeeCollection* conversations,
                                               GearyNamedFlag* flag)
{
	Block21Data* _data21_;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GearyFolder* _tmp2_;
#line 2510 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2510 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (conversations, GEE_TYPE_COLLECTION));
#line 2510 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (flag, GEARY_TYPE_NAMED_FLAG));
#line 2510 "../src/client/application/application-main-window.vala"
	_data21_ = g_slice_new0 (Block21Data);
#line 2510 "../src/client/application/application-main-window.vala"
	_data21_->_ref_count_ = 1;
#line 2510 "../src/client/application/application-main-window.vala"
	_data21_->self = g_object_ref (self);
#line 2512 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2512 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2512 "../src/client/application/application-main-window.vala"
	_data21_->location = _tmp1_;
#line 2513 "../src/client/application/application-main-window.vala"
	_tmp2_ = _data21_->location;
#line 2513 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 15134 "application-main-window.c"
		ApplicationController* _tmp3_;
		GearyFolder* _tmp4_;
#line 2514 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->controller;
#line 2514 "../src/client/application/application-main-window.vala"
		_tmp4_ = _data21_->location;
#line 2514 "../src/client/application/application-main-window.vala"
		application_controller_mark_conversations (_tmp3_, _tmp4_, conversations, flag, TRUE, ____lambda210__gasync_ready_callback, block21_data_ref (_data21_));
#line 15143 "application-main-window.c"
	}
#line 2510 "../src/client/application/application-main-window.vala"
	block21_data_unref (_data21_);
#line 2510 "../src/client/application/application-main-window.vala"
	_data21_ = NULL;
#line 15149 "application-main-window.c"
}

static Block22Data*
block22_data_ref (Block22Data* _data22_)
{
#line 2530 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data22_->_ref_count_);
#line 2530 "../src/client/application/application-main-window.vala"
	return _data22_;
#line 15159 "application-main-window.c"
}

static void
block22_data_unref (void * _userdata_)
{
	Block22Data* _data22_;
	_data22_ = (Block22Data*) _userdata_;
#line 2530 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data22_->_ref_count_)) {
#line 15169 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2530 "../src/client/application/application-main-window.vala"
		self = _data22_->self;
#line 2530 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data22_->location);
#line 2530 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2530 "../src/client/application/application-main-window.vala"
		g_slice_free (Block22Data, _data22_);
#line 15179 "application-main-window.c"
	}
}

static void
___lambda201_ (Block22Data* _data22_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2538 "../src/client/application/application-main-window.vala"
	self = _data22_->self;
#line 2538 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2538 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 15196 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2540 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2540 "../src/client/application/application-main-window.vala"
		application_controller_mark_conversations_finish (_tmp0_, res, &_inner_error0_);
#line 2540 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15205 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolder* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2539 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2539 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2542 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data22_->location;
#line 2542 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (_tmp1_);
#line 2542 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2542 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2542 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2542 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2542 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2539 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 15239 "application-main-window.c"
	}
	__finally0:
#line 2539 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2539 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2539 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2539 "../src/client/application/application-main-window.vala"
		return;
#line 15250 "application-main-window.c"
	}
}

static void
____lambda201__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2533 "../src/client/application/application-main-window.vala"
	___lambda201_ (self, source_object, res);
#line 2533 "../src/client/application/application-main-window.vala"
	block22_data_unref (self);
#line 15263 "application-main-window.c"
}

static void
application_main_window_on_mark_as_read (ApplicationMainWindow* self)
{
	Block22Data* _data22_;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GearyFolder* _tmp2_;
	ConversationListView* _tmp11_;
#line 2530 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2530 "../src/client/application/application-main-window.vala"
	_data22_ = g_slice_new0 (Block22Data);
#line 2530 "../src/client/application/application-main-window.vala"
	_data22_->_ref_count_ = 1;
#line 2530 "../src/client/application/application-main-window.vala"
	_data22_->self = g_object_ref (self);
#line 2531 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2531 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2531 "../src/client/application/application-main-window.vala"
	_data22_->location = _tmp1_;
#line 2532 "../src/client/application/application-main-window.vala"
	_tmp2_ = _data22_->location;
#line 2532 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 15292 "application-main-window.c"
		ApplicationController* _tmp3_;
		GearyFolder* _tmp4_;
		ConversationListView* _tmp5_;
		GeeSet* _tmp6_;
		GeeSet* _tmp7_;
		GearyNamedFlag* _tmp8_;
		GearyNamedFlag* _tmp9_;
		GearyNamedFlag* _tmp10_;
#line 2533 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->controller;
#line 2533 "../src/client/application/application-main-window.vala"
		_tmp4_ = _data22_->location;
#line 2533 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->_conversation_list_view;
#line 2533 "../src/client/application/application-main-window.vala"
		_tmp6_ = conversation_list_view_get_selected (_tmp5_);
#line 2533 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 2533 "../src/client/application/application-main-window.vala"
		_tmp8_ = geary_email_flags_get_UNREAD ();
#line 2533 "../src/client/application/application-main-window.vala"
		_tmp9_ = _tmp8_;
#line 2533 "../src/client/application/application-main-window.vala"
		_tmp10_ = _tmp9_;
#line 2533 "../src/client/application/application-main-window.vala"
		application_controller_mark_conversations (_tmp3_, _tmp4_, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection), _tmp10_, FALSE, ____lambda201__gasync_ready_callback, block22_data_ref (_data22_));
#line 2533 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp10_);
#line 15321 "application-main-window.c"
	}
#line 2547 "../src/client/application/application-main-window.vala"
	_tmp11_ = self->priv->_conversation_list_view;
#line 2547 "../src/client/application/application-main-window.vala"
	conversation_list_view_set_selection_mode_enabled (_tmp11_, FALSE);
#line 2530 "../src/client/application/application-main-window.vala"
	block22_data_unref (_data22_);
#line 2530 "../src/client/application/application-main-window.vala"
	_data22_ = NULL;
#line 15331 "application-main-window.c"
}

static Block23Data*
block23_data_ref (Block23Data* _data23_)
{
#line 2550 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data23_->_ref_count_);
#line 2550 "../src/client/application/application-main-window.vala"
	return _data23_;
#line 15341 "application-main-window.c"
}

static void
block23_data_unref (void * _userdata_)
{
	Block23Data* _data23_;
	_data23_ = (Block23Data*) _userdata_;
#line 2550 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data23_->_ref_count_)) {
#line 15351 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2550 "../src/client/application/application-main-window.vala"
		self = _data23_->self;
#line 2550 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data23_->location);
#line 2550 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2550 "../src/client/application/application-main-window.vala"
		g_slice_free (Block23Data, _data23_);
#line 15361 "application-main-window.c"
	}
}

static void
___lambda202_ (Block23Data* _data23_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2558 "../src/client/application/application-main-window.vala"
	self = _data23_->self;
#line 2558 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2558 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 15378 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2560 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2560 "../src/client/application/application-main-window.vala"
		application_controller_mark_conversations_finish (_tmp0_, res, &_inner_error0_);
#line 2560 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15387 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolder* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2559 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2559 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2562 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data23_->location;
#line 2562 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (_tmp1_);
#line 2562 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2562 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2562 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2562 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2562 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2559 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 15421 "application-main-window.c"
	}
	__finally0:
#line 2559 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2559 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2559 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2559 "../src/client/application/application-main-window.vala"
		return;
#line 15432 "application-main-window.c"
	}
}

static void
____lambda202__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2553 "../src/client/application/application-main-window.vala"
	___lambda202_ (self, source_object, res);
#line 2553 "../src/client/application/application-main-window.vala"
	block23_data_unref (self);
#line 15445 "application-main-window.c"
}

static void
application_main_window_on_mark_as_unread (ApplicationMainWindow* self)
{
	Block23Data* _data23_;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GearyFolder* _tmp2_;
	ConversationListView* _tmp11_;
#line 2550 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2550 "../src/client/application/application-main-window.vala"
	_data23_ = g_slice_new0 (Block23Data);
#line 2550 "../src/client/application/application-main-window.vala"
	_data23_->_ref_count_ = 1;
#line 2550 "../src/client/application/application-main-window.vala"
	_data23_->self = g_object_ref (self);
#line 2551 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2551 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2551 "../src/client/application/application-main-window.vala"
	_data23_->location = _tmp1_;
#line 2552 "../src/client/application/application-main-window.vala"
	_tmp2_ = _data23_->location;
#line 2552 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 15474 "application-main-window.c"
		ApplicationController* _tmp3_;
		GearyFolder* _tmp4_;
		ConversationListView* _tmp5_;
		GeeSet* _tmp6_;
		GeeSet* _tmp7_;
		GearyNamedFlag* _tmp8_;
		GearyNamedFlag* _tmp9_;
		GearyNamedFlag* _tmp10_;
#line 2553 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->controller;
#line 2553 "../src/client/application/application-main-window.vala"
		_tmp4_ = _data23_->location;
#line 2553 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->_conversation_list_view;
#line 2553 "../src/client/application/application-main-window.vala"
		_tmp6_ = conversation_list_view_get_selected (_tmp5_);
#line 2553 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 2553 "../src/client/application/application-main-window.vala"
		_tmp8_ = geary_email_flags_get_UNREAD ();
#line 2553 "../src/client/application/application-main-window.vala"
		_tmp9_ = _tmp8_;
#line 2553 "../src/client/application/application-main-window.vala"
		_tmp10_ = _tmp9_;
#line 2553 "../src/client/application/application-main-window.vala"
		application_controller_mark_conversations (_tmp3_, _tmp4_, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection), _tmp10_, TRUE, ____lambda202__gasync_ready_callback, block23_data_ref (_data23_));
#line 2553 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp10_);
#line 15503 "application-main-window.c"
	}
#line 2567 "../src/client/application/application-main-window.vala"
	_tmp11_ = self->priv->_conversation_list_view;
#line 2567 "../src/client/application/application-main-window.vala"
	conversation_list_view_set_selection_mode_enabled (_tmp11_, FALSE);
#line 2550 "../src/client/application/application-main-window.vala"
	block23_data_unref (_data23_);
#line 2550 "../src/client/application/application-main-window.vala"
	_data23_ = NULL;
#line 15513 "application-main-window.c"
}

static Block24Data*
block24_data_ref (Block24Data* _data24_)
{
#line 2570 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data24_->_ref_count_);
#line 2570 "../src/client/application/application-main-window.vala"
	return _data24_;
#line 15523 "application-main-window.c"
}

static void
block24_data_unref (void * _userdata_)
{
	Block24Data* _data24_;
	_data24_ = (Block24Data*) _userdata_;
#line 2570 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data24_->_ref_count_)) {
#line 15533 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2570 "../src/client/application/application-main-window.vala"
		self = _data24_->self;
#line 2570 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data24_->location);
#line 2570 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2570 "../src/client/application/application-main-window.vala"
		g_slice_free (Block24Data, _data24_);
#line 15543 "application-main-window.c"
	}
}

static void
___lambda203_ (Block24Data* _data24_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2578 "../src/client/application/application-main-window.vala"
	self = _data24_->self;
#line 2578 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2578 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 15560 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2580 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2580 "../src/client/application/application-main-window.vala"
		application_controller_mark_conversations_finish (_tmp0_, res, &_inner_error0_);
#line 2580 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15569 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolder* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2579 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2579 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2582 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data24_->location;
#line 2582 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (_tmp1_);
#line 2582 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2582 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2582 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2582 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2582 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2579 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 15603 "application-main-window.c"
	}
	__finally0:
#line 2579 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2579 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2579 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2579 "../src/client/application/application-main-window.vala"
		return;
#line 15614 "application-main-window.c"
	}
}

static void
____lambda203__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2573 "../src/client/application/application-main-window.vala"
	___lambda203_ (self, source_object, res);
#line 2573 "../src/client/application/application-main-window.vala"
	block24_data_unref (self);
#line 15627 "application-main-window.c"
}

static void
application_main_window_on_mark_as_starred (ApplicationMainWindow* self)
{
	Block24Data* _data24_;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GearyFolder* _tmp2_;
	ConversationListView* _tmp11_;
#line 2570 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2570 "../src/client/application/application-main-window.vala"
	_data24_ = g_slice_new0 (Block24Data);
#line 2570 "../src/client/application/application-main-window.vala"
	_data24_->_ref_count_ = 1;
#line 2570 "../src/client/application/application-main-window.vala"
	_data24_->self = g_object_ref (self);
#line 2571 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2571 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2571 "../src/client/application/application-main-window.vala"
	_data24_->location = _tmp1_;
#line 2572 "../src/client/application/application-main-window.vala"
	_tmp2_ = _data24_->location;
#line 2572 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 15656 "application-main-window.c"
		ApplicationController* _tmp3_;
		GearyFolder* _tmp4_;
		ConversationListView* _tmp5_;
		GeeSet* _tmp6_;
		GeeSet* _tmp7_;
		GearyNamedFlag* _tmp8_;
		GearyNamedFlag* _tmp9_;
		GearyNamedFlag* _tmp10_;
#line 2573 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->controller;
#line 2573 "../src/client/application/application-main-window.vala"
		_tmp4_ = _data24_->location;
#line 2573 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->_conversation_list_view;
#line 2573 "../src/client/application/application-main-window.vala"
		_tmp6_ = conversation_list_view_get_selected (_tmp5_);
#line 2573 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 2573 "../src/client/application/application-main-window.vala"
		_tmp8_ = geary_email_flags_get_FLAGGED ();
#line 2573 "../src/client/application/application-main-window.vala"
		_tmp9_ = _tmp8_;
#line 2573 "../src/client/application/application-main-window.vala"
		_tmp10_ = _tmp9_;
#line 2573 "../src/client/application/application-main-window.vala"
		application_controller_mark_conversations (_tmp3_, _tmp4_, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection), _tmp10_, TRUE, ____lambda203__gasync_ready_callback, block24_data_ref (_data24_));
#line 2573 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp10_);
#line 15685 "application-main-window.c"
	}
#line 2587 "../src/client/application/application-main-window.vala"
	_tmp11_ = self->priv->_conversation_list_view;
#line 2587 "../src/client/application/application-main-window.vala"
	conversation_list_view_set_selection_mode_enabled (_tmp11_, FALSE);
#line 2570 "../src/client/application/application-main-window.vala"
	block24_data_unref (_data24_);
#line 2570 "../src/client/application/application-main-window.vala"
	_data24_ = NULL;
#line 15695 "application-main-window.c"
}

static Block25Data*
block25_data_ref (Block25Data* _data25_)
{
#line 2590 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data25_->_ref_count_);
#line 2590 "../src/client/application/application-main-window.vala"
	return _data25_;
#line 15705 "application-main-window.c"
}

static void
block25_data_unref (void * _userdata_)
{
	Block25Data* _data25_;
	_data25_ = (Block25Data*) _userdata_;
#line 2590 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data25_->_ref_count_)) {
#line 15715 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2590 "../src/client/application/application-main-window.vala"
		self = _data25_->self;
#line 2590 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data25_->location);
#line 2590 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2590 "../src/client/application/application-main-window.vala"
		g_slice_free (Block25Data, _data25_);
#line 15725 "application-main-window.c"
	}
}

static void
___lambda204_ (Block25Data* _data25_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2598 "../src/client/application/application-main-window.vala"
	self = _data25_->self;
#line 2598 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2598 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 15742 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2600 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2600 "../src/client/application/application-main-window.vala"
		application_controller_mark_conversations_finish (_tmp0_, res, &_inner_error0_);
#line 2600 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15751 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolder* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2599 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2599 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2602 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data25_->location;
#line 2602 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (_tmp1_);
#line 2602 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2602 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2602 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2602 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2602 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2599 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 15785 "application-main-window.c"
	}
	__finally0:
#line 2599 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2599 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2599 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2599 "../src/client/application/application-main-window.vala"
		return;
#line 15796 "application-main-window.c"
	}
}

static void
____lambda204__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2593 "../src/client/application/application-main-window.vala"
	___lambda204_ (self, source_object, res);
#line 2593 "../src/client/application/application-main-window.vala"
	block25_data_unref (self);
#line 15809 "application-main-window.c"
}

static void
application_main_window_on_mark_as_unstarred (ApplicationMainWindow* self)
{
	Block25Data* _data25_;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GearyFolder* _tmp2_;
	ConversationListView* _tmp11_;
#line 2590 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2590 "../src/client/application/application-main-window.vala"
	_data25_ = g_slice_new0 (Block25Data);
#line 2590 "../src/client/application/application-main-window.vala"
	_data25_->_ref_count_ = 1;
#line 2590 "../src/client/application/application-main-window.vala"
	_data25_->self = g_object_ref (self);
#line 2591 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2591 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2591 "../src/client/application/application-main-window.vala"
	_data25_->location = _tmp1_;
#line 2592 "../src/client/application/application-main-window.vala"
	_tmp2_ = _data25_->location;
#line 2592 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 15838 "application-main-window.c"
		ApplicationController* _tmp3_;
		GearyFolder* _tmp4_;
		ConversationListView* _tmp5_;
		GeeSet* _tmp6_;
		GeeSet* _tmp7_;
		GearyNamedFlag* _tmp8_;
		GearyNamedFlag* _tmp9_;
		GearyNamedFlag* _tmp10_;
#line 2593 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->controller;
#line 2593 "../src/client/application/application-main-window.vala"
		_tmp4_ = _data25_->location;
#line 2593 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->_conversation_list_view;
#line 2593 "../src/client/application/application-main-window.vala"
		_tmp6_ = conversation_list_view_get_selected (_tmp5_);
#line 2593 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 2593 "../src/client/application/application-main-window.vala"
		_tmp8_ = geary_email_flags_get_FLAGGED ();
#line 2593 "../src/client/application/application-main-window.vala"
		_tmp9_ = _tmp8_;
#line 2593 "../src/client/application/application-main-window.vala"
		_tmp10_ = _tmp9_;
#line 2593 "../src/client/application/application-main-window.vala"
		application_controller_mark_conversations (_tmp3_, _tmp4_, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection), _tmp10_, FALSE, ____lambda204__gasync_ready_callback, block25_data_ref (_data25_));
#line 2593 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp10_);
#line 15867 "application-main-window.c"
	}
#line 2607 "../src/client/application/application-main-window.vala"
	_tmp11_ = self->priv->_conversation_list_view;
#line 2607 "../src/client/application/application-main-window.vala"
	conversation_list_view_set_selection_mode_enabled (_tmp11_, FALSE);
#line 2590 "../src/client/application/application-main-window.vala"
	block25_data_unref (_data25_);
#line 2590 "../src/client/application/application-main-window.vala"
	_data25_ = NULL;
#line 15877 "application-main-window.c"
}

static Block26Data*
block26_data_ref (Block26Data* _data26_)
{
#line 2610 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data26_->_ref_count_);
#line 2610 "../src/client/application/application-main-window.vala"
	return _data26_;
#line 15887 "application-main-window.c"
}

static void
block26_data_unref (void * _userdata_)
{
	Block26Data* _data26_;
	_data26_ = (Block26Data*) _userdata_;
#line 2610 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data26_->_ref_count_)) {
#line 15897 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2610 "../src/client/application/application-main-window.vala"
		self = _data26_->self;
#line 2610 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data26_->source);
#line 2610 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2610 "../src/client/application/application-main-window.vala"
		g_slice_free (Block26Data, _data26_);
#line 15907 "application-main-window.c"
	}
}

static void
___lambda205_ (Block26Data* _data26_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2621 "../src/client/application/application-main-window.vala"
	self = _data26_->self;
#line 2621 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2621 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 15924 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2623 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2623 "../src/client/application/application-main-window.vala"
		application_controller_move_conversations_special_finish (_tmp0_, res, &_inner_error0_);
#line 2623 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15933 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolder* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2622 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2622 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2625 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data26_->source;
#line 2625 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (_tmp1_);
#line 2625 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2625 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2625 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2625 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2625 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2622 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 15967 "application-main-window.c"
	}
	__finally0:
#line 2622 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2622 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2622 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2622 "../src/client/application/application-main-window.vala"
		return;
#line 15978 "application-main-window.c"
	}
}

static void
____lambda205__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2617 "../src/client/application/application-main-window.vala"
	___lambda205_ (self, source_object, res);
#line 2617 "../src/client/application/application-main-window.vala"
	block26_data_unref (self);
#line 15991 "application-main-window.c"
}

static void
application_main_window_on_mark_as_junk_toggle (ApplicationMainWindow* self)
{
	Block26Data* _data26_;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GearyFolder* _tmp2_;
	ConversationListView* _tmp12_;
#line 2610 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2610 "../src/client/application/application-main-window.vala"
	_data26_ = g_slice_new0 (Block26Data);
#line 2610 "../src/client/application/application-main-window.vala"
	_data26_->_ref_count_ = 1;
#line 2610 "../src/client/application/application-main-window.vala"
	_data26_->self = g_object_ref (self);
#line 2611 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2611 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2611 "../src/client/application/application-main-window.vala"
	_data26_->source = _tmp1_;
#line 2612 "../src/client/application/application-main-window.vala"
	_tmp2_ = _data26_->source;
#line 2612 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 16020 "application-main-window.c"
		GearyFolderSpecialUse _tmp3_ = 0;
		GearyFolder* _tmp4_;
		GearyFolderSpecialUse _tmp5_;
		GearyFolderSpecialUse _tmp6_;
		GearyFolderSpecialUse destination = 0;
		ApplicationController* _tmp7_;
		GearyFolder* _tmp8_;
		ConversationListView* _tmp9_;
		GeeSet* _tmp10_;
		GeeSet* _tmp11_;
#line 2614 "../src/client/application/application-main-window.vala"
		_tmp4_ = _data26_->source;
#line 2614 "../src/client/application/application-main-window.vala"
		_tmp5_ = geary_folder_get_used_as (_tmp4_);
#line 2614 "../src/client/application/application-main-window.vala"
		_tmp6_ = _tmp5_;
#line 2614 "../src/client/application/application-main-window.vala"
		if (_tmp6_ != GEARY_FOLDER_SPECIAL_USE_JUNK) {
#line 2615 "../src/client/application/application-main-window.vala"
			_tmp3_ = GEARY_FOLDER_SPECIAL_USE_JUNK;
#line 16041 "application-main-window.c"
		} else {
#line 2616 "../src/client/application/application-main-window.vala"
			_tmp3_ = GEARY_FOLDER_SPECIAL_USE_INBOX;
#line 16045 "application-main-window.c"
		}
#line 2613 "../src/client/application/application-main-window.vala"
		destination = _tmp3_;
#line 2617 "../src/client/application/application-main-window.vala"
		_tmp7_ = self->priv->controller;
#line 2617 "../src/client/application/application-main-window.vala"
		_tmp8_ = _data26_->source;
#line 2617 "../src/client/application/application-main-window.vala"
		_tmp9_ = self->priv->_conversation_list_view;
#line 2617 "../src/client/application/application-main-window.vala"
		_tmp10_ = conversation_list_view_get_selected (_tmp9_);
#line 2617 "../src/client/application/application-main-window.vala"
		_tmp11_ = _tmp10_;
#line 2617 "../src/client/application/application-main-window.vala"
		application_controller_move_conversations_special (_tmp7_, _tmp8_, destination, G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_COLLECTION, GeeCollection), ____lambda205__gasync_ready_callback, block26_data_ref (_data26_));
#line 16061 "application-main-window.c"
	}
#line 2630 "../src/client/application/application-main-window.vala"
	_tmp12_ = self->priv->_conversation_list_view;
#line 2630 "../src/client/application/application-main-window.vala"
	conversation_list_view_set_selection_mode_enabled (_tmp12_, FALSE);
#line 2610 "../src/client/application/application-main-window.vala"
	block26_data_unref (_data26_);
#line 2610 "../src/client/application/application-main-window.vala"
	_data26_ = NULL;
#line 16071 "application-main-window.c"
}

static Block27Data*
block27_data_ref (Block27Data* _data27_)
{
#line 2633 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data27_->_ref_count_);
#line 2633 "../src/client/application/application-main-window.vala"
	return _data27_;
#line 16081 "application-main-window.c"
}

static void
block27_data_unref (void * _userdata_)
{
	Block27Data* _data27_;
	_data27_ = (Block27Data*) _userdata_;
#line 2633 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data27_->_ref_count_)) {
#line 16091 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2633 "../src/client/application/application-main-window.vala"
		self = _data27_->self;
#line 2633 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data27_->source);
#line 2633 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2633 "../src/client/application/application-main-window.vala"
		g_slice_free (Block27Data, _data27_);
#line 16101 "application-main-window.c"
	}
}

static void
___lambda208_ (Block27Data* _data27_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2641 "../src/client/application/application-main-window.vala"
	self = _data27_->self;
#line 2641 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2641 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 16118 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2643 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2643 "../src/client/application/application-main-window.vala"
		application_controller_move_conversations_finish (_tmp0_, res, &_inner_error0_);
#line 2643 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16127 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolderSupportMove* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2642 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2642 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2645 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data27_->source;
#line 2645 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_TYPE_FOLDER, GearyFolder));
#line 2645 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2645 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2645 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2645 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2645 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2642 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 16161 "application-main-window.c"
	}
	__finally0:
#line 2642 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2642 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2642 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2642 "../src/client/application/application-main-window.vala"
		return;
#line 16172 "application-main-window.c"
	}
}

static void
____lambda208__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2637 "../src/client/application/application-main-window.vala"
	___lambda208_ (self, source_object, res);
#line 2637 "../src/client/application/application-main-window.vala"
	block27_data_unref (self);
#line 16185 "application-main-window.c"
}

static void
application_main_window_on_move_conversation (ApplicationMainWindow* self,
                                              GearyFolder* destination)
{
	Block27Data* _data27_;
	GearyFolder* _tmp0_;
	GearyFolderSupportMove* _tmp1_;
	GearyFolderSupportMove* _tmp2_;
	ConversationListView* _tmp8_;
#line 2633 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2633 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (destination, GEARY_TYPE_FOLDER));
#line 2633 "../src/client/application/application-main-window.vala"
	_data27_ = g_slice_new0 (Block27Data);
#line 2633 "../src/client/application/application-main-window.vala"
	_data27_->_ref_count_ = 1;
#line 2633 "../src/client/application/application-main-window.vala"
	_data27_->self = g_object_ref (self);
#line 2634 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2634 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GEARY_FOLDER_SUPPORT_TYPE_MOVE) ? ((GearyFolderSupportMove*) _tmp0_) : NULL);
#line 2634 "../src/client/application/application-main-window.vala"
	_data27_->source = _tmp1_;
#line 2636 "../src/client/application/application-main-window.vala"
	_tmp2_ = _data27_->source;
#line 2636 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 16217 "application-main-window.c"
		ApplicationController* _tmp3_;
		GearyFolderSupportMove* _tmp4_;
		ConversationListView* _tmp5_;
		GeeSet* _tmp6_;
		GeeSet* _tmp7_;
#line 2637 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->controller;
#line 2637 "../src/client/application/application-main-window.vala"
		_tmp4_ = _data27_->source;
#line 2637 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->_conversation_list_view;
#line 2637 "../src/client/application/application-main-window.vala"
		_tmp6_ = conversation_list_view_get_selected (_tmp5_);
#line 2637 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 2637 "../src/client/application/application-main-window.vala"
		application_controller_move_conversations (_tmp3_, _tmp4_, destination, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection), ____lambda208__gasync_ready_callback, block27_data_ref (_data27_));
#line 16235 "application-main-window.c"
	}
#line 2651 "../src/client/application/application-main-window.vala"
	_tmp8_ = self->priv->_conversation_list_view;
#line 2651 "../src/client/application/application-main-window.vala"
	conversation_list_view_set_selection_mode_enabled (_tmp8_, FALSE);
#line 2633 "../src/client/application/application-main-window.vala"
	block27_data_unref (_data27_);
#line 2633 "../src/client/application/application-main-window.vala"
	_data27_ = NULL;
#line 16245 "application-main-window.c"
}

static Block28Data*
block28_data_ref (Block28Data* _data28_)
{
#line 2654 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data28_->_ref_count_);
#line 2654 "../src/client/application/application-main-window.vala"
	return _data28_;
#line 16255 "application-main-window.c"
}

static void
block28_data_unref (void * _userdata_)
{
	Block28Data* _data28_;
	_data28_ = (Block28Data*) _userdata_;
#line 2654 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data28_->_ref_count_)) {
#line 16265 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2654 "../src/client/application/application-main-window.vala"
		self = _data28_->self;
#line 2654 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data28_->source);
#line 2654 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2654 "../src/client/application/application-main-window.vala"
		g_slice_free (Block28Data, _data28_);
#line 16275 "application-main-window.c"
	}
}

static void
___lambda209_ (Block28Data* _data28_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2662 "../src/client/application/application-main-window.vala"
	self = _data28_->self;
#line 2662 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2662 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 16292 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2664 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2664 "../src/client/application/application-main-window.vala"
		application_controller_copy_conversations_finish (_tmp0_, res, &_inner_error0_);
#line 2664 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16301 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolderSupportCopy* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2663 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2663 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2666 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data28_->source;
#line 2666 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_TYPE_FOLDER, GearyFolder));
#line 2666 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2666 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2666 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2666 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2666 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2663 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 16335 "application-main-window.c"
	}
	__finally0:
#line 2663 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2663 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2663 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2663 "../src/client/application/application-main-window.vala"
		return;
#line 16346 "application-main-window.c"
	}
}

static void
____lambda209__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2658 "../src/client/application/application-main-window.vala"
	___lambda209_ (self, source_object, res);
#line 2658 "../src/client/application/application-main-window.vala"
	block28_data_unref (self);
#line 16359 "application-main-window.c"
}

static void
application_main_window_on_copy_conversation (ApplicationMainWindow* self,
                                              GearyFolder* destination)
{
	Block28Data* _data28_;
	GearyFolder* _tmp0_;
	GearyFolderSupportCopy* _tmp1_;
	GearyFolderSupportCopy* _tmp2_;
	ConversationListView* _tmp8_;
#line 2654 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2654 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (destination, GEARY_TYPE_FOLDER));
#line 2654 "../src/client/application/application-main-window.vala"
	_data28_ = g_slice_new0 (Block28Data);
#line 2654 "../src/client/application/application-main-window.vala"
	_data28_->_ref_count_ = 1;
#line 2654 "../src/client/application/application-main-window.vala"
	_data28_->self = g_object_ref (self);
#line 2655 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2655 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GEARY_FOLDER_SUPPORT_TYPE_COPY) ? ((GearyFolderSupportCopy*) _tmp0_) : NULL);
#line 2655 "../src/client/application/application-main-window.vala"
	_data28_->source = _tmp1_;
#line 2657 "../src/client/application/application-main-window.vala"
	_tmp2_ = _data28_->source;
#line 2657 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 16391 "application-main-window.c"
		ApplicationController* _tmp3_;
		GearyFolderSupportCopy* _tmp4_;
		ConversationListView* _tmp5_;
		GeeSet* _tmp6_;
		GeeSet* _tmp7_;
#line 2658 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->controller;
#line 2658 "../src/client/application/application-main-window.vala"
		_tmp4_ = _data28_->source;
#line 2658 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->_conversation_list_view;
#line 2658 "../src/client/application/application-main-window.vala"
		_tmp6_ = conversation_list_view_get_selected (_tmp5_);
#line 2658 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 2658 "../src/client/application/application-main-window.vala"
		application_controller_copy_conversations (_tmp3_, _tmp4_, destination, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection), ____lambda209__gasync_ready_callback, block28_data_ref (_data28_));
#line 16409 "application-main-window.c"
	}
#line 2672 "../src/client/application/application-main-window.vala"
	_tmp8_ = self->priv->_conversation_list_view;
#line 2672 "../src/client/application/application-main-window.vala"
	conversation_list_view_set_selection_mode_enabled (_tmp8_, FALSE);
#line 2654 "../src/client/application/application-main-window.vala"
	block28_data_unref (_data28_);
#line 2654 "../src/client/application/application-main-window.vala"
	_data28_ = NULL;
#line 16419 "application-main-window.c"
}

static Block29Data*
block29_data_ref (Block29Data* _data29_)
{
#line 2675 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data29_->_ref_count_);
#line 2675 "../src/client/application/application-main-window.vala"
	return _data29_;
#line 16429 "application-main-window.c"
}

static void
block29_data_unref (void * _userdata_)
{
	Block29Data* _data29_;
	_data29_ = (Block29Data*) _userdata_;
#line 2675 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data29_->_ref_count_)) {
#line 16439 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2675 "../src/client/application/application-main-window.vala"
		self = _data29_->self;
#line 2675 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data29_->source);
#line 2675 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2675 "../src/client/application/application-main-window.vala"
		g_slice_free (Block29Data, _data29_);
#line 16449 "application-main-window.c"
	}
}

static void
___lambda198_ (Block29Data* _data29_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2682 "../src/client/application/application-main-window.vala"
	self = _data29_->self;
#line 2682 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2682 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 16466 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2684 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2684 "../src/client/application/application-main-window.vala"
		application_controller_move_conversations_special_finish (_tmp0_, res, &_inner_error0_);
#line 2684 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16475 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolder* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2683 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2683 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2686 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data29_->source;
#line 2686 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (_tmp1_);
#line 2686 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2686 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2686 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2686 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2686 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2683 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 16509 "application-main-window.c"
	}
	__finally0:
#line 2683 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2683 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2683 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2683 "../src/client/application/application-main-window.vala"
		return;
#line 16520 "application-main-window.c"
	}
}

static void
____lambda198__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2678 "../src/client/application/application-main-window.vala"
	___lambda198_ (self, source_object, res);
#line 2678 "../src/client/application/application-main-window.vala"
	block29_data_unref (self);
#line 16533 "application-main-window.c"
}

static void
application_main_window_on_archive_conversation (ApplicationMainWindow* self)
{
	Block29Data* _data29_;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GearyFolder* _tmp2_;
	ConversationListView* _tmp8_;
#line 2675 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2675 "../src/client/application/application-main-window.vala"
	_data29_ = g_slice_new0 (Block29Data);
#line 2675 "../src/client/application/application-main-window.vala"
	_data29_->_ref_count_ = 1;
#line 2675 "../src/client/application/application-main-window.vala"
	_data29_->self = g_object_ref (self);
#line 2676 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2676 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2676 "../src/client/application/application-main-window.vala"
	_data29_->source = _tmp1_;
#line 2677 "../src/client/application/application-main-window.vala"
	_tmp2_ = _data29_->source;
#line 2677 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 16562 "application-main-window.c"
		ApplicationController* _tmp3_;
		GearyFolder* _tmp4_;
		ConversationListView* _tmp5_;
		GeeSet* _tmp6_;
		GeeSet* _tmp7_;
#line 2678 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->controller;
#line 2678 "../src/client/application/application-main-window.vala"
		_tmp4_ = _data29_->source;
#line 2678 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->_conversation_list_view;
#line 2678 "../src/client/application/application-main-window.vala"
		_tmp6_ = conversation_list_view_get_selected (_tmp5_);
#line 2678 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 2678 "../src/client/application/application-main-window.vala"
		application_controller_move_conversations_special (_tmp3_, _tmp4_, GEARY_FOLDER_SPECIAL_USE_ARCHIVE, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection), ____lambda198__gasync_ready_callback, block29_data_ref (_data29_));
#line 16580 "application-main-window.c"
	}
#line 2691 "../src/client/application/application-main-window.vala"
	_tmp8_ = self->priv->_conversation_list_view;
#line 2691 "../src/client/application/application-main-window.vala"
	conversation_list_view_set_selection_mode_enabled (_tmp8_, FALSE);
#line 2675 "../src/client/application/application-main-window.vala"
	block29_data_unref (_data29_);
#line 2675 "../src/client/application/application-main-window.vala"
	_data29_ = NULL;
#line 16590 "application-main-window.c"
}

static Block30Data*
block30_data_ref (Block30Data* _data30_)
{
#line 2694 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data30_->_ref_count_);
#line 2694 "../src/client/application/application-main-window.vala"
	return _data30_;
#line 16600 "application-main-window.c"
}

static void
block30_data_unref (void * _userdata_)
{
	Block30Data* _data30_;
	_data30_ = (Block30Data*) _userdata_;
#line 2694 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data30_->_ref_count_)) {
#line 16610 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2694 "../src/client/application/application-main-window.vala"
		self = _data30_->self;
#line 2694 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data30_->source);
#line 2694 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2694 "../src/client/application/application-main-window.vala"
		g_slice_free (Block30Data, _data30_);
#line 16620 "application-main-window.c"
	}
}

static void
___lambda199_ (Block30Data* _data30_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2701 "../src/client/application/application-main-window.vala"
	self = _data30_->self;
#line 2701 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2701 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 16637 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2703 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2703 "../src/client/application/application-main-window.vala"
		application_controller_move_conversations_special_finish (_tmp0_, res, &_inner_error0_);
#line 2703 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16646 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolder* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2702 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2702 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2705 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data30_->source;
#line 2705 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (_tmp1_);
#line 2705 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2705 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2705 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2705 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2705 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2702 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 16680 "application-main-window.c"
	}
	__finally0:
#line 2702 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2702 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2702 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2702 "../src/client/application/application-main-window.vala"
		return;
#line 16691 "application-main-window.c"
	}
}

static void
____lambda199__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2697 "../src/client/application/application-main-window.vala"
	___lambda199_ (self, source_object, res);
#line 2697 "../src/client/application/application-main-window.vala"
	block30_data_unref (self);
#line 16704 "application-main-window.c"
}

static void
application_main_window_on_trash_conversation (ApplicationMainWindow* self)
{
	Block30Data* _data30_;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GearyFolder* _tmp2_;
#line 2694 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2694 "../src/client/application/application-main-window.vala"
	_data30_ = g_slice_new0 (Block30Data);
#line 2694 "../src/client/application/application-main-window.vala"
	_data30_->_ref_count_ = 1;
#line 2694 "../src/client/application/application-main-window.vala"
	_data30_->self = g_object_ref (self);
#line 2695 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2695 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2695 "../src/client/application/application-main-window.vala"
	_data30_->source = _tmp1_;
#line 2696 "../src/client/application/application-main-window.vala"
	_tmp2_ = _data30_->source;
#line 2696 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 16732 "application-main-window.c"
		ApplicationController* _tmp3_;
		GearyFolder* _tmp4_;
		ConversationListView* _tmp5_;
		GeeSet* _tmp6_;
		GeeSet* _tmp7_;
#line 2697 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->controller;
#line 2697 "../src/client/application/application-main-window.vala"
		_tmp4_ = _data30_->source;
#line 2697 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->_conversation_list_view;
#line 2697 "../src/client/application/application-main-window.vala"
		_tmp6_ = conversation_list_view_get_selected (_tmp5_);
#line 2697 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 2697 "../src/client/application/application-main-window.vala"
		application_controller_move_conversations_special (_tmp3_, _tmp4_, GEARY_FOLDER_SPECIAL_USE_TRASH, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection), ____lambda199__gasync_ready_callback, block30_data_ref (_data30_));
#line 16750 "application-main-window.c"
	}
#line 2694 "../src/client/application/application-main-window.vala"
	block30_data_unref (_data30_);
#line 2694 "../src/client/application/application-main-window.vala"
	_data30_ = NULL;
#line 16756 "application-main-window.c"
}

static Block31Data*
block31_data_ref (Block31Data* _data31_)
{
#line 2713 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data31_->_ref_count_);
#line 2713 "../src/client/application/application-main-window.vala"
	return _data31_;
#line 16766 "application-main-window.c"
}

static void
block31_data_unref (void * _userdata_)
{
	Block31Data* _data31_;
	_data31_ = (Block31Data*) _userdata_;
#line 2713 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data31_->_ref_count_)) {
#line 16776 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2713 "../src/client/application/application-main-window.vala"
		self = _data31_->self;
#line 2713 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data31_->target);
#line 2713 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2713 "../src/client/application/application-main-window.vala"
		g_slice_free (Block31Data, _data31_);
#line 16786 "application-main-window.c"
	}
}

static void
___lambda200_ (Block31Data* _data31_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2722 "../src/client/application/application-main-window.vala"
	self = _data31_->self;
#line 2722 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2722 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 16803 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2724 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2724 "../src/client/application/application-main-window.vala"
		application_controller_delete_conversations_finish (_tmp0_, res, &_inner_error0_);
#line 2724 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16812 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolderSupportRemove* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2723 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2723 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2726 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data31_->target;
#line 2726 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_TYPE_FOLDER, GearyFolder));
#line 2726 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2726 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2726 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2726 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2726 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2723 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 16846 "application-main-window.c"
	}
	__finally0:
#line 2723 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2723 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2723 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2723 "../src/client/application/application-main-window.vala"
		return;
#line 16857 "application-main-window.c"
	}
}

static void
____lambda200__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2719 "../src/client/application/application-main-window.vala"
	___lambda200_ (self, source_object, res);
#line 2719 "../src/client/application/application-main-window.vala"
	block31_data_unref (self);
#line 16870 "application-main-window.c"
}

static void
application_main_window_on_delete_conversation (ApplicationMainWindow* self)
{
	Block31Data* _data31_;
	GearyFolder* _tmp0_;
	GearyFolderSupportRemove* _tmp1_;
	GeeCollection* conversations = NULL;
	ConversationListView* _tmp2_;
	GeeSet* _tmp3_;
	GeeSet* _tmp4_;
	GeeCollection* _tmp5_;
	gboolean _tmp6_ = FALSE;
	GearyFolderSupportRemove* _tmp7_;
#line 2713 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2713 "../src/client/application/application-main-window.vala"
	_data31_ = g_slice_new0 (Block31Data);
#line 2713 "../src/client/application/application-main-window.vala"
	_data31_->_ref_count_ = 1;
#line 2713 "../src/client/application/application-main-window.vala"
	_data31_->self = g_object_ref (self);
#line 2714 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2714 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GEARY_FOLDER_SUPPORT_TYPE_REMOVE) ? ((GearyFolderSupportRemove*) _tmp0_) : NULL);
#line 2714 "../src/client/application/application-main-window.vala"
	_data31_->target = _tmp1_;
#line 2716 "../src/client/application/application-main-window.vala"
	_tmp2_ = self->priv->_conversation_list_view;
#line 2716 "../src/client/application/application-main-window.vala"
	_tmp3_ = conversation_list_view_get_selected (_tmp2_);
#line 2716 "../src/client/application/application-main-window.vala"
	_tmp4_ = _tmp3_;
#line 2716 "../src/client/application/application-main-window.vala"
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_COLLECTION, GeeCollection));
#line 2716 "../src/client/application/application-main-window.vala"
	conversations = _tmp5_;
#line 2718 "../src/client/application/application-main-window.vala"
	_tmp7_ = _data31_->target;
#line 2718 "../src/client/application/application-main-window.vala"
	if (_tmp7_ != NULL) {
#line 16914 "application-main-window.c"
		GeeCollection* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 2718 "../src/client/application/application-main-window.vala"
		_tmp8_ = conversations;
#line 2718 "../src/client/application/application-main-window.vala"
		_tmp9_ = gee_collection_get_size (_tmp8_);
#line 2718 "../src/client/application/application-main-window.vala"
		_tmp10_ = _tmp9_;
#line 2718 "../src/client/application/application-main-window.vala"
		_tmp6_ = application_main_window_prompt_delete_conversations (self, _tmp10_);
#line 16926 "application-main-window.c"
	} else {
#line 2718 "../src/client/application/application-main-window.vala"
		_tmp6_ = FALSE;
#line 16930 "application-main-window.c"
	}
#line 2718 "../src/client/application/application-main-window.vala"
	if (_tmp6_) {
#line 16934 "application-main-window.c"
		ApplicationController* _tmp11_;
		GearyFolderSupportRemove* _tmp12_;
		GeeCollection* _tmp13_;
#line 2719 "../src/client/application/application-main-window.vala"
		_tmp11_ = self->priv->controller;
#line 2719 "../src/client/application/application-main-window.vala"
		_tmp12_ = _data31_->target;
#line 2719 "../src/client/application/application-main-window.vala"
		_tmp13_ = conversations;
#line 2719 "../src/client/application/application-main-window.vala"
		application_controller_delete_conversations (_tmp11_, _tmp12_, _tmp13_, ____lambda200__gasync_ready_callback, block31_data_ref (_data31_));
#line 16946 "application-main-window.c"
	}
#line 2713 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (conversations);
#line 2713 "../src/client/application/application-main-window.vala"
	block31_data_unref (_data31_);
#line 2713 "../src/client/application/application-main-window.vala"
	_data31_ = NULL;
#line 16954 "application-main-window.c"
}

static void
application_main_window_on_email_loaded (ApplicationMainWindow* self,
                                         ConversationListBox* view,
                                         GearyEmail* loaded)
{
	ApplicationController* _tmp0_;
	GearyAppConversation* _tmp1_;
	GearyAppConversation* _tmp2_;
	GearyFolder* _tmp3_;
	GearyFolder* _tmp4_;
	GearyAccount* _tmp5_;
	GearyAccount* _tmp6_;
	GearyAccountInformation* _tmp7_;
	GearyAccountInformation* _tmp8_;
#line 2734 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2734 "../src/client/application/application-main-window.vala"
	g_return_if_fail (IS_CONVERSATION_LIST_BOX (view));
#line 2734 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (loaded, GEARY_TYPE_EMAIL));
#line 2736 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->controller;
#line 2736 "../src/client/application/application-main-window.vala"
	_tmp1_ = conversation_list_box_get_conversation (view);
#line 2736 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 2736 "../src/client/application/application-main-window.vala"
	_tmp3_ = geary_app_conversation_get_base_folder (_tmp2_);
#line 2736 "../src/client/application/application-main-window.vala"
	_tmp4_ = _tmp3_;
#line 2736 "../src/client/application/application-main-window.vala"
	_tmp5_ = geary_folder_get_account (_tmp4_);
#line 2736 "../src/client/application/application-main-window.vala"
	_tmp6_ = _tmp5_;
#line 2736 "../src/client/application/application-main-window.vala"
	_tmp7_ = geary_account_get_information (_tmp6_);
#line 2736 "../src/client/application/application-main-window.vala"
	_tmp8_ = _tmp7_;
#line 2736 "../src/client/application/application-main-window.vala"
	application_controller_email_loaded (_tmp0_, _tmp8_, loaded);
#line 16997 "application-main-window.c"
}

static Block32Data*
block32_data_ref (Block32Data* _data32_)
{
#line 2742 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data32_->_ref_count_);
#line 2742 "../src/client/application/application-main-window.vala"
	return _data32_;
#line 17007 "application-main-window.c"
}

static void
block32_data_unref (void * _userdata_)
{
	Block32Data* _data32_;
	_data32_ = (Block32Data*) _userdata_;
#line 2742 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data32_->_ref_count_)) {
#line 17017 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2742 "../src/client/application/application-main-window.vala"
		self = _data32_->self;
#line 2742 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data32_->location);
#line 2742 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2742 "../src/client/application/application-main-window.vala"
		g_slice_free (Block32Data, _data32_);
#line 17027 "application-main-window.c"
	}
}

static void
___lambda211_ (Block32Data* _data32_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2764 "../src/client/application/application-main-window.vala"
	self = _data32_->self;
#line 2764 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2764 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 17044 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2766 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2766 "../src/client/application/application-main-window.vala"
		application_controller_mark_messages_finish (_tmp0_, res, &_inner_error0_);
#line 2766 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17053 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolder* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2765 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2765 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2768 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data32_->location;
#line 2768 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (_tmp1_);
#line 2768 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2768 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2768 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2768 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2768 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2765 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 17087 "application-main-window.c"
	}
	__finally0:
#line 2765 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2765 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2765 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2765 "../src/client/application/application-main-window.vala"
		return;
#line 17098 "application-main-window.c"
	}
}

static void
____lambda211__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2758 "../src/client/application/application-main-window.vala"
	___lambda211_ (self, source_object, res);
#line 2758 "../src/client/application/application-main-window.vala"
	block32_data_unref (self);
#line 17111 "application-main-window.c"
}

static void
application_main_window_on_email_mark (ApplicationMainWindow* self,
                                       ConversationListBox* view,
                                       GeeCollection* messages,
                                       GearyNamedFlag* to_add,
                                       GearyNamedFlag* to_remove)
{
	Block32Data* _data32_;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GearyFolder* _tmp2_;
	ConversationListView* _tmp15_;
#line 2742 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2742 "../src/client/application/application-main-window.vala"
	g_return_if_fail (IS_CONVERSATION_LIST_BOX (view));
#line 2742 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (messages, GEE_TYPE_COLLECTION));
#line 2742 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((to_add == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (to_add, GEARY_TYPE_NAMED_FLAG));
#line 2742 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((to_remove == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (to_remove, GEARY_TYPE_NAMED_FLAG));
#line 2742 "../src/client/application/application-main-window.vala"
	_data32_ = g_slice_new0 (Block32Data);
#line 2742 "../src/client/application/application-main-window.vala"
	_data32_->_ref_count_ = 1;
#line 2742 "../src/client/application/application-main-window.vala"
	_data32_->self = g_object_ref (self);
#line 2746 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2746 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2746 "../src/client/application/application-main-window.vala"
	_data32_->location = _tmp1_;
#line 2747 "../src/client/application/application-main-window.vala"
	_tmp2_ = _data32_->location;
#line 2747 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 17152 "application-main-window.c"
		GearyEmailFlags* add_flags = NULL;
		GearyEmailFlags* remove_flags = NULL;
		ApplicationController* _tmp7_;
		GearyFolder* _tmp8_;
		GearyAppConversation* _tmp9_;
		GearyAppConversation* _tmp10_;
		GeeCollection* _tmp11_;
		GeeCollection* _tmp12_;
		GearyEmailFlags* _tmp13_;
		GearyEmailFlags* _tmp14_;
#line 2748 "../src/client/application/application-main-window.vala"
		add_flags = NULL;
#line 2749 "../src/client/application/application-main-window.vala"
		if (to_add != NULL) {
#line 17167 "application-main-window.c"
			GearyEmailFlags* _tmp3_;
			GearyEmailFlags* _tmp4_;
#line 2750 "../src/client/application/application-main-window.vala"
			_tmp3_ = geary_email_flags_new ();
#line 2750 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (add_flags);
#line 2750 "../src/client/application/application-main-window.vala"
			add_flags = _tmp3_;
#line 2751 "../src/client/application/application-main-window.vala"
			_tmp4_ = add_flags;
#line 2751 "../src/client/application/application-main-window.vala"
			geary_named_flags_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEARY_TYPE_NAMED_FLAGS, GearyNamedFlags), to_add);
#line 17180 "application-main-window.c"
		}
#line 2753 "../src/client/application/application-main-window.vala"
		remove_flags = NULL;
#line 2754 "../src/client/application/application-main-window.vala"
		if (to_remove != NULL) {
#line 17186 "application-main-window.c"
			GearyEmailFlags* _tmp5_;
			GearyEmailFlags* _tmp6_;
#line 2755 "../src/client/application/application-main-window.vala"
			_tmp5_ = geary_email_flags_new ();
#line 2755 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (remove_flags);
#line 2755 "../src/client/application/application-main-window.vala"
			remove_flags = _tmp5_;
#line 2756 "../src/client/application/application-main-window.vala"
			_tmp6_ = remove_flags;
#line 2756 "../src/client/application/application-main-window.vala"
			geary_named_flags_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEARY_TYPE_NAMED_FLAGS, GearyNamedFlags), to_remove);
#line 17199 "application-main-window.c"
		}
#line 2758 "../src/client/application/application-main-window.vala"
		_tmp7_ = self->priv->controller;
#line 2758 "../src/client/application/application-main-window.vala"
		_tmp8_ = _data32_->location;
#line 2758 "../src/client/application/application-main-window.vala"
		_tmp9_ = conversation_list_box_get_conversation (view);
#line 2758 "../src/client/application/application-main-window.vala"
		_tmp10_ = _tmp9_;
#line 2758 "../src/client/application/application-main-window.vala"
		_tmp11_ = geary_collection_single (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp10_);
#line 2758 "../src/client/application/application-main-window.vala"
		_tmp12_ = _tmp11_;
#line 2758 "../src/client/application/application-main-window.vala"
		_tmp13_ = add_flags;
#line 2758 "../src/client/application/application-main-window.vala"
		_tmp14_ = remove_flags;
#line 2758 "../src/client/application/application-main-window.vala"
		application_controller_mark_messages (_tmp7_, _tmp8_, _tmp12_, messages, _tmp13_, _tmp14_, ____lambda211__gasync_ready_callback, block32_data_ref (_data32_));
#line 2758 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp12_);
#line 2747 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (remove_flags);
#line 2747 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (add_flags);
#line 17225 "application-main-window.c"
	}
#line 2773 "../src/client/application/application-main-window.vala"
	_tmp15_ = self->priv->_conversation_list_view;
#line 2773 "../src/client/application/application-main-window.vala"
	conversation_list_view_set_selection_mode_enabled (_tmp15_, FALSE);
#line 2742 "../src/client/application/application-main-window.vala"
	block32_data_unref (_data32_);
#line 2742 "../src/client/application/application-main-window.vala"
	_data32_ = NULL;
#line 17235 "application-main-window.c"
}

static void
application_main_window_on_email_reply_to_sender (ApplicationMainWindow* self,
                                                  GearyEmail* target,
                                                  const gchar* quote)
{
	GearyAccount* _tmp0_;
	ConversationListView* _tmp2_;
#line 2776 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2776 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (target, GEARY_TYPE_EMAIL));
#line 2777 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_account;
#line 2777 "../src/client/application/application-main-window.vala"
	if (_tmp0_ != NULL) {
#line 17253 "application-main-window.c"
		GearyAccount* _tmp1_;
#line 2778 "../src/client/application/application-main-window.vala"
		_tmp1_ = self->priv->_selected_account;
#line 2778 "../src/client/application/application-main-window.vala"
		application_main_window_create_composer (self, _tmp1_, COMPOSER_WIDGET_CONTEXT_TYPE_REPLY_SENDER, target, quote, NULL, NULL);
#line 17259 "application-main-window.c"
	}
#line 2782 "../src/client/application/application-main-window.vala"
	_tmp2_ = self->priv->_conversation_list_view;
#line 2782 "../src/client/application/application-main-window.vala"
	conversation_list_view_set_selection_mode_enabled (_tmp2_, FALSE);
#line 17265 "application-main-window.c"
}

static void
application_main_window_on_email_reply_to_all (ApplicationMainWindow* self,
                                               GearyEmail* target,
                                               const gchar* quote)
{
	GearyAccount* _tmp0_;
	ConversationListView* _tmp2_;
#line 2785 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2785 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (target, GEARY_TYPE_EMAIL));
#line 2786 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_account;
#line 2786 "../src/client/application/application-main-window.vala"
	if (_tmp0_ != NULL) {
#line 17283 "application-main-window.c"
		GearyAccount* _tmp1_;
#line 2787 "../src/client/application/application-main-window.vala"
		_tmp1_ = self->priv->_selected_account;
#line 2787 "../src/client/application/application-main-window.vala"
		application_main_window_create_composer (self, _tmp1_, COMPOSER_WIDGET_CONTEXT_TYPE_REPLY_ALL, target, quote, NULL, NULL);
#line 17289 "application-main-window.c"
	}
#line 2791 "../src/client/application/application-main-window.vala"
	_tmp2_ = self->priv->_conversation_list_view;
#line 2791 "../src/client/application/application-main-window.vala"
	conversation_list_view_set_selection_mode_enabled (_tmp2_, FALSE);
#line 17295 "application-main-window.c"
}

static void
application_main_window_on_email_forward (ApplicationMainWindow* self,
                                          GearyEmail* target,
                                          const gchar* quote)
{
	GearyAccount* _tmp0_;
	ConversationListView* _tmp2_;
#line 2794 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2794 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (target, GEARY_TYPE_EMAIL));
#line 2795 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_account;
#line 2795 "../src/client/application/application-main-window.vala"
	if (_tmp0_ != NULL) {
#line 17313 "application-main-window.c"
		GearyAccount* _tmp1_;
#line 2796 "../src/client/application/application-main-window.vala"
		_tmp1_ = self->priv->_selected_account;
#line 2796 "../src/client/application/application-main-window.vala"
		application_main_window_create_composer (self, _tmp1_, COMPOSER_WIDGET_CONTEXT_TYPE_FORWARD, target, quote, NULL, NULL);
#line 17319 "application-main-window.c"
	}
#line 2800 "../src/client/application/application-main-window.vala"
	_tmp2_ = self->priv->_conversation_list_view;
#line 2800 "../src/client/application/application-main-window.vala"
	conversation_list_view_set_selection_mode_enabled (_tmp2_, FALSE);
#line 17325 "application-main-window.c"
}

static Block33Data*
block33_data_ref (Block33Data* _data33_)
{
#line 2803 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data33_->_ref_count_);
#line 2803 "../src/client/application/application-main-window.vala"
	return _data33_;
#line 17335 "application-main-window.c"
}

static void
block33_data_unref (void * _userdata_)
{
	Block33Data* _data33_;
	_data33_ = (Block33Data*) _userdata_;
#line 2803 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data33_->_ref_count_)) {
#line 17345 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2803 "../src/client/application/application-main-window.vala"
		self = _data33_->self;
#line 2803 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data33_->source);
#line 2803 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2803 "../src/client/application/application-main-window.vala"
		g_slice_free (Block33Data, _data33_);
#line 17355 "application-main-window.c"
	}
}

static void
___lambda212_ (Block33Data* _data33_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2811 "../src/client/application/application-main-window.vala"
	self = _data33_->self;
#line 2811 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2811 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 17372 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2813 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2813 "../src/client/application/application-main-window.vala"
		application_controller_move_messages_special_finish (_tmp0_, res, &_inner_error0_);
#line 2813 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17381 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolder* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2812 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2812 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2815 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data33_->source;
#line 2815 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (_tmp1_);
#line 2815 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2815 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2815 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2815 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2815 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2812 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 17415 "application-main-window.c"
	}
	__finally0:
#line 2812 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2812 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2812 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2812 "../src/client/application/application-main-window.vala"
		return;
#line 17426 "application-main-window.c"
	}
}

static void
____lambda212__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2806 "../src/client/application/application-main-window.vala"
	___lambda212_ (self, source_object, res);
#line 2806 "../src/client/application/application-main-window.vala"
	block33_data_unref (self);
#line 17439 "application-main-window.c"
}

static void
application_main_window_on_email_trash (ApplicationMainWindow* self,
                                        ConversationListBox* view,
                                        GearyEmail* target)
{
	Block33Data* _data33_;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GearyFolder* _tmp2_;
#line 2803 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2803 "../src/client/application/application-main-window.vala"
	g_return_if_fail (IS_CONVERSATION_LIST_BOX (view));
#line 2803 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (target, GEARY_TYPE_EMAIL));
#line 2803 "../src/client/application/application-main-window.vala"
	_data33_ = g_slice_new0 (Block33Data);
#line 2803 "../src/client/application/application-main-window.vala"
	_data33_->_ref_count_ = 1;
#line 2803 "../src/client/application/application-main-window.vala"
	_data33_->self = g_object_ref (self);
#line 2804 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2804 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2804 "../src/client/application/application-main-window.vala"
	_data33_->source = _tmp1_;
#line 2805 "../src/client/application/application-main-window.vala"
	_tmp2_ = _data33_->source;
#line 2805 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 17473 "application-main-window.c"
		ApplicationController* _tmp3_;
		GearyFolder* _tmp4_;
		GearyAppConversation* _tmp5_;
		GearyAppConversation* _tmp6_;
		GeeCollection* _tmp7_;
		GeeCollection* _tmp8_;
		GearyEmailIdentifier* _tmp9_;
		GearyEmailIdentifier* _tmp10_;
		GeeCollection* _tmp11_;
		GeeCollection* _tmp12_;
#line 2806 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->controller;
#line 2806 "../src/client/application/application-main-window.vala"
		_tmp4_ = _data33_->source;
#line 2806 "../src/client/application/application-main-window.vala"
		_tmp5_ = conversation_list_box_get_conversation (view);
#line 2806 "../src/client/application/application-main-window.vala"
		_tmp6_ = _tmp5_;
#line 2806 "../src/client/application/application-main-window.vala"
		_tmp7_ = geary_collection_single (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp6_);
#line 2806 "../src/client/application/application-main-window.vala"
		_tmp8_ = _tmp7_;
#line 2806 "../src/client/application/application-main-window.vala"
		_tmp9_ = geary_email_get_id (target);
#line 2806 "../src/client/application/application-main-window.vala"
		_tmp10_ = _tmp9_;
#line 2806 "../src/client/application/application-main-window.vala"
		_tmp11_ = geary_collection_single (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp10_);
#line 2806 "../src/client/application/application-main-window.vala"
		_tmp12_ = _tmp11_;
#line 2806 "../src/client/application/application-main-window.vala"
		application_controller_move_messages_special (_tmp3_, _tmp4_, GEARY_FOLDER_SPECIAL_USE_TRASH, _tmp8_, _tmp12_, ____lambda212__gasync_ready_callback, block33_data_ref (_data33_));
#line 2806 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp12_);
#line 2806 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp8_);
#line 17510 "application-main-window.c"
	}
#line 2803 "../src/client/application/application-main-window.vala"
	block33_data_unref (_data33_);
#line 2803 "../src/client/application/application-main-window.vala"
	_data33_ = NULL;
#line 17516 "application-main-window.c"
}

static Block34Data*
block34_data_ref (Block34Data* _data34_)
{
#line 2822 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data34_->_ref_count_);
#line 2822 "../src/client/application/application-main-window.vala"
	return _data34_;
#line 17526 "application-main-window.c"
}

static void
block34_data_unref (void * _userdata_)
{
	Block34Data* _data34_;
	_data34_ = (Block34Data*) _userdata_;
#line 2822 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data34_->_ref_count_)) {
#line 17536 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2822 "../src/client/application/application-main-window.vala"
		self = _data34_->self;
#line 2822 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data34_->source);
#line 2822 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2822 "../src/client/application/application-main-window.vala"
		g_slice_free (Block34Data, _data34_);
#line 17546 "application-main-window.c"
	}
}

static void
___lambda213_ (Block34Data* _data34_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2830 "../src/client/application/application-main-window.vala"
	self = _data34_->self;
#line 2830 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2830 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 17563 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2832 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2832 "../src/client/application/application-main-window.vala"
		application_controller_delete_messages_finish (_tmp0_, res, &_inner_error0_);
#line 2832 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17572 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolderSupportRemove* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2831 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2831 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2834 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data34_->source;
#line 2834 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_TYPE_FOLDER, GearyFolder));
#line 2834 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2834 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2834 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2834 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2834 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2831 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 17606 "application-main-window.c"
	}
	__finally0:
#line 2831 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2831 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2831 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2831 "../src/client/application/application-main-window.vala"
		return;
#line 17617 "application-main-window.c"
	}
}

static void
____lambda213__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2826 "../src/client/application/application-main-window.vala"
	___lambda213_ (self, source_object, res);
#line 2826 "../src/client/application/application-main-window.vala"
	block34_data_unref (self);
#line 17630 "application-main-window.c"
}

static void
application_main_window_on_email_delete (ApplicationMainWindow* self,
                                         ConversationListBox* view,
                                         GearyEmail* target)
{
	Block34Data* _data34_;
	GearyFolder* _tmp0_;
	GearyFolderSupportRemove* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GearyFolderSupportRemove* _tmp3_;
#line 2822 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2822 "../src/client/application/application-main-window.vala"
	g_return_if_fail (IS_CONVERSATION_LIST_BOX (view));
#line 2822 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (target, GEARY_TYPE_EMAIL));
#line 2822 "../src/client/application/application-main-window.vala"
	_data34_ = g_slice_new0 (Block34Data);
#line 2822 "../src/client/application/application-main-window.vala"
	_data34_->_ref_count_ = 1;
#line 2822 "../src/client/application/application-main-window.vala"
	_data34_->self = g_object_ref (self);
#line 2823 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2823 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GEARY_FOLDER_SUPPORT_TYPE_REMOVE) ? ((GearyFolderSupportRemove*) _tmp0_) : NULL);
#line 2823 "../src/client/application/application-main-window.vala"
	_data34_->source = _tmp1_;
#line 2825 "../src/client/application/application-main-window.vala"
	_tmp3_ = _data34_->source;
#line 2825 "../src/client/application/application-main-window.vala"
	if (_tmp3_ != NULL) {
#line 2825 "../src/client/application/application-main-window.vala"
		_tmp2_ = application_main_window_prompt_delete_messages (self, 1);
#line 17667 "application-main-window.c"
	} else {
#line 2825 "../src/client/application/application-main-window.vala"
		_tmp2_ = FALSE;
#line 17671 "application-main-window.c"
	}
#line 2825 "../src/client/application/application-main-window.vala"
	if (_tmp2_) {
#line 17675 "application-main-window.c"
		ApplicationController* _tmp4_;
		GearyFolderSupportRemove* _tmp5_;
		GearyAppConversation* _tmp6_;
		GearyAppConversation* _tmp7_;
		GeeCollection* _tmp8_;
		GeeCollection* _tmp9_;
		GearyEmailIdentifier* _tmp10_;
		GearyEmailIdentifier* _tmp11_;
		GeeCollection* _tmp12_;
		GeeCollection* _tmp13_;
#line 2826 "../src/client/application/application-main-window.vala"
		_tmp4_ = self->priv->controller;
#line 2826 "../src/client/application/application-main-window.vala"
		_tmp5_ = _data34_->source;
#line 2826 "../src/client/application/application-main-window.vala"
		_tmp6_ = conversation_list_box_get_conversation (view);
#line 2826 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 2826 "../src/client/application/application-main-window.vala"
		_tmp8_ = geary_collection_single (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp7_);
#line 2826 "../src/client/application/application-main-window.vala"
		_tmp9_ = _tmp8_;
#line 2826 "../src/client/application/application-main-window.vala"
		_tmp10_ = geary_email_get_id (target);
#line 2826 "../src/client/application/application-main-window.vala"
		_tmp11_ = _tmp10_;
#line 2826 "../src/client/application/application-main-window.vala"
		_tmp12_ = geary_collection_single (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp11_);
#line 2826 "../src/client/application/application-main-window.vala"
		_tmp13_ = _tmp12_;
#line 2826 "../src/client/application/application-main-window.vala"
		application_controller_delete_messages (_tmp4_, _tmp5_, _tmp9_, _tmp13_, ____lambda213__gasync_ready_callback, block34_data_ref (_data34_));
#line 2826 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp13_);
#line 2826 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp9_);
#line 17712 "application-main-window.c"
	}
#line 2822 "../src/client/application/application-main-window.vala"
	block34_data_unref (_data34_);
#line 2822 "../src/client/application/application-main-window.vala"
	_data34_ = NULL;
#line 17718 "application-main-window.c"
}

static void
application_main_window_on_gtk_decoration_layout_changed (ApplicationMainWindow* self)
{
#line 2841 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2842 "../src/client/application/application-main-window.vala"
	application_main_window_update_close_button_position (self);
#line 17728 "application-main-window.c"
}

static void
application_main_window_class_init (ApplicationMainWindowClass * klass,
                                    gpointer klass_data)
{
	GtkBindingSet* bindings = NULL;
	GTypeClass* _tmp0_;
	GObjectClass* _tmp1_;
	GtkBindingSet* _tmp2_;
	GtkBindingSet* _tmp3_;
	GtkBindingSet* _tmp4_;
	GtkBindingSet* _tmp5_;
	GtkBindingSet* _tmp6_;
	GtkBindingSet* _tmp7_;
	GtkBindingSet* _tmp8_;
	GtkBindingSet* _tmp9_;
	GtkBindingSet* _tmp10_;
	GtkBindingSet* _tmp11_;
	GtkBindingSet* _tmp12_;
	GtkBindingSet* _tmp13_;
	GtkBindingSet* _tmp14_;
	GtkBindingSet* _tmp15_;
	GtkBindingSet* _tmp16_;
	GtkBindingSet* _tmp17_;
	GtkBindingSet* _tmp18_;
	GtkBindingSet* _tmp19_;
	GtkBindingSet* _tmp20_;
	GtkBindingSet* _tmp21_;
	GtkBindingSet* _tmp22_;
	GtkBindingSet* _tmp23_;
	GtkBindingSet* _tmp24_;
	GtkBindingSet* _tmp25_;
	GtkBindingSet* _tmp26_;
	GtkBindingSet* _tmp27_;
	GtkBindingSet* _tmp28_;
	GtkBindingSet* _tmp29_;
	GtkBindingSet* _tmp30_;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_parent_class = g_type_class_peek_parent (klass);
#line 10 "../src/client/application/application-main-window.vala"
	g_type_class_adjust_private_offset (klass, &ApplicationMainWindow_private_offset);
#line 10 "../src/client/application/application-main-window.vala"
	((GtkWidgetClass *) klass)->destroy = (void (*) (GtkWidget*)) application_main_window_real_destroy;
#line 10 "../src/client/application/application-main-window.vala"
	((GtkWidgetClass *) klass)->window_state_event = (gboolean (*) (GtkWidget*, GdkEventWindowState*)) application_main_window_real_window_state_event;
#line 10 "../src/client/application/application-main-window.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, GtkAllocation*)) application_main_window_real_size_allocate;
#line 10 "../src/client/application/application-main-window.vala"
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) application_main_window_real_key_press_event;
#line 10 "../src/client/application/application-main-window.vala"
	((GtkWidgetClass *) klass)->key_release_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) application_main_window_real_key_release_event;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->reply_conversation_sender = application_main_window_real_reply_conversation_sender;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->reply_conversation_all = application_main_window_real_reply_conversation_all;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->forward_conversation = application_main_window_real_forward_conversation;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->mark_conversations_read = application_main_window_real_mark_conversations_read;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->mark_conversations_starred = application_main_window_real_mark_conversations_starred;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->show_copy_menu = application_main_window_real_show_copy_menu;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->archive_conversations = application_main_window_real_archive_conversations;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->junk_conversations = application_main_window_real_junk_conversations;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->trash_conversations = application_main_window_real_trash_conversations;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->delete_conversations = application_main_window_real_delete_conversations;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->search = application_main_window_real_search;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->find = application_main_window_real_find;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->escape = application_main_window_real_escape;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->select_all = application_main_window_real_select_all;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->navigate = application_main_window_real_navigate;
#line 10 "../src/client/application/application-main-window.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_application_main_window_get_property;
#line 10 "../src/client/application/application-main-window.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_application_main_window_set_property;
#line 10 "../src/client/application/application-main-window.vala"
	G_OBJECT_CLASS (klass)->finalize = application_main_window_finalize;
#line 17817 "application-main-window.c"
	/** Returns the window's associated client application instance. */
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_APPLICATION_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_APPLICATION_PROPERTY] = g_param_spec_object ("application", "application", "application", APPLICATION_TYPE_CLIENT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 17821 "application-main-window.c"
	/** Currently selected account, null if none selected */
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_SELECTED_ACCOUNT_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_SELECTED_ACCOUNT_PROPERTY] = g_param_spec_object ("selected-account", "selected-account", "selected-account", GEARY_TYPE_ACCOUNT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 17825 "application-main-window.c"
	/** Currently selected folder, null if none selected */
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_SELECTED_FOLDER_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_SELECTED_FOLDER_PROPERTY] = g_param_spec_object ("selected-folder", "selected-folder", "selected-folder", GEARY_TYPE_FOLDER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 17829 "application-main-window.c"
	/** Conversations for the current folder, null if none selected */
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_CONVERSATIONS_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_CONVERSATIONS_PROPERTY] = g_param_spec_object ("conversations", "conversations", "conversations", GEARY_APP_TYPE_CONVERSATION_MONITOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 17833 "application-main-window.c"
	/** Specifies if the conversation list is currently displayed. */
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_IS_FOLDER_LIST_SHOWN_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_IS_FOLDER_LIST_SHOWN_PROPERTY] = g_param_spec_boolean ("is-folder-list-shown", "is-folder-list-shown", "is-folder-list-shown", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 17837 "application-main-window.c"
	/** Specifies if the conversation list is currently displayed. */
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_IS_CONVERSATION_LIST_SHOWN_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_IS_CONVERSATION_LIST_SHOWN_PROPERTY] = g_param_spec_boolean ("is-conversation-list-shown", "is-conversation-list-shown", "is-conversation-list-shown", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 17841 "application-main-window.c"
	/** Specifies if the conversation viewer is currently displayed. */
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_IS_CONVERSATION_VIEWER_SHOWN_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_IS_CONVERSATION_VIEWER_SHOWN_PROPERTY] = g_param_spec_boolean ("is-conversation-viewer-shown", "is-conversation-viewer-shown", "is-conversation-viewer-shown", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 17845 "application-main-window.c"
	/** The attachment manager for this window. */
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_ATTACHMENTS_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_ATTACHMENTS_PROPERTY] = g_param_spec_object ("attachments", "attachments", "attachments", APPLICATION_TYPE_ATTACHMENT_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 17849 "application-main-window.c"
	/** Determines if conversations in the selected folder can be trashed. */
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_SELECTED_FOLDER_SUPPORTS_TRASH_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_SELECTED_FOLDER_SUPPORTS_TRASH_PROPERTY] = g_param_spec_boolean ("selected-folder-supports-trash", "selected-folder-supports-trash", "selected-folder-supports-trash", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 17853 "application-main-window.c"
	/** Determines if a composer is currently open in this window. */
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_HAS_COMPOSER_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_HAS_COMPOSER_PROPERTY] = g_param_spec_boolean ("has-composer", "has-composer", "has-composer", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 17857 "application-main-window.c"
	/** Specifies if the Shift key is currently being held. */
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_IS_SHIFT_DOWN_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_IS_SHIFT_DOWN_PROPERTY] = g_param_spec_boolean ("is-shift-down", "is-shift-down", "is-shift-down", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_WINDOW_WIDTH_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_WINDOW_WIDTH_PROPERTY] = g_param_spec_int ("window-width", "window-width", "window-width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_WINDOW_HEIGHT_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_WINDOW_HEIGHT_PROPERTY] = g_param_spec_int ("window-height", "window-height", "window-height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_WINDOW_MAXIMIZED_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_WINDOW_MAXIMIZED_PROPERTY] = g_param_spec_boolean ("window-maximized", "window-maximized", "window-maximized", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_FOLDER_LIST_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_FOLDER_LIST_PROPERTY] = g_param_spec_object ("folder-list", "folder-list", "folder-list", FOLDER_LIST_TYPE_TREE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_SEARCH_BAR_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_SEARCH_BAR_PROPERTY] = g_param_spec_object ("search-bar", "search-bar", "search-bar", TYPE_SEARCH_BAR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_CONVERSATION_LIST_VIEW_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_CONVERSATION_LIST_VIEW_PROPERTY] = g_param_spec_object ("conversation-list-view", "conversation-list-view", "conversation-list-view", CONVERSATION_LIST_TYPE_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_CONVERSATION_VIEWER_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_CONVERSATION_VIEWER_PROPERTY] = g_param_spec_object ("conversation-viewer", "conversation-viewer", "conversation-viewer", TYPE_CONVERSATION_VIEWER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_CONVERSATION_LIST_INFO_BARS_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_CONVERSATION_LIST_INFO_BARS_PROPERTY] = g_param_spec_object ("conversation-list-info-bars", "conversation-list-info-bars", "conversation-list-info-bars", COMPONENTS_TYPE_INFO_BAR_STACK, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Geary/application-main-window.ui");
#line 17879 "application-main-window.c"
	/** Fired when the user requests an account status be retried. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_RETRY_SERVICE_PROBLEM_SIGNAL] = g_signal_new ("retry-service-problem", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, GEARY_CLIENT_SERVICE_TYPE_STATUS);
#line 17883 "application-main-window.c"
	/** Keybinding signal for replying to sender for the current conversation. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_REPLY_CONVERSATION_SENDER_SIGNAL] = g_signal_new ("reply-conversation-sender", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, reply_conversation_sender), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 17887 "application-main-window.c"
	/** Keybinding signal for replying to all for the current conversation. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_REPLY_CONVERSATION_ALL_SIGNAL] = g_signal_new ("reply-conversation-all", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, reply_conversation_all), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 17891 "application-main-window.c"
	/** Keybinding signal for forwarding the current conversation. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_FORWARD_CONVERSATION_SIGNAL] = g_signal_new ("forward-conversation", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, forward_conversation), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 17895 "application-main-window.c"
	/** Keybinding signal for marking the current selection read. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_MARK_CONVERSATIONS_READ_SIGNAL] = g_signal_new ("mark-conversations-read", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, mark_conversations_read), NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 17899 "application-main-window.c"
	/** Keybinding signal for marking the current selection starred. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_MARK_CONVERSATIONS_STARRED_SIGNAL] = g_signal_new ("mark-conversations-starred", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, mark_conversations_starred), NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 17903 "application-main-window.c"
	/** Keybinding signal for showing the copy/label menu. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_SHOW_COPY_MENU_SIGNAL] = g_signal_new ("show-copy-menu", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, show_copy_menu), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 17907 "application-main-window.c"
	/** Keybinding signal for archiving the current selection. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_ARCHIVE_CONVERSATIONS_SIGNAL] = g_signal_new ("archive-conversations", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, archive_conversations), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 17911 "application-main-window.c"
	/** Keybinding signal for junking the current selection. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_JUNK_CONVERSATIONS_SIGNAL] = g_signal_new ("junk-conversations", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, junk_conversations), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 17915 "application-main-window.c"
	/** Keybinding signal for trashing the current selection. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_TRASH_CONVERSATIONS_SIGNAL] = g_signal_new ("trash-conversations", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, trash_conversations), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 17919 "application-main-window.c"
	/** Keybinding signal for deleting the current selection. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_DELETE_CONVERSATIONS_SIGNAL] = g_signal_new ("delete-conversations", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, delete_conversations), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 17923 "application-main-window.c"
	/** Keybinding signal for activating conversation search. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_SEARCH_SIGNAL] = g_signal_new ("search", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, search), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 17927 "application-main-window.c"
	/** Keybinding signal for activating in-conversation find. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_FIND_SIGNAL] = g_signal_new ("find", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, find), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 17931 "application-main-window.c"
	/** Keybinding signal for escaping current view. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_ESCAPE_SIGNAL] = g_signal_new ("escape", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, escape), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 17935 "application-main-window.c"
	/** Keybinding signal for selecting all elements in current view. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_SELECT_ALL_SIGNAL] = g_signal_new ("select-all", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, select_all), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 17939 "application-main-window.c"
	/** Keybinding signal for shifting the keyboard focus. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_NAVIGATE_SIGNAL] = g_signal_new ("navigate", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, navigate), NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, gtk_scroll_type_get_type ());
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "application_headerbar", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, application_headerbar));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_list_headerbar", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, conversation_list_headerbar));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_headerbar", FALSE, G_STRUCT_OFFSET (ApplicationMainWindow, conversation_headerbar));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "outer_leaflet", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, outer_leaflet));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "inner_leaflet", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, inner_leaflet));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "folder_list_scrolled", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, folder_list_scrolled));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_list_box", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, conversation_list_box));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_list_actions_revealer", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, conversation_list_actions_revealer));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_list_actions", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, conversation_list_actions));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_viewer_actions", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, conversation_viewer_actions));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_viewer_box", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, conversation_viewer_box));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_viewer_actions_revealer", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, conversation_viewer_actions_revealer));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "overlay", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, overlay));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "info_bars", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, info_bars));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_map", G_CALLBACK(_application_main_window_on_map_gtk_widget_map));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_unmap", G_CALLBACK(_application_main_window_on_unmap_gtk_widget_unmap));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_focus_event", G_CALLBACK(_application_main_window_on_focus_event_gtk_widget_focus_out_event));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_delete_event", G_CALLBACK(_application_main_window_on_delete_event_gtk_widget_delete_event));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_outer_leaflet_changed", G_CALLBACK(_application_main_window_on_outer_leaflet_changed_g_object_notify));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_inner_leaflet_changed", G_CALLBACK(_application_main_window_on_inner_leaflet_changed_g_object_notify));
#line 82 "../src/client/application/application-main-window.vala"
	_tmp0_ = g_type_class_ref (APPLICATION_TYPE_MAIN_WINDOW);
#line 82 "../src/client/application/application-main-window.vala"
	_tmp1_ = (GObjectClass*) _tmp0_;
#line 82 "../src/client/application/application-main-window.vala"
	_tmp2_ = gtk_binding_set_by_class ((gpointer) _tmp1_);
#line 82 "../src/client/application/application-main-window.vala"
	_tmp3_ = _tmp2_;
#line 82 "../src/client/application/application-main-window.vala"
	_g_type_class_unref0 (_tmp1_);
#line 82 "../src/client/application/application-main-window.vala"
	bindings = _tmp3_;
#line 88 "../src/client/application/application-main-window.vala"
	_tmp4_ = bindings;
#line 88 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp4_, GDK_KEY_R, GDK_CONTROL_MASK, "reply-conversation-sender", (guint) 0, NULL);
#line 93 "../src/client/application/application-main-window.vala"
	_tmp5_ = bindings;
#line 93 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp5_, GDK_KEY_R, GDK_CONTROL_MASK | GDK_SHIFT_MASK, "reply-conversation-all", (guint) 0, NULL);
#line 98 "../src/client/application/application-main-window.vala"
	_tmp6_ = bindings;
#line 98 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp6_, GDK_KEY_L, GDK_CONTROL_MASK, "forward-conversation", (guint) 0, NULL);
#line 108 "../src/client/application/application-main-window.vala"
	_tmp7_ = bindings;
#line 108 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp7_, GDK_KEY_U, GDK_CONTROL_MASK, "mark-conversations-read", (guint) 1, G_TYPE_BOOLEAN, TRUE, NULL);
#line 113 "../src/client/application/application-main-window.vala"
	_tmp8_ = bindings;
#line 113 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp8_, GDK_KEY_U, GDK_CONTROL_MASK | GDK_SHIFT_MASK, "mark-conversations-read", (guint) 1, G_TYPE_BOOLEAN, FALSE, NULL);
#line 119 "../src/client/application/application-main-window.vala"
	_tmp9_ = bindings;
#line 119 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp9_, GDK_KEY_D, GDK_CONTROL_MASK, "mark-conversations-starred", (guint) 1, G_TYPE_BOOLEAN, TRUE, NULL);
#line 124 "../src/client/application/application-main-window.vala"
	_tmp10_ = bindings;
#line 124 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp10_, GDK_KEY_D, GDK_CONTROL_MASK | GDK_SHIFT_MASK, "mark-conversations-starred", (guint) 1, G_TYPE_BOOLEAN, FALSE, NULL);
#line 132 "../src/client/application/application-main-window.vala"
	_tmp11_ = bindings;
#line 132 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp11_, GDK_KEY_B, GDK_CONTROL_MASK, "show-copy-menu", (guint) 0, NULL);
#line 137 "../src/client/application/application-main-window.vala"
	_tmp12_ = bindings;
#line 137 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp12_, GDK_KEY_M, GDK_CONTROL_MASK, "show-move-menu", (guint) 0, NULL);
#line 142 "../src/client/application/application-main-window.vala"
	_tmp13_ = bindings;
#line 142 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp13_, GDK_KEY_K, GDK_CONTROL_MASK, "archive-conversations", (guint) 0, NULL);
#line 147 "../src/client/application/application-main-window.vala"
	_tmp14_ = bindings;
#line 147 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp14_, GDK_KEY_J, GDK_CONTROL_MASK, "junk-conversations", (guint) 0, NULL);
#line 153 "../src/client/application/application-main-window.vala"
	_tmp15_ = bindings;
#line 153 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp15_, GDK_KEY_BackSpace, 0, "trash-conversations", (guint) 0, NULL);
#line 158 "../src/client/application/application-main-window.vala"
	_tmp16_ = bindings;
#line 158 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp16_, GDK_KEY_Delete, 0, "trash-conversations", (guint) 0, NULL);
#line 163 "../src/client/application/application-main-window.vala"
	_tmp17_ = bindings;
#line 163 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp17_, GDK_KEY_KP_Delete, 0, "trash-conversations", (guint) 0, NULL);
#line 169 "../src/client/application/application-main-window.vala"
	_tmp18_ = bindings;
#line 169 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp18_, GDK_KEY_BackSpace, GDK_SHIFT_MASK, "delete-conversations", (guint) 0, NULL);
#line 174 "../src/client/application/application-main-window.vala"
	_tmp19_ = bindings;
#line 174 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp19_, GDK_KEY_Delete, GDK_SHIFT_MASK, "delete-conversations", (guint) 0, NULL);
#line 179 "../src/client/application/application-main-window.vala"
	_tmp20_ = bindings;
#line 179 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp20_, GDK_KEY_KP_Delete, GDK_SHIFT_MASK, "delete-conversations", (guint) 0, NULL);
#line 187 "../src/client/application/application-main-window.vala"
	_tmp21_ = bindings;
#line 187 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp21_, GDK_KEY_F, GDK_CONTROL_MASK, "find", (guint) 0, NULL);
#line 192 "../src/client/application/application-main-window.vala"
	_tmp22_ = bindings;
#line 192 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp22_, GDK_KEY_S, GDK_CONTROL_MASK, "search", (guint) 0, NULL);
#line 200 "../src/client/application/application-main-window.vala"
	_tmp23_ = bindings;
#line 200 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp23_, GDK_KEY_Left, GDK_MOD1_MASK, "navigate", (guint) 1, gtk_scroll_type_get_type (), GTK_SCROLL_PAGE_LEFT, NULL);
#line 206 "../src/client/application/application-main-window.vala"
	_tmp24_ = bindings;
#line 206 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp24_, GDK_KEY_Back, 0, "navigate", (guint) 1, gtk_scroll_type_get_type (), GTK_SCROLL_PAGE_LEFT, NULL);
#line 212 "../src/client/application/application-main-window.vala"
	_tmp25_ = bindings;
#line 212 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp25_, GDK_KEY_Right, GDK_MOD1_MASK, "navigate", (guint) 1, gtk_scroll_type_get_type (), GTK_SCROLL_PAGE_RIGHT, NULL);
#line 218 "../src/client/application/application-main-window.vala"
	_tmp26_ = bindings;
#line 218 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp26_, GDK_KEY_Forward, 0, "navigate", (guint) 1, gtk_scroll_type_get_type (), GTK_SCROLL_PAGE_RIGHT, NULL);
#line 224 "../src/client/application/application-main-window.vala"
	_tmp27_ = bindings;
#line 224 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp27_, GDK_KEY_comma, GDK_CONTROL_MASK, "navigate", (guint) 1, gtk_scroll_type_get_type (), GTK_SCROLL_STEP_UP, NULL);
#line 230 "../src/client/application/application-main-window.vala"
	_tmp28_ = bindings;
#line 230 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp28_, GDK_KEY_period, GDK_CONTROL_MASK, "navigate", (guint) 1, gtk_scroll_type_get_type (), GTK_SCROLL_STEP_DOWN, NULL);
#line 236 "../src/client/application/application-main-window.vala"
	_tmp29_ = bindings;
#line 236 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp29_, GDK_KEY_Escape, 0, "escape", (guint) 0, NULL);
#line 241 "../src/client/application/application-main-window.vala"
	_tmp30_ = bindings;
#line 241 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp30_, GDK_KEY_a, GDK_CONTROL_MASK, "select_all", (guint) 0, NULL);
#line 18103 "application-main-window.c"
}

static void
application_main_window_geary_base_interface_interface_init (GearyBaseInterfaceIface * iface,
                                                             gpointer iface_data)
{
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_geary_base_interface_parent_iface = g_type_interface_peek_parent (iface);
#line 18112 "application-main-window.c"
}

static void
application_main_window_instance_init (ApplicationMainWindow * self,
                                       gpointer klass)
{
	FolderListTree* _tmp0_;
	ComponentsInfoBarStack* _tmp1_;
	GeeHashSet* _tmp2_;
	GSimpleActionGroup* _tmp3_;
	GearyAggregateProgressMonitor* _tmp4_;
	GCancellable* _tmp5_;
	GCancellable* _tmp6_;
	ComponentsConversationActions** _tmp7_;
#line 10 "../src/client/application/application-main-window.vala"
	self->priv = application_main_window_get_instance_private (self);
#line 291 "../src/client/application/application-main-window.vala"
	self->priv->_selected_account = NULL;
#line 294 "../src/client/application/application-main-window.vala"
	self->priv->_selected_folder = NULL;
#line 297 "../src/client/application/application-main-window.vala"
	self->priv->_conversations = NULL;
#line 354 "../src/client/application/application-main-window.vala"
	self->priv->_is_shift_down = FALSE;
#line 362 "../src/client/application/application-main-window.vala"
	_tmp0_ = folder_list_tree_new ();
#line 362 "../src/client/application/application-main-window.vala"
	g_object_ref_sink (_tmp0_);
#line 362 "../src/client/application/application-main-window.vala"
	self->priv->_folder_list = _tmp0_;
#line 367 "../src/client/application/application-main-window.vala"
	_tmp1_ = components_info_bar_stack_new (COMPONENTS_INFO_BAR_STACK_STACK_TYPE_PRIORITY_QUEUE);
#line 367 "../src/client/application/application-main-window.vala"
	g_object_ref_sink (_tmp1_);
#line 367 "../src/client/application/application-main-window.vala"
	self->priv->_conversation_list_info_bars = _tmp1_;
#line 373 "../src/client/application/application-main-window.vala"
	_tmp2_ = gee_hash_set_new (APPLICATION_TYPE_ACCOUNT_CONTEXT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 373 "../src/client/application/application-main-window.vala"
	self->priv->accounts = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_SET, GeeSet);
#line 375 "../src/client/application/application-main-window.vala"
	_tmp3_ = g_simple_action_group_new ();
#line 375 "../src/client/application/application-main-window.vala"
	self->priv->edit_actions = _tmp3_;
#line 379 "../src/client/application/application-main-window.vala"
	self->priv->previous_selection_was_interactive = FALSE;
#line 383 "../src/client/application/application-main-window.vala"
	self->priv->previous_non_search_folder = NULL;
#line 385 "../src/client/application/application-main-window.vala"
	_tmp4_ = geary_aggregate_progress_monitor_new ();
#line 385 "../src/client/application/application-main-window.vala"
	self->priv->progress_monitor = _tmp4_;
#line 387 "../src/client/application/application-main-window.vala"
	_tmp5_ = g_cancellable_new ();
#line 387 "../src/client/application/application-main-window.vala"
	self->priv->action_update_cancellable = _tmp5_;
#line 388 "../src/client/application/application-main-window.vala"
	_tmp6_ = g_cancellable_new ();
#line 388 "../src/client/application/application-main-window.vala"
	self->priv->folder_open = _tmp6_;
#line 391 "../src/client/application/application-main-window.vala"
	self->priv->update_ui_last = (gint64) 0;
#line 417 "../src/client/application/application-main-window.vala"
	_tmp7_ = g_new0 (ComponentsConversationActions*, 0 + 1);
#line 417 "../src/client/application/application-main-window.vala"
	self->priv->folder_conversation_actions = _tmp7_;
#line 417 "../src/client/application/application-main-window.vala"
	self->priv->folder_conversation_actions_length1 = 0;
#line 417 "../src/client/application/application-main-window.vala"
	self->priv->_folder_conversation_actions_size_ = self->priv->folder_conversation_actions_length1;
#line 422 "../src/client/application/application-main-window.vala"
	self->priv->service_problem_infobar = NULL;
#line 10 "../src/client/application/application-main-window.vala"
	g_type_ensure (COMPONENTS_TYPE_APPLICATION_HEADER_BAR);
#line 10 "../src/client/application/application-main-window.vala"
	g_type_ensure (COMPONENTS_TYPE_CONVERSATION_LIST_HEADER_BAR);
#line 10 "../src/client/application/application-main-window.vala"
	g_type_ensure (COMPONENTS_TYPE_CONVERSATION_HEADER_BAR);
#line 10 "../src/client/application/application-main-window.vala"
	g_type_ensure (COMPONENTS_TYPE_CONVERSATION_ACTIONS);
#line 10 "../src/client/application/application-main-window.vala"
	g_type_ensure (COMPONENTS_TYPE_CONVERSATION_ACTIONS);
#line 10 "../src/client/application/application-main-window.vala"
	g_type_ensure (COMPONENTS_TYPE_INFO_BAR_STACK);
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 18199 "application-main-window.c"
}

static void
application_main_window_finalize (GObject * obj)
{
	ApplicationMainWindow * self;
#line 10 "../src/client/application/application-main-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APPLICATION_TYPE_MAIN_WINDOW, ApplicationMainWindow);
#line 682 "../src/client/application/application-main-window.vala"
	geary_base_interface_base_unref (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_BASE_INTERFACE, GearyBaseInterface));
#line 291 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->_selected_account);
#line 294 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->_selected_folder);
#line 297 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->_conversations);
#line 337 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->_attachments);
#line 362 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->_folder_list);
#line 363 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->_search_bar);
#line 364 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->_conversation_list_view);
#line 365 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->_conversation_viewer);
#line 367 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->_conversation_list_info_bars);
#line 371 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->controller);
#line 373 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->accounts);
#line 375 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->edit_actions);
#line 383 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->previous_non_search_folder);
#line 385 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->progress_monitor);
#line 387 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->action_update_cancellable);
#line 388 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->folder_open);
#line 390 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->update_ui_timeout);
#line 417 "../src/client/application/application-main-window.vala"
	self->priv->folder_conversation_actions = (_vala_array_free (self->priv->folder_conversation_actions, self->priv->folder_conversation_actions_length1, (GDestroyNotify) g_object_unref), NULL);
#line 419 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->offline_infobar);
#line 420 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->cert_problem_infobar);
#line 421 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->auth_problem_infobar);
#line 422 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->service_problem_infobar);
#line 10 "../src/client/application/application-main-window.vala"
	G_OBJECT_CLASS (application_main_window_parent_class)->finalize (obj);
#line 18256 "application-main-window.c"
}

static GType
application_main_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ApplicationMainWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) application_main_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ApplicationMainWindow), 0, (GInstanceInitFunc) application_main_window_instance_init, NULL };
	static const GInterfaceInfo geary_base_interface_info = { (GInterfaceInitFunc) application_main_window_geary_base_interface_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType application_main_window_type_id;
	application_main_window_type_id = g_type_register_static (hdy_application_window_get_type (), "ApplicationMainWindow", &g_define_type_info, 0);
	g_type_add_interface_static (application_main_window_type_id, GEARY_TYPE_BASE_INTERFACE, &geary_base_interface_info);
	ApplicationMainWindow_private_offset = g_type_add_instance_private (application_main_window_type_id, sizeof (ApplicationMainWindowPrivate));
	return application_main_window_type_id;
}

GType
application_main_window_get_type (void)
{
	static volatile gsize application_main_window_type_id__once = 0;
	if (g_once_init_enter (&application_main_window_type_id__once)) {
		GType application_main_window_type_id;
		application_main_window_type_id = application_main_window_get_type_once ();
		g_once_init_leave (&application_main_window_type_id__once, application_main_window_type_id);
	}
	return application_main_window_type_id__once;
}

static void
_vala_application_main_window_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	ApplicationMainWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APPLICATION_TYPE_MAIN_WINDOW, ApplicationMainWindow);
#line 10 "../src/client/application/application-main-window.vala"
	switch (property_id) {
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_APPLICATION_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_object (value, application_main_window_get_application (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_SELECTED_ACCOUNT_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_object (value, application_main_window_get_selected_account (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_SELECTED_FOLDER_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_object (value, application_main_window_get_selected_folder (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_CONVERSATIONS_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_object (value, application_main_window_get_conversations (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_IS_FOLDER_LIST_SHOWN_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_boolean (value, application_main_window_get_is_folder_list_shown (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_IS_CONVERSATION_LIST_SHOWN_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_boolean (value, application_main_window_get_is_conversation_list_shown (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_IS_CONVERSATION_VIEWER_SHOWN_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_boolean (value, application_main_window_get_is_conversation_viewer_shown (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_ATTACHMENTS_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_object (value, application_main_window_get_attachments (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_SELECTED_FOLDER_SUPPORTS_TRASH_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_boolean (value, application_main_window_get_selected_folder_supports_trash (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_HAS_COMPOSER_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_boolean (value, application_main_window_get_has_composer (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_IS_SHIFT_DOWN_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_boolean (value, application_main_window_get_is_shift_down (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_WINDOW_WIDTH_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_int (value, application_main_window_get_window_width (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_WINDOW_HEIGHT_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_int (value, application_main_window_get_window_height (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_WINDOW_MAXIMIZED_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_boolean (value, application_main_window_get_window_maximized (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_FOLDER_LIST_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_object (value, application_main_window_get_folder_list (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_SEARCH_BAR_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_object (value, application_main_window_get_search_bar (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_CONVERSATION_LIST_VIEW_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_object (value, application_main_window_get_conversation_list_view (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_CONVERSATION_VIEWER_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_object (value, application_main_window_get_conversation_viewer (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_CONVERSATION_LIST_INFO_BARS_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_object (value, application_main_window_get_conversation_list_info_bars (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 18407 "application-main-window.c"
		default:
#line 10 "../src/client/application/application-main-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 18413 "application-main-window.c"
	}
}

static void
_vala_application_main_window_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	ApplicationMainWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APPLICATION_TYPE_MAIN_WINDOW, ApplicationMainWindow);
#line 10 "../src/client/application/application-main-window.vala"
	switch (property_id) {
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_APPLICATION_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_application (self, g_value_get_object (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_SELECTED_ACCOUNT_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_selected_account (self, g_value_get_object (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_SELECTED_FOLDER_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_selected_folder (self, g_value_get_object (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_CONVERSATIONS_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_conversations (self, g_value_get_object (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_ATTACHMENTS_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_attachments (self, g_value_get_object (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_IS_SHIFT_DOWN_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_is_shift_down (self, g_value_get_boolean (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_WINDOW_WIDTH_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_window_width (self, g_value_get_int (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_WINDOW_HEIGHT_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_window_height (self, g_value_get_int (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_WINDOW_MAXIMIZED_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_window_maximized (self, g_value_get_boolean (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_FOLDER_LIST_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_folder_list (self, g_value_get_object (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_SEARCH_BAR_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_search_bar (self, g_value_get_object (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_CONVERSATION_LIST_VIEW_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_conversation_list_view (self, g_value_get_object (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_CONVERSATION_VIEWER_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_conversation_viewer (self, g_value_get_object (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_CONVERSATION_LIST_INFO_BARS_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_conversation_list_info_bars (self, g_value_get_object (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 18511 "application-main-window.c"
		default:
#line 10 "../src/client/application/application-main-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 18517 "application-main-window.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

