/* conversation-email.c generated by valac 0.56.17, the Vala compiler
 * generated from conversation-email.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2016,2019 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-client-46.0.h"
#include "geary-engine.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include <unistd.h>
#include <sys/stat.h>
#include <json-glib/json-glib.h>
#include <glib/gi18n-lib.h>
#include <webkit2/webkit2.h>

#define CONVERSATION_EMAIL_MANUAL_READ_CLASS "geary-manual-read"
#define CONVERSATION_EMAIL_SENT_CLASS "geary-sent"
#define CONVERSATION_EMAIL_STARRED_CLASS "geary-starred"
#define CONVERSATION_EMAIL_UNREAD_CLASS "geary-unread"
#define CONVERSATION_EMAIL_REQUIRED_FOR_CONSTRUCT ((GEARY_EMAIL_FIELD_ENVELOPE | GEARY_EMAIL_FIELD_PREVIEW) | GEARY_EMAIL_FIELD_FLAGS)
#define CONVERSATION_EMAIL_REQUIRED_FOR_LOAD (CONVERSATION_EMAIL_REQUIRED_FOR_CONSTRUCT | GEARY_EMAIL_REQUIRED_FOR_MESSAGE)
#define CONVERSATION_EMAIL_BODY_LOAD_TIMEOUT_MSEC 250
#define CONVERSATION_LIST_BOX_EMAIL_ACTION_GROUP_NAME "eml"
#define CONVERSATION_LIST_BOX_ACTION_MARK_UNREAD "mark-unread"
#define CONVERSATION_LIST_BOX_ACTION_MARK_UNREAD_DOWN "mark-unread-down"
#define CONVERSATION_LIST_BOX_ACTION_MARK_READ "mark-read"
#define CONVERSATION_LIST_BOX_ACTION_MARK_LOAD_REMOTE "mark-load-remote"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	CONVERSATION_EMAIL_0_PROPERTY,
	CONVERSATION_EMAIL_EMAIL_PROPERTY,
	CONVERSATION_EMAIL_IS_UNREAD_PROPERTY,
	CONVERSATION_EMAIL_IS_STARRED_PROPERTY,
	CONVERSATION_EMAIL_IS_MANUALLY_READ_PROPERTY,
	CONVERSATION_EMAIL_IS_DRAFT_PROPERTY,
	CONVERSATION_EMAIL_PRIMARY_MESSAGE_PROPERTY,
	CONVERSATION_EMAIL_ATTACHMENTS_PANE_PROPERTY,
	CONVERSATION_EMAIL_ATTACHED_MESSAGES_PROPERTY,
	CONVERSATION_EMAIL_MESSAGE_BODY_STATE_PROPERTY,
	CONVERSATION_EMAIL_NUM_PROPERTIES
};
static GParamSpec* conversation_email_properties[CONVERSATION_EMAIL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ConversationEmailLoadContactsData ConversationEmailLoadContactsData;
typedef struct _ConversationEmailLoadBodyData ConversationEmailLoadBodyData;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _ConversationEmailGetSelectionForQuotingData ConversationEmailGetSelectionForQuotingData;
typedef struct _ConversationEmailGetSelectionForFindData ConversationEmailGetSelectionForFindData;
typedef struct _Block84Data Block84Data;
typedef struct _Block85Data Block85Data;

#define APPLICATION_TYPE_CONTROLLER (application_controller_get_type ())
#define APPLICATION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLICATION_TYPE_CONTROLLER, ApplicationController))
#define APPLICATION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APPLICATION_TYPE_CONTROLLER, ApplicationControllerClass))
#define APPLICATION_IS_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLICATION_TYPE_CONTROLLER))
#define APPLICATION_IS_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLICATION_TYPE_CONTROLLER))
#define APPLICATION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLICATION_TYPE_CONTROLLER, ApplicationControllerClass))

typedef struct _ApplicationController ApplicationController;
typedef struct _ApplicationControllerClass ApplicationControllerClass;

#define COMPOSER_TYPE_APPLICATION_INTERFACE (composer_application_interface_get_type ())
#define COMPOSER_APPLICATION_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), COMPOSER_TYPE_APPLICATION_INTERFACE, ComposerApplicationInterface))
#define COMPOSER_IS_APPLICATION_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), COMPOSER_TYPE_APPLICATION_INTERFACE))
#define COMPOSER_APPLICATION_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), COMPOSER_TYPE_APPLICATION_INTERFACE, ComposerApplicationInterfaceIface))

typedef struct _ComposerApplicationInterface ComposerApplicationInterface;
typedef struct _ComposerApplicationInterfaceIface ComposerApplicationInterfaceIface;

#define APPLICATION_TYPE_ACCOUNT_INTERFACE (application_account_interface_get_type ())
#define APPLICATION_ACCOUNT_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface))
#define APPLICATION_IS_ACCOUNT_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLICATION_TYPE_ACCOUNT_INTERFACE))
#define APPLICATION_ACCOUNT_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterfaceIface))

typedef struct _ApplicationAccountInterface ApplicationAccountInterface;
typedef struct _ApplicationAccountInterfaceIface ApplicationAccountInterfaceIface;
typedef struct _ConversationEmailViewSourceData ConversationEmailViewSourceData;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _ConversationEmailPrintData ConversationEmailPrintData;

#define CONVERSATION_EMAIL_TYPE_MESSAGE_VIEW_ITERATOR (conversation_email_message_view_iterator_get_type ())
#define CONVERSATION_EMAIL_MESSAGE_VIEW_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONVERSATION_EMAIL_TYPE_MESSAGE_VIEW_ITERATOR, ConversationEmailMessageViewIterator))
#define CONVERSATION_EMAIL_MESSAGE_VIEW_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONVERSATION_EMAIL_TYPE_MESSAGE_VIEW_ITERATOR, ConversationEmailMessageViewIteratorClass))
#define CONVERSATION_EMAIL_IS_MESSAGE_VIEW_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONVERSATION_EMAIL_TYPE_MESSAGE_VIEW_ITERATOR))
#define CONVERSATION_EMAIL_IS_MESSAGE_VIEW_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONVERSATION_EMAIL_TYPE_MESSAGE_VIEW_ITERATOR))
#define CONVERSATION_EMAIL_MESSAGE_VIEW_ITERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONVERSATION_EMAIL_TYPE_MESSAGE_VIEW_ITERATOR, ConversationEmailMessageViewIteratorClass))

typedef struct _ConversationEmailMessageViewIterator ConversationEmailMessageViewIterator;
typedef struct _ConversationEmailMessageViewIteratorClass ConversationEmailMessageViewIteratorClass;
typedef struct _Block86Data Block86Data;
typedef struct _ConversationEmailFetchRemoteBodyData ConversationEmailFetchRemoteBodyData;
typedef struct _ConversationEmailUpdateBodyData ConversationEmailUpdateBodyData;
typedef struct _Block87Data Block87Data;
typedef struct _ConversationEmailMessageViewIteratorPrivate ConversationEmailMessageViewIteratorPrivate;
enum  {
	CONVERSATION_EMAIL_MESSAGE_VIEW_ITERATOR_0_PROPERTY,
	CONVERSATION_EMAIL_MESSAGE_VIEW_ITERATOR_READ_ONLY_PROPERTY,
	CONVERSATION_EMAIL_MESSAGE_VIEW_ITERATOR_VALID_PROPERTY,
	CONVERSATION_EMAIL_MESSAGE_VIEW_ITERATOR_NUM_PROPERTIES
};
static GParamSpec* conversation_email_message_view_iterator_properties[CONVERSATION_EMAIL_MESSAGE_VIEW_ITERATOR_NUM_PROPERTIES];
enum  {
	CONVERSATION_EMAIL_INTERNAL_LINK_ACTIVATED_SIGNAL,
	CONVERSATION_EMAIL_BODY_SELECTION_CHANGED_SIGNAL,
	CONVERSATION_EMAIL_NUM_SIGNALS
};
static guint conversation_email_signals[CONVERSATION_EMAIL_NUM_SIGNALS] = {0};

struct _ConversationEmailPrivate {
	GearyEmail* _email;
	gboolean _is_draft;
	ConversationMessage* _primary_message;
	ComponentsAttachmentPane* _attachments_pane;
	GeeList* _attached_messages;
	ConversationEmailLoadState _message_body_state;
	GearyAppEmailStore* email_store;
	ApplicationContactStore* contacts;
	GCancellable* load_cancellable;
	ApplicationConfiguration* config;
	GearyTimeoutManager* body_loading_timeout;
	GearyNonblockingSpinlock* message_bodies_loaded_lock;
	ConversationMessage* body_selection_message;
	GeeList* displayed_attachments;
	gboolean shift_handler_installed;
	GtkGrid* actions;
	GtkButton* attachments_button;
	GtkButton* star_button;
	GtkButton* unstar_button;
	GtkMenuButton* email_menubutton;
	GtkGrid* sub_messages;
};

struct _ConversationEmailLoadContactsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ConversationEmail* self;
	ConversationMessage* _tmp0_;
	GCancellable* _tmp1_;
	GError* err;
	GearyRFC822MailboxAddress* from;
	ConversationMessage* _tmp2_;
	GearyRFC822MailboxAddress* _tmp3_;
	GearyRFC822MailboxAddress* _tmp4_;
	GearyRFC822MailboxAddress* _tmp5_;
	gchar* _tmp6_;
	GearyRFC822MailboxAddress* _tmp7_;
	GearyRFC822MailboxAddress* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GError* _tmp11_;
	const gchar* _tmp12_;
	GCancellable* _tmp13_;
	GError* _tmp14_;
	GError* _inner_error0_;
};

struct _ConversationEmailLoadBodyData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ConversationEmail* self;
	gboolean loaded;
	GearyEmail* _tmp0_;
	GearyEmailField _tmp1_;
	GearyEmailField _tmp2_;
	GearyTimeoutManager* _tmp3_;
	GearyEmail* _tmp4_;
	GearyAppEmailStore* _tmp5_;
	GearyEmail* _tmp6_;
	GearyEmailIdentifier* _tmp7_;
	GearyEmailIdentifier* _tmp8_;
	GCancellable* _tmp9_;
	GearyEmail* _tmp10_;
	GearyTimeoutManager* _tmp11_;
	GError* err;
	GearyTimeoutManager* _tmp12_;
	GError* _tmp13_;
	GError* _tmp14_;
	GError* _vala1_err;
	GearyTimeoutManager* _tmp15_;
	GError* _tmp16_;
	GError* _tmp17_;
	GError* _tmp18_;
	GError* _vala2_err;
	GearyTimeoutManager* _tmp19_;
	GError* _tmp20_;
	GError* _tmp21_;
	GError* _vala3_err;
	GearyTimeoutManager* _tmp22_;
	GError* _tmp23_;
	GError* _tmp24_;
	GError* _tmp25_;
	GearyNonblockingSpinlock* _tmp26_;
	GCancellable* _tmp27_;
	GError* _inner_error0_;
};

struct _ConversationEmailGetSelectionForQuotingData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ConversationEmail* self;
	gchar* result;
	gchar* selection;
	ConversationMessage* _tmp0_;
	gchar* _tmp1_;
	ConversationMessage* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GError* err;
	GError* _tmp5_;
	const gchar* _tmp6_;
	GError* _inner_error0_;
};

struct _ConversationEmailGetSelectionForFindData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ConversationEmail* self;
	gchar* result;
	gchar* selection;
	ConversationMessage* _tmp0_;
	gchar* _tmp1_;
	ConversationMessage* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GError* err;
	GError* _tmp5_;
	const gchar* _tmp6_;
	GError* _inner_error0_;
};

struct _Block84Data {
	int _ref_count_;
	ConversationEmail* self;
	ApplicationMainWindow* main;
	gpointer _async_data_;
};

struct _Block85Data {
	int _ref_count_;
	Block84Data * _data84_;
	GearyEmail* email;
};

struct _ApplicationAccountInterfaceIface {
	GTypeInterface parent_iface;
	ApplicationAccountContext* (*get_context_for_account) (ApplicationAccountInterface* self, GearyAccountInformation* account);
	GeeCollection* (*get_account_contexts) (ApplicationAccountInterface* self);
};

struct _ComposerApplicationInterfaceIface {
	GTypeInterface parent_iface;
	void (*report_problem) (ComposerApplicationInterface* self, GearyProblemReport* report);
	void (*send_composed_email) (ComposerApplicationInterface* self, ComposerWidget* composer, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*send_composed_email_finish) (ComposerApplicationInterface* self, GAsyncResult* _res_);
	void (*save_composed_email) (ComposerApplicationInterface* self, ComposerWidget* composer, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*save_composed_email_finish) (ComposerApplicationInterface* self, GAsyncResult* _res_);
	void (*discard_composed_email) (ComposerApplicationInterface* self, ComposerWidget* composer, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*discard_composed_email_finish) (ComposerApplicationInterface* self, GAsyncResult* _res_);
};

struct _ConversationEmailViewSourceData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ConversationEmail* self;
	Block84Data* _data84_;
	GtkWidget* _tmp0_;
	ApplicationMainWindow* _tmp1_;
	ApplicationMainWindow* _tmp2_;
	Block85Data* _data85_;
	GearyEmail* _tmp3_;
	GearyEmail* _tmp4_;
	GearyNonblockingConcurrent* _tmp5_;
	GearyNonblockingConcurrent* _tmp6_;
	GError* _error_;
	ApplicationMainWindow* _tmp7_;
	ApplicationClient* _tmp8_;
	ApplicationClient* _tmp9_;
	ApplicationController* _tmp10_;
	ApplicationController* _tmp11_;
	GError* _tmp12_;
	GearyProblemReport* _tmp13_;
	GearyProblemReport* _tmp14_;
	GError* _inner_error0_;
};

struct _ConversationEmailPrintData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ConversationEmail* self;
	JsonBuilder* builder;
	JsonBuilder* _tmp0_;
	JsonBuilder* _tmp1_;
	GearyEmail* _tmp2_;
	GearyRFC822MailboxAddresses* _tmp3_;
	GearyRFC822MailboxAddresses* _tmp4_;
	JsonBuilder* _tmp5_;
	JsonBuilder* _tmp6_;
	GearyEmail* _tmp7_;
	GearyRFC822MailboxAddresses* _tmp8_;
	GearyRFC822MailboxAddresses* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GearyEmail* _tmp12_;
	GearyRFC822MailboxAddresses* _tmp13_;
	GearyRFC822MailboxAddresses* _tmp14_;
	JsonBuilder* _tmp15_;
	JsonBuilder* _tmp16_;
	GearyEmail* _tmp17_;
	GearyRFC822MailboxAddresses* _tmp18_;
	GearyRFC822MailboxAddresses* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	GearyEmail* _tmp22_;
	GearyRFC822MailboxAddresses* _tmp23_;
	GearyRFC822MailboxAddresses* _tmp24_;
	JsonBuilder* _tmp25_;
	JsonBuilder* _tmp26_;
	GearyEmail* _tmp27_;
	GearyRFC822MailboxAddresses* _tmp28_;
	GearyRFC822MailboxAddresses* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	GearyEmail* _tmp32_;
	GearyRFC822MailboxAddresses* _tmp33_;
	GearyRFC822MailboxAddresses* _tmp34_;
	JsonBuilder* _tmp35_;
	JsonBuilder* _tmp36_;
	GearyEmail* _tmp37_;
	GearyRFC822MailboxAddresses* _tmp38_;
	GearyRFC822MailboxAddresses* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	GearyEmail* _tmp42_;
	GearyRFC822Date* _tmp43_;
	GearyRFC822Date* _tmp44_;
	JsonBuilder* _tmp45_;
	JsonBuilder* _tmp46_;
	GearyEmail* _tmp47_;
	GearyRFC822Date* _tmp48_;
	GearyRFC822Date* _tmp49_;
	GDateTime* _tmp50_;
	GDateTime* _tmp51_;
	GDateTime* _tmp52_;
	GDateTime* _tmp53_;
	ApplicationConfiguration* _tmp54_;
	UtilDateClockFormat _tmp55_;
	UtilDateClockFormat _tmp56_;
	gchar* _tmp57_;
	gchar* _tmp58_;
	GearyEmail* _tmp59_;
	GearyRFC822Subject* _tmp60_;
	GearyRFC822Subject* _tmp61_;
	JsonBuilder* _tmp62_;
	JsonBuilder* _tmp63_;
	GearyEmail* _tmp64_;
	GearyRFC822Subject* _tmp65_;
	GearyRFC822Subject* _tmp66_;
	gchar* _tmp67_;
	gchar* _tmp68_;
	JsonBuilder* _tmp69_;
	JsonGenerator* generator;
	JsonGenerator* _tmp70_;
	JsonBuilder* _tmp71_;
	JsonNode* _tmp72_;
	JsonNode* _tmp73_;
	gchar* js;
	gchar* _tmp74_;
	gchar* _tmp75_;
	gchar* _tmp76_;
	gchar* _tmp77_;
	gchar* _tmp78_;
	gchar* _tmp79_;
	ConversationMessage* _tmp80_;
	GtkWindow* window;
	GtkWidget* _tmp81_;
	GtkWindow* _tmp82_;
	WebKitPrintOperation* op;
	ConversationMessage* _tmp83_;
	WebKitPrintOperation* _tmp84_;
	GtkPrintSettings* settings;
	GtkPrintSettings* _tmp85_;
	gchar* download_dir;
	const gchar* _tmp86_;
	gchar* _tmp87_;
	const gchar* _tmp88_;
	GtkPrintSettings* _tmp89_;
	const gchar* _tmp90_;
	GearyEmail* _tmp91_;
	GearyRFC822Subject* _tmp92_;
	GearyRFC822Subject* _tmp93_;
	gchar* file_name;
	GearyEmail* _tmp94_;
	GearyRFC822Subject* _tmp95_;
	GearyRFC822Subject* _tmp96_;
	const gchar* _tmp97_;
	const gchar* _tmp98_;
	gchar* _tmp99_;
	const gchar* _tmp100_;
	gchar* _tmp101_;
	const gchar* _tmp102_;
	const gchar* _tmp103_;
	gchar* _tmp104_;
	const gchar* _tmp105_;
	GtkPrintSettings* _tmp106_;
	const gchar* _tmp107_;
	WebKitPrintOperation* _tmp108_;
	GtkPrintSettings* _tmp109_;
	WebKitPrintOperation* _tmp110_;
	GtkWindow* _tmp111_;
	GError* _inner_error0_;
};

struct _Block86Data {
	int _ref_count_;
	ConversationEmail* self;
	ConversationMessage* view;
};

struct _ConversationEmailFetchRemoteBodyData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ConversationEmail* self;
	GearyTimeoutManager* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GearyTimeoutManager* _tmp3_;
	GearyEmail* loaded;
	GearyEmail* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GearyEmail* _tmp7_;
	GearyAppEmailStore* _tmp8_;
	GearyEmail* _tmp9_;
	GearyEmailIdentifier* _tmp10_;
	GearyEmailIdentifier* _tmp11_;
	GCancellable* _tmp12_;
	GearyEmail* _tmp13_;
	GearyEmail* _tmp14_;
	GError* err;
	GError* _tmp15_;
	const gchar* _tmp16_;
	GError* _tmp17_;
	GearyTimeoutManager* _tmp18_;
	gboolean _tmp19_;
	GearyEmail* _tmp20_;
	GCancellable* _tmp21_;
	GearyEmail* _tmp22_;
	GError* _vala1_err;
	GError* _tmp23_;
	const gchar* _tmp24_;
	GError* _tmp25_;
	GearyTimeoutManager* _tmp26_;
	GError* _inner_error0_;
};

struct _ConversationEmailUpdateBodyData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ConversationEmail* self;
	GearyRFC822Message* message;
	GearyEmail* _tmp0_;
	GearyRFC822Message* _tmp1_;
	GeeMap* cid_resources;
	GeeHashMap* _tmp2_;
	GeeList* _attachment_list;
	GearyEmail* _tmp3_;
	GeeList* _tmp4_;
	GeeList* _tmp5_;
	gint _attachment_size;
	GeeList* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _attachment_index;
	gint _tmp9_;
	gint _tmp10_;
	GearyAttachment* attachment;
	GeeList* _tmp11_;
	gpointer _tmp12_;
	GeeList* _tmp13_;
	GearyAttachment* _tmp14_;
	GearyAttachment* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	GearyMemoryFileBuffer* _tmp18_;
	GearyAttachment* _tmp19_;
	GFile* _tmp20_;
	GFile* _tmp21_;
	GearyMemoryFileBuffer* _tmp22_;
	GeeMap* _tmp23_;
	GearyAttachment* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	GError* err;
	GError* _tmp27_;
	const gchar* _tmp28_;
	GtkButton* _tmp29_;
	GeeList* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	ConversationMessage* _tmp33_;
	GeeMap* _tmp34_;
	ConversationMessage* _tmp35_;
	GearyRFC822Message* _tmp36_;
	GCancellable* _tmp37_;
	GeeList* sub_messages;
	GearyRFC822Message* _tmp38_;
	GeeList* _tmp39_;
	GeeList* _tmp40_;
	gint _tmp41_;
	gint _tmp42_;
	ConversationMessage* _tmp43_;
	GtkGrid* _tmp44_;
	GtkGrid* _tmp45_;
	GtkGrid* _tmp46_;
	GeeList* _sub_message_list;
	GeeList* _tmp47_;
	gint _sub_message_size;
	GeeList* _tmp48_;
	gint _tmp49_;
	gint _tmp50_;
	gint _sub_message_index;
	gint _tmp51_;
	gint _tmp52_;
	GearyRFC822Message* sub_message;
	GeeList* _tmp53_;
	gpointer _tmp54_;
	ConversationMessage* attached_message;
	GearyRFC822Message* _tmp55_;
	GearyEmail* _tmp56_;
	ApplicationContactStore* _tmp57_;
	ApplicationConfiguration* _tmp58_;
	ConversationMessage* _tmp59_;
	ConversationMessage* _tmp60_;
	ConversationMessage* _tmp61_;
	GeeMap* _tmp62_;
	GtkGrid* _tmp63_;
	ConversationMessage* _tmp64_;
	GeeList* _tmp65_;
	ConversationMessage* _tmp66_;
	ConversationMessage* _tmp67_;
	GCancellable* _tmp68_;
	ConversationMessage* _tmp69_;
	GearyRFC822Message* _tmp70_;
	GCancellable* _tmp71_;
	ConversationMessage* _tmp72_;
	GError* _inner_error0_;
};

struct _Block87Data {
	int _ref_count_;
	ConversationEmail* self;
	gchar** blacklist;
	gint blacklist_length1;
	gint _blacklist_size_;
	gboolean show_trash;
	gboolean show_delete;
	GVariant* email_target;
};

struct _ConversationEmailMessageViewIterator {
	GearyBaseObject parent_instance;
	ConversationEmailMessageViewIteratorPrivate * priv;
};

struct _ConversationEmailMessageViewIteratorClass {
	GearyBaseObjectClass parent_class;
};

struct _ConversationEmailMessageViewIteratorPrivate {
	ConversationEmail* parent_view;
	gint pos;
	GeeIterator* attached_views;
};

static gint ConversationEmail_private_offset;
static gpointer conversation_email_parent_class = NULL;
static GMenuModel* conversation_email_email_menu_template;
static GMenuModel* conversation_email_email_menu_template = NULL;
static GMenuModel* conversation_email_email_menu_trash_section;
static GMenuModel* conversation_email_email_menu_trash_section = NULL;
static GMenuModel* conversation_email_email_menu_delete_section;
static GMenuModel* conversation_email_email_menu_delete_section = NULL;
static gint ConversationEmailMessageViewIterator_private_offset;
static gpointer conversation_email_message_view_iterator_parent_class = NULL;
static GeeTraversableIface * conversation_email_message_view_iterator_gee_traversable_parent_iface = NULL;
static GeeIteratorIface * conversation_email_message_view_iterator_gee_iterator_parent_iface = NULL;
static GearyBaseInterfaceIface * conversation_email_geary_base_interface_parent_iface = NULL;

static void conversation_email_set_email (ConversationEmail* self,
                                   GearyEmail* value);
static void conversation_email_set_is_draft (ConversationEmail* self,
                                      gboolean value);
static void conversation_email_set_primary_message (ConversationEmail* self,
                                             ConversationMessage* value);
static void conversation_email_set_attachments_pane (ConversationEmail* self,
                                              ComponentsAttachmentPane* value);
static void conversation_email_set_message_body_state (ConversationEmail* self,
                                                ConversationEmailLoadState value);
VALA_EXTERN GtkGrid* conversation_message_get_summary (ConversationMessage* self);
static void conversation_email_connect_message_view_signals (ConversationEmail* self,
                                                      ConversationMessage* view);
static void conversation_email_on_service_status_change (ConversationEmail* self);
static void _conversation_email_on_service_status_change_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self);
static void conversation_email_on_load_cancelled (ConversationEmail* self);
static void _conversation_email_on_load_cancelled_g_cancellable_cancelled (GCancellable* _sender,
                                                                    gpointer self);
static void conversation_email_on_body_loading_timeout (ConversationEmail* self);
static void _conversation_email_on_body_loading_timeout_geary_timeout_manager_timeout_func (GearyTimeoutManager* manager,
                                                                                     gpointer self);
static void conversation_email_update_email_state (ConversationEmail* self);
static void conversation_email_load_contacts_data_free (gpointer _data);
static gboolean conversation_email_load_contacts_co (ConversationEmailLoadContactsData* _data_);
static void conversation_email_load_contacts_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_);
VALA_EXTERN GearyRFC822MailboxAddress* conversation_message_get_primary_originator (ConversationMessage* self);
static void conversation_email_load_body_data_free (gpointer _data);
static gboolean conversation_email_load_body_co (ConversationEmailLoadBodyData* _data_);
static void conversation_email_load_body_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_);
static void conversation_email_fetch_remote_body (ConversationEmail* self,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
static void conversation_email_fetch_remote_body_finish (ConversationEmail* self,
                                                  GAsyncResult* _res_);
static void conversation_email_handle_load_failure (ConversationEmail* self,
                                             GError* _error_);
static void conversation_email_update_body (ConversationEmail* self,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
static void conversation_email_update_body_finish (ConversationEmail* self,
                                            GAsyncResult* _res_,
                                            GError** error);
VALA_EXTERN GeeIterator* conversation_email_iterator (ConversationEmail* self);
static void conversation_email_get_selection_for_quoting_data_free (gpointer _data);
static gboolean conversation_email_get_selection_for_quoting_co (ConversationEmailGetSelectionForQuotingData* _data_);
static void conversation_email_get_selection_for_quoting_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_);
static void conversation_email_get_selection_for_find_data_free (gpointer _data);
static gboolean conversation_email_get_selection_for_find_co (ConversationEmailGetSelectionForFindData* _data_);
static void conversation_email_get_selection_for_find_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
static void conversation_email_view_source_data_free (gpointer _data);
static gboolean conversation_email_view_source_co (ConversationEmailViewSourceData* _data_);
static Block84Data* block84_data_ref (Block84Data* _data84_);
static void block84_data_unref (void * _userdata_);
static Block85Data* block85_data_ref (Block85Data* _data85_);
static void block85_data_unref (void * _userdata_);
static void ____lambda105_ (Block85Data* _data85_,
                     GError** error);
static void _____lambda105__geary_nonblocking_concurrent_concurrent_callback (GCancellable* cancellable,
                                                                       gpointer self,
                                                                       GError** error);
static void conversation_email_view_source_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_);
VALA_EXTERN GType application_controller_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ApplicationController* application_client_get_controller (ApplicationClient* self);
VALA_EXTERN GType application_account_interface_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType composer_application_interface_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void composer_application_interface_report_problem (ComposerApplicationInterface* self,
                                                    GearyProblemReport* report);
static void conversation_email_print_data_free (gpointer _data);
static gboolean conversation_email_print_co (ConversationEmailPrintData* _data_);
static void _vala_JsonNode_free (JsonNode* self);
static void conversation_email_print_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_);
static ConversationEmailMessageViewIterator* conversation_email_message_view_iterator_new (ConversationEmail* parent_view);
static ConversationEmailMessageViewIterator* conversation_email_message_view_iterator_construct (GType object_type,
                                                                                          ConversationEmail* parent_view);
static GType conversation_email_message_view_iterator_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static Block86Data* block86_data_ref (Block86Data* _data86_);
static void block86_data_unref (void * _userdata_);
static void conversation_email_on_content_loaded (ConversationEmail* self);
static void _conversation_email_on_content_loaded_conversation_message_content_loaded (ConversationMessage* _sender,
                                                                                gpointer self);
static void conversation_email_on_flag_remote_images (ConversationEmail* self);
static void _conversation_email_on_flag_remote_images_conversation_message_flag_remote_images (ConversationMessage* _sender,
                                                                                        gpointer self);
static void __lambda102_ (ConversationEmail* self,
                   gint y);
static void ___lambda102__conversation_message_internal_link_activated (ConversationMessage* _sender,
                                                                 gint y,
                                                                 gpointer self);
static void conversation_email_on_resource_loaded (ConversationEmail* self,
                                            const gchar* id);
static void _conversation_email_on_resource_loaded_conversation_message_internal_resource_loaded (ConversationMessage* _sender,
                                                                                           const gchar* name,
                                                                                           gpointer self);
static void conversation_email_on_save_image (ConversationEmail* self,
                                       const gchar* uri,
                                       const gchar* alt_text,
                                       GearyMemoryBuffer* content);
static void _conversation_email_on_save_image_conversation_message_save_image (ConversationMessage* _sender,
                                                                        const gchar* uri,
                                                                        const gchar* alt_text,
                                                                        GearyMemoryBuffer* buffer,
                                                                        gpointer self);
static void __lambda103_ (Block86Data* _data86_,
                   gboolean has_selection);
static void ___lambda103__conversation_message_selection_changed (ConversationMessage* _sender,
                                                           gboolean has_selection,
                                                           gpointer self);
static void conversation_email_fetch_remote_body_data_free (gpointer _data);
static gboolean conversation_email_fetch_remote_body_co (ConversationEmailFetchRemoteBodyData* _data_);
static inline gboolean conversation_email_is_online (ConversationEmail* self);
static void conversation_email_fetch_remote_body_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_);
static void conversation_email_handle_load_offline (ConversationEmail* self);
static void conversation_email_update_body_data_free (gpointer _data);
static gboolean conversation_email_update_body_co (ConversationEmailUpdateBodyData* _data_);
static void conversation_email_update_body_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_);
VALA_EXTERN GtkGrid* conversation_message_get_body_container (ConversationMessage* self);
static void conversation_email_update_email_menu (ConversationEmail* self);
static Block87Data* block87_data_ref (Block87Data* _data87_);
static void block87_data_unref (void * _userdata_);
VALA_EXTERN gboolean application_controller_does_folder_support_trash (GearyFolder* target);
static void conversation_email_on_shift_changed (ConversationEmail* self);
static void _conversation_email_on_shift_changed_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self);
static void _vala_array_add16 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add17 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add18 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static gboolean ___lambda104_ (Block87Data* _data87_,
                        GMenuModel* menu,
                        GMenuModel* submenu,
                        const gchar* action,
                        GMenuItem* item);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static gboolean ____lambda104__util_gtk_menu_visitor (GMenuModel* existing_menu,
                                               GMenuModel* existing_child_menu,
                                               const gchar* existing_action,
                                               GMenuItem* new_item,
                                               gpointer self);
static void conversation_email_update_displayed_attachments (ConversationEmail* self);
static void conversation_email_activate_email_action (ConversationEmail* self,
                                               const gchar* name);
static void conversation_email_on_email_menu (ConversationEmail* self);
static void _conversation_email_on_email_menu_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                  gpointer self);
VALA_EXTERN gboolean conversation_message_get_is_content_loaded (ConversationMessage* self);
static gboolean conversation_email_message_view_iterator_real_next (GeeIterator* base);
static gboolean conversation_email_message_view_iterator_real_has_next (GeeIterator* base);
static ConversationMessage* conversation_email_message_view_iterator_real_get (GeeIterator* base);
static void conversation_email_message_view_iterator_real_remove (GeeIterator* base);
static gboolean conversation_email_message_view_iterator_real_foreach (GeeTraversable* base,
                                                                GeeForallFunc f,
                                                                gpointer f_target);
static void conversation_email_message_view_iterator_finalize (GObject * obj);
static GType conversation_email_message_view_iterator_get_type_once (void);
static void _vala_conversation_email_message_view_iterator_get_property (GObject * object,
                                                                  guint property_id,
                                                                  GValue * value,
                                                                  GParamSpec * pspec);
static void conversation_email_finalize (GObject * obj);
static GType conversation_email_get_type_once (void);
static void _vala_conversation_email_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_conversation_email_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
conversation_email_get_instance_private (ConversationEmail* self)
{
	return G_STRUCT_MEMBER_P (self, ConversationEmail_private_offset);
}

/** Specifies the loading state for a message part. */
static GType
conversation_email_load_state_get_type_once (void)
{
	static const GEnumValue values[] = {{CONVERSATION_EMAIL_LOAD_STATE_NOT_STARTED, "CONVERSATION_EMAIL_LOAD_STATE_NOT_STARTED", "not-started"}, {CONVERSATION_EMAIL_LOAD_STATE_STARTED, "CONVERSATION_EMAIL_LOAD_STATE_STARTED", "started"}, {CONVERSATION_EMAIL_LOAD_STATE_COMPLETED, "CONVERSATION_EMAIL_LOAD_STATE_COMPLETED", "completed"}, {CONVERSATION_EMAIL_LOAD_STATE_FAILED, "CONVERSATION_EMAIL_LOAD_STATE_FAILED", "failed"}, {0, NULL, NULL}};
	GType conversation_email_load_state_type_id;
	conversation_email_load_state_type_id = g_enum_register_static ("ConversationEmailLoadState", values);
	return conversation_email_load_state_type_id;
}

GType
conversation_email_load_state_get_type (void)
{
	static volatile gsize conversation_email_load_state_type_id__once = 0;
	if (g_once_init_enter (&conversation_email_load_state_type_id__once)) {
		GType conversation_email_load_state_type_id;
		conversation_email_load_state_type_id = conversation_email_load_state_get_type_once ();
		g_once_init_leave (&conversation_email_load_state_type_id__once, conversation_email_load_state_type_id);
	}
	return conversation_email_load_state_type_id__once;
}

GearyEmail*
conversation_email_get_email (ConversationEmail* self)
{
	GearyEmail* result;
	GearyEmail* _tmp0_;
#line 157 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_val_if_fail (IS_CONVERSATION_EMAIL (self), NULL);
#line 157 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = self->priv->_email;
#line 157 "../src/client/conversation-viewer/conversation-email.vala"
	result = _tmp0_;
#line 157 "../src/client/conversation-viewer/conversation-email.vala"
	return result;
#line 875 "conversation-email.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 157 "../src/client/conversation-viewer/conversation-email.vala"
	return self ? g_object_ref (self) : NULL;
#line 883 "conversation-email.c"
}

static void
conversation_email_set_email (ConversationEmail* self,
                              GearyEmail* value)
{
	GearyEmail* old_value;
#line 157 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 157 "../src/client/conversation-viewer/conversation-email.vala"
	old_value = conversation_email_get_email (self);
#line 157 "../src/client/conversation-viewer/conversation-email.vala"
	if (old_value != value) {
#line 897 "conversation-email.c"
		GearyEmail* _tmp0_;
#line 157 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 157 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (self->priv->_email);
#line 157 "../src/client/conversation-viewer/conversation-email.vala"
		self->priv->_email = _tmp0_;
#line 157 "../src/client/conversation-viewer/conversation-email.vala"
		g_object_notify_by_pspec ((GObject *) self, conversation_email_properties[CONVERSATION_EMAIL_EMAIL_PROPERTY]);
#line 907 "conversation-email.c"
	}
}

gboolean
conversation_email_get_is_unread (ConversationEmail* self)
{
	gboolean result;
	GearyEmailFlags* flags = NULL;
	GearyEmail* _tmp0_;
	GearyEmailFlags* _tmp1_;
	GearyEmailFlags* _tmp2_;
	GearyEmailFlags* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GearyEmailFlags* _tmp5_;
#line 161 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_val_if_fail (IS_CONVERSATION_EMAIL (self), FALSE);
#line 162 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = self->priv->_email;
#line 162 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp1_ = geary_email_get_email_flags (_tmp0_);
#line 162 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp2_ = _tmp1_;
#line 162 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 162 "../src/client/conversation-viewer/conversation-email.vala"
	flags = _tmp3_;
#line 163 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp5_ = flags;
#line 163 "../src/client/conversation-viewer/conversation-email.vala"
	if (_tmp5_ != NULL) {
#line 938 "conversation-email.c"
		GearyEmailFlags* _tmp6_;
#line 163 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp6_ = flags;
#line 163 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp4_ = geary_email_flags_is_unread (_tmp6_);
#line 944 "conversation-email.c"
	} else {
#line 163 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp4_ = FALSE;
#line 948 "conversation-email.c"
	}
#line 163 "../src/client/conversation-viewer/conversation-email.vala"
	result = _tmp4_;
#line 163 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (flags);
#line 163 "../src/client/conversation-viewer/conversation-email.vala"
	return result;
#line 956 "conversation-email.c"
}

gboolean
conversation_email_get_is_starred (ConversationEmail* self)
{
	gboolean result;
	GearyEmailFlags* flags = NULL;
	GearyEmail* _tmp0_;
	GearyEmailFlags* _tmp1_;
	GearyEmailFlags* _tmp2_;
	GearyEmailFlags* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GearyEmailFlags* _tmp5_;
#line 169 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_val_if_fail (IS_CONVERSATION_EMAIL (self), FALSE);
#line 170 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = self->priv->_email;
#line 170 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp1_ = geary_email_get_email_flags (_tmp0_);
#line 170 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp2_ = _tmp1_;
#line 170 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 170 "../src/client/conversation-viewer/conversation-email.vala"
	flags = _tmp3_;
#line 171 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp5_ = flags;
#line 171 "../src/client/conversation-viewer/conversation-email.vala"
	if (_tmp5_ != NULL) {
#line 986 "conversation-email.c"
		GearyEmailFlags* _tmp6_;
#line 171 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp6_ = flags;
#line 171 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp4_ = geary_email_flags_is_flagged (_tmp6_);
#line 992 "conversation-email.c"
	} else {
#line 171 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp4_ = FALSE;
#line 996 "conversation-email.c"
	}
#line 171 "../src/client/conversation-viewer/conversation-email.vala"
	result = _tmp4_;
#line 171 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (flags);
#line 171 "../src/client/conversation-viewer/conversation-email.vala"
	return result;
#line 1004 "conversation-email.c"
}

gboolean
conversation_email_get_is_manually_read (ConversationEmail* self)
{
	gboolean result;
	GtkStyleContext* _tmp0_;
#line 180 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_val_if_fail (IS_CONVERSATION_EMAIL (self), FALSE);
#line 180 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 180 "../src/client/conversation-viewer/conversation-email.vala"
	result = gtk_style_context_has_class (_tmp0_, CONVERSATION_EMAIL_MANUAL_READ_CLASS);
#line 180 "../src/client/conversation-viewer/conversation-email.vala"
	return result;
#line 1020 "conversation-email.c"
}

void
conversation_email_set_is_manually_read (ConversationEmail* self,
                                         gboolean value)
{
#line 181 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 182 "../src/client/conversation-viewer/conversation-email.vala"
	if (value) {
#line 1031 "conversation-email.c"
		GtkStyleContext* _tmp0_;
#line 183 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp0_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 183 "../src/client/conversation-viewer/conversation-email.vala"
		gtk_style_context_add_class (_tmp0_, CONVERSATION_EMAIL_MANUAL_READ_CLASS);
#line 1037 "conversation-email.c"
	} else {
		GtkStyleContext* _tmp1_;
#line 185 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp1_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 185 "../src/client/conversation-viewer/conversation-email.vala"
		gtk_style_context_remove_class (_tmp1_, CONVERSATION_EMAIL_MANUAL_READ_CLASS);
#line 1044 "conversation-email.c"
	}
#line 181 "../src/client/conversation-viewer/conversation-email.vala"
	g_object_notify_by_pspec ((GObject *) self, conversation_email_properties[CONVERSATION_EMAIL_IS_MANUALLY_READ_PROPERTY]);
#line 1048 "conversation-email.c"
}

gboolean
conversation_email_get_is_draft (ConversationEmail* self)
{
	gboolean result;
#line 191 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_val_if_fail (IS_CONVERSATION_EMAIL (self), FALSE);
#line 191 "../src/client/conversation-viewer/conversation-email.vala"
	result = self->priv->_is_draft;
#line 191 "../src/client/conversation-viewer/conversation-email.vala"
	return result;
#line 1061 "conversation-email.c"
}

static void
conversation_email_set_is_draft (ConversationEmail* self,
                                 gboolean value)
{
	gboolean old_value;
#line 191 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 191 "../src/client/conversation-viewer/conversation-email.vala"
	old_value = conversation_email_get_is_draft (self);
#line 191 "../src/client/conversation-viewer/conversation-email.vala"
	if (old_value != value) {
#line 191 "../src/client/conversation-viewer/conversation-email.vala"
		self->priv->_is_draft = value;
#line 191 "../src/client/conversation-viewer/conversation-email.vala"
		g_object_notify_by_pspec ((GObject *) self, conversation_email_properties[CONVERSATION_EMAIL_IS_DRAFT_PROPERTY]);
#line 1079 "conversation-email.c"
	}
}

ConversationMessage*
conversation_email_get_primary_message (ConversationEmail* self)
{
	ConversationMessage* result;
	ConversationMessage* _tmp0_;
#line 194 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_val_if_fail (IS_CONVERSATION_EMAIL (self), NULL);
#line 194 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = self->priv->_primary_message;
#line 194 "../src/client/conversation-viewer/conversation-email.vala"
	result = _tmp0_;
#line 194 "../src/client/conversation-viewer/conversation-email.vala"
	return result;
#line 1096 "conversation-email.c"
}

static void
conversation_email_set_primary_message (ConversationEmail* self,
                                        ConversationMessage* value)
{
	ConversationMessage* old_value;
#line 194 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 194 "../src/client/conversation-viewer/conversation-email.vala"
	old_value = conversation_email_get_primary_message (self);
#line 194 "../src/client/conversation-viewer/conversation-email.vala"
	if (old_value != value) {
#line 1110 "conversation-email.c"
		ConversationMessage* _tmp0_;
#line 194 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 194 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (self->priv->_primary_message);
#line 194 "../src/client/conversation-viewer/conversation-email.vala"
		self->priv->_primary_message = _tmp0_;
#line 194 "../src/client/conversation-viewer/conversation-email.vala"
		g_object_notify_by_pspec ((GObject *) self, conversation_email_properties[CONVERSATION_EMAIL_PRIMARY_MESSAGE_PROPERTY]);
#line 1120 "conversation-email.c"
	}
}

ComponentsAttachmentPane*
conversation_email_get_attachments_pane (ConversationEmail* self)
{
	ComponentsAttachmentPane* result;
	ComponentsAttachmentPane* _tmp0_;
#line 197 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_val_if_fail (IS_CONVERSATION_EMAIL (self), NULL);
#line 197 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = self->priv->_attachments_pane;
#line 197 "../src/client/conversation-viewer/conversation-email.vala"
	result = _tmp0_;
#line 197 "../src/client/conversation-viewer/conversation-email.vala"
	return result;
#line 1137 "conversation-email.c"
}

static void
conversation_email_set_attachments_pane (ConversationEmail* self,
                                         ComponentsAttachmentPane* value)
{
	ComponentsAttachmentPane* old_value;
#line 197 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 197 "../src/client/conversation-viewer/conversation-email.vala"
	old_value = conversation_email_get_attachments_pane (self);
#line 197 "../src/client/conversation-viewer/conversation-email.vala"
	if (old_value != value) {
#line 1151 "conversation-email.c"
		ComponentsAttachmentPane* _tmp0_;
#line 197 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 197 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (self->priv->_attachments_pane);
#line 197 "../src/client/conversation-viewer/conversation-email.vala"
		self->priv->_attachments_pane = _tmp0_;
#line 197 "../src/client/conversation-viewer/conversation-email.vala"
		g_object_notify_by_pspec ((GObject *) self, conversation_email_properties[CONVERSATION_EMAIL_ATTACHMENTS_PANE_PROPERTY]);
#line 1161 "conversation-email.c"
	}
}

GeeList*
conversation_email_get_attached_messages (ConversationEmail* self)
{
	GeeList* result;
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
#line 202 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_val_if_fail (IS_CONVERSATION_EMAIL (self), NULL);
#line 202 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = self->priv->_attached_messages;
#line 202 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp1_ = gee_list_get_read_only_view (_tmp0_);
#line 202 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp2_ = _tmp1_;
#line 202 "../src/client/conversation-viewer/conversation-email.vala"
	result = _tmp2_;
#line 202 "../src/client/conversation-viewer/conversation-email.vala"
	return result;
#line 1184 "conversation-email.c"
}

ConversationEmailLoadState
conversation_email_get_message_body_state (ConversationEmail* self)
{
	ConversationEmailLoadState result;
#line 208 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_val_if_fail (IS_CONVERSATION_EMAIL (self), 0);
#line 208 "../src/client/conversation-viewer/conversation-email.vala"
	result = self->priv->_message_body_state;
#line 208 "../src/client/conversation-viewer/conversation-email.vala"
	return result;
#line 1197 "conversation-email.c"
}

static void
conversation_email_set_message_body_state (ConversationEmail* self,
                                           ConversationEmailLoadState value)
{
	ConversationEmailLoadState old_value;
#line 208 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 208 "../src/client/conversation-viewer/conversation-email.vala"
	old_value = conversation_email_get_message_body_state (self);
#line 208 "../src/client/conversation-viewer/conversation-email.vala"
	if (old_value != value) {
#line 208 "../src/client/conversation-viewer/conversation-email.vala"
		self->priv->_message_body_state = value;
#line 208 "../src/client/conversation-viewer/conversation-email.vala"
		g_object_notify_by_pspec ((GObject *) self, conversation_email_properties[CONVERSATION_EMAIL_MESSAGE_BODY_STATE_PROPERTY]);
#line 1215 "conversation-email.c"
	}
}

/**
     * Constructs a new view to display an email.
     *
     * This method sets up most of the user interface for displaying
     * the complete email, but does not attempt any possibly
     * long-running loading processes.
     */
static void
_conversation_email_on_service_status_change_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self)
{
#line 303 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_on_service_status_change ((ConversationEmail*) self);
#line 1233 "conversation-email.c"
}

static void
_conversation_email_on_load_cancelled_g_cancellable_cancelled (GCancellable* _sender,
                                                               gpointer self)
{
#line 307 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_on_load_cancelled ((ConversationEmail*) self);
#line 1242 "conversation-email.c"
}

static void
_conversation_email_on_body_loading_timeout_geary_timeout_manager_timeout_func (GearyTimeoutManager* manager,
                                                                                gpointer self)
{
#line 309 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_on_body_loading_timeout ((ConversationEmail*) self);
#line 1251 "conversation-email.c"
}

ConversationEmail*
conversation_email_construct (GType object_type,
                              GearyAppConversation* conversation,
                              GearyEmail* email,
                              GearyAppEmailStore* email_store,
                              ApplicationContactStore* contacts,
                              ApplicationConfiguration* config,
                              gboolean is_sent,
                              gboolean is_draft,
                              GCancellable* load_cancellable)
{
	ConversationEmail * self = NULL;
	GearyAppConversation* _tmp0_;
	GearyAppEmailStore* _tmp1_;
	ApplicationContactStore* _tmp2_;
	ApplicationConfiguration* _tmp3_;
	GCancellable* _tmp4_;
	GearyNonblockingSpinlock* _tmp5_;
	ApplicationContactStore* _tmp7_;
	ApplicationConfiguration* _tmp8_;
	ConversationMessage* _tmp9_;
	ConversationMessage* _tmp10_;
	ConversationMessage* _tmp11_;
	GtkGrid* _tmp12_;
	GtkGrid* _tmp13_;
	GtkGrid* _tmp14_;
	ConversationMessage* _tmp15_;
	GearyAccount* _tmp16_;
	GearyAccount* _tmp17_;
	GearyClientService* _tmp18_;
	GearyClientService* _tmp19_;
	GCancellable* _tmp20_;
	GearyTimeoutManager* _tmp21_;
	ConversationMessage* _tmp22_;
#line 267 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (conversation, GEARY_APP_TYPE_CONVERSATION), NULL);
#line 267 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (email, GEARY_TYPE_EMAIL), NULL);
#line 267 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (email_store, GEARY_APP_TYPE_EMAIL_STORE), NULL);
#line 267 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_val_if_fail (APPLICATION_IS_CONTACT_STORE (contacts), NULL);
#line 267 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (config), NULL);
#line 267 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (load_cancellable, g_cancellable_get_type ()), NULL);
#line 267 "../src/client/conversation-viewer/conversation-email.vala"
	self = (ConversationEmail*) g_object_new (object_type, NULL);
#line 275 "../src/client/conversation-viewer/conversation-email.vala"
	geary_base_interface_base_ref (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_BASE_INTERFACE, GearyBaseInterface));
#line 276 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = _g_object_ref0 (conversation);
#line 276 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->conversation);
#line 276 "../src/client/conversation-viewer/conversation-email.vala"
	self->conversation = _tmp0_;
#line 277 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_set_email (self, email);
#line 278 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_set_is_draft (self, is_draft);
#line 279 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp1_ = _g_object_ref0 (email_store);
#line 279 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->priv->email_store);
#line 279 "../src/client/conversation-viewer/conversation-email.vala"
	self->priv->email_store = _tmp1_;
#line 280 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp2_ = _g_object_ref0 (contacts);
#line 280 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->priv->contacts);
#line 280 "../src/client/conversation-viewer/conversation-email.vala"
	self->priv->contacts = _tmp2_;
#line 281 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp3_ = _g_object_ref0 (config);
#line 281 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->priv->config);
#line 281 "../src/client/conversation-viewer/conversation-email.vala"
	self->priv->config = _tmp3_;
#line 282 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp4_ = _g_object_ref0 (load_cancellable);
#line 282 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->priv->load_cancellable);
#line 282 "../src/client/conversation-viewer/conversation-email.vala"
	self->priv->load_cancellable = _tmp4_;
#line 283 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp5_ = geary_nonblocking_spinlock_new (load_cancellable);
#line 283 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->priv->message_bodies_loaded_lock);
#line 283 "../src/client/conversation-viewer/conversation-email.vala"
	self->priv->message_bodies_loaded_lock = _tmp5_;
#line 286 "../src/client/conversation-viewer/conversation-email.vala"
	if (is_sent) {
#line 1346 "conversation-email.c"
		GtkStyleContext* _tmp6_;
#line 287 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp6_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 287 "../src/client/conversation-viewer/conversation-email.vala"
		gtk_style_context_add_class (_tmp6_, CONVERSATION_EMAIL_SENT_CLASS);
#line 1352 "conversation-email.c"
	}
#line 292 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp7_ = self->priv->contacts;
#line 292 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp8_ = self->priv->config;
#line 292 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp9_ = conversation_message_new_from_email (email, geary_trillian_is_certain (geary_email_load_remote_images (email)), _tmp7_, _tmp8_);
#line 292 "../src/client/conversation-viewer/conversation-email.vala"
	g_object_ref_sink (_tmp9_);
#line 292 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp10_ = _tmp9_;
#line 292 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_set_primary_message (self, _tmp10_);
#line 292 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (_tmp10_);
#line 298 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp11_ = self->priv->_primary_message;
#line 298 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp12_ = conversation_message_get_summary (_tmp11_);
#line 298 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp13_ = _tmp12_;
#line 298 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp14_ = self->priv->actions;
#line 298 "../src/client/conversation-viewer/conversation-email.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_widget_get_type (), GtkWidget));
#line 299 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp15_ = self->priv->_primary_message;
#line 299 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_connect_message_view_signals (self, _tmp15_);
#line 303 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp16_ = geary_app_email_store_get_account (email_store);
#line 303 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp17_ = _tmp16_;
#line 303 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp18_ = geary_account_get_incoming (_tmp17_);
#line 303 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp19_ = _tmp18_;
#line 303 "../src/client/conversation-viewer/conversation-email.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, G_TYPE_OBJECT, GObject), "notify::current-status", (GCallback) _conversation_email_on_service_status_change_g_object_notify, self, 0);
#line 307 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp20_ = self->priv->load_cancellable;
#line 307 "../src/client/conversation-viewer/conversation-email.vala"
	g_signal_connect_object (_tmp20_, "cancelled", (GCallback) _conversation_email_on_load_cancelled_g_cancellable_cancelled, self, 0);
#line 309 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp21_ = geary_timeout_manager_new_milliseconds ((guint) CONVERSATION_EMAIL_BODY_LOAD_TIMEOUT_MSEC, _conversation_email_on_body_loading_timeout_geary_timeout_manager_timeout_func, self);
#line 309 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->priv->body_loading_timeout);
#line 309 "../src/client/conversation-viewer/conversation-email.vala"
	self->priv->body_loading_timeout = _tmp21_;
#line 313 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp22_ = self->priv->_primary_message;
#line 313 "../src/client/conversation-viewer/conversation-email.vala"
	gtk_box_pack_start (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_box_get_type (), GtkBox), G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, gtk_widget_get_type (), GtkWidget), TRUE, TRUE, (guint) 0);
#line 314 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_update_email_state (self);
#line 267 "../src/client/conversation-viewer/conversation-email.vala"
	return self;
#line 1410 "conversation-email.c"
}

ConversationEmail*
conversation_email_new (GearyAppConversation* conversation,
                        GearyEmail* email,
                        GearyAppEmailStore* email_store,
                        ApplicationContactStore* contacts,
                        ApplicationConfiguration* config,
                        gboolean is_sent,
                        gboolean is_draft,
                        GCancellable* load_cancellable)
{
#line 267 "../src/client/conversation-viewer/conversation-email.vala"
	return conversation_email_construct (TYPE_CONVERSATION_EMAIL, conversation, email, email_store, contacts, config, is_sent, is_draft, load_cancellable);
#line 1425 "conversation-email.c"
}

static void
conversation_email_load_contacts_data_free (gpointer _data)
{
	ConversationEmailLoadContactsData* _data_;
	_data_ = _data;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (_data_->self);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_slice_free (ConversationEmailLoadContactsData, _data_);
#line 1437 "conversation-email.c"
}

void
conversation_email_load_contacts (ConversationEmail* self,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	ConversationEmailLoadContactsData* _data_;
	ConversationEmail* _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_ = g_slice_new0 (ConversationEmailLoadContactsData);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_task_set_task_data (_data_->_async_result, _data_, conversation_email_load_contacts_data_free);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->self = _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_load_contacts_co (_data_);
#line 1461 "conversation-email.c"
}

void
conversation_email_load_contacts_finish (ConversationEmail* self,
                                         GAsyncResult* _res_,
                                         GError** error)
{
	ConversationEmailLoadContactsData* _data_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	if (NULL == _data_) {
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		return;
#line 1476 "conversation-email.c"
	}
}

/**
     * Loads the contacts for the primary message.
     */
static void
conversation_email_load_contacts_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_)
{
	ConversationEmailLoadContactsData* _data_;
#line 327 "../src/client/conversation-viewer/conversation-email.vala"
	_data_ = _user_data_;
#line 327 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_source_object_ = source_object;
#line 327 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_res_ = _res_;
#line 327 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_load_contacts_co (_data_);
#line 1497 "conversation-email.c"
}

static gboolean
conversation_email_load_contacts_co (ConversationEmailLoadContactsData* _data_)
{
#line 324 "../src/client/conversation-viewer/conversation-email.vala"
	switch (_data_->_state_) {
#line 324 "../src/client/conversation-viewer/conversation-email.vala"
		case 0:
#line 1507 "conversation-email.c"
		goto _state_0;
#line 324 "../src/client/conversation-viewer/conversation-email.vala"
		case 1:
#line 1511 "conversation-email.c"
		goto _state_1;
		default:
#line 324 "../src/client/conversation-viewer/conversation-email.vala"
		g_assert_not_reached ();
#line 1516 "conversation-email.c"
	}
	_state_0:
	{
#line 327 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp0_ = _data_->self->priv->_primary_message;
#line 327 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp1_ = _data_->self->priv->load_cancellable;
#line 327 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_state_ = 1;
#line 327 "../src/client/conversation-viewer/conversation-email.vala"
		conversation_message_load_contacts (_data_->_tmp0_, _data_->_tmp1_, conversation_email_load_contacts_ready, _data_);
#line 327 "../src/client/conversation-viewer/conversation-email.vala"
		return FALSE;
#line 1530 "conversation-email.c"
		_state_1:
#line 327 "../src/client/conversation-viewer/conversation-email.vala"
		conversation_message_load_contacts_finish (_data_->_tmp0_, _data_->_res_, &_data_->_inner_error0_);
#line 327 "../src/client/conversation-viewer/conversation-email.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 327 "../src/client/conversation-viewer/conversation-email.vala"
			if (g_error_matches (_data_->_inner_error0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 1538 "conversation-email.c"
				goto __catch0_g_io_error_cancelled;
			}
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_io_error_cancelled:
	{
#line 326 "../src/client/conversation-viewer/conversation-email.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 1549 "conversation-email.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 326 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->err = _data_->_inner_error0_;
#line 326 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_inner_error0_ = NULL;
#line 331 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp2_ = _data_->self->priv->_primary_message;
#line 331 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp3_ = conversation_message_get_primary_originator (_data_->_tmp2_);
#line 331 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 331 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp5_ = _g_object_ref0 (_data_->_tmp4_);
#line 331 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->from = _data_->_tmp5_;
#line 334 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp7_ = _data_->from;
#line 334 "../src/client/conversation-viewer/conversation-email.vala"
		if (_data_->_tmp7_ != NULL) {
#line 334 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp8_ = _data_->from;
#line 334 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp9_ = geary_message_data_abstract_message_data_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp8_, GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA, GearyMessageDataAbstractMessageData));
#line 334 "../src/client/conversation-viewer/conversation-email.vala"
			_g_free0 (_data_->_tmp6_);
#line 334 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp6_ = _data_->_tmp9_;
#line 1580 "conversation-email.c"
		} else {
#line 334 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp10_ = g_strdup ("<unknown>");
#line 334 "../src/client/conversation-viewer/conversation-email.vala"
			_g_free0 (_data_->_tmp6_);
#line 334 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp6_ = _data_->_tmp10_;
#line 1588 "conversation-email.c"
		}
#line 333 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp11_ = _data_->err;
#line 333 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp12_ = _data_->_tmp11_->message;
#line 333 "../src/client/conversation-viewer/conversation-email.vala"
		g_debug ("conversation-email.vala:333: Contact load failed for \"%s\": %s", _data_->_tmp6_, _data_->_tmp12_);
#line 326 "../src/client/conversation-viewer/conversation-email.vala"
		_g_free0 (_data_->_tmp6_);
#line 326 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (_data_->from);
#line 326 "../src/client/conversation-viewer/conversation-email.vala"
		_g_error_free0 (_data_->err);
#line 1602 "conversation-email.c"
	}
	__finally0:
#line 326 "../src/client/conversation-viewer/conversation-email.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 326 "../src/client/conversation-viewer/conversation-email.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 326 "../src/client/conversation-viewer/conversation-email.vala"
		g_object_unref (_data_->_async_result);
#line 326 "../src/client/conversation-viewer/conversation-email.vala"
		return FALSE;
#line 1613 "conversation-email.c"
	}
#line 336 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp13_ = _data_->self->priv->load_cancellable;
#line 336 "../src/client/conversation-viewer/conversation-email.vala"
	if (g_cancellable_is_cancelled (_data_->_tmp13_)) {
#line 337 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp14_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_CANCELLED, "Contact load was cancelled");
#line 337 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_inner_error0_ = _data_->_tmp14_;
#line 337 "../src/client/conversation-viewer/conversation-email.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 337 "../src/client/conversation-viewer/conversation-email.vala"
		g_object_unref (_data_->_async_result);
#line 337 "../src/client/conversation-viewer/conversation-email.vala"
		return FALSE;
#line 1629 "conversation-email.c"
	}
#line 324 "../src/client/conversation-viewer/conversation-email.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 324 "../src/client/conversation-viewer/conversation-email.vala"
	if (_data_->_state_ != 0) {
#line 324 "../src/client/conversation-viewer/conversation-email.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 324 "../src/client/conversation-viewer/conversation-email.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1639 "conversation-email.c"
		}
	}
#line 324 "../src/client/conversation-viewer/conversation-email.vala"
	g_object_unref (_data_->_async_result);
#line 324 "../src/client/conversation-viewer/conversation-email.vala"
	return FALSE;
#line 1646 "conversation-email.c"
}

static void
conversation_email_load_body_data_free (gpointer _data)
{
	ConversationEmailLoadBodyData* _data_;
	_data_ = _data;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (_data_->self);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_slice_free (ConversationEmailLoadBodyData, _data_);
#line 1658 "conversation-email.c"
}

void
conversation_email_load_body (ConversationEmail* self,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	ConversationEmailLoadBodyData* _data_;
	ConversationEmail* _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_ = g_slice_new0 (ConversationEmailLoadBodyData);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_task_set_task_data (_data_->_async_result, _data_, conversation_email_load_body_data_free);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->self = _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_load_body_co (_data_);
#line 1682 "conversation-email.c"
}

void
conversation_email_load_body_finish (ConversationEmail* self,
                                     GAsyncResult* _res_,
                                     GError** error)
{
	ConversationEmailLoadBodyData* _data_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	if (NULL == _data_) {
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		return;
#line 1697 "conversation-email.c"
	}
}

/**
     * Loads the message body and attachments.
     *
     * This potentially hits the database if the email that the view
     * was constructed from doesn't satisfy requirements, loads
     * attachments, including views and avatars for any attached
     * messages, and waits for the primary message body content to
     * have been loaded by its web view before returning.
     */
static void
conversation_email_load_body_ready (GObject* source_object,
                                    GAsyncResult* _res_,
                                    gpointer _user_data_)
{
	ConversationEmailLoadBodyData* _data_;
#line 360 "../src/client/conversation-viewer/conversation-email.vala"
	_data_ = _user_data_;
#line 360 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_source_object_ = source_object;
#line 360 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_res_ = _res_;
#line 360 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_load_body_co (_data_);
#line 1724 "conversation-email.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 376 "../src/client/conversation-viewer/conversation-email.vala"
	return self ? g_error_copy (self) : NULL;
#line 1732 "conversation-email.c"
}

static gboolean
conversation_email_load_body_co (ConversationEmailLoadBodyData* _data_)
{
#line 350 "../src/client/conversation-viewer/conversation-email.vala"
	switch (_data_->_state_) {
#line 350 "../src/client/conversation-viewer/conversation-email.vala"
		case 0:
#line 1742 "conversation-email.c"
		goto _state_0;
#line 350 "../src/client/conversation-viewer/conversation-email.vala"
		case 1:
#line 1746 "conversation-email.c"
		goto _state_1;
#line 350 "../src/client/conversation-viewer/conversation-email.vala"
		case 2:
#line 1750 "conversation-email.c"
		goto _state_2;
#line 350 "../src/client/conversation-viewer/conversation-email.vala"
		case 3:
#line 1754 "conversation-email.c"
		goto _state_3;
		default:
#line 350 "../src/client/conversation-viewer/conversation-email.vala"
		g_assert_not_reached ();
#line 1759 "conversation-email.c"
	}
	_state_0:
#line 352 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_set_message_body_state (_data_->self, CONVERSATION_EMAIL_LOAD_STATE_STARTED);
#line 356 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp0_ = _data_->self->priv->_email;
#line 356 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp1_ = geary_email_get_fields (_data_->_tmp0_);
#line 356 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 356 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->loaded = geary_email_field_fulfills (_data_->_tmp2_, CONVERSATION_EMAIL_REQUIRED_FOR_LOAD);
#line 357 "../src/client/conversation-viewer/conversation-email.vala"
	if (!_data_->loaded) {
#line 358 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp3_ = _data_->self->priv->body_loading_timeout;
#line 358 "../src/client/conversation-viewer/conversation-email.vala"
		geary_timeout_manager_start (_data_->_tmp3_);
#line 1778 "conversation-email.c"
		{
#line 360 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp5_ = _data_->self->priv->email_store;
#line 360 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp6_ = _data_->self->priv->_email;
#line 360 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp7_ = geary_email_get_id (_data_->_tmp6_);
#line 360 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp8_ = _data_->_tmp7_;
#line 360 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp9_ = _data_->self->priv->load_cancellable;
#line 360 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_state_ = 1;
#line 360 "../src/client/conversation-viewer/conversation-email.vala"
			geary_app_email_store_fetch_email_async (_data_->_tmp5_, _data_->_tmp8_, CONVERSATION_EMAIL_REQUIRED_FOR_LOAD, GEARY_FOLDER_LIST_FLAGS_LOCAL_ONLY, _data_->_tmp9_, conversation_email_load_body_ready, _data_);
#line 360 "../src/client/conversation-viewer/conversation-email.vala"
			return FALSE;
#line 1796 "conversation-email.c"
			_state_1:
#line 360 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp10_ = geary_app_email_store_fetch_email_finish (_data_->_tmp5_, _data_->_res_, &_data_->_inner_error0_);
#line 360 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp4_ = _data_->_tmp10_;
#line 360 "../src/client/conversation-viewer/conversation-email.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 360 "../src/client/conversation-viewer/conversation-email.vala"
				if (g_error_matches (_data_->_inner_error0_, GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_INCOMPLETE_MESSAGE)) {
#line 1806 "conversation-email.c"
					goto __catch0_geary_engine_error_incomplete_message;
				}
#line 360 "../src/client/conversation-viewer/conversation-email.vala"
				if (g_error_matches (_data_->_inner_error0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 1811 "conversation-email.c"
					goto __catch0_g_io_error_cancelled;
				}
				goto __catch0_g_error;
			}
#line 360 "../src/client/conversation-viewer/conversation-email.vala"
			conversation_email_set_email (_data_->self, _data_->_tmp4_);
#line 366 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->loaded = TRUE;
#line 367 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp11_ = _data_->self->priv->body_loading_timeout;
#line 367 "../src/client/conversation-viewer/conversation-email.vala"
			geary_timeout_manager_reset (_data_->_tmp11_);
#line 359 "../src/client/conversation-viewer/conversation-email.vala"
			_g_object_unref0 (_data_->_tmp4_);
#line 1826 "conversation-email.c"
		}
		goto __finally0;
		__catch0_geary_engine_error_incomplete_message:
		{
#line 359 "../src/client/conversation-viewer/conversation-email.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 373 "../src/client/conversation-viewer/conversation-email.vala"
			conversation_email_fetch_remote_body (_data_->self, NULL, NULL);
#line 1835 "conversation-email.c"
		}
		goto __finally0;
		__catch0_g_io_error_cancelled:
		{
#line 359 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->err = _data_->_inner_error0_;
#line 359 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_inner_error0_ = NULL;
#line 375 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp12_ = _data_->self->priv->body_loading_timeout;
#line 375 "../src/client/conversation-viewer/conversation-email.vala"
			geary_timeout_manager_reset (_data_->_tmp12_);
#line 376 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp13_ = _data_->err;
#line 376 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp14_ = _g_error_copy0 (_data_->_tmp13_);
#line 376 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_inner_error0_ = _data_->_tmp14_;
#line 376 "../src/client/conversation-viewer/conversation-email.vala"
			_g_error_free0 (_data_->err);
#line 1856 "conversation-email.c"
			goto __finally0;
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 359 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_vala1_err = _data_->_inner_error0_;
#line 359 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_inner_error0_ = NULL;
#line 378 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp15_ = _data_->self->priv->body_loading_timeout;
#line 378 "../src/client/conversation-viewer/conversation-email.vala"
			geary_timeout_manager_reset (_data_->_tmp15_);
#line 379 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp16_ = _data_->_vala1_err;
#line 379 "../src/client/conversation-viewer/conversation-email.vala"
			conversation_email_handle_load_failure (_data_->self, _data_->_tmp16_);
#line 380 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp17_ = _data_->_vala1_err;
#line 380 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp18_ = _g_error_copy0 (_data_->_tmp17_);
#line 380 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_inner_error0_ = _data_->_tmp18_;
#line 380 "../src/client/conversation-viewer/conversation-email.vala"
			_g_error_free0 (_data_->_vala1_err);
#line 1882 "conversation-email.c"
			goto __finally0;
		}
		__finally0:
#line 359 "../src/client/conversation-viewer/conversation-email.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 359 "../src/client/conversation-viewer/conversation-email.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 359 "../src/client/conversation-viewer/conversation-email.vala"
			g_object_unref (_data_->_async_result);
#line 359 "../src/client/conversation-viewer/conversation-email.vala"
			return FALSE;
#line 1894 "conversation-email.c"
		}
	}
#line 384 "../src/client/conversation-viewer/conversation-email.vala"
	if (_data_->loaded) {
#line 1899 "conversation-email.c"
		{
#line 386 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_state_ = 2;
#line 386 "../src/client/conversation-viewer/conversation-email.vala"
			conversation_email_update_body (_data_->self, conversation_email_load_body_ready, _data_);
#line 386 "../src/client/conversation-viewer/conversation-email.vala"
			return FALSE;
#line 1907 "conversation-email.c"
			_state_2:
#line 386 "../src/client/conversation-viewer/conversation-email.vala"
			conversation_email_update_body_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 386 "../src/client/conversation-viewer/conversation-email.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 386 "../src/client/conversation-viewer/conversation-email.vala"
				if (g_error_matches (_data_->_inner_error0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 1915 "conversation-email.c"
					goto __catch1_g_io_error_cancelled;
				}
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_io_error_cancelled:
		{
#line 385 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_vala2_err = _data_->_inner_error0_;
#line 385 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_inner_error0_ = NULL;
#line 388 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp19_ = _data_->self->priv->body_loading_timeout;
#line 388 "../src/client/conversation-viewer/conversation-email.vala"
			geary_timeout_manager_reset (_data_->_tmp19_);
#line 389 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp20_ = _data_->_vala2_err;
#line 389 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp21_ = _g_error_copy0 (_data_->_tmp20_);
#line 389 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_inner_error0_ = _data_->_tmp21_;
#line 389 "../src/client/conversation-viewer/conversation-email.vala"
			_g_error_free0 (_data_->_vala2_err);
#line 1940 "conversation-email.c"
			goto __finally1;
		}
		goto __finally1;
		__catch1_g_error:
		{
#line 385 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_vala3_err = _data_->_inner_error0_;
#line 385 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_inner_error0_ = NULL;
#line 391 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp22_ = _data_->self->priv->body_loading_timeout;
#line 391 "../src/client/conversation-viewer/conversation-email.vala"
			geary_timeout_manager_reset (_data_->_tmp22_);
#line 392 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp23_ = _data_->_vala3_err;
#line 392 "../src/client/conversation-viewer/conversation-email.vala"
			conversation_email_handle_load_failure (_data_->self, _data_->_tmp23_);
#line 393 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp24_ = _data_->_vala3_err;
#line 393 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp25_ = _g_error_copy0 (_data_->_tmp24_);
#line 393 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_inner_error0_ = _data_->_tmp25_;
#line 393 "../src/client/conversation-viewer/conversation-email.vala"
			_g_error_free0 (_data_->_vala3_err);
#line 1966 "conversation-email.c"
			goto __finally1;
		}
		__finally1:
#line 385 "../src/client/conversation-viewer/conversation-email.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 385 "../src/client/conversation-viewer/conversation-email.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 385 "../src/client/conversation-viewer/conversation-email.vala"
			g_object_unref (_data_->_async_result);
#line 385 "../src/client/conversation-viewer/conversation-email.vala"
			return FALSE;
#line 1978 "conversation-email.c"
		}
#line 395 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp26_ = _data_->self->priv->message_bodies_loaded_lock;
#line 395 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp27_ = _data_->self->priv->load_cancellable;
#line 395 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_state_ = 3;
#line 395 "../src/client/conversation-viewer/conversation-email.vala"
		geary_nonblocking_lock_wait_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp26_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock), _data_->_tmp27_, conversation_email_load_body_ready, _data_);
#line 395 "../src/client/conversation-viewer/conversation-email.vala"
		return FALSE;
#line 1990 "conversation-email.c"
		_state_3:
#line 395 "../src/client/conversation-viewer/conversation-email.vala"
		geary_nonblocking_lock_wait_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp26_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock), _data_->_res_, &_data_->_inner_error0_);
#line 395 "../src/client/conversation-viewer/conversation-email.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 395 "../src/client/conversation-viewer/conversation-email.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 395 "../src/client/conversation-viewer/conversation-email.vala"
			g_object_unref (_data_->_async_result);
#line 395 "../src/client/conversation-viewer/conversation-email.vala"
			return FALSE;
#line 2002 "conversation-email.c"
		}
	}
#line 350 "../src/client/conversation-viewer/conversation-email.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 350 "../src/client/conversation-viewer/conversation-email.vala"
	if (_data_->_state_ != 0) {
#line 350 "../src/client/conversation-viewer/conversation-email.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 350 "../src/client/conversation-viewer/conversation-email.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2013 "conversation-email.c"
		}
	}
#line 350 "../src/client/conversation-viewer/conversation-email.vala"
	g_object_unref (_data_->_async_result);
#line 350 "../src/client/conversation-viewer/conversation-email.vala"
	return FALSE;
#line 2020 "conversation-email.c"
}

/**
     * Shows the complete message: headers, body and attachments.
     */
void
conversation_email_expand_email (ConversationEmail* self,
                                 gboolean include_transitions)
{
	GtkButton* _tmp0_;
	GtkMenuButton* _tmp1_;
	GMenu* _tmp2_;
	GMenu* _tmp3_;
	GVariant* email_target = NULL;
	GearyEmail* _tmp4_;
	GearyEmailIdentifier* _tmp5_;
	GearyEmailIdentifier* _tmp6_;
	GVariant* _tmp7_;
	GtkButton* _tmp8_;
	GVariant* _tmp9_;
	GtkButton* _tmp10_;
	GVariant* _tmp11_;
	GtkButton* _tmp12_;
	GVariant* _tmp13_;
#line 404 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 405 "../src/client/conversation-viewer/conversation-email.vala"
	self->is_collapsed = FALSE;
#line 406 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_update_email_state (self);
#line 407 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = self->priv->attachments_button;
#line 407 "../src/client/conversation-viewer/conversation-email.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), TRUE);
#line 410 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp1_ = self->priv->email_menubutton;
#line 410 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp2_ = g_menu_new ();
#line 410 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp3_ = _tmp2_;
#line 410 "../src/client/conversation-viewer/conversation-email.vala"
	gtk_menu_button_set_menu_model (_tmp1_, G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_menu_model_get_type (), GMenuModel));
#line 410 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (_tmp3_);
#line 413 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp4_ = self->priv->_email;
#line 413 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp5_ = geary_email_get_id (_tmp4_);
#line 413 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp6_ = _tmp5_;
#line 413 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp7_ = geary_email_identifier_to_variant (_tmp6_);
#line 413 "../src/client/conversation-viewer/conversation-email.vala"
	email_target = _tmp7_;
#line 414 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp8_ = self->priv->attachments_button;
#line 414 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp9_ = email_target;
#line 414 "../src/client/conversation-viewer/conversation-email.vala"
	gtk_actionable_set_action_target_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_actionable_get_type (), GtkActionable), _tmp9_);
#line 415 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp10_ = self->priv->star_button;
#line 415 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp11_ = email_target;
#line 415 "../src/client/conversation-viewer/conversation-email.vala"
	gtk_actionable_set_action_target_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_actionable_get_type (), GtkActionable), _tmp11_);
#line 416 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp12_ = self->priv->unstar_button;
#line 416 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp13_ = email_target;
#line 416 "../src/client/conversation-viewer/conversation-email.vala"
	gtk_actionable_set_action_target_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_actionable_get_type (), GtkActionable), _tmp13_);
#line 2093 "conversation-email.c"
	{
		GeeIterator* _message_it = NULL;
		GeeIterator* _tmp14_;
#line 418 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp14_ = conversation_email_iterator (self);
#line 418 "../src/client/conversation-viewer/conversation-email.vala"
		_message_it = _tmp14_;
#line 418 "../src/client/conversation-viewer/conversation-email.vala"
		while (TRUE) {
#line 2103 "conversation-email.c"
			GeeIterator* _tmp15_;
			ConversationMessage* message = NULL;
			GeeIterator* _tmp16_;
			gpointer _tmp17_;
			ConversationMessage* _tmp18_;
#line 418 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp15_ = _message_it;
#line 418 "../src/client/conversation-viewer/conversation-email.vala"
			if (!gee_iterator_next (_tmp15_)) {
#line 418 "../src/client/conversation-viewer/conversation-email.vala"
				break;
#line 2115 "conversation-email.c"
			}
#line 418 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp16_ = _message_it;
#line 418 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp17_ = gee_iterator_get (_tmp16_);
#line 418 "../src/client/conversation-viewer/conversation-email.vala"
			message = (ConversationMessage*) _tmp17_;
#line 419 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp18_ = message;
#line 419 "../src/client/conversation-viewer/conversation-email.vala"
			conversation_message_show_message_body (_tmp18_, include_transitions);
#line 418 "../src/client/conversation-viewer/conversation-email.vala"
			_g_object_unref0 (message);
#line 2129 "conversation-email.c"
		}
#line 418 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (_message_it);
#line 2133 "conversation-email.c"
	}
#line 404 "../src/client/conversation-viewer/conversation-email.vala"
	_g_variant_unref0 (email_target);
#line 2137 "conversation-email.c"
}

/**
     * Hides the complete message, just showing the header preview.
     */
void
conversation_email_collapse_email (ConversationEmail* self)
{
	GtkButton* _tmp0_;
	GtkMenuButton* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
	GtkButton* _tmp4_;
	ConversationMessage* _tmp5_;
#line 426 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 427 "../src/client/conversation-viewer/conversation-email.vala"
	self->is_collapsed = TRUE;
#line 428 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_update_email_state (self);
#line 429 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = self->priv->attachments_button;
#line 429 "../src/client/conversation-viewer/conversation-email.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 430 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp1_ = self->priv->email_menubutton;
#line 430 "../src/client/conversation-viewer/conversation-email.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 433 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp2_ = self->priv->attachments_button;
#line 433 "../src/client/conversation-viewer/conversation-email.vala"
	gtk_actionable_set_action_target_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_actionable_get_type (), GtkActionable), NULL);
#line 434 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp3_ = self->priv->star_button;
#line 434 "../src/client/conversation-viewer/conversation-email.vala"
	gtk_actionable_set_action_target_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_actionable_get_type (), GtkActionable), NULL);
#line 435 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp4_ = self->priv->unstar_button;
#line 435 "../src/client/conversation-viewer/conversation-email.vala"
	gtk_actionable_set_action_target_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_actionable_get_type (), GtkActionable), NULL);
#line 437 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp5_ = self->priv->_primary_message;
#line 437 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_message_hide_message_body (_tmp5_);
#line 2182 "conversation-email.c"
	{
		GeeList* _attached_list = NULL;
		GeeList* _tmp6_;
		gint _attached_size = 0;
		GeeList* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _attached_index = 0;
#line 438 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp6_ = self->priv->_attached_messages;
#line 438 "../src/client/conversation-viewer/conversation-email.vala"
		_attached_list = _tmp6_;
#line 438 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp7_ = _attached_list;
#line 438 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp8_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection));
#line 438 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp9_ = _tmp8_;
#line 438 "../src/client/conversation-viewer/conversation-email.vala"
		_attached_size = _tmp9_;
#line 438 "../src/client/conversation-viewer/conversation-email.vala"
		_attached_index = -1;
#line 438 "../src/client/conversation-viewer/conversation-email.vala"
		while (TRUE) {
#line 2207 "conversation-email.c"
			gint _tmp10_;
			gint _tmp11_;
			ConversationMessage* attached = NULL;
			GeeList* _tmp12_;
			gpointer _tmp13_;
			ConversationMessage* _tmp14_;
#line 438 "../src/client/conversation-viewer/conversation-email.vala"
			_attached_index = _attached_index + 1;
#line 438 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp10_ = _attached_index;
#line 438 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp11_ = _attached_size;
#line 438 "../src/client/conversation-viewer/conversation-email.vala"
			if (!(_tmp10_ < _tmp11_)) {
#line 438 "../src/client/conversation-viewer/conversation-email.vala"
				break;
#line 2224 "conversation-email.c"
			}
#line 438 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp12_ = _attached_list;
#line 438 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp13_ = gee_list_get (_tmp12_, _attached_index);
#line 438 "../src/client/conversation-viewer/conversation-email.vala"
			attached = (ConversationMessage*) _tmp13_;
#line 439 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp14_ = attached;
#line 439 "../src/client/conversation-viewer/conversation-email.vala"
			conversation_message_hide_message_body (_tmp14_);
#line 438 "../src/client/conversation-viewer/conversation-email.vala"
			_g_object_unref0 (attached);
#line 2238 "conversation-email.c"
		}
	}
}

/**
     * Updates the current email's flags and dependent UI state.
     */
void
conversation_email_update_flags (ConversationEmail* self,
                                 GearyEmail* email)
{
	GearyEmail* _tmp0_;
	GearyEmailFlags* _tmp1_;
	GearyEmailFlags* _tmp2_;
#line 446 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 446 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (email, GEARY_TYPE_EMAIL));
#line 447 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = self->priv->_email;
#line 447 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp1_ = geary_email_get_email_flags (email);
#line 447 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp2_ = _tmp1_;
#line 447 "../src/client/conversation-viewer/conversation-email.vala"
	geary_email_set_flags (_tmp0_, _tmp2_);
#line 448 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_update_email_state (self);
#line 2267 "conversation-email.c"
}

static void
conversation_email_get_selection_for_quoting_data_free (gpointer _data)
{
	ConversationEmailGetSelectionForQuotingData* _data_;
	_data_ = _data;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_g_free0 (_data_->result);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (_data_->self);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_slice_free (ConversationEmailGetSelectionForQuotingData, _data_);
#line 2281 "conversation-email.c"
}

void
conversation_email_get_selection_for_quoting (ConversationEmail* self,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	ConversationEmailGetSelectionForQuotingData* _data_;
	ConversationEmail* _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_ = g_slice_new0 (ConversationEmailGetSelectionForQuotingData);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_task_set_task_data (_data_->_async_result, _data_, conversation_email_get_selection_for_quoting_data_free);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->self = _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_get_selection_for_quoting_co (_data_);
#line 2305 "conversation-email.c"
}

gchar*
conversation_email_get_selection_for_quoting_finish (ConversationEmail* self,
                                                     GAsyncResult* _res_)
{
	gchar* result;
	ConversationEmailGetSelectionForQuotingData* _data_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	result = _data_->result;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->result = NULL;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	return result;
#line 2322 "conversation-email.c"
}

/**
     * Returns user-selected body HTML from a message, if any.
     */
static void
conversation_email_get_selection_for_quoting_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_)
{
	ConversationEmailGetSelectionForQuotingData* _data_;
#line 459 "../src/client/conversation-viewer/conversation-email.vala"
	_data_ = _user_data_;
#line 459 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_source_object_ = source_object;
#line 459 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_res_ = _res_;
#line 459 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_get_selection_for_quoting_co (_data_);
#line 2342 "conversation-email.c"
}

static gboolean
conversation_email_get_selection_for_quoting_co (ConversationEmailGetSelectionForQuotingData* _data_)
{
#line 454 "../src/client/conversation-viewer/conversation-email.vala"
	switch (_data_->_state_) {
#line 454 "../src/client/conversation-viewer/conversation-email.vala"
		case 0:
#line 2352 "conversation-email.c"
		goto _state_0;
#line 454 "../src/client/conversation-viewer/conversation-email.vala"
		case 1:
#line 2356 "conversation-email.c"
		goto _state_1;
		default:
#line 454 "../src/client/conversation-viewer/conversation-email.vala"
		g_assert_not_reached ();
#line 2361 "conversation-email.c"
	}
	_state_0:
#line 455 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->selection = NULL;
#line 456 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp0_ = _data_->self->priv->body_selection_message;
#line 456 "../src/client/conversation-viewer/conversation-email.vala"
	if (_data_->_tmp0_ != NULL) {
#line 2370 "conversation-email.c"
		{
#line 459 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp2_ = _data_->self->priv->body_selection_message;
#line 459 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_state_ = 1;
#line 459 "../src/client/conversation-viewer/conversation-email.vala"
			conversation_message_get_selection_for_quoting (_data_->_tmp2_, conversation_email_get_selection_for_quoting_ready, _data_);
#line 459 "../src/client/conversation-viewer/conversation-email.vala"
			return FALSE;
#line 2380 "conversation-email.c"
			_state_1:
#line 459 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp3_ = conversation_message_get_selection_for_quoting_finish (_data_->_tmp2_, _data_->_res_, &_data_->_inner_error0_);
#line 459 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp1_ = _data_->_tmp3_;
#line 459 "../src/client/conversation-viewer/conversation-email.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2388 "conversation-email.c"
				goto __catch0_g_error;
			}
#line 458 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp4_ = _data_->_tmp1_;
#line 458 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp1_ = NULL;
#line 458 "../src/client/conversation-viewer/conversation-email.vala"
			_g_free0 (_data_->selection);
#line 458 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->selection = _data_->_tmp4_;
#line 457 "../src/client/conversation-viewer/conversation-email.vala"
			_g_free0 (_data_->_tmp1_);
#line 2401 "conversation-email.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 457 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->err = _data_->_inner_error0_;
#line 457 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_inner_error0_ = NULL;
#line 461 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp5_ = _data_->err;
#line 461 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp6_ = _data_->_tmp5_->message;
#line 461 "../src/client/conversation-viewer/conversation-email.vala"
			g_debug ("conversation-email.vala:461: Failed to get selection for quoting: %s", _data_->_tmp6_);
#line 457 "../src/client/conversation-viewer/conversation-email.vala"
			_g_error_free0 (_data_->err);
#line 2418 "conversation-email.c"
		}
		__finally0:
#line 457 "../src/client/conversation-viewer/conversation-email.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 457 "../src/client/conversation-viewer/conversation-email.vala"
			_g_free0 (_data_->selection);
#line 457 "../src/client/conversation-viewer/conversation-email.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 457 "../src/client/conversation-viewer/conversation-email.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 457 "../src/client/conversation-viewer/conversation-email.vala"
			g_object_unref (_data_->_async_result);
#line 457 "../src/client/conversation-viewer/conversation-email.vala"
			return FALSE;
#line 2433 "conversation-email.c"
		}
	}
#line 464 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->result = _data_->selection;
#line 464 "../src/client/conversation-viewer/conversation-email.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 464 "../src/client/conversation-viewer/conversation-email.vala"
	if (_data_->_state_ != 0) {
#line 464 "../src/client/conversation-viewer/conversation-email.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 464 "../src/client/conversation-viewer/conversation-email.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2446 "conversation-email.c"
		}
	}
#line 464 "../src/client/conversation-viewer/conversation-email.vala"
	g_object_unref (_data_->_async_result);
#line 464 "../src/client/conversation-viewer/conversation-email.vala"
	return FALSE;
#line 2453 "conversation-email.c"
}

static void
conversation_email_get_selection_for_find_data_free (gpointer _data)
{
	ConversationEmailGetSelectionForFindData* _data_;
	_data_ = _data;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_g_free0 (_data_->result);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (_data_->self);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_slice_free (ConversationEmailGetSelectionForFindData, _data_);
#line 2467 "conversation-email.c"
}

void
conversation_email_get_selection_for_find (ConversationEmail* self,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	ConversationEmailGetSelectionForFindData* _data_;
	ConversationEmail* _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_ = g_slice_new0 (ConversationEmailGetSelectionForFindData);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_task_set_task_data (_data_->_async_result, _data_, conversation_email_get_selection_for_find_data_free);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->self = _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_get_selection_for_find_co (_data_);
#line 2491 "conversation-email.c"
}

gchar*
conversation_email_get_selection_for_find_finish (ConversationEmail* self,
                                                  GAsyncResult* _res_)
{
	gchar* result;
	ConversationEmailGetSelectionForFindData* _data_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	result = _data_->result;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->result = NULL;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	return result;
#line 2508 "conversation-email.c"
}

/**
     * Returns user-selected body text from a message, if any.
     */
static void
conversation_email_get_selection_for_find_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	ConversationEmailGetSelectionForFindData* _data_;
#line 475 "../src/client/conversation-viewer/conversation-email.vala"
	_data_ = _user_data_;
#line 475 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_source_object_ = source_object;
#line 475 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_res_ = _res_;
#line 475 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_get_selection_for_find_co (_data_);
#line 2528 "conversation-email.c"
}

static gboolean
conversation_email_get_selection_for_find_co (ConversationEmailGetSelectionForFindData* _data_)
{
#line 470 "../src/client/conversation-viewer/conversation-email.vala"
	switch (_data_->_state_) {
#line 470 "../src/client/conversation-viewer/conversation-email.vala"
		case 0:
#line 2538 "conversation-email.c"
		goto _state_0;
#line 470 "../src/client/conversation-viewer/conversation-email.vala"
		case 1:
#line 2542 "conversation-email.c"
		goto _state_1;
		default:
#line 470 "../src/client/conversation-viewer/conversation-email.vala"
		g_assert_not_reached ();
#line 2547 "conversation-email.c"
	}
	_state_0:
#line 471 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->selection = NULL;
#line 472 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp0_ = _data_->self->priv->body_selection_message;
#line 472 "../src/client/conversation-viewer/conversation-email.vala"
	if (_data_->_tmp0_ != NULL) {
#line 2556 "conversation-email.c"
		{
#line 475 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp2_ = _data_->self->priv->body_selection_message;
#line 475 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_state_ = 1;
#line 475 "../src/client/conversation-viewer/conversation-email.vala"
			conversation_message_get_selection_for_find (_data_->_tmp2_, conversation_email_get_selection_for_find_ready, _data_);
#line 475 "../src/client/conversation-viewer/conversation-email.vala"
			return FALSE;
#line 2566 "conversation-email.c"
			_state_1:
#line 475 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp3_ = conversation_message_get_selection_for_find_finish (_data_->_tmp2_, _data_->_res_, &_data_->_inner_error0_);
#line 475 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp1_ = _data_->_tmp3_;
#line 475 "../src/client/conversation-viewer/conversation-email.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2574 "conversation-email.c"
				goto __catch0_g_error;
			}
#line 474 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp4_ = _data_->_tmp1_;
#line 474 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp1_ = NULL;
#line 474 "../src/client/conversation-viewer/conversation-email.vala"
			_g_free0 (_data_->selection);
#line 474 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->selection = _data_->_tmp4_;
#line 473 "../src/client/conversation-viewer/conversation-email.vala"
			_g_free0 (_data_->_tmp1_);
#line 2587 "conversation-email.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 473 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->err = _data_->_inner_error0_;
#line 473 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_inner_error0_ = NULL;
#line 477 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp5_ = _data_->err;
#line 477 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp6_ = _data_->_tmp5_->message;
#line 477 "../src/client/conversation-viewer/conversation-email.vala"
			g_debug ("conversation-email.vala:477: Failed to get selection for find: %s", _data_->_tmp6_);
#line 473 "../src/client/conversation-viewer/conversation-email.vala"
			_g_error_free0 (_data_->err);
#line 2604 "conversation-email.c"
		}
		__finally0:
#line 473 "../src/client/conversation-viewer/conversation-email.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 473 "../src/client/conversation-viewer/conversation-email.vala"
			_g_free0 (_data_->selection);
#line 473 "../src/client/conversation-viewer/conversation-email.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 473 "../src/client/conversation-viewer/conversation-email.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 473 "../src/client/conversation-viewer/conversation-email.vala"
			g_object_unref (_data_->_async_result);
#line 473 "../src/client/conversation-viewer/conversation-email.vala"
			return FALSE;
#line 2619 "conversation-email.c"
		}
	}
#line 480 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->result = _data_->selection;
#line 480 "../src/client/conversation-viewer/conversation-email.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 480 "../src/client/conversation-viewer/conversation-email.vala"
	if (_data_->_state_ != 0) {
#line 480 "../src/client/conversation-viewer/conversation-email.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 480 "../src/client/conversation-viewer/conversation-email.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2632 "conversation-email.c"
		}
	}
#line 480 "../src/client/conversation-viewer/conversation-email.vala"
	g_object_unref (_data_->_async_result);
#line 480 "../src/client/conversation-viewer/conversation-email.vala"
	return FALSE;
#line 2639 "conversation-email.c"
}

static void
conversation_email_view_source_data_free (gpointer _data)
{
	ConversationEmailViewSourceData* _data_;
	_data_ = _data;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (_data_->self);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_slice_free (ConversationEmailViewSourceData, _data_);
#line 2651 "conversation-email.c"
}

void
conversation_email_view_source (ConversationEmail* self,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
	ConversationEmailViewSourceData* _data_;
	ConversationEmail* _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_ = g_slice_new0 (ConversationEmailViewSourceData);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_task_set_task_data (_data_->_async_result, _data_, conversation_email_view_source_data_free);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->self = _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_view_source_co (_data_);
#line 2675 "conversation-email.c"
}

void
conversation_email_view_source_finish (ConversationEmail* self,
                                       GAsyncResult* _res_)
{
	ConversationEmailViewSourceData* _data_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2685 "conversation-email.c"
}

/** Displays the raw RFC 822 source for this email. */
static Block84Data*
block84_data_ref (Block84Data* _data84_)
{
#line 484 "../src/client/conversation-viewer/conversation-email.vala"
	g_atomic_int_inc (&_data84_->_ref_count_);
#line 484 "../src/client/conversation-viewer/conversation-email.vala"
	return _data84_;
#line 2696 "conversation-email.c"
}

static void
block84_data_unref (void * _userdata_)
{
	Block84Data* _data84_;
	_data84_ = (Block84Data*) _userdata_;
#line 484 "../src/client/conversation-viewer/conversation-email.vala"
	if (g_atomic_int_dec_and_test (&_data84_->_ref_count_)) {
#line 2706 "conversation-email.c"
		ConversationEmail* self;
#line 484 "../src/client/conversation-viewer/conversation-email.vala"
		self = _data84_->self;
#line 484 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (_data84_->main);
#line 484 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (self);
#line 484 "../src/client/conversation-viewer/conversation-email.vala"
		g_slice_free (Block84Data, _data84_);
#line 2716 "conversation-email.c"
	}
}

static Block85Data*
block85_data_ref (Block85Data* _data85_)
{
#line 486 "../src/client/conversation-viewer/conversation-email.vala"
	g_atomic_int_inc (&_data85_->_ref_count_);
#line 486 "../src/client/conversation-viewer/conversation-email.vala"
	return _data85_;
#line 2727 "conversation-email.c"
}

static void
block85_data_unref (void * _userdata_)
{
	Block85Data* _data85_;
	_data85_ = (Block85Data*) _userdata_;
#line 486 "../src/client/conversation-viewer/conversation-email.vala"
	if (g_atomic_int_dec_and_test (&_data85_->_ref_count_)) {
#line 2737 "conversation-email.c"
		ConversationEmail* self;
#line 486 "../src/client/conversation-viewer/conversation-email.vala"
		self = _data85_->_data84_->self;
#line 486 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (_data85_->email);
#line 486 "../src/client/conversation-viewer/conversation-email.vala"
		block84_data_unref (_data85_->_data84_);
#line 486 "../src/client/conversation-viewer/conversation-email.vala"
		_data85_->_data84_ = NULL;
#line 486 "../src/client/conversation-viewer/conversation-email.vala"
		g_slice_free (Block85Data, _data85_);
#line 2749 "conversation-email.c"
	}
}

static void
____lambda105_ (Block85Data* _data85_,
                GError** error)
{
	Block84Data* _data84_;
	ConversationEmail* self;
	gchar* source = NULL;
	GearyEmail* _tmp0_;
	GearyRFC822Header* _tmp1_;
	GearyRFC822Header* _tmp2_;
	GearyMemoryBuffer* _tmp3_;
	GearyMemoryBuffer* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GearyEmail* _tmp7_;
	GearyRFC822Text* _tmp8_;
	GearyRFC822Text* _tmp9_;
	GearyMemoryBuffer* _tmp10_;
	GearyMemoryBuffer* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* temporary_filename = NULL;
	gint temporary_handle = 0;
	gchar* _tmp16_ = NULL;
	gint _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* temporary_uri = NULL;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	ApplicationMainWindow* _tmp23_;
	ApplicationClient* _tmp24_;
	ApplicationClient* _tmp25_;
	const gchar* _tmp26_;
	GError* _inner_error0_ = NULL;
#line 490 "../src/client/conversation-viewer/conversation-email.vala"
	_data84_ = _data85_->_data84_;
#line 490 "../src/client/conversation-viewer/conversation-email.vala"
	self = _data84_->self;
#line 491 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = _data85_->email;
#line 491 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp1_ = geary_email_get_header (_tmp0_);
#line 491 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp2_ = _tmp1_;
#line 491 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp3_ = geary_message_data_block_message_data_get_buffer (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEARY_MESSAGE_DATA_TYPE_BLOCK_MESSAGE_DATA, GearyMessageDataBlockMessageData));
#line 491 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp4_ = _tmp3_;
#line 491 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp5_ = geary_memory_buffer_to_string (_tmp4_);
#line 491 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp6_ = _tmp5_;
#line 491 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp7_ = _data85_->email;
#line 491 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp8_ = geary_email_get_body (_tmp7_);
#line 491 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp9_ = _tmp8_;
#line 491 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp10_ = geary_message_data_block_message_data_get_buffer (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEARY_MESSAGE_DATA_TYPE_BLOCK_MESSAGE_DATA, GearyMessageDataBlockMessageData));
#line 491 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp11_ = _tmp10_;
#line 491 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp12_ = geary_memory_buffer_to_string (_tmp11_);
#line 491 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp13_ = _tmp12_;
#line 491 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp14_ = g_strconcat (_tmp6_, _tmp13_, NULL);
#line 491 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp15_ = _tmp14_;
#line 491 "../src/client/conversation-viewer/conversation-email.vala"
	_g_free0 (_tmp13_);
#line 491 "../src/client/conversation-viewer/conversation-email.vala"
	_g_free0 (_tmp6_);
#line 491 "../src/client/conversation-viewer/conversation-email.vala"
	source = _tmp15_;
#line 496 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp17_ = g_file_open_tmp ("geary-message-XXXXXX.txt", &_tmp16_, &_inner_error0_);
#line 496 "../src/client/conversation-viewer/conversation-email.vala"
	_g_free0 (temporary_filename);
#line 496 "../src/client/conversation-viewer/conversation-email.vala"
	temporary_filename = _tmp16_;
#line 496 "../src/client/conversation-viewer/conversation-email.vala"
	temporary_handle = _tmp17_;
#line 496 "../src/client/conversation-viewer/conversation-email.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 496 "../src/client/conversation-viewer/conversation-email.vala"
		g_propagate_error (error, _inner_error0_);
#line 496 "../src/client/conversation-viewer/conversation-email.vala"
		_g_free0 (temporary_filename);
#line 496 "../src/client/conversation-viewer/conversation-email.vala"
		_g_free0 (source);
#line 496 "../src/client/conversation-viewer/conversation-email.vala"
		return;
#line 2851 "conversation-email.c"
	}
#line 500 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp18_ = temporary_filename;
#line 500 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp19_ = source;
#line 500 "../src/client/conversation-viewer/conversation-email.vala"
	g_file_set_contents (_tmp18_, _tmp19_, (gssize) -1, &_inner_error0_);
#line 500 "../src/client/conversation-viewer/conversation-email.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 500 "../src/client/conversation-viewer/conversation-email.vala"
		g_propagate_error (error, _inner_error0_);
#line 500 "../src/client/conversation-viewer/conversation-email.vala"
		_g_free0 (temporary_filename);
#line 500 "../src/client/conversation-viewer/conversation-email.vala"
		_g_free0 (source);
#line 500 "../src/client/conversation-viewer/conversation-email.vala"
		return;
#line 2869 "conversation-email.c"
	}
#line 501 "../src/client/conversation-viewer/conversation-email.vala"
	close (temporary_handle);
#line 506 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp20_ = temporary_filename;
#line 506 "../src/client/conversation-viewer/conversation-email.vala"
	g_chmod (_tmp20_, (gint) (S_IRUSR | S_IWUSR));
#line 511 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp21_ = temporary_filename;
#line 511 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp22_ = g_filename_to_uri (_tmp21_, NULL, &_inner_error0_);
#line 511 "../src/client/conversation-viewer/conversation-email.vala"
	temporary_uri = _tmp22_;
#line 511 "../src/client/conversation-viewer/conversation-email.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 511 "../src/client/conversation-viewer/conversation-email.vala"
		g_propagate_error (error, _inner_error0_);
#line 511 "../src/client/conversation-viewer/conversation-email.vala"
		_g_free0 (temporary_filename);
#line 511 "../src/client/conversation-viewer/conversation-email.vala"
		_g_free0 (source);
#line 511 "../src/client/conversation-viewer/conversation-email.vala"
		return;
#line 2893 "conversation-email.c"
	}
#line 514 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp23_ = _data84_->main;
#line 514 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp24_ = application_main_window_get_application (_tmp23_);
#line 514 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp25_ = _tmp24_;
#line 514 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp26_ = temporary_uri;
#line 514 "../src/client/conversation-viewer/conversation-email.vala"
	application_client_show_uri (_tmp25_, _tmp26_, NULL, NULL);
#line 490 "../src/client/conversation-viewer/conversation-email.vala"
	_g_free0 (temporary_uri);
#line 490 "../src/client/conversation-viewer/conversation-email.vala"
	_g_free0 (temporary_filename);
#line 490 "../src/client/conversation-viewer/conversation-email.vala"
	_g_free0 (source);
#line 2911 "conversation-email.c"
}

static void
_____lambda105__geary_nonblocking_concurrent_concurrent_callback (GCancellable* cancellable,
                                                                  gpointer self,
                                                                  GError** error)
{
#line 489 "../src/client/conversation-viewer/conversation-email.vala"
	____lambda105_ (self, error);
#line 2921 "conversation-email.c"
}

static void
conversation_email_view_source_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_)
{
	ConversationEmailViewSourceData* _data_;
#line 489 "../src/client/conversation-viewer/conversation-email.vala"
	_data_ = _user_data_;
#line 489 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_source_object_ = source_object;
#line 489 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_res_ = _res_;
#line 489 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_view_source_co (_data_);
#line 2938 "conversation-email.c"
}

static gboolean
conversation_email_view_source_co (ConversationEmailViewSourceData* _data_)
{
#line 484 "../src/client/conversation-viewer/conversation-email.vala"
	switch (_data_->_state_) {
#line 484 "../src/client/conversation-viewer/conversation-email.vala"
		case 0:
#line 2948 "conversation-email.c"
		goto _state_0;
#line 484 "../src/client/conversation-viewer/conversation-email.vala"
		case 1:
#line 2952 "conversation-email.c"
		goto _state_1;
		default:
#line 484 "../src/client/conversation-viewer/conversation-email.vala"
		g_assert_not_reached ();
#line 2957 "conversation-email.c"
	}
	_state_0:
#line 484 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_data84_ = g_slice_new0 (Block84Data);
#line 484 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_data84_->_ref_count_ = 1;
#line 484 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_data84_->self = g_object_ref (_data_->self);
#line 484 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_data84_->_async_data_ = _data_;
#line 485 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp0_ = gtk_widget_get_toplevel (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, gtk_widget_get_type (), GtkWidget));
#line 485 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp1_ = _g_object_ref0 (APPLICATION_IS_MAIN_WINDOW (_data_->_tmp0_) ? ((ApplicationMainWindow*) _data_->_tmp0_) : NULL);
#line 485 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_data84_->main = _data_->_tmp1_;
#line 486 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp2_ = _data_->_data84_->main;
#line 486 "../src/client/conversation-viewer/conversation-email.vala"
	if (_data_->_tmp2_ != NULL) {
#line 486 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_data85_ = g_slice_new0 (Block85Data);
#line 486 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_data85_->_ref_count_ = 1;
#line 486 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_data85_->_data84_ = block84_data_ref (_data_->_data84_);
#line 487 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp3_ = _data_->self->priv->_email;
#line 487 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp4_ = _g_object_ref0 (_data_->_tmp3_);
#line 487 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_data85_->email = _data_->_tmp4_;
#line 2990 "conversation-email.c"
		{
#line 489 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp5_ = geary_nonblocking_concurrent_get_global ();
#line 489 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp6_ = _data_->_tmp5_;
#line 489 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_state_ = 1;
#line 489 "../src/client/conversation-viewer/conversation-email.vala"
			geary_nonblocking_concurrent_schedule_async (_data_->_tmp6_, _____lambda105__geary_nonblocking_concurrent_concurrent_callback, _data_->_data85_, NULL, conversation_email_view_source_ready, _data_);
#line 489 "../src/client/conversation-viewer/conversation-email.vala"
			return FALSE;
#line 3002 "conversation-email.c"
			_state_1:
#line 489 "../src/client/conversation-viewer/conversation-email.vala"
			geary_nonblocking_concurrent_schedule_finish (_data_->_tmp6_, _data_->_res_, &_data_->_inner_error0_);
#line 489 "../src/client/conversation-viewer/conversation-email.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3008 "conversation-email.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 488 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_error_ = _data_->_inner_error0_;
#line 488 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_inner_error0_ = NULL;
#line 519 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp7_ = _data_->_data84_->main;
#line 519 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp8_ = application_main_window_get_application (_data_->_tmp7_);
#line 519 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp9_ = _data_->_tmp8_;
#line 519 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp10_ = application_client_get_controller (_data_->_tmp9_);
#line 519 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp11_ = _data_->_tmp10_;
#line 519 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp12_ = _data_->_error_;
#line 519 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp13_ = geary_problem_report_new (_data_->_tmp12_);
#line 519 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp14_ = _data_->_tmp13_;
#line 519 "../src/client/conversation-viewer/conversation-email.vala"
			composer_application_interface_report_problem (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp11_, COMPOSER_TYPE_APPLICATION_INTERFACE, ComposerApplicationInterface), _data_->_tmp14_);
#line 519 "../src/client/conversation-viewer/conversation-email.vala"
			_g_object_unref0 (_data_->_tmp14_);
#line 488 "../src/client/conversation-viewer/conversation-email.vala"
			_g_error_free0 (_data_->_error_);
#line 3041 "conversation-email.c"
		}
		__finally0:
#line 488 "../src/client/conversation-viewer/conversation-email.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 488 "../src/client/conversation-viewer/conversation-email.vala"
			block85_data_unref (_data_->_data85_);
#line 488 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_data85_ = NULL;
#line 488 "../src/client/conversation-viewer/conversation-email.vala"
			block84_data_unref (_data_->_data84_);
#line 488 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_data84_ = NULL;
#line 488 "../src/client/conversation-viewer/conversation-email.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 488 "../src/client/conversation-viewer/conversation-email.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 488 "../src/client/conversation-viewer/conversation-email.vala"
			g_object_unref (_data_->_async_result);
#line 488 "../src/client/conversation-viewer/conversation-email.vala"
			return FALSE;
#line 3062 "conversation-email.c"
		}
#line 486 "../src/client/conversation-viewer/conversation-email.vala"
		block85_data_unref (_data_->_data85_);
#line 486 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_data85_ = NULL;
#line 3068 "conversation-email.c"
	}
#line 484 "../src/client/conversation-viewer/conversation-email.vala"
	block84_data_unref (_data_->_data84_);
#line 484 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_data84_ = NULL;
#line 484 "../src/client/conversation-viewer/conversation-email.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 484 "../src/client/conversation-viewer/conversation-email.vala"
	if (_data_->_state_ != 0) {
#line 484 "../src/client/conversation-viewer/conversation-email.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 484 "../src/client/conversation-viewer/conversation-email.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3082 "conversation-email.c"
		}
	}
#line 484 "../src/client/conversation-viewer/conversation-email.vala"
	g_object_unref (_data_->_async_result);
#line 484 "../src/client/conversation-viewer/conversation-email.vala"
	return FALSE;
#line 3089 "conversation-email.c"
}

static void
conversation_email_print_data_free (gpointer _data)
{
	ConversationEmailPrintData* _data_;
	_data_ = _data;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (_data_->self);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_slice_free (ConversationEmailPrintData, _data_);
#line 3101 "conversation-email.c"
}

void
conversation_email_print (ConversationEmail* self,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_)
{
	ConversationEmailPrintData* _data_;
	ConversationEmail* _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_ = g_slice_new0 (ConversationEmailPrintData);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_task_set_task_data (_data_->_async_result, _data_, conversation_email_print_data_free);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->self = _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_print_co (_data_);
#line 3125 "conversation-email.c"
}

void
conversation_email_print_finish (ConversationEmail* self,
                                 GAsyncResult* _res_,
                                 GError** error)
{
	ConversationEmailPrintData* _data_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	if (NULL == _data_) {
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		return;
#line 3140 "conversation-email.c"
	}
}

/** Print this view's email. */
static void
_vala_JsonNode_free (JsonNode* self)
{
#line 566 "../src/client/conversation-viewer/conversation-email.vala"
	g_boxed_free (json_node_get_type (), self);
#line 3150 "conversation-email.c"
}

static void
conversation_email_print_ready (GObject* source_object,
                                GAsyncResult* _res_,
                                gpointer _user_data_)
{
	ConversationEmailPrintData* _data_;
#line 568 "../src/client/conversation-viewer/conversation-email.vala"
	_data_ = _user_data_;
#line 568 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_source_object_ = source_object;
#line 568 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_res_ = _res_;
#line 568 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_print_co (_data_);
#line 3167 "conversation-email.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 3189 "conversation-email.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 3193 "conversation-email.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 3199 "conversation-email.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 3203 "conversation-email.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 3207 "conversation-email.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 3215 "conversation-email.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 3243 "conversation-email.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 3252 "conversation-email.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 3266 "conversation-email.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 3275 "conversation-email.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 3289 "conversation-email.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 3298 "conversation-email.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 3307 "conversation-email.c"
}

static gboolean
conversation_email_print_co (ConversationEmailPrintData* _data_)
{
#line 527 "../src/client/conversation-viewer/conversation-email.vala"
	switch (_data_->_state_) {
#line 527 "../src/client/conversation-viewer/conversation-email.vala"
		case 0:
#line 3317 "conversation-email.c"
		goto _state_0;
#line 527 "../src/client/conversation-viewer/conversation-email.vala"
		case 1:
#line 3321 "conversation-email.c"
		goto _state_1;
		default:
#line 527 "../src/client/conversation-viewer/conversation-email.vala"
		g_assert_not_reached ();
#line 3326 "conversation-email.c"
	}
	_state_0:
#line 528 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp0_ = json_builder_new ();
#line 528 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->builder = _data_->_tmp0_;
#line 529 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp1_ = _data_->builder;
#line 529 "../src/client/conversation-viewer/conversation-email.vala"
	json_builder_begin_object (_data_->_tmp1_);
#line 530 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp2_ = _data_->self->priv->_email;
#line 530 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp3_ = geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 530 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 530 "../src/client/conversation-viewer/conversation-email.vala"
	if (_data_->_tmp4_ != NULL) {
#line 531 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp5_ = _data_->builder;
#line 531 "../src/client/conversation-viewer/conversation-email.vala"
		json_builder_set_member_name (_data_->_tmp5_, _ ("From:"));
#line 532 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp6_ = _data_->builder;
#line 532 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp7_ = _data_->self->priv->_email;
#line 532 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp8_ = geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp7_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 532 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 532 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp10_ = geary_message_data_abstract_message_data_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp9_, GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA, GearyMessageDataAbstractMessageData));
#line 532 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp11_ = _data_->_tmp10_;
#line 532 "../src/client/conversation-viewer/conversation-email.vala"
		json_builder_add_string_value (_data_->_tmp6_, _data_->_tmp11_);
#line 532 "../src/client/conversation-viewer/conversation-email.vala"
		_g_free0 (_data_->_tmp11_);
#line 3365 "conversation-email.c"
	}
#line 534 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp12_ = _data_->self->priv->_email;
#line 534 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp13_ = geary_email_header_set_get_to (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp12_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 534 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp14_ = _data_->_tmp13_;
#line 534 "../src/client/conversation-viewer/conversation-email.vala"
	if (_data_->_tmp14_ != NULL) {
#line 536 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp15_ = _data_->builder;
#line 536 "../src/client/conversation-viewer/conversation-email.vala"
		json_builder_set_member_name (_data_->_tmp15_, _ ("To:"));
#line 537 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp16_ = _data_->builder;
#line 537 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp17_ = _data_->self->priv->_email;
#line 537 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp18_ = geary_email_header_set_get_to (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp17_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 537 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp19_ = _data_->_tmp18_;
#line 537 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp20_ = geary_message_data_abstract_message_data_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp19_, GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA, GearyMessageDataAbstractMessageData));
#line 537 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp21_ = _data_->_tmp20_;
#line 537 "../src/client/conversation-viewer/conversation-email.vala"
		json_builder_add_string_value (_data_->_tmp16_, _data_->_tmp21_);
#line 537 "../src/client/conversation-viewer/conversation-email.vala"
		_g_free0 (_data_->_tmp21_);
#line 3395 "conversation-email.c"
	}
#line 539 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp22_ = _data_->self->priv->_email;
#line 539 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp23_ = geary_email_header_set_get_cc (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp22_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 539 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp24_ = _data_->_tmp23_;
#line 539 "../src/client/conversation-viewer/conversation-email.vala"
	if (_data_->_tmp24_ != NULL) {
#line 541 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp25_ = _data_->builder;
#line 541 "../src/client/conversation-viewer/conversation-email.vala"
		json_builder_set_member_name (_data_->_tmp25_, _ ("Cc:"));
#line 542 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp26_ = _data_->builder;
#line 542 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp27_ = _data_->self->priv->_email;
#line 542 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp28_ = geary_email_header_set_get_cc (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp27_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 542 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp29_ = _data_->_tmp28_;
#line 542 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp30_ = geary_message_data_abstract_message_data_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp29_, GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA, GearyMessageDataAbstractMessageData));
#line 542 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp31_ = _data_->_tmp30_;
#line 542 "../src/client/conversation-viewer/conversation-email.vala"
		json_builder_add_string_value (_data_->_tmp26_, _data_->_tmp31_);
#line 542 "../src/client/conversation-viewer/conversation-email.vala"
		_g_free0 (_data_->_tmp31_);
#line 3425 "conversation-email.c"
	}
#line 544 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp32_ = _data_->self->priv->_email;
#line 544 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp33_ = geary_email_header_set_get_bcc (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp32_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 544 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp34_ = _data_->_tmp33_;
#line 544 "../src/client/conversation-viewer/conversation-email.vala"
	if (_data_->_tmp34_ != NULL) {
#line 546 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp35_ = _data_->builder;
#line 546 "../src/client/conversation-viewer/conversation-email.vala"
		json_builder_set_member_name (_data_->_tmp35_, _ ("Bcc:"));
#line 547 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp36_ = _data_->builder;
#line 547 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp37_ = _data_->self->priv->_email;
#line 547 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp38_ = geary_email_header_set_get_bcc (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp37_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 547 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp39_ = _data_->_tmp38_;
#line 547 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp40_ = geary_message_data_abstract_message_data_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp39_, GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA, GearyMessageDataAbstractMessageData));
#line 547 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp41_ = _data_->_tmp40_;
#line 547 "../src/client/conversation-viewer/conversation-email.vala"
		json_builder_add_string_value (_data_->_tmp36_, _data_->_tmp41_);
#line 547 "../src/client/conversation-viewer/conversation-email.vala"
		_g_free0 (_data_->_tmp41_);
#line 3455 "conversation-email.c"
	}
#line 549 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp42_ = _data_->self->priv->_email;
#line 549 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp43_ = geary_email_header_set_get_date (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp42_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 549 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp44_ = _data_->_tmp43_;
#line 549 "../src/client/conversation-viewer/conversation-email.vala"
	if (_data_->_tmp44_ != NULL) {
#line 551 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp45_ = _data_->builder;
#line 551 "../src/client/conversation-viewer/conversation-email.vala"
		json_builder_set_member_name (_data_->_tmp45_, _ ("Date:"));
#line 552 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp46_ = _data_->builder;
#line 552 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp47_ = _data_->self->priv->_email;
#line 552 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp48_ = geary_email_header_set_get_date (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp47_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 552 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp49_ = _data_->_tmp48_;
#line 552 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp50_ = geary_rf_c822_date_get_value (_data_->_tmp49_);
#line 552 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp51_ = _data_->_tmp50_;
#line 552 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp52_ = g_date_time_to_local (_data_->_tmp51_);
#line 552 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp53_ = _data_->_tmp52_;
#line 552 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp54_ = _data_->self->priv->config;
#line 552 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp55_ = application_configuration_get_clock_format (_data_->_tmp54_);
#line 552 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp56_ = _data_->_tmp55_;
#line 552 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp57_ = util_date_pretty_print_verbose (_data_->_tmp53_, _data_->_tmp56_);
#line 552 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp58_ = _data_->_tmp57_;
#line 552 "../src/client/conversation-viewer/conversation-email.vala"
		json_builder_add_string_value (_data_->_tmp46_, _data_->_tmp58_);
#line 552 "../src/client/conversation-viewer/conversation-email.vala"
		_g_free0 (_data_->_tmp58_);
#line 552 "../src/client/conversation-viewer/conversation-email.vala"
		_g_date_time_unref0 (_data_->_tmp53_);
#line 3501 "conversation-email.c"
	}
#line 559 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp59_ = _data_->self->priv->_email;
#line 559 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp60_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp59_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 559 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp61_ = _data_->_tmp60_;
#line 559 "../src/client/conversation-viewer/conversation-email.vala"
	if (_data_->_tmp61_ != NULL) {
#line 561 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp62_ = _data_->builder;
#line 561 "../src/client/conversation-viewer/conversation-email.vala"
		json_builder_set_member_name (_data_->_tmp62_, _ ("Subject:"));
#line 562 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp63_ = _data_->builder;
#line 562 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp64_ = _data_->self->priv->_email;
#line 562 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp65_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp64_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 562 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp66_ = _data_->_tmp65_;
#line 562 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp67_ = geary_message_data_abstract_message_data_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp66_, GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA, GearyMessageDataAbstractMessageData));
#line 562 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp68_ = _data_->_tmp67_;
#line 562 "../src/client/conversation-viewer/conversation-email.vala"
		json_builder_add_string_value (_data_->_tmp63_, _data_->_tmp68_);
#line 562 "../src/client/conversation-viewer/conversation-email.vala"
		_g_free0 (_data_->_tmp68_);
#line 3531 "conversation-email.c"
	}
#line 564 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp69_ = _data_->builder;
#line 564 "../src/client/conversation-viewer/conversation-email.vala"
	json_builder_end_object (_data_->_tmp69_);
#line 565 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp70_ = json_generator_new ();
#line 565 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->generator = _data_->_tmp70_;
#line 566 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp71_ = _data_->builder;
#line 566 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp72_ = json_builder_get_root (_data_->_tmp71_);
#line 566 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp73_ = _data_->_tmp72_;
#line 566 "../src/client/conversation-viewer/conversation-email.vala"
	json_generator_set_root (_data_->generator, _data_->_tmp73_);
#line 566 "../src/client/conversation-viewer/conversation-email.vala"
	__vala_JsonNode_free0 (_data_->_tmp73_);
#line 567 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp74_ = json_generator_to_data (_data_->generator, NULL);
#line 567 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp75_ = _data_->_tmp74_;
#line 567 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp76_ = g_strconcat ("geary.addPrintHeaders(", _data_->_tmp75_, NULL);
#line 567 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp77_ = _data_->_tmp76_;
#line 567 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp78_ = g_strconcat (_data_->_tmp77_, ");", NULL);
#line 567 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp79_ = _data_->_tmp78_;
#line 567 "../src/client/conversation-viewer/conversation-email.vala"
	_g_free0 (_data_->_tmp77_);
#line 567 "../src/client/conversation-viewer/conversation-email.vala"
	_g_free0 (_data_->_tmp75_);
#line 567 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->js = _data_->_tmp79_;
#line 568 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp80_ = _data_->self->priv->_primary_message;
#line 568 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_state_ = 1;
#line 568 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_message_evaluate_javascript (_data_->_tmp80_, _data_->js, NULL, conversation_email_print_ready, _data_);
#line 568 "../src/client/conversation-viewer/conversation-email.vala"
	return FALSE;
#line 3577 "conversation-email.c"
	_state_1:
#line 568 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_message_evaluate_javascript_finish (_data_->_tmp80_, _data_->_res_, &_data_->_inner_error0_);
#line 568 "../src/client/conversation-viewer/conversation-email.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 568 "../src/client/conversation-viewer/conversation-email.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 568 "../src/client/conversation-viewer/conversation-email.vala"
		_g_free0 (_data_->js);
#line 568 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (_data_->generator);
#line 568 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (_data_->builder);
#line 568 "../src/client/conversation-viewer/conversation-email.vala"
		g_object_unref (_data_->_async_result);
#line 568 "../src/client/conversation-viewer/conversation-email.vala"
		return FALSE;
#line 3595 "conversation-email.c"
	}
#line 570 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp81_ = gtk_widget_get_toplevel (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, gtk_widget_get_type (), GtkWidget));
#line 570 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp82_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp81_, gtk_window_get_type ()) ? ((GtkWindow*) _data_->_tmp81_) : NULL);
#line 570 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->window = _data_->_tmp82_;
#line 571 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp83_ = _data_->self->priv->_primary_message;
#line 571 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp84_ = conversation_message_new_print_operation (_data_->_tmp83_);
#line 571 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->op = _data_->_tmp84_;
#line 572 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp85_ = gtk_print_settings_new ();
#line 572 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->settings = _data_->_tmp85_;
#line 578 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp86_ = g_get_user_special_dir (G_USER_DIRECTORY_DOWNLOAD);
#line 578 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp87_ = g_strdup (_data_->_tmp86_);
#line 578 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->download_dir = _data_->_tmp87_;
#line 579 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp88_ = _data_->download_dir;
#line 579 "../src/client/conversation-viewer/conversation-email.vala"
	if (!geary_string_is_empty_or_whitespace (_data_->_tmp88_)) {
#line 580 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp89_ = _data_->settings;
#line 580 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp90_ = _data_->download_dir;
#line 580 "../src/client/conversation-viewer/conversation-email.vala"
		gtk_print_settings_set (_data_->_tmp89_, GTK_PRINT_SETTINGS_OUTPUT_DIR, _data_->_tmp90_);
#line 3629 "conversation-email.c"
	}
#line 583 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp91_ = _data_->self->priv->_email;
#line 583 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp92_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp91_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 583 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp93_ = _data_->_tmp92_;
#line 583 "../src/client/conversation-viewer/conversation-email.vala"
	if (_data_->_tmp93_ != NULL) {
#line 584 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp94_ = _data_->self->priv->_email;
#line 584 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp95_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp94_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 584 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp96_ = _data_->_tmp95_;
#line 584 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp97_ = geary_message_data_string_message_data_get_value (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp96_, GEARY_MESSAGE_DATA_TYPE_STRING_MESSAGE_DATA, GearyMessageDataStringMessageData));
#line 584 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp98_ = _data_->_tmp97_;
#line 584 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp99_ = geary_string_reduce_whitespace (_data_->_tmp98_);
#line 584 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->file_name = _data_->_tmp99_;
#line 585 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp100_ = _data_->file_name;
#line 585 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp101_ = string_replace (_data_->_tmp100_, "/", "_");
#line 585 "../src/client/conversation-viewer/conversation-email.vala"
		_g_free0 (_data_->file_name);
#line 585 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->file_name = _data_->_tmp101_;
#line 586 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp102_ = _data_->file_name;
#line 586 "../src/client/conversation-viewer/conversation-email.vala"
		if (g_utf8_strlen (_data_->_tmp102_, (gssize) -1) > 128) {
#line 587 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp103_ = _data_->file_name;
#line 587 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp104_ = geary_string_safe_byte_substring (_data_->_tmp103_, (gssize) 128);
#line 587 "../src/client/conversation-viewer/conversation-email.vala"
			_g_free0 (_data_->file_name);
#line 587 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->file_name = _data_->_tmp104_;
#line 3673 "conversation-email.c"
		}
#line 590 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp105_ = _data_->file_name;
#line 590 "../src/client/conversation-viewer/conversation-email.vala"
		if (!geary_string_is_empty (_data_->_tmp105_)) {
#line 591 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp106_ = _data_->settings;
#line 591 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp107_ = _data_->file_name;
#line 591 "../src/client/conversation-viewer/conversation-email.vala"
			gtk_print_settings_set (_data_->_tmp106_, GTK_PRINT_SETTINGS_OUTPUT_BASENAME, _data_->_tmp107_);
#line 3685 "conversation-email.c"
		}
#line 583 "../src/client/conversation-viewer/conversation-email.vala"
		_g_free0 (_data_->file_name);
#line 3689 "conversation-email.c"
	}
#line 595 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp108_ = _data_->op;
#line 595 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp109_ = _data_->settings;
#line 595 "../src/client/conversation-viewer/conversation-email.vala"
	webkit_print_operation_set_print_settings (_data_->_tmp108_, _data_->_tmp109_);
#line 596 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp110_ = _data_->op;
#line 596 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp111_ = _data_->window;
#line 596 "../src/client/conversation-viewer/conversation-email.vala"
	webkit_print_operation_run_dialog (_data_->_tmp110_, _data_->_tmp111_);
#line 527 "../src/client/conversation-viewer/conversation-email.vala"
	_g_free0 (_data_->download_dir);
#line 527 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (_data_->settings);
#line 527 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (_data_->op);
#line 527 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (_data_->window);
#line 527 "../src/client/conversation-viewer/conversation-email.vala"
	_g_free0 (_data_->js);
#line 527 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (_data_->generator);
#line 527 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (_data_->builder);
#line 527 "../src/client/conversation-viewer/conversation-email.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 527 "../src/client/conversation-viewer/conversation-email.vala"
	if (_data_->_state_ != 0) {
#line 527 "../src/client/conversation-viewer/conversation-email.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 527 "../src/client/conversation-viewer/conversation-email.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3725 "conversation-email.c"
		}
	}
#line 527 "../src/client/conversation-viewer/conversation-email.vala"
	g_object_unref (_data_->_async_result);
#line 527 "../src/client/conversation-viewer/conversation-email.vala"
	return FALSE;
#line 3732 "conversation-email.c"
}

/**
     * Returns a new Iterable over all message views in this email view
     */
GeeIterator*
conversation_email_iterator (ConversationEmail* self)
{
	ConversationEmailMessageViewIterator* _tmp0_;
	GeeIterator* result;
#line 602 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_val_if_fail (IS_CONVERSATION_EMAIL (self), NULL);
#line 603 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = conversation_email_message_view_iterator_new (self);
#line 603 "../src/client/conversation-viewer/conversation-email.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ITERATOR, GeeIterator);
#line 603 "../src/client/conversation-viewer/conversation-email.vala"
	return result;
#line 3751 "conversation-email.c"
}

static Block86Data*
block86_data_ref (Block86Data* _data86_)
{
#line 606 "../src/client/conversation-viewer/conversation-email.vala"
	g_atomic_int_inc (&_data86_->_ref_count_);
#line 606 "../src/client/conversation-viewer/conversation-email.vala"
	return _data86_;
#line 3761 "conversation-email.c"
}

static void
block86_data_unref (void * _userdata_)
{
	Block86Data* _data86_;
	_data86_ = (Block86Data*) _userdata_;
#line 606 "../src/client/conversation-viewer/conversation-email.vala"
	if (g_atomic_int_dec_and_test (&_data86_->_ref_count_)) {
#line 3771 "conversation-email.c"
		ConversationEmail* self;
#line 606 "../src/client/conversation-viewer/conversation-email.vala"
		self = _data86_->self;
#line 606 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (_data86_->view);
#line 606 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (self);
#line 606 "../src/client/conversation-viewer/conversation-email.vala"
		g_slice_free (Block86Data, _data86_);
#line 3781 "conversation-email.c"
	}
}

static void
_conversation_email_on_content_loaded_conversation_message_content_loaded (ConversationMessage* _sender,
                                                                           gpointer self)
{
#line 607 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_on_content_loaded ((ConversationEmail*) self);
#line 3791 "conversation-email.c"
}

static void
_conversation_email_on_flag_remote_images_conversation_message_flag_remote_images (ConversationMessage* _sender,
                                                                                   gpointer self)
{
#line 608 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_on_flag_remote_images ((ConversationEmail*) self);
#line 3800 "conversation-email.c"
}

static void
__lambda102_ (ConversationEmail* self,
              gint y)
{
#line 610 "../src/client/conversation-viewer/conversation-email.vala"
	g_signal_emit (self, conversation_email_signals[CONVERSATION_EMAIL_INTERNAL_LINK_ACTIVATED_SIGNAL], 0, y);
#line 3809 "conversation-email.c"
}

static void
___lambda102__conversation_message_internal_link_activated (ConversationMessage* _sender,
                                                            gint y,
                                                            gpointer self)
{
#line 609 "../src/client/conversation-viewer/conversation-email.vala"
	__lambda102_ ((ConversationEmail*) self, y);
#line 3819 "conversation-email.c"
}

static void
_conversation_email_on_resource_loaded_conversation_message_internal_resource_loaded (ConversationMessage* _sender,
                                                                                      const gchar* name,
                                                                                      gpointer self)
{
#line 612 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_on_resource_loaded ((ConversationEmail*) self, name);
#line 3829 "conversation-email.c"
}

static void
_conversation_email_on_save_image_conversation_message_save_image (ConversationMessage* _sender,
                                                                   const gchar* uri,
                                                                   const gchar* alt_text,
                                                                   GearyMemoryBuffer* buffer,
                                                                   gpointer self)
{
#line 613 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_on_save_image ((ConversationEmail*) self, uri, alt_text, buffer);
#line 3841 "conversation-email.c"
}

static void
__lambda103_ (Block86Data* _data86_,
              gboolean has_selection)
{
	ConversationEmail* self;
	ConversationMessage* _tmp0_ = NULL;
	ConversationMessage* _tmp1_;
#line 614 "../src/client/conversation-viewer/conversation-email.vala"
	self = _data86_->self;
#line 615 "../src/client/conversation-viewer/conversation-email.vala"
	if (has_selection) {
#line 615 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp0_ = _data86_->view;
#line 3857 "conversation-email.c"
	} else {
#line 615 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp0_ = NULL;
#line 3861 "conversation-email.c"
	}
#line 615 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 615 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->priv->body_selection_message);
#line 615 "../src/client/conversation-viewer/conversation-email.vala"
	self->priv->body_selection_message = _tmp1_;
#line 616 "../src/client/conversation-viewer/conversation-email.vala"
	g_signal_emit (self, conversation_email_signals[CONVERSATION_EMAIL_BODY_SELECTION_CHANGED_SIGNAL], 0, has_selection);
#line 3871 "conversation-email.c"
}

static void
___lambda103__conversation_message_selection_changed (ConversationMessage* _sender,
                                                      gboolean has_selection,
                                                      gpointer self)
{
#line 614 "../src/client/conversation-viewer/conversation-email.vala"
	__lambda103_ (self, has_selection);
#line 3881 "conversation-email.c"
}

static void
conversation_email_connect_message_view_signals (ConversationEmail* self,
                                                 ConversationMessage* view)
{
	Block86Data* _data86_;
	ConversationMessage* _tmp0_;
#line 606 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 606 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_MESSAGE (view));
#line 606 "../src/client/conversation-viewer/conversation-email.vala"
	_data86_ = g_slice_new0 (Block86Data);
#line 606 "../src/client/conversation-viewer/conversation-email.vala"
	_data86_->_ref_count_ = 1;
#line 606 "../src/client/conversation-viewer/conversation-email.vala"
	_data86_->self = g_object_ref (self);
#line 606 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = _g_object_ref0 (view);
#line 606 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (_data86_->view);
#line 606 "../src/client/conversation-viewer/conversation-email.vala"
	_data86_->view = _tmp0_;
#line 607 "../src/client/conversation-viewer/conversation-email.vala"
	g_signal_connect_object (_data86_->view, "content-loaded", (GCallback) _conversation_email_on_content_loaded_conversation_message_content_loaded, self, 0);
#line 608 "../src/client/conversation-viewer/conversation-email.vala"
	g_signal_connect_object (_data86_->view, "flag-remote-images", (GCallback) _conversation_email_on_flag_remote_images_conversation_message_flag_remote_images, self, 0);
#line 609 "../src/client/conversation-viewer/conversation-email.vala"
	g_signal_connect_object (_data86_->view, "internal-link-activated", (GCallback) ___lambda102__conversation_message_internal_link_activated, self, 0);
#line 612 "../src/client/conversation-viewer/conversation-email.vala"
	g_signal_connect_object (_data86_->view, "internal-resource-loaded", (GCallback) _conversation_email_on_resource_loaded_conversation_message_internal_resource_loaded, self, 0);
#line 613 "../src/client/conversation-viewer/conversation-email.vala"
	g_signal_connect_object (_data86_->view, "save-image", (GCallback) _conversation_email_on_save_image_conversation_message_save_image, self, 0);
#line 614 "../src/client/conversation-viewer/conversation-email.vala"
	g_signal_connect_data (_data86_->view, "selection-changed", (GCallback) ___lambda103__conversation_message_selection_changed, block86_data_ref (_data86_), (GClosureNotify) block86_data_unref, 0);
#line 606 "../src/client/conversation-viewer/conversation-email.vala"
	block86_data_unref (_data86_);
#line 606 "../src/client/conversation-viewer/conversation-email.vala"
	_data86_ = NULL;
#line 3922 "conversation-email.c"
}

static void
conversation_email_fetch_remote_body_data_free (gpointer _data)
{
	ConversationEmailFetchRemoteBodyData* _data_;
	_data_ = _data;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (_data_->self);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_slice_free (ConversationEmailFetchRemoteBodyData, _data_);
#line 3934 "conversation-email.c"
}

static void
conversation_email_fetch_remote_body (ConversationEmail* self,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	ConversationEmailFetchRemoteBodyData* _data_;
	ConversationEmail* _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_ = g_slice_new0 (ConversationEmailFetchRemoteBodyData);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_task_set_task_data (_data_->_async_result, _data_, conversation_email_fetch_remote_body_data_free);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->self = _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_fetch_remote_body_co (_data_);
#line 3958 "conversation-email.c"
}

static void
conversation_email_fetch_remote_body_finish (ConversationEmail* self,
                                             GAsyncResult* _res_)
{
	ConversationEmailFetchRemoteBodyData* _data_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3968 "conversation-email.c"
}

static void
conversation_email_fetch_remote_body_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_)
{
	ConversationEmailFetchRemoteBodyData* _data_;
#line 631 "../src/client/conversation-viewer/conversation-email.vala"
	_data_ = _user_data_;
#line 631 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_source_object_ = source_object;
#line 631 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_res_ = _res_;
#line 631 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_fetch_remote_body_co (_data_);
#line 3985 "conversation-email.c"
}

static gboolean
conversation_email_fetch_remote_body_co (ConversationEmailFetchRemoteBodyData* _data_)
{
#line 620 "../src/client/conversation-viewer/conversation-email.vala"
	switch (_data_->_state_) {
#line 620 "../src/client/conversation-viewer/conversation-email.vala"
		case 0:
#line 3995 "conversation-email.c"
		goto _state_0;
#line 620 "../src/client/conversation-viewer/conversation-email.vala"
		case 1:
#line 3999 "conversation-email.c"
		goto _state_1;
#line 620 "../src/client/conversation-viewer/conversation-email.vala"
		case 2:
#line 4003 "conversation-email.c"
		goto _state_2;
		default:
#line 620 "../src/client/conversation-viewer/conversation-email.vala"
		g_assert_not_reached ();
#line 4008 "conversation-email.c"
	}
	_state_0:
#line 621 "../src/client/conversation-viewer/conversation-email.vala"
	if (conversation_email_is_online (_data_->self)) {
#line 624 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp0_ = _data_->self->priv->body_loading_timeout;
#line 624 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp1_ = geary_timeout_manager_get_is_running (_data_->_tmp0_);
#line 624 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp2_ = _data_->_tmp1_;
#line 624 "../src/client/conversation-viewer/conversation-email.vala"
		if (!_data_->_tmp2_) {
#line 625 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp3_ = _data_->self->priv->body_loading_timeout;
#line 625 "../src/client/conversation-viewer/conversation-email.vala"
			geary_timeout_manager_start (_data_->_tmp3_);
#line 4025 "conversation-email.c"
		}
#line 628 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->loaded = NULL;
#line 4029 "conversation-email.c"
		{
#line 630 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp4_ = _data_->self->priv->_email;
#line 630 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp5_ = geary_email_to_string (_data_->_tmp4_);
#line 630 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp6_ = _data_->_tmp5_;
#line 630 "../src/client/conversation-viewer/conversation-email.vala"
			g_debug ("conversation-email.vala:630: Downloading remote message: %s", _data_->_tmp6_);
#line 630 "../src/client/conversation-viewer/conversation-email.vala"
			_g_free0 (_data_->_tmp6_);
#line 631 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp8_ = _data_->self->priv->email_store;
#line 631 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp9_ = _data_->self->priv->_email;
#line 631 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp10_ = geary_email_get_id (_data_->_tmp9_);
#line 631 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp11_ = _data_->_tmp10_;
#line 631 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp12_ = _data_->self->priv->load_cancellable;
#line 631 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_state_ = 1;
#line 631 "../src/client/conversation-viewer/conversation-email.vala"
			geary_app_email_store_fetch_email_async (_data_->_tmp8_, _data_->_tmp11_, CONVERSATION_EMAIL_REQUIRED_FOR_LOAD, GEARY_FOLDER_LIST_FLAGS_FORCE_UPDATE, _data_->_tmp12_, conversation_email_fetch_remote_body_ready, _data_);
#line 631 "../src/client/conversation-viewer/conversation-email.vala"
			return FALSE;
#line 4057 "conversation-email.c"
			_state_1:
#line 631 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp13_ = geary_app_email_store_fetch_email_finish (_data_->_tmp8_, _data_->_res_, &_data_->_inner_error0_);
#line 631 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp7_ = _data_->_tmp13_;
#line 631 "../src/client/conversation-viewer/conversation-email.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 631 "../src/client/conversation-viewer/conversation-email.vala"
				if (g_error_matches (_data_->_inner_error0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 4067 "conversation-email.c"
					goto __catch0_g_io_error_cancelled;
				}
				goto __catch0_g_error;
			}
#line 631 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp14_ = _data_->_tmp7_;
#line 631 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp7_ = NULL;
#line 631 "../src/client/conversation-viewer/conversation-email.vala"
			_g_object_unref0 (_data_->loaded);
#line 631 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->loaded = _data_->_tmp14_;
#line 629 "../src/client/conversation-viewer/conversation-email.vala"
			_g_object_unref0 (_data_->_tmp7_);
#line 4082 "conversation-email.c"
		}
		goto __finally0;
		__catch0_g_io_error_cancelled:
		{
#line 629 "../src/client/conversation-viewer/conversation-email.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 4089 "conversation-email.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 629 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->err = _data_->_inner_error0_;
#line 629 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_inner_error0_ = NULL;
#line 640 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp15_ = _data_->err;
#line 640 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp16_ = _data_->_tmp15_->message;
#line 640 "../src/client/conversation-viewer/conversation-email.vala"
			g_debug ("conversation-email.vala:640: Remote message download failed: %s", _data_->_tmp16_);
#line 641 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp17_ = _data_->err;
#line 641 "../src/client/conversation-viewer/conversation-email.vala"
			conversation_email_handle_load_failure (_data_->self, _data_->_tmp17_);
#line 629 "../src/client/conversation-viewer/conversation-email.vala"
			_g_error_free0 (_data_->err);
#line 4110 "conversation-email.c"
		}
		__finally0:
#line 629 "../src/client/conversation-viewer/conversation-email.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 629 "../src/client/conversation-viewer/conversation-email.vala"
			_g_object_unref0 (_data_->loaded);
#line 629 "../src/client/conversation-viewer/conversation-email.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 629 "../src/client/conversation-viewer/conversation-email.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 629 "../src/client/conversation-viewer/conversation-email.vala"
			g_object_unref (_data_->_async_result);
#line 629 "../src/client/conversation-viewer/conversation-email.vala"
			return FALSE;
#line 4125 "conversation-email.c"
		}
#line 644 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp18_ = _data_->self->priv->body_loading_timeout;
#line 644 "../src/client/conversation-viewer/conversation-email.vala"
		geary_timeout_manager_reset (_data_->_tmp18_);
#line 646 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp20_ = _data_->loaded;
#line 646 "../src/client/conversation-viewer/conversation-email.vala"
		if (_data_->_tmp20_ != NULL) {
#line 646 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp21_ = _data_->self->priv->load_cancellable;
#line 646 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp19_ = !g_cancellable_is_cancelled (_data_->_tmp21_);
#line 4139 "conversation-email.c"
		} else {
#line 646 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp19_ = FALSE;
#line 4143 "conversation-email.c"
		}
#line 646 "../src/client/conversation-viewer/conversation-email.vala"
		if (_data_->_tmp19_) {
#line 4147 "conversation-email.c"
			{
#line 648 "../src/client/conversation-viewer/conversation-email.vala"
				_data_->_tmp22_ = _data_->loaded;
#line 648 "../src/client/conversation-viewer/conversation-email.vala"
				conversation_email_set_email (_data_->self, _data_->_tmp22_);
#line 649 "../src/client/conversation-viewer/conversation-email.vala"
				_data_->_state_ = 2;
#line 649 "../src/client/conversation-viewer/conversation-email.vala"
				conversation_email_update_body (_data_->self, conversation_email_fetch_remote_body_ready, _data_);
#line 649 "../src/client/conversation-viewer/conversation-email.vala"
				return FALSE;
#line 4159 "conversation-email.c"
				_state_2:
#line 649 "../src/client/conversation-viewer/conversation-email.vala"
				conversation_email_update_body_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 649 "../src/client/conversation-viewer/conversation-email.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 649 "../src/client/conversation-viewer/conversation-email.vala"
					if (g_error_matches (_data_->_inner_error0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 4167 "conversation-email.c"
						goto __catch1_g_io_error_cancelled;
					}
					goto __catch1_g_error;
				}
			}
			goto __finally1;
			__catch1_g_io_error_cancelled:
			{
#line 647 "../src/client/conversation-viewer/conversation-email.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 4178 "conversation-email.c"
			}
			goto __finally1;
			__catch1_g_error:
			{
#line 647 "../src/client/conversation-viewer/conversation-email.vala"
				_data_->_vala1_err = _data_->_inner_error0_;
#line 647 "../src/client/conversation-viewer/conversation-email.vala"
				_data_->_inner_error0_ = NULL;
#line 653 "../src/client/conversation-viewer/conversation-email.vala"
				_data_->_tmp23_ = _data_->_vala1_err;
#line 653 "../src/client/conversation-viewer/conversation-email.vala"
				_data_->_tmp24_ = _data_->_tmp23_->message;
#line 653 "../src/client/conversation-viewer/conversation-email.vala"
				g_debug ("conversation-email.vala:653: Remote message update failed: %s", _data_->_tmp24_);
#line 654 "../src/client/conversation-viewer/conversation-email.vala"
				_data_->_tmp25_ = _data_->_vala1_err;
#line 654 "../src/client/conversation-viewer/conversation-email.vala"
				conversation_email_handle_load_failure (_data_->self, _data_->_tmp25_);
#line 647 "../src/client/conversation-viewer/conversation-email.vala"
				_g_error_free0 (_data_->_vala1_err);
#line 4199 "conversation-email.c"
			}
			__finally1:
#line 647 "../src/client/conversation-viewer/conversation-email.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 647 "../src/client/conversation-viewer/conversation-email.vala"
				_g_object_unref0 (_data_->loaded);
#line 647 "../src/client/conversation-viewer/conversation-email.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 647 "../src/client/conversation-viewer/conversation-email.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 647 "../src/client/conversation-viewer/conversation-email.vala"
				g_object_unref (_data_->_async_result);
#line 647 "../src/client/conversation-viewer/conversation-email.vala"
				return FALSE;
#line 4214 "conversation-email.c"
			}
		}
#line 621 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (_data_->loaded);
#line 4219 "conversation-email.c"
	} else {
#line 658 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp26_ = _data_->self->priv->body_loading_timeout;
#line 658 "../src/client/conversation-viewer/conversation-email.vala"
		geary_timeout_manager_reset (_data_->_tmp26_);
#line 659 "../src/client/conversation-viewer/conversation-email.vala"
		conversation_email_handle_load_offline (_data_->self);
#line 4227 "conversation-email.c"
	}
#line 620 "../src/client/conversation-viewer/conversation-email.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 620 "../src/client/conversation-viewer/conversation-email.vala"
	if (_data_->_state_ != 0) {
#line 620 "../src/client/conversation-viewer/conversation-email.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 620 "../src/client/conversation-viewer/conversation-email.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4237 "conversation-email.c"
		}
	}
#line 620 "../src/client/conversation-viewer/conversation-email.vala"
	g_object_unref (_data_->_async_result);
#line 620 "../src/client/conversation-viewer/conversation-email.vala"
	return FALSE;
#line 4244 "conversation-email.c"
}

static void
conversation_email_update_body_data_free (gpointer _data)
{
	ConversationEmailUpdateBodyData* _data_;
	_data_ = _data;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (_data_->self);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_slice_free (ConversationEmailUpdateBodyData, _data_);
#line 4256 "conversation-email.c"
}

static void
conversation_email_update_body (ConversationEmail* self,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
	ConversationEmailUpdateBodyData* _data_;
	ConversationEmail* _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_ = g_slice_new0 (ConversationEmailUpdateBodyData);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_task_set_task_data (_data_->_async_result, _data_, conversation_email_update_body_data_free);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->self = _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_update_body_co (_data_);
#line 4280 "conversation-email.c"
}

static void
conversation_email_update_body_finish (ConversationEmail* self,
                                       GAsyncResult* _res_,
                                       GError** error)
{
	ConversationEmailUpdateBodyData* _data_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	if (NULL == _data_) {
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		return;
#line 4295 "conversation-email.c"
	}
}

static void
conversation_email_update_body_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_)
{
	ConversationEmailUpdateBodyData* _data_;
#line 691 "../src/client/conversation-viewer/conversation-email.vala"
	_data_ = _user_data_;
#line 691 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_source_object_ = source_object;
#line 691 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_res_ = _res_;
#line 691 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_update_body_co (_data_);
#line 4313 "conversation-email.c"
}

static gboolean
conversation_email_update_body_co (ConversationEmailUpdateBodyData* _data_)
{
#line 663 "../src/client/conversation-viewer/conversation-email.vala"
	switch (_data_->_state_) {
#line 663 "../src/client/conversation-viewer/conversation-email.vala"
		case 0:
#line 4323 "conversation-email.c"
		goto _state_0;
#line 663 "../src/client/conversation-viewer/conversation-email.vala"
		case 1:
#line 4327 "conversation-email.c"
		goto _state_1;
#line 663 "../src/client/conversation-viewer/conversation-email.vala"
		case 2:
#line 4331 "conversation-email.c"
		goto _state_2;
		default:
#line 663 "../src/client/conversation-viewer/conversation-email.vala"
		g_assert_not_reached ();
#line 4336 "conversation-email.c"
	}
	_state_0:
#line 665 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp0_ = _data_->self->priv->_email;
#line 665 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp1_ = geary_email_get_message (_data_->_tmp0_, &_data_->_inner_error0_);
#line 665 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->message = _data_->_tmp1_;
#line 665 "../src/client/conversation-viewer/conversation-email.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 665 "../src/client/conversation-viewer/conversation-email.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 665 "../src/client/conversation-viewer/conversation-email.vala"
		g_object_unref (_data_->_async_result);
#line 665 "../src/client/conversation-viewer/conversation-email.vala"
		return FALSE;
#line 4353 "conversation-email.c"
	}
#line 669 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp2_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEARY_MEMORY_TYPE_BUFFER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 669 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->cid_resources = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, GEE_TYPE_MAP, GeeMap);
#line 4359 "conversation-email.c"
	{
#line 671 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp3_ = _data_->self->priv->_email;
#line 671 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp4_ = geary_email_get_attachments (_data_->_tmp3_);
#line 671 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 671 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_attachment_list = _data_->_tmp5_;
#line 671 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp6_ = _data_->_attachment_list;
#line 671 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp7_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, GEE_TYPE_COLLECTION, GeeCollection));
#line 671 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 671 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_attachment_size = _data_->_tmp8_;
#line 671 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_attachment_index = -1;
#line 671 "../src/client/conversation-viewer/conversation-email.vala"
		while (TRUE) {
#line 671 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_attachment_index = _data_->_attachment_index + 1;
#line 671 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp9_ = _data_->_attachment_index;
#line 671 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp10_ = _data_->_attachment_size;
#line 671 "../src/client/conversation-viewer/conversation-email.vala"
			if (!(_data_->_tmp9_ < _data_->_tmp10_)) {
#line 671 "../src/client/conversation-viewer/conversation-email.vala"
				break;
#line 4391 "conversation-email.c"
			}
#line 671 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp11_ = _data_->_attachment_list;
#line 671 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp12_ = gee_list_get (_data_->_tmp11_, _data_->_attachment_index);
#line 671 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->attachment = (GearyAttachment*) _data_->_tmp12_;
#line 675 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp13_ = _data_->self->priv->displayed_attachments;
#line 675 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp14_ = _data_->attachment;
#line 675 "../src/client/conversation-viewer/conversation-email.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp13_, GEE_TYPE_COLLECTION, GeeCollection), _data_->_tmp14_);
#line 677 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp15_ = _data_->attachment;
#line 677 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp16_ = geary_attachment_get_content_id (_data_->_tmp15_);
#line 677 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp17_ = _data_->_tmp16_;
#line 677 "../src/client/conversation-viewer/conversation-email.vala"
			if (_data_->_tmp17_ != NULL) {
#line 4413 "conversation-email.c"
				{
#line 680 "../src/client/conversation-viewer/conversation-email.vala"
					_data_->_tmp19_ = _data_->attachment;
#line 680 "../src/client/conversation-viewer/conversation-email.vala"
					_data_->_tmp20_ = geary_attachment_get_file (_data_->_tmp19_);
#line 680 "../src/client/conversation-viewer/conversation-email.vala"
					_data_->_tmp21_ = _data_->_tmp20_;
#line 680 "../src/client/conversation-viewer/conversation-email.vala"
					_data_->_tmp22_ = geary_memory_file_buffer_new (_data_->_tmp21_, TRUE, &_data_->_inner_error0_);
#line 680 "../src/client/conversation-viewer/conversation-email.vala"
					_data_->_tmp18_ = _data_->_tmp22_;
#line 680 "../src/client/conversation-viewer/conversation-email.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 4427 "conversation-email.c"
						goto __catch0_g_error;
					}
#line 679 "../src/client/conversation-viewer/conversation-email.vala"
					_data_->_tmp23_ = _data_->cid_resources;
#line 679 "../src/client/conversation-viewer/conversation-email.vala"
					_data_->_tmp24_ = _data_->attachment;
#line 679 "../src/client/conversation-viewer/conversation-email.vala"
					_data_->_tmp25_ = geary_attachment_get_content_id (_data_->_tmp24_);
#line 679 "../src/client/conversation-viewer/conversation-email.vala"
					_data_->_tmp26_ = _data_->_tmp25_;
#line 679 "../src/client/conversation-viewer/conversation-email.vala"
					gee_map_set (_data_->_tmp23_, _data_->_tmp26_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp18_, GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBuffer));
#line 678 "../src/client/conversation-viewer/conversation-email.vala"
					_g_object_unref0 (_data_->_tmp18_);
#line 4442 "conversation-email.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
#line 678 "../src/client/conversation-viewer/conversation-email.vala"
					_data_->err = _data_->_inner_error0_;
#line 678 "../src/client/conversation-viewer/conversation-email.vala"
					_data_->_inner_error0_ = NULL;
#line 682 "../src/client/conversation-viewer/conversation-email.vala"
					_data_->_tmp27_ = _data_->err;
#line 682 "../src/client/conversation-viewer/conversation-email.vala"
					_data_->_tmp28_ = _data_->_tmp27_->message;
#line 682 "../src/client/conversation-viewer/conversation-email.vala"
					g_debug ("conversation-email.vala:682: Could not open attachment: %s", _data_->_tmp28_);
#line 678 "../src/client/conversation-viewer/conversation-email.vala"
					_g_error_free0 (_data_->err);
#line 4459 "conversation-email.c"
				}
				__finally0:
#line 678 "../src/client/conversation-viewer/conversation-email.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 678 "../src/client/conversation-viewer/conversation-email.vala"
					g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 678 "../src/client/conversation-viewer/conversation-email.vala"
					_g_object_unref0 (_data_->attachment);
#line 678 "../src/client/conversation-viewer/conversation-email.vala"
					_g_object_unref0 (_data_->cid_resources);
#line 678 "../src/client/conversation-viewer/conversation-email.vala"
					_g_object_unref0 (_data_->message);
#line 678 "../src/client/conversation-viewer/conversation-email.vala"
					g_object_unref (_data_->_async_result);
#line 678 "../src/client/conversation-viewer/conversation-email.vala"
					return FALSE;
#line 4476 "conversation-email.c"
				}
			}
#line 671 "../src/client/conversation-viewer/conversation-email.vala"
			_g_object_unref0 (_data_->attachment);
#line 4481 "conversation-email.c"
		}
	}
#line 686 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp29_ = _data_->self->priv->attachments_button;
#line 686 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp30_ = _data_->self->priv->displayed_attachments;
#line 686 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp31_ = gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp30_, GEE_TYPE_COLLECTION, GeeCollection));
#line 686 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp32_ = _data_->_tmp31_;
#line 686 "../src/client/conversation-viewer/conversation-email.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp29_, gtk_widget_get_type (), GtkWidget), !_data_->_tmp32_);
#line 690 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp33_ = _data_->self->priv->_primary_message;
#line 690 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp34_ = _data_->cid_resources;
#line 690 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_message_add_internal_resources (_data_->_tmp33_, _data_->_tmp34_);
#line 691 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp35_ = _data_->self->priv->_primary_message;
#line 691 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp36_ = _data_->message;
#line 691 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp37_ = _data_->self->priv->load_cancellable;
#line 691 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_state_ = 1;
#line 691 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_message_load_message_body (_data_->_tmp35_, _data_->_tmp36_, _data_->_tmp37_, conversation_email_update_body_ready, _data_);
#line 691 "../src/client/conversation-viewer/conversation-email.vala"
	return FALSE;
#line 4512 "conversation-email.c"
	_state_1:
#line 691 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_message_load_message_body_finish (_data_->_tmp35_, _data_->_res_, &_data_->_inner_error0_);
#line 691 "../src/client/conversation-viewer/conversation-email.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 691 "../src/client/conversation-viewer/conversation-email.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 691 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (_data_->cid_resources);
#line 691 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (_data_->message);
#line 691 "../src/client/conversation-viewer/conversation-email.vala"
		g_object_unref (_data_->_async_result);
#line 691 "../src/client/conversation-viewer/conversation-email.vala"
		return FALSE;
#line 4528 "conversation-email.c"
	}
#line 695 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp38_ = _data_->message;
#line 695 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp39_ = geary_rf_c822_message_get_sub_messages (_data_->_tmp38_, &_data_->_inner_error0_);
#line 695 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->sub_messages = _data_->_tmp39_;
#line 695 "../src/client/conversation-viewer/conversation-email.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 695 "../src/client/conversation-viewer/conversation-email.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 695 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (_data_->cid_resources);
#line 695 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (_data_->message);
#line 695 "../src/client/conversation-viewer/conversation-email.vala"
		g_object_unref (_data_->_async_result);
#line 695 "../src/client/conversation-viewer/conversation-email.vala"
		return FALSE;
#line 4548 "conversation-email.c"
	}
#line 696 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp40_ = _data_->sub_messages;
#line 696 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp41_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp40_, GEE_TYPE_COLLECTION, GeeCollection));
#line 696 "../src/client/conversation-viewer/conversation-email.vala"
	_data_->_tmp42_ = _data_->_tmp41_;
#line 696 "../src/client/conversation-viewer/conversation-email.vala"
	if (_data_->_tmp42_ > 0) {
#line 697 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp43_ = _data_->self->priv->_primary_message;
#line 697 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp44_ = conversation_message_get_body_container (_data_->_tmp43_);
#line 697 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp45_ = _data_->_tmp44_;
#line 697 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp46_ = _data_->self->priv->sub_messages;
#line 697 "../src/client/conversation-viewer/conversation-email.vala"
		gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp45_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp46_, gtk_widget_get_type (), GtkWidget));
#line 4568 "conversation-email.c"
	}
	{
#line 699 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp47_ = _data_->sub_messages;
#line 699 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_sub_message_list = _data_->_tmp47_;
#line 699 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp48_ = _data_->_sub_message_list;
#line 699 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp49_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp48_, GEE_TYPE_COLLECTION, GeeCollection));
#line 699 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_tmp50_ = _data_->_tmp49_;
#line 699 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_sub_message_size = _data_->_tmp50_;
#line 699 "../src/client/conversation-viewer/conversation-email.vala"
		_data_->_sub_message_index = -1;
#line 699 "../src/client/conversation-viewer/conversation-email.vala"
		while (TRUE) {
#line 699 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_sub_message_index = _data_->_sub_message_index + 1;
#line 699 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp51_ = _data_->_sub_message_index;
#line 699 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp52_ = _data_->_sub_message_size;
#line 699 "../src/client/conversation-viewer/conversation-email.vala"
			if (!(_data_->_tmp51_ < _data_->_tmp52_)) {
#line 699 "../src/client/conversation-viewer/conversation-email.vala"
				break;
#line 4597 "conversation-email.c"
			}
#line 699 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp53_ = _data_->_sub_message_list;
#line 699 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp54_ = gee_list_get (_data_->_tmp53_, _data_->_sub_message_index);
#line 699 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->sub_message = (GearyRFC822Message*) _data_->_tmp54_;
#line 700 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp55_ = _data_->sub_message;
#line 700 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp56_ = _data_->self->priv->_email;
#line 700 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp57_ = _data_->self->priv->contacts;
#line 700 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp58_ = _data_->self->priv->config;
#line 700 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp59_ = conversation_message_new_from_message (_data_->_tmp55_, geary_trillian_is_certain (geary_email_load_remote_images (_data_->_tmp56_)), _data_->_tmp57_, _data_->_tmp58_);
#line 700 "../src/client/conversation-viewer/conversation-email.vala"
			g_object_ref_sink (_data_->_tmp59_);
#line 700 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->attached_message = _data_->_tmp59_;
#line 707 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp60_ = _data_->attached_message;
#line 707 "../src/client/conversation-viewer/conversation-email.vala"
			conversation_email_connect_message_view_signals (_data_->self, _data_->_tmp60_);
#line 708 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp61_ = _data_->attached_message;
#line 708 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp62_ = _data_->cid_resources;
#line 708 "../src/client/conversation-viewer/conversation-email.vala"
			conversation_message_add_internal_resources (_data_->_tmp61_, _data_->_tmp62_);
#line 709 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp63_ = _data_->self->priv->sub_messages;
#line 709 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp64_ = _data_->attached_message;
#line 709 "../src/client/conversation-viewer/conversation-email.vala"
			gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp63_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp64_, gtk_widget_get_type (), GtkWidget));
#line 710 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp65_ = _data_->self->priv->_attached_messages;
#line 710 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp66_ = _data_->attached_message;
#line 710 "../src/client/conversation-viewer/conversation-email.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp65_, GEE_TYPE_COLLECTION, GeeCollection), _data_->_tmp66_);
#line 711 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp67_ = _data_->attached_message;
#line 711 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp68_ = _data_->self->priv->load_cancellable;
#line 711 "../src/client/conversation-viewer/conversation-email.vala"
			conversation_message_load_contacts (_data_->_tmp67_, _data_->_tmp68_, NULL, NULL);
#line 712 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp69_ = _data_->attached_message;
#line 712 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp70_ = _data_->sub_message;
#line 712 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_tmp71_ = _data_->self->priv->load_cancellable;
#line 712 "../src/client/conversation-viewer/conversation-email.vala"
			_data_->_state_ = 2;
#line 712 "../src/client/conversation-viewer/conversation-email.vala"
			conversation_message_load_message_body (_data_->_tmp69_, _data_->_tmp70_, _data_->_tmp71_, conversation_email_update_body_ready, _data_);
#line 712 "../src/client/conversation-viewer/conversation-email.vala"
			return FALSE;
#line 4659 "conversation-email.c"
			_state_2:
#line 712 "../src/client/conversation-viewer/conversation-email.vala"
			conversation_message_load_message_body_finish (_data_->_tmp69_, _data_->_res_, &_data_->_inner_error0_);
#line 712 "../src/client/conversation-viewer/conversation-email.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 712 "../src/client/conversation-viewer/conversation-email.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 712 "../src/client/conversation-viewer/conversation-email.vala"
				_g_object_unref0 (_data_->attached_message);
#line 712 "../src/client/conversation-viewer/conversation-email.vala"
				_g_object_unref0 (_data_->sub_message);
#line 712 "../src/client/conversation-viewer/conversation-email.vala"
				_g_object_unref0 (_data_->sub_messages);
#line 712 "../src/client/conversation-viewer/conversation-email.vala"
				_g_object_unref0 (_data_->cid_resources);
#line 712 "../src/client/conversation-viewer/conversation-email.vala"
				_g_object_unref0 (_data_->message);
#line 712 "../src/client/conversation-viewer/conversation-email.vala"
				g_object_unref (_data_->_async_result);
#line 712 "../src/client/conversation-viewer/conversation-email.vala"
				return FALSE;
#line 4681 "conversation-email.c"
			}
#line 715 "../src/client/conversation-viewer/conversation-email.vala"
			if (!_data_->self->is_collapsed) {
#line 716 "../src/client/conversation-viewer/conversation-email.vala"
				_data_->_tmp72_ = _data_->attached_message;
#line 716 "../src/client/conversation-viewer/conversation-email.vala"
				conversation_message_show_message_body (_data_->_tmp72_, FALSE);
#line 4689 "conversation-email.c"
			}
#line 699 "../src/client/conversation-viewer/conversation-email.vala"
			_g_object_unref0 (_data_->attached_message);
#line 699 "../src/client/conversation-viewer/conversation-email.vala"
			_g_object_unref0 (_data_->sub_message);
#line 4695 "conversation-email.c"
		}
	}
#line 663 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (_data_->sub_messages);
#line 663 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (_data_->cid_resources);
#line 663 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (_data_->message);
#line 663 "../src/client/conversation-viewer/conversation-email.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 663 "../src/client/conversation-viewer/conversation-email.vala"
	if (_data_->_state_ != 0) {
#line 663 "../src/client/conversation-viewer/conversation-email.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 663 "../src/client/conversation-viewer/conversation-email.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4712 "conversation-email.c"
		}
	}
#line 663 "../src/client/conversation-viewer/conversation-email.vala"
	g_object_unref (_data_->_async_result);
#line 663 "../src/client/conversation-viewer/conversation-email.vala"
	return FALSE;
#line 4719 "conversation-email.c"
}

static void
conversation_email_update_email_state (ConversationEmail* self)
{
	GtkStyleContext* style = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp6_;
	gboolean _tmp7_;
#line 721 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 722 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 722 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 722 "../src/client/conversation-viewer/conversation-email.vala"
	style = _tmp1_;
#line 724 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp2_ = conversation_email_get_is_unread (self);
#line 724 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp3_ = _tmp2_;
#line 724 "../src/client/conversation-viewer/conversation-email.vala"
	if (_tmp3_) {
#line 4746 "conversation-email.c"
		GtkStyleContext* _tmp4_;
#line 725 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp4_ = style;
#line 725 "../src/client/conversation-viewer/conversation-email.vala"
		gtk_style_context_add_class (_tmp4_, CONVERSATION_EMAIL_UNREAD_CLASS);
#line 4752 "conversation-email.c"
	} else {
		GtkStyleContext* _tmp5_;
#line 727 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp5_ = style;
#line 727 "../src/client/conversation-viewer/conversation-email.vala"
		gtk_style_context_remove_class (_tmp5_, CONVERSATION_EMAIL_UNREAD_CLASS);
#line 4759 "conversation-email.c"
	}
#line 730 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp6_ = conversation_email_get_is_starred (self);
#line 730 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp7_ = _tmp6_;
#line 730 "../src/client/conversation-viewer/conversation-email.vala"
	if (_tmp7_) {
#line 4767 "conversation-email.c"
		GtkStyleContext* _tmp8_;
		GtkButton* _tmp9_;
		GtkButton* _tmp10_;
#line 731 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp8_ = style;
#line 731 "../src/client/conversation-viewer/conversation-email.vala"
		gtk_style_context_add_class (_tmp8_, CONVERSATION_EMAIL_STARRED_CLASS);
#line 732 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp9_ = self->priv->star_button;
#line 732 "../src/client/conversation-viewer/conversation-email.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_widget_get_type (), GtkWidget));
#line 733 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp10_ = self->priv->unstar_button;
#line 733 "../src/client/conversation-viewer/conversation-email.vala"
		gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_widget_get_type (), GtkWidget));
#line 4783 "conversation-email.c"
	} else {
		GtkStyleContext* _tmp11_;
		GtkButton* _tmp12_;
		GtkButton* _tmp13_;
#line 735 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp11_ = style;
#line 735 "../src/client/conversation-viewer/conversation-email.vala"
		gtk_style_context_remove_class (_tmp11_, CONVERSATION_EMAIL_STARRED_CLASS);
#line 736 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp12_ = self->priv->star_button;
#line 736 "../src/client/conversation-viewer/conversation-email.vala"
		gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_widget_get_type (), GtkWidget));
#line 737 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp13_ = self->priv->unstar_button;
#line 737 "../src/client/conversation-viewer/conversation-email.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_widget_get_type (), GtkWidget));
#line 4800 "conversation-email.c"
	}
#line 740 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_update_email_menu (self);
#line 721 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (style);
#line 4806 "conversation-email.c"
}

static Block87Data*
block87_data_ref (Block87Data* _data87_)
{
#line 744 "../src/client/conversation-viewer/conversation-email.vala"
	g_atomic_int_inc (&_data87_->_ref_count_);
#line 744 "../src/client/conversation-viewer/conversation-email.vala"
	return _data87_;
#line 4816 "conversation-email.c"
}

static void
block87_data_unref (void * _userdata_)
{
	Block87Data* _data87_;
	_data87_ = (Block87Data*) _userdata_;
#line 744 "../src/client/conversation-viewer/conversation-email.vala"
	if (g_atomic_int_dec_and_test (&_data87_->_ref_count_)) {
#line 4826 "conversation-email.c"
		ConversationEmail* self;
#line 744 "../src/client/conversation-viewer/conversation-email.vala"
		self = _data87_->self;
#line 744 "../src/client/conversation-viewer/conversation-email.vala"
		_g_variant_unref0 (_data87_->email_target);
#line 744 "../src/client/conversation-viewer/conversation-email.vala"
		_data87_->blacklist = (_vala_array_free (_data87_->blacklist, _data87_->blacklist_length1, (GDestroyNotify) g_free), NULL);
#line 744 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (self);
#line 744 "../src/client/conversation-viewer/conversation-email.vala"
		g_slice_free (Block87Data, _data87_);
#line 4838 "conversation-email.c"
	}
}

static void
_conversation_email_on_shift_changed_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self)
{
#line 765 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_on_shift_changed ((ConversationEmail*) self);
#line 4849 "conversation-email.c"
}

static void
_vala_array_add16 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 771 "../src/client/conversation-viewer/conversation-email.vala"
	if ((*length) == (*size)) {
#line 771 "../src/client/conversation-viewer/conversation-email.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 771 "../src/client/conversation-viewer/conversation-email.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 4864 "conversation-email.c"
	}
#line 771 "../src/client/conversation-viewer/conversation-email.vala"
	(*array)[(*length)++] = value;
#line 771 "../src/client/conversation-viewer/conversation-email.vala"
	(*array)[*length] = NULL;
#line 4870 "conversation-email.c"
}

static void
_vala_array_add17 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 775 "../src/client/conversation-viewer/conversation-email.vala"
	if ((*length) == (*size)) {
#line 775 "../src/client/conversation-viewer/conversation-email.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 775 "../src/client/conversation-viewer/conversation-email.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 4885 "conversation-email.c"
	}
#line 775 "../src/client/conversation-viewer/conversation-email.vala"
	(*array)[(*length)++] = value;
#line 775 "../src/client/conversation-viewer/conversation-email.vala"
	(*array)[*length] = NULL;
#line 4891 "conversation-email.c"
}

static void
_vala_array_add18 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 780 "../src/client/conversation-viewer/conversation-email.vala"
	if ((*length) == (*size)) {
#line 780 "../src/client/conversation-viewer/conversation-email.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 780 "../src/client/conversation-viewer/conversation-email.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 4906 "conversation-email.c"
	}
#line 780 "../src/client/conversation-viewer/conversation-email.vala"
	(*array)[(*length)++] = value;
#line 780 "../src/client/conversation-viewer/conversation-email.vala"
	(*array)[*length] = NULL;
#line 4912 "conversation-email.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 799 "../src/client/conversation-viewer/conversation-email.vala"
	for (i = 0; i < stack_length; i++) {
#line 799 "../src/client/conversation-viewer/conversation-email.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 799 "../src/client/conversation-viewer/conversation-email.vala"
			return TRUE;
#line 4927 "conversation-email.c"
		}
	}
#line 799 "../src/client/conversation-viewer/conversation-email.vala"
	return FALSE;
#line 4932 "conversation-email.c"
}

static gboolean
___lambda104_ (Block87Data* _data87_,
               GMenuModel* menu,
               GMenuModel* submenu,
               const gchar* action,
               GMenuItem* item)
{
	ConversationEmail* self;
	gboolean accept = FALSE;
	gboolean _tmp0_ = FALSE;
	GMenuModel* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GMenuModel* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean result;
#line 791 "../src/client/conversation-viewer/conversation-email.vala"
	self = _data87_->self;
#line 791 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (menu, g_menu_model_get_type ()), FALSE);
#line 791 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_val_if_fail ((submenu == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (submenu, g_menu_model_get_type ()), FALSE);
#line 791 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_val_if_fail ((item == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (item, g_menu_item_get_type ()), FALSE);
#line 792 "../src/client/conversation-viewer/conversation-email.vala"
	accept = TRUE;
#line 793 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp1_ = conversation_email_email_menu_trash_section;
#line 793 "../src/client/conversation-viewer/conversation-email.vala"
	if (submenu == _tmp1_) {
#line 793 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp0_ = !_data87_->show_trash;
#line 4966 "conversation-email.c"
	} else {
#line 793 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp0_ = FALSE;
#line 4970 "conversation-email.c"
	}
#line 793 "../src/client/conversation-viewer/conversation-email.vala"
	if (_tmp0_) {
#line 794 "../src/client/conversation-viewer/conversation-email.vala"
		accept = FALSE;
#line 4976 "conversation-email.c"
	}
#line 796 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp3_ = conversation_email_email_menu_delete_section;
#line 796 "../src/client/conversation-viewer/conversation-email.vala"
	if (submenu == _tmp3_) {
#line 796 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp2_ = !_data87_->show_delete;
#line 4984 "conversation-email.c"
	} else {
#line 796 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp2_ = FALSE;
#line 4988 "conversation-email.c"
	}
#line 796 "../src/client/conversation-viewer/conversation-email.vala"
	if (_tmp2_) {
#line 797 "../src/client/conversation-viewer/conversation-email.vala"
		accept = FALSE;
#line 4994 "conversation-email.c"
	}
#line 799 "../src/client/conversation-viewer/conversation-email.vala"
	if (action != NULL) {
#line 4998 "conversation-email.c"
		gchar** _tmp5_;
		gint _tmp5__length1;
#line 799 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp5_ = _data87_->blacklist;
#line 799 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp5__length1 = _data87_->blacklist_length1;
#line 799 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp4_ = !_vala_string_array_contains (_tmp5_, _tmp5__length1, action);
#line 5007 "conversation-email.c"
	} else {
#line 799 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp4_ = FALSE;
#line 5011 "conversation-email.c"
	}
#line 799 "../src/client/conversation-viewer/conversation-email.vala"
	if (_tmp4_) {
#line 5015 "conversation-email.c"
		GVariant* _tmp6_;
#line 800 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp6_ = _data87_->email_target;
#line 800 "../src/client/conversation-viewer/conversation-email.vala"
		g_menu_item_set_action_and_target_value (item, action, _tmp6_);
#line 5021 "conversation-email.c"
	}
#line 804 "../src/client/conversation-viewer/conversation-email.vala"
	result = accept;
#line 804 "../src/client/conversation-viewer/conversation-email.vala"
	return result;
#line 5027 "conversation-email.c"
}

static gboolean
____lambda104__util_gtk_menu_visitor (GMenuModel* existing_menu,
                                      GMenuModel* existing_child_menu,
                                      const gchar* existing_action,
                                      GMenuItem* new_item,
                                      gpointer self)
{
	gboolean result;
	result = ___lambda104_ (self, existing_menu, existing_child_menu, existing_action, new_item);
#line 789 "../src/client/conversation-viewer/conversation-email.vala"
	return result;
#line 5041 "conversation-email.c"
}

static void
conversation_email_update_email_menu (ConversationEmail* self)
{
	GtkMenuButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 743 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 744 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = self->priv->email_menubutton;
#line 744 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp1_ = gtk_toggle_button_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_toggle_button_get_type (), GtkToggleButton));
#line 744 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp2_ = _tmp1_;
#line 744 "../src/client/conversation-viewer/conversation-email.vala"
	if (_tmp2_) {
#line 5060 "conversation-email.c"
		Block87Data* _data87_;
		gboolean in_base_folder = FALSE;
		GearyAppConversation* _tmp3_;
		GearyEmail* _tmp4_;
		GearyEmailIdentifier* _tmp5_;
		GearyEmailIdentifier* _tmp6_;
		gboolean _tmp7_ = FALSE;
		gboolean supports_trash = FALSE;
		gboolean _tmp11_ = FALSE;
		gboolean supports_delete = FALSE;
		gboolean is_shift_down = FALSE;
		ApplicationMainWindow* main = NULL;
		GtkWidget* _tmp15_;
		ApplicationMainWindow* _tmp16_;
		ApplicationMainWindow* _tmp17_;
		gchar** _tmp22_;
		gboolean _tmp23_;
		gboolean _tmp24_;
		gboolean _tmp28_ = FALSE;
		gboolean _tmp29_ = FALSE;
		GearyEmail* _tmp30_;
		GearyEmailIdentifier* _tmp31_;
		GearyEmailIdentifier* _tmp32_;
		GVariant* _tmp33_;
		GMenu* new_model = NULL;
		GMenuModel* _tmp34_;
		GMenu* _tmp35_;
		GtkMenuButton* _tmp36_;
		GtkPopover* _tmp37_;
		GtkPopover* _tmp38_;
		GMenu* _tmp39_;
		GtkMenuButton* _tmp40_;
		GtkPopover* _tmp41_;
		GtkPopover* _tmp42_;
#line 744 "../src/client/conversation-viewer/conversation-email.vala"
		_data87_ = g_slice_new0 (Block87Data);
#line 744 "../src/client/conversation-viewer/conversation-email.vala"
		_data87_->_ref_count_ = 1;
#line 744 "../src/client/conversation-viewer/conversation-email.vala"
		_data87_->self = g_object_ref (self);
#line 745 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp3_ = self->conversation;
#line 745 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp4_ = self->priv->_email;
#line 745 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp5_ = geary_email_get_id (_tmp4_);
#line 745 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp6_ = _tmp5_;
#line 745 "../src/client/conversation-viewer/conversation-email.vala"
		in_base_folder = geary_app_conversation_is_in_base_folder (_tmp3_, _tmp6_);
#line 748 "../src/client/conversation-viewer/conversation-email.vala"
		if (in_base_folder) {
#line 5113 "conversation-email.c"
			GearyAppConversation* _tmp8_;
			GearyFolder* _tmp9_;
			GearyFolder* _tmp10_;
#line 750 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp8_ = self->conversation;
#line 750 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp9_ = geary_app_conversation_get_base_folder (_tmp8_);
#line 750 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp10_ = _tmp9_;
#line 750 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp7_ = application_controller_does_folder_support_trash (_tmp10_);
#line 5125 "conversation-email.c"
		} else {
#line 749 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp7_ = FALSE;
#line 5129 "conversation-email.c"
		}
#line 748 "../src/client/conversation-viewer/conversation-email.vala"
		supports_trash = _tmp7_;
#line 754 "../src/client/conversation-viewer/conversation-email.vala"
		if (in_base_folder) {
#line 5135 "conversation-email.c"
			GearyAppConversation* _tmp12_;
			GearyFolder* _tmp13_;
			GearyFolder* _tmp14_;
#line 756 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp12_ = self->conversation;
#line 756 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp13_ = geary_app_conversation_get_base_folder (_tmp12_);
#line 756 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp14_ = _tmp13_;
#line 756 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp11_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, GEARY_FOLDER_SUPPORT_TYPE_REMOVE);
#line 5147 "conversation-email.c"
		} else {
#line 755 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp11_ = FALSE;
#line 5151 "conversation-email.c"
		}
#line 754 "../src/client/conversation-viewer/conversation-email.vala"
		supports_delete = _tmp11_;
#line 758 "../src/client/conversation-viewer/conversation-email.vala"
		is_shift_down = FALSE;
#line 759 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp15_ = gtk_widget_get_toplevel (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 759 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp16_ = _g_object_ref0 (APPLICATION_IS_MAIN_WINDOW (_tmp15_) ? ((ApplicationMainWindow*) _tmp15_) : NULL);
#line 759 "../src/client/conversation-viewer/conversation-email.vala"
		main = _tmp16_;
#line 760 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp17_ = main;
#line 760 "../src/client/conversation-viewer/conversation-email.vala"
		if (_tmp17_ != NULL) {
#line 5167 "conversation-email.c"
			ApplicationMainWindow* _tmp18_;
			gboolean _tmp19_;
			gboolean _tmp20_;
#line 761 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp18_ = main;
#line 761 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp19_ = application_main_window_get_is_shift_down (_tmp18_);
#line 761 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp20_ = _tmp19_;
#line 761 "../src/client/conversation-viewer/conversation-email.vala"
			is_shift_down = _tmp20_;
#line 763 "../src/client/conversation-viewer/conversation-email.vala"
			if (!self->priv->shift_handler_installed) {
#line 5181 "conversation-email.c"
				ApplicationMainWindow* _tmp21_;
#line 764 "../src/client/conversation-viewer/conversation-email.vala"
				self->priv->shift_handler_installed = TRUE;
#line 765 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp21_ = main;
#line 765 "../src/client/conversation-viewer/conversation-email.vala"
				g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, G_TYPE_OBJECT, GObject), "notify::is-shift-down", (GCallback) _conversation_email_on_shift_changed_g_object_notify, self, 0);
#line 5189 "conversation-email.c"
			}
		}
#line 769 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp22_ = g_new0 (gchar*, 0 + 1);
#line 769 "../src/client/conversation-viewer/conversation-email.vala"
		_data87_->blacklist = _tmp22_;
#line 769 "../src/client/conversation-viewer/conversation-email.vala"
		_data87_->blacklist_length1 = 0;
#line 769 "../src/client/conversation-viewer/conversation-email.vala"
		_data87_->_blacklist_size_ = _data87_->blacklist_length1;
#line 770 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp23_ = conversation_email_get_is_unread (self);
#line 770 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp24_ = _tmp23_;
#line 770 "../src/client/conversation-viewer/conversation-email.vala"
		if (_tmp24_) {
#line 5206 "conversation-email.c"
			gchar* _tmp25_;
			gchar* _tmp26_;
#line 771 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp25_ = g_strdup (CONVERSATION_LIST_BOX_EMAIL_ACTION_GROUP_NAME "." CONVERSATION_LIST_BOX_ACTION_MARK_UNREAD);
#line 771 "../src/client/conversation-viewer/conversation-email.vala"
			_vala_array_add16 (&_data87_->blacklist, &_data87_->blacklist_length1, &_data87_->_blacklist_size_, _tmp25_);
#line 775 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp26_ = g_strdup (CONVERSATION_LIST_BOX_EMAIL_ACTION_GROUP_NAME "." CONVERSATION_LIST_BOX_ACTION_MARK_UNREAD_DOWN);
#line 775 "../src/client/conversation-viewer/conversation-email.vala"
			_vala_array_add17 (&_data87_->blacklist, &_data87_->blacklist_length1, &_data87_->_blacklist_size_, _tmp26_);
#line 5217 "conversation-email.c"
		} else {
			gchar* _tmp27_;
#line 780 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp27_ = g_strdup (CONVERSATION_LIST_BOX_EMAIL_ACTION_GROUP_NAME "." CONVERSATION_LIST_BOX_ACTION_MARK_READ);
#line 780 "../src/client/conversation-viewer/conversation-email.vala"
			_vala_array_add18 (&_data87_->blacklist, &_data87_->blacklist_length1, &_data87_->_blacklist_size_, _tmp27_);
#line 5224 "conversation-email.c"
		}
#line 786 "../src/client/conversation-viewer/conversation-email.vala"
		if (!is_shift_down) {
#line 786 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp28_ = supports_trash;
#line 5230 "conversation-email.c"
		} else {
#line 786 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp28_ = FALSE;
#line 5234 "conversation-email.c"
		}
#line 786 "../src/client/conversation-viewer/conversation-email.vala"
		_data87_->show_trash = _tmp28_;
#line 787 "../src/client/conversation-viewer/conversation-email.vala"
		if (!_data87_->show_trash) {
#line 787 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp29_ = supports_delete;
#line 5242 "conversation-email.c"
		} else {
#line 787 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp29_ = FALSE;
#line 5246 "conversation-email.c"
		}
#line 787 "../src/client/conversation-viewer/conversation-email.vala"
		_data87_->show_delete = _tmp29_;
#line 788 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp30_ = self->priv->_email;
#line 788 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp31_ = geary_email_get_id (_tmp30_);
#line 788 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp32_ = _tmp31_;
#line 788 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp33_ = geary_email_identifier_to_variant (_tmp32_);
#line 788 "../src/client/conversation-viewer/conversation-email.vala"
		_data87_->email_target = _tmp33_;
#line 789 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp34_ = conversation_email_email_menu_template;
#line 789 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp35_ = util_gtk_construct_menu (_tmp34_, ____lambda104__util_gtk_menu_visitor, _data87_);
#line 789 "../src/client/conversation-viewer/conversation-email.vala"
		new_model = _tmp35_;
#line 808 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp36_ = self->priv->email_menubutton;
#line 808 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp37_ = gtk_menu_button_get_popover (_tmp36_);
#line 808 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp38_ = _tmp37_;
#line 808 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp39_ = new_model;
#line 808 "../src/client/conversation-viewer/conversation-email.vala"
		gtk_popover_bind_model (_tmp38_, G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, g_menu_model_get_type (), GMenuModel), NULL);
#line 809 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp40_ = self->priv->email_menubutton;
#line 809 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp41_ = gtk_menu_button_get_popover (_tmp40_);
#line 809 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp42_ = _tmp41_;
#line 809 "../src/client/conversation-viewer/conversation-email.vala"
		gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, gtk_widget_get_type (), GtkWidget));
#line 744 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (new_model);
#line 744 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (main);
#line 744 "../src/client/conversation-viewer/conversation-email.vala"
		block87_data_unref (_data87_);
#line 744 "../src/client/conversation-viewer/conversation-email.vala"
		_data87_ = NULL;
#line 5292 "conversation-email.c"
	}
}

static void
conversation_email_update_displayed_attachments (ConversationEmail* self)
{
	gboolean has_attachments = FALSE;
	GeeList* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GtkButton* _tmp3_;
	ApplicationMainWindow* main = NULL;
	GtkWidget* _tmp4_;
	ApplicationMainWindow* _tmp5_;
	gboolean _tmp6_ = FALSE;
#line 814 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 815 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = self->priv->displayed_attachments;
#line 815 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp1_ = gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection));
#line 815 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp2_ = _tmp1_;
#line 815 "../src/client/conversation-viewer/conversation-email.vala"
	has_attachments = !_tmp2_;
#line 816 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp3_ = self->priv->attachments_button;
#line 816 "../src/client/conversation-viewer/conversation-email.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget), has_attachments);
#line 817 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp4_ = gtk_widget_get_toplevel (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 817 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp5_ = _g_object_ref0 (APPLICATION_IS_MAIN_WINDOW (_tmp4_) ? ((ApplicationMainWindow*) _tmp4_) : NULL);
#line 817 "../src/client/conversation-viewer/conversation-email.vala"
	main = _tmp5_;
#line 819 "../src/client/conversation-viewer/conversation-email.vala"
	if (has_attachments) {
#line 5330 "conversation-email.c"
		ApplicationMainWindow* _tmp7_;
#line 819 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp7_ = main;
#line 819 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp6_ = _tmp7_ != NULL;
#line 5336 "conversation-email.c"
	} else {
#line 819 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp6_ = FALSE;
#line 5340 "conversation-email.c"
	}
#line 819 "../src/client/conversation-viewer/conversation-email.vala"
	if (_tmp6_) {
#line 5344 "conversation-email.c"
		ApplicationMainWindow* _tmp8_;
		ApplicationAttachmentManager* _tmp9_;
		ApplicationAttachmentManager* _tmp10_;
		ComponentsAttachmentPane* _tmp11_;
		ComponentsAttachmentPane* _tmp12_;
		ConversationMessage* _tmp13_;
		GtkGrid* _tmp14_;
		GtkGrid* _tmp15_;
		ComponentsAttachmentPane* _tmp16_;
#line 820 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp8_ = main;
#line 820 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp9_ = application_main_window_get_attachments (_tmp8_);
#line 820 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp10_ = _tmp9_;
#line 820 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp11_ = components_attachment_pane_new (FALSE, _tmp10_);
#line 820 "../src/client/conversation-viewer/conversation-email.vala"
		g_object_ref_sink (_tmp11_);
#line 820 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp12_ = _tmp11_;
#line 820 "../src/client/conversation-viewer/conversation-email.vala"
		conversation_email_set_attachments_pane (self, _tmp12_);
#line 820 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (_tmp12_);
#line 823 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp13_ = self->priv->_primary_message;
#line 823 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp14_ = conversation_message_get_body_container (_tmp13_);
#line 823 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp15_ = _tmp14_;
#line 823 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp16_ = self->priv->_attachments_pane;
#line 823 "../src/client/conversation-viewer/conversation-email.vala"
		gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_widget_get_type (), GtkWidget));
#line 5380 "conversation-email.c"
		{
			GeeList* _attachment_list = NULL;
			GeeList* _tmp17_;
			gint _attachment_size = 0;
			GeeList* _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
			gint _attachment_index = 0;
#line 825 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp17_ = self->priv->displayed_attachments;
#line 825 "../src/client/conversation-viewer/conversation-email.vala"
			_attachment_list = _tmp17_;
#line 825 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp18_ = _attachment_list;
#line 825 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp19_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_COLLECTION, GeeCollection));
#line 825 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp20_ = _tmp19_;
#line 825 "../src/client/conversation-viewer/conversation-email.vala"
			_attachment_size = _tmp20_;
#line 825 "../src/client/conversation-viewer/conversation-email.vala"
			_attachment_index = -1;
#line 825 "../src/client/conversation-viewer/conversation-email.vala"
			while (TRUE) {
#line 5405 "conversation-email.c"
				gint _tmp21_;
				gint _tmp22_;
				GearyAttachment* attachment = NULL;
				GeeList* _tmp23_;
				gpointer _tmp24_;
				ComponentsAttachmentPane* _tmp25_;
				GearyAttachment* _tmp26_;
				GCancellable* _tmp27_;
#line 825 "../src/client/conversation-viewer/conversation-email.vala"
				_attachment_index = _attachment_index + 1;
#line 825 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp21_ = _attachment_index;
#line 825 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp22_ = _attachment_size;
#line 825 "../src/client/conversation-viewer/conversation-email.vala"
				if (!(_tmp21_ < _tmp22_)) {
#line 825 "../src/client/conversation-viewer/conversation-email.vala"
					break;
#line 5424 "conversation-email.c"
				}
#line 825 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp23_ = _attachment_list;
#line 825 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp24_ = gee_list_get (_tmp23_, _attachment_index);
#line 825 "../src/client/conversation-viewer/conversation-email.vala"
				attachment = (GearyAttachment*) _tmp24_;
#line 826 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp25_ = self->priv->_attachments_pane;
#line 826 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp26_ = attachment;
#line 826 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp27_ = self->priv->load_cancellable;
#line 826 "../src/client/conversation-viewer/conversation-email.vala"
				components_attachment_pane_add_attachment (_tmp25_, _tmp26_, _tmp27_);
#line 825 "../src/client/conversation-viewer/conversation-email.vala"
				_g_object_unref0 (attachment);
#line 5442 "conversation-email.c"
			}
		}
	}
#line 814 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (main);
#line 5448 "conversation-email.c"
}

static void
conversation_email_handle_load_failure (ConversationEmail* self,
                                        GError* _error_)
{
	ConversationMessage* _tmp0_;
	ApplicationMainWindow* main = NULL;
	GtkWidget* _tmp1_;
	ApplicationMainWindow* _tmp2_;
	ApplicationMainWindow* _tmp3_;
#line 833 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 833 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (_error_ != NULL);
#line 834 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_set_message_body_state (self, CONVERSATION_EMAIL_LOAD_STATE_FAILED);
#line 835 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = self->priv->_primary_message;
#line 835 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_message_show_load_error_pane (_tmp0_);
#line 837 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp1_ = gtk_widget_get_toplevel (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 837 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp2_ = _g_object_ref0 (APPLICATION_IS_MAIN_WINDOW (_tmp1_) ? ((ApplicationMainWindow*) _tmp1_) : NULL);
#line 837 "../src/client/conversation-viewer/conversation-email.vala"
	main = _tmp2_;
#line 838 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp3_ = main;
#line 838 "../src/client/conversation-viewer/conversation-email.vala"
	if (_tmp3_ != NULL) {
#line 5480 "conversation-email.c"
		GearyAccountInformation* account = NULL;
		GearyAppEmailStore* _tmp4_;
		GearyAccount* _tmp5_;
		GearyAccount* _tmp6_;
		GearyAccountInformation* _tmp7_;
		GearyAccountInformation* _tmp8_;
		GearyAccountInformation* _tmp9_;
		ApplicationMainWindow* _tmp10_;
		ApplicationClient* _tmp11_;
		ApplicationClient* _tmp12_;
		ApplicationController* _tmp13_;
		ApplicationController* _tmp14_;
		GearyAccountInformation* _tmp15_;
		GearyAccountInformation* _tmp16_;
		GearyServiceInformation* _tmp17_;
		GearyServiceInformation* _tmp18_;
		GearyServiceProblemReport* _tmp19_;
		GearyServiceProblemReport* _tmp20_;
#line 839 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp4_ = self->priv->email_store;
#line 839 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp5_ = geary_app_email_store_get_account (_tmp4_);
#line 839 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp6_ = _tmp5_;
#line 839 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp7_ = geary_account_get_information (_tmp6_);
#line 839 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp8_ = _tmp7_;
#line 839 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 839 "../src/client/conversation-viewer/conversation-email.vala"
		account = _tmp9_;
#line 840 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp10_ = main;
#line 840 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp11_ = application_main_window_get_application (_tmp10_);
#line 840 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp12_ = _tmp11_;
#line 840 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp13_ = application_client_get_controller (_tmp12_);
#line 840 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp14_ = _tmp13_;
#line 840 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp15_ = account;
#line 840 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp16_ = account;
#line 840 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp17_ = geary_account_information_get_incoming (_tmp16_);
#line 840 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp18_ = _tmp17_;
#line 840 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp19_ = geary_service_problem_report_new (_tmp15_, _tmp18_, _error_);
#line 840 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp20_ = _tmp19_;
#line 840 "../src/client/conversation-viewer/conversation-email.vala"
		composer_application_interface_report_problem (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, COMPOSER_TYPE_APPLICATION_INTERFACE, ComposerApplicationInterface), G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEARY_TYPE_PROBLEM_REPORT, GearyProblemReport));
#line 840 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (_tmp20_);
#line 838 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (account);
#line 5541 "conversation-email.c"
	}
#line 833 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (main);
#line 5545 "conversation-email.c"
}

static void
conversation_email_handle_load_offline (ConversationEmail* self)
{
	ConversationMessage* _tmp0_;
#line 846 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 847 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_set_message_body_state (self, CONVERSATION_EMAIL_LOAD_STATE_FAILED);
#line 848 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = self->priv->_primary_message;
#line 848 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_message_show_offline_pane (_tmp0_);
#line 5560 "conversation-email.c"
}

static inline gboolean
conversation_email_is_online (ConversationEmail* self)
{
	GearyAppEmailStore* _tmp0_;
	GearyAccount* _tmp1_;
	GearyAccount* _tmp2_;
	GearyClientService* _tmp3_;
	GearyClientService* _tmp4_;
	GearyClientServiceStatus _tmp5_;
	GearyClientServiceStatus _tmp6_;
	gboolean result;
#line 851 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_val_if_fail (IS_CONVERSATION_EMAIL (self), FALSE);
#line 852 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = self->priv->email_store;
#line 852 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp1_ = geary_app_email_store_get_account (_tmp0_);
#line 852 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp2_ = _tmp1_;
#line 852 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp3_ = geary_account_get_incoming (_tmp2_);
#line 852 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp4_ = _tmp3_;
#line 852 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp5_ = geary_client_service_get_current_status (_tmp4_);
#line 852 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp6_ = _tmp5_;
#line 852 "../src/client/conversation-viewer/conversation-email.vala"
	result = _tmp6_ == GEARY_CLIENT_SERVICE_STATUS_CONNECTED;
#line 852 "../src/client/conversation-viewer/conversation-email.vala"
	return result;
#line 5594 "conversation-email.c"
}

static void
conversation_email_activate_email_action (ConversationEmail* self,
                                          const gchar* name)
{
	GActionGroup* email_actions = NULL;
	GActionGroup* _tmp0_;
	GActionGroup* _tmp1_;
	GActionGroup* _tmp2_;
#line 855 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 855 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (name != NULL);
#line 856 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = gtk_widget_get_action_group (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), CONVERSATION_LIST_BOX_EMAIL_ACTION_GROUP_NAME);
#line 856 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 856 "../src/client/conversation-viewer/conversation-email.vala"
	email_actions = _tmp1_;
#line 859 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp2_ = email_actions;
#line 859 "../src/client/conversation-viewer/conversation-email.vala"
	if (_tmp2_ != NULL) {
#line 5619 "conversation-email.c"
		GActionGroup* _tmp3_;
		GearyEmail* _tmp4_;
		GearyEmailIdentifier* _tmp5_;
		GearyEmailIdentifier* _tmp6_;
		GVariant* _tmp7_;
		GVariant* _tmp8_;
#line 860 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp3_ = email_actions;
#line 860 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp4_ = self->priv->_email;
#line 860 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp5_ = geary_email_get_id (_tmp4_);
#line 860 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp6_ = _tmp5_;
#line 860 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp7_ = geary_email_identifier_to_variant (_tmp6_);
#line 860 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp8_ = _tmp7_;
#line 860 "../src/client/conversation-viewer/conversation-email.vala"
		g_action_group_activate_action (_tmp3_, name, _tmp8_);
#line 860 "../src/client/conversation-viewer/conversation-email.vala"
		_g_variant_unref0 (_tmp8_);
#line 5642 "conversation-email.c"
	}
#line 855 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (email_actions);
#line 5646 "conversation-email.c"
}

static void
conversation_email_on_email_menu (ConversationEmail* self)
{
#line 865 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 866 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_update_email_menu (self);
#line 5656 "conversation-email.c"
}

static void
_conversation_email_on_email_menu_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                             gpointer self)
{
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_on_email_menu ((ConversationEmail*) self);
#line 5665 "conversation-email.c"
}

static void
conversation_email_on_shift_changed (ConversationEmail* self)
{
#line 869 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 870 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_update_email_menu (self);
#line 5675 "conversation-email.c"
}

static void
conversation_email_on_body_loading_timeout (ConversationEmail* self)
{
	ConversationMessage* _tmp0_;
#line 873 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 874 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = self->priv->_primary_message;
#line 874 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_message_show_loading_pane (_tmp0_);
#line 5688 "conversation-email.c"
}

static void
conversation_email_on_load_cancelled (ConversationEmail* self)
{
	GearyTimeoutManager* _tmp0_;
#line 877 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 878 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = self->priv->body_loading_timeout;
#line 878 "../src/client/conversation-viewer/conversation-email.vala"
	geary_timeout_manager_reset (_tmp0_);
#line 5701 "conversation-email.c"
}

static void
conversation_email_on_flag_remote_images (ConversationEmail* self)
{
#line 881 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 882 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_activate_email_action (self, CONVERSATION_LIST_BOX_ACTION_MARK_LOAD_REMOTE);
#line 5711 "conversation-email.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 5734 "conversation-email.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 5743 "conversation-email.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 5762 "conversation-email.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 5766 "conversation-email.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 5772 "conversation-email.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 5782 "conversation-email.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 5790 "conversation-email.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 5794 "conversation-email.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 5800 "conversation-email.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 5810 "conversation-email.c"
}

static void
conversation_email_on_save_image (ConversationEmail* self,
                                  const gchar* uri,
                                  const gchar* alt_text,
                                  GearyMemoryBuffer* content)
{
	ApplicationMainWindow* main = NULL;
	GtkWidget* _tmp0_;
	ApplicationMainWindow* _tmp1_;
	ApplicationMainWindow* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 885 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 885 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (uri != NULL);
#line 885 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail ((content == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (content, GEARY_MEMORY_TYPE_BUFFER));
#line 888 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = gtk_widget_get_toplevel (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 888 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp1_ = _g_object_ref0 (APPLICATION_IS_MAIN_WINDOW (_tmp0_) ? ((ApplicationMainWindow*) _tmp0_) : NULL);
#line 888 "../src/client/conversation-viewer/conversation-email.vala"
	main = _tmp1_;
#line 889 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp2_ = main;
#line 889 "../src/client/conversation-viewer/conversation-email.vala"
	if (_tmp2_ != NULL) {
#line 890 "../src/client/conversation-viewer/conversation-email.vala"
		if (g_str_has_prefix (uri, COMPONENTS_WEB_VIEW_CID_URL_PREFIX)) {
#line 5842 "conversation-email.c"
			gchar* cid = NULL;
			gint _tmp3_;
			gint _tmp4_;
			gchar* _tmp5_;
#line 891 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp3_ = strlen (COMPONENTS_WEB_VIEW_CID_URL_PREFIX);
#line 891 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp4_ = _tmp3_;
#line 891 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp5_ = string_substring (uri, (glong) _tmp4_, (glong) -1);
#line 891 "../src/client/conversation-viewer/conversation-email.vala"
			cid = _tmp5_;
#line 5855 "conversation-email.c"
			{
				GearyAttachment* attachment = NULL;
				GearyEmail* _tmp6_;
				const gchar* _tmp7_;
				GearyAttachment* _tmp8_;
				ApplicationMainWindow* _tmp9_;
				ApplicationAttachmentManager* _tmp10_;
				ApplicationAttachmentManager* _tmp11_;
				GearyAttachment* _tmp12_;
#line 893 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp6_ = self->priv->_email;
#line 893 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp7_ = cid;
#line 893 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp8_ = geary_email_get_attachment_by_content_id (_tmp6_, _tmp7_, &_inner_error0_);
#line 893 "../src/client/conversation-viewer/conversation-email.vala"
				attachment = _tmp8_;
#line 893 "../src/client/conversation-viewer/conversation-email.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5875 "conversation-email.c"
					goto __catch0_g_error;
				}
#line 896 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp9_ = main;
#line 896 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp10_ = application_main_window_get_attachments (_tmp9_);
#line 896 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp11_ = _tmp10_;
#line 896 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp12_ = attachment;
#line 896 "../src/client/conversation-viewer/conversation-email.vala"
				application_attachment_manager_save_attachment (_tmp11_, _tmp12_, alt_text, NULL, NULL, NULL);
#line 892 "../src/client/conversation-viewer/conversation-email.vala"
				_g_object_unref0 (attachment);
#line 5890 "conversation-email.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* err = NULL;
				const gchar* _tmp13_;
				GError* _tmp14_;
				const gchar* _tmp15_;
#line 892 "../src/client/conversation-viewer/conversation-email.vala"
				err = _inner_error0_;
#line 892 "../src/client/conversation-viewer/conversation-email.vala"
				_inner_error0_ = NULL;
#line 902 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp13_ = cid;
#line 902 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp14_ = err;
#line 902 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp15_ = _tmp14_->message;
#line 902 "../src/client/conversation-viewer/conversation-email.vala"
				g_debug ("conversation-email.vala:902: Could not get attachment \"%s\": %s", _tmp13_, _tmp15_);
#line 892 "../src/client/conversation-viewer/conversation-email.vala"
				_g_error_free0 (err);
#line 5913 "conversation-email.c"
			}
			__finally0:
#line 892 "../src/client/conversation-viewer/conversation-email.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 892 "../src/client/conversation-viewer/conversation-email.vala"
				_g_free0 (cid);
#line 892 "../src/client/conversation-viewer/conversation-email.vala"
				_g_object_unref0 (main);
#line 892 "../src/client/conversation-viewer/conversation-email.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 892 "../src/client/conversation-viewer/conversation-email.vala"
				g_clear_error (&_inner_error0_);
#line 892 "../src/client/conversation-viewer/conversation-email.vala"
				return;
#line 5928 "conversation-email.c"
			}
#line 890 "../src/client/conversation-viewer/conversation-email.vala"
			_g_free0 (cid);
#line 5932 "conversation-email.c"
		} else {
#line 904 "../src/client/conversation-viewer/conversation-email.vala"
			if (content != NULL) {
#line 5936 "conversation-email.c"
				GFile* source = NULL;
				GFile* _tmp16_;
				gchar* display_name = NULL;
				GFile* _tmp17_;
				gchar* _tmp18_;
				const gchar* _tmp19_;
				ApplicationMainWindow* _tmp22_;
				ApplicationAttachmentManager* _tmp23_;
				ApplicationAttachmentManager* _tmp24_;
				const gchar* _tmp25_;
#line 905 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp16_ = g_file_new_for_uri (uri);
#line 905 "../src/client/conversation-viewer/conversation-email.vala"
				source = _tmp16_;
#line 910 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp17_ = source;
#line 910 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp18_ = g_file_get_basename (_tmp17_);
#line 910 "../src/client/conversation-viewer/conversation-email.vala"
				display_name = _tmp18_;
#line 911 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp19_ = display_name;
#line 911 "../src/client/conversation-viewer/conversation-email.vala"
				if (geary_string_is_empty_or_whitespace (_tmp19_)) {
#line 5961 "conversation-email.c"
					const gchar* _tmp20_;
					gchar* _tmp21_;
#line 912 "../src/client/conversation-viewer/conversation-email.vala"
					_tmp20_ = application_attachment_manager_untitled_file_name;
#line 912 "../src/client/conversation-viewer/conversation-email.vala"
					_tmp21_ = g_strdup (_tmp20_);
#line 912 "../src/client/conversation-viewer/conversation-email.vala"
					_g_free0 (display_name);
#line 912 "../src/client/conversation-viewer/conversation-email.vala"
					display_name = _tmp21_;
#line 5972 "conversation-email.c"
				}
#line 914 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp22_ = main;
#line 914 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp23_ = application_main_window_get_attachments (_tmp22_);
#line 914 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp24_ = _tmp23_;
#line 914 "../src/client/conversation-viewer/conversation-email.vala"
				_tmp25_ = display_name;
#line 914 "../src/client/conversation-viewer/conversation-email.vala"
				application_attachment_manager_save_buffer (_tmp24_, _tmp25_, content, NULL, NULL, NULL);
#line 904 "../src/client/conversation-viewer/conversation-email.vala"
				_g_free0 (display_name);
#line 904 "../src/client/conversation-viewer/conversation-email.vala"
				_g_object_unref0 (source);
#line 5988 "conversation-email.c"
			}
		}
	}
#line 885 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (main);
#line 5994 "conversation-email.c"
}

static void
conversation_email_on_resource_loaded (ConversationEmail* self,
                                       const gchar* id)
{
	GeeIterator* displayed = NULL;
	GeeList* _tmp0_;
	GeeIterator* _tmp1_;
#line 923 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 923 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (id != NULL);
#line 924 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = self->priv->displayed_attachments;
#line 924 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ITERABLE, GeeIterable));
#line 924 "../src/client/conversation-viewer/conversation-email.vala"
	displayed = _tmp1_;
#line 926 "../src/client/conversation-viewer/conversation-email.vala"
	while (TRUE) {
#line 6016 "conversation-email.c"
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
		GearyAttachment* attachment = NULL;
		GeeIterator* _tmp4_;
		gpointer _tmp5_;
		GearyAttachment* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
#line 926 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp2_ = displayed;
#line 926 "../src/client/conversation-viewer/conversation-email.vala"
		if (!gee_iterator_has_next (_tmp2_)) {
#line 926 "../src/client/conversation-viewer/conversation-email.vala"
			break;
#line 6031 "conversation-email.c"
		}
#line 927 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp3_ = displayed;
#line 927 "../src/client/conversation-viewer/conversation-email.vala"
		gee_iterator_next (_tmp3_);
#line 928 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp4_ = displayed;
#line 928 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp5_ = gee_iterator_get (_tmp4_);
#line 928 "../src/client/conversation-viewer/conversation-email.vala"
		attachment = (GearyAttachment*) _tmp5_;
#line 929 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp6_ = attachment;
#line 929 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp7_ = geary_attachment_get_content_id (_tmp6_);
#line 929 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp8_ = _tmp7_;
#line 929 "../src/client/conversation-viewer/conversation-email.vala"
		if (g_strcmp0 (_tmp8_, id) == 0) {
#line 6051 "conversation-email.c"
			GeeIterator* _tmp9_;
#line 930 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp9_ = displayed;
#line 930 "../src/client/conversation-viewer/conversation-email.vala"
			gee_iterator_remove (_tmp9_);
#line 6057 "conversation-email.c"
		}
#line 926 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (attachment);
#line 6061 "conversation-email.c"
	}
#line 923 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (displayed);
#line 6065 "conversation-email.c"
}

static void
conversation_email_on_content_loaded (ConversationEmail* self)
{
	gboolean all_loaded = FALSE;
	gboolean _tmp7_ = FALSE;
#line 935 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 936 "../src/client/conversation-viewer/conversation-email.vala"
	all_loaded = TRUE;
#line 6077 "conversation-email.c"
	{
		GeeIterator* _message_it = NULL;
		GeeIterator* _tmp0_;
#line 937 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp0_ = conversation_email_iterator (self);
#line 937 "../src/client/conversation-viewer/conversation-email.vala"
		_message_it = _tmp0_;
#line 937 "../src/client/conversation-viewer/conversation-email.vala"
		while (TRUE) {
#line 6087 "conversation-email.c"
			GeeIterator* _tmp1_;
			ConversationMessage* message = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			ConversationMessage* _tmp4_;
			gboolean _tmp5_;
			gboolean _tmp6_;
#line 937 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp1_ = _message_it;
#line 937 "../src/client/conversation-viewer/conversation-email.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 937 "../src/client/conversation-viewer/conversation-email.vala"
				break;
#line 6101 "conversation-email.c"
			}
#line 937 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp2_ = _message_it;
#line 937 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 937 "../src/client/conversation-viewer/conversation-email.vala"
			message = (ConversationMessage*) _tmp3_;
#line 938 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp4_ = message;
#line 938 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp5_ = conversation_message_get_is_content_loaded (_tmp4_);
#line 938 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp6_ = _tmp5_;
#line 938 "../src/client/conversation-viewer/conversation-email.vala"
			if (!_tmp6_) {
#line 939 "../src/client/conversation-viewer/conversation-email.vala"
				all_loaded = FALSE;
#line 940 "../src/client/conversation-viewer/conversation-email.vala"
				_g_object_unref0 (message);
#line 940 "../src/client/conversation-viewer/conversation-email.vala"
				break;
#line 6123 "conversation-email.c"
			}
#line 937 "../src/client/conversation-viewer/conversation-email.vala"
			_g_object_unref0 (message);
#line 6127 "conversation-email.c"
		}
#line 937 "../src/client/conversation-viewer/conversation-email.vala"
		_g_object_unref0 (_message_it);
#line 6131 "conversation-email.c"
	}
#line 943 "../src/client/conversation-viewer/conversation-email.vala"
	if (all_loaded) {
#line 6135 "conversation-email.c"
		ConversationEmailLoadState _tmp8_;
#line 943 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp8_ = self->priv->_message_body_state;
#line 943 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp7_ = _tmp8_ != CONVERSATION_EMAIL_LOAD_STATE_COMPLETED;
#line 6141 "conversation-email.c"
	} else {
#line 943 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp7_ = FALSE;
#line 6145 "conversation-email.c"
	}
#line 943 "../src/client/conversation-viewer/conversation-email.vala"
	if (_tmp7_) {
#line 6149 "conversation-email.c"
		GearyNonblockingSpinlock* _tmp9_;
#line 944 "../src/client/conversation-viewer/conversation-email.vala"
		conversation_email_set_message_body_state (self, CONVERSATION_EMAIL_LOAD_STATE_COMPLETED);
#line 945 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp9_ = self->priv->message_bodies_loaded_lock;
#line 945 "../src/client/conversation-viewer/conversation-email.vala"
		geary_nonblocking_lock_blind_notify (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock));
#line 952 "../src/client/conversation-viewer/conversation-email.vala"
		conversation_email_update_displayed_attachments (self);
#line 6159 "conversation-email.c"
	}
}

static void
conversation_email_on_service_status_change (ConversationEmail* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	ConversationEmailLoadState _tmp2_;
#line 956 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_if_fail (IS_CONVERSATION_EMAIL (self));
#line 957 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp2_ = self->priv->_message_body_state;
#line 957 "../src/client/conversation-viewer/conversation-email.vala"
	if (_tmp2_ == CONVERSATION_EMAIL_LOAD_STATE_FAILED) {
#line 6175 "conversation-email.c"
		GCancellable* _tmp3_;
#line 958 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp3_ = self->priv->load_cancellable;
#line 958 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp1_ = !g_cancellable_is_cancelled (_tmp3_);
#line 6181 "conversation-email.c"
	} else {
#line 957 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp1_ = FALSE;
#line 6185 "conversation-email.c"
	}
#line 957 "../src/client/conversation-viewer/conversation-email.vala"
	if (_tmp1_) {
#line 959 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp0_ = conversation_email_is_online (self);
#line 6191 "conversation-email.c"
	} else {
#line 957 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp0_ = FALSE;
#line 6195 "conversation-email.c"
	}
#line 957 "../src/client/conversation-viewer/conversation-email.vala"
	if (_tmp0_) {
#line 960 "../src/client/conversation-viewer/conversation-email.vala"
		conversation_email_fetch_remote_body (self, NULL, NULL);
#line 6201 "conversation-email.c"
	}
}

static inline gpointer
conversation_email_message_view_iterator_get_instance_private (ConversationEmailMessageViewIterator* self)
{
	return G_STRUCT_MEMBER_P (self, ConversationEmailMessageViewIterator_private_offset);
}

static gboolean
conversation_email_message_view_iterator_real_get_read_only (GeeIterator* base)
{
	gboolean result;
	ConversationEmailMessageViewIterator* self;
#line 75 "../src/client/conversation-viewer/conversation-email.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, CONVERSATION_EMAIL_TYPE_MESSAGE_VIEW_ITERATOR, ConversationEmailMessageViewIterator);
#line 75 "../src/client/conversation-viewer/conversation-email.vala"
	result = TRUE;
#line 75 "../src/client/conversation-viewer/conversation-email.vala"
	return result;
#line 6222 "conversation-email.c"
}

static gboolean
conversation_email_message_view_iterator_real_get_valid (GeeIterator* base)
{
	gboolean result;
	ConversationEmailMessageViewIterator* self;
	gboolean _tmp0_ = FALSE;
#line 78 "../src/client/conversation-viewer/conversation-email.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, CONVERSATION_EMAIL_TYPE_MESSAGE_VIEW_ITERATOR, ConversationEmailMessageViewIterator);
#line 78 "../src/client/conversation-viewer/conversation-email.vala"
	if (self->priv->pos == 0) {
#line 78 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp0_ = TRUE;
#line 6237 "conversation-email.c"
	} else {
		GeeIterator* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 78 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp1_ = self->priv->attached_views;
#line 78 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp2_ = gee_iterator_get_valid (_tmp1_);
#line 78 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp3_ = _tmp2_;
#line 78 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp0_ = _tmp3_;
#line 6250 "conversation-email.c"
	}
#line 78 "../src/client/conversation-viewer/conversation-email.vala"
	result = _tmp0_;
#line 78 "../src/client/conversation-viewer/conversation-email.vala"
	return result;
#line 6256 "conversation-email.c"
}

static ConversationEmailMessageViewIterator*
conversation_email_message_view_iterator_construct (GType object_type,
                                                    ConversationEmail* parent_view)
{
	ConversationEmailMessageViewIterator * self = NULL;
	ConversationEmail* _tmp0_;
	GeeList* _tmp1_;
	GeeIterator* _tmp2_;
#line 85 "../src/client/conversation-viewer/conversation-email.vala"
	g_return_val_if_fail (IS_CONVERSATION_EMAIL (parent_view), NULL);
#line 85 "../src/client/conversation-viewer/conversation-email.vala"
	self = (ConversationEmailMessageViewIterator*) geary_base_object_construct (object_type);
#line 86 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = _g_object_ref0 (parent_view);
#line 86 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->priv->parent_view);
#line 86 "../src/client/conversation-viewer/conversation-email.vala"
	self->priv->parent_view = _tmp0_;
#line 87 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp1_ = parent_view->priv->_attached_messages;
#line 87 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp2_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ITERABLE, GeeIterable));
#line 87 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->priv->attached_views);
#line 87 "../src/client/conversation-viewer/conversation-email.vala"
	self->priv->attached_views = _tmp2_;
#line 85 "../src/client/conversation-viewer/conversation-email.vala"
	return self;
#line 6287 "conversation-email.c"
}

static ConversationEmailMessageViewIterator*
conversation_email_message_view_iterator_new (ConversationEmail* parent_view)
{
#line 85 "../src/client/conversation-viewer/conversation-email.vala"
	return conversation_email_message_view_iterator_construct (CONVERSATION_EMAIL_TYPE_MESSAGE_VIEW_ITERATOR, parent_view);
#line 6295 "conversation-email.c"
}

static gboolean
conversation_email_message_view_iterator_real_next (GeeIterator* base)
{
	ConversationEmailMessageViewIterator * self;
	gboolean has_next = FALSE;
	gboolean result;
#line 90 "../src/client/conversation-viewer/conversation-email.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, CONVERSATION_EMAIL_TYPE_MESSAGE_VIEW_ITERATOR, ConversationEmailMessageViewIterator);
#line 91 "../src/client/conversation-viewer/conversation-email.vala"
	has_next = FALSE;
#line 92 "../src/client/conversation-viewer/conversation-email.vala"
	self->priv->pos = self->priv->pos + 1;
#line 93 "../src/client/conversation-viewer/conversation-email.vala"
	if (self->priv->pos == 0) {
#line 94 "../src/client/conversation-viewer/conversation-email.vala"
		has_next = TRUE;
#line 6314 "conversation-email.c"
	} else {
		GeeIterator* _tmp0_;
#line 96 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp0_ = self->priv->attached_views;
#line 96 "../src/client/conversation-viewer/conversation-email.vala"
		has_next = gee_iterator_next (_tmp0_);
#line 6321 "conversation-email.c"
	}
#line 98 "../src/client/conversation-viewer/conversation-email.vala"
	result = has_next;
#line 98 "../src/client/conversation-viewer/conversation-email.vala"
	return result;
#line 6327 "conversation-email.c"
}

static gboolean
conversation_email_message_view_iterator_real_has_next (GeeIterator* base)
{
	ConversationEmailMessageViewIterator * self;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 101 "../src/client/conversation-viewer/conversation-email.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, CONVERSATION_EMAIL_TYPE_MESSAGE_VIEW_ITERATOR, ConversationEmailMessageViewIterator);
#line 102 "../src/client/conversation-viewer/conversation-email.vala"
	if (self->priv->pos == -1) {
#line 102 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp0_ = TRUE;
#line 6342 "conversation-email.c"
	} else {
		GeeIterator* _tmp1_;
#line 102 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp1_ = self->priv->attached_views;
#line 102 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp0_ = gee_iterator_next (_tmp1_);
#line 6349 "conversation-email.c"
	}
#line 102 "../src/client/conversation-viewer/conversation-email.vala"
	result = _tmp0_;
#line 102 "../src/client/conversation-viewer/conversation-email.vala"
	return result;
#line 6355 "conversation-email.c"
}

static ConversationMessage*
conversation_email_message_view_iterator_real_get (GeeIterator* base)
{
	ConversationEmailMessageViewIterator * self;
	ConversationMessage* result;
#line 105 "../src/client/conversation-viewer/conversation-email.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, CONVERSATION_EMAIL_TYPE_MESSAGE_VIEW_ITERATOR, ConversationEmailMessageViewIterator);
#line 106 "../src/client/conversation-viewer/conversation-email.vala"
	switch (self->priv->pos) {
#line 106 "../src/client/conversation-viewer/conversation-email.vala"
		case -1:
#line 6369 "conversation-email.c"
		{
#line 108 "../src/client/conversation-viewer/conversation-email.vala"
			g_assert_not_reached ();
#line 6373 "conversation-email.c"
		}
#line 106 "../src/client/conversation-viewer/conversation-email.vala"
		case 0:
#line 6377 "conversation-email.c"
		{
			ConversationEmail* _tmp0_;
			ConversationMessage* _tmp1_;
			ConversationMessage* _tmp2_;
			ConversationMessage* _tmp3_;
#line 111 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp0_ = self->priv->parent_view;
#line 111 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp1_ = conversation_email_get_primary_message (_tmp0_);
#line 111 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp2_ = _tmp1_;
#line 111 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp3_ = _g_object_ref0 (_tmp2_);
#line 111 "../src/client/conversation-viewer/conversation-email.vala"
			result = _tmp3_;
#line 111 "../src/client/conversation-viewer/conversation-email.vala"
			return result;
#line 6395 "conversation-email.c"
		}
		default:
		{
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
#line 114 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp4_ = self->priv->attached_views;
#line 114 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 114 "../src/client/conversation-viewer/conversation-email.vala"
			result = (ConversationMessage*) _tmp5_;
#line 114 "../src/client/conversation-viewer/conversation-email.vala"
			return result;
#line 6409 "conversation-email.c"
		}
	}
}

static void
conversation_email_message_view_iterator_real_remove (GeeIterator* base)
{
	ConversationEmailMessageViewIterator * self;
#line 118 "../src/client/conversation-viewer/conversation-email.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, CONVERSATION_EMAIL_TYPE_MESSAGE_VIEW_ITERATOR, ConversationEmailMessageViewIterator);
#line 119 "../src/client/conversation-viewer/conversation-email.vala"
	g_assert_not_reached ();
#line 6422 "conversation-email.c"
}

static gboolean
conversation_email_message_view_iterator_real_foreach (GeeTraversable* base,
                                                       GeeForallFunc f,
                                                       gpointer f_target)
{
	ConversationEmailMessageViewIterator * self;
	gboolean cont = FALSE;
	gboolean result;
#line 122 "../src/client/conversation-viewer/conversation-email.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, CONVERSATION_EMAIL_TYPE_MESSAGE_VIEW_ITERATOR, ConversationEmailMessageViewIterator);
#line 123 "../src/client/conversation-viewer/conversation-email.vala"
	cont = TRUE;
#line 124 "../src/client/conversation-viewer/conversation-email.vala"
	while (TRUE) {
#line 6439 "conversation-email.c"
		gboolean _tmp0_ = FALSE;
		gpointer _tmp1_;
#line 124 "../src/client/conversation-viewer/conversation-email.vala"
		if (cont) {
#line 124 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp0_ = gee_iterator_has_next (G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_ITERATOR, GeeIterator));
#line 6446 "conversation-email.c"
		} else {
#line 124 "../src/client/conversation-viewer/conversation-email.vala"
			_tmp0_ = FALSE;
#line 6450 "conversation-email.c"
		}
#line 124 "../src/client/conversation-viewer/conversation-email.vala"
		if (!_tmp0_) {
#line 124 "../src/client/conversation-viewer/conversation-email.vala"
			break;
#line 6456 "conversation-email.c"
		}
#line 125 "../src/client/conversation-viewer/conversation-email.vala"
		gee_iterator_next (G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_ITERATOR, GeeIterator));
#line 126 "../src/client/conversation-viewer/conversation-email.vala"
		_tmp1_ = gee_iterator_get (G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_ITERATOR, GeeIterator));
#line 126 "../src/client/conversation-viewer/conversation-email.vala"
		cont = f ((ConversationMessage*) _tmp1_, f_target);
#line 6464 "conversation-email.c"
	}
#line 128 "../src/client/conversation-viewer/conversation-email.vala"
	result = cont;
#line 128 "../src/client/conversation-viewer/conversation-email.vala"
	return result;
#line 6470 "conversation-email.c"
}

static void
conversation_email_message_view_iterator_class_init (ConversationEmailMessageViewIteratorClass * klass,
                                                     gpointer klass_data)
{
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_message_view_iterator_parent_class = g_type_class_peek_parent (klass);
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	g_type_class_adjust_private_offset (klass, &ConversationEmailMessageViewIterator_private_offset);
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_conversation_email_message_view_iterator_get_property;
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	G_OBJECT_CLASS (klass)->finalize = conversation_email_message_view_iterator_finalize;
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONVERSATION_EMAIL_MESSAGE_VIEW_ITERATOR_READ_ONLY_PROPERTY, conversation_email_message_view_iterator_properties[CONVERSATION_EMAIL_MESSAGE_VIEW_ITERATOR_READ_ONLY_PROPERTY] = g_param_spec_boolean ("read-only", "read-only", "read-only", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONVERSATION_EMAIL_MESSAGE_VIEW_ITERATOR_VALID_PROPERTY, conversation_email_message_view_iterator_properties[CONVERSATION_EMAIL_MESSAGE_VIEW_ITERATOR_VALID_PROPERTY] = g_param_spec_boolean ("valid", "valid", "valid", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6489 "conversation-email.c"
}

static GType
conversation_email_message_view_iterator_gee_traversable_get_g_type (ConversationEmailMessageViewIterator* self)
{
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	return (GType) TYPE_CONVERSATION_MESSAGE;
#line 6497 "conversation-email.c"
}

static GBoxedCopyFunc
conversation_email_message_view_iterator_gee_traversable_get_g_dup_func (ConversationEmailMessageViewIterator* self)
{
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	return (GBoxedCopyFunc) g_object_ref;
#line 6505 "conversation-email.c"
}

static GDestroyNotify
conversation_email_message_view_iterator_gee_traversable_get_g_destroy_func (ConversationEmailMessageViewIterator* self)
{
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	return (GDestroyNotify) g_object_unref;
#line 6513 "conversation-email.c"
}

static void
conversation_email_message_view_iterator_gee_traversable_interface_init (GeeTraversableIface * iface,
                                                                         gpointer iface_data)
{
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_message_view_iterator_gee_traversable_parent_iface = g_type_interface_peek_parent (iface);
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	iface->foreach = (gboolean (*) (GeeTraversable*, GeeForallFunc, gpointer)) conversation_email_message_view_iterator_real_foreach;
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	iface->get_g_type = (GType (*) (GeeTraversable *)) conversation_email_message_view_iterator_gee_traversable_get_g_type;
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	iface->get_g_dup_func = (GBoxedCopyFunc (*) (GeeTraversable *)) conversation_email_message_view_iterator_gee_traversable_get_g_dup_func;
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	iface->get_g_destroy_func = (GDestroyNotify (*) (GeeTraversable *)) conversation_email_message_view_iterator_gee_traversable_get_g_destroy_func;
#line 6530 "conversation-email.c"
}

static void
conversation_email_message_view_iterator_gee_iterator_interface_init (GeeIteratorIface * iface,
                                                                      gpointer iface_data)
{
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_message_view_iterator_gee_iterator_parent_iface = g_type_interface_peek_parent (iface);
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	iface->next = (gboolean (*) (GeeIterator*)) conversation_email_message_view_iterator_real_next;
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	iface->has_next = (gboolean (*) (GeeIterator*)) conversation_email_message_view_iterator_real_has_next;
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	iface->get = (gpointer (*) (GeeIterator*)) conversation_email_message_view_iterator_real_get;
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	iface->remove = (void (*) (GeeIterator*)) conversation_email_message_view_iterator_real_remove;
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	iface->get_read_only = conversation_email_message_view_iterator_real_get_read_only;
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	iface->get_valid = conversation_email_message_view_iterator_real_get_valid;
#line 6551 "conversation-email.c"
}

static void
conversation_email_message_view_iterator_instance_init (ConversationEmailMessageViewIterator * self,
                                                        gpointer klass)
{
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	self->priv = conversation_email_message_view_iterator_get_instance_private (self);
#line 82 "../src/client/conversation-viewer/conversation-email.vala"
	self->priv->pos = -1;
#line 83 "../src/client/conversation-viewer/conversation-email.vala"
	self->priv->attached_views = NULL;
#line 6564 "conversation-email.c"
}

static void
conversation_email_message_view_iterator_finalize (GObject * obj)
{
	ConversationEmailMessageViewIterator * self;
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONVERSATION_EMAIL_TYPE_MESSAGE_VIEW_ITERATOR, ConversationEmailMessageViewIterator);
#line 81 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->priv->parent_view);
#line 83 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->priv->attached_views);
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	G_OBJECT_CLASS (conversation_email_message_view_iterator_parent_class)->finalize (obj);
#line 6579 "conversation-email.c"
}

/**
     * Iterator that returns all message views in an email view.
     */
static GType
conversation_email_message_view_iterator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ConversationEmailMessageViewIteratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) conversation_email_message_view_iterator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ConversationEmailMessageViewIterator), 0, (GInstanceInitFunc) conversation_email_message_view_iterator_instance_init, NULL };
	static const GInterfaceInfo gee_traversable_info = { (GInterfaceInitFunc) conversation_email_message_view_iterator_gee_traversable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gee_iterator_info = { (GInterfaceInitFunc) conversation_email_message_view_iterator_gee_iterator_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType conversation_email_message_view_iterator_type_id;
	conversation_email_message_view_iterator_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "ConversationEmailMessageViewIterator", &g_define_type_info, 0);
	g_type_add_interface_static (conversation_email_message_view_iterator_type_id, GEE_TYPE_TRAVERSABLE, &gee_traversable_info);
	g_type_add_interface_static (conversation_email_message_view_iterator_type_id, GEE_TYPE_ITERATOR, &gee_iterator_info);
	ConversationEmailMessageViewIterator_private_offset = g_type_add_instance_private (conversation_email_message_view_iterator_type_id, sizeof (ConversationEmailMessageViewIteratorPrivate));
	return conversation_email_message_view_iterator_type_id;
}

static GType
conversation_email_message_view_iterator_get_type (void)
{
	static volatile gsize conversation_email_message_view_iterator_type_id__once = 0;
	if (g_once_init_enter (&conversation_email_message_view_iterator_type_id__once)) {
		GType conversation_email_message_view_iterator_type_id;
		conversation_email_message_view_iterator_type_id = conversation_email_message_view_iterator_get_type_once ();
		g_once_init_leave (&conversation_email_message_view_iterator_type_id__once, conversation_email_message_view_iterator_type_id);
	}
	return conversation_email_message_view_iterator_type_id__once;
}

static void
_vala_conversation_email_message_view_iterator_get_property (GObject * object,
                                                             guint property_id,
                                                             GValue * value,
                                                             GParamSpec * pspec)
{
	ConversationEmailMessageViewIterator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONVERSATION_EMAIL_TYPE_MESSAGE_VIEW_ITERATOR, ConversationEmailMessageViewIterator);
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
	switch (property_id) {
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
		case CONVERSATION_EMAIL_MESSAGE_VIEW_ITERATOR_READ_ONLY_PROPERTY:
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
		g_value_set_boolean (value, gee_iterator_get_read_only (G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_ITERATOR, GeeIterator)));
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
		break;
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
		case CONVERSATION_EMAIL_MESSAGE_VIEW_ITERATOR_VALID_PROPERTY:
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
		g_value_set_boolean (value, gee_iterator_get_valid (G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_ITERATOR, GeeIterator)));
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
		break;
#line 6633 "conversation-email.c"
		default:
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 68 "../src/client/conversation-viewer/conversation-email.vala"
		break;
#line 6639 "conversation-email.c"
	}
}

static void
conversation_email_class_init (ConversationEmailClass * klass,
                               gpointer klass_data)
{
	GtkBuilder* builder = NULL;
	GtkBuilder* _tmp0_;
	GtkBuilder* _tmp1_;
	GObject* _tmp2_;
	GMenuModel* _tmp3_;
	GtkBuilder* _tmp4_;
	GObject* _tmp5_;
	GMenuModel* _tmp6_;
	GtkBuilder* _tmp7_;
	GObject* _tmp8_;
	GMenuModel* _tmp9_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_type_class_adjust_private_offset (klass, &ConversationEmail_private_offset);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_conversation_email_get_property;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_conversation_email_set_property;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	G_OBJECT_CLASS (klass)->finalize = conversation_email_finalize;
#line 6668 "conversation-email.c"
	/**
	     * The specific email that is displayed by this view.
	     *
	     * This object is updated as additional fields are loaded, so it
	     * should not be relied on to a) contain required fields without
	     * testing or b) assumed to be the same over the life of this view
	     * object.
	     */
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONVERSATION_EMAIL_EMAIL_PROPERTY, conversation_email_properties[CONVERSATION_EMAIL_EMAIL_PROPERTY] = g_param_spec_object ("email", "email", "email", GEARY_TYPE_EMAIL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6679 "conversation-email.c"
	/** Determines if this email currently flagged as unread. */
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONVERSATION_EMAIL_IS_UNREAD_PROPERTY, conversation_email_properties[CONVERSATION_EMAIL_IS_UNREAD_PROPERTY] = g_param_spec_boolean ("is-unread", "is-unread", "is-unread", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6683 "conversation-email.c"
	/** Determines if this email currently flagged as starred. */
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONVERSATION_EMAIL_IS_STARRED_PROPERTY, conversation_email_properties[CONVERSATION_EMAIL_IS_STARRED_PROPERTY] = g_param_spec_boolean ("is-starred", "is-starred", "is-starred", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6687 "conversation-email.c"
	/** Determines if the email has been manually marked as being read. */
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONVERSATION_EMAIL_IS_MANUALLY_READ_PROPERTY, conversation_email_properties[CONVERSATION_EMAIL_IS_MANUALLY_READ_PROPERTY] = g_param_spec_boolean ("is-manually-read", "is-manually-read", "is-manually-read", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 6691 "conversation-email.c"
	/** Determines if the email is a draft message. */
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONVERSATION_EMAIL_IS_DRAFT_PROPERTY, conversation_email_properties[CONVERSATION_EMAIL_IS_DRAFT_PROPERTY] = g_param_spec_boolean ("is-draft", "is-draft", "is-draft", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6695 "conversation-email.c"
	/** The view displaying the email's primary message headers and body. */
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONVERSATION_EMAIL_PRIMARY_MESSAGE_PROPERTY, conversation_email_properties[CONVERSATION_EMAIL_PRIMARY_MESSAGE_PROPERTY] = g_param_spec_object ("primary-message", "primary-message", "primary-message", TYPE_CONVERSATION_MESSAGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONVERSATION_EMAIL_ATTACHMENTS_PANE_PROPERTY, conversation_email_properties[CONVERSATION_EMAIL_ATTACHMENTS_PANE_PROPERTY] = g_param_spec_object ("attachments-pane", "attachments-pane", "attachments-pane", COMPONENTS_TYPE_ATTACHMENT_PANE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6701 "conversation-email.c"
	/** Views for attached messages. */
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONVERSATION_EMAIL_ATTACHED_MESSAGES_PROPERTY, conversation_email_properties[CONVERSATION_EMAIL_ATTACHED_MESSAGES_PROPERTY] = g_param_spec_object ("attached-messages", "attached-messages", "attached-messages", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6705 "conversation-email.c"
	/** Determines the message body loading state. */
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONVERSATION_EMAIL_MESSAGE_BODY_STATE_PROPERTY, conversation_email_properties[CONVERSATION_EMAIL_MESSAGE_BODY_STATE_PROPERTY] = g_param_spec_enum ("message-body-state", "message-body-state", "message-body-state", CONVERSATION_EMAIL_TYPE_LOAD_STATE, CONVERSATION_EMAIL_LOAD_STATE_NOT_STARTED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Geary/conversation-email.ui");
#line 6711 "conversation-email.c"
	/** Fired when a internal link is activated */
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_signals[CONVERSATION_EMAIL_INTERNAL_LINK_ACTIVATED_SIGNAL] = g_signal_new ("internal-link-activated", TYPE_CONVERSATION_EMAIL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 6715 "conversation-email.c"
	/** Fired when the user selects text in a message. */
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_signals[CONVERSATION_EMAIL_BODY_SELECTION_CHANGED_SIGNAL] = g_signal_new ("body-selection-changed", TYPE_CONVERSATION_EMAIL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "actions", FALSE, ConversationEmail_private_offset + G_STRUCT_OFFSET (ConversationEmailPrivate, actions));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "attachments_button", FALSE, ConversationEmail_private_offset + G_STRUCT_OFFSET (ConversationEmailPrivate, attachments_button));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "star_button", FALSE, ConversationEmail_private_offset + G_STRUCT_OFFSET (ConversationEmailPrivate, star_button));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "unstar_button", FALSE, ConversationEmail_private_offset + G_STRUCT_OFFSET (ConversationEmailPrivate, unstar_button));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "email_menubutton", FALSE, ConversationEmail_private_offset + G_STRUCT_OFFSET (ConversationEmailPrivate, email_menubutton));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sub_messages", FALSE, ConversationEmail_private_offset + G_STRUCT_OFFSET (ConversationEmailPrivate, sub_messages));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_email_menu", G_CALLBACK(_conversation_email_on_email_menu_gtk_toggle_button_toggled));
#line 140 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = gtk_builder_new_from_resource ("/org/gnome/Geary/conversation-email-menus.ui");
#line 140 "../src/client/conversation-viewer/conversation-email.vala"
	builder = _tmp0_;
#line 143 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp1_ = builder;
#line 143 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp2_ = gtk_builder_get_object (_tmp1_, "email_menu");
#line 143 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, g_menu_model_get_type (), GMenuModel));
#line 143 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (conversation_email_email_menu_template);
#line 143 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_email_menu_template = _tmp3_;
#line 144 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp4_ = builder;
#line 144 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp5_ = gtk_builder_get_object (_tmp4_, "email_menu_trash");
#line 144 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, g_menu_model_get_type (), GMenuModel));
#line 144 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (conversation_email_email_menu_trash_section);
#line 144 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_email_menu_trash_section = _tmp6_;
#line 145 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp7_ = builder;
#line 145 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp8_ = gtk_builder_get_object (_tmp7_, "email_menu_delete");
#line 145 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, g_menu_model_get_type (), GMenuModel));
#line 145 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (conversation_email_email_menu_delete_section);
#line 145 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_email_menu_delete_section = _tmp9_;
#line 139 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (builder);
#line 6769 "conversation-email.c"
}

static void
conversation_email_geary_base_interface_interface_init (GearyBaseInterfaceIface * iface,
                                                        gpointer iface_data)
{
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	conversation_email_geary_base_interface_parent_iface = g_type_interface_peek_parent (iface);
#line 6778 "conversation-email.c"
}

static void
conversation_email_instance_init (ConversationEmail * self,
                                  gpointer klass)
{
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	self->priv = conversation_email_get_instance_private (self);
#line 176 "../src/client/conversation-viewer/conversation-email.vala"
	self->is_collapsed = TRUE;
#line 196 "../src/client/conversation-viewer/conversation-email.vala"
	self->priv->_attachments_pane = NULL;
#line 204 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp0_ = gee_linked_list_new (TYPE_CONVERSATION_MESSAGE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 204 "../src/client/conversation-viewer/conversation-email.vala"
	self->priv->_attached_messages = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_LIST, GeeList);
#line 208 "../src/client/conversation-viewer/conversation-email.vala"
	self->priv->_message_body_state = CONVERSATION_EMAIL_LOAD_STATE_NOT_STARTED;
#line 229 "../src/client/conversation-viewer/conversation-email.vala"
	self->priv->body_selection_message = NULL;
#line 233 "../src/client/conversation-viewer/conversation-email.vala"
	_tmp1_ = gee_linked_list_new (GEARY_TYPE_ATTACHMENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 233 "../src/client/conversation-viewer/conversation-email.vala"
	self->priv->displayed_attachments = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_LIST, GeeList);
#line 238 "../src/client/conversation-viewer/conversation-email.vala"
	self->priv->shift_handler_installed = FALSE;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 6809 "conversation-email.c"
}

static void
conversation_email_finalize (GObject * obj)
{
	ConversationEmail * self;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CONVERSATION_EMAIL, ConversationEmail);
#line 318 "../src/client/conversation-viewer/conversation-email.vala"
	geary_base_interface_base_unref (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_BASE_INTERFACE, GearyBaseInterface));
#line 157 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->priv->_email);
#line 194 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->priv->_primary_message);
#line 196 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->priv->_attachments_pane);
#line 204 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->priv->_attached_messages);
#line 210 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->conversation);
#line 213 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->priv->email_store);
#line 216 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->priv->contacts);
#line 219 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->priv->load_cancellable);
#line 221 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->priv->config);
#line 223 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->priv->body_loading_timeout);
#line 226 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->priv->message_bodies_loaded_lock);
#line 229 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->priv->body_selection_message);
#line 233 "../src/client/conversation-viewer/conversation-email.vala"
	_g_object_unref0 (self->priv->displayed_attachments);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	G_OBJECT_CLASS (conversation_email_parent_class)->finalize (obj);
#line 6848 "conversation-email.c"
}

/**
 * A widget for displaying an email in a conversation.
 *
 * This view corresponds to {@link Geary.Email}, displaying the
 * email's primary message (a {@link Geary.RFC822.Message}), any
 * sub-messages (also instances of {@link Geary.RFC822.Message}) and
 * attachments. The RFC822 messages are themselves displayed by {@link
 * ConversationMessage}.
 */
static GType
conversation_email_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ConversationEmailClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) conversation_email_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ConversationEmail), 0, (GInstanceInitFunc) conversation_email_instance_init, NULL };
	static const GInterfaceInfo geary_base_interface_info = { (GInterfaceInitFunc) conversation_email_geary_base_interface_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType conversation_email_type_id;
	conversation_email_type_id = g_type_register_static (gtk_box_get_type (), "ConversationEmail", &g_define_type_info, 0);
	g_type_add_interface_static (conversation_email_type_id, GEARY_TYPE_BASE_INTERFACE, &geary_base_interface_info);
	ConversationEmail_private_offset = g_type_add_instance_private (conversation_email_type_id, sizeof (ConversationEmailPrivate));
	return conversation_email_type_id;
}

GType
conversation_email_get_type (void)
{
	static volatile gsize conversation_email_type_id__once = 0;
	if (g_once_init_enter (&conversation_email_type_id__once)) {
		GType conversation_email_type_id;
		conversation_email_type_id = conversation_email_get_type_once ();
		g_once_init_leave (&conversation_email_type_id__once, conversation_email_type_id);
	}
	return conversation_email_type_id__once;
}

static void
_vala_conversation_email_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	ConversationEmail * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CONVERSATION_EMAIL, ConversationEmail);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	switch (property_id) {
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		case CONVERSATION_EMAIL_EMAIL_PROPERTY:
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		g_value_set_object (value, conversation_email_get_email (self));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		break;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		case CONVERSATION_EMAIL_IS_UNREAD_PROPERTY:
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		g_value_set_boolean (value, conversation_email_get_is_unread (self));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		break;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		case CONVERSATION_EMAIL_IS_STARRED_PROPERTY:
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		g_value_set_boolean (value, conversation_email_get_is_starred (self));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		break;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		case CONVERSATION_EMAIL_IS_MANUALLY_READ_PROPERTY:
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		g_value_set_boolean (value, conversation_email_get_is_manually_read (self));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		break;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		case CONVERSATION_EMAIL_IS_DRAFT_PROPERTY:
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		g_value_set_boolean (value, conversation_email_get_is_draft (self));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		break;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		case CONVERSATION_EMAIL_PRIMARY_MESSAGE_PROPERTY:
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		g_value_set_object (value, conversation_email_get_primary_message (self));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		break;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		case CONVERSATION_EMAIL_ATTACHMENTS_PANE_PROPERTY:
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		g_value_set_object (value, conversation_email_get_attachments_pane (self));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		break;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		case CONVERSATION_EMAIL_ATTACHED_MESSAGES_PROPERTY:
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		g_value_take_object (value, conversation_email_get_attached_messages (self));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		break;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		case CONVERSATION_EMAIL_MESSAGE_BODY_STATE_PROPERTY:
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		g_value_set_enum (value, conversation_email_get_message_body_state (self));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		break;
#line 6948 "conversation-email.c"
		default:
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		break;
#line 6954 "conversation-email.c"
	}
}

static void
_vala_conversation_email_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	ConversationEmail * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CONVERSATION_EMAIL, ConversationEmail);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
	switch (property_id) {
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		case CONVERSATION_EMAIL_EMAIL_PROPERTY:
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		conversation_email_set_email (self, g_value_get_object (value));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		break;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		case CONVERSATION_EMAIL_IS_MANUALLY_READ_PROPERTY:
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		conversation_email_set_is_manually_read (self, g_value_get_boolean (value));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		break;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		case CONVERSATION_EMAIL_IS_DRAFT_PROPERTY:
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		conversation_email_set_is_draft (self, g_value_get_boolean (value));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		break;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		case CONVERSATION_EMAIL_PRIMARY_MESSAGE_PROPERTY:
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		conversation_email_set_primary_message (self, g_value_get_object (value));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		break;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		case CONVERSATION_EMAIL_ATTACHMENTS_PANE_PROPERTY:
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		conversation_email_set_attachments_pane (self, g_value_get_object (value));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		break;
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		case CONVERSATION_EMAIL_MESSAGE_BODY_STATE_PROPERTY:
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		conversation_email_set_message_body_state (self, g_value_get_enum (value));
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		break;
#line 7004 "conversation-email.c"
		default:
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/client/conversation-viewer/conversation-email.vala"
		break;
#line 7010 "conversation-email.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

