/* mail-merge.c generated by valac 0.56.17, the Vala compiler
 * generated from mail-merge.vala, do not modify */

/*
 * Copyright © 2020 Michael Gratton <mike@vee.net>.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "mail-merge.h"
#include <glib-object.h>
#include <glib.h>
#include <libpeas/peas.h>
#include "geary-client-46.0.h"
#include "util.h"
#include <gio/gio.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include "geary-engine.h"
#include <gtk/gtk.h>

#define PLUGIN_MAIL_MERGE_LOC_NAMES _ ("Templates | Template Mail | Template Email | Template E-Mail")
#define PLUGIN_MAIL_MERGE_UNLOC_NAMES "Templates | Template Mail | Template Email | Template E-Mail"
#define PLUGIN_MAIL_MERGE_ACTION_EDIT "edit-template"
#define PLUGIN_MAIL_MERGE_ACTION_INSERT_FIELD "insert-field"
#define PLUGIN_MAIL_MERGE_ACTION_MERGE "merge-template"
#define PLUGIN_MAIL_MERGE_ACTION_LOAD "load-merge-data"
#define PLUGIN_MAIL_MERGE_ACTION_START "start-send"
#define PLUGIN_MAIL_MERGE_ACTION_PAUSE "pause-send"
#define PLUGIN_MAIL_MERGE_INFO_BAR_PRIORITY 10
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	PLUGIN_MAIL_MERGE_0_PROPERTY,
	PLUGIN_MAIL_MERGE_FOLDERS_PROPERTY,
	PLUGIN_MAIL_MERGE_EMAIL_PROPERTY,
	PLUGIN_MAIL_MERGE_CLIENT_APPLICATION_PROPERTY,
	PLUGIN_MAIL_MERGE_CLIENT_PLUGINS_PROPERTY,
	PLUGIN_MAIL_MERGE_NUM_PROPERTIES
};
static GParamSpec* plugin_mail_merge_properties[PLUGIN_MAIL_MERGE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _PluginMailMergeActivateData PluginMailMergeActivateData;
typedef struct _PluginMailMergeDeactivateData PluginMailMergeDeactivateData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _PluginMailMergeEditEmailData PluginMailMergeEditEmailData;
typedef struct _PluginMailMergeMergeEmailData PluginMailMergeMergeEmailData;
typedef struct _PluginMailMergeUpdateEmailData PluginMailMergeUpdateEmailData;
typedef struct _Block1Data Block1Data;
typedef struct _PluginMailMergeUpdateComposerData PluginMailMergeUpdateComposerData;
typedef struct _Block2Data Block2Data;
typedef struct _PluginMailMergeLoadComposerDataData PluginMailMergeLoadComposerDataData;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _PluginMailMergeNewComposerActionBarData PluginMailMergeNewComposerActionBarData;
typedef struct _PluginMailMergeLoadMergeEmailData PluginMailMergeLoadMergeEmailData;

struct _PluginMailMergePrivate {
	PluginFolderContext* _folders;
	PluginEmailContext* _email;
	ApplicationClient* _client_application;
	ApplicationPluginManager* _client_plugins;
	PluginFolderStore* folder_store;
	PluginEmailStore* email_store;
	MailMergeFolder* merge_folder;
	PluginInfoBar* merge_bar;
	GSimpleAction* edit_action;
	GSimpleAction* merge_action;
	GSimpleAction* start_action;
	GSimpleAction* pause_action;
	PluginActionable* start_ui;
	PluginActionable* pause_ui;
	GeeList* folder_names;
	GCancellable* cancellable;
};

struct _PluginMailMergeActivateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PluginMailMerge* self;
	gboolean is_startup;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	GearyIterable* _tmp3_;
	GearyIterable* _tmp4_;
	GearyIterable* _tmp5_;
	GearyIterable* _tmp6_;
	GeeList* _tmp7_;
	GeeCollection* _tmp8_;
	GeeCollection* _tmp9_;
	gchar** _tmp10_;
	gchar** _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	GearyIterable* _tmp13_;
	GearyIterable* _tmp14_;
	GearyIterable* _tmp15_;
	GearyIterable* _tmp16_;
	GeeList* _tmp17_;
	GeeCollection* _tmp18_;
	GeeCollection* _tmp19_;
	PluginFolderStore* _tmp20_;
	PluginFolderContext* _tmp21_;
	PluginFolderContext* _tmp22_;
	PluginFolderStore* _tmp23_;
	PluginFolderStore* _tmp24_;
	PluginFolderStore* _tmp25_;
	PluginFolderStore* _tmp26_;
	PluginEmailStore* _tmp27_;
	PluginEmailContext* _tmp28_;
	PluginEmailContext* _tmp29_;
	PluginEmailStore* _tmp30_;
	PluginEmailStore* _tmp31_;
	PluginEmailStore* _tmp32_;
	PluginEmailStore* _tmp33_;
	const GVariantType* _tmp34_;
	const GVariantType* _tmp35_;
	GSimpleAction* _tmp36_;
	GSimpleAction* _tmp37_;
	PluginApplication* _tmp38_;
	PluginApplication* _tmp39_;
	GSimpleAction* _tmp40_;
	PluginEmailStore* _tmp41_;
	const GVariantType* _tmp42_;
	const GVariantType* _tmp43_;
	GSimpleAction* _tmp44_;
	GSimpleAction* _tmp45_;
	PluginApplication* _tmp46_;
	PluginApplication* _tmp47_;
	GSimpleAction* _tmp48_;
	GSimpleAction* _tmp49_;
	GSimpleAction* _tmp50_;
	PluginApplication* _tmp51_;
	PluginApplication* _tmp52_;
	GSimpleAction* _tmp53_;
	GSimpleAction* _tmp54_;
	PluginActionable* _tmp55_;
	GSimpleAction* _tmp56_;
	GSimpleAction* _tmp57_;
	PluginApplication* _tmp58_;
	PluginApplication* _tmp59_;
	GSimpleAction* _tmp60_;
	GSimpleAction* _tmp61_;
	PluginActionable* _tmp62_;
	PluginApplication* _tmp63_;
	PluginApplication* _tmp64_;
	GError* _inner_error0_;
};

struct _PluginMailMergeDeactivateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PluginMailMerge* self;
	gboolean is_shutdown;
	GCancellable* _tmp0_;
	PluginApplication* _tmp1_;
	PluginApplication* _tmp2_;
	GSimpleAction* _tmp3_;
	PluginApplication* _tmp4_;
	PluginApplication* _tmp5_;
	GSimpleAction* _tmp6_;
	PluginEmailStore* _tmp7_;
	guint _tmp8_;
	GeeList* _tmp9_;
};

struct _PluginMailMergeEditEmailData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PluginMailMerge* self;
	PluginEmailIdentifier* id;
	PluginComposer* composer;
	PluginApplication* _tmp0_;
	PluginApplication* _tmp1_;
	PluginAccount* _tmp2_;
	PluginAccount* _tmp3_;
	PluginComposer* _tmp4_;
	GeeCollection* containing;
	PluginFolderStore* _tmp5_;
	GCancellable* _tmp6_;
	GeeCollection* _tmp7_;
	PluginFolder* folder;
	GeeCollection* _tmp8_;
	gpointer _tmp9_;
	PluginComposer* _tmp10_;
	PluginFolder* _tmp11_;
	PluginComposer* _tmp12_;
	PluginComposer* _tmp13_;
	GError* err;
	GError* _tmp14_;
	const gchar* _tmp15_;
	GError* _inner_error0_;
};

struct _PluginMailMergeMergeEmailData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PluginMailMerge* self;
	PluginEmailIdentifier* id;
	GFile* default_csv_file;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* csv_file;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFileInputStream* csv_input;
	GFile* _tmp5_;
	GCancellable* _tmp6_;
	GFileInputStream* _tmp7_;
	MailMergeCsvReader* csv;
	GFileInputStream* _tmp8_;
	GCancellable* _tmp9_;
	MailMergeCsvReader* _tmp10_;
	GeeCollection* emails;
	PluginEmailStore* _tmp11_;
	GeeCollection* _tmp12_;
	GeeCollection* _tmp13_;
	GCancellable* _tmp14_;
	GeeCollection* _tmp15_;
	GeeCollection* _tmp16_;
	GeeCollection* _tmp17_;
	gboolean _tmp18_;
	gboolean _tmp19_;
	ApplicationAccountContext* account_context;
	ApplicationPluginManager* _tmp20_;
	ApplicationPluginManager* _tmp21_;
	PluginAccount* _tmp22_;
	PluginAccount* _tmp23_;
	ApplicationAccountContext* _tmp24_;
	PluginEmail* email;
	GeeCollection* _tmp25_;
	gpointer _tmp26_;
	GearyEmail* _tmp27_;
	PluginEmail* _tmp28_;
	GearyEmail* _tmp29_;
	MailMergeFolder* _tmp30_;
	ApplicationAccountContext* _tmp31_;
	GearyAccount* _tmp32_;
	GearyAccount* _tmp33_;
	ApplicationAccountContext* _tmp34_;
	GearyAccount* _tmp35_;
	GearyAccount* _tmp36_;
	GearyFolderRoot* _tmp37_;
	GearyFolderRoot* _tmp38_;
	GFile* _tmp39_;
	MailMergeCsvReader* _tmp40_;
	MailMergeFolder* _tmp41_;
	MailMergeFolder* _tmp42_;
	MailMergeFolder* _tmp43_;
	const gchar* _tmp44_;
	const gchar* _tmp45_;
	PluginInfoBar* _tmp46_;
	PluginInfoBar* _tmp47_;
	PluginInfoBar* _tmp48_;
	MailMergeFolder* _tmp49_;
	MailMergeFolder* _tmp50_;
	ApplicationAccountContext* _tmp51_;
	GearyAccount* _tmp52_;
	GearyAccount* _tmp53_;
	MailMergeFolder* _tmp54_;
	ApplicationMainWindow* main;
	ApplicationClient* _tmp55_;
	ApplicationClient* _tmp56_;
	ApplicationMainWindow* _tmp57_;
	ApplicationMainWindow* _tmp58_;
	MailMergeFolder* _tmp59_;
	GError* err;
	GError* _tmp60_;
	const gchar* _tmp61_;
	GError* _inner_error0_;
};

struct _PluginMailMergeUpdateEmailData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PluginMailMerge* self;
	PluginEmail* target;
	GeeCollection* containing;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	PluginFolderStore* _tmp2_;
	PluginEmailIdentifier* _tmp3_;
	PluginEmailIdentifier* _tmp4_;
	GCancellable* _tmp5_;
	GeeCollection* _tmp6_;
	GeeCollection* _tmp7_;
	GError* err;
	GError* _tmp8_;
	const gchar* _tmp9_;
	GeeCollection* _tmp10_;
	GearyEmail* email;
	GearyEmail* _tmp11_;
	gboolean _tmp12_;
	GearyEmail* _tmp13_;
	PluginEmailContext* _tmp14_;
	PluginEmailContext* _tmp15_;
	PluginEmailIdentifier* _tmp16_;
	PluginEmailIdentifier* _tmp17_;
	PluginEmailIdentifier* _tmp18_;
	PluginEmailIdentifier* _tmp19_;
	PluginInfoBar* _tmp20_;
	PluginInfoBar* _tmp21_;
	GError* _vala1_err;
	GError* _tmp22_;
	const gchar* _tmp23_;
	GError* _inner_error0_;
};

struct _Block1Data {
	int _ref_count_;
	PluginMailMerge* self;
	PluginComposer* composer;
	gpointer _async_data_;
};

struct _PluginMailMergeUpdateComposerData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PluginMailMerge* self;
	PluginComposer* composer;
	Block1Data* _data1_;
	GSimpleAction* load_action;
	GSimpleAction* _tmp0_;
	PluginActionable* _tmp1_;
	PluginActionable* _tmp2_;
};

struct _Block2Data {
	int _ref_count_;
	PluginMailMerge* self;
	PluginComposer* composer;
	gpointer _async_data_;
};

struct _PluginMailMergeLoadComposerDataData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PluginMailMerge* self;
	PluginComposer* composer;
	Block2Data* _data2_;
	GFile* data;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GSimpleAction* insert_field_action;
	const GVariantType* _tmp2_;
	GSimpleAction* _tmp3_;
	GSimpleAction* _tmp4_;
	GSimpleAction* _tmp5_;
	PluginActionBar* _tmp6_;
	GFile* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	PluginActionBar* _tmp10_;
	GError* err;
	GError* _tmp11_;
	const gchar* _tmp12_;
	GError* _inner_error0_;
};

struct _PluginMailMergeNewComposerActionBarData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PluginMailMerge* self;
	GFile* csv_file;
	gchar* action_group_name;
	PluginActionBar* result;
	GFileInfo* info;
	GCancellable* _tmp0_;
	GFileInfo* _tmp1_;
	GFileInputStream* input;
	GCancellable* _tmp2_;
	GFileInputStream* _tmp3_;
	MailMergeCsvReader* csv;
	GFileInputStream* _tmp4_;
	GCancellable* _tmp5_;
	MailMergeCsvReader* _tmp6_;
	gchar** record;
	MailMergeCsvReader* _tmp7_;
	gint _tmp8_;
	gchar** _tmp9_;
	gint record_length1;
	gint _record_size_;
	GMenu* text_fields_menu;
	GMenu* _tmp10_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar** field_collection;
	gint field_collection_length1;
	gint _field_collection_size_;
	gint field_it;
	gchar* _tmp12_;
	gchar* field;
	GMenu* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	const gchar* _tmp19_;
	GVariant* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	PluginActionBar* action_bar;
	PluginActionBar* _tmp23_;
	PluginActionBar* _tmp24_;
	GMenu* _tmp25_;
	PluginActionBarMenuItem* _tmp26_;
	PluginActionBarMenuItem* _tmp27_;
	PluginActionBar* _tmp28_;
	GFileInfo* _tmp29_;
	const gchar* _tmp30_;
	PluginActionBarLabelItem* _tmp31_;
	PluginActionBarLabelItem* _tmp32_;
	GError* _inner_error0_;
};

struct _PluginMailMergeLoadMergeEmailData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PluginMailMerge* self;
	PluginEmail* plugin;
	GearyEmail* result;
	GearyEmail* engine;
	ApplicationPluginManager* _tmp0_;
	ApplicationPluginManager* _tmp1_;
	GearyEmail* _tmp2_;
	gboolean _tmp3_;
	GearyEmail* _tmp4_;
	GearyEmail* _tmp5_;
	GearyEmailField _tmp6_;
	GearyEmailField _tmp7_;
	ApplicationAccountContext* account_context;
	ApplicationPluginManager* _tmp8_;
	ApplicationPluginManager* _tmp9_;
	PluginEmailIdentifier* _tmp10_;
	PluginEmailIdentifier* _tmp11_;
	PluginAccount* _tmp12_;
	PluginAccount* _tmp13_;
	ApplicationAccountContext* _tmp14_;
	GearyEmail* _tmp15_;
	ApplicationAccountContext* _tmp16_;
	GearyAppEmailStore* _tmp17_;
	GearyAppEmailStore* _tmp18_;
	GearyEmail* _tmp19_;
	GearyEmailIdentifier* _tmp20_;
	GearyEmailIdentifier* _tmp21_;
	GCancellable* _tmp22_;
	GearyEmail* _tmp23_;
	GearyEmail* _tmp24_;
	GearyEmail* _tmp25_;
	GError* _tmp26_;
	GError* _inner_error0_;
};

static gint PluginMailMerge_private_offset;
static gpointer plugin_mail_merge_parent_class = NULL;
static PluginFolderExtensionIface * plugin_mail_merge_plugin_folder_extension_parent_iface = NULL;
static PluginEmailExtensionIface * plugin_mail_merge_plugin_email_extension_parent_iface = NULL;
static PluginTrustedExtensionIface * plugin_mail_merge_plugin_trusted_extension_parent_iface = NULL;
static GType plugin_mail_merge_type_id = 0;

static void plugin_mail_merge_real_activate_data_free (gpointer _data);
static void plugin_mail_merge_real_activate (PluginPluginBase* base,
                                      gboolean is_startup,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static gboolean plugin_mail_merge_real_activate_co (PluginMailMergeActivateData* _data_);
static gchar* __lambda4_ (PluginMailMerge* self,
                   gchar* name);
static gpointer ___lambda4__gee_map_func (gpointer g,
                                   gpointer self);
static gchar* __lambda5_ (PluginMailMerge* self,
                   gchar* name);
static gpointer ___lambda5__gee_map_func (gpointer g,
                                   gpointer self);
static void plugin_mail_merge_activate_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_);
static void plugin_mail_merge_on_folders_available (PluginMailMerge* self,
                                             GeeCollection* available);
static void _plugin_mail_merge_on_folders_available_plugin_folder_store_folders_available (PluginFolderStore* _sender,
                                                                                    GeeCollection* available,
                                                                                    gpointer self);
static void plugin_mail_merge_on_folder_selected (PluginMailMerge* self,
                                           PluginFolder* selected);
static void _plugin_mail_merge_on_folder_selected_plugin_folder_store_folder_selected (PluginFolderStore* _sender,
                                                                                PluginFolder* selected,
                                                                                gpointer self);
static void plugin_mail_merge_on_email_displayed (PluginMailMerge* self,
                                           PluginEmail* email);
static void _plugin_mail_merge_on_email_displayed_plugin_email_store_email_displayed (PluginEmailStore* _sender,
                                                                               PluginEmail* sent,
                                                                               gpointer self);
static void plugin_mail_merge_on_edit_activated (PluginMailMerge* self,
                                          GAction* action,
                                          GVariant* target);
static void _plugin_mail_merge_on_edit_activated_g_simple_action_activate (GSimpleAction* _sender,
                                                                    GVariant* parameter,
                                                                    gpointer self);
static void plugin_mail_merge_on_merge_activated (PluginMailMerge* self,
                                           GAction* action,
                                           GVariant* target);
static void _plugin_mail_merge_on_merge_activated_g_simple_action_activate (GSimpleAction* _sender,
                                                                     GVariant* parameter,
                                                                     gpointer self);
static void plugin_mail_merge_on_start_activated (PluginMailMerge* self,
                                           GAction* action,
                                           GVariant* target);
static void _plugin_mail_merge_on_start_activated_g_simple_action_activate (GSimpleAction* _sender,
                                                                     GVariant* parameter,
                                                                     gpointer self);
static void plugin_mail_merge_on_pause_activated (PluginMailMerge* self,
                                           GAction* action,
                                           GVariant* target);
static void _plugin_mail_merge_on_pause_activated_g_simple_action_activate (GSimpleAction* _sender,
                                                                     GVariant* parameter,
                                                                     gpointer self);
static void plugin_mail_merge_on_composer_registered (PluginMailMerge* self,
                                               PluginComposer* registered);
static void _plugin_mail_merge_on_composer_registered_plugin_application_composer_registered (PluginApplication* _sender,
                                                                                       PluginComposer* composer,
                                                                                       gpointer self);
static void plugin_mail_merge_real_deactivate_data_free (gpointer _data);
static void plugin_mail_merge_real_deactivate (PluginPluginBase* base,
                                        gboolean is_shutdown,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
static gboolean plugin_mail_merge_real_deactivate_co (PluginMailMergeDeactivateData* _data_);
static void plugin_mail_merge_edit_email_data_free (gpointer _data);
static void plugin_mail_merge_edit_email (PluginMailMerge* self,
                                   PluginEmailIdentifier* id,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
static void plugin_mail_merge_edit_email_finish (PluginMailMerge* self,
                                          GAsyncResult* _res_);
static gboolean plugin_mail_merge_edit_email_co (PluginMailMergeEditEmailData* _data_);
static void plugin_mail_merge_edit_email_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_);
static gboolean ___lambda7_ (PluginMailMerge* self,
                      PluginFolder* f);
static gboolean ____lambda7__gee_predicate (gconstpointer g,
                                     gpointer self);
static void plugin_mail_merge_merge_email_data_free (gpointer _data);
static void plugin_mail_merge_merge_email (PluginMailMerge* self,
                                    PluginEmailIdentifier* id,
                                    GFile* default_csv_file,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
static void plugin_mail_merge_merge_email_finish (PluginMailMerge* self,
                                           GAsyncResult* _res_);
static gboolean plugin_mail_merge_merge_email_co (PluginMailMergeMergeEmailData* _data_);
static GFile* plugin_mail_merge_show_merge_data_chooser (PluginMailMerge* self);
static void plugin_mail_merge_merge_email_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_);
static void plugin_mail_merge_load_merge_email (PluginMailMerge* self,
                                         PluginEmail* plugin,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
static GearyEmail* plugin_mail_merge_load_merge_email_finish (PluginMailMerge* self,
                                                       GAsyncResult* _res_,
                                                       GError** error);
static void plugin_mail_merge_update_merge_folder_info_bar (PluginMailMerge* self);
static void plugin_mail_merge_on_merge_closed (PluginMailMerge* self);
static void _plugin_mail_merge_on_merge_closed_plugin_info_bar_close_activated (PluginInfoBar* _sender,
                                                                         gpointer self);
static void _____lambda8_ (PluginMailMerge* self);
static void ______lambda8__g_object_notify (GObject* _sender,
                                     GParamSpec* pspec,
                                     gpointer self);
static void _____lambda9_ (PluginMailMerge* self);
static void ______lambda9__g_object_notify (GObject* _sender,
                                     GParamSpec* pspec,
                                     gpointer self);
static void plugin_mail_merge_update_email_data_free (gpointer _data);
static void plugin_mail_merge_update_email (PluginMailMerge* self,
                                     PluginEmail* target,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
static void plugin_mail_merge_update_email_finish (PluginMailMerge* self,
                                            GAsyncResult* _res_);
static gboolean plugin_mail_merge_update_email_co (PluginMailMergeUpdateEmailData* _data_);
static void plugin_mail_merge_update_email_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_);
static gboolean __lambda6_ (PluginMailMerge* self,
                     PluginFolder* f);
static gboolean ___lambda6__gee_predicate (gconstpointer g,
                                    gpointer self);
static PluginInfoBar* plugin_mail_merge_new_template_email_info_bar (PluginMailMerge* self,
                                                              PluginEmailIdentifier* target);
static void plugin_mail_merge_update_composer_data_free (gpointer _data);
static void plugin_mail_merge_update_composer (PluginMailMerge* self,
                                        PluginComposer* composer,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
static void plugin_mail_merge_update_composer_finish (PluginMailMerge* self,
                                               GAsyncResult* _res_);
static gboolean plugin_mail_merge_update_composer_co (PluginMailMergeUpdateComposerData* _data_);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void ___lambda10_ (Block1Data* _data1_);
static void plugin_mail_merge_load_composer_data (PluginMailMerge* self,
                                           PluginComposer* composer,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
static void plugin_mail_merge_load_composer_data_finish (PluginMailMerge* self,
                                                  GAsyncResult* _res_);
static void ____lambda10__g_simple_action_activate (GSimpleAction* _sender,
                                             GVariant* parameter,
                                             gpointer self);
static void plugin_mail_merge_load_composer_data_data_free (gpointer _data);
static gboolean plugin_mail_merge_load_composer_data_co (PluginMailMergeLoadComposerDataData* _data_);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void ___lambda11_ (Block2Data* _data2_,
                   GVariant* param);
static void plugin_mail_merge_insert_field (PluginMailMerge* self,
                                     PluginComposer* composer,
                                     const gchar* field);
static gchar* _variant_get1 (GVariant* value);
static void ____lambda11__g_simple_action_activate (GSimpleAction* _sender,
                                             GVariant* parameter,
                                             gpointer self);
static void plugin_mail_merge_new_composer_action_bar (PluginMailMerge* self,
                                                GFile* csv_file,
                                                const gchar* action_group_name,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static PluginActionBar* plugin_mail_merge_new_composer_action_bar_finish (PluginMailMerge* self,
                                                                   GAsyncResult* _res_,
                                                                   GError** error);
static void plugin_mail_merge_load_composer_data_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_);
static void plugin_mail_merge_new_composer_action_bar_data_free (gpointer _data);
static gboolean plugin_mail_merge_new_composer_action_bar_co (PluginMailMergeNewComposerActionBarData* _data_);
static void plugin_mail_merge_new_composer_action_bar_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
static GVariant* _variant_new1 (const gchar* value);
static void plugin_mail_merge_load_merge_email_data_free (gpointer _data);
static gboolean plugin_mail_merge_load_merge_email_co (PluginMailMergeLoadMergeEmailData* _data_);
static void plugin_mail_merge_load_merge_email_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static void plugin_mail_merge_finalize (GObject * obj);
static void _vala_plugin_mail_merge_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_plugin_mail_merge_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static gpointer
_g_object_ref0 (gpointer self)
{
#line 10 "../src/client/plugin/mail-merge/mail-merge.vala"
	return self ? g_object_ref (self) : NULL;
#line 702 "mail-merge.c"
}

void
peas_register_types (GTypeModule* module)
{
	PeasObjectModule* obj = NULL;
	PeasObjectModule* _tmp0_;
#line 9 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (module, g_type_module_get_type ()));
#line 9 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_register_type (module);
#line 10 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (module, peas_object_module_get_type ()) ? ((PeasObjectModule*) module) : NULL);
#line 10 "../src/client/plugin/mail-merge/mail-merge.vala"
	obj = _tmp0_;
#line 11 "../src/client/plugin/mail-merge/mail-merge.vala"
	peas_object_module_register_extension_type (obj, PLUGIN_TYPE_PLUGIN_BASE, PLUGIN_TYPE_MAIL_MERGE);
#line 9 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (obj);
#line 722 "mail-merge.c"
}

static inline gpointer
plugin_mail_merge_get_instance_private (PluginMailMerge* self)
{
	return G_STRUCT_MEMBER_P (self, PluginMailMerge_private_offset);
}

static PluginFolderContext*
plugin_mail_merge_real_get_folders (PluginFolderExtension* base)
{
	PluginFolderContext* result;
	PluginMailMerge* self;
	PluginFolderContext* _tmp0_;
#line 48 "../src/client/plugin/mail-merge/mail-merge.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PLUGIN_TYPE_MAIL_MERGE, PluginMailMerge);
#line 48 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = self->priv->_folders;
#line 48 "../src/client/plugin/mail-merge/mail-merge.vala"
	result = _tmp0_;
#line 48 "../src/client/plugin/mail-merge/mail-merge.vala"
	return result;
#line 745 "mail-merge.c"
}

static void
plugin_mail_merge_real_set_folders (PluginFolderExtension* base,
                                    PluginFolderContext* value)
{
	PluginMailMerge* self;
	PluginFolderContext* old_value;
#line 48 "../src/client/plugin/mail-merge/mail-merge.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PLUGIN_TYPE_MAIL_MERGE, PluginMailMerge);
#line 48 "../src/client/plugin/mail-merge/mail-merge.vala"
	old_value = plugin_mail_merge_real_get_folders (base);
#line 48 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (old_value != value) {
#line 760 "mail-merge.c"
		PluginFolderContext* _tmp0_;
#line 48 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 48 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (self->priv->_folders);
#line 48 "../src/client/plugin/mail-merge/mail-merge.vala"
		self->priv->_folders = _tmp0_;
#line 48 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_object_notify_by_pspec ((GObject *) self, plugin_mail_merge_properties[PLUGIN_MAIL_MERGE_FOLDERS_PROPERTY]);
#line 770 "mail-merge.c"
	}
}

static PluginEmailContext*
plugin_mail_merge_real_get_email (PluginEmailExtension* base)
{
	PluginEmailContext* result;
	PluginMailMerge* self;
	PluginEmailContext* _tmp0_;
#line 52 "../src/client/plugin/mail-merge/mail-merge.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PLUGIN_TYPE_MAIL_MERGE, PluginMailMerge);
#line 52 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = self->priv->_email;
#line 52 "../src/client/plugin/mail-merge/mail-merge.vala"
	result = _tmp0_;
#line 52 "../src/client/plugin/mail-merge/mail-merge.vala"
	return result;
#line 788 "mail-merge.c"
}

static void
plugin_mail_merge_real_set_email (PluginEmailExtension* base,
                                  PluginEmailContext* value)
{
	PluginMailMerge* self;
	PluginEmailContext* old_value;
#line 52 "../src/client/plugin/mail-merge/mail-merge.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PLUGIN_TYPE_MAIL_MERGE, PluginMailMerge);
#line 52 "../src/client/plugin/mail-merge/mail-merge.vala"
	old_value = plugin_mail_merge_real_get_email (base);
#line 52 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (old_value != value) {
#line 803 "mail-merge.c"
		PluginEmailContext* _tmp0_;
#line 52 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 52 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (self->priv->_email);
#line 52 "../src/client/plugin/mail-merge/mail-merge.vala"
		self->priv->_email = _tmp0_;
#line 52 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_object_notify_by_pspec ((GObject *) self, plugin_mail_merge_properties[PLUGIN_MAIL_MERGE_EMAIL_PROPERTY]);
#line 813 "mail-merge.c"
	}
}

static ApplicationClient*
plugin_mail_merge_real_get_client_application (PluginTrustedExtension* base)
{
	ApplicationClient* result;
	PluginMailMerge* self;
	ApplicationClient* _tmp0_;
#line 56 "../src/client/plugin/mail-merge/mail-merge.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PLUGIN_TYPE_MAIL_MERGE, PluginMailMerge);
#line 56 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = self->priv->_client_application;
#line 56 "../src/client/plugin/mail-merge/mail-merge.vala"
	result = _tmp0_;
#line 56 "../src/client/plugin/mail-merge/mail-merge.vala"
	return result;
#line 831 "mail-merge.c"
}

static void
plugin_mail_merge_real_set_client_application (PluginTrustedExtension* base,
                                               ApplicationClient* value)
{
	PluginMailMerge* self;
	ApplicationClient* old_value;
#line 56 "../src/client/plugin/mail-merge/mail-merge.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PLUGIN_TYPE_MAIL_MERGE, PluginMailMerge);
#line 56 "../src/client/plugin/mail-merge/mail-merge.vala"
	old_value = plugin_mail_merge_real_get_client_application (base);
#line 56 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (old_value != value) {
#line 846 "mail-merge.c"
		ApplicationClient* _tmp0_;
#line 56 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 56 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (self->priv->_client_application);
#line 56 "../src/client/plugin/mail-merge/mail-merge.vala"
		self->priv->_client_application = _tmp0_;
#line 56 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_object_notify_by_pspec ((GObject *) self, plugin_mail_merge_properties[PLUGIN_MAIL_MERGE_CLIENT_APPLICATION_PROPERTY]);
#line 856 "mail-merge.c"
	}
}

static ApplicationPluginManager*
plugin_mail_merge_real_get_client_plugins (PluginTrustedExtension* base)
{
	ApplicationPluginManager* result;
	PluginMailMerge* self;
	ApplicationPluginManager* _tmp0_;
#line 60 "../src/client/plugin/mail-merge/mail-merge.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PLUGIN_TYPE_MAIL_MERGE, PluginMailMerge);
#line 60 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = self->priv->_client_plugins;
#line 60 "../src/client/plugin/mail-merge/mail-merge.vala"
	result = _tmp0_;
#line 60 "../src/client/plugin/mail-merge/mail-merge.vala"
	return result;
#line 874 "mail-merge.c"
}

static void
plugin_mail_merge_real_set_client_plugins (PluginTrustedExtension* base,
                                           ApplicationPluginManager* value)
{
	PluginMailMerge* self;
	ApplicationPluginManager* old_value;
#line 60 "../src/client/plugin/mail-merge/mail-merge.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PLUGIN_TYPE_MAIL_MERGE, PluginMailMerge);
#line 60 "../src/client/plugin/mail-merge/mail-merge.vala"
	old_value = plugin_mail_merge_real_get_client_plugins (base);
#line 60 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (old_value != value) {
#line 889 "mail-merge.c"
		ApplicationPluginManager* _tmp0_;
#line 60 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 60 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (self->priv->_client_plugins);
#line 60 "../src/client/plugin/mail-merge/mail-merge.vala"
		self->priv->_client_plugins = _tmp0_;
#line 60 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_object_notify_by_pspec ((GObject *) self, plugin_mail_merge_properties[PLUGIN_MAIL_MERGE_CLIENT_PLUGINS_PROPERTY]);
#line 899 "mail-merge.c"
	}
}

static void
plugin_mail_merge_real_activate_data_free (gpointer _data)
{
	PluginMailMergeActivateData* _data_;
	_data_ = _data;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_slice_free (PluginMailMergeActivateData, _data_);
#line 912 "mail-merge.c"
}

static void
plugin_mail_merge_real_activate (PluginPluginBase* base,
                                 gboolean is_startup,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	PluginMailMerge * self;
	PluginMailMergeActivateData* _data_;
	PluginMailMerge* _tmp0_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PLUGIN_TYPE_MAIL_MERGE, PluginMailMerge);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = g_slice_new0 (PluginMailMergeActivateData);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_task_set_task_data (_data_->_async_result, _data_, plugin_mail_merge_real_activate_data_free);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->self = _tmp0_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->is_startup = is_startup;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_real_activate_co (_data_);
#line 940 "mail-merge.c"
}

static void
plugin_mail_merge_activate_finish (PluginPluginBase* base,
                                   GAsyncResult* _res_,
                                   GError** error)
{
	PluginMailMergeActivateData* _data_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (NULL == _data_) {
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		return;
#line 955 "mail-merge.c"
	}
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 977 "mail-merge.c"
}

static gchar*
__lambda4_ (PluginMailMerge* self,
            gchar* name)
{
	gchar* _tmp0_;
	gchar* result;
#line 86 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 86 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = string_strip (name);
#line 86 "../src/client/plugin/mail-merge/mail-merge.vala"
	result = _tmp0_;
#line 86 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_free0 (name);
#line 86 "../src/client/plugin/mail-merge/mail-merge.vala"
	return result;
#line 996 "mail-merge.c"
}

static gpointer
___lambda4__gee_map_func (gpointer g,
                          gpointer self)
{
	gpointer result;
	result = __lambda4_ ((PluginMailMerge*) self, (gchar*) g);
#line 85 "../src/client/plugin/mail-merge/mail-merge.vala"
	return result;
#line 1007 "mail-merge.c"
}

static gchar*
__lambda5_ (PluginMailMerge* self,
            gchar* name)
{
	gchar* _tmp0_;
	gchar* result;
#line 89 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 89 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = string_strip (name);
#line 89 "../src/client/plugin/mail-merge/mail-merge.vala"
	result = _tmp0_;
#line 89 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_free0 (name);
#line 89 "../src/client/plugin/mail-merge/mail-merge.vala"
	return result;
#line 1026 "mail-merge.c"
}

static gpointer
___lambda5__gee_map_func (gpointer g,
                          gpointer self)
{
	gpointer result;
	result = __lambda5_ ((PluginMailMerge*) self, (gchar*) g);
#line 88 "../src/client/plugin/mail-merge/mail-merge.vala"
	return result;
#line 1037 "mail-merge.c"
}

static void
plugin_mail_merge_activate_ready (GObject* source_object,
                                  GAsyncResult* _res_,
                                  gpointer _user_data_)
{
	PluginMailMergeActivateData* _data_;
#line 92 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = _user_data_;
#line 92 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_source_object_ = source_object;
#line 92 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_res_ = _res_;
#line 92 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_real_activate_co (_data_);
#line 1054 "mail-merge.c"
}

static void
_plugin_mail_merge_on_folders_available_plugin_folder_store_folders_available (PluginFolderStore* _sender,
                                                                               GeeCollection* available,
                                                                               gpointer self)
{
#line 93 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_on_folders_available ((PluginMailMerge*) self, available);
#line 1064 "mail-merge.c"
}

static void
_plugin_mail_merge_on_folder_selected_plugin_folder_store_folder_selected (PluginFolderStore* _sender,
                                                                           PluginFolder* selected,
                                                                           gpointer self)
{
#line 94 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_on_folder_selected ((PluginMailMerge*) self, selected);
#line 1074 "mail-merge.c"
}

static void
_plugin_mail_merge_on_email_displayed_plugin_email_store_email_displayed (PluginEmailStore* _sender,
                                                                          PluginEmail* sent,
                                                                          gpointer self)
{
#line 97 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_on_email_displayed ((PluginMailMerge*) self, sent);
#line 1084 "mail-merge.c"
}

static void
_plugin_mail_merge_on_edit_activated_g_simple_action_activate (GSimpleAction* _sender,
                                                               GVariant* parameter,
                                                               gpointer self)
{
#line 102 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_on_edit_activated ((PluginMailMerge*) self, _sender, parameter);
#line 1094 "mail-merge.c"
}

static void
_plugin_mail_merge_on_merge_activated_g_simple_action_activate (GSimpleAction* _sender,
                                                                GVariant* parameter,
                                                                gpointer self)
{
#line 108 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_on_merge_activated ((PluginMailMerge*) self, _sender, parameter);
#line 1104 "mail-merge.c"
}

static void
_plugin_mail_merge_on_start_activated_g_simple_action_activate (GSimpleAction* _sender,
                                                                GVariant* parameter,
                                                                gpointer self)
{
#line 112 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_on_start_activated ((PluginMailMerge*) self, _sender, parameter);
#line 1114 "mail-merge.c"
}

static void
_plugin_mail_merge_on_pause_activated_g_simple_action_activate (GSimpleAction* _sender,
                                                                GVariant* parameter,
                                                                gpointer self)
{
#line 124 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_on_pause_activated ((PluginMailMerge*) self, _sender, parameter);
#line 1124 "mail-merge.c"
}

static void
_plugin_mail_merge_on_composer_registered_plugin_application_composer_registered (PluginApplication* _sender,
                                                                                  PluginComposer* composer,
                                                                                  gpointer self)
{
#line 135 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_on_composer_registered ((PluginMailMerge*) self, composer);
#line 1134 "mail-merge.c"
}

static gboolean
plugin_mail_merge_real_activate_co (PluginMailMergeActivateData* _data_)
{
#line 82 "../src/client/plugin/mail-merge/mail-merge.vala"
	switch (_data_->_state_) {
#line 82 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 0:
#line 1144 "mail-merge.c"
		goto _state_0;
#line 82 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 1:
#line 1148 "mail-merge.c"
		goto _state_1;
#line 82 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 2:
#line 1152 "mail-merge.c"
		goto _state_2;
		default:
#line 82 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_assert_not_reached ();
#line 1157 "mail-merge.c"
	}
	_state_0:
#line 85 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp1_ = _data_->_tmp0_ = g_strsplit (PLUGIN_MAIL_MERGE_LOC_NAMES, "|", 0);
#line 85 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 85 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp2__length1 = _vala_array_length (_data_->_tmp0_);
#line 85 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp3_ = geary_iterate_array (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _data_->_tmp2_, (gint) _vala_array_length (_data_->_tmp0_), NULL, NULL, NULL);
#line 85 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 85 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp5_ = geary_iterable_map (_data_->_tmp4_, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, ___lambda4__gee_map_func, _data_->self);
#line 85 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 85 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp7_ = _data_->self->priv->folder_names;
#line 85 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp8_ = geary_iterable_add_all_to (_data_->_tmp6_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp7_, GEE_TYPE_COLLECTION, GeeCollection));
#line 85 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp9_ = _data_->_tmp8_;
#line 85 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->_tmp9_);
#line 85 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->_tmp6_);
#line 85 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->_tmp4_);
#line 85 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp2_ = (_vala_array_free (_data_->_tmp2_, _data_->_tmp2__length1, (GDestroyNotify) g_free), NULL);
#line 88 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp11_ = _data_->_tmp10_ = g_strsplit (PLUGIN_MAIL_MERGE_UNLOC_NAMES, "|", 0);
#line 88 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 88 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp12__length1 = _vala_array_length (_data_->_tmp10_);
#line 88 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp13_ = geary_iterate_array (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _data_->_tmp12_, (gint) _vala_array_length (_data_->_tmp10_), NULL, NULL, NULL);
#line 88 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp14_ = _data_->_tmp13_;
#line 88 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp15_ = geary_iterable_map (_data_->_tmp14_, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, ___lambda5__gee_map_func, _data_->self);
#line 88 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp16_ = _data_->_tmp15_;
#line 88 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp17_ = _data_->self->priv->folder_names;
#line 88 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp18_ = geary_iterable_add_all_to (_data_->_tmp16_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp17_, GEE_TYPE_COLLECTION, GeeCollection));
#line 88 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp19_ = _data_->_tmp18_;
#line 88 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->_tmp19_);
#line 88 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->_tmp16_);
#line 88 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->_tmp14_);
#line 88 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp12_ = (_vala_array_free (_data_->_tmp12_, _data_->_tmp12__length1, (GDestroyNotify) g_free), NULL);
#line 92 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp21_ = plugin_folder_extension_get_folders (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PLUGIN_TYPE_FOLDER_EXTENSION, PluginFolderExtension));
#line 92 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp22_ = _data_->_tmp21_;
#line 92 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_state_ = 1;
#line 92 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_folder_context_get_folder_store (_data_->_tmp22_, plugin_mail_merge_activate_ready, _data_);
#line 92 "../src/client/plugin/mail-merge/mail-merge.vala"
	return FALSE;
#line 1226 "mail-merge.c"
	_state_1:
#line 92 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp23_ = plugin_folder_context_get_folder_store_finish (_data_->_tmp22_, _data_->_res_, &_data_->_inner_error0_);
#line 92 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp20_ = _data_->_tmp23_;
#line 92 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 92 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 92 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_object_unref (_data_->_async_result);
#line 92 "../src/client/plugin/mail-merge/mail-merge.vala"
		return FALSE;
#line 1240 "mail-merge.c"
	}
#line 92 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp24_ = _data_->_tmp20_;
#line 92 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp20_ = NULL;
#line 92 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->self->priv->folder_store);
#line 92 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->self->priv->folder_store = _data_->_tmp24_;
#line 93 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp25_ = _data_->self->priv->folder_store;
#line 93 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_signal_connect_object (_data_->_tmp25_, "folders-available", (GCallback) _plugin_mail_merge_on_folders_available_plugin_folder_store_folders_available, _data_->self, 0);
#line 94 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp26_ = _data_->self->priv->folder_store;
#line 94 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_signal_connect_object (_data_->_tmp26_, "folder-selected", (GCallback) _plugin_mail_merge_on_folder_selected_plugin_folder_store_folder_selected, _data_->self, 0);
#line 96 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp28_ = plugin_email_extension_get_email (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PLUGIN_TYPE_EMAIL_EXTENSION, PluginEmailExtension));
#line 96 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp29_ = _data_->_tmp28_;
#line 96 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_state_ = 2;
#line 96 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_email_context_get_email_store (_data_->_tmp29_, plugin_mail_merge_activate_ready, _data_);
#line 96 "../src/client/plugin/mail-merge/mail-merge.vala"
	return FALSE;
#line 1268 "mail-merge.c"
	_state_2:
#line 96 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp30_ = plugin_email_context_get_email_store_finish (_data_->_tmp29_, _data_->_res_, &_data_->_inner_error0_);
#line 96 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp27_ = _data_->_tmp30_;
#line 96 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 96 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 96 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_data_->_tmp20_);
#line 96 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_object_unref (_data_->_async_result);
#line 96 "../src/client/plugin/mail-merge/mail-merge.vala"
		return FALSE;
#line 1284 "mail-merge.c"
	}
#line 96 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp31_ = _data_->_tmp27_;
#line 96 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp27_ = NULL;
#line 96 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->self->priv->email_store);
#line 96 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->self->priv->email_store = _data_->_tmp31_;
#line 97 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp32_ = _data_->self->priv->email_store;
#line 97 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_signal_connect_object (_data_->_tmp32_, "email-displayed", (GCallback) _plugin_mail_merge_on_email_displayed_plugin_email_store_email_displayed, _data_->self, 0);
#line 99 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp33_ = _data_->self->priv->email_store;
#line 99 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp34_ = plugin_email_store_get_email_identifier_variant_type (_data_->_tmp33_);
#line 99 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp35_ = _data_->_tmp34_;
#line 99 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp36_ = g_simple_action_new (PLUGIN_MAIL_MERGE_ACTION_EDIT, _data_->_tmp35_);
#line 99 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->self->priv->edit_action);
#line 99 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->self->priv->edit_action = _data_->_tmp36_;
#line 102 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp37_ = _data_->self->priv->edit_action;
#line 102 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_signal_connect_object (_data_->_tmp37_, "activate", (GCallback) _plugin_mail_merge_on_edit_activated_g_simple_action_activate, _data_->self, 0);
#line 103 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp38_ = plugin_plugin_base_get_plugin_application (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PLUGIN_TYPE_PLUGIN_BASE, PluginPluginBase));
#line 103 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp39_ = _data_->_tmp38_;
#line 103 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp40_ = _data_->self->priv->edit_action;
#line 103 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_application_register_action (_data_->_tmp39_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp40_, g_action_get_type (), GAction));
#line 105 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp41_ = _data_->self->priv->email_store;
#line 105 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp42_ = plugin_email_store_get_email_identifier_variant_type (_data_->_tmp41_);
#line 105 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp43_ = _data_->_tmp42_;
#line 105 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp44_ = g_simple_action_new (PLUGIN_MAIL_MERGE_ACTION_MERGE, _data_->_tmp43_);
#line 105 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->self->priv->merge_action);
#line 105 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->self->priv->merge_action = _data_->_tmp44_;
#line 108 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp45_ = _data_->self->priv->merge_action;
#line 108 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_signal_connect_object (_data_->_tmp45_, "activate", (GCallback) _plugin_mail_merge_on_merge_activated_g_simple_action_activate, _data_->self, 0);
#line 109 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp46_ = plugin_plugin_base_get_plugin_application (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PLUGIN_TYPE_PLUGIN_BASE, PluginPluginBase));
#line 109 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp47_ = _data_->_tmp46_;
#line 109 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp48_ = _data_->self->priv->merge_action;
#line 109 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_application_register_action (_data_->_tmp47_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp48_, g_action_get_type (), GAction));
#line 111 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp49_ = g_simple_action_new (PLUGIN_MAIL_MERGE_ACTION_START, NULL);
#line 111 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->self->priv->start_action);
#line 111 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->self->priv->start_action = _data_->_tmp49_;
#line 112 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp50_ = _data_->self->priv->start_action;
#line 112 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_signal_connect_object (_data_->_tmp50_, "activate", (GCallback) _plugin_mail_merge_on_start_activated_g_simple_action_activate, _data_->self, 0);
#line 113 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp51_ = plugin_plugin_base_get_plugin_application (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PLUGIN_TYPE_PLUGIN_BASE, PluginPluginBase));
#line 113 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp52_ = _data_->_tmp51_;
#line 113 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp53_ = _data_->self->priv->start_action;
#line 113 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_application_register_action (_data_->_tmp52_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp53_, g_action_get_type (), GAction));
#line 115 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp54_ = _data_->self->priv->start_action;
#line 115 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp55_ = plugin_actionable_new_with_icon (_ ("Start"), "media-playback-start-symbolic", G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp54_, g_action_get_type (), GAction), NULL);
#line 115 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->self->priv->start_ui);
#line 115 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->self->priv->start_ui = _data_->_tmp55_;
#line 123 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp56_ = g_simple_action_new (PLUGIN_MAIL_MERGE_ACTION_PAUSE, NULL);
#line 123 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->self->priv->pause_action);
#line 123 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->self->priv->pause_action = _data_->_tmp56_;
#line 124 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp57_ = _data_->self->priv->pause_action;
#line 124 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_signal_connect_object (_data_->_tmp57_, "activate", (GCallback) _plugin_mail_merge_on_pause_activated_g_simple_action_activate, _data_->self, 0);
#line 125 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp58_ = plugin_plugin_base_get_plugin_application (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PLUGIN_TYPE_PLUGIN_BASE, PluginPluginBase));
#line 125 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp59_ = _data_->_tmp58_;
#line 125 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp60_ = _data_->self->priv->pause_action;
#line 125 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_application_register_action (_data_->_tmp59_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp60_, g_action_get_type (), GAction));
#line 127 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp61_ = _data_->self->priv->pause_action;
#line 127 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp62_ = plugin_actionable_new_with_icon (_ ("Pause"), "media-playback-pause-symbolic", G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp61_, g_action_get_type (), GAction), NULL);
#line 127 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->self->priv->pause_ui);
#line 127 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->self->priv->pause_ui = _data_->_tmp62_;
#line 135 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp63_ = plugin_plugin_base_get_plugin_application (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PLUGIN_TYPE_PLUGIN_BASE, PluginPluginBase));
#line 135 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp64_ = _data_->_tmp63_;
#line 135 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_signal_connect_object (_data_->_tmp64_, "composer-registered", (GCallback) _plugin_mail_merge_on_composer_registered_plugin_application_composer_registered, _data_->self, 0);
#line 82 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->_tmp27_);
#line 82 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->_tmp20_);
#line 82 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 82 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (_data_->_state_ != 0) {
#line 82 "../src/client/plugin/mail-merge/mail-merge.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 82 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1416 "mail-merge.c"
		}
	}
#line 82 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_object_unref (_data_->_async_result);
#line 82 "../src/client/plugin/mail-merge/mail-merge.vala"
	return FALSE;
#line 1423 "mail-merge.c"
}

static void
plugin_mail_merge_real_deactivate_data_free (gpointer _data)
{
	PluginMailMergeDeactivateData* _data_;
	_data_ = _data;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_slice_free (PluginMailMergeDeactivateData, _data_);
#line 1435 "mail-merge.c"
}

static void
plugin_mail_merge_real_deactivate (PluginPluginBase* base,
                                   gboolean is_shutdown,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	PluginMailMerge * self;
	PluginMailMergeDeactivateData* _data_;
	PluginMailMerge* _tmp0_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PLUGIN_TYPE_MAIL_MERGE, PluginMailMerge);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = g_slice_new0 (PluginMailMergeDeactivateData);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_task_set_task_data (_data_->_async_result, _data_, plugin_mail_merge_real_deactivate_data_free);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->self = _tmp0_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->is_shutdown = is_shutdown;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_real_deactivate_co (_data_);
#line 1463 "mail-merge.c"
}

static void
plugin_mail_merge_deactivate_finish (PluginPluginBase* base,
                                     GAsyncResult* _res_,
                                     GError** error)
{
	PluginMailMergeDeactivateData* _data_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (NULL == _data_) {
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		return;
#line 1478 "mail-merge.c"
	}
}

static gboolean
plugin_mail_merge_real_deactivate_co (PluginMailMergeDeactivateData* _data_)
{
#line 140 "../src/client/plugin/mail-merge/mail-merge.vala"
	switch (_data_->_state_) {
#line 140 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 0:
#line 1489 "mail-merge.c"
		goto _state_0;
		default:
#line 140 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_assert_not_reached ();
#line 1494 "mail-merge.c"
	}
	_state_0:
#line 141 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp0_ = _data_->self->priv->cancellable;
#line 141 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_cancellable_cancel (_data_->_tmp0_);
#line 143 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp1_ = plugin_plugin_base_get_plugin_application (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PLUGIN_TYPE_PLUGIN_BASE, PluginPluginBase));
#line 143 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 143 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp3_ = _data_->self->priv->edit_action;
#line 143 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_application_deregister_action (_data_->_tmp2_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, g_action_get_type (), GAction));
#line 144 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->self->priv->edit_action);
#line 144 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->self->priv->edit_action = NULL;
#line 146 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp4_ = plugin_plugin_base_get_plugin_application (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PLUGIN_TYPE_PLUGIN_BASE, PluginPluginBase));
#line 146 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 146 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp6_ = _data_->self->priv->merge_action;
#line 146 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_application_deregister_action (_data_->_tmp5_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, g_action_get_type (), GAction));
#line 147 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->self->priv->merge_action);
#line 147 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->self->priv->merge_action = NULL;
#line 149 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->self->priv->folder_store);
#line 149 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->self->priv->folder_store = NULL;
#line 151 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp7_ = _data_->self->priv->email_store;
#line 151 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_signal_parse_name ("email-displayed", PLUGIN_TYPE_EMAIL_STORE, &_data_->_tmp8_, NULL, FALSE);
#line 151 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_signal_handlers_disconnect_matched (_data_->_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _data_->_tmp8_, 0, NULL, (GCallback) _plugin_mail_merge_on_email_displayed_plugin_email_store_email_displayed, _data_->self);
#line 152 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->self->priv->email_store);
#line 152 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->self->priv->email_store = NULL;
#line 154 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp9_ = _data_->self->priv->folder_names;
#line 154 "../src/client/plugin/mail-merge/mail-merge.vala"
	gee_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp9_, GEE_TYPE_COLLECTION, GeeCollection));
#line 140 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 140 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (_data_->_state_ != 0) {
#line 140 "../src/client/plugin/mail-merge/mail-merge.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 140 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1551 "mail-merge.c"
		}
	}
#line 140 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_object_unref (_data_->_async_result);
#line 140 "../src/client/plugin/mail-merge/mail-merge.vala"
	return FALSE;
#line 1558 "mail-merge.c"
}

static void
plugin_mail_merge_edit_email_data_free (gpointer _data)
{
	PluginMailMergeEditEmailData* _data_;
	_data_ = _data;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->id);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_slice_free (PluginMailMergeEditEmailData, _data_);
#line 1572 "mail-merge.c"
}

static void
plugin_mail_merge_edit_email (PluginMailMerge* self,
                              PluginEmailIdentifier* id,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	PluginMailMergeEditEmailData* _data_;
	PluginMailMerge* _tmp0_;
	PluginEmailIdentifier* _tmp1_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (PLUGIN_IS_MAIL_MERGE (self));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (id, PLUGIN_TYPE_EMAIL_IDENTIFIER));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = g_slice_new0 (PluginMailMergeEditEmailData);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_task_set_task_data (_data_->_async_result, _data_, plugin_mail_merge_edit_email_data_free);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->self = _tmp0_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp1_ = _g_object_ref0 (id);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->id);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->id = _tmp1_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_edit_email_co (_data_);
#line 1606 "mail-merge.c"
}

static void
plugin_mail_merge_edit_email_finish (PluginMailMerge* self,
                                     GAsyncResult* _res_)
{
	PluginMailMergeEditEmailData* _data_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1616 "mail-merge.c"
}

static void
plugin_mail_merge_edit_email_ready (GObject* source_object,
                                    GAsyncResult* _res_,
                                    gpointer _user_data_)
{
	PluginMailMergeEditEmailData* _data_;
#line 159 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = _user_data_;
#line 159 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_source_object_ = source_object;
#line 159 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_res_ = _res_;
#line 159 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_edit_email_co (_data_);
#line 1633 "mail-merge.c"
}

static gboolean
___lambda7_ (PluginMailMerge* self,
             PluginFolder* f)
{
	GeeList* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean result;
#line 168 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (f, PLUGIN_TYPE_FOLDER), FALSE);
#line 168 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = self->priv->folder_names;
#line 168 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp1_ = plugin_folder_get_display_name (f);
#line 168 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp2_ = _tmp1_;
#line 168 "../src/client/plugin/mail-merge/mail-merge.vala"
	result = gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), _tmp2_);
#line 168 "../src/client/plugin/mail-merge/mail-merge.vala"
	return result;
#line 1656 "mail-merge.c"
}

static gboolean
____lambda7__gee_predicate (gconstpointer g,
                            gpointer self)
{
	gboolean result;
	result = ___lambda7_ ((PluginMailMerge*) self, (PluginFolder*) g);
#line 167 "../src/client/plugin/mail-merge/mail-merge.vala"
	return result;
#line 1667 "mail-merge.c"
}

static gboolean
plugin_mail_merge_edit_email_co (PluginMailMergeEditEmailData* _data_)
{
#line 157 "../src/client/plugin/mail-merge/mail-merge.vala"
	switch (_data_->_state_) {
#line 157 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 0:
#line 1677 "mail-merge.c"
		goto _state_0;
#line 157 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 1:
#line 1681 "mail-merge.c"
		goto _state_1;
#line 157 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 2:
#line 1685 "mail-merge.c"
		goto _state_2;
		default:
#line 157 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_assert_not_reached ();
#line 1690 "mail-merge.c"
	}
	_state_0:
	{
#line 159 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp0_ = plugin_plugin_base_get_plugin_application (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PLUGIN_TYPE_PLUGIN_BASE, PluginPluginBase));
#line 159 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp1_ = _data_->_tmp0_;
#line 159 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp2_ = plugin_email_identifier_get_account (_data_->id);
#line 159 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 159 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_state_ = 1;
#line 159 "../src/client/plugin/mail-merge/mail-merge.vala"
		plugin_application_compose_with_context (_data_->_tmp1_, _data_->_tmp3_, PLUGIN_COMPOSER_CONTEXT_TYPE_EDIT, _data_->id, NULL, plugin_mail_merge_edit_email_ready, _data_);
#line 159 "../src/client/plugin/mail-merge/mail-merge.vala"
		return FALSE;
#line 1708 "mail-merge.c"
		_state_1:
#line 159 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp4_ = plugin_application_compose_with_context_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error0_);
#line 159 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->composer = _data_->_tmp4_;
#line 159 "../src/client/plugin/mail-merge/mail-merge.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1716 "mail-merge.c"
			goto __catch0_g_error;
		}
#line 164 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp5_ = _data_->self->priv->folder_store;
#line 164 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp6_ = _data_->self->priv->cancellable;
#line 164 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_state_ = 2;
#line 164 "../src/client/plugin/mail-merge/mail-merge.vala"
		plugin_folder_store_list_containing_folders (_data_->_tmp5_, _data_->id, _data_->_tmp6_, plugin_mail_merge_edit_email_ready, _data_);
#line 164 "../src/client/plugin/mail-merge/mail-merge.vala"
		return FALSE;
#line 1729 "mail-merge.c"
		_state_2:
#line 164 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp7_ = plugin_folder_store_list_containing_folders_finish (_data_->_tmp5_, _data_->_res_, &_data_->_inner_error0_);
#line 164 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->containing = _data_->_tmp7_;
#line 164 "../src/client/plugin/mail-merge/mail-merge.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 164 "../src/client/plugin/mail-merge/mail-merge.vala"
			_g_object_unref0 (_data_->composer);
#line 1739 "mail-merge.c"
			goto __catch0_g_error;
		}
#line 167 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp8_ = _data_->containing;
#line 167 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp9_ = gee_traversable_first_match (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp8_, GEE_TYPE_TRAVERSABLE, GeeTraversable), ____lambda7__gee_predicate, g_object_ref (_data_->self), g_object_unref);
#line 167 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->folder = (PluginFolder*) _data_->_tmp9_;
#line 171 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp10_ = _data_->composer;
#line 171 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp11_ = _data_->folder;
#line 171 "../src/client/plugin/mail-merge/mail-merge.vala"
		plugin_composer_save_to_folder (_data_->_tmp10_, _data_->_tmp11_);
#line 172 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp12_ = _data_->composer;
#line 172 "../src/client/plugin/mail-merge/mail-merge.vala"
		plugin_composer_set_can_send (_data_->_tmp12_, FALSE);
#line 173 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp13_ = _data_->composer;
#line 173 "../src/client/plugin/mail-merge/mail-merge.vala"
		plugin_composer_present (_data_->_tmp13_);
#line 158 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_data_->folder);
#line 158 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_data_->containing);
#line 158 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_data_->composer);
#line 1768 "mail-merge.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 158 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->err = _data_->_inner_error0_;
#line 158 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_inner_error0_ = NULL;
#line 175 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp14_ = _data_->err;
#line 175 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp15_ = _data_->_tmp14_->message;
#line 175 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_warning ("mail-merge.vala:175: Unable to construct composer: %s", _data_->_tmp15_);
#line 158 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_error_free0 (_data_->err);
#line 1785 "mail-merge.c"
	}
	__finally0:
#line 158 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 158 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 158 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 158 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_object_unref (_data_->_async_result);
#line 158 "../src/client/plugin/mail-merge/mail-merge.vala"
		return FALSE;
#line 1798 "mail-merge.c"
	}
#line 157 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 157 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (_data_->_state_ != 0) {
#line 157 "../src/client/plugin/mail-merge/mail-merge.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 157 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1808 "mail-merge.c"
		}
	}
#line 157 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_object_unref (_data_->_async_result);
#line 157 "../src/client/plugin/mail-merge/mail-merge.vala"
	return FALSE;
#line 1815 "mail-merge.c"
}

static void
plugin_mail_merge_merge_email_data_free (gpointer _data)
{
	PluginMailMergeMergeEmailData* _data_;
	_data_ = _data;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->id);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->default_csv_file);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_slice_free (PluginMailMergeMergeEmailData, _data_);
#line 1831 "mail-merge.c"
}

static void
plugin_mail_merge_merge_email (PluginMailMerge* self,
                               PluginEmailIdentifier* id,
                               GFile* default_csv_file,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	PluginMailMergeMergeEmailData* _data_;
	PluginMailMerge* _tmp0_;
	PluginEmailIdentifier* _tmp1_;
	GFile* _tmp2_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (PLUGIN_IS_MAIL_MERGE (self));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (id, PLUGIN_TYPE_EMAIL_IDENTIFIER));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail ((default_csv_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (default_csv_file, g_file_get_type ()));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = g_slice_new0 (PluginMailMergeMergeEmailData);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_task_set_task_data (_data_->_async_result, _data_, plugin_mail_merge_merge_email_data_free);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->self = _tmp0_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp1_ = _g_object_ref0 (id);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->id);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->id = _tmp1_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp2_ = _g_object_ref0 (default_csv_file);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->default_csv_file);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->default_csv_file = _tmp2_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_merge_email_co (_data_);
#line 1875 "mail-merge.c"
}

static void
plugin_mail_merge_merge_email_finish (PluginMailMerge* self,
                                      GAsyncResult* _res_)
{
	PluginMailMergeMergeEmailData* _data_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1885 "mail-merge.c"
}

static void
plugin_mail_merge_merge_email_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_)
{
	PluginMailMergeMergeEmailData* _data_;
#line 184 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = _user_data_;
#line 184 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_source_object_ = source_object;
#line 184 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_res_ = _res_;
#line 184 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_merge_email_co (_data_);
#line 1902 "mail-merge.c"
}

static void
_plugin_mail_merge_on_merge_closed_plugin_info_bar_close_activated (PluginInfoBar* _sender,
                                                                    gpointer self)
{
#line 215 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_on_merge_closed ((PluginMailMerge*) self);
#line 1911 "mail-merge.c"
}

static void
_____lambda8_ (PluginMailMerge* self)
{
#line 217 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_update_merge_folder_info_bar (self);
#line 1919 "mail-merge.c"
}

static void
______lambda8__g_object_notify (GObject* _sender,
                                GParamSpec* pspec,
                                gpointer self)
{
#line 216 "../src/client/plugin/mail-merge/mail-merge.vala"
	_____lambda8_ ((PluginMailMerge*) self);
#line 1929 "mail-merge.c"
}

static void
_____lambda9_ (PluginMailMerge* self)
{
#line 220 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_update_merge_folder_info_bar (self);
#line 1937 "mail-merge.c"
}

static void
______lambda9__g_object_notify (GObject* _sender,
                                GParamSpec* pspec,
                                gpointer self)
{
#line 219 "../src/client/plugin/mail-merge/mail-merge.vala"
	_____lambda9_ ((PluginMailMerge*) self);
#line 1947 "mail-merge.c"
}

static gboolean
plugin_mail_merge_merge_email_co (PluginMailMergeMergeEmailData* _data_)
{
#line 179 "../src/client/plugin/mail-merge/mail-merge.vala"
	switch (_data_->_state_) {
#line 179 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 0:
#line 1957 "mail-merge.c"
		goto _state_0;
#line 179 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 1:
#line 1961 "mail-merge.c"
		goto _state_1;
#line 179 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 2:
#line 1965 "mail-merge.c"
		goto _state_2;
#line 179 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 3:
#line 1969 "mail-merge.c"
		goto _state_3;
#line 179 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 4:
#line 1973 "mail-merge.c"
		goto _state_4;
#line 179 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 5:
#line 1977 "mail-merge.c"
		goto _state_5;
#line 179 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 6:
#line 1981 "mail-merge.c"
		goto _state_6;
		default:
#line 179 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_assert_not_reached ();
#line 1986 "mail-merge.c"
	}
	_state_0:
#line 181 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp1_ = _g_object_ref0 (_data_->default_csv_file);
#line 181 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp0_ = _data_->_tmp1_;
#line 181 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (_data_->_tmp0_ == NULL) {
#line 181 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp2_ = plugin_mail_merge_show_merge_data_chooser (_data_->self);
#line 181 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 181 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp0_ = _data_->_tmp2_;
#line 2001 "mail-merge.c"
	}
#line 181 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp3_ = _data_->_tmp0_;
#line 181 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp0_ = NULL;
#line 181 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->csv_file = _data_->_tmp3_;
#line 182 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp4_ = _data_->csv_file;
#line 182 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (_data_->_tmp4_ != NULL) {
#line 2013 "mail-merge.c"
		{
#line 184 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp5_ = _data_->csv_file;
#line 184 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp6_ = _data_->self->priv->cancellable;
#line 184 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_state_ = 1;
#line 184 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_file_read_async (_data_->_tmp5_, G_PRIORITY_DEFAULT, _data_->_tmp6_, plugin_mail_merge_merge_email_ready, _data_);
#line 184 "../src/client/plugin/mail-merge/mail-merge.vala"
			return FALSE;
#line 2025 "mail-merge.c"
			_state_1:
#line 184 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp7_ = g_file_read_finish (_data_->_tmp5_, _data_->_res_, &_data_->_inner_error0_);
#line 184 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->csv_input = _data_->_tmp7_;
#line 184 "../src/client/plugin/mail-merge/mail-merge.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2033 "mail-merge.c"
				goto __catch0_g_error;
			}
#line 188 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp8_ = _data_->csv_input;
#line 188 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp9_ = _data_->self->priv->cancellable;
#line 188 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_state_ = 2;
#line 188 "../src/client/plugin/mail-merge/mail-merge.vala"
			mail_merge_csv_reader_new (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp8_, g_input_stream_get_type (), GInputStream), _data_->_tmp9_, plugin_mail_merge_merge_email_ready, _data_);
#line 188 "../src/client/plugin/mail-merge/mail-merge.vala"
			return FALSE;
#line 2046 "mail-merge.c"
			_state_2:
#line 188 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp10_ = mail_merge_csv_reader_new_finish (_data_->_res_, &_data_->_inner_error0_);
#line 188 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->csv = _data_->_tmp10_;
#line 188 "../src/client/plugin/mail-merge/mail-merge.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 188 "../src/client/plugin/mail-merge/mail-merge.vala"
				_g_object_unref0 (_data_->csv_input);
#line 2056 "mail-merge.c"
				goto __catch0_g_error;
			}
#line 192 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp11_ = _data_->self->priv->email_store;
#line 192 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp12_ = geary_collection_single (PLUGIN_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _data_->id);
#line 192 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp13_ = _data_->_tmp12_;
#line 192 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp14_ = _data_->self->priv->cancellable;
#line 192 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_state_ = 3;
#line 192 "../src/client/plugin/mail-merge/mail-merge.vala"
			plugin_email_store_get_email (_data_->_tmp11_, _data_->_tmp13_, _data_->_tmp14_, plugin_mail_merge_merge_email_ready, _data_);
#line 192 "../src/client/plugin/mail-merge/mail-merge.vala"
			return FALSE;
#line 2073 "mail-merge.c"
			_state_3:
#line 192 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp15_ = plugin_email_store_get_email_finish (_data_->_tmp11_, _data_->_res_, &_data_->_inner_error0_);
#line 192 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp16_ = _data_->_tmp15_;
#line 192 "../src/client/plugin/mail-merge/mail-merge.vala"
			_g_object_unref0 (_data_->_tmp13_);
#line 192 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->emails = _data_->_tmp16_;
#line 192 "../src/client/plugin/mail-merge/mail-merge.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 192 "../src/client/plugin/mail-merge/mail-merge.vala"
				_g_object_unref0 (_data_->csv);
#line 192 "../src/client/plugin/mail-merge/mail-merge.vala"
				_g_object_unref0 (_data_->csv_input);
#line 2089 "mail-merge.c"
				goto __catch0_g_error;
			}
#line 196 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp17_ = _data_->emails;
#line 196 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp18_ = gee_collection_get_is_empty (_data_->_tmp17_);
#line 196 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp19_ = _data_->_tmp18_;
#line 196 "../src/client/plugin/mail-merge/mail-merge.vala"
			if (!_data_->_tmp19_) {
#line 197 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp20_ = plugin_trusted_extension_get_client_plugins (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PLUGIN_TYPE_TRUSTED_EXTENSION, PluginTrustedExtension));
#line 197 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp21_ = _data_->_tmp20_;
#line 197 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp22_ = plugin_email_identifier_get_account (_data_->id);
#line 197 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp23_ = _data_->_tmp22_;
#line 197 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp24_ = application_plugin_manager_to_client_account (_data_->_tmp21_, _data_->_tmp23_);
#line 197 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->account_context = _data_->_tmp24_;
#line 200 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp25_ = _data_->emails;
#line 200 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp26_ = geary_collection_first (PLUGIN_TYPE_EMAIL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _data_->_tmp25_);
#line 200 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->email = (PluginEmail*) _data_->_tmp26_;
#line 205 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp28_ = _data_->email;
#line 205 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_state_ = 4;
#line 205 "../src/client/plugin/mail-merge/mail-merge.vala"
				plugin_mail_merge_load_merge_email (_data_->self, _data_->_tmp28_, plugin_mail_merge_merge_email_ready, _data_);
#line 205 "../src/client/plugin/mail-merge/mail-merge.vala"
				return FALSE;
#line 2126 "mail-merge.c"
				_state_4:
#line 205 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp29_ = plugin_mail_merge_load_merge_email_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 205 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp27_ = _data_->_tmp29_;
#line 205 "../src/client/plugin/mail-merge/mail-merge.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 205 "../src/client/plugin/mail-merge/mail-merge.vala"
					_g_object_unref0 (_data_->email);
#line 205 "../src/client/plugin/mail-merge/mail-merge.vala"
					_g_object_unref0 (_data_->account_context);
#line 205 "../src/client/plugin/mail-merge/mail-merge.vala"
					_g_object_unref0 (_data_->emails);
#line 205 "../src/client/plugin/mail-merge/mail-merge.vala"
					_g_object_unref0 (_data_->csv);
#line 205 "../src/client/plugin/mail-merge/mail-merge.vala"
					_g_object_unref0 (_data_->csv_input);
#line 2144 "mail-merge.c"
					goto __catch0_g_error;
				}
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp31_ = _data_->account_context;
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp32_ = application_account_context_get_account (_data_->_tmp31_);
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp33_ = _data_->_tmp32_;
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp34_ = _data_->account_context;
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp35_ = application_account_context_get_account (_data_->_tmp34_);
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp36_ = _data_->_tmp35_;
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp37_ = geary_account_get_local_folder_root (_data_->_tmp36_);
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp38_ = _data_->_tmp37_;
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp39_ = _data_->csv_file;
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp40_ = _data_->csv;
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_state_ = 5;
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
				mail_merge_folder_new (_data_->_tmp33_, _data_->_tmp38_, _data_->_tmp27_, _data_->_tmp39_, _data_->_tmp40_, plugin_mail_merge_merge_email_ready, _data_);
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
				return FALSE;
#line 2173 "mail-merge.c"
				_state_5:
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp41_ = mail_merge_folder_new_finish (_data_->_res_, &_data_->_inner_error0_);
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp30_ = _data_->_tmp41_;
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
					_g_object_unref0 (_data_->_tmp27_);
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
					_g_object_unref0 (_data_->email);
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
					_g_object_unref0 (_data_->account_context);
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
					_g_object_unref0 (_data_->emails);
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
					_g_object_unref0 (_data_->csv);
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
					_g_object_unref0 (_data_->csv_input);
#line 2193 "mail-merge.c"
					goto __catch0_g_error;
				}
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp42_ = _data_->_tmp30_;
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp30_ = NULL;
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
				_g_object_unref0 (_data_->self->priv->merge_folder);
#line 202 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->self->priv->merge_folder = _data_->_tmp42_;
#line 210 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp43_ = _data_->self->priv->merge_folder;
#line 210 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp44_ = mail_merge_folder_get_data_display_name (_data_->_tmp43_);
#line 210 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp45_ = _data_->_tmp44_;
#line 210 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp46_ = plugin_info_bar_new (_data_->_tmp45_, "");
#line 210 "../src/client/plugin/mail-merge/mail-merge.vala"
				_g_object_unref0 (_data_->self->priv->merge_bar);
#line 210 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->self->priv->merge_bar = _data_->_tmp46_;
#line 213 "../src/client/plugin/mail-merge/mail-merge.vala"
				plugin_mail_merge_update_merge_folder_info_bar (_data_->self);
#line 214 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp47_ = _data_->self->priv->merge_bar;
#line 214 "../src/client/plugin/mail-merge/mail-merge.vala"
				plugin_info_bar_set_show_close_button (_data_->_tmp47_, TRUE);
#line 215 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp48_ = _data_->self->priv->merge_bar;
#line 215 "../src/client/plugin/mail-merge/mail-merge.vala"
				g_signal_connect_object (_data_->_tmp48_, "close-activated", (GCallback) _plugin_mail_merge_on_merge_closed_plugin_info_bar_close_activated, _data_->self, 0);
#line 216 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp49_ = _data_->self->priv->merge_folder;
#line 216 "../src/client/plugin/mail-merge/mail-merge.vala"
				g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp49_, G_TYPE_OBJECT, GObject), "notify::email-sent", (GCallback) ______lambda8__g_object_notify, _data_->self, 0);
#line 219 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp50_ = _data_->self->priv->merge_folder;
#line 219 "../src/client/plugin/mail-merge/mail-merge.vala"
				g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp50_, G_TYPE_OBJECT, GObject), "notify::email-total", (GCallback) ______lambda9__g_object_notify, _data_->self, 0);
#line 223 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp51_ = _data_->account_context;
#line 223 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp52_ = application_account_context_get_account (_data_->_tmp51_);
#line 223 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp53_ = _data_->_tmp52_;
#line 223 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp54_ = _data_->self->priv->merge_folder;
#line 223 "../src/client/plugin/mail-merge/mail-merge.vala"
				geary_account_register_local_folder (_data_->_tmp53_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp54_, GEARY_TYPE_FOLDER, GearyFolder), &_data_->_inner_error0_);
#line 223 "../src/client/plugin/mail-merge/mail-merge.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 223 "../src/client/plugin/mail-merge/mail-merge.vala"
					_g_object_unref0 (_data_->_tmp30_);
#line 223 "../src/client/plugin/mail-merge/mail-merge.vala"
					_g_object_unref0 (_data_->_tmp27_);
#line 223 "../src/client/plugin/mail-merge/mail-merge.vala"
					_g_object_unref0 (_data_->email);
#line 223 "../src/client/plugin/mail-merge/mail-merge.vala"
					_g_object_unref0 (_data_->account_context);
#line 223 "../src/client/plugin/mail-merge/mail-merge.vala"
					_g_object_unref0 (_data_->emails);
#line 223 "../src/client/plugin/mail-merge/mail-merge.vala"
					_g_object_unref0 (_data_->csv);
#line 223 "../src/client/plugin/mail-merge/mail-merge.vala"
					_g_object_unref0 (_data_->csv_input);
#line 2260 "mail-merge.c"
					goto __catch0_g_error;
				}
#line 226 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp55_ = plugin_trusted_extension_get_client_application (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PLUGIN_TYPE_TRUSTED_EXTENSION, PluginTrustedExtension));
#line 226 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp56_ = _data_->_tmp55_;
#line 226 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp57_ = application_client_get_active_main_window (_data_->_tmp56_);
#line 226 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->main = _data_->_tmp57_;
#line 227 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp58_ = _data_->main;
#line 227 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp59_ = _data_->self->priv->merge_folder;
#line 227 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_state_ = 6;
#line 227 "../src/client/plugin/mail-merge/mail-merge.vala"
				application_main_window_select_folder (_data_->_tmp58_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp59_, GEARY_TYPE_FOLDER, GearyFolder), TRUE, FALSE, plugin_mail_merge_merge_email_ready, _data_);
#line 227 "../src/client/plugin/mail-merge/mail-merge.vala"
				return FALSE;
#line 2281 "mail-merge.c"
				_state_6:
#line 227 "../src/client/plugin/mail-merge/mail-merge.vala"
				application_main_window_select_folder_finish (_data_->_tmp58_, _data_->_res_);
#line 196 "../src/client/plugin/mail-merge/mail-merge.vala"
				_g_object_unref0 (_data_->main);
#line 196 "../src/client/plugin/mail-merge/mail-merge.vala"
				_g_object_unref0 (_data_->_tmp30_);
#line 196 "../src/client/plugin/mail-merge/mail-merge.vala"
				_g_object_unref0 (_data_->_tmp27_);
#line 196 "../src/client/plugin/mail-merge/mail-merge.vala"
				_g_object_unref0 (_data_->email);
#line 196 "../src/client/plugin/mail-merge/mail-merge.vala"
				_g_object_unref0 (_data_->account_context);
#line 2295 "mail-merge.c"
			}
#line 183 "../src/client/plugin/mail-merge/mail-merge.vala"
			_g_object_unref0 (_data_->emails);
#line 183 "../src/client/plugin/mail-merge/mail-merge.vala"
			_g_object_unref0 (_data_->csv);
#line 183 "../src/client/plugin/mail-merge/mail-merge.vala"
			_g_object_unref0 (_data_->csv_input);
#line 2303 "mail-merge.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 183 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->err = _data_->_inner_error0_;
#line 183 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_inner_error0_ = NULL;
#line 230 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp60_ = _data_->err;
#line 230 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp61_ = _data_->_tmp60_->message;
#line 230 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_debug ("mail-merge.vala:230: Displaying merge folder failed: %s", _data_->_tmp61_);
#line 183 "../src/client/plugin/mail-merge/mail-merge.vala"
			_g_error_free0 (_data_->err);
#line 2320 "mail-merge.c"
		}
		__finally0:
#line 183 "../src/client/plugin/mail-merge/mail-merge.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 183 "../src/client/plugin/mail-merge/mail-merge.vala"
			_g_object_unref0 (_data_->csv_file);
#line 183 "../src/client/plugin/mail-merge/mail-merge.vala"
			_g_object_unref0 (_data_->_tmp0_);
#line 183 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 183 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 183 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_object_unref (_data_->_async_result);
#line 183 "../src/client/plugin/mail-merge/mail-merge.vala"
			return FALSE;
#line 2337 "mail-merge.c"
		}
	}
#line 179 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->csv_file);
#line 179 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->_tmp0_);
#line 179 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 179 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (_data_->_state_ != 0) {
#line 179 "../src/client/plugin/mail-merge/mail-merge.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 179 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2352 "mail-merge.c"
		}
	}
#line 179 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_object_unref (_data_->_async_result);
#line 179 "../src/client/plugin/mail-merge/mail-merge.vala"
	return FALSE;
#line 2359 "mail-merge.c"
}

static void
plugin_mail_merge_update_merge_folder_info_bar (PluginMailMerge* self)
{
	PluginInfoBar* _tmp0_;
	MailMergeFolder* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	MailMergeFolder* _tmp4_;
	guint _tmp5_;
	guint _tmp6_;
	MailMergeFolder* _tmp7_;
	guint _tmp8_;
	guint _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	PluginActionable* _tmp12_ = NULL;
	MailMergeFolder* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	PluginInfoBar* _tmp18_;
#line 235 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (PLUGIN_IS_MAIL_MERGE (self));
#line 239 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = self->priv->merge_bar;
#line 239 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp1_ = self->priv->merge_folder;
#line 239 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp2_ = mail_merge_folder_get_email_total (_tmp1_);
#line 239 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp3_ = _tmp2_;
#line 239 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp4_ = self->priv->merge_folder;
#line 239 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp5_ = mail_merge_folder_get_email_sent (_tmp4_);
#line 239 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp6_ = _tmp5_;
#line 239 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp7_ = self->priv->merge_folder;
#line 239 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp8_ = mail_merge_folder_get_email_total (_tmp7_);
#line 239 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp9_ = _tmp8_;
#line 239 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp10_ = g_strdup_printf (ngettext ("Sent %u of %u", "Sent %u of %u", (gulong) _tmp3_), _tmp6_, _tmp9_);
#line 239 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp11_ = _tmp10_;
#line 239 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_info_bar_set_description (_tmp0_, _tmp11_);
#line 239 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_free0 (_tmp11_);
#line 247 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp13_ = self->priv->merge_folder;
#line 247 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp14_ = mail_merge_folder_get_is_sending (_tmp13_);
#line 247 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp15_ = _tmp14_;
#line 247 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (_tmp15_) {
#line 2420 "mail-merge.c"
		PluginActionable* _tmp16_;
#line 248 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp16_ = self->priv->pause_ui;
#line 248 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp12_ = _tmp16_;
#line 2426 "mail-merge.c"
	} else {
		PluginActionable* _tmp17_;
#line 248 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp17_ = self->priv->start_ui;
#line 248 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp12_ = _tmp17_;
#line 2433 "mail-merge.c"
	}
#line 247 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp18_ = self->priv->merge_bar;
#line 247 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_info_bar_set_primary_button (_tmp18_, _tmp12_);
#line 2439 "mail-merge.c"
}

static void
plugin_mail_merge_update_email_data_free (gpointer _data)
{
	PluginMailMergeUpdateEmailData* _data_;
	_data_ = _data;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->target);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_slice_free (PluginMailMergeUpdateEmailData, _data_);
#line 2453 "mail-merge.c"
}

static void
plugin_mail_merge_update_email (PluginMailMerge* self,
                                PluginEmail* target,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
	PluginMailMergeUpdateEmailData* _data_;
	PluginMailMerge* _tmp0_;
	PluginEmail* _tmp1_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (PLUGIN_IS_MAIL_MERGE (self));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (target, PLUGIN_TYPE_EMAIL));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = g_slice_new0 (PluginMailMergeUpdateEmailData);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_task_set_task_data (_data_->_async_result, _data_, plugin_mail_merge_update_email_data_free);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->self = _tmp0_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp1_ = _g_object_ref0 (target);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->target);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->target = _tmp1_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_update_email_co (_data_);
#line 2487 "mail-merge.c"
}

static void
plugin_mail_merge_update_email_finish (PluginMailMerge* self,
                                       GAsyncResult* _res_)
{
	PluginMailMergeUpdateEmailData* _data_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2497 "mail-merge.c"
}

static void
plugin_mail_merge_update_email_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_)
{
	PluginMailMergeUpdateEmailData* _data_;
#line 255 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = _user_data_;
#line 255 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_source_object_ = source_object;
#line 255 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_res_ = _res_;
#line 255 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_update_email_co (_data_);
#line 2514 "mail-merge.c"
}

static gboolean
__lambda6_ (PluginMailMerge* self,
            PluginFolder* f)
{
	GeeList* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean result;
#line 261 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (f, PLUGIN_TYPE_FOLDER), FALSE);
#line 261 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = self->priv->folder_names;
#line 261 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp1_ = plugin_folder_get_display_name (f);
#line 261 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp2_ = _tmp1_;
#line 261 "../src/client/plugin/mail-merge/mail-merge.vala"
	result = gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), _tmp2_);
#line 261 "../src/client/plugin/mail-merge/mail-merge.vala"
	return result;
#line 2537 "mail-merge.c"
}

static gboolean
___lambda6__gee_predicate (gconstpointer g,
                           gpointer self)
{
	gboolean result;
	result = __lambda6_ ((PluginMailMerge*) self, (PluginFolder*) g);
#line 261 "../src/client/plugin/mail-merge/mail-merge.vala"
	return result;
#line 2548 "mail-merge.c"
}

static gboolean
plugin_mail_merge_update_email_co (PluginMailMergeUpdateEmailData* _data_)
{
#line 252 "../src/client/plugin/mail-merge/mail-merge.vala"
	switch (_data_->_state_) {
#line 252 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 0:
#line 2558 "mail-merge.c"
		goto _state_0;
#line 252 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 1:
#line 2562 "mail-merge.c"
		goto _state_1;
#line 252 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 2:
#line 2566 "mail-merge.c"
		goto _state_2;
		default:
#line 252 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_assert_not_reached ();
#line 2571 "mail-merge.c"
	}
	_state_0:
#line 253 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp0_ = gee_collection_empty (PLUGIN_TYPE_FOLDER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref);
#line 253 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->containing = _data_->_tmp0_;
#line 2578 "mail-merge.c"
	{
#line 255 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp2_ = _data_->self->priv->folder_store;
#line 255 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp3_ = plugin_email_get_identifier (_data_->target);
#line 255 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 255 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp5_ = _data_->self->priv->cancellable;
#line 255 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_state_ = 1;
#line 255 "../src/client/plugin/mail-merge/mail-merge.vala"
		plugin_folder_store_list_containing_folders (_data_->_tmp2_, _data_->_tmp4_, _data_->_tmp5_, plugin_mail_merge_update_email_ready, _data_);
#line 255 "../src/client/plugin/mail-merge/mail-merge.vala"
		return FALSE;
#line 2594 "mail-merge.c"
		_state_1:
#line 255 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp6_ = plugin_folder_store_list_containing_folders_finish (_data_->_tmp2_, _data_->_res_, &_data_->_inner_error0_);
#line 255 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp1_ = _data_->_tmp6_;
#line 255 "../src/client/plugin/mail-merge/mail-merge.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2602 "mail-merge.c"
			goto __catch0_g_error;
		}
#line 255 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp7_ = _data_->_tmp1_;
#line 255 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp1_ = NULL;
#line 255 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_data_->containing);
#line 255 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->containing = _data_->_tmp7_;
#line 254 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_data_->_tmp1_);
#line 2615 "mail-merge.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 254 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->err = _data_->_inner_error0_;
#line 254 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_inner_error0_ = NULL;
#line 259 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp8_ = _data_->err;
#line 259 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp9_ = _data_->_tmp8_->message;
#line 259 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_warning ("mail-merge.vala:259: Could not load folders for email: %s", _data_->_tmp9_);
#line 254 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_error_free0 (_data_->err);
#line 2632 "mail-merge.c"
	}
	__finally0:
#line 254 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 254 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_data_->containing);
#line 254 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 254 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 254 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_object_unref (_data_->_async_result);
#line 254 "../src/client/plugin/mail-merge/mail-merge.vala"
		return FALSE;
#line 2647 "mail-merge.c"
	}
#line 261 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp10_ = _data_->containing;
#line 261 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (gee_traversable_any_match (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp10_, GEE_TYPE_TRAVERSABLE, GeeTraversable), ___lambda6__gee_predicate, g_object_ref (_data_->self), g_object_unref)) {
#line 2653 "mail-merge.c"
		{
#line 263 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_state_ = 2;
#line 263 "../src/client/plugin/mail-merge/mail-merge.vala"
			plugin_mail_merge_load_merge_email (_data_->self, _data_->target, plugin_mail_merge_update_email_ready, _data_);
#line 263 "../src/client/plugin/mail-merge/mail-merge.vala"
			return FALSE;
#line 2661 "mail-merge.c"
			_state_2:
#line 263 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp11_ = plugin_mail_merge_load_merge_email_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 263 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->email = _data_->_tmp11_;
#line 263 "../src/client/plugin/mail-merge/mail-merge.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2669 "mail-merge.c"
				goto __catch1_g_error;
			}
#line 264 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp13_ = _data_->email;
#line 264 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp12_ = mail_merge_processor_is_mail_merge_template (_data_->_tmp13_, &_data_->_inner_error0_);
#line 264 "../src/client/plugin/mail-merge/mail-merge.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 264 "../src/client/plugin/mail-merge/mail-merge.vala"
				_g_object_unref0 (_data_->email);
#line 2680 "mail-merge.c"
				goto __catch1_g_error;
			}
#line 264 "../src/client/plugin/mail-merge/mail-merge.vala"
			if (_data_->_tmp12_) {
#line 265 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp14_ = plugin_email_extension_get_email (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PLUGIN_TYPE_EMAIL_EXTENSION, PluginEmailExtension));
#line 265 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp15_ = _data_->_tmp14_;
#line 265 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp16_ = plugin_email_get_identifier (_data_->target);
#line 265 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp17_ = _data_->_tmp16_;
#line 265 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp18_ = plugin_email_get_identifier (_data_->target);
#line 265 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp19_ = _data_->_tmp18_;
#line 265 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp20_ = plugin_mail_merge_new_template_email_info_bar (_data_->self, _data_->_tmp19_);
#line 265 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp21_ = _data_->_tmp20_;
#line 265 "../src/client/plugin/mail-merge/mail-merge.vala"
				plugin_email_context_add_email_info_bar (_data_->_tmp15_, _data_->_tmp17_, _data_->_tmp21_, (guint) PLUGIN_MAIL_MERGE_INFO_BAR_PRIORITY);
#line 265 "../src/client/plugin/mail-merge/mail-merge.vala"
				_g_object_unref0 (_data_->_tmp21_);
#line 2705 "mail-merge.c"
			}
#line 262 "../src/client/plugin/mail-merge/mail-merge.vala"
			_g_object_unref0 (_data_->email);
#line 2709 "mail-merge.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
#line 262 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_vala1_err = _data_->_inner_error0_;
#line 262 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_inner_error0_ = NULL;
#line 272 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp22_ = _data_->_vala1_err;
#line 272 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp23_ = _data_->_tmp22_->message;
#line 272 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_warning ("mail-merge.vala:272: Error checking email for merge templates: %s", _data_->_tmp23_);
#line 262 "../src/client/plugin/mail-merge/mail-merge.vala"
			_g_error_free0 (_data_->_vala1_err);
#line 2726 "mail-merge.c"
		}
		__finally1:
#line 262 "../src/client/plugin/mail-merge/mail-merge.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 262 "../src/client/plugin/mail-merge/mail-merge.vala"
			_g_object_unref0 (_data_->containing);
#line 262 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 262 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 262 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_object_unref (_data_->_async_result);
#line 262 "../src/client/plugin/mail-merge/mail-merge.vala"
			return FALSE;
#line 2741 "mail-merge.c"
		}
	}
#line 252 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->containing);
#line 252 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 252 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (_data_->_state_ != 0) {
#line 252 "../src/client/plugin/mail-merge/mail-merge.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 252 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2754 "mail-merge.c"
		}
	}
#line 252 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_object_unref (_data_->_async_result);
#line 252 "../src/client/plugin/mail-merge/mail-merge.vala"
	return FALSE;
#line 2761 "mail-merge.c"
}

static void
plugin_mail_merge_update_composer_data_free (gpointer _data)
{
	PluginMailMergeUpdateComposerData* _data_;
	_data_ = _data;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_slice_free (PluginMailMergeUpdateComposerData, _data_);
#line 2773 "mail-merge.c"
}

static void
plugin_mail_merge_update_composer (PluginMailMerge* self,
                                   PluginComposer* composer,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	PluginMailMergeUpdateComposerData* _data_;
	PluginMailMerge* _tmp0_;
	PluginComposer* _tmp1_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (PLUGIN_IS_MAIL_MERGE (self));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (composer, PLUGIN_TYPE_COMPOSER));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = g_slice_new0 (PluginMailMergeUpdateComposerData);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_task_set_task_data (_data_->_async_result, _data_, plugin_mail_merge_update_composer_data_free);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->self = _tmp0_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp1_ = _g_object_ref0 (composer);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->composer);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->composer = _tmp1_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_update_composer_co (_data_);
#line 2807 "mail-merge.c"
}

static void
plugin_mail_merge_update_composer_finish (PluginMailMerge* self,
                                          GAsyncResult* _res_)
{
	PluginMailMergeUpdateComposerData* _data_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2817 "mail-merge.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 278 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 278 "../src/client/plugin/mail-merge/mail-merge.vala"
	return _data1_;
#line 2827 "mail-merge.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 278 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 2837 "mail-merge.c"
		PluginMailMerge* self;
#line 278 "../src/client/plugin/mail-merge/mail-merge.vala"
		self = _data1_->self;
#line 278 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_data1_->composer);
#line 278 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (self);
#line 278 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_slice_free (Block1Data, _data1_);
#line 2847 "mail-merge.c"
	}
}

static void
___lambda10_ (Block1Data* _data1_)
{
	PluginMailMerge* self;
#line 282 "../src/client/plugin/mail-merge/mail-merge.vala"
	self = _data1_->self;
#line 282 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_load_composer_data (self, _data1_->composer, NULL, NULL);
#line 2859 "mail-merge.c"
}

static void
____lambda10__g_simple_action_activate (GSimpleAction* _sender,
                                        GVariant* parameter,
                                        gpointer self)
{
#line 281 "../src/client/plugin/mail-merge/mail-merge.vala"
	___lambda10_ (self);
#line 2869 "mail-merge.c"
}

static gboolean
plugin_mail_merge_update_composer_co (PluginMailMergeUpdateComposerData* _data_)
{
#line 278 "../src/client/plugin/mail-merge/mail-merge.vala"
	switch (_data_->_state_) {
#line 278 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 0:
#line 2879 "mail-merge.c"
		goto _state_0;
		default:
#line 278 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_assert_not_reached ();
#line 2884 "mail-merge.c"
	}
	_state_0:
#line 278 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_data1_ = g_slice_new0 (Block1Data);
#line 278 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_data1_->_ref_count_ = 1;
#line 278 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_data1_->self = g_object_ref (_data_->self);
#line 278 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->_data1_->composer);
#line 278 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_data1_->composer = _data_->composer;
#line 278 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_data1_->_async_data_ = _data_;
#line 279 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (TRUE) {
#line 280 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp0_ = g_simple_action_new (PLUGIN_MAIL_MERGE_ACTION_LOAD, NULL);
#line 280 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->load_action = _data_->_tmp0_;
#line 281 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_signal_connect_data (_data_->load_action, "activate", (GCallback) ____lambda10__g_simple_action_activate, block1_data_ref (_data_->_data1_), (GClosureNotify) block1_data_unref, 0);
#line 284 "../src/client/plugin/mail-merge/mail-merge.vala"
		plugin_composer_register_action (_data_->_data1_->composer, G_TYPE_CHECK_INSTANCE_CAST (_data_->load_action, g_action_get_type (), GAction));
#line 285 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp1_ = plugin_actionable_new (_ ("Mail Merge"), G_TYPE_CHECK_INSTANCE_CAST (_data_->load_action, g_action_get_type (), GAction), NULL);
#line 285 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp2_ = _data_->_tmp1_;
#line 285 "../src/client/plugin/mail-merge/mail-merge.vala"
		plugin_composer_append_menu_item (_data_->_data1_->composer, _data_->_tmp2_);
#line 285 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_data_->_tmp2_);
#line 290 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_object_bind_property_with_closures (G_TYPE_CHECK_INSTANCE_CAST (_data_->_data1_->composer, G_TYPE_OBJECT, GObject), "can-send", G_TYPE_CHECK_INSTANCE_CAST (_data_->load_action, G_TYPE_OBJECT, GObject), "enabled", G_BINDING_SYNC_CREATE | G_BINDING_INVERT_BOOLEAN, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 279 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_data_->load_action);
#line 2921 "mail-merge.c"
	}
#line 278 "../src/client/plugin/mail-merge/mail-merge.vala"
	block1_data_unref (_data_->_data1_);
#line 278 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_data1_ = NULL;
#line 278 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 278 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (_data_->_state_ != 0) {
#line 278 "../src/client/plugin/mail-merge/mail-merge.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 278 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2935 "mail-merge.c"
		}
	}
#line 278 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_object_unref (_data_->_async_result);
#line 278 "../src/client/plugin/mail-merge/mail-merge.vala"
	return FALSE;
#line 2942 "mail-merge.c"
}

static void
plugin_mail_merge_load_composer_data_data_free (gpointer _data)
{
	PluginMailMergeLoadComposerDataData* _data_;
	_data_ = _data;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_slice_free (PluginMailMergeLoadComposerDataData, _data_);
#line 2954 "mail-merge.c"
}

static void
plugin_mail_merge_load_composer_data (PluginMailMerge* self,
                                      PluginComposer* composer,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	PluginMailMergeLoadComposerDataData* _data_;
	PluginMailMerge* _tmp0_;
	PluginComposer* _tmp1_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (PLUGIN_IS_MAIL_MERGE (self));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (composer, PLUGIN_TYPE_COMPOSER));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = g_slice_new0 (PluginMailMergeLoadComposerDataData);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_task_set_task_data (_data_->_async_result, _data_, plugin_mail_merge_load_composer_data_data_free);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->self = _tmp0_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp1_ = _g_object_ref0 (composer);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->composer);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->composer = _tmp1_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_load_composer_data_co (_data_);
#line 2988 "mail-merge.c"
}

static void
plugin_mail_merge_load_composer_data_finish (PluginMailMerge* self,
                                             GAsyncResult* _res_)
{
	PluginMailMergeLoadComposerDataData* _data_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2998 "mail-merge.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
	return _data2_;
#line 3008 "mail-merge.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 3018 "mail-merge.c"
		PluginMailMerge* self;
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
		self = _data2_->self;
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_data2_->composer);
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (self);
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_slice_free (Block2Data, _data2_);
#line 3028 "mail-merge.c"
	}
}

static gchar*
_variant_get1 (GVariant* value)
{
#line 309 "../src/client/plugin/mail-merge/mail-merge.vala"
	return g_variant_dup_string (value, NULL);
#line 3037 "mail-merge.c"
}

static void
___lambda11_ (Block2Data* _data2_,
              GVariant* param)
{
	PluginMailMerge* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 308 "../src/client/plugin/mail-merge/mail-merge.vala"
	self = _data2_->self;
#line 309 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = _variant_get1 (param);
#line 309 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp1_ = _tmp0_;
#line 309 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_insert_field (self, _data2_->composer, _tmp1_);
#line 309 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_free0 (_tmp1_);
#line 3057 "mail-merge.c"
}

static void
____lambda11__g_simple_action_activate (GSimpleAction* _sender,
                                        GVariant* parameter,
                                        gpointer self)
{
#line 307 "../src/client/plugin/mail-merge/mail-merge.vala"
	___lambda11_ (self, parameter);
#line 3067 "mail-merge.c"
}

static void
plugin_mail_merge_load_composer_data_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_)
{
	PluginMailMergeLoadComposerDataData* _data_;
#line 315 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = _user_data_;
#line 315 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_source_object_ = source_object;
#line 315 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_res_ = _res_;
#line 315 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_load_composer_data_co (_data_);
#line 3084 "mail-merge.c"
}

static gboolean
plugin_mail_merge_load_composer_data_co (PluginMailMergeLoadComposerDataData* _data_)
{
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
	switch (_data_->_state_) {
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 0:
#line 3094 "mail-merge.c"
		goto _state_0;
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 1:
#line 3098 "mail-merge.c"
		goto _state_1;
		default:
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_assert_not_reached ();
#line 3103 "mail-merge.c"
	}
	_state_0:
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_data2_ = g_slice_new0 (Block2Data);
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_data2_->_ref_count_ = 1;
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_data2_->self = g_object_ref (_data_->self);
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->_data2_->composer);
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_data2_->composer = _data_->composer;
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_data2_->_async_data_ = _data_;
#line 300 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp0_ = plugin_mail_merge_show_merge_data_chooser (_data_->self);
#line 300 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->data = _data_->_tmp0_;
#line 301 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp1_ = _data_->data;
#line 301 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (_data_->_tmp1_ != NULL) {
#line 302 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp2_ = G_VARIANT_TYPE_STRING;
#line 302 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp3_ = g_simple_action_new (PLUGIN_MAIL_MERGE_ACTION_INSERT_FIELD, _data_->_tmp2_);
#line 302 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->insert_field_action = _data_->_tmp3_;
#line 306 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp4_ = _data_->insert_field_action;
#line 306 "../src/client/plugin/mail-merge/mail-merge.vala"
		plugin_composer_register_action (_data_->_data2_->composer, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp4_, g_action_get_type (), GAction));
#line 307 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp5_ = _data_->insert_field_action;
#line 307 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_signal_connect_data (_data_->_tmp5_, "activate", (GCallback) ____lambda11__g_simple_action_activate, block2_data_ref (_data_->_data2_), (GClosureNotify) block2_data_unref, 0);
#line 3140 "mail-merge.c"
		{
#line 315 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp7_ = _data_->data;
#line 315 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp8_ = plugin_composer_get_action_group_name (_data_->_data2_->composer);
#line 315 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp9_ = _data_->_tmp8_;
#line 315 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_state_ = 1;
#line 315 "../src/client/plugin/mail-merge/mail-merge.vala"
			plugin_mail_merge_new_composer_action_bar (_data_->self, _data_->_tmp7_, _data_->_tmp9_, plugin_mail_merge_load_composer_data_ready, _data_);
#line 315 "../src/client/plugin/mail-merge/mail-merge.vala"
			return FALSE;
#line 3154 "mail-merge.c"
			_state_1:
#line 315 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp10_ = plugin_mail_merge_new_composer_action_bar_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 315 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp6_ = _data_->_tmp10_;
#line 315 "../src/client/plugin/mail-merge/mail-merge.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3162 "mail-merge.c"
				goto __catch0_g_error;
			}
#line 314 "../src/client/plugin/mail-merge/mail-merge.vala"
			plugin_composer_set_action_bar (_data_->_data2_->composer, _data_->_tmp6_);
#line 313 "../src/client/plugin/mail-merge/mail-merge.vala"
			_g_object_unref0 (_data_->_tmp6_);
#line 3169 "mail-merge.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 313 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->err = _data_->_inner_error0_;
#line 313 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_inner_error0_ = NULL;
#line 321 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp11_ = _data_->err;
#line 321 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp12_ = _data_->_tmp11_->message;
#line 321 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_debug ("mail-merge.vala:321: Error loading CSV: %s", _data_->_tmp12_);
#line 313 "../src/client/plugin/mail-merge/mail-merge.vala"
			_g_error_free0 (_data_->err);
#line 3186 "mail-merge.c"
		}
		__finally0:
#line 313 "../src/client/plugin/mail-merge/mail-merge.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 313 "../src/client/plugin/mail-merge/mail-merge.vala"
			_g_object_unref0 (_data_->insert_field_action);
#line 313 "../src/client/plugin/mail-merge/mail-merge.vala"
			_g_object_unref0 (_data_->data);
#line 313 "../src/client/plugin/mail-merge/mail-merge.vala"
			block2_data_unref (_data_->_data2_);
#line 313 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_data2_ = NULL;
#line 313 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 313 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 313 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_object_unref (_data_->_async_result);
#line 313 "../src/client/plugin/mail-merge/mail-merge.vala"
			return FALSE;
#line 3207 "mail-merge.c"
		}
#line 301 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_data_->insert_field_action);
#line 3211 "mail-merge.c"
	}
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->data);
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
	block2_data_unref (_data_->_data2_);
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_data2_ = NULL;
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (_data_->_state_ != 0) {
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3227 "mail-merge.c"
		}
	}
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_object_unref (_data_->_async_result);
#line 299 "../src/client/plugin/mail-merge/mail-merge.vala"
	return FALSE;
#line 3234 "mail-merge.c"
}

static PluginInfoBar*
plugin_mail_merge_new_template_email_info_bar (PluginMailMerge* self,
                                               PluginEmailIdentifier* target)
{
	PluginInfoBar* bar = NULL;
	PluginInfoBar* _tmp0_;
	GSimpleAction* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	PluginActionable* _tmp4_;
	PluginActionable* _tmp5_;
	GeeBidirList* _tmp6_;
	GeeBidirList* _tmp7_;
	GSimpleAction* _tmp8_;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	PluginActionable* _tmp11_;
	PluginActionable* _tmp12_;
	PluginInfoBar* result;
#line 327 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_val_if_fail (PLUGIN_IS_MAIL_MERGE (self), NULL);
#line 327 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (target, PLUGIN_TYPE_EMAIL_IDENTIFIER), NULL);
#line 330 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = plugin_info_bar_new (_ ("Mail merge template"), NULL);
#line 330 "../src/client/plugin/mail-merge/mail-merge.vala"
	bar = _tmp0_;
#line 331 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp1_ = self->priv->merge_action;
#line 331 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp2_ = plugin_email_identifier_to_variant (target);
#line 331 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp3_ = _tmp2_;
#line 331 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp4_ = plugin_actionable_new (_ ("Merge"), G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_action_get_type (), GAction), _tmp3_);
#line 331 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp5_ = _tmp4_;
#line 331 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_info_bar_set_primary_button (bar, _tmp5_);
#line 331 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_tmp5_);
#line 331 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_variant_unref0 (_tmp3_);
#line 338 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp6_ = plugin_info_bar_get_secondary_buttons (bar);
#line 338 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp7_ = _tmp6_;
#line 338 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp8_ = self->priv->edit_action;
#line 338 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp9_ = plugin_email_identifier_to_variant (target);
#line 338 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp10_ = _tmp9_;
#line 338 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp11_ = plugin_actionable_new (_ ("Edit"), G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, g_action_get_type (), GAction), _tmp10_);
#line 338 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp12_ = _tmp11_;
#line 338 "../src/client/plugin/mail-merge/mail-merge.vala"
	gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection), _tmp12_);
#line 338 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_tmp12_);
#line 338 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_variant_unref0 (_tmp10_);
#line 347 "../src/client/plugin/mail-merge/mail-merge.vala"
	result = bar;
#line 347 "../src/client/plugin/mail-merge/mail-merge.vala"
	return result;
#line 3304 "mail-merge.c"
}

static void
plugin_mail_merge_new_composer_action_bar_data_free (gpointer _data)
{
	PluginMailMergeNewComposerActionBarData* _data_;
	_data_ = _data;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->csv_file);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_free0 (_data_->action_group_name);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->result);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_slice_free (PluginMailMergeNewComposerActionBarData, _data_);
#line 3322 "mail-merge.c"
}

static void
plugin_mail_merge_new_composer_action_bar (PluginMailMerge* self,
                                           GFile* csv_file,
                                           const gchar* action_group_name,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	PluginMailMergeNewComposerActionBarData* _data_;
	PluginMailMerge* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (PLUGIN_IS_MAIL_MERGE (self));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (csv_file, g_file_get_type ()));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (action_group_name != NULL);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = g_slice_new0 (PluginMailMergeNewComposerActionBarData);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_task_set_task_data (_data_->_async_result, _data_, plugin_mail_merge_new_composer_action_bar_data_free);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->self = _tmp0_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp1_ = _g_object_ref0 (csv_file);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->csv_file);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->csv_file = _tmp1_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp2_ = g_strdup (action_group_name);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_free0 (_data_->action_group_name);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->action_group_name = _tmp2_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_new_composer_action_bar_co (_data_);
#line 3366 "mail-merge.c"
}

static PluginActionBar*
plugin_mail_merge_new_composer_action_bar_finish (PluginMailMerge* self,
                                                  GAsyncResult* _res_,
                                                  GError** error)
{
	PluginActionBar* result;
	PluginMailMergeNewComposerActionBarData* _data_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (NULL == _data_) {
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		return NULL;
#line 3382 "mail-merge.c"
	}
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	result = _data_->result;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->result = NULL;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	return result;
#line 3390 "mail-merge.c"
}

static void
plugin_mail_merge_new_composer_action_bar_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	PluginMailMergeNewComposerActionBarData* _data_;
#line 353 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = _user_data_;
#line 353 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_source_object_ = source_object;
#line 353 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_res_ = _res_;
#line 353 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_new_composer_action_bar_co (_data_);
#line 3407 "mail-merge.c"
}

static GVariant*
_variant_new1 (const gchar* value)
{
#line 370 "../src/client/plugin/mail-merge/mail-merge.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 3415 "mail-merge.c"
}

static gboolean
plugin_mail_merge_new_composer_action_bar_co (PluginMailMergeNewComposerActionBarData* _data_)
{
#line 350 "../src/client/plugin/mail-merge/mail-merge.vala"
	switch (_data_->_state_) {
#line 350 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 0:
#line 3425 "mail-merge.c"
		goto _state_0;
#line 350 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 1:
#line 3429 "mail-merge.c"
		goto _state_1;
#line 350 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 2:
#line 3433 "mail-merge.c"
		goto _state_2;
#line 350 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 3:
#line 3437 "mail-merge.c"
		goto _state_3;
#line 350 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 4:
#line 3441 "mail-merge.c"
		goto _state_4;
		default:
#line 350 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_assert_not_reached ();
#line 3446 "mail-merge.c"
	}
	_state_0:
#line 353 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp0_ = _data_->self->priv->cancellable;
#line 353 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_state_ = 1;
#line 353 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_file_query_info_async (_data_->csv_file, G_FILE_ATTRIBUTE_STANDARD_DISPLAY_NAME, G_FILE_QUERY_INFO_NONE, G_PRIORITY_DEFAULT, _data_->_tmp0_, plugin_mail_merge_new_composer_action_bar_ready, _data_);
#line 353 "../src/client/plugin/mail-merge/mail-merge.vala"
	return FALSE;
#line 3457 "mail-merge.c"
	_state_1:
#line 353 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp1_ = g_file_query_info_finish (_data_->csv_file, _data_->_res_, &_data_->_inner_error0_);
#line 353 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->info = _data_->_tmp1_;
#line 353 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 353 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 353 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_object_unref (_data_->_async_result);
#line 353 "../src/client/plugin/mail-merge/mail-merge.vala"
		return FALSE;
#line 3471 "mail-merge.c"
	}
#line 359 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp2_ = _data_->self->priv->cancellable;
#line 359 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_state_ = 2;
#line 359 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_file_read_async (_data_->csv_file, G_PRIORITY_DEFAULT, _data_->_tmp2_, plugin_mail_merge_new_composer_action_bar_ready, _data_);
#line 359 "../src/client/plugin/mail-merge/mail-merge.vala"
	return FALSE;
#line 3481 "mail-merge.c"
	_state_2:
#line 359 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp3_ = g_file_read_finish (_data_->csv_file, _data_->_res_, &_data_->_inner_error0_);
#line 359 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->input = _data_->_tmp3_;
#line 359 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 359 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 359 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_data_->info);
#line 359 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_object_unref (_data_->_async_result);
#line 359 "../src/client/plugin/mail-merge/mail-merge.vala"
		return FALSE;
#line 3497 "mail-merge.c"
	}
#line 363 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp4_ = _data_->input;
#line 363 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp5_ = _data_->self->priv->cancellable;
#line 363 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_state_ = 3;
#line 363 "../src/client/plugin/mail-merge/mail-merge.vala"
	mail_merge_csv_reader_new (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp4_, g_input_stream_get_type (), GInputStream), _data_->_tmp5_, plugin_mail_merge_new_composer_action_bar_ready, _data_);
#line 363 "../src/client/plugin/mail-merge/mail-merge.vala"
	return FALSE;
#line 3509 "mail-merge.c"
	_state_3:
#line 363 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp6_ = mail_merge_csv_reader_new_finish (_data_->_res_, &_data_->_inner_error0_);
#line 363 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->csv = _data_->_tmp6_;
#line 363 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 363 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 363 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_data_->input);
#line 363 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_data_->info);
#line 363 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_object_unref (_data_->_async_result);
#line 363 "../src/client/plugin/mail-merge/mail-merge.vala"
		return FALSE;
#line 3527 "mail-merge.c"
	}
#line 366 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp7_ = _data_->csv;
#line 366 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp8_ = 0;
#line 366 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_state_ = 4;
#line 366 "../src/client/plugin/mail-merge/mail-merge.vala"
	mail_merge_csv_reader_read_record (_data_->_tmp7_, plugin_mail_merge_new_composer_action_bar_ready, _data_);
#line 366 "../src/client/plugin/mail-merge/mail-merge.vala"
	return FALSE;
#line 3539 "mail-merge.c"
	_state_4:
#line 366 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp9_ = mail_merge_csv_reader_read_record_finish (_data_->_tmp7_, _data_->_res_, &_data_->_tmp8_, &_data_->_inner_error0_);
#line 366 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->record = _data_->_tmp9_;
#line 366 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->record_length1 = _data_->_tmp8_;
#line 366 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_record_size_ = _data_->record_length1;
#line 366 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 366 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 366 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_data_->csv);
#line 366 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_data_->input);
#line 366 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_data_->info);
#line 366 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_object_unref (_data_->_async_result);
#line 366 "../src/client/plugin/mail-merge/mail-merge.vala"
		return FALSE;
#line 3563 "mail-merge.c"
	}
#line 368 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp10_ = g_menu_new ();
#line 368 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->text_fields_menu = _data_->_tmp10_;
#line 369 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp11_ = _data_->record;
#line 369 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp11__length1 = _data_->record_length1;
#line 3573 "mail-merge.c"
	{
#line 369 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->field_collection_length1 = 0;
#line 369 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_field_collection_size_ = 0;
#line 369 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->field_collection = _data_->_tmp11_;
#line 369 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->field_collection_length1 = _data_->_tmp11__length1;
#line 369 "../src/client/plugin/mail-merge/mail-merge.vala"
		for (_data_->field_it = 0; _data_->field_it < _data_->field_collection_length1; _data_->field_it = _data_->field_it + 1) {
#line 369 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->_tmp12_ = g_strdup (_data_->field_collection[_data_->field_it]);
#line 369 "../src/client/plugin/mail-merge/mail-merge.vala"
			_data_->field = _data_->_tmp12_;
#line 3589 "mail-merge.c"
			{
#line 370 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp13_ = _data_->text_fields_menu;
#line 370 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp14_ = _data_->field;
#line 370 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp15_ = g_strconcat (_data_->action_group_name, ".", NULL);
#line 370 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp16_ = _data_->_tmp15_;
#line 370 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp17_ = g_strconcat (_data_->_tmp16_, PLUGIN_MAIL_MERGE_ACTION_INSERT_FIELD, NULL);
#line 370 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp18_ = _data_->_tmp17_;
#line 370 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp19_ = _data_->field;
#line 370 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp20_ = _variant_new1 (_data_->_tmp19_);
#line 370 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp21_ = g_action_print_detailed_name (_data_->_tmp18_, _data_->_tmp20_);
#line 370 "../src/client/plugin/mail-merge/mail-merge.vala"
				_data_->_tmp22_ = _data_->_tmp21_;
#line 370 "../src/client/plugin/mail-merge/mail-merge.vala"
				g_menu_append (_data_->_tmp13_, _data_->_tmp14_, _data_->_tmp22_);
#line 370 "../src/client/plugin/mail-merge/mail-merge.vala"
				_g_free0 (_data_->_tmp22_);
#line 370 "../src/client/plugin/mail-merge/mail-merge.vala"
				_g_variant_unref0 (_data_->_tmp20_);
#line 370 "../src/client/plugin/mail-merge/mail-merge.vala"
				_g_free0 (_data_->_tmp18_);
#line 370 "../src/client/plugin/mail-merge/mail-merge.vala"
				_g_free0 (_data_->_tmp16_);
#line 369 "../src/client/plugin/mail-merge/mail-merge.vala"
				_g_free0 (_data_->field);
#line 3623 "mail-merge.c"
			}
		}
	}
#line 379 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp23_ = plugin_action_bar_new ();
#line 379 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->action_bar = _data_->_tmp23_;
#line 380 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp24_ = _data_->action_bar;
#line 380 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp25_ = _data_->text_fields_menu;
#line 380 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp26_ = plugin_action_bar_menu_item_new (_ ("Insert field"), G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp25_, g_menu_model_get_type (), GMenuModel));
#line 380 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp27_ = _data_->_tmp26_;
#line 380 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_action_bar_append_item (_data_->_tmp24_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp27_, PLUGIN_ACTION_BAR_TYPE_ITEM, PluginActionBarItem), PLUGIN_ACTION_BAR_POSITION_START);
#line 380 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->_tmp27_);
#line 385 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp28_ = _data_->action_bar;
#line 385 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp29_ = _data_->info;
#line 385 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp30_ = g_file_info_get_display_name (_data_->_tmp29_);
#line 385 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp31_ = plugin_action_bar_label_item_new (_data_->_tmp30_);
#line 385 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp32_ = _data_->_tmp31_;
#line 385 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_action_bar_append_item (_data_->_tmp28_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp32_, PLUGIN_ACTION_BAR_TYPE_ITEM, PluginActionBarItem), PLUGIN_ACTION_BAR_POSITION_START);
#line 385 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->_tmp32_);
#line 388 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->result = _data_->action_bar;
#line 388 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->text_fields_menu);
#line 388 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->record = (_vala_array_free (_data_->record, _data_->record_length1, (GDestroyNotify) g_free), NULL);
#line 388 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->csv);
#line 388 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->input);
#line 388 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->info);
#line 388 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 388 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (_data_->_state_ != 0) {
#line 388 "../src/client/plugin/mail-merge/mail-merge.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 388 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3677 "mail-merge.c"
		}
	}
#line 388 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_object_unref (_data_->_async_result);
#line 388 "../src/client/plugin/mail-merge/mail-merge.vala"
	return FALSE;
#line 3684 "mail-merge.c"
}

static GFile*
plugin_mail_merge_show_merge_data_chooser (PluginMailMerge* self)
{
	GtkFileChooserNative* chooser = NULL;
	GtkFileChooserNative* _tmp0_;
	GtkFileFilter* csv_filter = NULL;
	GtkFileFilter* _tmp1_;
	GtkFileFilter* _tmp2_;
	GtkFileFilter* _tmp3_;
	GtkFileChooserNative* _tmp4_;
	GtkFileFilter* _tmp5_;
	GtkFileFilter* _tmp6_;
	GFile* _tmp7_ = NULL;
	GtkFileChooserNative* _tmp8_;
	GFile* result;
#line 391 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_val_if_fail (PLUGIN_IS_MAIL_MERGE (self), NULL);
#line 392 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = gtk_file_chooser_native_new (_ ("Mail Merge"), NULL, GTK_FILE_CHOOSER_ACTION_OPEN, _ ("_Open"), _ ("_Cancel"));
#line 392 "../src/client/plugin/mail-merge/mail-merge.vala"
	chooser = _tmp0_;
#line 400 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp1_ = gtk_file_filter_new ();
#line 400 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_object_ref_sink (_tmp1_);
#line 400 "../src/client/plugin/mail-merge/mail-merge.vala"
	csv_filter = _tmp1_;
#line 402 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp2_ = csv_filter;
#line 402 "../src/client/plugin/mail-merge/mail-merge.vala"
	gtk_file_filter_set_name (_tmp2_, _ ("Comma separated values (CSV)"));
#line 403 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp3_ = csv_filter;
#line 403 "../src/client/plugin/mail-merge/mail-merge.vala"
	gtk_file_filter_add_mime_type (_tmp3_, "text/csv");
#line 404 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp4_ = chooser;
#line 404 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp5_ = csv_filter;
#line 404 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 404 "../src/client/plugin/mail-merge/mail-merge.vala"
	gtk_file_chooser_add_filter (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_file_chooser_get_type (), GtkFileChooser), _tmp6_);
#line 406 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp8_ = chooser;
#line 406 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (gtk_native_dialog_run (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_native_dialog_get_type (), GtkNativeDialog)) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 3734 "mail-merge.c"
		GtkFileChooserNative* _tmp9_;
		GFile* _tmp10_;
#line 408 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp9_ = chooser;
#line 408 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp10_ = gtk_file_chooser_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_file_chooser_get_type (), GtkFileChooser));
#line 408 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_tmp7_);
#line 408 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp7_ = _tmp10_;
#line 3745 "mail-merge.c"
	} else {
#line 409 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_tmp7_);
#line 409 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp7_ = NULL;
#line 3751 "mail-merge.c"
	}
#line 406 "../src/client/plugin/mail-merge/mail-merge.vala"
	result = _tmp7_;
#line 406 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (csv_filter);
#line 406 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (chooser);
#line 406 "../src/client/plugin/mail-merge/mail-merge.vala"
	return result;
#line 3761 "mail-merge.c"
}

static void
plugin_mail_merge_insert_field (PluginMailMerge* self,
                                PluginComposer* composer,
                                const gchar* field)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 413 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (PLUGIN_IS_MAIL_MERGE (self));
#line 413 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (composer, PLUGIN_TYPE_COMPOSER));
#line 413 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (field != NULL);
#line 414 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = mail_merge_processor_to_field (field);
#line 414 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp1_ = _tmp0_;
#line 414 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_composer_insert_text (composer, _tmp1_);
#line 414 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_free0 (_tmp1_);
#line 3785 "mail-merge.c"
}

static void
plugin_mail_merge_load_merge_email_data_free (gpointer _data)
{
	PluginMailMergeLoadMergeEmailData* _data_;
	_data_ = _data;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->plugin);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->result);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_slice_free (PluginMailMergeLoadMergeEmailData, _data_);
#line 3801 "mail-merge.c"
}

static void
plugin_mail_merge_load_merge_email (PluginMailMerge* self,
                                    PluginEmail* plugin,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	PluginMailMergeLoadMergeEmailData* _data_;
	PluginMailMerge* _tmp0_;
	PluginEmail* _tmp1_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (PLUGIN_IS_MAIL_MERGE (self));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (plugin, PLUGIN_TYPE_EMAIL));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = g_slice_new0 (PluginMailMergeLoadMergeEmailData);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_task_set_task_data (_data_->_async_result, _data_, plugin_mail_merge_load_merge_email_data_free);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->self = _tmp0_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp1_ = _g_object_ref0 (plugin);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (_data_->plugin);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->plugin = _tmp1_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_load_merge_email_co (_data_);
#line 3835 "mail-merge.c"
}

static GearyEmail*
plugin_mail_merge_load_merge_email_finish (PluginMailMerge* self,
                                           GAsyncResult* _res_,
                                           GError** error)
{
	GearyEmail* result;
	PluginMailMergeLoadMergeEmailData* _data_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (NULL == _data_) {
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		return NULL;
#line 3851 "mail-merge.c"
	}
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	result = _data_->result;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->result = NULL;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	return result;
#line 3859 "mail-merge.c"
}

static void
plugin_mail_merge_load_merge_email_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	PluginMailMergeLoadMergeEmailData* _data_;
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_ = _user_data_;
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_source_object_ = source_object;
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_res_ = _res_;
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_load_merge_email_co (_data_);
#line 3876 "mail-merge.c"
}

static gboolean
plugin_mail_merge_load_merge_email_co (PluginMailMergeLoadMergeEmailData* _data_)
{
#line 417 "../src/client/plugin/mail-merge/mail-merge.vala"
	switch (_data_->_state_) {
#line 417 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 0:
#line 3886 "mail-merge.c"
		goto _state_0;
#line 417 "../src/client/plugin/mail-merge/mail-merge.vala"
		case 1:
#line 3890 "mail-merge.c"
		goto _state_1;
		default:
#line 417 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_assert_not_reached ();
#line 3895 "mail-merge.c"
	}
	_state_0:
#line 418 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp0_ = plugin_trusted_extension_get_client_plugins (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PLUGIN_TYPE_TRUSTED_EXTENSION, PluginTrustedExtension));
#line 418 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 418 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp2_ = application_plugin_manager_to_engine_email (_data_->_tmp1_, _data_->plugin);
#line 418 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->engine = _data_->_tmp2_;
#line 419 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp4_ = _data_->engine;
#line 419 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (_data_->_tmp4_ != NULL) {
#line 420 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp5_ = _data_->engine;
#line 420 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp6_ = geary_email_get_fields (_data_->_tmp5_);
#line 420 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 420 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp3_ = !geary_email_field_fulfills (_data_->_tmp7_, MAIL_MERGE_PROCESSOR_REQUIRED_FIELDS);
#line 3918 "mail-merge.c"
	} else {
#line 419 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp3_ = FALSE;
#line 3922 "mail-merge.c"
	}
#line 419 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (_data_->_tmp3_) {
#line 421 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp8_ = plugin_trusted_extension_get_client_plugins (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PLUGIN_TYPE_TRUSTED_EXTENSION, PluginTrustedExtension));
#line 421 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 421 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp10_ = plugin_email_get_identifier (_data_->plugin);
#line 421 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp11_ = _data_->_tmp10_;
#line 421 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp12_ = plugin_email_identifier_get_account (_data_->_tmp11_);
#line 421 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp13_ = _data_->_tmp12_;
#line 421 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp14_ = application_plugin_manager_to_client_account (_data_->_tmp9_, _data_->_tmp13_);
#line 421 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->account_context = _data_->_tmp14_;
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp16_ = _data_->account_context;
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp17_ = application_account_context_get_emails (_data_->_tmp16_);
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp18_ = _data_->_tmp17_;
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp19_ = _data_->engine;
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp20_ = geary_email_get_id (_data_->_tmp19_);
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp21_ = _data_->_tmp20_;
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp22_ = _data_->self->priv->cancellable;
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_state_ = 1;
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
		geary_app_email_store_fetch_email_async (_data_->_tmp18_, _data_->_tmp21_, MAIL_MERGE_PROCESSOR_REQUIRED_FIELDS, GEARY_FOLDER_LIST_FLAGS_LOCAL_ONLY, _data_->_tmp22_, plugin_mail_merge_load_merge_email_ready, _data_);
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
		return FALSE;
#line 3962 "mail-merge.c"
		_state_1:
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp23_ = geary_app_email_store_fetch_email_finish (_data_->_tmp18_, _data_->_res_, &_data_->_inner_error0_);
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp15_ = _data_->_tmp23_;
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
			_g_object_unref0 (_data_->account_context);
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
			_g_object_unref0 (_data_->engine);
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_object_unref (_data_->_async_result);
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
			return FALSE;
#line 3980 "mail-merge.c"
		}
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp24_ = _data_->_tmp15_;
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp15_ = NULL;
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_data_->engine);
#line 424 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->engine = _data_->_tmp24_;
#line 419 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_data_->_tmp15_);
#line 419 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_data_->account_context);
#line 3994 "mail-merge.c"
	}
#line 431 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->_tmp25_ = _data_->engine;
#line 431 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (_data_->_tmp25_ == NULL) {
#line 432 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_tmp26_ = g_error_new_literal (GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_NOT_FOUND, "Plugin email not found");
#line 432 "../src/client/plugin/mail-merge/mail-merge.vala"
		_data_->_inner_error0_ = _data_->_tmp26_;
#line 432 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 432 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_data_->engine);
#line 432 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_object_unref (_data_->_async_result);
#line 432 "../src/client/plugin/mail-merge/mail-merge.vala"
		return FALSE;
#line 4012 "mail-merge.c"
	}
#line 434 "../src/client/plugin/mail-merge/mail-merge.vala"
	_data_->result = _data_->engine;
#line 434 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 434 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (_data_->_state_ != 0) {
#line 434 "../src/client/plugin/mail-merge/mail-merge.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 434 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4024 "mail-merge.c"
		}
	}
#line 434 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_object_unref (_data_->_async_result);
#line 434 "../src/client/plugin/mail-merge/mail-merge.vala"
	return FALSE;
#line 4031 "mail-merge.c"
}

static void
plugin_mail_merge_on_edit_activated (PluginMailMerge* self,
                                     GAction* action,
                                     GVariant* target)
{
	gboolean _tmp0_ = FALSE;
	PluginEmailStore* _tmp1_;
#line 437 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (PLUGIN_IS_MAIL_MERGE (self));
#line 437 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_action_get_type ()));
#line 438 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp1_ = self->priv->email_store;
#line 438 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (_tmp1_ != NULL) {
#line 438 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp0_ = target != NULL;
#line 4051 "mail-merge.c"
	} else {
#line 438 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp0_ = FALSE;
#line 4055 "mail-merge.c"
	}
#line 438 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (_tmp0_) {
#line 4059 "mail-merge.c"
		PluginEmailIdentifier* id = NULL;
		PluginEmailStore* _tmp2_;
		PluginEmailIdentifier* _tmp3_;
		PluginEmailIdentifier* _tmp4_;
#line 439 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp2_ = self->priv->email_store;
#line 439 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp3_ = plugin_email_store_get_email_identifier_for_variant (_tmp2_, target);
#line 439 "../src/client/plugin/mail-merge/mail-merge.vala"
		id = _tmp3_;
#line 441 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp4_ = id;
#line 441 "../src/client/plugin/mail-merge/mail-merge.vala"
		if (_tmp4_ != NULL) {
#line 4074 "mail-merge.c"
			PluginEmailIdentifier* _tmp5_;
#line 442 "../src/client/plugin/mail-merge/mail-merge.vala"
			_tmp5_ = id;
#line 442 "../src/client/plugin/mail-merge/mail-merge.vala"
			plugin_mail_merge_edit_email (self, _tmp5_, NULL, NULL);
#line 4080 "mail-merge.c"
		}
#line 438 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (id);
#line 4084 "mail-merge.c"
	}
}

static void
plugin_mail_merge_on_merge_activated (PluginMailMerge* self,
                                      GAction* action,
                                      GVariant* target)
{
	gboolean _tmp0_ = FALSE;
	PluginEmailStore* _tmp1_;
#line 447 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (PLUGIN_IS_MAIL_MERGE (self));
#line 447 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_action_get_type ()));
#line 448 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp1_ = self->priv->email_store;
#line 448 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (_tmp1_ != NULL) {
#line 448 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp0_ = target != NULL;
#line 4105 "mail-merge.c"
	} else {
#line 448 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp0_ = FALSE;
#line 4109 "mail-merge.c"
	}
#line 448 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (_tmp0_) {
#line 4113 "mail-merge.c"
		PluginEmailIdentifier* id = NULL;
		PluginEmailStore* _tmp2_;
		PluginEmailIdentifier* _tmp3_;
		PluginEmailIdentifier* _tmp4_;
#line 449 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp2_ = self->priv->email_store;
#line 449 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp3_ = plugin_email_store_get_email_identifier_for_variant (_tmp2_, target);
#line 449 "../src/client/plugin/mail-merge/mail-merge.vala"
		id = _tmp3_;
#line 451 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp4_ = id;
#line 451 "../src/client/plugin/mail-merge/mail-merge.vala"
		if (_tmp4_ != NULL) {
#line 4128 "mail-merge.c"
			PluginEmailIdentifier* _tmp5_;
#line 452 "../src/client/plugin/mail-merge/mail-merge.vala"
			_tmp5_ = id;
#line 452 "../src/client/plugin/mail-merge/mail-merge.vala"
			plugin_mail_merge_merge_email (self, _tmp5_, NULL, NULL, NULL);
#line 4134 "mail-merge.c"
		}
#line 448 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (id);
#line 4138 "mail-merge.c"
	}
}

static void
plugin_mail_merge_on_start_activated (PluginMailMerge* self,
                                      GAction* action,
                                      GVariant* target)
{
	MailMergeFolder* _tmp0_;
#line 457 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (PLUGIN_IS_MAIL_MERGE (self));
#line 457 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_action_get_type ()));
#line 458 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = self->priv->merge_folder;
#line 458 "../src/client/plugin/mail-merge/mail-merge.vala"
	mail_merge_folder_set_sending (_tmp0_, TRUE);
#line 459 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_update_merge_folder_info_bar (self);
#line 4158 "mail-merge.c"
}

static void
plugin_mail_merge_on_pause_activated (PluginMailMerge* self,
                                      GAction* action,
                                      GVariant* target)
{
	MailMergeFolder* _tmp0_;
#line 462 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (PLUGIN_IS_MAIL_MERGE (self));
#line 462 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_action_get_type ()));
#line 463 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = self->priv->merge_folder;
#line 463 "../src/client/plugin/mail-merge/mail-merge.vala"
	mail_merge_folder_set_sending (_tmp0_, FALSE);
#line 464 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_update_merge_folder_info_bar (self);
#line 4177 "mail-merge.c"
}

static void
plugin_mail_merge_on_composer_registered (PluginMailMerge* self,
                                          PluginComposer* registered)
{
#line 467 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (PLUGIN_IS_MAIL_MERGE (self));
#line 467 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (registered, PLUGIN_TYPE_COMPOSER));
#line 468 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_update_composer (self, registered, NULL, NULL);
#line 4190 "mail-merge.c"
}

static void
plugin_mail_merge_on_merge_closed (PluginMailMerge* self)
{
	MailMergeFolder* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 471 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (PLUGIN_IS_MAIL_MERGE (self));
#line 472 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = self->priv->merge_folder;
#line 472 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (_tmp0_ != NULL) {
#line 4204 "mail-merge.c"
		{
			MailMergeFolder* _tmp1_;
			GearyAccount* _tmp2_;
			GearyAccount* _tmp3_;
			MailMergeFolder* _tmp4_;
#line 474 "../src/client/plugin/mail-merge/mail-merge.vala"
			_tmp1_ = self->priv->merge_folder;
#line 474 "../src/client/plugin/mail-merge/mail-merge.vala"
			_tmp2_ = geary_folder_get_account (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_TYPE_FOLDER, GearyFolder));
#line 474 "../src/client/plugin/mail-merge/mail-merge.vala"
			_tmp3_ = _tmp2_;
#line 474 "../src/client/plugin/mail-merge/mail-merge.vala"
			_tmp4_ = self->priv->merge_folder;
#line 474 "../src/client/plugin/mail-merge/mail-merge.vala"
			geary_account_deregister_local_folder (_tmp3_, G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEARY_TYPE_FOLDER, GearyFolder), &_inner_error0_);
#line 474 "../src/client/plugin/mail-merge/mail-merge.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4222 "mail-merge.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			GError* _tmp5_;
			const gchar* _tmp6_;
#line 473 "../src/client/plugin/mail-merge/mail-merge.vala"
			err = _inner_error0_;
#line 473 "../src/client/plugin/mail-merge/mail-merge.vala"
			_inner_error0_ = NULL;
#line 478 "../src/client/plugin/mail-merge/mail-merge.vala"
			_tmp5_ = err;
#line 478 "../src/client/plugin/mail-merge/mail-merge.vala"
			_tmp6_ = _tmp5_->message;
#line 478 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_warning ("mail-merge.vala:478: Error de-registering merge folder: %s", _tmp6_);
#line 473 "../src/client/plugin/mail-merge/mail-merge.vala"
			_g_error_free0 (err);
#line 4244 "mail-merge.c"
		}
		__finally0:
#line 473 "../src/client/plugin/mail-merge/mail-merge.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 473 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 473 "../src/client/plugin/mail-merge/mail-merge.vala"
			g_clear_error (&_inner_error0_);
#line 473 "../src/client/plugin/mail-merge/mail-merge.vala"
			return;
#line 4255 "mail-merge.c"
		}
#line 480 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (self->priv->merge_folder);
#line 480 "../src/client/plugin/mail-merge/mail-merge.vala"
		self->priv->merge_folder = NULL;
#line 481 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (self->priv->merge_bar);
#line 481 "../src/client/plugin/mail-merge/mail-merge.vala"
		self->priv->merge_bar = NULL;
#line 4265 "mail-merge.c"
	}
}

static void
plugin_mail_merge_on_folders_available (PluginMailMerge* self,
                                        GeeCollection* available)
{
	GError* _inner_error0_ = NULL;
#line 485 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (PLUGIN_IS_MAIL_MERGE (self));
#line 485 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (available, GEE_TYPE_COLLECTION));
#line 4278 "mail-merge.c"
	{
		GeeIterator* _folder_it = NULL;
		GeeIterator* _tmp0_;
#line 486 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (available, GEE_TYPE_ITERABLE, GeeIterable));
#line 486 "../src/client/plugin/mail-merge/mail-merge.vala"
		_folder_it = _tmp0_;
#line 486 "../src/client/plugin/mail-merge/mail-merge.vala"
		while (TRUE) {
#line 4288 "mail-merge.c"
			GeeIterator* _tmp1_;
			PluginFolder* folder = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			GearyFolder* engine_folder = NULL;
			ApplicationPluginManager* _tmp4_;
			ApplicationPluginManager* _tmp5_;
			PluginFolder* _tmp6_;
			GearyFolder* _tmp7_;
			MailMergeFolder* _tmp8_;
			GearyFolder* _tmp9_;
#line 486 "../src/client/plugin/mail-merge/mail-merge.vala"
			_tmp1_ = _folder_it;
#line 486 "../src/client/plugin/mail-merge/mail-merge.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 486 "../src/client/plugin/mail-merge/mail-merge.vala"
				break;
#line 4306 "mail-merge.c"
			}
#line 486 "../src/client/plugin/mail-merge/mail-merge.vala"
			_tmp2_ = _folder_it;
#line 486 "../src/client/plugin/mail-merge/mail-merge.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 486 "../src/client/plugin/mail-merge/mail-merge.vala"
			folder = (PluginFolder*) _tmp3_;
#line 487 "../src/client/plugin/mail-merge/mail-merge.vala"
			_tmp4_ = plugin_trusted_extension_get_client_plugins (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_TRUSTED_EXTENSION, PluginTrustedExtension));
#line 487 "../src/client/plugin/mail-merge/mail-merge.vala"
			_tmp5_ = _tmp4_;
#line 487 "../src/client/plugin/mail-merge/mail-merge.vala"
			_tmp6_ = folder;
#line 487 "../src/client/plugin/mail-merge/mail-merge.vala"
			_tmp7_ = application_plugin_manager_to_engine_folder (_tmp5_, _tmp6_);
#line 487 "../src/client/plugin/mail-merge/mail-merge.vala"
			engine_folder = _tmp7_;
#line 488 "../src/client/plugin/mail-merge/mail-merge.vala"
			_tmp8_ = self->priv->merge_folder;
#line 488 "../src/client/plugin/mail-merge/mail-merge.vala"
			_tmp9_ = engine_folder;
#line 488 "../src/client/plugin/mail-merge/mail-merge.vala"
			if (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEARY_TYPE_FOLDER, GearyFolder) == _tmp9_) {
#line 4330 "mail-merge.c"
				{
					PluginFolderContext* _tmp10_;
					PluginFolderContext* _tmp11_;
					PluginFolder* _tmp12_;
#line 490 "../src/client/plugin/mail-merge/mail-merge.vala"
					_tmp10_ = plugin_folder_extension_get_folders (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_FOLDER_EXTENSION, PluginFolderExtension));
#line 490 "../src/client/plugin/mail-merge/mail-merge.vala"
					_tmp11_ = _tmp10_;
#line 490 "../src/client/plugin/mail-merge/mail-merge.vala"
					_tmp12_ = folder;
#line 490 "../src/client/plugin/mail-merge/mail-merge.vala"
					plugin_folder_context_register_folder_used_as (_tmp11_, _tmp12_, _ ("Mail Merge"), "mail-outbox-symbolic", &_inner_error0_);
#line 490 "../src/client/plugin/mail-merge/mail-merge.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4345 "mail-merge.c"
						goto __catch0_g_error;
					}
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* err = NULL;
					PluginFolder* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
					GError* _tmp16_;
					const gchar* _tmp17_;
#line 489 "../src/client/plugin/mail-merge/mail-merge.vala"
					err = _inner_error0_;
#line 489 "../src/client/plugin/mail-merge/mail-merge.vala"
					_inner_error0_ = NULL;
#line 498 "../src/client/plugin/mail-merge/mail-merge.vala"
					_tmp13_ = folder;
#line 498 "../src/client/plugin/mail-merge/mail-merge.vala"
					_tmp14_ = plugin_folder_get_persistent_id (_tmp13_);
#line 498 "../src/client/plugin/mail-merge/mail-merge.vala"
					_tmp15_ = _tmp14_;
#line 498 "../src/client/plugin/mail-merge/mail-merge.vala"
					_tmp16_ = err;
#line 498 "../src/client/plugin/mail-merge/mail-merge.vala"
					_tmp17_ = _tmp16_->message;
#line 498 "../src/client/plugin/mail-merge/mail-merge.vala"
					g_warning ("mail-merge.vala:498: Failed to register %s as merge folder: %s", _tmp15_, _tmp17_);
#line 489 "../src/client/plugin/mail-merge/mail-merge.vala"
					_g_error_free0 (err);
#line 4376 "mail-merge.c"
				}
				__finally0:
#line 489 "../src/client/plugin/mail-merge/mail-merge.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 489 "../src/client/plugin/mail-merge/mail-merge.vala"
					_g_object_unref0 (engine_folder);
#line 489 "../src/client/plugin/mail-merge/mail-merge.vala"
					_g_object_unref0 (folder);
#line 489 "../src/client/plugin/mail-merge/mail-merge.vala"
					_g_object_unref0 (_folder_it);
#line 489 "../src/client/plugin/mail-merge/mail-merge.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 489 "../src/client/plugin/mail-merge/mail-merge.vala"
					g_clear_error (&_inner_error0_);
#line 489 "../src/client/plugin/mail-merge/mail-merge.vala"
					return;
#line 4393 "mail-merge.c"
				}
			}
#line 486 "../src/client/plugin/mail-merge/mail-merge.vala"
			_g_object_unref0 (engine_folder);
#line 486 "../src/client/plugin/mail-merge/mail-merge.vala"
			_g_object_unref0 (folder);
#line 4400 "mail-merge.c"
		}
#line 486 "../src/client/plugin/mail-merge/mail-merge.vala"
		_g_object_unref0 (_folder_it);
#line 4404 "mail-merge.c"
	}
}

static void
plugin_mail_merge_on_folder_selected (PluginMailMerge* self,
                                      PluginFolder* selected)
{
	GearyFolder* engine_folder = NULL;
	ApplicationPluginManager* _tmp0_;
	ApplicationPluginManager* _tmp1_;
	GearyFolder* _tmp2_;
	MailMergeFolder* _tmp3_;
	GearyFolder* _tmp4_;
#line 508 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (PLUGIN_IS_MAIL_MERGE (self));
#line 508 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (selected, PLUGIN_TYPE_FOLDER));
#line 509 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = plugin_trusted_extension_get_client_plugins (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_TRUSTED_EXTENSION, PluginTrustedExtension));
#line 509 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp1_ = _tmp0_;
#line 509 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp2_ = application_plugin_manager_to_engine_folder (_tmp1_, selected);
#line 509 "../src/client/plugin/mail-merge/mail-merge.vala"
	engine_folder = _tmp2_;
#line 510 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp3_ = self->priv->merge_folder;
#line 510 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp4_ = engine_folder;
#line 510 "../src/client/plugin/mail-merge/mail-merge.vala"
	if (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEARY_TYPE_FOLDER, GearyFolder) == _tmp4_) {
#line 4436 "mail-merge.c"
		PluginFolderContext* _tmp5_;
		PluginFolderContext* _tmp6_;
		PluginInfoBar* _tmp7_;
#line 511 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp5_ = plugin_folder_extension_get_folders (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_FOLDER_EXTENSION, PluginFolderExtension));
#line 511 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp6_ = _tmp5_;
#line 511 "../src/client/plugin/mail-merge/mail-merge.vala"
		_tmp7_ = self->priv->merge_bar;
#line 511 "../src/client/plugin/mail-merge/mail-merge.vala"
		plugin_folder_context_add_folder_info_bar (_tmp6_, selected, _tmp7_, (guint) PLUGIN_MAIL_MERGE_INFO_BAR_PRIORITY);
#line 4448 "mail-merge.c"
	}
#line 508 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (engine_folder);
#line 4452 "mail-merge.c"
}

static void
plugin_mail_merge_on_email_displayed (PluginMailMerge* self,
                                      PluginEmail* email)
{
#line 517 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (PLUGIN_IS_MAIL_MERGE (self));
#line 517 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (email, PLUGIN_TYPE_EMAIL));
#line 518 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_update_email (self, email, NULL, NULL);
#line 4465 "mail-merge.c"
}

PluginMailMerge*
plugin_mail_merge_construct (GType object_type)
{
	PluginMailMerge * self = NULL;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	self = (PluginMailMerge*) plugin_plugin_base_construct (object_type);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	return self;
#line 4476 "mail-merge.c"
}

PluginMailMerge*
plugin_mail_merge_new (void)
{
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	return plugin_mail_merge_construct (PLUGIN_TYPE_MAIL_MERGE);
#line 4484 "mail-merge.c"
}

static void
plugin_mail_merge_class_init (PluginMailMergeClass * klass,
                              gpointer klass_data)
{
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_type_class_adjust_private_offset (klass, &PluginMailMerge_private_offset);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	((PluginPluginBaseClass *) klass)->activate = (void (*) (PluginPluginBase*, gboolean, GAsyncReadyCallback, gpointer)) plugin_mail_merge_real_activate;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	((PluginPluginBaseClass *) klass)->activate_finish = (void (*) (PluginPluginBase*, GAsyncResult*, GError**)) plugin_mail_merge_activate_finish;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	((PluginPluginBaseClass *) klass)->deactivate = (void (*) (PluginPluginBase*, gboolean, GAsyncReadyCallback, gpointer)) plugin_mail_merge_real_deactivate;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	((PluginPluginBaseClass *) klass)->deactivate_finish = (void (*) (PluginPluginBase*, GAsyncResult*, GError**)) plugin_mail_merge_deactivate_finish;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_plugin_mail_merge_get_property;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_plugin_mail_merge_set_property;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	G_OBJECT_CLASS (klass)->finalize = plugin_mail_merge_finalize;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLUGIN_MAIL_MERGE_FOLDERS_PROPERTY, plugin_mail_merge_properties[PLUGIN_MAIL_MERGE_FOLDERS_PROPERTY] = g_param_spec_object ("folders", "folders", "folders", PLUGIN_TYPE_FOLDER_CONTEXT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLUGIN_MAIL_MERGE_EMAIL_PROPERTY, plugin_mail_merge_properties[PLUGIN_MAIL_MERGE_EMAIL_PROPERTY] = g_param_spec_object ("email", "email", "email", PLUGIN_TYPE_EMAIL_CONTEXT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLUGIN_MAIL_MERGE_CLIENT_APPLICATION_PROPERTY, plugin_mail_merge_properties[PLUGIN_MAIL_MERGE_CLIENT_APPLICATION_PROPERTY] = g_param_spec_object ("client-application", "client-application", "client-application", APPLICATION_TYPE_CLIENT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLUGIN_MAIL_MERGE_CLIENT_PLUGINS_PROPERTY, plugin_mail_merge_properties[PLUGIN_MAIL_MERGE_CLIENT_PLUGINS_PROPERTY] = g_param_spec_object ("client-plugins", "client-plugins", "client-plugins", APPLICATION_TYPE_PLUGIN_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 4517 "mail-merge.c"
}

static void
plugin_mail_merge_plugin_folder_extension_interface_init (PluginFolderExtensionIface * iface,
                                                          gpointer iface_data)
{
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_plugin_folder_extension_parent_iface = g_type_interface_peek_parent (iface);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	iface->get_folders = plugin_mail_merge_real_get_folders;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	iface->set_folders = plugin_mail_merge_real_set_folders;
#line 4530 "mail-merge.c"
}

static void
plugin_mail_merge_plugin_email_extension_interface_init (PluginEmailExtensionIface * iface,
                                                         gpointer iface_data)
{
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_plugin_email_extension_parent_iface = g_type_interface_peek_parent (iface);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	iface->get_email = plugin_mail_merge_real_get_email;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	iface->set_email = plugin_mail_merge_real_set_email;
#line 4543 "mail-merge.c"
}

static void
plugin_mail_merge_plugin_trusted_extension_interface_init (PluginTrustedExtensionIface * iface,
                                                           gpointer iface_data)
{
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	plugin_mail_merge_plugin_trusted_extension_parent_iface = g_type_interface_peek_parent (iface);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	iface->get_client_application = plugin_mail_merge_real_get_client_application;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	iface->set_client_application = plugin_mail_merge_real_set_client_application;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	iface->get_client_plugins = plugin_mail_merge_real_get_client_plugins;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	iface->set_client_plugins = plugin_mail_merge_real_set_client_plugins;
#line 4560 "mail-merge.c"
}

static void
plugin_mail_merge_instance_init (PluginMailMerge * self,
                                 gpointer klass)
{
	GeeArrayList* _tmp0_;
	GCancellable* _tmp1_;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	self->priv = plugin_mail_merge_get_instance_private (self);
#line 63 "../src/client/plugin/mail-merge/mail-merge.vala"
	self->priv->folder_store = NULL;
#line 64 "../src/client/plugin/mail-merge/mail-merge.vala"
	self->priv->email_store = NULL;
#line 66 "../src/client/plugin/mail-merge/mail-merge.vala"
	self->priv->merge_folder = NULL;
#line 67 "../src/client/plugin/mail-merge/mail-merge.vala"
	self->priv->merge_bar = NULL;
#line 69 "../src/client/plugin/mail-merge/mail-merge.vala"
	self->priv->edit_action = NULL;
#line 70 "../src/client/plugin/mail-merge/mail-merge.vala"
	self->priv->merge_action = NULL;
#line 71 "../src/client/plugin/mail-merge/mail-merge.vala"
	self->priv->start_action = NULL;
#line 72 "../src/client/plugin/mail-merge/mail-merge.vala"
	self->priv->pause_action = NULL;
#line 74 "../src/client/plugin/mail-merge/mail-merge.vala"
	self->priv->start_ui = NULL;
#line 75 "../src/client/plugin/mail-merge/mail-merge.vala"
	self->priv->pause_ui = NULL;
#line 77 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 77 "../src/client/plugin/mail-merge/mail-merge.vala"
	self->priv->folder_names = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_LIST, GeeList);
#line 79 "../src/client/plugin/mail-merge/mail-merge.vala"
	_tmp1_ = g_cancellable_new ();
#line 79 "../src/client/plugin/mail-merge/mail-merge.vala"
	self->priv->cancellable = _tmp1_;
#line 4599 "mail-merge.c"
}

static void
plugin_mail_merge_finalize (GObject * obj)
{
	PluginMailMerge * self;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLUGIN_TYPE_MAIL_MERGE, PluginMailMerge);
#line 47 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (self->priv->_folders);
#line 51 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (self->priv->_email);
#line 55 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (self->priv->_client_application);
#line 59 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (self->priv->_client_plugins);
#line 63 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (self->priv->folder_store);
#line 64 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (self->priv->email_store);
#line 66 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (self->priv->merge_folder);
#line 67 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (self->priv->merge_bar);
#line 69 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (self->priv->edit_action);
#line 70 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (self->priv->merge_action);
#line 71 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (self->priv->start_action);
#line 72 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (self->priv->pause_action);
#line 74 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (self->priv->start_ui);
#line 75 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (self->priv->pause_ui);
#line 77 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (self->priv->folder_names);
#line 79 "../src/client/plugin/mail-merge/mail-merge.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	G_OBJECT_CLASS (plugin_mail_merge_parent_class)->finalize (obj);
#line 4642 "mail-merge.c"
}

/**
 * Plugin to fill in and send email templates using a spreadsheet.
 */
GType
plugin_mail_merge_get_type (void)
{
	return plugin_mail_merge_type_id;
}

GType
plugin_mail_merge_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (PluginMailMergeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plugin_mail_merge_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PluginMailMerge), 0, (GInstanceInitFunc) plugin_mail_merge_instance_init, NULL };
	static const GInterfaceInfo plugin_folder_extension_info = { (GInterfaceInitFunc) plugin_mail_merge_plugin_folder_extension_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo plugin_email_extension_info = { (GInterfaceInitFunc) plugin_mail_merge_plugin_email_extension_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo plugin_trusted_extension_info = { (GInterfaceInitFunc) plugin_mail_merge_plugin_trusted_extension_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	plugin_mail_merge_type_id = g_type_module_register_type (module, PLUGIN_TYPE_PLUGIN_BASE, "PluginMailMerge", &g_define_type_info, 0);
	g_type_module_add_interface (module, plugin_mail_merge_type_id, PLUGIN_TYPE_FOLDER_EXTENSION, &plugin_folder_extension_info);
	g_type_module_add_interface (module, plugin_mail_merge_type_id, PLUGIN_TYPE_EMAIL_EXTENSION, &plugin_email_extension_info);
	g_type_module_add_interface (module, plugin_mail_merge_type_id, PLUGIN_TYPE_TRUSTED_EXTENSION, &plugin_trusted_extension_info);
	PluginMailMerge_private_offset = sizeof (PluginMailMergePrivate);
	return plugin_mail_merge_type_id;
}

static void
_vala_plugin_mail_merge_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	PluginMailMerge * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLUGIN_TYPE_MAIL_MERGE, PluginMailMerge);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	switch (property_id) {
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		case PLUGIN_MAIL_MERGE_FOLDERS_PROPERTY:
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_value_set_object (value, plugin_folder_extension_get_folders (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_FOLDER_EXTENSION, PluginFolderExtension)));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		break;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		case PLUGIN_MAIL_MERGE_EMAIL_PROPERTY:
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_value_set_object (value, plugin_email_extension_get_email (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_EMAIL_EXTENSION, PluginEmailExtension)));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		break;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		case PLUGIN_MAIL_MERGE_CLIENT_APPLICATION_PROPERTY:
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_value_set_object (value, plugin_trusted_extension_get_client_application (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_TRUSTED_EXTENSION, PluginTrustedExtension)));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		break;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		case PLUGIN_MAIL_MERGE_CLIENT_PLUGINS_PROPERTY:
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		g_value_set_object (value, plugin_trusted_extension_get_client_plugins (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_TRUSTED_EXTENSION, PluginTrustedExtension)));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		break;
#line 4703 "mail-merge.c"
		default:
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		break;
#line 4709 "mail-merge.c"
	}
}

static void
_vala_plugin_mail_merge_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	PluginMailMerge * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLUGIN_TYPE_MAIL_MERGE, PluginMailMerge);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
	switch (property_id) {
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		case PLUGIN_MAIL_MERGE_FOLDERS_PROPERTY:
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		plugin_folder_extension_set_folders (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_FOLDER_EXTENSION, PluginFolderExtension), g_value_get_object (value));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		break;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		case PLUGIN_MAIL_MERGE_EMAIL_PROPERTY:
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		plugin_email_extension_set_email (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_EMAIL_EXTENSION, PluginEmailExtension), g_value_get_object (value));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		break;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		case PLUGIN_MAIL_MERGE_CLIENT_APPLICATION_PROPERTY:
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		plugin_trusted_extension_set_client_application (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_TRUSTED_EXTENSION, PluginTrustedExtension), g_value_get_object (value));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		break;
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		case PLUGIN_MAIL_MERGE_CLIENT_PLUGINS_PROPERTY:
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		plugin_trusted_extension_set_client_plugins (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_TRUSTED_EXTENSION, PluginTrustedExtension), g_value_get_object (value));
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		break;
#line 4747 "mail-merge.c"
		default:
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/client/plugin/mail-merge/mail-merge.vala"
		break;
#line 4753 "mail-merge.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

