/* geary-account-information.c generated by valac 0.56.17, the Vala compiler
 * generated from geary-account-information.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2018 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_ACCOUNT_INFORMATION_0_PROPERTY,
	GEARY_ACCOUNT_INFORMATION_ID_PROPERTY,
	GEARY_ACCOUNT_INFORMATION_ORDINAL_PROPERTY,
	GEARY_ACCOUNT_INFORMATION_SERVICE_PROVIDER_PROPERTY,
	GEARY_ACCOUNT_INFORMATION_SERVICE_LABEL_PROPERTY,
	GEARY_ACCOUNT_INFORMATION_DISPLAY_NAME_PROPERTY,
	GEARY_ACCOUNT_INFORMATION_LABEL_PROPERTY,
	GEARY_ACCOUNT_INFORMATION_PRIMARY_MAILBOX_PROPERTY,
	GEARY_ACCOUNT_INFORMATION_SENDER_MAILBOXES_PROPERTY,
	GEARY_ACCOUNT_INFORMATION_HAS_SENDER_ALIASES_PROPERTY,
	GEARY_ACCOUNT_INFORMATION_PREFETCH_PERIOD_DAYS_PROPERTY,
	GEARY_ACCOUNT_INFORMATION_SAVE_SENT_PROPERTY,
	GEARY_ACCOUNT_INFORMATION_SAVE_DRAFTS_PROPERTY,
	GEARY_ACCOUNT_INFORMATION_MEDIATOR_PROPERTY,
	GEARY_ACCOUNT_INFORMATION_INCOMING_PROPERTY,
	GEARY_ACCOUNT_INFORMATION_OUTGOING_PROPERTY,
	GEARY_ACCOUNT_INFORMATION_WRITE_LOCK_PROPERTY,
	GEARY_ACCOUNT_INFORMATION_USE_SIGNATURE_PROPERTY,
	GEARY_ACCOUNT_INFORMATION_SIGNATURE_PROPERTY,
	GEARY_ACCOUNT_INFORMATION_CONFIG_DIR_PROPERTY,
	GEARY_ACCOUNT_INFORMATION_DATA_DIR_PROPERTY,
	GEARY_ACCOUNT_INFORMATION_NUM_PROPERTIES
};
static GParamSpec* geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
typedef struct _GearyAccountInformationLoadOutgoingCredentialsData GearyAccountInformationLoadOutgoingCredentialsData;
typedef struct _GearyAccountInformationLoadIncomingCredentialsData GearyAccountInformationLoadIncomingCredentialsData;
typedef struct _Block3Data Block3Data;
enum  {
	GEARY_ACCOUNT_INFORMATION_AUTHENTICATION_FAILURE_SIGNAL,
	GEARY_ACCOUNT_INFORMATION_UNTRUSTED_HOST_SIGNAL,
	GEARY_ACCOUNT_INFORMATION_CHANGED_SIGNAL,
	GEARY_ACCOUNT_INFORMATION_NUM_SIGNALS
};
static guint geary_account_information_signals[GEARY_ACCOUNT_INFORMATION_NUM_SIGNALS] = {0};

struct _GearyAccountInformationPrivate {
	gchar* _id;
	gint _ordinal;
	GearyServiceProvider _service_provider;
	gchar* _service_label;
	gchar* _label;
	gint _prefetch_period_days;
	gboolean _save_sent;
	gboolean _save_drafts;
	GearyCredentialsMediator* _mediator;
	GearyServiceInformation* _incoming;
	GearyServiceInformation* _outgoing;
	GearyNonblockingMutex* _write_lock;
	gboolean _use_signature;
	gchar* _signature;
	GFile* _config_dir;
	GFile* _data_dir;
	GeeMap* special_use_paths;
	GeeList* _mailboxes;
};

struct _Block2Data {
	int _ref_count_;
	GearyAccountInformation* self;
	GearyRFC822MailboxAddress* email;
};

struct _GearyAccountInformationLoadOutgoingCredentialsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyAccountInformation* self;
	GCancellable* cancellable;
	gboolean result;
	GearyCredentials* creds;
	GearyCredentials* _tmp0_;
	gboolean loaded;
	GearyCredentials* _tmp1_;
	GearyServiceInformation* _tmp2_;
	GearyCredentialsRequirement _tmp3_;
	GearyCredentialsRequirement _tmp4_;
	gboolean _tmp5_;
	GearyCredentialsMediator* _tmp6_;
	GearyServiceInformation* _tmp7_;
	gboolean _tmp8_;
	GearyCredentialsMediator* _tmp9_;
	GearyServiceInformation* _tmp10_;
	GError* _inner_error0_;
};

struct _GearyAccountInformationLoadIncomingCredentialsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyAccountInformation* self;
	GCancellable* cancellable;
	gboolean result;
	GearyCredentials* creds;
	GearyServiceInformation* _tmp0_;
	GearyCredentials* _tmp1_;
	GearyCredentials* _tmp2_;
	GearyCredentials* _tmp3_;
	gboolean loaded;
	GearyCredentials* _tmp4_;
	gboolean _tmp5_;
	GearyCredentialsMediator* _tmp6_;
	GearyServiceInformation* _tmp7_;
	GError* _inner_error0_;
};

struct _Block3Data {
	int _ref_count_;
	GearyAccountInformation* self;
	GearyAccountInformation* other;
};

static gint GearyAccountInformation_private_offset;
static gpointer geary_account_information_parent_class = NULL;
gint geary_account_information_next_ordinal = 0;

static void geary_account_information_set_id (GearyAccountInformation* self,
                                       const gchar* value);
static void geary_account_information_set_service_provider (GearyAccountInformation* self,
                                                     GearyServiceProvider value);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static GeeList* geary_account_information_get_mailboxes (GearyAccountInformation* self);
static void geary_account_information_set_mediator (GearyAccountInformation* self,
                                             GearyCredentialsMediator* value);
static void geary_account_information_set_write_lock (GearyAccountInformation* self,
                                               GearyNonblockingMutex* value);
static void geary_account_information_set_config_dir (GearyAccountInformation* self,
                                               GFile* value);
static void geary_account_information_set_data_dir (GearyAccountInformation* self,
                                             GFile* value);
static guint _geary_account_information_special_use_paths_lambda140_ (GearyFolderSpecialUse* k);
static guint __geary_account_information_special_use_paths_lambda140__gee_hash_data_func (gconstpointer v,
                                                                                   gpointer self);
static gboolean _geary_account_information_special_use_paths_lambda141_ (GearyFolderSpecialUse* k1,
                                                                  GearyFolderSpecialUse* k2);
static gboolean __geary_account_information_special_use_paths_lambda141__gee_equal_data_func (gconstpointer a,
                                                                                       gconstpointer b,
                                                                                       gpointer self);
static GearyFolderSpecialUse* _geary_folder_special_use_dup (GearyFolderSpecialUse* self);
static void geary_account_information_set_mailboxes (GearyAccountInformation* self,
                                              GeeList* value);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT (GClosure * closure,
                                                         GValue * return_value,
                                                         guint n_param_values,
                                                         const GValue * param_values,
                                                         gpointer invocation_hint,
                                                         gpointer marshal_data);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean __lambda125_ (Block2Data* _data2_,
                       GearyRFC822MailboxAddress* alt);
static gboolean ___lambda125__gee_predicate (gconstpointer g,
                                      gpointer self);
static void geary_account_information_load_outgoing_credentials_data_free (gpointer _data);
static gboolean geary_account_information_load_outgoing_credentials_co (GearyAccountInformationLoadOutgoingCredentialsData* _data_);
static void geary_account_information_load_outgoing_credentials_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_);
static void geary_account_information_load_incoming_credentials_data_free (gpointer _data);
static gboolean geary_account_information_load_incoming_credentials_co (GearyAccountInformationLoadIncomingCredentialsData* _data_);
static void geary_account_information_load_incoming_credentials_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static gboolean ____lambda147_ (Block3Data* _data3_,
                         GearyRFC822MailboxAddress* addr);
static gboolean _____lambda147__gee_predicate (gconstpointer g,
                                        gpointer self);
static void geary_account_information_finalize (GObject * obj);
static GType geary_account_information_get_type_once (void);
static void _vala_geary_account_information_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_geary_account_information_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
geary_account_information_get_instance_private (GearyAccountInformation* self)
{
	return G_STRUCT_MEMBER_P (self, GearyAccountInformation_private_offset);
}

/** Comparator for account info objects based on their ordinals. */
gint
geary_account_information_compare_ascending (GearyAccountInformation* a,
                                             GearyAccountInformation* b)
{
	gint diff = 0;
	gint _tmp0_;
	gint _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gint result;
#line 19 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (a), 0);
#line 19 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (b), 0);
#line 20 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = a->priv->_ordinal;
#line 20 "../src/engine/api/geary-account-information.vala"
	_tmp1_ = b->priv->_ordinal;
#line 20 "../src/engine/api/geary-account-information.vala"
	diff = _tmp0_ - _tmp1_;
#line 21 "../src/engine/api/geary-account-information.vala"
	if (diff != 0) {
#line 22 "../src/engine/api/geary-account-information.vala"
		result = diff;
#line 22 "../src/engine/api/geary-account-information.vala"
		return result;
#line 258 "geary-account-information.c"
	}
#line 25 "../src/engine/api/geary-account-information.vala"
	_tmp2_ = geary_account_information_get_display_name (a);
#line 25 "../src/engine/api/geary-account-information.vala"
	_tmp3_ = _tmp2_;
#line 25 "../src/engine/api/geary-account-information.vala"
	_tmp4_ = geary_account_information_get_display_name (b);
#line 25 "../src/engine/api/geary-account-information.vala"
	_tmp5_ = _tmp4_;
#line 25 "../src/engine/api/geary-account-information.vala"
	result = g_utf8_collate (_tmp3_, _tmp5_);
#line 25 "../src/engine/api/geary-account-information.vala"
	return result;
#line 272 "geary-account-information.c"
}

const gchar*
geary_account_information_get_id (GearyAccountInformation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 30 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), NULL);
#line 30 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = self->priv->_id;
#line 30 "../src/engine/api/geary-account-information.vala"
	result = _tmp0_;
#line 30 "../src/engine/api/geary-account-information.vala"
	return result;
#line 288 "geary-account-information.c"
}

static void
geary_account_information_set_id (GearyAccountInformation* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 30 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self));
#line 30 "../src/engine/api/geary-account-information.vala"
	old_value = geary_account_information_get_id (self);
#line 30 "../src/engine/api/geary-account-information.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 302 "geary-account-information.c"
		gchar* _tmp0_;
#line 30 "../src/engine/api/geary-account-information.vala"
		_tmp0_ = g_strdup (value);
#line 30 "../src/engine/api/geary-account-information.vala"
		_g_free0 (self->priv->_id);
#line 30 "../src/engine/api/geary-account-information.vala"
		self->priv->_id = _tmp0_;
#line 30 "../src/engine/api/geary-account-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_ID_PROPERTY]);
#line 312 "geary-account-information.c"
	}
}

gint
geary_account_information_get_ordinal (GearyAccountInformation* self)
{
	gint result;
#line 34 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), 0);
#line 34 "../src/engine/api/geary-account-information.vala"
	result = self->priv->_ordinal;
#line 34 "../src/engine/api/geary-account-information.vala"
	return result;
#line 326 "geary-account-information.c"
}

void
geary_account_information_set_ordinal (GearyAccountInformation* self,
                                       gint value)
{
	gint old_value;
#line 34 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self));
#line 34 "../src/engine/api/geary-account-information.vala"
	old_value = geary_account_information_get_ordinal (self);
#line 34 "../src/engine/api/geary-account-information.vala"
	if (old_value != value) {
#line 34 "../src/engine/api/geary-account-information.vala"
		self->priv->_ordinal = value;
#line 34 "../src/engine/api/geary-account-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_ORDINAL_PROPERTY]);
#line 344 "geary-account-information.c"
	}
}

GearyServiceProvider
geary_account_information_get_service_provider (GearyAccountInformation* self)
{
	GearyServiceProvider result;
#line 38 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), 0);
#line 38 "../src/engine/api/geary-account-information.vala"
	result = self->priv->_service_provider;
#line 38 "../src/engine/api/geary-account-information.vala"
	return result;
#line 358 "geary-account-information.c"
}

static void
geary_account_information_set_service_provider (GearyAccountInformation* self,
                                                GearyServiceProvider value)
{
	GearyServiceProvider old_value;
#line 38 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self));
#line 38 "../src/engine/api/geary-account-information.vala"
	old_value = geary_account_information_get_service_provider (self);
#line 38 "../src/engine/api/geary-account-information.vala"
	if (old_value != value) {
#line 38 "../src/engine/api/geary-account-information.vala"
		self->priv->_service_provider = value;
#line 38 "../src/engine/api/geary-account-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_SERVICE_PROVIDER_PROPERTY]);
#line 376 "geary-account-information.c"
	}
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 59 "../src/engine/api/geary-account-information.vala"
	if (length >= 0) {
#line 386 "geary-account-information.c"
		gchar** result;
		gssize i;
#line 59 "../src/engine/api/geary-account-information.vala"
		result = g_new0 (gchar*, length + 1);
#line 59 "../src/engine/api/geary-account-information.vala"
		for (i = 0; i < length; i++) {
#line 393 "geary-account-information.c"
			gchar* _tmp0_;
#line 59 "../src/engine/api/geary-account-information.vala"
			_tmp0_ = g_strdup (self[i]);
#line 59 "../src/engine/api/geary-account-information.vala"
			result[i] = _tmp0_;
#line 399 "geary-account-information.c"
		}
#line 59 "../src/engine/api/geary-account-information.vala"
		return result;
#line 403 "geary-account-information.c"
	}
#line 59 "../src/engine/api/geary-account-information.vala"
	return NULL;
#line 407 "geary-account-information.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 421 "geary-account-information.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 425 "geary-account-information.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 431 "geary-account-information.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 436 "geary-account-information.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 442 "geary-account-information.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 446 "geary-account-information.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 450 "geary-account-information.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 454 "geary-account-information.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 458 "geary-account-information.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 462 "geary-account-information.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 477 "geary-account-information.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 486 "geary-account-information.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 493 "geary-account-information.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 499 "geary-account-information.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 507 "geary-account-information.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 511 "geary-account-information.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 517 "geary-account-information.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 522 "geary-account-information.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 528 "geary-account-information.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 532 "geary-account-information.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 536 "geary-account-information.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 542 "geary-account-information.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 548 "geary-account-information.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 560 "geary-account-information.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 564 "geary-account-information.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 568 "geary-account-information.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 573 "geary-account-information.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 581 "geary-account-information.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 599 "geary-account-information.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 605 "geary-account-information.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 609 "geary-account-information.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 617 "geary-account-information.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 626 "geary-account-information.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 635 "geary-account-information.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 641 "geary-account-information.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 649 "geary-account-information.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 661 "geary-account-information.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 667 "geary-account-information.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 671 "geary-account-information.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 679 "geary-account-information.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 690 "geary-account-information.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 699 "geary-account-information.c"
	}
}

gchar*
geary_account_information_get_service_label (GearyAccountInformation* self)
{
	gchar* result;
	gchar* value = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 49 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), NULL);
#line 50 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = self->priv->_service_label;
#line 50 "../src/engine/api/geary-account-information.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 50 "../src/engine/api/geary-account-information.vala"
	value = _tmp1_;
#line 51 "../src/engine/api/geary-account-information.vala"
	_tmp2_ = value;
#line 51 "../src/engine/api/geary-account-information.vala"
	if (_tmp2_ == NULL) {
#line 723 "geary-account-information.c"
		gchar* email_domain = NULL;
		GearyRFC822MailboxAddress* _tmp3_;
		GearyRFC822MailboxAddress* _tmp4_;
		GearyRFC822MailboxAddress* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GearyServiceInformation* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
#line 52 "../src/engine/api/geary-account-information.vala"
		_tmp3_ = geary_account_information_get_primary_mailbox (self);
#line 52 "../src/engine/api/geary-account-information.vala"
		_tmp4_ = _tmp3_;
#line 52 "../src/engine/api/geary-account-information.vala"
		_tmp5_ = _tmp4_;
#line 52 "../src/engine/api/geary-account-information.vala"
		_tmp6_ = geary_rf_c822_mailbox_address_get_domain (_tmp5_);
#line 52 "../src/engine/api/geary-account-information.vala"
		_tmp7_ = _tmp6_;
#line 52 "../src/engine/api/geary-account-information.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 52 "../src/engine/api/geary-account-information.vala"
		_tmp9_ = _tmp8_;
#line 52 "../src/engine/api/geary-account-information.vala"
		_g_object_unref0 (_tmp5_);
#line 52 "../src/engine/api/geary-account-information.vala"
		email_domain = _tmp9_;
#line 53 "../src/engine/api/geary-account-information.vala"
		_tmp10_ = self->priv->_incoming;
#line 53 "../src/engine/api/geary-account-information.vala"
		_tmp11_ = geary_service_information_get_host (_tmp10_);
#line 53 "../src/engine/api/geary-account-information.vala"
		_tmp12_ = _tmp11_;
#line 53 "../src/engine/api/geary-account-information.vala"
		_tmp13_ = email_domain;
#line 53 "../src/engine/api/geary-account-information.vala"
		if (g_str_has_suffix (_tmp12_, _tmp13_)) {
#line 764 "geary-account-information.c"
			const gchar* _tmp14_;
			gchar* _tmp15_;
#line 54 "../src/engine/api/geary-account-information.vala"
			_tmp14_ = email_domain;
#line 54 "../src/engine/api/geary-account-information.vala"
			_tmp15_ = g_strdup (_tmp14_);
#line 54 "../src/engine/api/geary-account-information.vala"
			_g_free0 (value);
#line 54 "../src/engine/api/geary-account-information.vala"
			value = _tmp15_;
#line 775 "geary-account-information.c"
		} else {
			gchar** host_parts = NULL;
			GearyServiceInformation* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			gchar** _tmp19_;
			gchar** _tmp20_;
			gint host_parts_length1;
			gint _host_parts_size_;
			gboolean _tmp21_ = FALSE;
			gchar** _tmp22_;
			gint _tmp22__length1;
			gchar** _tmp28_;
			gint _tmp28__length1;
			gchar* _tmp29_;
#line 56 "../src/engine/api/geary-account-information.vala"
			_tmp16_ = self->priv->_incoming;
#line 56 "../src/engine/api/geary-account-information.vala"
			_tmp17_ = geary_service_information_get_host (_tmp16_);
#line 56 "../src/engine/api/geary-account-information.vala"
			_tmp18_ = _tmp17_;
#line 56 "../src/engine/api/geary-account-information.vala"
			_tmp20_ = _tmp19_ = g_strsplit (_tmp18_, ".", 0);
#line 56 "../src/engine/api/geary-account-information.vala"
			host_parts = _tmp20_;
#line 56 "../src/engine/api/geary-account-information.vala"
			host_parts_length1 = _vala_array_length (_tmp19_);
#line 56 "../src/engine/api/geary-account-information.vala"
			_host_parts_size_ = host_parts_length1;
#line 58 "../src/engine/api/geary-account-information.vala"
			_tmp22_ = host_parts;
#line 58 "../src/engine/api/geary-account-information.vala"
			_tmp22__length1 = host_parts_length1;
#line 58 "../src/engine/api/geary-account-information.vala"
			if (_tmp22__length1 > 2) {
#line 811 "geary-account-information.c"
				gchar** _tmp23_;
				gint _tmp23__length1;
				const gchar* _tmp24_;
#line 58 "../src/engine/api/geary-account-information.vala"
				_tmp23_ = host_parts;
#line 58 "../src/engine/api/geary-account-information.vala"
				_tmp23__length1 = host_parts_length1;
#line 58 "../src/engine/api/geary-account-information.vala"
				_tmp24_ = _tmp23_[0];
#line 58 "../src/engine/api/geary-account-information.vala"
				_tmp21_ = atoi (_tmp24_) == 0;
#line 823 "geary-account-information.c"
			} else {
#line 58 "../src/engine/api/geary-account-information.vala"
				_tmp21_ = FALSE;
#line 827 "geary-account-information.c"
			}
#line 58 "../src/engine/api/geary-account-information.vala"
			if (_tmp21_) {
#line 831 "geary-account-information.c"
				gchar** _tmp25_;
				gint _tmp25__length1;
				gchar** _tmp26_;
				gint _tmp26__length1;
				gchar** _tmp27_;
				gint _tmp27__length1;
#line 59 "../src/engine/api/geary-account-information.vala"
				_tmp25_ = host_parts;
#line 59 "../src/engine/api/geary-account-information.vala"
				_tmp25__length1 = host_parts_length1;
#line 59 "../src/engine/api/geary-account-information.vala"
				_tmp26_ = host_parts;
#line 59 "../src/engine/api/geary-account-information.vala"
				_tmp26__length1 = host_parts_length1;
#line 59 "../src/engine/api/geary-account-information.vala"
				_tmp27_ = (_tmp25_ != NULL) ? _vala_array_dup1 (_tmp25_ + 1, _tmp26__length1 - 1) : _tmp25_;
#line 59 "../src/engine/api/geary-account-information.vala"
				_tmp27__length1 = _tmp26__length1 - 1;
#line 59 "../src/engine/api/geary-account-information.vala"
				host_parts = (_vala_array_free (host_parts, host_parts_length1, (GDestroyNotify) g_free), NULL);
#line 59 "../src/engine/api/geary-account-information.vala"
				host_parts = _tmp27_;
#line 59 "../src/engine/api/geary-account-information.vala"
				host_parts_length1 = _tmp27__length1;
#line 59 "../src/engine/api/geary-account-information.vala"
				_host_parts_size_ = host_parts_length1;
#line 858 "geary-account-information.c"
			}
#line 61 "../src/engine/api/geary-account-information.vala"
			_tmp28_ = host_parts;
#line 61 "../src/engine/api/geary-account-information.vala"
			_tmp28__length1 = host_parts_length1;
#line 61 "../src/engine/api/geary-account-information.vala"
			_tmp29_ = _vala_g_strjoinv (".", _tmp28_, (gint) _tmp28__length1);
#line 61 "../src/engine/api/geary-account-information.vala"
			_g_free0 (value);
#line 61 "../src/engine/api/geary-account-information.vala"
			value = _tmp29_;
#line 53 "../src/engine/api/geary-account-information.vala"
			host_parts = (_vala_array_free (host_parts, host_parts_length1, (GDestroyNotify) g_free), NULL);
#line 872 "geary-account-information.c"
		}
#line 51 "../src/engine/api/geary-account-information.vala"
		_g_free0 (email_domain);
#line 876 "geary-account-information.c"
	}
#line 67 "../src/engine/api/geary-account-information.vala"
	result = value;
#line 67 "../src/engine/api/geary-account-information.vala"
	return result;
#line 882 "geary-account-information.c"
}

void
geary_account_information_set_service_label (GearyAccountInformation* self,
                                             const gchar* value)
{
	gchar* _tmp0_;
#line 69 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self));
#line 69 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = g_strdup (value);
#line 69 "../src/engine/api/geary-account-information.vala"
	_g_free0 (self->priv->_service_label);
#line 69 "../src/engine/api/geary-account-information.vala"
	self->priv->_service_label = _tmp0_;
#line 69 "../src/engine/api/geary-account-information.vala"
	g_object_notify_by_pspec ((GObject *) self, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_SERVICE_LABEL_PROPERTY]);
#line 900 "geary-account-information.c"
}

const gchar*
geary_account_information_get_display_name (GearyAccountInformation* self)
{
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
#line 82 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), NULL);
#line 83 "../src/engine/api/geary-account-information.vala"
	_tmp1_ = self->priv->_label;
#line 83 "../src/engine/api/geary-account-information.vala"
	if (!geary_string_is_empty_or_whitespace (_tmp1_)) {
#line 915 "geary-account-information.c"
		const gchar* _tmp2_;
#line 84 "../src/engine/api/geary-account-information.vala"
		_tmp2_ = self->priv->_label;
#line 84 "../src/engine/api/geary-account-information.vala"
		_tmp0_ = _tmp2_;
#line 921 "geary-account-information.c"
	} else {
		GearyRFC822MailboxAddress* _tmp3_;
		GearyRFC822MailboxAddress* _tmp4_;
		GearyRFC822MailboxAddress* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 85 "../src/engine/api/geary-account-information.vala"
		_tmp3_ = geary_account_information_get_primary_mailbox (self);
#line 85 "../src/engine/api/geary-account-information.vala"
		_tmp4_ = _tmp3_;
#line 85 "../src/engine/api/geary-account-information.vala"
		_tmp5_ = _tmp4_;
#line 85 "../src/engine/api/geary-account-information.vala"
		_tmp6_ = geary_rf_c822_mailbox_address_get_address (_tmp5_);
#line 85 "../src/engine/api/geary-account-information.vala"
		_tmp7_ = _tmp6_;
#line 85 "../src/engine/api/geary-account-information.vala"
		_tmp0_ = _tmp7_;
#line 85 "../src/engine/api/geary-account-information.vala"
		_g_object_unref0 (_tmp5_);
#line 942 "geary-account-information.c"
	}
#line 83 "../src/engine/api/geary-account-information.vala"
	result = _tmp0_;
#line 83 "../src/engine/api/geary-account-information.vala"
	return result;
#line 948 "geary-account-information.c"
}

const gchar*
geary_account_information_get_label (GearyAccountInformation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 95 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), NULL);
#line 95 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = self->priv->_label;
#line 95 "../src/engine/api/geary-account-information.vala"
	result = _tmp0_;
#line 95 "../src/engine/api/geary-account-information.vala"
	return result;
#line 964 "geary-account-information.c"
}

void
geary_account_information_set_label (GearyAccountInformation* self,
                                     const gchar* value)
{
	gchar* old_value;
#line 95 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self));
#line 95 "../src/engine/api/geary-account-information.vala"
	old_value = geary_account_information_get_label (self);
#line 95 "../src/engine/api/geary-account-information.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 978 "geary-account-information.c"
		gchar* _tmp0_;
#line 95 "../src/engine/api/geary-account-information.vala"
		_tmp0_ = g_strdup (value);
#line 95 "../src/engine/api/geary-account-information.vala"
		_g_free0 (self->priv->_label);
#line 95 "../src/engine/api/geary-account-information.vala"
		self->priv->_label = _tmp0_;
#line 95 "../src/engine/api/geary-account-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_LABEL_PROPERTY]);
#line 988 "geary-account-information.c"
	}
}

GearyRFC822MailboxAddress*
geary_account_information_get_primary_mailbox (GearyAccountInformation* self)
{
	GearyRFC822MailboxAddress* result;
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
	gpointer _tmp3_;
	GearyRFC822MailboxAddress* _tmp4_;
#line 103 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), NULL);
#line 103 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = geary_account_information_get_sender_mailboxes (self);
#line 103 "../src/engine/api/geary-account-information.vala"
	_tmp1_ = _tmp0_;
#line 103 "../src/engine/api/geary-account-information.vala"
	_tmp2_ = _tmp1_;
#line 103 "../src/engine/api/geary-account-information.vala"
	_tmp3_ = gee_list_get (_tmp2_, 0);
#line 103 "../src/engine/api/geary-account-information.vala"
	_tmp4_ = (GearyRFC822MailboxAddress*) _tmp3_;
#line 103 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (_tmp2_);
#line 103 "../src/engine/api/geary-account-information.vala"
	result = _tmp4_;
#line 103 "../src/engine/api/geary-account-information.vala"
	return result;
#line 1019 "geary-account-information.c"
}

GeeList*
geary_account_information_get_sender_mailboxes (GearyAccountInformation* self)
{
	GeeList* result;
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
#line 113 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), NULL);
#line 113 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = self->priv->_mailboxes;
#line 113 "../src/engine/api/geary-account-information.vala"
	_tmp1_ = gee_list_get_read_only_view (_tmp0_);
#line 113 "../src/engine/api/geary-account-information.vala"
	_tmp2_ = _tmp1_;
#line 113 "../src/engine/api/geary-account-information.vala"
	result = _tmp2_;
#line 113 "../src/engine/api/geary-account-information.vala"
	return result;
#line 1041 "geary-account-information.c"
}

gboolean
geary_account_information_get_has_sender_aliases (GearyAccountInformation* self)
{
	gboolean result;
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_;
#line 118 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), FALSE);
#line 118 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = geary_account_information_get_sender_mailboxes (self);
#line 118 "../src/engine/api/geary-account-information.vala"
	_tmp1_ = _tmp0_;
#line 118 "../src/engine/api/geary-account-information.vala"
	_tmp2_ = _tmp1_;
#line 118 "../src/engine/api/geary-account-information.vala"
	_tmp3_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection));
#line 118 "../src/engine/api/geary-account-information.vala"
	_tmp4_ = _tmp3_;
#line 118 "../src/engine/api/geary-account-information.vala"
	_tmp5_ = _tmp4_ > 1;
#line 118 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (_tmp2_);
#line 118 "../src/engine/api/geary-account-information.vala"
	result = _tmp5_;
#line 118 "../src/engine/api/geary-account-information.vala"
	return result;
#line 1074 "geary-account-information.c"
}

gint
geary_account_information_get_prefetch_period_days (GearyAccountInformation* self)
{
	gint result;
#line 123 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), 0);
#line 123 "../src/engine/api/geary-account-information.vala"
	result = self->priv->_prefetch_period_days;
#line 123 "../src/engine/api/geary-account-information.vala"
	return result;
#line 1087 "geary-account-information.c"
}

void
geary_account_information_set_prefetch_period_days (GearyAccountInformation* self,
                                                    gint value)
{
	gint old_value;
#line 123 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self));
#line 123 "../src/engine/api/geary-account-information.vala"
	old_value = geary_account_information_get_prefetch_period_days (self);
#line 123 "../src/engine/api/geary-account-information.vala"
	if (old_value != value) {
#line 123 "../src/engine/api/geary-account-information.vala"
		self->priv->_prefetch_period_days = value;
#line 123 "../src/engine/api/geary-account-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_PREFETCH_PERIOD_DAYS_PROPERTY]);
#line 1105 "geary-account-information.c"
	}
}

gboolean
geary_account_information_get_save_sent (GearyAccountInformation* self)
{
	gboolean result;
	gboolean save = FALSE;
	GearyServiceProvider _tmp0_;
#line 128 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), FALSE);
#line 129 "../src/engine/api/geary-account-information.vala"
	save = self->priv->_save_sent;
#line 130 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = self->priv->_service_provider;
#line 130 "../src/engine/api/geary-account-information.vala"
	switch (_tmp0_) {
#line 130 "../src/engine/api/geary-account-information.vala"
		case GEARY_SERVICE_PROVIDER_GMAIL:
#line 130 "../src/engine/api/geary-account-information.vala"
		case GEARY_SERVICE_PROVIDER_OUTLOOK:
#line 1127 "geary-account-information.c"
		{
#line 133 "../src/engine/api/geary-account-information.vala"
			save = FALSE;
#line 134 "../src/engine/api/geary-account-information.vala"
			break;
#line 1133 "geary-account-information.c"
		}
		default:
		{
#line 136 "../src/engine/api/geary-account-information.vala"
			break;
#line 1139 "geary-account-information.c"
		}
	}
#line 138 "../src/engine/api/geary-account-information.vala"
	result = save;
#line 138 "../src/engine/api/geary-account-information.vala"
	return result;
#line 1146 "geary-account-information.c"
}

void
geary_account_information_set_save_sent (GearyAccountInformation* self,
                                         gboolean value)
{
#line 140 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self));
#line 140 "../src/engine/api/geary-account-information.vala"
	self->priv->_save_sent = value;
#line 140 "../src/engine/api/geary-account-information.vala"
	g_object_notify_by_pspec ((GObject *) self, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_SAVE_SENT_PROPERTY]);
#line 1159 "geary-account-information.c"
}

gboolean
geary_account_information_get_save_drafts (GearyAccountInformation* self)
{
	gboolean result;
#line 145 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), FALSE);
#line 145 "../src/engine/api/geary-account-information.vala"
	result = self->priv->_save_drafts;
#line 145 "../src/engine/api/geary-account-information.vala"
	return result;
#line 1172 "geary-account-information.c"
}

void
geary_account_information_set_save_drafts (GearyAccountInformation* self,
                                           gboolean value)
{
	gboolean old_value;
#line 145 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self));
#line 145 "../src/engine/api/geary-account-information.vala"
	old_value = geary_account_information_get_save_drafts (self);
#line 145 "../src/engine/api/geary-account-information.vala"
	if (old_value != value) {
#line 145 "../src/engine/api/geary-account-information.vala"
		self->priv->_save_drafts = value;
#line 145 "../src/engine/api/geary-account-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_SAVE_DRAFTS_PROPERTY]);
#line 1190 "geary-account-information.c"
	}
}

GearyCredentialsMediator*
geary_account_information_get_mediator (GearyAccountInformation* self)
{
	GearyCredentialsMediator* result;
	GearyCredentialsMediator* _tmp0_;
#line 150 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), NULL);
#line 150 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = self->priv->_mediator;
#line 150 "../src/engine/api/geary-account-information.vala"
	result = _tmp0_;
#line 150 "../src/engine/api/geary-account-information.vala"
	return result;
#line 1207 "geary-account-information.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 150 "../src/engine/api/geary-account-information.vala"
	return self ? g_object_ref (self) : NULL;
#line 1215 "geary-account-information.c"
}

static void
geary_account_information_set_mediator (GearyAccountInformation* self,
                                        GearyCredentialsMediator* value)
{
	GearyCredentialsMediator* old_value;
#line 150 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self));
#line 150 "../src/engine/api/geary-account-information.vala"
	old_value = geary_account_information_get_mediator (self);
#line 150 "../src/engine/api/geary-account-information.vala"
	if (old_value != value) {
#line 1229 "geary-account-information.c"
		GearyCredentialsMediator* _tmp0_;
#line 150 "../src/engine/api/geary-account-information.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 150 "../src/engine/api/geary-account-information.vala"
		_g_object_unref0 (self->priv->_mediator);
#line 150 "../src/engine/api/geary-account-information.vala"
		self->priv->_mediator = _tmp0_;
#line 150 "../src/engine/api/geary-account-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_MEDIATOR_PROPERTY]);
#line 1239 "geary-account-information.c"
	}
}

GearyServiceInformation*
geary_account_information_get_incoming (GearyAccountInformation* self)
{
	GearyServiceInformation* result;
	GearyServiceInformation* _tmp0_;
#line 153 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), NULL);
#line 153 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = self->priv->_incoming;
#line 153 "../src/engine/api/geary-account-information.vala"
	result = _tmp0_;
#line 153 "../src/engine/api/geary-account-information.vala"
	return result;
#line 1256 "geary-account-information.c"
}

void
geary_account_information_set_incoming (GearyAccountInformation* self,
                                        GearyServiceInformation* value)
{
	GearyServiceInformation* old_value;
#line 153 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self));
#line 153 "../src/engine/api/geary-account-information.vala"
	old_value = geary_account_information_get_incoming (self);
#line 153 "../src/engine/api/geary-account-information.vala"
	if (old_value != value) {
#line 1270 "geary-account-information.c"
		GearyServiceInformation* _tmp0_;
#line 153 "../src/engine/api/geary-account-information.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 153 "../src/engine/api/geary-account-information.vala"
		_g_object_unref0 (self->priv->_incoming);
#line 153 "../src/engine/api/geary-account-information.vala"
		self->priv->_incoming = _tmp0_;
#line 153 "../src/engine/api/geary-account-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_INCOMING_PROPERTY]);
#line 1280 "geary-account-information.c"
	}
}

GearyServiceInformation*
geary_account_information_get_outgoing (GearyAccountInformation* self)
{
	GearyServiceInformation* result;
	GearyServiceInformation* _tmp0_;
#line 156 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), NULL);
#line 156 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = self->priv->_outgoing;
#line 156 "../src/engine/api/geary-account-information.vala"
	result = _tmp0_;
#line 156 "../src/engine/api/geary-account-information.vala"
	return result;
#line 1297 "geary-account-information.c"
}

void
geary_account_information_set_outgoing (GearyAccountInformation* self,
                                        GearyServiceInformation* value)
{
	GearyServiceInformation* old_value;
#line 156 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self));
#line 156 "../src/engine/api/geary-account-information.vala"
	old_value = geary_account_information_get_outgoing (self);
#line 156 "../src/engine/api/geary-account-information.vala"
	if (old_value != value) {
#line 1311 "geary-account-information.c"
		GearyServiceInformation* _tmp0_;
#line 156 "../src/engine/api/geary-account-information.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 156 "../src/engine/api/geary-account-information.vala"
		_g_object_unref0 (self->priv->_outgoing);
#line 156 "../src/engine/api/geary-account-information.vala"
		self->priv->_outgoing = _tmp0_;
#line 156 "../src/engine/api/geary-account-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_OUTGOING_PROPERTY]);
#line 1321 "geary-account-information.c"
	}
}

GearyNonblockingMutex*
geary_account_information_get_write_lock (GearyAccountInformation* self)
{
	GearyNonblockingMutex* result;
	GearyNonblockingMutex* _tmp0_;
#line 160 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), NULL);
#line 160 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = self->priv->_write_lock;
#line 160 "../src/engine/api/geary-account-information.vala"
	result = _tmp0_;
#line 160 "../src/engine/api/geary-account-information.vala"
	return result;
#line 1338 "geary-account-information.c"
}

static void
geary_account_information_set_write_lock (GearyAccountInformation* self,
                                          GearyNonblockingMutex* value)
{
	GearyNonblockingMutex* old_value;
#line 160 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self));
#line 160 "../src/engine/api/geary-account-information.vala"
	old_value = geary_account_information_get_write_lock (self);
#line 160 "../src/engine/api/geary-account-information.vala"
	if (old_value != value) {
#line 1352 "geary-account-information.c"
		GearyNonblockingMutex* _tmp0_;
#line 160 "../src/engine/api/geary-account-information.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 160 "../src/engine/api/geary-account-information.vala"
		_g_object_unref0 (self->priv->_write_lock);
#line 160 "../src/engine/api/geary-account-information.vala"
		self->priv->_write_lock = _tmp0_;
#line 160 "../src/engine/api/geary-account-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_WRITE_LOCK_PROPERTY]);
#line 1362 "geary-account-information.c"
	}
}

gboolean
geary_account_information_get_use_signature (GearyAccountInformation* self)
{
	gboolean result;
#line 164 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), FALSE);
#line 164 "../src/engine/api/geary-account-information.vala"
	result = self->priv->_use_signature;
#line 164 "../src/engine/api/geary-account-information.vala"
	return result;
#line 1376 "geary-account-information.c"
}

void
geary_account_information_set_use_signature (GearyAccountInformation* self,
                                             gboolean value)
{
	gboolean old_value;
#line 164 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self));
#line 164 "../src/engine/api/geary-account-information.vala"
	old_value = geary_account_information_get_use_signature (self);
#line 164 "../src/engine/api/geary-account-information.vala"
	if (old_value != value) {
#line 164 "../src/engine/api/geary-account-information.vala"
		self->priv->_use_signature = value;
#line 164 "../src/engine/api/geary-account-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_USE_SIGNATURE_PROPERTY]);
#line 1394 "geary-account-information.c"
	}
}

const gchar*
geary_account_information_get_signature (GearyAccountInformation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 167 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), NULL);
#line 167 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = self->priv->_signature;
#line 167 "../src/engine/api/geary-account-information.vala"
	result = _tmp0_;
#line 167 "../src/engine/api/geary-account-information.vala"
	return result;
#line 1411 "geary-account-information.c"
}

void
geary_account_information_set_signature (GearyAccountInformation* self,
                                         const gchar* value)
{
	gchar* old_value;
#line 167 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self));
#line 167 "../src/engine/api/geary-account-information.vala"
	old_value = geary_account_information_get_signature (self);
#line 167 "../src/engine/api/geary-account-information.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1425 "geary-account-information.c"
		gchar* _tmp0_;
#line 167 "../src/engine/api/geary-account-information.vala"
		_tmp0_ = g_strdup (value);
#line 167 "../src/engine/api/geary-account-information.vala"
		_g_free0 (self->priv->_signature);
#line 167 "../src/engine/api/geary-account-information.vala"
		self->priv->_signature = _tmp0_;
#line 167 "../src/engine/api/geary-account-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_SIGNATURE_PROPERTY]);
#line 1435 "geary-account-information.c"
	}
}

GFile*
geary_account_information_get_config_dir (GearyAccountInformation* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 175 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), NULL);
#line 175 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = self->priv->_config_dir;
#line 175 "../src/engine/api/geary-account-information.vala"
	result = _tmp0_;
#line 175 "../src/engine/api/geary-account-information.vala"
	return result;
#line 1452 "geary-account-information.c"
}

static void
geary_account_information_set_config_dir (GearyAccountInformation* self,
                                          GFile* value)
{
	GFile* old_value;
#line 175 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self));
#line 175 "../src/engine/api/geary-account-information.vala"
	old_value = geary_account_information_get_config_dir (self);
#line 175 "../src/engine/api/geary-account-information.vala"
	if (old_value != value) {
#line 1466 "geary-account-information.c"
		GFile* _tmp0_;
#line 175 "../src/engine/api/geary-account-information.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 175 "../src/engine/api/geary-account-information.vala"
		_g_object_unref0 (self->priv->_config_dir);
#line 175 "../src/engine/api/geary-account-information.vala"
		self->priv->_config_dir = _tmp0_;
#line 175 "../src/engine/api/geary-account-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_CONFIG_DIR_PROPERTY]);
#line 1476 "geary-account-information.c"
	}
}

GFile*
geary_account_information_get_data_dir (GearyAccountInformation* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 183 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), NULL);
#line 183 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = self->priv->_data_dir;
#line 183 "../src/engine/api/geary-account-information.vala"
	result = _tmp0_;
#line 183 "../src/engine/api/geary-account-information.vala"
	return result;
#line 1493 "geary-account-information.c"
}

static void
geary_account_information_set_data_dir (GearyAccountInformation* self,
                                        GFile* value)
{
	GFile* old_value;
#line 183 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self));
#line 183 "../src/engine/api/geary-account-information.vala"
	old_value = geary_account_information_get_data_dir (self);
#line 183 "../src/engine/api/geary-account-information.vala"
	if (old_value != value) {
#line 1507 "geary-account-information.c"
		GFile* _tmp0_;
#line 183 "../src/engine/api/geary-account-information.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 183 "../src/engine/api/geary-account-information.vala"
		_g_object_unref0 (self->priv->_data_dir);
#line 183 "../src/engine/api/geary-account-information.vala"
		self->priv->_data_dir = _tmp0_;
#line 183 "../src/engine/api/geary-account-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_DATA_DIR_PROPERTY]);
#line 1517 "geary-account-information.c"
	}
}

static guint
_geary_account_information_special_use_paths_lambda140_ (GearyFolderSpecialUse* k)
{
	GHashFunc _tmp0_;
	guint result;
#line 187 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = g_int_hash;
#line 187 "../src/engine/api/geary-account-information.vala"
	result = _tmp0_ ((gint*) k);
#line 187 "../src/engine/api/geary-account-information.vala"
	return result;
#line 1532 "geary-account-information.c"
}

static guint
__geary_account_information_special_use_paths_lambda140__gee_hash_data_func (gconstpointer v,
                                                                             gpointer self)
{
	guint result;
	result = _geary_account_information_special_use_paths_lambda140_ ((GearyFolderSpecialUse*) v);
#line 185 "../src/engine/api/geary-account-information.vala"
	return result;
#line 1543 "geary-account-information.c"
}

static gboolean
_geary_account_information_special_use_paths_lambda141_ (GearyFolderSpecialUse* k1,
                                                         GearyFolderSpecialUse* k2)
{
	gboolean result;
#line 188 "../src/engine/api/geary-account-information.vala"
	result = ((GearyFolderSpecialUse) (*k1)) == ((GearyFolderSpecialUse) (*k2));
#line 188 "../src/engine/api/geary-account-information.vala"
	return result;
#line 1555 "geary-account-information.c"
}

static gboolean
__geary_account_information_special_use_paths_lambda141__gee_equal_data_func (gconstpointer a,
                                                                              gconstpointer b,
                                                                              gpointer self)
{
	gboolean result;
	result = _geary_account_information_special_use_paths_lambda141_ ((GearyFolderSpecialUse*) a, (GearyFolderSpecialUse*) b);
#line 185 "../src/engine/api/geary-account-information.vala"
	return result;
#line 1567 "geary-account-information.c"
}

static GearyFolderSpecialUse*
_geary_folder_special_use_dup (GearyFolderSpecialUse* self)
{
	GearyFolderSpecialUse* dup;
#line 185 "../src/engine/api/geary-account-information.vala"
	dup = g_new0 (GearyFolderSpecialUse, 1);
#line 185 "../src/engine/api/geary-account-information.vala"
	memcpy (dup, self, sizeof (GearyFolderSpecialUse));
#line 185 "../src/engine/api/geary-account-information.vala"
	return dup;
#line 1580 "geary-account-information.c"
}

static GeeList*
geary_account_information_get_mailboxes (GearyAccountInformation* self)
{
	GeeList* result;
	GeeList* _tmp0_;
#line 192 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), NULL);
#line 192 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = self->priv->_mailboxes;
#line 192 "../src/engine/api/geary-account-information.vala"
	result = _tmp0_;
#line 192 "../src/engine/api/geary-account-information.vala"
	return result;
#line 1596 "geary-account-information.c"
}

static void
geary_account_information_set_mailboxes (GearyAccountInformation* self,
                                         GeeList* value)
{
	GeeList* _tmp0_;
#line 192 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self));
#line 192 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 192 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (self->priv->_mailboxes);
#line 192 "../src/engine/api/geary-account-information.vala"
	self->priv->_mailboxes = _tmp0_;
#line 1612 "geary-account-information.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 9 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (n_param_values == 4);
#line 9 "../src/engine/api/geary-account-information.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 9 "../src/engine/api/geary-account-information.vala"
		data1 = closure->data;
#line 9 "../src/engine/api/geary-account-information.vala"
		data2 = param_values->data[0].v_pointer;
#line 1637 "geary-account-information.c"
	} else {
#line 9 "../src/engine/api/geary-account-information.vala"
		data1 = param_values->data[0].v_pointer;
#line 9 "../src/engine/api/geary-account-information.vala"
		data2 = closure->data;
#line 1643 "geary-account-information.c"
	}
#line 9 "../src/engine/api/geary-account-information.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 9 "../src/engine/api/geary-account-information.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_object (param_values + 3), data2);
#line 1649 "geary-account-information.c"
}

/**
     * Creates a new account with default settings.
     */
GearyAccountInformation*
geary_account_information_construct (GType object_type,
                                     const gchar* id,
                                     GearyServiceProvider provider,
                                     GearyCredentialsMediator* mediator,
                                     GearyRFC822MailboxAddress* primary_mailbox)
{
	GearyAccountInformation * self = NULL;
	GearyServiceInformation* _tmp0_;
	GearyServiceInformation* _tmp1_;
	GearyServiceInformation* _tmp2_;
	GearyServiceInformation* _tmp3_;
#line 232 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 232 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS_MEDIATOR (mediator), NULL);
#line 232 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MAILBOX_ADDRESS (primary_mailbox), NULL);
#line 232 "../src/engine/api/geary-account-information.vala"
	self = (GearyAccountInformation*) geary_base_object_construct (object_type);
#line 236 "../src/engine/api/geary-account-information.vala"
	geary_account_information_set_id (self, id);
#line 237 "../src/engine/api/geary-account-information.vala"
	geary_account_information_set_mediator (self, mediator);
#line 238 "../src/engine/api/geary-account-information.vala"
	geary_account_information_set_service_provider (self, provider);
#line 239 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = geary_service_information_new (GEARY_PROTOCOL_IMAP, provider);
#line 239 "../src/engine/api/geary-account-information.vala"
	_tmp1_ = _tmp0_;
#line 239 "../src/engine/api/geary-account-information.vala"
	geary_account_information_set_incoming (self, _tmp1_);
#line 239 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (_tmp1_);
#line 240 "../src/engine/api/geary-account-information.vala"
	_tmp2_ = geary_service_information_new (GEARY_PROTOCOL_SMTP, provider);
#line 240 "../src/engine/api/geary-account-information.vala"
	_tmp3_ = _tmp2_;
#line 240 "../src/engine/api/geary-account-information.vala"
	geary_account_information_set_outgoing (self, _tmp3_);
#line 240 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (_tmp3_);
#line 242 "../src/engine/api/geary-account-information.vala"
	geary_service_provider_set_account_defaults (provider, self);
#line 244 "../src/engine/api/geary-account-information.vala"
	geary_account_information_append_sender (self, primary_mailbox);
#line 232 "../src/engine/api/geary-account-information.vala"
	return self;
#line 1703 "geary-account-information.c"
}

GearyAccountInformation*
geary_account_information_new (const gchar* id,
                               GearyServiceProvider provider,
                               GearyCredentialsMediator* mediator,
                               GearyRFC822MailboxAddress* primary_mailbox)
{
#line 232 "../src/engine/api/geary-account-information.vala"
	return geary_account_information_construct (GEARY_TYPE_ACCOUNT_INFORMATION, id, provider, mediator, primary_mailbox);
#line 1714 "geary-account-information.c"
}

/**
     * Creates a copy of an existing config.
     */
GearyAccountInformation*
geary_account_information_construct_copy (GType object_type,
                                          GearyAccountInformation* other)
{
	GearyAccountInformation * self = NULL;
	const gchar* _tmp0_;
	GearyServiceProvider _tmp1_;
	GearyCredentialsMediator* _tmp2_;
	GearyRFC822MailboxAddress* _tmp3_;
	GearyRFC822MailboxAddress* _tmp4_;
	GearyRFC822MailboxAddress* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	GeeList* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	const gchar* _tmp25_;
	GearyServiceInformation* _tmp26_;
	GearyServiceInformation* _tmp27_;
	GearyServiceInformation* _tmp28_;
	GearyServiceInformation* _tmp29_;
	GearyServiceInformation* _tmp30_;
	GearyServiceInformation* _tmp31_;
	GeeMap* _tmp32_;
	GeeMap* _tmp33_;
	GFile* _tmp34_;
	GFile* _tmp35_;
#line 250 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (other), NULL);
#line 251 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = other->priv->_id;
#line 251 "../src/engine/api/geary-account-information.vala"
	_tmp1_ = other->priv->_service_provider;
#line 251 "../src/engine/api/geary-account-information.vala"
	_tmp2_ = other->priv->_mediator;
#line 251 "../src/engine/api/geary-account-information.vala"
	_tmp3_ = geary_account_information_get_primary_mailbox (other);
#line 251 "../src/engine/api/geary-account-information.vala"
	_tmp4_ = _tmp3_;
#line 251 "../src/engine/api/geary-account-information.vala"
	_tmp5_ = _tmp4_;
#line 251 "../src/engine/api/geary-account-information.vala"
	self = (GearyAccountInformation*) geary_account_information_construct (object_type, _tmp0_, _tmp1_, _tmp2_, _tmp5_);
#line 251 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (_tmp5_);
#line 257 "../src/engine/api/geary-account-information.vala"
	_tmp6_ = geary_account_information_get_service_label (other);
#line 257 "../src/engine/api/geary-account-information.vala"
	_tmp7_ = _tmp6_;
#line 257 "../src/engine/api/geary-account-information.vala"
	_tmp8_ = _tmp7_;
#line 257 "../src/engine/api/geary-account-information.vala"
	geary_account_information_set_service_label (self, _tmp8_);
#line 257 "../src/engine/api/geary-account-information.vala"
	_g_free0 (_tmp8_);
#line 258 "../src/engine/api/geary-account-information.vala"
	_tmp9_ = other->priv->_label;
#line 258 "../src/engine/api/geary-account-information.vala"
	geary_account_information_set_label (self, _tmp9_);
#line 259 "../src/engine/api/geary-account-information.vala"
	_tmp10_ = other->priv->_mailboxes;
#line 259 "../src/engine/api/geary-account-information.vala"
	_tmp11_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_COLLECTION, GeeCollection));
#line 259 "../src/engine/api/geary-account-information.vala"
	_tmp12_ = _tmp11_;
#line 259 "../src/engine/api/geary-account-information.vala"
	if (_tmp12_ > 1) {
#line 1794 "geary-account-information.c"
		GeeList* _tmp13_;
		GeeList* _tmp14_;
		GeeList* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		GeeList* _tmp18_;
		GeeList* _tmp19_;
#line 260 "../src/engine/api/geary-account-information.vala"
		_tmp13_ = self->priv->_mailboxes;
#line 260 "../src/engine/api/geary-account-information.vala"
		_tmp14_ = other->priv->_mailboxes;
#line 260 "../src/engine/api/geary-account-information.vala"
		_tmp15_ = other->priv->_mailboxes;
#line 260 "../src/engine/api/geary-account-information.vala"
		_tmp16_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_COLLECTION, GeeCollection));
#line 260 "../src/engine/api/geary-account-information.vala"
		_tmp17_ = _tmp16_;
#line 260 "../src/engine/api/geary-account-information.vala"
		_tmp18_ = gee_list_slice (_tmp14_, 1, _tmp17_);
#line 260 "../src/engine/api/geary-account-information.vala"
		_tmp19_ = _tmp18_;
#line 260 "../src/engine/api/geary-account-information.vala"
		gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEE_TYPE_COLLECTION, GeeCollection));
#line 260 "../src/engine/api/geary-account-information.vala"
		_g_object_unref0 (_tmp19_);
#line 1820 "geary-account-information.c"
	}
#line 264 "../src/engine/api/geary-account-information.vala"
	_tmp20_ = other->priv->_prefetch_period_days;
#line 264 "../src/engine/api/geary-account-information.vala"
	geary_account_information_set_prefetch_period_days (self, _tmp20_);
#line 265 "../src/engine/api/geary-account-information.vala"
	_tmp21_ = geary_account_information_get_save_sent (other);
#line 265 "../src/engine/api/geary-account-information.vala"
	_tmp22_ = _tmp21_;
#line 265 "../src/engine/api/geary-account-information.vala"
	geary_account_information_set_save_sent (self, _tmp22_);
#line 266 "../src/engine/api/geary-account-information.vala"
	_tmp23_ = other->priv->_save_drafts;
#line 266 "../src/engine/api/geary-account-information.vala"
	geary_account_information_set_save_drafts (self, _tmp23_);
#line 267 "../src/engine/api/geary-account-information.vala"
	_tmp24_ = other->priv->_use_signature;
#line 267 "../src/engine/api/geary-account-information.vala"
	geary_account_information_set_use_signature (self, _tmp24_);
#line 268 "../src/engine/api/geary-account-information.vala"
	_tmp25_ = other->priv->_signature;
#line 268 "../src/engine/api/geary-account-information.vala"
	geary_account_information_set_signature (self, _tmp25_);
#line 270 "../src/engine/api/geary-account-information.vala"
	_tmp26_ = other->priv->_incoming;
#line 270 "../src/engine/api/geary-account-information.vala"
	_tmp27_ = geary_service_information_new_copy (_tmp26_);
#line 270 "../src/engine/api/geary-account-information.vala"
	_tmp28_ = _tmp27_;
#line 270 "../src/engine/api/geary-account-information.vala"
	geary_account_information_set_incoming (self, _tmp28_);
#line 270 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (_tmp28_);
#line 271 "../src/engine/api/geary-account-information.vala"
	_tmp29_ = other->priv->_outgoing;
#line 271 "../src/engine/api/geary-account-information.vala"
	_tmp30_ = geary_service_information_new_copy (_tmp29_);
#line 271 "../src/engine/api/geary-account-information.vala"
	_tmp31_ = _tmp30_;
#line 271 "../src/engine/api/geary-account-information.vala"
	geary_account_information_set_outgoing (self, _tmp31_);
#line 271 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (_tmp31_);
#line 273 "../src/engine/api/geary-account-information.vala"
	_tmp32_ = self->priv->special_use_paths;
#line 273 "../src/engine/api/geary-account-information.vala"
	_tmp33_ = other->priv->special_use_paths;
#line 273 "../src/engine/api/geary-account-information.vala"
	gee_map_set_all (_tmp32_, _tmp33_);
#line 275 "../src/engine/api/geary-account-information.vala"
	_tmp34_ = other->priv->_config_dir;
#line 275 "../src/engine/api/geary-account-information.vala"
	geary_account_information_set_config_dir (self, _tmp34_);
#line 276 "../src/engine/api/geary-account-information.vala"
	_tmp35_ = other->priv->_data_dir;
#line 276 "../src/engine/api/geary-account-information.vala"
	geary_account_information_set_data_dir (self, _tmp35_);
#line 250 "../src/engine/api/geary-account-information.vala"
	return self;
#line 1880 "geary-account-information.c"
}

GearyAccountInformation*
geary_account_information_new_copy (GearyAccountInformation* other)
{
#line 250 "../src/engine/api/geary-account-information.vala"
	return geary_account_information_construct_copy (GEARY_TYPE_ACCOUNT_INFORMATION, other);
#line 1888 "geary-account-information.c"
}

/** Sets the location of the account's storage directories. */
void
geary_account_information_set_account_directories (GearyAccountInformation* self,
                                                   GFile* config,
                                                   GFile* data)
{
#line 280 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self));
#line 280 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (config, g_file_get_type ()));
#line 280 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (data, g_file_get_type ()));
#line 281 "../src/engine/api/geary-account-information.vala"
	geary_account_information_set_config_dir (self, config);
#line 282 "../src/engine/api/geary-account-information.vala"
	geary_account_information_set_data_dir (self, data);
#line 1907 "geary-account-information.c"
}

/**
     * Determines if a mailbox is in the sender mailbox list.
     *
     * Returns true if the given address is equal to one of the
     * addresses in {@link sender_mailboxes}, by case-insensitive
     * matching the address parts.
     *
     * @see Geary.RFC822.MailboxAddress.equal_to
     */
static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 294 "../src/engine/api/geary-account-information.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 294 "../src/engine/api/geary-account-information.vala"
	return _data2_;
#line 1926 "geary-account-information.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 294 "../src/engine/api/geary-account-information.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1936 "geary-account-information.c"
		GearyAccountInformation* self;
#line 294 "../src/engine/api/geary-account-information.vala"
		self = _data2_->self;
#line 294 "../src/engine/api/geary-account-information.vala"
		_g_object_unref0 (_data2_->email);
#line 294 "../src/engine/api/geary-account-information.vala"
		_g_object_unref0 (self);
#line 294 "../src/engine/api/geary-account-information.vala"
		g_slice_free (Block2Data, _data2_);
#line 1946 "geary-account-information.c"
	}
}

static gboolean
__lambda125_ (Block2Data* _data2_,
              GearyRFC822MailboxAddress* alt)
{
	GearyAccountInformation* self;
	gboolean result;
#line 295 "../src/engine/api/geary-account-information.vala"
	self = _data2_->self;
#line 295 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MAILBOX_ADDRESS (alt), FALSE);
#line 295 "../src/engine/api/geary-account-information.vala"
	result = gee_hashable_equal_to (G_TYPE_CHECK_INSTANCE_CAST (alt, GEE_TYPE_HASHABLE, GeeHashable), _data2_->email);
#line 295 "../src/engine/api/geary-account-information.vala"
	return result;
#line 1964 "geary-account-information.c"
}

static gboolean
___lambda125__gee_predicate (gconstpointer g,
                             gpointer self)
{
	gboolean result;
	result = __lambda125_ (self, (GearyRFC822MailboxAddress*) g);
#line 295 "../src/engine/api/geary-account-information.vala"
	return result;
#line 1975 "geary-account-information.c"
}

gboolean
geary_account_information_has_sender_mailbox (GearyAccountInformation* self,
                                              GearyRFC822MailboxAddress* email)
{
	Block2Data* _data2_;
	GearyRFC822MailboxAddress* _tmp0_;
	GeeList* _tmp1_;
	gboolean result;
#line 294 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), FALSE);
#line 294 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MAILBOX_ADDRESS (email), FALSE);
#line 294 "../src/engine/api/geary-account-information.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 294 "../src/engine/api/geary-account-information.vala"
	_data2_->_ref_count_ = 1;
#line 294 "../src/engine/api/geary-account-information.vala"
	_data2_->self = g_object_ref (self);
#line 294 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = _g_object_ref0 (email);
#line 294 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (_data2_->email);
#line 294 "../src/engine/api/geary-account-information.vala"
	_data2_->email = _tmp0_;
#line 295 "../src/engine/api/geary-account-information.vala"
	_tmp1_ = self->priv->_mailboxes;
#line 295 "../src/engine/api/geary-account-information.vala"
	result = gee_traversable_any_match (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_TRAVERSABLE, GeeTraversable), ___lambda125__gee_predicate, block2_data_ref (_data2_), block2_data_unref);
#line 295 "../src/engine/api/geary-account-information.vala"
	block2_data_unref (_data2_);
#line 295 "../src/engine/api/geary-account-information.vala"
	_data2_ = NULL;
#line 295 "../src/engine/api/geary-account-information.vala"
	return result;
#line 2012 "geary-account-information.c"
}

/**
     * Appends a mailbox to the list of sender mailboxes.
     *
     * Mailboxes with duplicate addresses will not be added.
     *
     * Returns true if the mailbox was appended.
     */
gboolean
geary_account_information_append_sender (GearyAccountInformation* self,
                                         GearyRFC822MailboxAddress* mailbox)
{
	gboolean add = FALSE;
	gboolean result;
#line 305 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), FALSE);
#line 305 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MAILBOX_ADDRESS (mailbox), FALSE);
#line 306 "../src/engine/api/geary-account-information.vala"
	add = !geary_account_information_has_sender_mailbox (self, mailbox);
#line 307 "../src/engine/api/geary-account-information.vala"
	if (add) {
#line 2036 "geary-account-information.c"
		GeeList* _tmp0_;
#line 308 "../src/engine/api/geary-account-information.vala"
		_tmp0_ = self->priv->_mailboxes;
#line 308 "../src/engine/api/geary-account-information.vala"
		gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), mailbox);
#line 2042 "geary-account-information.c"
	}
#line 310 "../src/engine/api/geary-account-information.vala"
	result = add;
#line 310 "../src/engine/api/geary-account-information.vala"
	return result;
#line 2048 "geary-account-information.c"
}

/**
     * Inserts a mailbox into the list of sender mailboxes.
     *
     * Mailboxes with duplicate addresses will not be added.
     *
     * Returns true if the mailbox was inserted.
     */
gboolean
geary_account_information_insert_sender (GearyAccountInformation* self,
                                         gint index,
                                         GearyRFC822MailboxAddress* mailbox)
{
	gboolean add = FALSE;
	gboolean result;
#line 320 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), FALSE);
#line 320 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MAILBOX_ADDRESS (mailbox), FALSE);
#line 321 "../src/engine/api/geary-account-information.vala"
	add = !geary_account_information_has_sender_mailbox (self, mailbox);
#line 322 "../src/engine/api/geary-account-information.vala"
	if (add) {
#line 2073 "geary-account-information.c"
		GeeList* _tmp0_;
#line 323 "../src/engine/api/geary-account-information.vala"
		_tmp0_ = self->priv->_mailboxes;
#line 323 "../src/engine/api/geary-account-information.vala"
		gee_list_insert (_tmp0_, index, mailbox);
#line 2079 "geary-account-information.c"
	}
#line 325 "../src/engine/api/geary-account-information.vala"
	result = add;
#line 325 "../src/engine/api/geary-account-information.vala"
	return result;
#line 2085 "geary-account-information.c"
}

/**
     * Removes a mailbox from the list of sender mailboxes.
     *
     * The last mailbox cannot be removed.
     *
     * Returns true if the mailbox was removed.
     */
gboolean
geary_account_information_remove_sender (GearyAccountInformation* self,
                                         GearyRFC822MailboxAddress* mailbox)
{
	gboolean removed = FALSE;
	GeeList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean result;
#line 335 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), FALSE);
#line 335 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MAILBOX_ADDRESS (mailbox), FALSE);
#line 336 "../src/engine/api/geary-account-information.vala"
	removed = FALSE;
#line 337 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = self->priv->_mailboxes;
#line 337 "../src/engine/api/geary-account-information.vala"
	_tmp1_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection));
#line 337 "../src/engine/api/geary-account-information.vala"
	_tmp2_ = _tmp1_;
#line 337 "../src/engine/api/geary-account-information.vala"
	if (_tmp2_ > 1) {
#line 2118 "geary-account-information.c"
		GeeList* _tmp3_;
#line 338 "../src/engine/api/geary-account-information.vala"
		_tmp3_ = self->priv->_mailboxes;
#line 338 "../src/engine/api/geary-account-information.vala"
		removed = gee_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection), mailbox);
#line 2124 "geary-account-information.c"
	}
#line 340 "../src/engine/api/geary-account-information.vala"
	result = removed;
#line 340 "../src/engine/api/geary-account-information.vala"
	return result;
#line 2130 "geary-account-information.c"
}

/**
     * Replace a mailbox at the specified index.
     */
void
geary_account_information_replace_sender (GearyAccountInformation* self,
                                          gint index,
                                          GearyRFC822MailboxAddress* mailbox)
{
	GeeList* _tmp0_;
#line 346 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self));
#line 346 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (GEARY_RF_C822_IS_MAILBOX_ADDRESS (mailbox));
#line 347 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = self->priv->_mailboxes;
#line 347 "../src/engine/api/geary-account-information.vala"
	gee_list_set (_tmp0_, index, mailbox);
#line 2150 "geary-account-information.c"
}

/**
     * Returns the folder path steps configured for a specific use.
     */
GeeList*
geary_account_information_get_folder_steps_for_use (GearyAccountInformation* self,
                                                    GearyFolderSpecialUse use)
{
	GeeList* steps = NULL;
	GeeMap* _tmp0_;
	gpointer _tmp1_;
	GeeList* _tmp2_;
	GeeList* result;
#line 353 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), NULL);
#line 354 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = self->priv->special_use_paths;
#line 354 "../src/engine/api/geary-account-information.vala"
	_tmp1_ = gee_map_get (_tmp0_, (gpointer) ((gintptr) (&use)));
#line 354 "../src/engine/api/geary-account-information.vala"
	steps = (GeeList*) _tmp1_;
#line 355 "../src/engine/api/geary-account-information.vala"
	_tmp2_ = steps;
#line 355 "../src/engine/api/geary-account-information.vala"
	if (_tmp2_ != NULL) {
#line 2177 "geary-account-information.c"
		GeeList* _tmp3_;
		GeeList* _tmp4_;
		GeeList* _tmp5_;
#line 356 "../src/engine/api/geary-account-information.vala"
		_tmp3_ = steps;
#line 356 "../src/engine/api/geary-account-information.vala"
		_tmp4_ = gee_list_get_read_only_view (_tmp3_);
#line 356 "../src/engine/api/geary-account-information.vala"
		_tmp5_ = _tmp4_;
#line 356 "../src/engine/api/geary-account-information.vala"
		_g_object_unref0 (steps);
#line 356 "../src/engine/api/geary-account-information.vala"
		steps = _tmp5_;
#line 2191 "geary-account-information.c"
	} else {
		GeeList* _tmp6_;
#line 358 "../src/engine/api/geary-account-information.vala"
		_tmp6_ = gee_list_empty (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free);
#line 358 "../src/engine/api/geary-account-information.vala"
		_g_object_unref0 (steps);
#line 358 "../src/engine/api/geary-account-information.vala"
		steps = _tmp6_;
#line 2200 "geary-account-information.c"
	}
#line 360 "../src/engine/api/geary-account-information.vala"
	result = steps;
#line 360 "../src/engine/api/geary-account-information.vala"
	return result;
#line 2206 "geary-account-information.c"
}

/**
     * Sets the configured folder path steps for a specific use.
     */
void
geary_account_information_set_folder_steps_for_use (GearyAccountInformation* self,
                                                    GearyFolderSpecialUse special,
                                                    GeeList* new_path)
{
	GeeList* existing = NULL;
	GeeMap* _tmp0_;
	gpointer _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	GeeList* _tmp10_;
#line 366 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self));
#line 366 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail ((new_path == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (new_path, GEE_TYPE_LIST));
#line 368 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = self->priv->special_use_paths;
#line 368 "../src/engine/api/geary-account-information.vala"
	_tmp1_ = gee_map_get (_tmp0_, (gpointer) ((gintptr) (&special)));
#line 368 "../src/engine/api/geary-account-information.vala"
	existing = (GeeList*) _tmp1_;
#line 369 "../src/engine/api/geary-account-information.vala"
	if (new_path != NULL) {
#line 2237 "geary-account-information.c"
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 369 "../src/engine/api/geary-account-information.vala"
		_tmp3_ = gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (new_path, GEE_TYPE_COLLECTION, GeeCollection));
#line 369 "../src/engine/api/geary-account-information.vala"
		_tmp4_ = _tmp3_;
#line 369 "../src/engine/api/geary-account-information.vala"
		_tmp2_ = !_tmp4_;
#line 2246 "geary-account-information.c"
	} else {
#line 369 "../src/engine/api/geary-account-information.vala"
		_tmp2_ = FALSE;
#line 2250 "geary-account-information.c"
	}
#line 369 "../src/engine/api/geary-account-information.vala"
	if (_tmp2_) {
#line 2254 "geary-account-information.c"
		GeeMap* _tmp5_;
#line 370 "../src/engine/api/geary-account-information.vala"
		_tmp5_ = self->priv->special_use_paths;
#line 370 "../src/engine/api/geary-account-information.vala"
		gee_map_set (_tmp5_, (gpointer) ((gintptr) (&special)), new_path);
#line 2260 "geary-account-information.c"
	} else {
		GeeMap* _tmp6_;
#line 372 "../src/engine/api/geary-account-information.vala"
		_tmp6_ = self->priv->special_use_paths;
#line 372 "../src/engine/api/geary-account-information.vala"
		gee_map_unset (_tmp6_, (gpointer) ((gintptr) (&special)), NULL);
#line 2267 "geary-account-information.c"
	}
#line 374 "../src/engine/api/geary-account-information.vala"
	_tmp10_ = existing;
#line 374 "../src/engine/api/geary-account-information.vala"
	if (_tmp10_ == NULL) {
#line 374 "../src/engine/api/geary-account-information.vala"
		_tmp9_ = new_path != NULL;
#line 2275 "geary-account-information.c"
	} else {
#line 374 "../src/engine/api/geary-account-information.vala"
		_tmp9_ = FALSE;
#line 2279 "geary-account-information.c"
	}
#line 374 "../src/engine/api/geary-account-information.vala"
	if (_tmp9_) {
#line 374 "../src/engine/api/geary-account-information.vala"
		_tmp8_ = TRUE;
#line 2285 "geary-account-information.c"
	} else {
		gboolean _tmp11_ = FALSE;
		GeeList* _tmp12_;
#line 375 "../src/engine/api/geary-account-information.vala"
		_tmp12_ = existing;
#line 375 "../src/engine/api/geary-account-information.vala"
		if (_tmp12_ != NULL) {
#line 375 "../src/engine/api/geary-account-information.vala"
			_tmp11_ = new_path == NULL;
#line 2295 "geary-account-information.c"
		} else {
#line 375 "../src/engine/api/geary-account-information.vala"
			_tmp11_ = FALSE;
#line 2299 "geary-account-information.c"
		}
#line 375 "../src/engine/api/geary-account-information.vala"
		_tmp8_ = _tmp11_;
#line 2303 "geary-account-information.c"
	}
#line 374 "../src/engine/api/geary-account-information.vala"
	if (_tmp8_) {
#line 374 "../src/engine/api/geary-account-information.vala"
		_tmp7_ = TRUE;
#line 2309 "geary-account-information.c"
	} else {
		gboolean _tmp13_ = FALSE;
		GeeList* _tmp14_;
#line 376 "../src/engine/api/geary-account-information.vala"
		_tmp14_ = existing;
#line 376 "../src/engine/api/geary-account-information.vala"
		if (_tmp14_ != NULL) {
#line 2317 "geary-account-information.c"
			gboolean _tmp15_ = FALSE;
			GeeList* _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
#line 377 "../src/engine/api/geary-account-information.vala"
			_tmp16_ = existing;
#line 377 "../src/engine/api/geary-account-information.vala"
			_tmp17_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_COLLECTION, GeeCollection));
#line 377 "../src/engine/api/geary-account-information.vala"
			_tmp18_ = _tmp17_;
#line 377 "../src/engine/api/geary-account-information.vala"
			_tmp19_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (new_path, GEE_TYPE_COLLECTION, GeeCollection));
#line 377 "../src/engine/api/geary-account-information.vala"
			_tmp20_ = _tmp19_;
#line 377 "../src/engine/api/geary-account-information.vala"
			if (_tmp18_ != _tmp20_) {
#line 377 "../src/engine/api/geary-account-information.vala"
				_tmp15_ = TRUE;
#line 2338 "geary-account-information.c"
			} else {
				GeeList* _tmp21_;
#line 378 "../src/engine/api/geary-account-information.vala"
				_tmp21_ = existing;
#line 378 "../src/engine/api/geary-account-information.vala"
				_tmp15_ = gee_collection_contains_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (new_path, GEE_TYPE_COLLECTION, GeeCollection));
#line 2345 "geary-account-information.c"
			}
#line 377 "../src/engine/api/geary-account-information.vala"
			_tmp13_ = _tmp15_;
#line 2349 "geary-account-information.c"
		} else {
#line 376 "../src/engine/api/geary-account-information.vala"
			_tmp13_ = FALSE;
#line 2353 "geary-account-information.c"
		}
#line 376 "../src/engine/api/geary-account-information.vala"
		_tmp7_ = _tmp13_;
#line 2357 "geary-account-information.c"
	}
#line 374 "../src/engine/api/geary-account-information.vala"
	if (_tmp7_) {
#line 379 "../src/engine/api/geary-account-information.vala"
		g_signal_emit (self, geary_account_information_signals[GEARY_ACCOUNT_INFORMATION_CHANGED_SIGNAL], 0);
#line 2363 "geary-account-information.c"
	}
#line 366 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (existing);
#line 2367 "geary-account-information.c"
}

/**
     * Returns a folder path based on the configured steps for a use.
     */
GearyFolderPath*
geary_account_information_new_folder_path_for_use (GearyAccountInformation* self,
                                                   GearyFolderRoot* root,
                                                   GearyFolderSpecialUse use)
{
	GearyFolderPath* path = NULL;
	GeeList* steps = NULL;
	GeeMap* _tmp0_;
	gpointer _tmp1_;
	GeeList* _tmp2_;
	GearyFolderPath* result;
#line 386 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), NULL);
#line 386 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_FOLDER_ROOT (root), NULL);
#line 388 "../src/engine/api/geary-account-information.vala"
	path = NULL;
#line 389 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = self->priv->special_use_paths;
#line 389 "../src/engine/api/geary-account-information.vala"
	_tmp1_ = gee_map_get (_tmp0_, (gpointer) ((gintptr) (&use)));
#line 389 "../src/engine/api/geary-account-information.vala"
	steps = (GeeList*) _tmp1_;
#line 390 "../src/engine/api/geary-account-information.vala"
	_tmp2_ = steps;
#line 390 "../src/engine/api/geary-account-information.vala"
	if (_tmp2_ != NULL) {
#line 2400 "geary-account-information.c"
		GearyFolderPath* _tmp3_;
#line 391 "../src/engine/api/geary-account-information.vala"
		_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (root, GEARY_TYPE_FOLDER_PATH, GearyFolderPath));
#line 391 "../src/engine/api/geary-account-information.vala"
		_g_object_unref0 (path);
#line 391 "../src/engine/api/geary-account-information.vala"
		path = _tmp3_;
#line 2408 "geary-account-information.c"
		{
			GeeList* _step_list = NULL;
			GeeList* _tmp4_;
			gint _step_size = 0;
			GeeList* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gint _step_index = 0;
#line 392 "../src/engine/api/geary-account-information.vala"
			_tmp4_ = steps;
#line 392 "../src/engine/api/geary-account-information.vala"
			_step_list = _tmp4_;
#line 392 "../src/engine/api/geary-account-information.vala"
			_tmp5_ = _step_list;
#line 392 "../src/engine/api/geary-account-information.vala"
			_tmp6_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_COLLECTION, GeeCollection));
#line 392 "../src/engine/api/geary-account-information.vala"
			_tmp7_ = _tmp6_;
#line 392 "../src/engine/api/geary-account-information.vala"
			_step_size = _tmp7_;
#line 392 "../src/engine/api/geary-account-information.vala"
			_step_index = -1;
#line 392 "../src/engine/api/geary-account-information.vala"
			while (TRUE) {
#line 2433 "geary-account-information.c"
				gint _tmp8_;
				gint _tmp9_;
				gchar* step = NULL;
				GeeList* _tmp10_;
				gpointer _tmp11_;
				GearyFolderPath* _tmp12_;
				const gchar* _tmp13_;
				GearyFolderPath* _tmp14_;
#line 392 "../src/engine/api/geary-account-information.vala"
				_step_index = _step_index + 1;
#line 392 "../src/engine/api/geary-account-information.vala"
				_tmp8_ = _step_index;
#line 392 "../src/engine/api/geary-account-information.vala"
				_tmp9_ = _step_size;
#line 392 "../src/engine/api/geary-account-information.vala"
				if (!(_tmp8_ < _tmp9_)) {
#line 392 "../src/engine/api/geary-account-information.vala"
					break;
#line 2452 "geary-account-information.c"
				}
#line 392 "../src/engine/api/geary-account-information.vala"
				_tmp10_ = _step_list;
#line 392 "../src/engine/api/geary-account-information.vala"
				_tmp11_ = gee_list_get (_tmp10_, _step_index);
#line 392 "../src/engine/api/geary-account-information.vala"
				step = (gchar*) _tmp11_;
#line 393 "../src/engine/api/geary-account-information.vala"
				_tmp12_ = path;
#line 393 "../src/engine/api/geary-account-information.vala"
				_tmp13_ = step;
#line 393 "../src/engine/api/geary-account-information.vala"
				_tmp14_ = geary_folder_path_get_child (_tmp12_, _tmp13_, GEARY_TRILLIAN_UNKNOWN);
#line 393 "../src/engine/api/geary-account-information.vala"
				_g_object_unref0 (path);
#line 393 "../src/engine/api/geary-account-information.vala"
				path = _tmp14_;
#line 392 "../src/engine/api/geary-account-information.vala"
				_g_free0 (step);
#line 2472 "geary-account-information.c"
			}
		}
	}
#line 396 "../src/engine/api/geary-account-information.vala"
	result = path;
#line 396 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (steps);
#line 396 "../src/engine/api/geary-account-information.vala"
	return result;
#line 2482 "geary-account-information.c"
}

/**
     * Returns the configured special folder use for a given path.
     */
GearyFolderSpecialUse
geary_account_information_get_folder_use_for_path (GearyAccountInformation* self,
                                                   GearyFolderPath* path)
{
	gchar** path_steps = NULL;
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	gint path_steps_length1;
	gint _path_steps_size_;
	GearyFolderSpecialUse use = 0;
	GearyFolderSpecialUse result;
#line 402 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), 0);
#line 402 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_FOLDER_PATH (path), 0);
#line 403 "../src/engine/api/geary-account-information.vala"
	_tmp1_ = geary_folder_path_as_array (path, &_tmp0_);
#line 403 "../src/engine/api/geary-account-information.vala"
	path_steps = _tmp1_;
#line 403 "../src/engine/api/geary-account-information.vala"
	path_steps_length1 = _tmp0_;
#line 403 "../src/engine/api/geary-account-information.vala"
	_path_steps_size_ = path_steps_length1;
#line 404 "../src/engine/api/geary-account-information.vala"
	use = GEARY_FOLDER_SPECIAL_USE_NONE;
#line 2513 "geary-account-information.c"
	{
		GeeIterator* _entry_it = NULL;
		GeeMap* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
		GeeIterator* _tmp6_;
		GeeIterator* _tmp7_;
#line 405 "../src/engine/api/geary-account-information.vala"
		_tmp2_ = self->priv->special_use_paths;
#line 405 "../src/engine/api/geary-account-information.vala"
		_tmp3_ = gee_map_get_entries (_tmp2_);
#line 405 "../src/engine/api/geary-account-information.vala"
		_tmp4_ = _tmp3_;
#line 405 "../src/engine/api/geary-account-information.vala"
		_tmp5_ = _tmp4_;
#line 405 "../src/engine/api/geary-account-information.vala"
		_tmp6_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ITERABLE, GeeIterable));
#line 405 "../src/engine/api/geary-account-information.vala"
		_tmp7_ = _tmp6_;
#line 405 "../src/engine/api/geary-account-information.vala"
		_g_object_unref0 (_tmp5_);
#line 405 "../src/engine/api/geary-account-information.vala"
		_entry_it = _tmp7_;
#line 405 "../src/engine/api/geary-account-information.vala"
		while (TRUE) {
#line 2540 "geary-account-information.c"
			GeeIterator* _tmp8_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp9_;
			gpointer _tmp10_;
			GeeList* use_steps = NULL;
			GeeMapEntry* _tmp11_;
			gconstpointer _tmp12_;
			gconstpointer _tmp13_;
			GeeList* _tmp14_;
			gboolean found = FALSE;
			gchar** _tmp15_;
			gint _tmp15__length1;
			GeeList* _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
#line 405 "../src/engine/api/geary-account-information.vala"
			_tmp8_ = _entry_it;
#line 405 "../src/engine/api/geary-account-information.vala"
			if (!gee_iterator_next (_tmp8_)) {
#line 405 "../src/engine/api/geary-account-information.vala"
				break;
#line 2562 "geary-account-information.c"
			}
#line 405 "../src/engine/api/geary-account-information.vala"
			_tmp9_ = _entry_it;
#line 405 "../src/engine/api/geary-account-information.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 405 "../src/engine/api/geary-account-information.vala"
			entry = (GeeMapEntry*) _tmp10_;
#line 406 "../src/engine/api/geary-account-information.vala"
			_tmp11_ = entry;
#line 406 "../src/engine/api/geary-account-information.vala"
			_tmp12_ = gee_map_entry_get_value (_tmp11_);
#line 406 "../src/engine/api/geary-account-information.vala"
			_tmp13_ = _tmp12_;
#line 406 "../src/engine/api/geary-account-information.vala"
			_tmp14_ = _g_object_ref0 ((GeeList*) _tmp13_);
#line 406 "../src/engine/api/geary-account-information.vala"
			use_steps = _tmp14_;
#line 407 "../src/engine/api/geary-account-information.vala"
			found = FALSE;
#line 408 "../src/engine/api/geary-account-information.vala"
			_tmp15_ = path_steps;
#line 408 "../src/engine/api/geary-account-information.vala"
			_tmp15__length1 = path_steps_length1;
#line 408 "../src/engine/api/geary-account-information.vala"
			_tmp16_ = use_steps;
#line 408 "../src/engine/api/geary-account-information.vala"
			_tmp17_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_COLLECTION, GeeCollection));
#line 408 "../src/engine/api/geary-account-information.vala"
			_tmp18_ = _tmp17_;
#line 408 "../src/engine/api/geary-account-information.vala"
			if (_tmp15__length1 == _tmp18_) {
#line 409 "../src/engine/api/geary-account-information.vala"
				found = TRUE;
#line 2596 "geary-account-information.c"
				{
					gint i = 0;
					gchar** _tmp19_;
					gint _tmp19__length1;
#line 410 "../src/engine/api/geary-account-information.vala"
					_tmp19_ = path_steps;
#line 410 "../src/engine/api/geary-account-information.vala"
					_tmp19__length1 = path_steps_length1;
#line 410 "../src/engine/api/geary-account-information.vala"
					i = _tmp19__length1 - 1;
#line 2607 "geary-account-information.c"
					{
						gboolean _tmp20_ = FALSE;
#line 410 "../src/engine/api/geary-account-information.vala"
						_tmp20_ = TRUE;
#line 410 "../src/engine/api/geary-account-information.vala"
						while (TRUE) {
#line 2614 "geary-account-information.c"
							gchar** _tmp22_;
							gint _tmp22__length1;
							const gchar* _tmp23_;
							GeeList* _tmp24_;
							gpointer _tmp25_;
							gchar* _tmp26_;
							gboolean _tmp27_;
#line 410 "../src/engine/api/geary-account-information.vala"
							if (!_tmp20_) {
#line 2624 "geary-account-information.c"
								gint _tmp21_;
#line 410 "../src/engine/api/geary-account-information.vala"
								_tmp21_ = i;
#line 410 "../src/engine/api/geary-account-information.vala"
								i = _tmp21_ - 1;
#line 2630 "geary-account-information.c"
							}
#line 410 "../src/engine/api/geary-account-information.vala"
							_tmp20_ = FALSE;
#line 410 "../src/engine/api/geary-account-information.vala"
							if (!(i >= 0)) {
#line 410 "../src/engine/api/geary-account-information.vala"
								break;
#line 2638 "geary-account-information.c"
							}
#line 411 "../src/engine/api/geary-account-information.vala"
							_tmp22_ = path_steps;
#line 411 "../src/engine/api/geary-account-information.vala"
							_tmp22__length1 = path_steps_length1;
#line 411 "../src/engine/api/geary-account-information.vala"
							_tmp23_ = _tmp22_[i];
#line 411 "../src/engine/api/geary-account-information.vala"
							_tmp24_ = use_steps;
#line 411 "../src/engine/api/geary-account-information.vala"
							_tmp25_ = gee_list_get (_tmp24_, i);
#line 411 "../src/engine/api/geary-account-information.vala"
							_tmp26_ = (gchar*) _tmp25_;
#line 411 "../src/engine/api/geary-account-information.vala"
							_tmp27_ = g_strcmp0 (_tmp23_, _tmp26_) != 0;
#line 411 "../src/engine/api/geary-account-information.vala"
							_g_free0 (_tmp26_);
#line 411 "../src/engine/api/geary-account-information.vala"
							if (_tmp27_) {
#line 412 "../src/engine/api/geary-account-information.vala"
								found = FALSE;
#line 413 "../src/engine/api/geary-account-information.vala"
								break;
#line 2662 "geary-account-information.c"
							}
						}
					}
				}
			}
#line 417 "../src/engine/api/geary-account-information.vala"
			if (found) {
#line 2670 "geary-account-information.c"
				GeeMapEntry* _tmp28_;
				gconstpointer _tmp29_;
				gconstpointer _tmp30_;
#line 418 "../src/engine/api/geary-account-information.vala"
				_tmp28_ = entry;
#line 418 "../src/engine/api/geary-account-information.vala"
				_tmp29_ = gee_map_entry_get_key (_tmp28_);
#line 418 "../src/engine/api/geary-account-information.vala"
				_tmp30_ = _tmp29_;
#line 418 "../src/engine/api/geary-account-information.vala"
				use = *((GearyFolderSpecialUse*) _tmp30_);
#line 419 "../src/engine/api/geary-account-information.vala"
				_g_object_unref0 (use_steps);
#line 419 "../src/engine/api/geary-account-information.vala"
				_g_object_unref0 (entry);
#line 419 "../src/engine/api/geary-account-information.vala"
				break;
#line 2688 "geary-account-information.c"
			}
#line 405 "../src/engine/api/geary-account-information.vala"
			_g_object_unref0 (use_steps);
#line 405 "../src/engine/api/geary-account-information.vala"
			_g_object_unref0 (entry);
#line 2694 "geary-account-information.c"
		}
#line 405 "../src/engine/api/geary-account-information.vala"
		_g_object_unref0 (_entry_it);
#line 2698 "geary-account-information.c"
	}
#line 422 "../src/engine/api/geary-account-information.vala"
	result = use;
#line 422 "../src/engine/api/geary-account-information.vala"
	path_steps = (_vala_array_free (path_steps, path_steps_length1, (GDestroyNotify) g_free), NULL);
#line 422 "../src/engine/api/geary-account-information.vala"
	return result;
#line 2706 "geary-account-information.c"
}

/**
     * Returns the best credentials to use for the outgoing service.
     *
     * This method checks for an outgoing service that use incoming
     * service's credentials for authentication and if enabled,
     * returns those. If this method returns null, then outgoing
     * authentication should not be attempted for this account.
     */
GearyCredentials*
geary_account_information_get_outgoing_credentials (GearyAccountInformation* self)
{
	GearyCredentials* outgoing = NULL;
	GearyServiceInformation* _tmp0_;
	GearyCredentialsRequirement _tmp1_;
	GearyCredentialsRequirement _tmp2_;
	GearyCredentials* result;
#line 433 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), NULL);
#line 434 "../src/engine/api/geary-account-information.vala"
	outgoing = NULL;
#line 435 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = self->priv->_outgoing;
#line 435 "../src/engine/api/geary-account-information.vala"
	_tmp1_ = geary_service_information_get_credentials_requirement (_tmp0_);
#line 435 "../src/engine/api/geary-account-information.vala"
	_tmp2_ = _tmp1_;
#line 435 "../src/engine/api/geary-account-information.vala"
	switch (_tmp2_) {
#line 435 "../src/engine/api/geary-account-information.vala"
		case GEARY_CREDENTIALS_REQUIREMENT_USE_INCOMING:
#line 2739 "geary-account-information.c"
		{
			GearyServiceInformation* _tmp3_;
			GearyCredentials* _tmp4_;
			GearyCredentials* _tmp5_;
			GearyCredentials* _tmp6_;
#line 437 "../src/engine/api/geary-account-information.vala"
			_tmp3_ = self->priv->_incoming;
#line 437 "../src/engine/api/geary-account-information.vala"
			_tmp4_ = geary_service_information_get_credentials (_tmp3_);
#line 437 "../src/engine/api/geary-account-information.vala"
			_tmp5_ = _tmp4_;
#line 437 "../src/engine/api/geary-account-information.vala"
			_tmp6_ = _g_object_ref0 (_tmp5_);
#line 437 "../src/engine/api/geary-account-information.vala"
			_g_object_unref0 (outgoing);
#line 437 "../src/engine/api/geary-account-information.vala"
			outgoing = _tmp6_;
#line 438 "../src/engine/api/geary-account-information.vala"
			break;
#line 2759 "geary-account-information.c"
		}
#line 435 "../src/engine/api/geary-account-information.vala"
		case GEARY_CREDENTIALS_REQUIREMENT_CUSTOM:
#line 2763 "geary-account-information.c"
		{
			GearyServiceInformation* _tmp7_;
			GearyCredentials* _tmp8_;
			GearyCredentials* _tmp9_;
			GearyCredentials* _tmp10_;
#line 440 "../src/engine/api/geary-account-information.vala"
			_tmp7_ = self->priv->_outgoing;
#line 440 "../src/engine/api/geary-account-information.vala"
			_tmp8_ = geary_service_information_get_credentials (_tmp7_);
#line 440 "../src/engine/api/geary-account-information.vala"
			_tmp9_ = _tmp8_;
#line 440 "../src/engine/api/geary-account-information.vala"
			_tmp10_ = _g_object_ref0 (_tmp9_);
#line 440 "../src/engine/api/geary-account-information.vala"
			_g_object_unref0 (outgoing);
#line 440 "../src/engine/api/geary-account-information.vala"
			outgoing = _tmp10_;
#line 441 "../src/engine/api/geary-account-information.vala"
			break;
#line 2783 "geary-account-information.c"
		}
#line 435 "../src/engine/api/geary-account-information.vala"
		case GEARY_CREDENTIALS_REQUIREMENT_NONE:
#line 2787 "geary-account-information.c"
		{
#line 444 "../src/engine/api/geary-account-information.vala"
			break;
#line 2791 "geary-account-information.c"
		}
		default:
#line 435 "../src/engine/api/geary-account-information.vala"
		break;
#line 2796 "geary-account-information.c"
	}
#line 446 "../src/engine/api/geary-account-information.vala"
	result = outgoing;
#line 446 "../src/engine/api/geary-account-information.vala"
	return result;
#line 2802 "geary-account-information.c"
}

static void
geary_account_information_load_outgoing_credentials_data_free (gpointer _data)
{
	GearyAccountInformationLoadOutgoingCredentialsData* _data_;
	_data_ = _data;
#line 9 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (_data_->self);
#line 9 "../src/engine/api/geary-account-information.vala"
	g_slice_free (GearyAccountInformationLoadOutgoingCredentialsData, _data_);
#line 2816 "geary-account-information.c"
}

void
geary_account_information_load_outgoing_credentials (GearyAccountInformation* self,
                                                     GCancellable* cancellable,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	GearyAccountInformationLoadOutgoingCredentialsData* _data_;
	GearyAccountInformation* _tmp0_;
	GCancellable* _tmp1_;
#line 9 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self));
#line 9 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 9 "../src/engine/api/geary-account-information.vala"
	_data_ = g_slice_new0 (GearyAccountInformationLoadOutgoingCredentialsData);
#line 9 "../src/engine/api/geary-account-information.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 9 "../src/engine/api/geary-account-information.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_account_information_load_outgoing_credentials_data_free);
#line 9 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 9 "../src/engine/api/geary-account-information.vala"
	_data_->self = _tmp0_;
#line 9 "../src/engine/api/geary-account-information.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 9 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/engine/api/geary-account-information.vala"
	_data_->cancellable = _tmp1_;
#line 9 "../src/engine/api/geary-account-information.vala"
	geary_account_information_load_outgoing_credentials_co (_data_);
#line 2850 "geary-account-information.c"
}

gboolean
geary_account_information_load_outgoing_credentials_finish (GearyAccountInformation* self,
                                                            GAsyncResult* _res_,
                                                            GError** error)
{
	gboolean result;
	GearyAccountInformationLoadOutgoingCredentialsData* _data_;
#line 9 "../src/engine/api/geary-account-information.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 9 "../src/engine/api/geary-account-information.vala"
	if (NULL == _data_) {
#line 2864 "geary-account-information.c"
		gboolean _tmp0_ = FALSE;
#line 9 "../src/engine/api/geary-account-information.vala"
		return _tmp0_;
#line 2868 "geary-account-information.c"
	}
#line 9 "../src/engine/api/geary-account-information.vala"
	result = _data_->result;
#line 9 "../src/engine/api/geary-account-information.vala"
	return result;
#line 2874 "geary-account-information.c"
}

/**
     * Loads the authentication token for the outgoing service.
     *
     * Credentials are loaded from the mediator, thus it may yield for
     * some time.
     *
     * Returns true if the credential's token was successfully loaded
     * or are not needed (that is, if the credentials are null), or
     * false if the token could not be loaded and the service's
     * credentials are invalid.
     */
static void
geary_account_information_load_outgoing_credentials_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_)
{
	GearyAccountInformationLoadOutgoingCredentialsData* _data_;
#line 466 "../src/engine/api/geary-account-information.vala"
	_data_ = _user_data_;
#line 466 "../src/engine/api/geary-account-information.vala"
	_data_->_source_object_ = source_object;
#line 466 "../src/engine/api/geary-account-information.vala"
	_data_->_res_ = _res_;
#line 466 "../src/engine/api/geary-account-information.vala"
	geary_account_information_load_outgoing_credentials_co (_data_);
#line 2902 "geary-account-information.c"
}

static gboolean
geary_account_information_load_outgoing_credentials_co (GearyAccountInformationLoadOutgoingCredentialsData* _data_)
{
#line 460 "../src/engine/api/geary-account-information.vala"
	switch (_data_->_state_) {
#line 460 "../src/engine/api/geary-account-information.vala"
		case 0:
#line 2912 "geary-account-information.c"
		goto _state_0;
#line 460 "../src/engine/api/geary-account-information.vala"
		case 1:
#line 2916 "geary-account-information.c"
		goto _state_1;
#line 460 "../src/engine/api/geary-account-information.vala"
		case 2:
#line 2920 "geary-account-information.c"
		goto _state_2;
		default:
#line 460 "../src/engine/api/geary-account-information.vala"
		g_assert_not_reached ();
#line 2925 "geary-account-information.c"
	}
	_state_0:
#line 462 "../src/engine/api/geary-account-information.vala"
	_data_->_tmp0_ = geary_account_information_get_outgoing_credentials (_data_->self);
#line 462 "../src/engine/api/geary-account-information.vala"
	_data_->creds = _data_->_tmp0_;
#line 463 "../src/engine/api/geary-account-information.vala"
	_data_->loaded = TRUE;
#line 464 "../src/engine/api/geary-account-information.vala"
	_data_->_tmp1_ = _data_->creds;
#line 464 "../src/engine/api/geary-account-information.vala"
	if (_data_->_tmp1_ != NULL) {
#line 465 "../src/engine/api/geary-account-information.vala"
		_data_->_tmp2_ = _data_->self->priv->_outgoing;
#line 465 "../src/engine/api/geary-account-information.vala"
		_data_->_tmp3_ = geary_service_information_get_credentials_requirement (_data_->_tmp2_);
#line 465 "../src/engine/api/geary-account-information.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 465 "../src/engine/api/geary-account-information.vala"
		if (_data_->_tmp4_ == GEARY_CREDENTIALS_REQUIREMENT_USE_INCOMING) {
#line 466 "../src/engine/api/geary-account-information.vala"
			_data_->_tmp6_ = _data_->self->priv->_mediator;
#line 466 "../src/engine/api/geary-account-information.vala"
			_data_->_tmp7_ = _data_->self->priv->_incoming;
#line 466 "../src/engine/api/geary-account-information.vala"
			_data_->_state_ = 1;
#line 466 "../src/engine/api/geary-account-information.vala"
			geary_credentials_mediator_load_token (_data_->_tmp6_, _data_->self, _data_->_tmp7_, _data_->cancellable, geary_account_information_load_outgoing_credentials_ready, _data_);
#line 466 "../src/engine/api/geary-account-information.vala"
			return FALSE;
#line 2956 "geary-account-information.c"
			_state_1:
#line 466 "../src/engine/api/geary-account-information.vala"
			_data_->_tmp5_ = geary_credentials_mediator_load_token_finish (_data_->_tmp6_, _data_->_res_, &_data_->_inner_error0_);
#line 466 "../src/engine/api/geary-account-information.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 466 "../src/engine/api/geary-account-information.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 466 "../src/engine/api/geary-account-information.vala"
				_g_object_unref0 (_data_->creds);
#line 466 "../src/engine/api/geary-account-information.vala"
				g_object_unref (_data_->_async_result);
#line 466 "../src/engine/api/geary-account-information.vala"
				return FALSE;
#line 2970 "geary-account-information.c"
			}
#line 466 "../src/engine/api/geary-account-information.vala"
			_data_->loaded = _data_->_tmp5_;
#line 2974 "geary-account-information.c"
		} else {
#line 470 "../src/engine/api/geary-account-information.vala"
			_data_->_tmp9_ = _data_->self->priv->_mediator;
#line 470 "../src/engine/api/geary-account-information.vala"
			_data_->_tmp10_ = _data_->self->priv->_outgoing;
#line 470 "../src/engine/api/geary-account-information.vala"
			_data_->_state_ = 2;
#line 470 "../src/engine/api/geary-account-information.vala"
			geary_credentials_mediator_load_token (_data_->_tmp9_, _data_->self, _data_->_tmp10_, _data_->cancellable, geary_account_information_load_outgoing_credentials_ready, _data_);
#line 470 "../src/engine/api/geary-account-information.vala"
			return FALSE;
#line 2986 "geary-account-information.c"
			_state_2:
#line 470 "../src/engine/api/geary-account-information.vala"
			_data_->_tmp8_ = geary_credentials_mediator_load_token_finish (_data_->_tmp9_, _data_->_res_, &_data_->_inner_error0_);
#line 470 "../src/engine/api/geary-account-information.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 470 "../src/engine/api/geary-account-information.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 470 "../src/engine/api/geary-account-information.vala"
				_g_object_unref0 (_data_->creds);
#line 470 "../src/engine/api/geary-account-information.vala"
				g_object_unref (_data_->_async_result);
#line 470 "../src/engine/api/geary-account-information.vala"
				return FALSE;
#line 3000 "geary-account-information.c"
			}
#line 470 "../src/engine/api/geary-account-information.vala"
			_data_->loaded = _data_->_tmp8_;
#line 3004 "geary-account-information.c"
		}
	}
#line 475 "../src/engine/api/geary-account-information.vala"
	_data_->result = _data_->loaded;
#line 475 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (_data_->creds);
#line 475 "../src/engine/api/geary-account-information.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 475 "../src/engine/api/geary-account-information.vala"
	if (_data_->_state_ != 0) {
#line 475 "../src/engine/api/geary-account-information.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 475 "../src/engine/api/geary-account-information.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3019 "geary-account-information.c"
		}
	}
#line 475 "../src/engine/api/geary-account-information.vala"
	g_object_unref (_data_->_async_result);
#line 475 "../src/engine/api/geary-account-information.vala"
	return FALSE;
#line 3026 "geary-account-information.c"
}

static void
geary_account_information_load_incoming_credentials_data_free (gpointer _data)
{
	GearyAccountInformationLoadIncomingCredentialsData* _data_;
	_data_ = _data;
#line 9 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (_data_->self);
#line 9 "../src/engine/api/geary-account-information.vala"
	g_slice_free (GearyAccountInformationLoadIncomingCredentialsData, _data_);
#line 3040 "geary-account-information.c"
}

void
geary_account_information_load_incoming_credentials (GearyAccountInformation* self,
                                                     GCancellable* cancellable,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	GearyAccountInformationLoadIncomingCredentialsData* _data_;
	GearyAccountInformation* _tmp0_;
	GCancellable* _tmp1_;
#line 9 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self));
#line 9 "../src/engine/api/geary-account-information.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 9 "../src/engine/api/geary-account-information.vala"
	_data_ = g_slice_new0 (GearyAccountInformationLoadIncomingCredentialsData);
#line 9 "../src/engine/api/geary-account-information.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 9 "../src/engine/api/geary-account-information.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_account_information_load_incoming_credentials_data_free);
#line 9 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 9 "../src/engine/api/geary-account-information.vala"
	_data_->self = _tmp0_;
#line 9 "../src/engine/api/geary-account-information.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 9 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/engine/api/geary-account-information.vala"
	_data_->cancellable = _tmp1_;
#line 9 "../src/engine/api/geary-account-information.vala"
	geary_account_information_load_incoming_credentials_co (_data_);
#line 3074 "geary-account-information.c"
}

gboolean
geary_account_information_load_incoming_credentials_finish (GearyAccountInformation* self,
                                                            GAsyncResult* _res_,
                                                            GError** error)
{
	gboolean result;
	GearyAccountInformationLoadIncomingCredentialsData* _data_;
#line 9 "../src/engine/api/geary-account-information.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 9 "../src/engine/api/geary-account-information.vala"
	if (NULL == _data_) {
#line 3088 "geary-account-information.c"
		gboolean _tmp0_ = FALSE;
#line 9 "../src/engine/api/geary-account-information.vala"
		return _tmp0_;
#line 3092 "geary-account-information.c"
	}
#line 9 "../src/engine/api/geary-account-information.vala"
	result = _data_->result;
#line 9 "../src/engine/api/geary-account-information.vala"
	return result;
#line 3098 "geary-account-information.c"
}

/**
     * Loads the authentication token for the incoming service.
     *
     * Credentials are loaded from the mediator, thus it may yield for
     * some time.
     *
     * Returns true if the credential's token was successfully loaded
     * or are not needed (that is, if the credentials are null), or
     * false if the token could not be loaded and the service's
     * credentials are invalid.
     */
static void
geary_account_information_load_incoming_credentials_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_)
{
	GearyAccountInformationLoadIncomingCredentialsData* _data_;
#line 494 "../src/engine/api/geary-account-information.vala"
	_data_ = _user_data_;
#line 494 "../src/engine/api/geary-account-information.vala"
	_data_->_source_object_ = source_object;
#line 494 "../src/engine/api/geary-account-information.vala"
	_data_->_res_ = _res_;
#line 494 "../src/engine/api/geary-account-information.vala"
	geary_account_information_load_incoming_credentials_co (_data_);
#line 3126 "geary-account-information.c"
}

static gboolean
geary_account_information_load_incoming_credentials_co (GearyAccountInformationLoadIncomingCredentialsData* _data_)
{
#line 489 "../src/engine/api/geary-account-information.vala"
	switch (_data_->_state_) {
#line 489 "../src/engine/api/geary-account-information.vala"
		case 0:
#line 3136 "geary-account-information.c"
		goto _state_0;
#line 489 "../src/engine/api/geary-account-information.vala"
		case 1:
#line 3140 "geary-account-information.c"
		goto _state_1;
		default:
#line 489 "../src/engine/api/geary-account-information.vala"
		g_assert_not_reached ();
#line 3145 "geary-account-information.c"
	}
	_state_0:
#line 491 "../src/engine/api/geary-account-information.vala"
	_data_->_tmp0_ = _data_->self->priv->_incoming;
#line 491 "../src/engine/api/geary-account-information.vala"
	_data_->_tmp1_ = geary_service_information_get_credentials (_data_->_tmp0_);
#line 491 "../src/engine/api/geary-account-information.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 491 "../src/engine/api/geary-account-information.vala"
	_data_->_tmp3_ = _g_object_ref0 (_data_->_tmp2_);
#line 491 "../src/engine/api/geary-account-information.vala"
	_data_->creds = _data_->_tmp3_;
#line 492 "../src/engine/api/geary-account-information.vala"
	_data_->loaded = TRUE;
#line 493 "../src/engine/api/geary-account-information.vala"
	_data_->_tmp4_ = _data_->creds;
#line 493 "../src/engine/api/geary-account-information.vala"
	if (_data_->_tmp4_ != NULL) {
#line 494 "../src/engine/api/geary-account-information.vala"
		_data_->_tmp6_ = _data_->self->priv->_mediator;
#line 494 "../src/engine/api/geary-account-information.vala"
		_data_->_tmp7_ = _data_->self->priv->_incoming;
#line 494 "../src/engine/api/geary-account-information.vala"
		_data_->_state_ = 1;
#line 494 "../src/engine/api/geary-account-information.vala"
		geary_credentials_mediator_load_token (_data_->_tmp6_, _data_->self, _data_->_tmp7_, _data_->cancellable, geary_account_information_load_incoming_credentials_ready, _data_);
#line 494 "../src/engine/api/geary-account-information.vala"
		return FALSE;
#line 3174 "geary-account-information.c"
		_state_1:
#line 494 "../src/engine/api/geary-account-information.vala"
		_data_->_tmp5_ = geary_credentials_mediator_load_token_finish (_data_->_tmp6_, _data_->_res_, &_data_->_inner_error0_);
#line 494 "../src/engine/api/geary-account-information.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 494 "../src/engine/api/geary-account-information.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 494 "../src/engine/api/geary-account-information.vala"
			_g_object_unref0 (_data_->creds);
#line 494 "../src/engine/api/geary-account-information.vala"
			g_object_unref (_data_->_async_result);
#line 494 "../src/engine/api/geary-account-information.vala"
			return FALSE;
#line 3188 "geary-account-information.c"
		}
#line 494 "../src/engine/api/geary-account-information.vala"
		_data_->loaded = _data_->_tmp5_;
#line 3192 "geary-account-information.c"
	}
#line 498 "../src/engine/api/geary-account-information.vala"
	_data_->result = _data_->loaded;
#line 498 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (_data_->creds);
#line 498 "../src/engine/api/geary-account-information.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 498 "../src/engine/api/geary-account-information.vala"
	if (_data_->_state_ != 0) {
#line 498 "../src/engine/api/geary-account-information.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 498 "../src/engine/api/geary-account-information.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3206 "geary-account-information.c"
		}
	}
#line 498 "../src/engine/api/geary-account-information.vala"
	g_object_unref (_data_->_async_result);
#line 498 "../src/engine/api/geary-account-information.vala"
	return FALSE;
#line 3213 "geary-account-information.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 501 "../src/engine/api/geary-account-information.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 501 "../src/engine/api/geary-account-information.vala"
	return _data3_;
#line 3223 "geary-account-information.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 501 "../src/engine/api/geary-account-information.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 3233 "geary-account-information.c"
		GearyAccountInformation* self;
#line 501 "../src/engine/api/geary-account-information.vala"
		self = _data3_->self;
#line 501 "../src/engine/api/geary-account-information.vala"
		_g_object_unref0 (_data3_->other);
#line 501 "../src/engine/api/geary-account-information.vala"
		_g_object_unref0 (self);
#line 501 "../src/engine/api/geary-account-information.vala"
		g_slice_free (Block3Data, _data3_);
#line 3243 "geary-account-information.c"
	}
}

static gboolean
____lambda147_ (Block3Data* _data3_,
                GearyRFC822MailboxAddress* addr)
{
	GearyAccountInformation* self;
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 514 "../src/engine/api/geary-account-information.vala"
	self = _data3_->self;
#line 514 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MAILBOX_ADDRESS (addr), FALSE);
#line 514 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = geary_account_information_get_sender_mailboxes (_data3_->other);
#line 514 "../src/engine/api/geary-account-information.vala"
	_tmp1_ = _tmp0_;
#line 514 "../src/engine/api/geary-account-information.vala"
	_tmp2_ = _tmp1_;
#line 514 "../src/engine/api/geary-account-information.vala"
	_tmp3_ = gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection), addr);
#line 514 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (_tmp2_);
#line 514 "../src/engine/api/geary-account-information.vala"
	result = _tmp3_;
#line 514 "../src/engine/api/geary-account-information.vala"
	return result;
#line 3275 "geary-account-information.c"
}

static gboolean
_____lambda147__gee_predicate (gconstpointer g,
                               gpointer self)
{
	gboolean result;
	result = ____lambda147_ (self, (GearyRFC822MailboxAddress*) g);
#line 513 "../src/engine/api/geary-account-information.vala"
	return result;
#line 3286 "geary-account-information.c"
}

gboolean
geary_account_information_equal_to (GearyAccountInformation* self,
                                    GearyAccountInformation* other)
{
	Block3Data* _data3_;
	GearyAccountInformation* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 501 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (self), FALSE);
#line 501 "../src/engine/api/geary-account-information.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (other), FALSE);
#line 501 "../src/engine/api/geary-account-information.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 501 "../src/engine/api/geary-account-information.vala"
	_data3_->_ref_count_ = 1;
#line 501 "../src/engine/api/geary-account-information.vala"
	_data3_->self = g_object_ref (self);
#line 501 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = _g_object_ref0 (other);
#line 501 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (_data3_->other);
#line 501 "../src/engine/api/geary-account-information.vala"
	_data3_->other = _tmp0_;
#line 502 "../src/engine/api/geary-account-information.vala"
	if (self == _data3_->other) {
#line 503 "../src/engine/api/geary-account-information.vala"
		_tmp1_ = TRUE;
#line 3317 "geary-account-information.c"
	} else {
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_ = FALSE;
		gboolean _tmp11_ = FALSE;
		gboolean _tmp12_ = FALSE;
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
		gboolean _tmp18_ = FALSE;
		gboolean _tmp19_ = FALSE;
		gboolean _tmp20_ = FALSE;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
#line 505 "../src/engine/api/geary-account-information.vala"
		_tmp21_ = self->priv->_id;
#line 505 "../src/engine/api/geary-account-information.vala"
		_tmp22_ = _data3_->other->priv->_id;
#line 505 "../src/engine/api/geary-account-information.vala"
		if (g_strcmp0 (_tmp21_, _tmp22_) == 0) {
#line 3346 "geary-account-information.c"
			gint _tmp23_;
			gint _tmp24_;
#line 506 "../src/engine/api/geary-account-information.vala"
			_tmp23_ = self->priv->_ordinal;
#line 506 "../src/engine/api/geary-account-information.vala"
			_tmp24_ = _data3_->other->priv->_ordinal;
#line 506 "../src/engine/api/geary-account-information.vala"
			_tmp20_ = _tmp23_ == _tmp24_;
#line 3355 "geary-account-information.c"
		} else {
#line 505 "../src/engine/api/geary-account-information.vala"
			_tmp20_ = FALSE;
#line 3359 "geary-account-information.c"
		}
#line 505 "../src/engine/api/geary-account-information.vala"
		if (_tmp20_) {
#line 3363 "geary-account-information.c"
			GearyCredentialsMediator* _tmp25_;
			GearyCredentialsMediator* _tmp26_;
#line 507 "../src/engine/api/geary-account-information.vala"
			_tmp25_ = self->priv->_mediator;
#line 507 "../src/engine/api/geary-account-information.vala"
			_tmp26_ = _data3_->other->priv->_mediator;
#line 507 "../src/engine/api/geary-account-information.vala"
			_tmp19_ = _tmp25_ == _tmp26_;
#line 3372 "geary-account-information.c"
		} else {
#line 505 "../src/engine/api/geary-account-information.vala"
			_tmp19_ = FALSE;
#line 3376 "geary-account-information.c"
		}
#line 505 "../src/engine/api/geary-account-information.vala"
		if (_tmp19_) {
#line 3380 "geary-account-information.c"
			GearyServiceProvider _tmp27_;
			GearyServiceProvider _tmp28_;
#line 508 "../src/engine/api/geary-account-information.vala"
			_tmp27_ = self->priv->_service_provider;
#line 508 "../src/engine/api/geary-account-information.vala"
			_tmp28_ = _data3_->other->priv->_service_provider;
#line 508 "../src/engine/api/geary-account-information.vala"
			_tmp18_ = _tmp27_ == _tmp28_;
#line 3389 "geary-account-information.c"
		} else {
#line 505 "../src/engine/api/geary-account-information.vala"
			_tmp18_ = FALSE;
#line 3393 "geary-account-information.c"
		}
#line 505 "../src/engine/api/geary-account-information.vala"
		if (_tmp18_) {
#line 3397 "geary-account-information.c"
			gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
#line 509 "../src/engine/api/geary-account-information.vala"
			_tmp29_ = geary_account_information_get_service_label (self);
#line 509 "../src/engine/api/geary-account-information.vala"
			_tmp30_ = _tmp29_;
#line 509 "../src/engine/api/geary-account-information.vala"
			_tmp31_ = _tmp30_;
#line 509 "../src/engine/api/geary-account-information.vala"
			_tmp32_ = geary_account_information_get_service_label (_data3_->other);
#line 509 "../src/engine/api/geary-account-information.vala"
			_tmp33_ = _tmp32_;
#line 509 "../src/engine/api/geary-account-information.vala"
			_tmp34_ = _tmp33_;
#line 509 "../src/engine/api/geary-account-information.vala"
			_tmp17_ = g_strcmp0 (_tmp31_, _tmp34_) == 0;
#line 509 "../src/engine/api/geary-account-information.vala"
			_g_free0 (_tmp34_);
#line 509 "../src/engine/api/geary-account-information.vala"
			_g_free0 (_tmp31_);
#line 3422 "geary-account-information.c"
		} else {
#line 505 "../src/engine/api/geary-account-information.vala"
			_tmp17_ = FALSE;
#line 3426 "geary-account-information.c"
		}
#line 505 "../src/engine/api/geary-account-information.vala"
		if (_tmp17_) {
#line 3430 "geary-account-information.c"
			const gchar* _tmp35_;
			const gchar* _tmp36_;
#line 510 "../src/engine/api/geary-account-information.vala"
			_tmp35_ = self->priv->_label;
#line 510 "../src/engine/api/geary-account-information.vala"
			_tmp36_ = _data3_->other->priv->_label;
#line 510 "../src/engine/api/geary-account-information.vala"
			_tmp16_ = g_strcmp0 (_tmp35_, _tmp36_) == 0;
#line 3439 "geary-account-information.c"
		} else {
#line 505 "../src/engine/api/geary-account-information.vala"
			_tmp16_ = FALSE;
#line 3443 "geary-account-information.c"
		}
#line 505 "../src/engine/api/geary-account-information.vala"
		if (_tmp16_) {
#line 3447 "geary-account-information.c"
			GearyRFC822MailboxAddress* _tmp37_;
			GearyRFC822MailboxAddress* _tmp38_;
			GearyRFC822MailboxAddress* _tmp39_;
			GearyRFC822MailboxAddress* _tmp40_;
			GearyRFC822MailboxAddress* _tmp41_;
			GearyRFC822MailboxAddress* _tmp42_;
#line 511 "../src/engine/api/geary-account-information.vala"
			_tmp37_ = geary_account_information_get_primary_mailbox (self);
#line 511 "../src/engine/api/geary-account-information.vala"
			_tmp38_ = _tmp37_;
#line 511 "../src/engine/api/geary-account-information.vala"
			_tmp39_ = _tmp38_;
#line 511 "../src/engine/api/geary-account-information.vala"
			_tmp40_ = geary_account_information_get_primary_mailbox (_data3_->other);
#line 511 "../src/engine/api/geary-account-information.vala"
			_tmp41_ = _tmp40_;
#line 511 "../src/engine/api/geary-account-information.vala"
			_tmp42_ = _tmp41_;
#line 511 "../src/engine/api/geary-account-information.vala"
			_tmp15_ = gee_hashable_equal_to (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, GEE_TYPE_HASHABLE, GeeHashable), _tmp42_);
#line 511 "../src/engine/api/geary-account-information.vala"
			_g_object_unref0 (_tmp42_);
#line 511 "../src/engine/api/geary-account-information.vala"
			_g_object_unref0 (_tmp39_);
#line 3472 "geary-account-information.c"
		} else {
#line 505 "../src/engine/api/geary-account-information.vala"
			_tmp15_ = FALSE;
#line 3476 "geary-account-information.c"
		}
#line 505 "../src/engine/api/geary-account-information.vala"
		if (_tmp15_) {
#line 3480 "geary-account-information.c"
			GeeList* _tmp43_;
			GeeList* _tmp44_;
			GeeList* _tmp45_;
			gint _tmp46_;
			gint _tmp47_;
			GeeList* _tmp48_;
			GeeList* _tmp49_;
			GeeList* _tmp50_;
			gint _tmp51_;
			gint _tmp52_;
#line 512 "../src/engine/api/geary-account-information.vala"
			_tmp43_ = geary_account_information_get_sender_mailboxes (self);
#line 512 "../src/engine/api/geary-account-information.vala"
			_tmp44_ = _tmp43_;
#line 512 "../src/engine/api/geary-account-information.vala"
			_tmp45_ = _tmp44_;
#line 512 "../src/engine/api/geary-account-information.vala"
			_tmp46_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, GEE_TYPE_COLLECTION, GeeCollection));
#line 512 "../src/engine/api/geary-account-information.vala"
			_tmp47_ = _tmp46_;
#line 512 "../src/engine/api/geary-account-information.vala"
			_tmp48_ = geary_account_information_get_sender_mailboxes (_data3_->other);
#line 512 "../src/engine/api/geary-account-information.vala"
			_tmp49_ = _tmp48_;
#line 512 "../src/engine/api/geary-account-information.vala"
			_tmp50_ = _tmp49_;
#line 512 "../src/engine/api/geary-account-information.vala"
			_tmp51_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, GEE_TYPE_COLLECTION, GeeCollection));
#line 512 "../src/engine/api/geary-account-information.vala"
			_tmp52_ = _tmp51_;
#line 512 "../src/engine/api/geary-account-information.vala"
			_tmp14_ = _tmp47_ == _tmp52_;
#line 512 "../src/engine/api/geary-account-information.vala"
			_g_object_unref0 (_tmp50_);
#line 512 "../src/engine/api/geary-account-information.vala"
			_g_object_unref0 (_tmp45_);
#line 3517 "geary-account-information.c"
		} else {
#line 505 "../src/engine/api/geary-account-information.vala"
			_tmp14_ = FALSE;
#line 3521 "geary-account-information.c"
		}
#line 505 "../src/engine/api/geary-account-information.vala"
		if (_tmp14_) {
#line 3525 "geary-account-information.c"
			GeeList* _tmp53_;
			GeeList* _tmp54_;
			GeeList* _tmp55_;
			GearyIterable* _tmp56_;
			GearyIterable* _tmp57_;
#line 513 "../src/engine/api/geary-account-information.vala"
			_tmp53_ = geary_account_information_get_sender_mailboxes (self);
#line 513 "../src/engine/api/geary-account-information.vala"
			_tmp54_ = _tmp53_;
#line 513 "../src/engine/api/geary-account-information.vala"
			_tmp55_ = _tmp54_;
#line 513 "../src/engine/api/geary-account-information.vala"
			_tmp56_ = geary_traverse (GEARY_RF_C822_TYPE_MAILBOX_ADDRESS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_CHECK_INSTANCE_CAST (_tmp55_, GEE_TYPE_ITERABLE, GeeIterable));
#line 513 "../src/engine/api/geary-account-information.vala"
			_tmp57_ = _tmp56_;
#line 513 "../src/engine/api/geary-account-information.vala"
			_tmp13_ = geary_iterable_all (_tmp57_, _____lambda147__gee_predicate, block3_data_ref (_data3_), block3_data_unref);
#line 513 "../src/engine/api/geary-account-information.vala"
			_g_object_unref0 (_tmp57_);
#line 513 "../src/engine/api/geary-account-information.vala"
			_g_object_unref0 (_tmp55_);
#line 3547 "geary-account-information.c"
		} else {
#line 505 "../src/engine/api/geary-account-information.vala"
			_tmp13_ = FALSE;
#line 3551 "geary-account-information.c"
		}
#line 505 "../src/engine/api/geary-account-information.vala"
		if (_tmp13_) {
#line 3555 "geary-account-information.c"
			gint _tmp58_;
			gint _tmp59_;
#line 516 "../src/engine/api/geary-account-information.vala"
			_tmp58_ = self->priv->_prefetch_period_days;
#line 516 "../src/engine/api/geary-account-information.vala"
			_tmp59_ = _data3_->other->priv->_prefetch_period_days;
#line 516 "../src/engine/api/geary-account-information.vala"
			_tmp12_ = _tmp58_ == _tmp59_;
#line 3564 "geary-account-information.c"
		} else {
#line 505 "../src/engine/api/geary-account-information.vala"
			_tmp12_ = FALSE;
#line 3568 "geary-account-information.c"
		}
#line 505 "../src/engine/api/geary-account-information.vala"
		if (_tmp12_) {
#line 3572 "geary-account-information.c"
			gboolean _tmp60_;
			gboolean _tmp61_;
			gboolean _tmp62_;
			gboolean _tmp63_;
#line 517 "../src/engine/api/geary-account-information.vala"
			_tmp60_ = geary_account_information_get_save_sent (self);
#line 517 "../src/engine/api/geary-account-information.vala"
			_tmp61_ = _tmp60_;
#line 517 "../src/engine/api/geary-account-information.vala"
			_tmp62_ = geary_account_information_get_save_sent (_data3_->other);
#line 517 "../src/engine/api/geary-account-information.vala"
			_tmp63_ = _tmp62_;
#line 517 "../src/engine/api/geary-account-information.vala"
			_tmp11_ = _tmp61_ == _tmp63_;
#line 3587 "geary-account-information.c"
		} else {
#line 505 "../src/engine/api/geary-account-information.vala"
			_tmp11_ = FALSE;
#line 3591 "geary-account-information.c"
		}
#line 505 "../src/engine/api/geary-account-information.vala"
		if (_tmp11_) {
#line 3595 "geary-account-information.c"
			gboolean _tmp64_;
			gboolean _tmp65_;
#line 518 "../src/engine/api/geary-account-information.vala"
			_tmp64_ = self->priv->_save_drafts;
#line 518 "../src/engine/api/geary-account-information.vala"
			_tmp65_ = _data3_->other->priv->_save_drafts;
#line 518 "../src/engine/api/geary-account-information.vala"
			_tmp10_ = _tmp64_ == _tmp65_;
#line 3604 "geary-account-information.c"
		} else {
#line 505 "../src/engine/api/geary-account-information.vala"
			_tmp10_ = FALSE;
#line 3608 "geary-account-information.c"
		}
#line 505 "../src/engine/api/geary-account-information.vala"
		if (_tmp10_) {
#line 3612 "geary-account-information.c"
			gboolean _tmp66_;
			gboolean _tmp67_;
#line 519 "../src/engine/api/geary-account-information.vala"
			_tmp66_ = self->priv->_use_signature;
#line 519 "../src/engine/api/geary-account-information.vala"
			_tmp67_ = _data3_->other->priv->_use_signature;
#line 519 "../src/engine/api/geary-account-information.vala"
			_tmp9_ = _tmp66_ == _tmp67_;
#line 3621 "geary-account-information.c"
		} else {
#line 505 "../src/engine/api/geary-account-information.vala"
			_tmp9_ = FALSE;
#line 3625 "geary-account-information.c"
		}
#line 505 "../src/engine/api/geary-account-information.vala"
		if (_tmp9_) {
#line 3629 "geary-account-information.c"
			const gchar* _tmp68_;
			const gchar* _tmp69_;
#line 520 "../src/engine/api/geary-account-information.vala"
			_tmp68_ = self->priv->_signature;
#line 520 "../src/engine/api/geary-account-information.vala"
			_tmp69_ = _data3_->other->priv->_signature;
#line 520 "../src/engine/api/geary-account-information.vala"
			_tmp8_ = g_strcmp0 (_tmp68_, _tmp69_) == 0;
#line 3638 "geary-account-information.c"
		} else {
#line 505 "../src/engine/api/geary-account-information.vala"
			_tmp8_ = FALSE;
#line 3642 "geary-account-information.c"
		}
#line 505 "../src/engine/api/geary-account-information.vala"
		if (_tmp8_) {
#line 3646 "geary-account-information.c"
			GearyServiceInformation* _tmp70_;
			GearyServiceInformation* _tmp71_;
#line 521 "../src/engine/api/geary-account-information.vala"
			_tmp70_ = self->priv->_incoming;
#line 521 "../src/engine/api/geary-account-information.vala"
			_tmp71_ = _data3_->other->priv->_incoming;
#line 521 "../src/engine/api/geary-account-information.vala"
			_tmp7_ = geary_service_information_equal_to (_tmp70_, _tmp71_);
#line 3655 "geary-account-information.c"
		} else {
#line 505 "../src/engine/api/geary-account-information.vala"
			_tmp7_ = FALSE;
#line 3659 "geary-account-information.c"
		}
#line 505 "../src/engine/api/geary-account-information.vala"
		if (_tmp7_) {
#line 3663 "geary-account-information.c"
			GearyServiceInformation* _tmp72_;
			GearyServiceInformation* _tmp73_;
#line 522 "../src/engine/api/geary-account-information.vala"
			_tmp72_ = self->priv->_outgoing;
#line 522 "../src/engine/api/geary-account-information.vala"
			_tmp73_ = _data3_->other->priv->_outgoing;
#line 522 "../src/engine/api/geary-account-information.vala"
			_tmp6_ = geary_service_information_equal_to (_tmp72_, _tmp73_);
#line 3672 "geary-account-information.c"
		} else {
#line 505 "../src/engine/api/geary-account-information.vala"
			_tmp6_ = FALSE;
#line 3676 "geary-account-information.c"
		}
#line 505 "../src/engine/api/geary-account-information.vala"
		if (_tmp6_) {
#line 3680 "geary-account-information.c"
			GeeMap* _tmp74_;
			gint _tmp75_;
			gint _tmp76_;
			GeeMap* _tmp77_;
			gint _tmp78_;
			gint _tmp79_;
#line 523 "../src/engine/api/geary-account-information.vala"
			_tmp74_ = self->priv->special_use_paths;
#line 523 "../src/engine/api/geary-account-information.vala"
			_tmp75_ = gee_map_get_size (_tmp74_);
#line 523 "../src/engine/api/geary-account-information.vala"
			_tmp76_ = _tmp75_;
#line 523 "../src/engine/api/geary-account-information.vala"
			_tmp77_ = _data3_->other->priv->special_use_paths;
#line 523 "../src/engine/api/geary-account-information.vala"
			_tmp78_ = gee_map_get_size (_tmp77_);
#line 523 "../src/engine/api/geary-account-information.vala"
			_tmp79_ = _tmp78_;
#line 523 "../src/engine/api/geary-account-information.vala"
			_tmp5_ = _tmp76_ == _tmp79_;
#line 3701 "geary-account-information.c"
		} else {
#line 505 "../src/engine/api/geary-account-information.vala"
			_tmp5_ = FALSE;
#line 3705 "geary-account-information.c"
		}
#line 505 "../src/engine/api/geary-account-information.vala"
		if (_tmp5_) {
#line 3709 "geary-account-information.c"
			GeeMap* _tmp80_;
			GeeMap* _tmp81_;
#line 524 "../src/engine/api/geary-account-information.vala"
			_tmp80_ = self->priv->special_use_paths;
#line 524 "../src/engine/api/geary-account-information.vala"
			_tmp81_ = _data3_->other->priv->special_use_paths;
#line 524 "../src/engine/api/geary-account-information.vala"
			_tmp4_ = gee_map_has_all (_tmp80_, _tmp81_);
#line 3718 "geary-account-information.c"
		} else {
#line 505 "../src/engine/api/geary-account-information.vala"
			_tmp4_ = FALSE;
#line 3722 "geary-account-information.c"
		}
#line 505 "../src/engine/api/geary-account-information.vala"
		if (_tmp4_) {
#line 3726 "geary-account-information.c"
			GFile* _tmp82_;
			GFile* _tmp83_;
#line 525 "../src/engine/api/geary-account-information.vala"
			_tmp82_ = self->priv->_config_dir;
#line 525 "../src/engine/api/geary-account-information.vala"
			_tmp83_ = _data3_->other->priv->_config_dir;
#line 525 "../src/engine/api/geary-account-information.vala"
			_tmp3_ = _tmp82_ == _tmp83_;
#line 3735 "geary-account-information.c"
		} else {
#line 505 "../src/engine/api/geary-account-information.vala"
			_tmp3_ = FALSE;
#line 3739 "geary-account-information.c"
		}
#line 503 "../src/engine/api/geary-account-information.vala"
		if (_tmp3_) {
#line 3743 "geary-account-information.c"
			GFile* _tmp84_;
			GFile* _tmp85_;
#line 526 "../src/engine/api/geary-account-information.vala"
			_tmp84_ = self->priv->_data_dir;
#line 526 "../src/engine/api/geary-account-information.vala"
			_tmp85_ = _data3_->other->priv->_data_dir;
#line 526 "../src/engine/api/geary-account-information.vala"
			_tmp2_ = _tmp84_ == _tmp85_;
#line 3752 "geary-account-information.c"
		} else {
#line 505 "../src/engine/api/geary-account-information.vala"
			_tmp2_ = FALSE;
#line 3756 "geary-account-information.c"
		}
#line 503 "../src/engine/api/geary-account-information.vala"
		_tmp1_ = _tmp2_;
#line 3760 "geary-account-information.c"
	}
#line 502 "../src/engine/api/geary-account-information.vala"
	result = _tmp1_;
#line 502 "../src/engine/api/geary-account-information.vala"
	block3_data_unref (_data3_);
#line 502 "../src/engine/api/geary-account-information.vala"
	_data3_ = NULL;
#line 502 "../src/engine/api/geary-account-information.vala"
	return result;
#line 3770 "geary-account-information.c"
}

static void
geary_account_information_class_init (GearyAccountInformationClass * klass,
                                      gpointer klass_data)
{
	gint _tmp0_;
#line 9 "../src/engine/api/geary-account-information.vala"
	geary_account_information_parent_class = g_type_class_peek_parent (klass);
#line 9 "../src/engine/api/geary-account-information.vala"
	g_type_class_adjust_private_offset (klass, &GearyAccountInformation_private_offset);
#line 9 "../src/engine/api/geary-account-information.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_account_information_get_property;
#line 9 "../src/engine/api/geary-account-information.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_account_information_set_property;
#line 9 "../src/engine/api/geary-account-information.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_account_information_finalize;
#line 3788 "geary-account-information.c"
	/** A unique (engine-wide), opaque identifier for the account. */
#line 9 "../src/engine/api/geary-account-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_INFORMATION_ID_PROPERTY, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3792 "geary-account-information.c"
	/** A unique (engine-wide) ordering for the account. */
#line 9 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = geary_account_information_next_ordinal;
#line 9 "../src/engine/api/geary-account-information.vala"
	geary_account_information_next_ordinal = _tmp0_ + 1;
#line 9 "../src/engine/api/geary-account-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_INFORMATION_ORDINAL_PROPERTY, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_ORDINAL_PROPERTY] = g_param_spec_int ("ordinal", "ordinal", "ordinal", G_MININT, G_MAXINT, _tmp0_, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3800 "geary-account-information.c"
	/** Specifies the email provider for this account. */
#line 9 "../src/engine/api/geary-account-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_INFORMATION_SERVICE_PROVIDER_PROPERTY, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_SERVICE_PROVIDER_PROPERTY] = g_param_spec_enum ("service-provider", "service-provider", "service-provider", GEARY_TYPE_SERVICE_PROVIDER, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3804 "geary-account-information.c"
	/**
	     * A human-readable label describing the email service provider.
	     *
	     * Known providers such as Gmail will have a label specified by
	     * clients, but other accounts can only really be identified by
	     * their server names. This attempts to extract a 'nice' value for
	     * label based on the service's host names.
	     */
#line 9 "../src/engine/api/geary-account-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_INFORMATION_SERVICE_LABEL_PROPERTY, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_SERVICE_LABEL_PROPERTY] = g_param_spec_string ("service-label", "service-label", "service-label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3815 "geary-account-information.c"
	/**
	     * A unique human-readable display name for this account.
	     *
	     * Use this to display a string to the user that can uniquely
	     * identify this account. Note this value is mutable - it may
	     * change as a result of user action, so do not rely on it staying
	     * the same.
	     */
#line 9 "../src/engine/api/geary-account-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_INFORMATION_DISPLAY_NAME_PROPERTY, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_DISPLAY_NAME_PROPERTY] = g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3826 "geary-account-information.c"
	/**
	     * User-provided label for the account.
	     *
	     * This is not to be used in the UI (use `display_name` instead)
	     * and not transmitted on the wire or used in correspondence.
	     */
#line 9 "../src/engine/api/geary-account-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_INFORMATION_LABEL_PROPERTY, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3835 "geary-account-information.c"
	/**
	     * The default sender mailbox address for the account.
	     *
	     * This is the first mailbox in the {@link sender_mailboxes} list.
	     */
#line 9 "../src/engine/api/geary-account-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_INFORMATION_PRIMARY_MAILBOX_PROPERTY, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_PRIMARY_MAILBOX_PROPERTY] = g_param_spec_object ("primary-mailbox", "primary-mailbox", "primary-mailbox", GEARY_RF_C822_TYPE_MAILBOX_ADDRESS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3843 "geary-account-information.c"
	/**
	     * A read-only list of sender mailbox address for the account.
	     *
	     * The first address in the list is the default address, others
	     * are essentially aliases.
	     */
#line 9 "../src/engine/api/geary-account-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_INFORMATION_SENDER_MAILBOXES_PROPERTY, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_SENDER_MAILBOXES_PROPERTY] = g_param_spec_object ("sender-mailboxes", "sender-mailboxes", "sender-mailboxes", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3852 "geary-account-information.c"
	/** Determines if the account has more than one sender mailbox. */
#line 9 "../src/engine/api/geary-account-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_INFORMATION_HAS_SENDER_ALIASES_PROPERTY, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_HAS_SENDER_ALIASES_PROPERTY] = g_param_spec_boolean ("has-sender-aliases", "has-sender-aliases", "has-sender-aliases", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3856 "geary-account-information.c"
	/** Specifies the number of days to be fetched by the account sync. */
#line 9 "../src/engine/api/geary-account-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_INFORMATION_PREFETCH_PERIOD_DAYS_PROPERTY, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_PREFETCH_PERIOD_DAYS_PROPERTY] = g_param_spec_int ("prefetch-period-days", "prefetch-period-days", "prefetch-period-days", G_MININT, G_MAXINT, GEARY_ACCOUNT_INFORMATION_DEFAULT_PREFETCH_PERIOD_DAYS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3860 "geary-account-information.c"
	/** Specifies if sent email should be saved to the Sent folder. */
#line 9 "../src/engine/api/geary-account-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_INFORMATION_SAVE_SENT_PROPERTY, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_SAVE_SENT_PROPERTY] = g_param_spec_boolean ("save-sent", "save-sent", "save-sent", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3864 "geary-account-information.c"
	/** Determines if drafts should be saved on the server. */
#line 9 "../src/engine/api/geary-account-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_INFORMATION_SAVE_DRAFTS_PROPERTY, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_SAVE_DRAFTS_PROPERTY] = g_param_spec_boolean ("save-drafts", "save-drafts", "save-drafts", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3868 "geary-account-information.c"
	/**
	     * The source of authentication credentials for this account.
	     */
#line 9 "../src/engine/api/geary-account-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_INFORMATION_MEDIATOR_PROPERTY, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_MEDIATOR_PROPERTY] = g_param_spec_object ("mediator", "mediator", "mediator", GEARY_TYPE_CREDENTIALS_MEDIATOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 9 "../src/engine/api/geary-account-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_INFORMATION_INCOMING_PROPERTY, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_INCOMING_PROPERTY] = g_param_spec_object ("incoming", "incoming", "incoming", GEARY_TYPE_SERVICE_INFORMATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 9 "../src/engine/api/geary-account-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_INFORMATION_OUTGOING_PROPERTY, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_OUTGOING_PROPERTY] = g_param_spec_object ("outgoing", "outgoing", "outgoing", GEARY_TYPE_SERVICE_INFORMATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3878 "geary-account-information.c"
	/** A lock that can be used to ensure saving is serialised. */
#line 9 "../src/engine/api/geary-account-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_INFORMATION_WRITE_LOCK_PROPERTY, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_WRITE_LOCK_PROPERTY] = g_param_spec_object ("write-lock", "write-lock", "write-lock", GEARY_NONBLOCKING_TYPE_MUTEX, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3882 "geary-account-information.c"
	/** Specifies if an email sig should be appended to new messages. */
#line 9 "../src/engine/api/geary-account-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_INFORMATION_USE_SIGNATURE_PROPERTY, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_USE_SIGNATURE_PROPERTY] = g_param_spec_boolean ("use-signature", "use-signature", "use-signature", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3886 "geary-account-information.c"
	/** Specifies the email sig to be appended to new messages. */
#line 9 "../src/engine/api/geary-account-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_INFORMATION_SIGNATURE_PROPERTY, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_SIGNATURE_PROPERTY] = g_param_spec_string ("signature", "signature", "signature", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3890 "geary-account-information.c"
	/**
	     * Location of the account's config directory.
	     *
	     * This directory is used to store small, per-account
	     * configuration files, including the account's settings key file.
	     */
#line 9 "../src/engine/api/geary-account-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_INFORMATION_CONFIG_DIR_PROPERTY, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_CONFIG_DIR_PROPERTY] = g_param_spec_object ("config-dir", "config-dir", "config-dir", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3899 "geary-account-information.c"
	/**
	     * Location of the account's data directory.
	     *
	     * This directory is used to store large, per-account data files
	     * such as the account database.
	     */
#line 9 "../src/engine/api/geary-account-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ACCOUNT_INFORMATION_DATA_DIR_PROPERTY, geary_account_information_properties[GEARY_ACCOUNT_INFORMATION_DATA_DIR_PROPERTY] = g_param_spec_object ("data-dir", "data-dir", "data-dir", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3908 "geary-account-information.c"
	/**
	     * Emitted when a service has reported an authentication failure.
	     *
	     * No further connection attempts will be made after this signal
	     * has been fired until the associated {@link ClientService} has
	     * been restarted. It is up to the client to prompt the user for
	     * updated credentials and restart the service.
	     */
#line 9 "../src/engine/api/geary-account-information.vala"
	geary_account_information_signals[GEARY_ACCOUNT_INFORMATION_AUTHENTICATION_FAILURE_SIGNAL] = g_signal_new ("authentication-failure", GEARY_TYPE_ACCOUNT_INFORMATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_TYPE_SERVICE_INFORMATION);
#line 3919 "geary-account-information.c"
	/**
	     * Emitted when an endpoint has reported TLS certificate warnings.
	     *
	     * This signal is emitted when either of the incoming or outgoing
	     * endpoints emit the signal with the same name. It may be more
	     * convenient for clients to connect to this instead.
	     *
	     * No further connection attempts will be made after this signal
	     * has been fired until the associated {@link ClientService} has
	     * been restarted. It is up to the client to prompt the user to
	     * take action about the certificate (e.g. decide to pin it) then
	     * restart the service.
	     *
	     * @see Endpoint.untrusted_host
	     */
#line 9 "../src/engine/api/geary-account-information.vala"
	geary_account_information_signals[GEARY_ACCOUNT_INFORMATION_UNTRUSTED_HOST_SIGNAL] = g_signal_new ("untrusted-host", GEARY_TYPE_ACCOUNT_INFORMATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, GEARY_TYPE_SERVICE_INFORMATION, GEARY_TYPE_ENDPOINT, g_tls_connection_get_type ());
#line 3937 "geary-account-information.c"
	/** Emitted when the account settings have changed. */
#line 9 "../src/engine/api/geary-account-information.vala"
	geary_account_information_signals[GEARY_ACCOUNT_INFORMATION_CHANGED_SIGNAL] = g_signal_new ("changed", GEARY_TYPE_ACCOUNT_INFORMATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3941 "geary-account-information.c"
}

static void
geary_account_information_instance_init (GearyAccountInformation * self,
                                         gpointer klass)
{
	gint _tmp0_;
	gchar* _tmp1_;
	GearyNonblockingMutex* _tmp2_;
	gchar* _tmp3_;
	GeeHashMap* _tmp4_;
	GeeLinkedList* _tmp5_;
#line 9 "../src/engine/api/geary-account-information.vala"
	self->priv = geary_account_information_get_instance_private (self);
#line 33 "../src/engine/api/geary-account-information.vala"
	_tmp0_ = geary_account_information_next_ordinal;
#line 33 "../src/engine/api/geary-account-information.vala"
	geary_account_information_next_ordinal = _tmp0_ + 1;
#line 33 "../src/engine/api/geary-account-information.vala"
	self->priv->_ordinal = _tmp0_;
#line 71 "../src/engine/api/geary-account-information.vala"
	self->priv->_service_label = NULL;
#line 95 "../src/engine/api/geary-account-information.vala"
	_tmp1_ = g_strdup ("");
#line 95 "../src/engine/api/geary-account-information.vala"
	self->priv->_label = _tmp1_;
#line 122 "../src/engine/api/geary-account-information.vala"
	self->priv->_prefetch_period_days = GEARY_ACCOUNT_INFORMATION_DEFAULT_PREFETCH_PERIOD_DAYS;
#line 142 "../src/engine/api/geary-account-information.vala"
	self->priv->_save_sent = TRUE;
#line 145 "../src/engine/api/geary-account-information.vala"
	self->priv->_save_drafts = TRUE;
#line 159 "../src/engine/api/geary-account-information.vala"
	_tmp2_ = geary_nonblocking_mutex_new ();
#line 159 "../src/engine/api/geary-account-information.vala"
	self->priv->_write_lock = _tmp2_;
#line 164 "../src/engine/api/geary-account-information.vala"
	self->priv->_use_signature = FALSE;
#line 167 "../src/engine/api/geary-account-information.vala"
	_tmp3_ = g_strdup ("");
#line 167 "../src/engine/api/geary-account-information.vala"
	self->priv->_signature = _tmp3_;
#line 175 "../src/engine/api/geary-account-information.vala"
	self->priv->_config_dir = NULL;
#line 183 "../src/engine/api/geary-account-information.vala"
	self->priv->_data_dir = NULL;
#line 185 "../src/engine/api/geary-account-information.vala"
	_tmp4_ = gee_hash_map_new (GEARY_FOLDER_TYPE_SPECIAL_USE, (GBoxedCopyFunc) _geary_folder_special_use_dup, (GDestroyNotify) g_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, __geary_account_information_special_use_paths_lambda140__gee_hash_data_func, NULL, NULL, __geary_account_information_special_use_paths_lambda141__gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 185 "../src/engine/api/geary-account-information.vala"
	self->priv->special_use_paths = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_MAP, GeeMap);
#line 191 "../src/engine/api/geary-account-information.vala"
	_tmp5_ = gee_linked_list_new (GEARY_RF_C822_TYPE_MAILBOX_ADDRESS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 191 "../src/engine/api/geary-account-information.vala"
	self->priv->_mailboxes = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_LIST, GeeList);
#line 3996 "geary-account-information.c"
}

static void
geary_account_information_finalize (GObject * obj)
{
	GearyAccountInformation * self;
#line 9 "../src/engine/api/geary-account-information.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_TYPE_ACCOUNT_INFORMATION, GearyAccountInformation);
#line 30 "../src/engine/api/geary-account-information.vala"
	_g_free0 (self->priv->_id);
#line 71 "../src/engine/api/geary-account-information.vala"
	_g_free0 (self->priv->_service_label);
#line 95 "../src/engine/api/geary-account-information.vala"
	_g_free0 (self->priv->_label);
#line 150 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (self->priv->_mediator);
#line 153 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (self->priv->_incoming);
#line 156 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (self->priv->_outgoing);
#line 159 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (self->priv->_write_lock);
#line 167 "../src/engine/api/geary-account-information.vala"
	_g_free0 (self->priv->_signature);
#line 175 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (self->priv->_config_dir);
#line 183 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (self->priv->_data_dir);
#line 185 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (self->priv->special_use_paths);
#line 191 "../src/engine/api/geary-account-information.vala"
	_g_object_unref0 (self->priv->_mailboxes);
#line 9 "../src/engine/api/geary-account-information.vala"
	G_OBJECT_CLASS (geary_account_information_parent_class)->finalize (obj);
#line 4031 "geary-account-information.c"
}

 G_GNUC_NO_INLINE static GType
geary_account_information_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyAccountInformationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_account_information_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyAccountInformation), 0, (GInstanceInitFunc) geary_account_information_instance_init, NULL };
	GType geary_account_information_type_id;
	geary_account_information_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyAccountInformation", &g_define_type_info, 0);
	GearyAccountInformation_private_offset = g_type_add_instance_private (geary_account_information_type_id, sizeof (GearyAccountInformationPrivate));
	return geary_account_information_type_id;
}

GType
geary_account_information_get_type (void)
{
	static gsize geary_account_information_type_id__once = 0;
	if (g_once_init_enter (&geary_account_information_type_id__once)) {
		GType geary_account_information_type_id;
		geary_account_information_type_id = geary_account_information_get_type_once ();
		g_once_init_leave (&geary_account_information_type_id__once, geary_account_information_type_id);
	}
	return geary_account_information_type_id__once;
}

static void
_vala_geary_account_information_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	GearyAccountInformation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_ACCOUNT_INFORMATION, GearyAccountInformation);
#line 9 "../src/engine/api/geary-account-information.vala"
	switch (property_id) {
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_ID_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		g_value_set_string (value, geary_account_information_get_id (self));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_ORDINAL_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		g_value_set_int (value, geary_account_information_get_ordinal (self));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_SERVICE_PROVIDER_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		g_value_set_enum (value, geary_account_information_get_service_provider (self));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_SERVICE_LABEL_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		g_value_take_string (value, geary_account_information_get_service_label (self));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_DISPLAY_NAME_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		g_value_set_string (value, geary_account_information_get_display_name (self));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_LABEL_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		g_value_set_string (value, geary_account_information_get_label (self));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_PRIMARY_MAILBOX_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		g_value_take_object (value, geary_account_information_get_primary_mailbox (self));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_SENDER_MAILBOXES_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		g_value_take_object (value, geary_account_information_get_sender_mailboxes (self));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_HAS_SENDER_ALIASES_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		g_value_set_boolean (value, geary_account_information_get_has_sender_aliases (self));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_PREFETCH_PERIOD_DAYS_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		g_value_set_int (value, geary_account_information_get_prefetch_period_days (self));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_SAVE_SENT_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		g_value_set_boolean (value, geary_account_information_get_save_sent (self));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_SAVE_DRAFTS_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		g_value_set_boolean (value, geary_account_information_get_save_drafts (self));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_MEDIATOR_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		g_value_set_object (value, geary_account_information_get_mediator (self));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_INCOMING_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		g_value_set_object (value, geary_account_information_get_incoming (self));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_OUTGOING_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		g_value_set_object (value, geary_account_information_get_outgoing (self));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_WRITE_LOCK_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		g_value_set_object (value, geary_account_information_get_write_lock (self));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_USE_SIGNATURE_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		g_value_set_boolean (value, geary_account_information_get_use_signature (self));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_SIGNATURE_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		g_value_set_string (value, geary_account_information_get_signature (self));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_CONFIG_DIR_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		g_value_set_object (value, geary_account_information_get_config_dir (self));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_DATA_DIR_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		g_value_set_object (value, geary_account_information_get_data_dir (self));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 4186 "geary-account-information.c"
		default:
#line 9 "../src/engine/api/geary-account-information.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 4192 "geary-account-information.c"
	}
}

static void
_vala_geary_account_information_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	GearyAccountInformation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_ACCOUNT_INFORMATION, GearyAccountInformation);
#line 9 "../src/engine/api/geary-account-information.vala"
	switch (property_id) {
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_ID_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		geary_account_information_set_id (self, g_value_get_string (value));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_ORDINAL_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		geary_account_information_set_ordinal (self, g_value_get_int (value));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_SERVICE_PROVIDER_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		geary_account_information_set_service_provider (self, g_value_get_enum (value));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_SERVICE_LABEL_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		geary_account_information_set_service_label (self, g_value_get_string (value));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_LABEL_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		geary_account_information_set_label (self, g_value_get_string (value));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_PREFETCH_PERIOD_DAYS_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		geary_account_information_set_prefetch_period_days (self, g_value_get_int (value));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_SAVE_SENT_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		geary_account_information_set_save_sent (self, g_value_get_boolean (value));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_SAVE_DRAFTS_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		geary_account_information_set_save_drafts (self, g_value_get_boolean (value));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_MEDIATOR_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		geary_account_information_set_mediator (self, g_value_get_object (value));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_INCOMING_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		geary_account_information_set_incoming (self, g_value_get_object (value));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_OUTGOING_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		geary_account_information_set_outgoing (self, g_value_get_object (value));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_WRITE_LOCK_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		geary_account_information_set_write_lock (self, g_value_get_object (value));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_USE_SIGNATURE_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		geary_account_information_set_use_signature (self, g_value_get_boolean (value));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_SIGNATURE_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		geary_account_information_set_signature (self, g_value_get_string (value));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_CONFIG_DIR_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		geary_account_information_set_config_dir (self, g_value_get_object (value));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 9 "../src/engine/api/geary-account-information.vala"
		case GEARY_ACCOUNT_INFORMATION_DATA_DIR_PROPERTY:
#line 9 "../src/engine/api/geary-account-information.vala"
		geary_account_information_set_data_dir (self, g_value_get_object (value));
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 4302 "geary-account-information.c"
		default:
#line 9 "../src/engine/api/geary-account-information.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 9 "../src/engine/api/geary-account-information.vala"
		break;
#line 4308 "geary-account-information.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

