/* imap-client-service.c generated by valac 0.56.17, the Vala compiler
 * generated from imap-client-service.vala, do not modify */

/*
 * Copyright © 2016 Software Freedom Conservancy Inc.
 * Copyright © 2017-2020 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>

#define GEARY_IMAP_CLIENT_SERVICE_DEFAULT_MIN_POOL_SIZE 1
#define GEARY_IMAP_CLIENT_SERVICE_DEFAULT_MAX_FREE_SIZE 1
#define GEARY_IMAP_CLIENT_SERVICE_CHECK_NOOP_THRESHOLD_SEC 5
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_IMAP_CLIENT_SERVICE_0_PROPERTY,
	GEARY_IMAP_CLIENT_SERVICE_UNSELECTED_KEEPALIVE_SEC_PROPERTY,
	GEARY_IMAP_CLIENT_SERVICE_SELECTED_KEEPALIVE_SEC_PROPERTY,
	GEARY_IMAP_CLIENT_SERVICE_SELECTED_WITH_IDLE_KEEPALIVE_SEC_PROPERTY,
	GEARY_IMAP_CLIENT_SERVICE_MIN_POOL_SIZE_PROPERTY,
	GEARY_IMAP_CLIENT_SERVICE_MAX_FREE_SIZE_PROPERTY,
	GEARY_IMAP_CLIENT_SERVICE_LOGGING_DOMAIN_PROPERTY,
	GEARY_IMAP_CLIENT_SERVICE_NUM_PROPERTIES
};
static GParamSpec* geary_imap_client_service_properties[GEARY_IMAP_CLIENT_SERVICE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _GearyImapClientServiceStartData GearyImapClientServiceStartData;
typedef struct _GearyImapClientServiceStopData GearyImapClientServiceStopData;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _GearyImapClientServiceClaimAuthorizedSessionAsyncData GearyImapClientServiceClaimAuthorizedSessionAsyncData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _GearyImapClientServiceReleaseSessionAsyncData GearyImapClientServiceReleaseSessionAsyncData;
typedef struct _GearyImapClientServiceCheckPoolData GearyImapClientServiceCheckPoolData;
typedef struct _Block25Data Block25Data;
typedef struct _GearyImapClientServiceAddPoolSessionData GearyImapClientServiceAddPoolSessionData;
typedef struct _GearyImapClientServiceCheckSessionData GearyImapClientServiceCheckSessionData;
typedef struct _GearyImapClientServiceCreateNewAuthorizedSessionData GearyImapClientServiceCreateNewAuthorizedSessionData;
typedef struct _Block26Data Block26Data;
typedef struct _GearyImapClientServiceClosePoolData GearyImapClientServiceClosePoolData;
typedef struct _GearyImapClientServiceDisconnectSessionData GearyImapClientServiceDisconnectSessionData;
typedef struct _GearyImapClientServiceForceDisconnectSessionData GearyImapClientServiceForceDisconnectSessionData;
typedef struct _Block27Data Block27Data;
typedef struct _GearyImapClientServiceRemoveSessionAsyncData GearyImapClientServiceRemoveSessionAsyncData;

struct _GearyImapClientServicePrivate {
	guint _unselected_keepalive_sec;
	guint _selected_keepalive_sec;
	guint _selected_with_idle_keepalive_sec;
	gint _min_pool_size;
	gint _max_free_size;
	GearyImapQuirks* quirks;
	GearyNonblockingMutex* sessions_mutex;
	GeeSet* all_sessions;
	GearyNonblockingQueue* free_queue;
	GCancellable* pool_cancellable;
	GCancellable* close_cancellable;
};

struct _GearyImapClientServiceStartData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientService* self;
	GCancellable* cancellable;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GError* _tmp2_;
	GCancellable* _tmp3_;
	GCancellable* _tmp4_;
	GError* _inner_error0_;
};

struct _GearyImapClientServiceStopData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientService* self;
	GCancellable* cancellable;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GCancellable* _tmp2_;
	gint attempts;
	GeeSet* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	GeeSet* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	GCancellable* _tmp10_;
};

struct _GearyImapClientServiceClaimAuthorizedSessionAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientService* self;
	GCancellable* cancellable;
	GearyImapClientSession* result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GError* _tmp2_;
	GearyNonblockingQueue* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GeeSet* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GearyClientServiceStatus _tmp9_;
	GearyClientServiceStatus _tmp10_;
	GError* _tmp11_;
	GearyClientServiceStatus _tmp12_;
	GearyClientServiceStatus _tmp13_;
	GearyEndpoint* _tmp14_;
	GearyEndpoint* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GError* _tmp18_;
	GError* _tmp19_;
	GearyImapClientSession* claimed;
	GearyImapClientSession* _tmp20_;
	GearyNonblockingQueue* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	GearyImapClientSession* _tmp24_;
	GearyNonblockingQueue* _tmp25_;
	gpointer _tmp26_;
	GearyImapClientSession* _tmp27_;
	GearyImapClientSession* _tmp28_;
	GError* _inner_error0_;
};

struct _GearyImapClientServiceReleaseSessionAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientService* self;
	GearyImapClientSession* session;
	GearyNonblockingQueue* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeSet* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gboolean _tmp6_;
	GearyNonblockingQueue* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	GeeSet* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gboolean too_many_free;
	gboolean _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	gboolean _tmp19_;
	gboolean disconnect;
	GearyImapClientSessionProtocolState proto;
	GearyImapClientSessionProtocolState _tmp20_;
	GearyImapClientSessionProtocolState _tmp21_;
	gboolean _tmp22_;
	GCancellable* _tmp23_;
	GearyImapStatusResponse* _tmp24_;
	GearyImapStatusResponse* _tmp25_;
	GError* imap_error;
	gchar* _tmp26_;
	gchar* _tmp27_;
	GError* _tmp28_;
	const gchar* _tmp29_;
	GearyImapClientSessionProtocolState _tmp30_;
	GearyImapClientSessionProtocolState _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	GearyNonblockingQueue* _tmp34_;
	GError* _inner_error0_;
};

struct _GearyImapClientServiceCheckPoolData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientService* self;
	gboolean is_claiming;
	GearyNonblockingQueue* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeSet* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gboolean loaded;
	GearyAccountInformation* _tmp6_;
	GearyAccountInformation* _tmp7_;
	GCancellable* _tmp8_;
	GError* err;
	GError* _tmp9_;
	GearyErrorContext* _tmp10_;
	GearyErrorContext* _tmp11_;
	gint needed;
	gint _tmp12_;
	GeeSet* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gboolean _tmp16_;
	gint _tmp17_;
	GError* _inner_error0_;
};

struct _Block25Data {
	int _ref_count_;
	GearyImapClientService* self;
	GearyImapClientSession* new_session;
	gpointer _async_data_;
};

struct _GearyImapClientServiceAddPoolSessionData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientService* self;
	Block25Data* _data25_;
	GearyImapClientSession* _tmp0_;
	GCancellable* _tmp1_;
	GearyImapClientSession* _tmp2_;
	GearyImapClientSession* _tmp3_;
	GError* err;
	GError* _tmp4_;
	const gchar* _tmp5_;
	GError* _vala1_err;
	GError* _tmp6_;
	const gchar* _tmp7_;
	GError* _vala2_err;
	GearyErrorContext* context;
	GError* _tmp8_;
	GearyErrorContext* _tmp9_;
	GearyErrorContext* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GearyErrorContext* _tmp13_;
	GearyImapClientSession* _tmp14_;
	GearyImapQuirks* _tmp15_;
	GearyImapClientSession* _tmp16_;
	GearyNonblockingMutex* _tmp17_;
	GearyNonblockingQueue* _tmp18_;
	GearyImapClientSession* _tmp19_;
	GError* _vala3_err;
	GearyErrorContext* _vala1_context;
	GError* _tmp20_;
	GearyErrorContext* _tmp21_;
	GearyErrorContext* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GearyErrorContext* _tmp25_;
	GearyImapClientSession* _tmp26_;
	GError* _inner_error0_;
};

struct _GearyImapClientServiceCheckSessionData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientService* self;
	GearyImapClientSession* target;
	gboolean claiming;
	gboolean result;
	gboolean valid;
	GearyImapClientSessionProtocolState _tmp0_;
	GearyImapClientSessionProtocolState _tmp1_;
	gboolean _tmp2_;
	gint64 _tmp3_;
	gint64 _tmp4_;
	GCancellable* _tmp5_;
	GearyImapNoopCommand* _tmp6_;
	GearyImapNoopCommand* _tmp7_;
	GearyImapStatusResponse* _tmp8_;
	GearyImapStatusResponse* _tmp9_;
	GError* err;
	GError* _tmp10_;
	const gchar* _tmp11_;
	GError* _inner_error0_;
};

struct _GearyImapClientServiceCreateNewAuthorizedSessionData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientService* self;
	GCancellable* cancellable;
	GearyImapClientSession* result;
	GearyCredentials* login;
	GearyServiceInformation* _tmp0_;
	GearyServiceInformation* _tmp1_;
	GearyCredentials* _tmp2_;
	GearyCredentials* _tmp3_;
	GearyCredentials* _tmp4_;
	gboolean _tmp5_;
	GearyCredentials* _tmp6_;
	GearyCredentials* _tmp7_;
	GError* _tmp8_;
	GearyImapClientSession* new_session;
	GearyEndpoint* _tmp9_;
	GearyEndpoint* _tmp10_;
	GearyImapQuirks* _tmp11_;
	GearyImapClientSession* _tmp12_;
	GearyImapClientSession* _tmp13_;
	GearyImapClientSession* _tmp14_;
	GearyImapClientSession* _tmp15_;
	GearyCredentials* _tmp16_;
	GError* err;
	GearyImapClientSession* _tmp17_;
	GError* disconnect_err;
	GError* _tmp18_;
	const gchar* _tmp19_;
	GError* _tmp20_;
	GError* _tmp21_;
	GearyImapClientSession* _tmp22_;
	GearyImapClientSession* _tmp23_;
	guint _tmp24_;
	guint _tmp25_;
	guint _tmp26_;
	GError* _inner_error0_;
};

struct _Block26Data {
	int _ref_count_;
	GearyImapClientService* self;
	GearyImapClientSession** to_close;
	gint to_close_length1;
	gint _to_close_size_;
	gpointer _async_data_;
};

struct _GearyImapClientServiceClosePoolData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientService* self;
	gboolean clean_disconnect;
	Block26Data* _data26_;
	GeeSet* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GearyNonblockingMutex* _tmp3_;
	GError* err;
	GError* _tmp4_;
	const gchar* _tmp5_;
	GearyImapClientSession** session_collection;
	gint session_collection_length1;
	gint _session_collection_size_;
	gint session_it;
	GearyImapClientSession* _tmp6_;
	GearyImapClientSession* session;
	GearyImapClientSession* _tmp7_;
	GearyImapClientSession* _tmp8_;
	GError* _inner_error0_;
};

struct _GearyImapClientServiceDisconnectSessionData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientService* self;
	GearyImapClientSession* session;
	GearyImapClientSessionProtocolState _tmp0_;
	GearyImapClientSessionProtocolState _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GCancellable* _tmp4_;
	GError* err;
	GError* _tmp5_;
	const gchar* _tmp6_;
	GError* _inner_error0_;
};

struct _GearyImapClientServiceForceDisconnectSessionData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientService* self;
	GearyImapClientSession* session;
	gchar* _tmp0_;
	gchar* _tmp1_;
};

struct _Block27Data {
	int _ref_count_;
	GearyImapClientService* self;
	gboolean removed;
	GearyImapClientSession* session;
	gpointer _async_data_;
};

struct _GearyImapClientServiceRemoveSessionAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientService* self;
	GearyImapClientSession* session;
	gboolean result;
	Block27Data* _data27_;
	GearyNonblockingQueue* _tmp0_;
	GearyNonblockingMutex* _tmp1_;
	GError* err;
	GError* _tmp2_;
	const gchar* _tmp3_;
	GError* _inner_error0_;
};

static gint GearyImapClientService_private_offset;
static gpointer geary_imap_client_service_parent_class = NULL;

static void geary_imap_client_service_real_start_data_free (gpointer _data);
static void geary_imap_client_service_real_start (GearyClientService* base,
                                           GCancellable* cancellable,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
static gboolean geary_imap_client_service_real_start_co (GearyImapClientServiceStartData* _data_);
static void geary_imap_client_service_real_stop_data_free (gpointer _data);
static void geary_imap_client_service_real_stop (GearyClientService* base,
                                          GCancellable* cancellable,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
static gboolean geary_imap_client_service_real_stop_co (GearyImapClientServiceStopData* _data_);
static void geary_imap_client_service_close_pool (GearyImapClientService* self,
                                           gboolean clean_disconnect,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
static void geary_imap_client_service_close_pool_finish (GearyImapClientService* self,
                                                  GAsyncResult* _res_);
static void geary_imap_client_service_stop_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_);
static gboolean _geary_imap_client_service_real_stop_co_gsource_func (gpointer self);
static void geary_imap_client_service_claim_authorized_session_async_data_free (gpointer _data);
static gboolean geary_imap_client_service_claim_authorized_session_async_co (GearyImapClientServiceClaimAuthorizedSessionAsyncData* _data_);
static void geary_imap_client_service_check_pool (GearyImapClientService* self,
                                           gboolean is_claiming,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
static void geary_imap_client_service_check_pool_finish (GearyImapClientService* self,
                                                  GAsyncResult* _res_);
static void geary_imap_client_service_claim_authorized_session_async_ready (GObject* source_object,
                                                                     GAsyncResult* _res_,
                                                                     gpointer _user_data_);
static void geary_imap_client_service_check_session (GearyImapClientService* self,
                                              GearyImapClientSession* target,
                                              gboolean claiming,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
static gboolean geary_imap_client_service_check_session_finish (GearyImapClientService* self,
                                                         GAsyncResult* _res_);
static void geary_imap_client_service_release_session_async_data_free (gpointer _data);
static gboolean geary_imap_client_service_release_session_async_co (GearyImapClientServiceReleaseSessionAsyncData* _data_);
static void geary_imap_client_service_release_session_async_ready (GObject* source_object,
                                                            GAsyncResult* _res_,
                                                            gpointer _user_data_);
static void geary_imap_client_service_disconnect_session (GearyImapClientService* self,
                                                   GearyImapClientSession* session,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
static void geary_imap_client_service_disconnect_session_finish (GearyImapClientService* self,
                                                          GAsyncResult* _res_);
static void geary_imap_client_service_real_became_reachable (GearyClientService* base);
static void geary_imap_client_service_real_became_unreachable (GearyClientService* base);
static void geary_imap_client_service_check_pool_data_free (gpointer _data);
static gboolean geary_imap_client_service_check_pool_co (GearyImapClientServiceCheckPoolData* _data_);
static void geary_imap_client_service_check_pool_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_);
static void geary_imap_client_service_add_pool_session (GearyImapClientService* self,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
static void geary_imap_client_service_add_pool_session_finish (GearyImapClientService* self,
                                                        GAsyncResult* _res_);
static void geary_imap_client_service_add_pool_session_data_free (gpointer _data);
static gboolean geary_imap_client_service_add_pool_session_co (GearyImapClientServiceAddPoolSessionData* _data_);
static Block25Data* block25_data_ref (Block25Data* _data25_);
static void block25_data_unref (void * _userdata_);
static void geary_imap_client_service_create_new_authorized_session (GearyImapClientService* self,
                                                              GCancellable* cancellable,
                                                              GAsyncReadyCallback _callback_,
                                                              gpointer _user_data_);
static GearyImapClientSession* geary_imap_client_service_create_new_authorized_session_finish (GearyImapClientService* self,
                                                                                        GAsyncResult* _res_,
                                                                                        GError** error);
static void geary_imap_client_service_add_pool_session_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_);
static void ____lambda108_ (Block25Data* _data25_,
                     GError** error);
static void _____lambda108__geary_nonblocking_mutex_critical_section (gpointer self,
                                                               GError** error);
static void geary_imap_client_service_check_session_data_free (gpointer _data);
static gboolean geary_imap_client_service_check_session_co (GearyImapClientServiceCheckSessionData* _data_);
static void geary_imap_client_service_check_session_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_);
VALA_EXTERN gint64 geary_imap_client_session_get_last_seen (GearyImapClientSession* self);
static void geary_imap_client_service_create_new_authorized_session_data_free (gpointer _data);
static gboolean geary_imap_client_service_create_new_authorized_session_co (GearyImapClientServiceCreateNewAuthorizedSessionData* _data_);
VALA_EXTERN void geary_imap_client_session_set_logging_parent (GearyImapClientSession* self,
                                                   GearyLoggingSource* parent);
static void geary_imap_client_service_create_new_authorized_session_ready (GObject* source_object,
                                                                    GAsyncResult* _res_,
                                                                    gpointer _user_data_);
static void geary_imap_client_service_on_session_disconnected (GearyImapClientService* self,
                                                        GObject* source,
                                                        GParamSpec* param);
static void _geary_imap_client_service_on_session_disconnected_g_object_notify (GObject* _sender,
                                                                         GParamSpec* pspec,
                                                                         gpointer self);
static void geary_imap_client_service_close_pool_data_free (gpointer _data);
static gboolean geary_imap_client_service_close_pool_co (GearyImapClientServiceClosePoolData* _data_);
static Block26Data* block26_data_ref (Block26Data* _data26_);
static void block26_data_unref (void * _userdata_);
static void ___lambda107_ (Block26Data* _data26_,
                    GError** error);
static void ____lambda107__geary_nonblocking_mutex_critical_section (gpointer self,
                                                              GError** error);
static void geary_imap_client_service_close_pool_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_);
static void geary_imap_client_service_force_disconnect_session (GearyImapClientService* self,
                                                         GearyImapClientSession* session,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_);
static void geary_imap_client_service_force_disconnect_session_finish (GearyImapClientService* self,
                                                                GAsyncResult* _res_);
static void geary_imap_client_service_disconnect_session_data_free (gpointer _data);
static gboolean geary_imap_client_service_disconnect_session_co (GearyImapClientServiceDisconnectSessionData* _data_);
static void geary_imap_client_service_disconnect_session_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_);
static void geary_imap_client_service_remove_session_async (GearyImapClientService* self,
                                                     GearyImapClientSession* session,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_);
static gboolean geary_imap_client_service_remove_session_finish (GearyImapClientService* self,
                                                          GAsyncResult* _res_);
static void geary_imap_client_service_force_disconnect_session_data_free (gpointer _data);
static gboolean geary_imap_client_service_force_disconnect_session_co (GearyImapClientServiceForceDisconnectSessionData* _data_);
static void geary_imap_client_service_force_disconnect_session_ready (GObject* source_object,
                                                               GAsyncResult* _res_,
                                                               gpointer _user_data_);
static void geary_imap_client_service_remove_session_async_data_free (gpointer _data);
static gboolean geary_imap_client_service_remove_session_async_co (GearyImapClientServiceRemoveSessionAsyncData* _data_);
static Block27Data* block27_data_ref (Block27Data* _data27_);
static void block27_data_unref (void * _userdata_);
static void ___lambda105_ (Block27Data* _data27_,
                    GError** error);
static void ____lambda105__geary_nonblocking_mutex_critical_section (gpointer self,
                                                              GError** error);
static void geary_imap_client_service_remove_session_async_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_);
static void ___lambda106_ (GearyImapClientService* self,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda106__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static void geary_imap_client_service_finalize (GObject * obj);
static GType geary_imap_client_service_get_type_once (void);
static void _vala_geary_imap_client_service_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_geary_imap_client_service_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
geary_imap_client_service_get_instance_private (GearyImapClientService* self)
{
	return G_STRUCT_MEMBER_P (self, GearyImapClientService_private_offset);
}

guint
geary_imap_client_service_get_unselected_keepalive_sec (GearyImapClientService* self)
{
	guint result;
#line 49 "../src/engine/imap/api/imap-client-service.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SERVICE (self), 0U);
#line 49 "../src/engine/imap/api/imap-client-service.vala"
	result = self->priv->_unselected_keepalive_sec;
#line 49 "../src/engine/imap/api/imap-client-service.vala"
	return result;
#line 627 "imap-client-service.c"
}

void
geary_imap_client_service_set_unselected_keepalive_sec (GearyImapClientService* self,
                                                        guint value)
{
	guint old_value;
#line 49 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SERVICE (self));
#line 49 "../src/engine/imap/api/imap-client-service.vala"
	old_value = geary_imap_client_service_get_unselected_keepalive_sec (self);
#line 49 "../src/engine/imap/api/imap-client-service.vala"
	if (old_value != value) {
#line 49 "../src/engine/imap/api/imap-client-service.vala"
		self->priv->_unselected_keepalive_sec = value;
#line 49 "../src/engine/imap/api/imap-client-service.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_imap_client_service_properties[GEARY_IMAP_CLIENT_SERVICE_UNSELECTED_KEEPALIVE_SEC_PROPERTY]);
#line 645 "imap-client-service.c"
	}
}

guint
geary_imap_client_service_get_selected_keepalive_sec (GearyImapClientService* self)
{
	guint result;
#line 57 "../src/engine/imap/api/imap-client-service.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SERVICE (self), 0U);
#line 57 "../src/engine/imap/api/imap-client-service.vala"
	result = self->priv->_selected_keepalive_sec;
#line 57 "../src/engine/imap/api/imap-client-service.vala"
	return result;
#line 659 "imap-client-service.c"
}

void
geary_imap_client_service_set_selected_keepalive_sec (GearyImapClientService* self,
                                                      guint value)
{
	guint old_value;
#line 57 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SERVICE (self));
#line 57 "../src/engine/imap/api/imap-client-service.vala"
	old_value = geary_imap_client_service_get_selected_keepalive_sec (self);
#line 57 "../src/engine/imap/api/imap-client-service.vala"
	if (old_value != value) {
#line 57 "../src/engine/imap/api/imap-client-service.vala"
		self->priv->_selected_keepalive_sec = value;
#line 57 "../src/engine/imap/api/imap-client-service.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_imap_client_service_properties[GEARY_IMAP_CLIENT_SERVICE_SELECTED_KEEPALIVE_SEC_PROPERTY]);
#line 677 "imap-client-service.c"
	}
}

guint
geary_imap_client_service_get_selected_with_idle_keepalive_sec (GearyImapClientService* self)
{
	guint result;
#line 65 "../src/engine/imap/api/imap-client-service.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SERVICE (self), 0U);
#line 65 "../src/engine/imap/api/imap-client-service.vala"
	result = self->priv->_selected_with_idle_keepalive_sec;
#line 65 "../src/engine/imap/api/imap-client-service.vala"
	return result;
#line 691 "imap-client-service.c"
}

void
geary_imap_client_service_set_selected_with_idle_keepalive_sec (GearyImapClientService* self,
                                                                guint value)
{
	guint old_value;
#line 65 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SERVICE (self));
#line 65 "../src/engine/imap/api/imap-client-service.vala"
	old_value = geary_imap_client_service_get_selected_with_idle_keepalive_sec (self);
#line 65 "../src/engine/imap/api/imap-client-service.vala"
	if (old_value != value) {
#line 65 "../src/engine/imap/api/imap-client-service.vala"
		self->priv->_selected_with_idle_keepalive_sec = value;
#line 65 "../src/engine/imap/api/imap-client-service.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_imap_client_service_properties[GEARY_IMAP_CLIENT_SERVICE_SELECTED_WITH_IDLE_KEEPALIVE_SEC_PROPERTY]);
#line 709 "imap-client-service.c"
	}
}

gint
geary_imap_client_service_get_min_pool_size (GearyImapClientService* self)
{
	gint result;
#line 77 "../src/engine/imap/api/imap-client-service.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SERVICE (self), 0);
#line 77 "../src/engine/imap/api/imap-client-service.vala"
	result = self->priv->_min_pool_size;
#line 77 "../src/engine/imap/api/imap-client-service.vala"
	return result;
#line 723 "imap-client-service.c"
}

void
geary_imap_client_service_set_min_pool_size (GearyImapClientService* self,
                                             gint value)
{
	gint old_value;
#line 77 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SERVICE (self));
#line 77 "../src/engine/imap/api/imap-client-service.vala"
	old_value = geary_imap_client_service_get_min_pool_size (self);
#line 77 "../src/engine/imap/api/imap-client-service.vala"
	if (old_value != value) {
#line 77 "../src/engine/imap/api/imap-client-service.vala"
		self->priv->_min_pool_size = value;
#line 77 "../src/engine/imap/api/imap-client-service.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_imap_client_service_properties[GEARY_IMAP_CLIENT_SERVICE_MIN_POOL_SIZE_PROPERTY]);
#line 741 "imap-client-service.c"
	}
}

gint
geary_imap_client_service_get_max_free_size (GearyImapClientService* self)
{
	gint result;
#line 92 "../src/engine/imap/api/imap-client-service.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SERVICE (self), 0);
#line 92 "../src/engine/imap/api/imap-client-service.vala"
	result = self->priv->_max_free_size;
#line 92 "../src/engine/imap/api/imap-client-service.vala"
	return result;
#line 755 "imap-client-service.c"
}

void
geary_imap_client_service_set_max_free_size (GearyImapClientService* self,
                                             gint value)
{
	gint old_value;
#line 92 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SERVICE (self));
#line 92 "../src/engine/imap/api/imap-client-service.vala"
	old_value = geary_imap_client_service_get_max_free_size (self);
#line 92 "../src/engine/imap/api/imap-client-service.vala"
	if (old_value != value) {
#line 92 "../src/engine/imap/api/imap-client-service.vala"
		self->priv->_max_free_size = value;
#line 92 "../src/engine/imap/api/imap-client-service.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_imap_client_service_properties[GEARY_IMAP_CLIENT_SERVICE_MAX_FREE_SIZE_PROPERTY]);
#line 773 "imap-client-service.c"
	}
}

static const gchar*
geary_imap_client_service_real_get_logging_domain (GearyClientService* base)
{
	const gchar* result;
	GearyImapClientService* self;
#line 101 "../src/engine/imap/api/imap-client-service.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_IMAP_TYPE_CLIENT_SERVICE, GearyImapClientService);
#line 101 "../src/engine/imap/api/imap-client-service.vala"
	result = GEARY_IMAP_CLIENT_SERVICE_LOGGING_DOMAIN;
#line 101 "../src/engine/imap/api/imap-client-service.vala"
	return result;
#line 788 "imap-client-service.c"
}

GearyImapClientService*
geary_imap_client_service_construct (GType object_type,
                                     GearyAccountInformation* account,
                                     GearyServiceInformation* configuration,
                                     GearyEndpoint* remote)
{
	GearyImapClientService * self = NULL;
#line 116 "../src/engine/imap/api/imap-client-service.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (account), NULL);
#line 116 "../src/engine/imap/api/imap-client-service.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (configuration), NULL);
#line 116 "../src/engine/imap/api/imap-client-service.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (remote), NULL);
#line 119 "../src/engine/imap/api/imap-client-service.vala"
	self = (GearyImapClientService*) geary_client_service_construct (object_type, account, configuration, remote);
#line 116 "../src/engine/imap/api/imap-client-service.vala"
	return self;
#line 808 "imap-client-service.c"
}

GearyImapClientService*
geary_imap_client_service_new (GearyAccountInformation* account,
                               GearyServiceInformation* configuration,
                               GearyEndpoint* remote)
{
#line 116 "../src/engine/imap/api/imap-client-service.vala"
	return geary_imap_client_service_construct (GEARY_IMAP_TYPE_CLIENT_SERVICE, account, configuration, remote);
#line 818 "imap-client-service.c"
}

static void
geary_imap_client_service_real_start_data_free (gpointer _data)
{
	GearyImapClientServiceStartData* _data_;
	_data_ = _data;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_slice_free (GearyImapClientServiceStartData, _data_);
#line 832 "imap-client-service.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	return self ? g_object_ref (self) : NULL;
#line 840 "imap-client-service.c"
}

static void
geary_imap_client_service_real_start (GearyClientService* base,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	GearyImapClientService * self;
	GearyImapClientServiceStartData* _data_;
	GearyImapClientService* _tmp0_;
	GCancellable* _tmp1_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_IMAP_TYPE_CLIENT_SERVICE, GearyImapClientService);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = g_slice_new0 (GearyImapClientServiceStartData);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_service_real_start_data_free);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->self = _tmp0_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->cancellable = _tmp1_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_real_start_co (_data_);
#line 875 "imap-client-service.c"
}

static void
geary_imap_client_service_start_finish (GearyClientService* base,
                                        GAsyncResult* _res_,
                                        GError** error)
{
	GearyImapClientServiceStartData* _data_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	if (NULL == _data_) {
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		return;
#line 890 "imap-client-service.c"
	}
}

/**
     * Starts the manager opening IMAP client sessions.
     */
static gboolean
geary_imap_client_service_real_start_co (GearyImapClientServiceStartData* _data_)
{
#line 125 "../src/engine/imap/api/imap-client-service.vala"
	switch (_data_->_state_) {
#line 125 "../src/engine/imap/api/imap-client-service.vala"
		case 0:
#line 904 "imap-client-service.c"
		goto _state_0;
		default:
#line 125 "../src/engine/imap/api/imap-client-service.vala"
		g_assert_not_reached ();
#line 909 "imap-client-service.c"
	}
	_state_0:
#line 127 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp0_ = geary_client_service_get_is_running (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 127 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 127 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_tmp1_) {
#line 128 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp2_ = g_error_new_literal (GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_ALREADY_OPEN, "IMAP client service already open");
#line 128 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_inner_error0_ = _data_->_tmp2_;
#line 128 "../src/engine/imap/api/imap-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 128 "../src/engine/imap/api/imap-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 128 "../src/engine/imap/api/imap-client-service.vala"
		return FALSE;
#line 928 "imap-client-service.c"
	}
#line 133 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp3_ = g_cancellable_new ();
#line 133 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->self->priv->pool_cancellable);
#line 133 "../src/engine/imap/api/imap-client-service.vala"
	_data_->self->priv->pool_cancellable = _data_->_tmp3_;
#line 134 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp4_ = g_cancellable_new ();
#line 134 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->self->priv->close_cancellable);
#line 134 "../src/engine/imap/api/imap-client-service.vala"
	_data_->self->priv->close_cancellable = _data_->_tmp4_;
#line 135 "../src/engine/imap/api/imap-client-service.vala"
	geary_client_service_notify_started (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 125 "../src/engine/imap/api/imap-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 125 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_state_ != 0) {
#line 125 "../src/engine/imap/api/imap-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 125 "../src/engine/imap/api/imap-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 952 "imap-client-service.c"
		}
	}
#line 125 "../src/engine/imap/api/imap-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 125 "../src/engine/imap/api/imap-client-service.vala"
	return FALSE;
#line 959 "imap-client-service.c"
}

static void
geary_imap_client_service_real_stop_data_free (gpointer _data)
{
	GearyImapClientServiceStopData* _data_;
	_data_ = _data;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_slice_free (GearyImapClientServiceStopData, _data_);
#line 973 "imap-client-service.c"
}

static void
geary_imap_client_service_real_stop (GearyClientService* base,
                                     GCancellable* cancellable,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	GearyImapClientService * self;
	GearyImapClientServiceStopData* _data_;
	GearyImapClientService* _tmp0_;
	GCancellable* _tmp1_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_IMAP_TYPE_CLIENT_SERVICE, GearyImapClientService);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = g_slice_new0 (GearyImapClientServiceStopData);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_service_real_stop_data_free);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->self = _tmp0_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->cancellable = _tmp1_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_real_stop_co (_data_);
#line 1008 "imap-client-service.c"
}

static void
geary_imap_client_service_stop_finish (GearyClientService* base,
                                       GAsyncResult* _res_,
                                       GError** error)
{
	GearyImapClientServiceStopData* _data_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	if (NULL == _data_) {
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		return;
#line 1023 "imap-client-service.c"
	}
}

/**
     * Stops the manager running, closing any existing sessions.
     */
static void
geary_imap_client_service_stop_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_)
{
	GearyImapClientServiceStopData* _data_;
#line 150 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = _user_data_;
#line 150 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_source_object_ = source_object;
#line 150 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_res_ = _res_;
#line 150 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_real_stop_co (_data_);
#line 1044 "imap-client-service.c"
}

static gboolean
_geary_imap_client_service_real_stop_co_gsource_func (gpointer self)
{
	gboolean result;
	result = geary_imap_client_service_real_stop_co (self);
#line 157 "../src/engine/imap/api/imap-client-service.vala"
	return result;
#line 1054 "imap-client-service.c"
}

static gboolean
geary_imap_client_service_real_stop_co (GearyImapClientServiceStopData* _data_)
{
#line 141 "../src/engine/imap/api/imap-client-service.vala"
	switch (_data_->_state_) {
#line 141 "../src/engine/imap/api/imap-client-service.vala"
		case 0:
#line 1064 "imap-client-service.c"
		goto _state_0;
#line 141 "../src/engine/imap/api/imap-client-service.vala"
		case 1:
#line 1068 "imap-client-service.c"
		goto _state_1;
#line 141 "../src/engine/imap/api/imap-client-service.vala"
		case 2:
#line 1072 "imap-client-service.c"
		goto _state_2;
		default:
#line 141 "../src/engine/imap/api/imap-client-service.vala"
		g_assert_not_reached ();
#line 1077 "imap-client-service.c"
	}
	_state_0:
#line 143 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp0_ = geary_client_service_get_is_running (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 143 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 143 "../src/engine/imap/api/imap-client-service.vala"
	if (!_data_->_tmp1_) {
#line 144 "../src/engine/imap/api/imap-client-service.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 144 "../src/engine/imap/api/imap-client-service.vala"
		if (_data_->_state_ != 0) {
#line 144 "../src/engine/imap/api/imap-client-service.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 144 "../src/engine/imap/api/imap-client-service.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1094 "imap-client-service.c"
			}
		}
#line 144 "../src/engine/imap/api/imap-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 144 "../src/engine/imap/api/imap-client-service.vala"
		return FALSE;
#line 1101 "imap-client-service.c"
	}
#line 147 "../src/engine/imap/api/imap-client-service.vala"
	geary_client_service_notify_stopped (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 149 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp2_ = _data_->self->priv->pool_cancellable;
#line 149 "../src/engine/imap/api/imap-client-service.vala"
	g_cancellable_cancel (_data_->_tmp2_);
#line 150 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_state_ = 1;
#line 150 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_close_pool (_data_->self, TRUE, geary_imap_client_service_stop_ready, _data_);
#line 150 "../src/engine/imap/api/imap-client-service.vala"
	return FALSE;
#line 1115 "imap-client-service.c"
	_state_1:
#line 150 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_close_pool_finish (_data_->self, _data_->_res_);
#line 154 "../src/engine/imap/api/imap-client-service.vala"
	_data_->attempts = 0;
#line 155 "../src/engine/imap/api/imap-client-service.vala"
	while (TRUE) {
#line 155 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp3_ = _data_->self->priv->all_sessions;
#line 155 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp4_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 155 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 155 "../src/engine/imap/api/imap-client-service.vala"
		if (!(_data_->_tmp5_ > 0)) {
#line 155 "../src/engine/imap/api/imap-client-service.vala"
			break;
#line 1133 "imap-client-service.c"
		}
#line 156 "../src/engine/imap/api/imap-client-service.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Waiting for client sessions to disconnect...");
#line 157 "../src/engine/imap/api/imap-client-service.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 250, _geary_imap_client_service_real_stop_co_gsource_func, _data_, NULL);
#line 158 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_state_ = 2;
#line 158 "../src/engine/imap/api/imap-client-service.vala"
		return FALSE;
#line 1143 "imap-client-service.c"
		_state_2:
		;
#line 161 "../src/engine/imap/api/imap-client-service.vala"
		_data_->attempts = _data_->attempts + 1;
#line 161 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp6_ = _data_->attempts;
#line 161 "../src/engine/imap/api/imap-client-service.vala"
		if (_data_->_tmp6_ > 12) {
#line 162 "../src/engine/imap/api/imap-client-service.vala"
			break;
#line 1154 "imap-client-service.c"
		}
	}
#line 165 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp7_ = _data_->self->priv->all_sessions;
#line 165 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp8_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp7_, GEE_TYPE_COLLECTION, GeeCollection));
#line 165 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp9_ = _data_->_tmp8_;
#line 165 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_tmp9_ > 0) {
#line 166 "../src/engine/imap/api/imap-client-service.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Cancelling remaining client sessions...");
#line 167 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp10_ = _data_->self->priv->close_cancellable;
#line 167 "../src/engine/imap/api/imap-client-service.vala"
		g_cancellable_cancel (_data_->_tmp10_);
#line 1171 "imap-client-service.c"
	}
#line 141 "../src/engine/imap/api/imap-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 141 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_state_ != 0) {
#line 141 "../src/engine/imap/api/imap-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 141 "../src/engine/imap/api/imap-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1181 "imap-client-service.c"
		}
	}
#line 141 "../src/engine/imap/api/imap-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 141 "../src/engine/imap/api/imap-client-service.vala"
	return FALSE;
#line 1188 "imap-client-service.c"
}

static void
geary_imap_client_service_claim_authorized_session_async_data_free (gpointer _data)
{
	GearyImapClientServiceClaimAuthorizedSessionAsyncData* _data_;
	_data_ = _data;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->result);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_slice_free (GearyImapClientServiceClaimAuthorizedSessionAsyncData, _data_);
#line 1204 "imap-client-service.c"
}

void
geary_imap_client_service_claim_authorized_session_async (GearyImapClientService* self,
                                                          GCancellable* cancellable,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_)
{
	GearyImapClientServiceClaimAuthorizedSessionAsyncData* _data_;
	GearyImapClientService* _tmp0_;
	GCancellable* _tmp1_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SERVICE (self));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = g_slice_new0 (GearyImapClientServiceClaimAuthorizedSessionAsyncData);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_service_claim_authorized_session_async_data_free);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->self = _tmp0_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->cancellable = _tmp1_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_claim_authorized_session_async_co (_data_);
#line 1238 "imap-client-service.c"
}

GearyImapClientSession*
geary_imap_client_service_claim_authorized_session_finish (GearyImapClientService* self,
                                                           GAsyncResult* _res_,
                                                           GError** error)
{
	GearyImapClientSession* result;
	GearyImapClientServiceClaimAuthorizedSessionAsyncData* _data_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	if (NULL == _data_) {
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		return NULL;
#line 1254 "imap-client-service.c"
	}
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	result = _data_->result;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->result = NULL;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	return result;
#line 1262 "imap-client-service.c"
}

/**
     * Claims a free session, blocking until one becomes available.
     *
     * This call will fail fast if the pool is known to not in the
     * right state (bad authorisation credentials, host not ready,
     * etc), but then will block while attempting to obtain a
     * connection if the free queue is empty. If an error occurs when
     * this connection is in progress, then the call will block until
     * another becomes available (host becomes reachable again, user
     * enters password, etc). If this is undesirable, then the caller
     * may cancel the call.
     *
     * @throws ImapError.UNAUTHENTICATED if the stored credentials are
     * invalid.
     * @throws ImapError.UNAVAILABLE if the IMAP endpoint is not
     * trusted or is not reachable.
     */
static void
geary_imap_client_service_claim_authorized_session_async_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_)
{
	GearyImapClientServiceClaimAuthorizedSessionAsyncData* _data_;
#line 220 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = _user_data_;
#line 220 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_source_object_ = source_object;
#line 220 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_res_ = _res_;
#line 220 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_claim_authorized_session_async_co (_data_);
#line 1296 "imap-client-service.c"
}

static gboolean
geary_imap_client_service_claim_authorized_session_async_co (GearyImapClientServiceClaimAuthorizedSessionAsyncData* _data_)
{
#line 188 "../src/engine/imap/api/imap-client-service.vala"
	switch (_data_->_state_) {
#line 188 "../src/engine/imap/api/imap-client-service.vala"
		case 0:
#line 1306 "imap-client-service.c"
		goto _state_0;
#line 188 "../src/engine/imap/api/imap-client-service.vala"
		case 1:
#line 1310 "imap-client-service.c"
		goto _state_1;
#line 188 "../src/engine/imap/api/imap-client-service.vala"
		case 2:
#line 1314 "imap-client-service.c"
		goto _state_2;
		default:
#line 188 "../src/engine/imap/api/imap-client-service.vala"
		g_assert_not_reached ();
#line 1319 "imap-client-service.c"
	}
	_state_0:
#line 191 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp0_ = geary_client_service_get_is_running (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 191 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 191 "../src/engine/imap/api/imap-client-service.vala"
	if (!_data_->_tmp1_) {
#line 192 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp2_ = g_error_new_literal (GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_OPEN_REQUIRED, "IMAP client service is not running");
#line 192 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_inner_error0_ = _data_->_tmp2_;
#line 192 "../src/engine/imap/api/imap-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 192 "../src/engine/imap/api/imap-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 192 "../src/engine/imap/api/imap-client-service.vala"
		return FALSE;
#line 1338 "imap-client-service.c"
	}
#line 197 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp3_ = _data_->self->priv->free_queue;
#line 197 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp4_ = geary_nonblocking_queue_get_size (_data_->_tmp3_);
#line 197 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 197 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp6_ = _data_->self->priv->all_sessions;
#line 197 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp7_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, GEE_TYPE_COLLECTION, GeeCollection));
#line 197 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 197 "../src/engine/imap/api/imap-client-service.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Claiming session with %d of %d free", _data_->_tmp5_, _data_->_tmp8_);
#line 200 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp9_ = geary_client_service_get_current_status (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 200 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 200 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_tmp10_ == GEARY_CLIENT_SERVICE_STATUS_AUTHENTICATION_FAILED) {
#line 201 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp11_ = g_error_new_literal (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_UNAUTHENTICATED, "Invalid credentials");
#line 201 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_inner_error0_ = _data_->_tmp11_;
#line 201 "../src/engine/imap/api/imap-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 201 "../src/engine/imap/api/imap-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 201 "../src/engine/imap/api/imap-client-service.vala"
		return FALSE;
#line 1370 "imap-client-service.c"
	}
#line 204 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp12_ = geary_client_service_get_current_status (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 204 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp13_ = _data_->_tmp12_;
#line 204 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_tmp13_ == GEARY_CLIENT_SERVICE_STATUS_TLS_VALIDATION_FAILED) {
#line 205 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp14_ = geary_client_service_get_remote (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 205 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 205 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp16_ = geary_endpoint_to_string (_data_->_tmp15_);
#line 205 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp17_ = _data_->_tmp16_;
#line 205 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp18_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_UNAVAILABLE, "Untrusted host %s", _data_->_tmp17_);
#line 205 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp19_ = _data_->_tmp18_;
#line 205 "../src/engine/imap/api/imap-client-service.vala"
		_g_free0 (_data_->_tmp17_);
#line 205 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_inner_error0_ = _data_->_tmp19_;
#line 205 "../src/engine/imap/api/imap-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 205 "../src/engine/imap/api/imap-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 205 "../src/engine/imap/api/imap-client-service.vala"
		return FALSE;
#line 1400 "imap-client-service.c"
	}
#line 210 "../src/engine/imap/api/imap-client-service.vala"
	_data_->claimed = NULL;
#line 211 "../src/engine/imap/api/imap-client-service.vala"
	while (TRUE) {
#line 211 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp20_ = _data_->claimed;
#line 211 "../src/engine/imap/api/imap-client-service.vala"
		if (!(_data_->_tmp20_ == NULL)) {
#line 211 "../src/engine/imap/api/imap-client-service.vala"
			break;
#line 1412 "imap-client-service.c"
		}
#line 216 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp21_ = _data_->self->priv->free_queue;
#line 216 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp22_ = geary_nonblocking_queue_get_size (_data_->_tmp21_);
#line 216 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp23_ = _data_->_tmp22_;
#line 216 "../src/engine/imap/api/imap-client-service.vala"
		if (_data_->_tmp23_ == 0) {
#line 217 "../src/engine/imap/api/imap-client-service.vala"
			geary_imap_client_service_check_pool (_data_->self, TRUE, NULL, NULL);
#line 1424 "imap-client-service.c"
		}
#line 220 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp25_ = _data_->self->priv->free_queue;
#line 220 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_state_ = 1;
#line 220 "../src/engine/imap/api/imap-client-service.vala"
		geary_nonblocking_queue_receive (_data_->_tmp25_, _data_->cancellable, geary_imap_client_service_claim_authorized_session_async_ready, _data_);
#line 220 "../src/engine/imap/api/imap-client-service.vala"
		return FALSE;
#line 1434 "imap-client-service.c"
		_state_1:
#line 220 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp26_ = geary_nonblocking_queue_receive_finish (_data_->_tmp25_, _data_->_res_, &_data_->_inner_error0_);
#line 220 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp24_ = (GearyImapClientSession*) _data_->_tmp26_;
#line 220 "../src/engine/imap/api/imap-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 220 "../src/engine/imap/api/imap-client-service.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 220 "../src/engine/imap/api/imap-client-service.vala"
			_g_object_unref0 (_data_->claimed);
#line 220 "../src/engine/imap/api/imap-client-service.vala"
			g_object_unref (_data_->_async_result);
#line 220 "../src/engine/imap/api/imap-client-service.vala"
			return FALSE;
#line 1450 "imap-client-service.c"
		}
#line 220 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp27_ = _data_->_tmp24_;
#line 220 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp24_ = NULL;
#line 220 "../src/engine/imap/api/imap-client-service.vala"
		_g_object_unref0 (_data_->claimed);
#line 220 "../src/engine/imap/api/imap-client-service.vala"
		_data_->claimed = _data_->_tmp27_;
#line 224 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp28_ = _data_->claimed;
#line 224 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_state_ = 2;
#line 224 "../src/engine/imap/api/imap-client-service.vala"
		geary_imap_client_service_check_session (_data_->self, _data_->_tmp28_, TRUE, geary_imap_client_service_claim_authorized_session_async_ready, _data_);
#line 224 "../src/engine/imap/api/imap-client-service.vala"
		return FALSE;
#line 1468 "imap-client-service.c"
		_state_2:
#line 224 "../src/engine/imap/api/imap-client-service.vala"
		if (!geary_imap_client_service_check_session_finish (_data_->self, _data_->_res_)) {
#line 225 "../src/engine/imap/api/imap-client-service.vala"
			_g_object_unref0 (_data_->claimed);
#line 225 "../src/engine/imap/api/imap-client-service.vala"
			_data_->claimed = NULL;
#line 1476 "imap-client-service.c"
		}
#line 211 "../src/engine/imap/api/imap-client-service.vala"
		_g_object_unref0 (_data_->_tmp24_);
#line 1480 "imap-client-service.c"
	}
#line 229 "../src/engine/imap/api/imap-client-service.vala"
	_data_->result = _data_->claimed;
#line 229 "../src/engine/imap/api/imap-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 229 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_state_ != 0) {
#line 229 "../src/engine/imap/api/imap-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 229 "../src/engine/imap/api/imap-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1492 "imap-client-service.c"
		}
	}
#line 229 "../src/engine/imap/api/imap-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 229 "../src/engine/imap/api/imap-client-service.vala"
	return FALSE;
#line 1499 "imap-client-service.c"
}

static void
geary_imap_client_service_release_session_async_data_free (gpointer _data)
{
	GearyImapClientServiceReleaseSessionAsyncData* _data_;
	_data_ = _data;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->session);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_slice_free (GearyImapClientServiceReleaseSessionAsyncData, _data_);
#line 1513 "imap-client-service.c"
}

void
geary_imap_client_service_release_session_async (GearyImapClientService* self,
                                                 GearyImapClientSession* session,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_)
{
	GearyImapClientServiceReleaseSessionAsyncData* _data_;
	GearyImapClientService* _tmp0_;
	GearyImapClientSession* _tmp1_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SERVICE (self));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (session));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = g_slice_new0 (GearyImapClientServiceReleaseSessionAsyncData);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_service_release_session_async_data_free);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->self = _tmp0_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_tmp1_ = _g_object_ref0 (session);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->session);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->session = _tmp1_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_release_session_async_co (_data_);
#line 1547 "imap-client-service.c"
}

void
geary_imap_client_service_release_session_finish (GearyImapClientService* self,
                                                  GAsyncResult* _res_,
                                                  GError** error)
{
	GearyImapClientServiceReleaseSessionAsyncData* _data_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	if (NULL == _data_) {
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		return;
#line 1562 "imap-client-service.c"
	}
}

static void
geary_imap_client_service_release_session_async_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_)
{
	GearyImapClientServiceReleaseSessionAsyncData* _data_;
#line 249 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = _user_data_;
#line 249 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_source_object_ = source_object;
#line 249 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_res_ = _res_;
#line 249 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_release_session_async_co (_data_);
#line 1580 "imap-client-service.c"
}

static gboolean
geary_imap_client_service_release_session_async_co (GearyImapClientServiceReleaseSessionAsyncData* _data_)
{
#line 232 "../src/engine/imap/api/imap-client-service.vala"
	switch (_data_->_state_) {
#line 232 "../src/engine/imap/api/imap-client-service.vala"
		case 0:
#line 1590 "imap-client-service.c"
		goto _state_0;
#line 232 "../src/engine/imap/api/imap-client-service.vala"
		case 1:
#line 1594 "imap-client-service.c"
		goto _state_1;
#line 232 "../src/engine/imap/api/imap-client-service.vala"
		case 2:
#line 1598 "imap-client-service.c"
		goto _state_2;
#line 232 "../src/engine/imap/api/imap-client-service.vala"
		case 3:
#line 1602 "imap-client-service.c"
		goto _state_3;
		default:
#line 232 "../src/engine/imap/api/imap-client-service.vala"
		g_assert_not_reached ();
#line 1607 "imap-client-service.c"
	}
	_state_0:
#line 237 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp0_ = _data_->self->priv->free_queue;
#line 237 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp1_ = geary_nonblocking_queue_get_size (_data_->_tmp0_);
#line 237 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 237 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp3_ = _data_->self->priv->all_sessions;
#line 237 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp4_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 237 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 237 "../src/engine/imap/api/imap-client-service.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Returning session with %d of %d free", _data_->_tmp2_, _data_->_tmp5_);
#line 240 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp7_ = _data_->self->priv->free_queue;
#line 240 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp8_ = geary_nonblocking_queue_get_size (_data_->_tmp7_);
#line 240 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp9_ = _data_->_tmp8_;
#line 240 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp10_ = _data_->self->priv->_max_free_size;
#line 240 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_tmp9_ >= _data_->_tmp10_) {
#line 242 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp11_ = _data_->self->priv->all_sessions;
#line 242 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp12_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp11_, GEE_TYPE_COLLECTION, GeeCollection));
#line 242 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp13_ = _data_->_tmp12_;
#line 242 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp14_ = _data_->self->priv->_min_pool_size;
#line 242 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp6_ = _data_->_tmp13_ > _data_->_tmp14_;
#line 1644 "imap-client-service.c"
	} else {
#line 241 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp6_ = FALSE;
#line 1648 "imap-client-service.c"
	}
#line 240 "../src/engine/imap/api/imap-client-service.vala"
	_data_->too_many_free = _data_->_tmp6_;
#line 246 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->too_many_free) {
#line 246 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp17_ = TRUE;
#line 1656 "imap-client-service.c"
	} else {
#line 247 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp17_ = _data_->self->discard_returned_sessions;
#line 1660 "imap-client-service.c"
	}
#line 246 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_tmp17_) {
#line 246 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp16_ = TRUE;
#line 1666 "imap-client-service.c"
	} else {
#line 248 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp18_ = geary_client_service_get_is_running (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 248 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp19_ = _data_->_tmp18_;
#line 248 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp16_ = !_data_->_tmp19_;
#line 1674 "imap-client-service.c"
	}
#line 245 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_tmp16_) {
#line 246 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp15_ = TRUE;
#line 1680 "imap-client-service.c"
	} else {
#line 249 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_state_ = 1;
#line 249 "../src/engine/imap/api/imap-client-service.vala"
		geary_imap_client_service_check_session (_data_->self, _data_->session, FALSE, geary_imap_client_service_release_session_async_ready, _data_);
#line 249 "../src/engine/imap/api/imap-client-service.vala"
		return FALSE;
#line 1688 "imap-client-service.c"
		_state_1:
#line 249 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp15_ = !geary_imap_client_service_check_session_finish (_data_->self, _data_->_res_);
#line 1692 "imap-client-service.c"
	}
#line 245 "../src/engine/imap/api/imap-client-service.vala"
	_data_->disconnect = _data_->_tmp15_;
#line 252 "../src/engine/imap/api/imap-client-service.vala"
	if (!_data_->disconnect) {
#line 255 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp20_ = geary_imap_client_session_get_protocol_state (_data_->session);
#line 255 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp21_ = _data_->_tmp20_;
#line 255 "../src/engine/imap/api/imap-client-service.vala"
		_data_->proto = _data_->_tmp21_;
#line 256 "../src/engine/imap/api/imap-client-service.vala"
		if (_data_->proto == GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_SELECTED) {
#line 256 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp22_ = TRUE;
#line 1708 "imap-client-service.c"
		} else {
#line 257 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp22_ = _data_->proto == GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_SELECTING;
#line 1712 "imap-client-service.c"
		}
#line 256 "../src/engine/imap/api/imap-client-service.vala"
		if (_data_->_tmp22_) {
#line 1716 "imap-client-service.c"
			{
#line 260 "../src/engine/imap/api/imap-client-service.vala"
				_data_->_tmp23_ = _data_->self->priv->close_cancellable;
#line 260 "../src/engine/imap/api/imap-client-service.vala"
				_data_->_state_ = 2;
#line 260 "../src/engine/imap/api/imap-client-service.vala"
				geary_imap_client_session_close_mailbox_async (_data_->session, _data_->_tmp23_, geary_imap_client_service_release_session_async_ready, _data_);
#line 260 "../src/engine/imap/api/imap-client-service.vala"
				return FALSE;
#line 1726 "imap-client-service.c"
				_state_2:
#line 260 "../src/engine/imap/api/imap-client-service.vala"
				_data_->_tmp24_ = geary_imap_client_session_close_mailbox_finish (_data_->session, _data_->_res_, &_data_->_inner_error0_);
#line 260 "../src/engine/imap/api/imap-client-service.vala"
				_data_->_tmp25_ = _data_->_tmp24_;
#line 260 "../src/engine/imap/api/imap-client-service.vala"
				_g_object_unref0 (_data_->_tmp25_);
#line 260 "../src/engine/imap/api/imap-client-service.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 260 "../src/engine/imap/api/imap-client-service.vala"
					if (_data_->_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 1738 "imap-client-service.c"
						goto __catch0_geary_imap_error;
					}
					goto __finally0;
				}
			}
			goto __finally0;
			__catch0_geary_imap_error:
			{
#line 259 "../src/engine/imap/api/imap-client-service.vala"
				_data_->imap_error = _data_->_inner_error0_;
#line 259 "../src/engine/imap/api/imap-client-service.vala"
				_data_->_inner_error0_ = NULL;
#line 262 "../src/engine/imap/api/imap-client-service.vala"
				_data_->_tmp26_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->session, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 262 "../src/engine/imap/api/imap-client-service.vala"
				_data_->_tmp27_ = _data_->_tmp26_;
#line 262 "../src/engine/imap/api/imap-client-service.vala"
				_data_->_tmp28_ = _data_->imap_error;
#line 262 "../src/engine/imap/api/imap-client-service.vala"
				_data_->_tmp29_ = _data_->_tmp28_->message;
#line 262 "../src/engine/imap/api/imap-client-service.vala"
				geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Error attempting to close released session %s: %s", _data_->_tmp27_, _data_->_tmp29_);
#line 262 "../src/engine/imap/api/imap-client-service.vala"
				_g_free0 (_data_->_tmp27_);
#line 264 "../src/engine/imap/api/imap-client-service.vala"
				_data_->disconnect = TRUE;
#line 259 "../src/engine/imap/api/imap-client-service.vala"
				_g_error_free0 (_data_->imap_error);
#line 1767 "imap-client-service.c"
			}
			__finally0:
#line 259 "../src/engine/imap/api/imap-client-service.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 259 "../src/engine/imap/api/imap-client-service.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 259 "../src/engine/imap/api/imap-client-service.vala"
				g_object_unref (_data_->_async_result);
#line 259 "../src/engine/imap/api/imap-client-service.vala"
				return FALSE;
#line 1778 "imap-client-service.c"
			}
#line 266 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp30_ = geary_imap_client_session_get_protocol_state (_data_->session);
#line 266 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp31_ = _data_->_tmp30_;
#line 266 "../src/engine/imap/api/imap-client-service.vala"
			if (_data_->_tmp31_ != GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_AUTHORIZED) {
#line 269 "../src/engine/imap/api/imap-client-service.vala"
				_data_->disconnect = TRUE;
#line 1788 "imap-client-service.c"
			}
		}
#line 273 "../src/engine/imap/api/imap-client-service.vala"
		if (!_data_->disconnect) {
#line 274 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp32_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->session, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 274 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp33_ = _data_->_tmp32_;
#line 274 "../src/engine/imap/api/imap-client-service.vala"
			geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Unreserving session %s", _data_->_tmp33_);
#line 274 "../src/engine/imap/api/imap-client-service.vala"
			_g_free0 (_data_->_tmp33_);
#line 275 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp34_ = _data_->self->priv->free_queue;
#line 275 "../src/engine/imap/api/imap-client-service.vala"
			geary_nonblocking_queue_send (_data_->_tmp34_, _data_->session);
#line 1805 "imap-client-service.c"
		} else {
#line 277 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_state_ = 3;
#line 277 "../src/engine/imap/api/imap-client-service.vala"
			geary_imap_client_service_disconnect_session (_data_->self, _data_->session, geary_imap_client_service_release_session_async_ready, _data_);
#line 277 "../src/engine/imap/api/imap-client-service.vala"
			return FALSE;
#line 1813 "imap-client-service.c"
			_state_3:
#line 277 "../src/engine/imap/api/imap-client-service.vala"
			geary_imap_client_service_disconnect_session_finish (_data_->self, _data_->_res_);
#line 1817 "imap-client-service.c"
		}
	}
#line 232 "../src/engine/imap/api/imap-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 232 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_state_ != 0) {
#line 232 "../src/engine/imap/api/imap-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 232 "../src/engine/imap/api/imap-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1828 "imap-client-service.c"
		}
	}
#line 232 "../src/engine/imap/api/imap-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 232 "../src/engine/imap/api/imap-client-service.vala"
	return FALSE;
#line 1835 "imap-client-service.c"
}

/** Restarts the client session pool. */
static void
geary_imap_client_service_real_became_reachable (GearyClientService* base)
{
	GearyImapClientService * self;
#line 283 "../src/engine/imap/api/imap-client-service.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_IMAP_TYPE_CLIENT_SERVICE, GearyImapClientService);
#line 284 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_check_pool (self, FALSE, NULL, NULL);
#line 1847 "imap-client-service.c"
}

/** Closes the client session pool. */
static void
geary_imap_client_service_real_became_unreachable (GearyClientService* base)
{
	GearyImapClientService * self;
#line 288 "../src/engine/imap/api/imap-client-service.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_IMAP_TYPE_CLIENT_SERVICE, GearyImapClientService);
#line 289 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_close_pool (self, FALSE, NULL, NULL);
#line 1859 "imap-client-service.c"
}

static void
geary_imap_client_service_check_pool_data_free (gpointer _data)
{
	GearyImapClientServiceCheckPoolData* _data_;
	_data_ = _data;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_slice_free (GearyImapClientServiceCheckPoolData, _data_);
#line 1871 "imap-client-service.c"
}

static void
geary_imap_client_service_check_pool (GearyImapClientService* self,
                                      gboolean is_claiming,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	GearyImapClientServiceCheckPoolData* _data_;
	GearyImapClientService* _tmp0_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SERVICE (self));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = g_slice_new0 (GearyImapClientServiceCheckPoolData);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_service_check_pool_data_free);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->self = _tmp0_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->is_claiming = is_claiming;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_check_pool_co (_data_);
#line 1898 "imap-client-service.c"
}

static void
geary_imap_client_service_check_pool_finish (GearyImapClientService* self,
                                             GAsyncResult* _res_)
{
	GearyImapClientServiceCheckPoolData* _data_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1908 "imap-client-service.c"
}

static void
geary_imap_client_service_check_pool_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_)
{
	GearyImapClientServiceCheckPoolData* _data_;
#line 301 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = _user_data_;
#line 301 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_source_object_ = source_object;
#line 301 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_res_ = _res_;
#line 301 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_check_pool_co (_data_);
#line 1925 "imap-client-service.c"
}

static gboolean
geary_imap_client_service_check_pool_co (GearyImapClientServiceCheckPoolData* _data_)
{
#line 292 "../src/engine/imap/api/imap-client-service.vala"
	switch (_data_->_state_) {
#line 292 "../src/engine/imap/api/imap-client-service.vala"
		case 0:
#line 1935 "imap-client-service.c"
		goto _state_0;
#line 292 "../src/engine/imap/api/imap-client-service.vala"
		case 1:
#line 1939 "imap-client-service.c"
		goto _state_1;
		default:
#line 292 "../src/engine/imap/api/imap-client-service.vala"
		g_assert_not_reached ();
#line 1944 "imap-client-service.c"
	}
	_state_0:
#line 293 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp0_ = _data_->self->priv->free_queue;
#line 293 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp1_ = geary_nonblocking_queue_get_size (_data_->_tmp0_);
#line 293 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 293 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp3_ = _data_->self->priv->all_sessions;
#line 293 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp4_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 293 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 293 "../src/engine/imap/api/imap-client-service.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Checking session pool with %d of %d free", _data_->_tmp2_, _data_->_tmp5_);
#line 296 "../src/engine/imap/api/imap-client-service.vala"
	if (!_data_->is_claiming) {
#line 1963 "imap-client-service.c"
		{
#line 301 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp6_ = geary_client_service_get_account (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 301 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp7_ = _data_->_tmp6_;
#line 301 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp8_ = _data_->self->priv->pool_cancellable;
#line 301 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_state_ = 1;
#line 301 "../src/engine/imap/api/imap-client-service.vala"
			geary_account_information_load_incoming_credentials (_data_->_tmp7_, _data_->_tmp8_, geary_imap_client_service_check_pool_ready, _data_);
#line 301 "../src/engine/imap/api/imap-client-service.vala"
			return FALSE;
#line 1977 "imap-client-service.c"
			_state_1:
#line 301 "../src/engine/imap/api/imap-client-service.vala"
			_data_->loaded = geary_account_information_load_incoming_credentials_finish (_data_->_tmp7_, _data_->_res_, &_data_->_inner_error0_);
#line 301 "../src/engine/imap/api/imap-client-service.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1983 "imap-client-service.c"
				goto __catch0_g_error;
			}
#line 304 "../src/engine/imap/api/imap-client-service.vala"
			if (!_data_->loaded) {
#line 305 "../src/engine/imap/api/imap-client-service.vala"
				geary_client_service_notify_authentication_failed (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 306 "../src/engine/imap/api/imap-client-service.vala"
				g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 306 "../src/engine/imap/api/imap-client-service.vala"
				if (_data_->_state_ != 0) {
#line 306 "../src/engine/imap/api/imap-client-service.vala"
					while (!g_task_get_completed (_data_->_async_result)) {
#line 306 "../src/engine/imap/api/imap-client-service.vala"
						g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1998 "imap-client-service.c"
					}
				}
#line 306 "../src/engine/imap/api/imap-client-service.vala"
				g_object_unref (_data_->_async_result);
#line 306 "../src/engine/imap/api/imap-client-service.vala"
				return FALSE;
#line 2005 "imap-client-service.c"
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 300 "../src/engine/imap/api/imap-client-service.vala"
			_data_->err = _data_->_inner_error0_;
#line 300 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_inner_error0_ = NULL;
#line 309 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp9_ = _data_->err;
#line 309 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp10_ = geary_error_context_new (_data_->_tmp9_);
#line 309 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp11_ = _data_->_tmp10_;
#line 309 "../src/engine/imap/api/imap-client-service.vala"
			geary_client_service_notify_connection_failed (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService), _data_->_tmp11_);
#line 309 "../src/engine/imap/api/imap-client-service.vala"
			_g_object_unref0 (_data_->_tmp11_);
#line 310 "../src/engine/imap/api/imap-client-service.vala"
			_g_error_free0 (_data_->err);
#line 310 "../src/engine/imap/api/imap-client-service.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 310 "../src/engine/imap/api/imap-client-service.vala"
			if (_data_->_state_ != 0) {
#line 310 "../src/engine/imap/api/imap-client-service.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 310 "../src/engine/imap/api/imap-client-service.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2035 "imap-client-service.c"
				}
			}
#line 310 "../src/engine/imap/api/imap-client-service.vala"
			g_object_unref (_data_->_async_result);
#line 310 "../src/engine/imap/api/imap-client-service.vala"
			return FALSE;
#line 2042 "imap-client-service.c"
		}
		__finally0:
#line 300 "../src/engine/imap/api/imap-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 300 "../src/engine/imap/api/imap-client-service.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 300 "../src/engine/imap/api/imap-client-service.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 300 "../src/engine/imap/api/imap-client-service.vala"
			g_object_unref (_data_->_async_result);
#line 300 "../src/engine/imap/api/imap-client-service.vala"
			return FALSE;
#line 2055 "imap-client-service.c"
		}
	}
#line 314 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp12_ = _data_->self->priv->_min_pool_size;
#line 314 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp13_ = _data_->self->priv->all_sessions;
#line 314 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp14_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp13_, GEE_TYPE_COLLECTION, GeeCollection));
#line 314 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp15_ = _data_->_tmp14_;
#line 314 "../src/engine/imap/api/imap-client-service.vala"
	_data_->needed = _data_->_tmp12_ - _data_->_tmp15_;
#line 315 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->needed <= 0) {
#line 315 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp16_ = _data_->is_claiming;
#line 2072 "imap-client-service.c"
	} else {
#line 315 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp16_ = FALSE;
#line 2076 "imap-client-service.c"
	}
#line 315 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_tmp16_) {
#line 316 "../src/engine/imap/api/imap-client-service.vala"
		_data_->needed = 1;
#line 2082 "imap-client-service.c"
	}
#line 320 "../src/engine/imap/api/imap-client-service.vala"
	while (TRUE) {
#line 320 "../src/engine/imap/api/imap-client-service.vala"
		if (!(_data_->needed > 0)) {
#line 320 "../src/engine/imap/api/imap-client-service.vala"
			break;
#line 2090 "imap-client-service.c"
		}
#line 321 "../src/engine/imap/api/imap-client-service.vala"
		geary_imap_client_service_add_pool_session (_data_->self, NULL, NULL);
#line 322 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp17_ = _data_->needed;
#line 322 "../src/engine/imap/api/imap-client-service.vala"
		_data_->needed = _data_->_tmp17_ - 1;
#line 2098 "imap-client-service.c"
	}
#line 292 "../src/engine/imap/api/imap-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 292 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_state_ != 0) {
#line 292 "../src/engine/imap/api/imap-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 292 "../src/engine/imap/api/imap-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2108 "imap-client-service.c"
		}
	}
#line 292 "../src/engine/imap/api/imap-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 292 "../src/engine/imap/api/imap-client-service.vala"
	return FALSE;
#line 2115 "imap-client-service.c"
}

static void
geary_imap_client_service_add_pool_session_data_free (gpointer _data)
{
	GearyImapClientServiceAddPoolSessionData* _data_;
	_data_ = _data;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_slice_free (GearyImapClientServiceAddPoolSessionData, _data_);
#line 2127 "imap-client-service.c"
}

static void
geary_imap_client_service_add_pool_session (GearyImapClientService* self,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	GearyImapClientServiceAddPoolSessionData* _data_;
	GearyImapClientService* _tmp0_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SERVICE (self));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = g_slice_new0 (GearyImapClientServiceAddPoolSessionData);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_service_add_pool_session_data_free);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->self = _tmp0_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_add_pool_session_co (_data_);
#line 2151 "imap-client-service.c"
}

static void
geary_imap_client_service_add_pool_session_finish (GearyImapClientService* self,
                                                   GAsyncResult* _res_)
{
	GearyImapClientServiceAddPoolSessionData* _data_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2161 "imap-client-service.c"
}

static Block25Data*
block25_data_ref (Block25Data* _data25_)
{
#line 326 "../src/engine/imap/api/imap-client-service.vala"
	g_atomic_int_inc (&_data25_->_ref_count_);
#line 326 "../src/engine/imap/api/imap-client-service.vala"
	return _data25_;
#line 2171 "imap-client-service.c"
}

static void
block25_data_unref (void * _userdata_)
{
	Block25Data* _data25_;
	_data25_ = (Block25Data*) _userdata_;
#line 326 "../src/engine/imap/api/imap-client-service.vala"
	if (g_atomic_int_dec_and_test (&_data25_->_ref_count_)) {
#line 2181 "imap-client-service.c"
		GearyImapClientService* self;
#line 326 "../src/engine/imap/api/imap-client-service.vala"
		self = _data25_->self;
#line 326 "../src/engine/imap/api/imap-client-service.vala"
		_g_object_unref0 (_data25_->new_session);
#line 326 "../src/engine/imap/api/imap-client-service.vala"
		_g_object_unref0 (self);
#line 326 "../src/engine/imap/api/imap-client-service.vala"
		g_slice_free (Block25Data, _data25_);
#line 2191 "imap-client-service.c"
	}
}

static void
geary_imap_client_service_add_pool_session_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_)
{
	GearyImapClientServiceAddPoolSessionData* _data_;
#line 329 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = _user_data_;
#line 329 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_source_object_ = source_object;
#line 329 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_res_ = _res_;
#line 329 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_add_pool_session_co (_data_);
#line 2209 "imap-client-service.c"
}

static void
____lambda108_ (Block25Data* _data25_,
                GError** error)
{
	GearyImapClientService* self;
	GeeSet* _tmp0_;
	GearyImapClientSession* _tmp1_;
#line 355 "../src/engine/imap/api/imap-client-service.vala"
	self = _data25_->self;
#line 356 "../src/engine/imap/api/imap-client-service.vala"
	_tmp0_ = self->priv->all_sessions;
#line 356 "../src/engine/imap/api/imap-client-service.vala"
	_tmp1_ = _data25_->new_session;
#line 356 "../src/engine/imap/api/imap-client-service.vala"
	gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), _tmp1_);
#line 2227 "imap-client-service.c"
}

static void
_____lambda108__geary_nonblocking_mutex_critical_section (gpointer self,
                                                          GError** error)
{
#line 355 "../src/engine/imap/api/imap-client-service.vala"
	____lambda108_ (self, error);
#line 2236 "imap-client-service.c"
}

static gboolean
geary_imap_client_service_add_pool_session_co (GearyImapClientServiceAddPoolSessionData* _data_)
{
#line 326 "../src/engine/imap/api/imap-client-service.vala"
	switch (_data_->_state_) {
#line 326 "../src/engine/imap/api/imap-client-service.vala"
		case 0:
#line 2246 "imap-client-service.c"
		goto _state_0;
#line 326 "../src/engine/imap/api/imap-client-service.vala"
		case 1:
#line 2250 "imap-client-service.c"
		goto _state_1;
#line 326 "../src/engine/imap/api/imap-client-service.vala"
		case 2:
#line 2254 "imap-client-service.c"
		goto _state_2;
		default:
#line 326 "../src/engine/imap/api/imap-client-service.vala"
		g_assert_not_reached ();
#line 2259 "imap-client-service.c"
	}
	_state_0:
#line 326 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_data25_ = g_slice_new0 (Block25Data);
#line 326 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_data25_->_ref_count_ = 1;
#line 326 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_data25_->self = g_object_ref (_data_->self);
#line 326 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_data25_->_async_data_ = _data_;
#line 327 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_data25_->new_session = NULL;
#line 2272 "imap-client-service.c"
	{
#line 329 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp1_ = _data_->self->priv->pool_cancellable;
#line 329 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_state_ = 1;
#line 329 "../src/engine/imap/api/imap-client-service.vala"
		geary_imap_client_service_create_new_authorized_session (_data_->self, _data_->_tmp1_, geary_imap_client_service_add_pool_session_ready, _data_);
#line 329 "../src/engine/imap/api/imap-client-service.vala"
		return FALSE;
#line 2282 "imap-client-service.c"
		_state_1:
#line 329 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp2_ = geary_imap_client_service_create_new_authorized_session_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 329 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp0_ = _data_->_tmp2_;
#line 329 "../src/engine/imap/api/imap-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 329 "../src/engine/imap/api/imap-client-service.vala"
			if (g_error_matches (_data_->_inner_error0_, GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_UNAUTHENTICATED)) {
#line 2292 "imap-client-service.c"
				goto __catch0_geary_imap_error_unauthenticated;
			}
#line 329 "../src/engine/imap/api/imap-client-service.vala"
			if (g_error_matches (_data_->_inner_error0_, G_TLS_ERROR, G_TLS_ERROR_BAD_CERTIFICATE)) {
#line 2297 "imap-client-service.c"
				goto __catch0_g_tls_error_bad_certificate;
			}
#line 329 "../src/engine/imap/api/imap-client-service.vala"
			if (g_error_matches (_data_->_inner_error0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 2302 "imap-client-service.c"
				goto __catch0_g_io_error_cancelled;
			}
			goto __catch0_g_error;
		}
#line 329 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp3_ = _data_->_tmp0_;
#line 329 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp0_ = NULL;
#line 329 "../src/engine/imap/api/imap-client-service.vala"
		_g_object_unref0 (_data_->_data25_->new_session);
#line 329 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_data25_->new_session = _data_->_tmp3_;
#line 328 "../src/engine/imap/api/imap-client-service.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 2317 "imap-client-service.c"
	}
	goto __finally0;
	__catch0_geary_imap_error_unauthenticated:
	{
#line 328 "../src/engine/imap/api/imap-client-service.vala"
		_data_->err = _data_->_inner_error0_;
#line 328 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_inner_error0_ = NULL;
#line 333 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp4_ = _data_->err;
#line 333 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp5_ = _data_->_tmp4_->message;
#line 333 "../src/engine/imap/api/imap-client-service.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Auth error adding new session to the pool: %s", _data_->_tmp5_);
#line 334 "../src/engine/imap/api/imap-client-service.vala"
		geary_client_service_notify_authentication_failed (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 328 "../src/engine/imap/api/imap-client-service.vala"
		_g_error_free0 (_data_->err);
#line 2336 "imap-client-service.c"
	}
	goto __finally0;
	__catch0_g_tls_error_bad_certificate:
	{
#line 328 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_vala1_err = _data_->_inner_error0_;
#line 328 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_inner_error0_ = NULL;
#line 338 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp6_ = _data_->_vala1_err;
#line 338 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp7_ = _data_->_tmp6_->message;
#line 338 "../src/engine/imap/api/imap-client-service.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "TLS validation error adding new session to the pool: %s", _data_->_tmp7_);
#line 328 "../src/engine/imap/api/imap-client-service.vala"
		_g_error_free0 (_data_->_vala1_err);
#line 2353 "imap-client-service.c"
	}
	goto __finally0;
	__catch0_g_io_error_cancelled:
	{
#line 328 "../src/engine/imap/api/imap-client-service.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 2360 "imap-client-service.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 328 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_vala2_err = _data_->_inner_error0_;
#line 328 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_inner_error0_ = NULL;
#line 343 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp8_ = _data_->_vala2_err;
#line 343 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp9_ = geary_error_context_new (_data_->_tmp8_);
#line 343 "../src/engine/imap/api/imap-client-service.vala"
		_data_->context = _data_->_tmp9_;
#line 344 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp10_ = _data_->context;
#line 344 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp11_ = geary_error_context_format_full_error (_data_->_tmp10_);
#line 344 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp12_ = _data_->_tmp11_;
#line 344 "../src/engine/imap/api/imap-client-service.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Error creating new session for the pool: %s", _data_->_tmp12_);
#line 344 "../src/engine/imap/api/imap-client-service.vala"
		_g_free0 (_data_->_tmp12_);
#line 346 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp13_ = _data_->context;
#line 346 "../src/engine/imap/api/imap-client-service.vala"
		geary_client_service_notify_connection_failed (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService), _data_->_tmp13_);
#line 328 "../src/engine/imap/api/imap-client-service.vala"
		_g_object_unref0 (_data_->context);
#line 328 "../src/engine/imap/api/imap-client-service.vala"
		_g_error_free0 (_data_->_vala2_err);
#line 2393 "imap-client-service.c"
	}
	__finally0:
#line 328 "../src/engine/imap/api/imap-client-service.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 328 "../src/engine/imap/api/imap-client-service.vala"
		block25_data_unref (_data_->_data25_);
#line 328 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_data25_ = NULL;
#line 328 "../src/engine/imap/api/imap-client-service.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 328 "../src/engine/imap/api/imap-client-service.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 328 "../src/engine/imap/api/imap-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 328 "../src/engine/imap/api/imap-client-service.vala"
		return FALSE;
#line 2410 "imap-client-service.c"
	}
#line 349 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp14_ = _data_->_data25_->new_session;
#line 349 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_tmp14_ == NULL) {
#line 351 "../src/engine/imap/api/imap-client-service.vala"
		geary_imap_client_service_close_pool (_data_->self, TRUE, NULL, NULL);
#line 2418 "imap-client-service.c"
	} else {
#line 353 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp15_ = _data_->self->priv->quirks;
#line 353 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp16_ = _data_->_data25_->new_session;
#line 353 "../src/engine/imap/api/imap-client-service.vala"
		geary_imap_quirks_update_for_server (_data_->_tmp15_, _data_->_tmp16_);
#line 2426 "imap-client-service.c"
		{
#line 355 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp17_ = _data_->self->priv->sessions_mutex;
#line 355 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_state_ = 2;
#line 355 "../src/engine/imap/api/imap-client-service.vala"
			geary_nonblocking_mutex_execute_locked (_data_->_tmp17_, _____lambda108__geary_nonblocking_mutex_critical_section, _data_->_data25_, NULL, geary_imap_client_service_add_pool_session_ready, _data_);
#line 355 "../src/engine/imap/api/imap-client-service.vala"
			return FALSE;
#line 2436 "imap-client-service.c"
			_state_2:
#line 355 "../src/engine/imap/api/imap-client-service.vala"
			geary_nonblocking_mutex_execute_locked_finish (_data_->_tmp17_, _data_->_res_, &_data_->_inner_error0_);
#line 355 "../src/engine/imap/api/imap-client-service.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2442 "imap-client-service.c"
				goto __catch1_g_error;
			}
#line 358 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp18_ = _data_->self->priv->free_queue;
#line 358 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp19_ = _data_->_data25_->new_session;
#line 358 "../src/engine/imap/api/imap-client-service.vala"
			geary_nonblocking_queue_send (_data_->_tmp18_, _data_->_tmp19_);
#line 359 "../src/engine/imap/api/imap-client-service.vala"
			geary_client_service_notify_connected (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 2453 "imap-client-service.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
#line 354 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_vala3_err = _data_->_inner_error0_;
#line 354 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_inner_error0_ = NULL;
#line 361 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp20_ = _data_->_vala3_err;
#line 361 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp21_ = geary_error_context_new (_data_->_tmp20_);
#line 361 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_vala1_context = _data_->_tmp21_;
#line 362 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp22_ = _data_->_vala1_context;
#line 362 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp23_ = geary_error_context_format_full_error (_data_->_tmp22_);
#line 362 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp24_ = _data_->_tmp23_;
#line 362 "../src/engine/imap/api/imap-client-service.vala"
			geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Error adding new session to the pool: %s", _data_->_tmp24_);
#line 362 "../src/engine/imap/api/imap-client-service.vala"
			_g_free0 (_data_->_tmp24_);
#line 364 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp25_ = _data_->_vala1_context;
#line 364 "../src/engine/imap/api/imap-client-service.vala"
			geary_client_service_notify_connection_failed (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService), _data_->_tmp25_);
#line 365 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp26_ = _data_->_data25_->new_session;
#line 365 "../src/engine/imap/api/imap-client-service.vala"
			geary_imap_client_session_disconnect_async (_data_->_tmp26_, NULL, NULL, NULL);
#line 366 "../src/engine/imap/api/imap-client-service.vala"
			geary_imap_client_service_close_pool (_data_->self, TRUE, NULL, NULL);
#line 354 "../src/engine/imap/api/imap-client-service.vala"
			_g_object_unref0 (_data_->_vala1_context);
#line 354 "../src/engine/imap/api/imap-client-service.vala"
			_g_error_free0 (_data_->_vala3_err);
#line 2492 "imap-client-service.c"
		}
		__finally1:
#line 354 "../src/engine/imap/api/imap-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 354 "../src/engine/imap/api/imap-client-service.vala"
			block25_data_unref (_data_->_data25_);
#line 354 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_data25_ = NULL;
#line 354 "../src/engine/imap/api/imap-client-service.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 354 "../src/engine/imap/api/imap-client-service.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 354 "../src/engine/imap/api/imap-client-service.vala"
			g_object_unref (_data_->_async_result);
#line 354 "../src/engine/imap/api/imap-client-service.vala"
			return FALSE;
#line 2509 "imap-client-service.c"
		}
	}
#line 326 "../src/engine/imap/api/imap-client-service.vala"
	block25_data_unref (_data_->_data25_);
#line 326 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_data25_ = NULL;
#line 326 "../src/engine/imap/api/imap-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 326 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_state_ != 0) {
#line 326 "../src/engine/imap/api/imap-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 326 "../src/engine/imap/api/imap-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2524 "imap-client-service.c"
		}
	}
#line 326 "../src/engine/imap/api/imap-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 326 "../src/engine/imap/api/imap-client-service.vala"
	return FALSE;
#line 2531 "imap-client-service.c"
}

static void
geary_imap_client_service_check_session_data_free (gpointer _data)
{
	GearyImapClientServiceCheckSessionData* _data_;
	_data_ = _data;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->target);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_slice_free (GearyImapClientServiceCheckSessionData, _data_);
#line 2545 "imap-client-service.c"
}

static void
geary_imap_client_service_check_session (GearyImapClientService* self,
                                         GearyImapClientSession* target,
                                         gboolean claiming,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	GearyImapClientServiceCheckSessionData* _data_;
	GearyImapClientService* _tmp0_;
	GearyImapClientSession* _tmp1_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SERVICE (self));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (target));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = g_slice_new0 (GearyImapClientServiceCheckSessionData);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_service_check_session_data_free);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->self = _tmp0_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_tmp1_ = _g_object_ref0 (target);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->target);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->target = _tmp1_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->claiming = claiming;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_check_session_co (_data_);
#line 2582 "imap-client-service.c"
}

static gboolean
geary_imap_client_service_check_session_finish (GearyImapClientService* self,
                                                GAsyncResult* _res_)
{
	gboolean result;
	GearyImapClientServiceCheckSessionData* _data_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	result = _data_->result;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	return result;
#line 2597 "imap-client-service.c"
}

/** Determines if a session is valid, disposing of it if not. */
static void
geary_imap_client_service_check_session_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_)
{
	GearyImapClientServiceCheckSessionData* _data_;
#line 383 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = _user_data_;
#line 383 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_source_object_ = source_object;
#line 383 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_res_ = _res_;
#line 383 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_check_session_co (_data_);
#line 2615 "imap-client-service.c"
}

static gboolean
geary_imap_client_service_check_session_co (GearyImapClientServiceCheckSessionData* _data_)
{
#line 372 "../src/engine/imap/api/imap-client-service.vala"
	switch (_data_->_state_) {
#line 372 "../src/engine/imap/api/imap-client-service.vala"
		case 0:
#line 2625 "imap-client-service.c"
		goto _state_0;
#line 372 "../src/engine/imap/api/imap-client-service.vala"
		case 1:
#line 2629 "imap-client-service.c"
		goto _state_1;
#line 372 "../src/engine/imap/api/imap-client-service.vala"
		case 2:
#line 2633 "imap-client-service.c"
		goto _state_2;
#line 372 "../src/engine/imap/api/imap-client-service.vala"
		case 3:
#line 2637 "imap-client-service.c"
		goto _state_3;
		default:
#line 372 "../src/engine/imap/api/imap-client-service.vala"
		g_assert_not_reached ();
#line 2642 "imap-client-service.c"
	}
	_state_0:
#line 373 "../src/engine/imap/api/imap-client-service.vala"
	_data_->valid = FALSE;
#line 374 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp0_ = geary_imap_client_session_get_protocol_state (_data_->target);
#line 374 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 374 "../src/engine/imap/api/imap-client-service.vala"
	switch (_data_->_tmp1_) {
#line 374 "../src/engine/imap/api/imap-client-service.vala"
		case GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_AUTHORIZED:
#line 374 "../src/engine/imap/api/imap-client-service.vala"
		case GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_CLOSING_MAILBOX:
#line 2657 "imap-client-service.c"
		{
#line 377 "../src/engine/imap/api/imap-client-service.vala"
			_data_->valid = TRUE;
#line 378 "../src/engine/imap/api/imap-client-service.vala"
			break;
#line 2663 "imap-client-service.c"
		}
#line 374 "../src/engine/imap/api/imap-client-service.vala"
		case GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_SELECTED:
#line 374 "../src/engine/imap/api/imap-client-service.vala"
		case GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_SELECTING:
#line 2669 "imap-client-service.c"
		{
#line 382 "../src/engine/imap/api/imap-client-service.vala"
			if (_data_->claiming) {
#line 383 "../src/engine/imap/api/imap-client-service.vala"
				_data_->_state_ = 1;
#line 383 "../src/engine/imap/api/imap-client-service.vala"
				geary_imap_client_service_disconnect_session (_data_->self, _data_->target, geary_imap_client_service_check_session_ready, _data_);
#line 383 "../src/engine/imap/api/imap-client-service.vala"
				return FALSE;
#line 2679 "imap-client-service.c"
				_state_1:
#line 383 "../src/engine/imap/api/imap-client-service.vala"
				geary_imap_client_service_disconnect_session_finish (_data_->self, _data_->_res_);
#line 2683 "imap-client-service.c"
			} else {
#line 385 "../src/engine/imap/api/imap-client-service.vala"
				_data_->valid = TRUE;
#line 2687 "imap-client-service.c"
			}
#line 387 "../src/engine/imap/api/imap-client-service.vala"
			break;
#line 2691 "imap-client-service.c"
		}
		default:
		{
#line 390 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_state_ = 2;
#line 390 "../src/engine/imap/api/imap-client-service.vala"
			geary_imap_client_service_disconnect_session (_data_->self, _data_->target, geary_imap_client_service_check_session_ready, _data_);
#line 390 "../src/engine/imap/api/imap-client-service.vala"
			return FALSE;
#line 2701 "imap-client-service.c"
			_state_2:
#line 390 "../src/engine/imap/api/imap-client-service.vala"
			geary_imap_client_service_disconnect_session_finish (_data_->self, _data_->_res_);
#line 391 "../src/engine/imap/api/imap-client-service.vala"
			break;
#line 2707 "imap-client-service.c"
		}
	}
#line 406 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->claiming) {
#line 407 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp3_ = geary_imap_client_session_get_last_seen (_data_->target);
#line 407 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 407 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp2_ = (_data_->_tmp4_ + (GEARY_IMAP_CLIENT_SERVICE_CHECK_NOOP_THRESHOLD_SEC * 1000000)) < g_get_real_time ();
#line 2718 "imap-client-service.c"
	} else {
#line 406 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp2_ = FALSE;
#line 2722 "imap-client-service.c"
	}
#line 406 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_tmp2_) {
#line 2726 "imap-client-service.c"
		{
#line 409 "../src/engine/imap/api/imap-client-service.vala"
			geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Sending NOOP when claiming a session");
#line 410 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp5_ = _data_->self->priv->close_cancellable;
#line 410 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp6_ = geary_imap_noop_command_new (_data_->_tmp5_);
#line 410 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp7_ = _data_->_tmp6_;
#line 410 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_state_ = 3;
#line 410 "../src/engine/imap/api/imap-client-service.vala"
			geary_imap_client_session_send_command_async (_data_->target, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp7_, GEARY_IMAP_TYPE_COMMAND, GearyImapCommand), geary_imap_client_service_check_session_ready, _data_);
#line 410 "../src/engine/imap/api/imap-client-service.vala"
			return FALSE;
#line 2742 "imap-client-service.c"
			_state_3:
#line 410 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp8_ = geary_imap_client_session_send_command_finish (_data_->target, _data_->_res_, &_data_->_inner_error0_);
#line 410 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp9_ = _data_->_tmp8_;
#line 410 "../src/engine/imap/api/imap-client-service.vala"
			_g_object_unref0 (_data_->_tmp9_);
#line 410 "../src/engine/imap/api/imap-client-service.vala"
			_g_object_unref0 (_data_->_tmp7_);
#line 410 "../src/engine/imap/api/imap-client-service.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2754 "imap-client-service.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 408 "../src/engine/imap/api/imap-client-service.vala"
			_data_->err = _data_->_inner_error0_;
#line 408 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_inner_error0_ = NULL;
#line 414 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp10_ = _data_->err;
#line 414 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp11_ = _data_->_tmp10_->message;
#line 414 "../src/engine/imap/api/imap-client-service.vala"
			geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Error sending NOOP: %s", _data_->_tmp11_);
#line 415 "../src/engine/imap/api/imap-client-service.vala"
			_data_->valid = FALSE;
#line 408 "../src/engine/imap/api/imap-client-service.vala"
			_g_error_free0 (_data_->err);
#line 2775 "imap-client-service.c"
		}
		__finally0:
#line 408 "../src/engine/imap/api/imap-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 408 "../src/engine/imap/api/imap-client-service.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 408 "../src/engine/imap/api/imap-client-service.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 408 "../src/engine/imap/api/imap-client-service.vala"
			g_object_unref (_data_->_async_result);
#line 408 "../src/engine/imap/api/imap-client-service.vala"
			return FALSE;
#line 2788 "imap-client-service.c"
		}
	}
#line 419 "../src/engine/imap/api/imap-client-service.vala"
	_data_->result = _data_->valid;
#line 419 "../src/engine/imap/api/imap-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 419 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_state_ != 0) {
#line 419 "../src/engine/imap/api/imap-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 419 "../src/engine/imap/api/imap-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2801 "imap-client-service.c"
		}
	}
#line 419 "../src/engine/imap/api/imap-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 419 "../src/engine/imap/api/imap-client-service.vala"
	return FALSE;
#line 2808 "imap-client-service.c"
}

static void
geary_imap_client_service_create_new_authorized_session_data_free (gpointer _data)
{
	GearyImapClientServiceCreateNewAuthorizedSessionData* _data_;
	_data_ = _data;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->result);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_slice_free (GearyImapClientServiceCreateNewAuthorizedSessionData, _data_);
#line 2824 "imap-client-service.c"
}

static void
geary_imap_client_service_create_new_authorized_session (GearyImapClientService* self,
                                                         GCancellable* cancellable,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_)
{
	GearyImapClientServiceCreateNewAuthorizedSessionData* _data_;
	GearyImapClientService* _tmp0_;
	GCancellable* _tmp1_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SERVICE (self));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = g_slice_new0 (GearyImapClientServiceCreateNewAuthorizedSessionData);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_service_create_new_authorized_session_data_free);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->self = _tmp0_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->cancellable = _tmp1_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_create_new_authorized_session_co (_data_);
#line 2858 "imap-client-service.c"
}

static GearyImapClientSession*
geary_imap_client_service_create_new_authorized_session_finish (GearyImapClientService* self,
                                                                GAsyncResult* _res_,
                                                                GError** error)
{
	GearyImapClientSession* result;
	GearyImapClientServiceCreateNewAuthorizedSessionData* _data_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	if (NULL == _data_) {
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		return NULL;
#line 2874 "imap-client-service.c"
	}
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	result = _data_->result;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->result = NULL;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	return result;
#line 2882 "imap-client-service.c"
}

static void
geary_imap_client_service_create_new_authorized_session_ready (GObject* source_object,
                                                               GAsyncResult* _res_,
                                                               gpointer _user_data_)
{
	GearyImapClientServiceCreateNewAuthorizedSessionData* _data_;
#line 431 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = _user_data_;
#line 431 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_source_object_ = source_object;
#line 431 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_res_ = _res_;
#line 431 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_create_new_authorized_session_co (_data_);
#line 2899 "imap-client-service.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 448 "../src/engine/imap/api/imap-client-service.vala"
	return self ? g_error_copy (self) : NULL;
#line 2907 "imap-client-service.c"
}

static void
_geary_imap_client_service_on_session_disconnected_g_object_notify (GObject* _sender,
                                                                    GParamSpec* pspec,
                                                                    gpointer self)
{
#line 453 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_on_session_disconnected ((GearyImapClientService*) self, _sender, pspec);
#line 2917 "imap-client-service.c"
}

static gboolean
geary_imap_client_service_create_new_authorized_session_co (GearyImapClientServiceCreateNewAuthorizedSessionData* _data_)
{
#line 422 "../src/engine/imap/api/imap-client-service.vala"
	switch (_data_->_state_) {
#line 422 "../src/engine/imap/api/imap-client-service.vala"
		case 0:
#line 2927 "imap-client-service.c"
		goto _state_0;
#line 422 "../src/engine/imap/api/imap-client-service.vala"
		case 1:
#line 2931 "imap-client-service.c"
		goto _state_1;
#line 422 "../src/engine/imap/api/imap-client-service.vala"
		case 2:
#line 2935 "imap-client-service.c"
		goto _state_2;
#line 422 "../src/engine/imap/api/imap-client-service.vala"
		case 3:
#line 2939 "imap-client-service.c"
		goto _state_3;
		default:
#line 422 "../src/engine/imap/api/imap-client-service.vala"
		g_assert_not_reached ();
#line 2944 "imap-client-service.c"
	}
	_state_0:
#line 423 "../src/engine/imap/api/imap-client-service.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Opening new session");
#line 424 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp0_ = geary_client_service_get_configuration (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 424 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 424 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp2_ = geary_service_information_get_credentials (_data_->_tmp1_);
#line 424 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 424 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp4_ = _g_object_ref0 (_data_->_tmp3_);
#line 424 "../src/engine/imap/api/imap-client-service.vala"
	_data_->login = _data_->_tmp4_;
#line 425 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp6_ = _data_->login;
#line 425 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_tmp6_ != NULL) {
#line 425 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp7_ = _data_->login;
#line 425 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp5_ = !geary_credentials_is_complete (_data_->_tmp7_);
#line 2969 "imap-client-service.c"
	} else {
#line 425 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp5_ = FALSE;
#line 2973 "imap-client-service.c"
	}
#line 425 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_tmp5_) {
#line 426 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp8_ = g_error_new_literal (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_UNAUTHENTICATED, "Token not loaded");
#line 426 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_inner_error0_ = _data_->_tmp8_;
#line 426 "../src/engine/imap/api/imap-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 426 "../src/engine/imap/api/imap-client-service.vala"
		_g_object_unref0 (_data_->login);
#line 426 "../src/engine/imap/api/imap-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 426 "../src/engine/imap/api/imap-client-service.vala"
		return FALSE;
#line 2989 "imap-client-service.c"
	}
#line 429 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp9_ = geary_client_service_get_remote (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 429 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 429 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp11_ = _data_->self->priv->quirks;
#line 429 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp12_ = geary_imap_client_session_new (_data_->_tmp10_, _data_->_tmp11_);
#line 429 "../src/engine/imap/api/imap-client-service.vala"
	_data_->new_session = _data_->_tmp12_;
#line 430 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp13_ = _data_->new_session;
#line 430 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_session_set_logging_parent (_data_->_tmp13_, G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 431 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp14_ = _data_->new_session;
#line 431 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_state_ = 1;
#line 431 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_session_connect_async (_data_->_tmp14_, GEARY_IMAP_CLIENT_SESSION_DEFAULT_GREETING_TIMEOUT_SEC, _data_->cancellable, geary_imap_client_service_create_new_authorized_session_ready, _data_);
#line 431 "../src/engine/imap/api/imap-client-service.vala"
	return FALSE;
#line 3013 "imap-client-service.c"
	_state_1:
#line 431 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_session_connect_finish (_data_->_tmp14_, _data_->_res_, &_data_->_inner_error0_);
#line 431 "../src/engine/imap/api/imap-client-service.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 431 "../src/engine/imap/api/imap-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 431 "../src/engine/imap/api/imap-client-service.vala"
		_g_object_unref0 (_data_->new_session);
#line 431 "../src/engine/imap/api/imap-client-service.vala"
		_g_object_unref0 (_data_->login);
#line 431 "../src/engine/imap/api/imap-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 431 "../src/engine/imap/api/imap-client-service.vala"
		return FALSE;
#line 3029 "imap-client-service.c"
	}
	{
#line 436 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp15_ = _data_->new_session;
#line 436 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp16_ = _data_->login;
#line 436 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_state_ = 2;
#line 436 "../src/engine/imap/api/imap-client-service.vala"
		geary_imap_client_session_initiate_session_async (_data_->_tmp15_, _data_->_tmp16_, _data_->cancellable, geary_imap_client_service_create_new_authorized_session_ready, _data_);
#line 436 "../src/engine/imap/api/imap-client-service.vala"
		return FALSE;
#line 3042 "imap-client-service.c"
		_state_2:
#line 436 "../src/engine/imap/api/imap-client-service.vala"
		geary_imap_client_session_initiate_session_finish (_data_->_tmp15_, _data_->_res_, &_data_->_inner_error0_);
#line 436 "../src/engine/imap/api/imap-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3048 "imap-client-service.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 435 "../src/engine/imap/api/imap-client-service.vala"
		_data_->err = _data_->_inner_error0_;
#line 435 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_inner_error0_ = NULL;
#line 3059 "imap-client-service.c"
		{
#line 442 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp17_ = _data_->new_session;
#line 442 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_state_ = 3;
#line 442 "../src/engine/imap/api/imap-client-service.vala"
			geary_imap_client_session_disconnect_async (_data_->_tmp17_, NULL, geary_imap_client_service_create_new_authorized_session_ready, _data_);
#line 442 "../src/engine/imap/api/imap-client-service.vala"
			return FALSE;
#line 3069 "imap-client-service.c"
			_state_3:
#line 442 "../src/engine/imap/api/imap-client-service.vala"
			geary_imap_client_session_disconnect_finish (_data_->_tmp17_, _data_->_res_, &_data_->_inner_error0_);
#line 442 "../src/engine/imap/api/imap-client-service.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3075 "imap-client-service.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
#line 441 "../src/engine/imap/api/imap-client-service.vala"
			_data_->disconnect_err = _data_->_inner_error0_;
#line 441 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_inner_error0_ = NULL;
#line 444 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp18_ = _data_->disconnect_err;
#line 444 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp19_ = _data_->_tmp18_->message;
#line 444 "../src/engine/imap/api/imap-client-service.vala"
			geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Error disconnecting due to session initiation failure, ignored: %s", _data_->_tmp19_);
#line 441 "../src/engine/imap/api/imap-client-service.vala"
			_g_error_free0 (_data_->disconnect_err);
#line 3094 "imap-client-service.c"
		}
		__finally1:
#line 441 "../src/engine/imap/api/imap-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 441 "../src/engine/imap/api/imap-client-service.vala"
			_g_error_free0 (_data_->err);
#line 441 "../src/engine/imap/api/imap-client-service.vala"
			_g_object_unref0 (_data_->new_session);
#line 441 "../src/engine/imap/api/imap-client-service.vala"
			_g_object_unref0 (_data_->login);
#line 441 "../src/engine/imap/api/imap-client-service.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 441 "../src/engine/imap/api/imap-client-service.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 441 "../src/engine/imap/api/imap-client-service.vala"
			g_object_unref (_data_->_async_result);
#line 441 "../src/engine/imap/api/imap-client-service.vala"
			return FALSE;
#line 3113 "imap-client-service.c"
		}
#line 448 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp20_ = _data_->err;
#line 448 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp21_ = _g_error_copy0 (_data_->_tmp20_);
#line 448 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_inner_error0_ = _data_->_tmp21_;
#line 448 "../src/engine/imap/api/imap-client-service.vala"
		_g_error_free0 (_data_->err);
#line 3123 "imap-client-service.c"
		goto __finally0;
	}
	__finally0:
#line 435 "../src/engine/imap/api/imap-client-service.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 435 "../src/engine/imap/api/imap-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 435 "../src/engine/imap/api/imap-client-service.vala"
		_g_object_unref0 (_data_->new_session);
#line 435 "../src/engine/imap/api/imap-client-service.vala"
		_g_object_unref0 (_data_->login);
#line 435 "../src/engine/imap/api/imap-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 435 "../src/engine/imap/api/imap-client-service.vala"
		return FALSE;
#line 3139 "imap-client-service.c"
	}
#line 453 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp22_ = _data_->new_session;
#line 453 "../src/engine/imap/api/imap-client-service.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp22_, G_TYPE_OBJECT, GObject), "notify::disconnected", (GCallback) _geary_imap_client_service_on_session_disconnected_g_object_notify, _data_->self, 0);
#line 454 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp23_ = _data_->new_session;
#line 454 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp24_ = _data_->self->priv->_selected_keepalive_sec;
#line 454 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp25_ = _data_->self->priv->_unselected_keepalive_sec;
#line 454 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp26_ = _data_->self->priv->_selected_with_idle_keepalive_sec;
#line 454 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_session_enable_keepalives (_data_->_tmp23_, _data_->_tmp24_, _data_->_tmp25_, _data_->_tmp26_);
#line 458 "../src/engine/imap/api/imap-client-service.vala"
	_data_->result = _data_->new_session;
#line 458 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->login);
#line 458 "../src/engine/imap/api/imap-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 458 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_state_ != 0) {
#line 458 "../src/engine/imap/api/imap-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 458 "../src/engine/imap/api/imap-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3167 "imap-client-service.c"
		}
	}
#line 458 "../src/engine/imap/api/imap-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 458 "../src/engine/imap/api/imap-client-service.vala"
	return FALSE;
#line 3174 "imap-client-service.c"
}

static void
geary_imap_client_service_close_pool_data_free (gpointer _data)
{
	GearyImapClientServiceClosePoolData* _data_;
	_data_ = _data;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_slice_free (GearyImapClientServiceClosePoolData, _data_);
#line 3186 "imap-client-service.c"
}

static void
geary_imap_client_service_close_pool (GearyImapClientService* self,
                                      gboolean clean_disconnect,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	GearyImapClientServiceClosePoolData* _data_;
	GearyImapClientService* _tmp0_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SERVICE (self));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = g_slice_new0 (GearyImapClientServiceClosePoolData);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_service_close_pool_data_free);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->self = _tmp0_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->clean_disconnect = clean_disconnect;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_close_pool_co (_data_);
#line 3213 "imap-client-service.c"
}

static void
geary_imap_client_service_close_pool_finish (GearyImapClientService* self,
                                             GAsyncResult* _res_)
{
	GearyImapClientServiceClosePoolData* _data_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3223 "imap-client-service.c"
}

static Block26Data*
block26_data_ref (Block26Data* _data26_)
{
#line 461 "../src/engine/imap/api/imap-client-service.vala"
	g_atomic_int_inc (&_data26_->_ref_count_);
#line 461 "../src/engine/imap/api/imap-client-service.vala"
	return _data26_;
#line 3233 "imap-client-service.c"
}

static void
block26_data_unref (void * _userdata_)
{
	Block26Data* _data26_;
	_data26_ = (Block26Data*) _userdata_;
#line 461 "../src/engine/imap/api/imap-client-service.vala"
	if (g_atomic_int_dec_and_test (&_data26_->_ref_count_)) {
#line 3243 "imap-client-service.c"
		GearyImapClientService* self;
#line 461 "../src/engine/imap/api/imap-client-service.vala"
		self = _data26_->self;
#line 461 "../src/engine/imap/api/imap-client-service.vala"
		_data26_->to_close = (_vala_array_free (_data26_->to_close, _data26_->to_close_length1, (GDestroyNotify) g_object_unref), NULL);
#line 461 "../src/engine/imap/api/imap-client-service.vala"
		_g_object_unref0 (self);
#line 461 "../src/engine/imap/api/imap-client-service.vala"
		g_slice_free (Block26Data, _data26_);
#line 3253 "imap-client-service.c"
	}
}

static void
___lambda107_ (Block26Data* _data26_,
               GError** error)
{
	GearyImapClientService* self;
	GeeSet* _tmp0_;
	gint _tmp1_ = 0;
	gpointer* _tmp2_;
#line 470 "../src/engine/imap/api/imap-client-service.vala"
	self = _data26_->self;
#line 471 "../src/engine/imap/api/imap-client-service.vala"
	_tmp0_ = self->priv->all_sessions;
#line 471 "../src/engine/imap/api/imap-client-service.vala"
	_tmp2_ = gee_collection_to_array (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), &_tmp1_);
#line 471 "../src/engine/imap/api/imap-client-service.vala"
	_data26_->to_close = (_vala_array_free (_data26_->to_close, _data26_->to_close_length1, (GDestroyNotify) g_object_unref), NULL);
#line 471 "../src/engine/imap/api/imap-client-service.vala"
	_data26_->to_close = _tmp2_;
#line 471 "../src/engine/imap/api/imap-client-service.vala"
	_data26_->to_close_length1 = _tmp1_;
#line 471 "../src/engine/imap/api/imap-client-service.vala"
	_data26_->_to_close_size_ = _data26_->to_close_length1;
#line 3279 "imap-client-service.c"
}

static void
____lambda107__geary_nonblocking_mutex_critical_section (gpointer self,
                                                         GError** error)
{
#line 470 "../src/engine/imap/api/imap-client-service.vala"
	___lambda107_ (self, error);
#line 3288 "imap-client-service.c"
}

static void
geary_imap_client_service_close_pool_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_)
{
	GearyImapClientServiceClosePoolData* _data_;
#line 470 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = _user_data_;
#line 470 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_source_object_ = source_object;
#line 470 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_res_ = _res_;
#line 470 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_close_pool_co (_data_);
#line 3305 "imap-client-service.c"
}

static gboolean
geary_imap_client_service_close_pool_co (GearyImapClientServiceClosePoolData* _data_)
{
#line 461 "../src/engine/imap/api/imap-client-service.vala"
	switch (_data_->_state_) {
#line 461 "../src/engine/imap/api/imap-client-service.vala"
		case 0:
#line 3315 "imap-client-service.c"
		goto _state_0;
#line 461 "../src/engine/imap/api/imap-client-service.vala"
		case 1:
#line 3319 "imap-client-service.c"
		goto _state_1;
		default:
#line 461 "../src/engine/imap/api/imap-client-service.vala"
		g_assert_not_reached ();
#line 3324 "imap-client-service.c"
	}
	_state_0:
#line 461 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_data26_ = g_slice_new0 (Block26Data);
#line 461 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_data26_->_ref_count_ = 1;
#line 461 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_data26_->self = g_object_ref (_data_->self);
#line 461 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_data26_->_async_data_ = _data_;
#line 462 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp0_ = _data_->self->priv->all_sessions;
#line 462 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp1_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEE_TYPE_COLLECTION, GeeCollection));
#line 462 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 462 "../src/engine/imap/api/imap-client-service.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Closing the pool, disconnecting %d sessions", _data_->_tmp2_);
#line 468 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_data26_->to_close = NULL;
#line 468 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_data26_->to_close_length1 = 0;
#line 468 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_data26_->_to_close_size_ = _data_->_data26_->to_close_length1;
#line 3349 "imap-client-service.c"
	{
#line 470 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp3_ = _data_->self->priv->sessions_mutex;
#line 470 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_state_ = 1;
#line 470 "../src/engine/imap/api/imap-client-service.vala"
		geary_nonblocking_mutex_execute_locked (_data_->_tmp3_, ____lambda107__geary_nonblocking_mutex_critical_section, _data_->_data26_, NULL, geary_imap_client_service_close_pool_ready, _data_);
#line 470 "../src/engine/imap/api/imap-client-service.vala"
		return FALSE;
#line 3359 "imap-client-service.c"
		_state_1:
#line 470 "../src/engine/imap/api/imap-client-service.vala"
		geary_nonblocking_mutex_execute_locked_finish (_data_->_tmp3_, _data_->_res_, &_data_->_inner_error0_);
#line 470 "../src/engine/imap/api/imap-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3365 "imap-client-service.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 469 "../src/engine/imap/api/imap-client-service.vala"
		_data_->err = _data_->_inner_error0_;
#line 469 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_inner_error0_ = NULL;
#line 474 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp4_ = _data_->err;
#line 474 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp5_ = _data_->_tmp4_->message;
#line 474 "../src/engine/imap/api/imap-client-service.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Error occurred copying sessions: %s", _data_->_tmp5_);
#line 469 "../src/engine/imap/api/imap-client-service.vala"
		_g_error_free0 (_data_->err);
#line 3384 "imap-client-service.c"
	}
	__finally0:
#line 469 "../src/engine/imap/api/imap-client-service.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 469 "../src/engine/imap/api/imap-client-service.vala"
		block26_data_unref (_data_->_data26_);
#line 469 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_data26_ = NULL;
#line 469 "../src/engine/imap/api/imap-client-service.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 469 "../src/engine/imap/api/imap-client-service.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 469 "../src/engine/imap/api/imap-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 469 "../src/engine/imap/api/imap-client-service.vala"
		return FALSE;
#line 3401 "imap-client-service.c"
	}
	{
#line 480 "../src/engine/imap/api/imap-client-service.vala"
		_data_->session_collection_length1 = 0;
#line 480 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_session_collection_size_ = 0;
#line 480 "../src/engine/imap/api/imap-client-service.vala"
		_data_->session_collection = _data_->_data26_->to_close;
#line 480 "../src/engine/imap/api/imap-client-service.vala"
		_data_->session_collection_length1 = _data_->_data26_->to_close_length1;
#line 480 "../src/engine/imap/api/imap-client-service.vala"
		for (_data_->session_it = 0; _data_->session_it < _data_->session_collection_length1; _data_->session_it = _data_->session_it + 1) {
#line 480 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp6_ = _g_object_ref0 (_data_->session_collection[_data_->session_it]);
#line 480 "../src/engine/imap/api/imap-client-service.vala"
			_data_->session = _data_->_tmp6_;
#line 3418 "imap-client-service.c"
			{
#line 481 "../src/engine/imap/api/imap-client-service.vala"
				if (_data_->clean_disconnect) {
#line 482 "../src/engine/imap/api/imap-client-service.vala"
					_data_->_tmp7_ = _data_->session;
#line 482 "../src/engine/imap/api/imap-client-service.vala"
					geary_imap_client_service_disconnect_session (_data_->self, _data_->_tmp7_, NULL, NULL);
#line 3426 "imap-client-service.c"
				} else {
#line 484 "../src/engine/imap/api/imap-client-service.vala"
					_data_->_tmp8_ = _data_->session;
#line 484 "../src/engine/imap/api/imap-client-service.vala"
					geary_imap_client_service_force_disconnect_session (_data_->self, _data_->_tmp8_, NULL, NULL);
#line 3432 "imap-client-service.c"
				}
#line 480 "../src/engine/imap/api/imap-client-service.vala"
				_g_object_unref0 (_data_->session);
#line 3436 "imap-client-service.c"
			}
		}
	}
#line 461 "../src/engine/imap/api/imap-client-service.vala"
	block26_data_unref (_data_->_data26_);
#line 461 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_data26_ = NULL;
#line 461 "../src/engine/imap/api/imap-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 461 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_state_ != 0) {
#line 461 "../src/engine/imap/api/imap-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 461 "../src/engine/imap/api/imap-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3452 "imap-client-service.c"
		}
	}
#line 461 "../src/engine/imap/api/imap-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 461 "../src/engine/imap/api/imap-client-service.vala"
	return FALSE;
#line 3459 "imap-client-service.c"
}

static void
geary_imap_client_service_disconnect_session_data_free (gpointer _data)
{
	GearyImapClientServiceDisconnectSessionData* _data_;
	_data_ = _data;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->session);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_slice_free (GearyImapClientServiceDisconnectSessionData, _data_);
#line 3473 "imap-client-service.c"
}

static void
geary_imap_client_service_disconnect_session (GearyImapClientService* self,
                                              GearyImapClientSession* session,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	GearyImapClientServiceDisconnectSessionData* _data_;
	GearyImapClientService* _tmp0_;
	GearyImapClientSession* _tmp1_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SERVICE (self));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (session));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = g_slice_new0 (GearyImapClientServiceDisconnectSessionData);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_service_disconnect_session_data_free);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->self = _tmp0_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_tmp1_ = _g_object_ref0 (session);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->session);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->session = _tmp1_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_disconnect_session_co (_data_);
#line 3507 "imap-client-service.c"
}

static void
geary_imap_client_service_disconnect_session_finish (GearyImapClientService* self,
                                                     GAsyncResult* _res_)
{
	GearyImapClientServiceDisconnectSessionData* _data_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3517 "imap-client-service.c"
}

static void
geary_imap_client_service_disconnect_session_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_)
{
	GearyImapClientServiceDisconnectSessionData* _data_;
#line 495 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = _user_data_;
#line 495 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_source_object_ = source_object;
#line 495 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_res_ = _res_;
#line 495 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_disconnect_session_co (_data_);
#line 3534 "imap-client-service.c"
}

static gboolean
geary_imap_client_service_disconnect_session_co (GearyImapClientServiceDisconnectSessionData* _data_)
{
#line 489 "../src/engine/imap/api/imap-client-service.vala"
	switch (_data_->_state_) {
#line 489 "../src/engine/imap/api/imap-client-service.vala"
		case 0:
#line 3544 "imap-client-service.c"
		goto _state_0;
#line 489 "../src/engine/imap/api/imap-client-service.vala"
		case 1:
#line 3548 "imap-client-service.c"
		goto _state_1;
#line 489 "../src/engine/imap/api/imap-client-service.vala"
		case 2:
#line 3552 "imap-client-service.c"
		goto _state_2;
#line 489 "../src/engine/imap/api/imap-client-service.vala"
		case 3:
#line 3556 "imap-client-service.c"
		goto _state_3;
		default:
#line 489 "../src/engine/imap/api/imap-client-service.vala"
		g_assert_not_reached ();
#line 3561 "imap-client-service.c"
	}
	_state_0:
#line 490 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp0_ = geary_imap_client_session_get_protocol_state (_data_->session);
#line 490 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 490 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_tmp1_ != GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_NOT_CONNECTED) {
#line 491 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp2_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->session, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 491 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 491 "../src/engine/imap/api/imap-client-service.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Logging out session: %s", _data_->_tmp3_);
#line 491 "../src/engine/imap/api/imap-client-service.vala"
		_g_free0 (_data_->_tmp3_);
#line 3578 "imap-client-service.c"
		{
#line 495 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp4_ = _data_->self->priv->close_cancellable;
#line 495 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_state_ = 1;
#line 495 "../src/engine/imap/api/imap-client-service.vala"
			geary_imap_client_session_logout_async (_data_->session, _data_->_tmp4_, geary_imap_client_service_disconnect_session_ready, _data_);
#line 495 "../src/engine/imap/api/imap-client-service.vala"
			return FALSE;
#line 3588 "imap-client-service.c"
			_state_1:
#line 495 "../src/engine/imap/api/imap-client-service.vala"
			geary_imap_client_session_logout_finish (_data_->session, _data_->_res_, &_data_->_inner_error0_);
#line 495 "../src/engine/imap/api/imap-client-service.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3594 "imap-client-service.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 494 "../src/engine/imap/api/imap-client-service.vala"
			_data_->err = _data_->_inner_error0_;
#line 494 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_inner_error0_ = NULL;
#line 497 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp5_ = _data_->err;
#line 497 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_tmp6_ = _data_->_tmp5_->message;
#line 497 "../src/engine/imap/api/imap-client-service.vala"
			geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Error logging out of session: %s", _data_->_tmp6_);
#line 498 "../src/engine/imap/api/imap-client-service.vala"
			_data_->_state_ = 2;
#line 498 "../src/engine/imap/api/imap-client-service.vala"
			geary_imap_client_service_force_disconnect_session (_data_->self, _data_->session, geary_imap_client_service_disconnect_session_ready, _data_);
#line 498 "../src/engine/imap/api/imap-client-service.vala"
			return FALSE;
#line 3617 "imap-client-service.c"
			_state_2:
#line 498 "../src/engine/imap/api/imap-client-service.vala"
			geary_imap_client_service_force_disconnect_session_finish (_data_->self, _data_->_res_);
#line 494 "../src/engine/imap/api/imap-client-service.vala"
			_g_error_free0 (_data_->err);
#line 3623 "imap-client-service.c"
		}
		__finally0:
#line 494 "../src/engine/imap/api/imap-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 494 "../src/engine/imap/api/imap-client-service.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 494 "../src/engine/imap/api/imap-client-service.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 494 "../src/engine/imap/api/imap-client-service.vala"
			g_object_unref (_data_->_async_result);
#line 494 "../src/engine/imap/api/imap-client-service.vala"
			return FALSE;
#line 3636 "imap-client-service.c"
		}
	} else {
#line 501 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_state_ = 3;
#line 501 "../src/engine/imap/api/imap-client-service.vala"
		geary_imap_client_service_remove_session_async (_data_->self, _data_->session, geary_imap_client_service_disconnect_session_ready, _data_);
#line 501 "../src/engine/imap/api/imap-client-service.vala"
		return FALSE;
#line 3645 "imap-client-service.c"
		_state_3:
#line 501 "../src/engine/imap/api/imap-client-service.vala"
		geary_imap_client_service_remove_session_finish (_data_->self, _data_->_res_);
#line 3649 "imap-client-service.c"
	}
#line 489 "../src/engine/imap/api/imap-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 489 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_state_ != 0) {
#line 489 "../src/engine/imap/api/imap-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 489 "../src/engine/imap/api/imap-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3659 "imap-client-service.c"
		}
	}
#line 489 "../src/engine/imap/api/imap-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 489 "../src/engine/imap/api/imap-client-service.vala"
	return FALSE;
#line 3666 "imap-client-service.c"
}

static void
geary_imap_client_service_force_disconnect_session_data_free (gpointer _data)
{
	GearyImapClientServiceForceDisconnectSessionData* _data_;
	_data_ = _data;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->session);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_slice_free (GearyImapClientServiceForceDisconnectSessionData, _data_);
#line 3680 "imap-client-service.c"
}

static void
geary_imap_client_service_force_disconnect_session (GearyImapClientService* self,
                                                    GearyImapClientSession* session,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_)
{
	GearyImapClientServiceForceDisconnectSessionData* _data_;
	GearyImapClientService* _tmp0_;
	GearyImapClientSession* _tmp1_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SERVICE (self));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (session));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = g_slice_new0 (GearyImapClientServiceForceDisconnectSessionData);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_service_force_disconnect_session_data_free);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->self = _tmp0_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_tmp1_ = _g_object_ref0 (session);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->session);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->session = _tmp1_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_force_disconnect_session_co (_data_);
#line 3714 "imap-client-service.c"
}

static void
geary_imap_client_service_force_disconnect_session_finish (GearyImapClientService* self,
                                                           GAsyncResult* _res_)
{
	GearyImapClientServiceForceDisconnectSessionData* _data_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3724 "imap-client-service.c"
}

static void
geary_imap_client_service_force_disconnect_session_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_)
{
	GearyImapClientServiceForceDisconnectSessionData* _data_;
#line 507 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = _user_data_;
#line 507 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_source_object_ = source_object;
#line 507 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_res_ = _res_;
#line 507 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_force_disconnect_session_co (_data_);
#line 3741 "imap-client-service.c"
}

static gboolean
geary_imap_client_service_force_disconnect_session_co (GearyImapClientServiceForceDisconnectSessionData* _data_)
{
#line 505 "../src/engine/imap/api/imap-client-service.vala"
	switch (_data_->_state_) {
#line 505 "../src/engine/imap/api/imap-client-service.vala"
		case 0:
#line 3751 "imap-client-service.c"
		goto _state_0;
#line 505 "../src/engine/imap/api/imap-client-service.vala"
		case 1:
#line 3755 "imap-client-service.c"
		goto _state_1;
		default:
#line 505 "../src/engine/imap/api/imap-client-service.vala"
		g_assert_not_reached ();
#line 3760 "imap-client-service.c"
	}
	_state_0:
#line 506 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp0_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->session, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 506 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 506 "../src/engine/imap/api/imap-client-service.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Dropping session: %s", _data_->_tmp1_);
#line 506 "../src/engine/imap/api/imap-client-service.vala"
	_g_free0 (_data_->_tmp1_);
#line 507 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_state_ = 1;
#line 507 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_remove_session_async (_data_->self, _data_->session, geary_imap_client_service_force_disconnect_session_ready, _data_);
#line 507 "../src/engine/imap/api/imap-client-service.vala"
	return FALSE;
#line 3777 "imap-client-service.c"
	_state_1:
#line 507 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_remove_session_finish (_data_->self, _data_->_res_);
#line 511 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_session_disconnect_async (_data_->session, NULL, NULL, NULL);
#line 505 "../src/engine/imap/api/imap-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 505 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_state_ != 0) {
#line 505 "../src/engine/imap/api/imap-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 505 "../src/engine/imap/api/imap-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3791 "imap-client-service.c"
		}
	}
#line 505 "../src/engine/imap/api/imap-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 505 "../src/engine/imap/api/imap-client-service.vala"
	return FALSE;
#line 3798 "imap-client-service.c"
}

static void
geary_imap_client_service_remove_session_async_data_free (gpointer _data)
{
	GearyImapClientServiceRemoveSessionAsyncData* _data_;
	_data_ = _data;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_slice_free (GearyImapClientServiceRemoveSessionAsyncData, _data_);
#line 3810 "imap-client-service.c"
}

static void
geary_imap_client_service_remove_session_async (GearyImapClientService* self,
                                                GearyImapClientSession* session,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_)
{
	GearyImapClientServiceRemoveSessionAsyncData* _data_;
	GearyImapClientService* _tmp0_;
	GearyImapClientSession* _tmp1_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SERVICE (self));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (session));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = g_slice_new0 (GearyImapClientServiceRemoveSessionAsyncData);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_service_remove_session_async_data_free);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->self = _tmp0_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_tmp1_ = _g_object_ref0 (session);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->session);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_->session = _tmp1_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_remove_session_async_co (_data_);
#line 3844 "imap-client-service.c"
}

static gboolean
geary_imap_client_service_remove_session_finish (GearyImapClientService* self,
                                                 GAsyncResult* _res_)
{
	gboolean result;
	GearyImapClientServiceRemoveSessionAsyncData* _data_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	result = _data_->result;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	return result;
#line 3859 "imap-client-service.c"
}

static Block27Data*
block27_data_ref (Block27Data* _data27_)
{
#line 514 "../src/engine/imap/api/imap-client-service.vala"
	g_atomic_int_inc (&_data27_->_ref_count_);
#line 514 "../src/engine/imap/api/imap-client-service.vala"
	return _data27_;
#line 3869 "imap-client-service.c"
}

static void
block27_data_unref (void * _userdata_)
{
	Block27Data* _data27_;
	_data27_ = (Block27Data*) _userdata_;
#line 514 "../src/engine/imap/api/imap-client-service.vala"
	if (g_atomic_int_dec_and_test (&_data27_->_ref_count_)) {
#line 3879 "imap-client-service.c"
		GearyImapClientService* self;
#line 514 "../src/engine/imap/api/imap-client-service.vala"
		self = _data27_->self;
#line 514 "../src/engine/imap/api/imap-client-service.vala"
		_g_object_unref0 (_data27_->session);
#line 514 "../src/engine/imap/api/imap-client-service.vala"
		_g_object_unref0 (self);
#line 514 "../src/engine/imap/api/imap-client-service.vala"
		g_slice_free (Block27Data, _data27_);
#line 3889 "imap-client-service.c"
	}
}

static void
___lambda105_ (Block27Data* _data27_,
               GError** error)
{
	GearyImapClientService* self;
	GeeSet* _tmp0_;
#line 521 "../src/engine/imap/api/imap-client-service.vala"
	self = _data27_->self;
#line 522 "../src/engine/imap/api/imap-client-service.vala"
	_tmp0_ = self->priv->all_sessions;
#line 522 "../src/engine/imap/api/imap-client-service.vala"
	_data27_->removed = gee_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), _data27_->session);
#line 3905 "imap-client-service.c"
}

static void
____lambda105__geary_nonblocking_mutex_critical_section (gpointer self,
                                                         GError** error)
{
#line 521 "../src/engine/imap/api/imap-client-service.vala"
	___lambda105_ (self, error);
#line 3914 "imap-client-service.c"
}

static void
geary_imap_client_service_remove_session_async_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_)
{
	GearyImapClientServiceRemoveSessionAsyncData* _data_;
#line 521 "../src/engine/imap/api/imap-client-service.vala"
	_data_ = _user_data_;
#line 521 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_source_object_ = source_object;
#line 521 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_res_ = _res_;
#line 521 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_remove_session_async_co (_data_);
#line 3931 "imap-client-service.c"
}

static gboolean
geary_imap_client_service_remove_session_async_co (GearyImapClientServiceRemoveSessionAsyncData* _data_)
{
#line 514 "../src/engine/imap/api/imap-client-service.vala"
	switch (_data_->_state_) {
#line 514 "../src/engine/imap/api/imap-client-service.vala"
		case 0:
#line 3941 "imap-client-service.c"
		goto _state_0;
#line 514 "../src/engine/imap/api/imap-client-service.vala"
		case 1:
#line 3945 "imap-client-service.c"
		goto _state_1;
		default:
#line 514 "../src/engine/imap/api/imap-client-service.vala"
		g_assert_not_reached ();
#line 3950 "imap-client-service.c"
	}
	_state_0:
#line 514 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_data27_ = g_slice_new0 (Block27Data);
#line 514 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_data27_->_ref_count_ = 1;
#line 514 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_data27_->self = g_object_ref (_data_->self);
#line 514 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (_data_->_data27_->session);
#line 514 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_data27_->session = _data_->session;
#line 514 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_data27_->_async_data_ = _data_;
#line 517 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_tmp0_ = _data_->self->priv->free_queue;
#line 517 "../src/engine/imap/api/imap-client-service.vala"
	geary_nonblocking_queue_revoke (_data_->_tmp0_, _data_->_data27_->session);
#line 519 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_data27_->removed = FALSE;
#line 3971 "imap-client-service.c"
	{
#line 521 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp1_ = _data_->self->priv->sessions_mutex;
#line 521 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_state_ = 1;
#line 521 "../src/engine/imap/api/imap-client-service.vala"
		geary_nonblocking_mutex_execute_locked (_data_->_tmp1_, ____lambda105__geary_nonblocking_mutex_critical_section, _data_->_data27_, NULL, geary_imap_client_service_remove_session_async_ready, _data_);
#line 521 "../src/engine/imap/api/imap-client-service.vala"
		return FALSE;
#line 3981 "imap-client-service.c"
		_state_1:
#line 521 "../src/engine/imap/api/imap-client-service.vala"
		geary_nonblocking_mutex_execute_locked_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error0_);
#line 521 "../src/engine/imap/api/imap-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3987 "imap-client-service.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 520 "../src/engine/imap/api/imap-client-service.vala"
		_data_->err = _data_->_inner_error0_;
#line 520 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_inner_error0_ = NULL;
#line 525 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp2_ = _data_->err;
#line 525 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_tmp3_ = _data_->_tmp2_->message;
#line 525 "../src/engine/imap/api/imap-client-service.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Error removing session: %s", _data_->_tmp3_);
#line 520 "../src/engine/imap/api/imap-client-service.vala"
		_g_error_free0 (_data_->err);
#line 4006 "imap-client-service.c"
	}
	__finally0:
#line 520 "../src/engine/imap/api/imap-client-service.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 520 "../src/engine/imap/api/imap-client-service.vala"
		block27_data_unref (_data_->_data27_);
#line 520 "../src/engine/imap/api/imap-client-service.vala"
		_data_->_data27_ = NULL;
#line 520 "../src/engine/imap/api/imap-client-service.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 520 "../src/engine/imap/api/imap-client-service.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 520 "../src/engine/imap/api/imap-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 520 "../src/engine/imap/api/imap-client-service.vala"
		return FALSE;
#line 4023 "imap-client-service.c"
	}
#line 528 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_data27_->removed) {
#line 529 "../src/engine/imap/api/imap-client-service.vala"
		g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_data_->_data27_->session, G_TYPE_OBJECT, GObject), "notify::disconnected", (GCallback) _geary_imap_client_service_on_session_disconnected_g_object_notify, _data_->self, 0);
#line 4029 "imap-client-service.c"
	}
#line 531 "../src/engine/imap/api/imap-client-service.vala"
	_data_->result = _data_->_data27_->removed;
#line 531 "../src/engine/imap/api/imap-client-service.vala"
	block27_data_unref (_data_->_data27_);
#line 531 "../src/engine/imap/api/imap-client-service.vala"
	_data_->_data27_ = NULL;
#line 531 "../src/engine/imap/api/imap-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 531 "../src/engine/imap/api/imap-client-service.vala"
	if (_data_->_state_ != 0) {
#line 531 "../src/engine/imap/api/imap-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 531 "../src/engine/imap/api/imap-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4045 "imap-client-service.c"
		}
	}
#line 531 "../src/engine/imap/api/imap-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 531 "../src/engine/imap/api/imap-client-service.vala"
	return FALSE;
#line 4052 "imap-client-service.c"
}

static void
___lambda106_ (GearyImapClientService* self,
               GObject* obj,
               GAsyncResult* res)
{
#line 547 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 547 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 547 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_remove_session_finish (self, res);
#line 4066 "imap-client-service.c"
}

static void
____lambda106__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 545 "../src/engine/imap/api/imap-client-service.vala"
	___lambda106_ ((GearyImapClientService*) self, source_object, res);
#line 545 "../src/engine/imap/api/imap-client-service.vala"
	g_object_unref (self);
#line 4078 "imap-client-service.c"
}

static void
geary_imap_client_service_on_session_disconnected (GearyImapClientService* self,
                                                   GObject* source,
                                                   GParamSpec* param)
{
	GearyImapClientSession* session = NULL;
	GearyImapClientSession* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GearyImapClientSession* _tmp3_;
#line 534 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SERVICE (self));
#line 534 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (source, G_TYPE_OBJECT));
#line 534 "../src/engine/imap/api/imap-client-service.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (param, G_TYPE_PARAM));
#line 536 "../src/engine/imap/api/imap-client-service.vala"
	_tmp0_ = _g_object_ref0 (GEARY_IMAP_IS_CLIENT_SESSION (source) ? ((GearyImapClientSession*) source) : NULL);
#line 536 "../src/engine/imap/api/imap-client-service.vala"
	session = _tmp0_;
#line 537 "../src/engine/imap/api/imap-client-service.vala"
	_tmp3_ = session;
#line 537 "../src/engine/imap/api/imap-client-service.vala"
	if (_tmp3_ != NULL) {
#line 4105 "imap-client-service.c"
		GearyImapClientSession* _tmp4_;
		GearyImapClientSessionProtocolState _tmp5_;
		GearyImapClientSessionProtocolState _tmp6_;
#line 538 "../src/engine/imap/api/imap-client-service.vala"
		_tmp4_ = session;
#line 538 "../src/engine/imap/api/imap-client-service.vala"
		_tmp5_ = geary_imap_client_session_get_protocol_state (_tmp4_);
#line 538 "../src/engine/imap/api/imap-client-service.vala"
		_tmp6_ = _tmp5_;
#line 538 "../src/engine/imap/api/imap-client-service.vala"
		_tmp2_ = _tmp6_ == GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_NOT_CONNECTED;
#line 4117 "imap-client-service.c"
	} else {
#line 537 "../src/engine/imap/api/imap-client-service.vala"
		_tmp2_ = FALSE;
#line 4121 "imap-client-service.c"
	}
#line 537 "../src/engine/imap/api/imap-client-service.vala"
	if (_tmp2_) {
#line 4125 "imap-client-service.c"
		GearyImapClientSession* _tmp7_;
		GearyImapClientSessionDisconnectReason _tmp8_;
		GearyImapClientSessionDisconnectReason _tmp9_;
#line 539 "../src/engine/imap/api/imap-client-service.vala"
		_tmp7_ = session;
#line 539 "../src/engine/imap/api/imap-client-service.vala"
		_tmp8_ = geary_imap_client_session_get_disconnected (_tmp7_);
#line 539 "../src/engine/imap/api/imap-client-service.vala"
		_tmp9_ = _tmp8_;
#line 539 "../src/engine/imap/api/imap-client-service.vala"
		_tmp1_ = _tmp9_ != GEARY_IMAP_CLIENT_SESSION_DISCONNECT_REASON_NULL;
#line 4137 "imap-client-service.c"
	} else {
#line 537 "../src/engine/imap/api/imap-client-service.vala"
		_tmp1_ = FALSE;
#line 4141 "imap-client-service.c"
	}
#line 537 "../src/engine/imap/api/imap-client-service.vala"
	if (_tmp1_) {
#line 4145 "imap-client-service.c"
		GearyImapClientSession* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		GearyImapClientSession* _tmp13_;
		GearyImapClientSessionDisconnectReason _tmp14_;
		GearyImapClientSessionDisconnectReason _tmp15_;
		gchar* _tmp16_;
		GearyImapClientSession* _tmp17_;
		GearyImapClientSession* _tmp18_;
		GearyImapClientSessionDisconnectReason _tmp19_;
		GearyImapClientSessionDisconnectReason _tmp20_;
#line 540 "../src/engine/imap/api/imap-client-service.vala"
		_tmp10_ = session;
#line 540 "../src/engine/imap/api/imap-client-service.vala"
		_tmp11_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 540 "../src/engine/imap/api/imap-client-service.vala"
		_tmp12_ = _tmp11_;
#line 540 "../src/engine/imap/api/imap-client-service.vala"
		_tmp13_ = session;
#line 540 "../src/engine/imap/api/imap-client-service.vala"
		_tmp14_ = geary_imap_client_session_get_disconnected (_tmp13_);
#line 540 "../src/engine/imap/api/imap-client-service.vala"
		_tmp15_ = _tmp14_;
#line 540 "../src/engine/imap/api/imap-client-service.vala"
		_tmp16_ = g_enum_to_string (GEARY_IMAP_CLIENT_SESSION_TYPE_DISCONNECT_REASON, _tmp15_);
#line 540 "../src/engine/imap/api/imap-client-service.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Session disconnected: %s: %s", _tmp12_, _tmp16_);
#line 540 "../src/engine/imap/api/imap-client-service.vala"
		_g_free0 (_tmp16_);
#line 540 "../src/engine/imap/api/imap-client-service.vala"
		_g_free0 (_tmp12_);
#line 545 "../src/engine/imap/api/imap-client-service.vala"
		_tmp17_ = session;
#line 545 "../src/engine/imap/api/imap-client-service.vala"
		geary_imap_client_service_remove_session_async (self, _tmp17_, ____lambda106__gasync_ready_callback, g_object_ref (self));
#line 549 "../src/engine/imap/api/imap-client-service.vala"
		_tmp18_ = session;
#line 549 "../src/engine/imap/api/imap-client-service.vala"
		_tmp19_ = geary_imap_client_session_get_disconnected (_tmp18_);
#line 549 "../src/engine/imap/api/imap-client-service.vala"
		_tmp20_ = _tmp19_;
#line 549 "../src/engine/imap/api/imap-client-service.vala"
		if (_tmp20_ == GEARY_IMAP_CLIENT_SESSION_DISCONNECT_REASON_REMOTE_ERROR) {
#line 4189 "imap-client-service.c"
			GearyErrorContext* context = NULL;
			GError* _tmp21_;
			GError* _tmp22_;
			GearyErrorContext* _tmp23_;
			GearyErrorContext* _tmp24_;
			GearyErrorContext* _tmp25_;
#line 550 "../src/engine/imap/api/imap-client-service.vala"
			_tmp21_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_CONNECTED, "Session disconnected, remote error");
#line 550 "../src/engine/imap/api/imap-client-service.vala"
			_tmp22_ = _tmp21_;
#line 550 "../src/engine/imap/api/imap-client-service.vala"
			_tmp23_ = geary_error_context_new (_tmp22_);
#line 550 "../src/engine/imap/api/imap-client-service.vala"
			_tmp24_ = _tmp23_;
#line 550 "../src/engine/imap/api/imap-client-service.vala"
			_g_error_free0 (_tmp22_);
#line 550 "../src/engine/imap/api/imap-client-service.vala"
			context = _tmp24_;
#line 553 "../src/engine/imap/api/imap-client-service.vala"
			_tmp25_ = context;
#line 553 "../src/engine/imap/api/imap-client-service.vala"
			geary_client_service_notify_connection_failed (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService), _tmp25_);
#line 549 "../src/engine/imap/api/imap-client-service.vala"
			_g_object_unref0 (context);
#line 4214 "imap-client-service.c"
		}
	}
#line 534 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (session);
#line 4219 "imap-client-service.c"
}

static void
geary_imap_client_service_class_init (GearyImapClientServiceClass * klass,
                                      gpointer klass_data)
{
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	geary_imap_client_service_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_type_class_adjust_private_offset (klass, &GearyImapClientService_private_offset);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	((GearyClientServiceClass *) klass)->start = (void (*) (GearyClientService*, GCancellable*, GAsyncReadyCallback, gpointer)) geary_imap_client_service_real_start;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	((GearyClientServiceClass *) klass)->start_finish = (void (*) (GearyClientService*, GAsyncResult*, GError**)) geary_imap_client_service_start_finish;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	((GearyClientServiceClass *) klass)->stop = (void (*) (GearyClientService*, GCancellable*, GAsyncReadyCallback, gpointer)) geary_imap_client_service_real_stop;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	((GearyClientServiceClass *) klass)->stop_finish = (void (*) (GearyClientService*, GAsyncResult*, GError**)) geary_imap_client_service_stop_finish;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	((GearyClientServiceClass *) klass)->became_reachable = (void (*) (GearyClientService*)) geary_imap_client_service_real_became_reachable;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	((GearyClientServiceClass *) klass)->became_unreachable = (void (*) (GearyClientService*)) geary_imap_client_service_real_became_unreachable;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	GEARY_CLIENT_SERVICE_CLASS (klass)->get_logging_domain = (const gchar* (*) (GearyClientService*)) geary_imap_client_service_real_get_logging_domain;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_imap_client_service_get_property;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_imap_client_service_set_property;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_imap_client_service_finalize;
#line 4250 "imap-client-service.c"
	/**
	     * Set to zero or negative value if keepalives should be disabled when a connection has not
	     * selected a mailbox.  (This is not recommended.)
	     *
	     * This only affects newly created sessions or sessions leaving the selected/examined state
	     * and returning to an authorized state.
	     */
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_CLIENT_SERVICE_UNSELECTED_KEEPALIVE_SEC_PROPERTY, geary_imap_client_service_properties[GEARY_IMAP_CLIENT_SERVICE_UNSELECTED_KEEPALIVE_SEC_PROPERTY] = g_param_spec_uint ("unselected-keepalive-sec", "unselected-keepalive-sec", "unselected-keepalive-sec", 0, G_MAXUINT, GEARY_IMAP_CLIENT_SESSION_DEFAULT_UNSELECTED_KEEPALIVE_SEC, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4260 "imap-client-service.c"
	/**
	     * Set to zero or negative value if keepalives should be disabled when a mailbox is selected
	     * or examined.  (This is not recommended.)
	     *
	     * This only affects newly selected/examined sessions.
	     */
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_CLIENT_SERVICE_SELECTED_KEEPALIVE_SEC_PROPERTY, geary_imap_client_service_properties[GEARY_IMAP_CLIENT_SERVICE_SELECTED_KEEPALIVE_SEC_PROPERTY] = g_param_spec_uint ("selected-keepalive-sec", "selected-keepalive-sec", "selected-keepalive-sec", 0, G_MAXUINT, GEARY_IMAP_CLIENT_SESSION_DEFAULT_SELECTED_KEEPALIVE_SEC, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4269 "imap-client-service.c"
	/**
	     * Set to zero or negative value if keepalives should be disabled when a mailbox is selected
	     * or examined and IDLE is supported.  (This is not recommended.)
	     *
	     * This only affects newly selected/examined sessions.
	     */
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_CLIENT_SERVICE_SELECTED_WITH_IDLE_KEEPALIVE_SEC_PROPERTY, geary_imap_client_service_properties[GEARY_IMAP_CLIENT_SERVICE_SELECTED_WITH_IDLE_KEEPALIVE_SEC_PROPERTY] = g_param_spec_uint ("selected-with-idle-keepalive-sec", "selected-with-idle-keepalive-sec", "selected-with-idle-keepalive-sec", 0, G_MAXUINT, GEARY_IMAP_CLIENT_SESSION_DEFAULT_SELECTED_WITH_IDLE_KEEPALIVE_SEC, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4278 "imap-client-service.c"
	/**
	     * Specifies the minimum number of sessions to keep open.
	     *
	     * The manager will attempt to keep at least this number of
	     * connections open at all times.
	     *
	     * Setting this does not immediately adjust the pool size in
	     * either direction.  Adjustment will happen as connections are
	     * needed or closed.
	     */
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_CLIENT_SERVICE_MIN_POOL_SIZE_PROPERTY, geary_imap_client_service_properties[GEARY_IMAP_CLIENT_SERVICE_MIN_POOL_SIZE_PROPERTY] = g_param_spec_int ("min-pool-size", "min-pool-size", "min-pool-size", G_MININT, G_MAXINT, GEARY_IMAP_CLIENT_SERVICE_DEFAULT_MIN_POOL_SIZE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4291 "imap-client-service.c"
	/**
	     * Specifies the maximum number of free sessions to keep open.
	     *
	     * If there are already this number of free sessions available,
	     * the manager will close any additional sessions that are
	     * released, instead of keeping them for re-use. However it will
	     * not close sessions if doing so would reduce the size of the
	     * pool below {@link min_pool_size}.
	     *
	     * Setting this does not immediately adjust the pool size in
	     * either direction.  Adjustment will happen as connections are
	     * needed or closed.
	     */
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_CLIENT_SERVICE_MAX_FREE_SIZE_PROPERTY, geary_imap_client_service_properties[GEARY_IMAP_CLIENT_SERVICE_MAX_FREE_SIZE_PROPERTY] = g_param_spec_int ("max-free-size", "max-free-size", "max-free-size", G_MININT, G_MAXINT, GEARY_IMAP_CLIENT_SERVICE_DEFAULT_MAX_FREE_SIZE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4307 "imap-client-service.c"
	/** {@inheritDoc} */
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_CLIENT_SERVICE_LOGGING_DOMAIN_PROPERTY, geary_imap_client_service_properties[GEARY_IMAP_CLIENT_SERVICE_LOGGING_DOMAIN_PROPERTY] = g_param_spec_string ("logging-domain", "logging-domain", "logging-domain", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4311 "imap-client-service.c"
}

static void
geary_imap_client_service_instance_init (GearyImapClientService * self,
                                         gpointer klass)
{
	GearyImapQuirks* _tmp0_;
	GearyNonblockingMutex* _tmp1_;
	GeeHashSet* _tmp2_;
	GearyNonblockingQueue* _tmp3_;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	self->priv = geary_imap_client_service_get_instance_private (self);
#line 49 "../src/engine/imap/api/imap-client-service.vala"
	self->priv->_unselected_keepalive_sec = GEARY_IMAP_CLIENT_SESSION_DEFAULT_UNSELECTED_KEEPALIVE_SEC;
#line 57 "../src/engine/imap/api/imap-client-service.vala"
	self->priv->_selected_keepalive_sec = GEARY_IMAP_CLIENT_SESSION_DEFAULT_SELECTED_KEEPALIVE_SEC;
#line 65 "../src/engine/imap/api/imap-client-service.vala"
	self->priv->_selected_with_idle_keepalive_sec = GEARY_IMAP_CLIENT_SESSION_DEFAULT_SELECTED_WITH_IDLE_KEEPALIVE_SEC;
#line 77 "../src/engine/imap/api/imap-client-service.vala"
	self->priv->_min_pool_size = GEARY_IMAP_CLIENT_SERVICE_DEFAULT_MIN_POOL_SIZE;
#line 92 "../src/engine/imap/api/imap-client-service.vala"
	self->priv->_max_free_size = GEARY_IMAP_CLIENT_SERVICE_DEFAULT_MAX_FREE_SIZE;
#line 97 "../src/engine/imap/api/imap-client-service.vala"
	self->discard_returned_sessions = FALSE;
#line 104 "../src/engine/imap/api/imap-client-service.vala"
	_tmp0_ = geary_imap_quirks_new ();
#line 104 "../src/engine/imap/api/imap-client-service.vala"
	self->priv->quirks = _tmp0_;
#line 106 "../src/engine/imap/api/imap-client-service.vala"
	_tmp1_ = geary_nonblocking_mutex_new ();
#line 106 "../src/engine/imap/api/imap-client-service.vala"
	self->priv->sessions_mutex = _tmp1_;
#line 107 "../src/engine/imap/api/imap-client-service.vala"
	_tmp2_ = gee_hash_set_new (GEARY_IMAP_TYPE_CLIENT_SESSION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 107 "../src/engine/imap/api/imap-client-service.vala"
	self->priv->all_sessions = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_SET, GeeSet);
#line 109 "../src/engine/imap/api/imap-client-service.vala"
	_tmp3_ = geary_nonblocking_queue_new_fifo (GEARY_IMAP_TYPE_CLIENT_SESSION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 109 "../src/engine/imap/api/imap-client-service.vala"
	self->priv->free_queue = _tmp3_;
#line 112 "../src/engine/imap/api/imap-client-service.vala"
	self->priv->pool_cancellable = NULL;
#line 113 "../src/engine/imap/api/imap-client-service.vala"
	self->priv->close_cancellable = NULL;
#line 4356 "imap-client-service.c"
}

static void
geary_imap_client_service_finalize (GObject * obj)
{
	GearyImapClientService * self;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_IMAP_TYPE_CLIENT_SERVICE, GearyImapClientService);
#line 104 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (self->priv->quirks);
#line 106 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (self->priv->sessions_mutex);
#line 107 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (self->priv->all_sessions);
#line 109 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (self->priv->free_queue);
#line 112 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (self->priv->pool_cancellable);
#line 113 "../src/engine/imap/api/imap-client-service.vala"
	_g_object_unref0 (self->priv->close_cancellable);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	G_OBJECT_CLASS (geary_imap_client_service_parent_class)->finalize (obj);
#line 4379 "imap-client-service.c"
}

/**
 * Manages a pool of IMAP client sessions.
 *
 * When started and when the remote host is reachable, the manager
 * will establish a pool of {@link ClientSession} instances that are
 * connected to the service's endpoint, ensuring there are at least
 * {@link min_pool_size} available. A connected, authorised client
 * session can be obtained from the connection pool by calling {@link
 * claim_authorized_session_async}, and when finished with returned by
 * calling {@link release_session_async}.
 *
 * This class is not thread-safe.
 */
 G_GNUC_NO_INLINE static GType
geary_imap_client_service_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyImapClientServiceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_imap_client_service_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyImapClientService), 0, (GInstanceInitFunc) geary_imap_client_service_instance_init, NULL };
	GType geary_imap_client_service_type_id;
	geary_imap_client_service_type_id = g_type_register_static (GEARY_TYPE_CLIENT_SERVICE, "GearyImapClientService", &g_define_type_info, 0);
	GearyImapClientService_private_offset = g_type_add_instance_private (geary_imap_client_service_type_id, sizeof (GearyImapClientServicePrivate));
	return geary_imap_client_service_type_id;
}

GType
geary_imap_client_service_get_type (void)
{
	static gsize geary_imap_client_service_type_id__once = 0;
	if (g_once_init_enter (&geary_imap_client_service_type_id__once)) {
		GType geary_imap_client_service_type_id;
		geary_imap_client_service_type_id = geary_imap_client_service_get_type_once ();
		g_once_init_leave (&geary_imap_client_service_type_id__once, geary_imap_client_service_type_id);
	}
	return geary_imap_client_service_type_id__once;
}

static void
_vala_geary_imap_client_service_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	GearyImapClientService * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_TYPE_CLIENT_SERVICE, GearyImapClientService);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	switch (property_id) {
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		case GEARY_IMAP_CLIENT_SERVICE_UNSELECTED_KEEPALIVE_SEC_PROPERTY:
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		g_value_set_uint (value, geary_imap_client_service_get_unselected_keepalive_sec (self));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		break;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		case GEARY_IMAP_CLIENT_SERVICE_SELECTED_KEEPALIVE_SEC_PROPERTY:
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		g_value_set_uint (value, geary_imap_client_service_get_selected_keepalive_sec (self));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		break;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		case GEARY_IMAP_CLIENT_SERVICE_SELECTED_WITH_IDLE_KEEPALIVE_SEC_PROPERTY:
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		g_value_set_uint (value, geary_imap_client_service_get_selected_with_idle_keepalive_sec (self));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		break;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		case GEARY_IMAP_CLIENT_SERVICE_MIN_POOL_SIZE_PROPERTY:
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		g_value_set_int (value, geary_imap_client_service_get_min_pool_size (self));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		break;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		case GEARY_IMAP_CLIENT_SERVICE_MAX_FREE_SIZE_PROPERTY:
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		g_value_set_int (value, geary_imap_client_service_get_max_free_size (self));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		break;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		case GEARY_IMAP_CLIENT_SERVICE_LOGGING_DOMAIN_PROPERTY:
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		g_value_set_string (value, geary_client_service_get_logging_domain (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService)));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		break;
#line 4463 "imap-client-service.c"
		default:
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		break;
#line 4469 "imap-client-service.c"
	}
}

static void
_vala_geary_imap_client_service_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	GearyImapClientService * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_TYPE_CLIENT_SERVICE, GearyImapClientService);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
	switch (property_id) {
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		case GEARY_IMAP_CLIENT_SERVICE_UNSELECTED_KEEPALIVE_SEC_PROPERTY:
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		geary_imap_client_service_set_unselected_keepalive_sec (self, g_value_get_uint (value));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		break;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		case GEARY_IMAP_CLIENT_SERVICE_SELECTED_KEEPALIVE_SEC_PROPERTY:
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		geary_imap_client_service_set_selected_keepalive_sec (self, g_value_get_uint (value));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		break;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		case GEARY_IMAP_CLIENT_SERVICE_SELECTED_WITH_IDLE_KEEPALIVE_SEC_PROPERTY:
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		geary_imap_client_service_set_selected_with_idle_keepalive_sec (self, g_value_get_uint (value));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		break;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		case GEARY_IMAP_CLIENT_SERVICE_MIN_POOL_SIZE_PROPERTY:
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		geary_imap_client_service_set_min_pool_size (self, g_value_get_int (value));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		break;
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		case GEARY_IMAP_CLIENT_SERVICE_MAX_FREE_SIZE_PROPERTY:
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		geary_imap_client_service_set_max_free_size (self, g_value_get_int (value));
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		break;
#line 4513 "imap-client-service.c"
		default:
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/engine/imap/api/imap-client-service.vala"
		break;
#line 4519 "imap-client-service.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

