/* imap-client-connection.c generated by valac 0.56.17, the Vala compiler
 * generated from imap-client-connection.vala, do not modify */

/*
 * Copyright © 2016 Software Freedom Conservancy Inc.
 * Copyright © 2018-2020 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_IMAP_CLIENT_CONNECTION_0_PROPERTY,
	GEARY_IMAP_CLIENT_CONNECTION_IDLE_WHEN_QUIET_PROPERTY,
	GEARY_IMAP_CLIENT_CONNECTION_LOGGING_PARENT_PROPERTY,
	GEARY_IMAP_CLIENT_CONNECTION_NUM_PROPERTIES
};
static GParamSpec* geary_imap_client_connection_properties[GEARY_IMAP_CLIENT_CONNECTION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _GearyImapClientConnectionConnectAsyncData GearyImapClientConnectionConnectAsyncData;
typedef struct _GearyImapClientConnectionDisconnectAsyncData GearyImapClientConnectionDisconnectAsyncData;
typedef struct _GearyImapClientConnectionStarttlsAsyncData GearyImapClientConnectionStarttlsAsyncData;
typedef struct _GearyImapClientConnectionOpenChannelsAsyncData GearyImapClientConnectionOpenChannelsAsyncData;
typedef struct _GearyImapClientConnectionCloseChannelsAsyncData GearyImapClientConnectionCloseChannelsAsyncData;
typedef struct _GearyImapClientConnectionSendLoopData GearyImapClientConnectionSendLoopData;
typedef struct _GearyImapClientConnectionFlushCommandData GearyImapClientConnectionFlushCommandData;
enum  {
	GEARY_IMAP_CLIENT_CONNECTION_SENT_COMMAND_SIGNAL,
	GEARY_IMAP_CLIENT_CONNECTION_RECEIVED_STATUS_RESPONSE_SIGNAL,
	GEARY_IMAP_CLIENT_CONNECTION_RECEIVED_SERVER_DATA_SIGNAL,
	GEARY_IMAP_CLIENT_CONNECTION_RECEIVED_CONTINUATION_RESPONSE_SIGNAL,
	GEARY_IMAP_CLIENT_CONNECTION_RECEIVED_BYTES_SIGNAL,
	GEARY_IMAP_CLIENT_CONNECTION_RECEIVED_BAD_RESPONSE_SIGNAL,
	GEARY_IMAP_CLIENT_CONNECTION_SEND_FAILURE_SIGNAL,
	GEARY_IMAP_CLIENT_CONNECTION_RECEIVE_FAILURE_SIGNAL,
	GEARY_IMAP_CLIENT_CONNECTION_NUM_SIGNALS
};
static guint geary_imap_client_connection_signals[GEARY_IMAP_CLIENT_CONNECTION_NUM_SIGNALS] = {0};

struct _GearyImapClientConnectionPrivate {
	gboolean _idle_when_quiet;
	GearyLoggingSource* _logging_parent;
	GearyEndpoint* endpoint;
	gint cx_id;
	GearyImapQuirks* quirks;
	GIOStream* cx;
	GearyImapDeserializer* deserializer;
	GearyImapSerializer* serializer;
	gint tag_counter;
	gchar tag_prefix;
	gint64 last_seen;
	gsize bytes_accumulator;
	GearyNonblockingQueue* pending_queue;
	GeeQueue* sent_queue;
	GearyImapCommand* current_command;
	guint command_timeout;
	GearyTimeoutManager* idle_timer;
	GCancellable* open_cancellable;
};

struct _GearyImapClientConnectionConnectAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientConnection* self;
	GCancellable* cancellable;
	GIOStream* _tmp0_;
	GError* _tmp1_;
	GSocketConnection* _tmp2_;
	GearyEndpoint* _tmp3_;
	GSocketConnection* _tmp4_;
	GSocketConnection* _tmp5_;
	GearyNonblockingQueue* _tmp6_;
	GeeQueue* _tmp7_;
	GError* err;
	GIOStream* _tmp8_;
	GError* _tmp9_;
	GError* _tmp10_;
	gboolean _tmp11_;
	GearyTimeoutManager* _tmp12_;
	GError* _inner_error0_;
};

struct _GearyImapClientConnectionDisconnectAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientConnection* self;
	GCancellable* cancellable;
	GIOStream* _tmp0_;
	GearyTimeoutManager* _tmp1_;
	GIOStream* old_cx;
	GIOStream* _tmp2_;
	GIOStream* _tmp3_;
	GeeIterator* _pending_it;
	GearyNonblockingQueue* _tmp4_;
	GeeCollection* _tmp5_;
	GeeCollection* _tmp6_;
	GeeIterator* _tmp7_;
	GeeIterator* _tmp8_;
	GeeIterator* _tmp9_;
	GearyImapCommand* pending;
	GeeIterator* _tmp10_;
	gpointer _tmp11_;
	GearyImapCommand* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GearyImapCommand* _tmp15_;
	GearyNonblockingQueue* _tmp16_;
	GIOStream* _tmp17_;
	GTlsConnection* tls_cx;
	GIOStream* _tmp18_;
	GTlsConnection* _tmp19_;
	gboolean _tmp20_;
	GTlsConnection* _tmp21_;
	GTlsConnection* _tmp22_;
	GIOStream* _tmp23_;
	GIOStream* _tmp24_;
	GIOStream* _tmp25_;
	GTlsConnection* _tmp26_;
	GIOStream* _tmp27_;
	GIOStream* _tmp28_;
	GIOStream* _tmp29_;
	GError* _inner_error0_;
};

struct _GearyImapClientConnectionStarttlsAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientConnection* self;
	GCancellable* cancellable;
	GIOStream* _tmp0_;
	GError* _tmp1_;
	GIOStream* _tmp2_;
	GError* _tmp3_;
	GTlsClientConnection* _tmp4_;
	GearyEndpoint* _tmp5_;
	GIOStream* _tmp6_;
	GTlsClientConnection* _tmp7_;
	GTlsClientConnection* _tmp8_;
	GError* _inner_error0_;
};

struct _GearyImapClientConnectionOpenChannelsAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientConnection* self;
	GCancellable* _tmp0_;
	gchar* id;
	gchar* _tmp1_;
	GBufferedOutputStream* serializer_buffer;
	GIOStream* _tmp2_;
	GOutputStream* _tmp3_;
	GOutputStream* _tmp4_;
	GBufferedOutputStream* _tmp5_;
	GearyImapSerializer* _tmp6_;
	GIOStream* _tmp7_;
	GInputStream* _tmp8_;
	GInputStream* _tmp9_;
	GearyImapQuirks* _tmp10_;
	GearyImapDeserializer* _tmp11_;
	GearyImapDeserializer* _tmp12_;
	GearyImapDeserializer* _tmp13_;
	GearyImapDeserializer* _tmp14_;
	GearyImapDeserializer* _tmp15_;
	GearyImapDeserializer* _tmp16_;
	GearyImapDeserializer* _tmp17_;
	GearyImapDeserializer* _tmp18_;
	GError* _inner_error0_;
};

struct _GearyImapClientConnectionCloseChannelsAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientConnection* self;
	GCancellable* cancellable;
	GCancellable* _tmp0_;
	GeeIterator* _sent_it;
	GeeQueue* _tmp1_;
	GeeIterator* _tmp2_;
	GeeIterator* _tmp3_;
	GearyImapCommand* sent;
	GeeIterator* _tmp4_;
	gpointer _tmp5_;
	GearyImapCommand* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GearyImapCommand* _tmp9_;
	GeeQueue* _tmp10_;
	GearyImapSerializer* _tmp11_;
	GearyImapSerializer* _tmp12_;
	GearyImapDeserializer* deserializer;
	GearyImapDeserializer* _tmp13_;
	GearyImapDeserializer* _tmp14_;
	GearyImapDeserializer* _tmp15_;
	GearyImapDeserializer* _tmp16_;
	guint _tmp17_;
	GearyImapDeserializer* _tmp18_;
	guint _tmp19_;
	GearyImapDeserializer* _tmp20_;
	guint _tmp21_;
	GearyImapDeserializer* _tmp22_;
	guint _tmp23_;
	GearyImapDeserializer* _tmp24_;
	guint _tmp25_;
	GearyImapDeserializer* _tmp26_;
	GError* _inner_error0_;
};

struct _GearyImapClientConnectionSendLoopData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientConnection* self;
	GCancellable* _tmp0_;
	GCancellable* cancellable;
	GCancellable* _tmp1_;
	GCancellable* _tmp2_;
	GearyImapCommand* pending;
	GearyNonblockingQueue* _tmp3_;
	GCancellable* _tmp4_;
	gpointer _tmp5_;
	gboolean _tmp6_;
	GearyImapCommand* _tmp7_;
	GearyNonblockingQueue* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GearyImapCommand* _tmp11_;
	GCancellable* _tmp12_;
	GearyNonblockingQueue* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	GearyImapSerializer* _tmp16_;
	GCancellable* _tmp17_;
	GError* err;
	GError* _tmp18_;
	GError* _tmp19_;
	GError* _inner_error0_;
};

struct _GearyImapClientConnectionFlushCommandData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientConnection* self;
	GearyImapCommand* command;
	GCancellable* cancellable;
	gboolean _tmp0_;
	GCancellable* _tmp1_;
	GCancellable* _tmp2_;
	GCancellable* _tmp3_;
	GCancellable* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GError* _tmp7_;
	GError* _tmp8_;
	GError* ser_error;
	GearyImapTag* _tmp9_;
	GearyImapTag* _tmp10_;
	GearyImapCommand* _tmp11_;
	GeeQueue* _tmp12_;
	GearyImapSerializer* _tmp13_;
	GearyImapSerializer* _tmp14_;
	GError* err;
	GError* _tmp15_;
	GError* _tmp16_;
	GError* _tmp17_;
	GeeQueue* _tmp18_;
	GError* _tmp19_;
	GError* _tmp20_;
	GError* _inner_error0_;
};

static gint GearyImapClientConnection_private_offset;
static gpointer geary_imap_client_connection_parent_class = NULL;
static gint geary_imap_client_connection_next_cx_id;
static gint geary_imap_client_connection_next_cx_id = 0;
static GearyLoggingSourceIface * geary_imap_client_connection_geary_logging_source_parent_iface = NULL;

static void geary_imap_client_connection_set_idle_when_quiet (GearyImapClientConnection* self,
                                                       gboolean value);
static void geary_imap_client_connection_real_sent_command (GearyImapClientConnection* self,
                                                     GearyImapCommand* cmd);
static void geary_imap_client_connection_real_received_status_response (GearyImapClientConnection* self,
                                                                 GearyImapStatusResponse* status_response);
static void geary_imap_client_connection_real_received_server_data (GearyImapClientConnection* self,
                                                             GearyImapServerData* server_data);
static void geary_imap_client_connection_real_received_continuation_response (GearyImapClientConnection* self,
                                                                       GearyImapContinuationResponse* continuation_response);
static void g_cclosure_user_marshal_VOID__OBJECT_BOXED (GClosure * closure,
                                                 GValue * return_value,
                                                 guint n_param_values,
                                                 const GValue * param_values,
                                                 gpointer invocation_hint,
                                                 gpointer marshal_data);
static void geary_imap_client_connection_on_idle_timeout (GearyImapClientConnection* self);
static void _geary_imap_client_connection_on_idle_timeout_geary_timeout_manager_timeout_func (GearyTimeoutManager* manager,
                                                                                       gpointer self);
static GTcpConnection* geary_imap_client_connection_getTcpConnection (GearyImapClientConnection* self);
static inline void geary_imap_client_connection_cancel_idle (GearyImapClientConnection* self);
static void geary_imap_client_connection_connect_async_data_free (gpointer _data);
static gboolean geary_imap_client_connection_connect_async_co (GearyImapClientConnectionConnectAsyncData* _data_);
static void geary_imap_client_connection_connect_async_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_);
static void geary_imap_client_connection_open_channels_async (GearyImapClientConnection* self,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_);
static void geary_imap_client_connection_open_channels_finish (GearyImapClientConnection* self,
                                                        GAsyncResult* _res_,
                                                        GError** error);
static void geary_imap_client_connection_disconnect_async_data_free (gpointer _data);
static gboolean geary_imap_client_connection_disconnect_async_co (GearyImapClientConnectionDisconnectAsyncData* _data_);
VALA_EXTERN gchar* geary_imap_command_to_brief_string (GearyImapCommand* self);
VALA_EXTERN void geary_imap_command_disconnected (GearyImapCommand* self,
                                      const gchar* reason);
static void geary_imap_client_connection_close_channels_async (GearyImapClientConnection* self,
                                                        GCancellable* cancellable,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_);
static void geary_imap_client_connection_close_channels_finish (GearyImapClientConnection* self,
                                                         GAsyncResult* _res_,
                                                         GError** error);
static void geary_imap_client_connection_disconnect_async_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_);
static void geary_imap_client_connection_starttls_async_data_free (gpointer _data);
static gboolean geary_imap_client_connection_starttls_async_co (GearyImapClientConnectionStarttlsAsyncData* _data_);
static void geary_imap_client_connection_starttls_async_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_);
static void geary_imap_client_connection_check_connection (GearyImapClientConnection* self,
                                                    GError** error);
VALA_EXTERN void geary_imap_command_cancelled_before_send (GearyImapCommand* self);
static GearyLoggingState* geary_imap_client_connection_real_to_logging_state (GearyLoggingSource* base);
VALA_EXTERN GearyImapCommand* geary_imap_client_connection_get_sent_command (GearyImapClientConnection* self,
                                                                 GearyImapTag* tag);
VALA_EXTERN void geary_imap_client_connection_set_logging_parent (GearyImapClientConnection* self,
                                                      GearyLoggingSource* parent);
static void geary_imap_client_connection_open_channels_async_data_free (gpointer _data);
static gboolean geary_imap_client_connection_open_channels_async_co (GearyImapClientConnectionOpenChannelsAsyncData* _data_);
static void geary_imap_client_connection_on_bytes_received (GearyImapClientConnection* self,
                                                     gsize bytes);
static void _geary_imap_client_connection_on_bytes_received_geary_imap_deserializer_bytes_received (GearyImapDeserializer* _sender,
                                                                                             gsize bytes,
                                                                                             gpointer self);
static void geary_imap_client_connection_on_deserialize_failure (GearyImapClientConnection* self);
static void _geary_imap_client_connection_on_deserialize_failure_geary_imap_deserializer_deserialize_failure (GearyImapDeserializer* _sender,
                                                                                                       gpointer self);
static void geary_imap_client_connection_on_eos (GearyImapClientConnection* self);
static void _geary_imap_client_connection_on_eos_geary_imap_deserializer_end_of_stream (GearyImapDeserializer* _sender,
                                                                                 gpointer self);
static void geary_imap_client_connection_on_parameters_ready (GearyImapClientConnection* self,
                                                       GearyImapRootParameters* root);
static void _geary_imap_client_connection_on_parameters_ready_geary_imap_deserializer_parameters_ready (GearyImapDeserializer* _sender,
                                                                                                 GearyImapRootParameters* root,
                                                                                                 gpointer self);
static void geary_imap_client_connection_on_receive_failure (GearyImapClientConnection* self,
                                                      GError* err);
static void _geary_imap_client_connection_on_receive_failure_geary_imap_deserializer_receive_failure (GearyImapDeserializer* _sender,
                                                                                               GError* err,
                                                                                               gpointer self);
VALA_EXTERN void geary_imap_deserializer_set_logging_parent (GearyImapDeserializer* self,
                                                 GearyLoggingSource* parent);
static void geary_imap_client_connection_open_channels_async_ready (GObject* source_object,
                                                             GAsyncResult* _res_,
                                                             gpointer _user_data_);
static void geary_imap_client_connection_send_loop (GearyImapClientConnection* self,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
static void geary_imap_client_connection_send_loop_finish (GearyImapClientConnection* self,
                                                    GAsyncResult* _res_);
static void geary_imap_client_connection_close_channels_async_data_free (gpointer _data);
static gboolean geary_imap_client_connection_close_channels_async_co (GearyImapClientConnectionCloseChannelsAsyncData* _data_);
static void geary_imap_client_connection_close_channels_async_ready (GObject* source_object,
                                                              GAsyncResult* _res_,
                                                              gpointer _user_data_);
static GearyImapTag* geary_imap_client_connection_generate_tag (GearyImapClientConnection* self);
static void geary_imap_client_connection_send_loop_data_free (gpointer _data);
static gboolean geary_imap_client_connection_send_loop_co (GearyImapClientConnectionSendLoopData* _data_);
static void geary_imap_client_connection_send_loop_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_);
static void geary_imap_client_connection_flush_command (GearyImapClientConnection* self,
                                                 GearyImapCommand* command,
                                                 GCancellable* cancellable,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
static void geary_imap_client_connection_flush_command_finish (GearyImapClientConnection* self,
                                                        GAsyncResult* _res_,
                                                        GError** error);
static void geary_imap_client_connection_flush_command_data_free (gpointer _data);
static gboolean geary_imap_client_connection_flush_command_co (GearyImapClientConnectionFlushCommandData* _data_);
VALA_EXTERN void geary_imap_command_assign_tag (GearyImapCommand* self,
                                    GearyImapTag* new_tag,
                                    GError** error);
static void geary_imap_client_connection_on_command_timeout (GearyImapClientConnection* self,
                                                      GearyImapCommand* command);
static void _geary_imap_client_connection_on_command_timeout_geary_imap_command_response_timed_out (GearyImapCommand* _sender,
                                                                                             gpointer self);
VALA_EXTERN void geary_imap_command_send (GearyImapCommand* self,
                              GearyImapSerializer* ser,
                              GCancellable* cancellable,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_);
VALA_EXTERN void geary_imap_command_send_finish (GearyImapCommand* self,
                                     GAsyncResult* _res_,
                                     GError** error);
static void geary_imap_client_connection_flush_command_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_);
VALA_EXTERN void geary_imap_command_send_wait (GearyImapCommand* self,
                                   GearyImapSerializer* ser,
                                   GCancellable* cancellable,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
VALA_EXTERN void geary_imap_command_send_wait_finish (GearyImapCommand* self,
                                          GAsyncResult* _res_,
                                          GError** error);
static void geary_imap_client_connection_on_continuation_response (GearyImapClientConnection* self,
                                                            GearyImapContinuationResponse* continuation,
                                                            GError** error);
static void geary_imap_client_connection_on_status_response (GearyImapClientConnection* self,
                                                      GearyImapStatusResponse* status,
                                                      GError** error);
static void geary_imap_client_connection_on_server_data (GearyImapClientConnection* self,
                                                  GearyImapServerData* data,
                                                  GError** error);
VALA_EXTERN void geary_imap_command_completed (GearyImapCommand* self,
                                   GearyImapStatusResponse* new_status,
                                   GError** error);
VALA_EXTERN void geary_imap_command_data_received (GearyImapCommand* self,
                                       GearyImapServerData* data,
                                       GError** error);
VALA_EXTERN void geary_imap_command_continuation_requested (GearyImapCommand* self,
                                                GearyImapContinuationResponse* continuation,
                                                GError** error);
VALA_EXTERN void geary_imap_command_update_response_timer (GearyImapCommand* self);
static void geary_imap_client_connection_finalize (GObject * obj);
static GType geary_imap_client_connection_get_type_once (void);
static void _vala_geary_imap_client_connection_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_geary_imap_client_connection_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);

static inline gpointer
geary_imap_client_connection_get_instance_private (GearyImapClientConnection* self)
{
	return G_STRUCT_MEMBER_P (self, GearyImapClientConnection_private_offset);
}

gboolean
geary_imap_client_connection_get_idle_when_quiet (GearyImapClientConnection* self)
{
	gboolean result;
#line 54 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self), FALSE);
#line 54 "../src/engine/imap/transport/imap-client-connection.vala"
	result = self->priv->_idle_when_quiet;
#line 54 "../src/engine/imap/transport/imap-client-connection.vala"
	return result;
#line 496 "imap-client-connection.c"
}

static void
geary_imap_client_connection_set_idle_when_quiet (GearyImapClientConnection* self,
                                                  gboolean value)
{
	gboolean old_value;
#line 54 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self));
#line 54 "../src/engine/imap/transport/imap-client-connection.vala"
	old_value = geary_imap_client_connection_get_idle_when_quiet (self);
#line 54 "../src/engine/imap/transport/imap-client-connection.vala"
	if (old_value != value) {
#line 54 "../src/engine/imap/transport/imap-client-connection.vala"
		self->priv->_idle_when_quiet = value;
#line 54 "../src/engine/imap/transport/imap-client-connection.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_imap_client_connection_properties[GEARY_IMAP_CLIENT_CONNECTION_IDLE_WHEN_QUIET_PROPERTY]);
#line 514 "imap-client-connection.c"
	}
}

static const gchar*
geary_imap_client_connection_real_get_logging_domain (GearyLoggingSource* base)
{
	const gchar* result;
	GearyImapClientConnection* self;
#line 59 "../src/engine/imap/transport/imap-client-connection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_IMAP_TYPE_CLIENT_CONNECTION, GearyImapClientConnection);
#line 59 "../src/engine/imap/transport/imap-client-connection.vala"
	result = GEARY_IMAP_CLIENT_SERVICE_PROTOCOL_LOGGING_DOMAIN;
#line 59 "../src/engine/imap/transport/imap-client-connection.vala"
	return result;
#line 529 "imap-client-connection.c"
}

static GearyLoggingSource*
geary_imap_client_connection_real_get_logging_parent (GearyLoggingSource* base)
{
	GearyLoggingSource* result;
	GearyImapClientConnection* self;
	GearyLoggingSource* _tmp0_;
#line 63 "../src/engine/imap/transport/imap-client-connection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_IMAP_TYPE_CLIENT_CONNECTION, GearyImapClientConnection);
#line 63 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = self->priv->_logging_parent;
#line 63 "../src/engine/imap/transport/imap-client-connection.vala"
	result = _tmp0_;
#line 63 "../src/engine/imap/transport/imap-client-connection.vala"
	return result;
#line 546 "imap-client-connection.c"
}

static void
geary_imap_client_connection_real_sent_command (GearyImapClientConnection* self,
                                                GearyImapCommand* cmd)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 91 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (cmd));
#line 92 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = geary_imap_command_to_string (cmd);
#line 92 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp1_ = _tmp0_;
#line 92 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "SEND: %s", _tmp1_);
#line 92 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_free0 (_tmp1_);
#line 565 "imap-client-connection.c"
}

static void
geary_imap_client_connection_real_received_status_response (GearyImapClientConnection* self,
                                                            GearyImapStatusResponse* status_response)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 95 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_STATUS_RESPONSE (status_response));
#line 96 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (status_response, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 96 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp1_ = _tmp0_;
#line 96 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "RECV: %s", _tmp1_);
#line 96 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_free0 (_tmp1_);
#line 584 "imap-client-connection.c"
}

static void
geary_imap_client_connection_real_received_server_data (GearyImapClientConnection* self,
                                                        GearyImapServerData* server_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 99 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_SERVER_DATA (server_data));
#line 100 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (server_data, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 100 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp1_ = _tmp0_;
#line 100 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "RECV: %s", _tmp1_);
#line 100 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_free0 (_tmp1_);
#line 603 "imap-client-connection.c"
}

static void
geary_imap_client_connection_real_received_continuation_response (GearyImapClientConnection* self,
                                                                  GearyImapContinuationResponse* continuation_response)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 103 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CONTINUATION_RESPONSE (continuation_response));
#line 104 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (continuation_response, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 104 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp1_ = _tmp0_;
#line 104 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "RECV: %s", _tmp1_);
#line 104 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_free0 (_tmp1_);
#line 622 "imap-client-connection.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_BOXED (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_BOXED) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_BOXED callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (n_param_values == 3);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
		data1 = closure->data;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
		data2 = param_values->data[0].v_pointer;
#line 647 "imap-client-connection.c"
	} else {
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
		data1 = param_values->data[0].v_pointer;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
		data2 = closure->data;
#line 653 "imap-client-connection.c"
	}
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	callback = (GMarshalFunc_VOID__OBJECT_BOXED) (marshal_data ? marshal_data : cc->callback);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_boxed (param_values + 2), data2);
#line 659 "imap-client-connection.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 122 "../src/engine/imap/transport/imap-client-connection.vala"
	return self ? g_object_ref (self) : NULL;
#line 667 "imap-client-connection.c"
}

static void
_geary_imap_client_connection_on_idle_timeout_geary_timeout_manager_timeout_func (GearyTimeoutManager* manager,
                                                                                  gpointer self)
{
#line 126 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_on_idle_timeout ((GearyImapClientConnection*) self);
#line 676 "imap-client-connection.c"
}

GearyImapClientConnection*
geary_imap_client_connection_construct (GType object_type,
                                        GearyEndpoint* endpoint,
                                        GearyImapQuirks* quirks,
                                        guint command_timeout,
                                        guint idle_timeout_sec)
{
	GearyImapClientConnection * self = NULL;
	GearyEndpoint* _tmp0_;
	GearyImapQuirks* _tmp1_;
	gint _tmp2_;
	GearyTimeoutManager* _tmp3_;
#line 117 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (endpoint), NULL);
#line 117 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_QUIRKS (quirks), NULL);
#line 117 "../src/engine/imap/transport/imap-client-connection.vala"
	self = (GearyImapClientConnection*) geary_base_object_construct (object_type);
#line 122 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = _g_object_ref0 (endpoint);
#line 122 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (self->priv->endpoint);
#line 122 "../src/engine/imap/transport/imap-client-connection.vala"
	self->priv->endpoint = _tmp0_;
#line 123 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp1_ = _g_object_ref0 (quirks);
#line 123 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (self->priv->quirks);
#line 123 "../src/engine/imap/transport/imap-client-connection.vala"
	self->priv->quirks = _tmp1_;
#line 124 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp2_ = geary_imap_client_connection_next_cx_id;
#line 124 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_next_cx_id = _tmp2_ + 1;
#line 124 "../src/engine/imap/transport/imap-client-connection.vala"
	self->priv->cx_id = _tmp2_;
#line 125 "../src/engine/imap/transport/imap-client-connection.vala"
	self->priv->command_timeout = command_timeout;
#line 126 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp3_ = geary_timeout_manager_new_seconds (idle_timeout_sec, _geary_imap_client_connection_on_idle_timeout_geary_timeout_manager_timeout_func, self);
#line 126 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (self->priv->idle_timer);
#line 126 "../src/engine/imap/transport/imap-client-connection.vala"
	self->priv->idle_timer = _tmp3_;
#line 117 "../src/engine/imap/transport/imap-client-connection.vala"
	return self;
#line 725 "imap-client-connection.c"
}

GearyImapClientConnection*
geary_imap_client_connection_new (GearyEndpoint* endpoint,
                                  GearyImapQuirks* quirks,
                                  guint command_timeout,
                                  guint idle_timeout_sec)
{
#line 117 "../src/engine/imap/transport/imap-client-connection.vala"
	return geary_imap_client_connection_construct (GEARY_IMAP_TYPE_CLIENT_CONNECTION, endpoint, quirks, command_timeout, idle_timeout_sec);
#line 736 "imap-client-connection.c"
}

/** Returns the remote address of this connection, if any. */
GSocketAddress*
geary_imap_client_connection_get_remote_address (GearyImapClientConnection* self,
                                                 GError** error)
{
	GSocketAddress* addr = NULL;
	GTcpConnection* tcp_cx = NULL;
	GTcpConnection* _tmp0_;
	GTcpConnection* _tmp1_;
	GError* _inner_error0_ = NULL;
	GSocketAddress* result;
#line 132 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self), NULL);
#line 133 "../src/engine/imap/transport/imap-client-connection.vala"
	addr = NULL;
#line 134 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = geary_imap_client_connection_getTcpConnection (self);
#line 134 "../src/engine/imap/transport/imap-client-connection.vala"
	tcp_cx = _tmp0_;
#line 135 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp1_ = tcp_cx;
#line 135 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_tmp1_ != NULL) {
#line 762 "imap-client-connection.c"
		GSocketAddress* _tmp2_ = NULL;
		GTcpConnection* _tmp3_;
		GSocketAddress* _tmp4_;
		GSocketAddress* _tmp5_;
#line 136 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp3_ = tcp_cx;
#line 136 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp4_ = g_socket_connection_get_remote_address (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_socket_connection_get_type (), GSocketConnection), &_inner_error0_);
#line 136 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp2_ = _tmp4_;
#line 136 "../src/engine/imap/transport/imap-client-connection.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 136 "../src/engine/imap/transport/imap-client-connection.vala"
			g_propagate_error (error, _inner_error0_);
#line 136 "../src/engine/imap/transport/imap-client-connection.vala"
			_g_object_unref0 (tcp_cx);
#line 136 "../src/engine/imap/transport/imap-client-connection.vala"
			_g_object_unref0 (addr);
#line 136 "../src/engine/imap/transport/imap-client-connection.vala"
			return NULL;
#line 783 "imap-client-connection.c"
		}
#line 136 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp5_ = _tmp2_;
#line 136 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp2_ = NULL;
#line 136 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_object_unref0 (addr);
#line 136 "../src/engine/imap/transport/imap-client-connection.vala"
		addr = _tmp5_;
#line 135 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_object_unref0 (_tmp2_);
#line 795 "imap-client-connection.c"
	}
#line 138 "../src/engine/imap/transport/imap-client-connection.vala"
	result = addr;
#line 138 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (tcp_cx);
#line 138 "../src/engine/imap/transport/imap-client-connection.vala"
	return result;
#line 803 "imap-client-connection.c"
}

/** Returns the local address of this connection, if any. */
GSocketAddress*
geary_imap_client_connection_get_local_address (GearyImapClientConnection* self,
                                                GError** error)
{
	GSocketAddress* addr = NULL;
	GTcpConnection* tcp_cx = NULL;
	GTcpConnection* _tmp0_;
	GTcpConnection* _tmp1_;
	GError* _inner_error0_ = NULL;
	GSocketAddress* result;
#line 142 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self), NULL);
#line 143 "../src/engine/imap/transport/imap-client-connection.vala"
	addr = NULL;
#line 144 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = geary_imap_client_connection_getTcpConnection (self);
#line 144 "../src/engine/imap/transport/imap-client-connection.vala"
	tcp_cx = _tmp0_;
#line 145 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp1_ = tcp_cx;
#line 145 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_tmp1_ != NULL) {
#line 829 "imap-client-connection.c"
		GSocketAddress* _tmp2_ = NULL;
		GTcpConnection* _tmp3_;
		GSocketAddress* _tmp4_;
		GSocketAddress* _tmp5_;
#line 146 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp3_ = tcp_cx;
#line 146 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp4_ = g_socket_connection_get_local_address (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_socket_connection_get_type (), GSocketConnection), &_inner_error0_);
#line 146 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp2_ = _tmp4_;
#line 146 "../src/engine/imap/transport/imap-client-connection.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 146 "../src/engine/imap/transport/imap-client-connection.vala"
			g_propagate_error (error, _inner_error0_);
#line 146 "../src/engine/imap/transport/imap-client-connection.vala"
			_g_object_unref0 (tcp_cx);
#line 146 "../src/engine/imap/transport/imap-client-connection.vala"
			_g_object_unref0 (addr);
#line 146 "../src/engine/imap/transport/imap-client-connection.vala"
			return NULL;
#line 850 "imap-client-connection.c"
		}
#line 146 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp5_ = _tmp2_;
#line 146 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp2_ = NULL;
#line 146 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_object_unref0 (addr);
#line 146 "../src/engine/imap/transport/imap-client-connection.vala"
		addr = _tmp5_;
#line 145 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_object_unref0 (_tmp2_);
#line 862 "imap-client-connection.c"
	}
#line 148 "../src/engine/imap/transport/imap-client-connection.vala"
	result = addr;
#line 148 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (tcp_cx);
#line 148 "../src/engine/imap/transport/imap-client-connection.vala"
	return result;
#line 870 "imap-client-connection.c"
}

/**
     * Determines if the connection has an outstanding IDLE command.
     */
gboolean
geary_imap_client_connection_is_in_idle (GearyImapClientConnection* self)
{
	GearyImapCommand* _tmp0_;
	gboolean result;
#line 154 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self), FALSE);
#line 155 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = self->priv->current_command;
#line 155 "../src/engine/imap/transport/imap-client-connection.vala"
	result = GEARY_IMAP_IS_IDLE_COMMAND (_tmp0_);
#line 155 "../src/engine/imap/transport/imap-client-connection.vala"
	return result;
#line 889 "imap-client-connection.c"
}

/**
     * Sets whether this connection should automatically IDLE.
     *
     * If true, this will cause the connection to send an IDLE command
     * when no other commands have been sent after a short period of
     * time
     *
     * If false, any existing IDLE command will be cancelled, and the
     * connection will no longer be automatically sent.
     */
void
geary_imap_client_connection_enable_idle_when_quiet (GearyImapClientConnection* self,
                                                     gboolean do_idle)
{
#line 168 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self));
#line 169 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_set_idle_when_quiet (self, do_idle);
#line 170 "../src/engine/imap/transport/imap-client-connection.vala"
	if (do_idle) {
#line 912 "imap-client-connection.c"
		GearyTimeoutManager* _tmp0_;
		gboolean _tmp1_;
		gboolean _tmp2_;
#line 171 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp0_ = self->priv->idle_timer;
#line 171 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp1_ = geary_timeout_manager_get_is_running (_tmp0_);
#line 171 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp2_ = _tmp1_;
#line 171 "../src/engine/imap/transport/imap-client-connection.vala"
		if (!_tmp2_) {
#line 924 "imap-client-connection.c"
			GearyTimeoutManager* _tmp3_;
#line 172 "../src/engine/imap/transport/imap-client-connection.vala"
			_tmp3_ = self->priv->idle_timer;
#line 172 "../src/engine/imap/transport/imap-client-connection.vala"
			geary_timeout_manager_start (_tmp3_);
#line 930 "imap-client-connection.c"
		}
	} else {
#line 175 "../src/engine/imap/transport/imap-client-connection.vala"
		geary_imap_client_connection_cancel_idle (self);
#line 935 "imap-client-connection.c"
	}
}

static void
geary_imap_client_connection_connect_async_data_free (gpointer _data)
{
	GearyImapClientConnectionConnectAsyncData* _data_;
	_data_ = _data;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->self);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_slice_free (GearyImapClientConnectionConnectAsyncData, _data_);
#line 950 "imap-client-connection.c"
}

void
geary_imap_client_connection_connect_async (GearyImapClientConnection* self,
                                            GCancellable* cancellable,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	GearyImapClientConnectionConnectAsyncData* _data_;
	GearyImapClientConnection* _tmp0_;
	GCancellable* _tmp1_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self));
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_ = g_slice_new0 (GearyImapClientConnectionConnectAsyncData);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_connection_connect_async_data_free);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->self = _tmp0_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->cancellable = _tmp1_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_connect_async_co (_data_);
#line 984 "imap-client-connection.c"
}

void
geary_imap_client_connection_connect_finish (GearyImapClientConnection* self,
                                             GAsyncResult* _res_,
                                             GError** error)
{
	GearyImapClientConnectionConnectAsyncData* _data_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	if (NULL == _data_) {
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
		return;
#line 999 "imap-client-connection.c"
	}
}

/**
     * Establishes a connection to the connection's endpoint.
     */
static void
geary_imap_client_connection_connect_async_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_)
{
	GearyImapClientConnectionConnectAsyncData* _data_;
#line 187 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_ = _user_data_;
#line 187 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_source_object_ = source_object;
#line 187 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_res_ = _res_;
#line 187 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_connect_async_co (_data_);
#line 1020 "imap-client-connection.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 204 "../src/engine/imap/transport/imap-client-connection.vala"
	return self ? g_error_copy (self) : NULL;
#line 1028 "imap-client-connection.c"
}

static gboolean
geary_imap_client_connection_connect_async_co (GearyImapClientConnectionConnectAsyncData* _data_)
{
#line 182 "../src/engine/imap/transport/imap-client-connection.vala"
	switch (_data_->_state_) {
#line 182 "../src/engine/imap/transport/imap-client-connection.vala"
		case 0:
#line 1038 "imap-client-connection.c"
		goto _state_0;
#line 182 "../src/engine/imap/transport/imap-client-connection.vala"
		case 1:
#line 1042 "imap-client-connection.c"
		goto _state_1;
#line 182 "../src/engine/imap/transport/imap-client-connection.vala"
		case 2:
#line 1046 "imap-client-connection.c"
		goto _state_2;
#line 182 "../src/engine/imap/transport/imap-client-connection.vala"
		case 3:
#line 1050 "imap-client-connection.c"
		goto _state_3;
		default:
#line 182 "../src/engine/imap/transport/imap-client-connection.vala"
		g_assert_not_reached ();
#line 1055 "imap-client-connection.c"
	}
	_state_0:
#line 184 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp0_ = _data_->self->priv->cx;
#line 184 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_data_->_tmp0_ != NULL) {
#line 185 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp1_ = g_error_new_literal (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_ALREADY_CONNECTED, "Client already connected");
#line 185 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_inner_error0_ = _data_->_tmp1_;
#line 185 "../src/engine/imap/transport/imap-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 185 "../src/engine/imap/transport/imap-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 185 "../src/engine/imap/transport/imap-client-connection.vala"
		return FALSE;
#line 1072 "imap-client-connection.c"
	}
#line 187 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp3_ = _data_->self->priv->endpoint;
#line 187 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_state_ = 1;
#line 187 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_endpoint_connect_async (_data_->_tmp3_, _data_->cancellable, geary_imap_client_connection_connect_async_ready, _data_);
#line 187 "../src/engine/imap/transport/imap-client-connection.vala"
	return FALSE;
#line 1082 "imap-client-connection.c"
	_state_1:
#line 187 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp4_ = geary_endpoint_connect_finish (_data_->_tmp3_, _data_->_res_, &_data_->_inner_error0_);
#line 187 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp2_ = _data_->_tmp4_;
#line 187 "../src/engine/imap/transport/imap-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 187 "../src/engine/imap/transport/imap-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 187 "../src/engine/imap/transport/imap-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 187 "../src/engine/imap/transport/imap-client-connection.vala"
		return FALSE;
#line 1096 "imap-client-connection.c"
	}
#line 187 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp5_ = _data_->_tmp2_;
#line 187 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp2_ = NULL;
#line 187 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->self->priv->cx);
#line 187 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->self->priv->cx = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp5_, g_io_stream_get_type (), GIOStream);
#line 189 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp6_ = _data_->self->priv->pending_queue;
#line 189 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_nonblocking_queue_clear (_data_->_tmp6_);
#line 190 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp7_ = _data_->self->priv->sent_queue;
#line 190 "../src/engine/imap/transport/imap-client-connection.vala"
	gee_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp7_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1114 "imap-client-connection.c"
	{
#line 193 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_state_ = 2;
#line 193 "../src/engine/imap/transport/imap-client-connection.vala"
		geary_imap_client_connection_open_channels_async (_data_->self, geary_imap_client_connection_connect_async_ready, _data_);
#line 193 "../src/engine/imap/transport/imap-client-connection.vala"
		return FALSE;
#line 1122 "imap-client-connection.c"
		_state_2:
#line 193 "../src/engine/imap/transport/imap-client-connection.vala"
		geary_imap_client_connection_open_channels_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 193 "../src/engine/imap/transport/imap-client-connection.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1128 "imap-client-connection.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 192 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->err = _data_->_inner_error0_;
#line 192 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_inner_error0_ = NULL;
#line 1139 "imap-client-connection.c"
		{
#line 198 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp8_ = _data_->self->priv->cx;
#line 198 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_state_ = 3;
#line 198 "../src/engine/imap/transport/imap-client-connection.vala"
			g_io_stream_close_async (_data_->_tmp8_, G_PRIORITY_DEFAULT, NULL, geary_imap_client_connection_connect_async_ready, _data_);
#line 198 "../src/engine/imap/transport/imap-client-connection.vala"
			return FALSE;
#line 1149 "imap-client-connection.c"
			_state_3:
#line 198 "../src/engine/imap/transport/imap-client-connection.vala"
			g_io_stream_close_finish (_data_->_tmp8_, _data_->_res_, &_data_->_inner_error0_);
#line 198 "../src/engine/imap/transport/imap-client-connection.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1155 "imap-client-connection.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
#line 197 "../src/engine/imap/transport/imap-client-connection.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 1164 "imap-client-connection.c"
		}
		__finally1:
#line 197 "../src/engine/imap/transport/imap-client-connection.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 197 "../src/engine/imap/transport/imap-client-connection.vala"
			_g_error_free0 (_data_->err);
#line 197 "../src/engine/imap/transport/imap-client-connection.vala"
			_g_object_unref0 (_data_->_tmp2_);
#line 197 "../src/engine/imap/transport/imap-client-connection.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 197 "../src/engine/imap/transport/imap-client-connection.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 197 "../src/engine/imap/transport/imap-client-connection.vala"
			g_object_unref (_data_->_async_result);
#line 197 "../src/engine/imap/transport/imap-client-connection.vala"
			return FALSE;
#line 1181 "imap-client-connection.c"
		}
#line 202 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_object_unref0 (_data_->self->priv->cx);
#line 202 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->self->priv->cx = NULL;
#line 204 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp9_ = _data_->err;
#line 204 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp10_ = _g_error_copy0 (_data_->_tmp9_);
#line 204 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_inner_error0_ = _data_->_tmp10_;
#line 204 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_error_free0 (_data_->err);
#line 1195 "imap-client-connection.c"
		goto __finally0;
	}
	__finally0:
#line 192 "../src/engine/imap/transport/imap-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 192 "../src/engine/imap/transport/imap-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 192 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_object_unref0 (_data_->_tmp2_);
#line 192 "../src/engine/imap/transport/imap-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 192 "../src/engine/imap/transport/imap-client-connection.vala"
		return FALSE;
#line 1209 "imap-client-connection.c"
	}
#line 207 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp11_ = _data_->self->priv->_idle_when_quiet;
#line 207 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_data_->_tmp11_) {
#line 208 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp12_ = _data_->self->priv->idle_timer;
#line 208 "../src/engine/imap/transport/imap-client-connection.vala"
		geary_timeout_manager_start (_data_->_tmp12_);
#line 1219 "imap-client-connection.c"
	}
#line 182 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->_tmp2_);
#line 182 "../src/engine/imap/transport/imap-client-connection.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 182 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_data_->_state_ != 0) {
#line 182 "../src/engine/imap/transport/imap-client-connection.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 182 "../src/engine/imap/transport/imap-client-connection.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1231 "imap-client-connection.c"
		}
	}
#line 182 "../src/engine/imap/transport/imap-client-connection.vala"
	g_object_unref (_data_->_async_result);
#line 182 "../src/engine/imap/transport/imap-client-connection.vala"
	return FALSE;
#line 1238 "imap-client-connection.c"
}

static void
geary_imap_client_connection_disconnect_async_data_free (gpointer _data)
{
	GearyImapClientConnectionDisconnectAsyncData* _data_;
	_data_ = _data;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->self);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_slice_free (GearyImapClientConnectionDisconnectAsyncData, _data_);
#line 1252 "imap-client-connection.c"
}

void
geary_imap_client_connection_disconnect_async (GearyImapClientConnection* self,
                                               GCancellable* cancellable,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
	GearyImapClientConnectionDisconnectAsyncData* _data_;
	GearyImapClientConnection* _tmp0_;
	GCancellable* _tmp1_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self));
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_ = g_slice_new0 (GearyImapClientConnectionDisconnectAsyncData);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_connection_disconnect_async_data_free);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->self = _tmp0_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->cancellable = _tmp1_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_disconnect_async_co (_data_);
#line 1286 "imap-client-connection.c"
}

void
geary_imap_client_connection_disconnect_finish (GearyImapClientConnection* self,
                                                GAsyncResult* _res_,
                                                GError** error)
{
	GearyImapClientConnectionDisconnectAsyncData* _data_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	if (NULL == _data_) {
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
		return;
#line 1301 "imap-client-connection.c"
	}
}

static void
geary_imap_client_connection_disconnect_async_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_)
{
	GearyImapClientConnectionDisconnectAsyncData* _data_;
#line 230 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_ = _user_data_;
#line 230 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_source_object_ = source_object;
#line 230 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_res_ = _res_;
#line 230 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_disconnect_async_co (_data_);
#line 1319 "imap-client-connection.c"
}

static gboolean
geary_imap_client_connection_disconnect_async_co (GearyImapClientConnectionDisconnectAsyncData* _data_)
{
#line 212 "../src/engine/imap/transport/imap-client-connection.vala"
	switch (_data_->_state_) {
#line 212 "../src/engine/imap/transport/imap-client-connection.vala"
		case 0:
#line 1329 "imap-client-connection.c"
		goto _state_0;
#line 212 "../src/engine/imap/transport/imap-client-connection.vala"
		case 1:
#line 1333 "imap-client-connection.c"
		goto _state_1;
#line 212 "../src/engine/imap/transport/imap-client-connection.vala"
		case 2:
#line 1337 "imap-client-connection.c"
		goto _state_2;
#line 212 "../src/engine/imap/transport/imap-client-connection.vala"
		case 3:
#line 1341 "imap-client-connection.c"
		goto _state_3;
		default:
#line 212 "../src/engine/imap/transport/imap-client-connection.vala"
		g_assert_not_reached ();
#line 1346 "imap-client-connection.c"
	}
	_state_0:
#line 213 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp0_ = _data_->self->priv->cx;
#line 213 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_data_->_tmp0_ == NULL) {
#line 214 "../src/engine/imap/transport/imap-client-connection.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 214 "../src/engine/imap/transport/imap-client-connection.vala"
		if (_data_->_state_ != 0) {
#line 214 "../src/engine/imap/transport/imap-client-connection.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 214 "../src/engine/imap/transport/imap-client-connection.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1361 "imap-client-connection.c"
			}
		}
#line 214 "../src/engine/imap/transport/imap-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 214 "../src/engine/imap/transport/imap-client-connection.vala"
		return FALSE;
#line 1368 "imap-client-connection.c"
	}
#line 216 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp1_ = _data_->self->priv->idle_timer;
#line 216 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_timeout_manager_reset (_data_->_tmp1_);
#line 219 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp2_ = _data_->self->priv->cx;
#line 219 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp3_ = _g_object_ref0 (_data_->_tmp2_);
#line 219 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->old_cx = _data_->_tmp3_;
#line 220 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->self->priv->cx);
#line 220 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->self->priv->cx = NULL;
#line 1384 "imap-client-connection.c"
	{
#line 223 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp4_ = _data_->self->priv->pending_queue;
#line 223 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp5_ = geary_nonblocking_queue_get_all (_data_->_tmp4_);
#line 223 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 223 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp7_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, GEE_TYPE_ITERABLE, GeeIterable));
#line 223 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 223 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_object_unref0 (_data_->_tmp6_);
#line 223 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_pending_it = _data_->_tmp8_;
#line 223 "../src/engine/imap/transport/imap-client-connection.vala"
		while (TRUE) {
#line 223 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp9_ = _data_->_pending_it;
#line 223 "../src/engine/imap/transport/imap-client-connection.vala"
			if (!gee_iterator_next (_data_->_tmp9_)) {
#line 223 "../src/engine/imap/transport/imap-client-connection.vala"
				break;
#line 1408 "imap-client-connection.c"
			}
#line 223 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp10_ = _data_->_pending_it;
#line 223 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp11_ = gee_iterator_get (_data_->_tmp10_);
#line 223 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->pending = (GearyImapCommand*) _data_->_tmp11_;
#line 224 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp12_ = _data_->pending;
#line 224 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp13_ = geary_imap_command_to_brief_string (_data_->_tmp12_);
#line 224 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp14_ = _data_->_tmp13_;
#line 224 "../src/engine/imap/transport/imap-client-connection.vala"
			geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Cancelling pending command: %s", _data_->_tmp14_);
#line 224 "../src/engine/imap/transport/imap-client-connection.vala"
			_g_free0 (_data_->_tmp14_);
#line 225 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp15_ = _data_->pending;
#line 225 "../src/engine/imap/transport/imap-client-connection.vala"
			geary_imap_command_disconnected (_data_->_tmp15_, "Disconnected");
#line 223 "../src/engine/imap/transport/imap-client-connection.vala"
			_g_object_unref0 (_data_->pending);
#line 1432 "imap-client-connection.c"
		}
#line 223 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_object_unref0 (_data_->_pending_it);
#line 1436 "imap-client-connection.c"
	}
#line 227 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp16_ = _data_->self->priv->pending_queue;
#line 227 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_nonblocking_queue_clear (_data_->_tmp16_);
#line 230 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_state_ = 1;
#line 230 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_close_channels_async (_data_->self, _data_->cancellable, geary_imap_client_connection_disconnect_async_ready, _data_);
#line 230 "../src/engine/imap/transport/imap-client-connection.vala"
	return FALSE;
#line 1448 "imap-client-connection.c"
	_state_1:
#line 230 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_close_channels_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 230 "../src/engine/imap/transport/imap-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 230 "../src/engine/imap/transport/imap-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 230 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_object_unref0 (_data_->old_cx);
#line 230 "../src/engine/imap/transport/imap-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 230 "../src/engine/imap/transport/imap-client-connection.vala"
		return FALSE;
#line 1462 "imap-client-connection.c"
	}
#line 231 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp17_ = _data_->old_cx;
#line 231 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_state_ = 2;
#line 231 "../src/engine/imap/transport/imap-client-connection.vala"
	g_io_stream_close_async (_data_->_tmp17_, G_PRIORITY_DEFAULT, _data_->cancellable, geary_imap_client_connection_disconnect_async_ready, _data_);
#line 231 "../src/engine/imap/transport/imap-client-connection.vala"
	return FALSE;
#line 1472 "imap-client-connection.c"
	_state_2:
#line 231 "../src/engine/imap/transport/imap-client-connection.vala"
	g_io_stream_close_finish (_data_->_tmp17_, _data_->_res_, &_data_->_inner_error0_);
#line 231 "../src/engine/imap/transport/imap-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 231 "../src/engine/imap/transport/imap-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 231 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_object_unref0 (_data_->old_cx);
#line 231 "../src/engine/imap/transport/imap-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 231 "../src/engine/imap/transport/imap-client-connection.vala"
		return FALSE;
#line 1486 "imap-client-connection.c"
	}
#line 233 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp18_ = _data_->old_cx;
#line 233 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp19_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp18_, g_tls_connection_get_type ()) ? ((GTlsConnection*) _data_->_tmp18_) : NULL);
#line 233 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->tls_cx = _data_->_tmp19_;
#line 234 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp21_ = _data_->tls_cx;
#line 234 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_data_->_tmp21_ != NULL) {
#line 234 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp22_ = _data_->tls_cx;
#line 234 "../src/engine/imap/transport/imap-client-connection.vala"
		g_object_get (_data_->_tmp22_, "base-io-stream", &_data_->_tmp23_, NULL);
#line 234 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp24_ = _data_->_tmp23_;
#line 234 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp25_ = _data_->_tmp24_;
#line 234 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp20_ = !g_io_stream_is_closed (_data_->_tmp25_);
#line 234 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_object_unref0 (_data_->_tmp25_);
#line 1510 "imap-client-connection.c"
	} else {
#line 234 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp20_ = FALSE;
#line 1514 "imap-client-connection.c"
	}
#line 234 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_data_->_tmp20_) {
#line 235 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp26_ = _data_->tls_cx;
#line 235 "../src/engine/imap/transport/imap-client-connection.vala"
		g_object_get (_data_->_tmp26_, "base-io-stream", &_data_->_tmp27_, NULL);
#line 235 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp28_ = _data_->_tmp27_;
#line 235 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp29_ = _data_->_tmp28_;
#line 235 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_state_ = 3;
#line 235 "../src/engine/imap/transport/imap-client-connection.vala"
		g_io_stream_close_async (_data_->_tmp29_, G_PRIORITY_DEFAULT, _data_->cancellable, geary_imap_client_connection_disconnect_async_ready, _data_);
#line 235 "../src/engine/imap/transport/imap-client-connection.vala"
		return FALSE;
#line 1532 "imap-client-connection.c"
		_state_3:
#line 235 "../src/engine/imap/transport/imap-client-connection.vala"
		g_io_stream_close_finish (_data_->_tmp29_, _data_->_res_, &_data_->_inner_error0_);
#line 235 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_object_unref0 (_data_->_tmp29_);
#line 235 "../src/engine/imap/transport/imap-client-connection.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 235 "../src/engine/imap/transport/imap-client-connection.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 235 "../src/engine/imap/transport/imap-client-connection.vala"
			_g_object_unref0 (_data_->tls_cx);
#line 235 "../src/engine/imap/transport/imap-client-connection.vala"
			_g_object_unref0 (_data_->old_cx);
#line 235 "../src/engine/imap/transport/imap-client-connection.vala"
			g_object_unref (_data_->_async_result);
#line 235 "../src/engine/imap/transport/imap-client-connection.vala"
			return FALSE;
#line 1550 "imap-client-connection.c"
		}
	}
#line 212 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->tls_cx);
#line 212 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->old_cx);
#line 212 "../src/engine/imap/transport/imap-client-connection.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 212 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_data_->_state_ != 0) {
#line 212 "../src/engine/imap/transport/imap-client-connection.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 212 "../src/engine/imap/transport/imap-client-connection.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1565 "imap-client-connection.c"
		}
	}
#line 212 "../src/engine/imap/transport/imap-client-connection.vala"
	g_object_unref (_data_->_async_result);
#line 212 "../src/engine/imap/transport/imap-client-connection.vala"
	return FALSE;
#line 1572 "imap-client-connection.c"
}

static void
geary_imap_client_connection_starttls_async_data_free (gpointer _data)
{
	GearyImapClientConnectionStarttlsAsyncData* _data_;
	_data_ = _data;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->self);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_slice_free (GearyImapClientConnectionStarttlsAsyncData, _data_);
#line 1586 "imap-client-connection.c"
}

void
geary_imap_client_connection_starttls_async (GearyImapClientConnection* self,
                                             GCancellable* cancellable,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_)
{
	GearyImapClientConnectionStarttlsAsyncData* _data_;
	GearyImapClientConnection* _tmp0_;
	GCancellable* _tmp1_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self));
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_ = g_slice_new0 (GearyImapClientConnectionStarttlsAsyncData);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_connection_starttls_async_data_free);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->self = _tmp0_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->cancellable = _tmp1_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_starttls_async_co (_data_);
#line 1620 "imap-client-connection.c"
}

void
geary_imap_client_connection_starttls_finish (GearyImapClientConnection* self,
                                              GAsyncResult* _res_,
                                              GError** error)
{
	GearyImapClientConnectionStarttlsAsyncData* _data_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	if (NULL == _data_) {
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
		return;
#line 1635 "imap-client-connection.c"
	}
}

static void
geary_imap_client_connection_starttls_async_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_)
{
	GearyImapClientConnectionStarttlsAsyncData* _data_;
#line 258 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_ = _user_data_;
#line 258 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_source_object_ = source_object;
#line 258 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_res_ = _res_;
#line 258 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_starttls_async_co (_data_);
#line 1653 "imap-client-connection.c"
}

static gboolean
geary_imap_client_connection_starttls_async_co (GearyImapClientConnectionStarttlsAsyncData* _data_)
{
#line 241 "../src/engine/imap/transport/imap-client-connection.vala"
	switch (_data_->_state_) {
#line 241 "../src/engine/imap/transport/imap-client-connection.vala"
		case 0:
#line 1663 "imap-client-connection.c"
		goto _state_0;
#line 241 "../src/engine/imap/transport/imap-client-connection.vala"
		case 1:
#line 1667 "imap-client-connection.c"
		goto _state_1;
#line 241 "../src/engine/imap/transport/imap-client-connection.vala"
		case 2:
#line 1671 "imap-client-connection.c"
		goto _state_2;
#line 241 "../src/engine/imap/transport/imap-client-connection.vala"
		case 3:
#line 1675 "imap-client-connection.c"
		goto _state_3;
		default:
#line 241 "../src/engine/imap/transport/imap-client-connection.vala"
		g_assert_not_reached ();
#line 1680 "imap-client-connection.c"
	}
	_state_0:
#line 243 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp0_ = _data_->self->priv->cx;
#line 243 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_data_->_tmp0_ == NULL) {
#line 244 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp1_ = g_error_new_literal (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_NOT_CONNECTED, "Cannot start TLS when not connected");
#line 244 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_inner_error0_ = _data_->_tmp1_;
#line 244 "../src/engine/imap/transport/imap-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 244 "../src/engine/imap/transport/imap-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 244 "../src/engine/imap/transport/imap-client-connection.vala"
		return FALSE;
#line 1697 "imap-client-connection.c"
	}
#line 250 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp2_ = _data_->self->priv->cx;
#line 250 "../src/engine/imap/transport/imap-client-connection.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp2_, g_tls_client_connection_get_type ())) {
#line 251 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp3_ = g_error_new_literal (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_NOT_SUPPORTED, "Cannot start TLS when already established");
#line 251 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_inner_error0_ = _data_->_tmp3_;
#line 251 "../src/engine/imap/transport/imap-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 251 "../src/engine/imap/transport/imap-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 251 "../src/engine/imap/transport/imap-client-connection.vala"
		return FALSE;
#line 1713 "imap-client-connection.c"
	}
#line 257 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Closing serializer to switch to TLS");
#line 258 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_state_ = 1;
#line 258 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_close_channels_async (_data_->self, _data_->cancellable, geary_imap_client_connection_starttls_async_ready, _data_);
#line 258 "../src/engine/imap/transport/imap-client-connection.vala"
	return FALSE;
#line 1723 "imap-client-connection.c"
	_state_1:
#line 258 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_close_channels_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 258 "../src/engine/imap/transport/imap-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 258 "../src/engine/imap/transport/imap-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 258 "../src/engine/imap/transport/imap-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 258 "../src/engine/imap/transport/imap-client-connection.vala"
		return FALSE;
#line 1735 "imap-client-connection.c"
	}
#line 261 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp5_ = _data_->self->priv->endpoint;
#line 261 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp6_ = _data_->self->priv->cx;
#line 261 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_state_ = 2;
#line 261 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_endpoint_starttls_handshake_async (_data_->_tmp5_, _data_->_tmp6_, _data_->cancellable, geary_imap_client_connection_starttls_async_ready, _data_);
#line 261 "../src/engine/imap/transport/imap-client-connection.vala"
	return FALSE;
#line 1747 "imap-client-connection.c"
	_state_2:
#line 261 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp7_ = geary_endpoint_starttls_handshake_finish (_data_->_tmp5_, _data_->_res_, &_data_->_inner_error0_);
#line 261 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp4_ = _data_->_tmp7_;
#line 261 "../src/engine/imap/transport/imap-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 261 "../src/engine/imap/transport/imap-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 261 "../src/engine/imap/transport/imap-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 261 "../src/engine/imap/transport/imap-client-connection.vala"
		return FALSE;
#line 1761 "imap-client-connection.c"
	}
#line 261 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp8_ = _data_->_tmp4_;
#line 261 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp4_ = NULL;
#line 261 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->self->priv->cx);
#line 261 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->self->priv->cx = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp8_, g_io_stream_get_type (), GIOStream);
#line 264 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_state_ = 3;
#line 264 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_open_channels_async (_data_->self, geary_imap_client_connection_starttls_async_ready, _data_);
#line 264 "../src/engine/imap/transport/imap-client-connection.vala"
	return FALSE;
#line 1777 "imap-client-connection.c"
	_state_3:
#line 264 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_open_channels_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 264 "../src/engine/imap/transport/imap-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 264 "../src/engine/imap/transport/imap-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 264 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_object_unref0 (_data_->_tmp4_);
#line 264 "../src/engine/imap/transport/imap-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 264 "../src/engine/imap/transport/imap-client-connection.vala"
		return FALSE;
#line 1791 "imap-client-connection.c"
	}
#line 241 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->_tmp4_);
#line 241 "../src/engine/imap/transport/imap-client-connection.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 241 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_data_->_state_ != 0) {
#line 241 "../src/engine/imap/transport/imap-client-connection.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 241 "../src/engine/imap/transport/imap-client-connection.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1803 "imap-client-connection.c"
		}
	}
#line 241 "../src/engine/imap/transport/imap-client-connection.vala"
	g_object_unref (_data_->_async_result);
#line 241 "../src/engine/imap/transport/imap-client-connection.vala"
	return FALSE;
#line 1810 "imap-client-connection.c"
}

void
geary_imap_client_connection_send_command (GearyImapClientConnection* self,
                                           GearyImapCommand* new_command,
                                           GError** error)
{
	gboolean _tmp0_ = FALSE;
	GCancellable* _tmp1_;
	GCancellable* _tmp2_;
	GearyNonblockingQueue* _tmp9_;
	GError* _inner_error0_ = NULL;
#line 267 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self));
#line 267 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (new_command));
#line 269 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_check_connection (self, &_inner_error0_);
#line 269 "../src/engine/imap/transport/imap-client-connection.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 269 "../src/engine/imap/transport/imap-client-connection.vala"
		if ((_inner_error0_->domain == GEARY_IMAP_ERROR) || (_inner_error0_->domain == G_IO_ERROR)) {
#line 269 "../src/engine/imap/transport/imap-client-connection.vala"
			g_propagate_error (error, _inner_error0_);
#line 269 "../src/engine/imap/transport/imap-client-connection.vala"
			return;
#line 1837 "imap-client-connection.c"
		} else {
#line 269 "../src/engine/imap/transport/imap-client-connection.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 269 "../src/engine/imap/transport/imap-client-connection.vala"
			g_clear_error (&_inner_error0_);
#line 269 "../src/engine/imap/transport/imap-client-connection.vala"
			return;
#line 1845 "imap-client-connection.c"
		}
	}
#line 270 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp1_ = geary_imap_command_get_should_send (new_command);
#line 270 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp2_ = _tmp1_;
#line 270 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_tmp2_ != NULL) {
#line 1854 "imap-client-connection.c"
		GCancellable* _tmp3_;
		GCancellable* _tmp4_;
#line 271 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp3_ = geary_imap_command_get_should_send (new_command);
#line 271 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp4_ = _tmp3_;
#line 271 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp0_ = g_cancellable_is_cancelled (_tmp4_);
#line 1863 "imap-client-connection.c"
	} else {
#line 270 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp0_ = FALSE;
#line 1867 "imap-client-connection.c"
	}
#line 270 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_tmp0_) {
#line 1871 "imap-client-connection.c"
		gchar* _tmp5_;
		gchar* _tmp6_;
		GError* _tmp7_;
		GError* _tmp8_;
#line 272 "../src/engine/imap/transport/imap-client-connection.vala"
		geary_imap_command_cancelled_before_send (new_command);
#line 273 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp5_ = geary_imap_command_to_brief_string (new_command);
#line 273 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp6_ = _tmp5_;
#line 273 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp7_ = g_error_new (G_IO_ERROR, G_IO_ERROR_CANCELLED, "Not queuing command, sending is cancelled: %s", _tmp6_);
#line 273 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp8_ = _tmp7_;
#line 273 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_free0 (_tmp6_);
#line 273 "../src/engine/imap/transport/imap-client-connection.vala"
		_inner_error0_ = _tmp8_;
#line 273 "../src/engine/imap/transport/imap-client-connection.vala"
		if ((_inner_error0_->domain == GEARY_IMAP_ERROR) || (_inner_error0_->domain == G_IO_ERROR)) {
#line 273 "../src/engine/imap/transport/imap-client-connection.vala"
			g_propagate_error (error, _inner_error0_);
#line 273 "../src/engine/imap/transport/imap-client-connection.vala"
			return;
#line 1896 "imap-client-connection.c"
		} else {
#line 273 "../src/engine/imap/transport/imap-client-connection.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 273 "../src/engine/imap/transport/imap-client-connection.vala"
			g_clear_error (&_inner_error0_);
#line 273 "../src/engine/imap/transport/imap-client-connection.vala"
			return;
#line 1904 "imap-client-connection.c"
		}
	}
#line 279 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp9_ = self->priv->pending_queue;
#line 279 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_nonblocking_queue_send (_tmp9_, new_command);
#line 282 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_cancel_idle (self);
#line 1913 "imap-client-connection.c"
}

/** {@inheritDoc} */
static GearyLoggingState*
geary_imap_client_connection_real_to_logging_state (GearyLoggingSource* base)
{
	GearyImapClientConnection * self;
	const gchar* _tmp0_ = NULL;
	GIOStream* _tmp1_;
	GearyEndpoint* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GearyLoggingState* _tmp5_;
	GearyLoggingState* _tmp6_;
	GearyLoggingState* result;
#line 286 "../src/engine/imap/transport/imap-client-connection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_IMAP_TYPE_CLIENT_CONNECTION, GearyImapClientConnection);
#line 292 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp1_ = self->priv->cx;
#line 292 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_tmp1_ != NULL) {
#line 292 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp0_ = "up";
#line 1937 "imap-client-connection.c"
	} else {
#line 292 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp0_ = "down";
#line 1941 "imap-client-connection.c"
	}
#line 287 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp2_ = self->priv->endpoint;
#line 287 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp3_ = geary_endpoint_to_string (_tmp2_);
#line 287 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp4_ = _tmp3_;
#line 287 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp5_ = geary_logging_state_new (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "%04X/%s/%s", (guint) self->priv->cx_id, _tmp4_, _tmp0_);
#line 287 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp6_ = _tmp5_;
#line 287 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_free0 (_tmp4_);
#line 287 "../src/engine/imap/transport/imap-client-connection.vala"
	result = _tmp6_;
#line 287 "../src/engine/imap/transport/imap-client-connection.vala"
	return result;
#line 1959 "imap-client-connection.c"
}

/**
     * Returns the command that has been sent with the given tag.
     *
     * This should be private, but is internal for the
     * ClientSession.on_received_status_response IDLE workaround.
     */
GearyImapCommand*
geary_imap_client_connection_get_sent_command (GearyImapClientConnection* self,
                                               GearyImapTag* tag)
{
	GearyImapCommand* sent = NULL;
	GearyImapCommand* result;
#line 302 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self), NULL);
#line 302 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_TAG (tag), NULL);
#line 303 "../src/engine/imap/transport/imap-client-connection.vala"
	sent = NULL;
#line 304 "../src/engine/imap/transport/imap-client-connection.vala"
	if (geary_imap_tag_is_tagged (tag)) {
#line 1982 "imap-client-connection.c"
		{
			GeeIterator* _queued_it = NULL;
			GeeQueue* _tmp0_;
			GeeIterator* _tmp1_;
#line 305 "../src/engine/imap/transport/imap-client-connection.vala"
			_tmp0_ = self->priv->sent_queue;
#line 305 "../src/engine/imap/transport/imap-client-connection.vala"
			_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ITERABLE, GeeIterable));
#line 305 "../src/engine/imap/transport/imap-client-connection.vala"
			_queued_it = _tmp1_;
#line 305 "../src/engine/imap/transport/imap-client-connection.vala"
			while (TRUE) {
#line 1995 "imap-client-connection.c"
				GeeIterator* _tmp2_;
				GearyImapCommand* queued = NULL;
				GeeIterator* _tmp3_;
				gpointer _tmp4_;
				GearyImapCommand* _tmp5_;
				GearyImapTag* _tmp6_;
				GearyImapTag* _tmp7_;
#line 305 "../src/engine/imap/transport/imap-client-connection.vala"
				_tmp2_ = _queued_it;
#line 305 "../src/engine/imap/transport/imap-client-connection.vala"
				if (!gee_iterator_next (_tmp2_)) {
#line 305 "../src/engine/imap/transport/imap-client-connection.vala"
					break;
#line 2009 "imap-client-connection.c"
				}
#line 305 "../src/engine/imap/transport/imap-client-connection.vala"
				_tmp3_ = _queued_it;
#line 305 "../src/engine/imap/transport/imap-client-connection.vala"
				_tmp4_ = gee_iterator_get (_tmp3_);
#line 305 "../src/engine/imap/transport/imap-client-connection.vala"
				queued = (GearyImapCommand*) _tmp4_;
#line 306 "../src/engine/imap/transport/imap-client-connection.vala"
				_tmp5_ = queued;
#line 306 "../src/engine/imap/transport/imap-client-connection.vala"
				_tmp6_ = geary_imap_command_get_tag (_tmp5_);
#line 306 "../src/engine/imap/transport/imap-client-connection.vala"
				_tmp7_ = _tmp6_;
#line 306 "../src/engine/imap/transport/imap-client-connection.vala"
				if (gee_hashable_equal_to (G_TYPE_CHECK_INSTANCE_CAST (tag, GEE_TYPE_HASHABLE, GeeHashable), _tmp7_)) {
#line 2025 "imap-client-connection.c"
					GearyImapCommand* _tmp8_;
					GearyImapCommand* _tmp9_;
#line 307 "../src/engine/imap/transport/imap-client-connection.vala"
					_tmp8_ = queued;
#line 307 "../src/engine/imap/transport/imap-client-connection.vala"
					_tmp9_ = _g_object_ref0 (_tmp8_);
#line 307 "../src/engine/imap/transport/imap-client-connection.vala"
					_g_object_unref0 (sent);
#line 307 "../src/engine/imap/transport/imap-client-connection.vala"
					sent = _tmp9_;
#line 308 "../src/engine/imap/transport/imap-client-connection.vala"
					_g_object_unref0 (queued);
#line 308 "../src/engine/imap/transport/imap-client-connection.vala"
					break;
#line 2040 "imap-client-connection.c"
				}
#line 305 "../src/engine/imap/transport/imap-client-connection.vala"
				_g_object_unref0 (queued);
#line 2044 "imap-client-connection.c"
			}
#line 305 "../src/engine/imap/transport/imap-client-connection.vala"
			_g_object_unref0 (_queued_it);
#line 2048 "imap-client-connection.c"
		}
	}
#line 312 "../src/engine/imap/transport/imap-client-connection.vala"
	result = sent;
#line 312 "../src/engine/imap/transport/imap-client-connection.vala"
	return result;
#line 2055 "imap-client-connection.c"
}

/** Sets the connection's logging parent. */
void
geary_imap_client_connection_set_logging_parent (GearyImapClientConnection* self,
                                                 GearyLoggingSource* parent)
{
#line 316 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self));
#line 316 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_LOGGING_IS_SOURCE (parent));
#line 317 "../src/engine/imap/transport/imap-client-connection.vala"
	self->priv->_logging_parent = parent;
#line 2069 "imap-client-connection.c"
}

static GTcpConnection*
geary_imap_client_connection_getTcpConnection (GearyImapClientConnection* self)
{
	GIOStream* cx = NULL;
	GIOStream* _tmp0_;
	GIOStream* _tmp1_;
	GTlsConnection* tls_cx = NULL;
	GIOStream* _tmp2_;
	GTlsConnection* _tmp3_;
	GTlsConnection* _tmp4_;
	GIOStream* _tmp8_;
	GTcpConnection* _tmp9_;
	GTcpConnection* result;
#line 320 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self), NULL);
#line 321 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = self->priv->cx;
#line 321 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 321 "../src/engine/imap/transport/imap-client-connection.vala"
	cx = _tmp1_;
#line 322 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp2_ = cx;
#line 322 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, g_tls_connection_get_type ()) ? ((GTlsConnection*) _tmp2_) : NULL);
#line 322 "../src/engine/imap/transport/imap-client-connection.vala"
	tls_cx = _tmp3_;
#line 323 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp4_ = tls_cx;
#line 323 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_tmp4_ != NULL) {
#line 2103 "imap-client-connection.c"
		GTlsConnection* _tmp5_;
		GIOStream* _tmp6_;
		GIOStream* _tmp7_;
#line 324 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp5_ = tls_cx;
#line 324 "../src/engine/imap/transport/imap-client-connection.vala"
		g_object_get (_tmp5_, "base-io-stream", &_tmp6_, NULL);
#line 324 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp7_ = _tmp6_;
#line 324 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_object_unref0 (cx);
#line 324 "../src/engine/imap/transport/imap-client-connection.vala"
		cx = _tmp7_;
#line 2117 "imap-client-connection.c"
	}
#line 326 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp8_ = cx;
#line 326 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, g_tcp_connection_get_type ()) ? ((GTcpConnection*) _tmp8_) : NULL);
#line 326 "../src/engine/imap/transport/imap-client-connection.vala"
	result = _tmp9_;
#line 326 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (tls_cx);
#line 326 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (cx);
#line 326 "../src/engine/imap/transport/imap-client-connection.vala"
	return result;
#line 2131 "imap-client-connection.c"
}

static void
geary_imap_client_connection_open_channels_async_data_free (gpointer _data)
{
	GearyImapClientConnectionOpenChannelsAsyncData* _data_;
	_data_ = _data;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->self);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_slice_free (GearyImapClientConnectionOpenChannelsAsyncData, _data_);
#line 2143 "imap-client-connection.c"
}

static void
geary_imap_client_connection_open_channels_async (GearyImapClientConnection* self,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_)
{
	GearyImapClientConnectionOpenChannelsAsyncData* _data_;
	GearyImapClientConnection* _tmp0_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self));
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_ = g_slice_new0 (GearyImapClientConnectionOpenChannelsAsyncData);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_connection_open_channels_async_data_free);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->self = _tmp0_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_open_channels_async_co (_data_);
#line 2167 "imap-client-connection.c"
}

static void
geary_imap_client_connection_open_channels_finish (GearyImapClientConnection* self,
                                                   GAsyncResult* _res_,
                                                   GError** error)
{
	GearyImapClientConnectionOpenChannelsAsyncData* _data_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	if (NULL == _data_) {
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
		return;
#line 2182 "imap-client-connection.c"
	}
}

static void
_geary_imap_client_connection_on_bytes_received_geary_imap_deserializer_bytes_received (GearyImapDeserializer* _sender,
                                                                                        gsize bytes,
                                                                                        gpointer self)
{
#line 345 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_on_bytes_received ((GearyImapClientConnection*) self, bytes);
#line 2193 "imap-client-connection.c"
}

static void
_geary_imap_client_connection_on_deserialize_failure_geary_imap_deserializer_deserialize_failure (GearyImapDeserializer* _sender,
                                                                                                  gpointer self)
{
#line 346 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_on_deserialize_failure ((GearyImapClientConnection*) self);
#line 2202 "imap-client-connection.c"
}

static void
_geary_imap_client_connection_on_eos_geary_imap_deserializer_end_of_stream (GearyImapDeserializer* _sender,
                                                                            gpointer self)
{
#line 347 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_on_eos ((GearyImapClientConnection*) self);
#line 2211 "imap-client-connection.c"
}

static void
_geary_imap_client_connection_on_parameters_ready_geary_imap_deserializer_parameters_ready (GearyImapDeserializer* _sender,
                                                                                            GearyImapRootParameters* root,
                                                                                            gpointer self)
{
#line 348 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_on_parameters_ready ((GearyImapClientConnection*) self, root);
#line 2221 "imap-client-connection.c"
}

static void
_geary_imap_client_connection_on_receive_failure_geary_imap_deserializer_receive_failure (GearyImapDeserializer* _sender,
                                                                                          GError* err,
                                                                                          gpointer self)
{
#line 349 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_on_receive_failure ((GearyImapClientConnection*) self, err);
#line 2231 "imap-client-connection.c"
}

static void
geary_imap_client_connection_open_channels_async_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_)
{
	GearyImapClientConnectionOpenChannelsAsyncData* _data_;
#line 351 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_ = _user_data_;
#line 351 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_source_object_ = source_object;
#line 351 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_res_ = _res_;
#line 351 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_open_channels_async_co (_data_);
#line 2248 "imap-client-connection.c"
}

static gboolean
geary_imap_client_connection_open_channels_async_co (GearyImapClientConnectionOpenChannelsAsyncData* _data_)
{
#line 329 "../src/engine/imap/transport/imap-client-connection.vala"
	switch (_data_->_state_) {
#line 329 "../src/engine/imap/transport/imap-client-connection.vala"
		case 0:
#line 2258 "imap-client-connection.c"
		goto _state_0;
#line 329 "../src/engine/imap/transport/imap-client-connection.vala"
		case 1:
#line 2262 "imap-client-connection.c"
		goto _state_1;
		default:
#line 329 "../src/engine/imap/transport/imap-client-connection.vala"
		g_assert_not_reached ();
#line 2267 "imap-client-connection.c"
	}
	_state_0:
#line 330 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp0_ = g_cancellable_new ();
#line 330 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->self->priv->open_cancellable);
#line 330 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->self->priv->open_cancellable = _data_->_tmp0_;
#line 332 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp1_ = g_strdup_printf ("%04d", _data_->self->priv->cx_id);
#line 332 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->id = _data_->_tmp1_;
#line 334 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp2_ = _data_->self->priv->cx;
#line 334 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp3_ = g_io_stream_get_output_stream (_data_->_tmp2_);
#line 334 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 334 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp5_ = (GBufferedOutputStream*) g_buffered_output_stream_new (_data_->_tmp4_);
#line 334 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->serializer_buffer = _data_->_tmp5_;
#line 337 "../src/engine/imap/transport/imap-client-connection.vala"
	g_filter_output_stream_set_close_base_stream (G_TYPE_CHECK_INSTANCE_CAST (_data_->serializer_buffer, g_filter_output_stream_get_type (), GFilterOutputStream), FALSE);
#line 338 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp6_ = geary_imap_serializer_new (G_TYPE_CHECK_INSTANCE_CAST (_data_->serializer_buffer, g_output_stream_get_type (), GOutputStream));
#line 338 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->self->priv->serializer);
#line 338 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->self->priv->serializer = _data_->_tmp6_;
#line 342 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp7_ = _data_->self->priv->cx;
#line 342 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp8_ = g_io_stream_get_input_stream (_data_->_tmp7_);
#line 342 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp9_ = _data_->_tmp8_;
#line 342 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp10_ = _data_->self->priv->quirks;
#line 342 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp11_ = geary_imap_deserializer_new (_data_->id, _data_->_tmp9_, _data_->_tmp10_);
#line 342 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->self->priv->deserializer);
#line 342 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->self->priv->deserializer = _data_->_tmp11_;
#line 345 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp12_ = _data_->self->priv->deserializer;
#line 345 "../src/engine/imap/transport/imap-client-connection.vala"
	g_signal_connect_object (_data_->_tmp12_, "bytes-received", (GCallback) _geary_imap_client_connection_on_bytes_received_geary_imap_deserializer_bytes_received, _data_->self, 0);
#line 346 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp13_ = _data_->self->priv->deserializer;
#line 346 "../src/engine/imap/transport/imap-client-connection.vala"
	g_signal_connect_object (_data_->_tmp13_, "deserialize-failure", (GCallback) _geary_imap_client_connection_on_deserialize_failure_geary_imap_deserializer_deserialize_failure, _data_->self, 0);
#line 347 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp14_ = _data_->self->priv->deserializer;
#line 347 "../src/engine/imap/transport/imap-client-connection.vala"
	g_signal_connect_object (_data_->_tmp14_, "end-of-stream", (GCallback) _geary_imap_client_connection_on_eos_geary_imap_deserializer_end_of_stream, _data_->self, 0);
#line 348 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp15_ = _data_->self->priv->deserializer;
#line 348 "../src/engine/imap/transport/imap-client-connection.vala"
	g_signal_connect_object (_data_->_tmp15_, "parameters-ready", (GCallback) _geary_imap_client_connection_on_parameters_ready_geary_imap_deserializer_parameters_ready, _data_->self, 0);
#line 349 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp16_ = _data_->self->priv->deserializer;
#line 349 "../src/engine/imap/transport/imap-client-connection.vala"
	g_signal_connect_object (_data_->_tmp16_, "receive-failure", (GCallback) _geary_imap_client_connection_on_receive_failure_geary_imap_deserializer_receive_failure, _data_->self, 0);
#line 350 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp17_ = _data_->self->priv->deserializer;
#line 350 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_deserializer_set_logging_parent (_data_->_tmp17_, G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 351 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp18_ = _data_->self->priv->deserializer;
#line 351 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_state_ = 1;
#line 351 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_deserializer_start_async (_data_->_tmp18_, G_PRIORITY_DEFAULT_IDLE, geary_imap_client_connection_open_channels_async_ready, _data_);
#line 351 "../src/engine/imap/transport/imap-client-connection.vala"
	return FALSE;
#line 2344 "imap-client-connection.c"
	_state_1:
#line 351 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_deserializer_start_finish (_data_->_tmp18_, _data_->_res_, &_data_->_inner_error0_);
#line 351 "../src/engine/imap/transport/imap-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 351 "../src/engine/imap/transport/imap-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 351 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_object_unref0 (_data_->serializer_buffer);
#line 351 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_free0 (_data_->id);
#line 351 "../src/engine/imap/transport/imap-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 351 "../src/engine/imap/transport/imap-client-connection.vala"
		return FALSE;
#line 2360 "imap-client-connection.c"
	}
#line 355 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_send_loop (_data_->self, NULL, NULL);
#line 329 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->serializer_buffer);
#line 329 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_free0 (_data_->id);
#line 329 "../src/engine/imap/transport/imap-client-connection.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 329 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_data_->_state_ != 0) {
#line 329 "../src/engine/imap/transport/imap-client-connection.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 329 "../src/engine/imap/transport/imap-client-connection.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2376 "imap-client-connection.c"
		}
	}
#line 329 "../src/engine/imap/transport/imap-client-connection.vala"
	g_object_unref (_data_->_async_result);
#line 329 "../src/engine/imap/transport/imap-client-connection.vala"
	return FALSE;
#line 2383 "imap-client-connection.c"
}

static void
geary_imap_client_connection_close_channels_async_data_free (gpointer _data)
{
	GearyImapClientConnectionCloseChannelsAsyncData* _data_;
	_data_ = _data;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->self);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_slice_free (GearyImapClientConnectionCloseChannelsAsyncData, _data_);
#line 2397 "imap-client-connection.c"
}

static void
geary_imap_client_connection_close_channels_async (GearyImapClientConnection* self,
                                                   GCancellable* cancellable,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_)
{
	GearyImapClientConnectionCloseChannelsAsyncData* _data_;
	GearyImapClientConnection* _tmp0_;
	GCancellable* _tmp1_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self));
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_ = g_slice_new0 (GearyImapClientConnectionCloseChannelsAsyncData);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_connection_close_channels_async_data_free);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->self = _tmp0_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->cancellable = _tmp1_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_close_channels_async_co (_data_);
#line 2431 "imap-client-connection.c"
}

static void
geary_imap_client_connection_close_channels_finish (GearyImapClientConnection* self,
                                                    GAsyncResult* _res_,
                                                    GError** error)
{
	GearyImapClientConnectionCloseChannelsAsyncData* _data_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	if (NULL == _data_) {
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
		return;
#line 2446 "imap-client-connection.c"
	}
}

/** Disconnect and deallocates the Serializer and Deserializer. */
static void
geary_imap_client_connection_close_channels_async_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_)
{
	GearyImapClientConnectionCloseChannelsAsyncData* _data_;
#line 370 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_ = _user_data_;
#line 370 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_source_object_ = source_object;
#line 370 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_res_ = _res_;
#line 370 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_close_channels_async_co (_data_);
#line 2465 "imap-client-connection.c"
}

static gboolean
geary_imap_client_connection_close_channels_async_co (GearyImapClientConnectionCloseChannelsAsyncData* _data_)
{
#line 359 "../src/engine/imap/transport/imap-client-connection.vala"
	switch (_data_->_state_) {
#line 359 "../src/engine/imap/transport/imap-client-connection.vala"
		case 0:
#line 2475 "imap-client-connection.c"
		goto _state_0;
#line 359 "../src/engine/imap/transport/imap-client-connection.vala"
		case 1:
#line 2479 "imap-client-connection.c"
		goto _state_1;
#line 359 "../src/engine/imap/transport/imap-client-connection.vala"
		case 2:
#line 2483 "imap-client-connection.c"
		goto _state_2;
		default:
#line 359 "../src/engine/imap/transport/imap-client-connection.vala"
		g_assert_not_reached ();
#line 2488 "imap-client-connection.c"
	}
	_state_0:
#line 362 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp0_ = _data_->self->priv->open_cancellable;
#line 362 "../src/engine/imap/transport/imap-client-connection.vala"
	g_cancellable_cancel (_data_->_tmp0_);
#line 2495 "imap-client-connection.c"
	{
#line 363 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp1_ = _data_->self->priv->sent_queue;
#line 363 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp2_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp1_, GEE_TYPE_ITERABLE, GeeIterable));
#line 363 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_sent_it = _data_->_tmp2_;
#line 363 "../src/engine/imap/transport/imap-client-connection.vala"
		while (TRUE) {
#line 363 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp3_ = _data_->_sent_it;
#line 363 "../src/engine/imap/transport/imap-client-connection.vala"
			if (!gee_iterator_next (_data_->_tmp3_)) {
#line 363 "../src/engine/imap/transport/imap-client-connection.vala"
				break;
#line 2511 "imap-client-connection.c"
			}
#line 363 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp4_ = _data_->_sent_it;
#line 363 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp5_ = gee_iterator_get (_data_->_tmp4_);
#line 363 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->sent = (GearyImapCommand*) _data_->_tmp5_;
#line 364 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp6_ = _data_->sent;
#line 364 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp7_ = geary_imap_command_to_brief_string (_data_->_tmp6_);
#line 364 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp8_ = _data_->_tmp7_;
#line 364 "../src/engine/imap/transport/imap-client-connection.vala"
			geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Cancelling sent command: %s", _data_->_tmp8_);
#line 364 "../src/engine/imap/transport/imap-client-connection.vala"
			_g_free0 (_data_->_tmp8_);
#line 365 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp9_ = _data_->sent;
#line 365 "../src/engine/imap/transport/imap-client-connection.vala"
			geary_imap_command_disconnected (_data_->_tmp9_, "Connection channels closed");
#line 363 "../src/engine/imap/transport/imap-client-connection.vala"
			_g_object_unref0 (_data_->sent);
#line 2535 "imap-client-connection.c"
		}
#line 363 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_object_unref0 (_data_->_sent_it);
#line 2539 "imap-client-connection.c"
	}
#line 367 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp10_ = _data_->self->priv->sent_queue;
#line 367 "../src/engine/imap/transport/imap-client-connection.vala"
	gee_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp10_, GEE_TYPE_COLLECTION, GeeCollection));
#line 369 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp11_ = _data_->self->priv->serializer;
#line 369 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_data_->_tmp11_ != NULL) {
#line 370 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp12_ = _data_->self->priv->serializer;
#line 370 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_state_ = 1;
#line 370 "../src/engine/imap/transport/imap-client-connection.vala"
		geary_imap_serializer_close_stream (_data_->_tmp12_, _data_->cancellable, geary_imap_client_connection_close_channels_async_ready, _data_);
#line 370 "../src/engine/imap/transport/imap-client-connection.vala"
		return FALSE;
#line 2557 "imap-client-connection.c"
		_state_1:
#line 370 "../src/engine/imap/transport/imap-client-connection.vala"
		geary_imap_serializer_close_stream_finish (_data_->_tmp12_, _data_->_res_, &_data_->_inner_error0_);
#line 370 "../src/engine/imap/transport/imap-client-connection.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 370 "../src/engine/imap/transport/imap-client-connection.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 370 "../src/engine/imap/transport/imap-client-connection.vala"
			g_object_unref (_data_->_async_result);
#line 370 "../src/engine/imap/transport/imap-client-connection.vala"
			return FALSE;
#line 2569 "imap-client-connection.c"
		}
#line 371 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_object_unref0 (_data_->self->priv->serializer);
#line 371 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->self->priv->serializer = NULL;
#line 2575 "imap-client-connection.c"
	}
#line 374 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp13_ = _data_->self->priv->deserializer;
#line 374 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp14_ = _g_object_ref0 (_data_->_tmp13_);
#line 374 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->deserializer = _data_->_tmp14_;
#line 375 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp15_ = _data_->deserializer;
#line 375 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_data_->_tmp15_ != NULL) {
#line 376 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp16_ = _data_->deserializer;
#line 376 "../src/engine/imap/transport/imap-client-connection.vala"
		g_signal_parse_name ("bytes-received", GEARY_IMAP_TYPE_DESERIALIZER, &_data_->_tmp17_, NULL, FALSE);
#line 376 "../src/engine/imap/transport/imap-client-connection.vala"
		g_signal_handlers_disconnect_matched (_data_->_tmp16_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _data_->_tmp17_, 0, NULL, (GCallback) _geary_imap_client_connection_on_bytes_received_geary_imap_deserializer_bytes_received, _data_->self);
#line 377 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp18_ = _data_->deserializer;
#line 377 "../src/engine/imap/transport/imap-client-connection.vala"
		g_signal_parse_name ("deserialize-failure", GEARY_IMAP_TYPE_DESERIALIZER, &_data_->_tmp19_, NULL, FALSE);
#line 377 "../src/engine/imap/transport/imap-client-connection.vala"
		g_signal_handlers_disconnect_matched (_data_->_tmp18_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _data_->_tmp19_, 0, NULL, (GCallback) _geary_imap_client_connection_on_deserialize_failure_geary_imap_deserializer_deserialize_failure, _data_->self);
#line 378 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp20_ = _data_->deserializer;
#line 378 "../src/engine/imap/transport/imap-client-connection.vala"
		g_signal_parse_name ("end-of-stream", GEARY_IMAP_TYPE_DESERIALIZER, &_data_->_tmp21_, NULL, FALSE);
#line 378 "../src/engine/imap/transport/imap-client-connection.vala"
		g_signal_handlers_disconnect_matched (_data_->_tmp20_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _data_->_tmp21_, 0, NULL, (GCallback) _geary_imap_client_connection_on_eos_geary_imap_deserializer_end_of_stream, _data_->self);
#line 379 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp22_ = _data_->deserializer;
#line 379 "../src/engine/imap/transport/imap-client-connection.vala"
		g_signal_parse_name ("parameters-ready", GEARY_IMAP_TYPE_DESERIALIZER, &_data_->_tmp23_, NULL, FALSE);
#line 379 "../src/engine/imap/transport/imap-client-connection.vala"
		g_signal_handlers_disconnect_matched (_data_->_tmp22_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _data_->_tmp23_, 0, NULL, (GCallback) _geary_imap_client_connection_on_parameters_ready_geary_imap_deserializer_parameters_ready, _data_->self);
#line 380 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp24_ = _data_->deserializer;
#line 380 "../src/engine/imap/transport/imap-client-connection.vala"
		g_signal_parse_name ("receive-failure", GEARY_IMAP_TYPE_DESERIALIZER, &_data_->_tmp25_, NULL, FALSE);
#line 380 "../src/engine/imap/transport/imap-client-connection.vala"
		g_signal_handlers_disconnect_matched (_data_->_tmp24_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _data_->_tmp25_, 0, NULL, (GCallback) _geary_imap_client_connection_on_receive_failure_geary_imap_deserializer_receive_failure, _data_->self);
#line 382 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp26_ = _data_->deserializer;
#line 382 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_state_ = 2;
#line 382 "../src/engine/imap/transport/imap-client-connection.vala"
		geary_imap_deserializer_stop_async (_data_->_tmp26_, geary_imap_client_connection_close_channels_async_ready, _data_);
#line 382 "../src/engine/imap/transport/imap-client-connection.vala"
		return FALSE;
#line 2625 "imap-client-connection.c"
		_state_2:
#line 382 "../src/engine/imap/transport/imap-client-connection.vala"
		geary_imap_deserializer_stop_finish (_data_->_tmp26_, _data_->_res_, &_data_->_inner_error0_);
#line 382 "../src/engine/imap/transport/imap-client-connection.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 382 "../src/engine/imap/transport/imap-client-connection.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 382 "../src/engine/imap/transport/imap-client-connection.vala"
			_g_object_unref0 (_data_->deserializer);
#line 382 "../src/engine/imap/transport/imap-client-connection.vala"
			g_object_unref (_data_->_async_result);
#line 382 "../src/engine/imap/transport/imap-client-connection.vala"
			return FALSE;
#line 2639 "imap-client-connection.c"
		}
#line 383 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_object_unref0 (_data_->self->priv->deserializer);
#line 383 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->self->priv->deserializer = NULL;
#line 2645 "imap-client-connection.c"
	}
#line 359 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->deserializer);
#line 359 "../src/engine/imap/transport/imap-client-connection.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 359 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_data_->_state_ != 0) {
#line 359 "../src/engine/imap/transport/imap-client-connection.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 359 "../src/engine/imap/transport/imap-client-connection.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2657 "imap-client-connection.c"
		}
	}
#line 359 "../src/engine/imap/transport/imap-client-connection.vala"
	g_object_unref (_data_->_async_result);
#line 359 "../src/engine/imap/transport/imap-client-connection.vala"
	return FALSE;
#line 2664 "imap-client-connection.c"
}

static inline void
geary_imap_client_connection_cancel_idle (GearyImapClientConnection* self)
{
	GearyTimeoutManager* _tmp0_;
	GearyImapIdleCommand* idle = NULL;
	GearyImapCommand* _tmp1_;
	GearyImapIdleCommand* _tmp2_;
	GearyImapIdleCommand* _tmp3_;
#line 387 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self));
#line 388 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = self->priv->idle_timer;
#line 388 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_timeout_manager_reset (_tmp0_);
#line 389 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp1_ = self->priv->current_command;
#line 389 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp2_ = _g_object_ref0 (GEARY_IMAP_IS_IDLE_COMMAND (_tmp1_) ? ((GearyImapIdleCommand*) _tmp1_) : NULL);
#line 389 "../src/engine/imap/transport/imap-client-connection.vala"
	idle = _tmp2_;
#line 390 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp3_ = idle;
#line 390 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_tmp3_ != NULL) {
#line 2691 "imap-client-connection.c"
		GearyImapIdleCommand* _tmp4_;
#line 391 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp4_ = idle;
#line 391 "../src/engine/imap/transport/imap-client-connection.vala"
		geary_imap_idle_command_exit_idle (_tmp4_);
#line 2697 "imap-client-connection.c"
	}
#line 387 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (idle);
#line 2701 "imap-client-connection.c"
}

static GearyImapTag*
geary_imap_client_connection_generate_tag (GearyImapClientConnection* self)
{
	gint _tmp0_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GearyImapTag* _tmp4_;
	GearyImapTag* _tmp5_;
	GearyImapTag* result;
#line 397 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self), NULL);
#line 399 "../src/engine/imap/transport/imap-client-connection.vala"
	self->priv->tag_counter = self->priv->tag_counter + 1;
#line 399 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = self->priv->tag_counter;
#line 399 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_tmp0_ >= 1000) {
#line 2721 "imap-client-connection.c"
		gint _tmp1_ = 0;
#line 400 "../src/engine/imap/transport/imap-client-connection.vala"
		self->priv->tag_counter = 0;
#line 401 "../src/engine/imap/transport/imap-client-connection.vala"
		if (self->priv->tag_prefix != 'z') {
#line 401 "../src/engine/imap/transport/imap-client-connection.vala"
			_tmp1_ = self->priv->tag_prefix + 1;
#line 2729 "imap-client-connection.c"
		} else {
#line 401 "../src/engine/imap/transport/imap-client-connection.vala"
			_tmp1_ = (gint) 'a';
#line 2733 "imap-client-connection.c"
		}
#line 401 "../src/engine/imap/transport/imap-client-connection.vala"
		self->priv->tag_prefix = (gchar) _tmp1_;
#line 2737 "imap-client-connection.c"
	}
#line 405 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp2_ = g_strdup_printf ("%c%03d", (gint) self->priv->tag_prefix, self->priv->tag_counter);
#line 405 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp3_ = _tmp2_;
#line 405 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp4_ = geary_imap_tag_new (_tmp3_);
#line 405 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp5_ = _tmp4_;
#line 405 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_free0 (_tmp3_);
#line 405 "../src/engine/imap/transport/imap-client-connection.vala"
	result = _tmp5_;
#line 405 "../src/engine/imap/transport/imap-client-connection.vala"
	return result;
#line 2753 "imap-client-connection.c"
}

static void
geary_imap_client_connection_send_loop_data_free (gpointer _data)
{
	GearyImapClientConnectionSendLoopData* _data_;
	_data_ = _data;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->self);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_slice_free (GearyImapClientConnectionSendLoopData, _data_);
#line 2765 "imap-client-connection.c"
}

static void
geary_imap_client_connection_send_loop (GearyImapClientConnection* self,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	GearyImapClientConnectionSendLoopData* _data_;
	GearyImapClientConnection* _tmp0_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self));
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_ = g_slice_new0 (GearyImapClientConnectionSendLoopData);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_connection_send_loop_data_free);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->self = _tmp0_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_send_loop_co (_data_);
#line 2789 "imap-client-connection.c"
}

static void
geary_imap_client_connection_send_loop_finish (GearyImapClientConnection* self,
                                               GAsyncResult* _res_)
{
	GearyImapClientConnectionSendLoopData* _data_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2799 "imap-client-connection.c"
}

/** Long lived method to send commands as they are queued. */
static void
geary_imap_client_connection_send_loop_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_)
{
	GearyImapClientConnectionSendLoopData* _data_;
#line 413 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_ = _user_data_;
#line 413 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_source_object_ = source_object;
#line 413 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_res_ = _res_;
#line 413 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_send_loop_co (_data_);
#line 2817 "imap-client-connection.c"
}

static gboolean
geary_imap_client_connection_send_loop_co (GearyImapClientConnectionSendLoopData* _data_)
{
#line 409 "../src/engine/imap/transport/imap-client-connection.vala"
	switch (_data_->_state_) {
#line 409 "../src/engine/imap/transport/imap-client-connection.vala"
		case 0:
#line 2827 "imap-client-connection.c"
		goto _state_0;
#line 409 "../src/engine/imap/transport/imap-client-connection.vala"
		case 1:
#line 2831 "imap-client-connection.c"
		goto _state_1;
#line 409 "../src/engine/imap/transport/imap-client-connection.vala"
		case 2:
#line 2835 "imap-client-connection.c"
		goto _state_2;
#line 409 "../src/engine/imap/transport/imap-client-connection.vala"
		case 3:
#line 2839 "imap-client-connection.c"
		goto _state_3;
		default:
#line 409 "../src/engine/imap/transport/imap-client-connection.vala"
		g_assert_not_reached ();
#line 2844 "imap-client-connection.c"
	}
	_state_0:
#line 410 "../src/engine/imap/transport/imap-client-connection.vala"
	while (TRUE) {
#line 410 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp0_ = _data_->self->priv->open_cancellable;
#line 410 "../src/engine/imap/transport/imap-client-connection.vala"
		if (!(!g_cancellable_is_cancelled (_data_->_tmp0_))) {
#line 410 "../src/engine/imap/transport/imap-client-connection.vala"
			break;
#line 2855 "imap-client-connection.c"
		}
		{
#line 412 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp1_ = _data_->self->priv->open_cancellable;
#line 412 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp2_ = _g_object_ref0 (_data_->_tmp1_);
#line 412 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->cancellable = _data_->_tmp2_;
#line 413 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp3_ = _data_->self->priv->pending_queue;
#line 413 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp4_ = _data_->self->priv->open_cancellable;
#line 413 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_state_ = 1;
#line 413 "../src/engine/imap/transport/imap-client-connection.vala"
			geary_nonblocking_queue_receive (_data_->_tmp3_, _data_->_tmp4_, geary_imap_client_connection_send_loop_ready, _data_);
#line 413 "../src/engine/imap/transport/imap-client-connection.vala"
			return FALSE;
#line 2874 "imap-client-connection.c"
			_state_1:
#line 413 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp5_ = geary_nonblocking_queue_receive_finish (_data_->_tmp3_, _data_->_res_, &_data_->_inner_error0_);
#line 413 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->pending = (GearyImapCommand*) _data_->_tmp5_;
#line 413 "../src/engine/imap/transport/imap-client-connection.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 413 "../src/engine/imap/transport/imap-client-connection.vala"
				_g_object_unref0 (_data_->cancellable);
#line 2884 "imap-client-connection.c"
				goto __catch0_g_error;
			}
#line 419 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp7_ = _data_->pending;
#line 419 "../src/engine/imap/transport/imap-client-connection.vala"
			if (!GEARY_IMAP_IS_IDLE_COMMAND (_data_->_tmp7_)) {
#line 419 "../src/engine/imap/transport/imap-client-connection.vala"
				_data_->_tmp6_ = TRUE;
#line 2893 "imap-client-connection.c"
			} else {
#line 419 "../src/engine/imap/transport/imap-client-connection.vala"
				_data_->_tmp8_ = _data_->self->priv->pending_queue;
#line 419 "../src/engine/imap/transport/imap-client-connection.vala"
				_data_->_tmp9_ = geary_nonblocking_queue_get_is_empty (_data_->_tmp8_);
#line 419 "../src/engine/imap/transport/imap-client-connection.vala"
				_data_->_tmp10_ = _data_->_tmp9_;
#line 419 "../src/engine/imap/transport/imap-client-connection.vala"
				_data_->_tmp6_ = _data_->_tmp10_;
#line 2903 "imap-client-connection.c"
			}
#line 419 "../src/engine/imap/transport/imap-client-connection.vala"
			if (_data_->_tmp6_) {
#line 420 "../src/engine/imap/transport/imap-client-connection.vala"
				_data_->_tmp11_ = _data_->pending;
#line 420 "../src/engine/imap/transport/imap-client-connection.vala"
				_data_->_tmp12_ = _data_->cancellable;
#line 420 "../src/engine/imap/transport/imap-client-connection.vala"
				_data_->_state_ = 2;
#line 420 "../src/engine/imap/transport/imap-client-connection.vala"
				geary_imap_client_connection_flush_command (_data_->self, _data_->_tmp11_, _data_->_tmp12_, geary_imap_client_connection_send_loop_ready, _data_);
#line 420 "../src/engine/imap/transport/imap-client-connection.vala"
				return FALSE;
#line 2917 "imap-client-connection.c"
				_state_2:
#line 420 "../src/engine/imap/transport/imap-client-connection.vala"
				geary_imap_client_connection_flush_command_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 420 "../src/engine/imap/transport/imap-client-connection.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 420 "../src/engine/imap/transport/imap-client-connection.vala"
					_g_object_unref0 (_data_->pending);
#line 420 "../src/engine/imap/transport/imap-client-connection.vala"
					_g_object_unref0 (_data_->cancellable);
#line 2927 "imap-client-connection.c"
					goto __catch0_g_error;
				}
			}
#line 425 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp13_ = _data_->self->priv->pending_queue;
#line 425 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp14_ = geary_nonblocking_queue_get_is_empty (_data_->_tmp13_);
#line 425 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp15_ = _data_->_tmp14_;
#line 425 "../src/engine/imap/transport/imap-client-connection.vala"
			if (_data_->_tmp15_) {
#line 426 "../src/engine/imap/transport/imap-client-connection.vala"
				_data_->_tmp16_ = _data_->self->priv->serializer;
#line 426 "../src/engine/imap/transport/imap-client-connection.vala"
				_data_->_tmp17_ = _data_->cancellable;
#line 426 "../src/engine/imap/transport/imap-client-connection.vala"
				_data_->_state_ = 3;
#line 426 "../src/engine/imap/transport/imap-client-connection.vala"
				geary_imap_serializer_flush_stream (_data_->_tmp16_, _data_->_tmp17_, geary_imap_client_connection_send_loop_ready, _data_);
#line 426 "../src/engine/imap/transport/imap-client-connection.vala"
				return FALSE;
#line 2949 "imap-client-connection.c"
				_state_3:
#line 426 "../src/engine/imap/transport/imap-client-connection.vala"
				geary_imap_serializer_flush_stream_finish (_data_->_tmp16_, _data_->_res_, &_data_->_inner_error0_);
#line 426 "../src/engine/imap/transport/imap-client-connection.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 426 "../src/engine/imap/transport/imap-client-connection.vala"
					_g_object_unref0 (_data_->pending);
#line 426 "../src/engine/imap/transport/imap-client-connection.vala"
					_g_object_unref0 (_data_->cancellable);
#line 2959 "imap-client-connection.c"
					goto __catch0_g_error;
				}
			}
#line 411 "../src/engine/imap/transport/imap-client-connection.vala"
			_g_object_unref0 (_data_->pending);
#line 411 "../src/engine/imap/transport/imap-client-connection.vala"
			_g_object_unref0 (_data_->cancellable);
#line 2967 "imap-client-connection.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 411 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->err = _data_->_inner_error0_;
#line 411 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_inner_error0_ = NULL;
#line 429 "../src/engine/imap/transport/imap-client-connection.vala"
			_data_->_tmp18_ = _data_->err;
#line 429 "../src/engine/imap/transport/imap-client-connection.vala"
			if (!g_error_matches (_data_->_tmp18_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 430 "../src/engine/imap/transport/imap-client-connection.vala"
				_data_->_tmp19_ = _data_->err;
#line 430 "../src/engine/imap/transport/imap-client-connection.vala"
				g_signal_emit (_data_->self, geary_imap_client_connection_signals[GEARY_IMAP_CLIENT_CONNECTION_SEND_FAILURE_SIGNAL], 0, _data_->_tmp19_);
#line 2984 "imap-client-connection.c"
			}
#line 411 "../src/engine/imap/transport/imap-client-connection.vala"
			_g_error_free0 (_data_->err);
#line 2988 "imap-client-connection.c"
		}
		__finally0:
#line 411 "../src/engine/imap/transport/imap-client-connection.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 411 "../src/engine/imap/transport/imap-client-connection.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 411 "../src/engine/imap/transport/imap-client-connection.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 411 "../src/engine/imap/transport/imap-client-connection.vala"
			g_object_unref (_data_->_async_result);
#line 411 "../src/engine/imap/transport/imap-client-connection.vala"
			return FALSE;
#line 3001 "imap-client-connection.c"
		}
	}
#line 409 "../src/engine/imap/transport/imap-client-connection.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 409 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_data_->_state_ != 0) {
#line 409 "../src/engine/imap/transport/imap-client-connection.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 409 "../src/engine/imap/transport/imap-client-connection.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3012 "imap-client-connection.c"
		}
	}
#line 409 "../src/engine/imap/transport/imap-client-connection.vala"
	g_object_unref (_data_->_async_result);
#line 409 "../src/engine/imap/transport/imap-client-connection.vala"
	return FALSE;
#line 3019 "imap-client-connection.c"
}

static void
geary_imap_client_connection_flush_command_data_free (gpointer _data)
{
	GearyImapClientConnectionFlushCommandData* _data_;
	_data_ = _data;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->command);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->self);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_slice_free (GearyImapClientConnectionFlushCommandData, _data_);
#line 3035 "imap-client-connection.c"
}

static void
geary_imap_client_connection_flush_command (GearyImapClientConnection* self,
                                            GearyImapCommand* command,
                                            GCancellable* cancellable,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	GearyImapClientConnectionFlushCommandData* _data_;
	GearyImapClientConnection* _tmp0_;
	GearyImapCommand* _tmp1_;
	GCancellable* _tmp2_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self));
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (command));
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_ = g_slice_new0 (GearyImapClientConnectionFlushCommandData);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_connection_flush_command_data_free);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->self = _tmp0_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp1_ = _g_object_ref0 (command);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->command);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->command = _tmp1_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->cancellable = _tmp2_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_flush_command_co (_data_);
#line 3079 "imap-client-connection.c"
}

static void
geary_imap_client_connection_flush_command_finish (GearyImapClientConnection* self,
                                                   GAsyncResult* _res_,
                                                   GError** error)
{
	GearyImapClientConnectionFlushCommandData* _data_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	if (NULL == _data_) {
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
		return;
#line 3094 "imap-client-connection.c"
	}
}

static void
_geary_imap_client_connection_on_command_timeout_geary_imap_command_response_timed_out (GearyImapCommand* _sender,
                                                                                        gpointer self)
{
#line 462 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_on_command_timeout ((GearyImapClientConnection*) self, _sender);
#line 3104 "imap-client-connection.c"
}

static void
geary_imap_client_connection_flush_command_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_)
{
	GearyImapClientConnectionFlushCommandData* _data_;
#line 466 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_ = _user_data_;
#line 466 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_source_object_ = source_object;
#line 466 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_res_ = _res_;
#line 466 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_flush_command_co (_data_);
#line 3121 "imap-client-connection.c"
}

static gboolean
geary_imap_client_connection_flush_command_co (GearyImapClientConnectionFlushCommandData* _data_)
{
#line 441 "../src/engine/imap/transport/imap-client-connection.vala"
	switch (_data_->_state_) {
#line 441 "../src/engine/imap/transport/imap-client-connection.vala"
		case 0:
#line 3131 "imap-client-connection.c"
		goto _state_0;
#line 441 "../src/engine/imap/transport/imap-client-connection.vala"
		case 1:
#line 3135 "imap-client-connection.c"
		goto _state_1;
#line 441 "../src/engine/imap/transport/imap-client-connection.vala"
		case 2:
#line 3139 "imap-client-connection.c"
		goto _state_2;
		default:
#line 441 "../src/engine/imap/transport/imap-client-connection.vala"
		g_assert_not_reached ();
#line 3144 "imap-client-connection.c"
	}
	_state_0:
#line 443 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp1_ = geary_imap_command_get_should_send (_data_->command);
#line 443 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 443 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_data_->_tmp2_ != NULL) {
#line 444 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp3_ = geary_imap_command_get_should_send (_data_->command);
#line 444 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 444 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp0_ = g_cancellable_is_cancelled (_data_->_tmp4_);
#line 3159 "imap-client-connection.c"
	} else {
#line 443 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp0_ = FALSE;
#line 3163 "imap-client-connection.c"
	}
#line 443 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_data_->_tmp0_) {
#line 445 "../src/engine/imap/transport/imap-client-connection.vala"
		geary_imap_command_cancelled_before_send (_data_->command);
#line 446 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp5_ = geary_imap_command_to_brief_string (_data_->command);
#line 446 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 446 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp7_ = g_error_new (G_IO_ERROR, G_IO_ERROR_CANCELLED, "Not sending command, sending is cancelled: %s", _data_->_tmp6_);
#line 446 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 446 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_free0 (_data_->_tmp6_);
#line 446 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_inner_error0_ = _data_->_tmp8_;
#line 446 "../src/engine/imap/transport/imap-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 446 "../src/engine/imap/transport/imap-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 446 "../src/engine/imap/transport/imap-client-connection.vala"
		return FALSE;
#line 3187 "imap-client-connection.c"
	}
#line 451 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->ser_error = NULL;
#line 3191 "imap-client-connection.c"
	{
#line 458 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp9_ = geary_imap_client_connection_generate_tag (_data_->self);
#line 458 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 458 "../src/engine/imap/transport/imap-client-connection.vala"
		geary_imap_command_assign_tag (_data_->command, _data_->_tmp10_, &_data_->_inner_error0_);
#line 458 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_object_unref0 (_data_->_tmp10_);
#line 458 "../src/engine/imap/transport/imap-client-connection.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3203 "imap-client-connection.c"
			goto __catch0_g_error;
		}
#line 461 "../src/engine/imap/transport/imap-client-connection.vala"
		geary_imap_command_set_response_timeout (_data_->command, _data_->self->priv->command_timeout);
#line 462 "../src/engine/imap/transport/imap-client-connection.vala"
		g_signal_connect_object (_data_->command, "response-timed-out", (GCallback) _geary_imap_client_connection_on_command_timeout_geary_imap_command_response_timed_out, _data_->self, 0);
#line 464 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp11_ = _g_object_ref0 (_data_->command);
#line 464 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_object_unref0 (_data_->self->priv->current_command);
#line 464 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->self->priv->current_command = _data_->_tmp11_;
#line 465 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp12_ = _data_->self->priv->sent_queue;
#line 465 "../src/engine/imap/transport/imap-client-connection.vala"
		gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp12_, GEE_TYPE_COLLECTION, GeeCollection), _data_->command);
#line 466 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp13_ = _data_->self->priv->serializer;
#line 466 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_state_ = 1;
#line 466 "../src/engine/imap/transport/imap-client-connection.vala"
		geary_imap_command_send (_data_->command, _data_->_tmp13_, _data_->cancellable, geary_imap_client_connection_flush_command_ready, _data_);
#line 466 "../src/engine/imap/transport/imap-client-connection.vala"
		return FALSE;
#line 3228 "imap-client-connection.c"
		_state_1:
#line 466 "../src/engine/imap/transport/imap-client-connection.vala"
		geary_imap_command_send_finish (_data_->command, _data_->_res_, &_data_->_inner_error0_);
#line 466 "../src/engine/imap/transport/imap-client-connection.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3234 "imap-client-connection.c"
			goto __catch0_g_error;
		}
#line 467 "../src/engine/imap/transport/imap-client-connection.vala"
		g_signal_emit (_data_->self, geary_imap_client_connection_signals[GEARY_IMAP_CLIENT_CONNECTION_SENT_COMMAND_SIGNAL], 0, _data_->command);
#line 468 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp14_ = _data_->self->priv->serializer;
#line 468 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_state_ = 2;
#line 468 "../src/engine/imap/transport/imap-client-connection.vala"
		geary_imap_command_send_wait (_data_->command, _data_->_tmp14_, _data_->cancellable, geary_imap_client_connection_flush_command_ready, _data_);
#line 468 "../src/engine/imap/transport/imap-client-connection.vala"
		return FALSE;
#line 3247 "imap-client-connection.c"
		_state_2:
#line 468 "../src/engine/imap/transport/imap-client-connection.vala"
		geary_imap_command_send_wait_finish (_data_->command, _data_->_res_, &_data_->_inner_error0_);
#line 468 "../src/engine/imap/transport/imap-client-connection.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3253 "imap-client-connection.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 452 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->err = _data_->_inner_error0_;
#line 452 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_inner_error0_ = NULL;
#line 470 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp15_ = _data_->err;
#line 470 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp16_ = _g_error_copy0 (_data_->_tmp15_);
#line 470 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_error_free0 (_data_->ser_error);
#line 470 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->ser_error = _data_->_tmp16_;
#line 452 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_error_free0 (_data_->err);
#line 3274 "imap-client-connection.c"
	}
	__finally0:
#line 452 "../src/engine/imap/transport/imap-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 452 "../src/engine/imap/transport/imap-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 452 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_error_free0 (_data_->ser_error);
#line 452 "../src/engine/imap/transport/imap-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 452 "../src/engine/imap/transport/imap-client-connection.vala"
		return FALSE;
#line 3287 "imap-client-connection.c"
	}
#line 473 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (_data_->self->priv->current_command);
#line 473 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->self->priv->current_command = NULL;
#line 475 "../src/engine/imap/transport/imap-client-connection.vala"
	_data_->_tmp17_ = _data_->ser_error;
#line 475 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_data_->_tmp17_ != NULL) {
#line 476 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp18_ = _data_->self->priv->sent_queue;
#line 476 "../src/engine/imap/transport/imap-client-connection.vala"
		gee_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp18_, GEE_TYPE_COLLECTION, GeeCollection), _data_->command);
#line 477 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp19_ = _data_->ser_error;
#line 477 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_tmp20_ = _g_error_copy0 (_data_->_tmp19_);
#line 477 "../src/engine/imap/transport/imap-client-connection.vala"
		_data_->_inner_error0_ = _data_->_tmp20_;
#line 477 "../src/engine/imap/transport/imap-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 477 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_error_free0 (_data_->ser_error);
#line 477 "../src/engine/imap/transport/imap-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 477 "../src/engine/imap/transport/imap-client-connection.vala"
		return FALSE;
#line 3315 "imap-client-connection.c"
	}
#line 441 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_error_free0 (_data_->ser_error);
#line 441 "../src/engine/imap/transport/imap-client-connection.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 441 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_data_->_state_ != 0) {
#line 441 "../src/engine/imap/transport/imap-client-connection.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 441 "../src/engine/imap/transport/imap-client-connection.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3327 "imap-client-connection.c"
		}
	}
#line 441 "../src/engine/imap/transport/imap-client-connection.vala"
	g_object_unref (_data_->_async_result);
#line 441 "../src/engine/imap/transport/imap-client-connection.vala"
	return FALSE;
#line 3334 "imap-client-connection.c"
}

static void
geary_imap_client_connection_check_connection (GearyImapClientConnection* self,
                                               GError** error)
{
	GIOStream* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 481 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self));
#line 482 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = self->priv->cx;
#line 482 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_tmp0_ == NULL) {
#line 3349 "imap-client-connection.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
		GError* _tmp3_;
		GError* _tmp4_;
#line 483 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp1_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 483 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp2_ = _tmp1_;
#line 483 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp3_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_NOT_CONNECTED, "Not connected to %s", _tmp2_);
#line 483 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp4_ = _tmp3_;
#line 483 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_free0 (_tmp2_);
#line 483 "../src/engine/imap/transport/imap-client-connection.vala"
		_inner_error0_ = _tmp4_;
#line 483 "../src/engine/imap/transport/imap-client-connection.vala"
		if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 483 "../src/engine/imap/transport/imap-client-connection.vala"
			g_propagate_error (error, _inner_error0_);
#line 483 "../src/engine/imap/transport/imap-client-connection.vala"
			return;
#line 3372 "imap-client-connection.c"
		} else {
#line 483 "../src/engine/imap/transport/imap-client-connection.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 483 "../src/engine/imap/transport/imap-client-connection.vala"
			g_clear_error (&_inner_error0_);
#line 483 "../src/engine/imap/transport/imap-client-connection.vala"
			return;
#line 3380 "imap-client-connection.c"
		}
	}
}

static void
geary_imap_client_connection_on_parameters_ready (GearyImapClientConnection* self,
                                                  GearyImapRootParameters* root)
{
	gboolean _tmp14_ = FALSE;
	GearyNonblockingQueue* _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
	GError* _inner_error0_ = NULL;
#line 489 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self));
#line 489 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_ROOT_PARAMETERS (root));
#line 3398 "imap-client-connection.c"
	{
#line 492 "../src/engine/imap/transport/imap-client-connection.vala"
		if (geary_imap_continuation_response_is_continuation_response (root)) {
#line 3402 "imap-client-connection.c"
			GearyImapContinuationResponse* _tmp0_ = NULL;
			GearyImapQuirks* _tmp1_;
			GearyImapContinuationResponse* _tmp2_;
#line 494 "../src/engine/imap/transport/imap-client-connection.vala"
			_tmp1_ = self->priv->quirks;
#line 494 "../src/engine/imap/transport/imap-client-connection.vala"
			_tmp2_ = geary_imap_continuation_response_new_migrate (root, _tmp1_, &_inner_error0_);
#line 494 "../src/engine/imap/transport/imap-client-connection.vala"
			_tmp0_ = _tmp2_;
#line 494 "../src/engine/imap/transport/imap-client-connection.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 494 "../src/engine/imap/transport/imap-client-connection.vala"
				if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 3416 "imap-client-connection.c"
					goto __catch0_geary_imap_error;
				}
#line 494 "../src/engine/imap/transport/imap-client-connection.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 494 "../src/engine/imap/transport/imap-client-connection.vala"
				g_clear_error (&_inner_error0_);
#line 494 "../src/engine/imap/transport/imap-client-connection.vala"
				return;
#line 3425 "imap-client-connection.c"
			}
#line 493 "../src/engine/imap/transport/imap-client-connection.vala"
			geary_imap_client_connection_on_continuation_response (self, _tmp0_, &_inner_error0_);
#line 493 "../src/engine/imap/transport/imap-client-connection.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 493 "../src/engine/imap/transport/imap-client-connection.vala"
				_g_object_unref0 (_tmp0_);
#line 493 "../src/engine/imap/transport/imap-client-connection.vala"
				if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 3435 "imap-client-connection.c"
					goto __catch0_geary_imap_error;
				}
#line 493 "../src/engine/imap/transport/imap-client-connection.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 493 "../src/engine/imap/transport/imap-client-connection.vala"
				g_clear_error (&_inner_error0_);
#line 493 "../src/engine/imap/transport/imap-client-connection.vala"
				return;
#line 3444 "imap-client-connection.c"
			}
#line 492 "../src/engine/imap/transport/imap-client-connection.vala"
			_g_object_unref0 (_tmp0_);
#line 3448 "imap-client-connection.c"
		} else {
#line 496 "../src/engine/imap/transport/imap-client-connection.vala"
			if (geary_imap_status_response_is_status_response (root)) {
#line 3452 "imap-client-connection.c"
				GearyImapStatusResponse* _tmp3_ = NULL;
				GearyImapQuirks* _tmp4_;
				GearyImapStatusResponse* _tmp5_;
#line 497 "../src/engine/imap/transport/imap-client-connection.vala"
				_tmp4_ = self->priv->quirks;
#line 497 "../src/engine/imap/transport/imap-client-connection.vala"
				_tmp5_ = geary_imap_status_response_new_migrate (root, _tmp4_, &_inner_error0_);
#line 497 "../src/engine/imap/transport/imap-client-connection.vala"
				_tmp3_ = _tmp5_;
#line 497 "../src/engine/imap/transport/imap-client-connection.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 497 "../src/engine/imap/transport/imap-client-connection.vala"
					if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 3466 "imap-client-connection.c"
						goto __catch0_geary_imap_error;
					}
#line 497 "../src/engine/imap/transport/imap-client-connection.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 497 "../src/engine/imap/transport/imap-client-connection.vala"
					g_clear_error (&_inner_error0_);
#line 497 "../src/engine/imap/transport/imap-client-connection.vala"
					return;
#line 3475 "imap-client-connection.c"
				}
#line 497 "../src/engine/imap/transport/imap-client-connection.vala"
				geary_imap_client_connection_on_status_response (self, _tmp3_, &_inner_error0_);
#line 497 "../src/engine/imap/transport/imap-client-connection.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 497 "../src/engine/imap/transport/imap-client-connection.vala"
					_g_object_unref0 (_tmp3_);
#line 497 "../src/engine/imap/transport/imap-client-connection.vala"
					if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 3485 "imap-client-connection.c"
						goto __catch0_geary_imap_error;
					}
#line 497 "../src/engine/imap/transport/imap-client-connection.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 497 "../src/engine/imap/transport/imap-client-connection.vala"
					g_clear_error (&_inner_error0_);
#line 497 "../src/engine/imap/transport/imap-client-connection.vala"
					return;
#line 3494 "imap-client-connection.c"
				}
#line 496 "../src/engine/imap/transport/imap-client-connection.vala"
				_g_object_unref0 (_tmp3_);
#line 3498 "imap-client-connection.c"
			} else {
#line 498 "../src/engine/imap/transport/imap-client-connection.vala"
				if (geary_imap_server_data_is_server_data (root)) {
#line 3502 "imap-client-connection.c"
					GearyImapServerData* _tmp6_ = NULL;
					GearyImapQuirks* _tmp7_;
					GearyImapServerData* _tmp8_;
#line 499 "../src/engine/imap/transport/imap-client-connection.vala"
					_tmp7_ = self->priv->quirks;
#line 499 "../src/engine/imap/transport/imap-client-connection.vala"
					_tmp8_ = geary_imap_server_data_new_migrate (root, _tmp7_, &_inner_error0_);
#line 499 "../src/engine/imap/transport/imap-client-connection.vala"
					_tmp6_ = _tmp8_;
#line 499 "../src/engine/imap/transport/imap-client-connection.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 499 "../src/engine/imap/transport/imap-client-connection.vala"
						if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 3516 "imap-client-connection.c"
							goto __catch0_geary_imap_error;
						}
#line 499 "../src/engine/imap/transport/imap-client-connection.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 499 "../src/engine/imap/transport/imap-client-connection.vala"
						g_clear_error (&_inner_error0_);
#line 499 "../src/engine/imap/transport/imap-client-connection.vala"
						return;
#line 3525 "imap-client-connection.c"
					}
#line 499 "../src/engine/imap/transport/imap-client-connection.vala"
					geary_imap_client_connection_on_server_data (self, _tmp6_, &_inner_error0_);
#line 499 "../src/engine/imap/transport/imap-client-connection.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 499 "../src/engine/imap/transport/imap-client-connection.vala"
						_g_object_unref0 (_tmp6_);
#line 499 "../src/engine/imap/transport/imap-client-connection.vala"
						if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 3535 "imap-client-connection.c"
							goto __catch0_geary_imap_error;
						}
#line 499 "../src/engine/imap/transport/imap-client-connection.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 499 "../src/engine/imap/transport/imap-client-connection.vala"
						g_clear_error (&_inner_error0_);
#line 499 "../src/engine/imap/transport/imap-client-connection.vala"
						return;
#line 3544 "imap-client-connection.c"
					}
#line 498 "../src/engine/imap/transport/imap-client-connection.vala"
					_g_object_unref0 (_tmp6_);
#line 3548 "imap-client-connection.c"
				} else {
					gchar* _tmp9_;
					gchar* _tmp10_;
					GError* _tmp11_;
					GError* _tmp12_;
#line 501 "../src/engine/imap/transport/imap-client-connection.vala"
					_tmp9_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (root, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 501 "../src/engine/imap/transport/imap-client-connection.vala"
					_tmp10_ = _tmp9_;
#line 501 "../src/engine/imap/transport/imap-client-connection.vala"
					_tmp11_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_PARSE_ERROR, "Unknown server response: %s", _tmp10_);
#line 501 "../src/engine/imap/transport/imap-client-connection.vala"
					_tmp12_ = _tmp11_;
#line 501 "../src/engine/imap/transport/imap-client-connection.vala"
					_g_free0 (_tmp10_);
#line 501 "../src/engine/imap/transport/imap-client-connection.vala"
					_inner_error0_ = _tmp12_;
#line 501 "../src/engine/imap/transport/imap-client-connection.vala"
					if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 3568 "imap-client-connection.c"
						goto __catch0_geary_imap_error;
					}
#line 501 "../src/engine/imap/transport/imap-client-connection.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 501 "../src/engine/imap/transport/imap-client-connection.vala"
					g_clear_error (&_inner_error0_);
#line 501 "../src/engine/imap/transport/imap-client-connection.vala"
					return;
#line 3577 "imap-client-connection.c"
				}
			}
		}
	}
	goto __finally0;
	__catch0_geary_imap_error:
	{
		GError* err = NULL;
		GError* _tmp13_;
#line 490 "../src/engine/imap/transport/imap-client-connection.vala"
		err = _inner_error0_;
#line 490 "../src/engine/imap/transport/imap-client-connection.vala"
		_inner_error0_ = NULL;
#line 506 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp13_ = err;
#line 506 "../src/engine/imap/transport/imap-client-connection.vala"
		g_signal_emit (self, geary_imap_client_connection_signals[GEARY_IMAP_CLIENT_CONNECTION_RECEIVED_BAD_RESPONSE_SIGNAL], 0, root, _tmp13_);
#line 490 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_error_free0 (err);
#line 3597 "imap-client-connection.c"
	}
	__finally0:
#line 490 "../src/engine/imap/transport/imap-client-connection.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 490 "../src/engine/imap/transport/imap-client-connection.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 490 "../src/engine/imap/transport/imap-client-connection.vala"
		g_clear_error (&_inner_error0_);
#line 490 "../src/engine/imap/transport/imap-client-connection.vala"
		return;
#line 3608 "imap-client-connection.c"
	}
#line 509 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp15_ = self->priv->pending_queue;
#line 509 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp16_ = geary_nonblocking_queue_get_is_empty (_tmp15_);
#line 509 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp17_ = _tmp16_;
#line 509 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_tmp17_) {
#line 3618 "imap-client-connection.c"
		GeeQueue* _tmp18_;
		gboolean _tmp19_;
		gboolean _tmp20_;
#line 509 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp18_ = self->priv->sent_queue;
#line 509 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp19_ = gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_COLLECTION, GeeCollection));
#line 509 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp20_ = _tmp19_;
#line 509 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp14_ = _tmp20_;
#line 3630 "imap-client-connection.c"
	} else {
#line 509 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp14_ = FALSE;
#line 3634 "imap-client-connection.c"
	}
#line 509 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_tmp14_) {
#line 3638 "imap-client-connection.c"
		gboolean _tmp21_;
#line 512 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp21_ = self->priv->_idle_when_quiet;
#line 512 "../src/engine/imap/transport/imap-client-connection.vala"
		if (_tmp21_) {
#line 3644 "imap-client-connection.c"
			GearyTimeoutManager* _tmp22_;
#line 513 "../src/engine/imap/transport/imap-client-connection.vala"
			_tmp22_ = self->priv->idle_timer;
#line 513 "../src/engine/imap/transport/imap-client-connection.vala"
			geary_timeout_manager_start (_tmp22_);
#line 3650 "imap-client-connection.c"
		}
	}
}

static void
geary_imap_client_connection_on_status_response (GearyImapClientConnection* self,
                                                 GearyImapStatusResponse* status,
                                                 GError** error)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GError* _inner_error0_ = NULL;
#line 518 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self));
#line 518 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_STATUS_RESPONSE (status));
#line 521 "../src/engine/imap/transport/imap-client-connection.vala"
	g_signal_emit (self, geary_imap_client_connection_signals[GEARY_IMAP_CLIENT_CONNECTION_RECEIVED_STATUS_RESPONSE_SIGNAL], 0, status);
#line 523 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = geary_imap_status_response_get_is_completion (status);
#line 523 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp1_ = _tmp0_;
#line 523 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_tmp1_) {
#line 3675 "imap-client-connection.c"
		GearyImapCommand* sent = NULL;
		GearyImapTag* _tmp2_;
		GearyImapTag* _tmp3_;
		GearyImapCommand* _tmp4_;
		GearyImapCommand* _tmp5_;
		GeeQueue* _tmp10_;
		GearyImapCommand* _tmp11_;
		GearyImapCommand* _tmp12_;
		guint _tmp13_;
		GearyImapCommand* _tmp14_;
#line 524 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp2_ = geary_imap_server_response_get_tag (G_TYPE_CHECK_INSTANCE_CAST (status, GEARY_IMAP_TYPE_SERVER_RESPONSE, GearyImapServerResponse));
#line 524 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp3_ = _tmp2_;
#line 524 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp4_ = geary_imap_client_connection_get_sent_command (self, _tmp3_);
#line 524 "../src/engine/imap/transport/imap-client-connection.vala"
		sent = _tmp4_;
#line 525 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp5_ = sent;
#line 525 "../src/engine/imap/transport/imap-client-connection.vala"
		if (_tmp5_ == NULL) {
#line 3698 "imap-client-connection.c"
			gchar* _tmp6_;
			gchar* _tmp7_;
			GError* _tmp8_;
			GError* _tmp9_;
#line 526 "../src/engine/imap/transport/imap-client-connection.vala"
			_tmp6_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (status, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 526 "../src/engine/imap/transport/imap-client-connection.vala"
			_tmp7_ = _tmp6_;
#line 526 "../src/engine/imap/transport/imap-client-connection.vala"
			_tmp8_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_SERVER_ERROR, "Unexpected status response: %s", _tmp7_);
#line 526 "../src/engine/imap/transport/imap-client-connection.vala"
			_tmp9_ = _tmp8_;
#line 526 "../src/engine/imap/transport/imap-client-connection.vala"
			_g_free0 (_tmp7_);
#line 526 "../src/engine/imap/transport/imap-client-connection.vala"
			_inner_error0_ = _tmp9_;
#line 526 "../src/engine/imap/transport/imap-client-connection.vala"
			if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 526 "../src/engine/imap/transport/imap-client-connection.vala"
				g_propagate_error (error, _inner_error0_);
#line 526 "../src/engine/imap/transport/imap-client-connection.vala"
				_g_object_unref0 (sent);
#line 526 "../src/engine/imap/transport/imap-client-connection.vala"
				return;
#line 3723 "imap-client-connection.c"
			} else {
#line 526 "../src/engine/imap/transport/imap-client-connection.vala"
				_g_object_unref0 (sent);
#line 526 "../src/engine/imap/transport/imap-client-connection.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 526 "../src/engine/imap/transport/imap-client-connection.vala"
				g_clear_error (&_inner_error0_);
#line 526 "../src/engine/imap/transport/imap-client-connection.vala"
				return;
#line 3733 "imap-client-connection.c"
			}
		}
#line 530 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp10_ = self->priv->sent_queue;
#line 530 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp11_ = sent;
#line 530 "../src/engine/imap/transport/imap-client-connection.vala"
		gee_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_COLLECTION, GeeCollection), _tmp11_);
#line 531 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp12_ = sent;
#line 531 "../src/engine/imap/transport/imap-client-connection.vala"
		g_signal_parse_name ("response-timed-out", GEARY_IMAP_TYPE_COMMAND, &_tmp13_, NULL, FALSE);
#line 531 "../src/engine/imap/transport/imap-client-connection.vala"
		g_signal_handlers_disconnect_matched (_tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _geary_imap_client_connection_on_command_timeout_geary_imap_command_response_timed_out, self);
#line 533 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp14_ = sent;
#line 533 "../src/engine/imap/transport/imap-client-connection.vala"
		geary_imap_command_completed (_tmp14_, status, &_inner_error0_);
#line 533 "../src/engine/imap/transport/imap-client-connection.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 533 "../src/engine/imap/transport/imap-client-connection.vala"
			if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 533 "../src/engine/imap/transport/imap-client-connection.vala"
				g_propagate_error (error, _inner_error0_);
#line 533 "../src/engine/imap/transport/imap-client-connection.vala"
				_g_object_unref0 (sent);
#line 533 "../src/engine/imap/transport/imap-client-connection.vala"
				return;
#line 3762 "imap-client-connection.c"
			} else {
#line 533 "../src/engine/imap/transport/imap-client-connection.vala"
				_g_object_unref0 (sent);
#line 533 "../src/engine/imap/transport/imap-client-connection.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 533 "../src/engine/imap/transport/imap-client-connection.vala"
				g_clear_error (&_inner_error0_);
#line 533 "../src/engine/imap/transport/imap-client-connection.vala"
				return;
#line 3772 "imap-client-connection.c"
			}
		}
#line 523 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_object_unref0 (sent);
#line 3777 "imap-client-connection.c"
	}
}

static void
geary_imap_client_connection_on_server_data (GearyImapClientConnection* self,
                                             GearyImapServerData* data,
                                             GError** error)
{
	GearyImapCommand* sent = NULL;
	GearyImapTag* _tmp0_;
	GearyImapTag* _tmp1_;
	GearyImapCommand* _tmp2_;
	GearyImapCommand* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 537 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self));
#line 537 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_SERVER_DATA (data));
#line 539 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = geary_imap_server_response_get_tag (G_TYPE_CHECK_INSTANCE_CAST (data, GEARY_IMAP_TYPE_SERVER_RESPONSE, GearyImapServerResponse));
#line 539 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp1_ = _tmp0_;
#line 539 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp2_ = geary_imap_client_connection_get_sent_command (self, _tmp1_);
#line 539 "../src/engine/imap/transport/imap-client-connection.vala"
	sent = _tmp2_;
#line 540 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp3_ = sent;
#line 540 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_tmp3_ != NULL) {
#line 3808 "imap-client-connection.c"
		GearyImapCommand* _tmp4_;
#line 541 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp4_ = sent;
#line 541 "../src/engine/imap/transport/imap-client-connection.vala"
		geary_imap_command_data_received (_tmp4_, data, &_inner_error0_);
#line 541 "../src/engine/imap/transport/imap-client-connection.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 541 "../src/engine/imap/transport/imap-client-connection.vala"
			if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 541 "../src/engine/imap/transport/imap-client-connection.vala"
				g_propagate_error (error, _inner_error0_);
#line 541 "../src/engine/imap/transport/imap-client-connection.vala"
				_g_object_unref0 (sent);
#line 541 "../src/engine/imap/transport/imap-client-connection.vala"
				return;
#line 3824 "imap-client-connection.c"
			} else {
#line 541 "../src/engine/imap/transport/imap-client-connection.vala"
				_g_object_unref0 (sent);
#line 541 "../src/engine/imap/transport/imap-client-connection.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 541 "../src/engine/imap/transport/imap-client-connection.vala"
				g_clear_error (&_inner_error0_);
#line 541 "../src/engine/imap/transport/imap-client-connection.vala"
				return;
#line 3834 "imap-client-connection.c"
			}
		}
	}
#line 544 "../src/engine/imap/transport/imap-client-connection.vala"
	g_signal_emit (self, geary_imap_client_connection_signals[GEARY_IMAP_CLIENT_CONNECTION_RECEIVED_SERVER_DATA_SIGNAL], 0, data);
#line 537 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (sent);
#line 3842 "imap-client-connection.c"
}

static void
geary_imap_client_connection_on_continuation_response (GearyImapClientConnection* self,
                                                       GearyImapContinuationResponse* continuation,
                                                       GError** error)
{
	GearyImapCommand* current = NULL;
	GearyImapCommand* _tmp0_;
	GearyImapCommand* _tmp1_;
	GearyImapCommand* _tmp2_;
	GearyImapCommand* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 547 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self));
#line 547 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CONTINUATION_RESPONSE (continuation));
#line 549 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = self->priv->current_command;
#line 549 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 549 "../src/engine/imap/transport/imap-client-connection.vala"
	current = _tmp1_;
#line 550 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp2_ = current;
#line 550 "../src/engine/imap/transport/imap-client-connection.vala"
	if (_tmp2_ == NULL) {
#line 3870 "imap-client-connection.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
		GError* _tmp5_;
		GError* _tmp6_;
#line 551 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp3_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (continuation, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 551 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp4_ = _tmp3_;
#line 551 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp5_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_SERVER_ERROR, "Unexpected continuation request response: %s", _tmp4_);
#line 551 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp6_ = _tmp5_;
#line 551 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_free0 (_tmp4_);
#line 551 "../src/engine/imap/transport/imap-client-connection.vala"
		_inner_error0_ = _tmp6_;
#line 551 "../src/engine/imap/transport/imap-client-connection.vala"
		if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 551 "../src/engine/imap/transport/imap-client-connection.vala"
			g_propagate_error (error, _inner_error0_);
#line 551 "../src/engine/imap/transport/imap-client-connection.vala"
			_g_object_unref0 (current);
#line 551 "../src/engine/imap/transport/imap-client-connection.vala"
			return;
#line 3895 "imap-client-connection.c"
		} else {
#line 551 "../src/engine/imap/transport/imap-client-connection.vala"
			_g_object_unref0 (current);
#line 551 "../src/engine/imap/transport/imap-client-connection.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 551 "../src/engine/imap/transport/imap-client-connection.vala"
			g_clear_error (&_inner_error0_);
#line 551 "../src/engine/imap/transport/imap-client-connection.vala"
			return;
#line 3905 "imap-client-connection.c"
		}
	}
#line 556 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp7_ = current;
#line 556 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_command_continuation_requested (_tmp7_, continuation, &_inner_error0_);
#line 556 "../src/engine/imap/transport/imap-client-connection.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 556 "../src/engine/imap/transport/imap-client-connection.vala"
		if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 556 "../src/engine/imap/transport/imap-client-connection.vala"
			g_propagate_error (error, _inner_error0_);
#line 556 "../src/engine/imap/transport/imap-client-connection.vala"
			_g_object_unref0 (current);
#line 556 "../src/engine/imap/transport/imap-client-connection.vala"
			return;
#line 3922 "imap-client-connection.c"
		} else {
#line 556 "../src/engine/imap/transport/imap-client-connection.vala"
			_g_object_unref0 (current);
#line 556 "../src/engine/imap/transport/imap-client-connection.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 556 "../src/engine/imap/transport/imap-client-connection.vala"
			g_clear_error (&_inner_error0_);
#line 556 "../src/engine/imap/transport/imap-client-connection.vala"
			return;
#line 3932 "imap-client-connection.c"
		}
	}
#line 558 "../src/engine/imap/transport/imap-client-connection.vala"
	g_signal_emit (self, geary_imap_client_connection_signals[GEARY_IMAP_CLIENT_CONNECTION_RECEIVED_CONTINUATION_RESPONSE_SIGNAL], 0, continuation);
#line 547 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (current);
#line 3939 "imap-client-connection.c"
}

static void
geary_imap_client_connection_on_bytes_received (GearyImapClientConnection* self,
                                                gsize bytes)
{
	gint64 now = 0LL;
#line 561 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self));
#line 566 "../src/engine/imap/transport/imap-client-connection.vala"
	self->priv->bytes_accumulator = self->priv->bytes_accumulator + bytes;
#line 567 "../src/engine/imap/transport/imap-client-connection.vala"
	now = g_get_real_time ();
#line 568 "../src/engine/imap/transport/imap-client-connection.vala"
	if ((self->priv->last_seen + 1000000) <= now) {
#line 3955 "imap-client-connection.c"
		{
			GeeIterator* _command_it = NULL;
			GeeQueue* _tmp0_;
			GeeIterator* _tmp1_;
#line 571 "../src/engine/imap/transport/imap-client-connection.vala"
			_tmp0_ = self->priv->sent_queue;
#line 571 "../src/engine/imap/transport/imap-client-connection.vala"
			_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ITERABLE, GeeIterable));
#line 571 "../src/engine/imap/transport/imap-client-connection.vala"
			_command_it = _tmp1_;
#line 571 "../src/engine/imap/transport/imap-client-connection.vala"
			while (TRUE) {
#line 3968 "imap-client-connection.c"
				GeeIterator* _tmp2_;
				GearyImapCommand* command = NULL;
				GeeIterator* _tmp3_;
				gpointer _tmp4_;
				GearyImapCommand* _tmp5_;
#line 571 "../src/engine/imap/transport/imap-client-connection.vala"
				_tmp2_ = _command_it;
#line 571 "../src/engine/imap/transport/imap-client-connection.vala"
				if (!gee_iterator_next (_tmp2_)) {
#line 571 "../src/engine/imap/transport/imap-client-connection.vala"
					break;
#line 3980 "imap-client-connection.c"
				}
#line 571 "../src/engine/imap/transport/imap-client-connection.vala"
				_tmp3_ = _command_it;
#line 571 "../src/engine/imap/transport/imap-client-connection.vala"
				_tmp4_ = gee_iterator_get (_tmp3_);
#line 571 "../src/engine/imap/transport/imap-client-connection.vala"
				command = (GearyImapCommand*) _tmp4_;
#line 572 "../src/engine/imap/transport/imap-client-connection.vala"
				_tmp5_ = command;
#line 572 "../src/engine/imap/transport/imap-client-connection.vala"
				geary_imap_command_update_response_timer (_tmp5_);
#line 571 "../src/engine/imap/transport/imap-client-connection.vala"
				_g_object_unref0 (command);
#line 3994 "imap-client-connection.c"
			}
#line 571 "../src/engine/imap/transport/imap-client-connection.vala"
			_g_object_unref0 (_command_it);
#line 3998 "imap-client-connection.c"
		}
#line 574 "../src/engine/imap/transport/imap-client-connection.vala"
		g_signal_emit (self, geary_imap_client_connection_signals[GEARY_IMAP_CLIENT_CONNECTION_RECEIVED_BYTES_SIGNAL], 0, self->priv->bytes_accumulator);
#line 575 "../src/engine/imap/transport/imap-client-connection.vala"
		self->priv->bytes_accumulator = (gsize) 0;
#line 576 "../src/engine/imap/transport/imap-client-connection.vala"
		self->priv->last_seen = now;
#line 4006 "imap-client-connection.c"
	}
}

static void
geary_imap_client_connection_on_eos (GearyImapClientConnection* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _tmp2_;
	GError* _tmp3_;
#line 580 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self));
#line 581 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 581 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp1_ = _tmp0_;
#line 581 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp2_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_NOT_CONNECTED, "End of stream reading from %s", _tmp1_);
#line 581 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp3_ = _tmp2_;
#line 581 "../src/engine/imap/transport/imap-client-connection.vala"
	g_signal_emit (self, geary_imap_client_connection_signals[GEARY_IMAP_CLIENT_CONNECTION_RECEIVE_FAILURE_SIGNAL], 0, _tmp3_);
#line 581 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_error_free0 (_tmp3_);
#line 581 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_free0 (_tmp1_);
#line 4033 "imap-client-connection.c"
}

static void
geary_imap_client_connection_on_receive_failure (GearyImapClientConnection* self,
                                                 GError* err)
{
#line 588 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self));
#line 588 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (err != NULL);
#line 589 "../src/engine/imap/transport/imap-client-connection.vala"
	g_signal_emit (self, geary_imap_client_connection_signals[GEARY_IMAP_CLIENT_CONNECTION_RECEIVE_FAILURE_SIGNAL], 0, err);
#line 4046 "imap-client-connection.c"
}

static void
geary_imap_client_connection_on_deserialize_failure (GearyImapClientConnection* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _tmp2_;
	GError* _tmp3_;
#line 592 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self));
#line 593 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 593 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp1_ = _tmp0_;
#line 593 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp2_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_PARSE_ERROR, "Unable to deserialize from %s", _tmp1_);
#line 593 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp3_ = _tmp2_;
#line 593 "../src/engine/imap/transport/imap-client-connection.vala"
	g_signal_emit (self, geary_imap_client_connection_signals[GEARY_IMAP_CLIENT_CONNECTION_RECEIVE_FAILURE_SIGNAL], 0, _tmp3_);
#line 593 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_error_free0 (_tmp3_);
#line 593 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_free0 (_tmp1_);
#line 4072 "imap-client-connection.c"
}

static void
geary_imap_client_connection_on_command_timeout (GearyImapClientConnection* self,
                                                 GearyImapCommand* command)
{
	GeeQueue* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GError* _tmp6_;
	GError* _tmp7_;
#line 600 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self));
#line 600 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (command));
#line 601 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = self->priv->sent_queue;
#line 601 "../src/engine/imap/transport/imap-client-connection.vala"
	gee_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), command);
#line 602 "../src/engine/imap/transport/imap-client-connection.vala"
	g_signal_parse_name ("response-timed-out", GEARY_IMAP_TYPE_COMMAND, &_tmp1_, NULL, FALSE);
#line 602 "../src/engine/imap/transport/imap-client-connection.vala"
	g_signal_handlers_disconnect_matched (command, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _geary_imap_client_connection_on_command_timeout_geary_imap_command_response_timed_out, self);
#line 603 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp2_ = geary_imap_command_get_response_timeout (command);
#line 603 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp3_ = _tmp2_;
#line 603 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp4_ = geary_imap_command_to_string (command);
#line 603 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp5_ = _tmp4_;
#line 603 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp6_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_TIMED_OUT, "No response to command after %u seconds: %s", _tmp3_, _tmp5_);
#line 603 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp7_ = _tmp6_;
#line 603 "../src/engine/imap/transport/imap-client-connection.vala"
	g_signal_emit (self, geary_imap_client_connection_signals[GEARY_IMAP_CLIENT_CONNECTION_RECEIVE_FAILURE_SIGNAL], 0, _tmp7_);
#line 603 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_error_free0 (_tmp7_);
#line 603 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_free0 (_tmp5_);
#line 4117 "imap-client-connection.c"
}

static void
geary_imap_client_connection_on_idle_timeout (GearyImapClientConnection* self)
{
	GError* _inner_error0_ = NULL;
#line 612 "../src/engine/imap/transport/imap-client-connection.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_CONNECTION (self));
#line 613 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Initiating IDLE");
#line 4128 "imap-client-connection.c"
	{
		GCancellable* _tmp0_;
		GearyImapIdleCommand* _tmp1_;
		GearyImapIdleCommand* _tmp2_;
#line 615 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp0_ = self->priv->open_cancellable;
#line 615 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp1_ = geary_imap_idle_command_new (_tmp0_);
#line 615 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp2_ = _tmp1_;
#line 615 "../src/engine/imap/transport/imap-client-connection.vala"
		geary_imap_client_connection_send_command (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEARY_IMAP_TYPE_COMMAND, GearyImapCommand), &_inner_error0_);
#line 615 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_object_unref0 (_tmp2_);
#line 615 "../src/engine/imap/transport/imap-client-connection.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4145 "imap-client-connection.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 614 "../src/engine/imap/transport/imap-client-connection.vala"
		err = _inner_error0_;
#line 614 "../src/engine/imap/transport/imap-client-connection.vala"
		_inner_error0_ = NULL;
#line 617 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp3_ = err;
#line 617 "../src/engine/imap/transport/imap-client-connection.vala"
		_tmp4_ = _tmp3_->message;
#line 617 "../src/engine/imap/transport/imap-client-connection.vala"
		geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Error sending IDLE: %s", _tmp4_);
#line 614 "../src/engine/imap/transport/imap-client-connection.vala"
		_g_error_free0 (err);
#line 4167 "imap-client-connection.c"
	}
	__finally0:
#line 614 "../src/engine/imap/transport/imap-client-connection.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 614 "../src/engine/imap/transport/imap-client-connection.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 614 "../src/engine/imap/transport/imap-client-connection.vala"
		g_clear_error (&_inner_error0_);
#line 614 "../src/engine/imap/transport/imap-client-connection.vala"
		return;
#line 4178 "imap-client-connection.c"
	}
}

static void
geary_imap_client_connection_class_init (GearyImapClientConnectionClass * klass,
                                         gpointer klass_data)
{
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_parent_class = g_type_class_peek_parent (klass);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_type_class_adjust_private_offset (klass, &GearyImapClientConnection_private_offset);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	((GearyImapClientConnectionClass *) klass)->sent_command = geary_imap_client_connection_real_sent_command;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	((GearyImapClientConnectionClass *) klass)->received_status_response = geary_imap_client_connection_real_received_status_response;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	((GearyImapClientConnectionClass *) klass)->received_server_data = geary_imap_client_connection_real_received_server_data;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	((GearyImapClientConnectionClass *) klass)->received_continuation_response = geary_imap_client_connection_real_received_continuation_response;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_imap_client_connection_get_property;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_imap_client_connection_set_property;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_imap_client_connection_finalize;
#line 4204 "imap-client-connection.c"
	/**
	     * Determines if the connection will use IMAP IDLE when idle.
	     *
	     * If //true//, when the connection is not sending commands
	     * ("quiet"), it will issue an IDLE command to enter a state where
	     * unsolicited server data may be sent from the server without
	     * resorting to NOOP keepalives.  (Note that keepalives are still
	     * required to hold the connection open, according to the IMAP
	     * specification.)
	     */
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_CLIENT_CONNECTION_IDLE_WHEN_QUIET_PROPERTY, geary_imap_client_connection_properties[GEARY_IMAP_CLIENT_CONNECTION_IDLE_WHEN_QUIET_PROPERTY] = g_param_spec_boolean ("idle-when-quiet", "idle-when-quiet", "idle-when-quiet", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4217 "imap-client-connection.c"
	/** {@inheritDoc} */
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_CLIENT_CONNECTION_LOGGING_PARENT_PROPERTY, geary_imap_client_connection_properties[GEARY_IMAP_CLIENT_CONNECTION_LOGGING_PARENT_PROPERTY] = g_param_spec_object ("logging-parent", "logging-parent", "logging-parent", GEARY_LOGGING_TYPE_SOURCE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_signals[GEARY_IMAP_CLIENT_CONNECTION_SENT_COMMAND_SIGNAL] = g_signal_new ("sent-command", GEARY_IMAP_TYPE_CLIENT_CONNECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (GearyImapClientConnectionClass, sent_command), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_IMAP_TYPE_COMMAND);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_signals[GEARY_IMAP_CLIENT_CONNECTION_RECEIVED_STATUS_RESPONSE_SIGNAL] = g_signal_new ("received-status-response", GEARY_IMAP_TYPE_CLIENT_CONNECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (GearyImapClientConnectionClass, received_status_response), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_IMAP_TYPE_STATUS_RESPONSE);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_signals[GEARY_IMAP_CLIENT_CONNECTION_RECEIVED_SERVER_DATA_SIGNAL] = g_signal_new ("received-server-data", GEARY_IMAP_TYPE_CLIENT_CONNECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (GearyImapClientConnectionClass, received_server_data), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_IMAP_TYPE_SERVER_DATA);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_signals[GEARY_IMAP_CLIENT_CONNECTION_RECEIVED_CONTINUATION_RESPONSE_SIGNAL] = g_signal_new ("received-continuation-response", GEARY_IMAP_TYPE_CLIENT_CONNECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (GearyImapClientConnectionClass, received_continuation_response), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_IMAP_TYPE_CONTINUATION_RESPONSE);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_signals[GEARY_IMAP_CLIENT_CONNECTION_RECEIVED_BYTES_SIGNAL] = g_signal_new ("received-bytes", GEARY_IMAP_TYPE_CLIENT_CONNECTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ULONG, G_TYPE_NONE, 1, G_TYPE_ULONG);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_signals[GEARY_IMAP_CLIENT_CONNECTION_RECEIVED_BAD_RESPONSE_SIGNAL] = g_signal_new ("received-bad-response", GEARY_IMAP_TYPE_CLIENT_CONNECTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_BOXED, G_TYPE_NONE, 2, GEARY_IMAP_TYPE_ROOT_PARAMETERS, G_TYPE_ERROR);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_signals[GEARY_IMAP_CLIENT_CONNECTION_SEND_FAILURE_SIGNAL] = g_signal_new ("send-failure", GEARY_IMAP_TYPE_CLIENT_CONNECTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOXED, G_TYPE_NONE, 1, G_TYPE_ERROR);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_signals[GEARY_IMAP_CLIENT_CONNECTION_RECEIVE_FAILURE_SIGNAL] = g_signal_new ("receive-failure", GEARY_IMAP_TYPE_CLIENT_CONNECTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOXED, G_TYPE_NONE, 1, G_TYPE_ERROR);
#line 4237 "imap-client-connection.c"
}

static void
geary_imap_client_connection_geary_logging_source_interface_init (GearyLoggingSourceIface * iface,
                                                                  gpointer iface_data)
{
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	geary_imap_client_connection_geary_logging_source_parent_iface = g_type_interface_peek_parent (iface);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	iface->to_logging_state = (GearyLoggingState* (*) (GearyLoggingSource*)) geary_imap_client_connection_real_to_logging_state;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	iface->get_logging_domain = geary_imap_client_connection_real_get_logging_domain;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	iface->get_logging_parent = geary_imap_client_connection_real_get_logging_parent;
#line 4252 "imap-client-connection.c"
}

static void
geary_imap_client_connection_instance_init (GearyImapClientConnection * self,
                                            gpointer klass)
{
	GearyNonblockingQueue* _tmp0_;
	GeeLinkedList* _tmp1_;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	self->priv = geary_imap_client_connection_get_instance_private (self);
#line 54 "../src/engine/imap/transport/imap-client-connection.vala"
	self->priv->_idle_when_quiet = FALSE;
#line 64 "../src/engine/imap/transport/imap-client-connection.vala"
	self->priv->_logging_parent = NULL;
#line 69 "../src/engine/imap/transport/imap-client-connection.vala"
	self->priv->cx = NULL;
#line 70 "../src/engine/imap/transport/imap-client-connection.vala"
	self->priv->deserializer = NULL;
#line 71 "../src/engine/imap/transport/imap-client-connection.vala"
	self->priv->serializer = NULL;
#line 73 "../src/engine/imap/transport/imap-client-connection.vala"
	self->priv->tag_counter = 0;
#line 74 "../src/engine/imap/transport/imap-client-connection.vala"
	self->priv->tag_prefix = 'a';
#line 76 "../src/engine/imap/transport/imap-client-connection.vala"
	self->priv->last_seen = (gint64) 0;
#line 78 "../src/engine/imap/transport/imap-client-connection.vala"
	self->priv->bytes_accumulator = (gsize) 0;
#line 80 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp0_ = geary_nonblocking_queue_new_fifo (GEARY_IMAP_TYPE_COMMAND, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 80 "../src/engine/imap/transport/imap-client-connection.vala"
	self->priv->pending_queue = _tmp0_;
#line 82 "../src/engine/imap/transport/imap-client-connection.vala"
	_tmp1_ = gee_linked_list_new (GEARY_IMAP_TYPE_COMMAND, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 82 "../src/engine/imap/transport/imap-client-connection.vala"
	self->priv->sent_queue = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_QUEUE, GeeQueue);
#line 83 "../src/engine/imap/transport/imap-client-connection.vala"
	self->priv->current_command = NULL;
#line 88 "../src/engine/imap/transport/imap-client-connection.vala"
	self->priv->open_cancellable = NULL;
#line 4293 "imap-client-connection.c"
}

static void
geary_imap_client_connection_finalize (GObject * obj)
{
	GearyImapClientConnection * self;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_IMAP_TYPE_CLIENT_CONNECTION, GearyImapClientConnection);
#line 66 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (self->priv->endpoint);
#line 68 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (self->priv->quirks);
#line 69 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (self->priv->cx);
#line 70 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (self->priv->deserializer);
#line 71 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (self->priv->serializer);
#line 80 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (self->priv->pending_queue);
#line 82 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (self->priv->sent_queue);
#line 83 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (self->priv->current_command);
#line 86 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (self->priv->idle_timer);
#line 88 "../src/engine/imap/transport/imap-client-connection.vala"
	_g_object_unref0 (self->priv->open_cancellable);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	G_OBJECT_CLASS (geary_imap_client_connection_parent_class)->finalize (obj);
#line 4324 "imap-client-connection.c"
}

 G_GNUC_NO_INLINE static GType
geary_imap_client_connection_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyImapClientConnectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_imap_client_connection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyImapClientConnection), 0, (GInstanceInitFunc) geary_imap_client_connection_instance_init, NULL };
	static const GInterfaceInfo geary_logging_source_info = { (GInterfaceInitFunc) geary_imap_client_connection_geary_logging_source_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType geary_imap_client_connection_type_id;
	geary_imap_client_connection_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyImapClientConnection", &g_define_type_info, 0);
	g_type_add_interface_static (geary_imap_client_connection_type_id, GEARY_LOGGING_TYPE_SOURCE, &geary_logging_source_info);
	GearyImapClientConnection_private_offset = g_type_add_instance_private (geary_imap_client_connection_type_id, sizeof (GearyImapClientConnectionPrivate));
	return geary_imap_client_connection_type_id;
}

GType
geary_imap_client_connection_get_type (void)
{
	static gsize geary_imap_client_connection_type_id__once = 0;
	if (g_once_init_enter (&geary_imap_client_connection_type_id__once)) {
		GType geary_imap_client_connection_type_id;
		geary_imap_client_connection_type_id = geary_imap_client_connection_get_type_once ();
		g_once_init_leave (&geary_imap_client_connection_type_id__once, geary_imap_client_connection_type_id);
	}
	return geary_imap_client_connection_type_id__once;
}

static void
_vala_geary_imap_client_connection_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	GearyImapClientConnection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_TYPE_CLIENT_CONNECTION, GearyImapClientConnection);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	switch (property_id) {
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
		case GEARY_IMAP_CLIENT_CONNECTION_IDLE_WHEN_QUIET_PROPERTY:
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
		g_value_set_boolean (value, geary_imap_client_connection_get_idle_when_quiet (self));
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
		break;
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
		case GEARY_IMAP_CLIENT_CONNECTION_LOGGING_PARENT_PROPERTY:
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
		g_value_set_object (value, geary_logging_source_get_logging_parent (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource)));
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
		break;
#line 4373 "imap-client-connection.c"
		default:
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
		break;
#line 4379 "imap-client-connection.c"
	}
}

static void
_vala_geary_imap_client_connection_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	GearyImapClientConnection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_TYPE_CLIENT_CONNECTION, GearyImapClientConnection);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
	switch (property_id) {
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
		case GEARY_IMAP_CLIENT_CONNECTION_IDLE_WHEN_QUIET_PROPERTY:
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
		geary_imap_client_connection_set_idle_when_quiet (self, g_value_get_boolean (value));
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
		break;
#line 4399 "imap-client-connection.c"
		default:
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 9 "../src/engine/imap/transport/imap-client-connection.vala"
		break;
#line 4405 "imap-client-connection.c"
	}
}

