/* imap-client-session.c generated by valac 0.56.17, the Vala compiler
 * generated from imap-client-session.vala, do not modify */

/*
 * Copyright © 2016 Software Freedom Conservancy Inc.
 * Copyright © 2019-2020 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_IMAP_CLIENT_SESSION_0_PROPERTY,
	GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_PROPERTY,
	GEARY_IMAP_CLIENT_SESSION_DISCONNECTED_PROPERTY,
	GEARY_IMAP_CLIENT_SESSION_CAPABILITIES_PROPERTY,
	GEARY_IMAP_CLIENT_SESSION_IS_IDLE_SUPPORTED_PROPERTY,
	GEARY_IMAP_CLIENT_SESSION_SERVER_GREETING_PROPERTY,
	GEARY_IMAP_CLIENT_SESSION_LOGGING_PARENT_PROPERTY,
	GEARY_IMAP_CLIENT_SESSION_LAST_SEEN_PROPERTY,
	GEARY_IMAP_CLIENT_SESSION_INBOX_PROPERTY,
	GEARY_IMAP_CLIENT_SESSION_QUIRKS_PROPERTY,
	GEARY_IMAP_CLIENT_SESSION_NUM_PROPERTIES
};
static GParamSpec* geary_imap_client_session_properties[GEARY_IMAP_CLIENT_SESSION_NUM_PROPERTIES];
typedef enum  {
	GEARY_IMAP_CLIENT_SESSION_STATE_NOT_CONNECTED,
	GEARY_IMAP_CLIENT_SESSION_STATE_NOAUTH,
	GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZED,
	GEARY_IMAP_CLIENT_SESSION_STATE_SELECTED,
	GEARY_IMAP_CLIENT_SESSION_STATE_LOGOUT,
	GEARY_IMAP_CLIENT_SESSION_STATE_CONNECTING,
	GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZING,
	GEARY_IMAP_CLIENT_SESSION_STATE_SELECTING,
	GEARY_IMAP_CLIENT_SESSION_STATE_CLOSING_MAILBOX,
	GEARY_IMAP_CLIENT_SESSION_STATE_CLOSED,
	GEARY_IMAP_CLIENT_SESSION_STATE_COUNT
} GearyImapClientSessionState;

#define GEARY_IMAP_CLIENT_SESSION_TYPE_STATE (geary_imap_client_session_state_get_type ())
typedef enum  {
	GEARY_IMAP_CLIENT_SESSION_EVENT_CONNECT,
	GEARY_IMAP_CLIENT_SESSION_EVENT_DISCONNECT,
	GEARY_IMAP_CLIENT_SESSION_EVENT_LOGIN,
	GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_CMD,
	GEARY_IMAP_CLIENT_SESSION_EVENT_SELECT,
	GEARY_IMAP_CLIENT_SESSION_EVENT_CLOSE_MAILBOX,
	GEARY_IMAP_CLIENT_SESSION_EVENT_LOGOUT,
	GEARY_IMAP_CLIENT_SESSION_EVENT_CONNECTED,
	GEARY_IMAP_CLIENT_SESSION_EVENT_DISCONNECTED,
	GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_STATUS,
	GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_COMPLETION,
	GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_ERROR,
	GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_ERROR,
	GEARY_IMAP_CLIENT_SESSION_EVENT_TIMEOUT,
	GEARY_IMAP_CLIENT_SESSION_EVENT_COUNT
} GearyImapClientSessionEvent;

#define GEARY_IMAP_CLIENT_SESSION_TYPE_EVENT (geary_imap_client_session_event_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define GEARY_IMAP_CLIENT_SESSION_TYPE_MACHINE_PARAMS (geary_imap_client_session_machine_params_get_type ())
#define GEARY_IMAP_CLIENT_SESSION_MACHINE_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_IMAP_CLIENT_SESSION_TYPE_MACHINE_PARAMS, GearyImapClientSessionMachineParams))
#define GEARY_IMAP_CLIENT_SESSION_MACHINE_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_IMAP_CLIENT_SESSION_TYPE_MACHINE_PARAMS, GearyImapClientSessionMachineParamsClass))
#define GEARY_IMAP_CLIENT_SESSION_IS_MACHINE_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_IMAP_CLIENT_SESSION_TYPE_MACHINE_PARAMS))
#define GEARY_IMAP_CLIENT_SESSION_IS_MACHINE_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_IMAP_CLIENT_SESSION_TYPE_MACHINE_PARAMS))
#define GEARY_IMAP_CLIENT_SESSION_MACHINE_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_IMAP_CLIENT_SESSION_TYPE_MACHINE_PARAMS, GearyImapClientSessionMachineParamsClass))

typedef struct _GearyImapClientSessionMachineParams GearyImapClientSessionMachineParams;
typedef struct _GearyImapClientSessionMachineParamsClass GearyImapClientSessionMachineParamsClass;
typedef struct _GearyImapClientSessionMachineParamsPrivate GearyImapClientSessionMachineParamsPrivate;
typedef struct _GearyImapClientSessionConnectAsyncData GearyImapClientSessionConnectAsyncData;
typedef struct _GearyImapClientSessionLoginAsyncData GearyImapClientSessionLoginAsyncData;
typedef struct _Block32Data Block32Data;
typedef struct _GearyImapClientSessionInitiateSessionAsyncData GearyImapClientSessionInitiateSessionAsyncData;
typedef struct _GearyImapClientSessionSendCommandAsyncData GearyImapClientSessionSendCommandAsyncData;

#define GEARY_IMAP_CLIENT_SESSION_TYPE_SEND_COMMAND_OPERATION (geary_imap_client_session_send_command_operation_get_type ())
#define GEARY_IMAP_CLIENT_SESSION_SEND_COMMAND_OPERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_IMAP_CLIENT_SESSION_TYPE_SEND_COMMAND_OPERATION, GearyImapClientSessionSendCommandOperation))
#define GEARY_IMAP_CLIENT_SESSION_SEND_COMMAND_OPERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_IMAP_CLIENT_SESSION_TYPE_SEND_COMMAND_OPERATION, GearyImapClientSessionSendCommandOperationClass))
#define GEARY_IMAP_CLIENT_SESSION_IS_SEND_COMMAND_OPERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_IMAP_CLIENT_SESSION_TYPE_SEND_COMMAND_OPERATION))
#define GEARY_IMAP_CLIENT_SESSION_IS_SEND_COMMAND_OPERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_IMAP_CLIENT_SESSION_TYPE_SEND_COMMAND_OPERATION))
#define GEARY_IMAP_CLIENT_SESSION_SEND_COMMAND_OPERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_IMAP_CLIENT_SESSION_TYPE_SEND_COMMAND_OPERATION, GearyImapClientSessionSendCommandOperationClass))

typedef struct _GearyImapClientSessionSendCommandOperation GearyImapClientSessionSendCommandOperation;
typedef struct _GearyImapClientSessionSendCommandOperationClass GearyImapClientSessionSendCommandOperationClass;
typedef struct _GearyImapClientSessionSendCommandOperationPrivate GearyImapClientSessionSendCommandOperationPrivate;
typedef struct _GearyImapClientSessionSendMultipleCommandsAsyncData GearyImapClientSessionSendMultipleCommandsAsyncData;
typedef struct _GearyImapClientSessionSelectAsyncData GearyImapClientSessionSelectAsyncData;
typedef struct _GearyImapClientSessionExamineAsyncData GearyImapClientSessionExamineAsyncData;
typedef struct _GearyImapClientSessionSelectExamineAsyncData GearyImapClientSessionSelectExamineAsyncData;
typedef struct _GearyImapClientSessionCloseMailboxAsyncData GearyImapClientSessionCloseMailboxAsyncData;
typedef struct _GearyImapClientSessionLogoutAsyncData GearyImapClientSessionLogoutAsyncData;
typedef struct _GearyImapClientSessionDisconnectAsyncData GearyImapClientSessionDisconnectAsyncData;
#define _geary_logging_state_unref0(var) ((var == NULL) ? NULL : (var = (geary_logging_state_unref (var), NULL)))
typedef struct _GearyImapClientSessionDoDisconnectData GearyImapClientSessionDoDisconnectData;
typedef struct _GearyImapClientSessionSubmitCommandData GearyImapClientSessionSubmitCommandData;
enum  {
	GEARY_IMAP_CLIENT_SESSION_MACHINE_PARAMS_0_PROPERTY,
	GEARY_IMAP_CLIENT_SESSION_MACHINE_PARAMS_NUM_PROPERTIES
};
static GParamSpec* geary_imap_client_session_machine_params_properties[GEARY_IMAP_CLIENT_SESSION_MACHINE_PARAMS_NUM_PROPERTIES];

#define GEARY_IMAP_CLIENT_SESSION_TYPE_COMMAND_CALLBACK (geary_imap_client_session_command_callback_get_type ())
#define GEARY_IMAP_CLIENT_SESSION_COMMAND_CALLBACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_IMAP_CLIENT_SESSION_TYPE_COMMAND_CALLBACK, GearyImapClientSessionCommandCallback))
#define GEARY_IMAP_CLIENT_SESSION_COMMAND_CALLBACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_IMAP_CLIENT_SESSION_TYPE_COMMAND_CALLBACK, GearyImapClientSessionCommandCallbackClass))
#define GEARY_IMAP_CLIENT_SESSION_IS_COMMAND_CALLBACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_IMAP_CLIENT_SESSION_TYPE_COMMAND_CALLBACK))
#define GEARY_IMAP_CLIENT_SESSION_IS_COMMAND_CALLBACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_IMAP_CLIENT_SESSION_TYPE_COMMAND_CALLBACK))
#define GEARY_IMAP_CLIENT_SESSION_COMMAND_CALLBACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_IMAP_CLIENT_SESSION_TYPE_COMMAND_CALLBACK, GearyImapClientSessionCommandCallbackClass))

typedef struct _GearyImapClientSessionCommandCallback GearyImapClientSessionCommandCallback;
typedef struct _GearyImapClientSessionCommandCallbackClass GearyImapClientSessionCommandCallbackClass;
typedef struct _GearyImapClientSessionCommandCallbackPrivate GearyImapClientSessionCommandCallbackPrivate;
typedef struct _GearyImapClientSessionParamSpecCommandCallback GearyImapClientSessionParamSpecCommandCallback;
enum  {
	GEARY_IMAP_CLIENT_SESSION_SEND_COMMAND_OPERATION_0_PROPERTY,
	GEARY_IMAP_CLIENT_SESSION_SEND_COMMAND_OPERATION_NUM_PROPERTIES
};
static GParamSpec* geary_imap_client_session_send_command_operation_properties[GEARY_IMAP_CLIENT_SESSION_SEND_COMMAND_OPERATION_NUM_PROPERTIES];
typedef struct _GearyImapClientSessionSendCommandOperationExecuteAsyncData GearyImapClientSessionSendCommandOperationExecuteAsyncData;
enum  {
	GEARY_IMAP_CLIENT_SESSION_STATUS_RESPONSE_RECEIVED_SIGNAL,
	GEARY_IMAP_CLIENT_SESSION_EXISTS_SIGNAL,
	GEARY_IMAP_CLIENT_SESSION_EXPUNGE_SIGNAL,
	GEARY_IMAP_CLIENT_SESSION_FETCH_SIGNAL,
	GEARY_IMAP_CLIENT_SESSION_FLAGS_SIGNAL,
	GEARY_IMAP_CLIENT_SESSION_LIST_SIGNAL,
	GEARY_IMAP_CLIENT_SESSION_RECENT_SIGNAL,
	GEARY_IMAP_CLIENT_SESSION_SEARCH_SIGNAL,
	GEARY_IMAP_CLIENT_SESSION_STATUS_SIGNAL,
	GEARY_IMAP_CLIENT_SESSION_NUM_SIGNALS
};
static guint geary_imap_client_session_signals[GEARY_IMAP_CLIENT_SESSION_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GearyImapClientSessionPrivate {
	GearyImapClientSessionDisconnectReason _disconnected;
	GearyImapCapabilities* _capabilities;
	GearyImapStatusResponse* _server_greeting;
	GearyLoggingSource* _logging_parent;
	gint64 _last_seen;
	GearyImapMailboxInformation* _inbox;
	GearyImapQuirks* _quirks;
	GeeList* personal_namespaces;
	GeeList* user_namespaces;
	GeeList* shared_namespaces;
	GearyEndpoint* imap_endpoint;
	GearyStateMachine* fsm;
	GearyImapClientConnection* cx;
	guint keepalive_id;
	guint selected_keepalive_secs;
	guint unselected_keepalive_secs;
	guint selected_with_idle_keepalive_secs;
	GearyImapCommand* state_change_cmd;
	GearyNonblockingSemaphore* connect_waiter;
	GError* connect_err;
	GeeMap* namespaces;
};

struct _GearyImapClientSessionMachineParams {
	GObject parent_instance;
	GearyImapCommand* cmd;
	GError* err;
	gboolean proceed;
	GearyImapClientSessionMachineParamsPrivate * priv;
};

struct _GearyImapClientSessionMachineParamsClass {
	GObjectClass parent_class;
};

struct _GearyImapClientSessionConnectAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientSession* self;
	guint greeting_timeout_sec;
	GCancellable* cancellable;
	GearyImapClientSessionMachineParams* params;
	GearyImapClientSessionMachineParams* _tmp0_;
	GearyStateMachine* _tmp1_;
	GearyImapClientSessionMachineParams* _tmp2_;
	GearyImapClientSessionMachineParams* _tmp3_;
	GError* _tmp4_;
	GearyImapClientSessionMachineParams* _tmp5_;
	GError* _tmp6_;
	GError* _tmp7_;
	GearyImapClientSessionMachineParams* _tmp8_;
	GearyImapClientConnection* _tmp9_;
	GearyNonblockingSemaphore* _tmp10_;
	GearyImapClientConnection* _tmp11_;
	GearyStateMachine* _tmp12_;
	GError* err;
	GearyStateMachine* _tmp13_;
	GError* _tmp14_;
	GError* _tmp15_;
	GError* _tmp16_;
	GearySchedulerScheduled* timeout;
	GearySchedulerScheduled* _tmp17_;
	GearyNonblockingSemaphore* _tmp18_;
	GError* _vala1_err;
	GError* _tmp19_;
	GError* _tmp20_;
	GearySchedulerScheduled* _tmp21_;
	GError* _tmp22_;
	GError* _vala2_err;
	GError* _tmp23_;
	const gchar* _tmp24_;
	GError* _tmp25_;
	GError* _tmp26_;
	GError* _inner_error0_;
};

struct _GearyImapClientSessionLoginAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientSession* self;
	GearyCredentials* credentials;
	GCancellable* cancellable;
	GearyImapStatusResponse* result;
	GearyImapCommand* cmd;
	GearyCredentialsMethod _tmp0_;
	GearyCredentialsMethod _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GearyImapLoginCommand* _tmp6_;
	GearyImapCapabilities* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GError* _tmp10_;
	GError* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	GearyImapAuthenticateCommand* _tmp16_;
	GearyCredentialsMethod _tmp17_;
	GearyCredentialsMethod _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	GError* _tmp23_;
	GError* _tmp24_;
	GearyImapClientSessionMachineParams* params;
	GearyImapCommand* _tmp25_;
	GearyImapClientSessionMachineParams* _tmp26_;
	GearyStateMachine* _tmp27_;
	GearyImapClientSessionMachineParams* _tmp28_;
	GearyImapClientSessionMachineParams* _tmp29_;
	GError* _tmp30_;
	GearyImapClientSessionMachineParams* _tmp31_;
	GError* _tmp32_;
	GError* _tmp33_;
	GearyImapClientSessionMachineParams* _tmp34_;
	GearyImapStatusResponse* response;
	GearyImapCommand* _tmp35_;
	GearyImapStatusResponse* _tmp36_;
	GearyImapStatusResponse* _tmp37_;
	GearyImapStatus _tmp38_;
	GearyImapStatus _tmp39_;
	GearyImapResponseCode* code;
	GearyImapStatusResponse* _tmp40_;
	GearyImapResponseCode* _tmp41_;
	GearyImapResponseCode* _tmp42_;
	GearyImapResponseCode* _tmp43_;
	GearyImapResponseCode* _tmp44_;
	GearyImapResponseCodeType* code_type;
	GearyImapResponseCode* _tmp45_;
	GearyImapResponseCodeType* _tmp46_;
	GearyImapResponseCodeType* _tmp47_;
	GearyImapResponseCodeType* _tmp48_;
	const gchar* _tmp49_;
	const gchar* _tmp50_;
	const gchar* _tmp51_;
	GQuark _tmp53_;
	GearyImapStatusResponse* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
	GError* _tmp57_;
	GError* _tmp58_;
	GearyImapStatusResponse* _tmp59_;
	gchar* _tmp60_;
	gchar* _tmp61_;
	GError* _tmp62_;
	GError* _tmp63_;
	GearyImapStatusResponse* _tmp64_;
	gchar* _tmp65_;
	gchar* _tmp66_;
	GError* _tmp67_;
	GError* _tmp68_;
	GearyImapCommand* _tmp69_;
	GearyImapStatusResponse* _tmp70_;
	GearyImapStatusResponse* _tmp71_;
	GearyImapStatusResponse* _tmp72_;
	GError* _inner_error0_;
};

struct _Block32Data {
	int _ref_count_;
	GearyImapClientSession* self;
	GeeArrayList* list_results;
	gpointer _async_data_;
};

struct _GearyImapClientSessionInitiateSessionAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientSession* self;
	GearyCredentials* credentials;
	GCancellable* cancellable;
	Block32Data* _data32_;
	GearyImapCapabilities* _tmp0_;
	GearyImapCapabilityCommand* _tmp1_;
	GearyImapCapabilityCommand* _tmp2_;
	GearyImapStatusResponse* _tmp3_;
	GearyImapStatusResponse* _tmp4_;
	gint last_capabilities;
	GearyImapCapabilities* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GearyEndpoint* _tmp8_;
	GearyTlsNegotiationMethod _tmp9_;
	GearyTlsNegotiationMethod _tmp10_;
	GearyImapCapabilities* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GError* _tmp14_;
	GError* _tmp15_;
	GearyImapStatusResponse* resp;
	GearyImapStarttlsCommand* _tmp16_;
	GearyImapStarttlsCommand* _tmp17_;
	GearyImapStatusResponse* _tmp18_;
	GearyImapStatusResponse* _tmp19_;
	GearyImapStatusResponse* _tmp20_;
	GearyImapStatus _tmp21_;
	GearyImapStatus _tmp22_;
	GearyImapClientConnection* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	GearyImapStatusResponse* _tmp26_;
	GearyImapStatus _tmp27_;
	GearyImapStatus _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	GError* _tmp31_;
	GError* _tmp32_;
	GearyImapCapabilities* _tmp33_;
	gint _tmp34_;
	gint _tmp35_;
	GearyImapCapabilityCommand* _tmp36_;
	GearyImapCapabilityCommand* _tmp37_;
	GearyImapStatusResponse* _tmp38_;
	GearyImapStatusResponse* _tmp39_;
	GearyImapCapabilities* _tmp40_;
	gint _tmp41_;
	gint _tmp42_;
	GearyImapStatusResponse* _tmp43_;
	GearyImapStatusResponse* _tmp44_;
	GearyImapCapabilities* _tmp45_;
	gint _tmp46_;
	gint _tmp47_;
	GearyImapCapabilityCommand* _tmp48_;
	GearyImapCapabilityCommand* _tmp49_;
	GearyImapStatusResponse* _tmp50_;
	GearyImapStatusResponse* _tmp51_;
	GeeArrayList* _tmp52_;
	gulong list_id;
	gulong _tmp53_;
	GearyImapStatusResponse* response;
	GearyImapMailboxSpecifier* _tmp54_;
	GearyImapMailboxSpecifier* _tmp55_;
	GearyImapListCommand* _tmp56_;
	GearyImapListCommand* _tmp57_;
	GearyImapStatusResponse* _tmp58_;
	GearyImapStatusResponse* _tmp59_;
	gboolean _tmp60_;
	GearyImapStatusResponse* _tmp61_;
	GearyImapStatus _tmp62_;
	GearyImapStatus _tmp63_;
	GeeArrayList* _tmp64_;
	gboolean _tmp65_;
	gboolean _tmp66_;
	GeeArrayList* _tmp67_;
	gpointer _tmp68_;
	GearyImapMailboxInformation* _tmp69_;
	GeeArrayList* _tmp70_;
	GearyImapMailboxInformation* _tmp71_;
	gchar* _tmp72_;
	gchar* _tmp73_;
	GError* _tmp74_;
	GearyImapCapabilities* _tmp75_;
	GearyImapStatusResponse* _tmp76_;
	GearyImapNamespaceCommand* _tmp77_;
	GearyImapNamespaceCommand* _tmp78_;
	GearyImapStatusResponse* _tmp79_;
	GearyImapStatusResponse* _tmp80_;
	GearyImapStatusResponse* _tmp81_;
	GearyImapStatusResponse* _tmp82_;
	GearyImapStatus _tmp83_;
	GearyImapStatus _tmp84_;
	GeeList* _tmp85_;
	gboolean _tmp86_;
	gboolean _tmp87_;
	GeeList* _tmp88_;
	gpointer _tmp89_;
	GearyImapNamespace* _tmp90_;
	gchar* _tmp91_;
	gchar* _tmp92_;
	gchar* prefix;
	gchar* _tmp93_;
	gchar* delim;
	GearyImapMailboxInformation* _tmp94_;
	const gchar* _tmp95_;
	const gchar* _tmp96_;
	gchar* _tmp97_;
	gboolean _tmp98_;
	GearyImapMailboxInformation* _tmp99_;
	GearyImapMailboxAttributes* _tmp100_;
	GearyImapMailboxAttributes* _tmp101_;
	GearyImapMailboxAttribute* _tmp102_;
	GearyImapMailboxAttribute* _tmp103_;
	GearyImapMailboxInformation* _tmp104_;
	const gchar* _tmp105_;
	const gchar* _tmp106_;
	GearyImapMailboxInformation* _tmp107_;
	GearyImapMailboxSpecifier* _tmp108_;
	GearyImapMailboxSpecifier* _tmp109_;
	const gchar* _tmp110_;
	const gchar* _tmp111_;
	gchar* _tmp112_;
	const gchar* _tmp113_;
	GearyImapStatusResponse* _tmp114_;
	const gchar* _tmp115_;
	GearyImapMailboxSpecifier* _tmp116_;
	GearyImapMailboxSpecifier* _tmp117_;
	GearyImapListCommand* _tmp118_;
	GearyImapListCommand* _tmp119_;
	GearyImapStatusResponse* _tmp120_;
	GearyImapStatusResponse* _tmp121_;
	GearyImapStatusResponse* _tmp122_;
	gboolean _tmp123_;
	GearyImapStatusResponse* _tmp124_;
	GearyImapStatus _tmp125_;
	GearyImapStatus _tmp126_;
	GeeArrayList* _tmp127_;
	gboolean _tmp128_;
	gboolean _tmp129_;
	GearyImapMailboxInformation* list;
	GeeArrayList* _tmp130_;
	gpointer _tmp131_;
	GearyImapMailboxInformation* _tmp132_;
	const gchar* _tmp133_;
	const gchar* _tmp134_;
	gchar* _tmp135_;
	GError* _tmp136_;
	GeeList* _tmp137_;
	const gchar* _tmp138_;
	const gchar* _tmp139_;
	GearyImapNamespace* _tmp140_;
	GearyImapNamespace* _tmp141_;
	GeeList* _tmp142_;
	gpointer _tmp143_;
	GearyImapNamespace* _tmp144_;
	gchar* _tmp145_;
	gchar* _tmp146_;
	GError* _inner_error1_;
	GError* _inner_error0_;
};

struct _GearyImapClientSessionSendCommandAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientSession* self;
	GearyImapCommand* cmd;
	GearyImapStatusResponse* result;
	GearyImapClientSessionMachineParams* params;
	GearyImapClientSessionMachineParams* _tmp0_;
	GearyStateMachine* _tmp1_;
	GearyImapClientSessionMachineParams* _tmp2_;
	GearyImapClientSessionMachineParams* _tmp3_;
	GError* _tmp4_;
	GearyImapClientSessionMachineParams* _tmp5_;
	GError* _tmp6_;
	GError* _tmp7_;
	GearyImapClientSessionMachineParams* _tmp8_;
	GearyImapStatusResponse* _tmp9_;
	GearyImapStatusResponse* _tmp10_;
	GearyImapStatusResponse* _tmp11_;
	GError* _inner_error0_;
};

struct _GearyImapClientSessionSendCommandOperation {
	GearyNonblockingBatchOperation parent_instance;
	GearyImapClientSession* owner;
	GearyImapCommand* cmd;
	GearyImapStatusResponse* response;
	GearyImapClientSessionSendCommandOperationPrivate * priv;
};

struct _GearyImapClientSessionSendCommandOperationClass {
	GearyNonblockingBatchOperationClass parent_class;
};

struct _GearyImapClientSessionSendMultipleCommandsAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientSession* self;
	GeeCollection* cmds;
	GCancellable* cancellable;
	GeeMap* result;
	gint _tmp0_;
	gint _tmp1_;
	GError* _tmp2_;
	GeeIterator* _cmd_it;
	GeeIterator* _tmp3_;
	GeeIterator* _tmp4_;
	GearyImapCommand* cmd;
	GeeIterator* _tmp5_;
	gpointer _tmp6_;
	GearyImapCommand* _tmp7_;
	GearyImapClientSessionMachineParams* params;
	gpointer _tmp8_;
	GearyImapCommand* _tmp9_;
	GearyImapClientSessionMachineParams* _tmp10_;
	GearyImapClientSessionMachineParams* _tmp11_;
	GearyStateMachine* _tmp12_;
	GearyImapClientSessionMachineParams* _tmp13_;
	GearyImapClientSessionMachineParams* _tmp14_;
	GError* _tmp15_;
	GearyImapClientSessionMachineParams* _tmp16_;
	GError* _tmp17_;
	GError* _tmp18_;
	GearyImapClientSessionMachineParams* _tmp19_;
	guint max_batch_size;
	GearyImapQuirks* _tmp20_;
	guint _tmp21_;
	guint _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	GeeIterator* cmd_remaining;
	GeeIterator* _tmp25_;
	GearyNonblockingBatch* batch;
	GeeMap* responses;
	GeeHashMap* _tmp26_;
	GeeIterator* _tmp27_;
	GearyNonblockingBatch* _tmp28_;
	gboolean _tmp29_;
	GeeIterator* _tmp30_;
	GearyNonblockingBatch* _tmp31_;
	gint _tmp32_;
	gint _tmp33_;
	GeeIterator* _tmp34_;
	GearyNonblockingBatch* _tmp35_;
	GeeIterator* _tmp36_;
	gpointer _tmp37_;
	GearyImapCommand* _tmp38_;
	GearyImapClientSessionSendCommandOperation* _tmp39_;
	GearyImapClientSessionSendCommandOperation* _tmp40_;
	GearyNonblockingBatch* _tmp41_;
	GearyNonblockingBatch* _tmp42_;
	GeeIterator* _id_it;
	GearyNonblockingBatch* _tmp43_;
	GeeSet* _tmp44_;
	GeeSet* _tmp45_;
	GeeIterator* _tmp46_;
	GeeIterator* _tmp47_;
	GeeIterator* _tmp48_;
	gint id;
	GeeIterator* _tmp49_;
	gpointer _tmp50_;
	GearyImapClientSessionSendCommandOperation* op;
	GearyNonblockingBatch* _tmp51_;
	GearyNonblockingBatchOperation* _tmp52_;
	GeeMap* _tmp53_;
	GearyImapClientSessionSendCommandOperation* _tmp54_;
	GearyImapCommand* _tmp55_;
	GearyImapClientSessionSendCommandOperation* _tmp56_;
	GearyImapStatusResponse* _tmp57_;
	GError* _inner_error0_;
};

struct _GearyImapClientSessionSelectAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientSession* self;
	GearyImapMailboxSpecifier* mailbox;
	GCancellable* cancellable;
	GearyImapStatusResponse* result;
	GearyImapStatusResponse* _tmp0_;
	GearyImapStatusResponse* _tmp1_;
	GearyImapStatusResponse* _tmp2_;
	GError* _inner_error0_;
};

struct _GearyImapClientSessionExamineAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientSession* self;
	GearyImapMailboxSpecifier* mailbox;
	GCancellable* cancellable;
	GearyImapStatusResponse* result;
	GearyImapStatusResponse* _tmp0_;
	GearyImapStatusResponse* _tmp1_;
	GearyImapStatusResponse* _tmp2_;
	GError* _inner_error0_;
};

struct _GearyImapClientSessionSelectExamineAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientSession* self;
	GearyImapMailboxSpecifier* mailbox;
	gboolean is_select;
	GCancellable* cancellable;
	GearyImapStatusResponse* result;
	GearyImapCommand* cmd;
	GearyImapSelectCommand* _tmp0_;
	GearyImapExamineCommand* _tmp1_;
	GearyImapClientSessionMachineParams* params;
	GearyImapCommand* _tmp2_;
	GearyImapClientSessionMachineParams* _tmp3_;
	GearyStateMachine* _tmp4_;
	GearyImapClientSessionMachineParams* _tmp5_;
	GearyImapClientSessionMachineParams* _tmp6_;
	GError* _tmp7_;
	GearyImapClientSessionMachineParams* _tmp8_;
	GError* _tmp9_;
	GError* _tmp10_;
	GearyImapClientSessionMachineParams* _tmp11_;
	GearyImapStatusResponse* _tmp12_;
	GearyImapCommand* _tmp13_;
	GearyImapStatusResponse* _tmp14_;
	GearyImapStatusResponse* _tmp15_;
	GError* _inner_error0_;
};

struct _GearyImapClientSessionCloseMailboxAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientSession* self;
	GCancellable* cancellable;
	GearyImapStatusResponse* result;
	GearyImapCloseCommand* cmd;
	GearyImapCloseCommand* _tmp0_;
	GearyImapClientSessionMachineParams* params;
	GearyImapCloseCommand* _tmp1_;
	GearyImapClientSessionMachineParams* _tmp2_;
	GearyStateMachine* _tmp3_;
	GearyImapClientSessionMachineParams* _tmp4_;
	GearyImapClientSessionMachineParams* _tmp5_;
	GError* _tmp6_;
	GearyImapClientSessionMachineParams* _tmp7_;
	GError* _tmp8_;
	GError* _tmp9_;
	GearyImapStatusResponse* _tmp10_;
	GearyImapCloseCommand* _tmp11_;
	GearyImapStatusResponse* _tmp12_;
	GearyImapStatusResponse* _tmp13_;
	GError* _inner_error0_;
};

struct _GearyImapClientSessionLogoutAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientSession* self;
	GCancellable* cancellable;
	GearyImapLogoutCommand* cmd;
	GearyImapLogoutCommand* _tmp0_;
	GearyImapClientSessionMachineParams* params;
	GearyImapClientSessionMachineParams* _tmp1_;
	GearyStateMachine* _tmp2_;
	GError* _tmp3_;
	GError* _tmp4_;
	GError* _tmp5_;
	GearyImapStatusResponse* _tmp6_;
	GearyImapStatusResponse* _tmp7_;
	GError* _inner_error0_;
};

struct _GearyImapClientSessionDisconnectAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientSession* self;
	GCancellable* cancellable;
	GearyImapClientSessionMachineParams* params;
	GearyImapClientSessionMachineParams* _tmp0_;
	GearyStateMachine* _tmp1_;
	GError* _tmp2_;
	GError* _tmp3_;
	GError* _tmp4_;
	GError* disconnect_err;
	GearyImapClientConnection* _tmp5_;
	GError* err;
	GError* _tmp6_;
	GError* _tmp7_;
	GError* _tmp8_;
	GError* _tmp9_;
	GError* _tmp10_;
	GError* _inner_error0_;
};

struct _GearyImapClientSessionDoDisconnectData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientSession* self;
	GearyImapClientSessionDisconnectReason reason;
	GearyImapClientConnection* _tmp0_;
	GError* err;
	GError* _tmp1_;
	const gchar* _tmp2_;
	GError* _inner_error0_;
};

struct _GearyImapClientSessionSubmitCommandData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientSession* self;
	GearyImapCommand* cmd;
	GearyImapStatusResponse* result;
	GearyImapClientConnection* _tmp0_;
	GearyEndpoint* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GError* _tmp4_;
	GError* _tmp5_;
	GearyImapClientConnection* _tmp6_;
	GearyImapStatusResponse* _tmp7_;
	GearyImapStatusResponse* _tmp8_;
	GearyImapStatusResponse* _tmp9_;
	GError* _inner_error0_;
};

struct _GearyImapClientSessionCommandCallback {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GSourceFunc callback;
	gpointer callback_target;
	GearyImapClientSessionCommandCallbackPrivate * priv;
};

struct _GearyImapClientSessionCommandCallbackClass {
	GTypeClass parent_class;
	void (*finalize) (GearyImapClientSessionCommandCallback *self);
};

struct _GearyImapClientSessionParamSpecCommandCallback {
	GParamSpec parent_instance;
};

struct _GearyImapClientSessionSendCommandOperationExecuteAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapClientSessionSendCommandOperation* self;
	GCancellable* cancellable;
	GObject* result;
	GearyImapStatusResponse* _tmp0_;
	GearyImapClientSession* _tmp1_;
	GearyImapCommand* _tmp2_;
	GearyImapStatusResponse* _tmp3_;
	GearyImapStatusResponse* _tmp4_;
	GearyImapStatusResponse* _tmp5_;
	GObject* _tmp6_;
	GError* _inner_error0_;
};

static gint GearyImapClientSession_private_offset;
static gpointer geary_imap_client_session_parent_class = NULL;
static GearyStateMachineDescriptor* geary_imap_client_session_machine_desc;
static GearyStateMachineDescriptor* geary_imap_client_session_machine_desc = NULL;
static gpointer geary_imap_client_session_machine_params_parent_class = NULL;
static gpointer geary_imap_client_session_command_callback_parent_class = NULL;
static gpointer geary_imap_client_session_send_command_operation_parent_class = NULL;
static GearyLoggingSourceIface * geary_imap_client_session_geary_logging_source_parent_iface = NULL;

static GType geary_imap_client_session_state_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GType geary_imap_client_session_event_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static gchar* geary_imap_client_session_state_to_string (guint state);
static gchar* geary_imap_client_session_event_to_string (guint event);
static gchar* _geary_imap_client_session_state_to_string_geary_state_state_event_to_string (guint state_or_event,
                                                                                     gpointer self);
static gchar* _geary_imap_client_session_event_to_string_geary_state_state_event_to_string (guint state_or_event,
                                                                                     gpointer self);
static void geary_imap_client_session_set_disconnected (GearyImapClientSession* self,
                                                 GearyImapClientSessionDisconnectReason value);
static void geary_imap_client_session_set_capabilities (GearyImapClientSession* self,
                                                 GearyImapCapabilities* value);
static void geary_imap_client_session_set_server_greeting (GearyImapClientSession* self,
                                                    GearyImapStatusResponse* value);
VALA_EXTERN gint64 geary_imap_client_session_get_last_seen (GearyImapClientSession* self);
static void geary_imap_client_session_set_last_seen (GearyImapClientSession* self,
                                              gint64 value);
VALA_EXTERN GearyImapMailboxInformation* geary_imap_client_session_get_inbox (GearyImapClientSession* self);
static void geary_imap_client_session_set_inbox (GearyImapClientSession* self,
                                          GearyImapMailboxInformation* value);
VALA_EXTERN GearyImapQuirks* geary_imap_client_session_get_quirks (GearyImapClientSession* self);
VALA_EXTERN void geary_imap_client_session_set_quirks (GearyImapClientSession* self,
                                           GearyImapQuirks* value);
static void g_cclosure_user_marshal_VOID__POINTER_INT (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static guint geary_imap_client_session_on_connect (GearyImapClientSession* self,
                                            guint state,
                                            guint event,
                                            void* user,
                                            GObject* object);
static guint _geary_imap_client_session_on_connect_geary_state_transition (guint state,
                                                                    guint event,
                                                                    void* user,
                                                                    GObject* object,
                                                                    GError* err,
                                                                    gpointer self);
static guint geary_imap_client_session_on_early_command (GearyImapClientSession* self,
                                                  guint state,
                                                  guint event,
                                                  void* user,
                                                  GObject* object);
static guint _geary_imap_client_session_on_early_command_geary_state_transition (guint state,
                                                                          guint event,
                                                                          void* user,
                                                                          GObject* object,
                                                                          GError* err,
                                                                          gpointer self);
static guint _geary_state_nop_geary_state_transition (guint state,
                                               guint event,
                                               void* user,
                                               GObject* object,
                                               GError* err,
                                               gpointer self);
static guint geary_imap_client_session_on_already_connected (GearyImapClientSession* self,
                                                      guint state,
                                                      guint event,
                                                      void* user,
                                                      GObject* object);
static guint _geary_imap_client_session_on_already_connected_geary_state_transition (guint state,
                                                                              guint event,
                                                                              void* user,
                                                                              GObject* object,
                                                                              GError* err,
                                                                              gpointer self);
static guint geary_imap_client_session_on_disconnect (GearyImapClientSession* self,
                                               guint state,
                                               guint event,
                                               void* user,
                                               GObject* object,
                                               GError* err);
static guint _geary_imap_client_session_on_disconnect_geary_state_transition (guint state,
                                                                       guint event,
                                                                       void* user,
                                                                       GObject* object,
                                                                       GError* err,
                                                                       gpointer self);
static guint geary_imap_client_session_on_connected (GearyImapClientSession* self,
                                              guint state,
                                              guint event);
static guint _geary_imap_client_session_on_connected_geary_state_transition (guint state,
                                                                      guint event,
                                                                      void* user,
                                                                      GObject* object,
                                                                      GError* err,
                                                                      gpointer self);
static guint geary_imap_client_session_on_connecting_recv_status (GearyImapClientSession* self,
                                                           guint state,
                                                           guint event,
                                                           void* user,
                                                           GObject* object);
static guint _geary_imap_client_session_on_connecting_recv_status_geary_state_transition (guint state,
                                                                                   guint event,
                                                                                   void* user,
                                                                                   GObject* object,
                                                                                   GError* err,
                                                                                   gpointer self);
static guint geary_imap_client_session_on_dropped_response (GearyImapClientSession* self,
                                                     guint state,
                                                     guint event,
                                                     void* user,
                                                     GObject* object);
static guint _geary_imap_client_session_on_dropped_response_geary_state_transition (guint state,
                                                                             guint event,
                                                                             void* user,
                                                                             GObject* object,
                                                                             GError* err,
                                                                             gpointer self);
static guint geary_imap_client_session_on_connecting_send_recv_error (GearyImapClientSession* self,
                                                               guint state,
                                                               guint event,
                                                               void* user,
                                                               GObject* object,
                                                               GError* err);
static guint _geary_imap_client_session_on_connecting_send_recv_error_geary_state_transition (guint state,
                                                                                       guint event,
                                                                                       void* user,
                                                                                       GObject* object,
                                                                                       GError* err,
                                                                                       gpointer self);
static guint geary_imap_client_session_on_connecting_timeout (GearyImapClientSession* self,
                                                       guint state,
                                                       guint event);
static guint _geary_imap_client_session_on_connecting_timeout_geary_state_transition (guint state,
                                                                               guint event,
                                                                               void* user,
                                                                               GObject* object,
                                                                               GError* err,
                                                                               gpointer self);
static guint geary_imap_client_session_on_login (GearyImapClientSession* self,
                                          guint state,
                                          guint event,
                                          void* user,
                                          GObject* object);
static guint _geary_imap_client_session_on_login_geary_state_transition (guint state,
                                                                  guint event,
                                                                  void* user,
                                                                  GObject* object,
                                                                  GError* err,
                                                                  gpointer self);
static guint geary_imap_client_session_on_send_command (GearyImapClientSession* self,
                                                 guint state,
                                                 guint event,
                                                 void* user,
                                                 GObject* object);
static guint _geary_imap_client_session_on_send_command_geary_state_transition (guint state,
                                                                         guint event,
                                                                         void* user,
                                                                         GObject* object,
                                                                         GError* err,
                                                                         gpointer self);
static guint geary_imap_client_session_on_unauthenticated (GearyImapClientSession* self,
                                                    guint state,
                                                    guint event,
                                                    void* user,
                                                    GObject* object);
static guint _geary_imap_client_session_on_unauthenticated_geary_state_transition (guint state,
                                                                            guint event,
                                                                            void* user,
                                                                            GObject* object,
                                                                            GError* err,
                                                                            gpointer self);
static guint geary_imap_client_session_on_logout (GearyImapClientSession* self,
                                           guint state,
                                           guint event,
                                           void* user,
                                           GObject* object);
static guint _geary_imap_client_session_on_logout_geary_state_transition (guint state,
                                                                   guint event,
                                                                   void* user,
                                                                   GObject* object,
                                                                   GError* err,
                                                                   gpointer self);
static guint geary_imap_client_session_on_recv_status (GearyImapClientSession* self,
                                                guint state,
                                                guint event,
                                                void* user,
                                                GObject* object);
static guint _geary_imap_client_session_on_recv_status_geary_state_transition (guint state,
                                                                        guint event,
                                                                        void* user,
                                                                        GObject* object,
                                                                        GError* err,
                                                                        gpointer self);
static guint geary_imap_client_session_on_send_error (GearyImapClientSession* self,
                                               guint state,
                                               guint event,
                                               void* user,
                                               GObject* object,
                                               GError* err);
static guint _geary_imap_client_session_on_send_error_geary_state_transition (guint state,
                                                                       guint event,
                                                                       void* user,
                                                                       GObject* object,
                                                                       GError* err,
                                                                       gpointer self);
static guint geary_imap_client_session_on_recv_error (GearyImapClientSession* self,
                                               guint state,
                                               guint event,
                                               void* user,
                                               GObject* object,
                                               GError* err);
static guint _geary_imap_client_session_on_recv_error_geary_state_transition (guint state,
                                                                       guint event,
                                                                       void* user,
                                                                       GObject* object,
                                                                       GError* err,
                                                                       gpointer self);
static guint geary_imap_client_session_on_logging_in (GearyImapClientSession* self,
                                               guint state,
                                               guint event,
                                               void* user,
                                               GObject* object);
static guint _geary_imap_client_session_on_logging_in_geary_state_transition (guint state,
                                                                       guint event,
                                                                       void* user,
                                                                       GObject* object,
                                                                       GError* err,
                                                                       gpointer self);
static guint geary_imap_client_session_on_login_recv_completion (GearyImapClientSession* self,
                                                          guint state,
                                                          guint event,
                                                          void* user,
                                                          GObject* object);
static guint _geary_imap_client_session_on_login_recv_completion_geary_state_transition (guint state,
                                                                                  guint event,
                                                                                  void* user,
                                                                                  GObject* object,
                                                                                  GError* err,
                                                                                  gpointer self);
static guint geary_imap_client_session_on_already_logged_in (GearyImapClientSession* self,
                                                      guint state,
                                                      guint event,
                                                      void* user,
                                                      GObject* object);
static guint _geary_imap_client_session_on_already_logged_in_geary_state_transition (guint state,
                                                                              guint event,
                                                                              void* user,
                                                                              GObject* object,
                                                                              GError* err,
                                                                              gpointer self);
static guint geary_imap_client_session_on_select (GearyImapClientSession* self,
                                           guint state,
                                           guint event,
                                           void* user,
                                           GObject* object);
static guint _geary_imap_client_session_on_select_geary_state_transition (guint state,
                                                                   guint event,
                                                                   void* user,
                                                                   GObject* object,
                                                                   GError* err,
                                                                   gpointer self);
static guint geary_imap_client_session_on_not_selected (GearyImapClientSession* self,
                                                 guint state,
                                                 guint event,
                                                 void* user,
                                                 GObject* object);
static guint _geary_imap_client_session_on_not_selected_geary_state_transition (guint state,
                                                                         guint event,
                                                                         void* user,
                                                                         GObject* object,
                                                                         GError* err,
                                                                         gpointer self);
static guint geary_imap_client_session_on_close_mailbox (GearyImapClientSession* self,
                                                  guint state,
                                                  guint event,
                                                  void* user,
                                                  GObject* object);
static guint _geary_imap_client_session_on_close_mailbox_geary_state_transition (guint state,
                                                                          guint event,
                                                                          void* user,
                                                                          GObject* object,
                                                                          GError* err,
                                                                          gpointer self);
static guint geary_imap_client_session_on_selecting_recv_completion (GearyImapClientSession* self,
                                                              guint state,
                                                              guint event,
                                                              void* user,
                                                              GObject* object);
static guint _geary_imap_client_session_on_selecting_recv_completion_geary_state_transition (guint state,
                                                                                      guint event,
                                                                                      void* user,
                                                                                      GObject* object,
                                                                                      GError* err,
                                                                                      gpointer self);
static guint geary_imap_client_session_on_closing_recv_completion (GearyImapClientSession* self,
                                                            guint state,
                                                            guint event,
                                                            void* user,
                                                            GObject* object);
static guint _geary_imap_client_session_on_closing_recv_completion_geary_state_transition (guint state,
                                                                                    guint event,
                                                                                    void* user,
                                                                                    GObject* object,
                                                                                    GError* err,
                                                                                    gpointer self);
static guint geary_imap_client_session_on_late_command (GearyImapClientSession* self,
                                                 guint state,
                                                 guint event,
                                                 void* user,
                                                 GObject* object);
static guint _geary_imap_client_session_on_late_command_geary_state_transition (guint state,
                                                                         guint event,
                                                                         void* user,
                                                                         GObject* object,
                                                                         GError* err,
                                                                         gpointer self);
static guint geary_imap_client_session_on_logging_out_recv_status (GearyImapClientSession* self,
                                                            guint state,
                                                            guint event,
                                                            void* user,
                                                            GObject* object);
static guint _geary_imap_client_session_on_logging_out_recv_status_geary_state_transition (guint state,
                                                                                    guint event,
                                                                                    void* user,
                                                                                    GObject* object,
                                                                                    GError* err,
                                                                                    gpointer self);
static guint geary_imap_client_session_on_logging_out_recv_completion (GearyImapClientSession* self,
                                                                guint state,
                                                                guint event,
                                                                void* user,
                                                                GObject* object);
static guint _geary_imap_client_session_on_logging_out_recv_completion_geary_state_transition (guint state,
                                                                                        guint event,
                                                                                        void* user,
                                                                                        GObject* object,
                                                                                        GError* err,
                                                                                        gpointer self);
static guint geary_imap_client_session_on_ignored_transition (GearyImapClientSession* self,
                                                       guint state,
                                                       guint event);
static guint _geary_imap_client_session_on_ignored_transition_geary_state_transition (guint state,
                                                                               guint event,
                                                                               void* user,
                                                                               GObject* object,
                                                                               GError* err,
                                                                               gpointer self);
static void __lambda49_ (GearyImapClientSession* self);
static void ___lambda49__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static GType geary_imap_client_session_machine_params_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static gboolean geary_imap_client_session_reserve_state_change_cmd (GearyImapClientSession* self,
                                                             GearyImapClientSessionMachineParams* params,
                                                             guint state,
                                                             guint event);
static gboolean geary_imap_client_session_validate_state_change_cmd (GearyImapClientSession* self,
                                                              GearyImapServerResponse* response,
                                                              GearyImapCommand** cmd);
static void geary_imap_client_session_connect_async_data_free (gpointer _data);
static gboolean geary_imap_client_session_connect_async_co (GearyImapClientSessionConnectAsyncData* _data_);
static GearyImapClientSessionMachineParams* geary_imap_client_session_machine_params_new (GearyImapCommand* cmd);
static GearyImapClientSessionMachineParams* geary_imap_client_session_machine_params_construct (GType object_type,
                                                                                         GearyImapCommand* cmd);
static void geary_imap_client_session_connect_async_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_);
static gboolean geary_imap_client_session_on_greeting_timeout (GearyImapClientSession* self);
static gboolean _geary_imap_client_session_on_greeting_timeout_gsource_func (gpointer self);
VALA_EXTERN void geary_imap_client_connection_set_logging_parent (GearyImapClientConnection* self,
                                                      GearyLoggingSource* parent);
static void geary_imap_client_session_on_network_send_error (GearyImapClientSession* self,
                                                      GError* err);
static void _geary_imap_client_session_on_network_send_error_geary_imap_client_connection_send_failure (GearyImapClientConnection* _sender,
                                                                                                 GError* err,
                                                                                                 gpointer self);
static void geary_imap_client_session_on_received_status_response (GearyImapClientSession* self,
                                                            GearyImapStatusResponse* status_response);
static void _geary_imap_client_session_on_received_status_response_geary_imap_client_connection_received_status_response (GearyImapClientConnection* _sender,
                                                                                                                   GearyImapStatusResponse* status_response,
                                                                                                                   gpointer self);
static void geary_imap_client_session_on_received_server_data (GearyImapClientSession* self,
                                                        GearyImapServerData* server_data);
static void _geary_imap_client_session_on_received_server_data_geary_imap_client_connection_received_server_data (GearyImapClientConnection* _sender,
                                                                                                           GearyImapServerData* server_data,
                                                                                                           gpointer self);
static void geary_imap_client_session_on_received_bytes (GearyImapClientSession* self);
static void _geary_imap_client_session_on_received_bytes_geary_imap_client_connection_received_bytes (GearyImapClientConnection* _sender,
                                                                                               gsize bytes,
                                                                                               gpointer self);
static void geary_imap_client_session_on_received_bad_response (GearyImapClientSession* self,
                                                         GearyImapRootParameters* root,
                                                         GError* err);
static void _geary_imap_client_session_on_received_bad_response_geary_imap_client_connection_received_bad_response (GearyImapClientConnection* _sender,
                                                                                                             GearyImapRootParameters* root,
                                                                                                             GError* err,
                                                                                                             gpointer self);
static void geary_imap_client_session_on_network_receive_failure (GearyImapClientSession* self,
                                                           GError* err);
static void _geary_imap_client_session_on_network_receive_failure_geary_imap_client_connection_receive_failure (GearyImapClientConnection* _sender,
                                                                                                         GError* err,
                                                                                                         gpointer self);
static void geary_imap_client_session_drop_connection (GearyImapClientSession* self);
static gboolean geary_imap_client_session_unschedule_keepalive (GearyImapClientSession* self);
static void geary_imap_client_session_login_async_data_free (gpointer _data);
static gboolean geary_imap_client_session_login_async_co (GearyImapClientSessionLoginAsyncData* _data_);
static void geary_imap_client_session_submit_command (GearyImapClientSession* self,
                                               GearyImapCommand* cmd,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
static GearyImapStatusResponse* geary_imap_client_session_submit_command_finish (GearyImapClientSession* self,
                                                                          GAsyncResult* _res_,
                                                                          GError** error);
static void geary_imap_client_session_login_async_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
static void geary_imap_client_session_initiate_session_async_data_free (gpointer _data);
static gboolean geary_imap_client_session_initiate_session_async_co (GearyImapClientSessionInitiateSessionAsyncData* _data_);
static Block32Data* block32_data_ref (Block32Data* _data32_);
static void block32_data_unref (void * _userdata_);
static void geary_imap_client_session_initiate_session_async_ready (GObject* source_object,
                                                             GAsyncResult* _res_,
                                                             gpointer _user_data_);
static void __lambda50_ (Block32Data* _data32_,
                  GearyImapMailboxInformation* mailbox);
static void ___lambda50__geary_imap_client_session_list (GearyImapClientSession* _sender,
                                                  GearyImapMailboxInformation* mailbox_info,
                                                  gpointer self);
static void geary_imap_client_session_schedule_keepalive (GearyImapClientSession* self);
static gboolean geary_imap_client_session_on_keepalive (GearyImapClientSession* self);
static gboolean _geary_imap_client_session_on_keepalive_gsource_func (gpointer self);
static void geary_imap_client_session_on_keepalive_completed (GearyImapClientSession* self,
                                                       GObject* source,
                                                       GAsyncResult* _result_);
static void _geary_imap_client_session_on_keepalive_completed_gasync_ready_callback (GObject* source_object,
                                                                              GAsyncResult* res,
                                                                              gpointer self);
static void geary_imap_client_session_send_command_async_data_free (gpointer _data);
static gboolean geary_imap_client_session_send_command_async_co (GearyImapClientSessionSendCommandAsyncData* _data_);
static void geary_imap_client_session_check_unsupported_send_command (GearyImapClientSession* self,
                                                               GearyImapCommand* cmd,
                                                               GError** error);
static void geary_imap_client_session_send_command_async_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_);
static void geary_imap_client_session_send_multiple_commands_async_data_free (gpointer _data);
static gboolean geary_imap_client_session_send_multiple_commands_async_co (GearyImapClientSessionSendMultipleCommandsAsyncData* _data_);
static GearyImapClientSessionSendCommandOperation* geary_imap_client_session_send_command_operation_new (GearyImapClientSession* owner,
                                                                                                  GearyImapCommand* cmd);
static GearyImapClientSessionSendCommandOperation* geary_imap_client_session_send_command_operation_construct (GType object_type,
                                                                                                        GearyImapClientSession* owner,
                                                                                                        GearyImapCommand* cmd);
static GType geary_imap_client_session_send_command_operation_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void geary_imap_client_session_send_multiple_commands_async_ready (GObject* source_object,
                                                                   GAsyncResult* _res_,
                                                                   gpointer _user_data_);
static void geary_imap_client_session_do_disconnect (GearyImapClientSession* self,
                                              GearyImapClientSessionDisconnectReason reason,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
static void geary_imap_client_session_do_disconnect_finish (GearyImapClientSession* self,
                                                     GAsyncResult* _res_);
static void geary_imap_client_session_select_async_data_free (gpointer _data);
static gboolean geary_imap_client_session_select_async_co (GearyImapClientSessionSelectAsyncData* _data_);
static void geary_imap_client_session_select_async_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_);
static void geary_imap_client_session_examine_async_data_free (gpointer _data);
static gboolean geary_imap_client_session_examine_async_co (GearyImapClientSessionExamineAsyncData* _data_);
static void geary_imap_client_session_examine_async_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_);
static void geary_imap_client_session_select_examine_async_data_free (gpointer _data);
static gboolean geary_imap_client_session_select_examine_async_co (GearyImapClientSessionSelectExamineAsyncData* _data_);
static void geary_imap_client_session_select_examine_async_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_);
static void geary_imap_client_session_close_mailbox_async_data_free (gpointer _data);
static gboolean geary_imap_client_session_close_mailbox_async_co (GearyImapClientSessionCloseMailboxAsyncData* _data_);
static void geary_imap_client_session_close_mailbox_async_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_);
static void geary_imap_client_session_logout_async_data_free (gpointer _data);
static gboolean geary_imap_client_session_logout_async_co (GearyImapClientSessionLogoutAsyncData* _data_);
static void geary_imap_client_session_logout_async_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_);
static void geary_imap_client_session_clear_namespaces (GearyImapClientSession* self);
static void geary_imap_client_session_disconnect_async_data_free (gpointer _data);
static gboolean geary_imap_client_session_disconnect_async_co (GearyImapClientSessionDisconnectAsyncData* _data_);
static void geary_imap_client_session_disconnect_async_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_);
static gchar* geary_imap_client_session_real_to_string (GearyLoggingSource* base);
static GearyLoggingState* geary_imap_client_session_real_to_logging_state (GearyLoggingSource* base);
VALA_EXTERN void geary_imap_client_session_set_logging_parent (GearyImapClientSession* self,
                                                   GearyLoggingSource* parent);
static void geary_imap_client_session_do_disconnect_data_free (gpointer _data);
static gboolean geary_imap_client_session_do_disconnect_co (GearyImapClientSessionDoDisconnectData* _data_);
static void geary_imap_client_session_do_disconnect_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_);
static void __lambda48_ (GearyImapClientSession* self);
static void ___lambda48__geary_state_post_transition (void* user,
                                               GObject* object,
                                               GError* err,
                                               gpointer self);
static void geary_imap_client_session_submit_command_data_free (gpointer _data);
static gboolean geary_imap_client_session_submit_command_co (GearyImapClientSessionSubmitCommandData* _data_);
static void geary_imap_client_session_submit_command_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_);
VALA_EXTERN GearyImapCommand* geary_imap_client_connection_get_sent_command (GearyImapClientConnection* self,
                                                                 GearyImapTag* tag);
static void geary_imap_client_session_notify_received_data (GearyImapClientSession* self,
                                                     GearyImapServerData* server_data,
                                                     GError** error);
static void geary_imap_client_session_update_namespaces (GearyImapClientSession* self,
                                                  GeeList* response,
                                                  GeeList* list);
static void geary_imap_client_session_machine_params_finalize (GObject * obj);
static GType geary_imap_client_session_machine_params_get_type_once (void);
static gpointer geary_imap_client_session_command_callback_ref (gpointer instance);
static void geary_imap_client_session_command_callback_unref (gpointer instance);
static GParamSpec* geary_imap_client_session_param_spec_command_callback (const gchar* name,
                                                                   const gchar* nick,
                                                                   const gchar* blurb,
                                                                   GType object_type,
                                                                   GParamFlags flags) G_GNUC_UNUSED ;
static void geary_imap_client_session_value_set_command_callback (GValue* value,
                                                           gpointer v_object) G_GNUC_UNUSED ;
static void geary_imap_client_session_value_take_command_callback (GValue* value,
                                                            gpointer v_object) G_GNUC_UNUSED ;
static gpointer geary_imap_client_session_value_get_command_callback (const GValue* value) G_GNUC_UNUSED ;
static GType geary_imap_client_session_command_callback_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GearyImapClientSessionCommandCallback* geary_imap_client_session_command_callback_new (GSourceFunc callback,
                                                                                       gpointer callback_target);
static GearyImapClientSessionCommandCallback* geary_imap_client_session_command_callback_construct (GType object_type,
                                                                                             GSourceFunc callback,
                                                                                             gpointer callback_target);
static void geary_imap_client_session_command_callback_finalize (GearyImapClientSessionCommandCallback * obj);
static GType geary_imap_client_session_command_callback_get_type_once (void);
static void geary_imap_client_session_send_command_operation_real_execute_async_data_free (gpointer _data);
static void geary_imap_client_session_send_command_operation_real_execute_async (GearyNonblockingBatchOperation* base,
                                                                          GCancellable* cancellable,
                                                                          GAsyncReadyCallback _callback_,
                                                                          gpointer _user_data_);
static gboolean geary_imap_client_session_send_command_operation_real_execute_async_co (GearyImapClientSessionSendCommandOperationExecuteAsyncData* _data_);
static void geary_imap_client_session_send_command_operation_execute_async_ready (GObject* source_object,
                                                                           GAsyncResult* _res_,
                                                                           gpointer _user_data_);
static void geary_imap_client_session_send_command_operation_finalize (GObject * obj);
static GType geary_imap_client_session_send_command_operation_get_type_once (void);
static void geary_imap_client_session_finalize (GObject * obj);
static GType geary_imap_client_session_get_type_once (void);
static void _vala_geary_imap_client_session_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_geary_imap_client_session_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
geary_imap_client_session_get_instance_private (GearyImapClientSession* self)
{
	return G_STRUCT_MEMBER_P (self, GearyImapClientSession_private_offset);
}

/**
     * The various states an IMAP {@link ClientSession} may be in at any moment.
     *
     * These don't exactly match the states in the IMAP specification.  For one, they count
     * transitions as states unto themselves (due to network latency and the asynchronous nature
     * of ClientSession's interface).  Also, the LOGOUT state has been melded
     * into {@link ProtocolState.NOT_CONNECTED} on the presumption that the nuances of a disconnected or
     * disconnecting session is uninteresting to the caller.
     *
     * See [[http://tools.ietf.org/html/rfc3501#section-3]]
     *
     * @see protocol_state
     */
 G_GNUC_NO_INLINE static GType
geary_imap_client_session_protocol_state_get_type_once (void)
{
	static const GEnumValue values[] = {{GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_NOT_CONNECTED, "GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_NOT_CONNECTED", "not-connected"}, {GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_CONNECTING, "GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_CONNECTING", "connecting"}, {GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_UNAUTHORIZED, "GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_UNAUTHORIZED", "unauthorized"}, {GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_AUTHORIZING, "GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_AUTHORIZING", "authorizing"}, {GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_AUTHORIZED, "GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_AUTHORIZED", "authorized"}, {GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_SELECTING, "GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_SELECTING", "selecting"}, {GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_SELECTED, "GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_SELECTED", "selected"}, {GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_CLOSING_MAILBOX, "GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_CLOSING_MAILBOX", "closing-mailbox"}, {0, NULL, NULL}};
	GType geary_imap_client_session_protocol_state_type_id;
	geary_imap_client_session_protocol_state_type_id = g_enum_register_static ("GearyImapClientSessionProtocolState", values);
	return geary_imap_client_session_protocol_state_type_id;
}

GType
geary_imap_client_session_protocol_state_get_type (void)
{
	static gsize geary_imap_client_session_protocol_state_type_id__once = 0;
	if (g_once_init_enter (&geary_imap_client_session_protocol_state_type_id__once)) {
		GType geary_imap_client_session_protocol_state_type_id;
		geary_imap_client_session_protocol_state_type_id = geary_imap_client_session_protocol_state_get_type_once ();
		g_once_init_leave (&geary_imap_client_session_protocol_state_type_id__once, geary_imap_client_session_protocol_state_type_id);
	}
	return geary_imap_client_session_protocol_state_type_id__once;
}

gboolean
geary_imap_client_session_disconnect_reason_is_error (GearyImapClientSessionDisconnectReason self)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 118 "../src/engine/imap/transport/imap-client-session.vala"
	if (self == GEARY_IMAP_CLIENT_SESSION_DISCONNECT_REASON_LOCAL_ERROR) {
#line 118 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp0_ = TRUE;
#line 1442 "imap-client-session.c"
	} else {
#line 118 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp0_ = self == GEARY_IMAP_CLIENT_SESSION_DISCONNECT_REASON_REMOTE_ERROR;
#line 1446 "imap-client-session.c"
	}
#line 118 "../src/engine/imap/transport/imap-client-session.vala"
	result = _tmp0_;
#line 118 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 1452 "imap-client-session.c"
}

gboolean
geary_imap_client_session_disconnect_reason_is_remote (GearyImapClientSessionDisconnectReason self)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 122 "../src/engine/imap/transport/imap-client-session.vala"
	if (self == GEARY_IMAP_CLIENT_SESSION_DISCONNECT_REASON_REMOTE_CLOSE) {
#line 122 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp0_ = TRUE;
#line 1464 "imap-client-session.c"
	} else {
#line 122 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp0_ = self == GEARY_IMAP_CLIENT_SESSION_DISCONNECT_REASON_REMOTE_ERROR;
#line 1468 "imap-client-session.c"
	}
#line 122 "../src/engine/imap/transport/imap-client-session.vala"
	result = _tmp0_;
#line 122 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 1474 "imap-client-session.c"
}

 G_GNUC_NO_INLINE static GType
geary_imap_client_session_disconnect_reason_get_type_once (void)
{
	static const GEnumValue values[] = {{GEARY_IMAP_CLIENT_SESSION_DISCONNECT_REASON_NULL, "GEARY_IMAP_CLIENT_SESSION_DISCONNECT_REASON_NULL", "null"}, {GEARY_IMAP_CLIENT_SESSION_DISCONNECT_REASON_LOCAL_CLOSE, "GEARY_IMAP_CLIENT_SESSION_DISCONNECT_REASON_LOCAL_CLOSE", "local-close"}, {GEARY_IMAP_CLIENT_SESSION_DISCONNECT_REASON_LOCAL_ERROR, "GEARY_IMAP_CLIENT_SESSION_DISCONNECT_REASON_LOCAL_ERROR", "local-error"}, {GEARY_IMAP_CLIENT_SESSION_DISCONNECT_REASON_REMOTE_CLOSE, "GEARY_IMAP_CLIENT_SESSION_DISCONNECT_REASON_REMOTE_CLOSE", "remote-close"}, {GEARY_IMAP_CLIENT_SESSION_DISCONNECT_REASON_REMOTE_ERROR, "GEARY_IMAP_CLIENT_SESSION_DISCONNECT_REASON_REMOTE_ERROR", "remote-error"}, {0, NULL, NULL}};
	GType geary_imap_client_session_disconnect_reason_type_id;
	geary_imap_client_session_disconnect_reason_type_id = g_enum_register_static ("GearyImapClientSessionDisconnectReason", values);
	return geary_imap_client_session_disconnect_reason_type_id;
}

GType
geary_imap_client_session_disconnect_reason_get_type (void)
{
	static gsize geary_imap_client_session_disconnect_reason_type_id__once = 0;
	if (g_once_init_enter (&geary_imap_client_session_disconnect_reason_type_id__once)) {
		GType geary_imap_client_session_disconnect_reason_type_id;
		geary_imap_client_session_disconnect_reason_type_id = geary_imap_client_session_disconnect_reason_get_type_once ();
		g_once_init_leave (&geary_imap_client_session_disconnect_reason_type_id__once, geary_imap_client_session_disconnect_reason_type_id);
	}
	return geary_imap_client_session_disconnect_reason_type_id__once;
}

 G_GNUC_NO_INLINE static GType
geary_imap_client_session_state_get_type_once (void)
{
	static const GEnumValue values[] = {{GEARY_IMAP_CLIENT_SESSION_STATE_NOT_CONNECTED, "GEARY_IMAP_CLIENT_SESSION_STATE_NOT_CONNECTED", "not-connected"}, {GEARY_IMAP_CLIENT_SESSION_STATE_NOAUTH, "GEARY_IMAP_CLIENT_SESSION_STATE_NOAUTH", "noauth"}, {GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZED, "GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZED", "authorized"}, {GEARY_IMAP_CLIENT_SESSION_STATE_SELECTED, "GEARY_IMAP_CLIENT_SESSION_STATE_SELECTED", "selected"}, {GEARY_IMAP_CLIENT_SESSION_STATE_LOGOUT, "GEARY_IMAP_CLIENT_SESSION_STATE_LOGOUT", "logout"}, {GEARY_IMAP_CLIENT_SESSION_STATE_CONNECTING, "GEARY_IMAP_CLIENT_SESSION_STATE_CONNECTING", "connecting"}, {GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZING, "GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZING", "authorizing"}, {GEARY_IMAP_CLIENT_SESSION_STATE_SELECTING, "GEARY_IMAP_CLIENT_SESSION_STATE_SELECTING", "selecting"}, {GEARY_IMAP_CLIENT_SESSION_STATE_CLOSING_MAILBOX, "GEARY_IMAP_CLIENT_SESSION_STATE_CLOSING_MAILBOX", "closing-mailbox"}, {GEARY_IMAP_CLIENT_SESSION_STATE_CLOSED, "GEARY_IMAP_CLIENT_SESSION_STATE_CLOSED", "closed"}, {GEARY_IMAP_CLIENT_SESSION_STATE_COUNT, "GEARY_IMAP_CLIENT_SESSION_STATE_COUNT", "count"}, {0, NULL, NULL}};
	GType geary_imap_client_session_state_type_id;
	geary_imap_client_session_state_type_id = g_enum_register_static ("GearyImapClientSessionState", values);
	return geary_imap_client_session_state_type_id;
}

static GType
geary_imap_client_session_state_get_type (void)
{
	static gsize geary_imap_client_session_state_type_id__once = 0;
	if (g_once_init_enter (&geary_imap_client_session_state_type_id__once)) {
		GType geary_imap_client_session_state_type_id;
		geary_imap_client_session_state_type_id = geary_imap_client_session_state_get_type_once ();
		g_once_init_leave (&geary_imap_client_session_state_type_id__once, geary_imap_client_session_state_type_id);
	}
	return geary_imap_client_session_state_type_id__once;
}

 G_GNUC_NO_INLINE static GType
geary_imap_client_session_event_get_type_once (void)
{
	static const GEnumValue values[] = {{GEARY_IMAP_CLIENT_SESSION_EVENT_CONNECT, "GEARY_IMAP_CLIENT_SESSION_EVENT_CONNECT", "connect"}, {GEARY_IMAP_CLIENT_SESSION_EVENT_DISCONNECT, "GEARY_IMAP_CLIENT_SESSION_EVENT_DISCONNECT", "disconnect"}, {GEARY_IMAP_CLIENT_SESSION_EVENT_LOGIN, "GEARY_IMAP_CLIENT_SESSION_EVENT_LOGIN", "login"}, {GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_CMD, "GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_CMD", "send-cmd"}, {GEARY_IMAP_CLIENT_SESSION_EVENT_SELECT, "GEARY_IMAP_CLIENT_SESSION_EVENT_SELECT", "select"}, {GEARY_IMAP_CLIENT_SESSION_EVENT_CLOSE_MAILBOX, "GEARY_IMAP_CLIENT_SESSION_EVENT_CLOSE_MAILBOX", "close-mailbox"}, {GEARY_IMAP_CLIENT_SESSION_EVENT_LOGOUT, "GEARY_IMAP_CLIENT_SESSION_EVENT_LOGOUT", "logout"}, {GEARY_IMAP_CLIENT_SESSION_EVENT_CONNECTED, "GEARY_IMAP_CLIENT_SESSION_EVENT_CONNECTED", "connected"}, {GEARY_IMAP_CLIENT_SESSION_EVENT_DISCONNECTED, "GEARY_IMAP_CLIENT_SESSION_EVENT_DISCONNECTED", "disconnected"}, {GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_STATUS, "GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_STATUS", "recv-status"}, {GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_COMPLETION, "GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_COMPLETION", "recv-completion"}, {GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_ERROR, "GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_ERROR", "recv-error"}, {GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_ERROR, "GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_ERROR", "send-error"}, {GEARY_IMAP_CLIENT_SESSION_EVENT_TIMEOUT, "GEARY_IMAP_CLIENT_SESSION_EVENT_TIMEOUT", "timeout"}, {GEARY_IMAP_CLIENT_SESSION_EVENT_COUNT, "GEARY_IMAP_CLIENT_SESSION_EVENT_COUNT", "count"}, {0, NULL, NULL}};
	GType geary_imap_client_session_event_type_id;
	geary_imap_client_session_event_type_id = g_enum_register_static ("GearyImapClientSessionEvent", values);
	return geary_imap_client_session_event_type_id;
}

static GType
geary_imap_client_session_event_get_type (void)
{
	static gsize geary_imap_client_session_event_type_id__once = 0;
	if (g_once_init_enter (&geary_imap_client_session_event_type_id__once)) {
		GType geary_imap_client_session_event_type_id;
		geary_imap_client_session_event_type_id = geary_imap_client_session_event_get_type_once ();
		g_once_init_leave (&geary_imap_client_session_event_type_id__once, geary_imap_client_session_event_type_id);
	}
	return geary_imap_client_session_event_type_id__once;
}

static gchar*
geary_imap_client_session_state_to_string (guint state)
{
	gchar* _tmp0_;
	gchar* result;
#line 196 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = geary_object_utils_to_enum_nick (G_TYPE_UINT, NULL, NULL, GEARY_IMAP_CLIENT_SESSION_TYPE_STATE, (gpointer) ((guintptr) state));
#line 196 "../src/engine/imap/transport/imap-client-session.vala"
	result = _tmp0_;
#line 196 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 1551 "imap-client-session.c"
}

static gchar*
geary_imap_client_session_event_to_string (guint event)
{
	gchar* result;
#line 227 "../src/engine/imap/transport/imap-client-session.vala"
	result = g_enum_to_string (GEARY_IMAP_CLIENT_SESSION_TYPE_EVENT, (GearyImapClientSessionEvent) event);
#line 227 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 1562 "imap-client-session.c"
}

static gchar*
_geary_imap_client_session_state_to_string_geary_state_state_event_to_string (guint state_or_event,
                                                                              gpointer self)
{
	gchar* result;
	result = geary_imap_client_session_state_to_string (state_or_event);
#line 230 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 1573 "imap-client-session.c"
}

static gchar*
_geary_imap_client_session_event_to_string_geary_state_state_event_to_string (guint state_or_event,
                                                                              gpointer self)
{
	gchar* result;
	result = geary_imap_client_session_event_to_string (state_or_event);
#line 230 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 1584 "imap-client-session.c"
}

GearyImapClientSessionProtocolState
geary_imap_client_session_get_protocol_state (GearyImapClientSession* self)
{
	GearyImapClientSessionProtocolState result;
	GearyImapClientSessionProtocolState state = 0;
	GearyStateMachine* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
#line 239 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0);
#line 240 "../src/engine/imap/transport/imap-client-session.vala"
	state = GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_NOT_CONNECTED;
#line 241 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = self->priv->fsm;
#line 241 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = geary_state_machine_get_state (_tmp0_);
#line 241 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = _tmp1_;
#line 241 "../src/engine/imap/transport/imap-client-session.vala"
	switch (_tmp2_) {
#line 241 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_STATE_NOT_CONNECTED:
#line 241 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_STATE_LOGOUT:
#line 241 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_STATE_CLOSED:
#line 1613 "imap-client-session.c"
		{
#line 245 "../src/engine/imap/transport/imap-client-session.vala"
			state = GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_NOT_CONNECTED;
#line 246 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 1619 "imap-client-session.c"
		}
#line 241 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_STATE_NOAUTH:
#line 1623 "imap-client-session.c"
		{
#line 249 "../src/engine/imap/transport/imap-client-session.vala"
			state = GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_UNAUTHORIZED;
#line 250 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 1629 "imap-client-session.c"
		}
#line 241 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZED:
#line 1633 "imap-client-session.c"
		{
#line 253 "../src/engine/imap/transport/imap-client-session.vala"
			state = GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_AUTHORIZED;
#line 254 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 1639 "imap-client-session.c"
		}
#line 241 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_STATE_SELECTED:
#line 1643 "imap-client-session.c"
		{
#line 257 "../src/engine/imap/transport/imap-client-session.vala"
			state = GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_SELECTED;
#line 258 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 1649 "imap-client-session.c"
		}
#line 241 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_STATE_CONNECTING:
#line 1653 "imap-client-session.c"
		{
#line 261 "../src/engine/imap/transport/imap-client-session.vala"
			state = GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_CONNECTING;
#line 262 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 1659 "imap-client-session.c"
		}
#line 241 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZING:
#line 1663 "imap-client-session.c"
		{
#line 265 "../src/engine/imap/transport/imap-client-session.vala"
			state = GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_AUTHORIZING;
#line 266 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 1669 "imap-client-session.c"
		}
#line 241 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_STATE_SELECTING:
#line 1673 "imap-client-session.c"
		{
#line 269 "../src/engine/imap/transport/imap-client-session.vala"
			state = GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_SELECTING;
#line 270 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 1679 "imap-client-session.c"
		}
#line 241 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_STATE_CLOSING_MAILBOX:
#line 1683 "imap-client-session.c"
		{
#line 273 "../src/engine/imap/transport/imap-client-session.vala"
			state = GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_CLOSING_MAILBOX;
#line 274 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 1689 "imap-client-session.c"
		}
		default:
#line 241 "../src/engine/imap/transport/imap-client-session.vala"
		break;
#line 1694 "imap-client-session.c"
	}
#line 276 "../src/engine/imap/transport/imap-client-session.vala"
	result = state;
#line 276 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 1700 "imap-client-session.c"
}

GearyImapClientSessionDisconnectReason
geary_imap_client_session_get_disconnected (GearyImapClientSession* self)
{
	GearyImapClientSessionDisconnectReason result;
#line 281 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0);
#line 281 "../src/engine/imap/transport/imap-client-session.vala"
	result = self->priv->_disconnected;
#line 281 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 1713 "imap-client-session.c"
}

static void
geary_imap_client_session_set_disconnected (GearyImapClientSession* self,
                                            GearyImapClientSessionDisconnectReason value)
{
	GearyImapClientSessionDisconnectReason old_value;
#line 281 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 281 "../src/engine/imap/transport/imap-client-session.vala"
	old_value = geary_imap_client_session_get_disconnected (self);
#line 281 "../src/engine/imap/transport/imap-client-session.vala"
	if (old_value != value) {
#line 281 "../src/engine/imap/transport/imap-client-session.vala"
		self->priv->_disconnected = value;
#line 281 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_imap_client_session_properties[GEARY_IMAP_CLIENT_SESSION_DISCONNECTED_PROPERTY]);
#line 1731 "imap-client-session.c"
	}
}

GearyImapCapabilities*
geary_imap_client_session_get_capabilities (GearyImapClientSession* self)
{
	GearyImapCapabilities* result;
	GearyImapCapabilities* _tmp0_;
#line 293 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), NULL);
#line 293 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = self->priv->_capabilities;
#line 293 "../src/engine/imap/transport/imap-client-session.vala"
	result = _tmp0_;
#line 293 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 1748 "imap-client-session.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 293 "../src/engine/imap/transport/imap-client-session.vala"
	return self ? g_object_ref (self) : NULL;
#line 1756 "imap-client-session.c"
}

static void
geary_imap_client_session_set_capabilities (GearyImapClientSession* self,
                                            GearyImapCapabilities* value)
{
	GearyImapCapabilities* old_value;
#line 293 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 293 "../src/engine/imap/transport/imap-client-session.vala"
	old_value = geary_imap_client_session_get_capabilities (self);
#line 293 "../src/engine/imap/transport/imap-client-session.vala"
	if (old_value != value) {
#line 1770 "imap-client-session.c"
		GearyImapCapabilities* _tmp0_;
#line 293 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 293 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (self->priv->_capabilities);
#line 293 "../src/engine/imap/transport/imap-client-session.vala"
		self->priv->_capabilities = _tmp0_;
#line 293 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_imap_client_session_properties[GEARY_IMAP_CLIENT_SESSION_CAPABILITIES_PROPERTY]);
#line 1780 "imap-client-session.c"
	}
}

gboolean
geary_imap_client_session_get_is_idle_supported (GearyImapClientSession* self)
{
	gboolean result;
	GearyImapCapabilities* _tmp0_;
#line 298 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), FALSE);
#line 298 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = self->priv->_capabilities;
#line 298 "../src/engine/imap/transport/imap-client-session.vala"
	result = geary_generic_capabilities_has_capability (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_TYPE_GENERIC_CAPABILITIES, GearyGenericCapabilities), GEARY_IMAP_CAPABILITIES_IDLE);
#line 298 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 1797 "imap-client-session.c"
}

GearyImapStatusResponse*
geary_imap_client_session_get_server_greeting (GearyImapClientSession* self)
{
	GearyImapStatusResponse* result;
	GearyImapStatusResponse* _tmp0_;
#line 307 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), NULL);
#line 307 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = self->priv->_server_greeting;
#line 307 "../src/engine/imap/transport/imap-client-session.vala"
	result = _tmp0_;
#line 307 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 1813 "imap-client-session.c"
}

static void
geary_imap_client_session_set_server_greeting (GearyImapClientSession* self,
                                               GearyImapStatusResponse* value)
{
	GearyImapStatusResponse* old_value;
#line 307 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 307 "../src/engine/imap/transport/imap-client-session.vala"
	old_value = geary_imap_client_session_get_server_greeting (self);
#line 307 "../src/engine/imap/transport/imap-client-session.vala"
	if (old_value != value) {
#line 1827 "imap-client-session.c"
		GearyImapStatusResponse* _tmp0_;
#line 307 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 307 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (self->priv->_server_greeting);
#line 307 "../src/engine/imap/transport/imap-client-session.vala"
		self->priv->_server_greeting = _tmp0_;
#line 307 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_imap_client_session_properties[GEARY_IMAP_CLIENT_SESSION_SERVER_GREETING_PROPERTY]);
#line 1837 "imap-client-session.c"
	}
}

static const gchar*
geary_imap_client_session_real_get_logging_domain (GearyLoggingSource* base)
{
	const gchar* result;
	GearyImapClientSession* self;
#line 324 "../src/engine/imap/transport/imap-client-session.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_IMAP_TYPE_CLIENT_SESSION, GearyImapClientSession);
#line 324 "../src/engine/imap/transport/imap-client-session.vala"
	result = GEARY_IMAP_CLIENT_SERVICE_LOGGING_DOMAIN;
#line 324 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 1852 "imap-client-session.c"
}

static GearyLoggingSource*
geary_imap_client_session_real_get_logging_parent (GearyLoggingSource* base)
{
	GearyLoggingSource* result;
	GearyImapClientSession* self;
	GearyLoggingSource* _tmp0_;
#line 328 "../src/engine/imap/transport/imap-client-session.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_IMAP_TYPE_CLIENT_SESSION, GearyImapClientSession);
#line 328 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = self->priv->_logging_parent;
#line 328 "../src/engine/imap/transport/imap-client-session.vala"
	result = _tmp0_;
#line 328 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 1869 "imap-client-session.c"
}

gint64
geary_imap_client_session_get_last_seen (GearyImapClientSession* self)
{
	gint64 result;
#line 337 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0LL);
#line 337 "../src/engine/imap/transport/imap-client-session.vala"
	result = self->priv->_last_seen;
#line 337 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 1882 "imap-client-session.c"
}

static void
geary_imap_client_session_set_last_seen (GearyImapClientSession* self,
                                         gint64 value)
{
	gint64 old_value;
#line 337 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 337 "../src/engine/imap/transport/imap-client-session.vala"
	old_value = geary_imap_client_session_get_last_seen (self);
#line 337 "../src/engine/imap/transport/imap-client-session.vala"
	if (old_value != value) {
#line 337 "../src/engine/imap/transport/imap-client-session.vala"
		self->priv->_last_seen = value;
#line 337 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_imap_client_session_properties[GEARY_IMAP_CLIENT_SESSION_LAST_SEEN_PROPERTY]);
#line 1900 "imap-client-session.c"
	}
}

GearyImapMailboxInformation*
geary_imap_client_session_get_inbox (GearyImapClientSession* self)
{
	GearyImapMailboxInformation* result;
	GearyImapMailboxInformation* _tmp0_;
#line 348 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), NULL);
#line 348 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = self->priv->_inbox;
#line 348 "../src/engine/imap/transport/imap-client-session.vala"
	result = _tmp0_;
#line 348 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 1917 "imap-client-session.c"
}

static void
geary_imap_client_session_set_inbox (GearyImapClientSession* self,
                                     GearyImapMailboxInformation* value)
{
	GearyImapMailboxInformation* old_value;
#line 348 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 348 "../src/engine/imap/transport/imap-client-session.vala"
	old_value = geary_imap_client_session_get_inbox (self);
#line 348 "../src/engine/imap/transport/imap-client-session.vala"
	if (old_value != value) {
#line 1931 "imap-client-session.c"
		GearyImapMailboxInformation* _tmp0_;
#line 348 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 348 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (self->priv->_inbox);
#line 348 "../src/engine/imap/transport/imap-client-session.vala"
		self->priv->_inbox = _tmp0_;
#line 348 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_imap_client_session_properties[GEARY_IMAP_CLIENT_SESSION_INBOX_PROPERTY]);
#line 1941 "imap-client-session.c"
	}
}

GearyImapQuirks*
geary_imap_client_session_get_quirks (GearyImapClientSession* self)
{
	GearyImapQuirks* result;
	GearyImapQuirks* _tmp0_;
#line 351 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), NULL);
#line 351 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = self->priv->_quirks;
#line 351 "../src/engine/imap/transport/imap-client-session.vala"
	result = _tmp0_;
#line 351 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 1958 "imap-client-session.c"
}

void
geary_imap_client_session_set_quirks (GearyImapClientSession* self,
                                      GearyImapQuirks* value)
{
	GearyImapQuirks* old_value;
#line 351 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 351 "../src/engine/imap/transport/imap-client-session.vala"
	old_value = geary_imap_client_session_get_quirks (self);
#line 351 "../src/engine/imap/transport/imap-client-session.vala"
	if (old_value != value) {
#line 1972 "imap-client-session.c"
		GearyImapQuirks* _tmp0_;
#line 351 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 351 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (self->priv->_quirks);
#line 351 "../src/engine/imap/transport/imap-client-session.vala"
		self->priv->_quirks = _tmp0_;
#line 351 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_imap_client_session_properties[GEARY_IMAP_CLIENT_SESSION_QUIRKS_PROPERTY]);
#line 1982 "imap-client-session.c"
	}
}

static void
g_cclosure_user_marshal_VOID__POINTER_INT (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__POINTER_INT) (gpointer data1, gpointer arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__POINTER_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (n_param_values == 3);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		data1 = closure->data;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		data2 = param_values->data[0].v_pointer;
#line 2008 "imap-client-session.c"
	} else {
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		data1 = param_values->data[0].v_pointer;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		data2 = closure->data;
#line 2014 "imap-client-session.c"
	}
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	callback = (GMarshalFunc_VOID__POINTER_INT) (marshal_data ? marshal_data : cc->callback);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	callback (data1, g_value_get_pointer (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 2020 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_connect_geary_state_transition (guint state,
                                                              guint event,
                                                              void* user,
                                                              GObject* object,
                                                              GError* err,
                                                              gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_connect ((GearyImapClientSession*) self, state, event, user, object);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2035 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_early_command_geary_state_transition (guint state,
                                                                    guint event,
                                                                    void* user,
                                                                    GObject* object,
                                                                    GError* err,
                                                                    gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_early_command ((GearyImapClientSession*) self, state, event, user, object);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2050 "imap-client-session.c"
}

static guint
_geary_state_nop_geary_state_transition (guint state,
                                         guint event,
                                         void* user,
                                         GObject* object,
                                         GError* err,
                                         gpointer self)
{
	guint result;
	result = geary_state_nop (state, event);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2065 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_already_connected_geary_state_transition (guint state,
                                                                        guint event,
                                                                        void* user,
                                                                        GObject* object,
                                                                        GError* err,
                                                                        gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_already_connected ((GearyImapClientSession*) self, state, event, user, object);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2080 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_disconnect_geary_state_transition (guint state,
                                                                 guint event,
                                                                 void* user,
                                                                 GObject* object,
                                                                 GError* err,
                                                                 gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_disconnect ((GearyImapClientSession*) self, state, event, user, object, err);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2095 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_connected_geary_state_transition (guint state,
                                                                guint event,
                                                                void* user,
                                                                GObject* object,
                                                                GError* err,
                                                                gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_connected ((GearyImapClientSession*) self, state, event);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2110 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_connecting_recv_status_geary_state_transition (guint state,
                                                                             guint event,
                                                                             void* user,
                                                                             GObject* object,
                                                                             GError* err,
                                                                             gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_connecting_recv_status ((GearyImapClientSession*) self, state, event, user, object);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2125 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_dropped_response_geary_state_transition (guint state,
                                                                       guint event,
                                                                       void* user,
                                                                       GObject* object,
                                                                       GError* err,
                                                                       gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_dropped_response ((GearyImapClientSession*) self, state, event, user, object);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2140 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_connecting_send_recv_error_geary_state_transition (guint state,
                                                                                 guint event,
                                                                                 void* user,
                                                                                 GObject* object,
                                                                                 GError* err,
                                                                                 gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_connecting_send_recv_error ((GearyImapClientSession*) self, state, event, user, object, err);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2155 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_connecting_timeout_geary_state_transition (guint state,
                                                                         guint event,
                                                                         void* user,
                                                                         GObject* object,
                                                                         GError* err,
                                                                         gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_connecting_timeout ((GearyImapClientSession*) self, state, event);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2170 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_login_geary_state_transition (guint state,
                                                            guint event,
                                                            void* user,
                                                            GObject* object,
                                                            GError* err,
                                                            gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_login ((GearyImapClientSession*) self, state, event, user, object);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2185 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_send_command_geary_state_transition (guint state,
                                                                   guint event,
                                                                   void* user,
                                                                   GObject* object,
                                                                   GError* err,
                                                                   gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_send_command ((GearyImapClientSession*) self, state, event, user, object);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2200 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_unauthenticated_geary_state_transition (guint state,
                                                                      guint event,
                                                                      void* user,
                                                                      GObject* object,
                                                                      GError* err,
                                                                      gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_unauthenticated ((GearyImapClientSession*) self, state, event, user, object);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2215 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_logout_geary_state_transition (guint state,
                                                             guint event,
                                                             void* user,
                                                             GObject* object,
                                                             GError* err,
                                                             gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_logout ((GearyImapClientSession*) self, state, event, user, object);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2230 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_recv_status_geary_state_transition (guint state,
                                                                  guint event,
                                                                  void* user,
                                                                  GObject* object,
                                                                  GError* err,
                                                                  gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_recv_status ((GearyImapClientSession*) self, state, event, user, object);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2245 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_send_error_geary_state_transition (guint state,
                                                                 guint event,
                                                                 void* user,
                                                                 GObject* object,
                                                                 GError* err,
                                                                 gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_send_error ((GearyImapClientSession*) self, state, event, user, object, err);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2260 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_recv_error_geary_state_transition (guint state,
                                                                 guint event,
                                                                 void* user,
                                                                 GObject* object,
                                                                 GError* err,
                                                                 gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_recv_error ((GearyImapClientSession*) self, state, event, user, object, err);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2275 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_logging_in_geary_state_transition (guint state,
                                                                 guint event,
                                                                 void* user,
                                                                 GObject* object,
                                                                 GError* err,
                                                                 gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_logging_in ((GearyImapClientSession*) self, state, event, user, object);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2290 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_login_recv_completion_geary_state_transition (guint state,
                                                                            guint event,
                                                                            void* user,
                                                                            GObject* object,
                                                                            GError* err,
                                                                            gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_login_recv_completion ((GearyImapClientSession*) self, state, event, user, object);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2305 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_already_logged_in_geary_state_transition (guint state,
                                                                        guint event,
                                                                        void* user,
                                                                        GObject* object,
                                                                        GError* err,
                                                                        gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_already_logged_in ((GearyImapClientSession*) self, state, event, user, object);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2320 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_select_geary_state_transition (guint state,
                                                             guint event,
                                                             void* user,
                                                             GObject* object,
                                                             GError* err,
                                                             gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_select ((GearyImapClientSession*) self, state, event, user, object);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2335 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_not_selected_geary_state_transition (guint state,
                                                                   guint event,
                                                                   void* user,
                                                                   GObject* object,
                                                                   GError* err,
                                                                   gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_not_selected ((GearyImapClientSession*) self, state, event, user, object);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2350 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_close_mailbox_geary_state_transition (guint state,
                                                                    guint event,
                                                                    void* user,
                                                                    GObject* object,
                                                                    GError* err,
                                                                    gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_close_mailbox ((GearyImapClientSession*) self, state, event, user, object);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2365 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_selecting_recv_completion_geary_state_transition (guint state,
                                                                                guint event,
                                                                                void* user,
                                                                                GObject* object,
                                                                                GError* err,
                                                                                gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_selecting_recv_completion ((GearyImapClientSession*) self, state, event, user, object);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2380 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_closing_recv_completion_geary_state_transition (guint state,
                                                                              guint event,
                                                                              void* user,
                                                                              GObject* object,
                                                                              GError* err,
                                                                              gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_closing_recv_completion ((GearyImapClientSession*) self, state, event, user, object);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2395 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_late_command_geary_state_transition (guint state,
                                                                   guint event,
                                                                   void* user,
                                                                   GObject* object,
                                                                   GError* err,
                                                                   gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_late_command ((GearyImapClientSession*) self, state, event, user, object);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2410 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_logging_out_recv_status_geary_state_transition (guint state,
                                                                              guint event,
                                                                              void* user,
                                                                              GObject* object,
                                                                              GError* err,
                                                                              gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_logging_out_recv_status ((GearyImapClientSession*) self, state, event, user, object);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2425 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_logging_out_recv_completion_geary_state_transition (guint state,
                                                                                  guint event,
                                                                                  void* user,
                                                                                  GObject* object,
                                                                                  GError* err,
                                                                                  gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_logging_out_recv_completion ((GearyImapClientSession*) self, state, event, user, object);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2440 "imap-client-session.c"
}

static guint
_geary_imap_client_session_on_ignored_transition_geary_state_transition (guint state,
                                                                         guint event,
                                                                         void* user,
                                                                         GObject* object,
                                                                         GError* err,
                                                                         gpointer self)
{
	guint result;
	result = geary_imap_client_session_on_ignored_transition ((GearyImapClientSession*) self, state, event);
#line 532 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 2455 "imap-client-session.c"
}

static void
__lambda49_ (GearyImapClientSession* self)
{
#line 538 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_notify (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "protocol_state");
#line 2463 "imap-client-session.c"
}

static void
___lambda49__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 537 "../src/engine/imap/transport/imap-client-session.vala"
	__lambda49_ ((GearyImapClientSession*) self);
#line 2473 "imap-client-session.c"
}

GearyImapClientSession*
geary_imap_client_session_construct (GType object_type,
                                     GearyEndpoint* imap_endpoint,
                                     GearyImapQuirks* quirks)
{
	GearyImapClientSession * self = NULL;
	GearyEndpoint* _tmp0_;
	GearyStateMapping** mappings = NULL;
	GearyStateMapping* _tmp1_;
	GearyStateMapping* _tmp2_;
	GearyStateMapping* _tmp3_;
	GearyStateMapping* _tmp4_;
	GearyStateMapping* _tmp5_;
	GearyStateMapping* _tmp6_;
	GearyStateMapping* _tmp7_;
	GearyStateMapping* _tmp8_;
	GearyStateMapping* _tmp9_;
	GearyStateMapping* _tmp10_;
	GearyStateMapping* _tmp11_;
	GearyStateMapping* _tmp12_;
	GearyStateMapping* _tmp13_;
	GearyStateMapping* _tmp14_;
	GearyStateMapping* _tmp15_;
	GearyStateMapping* _tmp16_;
	GearyStateMapping* _tmp17_;
	GearyStateMapping* _tmp18_;
	GearyStateMapping* _tmp19_;
	GearyStateMapping* _tmp20_;
	GearyStateMapping* _tmp21_;
	GearyStateMapping* _tmp22_;
	GearyStateMapping* _tmp23_;
	GearyStateMapping* _tmp24_;
	GearyStateMapping* _tmp25_;
	GearyStateMapping* _tmp26_;
	GearyStateMapping* _tmp27_;
	GearyStateMapping* _tmp28_;
	GearyStateMapping* _tmp29_;
	GearyStateMapping* _tmp30_;
	GearyStateMapping* _tmp31_;
	GearyStateMapping* _tmp32_;
	GearyStateMapping* _tmp33_;
	GearyStateMapping* _tmp34_;
	GearyStateMapping* _tmp35_;
	GearyStateMapping* _tmp36_;
	GearyStateMapping* _tmp37_;
	GearyStateMapping* _tmp38_;
	GearyStateMapping* _tmp39_;
	GearyStateMapping* _tmp40_;
	GearyStateMapping* _tmp41_;
	GearyStateMapping* _tmp42_;
	GearyStateMapping* _tmp43_;
	GearyStateMapping* _tmp44_;
	GearyStateMapping* _tmp45_;
	GearyStateMapping* _tmp46_;
	GearyStateMapping* _tmp47_;
	GearyStateMapping* _tmp48_;
	GearyStateMapping* _tmp49_;
	GearyStateMapping* _tmp50_;
	GearyStateMapping* _tmp51_;
	GearyStateMapping* _tmp52_;
	GearyStateMapping* _tmp53_;
	GearyStateMapping* _tmp54_;
	GearyStateMapping* _tmp55_;
	GearyStateMapping* _tmp56_;
	GearyStateMapping* _tmp57_;
	GearyStateMapping* _tmp58_;
	GearyStateMapping* _tmp59_;
	GearyStateMapping* _tmp60_;
	GearyStateMapping* _tmp61_;
	GearyStateMapping* _tmp62_;
	GearyStateMapping* _tmp63_;
	GearyStateMapping* _tmp64_;
	GearyStateMapping* _tmp65_;
	GearyStateMapping* _tmp66_;
	GearyStateMapping* _tmp67_;
	GearyStateMapping* _tmp68_;
	GearyStateMapping* _tmp69_;
	GearyStateMapping* _tmp70_;
	GearyStateMapping* _tmp71_;
	GearyStateMapping* _tmp72_;
	GearyStateMapping* _tmp73_;
	GearyStateMapping* _tmp74_;
	GearyStateMapping* _tmp75_;
	GearyStateMapping* _tmp76_;
	GearyStateMapping* _tmp77_;
	GearyStateMapping* _tmp78_;
	GearyStateMapping* _tmp79_;
	GearyStateMapping* _tmp80_;
	GearyStateMapping* _tmp81_;
	GearyStateMapping* _tmp82_;
	GearyStateMapping* _tmp83_;
	GearyStateMapping* _tmp84_;
	GearyStateMapping* _tmp85_;
	GearyStateMapping* _tmp86_;
	GearyStateMapping* _tmp87_;
	GearyStateMapping* _tmp88_;
	GearyStateMapping* _tmp89_;
	GearyStateMapping* _tmp90_;
	GearyStateMapping* _tmp91_;
	GearyStateMapping* _tmp92_;
	GearyStateMapping* _tmp93_;
	GearyStateMapping* _tmp94_;
	GearyStateMapping* _tmp95_;
	GearyStateMapping* _tmp96_;
	GearyStateMapping* _tmp97_;
	GearyStateMapping* _tmp98_;
	GearyStateMapping* _tmp99_;
	GearyStateMapping* _tmp100_;
	GearyStateMapping* _tmp101_;
	GearyStateMapping* _tmp102_;
	GearyStateMapping* _tmp103_;
	GearyStateMapping* _tmp104_;
	GearyStateMapping* _tmp105_;
	GearyStateMapping* _tmp106_;
	GearyStateMapping* _tmp107_;
	GearyStateMapping* _tmp108_;
	GearyStateMapping** _tmp109_;
	gint mappings_length1;
	gint _mappings_size_;
	GearyStateMachineDescriptor* _tmp110_;
	GearyStateMachine* _tmp111_;
	GearyStateMachine* _tmp112_;
#line 408 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (imap_endpoint), NULL);
#line 408 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_QUIRKS (quirks), NULL);
#line 408 "../src/engine/imap/transport/imap-client-session.vala"
	self = (GearyImapClientSession*) geary_base_object_construct (object_type);
#line 409 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (imap_endpoint);
#line 409 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->priv->imap_endpoint);
#line 409 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->imap_endpoint = _tmp0_;
#line 410 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_set_quirks (self, quirks);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_NOT_CONNECTED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_CONNECT, _geary_imap_client_session_on_connect_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_NOT_CONNECTED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_LOGIN, _geary_imap_client_session_on_early_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_NOT_CONNECTED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_CMD, _geary_imap_client_session_on_early_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp4_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_NOT_CONNECTED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SELECT, _geary_imap_client_session_on_early_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp5_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_NOT_CONNECTED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_CLOSE_MAILBOX, _geary_imap_client_session_on_early_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp6_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_NOT_CONNECTED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_LOGOUT, _geary_imap_client_session_on_early_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp7_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_NOT_CONNECTED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_DISCONNECT, _geary_state_nop_geary_state_transition, NULL);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp8_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CONNECTING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_CONNECT, _geary_imap_client_session_on_already_connected_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp9_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CONNECTING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_DISCONNECT, _geary_imap_client_session_on_disconnect_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp10_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CONNECTING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_LOGIN, _geary_imap_client_session_on_early_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp11_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CONNECTING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_CMD, _geary_imap_client_session_on_early_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp12_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CONNECTING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SELECT, _geary_imap_client_session_on_early_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp13_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CONNECTING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_CLOSE_MAILBOX, _geary_imap_client_session_on_early_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp14_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CONNECTING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_LOGOUT, _geary_imap_client_session_on_early_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp15_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CONNECTING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_CONNECTED, _geary_imap_client_session_on_connected_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp16_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CONNECTING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_STATUS, _geary_imap_client_session_on_connecting_recv_status_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp17_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CONNECTING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_COMPLETION, _geary_imap_client_session_on_dropped_response_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp18_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CONNECTING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_ERROR, _geary_imap_client_session_on_connecting_send_recv_error_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp19_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CONNECTING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_ERROR, _geary_imap_client_session_on_connecting_send_recv_error_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp20_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CONNECTING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_TIMEOUT, _geary_imap_client_session_on_connecting_timeout_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp21_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_NOAUTH, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_CONNECT, _geary_imap_client_session_on_already_connected_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp22_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_NOAUTH, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_DISCONNECT, _geary_imap_client_session_on_disconnect_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp23_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_NOAUTH, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_LOGIN, _geary_imap_client_session_on_login_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp24_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_NOAUTH, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_CMD, _geary_imap_client_session_on_send_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp25_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_NOAUTH, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SELECT, _geary_imap_client_session_on_unauthenticated_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp26_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_NOAUTH, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_CLOSE_MAILBOX, _geary_imap_client_session_on_unauthenticated_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp27_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_NOAUTH, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_LOGOUT, _geary_imap_client_session_on_logout_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp28_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_NOAUTH, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_STATUS, _geary_imap_client_session_on_recv_status_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp29_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_NOAUTH, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_COMPLETION, _geary_imap_client_session_on_recv_status_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp30_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_NOAUTH, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_ERROR, _geary_imap_client_session_on_send_error_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp31_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_NOAUTH, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_ERROR, _geary_imap_client_session_on_recv_error_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp32_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_CONNECT, _geary_imap_client_session_on_already_connected_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp33_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_DISCONNECT, _geary_imap_client_session_on_disconnect_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp34_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_LOGIN, _geary_imap_client_session_on_logging_in_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp35_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_CMD, _geary_imap_client_session_on_unauthenticated_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp36_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SELECT, _geary_imap_client_session_on_unauthenticated_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp37_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_CLOSE_MAILBOX, _geary_imap_client_session_on_unauthenticated_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp38_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_LOGOUT, _geary_imap_client_session_on_logout_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp39_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_STATUS, _geary_imap_client_session_on_recv_status_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp40_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_COMPLETION, _geary_imap_client_session_on_login_recv_completion_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp41_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_ERROR, _geary_imap_client_session_on_send_error_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp42_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_ERROR, _geary_imap_client_session_on_recv_error_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp43_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_CONNECT, _geary_imap_client_session_on_already_connected_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp44_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_DISCONNECT, _geary_imap_client_session_on_disconnect_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp45_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_LOGIN, _geary_imap_client_session_on_already_logged_in_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp46_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_CMD, _geary_imap_client_session_on_send_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp47_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SELECT, _geary_imap_client_session_on_select_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp48_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_CLOSE_MAILBOX, _geary_imap_client_session_on_not_selected_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp49_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_LOGOUT, _geary_imap_client_session_on_logout_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp50_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_STATUS, _geary_imap_client_session_on_recv_status_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp51_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_COMPLETION, _geary_imap_client_session_on_recv_status_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp52_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_ERROR, _geary_imap_client_session_on_send_error_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp53_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_ERROR, _geary_imap_client_session_on_recv_error_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp54_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_CONNECT, _geary_imap_client_session_on_already_connected_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp55_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_DISCONNECT, _geary_imap_client_session_on_disconnect_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp56_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_LOGIN, _geary_imap_client_session_on_already_logged_in_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp57_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_CMD, _geary_imap_client_session_on_send_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp58_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SELECT, _geary_imap_client_session_on_select_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp59_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_CLOSE_MAILBOX, _geary_imap_client_session_on_close_mailbox_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp60_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_LOGOUT, _geary_imap_client_session_on_logout_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp61_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_STATUS, _geary_imap_client_session_on_recv_status_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp62_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_COMPLETION, _geary_imap_client_session_on_selecting_recv_completion_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp63_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_ERROR, _geary_imap_client_session_on_send_error_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp64_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTING, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_ERROR, _geary_imap_client_session_on_recv_error_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp65_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_CONNECT, _geary_imap_client_session_on_already_connected_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp66_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_DISCONNECT, _geary_imap_client_session_on_disconnect_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp67_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_LOGIN, _geary_imap_client_session_on_already_logged_in_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp68_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_CMD, _geary_imap_client_session_on_send_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp69_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SELECT, _geary_imap_client_session_on_select_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp70_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_CLOSE_MAILBOX, _geary_imap_client_session_on_close_mailbox_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp71_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_LOGOUT, _geary_imap_client_session_on_logout_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp72_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_STATUS, _geary_imap_client_session_on_recv_status_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp73_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_COMPLETION, _geary_imap_client_session_on_recv_status_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp74_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_ERROR, _geary_imap_client_session_on_send_error_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp75_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_ERROR, _geary_imap_client_session_on_recv_error_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp76_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSING_MAILBOX, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_CONNECT, _geary_imap_client_session_on_already_connected_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp77_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSING_MAILBOX, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_DISCONNECT, _geary_imap_client_session_on_disconnect_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp78_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSING_MAILBOX, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_LOGIN, _geary_imap_client_session_on_already_logged_in_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp79_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSING_MAILBOX, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_CMD, _geary_imap_client_session_on_send_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp80_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSING_MAILBOX, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SELECT, _geary_imap_client_session_on_select_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp81_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSING_MAILBOX, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_CLOSE_MAILBOX, _geary_imap_client_session_on_not_selected_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp82_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSING_MAILBOX, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_LOGOUT, _geary_imap_client_session_on_logout_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp83_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSING_MAILBOX, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_STATUS, _geary_imap_client_session_on_recv_status_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp84_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSING_MAILBOX, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_COMPLETION, _geary_imap_client_session_on_closing_recv_completion_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp85_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSING_MAILBOX, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_ERROR, _geary_imap_client_session_on_send_error_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp86_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSING_MAILBOX, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_ERROR, _geary_imap_client_session_on_recv_error_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp87_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_LOGOUT, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_CONNECT, _geary_imap_client_session_on_already_connected_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp88_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_LOGOUT, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_DISCONNECT, _geary_imap_client_session_on_disconnect_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp89_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_LOGOUT, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_LOGIN, _geary_imap_client_session_on_already_logged_in_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp90_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_LOGOUT, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_CMD, _geary_imap_client_session_on_late_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp91_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_LOGOUT, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SELECT, _geary_imap_client_session_on_late_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp92_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_LOGOUT, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_CLOSE_MAILBOX, _geary_imap_client_session_on_late_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp93_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_LOGOUT, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_LOGOUT, _geary_imap_client_session_on_late_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp94_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_LOGOUT, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_STATUS, _geary_imap_client_session_on_logging_out_recv_status_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp95_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_LOGOUT, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_COMPLETION, _geary_imap_client_session_on_logging_out_recv_completion_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp96_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_LOGOUT, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_ERROR, _geary_imap_client_session_on_recv_error_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp97_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_LOGOUT, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_ERROR, _geary_imap_client_session_on_send_error_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp98_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_CONNECT, _geary_imap_client_session_on_late_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp99_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_DISCONNECT, _geary_state_nop_geary_state_transition, NULL);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp100_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_LOGIN, _geary_imap_client_session_on_late_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp101_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_CMD, _geary_imap_client_session_on_late_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp102_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SELECT, _geary_imap_client_session_on_late_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp103_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_CLOSE_MAILBOX, _geary_imap_client_session_on_late_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp104_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_LOGOUT, _geary_imap_client_session_on_late_command_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp105_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_STATUS, _geary_imap_client_session_on_dropped_response_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp106_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_COMPLETION, _geary_imap_client_session_on_dropped_response_geary_state_transition, self);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp107_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_ERROR, _geary_state_nop_geary_state_transition, NULL);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp108_ = geary_state_mapping_new ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSED, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_ERROR, _geary_state_nop_geary_state_transition, NULL);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_ = g_new0 (GearyStateMapping*, 108 + 1);
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[0] = _tmp1_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[1] = _tmp2_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[2] = _tmp3_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[3] = _tmp4_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[4] = _tmp5_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[5] = _tmp6_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[6] = _tmp7_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[7] = _tmp8_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[8] = _tmp9_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[9] = _tmp10_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[10] = _tmp11_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[11] = _tmp12_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[12] = _tmp13_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[13] = _tmp14_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[14] = _tmp15_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[15] = _tmp16_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[16] = _tmp17_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[17] = _tmp18_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[18] = _tmp19_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[19] = _tmp20_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[20] = _tmp21_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[21] = _tmp22_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[22] = _tmp23_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[23] = _tmp24_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[24] = _tmp25_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[25] = _tmp26_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[26] = _tmp27_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[27] = _tmp28_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[28] = _tmp29_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[29] = _tmp30_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[30] = _tmp31_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[31] = _tmp32_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[32] = _tmp33_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[33] = _tmp34_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[34] = _tmp35_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[35] = _tmp36_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[36] = _tmp37_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[37] = _tmp38_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[38] = _tmp39_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[39] = _tmp40_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[40] = _tmp41_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[41] = _tmp42_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[42] = _tmp43_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[43] = _tmp44_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[44] = _tmp45_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[45] = _tmp46_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[46] = _tmp47_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[47] = _tmp48_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[48] = _tmp49_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[49] = _tmp50_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[50] = _tmp51_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[51] = _tmp52_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[52] = _tmp53_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[53] = _tmp54_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[54] = _tmp55_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[55] = _tmp56_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[56] = _tmp57_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[57] = _tmp58_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[58] = _tmp59_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[59] = _tmp60_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[60] = _tmp61_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[61] = _tmp62_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[62] = _tmp63_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[63] = _tmp64_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[64] = _tmp65_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[65] = _tmp66_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[66] = _tmp67_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[67] = _tmp68_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[68] = _tmp69_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[69] = _tmp70_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[70] = _tmp71_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[71] = _tmp72_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[72] = _tmp73_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[73] = _tmp74_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[74] = _tmp75_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[75] = _tmp76_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[76] = _tmp77_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[77] = _tmp78_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[78] = _tmp79_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[79] = _tmp80_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[80] = _tmp81_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[81] = _tmp82_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[82] = _tmp83_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[83] = _tmp84_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[84] = _tmp85_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[85] = _tmp86_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[86] = _tmp87_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[87] = _tmp88_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[88] = _tmp89_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[89] = _tmp90_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[90] = _tmp91_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[91] = _tmp92_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[92] = _tmp93_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[93] = _tmp94_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[94] = _tmp95_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[95] = _tmp96_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[96] = _tmp97_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[97] = _tmp98_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[98] = _tmp99_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[99] = _tmp100_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[100] = _tmp101_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[101] = _tmp102_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[102] = _tmp103_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[103] = _tmp104_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[104] = _tmp105_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[105] = _tmp106_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[106] = _tmp107_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp109_[107] = _tmp108_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	mappings = _tmp109_;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	mappings_length1 = 108;
#line 412 "../src/engine/imap/transport/imap-client-session.vala"
	_mappings_size_ = mappings_length1;
#line 532 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp110_ = geary_imap_client_session_machine_desc;
#line 532 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp111_ = geary_state_machine_new (_tmp110_, mappings, mappings_length1, _geary_imap_client_session_on_ignored_transition_geary_state_transition, self);
#line 532 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->priv->fsm);
#line 532 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->fsm = _tmp111_;
#line 537 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp112_ = self->priv->fsm;
#line 537 "../src/engine/imap/transport/imap-client-session.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp112_, G_TYPE_OBJECT, GObject), "notify::state", (GCallback) ___lambda49__g_object_notify, self, 0);
#line 408 "../src/engine/imap/transport/imap-client-session.vala"
	mappings = (_vala_array_free (mappings, mappings_length1, (GDestroyNotify) g_object_unref), NULL);
#line 408 "../src/engine/imap/transport/imap-client-session.vala"
	return self;
#line 3068 "imap-client-session.c"
}

GearyImapClientSession*
geary_imap_client_session_new (GearyEndpoint* imap_endpoint,
                               GearyImapQuirks* quirks)
{
#line 408 "../src/engine/imap/transport/imap-client-session.vala"
	return geary_imap_client_session_construct (GEARY_IMAP_TYPE_CLIENT_SESSION, imap_endpoint, quirks);
#line 3077 "imap-client-session.c"
}

/**
     * Returns the list of known personal mailbox namespaces.
     *
     * A personal namespace is a common prefix of a set of mailboxes
     * that belong to the currently authenticated account. It may
     * contain the account's Inbox and Sent mailboxes, for example.
     *
     * The list will be empty when the session is not in the
     * authenticated or selected states, it will contain at least one
     * after having successfully logged in.
     *
     * See [[https://tools.ietf.org/html/rfc2342|RFC 2342]] for more
     * information.
     */
GeeList*
geary_imap_client_session_get_personal_namespaces (GearyImapClientSession* self)
{
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
	GeeList* result;
#line 568 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), NULL);
#line 569 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = self->priv->personal_namespaces;
#line 569 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = gee_list_get_read_only_view (_tmp0_);
#line 569 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = _tmp1_;
#line 569 "../src/engine/imap/transport/imap-client-session.vala"
	result = _tmp2_;
#line 569 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 3113 "imap-client-session.c"
}

/**
     * Returns the list of known shared mailbox namespaces.
     *
     * A shared namespace is a common prefix of a set of mailboxes
     * that are normally accessible by multiple accounts on the
     * server, for example shared email mailboxes and NNTP news
     * mailboxes.
     *
     * The list will be empty when the session is not in the
     * authenticated or selected states, it will only be non-empty
     * after having successfully logged in and if the server supports
     * shared mailboxes.
     *
     * See [[https://tools.ietf.org/html/rfc2342|RFC 2342]] for more
     * information.
     */
GeeList*
geary_imap_client_session_get_shared_namespaces (GearyImapClientSession* self)
{
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
	GeeList* result;
#line 588 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), NULL);
#line 589 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = self->priv->shared_namespaces;
#line 589 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = gee_list_get_read_only_view (_tmp0_);
#line 589 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = _tmp1_;
#line 589 "../src/engine/imap/transport/imap-client-session.vala"
	result = _tmp2_;
#line 589 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 3151 "imap-client-session.c"
}

/**
     * Returns the list of known other-users mailbox namespaces.
     *
     * An other-user namespace is a common prefix of a set of
     * mailboxes that are the personal mailboxes of other accounts on
     * the server. These would not normally be accessible to the
     * currently authenticated account unless the account has
     * administration privileges.
     *
     * The list will be empty when the session is not in the
     * authenticated or selected states, it will only be non-empty
     * after having successfully logged in and if the server or
     * account supports accessing other account's mailboxes.
     *
     * See [[https://tools.ietf.org/html/rfc2342|RFC 2342]] for more
     * information.
     */
GeeList*
geary_imap_client_session_get_other_users_namespaces (GearyImapClientSession* self)
{
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
	GeeList* result;
#line 609 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), NULL);
#line 610 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = self->priv->user_namespaces;
#line 610 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = gee_list_get_read_only_view (_tmp0_);
#line 610 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = _tmp1_;
#line 610 "../src/engine/imap/transport/imap-client-session.vala"
	result = _tmp2_;
#line 610 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 3190 "imap-client-session.c"
}

/**
     * Determines the SELECT-able mailbox name for a specific folder path.
     */
GearyImapMailboxSpecifier*
geary_imap_client_session_get_mailbox_for_path (GearyImapClientSession* self,
                                                GearyFolderPath* path,
                                                GError** error)
{
	gchar* delim = NULL;
	gchar* _tmp0_;
	GearyImapMailboxSpecifier* _tmp1_ = NULL;
	GearyImapMailboxInformation* _tmp2_;
	GearyImapMailboxSpecifier* _tmp3_;
	GearyImapMailboxSpecifier* _tmp4_;
	const gchar* _tmp5_;
	GearyImapMailboxSpecifier* _tmp6_;
	GearyImapMailboxSpecifier* _tmp7_;
	GError* _inner_error0_ = NULL;
	GearyImapMailboxSpecifier* result;
#line 616 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), NULL);
#line 616 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IS_FOLDER_PATH (path), NULL);
#line 618 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = geary_imap_client_session_get_delimiter_for_path (self, path, &_inner_error0_);
#line 618 "../src/engine/imap/transport/imap-client-session.vala"
	delim = _tmp0_;
#line 618 "../src/engine/imap/transport/imap-client-session.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 618 "../src/engine/imap/transport/imap-client-session.vala"
		if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 618 "../src/engine/imap/transport/imap-client-session.vala"
			g_propagate_error (error, _inner_error0_);
#line 618 "../src/engine/imap/transport/imap-client-session.vala"
			return NULL;
#line 3228 "imap-client-session.c"
		} else {
#line 618 "../src/engine/imap/transport/imap-client-session.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 618 "../src/engine/imap/transport/imap-client-session.vala"
			g_clear_error (&_inner_error0_);
#line 618 "../src/engine/imap/transport/imap-client-session.vala"
			return NULL;
#line 3236 "imap-client-session.c"
		}
	}
#line 619 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = self->priv->_inbox;
#line 619 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = geary_imap_mailbox_information_get_mailbox (_tmp2_);
#line 619 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp4_ = _tmp3_;
#line 619 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp5_ = delim;
#line 619 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp6_ = geary_imap_mailbox_specifier_new_from_folder_path (path, _tmp4_, _tmp5_, &_inner_error0_);
#line 619 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = _tmp6_;
#line 619 "../src/engine/imap/transport/imap-client-session.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 619 "../src/engine/imap/transport/imap-client-session.vala"
		if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 619 "../src/engine/imap/transport/imap-client-session.vala"
			g_propagate_error (error, _inner_error0_);
#line 619 "../src/engine/imap/transport/imap-client-session.vala"
			_g_free0 (delim);
#line 619 "../src/engine/imap/transport/imap-client-session.vala"
			return NULL;
#line 3261 "imap-client-session.c"
		} else {
#line 619 "../src/engine/imap/transport/imap-client-session.vala"
			_g_free0 (delim);
#line 619 "../src/engine/imap/transport/imap-client-session.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 619 "../src/engine/imap/transport/imap-client-session.vala"
			g_clear_error (&_inner_error0_);
#line 619 "../src/engine/imap/transport/imap-client-session.vala"
			return NULL;
#line 3271 "imap-client-session.c"
		}
	}
#line 619 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp7_ = _tmp1_;
#line 619 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = NULL;
#line 619 "../src/engine/imap/transport/imap-client-session.vala"
	result = _tmp7_;
#line 619 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_tmp1_);
#line 619 "../src/engine/imap/transport/imap-client-session.vala"
	_g_free0 (delim);
#line 619 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 3286 "imap-client-session.c"
}

/**
     * Determines the folder path for a mailbox name.
     */
GearyFolderPath*
geary_imap_client_session_get_path_for_mailbox (GearyImapClientSession* self,
                                                GearyImapFolderRoot* root,
                                                GearyImapMailboxSpecifier* mailbox,
                                                GError** error)
{
	gchar* delim = NULL;
	gchar* _tmp0_;
	GearyImapMailboxInformation* _tmp1_;
	GearyImapMailboxSpecifier* _tmp2_;
	GearyImapMailboxSpecifier* _tmp3_;
	GearyFolderPath* _tmp4_;
	GError* _inner_error0_ = NULL;
	GearyFolderPath* result;
#line 625 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), NULL);
#line 625 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_FOLDER_ROOT (root), NULL);
#line 625 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_MAILBOX_SPECIFIER (mailbox), NULL);
#line 628 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = geary_imap_client_session_get_delimiter_for_mailbox (self, mailbox, &_inner_error0_);
#line 628 "../src/engine/imap/transport/imap-client-session.vala"
	delim = _tmp0_;
#line 628 "../src/engine/imap/transport/imap-client-session.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 628 "../src/engine/imap/transport/imap-client-session.vala"
		if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 628 "../src/engine/imap/transport/imap-client-session.vala"
			g_propagate_error (error, _inner_error0_);
#line 628 "../src/engine/imap/transport/imap-client-session.vala"
			return NULL;
#line 3324 "imap-client-session.c"
		} else {
#line 628 "../src/engine/imap/transport/imap-client-session.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 628 "../src/engine/imap/transport/imap-client-session.vala"
			g_clear_error (&_inner_error0_);
#line 628 "../src/engine/imap/transport/imap-client-session.vala"
			return NULL;
#line 3332 "imap-client-session.c"
		}
	}
#line 629 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = self->priv->_inbox;
#line 629 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = geary_imap_mailbox_information_get_mailbox (_tmp1_);
#line 629 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = _tmp2_;
#line 629 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp4_ = geary_imap_mailbox_specifier_to_folder_path (mailbox, root, delim, _tmp3_);
#line 629 "../src/engine/imap/transport/imap-client-session.vala"
	result = _tmp4_;
#line 629 "../src/engine/imap/transport/imap-client-session.vala"
	_g_free0 (delim);
#line 629 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 3349 "imap-client-session.c"
}

/**
     * Determines the mailbox hierarchy delimiter for a given folder path.
     *
     * The returned delimiter be null if a namespace (INBOX, personal,
     * etc) for the path does not exist, or if the namespace is flat.
     */
gchar*
geary_imap_client_session_get_delimiter_for_path (GearyImapClientSession* self,
                                                  GearyFolderPath* path,
                                                  GError** error)
{
	gchar* delim = NULL;
	GearyImapFolderRoot* root = NULL;
	GearyFolderRoot* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GearyImapFolderRoot* _tmp2_;
	GearyFolderPath* _tmp3_;
	GearyFolderPath* _tmp4_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 638 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), NULL);
#line 638 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IS_FOLDER_PATH (path), NULL);
#line 640 "../src/engine/imap/transport/imap-client-session.vala"
	delim = NULL;
#line 642 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = geary_folder_path_get_root (path);
#line 642 "../src/engine/imap/transport/imap-client-session.vala"
	root = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_IMAP_TYPE_FOLDER_ROOT, GearyImapFolderRoot);
#line 643 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = root;
#line 643 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = geary_imap_folder_root_get_inbox (_tmp2_);
#line 643 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp4_ = _tmp3_;
#line 643 "../src/engine/imap/transport/imap-client-session.vala"
	if (gee_hashable_equal_to (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_HASHABLE, GeeHashable), path)) {
#line 643 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp1_ = TRUE;
#line 3392 "imap-client-session.c"
	} else {
		GearyImapFolderRoot* _tmp5_;
		GearyFolderPath* _tmp6_;
		GearyFolderPath* _tmp7_;
#line 644 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp5_ = root;
#line 644 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp6_ = geary_imap_folder_root_get_inbox (_tmp5_);
#line 644 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp7_ = _tmp6_;
#line 644 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp1_ = geary_folder_path_is_descendant (_tmp7_, path);
#line 3405 "imap-client-session.c"
	}
#line 643 "../src/engine/imap/transport/imap-client-session.vala"
	if (_tmp1_) {
#line 3409 "imap-client-session.c"
		GearyImapMailboxInformation* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 645 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp8_ = self->priv->_inbox;
#line 645 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp9_ = geary_imap_mailbox_information_get_delim (_tmp8_);
#line 645 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp10_ = _tmp9_;
#line 645 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 645 "../src/engine/imap/transport/imap-client-session.vala"
		_g_free0 (delim);
#line 645 "../src/engine/imap/transport/imap-client-session.vala"
		delim = _tmp11_;
#line 3426 "imap-client-session.c"
	} else {
		GearyImapNamespace* ns = NULL;
		GearyFolderPath* search = NULL;
		GearyFolderPath* _tmp12_;
		GearyImapNamespace* _tmp25_;
		GearyImapNamespace* _tmp32_;
		const gchar* _tmp33_;
		const gchar* _tmp34_;
		gchar* _tmp35_;
#line 647 "../src/engine/imap/transport/imap-client-session.vala"
		ns = NULL;
#line 648 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp12_ = _g_object_ref0 (path);
#line 648 "../src/engine/imap/transport/imap-client-session.vala"
		search = _tmp12_;
#line 649 "../src/engine/imap/transport/imap-client-session.vala"
		while (TRUE) {
#line 3444 "imap-client-session.c"
			gboolean _tmp13_ = FALSE;
			GearyImapNamespace* _tmp14_;
			GeeMap* _tmp16_;
			GearyFolderPath* _tmp17_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			gpointer _tmp20_;
			GearyFolderPath* _tmp21_;
			GearyFolderPath* _tmp22_;
			GearyFolderPath* _tmp23_;
			GearyFolderPath* _tmp24_;
#line 649 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp14_ = ns;
#line 649 "../src/engine/imap/transport/imap-client-session.vala"
			if (_tmp14_ == NULL) {
#line 3460 "imap-client-session.c"
				GearyFolderPath* _tmp15_;
#line 649 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp15_ = search;
#line 649 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp13_ = _tmp15_ != NULL;
#line 3466 "imap-client-session.c"
			} else {
#line 649 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp13_ = FALSE;
#line 3470 "imap-client-session.c"
			}
#line 649 "../src/engine/imap/transport/imap-client-session.vala"
			if (!_tmp13_) {
#line 649 "../src/engine/imap/transport/imap-client-session.vala"
				break;
#line 3476 "imap-client-session.c"
			}
#line 650 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp16_ = self->priv->namespaces;
#line 650 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp17_ = search;
#line 650 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp18_ = geary_folder_path_get_name (_tmp17_);
#line 650 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp19_ = _tmp18_;
#line 650 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp20_ = gee_map_get (_tmp16_, _tmp19_);
#line 650 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (ns);
#line 650 "../src/engine/imap/transport/imap-client-session.vala"
			ns = (GearyImapNamespace*) _tmp20_;
#line 651 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp21_ = search;
#line 651 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp22_ = geary_folder_path_get_parent (_tmp21_);
#line 651 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp23_ = _tmp22_;
#line 651 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp24_ = _g_object_ref0 (_tmp23_);
#line 651 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (search);
#line 651 "../src/engine/imap/transport/imap-client-session.vala"
			search = _tmp24_;
#line 3504 "imap-client-session.c"
		}
#line 653 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp25_ = ns;
#line 653 "../src/engine/imap/transport/imap-client-session.vala"
		if (_tmp25_ == NULL) {
#line 3510 "imap-client-session.c"
			GeeList* _tmp26_;
			gboolean _tmp27_;
			gboolean _tmp28_;
			GeeList* _tmp30_;
			gpointer _tmp31_;
#line 655 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp26_ = self->priv->personal_namespaces;
#line 655 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp27_ = gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_COLLECTION, GeeCollection));
#line 655 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp28_ = _tmp27_;
#line 655 "../src/engine/imap/transport/imap-client-session.vala"
			if (_tmp28_) {
#line 3524 "imap-client-session.c"
				GError* _tmp29_;
#line 656 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp29_ = g_error_new_literal (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_UNAVAILABLE, "No personal namespace");
#line 656 "../src/engine/imap/transport/imap-client-session.vala"
				_inner_error0_ = _tmp29_;
#line 656 "../src/engine/imap/transport/imap-client-session.vala"
				if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 656 "../src/engine/imap/transport/imap-client-session.vala"
					g_propagate_error (error, _inner_error0_);
#line 656 "../src/engine/imap/transport/imap-client-session.vala"
					_g_object_unref0 (search);
#line 656 "../src/engine/imap/transport/imap-client-session.vala"
					_g_object_unref0 (ns);
#line 656 "../src/engine/imap/transport/imap-client-session.vala"
					_g_object_unref0 (root);
#line 656 "../src/engine/imap/transport/imap-client-session.vala"
					_g_free0 (delim);
#line 656 "../src/engine/imap/transport/imap-client-session.vala"
					return NULL;
#line 3544 "imap-client-session.c"
				} else {
#line 656 "../src/engine/imap/transport/imap-client-session.vala"
					_g_object_unref0 (search);
#line 656 "../src/engine/imap/transport/imap-client-session.vala"
					_g_object_unref0 (ns);
#line 656 "../src/engine/imap/transport/imap-client-session.vala"
					_g_object_unref0 (root);
#line 656 "../src/engine/imap/transport/imap-client-session.vala"
					_g_free0 (delim);
#line 656 "../src/engine/imap/transport/imap-client-session.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 656 "../src/engine/imap/transport/imap-client-session.vala"
					g_clear_error (&_inner_error0_);
#line 656 "../src/engine/imap/transport/imap-client-session.vala"
					return NULL;
#line 3560 "imap-client-session.c"
				}
			}
#line 658 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp30_ = self->priv->personal_namespaces;
#line 658 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp31_ = gee_list_get (_tmp30_, 0);
#line 658 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (ns);
#line 658 "../src/engine/imap/transport/imap-client-session.vala"
			ns = (GearyImapNamespace*) _tmp31_;
#line 3571 "imap-client-session.c"
		}
#line 661 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp32_ = ns;
#line 661 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp33_ = geary_imap_namespace_get_delim (_tmp32_);
#line 661 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp34_ = _tmp33_;
#line 661 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp35_ = g_strdup (_tmp34_);
#line 661 "../src/engine/imap/transport/imap-client-session.vala"
		_g_free0 (delim);
#line 661 "../src/engine/imap/transport/imap-client-session.vala"
		delim = _tmp35_;
#line 643 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (search);
#line 643 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (ns);
#line 3589 "imap-client-session.c"
	}
#line 663 "../src/engine/imap/transport/imap-client-session.vala"
	result = delim;
#line 663 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (root);
#line 663 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 3597 "imap-client-session.c"
}

/**
     * Determines the mailbox hierarchy delimiter for a given mailbox name.
     *
     * The returned delimiter be null if a namespace (INBOX, personal,
     * etc) for the mailbox does not exist, or if the namespace is flat.
     */
gchar*
geary_imap_client_session_get_delimiter_for_mailbox (GearyImapClientSession* self,
                                                     GearyImapMailboxSpecifier* mailbox,
                                                     GError** error)
{
	gchar* name = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* delim = NULL;
	gchar* inbox_name = NULL;
	GearyImapMailboxInformation* _tmp3_;
	GearyImapMailboxSpecifier* _tmp4_;
	GearyImapMailboxSpecifier* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* inbox_delim = NULL;
	GearyImapMailboxInformation* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gboolean _tmp13_ = FALSE;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* result;
#line 672 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), NULL);
#line 672 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_MAILBOX_SPECIFIER (mailbox), NULL);
#line 674 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = geary_imap_mailbox_specifier_get_name (mailbox);
#line 674 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = _tmp0_;
#line 674 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 674 "../src/engine/imap/transport/imap-client-session.vala"
	name = _tmp2_;
#line 675 "../src/engine/imap/transport/imap-client-session.vala"
	delim = NULL;
#line 677 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = self->priv->_inbox;
#line 677 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp4_ = geary_imap_mailbox_information_get_mailbox (_tmp3_);
#line 677 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp5_ = _tmp4_;
#line 677 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp6_ = geary_imap_mailbox_specifier_get_name (_tmp5_);
#line 677 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp7_ = _tmp6_;
#line 677 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 677 "../src/engine/imap/transport/imap-client-session.vala"
	inbox_name = _tmp8_;
#line 678 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp9_ = self->priv->_inbox;
#line 678 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp10_ = geary_imap_mailbox_information_get_delim (_tmp9_);
#line 678 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp11_ = _tmp10_;
#line 678 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 678 "../src/engine/imap/transport/imap-client-session.vala"
	inbox_delim = _tmp12_;
#line 679 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp14_ = inbox_name;
#line 679 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp15_ = name;
#line 679 "../src/engine/imap/transport/imap-client-session.vala"
	if (g_strcmp0 (_tmp14_, _tmp15_) == 0) {
#line 679 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp13_ = TRUE;
#line 3678 "imap-client-session.c"
	} else {
		gboolean _tmp16_ = FALSE;
		const gchar* _tmp17_;
#line 680 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp17_ = inbox_delim;
#line 680 "../src/engine/imap/transport/imap-client-session.vala"
		if (_tmp17_ != NULL) {
#line 3686 "imap-client-session.c"
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
#line 680 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp18_ = inbox_name;
#line 680 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp19_ = name;
#line 680 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp20_ = inbox_delim;
#line 680 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp21_ = g_strconcat (_tmp19_, _tmp20_, NULL);
#line 680 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp22_ = _tmp21_;
#line 680 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp16_ = g_str_has_prefix (_tmp18_, _tmp22_);
#line 680 "../src/engine/imap/transport/imap-client-session.vala"
			_g_free0 (_tmp22_);
#line 3706 "imap-client-session.c"
		} else {
#line 680 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp16_ = FALSE;
#line 3710 "imap-client-session.c"
		}
#line 680 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp13_ = _tmp16_;
#line 3714 "imap-client-session.c"
	}
#line 679 "../src/engine/imap/transport/imap-client-session.vala"
	if (_tmp13_) {
#line 3718 "imap-client-session.c"
		GearyImapMailboxInformation* _tmp23_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
#line 681 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp23_ = self->priv->_inbox;
#line 681 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp24_ = geary_imap_mailbox_information_get_delim (_tmp23_);
#line 681 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp25_ = _tmp24_;
#line 681 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp26_ = g_strdup (_tmp25_);
#line 681 "../src/engine/imap/transport/imap-client-session.vala"
		_g_free0 (delim);
#line 681 "../src/engine/imap/transport/imap-client-session.vala"
		delim = _tmp26_;
#line 3735 "imap-client-session.c"
	} else {
		{
			GeeIterator* _ns_it = NULL;
			GeeMap* _tmp27_;
			GeeCollection* _tmp28_;
			GeeCollection* _tmp29_;
			GeeCollection* _tmp30_;
			GeeIterator* _tmp31_;
			GeeIterator* _tmp32_;
#line 683 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp27_ = self->priv->namespaces;
#line 683 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp28_ = gee_map_get_values (_tmp27_);
#line 683 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp29_ = _tmp28_;
#line 683 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp30_ = _tmp29_;
#line 683 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp31_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GEE_TYPE_ITERABLE, GeeIterable));
#line 683 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp32_ = _tmp31_;
#line 683 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_tmp30_);
#line 683 "../src/engine/imap/transport/imap-client-session.vala"
			_ns_it = _tmp32_;
#line 683 "../src/engine/imap/transport/imap-client-session.vala"
			while (TRUE) {
#line 3763 "imap-client-session.c"
				GeeIterator* _tmp33_;
				GearyImapNamespace* ns = NULL;
				GeeIterator* _tmp34_;
				gpointer _tmp35_;
				const gchar* _tmp36_;
				GearyImapNamespace* _tmp37_;
				const gchar* _tmp38_;
				const gchar* _tmp39_;
#line 683 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp33_ = _ns_it;
#line 683 "../src/engine/imap/transport/imap-client-session.vala"
				if (!gee_iterator_next (_tmp33_)) {
#line 683 "../src/engine/imap/transport/imap-client-session.vala"
					break;
#line 3778 "imap-client-session.c"
				}
#line 683 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp34_ = _ns_it;
#line 683 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp35_ = gee_iterator_get (_tmp34_);
#line 683 "../src/engine/imap/transport/imap-client-session.vala"
				ns = (GearyImapNamespace*) _tmp35_;
#line 684 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp36_ = name;
#line 684 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp37_ = ns;
#line 684 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp38_ = geary_imap_namespace_get_prefix (_tmp37_);
#line 684 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp39_ = _tmp38_;
#line 684 "../src/engine/imap/transport/imap-client-session.vala"
				if (g_str_has_prefix (_tmp36_, _tmp39_)) {
#line 3796 "imap-client-session.c"
					GearyImapNamespace* _tmp40_;
					const gchar* _tmp41_;
					const gchar* _tmp42_;
					gchar* _tmp43_;
#line 685 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp40_ = ns;
#line 685 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp41_ = geary_imap_namespace_get_delim (_tmp40_);
#line 685 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp42_ = _tmp41_;
#line 685 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp43_ = g_strdup (_tmp42_);
#line 685 "../src/engine/imap/transport/imap-client-session.vala"
					_g_free0 (delim);
#line 685 "../src/engine/imap/transport/imap-client-session.vala"
					delim = _tmp43_;
#line 686 "../src/engine/imap/transport/imap-client-session.vala"
					_g_object_unref0 (ns);
#line 686 "../src/engine/imap/transport/imap-client-session.vala"
					break;
#line 3817 "imap-client-session.c"
				}
#line 683 "../src/engine/imap/transport/imap-client-session.vala"
				_g_object_unref0 (ns);
#line 3821 "imap-client-session.c"
			}
#line 683 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_ns_it);
#line 3825 "imap-client-session.c"
		}
	}
#line 690 "../src/engine/imap/transport/imap-client-session.vala"
	result = delim;
#line 690 "../src/engine/imap/transport/imap-client-session.vala"
	_g_free0 (inbox_delim);
#line 690 "../src/engine/imap/transport/imap-client-session.vala"
	_g_free0 (inbox_name);
#line 690 "../src/engine/imap/transport/imap-client-session.vala"
	_g_free0 (name);
#line 690 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 3838 "imap-client-session.c"
}

static gboolean
geary_imap_client_session_reserve_state_change_cmd (GearyImapClientSession* self,
                                                    GearyImapClientSessionMachineParams* params,
                                                    guint state,
                                                    guint event)
{
	gboolean _tmp0_ = FALSE;
	GearyImapCommand* _tmp1_;
	GearyImapCommand* _tmp10_;
	GearyImapCommand* _tmp11_;
	gboolean result;
#line 696 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), FALSE);
#line 696 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_CLIENT_SESSION_IS_MACHINE_PARAMS (params), FALSE);
#line 697 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = self->priv->state_change_cmd;
#line 697 "../src/engine/imap/transport/imap-client-session.vala"
	if (_tmp1_ != NULL) {
#line 697 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp0_ = TRUE;
#line 3862 "imap-client-session.c"
	} else {
		GearyImapCommand* _tmp2_;
#line 697 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp2_ = params->cmd;
#line 697 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 3869 "imap-client-session.c"
	}
#line 697 "../src/engine/imap/transport/imap-client-session.vala"
	if (_tmp0_) {
#line 3873 "imap-client-session.c"
		GearyStateMachine* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GearyStateMachine* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GError* _tmp9_;
#line 698 "../src/engine/imap/transport/imap-client-session.vala"
		params->proceed = FALSE;
#line 699 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp3_ = self->priv->fsm;
#line 699 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp4_ = geary_state_machine_get_event_string (_tmp3_, event);
#line 699 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp5_ = _tmp4_;
#line 699 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp6_ = self->priv->fsm;
#line 699 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp7_ = geary_state_machine_get_state_string (_tmp6_, state);
#line 699 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp8_ = _tmp7_;
#line 699 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp9_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_NOT_SUPPORTED, "Cannot perform operation %s while session is %s", _tmp5_, _tmp8_);
#line 699 "../src/engine/imap/transport/imap-client-session.vala"
		_g_error_free0 (params->err);
#line 699 "../src/engine/imap/transport/imap-client-session.vala"
		params->err = _tmp9_;
#line 699 "../src/engine/imap/transport/imap-client-session.vala"
		_g_free0 (_tmp8_);
#line 699 "../src/engine/imap/transport/imap-client-session.vala"
		_g_free0 (_tmp5_);
#line 702 "../src/engine/imap/transport/imap-client-session.vala"
		result = FALSE;
#line 702 "../src/engine/imap/transport/imap-client-session.vala"
		return result;
#line 3909 "imap-client-session.c"
	}
#line 705 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp10_ = params->cmd;
#line 705 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 705 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->priv->state_change_cmd);
#line 705 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->state_change_cmd = _tmp11_;
#line 706 "../src/engine/imap/transport/imap-client-session.vala"
	params->proceed = TRUE;
#line 708 "../src/engine/imap/transport/imap-client-session.vala"
	result = TRUE;
#line 708 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 3925 "imap-client-session.c"
}

static gboolean
geary_imap_client_session_validate_state_change_cmd (GearyImapClientSession* self,
                                                     GearyImapServerResponse* response,
                                                     GearyImapCommand** cmd)
{
	GearyImapCommand* _vala_cmd = NULL;
	GearyImapCommand* _tmp0_;
	GearyImapCommand* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GearyImapCommand* _tmp3_;
	gboolean result;
#line 713 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), FALSE);
#line 713 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_SERVER_RESPONSE (response), FALSE);
#line 714 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = self->priv->state_change_cmd;
#line 714 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 714 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_vala_cmd);
#line 714 "../src/engine/imap/transport/imap-client-session.vala"
	_vala_cmd = _tmp1_;
#line 716 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = self->priv->state_change_cmd;
#line 716 "../src/engine/imap/transport/imap-client-session.vala"
	if (_tmp3_ == NULL) {
#line 716 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp2_ = TRUE;
#line 3957 "imap-client-session.c"
	} else {
		GearyImapCommand* _tmp4_;
		GearyImapTag* _tmp5_;
		GearyImapTag* _tmp6_;
		GearyImapTag* _tmp7_;
		GearyImapTag* _tmp8_;
#line 716 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp4_ = self->priv->state_change_cmd;
#line 716 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp5_ = geary_imap_command_get_tag (_tmp4_);
#line 716 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp6_ = _tmp5_;
#line 716 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp7_ = geary_imap_server_response_get_tag (response);
#line 716 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp8_ = _tmp7_;
#line 716 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp2_ = !gee_hashable_equal_to (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_HASHABLE, GeeHashable), _tmp8_);
#line 3976 "imap-client-session.c"
	}
#line 716 "../src/engine/imap/transport/imap-client-session.vala"
	if (_tmp2_) {
#line 717 "../src/engine/imap/transport/imap-client-session.vala"
		result = FALSE;
#line 717 "../src/engine/imap/transport/imap-client-session.vala"
		if (cmd) {
#line 717 "../src/engine/imap/transport/imap-client-session.vala"
			*cmd = _vala_cmd;
#line 3986 "imap-client-session.c"
		} else {
#line 717 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_vala_cmd);
#line 3990 "imap-client-session.c"
		}
#line 717 "../src/engine/imap/transport/imap-client-session.vala"
		return result;
#line 3994 "imap-client-session.c"
	}
#line 719 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->priv->state_change_cmd);
#line 719 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->state_change_cmd = NULL;
#line 721 "../src/engine/imap/transport/imap-client-session.vala"
	result = TRUE;
#line 721 "../src/engine/imap/transport/imap-client-session.vala"
	if (cmd) {
#line 721 "../src/engine/imap/transport/imap-client-session.vala"
		*cmd = _vala_cmd;
#line 4006 "imap-client-session.c"
	} else {
#line 721 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_vala_cmd);
#line 4010 "imap-client-session.c"
	}
#line 721 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 4014 "imap-client-session.c"
}

static void
geary_imap_client_session_connect_async_data_free (gpointer _data)
{
	GearyImapClientSessionConnectAsyncData* _data_;
	_data_ = _data;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_slice_free (GearyImapClientSessionConnectAsyncData, _data_);
#line 4028 "imap-client-session.c"
}

void
geary_imap_client_session_connect_async (GearyImapClientSession* self,
                                         guint greeting_timeout_sec,
                                         GCancellable* cancellable,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	GearyImapClientSessionConnectAsyncData* _data_;
	GearyImapClientSession* _tmp0_;
	GCancellable* _tmp1_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_slice_new0 (GearyImapClientSessionConnectAsyncData);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_session_connect_async_data_free);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->self = _tmp0_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->greeting_timeout_sec = greeting_timeout_sec;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->cancellable = _tmp1_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_connect_async_co (_data_);
#line 4065 "imap-client-session.c"
}

void
geary_imap_client_session_connect_finish (GearyImapClientSession* self,
                                          GAsyncResult* _res_,
                                          GError** error)
{
	GearyImapClientSessionConnectAsyncData* _data_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	if (NULL == _data_) {
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		return;
#line 4080 "imap-client-session.c"
	}
}

/**
     * Connect to the server.
     *
     * This performs no transaction or session initiation with the
     * server.  See {@link login_async} and {@link
     * initiate_session_async} for next steps.
     *
     * If the connection fails (if this call throws an Error) the
     * ClientSession will be disconnected, even if the error was from
     * the server (that is, not a network problem).  The {@link
     * ClientSession} should be discarded.
     */
static gpointer
_g_error_copy0 (gpointer self)
{
#line 748 "../src/engine/imap/transport/imap-client-session.vala"
	return self ? g_error_copy (self) : NULL;
#line 4101 "imap-client-session.c"
}

static void
geary_imap_client_session_connect_async_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_)
{
	GearyImapClientSessionConnectAsyncData* _data_;
#line 758 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = _user_data_;
#line 758 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_source_object_ = source_object;
#line 758 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_res_ = _res_;
#line 758 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_connect_async_co (_data_);
#line 4118 "imap-client-session.c"
}

static gboolean
_geary_imap_client_session_on_greeting_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = geary_imap_client_session_on_greeting_timeout ((GearyImapClientSession*) self);
#line 766 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 4128 "imap-client-session.c"
}

static gboolean
geary_imap_client_session_connect_async_co (GearyImapClientSessionConnectAsyncData* _data_)
{
#line 740 "../src/engine/imap/transport/imap-client-session.vala"
	switch (_data_->_state_) {
#line 740 "../src/engine/imap/transport/imap-client-session.vala"
		case 0:
#line 4138 "imap-client-session.c"
		goto _state_0;
#line 740 "../src/engine/imap/transport/imap-client-session.vala"
		case 1:
#line 4142 "imap-client-session.c"
		goto _state_1;
#line 740 "../src/engine/imap/transport/imap-client-session.vala"
		case 2:
#line 4146 "imap-client-session.c"
		goto _state_2;
#line 740 "../src/engine/imap/transport/imap-client-session.vala"
		case 3:
#line 4150 "imap-client-session.c"
		goto _state_3;
		default:
#line 740 "../src/engine/imap/transport/imap-client-session.vala"
		g_assert_not_reached ();
#line 4155 "imap-client-session.c"
	}
	_state_0:
#line 744 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp0_ = geary_imap_client_session_machine_params_new (NULL);
#line 744 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->params = _data_->_tmp0_;
#line 745 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp1_ = _data_->self->priv->fsm;
#line 745 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp2_ = _data_->params;
#line 745 "../src/engine/imap/transport/imap-client-session.vala"
	geary_state_machine_issue (_data_->_tmp1_, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_CONNECT, NULL, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, G_TYPE_OBJECT, GObject), NULL);
#line 747 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp3_ = _data_->params;
#line 747 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp4_ = _data_->_tmp3_->err;
#line 747 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_tmp4_ != NULL) {
#line 748 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp5_ = _data_->params;
#line 748 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp6_ = _data_->_tmp5_->err;
#line 748 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp7_ = _g_error_copy0 (_data_->_tmp6_);
#line 748 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_inner_error0_ = _data_->_tmp7_;
#line 748 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 748 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->params);
#line 748 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 748 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 4190 "imap-client-session.c"
	}
#line 750 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp8_ = _data_->params;
#line 750 "../src/engine/imap/transport/imap-client-session.vala"
	_vala_assert (_data_->_tmp8_->proceed, "params.proceed");
#line 753 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp9_ = _data_->self->priv->cx;
#line 753 "../src/engine/imap/transport/imap-client-session.vala"
	_vala_assert (_data_->_tmp9_ != NULL, "cx != null");
#line 754 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp10_ = _data_->self->priv->connect_waiter;
#line 754 "../src/engine/imap/transport/imap-client-session.vala"
	_vala_assert (_data_->_tmp10_ != NULL, "connect_waiter != null");
#line 4204 "imap-client-session.c"
	{
#line 758 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp11_ = _data_->self->priv->cx;
#line 758 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_state_ = 1;
#line 758 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_connection_connect_async (_data_->_tmp11_, _data_->cancellable, geary_imap_client_session_connect_async_ready, _data_);
#line 758 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 4214 "imap-client-session.c"
		_state_1:
#line 758 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_connection_connect_finish (_data_->_tmp11_, _data_->_res_, &_data_->_inner_error0_);
#line 758 "../src/engine/imap/transport/imap-client-session.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 4220 "imap-client-session.c"
			goto __catch0_g_error;
		}
#line 759 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp12_ = _data_->self->priv->fsm;
#line 759 "../src/engine/imap/transport/imap-client-session.vala"
		geary_state_machine_issue (_data_->_tmp12_, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_CONNECTED, NULL, NULL, NULL);
#line 4227 "imap-client-session.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 757 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->err = _data_->_inner_error0_;
#line 757 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_inner_error0_ = NULL;
#line 761 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp13_ = _data_->self->priv->fsm;
#line 761 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp14_ = _data_->err;
#line 761 "../src/engine/imap/transport/imap-client-session.vala"
		geary_state_machine_issue (_data_->_tmp13_, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_ERROR, NULL, NULL, _data_->_tmp14_);
#line 762 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp15_ = _data_->err;
#line 762 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp16_ = _g_error_copy0 (_data_->_tmp15_);
#line 762 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_inner_error0_ = _data_->_tmp16_;
#line 762 "../src/engine/imap/transport/imap-client-session.vala"
		_g_error_free0 (_data_->err);
#line 4250 "imap-client-session.c"
		goto __finally0;
	}
	__finally0:
#line 757 "../src/engine/imap/transport/imap-client-session.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 757 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 757 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->params);
#line 757 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 757 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 4264 "imap-client-session.c"
	}
#line 766 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp17_ = geary_scheduler_after_sec (_data_->greeting_timeout_sec, _geary_imap_client_session_on_greeting_timeout_gsource_func, _data_->self, G_PRIORITY_DEFAULT);
#line 766 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->timeout = _data_->_tmp17_;
#line 4270 "imap-client-session.c"
	{
#line 774 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp18_ = _data_->self->priv->connect_waiter;
#line 774 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_state_ = 2;
#line 774 "../src/engine/imap/transport/imap-client-session.vala"
		geary_nonblocking_lock_wait_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp18_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock), _data_->cancellable, geary_imap_client_session_connect_async_ready, _data_);
#line 774 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 4280 "imap-client-session.c"
		_state_2:
#line 774 "../src/engine/imap/transport/imap-client-session.vala"
		geary_nonblocking_lock_wait_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp18_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock), _data_->_res_, &_data_->_inner_error0_);
#line 774 "../src/engine/imap/transport/imap-client-session.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 774 "../src/engine/imap/transport/imap-client-session.vala"
			if (g_error_matches (_data_->_inner_error0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 4288 "imap-client-session.c"
				goto __catch1_g_io_error_cancelled;
			}
			goto __finally1;
		}
	}
	goto __finally1;
	__catch1_g_io_error_cancelled:
	{
#line 773 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_vala1_err = _data_->_inner_error0_;
#line 773 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_inner_error0_ = NULL;
#line 776 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp19_ = _data_->_vala1_err;
#line 776 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp20_ = _g_error_copy0 (_data_->_tmp19_);
#line 776 "../src/engine/imap/transport/imap-client-session.vala"
		_g_error_free0 (_data_->self->priv->connect_err);
#line 776 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->self->priv->connect_err = _data_->_tmp20_;
#line 773 "../src/engine/imap/transport/imap-client-session.vala"
		_g_error_free0 (_data_->_vala1_err);
#line 4311 "imap-client-session.c"
	}
	__finally1:
#line 773 "../src/engine/imap/transport/imap-client-session.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 773 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 773 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->timeout);
#line 773 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->params);
#line 773 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 773 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 4326 "imap-client-session.c"
	}
#line 780 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp21_ = _data_->timeout;
#line 780 "../src/engine/imap/transport/imap-client-session.vala"
	geary_scheduler_scheduled_cancel (_data_->_tmp21_);
#line 785 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp22_ = _data_->self->priv->connect_err;
#line 785 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_tmp22_ != NULL) {
#line 4336 "imap-client-session.c"
		{
#line 787 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_state_ = 3;
#line 787 "../src/engine/imap/transport/imap-client-session.vala"
			geary_imap_client_session_disconnect_async (_data_->self, _data_->cancellable, geary_imap_client_session_connect_async_ready, _data_);
#line 787 "../src/engine/imap/transport/imap-client-session.vala"
			return FALSE;
#line 4344 "imap-client-session.c"
			_state_3:
#line 787 "../src/engine/imap/transport/imap-client-session.vala"
			geary_imap_client_session_disconnect_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 787 "../src/engine/imap/transport/imap-client-session.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 4350 "imap-client-session.c"
				goto __catch2_g_error;
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
#line 786 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_vala2_err = _data_->_inner_error0_;
#line 786 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_inner_error0_ = NULL;
#line 789 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp23_ = _data_->_vala2_err;
#line 789 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp24_ = _data_->_tmp23_->message;
#line 789 "../src/engine/imap/transport/imap-client-session.vala"
			geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Error disconnecting after a failed connect attempt: %s", _data_->_tmp24_);
#line 786 "../src/engine/imap/transport/imap-client-session.vala"
			_g_error_free0 (_data_->_vala2_err);
#line 4369 "imap-client-session.c"
		}
		__finally2:
#line 786 "../src/engine/imap/transport/imap-client-session.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 786 "../src/engine/imap/transport/imap-client-session.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 786 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->timeout);
#line 786 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->params);
#line 786 "../src/engine/imap/transport/imap-client-session.vala"
			g_object_unref (_data_->_async_result);
#line 786 "../src/engine/imap/transport/imap-client-session.vala"
			return FALSE;
#line 4384 "imap-client-session.c"
		}
#line 795 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp25_ = _data_->self->priv->connect_err;
#line 795 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp26_ = _g_error_copy0 (_data_->_tmp25_);
#line 795 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_inner_error0_ = _data_->_tmp26_;
#line 795 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 795 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->timeout);
#line 795 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->params);
#line 795 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 795 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 4402 "imap-client-session.c"
	}
#line 740 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->timeout);
#line 740 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->params);
#line 740 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 740 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_state_ != 0) {
#line 740 "../src/engine/imap/transport/imap-client-session.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 740 "../src/engine/imap/transport/imap-client-session.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4416 "imap-client-session.c"
		}
	}
#line 740 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_unref (_data_->_async_result);
#line 740 "../src/engine/imap/transport/imap-client-session.vala"
	return FALSE;
#line 4423 "imap-client-session.c"
}

static gboolean
geary_imap_client_session_on_greeting_timeout (GearyImapClientSession* self)
{
	GearyStateMachine* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	gboolean result;
#line 799 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), FALSE);
#line 801 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = self->priv->fsm;
#line 801 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = geary_state_machine_get_state (_tmp0_);
#line 801 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = _tmp1_;
#line 801 "../src/engine/imap/transport/imap-client-session.vala"
	if (_tmp2_ == ((guint) GEARY_IMAP_CLIENT_SESSION_STATE_CONNECTING)) {
#line 4443 "imap-client-session.c"
		GearyStateMachine* _tmp3_;
#line 802 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp3_ = self->priv->fsm;
#line 802 "../src/engine/imap/transport/imap-client-session.vala"
		geary_state_machine_issue (_tmp3_, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_TIMEOUT, NULL, NULL, NULL);
#line 4449 "imap-client-session.c"
	}
#line 804 "../src/engine/imap/transport/imap-client-session.vala"
	result = FALSE;
#line 804 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 4455 "imap-client-session.c"
}

static void
_geary_imap_client_session_on_network_send_error_geary_imap_client_connection_send_failure (GearyImapClientConnection* _sender,
                                                                                            GError* err,
                                                                                            gpointer self)
{
#line 813 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_on_network_send_error ((GearyImapClientSession*) self, err);
#line 4465 "imap-client-session.c"
}

static void
_geary_imap_client_session_on_received_status_response_geary_imap_client_connection_received_status_response (GearyImapClientConnection* _sender,
                                                                                                              GearyImapStatusResponse* status_response,
                                                                                                              gpointer self)
{
#line 814 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_on_received_status_response ((GearyImapClientSession*) self, status_response);
#line 4475 "imap-client-session.c"
}

static void
_geary_imap_client_session_on_received_server_data_geary_imap_client_connection_received_server_data (GearyImapClientConnection* _sender,
                                                                                                      GearyImapServerData* server_data,
                                                                                                      gpointer self)
{
#line 815 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_on_received_server_data ((GearyImapClientSession*) self, server_data);
#line 4485 "imap-client-session.c"
}

static void
_geary_imap_client_session_on_received_bytes_geary_imap_client_connection_received_bytes (GearyImapClientConnection* _sender,
                                                                                          gsize bytes,
                                                                                          gpointer self)
{
#line 816 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_on_received_bytes ((GearyImapClientSession*) self);
#line 4495 "imap-client-session.c"
}

static void
_geary_imap_client_session_on_received_bad_response_geary_imap_client_connection_received_bad_response (GearyImapClientConnection* _sender,
                                                                                                        GearyImapRootParameters* root,
                                                                                                        GError* err,
                                                                                                        gpointer self)
{
#line 817 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_on_received_bad_response ((GearyImapClientSession*) self, root, err);
#line 4506 "imap-client-session.c"
}

static void
_geary_imap_client_session_on_network_receive_failure_geary_imap_client_connection_receive_failure (GearyImapClientConnection* _sender,
                                                                                                    GError* err,
                                                                                                    gpointer self)
{
#line 818 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_on_network_receive_failure ((GearyImapClientSession*) self, err);
#line 4516 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_connect (GearyImapClientSession* self,
                                      guint state,
                                      guint event,
                                      void* user,
                                      GObject* object)
{
	GearyImapClientSessionMachineParams* params = NULL;
	GearyImapClientSessionMachineParams* _tmp0_;
	GearyImapClientConnection* _tmp1_;
	GearyEndpoint* _tmp2_;
	GearyImapQuirks* _tmp3_;
	GearyImapClientConnection* _tmp4_;
	GearyImapClientConnection* _tmp5_;
	GearyImapClientConnection* _tmp6_;
	GearyImapClientConnection* _tmp7_;
	GearyImapClientConnection* _tmp8_;
	GearyImapClientConnection* _tmp9_;
	GearyImapClientConnection* _tmp10_;
	GearyImapClientConnection* _tmp11_;
	GearyNonblockingSemaphore* _tmp12_;
	GearyNonblockingSemaphore* _tmp13_;
	guint result;
#line 807 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 807 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 808 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_CLIENT_SESSION_TYPE_MACHINE_PARAMS, GearyImapClientSessionMachineParams));
#line 808 "../src/engine/imap/transport/imap-client-session.vala"
	params = _tmp0_;
#line 810 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = self->priv->cx;
#line 810 "../src/engine/imap/transport/imap-client-session.vala"
	_vala_assert (_tmp1_ == NULL, "cx == null");
#line 811 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = self->priv->imap_endpoint;
#line 811 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = self->priv->_quirks;
#line 811 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp4_ = geary_imap_client_connection_new (_tmp2_, _tmp3_, GEARY_IMAP_COMMAND_DEFAULT_RESPONSE_TIMEOUT_SEC, GEARY_IMAP_CLIENT_CONNECTION_DEFAULT_IDLE_TIMEOUT_SEC);
#line 811 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->priv->cx);
#line 811 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->cx = _tmp4_;
#line 812 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp5_ = self->priv->cx;
#line 812 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_connection_set_logging_parent (_tmp5_, G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 813 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp6_ = self->priv->cx;
#line 813 "../src/engine/imap/transport/imap-client-session.vala"
	g_signal_connect_object (_tmp6_, "send-failure", (GCallback) _geary_imap_client_session_on_network_send_error_geary_imap_client_connection_send_failure, self, 0);
#line 814 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp7_ = self->priv->cx;
#line 814 "../src/engine/imap/transport/imap-client-session.vala"
	g_signal_connect_object (_tmp7_, "received-status-response", (GCallback) _geary_imap_client_session_on_received_status_response_geary_imap_client_connection_received_status_response, self, 0);
#line 815 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp8_ = self->priv->cx;
#line 815 "../src/engine/imap/transport/imap-client-session.vala"
	g_signal_connect_object (_tmp8_, "received-server-data", (GCallback) _geary_imap_client_session_on_received_server_data_geary_imap_client_connection_received_server_data, self, 0);
#line 816 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp9_ = self->priv->cx;
#line 816 "../src/engine/imap/transport/imap-client-session.vala"
	g_signal_connect_object (_tmp9_, "received-bytes", (GCallback) _geary_imap_client_session_on_received_bytes_geary_imap_client_connection_received_bytes, self, 0);
#line 817 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp10_ = self->priv->cx;
#line 817 "../src/engine/imap/transport/imap-client-session.vala"
	g_signal_connect_object (_tmp10_, "received-bad-response", (GCallback) _geary_imap_client_session_on_received_bad_response_geary_imap_client_connection_received_bad_response, self, 0);
#line 818 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp11_ = self->priv->cx;
#line 818 "../src/engine/imap/transport/imap-client-session.vala"
	g_signal_connect_object (_tmp11_, "receive-failure", (GCallback) _geary_imap_client_session_on_network_receive_failure_geary_imap_client_connection_receive_failure, self, 0);
#line 820 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp12_ = self->priv->connect_waiter;
#line 820 "../src/engine/imap/transport/imap-client-session.vala"
	_vala_assert (_tmp12_ == NULL, "connect_waiter == null");
#line 821 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp13_ = geary_nonblocking_semaphore_new (NULL);
#line 821 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->priv->connect_waiter);
#line 821 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->connect_waiter = _tmp13_;
#line 823 "../src/engine/imap/transport/imap-client-session.vala"
	params->proceed = TRUE;
#line 825 "../src/engine/imap/transport/imap-client-session.vala"
	result = (guint) GEARY_IMAP_CLIENT_SESSION_STATE_CONNECTING;
#line 825 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (params);
#line 825 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 4610 "imap-client-session.c"
}

static void
geary_imap_client_session_drop_connection (GearyImapClientSession* self)
{
	GearyImapClientConnection* _tmp0_;
#line 828 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 829 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_unschedule_keepalive (self);
#line 831 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = self->priv->cx;
#line 831 "../src/engine/imap/transport/imap-client-session.vala"
	if (_tmp0_ != NULL) {
#line 4625 "imap-client-session.c"
		GearyImapClientConnection* _tmp1_;
		guint _tmp2_;
		GearyImapClientConnection* _tmp3_;
		guint _tmp4_;
		GearyImapClientConnection* _tmp5_;
		guint _tmp6_;
		GearyImapClientConnection* _tmp7_;
		guint _tmp8_;
		GearyImapClientConnection* _tmp9_;
		guint _tmp10_;
#line 832 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp1_ = self->priv->cx;
#line 832 "../src/engine/imap/transport/imap-client-session.vala"
		g_signal_parse_name ("received-status-response", GEARY_IMAP_TYPE_CLIENT_CONNECTION, &_tmp2_, NULL, FALSE);
#line 832 "../src/engine/imap/transport/imap-client-session.vala"
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _geary_imap_client_session_on_received_status_response_geary_imap_client_connection_received_status_response, self);
#line 833 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp3_ = self->priv->cx;
#line 833 "../src/engine/imap/transport/imap-client-session.vala"
		g_signal_parse_name ("received-server-data", GEARY_IMAP_TYPE_CLIENT_CONNECTION, &_tmp4_, NULL, FALSE);
#line 833 "../src/engine/imap/transport/imap-client-session.vala"
		g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _geary_imap_client_session_on_received_server_data_geary_imap_client_connection_received_server_data, self);
#line 834 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp5_ = self->priv->cx;
#line 834 "../src/engine/imap/transport/imap-client-session.vala"
		g_signal_parse_name ("received-bytes", GEARY_IMAP_TYPE_CLIENT_CONNECTION, &_tmp6_, NULL, FALSE);
#line 834 "../src/engine/imap/transport/imap-client-session.vala"
		g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _geary_imap_client_session_on_received_bytes_geary_imap_client_connection_received_bytes, self);
#line 835 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp7_ = self->priv->cx;
#line 835 "../src/engine/imap/transport/imap-client-session.vala"
		g_signal_parse_name ("received-bad-response", GEARY_IMAP_TYPE_CLIENT_CONNECTION, &_tmp8_, NULL, FALSE);
#line 835 "../src/engine/imap/transport/imap-client-session.vala"
		g_signal_handlers_disconnect_matched (_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _geary_imap_client_session_on_received_bad_response_geary_imap_client_connection_received_bad_response, self);
#line 836 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp9_ = self->priv->cx;
#line 836 "../src/engine/imap/transport/imap-client-session.vala"
		g_signal_parse_name ("receive-failure", GEARY_IMAP_TYPE_CLIENT_CONNECTION, &_tmp10_, NULL, FALSE);
#line 836 "../src/engine/imap/transport/imap-client-session.vala"
		g_signal_handlers_disconnect_matched (_tmp9_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _geary_imap_client_session_on_network_receive_failure_geary_imap_client_connection_receive_failure, self);
#line 838 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (self->priv->cx);
#line 838 "../src/engine/imap/transport/imap-client-session.vala"
		self->priv->cx = NULL;
#line 4670 "imap-client-session.c"
	}
}

static guint
geary_imap_client_session_on_connected (GearyImapClientSession* self,
                                        guint state,
                                        guint event)
{
	GearyEndpoint* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	guint result;
#line 842 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 843 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = self->priv->imap_endpoint;
#line 843 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = geary_endpoint_to_string (_tmp0_);
#line 843 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = _tmp1_;
#line 843 "../src/engine/imap/transport/imap-client-session.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Connected to %s", _tmp2_);
#line 843 "../src/engine/imap/transport/imap-client-session.vala"
	_g_free0 (_tmp2_);
#line 847 "../src/engine/imap/transport/imap-client-session.vala"
	result = state;
#line 847 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 4699 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_disconnect (GearyImapClientSession* self,
                                         guint state,
                                         guint event,
                                         void* user,
                                         GObject* object,
                                         GError* err)
{
	GearyEndpoint* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GearyImapClientSessionMachineParams* params = NULL;
	GearyImapClientSessionMachineParams* _tmp3_;
	guint result;
#line 850 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 850 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 855 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = self->priv->imap_endpoint;
#line 855 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = geary_endpoint_to_string (_tmp0_);
#line 855 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = _tmp1_;
#line 855 "../src/engine/imap/transport/imap-client-session.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Disconnected from %s", _tmp2_);
#line 855 "../src/engine/imap/transport/imap-client-session.vala"
	_g_free0 (_tmp2_);
#line 856 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_CLIENT_SESSION_TYPE_MACHINE_PARAMS, GearyImapClientSessionMachineParams));
#line 856 "../src/engine/imap/transport/imap-client-session.vala"
	params = _tmp3_;
#line 857 "../src/engine/imap/transport/imap-client-session.vala"
	params->proceed = TRUE;
#line 858 "../src/engine/imap/transport/imap-client-session.vala"
	result = (guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSED;
#line 858 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (params);
#line 858 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 4742 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_connecting_recv_status (GearyImapClientSession* self,
                                                     guint state,
                                                     guint event,
                                                     void* user,
                                                     GObject* object)
{
	GearyImapStatusResponse* status_response = NULL;
	GearyImapStatusResponse* _tmp0_;
	guint new_state = 0U;
	GearyImapStatusResponse* _tmp1_;
	GearyImapStatus _tmp2_;
	GearyImapStatus _tmp3_;
	GearyImapStatusResponse* _tmp8_;
	GearyImapStatusResponse* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GError* _inner_error0_ = NULL;
	guint result;
#line 861 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 861 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 862 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_TYPE_STATUS_RESPONSE, GearyImapStatusResponse));
#line 862 "../src/engine/imap/transport/imap-client-session.vala"
	status_response = _tmp0_;
#line 864 "../src/engine/imap/transport/imap-client-session.vala"
	new_state = (guint) GEARY_IMAP_CLIENT_SESSION_STATE_NOAUTH;
#line 865 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = status_response;
#line 865 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = geary_imap_status_response_get_status (_tmp1_);
#line 865 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = _tmp2_;
#line 865 "../src/engine/imap/transport/imap-client-session.vala"
	if (_tmp3_ != GEARY_IMAP_STATUS_OK) {
#line 4782 "imap-client-session.c"
		GearyImapStatusResponse* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GError* _tmp7_;
#line 868 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp4_ = status_response;
#line 868 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp5_ = geary_imap_status_response_get_text (_tmp4_);
#line 868 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp6_ = _tmp5_;
#line 868 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp7_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_UNAVAILABLE, "Session denied: %s", _tmp6_);
#line 868 "../src/engine/imap/transport/imap-client-session.vala"
		_g_error_free0 (self->priv->connect_err);
#line 868 "../src/engine/imap/transport/imap-client-session.vala"
		self->priv->connect_err = _tmp7_;
#line 868 "../src/engine/imap/transport/imap-client-session.vala"
		_g_free0 (_tmp6_);
#line 871 "../src/engine/imap/transport/imap-client-session.vala"
		new_state = (guint) GEARY_IMAP_CLIENT_SESSION_STATE_LOGOUT;
#line 4803 "imap-client-session.c"
	}
#line 874 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp8_ = status_response;
#line 874 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_set_server_greeting (self, _tmp8_);
#line 875 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp9_ = status_response;
#line 875 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp10_ = geary_imap_status_response_get_text (_tmp9_);
#line 875 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp11_ = _tmp10_;
#line 875 "../src/engine/imap/transport/imap-client-session.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Server greeting: %s", _tmp11_);
#line 875 "../src/engine/imap/transport/imap-client-session.vala"
	_g_free0 (_tmp11_);
#line 4819 "imap-client-session.c"
	{
		GearyNonblockingSemaphore* _tmp12_;
#line 878 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp12_ = self->priv->connect_waiter;
#line 878 "../src/engine/imap/transport/imap-client-session.vala"
		geary_nonblocking_lock_notify (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock), &_inner_error0_);
#line 878 "../src/engine/imap/transport/imap-client-session.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4828 "imap-client-session.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 877 "../src/engine/imap/transport/imap-client-session.vala"
		err = _inner_error0_;
#line 877 "../src/engine/imap/transport/imap-client-session.vala"
		_inner_error0_ = NULL;
#line 880 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp13_ = err;
#line 880 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp14_ = _tmp13_->message;
#line 880 "../src/engine/imap/transport/imap-client-session.vala"
		geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Unable to notify connect_waiter of connection: %s", _tmp14_);
#line 877 "../src/engine/imap/transport/imap-client-session.vala"
		_g_error_free0 (err);
#line 4850 "imap-client-session.c"
	}
	__finally0:
#line 877 "../src/engine/imap/transport/imap-client-session.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4855 "imap-client-session.c"
		guint _tmp15_ = 0U;
#line 877 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (status_response);
#line 877 "../src/engine/imap/transport/imap-client-session.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 877 "../src/engine/imap/transport/imap-client-session.vala"
		g_clear_error (&_inner_error0_);
#line 877 "../src/engine/imap/transport/imap-client-session.vala"
		return _tmp15_;
#line 4865 "imap-client-session.c"
	}
#line 886 "../src/engine/imap/transport/imap-client-session.vala"
	result = new_state;
#line 886 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (status_response);
#line 886 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 4873 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_connecting_timeout (GearyImapClientSession* self,
                                                 guint state,
                                                 guint event)
{
	GError* _tmp0_;
	GError* _inner_error0_ = NULL;
	guint result;
#line 889 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 892 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_TIMED_OUT, "Session greeting not sent");
#line 892 "../src/engine/imap/transport/imap-client-session.vala"
	_g_error_free0 (self->priv->connect_err);
#line 892 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->connect_err = _tmp0_;
#line 4892 "imap-client-session.c"
	{
		GearyNonblockingSemaphore* _tmp1_;
#line 897 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp1_ = self->priv->connect_waiter;
#line 897 "../src/engine/imap/transport/imap-client-session.vala"
		geary_nonblocking_lock_notify (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock), &_inner_error0_);
#line 897 "../src/engine/imap/transport/imap-client-session.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4901 "imap-client-session.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 896 "../src/engine/imap/transport/imap-client-session.vala"
		err = _inner_error0_;
#line 896 "../src/engine/imap/transport/imap-client-session.vala"
		_inner_error0_ = NULL;
#line 899 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp2_ = err;
#line 899 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp3_ = _tmp2_->message;
#line 899 "../src/engine/imap/transport/imap-client-session.vala"
		geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Unable to notify connect_waiter of timeout: %s", _tmp3_);
#line 896 "../src/engine/imap/transport/imap-client-session.vala"
		_g_error_free0 (err);
#line 4923 "imap-client-session.c"
	}
	__finally0:
#line 896 "../src/engine/imap/transport/imap-client-session.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4928 "imap-client-session.c"
		guint _tmp4_ = 0U;
#line 896 "../src/engine/imap/transport/imap-client-session.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 896 "../src/engine/imap/transport/imap-client-session.vala"
		g_clear_error (&_inner_error0_);
#line 896 "../src/engine/imap/transport/imap-client-session.vala"
		return _tmp4_;
#line 4936 "imap-client-session.c"
	}
#line 904 "../src/engine/imap/transport/imap-client-session.vala"
	result = (guint) GEARY_IMAP_CLIENT_SESSION_STATE_LOGOUT;
#line 904 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 4942 "imap-client-session.c"
}

static void
geary_imap_client_session_login_async_data_free (gpointer _data)
{
	GearyImapClientSessionLoginAsyncData* _data_;
	_data_ = _data;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->credentials);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->result);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_slice_free (GearyImapClientSessionLoginAsyncData, _data_);
#line 4960 "imap-client-session.c"
}

void
geary_imap_client_session_login_async (GearyImapClientSession* self,
                                       GearyCredentials* credentials,
                                       GCancellable* cancellable,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	GearyImapClientSessionLoginAsyncData* _data_;
	GearyImapClientSession* _tmp0_;
	GearyCredentials* _tmp1_;
	GCancellable* _tmp2_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IS_CREDENTIALS (credentials));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_slice_new0 (GearyImapClientSessionLoginAsyncData);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_session_login_async_data_free);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->self = _tmp0_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = _g_object_ref0 (credentials);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->credentials);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->credentials = _tmp1_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->cancellable = _tmp2_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_login_async_co (_data_);
#line 5004 "imap-client-session.c"
}

GearyImapStatusResponse*
geary_imap_client_session_login_finish (GearyImapClientSession* self,
                                        GAsyncResult* _res_,
                                        GError** error)
{
	GearyImapStatusResponse* result;
	GearyImapClientSessionLoginAsyncData* _data_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	if (NULL == _data_) {
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		return NULL;
#line 5020 "imap-client-session.c"
	}
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	result = _data_->result;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->result = NULL;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 5028 "imap-client-session.c"
}

/**
     * Performs the LOGIN command using the supplied credentials.
     *
     * Throws {@link ImapError.UNAUTHENTICATED} if the credentials are
     * bad, unsupported, or if authentication actually failed. Returns
     * the status response for the command otherwise.
     *
     * @see initiate_session_async
     */
static void
geary_imap_client_session_login_async_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	GearyImapClientSessionLoginAsyncData* _data_;
#line 960 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = _user_data_;
#line 960 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_source_object_ = source_object;
#line 960 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_res_ = _res_;
#line 960 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_login_async_co (_data_);
#line 5054 "imap-client-session.c"
}

static gboolean
geary_imap_client_session_login_async_co (GearyImapClientSessionLoginAsyncData* _data_)
{
#line 916 "../src/engine/imap/transport/imap-client-session.vala"
	switch (_data_->_state_) {
#line 916 "../src/engine/imap/transport/imap-client-session.vala"
		case 0:
#line 5064 "imap-client-session.c"
		goto _state_0;
#line 916 "../src/engine/imap/transport/imap-client-session.vala"
		case 1:
#line 5068 "imap-client-session.c"
		goto _state_1;
		default:
#line 916 "../src/engine/imap/transport/imap-client-session.vala"
		g_assert_not_reached ();
#line 5073 "imap-client-session.c"
	}
	_state_0:
#line 919 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->cmd = NULL;
#line 920 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp0_ = geary_credentials_get_supported_method (_data_->credentials);
#line 920 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 920 "../src/engine/imap/transport/imap-client-session.vala"
	switch (_data_->_tmp1_) {
#line 920 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_CREDENTIALS_METHOD_PASSWORD:
#line 5086 "imap-client-session.c"
		{
#line 922 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp2_ = geary_credentials_get_user (_data_->credentials);
#line 922 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp3_ = _data_->_tmp2_;
#line 922 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp4_ = geary_credentials_get_token (_data_->credentials);
#line 922 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp5_ = _data_->_tmp4_;
#line 922 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp6_ = geary_imap_login_command_new (_data_->_tmp3_, _data_->_tmp5_, _data_->cancellable);
#line 922 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->cmd);
#line 922 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->cmd = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, GEARY_IMAP_TYPE_COMMAND, GearyImapCommand);
#line 927 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 5104 "imap-client-session.c"
		}
#line 920 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_CREDENTIALS_METHOD_OAUTH2:
#line 5108 "imap-client-session.c"
		{
#line 930 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp7_ = _data_->self->priv->_capabilities;
#line 930 "../src/engine/imap/transport/imap-client-session.vala"
			if (!geary_generic_capabilities_has_setting (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp7_, GEARY_TYPE_GENERIC_CAPABILITIES, GearyGenericCapabilities), GEARY_IMAP_CAPABILITIES_AUTH, GEARY_IMAP_CAPABILITIES_AUTH_XOAUTH2)) {
#line 932 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp8_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 932 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp9_ = _data_->_tmp8_;
#line 932 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp10_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_UNAUTHENTICATED, "OAuth2 authentication not supported for %s", _data_->_tmp9_);
#line 932 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp11_ = _data_->_tmp10_;
#line 932 "../src/engine/imap/transport/imap-client-session.vala"
				_g_free0 (_data_->_tmp9_);
#line 932 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_inner_error0_ = _data_->_tmp11_;
#line 932 "../src/engine/imap/transport/imap-client-session.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 932 "../src/engine/imap/transport/imap-client-session.vala"
				_g_object_unref0 (_data_->cmd);
#line 932 "../src/engine/imap/transport/imap-client-session.vala"
				g_object_unref (_data_->_async_result);
#line 932 "../src/engine/imap/transport/imap-client-session.vala"
				return FALSE;
#line 5134 "imap-client-session.c"
			}
#line 936 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp12_ = geary_credentials_get_user (_data_->credentials);
#line 936 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp13_ = _data_->_tmp12_;
#line 936 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp14_ = geary_credentials_get_token (_data_->credentials);
#line 936 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp15_ = _data_->_tmp14_;
#line 936 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp16_ = geary_imap_authenticate_command_new_oauth2 (_data_->_tmp13_, _data_->_tmp15_, _data_->cancellable);
#line 936 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->cmd);
#line 936 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->cmd = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp16_, GEARY_IMAP_TYPE_COMMAND, GearyImapCommand);
#line 941 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 5152 "imap-client-session.c"
		}
		default:
		{
#line 944 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp17_ = geary_credentials_get_supported_method (_data_->credentials);
#line 944 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp18_ = _data_->_tmp17_;
#line 944 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp19_ = geary_credentials_method_to_string (_data_->_tmp18_);
#line 944 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp20_ = _data_->_tmp19_;
#line 944 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp21_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 944 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp22_ = _data_->_tmp21_;
#line 944 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp23_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_UNAUTHENTICATED, "Credentials method %s not supported for: %s", _data_->_tmp20_, _data_->_tmp22_);
#line 944 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp24_ = _data_->_tmp23_;
#line 944 "../src/engine/imap/transport/imap-client-session.vala"
			_g_free0 (_data_->_tmp22_);
#line 944 "../src/engine/imap/transport/imap-client-session.vala"
			_g_free0 (_data_->_tmp20_);
#line 944 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_inner_error0_ = _data_->_tmp24_;
#line 944 "../src/engine/imap/transport/imap-client-session.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 944 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->cmd);
#line 944 "../src/engine/imap/transport/imap-client-session.vala"
			g_object_unref (_data_->_async_result);
#line 944 "../src/engine/imap/transport/imap-client-session.vala"
			return FALSE;
#line 5186 "imap-client-session.c"
		}
	}
#line 951 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp25_ = _data_->cmd;
#line 951 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp26_ = geary_imap_client_session_machine_params_new (_data_->_tmp25_);
#line 951 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->params = _data_->_tmp26_;
#line 952 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp27_ = _data_->self->priv->fsm;
#line 952 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp28_ = _data_->params;
#line 952 "../src/engine/imap/transport/imap-client-session.vala"
	geary_state_machine_issue (_data_->_tmp27_, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_LOGIN, NULL, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp28_, G_TYPE_OBJECT, GObject), NULL);
#line 954 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp29_ = _data_->params;
#line 954 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp30_ = _data_->_tmp29_->err;
#line 954 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_tmp30_ != NULL) {
#line 955 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp31_ = _data_->params;
#line 955 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp32_ = _data_->_tmp31_->err;
#line 955 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp33_ = _g_error_copy0 (_data_->_tmp32_);
#line 955 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_inner_error0_ = _data_->_tmp33_;
#line 955 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 955 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->params);
#line 955 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->cmd);
#line 955 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 955 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 5225 "imap-client-session.c"
	}
#line 958 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp34_ = _data_->params;
#line 958 "../src/engine/imap/transport/imap-client-session.vala"
	_vala_assert (_data_->_tmp34_->proceed, "params.proceed");
#line 960 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp35_ = _data_->cmd;
#line 960 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_state_ = 1;
#line 960 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_submit_command (_data_->self, _data_->_tmp35_, geary_imap_client_session_login_async_ready, _data_);
#line 960 "../src/engine/imap/transport/imap-client-session.vala"
	return FALSE;
#line 5239 "imap-client-session.c"
	_state_1:
#line 960 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp36_ = geary_imap_client_session_submit_command_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 960 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->response = _data_->_tmp36_;
#line 960 "../src/engine/imap/transport/imap-client-session.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 960 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 960 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->params);
#line 960 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->cmd);
#line 960 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 960 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 5257 "imap-client-session.c"
	}
#line 961 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp37_ = _data_->response;
#line 961 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp38_ = geary_imap_status_response_get_status (_data_->_tmp37_);
#line 961 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp39_ = _data_->_tmp38_;
#line 961 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_tmp39_ != GEARY_IMAP_STATUS_OK) {
#line 966 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp40_ = _data_->response;
#line 966 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp41_ = geary_imap_status_response_get_response_code (_data_->_tmp40_);
#line 966 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp42_ = _data_->_tmp41_;
#line 966 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp43_ = _g_object_ref0 (_data_->_tmp42_);
#line 966 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->code = _data_->_tmp43_;
#line 967 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp44_ = _data_->code;
#line 967 "../src/engine/imap/transport/imap-client-session.vala"
		if (_data_->_tmp44_ != NULL) {
#line 968 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp45_ = _data_->code;
#line 968 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp46_ = geary_imap_response_code_get_response_code_type (_data_->_tmp45_, &_data_->_inner_error0_);
#line 968 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->code_type = _data_->_tmp46_;
#line 968 "../src/engine/imap/transport/imap-client-session.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 968 "../src/engine/imap/transport/imap-client-session.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 968 "../src/engine/imap/transport/imap-client-session.vala"
				_g_object_unref0 (_data_->code);
#line 968 "../src/engine/imap/transport/imap-client-session.vala"
				_g_object_unref0 (_data_->response);
#line 968 "../src/engine/imap/transport/imap-client-session.vala"
				_g_object_unref0 (_data_->params);
#line 968 "../src/engine/imap/transport/imap-client-session.vala"
				_g_object_unref0 (_data_->cmd);
#line 968 "../src/engine/imap/transport/imap-client-session.vala"
				g_object_unref (_data_->_async_result);
#line 968 "../src/engine/imap/transport/imap-client-session.vala"
				return FALSE;
#line 5303 "imap-client-session.c"
			}
#line 969 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp47_ = _data_->code_type;
#line 969 "../src/engine/imap/transport/imap-client-session.vala"
			if (_data_->_tmp47_ != NULL) {
#line 970 "../src/engine/imap/transport/imap-client-session.vala"
				static GQuark _tmp52_label0 = 0;
#line 970 "../src/engine/imap/transport/imap-client-session.vala"
				static GQuark _tmp52_label1 = 0;
#line 970 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp48_ = _data_->code_type;
#line 970 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp49_ = geary_imap_response_code_type_get_value (_data_->_tmp48_);
#line 970 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp50_ = _data_->_tmp49_;
#line 970 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp53_ = 0U;
#line 970 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp51_ = _data_->_tmp50_;
#line 970 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp53_ = (NULL == _data_->_tmp51_) ? 0 : g_quark_from_string (_data_->_tmp51_);
#line 970 "../src/engine/imap/transport/imap-client-session.vala"
				if (_data_->_tmp53_ == ((0 != _tmp52_label0) ? _tmp52_label0 : (_tmp52_label0 = g_quark_from_static_string (GEARY_IMAP_RESPONSE_CODE_TYPE_UNAVAILABLE)))) {
#line 970 "../src/engine/imap/transport/imap-client-session.vala"
					switch (0) {
#line 5329 "imap-client-session.c"
						default:
						{
#line 972 "../src/engine/imap/transport/imap-client-session.vala"
							_data_->_tmp54_ = _data_->response;
#line 972 "../src/engine/imap/transport/imap-client-session.vala"
							_data_->_tmp55_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp54_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 972 "../src/engine/imap/transport/imap-client-session.vala"
							_data_->_tmp56_ = _data_->_tmp55_;
#line 972 "../src/engine/imap/transport/imap-client-session.vala"
							_data_->_tmp57_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_UNAVAILABLE, "Login restricted: %s: ", _data_->_tmp56_);
#line 972 "../src/engine/imap/transport/imap-client-session.vala"
							_data_->_tmp58_ = _data_->_tmp57_;
#line 972 "../src/engine/imap/transport/imap-client-session.vala"
							_g_free0 (_data_->_tmp56_);
#line 972 "../src/engine/imap/transport/imap-client-session.vala"
							_data_->_inner_error0_ = _data_->_tmp58_;
#line 972 "../src/engine/imap/transport/imap-client-session.vala"
							g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 972 "../src/engine/imap/transport/imap-client-session.vala"
							_g_object_unref0 (_data_->code_type);
#line 972 "../src/engine/imap/transport/imap-client-session.vala"
							_g_object_unref0 (_data_->code);
#line 972 "../src/engine/imap/transport/imap-client-session.vala"
							_g_object_unref0 (_data_->response);
#line 972 "../src/engine/imap/transport/imap-client-session.vala"
							_g_object_unref0 (_data_->params);
#line 972 "../src/engine/imap/transport/imap-client-session.vala"
							_g_object_unref0 (_data_->cmd);
#line 972 "../src/engine/imap/transport/imap-client-session.vala"
							g_object_unref (_data_->_async_result);
#line 972 "../src/engine/imap/transport/imap-client-session.vala"
							return FALSE;
#line 5362 "imap-client-session.c"
						}
					}
				} else if (_data_->_tmp53_ == ((0 != _tmp52_label1) ? _tmp52_label1 : (_tmp52_label1 = g_quark_from_static_string (GEARY_IMAP_RESPONSE_CODE_TYPE_AUTHENTICATIONFAILED)))) {
#line 970 "../src/engine/imap/transport/imap-client-session.vala"
					switch (0) {
#line 5368 "imap-client-session.c"
						default:
						{
#line 978 "../src/engine/imap/transport/imap-client-session.vala"
							break;
#line 5373 "imap-client-session.c"
						}
					}
				} else {
#line 970 "../src/engine/imap/transport/imap-client-session.vala"
					switch (0) {
#line 5379 "imap-client-session.c"
						default:
						{
#line 981 "../src/engine/imap/transport/imap-client-session.vala"
							_data_->_tmp59_ = _data_->response;
#line 981 "../src/engine/imap/transport/imap-client-session.vala"
							_data_->_tmp60_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp59_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 981 "../src/engine/imap/transport/imap-client-session.vala"
							_data_->_tmp61_ = _data_->_tmp60_;
#line 981 "../src/engine/imap/transport/imap-client-session.vala"
							_data_->_tmp62_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_SERVER_ERROR, "Login error: %s: ", _data_->_tmp61_);
#line 981 "../src/engine/imap/transport/imap-client-session.vala"
							_data_->_tmp63_ = _data_->_tmp62_;
#line 981 "../src/engine/imap/transport/imap-client-session.vala"
							_g_free0 (_data_->_tmp61_);
#line 981 "../src/engine/imap/transport/imap-client-session.vala"
							_data_->_inner_error0_ = _data_->_tmp63_;
#line 981 "../src/engine/imap/transport/imap-client-session.vala"
							g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 981 "../src/engine/imap/transport/imap-client-session.vala"
							_g_object_unref0 (_data_->code_type);
#line 981 "../src/engine/imap/transport/imap-client-session.vala"
							_g_object_unref0 (_data_->code);
#line 981 "../src/engine/imap/transport/imap-client-session.vala"
							_g_object_unref0 (_data_->response);
#line 981 "../src/engine/imap/transport/imap-client-session.vala"
							_g_object_unref0 (_data_->params);
#line 981 "../src/engine/imap/transport/imap-client-session.vala"
							_g_object_unref0 (_data_->cmd);
#line 981 "../src/engine/imap/transport/imap-client-session.vala"
							g_object_unref (_data_->_async_result);
#line 981 "../src/engine/imap/transport/imap-client-session.vala"
							return FALSE;
#line 5412 "imap-client-session.c"
						}
					}
				}
			}
#line 967 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->code_type);
#line 5419 "imap-client-session.c"
		}
#line 988 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp64_ = _data_->response;
#line 988 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp65_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp64_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 988 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp66_ = _data_->_tmp65_;
#line 988 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp67_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_UNAUTHENTICATED, "Bad credentials: %s: ", _data_->_tmp66_);
#line 988 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp68_ = _data_->_tmp67_;
#line 988 "../src/engine/imap/transport/imap-client-session.vala"
		_g_free0 (_data_->_tmp66_);
#line 988 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_inner_error0_ = _data_->_tmp68_;
#line 988 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 988 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->code);
#line 988 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->response);
#line 988 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->params);
#line 988 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->cmd);
#line 988 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 988 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 5449 "imap-client-session.c"
	}
#line 993 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp69_ = _data_->cmd;
#line 993 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp70_ = geary_imap_command_get_status (_data_->_tmp69_);
#line 993 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp71_ = _data_->_tmp70_;
#line 993 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp72_ = _g_object_ref0 (_data_->_tmp71_);
#line 993 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->result = _data_->_tmp72_;
#line 993 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->response);
#line 993 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->params);
#line 993 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cmd);
#line 993 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 993 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_state_ != 0) {
#line 993 "../src/engine/imap/transport/imap-client-session.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 993 "../src/engine/imap/transport/imap-client-session.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5475 "imap-client-session.c"
		}
	}
#line 993 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_unref (_data_->_async_result);
#line 993 "../src/engine/imap/transport/imap-client-session.vala"
	return FALSE;
#line 5482 "imap-client-session.c"
}

static void
geary_imap_client_session_initiate_session_async_data_free (gpointer _data)
{
	GearyImapClientSessionInitiateSessionAsyncData* _data_;
	_data_ = _data;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->credentials);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_slice_free (GearyImapClientSessionInitiateSessionAsyncData, _data_);
#line 5498 "imap-client-session.c"
}

void
geary_imap_client_session_initiate_session_async (GearyImapClientSession* self,
                                                  GearyCredentials* credentials,
                                                  GCancellable* cancellable,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_)
{
	GearyImapClientSessionInitiateSessionAsyncData* _data_;
	GearyImapClientSession* _tmp0_;
	GearyCredentials* _tmp1_;
	GCancellable* _tmp2_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IS_CREDENTIALS (credentials));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_slice_new0 (GearyImapClientSessionInitiateSessionAsyncData);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_session_initiate_session_async_data_free);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->self = _tmp0_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = _g_object_ref0 (credentials);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->credentials);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->credentials = _tmp1_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->cancellable = _tmp2_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_initiate_session_async_co (_data_);
#line 5542 "imap-client-session.c"
}

void
geary_imap_client_session_initiate_session_finish (GearyImapClientSession* self,
                                                   GAsyncResult* _res_,
                                                   GError** error)
{
	GearyImapClientSessionInitiateSessionAsyncData* _data_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	if (NULL == _data_) {
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		return;
#line 5557 "imap-client-session.c"
	}
}

/**
     * Prepares the connection and performs a login using the supplied credentials.
     *
     * Preparing the connection includes attempting compression and using STARTTLS if necessary.
     * {@link Capabilities} are also retrieved automatically at the right time to ensure the best
     * results are available with {@link capabilities}.
     */
static Block32Data*
block32_data_ref (Block32Data* _data32_)
{
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
	g_atomic_int_inc (&_data32_->_ref_count_);
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
	return _data32_;
#line 5575 "imap-client-session.c"
}

static void
block32_data_unref (void * _userdata_)
{
	Block32Data* _data32_;
	_data32_ = (Block32Data*) _userdata_;
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
	if (g_atomic_int_dec_and_test (&_data32_->_ref_count_)) {
#line 5585 "imap-client-session.c"
		GearyImapClientSession* self;
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
		self = _data32_->self;
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data32_->list_results);
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (self);
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
		g_slice_free (Block32Data, _data32_);
#line 5595 "imap-client-session.c"
	}
}

static void
geary_imap_client_session_initiate_session_async_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_)
{
	GearyImapClientSessionInitiateSessionAsyncData* _data_;
#line 1008 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = _user_data_;
#line 1008 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_source_object_ = source_object;
#line 1008 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_res_ = _res_;
#line 1008 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_initiate_session_async_co (_data_);
#line 5613 "imap-client-session.c"
}

static void
__lambda50_ (Block32Data* _data32_,
             GearyImapMailboxInformation* mailbox)
{
	GearyImapClientSession* self;
	GeeArrayList* _tmp0_;
#line 1057 "../src/engine/imap/transport/imap-client-session.vala"
	self = _data32_->self;
#line 1057 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_MAILBOX_INFORMATION (mailbox));
#line 1057 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _data32_->list_results;
#line 1057 "../src/engine/imap/transport/imap-client-session.vala"
	gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), mailbox);
#line 5630 "imap-client-session.c"
}

static void
___lambda50__geary_imap_client_session_list (GearyImapClientSession* _sender,
                                             GearyImapMailboxInformation* mailbox_info,
                                             gpointer self)
{
#line 1056 "../src/engine/imap/transport/imap-client-session.vala"
	__lambda50_ (self, mailbox_info);
#line 5640 "imap-client-session.c"
}

static gboolean
geary_imap_client_session_initiate_session_async_co (GearyImapClientSessionInitiateSessionAsyncData* _data_)
{
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
	switch (_data_->_state_) {
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
		case 0:
#line 5650 "imap-client-session.c"
		goto _state_0;
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
		case 1:
#line 5654 "imap-client-session.c"
		goto _state_1;
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
		case 2:
#line 5658 "imap-client-session.c"
		goto _state_2;
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
		case 3:
#line 5662 "imap-client-session.c"
		goto _state_3;
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
		case 4:
#line 5666 "imap-client-session.c"
		goto _state_4;
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
		case 5:
#line 5670 "imap-client-session.c"
		goto _state_5;
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
		case 6:
#line 5674 "imap-client-session.c"
		goto _state_6;
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
		case 7:
#line 5678 "imap-client-session.c"
		goto _state_7;
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
		case 8:
#line 5682 "imap-client-session.c"
		goto _state_8;
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
		case 9:
#line 5686 "imap-client-session.c"
		goto _state_9;
		default:
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
		g_assert_not_reached ();
#line 5691 "imap-client-session.c"
	}
	_state_0:
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_data32_ = g_slice_new0 (Block32Data);
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_data32_->_ref_count_ = 1;
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_data32_->self = g_object_ref (_data_->self);
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_data32_->_async_data_ = _data_;
#line 1007 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp0_ = _data_->self->priv->_capabilities;
#line 1007 "../src/engine/imap/transport/imap-client-session.vala"
	if (geary_generic_capabilities_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEARY_TYPE_GENERIC_CAPABILITIES, GearyGenericCapabilities))) {
#line 1008 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp1_ = geary_imap_capability_command_new (_data_->cancellable);
#line 1008 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp2_ = _data_->_tmp1_;
#line 1008 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_state_ = 1;
#line 1008 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_session_send_command_async (_data_->self, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, GEARY_IMAP_TYPE_COMMAND, GearyImapCommand), geary_imap_client_session_initiate_session_async_ready, _data_);
#line 1008 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 5716 "imap-client-session.c"
		_state_1:
#line 1008 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp3_ = geary_imap_client_session_send_command_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 1008 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 1008 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->_tmp4_);
#line 1008 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->_tmp2_);
#line 1008 "../src/engine/imap/transport/imap-client-session.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1008 "../src/engine/imap/transport/imap-client-session.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1008 "../src/engine/imap/transport/imap-client-session.vala"
			block32_data_unref (_data_->_data32_);
#line 1008 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_data32_ = NULL;
#line 1008 "../src/engine/imap/transport/imap-client-session.vala"
			g_object_unref (_data_->_async_result);
#line 1008 "../src/engine/imap/transport/imap-client-session.vala"
			return FALSE;
#line 5738 "imap-client-session.c"
		}
	}
#line 1011 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp5_ = _data_->self->priv->_capabilities;
#line 1011 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp6_ = geary_imap_capabilities_get_revision (_data_->_tmp5_);
#line 1011 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 1011 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->last_capabilities = _data_->_tmp7_;
#line 1013 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp8_ = _data_->self->priv->imap_endpoint;
#line 1013 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp9_ = geary_endpoint_get_tls_method (_data_->_tmp8_);
#line 1013 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 1013 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_tmp10_ == GEARY_TLS_NEGOTIATION_METHOD_START_TLS) {
#line 1014 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp11_ = _data_->self->priv->_capabilities;
#line 1014 "../src/engine/imap/transport/imap-client-session.vala"
		if (!geary_generic_capabilities_has_capability (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp11_, GEARY_TYPE_GENERIC_CAPABILITIES, GearyGenericCapabilities), GEARY_IMAP_CAPABILITIES_STARTTLS)) {
#line 1015 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp12_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 1015 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp13_ = _data_->_tmp12_;
#line 1015 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp14_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_NOT_SUPPORTED, "STARTTLS unavailable for %s", _data_->_tmp13_);
#line 1015 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp15_ = _data_->_tmp14_;
#line 1015 "../src/engine/imap/transport/imap-client-session.vala"
			_g_free0 (_data_->_tmp13_);
#line 1015 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_inner_error0_ = _data_->_tmp15_;
#line 1015 "../src/engine/imap/transport/imap-client-session.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1015 "../src/engine/imap/transport/imap-client-session.vala"
			block32_data_unref (_data_->_data32_);
#line 1015 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_data32_ = NULL;
#line 1015 "../src/engine/imap/transport/imap-client-session.vala"
			g_object_unref (_data_->_async_result);
#line 1015 "../src/engine/imap/transport/imap-client-session.vala"
			return FALSE;
#line 5783 "imap-client-session.c"
		}
#line 1019 "../src/engine/imap/transport/imap-client-session.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Attempting STARTTLS...");
#line 1020 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp16_ = geary_imap_starttls_command_new (_data_->cancellable);
#line 1020 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp17_ = _data_->_tmp16_;
#line 1020 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_state_ = 2;
#line 1020 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_session_send_command_async (_data_->self, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp17_, GEARY_IMAP_TYPE_COMMAND, GearyImapCommand), geary_imap_client_session_initiate_session_async_ready, _data_);
#line 1020 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 5797 "imap-client-session.c"
		_state_2:
#line 1020 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp18_ = geary_imap_client_session_send_command_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 1020 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp19_ = _data_->_tmp18_;
#line 1020 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->_tmp17_);
#line 1020 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->resp = _data_->_tmp19_;
#line 1020 "../src/engine/imap/transport/imap-client-session.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1020 "../src/engine/imap/transport/imap-client-session.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1020 "../src/engine/imap/transport/imap-client-session.vala"
			block32_data_unref (_data_->_data32_);
#line 1020 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_data32_ = NULL;
#line 1020 "../src/engine/imap/transport/imap-client-session.vala"
			g_object_unref (_data_->_async_result);
#line 1020 "../src/engine/imap/transport/imap-client-session.vala"
			return FALSE;
#line 5819 "imap-client-session.c"
		}
#line 1024 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp20_ = _data_->resp;
#line 1024 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp21_ = geary_imap_status_response_get_status (_data_->_tmp20_);
#line 1024 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp22_ = _data_->_tmp21_;
#line 1024 "../src/engine/imap/transport/imap-client-session.vala"
		if (_data_->_tmp22_ == GEARY_IMAP_STATUS_OK) {
#line 1025 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp23_ = _data_->self->priv->cx;
#line 1025 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_state_ = 3;
#line 1025 "../src/engine/imap/transport/imap-client-session.vala"
			geary_imap_client_connection_starttls_async (_data_->_tmp23_, _data_->cancellable, geary_imap_client_session_initiate_session_async_ready, _data_);
#line 1025 "../src/engine/imap/transport/imap-client-session.vala"
			return FALSE;
#line 5837 "imap-client-session.c"
			_state_3:
#line 1025 "../src/engine/imap/transport/imap-client-session.vala"
			geary_imap_client_connection_starttls_finish (_data_->_tmp23_, _data_->_res_, &_data_->_inner_error0_);
#line 1025 "../src/engine/imap/transport/imap-client-session.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1025 "../src/engine/imap/transport/imap-client-session.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1025 "../src/engine/imap/transport/imap-client-session.vala"
				_g_object_unref0 (_data_->resp);
#line 1025 "../src/engine/imap/transport/imap-client-session.vala"
				block32_data_unref (_data_->_data32_);
#line 1025 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_data32_ = NULL;
#line 1025 "../src/engine/imap/transport/imap-client-session.vala"
				g_object_unref (_data_->_async_result);
#line 1025 "../src/engine/imap/transport/imap-client-session.vala"
				return FALSE;
#line 5855 "imap-client-session.c"
			}
#line 1026 "../src/engine/imap/transport/imap-client-session.vala"
			geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "STARTTLS completed");
#line 5859 "imap-client-session.c"
		} else {
#line 1030 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp24_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 1030 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp25_ = _data_->_tmp24_;
#line 1030 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp26_ = _data_->resp;
#line 1030 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp27_ = geary_imap_status_response_get_status (_data_->_tmp26_);
#line 1030 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp28_ = _data_->_tmp27_;
#line 1030 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp29_ = geary_imap_status_to_string (_data_->_tmp28_);
#line 1030 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp30_ = _data_->_tmp29_;
#line 1030 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp31_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_NOT_SUPPORTED, "STARTTLS refused by %s: %s", _data_->_tmp25_, _data_->_tmp30_);
#line 1030 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp32_ = _data_->_tmp31_;
#line 1030 "../src/engine/imap/transport/imap-client-session.vala"
			_g_free0 (_data_->_tmp30_);
#line 1030 "../src/engine/imap/transport/imap-client-session.vala"
			_g_free0 (_data_->_tmp25_);
#line 1030 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_inner_error0_ = _data_->_tmp32_;
#line 1030 "../src/engine/imap/transport/imap-client-session.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1030 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->resp);
#line 1030 "../src/engine/imap/transport/imap-client-session.vala"
			block32_data_unref (_data_->_data32_);
#line 1030 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_data32_ = NULL;
#line 1030 "../src/engine/imap/transport/imap-client-session.vala"
			g_object_unref (_data_->_async_result);
#line 1030 "../src/engine/imap/transport/imap-client-session.vala"
			return FALSE;
#line 5897 "imap-client-session.c"
		}
#line 1036 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp33_ = _data_->self->priv->_capabilities;
#line 1036 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp34_ = geary_imap_capabilities_get_revision (_data_->_tmp33_);
#line 1036 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp35_ = _data_->_tmp34_;
#line 1036 "../src/engine/imap/transport/imap-client-session.vala"
		if (_data_->last_capabilities == _data_->_tmp35_) {
#line 1042 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp36_ = geary_imap_capability_command_new (_data_->cancellable);
#line 1042 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp37_ = _data_->_tmp36_;
#line 1042 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_state_ = 4;
#line 1042 "../src/engine/imap/transport/imap-client-session.vala"
			geary_imap_client_session_send_command_async (_data_->self, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp37_, GEARY_IMAP_TYPE_COMMAND, GearyImapCommand), geary_imap_client_session_initiate_session_async_ready, _data_);
#line 1042 "../src/engine/imap/transport/imap-client-session.vala"
			return FALSE;
#line 5917 "imap-client-session.c"
			_state_4:
#line 1042 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp38_ = geary_imap_client_session_send_command_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 1042 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp39_ = _data_->_tmp38_;
#line 1042 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->_tmp39_);
#line 1042 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->_tmp37_);
#line 1042 "../src/engine/imap/transport/imap-client-session.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1042 "../src/engine/imap/transport/imap-client-session.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1042 "../src/engine/imap/transport/imap-client-session.vala"
				_g_object_unref0 (_data_->resp);
#line 1042 "../src/engine/imap/transport/imap-client-session.vala"
				block32_data_unref (_data_->_data32_);
#line 1042 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_data32_ = NULL;
#line 1042 "../src/engine/imap/transport/imap-client-session.vala"
				g_object_unref (_data_->_async_result);
#line 1042 "../src/engine/imap/transport/imap-client-session.vala"
				return FALSE;
#line 5941 "imap-client-session.c"
			}
#line 1043 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp40_ = _data_->self->priv->_capabilities;
#line 1043 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp41_ = geary_imap_capabilities_get_revision (_data_->_tmp40_);
#line 1043 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp42_ = _data_->_tmp41_;
#line 1043 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->last_capabilities = _data_->_tmp42_;
#line 5951 "imap-client-session.c"
		}
#line 1013 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->resp);
#line 5955 "imap-client-session.c"
	}
#line 1048 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_state_ = 5;
#line 1048 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_login_async (_data_->self, _data_->credentials, _data_->cancellable, geary_imap_client_session_initiate_session_async_ready, _data_);
#line 1048 "../src/engine/imap/transport/imap-client-session.vala"
	return FALSE;
#line 5963 "imap-client-session.c"
	_state_5:
#line 1048 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp43_ = geary_imap_client_session_login_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 1048 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp44_ = _data_->_tmp43_;
#line 1048 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->_tmp44_);
#line 1048 "../src/engine/imap/transport/imap-client-session.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1048 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1048 "../src/engine/imap/transport/imap-client-session.vala"
		block32_data_unref (_data_->_data32_);
#line 1048 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_data32_ = NULL;
#line 1048 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 1048 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 5983 "imap-client-session.c"
	}
#line 1051 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp45_ = _data_->self->priv->_capabilities;
#line 1051 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp46_ = geary_imap_capabilities_get_revision (_data_->_tmp45_);
#line 1051 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp47_ = _data_->_tmp46_;
#line 1051 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->last_capabilities == _data_->_tmp47_) {
#line 1052 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp48_ = geary_imap_capability_command_new (_data_->cancellable);
#line 1052 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp49_ = _data_->_tmp48_;
#line 1052 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_state_ = 6;
#line 1052 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_session_send_command_async (_data_->self, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp49_, GEARY_IMAP_TYPE_COMMAND, GearyImapCommand), geary_imap_client_session_initiate_session_async_ready, _data_);
#line 1052 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 6003 "imap-client-session.c"
		_state_6:
#line 1052 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp50_ = geary_imap_client_session_send_command_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 1052 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp51_ = _data_->_tmp50_;
#line 1052 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->_tmp51_);
#line 1052 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->_tmp49_);
#line 1052 "../src/engine/imap/transport/imap-client-session.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1052 "../src/engine/imap/transport/imap-client-session.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1052 "../src/engine/imap/transport/imap-client-session.vala"
			block32_data_unref (_data_->_data32_);
#line 1052 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_data32_ = NULL;
#line 1052 "../src/engine/imap/transport/imap-client-session.vala"
			g_object_unref (_data_->_async_result);
#line 1052 "../src/engine/imap/transport/imap-client-session.vala"
			return FALSE;
#line 6025 "imap-client-session.c"
		}
	}
#line 1055 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp52_ = gee_array_list_new (GEARY_IMAP_TYPE_MAILBOX_INFORMATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1055 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_data32_->list_results = _data_->_tmp52_;
#line 1056 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp53_ = g_signal_connect_data (_data_->self, "list", (GCallback) ___lambda50__geary_imap_client_session_list, block32_data_ref (_data_->_data32_), (GClosureNotify) block32_data_unref, 0);
#line 1056 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->list_id = _data_->_tmp53_;
#line 6036 "imap-client-session.c"
	{
#line 1061 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp54_ = geary_imap_mailbox_specifier_get_inbox ();
#line 1061 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp55_ = _data_->_tmp54_;
#line 1061 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp56_ = geary_imap_list_command_new (_data_->_tmp55_, FALSE, NULL, _data_->cancellable);
#line 1061 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp57_ = _data_->_tmp56_;
#line 1061 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_state_ = 7;
#line 1061 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_session_send_command_async (_data_->self, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp57_, GEARY_IMAP_TYPE_COMMAND, GearyImapCommand), geary_imap_client_session_initiate_session_async_ready, _data_);
#line 1061 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 6052 "imap-client-session.c"
		_state_7:
#line 1061 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp58_ = geary_imap_client_session_send_command_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 1061 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp59_ = _data_->_tmp58_;
#line 1061 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->_tmp57_);
#line 1061 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->response = _data_->_tmp59_;
#line 1061 "../src/engine/imap/transport/imap-client-session.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 6064 "imap-client-session.c"
			goto __finally0;
		}
#line 1064 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp61_ = _data_->response;
#line 1064 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp62_ = geary_imap_status_response_get_status (_data_->_tmp61_);
#line 1064 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp63_ = _data_->_tmp62_;
#line 1064 "../src/engine/imap/transport/imap-client-session.vala"
		if (_data_->_tmp63_ == GEARY_IMAP_STATUS_OK) {
#line 1064 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp64_ = _data_->_data32_->list_results;
#line 1064 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp65_ = gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp64_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1064 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp66_ = _data_->_tmp65_;
#line 1064 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp60_ = !_data_->_tmp66_;
#line 6083 "imap-client-session.c"
		} else {
#line 1064 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp60_ = FALSE;
#line 6087 "imap-client-session.c"
		}
#line 1064 "../src/engine/imap/transport/imap-client-session.vala"
		if (_data_->_tmp60_) {
#line 1065 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp67_ = _data_->_data32_->list_results;
#line 1065 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp68_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp67_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), 0);
#line 1065 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp69_ = (GearyImapMailboxInformation*) _data_->_tmp68_;
#line 1065 "../src/engine/imap/transport/imap-client-session.vala"
			geary_imap_client_session_set_inbox (_data_->self, _data_->_tmp69_);
#line 1065 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->_tmp69_);
#line 1066 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp70_ = _data_->_data32_->list_results;
#line 1066 "../src/engine/imap/transport/imap-client-session.vala"
			gee_abstract_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp70_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 1067 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp71_ = _data_->self->priv->_inbox;
#line 1067 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp72_ = geary_imap_mailbox_information_to_string (_data_->_tmp71_);
#line 1067 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp73_ = _data_->_tmp72_;
#line 1067 "../src/engine/imap/transport/imap-client-session.vala"
			geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Using INBOX: %s", _data_->_tmp73_);
#line 1067 "../src/engine/imap/transport/imap-client-session.vala"
			_g_free0 (_data_->_tmp73_);
#line 6115 "imap-client-session.c"
		} else {
#line 1069 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp74_ = g_error_new_literal (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_INVALID, "Unable to find INBOX");
#line 1069 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_inner_error0_ = _data_->_tmp74_;
#line 1069 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->response);
#line 6123 "imap-client-session.c"
			goto __finally0;
		}
#line 1073 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp75_ = _data_->self->priv->_capabilities;
#line 1073 "../src/engine/imap/transport/imap-client-session.vala"
		if (geary_generic_capabilities_has_capability (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp75_, GEARY_TYPE_GENERIC_CAPABILITIES, GearyGenericCapabilities), GEARY_IMAP_CAPABILITIES_NAMESPACE)) {
#line 1074 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp77_ = geary_imap_namespace_command_new (_data_->cancellable);
#line 1074 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp78_ = _data_->_tmp77_;
#line 1074 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_state_ = 8;
#line 1074 "../src/engine/imap/transport/imap-client-session.vala"
			geary_imap_client_session_send_command_async (_data_->self, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp78_, GEARY_IMAP_TYPE_COMMAND, GearyImapCommand), geary_imap_client_session_initiate_session_async_ready, _data_);
#line 1074 "../src/engine/imap/transport/imap-client-session.vala"
			return FALSE;
#line 6140 "imap-client-session.c"
			_state_8:
#line 1074 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp79_ = geary_imap_client_session_send_command_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 1074 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp80_ = _data_->_tmp79_;
#line 1074 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->_tmp78_);
#line 1074 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp76_ = _data_->_tmp80_;
#line 1074 "../src/engine/imap/transport/imap-client-session.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1074 "../src/engine/imap/transport/imap-client-session.vala"
				_g_object_unref0 (_data_->response);
#line 6154 "imap-client-session.c"
				goto __finally0;
			}
#line 1074 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp81_ = _data_->_tmp76_;
#line 1074 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp76_ = NULL;
#line 1074 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->response);
#line 1074 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->response = _data_->_tmp81_;
#line 1077 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp82_ = _data_->response;
#line 1077 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp83_ = geary_imap_status_response_get_status (_data_->_tmp82_);
#line 1077 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp84_ = _data_->_tmp83_;
#line 1077 "../src/engine/imap/transport/imap-client-session.vala"
			if (_data_->_tmp84_ != GEARY_IMAP_STATUS_OK) {
#line 1078 "../src/engine/imap/transport/imap-client-session.vala"
				geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "NAMESPACE command failed");
#line 6175 "imap-client-session.c"
			}
#line 1073 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->_tmp76_);
#line 6179 "imap-client-session.c"
		}
#line 1081 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp85_ = _data_->self->priv->personal_namespaces;
#line 1081 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp86_ = gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp85_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1081 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp87_ = _data_->_tmp86_;
#line 1081 "../src/engine/imap/transport/imap-client-session.vala"
		if (!_data_->_tmp87_) {
#line 1082 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp88_ = _data_->self->priv->personal_namespaces;
#line 1082 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp89_ = gee_list_get (_data_->_tmp88_, 0);
#line 1082 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp90_ = (GearyImapNamespace*) _data_->_tmp89_;
#line 1082 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp91_ = geary_imap_namespace_to_string (_data_->_tmp90_);
#line 1082 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp92_ = _data_->_tmp91_;
#line 1082 "../src/engine/imap/transport/imap-client-session.vala"
			geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Default personal namespace: %s", _data_->_tmp92_);
#line 1082 "../src/engine/imap/transport/imap-client-session.vala"
			_g_free0 (_data_->_tmp92_);
#line 1082 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->_tmp90_);
#line 6205 "imap-client-session.c"
		} else {
#line 1087 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp93_ = g_strdup ("");
#line 1087 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->prefix = _data_->_tmp93_;
#line 1088 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp94_ = _data_->self->priv->_inbox;
#line 1088 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp95_ = geary_imap_mailbox_information_get_delim (_data_->_tmp94_);
#line 1088 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp96_ = _data_->_tmp95_;
#line 1088 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp97_ = g_strdup (_data_->_tmp96_);
#line 1088 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->delim = _data_->_tmp97_;
#line 1089 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp99_ = _data_->self->priv->_inbox;
#line 1089 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp100_ = geary_imap_mailbox_information_get_attrs (_data_->_tmp99_);
#line 1089 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp101_ = _data_->_tmp100_;
#line 1089 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp102_ = geary_imap_mailbox_attribute_get_NO_INFERIORS ();
#line 1089 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp103_ = _data_->_tmp102_;
#line 1089 "../src/engine/imap/transport/imap-client-session.vala"
			if (!geary_imap_flags_contains (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp101_, GEARY_IMAP_TYPE_FLAGS, GearyImapFlags), G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp103_, GEARY_IMAP_TYPE_FLAG, GearyImapFlag))) {
#line 1090 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp104_ = _data_->self->priv->_inbox;
#line 1090 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp105_ = geary_imap_mailbox_information_get_delim (_data_->_tmp104_);
#line 1090 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp106_ = _data_->_tmp105_;
#line 1090 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp98_ = g_strcmp0 (_data_->_tmp106_, ".") == 0;
#line 6241 "imap-client-session.c"
			} else {
#line 1089 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp98_ = FALSE;
#line 6245 "imap-client-session.c"
			}
#line 1089 "../src/engine/imap/transport/imap-client-session.vala"
			if (_data_->_tmp98_) {
#line 1093 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp107_ = _data_->self->priv->_inbox;
#line 1093 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp108_ = geary_imap_mailbox_information_get_mailbox (_data_->_tmp107_);
#line 1093 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp109_ = _data_->_tmp108_;
#line 1093 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp110_ = geary_imap_mailbox_specifier_get_name (_data_->_tmp109_);
#line 1093 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp111_ = _data_->_tmp110_;
#line 1093 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp112_ = g_strconcat (_data_->_tmp111_, ".", NULL);
#line 1093 "../src/engine/imap/transport/imap-client-session.vala"
				_g_free0 (_data_->prefix);
#line 1093 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->prefix = _data_->_tmp112_;
#line 6265 "imap-client-session.c"
			}
#line 1096 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp113_ = _data_->delim;
#line 1096 "../src/engine/imap/transport/imap-client-session.vala"
			if (_data_->_tmp113_ == NULL) {
#line 1100 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp115_ = _data_->prefix;
#line 1100 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp116_ = geary_imap_mailbox_specifier_new (_data_->_tmp115_);
#line 1100 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp117_ = _data_->_tmp116_;
#line 1100 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp118_ = geary_imap_list_command_new (_data_->_tmp117_, FALSE, NULL, _data_->cancellable);
#line 1100 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp119_ = _data_->_tmp118_;
#line 1100 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_state_ = 9;
#line 1100 "../src/engine/imap/transport/imap-client-session.vala"
				geary_imap_client_session_send_command_async (_data_->self, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp119_, GEARY_IMAP_TYPE_COMMAND, GearyImapCommand), geary_imap_client_session_initiate_session_async_ready, _data_);
#line 1100 "../src/engine/imap/transport/imap-client-session.vala"
				return FALSE;
#line 6287 "imap-client-session.c"
				_state_9:
#line 1100 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp120_ = geary_imap_client_session_send_command_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 1100 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp121_ = _data_->_tmp120_;
#line 1100 "../src/engine/imap/transport/imap-client-session.vala"
				_g_object_unref0 (_data_->_tmp119_);
#line 1100 "../src/engine/imap/transport/imap-client-session.vala"
				_g_object_unref0 (_data_->_tmp117_);
#line 1100 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp114_ = _data_->_tmp121_;
#line 1100 "../src/engine/imap/transport/imap-client-session.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1100 "../src/engine/imap/transport/imap-client-session.vala"
					_g_free0 (_data_->delim);
#line 1100 "../src/engine/imap/transport/imap-client-session.vala"
					_g_free0 (_data_->prefix);
#line 1100 "../src/engine/imap/transport/imap-client-session.vala"
					_g_object_unref0 (_data_->response);
#line 6307 "imap-client-session.c"
					goto __finally0;
				}
#line 1100 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp122_ = _data_->_tmp114_;
#line 1100 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp114_ = NULL;
#line 1100 "../src/engine/imap/transport/imap-client-session.vala"
				_g_object_unref0 (_data_->response);
#line 1100 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->response = _data_->_tmp122_;
#line 1108 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp124_ = _data_->response;
#line 1108 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp125_ = geary_imap_status_response_get_status (_data_->_tmp124_);
#line 1108 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp126_ = _data_->_tmp125_;
#line 1108 "../src/engine/imap/transport/imap-client-session.vala"
				if (_data_->_tmp126_ == GEARY_IMAP_STATUS_OK) {
#line 1108 "../src/engine/imap/transport/imap-client-session.vala"
					_data_->_tmp127_ = _data_->_data32_->list_results;
#line 1108 "../src/engine/imap/transport/imap-client-session.vala"
					_data_->_tmp128_ = gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp127_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1108 "../src/engine/imap/transport/imap-client-session.vala"
					_data_->_tmp129_ = _data_->_tmp128_;
#line 1108 "../src/engine/imap/transport/imap-client-session.vala"
					_data_->_tmp123_ = !_data_->_tmp129_;
#line 6334 "imap-client-session.c"
				} else {
#line 1108 "../src/engine/imap/transport/imap-client-session.vala"
					_data_->_tmp123_ = FALSE;
#line 6338 "imap-client-session.c"
				}
#line 1108 "../src/engine/imap/transport/imap-client-session.vala"
				if (_data_->_tmp123_) {
#line 1109 "../src/engine/imap/transport/imap-client-session.vala"
					_data_->_tmp130_ = _data_->_data32_->list_results;
#line 1109 "../src/engine/imap/transport/imap-client-session.vala"
					_data_->_tmp131_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp130_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), 0);
#line 1109 "../src/engine/imap/transport/imap-client-session.vala"
					_data_->list = (GearyImapMailboxInformation*) _data_->_tmp131_;
#line 1110 "../src/engine/imap/transport/imap-client-session.vala"
					_data_->_tmp132_ = _data_->list;
#line 1110 "../src/engine/imap/transport/imap-client-session.vala"
					_data_->_tmp133_ = geary_imap_mailbox_information_get_delim (_data_->_tmp132_);
#line 1110 "../src/engine/imap/transport/imap-client-session.vala"
					_data_->_tmp134_ = _data_->_tmp133_;
#line 1110 "../src/engine/imap/transport/imap-client-session.vala"
					_data_->_tmp135_ = g_strdup (_data_->_tmp134_);
#line 1110 "../src/engine/imap/transport/imap-client-session.vala"
					_g_free0 (_data_->delim);
#line 1110 "../src/engine/imap/transport/imap-client-session.vala"
					_data_->delim = _data_->_tmp135_;
#line 1108 "../src/engine/imap/transport/imap-client-session.vala"
					_g_object_unref0 (_data_->list);
#line 6362 "imap-client-session.c"
				} else {
#line 1112 "../src/engine/imap/transport/imap-client-session.vala"
					_data_->_tmp136_ = g_error_new_literal (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_INVALID, "Unable to determine personal namespace delimiter");
#line 1112 "../src/engine/imap/transport/imap-client-session.vala"
					_data_->_inner_error0_ = _data_->_tmp136_;
#line 1112 "../src/engine/imap/transport/imap-client-session.vala"
					_g_object_unref0 (_data_->_tmp114_);
#line 1112 "../src/engine/imap/transport/imap-client-session.vala"
					_g_free0 (_data_->delim);
#line 1112 "../src/engine/imap/transport/imap-client-session.vala"
					_g_free0 (_data_->prefix);
#line 1112 "../src/engine/imap/transport/imap-client-session.vala"
					_g_object_unref0 (_data_->response);
#line 6376 "imap-client-session.c"
					goto __finally0;
				}
#line 1096 "../src/engine/imap/transport/imap-client-session.vala"
				_g_object_unref0 (_data_->_tmp114_);
#line 6381 "imap-client-session.c"
			}
#line 1116 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp137_ = _data_->self->priv->personal_namespaces;
#line 1116 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp138_ = _data_->prefix;
#line 1116 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp139_ = _data_->delim;
#line 1116 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp140_ = geary_imap_namespace_new (_data_->_tmp138_, _data_->_tmp139_);
#line 1116 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp141_ = _data_->_tmp140_;
#line 1116 "../src/engine/imap/transport/imap-client-session.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp137_, GEE_TYPE_COLLECTION, GeeCollection), _data_->_tmp141_);
#line 1116 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->_tmp141_);
#line 1117 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp142_ = _data_->self->priv->personal_namespaces;
#line 1117 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp143_ = gee_list_get (_data_->_tmp142_, 0);
#line 1117 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp144_ = (GearyImapNamespace*) _data_->_tmp143_;
#line 1117 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp145_ = geary_imap_namespace_to_string (_data_->_tmp144_);
#line 1117 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp146_ = _data_->_tmp145_;
#line 1117 "../src/engine/imap/transport/imap-client-session.vala"
			geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Personal namespace not specified, guessed as: %s", _data_->_tmp146_);
#line 1117 "../src/engine/imap/transport/imap-client-session.vala"
			_g_free0 (_data_->_tmp146_);
#line 1117 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->_tmp144_);
#line 1081 "../src/engine/imap/transport/imap-client-session.vala"
			_g_free0 (_data_->delim);
#line 1081 "../src/engine/imap/transport/imap-client-session.vala"
			_g_free0 (_data_->prefix);
#line 6417 "imap-client-session.c"
		}
#line 1059 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->response);
#line 6421 "imap-client-session.c"
	}
	__finally0:
	{
#line 1121 "../src/engine/imap/transport/imap-client-session.vala"
		g_signal_handler_disconnect (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, G_TYPE_OBJECT, GObject), _data_->list_id);
#line 6427 "imap-client-session.c"
	}
#line 1059 "../src/engine/imap/transport/imap-client-session.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1059 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1059 "../src/engine/imap/transport/imap-client-session.vala"
		block32_data_unref (_data_->_data32_);
#line 1059 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_data32_ = NULL;
#line 1059 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 1059 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 6441 "imap-client-session.c"
	}
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
	block32_data_unref (_data_->_data32_);
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_data32_ = NULL;
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_state_ != 0) {
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 6455 "imap-client-session.c"
		}
	}
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_unref (_data_->_async_result);
#line 1003 "../src/engine/imap/transport/imap-client-session.vala"
	return FALSE;
#line 6462 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_login (GearyImapClientSession* self,
                                    guint state,
                                    guint event,
                                    void* user,
                                    GObject* object)
{
	GearyImapClientSessionMachineParams* params = NULL;
	GearyImapClientSessionMachineParams* _tmp0_;
	GearyImapClientSessionMachineParams* _tmp1_;
	guint result;
#line 1125 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 1125 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 1126 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_CLIENT_SESSION_TYPE_MACHINE_PARAMS, GearyImapClientSessionMachineParams));
#line 1126 "../src/engine/imap/transport/imap-client-session.vala"
	params = _tmp0_;
#line 1128 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = params;
#line 1128 "../src/engine/imap/transport/imap-client-session.vala"
	if (!geary_imap_client_session_reserve_state_change_cmd (self, _tmp1_, state, event)) {
#line 1129 "../src/engine/imap/transport/imap-client-session.vala"
		result = state;
#line 1129 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (params);
#line 1129 "../src/engine/imap/transport/imap-client-session.vala"
		return result;
#line 6494 "imap-client-session.c"
	}
#line 1131 "../src/engine/imap/transport/imap-client-session.vala"
	result = (guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZING;
#line 1131 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (params);
#line 1131 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 6502 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_logging_in (GearyImapClientSession* self,
                                         guint state,
                                         guint event,
                                         void* user,
                                         GObject* object)
{
	GearyImapClientSessionMachineParams* params = NULL;
	GearyImapClientSessionMachineParams* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GError* _tmp3_;
	guint result;
#line 1134 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 1134 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 1135 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_CLIENT_SESSION_TYPE_MACHINE_PARAMS, GearyImapClientSessionMachineParams));
#line 1135 "../src/engine/imap/transport/imap-client-session.vala"
	params = _tmp0_;
#line 1137 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 1137 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = _tmp1_;
#line 1137 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_ALREADY_CONNECTED, "Already logging in to %s", _tmp2_);
#line 1137 "../src/engine/imap/transport/imap-client-session.vala"
	_g_error_free0 (params->err);
#line 1137 "../src/engine/imap/transport/imap-client-session.vala"
	params->err = _tmp3_;
#line 1137 "../src/engine/imap/transport/imap-client-session.vala"
	_g_free0 (_tmp2_);
#line 1139 "../src/engine/imap/transport/imap-client-session.vala"
	result = state;
#line 1139 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (params);
#line 1139 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 6544 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_login_recv_completion (GearyImapClientSession* self,
                                                    guint state,
                                                    guint event,
                                                    void* user,
                                                    GObject* object)
{
	GearyImapStatusResponse* completion_response = NULL;
	GearyImapStatusResponse* _tmp0_;
	GearyImapStatusResponse* _tmp1_;
	guint new_state = 0U;
	GearyImapStatusResponse* _tmp2_;
	GearyImapStatus _tmp3_;
	GearyImapStatus _tmp4_;
	guint result;
#line 1142 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 1142 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 1143 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_TYPE_STATUS_RESPONSE, GearyImapStatusResponse));
#line 1143 "../src/engine/imap/transport/imap-client-session.vala"
	completion_response = _tmp0_;
#line 1145 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = completion_response;
#line 1145 "../src/engine/imap/transport/imap-client-session.vala"
	if (!geary_imap_client_session_validate_state_change_cmd (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_IMAP_TYPE_SERVER_RESPONSE, GearyImapServerResponse), NULL)) {
#line 1146 "../src/engine/imap/transport/imap-client-session.vala"
		result = state;
#line 1146 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (completion_response);
#line 1146 "../src/engine/imap/transport/imap-client-session.vala"
		return result;
#line 6580 "imap-client-session.c"
	}
#line 1148 "../src/engine/imap/transport/imap-client-session.vala"
	new_state = (guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZED;
#line 1149 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = completion_response;
#line 1149 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = geary_imap_status_response_get_status (_tmp2_);
#line 1149 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp4_ = _tmp3_;
#line 1149 "../src/engine/imap/transport/imap-client-session.vala"
	if (_tmp4_ != GEARY_IMAP_STATUS_OK) {
#line 6592 "imap-client-session.c"
		GearyImapStatusResponse* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 1150 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp5_ = completion_response;
#line 1150 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp6_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 1150 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp7_ = _tmp6_;
#line 1150 "../src/engine/imap/transport/imap-client-session.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "LOGIN failed: %s", _tmp7_);
#line 1150 "../src/engine/imap/transport/imap-client-session.vala"
		_g_free0 (_tmp7_);
#line 1151 "../src/engine/imap/transport/imap-client-session.vala"
		new_state = (guint) GEARY_IMAP_CLIENT_SESSION_STATE_NOAUTH;
#line 6608 "imap-client-session.c"
	}
#line 1153 "../src/engine/imap/transport/imap-client-session.vala"
	result = new_state;
#line 1153 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (completion_response);
#line 1153 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 6616 "imap-client-session.c"
}

/**
     * Enables sending keep-alive commands for the sesion.
     *
     * Although keepalives can be enabled at any time, if they're
     * enabled and trigger sending a command prior to connection,
     * error signals may be fired.
     *
     * If values are negative or zero, keepalives will be disabled.
     * (This is not recommended.)
     */
void
geary_imap_client_session_enable_keepalives (GearyImapClientSession* self,
                                             guint seconds_while_selected,
                                             guint seconds_while_unselected,
                                             guint seconds_while_selected_with_idle)
{
#line 1171 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 1174 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->selected_keepalive_secs = seconds_while_selected;
#line 1175 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->selected_with_idle_keepalive_secs = seconds_while_selected_with_idle;
#line 1176 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->unselected_keepalive_secs = seconds_while_unselected;
#line 1180 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_schedule_keepalive (self);
#line 6645 "imap-client-session.c"
}

/**
     * Returns true if keepalives are disactivated, false if already disabled.
     */
gboolean
geary_imap_client_session_disable_keepalives (GearyImapClientSession* self)
{
	gboolean result;
#line 1186 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), FALSE);
#line 1187 "../src/engine/imap/transport/imap-client-session.vala"
	result = geary_imap_client_session_unschedule_keepalive (self);
#line 1187 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 6661 "imap-client-session.c"
}

static gboolean
geary_imap_client_session_unschedule_keepalive (GearyImapClientSession* self)
{
	gboolean result;
#line 1190 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), FALSE);
#line 1191 "../src/engine/imap/transport/imap-client-session.vala"
	if (self->priv->keepalive_id == ((guint) 0)) {
#line 1192 "../src/engine/imap/transport/imap-client-session.vala"
		result = FALSE;
#line 1192 "../src/engine/imap/transport/imap-client-session.vala"
		return result;
#line 6676 "imap-client-session.c"
	}
#line 1194 "../src/engine/imap/transport/imap-client-session.vala"
	g_source_remove (self->priv->keepalive_id);
#line 1195 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->keepalive_id = (guint) 0;
#line 1197 "../src/engine/imap/transport/imap-client-session.vala"
	result = TRUE;
#line 1197 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 6686 "imap-client-session.c"
}

/**
     * Enables IMAP IDLE for the client session, if supported.
     *
     * If enabled, an IDLE command will be used for notification of
     * unsolicited server data whenever a mailbox is selected or
     * examined.  IDLE will only be used if ClientSession has seen a
     * CAPABILITY server data response with IDLE listed as a supported
     * extension.
     */
void
geary_imap_client_session_enable_idle (GearyImapClientSession* self,
                                       GError** error)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GError* _inner_error0_ = NULL;
#line 1209 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 1211 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = geary_imap_client_session_get_is_idle_supported (self);
#line 1211 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = _tmp0_;
#line 1211 "../src/engine/imap/transport/imap-client-session.vala"
	if (_tmp1_) {
#line 6713 "imap-client-session.c"
		GearyImapClientSessionProtocolState _tmp2_;
		GearyImapClientSessionProtocolState _tmp3_;
#line 1212 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp2_ = geary_imap_client_session_get_protocol_state (self);
#line 1212 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp3_ = _tmp2_;
#line 1212 "../src/engine/imap/transport/imap-client-session.vala"
		switch (_tmp3_) {
#line 1212 "../src/engine/imap/transport/imap-client-session.vala"
			case GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_AUTHORIZING:
#line 1212 "../src/engine/imap/transport/imap-client-session.vala"
			case GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_AUTHORIZED:
#line 1212 "../src/engine/imap/transport/imap-client-session.vala"
			case GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_SELECTED:
#line 1212 "../src/engine/imap/transport/imap-client-session.vala"
			case GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_SELECTING:
#line 6730 "imap-client-session.c"
			{
				GearyImapClientConnection* _tmp4_;
#line 1217 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp4_ = self->priv->cx;
#line 1217 "../src/engine/imap/transport/imap-client-session.vala"
				geary_imap_client_connection_enable_idle_when_quiet (_tmp4_, TRUE);
#line 1218 "../src/engine/imap/transport/imap-client-session.vala"
				break;
#line 6739 "imap-client-session.c"
			}
			default:
			{
				GError* _tmp5_;
#line 1221 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp5_ = g_error_new_literal (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_NOT_SUPPORTED, "IMAP IDLE only supported in AUTHORIZED or SELECTED states");
#line 1221 "../src/engine/imap/transport/imap-client-session.vala"
				_inner_error0_ = _tmp5_;
#line 1221 "../src/engine/imap/transport/imap-client-session.vala"
				g_propagate_error (error, _inner_error0_);
#line 1221 "../src/engine/imap/transport/imap-client-session.vala"
				return;
#line 6752 "imap-client-session.c"
			}
		}
	}
}

static gboolean
_geary_imap_client_session_on_keepalive_gsource_func (gpointer self)
{
	gboolean result;
	result = geary_imap_client_session_on_keepalive ((GearyImapClientSession*) self);
#line 1258 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 6765 "imap-client-session.c"
}

static void
geary_imap_client_session_schedule_keepalive (GearyImapClientSession* self)
{
	guint seconds = 0U;
	GearyImapClientSessionProtocolState _tmp0_;
	GearyImapClientSessionProtocolState _tmp1_;
#line 1228 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 1230 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_unschedule_keepalive (self);
#line 1233 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = geary_imap_client_session_get_protocol_state (self);
#line 1233 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = _tmp0_;
#line 1233 "../src/engine/imap/transport/imap-client-session.vala"
	switch (_tmp1_) {
#line 1233 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_NOT_CONNECTED:
#line 1233 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_CONNECTING:
#line 6788 "imap-client-session.c"
		{
#line 1236 "../src/engine/imap/transport/imap-client-session.vala"
			return;
#line 6792 "imap-client-session.c"
		}
#line 1233 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_SELECTING:
#line 1233 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_SELECTED:
#line 6798 "imap-client-session.c"
		{
			guint _tmp2_ = 0U;
			gboolean _tmp3_ = FALSE;
			GearyImapClientConnection* _tmp4_;
			gboolean _tmp5_;
			gboolean _tmp6_;
#line 1240 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp4_ = self->priv->cx;
#line 1240 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp5_ = geary_imap_client_connection_get_idle_when_quiet (_tmp4_);
#line 1240 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp6_ = _tmp5_;
#line 1240 "../src/engine/imap/transport/imap-client-session.vala"
			if (_tmp6_) {
#line 6813 "imap-client-session.c"
				gboolean _tmp7_;
				gboolean _tmp8_;
#line 1240 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp7_ = geary_imap_client_session_get_is_idle_supported (self);
#line 1240 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp8_ = _tmp7_;
#line 1240 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp3_ = _tmp8_;
#line 6822 "imap-client-session.c"
			} else {
#line 1240 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp3_ = FALSE;
#line 6826 "imap-client-session.c"
			}
#line 1240 "../src/engine/imap/transport/imap-client-session.vala"
			if (_tmp3_) {
#line 1241 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp2_ = self->priv->selected_with_idle_keepalive_secs;
#line 6832 "imap-client-session.c"
			} else {
#line 1242 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp2_ = self->priv->selected_keepalive_secs;
#line 6836 "imap-client-session.c"
			}
#line 1240 "../src/engine/imap/transport/imap-client-session.vala"
			seconds = _tmp2_;
#line 1243 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 6842 "imap-client-session.c"
		}
		default:
#line 1233 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_UNAUTHORIZED:
#line 1233 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_AUTHORIZING:
#line 1233 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_AUTHORIZED:
#line 1233 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_CLOSING_MAILBOX:
#line 6853 "imap-client-session.c"
		{
#line 1250 "../src/engine/imap/transport/imap-client-session.vala"
			seconds = self->priv->unselected_keepalive_secs;
#line 1251 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 6859 "imap-client-session.c"
		}
	}
#line 1257 "../src/engine/imap/transport/imap-client-session.vala"
	if (seconds > ((guint) 0)) {
#line 1258 "../src/engine/imap/transport/imap-client-session.vala"
		self->priv->keepalive_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, seconds, _geary_imap_client_session_on_keepalive_gsource_func, g_object_ref (self), g_object_unref);
#line 6866 "imap-client-session.c"
	}
}

static void
_geary_imap_client_session_on_keepalive_completed_gasync_ready_callback (GObject* source_object,
                                                                         GAsyncResult* res,
                                                                         gpointer self)
{
#line 1266 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_on_keepalive_completed ((GearyImapClientSession*) self, source_object, res);
#line 1266 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_unref (self);
#line 6879 "imap-client-session.c"
}

static gboolean
geary_imap_client_session_on_keepalive (GearyImapClientSession* self)
{
	GearyImapNoopCommand* _tmp0_;
	GearyImapNoopCommand* _tmp1_;
	gboolean result;
#line 1261 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), FALSE);
#line 1264 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->keepalive_id = (guint) 0;
#line 1266 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = geary_imap_noop_command_new (NULL);
#line 1266 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = _tmp0_;
#line 1266 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_send_command_async (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_IMAP_TYPE_COMMAND, GearyImapCommand), _geary_imap_client_session_on_keepalive_completed_gasync_ready_callback, g_object_ref (self));
#line 1266 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_tmp1_);
#line 1270 "../src/engine/imap/transport/imap-client-session.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Sending keepalive...");
#line 1275 "../src/engine/imap/transport/imap-client-session.vala"
	result = FALSE;
#line 1275 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 6906 "imap-client-session.c"
}

static void
geary_imap_client_session_on_keepalive_completed (GearyImapClientSession* self,
                                                  GObject* source,
                                                  GAsyncResult* _result_)
{
	GError* _inner_error0_ = NULL;
#line 1278 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 1278 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail ((source == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (source, G_TYPE_OBJECT));
#line 1278 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (_result_, g_async_result_get_type ()));
#line 6921 "imap-client-session.c"
	{
		GearyImapStatusResponse* _tmp0_;
		GearyImapStatusResponse* _tmp1_;
#line 1280 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp0_ = geary_imap_client_session_send_command_finish (self, _result_, &_inner_error0_);
#line 1280 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp1_ = _tmp0_;
#line 1280 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_tmp1_);
#line 1280 "../src/engine/imap/transport/imap-client-session.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6933 "imap-client-session.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 1279 "../src/engine/imap/transport/imap-client-session.vala"
		err = _inner_error0_;
#line 1279 "../src/engine/imap/transport/imap-client-session.vala"
		_inner_error0_ = NULL;
#line 1282 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp2_ = err;
#line 1282 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp3_ = _tmp2_->message;
#line 1282 "../src/engine/imap/transport/imap-client-session.vala"
		geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Keepalive error: %s", _tmp3_);
#line 1279 "../src/engine/imap/transport/imap-client-session.vala"
		_g_error_free0 (err);
#line 6955 "imap-client-session.c"
	}
	__finally0:
#line 1279 "../src/engine/imap/transport/imap-client-session.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1279 "../src/engine/imap/transport/imap-client-session.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1279 "../src/engine/imap/transport/imap-client-session.vala"
		g_clear_error (&_inner_error0_);
#line 1279 "../src/engine/imap/transport/imap-client-session.vala"
		return;
#line 6966 "imap-client-session.c"
	}
}

static void
geary_imap_client_session_send_command_async_data_free (gpointer _data)
{
	GearyImapClientSessionSendCommandAsyncData* _data_;
	_data_ = _data;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cmd);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->result);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_slice_free (GearyImapClientSessionSendCommandAsyncData, _data_);
#line 6983 "imap-client-session.c"
}

void
geary_imap_client_session_send_command_async (GearyImapClientSession* self,
                                              GearyImapCommand* cmd,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	GearyImapClientSessionSendCommandAsyncData* _data_;
	GearyImapClientSession* _tmp0_;
	GearyImapCommand* _tmp1_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (cmd));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_slice_new0 (GearyImapClientSessionSendCommandAsyncData);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_session_send_command_async_data_free);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->self = _tmp0_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = _g_object_ref0 (cmd);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cmd);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->cmd = _tmp1_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_send_command_async_co (_data_);
#line 7017 "imap-client-session.c"
}

GearyImapStatusResponse*
geary_imap_client_session_send_command_finish (GearyImapClientSession* self,
                                               GAsyncResult* _res_,
                                               GError** error)
{
	GearyImapStatusResponse* result;
	GearyImapClientSessionSendCommandAsyncData* _data_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	if (NULL == _data_) {
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		return NULL;
#line 7033 "imap-client-session.c"
	}
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	result = _data_->result;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->result = NULL;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 7041 "imap-client-session.c"
}

static void
geary_imap_client_session_send_command_async_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_)
{
	GearyImapClientSessionSendCommandAsyncData* _data_;
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = _user_data_;
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_source_object_ = source_object;
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_res_ = _res_;
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_send_command_async_co (_data_);
#line 7058 "imap-client-session.c"
}

static gboolean
geary_imap_client_session_send_command_async_co (GearyImapClientSessionSendCommandAsyncData* _data_)
{
#line 1290 "../src/engine/imap/transport/imap-client-session.vala"
	switch (_data_->_state_) {
#line 1290 "../src/engine/imap/transport/imap-client-session.vala"
		case 0:
#line 7068 "imap-client-session.c"
		goto _state_0;
#line 1290 "../src/engine/imap/transport/imap-client-session.vala"
		case 1:
#line 7072 "imap-client-session.c"
		goto _state_1;
		default:
#line 1290 "../src/engine/imap/transport/imap-client-session.vala"
		g_assert_not_reached ();
#line 7077 "imap-client-session.c"
	}
	_state_0:
#line 1292 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_check_unsupported_send_command (_data_->self, _data_->cmd, &_data_->_inner_error0_);
#line 1292 "../src/engine/imap/transport/imap-client-session.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1292 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1292 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 1292 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 7090 "imap-client-session.c"
	}
#line 1294 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp0_ = geary_imap_client_session_machine_params_new (_data_->cmd);
#line 1294 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->params = _data_->_tmp0_;
#line 1295 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp1_ = _data_->self->priv->fsm;
#line 1295 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp2_ = _data_->params;
#line 1295 "../src/engine/imap/transport/imap-client-session.vala"
	geary_state_machine_issue (_data_->_tmp1_, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_CMD, NULL, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, G_TYPE_OBJECT, GObject), NULL);
#line 1297 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp3_ = _data_->params;
#line 1297 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp4_ = _data_->_tmp3_->err;
#line 1297 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_tmp4_ != NULL) {
#line 1298 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp5_ = _data_->params;
#line 1298 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp6_ = _data_->_tmp5_->err;
#line 1298 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp7_ = _g_error_copy0 (_data_->_tmp6_);
#line 1298 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_inner_error0_ = _data_->_tmp7_;
#line 1298 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1298 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->params);
#line 1298 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 1298 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 7124 "imap-client-session.c"
	}
#line 1300 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp8_ = _data_->params;
#line 1300 "../src/engine/imap/transport/imap-client-session.vala"
	_vala_assert (_data_->_tmp8_->proceed, "params.proceed");
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_state_ = 1;
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_submit_command (_data_->self, _data_->cmd, geary_imap_client_session_send_command_async_ready, _data_);
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
	return FALSE;
#line 7136 "imap-client-session.c"
	_state_1:
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp10_ = geary_imap_client_session_submit_command_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp9_ = _data_->_tmp10_;
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->params);
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 7152 "imap-client-session.c"
	}
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp11_ = _data_->_tmp9_;
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp9_ = NULL;
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->result = _data_->_tmp11_;
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->_tmp9_);
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->params);
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_state_ != 0) {
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7172 "imap-client-session.c"
		}
	}
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_unref (_data_->_async_result);
#line 1302 "../src/engine/imap/transport/imap-client-session.vala"
	return FALSE;
#line 7179 "imap-client-session.c"
}

static void
geary_imap_client_session_send_multiple_commands_async_data_free (gpointer _data)
{
	GearyImapClientSessionSendMultipleCommandsAsyncData* _data_;
	_data_ = _data;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cmds);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->result);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_slice_free (GearyImapClientSessionSendMultipleCommandsAsyncData, _data_);
#line 7197 "imap-client-session.c"
}

void
geary_imap_client_session_send_multiple_commands_async (GearyImapClientSession* self,
                                                        GeeCollection* cmds,
                                                        GCancellable* cancellable,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_)
{
	GearyImapClientSessionSendMultipleCommandsAsyncData* _data_;
	GearyImapClientSession* _tmp0_;
	GeeCollection* _tmp1_;
	GCancellable* _tmp2_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cmds, GEE_TYPE_COLLECTION));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_slice_new0 (GearyImapClientSessionSendMultipleCommandsAsyncData);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_session_send_multiple_commands_async_data_free);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->self = _tmp0_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = _g_object_ref0 (cmds);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cmds);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->cmds = _tmp1_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->cancellable = _tmp2_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_send_multiple_commands_async_co (_data_);
#line 7241 "imap-client-session.c"
}

GeeMap*
geary_imap_client_session_send_multiple_commands_finish (GearyImapClientSession* self,
                                                         GAsyncResult* _res_,
                                                         GError** error)
{
	GeeMap* result;
	GearyImapClientSessionSendMultipleCommandsAsyncData* _data_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	if (NULL == _data_) {
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		return NULL;
#line 7257 "imap-client-session.c"
	}
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	result = _data_->result;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->result = NULL;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 7265 "imap-client-session.c"
}

static void
geary_imap_client_session_send_multiple_commands_async_ready (GObject* source_object,
                                                              GAsyncResult* _res_,
                                                              gpointer _user_data_)
{
	GearyImapClientSessionSendMultipleCommandsAsyncData* _data_;
#line 1343 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = _user_data_;
#line 1343 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_source_object_ = source_object;
#line 1343 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_res_ = _res_;
#line 1343 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_send_multiple_commands_async_co (_data_);
#line 7282 "imap-client-session.c"
}

static gboolean
geary_imap_client_session_send_multiple_commands_async_co (GearyImapClientSessionSendMultipleCommandsAsyncData* _data_)
{
#line 1305 "../src/engine/imap/transport/imap-client-session.vala"
	switch (_data_->_state_) {
#line 1305 "../src/engine/imap/transport/imap-client-session.vala"
		case 0:
#line 7292 "imap-client-session.c"
		goto _state_0;
#line 1305 "../src/engine/imap/transport/imap-client-session.vala"
		case 1:
#line 7296 "imap-client-session.c"
		goto _state_1;
		default:
#line 1305 "../src/engine/imap/transport/imap-client-session.vala"
		g_assert_not_reached ();
#line 7301 "imap-client-session.c"
	}
	_state_0:
#line 1309 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp0_ = gee_collection_get_size (_data_->cmds);
#line 1309 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 1309 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_tmp1_ == 0) {
#line 1310 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp2_ = g_error_new_literal (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_INVALID, "Must supply at least one command");
#line 1310 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_inner_error0_ = _data_->_tmp2_;
#line 1310 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1310 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 1310 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 7320 "imap-client-session.c"
	}
	{
#line 1312 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_data_->cmds, GEE_TYPE_ITERABLE, GeeIterable));
#line 1312 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_cmd_it = _data_->_tmp3_;
#line 1312 "../src/engine/imap/transport/imap-client-session.vala"
		while (TRUE) {
#line 1312 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp4_ = _data_->_cmd_it;
#line 1312 "../src/engine/imap/transport/imap-client-session.vala"
			if (!gee_iterator_next (_data_->_tmp4_)) {
#line 1312 "../src/engine/imap/transport/imap-client-session.vala"
				break;
#line 7335 "imap-client-session.c"
			}
#line 1312 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp5_ = _data_->_cmd_it;
#line 1312 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp6_ = gee_iterator_get (_data_->_tmp5_);
#line 1312 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->cmd = (GearyImapCommand*) _data_->_tmp6_;
#line 1313 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp7_ = _data_->cmd;
#line 1313 "../src/engine/imap/transport/imap-client-session.vala"
			geary_imap_client_session_check_unsupported_send_command (_data_->self, _data_->_tmp7_, &_data_->_inner_error0_);
#line 1313 "../src/engine/imap/transport/imap-client-session.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1313 "../src/engine/imap/transport/imap-client-session.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1313 "../src/engine/imap/transport/imap-client-session.vala"
				_g_object_unref0 (_data_->cmd);
#line 1313 "../src/engine/imap/transport/imap-client-session.vala"
				_g_object_unref0 (_data_->_cmd_it);
#line 1313 "../src/engine/imap/transport/imap-client-session.vala"
				g_object_unref (_data_->_async_result);
#line 1313 "../src/engine/imap/transport/imap-client-session.vala"
				return FALSE;
#line 7359 "imap-client-session.c"
			}
#line 1312 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->cmd);
#line 7363 "imap-client-session.c"
		}
#line 1312 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->_cmd_it);
#line 7367 "imap-client-session.c"
	}
#line 1316 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp8_ = geary_collection_first (GEARY_IMAP_TYPE_COMMAND, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _data_->cmds);
#line 1316 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp9_ = (GearyImapCommand*) _data_->_tmp8_;
#line 1316 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp10_ = geary_imap_client_session_machine_params_new (_data_->_tmp9_);
#line 1316 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp11_ = _data_->_tmp10_;
#line 1316 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->_tmp9_);
#line 1316 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->params = _data_->_tmp11_;
#line 1317 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp12_ = _data_->self->priv->fsm;
#line 1317 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp13_ = _data_->params;
#line 1317 "../src/engine/imap/transport/imap-client-session.vala"
	geary_state_machine_issue (_data_->_tmp12_, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_CMD, NULL, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp13_, G_TYPE_OBJECT, GObject), NULL);
#line 1319 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp14_ = _data_->params;
#line 1319 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp15_ = _data_->_tmp14_->err;
#line 1319 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_tmp15_ != NULL) {
#line 1320 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp16_ = _data_->params;
#line 1320 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp17_ = _data_->_tmp16_->err;
#line 1320 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp18_ = _g_error_copy0 (_data_->_tmp17_);
#line 1320 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_inner_error0_ = _data_->_tmp18_;
#line 1320 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1320 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->params);
#line 1320 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 1320 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 7409 "imap-client-session.c"
	}
#line 1322 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp19_ = _data_->params;
#line 1322 "../src/engine/imap/transport/imap-client-session.vala"
	_vala_assert (_data_->_tmp19_->proceed, "params.proceed");
#line 1328 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp20_ = _data_->self->priv->_quirks;
#line 1328 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp21_ = geary_imap_quirks_get_max_pipeline_batch_size (_data_->_tmp20_);
#line 1328 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp22_ = _data_->_tmp21_;
#line 1328 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->max_batch_size = _data_->_tmp22_;
#line 1329 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->max_batch_size < ((guint) 1)) {
#line 1330 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp23_ = gee_collection_get_size (_data_->cmds);
#line 1330 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp24_ = _data_->_tmp23_;
#line 1330 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->max_batch_size = (guint) _data_->_tmp24_;
#line 7431 "imap-client-session.c"
	}
#line 1333 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp25_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_data_->cmds, GEE_TYPE_ITERABLE, GeeIterable));
#line 1333 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->cmd_remaining = _data_->_tmp25_;
#line 1334 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->batch = NULL;
#line 1335 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp26_ = gee_hash_map_new (GEARY_IMAP_TYPE_COMMAND, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GEARY_IMAP_TYPE_STATUS_RESPONSE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1335 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->responses = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp26_, GEE_TYPE_MAP, GeeMap);
#line 1336 "../src/engine/imap/transport/imap-client-session.vala"
	while (TRUE) {
#line 1336 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp27_ = _data_->cmd_remaining;
#line 1336 "../src/engine/imap/transport/imap-client-session.vala"
		if (!gee_iterator_has_next (_data_->_tmp27_)) {
#line 1336 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 7451 "imap-client-session.c"
		}
#line 1337 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp28_ = geary_nonblocking_batch_new ();
#line 1337 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->batch);
#line 1337 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->batch = _data_->_tmp28_;
#line 1338 "../src/engine/imap/transport/imap-client-session.vala"
		while (TRUE) {
#line 1338 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp30_ = _data_->cmd_remaining;
#line 1338 "../src/engine/imap/transport/imap-client-session.vala"
			if (gee_iterator_has_next (_data_->_tmp30_)) {
#line 1338 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp31_ = _data_->batch;
#line 1338 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp32_ = geary_nonblocking_batch_get_size (_data_->_tmp31_);
#line 1338 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp33_ = _data_->_tmp32_;
#line 1338 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp29_ = ((guint) _data_->_tmp33_) < _data_->max_batch_size;
#line 7473 "imap-client-session.c"
			} else {
#line 1338 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp29_ = FALSE;
#line 7477 "imap-client-session.c"
			}
#line 1338 "../src/engine/imap/transport/imap-client-session.vala"
			if (!_data_->_tmp29_) {
#line 1338 "../src/engine/imap/transport/imap-client-session.vala"
				break;
#line 7483 "imap-client-session.c"
			}
#line 1339 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp34_ = _data_->cmd_remaining;
#line 1339 "../src/engine/imap/transport/imap-client-session.vala"
			gee_iterator_next (_data_->_tmp34_);
#line 1340 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp35_ = _data_->batch;
#line 1340 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp36_ = _data_->cmd_remaining;
#line 1340 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp37_ = gee_iterator_get (_data_->_tmp36_);
#line 1340 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp38_ = (GearyImapCommand*) _data_->_tmp37_;
#line 1340 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp39_ = geary_imap_client_session_send_command_operation_new (_data_->self, _data_->_tmp38_);
#line 1340 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp40_ = _data_->_tmp39_;
#line 1340 "../src/engine/imap/transport/imap-client-session.vala"
			geary_nonblocking_batch_add (_data_->_tmp35_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp40_, GEARY_NONBLOCKING_TYPE_BATCH_OPERATION, GearyNonblockingBatchOperation));
#line 1340 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->_tmp40_);
#line 1340 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->_tmp38_);
#line 7507 "imap-client-session.c"
		}
#line 1343 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp41_ = _data_->batch;
#line 1343 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_state_ = 1;
#line 1343 "../src/engine/imap/transport/imap-client-session.vala"
		geary_nonblocking_batch_execute_all_async (_data_->_tmp41_, _data_->cancellable, geary_imap_client_session_send_multiple_commands_async_ready, _data_);
#line 1343 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 7517 "imap-client-session.c"
		_state_1:
#line 1343 "../src/engine/imap/transport/imap-client-session.vala"
		geary_nonblocking_batch_execute_all_finish (_data_->_tmp41_, _data_->_res_, &_data_->_inner_error0_);
#line 1343 "../src/engine/imap/transport/imap-client-session.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1343 "../src/engine/imap/transport/imap-client-session.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1343 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->responses);
#line 1343 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->batch);
#line 1343 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->cmd_remaining);
#line 1343 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->params);
#line 1343 "../src/engine/imap/transport/imap-client-session.vala"
			g_object_unref (_data_->_async_result);
#line 1343 "../src/engine/imap/transport/imap-client-session.vala"
			return FALSE;
#line 7537 "imap-client-session.c"
		}
#line 1344 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp42_ = _data_->batch;
#line 1344 "../src/engine/imap/transport/imap-client-session.vala"
		geary_nonblocking_batch_throw_first_exception (_data_->_tmp42_, &_data_->_inner_error0_);
#line 1344 "../src/engine/imap/transport/imap-client-session.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1344 "../src/engine/imap/transport/imap-client-session.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1344 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->responses);
#line 1344 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->batch);
#line 1344 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->cmd_remaining);
#line 1344 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->params);
#line 1344 "../src/engine/imap/transport/imap-client-session.vala"
			g_object_unref (_data_->_async_result);
#line 1344 "../src/engine/imap/transport/imap-client-session.vala"
			return FALSE;
#line 7559 "imap-client-session.c"
		}
		{
#line 1346 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp43_ = _data_->batch;
#line 1346 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp44_ = geary_nonblocking_batch_get_ids (_data_->_tmp43_);
#line 1346 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp45_ = _data_->_tmp44_;
#line 1346 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp46_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp45_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1346 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_tmp47_ = _data_->_tmp46_;
#line 1346 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->_tmp45_);
#line 1346 "../src/engine/imap/transport/imap-client-session.vala"
			_data_->_id_it = _data_->_tmp47_;
#line 1346 "../src/engine/imap/transport/imap-client-session.vala"
			while (TRUE) {
#line 1346 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp48_ = _data_->_id_it;
#line 1346 "../src/engine/imap/transport/imap-client-session.vala"
				if (!gee_iterator_next (_data_->_tmp48_)) {
#line 1346 "../src/engine/imap/transport/imap-client-session.vala"
					break;
#line 7584 "imap-client-session.c"
				}
#line 1346 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp49_ = _data_->_id_it;
#line 1346 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp50_ = gee_iterator_get (_data_->_tmp49_);
#line 1346 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->id = (gint) ((gintptr) _data_->_tmp50_);
#line 1347 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp51_ = _data_->batch;
#line 1347 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp52_ = geary_nonblocking_batch_get_operation (_data_->_tmp51_, _data_->id);
#line 1347 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->op = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp52_, GEARY_IMAP_CLIENT_SESSION_TYPE_SEND_COMMAND_OPERATION, GearyImapClientSessionSendCommandOperation);
#line 1348 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp53_ = _data_->responses;
#line 1348 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp54_ = _data_->op;
#line 1348 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp55_ = _data_->_tmp54_->cmd;
#line 1348 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp56_ = _data_->op;
#line 1348 "../src/engine/imap/transport/imap-client-session.vala"
				_data_->_tmp57_ = _data_->_tmp56_->response;
#line 1348 "../src/engine/imap/transport/imap-client-session.vala"
				gee_map_set (_data_->_tmp53_, _data_->_tmp55_, _data_->_tmp57_);
#line 1346 "../src/engine/imap/transport/imap-client-session.vala"
				_g_object_unref0 (_data_->op);
#line 7612 "imap-client-session.c"
			}
#line 1346 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->_id_it);
#line 7616 "imap-client-session.c"
		}
	}
#line 1352 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->result = _data_->responses;
#line 1352 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->batch);
#line 1352 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cmd_remaining);
#line 1352 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->params);
#line 1352 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1352 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_state_ != 0) {
#line 1352 "../src/engine/imap/transport/imap-client-session.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1352 "../src/engine/imap/transport/imap-client-session.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7635 "imap-client-session.c"
		}
	}
#line 1352 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_unref (_data_->_async_result);
#line 1352 "../src/engine/imap/transport/imap-client-session.vala"
	return FALSE;
#line 7642 "imap-client-session.c"
}

static void
geary_imap_client_session_check_unsupported_send_command (GearyImapClientSession* self,
                                                          GearyImapCommand* cmd,
                                                          GError** error)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 1355 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 1355 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (cmd));
#line 1360 "../src/engine/imap/transport/imap-client-session.vala"
	if (geary_imap_command_has_name (cmd, GEARY_IMAP_LOGIN_COMMAND_NAME)) {
#line 1360 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp4_ = TRUE;
#line 7664 "imap-client-session.c"
	} else {
#line 1361 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp4_ = geary_imap_command_has_name (cmd, GEARY_IMAP_AUTHENTICATE_COMMAND_NAME);
#line 7668 "imap-client-session.c"
	}
#line 1360 "../src/engine/imap/transport/imap-client-session.vala"
	if (_tmp4_) {
#line 1360 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp3_ = TRUE;
#line 7674 "imap-client-session.c"
	} else {
#line 1362 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp3_ = geary_imap_command_has_name (cmd, GEARY_IMAP_LOGOUT_COMMAND_NAME);
#line 7678 "imap-client-session.c"
	}
#line 1360 "../src/engine/imap/transport/imap-client-session.vala"
	if (_tmp3_) {
#line 1360 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp2_ = TRUE;
#line 7684 "imap-client-session.c"
	} else {
#line 1363 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp2_ = geary_imap_command_has_name (cmd, GEARY_IMAP_SELECT_COMMAND_NAME);
#line 7688 "imap-client-session.c"
	}
#line 1360 "../src/engine/imap/transport/imap-client-session.vala"
	if (_tmp2_) {
#line 1360 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp1_ = TRUE;
#line 7694 "imap-client-session.c"
	} else {
#line 1364 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp1_ = geary_imap_command_has_name (cmd, GEARY_IMAP_EXAMINE_COMMAND_NAME);
#line 7698 "imap-client-session.c"
	}
#line 1360 "../src/engine/imap/transport/imap-client-session.vala"
	if (_tmp1_) {
#line 1360 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp0_ = TRUE;
#line 7704 "imap-client-session.c"
	} else {
#line 1365 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp0_ = geary_imap_command_has_name (cmd, GEARY_IMAP_CLOSE_COMMAND_NAME);
#line 7708 "imap-client-session.c"
	}
#line 1360 "../src/engine/imap/transport/imap-client-session.vala"
	if (_tmp0_) {
#line 7712 "imap-client-session.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		GError* _tmp7_;
#line 1366 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp5_ = geary_imap_command_get_name (cmd);
#line 1366 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp6_ = _tmp5_;
#line 1366 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp7_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_NOT_SUPPORTED, "Use direct calls rather than commands for %s", _tmp6_);
#line 1366 "../src/engine/imap/transport/imap-client-session.vala"
		_inner_error0_ = _tmp7_;
#line 1366 "../src/engine/imap/transport/imap-client-session.vala"
		g_propagate_error (error, _inner_error0_);
#line 1366 "../src/engine/imap/transport/imap-client-session.vala"
		return;
#line 7728 "imap-client-session.c"
	}
}

static guint
geary_imap_client_session_on_send_command (GearyImapClientSession* self,
                                           guint state,
                                           guint event,
                                           void* user,
                                           GObject* object)
{
	GearyImapClientSessionMachineParams* params = NULL;
	GearyImapClientSessionMachineParams* _tmp0_;
	guint result;
#line 1370 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 1370 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 1371 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_CLIENT_SESSION_TYPE_MACHINE_PARAMS, GearyImapClientSessionMachineParams));
#line 1371 "../src/engine/imap/transport/imap-client-session.vala"
	params = _tmp0_;
#line 1373 "../src/engine/imap/transport/imap-client-session.vala"
	params->proceed = TRUE;
#line 1375 "../src/engine/imap/transport/imap-client-session.vala"
	result = state;
#line 1375 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (params);
#line 1375 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 7758 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_recv_status (GearyImapClientSession* self,
                                          guint state,
                                          guint event,
                                          void* user,
                                          GObject* object)
{
	GearyImapStatusResponse* status_response = NULL;
	GearyImapStatusResponse* _tmp0_;
	GearyImapStatusResponse* _tmp1_;
	GearyImapStatus _tmp2_;
	GearyImapStatus _tmp3_;
	guint result;
#line 1378 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 1378 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 1379 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_TYPE_STATUS_RESPONSE, GearyImapStatusResponse));
#line 1379 "../src/engine/imap/transport/imap-client-session.vala"
	status_response = _tmp0_;
#line 1381 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = status_response;
#line 1381 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = geary_imap_status_response_get_status (_tmp1_);
#line 1381 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = _tmp2_;
#line 1381 "../src/engine/imap/transport/imap-client-session.vala"
	switch (_tmp3_) {
#line 1381 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_STATUS_OK:
#line 7792 "imap-client-session.c"
		{
#line 1384 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 7796 "imap-client-session.c"
		}
#line 1381 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_STATUS_BYE:
#line 7800 "imap-client-session.c"
		{
			GearyImapStatusResponse* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
#line 1387 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp4_ = status_response;
#line 1387 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp5_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 1387 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp6_ = _tmp5_;
#line 1387 "../src/engine/imap/transport/imap-client-session.vala"
			geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Received unilateral BYE from server: %s", _tmp6_);
#line 1387 "../src/engine/imap/transport/imap-client-session.vala"
			_g_free0 (_tmp6_);
#line 1391 "../src/engine/imap/transport/imap-client-session.vala"
			geary_imap_client_session_do_disconnect (self, GEARY_IMAP_CLIENT_SESSION_DISCONNECT_REASON_REMOTE_CLOSE, NULL, NULL);
#line 1392 "../src/engine/imap/transport/imap-client-session.vala"
			state = (guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSED;
#line 1393 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 7821 "imap-client-session.c"
		}
		default:
		{
			GearyImapStatusResponse* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
#line 1396 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp7_ = status_response;
#line 1396 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp8_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 1396 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp9_ = _tmp8_;
#line 1396 "../src/engine/imap/transport/imap-client-session.vala"
			geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Received error from server: %s", _tmp9_);
#line 1396 "../src/engine/imap/transport/imap-client-session.vala"
			_g_free0 (_tmp9_);
#line 1398 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 7840 "imap-client-session.c"
		}
	}
#line 1401 "../src/engine/imap/transport/imap-client-session.vala"
	result = state;
#line 1401 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (status_response);
#line 1401 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 7849 "imap-client-session.c"
}

static void
geary_imap_client_session_select_async_data_free (gpointer _data)
{
	GearyImapClientSessionSelectAsyncData* _data_;
	_data_ = _data;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->mailbox);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->result);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_slice_free (GearyImapClientSessionSelectAsyncData, _data_);
#line 7867 "imap-client-session.c"
}

void
geary_imap_client_session_select_async (GearyImapClientSession* self,
                                        GearyImapMailboxSpecifier* mailbox,
                                        GCancellable* cancellable,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	GearyImapClientSessionSelectAsyncData* _data_;
	GearyImapClientSession* _tmp0_;
	GearyImapMailboxSpecifier* _tmp1_;
	GCancellable* _tmp2_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_MAILBOX_SPECIFIER (mailbox));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_slice_new0 (GearyImapClientSessionSelectAsyncData);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_session_select_async_data_free);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->self = _tmp0_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = _g_object_ref0 (mailbox);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->mailbox);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->mailbox = _tmp1_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->cancellable = _tmp2_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_select_async_co (_data_);
#line 7911 "imap-client-session.c"
}

GearyImapStatusResponse*
geary_imap_client_session_select_finish (GearyImapClientSession* self,
                                         GAsyncResult* _res_,
                                         GError** error)
{
	GearyImapStatusResponse* result;
	GearyImapClientSessionSelectAsyncData* _data_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	if (NULL == _data_) {
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		return NULL;
#line 7927 "imap-client-session.c"
	}
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	result = _data_->result;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->result = NULL;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 7935 "imap-client-session.c"
}

static void
geary_imap_client_session_select_async_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_)
{
	GearyImapClientSessionSelectAsyncData* _data_;
#line 1411 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = _user_data_;
#line 1411 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_source_object_ = source_object;
#line 1411 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_res_ = _res_;
#line 1411 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_select_async_co (_data_);
#line 7952 "imap-client-session.c"
}

static gboolean
geary_imap_client_session_select_async_co (GearyImapClientSessionSelectAsyncData* _data_)
{
#line 1408 "../src/engine/imap/transport/imap-client-session.vala"
	switch (_data_->_state_) {
#line 1408 "../src/engine/imap/transport/imap-client-session.vala"
		case 0:
#line 7962 "imap-client-session.c"
		goto _state_0;
#line 1408 "../src/engine/imap/transport/imap-client-session.vala"
		case 1:
#line 7966 "imap-client-session.c"
		goto _state_1;
		default:
#line 1408 "../src/engine/imap/transport/imap-client-session.vala"
		g_assert_not_reached ();
#line 7971 "imap-client-session.c"
	}
	_state_0:
#line 1411 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_state_ = 1;
#line 1411 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_select_examine_async (_data_->self, _data_->mailbox, TRUE, _data_->cancellable, geary_imap_client_session_select_async_ready, _data_);
#line 1411 "../src/engine/imap/transport/imap-client-session.vala"
	return FALSE;
#line 7980 "imap-client-session.c"
	_state_1:
#line 1411 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp1_ = geary_imap_client_session_select_examine_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 1411 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp0_ = _data_->_tmp1_;
#line 1411 "../src/engine/imap/transport/imap-client-session.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1411 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1411 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 1411 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 7994 "imap-client-session.c"
	}
#line 1411 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp2_ = _data_->_tmp0_;
#line 1411 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp0_ = NULL;
#line 1411 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->result = _data_->_tmp2_;
#line 1411 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->_tmp0_);
#line 1411 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1411 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_state_ != 0) {
#line 1411 "../src/engine/imap/transport/imap-client-session.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1411 "../src/engine/imap/transport/imap-client-session.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8012 "imap-client-session.c"
		}
	}
#line 1411 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_unref (_data_->_async_result);
#line 1411 "../src/engine/imap/transport/imap-client-session.vala"
	return FALSE;
#line 8019 "imap-client-session.c"
}

static void
geary_imap_client_session_examine_async_data_free (gpointer _data)
{
	GearyImapClientSessionExamineAsyncData* _data_;
	_data_ = _data;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->mailbox);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->result);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_slice_free (GearyImapClientSessionExamineAsyncData, _data_);
#line 8037 "imap-client-session.c"
}

void
geary_imap_client_session_examine_async (GearyImapClientSession* self,
                                         GearyImapMailboxSpecifier* mailbox,
                                         GCancellable* cancellable,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	GearyImapClientSessionExamineAsyncData* _data_;
	GearyImapClientSession* _tmp0_;
	GearyImapMailboxSpecifier* _tmp1_;
	GCancellable* _tmp2_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_MAILBOX_SPECIFIER (mailbox));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_slice_new0 (GearyImapClientSessionExamineAsyncData);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_session_examine_async_data_free);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->self = _tmp0_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = _g_object_ref0 (mailbox);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->mailbox);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->mailbox = _tmp1_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->cancellable = _tmp2_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_examine_async_co (_data_);
#line 8081 "imap-client-session.c"
}

GearyImapStatusResponse*
geary_imap_client_session_examine_finish (GearyImapClientSession* self,
                                          GAsyncResult* _res_,
                                          GError** error)
{
	GearyImapStatusResponse* result;
	GearyImapClientSessionExamineAsyncData* _data_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	if (NULL == _data_) {
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		return NULL;
#line 8097 "imap-client-session.c"
	}
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	result = _data_->result;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->result = NULL;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 8105 "imap-client-session.c"
}

static void
geary_imap_client_session_examine_async_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_)
{
	GearyImapClientSessionExamineAsyncData* _data_;
#line 1417 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = _user_data_;
#line 1417 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_source_object_ = source_object;
#line 1417 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_res_ = _res_;
#line 1417 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_examine_async_co (_data_);
#line 8122 "imap-client-session.c"
}

static gboolean
geary_imap_client_session_examine_async_co (GearyImapClientSessionExamineAsyncData* _data_)
{
#line 1414 "../src/engine/imap/transport/imap-client-session.vala"
	switch (_data_->_state_) {
#line 1414 "../src/engine/imap/transport/imap-client-session.vala"
		case 0:
#line 8132 "imap-client-session.c"
		goto _state_0;
#line 1414 "../src/engine/imap/transport/imap-client-session.vala"
		case 1:
#line 8136 "imap-client-session.c"
		goto _state_1;
		default:
#line 1414 "../src/engine/imap/transport/imap-client-session.vala"
		g_assert_not_reached ();
#line 8141 "imap-client-session.c"
	}
	_state_0:
#line 1417 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_state_ = 1;
#line 1417 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_select_examine_async (_data_->self, _data_->mailbox, FALSE, _data_->cancellable, geary_imap_client_session_examine_async_ready, _data_);
#line 1417 "../src/engine/imap/transport/imap-client-session.vala"
	return FALSE;
#line 8150 "imap-client-session.c"
	_state_1:
#line 1417 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp1_ = geary_imap_client_session_select_examine_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 1417 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp0_ = _data_->_tmp1_;
#line 1417 "../src/engine/imap/transport/imap-client-session.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1417 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1417 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 1417 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 8164 "imap-client-session.c"
	}
#line 1417 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp2_ = _data_->_tmp0_;
#line 1417 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp0_ = NULL;
#line 1417 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->result = _data_->_tmp2_;
#line 1417 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->_tmp0_);
#line 1417 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1417 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_state_ != 0) {
#line 1417 "../src/engine/imap/transport/imap-client-session.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1417 "../src/engine/imap/transport/imap-client-session.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8182 "imap-client-session.c"
		}
	}
#line 1417 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_unref (_data_->_async_result);
#line 1417 "../src/engine/imap/transport/imap-client-session.vala"
	return FALSE;
#line 8189 "imap-client-session.c"
}

static void
geary_imap_client_session_select_examine_async_data_free (gpointer _data)
{
	GearyImapClientSessionSelectExamineAsyncData* _data_;
	_data_ = _data;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->mailbox);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->result);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_slice_free (GearyImapClientSessionSelectExamineAsyncData, _data_);
#line 8207 "imap-client-session.c"
}

void
geary_imap_client_session_select_examine_async (GearyImapClientSession* self,
                                                GearyImapMailboxSpecifier* mailbox,
                                                gboolean is_select,
                                                GCancellable* cancellable,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_)
{
	GearyImapClientSessionSelectExamineAsyncData* _data_;
	GearyImapClientSession* _tmp0_;
	GearyImapMailboxSpecifier* _tmp1_;
	GCancellable* _tmp2_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_MAILBOX_SPECIFIER (mailbox));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_slice_new0 (GearyImapClientSessionSelectExamineAsyncData);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_session_select_examine_async_data_free);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->self = _tmp0_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = _g_object_ref0 (mailbox);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->mailbox);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->mailbox = _tmp1_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->is_select = is_select;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->cancellable = _tmp2_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_select_examine_async_co (_data_);
#line 8254 "imap-client-session.c"
}

GearyImapStatusResponse*
geary_imap_client_session_select_examine_finish (GearyImapClientSession* self,
                                                 GAsyncResult* _res_,
                                                 GError** error)
{
	GearyImapStatusResponse* result;
	GearyImapClientSessionSelectExamineAsyncData* _data_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	if (NULL == _data_) {
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		return NULL;
#line 8270 "imap-client-session.c"
	}
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	result = _data_->result;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->result = NULL;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 8278 "imap-client-session.c"
}

static void
geary_imap_client_session_select_examine_async_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_)
{
	GearyImapClientSessionSelectExamineAsyncData* _data_;
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = _user_data_;
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_source_object_ = source_object;
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_res_ = _res_;
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_select_examine_async_co (_data_);
#line 8295 "imap-client-session.c"
}

static gboolean
geary_imap_client_session_select_examine_async_co (GearyImapClientSessionSelectExamineAsyncData* _data_)
{
#line 1420 "../src/engine/imap/transport/imap-client-session.vala"
	switch (_data_->_state_) {
#line 1420 "../src/engine/imap/transport/imap-client-session.vala"
		case 0:
#line 8305 "imap-client-session.c"
		goto _state_0;
#line 1420 "../src/engine/imap/transport/imap-client-session.vala"
		case 1:
#line 8309 "imap-client-session.c"
		goto _state_1;
		default:
#line 1420 "../src/engine/imap/transport/imap-client-session.vala"
		g_assert_not_reached ();
#line 8314 "imap-client-session.c"
	}
	_state_0:
#line 1426 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->is_select) {
#line 1427 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp0_ = geary_imap_select_command_new (_data_->mailbox, _data_->cancellable);
#line 1427 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->cmd);
#line 1427 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->cmd = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEARY_IMAP_TYPE_COMMAND, GearyImapCommand);
#line 8325 "imap-client-session.c"
	} else {
#line 1429 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp1_ = geary_imap_examine_command_new (_data_->mailbox, _data_->cancellable);
#line 1429 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->cmd);
#line 1429 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->cmd = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp1_, GEARY_IMAP_TYPE_COMMAND, GearyImapCommand);
#line 8333 "imap-client-session.c"
	}
#line 1431 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp2_ = _data_->cmd;
#line 1431 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp3_ = geary_imap_client_session_machine_params_new (_data_->_tmp2_);
#line 1431 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->params = _data_->_tmp3_;
#line 1432 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp4_ = _data_->self->priv->fsm;
#line 1432 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp5_ = _data_->params;
#line 1432 "../src/engine/imap/transport/imap-client-session.vala"
	geary_state_machine_issue (_data_->_tmp4_, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SELECT, NULL, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp5_, G_TYPE_OBJECT, GObject), NULL);
#line 1434 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp6_ = _data_->params;
#line 1434 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp7_ = _data_->_tmp6_->err;
#line 1434 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_tmp7_ != NULL) {
#line 1435 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp8_ = _data_->params;
#line 1435 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp9_ = _data_->_tmp8_->err;
#line 1435 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp10_ = _g_error_copy0 (_data_->_tmp9_);
#line 1435 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_inner_error0_ = _data_->_tmp10_;
#line 1435 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1435 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->params);
#line 1435 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->cmd);
#line 1435 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 1435 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 8371 "imap-client-session.c"
	}
#line 1437 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp11_ = _data_->params;
#line 1437 "../src/engine/imap/transport/imap-client-session.vala"
	_vala_assert (_data_->_tmp11_->proceed, "params.proceed");
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp13_ = _data_->cmd;
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_state_ = 1;
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_submit_command (_data_->self, _data_->_tmp13_, geary_imap_client_session_select_examine_async_ready, _data_);
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
	return FALSE;
#line 8385 "imap-client-session.c"
	_state_1:
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp14_ = geary_imap_client_session_submit_command_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp12_ = _data_->_tmp14_;
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->params);
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->cmd);
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 8403 "imap-client-session.c"
	}
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp15_ = _data_->_tmp12_;
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp12_ = NULL;
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->result = _data_->_tmp15_;
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->_tmp12_);
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->params);
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cmd);
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_state_ != 0) {
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8425 "imap-client-session.c"
		}
	}
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_unref (_data_->_async_result);
#line 1439 "../src/engine/imap/transport/imap-client-session.vala"
	return FALSE;
#line 8432 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_select (GearyImapClientSession* self,
                                     guint state,
                                     guint event,
                                     void* user,
                                     GObject* object)
{
	GearyImapClientSessionMachineParams* params = NULL;
	GearyImapClientSessionMachineParams* _tmp0_;
	GearyImapClientSessionMachineParams* _tmp1_;
	guint result;
#line 1442 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 1442 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 1443 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_CLIENT_SESSION_TYPE_MACHINE_PARAMS, GearyImapClientSessionMachineParams));
#line 1443 "../src/engine/imap/transport/imap-client-session.vala"
	params = _tmp0_;
#line 1445 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = params;
#line 1445 "../src/engine/imap/transport/imap-client-session.vala"
	if (!geary_imap_client_session_reserve_state_change_cmd (self, _tmp1_, state, event)) {
#line 1446 "../src/engine/imap/transport/imap-client-session.vala"
		result = state;
#line 1446 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (params);
#line 1446 "../src/engine/imap/transport/imap-client-session.vala"
		return result;
#line 8464 "imap-client-session.c"
	}
#line 1448 "../src/engine/imap/transport/imap-client-session.vala"
	result = (guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTING;
#line 1448 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (params);
#line 1448 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 8472 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_not_selected (GearyImapClientSession* self,
                                           guint state,
                                           guint event,
                                           void* user,
                                           GObject* object)
{
	GearyImapClientSessionMachineParams* params = NULL;
	GearyImapClientSessionMachineParams* _tmp0_;
	GError* _tmp1_;
	guint result;
#line 1451 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 1451 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 1452 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_CLIENT_SESSION_TYPE_MACHINE_PARAMS, GearyImapClientSessionMachineParams));
#line 1452 "../src/engine/imap/transport/imap-client-session.vala"
	params = _tmp0_;
#line 1454 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = g_error_new_literal (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_INVALID, "Can't close mailbox, not selected");
#line 1454 "../src/engine/imap/transport/imap-client-session.vala"
	_g_error_free0 (params->err);
#line 1454 "../src/engine/imap/transport/imap-client-session.vala"
	params->err = _tmp1_;
#line 1456 "../src/engine/imap/transport/imap-client-session.vala"
	result = state;
#line 1456 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (params);
#line 1456 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 8506 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_selecting_recv_completion (GearyImapClientSession* self,
                                                        guint state,
                                                        guint event,
                                                        void* user,
                                                        GObject* object)
{
	guint new_state = 0U;
	GearyImapStatusResponse* completion_response = NULL;
	GearyImapStatusResponse* _tmp0_;
	GearyImapCommand* cmd = NULL;
	GearyImapStatusResponse* _tmp1_;
	GearyImapCommand* _tmp2_ = NULL;
	gboolean _tmp3_;
	guint result;
#line 1459 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 1459 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 1460 "../src/engine/imap/transport/imap-client-session.vala"
	new_state = state;
#line 1461 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_TYPE_STATUS_RESPONSE, GearyImapStatusResponse));
#line 1461 "../src/engine/imap/transport/imap-client-session.vala"
	completion_response = _tmp0_;
#line 1463 "../src/engine/imap/transport/imap-client-session.vala"
	cmd = NULL;
#line 1464 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = completion_response;
#line 1464 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = geary_imap_client_session_validate_state_change_cmd (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_IMAP_TYPE_SERVER_RESPONSE, GearyImapServerResponse), &_tmp2_);
#line 1464 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (cmd);
#line 1464 "../src/engine/imap/transport/imap-client-session.vala"
	cmd = _tmp2_;
#line 1464 "../src/engine/imap/transport/imap-client-session.vala"
	if (_tmp3_) {
#line 8546 "imap-client-session.c"
		GearyImapStatusResponse* _tmp4_;
		GearyImapStatus _tmp5_;
		GearyImapStatus _tmp6_;
#line 1465 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp4_ = completion_response;
#line 1465 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp5_ = geary_imap_status_response_get_status (_tmp4_);
#line 1465 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp6_ = _tmp5_;
#line 1465 "../src/engine/imap/transport/imap-client-session.vala"
		switch (_tmp6_) {
#line 1465 "../src/engine/imap/transport/imap-client-session.vala"
			case GEARY_IMAP_STATUS_OK:
#line 8560 "imap-client-session.c"
			{
				GearyImapCommand* _tmp7_;
#line 1467 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp7_ = cmd;
#line 1467 "../src/engine/imap/transport/imap-client-session.vala"
				if (GEARY_IMAP_IS_SELECT_COMMAND (_tmp7_)) {
#line 8567 "imap-client-session.c"
					GearyImapCommand* _tmp8_;
					GearyImapMailboxSpecifier* _tmp9_;
					GearyImapMailboxSpecifier* _tmp10_;
					GearyImapMailboxSpecifier* _tmp11_;
#line 1468 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp8_ = cmd;
#line 1468 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp9_ = geary_imap_select_command_get_mailbox (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEARY_IMAP_TYPE_SELECT_COMMAND, GearyImapSelectCommand));
#line 1468 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp10_ = _tmp9_;
#line 1468 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp11_ = _g_object_ref0 (_tmp10_);
#line 1468 "../src/engine/imap/transport/imap-client-session.vala"
					_g_object_unref0 (self->selected_mailbox);
#line 1468 "../src/engine/imap/transport/imap-client-session.vala"
					self->selected_mailbox = _tmp11_;
#line 1469 "../src/engine/imap/transport/imap-client-session.vala"
					self->selected_readonly = FALSE;
#line 8586 "imap-client-session.c"
				} else {
					GearyImapCommand* _tmp12_;
#line 1470 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp12_ = cmd;
#line 1470 "../src/engine/imap/transport/imap-client-session.vala"
					if (GEARY_IMAP_IS_EXAMINE_COMMAND (_tmp12_)) {
#line 8593 "imap-client-session.c"
						GearyImapCommand* _tmp13_;
						GearyImapMailboxSpecifier* _tmp14_;
						GearyImapMailboxSpecifier* _tmp15_;
						GearyImapMailboxSpecifier* _tmp16_;
#line 1471 "../src/engine/imap/transport/imap-client-session.vala"
						_tmp13_ = cmd;
#line 1471 "../src/engine/imap/transport/imap-client-session.vala"
						_tmp14_ = geary_imap_examine_command_get_mailbox (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEARY_IMAP_TYPE_EXAMINE_COMMAND, GearyImapExamineCommand));
#line 1471 "../src/engine/imap/transport/imap-client-session.vala"
						_tmp15_ = _tmp14_;
#line 1471 "../src/engine/imap/transport/imap-client-session.vala"
						_tmp16_ = _g_object_ref0 (_tmp15_);
#line 1471 "../src/engine/imap/transport/imap-client-session.vala"
						_g_object_unref0 (self->selected_mailbox);
#line 1471 "../src/engine/imap/transport/imap-client-session.vala"
						self->selected_mailbox = _tmp16_;
#line 1472 "../src/engine/imap/transport/imap-client-session.vala"
						self->selected_readonly = TRUE;
#line 8612 "imap-client-session.c"
					}
				}
#line 1474 "../src/engine/imap/transport/imap-client-session.vala"
				new_state = (guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTED;
#line 1475 "../src/engine/imap/transport/imap-client-session.vala"
				break;
#line 8619 "imap-client-session.c"
			}
			default:
			{
				GearyImapStatusResponse* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
#line 1478 "../src/engine/imap/transport/imap-client-session.vala"
				_g_object_unref0 (self->selected_mailbox);
#line 1478 "../src/engine/imap/transport/imap-client-session.vala"
				self->selected_mailbox = NULL;
#line 1479 "../src/engine/imap/transport/imap-client-session.vala"
				self->selected_readonly = FALSE;
#line 1480 "../src/engine/imap/transport/imap-client-session.vala"
				new_state = (guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZED;
#line 1481 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp17_ = completion_response;
#line 1481 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp18_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 1481 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp19_ = _tmp18_;
#line 1481 "../src/engine/imap/transport/imap-client-session.vala"
				geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "SELECT/EXAMINE failed: %s", _tmp19_);
#line 1481 "../src/engine/imap/transport/imap-client-session.vala"
				_g_free0 (_tmp19_);
#line 1483 "../src/engine/imap/transport/imap-client-session.vala"
				break;
#line 8646 "imap-client-session.c"
			}
		}
	}
#line 1487 "../src/engine/imap/transport/imap-client-session.vala"
	result = new_state;
#line 1487 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (cmd);
#line 1487 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (completion_response);
#line 1487 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 8658 "imap-client-session.c"
}

static void
geary_imap_client_session_close_mailbox_async_data_free (gpointer _data)
{
	GearyImapClientSessionCloseMailboxAsyncData* _data_;
	_data_ = _data;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->result);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_slice_free (GearyImapClientSessionCloseMailboxAsyncData, _data_);
#line 8674 "imap-client-session.c"
}

void
geary_imap_client_session_close_mailbox_async (GearyImapClientSession* self,
                                               GCancellable* cancellable,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
	GearyImapClientSessionCloseMailboxAsyncData* _data_;
	GearyImapClientSession* _tmp0_;
	GCancellable* _tmp1_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_slice_new0 (GearyImapClientSessionCloseMailboxAsyncData);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_session_close_mailbox_async_data_free);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->self = _tmp0_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->cancellable = _tmp1_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_close_mailbox_async_co (_data_);
#line 8708 "imap-client-session.c"
}

GearyImapStatusResponse*
geary_imap_client_session_close_mailbox_finish (GearyImapClientSession* self,
                                                GAsyncResult* _res_,
                                                GError** error)
{
	GearyImapStatusResponse* result;
	GearyImapClientSessionCloseMailboxAsyncData* _data_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	if (NULL == _data_) {
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		return NULL;
#line 8724 "imap-client-session.c"
	}
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	result = _data_->result;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->result = NULL;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 8732 "imap-client-session.c"
}

static void
geary_imap_client_session_close_mailbox_async_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_)
{
	GearyImapClientSessionCloseMailboxAsyncData* _data_;
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = _user_data_;
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_source_object_ = source_object;
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_res_ = _res_;
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_close_mailbox_async_co (_data_);
#line 8749 "imap-client-session.c"
}

static gboolean
geary_imap_client_session_close_mailbox_async_co (GearyImapClientSessionCloseMailboxAsyncData* _data_)
{
#line 1494 "../src/engine/imap/transport/imap-client-session.vala"
	switch (_data_->_state_) {
#line 1494 "../src/engine/imap/transport/imap-client-session.vala"
		case 0:
#line 8759 "imap-client-session.c"
		goto _state_0;
#line 1494 "../src/engine/imap/transport/imap-client-session.vala"
		case 1:
#line 8763 "imap-client-session.c"
		goto _state_1;
		default:
#line 1494 "../src/engine/imap/transport/imap-client-session.vala"
		g_assert_not_reached ();
#line 8768 "imap-client-session.c"
	}
	_state_0:
#line 1496 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp0_ = geary_imap_close_command_new (_data_->cancellable);
#line 1496 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->cmd = _data_->_tmp0_;
#line 1498 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp1_ = _data_->cmd;
#line 1498 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp2_ = geary_imap_client_session_machine_params_new (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp1_, GEARY_IMAP_TYPE_COMMAND, GearyImapCommand));
#line 1498 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->params = _data_->_tmp2_;
#line 1499 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp3_ = _data_->self->priv->fsm;
#line 1499 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp4_ = _data_->params;
#line 1499 "../src/engine/imap/transport/imap-client-session.vala"
	geary_state_machine_issue (_data_->_tmp3_, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_CLOSE_MAILBOX, NULL, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp4_, G_TYPE_OBJECT, GObject), NULL);
#line 1501 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp5_ = _data_->params;
#line 1501 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp6_ = _data_->_tmp5_->err;
#line 1501 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_tmp6_ != NULL) {
#line 1502 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp7_ = _data_->params;
#line 1502 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp8_ = _data_->_tmp7_->err;
#line 1502 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp9_ = _g_error_copy0 (_data_->_tmp8_);
#line 1502 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_inner_error0_ = _data_->_tmp9_;
#line 1502 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1502 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->params);
#line 1502 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->cmd);
#line 1502 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 1502 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 8811 "imap-client-session.c"
	}
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp11_ = _data_->cmd;
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_state_ = 1;
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_submit_command (_data_->self, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp11_, GEARY_IMAP_TYPE_COMMAND, GearyImapCommand), geary_imap_client_session_close_mailbox_async_ready, _data_);
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
	return FALSE;
#line 8821 "imap-client-session.c"
	_state_1:
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp12_ = geary_imap_client_session_submit_command_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp10_ = _data_->_tmp12_;
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->params);
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->cmd);
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 8839 "imap-client-session.c"
	}
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp13_ = _data_->_tmp10_;
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp10_ = NULL;
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->result = _data_->_tmp13_;
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->_tmp10_);
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->params);
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cmd);
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_state_ != 0) {
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8861 "imap-client-session.c"
		}
	}
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_unref (_data_->_async_result);
#line 1504 "../src/engine/imap/transport/imap-client-session.vala"
	return FALSE;
#line 8868 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_close_mailbox (GearyImapClientSession* self,
                                            guint state,
                                            guint event,
                                            void* user,
                                            GObject* object)
{
	GearyImapClientSessionMachineParams* params = NULL;
	GearyImapClientSessionMachineParams* _tmp0_;
	GearyImapClientSessionMachineParams* _tmp1_;
	GearyImapCommand* _tmp2_;
	GearyImapClientSessionMachineParams* _tmp3_;
	GearyImapClientConnection* _tmp4_;
	guint result;
#line 1507 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 1507 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 1508 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_CLIENT_SESSION_TYPE_MACHINE_PARAMS, GearyImapClientSessionMachineParams));
#line 1508 "../src/engine/imap/transport/imap-client-session.vala"
	params = _tmp0_;
#line 1510 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = params;
#line 1510 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = _tmp1_->cmd;
#line 1510 "../src/engine/imap/transport/imap-client-session.vala"
	_vala_assert (GEARY_IMAP_IS_CLOSE_COMMAND (_tmp2_), "params.cmd is CloseCommand");
#line 1511 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = params;
#line 1511 "../src/engine/imap/transport/imap-client-session.vala"
	if (!geary_imap_client_session_reserve_state_change_cmd (self, _tmp3_, state, event)) {
#line 1512 "../src/engine/imap/transport/imap-client-session.vala"
		result = state;
#line 1512 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (params);
#line 1512 "../src/engine/imap/transport/imap-client-session.vala"
		return result;
#line 8909 "imap-client-session.c"
	}
#line 1515 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp4_ = self->priv->cx;
#line 1515 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_connection_enable_idle_when_quiet (_tmp4_, FALSE);
#line 1517 "../src/engine/imap/transport/imap-client-session.vala"
	result = (guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSING_MAILBOX;
#line 1517 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (params);
#line 1517 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 8921 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_closing_recv_completion (GearyImapClientSession* self,
                                                      guint state,
                                                      guint event,
                                                      void* user,
                                                      GObject* object)
{
	GearyImapStatusResponse* completion_response = NULL;
	GearyImapStatusResponse* _tmp0_;
	GearyImapStatusResponse* _tmp1_;
	GearyImapStatusResponse* _tmp2_;
	GearyImapStatus _tmp3_;
	GearyImapStatus _tmp4_;
	guint result;
#line 1520 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 1520 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 1521 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_TYPE_STATUS_RESPONSE, GearyImapStatusResponse));
#line 1521 "../src/engine/imap/transport/imap-client-session.vala"
	completion_response = _tmp0_;
#line 1523 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = completion_response;
#line 1523 "../src/engine/imap/transport/imap-client-session.vala"
	if (!geary_imap_client_session_validate_state_change_cmd (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_IMAP_TYPE_SERVER_RESPONSE, GearyImapServerResponse), NULL)) {
#line 1524 "../src/engine/imap/transport/imap-client-session.vala"
		result = state;
#line 1524 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (completion_response);
#line 1524 "../src/engine/imap/transport/imap-client-session.vala"
		return result;
#line 8956 "imap-client-session.c"
	}
#line 1526 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = completion_response;
#line 1526 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = geary_imap_status_response_get_status (_tmp2_);
#line 1526 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp4_ = _tmp3_;
#line 1526 "../src/engine/imap/transport/imap-client-session.vala"
	switch (_tmp4_) {
#line 1526 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_STATUS_OK:
#line 8968 "imap-client-session.c"
		{
#line 1528 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (self->selected_mailbox);
#line 1528 "../src/engine/imap/transport/imap-client-session.vala"
			self->selected_mailbox = NULL;
#line 1529 "../src/engine/imap/transport/imap-client-session.vala"
			self->selected_readonly = FALSE;
#line 1530 "../src/engine/imap/transport/imap-client-session.vala"
			result = (guint) GEARY_IMAP_CLIENT_SESSION_STATE_AUTHORIZED;
#line 1530 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (completion_response);
#line 1530 "../src/engine/imap/transport/imap-client-session.vala"
			return result;
#line 8982 "imap-client-session.c"
		}
		default:
		{
			GearyImapStatusResponse* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
#line 1533 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp5_ = completion_response;
#line 1533 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp6_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 1533 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp7_ = _tmp6_;
#line 1533 "../src/engine/imap/transport/imap-client-session.vala"
			geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "CLOSE failed: %s", _tmp7_);
#line 1533 "../src/engine/imap/transport/imap-client-session.vala"
			_g_free0 (_tmp7_);
#line 1534 "../src/engine/imap/transport/imap-client-session.vala"
			result = (guint) GEARY_IMAP_CLIENT_SESSION_STATE_SELECTED;
#line 1534 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (completion_response);
#line 1534 "../src/engine/imap/transport/imap-client-session.vala"
			return result;
#line 9005 "imap-client-session.c"
		}
	}
}

static void
geary_imap_client_session_logout_async_data_free (gpointer _data)
{
	GearyImapClientSessionLogoutAsyncData* _data_;
	_data_ = _data;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_slice_free (GearyImapClientSessionLogoutAsyncData, _data_);
#line 9021 "imap-client-session.c"
}

void
geary_imap_client_session_logout_async (GearyImapClientSession* self,
                                        GCancellable* cancellable,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	GearyImapClientSessionLogoutAsyncData* _data_;
	GearyImapClientSession* _tmp0_;
	GCancellable* _tmp1_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_slice_new0 (GearyImapClientSessionLogoutAsyncData);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_session_logout_async_data_free);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->self = _tmp0_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->cancellable = _tmp1_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_logout_async_co (_data_);
#line 9055 "imap-client-session.c"
}

void
geary_imap_client_session_logout_finish (GearyImapClientSession* self,
                                         GAsyncResult* _res_,
                                         GError** error)
{
	GearyImapClientSessionLogoutAsyncData* _data_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	if (NULL == _data_) {
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		return;
#line 9070 "imap-client-session.c"
	}
}

/**
     * Sends a logout command.
     *
     * If the connection is still available and the server still
     * responding, this will result in the connection being closed
     * gracefully. Thus unless an error occurs, {@link
     * disconnect_async} would not need to be called afterwards.
     */
static void
geary_imap_client_session_logout_async_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_)
{
	GearyImapClientSessionLogoutAsyncData* _data_;
#line 1561 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = _user_data_;
#line 1561 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_source_object_ = source_object;
#line 1561 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_res_ = _res_;
#line 1561 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_logout_async_co (_data_);
#line 9096 "imap-client-session.c"
}

static gboolean
geary_imap_client_session_logout_async_co (GearyImapClientSessionLogoutAsyncData* _data_)
{
#line 1550 "../src/engine/imap/transport/imap-client-session.vala"
	switch (_data_->_state_) {
#line 1550 "../src/engine/imap/transport/imap-client-session.vala"
		case 0:
#line 9106 "imap-client-session.c"
		goto _state_0;
#line 1550 "../src/engine/imap/transport/imap-client-session.vala"
		case 1:
#line 9110 "imap-client-session.c"
		goto _state_1;
#line 1550 "../src/engine/imap/transport/imap-client-session.vala"
		case 2:
#line 9114 "imap-client-session.c"
		goto _state_2;
		default:
#line 1550 "../src/engine/imap/transport/imap-client-session.vala"
		g_assert_not_reached ();
#line 9119 "imap-client-session.c"
	}
	_state_0:
#line 1552 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp0_ = geary_imap_logout_command_new (_data_->cancellable);
#line 1552 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->cmd = _data_->_tmp0_;
#line 1554 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp1_ = geary_imap_client_session_machine_params_new (G_TYPE_CHECK_INSTANCE_CAST (_data_->cmd, GEARY_IMAP_TYPE_COMMAND, GearyImapCommand));
#line 1554 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->params = _data_->_tmp1_;
#line 1555 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp2_ = _data_->self->priv->fsm;
#line 1555 "../src/engine/imap/transport/imap-client-session.vala"
	geary_state_machine_issue (_data_->_tmp2_, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_LOGOUT, NULL, G_TYPE_CHECK_INSTANCE_CAST (_data_->params, G_TYPE_OBJECT, GObject), NULL);
#line 1557 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp3_ = _data_->params->err;
#line 1557 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_tmp3_ != NULL) {
#line 1558 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp4_ = _data_->params->err;
#line 1558 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp5_ = _g_error_copy0 (_data_->_tmp4_);
#line 1558 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_inner_error0_ = _data_->_tmp5_;
#line 1558 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1558 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->params);
#line 1558 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->cmd);
#line 1558 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 1558 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 9154 "imap-client-session.c"
	}
#line 1560 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->params->proceed) {
#line 1561 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_state_ = 1;
#line 1561 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_session_submit_command (_data_->self, G_TYPE_CHECK_INSTANCE_CAST (_data_->cmd, GEARY_IMAP_TYPE_COMMAND, GearyImapCommand), geary_imap_client_session_logout_async_ready, _data_);
#line 1561 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 9164 "imap-client-session.c"
		_state_1:
#line 1561 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp6_ = geary_imap_client_session_submit_command_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 1561 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 1561 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->_tmp7_);
#line 1561 "../src/engine/imap/transport/imap-client-session.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1561 "../src/engine/imap/transport/imap-client-session.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1561 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->params);
#line 1561 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_data_->cmd);
#line 1561 "../src/engine/imap/transport/imap-client-session.vala"
			g_object_unref (_data_->_async_result);
#line 1561 "../src/engine/imap/transport/imap-client-session.vala"
			return FALSE;
#line 9184 "imap-client-session.c"
		}
#line 1562 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_state_ = 2;
#line 1562 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_session_do_disconnect (_data_->self, GEARY_IMAP_CLIENT_SESSION_DISCONNECT_REASON_LOCAL_CLOSE, geary_imap_client_session_logout_async_ready, _data_);
#line 1562 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 9192 "imap-client-session.c"
		_state_2:
#line 1562 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_session_do_disconnect_finish (_data_->self, _data_->_res_);
#line 9196 "imap-client-session.c"
	}
#line 1550 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->params);
#line 1550 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cmd);
#line 1550 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1550 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_state_ != 0) {
#line 1550 "../src/engine/imap/transport/imap-client-session.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1550 "../src/engine/imap/transport/imap-client-session.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 9210 "imap-client-session.c"
		}
	}
#line 1550 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_unref (_data_->_async_result);
#line 1550 "../src/engine/imap/transport/imap-client-session.vala"
	return FALSE;
#line 9217 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_logout (GearyImapClientSession* self,
                                     guint state,
                                     guint event,
                                     void* user,
                                     GObject* object)
{
	GearyImapClientSessionMachineParams* params = NULL;
	GearyImapClientSessionMachineParams* _tmp0_;
	GearyImapClientSessionMachineParams* _tmp1_;
	GearyImapCommand* _tmp2_;
	GearyImapClientSessionMachineParams* _tmp3_;
	guint result;
#line 1566 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 1566 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 1567 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_CLIENT_SESSION_TYPE_MACHINE_PARAMS, GearyImapClientSessionMachineParams));
#line 1567 "../src/engine/imap/transport/imap-client-session.vala"
	params = _tmp0_;
#line 1569 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = params;
#line 1569 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = _tmp1_->cmd;
#line 1569 "../src/engine/imap/transport/imap-client-session.vala"
	_vala_assert (GEARY_IMAP_IS_LOGOUT_COMMAND (_tmp2_), "params.cmd is LogoutCommand");
#line 1570 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = params;
#line 1570 "../src/engine/imap/transport/imap-client-session.vala"
	if (geary_imap_client_session_reserve_state_change_cmd (self, _tmp3_, state, event)) {
#line 1571 "../src/engine/imap/transport/imap-client-session.vala"
		state = (guint) GEARY_IMAP_CLIENT_SESSION_STATE_LOGOUT;
#line 9253 "imap-client-session.c"
	}
#line 1574 "../src/engine/imap/transport/imap-client-session.vala"
	result = state;
#line 1574 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (params);
#line 1574 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 9261 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_logging_out_recv_status (GearyImapClientSession* self,
                                                      guint state,
                                                      guint event,
                                                      void* user,
                                                      GObject* object)
{
	GearyImapStatusResponse* status_response = NULL;
	GearyImapStatusResponse* _tmp0_;
	GearyImapStatusResponse* _tmp1_;
	GearyImapStatus _tmp2_;
	GearyImapStatus _tmp3_;
	guint result;
#line 1577 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 1577 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 1581 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_TYPE_STATUS_RESPONSE, GearyImapStatusResponse));
#line 1581 "../src/engine/imap/transport/imap-client-session.vala"
	status_response = _tmp0_;
#line 1583 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = status_response;
#line 1583 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = geary_imap_status_response_get_status (_tmp1_);
#line 1583 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = _tmp2_;
#line 1583 "../src/engine/imap/transport/imap-client-session.vala"
	switch (_tmp3_) {
#line 1583 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_STATUS_OK:
#line 9295 "imap-client-session.c"
		{
#line 1587 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 9299 "imap-client-session.c"
		}
#line 1583 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_STATUS_BYE:
#line 9303 "imap-client-session.c"
		{
			GearyImapStatusResponse* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
#line 1592 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp4_ = status_response;
#line 1592 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp5_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 1592 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp6_ = _tmp5_;
#line 1592 "../src/engine/imap/transport/imap-client-session.vala"
			geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Received bye from server on logout: %s", _tmp6_);
#line 1592 "../src/engine/imap/transport/imap-client-session.vala"
			_g_free0 (_tmp6_);
#line 1594 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 9320 "imap-client-session.c"
		}
		default:
		{
			GearyImapStatusResponse* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
#line 1597 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp7_ = status_response;
#line 1597 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp8_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 1597 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp9_ = _tmp8_;
#line 1597 "../src/engine/imap/transport/imap-client-session.vala"
			geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Received error from server on logout: %s", _tmp9_);
#line 1597 "../src/engine/imap/transport/imap-client-session.vala"
			_g_free0 (_tmp9_);
#line 1599 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 9339 "imap-client-session.c"
		}
	}
#line 1602 "../src/engine/imap/transport/imap-client-session.vala"
	result = state;
#line 1602 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (status_response);
#line 1602 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 9348 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_logging_out_recv_completion (GearyImapClientSession* self,
                                                          guint state,
                                                          guint event,
                                                          void* user,
                                                          GObject* object)
{
	GearyImapStatusResponse* completion_response = NULL;
	GearyImapStatusResponse* _tmp0_;
	guint new_state = 0U;
	GearyImapStatusResponse* _tmp1_;
	guint result;
#line 1605 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 1605 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 1606 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_TYPE_STATUS_RESPONSE, GearyImapStatusResponse));
#line 1606 "../src/engine/imap/transport/imap-client-session.vala"
	completion_response = _tmp0_;
#line 1608 "../src/engine/imap/transport/imap-client-session.vala"
	new_state = state;
#line 1609 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = completion_response;
#line 1609 "../src/engine/imap/transport/imap-client-session.vala"
	if (geary_imap_client_session_validate_state_change_cmd (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_IMAP_TYPE_SERVER_RESPONSE, GearyImapServerResponse), NULL)) {
#line 1610 "../src/engine/imap/transport/imap-client-session.vala"
		new_state = (guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSED;
#line 1613 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_session_clear_namespaces (self);
#line 9381 "imap-client-session.c"
	}
#line 1615 "../src/engine/imap/transport/imap-client-session.vala"
	result = new_state;
#line 1615 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (completion_response);
#line 1615 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 9389 "imap-client-session.c"
}

static void
geary_imap_client_session_disconnect_async_data_free (gpointer _data)
{
	GearyImapClientSessionDisconnectAsyncData* _data_;
	_data_ = _data;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_slice_free (GearyImapClientSessionDisconnectAsyncData, _data_);
#line 9403 "imap-client-session.c"
}

void
geary_imap_client_session_disconnect_async (GearyImapClientSession* self,
                                            GCancellable* cancellable,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	GearyImapClientSessionDisconnectAsyncData* _data_;
	GearyImapClientSession* _tmp0_;
	GCancellable* _tmp1_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_slice_new0 (GearyImapClientSessionDisconnectAsyncData);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_session_disconnect_async_data_free);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->self = _tmp0_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cancellable);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->cancellable = _tmp1_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_disconnect_async_co (_data_);
#line 9437 "imap-client-session.c"
}

void
geary_imap_client_session_disconnect_finish (GearyImapClientSession* self,
                                             GAsyncResult* _res_,
                                             GError** error)
{
	GearyImapClientSessionDisconnectAsyncData* _data_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	if (NULL == _data_) {
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		return;
#line 9452 "imap-client-session.c"
	}
}

static void
geary_imap_client_session_disconnect_async_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_)
{
	GearyImapClientSessionDisconnectAsyncData* _data_;
#line 1635 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = _user_data_;
#line 1635 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_source_object_ = source_object;
#line 1635 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_res_ = _res_;
#line 1635 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_disconnect_async_co (_data_);
#line 9470 "imap-client-session.c"
}

static gboolean
geary_imap_client_session_disconnect_async_co (GearyImapClientSessionDisconnectAsyncData* _data_)
{
#line 1622 "../src/engine/imap/transport/imap-client-session.vala"
	switch (_data_->_state_) {
#line 1622 "../src/engine/imap/transport/imap-client-session.vala"
		case 0:
#line 9480 "imap-client-session.c"
		goto _state_0;
#line 1622 "../src/engine/imap/transport/imap-client-session.vala"
		case 1:
#line 9484 "imap-client-session.c"
		goto _state_1;
		default:
#line 1622 "../src/engine/imap/transport/imap-client-session.vala"
		g_assert_not_reached ();
#line 9489 "imap-client-session.c"
	}
	_state_0:
#line 1624 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp0_ = geary_imap_client_session_machine_params_new (NULL);
#line 1624 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->params = _data_->_tmp0_;
#line 1625 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp1_ = _data_->self->priv->fsm;
#line 1625 "../src/engine/imap/transport/imap-client-session.vala"
	geary_state_machine_issue (_data_->_tmp1_, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_DISCONNECT, NULL, G_TYPE_CHECK_INSTANCE_CAST (_data_->params, G_TYPE_OBJECT, GObject), NULL);
#line 1627 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp2_ = _data_->params->err;
#line 1627 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_tmp2_ != NULL) {
#line 1628 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp3_ = _data_->params->err;
#line 1628 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp4_ = _g_error_copy0 (_data_->_tmp3_);
#line 1628 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_inner_error0_ = _data_->_tmp4_;
#line 1628 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1628 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->params);
#line 1628 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 1628 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 9518 "imap-client-session.c"
	}
#line 1630 "../src/engine/imap/transport/imap-client-session.vala"
	if (!_data_->params->proceed) {
#line 1631 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->params);
#line 1631 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1631 "../src/engine/imap/transport/imap-client-session.vala"
		if (_data_->_state_ != 0) {
#line 1631 "../src/engine/imap/transport/imap-client-session.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 1631 "../src/engine/imap/transport/imap-client-session.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 9532 "imap-client-session.c"
			}
		}
#line 1631 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 1631 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 9539 "imap-client-session.c"
	}
#line 1633 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->disconnect_err = NULL;
#line 9543 "imap-client-session.c"
	{
#line 1635 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp5_ = _data_->self->priv->cx;
#line 1635 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_state_ = 1;
#line 1635 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_connection_disconnect_async (_data_->_tmp5_, _data_->cancellable, geary_imap_client_session_disconnect_async_ready, _data_);
#line 1635 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 9553 "imap-client-session.c"
		_state_1:
#line 1635 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_connection_disconnect_finish (_data_->_tmp5_, _data_->_res_, &_data_->_inner_error0_);
#line 1635 "../src/engine/imap/transport/imap-client-session.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 9559 "imap-client-session.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 1634 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->err = _data_->_inner_error0_;
#line 1634 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_inner_error0_ = NULL;
#line 1637 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp6_ = _data_->err;
#line 1637 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp7_ = _g_error_copy0 (_data_->_tmp6_);
#line 1637 "../src/engine/imap/transport/imap-client-session.vala"
		_g_error_free0 (_data_->disconnect_err);
#line 1637 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->disconnect_err = _data_->_tmp7_;
#line 1634 "../src/engine/imap/transport/imap-client-session.vala"
		_g_error_free0 (_data_->err);
#line 9580 "imap-client-session.c"
	}
	__finally0:
#line 1634 "../src/engine/imap/transport/imap-client-session.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1634 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1634 "../src/engine/imap/transport/imap-client-session.vala"
		_g_error_free0 (_data_->disconnect_err);
#line 1634 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->params);
#line 1634 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 1634 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 9595 "imap-client-session.c"
	}
#line 1640 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_drop_connection (_data_->self);
#line 1641 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_set_disconnected (_data_->self, GEARY_IMAP_CLIENT_SESSION_DISCONNECT_REASON_LOCAL_CLOSE);
#line 1643 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp8_ = _data_->disconnect_err;
#line 1643 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_tmp8_ != NULL) {
#line 1644 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp9_ = _data_->disconnect_err;
#line 1644 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp10_ = _g_error_copy0 (_data_->_tmp9_);
#line 1644 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_inner_error0_ = _data_->_tmp10_;
#line 1644 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1644 "../src/engine/imap/transport/imap-client-session.vala"
		_g_error_free0 (_data_->disconnect_err);
#line 1644 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (_data_->params);
#line 1644 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 1644 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 9621 "imap-client-session.c"
	}
#line 1622 "../src/engine/imap/transport/imap-client-session.vala"
	_g_error_free0 (_data_->disconnect_err);
#line 1622 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->params);
#line 1622 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1622 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_state_ != 0) {
#line 1622 "../src/engine/imap/transport/imap-client-session.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1622 "../src/engine/imap/transport/imap-client-session.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 9635 "imap-client-session.c"
		}
	}
#line 1622 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_unref (_data_->_async_result);
#line 1622 "../src/engine/imap/transport/imap-client-session.vala"
	return FALSE;
#line 9642 "imap-client-session.c"
}

/** {@inheritDoc} */
static gchar*
geary_imap_client_session_real_to_string (GearyLoggingSource* base)
{
	GearyImapClientSession * self;
	gchar* _tmp0_ = NULL;
	GearyImapClientConnection* _tmp1_;
	gchar* cx = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* result;
#line 1648 "../src/engine/imap/transport/imap-client-session.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_IMAP_TYPE_CLIENT_SESSION, GearyImapClientSession);
#line 1649 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = self->priv->cx;
#line 1649 "../src/engine/imap/transport/imap-client-session.vala"
	if (_tmp1_ != NULL) {
#line 9662 "imap-client-session.c"
		GearyImapClientConnection* _tmp2_;
		gchar* _tmp3_;
#line 1650 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp2_ = self->priv->cx;
#line 1650 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp3_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 1650 "../src/engine/imap/transport/imap-client-session.vala"
		_g_free0 (_tmp0_);
#line 1650 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp0_ = _tmp3_;
#line 9673 "imap-client-session.c"
	} else {
		gchar* _tmp4_;
#line 1650 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp4_ = g_strdup ("not connected");
#line 1650 "../src/engine/imap/transport/imap-client-session.vala"
		_g_free0 (_tmp0_);
#line 1650 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp0_ = _tmp4_;
#line 9682 "imap-client-session.c"
	}
#line 1649 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp5_ = g_strconcat (", ", _tmp0_, NULL);
#line 1649 "../src/engine/imap/transport/imap-client-session.vala"
	cx = _tmp5_;
#line 1652 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp6_ = geary_logging_source_default_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), cx);
#line 1652 "../src/engine/imap/transport/imap-client-session.vala"
	result = _tmp6_;
#line 1652 "../src/engine/imap/transport/imap-client-session.vala"
	_g_free0 (cx);
#line 1652 "../src/engine/imap/transport/imap-client-session.vala"
	_g_free0 (_tmp0_);
#line 1652 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 9698 "imap-client-session.c"
}

/** {@inheritDoc} */
static GearyLoggingState*
geary_imap_client_session_real_to_logging_state (GearyLoggingSource* base)
{
	GearyImapClientSession * self;
	GearyLoggingState* _tmp0_ = NULL;
	GearyImapMailboxSpecifier* _tmp1_;
	GearyLoggingState* result;
#line 1656 "../src/engine/imap/transport/imap-client-session.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_IMAP_TYPE_CLIENT_SESSION, GearyImapClientSession);
#line 1657 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = self->selected_mailbox;
#line 1657 "../src/engine/imap/transport/imap-client-session.vala"
	if (_tmp1_ == NULL) {
#line 9715 "imap-client-session.c"
		GearyStateMachine* _tmp2_;
		GearyStateMachine* _tmp3_;
		guint _tmp4_;
		guint _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		GearyLoggingState* _tmp8_;
#line 1658 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp2_ = self->priv->fsm;
#line 1658 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp3_ = self->priv->fsm;
#line 1658 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp4_ = geary_state_machine_get_state (_tmp3_);
#line 1658 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp5_ = _tmp4_;
#line 1658 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp6_ = geary_state_machine_get_state_string (_tmp2_, _tmp5_);
#line 1658 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp7_ = _tmp6_;
#line 1658 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp8_ = geary_logging_state_new (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "%s", _tmp7_);
#line 1658 "../src/engine/imap/transport/imap-client-session.vala"
		_geary_logging_state_unref0 (_tmp0_);
#line 1658 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp0_ = _tmp8_;
#line 1658 "../src/engine/imap/transport/imap-client-session.vala"
		_g_free0 (_tmp7_);
#line 9743 "imap-client-session.c"
	} else {
		const gchar* _tmp9_ = NULL;
		GearyStateMachine* _tmp10_;
		GearyStateMachine* _tmp11_;
		guint _tmp12_;
		guint _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GearyImapMailboxSpecifier* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		GearyLoggingState* _tmp19_;
#line 1667 "../src/engine/imap/transport/imap-client-session.vala"
		if (self->selected_readonly) {
#line 1667 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp9_ = "RO";
#line 9760 "imap-client-session.c"
		} else {
#line 1667 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp9_ = "RW";
#line 9764 "imap-client-session.c"
		}
#line 1662 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp10_ = self->priv->fsm;
#line 1662 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp11_ = self->priv->fsm;
#line 1662 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp12_ = geary_state_machine_get_state (_tmp11_);
#line 1662 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp13_ = _tmp12_;
#line 1662 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp14_ = geary_state_machine_get_state_string (_tmp10_, _tmp13_);
#line 1662 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp15_ = _tmp14_;
#line 1662 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp16_ = self->selected_mailbox;
#line 1662 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp17_ = geary_imap_mailbox_specifier_to_string (_tmp16_);
#line 1662 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp18_ = _tmp17_;
#line 1662 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp19_ = geary_logging_state_new (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "%s:%s selected %s", _tmp15_, _tmp18_, _tmp9_);
#line 1662 "../src/engine/imap/transport/imap-client-session.vala"
		_geary_logging_state_unref0 (_tmp0_);
#line 1662 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp0_ = _tmp19_;
#line 1662 "../src/engine/imap/transport/imap-client-session.vala"
		_g_free0 (_tmp18_);
#line 1662 "../src/engine/imap/transport/imap-client-session.vala"
		_g_free0 (_tmp15_);
#line 9794 "imap-client-session.c"
	}
#line 1657 "../src/engine/imap/transport/imap-client-session.vala"
	result = _tmp0_;
#line 1657 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 9800 "imap-client-session.c"
}

/** Sets the connection's logging parent. */
void
geary_imap_client_session_set_logging_parent (GearyImapClientSession* self,
                                              GearyLoggingSource* parent)
{
#line 1672 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 1672 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_LOGGING_IS_SOURCE (parent));
#line 1673 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->_logging_parent = parent;
#line 9814 "imap-client-session.c"
}

static void
geary_imap_client_session_do_disconnect_data_free (gpointer _data)
{
	GearyImapClientSessionDoDisconnectData* _data_;
	_data_ = _data;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_slice_free (GearyImapClientSessionDoDisconnectData, _data_);
#line 9826 "imap-client-session.c"
}

static void
geary_imap_client_session_do_disconnect (GearyImapClientSession* self,
                                         GearyImapClientSessionDisconnectReason reason,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	GearyImapClientSessionDoDisconnectData* _data_;
	GearyImapClientSession* _tmp0_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_slice_new0 (GearyImapClientSessionDoDisconnectData);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_session_do_disconnect_data_free);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->self = _tmp0_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->reason = reason;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_do_disconnect_co (_data_);
#line 9853 "imap-client-session.c"
}

static void
geary_imap_client_session_do_disconnect_finish (GearyImapClientSession* self,
                                                GAsyncResult* _res_)
{
	GearyImapClientSessionDoDisconnectData* _data_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 9863 "imap-client-session.c"
}

static void
geary_imap_client_session_do_disconnect_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_)
{
	GearyImapClientSessionDoDisconnectData* _data_;
#line 1680 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = _user_data_;
#line 1680 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_source_object_ = source_object;
#line 1680 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_res_ = _res_;
#line 1680 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_do_disconnect_co (_data_);
#line 9880 "imap-client-session.c"
}

static gboolean
geary_imap_client_session_do_disconnect_co (GearyImapClientSessionDoDisconnectData* _data_)
{
#line 1676 "../src/engine/imap/transport/imap-client-session.vala"
	switch (_data_->_state_) {
#line 1676 "../src/engine/imap/transport/imap-client-session.vala"
		case 0:
#line 9890 "imap-client-session.c"
		goto _state_0;
#line 1676 "../src/engine/imap/transport/imap-client-session.vala"
		case 1:
#line 9894 "imap-client-session.c"
		goto _state_1;
		default:
#line 1676 "../src/engine/imap/transport/imap-client-session.vala"
		g_assert_not_reached ();
#line 9899 "imap-client-session.c"
	}
	_state_0:
#line 1677 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_set_disconnected (_data_->self, _data_->reason);
#line 9904 "imap-client-session.c"
	{
#line 1680 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp0_ = _data_->self->priv->cx;
#line 1680 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_state_ = 1;
#line 1680 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_connection_disconnect_async (_data_->_tmp0_, NULL, geary_imap_client_session_do_disconnect_ready, _data_);
#line 1680 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 9914 "imap-client-session.c"
		_state_1:
#line 1680 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_connection_disconnect_finish (_data_->_tmp0_, _data_->_res_, &_data_->_inner_error0_);
#line 1680 "../src/engine/imap/transport/imap-client-session.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 9920 "imap-client-session.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 1679 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->err = _data_->_inner_error0_;
#line 1679 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_inner_error0_ = NULL;
#line 1682 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp1_ = _data_->err;
#line 1682 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp2_ = _data_->_tmp1_->message;
#line 1682 "../src/engine/imap/transport/imap-client-session.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "IMAP disconnect failed: %s", _data_->_tmp2_);
#line 1679 "../src/engine/imap/transport/imap-client-session.vala"
		_g_error_free0 (_data_->err);
#line 9939 "imap-client-session.c"
	}
	__finally0:
#line 1679 "../src/engine/imap/transport/imap-client-session.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1679 "../src/engine/imap/transport/imap-client-session.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 1679 "../src/engine/imap/transport/imap-client-session.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 1679 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 1679 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 9952 "imap-client-session.c"
	}
#line 1685 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_drop_connection (_data_->self);
#line 1676 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1676 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_state_ != 0) {
#line 1676 "../src/engine/imap/transport/imap-client-session.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1676 "../src/engine/imap/transport/imap-client-session.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 9964 "imap-client-session.c"
		}
	}
#line 1676 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_unref (_data_->_async_result);
#line 1676 "../src/engine/imap/transport/imap-client-session.vala"
	return FALSE;
#line 9971 "imap-client-session.c"
}

static void
__lambda48_ (GearyImapClientSession* self)
{
#line 1706 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_drop_connection (self);
#line 9979 "imap-client-session.c"
}

static void
___lambda48__geary_state_post_transition (void* user,
                                          GObject* object,
                                          GError* err,
                                          gpointer self)
{
#line 1706 "../src/engine/imap/transport/imap-client-session.vala"
	__lambda48_ ((GearyImapClientSession*) self);
#line 9990 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_connecting_send_recv_error (GearyImapClientSession* self,
                                                         guint state,
                                                         guint event,
                                                         void* user,
                                                         GObject* object,
                                                         GError* err)
{
	const gchar* _tmp0_ = NULL;
	GearyStateMachine* _tmp2_;
	guint result;
#line 1697 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 1697 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 1704 "../src/engine/imap/transport/imap-client-session.vala"
	if (err != NULL) {
#line 10010 "imap-client-session.c"
		const gchar* _tmp1_;
#line 1704 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp1_ = err->message;
#line 1704 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp0_ = _tmp1_;
#line 10016 "imap-client-session.c"
	} else {
#line 1704 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp0_ = "(no error)";
#line 10020 "imap-client-session.c"
	}
#line 1702 "../src/engine/imap/transport/imap-client-session.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Connecting send/recv error, dropping client connection: %s", _tmp0_);
#line 1706 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = self->priv->fsm;
#line 1706 "../src/engine/imap/transport/imap-client-session.vala"
	geary_state_machine_do_post_transition (_tmp2_, ___lambda48__geary_state_post_transition, self, NULL, NULL, NULL);
#line 1707 "../src/engine/imap/transport/imap-client-session.vala"
	result = (guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSED;
#line 1707 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 10032 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_send_error (GearyImapClientSession* self,
                                         guint state,
                                         guint event,
                                         void* user,
                                         GObject* object,
                                         GError* err)
{
	const gchar* _tmp0_;
	guint result;
#line 1710 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 1710 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 1711 "../src/engine/imap/transport/imap-client-session.vala"
	if (g_error_matches (err, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 1712 "../src/engine/imap/transport/imap-client-session.vala"
		result = state;
#line 1712 "../src/engine/imap/transport/imap-client-session.vala"
		return result;
#line 10055 "imap-client-session.c"
	}
#line 1715 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = err->message;
#line 1715 "../src/engine/imap/transport/imap-client-session.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Send error, disconnecting: %s", _tmp0_);
#line 1716 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_do_disconnect (self, GEARY_IMAP_CLIENT_SESSION_DISCONNECT_REASON_LOCAL_ERROR, NULL, NULL);
#line 1717 "../src/engine/imap/transport/imap-client-session.vala"
	result = (guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSED;
#line 1717 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 10067 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_recv_error (GearyImapClientSession* self,
                                         guint state,
                                         guint event,
                                         void* user,
                                         GObject* object,
                                         GError* err)
{
	const gchar* _tmp0_ = NULL;
	guint result;
#line 1720 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 1720 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 1727 "../src/engine/imap/transport/imap-client-session.vala"
	if (err != NULL) {
#line 10086 "imap-client-session.c"
		const gchar* _tmp1_;
#line 1727 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp1_ = err->message;
#line 1727 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp0_ = _tmp1_;
#line 10092 "imap-client-session.c"
	} else {
#line 1727 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp0_ = "(no error)";
#line 10096 "imap-client-session.c"
	}
#line 1725 "../src/engine/imap/transport/imap-client-session.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Receive error, disconnecting: %s", _tmp0_);
#line 1729 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_do_disconnect (self, GEARY_IMAP_CLIENT_SESSION_DISCONNECT_REASON_REMOTE_ERROR, NULL, NULL);
#line 1730 "../src/engine/imap/transport/imap-client-session.vala"
	result = (guint) GEARY_IMAP_CLIENT_SESSION_STATE_CLOSED;
#line 1730 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 10106 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_early_command (GearyImapClientSession* self,
                                            guint state,
                                            guint event,
                                            void* user,
                                            GObject* object)
{
	GearyImapClientSessionMachineParams* params = NULL;
	GearyImapClientSessionMachineParams* _tmp0_;
	GearyImapCommand* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GError* _tmp6_;
	guint result;
#line 1735 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 1735 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 1736 "../src/engine/imap/transport/imap-client-session.vala"
	_vala_assert (object != NULL, "object != null");
#line 1738 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_CLIENT_SESSION_TYPE_MACHINE_PARAMS, GearyImapClientSessionMachineParams));
#line 1738 "../src/engine/imap/transport/imap-client-session.vala"
	params = _tmp0_;
#line 1739 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = params->cmd;
#line 1739 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = geary_imap_command_get_name (_tmp1_);
#line 1739 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = _tmp2_;
#line 1739 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp4_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 1739 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp5_ = _tmp4_;
#line 1739 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp6_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_NOT_CONNECTED, "Command %s too early: not connected to %s", _tmp3_, _tmp5_);
#line 1739 "../src/engine/imap/transport/imap-client-session.vala"
	_g_error_free0 (params->err);
#line 1739 "../src/engine/imap/transport/imap-client-session.vala"
	params->err = _tmp6_;
#line 1739 "../src/engine/imap/transport/imap-client-session.vala"
	_g_free0 (_tmp5_);
#line 1742 "../src/engine/imap/transport/imap-client-session.vala"
	result = state;
#line 1742 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (params);
#line 1742 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 10159 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_late_command (GearyImapClientSession* self,
                                           guint state,
                                           guint event,
                                           void* user,
                                           GObject* object)
{
	GearyImapClientSessionMachineParams* params = NULL;
	GearyImapClientSessionMachineParams* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GError* _tmp3_;
	guint result;
#line 1747 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 1747 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 1748 "../src/engine/imap/transport/imap-client-session.vala"
	_vala_assert (object != NULL, "object != null");
#line 1750 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_CLIENT_SESSION_TYPE_MACHINE_PARAMS, GearyImapClientSessionMachineParams));
#line 1750 "../src/engine/imap/transport/imap-client-session.vala"
	params = _tmp0_;
#line 1751 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 1751 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = _tmp1_;
#line 1751 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_NOT_CONNECTED, "Connection to %s closing or closed", _tmp2_);
#line 1751 "../src/engine/imap/transport/imap-client-session.vala"
	_g_error_free0 (params->err);
#line 1751 "../src/engine/imap/transport/imap-client-session.vala"
	params->err = _tmp3_;
#line 1751 "../src/engine/imap/transport/imap-client-session.vala"
	_g_free0 (_tmp2_);
#line 1753 "../src/engine/imap/transport/imap-client-session.vala"
	result = state;
#line 1753 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (params);
#line 1753 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 10203 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_already_connected (GearyImapClientSession* self,
                                                guint state,
                                                guint event,
                                                void* user,
                                                GObject* object)
{
	GearyImapClientSessionMachineParams* params = NULL;
	GearyImapClientSessionMachineParams* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GError* _tmp3_;
	guint result;
#line 1756 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 1756 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 1757 "../src/engine/imap/transport/imap-client-session.vala"
	_vala_assert (object != NULL, "object != null");
#line 1759 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_CLIENT_SESSION_TYPE_MACHINE_PARAMS, GearyImapClientSessionMachineParams));
#line 1759 "../src/engine/imap/transport/imap-client-session.vala"
	params = _tmp0_;
#line 1760 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 1760 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = _tmp1_;
#line 1760 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_ALREADY_CONNECTED, "Already connected or connecting to %s", _tmp2_);
#line 1760 "../src/engine/imap/transport/imap-client-session.vala"
	_g_error_free0 (params->err);
#line 1760 "../src/engine/imap/transport/imap-client-session.vala"
	params->err = _tmp3_;
#line 1760 "../src/engine/imap/transport/imap-client-session.vala"
	_g_free0 (_tmp2_);
#line 1762 "../src/engine/imap/transport/imap-client-session.vala"
	result = state;
#line 1762 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (params);
#line 1762 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 10247 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_already_logged_in (GearyImapClientSession* self,
                                                guint state,
                                                guint event,
                                                void* user,
                                                GObject* object)
{
	GearyImapClientSessionMachineParams* params = NULL;
	GearyImapClientSessionMachineParams* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GError* _tmp3_;
	guint result;
#line 1765 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 1765 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 1766 "../src/engine/imap/transport/imap-client-session.vala"
	_vala_assert (object != NULL, "object != null");
#line 1768 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_CLIENT_SESSION_TYPE_MACHINE_PARAMS, GearyImapClientSessionMachineParams));
#line 1768 "../src/engine/imap/transport/imap-client-session.vala"
	params = _tmp0_;
#line 1769 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 1769 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = _tmp1_;
#line 1769 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_ALREADY_CONNECTED, "Already logged in to %s", _tmp2_);
#line 1769 "../src/engine/imap/transport/imap-client-session.vala"
	_g_error_free0 (params->err);
#line 1769 "../src/engine/imap/transport/imap-client-session.vala"
	params->err = _tmp3_;
#line 1769 "../src/engine/imap/transport/imap-client-session.vala"
	_g_free0 (_tmp2_);
#line 1771 "../src/engine/imap/transport/imap-client-session.vala"
	result = state;
#line 1771 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (params);
#line 1771 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 10291 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_dropped_response (GearyImapClientSession* self,
                                               guint state,
                                               guint event,
                                               void* user,
                                               GObject* object)
{
	GearyImapServerResponse* server_response = NULL;
	GearyImapServerResponse* _tmp0_;
	GearyStateMachine* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	guint result;
#line 1775 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 1775 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 1776 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_TYPE_SERVER_RESPONSE, GearyImapServerResponse));
#line 1776 "../src/engine/imap/transport/imap-client-session.vala"
	server_response = _tmp0_;
#line 1778 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = self->priv->fsm;
#line 1778 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = geary_state_machine_get_event_issued_string (_tmp1_, state, event);
#line 1778 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = _tmp2_;
#line 1778 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp4_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (server_response, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 1778 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp5_ = _tmp4_;
#line 1778 "../src/engine/imap/transport/imap-client-session.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Dropped server response at %s: %s", _tmp3_, _tmp5_);
#line 1778 "../src/engine/imap/transport/imap-client-session.vala"
	_g_free0 (_tmp5_);
#line 1778 "../src/engine/imap/transport/imap-client-session.vala"
	_g_free0 (_tmp3_);
#line 1782 "../src/engine/imap/transport/imap-client-session.vala"
	result = state;
#line 1782 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (server_response);
#line 1782 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 10339 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_unauthenticated (GearyImapClientSession* self,
                                              guint state,
                                              guint event,
                                              void* user,
                                              GObject* object)
{
	GearyImapClientSessionMachineParams* params = NULL;
	GearyImapClientSessionMachineParams* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GError* _tmp3_;
	guint result;
#line 1786 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 1786 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 1787 "../src/engine/imap/transport/imap-client-session.vala"
	_vala_assert (object != NULL, "object != null");
#line 1789 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_CLIENT_SESSION_TYPE_MACHINE_PARAMS, GearyImapClientSessionMachineParams));
#line 1789 "../src/engine/imap/transport/imap-client-session.vala"
	params = _tmp0_;
#line 1790 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 1790 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = _tmp1_;
#line 1790 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_UNAUTHENTICATED, "Not authenticated with %s", _tmp2_);
#line 1790 "../src/engine/imap/transport/imap-client-session.vala"
	_g_error_free0 (params->err);
#line 1790 "../src/engine/imap/transport/imap-client-session.vala"
	params->err = _tmp3_;
#line 1790 "../src/engine/imap/transport/imap-client-session.vala"
	_g_free0 (_tmp2_);
#line 1792 "../src/engine/imap/transport/imap-client-session.vala"
	result = state;
#line 1792 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (params);
#line 1792 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 10383 "imap-client-session.c"
}

static guint
geary_imap_client_session_on_ignored_transition (GearyImapClientSession* self,
                                                 guint state,
                                                 guint event)
{
	GearyStateMachine* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	guint result;
#line 1795 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self), 0U);
#line 1796 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = self->priv->fsm;
#line 1796 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = geary_state_machine_get_event_issued_string (_tmp0_, state, event);
#line 1796 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = _tmp1_;
#line 1796 "../src/engine/imap/transport/imap-client-session.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Ignored transition: %s", _tmp2_);
#line 1796 "../src/engine/imap/transport/imap-client-session.vala"
	_g_free0 (_tmp2_);
#line 1799 "../src/engine/imap/transport/imap-client-session.vala"
	result = state;
#line 1799 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 10411 "imap-client-session.c"
}

static void
geary_imap_client_session_submit_command_data_free (gpointer _data)
{
	GearyImapClientSessionSubmitCommandData* _data_;
	_data_ = _data;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cmd);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->result);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_slice_free (GearyImapClientSessionSubmitCommandData, _data_);
#line 10427 "imap-client-session.c"
}

static void
geary_imap_client_session_submit_command (GearyImapClientSession* self,
                                          GearyImapCommand* cmd,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	GearyImapClientSessionSubmitCommandData* _data_;
	GearyImapClientSession* _tmp0_;
	GearyImapCommand* _tmp1_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_COMMAND (cmd));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_slice_new0 (GearyImapClientSessionSubmitCommandData);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_session_submit_command_data_free);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->self = _tmp0_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = _g_object_ref0 (cmd);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cmd);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->cmd = _tmp1_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_submit_command_co (_data_);
#line 10461 "imap-client-session.c"
}

static GearyImapStatusResponse*
geary_imap_client_session_submit_command_finish (GearyImapClientSession* self,
                                                 GAsyncResult* _res_,
                                                 GError** error)
{
	GearyImapStatusResponse* result;
	GearyImapClientSessionSubmitCommandData* _data_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	if (NULL == _data_) {
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		return NULL;
#line 10477 "imap-client-session.c"
	}
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	result = _data_->result;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->result = NULL;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 10485 "imap-client-session.c"
}

static void
geary_imap_client_session_submit_command_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_)
{
	GearyImapClientSessionSubmitCommandData* _data_;
#line 1819 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = _user_data_;
#line 1819 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_source_object_ = source_object;
#line 1819 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_res_ = _res_;
#line 1819 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_submit_command_co (_data_);
#line 10502 "imap-client-session.c"
}

static gboolean
geary_imap_client_session_submit_command_co (GearyImapClientSessionSubmitCommandData* _data_)
{
#line 1806 "../src/engine/imap/transport/imap-client-session.vala"
	switch (_data_->_state_) {
#line 1806 "../src/engine/imap/transport/imap-client-session.vala"
		case 0:
#line 10512 "imap-client-session.c"
		goto _state_0;
#line 1806 "../src/engine/imap/transport/imap-client-session.vala"
		case 1:
#line 10516 "imap-client-session.c"
		goto _state_1;
		default:
#line 1806 "../src/engine/imap/transport/imap-client-session.vala"
		g_assert_not_reached ();
#line 10521 "imap-client-session.c"
	}
	_state_0:
#line 1808 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp0_ = _data_->self->priv->cx;
#line 1808 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_tmp0_ == NULL) {
#line 1809 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp1_ = _data_->self->priv->imap_endpoint;
#line 1809 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp2_ = geary_endpoint_to_string (_data_->_tmp1_);
#line 1809 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 1809 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp4_ = g_error_new (GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_NOT_CONNECTED, "Not connected to %s", _data_->_tmp3_);
#line 1809 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 1809 "../src/engine/imap/transport/imap-client-session.vala"
		_g_free0 (_data_->_tmp3_);
#line 1809 "../src/engine/imap/transport/imap-client-session.vala"
		_data_->_inner_error0_ = _data_->_tmp5_;
#line 1809 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1809 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 1809 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 10548 "imap-client-session.c"
	}
#line 1813 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp6_ = _data_->self->priv->cx;
#line 1813 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_connection_send_command (_data_->_tmp6_, _data_->cmd, &_data_->_inner_error0_);
#line 1813 "../src/engine/imap/transport/imap-client-session.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1813 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1813 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 1813 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 10562 "imap-client-session.c"
	}
#line 1819 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_state_ = 1;
#line 1819 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_command_wait_until_complete (_data_->cmd, NULL, geary_imap_client_session_submit_command_ready, _data_);
#line 1819 "../src/engine/imap/transport/imap-client-session.vala"
	return FALSE;
#line 10570 "imap-client-session.c"
	_state_1:
#line 1819 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_command_wait_until_complete_finish (_data_->cmd, _data_->_res_, &_data_->_inner_error0_);
#line 1819 "../src/engine/imap/transport/imap-client-session.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1819 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1819 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 1819 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 10582 "imap-client-session.c"
	}
#line 1823 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp7_ = geary_imap_command_get_status (_data_->cmd);
#line 1823 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 1823 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp9_ = _g_object_ref0 (_data_->_tmp8_);
#line 1823 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->result = _data_->_tmp9_;
#line 1823 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1823 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_state_ != 0) {
#line 1823 "../src/engine/imap/transport/imap-client-session.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1823 "../src/engine/imap/transport/imap-client-session.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 10600 "imap-client-session.c"
		}
	}
#line 1823 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_unref (_data_->_async_result);
#line 1823 "../src/engine/imap/transport/imap-client-session.vala"
	return FALSE;
#line 10607 "imap-client-session.c"
}

static void
geary_imap_client_session_on_network_send_error (GearyImapClientSession* self,
                                                 GError* err)
{
	GearyStateMachine* _tmp0_;
#line 1830 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 1830 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (err != NULL);
#line 1831 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = self->priv->fsm;
#line 1831 "../src/engine/imap/transport/imap-client-session.vala"
	geary_state_machine_issue (_tmp0_, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_SEND_ERROR, NULL, NULL, err);
#line 10623 "imap-client-session.c"
}

static void
geary_imap_client_session_on_received_status_response (GearyImapClientSession* self,
                                                       GearyImapStatusResponse* status_response)
{
	GearyImapCommand* command = NULL;
	GearyImapClientConnection* _tmp0_;
	GearyImapTag* _tmp1_;
	GearyImapTag* _tmp2_;
	GearyImapCommand* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GearyImapCommand* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 1834 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 1834 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_STATUS_RESPONSE (status_response));
#line 1842 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = self->priv->cx;
#line 1842 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = geary_imap_server_response_get_tag (G_TYPE_CHECK_INSTANCE_CAST (status_response, GEARY_IMAP_TYPE_SERVER_RESPONSE, GearyImapServerResponse));
#line 1842 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = _tmp1_;
#line 1842 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = geary_imap_client_connection_get_sent_command (_tmp0_, _tmp2_);
#line 1842 "../src/engine/imap/transport/imap-client-session.vala"
	command = _tmp3_;
#line 1843 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp5_ = command;
#line 1843 "../src/engine/imap/transport/imap-client-session.vala"
	if (_tmp5_ == NULL) {
#line 1843 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp4_ = TRUE;
#line 10658 "imap-client-session.c"
	} else {
		GearyImapCommand* _tmp6_;
#line 1843 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp6_ = command;
#line 1843 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp4_ = !GEARY_IMAP_IS_IDLE_COMMAND (_tmp6_);
#line 10665 "imap-client-session.c"
	}
#line 1843 "../src/engine/imap/transport/imap-client-session.vala"
	if (_tmp4_) {
#line 10669 "imap-client-session.c"
		GearyImapResponseCode* response_code = NULL;
		GearyImapResponseCode* _tmp7_;
		GearyImapResponseCode* _tmp8_;
		GearyImapResponseCode* _tmp9_;
		GearyImapResponseCode* _tmp10_;
		gboolean _tmp29_;
		gboolean _tmp30_;
#line 1847 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp7_ = geary_imap_status_response_get_response_code (status_response);
#line 1847 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp8_ = _tmp7_;
#line 1847 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 1847 "../src/engine/imap/transport/imap-client-session.vala"
		response_code = _tmp9_;
#line 1848 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp10_ = response_code;
#line 1848 "../src/engine/imap/transport/imap-client-session.vala"
		if (_tmp10_ != NULL) {
#line 10689 "imap-client-session.c"
			{
				GearyImapResponseCodeType* _tmp11_ = NULL;
				GearyImapResponseCode* _tmp12_;
				GearyImapResponseCodeType* _tmp13_;
#line 1850 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp12_ = response_code;
#line 1850 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp13_ = geary_imap_response_code_get_response_code_type (_tmp12_, &_inner_error0_);
#line 1850 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp11_ = _tmp13_;
#line 1850 "../src/engine/imap/transport/imap-client-session.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10702 "imap-client-session.c"
					goto __catch0_g_error;
				}
#line 1850 "../src/engine/imap/transport/imap-client-session.vala"
				if (geary_imap_response_code_type_is_value (_tmp11_, GEARY_IMAP_RESPONSE_CODE_TYPE_CAPABILITY)) {
#line 10707 "imap-client-session.c"
					GearyImapCapabilities* _tmp14_ = NULL;
					GearyImapResponseCode* _tmp15_;
					GearyImapCapabilities* _tmp16_;
					gint _tmp17_;
					gint _tmp18_;
					GearyImapCapabilities* _tmp19_;
					GearyImapStatus _tmp20_;
					GearyImapStatus _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
					GearyImapCapabilities* _tmp24_;
					gchar* _tmp25_;
					gchar* _tmp26_;
#line 1851 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp15_ = response_code;
#line 1851 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp16_ = self->priv->_capabilities;
#line 1851 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp17_ = geary_imap_capabilities_get_revision (_tmp16_);
#line 1851 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp18_ = _tmp17_;
#line 1851 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp19_ = geary_imap_response_code_get_capabilities (_tmp15_, _tmp18_ + 1, &_inner_error0_);
#line 1851 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp14_ = _tmp19_;
#line 1851 "../src/engine/imap/transport/imap-client-session.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1851 "../src/engine/imap/transport/imap-client-session.vala"
						_g_object_unref0 (_tmp11_);
#line 10737 "imap-client-session.c"
						goto __catch0_g_error;
					}
#line 1851 "../src/engine/imap/transport/imap-client-session.vala"
					geary_imap_client_session_set_capabilities (self, _tmp14_);
#line 1854 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp20_ = geary_imap_status_response_get_status (status_response);
#line 1854 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp21_ = _tmp20_;
#line 1854 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp22_ = geary_imap_status_to_string (_tmp21_);
#line 1854 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp23_ = _tmp22_;
#line 1854 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp24_ = self->priv->_capabilities;
#line 1854 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp25_ = geary_generic_capabilities_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, GEARY_TYPE_GENERIC_CAPABILITIES, GearyGenericCapabilities));
#line 1854 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp26_ = _tmp25_;
#line 1854 "../src/engine/imap/transport/imap-client-session.vala"
					geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "%s set capabilities to: %s", _tmp23_, _tmp26_);
#line 1854 "../src/engine/imap/transport/imap-client-session.vala"
					_g_free0 (_tmp26_);
#line 1854 "../src/engine/imap/transport/imap-client-session.vala"
					_g_free0 (_tmp23_);
#line 1850 "../src/engine/imap/transport/imap-client-session.vala"
					_g_object_unref0 (_tmp14_);
#line 10764 "imap-client-session.c"
				}
#line 1849 "../src/engine/imap/transport/imap-client-session.vala"
				_g_object_unref0 (_tmp11_);
#line 10768 "imap-client-session.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* err = NULL;
				GError* _tmp27_;
				const gchar* _tmp28_;
#line 1849 "../src/engine/imap/transport/imap-client-session.vala"
				err = _inner_error0_;
#line 1849 "../src/engine/imap/transport/imap-client-session.vala"
				_inner_error0_ = NULL;
#line 1861 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp27_ = err;
#line 1861 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp28_ = _tmp27_->message;
#line 1861 "../src/engine/imap/transport/imap-client-session.vala"
				geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Unable to convert response code to capabilities: %s", _tmp28_);
#line 1849 "../src/engine/imap/transport/imap-client-session.vala"
				_g_error_free0 (err);
#line 10788 "imap-client-session.c"
			}
			__finally0:
#line 1849 "../src/engine/imap/transport/imap-client-session.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1849 "../src/engine/imap/transport/imap-client-session.vala"
				_g_object_unref0 (response_code);
#line 1849 "../src/engine/imap/transport/imap-client-session.vala"
				_g_object_unref0 (command);
#line 1849 "../src/engine/imap/transport/imap-client-session.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1849 "../src/engine/imap/transport/imap-client-session.vala"
				g_clear_error (&_inner_error0_);
#line 1849 "../src/engine/imap/transport/imap-client-session.vala"
				return;
#line 10803 "imap-client-session.c"
			}
		}
#line 1870 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp29_ = geary_imap_status_response_get_is_completion (status_response);
#line 1870 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp30_ = _tmp29_;
#line 1870 "../src/engine/imap/transport/imap-client-session.vala"
		if (_tmp30_) {
#line 10812 "imap-client-session.c"
			GearyStateMachine* _tmp31_;
#line 1871 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp31_ = self->priv->fsm;
#line 1871 "../src/engine/imap/transport/imap-client-session.vala"
			geary_state_machine_issue (_tmp31_, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_COMPLETION, NULL, G_TYPE_CHECK_INSTANCE_CAST (status_response, G_TYPE_OBJECT, GObject), NULL);
#line 10818 "imap-client-session.c"
		} else {
			GearyStateMachine* _tmp32_;
#line 1873 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp32_ = self->priv->fsm;
#line 1873 "../src/engine/imap/transport/imap-client-session.vala"
			geary_state_machine_issue (_tmp32_, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_STATUS, NULL, G_TYPE_CHECK_INSTANCE_CAST (status_response, G_TYPE_OBJECT, GObject), NULL);
#line 10825 "imap-client-session.c"
		}
#line 1876 "../src/engine/imap/transport/imap-client-session.vala"
		g_signal_emit (self, geary_imap_client_session_signals[GEARY_IMAP_CLIENT_SESSION_STATUS_RESPONSE_RECEIVED_SIGNAL], 0, status_response);
#line 1843 "../src/engine/imap/transport/imap-client-session.vala"
		_g_object_unref0 (response_code);
#line 10831 "imap-client-session.c"
	}
#line 1834 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (command);
#line 10835 "imap-client-session.c"
}

static void
geary_imap_client_session_notify_received_data (GearyImapClientSession* self,
                                                GearyImapServerData* server_data,
                                                GError** error)
{
	GearyImapServerDataType _tmp0_;
	GearyImapServerDataType _tmp1_;
	GError* _inner_error0_ = NULL;
#line 1880 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 1880 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_SERVER_DATA (server_data));
#line 1881 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = geary_imap_server_data_get_server_data_type (server_data);
#line 1881 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = _tmp0_;
#line 1881 "../src/engine/imap/transport/imap-client-session.vala"
	switch (_tmp1_) {
#line 1881 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_SERVER_DATA_TYPE_CAPABILITY:
#line 10858 "imap-client-session.c"
		{
			GearyImapCapabilities* _tmp2_ = NULL;
			GearyImapCapabilities* _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
			GearyImapCapabilities* _tmp6_;
			GearyImapServerDataType _tmp7_;
			GearyImapServerDataType _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			GearyImapCapabilities* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
#line 1885 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp3_ = self->priv->_capabilities;
#line 1885 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp4_ = geary_imap_capabilities_get_revision (_tmp3_);
#line 1885 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp5_ = _tmp4_;
#line 1885 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp6_ = geary_imap_server_data_get_capabilities (server_data, _tmp5_ + 1, &_inner_error0_);
#line 1885 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp2_ = _tmp6_;
#line 1885 "../src/engine/imap/transport/imap-client-session.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1885 "../src/engine/imap/transport/imap-client-session.vala"
				if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 1885 "../src/engine/imap/transport/imap-client-session.vala"
					g_propagate_error (error, _inner_error0_);
#line 1885 "../src/engine/imap/transport/imap-client-session.vala"
					return;
#line 10890 "imap-client-session.c"
				} else {
#line 1885 "../src/engine/imap/transport/imap-client-session.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1885 "../src/engine/imap/transport/imap-client-session.vala"
					g_clear_error (&_inner_error0_);
#line 1885 "../src/engine/imap/transport/imap-client-session.vala"
					return;
#line 10898 "imap-client-session.c"
				}
			}
#line 1885 "../src/engine/imap/transport/imap-client-session.vala"
			geary_imap_client_session_set_capabilities (self, _tmp2_);
#line 1888 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp7_ = geary_imap_server_data_get_server_data_type (server_data);
#line 1888 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp8_ = _tmp7_;
#line 1888 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp9_ = geary_imap_server_data_type_to_string (_tmp8_);
#line 1888 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp10_ = _tmp9_;
#line 1888 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp11_ = self->priv->_capabilities;
#line 1888 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp12_ = geary_generic_capabilities_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEARY_TYPE_GENERIC_CAPABILITIES, GearyGenericCapabilities));
#line 1888 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp13_ = _tmp12_;
#line 1888 "../src/engine/imap/transport/imap-client-session.vala"
			geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "%s set capabilities to: %s", _tmp10_, _tmp13_);
#line 1888 "../src/engine/imap/transport/imap-client-session.vala"
			_g_free0 (_tmp13_);
#line 1888 "../src/engine/imap/transport/imap-client-session.vala"
			_g_free0 (_tmp10_);
#line 1893 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_tmp2_);
#line 1893 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 10927 "imap-client-session.c"
		}
#line 1881 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_SERVER_DATA_TYPE_EXISTS:
#line 10931 "imap-client-session.c"
		{
			gint _tmp14_ = 0;
#line 1896 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp14_ = geary_imap_server_data_get_exists (server_data, &_inner_error0_);
#line 1896 "../src/engine/imap/transport/imap-client-session.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1896 "../src/engine/imap/transport/imap-client-session.vala"
				if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 1896 "../src/engine/imap/transport/imap-client-session.vala"
					g_propagate_error (error, _inner_error0_);
#line 1896 "../src/engine/imap/transport/imap-client-session.vala"
					return;
#line 10944 "imap-client-session.c"
				} else {
#line 1896 "../src/engine/imap/transport/imap-client-session.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1896 "../src/engine/imap/transport/imap-client-session.vala"
					g_clear_error (&_inner_error0_);
#line 1896 "../src/engine/imap/transport/imap-client-session.vala"
					return;
#line 10952 "imap-client-session.c"
				}
			}
#line 1896 "../src/engine/imap/transport/imap-client-session.vala"
			g_signal_emit (self, geary_imap_client_session_signals[GEARY_IMAP_CLIENT_SESSION_EXISTS_SIGNAL], 0, _tmp14_);
#line 1897 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 10959 "imap-client-session.c"
		}
#line 1881 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_SERVER_DATA_TYPE_EXPUNGE:
#line 10963 "imap-client-session.c"
		{
			GearyImapSequenceNumber* _tmp15_ = NULL;
			GearyImapSequenceNumber* _tmp16_;
#line 1900 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp16_ = geary_imap_server_data_get_expunge (server_data, &_inner_error0_);
#line 1900 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp15_ = _tmp16_;
#line 1900 "../src/engine/imap/transport/imap-client-session.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1900 "../src/engine/imap/transport/imap-client-session.vala"
				if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 1900 "../src/engine/imap/transport/imap-client-session.vala"
					g_propagate_error (error, _inner_error0_);
#line 1900 "../src/engine/imap/transport/imap-client-session.vala"
					return;
#line 10979 "imap-client-session.c"
				} else {
#line 1900 "../src/engine/imap/transport/imap-client-session.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1900 "../src/engine/imap/transport/imap-client-session.vala"
					g_clear_error (&_inner_error0_);
#line 1900 "../src/engine/imap/transport/imap-client-session.vala"
					return;
#line 10987 "imap-client-session.c"
				}
			}
#line 1900 "../src/engine/imap/transport/imap-client-session.vala"
			g_signal_emit (self, geary_imap_client_session_signals[GEARY_IMAP_CLIENT_SESSION_EXPUNGE_SIGNAL], 0, _tmp15_);
#line 1901 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_tmp15_);
#line 1901 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 10996 "imap-client-session.c"
		}
#line 1881 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_SERVER_DATA_TYPE_FETCH:
#line 11000 "imap-client-session.c"
		{
			GearyImapFetchedData* _tmp17_ = NULL;
			GearyImapFetchedData* _tmp18_;
#line 1904 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp18_ = geary_imap_server_data_get_fetch (server_data, &_inner_error0_);
#line 1904 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp17_ = _tmp18_;
#line 1904 "../src/engine/imap/transport/imap-client-session.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1904 "../src/engine/imap/transport/imap-client-session.vala"
				if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 1904 "../src/engine/imap/transport/imap-client-session.vala"
					g_propagate_error (error, _inner_error0_);
#line 1904 "../src/engine/imap/transport/imap-client-session.vala"
					return;
#line 11016 "imap-client-session.c"
				} else {
#line 1904 "../src/engine/imap/transport/imap-client-session.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1904 "../src/engine/imap/transport/imap-client-session.vala"
					g_clear_error (&_inner_error0_);
#line 1904 "../src/engine/imap/transport/imap-client-session.vala"
					return;
#line 11024 "imap-client-session.c"
				}
			}
#line 1904 "../src/engine/imap/transport/imap-client-session.vala"
			g_signal_emit (self, geary_imap_client_session_signals[GEARY_IMAP_CLIENT_SESSION_FETCH_SIGNAL], 0, _tmp17_);
#line 1905 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_tmp17_);
#line 1905 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 11033 "imap-client-session.c"
		}
#line 1881 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_SERVER_DATA_TYPE_FLAGS:
#line 11037 "imap-client-session.c"
		{
			GearyImapMailboxAttributes* _tmp19_ = NULL;
			GearyImapMailboxAttributes* _tmp20_;
#line 1908 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp20_ = geary_imap_server_data_get_flags (server_data, &_inner_error0_);
#line 1908 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp19_ = _tmp20_;
#line 1908 "../src/engine/imap/transport/imap-client-session.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1908 "../src/engine/imap/transport/imap-client-session.vala"
				if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 1908 "../src/engine/imap/transport/imap-client-session.vala"
					g_propagate_error (error, _inner_error0_);
#line 1908 "../src/engine/imap/transport/imap-client-session.vala"
					return;
#line 11053 "imap-client-session.c"
				} else {
#line 1908 "../src/engine/imap/transport/imap-client-session.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1908 "../src/engine/imap/transport/imap-client-session.vala"
					g_clear_error (&_inner_error0_);
#line 1908 "../src/engine/imap/transport/imap-client-session.vala"
					return;
#line 11061 "imap-client-session.c"
				}
			}
#line 1908 "../src/engine/imap/transport/imap-client-session.vala"
			g_signal_emit (self, geary_imap_client_session_signals[GEARY_IMAP_CLIENT_SESSION_FLAGS_SIGNAL], 0, _tmp19_);
#line 1909 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_tmp19_);
#line 1909 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 11070 "imap-client-session.c"
		}
#line 1881 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_SERVER_DATA_TYPE_LIST:
#line 1881 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_SERVER_DATA_TYPE_XLIST:
#line 11076 "imap-client-session.c"
		{
			GearyImapMailboxInformation* _tmp21_ = NULL;
			GearyImapMailboxInformation* _tmp22_;
#line 1913 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp22_ = geary_imap_server_data_get_list (server_data, &_inner_error0_);
#line 1913 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp21_ = _tmp22_;
#line 1913 "../src/engine/imap/transport/imap-client-session.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1913 "../src/engine/imap/transport/imap-client-session.vala"
				if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 1913 "../src/engine/imap/transport/imap-client-session.vala"
					g_propagate_error (error, _inner_error0_);
#line 1913 "../src/engine/imap/transport/imap-client-session.vala"
					return;
#line 11092 "imap-client-session.c"
				} else {
#line 1913 "../src/engine/imap/transport/imap-client-session.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1913 "../src/engine/imap/transport/imap-client-session.vala"
					g_clear_error (&_inner_error0_);
#line 1913 "../src/engine/imap/transport/imap-client-session.vala"
					return;
#line 11100 "imap-client-session.c"
				}
			}
#line 1913 "../src/engine/imap/transport/imap-client-session.vala"
			g_signal_emit (self, geary_imap_client_session_signals[GEARY_IMAP_CLIENT_SESSION_LIST_SIGNAL], 0, _tmp21_);
#line 1914 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_tmp21_);
#line 1914 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 11109 "imap-client-session.c"
		}
#line 1881 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_SERVER_DATA_TYPE_RECENT:
#line 11113 "imap-client-session.c"
		{
			gint _tmp23_ = 0;
#line 1917 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp23_ = geary_imap_server_data_get_recent (server_data, &_inner_error0_);
#line 1917 "../src/engine/imap/transport/imap-client-session.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1917 "../src/engine/imap/transport/imap-client-session.vala"
				if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 1917 "../src/engine/imap/transport/imap-client-session.vala"
					g_propagate_error (error, _inner_error0_);
#line 1917 "../src/engine/imap/transport/imap-client-session.vala"
					return;
#line 11126 "imap-client-session.c"
				} else {
#line 1917 "../src/engine/imap/transport/imap-client-session.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1917 "../src/engine/imap/transport/imap-client-session.vala"
					g_clear_error (&_inner_error0_);
#line 1917 "../src/engine/imap/transport/imap-client-session.vala"
					return;
#line 11134 "imap-client-session.c"
				}
			}
#line 1917 "../src/engine/imap/transport/imap-client-session.vala"
			g_signal_emit (self, geary_imap_client_session_signals[GEARY_IMAP_CLIENT_SESSION_RECENT_SIGNAL], 0, _tmp23_);
#line 1918 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 11141 "imap-client-session.c"
		}
#line 1881 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_SERVER_DATA_TYPE_STATUS:
#line 11145 "imap-client-session.c"
		{
			GearyImapStatusData* _tmp24_ = NULL;
			GearyImapStatusData* _tmp25_;
#line 1921 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp25_ = geary_imap_server_data_get_status (server_data, &_inner_error0_);
#line 1921 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp24_ = _tmp25_;
#line 1921 "../src/engine/imap/transport/imap-client-session.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1921 "../src/engine/imap/transport/imap-client-session.vala"
				if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 1921 "../src/engine/imap/transport/imap-client-session.vala"
					g_propagate_error (error, _inner_error0_);
#line 1921 "../src/engine/imap/transport/imap-client-session.vala"
					return;
#line 11161 "imap-client-session.c"
				} else {
#line 1921 "../src/engine/imap/transport/imap-client-session.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1921 "../src/engine/imap/transport/imap-client-session.vala"
					g_clear_error (&_inner_error0_);
#line 1921 "../src/engine/imap/transport/imap-client-session.vala"
					return;
#line 11169 "imap-client-session.c"
				}
			}
#line 1921 "../src/engine/imap/transport/imap-client-session.vala"
			g_signal_emit (self, geary_imap_client_session_signals[GEARY_IMAP_CLIENT_SESSION_STATUS_SIGNAL], 0, _tmp24_);
#line 1922 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (_tmp24_);
#line 1922 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 11178 "imap-client-session.c"
		}
#line 1881 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_SERVER_DATA_TYPE_SEARCH:
#line 11182 "imap-client-session.c"
		{
			gint64* _tmp26_ = NULL;
			gint _tmp27_ = 0;
			gint64* _tmp28_;
			gint _tmp26__length1;
			gint __tmp26__size_;
#line 1925 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp28_ = geary_imap_server_data_get_search (server_data, &_tmp27_, &_inner_error0_);
#line 1925 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp26_ = _tmp28_;
#line 1925 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp26__length1 = _tmp27_;
#line 1925 "../src/engine/imap/transport/imap-client-session.vala"
			__tmp26__size_ = _tmp26__length1;
#line 1925 "../src/engine/imap/transport/imap-client-session.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1925 "../src/engine/imap/transport/imap-client-session.vala"
				if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 1925 "../src/engine/imap/transport/imap-client-session.vala"
					g_propagate_error (error, _inner_error0_);
#line 1925 "../src/engine/imap/transport/imap-client-session.vala"
					return;
#line 11205 "imap-client-session.c"
				} else {
#line 1925 "../src/engine/imap/transport/imap-client-session.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1925 "../src/engine/imap/transport/imap-client-session.vala"
					g_clear_error (&_inner_error0_);
#line 1925 "../src/engine/imap/transport/imap-client-session.vala"
					return;
#line 11213 "imap-client-session.c"
				}
			}
#line 1925 "../src/engine/imap/transport/imap-client-session.vala"
			g_signal_emit (self, geary_imap_client_session_signals[GEARY_IMAP_CLIENT_SESSION_SEARCH_SIGNAL], 0, _tmp26_, (gint) _tmp26__length1);
#line 1926 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp26_ = (g_free (_tmp26_), NULL);
#line 1926 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 11222 "imap-client-session.c"
		}
#line 1881 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_SERVER_DATA_TYPE_NAMESPACE:
#line 11226 "imap-client-session.c"
		{
			GearyImapNamespaceResponse* ns = NULL;
			GearyImapNamespaceResponse* _tmp29_;
			GearyImapNamespaceResponse* _tmp30_;
			GeeList* _tmp31_;
			GeeList* _tmp32_;
			GeeList* _tmp33_;
			GearyImapNamespaceResponse* _tmp34_;
			GeeList* _tmp35_;
			GeeList* _tmp36_;
			GeeList* _tmp37_;
			GearyImapNamespaceResponse* _tmp38_;
			GeeList* _tmp39_;
			GeeList* _tmp40_;
			GeeList* _tmp41_;
#line 1932 "../src/engine/imap/transport/imap-client-session.vala"
			geary_imap_client_session_clear_namespaces (self);
#line 1933 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp29_ = geary_imap_server_data_get_namespace (server_data, &_inner_error0_);
#line 1933 "../src/engine/imap/transport/imap-client-session.vala"
			ns = _tmp29_;
#line 1933 "../src/engine/imap/transport/imap-client-session.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1933 "../src/engine/imap/transport/imap-client-session.vala"
				if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 1933 "../src/engine/imap/transport/imap-client-session.vala"
					g_propagate_error (error, _inner_error0_);
#line 1933 "../src/engine/imap/transport/imap-client-session.vala"
					return;
#line 11256 "imap-client-session.c"
				} else {
#line 1933 "../src/engine/imap/transport/imap-client-session.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1933 "../src/engine/imap/transport/imap-client-session.vala"
					g_clear_error (&_inner_error0_);
#line 1933 "../src/engine/imap/transport/imap-client-session.vala"
					return;
#line 11264 "imap-client-session.c"
				}
			}
#line 1934 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp30_ = ns;
#line 1934 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp31_ = geary_imap_namespace_response_get_personal (_tmp30_);
#line 1934 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp32_ = _tmp31_;
#line 1934 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp33_ = self->priv->personal_namespaces;
#line 1934 "../src/engine/imap/transport/imap-client-session.vala"
			geary_imap_client_session_update_namespaces (self, _tmp32_, _tmp33_);
#line 1935 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp34_ = ns;
#line 1935 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp35_ = geary_imap_namespace_response_get_shared (_tmp34_);
#line 1935 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp36_ = _tmp35_;
#line 1935 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp37_ = self->priv->shared_namespaces;
#line 1935 "../src/engine/imap/transport/imap-client-session.vala"
			geary_imap_client_session_update_namespaces (self, _tmp36_, _tmp37_);
#line 1936 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp38_ = ns;
#line 1936 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp39_ = geary_imap_namespace_response_get_user (_tmp38_);
#line 1936 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp40_ = _tmp39_;
#line 1936 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp41_ = self->priv->user_namespaces;
#line 1936 "../src/engine/imap/transport/imap-client-session.vala"
			geary_imap_client_session_update_namespaces (self, _tmp40_, _tmp41_);
#line 1937 "../src/engine/imap/transport/imap-client-session.vala"
			_g_object_unref0 (ns);
#line 1937 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 11301 "imap-client-session.c"
		}
		default:
#line 1881 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_SERVER_DATA_TYPE_LSUB:
#line 11306 "imap-client-session.c"
		{
			gchar* _tmp42_;
			gchar* _tmp43_;
#line 1943 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp42_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (server_data, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 1943 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp43_ = _tmp42_;
#line 1943 "../src/engine/imap/transport/imap-client-session.vala"
			geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Not notifying of unhandled server data: %s", _tmp43_);
#line 1943 "../src/engine/imap/transport/imap-client-session.vala"
			_g_free0 (_tmp43_);
#line 1945 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 11320 "imap-client-session.c"
		}
	}
}

static void
geary_imap_client_session_clear_namespaces (GearyImapClientSession* self)
{
	GeeMap* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
	GeeList* _tmp3_;
#line 1949 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 1950 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = self->priv->namespaces;
#line 1950 "../src/engine/imap/transport/imap-client-session.vala"
	gee_map_clear (_tmp0_);
#line 1951 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = self->priv->personal_namespaces;
#line 1951 "../src/engine/imap/transport/imap-client-session.vala"
	gee_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1952 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = self->priv->shared_namespaces;
#line 1952 "../src/engine/imap/transport/imap-client-session.vala"
	gee_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1953 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = self->priv->user_namespaces;
#line 1953 "../src/engine/imap/transport/imap-client-session.vala"
	gee_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 11350 "imap-client-session.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 11373 "imap-client-session.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 11382 "imap-client-session.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 11401 "imap-client-session.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 11405 "imap-client-session.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 11411 "imap-client-session.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 11421 "imap-client-session.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 11429 "imap-client-session.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 11433 "imap-client-session.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 11439 "imap-client-session.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 11449 "imap-client-session.c"
}

static void
geary_imap_client_session_update_namespaces (GearyImapClientSession* self,
                                             GeeList* response,
                                             GeeList* list)
{
#line 1956 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 1956 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail ((response == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (response, GEE_TYPE_LIST));
#line 1956 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (list, GEE_TYPE_LIST));
#line 1958 "../src/engine/imap/transport/imap-client-session.vala"
	if (response != NULL) {
#line 11465 "imap-client-session.c"
		{
			GeeList* _ns_list = NULL;
			gint _ns_size = 0;
			GeeList* _tmp0_;
			gint _tmp1_;
			gint _tmp2_;
			gint _ns_index = 0;
#line 1959 "../src/engine/imap/transport/imap-client-session.vala"
			_ns_list = response;
#line 1959 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp0_ = _ns_list;
#line 1959 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp1_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1959 "../src/engine/imap/transport/imap-client-session.vala"
			_tmp2_ = _tmp1_;
#line 1959 "../src/engine/imap/transport/imap-client-session.vala"
			_ns_size = _tmp2_;
#line 1959 "../src/engine/imap/transport/imap-client-session.vala"
			_ns_index = -1;
#line 1959 "../src/engine/imap/transport/imap-client-session.vala"
			while (TRUE) {
#line 11487 "imap-client-session.c"
				gint _tmp3_;
				gint _tmp4_;
				GearyImapNamespace* ns = NULL;
				GeeList* _tmp5_;
				gpointer _tmp6_;
				GearyImapNamespace* _tmp7_;
				gchar* prefix = NULL;
				GearyImapNamespace* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* delim = NULL;
				GearyImapNamespace* _tmp12_;
				const gchar* _tmp13_;
				const gchar* _tmp14_;
				gchar* _tmp15_;
				gboolean _tmp16_ = FALSE;
				const gchar* _tmp17_;
				GeeMap* _tmp28_;
				const gchar* _tmp29_;
				GearyImapNamespace* _tmp30_;
#line 1959 "../src/engine/imap/transport/imap-client-session.vala"
				_ns_index = _ns_index + 1;
#line 1959 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp3_ = _ns_index;
#line 1959 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp4_ = _ns_size;
#line 1959 "../src/engine/imap/transport/imap-client-session.vala"
				if (!(_tmp3_ < _tmp4_)) {
#line 1959 "../src/engine/imap/transport/imap-client-session.vala"
					break;
#line 11519 "imap-client-session.c"
				}
#line 1959 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp5_ = _ns_list;
#line 1959 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp6_ = gee_list_get (_tmp5_, _ns_index);
#line 1959 "../src/engine/imap/transport/imap-client-session.vala"
				ns = (GearyImapNamespace*) _tmp6_;
#line 1960 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp7_ = ns;
#line 1960 "../src/engine/imap/transport/imap-client-session.vala"
				gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (list, GEE_TYPE_COLLECTION, GeeCollection), _tmp7_);
#line 1961 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp8_ = ns;
#line 1961 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp9_ = geary_imap_namespace_get_prefix (_tmp8_);
#line 1961 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp10_ = _tmp9_;
#line 1961 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp11_ = g_strdup (_tmp10_);
#line 1961 "../src/engine/imap/transport/imap-client-session.vala"
				prefix = _tmp11_;
#line 1962 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp12_ = ns;
#line 1962 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp13_ = geary_imap_namespace_get_delim (_tmp12_);
#line 1962 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp14_ = _tmp13_;
#line 1962 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp15_ = g_strdup (_tmp14_);
#line 1962 "../src/engine/imap/transport/imap-client-session.vala"
				delim = _tmp15_;
#line 1963 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp17_ = delim;
#line 1963 "../src/engine/imap/transport/imap-client-session.vala"
				if (_tmp17_ != NULL) {
#line 11555 "imap-client-session.c"
					const gchar* _tmp18_;
					const gchar* _tmp19_;
#line 1963 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp18_ = prefix;
#line 1963 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp19_ = delim;
#line 1963 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp16_ = g_str_has_suffix (_tmp18_, _tmp19_);
#line 11564 "imap-client-session.c"
				} else {
#line 1963 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp16_ = FALSE;
#line 11568 "imap-client-session.c"
				}
#line 1963 "../src/engine/imap/transport/imap-client-session.vala"
				if (_tmp16_) {
#line 11572 "imap-client-session.c"
					const gchar* _tmp20_;
					const gchar* _tmp21_;
					gint _tmp22_;
					gint _tmp23_;
					const gchar* _tmp24_;
					gint _tmp25_;
					gint _tmp26_;
					gchar* _tmp27_;
#line 1964 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp20_ = prefix;
#line 1964 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp21_ = prefix;
#line 1964 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp22_ = strlen (_tmp21_);
#line 1964 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp23_ = _tmp22_;
#line 1964 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp24_ = delim;
#line 1964 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp25_ = strlen (_tmp24_);
#line 1964 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp26_ = _tmp25_;
#line 1964 "../src/engine/imap/transport/imap-client-session.vala"
					_tmp27_ = string_substring (_tmp20_, (glong) 0, (glong) (_tmp23_ - _tmp26_));
#line 1964 "../src/engine/imap/transport/imap-client-session.vala"
					_g_free0 (prefix);
#line 1964 "../src/engine/imap/transport/imap-client-session.vala"
					prefix = _tmp27_;
#line 11601 "imap-client-session.c"
				}
#line 1966 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp28_ = self->priv->namespaces;
#line 1966 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp29_ = prefix;
#line 1966 "../src/engine/imap/transport/imap-client-session.vala"
				_tmp30_ = ns;
#line 1966 "../src/engine/imap/transport/imap-client-session.vala"
				gee_map_set (_tmp28_, _tmp29_, _tmp30_);
#line 1959 "../src/engine/imap/transport/imap-client-session.vala"
				_g_free0 (delim);
#line 1959 "../src/engine/imap/transport/imap-client-session.vala"
				_g_free0 (prefix);
#line 1959 "../src/engine/imap/transport/imap-client-session.vala"
				_g_object_unref0 (ns);
#line 11617 "imap-client-session.c"
			}
		}
	}
}

static void
geary_imap_client_session_on_received_server_data (GearyImapClientSession* self,
                                                   GearyImapServerData* server_data)
{
	GError* _inner_error0_ = NULL;
#line 1971 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 1971 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_SERVER_DATA (server_data));
#line 11632 "imap-client-session.c"
	{
#line 1974 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_session_notify_received_data (self, server_data, &_inner_error0_);
#line 1974 "../src/engine/imap/transport/imap-client-session.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1974 "../src/engine/imap/transport/imap-client-session.vala"
			if (_inner_error0_->domain == GEARY_IMAP_ERROR) {
#line 11640 "imap-client-session.c"
				goto __catch0_geary_imap_error;
			}
#line 1974 "../src/engine/imap/transport/imap-client-session.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1974 "../src/engine/imap/transport/imap-client-session.vala"
			g_clear_error (&_inner_error0_);
#line 1974 "../src/engine/imap/transport/imap-client-session.vala"
			return;
#line 11649 "imap-client-session.c"
		}
	}
	goto __finally0;
	__catch0_geary_imap_error:
	{
		GError* ierr = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 1973 "../src/engine/imap/transport/imap-client-session.vala"
		ierr = _inner_error0_;
#line 1973 "../src/engine/imap/transport/imap-client-session.vala"
		_inner_error0_ = NULL;
#line 1976 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp0_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (server_data, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 1976 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp1_ = _tmp0_;
#line 1976 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp2_ = ierr;
#line 1976 "../src/engine/imap/transport/imap-client-session.vala"
		_tmp3_ = _tmp2_->message;
#line 1976 "../src/engine/imap/transport/imap-client-session.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Failure notifying of server data: %s %s", _tmp1_, _tmp3_);
#line 1976 "../src/engine/imap/transport/imap-client-session.vala"
		_g_free0 (_tmp1_);
#line 1973 "../src/engine/imap/transport/imap-client-session.vala"
		_g_error_free0 (ierr);
#line 11678 "imap-client-session.c"
	}
	__finally0:
#line 1973 "../src/engine/imap/transport/imap-client-session.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1973 "../src/engine/imap/transport/imap-client-session.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1973 "../src/engine/imap/transport/imap-client-session.vala"
		g_clear_error (&_inner_error0_);
#line 1973 "../src/engine/imap/transport/imap-client-session.vala"
		return;
#line 11689 "imap-client-session.c"
	}
}

static void
geary_imap_client_session_on_received_bytes (GearyImapClientSession* self)
{
#line 1982 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 1983 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_set_last_seen (self, g_get_real_time ());
#line 1986 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_schedule_keepalive (self);
#line 11702 "imap-client-session.c"
}

static void
geary_imap_client_session_on_received_bad_response (GearyImapClientSession* self,
                                                    GearyImapRootParameters* root,
                                                    GError* err)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GearyStateMachine* _tmp3_;
#line 1989 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 1989 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_ROOT_PARAMETERS (root));
#line 1990 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (root, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 1990 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = _tmp0_;
#line 1990 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = err->message;
#line 1990 "../src/engine/imap/transport/imap-client-session.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Received bad response %s: %s", _tmp1_, _tmp2_);
#line 1990 "../src/engine/imap/transport/imap-client-session.vala"
	_g_free0 (_tmp1_);
#line 1991 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = self->priv->fsm;
#line 1991 "../src/engine/imap/transport/imap-client-session.vala"
	geary_state_machine_issue (_tmp3_, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_ERROR, NULL, NULL, err);
#line 11732 "imap-client-session.c"
}

static void
geary_imap_client_session_on_network_receive_failure (GearyImapClientSession* self,
                                                      GError* err)
{
	GearyStateMachine* _tmp0_;
#line 1994 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (self));
#line 1994 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (err != NULL);
#line 1995 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = self->priv->fsm;
#line 1995 "../src/engine/imap/transport/imap-client-session.vala"
	geary_state_machine_issue (_tmp0_, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_RECV_ERROR, NULL, NULL, err);
#line 11748 "imap-client-session.c"
}

static GearyImapClientSessionMachineParams*
geary_imap_client_session_machine_params_construct (GType object_type,
                                                    GearyImapCommand* cmd)
{
	GearyImapClientSessionMachineParams * self = NULL;
	GearyImapCommand* _tmp0_;
#line 136 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail ((cmd == NULL) || GEARY_IMAP_IS_COMMAND (cmd), NULL);
#line 136 "../src/engine/imap/transport/imap-client-session.vala"
	self = (GearyImapClientSessionMachineParams*) g_object_new (object_type, NULL);
#line 137 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (cmd);
#line 137 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->cmd);
#line 137 "../src/engine/imap/transport/imap-client-session.vala"
	self->cmd = _tmp0_;
#line 136 "../src/engine/imap/transport/imap-client-session.vala"
	return self;
#line 11769 "imap-client-session.c"
}

static GearyImapClientSessionMachineParams*
geary_imap_client_session_machine_params_new (GearyImapCommand* cmd)
{
#line 136 "../src/engine/imap/transport/imap-client-session.vala"
	return geary_imap_client_session_machine_params_construct (GEARY_IMAP_CLIENT_SESSION_TYPE_MACHINE_PARAMS, cmd);
#line 11777 "imap-client-session.c"
}

static void
geary_imap_client_session_machine_params_class_init (GearyImapClientSessionMachineParamsClass * klass,
                                                     gpointer klass_data)
{
#line 128 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_machine_params_parent_class = g_type_class_peek_parent (klass);
#line 128 "../src/engine/imap/transport/imap-client-session.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_imap_client_session_machine_params_finalize;
#line 11788 "imap-client-session.c"
}

static void
geary_imap_client_session_machine_params_instance_init (GearyImapClientSessionMachineParams * self,
                                                        gpointer klass)
{
#line 133 "../src/engine/imap/transport/imap-client-session.vala"
	self->err = NULL;
#line 134 "../src/engine/imap/transport/imap-client-session.vala"
	self->proceed = FALSE;
#line 11799 "imap-client-session.c"
}

static void
geary_imap_client_session_machine_params_finalize (GObject * obj)
{
	GearyImapClientSessionMachineParams * self;
#line 128 "../src/engine/imap/transport/imap-client-session.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_IMAP_CLIENT_SESSION_TYPE_MACHINE_PARAMS, GearyImapClientSessionMachineParams);
#line 130 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->cmd);
#line 133 "../src/engine/imap/transport/imap-client-session.vala"
	_g_error_free0 (self->err);
#line 128 "../src/engine/imap/transport/imap-client-session.vala"
	G_OBJECT_CLASS (geary_imap_client_session_machine_params_parent_class)->finalize (obj);
#line 11814 "imap-client-session.c"
}

 G_GNUC_NO_INLINE static GType
geary_imap_client_session_machine_params_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyImapClientSessionMachineParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_imap_client_session_machine_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyImapClientSessionMachineParams), 0, (GInstanceInitFunc) geary_imap_client_session_machine_params_instance_init, NULL };
	GType geary_imap_client_session_machine_params_type_id;
	geary_imap_client_session_machine_params_type_id = g_type_register_static (G_TYPE_OBJECT, "GearyImapClientSessionMachineParams", &g_define_type_info, 0);
	return geary_imap_client_session_machine_params_type_id;
}

static GType
geary_imap_client_session_machine_params_get_type (void)
{
	static gsize geary_imap_client_session_machine_params_type_id__once = 0;
	if (g_once_init_enter (&geary_imap_client_session_machine_params_type_id__once)) {
		GType geary_imap_client_session_machine_params_type_id;
		geary_imap_client_session_machine_params_type_id = geary_imap_client_session_machine_params_get_type_once ();
		g_once_init_leave (&geary_imap_client_session_machine_params_type_id__once, geary_imap_client_session_machine_params_type_id);
	}
	return geary_imap_client_session_machine_params_type_id__once;
}

static GearyImapClientSessionCommandCallback*
geary_imap_client_session_command_callback_construct (GType object_type,
                                                      GSourceFunc callback,
                                                      gpointer callback_target)
{
	GearyImapClientSessionCommandCallback* self = NULL;
#line 145 "../src/engine/imap/transport/imap-client-session.vala"
	self = (GearyImapClientSessionCommandCallback*) g_type_create_instance (object_type);
#line 146 "../src/engine/imap/transport/imap-client-session.vala"
	self->callback = callback;
#line 146 "../src/engine/imap/transport/imap-client-session.vala"
	self->callback_target = callback_target;
#line 145 "../src/engine/imap/transport/imap-client-session.vala"
	return self;
#line 11852 "imap-client-session.c"
}

static GearyImapClientSessionCommandCallback*
geary_imap_client_session_command_callback_new (GSourceFunc callback,
                                                gpointer callback_target)
{
#line 145 "../src/engine/imap/transport/imap-client-session.vala"
	return geary_imap_client_session_command_callback_construct (GEARY_IMAP_CLIENT_SESSION_TYPE_COMMAND_CALLBACK, callback, callback_target);
#line 11861 "imap-client-session.c"
}

static void
geary_imap_client_session_value_command_callback_init (GValue* value)
{
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	value->data[0].v_pointer = NULL;
#line 11869 "imap-client-session.c"
}

static void
geary_imap_client_session_value_command_callback_free_value (GValue* value)
{
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	if (value->data[0].v_pointer) {
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_session_command_callback_unref (value->data[0].v_pointer);
#line 11879 "imap-client-session.c"
	}
}

static void
geary_imap_client_session_value_command_callback_copy_value (const GValue* src_value,
                                                             GValue* dest_value)
{
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	if (src_value->data[0].v_pointer) {
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
		dest_value->data[0].v_pointer = geary_imap_client_session_command_callback_ref (src_value->data[0].v_pointer);
#line 11891 "imap-client-session.c"
	} else {
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
		dest_value->data[0].v_pointer = NULL;
#line 11895 "imap-client-session.c"
	}
}

static gpointer
geary_imap_client_session_value_command_callback_peek_pointer (const GValue* value)
{
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	return value->data[0].v_pointer;
#line 11904 "imap-client-session.c"
}

static gchar*
geary_imap_client_session_value_command_callback_collect_value (GValue* value,
                                                                guint n_collect_values,
                                                                GTypeCValue* collect_values,
                                                                guint collect_flags)
{
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	if (collect_values[0].v_pointer) {
#line 11915 "imap-client-session.c"
		GearyImapClientSessionCommandCallback * object;
		object = collect_values[0].v_pointer;
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
		if (object->parent_instance.g_class == NULL) {
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 11922 "imap-client-session.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 11926 "imap-client-session.c"
		}
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
		value->data[0].v_pointer = geary_imap_client_session_command_callback_ref (object);
#line 11930 "imap-client-session.c"
	} else {
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
		value->data[0].v_pointer = NULL;
#line 11934 "imap-client-session.c"
	}
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	return NULL;
#line 11938 "imap-client-session.c"
}

static gchar*
geary_imap_client_session_value_command_callback_lcopy_value (const GValue* value,
                                                              guint n_collect_values,
                                                              GTypeCValue* collect_values,
                                                              guint collect_flags)
{
	GearyImapClientSessionCommandCallback ** object_p;
	object_p = collect_values[0].v_pointer;
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	if (!object_p) {
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 11953 "imap-client-session.c"
	}
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	if (!value->data[0].v_pointer) {
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
		*object_p = NULL;
#line 11959 "imap-client-session.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
		*object_p = value->data[0].v_pointer;
#line 11963 "imap-client-session.c"
	} else {
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
		*object_p = geary_imap_client_session_command_callback_ref (value->data[0].v_pointer);
#line 11967 "imap-client-session.c"
	}
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	return NULL;
#line 11971 "imap-client-session.c"
}

static GParamSpec*
geary_imap_client_session_param_spec_command_callback (const gchar* name,
                                                       const gchar* nick,
                                                       const gchar* blurb,
                                                       GType object_type,
                                                       GParamFlags flags)
{
	GearyImapClientSessionParamSpecCommandCallback* spec;
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GEARY_IMAP_CLIENT_SESSION_TYPE_COMMAND_CALLBACK), NULL);
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	return G_PARAM_SPEC (spec);
#line 11990 "imap-client-session.c"
}

static gpointer
geary_imap_client_session_value_get_command_callback (const GValue* value)
{
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_IMAP_CLIENT_SESSION_TYPE_COMMAND_CALLBACK), NULL);
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	return value->data[0].v_pointer;
#line 12000 "imap-client-session.c"
}

static void
geary_imap_client_session_value_set_command_callback (GValue* value,
                                                      gpointer v_object)
{
	GearyImapClientSessionCommandCallback * old;
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_IMAP_CLIENT_SESSION_TYPE_COMMAND_CALLBACK));
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	old = value->data[0].v_pointer;
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	if (v_object) {
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GEARY_IMAP_CLIENT_SESSION_TYPE_COMMAND_CALLBACK));
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
		value->data[0].v_pointer = v_object;
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_session_command_callback_ref (value->data[0].v_pointer);
#line 12022 "imap-client-session.c"
	} else {
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
		value->data[0].v_pointer = NULL;
#line 12026 "imap-client-session.c"
	}
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	if (old) {
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_session_command_callback_unref (old);
#line 12032 "imap-client-session.c"
	}
}

static void
geary_imap_client_session_value_take_command_callback (GValue* value,
                                                       gpointer v_object)
{
	GearyImapClientSessionCommandCallback * old;
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_IMAP_CLIENT_SESSION_TYPE_COMMAND_CALLBACK));
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	old = value->data[0].v_pointer;
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	if (v_object) {
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GEARY_IMAP_CLIENT_SESSION_TYPE_COMMAND_CALLBACK));
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
		value->data[0].v_pointer = v_object;
#line 12053 "imap-client-session.c"
	} else {
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
		value->data[0].v_pointer = NULL;
#line 12057 "imap-client-session.c"
	}
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	if (old) {
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_session_command_callback_unref (old);
#line 12063 "imap-client-session.c"
	}
}

static void
geary_imap_client_session_command_callback_class_init (GearyImapClientSessionCommandCallbackClass * klass,
                                                       gpointer klass_data)
{
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_command_callback_parent_class = g_type_class_peek_parent (klass);
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	((GearyImapClientSessionCommandCallbackClass *) klass)->finalize = geary_imap_client_session_command_callback_finalize;
#line 12075 "imap-client-session.c"
}

static void
geary_imap_client_session_command_callback_instance_init (GearyImapClientSessionCommandCallback * self,
                                                          gpointer klass)
{
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	self->ref_count = 1;
#line 12084 "imap-client-session.c"
}

static void
geary_imap_client_session_command_callback_finalize (GearyImapClientSessionCommandCallback * obj)
{
	GearyImapClientSessionCommandCallback * self;
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_IMAP_CLIENT_SESSION_TYPE_COMMAND_CALLBACK, GearyImapClientSessionCommandCallback);
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	g_signal_handlers_destroy (self);
#line 12095 "imap-client-session.c"
}

 G_GNUC_NO_INLINE static GType
geary_imap_client_session_command_callback_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { geary_imap_client_session_value_command_callback_init, geary_imap_client_session_value_command_callback_free_value, geary_imap_client_session_value_command_callback_copy_value, geary_imap_client_session_value_command_callback_peek_pointer, "p", geary_imap_client_session_value_command_callback_collect_value, "p", geary_imap_client_session_value_command_callback_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GearyImapClientSessionCommandCallbackClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_imap_client_session_command_callback_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyImapClientSessionCommandCallback), 0, (GInstanceInitFunc) geary_imap_client_session_command_callback_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType geary_imap_client_session_command_callback_type_id;
	geary_imap_client_session_command_callback_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GearyImapClientSessionCommandCallback", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return geary_imap_client_session_command_callback_type_id;
}

static GType
geary_imap_client_session_command_callback_get_type (void)
{
	static gsize geary_imap_client_session_command_callback_type_id__once = 0;
	if (g_once_init_enter (&geary_imap_client_session_command_callback_type_id__once)) {
		GType geary_imap_client_session_command_callback_type_id;
		geary_imap_client_session_command_callback_type_id = geary_imap_client_session_command_callback_get_type_once ();
		g_once_init_leave (&geary_imap_client_session_command_callback_type_id__once, geary_imap_client_session_command_callback_type_id);
	}
	return geary_imap_client_session_command_callback_type_id__once;
}

static gpointer
geary_imap_client_session_command_callback_ref (gpointer instance)
{
	GearyImapClientSessionCommandCallback * self;
	self = instance;
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	g_atomic_int_inc (&self->ref_count);
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	return instance;
#line 12130 "imap-client-session.c"
}

static void
geary_imap_client_session_command_callback_unref (gpointer instance)
{
	GearyImapClientSessionCommandCallback * self;
	self = instance;
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
		GEARY_IMAP_CLIENT_SESSION_COMMAND_CALLBACK_GET_CLASS (self)->finalize (self);
#line 142 "../src/engine/imap/transport/imap-client-session.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 12144 "imap-client-session.c"
	}
}

static GearyImapClientSessionSendCommandOperation*
geary_imap_client_session_send_command_operation_construct (GType object_type,
                                                            GearyImapClientSession* owner,
                                                            GearyImapCommand* cmd)
{
	GearyImapClientSessionSendCommandOperation * self = NULL;
	GearyImapClientSession* _tmp0_;
	GearyImapCommand* _tmp1_;
#line 158 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_CLIENT_SESSION (owner), NULL);
#line 158 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_COMMAND (cmd), NULL);
#line 158 "../src/engine/imap/transport/imap-client-session.vala"
	self = (GearyImapClientSessionSendCommandOperation*) geary_nonblocking_batch_operation_construct (object_type);
#line 159 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (owner);
#line 159 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->owner);
#line 159 "../src/engine/imap/transport/imap-client-session.vala"
	self->owner = _tmp0_;
#line 160 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = _g_object_ref0 (cmd);
#line 160 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->cmd);
#line 160 "../src/engine/imap/transport/imap-client-session.vala"
	self->cmd = _tmp1_;
#line 158 "../src/engine/imap/transport/imap-client-session.vala"
	return self;
#line 12176 "imap-client-session.c"
}

static GearyImapClientSessionSendCommandOperation*
geary_imap_client_session_send_command_operation_new (GearyImapClientSession* owner,
                                                      GearyImapCommand* cmd)
{
#line 158 "../src/engine/imap/transport/imap-client-session.vala"
	return geary_imap_client_session_send_command_operation_construct (GEARY_IMAP_CLIENT_SESSION_TYPE_SEND_COMMAND_OPERATION, owner, cmd);
#line 12185 "imap-client-session.c"
}

static void
geary_imap_client_session_send_command_operation_real_execute_async_data_free (gpointer _data)
{
	GearyImapClientSessionSendCommandOperationExecuteAsyncData* _data_;
	_data_ = _data;
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cancellable);
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->result);
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->self);
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	g_slice_free (GearyImapClientSessionSendCommandOperationExecuteAsyncData, _data_);
#line 12201 "imap-client-session.c"
}

static void
geary_imap_client_session_send_command_operation_real_execute_async (GearyNonblockingBatchOperation* base,
                                                                     GCancellable* cancellable,
                                                                     GAsyncReadyCallback _callback_,
                                                                     gpointer _user_data_)
{
	GearyImapClientSessionSendCommandOperation * self;
	GearyImapClientSessionSendCommandOperationExecuteAsyncData* _data_;
	GearyImapClientSessionSendCommandOperation* _tmp0_;
	GCancellable* _tmp1_;
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_IMAP_CLIENT_SESSION_TYPE_SEND_COMMAND_OPERATION, GearyImapClientSessionSendCommandOperation);
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_slice_new0 (GearyImapClientSessionSendCommandOperationExecuteAsyncData);
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_client_session_send_command_operation_real_execute_async_data_free);
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->self = _tmp0_;
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->cancellable);
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->cancellable = _tmp1_;
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_send_command_operation_real_execute_async_co (_data_);
#line 12236 "imap-client-session.c"
}

static GObject*
geary_imap_client_session_send_command_operation_execute_finish (GearyNonblockingBatchOperation* base,
                                                                 GAsyncResult* _res_,
                                                                 GError** error)
{
	GObject* result;
	GearyImapClientSessionSendCommandOperationExecuteAsyncData* _data_;
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	if (NULL == _data_) {
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
		return NULL;
#line 12252 "imap-client-session.c"
	}
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	result = _data_->result;
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->result = NULL;
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	return result;
#line 12260 "imap-client-session.c"
}

static void
geary_imap_client_session_send_command_operation_execute_async_ready (GObject* source_object,
                                                                      GAsyncResult* _res_,
                                                                      gpointer _user_data_)
{
	GearyImapClientSessionSendCommandOperationExecuteAsyncData* _data_;
#line 168 "../src/engine/imap/transport/imap-client-session.vala"
	_data_ = _user_data_;
#line 168 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_source_object_ = source_object;
#line 168 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_res_ = _res_;
#line 168 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_send_command_operation_real_execute_async_co (_data_);
#line 12277 "imap-client-session.c"
}

static gboolean
geary_imap_client_session_send_command_operation_real_execute_async_co (GearyImapClientSessionSendCommandOperationExecuteAsyncData* _data_)
{
#line 163 "../src/engine/imap/transport/imap-client-session.vala"
	switch (_data_->_state_) {
#line 163 "../src/engine/imap/transport/imap-client-session.vala"
		case 0:
#line 12287 "imap-client-session.c"
		goto _state_0;
#line 163 "../src/engine/imap/transport/imap-client-session.vala"
		case 1:
#line 12291 "imap-client-session.c"
		goto _state_1;
		default:
#line 163 "../src/engine/imap/transport/imap-client-session.vala"
		g_assert_not_reached ();
#line 12296 "imap-client-session.c"
	}
	_state_0:
#line 168 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp1_ = _data_->self->owner;
#line 168 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp2_ = _data_->self->cmd;
#line 168 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_state_ = 1;
#line 168 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_submit_command (_data_->_tmp1_, _data_->_tmp2_, geary_imap_client_session_send_command_operation_execute_async_ready, _data_);
#line 168 "../src/engine/imap/transport/imap-client-session.vala"
	return FALSE;
#line 12309 "imap-client-session.c"
	_state_1:
#line 168 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp3_ = geary_imap_client_session_submit_command_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error0_);
#line 168 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp0_ = _data_->_tmp3_;
#line 168 "../src/engine/imap/transport/imap-client-session.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 168 "../src/engine/imap/transport/imap-client-session.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 168 "../src/engine/imap/transport/imap-client-session.vala"
		g_object_unref (_data_->_async_result);
#line 168 "../src/engine/imap/transport/imap-client-session.vala"
		return FALSE;
#line 12323 "imap-client-session.c"
	}
#line 168 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp4_ = _data_->_tmp0_;
#line 168 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp0_ = NULL;
#line 168 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->self->response);
#line 168 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->self->response = _data_->_tmp4_;
#line 169 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp5_ = _data_->self->response;
#line 169 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp5_, G_TYPE_OBJECT, GObject));
#line 169 "../src/engine/imap/transport/imap-client-session.vala"
	_data_->result = _data_->_tmp6_;
#line 169 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (_data_->_tmp0_);
#line 169 "../src/engine/imap/transport/imap-client-session.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 169 "../src/engine/imap/transport/imap-client-session.vala"
	if (_data_->_state_ != 0) {
#line 169 "../src/engine/imap/transport/imap-client-session.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 169 "../src/engine/imap/transport/imap-client-session.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 12349 "imap-client-session.c"
		}
	}
#line 169 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_unref (_data_->_async_result);
#line 169 "../src/engine/imap/transport/imap-client-session.vala"
	return FALSE;
#line 12356 "imap-client-session.c"
}

static void
geary_imap_client_session_send_command_operation_class_init (GearyImapClientSessionSendCommandOperationClass * klass,
                                                             gpointer klass_data)
{
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_send_command_operation_parent_class = g_type_class_peek_parent (klass);
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	((GearyNonblockingBatchOperationClass *) klass)->execute_async = (void (*) (GearyNonblockingBatchOperation*, GCancellable*, GAsyncReadyCallback, gpointer)) geary_imap_client_session_send_command_operation_real_execute_async;
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	((GearyNonblockingBatchOperationClass *) klass)->execute_finish = (GObject* (*) (GearyNonblockingBatchOperation*, GAsyncResult*, GError**)) geary_imap_client_session_send_command_operation_execute_finish;
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_imap_client_session_send_command_operation_finalize;
#line 12371 "imap-client-session.c"
}

static void
geary_imap_client_session_send_command_operation_instance_init (GearyImapClientSessionSendCommandOperation * self,
                                                                gpointer klass)
{
}

static void
geary_imap_client_session_send_command_operation_finalize (GObject * obj)
{
	GearyImapClientSessionSendCommandOperation * self;
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_IMAP_CLIENT_SESSION_TYPE_SEND_COMMAND_OPERATION, GearyImapClientSessionSendCommandOperation);
#line 152 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->owner);
#line 153 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->cmd);
#line 156 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->response);
#line 150 "../src/engine/imap/transport/imap-client-session.vala"
	G_OBJECT_CLASS (geary_imap_client_session_send_command_operation_parent_class)->finalize (obj);
#line 12394 "imap-client-session.c"
}

 G_GNUC_NO_INLINE static GType
geary_imap_client_session_send_command_operation_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyImapClientSessionSendCommandOperationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_imap_client_session_send_command_operation_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyImapClientSessionSendCommandOperation), 0, (GInstanceInitFunc) geary_imap_client_session_send_command_operation_instance_init, NULL };
	GType geary_imap_client_session_send_command_operation_type_id;
	geary_imap_client_session_send_command_operation_type_id = g_type_register_static (GEARY_NONBLOCKING_TYPE_BATCH_OPERATION, "GearyImapClientSessionSendCommandOperation", &g_define_type_info, 0);
	return geary_imap_client_session_send_command_operation_type_id;
}

static GType
geary_imap_client_session_send_command_operation_get_type (void)
{
	static gsize geary_imap_client_session_send_command_operation_type_id__once = 0;
	if (g_once_init_enter (&geary_imap_client_session_send_command_operation_type_id__once)) {
		GType geary_imap_client_session_send_command_operation_type_id;
		geary_imap_client_session_send_command_operation_type_id = geary_imap_client_session_send_command_operation_get_type_once ();
		g_once_init_leave (&geary_imap_client_session_send_command_operation_type_id__once, geary_imap_client_session_send_command_operation_type_id);
	}
	return geary_imap_client_session_send_command_operation_type_id__once;
}

static void
geary_imap_client_session_class_init (GearyImapClientSessionClass * klass,
                                      gpointer klass_data)
{
	GearyStateMachineDescriptor* _tmp0_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_type_class_adjust_private_offset (klass, &GearyImapClientSession_private_offset);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_imap_client_session_get_property;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_imap_client_session_set_property;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_imap_client_session_finalize;
#line 12433 "imap-client-session.c"
	/**
	     * Returns the current IMAP protocol state for the session.
	     */
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_PROPERTY, geary_imap_client_session_properties[GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_PROPERTY] = g_param_spec_enum ("protocol-state", "protocol-state", "protocol-state", GEARY_IMAP_CLIENT_SESSION_TYPE_PROTOCOL_STATE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12439 "imap-client-session.c"
	/** Specifies the reason the session was disconnected, if any. */
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_CLIENT_SESSION_DISCONNECTED_PROPERTY, geary_imap_client_session_properties[GEARY_IMAP_CLIENT_SESSION_DISCONNECTED_PROPERTY] = g_param_spec_enum ("disconnected", "disconnected", "disconnected", GEARY_IMAP_CLIENT_SESSION_TYPE_DISCONNECT_REASON, GEARY_IMAP_CLIENT_SESSION_DISCONNECT_REASON_NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12443 "imap-client-session.c"
	/**
	     * Set of IMAP extensions reported as being supported by the server.
	     *
	     * The capabilities that an IMAP session offers changes over time,
	     * for example after login or STARTTLS. The instance assigned to
	     * this property will change as these change and the instance's
	     * {@link Capabilities.revision} property will also monotonically
	     * increase over the lifetime of a single session.
	     */
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_CLIENT_SESSION_CAPABILITIES_PROPERTY, geary_imap_client_session_properties[GEARY_IMAP_CLIENT_SESSION_CAPABILITIES_PROPERTY] = g_param_spec_object ("capabilities", "capabilities", "capabilities", GEARY_IMAP_TYPE_CAPABILITIES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12455 "imap-client-session.c"
	/** Determines if this session supports the IMAP IDLE extension. */
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_CLIENT_SESSION_IS_IDLE_SUPPORTED_PROPERTY, geary_imap_client_session_properties[GEARY_IMAP_CLIENT_SESSION_IS_IDLE_SUPPORTED_PROPERTY] = g_param_spec_boolean ("is-idle-supported", "is-idle-supported", "is-idle-supported", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12459 "imap-client-session.c"
	/**
	     * The server's greeting, if any.
	     *
	     * This will be null up until the session has successfully
	     * connected and the server has responded with a greeting.
	     */
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_CLIENT_SESSION_SERVER_GREETING_PROPERTY, geary_imap_client_session_properties[GEARY_IMAP_CLIENT_SESSION_SERVER_GREETING_PROPERTY] = g_param_spec_object ("server-greeting", "server-greeting", "server-greeting", GEARY_IMAP_TYPE_STATUS_RESPONSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12468 "imap-client-session.c"
	/** {@inheritDoc} */
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_CLIENT_SESSION_LOGGING_PARENT_PROPERTY, geary_imap_client_session_properties[GEARY_IMAP_CLIENT_SESSION_LOGGING_PARENT_PROPERTY] = g_param_spec_object ("logging-parent", "logging-parent", "logging-parent", GEARY_LOGGING_TYPE_SOURCE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12472 "imap-client-session.c"
	/**
	     * Determines when the last successful command response was received.
	     *
	     * Returns the system wall clock time the last successful command
	     * response was received, in microseconds since the UNIX epoch.
	     */
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_CLIENT_SESSION_LAST_SEEN_PROPERTY, geary_imap_client_session_properties[GEARY_IMAP_CLIENT_SESSION_LAST_SEEN_PROPERTY] = g_param_spec_int64 ("last-seen", "last-seen", "last-seen", G_MININT64, G_MAXINT64, (gint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12481 "imap-client-session.c"
	/** Records the actual name and delimiter used for the inbox */
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_CLIENT_SESSION_INBOX_PROPERTY, geary_imap_client_session_properties[GEARY_IMAP_CLIENT_SESSION_INBOX_PROPERTY] = g_param_spec_object ("inbox", "inbox", "inbox", GEARY_IMAP_TYPE_MAILBOX_INFORMATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12485 "imap-client-session.c"
	/** The quirks being used by this session. */
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_CLIENT_SESSION_QUIRKS_PROPERTY, geary_imap_client_session_properties[GEARY_IMAP_CLIENT_SESSION_QUIRKS_PROPERTY] = g_param_spec_object ("quirks", "quirks", "quirks", GEARY_IMAP_TYPE_QUIRKS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 12489 "imap-client-session.c"
	/** Emitted when an IMAP command status response is received. */
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_signals[GEARY_IMAP_CLIENT_SESSION_STATUS_RESPONSE_RECEIVED_SIGNAL] = g_signal_new ("status-response-received", GEARY_IMAP_TYPE_CLIENT_SESSION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_IMAP_TYPE_STATUS_RESPONSE);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_signals[GEARY_IMAP_CLIENT_SESSION_EXISTS_SIGNAL] = g_signal_new ("exists", GEARY_IMAP_TYPE_CLIENT_SESSION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_signals[GEARY_IMAP_CLIENT_SESSION_EXPUNGE_SIGNAL] = g_signal_new ("expunge", GEARY_IMAP_TYPE_CLIENT_SESSION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_IMAP_TYPE_SEQUENCE_NUMBER);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_signals[GEARY_IMAP_CLIENT_SESSION_FETCH_SIGNAL] = g_signal_new ("fetch", GEARY_IMAP_TYPE_CLIENT_SESSION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_IMAP_TYPE_FETCHED_DATA);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_signals[GEARY_IMAP_CLIENT_SESSION_FLAGS_SIGNAL] = g_signal_new ("flags", GEARY_IMAP_TYPE_CLIENT_SESSION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_IMAP_TYPE_MAILBOX_ATTRIBUTES);
#line 12501 "imap-client-session.c"
	/**
	     * Fired when a LIST or XLIST {@link ServerData} is returned from the server.
	     */
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_signals[GEARY_IMAP_CLIENT_SESSION_LIST_SIGNAL] = g_signal_new ("list", GEARY_IMAP_TYPE_CLIENT_SESSION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_IMAP_TYPE_MAILBOX_INFORMATION);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_signals[GEARY_IMAP_CLIENT_SESSION_RECENT_SIGNAL] = g_signal_new ("recent", GEARY_IMAP_TYPE_CLIENT_SESSION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_signals[GEARY_IMAP_CLIENT_SESSION_SEARCH_SIGNAL] = g_signal_new ("search", GEARY_IMAP_TYPE_CLIENT_SESSION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__POINTER_INT, G_TYPE_NONE, 2, G_TYPE_POINTER, G_TYPE_INT);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_signals[GEARY_IMAP_CLIENT_SESSION_STATUS_SIGNAL] = g_signal_new ("status", GEARY_IMAP_TYPE_CLIENT_SESSION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_IMAP_TYPE_STATUS_DATA);
#line 230 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = geary_state_machine_descriptor_new ("Geary.Imap.ClientSession", (guint) GEARY_IMAP_CLIENT_SESSION_STATE_NOT_CONNECTED, (guint) GEARY_IMAP_CLIENT_SESSION_STATE_COUNT, (guint) GEARY_IMAP_CLIENT_SESSION_EVENT_COUNT, _geary_imap_client_session_state_to_string_geary_state_state_event_to_string, NULL, _geary_imap_client_session_event_to_string_geary_state_state_event_to_string, NULL);
#line 230 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_machine_desc = _tmp0_;
#line 12517 "imap-client-session.c"
}

static void
geary_imap_client_session_geary_logging_source_interface_init (GearyLoggingSourceIface * iface,
                                                               gpointer iface_data)
{
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	geary_imap_client_session_geary_logging_source_parent_iface = g_type_interface_peek_parent (iface);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	iface->to_string = (gchar* (*) (GearyLoggingSource*)) geary_imap_client_session_real_to_string;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	iface->to_logging_state = (GearyLoggingState* (*) (GearyLoggingSource*)) geary_imap_client_session_real_to_logging_state;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	iface->get_logging_domain = geary_imap_client_session_real_get_logging_domain;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	iface->get_logging_parent = geary_imap_client_session_real_get_logging_parent;
#line 12534 "imap-client-session.c"
}

static void
geary_imap_client_session_instance_init (GearyImapClientSession * self,
                                         gpointer klass)
{
	GearyImapCapabilities* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeHashMap* _tmp4_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv = geary_imap_client_session_get_instance_private (self);
#line 281 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->_disconnected = GEARY_IMAP_CLIENT_SESSION_DISCONNECT_REASON_NULL;
#line 292 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = geary_imap_capabilities_new_empty (0);
#line 292 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->_capabilities = _tmp0_;
#line 307 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->_server_greeting = NULL;
#line 310 "../src/engine/imap/transport/imap-client-session.vala"
	self->selected_mailbox = NULL;
#line 320 "../src/engine/imap/transport/imap-client-session.vala"
	self->selected_readonly = FALSE;
#line 329 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->_logging_parent = NULL;
#line 337 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->_last_seen = (gint64) 0;
#line 348 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->_inbox = NULL;
#line 354 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = gee_array_list_new (GEARY_IMAP_TYPE_NAMESPACE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 354 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->personal_namespaces = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_LIST, GeeList);
#line 357 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = gee_array_list_new (GEARY_IMAP_TYPE_NAMESPACE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 357 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->user_namespaces = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_LIST, GeeList);
#line 360 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp3_ = gee_array_list_new (GEARY_IMAP_TYPE_NAMESPACE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 360 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->shared_namespaces = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_LIST, GeeList);
#line 364 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->cx = NULL;
#line 366 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->keepalive_id = (guint) 0;
#line 367 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->selected_keepalive_secs = (guint) 0;
#line 368 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->unselected_keepalive_secs = (guint) 0;
#line 369 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->selected_with_idle_keepalive_secs = (guint) 0;
#line 371 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->state_change_cmd = NULL;
#line 372 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->connect_waiter = NULL;
#line 373 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->connect_err = NULL;
#line 375 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEARY_IMAP_TYPE_NAMESPACE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 375 "../src/engine/imap/transport/imap-client-session.vala"
	self->priv->namespaces = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_MAP, GeeMap);
#line 12598 "imap-client-session.c"
}

static void
geary_imap_client_session_finalize (GObject * obj)
{
	GearyImapClientSession * self;
	GearyStateMachine* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_IMAP_TYPE_CLIENT_SESSION, GearyImapClientSession);
#line 543 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp0_ = self->priv->fsm;
#line 543 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp1_ = geary_state_machine_get_state (_tmp0_);
#line 543 "../src/engine/imap/transport/imap-client-session.vala"
	_tmp2_ = _tmp1_;
#line 543 "../src/engine/imap/transport/imap-client-session.vala"
	switch (_tmp2_) {
#line 543 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_STATE_NOT_CONNECTED:
#line 543 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_STATE_CLOSED:
#line 12622 "imap-client-session.c"
		{
#line 547 "../src/engine/imap/transport/imap-client-session.vala"
			break;
#line 12626 "imap-client-session.c"
		}
		default:
		{
#line 550 "../src/engine/imap/transport/imap-client-session.vala"
			g_warning ("imap-client-session.vala:550: ClientSession ref dropped while still ac" \
"tive");
#line 12632 "imap-client-session.c"
		}
	}
#line 292 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->priv->_capabilities);
#line 307 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->priv->_server_greeting);
#line 310 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->selected_mailbox);
#line 348 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->priv->_inbox);
#line 351 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->priv->_quirks);
#line 354 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->priv->personal_namespaces);
#line 357 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->priv->user_namespaces);
#line 360 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->priv->shared_namespaces);
#line 362 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->priv->imap_endpoint);
#line 363 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->priv->fsm);
#line 364 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->priv->cx);
#line 371 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->priv->state_change_cmd);
#line 372 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->priv->connect_waiter);
#line 373 "../src/engine/imap/transport/imap-client-session.vala"
	_g_error_free0 (self->priv->connect_err);
#line 375 "../src/engine/imap/transport/imap-client-session.vala"
	_g_object_unref0 (self->priv->namespaces);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	G_OBJECT_CLASS (geary_imap_client_session_parent_class)->finalize (obj);
#line 12667 "imap-client-session.c"
}

/**
 * High-level interface to a single IMAP server connection.
 *
 * The client session is responsible for opening, maintaining and
 * closing a TCP connection to an IMAP server. When opening, the
 * session will obtain and maintain capabilities, establish a StartTLS
 * session if appropriate, authenticate, and obtain
 * connection-specific information about the server such as the name
 * used for the INBOX and any mailbox namespaces. When connecting has
 * completed successfully, the connection will be in the IMAP
 * authenticated state.
 *
 * Any IMAP commands that affect the IMAP connection's state (LOGIN,
 * LOGOUT, SELECT, etc) must be executed by calling the appropriate
 * method on this object. For example, call `login_async` rather than
 * sending a {@link LoginCommand}. Other commands can be sent via
 * {@link send_command_async} and {@link send_multiple_commands_async}.
 */
 G_GNUC_NO_INLINE static GType
geary_imap_client_session_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyImapClientSessionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_imap_client_session_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyImapClientSession), 0, (GInstanceInitFunc) geary_imap_client_session_instance_init, NULL };
	static const GInterfaceInfo geary_logging_source_info = { (GInterfaceInitFunc) geary_imap_client_session_geary_logging_source_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType geary_imap_client_session_type_id;
	geary_imap_client_session_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyImapClientSession", &g_define_type_info, 0);
	g_type_add_interface_static (geary_imap_client_session_type_id, GEARY_LOGGING_TYPE_SOURCE, &geary_logging_source_info);
	GearyImapClientSession_private_offset = g_type_add_instance_private (geary_imap_client_session_type_id, sizeof (GearyImapClientSessionPrivate));
	return geary_imap_client_session_type_id;
}

GType
geary_imap_client_session_get_type (void)
{
	static gsize geary_imap_client_session_type_id__once = 0;
	if (g_once_init_enter (&geary_imap_client_session_type_id__once)) {
		GType geary_imap_client_session_type_id;
		geary_imap_client_session_type_id = geary_imap_client_session_get_type_once ();
		g_once_init_leave (&geary_imap_client_session_type_id__once, geary_imap_client_session_type_id);
	}
	return geary_imap_client_session_type_id__once;
}

static void
_vala_geary_imap_client_session_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	GearyImapClientSession * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_TYPE_CLIENT_SESSION, GearyImapClientSession);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	switch (property_id) {
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_PROTOCOL_STATE_PROPERTY:
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		g_value_set_enum (value, geary_imap_client_session_get_protocol_state (self));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		break;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_DISCONNECTED_PROPERTY:
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		g_value_set_enum (value, geary_imap_client_session_get_disconnected (self));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		break;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_CAPABILITIES_PROPERTY:
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		g_value_set_object (value, geary_imap_client_session_get_capabilities (self));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		break;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_IS_IDLE_SUPPORTED_PROPERTY:
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		g_value_set_boolean (value, geary_imap_client_session_get_is_idle_supported (self));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		break;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_SERVER_GREETING_PROPERTY:
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		g_value_set_object (value, geary_imap_client_session_get_server_greeting (self));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		break;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_LOGGING_PARENT_PROPERTY:
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		g_value_set_object (value, geary_logging_source_get_logging_parent (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource)));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		break;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_LAST_SEEN_PROPERTY:
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		g_value_set_int64 (value, geary_imap_client_session_get_last_seen (self));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		break;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_INBOX_PROPERTY:
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		g_value_set_object (value, geary_imap_client_session_get_inbox (self));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		break;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_QUIRKS_PROPERTY:
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		g_value_set_object (value, geary_imap_client_session_get_quirks (self));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		break;
#line 12776 "imap-client-session.c"
		default:
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		break;
#line 12782 "imap-client-session.c"
	}
}

static void
_vala_geary_imap_client_session_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	GearyImapClientSession * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_TYPE_CLIENT_SESSION, GearyImapClientSession);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
	switch (property_id) {
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_DISCONNECTED_PROPERTY:
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_session_set_disconnected (self, g_value_get_enum (value));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		break;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_CAPABILITIES_PROPERTY:
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_session_set_capabilities (self, g_value_get_object (value));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		break;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_SERVER_GREETING_PROPERTY:
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_session_set_server_greeting (self, g_value_get_object (value));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		break;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_LAST_SEEN_PROPERTY:
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_session_set_last_seen (self, g_value_get_int64 (value));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		break;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_INBOX_PROPERTY:
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_session_set_inbox (self, g_value_get_object (value));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		break;
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		case GEARY_IMAP_CLIENT_SESSION_QUIRKS_PROPERTY:
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		geary_imap_client_session_set_quirks (self, g_value_get_object (value));
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		break;
#line 12832 "imap-client-session.c"
		default:
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/engine/imap/transport/imap-client-session.vala"
		break;
#line 12838 "imap-client-session.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

