/* imap-deserializer.c generated by valac 0.56.17, the Vala compiler
 * generated from imap-deserializer.vala, do not modify */

/*
 * Copyright © 2016 Software Freedom Conservancy Inc.
 * Copyright © 2019-2020 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>

#define GEARY_IMAP_DESERIALIZER_MAX_BLOCK_READ_SIZE ((gsize) 4096)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_IMAP_DESERIALIZER_0_PROPERTY,
	GEARY_IMAP_DESERIALIZER_LOGGING_PARENT_PROPERTY,
	GEARY_IMAP_DESERIALIZER_QUIRKS_PROPERTY,
	GEARY_IMAP_DESERIALIZER_NUM_PROPERTIES
};
static GParamSpec* geary_imap_deserializer_properties[GEARY_IMAP_DESERIALIZER_NUM_PROPERTIES];
typedef enum  {
	GEARY_IMAP_DESERIALIZER_MODE_LINE,
	GEARY_IMAP_DESERIALIZER_MODE_BLOCK,
	GEARY_IMAP_DESERIALIZER_MODE_FAILED,
	GEARY_IMAP_DESERIALIZER_MODE_CLOSED
} GearyImapDeserializerMode;

#define GEARY_IMAP_DESERIALIZER_TYPE_MODE (geary_imap_deserializer_mode_get_type ())
typedef enum  {
	GEARY_IMAP_DESERIALIZER_STATE_TAG,
	GEARY_IMAP_DESERIALIZER_STATE_START_PARAM,
	GEARY_IMAP_DESERIALIZER_STATE_ATOM,
	GEARY_IMAP_DESERIALIZER_STATE_FLAG,
	GEARY_IMAP_DESERIALIZER_STATE_QUOTED,
	GEARY_IMAP_DESERIALIZER_STATE_QUOTED_ESCAPE,
	GEARY_IMAP_DESERIALIZER_STATE_PARTIAL_BODY_ATOM,
	GEARY_IMAP_DESERIALIZER_STATE_PARTIAL_BODY_ATOM_TERMINATING,
	GEARY_IMAP_DESERIALIZER_STATE_LITERAL,
	GEARY_IMAP_DESERIALIZER_STATE_LITERAL_DATA_BEGIN,
	GEARY_IMAP_DESERIALIZER_STATE_LITERAL_DATA,
	GEARY_IMAP_DESERIALIZER_STATE_RESPONSE_TEXT,
	GEARY_IMAP_DESERIALIZER_STATE_FAILED,
	GEARY_IMAP_DESERIALIZER_STATE_CLOSED,
	GEARY_IMAP_DESERIALIZER_STATE_COUNT
} GearyImapDeserializerState;

#define GEARY_IMAP_DESERIALIZER_TYPE_STATE (geary_imap_deserializer_state_get_type ())
typedef enum  {
	GEARY_IMAP_DESERIALIZER_EVENT_CHAR,
	GEARY_IMAP_DESERIALIZER_EVENT_EOL,
	GEARY_IMAP_DESERIALIZER_EVENT_DATA,
	GEARY_IMAP_DESERIALIZER_EVENT_EOS,
	GEARY_IMAP_DESERIALIZER_EVENT_ERROR,
	GEARY_IMAP_DESERIALIZER_EVENT_COUNT
} GearyImapDeserializerEvent;

#define GEARY_IMAP_DESERIALIZER_TYPE_EVENT (geary_imap_deserializer_event_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _GearyImapDeserializerStartAsyncData GearyImapDeserializerStartAsyncData;
typedef struct _GearyImapDeserializerStopAsyncData GearyImapDeserializerStopAsyncData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	GEARY_IMAP_DESERIALIZER_PARAMETERS_READY_SIGNAL,
	GEARY_IMAP_DESERIALIZER_BYTES_RECEIVED_SIGNAL,
	GEARY_IMAP_DESERIALIZER_DESERIALIZE_FAILURE_SIGNAL,
	GEARY_IMAP_DESERIALIZER_RECEIVE_FAILURE_SIGNAL,
	GEARY_IMAP_DESERIALIZER_END_OF_STREAM_SIGNAL,
	GEARY_IMAP_DESERIALIZER_NUM_SIGNALS
};
static guint geary_imap_deserializer_signals[GEARY_IMAP_DESERIALIZER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GearyImapDeserializerPrivate {
	GearyLoggingSource* _logging_parent;
	GearyImapQuirks* _quirks;
	gchar* identifier;
	GDataInputStream* input;
	GearyStateMachine* fsm;
	GearyImapListParameter* context;
	GeeLinkedList* context_stack;
	GCancellable* cancellable;
	GearyNonblockingSemaphore* closed_semaphore;
	GString* current_string;
	gsize literal_length_remaining;
	GearyMemoryGrowableBuffer* block_buffer;
	guint8* current_buffer;
	gint current_buffer_length1;
	gint _current_buffer_size_;
	gint ins_priority;
	gboolean is_parsing_flags;
};

struct _GearyImapDeserializerStartAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapDeserializer* self;
	gint priority;
	GCancellable* _tmp0_;
	GError* _tmp1_;
	GearyImapDeserializerMode mode;
	GError* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GCancellable* _tmp5_;
	GCancellable* _tmp6_;
	GError* _tmp7_;
	GCancellable* _tmp8_;
	GError* _inner_error0_;
};

struct _GearyImapDeserializerStopAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyImapDeserializer* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GCancellable* _tmp2_;
	GCancellable* _tmp3_;
	GCancellable* _tmp4_;
	GearyNonblockingSemaphore* _tmp5_;
	GDataInputStream* _tmp6_;
	GError* _inner_error0_;
};

static gint GearyImapDeserializer_private_offset;
static gpointer geary_imap_deserializer_parent_class = NULL;
static GearyStateMachineDescriptor* geary_imap_deserializer_machine_desc;
static GearyStateMachineDescriptor* geary_imap_deserializer_machine_desc = NULL;
static GearyLoggingSourceIface * geary_imap_deserializer_geary_logging_source_parent_iface = NULL;

static GType geary_imap_deserializer_mode_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GType geary_imap_deserializer_state_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GType geary_imap_deserializer_event_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static gchar* geary_imap_deserializer_state_to_string (guint state);
static gchar* geary_imap_deserializer_event_to_string (guint event);
static gchar* _geary_imap_deserializer_state_to_string_geary_state_state_event_to_string (guint state_or_event,
                                                                                   gpointer self);
static gchar* _geary_imap_deserializer_event_to_string_geary_state_state_event_to_string (guint state_or_event,
                                                                                   gpointer self);
VALA_EXTERN GearyImapQuirks* geary_imap_deserializer_get_quirks (GearyImapDeserializer* self);
VALA_EXTERN void geary_imap_deserializer_set_quirks (GearyImapDeserializer* self,
                                         GearyImapQuirks* value);
static guint geary_imap_deserializer_on_tag_char (GearyImapDeserializer* self,
                                           guint state,
                                           guint event,
                                           void* user);
static guint _geary_imap_deserializer_on_tag_char_geary_state_transition (guint state,
                                                                   guint event,
                                                                   void* user,
                                                                   GObject* object,
                                                                   GError* err,
                                                                   gpointer self);
static guint geary_imap_deserializer_on_eos (GearyImapDeserializer* self);
static guint _geary_imap_deserializer_on_eos_geary_state_transition (guint state,
                                                              guint event,
                                                              void* user,
                                                              GObject* object,
                                                              GError* err,
                                                              gpointer self);
static guint geary_imap_deserializer_on_error (GearyImapDeserializer* self,
                                        guint state,
                                        guint event,
                                        void* user,
                                        GObject* object,
                                        GError* err);
static guint _geary_imap_deserializer_on_error_geary_state_transition (guint state,
                                                                guint event,
                                                                void* user,
                                                                GObject* object,
                                                                GError* err,
                                                                gpointer self);
static guint geary_imap_deserializer_on_first_param_char (GearyImapDeserializer* self,
                                                   guint state,
                                                   guint event,
                                                   void* user);
static guint _geary_imap_deserializer_on_first_param_char_geary_state_transition (guint state,
                                                                           guint event,
                                                                           void* user,
                                                                           GObject* object,
                                                                           GError* err,
                                                                           gpointer self);
static guint geary_imap_deserializer_on_eol (GearyImapDeserializer* self,
                                      guint state,
                                      guint event,
                                      void* user);
static guint _geary_imap_deserializer_on_eol_geary_state_transition (guint state,
                                                              guint event,
                                                              void* user,
                                                              GObject* object,
                                                              GError* err,
                                                              gpointer self);
static guint geary_imap_deserializer_on_atom_char (GearyImapDeserializer* self,
                                            guint state,
                                            guint event,
                                            void* user);
static guint _geary_imap_deserializer_on_atom_char_geary_state_transition (guint state,
                                                                    guint event,
                                                                    void* user,
                                                                    GObject* object,
                                                                    GError* err,
                                                                    gpointer self);
static guint geary_imap_deserializer_on_param_eol (GearyImapDeserializer* self,
                                            guint state,
                                            guint event,
                                            void* user);
static guint _geary_imap_deserializer_on_param_eol_geary_state_transition (guint state,
                                                                    guint event,
                                                                    void* user,
                                                                    GObject* object,
                                                                    GError* err,
                                                                    gpointer self);
static guint geary_imap_deserializer_on_flag_char (GearyImapDeserializer* self,
                                            guint state,
                                            guint event,
                                            void* user);
static guint _geary_imap_deserializer_on_flag_char_geary_state_transition (guint state,
                                                                    guint event,
                                                                    void* user,
                                                                    GObject* object,
                                                                    GError* err,
                                                                    gpointer self);
static guint geary_imap_deserializer_on_quoted_char (GearyImapDeserializer* self,
                                              guint state,
                                              guint event,
                                              void* user);
static guint _geary_imap_deserializer_on_quoted_char_geary_state_transition (guint state,
                                                                      guint event,
                                                                      void* user,
                                                                      GObject* object,
                                                                      GError* err,
                                                                      gpointer self);
static guint geary_imap_deserializer_on_quoted_escape_char (GearyImapDeserializer* self,
                                                     guint state,
                                                     guint event,
                                                     void* user);
static guint _geary_imap_deserializer_on_quoted_escape_char_geary_state_transition (guint state,
                                                                             guint event,
                                                                             void* user,
                                                                             GObject* object,
                                                                             GError* err,
                                                                             gpointer self);
static guint geary_imap_deserializer_on_partial_body_atom_char (GearyImapDeserializer* self,
                                                         guint state,
                                                         guint event,
                                                         void* user);
static guint _geary_imap_deserializer_on_partial_body_atom_char_geary_state_transition (guint state,
                                                                                 guint event,
                                                                                 void* user,
                                                                                 GObject* object,
                                                                                 GError* err,
                                                                                 gpointer self);
static guint geary_imap_deserializer_on_partial_body_atom_terminating_char (GearyImapDeserializer* self,
                                                                     guint state,
                                                                     guint event,
                                                                     void* user);
static guint _geary_imap_deserializer_on_partial_body_atom_terminating_char_geary_state_transition (guint state,
                                                                                             guint event,
                                                                                             void* user,
                                                                                             GObject* object,
                                                                                             GError* err,
                                                                                             gpointer self);
static guint geary_imap_deserializer_on_literal_char (GearyImapDeserializer* self,
                                               guint state,
                                               guint event,
                                               void* user);
static guint _geary_imap_deserializer_on_literal_char_geary_state_transition (guint state,
                                                                       guint event,
                                                                       void* user,
                                                                       GObject* object,
                                                                       GError* err,
                                                                       gpointer self);
static guint geary_imap_deserializer_on_literal_data_begin_eol (GearyImapDeserializer* self,
                                                         guint state,
                                                         guint event,
                                                         void* user);
static guint _geary_imap_deserializer_on_literal_data_begin_eol_geary_state_transition (guint state,
                                                                                 guint event,
                                                                                 void* user,
                                                                                 GObject* object,
                                                                                 GError* err,
                                                                                 gpointer self);
static guint geary_imap_deserializer_on_literal_data (GearyImapDeserializer* self,
                                               guint state,
                                               guint event,
                                               void* user);
static guint _geary_imap_deserializer_on_literal_data_geary_state_transition (guint state,
                                                                       guint event,
                                                                       void* user,
                                                                       GObject* object,
                                                                       GError* err,
                                                                       gpointer self);
static guint geary_imap_deserializer_on_response_text_char (GearyImapDeserializer* self,
                                                     guint state,
                                                     guint event,
                                                     void* user);
static guint _geary_imap_deserializer_on_response_text_char_geary_state_transition (guint state,
                                                                             guint event,
                                                                             void* user,
                                                                             GObject* object,
                                                                             GError* err,
                                                                             gpointer self);
static guint geary_imap_deserializer_on_failed_eol (GearyImapDeserializer* self,
                                             guint state,
                                             guint event,
                                             void* user);
static guint _geary_imap_deserializer_on_failed_eol_geary_state_transition (guint state,
                                                                     guint event,
                                                                     void* user,
                                                                     GObject* object,
                                                                     GError* err,
                                                                     gpointer self);
static guint _geary_state_nop_geary_state_transition (guint state,
                                               guint event,
                                               void* user,
                                               GObject* object,
                                               GError* err,
                                               gpointer self);
static guint geary_imap_deserializer_on_bad_transition (GearyImapDeserializer* self,
                                                 guint state,
                                                 guint event,
                                                 void* user);
static guint _geary_imap_deserializer_on_bad_transition_geary_state_transition (guint state,
                                                                         guint event,
                                                                         void* user,
                                                                         GObject* object,
                                                                         GError* err,
                                                                         gpointer self);
static void geary_imap_deserializer_reset_params (GearyImapDeserializer* self);
static void geary_imap_deserializer_start_async_data_free (gpointer _data);
static gboolean geary_imap_deserializer_start_async_co (GearyImapDeserializerStartAsyncData* _data_);
static GearyImapDeserializerMode geary_imap_deserializer_get_mode (GearyImapDeserializer* self);
static void geary_imap_deserializer_next_deserialize_step (GearyImapDeserializer* self);
static void geary_imap_deserializer_stop_async_data_free (gpointer _data);
static gboolean geary_imap_deserializer_stop_async_co (GearyImapDeserializerStopAsyncData* _data_);
static void geary_imap_deserializer_stop_async_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static GearyLoggingState* geary_imap_deserializer_real_to_logging_state (GearyLoggingSource* base);
VALA_EXTERN void geary_imap_deserializer_set_logging_parent (GearyImapDeserializer* self,
                                                 GearyLoggingSource* parent);
static void geary_imap_deserializer_on_read_line (GearyImapDeserializer* self,
                                           GObject* source,
                                           GAsyncResult* _result_);
static void _geary_imap_deserializer_on_read_line_gasync_ready_callback (GObject* source_object,
                                                                  GAsyncResult* res,
                                                                  gpointer self);
static void geary_imap_deserializer_on_read_block (GearyImapDeserializer* self,
                                            GObject* source,
                                            GAsyncResult* _result_);
static void _geary_imap_deserializer_on_read_block_gasync_ready_callback (GObject* source_object,
                                                                   GAsyncResult* res,
                                                                   gpointer self);
static void geary_imap_deserializer_push_eos (GearyImapDeserializer* self);
static void geary_imap_deserializer_push_line (GearyImapDeserializer* self,
                                        const gchar* line,
                                        gsize count);
static void geary_imap_deserializer_push_error (GearyImapDeserializer* self,
                                         GError* err);
static void geary_imap_deserializer_push_data (GearyImapDeserializer* self,
                                        gsize bytes_read);
static inline gboolean geary_imap_deserializer_is_current_string_empty (GearyImapDeserializer* self);
static inline gboolean geary_imap_deserializer_is_current_string_ci (GearyImapDeserializer* self,
                                                       const gchar* cmp);
static inline void geary_imap_deserializer_append_to_string (GearyImapDeserializer* self,
                                               gchar ch);
static void geary_imap_deserializer_save_string_parameter (GearyImapDeserializer* self,
                                                    gboolean quoted);
static void geary_imap_deserializer_save_parameter (GearyImapDeserializer* self,
                                             GearyImapParameter* param);
static void geary_imap_deserializer_save_literal_parameter (GearyImapDeserializer* self);
static void geary_imap_deserializer_push (GearyImapDeserializer* self,
                                   GearyImapListParameter* child);
static gchar geary_imap_deserializer_get_current_context_terminator (GearyImapDeserializer* self);
static GearyImapDeserializerState geary_imap_deserializer_pop (GearyImapDeserializer* self);
static void geary_imap_deserializer_flush_params (GearyImapDeserializer* self);
static gboolean _vala_string_array_contains (const gchar* * stack,
                                      gssize stack_length,
                                      const const gchar* needle);
static void geary_imap_deserializer_finalize (GObject * obj);
static GType geary_imap_deserializer_get_type_once (void);
static void _vala_geary_imap_deserializer_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_geary_imap_deserializer_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const gchar* GEARY_IMAP_DESERIALIZER_RESPONSE_ATOMS[5] = {"OK", "NO", "BAD", "BYE", "PREAUTH"};

static inline gpointer
geary_imap_deserializer_get_instance_private (GearyImapDeserializer* self)
{
	return G_STRUCT_MEMBER_P (self, GearyImapDeserializer_private_offset);
}

 G_GNUC_NO_INLINE static GType
geary_imap_deserializer_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{GEARY_IMAP_DESERIALIZER_MODE_LINE, "GEARY_IMAP_DESERIALIZER_MODE_LINE", "line"}, {GEARY_IMAP_DESERIALIZER_MODE_BLOCK, "GEARY_IMAP_DESERIALIZER_MODE_BLOCK", "block"}, {GEARY_IMAP_DESERIALIZER_MODE_FAILED, "GEARY_IMAP_DESERIALIZER_MODE_FAILED", "failed"}, {GEARY_IMAP_DESERIALIZER_MODE_CLOSED, "GEARY_IMAP_DESERIALIZER_MODE_CLOSED", "closed"}, {0, NULL, NULL}};
	GType geary_imap_deserializer_mode_type_id;
	geary_imap_deserializer_mode_type_id = g_enum_register_static ("GearyImapDeserializerMode", values);
	return geary_imap_deserializer_mode_type_id;
}

static GType
geary_imap_deserializer_mode_get_type (void)
{
	static gsize geary_imap_deserializer_mode_type_id__once = 0;
	if (g_once_init_enter (&geary_imap_deserializer_mode_type_id__once)) {
		GType geary_imap_deserializer_mode_type_id;
		geary_imap_deserializer_mode_type_id = geary_imap_deserializer_mode_get_type_once ();
		g_once_init_leave (&geary_imap_deserializer_mode_type_id__once, geary_imap_deserializer_mode_type_id);
	}
	return geary_imap_deserializer_mode_type_id__once;
}

 G_GNUC_NO_INLINE static GType
geary_imap_deserializer_state_get_type_once (void)
{
	static const GEnumValue values[] = {{GEARY_IMAP_DESERIALIZER_STATE_TAG, "GEARY_IMAP_DESERIALIZER_STATE_TAG", "tag"}, {GEARY_IMAP_DESERIALIZER_STATE_START_PARAM, "GEARY_IMAP_DESERIALIZER_STATE_START_PARAM", "start-param"}, {GEARY_IMAP_DESERIALIZER_STATE_ATOM, "GEARY_IMAP_DESERIALIZER_STATE_ATOM", "atom"}, {GEARY_IMAP_DESERIALIZER_STATE_FLAG, "GEARY_IMAP_DESERIALIZER_STATE_FLAG", "flag"}, {GEARY_IMAP_DESERIALIZER_STATE_QUOTED, "GEARY_IMAP_DESERIALIZER_STATE_QUOTED", "quoted"}, {GEARY_IMAP_DESERIALIZER_STATE_QUOTED_ESCAPE, "GEARY_IMAP_DESERIALIZER_STATE_QUOTED_ESCAPE", "quoted-escape"}, {GEARY_IMAP_DESERIALIZER_STATE_PARTIAL_BODY_ATOM, "GEARY_IMAP_DESERIALIZER_STATE_PARTIAL_BODY_ATOM", "partial-body-atom"}, {GEARY_IMAP_DESERIALIZER_STATE_PARTIAL_BODY_ATOM_TERMINATING, "GEARY_IMAP_DESERIALIZER_STATE_PARTIAL_BODY_ATOM_TERMINATING", "partial-body-atom-terminating"}, {GEARY_IMAP_DESERIALIZER_STATE_LITERAL, "GEARY_IMAP_DESERIALIZER_STATE_LITERAL", "literal"}, {GEARY_IMAP_DESERIALIZER_STATE_LITERAL_DATA_BEGIN, "GEARY_IMAP_DESERIALIZER_STATE_LITERAL_DATA_BEGIN", "literal-data-begin"}, {GEARY_IMAP_DESERIALIZER_STATE_LITERAL_DATA, "GEARY_IMAP_DESERIALIZER_STATE_LITERAL_DATA", "literal-data"}, {GEARY_IMAP_DESERIALIZER_STATE_RESPONSE_TEXT, "GEARY_IMAP_DESERIALIZER_STATE_RESPONSE_TEXT", "response-text"}, {GEARY_IMAP_DESERIALIZER_STATE_FAILED, "GEARY_IMAP_DESERIALIZER_STATE_FAILED", "failed"}, {GEARY_IMAP_DESERIALIZER_STATE_CLOSED, "GEARY_IMAP_DESERIALIZER_STATE_CLOSED", "closed"}, {GEARY_IMAP_DESERIALIZER_STATE_COUNT, "GEARY_IMAP_DESERIALIZER_STATE_COUNT", "count"}, {0, NULL, NULL}};
	GType geary_imap_deserializer_state_type_id;
	geary_imap_deserializer_state_type_id = g_enum_register_static ("GearyImapDeserializerState", values);
	return geary_imap_deserializer_state_type_id;
}

static GType
geary_imap_deserializer_state_get_type (void)
{
	static gsize geary_imap_deserializer_state_type_id__once = 0;
	if (g_once_init_enter (&geary_imap_deserializer_state_type_id__once)) {
		GType geary_imap_deserializer_state_type_id;
		geary_imap_deserializer_state_type_id = geary_imap_deserializer_state_get_type_once ();
		g_once_init_leave (&geary_imap_deserializer_state_type_id__once, geary_imap_deserializer_state_type_id);
	}
	return geary_imap_deserializer_state_type_id__once;
}

 G_GNUC_NO_INLINE static GType
geary_imap_deserializer_event_get_type_once (void)
{
	static const GEnumValue values[] = {{GEARY_IMAP_DESERIALIZER_EVENT_CHAR, "GEARY_IMAP_DESERIALIZER_EVENT_CHAR", "char"}, {GEARY_IMAP_DESERIALIZER_EVENT_EOL, "GEARY_IMAP_DESERIALIZER_EVENT_EOL", "eol"}, {GEARY_IMAP_DESERIALIZER_EVENT_DATA, "GEARY_IMAP_DESERIALIZER_EVENT_DATA", "data"}, {GEARY_IMAP_DESERIALIZER_EVENT_EOS, "GEARY_IMAP_DESERIALIZER_EVENT_EOS", "eos"}, {GEARY_IMAP_DESERIALIZER_EVENT_ERROR, "GEARY_IMAP_DESERIALIZER_EVENT_ERROR", "error"}, {GEARY_IMAP_DESERIALIZER_EVENT_COUNT, "GEARY_IMAP_DESERIALIZER_EVENT_COUNT", "count"}, {0, NULL, NULL}};
	GType geary_imap_deserializer_event_type_id;
	geary_imap_deserializer_event_type_id = g_enum_register_static ("GearyImapDeserializerEvent", values);
	return geary_imap_deserializer_event_type_id;
}

static GType
geary_imap_deserializer_event_get_type (void)
{
	static gsize geary_imap_deserializer_event_type_id__once = 0;
	if (g_once_init_enter (&geary_imap_deserializer_event_type_id__once)) {
		GType geary_imap_deserializer_event_type_id;
		geary_imap_deserializer_event_type_id = geary_imap_deserializer_event_get_type_once ();
		g_once_init_leave (&geary_imap_deserializer_event_type_id__once, geary_imap_deserializer_event_type_id);
	}
	return geary_imap_deserializer_event_type_id__once;
}

static gchar*
geary_imap_deserializer_state_to_string (guint state)
{
	gchar* result;
#line 63 "../src/engine/imap/transport/imap-deserializer.vala"
	result = g_enum_to_string (GEARY_IMAP_DESERIALIZER_TYPE_STATE, (GearyImapDeserializerState) state);
#line 63 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 501 "imap-deserializer.c"
}

static gchar*
geary_imap_deserializer_event_to_string (guint event)
{
	gchar* result;
#line 76 "../src/engine/imap/transport/imap-deserializer.vala"
	result = g_enum_to_string (GEARY_IMAP_DESERIALIZER_TYPE_EVENT, (GearyImapDeserializerEvent) event);
#line 76 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 512 "imap-deserializer.c"
}

static gchar*
_geary_imap_deserializer_state_to_string_geary_state_state_event_to_string (guint state_or_event,
                                                                            gpointer self)
{
	gchar* result;
	result = geary_imap_deserializer_state_to_string (state_or_event);
#line 79 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 523 "imap-deserializer.c"
}

static gchar*
_geary_imap_deserializer_event_to_string_geary_state_state_event_to_string (guint state_or_event,
                                                                            gpointer self)
{
	gchar* result;
	result = geary_imap_deserializer_event_to_string (state_or_event);
#line 79 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 534 "imap-deserializer.c"
}

static const gchar*
geary_imap_deserializer_real_get_logging_domain (GearyLoggingSource* base)
{
	const gchar* result;
	GearyImapDeserializer* self;
#line 85 "../src/engine/imap/transport/imap-deserializer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_IMAP_TYPE_DESERIALIZER, GearyImapDeserializer);
#line 85 "../src/engine/imap/transport/imap-deserializer.vala"
	result = GEARY_IMAP_CLIENT_SERVICE_DESERIALISATION_LOGGING_DOMAIN;
#line 85 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 548 "imap-deserializer.c"
}

static GearyLoggingSource*
geary_imap_deserializer_real_get_logging_parent (GearyLoggingSource* base)
{
	GearyLoggingSource* result;
	GearyImapDeserializer* self;
	GearyLoggingSource* _tmp0_;
#line 89 "../src/engine/imap/transport/imap-deserializer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_IMAP_TYPE_DESERIALIZER, GearyImapDeserializer);
#line 89 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp0_ = self->priv->_logging_parent;
#line 89 "../src/engine/imap/transport/imap-deserializer.vala"
	result = _tmp0_;
#line 89 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 565 "imap-deserializer.c"
}

GearyImapQuirks*
geary_imap_deserializer_get_quirks (GearyImapDeserializer* self)
{
	GearyImapQuirks* result;
	GearyImapQuirks* _tmp0_;
#line 93 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), NULL);
#line 93 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp0_ = self->priv->_quirks;
#line 93 "../src/engine/imap/transport/imap-deserializer.vala"
	result = _tmp0_;
#line 93 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 581 "imap-deserializer.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 93 "../src/engine/imap/transport/imap-deserializer.vala"
	return self ? g_object_ref (self) : NULL;
#line 589 "imap-deserializer.c"
}

void
geary_imap_deserializer_set_quirks (GearyImapDeserializer* self,
                                    GearyImapQuirks* value)
{
	GearyImapQuirks* old_value;
#line 93 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_DESERIALIZER (self));
#line 93 "../src/engine/imap/transport/imap-deserializer.vala"
	old_value = geary_imap_deserializer_get_quirks (self);
#line 93 "../src/engine/imap/transport/imap-deserializer.vala"
	if (old_value != value) {
#line 603 "imap-deserializer.c"
		GearyImapQuirks* _tmp0_;
#line 93 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 93 "../src/engine/imap/transport/imap-deserializer.vala"
		_g_object_unref0 (self->priv->_quirks);
#line 93 "../src/engine/imap/transport/imap-deserializer.vala"
		self->priv->_quirks = _tmp0_;
#line 93 "../src/engine/imap/transport/imap-deserializer.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_imap_deserializer_properties[GEARY_IMAP_DESERIALIZER_QUIRKS_PROPERTY]);
#line 613 "imap-deserializer.c"
	}
}

static guint
_geary_imap_deserializer_on_tag_char_geary_state_transition (guint state,
                                                             guint event,
                                                             void* user,
                                                             GObject* object,
                                                             GError* err,
                                                             gpointer self)
{
	guint result;
	result = geary_imap_deserializer_on_tag_char ((GearyImapDeserializer*) self, state, event, user);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 629 "imap-deserializer.c"
}

static guint
_geary_imap_deserializer_on_eos_geary_state_transition (guint state,
                                                        guint event,
                                                        void* user,
                                                        GObject* object,
                                                        GError* err,
                                                        gpointer self)
{
	guint result;
	result = geary_imap_deserializer_on_eos ((GearyImapDeserializer*) self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 644 "imap-deserializer.c"
}

static guint
_geary_imap_deserializer_on_error_geary_state_transition (guint state,
                                                          guint event,
                                                          void* user,
                                                          GObject* object,
                                                          GError* err,
                                                          gpointer self)
{
	guint result;
	result = geary_imap_deserializer_on_error ((GearyImapDeserializer*) self, state, event, user, object, err);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 659 "imap-deserializer.c"
}

static guint
_geary_imap_deserializer_on_first_param_char_geary_state_transition (guint state,
                                                                     guint event,
                                                                     void* user,
                                                                     GObject* object,
                                                                     GError* err,
                                                                     gpointer self)
{
	guint result;
	result = geary_imap_deserializer_on_first_param_char ((GearyImapDeserializer*) self, state, event, user);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 674 "imap-deserializer.c"
}

static guint
_geary_imap_deserializer_on_eol_geary_state_transition (guint state,
                                                        guint event,
                                                        void* user,
                                                        GObject* object,
                                                        GError* err,
                                                        gpointer self)
{
	guint result;
	result = geary_imap_deserializer_on_eol ((GearyImapDeserializer*) self, state, event, user);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 689 "imap-deserializer.c"
}

static guint
_geary_imap_deserializer_on_atom_char_geary_state_transition (guint state,
                                                              guint event,
                                                              void* user,
                                                              GObject* object,
                                                              GError* err,
                                                              gpointer self)
{
	guint result;
	result = geary_imap_deserializer_on_atom_char ((GearyImapDeserializer*) self, state, event, user);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 704 "imap-deserializer.c"
}

static guint
_geary_imap_deserializer_on_param_eol_geary_state_transition (guint state,
                                                              guint event,
                                                              void* user,
                                                              GObject* object,
                                                              GError* err,
                                                              gpointer self)
{
	guint result;
	result = geary_imap_deserializer_on_param_eol ((GearyImapDeserializer*) self, state, event, user);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 719 "imap-deserializer.c"
}

static guint
_geary_imap_deserializer_on_flag_char_geary_state_transition (guint state,
                                                              guint event,
                                                              void* user,
                                                              GObject* object,
                                                              GError* err,
                                                              gpointer self)
{
	guint result;
	result = geary_imap_deserializer_on_flag_char ((GearyImapDeserializer*) self, state, event, user);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 734 "imap-deserializer.c"
}

static guint
_geary_imap_deserializer_on_quoted_char_geary_state_transition (guint state,
                                                                guint event,
                                                                void* user,
                                                                GObject* object,
                                                                GError* err,
                                                                gpointer self)
{
	guint result;
	result = geary_imap_deserializer_on_quoted_char ((GearyImapDeserializer*) self, state, event, user);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 749 "imap-deserializer.c"
}

static guint
_geary_imap_deserializer_on_quoted_escape_char_geary_state_transition (guint state,
                                                                       guint event,
                                                                       void* user,
                                                                       GObject* object,
                                                                       GError* err,
                                                                       gpointer self)
{
	guint result;
	result = geary_imap_deserializer_on_quoted_escape_char ((GearyImapDeserializer*) self, state, event, user);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 764 "imap-deserializer.c"
}

static guint
_geary_imap_deserializer_on_partial_body_atom_char_geary_state_transition (guint state,
                                                                           guint event,
                                                                           void* user,
                                                                           GObject* object,
                                                                           GError* err,
                                                                           gpointer self)
{
	guint result;
	result = geary_imap_deserializer_on_partial_body_atom_char ((GearyImapDeserializer*) self, state, event, user);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 779 "imap-deserializer.c"
}

static guint
_geary_imap_deserializer_on_partial_body_atom_terminating_char_geary_state_transition (guint state,
                                                                                       guint event,
                                                                                       void* user,
                                                                                       GObject* object,
                                                                                       GError* err,
                                                                                       gpointer self)
{
	guint result;
	result = geary_imap_deserializer_on_partial_body_atom_terminating_char ((GearyImapDeserializer*) self, state, event, user);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 794 "imap-deserializer.c"
}

static guint
_geary_imap_deserializer_on_literal_char_geary_state_transition (guint state,
                                                                 guint event,
                                                                 void* user,
                                                                 GObject* object,
                                                                 GError* err,
                                                                 gpointer self)
{
	guint result;
	result = geary_imap_deserializer_on_literal_char ((GearyImapDeserializer*) self, state, event, user);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 809 "imap-deserializer.c"
}

static guint
_geary_imap_deserializer_on_literal_data_begin_eol_geary_state_transition (guint state,
                                                                           guint event,
                                                                           void* user,
                                                                           GObject* object,
                                                                           GError* err,
                                                                           gpointer self)
{
	guint result;
	result = geary_imap_deserializer_on_literal_data_begin_eol ((GearyImapDeserializer*) self, state, event, user);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 824 "imap-deserializer.c"
}

static guint
_geary_imap_deserializer_on_literal_data_geary_state_transition (guint state,
                                                                 guint event,
                                                                 void* user,
                                                                 GObject* object,
                                                                 GError* err,
                                                                 gpointer self)
{
	guint result;
	result = geary_imap_deserializer_on_literal_data ((GearyImapDeserializer*) self, state, event, user);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 839 "imap-deserializer.c"
}

static guint
_geary_imap_deserializer_on_response_text_char_geary_state_transition (guint state,
                                                                       guint event,
                                                                       void* user,
                                                                       GObject* object,
                                                                       GError* err,
                                                                       gpointer self)
{
	guint result;
	result = geary_imap_deserializer_on_response_text_char ((GearyImapDeserializer*) self, state, event, user);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 854 "imap-deserializer.c"
}

static guint
_geary_imap_deserializer_on_failed_eol_geary_state_transition (guint state,
                                                               guint event,
                                                               void* user,
                                                               GObject* object,
                                                               GError* err,
                                                               gpointer self)
{
	guint result;
	result = geary_imap_deserializer_on_failed_eol ((GearyImapDeserializer*) self, state, event, user);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 869 "imap-deserializer.c"
}

static guint
_geary_state_nop_geary_state_transition (guint state,
                                         guint event,
                                         void* user,
                                         GObject* object,
                                         GError* err,
                                         gpointer self)
{
	guint result;
	result = geary_state_nop (state, event);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 884 "imap-deserializer.c"
}

static guint
_geary_imap_deserializer_on_bad_transition_geary_state_transition (guint state,
                                                                   guint event,
                                                                   void* user,
                                                                   GObject* object,
                                                                   GError* err,
                                                                   gpointer self)
{
	guint result;
	result = geary_imap_deserializer_on_bad_transition ((GearyImapDeserializer*) self, state, event, user);
#line 239 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 899 "imap-deserializer.c"
}

GearyImapDeserializer*
geary_imap_deserializer_construct (GType object_type,
                                   const gchar* identifier,
                                   GInputStream* input,
                                   GearyImapQuirks* quirks)
{
	GearyImapDeserializer * self = NULL;
	gchar* _tmp0_;
	GDataInputStream* _tmp1_;
	GDataInputStream* _tmp2_;
	GDataInputStream* _tmp3_;
	GearyStateMapping** mappings = NULL;
	GearyStateMapping* _tmp4_;
	GearyStateMapping* _tmp5_;
	GearyStateMapping* _tmp6_;
	GearyStateMapping* _tmp7_;
	GearyStateMapping* _tmp8_;
	GearyStateMapping* _tmp9_;
	GearyStateMapping* _tmp10_;
	GearyStateMapping* _tmp11_;
	GearyStateMapping* _tmp12_;
	GearyStateMapping* _tmp13_;
	GearyStateMapping* _tmp14_;
	GearyStateMapping* _tmp15_;
	GearyStateMapping* _tmp16_;
	GearyStateMapping* _tmp17_;
	GearyStateMapping* _tmp18_;
	GearyStateMapping* _tmp19_;
	GearyStateMapping* _tmp20_;
	GearyStateMapping* _tmp21_;
	GearyStateMapping* _tmp22_;
	GearyStateMapping* _tmp23_;
	GearyStateMapping* _tmp24_;
	GearyStateMapping* _tmp25_;
	GearyStateMapping* _tmp26_;
	GearyStateMapping* _tmp27_;
	GearyStateMapping* _tmp28_;
	GearyStateMapping* _tmp29_;
	GearyStateMapping* _tmp30_;
	GearyStateMapping* _tmp31_;
	GearyStateMapping* _tmp32_;
	GearyStateMapping* _tmp33_;
	GearyStateMapping* _tmp34_;
	GearyStateMapping* _tmp35_;
	GearyStateMapping* _tmp36_;
	GearyStateMapping* _tmp37_;
	GearyStateMapping* _tmp38_;
	GearyStateMapping* _tmp39_;
	GearyStateMapping* _tmp40_;
	GearyStateMapping* _tmp41_;
	GearyStateMapping* _tmp42_;
	GearyStateMapping* _tmp43_;
	GearyStateMapping* _tmp44_;
	GearyStateMapping* _tmp45_;
	GearyStateMapping* _tmp46_;
	GearyStateMapping* _tmp47_;
	GearyStateMapping* _tmp48_;
	GearyStateMapping** _tmp49_;
	gint mappings_length1;
	gint _mappings_size_;
	GearyStateMachineDescriptor* _tmp50_;
	GearyStateMachine* _tmp51_;
#line 166 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (identifier != NULL, NULL);
#line 166 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (input, g_input_stream_get_type ()), NULL);
#line 166 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_QUIRKS (quirks), NULL);
#line 166 "../src/engine/imap/transport/imap-deserializer.vala"
	self = (GearyImapDeserializer*) geary_base_object_construct (object_type);
#line 169 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp0_ = g_strdup (identifier);
#line 169 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_free0 (self->priv->identifier);
#line 169 "../src/engine/imap/transport/imap-deserializer.vala"
	self->priv->identifier = _tmp0_;
#line 171 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp1_ = g_data_input_stream_new (input);
#line 171 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_object_unref0 (self->priv->input);
#line 171 "../src/engine/imap/transport/imap-deserializer.vala"
	self->priv->input = _tmp1_;
#line 172 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp2_ = self->priv->input;
#line 172 "../src/engine/imap/transport/imap-deserializer.vala"
	g_filter_input_stream_set_close_base_stream (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, g_filter_input_stream_get_type (), GFilterInputStream), FALSE);
#line 173 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp3_ = self->priv->input;
#line 173 "../src/engine/imap/transport/imap-deserializer.vala"
	g_data_input_stream_set_newline_type (_tmp3_, G_DATA_STREAM_NEWLINE_TYPE_CR_LF);
#line 175 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_set_quirks (self, quirks);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp4_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_TAG, (guint) GEARY_IMAP_DESERIALIZER_EVENT_CHAR, _geary_imap_deserializer_on_tag_char_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp5_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_TAG, (guint) GEARY_IMAP_DESERIALIZER_EVENT_EOS, _geary_imap_deserializer_on_eos_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp6_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_TAG, (guint) GEARY_IMAP_DESERIALIZER_EVENT_ERROR, _geary_imap_deserializer_on_error_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp7_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_START_PARAM, (guint) GEARY_IMAP_DESERIALIZER_EVENT_CHAR, _geary_imap_deserializer_on_first_param_char_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp8_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_START_PARAM, (guint) GEARY_IMAP_DESERIALIZER_EVENT_EOL, _geary_imap_deserializer_on_eol_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp9_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_START_PARAM, (guint) GEARY_IMAP_DESERIALIZER_EVENT_EOS, _geary_imap_deserializer_on_eos_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp10_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_START_PARAM, (guint) GEARY_IMAP_DESERIALIZER_EVENT_ERROR, _geary_imap_deserializer_on_error_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp11_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_ATOM, (guint) GEARY_IMAP_DESERIALIZER_EVENT_CHAR, _geary_imap_deserializer_on_atom_char_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp12_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_ATOM, (guint) GEARY_IMAP_DESERIALIZER_EVENT_EOL, _geary_imap_deserializer_on_param_eol_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp13_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_ATOM, (guint) GEARY_IMAP_DESERIALIZER_EVENT_EOS, _geary_imap_deserializer_on_eos_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp14_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_ATOM, (guint) GEARY_IMAP_DESERIALIZER_EVENT_ERROR, _geary_imap_deserializer_on_error_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp15_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_FLAG, (guint) GEARY_IMAP_DESERIALIZER_EVENT_CHAR, _geary_imap_deserializer_on_flag_char_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp16_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_FLAG, (guint) GEARY_IMAP_DESERIALIZER_EVENT_EOL, _geary_imap_deserializer_on_param_eol_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp17_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_FLAG, (guint) GEARY_IMAP_DESERIALIZER_EVENT_EOS, _geary_imap_deserializer_on_eos_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp18_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_FLAG, (guint) GEARY_IMAP_DESERIALIZER_EVENT_ERROR, _geary_imap_deserializer_on_error_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp19_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_QUOTED, (guint) GEARY_IMAP_DESERIALIZER_EVENT_CHAR, _geary_imap_deserializer_on_quoted_char_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp20_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_QUOTED, (guint) GEARY_IMAP_DESERIALIZER_EVENT_EOS, _geary_imap_deserializer_on_eos_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp21_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_QUOTED, (guint) GEARY_IMAP_DESERIALIZER_EVENT_ERROR, _geary_imap_deserializer_on_error_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp22_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_QUOTED_ESCAPE, (guint) GEARY_IMAP_DESERIALIZER_EVENT_CHAR, _geary_imap_deserializer_on_quoted_escape_char_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp23_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_QUOTED_ESCAPE, (guint) GEARY_IMAP_DESERIALIZER_EVENT_EOS, _geary_imap_deserializer_on_eos_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp24_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_QUOTED_ESCAPE, (guint) GEARY_IMAP_DESERIALIZER_EVENT_ERROR, _geary_imap_deserializer_on_error_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp25_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_PARTIAL_BODY_ATOM, (guint) GEARY_IMAP_DESERIALIZER_EVENT_CHAR, _geary_imap_deserializer_on_partial_body_atom_char_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp26_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_PARTIAL_BODY_ATOM, (guint) GEARY_IMAP_DESERIALIZER_EVENT_EOS, _geary_imap_deserializer_on_eos_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp27_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_PARTIAL_BODY_ATOM, (guint) GEARY_IMAP_DESERIALIZER_EVENT_ERROR, _geary_imap_deserializer_on_error_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp28_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_PARTIAL_BODY_ATOM_TERMINATING, (guint) GEARY_IMAP_DESERIALIZER_EVENT_CHAR, _geary_imap_deserializer_on_partial_body_atom_terminating_char_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp29_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_PARTIAL_BODY_ATOM_TERMINATING, (guint) GEARY_IMAP_DESERIALIZER_EVENT_EOS, _geary_imap_deserializer_on_eos_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp30_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_PARTIAL_BODY_ATOM_TERMINATING, (guint) GEARY_IMAP_DESERIALIZER_EVENT_ERROR, _geary_imap_deserializer_on_error_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp31_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_LITERAL, (guint) GEARY_IMAP_DESERIALIZER_EVENT_CHAR, _geary_imap_deserializer_on_literal_char_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp32_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_LITERAL, (guint) GEARY_IMAP_DESERIALIZER_EVENT_EOS, _geary_imap_deserializer_on_eos_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp33_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_LITERAL, (guint) GEARY_IMAP_DESERIALIZER_EVENT_ERROR, _geary_imap_deserializer_on_error_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp34_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_LITERAL_DATA_BEGIN, (guint) GEARY_IMAP_DESERIALIZER_EVENT_EOL, _geary_imap_deserializer_on_literal_data_begin_eol_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp35_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_LITERAL_DATA_BEGIN, (guint) GEARY_IMAP_DESERIALIZER_EVENT_EOS, _geary_imap_deserializer_on_eos_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp36_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_LITERAL_DATA_BEGIN, (guint) GEARY_IMAP_DESERIALIZER_EVENT_ERROR, _geary_imap_deserializer_on_error_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp37_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_LITERAL_DATA, (guint) GEARY_IMAP_DESERIALIZER_EVENT_DATA, _geary_imap_deserializer_on_literal_data_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp38_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_LITERAL_DATA, (guint) GEARY_IMAP_DESERIALIZER_EVENT_EOS, _geary_imap_deserializer_on_eos_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp39_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_LITERAL_DATA, (guint) GEARY_IMAP_DESERIALIZER_EVENT_ERROR, _geary_imap_deserializer_on_error_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp40_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_RESPONSE_TEXT, (guint) GEARY_IMAP_DESERIALIZER_EVENT_CHAR, _geary_imap_deserializer_on_response_text_char_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp41_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_RESPONSE_TEXT, (guint) GEARY_IMAP_DESERIALIZER_EVENT_EOL, _geary_imap_deserializer_on_param_eol_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp42_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_RESPONSE_TEXT, (guint) GEARY_IMAP_DESERIALIZER_EVENT_EOS, _geary_imap_deserializer_on_eos_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp43_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_RESPONSE_TEXT, (guint) GEARY_IMAP_DESERIALIZER_EVENT_ERROR, _geary_imap_deserializer_on_error_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp44_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_FAILED, (guint) GEARY_IMAP_DESERIALIZER_EVENT_EOL, _geary_imap_deserializer_on_failed_eol_geary_state_transition, self);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp45_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_FAILED, (guint) GEARY_IMAP_DESERIALIZER_EVENT_EOS, _geary_state_nop_geary_state_transition, NULL);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp46_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_FAILED, (guint) GEARY_IMAP_DESERIALIZER_EVENT_ERROR, _geary_state_nop_geary_state_transition, NULL);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp47_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_CLOSED, (guint) GEARY_IMAP_DESERIALIZER_EVENT_EOS, _geary_state_nop_geary_state_transition, NULL);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp48_ = geary_state_mapping_new ((guint) GEARY_IMAP_DESERIALIZER_STATE_CLOSED, (guint) GEARY_IMAP_DESERIALIZER_EVENT_ERROR, _geary_state_nop_geary_state_transition, NULL);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_ = g_new0 (GearyStateMapping*, 45 + 1);
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[0] = _tmp4_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[1] = _tmp5_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[2] = _tmp6_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[3] = _tmp7_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[4] = _tmp8_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[5] = _tmp9_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[6] = _tmp10_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[7] = _tmp11_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[8] = _tmp12_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[9] = _tmp13_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[10] = _tmp14_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[11] = _tmp15_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[12] = _tmp16_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[13] = _tmp17_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[14] = _tmp18_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[15] = _tmp19_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[16] = _tmp20_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[17] = _tmp21_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[18] = _tmp22_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[19] = _tmp23_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[20] = _tmp24_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[21] = _tmp25_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[22] = _tmp26_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[23] = _tmp27_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[24] = _tmp28_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[25] = _tmp29_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[26] = _tmp30_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[27] = _tmp31_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[28] = _tmp32_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[29] = _tmp33_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[30] = _tmp34_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[31] = _tmp35_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[32] = _tmp36_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[33] = _tmp37_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[34] = _tmp38_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[35] = _tmp39_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[36] = _tmp40_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[37] = _tmp41_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[38] = _tmp42_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[39] = _tmp43_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[40] = _tmp44_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[41] = _tmp45_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[42] = _tmp46_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[43] = _tmp47_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp49_[44] = _tmp48_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	mappings = _tmp49_;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	mappings_length1 = 45;
#line 177 "../src/engine/imap/transport/imap-deserializer.vala"
	_mappings_size_ = mappings_length1;
#line 239 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp50_ = geary_imap_deserializer_machine_desc;
#line 239 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp51_ = geary_state_machine_new (_tmp50_, mappings, mappings_length1, _geary_imap_deserializer_on_bad_transition_geary_state_transition, self);
#line 239 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_object_unref0 (self->priv->fsm);
#line 239 "../src/engine/imap/transport/imap-deserializer.vala"
	self->priv->fsm = _tmp51_;
#line 241 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_reset_params (self);
#line 166 "../src/engine/imap/transport/imap-deserializer.vala"
	mappings = (_vala_array_free (mappings, mappings_length1, (GDestroyNotify) g_object_unref), NULL);
#line 166 "../src/engine/imap/transport/imap-deserializer.vala"
	return self;
#line 1196 "imap-deserializer.c"
}

GearyImapDeserializer*
geary_imap_deserializer_new (const gchar* identifier,
                             GInputStream* input,
                             GearyImapQuirks* quirks)
{
#line 166 "../src/engine/imap/transport/imap-deserializer.vala"
	return geary_imap_deserializer_construct (GEARY_IMAP_TYPE_DESERIALIZER, identifier, input, quirks);
#line 1206 "imap-deserializer.c"
}

static void
geary_imap_deserializer_start_async_data_free (gpointer _data)
{
	GearyImapDeserializerStartAsyncData* _data_;
	_data_ = _data;
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_object_unref0 (_data_->self);
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	g_slice_free (GearyImapDeserializerStartAsyncData, _data_);
#line 1218 "imap-deserializer.c"
}

void
geary_imap_deserializer_start_async (GearyImapDeserializer* self,
                                     gint priority,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	GearyImapDeserializerStartAsyncData* _data_;
	GearyImapDeserializer* _tmp0_;
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_DESERIALIZER (self));
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	_data_ = g_slice_new0 (GearyImapDeserializerStartAsyncData);
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_deserializer_start_async_data_free);
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	_data_->self = _tmp0_;
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	_data_->priority = priority;
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_start_async_co (_data_);
#line 1245 "imap-deserializer.c"
}

void
geary_imap_deserializer_start_finish (GearyImapDeserializer* self,
                                      GAsyncResult* _res_,
                                      GError** error)
{
	GearyImapDeserializerStartAsyncData* _data_;
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	if (NULL == _data_) {
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
		return;
#line 1260 "imap-deserializer.c"
	}
}

/**
     * Begin deserializing IMAP responses from the input stream.
     *
     * Subscribe to the various signals before starting to ensure that all responses are trapped.
     */
static gboolean
geary_imap_deserializer_start_async_co (GearyImapDeserializerStartAsyncData* _data_)
{
#line 249 "../src/engine/imap/transport/imap-deserializer.vala"
	switch (_data_->_state_) {
#line 249 "../src/engine/imap/transport/imap-deserializer.vala"
		case 0:
#line 1276 "imap-deserializer.c"
		goto _state_0;
		default:
#line 249 "../src/engine/imap/transport/imap-deserializer.vala"
		g_assert_not_reached ();
#line 1281 "imap-deserializer.c"
	}
	_state_0:
#line 250 "../src/engine/imap/transport/imap-deserializer.vala"
	_data_->_tmp0_ = _data_->self->priv->cancellable;
#line 250 "../src/engine/imap/transport/imap-deserializer.vala"
	if (_data_->_tmp0_ != NULL) {
#line 251 "../src/engine/imap/transport/imap-deserializer.vala"
		_data_->_tmp1_ = g_error_new_literal (GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_ALREADY_OPEN, "Deserializer already open");
#line 251 "../src/engine/imap/transport/imap-deserializer.vala"
		_data_->_inner_error0_ = _data_->_tmp1_;
#line 251 "../src/engine/imap/transport/imap-deserializer.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 251 "../src/engine/imap/transport/imap-deserializer.vala"
		g_object_unref (_data_->_async_result);
#line 251 "../src/engine/imap/transport/imap-deserializer.vala"
		return FALSE;
#line 1298 "imap-deserializer.c"
	}
#line 253 "../src/engine/imap/transport/imap-deserializer.vala"
	_data_->mode = geary_imap_deserializer_get_mode (_data_->self);
#line 255 "../src/engine/imap/transport/imap-deserializer.vala"
	if (_data_->mode == GEARY_IMAP_DESERIALIZER_MODE_FAILED) {
#line 256 "../src/engine/imap/transport/imap-deserializer.vala"
		_data_->_tmp2_ = g_error_new_literal (GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_ALREADY_CLOSED, "Deserializer failed");
#line 256 "../src/engine/imap/transport/imap-deserializer.vala"
		_data_->_inner_error0_ = _data_->_tmp2_;
#line 256 "../src/engine/imap/transport/imap-deserializer.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 256 "../src/engine/imap/transport/imap-deserializer.vala"
		g_object_unref (_data_->_async_result);
#line 256 "../src/engine/imap/transport/imap-deserializer.vala"
		return FALSE;
#line 1314 "imap-deserializer.c"
	}
#line 258 "../src/engine/imap/transport/imap-deserializer.vala"
	if (_data_->mode == GEARY_IMAP_DESERIALIZER_MODE_CLOSED) {
#line 258 "../src/engine/imap/transport/imap-deserializer.vala"
		_data_->_tmp3_ = TRUE;
#line 1320 "imap-deserializer.c"
	} else {
#line 258 "../src/engine/imap/transport/imap-deserializer.vala"
		_data_->_tmp5_ = _data_->self->priv->cancellable;
#line 258 "../src/engine/imap/transport/imap-deserializer.vala"
		if (_data_->_tmp5_ != NULL) {
#line 258 "../src/engine/imap/transport/imap-deserializer.vala"
			_data_->_tmp6_ = _data_->self->priv->cancellable;
#line 258 "../src/engine/imap/transport/imap-deserializer.vala"
			_data_->_tmp4_ = g_cancellable_is_cancelled (_data_->_tmp6_);
#line 1330 "imap-deserializer.c"
		} else {
#line 258 "../src/engine/imap/transport/imap-deserializer.vala"
			_data_->_tmp4_ = FALSE;
#line 1334 "imap-deserializer.c"
		}
#line 258 "../src/engine/imap/transport/imap-deserializer.vala"
		_data_->_tmp3_ = _data_->_tmp4_;
#line 1338 "imap-deserializer.c"
	}
#line 258 "../src/engine/imap/transport/imap-deserializer.vala"
	if (_data_->_tmp3_) {
#line 259 "../src/engine/imap/transport/imap-deserializer.vala"
		_data_->_tmp7_ = g_error_new_literal (GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_ALREADY_CLOSED, "Deserializer closed");
#line 259 "../src/engine/imap/transport/imap-deserializer.vala"
		_data_->_inner_error0_ = _data_->_tmp7_;
#line 259 "../src/engine/imap/transport/imap-deserializer.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 259 "../src/engine/imap/transport/imap-deserializer.vala"
		g_object_unref (_data_->_async_result);
#line 259 "../src/engine/imap/transport/imap-deserializer.vala"
		return FALSE;
#line 1352 "imap-deserializer.c"
	}
#line 261 "../src/engine/imap/transport/imap-deserializer.vala"
	_data_->_tmp8_ = g_cancellable_new ();
#line 261 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_object_unref0 (_data_->self->priv->cancellable);
#line 261 "../src/engine/imap/transport/imap-deserializer.vala"
	_data_->self->priv->cancellable = _data_->_tmp8_;
#line 262 "../src/engine/imap/transport/imap-deserializer.vala"
	_data_->self->priv->ins_priority = _data_->priority;
#line 264 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_next_deserialize_step (_data_->self);
#line 249 "../src/engine/imap/transport/imap-deserializer.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 249 "../src/engine/imap/transport/imap-deserializer.vala"
	if (_data_->_state_ != 0) {
#line 249 "../src/engine/imap/transport/imap-deserializer.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 249 "../src/engine/imap/transport/imap-deserializer.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1372 "imap-deserializer.c"
		}
	}
#line 249 "../src/engine/imap/transport/imap-deserializer.vala"
	g_object_unref (_data_->_async_result);
#line 249 "../src/engine/imap/transport/imap-deserializer.vala"
	return FALSE;
#line 1379 "imap-deserializer.c"
}

static void
geary_imap_deserializer_stop_async_data_free (gpointer _data)
{
	GearyImapDeserializerStopAsyncData* _data_;
	_data_ = _data;
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_object_unref0 (_data_->self);
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	g_slice_free (GearyImapDeserializerStopAsyncData, _data_);
#line 1391 "imap-deserializer.c"
}

void
geary_imap_deserializer_stop_async (GearyImapDeserializer* self,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	GearyImapDeserializerStopAsyncData* _data_;
	GearyImapDeserializer* _tmp0_;
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_DESERIALIZER (self));
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	_data_ = g_slice_new0 (GearyImapDeserializerStopAsyncData);
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_imap_deserializer_stop_async_data_free);
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	_data_->self = _tmp0_;
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_stop_async_co (_data_);
#line 1415 "imap-deserializer.c"
}

void
geary_imap_deserializer_stop_finish (GearyImapDeserializer* self,
                                     GAsyncResult* _res_,
                                     GError** error)
{
	GearyImapDeserializerStopAsyncData* _data_;
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	if (NULL == _data_) {
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
		return;
#line 1430 "imap-deserializer.c"
	}
}

static void
geary_imap_deserializer_stop_async_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	GearyImapDeserializerStopAsyncData* _data_;
#line 276 "../src/engine/imap/transport/imap-deserializer.vala"
	_data_ = _user_data_;
#line 276 "../src/engine/imap/transport/imap-deserializer.vala"
	_data_->_source_object_ = source_object;
#line 276 "../src/engine/imap/transport/imap-deserializer.vala"
	_data_->_res_ = _res_;
#line 276 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_stop_async_co (_data_);
#line 1448 "imap-deserializer.c"
}

static gboolean
geary_imap_deserializer_stop_async_co (GearyImapDeserializerStopAsyncData* _data_)
{
#line 267 "../src/engine/imap/transport/imap-deserializer.vala"
	switch (_data_->_state_) {
#line 267 "../src/engine/imap/transport/imap-deserializer.vala"
		case 0:
#line 1458 "imap-deserializer.c"
		goto _state_0;
#line 267 "../src/engine/imap/transport/imap-deserializer.vala"
		case 1:
#line 1462 "imap-deserializer.c"
		goto _state_1;
#line 267 "../src/engine/imap/transport/imap-deserializer.vala"
		case 2:
#line 1466 "imap-deserializer.c"
		goto _state_2;
		default:
#line 267 "../src/engine/imap/transport/imap-deserializer.vala"
		g_assert_not_reached ();
#line 1471 "imap-deserializer.c"
	}
	_state_0:
#line 269 "../src/engine/imap/transport/imap-deserializer.vala"
	_data_->_tmp2_ = _data_->self->priv->cancellable;
#line 269 "../src/engine/imap/transport/imap-deserializer.vala"
	if (_data_->_tmp2_ == NULL) {
#line 269 "../src/engine/imap/transport/imap-deserializer.vala"
		_data_->_tmp1_ = TRUE;
#line 1480 "imap-deserializer.c"
	} else {
#line 269 "../src/engine/imap/transport/imap-deserializer.vala"
		_data_->_tmp3_ = _data_->self->priv->cancellable;
#line 269 "../src/engine/imap/transport/imap-deserializer.vala"
		_data_->_tmp1_ = g_cancellable_is_cancelled (_data_->_tmp3_);
#line 1486 "imap-deserializer.c"
	}
#line 269 "../src/engine/imap/transport/imap-deserializer.vala"
	if (_data_->_tmp1_) {
#line 269 "../src/engine/imap/transport/imap-deserializer.vala"
		_data_->_tmp0_ = TRUE;
#line 1492 "imap-deserializer.c"
	} else {
#line 269 "../src/engine/imap/transport/imap-deserializer.vala"
		_data_->_tmp0_ = geary_imap_deserializer_is_halted (_data_->self);
#line 1496 "imap-deserializer.c"
	}
#line 269 "../src/engine/imap/transport/imap-deserializer.vala"
	if (_data_->_tmp0_) {
#line 270 "../src/engine/imap/transport/imap-deserializer.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 270 "../src/engine/imap/transport/imap-deserializer.vala"
		if (_data_->_state_ != 0) {
#line 270 "../src/engine/imap/transport/imap-deserializer.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 270 "../src/engine/imap/transport/imap-deserializer.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1508 "imap-deserializer.c"
			}
		}
#line 270 "../src/engine/imap/transport/imap-deserializer.vala"
		g_object_unref (_data_->_async_result);
#line 270 "../src/engine/imap/transport/imap-deserializer.vala"
		return FALSE;
#line 1515 "imap-deserializer.c"
	}
#line 273 "../src/engine/imap/transport/imap-deserializer.vala"
	_data_->_tmp4_ = _data_->self->priv->cancellable;
#line 273 "../src/engine/imap/transport/imap-deserializer.vala"
	g_cancellable_cancel (_data_->_tmp4_);
#line 276 "../src/engine/imap/transport/imap-deserializer.vala"
	_data_->_tmp5_ = _data_->self->priv->closed_semaphore;
#line 276 "../src/engine/imap/transport/imap-deserializer.vala"
	_data_->_state_ = 1;
#line 276 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_nonblocking_lock_wait_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp5_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock), NULL, geary_imap_deserializer_stop_async_ready, _data_);
#line 276 "../src/engine/imap/transport/imap-deserializer.vala"
	return FALSE;
#line 1529 "imap-deserializer.c"
	_state_1:
#line 276 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_nonblocking_lock_wait_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp5_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock), _data_->_res_, &_data_->_inner_error0_);
#line 276 "../src/engine/imap/transport/imap-deserializer.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 276 "../src/engine/imap/transport/imap-deserializer.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 276 "../src/engine/imap/transport/imap-deserializer.vala"
		g_object_unref (_data_->_async_result);
#line 276 "../src/engine/imap/transport/imap-deserializer.vala"
		return FALSE;
#line 1541 "imap-deserializer.c"
	}
#line 277 "../src/engine/imap/transport/imap-deserializer.vala"
	_data_->_tmp6_ = _data_->self->priv->input;
#line 277 "../src/engine/imap/transport/imap-deserializer.vala"
	_data_->_state_ = 2;
#line 277 "../src/engine/imap/transport/imap-deserializer.vala"
	g_input_stream_close_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, g_input_stream_get_type (), GInputStream), G_PRIORITY_DEFAULT, NULL, geary_imap_deserializer_stop_async_ready, _data_);
#line 277 "../src/engine/imap/transport/imap-deserializer.vala"
	return FALSE;
#line 1551 "imap-deserializer.c"
	_state_2:
#line 277 "../src/engine/imap/transport/imap-deserializer.vala"
	g_input_stream_close_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, g_input_stream_get_type (), GInputStream), _data_->_res_, &_data_->_inner_error0_);
#line 277 "../src/engine/imap/transport/imap-deserializer.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 277 "../src/engine/imap/transport/imap-deserializer.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 277 "../src/engine/imap/transport/imap-deserializer.vala"
		g_object_unref (_data_->_async_result);
#line 277 "../src/engine/imap/transport/imap-deserializer.vala"
		return FALSE;
#line 1563 "imap-deserializer.c"
	}
#line 278 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Deserializer closed");
#line 267 "../src/engine/imap/transport/imap-deserializer.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 267 "../src/engine/imap/transport/imap-deserializer.vala"
	if (_data_->_state_ != 0) {
#line 267 "../src/engine/imap/transport/imap-deserializer.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 267 "../src/engine/imap/transport/imap-deserializer.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1575 "imap-deserializer.c"
		}
	}
#line 267 "../src/engine/imap/transport/imap-deserializer.vala"
	g_object_unref (_data_->_async_result);
#line 267 "../src/engine/imap/transport/imap-deserializer.vala"
	return FALSE;
#line 1582 "imap-deserializer.c"
}

/**
     * Determines if the deserializer is closed.
     */
gboolean
geary_imap_deserializer_is_halted (GearyImapDeserializer* self)
{
	gboolean result;
#line 284 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), FALSE);
#line 285 "../src/engine/imap/transport/imap-deserializer.vala"
	switch (geary_imap_deserializer_get_mode (self)) {
#line 285 "../src/engine/imap/transport/imap-deserializer.vala"
		case GEARY_IMAP_DESERIALIZER_MODE_FAILED:
#line 285 "../src/engine/imap/transport/imap-deserializer.vala"
		case GEARY_IMAP_DESERIALIZER_MODE_CLOSED:
#line 1600 "imap-deserializer.c"
		{
#line 288 "../src/engine/imap/transport/imap-deserializer.vala"
			result = TRUE;
#line 288 "../src/engine/imap/transport/imap-deserializer.vala"
			return result;
#line 1606 "imap-deserializer.c"
		}
		default:
		{
#line 291 "../src/engine/imap/transport/imap-deserializer.vala"
			result = FALSE;
#line 291 "../src/engine/imap/transport/imap-deserializer.vala"
			return result;
#line 1614 "imap-deserializer.c"
		}
	}
}

/** {@inheritDoc} */
static GearyLoggingState*
geary_imap_deserializer_real_to_logging_state (GearyLoggingSource* base)
{
	GearyImapDeserializer * self;
	GearyStateMachine* _tmp0_;
	GearyStateMachine* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GearyLoggingState* _tmp6_;
	GearyLoggingState* _tmp7_;
	GearyLoggingState* result;
#line 296 "../src/engine/imap/transport/imap-deserializer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_IMAP_TYPE_DESERIALIZER, GearyImapDeserializer);
#line 297 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp0_ = self->priv->fsm;
#line 297 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp1_ = self->priv->fsm;
#line 297 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp2_ = geary_state_machine_get_state (_tmp1_);
#line 297 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp3_ = _tmp2_;
#line 297 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp4_ = geary_state_machine_get_state_string (_tmp0_, _tmp3_);
#line 297 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp5_ = _tmp4_;
#line 297 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp6_ = geary_logging_state_new (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "%s", _tmp5_);
#line 297 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp7_ = _tmp6_;
#line 297 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_free0 (_tmp5_);
#line 297 "../src/engine/imap/transport/imap-deserializer.vala"
	result = _tmp7_;
#line 297 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 1657 "imap-deserializer.c"
}

/** Sets the connection's logging parent. */
void
geary_imap_deserializer_set_logging_parent (GearyImapDeserializer* self,
                                            GearyLoggingSource* parent)
{
#line 301 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_DESERIALIZER (self));
#line 301 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (GEARY_LOGGING_IS_SOURCE (parent));
#line 302 "../src/engine/imap/transport/imap-deserializer.vala"
	self->priv->_logging_parent = parent;
#line 1671 "imap-deserializer.c"
}

static void
_geary_imap_deserializer_on_read_line_gasync_ready_callback (GObject* source_object,
                                                             GAsyncResult* res,
                                                             gpointer self)
{
#line 308 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_on_read_line ((GearyImapDeserializer*) self, source_object, res);
#line 308 "../src/engine/imap/transport/imap-deserializer.vala"
	g_object_unref (self);
#line 1683 "imap-deserializer.c"
}

static void
_geary_imap_deserializer_on_read_block_gasync_ready_callback (GObject* source_object,
                                                              GAsyncResult* res,
                                                              gpointer self)
{
#line 324 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_on_read_block ((GearyImapDeserializer*) self, source_object, res);
#line 324 "../src/engine/imap/transport/imap-deserializer.vala"
	g_object_unref (self);
#line 1695 "imap-deserializer.c"
}

static void
geary_imap_deserializer_next_deserialize_step (GearyImapDeserializer* self)
{
#line 305 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_DESERIALIZER (self));
#line 306 "../src/engine/imap/transport/imap-deserializer.vala"
	switch (geary_imap_deserializer_get_mode (self)) {
#line 306 "../src/engine/imap/transport/imap-deserializer.vala"
		case GEARY_IMAP_DESERIALIZER_MODE_LINE:
#line 1707 "imap-deserializer.c"
		{
			GDataInputStream* _tmp0_;
			GCancellable* _tmp1_;
#line 308 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp0_ = self->priv->input;
#line 308 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp1_ = self->priv->cancellable;
#line 308 "../src/engine/imap/transport/imap-deserializer.vala"
			g_data_input_stream_read_line_async (_tmp0_, self->priv->ins_priority, _tmp1_, _geary_imap_deserializer_on_read_line_gasync_ready_callback, g_object_ref (self));
#line 311 "../src/engine/imap/transport/imap-deserializer.vala"
			break;
#line 1719 "imap-deserializer.c"
		}
#line 306 "../src/engine/imap/transport/imap-deserializer.vala"
		case GEARY_IMAP_DESERIALIZER_MODE_BLOCK:
#line 1723 "imap-deserializer.c"
		{
			GearyMemoryGrowableBuffer* _tmp2_;
			GearyMemoryGrowableBuffer* _tmp4_;
			gint _tmp5_ = 0;
			guint8* _tmp6_;
			GDataInputStream* _tmp7_;
			guint8* _tmp8_;
			gint _tmp8__length1;
			GCancellable* _tmp9_;
#line 316 "../src/engine/imap/transport/imap-deserializer.vala"
			_vala_assert (self->priv->literal_length_remaining >= ((gsize) 0), "literal_length_remaining >= 0");
#line 318 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp2_ = self->priv->block_buffer;
#line 318 "../src/engine/imap/transport/imap-deserializer.vala"
			if (_tmp2_ == NULL) {
#line 1739 "imap-deserializer.c"
				GearyMemoryGrowableBuffer* _tmp3_;
#line 319 "../src/engine/imap/transport/imap-deserializer.vala"
				_tmp3_ = geary_memory_growable_buffer_new ();
#line 319 "../src/engine/imap/transport/imap-deserializer.vala"
				_g_object_unref0 (self->priv->block_buffer);
#line 319 "../src/engine/imap/transport/imap-deserializer.vala"
				self->priv->block_buffer = _tmp3_;
#line 1747 "imap-deserializer.c"
			}
#line 321 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp4_ = self->priv->block_buffer;
#line 321 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp6_ = geary_memory_growable_buffer_allocate (_tmp4_, MIN (GEARY_IMAP_DESERIALIZER_MAX_BLOCK_READ_SIZE, self->priv->literal_length_remaining), &_tmp5_);
#line 321 "../src/engine/imap/transport/imap-deserializer.vala"
			self->priv->current_buffer = _tmp6_;
#line 321 "../src/engine/imap/transport/imap-deserializer.vala"
			self->priv->current_buffer_length1 = _tmp5_;
#line 321 "../src/engine/imap/transport/imap-deserializer.vala"
			self->priv->_current_buffer_size_ = self->priv->current_buffer_length1;
#line 324 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp7_ = self->priv->input;
#line 324 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp8_ = self->priv->current_buffer;
#line 324 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp8__length1 = self->priv->current_buffer_length1;
#line 324 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp9_ = self->priv->cancellable;
#line 324 "../src/engine/imap/transport/imap-deserializer.vala"
			g_input_stream_read_async (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, g_input_stream_get_type (), GInputStream), _tmp8_, (gsize) _tmp8__length1, self->priv->ins_priority, _tmp9_, _geary_imap_deserializer_on_read_block_gasync_ready_callback, g_object_ref (self));
#line 327 "../src/engine/imap/transport/imap-deserializer.vala"
			break;
#line 1771 "imap-deserializer.c"
		}
#line 306 "../src/engine/imap/transport/imap-deserializer.vala"
		case GEARY_IMAP_DESERIALIZER_MODE_FAILED:
#line 306 "../src/engine/imap/transport/imap-deserializer.vala"
		case GEARY_IMAP_DESERIALIZER_MODE_CLOSED:
#line 1777 "imap-deserializer.c"
		{
#line 332 "../src/engine/imap/transport/imap-deserializer.vala"
			break;
#line 1781 "imap-deserializer.c"
		}
		default:
		{
#line 335 "../src/engine/imap/transport/imap-deserializer.vala"
			g_assert_not_reached ();
#line 1787 "imap-deserializer.c"
		}
	}
}

static void
geary_imap_deserializer_on_read_line (GearyImapDeserializer* self,
                                      GObject* source,
                                      GAsyncResult* _result_)
{
	GError* _inner_error0_ = NULL;
#line 339 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_DESERIALIZER (self));
#line 339 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail ((source == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (source, G_TYPE_OBJECT));
#line 339 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (_result_, g_async_result_get_type ()));
#line 1804 "imap-deserializer.c"
	{
		gsize bytes_read = 0UL;
		gchar* line = NULL;
		GDataInputStream* _tmp0_;
		gsize _tmp1_ = 0UL;
		gchar* _tmp2_;
#line 342 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp0_ = self->priv->input;
#line 342 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp2_ = g_data_input_stream_read_line_finish (_tmp0_, _result_, &_tmp1_, &_inner_error0_);
#line 342 "../src/engine/imap/transport/imap-deserializer.vala"
		bytes_read = _tmp1_;
#line 342 "../src/engine/imap/transport/imap-deserializer.vala"
		line = _tmp2_;
#line 342 "../src/engine/imap/transport/imap-deserializer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1821 "imap-deserializer.c"
			goto __catch0_g_error;
		}
#line 345 "../src/engine/imap/transport/imap-deserializer.vala"
		if (line == NULL) {
#line 346 "../src/engine/imap/transport/imap-deserializer.vala"
			geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Line EOS");
#line 347 "../src/engine/imap/transport/imap-deserializer.vala"
			geary_imap_deserializer_push_eos (self);
#line 348 "../src/engine/imap/transport/imap-deserializer.vala"
			_g_free0 (line);
#line 348 "../src/engine/imap/transport/imap-deserializer.vala"
			return;
#line 1834 "imap-deserializer.c"
		}
#line 351 "../src/engine/imap/transport/imap-deserializer.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Line: %s", line);
#line 352 "../src/engine/imap/transport/imap-deserializer.vala"
		g_signal_emit (self, geary_imap_deserializer_signals[GEARY_IMAP_DESERIALIZER_BYTES_RECEIVED_SIGNAL], 0, bytes_read);
#line 353 "../src/engine/imap/transport/imap-deserializer.vala"
		geary_imap_deserializer_push_line (self, line, bytes_read);
#line 340 "../src/engine/imap/transport/imap-deserializer.vala"
		_g_free0 (line);
#line 1844 "imap-deserializer.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
#line 340 "../src/engine/imap/transport/imap-deserializer.vala"
		err = _inner_error0_;
#line 340 "../src/engine/imap/transport/imap-deserializer.vala"
		_inner_error0_ = NULL;
#line 355 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp3_ = err;
#line 355 "../src/engine/imap/transport/imap-deserializer.vala"
		geary_imap_deserializer_push_error (self, _tmp3_);
#line 356 "../src/engine/imap/transport/imap-deserializer.vala"
		_g_error_free0 (err);
#line 356 "../src/engine/imap/transport/imap-deserializer.vala"
		return;
#line 1863 "imap-deserializer.c"
	}
	__finally0:
#line 340 "../src/engine/imap/transport/imap-deserializer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 340 "../src/engine/imap/transport/imap-deserializer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 340 "../src/engine/imap/transport/imap-deserializer.vala"
		g_clear_error (&_inner_error0_);
#line 340 "../src/engine/imap/transport/imap-deserializer.vala"
		return;
#line 1874 "imap-deserializer.c"
	}
#line 359 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_next_deserialize_step (self);
#line 1878 "imap-deserializer.c"
}

static void
geary_imap_deserializer_on_read_block (GearyImapDeserializer* self,
                                       GObject* source,
                                       GAsyncResult* _result_)
{
	GError* _inner_error0_ = NULL;
#line 362 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_DESERIALIZER (self));
#line 362 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail ((source == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (source, G_TYPE_OBJECT));
#line 362 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (_result_, g_async_result_get_type ()));
#line 1893 "imap-deserializer.c"
	{
		gsize bytes_read = 0UL;
		GDataInputStream* _tmp0_;
		gboolean _tmp1_ = FALSE;
		GearyMemoryGrowableBuffer* _tmp2_;
		guint8* _tmp3_;
		gint _tmp3__length1;
#line 366 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp0_ = self->priv->input;
#line 366 "../src/engine/imap/transport/imap-deserializer.vala"
		bytes_read = (gsize) g_input_stream_read_finish (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_input_stream_get_type (), GInputStream), _result_, &_inner_error0_);
#line 366 "../src/engine/imap/transport/imap-deserializer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1907 "imap-deserializer.c"
			goto __catch0_g_error;
		}
#line 367 "../src/engine/imap/transport/imap-deserializer.vala"
		if (bytes_read == ((gsize) 0)) {
#line 367 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp1_ = self->priv->literal_length_remaining > ((gsize) 0);
#line 1914 "imap-deserializer.c"
		} else {
#line 367 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp1_ = FALSE;
#line 1918 "imap-deserializer.c"
		}
#line 367 "../src/engine/imap/transport/imap-deserializer.vala"
		if (_tmp1_) {
#line 368 "../src/engine/imap/transport/imap-deserializer.vala"
			geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Block EOS");
#line 370 "../src/engine/imap/transport/imap-deserializer.vala"
			geary_imap_deserializer_push_eos (self);
#line 372 "../src/engine/imap/transport/imap-deserializer.vala"
			return;
#line 1928 "imap-deserializer.c"
		}
#line 375 "../src/engine/imap/transport/imap-deserializer.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Block %lub", (gulong) bytes_read);
#line 376 "../src/engine/imap/transport/imap-deserializer.vala"
		g_signal_emit (self, geary_imap_deserializer_signals[GEARY_IMAP_DESERIALIZER_BYTES_RECEIVED_SIGNAL], 0, bytes_read);
#line 379 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp2_ = self->priv->block_buffer;
#line 379 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp3_ = self->priv->current_buffer;
#line 379 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp3__length1 = self->priv->current_buffer_length1;
#line 379 "../src/engine/imap/transport/imap-deserializer.vala"
		geary_memory_growable_buffer_trim (_tmp2_, _tmp3_, (gint) _tmp3__length1, bytes_read);
#line 381 "../src/engine/imap/transport/imap-deserializer.vala"
		geary_imap_deserializer_push_data (self, bytes_read);
#line 1944 "imap-deserializer.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp4_;
#line 363 "../src/engine/imap/transport/imap-deserializer.vala"
		err = _inner_error0_;
#line 363 "../src/engine/imap/transport/imap-deserializer.vala"
		_inner_error0_ = NULL;
#line 383 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp4_ = err;
#line 383 "../src/engine/imap/transport/imap-deserializer.vala"
		geary_imap_deserializer_push_error (self, _tmp4_);
#line 385 "../src/engine/imap/transport/imap-deserializer.vala"
		_g_error_free0 (err);
#line 385 "../src/engine/imap/transport/imap-deserializer.vala"
		return;
#line 1963 "imap-deserializer.c"
	}
	__finally0:
#line 363 "../src/engine/imap/transport/imap-deserializer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 363 "../src/engine/imap/transport/imap-deserializer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 363 "../src/engine/imap/transport/imap-deserializer.vala"
		g_clear_error (&_inner_error0_);
#line 363 "../src/engine/imap/transport/imap-deserializer.vala"
		return;
#line 1974 "imap-deserializer.c"
	}
#line 388 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_next_deserialize_step (self);
#line 1978 "imap-deserializer.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 1995 "imap-deserializer.c"
}

static void
geary_imap_deserializer_push_line (GearyImapDeserializer* self,
                                   const gchar* line,
                                   gsize count)
{
	GearyStateMachine* _tmp3_;
#line 394 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_DESERIALIZER (self));
#line 394 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (line != NULL);
#line 395 "../src/engine/imap/transport/imap-deserializer.vala"
	_vala_assert (geary_imap_deserializer_get_mode (self) == GEARY_IMAP_DESERIALIZER_MODE_LINE, "get_mode() == Mode.LINE");
#line 2010 "imap-deserializer.c"
	{
		glong ctr = 0L;
#line 397 "../src/engine/imap/transport/imap-deserializer.vala"
		ctr = (glong) 0;
#line 2015 "imap-deserializer.c"
		{
			gboolean _tmp0_ = FALSE;
#line 397 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp0_ = TRUE;
#line 397 "../src/engine/imap/transport/imap-deserializer.vala"
			while (TRUE) {
#line 2022 "imap-deserializer.c"
				gchar ch = '\0';
				GearyStateMachine* _tmp2_;
#line 397 "../src/engine/imap/transport/imap-deserializer.vala"
				if (!_tmp0_) {
#line 2027 "imap-deserializer.c"
					glong _tmp1_;
#line 397 "../src/engine/imap/transport/imap-deserializer.vala"
					_tmp1_ = ctr;
#line 397 "../src/engine/imap/transport/imap-deserializer.vala"
					ctr = _tmp1_ + 1;
#line 2033 "imap-deserializer.c"
				}
#line 397 "../src/engine/imap/transport/imap-deserializer.vala"
				_tmp0_ = FALSE;
#line 397 "../src/engine/imap/transport/imap-deserializer.vala"
				if (!(((gsize) ctr) < count)) {
#line 397 "../src/engine/imap/transport/imap-deserializer.vala"
					break;
#line 2041 "imap-deserializer.c"
				}
#line 398 "../src/engine/imap/transport/imap-deserializer.vala"
				ch = string_get (line, ctr);
#line 399 "../src/engine/imap/transport/imap-deserializer.vala"
				if (ch == '\0') {
#line 402 "../src/engine/imap/transport/imap-deserializer.vala"
					continue;
#line 2049 "imap-deserializer.c"
				}
#line 405 "../src/engine/imap/transport/imap-deserializer.vala"
				_tmp2_ = self->priv->fsm;
#line 405 "../src/engine/imap/transport/imap-deserializer.vala"
				if (geary_state_machine_issue (_tmp2_, (guint) GEARY_IMAP_DESERIALIZER_EVENT_CHAR, &ch, NULL, NULL) == ((guint) GEARY_IMAP_DESERIALIZER_STATE_FAILED)) {
#line 408 "../src/engine/imap/transport/imap-deserializer.vala"
					break;
#line 2057 "imap-deserializer.c"
				}
			}
		}
	}
#line 412 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp3_ = self->priv->fsm;
#line 412 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_state_machine_issue (_tmp3_, (guint) GEARY_IMAP_DESERIALIZER_EVENT_EOL, NULL, NULL, NULL);
#line 2066 "imap-deserializer.c"
}

static void
geary_imap_deserializer_push_data (GearyImapDeserializer* self,
                                   gsize bytes_read)
{
	GearyStateMachine* _tmp0_;
#line 416 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_DESERIALIZER (self));
#line 417 "../src/engine/imap/transport/imap-deserializer.vala"
	_vala_assert (geary_imap_deserializer_get_mode (self) == GEARY_IMAP_DESERIALIZER_MODE_BLOCK, "get_mode() == Mode.BLOCK");
#line 418 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp0_ = self->priv->fsm;
#line 418 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_state_machine_issue (_tmp0_, (guint) GEARY_IMAP_DESERIALIZER_EVENT_DATA, &bytes_read, NULL, NULL);
#line 2082 "imap-deserializer.c"
}

static void
geary_imap_deserializer_push_eos (GearyImapDeserializer* self)
{
	GearyStateMachine* _tmp0_;
#line 422 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_DESERIALIZER (self));
#line 423 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp0_ = self->priv->fsm;
#line 423 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_state_machine_issue (_tmp0_, (guint) GEARY_IMAP_DESERIALIZER_EVENT_EOS, NULL, NULL, NULL);
#line 2095 "imap-deserializer.c"
}

static void
geary_imap_deserializer_push_error (GearyImapDeserializer* self,
                                    GError* err)
{
	GearyStateMachine* _tmp0_;
#line 427 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_DESERIALIZER (self));
#line 427 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (err != NULL);
#line 428 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp0_ = self->priv->fsm;
#line 428 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_state_machine_issue (_tmp0_, (guint) GEARY_IMAP_DESERIALIZER_EVENT_ERROR, NULL, NULL, err);
#line 2111 "imap-deserializer.c"
}

static GearyImapDeserializerMode
geary_imap_deserializer_get_mode (GearyImapDeserializer* self)
{
	GearyStateMachine* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	GearyImapDeserializerMode result;
#line 431 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), 0);
#line 432 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp0_ = self->priv->fsm;
#line 432 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp1_ = geary_state_machine_get_state (_tmp0_);
#line 432 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp2_ = _tmp1_;
#line 432 "../src/engine/imap/transport/imap-deserializer.vala"
	switch (_tmp2_) {
#line 432 "../src/engine/imap/transport/imap-deserializer.vala"
		case GEARY_IMAP_DESERIALIZER_STATE_LITERAL_DATA:
#line 2133 "imap-deserializer.c"
		{
#line 434 "../src/engine/imap/transport/imap-deserializer.vala"
			result = GEARY_IMAP_DESERIALIZER_MODE_BLOCK;
#line 434 "../src/engine/imap/transport/imap-deserializer.vala"
			return result;
#line 2139 "imap-deserializer.c"
		}
#line 432 "../src/engine/imap/transport/imap-deserializer.vala"
		case GEARY_IMAP_DESERIALIZER_STATE_FAILED:
#line 2143 "imap-deserializer.c"
		{
#line 437 "../src/engine/imap/transport/imap-deserializer.vala"
			result = GEARY_IMAP_DESERIALIZER_MODE_FAILED;
#line 437 "../src/engine/imap/transport/imap-deserializer.vala"
			return result;
#line 2149 "imap-deserializer.c"
		}
#line 432 "../src/engine/imap/transport/imap-deserializer.vala"
		case GEARY_IMAP_DESERIALIZER_STATE_CLOSED:
#line 2153 "imap-deserializer.c"
		{
#line 440 "../src/engine/imap/transport/imap-deserializer.vala"
			result = GEARY_IMAP_DESERIALIZER_MODE_CLOSED;
#line 440 "../src/engine/imap/transport/imap-deserializer.vala"
			return result;
#line 2159 "imap-deserializer.c"
		}
		default:
		{
#line 443 "../src/engine/imap/transport/imap-deserializer.vala"
			result = GEARY_IMAP_DESERIALIZER_MODE_LINE;
#line 443 "../src/engine/imap/transport/imap-deserializer.vala"
			return result;
#line 2167 "imap-deserializer.c"
		}
	}
}

static inline gboolean
geary_imap_deserializer_is_current_string_empty (GearyImapDeserializer* self)
{
	gboolean _tmp0_ = FALSE;
	GString* _tmp1_;
	gboolean result;
#line 447 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), FALSE);
#line 448 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp1_ = self->priv->current_string;
#line 448 "../src/engine/imap/transport/imap-deserializer.vala"
	if (_tmp1_ == NULL) {
#line 449 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp0_ = TRUE;
#line 2186 "imap-deserializer.c"
	} else {
		GString* _tmp2_;
#line 449 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp2_ = self->priv->current_string;
#line 449 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp0_ = _tmp2_->len == ((gssize) 0);
#line 2193 "imap-deserializer.c"
	}
#line 448 "../src/engine/imap/transport/imap-deserializer.vala"
	result = _tmp0_;
#line 448 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 2199 "imap-deserializer.c"
}

static inline gboolean
geary_imap_deserializer_is_current_string_ci (GearyImapDeserializer* self,
                                              const gchar* cmp)
{
	gboolean _tmp0_ = FALSE;
	GString* _tmp1_;
	GString* _tmp5_;
	const gchar* _tmp6_;
	gboolean result;
#line 454 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), FALSE);
#line 454 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (cmp != NULL, FALSE);
#line 455 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp1_ = self->priv->current_string;
#line 455 "../src/engine/imap/transport/imap-deserializer.vala"
	if (_tmp1_ == NULL) {
#line 455 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp0_ = TRUE;
#line 2221 "imap-deserializer.c"
	} else {
		GString* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 456 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp2_ = self->priv->current_string;
#line 456 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp3_ = strlen (cmp);
#line 456 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp4_ = _tmp3_;
#line 456 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp0_ = _tmp2_->len != ((gssize) _tmp4_);
#line 2234 "imap-deserializer.c"
	}
#line 455 "../src/engine/imap/transport/imap-deserializer.vala"
	if (_tmp0_) {
#line 457 "../src/engine/imap/transport/imap-deserializer.vala"
		result = FALSE;
#line 457 "../src/engine/imap/transport/imap-deserializer.vala"
		return result;
#line 2242 "imap-deserializer.c"
	}
#line 460 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp5_ = self->priv->current_string;
#line 460 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp6_ = _tmp5_->str;
#line 460 "../src/engine/imap/transport/imap-deserializer.vala"
	result = geary_ascii_stri_equal (_tmp6_, cmp);
#line 460 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 2252 "imap-deserializer.c"
}

static inline void
geary_imap_deserializer_append_to_string (GearyImapDeserializer* self,
                                          gchar ch)
{
	GString* _tmp0_;
	GString* _tmp2_;
#line 463 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_DESERIALIZER (self));
#line 464 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp0_ = self->priv->current_string;
#line 464 "../src/engine/imap/transport/imap-deserializer.vala"
	if (_tmp0_ == NULL) {
#line 2267 "imap-deserializer.c"
		GString* _tmp1_;
#line 465 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp1_ = g_string_new ("");
#line 465 "../src/engine/imap/transport/imap-deserializer.vala"
		_g_string_free0 (self->priv->current_string);
#line 465 "../src/engine/imap/transport/imap-deserializer.vala"
		self->priv->current_string = _tmp1_;
#line 2275 "imap-deserializer.c"
	}
#line 468 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp2_ = self->priv->current_string;
#line 468 "../src/engine/imap/transport/imap-deserializer.vala"
	g_string_append_c (_tmp2_, ch);
#line 2281 "imap-deserializer.c"
}

static void
geary_imap_deserializer_save_string_parameter (GearyImapDeserializer* self,
                                               gboolean quoted)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gchar* str = NULL;
	gchar* _tmp6_;
#line 471 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_DESERIALIZER (self));
#line 473 "../src/engine/imap/transport/imap-deserializer.vala"
	if (!quoted) {
#line 473 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp0_ = geary_imap_deserializer_is_current_string_empty (self);
#line 2299 "imap-deserializer.c"
	} else {
#line 473 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp0_ = FALSE;
#line 2303 "imap-deserializer.c"
	}
#line 473 "../src/engine/imap/transport/imap-deserializer.vala"
	if (_tmp0_) {
#line 474 "../src/engine/imap/transport/imap-deserializer.vala"
		return;
#line 2309 "imap-deserializer.c"
	}
#line 477 "../src/engine/imap/transport/imap-deserializer.vala"
	if (quoted) {
#line 2313 "imap-deserializer.c"
		GString* _tmp3_;
#line 477 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp3_ = self->priv->current_string;
#line 477 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp2_ = _tmp3_ == NULL;
#line 2319 "imap-deserializer.c"
	} else {
#line 477 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp2_ = FALSE;
#line 2323 "imap-deserializer.c"
	}
#line 477 "../src/engine/imap/transport/imap-deserializer.vala"
	if (_tmp2_) {
#line 477 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp1_ = "";
#line 2329 "imap-deserializer.c"
	} else {
		GString* _tmp4_;
		const gchar* _tmp5_;
#line 477 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp4_ = self->priv->current_string;
#line 477 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp5_ = _tmp4_->str;
#line 477 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp1_ = _tmp5_;
#line 2339 "imap-deserializer.c"
	}
#line 477 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp6_ = g_strdup (_tmp1_);
#line 477 "../src/engine/imap/transport/imap-deserializer.vala"
	str = _tmp6_;
#line 479 "../src/engine/imap/transport/imap-deserializer.vala"
	if (quoted) {
#line 2347 "imap-deserializer.c"
		const gchar* _tmp7_;
		GearyImapQuotedStringParameter* _tmp8_;
		GearyImapQuotedStringParameter* _tmp9_;
#line 480 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp7_ = str;
#line 480 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp8_ = geary_imap_quoted_string_parameter_new (_tmp7_);
#line 480 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp9_ = _tmp8_;
#line 480 "../src/engine/imap/transport/imap-deserializer.vala"
		geary_imap_deserializer_save_parameter (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 480 "../src/engine/imap/transport/imap-deserializer.vala"
		_g_object_unref0 (_tmp9_);
#line 2361 "imap-deserializer.c"
	} else {
		const gchar* _tmp10_;
#line 481 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp10_ = str;
#line 481 "../src/engine/imap/transport/imap-deserializer.vala"
		if (geary_imap_number_parameter_is_ascii_numeric (_tmp10_, NULL)) {
#line 2368 "imap-deserializer.c"
			const gchar* _tmp11_;
			GearyImapNumberParameter* _tmp12_;
			GearyImapNumberParameter* _tmp13_;
#line 482 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp11_ = str;
#line 482 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp12_ = geary_imap_number_parameter_new_from_ascii (_tmp11_);
#line 482 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp13_ = _tmp12_;
#line 482 "../src/engine/imap/transport/imap-deserializer.vala"
			geary_imap_deserializer_save_parameter (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 482 "../src/engine/imap/transport/imap-deserializer.vala"
			_g_object_unref0 (_tmp13_);
#line 2382 "imap-deserializer.c"
		} else {
			const gchar* _tmp14_;
			GearyImapUnquotedStringParameter* _tmp15_;
			GearyImapUnquotedStringParameter* _tmp16_;
#line 484 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp14_ = str;
#line 484 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp15_ = geary_imap_unquoted_string_parameter_new (_tmp14_);
#line 484 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp16_ = _tmp15_;
#line 484 "../src/engine/imap/transport/imap-deserializer.vala"
			geary_imap_deserializer_save_parameter (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 484 "../src/engine/imap/transport/imap-deserializer.vala"
			_g_object_unref0 (_tmp16_);
#line 2397 "imap-deserializer.c"
		}
	}
#line 486 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_string_free0 (self->priv->current_string);
#line 486 "../src/engine/imap/transport/imap-deserializer.vala"
	self->priv->current_string = NULL;
#line 471 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_free0 (str);
#line 2406 "imap-deserializer.c"
}

static void
geary_imap_deserializer_save_literal_parameter (GearyImapDeserializer* self)
{
	GearyImapLiteralParameter* literal = NULL;
	GearyMemoryGrowableBuffer* _tmp0_;
	GearyImapLiteralParameter* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GearyImapLiteralParameter* _tmp9_;
#line 489 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_DESERIALIZER (self));
#line 490 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp0_ = self->priv->block_buffer;
#line 490 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp1_ = geary_imap_literal_parameter_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBuffer));
#line 490 "../src/engine/imap/transport/imap-deserializer.vala"
	literal = _tmp1_;
#line 491 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp2_ = geary_logging_source_get_logging_domain (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 491 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp3_ = _tmp2_;
#line 491 "../src/engine/imap/transport/imap-deserializer.vala"
	if (!geary_logging_is_suppressed_domain (_tmp3_)) {
#line 2432 "imap-deserializer.c"
		GearyImapLiteralParameter* _tmp4_;
		GearyImapStringParameter* _tmp5_;
		GearyImapStringParameter* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 492 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp4_ = literal;
#line 492 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp5_ = geary_imap_literal_parameter_coerce_to_string_parameter (_tmp4_);
#line 492 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp6_ = _tmp5_;
#line 492 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp7_ = geary_imap_parameter_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 492 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp8_ = _tmp7_;
#line 492 "../src/engine/imap/transport/imap-deserializer.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "%s", _tmp8_);
#line 492 "../src/engine/imap/transport/imap-deserializer.vala"
		_g_free0 (_tmp8_);
#line 492 "../src/engine/imap/transport/imap-deserializer.vala"
		_g_object_unref0 (_tmp6_);
#line 2454 "imap-deserializer.c"
	}
#line 494 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp9_ = literal;
#line 494 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_save_parameter (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 495 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_object_unref0 (self->priv->block_buffer);
#line 495 "../src/engine/imap/transport/imap-deserializer.vala"
	self->priv->block_buffer = NULL;
#line 489 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_object_unref0 (literal);
#line 2466 "imap-deserializer.c"
}

static void
geary_imap_deserializer_save_parameter (GearyImapDeserializer* self,
                                        GearyImapParameter* param)
{
	GearyImapListParameter* _tmp0_;
#line 498 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_DESERIALIZER (self));
#line 498 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_PARAMETER (param));
#line 499 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp0_ = self->priv->context;
#line 499 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_list_parameter_add (_tmp0_, param);
#line 2482 "imap-deserializer.c"
}

static void
geary_imap_deserializer_push (GearyImapDeserializer* self,
                              GearyImapListParameter* child)
{
	GearyImapListParameter* _tmp0_;
	GeeLinkedList* _tmp1_;
	GearyImapListParameter* _tmp2_;
#line 503 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_DESERIALIZER (self));
#line 503 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_LIST_PARAMETER (child));
#line 504 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp0_ = self->priv->context;
#line 504 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_list_parameter_add (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (child, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
#line 506 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp1_ = self->priv->context_stack;
#line 506 "../src/engine/imap/transport/imap-deserializer.vala"
	gee_abstract_list_insert (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), 0, child);
#line 507 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp2_ = _g_object_ref0 (child);
#line 507 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_object_unref0 (self->priv->context);
#line 507 "../src/engine/imap/transport/imap-deserializer.vala"
	self->priv->context = _tmp2_;
#line 2510 "imap-deserializer.c"
}

static gchar
geary_imap_deserializer_get_current_context_terminator (GearyImapDeserializer* self)
{
	gchar _tmp0_ = '\0';
	GearyImapListParameter* _tmp1_;
	gchar result;
#line 510 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), '\0');
#line 511 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp1_ = self->priv->context;
#line 511 "../src/engine/imap/transport/imap-deserializer.vala"
	if (GEARY_IMAP_IS_RESPONSE_CODE (_tmp1_)) {
#line 511 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp0_ = ']';
#line 2527 "imap-deserializer.c"
	} else {
#line 511 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp0_ = ')';
#line 2531 "imap-deserializer.c"
	}
#line 511 "../src/engine/imap/transport/imap-deserializer.vala"
	result = _tmp0_;
#line 511 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 2537 "imap-deserializer.c"
}

static GearyImapDeserializerState
geary_imap_deserializer_pop (GearyImapDeserializer* self)
{
	GearyImapDeserializerState ret = 0;
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GearyImapDeserializerState result;
#line 514 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), 0);
#line 515 "../src/engine/imap/transport/imap-deserializer.vala"
	ret = GEARY_IMAP_DESERIALIZER_STATE_START_PARAM;
#line 516 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp0_ = self->priv->context_stack;
#line 516 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp1_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 516 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp2_ = _tmp1_;
#line 516 "../src/engine/imap/transport/imap-deserializer.vala"
	if (_tmp2_ > 1) {
#line 2560 "imap-deserializer.c"
		GeeLinkedList* _tmp3_;
		gpointer _tmp4_;
		GearyImapListParameter* _tmp5_;
		GeeLinkedList* _tmp6_;
		gpointer _tmp7_;
#line 517 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp3_ = self->priv->context_stack;
#line 517 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp4_ = gee_abstract_list_remove_at (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), 0);
#line 517 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp5_ = (GearyImapListParameter*) _tmp4_;
#line 517 "../src/engine/imap/transport/imap-deserializer.vala"
		_g_object_unref0 (_tmp5_);
#line 518 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp6_ = self->priv->context_stack;
#line 518 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp7_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), 0);
#line 518 "../src/engine/imap/transport/imap-deserializer.vala"
		_g_object_unref0 (self->priv->context);
#line 518 "../src/engine/imap/transport/imap-deserializer.vala"
		self->priv->context = (GearyImapListParameter*) _tmp7_;
#line 2582 "imap-deserializer.c"
	} else {
#line 520 "../src/engine/imap/transport/imap-deserializer.vala"
		geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Attempt to close unopened list/response code");
#line 521 "../src/engine/imap/transport/imap-deserializer.vala"
		ret = GEARY_IMAP_DESERIALIZER_STATE_FAILED;
#line 2588 "imap-deserializer.c"
	}
#line 523 "../src/engine/imap/transport/imap-deserializer.vala"
	result = ret;
#line 523 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 2594 "imap-deserializer.c"
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 2603 "imap-deserializer.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 2611 "imap-deserializer.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 2620 "imap-deserializer.c"
	}
}

static void
geary_imap_deserializer_flush_params (GearyImapDeserializer* self)
{
	gboolean okay = FALSE;
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp6_ = FALSE;
#line 526 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_DESERIALIZER (self));
#line 527 "../src/engine/imap/transport/imap-deserializer.vala"
	okay = TRUE;
#line 528 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp0_ = self->priv->context_stack;
#line 528 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp1_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 528 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp2_ = _tmp1_;
#line 528 "../src/engine/imap/transport/imap-deserializer.vala"
	if (_tmp2_ > 1) {
#line 529 "../src/engine/imap/transport/imap-deserializer.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Unclosed list in parameters");
#line 530 "../src/engine/imap/transport/imap-deserializer.vala"
		okay = FALSE;
#line 2649 "imap-deserializer.c"
	}
#line 533 "../src/engine/imap/transport/imap-deserializer.vala"
	if (!geary_imap_deserializer_is_current_string_empty (self)) {
#line 533 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp3_ = TRUE;
#line 2655 "imap-deserializer.c"
	} else {
#line 533 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp3_ = self->priv->literal_length_remaining > ((gsize) 0);
#line 2659 "imap-deserializer.c"
	}
#line 533 "../src/engine/imap/transport/imap-deserializer.vala"
	if (_tmp3_) {
#line 2663 "imap-deserializer.c"
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 534 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp4_ = bool_to_string (!geary_imap_deserializer_is_current_string_empty (self));
#line 534 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp5_ = _tmp4_;
#line 534 "../src/engine/imap/transport/imap-deserializer.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Unfinished parameter: string=%s literal remaining=%lu", _tmp5_, (gulong) self->priv->literal_length_remaining);
#line 534 "../src/engine/imap/transport/imap-deserializer.vala"
		_g_free0 (_tmp5_);
#line 539 "../src/engine/imap/transport/imap-deserializer.vala"
		okay = FALSE;
#line 2676 "imap-deserializer.c"
	}
#line 542 "../src/engine/imap/transport/imap-deserializer.vala"
	if (okay) {
#line 2680 "imap-deserializer.c"
		GearyImapListParameter* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
#line 542 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp7_ = self->priv->context;
#line 542 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp8_ = geary_imap_list_parameter_get_size (_tmp7_);
#line 542 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp9_ = _tmp8_;
#line 542 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp6_ = _tmp9_ > 0;
#line 2692 "imap-deserializer.c"
	} else {
#line 542 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp6_ = FALSE;
#line 2696 "imap-deserializer.c"
	}
#line 542 "../src/engine/imap/transport/imap-deserializer.vala"
	if (_tmp6_) {
#line 2700 "imap-deserializer.c"
		GearyImapListParameter* _tmp10_;
#line 543 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp10_ = self->priv->context;
#line 543 "../src/engine/imap/transport/imap-deserializer.vala"
		g_signal_emit (self, geary_imap_deserializer_signals[GEARY_IMAP_DESERIALIZER_PARAMETERS_READY_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEARY_IMAP_TYPE_ROOT_PARAMETERS, GearyImapRootParameters));
#line 2706 "imap-deserializer.c"
	}
#line 546 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_reset_params (self);
#line 2710 "imap-deserializer.c"
}

static void
geary_imap_deserializer_reset_params (GearyImapDeserializer* self)
{
	GearyImapRootParameters* _tmp0_;
	GeeLinkedList* _tmp1_;
	GeeLinkedList* _tmp2_;
	GearyImapListParameter* _tmp3_;
#line 549 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_if_fail (GEARY_IMAP_IS_DESERIALIZER (self));
#line 550 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp0_ = geary_imap_root_parameters_new ();
#line 550 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_object_unref0 (self->priv->context);
#line 550 "../src/engine/imap/transport/imap-deserializer.vala"
	self->priv->context = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_IMAP_TYPE_LIST_PARAMETER, GearyImapListParameter);
#line 551 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp1_ = self->priv->context_stack;
#line 551 "../src/engine/imap/transport/imap-deserializer.vala"
	gee_abstract_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 552 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp2_ = self->priv->context_stack;
#line 552 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp3_ = self->priv->context;
#line 552 "../src/engine/imap/transport/imap-deserializer.vala"
	gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp3_);
#line 2738 "imap-deserializer.c"
}

static gboolean
_vala_string_array_contains (const gchar* * stack,
                             gssize stack_length,
                             const const gchar* needle)
{
	gssize i;
#line 622 "../src/engine/imap/transport/imap-deserializer.vala"
	for (i = 0; i < stack_length; i++) {
#line 622 "../src/engine/imap/transport/imap-deserializer.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 622 "../src/engine/imap/transport/imap-deserializer.vala"
			return TRUE;
#line 2753 "imap-deserializer.c"
		}
	}
#line 622 "../src/engine/imap/transport/imap-deserializer.vala"
	return FALSE;
#line 2758 "imap-deserializer.c"
}

static guint
geary_imap_deserializer_on_first_param_char (GearyImapDeserializer* self,
                                             guint state,
                                             guint event,
                                             void* user)
{
	gchar ch = '\0';
	guint result;
#line 559 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), 0U);
#line 562 "../src/engine/imap/transport/imap-deserializer.vala"
	ch = *((gchar*) user);
#line 563 "../src/engine/imap/transport/imap-deserializer.vala"
	switch (ch) {
#line 563 "../src/engine/imap/transport/imap-deserializer.vala"
		case '[':
#line 2777 "imap-deserializer.c"
		{
			GearyImapResponseCode* response_code = NULL;
			GearyImapResponseCode* _tmp0_;
			GearyImapResponseCode* _tmp1_;
#line 566 "../src/engine/imap/transport/imap-deserializer.vala"
			if (self->priv->is_parsing_flags) {
#line 567 "../src/engine/imap/transport/imap-deserializer.vala"
				geary_imap_deserializer_append_to_string (self, ch);
#line 568 "../src/engine/imap/transport/imap-deserializer.vala"
				result = (guint) GEARY_IMAP_DESERIALIZER_STATE_FLAG;
#line 568 "../src/engine/imap/transport/imap-deserializer.vala"
				return result;
#line 2790 "imap-deserializer.c"
			}
#line 572 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp0_ = geary_imap_response_code_new ();
#line 572 "../src/engine/imap/transport/imap-deserializer.vala"
			response_code = _tmp0_;
#line 573 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp1_ = response_code;
#line 573 "../src/engine/imap/transport/imap-deserializer.vala"
			geary_imap_deserializer_push (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_IMAP_TYPE_LIST_PARAMETER, GearyImapListParameter));
#line 574 "../src/engine/imap/transport/imap-deserializer.vala"
			result = (guint) GEARY_IMAP_DESERIALIZER_STATE_START_PARAM;
#line 574 "../src/engine/imap/transport/imap-deserializer.vala"
			_g_object_unref0 (response_code);
#line 574 "../src/engine/imap/transport/imap-deserializer.vala"
			return result;
#line 2806 "imap-deserializer.c"
		}
#line 563 "../src/engine/imap/transport/imap-deserializer.vala"
		case ']':
#line 2810 "imap-deserializer.c"
		{
#line 577 "../src/engine/imap/transport/imap-deserializer.vala"
			if (ch != geary_imap_deserializer_get_current_context_terminator (self)) {
#line 578 "../src/engine/imap/transport/imap-deserializer.vala"
				if (state == ((guint) GEARY_IMAP_DESERIALIZER_STATE_ATOM)) {
#line 581 "../src/engine/imap/transport/imap-deserializer.vala"
					geary_imap_deserializer_append_to_string (self, ch);
#line 582 "../src/engine/imap/transport/imap-deserializer.vala"
					result = (guint) GEARY_IMAP_DESERIALIZER_STATE_ATOM;
#line 582 "../src/engine/imap/transport/imap-deserializer.vala"
					return result;
#line 2822 "imap-deserializer.c"
				}
#line 584 "../src/engine/imap/transport/imap-deserializer.vala"
				geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Received an unexpected closing brace");
#line 585 "../src/engine/imap/transport/imap-deserializer.vala"
				result = (guint) GEARY_IMAP_DESERIALIZER_STATE_FAILED;
#line 585 "../src/engine/imap/transport/imap-deserializer.vala"
				return result;
#line 2830 "imap-deserializer.c"
			}
#line 587 "../src/engine/imap/transport/imap-deserializer.vala"
			result = (guint) geary_imap_deserializer_pop (self);
#line 587 "../src/engine/imap/transport/imap-deserializer.vala"
			return result;
#line 2836 "imap-deserializer.c"
		}
#line 563 "../src/engine/imap/transport/imap-deserializer.vala"
		case '{':
#line 2840 "imap-deserializer.c"
		{
#line 590 "../src/engine/imap/transport/imap-deserializer.vala"
			result = (guint) GEARY_IMAP_DESERIALIZER_STATE_LITERAL;
#line 590 "../src/engine/imap/transport/imap-deserializer.vala"
			return result;
#line 2846 "imap-deserializer.c"
		}
#line 563 "../src/engine/imap/transport/imap-deserializer.vala"
		case '\"':
#line 2850 "imap-deserializer.c"
		{
#line 593 "../src/engine/imap/transport/imap-deserializer.vala"
			result = (guint) GEARY_IMAP_DESERIALIZER_STATE_QUOTED;
#line 593 "../src/engine/imap/transport/imap-deserializer.vala"
			return result;
#line 2856 "imap-deserializer.c"
		}
#line 563 "../src/engine/imap/transport/imap-deserializer.vala"
		case '(':
#line 2860 "imap-deserializer.c"
		{
			GearyImapListParameter* list = NULL;
			GearyImapListParameter* _tmp2_;
			GearyImapListParameter* _tmp3_;
#line 597 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp2_ = geary_imap_list_parameter_new ();
#line 597 "../src/engine/imap/transport/imap-deserializer.vala"
			list = _tmp2_;
#line 598 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp3_ = list;
#line 598 "../src/engine/imap/transport/imap-deserializer.vala"
			geary_imap_deserializer_push (self, _tmp3_);
#line 599 "../src/engine/imap/transport/imap-deserializer.vala"
			result = (guint) GEARY_IMAP_DESERIALIZER_STATE_START_PARAM;
#line 599 "../src/engine/imap/transport/imap-deserializer.vala"
			_g_object_unref0 (list);
#line 599 "../src/engine/imap/transport/imap-deserializer.vala"
			return result;
#line 2879 "imap-deserializer.c"
		}
#line 563 "../src/engine/imap/transport/imap-deserializer.vala"
		case ')':
#line 2883 "imap-deserializer.c"
		{
#line 602 "../src/engine/imap/transport/imap-deserializer.vala"
			if (ch != geary_imap_deserializer_get_current_context_terminator (self)) {
#line 603 "../src/engine/imap/transport/imap-deserializer.vala"
				geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Received an unexpected closing parens");
#line 604 "../src/engine/imap/transport/imap-deserializer.vala"
				result = (guint) GEARY_IMAP_DESERIALIZER_STATE_FAILED;
#line 604 "../src/engine/imap/transport/imap-deserializer.vala"
				return result;
#line 2893 "imap-deserializer.c"
			}
#line 606 "../src/engine/imap/transport/imap-deserializer.vala"
			self->priv->is_parsing_flags = FALSE;
#line 607 "../src/engine/imap/transport/imap-deserializer.vala"
			result = (guint) geary_imap_deserializer_pop (self);
#line 607 "../src/engine/imap/transport/imap-deserializer.vala"
			return result;
#line 2901 "imap-deserializer.c"
		}
#line 563 "../src/engine/imap/transport/imap-deserializer.vala"
		case '\\':
#line 2905 "imap-deserializer.c"
		{
#line 611 "../src/engine/imap/transport/imap-deserializer.vala"
			geary_imap_deserializer_append_to_string (self, ch);
#line 612 "../src/engine/imap/transport/imap-deserializer.vala"
			self->priv->is_parsing_flags = TRUE;
#line 613 "../src/engine/imap/transport/imap-deserializer.vala"
			result = (guint) GEARY_IMAP_DESERIALIZER_STATE_FLAG;
#line 613 "../src/engine/imap/transport/imap-deserializer.vala"
			return result;
#line 2915 "imap-deserializer.c"
		}
#line 563 "../src/engine/imap/transport/imap-deserializer.vala"
		case ' ':
#line 2919 "imap-deserializer.c"
		{
#line 617 "../src/engine/imap/transport/imap-deserializer.vala"
			result = (guint) GEARY_IMAP_DESERIALIZER_STATE_START_PARAM;
#line 617 "../src/engine/imap/transport/imap-deserializer.vala"
			return result;
#line 2925 "imap-deserializer.c"
		}
		default:
		{
			gboolean _tmp4_ = FALSE;
			gboolean _tmp5_ = FALSE;
			GeeLinkedList* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
#line 620 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp6_ = self->priv->context_stack;
#line 620 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp7_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 620 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp8_ = _tmp7_;
#line 620 "../src/engine/imap/transport/imap-deserializer.vala"
			if (_tmp8_ == 1) {
#line 2942 "imap-deserializer.c"
				GearyImapListParameter* _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
#line 621 "../src/engine/imap/transport/imap-deserializer.vala"
				_tmp9_ = self->priv->context;
#line 621 "../src/engine/imap/transport/imap-deserializer.vala"
				_tmp10_ = geary_imap_list_parameter_get_size (_tmp9_);
#line 621 "../src/engine/imap/transport/imap-deserializer.vala"
				_tmp11_ = _tmp10_;
#line 621 "../src/engine/imap/transport/imap-deserializer.vala"
				_tmp5_ = _tmp11_ >= 2;
#line 2954 "imap-deserializer.c"
			} else {
#line 620 "../src/engine/imap/transport/imap-deserializer.vala"
				_tmp5_ = FALSE;
#line 2958 "imap-deserializer.c"
			}
#line 620 "../src/engine/imap/transport/imap-deserializer.vala"
			if (_tmp5_) {
#line 2962 "imap-deserializer.c"
				GearyImapListParameter* _tmp12_;
				GearyImapParameter* _tmp13_;
				GearyImapParameter* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
#line 622 "../src/engine/imap/transport/imap-deserializer.vala"
				_tmp12_ = self->priv->context;
#line 622 "../src/engine/imap/transport/imap-deserializer.vala"
				_tmp13_ = geary_imap_list_parameter_get (_tmp12_, 1);
#line 622 "../src/engine/imap/transport/imap-deserializer.vala"
				_tmp14_ = _tmp13_;
#line 622 "../src/engine/imap/transport/imap-deserializer.vala"
				_tmp15_ = geary_imap_parameter_to_string (_tmp14_);
#line 622 "../src/engine/imap/transport/imap-deserializer.vala"
				_tmp16_ = _tmp15_;
#line 622 "../src/engine/imap/transport/imap-deserializer.vala"
				_tmp17_ = g_ascii_strup (_tmp16_, (gssize) -1);
#line 622 "../src/engine/imap/transport/imap-deserializer.vala"
				_tmp18_ = _tmp17_;
#line 622 "../src/engine/imap/transport/imap-deserializer.vala"
				_tmp4_ = _vala_string_array_contains (GEARY_IMAP_DESERIALIZER_RESPONSE_ATOMS, G_N_ELEMENTS (GEARY_IMAP_DESERIALIZER_RESPONSE_ATOMS), _tmp18_);
#line 622 "../src/engine/imap/transport/imap-deserializer.vala"
				_g_free0 (_tmp18_);
#line 622 "../src/engine/imap/transport/imap-deserializer.vala"
				_g_free0 (_tmp16_);
#line 622 "../src/engine/imap/transport/imap-deserializer.vala"
				_g_object_unref0 (_tmp14_);
#line 2992 "imap-deserializer.c"
			} else {
#line 620 "../src/engine/imap/transport/imap-deserializer.vala"
				_tmp4_ = FALSE;
#line 2996 "imap-deserializer.c"
			}
#line 620 "../src/engine/imap/transport/imap-deserializer.vala"
			if (_tmp4_) {
#line 623 "../src/engine/imap/transport/imap-deserializer.vala"
				geary_imap_deserializer_append_to_string (self, ch);
#line 624 "../src/engine/imap/transport/imap-deserializer.vala"
				result = (guint) GEARY_IMAP_DESERIALIZER_STATE_RESPONSE_TEXT;
#line 624 "../src/engine/imap/transport/imap-deserializer.vala"
				return result;
#line 3006 "imap-deserializer.c"
			} else {
#line 625 "../src/engine/imap/transport/imap-deserializer.vala"
				if (!self->priv->is_parsing_flags) {
#line 626 "../src/engine/imap/transport/imap-deserializer.vala"
					if (geary_imap_data_format_is_atom_special (ch, NULL)) {
#line 627 "../src/engine/imap/transport/imap-deserializer.vala"
						geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Received an invalid atom-char: %c", (gint) ch);
#line 628 "../src/engine/imap/transport/imap-deserializer.vala"
						result = (guint) GEARY_IMAP_DESERIALIZER_STATE_FAILED;
#line 628 "../src/engine/imap/transport/imap-deserializer.vala"
						return result;
#line 3018 "imap-deserializer.c"
					}
#line 630 "../src/engine/imap/transport/imap-deserializer.vala"
					geary_imap_deserializer_append_to_string (self, ch);
#line 631 "../src/engine/imap/transport/imap-deserializer.vala"
					result = (guint) GEARY_IMAP_DESERIALIZER_STATE_ATOM;
#line 631 "../src/engine/imap/transport/imap-deserializer.vala"
					return result;
#line 3026 "imap-deserializer.c"
				} else {
					GearyImapQuirks* _tmp19_;
					const gchar* _tmp20_;
					const gchar* _tmp21_;
#line 633 "../src/engine/imap/transport/imap-deserializer.vala"
					_tmp19_ = self->priv->_quirks;
#line 633 "../src/engine/imap/transport/imap-deserializer.vala"
					_tmp20_ = geary_imap_quirks_get_flag_atom_exceptions (_tmp19_);
#line 633 "../src/engine/imap/transport/imap-deserializer.vala"
					_tmp21_ = _tmp20_;
#line 633 "../src/engine/imap/transport/imap-deserializer.vala"
					if (geary_imap_data_format_is_atom_special (ch, _tmp21_)) {
#line 635 "../src/engine/imap/transport/imap-deserializer.vala"
						geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Received an invalid flag-char: %c", (gint) ch);
#line 636 "../src/engine/imap/transport/imap-deserializer.vala"
						result = (guint) GEARY_IMAP_DESERIALIZER_STATE_FAILED;
#line 636 "../src/engine/imap/transport/imap-deserializer.vala"
						return result;
#line 3045 "imap-deserializer.c"
					}
#line 638 "../src/engine/imap/transport/imap-deserializer.vala"
					geary_imap_deserializer_append_to_string (self, ch);
#line 639 "../src/engine/imap/transport/imap-deserializer.vala"
					result = (guint) GEARY_IMAP_DESERIALIZER_STATE_FLAG;
#line 639 "../src/engine/imap/transport/imap-deserializer.vala"
					return result;
#line 3053 "imap-deserializer.c"
				}
			}
		}
	}
}

static guint
geary_imap_deserializer_on_tag_char (GearyImapDeserializer* self,
                                     guint state,
                                     guint event,
                                     void* user)
{
	gchar ch = '\0';
	gboolean _tmp0_ = FALSE;
	guint result;
#line 644 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), 0U);
#line 645 "../src/engine/imap/transport/imap-deserializer.vala"
	ch = *((gchar*) user);
#line 647 "../src/engine/imap/transport/imap-deserializer.vala"
	if (geary_imap_deserializer_is_current_string_empty (self)) {
#line 3075 "imap-deserializer.c"
		gboolean _tmp1_ = FALSE;
#line 648 "../src/engine/imap/transport/imap-deserializer.vala"
		if (ch == '*') {
#line 648 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp1_ = TRUE;
#line 3081 "imap-deserializer.c"
		} else {
#line 648 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp1_ = ch == '+';
#line 3085 "imap-deserializer.c"
		}
#line 648 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp0_ = _tmp1_;
#line 3089 "imap-deserializer.c"
	} else {
#line 647 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp0_ = FALSE;
#line 3093 "imap-deserializer.c"
	}
#line 647 "../src/engine/imap/transport/imap-deserializer.vala"
	if (_tmp0_) {
#line 651 "../src/engine/imap/transport/imap-deserializer.vala"
		geary_imap_deserializer_append_to_string (self, ch);
#line 652 "../src/engine/imap/transport/imap-deserializer.vala"
		result = (guint) GEARY_IMAP_DESERIALIZER_STATE_TAG;
#line 652 "../src/engine/imap/transport/imap-deserializer.vala"
		return result;
#line 3103 "imap-deserializer.c"
	}
#line 657 "../src/engine/imap/transport/imap-deserializer.vala"
	if (geary_imap_data_format_is_tag_special (ch, NULL)) {
#line 658 "../src/engine/imap/transport/imap-deserializer.vala"
		geary_imap_deserializer_save_string_parameter (self, FALSE);
#line 659 "../src/engine/imap/transport/imap-deserializer.vala"
		result = geary_imap_deserializer_on_first_param_char (self, state, event, user);
#line 659 "../src/engine/imap/transport/imap-deserializer.vala"
		return result;
#line 3113 "imap-deserializer.c"
	}
#line 662 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_append_to_string (self, ch);
#line 663 "../src/engine/imap/transport/imap-deserializer.vala"
	result = (guint) GEARY_IMAP_DESERIALIZER_STATE_TAG;
#line 663 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 3121 "imap-deserializer.c"
}

static guint
geary_imap_deserializer_on_atom_char (GearyImapDeserializer* self,
                                      guint state,
                                      guint event,
                                      void* user)
{
	gchar ch = '\0';
	gboolean _tmp0_ = FALSE;
	guint result;
#line 666 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), 0U);
#line 667 "../src/engine/imap/transport/imap-deserializer.vala"
	ch = *((gchar*) user);
#line 672 "../src/engine/imap/transport/imap-deserializer.vala"
	if (ch == '[') {
#line 3139 "imap-deserializer.c"
		gboolean _tmp1_ = FALSE;
#line 672 "../src/engine/imap/transport/imap-deserializer.vala"
		if (geary_imap_deserializer_is_current_string_ci (self, "body")) {
#line 672 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp1_ = TRUE;
#line 3145 "imap-deserializer.c"
		} else {
#line 672 "../src/engine/imap/transport/imap-deserializer.vala"
			_tmp1_ = geary_imap_deserializer_is_current_string_ci (self, "body.peek");
#line 3149 "imap-deserializer.c"
		}
#line 672 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp0_ = _tmp1_;
#line 3153 "imap-deserializer.c"
	} else {
#line 672 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp0_ = FALSE;
#line 3157 "imap-deserializer.c"
	}
#line 672 "../src/engine/imap/transport/imap-deserializer.vala"
	if (_tmp0_) {
#line 673 "../src/engine/imap/transport/imap-deserializer.vala"
		geary_imap_deserializer_append_to_string (self, ch);
#line 674 "../src/engine/imap/transport/imap-deserializer.vala"
		result = (guint) GEARY_IMAP_DESERIALIZER_STATE_PARTIAL_BODY_ATOM;
#line 674 "../src/engine/imap/transport/imap-deserializer.vala"
		return result;
#line 3167 "imap-deserializer.c"
	}
#line 679 "../src/engine/imap/transport/imap-deserializer.vala"
	if (geary_imap_data_format_is_atom_special (ch, NULL)) {
#line 680 "../src/engine/imap/transport/imap-deserializer.vala"
		geary_imap_deserializer_save_string_parameter (self, FALSE);
#line 681 "../src/engine/imap/transport/imap-deserializer.vala"
		result = geary_imap_deserializer_on_first_param_char (self, state, event, user);
#line 681 "../src/engine/imap/transport/imap-deserializer.vala"
		return result;
#line 3177 "imap-deserializer.c"
	}
#line 684 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_append_to_string (self, ch);
#line 685 "../src/engine/imap/transport/imap-deserializer.vala"
	result = (guint) GEARY_IMAP_DESERIALIZER_STATE_ATOM;
#line 685 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 3185 "imap-deserializer.c"
}

static guint
geary_imap_deserializer_on_flag_char (GearyImapDeserializer* self,
                                      guint state,
                                      guint event,
                                      void* user)
{
	gchar ch = '\0';
	GearyImapQuirks* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	guint result;
#line 691 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), 0U);
#line 692 "../src/engine/imap/transport/imap-deserializer.vala"
	ch = *((gchar*) user);
#line 694 "../src/engine/imap/transport/imap-deserializer.vala"
	if (geary_imap_deserializer_is_current_string_ci (self, "\\")) {
#line 3205 "imap-deserializer.c"
		GearyImapQuirks* _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 699 "../src/engine/imap/transport/imap-deserializer.vala"
		if (ch == '*') {
#line 700 "../src/engine/imap/transport/imap-deserializer.vala"
			geary_imap_deserializer_append_to_string (self, ch);
#line 701 "../src/engine/imap/transport/imap-deserializer.vala"
			geary_imap_deserializer_save_string_parameter (self, FALSE);
#line 702 "../src/engine/imap/transport/imap-deserializer.vala"
			result = (guint) GEARY_IMAP_DESERIALIZER_STATE_START_PARAM;
#line 702 "../src/engine/imap/transport/imap-deserializer.vala"
			return result;
#line 3219 "imap-deserializer.c"
		}
#line 709 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp0_ = self->priv->_quirks;
#line 709 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp1_ = geary_imap_quirks_get_flag_atom_exceptions (_tmp0_);
#line 709 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp2_ = _tmp1_;
#line 709 "../src/engine/imap/transport/imap-deserializer.vala"
		if (geary_imap_data_format_is_atom_special (ch, _tmp2_)) {
#line 710 "../src/engine/imap/transport/imap-deserializer.vala"
			geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Empty flag atom");
#line 711 "../src/engine/imap/transport/imap-deserializer.vala"
			result = (guint) GEARY_IMAP_DESERIALIZER_STATE_FAILED;
#line 711 "../src/engine/imap/transport/imap-deserializer.vala"
			return result;
#line 3235 "imap-deserializer.c"
		}
	}
#line 717 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp3_ = self->priv->_quirks;
#line 717 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp4_ = geary_imap_quirks_get_flag_atom_exceptions (_tmp3_);
#line 717 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp5_ = _tmp4_;
#line 717 "../src/engine/imap/transport/imap-deserializer.vala"
	if (geary_imap_data_format_is_atom_special (ch, _tmp5_)) {
#line 718 "../src/engine/imap/transport/imap-deserializer.vala"
		geary_imap_deserializer_save_string_parameter (self, FALSE);
#line 719 "../src/engine/imap/transport/imap-deserializer.vala"
		result = geary_imap_deserializer_on_first_param_char (self, state, event, user);
#line 719 "../src/engine/imap/transport/imap-deserializer.vala"
		return result;
#line 3252 "imap-deserializer.c"
	}
#line 723 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_append_to_string (self, ch);
#line 724 "../src/engine/imap/transport/imap-deserializer.vala"
	result = (guint) GEARY_IMAP_DESERIALIZER_STATE_FLAG;
#line 724 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 3260 "imap-deserializer.c"
}

static guint
geary_imap_deserializer_on_eol (GearyImapDeserializer* self,
                                guint state,
                                guint event,
                                void* user)
{
	guint result;
#line 727 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), 0U);
#line 728 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_flush_params (self);
#line 729 "../src/engine/imap/transport/imap-deserializer.vala"
	result = (guint) GEARY_IMAP_DESERIALIZER_STATE_TAG;
#line 729 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 3278 "imap-deserializer.c"
}

static guint
geary_imap_deserializer_on_param_eol (GearyImapDeserializer* self,
                                      guint state,
                                      guint event,
                                      void* user)
{
	guint result;
#line 732 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), 0U);
#line 734 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_save_string_parameter (self, FALSE);
#line 735 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_flush_params (self);
#line 736 "../src/engine/imap/transport/imap-deserializer.vala"
	result = (guint) GEARY_IMAP_DESERIALIZER_STATE_TAG;
#line 736 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 3298 "imap-deserializer.c"
}

static guint
geary_imap_deserializer_on_failed_eol (GearyImapDeserializer* self,
                                       guint state,
                                       guint event,
                                       void* user)
{
	guint result;
#line 739 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), 0U);
#line 743 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Syntax error, dropping");
#line 744 "../src/engine/imap/transport/imap-deserializer.vala"
	g_signal_emit (self, geary_imap_deserializer_signals[GEARY_IMAP_DESERIALIZER_DESERIALIZE_FAILURE_SIGNAL], 0);
#line 745 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_reset_params (self);
#line 746 "../src/engine/imap/transport/imap-deserializer.vala"
	result = (guint) GEARY_IMAP_DESERIALIZER_STATE_TAG;
#line 746 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 3320 "imap-deserializer.c"
}

static guint
geary_imap_deserializer_on_quoted_char (GearyImapDeserializer* self,
                                        guint state,
                                        guint event,
                                        void* user)
{
	gchar ch = '\0';
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	guint result;
#line 749 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), 0U);
#line 750 "../src/engine/imap/transport/imap-deserializer.vala"
	ch = *((gchar*) user);
#line 753 "../src/engine/imap/transport/imap-deserializer.vala"
	if (((gint) ch) > 0x7F) {
#line 753 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp2_ = TRUE;
#line 3342 "imap-deserializer.c"
	} else {
#line 753 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp2_ = ch == '\0';
#line 3346 "imap-deserializer.c"
	}
#line 753 "../src/engine/imap/transport/imap-deserializer.vala"
	if (_tmp2_) {
#line 753 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp1_ = TRUE;
#line 3352 "imap-deserializer.c"
	} else {
#line 753 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp1_ = ch == '\r';
#line 3356 "imap-deserializer.c"
	}
#line 753 "../src/engine/imap/transport/imap-deserializer.vala"
	if (_tmp1_) {
#line 753 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp0_ = TRUE;
#line 3362 "imap-deserializer.c"
	} else {
#line 753 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp0_ = ch == '\n';
#line 3366 "imap-deserializer.c"
	}
#line 753 "../src/engine/imap/transport/imap-deserializer.vala"
	if (_tmp0_) {
#line 754 "../src/engine/imap/transport/imap-deserializer.vala"
		result = (guint) GEARY_IMAP_DESERIALIZER_STATE_QUOTED;
#line 754 "../src/engine/imap/transport/imap-deserializer.vala"
		return result;
#line 3374 "imap-deserializer.c"
	}
#line 757 "../src/engine/imap/transport/imap-deserializer.vala"
	if (ch == '\\') {
#line 758 "../src/engine/imap/transport/imap-deserializer.vala"
		result = (guint) GEARY_IMAP_DESERIALIZER_STATE_QUOTED_ESCAPE;
#line 758 "../src/engine/imap/transport/imap-deserializer.vala"
		return result;
#line 3382 "imap-deserializer.c"
	}
#line 761 "../src/engine/imap/transport/imap-deserializer.vala"
	if (ch == '\"') {
#line 762 "../src/engine/imap/transport/imap-deserializer.vala"
		geary_imap_deserializer_save_string_parameter (self, TRUE);
#line 764 "../src/engine/imap/transport/imap-deserializer.vala"
		result = (guint) GEARY_IMAP_DESERIALIZER_STATE_START_PARAM;
#line 764 "../src/engine/imap/transport/imap-deserializer.vala"
		return result;
#line 3392 "imap-deserializer.c"
	}
#line 767 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_append_to_string (self, ch);
#line 769 "../src/engine/imap/transport/imap-deserializer.vala"
	result = (guint) GEARY_IMAP_DESERIALIZER_STATE_QUOTED;
#line 769 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 3400 "imap-deserializer.c"
}

static guint
geary_imap_deserializer_on_quoted_escape_char (GearyImapDeserializer* self,
                                               guint state,
                                               guint event,
                                               void* user)
{
	gchar ch = '\0';
	guint result;
#line 772 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), 0U);
#line 773 "../src/engine/imap/transport/imap-deserializer.vala"
	ch = *((gchar*) user);
#line 777 "../src/engine/imap/transport/imap-deserializer.vala"
	switch (ch) {
#line 777 "../src/engine/imap/transport/imap-deserializer.vala"
		case '\"':
#line 777 "../src/engine/imap/transport/imap-deserializer.vala"
		case '\\':
#line 3421 "imap-deserializer.c"
		{
#line 780 "../src/engine/imap/transport/imap-deserializer.vala"
			geary_imap_deserializer_append_to_string (self, ch);
#line 781 "../src/engine/imap/transport/imap-deserializer.vala"
			break;
#line 3427 "imap-deserializer.c"
		}
		default:
#line 777 "../src/engine/imap/transport/imap-deserializer.vala"
		break;
#line 3432 "imap-deserializer.c"
	}
#line 784 "../src/engine/imap/transport/imap-deserializer.vala"
	result = (guint) GEARY_IMAP_DESERIALIZER_STATE_QUOTED;
#line 784 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 3438 "imap-deserializer.c"
}

static guint
geary_imap_deserializer_on_partial_body_atom_char (GearyImapDeserializer* self,
                                                   guint state,
                                                   guint event,
                                                   void* user)
{
	gchar ch = '\0';
	guint result;
#line 787 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), 0U);
#line 788 "../src/engine/imap/transport/imap-deserializer.vala"
	ch = *((gchar*) user);
#line 794 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_append_to_string (self, ch);
#line 802 "../src/engine/imap/transport/imap-deserializer.vala"
	switch (ch) {
#line 802 "../src/engine/imap/transport/imap-deserializer.vala"
		case ']':
#line 802 "../src/engine/imap/transport/imap-deserializer.vala"
		case '>':
#line 3461 "imap-deserializer.c"
		{
#line 805 "../src/engine/imap/transport/imap-deserializer.vala"
			result = (guint) GEARY_IMAP_DESERIALIZER_STATE_PARTIAL_BODY_ATOM_TERMINATING;
#line 805 "../src/engine/imap/transport/imap-deserializer.vala"
			return result;
#line 3467 "imap-deserializer.c"
		}
		default:
		{
#line 808 "../src/engine/imap/transport/imap-deserializer.vala"
			result = state;
#line 808 "../src/engine/imap/transport/imap-deserializer.vala"
			return result;
#line 3475 "imap-deserializer.c"
		}
	}
}

static guint
geary_imap_deserializer_on_partial_body_atom_terminating_char (GearyImapDeserializer* self,
                                                               guint state,
                                                               guint event,
                                                               void* user)
{
	gchar ch = '\0';
	guint result;
#line 812 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), 0U);
#line 813 "../src/engine/imap/transport/imap-deserializer.vala"
	ch = *((gchar*) user);
#line 816 "../src/engine/imap/transport/imap-deserializer.vala"
	if (ch != ' ') {
#line 817 "../src/engine/imap/transport/imap-deserializer.vala"
		result = geary_imap_deserializer_on_partial_body_atom_char (self, (guint) GEARY_IMAP_DESERIALIZER_STATE_PARTIAL_BODY_ATOM, event, user);
#line 817 "../src/engine/imap/transport/imap-deserializer.vala"
		return result;
#line 3498 "imap-deserializer.c"
	}
#line 819 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_save_string_parameter (self, FALSE);
#line 821 "../src/engine/imap/transport/imap-deserializer.vala"
	result = (guint) GEARY_IMAP_DESERIALIZER_STATE_START_PARAM;
#line 821 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 3506 "imap-deserializer.c"
}

static glong
long_parse (const gchar* str,
            guint _base)
{
	glong result;
#line 315 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0L);
#line 316 "glib-2.0.vapi"
	result = strtol (str, NULL, (gint) _base);
#line 316 "glib-2.0.vapi"
	return result;
#line 3520 "imap-deserializer.c"
}

static guint
geary_imap_deserializer_on_literal_char (GearyImapDeserializer* self,
                                         guint state,
                                         guint event,
                                         void* user)
{
	gchar ch = '\0';
	guint result;
#line 824 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), 0U);
#line 825 "../src/engine/imap/transport/imap-deserializer.vala"
	ch = *((gchar*) user);
#line 828 "../src/engine/imap/transport/imap-deserializer.vala"
	if (ch == '}') {
#line 3537 "imap-deserializer.c"
		GString* _tmp0_;
		const gchar* _tmp1_;
#line 830 "../src/engine/imap/transport/imap-deserializer.vala"
		if (geary_imap_deserializer_is_current_string_empty (self)) {
#line 831 "../src/engine/imap/transport/imap-deserializer.vala"
			geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Empty flag atom");
#line 832 "../src/engine/imap/transport/imap-deserializer.vala"
			result = (guint) GEARY_IMAP_DESERIALIZER_STATE_FAILED;
#line 832 "../src/engine/imap/transport/imap-deserializer.vala"
			return result;
#line 3548 "imap-deserializer.c"
		}
#line 835 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp0_ = self->priv->current_string;
#line 835 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp1_ = _tmp0_->str;
#line 835 "../src/engine/imap/transport/imap-deserializer.vala"
		self->priv->literal_length_remaining = (gsize) long_parse (_tmp1_, (guint) 0);
#line 836 "../src/engine/imap/transport/imap-deserializer.vala"
		_g_string_free0 (self->priv->current_string);
#line 836 "../src/engine/imap/transport/imap-deserializer.vala"
		self->priv->current_string = NULL;
#line 837 "../src/engine/imap/transport/imap-deserializer.vala"
		if (self->priv->literal_length_remaining < ((gsize) 0)) {
#line 838 "../src/engine/imap/transport/imap-deserializer.vala"
			geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Negative literal data length %lu", (gulong) self->priv->literal_length_remaining);
#line 839 "../src/engine/imap/transport/imap-deserializer.vala"
			result = (guint) GEARY_IMAP_DESERIALIZER_STATE_FAILED;
#line 839 "../src/engine/imap/transport/imap-deserializer.vala"
			return result;
#line 3568 "imap-deserializer.c"
		}
#line 842 "../src/engine/imap/transport/imap-deserializer.vala"
		result = (guint) GEARY_IMAP_DESERIALIZER_STATE_LITERAL_DATA_BEGIN;
#line 842 "../src/engine/imap/transport/imap-deserializer.vala"
		return result;
#line 3574 "imap-deserializer.c"
	}
#line 846 "../src/engine/imap/transport/imap-deserializer.vala"
	if (!g_ascii_isdigit (ch)) {
#line 847 "../src/engine/imap/transport/imap-deserializer.vala"
		result = (guint) GEARY_IMAP_DESERIALIZER_STATE_LITERAL;
#line 847 "../src/engine/imap/transport/imap-deserializer.vala"
		return result;
#line 3582 "imap-deserializer.c"
	}
#line 849 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_append_to_string (self, ch);
#line 851 "../src/engine/imap/transport/imap-deserializer.vala"
	result = (guint) GEARY_IMAP_DESERIALIZER_STATE_LITERAL;
#line 851 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 3590 "imap-deserializer.c"
}

static guint
geary_imap_deserializer_on_literal_data_begin_eol (GearyImapDeserializer* self,
                                                   guint state,
                                                   guint event,
                                                   void* user)
{
	guint result;
#line 854 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), 0U);
#line 855 "../src/engine/imap/transport/imap-deserializer.vala"
	result = (guint) GEARY_IMAP_DESERIALIZER_STATE_LITERAL_DATA;
#line 855 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 3606 "imap-deserializer.c"
}

static guint
geary_imap_deserializer_on_literal_data (GearyImapDeserializer* self,
                                         guint state,
                                         guint event,
                                         void* user)
{
	gsize* bytes_read = NULL;
	gsize* _tmp0_;
	gsize* _tmp1_;
	guint result;
#line 858 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), 0U);
#line 859 "../src/engine/imap/transport/imap-deserializer.vala"
	bytes_read = (gsize*) user;
#line 861 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp0_ = bytes_read;
#line 861 "../src/engine/imap/transport/imap-deserializer.vala"
	_vala_assert ((*_tmp0_) <= self->priv->literal_length_remaining, "*bytes_read <= literal_length_remaining");
#line 862 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp1_ = bytes_read;
#line 862 "../src/engine/imap/transport/imap-deserializer.vala"
	self->priv->literal_length_remaining = self->priv->literal_length_remaining - (*_tmp1_);
#line 864 "../src/engine/imap/transport/imap-deserializer.vala"
	if (self->priv->literal_length_remaining > ((gsize) 0)) {
#line 865 "../src/engine/imap/transport/imap-deserializer.vala"
		result = (guint) GEARY_IMAP_DESERIALIZER_STATE_LITERAL_DATA;
#line 865 "../src/engine/imap/transport/imap-deserializer.vala"
		return result;
#line 3637 "imap-deserializer.c"
	}
#line 867 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_save_literal_parameter (self);
#line 869 "../src/engine/imap/transport/imap-deserializer.vala"
	result = (guint) GEARY_IMAP_DESERIALIZER_STATE_START_PARAM;
#line 869 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 3645 "imap-deserializer.c"
}

static guint
geary_imap_deserializer_on_response_text_char (GearyImapDeserializer* self,
                                               guint state,
                                               guint event,
                                               void* user)
{
	gchar ch = '\0';
	guint result;
#line 872 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), 0U);
#line 873 "../src/engine/imap/transport/imap-deserializer.vala"
	ch = *((gchar*) user);
#line 874 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_append_to_string (self, ch);
#line 875 "../src/engine/imap/transport/imap-deserializer.vala"
	result = (guint) GEARY_IMAP_DESERIALIZER_STATE_RESPONSE_TEXT;
#line 875 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 3666 "imap-deserializer.c"
}

static guint
geary_imap_deserializer_on_eos (GearyImapDeserializer* self)
{
	GearyNonblockingSemaphore* _tmp0_;
	guint result;
#line 878 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), 0U);
#line 879 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "EOS");
#line 884 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_flush_params (self);
#line 887 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp0_ = self->priv->closed_semaphore;
#line 887 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_nonblocking_lock_blind_notify (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock));
#line 888 "../src/engine/imap/transport/imap-deserializer.vala"
	g_signal_emit (self, geary_imap_deserializer_signals[GEARY_IMAP_DESERIALIZER_END_OF_STREAM_SIGNAL], 0);
#line 890 "../src/engine/imap/transport/imap-deserializer.vala"
	result = (guint) GEARY_IMAP_DESERIALIZER_STATE_CLOSED;
#line 890 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 3690 "imap-deserializer.c"
}

static guint
geary_imap_deserializer_on_error (GearyImapDeserializer* self,
                                  guint state,
                                  guint event,
                                  void* user,
                                  GObject* object,
                                  GError* err)
{
	GearyNonblockingSemaphore* _tmp1_;
	guint result;
#line 893 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), 0U);
#line 893 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail ((object == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT), 0U);
#line 894 "../src/engine/imap/transport/imap-deserializer.vala"
	_vala_assert (err != NULL, "err != null");
#line 898 "../src/engine/imap/transport/imap-deserializer.vala"
	if (!g_error_matches (err, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 3711 "imap-deserializer.c"
		const gchar* _tmp0_;
#line 899 "../src/engine/imap/transport/imap-deserializer.vala"
		_tmp0_ = err->message;
#line 899 "../src/engine/imap/transport/imap-deserializer.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Input error: %s", _tmp0_);
#line 900 "../src/engine/imap/transport/imap-deserializer.vala"
		g_signal_emit (self, geary_imap_deserializer_signals[GEARY_IMAP_DESERIALIZER_RECEIVE_FAILURE_SIGNAL], 0, err);
#line 3719 "imap-deserializer.c"
	}
#line 904 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp1_ = self->priv->closed_semaphore;
#line 904 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_nonblocking_lock_blind_notify (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_NONBLOCKING_TYPE_LOCK, GearyNonblockingLock));
#line 905 "../src/engine/imap/transport/imap-deserializer.vala"
	result = (guint) GEARY_IMAP_DESERIALIZER_STATE_CLOSED;
#line 905 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 3729 "imap-deserializer.c"
}

static guint
geary_imap_deserializer_on_bad_transition (GearyImapDeserializer* self,
                                           guint state,
                                           guint event,
                                           void* user)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	guint result;
#line 908 "../src/engine/imap/transport/imap-deserializer.vala"
	g_return_val_if_fail (GEARY_IMAP_IS_DESERIALIZER (self), 0U);
#line 909 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp0_ = geary_imap_deserializer_event_to_string (event);
#line 909 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp1_ = _tmp0_;
#line 909 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp2_ = geary_imap_deserializer_state_to_string (state);
#line 909 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp3_ = _tmp2_;
#line 909 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Bad event %s at state %s", _tmp1_, _tmp3_);
#line 909 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_free0 (_tmp3_);
#line 909 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_free0 (_tmp1_);
#line 911 "../src/engine/imap/transport/imap-deserializer.vala"
	result = (guint) GEARY_IMAP_DESERIALIZER_STATE_FAILED;
#line 911 "../src/engine/imap/transport/imap-deserializer.vala"
	return result;
#line 3763 "imap-deserializer.c"
}

static void
geary_imap_deserializer_class_init (GearyImapDeserializerClass * klass,
                                    gpointer klass_data)
{
	GearyStateMachineDescriptor* _tmp0_;
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_parent_class = g_type_class_peek_parent (klass);
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	g_type_class_adjust_private_offset (klass, &GearyImapDeserializer_private_offset);
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_imap_deserializer_get_property;
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_imap_deserializer_set_property;
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_imap_deserializer_finalize;
#line 3781 "imap-deserializer.c"
	/** {@inheritDoc} */
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_DESERIALIZER_LOGGING_PARENT_PROPERTY, geary_imap_deserializer_properties[GEARY_IMAP_DESERIALIZER_LOGGING_PARENT_PROPERTY] = g_param_spec_object ("logging-parent", "logging-parent", "logging-parent", GEARY_LOGGING_TYPE_SOURCE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3785 "imap-deserializer.c"
	/** The quirks being used by this deserializer. */
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_IMAP_DESERIALIZER_QUIRKS_PROPERTY, geary_imap_deserializer_properties[GEARY_IMAP_DESERIALIZER_QUIRKS_PROPERTY] = g_param_spec_object ("quirks", "quirks", "quirks", GEARY_IMAP_TYPE_QUIRKS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3789 "imap-deserializer.c"
	/**
	     * Fired when a complete set of IMAP {@link Parameter}s have been received.
	     *
	     * Note that {@link RootParameters} may contain {@link QuotedStringParameter}s,
	     * {@link UnquotedStringParameter}s, {@link ResponseCode}, and {@link ListParameter}s.
	     * Deserializer does not produce any other kind of Parameter due to its inability to deduce
	     * them from syntax alone.  ResponseCode, however, can be.
	     *
	     * All strings are ASCII (7-bit) with control characters stripped (with the exception of
	     * {@link QuotedStringParameter} which allows for some control characters).
	     */
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_signals[GEARY_IMAP_DESERIALIZER_PARAMETERS_READY_SIGNAL] = g_signal_new ("parameters-ready", GEARY_IMAP_TYPE_DESERIALIZER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_IMAP_TYPE_ROOT_PARAMETERS);
#line 3803 "imap-deserializer.c"
	/**
	     * Fired as data blocks are received during download.
	     *
	     * The bytes themselves may be partial and unusable out of context, so they're not provided,
	     * but their size is, to allow monitoring of speed and such.
	     *
	     * Note that this is fired for both line data (i.e. responses, status, etc.) and literal data
	     * (block transfers).
	     *
	     * In general, this signal is provided to inform subscribers that activity is happening
	     * on the receive channel, especially during long downloads.
	     */
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_signals[GEARY_IMAP_DESERIALIZER_BYTES_RECEIVED_SIGNAL] = g_signal_new ("bytes-received", GEARY_IMAP_TYPE_DESERIALIZER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ULONG, G_TYPE_NONE, 1, G_TYPE_ULONG);
#line 3818 "imap-deserializer.c"
	/**
	     * Fired when a syntax error has occurred.
	     *
	     * This generally means the data looks like garbage and further
	     * deserialization is unlikely or impossible.
	     */
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_signals[GEARY_IMAP_DESERIALIZER_DESERIALIZE_FAILURE_SIGNAL] = g_signal_new ("deserialize-failure", GEARY_IMAP_TYPE_DESERIALIZER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3827 "imap-deserializer.c"
	/**
	     * Fired when an Error is trapped on the input stream.
	     *
	     * This is nonrecoverable and means the stream should be closed
	     * and this Deserializer destroyed.
	     */
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_signals[GEARY_IMAP_DESERIALIZER_RECEIVE_FAILURE_SIGNAL] = g_signal_new ("receive-failure", GEARY_IMAP_TYPE_DESERIALIZER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOXED, G_TYPE_NONE, 1, G_TYPE_ERROR);
#line 3836 "imap-deserializer.c"
	/**
	     * Fired when the underlying InputStream is closed.
	     *
	     * This is nonrecoverable and means the stream should be closed
	     * and this Deserializer destroyed.
	     */
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_signals[GEARY_IMAP_DESERIALIZER_END_OF_STREAM_SIGNAL] = g_signal_new ("end-of-stream", GEARY_IMAP_TYPE_DESERIALIZER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 79 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp0_ = geary_state_machine_descriptor_new ("Geary.Imap.Deserializer", (guint) GEARY_IMAP_DESERIALIZER_STATE_TAG, (guint) GEARY_IMAP_DESERIALIZER_STATE_COUNT, (guint) GEARY_IMAP_DESERIALIZER_EVENT_COUNT, _geary_imap_deserializer_state_to_string_geary_state_state_event_to_string, NULL, _geary_imap_deserializer_event_to_string_geary_state_state_event_to_string, NULL);
#line 79 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_machine_desc = _tmp0_;
#line 3849 "imap-deserializer.c"
}

static void
geary_imap_deserializer_geary_logging_source_interface_init (GearyLoggingSourceIface * iface,
                                                             gpointer iface_data)
{
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	geary_imap_deserializer_geary_logging_source_parent_iface = g_type_interface_peek_parent (iface);
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	iface->to_logging_state = (GearyLoggingState* (*) (GearyLoggingSource*)) geary_imap_deserializer_real_to_logging_state;
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	iface->get_logging_domain = geary_imap_deserializer_real_get_logging_domain;
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	iface->get_logging_parent = geary_imap_deserializer_real_get_logging_parent;
#line 3864 "imap-deserializer.c"
}

static void
geary_imap_deserializer_instance_init (GearyImapDeserializer * self,
                                       gpointer klass)
{
	GeeLinkedList* _tmp0_;
	GearyNonblockingSemaphore* _tmp1_;
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	self->priv = geary_imap_deserializer_get_instance_private (self);
#line 90 "../src/engine/imap/transport/imap-deserializer.vala"
	self->priv->_logging_parent = NULL;
#line 100 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp0_ = gee_linked_list_new (GEARY_IMAP_TYPE_LIST_PARAMETER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 100 "../src/engine/imap/transport/imap-deserializer.vala"
	self->priv->context_stack = _tmp0_;
#line 103 "../src/engine/imap/transport/imap-deserializer.vala"
	self->priv->cancellable = NULL;
#line 104 "../src/engine/imap/transport/imap-deserializer.vala"
	_tmp1_ = geary_nonblocking_semaphore_new (NULL);
#line 104 "../src/engine/imap/transport/imap-deserializer.vala"
	self->priv->closed_semaphore = _tmp1_;
#line 105 "../src/engine/imap/transport/imap-deserializer.vala"
	self->priv->current_string = NULL;
#line 106 "../src/engine/imap/transport/imap-deserializer.vala"
	self->priv->literal_length_remaining = (gsize) 0;
#line 107 "../src/engine/imap/transport/imap-deserializer.vala"
	self->priv->block_buffer = NULL;
#line 108 "../src/engine/imap/transport/imap-deserializer.vala"
	self->priv->current_buffer = NULL;
#line 108 "../src/engine/imap/transport/imap-deserializer.vala"
	self->priv->current_buffer_length1 = 0;
#line 108 "../src/engine/imap/transport/imap-deserializer.vala"
	self->priv->_current_buffer_size_ = self->priv->current_buffer_length1;
#line 109 "../src/engine/imap/transport/imap-deserializer.vala"
	self->priv->ins_priority = G_PRIORITY_DEFAULT;
#line 111 "../src/engine/imap/transport/imap-deserializer.vala"
	self->priv->is_parsing_flags = FALSE;
#line 3903 "imap-deserializer.c"
}

static void
geary_imap_deserializer_finalize (GObject * obj)
{
	GearyImapDeserializer * self;
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_IMAP_TYPE_DESERIALIZER, GearyImapDeserializer);
#line 93 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_object_unref0 (self->priv->_quirks);
#line 95 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_free0 (self->priv->identifier);
#line 96 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_object_unref0 (self->priv->input);
#line 97 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_object_unref0 (self->priv->fsm);
#line 99 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_object_unref0 (self->priv->context);
#line 100 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_object_unref0 (self->priv->context_stack);
#line 103 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 104 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_object_unref0 (self->priv->closed_semaphore);
#line 105 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_string_free0 (self->priv->current_string);
#line 107 "../src/engine/imap/transport/imap-deserializer.vala"
	_g_object_unref0 (self->priv->block_buffer);
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	G_OBJECT_CLASS (geary_imap_deserializer_parent_class)->finalize (obj);
#line 3934 "imap-deserializer.c"
}

/**
 * The Deserializer performs asynchronous I/O on a supplied input stream and transforms the raw
 * bytes into IMAP {@link Parameter}s (which can then be converted into {@link ServerResponse}s or
 * {@link ServerData}).
 *
 * The Deserializer will only begin reading from the stream when {@link start_async} is called.
 * Calling {@link stop_async} will halt reading without closing the stream itself.  A Deserializer
 * may not be reused once stop_async has been invoked.
 *
 * Since all results from the Deserializer are reported via signals, those signals should be
 * connected to prior to calling start_async, or the caller risks missing early messages.  (Note
 * that since Deserializer uses async I/O, this isn't technically possible unless the signals are
 * connected after the Idle loop has a chance to run; however, this is an implementation detail and
 * shouldn't be relied upon.)
 *
 * Internally Deserializer uses a DataInputStream to help decode the data.  Since DataInputStream
 * is buffered, there's no need to buffer the InputStream passed to Deserializer's constructor.
 */
 G_GNUC_NO_INLINE static GType
geary_imap_deserializer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyImapDeserializerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_imap_deserializer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyImapDeserializer), 0, (GInstanceInitFunc) geary_imap_deserializer_instance_init, NULL };
	static const GInterfaceInfo geary_logging_source_info = { (GInterfaceInitFunc) geary_imap_deserializer_geary_logging_source_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType geary_imap_deserializer_type_id;
	geary_imap_deserializer_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyImapDeserializer", &g_define_type_info, 0);
	g_type_add_interface_static (geary_imap_deserializer_type_id, GEARY_LOGGING_TYPE_SOURCE, &geary_logging_source_info);
	GearyImapDeserializer_private_offset = g_type_add_instance_private (geary_imap_deserializer_type_id, sizeof (GearyImapDeserializerPrivate));
	return geary_imap_deserializer_type_id;
}

GType
geary_imap_deserializer_get_type (void)
{
	static gsize geary_imap_deserializer_type_id__once = 0;
	if (g_once_init_enter (&geary_imap_deserializer_type_id__once)) {
		GType geary_imap_deserializer_type_id;
		geary_imap_deserializer_type_id = geary_imap_deserializer_get_type_once ();
		g_once_init_leave (&geary_imap_deserializer_type_id__once, geary_imap_deserializer_type_id);
	}
	return geary_imap_deserializer_type_id__once;
}

static void
_vala_geary_imap_deserializer_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	GearyImapDeserializer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_TYPE_DESERIALIZER, GearyImapDeserializer);
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	switch (property_id) {
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
		case GEARY_IMAP_DESERIALIZER_LOGGING_PARENT_PROPERTY:
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
		g_value_set_object (value, geary_logging_source_get_logging_parent (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource)));
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
		break;
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
		case GEARY_IMAP_DESERIALIZER_QUIRKS_PROPERTY:
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
		g_value_set_object (value, geary_imap_deserializer_get_quirks (self));
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
		break;
#line 4001 "imap-deserializer.c"
		default:
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
		break;
#line 4007 "imap-deserializer.c"
	}
}

static void
_vala_geary_imap_deserializer_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	GearyImapDeserializer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_IMAP_TYPE_DESERIALIZER, GearyImapDeserializer);
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
	switch (property_id) {
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
		case GEARY_IMAP_DESERIALIZER_QUIRKS_PROPERTY:
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
		geary_imap_deserializer_set_quirks (self, g_value_get_object (value));
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
		break;
#line 4027 "imap-deserializer.c"
		default:
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../src/engine/imap/transport/imap-deserializer.vala"
		break;
#line 4033 "imap-deserializer.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

