/* rfc822-message.c generated by valac 0.56.17, the Vala compiler
 * generated from rfc822-message.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2018 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gmime/gmime.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <ytnef.h>

#define GEARY_RF_C822_MESSAGE_HEADER_IN_REPLY_TO "In-Reply-To"
#define GEARY_RF_C822_MESSAGE_HEADER_REFERENCES "References"
#define GEARY_RF_C822_MESSAGE_HEADER_MAILER "X-Mailer"
#define GEARY_RF_C822_MESSAGE_HEADER_BCC "Bcc"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_RF_C822_MESSAGE_0_PROPERTY,
	GEARY_RF_C822_MESSAGE_FROM_PROPERTY,
	GEARY_RF_C822_MESSAGE_SENDER_PROPERTY,
	GEARY_RF_C822_MESSAGE_REPLY_TO_PROPERTY,
	GEARY_RF_C822_MESSAGE_TO_PROPERTY,
	GEARY_RF_C822_MESSAGE_CC_PROPERTY,
	GEARY_RF_C822_MESSAGE_BCC_PROPERTY,
	GEARY_RF_C822_MESSAGE_MESSAGE_ID_PROPERTY,
	GEARY_RF_C822_MESSAGE_IN_REPLY_TO_PROPERTY,
	GEARY_RF_C822_MESSAGE_REFERENCES_PROPERTY,
	GEARY_RF_C822_MESSAGE_SUBJECT_PROPERTY,
	GEARY_RF_C822_MESSAGE_DATE_PROPERTY,
	GEARY_RF_C822_MESSAGE_AUTH_RESULTS_PROPERTY,
	GEARY_RF_C822_MESSAGE_MAILER_PROPERTY,
	GEARY_RF_C822_MESSAGE_NUM_PROPERTIES
};
static GParamSpec* geary_rf_c822_message_properties[GEARY_RF_C822_MESSAGE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GMimeParserOptions_free0(var) ((var == NULL) ? NULL : (var = (_vala_GMimeParserOptions_free (var), NULL)))
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _GearyRfC822MessageNewFromComposedEmailData GearyRfC822MessageNewFromComposedEmailData;
typedef struct _GearyRfC822MessageGetFilePartData GearyRfC822MessageGetFilePartData;
typedef struct _GearyRfC822MessageGetBufferPartData GearyRfC822MessageGetBufferPartData;
#define __vala_GMimeFormatOptions_free0(var) ((var == NULL) ? NULL : (var = (_vala_GMimeFormatOptions_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_byte_array_unref0(var) ((var == NULL) ? NULL : (var = (g_byte_array_unref (var), NULL)))
typedef struct _GearyRfC822MessageBodyDataToPartData GearyRfC822MessageBodyDataToPartData;

struct _GearyRFC822MessagePrivate {
	GearyRFC822MailboxAddresses* _from;
	GearyRFC822MailboxAddress* _sender;
	GearyRFC822MailboxAddresses* _reply_to;
	GearyRFC822MailboxAddresses* _to;
	GearyRFC822MailboxAddresses* _cc;
	GearyRFC822MailboxAddresses* _bcc;
	GearyRFC822MessageID* _message_id;
	GearyRFC822MessageIDList* _in_reply_to;
	GearyRFC822MessageIDList* _references;
	GearyRFC822Subject* _subject;
	GearyRFC822Date* _date;
	GearyRFC822AuthenticationResults* _auth_results;
	gchar* _mailer;
	GMimeMessage* message;
};

struct _GearyRfC822MessageNewFromComposedEmailData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GType object_type;
	GearyRFC822Message* self;
	GearyComposedEmail* email;
	gchar* message_id;
	GCancellable* cancellable;
	GMimeMessage* _tmp0_;
	GearyRFC822MailboxAddresses* _tmp1_;
	GearyRFC822MailboxAddresses* _tmp2_;
	GearyRFC822MailboxAddresses* _tmp3_;
	GearyRFC822MailboxAddresses* _mailbox_list;
	GearyRFC822MailboxAddresses* _tmp4_;
	GearyRFC822MailboxAddresses* _tmp5_;
	gint _mailbox_size;
	GearyRFC822MailboxAddresses* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _mailbox_index;
	gint _tmp9_;
	gint _tmp10_;
	GearyRFC822MailboxAddress* mailbox;
	GearyRFC822MailboxAddresses* _tmp11_;
	GearyRFC822MailboxAddress* _tmp12_;
	GMimeMessage* _tmp13_;
	GearyRFC822MailboxAddress* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	GearyRFC822MailboxAddress* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	GearyRFC822Date* _tmp20_;
	GearyRFC822Date* _tmp21_;
	GearyRFC822Date* _tmp22_;
	GMimeMessage* _tmp23_;
	GearyRFC822Date* _tmp24_;
	GearyRFC822Date* _tmp25_;
	GDateTime* _tmp26_;
	GDateTime* _tmp27_;
	GearyRFC822MailboxAddresses* _tmp28_;
	GearyRFC822MailboxAddresses* _tmp29_;
	GearyRFC822MailboxAddresses* _tmp30_;
	GearyRFC822MailboxAddresses* _tmp31_;
	GearyRFC822MailboxAddresses* _tmp32_;
	GearyRFC822MailboxAddresses* _vala1__mailbox_list;
	GearyRFC822MailboxAddresses* _tmp33_;
	GearyRFC822MailboxAddresses* _tmp34_;
	gint _vala1__mailbox_size;
	GearyRFC822MailboxAddresses* _tmp35_;
	gint _tmp36_;
	gint _tmp37_;
	gint _vala1__mailbox_index;
	gint _tmp38_;
	gint _tmp39_;
	GearyRFC822MailboxAddress* _vala1_mailbox;
	GearyRFC822MailboxAddresses* _tmp40_;
	GearyRFC822MailboxAddress* _tmp41_;
	GMimeMessage* _tmp42_;
	GearyRFC822MailboxAddress* _tmp43_;
	const gchar* _tmp44_;
	const gchar* _tmp45_;
	GearyRFC822MailboxAddress* _tmp46_;
	const gchar* _tmp47_;
	const gchar* _tmp48_;
	GearyRFC822MailboxAddresses* _tmp49_;
	GearyRFC822MailboxAddresses* _tmp50_;
	GearyRFC822MailboxAddresses* _tmp51_;
	GearyRFC822MailboxAddresses* _tmp52_;
	GearyRFC822MailboxAddresses* _tmp53_;
	GearyRFC822MailboxAddresses* _vala2__mailbox_list;
	GearyRFC822MailboxAddresses* _tmp54_;
	GearyRFC822MailboxAddresses* _tmp55_;
	gint _vala2__mailbox_size;
	GearyRFC822MailboxAddresses* _tmp56_;
	gint _tmp57_;
	gint _tmp58_;
	gint _vala2__mailbox_index;
	gint _tmp59_;
	gint _tmp60_;
	GearyRFC822MailboxAddress* _vala2_mailbox;
	GearyRFC822MailboxAddresses* _tmp61_;
	GearyRFC822MailboxAddress* _tmp62_;
	GMimeMessage* _tmp63_;
	GearyRFC822MailboxAddress* _tmp64_;
	const gchar* _tmp65_;
	const gchar* _tmp66_;
	GearyRFC822MailboxAddress* _tmp67_;
	const gchar* _tmp68_;
	const gchar* _tmp69_;
	GearyRFC822MailboxAddresses* _tmp70_;
	GearyRFC822MailboxAddresses* _tmp71_;
	GearyRFC822MailboxAddresses* _tmp72_;
	GearyRFC822MailboxAddresses* _tmp73_;
	GearyRFC822MailboxAddresses* _tmp74_;
	GearyRFC822MailboxAddresses* _vala3__mailbox_list;
	GearyRFC822MailboxAddresses* _tmp75_;
	GearyRFC822MailboxAddresses* _tmp76_;
	gint _vala3__mailbox_size;
	GearyRFC822MailboxAddresses* _tmp77_;
	gint _tmp78_;
	gint _tmp79_;
	gint _vala3__mailbox_index;
	gint _tmp80_;
	gint _tmp81_;
	GearyRFC822MailboxAddress* _vala3_mailbox;
	GearyRFC822MailboxAddresses* _tmp82_;
	GearyRFC822MailboxAddress* _tmp83_;
	GMimeMessage* _tmp84_;
	GearyRFC822MailboxAddress* _tmp85_;
	const gchar* _tmp86_;
	const gchar* _tmp87_;
	GearyRFC822MailboxAddress* _tmp88_;
	const gchar* _tmp89_;
	const gchar* _tmp90_;
	GearyRFC822MailboxAddress* _tmp91_;
	GearyRFC822MailboxAddress* _tmp92_;
	GearyRFC822MailboxAddress* _tmp93_;
	GearyRFC822MailboxAddress* _tmp94_;
	GearyRFC822MailboxAddress* _tmp95_;
	GMimeMessage* _tmp96_;
	GearyRFC822MailboxAddress* _tmp97_;
	GearyRFC822MailboxAddress* _tmp98_;
	const gchar* _tmp99_;
	const gchar* _tmp100_;
	GearyRFC822MailboxAddress* _tmp101_;
	GearyRFC822MailboxAddress* _tmp102_;
	const gchar* _tmp103_;
	const gchar* _tmp104_;
	GearyRFC822MailboxAddresses* _tmp105_;
	GearyRFC822MailboxAddresses* _tmp106_;
	GearyRFC822MailboxAddresses* _tmp107_;
	GearyRFC822MailboxAddresses* _tmp108_;
	GearyRFC822MailboxAddresses* _tmp109_;
	GearyRFC822MailboxAddresses* _vala4__mailbox_list;
	GearyRFC822MailboxAddresses* _tmp110_;
	GearyRFC822MailboxAddresses* _tmp111_;
	gint _vala4__mailbox_size;
	GearyRFC822MailboxAddresses* _tmp112_;
	gint _tmp113_;
	gint _tmp114_;
	gint _vala4__mailbox_index;
	gint _tmp115_;
	gint _tmp116_;
	GearyRFC822MailboxAddress* _vala4_mailbox;
	GearyRFC822MailboxAddresses* _tmp117_;
	GearyRFC822MailboxAddress* _tmp118_;
	GMimeMessage* _tmp119_;
	GearyRFC822MailboxAddress* _tmp120_;
	const gchar* _tmp121_;
	const gchar* _tmp122_;
	GearyRFC822MailboxAddress* _tmp123_;
	const gchar* _tmp124_;
	const gchar* _tmp125_;
	GearyRFC822MessageID* _tmp126_;
	GMimeMessage* _tmp127_;
	GearyRFC822MessageIDList* _tmp128_;
	GearyRFC822MessageIDList* _tmp129_;
	GearyRFC822MessageIDList* _tmp130_;
	GearyRFC822MessageIDList* _tmp131_;
	GearyRFC822MessageIDList* _tmp132_;
	GMimeMessage* _tmp133_;
	GearyRFC822MessageIDList* _tmp134_;
	GearyRFC822MessageIDList* _tmp135_;
	gchar* _tmp136_;
	gchar* _tmp137_;
	gchar* _tmp138_;
	gchar* _tmp139_;
	GearyRFC822MessageIDList* _tmp140_;
	GearyRFC822MessageIDList* _tmp141_;
	GearyRFC822MessageIDList* _tmp142_;
	GearyRFC822MessageIDList* _tmp143_;
	GearyRFC822MessageIDList* _tmp144_;
	GMimeMessage* _tmp145_;
	GearyRFC822MessageIDList* _tmp146_;
	GearyRFC822MessageIDList* _tmp147_;
	gchar* _tmp148_;
	gchar* _tmp149_;
	gchar* _tmp150_;
	gchar* _tmp151_;
	GearyRFC822Subject* _tmp152_;
	GearyRFC822Subject* _tmp153_;
	GearyRFC822Subject* _tmp154_;
	GearyRFC822Subject* _tmp155_;
	GearyRFC822Subject* _tmp156_;
	GMimeMessage* _tmp157_;
	GearyRFC822Subject* _tmp158_;
	GearyRFC822Subject* _tmp159_;
	const gchar* _tmp160_;
	const gchar* _tmp161_;
	gchar* _tmp162_;
	gchar* _tmp163_;
	const gchar* _tmp164_;
	const gchar* _tmp165_;
	const gchar* _tmp166_;
	const gchar* _tmp167_;
	GMimeMessage* _tmp168_;
	const gchar* _tmp169_;
	const gchar* _tmp170_;
	gchar* _tmp171_;
	gchar* _tmp172_;
	GeeList* body_parts;
	GeeLinkedList* _tmp173_;
	gchar* body_charset;
	const gchar* _tmp174_;
	const gchar* _tmp175_;
	GMimePart* body_text;
	GMimePart* _tmp176_;
	const gchar* _tmp177_;
	const gchar* _tmp178_;
	guint8* _tmp179_;
	gint _tmp179__length1;
	gint _tmp180_;
	guint8* _tmp181_;
	gint _tmp181__length1;
	GMimePart* _tmp182_;
	GMimePart* _tmp183_;
	GError* err;
	GError* _tmp184_;
	const gchar* _tmp185_;
	GMimePart* _tmp186_;
	GMimePart* _tmp187_;
	GMimeContentType* _tmp188_;
	const gchar* _tmp189_;
	gchar* _tmp190_;
	GeeList* _tmp191_;
	GMimePart* _tmp192_;
	const gchar* _tmp193_;
	const gchar* _tmp194_;
	GeeList* related_parts;
	GeeLinkedList* _tmp195_;
	GeeMap* inline_files;
	GeeHashMap* _tmp196_;
	GeeMap* _tmp197_;
	GeeMap* _tmp198_;
	GeeMap* _tmp199_;
	GeeIterator* _cid_it;
	GeeMap* _tmp200_;
	GeeMap* _tmp201_;
	GeeSet* _tmp202_;
	GeeSet* _tmp203_;
	GeeSet* _tmp204_;
	GeeIterator* _tmp205_;
	GeeIterator* _tmp206_;
	GeeIterator* _tmp207_;
	gchar* cid;
	GeeIterator* _tmp208_;
	gpointer _tmp209_;
	const gchar* _tmp210_;
	gchar* _tmp211_;
	gchar* _tmp212_;
	gboolean _tmp213_;
	GMimeObject* inline_part;
	GMimePart* _tmp214_;
	GeeMap* _tmp215_;
	GeeMap* _tmp216_;
	const gchar* _tmp217_;
	gpointer _tmp218_;
	GearyMemoryBuffer* _tmp219_;
	const gchar* _tmp220_;
	gchar* _tmp221_;
	gchar* _tmp222_;
	GMimePart* _tmp223_;
	GMimePart* _tmp224_;
	GMimePart* _tmp225_;
	GError* _vala1_err;
	const gchar* _tmp226_;
	GError* _tmp227_;
	const gchar* _tmp228_;
	GMimeObject* _tmp229_;
	GMimeObject* _tmp230_;
	const gchar* _tmp231_;
	GeeList* _tmp232_;
	GMimeObject* _tmp233_;
	GeeMap* _tmp234_;
	const gchar* _tmp235_;
	GeeMap* _tmp236_;
	gboolean _tmp237_;
	gboolean _tmp238_;
	guint cid_index;
	GeeIterator* _name_it;
	GeeMap* _tmp239_;
	GeeSet* _tmp240_;
	GeeSet* _tmp241_;
	GeeSet* _tmp242_;
	GeeIterator* _tmp243_;
	GeeIterator* _tmp244_;
	GeeIterator* _tmp245_;
	gchar* name;
	GeeIterator* _tmp246_;
	gpointer _tmp247_;
	gchar* _vala1_cid;
	gchar* _tmp248_;
	gboolean _tmp249_;
	GeeMap* _tmp250_;
	GeeMap* _tmp251_;
	const gchar* _tmp252_;
	guint _tmp253_;
	gchar* _tmp254_;
	const gchar* _tmp255_;
	const gchar* _tmp256_;
	gchar* _tmp257_;
	gchar* _tmp258_;
	gboolean _tmp259_;
	GMimeObject* _vala1_inline_part;
	GMimePart* _tmp260_;
	GeeMap* _tmp261_;
	const gchar* _tmp262_;
	gpointer _tmp263_;
	GearyMemoryBuffer* _tmp264_;
	const gchar* _tmp265_;
	gchar* _tmp266_;
	gchar* _tmp267_;
	GMimePart* _tmp268_;
	GMimePart* _tmp269_;
	GMimePart* _tmp270_;
	GError* _vala2_err;
	const gchar* _tmp271_;
	GError* _tmp272_;
	const gchar* _tmp273_;
	GMimeObject* _tmp274_;
	GMimeObject* _tmp275_;
	const gchar* _tmp276_;
	GeeList* _tmp277_;
	GMimeObject* _tmp278_;
	GMimeObject* body_html;
	GMimePart* _tmp279_;
	const gchar* _tmp280_;
	const gchar* _tmp281_;
	guint8* _tmp282_;
	gint _tmp282__length1;
	gint _tmp283_;
	guint8* _tmp284_;
	gint _tmp284__length1;
	const gchar* _tmp285_;
	GMimePart* _tmp286_;
	GMimePart* _tmp287_;
	GError* _vala3_err;
	GError* _tmp288_;
	const gchar* _tmp289_;
	GeeList* _tmp290_;
	gboolean _tmp291_;
	gboolean _tmp292_;
	GeeList* _tmp293_;
	GMimeObject* _tmp294_;
	GMimeObject* related_part;
	GeeList* _tmp295_;
	GMimeObject* _tmp296_;
	GMimeObject* _tmp297_;
	GMimeObject* _tmp298_;
	GMimeObject* _tmp299_;
	GeeList* _tmp300_;
	GMimeObject* _tmp301_;
	GeeList* main_parts;
	GeeLinkedList* _tmp302_;
	GMimeObject* body_part;
	GeeList* _tmp303_;
	GMimeObject* _tmp304_;
	GMimeObject* _tmp305_;
	GeeList* _tmp306_;
	GMimeObject* _tmp307_;
	GeeList* attachment_parts;
	GeeLinkedList* _tmp308_;
	GeeIterator* _file_it;
	GeeSet* _tmp309_;
	GeeSet* _tmp310_;
	GeeIterator* _tmp311_;
	GeeIterator* _tmp312_;
	GFile* file;
	GeeIterator* _tmp313_;
	gpointer _tmp314_;
	GMimeObject* attachment_part;
	GMimePart* _tmp315_;
	GFile* _tmp316_;
	GMimePart* _tmp317_;
	GMimePart* _tmp318_;
	GError* _vala4_err;
	GFile* _tmp319_;
	gchar* _tmp320_;
	gchar* _tmp321_;
	GError* _tmp322_;
	const gchar* _tmp323_;
	GMimeObject* _tmp324_;
	GeeList* _tmp325_;
	GMimeObject* _tmp326_;
	GMimeObject* _vala1_attachment_part;
	GeeList* _tmp327_;
	GMimeObject* _tmp328_;
	GMimeObject* _tmp329_;
	GeeList* _tmp330_;
	GMimeObject* _tmp331_;
	GMimeObject* main_part;
	GeeList* _tmp332_;
	GMimeObject* _tmp333_;
	GMimeMessage* _tmp334_;
	GError* _inner_error0_;
};

struct _GearyRfC822MessageGetFilePartData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyRFC822Message* self;
	GFile* file;
	GearyMimeDispositionType disposition;
	GCancellable* cancellable;
	GMimePart* result;
	GFileInfo* file_info;
	GFileInfo* _tmp0_;
	GMimePart* part;
	GMimePart* _tmp1_;
	GMimePart* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GMimePart* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GMimeContentType* content_type;
	GMimeParserOptions* _tmp8_;
	GMimeParserOptions* _tmp9_;
	const gchar* _tmp10_;
	GMimeContentType* _tmp11_;
	GMimeContentType* _tmp12_;
	GMimePart* _tmp13_;
	GMimeContentType* _tmp14_;
	GMimePart* _tmp15_;
	GMimeStreamGIO* stream;
	GMimeStreamGIO* _tmp16_;
	GMimeStreamGIO* _tmp17_;
	GMimePart* _tmp18_;
	GMimeStreamGIO* _tmp19_;
	GMimeDataWrapper* _tmp20_;
	GMimeDataWrapper* _tmp21_;
	GError* _inner_error0_;
};

struct _GearyRfC822MessageGetBufferPartData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyRFC822Message* self;
	GearyMemoryBuffer* buffer;
	gchar* basename;
	GearyMimeDispositionType disposition;
	GCancellable* cancellable;
	GMimePart* result;
	GearyMimeContentType* mime_type;
	GearyMimeContentType* _tmp0_;
	GearyMimeContentType* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GError* _tmp4_;
	GError* _tmp5_;
	GMimeContentType* content_type;
	GMimeParserOptions* _tmp6_;
	GMimeParserOptions* _tmp7_;
	GearyMimeContentType* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GMimeContentType* _tmp11_;
	GMimeContentType* _tmp12_;
	GMimeContentType* _tmp13_;
	GearyMimeContentType* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GError* _tmp19_;
	GError* _tmp20_;
	GMimePart* part;
	GMimePart* _tmp21_;
	GMimePart* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GMimePart* _tmp25_;
	GMimePart* _tmp26_;
	GMimeContentType* _tmp27_;
	GMimePart* _tmp28_;
	GMimeStreamMem* stream;
	GMimeStreamMem* _tmp29_;
	GMimePart* _tmp30_;
	GMimeStreamMem* _tmp31_;
	GMimeDataWrapper* _tmp32_;
	GMimeDataWrapper* _tmp33_;
	GError* _inner_error0_;
};

struct _GearyRfC822MessageBodyDataToPartData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearyRFC822Message* self;
	guint8* content;
	gint content_length1;
	gchar* charset;
	gchar* content_type;
	gboolean is_flowed;
	GCancellable* cancellable;
	GMimePart* result;
	GMimeStream* content_stream;
	GMimeStreamMem* _tmp0_;
	gchar* _tmp1_;
	GMimeStream* _tmp2_;
	gchar* _tmp3_;
	GMimeStreamFilter* filter_stream;
	GMimeStream* _tmp5_;
	GMimeStreamFilter* _tmp6_;
	GMimeStreamFilter* _tmp7_;
	GMimeFilterCharset* _tmp8_;
	GMimeFilterCharset* _tmp9_;
	GMimeContentEncoding encoding;
	GMimeStreamFilter* _tmp10_;
	gboolean _tmp11_;
	GMimeStreamFilter* _tmp12_;
	GMimeFilterUnix2Dos* _tmp13_;
	GMimeFilterUnix2Dos* _tmp14_;
	GMimeContentType* complete_type;
	GMimeParserOptions* _tmp15_;
	GMimeParserOptions* _tmp16_;
	GMimeContentType* _tmp17_;
	GMimeContentType* _tmp18_;
	GMimeContentType* _tmp19_;
	GMimeContentType* _tmp20_;
	GMimeDataWrapper* body;
	GMimeStreamFilter* _tmp21_;
	GMimeDataWrapper* _tmp22_;
	GMimePart* body_part;
	GMimePart* _tmp23_;
	GMimePart* _tmp24_;
	GMimeContentType* _tmp25_;
	GMimePart* _tmp26_;
	GMimeDataWrapper* _tmp27_;
	GMimePart* _tmp28_;
	GError* _inner_error0_;
};

static gint GearyRFC822Message_private_offset;
static gpointer geary_rf_c822_message_parent_class = NULL;
static GearyEmailHeaderSetIface * geary_rf_c822_message_geary_email_header_set_parent_iface = NULL;

VALA_EXTERN GMimeStreamMem* geary_rf_c822_utils_create_stream_mem (GearyMemoryBuffer* buffer);
static void _vala_GMimeParserOptions_free (GMimeParserOptions* self);
static GearyRFC822MailboxAddresses* geary_rf_c822_message_to_addresses (GearyRFC822Message* self,
                                                                 InternetAddressList* list,
                                                                 GError** error);
static GearyRFC822MessageIDList* geary_rf_c822_message_append_message_id (GearyRFC822Message* self,
                                                                   GearyRFC822MessageIDList* existing,
                                                                   const gchar* header_value,
                                                                   GError** error);
static void geary_rf_c822_message_construct_from_composed_email_data_free (gpointer _data);
static gboolean geary_rf_c822_message_construct_from_composed_email_co (GearyRfC822MessageNewFromComposedEmailData* _data_);
static void geary_rf_c822_message_body_data_to_part (GearyRFC822Message* self,
                                              guint8* content,
                                              gint content_length1,
                                              const gchar* charset,
                                              const gchar* content_type,
                                              gboolean is_flowed,
                                              GCancellable* cancellable,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
static GMimePart* geary_rf_c822_message_body_data_to_part_finish (GearyRFC822Message* self,
                                                           GAsyncResult* _res_,
                                                           GError** error);
static void geary_rf_c822_message_new_from_composed_email_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_);
static void geary_rf_c822_message_get_buffer_part (GearyRFC822Message* self,
                                            GearyMemoryBuffer* buffer,
                                            const gchar* basename,
                                            GearyMimeDispositionType disposition,
                                            GCancellable* cancellable,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
static GMimePart* geary_rf_c822_message_get_buffer_part_finish (GearyRFC822Message* self,
                                                         GAsyncResult* _res_,
                                                         GError** error);
static GMimeObject* geary_rf_c822_message_coalesce_related (GearyRFC822Message* self,
                                                     GeeList* parts,
                                                     const gchar* type);
static GMimeObject* geary_rf_c822_message_coalesce_parts (GearyRFC822Message* self,
                                                   GeeList* parts,
                                                   const gchar* subtype);
static void geary_rf_c822_message_get_file_part (GearyRFC822Message* self,
                                          GFile* file,
                                          GearyMimeDispositionType disposition,
                                          GCancellable* cancellable,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
static GMimePart* geary_rf_c822_message_get_file_part_finish (GearyRFC822Message* self,
                                                       GAsyncResult* _res_,
                                                       GError** error);
static void geary_rf_c822_message_get_file_part_data_free (gpointer _data);
static gboolean geary_rf_c822_message_get_file_part_co (GearyRfC822MessageGetFilePartData* _data_);
static void geary_rf_c822_message_get_file_part_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_);
static void geary_rf_c822_message_get_buffer_part_data_free (gpointer _data);
static gboolean geary_rf_c822_message_get_buffer_part_co (GearyRfC822MessageGetBufferPartData* _data_);
static void _vala_GMimeFormatOptions_free (GMimeFormatOptions* self);
static GearyMemoryBuffer* geary_rf_c822_message_message_to_memory_buffer (GearyRFC822Message* self,
                                                                   gboolean encode_lf,
                                                                   GearyRFC822MessageRFC822FormatOptions options,
                                                                   GError** error);
static gboolean geary_rf_c822_message_has_body_parts (GearyRFC822Message* self,
                                               GMimeObject* node,
                                               const gchar* text_subtype);
VALA_EXTERN GearyRFC822Part* geary_rf_c822_part_new (GMimeObject* source);
VALA_EXTERN GearyRFC822Part* geary_rf_c822_part_construct (GType object_type,
                                               GMimeObject* source);
static gboolean geary_rf_c822_message_construct_body_from_mime_parts (GearyRFC822Message* self,
                                                               GMimeObject* node,
                                                               GearyMimeMultipartSubtype container_subtype,
                                                               const gchar* text_subtype,
                                                               gboolean to_html,
                                                               GearyRFC822MessageInlinePartReplacer replacer,
                                                               gpointer replacer_target,
                                                               gchar** body,
                                                               GError** error);
static gchar* geary_rf_c822_message_internal_get_body (GearyRFC822Message* self,
                                                const gchar* text_subtype,
                                                gboolean to_html,
                                                GearyRFC822MessageInlinePartReplacer replacer,
                                                gpointer replacer_target,
                                                GError** error);
VALA_EXTERN GeeList* geary_rf_c822_message_get_attachments (GearyRFC822Message* self,
                                                GearyMimeDispositionType disposition,
                                                GError** error);
static void geary_rf_c822_message_get_attachments_recursively (GearyRFC822Message* self,
                                                        GeeList* attachments,
                                                        GMimeObject* root,
                                                        GearyMimeDispositionType requested_disposition,
                                                        GError** error);
static GMimePart* geary_rf_c822_message_tnef_attachment_to_gmime_part (GearyRFC822Message* self,
                                                                Attachment* a);
static void geary_rf_c822_message_find_sub_messages (GearyRFC822Message* self,
                                              GeeList* messages,
                                              GMimeObject* root,
                                              GError** error);
static void geary_rf_c822_message_body_data_to_part_data_free (gpointer _data);
static gboolean geary_rf_c822_message_body_data_to_part_co (GearyRfC822MessageBodyDataToPartData* _data_);
VALA_EXTERN void geary_rf_c822_utils_get_best_charset (GMimeStream* in_stream,
                                           GCancellable* cancellable,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
VALA_EXTERN gchar* geary_rf_c822_utils_get_best_charset_finish (GAsyncResult* _res_,
                                                    GError** error);
static void geary_rf_c822_message_body_data_to_part_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_);
VALA_EXTERN void geary_rf_c822_utils_get_best_encoding (GMimeStream* in_stream,
                                            GMimeEncodingConstraint constraint,
                                            GCancellable* cancellable,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
VALA_EXTERN GMimeContentEncoding geary_rf_c822_utils_get_best_encoding_finish (GAsyncResult* _res_,
                                                                   GError** error);
static void geary_rf_c822_message_finalize (GObject * obj);
static GType geary_rf_c822_message_get_type_once (void);
static void _vala_geary_rf_c822_message_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_geary_rf_c822_message_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);

static const gchar* GEARY_RF_C822_MESSAGE_HEADER_AUTH_RESULTS[3] = {"ARC-Authentication-Results", "Authentication-Results", "X-Original-Authentication-Results"};

static inline gpointer
geary_rf_c822_message_get_instance_private (GearyRFC822Message* self)
{
	return G_STRUCT_MEMBER_P (self, GearyRFC822Message_private_offset);
}

/** Options to use when serialising a message in RFC 822 format. */
 G_GNUC_NO_INLINE static GType
geary_rf_c822_message_rf_c822_format_options_get_type_once (void)
{
	static const GFlagsValue values[] = {{GEARY_RF_C822_MESSAGE_RF_C822_FORMAT_OPTIONS_NONE, "GEARY_RF_C822_MESSAGE_RF_C822_FORMAT_OPTIONS_NONE", "none"}, {GEARY_RF_C822_MESSAGE_RF_C822_FORMAT_OPTIONS_SMTP_FORMAT, "GEARY_RF_C822_MESSAGE_RF_C822_FORMAT_OPTIONS_SMTP_FORMAT", "smtp-format"}, {0, NULL, NULL}};
	GType geary_rf_c822_message_rf_c822_format_options_type_id;
	geary_rf_c822_message_rf_c822_format_options_type_id = g_flags_register_static ("GearyRFC822MessageRFC822FormatOptions", values);
	return geary_rf_c822_message_rf_c822_format_options_type_id;
}

GType
geary_rf_c822_message_rf_c822_format_options_get_type (void)
{
	static gsize geary_rf_c822_message_rf_c822_format_options_type_id__once = 0;
	if (g_once_init_enter (&geary_rf_c822_message_rf_c822_format_options_type_id__once)) {
		GType geary_rf_c822_message_rf_c822_format_options_type_id;
		geary_rf_c822_message_rf_c822_format_options_type_id = geary_rf_c822_message_rf_c822_format_options_get_type_once ();
		g_once_init_leave (&geary_rf_c822_message_rf_c822_format_options_type_id__once, geary_rf_c822_message_rf_c822_format_options_type_id);
	}
	return geary_rf_c822_message_rf_c822_format_options_type_id__once;
}

static GearyRFC822MailboxAddresses*
geary_rf_c822_message_real_get_from (GearyEmailHeaderSet* base)
{
	GearyRFC822MailboxAddresses* result;
	GearyRFC822Message* self;
	GearyRFC822MailboxAddresses* _tmp0_;
#line 73 "../src/engine/rfc822/rfc822-message.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_RF_C822_TYPE_MESSAGE, GearyRFC822Message);
#line 73 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = self->priv->_from;
#line 73 "../src/engine/rfc822/rfc822-message.vala"
	result = _tmp0_;
#line 73 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 801 "rfc822-message.c"
}

static GearyRFC822MailboxAddress*
geary_rf_c822_message_real_get_sender (GearyEmailHeaderSet* base)
{
	GearyRFC822MailboxAddress* result;
	GearyRFC822Message* self;
	GearyRFC822MailboxAddress* _tmp0_;
#line 77 "../src/engine/rfc822/rfc822-message.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_RF_C822_TYPE_MESSAGE, GearyRFC822Message);
#line 77 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = self->priv->_sender;
#line 77 "../src/engine/rfc822/rfc822-message.vala"
	result = _tmp0_;
#line 77 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 818 "rfc822-message.c"
}

static GearyRFC822MailboxAddresses*
geary_rf_c822_message_real_get_reply_to (GearyEmailHeaderSet* base)
{
	GearyRFC822MailboxAddresses* result;
	GearyRFC822Message* self;
	GearyRFC822MailboxAddresses* _tmp0_;
#line 81 "../src/engine/rfc822/rfc822-message.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_RF_C822_TYPE_MESSAGE, GearyRFC822Message);
#line 81 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = self->priv->_reply_to;
#line 81 "../src/engine/rfc822/rfc822-message.vala"
	result = _tmp0_;
#line 81 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 835 "rfc822-message.c"
}

static GearyRFC822MailboxAddresses*
geary_rf_c822_message_real_get_to (GearyEmailHeaderSet* base)
{
	GearyRFC822MailboxAddresses* result;
	GearyRFC822Message* self;
	GearyRFC822MailboxAddresses* _tmp0_;
#line 85 "../src/engine/rfc822/rfc822-message.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_RF_C822_TYPE_MESSAGE, GearyRFC822Message);
#line 85 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = self->priv->_to;
#line 85 "../src/engine/rfc822/rfc822-message.vala"
	result = _tmp0_;
#line 85 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 852 "rfc822-message.c"
}

static GearyRFC822MailboxAddresses*
geary_rf_c822_message_real_get_cc (GearyEmailHeaderSet* base)
{
	GearyRFC822MailboxAddresses* result;
	GearyRFC822Message* self;
	GearyRFC822MailboxAddresses* _tmp0_;
#line 89 "../src/engine/rfc822/rfc822-message.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_RF_C822_TYPE_MESSAGE, GearyRFC822Message);
#line 89 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = self->priv->_cc;
#line 89 "../src/engine/rfc822/rfc822-message.vala"
	result = _tmp0_;
#line 89 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 869 "rfc822-message.c"
}

static GearyRFC822MailboxAddresses*
geary_rf_c822_message_real_get_bcc (GearyEmailHeaderSet* base)
{
	GearyRFC822MailboxAddresses* result;
	GearyRFC822Message* self;
	GearyRFC822MailboxAddresses* _tmp0_;
#line 93 "../src/engine/rfc822/rfc822-message.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_RF_C822_TYPE_MESSAGE, GearyRFC822Message);
#line 93 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = self->priv->_bcc;
#line 93 "../src/engine/rfc822/rfc822-message.vala"
	result = _tmp0_;
#line 93 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 886 "rfc822-message.c"
}

static GearyRFC822MessageID*
geary_rf_c822_message_real_get_message_id (GearyEmailHeaderSet* base)
{
	GearyRFC822MessageID* result;
	GearyRFC822Message* self;
	GearyRFC822MessageID* _tmp0_;
#line 97 "../src/engine/rfc822/rfc822-message.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_RF_C822_TYPE_MESSAGE, GearyRFC822Message);
#line 97 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = self->priv->_message_id;
#line 97 "../src/engine/rfc822/rfc822-message.vala"
	result = _tmp0_;
#line 97 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 903 "rfc822-message.c"
}

static GearyRFC822MessageIDList*
geary_rf_c822_message_real_get_in_reply_to (GearyEmailHeaderSet* base)
{
	GearyRFC822MessageIDList* result;
	GearyRFC822Message* self;
	GearyRFC822MessageIDList* _tmp0_;
#line 101 "../src/engine/rfc822/rfc822-message.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_RF_C822_TYPE_MESSAGE, GearyRFC822Message);
#line 101 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = self->priv->_in_reply_to;
#line 101 "../src/engine/rfc822/rfc822-message.vala"
	result = _tmp0_;
#line 101 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 920 "rfc822-message.c"
}

static GearyRFC822MessageIDList*
geary_rf_c822_message_real_get_references (GearyEmailHeaderSet* base)
{
	GearyRFC822MessageIDList* result;
	GearyRFC822Message* self;
	GearyRFC822MessageIDList* _tmp0_;
#line 105 "../src/engine/rfc822/rfc822-message.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_RF_C822_TYPE_MESSAGE, GearyRFC822Message);
#line 105 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = self->priv->_references;
#line 105 "../src/engine/rfc822/rfc822-message.vala"
	result = _tmp0_;
#line 105 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 937 "rfc822-message.c"
}

static GearyRFC822Subject*
geary_rf_c822_message_real_get_subject (GearyEmailHeaderSet* base)
{
	GearyRFC822Subject* result;
	GearyRFC822Message* self;
	GearyRFC822Subject* _tmp0_;
#line 109 "../src/engine/rfc822/rfc822-message.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_RF_C822_TYPE_MESSAGE, GearyRFC822Message);
#line 109 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = self->priv->_subject;
#line 109 "../src/engine/rfc822/rfc822-message.vala"
	result = _tmp0_;
#line 109 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 954 "rfc822-message.c"
}

static GearyRFC822Date*
geary_rf_c822_message_real_get_date (GearyEmailHeaderSet* base)
{
	GearyRFC822Date* result;
	GearyRFC822Message* self;
	GearyRFC822Date* _tmp0_;
#line 113 "../src/engine/rfc822/rfc822-message.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_RF_C822_TYPE_MESSAGE, GearyRFC822Message);
#line 113 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = self->priv->_date;
#line 113 "../src/engine/rfc822/rfc822-message.vala"
	result = _tmp0_;
#line 113 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 971 "rfc822-message.c"
}

GearyRFC822AuthenticationResults*
geary_rf_c822_message_get_auth_results (GearyRFC822Message* self)
{
	GearyRFC822AuthenticationResults* result;
	GearyRFC822AuthenticationResults* _tmp0_;
#line 121 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), NULL);
#line 121 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = self->priv->_auth_results;
#line 121 "../src/engine/rfc822/rfc822-message.vala"
	result = _tmp0_;
#line 121 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 987 "rfc822-message.c"
}

const gchar*
geary_rf_c822_message_get_mailer (GearyRFC822Message* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 125 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), NULL);
#line 125 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = self->priv->_mailer;
#line 125 "../src/engine/rfc822/rfc822-message.vala"
	result = _tmp0_;
#line 125 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 1003 "rfc822-message.c"
}

void
geary_rf_c822_message_set_mailer (GearyRFC822Message* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 125 "../src/engine/rfc822/rfc822-message.vala"
	g_return_if_fail (GEARY_RF_C822_IS_MESSAGE (self));
#line 125 "../src/engine/rfc822/rfc822-message.vala"
	old_value = geary_rf_c822_message_get_mailer (self);
#line 125 "../src/engine/rfc822/rfc822-message.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1017 "rfc822-message.c"
		gchar* _tmp0_;
#line 125 "../src/engine/rfc822/rfc822-message.vala"
		_tmp0_ = g_strdup (value);
#line 125 "../src/engine/rfc822/rfc822-message.vala"
		_g_free0 (self->priv->_mailer);
#line 125 "../src/engine/rfc822/rfc822-message.vala"
		self->priv->_mailer = _tmp0_;
#line 125 "../src/engine/rfc822/rfc822-message.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_rf_c822_message_properties[GEARY_RF_C822_MESSAGE_MAILER_PROPERTY]);
#line 1027 "rfc822-message.c"
	}
}

static void
_vala_GMimeParserOptions_free (GMimeParserOptions* self)
{
#line 135 "../src/engine/rfc822/rfc822-message.vala"
	g_boxed_free (g_mime_parser_options_get_type (), self);
#line 1036 "rfc822-message.c"
}

GearyRFC822Message*
geary_rf_c822_message_construct (GType object_type,
                                 GearyRFC822Full* full,
                                 GError** error)
{
	GearyRFC822Message * self = NULL;
	GMimeParser* parser = NULL;
	GearyMemoryBuffer* _tmp0_;
	GearyMemoryBuffer* _tmp1_;
	GMimeStreamMem* _tmp2_;
	GMimeStreamMem* _tmp3_;
	GMimeParser* _tmp4_;
	GMimeParser* _tmp5_;
	GMimeMessage* message = NULL;
	GMimeParser* _tmp6_;
	GMimeParserOptions* _tmp7_;
	GMimeParserOptions* _tmp8_;
	GMimeMessage* _tmp9_;
	GMimeMessage* _tmp10_;
	GMimeMessage* _tmp11_;
	GMimeMessage* _tmp13_;
	GError* _inner_error0_ = NULL;
#line 131 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_FULL (full), NULL);
#line 132 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = geary_message_data_block_message_data_get_buffer (G_TYPE_CHECK_INSTANCE_CAST (full, GEARY_MESSAGE_DATA_TYPE_BLOCK_MESSAGE_DATA, GearyMessageDataBlockMessageData));
#line 132 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = _tmp0_;
#line 132 "../src/engine/rfc822/rfc822-message.vala"
	_tmp2_ = geary_rf_c822_utils_create_stream_mem (_tmp1_);
#line 132 "../src/engine/rfc822/rfc822-message.vala"
	_tmp3_ = _tmp2_;
#line 132 "../src/engine/rfc822/rfc822-message.vala"
	_tmp4_ = g_mime_parser_new_with_stream (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_mime_stream_get_type (), GMimeStream));
#line 132 "../src/engine/rfc822/rfc822-message.vala"
	_tmp5_ = _tmp4_;
#line 132 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_tmp3_);
#line 132 "../src/engine/rfc822/rfc822-message.vala"
	parser = _tmp5_;
#line 135 "../src/engine/rfc822/rfc822-message.vala"
	_tmp6_ = parser;
#line 135 "../src/engine/rfc822/rfc822-message.vala"
	_tmp7_ = geary_rf_c822_get_parser_options ();
#line 135 "../src/engine/rfc822/rfc822-message.vala"
	_tmp8_ = _tmp7_;
#line 135 "../src/engine/rfc822/rfc822-message.vala"
	_tmp9_ = g_mime_parser_construct_message (_tmp6_, _tmp8_);
#line 135 "../src/engine/rfc822/rfc822-message.vala"
	_tmp10_ = _tmp9_;
#line 135 "../src/engine/rfc822/rfc822-message.vala"
	__vala_GMimeParserOptions_free0 (_tmp8_);
#line 135 "../src/engine/rfc822/rfc822-message.vala"
	message = _tmp10_;
#line 136 "../src/engine/rfc822/rfc822-message.vala"
	_tmp11_ = message;
#line 136 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp11_ == NULL) {
#line 1097 "rfc822-message.c"
		GError* _tmp12_;
#line 137 "../src/engine/rfc822/rfc822-message.vala"
		_tmp12_ = g_error_new_literal (GEARY_RF_C822_ERROR, GEARY_RF_C822_ERROR_INVALID, "Unable to parse RFC 822 message");
#line 137 "../src/engine/rfc822/rfc822-message.vala"
		_inner_error0_ = _tmp12_;
#line 137 "../src/engine/rfc822/rfc822-message.vala"
		if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 137 "../src/engine/rfc822/rfc822-message.vala"
			g_propagate_error (error, _inner_error0_);
#line 137 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (message);
#line 137 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (parser);
#line 137 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (self);
#line 137 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 1115 "rfc822-message.c"
		} else {
#line 137 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (message);
#line 137 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (parser);
#line 137 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 137 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 137 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 1127 "rfc822-message.c"
		}
	}
#line 140 "../src/engine/rfc822/rfc822-message.vala"
	_tmp13_ = message;
#line 140 "../src/engine/rfc822/rfc822-message.vala"
	self = (GearyRFC822Message*) geary_rf_c822_message_construct_from_gmime_message (object_type, _tmp13_, &_inner_error0_);
#line 140 "../src/engine/rfc822/rfc822-message.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 140 "../src/engine/rfc822/rfc822-message.vala"
		if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 140 "../src/engine/rfc822/rfc822-message.vala"
			g_propagate_error (error, _inner_error0_);
#line 140 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (message);
#line 140 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (parser);
#line 140 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (self);
#line 140 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 1148 "rfc822-message.c"
		} else {
#line 140 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (message);
#line 140 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (parser);
#line 140 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 140 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 140 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 1160 "rfc822-message.c"
		}
	}
#line 131 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (message);
#line 131 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (parser);
#line 131 "../src/engine/rfc822/rfc822-message.vala"
	return self;
#line 1169 "rfc822-message.c"
}

GearyRFC822Message*
geary_rf_c822_message_new (GearyRFC822Full* full,
                           GError** error)
{
#line 131 "../src/engine/rfc822/rfc822-message.vala"
	return geary_rf_c822_message_construct (GEARY_RF_C822_TYPE_MESSAGE, full, error);
#line 1178 "rfc822-message.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 145 "../src/engine/rfc822/rfc822-message.vala"
	return self ? g_object_ref (self) : NULL;
#line 1186 "rfc822-message.c"
}

GearyRFC822Message*
geary_rf_c822_message_construct_from_gmime_message (GType object_type,
                                                    GMimeMessage* message,
                                                    GError** error)
{
	GearyRFC822Message * self = NULL;
	GMimeMessage* _tmp0_;
	GearyRFC822MailboxAddresses* _tmp1_ = NULL;
	InternetAddressList* _tmp2_;
	GearyRFC822MailboxAddresses* _tmp3_;
	GearyRFC822MailboxAddresses* _tmp4_;
	GearyRFC822MailboxAddresses* _tmp5_ = NULL;
	InternetAddressList* _tmp6_;
	GearyRFC822MailboxAddresses* _tmp7_;
	GearyRFC822MailboxAddresses* _tmp8_;
	GearyRFC822MailboxAddresses* _tmp9_ = NULL;
	InternetAddressList* _tmp10_;
	GearyRFC822MailboxAddresses* _tmp11_;
	GearyRFC822MailboxAddresses* _tmp12_;
	GearyRFC822MailboxAddresses* _tmp13_ = NULL;
	InternetAddressList* _tmp14_;
	GearyRFC822MailboxAddresses* _tmp15_;
	GearyRFC822MailboxAddresses* _tmp16_;
	GearyRFC822MailboxAddresses* _tmp17_ = NULL;
	InternetAddressList* _tmp18_;
	GearyRFC822MailboxAddresses* _tmp19_;
	GearyRFC822MailboxAddresses* _tmp20_;
	InternetAddressMailbox* sender = NULL;
	InternetAddressList* _tmp21_;
	InternetAddress* _tmp22_;
	InternetAddressMailbox* _tmp23_;
	InternetAddressMailbox* _tmp24_;
	gchar* subject = NULL;
	const gchar* _tmp27_;
	gchar* _tmp28_;
	const gchar* _tmp29_;
	GDateTime* date = NULL;
	GDateTime* _tmp32_;
	GDateTime* _tmp33_;
	gchar* message_id = NULL;
	const gchar* _tmp36_;
	gchar* _tmp37_;
	const gchar* _tmp38_;
	GMimeHeaderList* headers = NULL;
	GMimeHeaderList* _tmp48_;
	GMimeHeaderList* _tmp49_;
	const gchar* _tmp74_;
	GError* _inner_error0_ = NULL;
#line 143 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (message, g_mime_message_get_type ()), NULL);
#line 143 "../src/engine/rfc822/rfc822-message.vala"
	self = (GearyRFC822Message*) geary_base_object_construct (object_type);
#line 145 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = _g_object_ref0 (message);
#line 145 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (self->priv->message);
#line 145 "../src/engine/rfc822/rfc822-message.vala"
	self->priv->message = _tmp0_;
#line 147 "../src/engine/rfc822/rfc822-message.vala"
	_tmp2_ = g_mime_message_get_from (message);
#line 147 "../src/engine/rfc822/rfc822-message.vala"
	_tmp3_ = geary_rf_c822_message_to_addresses (self, _tmp2_, &_inner_error0_);
#line 147 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = _tmp3_;
#line 147 "../src/engine/rfc822/rfc822-message.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 147 "../src/engine/rfc822/rfc822-message.vala"
		if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 147 "../src/engine/rfc822/rfc822-message.vala"
			g_propagate_error (error, _inner_error0_);
#line 147 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (self);
#line 147 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 1263 "rfc822-message.c"
		} else {
#line 147 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 147 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 147 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 1271 "rfc822-message.c"
		}
	}
#line 147 "../src/engine/rfc822/rfc822-message.vala"
	_tmp4_ = _tmp1_;
#line 147 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = NULL;
#line 147 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (self->priv->_from);
#line 147 "../src/engine/rfc822/rfc822-message.vala"
	self->priv->_from = _tmp4_;
#line 148 "../src/engine/rfc822/rfc822-message.vala"
	_tmp6_ = g_mime_message_get_to (message);
#line 148 "../src/engine/rfc822/rfc822-message.vala"
	_tmp7_ = geary_rf_c822_message_to_addresses (self, _tmp6_, &_inner_error0_);
#line 148 "../src/engine/rfc822/rfc822-message.vala"
	_tmp5_ = _tmp7_;
#line 148 "../src/engine/rfc822/rfc822-message.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 148 "../src/engine/rfc822/rfc822-message.vala"
		if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 148 "../src/engine/rfc822/rfc822-message.vala"
			g_propagate_error (error, _inner_error0_);
#line 148 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_tmp1_);
#line 148 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (self);
#line 148 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 1300 "rfc822-message.c"
		} else {
#line 148 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_tmp1_);
#line 148 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 148 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 148 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 1310 "rfc822-message.c"
		}
	}
#line 148 "../src/engine/rfc822/rfc822-message.vala"
	_tmp8_ = _tmp5_;
#line 148 "../src/engine/rfc822/rfc822-message.vala"
	_tmp5_ = NULL;
#line 148 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (self->priv->_to);
#line 148 "../src/engine/rfc822/rfc822-message.vala"
	self->priv->_to = _tmp8_;
#line 149 "../src/engine/rfc822/rfc822-message.vala"
	_tmp10_ = g_mime_message_get_cc (message);
#line 149 "../src/engine/rfc822/rfc822-message.vala"
	_tmp11_ = geary_rf_c822_message_to_addresses (self, _tmp10_, &_inner_error0_);
#line 149 "../src/engine/rfc822/rfc822-message.vala"
	_tmp9_ = _tmp11_;
#line 149 "../src/engine/rfc822/rfc822-message.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 149 "../src/engine/rfc822/rfc822-message.vala"
		if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 149 "../src/engine/rfc822/rfc822-message.vala"
			g_propagate_error (error, _inner_error0_);
#line 149 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_tmp5_);
#line 149 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_tmp1_);
#line 149 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (self);
#line 149 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 1341 "rfc822-message.c"
		} else {
#line 149 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_tmp5_);
#line 149 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_tmp1_);
#line 149 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 149 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 149 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 1353 "rfc822-message.c"
		}
	}
#line 149 "../src/engine/rfc822/rfc822-message.vala"
	_tmp12_ = _tmp9_;
#line 149 "../src/engine/rfc822/rfc822-message.vala"
	_tmp9_ = NULL;
#line 149 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (self->priv->_cc);
#line 149 "../src/engine/rfc822/rfc822-message.vala"
	self->priv->_cc = _tmp12_;
#line 150 "../src/engine/rfc822/rfc822-message.vala"
	_tmp14_ = g_mime_message_get_bcc (message);
#line 150 "../src/engine/rfc822/rfc822-message.vala"
	_tmp15_ = geary_rf_c822_message_to_addresses (self, _tmp14_, &_inner_error0_);
#line 150 "../src/engine/rfc822/rfc822-message.vala"
	_tmp13_ = _tmp15_;
#line 150 "../src/engine/rfc822/rfc822-message.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 150 "../src/engine/rfc822/rfc822-message.vala"
		if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 150 "../src/engine/rfc822/rfc822-message.vala"
			g_propagate_error (error, _inner_error0_);
#line 150 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_tmp9_);
#line 150 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_tmp5_);
#line 150 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_tmp1_);
#line 150 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (self);
#line 150 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 1386 "rfc822-message.c"
		} else {
#line 150 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_tmp9_);
#line 150 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_tmp5_);
#line 150 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_tmp1_);
#line 150 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 150 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 150 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 1400 "rfc822-message.c"
		}
	}
#line 150 "../src/engine/rfc822/rfc822-message.vala"
	_tmp16_ = _tmp13_;
#line 150 "../src/engine/rfc822/rfc822-message.vala"
	_tmp13_ = NULL;
#line 150 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (self->priv->_bcc);
#line 150 "../src/engine/rfc822/rfc822-message.vala"
	self->priv->_bcc = _tmp16_;
#line 151 "../src/engine/rfc822/rfc822-message.vala"
	_tmp18_ = g_mime_message_get_reply_to (message);
#line 151 "../src/engine/rfc822/rfc822-message.vala"
	_tmp19_ = geary_rf_c822_message_to_addresses (self, _tmp18_, &_inner_error0_);
#line 151 "../src/engine/rfc822/rfc822-message.vala"
	_tmp17_ = _tmp19_;
#line 151 "../src/engine/rfc822/rfc822-message.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 151 "../src/engine/rfc822/rfc822-message.vala"
		if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 151 "../src/engine/rfc822/rfc822-message.vala"
			g_propagate_error (error, _inner_error0_);
#line 151 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_tmp13_);
#line 151 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_tmp9_);
#line 151 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_tmp5_);
#line 151 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_tmp1_);
#line 151 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (self);
#line 151 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 1435 "rfc822-message.c"
		} else {
#line 151 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_tmp13_);
#line 151 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_tmp9_);
#line 151 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_tmp5_);
#line 151 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_tmp1_);
#line 151 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 151 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 151 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 1451 "rfc822-message.c"
		}
	}
#line 151 "../src/engine/rfc822/rfc822-message.vala"
	_tmp20_ = _tmp17_;
#line 151 "../src/engine/rfc822/rfc822-message.vala"
	_tmp17_ = NULL;
#line 151 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (self->priv->_reply_to);
#line 151 "../src/engine/rfc822/rfc822-message.vala"
	self->priv->_reply_to = _tmp20_;
#line 153 "../src/engine/rfc822/rfc822-message.vala"
	_tmp21_ = g_mime_message_get_sender (message);
#line 153 "../src/engine/rfc822/rfc822-message.vala"
	_tmp22_ = internet_address_list_get_address (_tmp21_, 0);
#line 153 "../src/engine/rfc822/rfc822-message.vala"
	_tmp23_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp22_, internet_address_mailbox_get_type ()) ? ((InternetAddressMailbox*) _tmp22_) : NULL);
#line 153 "../src/engine/rfc822/rfc822-message.vala"
	sender = _tmp23_;
#line 156 "../src/engine/rfc822/rfc822-message.vala"
	_tmp24_ = sender;
#line 156 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp24_ != NULL) {
#line 1474 "rfc822-message.c"
		InternetAddressMailbox* _tmp25_;
		GearyRFC822MailboxAddress* _tmp26_;
#line 157 "../src/engine/rfc822/rfc822-message.vala"
		_tmp25_ = sender;
#line 157 "../src/engine/rfc822/rfc822-message.vala"
		_tmp26_ = geary_rf_c822_mailbox_address_new_from_gmime (_tmp25_);
#line 157 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (self->priv->_sender);
#line 157 "../src/engine/rfc822/rfc822-message.vala"
		self->priv->_sender = _tmp26_;
#line 1485 "rfc822-message.c"
	}
#line 160 "../src/engine/rfc822/rfc822-message.vala"
	_tmp27_ = g_mime_message_get_subject (message);
#line 160 "../src/engine/rfc822/rfc822-message.vala"
	_tmp28_ = g_strdup (_tmp27_);
#line 160 "../src/engine/rfc822/rfc822-message.vala"
	subject = _tmp28_;
#line 161 "../src/engine/rfc822/rfc822-message.vala"
	_tmp29_ = subject;
#line 161 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp29_ != NULL) {
#line 1497 "rfc822-message.c"
		const gchar* _tmp30_;
		GearyRFC822Subject* _tmp31_;
#line 162 "../src/engine/rfc822/rfc822-message.vala"
		_tmp30_ = subject;
#line 162 "../src/engine/rfc822/rfc822-message.vala"
		_tmp31_ = geary_rf_c822_subject_new (_tmp30_);
#line 162 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (self->priv->_subject);
#line 162 "../src/engine/rfc822/rfc822-message.vala"
		self->priv->_subject = _tmp31_;
#line 1508 "rfc822-message.c"
	}
#line 166 "../src/engine/rfc822/rfc822-message.vala"
	_tmp32_ = g_mime_message_get_date (message);
#line 166 "../src/engine/rfc822/rfc822-message.vala"
	date = _tmp32_;
#line 167 "../src/engine/rfc822/rfc822-message.vala"
	_tmp33_ = date;
#line 167 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp33_ != NULL) {
#line 1518 "rfc822-message.c"
		GDateTime* _tmp34_;
		GearyRFC822Date* _tmp35_;
#line 168 "../src/engine/rfc822/rfc822-message.vala"
		_tmp34_ = date;
#line 168 "../src/engine/rfc822/rfc822-message.vala"
		_tmp35_ = geary_rf_c822_date_new (_tmp34_);
#line 168 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (self->priv->_date);
#line 168 "../src/engine/rfc822/rfc822-message.vala"
		self->priv->_date = _tmp35_;
#line 1529 "rfc822-message.c"
	}
#line 171 "../src/engine/rfc822/rfc822-message.vala"
	_tmp36_ = g_mime_message_get_message_id (message);
#line 171 "../src/engine/rfc822/rfc822-message.vala"
	_tmp37_ = g_strdup (_tmp36_);
#line 171 "../src/engine/rfc822/rfc822-message.vala"
	message_id = _tmp37_;
#line 172 "../src/engine/rfc822/rfc822-message.vala"
	_tmp38_ = message_id;
#line 172 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp38_ != NULL) {
#line 1541 "rfc822-message.c"
		const gchar* _tmp39_;
		GearyRFC822MessageID* _tmp40_;
#line 173 "../src/engine/rfc822/rfc822-message.vala"
		_tmp39_ = message_id;
#line 173 "../src/engine/rfc822/rfc822-message.vala"
		_tmp40_ = geary_rf_c822_message_id_new (_tmp39_);
#line 173 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (self->priv->_message_id);
#line 173 "../src/engine/rfc822/rfc822-message.vala"
		self->priv->_message_id = _tmp40_;
#line 1552 "rfc822-message.c"
	}
	{
		const gchar** field_collection = NULL;
		gint field_collection_length1 = 0;
		gint _field_collection_size_ = 0;
		gint field_it = 0;
#line 176 "../src/engine/rfc822/rfc822-message.vala"
		field_collection = GEARY_RF_C822_MESSAGE_HEADER_AUTH_RESULTS;
#line 176 "../src/engine/rfc822/rfc822-message.vala"
		field_collection_length1 = G_N_ELEMENTS (GEARY_RF_C822_MESSAGE_HEADER_AUTH_RESULTS);
#line 176 "../src/engine/rfc822/rfc822-message.vala"
		for (field_it = 0; field_it < field_collection_length1; field_it = field_it + 1) {
#line 1565 "rfc822-message.c"
			gchar* _tmp41_;
			gchar* field = NULL;
#line 176 "../src/engine/rfc822/rfc822-message.vala"
			_tmp41_ = g_strdup (field_collection[field_it]);
#line 176 "../src/engine/rfc822/rfc822-message.vala"
			field = _tmp41_;
#line 1572 "rfc822-message.c"
			{
				gchar* auth_results = NULL;
				const gchar* _tmp42_;
				const gchar* _tmp43_;
				gchar* _tmp44_;
				const gchar* _tmp45_;
#line 177 "../src/engine/rfc822/rfc822-message.vala"
				_tmp42_ = field;
#line 177 "../src/engine/rfc822/rfc822-message.vala"
				_tmp43_ = g_mime_object_get_header (G_TYPE_CHECK_INSTANCE_CAST (message, g_mime_object_get_type (), GMimeObject), _tmp42_);
#line 177 "../src/engine/rfc822/rfc822-message.vala"
				_tmp44_ = g_strdup (_tmp43_);
#line 177 "../src/engine/rfc822/rfc822-message.vala"
				auth_results = _tmp44_;
#line 178 "../src/engine/rfc822/rfc822-message.vala"
				_tmp45_ = auth_results;
#line 178 "../src/engine/rfc822/rfc822-message.vala"
				if (_tmp45_ != NULL) {
#line 1591 "rfc822-message.c"
					const gchar* _tmp46_;
					GearyRFC822AuthenticationResults* _tmp47_;
#line 179 "../src/engine/rfc822/rfc822-message.vala"
					_tmp46_ = auth_results;
#line 179 "../src/engine/rfc822/rfc822-message.vala"
					_tmp47_ = geary_rf_c822_authentication_results_new (_tmp46_);
#line 179 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (self->priv->_auth_results);
#line 179 "../src/engine/rfc822/rfc822-message.vala"
					self->priv->_auth_results = _tmp47_;
#line 180 "../src/engine/rfc822/rfc822-message.vala"
					_g_free0 (auth_results);
#line 180 "../src/engine/rfc822/rfc822-message.vala"
					_g_free0 (field);
#line 180 "../src/engine/rfc822/rfc822-message.vala"
					break;
#line 1608 "rfc822-message.c"
				}
#line 176 "../src/engine/rfc822/rfc822-message.vala"
				_g_free0 (auth_results);
#line 176 "../src/engine/rfc822/rfc822-message.vala"
				_g_free0 (field);
#line 1614 "rfc822-message.c"
			}
		}
	}
#line 186 "../src/engine/rfc822/rfc822-message.vala"
	_tmp48_ = g_mime_object_get_header_list (G_TYPE_CHECK_INSTANCE_CAST (message, g_mime_object_get_type (), GMimeObject));
#line 186 "../src/engine/rfc822/rfc822-message.vala"
	_tmp49_ = _g_object_ref0 (_tmp48_);
#line 186 "../src/engine/rfc822/rfc822-message.vala"
	headers = _tmp49_;
#line 1624 "rfc822-message.c"
	{
		gint i = 0;
#line 187 "../src/engine/rfc822/rfc822-message.vala"
		i = 0;
#line 1629 "rfc822-message.c"
		{
			gboolean _tmp50_ = FALSE;
#line 187 "../src/engine/rfc822/rfc822-message.vala"
			_tmp50_ = TRUE;
#line 187 "../src/engine/rfc822/rfc822-message.vala"
			while (TRUE) {
#line 1636 "rfc822-message.c"
				GMimeHeaderList* _tmp52_;
				GMimeHeader* header = NULL;
				GMimeHeaderList* _tmp53_;
				GMimeHeader* _tmp54_;
				GMimeHeader* _tmp55_;
				GMimeHeader* _tmp56_;
				const gchar* _tmp57_;
				gchar* _tmp58_;
				gchar* _tmp59_;
				GQuark _tmp61_ = 0U;
#line 189 "../src/engine/rfc822/rfc822-message.vala"
				static GQuark _tmp60_label0 = 0;
#line 189 "../src/engine/rfc822/rfc822-message.vala"
				static GQuark _tmp60_label1 = 0;
#line 187 "../src/engine/rfc822/rfc822-message.vala"
				if (!_tmp50_) {
#line 1653 "rfc822-message.c"
					gint _tmp51_;
#line 187 "../src/engine/rfc822/rfc822-message.vala"
					_tmp51_ = i;
#line 187 "../src/engine/rfc822/rfc822-message.vala"
					i = _tmp51_ + 1;
#line 1659 "rfc822-message.c"
				}
#line 187 "../src/engine/rfc822/rfc822-message.vala"
				_tmp50_ = FALSE;
#line 187 "../src/engine/rfc822/rfc822-message.vala"
				_tmp52_ = headers;
#line 187 "../src/engine/rfc822/rfc822-message.vala"
				if (!(i < g_mime_header_list_get_count (_tmp52_))) {
#line 187 "../src/engine/rfc822/rfc822-message.vala"
					break;
#line 1669 "rfc822-message.c"
				}
#line 188 "../src/engine/rfc822/rfc822-message.vala"
				_tmp53_ = headers;
#line 188 "../src/engine/rfc822/rfc822-message.vala"
				_tmp54_ = g_mime_header_list_get_header_at (_tmp53_, i);
#line 188 "../src/engine/rfc822/rfc822-message.vala"
				_tmp55_ = _g_object_ref0 (_tmp54_);
#line 188 "../src/engine/rfc822/rfc822-message.vala"
				header = _tmp55_;
#line 189 "../src/engine/rfc822/rfc822-message.vala"
				_tmp56_ = header;
#line 189 "../src/engine/rfc822/rfc822-message.vala"
				_tmp57_ = g_mime_header_get_name (_tmp56_);
#line 189 "../src/engine/rfc822/rfc822-message.vala"
				_tmp58_ = g_utf8_strdown (_tmp57_, (gssize) -1);
#line 189 "../src/engine/rfc822/rfc822-message.vala"
				_tmp59_ = _tmp58_;
#line 189 "../src/engine/rfc822/rfc822-message.vala"
				_tmp61_ = (NULL == _tmp59_) ? 0 : g_quark_from_string (_tmp59_);
#line 189 "../src/engine/rfc822/rfc822-message.vala"
				g_free (_tmp59_);
#line 189 "../src/engine/rfc822/rfc822-message.vala"
				if (_tmp61_ == ((0 != _tmp60_label0) ? _tmp60_label0 : (_tmp60_label0 = g_quark_from_static_string ("in-reply-to")))) {
#line 189 "../src/engine/rfc822/rfc822-message.vala"
					switch (0) {
#line 1695 "rfc822-message.c"
						default:
						{
							GearyRFC822MessageIDList* _tmp62_ = NULL;
							GearyRFC822MessageIDList* _tmp63_;
							GMimeHeader* _tmp64_;
							const gchar* _tmp65_;
							GearyRFC822MessageIDList* _tmp66_;
							GearyRFC822MessageIDList* _tmp67_;
#line 191 "../src/engine/rfc822/rfc822-message.vala"
							_tmp63_ = self->priv->_in_reply_to;
#line 191 "../src/engine/rfc822/rfc822-message.vala"
							_tmp64_ = header;
#line 191 "../src/engine/rfc822/rfc822-message.vala"
							_tmp65_ = g_mime_header_get_raw_value (_tmp64_);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
							_tmp66_ = geary_rf_c822_message_append_message_id (self, _tmp63_, _tmp65_, &_inner_error0_);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
							_tmp62_ = _tmp66_;
#line 191 "../src/engine/rfc822/rfc822-message.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 191 "../src/engine/rfc822/rfc822-message.vala"
								if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									g_propagate_error (error, _inner_error0_);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (header);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (headers);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									_g_free0 (message_id);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									_g_free0 (subject);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (sender);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (_tmp17_);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (_tmp13_);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (_tmp9_);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (_tmp5_);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (_tmp1_);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (self);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									return NULL;
#line 1744 "rfc822-message.c"
								} else {
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (header);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (headers);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									_g_free0 (message_id);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									_g_free0 (subject);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (sender);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (_tmp17_);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (_tmp13_);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (_tmp9_);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (_tmp5_);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (_tmp1_);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									g_clear_error (&_inner_error0_);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
									return NULL;
#line 1772 "rfc822-message.c"
								}
							}
#line 191 "../src/engine/rfc822/rfc822-message.vala"
							_tmp67_ = _tmp62_;
#line 191 "../src/engine/rfc822/rfc822-message.vala"
							_tmp62_ = NULL;
#line 191 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (self->priv->_in_reply_to);
#line 191 "../src/engine/rfc822/rfc822-message.vala"
							self->priv->_in_reply_to = _tmp67_;
#line 194 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (_tmp62_);
#line 194 "../src/engine/rfc822/rfc822-message.vala"
							break;
#line 1787 "rfc822-message.c"
						}
					}
				} else if (_tmp61_ == ((0 != _tmp60_label1) ? _tmp60_label1 : (_tmp60_label1 = g_quark_from_static_string ("references")))) {
#line 189 "../src/engine/rfc822/rfc822-message.vala"
					switch (0) {
#line 1793 "rfc822-message.c"
						default:
						{
							GearyRFC822MessageIDList* _tmp68_ = NULL;
							GearyRFC822MessageIDList* _tmp69_;
							GMimeHeader* _tmp70_;
							const gchar* _tmp71_;
							GearyRFC822MessageIDList* _tmp72_;
							GearyRFC822MessageIDList* _tmp73_;
#line 197 "../src/engine/rfc822/rfc822-message.vala"
							_tmp69_ = self->priv->_references;
#line 197 "../src/engine/rfc822/rfc822-message.vala"
							_tmp70_ = header;
#line 197 "../src/engine/rfc822/rfc822-message.vala"
							_tmp71_ = g_mime_header_get_raw_value (_tmp70_);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
							_tmp72_ = geary_rf_c822_message_append_message_id (self, _tmp69_, _tmp71_, &_inner_error0_);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
							_tmp68_ = _tmp72_;
#line 197 "../src/engine/rfc822/rfc822-message.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 197 "../src/engine/rfc822/rfc822-message.vala"
								if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									g_propagate_error (error, _inner_error0_);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (header);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (headers);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									_g_free0 (message_id);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									_g_free0 (subject);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (sender);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (_tmp17_);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (_tmp13_);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (_tmp9_);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (_tmp5_);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (_tmp1_);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (self);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									return NULL;
#line 1842 "rfc822-message.c"
								} else {
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (header);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (headers);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									_g_free0 (message_id);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									_g_free0 (subject);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (sender);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (_tmp17_);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (_tmp13_);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (_tmp9_);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (_tmp5_);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									_g_object_unref0 (_tmp1_);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									g_clear_error (&_inner_error0_);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
									return NULL;
#line 1870 "rfc822-message.c"
								}
							}
#line 197 "../src/engine/rfc822/rfc822-message.vala"
							_tmp73_ = _tmp68_;
#line 197 "../src/engine/rfc822/rfc822-message.vala"
							_tmp68_ = NULL;
#line 197 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (self->priv->_references);
#line 197 "../src/engine/rfc822/rfc822-message.vala"
							self->priv->_references = _tmp73_;
#line 200 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (_tmp68_);
#line 200 "../src/engine/rfc822/rfc822-message.vala"
							break;
#line 1885 "rfc822-message.c"
						}
					}
				} else {
#line 189 "../src/engine/rfc822/rfc822-message.vala"
					switch (0) {
#line 1891 "rfc822-message.c"
						default:
						{
#line 203 "../src/engine/rfc822/rfc822-message.vala"
							break;
#line 1896 "rfc822-message.c"
						}
					}
				}
#line 187 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (header);
#line 1902 "rfc822-message.c"
			}
		}
	}
#line 207 "../src/engine/rfc822/rfc822-message.vala"
	_tmp74_ = g_mime_object_get_header (G_TYPE_CHECK_INSTANCE_CAST (message, g_mime_object_get_type (), GMimeObject), "X-Mailer");
#line 207 "../src/engine/rfc822/rfc822-message.vala"
	geary_rf_c822_message_set_mailer (self, _tmp74_);
#line 143 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (headers);
#line 143 "../src/engine/rfc822/rfc822-message.vala"
	_g_free0 (message_id);
#line 143 "../src/engine/rfc822/rfc822-message.vala"
	_g_free0 (subject);
#line 143 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (sender);
#line 143 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_tmp17_);
#line 143 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_tmp13_);
#line 143 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_tmp9_);
#line 143 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_tmp5_);
#line 143 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_tmp1_);
#line 143 "../src/engine/rfc822/rfc822-message.vala"
	return self;
#line 1930 "rfc822-message.c"
}

GearyRFC822Message*
geary_rf_c822_message_new_from_gmime_message (GMimeMessage* message,
                                              GError** error)
{
#line 143 "../src/engine/rfc822/rfc822-message.vala"
	return geary_rf_c822_message_construct_from_gmime_message (GEARY_RF_C822_TYPE_MESSAGE, message, error);
#line 1939 "rfc822-message.c"
}

GearyRFC822Message*
geary_rf_c822_message_construct_from_buffer (GType object_type,
                                             GearyMemoryBuffer* full_email,
                                             GError** error)
{
	GearyRFC822Message * self = NULL;
	GearyRFC822Full* _tmp0_;
	GearyRFC822Full* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 210 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_MEMORY_IS_BUFFER (full_email), NULL);
#line 212 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = geary_rf_c822_full_new (full_email);
#line 212 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = _tmp0_;
#line 212 "../src/engine/rfc822/rfc822-message.vala"
	self = (GearyRFC822Message*) geary_rf_c822_message_construct (object_type, _tmp1_, &_inner_error0_);
#line 212 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_tmp1_);
#line 212 "../src/engine/rfc822/rfc822-message.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 212 "../src/engine/rfc822/rfc822-message.vala"
		if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 212 "../src/engine/rfc822/rfc822-message.vala"
			g_propagate_error (error, _inner_error0_);
#line 212 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (self);
#line 212 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 1971 "rfc822-message.c"
		} else {
#line 212 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 212 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 212 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 1979 "rfc822-message.c"
		}
	}
#line 210 "../src/engine/rfc822/rfc822-message.vala"
	return self;
#line 1984 "rfc822-message.c"
}

GearyRFC822Message*
geary_rf_c822_message_new_from_buffer (GearyMemoryBuffer* full_email,
                                       GError** error)
{
#line 210 "../src/engine/rfc822/rfc822-message.vala"
	return geary_rf_c822_message_construct_from_buffer (GEARY_RF_C822_TYPE_MESSAGE, full_email, error);
#line 1993 "rfc822-message.c"
}

GearyRFC822Message*
geary_rf_c822_message_construct_from_parts (GType object_type,
                                            GearyRFC822Header* header,
                                            GearyRFC822Text* body,
                                            GError** error)
{
	GearyRFC822Message * self = NULL;
	GMimeStreamCat* stream_cat = NULL;
	GMimeStreamCat* _tmp0_;
	GearyMemoryBuffer* _tmp1_;
	GearyMemoryBuffer* _tmp2_;
	gsize _tmp3_;
	gsize _tmp4_;
	GearyMemoryBuffer* _tmp15_;
	GearyMemoryBuffer* _tmp16_;
	gsize _tmp17_;
	gsize _tmp18_;
	GMimeParser* parser = NULL;
	GMimeStreamCat* _tmp28_;
	GMimeParser* _tmp29_;
	GMimeMessage* message = NULL;
	GMimeParser* _tmp30_;
	GMimeParserOptions* _tmp31_;
	GMimeParserOptions* _tmp32_;
	GMimeMessage* _tmp33_;
	GMimeMessage* _tmp34_;
	GMimeMessage* _tmp35_;
	GMimeMessage* _tmp37_;
	GError* _inner_error0_ = NULL;
#line 215 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_HEADER (header), NULL);
#line 215 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_TEXT (body), NULL);
#line 217 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = (GMimeStreamCat*) g_mime_stream_cat_new ();
#line 217 "../src/engine/rfc822/rfc822-message.vala"
	stream_cat = _tmp0_;
#line 219 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = geary_message_data_block_message_data_get_buffer (G_TYPE_CHECK_INSTANCE_CAST (header, GEARY_MESSAGE_DATA_TYPE_BLOCK_MESSAGE_DATA, GearyMessageDataBlockMessageData));
#line 219 "../src/engine/rfc822/rfc822-message.vala"
	_tmp2_ = _tmp1_;
#line 219 "../src/engine/rfc822/rfc822-message.vala"
	_tmp3_ = geary_memory_buffer_get_size (_tmp2_);
#line 219 "../src/engine/rfc822/rfc822-message.vala"
	_tmp4_ = _tmp3_;
#line 219 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp4_ != ((gsize) 0)) {
#line 2043 "rfc822-message.c"
		GMimeStreamCat* _tmp5_;
		GearyMemoryBuffer* _tmp6_;
		GearyMemoryBuffer* _tmp7_;
		GBytes* _tmp8_;
		GBytes* _tmp9_;
		gsize _tmp10_ = 0;
		guint8* _tmp11_;
		GMimeStreamMem* _tmp12_;
		GMimeStreamMem* _tmp13_;
#line 220 "../src/engine/rfc822/rfc822-message.vala"
		_tmp5_ = stream_cat;
#line 220 "../src/engine/rfc822/rfc822-message.vala"
		_tmp6_ = geary_message_data_block_message_data_get_buffer (G_TYPE_CHECK_INSTANCE_CAST (header, GEARY_MESSAGE_DATA_TYPE_BLOCK_MESSAGE_DATA, GearyMessageDataBlockMessageData));
#line 220 "../src/engine/rfc822/rfc822-message.vala"
		_tmp7_ = _tmp6_;
#line 220 "../src/engine/rfc822/rfc822-message.vala"
		_tmp8_ = geary_memory_buffer_get_bytes (_tmp7_);
#line 220 "../src/engine/rfc822/rfc822-message.vala"
		_tmp9_ = _tmp8_;
#line 220 "../src/engine/rfc822/rfc822-message.vala"
		_tmp11_ = g_bytes_get_data (_tmp9_, &_tmp10_);
#line 220 "../src/engine/rfc822/rfc822-message.vala"
		_tmp12_ = (GMimeStreamMem*) g_mime_stream_mem_new_with_buffer (_tmp11_, _tmp10_);
#line 220 "../src/engine/rfc822/rfc822-message.vala"
		_tmp13_ = _tmp12_;
#line 220 "../src/engine/rfc822/rfc822-message.vala"
		g_mime_stream_cat_add_source (_tmp5_, G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, g_mime_stream_get_type (), GMimeStream));
#line 220 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_tmp13_);
#line 220 "../src/engine/rfc822/rfc822-message.vala"
		_g_bytes_unref0 (_tmp9_);
#line 2075 "rfc822-message.c"
	} else {
		GError* _tmp14_;
#line 222 "../src/engine/rfc822/rfc822-message.vala"
		_tmp14_ = g_error_new_literal (GEARY_RF_C822_ERROR, GEARY_RF_C822_ERROR_INVALID, "Missing header in RFC 822 message");
#line 222 "../src/engine/rfc822/rfc822-message.vala"
		_inner_error0_ = _tmp14_;
#line 222 "../src/engine/rfc822/rfc822-message.vala"
		if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 222 "../src/engine/rfc822/rfc822-message.vala"
			g_propagate_error (error, _inner_error0_);
#line 222 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (stream_cat);
#line 222 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (self);
#line 222 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 2092 "rfc822-message.c"
		} else {
#line 222 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (stream_cat);
#line 222 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 222 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 222 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 2102 "rfc822-message.c"
		}
	}
#line 224 "../src/engine/rfc822/rfc822-message.vala"
	_tmp15_ = geary_message_data_block_message_data_get_buffer (G_TYPE_CHECK_INSTANCE_CAST (body, GEARY_MESSAGE_DATA_TYPE_BLOCK_MESSAGE_DATA, GearyMessageDataBlockMessageData));
#line 224 "../src/engine/rfc822/rfc822-message.vala"
	_tmp16_ = _tmp15_;
#line 224 "../src/engine/rfc822/rfc822-message.vala"
	_tmp17_ = geary_memory_buffer_get_size (_tmp16_);
#line 224 "../src/engine/rfc822/rfc822-message.vala"
	_tmp18_ = _tmp17_;
#line 224 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp18_ != ((gsize) 0)) {
#line 2115 "rfc822-message.c"
		GMimeStreamCat* _tmp19_;
		GearyMemoryBuffer* _tmp20_;
		GearyMemoryBuffer* _tmp21_;
		GBytes* _tmp22_;
		GBytes* _tmp23_;
		gsize _tmp24_ = 0;
		guint8* _tmp25_;
		GMimeStreamMem* _tmp26_;
		GMimeStreamMem* _tmp27_;
#line 225 "../src/engine/rfc822/rfc822-message.vala"
		_tmp19_ = stream_cat;
#line 225 "../src/engine/rfc822/rfc822-message.vala"
		_tmp20_ = geary_message_data_block_message_data_get_buffer (G_TYPE_CHECK_INSTANCE_CAST (body, GEARY_MESSAGE_DATA_TYPE_BLOCK_MESSAGE_DATA, GearyMessageDataBlockMessageData));
#line 225 "../src/engine/rfc822/rfc822-message.vala"
		_tmp21_ = _tmp20_;
#line 225 "../src/engine/rfc822/rfc822-message.vala"
		_tmp22_ = geary_memory_buffer_get_bytes (_tmp21_);
#line 225 "../src/engine/rfc822/rfc822-message.vala"
		_tmp23_ = _tmp22_;
#line 225 "../src/engine/rfc822/rfc822-message.vala"
		_tmp25_ = g_bytes_get_data (_tmp23_, &_tmp24_);
#line 225 "../src/engine/rfc822/rfc822-message.vala"
		_tmp26_ = (GMimeStreamMem*) g_mime_stream_mem_new_with_buffer (_tmp25_, _tmp24_);
#line 225 "../src/engine/rfc822/rfc822-message.vala"
		_tmp27_ = _tmp26_;
#line 225 "../src/engine/rfc822/rfc822-message.vala"
		g_mime_stream_cat_add_source (_tmp19_, G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, g_mime_stream_get_type (), GMimeStream));
#line 225 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_tmp27_);
#line 225 "../src/engine/rfc822/rfc822-message.vala"
		_g_bytes_unref0 (_tmp23_);
#line 2147 "rfc822-message.c"
	}
#line 228 "../src/engine/rfc822/rfc822-message.vala"
	_tmp28_ = stream_cat;
#line 228 "../src/engine/rfc822/rfc822-message.vala"
	_tmp29_ = g_mime_parser_new_with_stream (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, g_mime_stream_get_type (), GMimeStream));
#line 228 "../src/engine/rfc822/rfc822-message.vala"
	parser = _tmp29_;
#line 229 "../src/engine/rfc822/rfc822-message.vala"
	_tmp30_ = parser;
#line 229 "../src/engine/rfc822/rfc822-message.vala"
	_tmp31_ = geary_rf_c822_get_parser_options ();
#line 229 "../src/engine/rfc822/rfc822-message.vala"
	_tmp32_ = _tmp31_;
#line 229 "../src/engine/rfc822/rfc822-message.vala"
	_tmp33_ = g_mime_parser_construct_message (_tmp30_, _tmp32_);
#line 229 "../src/engine/rfc822/rfc822-message.vala"
	_tmp34_ = _tmp33_;
#line 229 "../src/engine/rfc822/rfc822-message.vala"
	__vala_GMimeParserOptions_free0 (_tmp32_);
#line 229 "../src/engine/rfc822/rfc822-message.vala"
	message = _tmp34_;
#line 230 "../src/engine/rfc822/rfc822-message.vala"
	_tmp35_ = message;
#line 230 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp35_ == NULL) {
#line 2173 "rfc822-message.c"
		GError* _tmp36_;
#line 231 "../src/engine/rfc822/rfc822-message.vala"
		_tmp36_ = g_error_new_literal (GEARY_RF_C822_ERROR, GEARY_RF_C822_ERROR_INVALID, "Unable to parse RFC 822 message");
#line 231 "../src/engine/rfc822/rfc822-message.vala"
		_inner_error0_ = _tmp36_;
#line 231 "../src/engine/rfc822/rfc822-message.vala"
		if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 231 "../src/engine/rfc822/rfc822-message.vala"
			g_propagate_error (error, _inner_error0_);
#line 231 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (message);
#line 231 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (parser);
#line 231 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (stream_cat);
#line 231 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (self);
#line 231 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 2193 "rfc822-message.c"
		} else {
#line 231 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (message);
#line 231 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (parser);
#line 231 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (stream_cat);
#line 231 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 231 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 231 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 2207 "rfc822-message.c"
		}
	}
#line 234 "../src/engine/rfc822/rfc822-message.vala"
	_tmp37_ = message;
#line 234 "../src/engine/rfc822/rfc822-message.vala"
	self = (GearyRFC822Message*) geary_rf_c822_message_construct_from_gmime_message (object_type, _tmp37_, &_inner_error0_);
#line 234 "../src/engine/rfc822/rfc822-message.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 234 "../src/engine/rfc822/rfc822-message.vala"
		if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 234 "../src/engine/rfc822/rfc822-message.vala"
			g_propagate_error (error, _inner_error0_);
#line 234 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (message);
#line 234 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (parser);
#line 234 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (stream_cat);
#line 234 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (self);
#line 234 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 2230 "rfc822-message.c"
		} else {
#line 234 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (message);
#line 234 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (parser);
#line 234 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (stream_cat);
#line 234 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 234 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 234 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 2244 "rfc822-message.c"
		}
	}
#line 215 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (message);
#line 215 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (parser);
#line 215 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (stream_cat);
#line 215 "../src/engine/rfc822/rfc822-message.vala"
	return self;
#line 2255 "rfc822-message.c"
}

GearyRFC822Message*
geary_rf_c822_message_new_from_parts (GearyRFC822Header* header,
                                      GearyRFC822Text* body,
                                      GError** error)
{
#line 215 "../src/engine/rfc822/rfc822-message.vala"
	return geary_rf_c822_message_construct_from_parts (GEARY_RF_C822_TYPE_MESSAGE, header, body, error);
#line 2265 "rfc822-message.c"
}

static void
geary_rf_c822_message_construct_from_composed_email_data_free (gpointer _data)
{
	GearyRfC822MessageNewFromComposedEmailData* _data_;
	_data_ = _data;
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->email);
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_g_free0 (_data_->message_id);
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->cancellable);
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->self);
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	g_slice_free (GearyRfC822MessageNewFromComposedEmailData, _data_);
#line 2283 "rfc822-message.c"
}

void
geary_rf_c822_message_construct_from_composed_email (GType object_type,
                                                     GearyComposedEmail* email,
                                                     const gchar* message_id,
                                                     GCancellable* cancellable,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	GearyRfC822MessageNewFromComposedEmailData* _data_;
	GearyComposedEmail* _tmp0_;
	gchar* _tmp1_;
	GCancellable* _tmp2_;
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	g_return_if_fail (GEARY_IS_COMPOSED_EMAIL (email));
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_data_ = g_slice_new0 (GearyRfC822MessageNewFromComposedEmailData);
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_async_result = g_task_new (NULL, cancellable, _callback_, _user_data_);
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_rf_c822_message_construct_from_composed_email_data_free);
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_data_->object_type = object_type;
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = _g_object_ref0 (email);
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->email);
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_data_->email = _tmp0_;
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = g_strdup (message_id);
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_g_free0 (_data_->message_id);
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_data_->message_id = _tmp1_;
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->cancellable);
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_data_->cancellable = _tmp2_;
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	geary_rf_c822_message_construct_from_composed_email_co (_data_);
#line 2330 "rfc822-message.c"
}

GearyRFC822Message*
geary_rf_c822_message_construct_from_composed_email_finish (GAsyncResult* _res_,
                                                            GError** error)
{
	GearyRFC822Message* result;
	GearyRfC822MessageNewFromComposedEmailData* _data_;
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	if (NULL == _data_) {
#line 237 "../src/engine/rfc822/rfc822-message.vala"
		return NULL;
#line 2345 "rfc822-message.c"
	}
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	result = _data_->self;
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_data_->self = NULL;
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 2353 "rfc822-message.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 2390 "rfc822-message.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 2396 "rfc822-message.c"
}

static void
geary_rf_c822_message_new_from_composed_email_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_)
{
	GearyRfC822MessageNewFromComposedEmailData* _data_;
#line 336 "../src/engine/rfc822/rfc822-message.vala"
	_data_ = _user_data_;
#line 336 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_source_object_ = source_object;
#line 336 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_res_ = _res_;
#line 336 "../src/engine/rfc822/rfc822-message.vala"
	geary_rf_c822_message_construct_from_composed_email_co (_data_);
#line 2413 "rfc822-message.c"
}

static gboolean
geary_rf_c822_message_construct_from_composed_email_co (GearyRfC822MessageNewFromComposedEmailData* _data_)
{
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	switch (_data_->_state_) {
#line 237 "../src/engine/rfc822/rfc822-message.vala"
		case 0:
#line 2423 "rfc822-message.c"
		goto _state_0;
#line 237 "../src/engine/rfc822/rfc822-message.vala"
		case 1:
#line 2427 "rfc822-message.c"
		goto _state_1;
#line 237 "../src/engine/rfc822/rfc822-message.vala"
		case 2:
#line 2431 "rfc822-message.c"
		goto _state_2;
#line 237 "../src/engine/rfc822/rfc822-message.vala"
		case 3:
#line 2435 "rfc822-message.c"
		goto _state_3;
#line 237 "../src/engine/rfc822/rfc822-message.vala"
		case 4:
#line 2439 "rfc822-message.c"
		goto _state_4;
#line 237 "../src/engine/rfc822/rfc822-message.vala"
		case 5:
#line 2443 "rfc822-message.c"
		goto _state_5;
		default:
#line 237 "../src/engine/rfc822/rfc822-message.vala"
		g_assert_not_reached ();
#line 2448 "rfc822-message.c"
	}
	_state_0:
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_data_->self = (GearyRFC822Message*) geary_base_object_construct (_data_->object_type);
#line 241 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp0_ = g_mime_message_new (TRUE);
#line 241 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->self->priv->message);
#line 241 "../src/engine/rfc822/rfc822-message.vala"
	_data_->self->priv->message = _data_->_tmp0_;
#line 246 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp1_ = geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 246 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 246 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp3_ = _g_object_ref0 (_data_->_tmp2_);
#line 246 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->self->priv->_from);
#line 246 "../src/engine/rfc822/rfc822-message.vala"
	_data_->self->priv->_from = _data_->_tmp3_;
#line 2469 "rfc822-message.c"
	{
#line 247 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp4_ = geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 247 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 247 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_mailbox_list = _data_->_tmp5_;
#line 247 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp6_ = _data_->_mailbox_list;
#line 247 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp7_ = geary_rf_c822_mailbox_addresses_get_size (_data_->_tmp6_);
#line 247 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 247 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_mailbox_size = _data_->_tmp8_;
#line 247 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_mailbox_index = -1;
#line 247 "../src/engine/rfc822/rfc822-message.vala"
		while (TRUE) {
#line 247 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_mailbox_index = _data_->_mailbox_index + 1;
#line 247 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp9_ = _data_->_mailbox_index;
#line 247 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp10_ = _data_->_mailbox_size;
#line 247 "../src/engine/rfc822/rfc822-message.vala"
			if (!(_data_->_tmp9_ < _data_->_tmp10_)) {
#line 247 "../src/engine/rfc822/rfc822-message.vala"
				break;
#line 2499 "rfc822-message.c"
			}
#line 247 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp11_ = _data_->_mailbox_list;
#line 247 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp12_ = geary_rf_c822_mailbox_addresses_get (_data_->_tmp11_, _data_->_mailbox_index);
#line 247 "../src/engine/rfc822/rfc822-message.vala"
			_data_->mailbox = _data_->_tmp12_;
#line 248 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp13_ = _data_->self->priv->message;
#line 248 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp14_ = _data_->mailbox;
#line 248 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp15_ = geary_rf_c822_mailbox_address_get_name (_data_->_tmp14_);
#line 248 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp16_ = _data_->_tmp15_;
#line 248 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp17_ = _data_->mailbox;
#line 248 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp18_ = geary_rf_c822_mailbox_address_get_address (_data_->_tmp17_);
#line 248 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp19_ = _data_->_tmp18_;
#line 248 "../src/engine/rfc822/rfc822-message.vala"
			g_mime_message_add_mailbox (_data_->_tmp13_, GMIME_ADDRESS_TYPE_FROM, _data_->_tmp16_, _data_->_tmp19_);
#line 247 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_data_->mailbox);
#line 2525 "rfc822-message.c"
		}
	}
#line 251 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp20_ = geary_email_header_set_get_date (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 251 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp21_ = _data_->_tmp20_;
#line 251 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp22_ = _g_object_ref0 (_data_->_tmp21_);
#line 251 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->self->priv->_date);
#line 251 "../src/engine/rfc822/rfc822-message.vala"
	_data_->self->priv->_date = _data_->_tmp22_;
#line 252 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp23_ = _data_->self->priv->message;
#line 252 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp24_ = geary_email_header_set_get_date (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 252 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp25_ = _data_->_tmp24_;
#line 252 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp26_ = geary_rf_c822_date_get_value (_data_->_tmp25_);
#line 252 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp27_ = _data_->_tmp26_;
#line 252 "../src/engine/rfc822/rfc822-message.vala"
	g_mime_message_set_date (_data_->_tmp23_, _data_->_tmp27_);
#line 256 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp28_ = geary_email_header_set_get_to (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 256 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp29_ = _data_->_tmp28_;
#line 256 "../src/engine/rfc822/rfc822-message.vala"
	if (_data_->_tmp29_ != NULL) {
#line 257 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp30_ = geary_email_header_set_get_to (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 257 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp31_ = _data_->_tmp30_;
#line 257 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp32_ = _g_object_ref0 (_data_->_tmp31_);
#line 257 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_data_->self->priv->_to);
#line 257 "../src/engine/rfc822/rfc822-message.vala"
		_data_->self->priv->_to = _data_->_tmp32_;
#line 2566 "rfc822-message.c"
		{
#line 258 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp33_ = geary_email_header_set_get_to (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 258 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp34_ = _data_->_tmp33_;
#line 258 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_vala1__mailbox_list = _data_->_tmp34_;
#line 258 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp35_ = _data_->_vala1__mailbox_list;
#line 258 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp36_ = geary_rf_c822_mailbox_addresses_get_size (_data_->_tmp35_);
#line 258 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp37_ = _data_->_tmp36_;
#line 258 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_vala1__mailbox_size = _data_->_tmp37_;
#line 258 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_vala1__mailbox_index = -1;
#line 258 "../src/engine/rfc822/rfc822-message.vala"
			while (TRUE) {
#line 258 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_vala1__mailbox_index = _data_->_vala1__mailbox_index + 1;
#line 258 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp38_ = _data_->_vala1__mailbox_index;
#line 258 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp39_ = _data_->_vala1__mailbox_size;
#line 258 "../src/engine/rfc822/rfc822-message.vala"
				if (!(_data_->_tmp38_ < _data_->_tmp39_)) {
#line 258 "../src/engine/rfc822/rfc822-message.vala"
					break;
#line 2596 "rfc822-message.c"
				}
#line 258 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp40_ = _data_->_vala1__mailbox_list;
#line 258 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp41_ = geary_rf_c822_mailbox_addresses_get (_data_->_tmp40_, _data_->_vala1__mailbox_index);
#line 258 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_vala1_mailbox = _data_->_tmp41_;
#line 259 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp42_ = _data_->self->priv->message;
#line 259 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp43_ = _data_->_vala1_mailbox;
#line 259 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp44_ = geary_rf_c822_mailbox_address_get_name (_data_->_tmp43_);
#line 259 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp45_ = _data_->_tmp44_;
#line 259 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp46_ = _data_->_vala1_mailbox;
#line 259 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp47_ = geary_rf_c822_mailbox_address_get_address (_data_->_tmp46_);
#line 259 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp48_ = _data_->_tmp47_;
#line 259 "../src/engine/rfc822/rfc822-message.vala"
				g_mime_message_add_mailbox (_data_->_tmp42_, GMIME_ADDRESS_TYPE_TO, _data_->_tmp45_, _data_->_tmp48_);
#line 258 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (_data_->_vala1_mailbox);
#line 2622 "rfc822-message.c"
			}
		}
	}
#line 262 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp49_ = geary_email_header_set_get_cc (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 262 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp50_ = _data_->_tmp49_;
#line 262 "../src/engine/rfc822/rfc822-message.vala"
	if (_data_->_tmp50_ != NULL) {
#line 263 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp51_ = geary_email_header_set_get_cc (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 263 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp52_ = _data_->_tmp51_;
#line 263 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp53_ = _g_object_ref0 (_data_->_tmp52_);
#line 263 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_data_->self->priv->_cc);
#line 263 "../src/engine/rfc822/rfc822-message.vala"
		_data_->self->priv->_cc = _data_->_tmp53_;
#line 2642 "rfc822-message.c"
		{
#line 264 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp54_ = geary_email_header_set_get_cc (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 264 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp55_ = _data_->_tmp54_;
#line 264 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_vala2__mailbox_list = _data_->_tmp55_;
#line 264 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp56_ = _data_->_vala2__mailbox_list;
#line 264 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp57_ = geary_rf_c822_mailbox_addresses_get_size (_data_->_tmp56_);
#line 264 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp58_ = _data_->_tmp57_;
#line 264 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_vala2__mailbox_size = _data_->_tmp58_;
#line 264 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_vala2__mailbox_index = -1;
#line 264 "../src/engine/rfc822/rfc822-message.vala"
			while (TRUE) {
#line 264 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_vala2__mailbox_index = _data_->_vala2__mailbox_index + 1;
#line 264 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp59_ = _data_->_vala2__mailbox_index;
#line 264 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp60_ = _data_->_vala2__mailbox_size;
#line 264 "../src/engine/rfc822/rfc822-message.vala"
				if (!(_data_->_tmp59_ < _data_->_tmp60_)) {
#line 264 "../src/engine/rfc822/rfc822-message.vala"
					break;
#line 2672 "rfc822-message.c"
				}
#line 264 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp61_ = _data_->_vala2__mailbox_list;
#line 264 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp62_ = geary_rf_c822_mailbox_addresses_get (_data_->_tmp61_, _data_->_vala2__mailbox_index);
#line 264 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_vala2_mailbox = _data_->_tmp62_;
#line 265 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp63_ = _data_->self->priv->message;
#line 265 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp64_ = _data_->_vala2_mailbox;
#line 265 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp65_ = geary_rf_c822_mailbox_address_get_name (_data_->_tmp64_);
#line 265 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp66_ = _data_->_tmp65_;
#line 265 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp67_ = _data_->_vala2_mailbox;
#line 265 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp68_ = geary_rf_c822_mailbox_address_get_address (_data_->_tmp67_);
#line 265 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp69_ = _data_->_tmp68_;
#line 265 "../src/engine/rfc822/rfc822-message.vala"
				g_mime_message_add_mailbox (_data_->_tmp63_, GMIME_ADDRESS_TYPE_CC, _data_->_tmp66_, _data_->_tmp69_);
#line 264 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (_data_->_vala2_mailbox);
#line 2698 "rfc822-message.c"
			}
		}
	}
#line 268 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp70_ = geary_email_header_set_get_bcc (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 268 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp71_ = _data_->_tmp70_;
#line 268 "../src/engine/rfc822/rfc822-message.vala"
	if (_data_->_tmp71_ != NULL) {
#line 269 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp72_ = geary_email_header_set_get_bcc (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 269 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp73_ = _data_->_tmp72_;
#line 269 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp74_ = _g_object_ref0 (_data_->_tmp73_);
#line 269 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_data_->self->priv->_bcc);
#line 269 "../src/engine/rfc822/rfc822-message.vala"
		_data_->self->priv->_bcc = _data_->_tmp74_;
#line 2718 "rfc822-message.c"
		{
#line 270 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp75_ = geary_email_header_set_get_bcc (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 270 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp76_ = _data_->_tmp75_;
#line 270 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_vala3__mailbox_list = _data_->_tmp76_;
#line 270 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp77_ = _data_->_vala3__mailbox_list;
#line 270 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp78_ = geary_rf_c822_mailbox_addresses_get_size (_data_->_tmp77_);
#line 270 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp79_ = _data_->_tmp78_;
#line 270 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_vala3__mailbox_size = _data_->_tmp79_;
#line 270 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_vala3__mailbox_index = -1;
#line 270 "../src/engine/rfc822/rfc822-message.vala"
			while (TRUE) {
#line 270 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_vala3__mailbox_index = _data_->_vala3__mailbox_index + 1;
#line 270 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp80_ = _data_->_vala3__mailbox_index;
#line 270 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp81_ = _data_->_vala3__mailbox_size;
#line 270 "../src/engine/rfc822/rfc822-message.vala"
				if (!(_data_->_tmp80_ < _data_->_tmp81_)) {
#line 270 "../src/engine/rfc822/rfc822-message.vala"
					break;
#line 2748 "rfc822-message.c"
				}
#line 270 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp82_ = _data_->_vala3__mailbox_list;
#line 270 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp83_ = geary_rf_c822_mailbox_addresses_get (_data_->_tmp82_, _data_->_vala3__mailbox_index);
#line 270 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_vala3_mailbox = _data_->_tmp83_;
#line 271 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp84_ = _data_->self->priv->message;
#line 271 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp85_ = _data_->_vala3_mailbox;
#line 271 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp86_ = geary_rf_c822_mailbox_address_get_name (_data_->_tmp85_);
#line 271 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp87_ = _data_->_tmp86_;
#line 271 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp88_ = _data_->_vala3_mailbox;
#line 271 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp89_ = geary_rf_c822_mailbox_address_get_address (_data_->_tmp88_);
#line 271 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp90_ = _data_->_tmp89_;
#line 271 "../src/engine/rfc822/rfc822-message.vala"
				g_mime_message_add_mailbox (_data_->_tmp84_, GMIME_ADDRESS_TYPE_BCC, _data_->_tmp87_, _data_->_tmp90_);
#line 270 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (_data_->_vala3_mailbox);
#line 2774 "rfc822-message.c"
			}
		}
	}
#line 274 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp91_ = geary_email_header_set_get_sender (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 274 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp92_ = _data_->_tmp91_;
#line 274 "../src/engine/rfc822/rfc822-message.vala"
	if (_data_->_tmp92_ != NULL) {
#line 275 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp93_ = geary_email_header_set_get_sender (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 275 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp94_ = _data_->_tmp93_;
#line 275 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp95_ = _g_object_ref0 (_data_->_tmp94_);
#line 275 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_data_->self->priv->_sender);
#line 275 "../src/engine/rfc822/rfc822-message.vala"
		_data_->self->priv->_sender = _data_->_tmp95_;
#line 276 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp96_ = _data_->self->priv->message;
#line 276 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp97_ = geary_email_header_set_get_sender (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 276 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp98_ = _data_->_tmp97_;
#line 276 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp99_ = geary_rf_c822_mailbox_address_get_name (_data_->_tmp98_);
#line 276 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp100_ = _data_->_tmp99_;
#line 276 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp101_ = geary_email_header_set_get_sender (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 276 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp102_ = _data_->_tmp101_;
#line 276 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp103_ = geary_rf_c822_mailbox_address_get_address (_data_->_tmp102_);
#line 276 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp104_ = _data_->_tmp103_;
#line 276 "../src/engine/rfc822/rfc822-message.vala"
		g_mime_message_add_mailbox (_data_->_tmp96_, GMIME_ADDRESS_TYPE_SENDER, _data_->_tmp100_, _data_->_tmp104_);
#line 2814 "rfc822-message.c"
	}
#line 279 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp105_ = geary_email_header_set_get_reply_to (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 279 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp106_ = _data_->_tmp105_;
#line 279 "../src/engine/rfc822/rfc822-message.vala"
	if (_data_->_tmp106_ != NULL) {
#line 280 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp107_ = geary_email_header_set_get_reply_to (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 280 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp108_ = _data_->_tmp107_;
#line 280 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp109_ = _g_object_ref0 (_data_->_tmp108_);
#line 280 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_data_->self->priv->_reply_to);
#line 280 "../src/engine/rfc822/rfc822-message.vala"
		_data_->self->priv->_reply_to = _data_->_tmp109_;
#line 2832 "rfc822-message.c"
		{
#line 281 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp110_ = geary_email_header_set_get_reply_to (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 281 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp111_ = _data_->_tmp110_;
#line 281 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_vala4__mailbox_list = _data_->_tmp111_;
#line 281 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp112_ = _data_->_vala4__mailbox_list;
#line 281 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp113_ = geary_rf_c822_mailbox_addresses_get_size (_data_->_tmp112_);
#line 281 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp114_ = _data_->_tmp113_;
#line 281 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_vala4__mailbox_size = _data_->_tmp114_;
#line 281 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_vala4__mailbox_index = -1;
#line 281 "../src/engine/rfc822/rfc822-message.vala"
			while (TRUE) {
#line 281 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_vala4__mailbox_index = _data_->_vala4__mailbox_index + 1;
#line 281 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp115_ = _data_->_vala4__mailbox_index;
#line 281 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp116_ = _data_->_vala4__mailbox_size;
#line 281 "../src/engine/rfc822/rfc822-message.vala"
				if (!(_data_->_tmp115_ < _data_->_tmp116_)) {
#line 281 "../src/engine/rfc822/rfc822-message.vala"
					break;
#line 2862 "rfc822-message.c"
				}
#line 281 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp117_ = _data_->_vala4__mailbox_list;
#line 281 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp118_ = geary_rf_c822_mailbox_addresses_get (_data_->_tmp117_, _data_->_vala4__mailbox_index);
#line 281 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_vala4_mailbox = _data_->_tmp118_;
#line 282 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp119_ = _data_->self->priv->message;
#line 282 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp120_ = _data_->_vala4_mailbox;
#line 282 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp121_ = geary_rf_c822_mailbox_address_get_name (_data_->_tmp120_);
#line 282 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp122_ = _data_->_tmp121_;
#line 282 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp123_ = _data_->_vala4_mailbox;
#line 282 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp124_ = geary_rf_c822_mailbox_address_get_address (_data_->_tmp123_);
#line 282 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp125_ = _data_->_tmp124_;
#line 282 "../src/engine/rfc822/rfc822-message.vala"
				g_mime_message_add_mailbox (_data_->_tmp119_, GMIME_ADDRESS_TYPE_REPLY_TO, _data_->_tmp122_, _data_->_tmp125_);
#line 281 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (_data_->_vala4_mailbox);
#line 2888 "rfc822-message.c"
			}
		}
	}
#line 285 "../src/engine/rfc822/rfc822-message.vala"
	if (_data_->message_id != NULL) {
#line 286 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp126_ = geary_rf_c822_message_id_new (_data_->message_id);
#line 286 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_data_->self->priv->_message_id);
#line 286 "../src/engine/rfc822/rfc822-message.vala"
		_data_->self->priv->_message_id = _data_->_tmp126_;
#line 287 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp127_ = _data_->self->priv->message;
#line 287 "../src/engine/rfc822/rfc822-message.vala"
		g_mime_message_set_message_id (_data_->_tmp127_, _data_->message_id);
#line 2904 "rfc822-message.c"
	}
#line 290 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp128_ = geary_email_header_set_get_in_reply_to (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 290 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp129_ = _data_->_tmp128_;
#line 290 "../src/engine/rfc822/rfc822-message.vala"
	if (_data_->_tmp129_ != NULL) {
#line 291 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp130_ = geary_email_header_set_get_in_reply_to (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 291 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp131_ = _data_->_tmp130_;
#line 291 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp132_ = _g_object_ref0 (_data_->_tmp131_);
#line 291 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_data_->self->priv->_in_reply_to);
#line 291 "../src/engine/rfc822/rfc822-message.vala"
		_data_->self->priv->_in_reply_to = _data_->_tmp132_;
#line 296 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp133_ = _data_->self->priv->message;
#line 296 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp134_ = geary_email_header_set_get_in_reply_to (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 296 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp135_ = _data_->_tmp134_;
#line 296 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp136_ = geary_rf_c822_decoded_message_data_to_rfc822_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp135_, GEARY_RF_C822_TYPE_DECODED_MESSAGE_DATA, GearyRFC822DecodedMessageData));
#line 296 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp137_ = _data_->_tmp136_;
#line 296 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp138_ = geary_rf_c822_get_charset ();
#line 296 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp139_ = _data_->_tmp138_;
#line 296 "../src/engine/rfc822/rfc822-message.vala"
		g_mime_object_set_header (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp133_, g_mime_object_get_type (), GMimeObject), GEARY_RF_C822_MESSAGE_HEADER_IN_REPLY_TO, _data_->_tmp137_, _data_->_tmp139_);
#line 296 "../src/engine/rfc822/rfc822-message.vala"
		_g_free0 (_data_->_tmp139_);
#line 296 "../src/engine/rfc822/rfc822-message.vala"
		_g_free0 (_data_->_tmp137_);
#line 2942 "rfc822-message.c"
	}
#line 301 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp140_ = geary_email_header_set_get_references (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 301 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp141_ = _data_->_tmp140_;
#line 301 "../src/engine/rfc822/rfc822-message.vala"
	if (_data_->_tmp141_ != NULL) {
#line 302 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp142_ = geary_email_header_set_get_references (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 302 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp143_ = _data_->_tmp142_;
#line 302 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp144_ = _g_object_ref0 (_data_->_tmp143_);
#line 302 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_data_->self->priv->_references);
#line 302 "../src/engine/rfc822/rfc822-message.vala"
		_data_->self->priv->_references = _data_->_tmp144_;
#line 303 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp145_ = _data_->self->priv->message;
#line 303 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp146_ = geary_email_header_set_get_references (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 303 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp147_ = _data_->_tmp146_;
#line 303 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp148_ = geary_rf_c822_decoded_message_data_to_rfc822_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp147_, GEARY_RF_C822_TYPE_DECODED_MESSAGE_DATA, GearyRFC822DecodedMessageData));
#line 303 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp149_ = _data_->_tmp148_;
#line 303 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp150_ = geary_rf_c822_get_charset ();
#line 303 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp151_ = _data_->_tmp150_;
#line 303 "../src/engine/rfc822/rfc822-message.vala"
		g_mime_object_set_header (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp145_, g_mime_object_get_type (), GMimeObject), GEARY_RF_C822_MESSAGE_HEADER_REFERENCES, _data_->_tmp149_, _data_->_tmp151_);
#line 303 "../src/engine/rfc822/rfc822-message.vala"
		_g_free0 (_data_->_tmp151_);
#line 303 "../src/engine/rfc822/rfc822-message.vala"
		_g_free0 (_data_->_tmp149_);
#line 2980 "rfc822-message.c"
	}
#line 308 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp152_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 308 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp153_ = _data_->_tmp152_;
#line 308 "../src/engine/rfc822/rfc822-message.vala"
	if (_data_->_tmp153_ != NULL) {
#line 309 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp154_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 309 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp155_ = _data_->_tmp154_;
#line 309 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp156_ = _g_object_ref0 (_data_->_tmp155_);
#line 309 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_data_->self->priv->_subject);
#line 309 "../src/engine/rfc822/rfc822-message.vala"
		_data_->self->priv->_subject = _data_->_tmp156_;
#line 310 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp157_ = _data_->self->priv->message;
#line 310 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp158_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 310 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp159_ = _data_->_tmp158_;
#line 310 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp160_ = geary_message_data_string_message_data_get_value (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp159_, GEARY_MESSAGE_DATA_TYPE_STRING_MESSAGE_DATA, GearyMessageDataStringMessageData));
#line 310 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp161_ = _data_->_tmp160_;
#line 310 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp162_ = geary_rf_c822_get_charset ();
#line 310 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp163_ = _data_->_tmp162_;
#line 310 "../src/engine/rfc822/rfc822-message.vala"
		g_mime_message_set_subject (_data_->_tmp157_, _data_->_tmp161_, _data_->_tmp163_);
#line 310 "../src/engine/rfc822/rfc822-message.vala"
		_g_free0 (_data_->_tmp163_);
#line 3016 "rfc822-message.c"
	}
#line 315 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp164_ = geary_composed_email_get_mailer (_data_->email);
#line 315 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp165_ = _data_->_tmp164_;
#line 315 "../src/engine/rfc822/rfc822-message.vala"
	if (!geary_string_is_empty (_data_->_tmp165_)) {
#line 316 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp166_ = geary_composed_email_get_mailer (_data_->email);
#line 316 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp167_ = _data_->_tmp166_;
#line 316 "../src/engine/rfc822/rfc822-message.vala"
		geary_rf_c822_message_set_mailer (_data_->self, _data_->_tmp167_);
#line 317 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp168_ = _data_->self->priv->message;
#line 317 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp169_ = geary_composed_email_get_mailer (_data_->email);
#line 317 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp170_ = _data_->_tmp169_;
#line 317 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp171_ = geary_rf_c822_get_charset ();
#line 317 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp172_ = _data_->_tmp171_;
#line 317 "../src/engine/rfc822/rfc822-message.vala"
		g_mime_object_set_header (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp168_, g_mime_object_get_type (), GMimeObject), GEARY_RF_C822_MESSAGE_HEADER_MAILER, _data_->_tmp170_, _data_->_tmp172_);
#line 317 "../src/engine/rfc822/rfc822-message.vala"
		_g_free0 (_data_->_tmp172_);
#line 3044 "rfc822-message.c"
	}
#line 323 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp173_ = gee_linked_list_new (g_mime_object_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 323 "../src/engine/rfc822/rfc822-message.vala"
	_data_->body_parts = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp173_, GEE_TYPE_LIST, GeeList);
#line 330 "../src/engine/rfc822/rfc822-message.vala"
	_data_->body_charset = NULL;
#line 333 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp174_ = geary_composed_email_get_body_text (_data_->email);
#line 333 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp175_ = _data_->_tmp174_;
#line 333 "../src/engine/rfc822/rfc822-message.vala"
	if (_data_->_tmp175_ != NULL) {
#line 334 "../src/engine/rfc822/rfc822-message.vala"
		_data_->body_text = NULL;
#line 3060 "rfc822-message.c"
		{
#line 336 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp177_ = geary_composed_email_get_body_text (_data_->email);
#line 336 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp178_ = _data_->_tmp177_;
#line 336 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp180_ = 0;
#line 336 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp179_ = string_get_data (_data_->_tmp178_, &_data_->_tmp180_);
#line 336 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp179__length1 = _data_->_tmp180_;
#line 336 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp181_ = _data_->_tmp179_;
#line 336 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp181__length1 = _data_->_tmp179__length1;
#line 336 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_state_ = 1;
#line 336 "../src/engine/rfc822/rfc822-message.vala"
			geary_rf_c822_message_body_data_to_part (_data_->self, _data_->_tmp181_, (gint) _data_->_tmp181__length1, NULL, "text/plain", TRUE, _data_->cancellable, geary_rf_c822_message_new_from_composed_email_ready, _data_);
#line 336 "../src/engine/rfc822/rfc822-message.vala"
			return FALSE;
#line 3082 "rfc822-message.c"
			_state_1:
#line 336 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp182_ = geary_rf_c822_message_body_data_to_part_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 336 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp176_ = _data_->_tmp182_;
#line 336 "../src/engine/rfc822/rfc822-message.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3090 "rfc822-message.c"
				goto __catch0_g_error;
			}
#line 336 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp183_ = _data_->_tmp176_;
#line 336 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp176_ = NULL;
#line 336 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_data_->body_text);
#line 336 "../src/engine/rfc822/rfc822-message.vala"
			_data_->body_text = _data_->_tmp183_;
#line 335 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_data_->_tmp176_);
#line 3103 "rfc822-message.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 335 "../src/engine/rfc822/rfc822-message.vala"
			_data_->err = _data_->_inner_error0_;
#line 335 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_inner_error0_ = NULL;
#line 344 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp184_ = _data_->err;
#line 344 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp185_ = _data_->_tmp184_->message;
#line 344 "../src/engine/rfc822/rfc822-message.vala"
			g_warning ("rfc822-message.vala:344: Error creating text body part: %s", _data_->_tmp185_);
#line 335 "../src/engine/rfc822/rfc822-message.vala"
			_g_error_free0 (_data_->err);
#line 3120 "rfc822-message.c"
		}
		__finally0:
#line 335 "../src/engine/rfc822/rfc822-message.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 335 "../src/engine/rfc822/rfc822-message.vala"
			if (_data_->_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 335 "../src/engine/rfc822/rfc822-message.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 335 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (_data_->body_text);
#line 335 "../src/engine/rfc822/rfc822-message.vala"
				_g_free0 (_data_->body_charset);
#line 335 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (_data_->body_parts);
#line 335 "../src/engine/rfc822/rfc822-message.vala"
				g_object_unref (_data_->_async_result);
#line 335 "../src/engine/rfc822/rfc822-message.vala"
				return FALSE;
#line 3139 "rfc822-message.c"
			} else {
#line 335 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (_data_->body_text);
#line 335 "../src/engine/rfc822/rfc822-message.vala"
				_g_free0 (_data_->body_charset);
#line 335 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (_data_->body_parts);
#line 335 "../src/engine/rfc822/rfc822-message.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 335 "../src/engine/rfc822/rfc822-message.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 335 "../src/engine/rfc822/rfc822-message.vala"
				g_object_unref (_data_->_async_result);
#line 335 "../src/engine/rfc822/rfc822-message.vala"
				return FALSE;
#line 3155 "rfc822-message.c"
			}
		}
#line 346 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp186_ = _data_->body_text;
#line 346 "../src/engine/rfc822/rfc822-message.vala"
		if (_data_->_tmp186_ != NULL) {
#line 347 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp187_ = _data_->body_text;
#line 347 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp188_ = g_mime_object_get_content_type (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp187_, g_mime_object_get_type (), GMimeObject));
#line 347 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp189_ = g_mime_content_type_get_parameter (_data_->_tmp188_, "charset");
#line 347 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp190_ = g_strdup (_data_->_tmp189_);
#line 347 "../src/engine/rfc822/rfc822-message.vala"
			_g_free0 (_data_->body_charset);
#line 347 "../src/engine/rfc822/rfc822-message.vala"
			_data_->body_charset = _data_->_tmp190_;
#line 350 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp191_ = _data_->body_parts;
#line 350 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp192_ = _data_->body_text;
#line 350 "../src/engine/rfc822/rfc822-message.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp191_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp192_, g_mime_object_get_type (), GMimeObject));
#line 3180 "rfc822-message.c"
		}
#line 333 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_data_->body_text);
#line 3184 "rfc822-message.c"
	}
#line 355 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp193_ = geary_composed_email_get_body_html (_data_->email);
#line 355 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp194_ = _data_->_tmp193_;
#line 355 "../src/engine/rfc822/rfc822-message.vala"
	if (_data_->_tmp194_ != NULL) {
#line 356 "../src/engine/rfc822/rfc822-message.vala"
		static const char CID_URL_PREFIX[] = "cid:";
#line 357 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp195_ = gee_linked_list_new (g_mime_object_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 357 "../src/engine/rfc822/rfc822-message.vala"
		_data_->related_parts = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp195_, GEE_TYPE_LIST, GeeList);
#line 361 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp196_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEARY_MEMORY_TYPE_BUFFER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 361 "../src/engine/rfc822/rfc822-message.vala"
		_data_->inline_files = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp196_, GEE_TYPE_MAP, GeeMap);
#line 362 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp197_ = _data_->inline_files;
#line 362 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp198_ = geary_composed_email_get_inline_files (_data_->email);
#line 362 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp199_ = _data_->_tmp198_;
#line 362 "../src/engine/rfc822/rfc822-message.vala"
		gee_map_set_all (_data_->_tmp197_, _data_->_tmp199_);
#line 3210 "rfc822-message.c"
		{
#line 371 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp200_ = geary_composed_email_get_cid_files (_data_->email);
#line 371 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp201_ = _data_->_tmp200_;
#line 371 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp202_ = gee_map_get_keys (_data_->_tmp201_);
#line 371 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp203_ = _data_->_tmp202_;
#line 371 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp204_ = _data_->_tmp203_;
#line 371 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp205_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp204_, GEE_TYPE_ITERABLE, GeeIterable));
#line 371 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp206_ = _data_->_tmp205_;
#line 371 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_data_->_tmp204_);
#line 371 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_cid_it = _data_->_tmp206_;
#line 371 "../src/engine/rfc822/rfc822-message.vala"
			while (TRUE) {
#line 371 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp207_ = _data_->_cid_it;
#line 371 "../src/engine/rfc822/rfc822-message.vala"
				if (!gee_iterator_next (_data_->_tmp207_)) {
#line 371 "../src/engine/rfc822/rfc822-message.vala"
					break;
#line 3238 "rfc822-message.c"
				}
#line 371 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp208_ = _data_->_cid_it;
#line 371 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp209_ = gee_iterator_get (_data_->_tmp208_);
#line 371 "../src/engine/rfc822/rfc822-message.vala"
				_data_->cid = (gchar*) _data_->_tmp209_;
#line 372 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp210_ = _data_->cid;
#line 372 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp211_ = g_strconcat (CID_URL_PREFIX, _data_->_tmp210_, NULL);
#line 372 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp212_ = _data_->_tmp211_;
#line 372 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp213_ = geary_composed_email_contains_inline_img_src (_data_->email, _data_->_tmp212_);
#line 372 "../src/engine/rfc822/rfc822-message.vala"
				_g_free0 (_data_->_tmp212_);
#line 372 "../src/engine/rfc822/rfc822-message.vala"
				if (_data_->_tmp213_) {
#line 373 "../src/engine/rfc822/rfc822-message.vala"
					_data_->inline_part = NULL;
#line 3260 "rfc822-message.c"
					{
#line 375 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_tmp215_ = geary_composed_email_get_cid_files (_data_->email);
#line 375 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_tmp216_ = _data_->_tmp215_;
#line 375 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_tmp217_ = _data_->cid;
#line 375 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_tmp218_ = gee_map_get (_data_->_tmp216_, _data_->_tmp217_);
#line 375 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_tmp219_ = (GearyMemoryBuffer*) _data_->_tmp218_;
#line 375 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_tmp220_ = _data_->cid;
#line 375 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_tmp221_ = g_path_get_basename (_data_->_tmp220_);
#line 375 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_tmp222_ = _data_->_tmp221_;
#line 375 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_state_ = 2;
#line 375 "../src/engine/rfc822/rfc822-message.vala"
						geary_rf_c822_message_get_buffer_part (_data_->self, _data_->_tmp219_, _data_->_tmp222_, GEARY_MIME_DISPOSITION_TYPE_INLINE, _data_->cancellable, geary_rf_c822_message_new_from_composed_email_ready, _data_);
#line 375 "../src/engine/rfc822/rfc822-message.vala"
						return FALSE;
#line 3284 "rfc822-message.c"
						_state_2:
#line 375 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_tmp223_ = geary_rf_c822_message_get_buffer_part_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 375 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_tmp224_ = _data_->_tmp223_;
#line 375 "../src/engine/rfc822/rfc822-message.vala"
						_g_free0 (_data_->_tmp222_);
#line 375 "../src/engine/rfc822/rfc822-message.vala"
						_g_object_unref0 (_data_->_tmp219_);
#line 375 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_tmp214_ = _data_->_tmp224_;
#line 375 "../src/engine/rfc822/rfc822-message.vala"
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3298 "rfc822-message.c"
							goto __catch1_g_error;
						}
#line 375 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_tmp225_ = _data_->_tmp214_;
#line 375 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_tmp214_ = NULL;
#line 375 "../src/engine/rfc822/rfc822-message.vala"
						_g_object_unref0 (_data_->inline_part);
#line 375 "../src/engine/rfc822/rfc822-message.vala"
						_data_->inline_part = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp225_, g_mime_object_get_type (), GMimeObject);
#line 374 "../src/engine/rfc822/rfc822-message.vala"
						_g_object_unref0 (_data_->_tmp214_);
#line 3311 "rfc822-message.c"
					}
					goto __finally1;
					__catch1_g_error:
					{
#line 374 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_vala1_err = _data_->_inner_error0_;
#line 374 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_inner_error0_ = NULL;
#line 382 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_tmp226_ = _data_->cid;
#line 382 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_tmp227_ = _data_->_vala1_err;
#line 382 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_tmp228_ = _data_->_tmp227_->message;
#line 382 "../src/engine/rfc822/rfc822-message.vala"
						g_warning ("rfc822-message.vala:382: Error creating CID part %s: %s", _data_->_tmp226_, _data_->_tmp228_);
#line 374 "../src/engine/rfc822/rfc822-message.vala"
						_g_error_free0 (_data_->_vala1_err);
#line 3330 "rfc822-message.c"
					}
					__finally1:
#line 374 "../src/engine/rfc822/rfc822-message.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 374 "../src/engine/rfc822/rfc822-message.vala"
						if (_data_->_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 374 "../src/engine/rfc822/rfc822-message.vala"
							g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 374 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (_data_->inline_part);
#line 374 "../src/engine/rfc822/rfc822-message.vala"
							_g_free0 (_data_->cid);
#line 374 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (_data_->_cid_it);
#line 374 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (_data_->inline_files);
#line 374 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (_data_->related_parts);
#line 374 "../src/engine/rfc822/rfc822-message.vala"
							_g_free0 (_data_->body_charset);
#line 374 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (_data_->body_parts);
#line 374 "../src/engine/rfc822/rfc822-message.vala"
							g_object_unref (_data_->_async_result);
#line 374 "../src/engine/rfc822/rfc822-message.vala"
							return FALSE;
#line 3357 "rfc822-message.c"
						} else {
#line 374 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (_data_->inline_part);
#line 374 "../src/engine/rfc822/rfc822-message.vala"
							_g_free0 (_data_->cid);
#line 374 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (_data_->_cid_it);
#line 374 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (_data_->inline_files);
#line 374 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (_data_->related_parts);
#line 374 "../src/engine/rfc822/rfc822-message.vala"
							_g_free0 (_data_->body_charset);
#line 374 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (_data_->body_parts);
#line 374 "../src/engine/rfc822/rfc822-message.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 374 "../src/engine/rfc822/rfc822-message.vala"
							g_clear_error (&_data_->_inner_error0_);
#line 374 "../src/engine/rfc822/rfc822-message.vala"
							g_object_unref (_data_->_async_result);
#line 374 "../src/engine/rfc822/rfc822-message.vala"
							return FALSE;
#line 3381 "rfc822-message.c"
						}
					}
#line 388 "../src/engine/rfc822/rfc822-message.vala"
					_data_->_tmp229_ = _data_->inline_part;
#line 388 "../src/engine/rfc822/rfc822-message.vala"
					if (_data_->_tmp229_ != NULL) {
#line 389 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_tmp230_ = _data_->inline_part;
#line 389 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_tmp231_ = _data_->cid;
#line 389 "../src/engine/rfc822/rfc822-message.vala"
						g_mime_object_set_content_id (_data_->_tmp230_, _data_->_tmp231_);
#line 390 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_tmp232_ = _data_->related_parts;
#line 390 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_tmp233_ = _data_->inline_part;
#line 390 "../src/engine/rfc822/rfc822-message.vala"
						gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp232_, GEE_TYPE_COLLECTION, GeeCollection), _data_->_tmp233_);
#line 3400 "rfc822-message.c"
					}
#line 394 "../src/engine/rfc822/rfc822-message.vala"
					_data_->_tmp234_ = _data_->inline_files;
#line 394 "../src/engine/rfc822/rfc822-message.vala"
					_data_->_tmp235_ = _data_->cid;
#line 394 "../src/engine/rfc822/rfc822-message.vala"
					gee_map_unset (_data_->_tmp234_, _data_->_tmp235_, NULL);
#line 372 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (_data_->inline_part);
#line 3410 "rfc822-message.c"
				}
#line 371 "../src/engine/rfc822/rfc822-message.vala"
				_g_free0 (_data_->cid);
#line 3414 "rfc822-message.c"
			}
#line 371 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_data_->_cid_it);
#line 3418 "rfc822-message.c"
		}
#line 400 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp236_ = _data_->inline_files;
#line 400 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp237_ = gee_map_get_is_empty (_data_->_tmp236_);
#line 400 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp238_ = _data_->_tmp237_;
#line 400 "../src/engine/rfc822/rfc822-message.vala"
		if (!_data_->_tmp238_) {
#line 401 "../src/engine/rfc822/rfc822-message.vala"
			static const char CID_TEMPLATE[] = "inline_%02u@geary";
#line 402 "../src/engine/rfc822/rfc822-message.vala"
			_data_->cid_index = (guint) 0;
#line 3432 "rfc822-message.c"
			{
#line 403 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp239_ = _data_->inline_files;
#line 403 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp240_ = gee_map_get_keys (_data_->_tmp239_);
#line 403 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp241_ = _data_->_tmp240_;
#line 403 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp242_ = _data_->_tmp241_;
#line 403 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp243_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp242_, GEE_TYPE_ITERABLE, GeeIterable));
#line 403 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp244_ = _data_->_tmp243_;
#line 403 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (_data_->_tmp242_);
#line 403 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_name_it = _data_->_tmp244_;
#line 403 "../src/engine/rfc822/rfc822-message.vala"
				while (TRUE) {
#line 403 "../src/engine/rfc822/rfc822-message.vala"
					_data_->_tmp245_ = _data_->_name_it;
#line 403 "../src/engine/rfc822/rfc822-message.vala"
					if (!gee_iterator_next (_data_->_tmp245_)) {
#line 403 "../src/engine/rfc822/rfc822-message.vala"
						break;
#line 3458 "rfc822-message.c"
					}
#line 403 "../src/engine/rfc822/rfc822-message.vala"
					_data_->_tmp246_ = _data_->_name_it;
#line 403 "../src/engine/rfc822/rfc822-message.vala"
					_data_->_tmp247_ = gee_iterator_get (_data_->_tmp246_);
#line 403 "../src/engine/rfc822/rfc822-message.vala"
					_data_->name = (gchar*) _data_->_tmp247_;
#line 404 "../src/engine/rfc822/rfc822-message.vala"
					_data_->_tmp248_ = g_strdup ("");
#line 404 "../src/engine/rfc822/rfc822-message.vala"
					_data_->_vala1_cid = _data_->_tmp248_;
#line 3470 "rfc822-message.c"
					{
#line 405 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_tmp249_ = TRUE;
#line 405 "../src/engine/rfc822/rfc822-message.vala"
						while (TRUE) {
#line 405 "../src/engine/rfc822/rfc822-message.vala"
							if (!_data_->_tmp249_) {
#line 407 "../src/engine/rfc822/rfc822-message.vala"
								_data_->_tmp250_ = geary_composed_email_get_cid_files (_data_->email);
#line 407 "../src/engine/rfc822/rfc822-message.vala"
								_data_->_tmp251_ = _data_->_tmp250_;
#line 407 "../src/engine/rfc822/rfc822-message.vala"
								_data_->_tmp252_ = _data_->_vala1_cid;
#line 407 "../src/engine/rfc822/rfc822-message.vala"
								if (!gee_map_has_key (_data_->_tmp251_, _data_->_tmp252_)) {
#line 407 "../src/engine/rfc822/rfc822-message.vala"
									break;
#line 3488 "rfc822-message.c"
								}
							}
#line 405 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_tmp249_ = FALSE;
#line 406 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_tmp253_ = _data_->cid_index;
#line 406 "../src/engine/rfc822/rfc822-message.vala"
							_data_->cid_index = _data_->_tmp253_ + 1;
#line 406 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_tmp254_ = g_strdup_printf (CID_TEMPLATE, _data_->_tmp253_);
#line 406 "../src/engine/rfc822/rfc822-message.vala"
							_g_free0 (_data_->_vala1_cid);
#line 406 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_vala1_cid = _data_->_tmp254_;
#line 3503 "rfc822-message.c"
						}
					}
#line 409 "../src/engine/rfc822/rfc822-message.vala"
					_data_->_tmp255_ = _data_->name;
#line 409 "../src/engine/rfc822/rfc822-message.vala"
					_data_->_tmp256_ = _data_->_vala1_cid;
#line 409 "../src/engine/rfc822/rfc822-message.vala"
					_data_->_tmp257_ = g_strconcat (CID_URL_PREFIX, _data_->_tmp256_, NULL);
#line 409 "../src/engine/rfc822/rfc822-message.vala"
					_data_->_tmp258_ = _data_->_tmp257_;
#line 409 "../src/engine/rfc822/rfc822-message.vala"
					_data_->_tmp259_ = geary_composed_email_replace_inline_img_src (_data_->email, _data_->_tmp255_, _data_->_tmp258_);
#line 409 "../src/engine/rfc822/rfc822-message.vala"
					_g_free0 (_data_->_tmp258_);
#line 409 "../src/engine/rfc822/rfc822-message.vala"
					if (_data_->_tmp259_) {
#line 411 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_vala1_inline_part = NULL;
#line 3522 "rfc822-message.c"
						{
#line 413 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_tmp261_ = _data_->inline_files;
#line 413 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_tmp262_ = _data_->name;
#line 413 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_tmp263_ = gee_map_get (_data_->_tmp261_, _data_->_tmp262_);
#line 413 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_tmp264_ = (GearyMemoryBuffer*) _data_->_tmp263_;
#line 413 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_tmp265_ = _data_->name;
#line 413 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_tmp266_ = g_path_get_basename (_data_->_tmp265_);
#line 413 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_tmp267_ = _data_->_tmp266_;
#line 413 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_state_ = 3;
#line 413 "../src/engine/rfc822/rfc822-message.vala"
							geary_rf_c822_message_get_buffer_part (_data_->self, _data_->_tmp264_, _data_->_tmp267_, GEARY_MIME_DISPOSITION_TYPE_INLINE, _data_->cancellable, geary_rf_c822_message_new_from_composed_email_ready, _data_);
#line 413 "../src/engine/rfc822/rfc822-message.vala"
							return FALSE;
#line 3544 "rfc822-message.c"
							_state_3:
#line 413 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_tmp268_ = geary_rf_c822_message_get_buffer_part_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 413 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_tmp269_ = _data_->_tmp268_;
#line 413 "../src/engine/rfc822/rfc822-message.vala"
							_g_free0 (_data_->_tmp267_);
#line 413 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (_data_->_tmp264_);
#line 413 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_tmp260_ = _data_->_tmp269_;
#line 413 "../src/engine/rfc822/rfc822-message.vala"
							if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3558 "rfc822-message.c"
								goto __catch2_g_error;
							}
#line 413 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_tmp270_ = _data_->_tmp260_;
#line 413 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_tmp260_ = NULL;
#line 413 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (_data_->_vala1_inline_part);
#line 413 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_vala1_inline_part = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp270_, g_mime_object_get_type (), GMimeObject);
#line 412 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (_data_->_tmp260_);
#line 3571 "rfc822-message.c"
						}
						goto __finally2;
						__catch2_g_error:
						{
#line 412 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_vala2_err = _data_->_inner_error0_;
#line 412 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_inner_error0_ = NULL;
#line 420 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_tmp271_ = _data_->name;
#line 420 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_tmp272_ = _data_->_vala2_err;
#line 420 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_tmp273_ = _data_->_tmp272_->message;
#line 420 "../src/engine/rfc822/rfc822-message.vala"
							g_warning ("rfc822-message.vala:420: Error creating inline file part %s: %s", _data_->_tmp271_, _data_->_tmp273_);
#line 412 "../src/engine/rfc822/rfc822-message.vala"
							_g_error_free0 (_data_->_vala2_err);
#line 3590 "rfc822-message.c"
						}
						__finally2:
#line 412 "../src/engine/rfc822/rfc822-message.vala"
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 412 "../src/engine/rfc822/rfc822-message.vala"
							if (_data_->_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 412 "../src/engine/rfc822/rfc822-message.vala"
								g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 412 "../src/engine/rfc822/rfc822-message.vala"
								_g_object_unref0 (_data_->_vala1_inline_part);
#line 412 "../src/engine/rfc822/rfc822-message.vala"
								_g_free0 (_data_->_vala1_cid);
#line 412 "../src/engine/rfc822/rfc822-message.vala"
								_g_free0 (_data_->name);
#line 412 "../src/engine/rfc822/rfc822-message.vala"
								_g_object_unref0 (_data_->_name_it);
#line 412 "../src/engine/rfc822/rfc822-message.vala"
								_g_object_unref0 (_data_->inline_files);
#line 412 "../src/engine/rfc822/rfc822-message.vala"
								_g_object_unref0 (_data_->related_parts);
#line 412 "../src/engine/rfc822/rfc822-message.vala"
								_g_free0 (_data_->body_charset);
#line 412 "../src/engine/rfc822/rfc822-message.vala"
								_g_object_unref0 (_data_->body_parts);
#line 412 "../src/engine/rfc822/rfc822-message.vala"
								g_object_unref (_data_->_async_result);
#line 412 "../src/engine/rfc822/rfc822-message.vala"
								return FALSE;
#line 3619 "rfc822-message.c"
							} else {
#line 412 "../src/engine/rfc822/rfc822-message.vala"
								_g_object_unref0 (_data_->_vala1_inline_part);
#line 412 "../src/engine/rfc822/rfc822-message.vala"
								_g_free0 (_data_->_vala1_cid);
#line 412 "../src/engine/rfc822/rfc822-message.vala"
								_g_free0 (_data_->name);
#line 412 "../src/engine/rfc822/rfc822-message.vala"
								_g_object_unref0 (_data_->_name_it);
#line 412 "../src/engine/rfc822/rfc822-message.vala"
								_g_object_unref0 (_data_->inline_files);
#line 412 "../src/engine/rfc822/rfc822-message.vala"
								_g_object_unref0 (_data_->related_parts);
#line 412 "../src/engine/rfc822/rfc822-message.vala"
								_g_free0 (_data_->body_charset);
#line 412 "../src/engine/rfc822/rfc822-message.vala"
								_g_object_unref0 (_data_->body_parts);
#line 412 "../src/engine/rfc822/rfc822-message.vala"
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 412 "../src/engine/rfc822/rfc822-message.vala"
								g_clear_error (&_data_->_inner_error0_);
#line 412 "../src/engine/rfc822/rfc822-message.vala"
								g_object_unref (_data_->_async_result);
#line 412 "../src/engine/rfc822/rfc822-message.vala"
								return FALSE;
#line 3645 "rfc822-message.c"
							}
						}
#line 426 "../src/engine/rfc822/rfc822-message.vala"
						_data_->_tmp274_ = _data_->_vala1_inline_part;
#line 426 "../src/engine/rfc822/rfc822-message.vala"
						if (_data_->_tmp274_ != NULL) {
#line 427 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_tmp275_ = _data_->_vala1_inline_part;
#line 427 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_tmp276_ = _data_->_vala1_cid;
#line 427 "../src/engine/rfc822/rfc822-message.vala"
							g_mime_object_set_content_id (_data_->_tmp275_, _data_->_tmp276_);
#line 428 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_tmp277_ = _data_->related_parts;
#line 428 "../src/engine/rfc822/rfc822-message.vala"
							_data_->_tmp278_ = _data_->_vala1_inline_part;
#line 428 "../src/engine/rfc822/rfc822-message.vala"
							gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp277_, GEE_TYPE_COLLECTION, GeeCollection), _data_->_tmp278_);
#line 3664 "rfc822-message.c"
						}
#line 409 "../src/engine/rfc822/rfc822-message.vala"
						_g_object_unref0 (_data_->_vala1_inline_part);
#line 3668 "rfc822-message.c"
					}
#line 403 "../src/engine/rfc822/rfc822-message.vala"
					_g_free0 (_data_->_vala1_cid);
#line 403 "../src/engine/rfc822/rfc822-message.vala"
					_g_free0 (_data_->name);
#line 3674 "rfc822-message.c"
				}
#line 403 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (_data_->_name_it);
#line 3678 "rfc822-message.c"
			}
		}
#line 434 "../src/engine/rfc822/rfc822-message.vala"
		_data_->body_html = NULL;
#line 3683 "rfc822-message.c"
		{
#line 436 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp280_ = geary_composed_email_get_body_html (_data_->email);
#line 436 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp281_ = _data_->_tmp280_;
#line 436 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp283_ = 0;
#line 436 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp282_ = string_get_data (_data_->_tmp281_, &_data_->_tmp283_);
#line 436 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp282__length1 = _data_->_tmp283_;
#line 436 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp284_ = _data_->_tmp282_;
#line 436 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp284__length1 = _data_->_tmp282__length1;
#line 436 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp285_ = _data_->body_charset;
#line 436 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_state_ = 4;
#line 436 "../src/engine/rfc822/rfc822-message.vala"
			geary_rf_c822_message_body_data_to_part (_data_->self, _data_->_tmp284_, (gint) _data_->_tmp284__length1, _data_->_tmp285_, "text/html", FALSE, _data_->cancellable, geary_rf_c822_message_new_from_composed_email_ready, _data_);
#line 436 "../src/engine/rfc822/rfc822-message.vala"
			return FALSE;
#line 3707 "rfc822-message.c"
			_state_4:
#line 436 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp286_ = geary_rf_c822_message_body_data_to_part_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 436 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp279_ = _data_->_tmp286_;
#line 436 "../src/engine/rfc822/rfc822-message.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3715 "rfc822-message.c"
				goto __catch3_g_error;
			}
#line 436 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp287_ = _data_->_tmp279_;
#line 436 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp279_ = NULL;
#line 436 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_data_->body_html);
#line 436 "../src/engine/rfc822/rfc822-message.vala"
			_data_->body_html = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp287_, g_mime_object_get_type (), GMimeObject);
#line 435 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_data_->_tmp279_);
#line 3728 "rfc822-message.c"
		}
		goto __finally3;
		__catch3_g_error:
		{
#line 435 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_vala3_err = _data_->_inner_error0_;
#line 435 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_inner_error0_ = NULL;
#line 444 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp288_ = _data_->_vala3_err;
#line 444 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp289_ = _data_->_tmp288_->message;
#line 444 "../src/engine/rfc822/rfc822-message.vala"
			g_warning ("rfc822-message.vala:444: Error creating html body part: %s", _data_->_tmp289_);
#line 435 "../src/engine/rfc822/rfc822-message.vala"
			_g_error_free0 (_data_->_vala3_err);
#line 3745 "rfc822-message.c"
		}
		__finally3:
#line 435 "../src/engine/rfc822/rfc822-message.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 435 "../src/engine/rfc822/rfc822-message.vala"
			if (_data_->_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 435 "../src/engine/rfc822/rfc822-message.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 435 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (_data_->body_html);
#line 435 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (_data_->inline_files);
#line 435 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (_data_->related_parts);
#line 435 "../src/engine/rfc822/rfc822-message.vala"
				_g_free0 (_data_->body_charset);
#line 435 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (_data_->body_parts);
#line 435 "../src/engine/rfc822/rfc822-message.vala"
				g_object_unref (_data_->_async_result);
#line 435 "../src/engine/rfc822/rfc822-message.vala"
				return FALSE;
#line 3768 "rfc822-message.c"
			} else {
#line 435 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (_data_->body_html);
#line 435 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (_data_->inline_files);
#line 435 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (_data_->related_parts);
#line 435 "../src/engine/rfc822/rfc822-message.vala"
				_g_free0 (_data_->body_charset);
#line 435 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (_data_->body_parts);
#line 435 "../src/engine/rfc822/rfc822-message.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 435 "../src/engine/rfc822/rfc822-message.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 435 "../src/engine/rfc822/rfc822-message.vala"
				g_object_unref (_data_->_async_result);
#line 435 "../src/engine/rfc822/rfc822-message.vala"
				return FALSE;
#line 3788 "rfc822-message.c"
			}
		}
#line 449 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp290_ = _data_->related_parts;
#line 449 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp291_ = gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp290_, GEE_TYPE_COLLECTION, GeeCollection));
#line 449 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp292_ = _data_->_tmp291_;
#line 449 "../src/engine/rfc822/rfc822-message.vala"
		if (!_data_->_tmp292_) {
#line 450 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp293_ = _data_->related_parts;
#line 450 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp294_ = _data_->body_html;
#line 450 "../src/engine/rfc822/rfc822-message.vala"
			gee_list_insert (_data_->_tmp293_, 0, _data_->_tmp294_);
#line 451 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp295_ = _data_->related_parts;
#line 451 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp296_ = geary_rf_c822_message_coalesce_related (_data_->self, _data_->_tmp295_, "text/html");
#line 451 "../src/engine/rfc822/rfc822-message.vala"
			_data_->related_part = _data_->_tmp296_;
#line 453 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp297_ = _data_->related_part;
#line 453 "../src/engine/rfc822/rfc822-message.vala"
			if (_data_->_tmp297_ != NULL) {
#line 454 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp298_ = _data_->related_part;
#line 454 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp299_ = _g_object_ref0 (_data_->_tmp298_);
#line 454 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (_data_->body_html);
#line 454 "../src/engine/rfc822/rfc822-message.vala"
				_data_->body_html = _data_->_tmp299_;
#line 3823 "rfc822-message.c"
			}
#line 449 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_data_->related_part);
#line 3827 "rfc822-message.c"
		}
#line 457 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp300_ = _data_->body_parts;
#line 457 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp301_ = _data_->body_html;
#line 457 "../src/engine/rfc822/rfc822-message.vala"
		gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp300_, GEE_TYPE_COLLECTION, GeeCollection), _data_->_tmp301_);
#line 355 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_data_->body_html);
#line 355 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_data_->inline_files);
#line 355 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_data_->related_parts);
#line 3841 "rfc822-message.c"
	}
#line 461 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp302_ = gee_linked_list_new (g_mime_object_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 461 "../src/engine/rfc822/rfc822-message.vala"
	_data_->main_parts = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp302_, GEE_TYPE_LIST, GeeList);
#line 462 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp303_ = _data_->body_parts;
#line 462 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp304_ = geary_rf_c822_message_coalesce_parts (_data_->self, _data_->_tmp303_, "alternative");
#line 462 "../src/engine/rfc822/rfc822-message.vala"
	_data_->body_part = _data_->_tmp304_;
#line 463 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp305_ = _data_->body_part;
#line 463 "../src/engine/rfc822/rfc822-message.vala"
	if (_data_->_tmp305_ != NULL) {
#line 464 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp306_ = _data_->main_parts;
#line 464 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp307_ = _data_->body_part;
#line 464 "../src/engine/rfc822/rfc822-message.vala"
		gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp306_, GEE_TYPE_COLLECTION, GeeCollection), _data_->_tmp307_);
#line 3863 "rfc822-message.c"
	}
#line 466 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp308_ = gee_linked_list_new (g_mime_object_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 466 "../src/engine/rfc822/rfc822-message.vala"
	_data_->attachment_parts = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp308_, GEE_TYPE_LIST, GeeList);
#line 3869 "rfc822-message.c"
	{
#line 467 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp309_ = geary_composed_email_get_attached_files (_data_->email);
#line 467 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp310_ = _data_->_tmp309_;
#line 467 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp311_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp310_, GEE_TYPE_ITERABLE, GeeIterable));
#line 467 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_file_it = _data_->_tmp311_;
#line 467 "../src/engine/rfc822/rfc822-message.vala"
		while (TRUE) {
#line 467 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp312_ = _data_->_file_it;
#line 467 "../src/engine/rfc822/rfc822-message.vala"
			if (!gee_iterator_next (_data_->_tmp312_)) {
#line 467 "../src/engine/rfc822/rfc822-message.vala"
				break;
#line 3887 "rfc822-message.c"
			}
#line 467 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp313_ = _data_->_file_it;
#line 467 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp314_ = gee_iterator_get (_data_->_tmp313_);
#line 467 "../src/engine/rfc822/rfc822-message.vala"
			_data_->file = (GFile*) _data_->_tmp314_;
#line 468 "../src/engine/rfc822/rfc822-message.vala"
			_data_->attachment_part = NULL;
#line 3897 "rfc822-message.c"
			{
#line 470 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp316_ = _data_->file;
#line 470 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_state_ = 5;
#line 470 "../src/engine/rfc822/rfc822-message.vala"
				geary_rf_c822_message_get_file_part (_data_->self, _data_->_tmp316_, GEARY_MIME_DISPOSITION_TYPE_ATTACHMENT, _data_->cancellable, geary_rf_c822_message_new_from_composed_email_ready, _data_);
#line 470 "../src/engine/rfc822/rfc822-message.vala"
				return FALSE;
#line 3907 "rfc822-message.c"
				_state_5:
#line 470 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp317_ = geary_rf_c822_message_get_file_part_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 470 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp315_ = _data_->_tmp317_;
#line 470 "../src/engine/rfc822/rfc822-message.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3915 "rfc822-message.c"
					goto __catch4_g_error;
				}
#line 470 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp318_ = _data_->_tmp315_;
#line 470 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp315_ = NULL;
#line 470 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (_data_->attachment_part);
#line 470 "../src/engine/rfc822/rfc822-message.vala"
				_data_->attachment_part = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp318_, g_mime_object_get_type (), GMimeObject);
#line 469 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (_data_->_tmp315_);
#line 3928 "rfc822-message.c"
			}
			goto __finally4;
			__catch4_g_error:
			{
#line 469 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_vala4_err = _data_->_inner_error0_;
#line 469 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_inner_error0_ = NULL;
#line 476 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp319_ = _data_->file;
#line 476 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp320_ = g_file_get_path (_data_->_tmp319_);
#line 476 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp321_ = _data_->_tmp320_;
#line 476 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp322_ = _data_->_vala4_err;
#line 476 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp323_ = _data_->_tmp322_->message;
#line 476 "../src/engine/rfc822/rfc822-message.vala"
				g_warning ("rfc822-message.vala:476: Error creating attachment file part %s: %s", _data_->_tmp321_, _data_->_tmp323_);
#line 476 "../src/engine/rfc822/rfc822-message.vala"
				_g_free0 (_data_->_tmp321_);
#line 469 "../src/engine/rfc822/rfc822-message.vala"
				_g_error_free0 (_data_->_vala4_err);
#line 3953 "rfc822-message.c"
			}
			__finally4:
#line 469 "../src/engine/rfc822/rfc822-message.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 469 "../src/engine/rfc822/rfc822-message.vala"
				if (_data_->_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 469 "../src/engine/rfc822/rfc822-message.vala"
					g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 469 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (_data_->attachment_part);
#line 469 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (_data_->file);
#line 469 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (_data_->_file_it);
#line 469 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (_data_->attachment_parts);
#line 469 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (_data_->body_part);
#line 469 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (_data_->main_parts);
#line 469 "../src/engine/rfc822/rfc822-message.vala"
					_g_free0 (_data_->body_charset);
#line 469 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (_data_->body_parts);
#line 469 "../src/engine/rfc822/rfc822-message.vala"
					g_object_unref (_data_->_async_result);
#line 469 "../src/engine/rfc822/rfc822-message.vala"
					return FALSE;
#line 3982 "rfc822-message.c"
				} else {
#line 469 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (_data_->attachment_part);
#line 469 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (_data_->file);
#line 469 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (_data_->_file_it);
#line 469 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (_data_->attachment_parts);
#line 469 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (_data_->body_part);
#line 469 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (_data_->main_parts);
#line 469 "../src/engine/rfc822/rfc822-message.vala"
					_g_free0 (_data_->body_charset);
#line 469 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (_data_->body_parts);
#line 469 "../src/engine/rfc822/rfc822-message.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 469 "../src/engine/rfc822/rfc822-message.vala"
					g_clear_error (&_data_->_inner_error0_);
#line 469 "../src/engine/rfc822/rfc822-message.vala"
					g_object_unref (_data_->_async_result);
#line 469 "../src/engine/rfc822/rfc822-message.vala"
					return FALSE;
#line 4008 "rfc822-message.c"
				}
			}
#line 482 "../src/engine/rfc822/rfc822-message.vala"
			_data_->_tmp324_ = _data_->attachment_part;
#line 482 "../src/engine/rfc822/rfc822-message.vala"
			if (_data_->_tmp324_ != NULL) {
#line 483 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp325_ = _data_->attachment_parts;
#line 483 "../src/engine/rfc822/rfc822-message.vala"
				_data_->_tmp326_ = _data_->attachment_part;
#line 483 "../src/engine/rfc822/rfc822-message.vala"
				gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp325_, GEE_TYPE_COLLECTION, GeeCollection), _data_->_tmp326_);
#line 4021 "rfc822-message.c"
			}
#line 467 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_data_->attachment_part);
#line 467 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_data_->file);
#line 4027 "rfc822-message.c"
		}
#line 467 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_data_->_file_it);
#line 4031 "rfc822-message.c"
	}
#line 486 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp327_ = _data_->attachment_parts;
#line 486 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp328_ = geary_rf_c822_message_coalesce_parts (_data_->self, _data_->_tmp327_, "mixed");
#line 486 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_vala1_attachment_part = _data_->_tmp328_;
#line 487 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp329_ = _data_->_vala1_attachment_part;
#line 487 "../src/engine/rfc822/rfc822-message.vala"
	if (_data_->_tmp329_ != NULL) {
#line 488 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp330_ = _data_->main_parts;
#line 488 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp331_ = _data_->_vala1_attachment_part;
#line 488 "../src/engine/rfc822/rfc822-message.vala"
		gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp330_, GEE_TYPE_COLLECTION, GeeCollection), _data_->_tmp331_);
#line 4049 "rfc822-message.c"
	}
#line 490 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp332_ = _data_->main_parts;
#line 490 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp333_ = geary_rf_c822_message_coalesce_parts (_data_->self, _data_->_tmp332_, "mixed");
#line 490 "../src/engine/rfc822/rfc822-message.vala"
	_data_->main_part = _data_->_tmp333_;
#line 491 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp334_ = _data_->self->priv->message;
#line 491 "../src/engine/rfc822/rfc822-message.vala"
	g_mime_message_set_mime_part (_data_->_tmp334_, _data_->main_part);
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->main_part);
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->_vala1_attachment_part);
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->attachment_parts);
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->body_part);
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->main_parts);
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_g_free0 (_data_->body_charset);
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->body_parts);
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	if (_data_->_state_ != 0) {
#line 237 "../src/engine/rfc822/rfc822-message.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 237 "../src/engine/rfc822/rfc822-message.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4083 "rfc822-message.c"
		}
	}
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	g_object_unref (_data_->_async_result);
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	return FALSE;
#line 4090 "rfc822-message.c"
}

void
geary_rf_c822_message_new_from_composed_email (GearyComposedEmail* email,
                                               const gchar* message_id,
                                               GCancellable* cancellable,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	geary_rf_c822_message_construct_from_composed_email (GEARY_RF_C822_TYPE_MESSAGE, email, message_id, cancellable, _callback_, _user_data_);
#line 4102 "rfc822-message.c"
}

GearyRFC822Message*
geary_rf_c822_message_new_from_composed_email_finish (GAsyncResult* _res_,
                                                      GError** error)
{
#line 237 "../src/engine/rfc822/rfc822-message.vala"
	return geary_rf_c822_message_construct_from_composed_email_finish (_res_, error);
#line 4111 "rfc822-message.c"
}

static GMimeObject*
geary_rf_c822_message_coalesce_related (GearyRFC822Message* self,
                                        GeeList* parts,
                                        const gchar* type)
{
	GMimeObject* part = NULL;
	GMimeObject* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GMimeObject* result;
#line 494 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), NULL);
#line 494 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (parts, GEE_TYPE_LIST), NULL);
#line 494 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (type != NULL, NULL);
#line 496 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = geary_rf_c822_message_coalesce_parts (self, parts, "related");
#line 496 "../src/engine/rfc822/rfc822-message.vala"
	part = _tmp0_;
#line 497 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (parts, GEE_TYPE_COLLECTION, GeeCollection));
#line 497 "../src/engine/rfc822/rfc822-message.vala"
	_tmp2_ = _tmp1_;
#line 497 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp2_ > 1) {
#line 4140 "rfc822-message.c"
		GMimeObject* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 498 "../src/engine/rfc822/rfc822-message.vala"
		_tmp3_ = part;
#line 498 "../src/engine/rfc822/rfc822-message.vala"
		_tmp4_ = geary_rf_c822_get_charset ();
#line 498 "../src/engine/rfc822/rfc822-message.vala"
		_tmp5_ = _tmp4_;
#line 498 "../src/engine/rfc822/rfc822-message.vala"
		g_mime_object_set_header (_tmp3_, "Type", type, _tmp5_);
#line 498 "../src/engine/rfc822/rfc822-message.vala"
		_g_free0 (_tmp5_);
#line 4154 "rfc822-message.c"
	}
#line 500 "../src/engine/rfc822/rfc822-message.vala"
	result = part;
#line 500 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 4160 "rfc822-message.c"
}

static GMimeObject*
geary_rf_c822_message_coalesce_parts (GearyRFC822Message* self,
                                      GeeList* parts,
                                      const gchar* subtype)
{
	gint _tmp0_;
	gint _tmp1_;
	GMimeObject* result;
#line 503 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), NULL);
#line 503 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (parts, GEE_TYPE_LIST), NULL);
#line 503 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (subtype != NULL, NULL);
#line 504 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (parts, GEE_TYPE_COLLECTION, GeeCollection));
#line 504 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = _tmp0_;
#line 504 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp1_ == 0) {
#line 505 "../src/engine/rfc822/rfc822-message.vala"
		result = NULL;
#line 505 "../src/engine/rfc822/rfc822-message.vala"
		return result;
#line 4187 "rfc822-message.c"
	} else {
		gint _tmp2_;
		gint _tmp3_;
#line 506 "../src/engine/rfc822/rfc822-message.vala"
		_tmp2_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (parts, GEE_TYPE_COLLECTION, GeeCollection));
#line 506 "../src/engine/rfc822/rfc822-message.vala"
		_tmp3_ = _tmp2_;
#line 506 "../src/engine/rfc822/rfc822-message.vala"
		if (_tmp3_ == 1) {
#line 4197 "rfc822-message.c"
			gpointer _tmp4_;
#line 507 "../src/engine/rfc822/rfc822-message.vala"
			_tmp4_ = gee_list_first (parts);
#line 507 "../src/engine/rfc822/rfc822-message.vala"
			result = (GMimeObject*) _tmp4_;
#line 507 "../src/engine/rfc822/rfc822-message.vala"
			return result;
#line 4205 "rfc822-message.c"
		} else {
			GMimeMultipart* multipart = NULL;
			GMimeMultipart* _tmp5_;
#line 509 "../src/engine/rfc822/rfc822-message.vala"
			_tmp5_ = g_mime_multipart_new_with_subtype (subtype);
#line 509 "../src/engine/rfc822/rfc822-message.vala"
			multipart = _tmp5_;
#line 4213 "rfc822-message.c"
			{
				GeeList* _part_list = NULL;
				gint _part_size = 0;
				GeeList* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				gint _part_index = 0;
#line 510 "../src/engine/rfc822/rfc822-message.vala"
				_part_list = parts;
#line 510 "../src/engine/rfc822/rfc822-message.vala"
				_tmp6_ = _part_list;
#line 510 "../src/engine/rfc822/rfc822-message.vala"
				_tmp7_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_COLLECTION, GeeCollection));
#line 510 "../src/engine/rfc822/rfc822-message.vala"
				_tmp8_ = _tmp7_;
#line 510 "../src/engine/rfc822/rfc822-message.vala"
				_part_size = _tmp8_;
#line 510 "../src/engine/rfc822/rfc822-message.vala"
				_part_index = -1;
#line 510 "../src/engine/rfc822/rfc822-message.vala"
				while (TRUE) {
#line 4235 "rfc822-message.c"
					gint _tmp9_;
					gint _tmp10_;
					GMimeObject* part = NULL;
					GeeList* _tmp11_;
					gpointer _tmp12_;
					GMimeMultipart* _tmp13_;
					GMimeObject* _tmp14_;
#line 510 "../src/engine/rfc822/rfc822-message.vala"
					_part_index = _part_index + 1;
#line 510 "../src/engine/rfc822/rfc822-message.vala"
					_tmp9_ = _part_index;
#line 510 "../src/engine/rfc822/rfc822-message.vala"
					_tmp10_ = _part_size;
#line 510 "../src/engine/rfc822/rfc822-message.vala"
					if (!(_tmp9_ < _tmp10_)) {
#line 510 "../src/engine/rfc822/rfc822-message.vala"
						break;
#line 4253 "rfc822-message.c"
					}
#line 510 "../src/engine/rfc822/rfc822-message.vala"
					_tmp11_ = _part_list;
#line 510 "../src/engine/rfc822/rfc822-message.vala"
					_tmp12_ = gee_list_get (_tmp11_, _part_index);
#line 510 "../src/engine/rfc822/rfc822-message.vala"
					part = (GMimeObject*) _tmp12_;
#line 511 "../src/engine/rfc822/rfc822-message.vala"
					_tmp13_ = multipart;
#line 511 "../src/engine/rfc822/rfc822-message.vala"
					_tmp14_ = part;
#line 511 "../src/engine/rfc822/rfc822-message.vala"
					g_mime_multipart_add (_tmp13_, _tmp14_);
#line 510 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (part);
#line 4269 "rfc822-message.c"
				}
			}
#line 512 "../src/engine/rfc822/rfc822-message.vala"
			result = G_TYPE_CHECK_INSTANCE_CAST (multipart, g_mime_object_get_type (), GMimeObject);
#line 512 "../src/engine/rfc822/rfc822-message.vala"
			return result;
#line 4276 "rfc822-message.c"
		}
	}
}

static void
geary_rf_c822_message_get_file_part_data_free (gpointer _data)
{
	GearyRfC822MessageGetFilePartData* _data_;
	_data_ = _data;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->file);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->cancellable);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->result);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->self);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_slice_free (GearyRfC822MessageGetFilePartData, _data_);
#line 4296 "rfc822-message.c"
}

static void
geary_rf_c822_message_get_file_part (GearyRFC822Message* self,
                                     GFile* file,
                                     GearyMimeDispositionType disposition,
                                     GCancellable* cancellable,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	GearyRfC822MessageGetFilePartData* _data_;
	GearyRFC822Message* _tmp0_;
	GFile* _tmp1_;
	GCancellable* _tmp2_;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_return_if_fail (GEARY_RF_C822_IS_MESSAGE (self));
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_ = g_slice_new0 (GearyRfC822MessageGetFilePartData);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_rf_c822_message_get_file_part_data_free);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_->self = _tmp0_;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = _g_object_ref0 (file);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->file);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_->file = _tmp1_;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_->disposition = disposition;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->cancellable);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_->cancellable = _tmp2_;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	geary_rf_c822_message_get_file_part_co (_data_);
#line 4343 "rfc822-message.c"
}

static GMimePart*
geary_rf_c822_message_get_file_part_finish (GearyRFC822Message* self,
                                            GAsyncResult* _res_,
                                            GError** error)
{
	GMimePart* result;
	GearyRfC822MessageGetFilePartData* _data_;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	if (NULL == _data_) {
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		return NULL;
#line 4359 "rfc822-message.c"
	}
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	result = _data_->result;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_->result = NULL;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 4367 "rfc822-message.c"
}

static void
geary_rf_c822_message_get_file_part_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_)
{
	GearyRfC822MessageGetFilePartData* _data_;
#line 520 "../src/engine/rfc822/rfc822-message.vala"
	_data_ = _user_data_;
#line 520 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_source_object_ = source_object;
#line 520 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_res_ = _res_;
#line 520 "../src/engine/rfc822/rfc822-message.vala"
	geary_rf_c822_message_get_file_part_co (_data_);
#line 4384 "rfc822-message.c"
}

static gboolean
geary_rf_c822_message_get_file_part_co (GearyRfC822MessageGetFilePartData* _data_)
{
#line 516 "../src/engine/rfc822/rfc822-message.vala"
	switch (_data_->_state_) {
#line 516 "../src/engine/rfc822/rfc822-message.vala"
		case 0:
#line 4394 "rfc822-message.c"
		goto _state_0;
#line 516 "../src/engine/rfc822/rfc822-message.vala"
		case 1:
#line 4398 "rfc822-message.c"
		goto _state_1;
		default:
#line 516 "../src/engine/rfc822/rfc822-message.vala"
		g_assert_not_reached ();
#line 4403 "rfc822-message.c"
	}
	_state_0:
#line 520 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_state_ = 1;
#line 520 "../src/engine/rfc822/rfc822-message.vala"
	g_file_query_info_async (_data_->file, G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, G_FILE_QUERY_INFO_NONE, G_PRIORITY_DEFAULT, NULL, geary_rf_c822_message_get_file_part_ready, _data_);
#line 520 "../src/engine/rfc822/rfc822-message.vala"
	return FALSE;
#line 4412 "rfc822-message.c"
	_state_1:
#line 520 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp0_ = g_file_query_info_finish (_data_->file, _data_->_res_, &_data_->_inner_error0_);
#line 520 "../src/engine/rfc822/rfc822-message.vala"
	_data_->file_info = _data_->_tmp0_;
#line 520 "../src/engine/rfc822/rfc822-message.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 520 "../src/engine/rfc822/rfc822-message.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 520 "../src/engine/rfc822/rfc822-message.vala"
		g_object_unref (_data_->_async_result);
#line 520 "../src/engine/rfc822/rfc822-message.vala"
		return FALSE;
#line 4426 "rfc822-message.c"
	}
#line 525 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp1_ = g_mime_part_new ();
#line 525 "../src/engine/rfc822/rfc822-message.vala"
	_data_->part = _data_->_tmp1_;
#line 526 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp2_ = _data_->part;
#line 526 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp3_ = geary_mime_disposition_type_serialize (_data_->disposition);
#line 526 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 526 "../src/engine/rfc822/rfc822-message.vala"
	g_mime_object_set_disposition (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, g_mime_object_get_type (), GMimeObject), _data_->_tmp4_);
#line 526 "../src/engine/rfc822/rfc822-message.vala"
	_g_free0 (_data_->_tmp4_);
#line 527 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp5_ = _data_->part;
#line 527 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp6_ = g_file_get_basename (_data_->file);
#line 527 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 527 "../src/engine/rfc822/rfc822-message.vala"
	g_mime_part_set_filename (_data_->_tmp5_, _data_->_tmp7_);
#line 527 "../src/engine/rfc822/rfc822-message.vala"
	_g_free0 (_data_->_tmp7_);
#line 529 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp8_ = geary_rf_c822_get_parser_options ();
#line 529 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp9_ = _data_->_tmp8_;
#line 529 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp10_ = g_file_info_get_content_type (_data_->file_info);
#line 529 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp11_ = g_mime_content_type_parse (_data_->_tmp9_, _data_->_tmp10_);
#line 529 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 529 "../src/engine/rfc822/rfc822-message.vala"
	__vala_GMimeParserOptions_free0 (_data_->_tmp9_);
#line 529 "../src/engine/rfc822/rfc822-message.vala"
	_data_->content_type = _data_->_tmp12_;
#line 533 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp13_ = _data_->part;
#line 533 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp14_ = _data_->content_type;
#line 533 "../src/engine/rfc822/rfc822-message.vala"
	g_mime_object_set_content_type (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp13_, g_mime_object_get_type (), GMimeObject), _data_->_tmp14_);
#line 544 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp15_ = _data_->part;
#line 544 "../src/engine/rfc822/rfc822-message.vala"
	g_mime_part_set_content_encoding (_data_->_tmp15_, GMIME_CONTENT_ENCODING_BASE64);
#line 546 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp16_ = (GMimeStreamGIO*) g_mime_stream_gio_new (_data_->file);
#line 546 "../src/engine/rfc822/rfc822-message.vala"
	_data_->stream = _data_->_tmp16_;
#line 547 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp17_ = _data_->stream;
#line 547 "../src/engine/rfc822/rfc822-message.vala"
	g_mime_stream_gio_set_owner (_data_->_tmp17_, FALSE);
#line 548 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp18_ = _data_->part;
#line 548 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp19_ = _data_->stream;
#line 548 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp20_ = g_mime_data_wrapper_new_with_stream (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp19_, g_mime_stream_get_type (), GMimeStream), GMIME_CONTENT_ENCODING_BINARY);
#line 548 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp21_ = _data_->_tmp20_;
#line 548 "../src/engine/rfc822/rfc822-message.vala"
	g_mime_part_set_content (_data_->_tmp18_, _data_->_tmp21_);
#line 548 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->_tmp21_);
#line 554 "../src/engine/rfc822/rfc822-message.vala"
	_data_->result = _data_->part;
#line 554 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->stream);
#line 554 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->content_type);
#line 554 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->file_info);
#line 554 "../src/engine/rfc822/rfc822-message.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 554 "../src/engine/rfc822/rfc822-message.vala"
	if (_data_->_state_ != 0) {
#line 554 "../src/engine/rfc822/rfc822-message.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 554 "../src/engine/rfc822/rfc822-message.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4512 "rfc822-message.c"
		}
	}
#line 554 "../src/engine/rfc822/rfc822-message.vala"
	g_object_unref (_data_->_async_result);
#line 554 "../src/engine/rfc822/rfc822-message.vala"
	return FALSE;
#line 4519 "rfc822-message.c"
}

static void
geary_rf_c822_message_get_buffer_part_data_free (gpointer _data)
{
	GearyRfC822MessageGetBufferPartData* _data_;
	_data_ = _data;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->buffer);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_g_free0 (_data_->basename);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->cancellable);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->result);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->self);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_slice_free (GearyRfC822MessageGetBufferPartData, _data_);
#line 4539 "rfc822-message.c"
}

static void
geary_rf_c822_message_get_buffer_part (GearyRFC822Message* self,
                                       GearyMemoryBuffer* buffer,
                                       const gchar* basename,
                                       GearyMimeDispositionType disposition,
                                       GCancellable* cancellable,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	GearyRfC822MessageGetBufferPartData* _data_;
	GearyRFC822Message* _tmp0_;
	GearyMemoryBuffer* _tmp1_;
	gchar* _tmp2_;
	GCancellable* _tmp3_;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_return_if_fail (GEARY_RF_C822_IS_MESSAGE (self));
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_return_if_fail (GEARY_MEMORY_IS_BUFFER (buffer));
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_return_if_fail (basename != NULL);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_ = g_slice_new0 (GearyRfC822MessageGetBufferPartData);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_rf_c822_message_get_buffer_part_data_free);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_->self = _tmp0_;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = _g_object_ref0 (buffer);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->buffer);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_->buffer = _tmp1_;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_tmp2_ = g_strdup (basename);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_g_free0 (_data_->basename);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_->basename = _tmp2_;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_->disposition = disposition;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->cancellable);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_->cancellable = _tmp3_;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	geary_rf_c822_message_get_buffer_part_co (_data_);
#line 4596 "rfc822-message.c"
}

static GMimePart*
geary_rf_c822_message_get_buffer_part_finish (GearyRFC822Message* self,
                                              GAsyncResult* _res_,
                                              GError** error)
{
	GMimePart* result;
	GearyRfC822MessageGetBufferPartData* _data_;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	if (NULL == _data_) {
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		return NULL;
#line 4612 "rfc822-message.c"
	}
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	result = _data_->result;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_->result = NULL;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 4620 "rfc822-message.c"
}

/**
     * Create a GMime part for the provided attachment buffer
     */
static gboolean
geary_rf_c822_message_get_buffer_part_co (GearyRfC822MessageGetBufferPartData* _data_)
{
#line 560 "../src/engine/rfc822/rfc822-message.vala"
	switch (_data_->_state_) {
#line 560 "../src/engine/rfc822/rfc822-message.vala"
		case 0:
#line 4633 "rfc822-message.c"
		goto _state_0;
		default:
#line 560 "../src/engine/rfc822/rfc822-message.vala"
		g_assert_not_reached ();
#line 4638 "rfc822-message.c"
	}
	_state_0:
#line 565 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp0_ = geary_mime_content_type_guess_type (_data_->basename, _data_->buffer, &_data_->_inner_error0_);
#line 565 "../src/engine/rfc822/rfc822-message.vala"
	_data_->mime_type = _data_->_tmp0_;
#line 565 "../src/engine/rfc822/rfc822-message.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 565 "../src/engine/rfc822/rfc822-message.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 565 "../src/engine/rfc822/rfc822-message.vala"
		g_object_unref (_data_->_async_result);
#line 565 "../src/engine/rfc822/rfc822-message.vala"
		return FALSE;
#line 4653 "rfc822-message.c"
	}
#line 570 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp1_ = _data_->mime_type;
#line 570 "../src/engine/rfc822/rfc822-message.vala"
	if (_data_->_tmp1_ == NULL) {
#line 571 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp2_ = g_strdup_printf (_ ("Could not determine mime type for “%s”."), _data_->basename);
#line 571 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 571 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp4_ = g_error_new_literal (GEARY_RF_C822_ERROR, GEARY_RF_C822_ERROR_INVALID, _data_->_tmp3_);
#line 571 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 571 "../src/engine/rfc822/rfc822-message.vala"
		_g_free0 (_data_->_tmp3_);
#line 571 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_inner_error0_ = _data_->_tmp5_;
#line 571 "../src/engine/rfc822/rfc822-message.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 571 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_data_->mime_type);
#line 571 "../src/engine/rfc822/rfc822-message.vala"
		g_object_unref (_data_->_async_result);
#line 571 "../src/engine/rfc822/rfc822-message.vala"
		return FALSE;
#line 4679 "rfc822-message.c"
	}
#line 576 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp6_ = geary_rf_c822_get_parser_options ();
#line 576 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 576 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp8_ = _data_->mime_type;
#line 576 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp9_ = geary_mime_content_type_get_mime_type (_data_->_tmp8_);
#line 576 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 576 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp11_ = g_mime_content_type_parse (_data_->_tmp7_, _data_->_tmp10_);
#line 576 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 576 "../src/engine/rfc822/rfc822-message.vala"
	_g_free0 (_data_->_tmp10_);
#line 576 "../src/engine/rfc822/rfc822-message.vala"
	__vala_GMimeParserOptions_free0 (_data_->_tmp7_);
#line 576 "../src/engine/rfc822/rfc822-message.vala"
	_data_->content_type = _data_->_tmp12_;
#line 581 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp13_ = _data_->content_type;
#line 581 "../src/engine/rfc822/rfc822-message.vala"
	if (_data_->_tmp13_ == NULL) {
#line 582 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp14_ = _data_->mime_type;
#line 582 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp15_ = geary_mime_content_type_to_string (_data_->_tmp14_);
#line 582 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp16_ = _data_->_tmp15_;
#line 582 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp17_ = g_strdup_printf (_ ("Could not determine content type for mime type “%s” on “%s”."), _data_->_tmp16_, _data_->basename);
#line 582 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp18_ = _data_->_tmp17_;
#line 582 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp19_ = g_error_new_literal (GEARY_RF_C822_ERROR, GEARY_RF_C822_ERROR_INVALID, _data_->_tmp18_);
#line 582 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp20_ = _data_->_tmp19_;
#line 582 "../src/engine/rfc822/rfc822-message.vala"
		_g_free0 (_data_->_tmp18_);
#line 582 "../src/engine/rfc822/rfc822-message.vala"
		_g_free0 (_data_->_tmp16_);
#line 582 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_inner_error0_ = _data_->_tmp20_;
#line 582 "../src/engine/rfc822/rfc822-message.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 582 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_data_->content_type);
#line 582 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_data_->mime_type);
#line 582 "../src/engine/rfc822/rfc822-message.vala"
		g_object_unref (_data_->_async_result);
#line 582 "../src/engine/rfc822/rfc822-message.vala"
		return FALSE;
#line 4735 "rfc822-message.c"
	}
#line 587 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp21_ = g_mime_part_new ();
#line 587 "../src/engine/rfc822/rfc822-message.vala"
	_data_->part = _data_->_tmp21_;
#line 588 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp22_ = _data_->part;
#line 588 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp23_ = geary_mime_disposition_type_serialize (_data_->disposition);
#line 588 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp24_ = _data_->_tmp23_;
#line 588 "../src/engine/rfc822/rfc822-message.vala"
	g_mime_object_set_disposition (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp22_, g_mime_object_get_type (), GMimeObject), _data_->_tmp24_);
#line 588 "../src/engine/rfc822/rfc822-message.vala"
	_g_free0 (_data_->_tmp24_);
#line 589 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp25_ = _data_->part;
#line 589 "../src/engine/rfc822/rfc822-message.vala"
	g_mime_part_set_filename (_data_->_tmp25_, _data_->basename);
#line 590 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp26_ = _data_->part;
#line 590 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp27_ = _data_->content_type;
#line 590 "../src/engine/rfc822/rfc822-message.vala"
	g_mime_object_set_content_type (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp26_, g_mime_object_get_type (), GMimeObject), _data_->_tmp27_);
#line 601 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp28_ = _data_->part;
#line 601 "../src/engine/rfc822/rfc822-message.vala"
	g_mime_part_set_content_encoding (_data_->_tmp28_, GMIME_CONTENT_ENCODING_BASE64);
#line 603 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp29_ = geary_rf_c822_utils_create_stream_mem (_data_->buffer);
#line 603 "../src/engine/rfc822/rfc822-message.vala"
	_data_->stream = _data_->_tmp29_;
#line 604 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp30_ = _data_->part;
#line 604 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp31_ = _data_->stream;
#line 604 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp32_ = g_mime_data_wrapper_new_with_stream (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp31_, g_mime_stream_get_type (), GMimeStream), GMIME_CONTENT_ENCODING_BINARY);
#line 604 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp33_ = _data_->_tmp32_;
#line 604 "../src/engine/rfc822/rfc822-message.vala"
	g_mime_part_set_content (_data_->_tmp30_, _data_->_tmp33_);
#line 604 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->_tmp33_);
#line 610 "../src/engine/rfc822/rfc822-message.vala"
	_data_->result = _data_->part;
#line 610 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->stream);
#line 610 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->content_type);
#line 610 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->mime_type);
#line 610 "../src/engine/rfc822/rfc822-message.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 610 "../src/engine/rfc822/rfc822-message.vala"
	if (_data_->_state_ != 0) {
#line 610 "../src/engine/rfc822/rfc822-message.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 610 "../src/engine/rfc822/rfc822-message.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4797 "rfc822-message.c"
		}
	}
#line 610 "../src/engine/rfc822/rfc822-message.vala"
	g_object_unref (_data_->_async_result);
#line 610 "../src/engine/rfc822/rfc822-message.vala"
	return FALSE;
#line 4804 "rfc822-message.c"
}

/**
     * Generates a preview from the email's message body.
     *
     * If there is no body, the empty string will be returned.
     */
gchar*
geary_rf_c822_message_get_preview (GearyRFC822Message* self)
{
	GearyRFC822TextFormat format = 0;
	gchar* preview = NULL;
	gchar* _tmp10_ = NULL;
	const gchar* _tmp11_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 618 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), NULL);
#line 619 "../src/engine/rfc822/rfc822-message.vala"
	format = GEARY_RF_C822_TEXT_FORMAT_PLAIN;
#line 620 "../src/engine/rfc822/rfc822-message.vala"
	preview = NULL;
#line 4827 "rfc822-message.c"
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 622 "../src/engine/rfc822/rfc822-message.vala"
		_tmp1_ = geary_rf_c822_message_get_plain_body (self, FALSE, NULL, NULL, &_inner_error0_);
#line 622 "../src/engine/rfc822/rfc822-message.vala"
		_tmp0_ = _tmp1_;
#line 622 "../src/engine/rfc822/rfc822-message.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 622 "../src/engine/rfc822/rfc822-message.vala"
			if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 4840 "rfc822-message.c"
				goto __catch0_geary_rf_c822_error;
			}
#line 622 "../src/engine/rfc822/rfc822-message.vala"
			_g_free0 (preview);
#line 622 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 622 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 622 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 4851 "rfc822-message.c"
		}
#line 622 "../src/engine/rfc822/rfc822-message.vala"
		_tmp2_ = _tmp0_;
#line 622 "../src/engine/rfc822/rfc822-message.vala"
		_tmp0_ = NULL;
#line 622 "../src/engine/rfc822/rfc822-message.vala"
		_g_free0 (preview);
#line 622 "../src/engine/rfc822/rfc822-message.vala"
		preview = _tmp2_;
#line 621 "../src/engine/rfc822/rfc822-message.vala"
		_g_free0 (_tmp0_);
#line 4863 "rfc822-message.c"
	}
	goto __finally0;
	__catch0_geary_rf_c822_error:
	{
		GError* e = NULL;
#line 621 "../src/engine/rfc822/rfc822-message.vala"
		e = _inner_error0_;
#line 621 "../src/engine/rfc822/rfc822-message.vala"
		_inner_error0_ = NULL;
#line 4873 "rfc822-message.c"
		{
			gchar* _tmp3_ = NULL;
			gchar* _tmp4_;
			gchar* _tmp5_;
#line 625 "../src/engine/rfc822/rfc822-message.vala"
			format = GEARY_RF_C822_TEXT_FORMAT_HTML;
#line 626 "../src/engine/rfc822/rfc822-message.vala"
			_tmp4_ = geary_rf_c822_message_get_html_body (self, NULL, NULL, &_inner_error0_);
#line 626 "../src/engine/rfc822/rfc822-message.vala"
			_tmp3_ = _tmp4_;
#line 626 "../src/engine/rfc822/rfc822-message.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 626 "../src/engine/rfc822/rfc822-message.vala"
				if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 4888 "rfc822-message.c"
					goto __catch1_geary_rf_c822_error;
				}
#line 626 "../src/engine/rfc822/rfc822-message.vala"
				_g_error_free0 (e);
#line 626 "../src/engine/rfc822/rfc822-message.vala"
				_g_free0 (preview);
#line 626 "../src/engine/rfc822/rfc822-message.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 626 "../src/engine/rfc822/rfc822-message.vala"
				g_clear_error (&_inner_error0_);
#line 626 "../src/engine/rfc822/rfc822-message.vala"
				return NULL;
#line 4901 "rfc822-message.c"
			}
#line 626 "../src/engine/rfc822/rfc822-message.vala"
			_tmp5_ = _tmp3_;
#line 626 "../src/engine/rfc822/rfc822-message.vala"
			_tmp3_ = NULL;
#line 626 "../src/engine/rfc822/rfc822-message.vala"
			_g_free0 (preview);
#line 626 "../src/engine/rfc822/rfc822-message.vala"
			preview = _tmp5_;
#line 624 "../src/engine/rfc822/rfc822-message.vala"
			_g_free0 (_tmp3_);
#line 4913 "rfc822-message.c"
		}
		goto __finally1;
		__catch1_geary_rf_c822_error:
		{
			GError* _error_ = NULL;
			GError* _tmp6_;
			const gchar* _tmp7_;
			GError* _tmp8_;
			const gchar* _tmp9_;
#line 624 "../src/engine/rfc822/rfc822-message.vala"
			_error_ = _inner_error0_;
#line 624 "../src/engine/rfc822/rfc822-message.vala"
			_inner_error0_ = NULL;
#line 628 "../src/engine/rfc822/rfc822-message.vala"
			_tmp6_ = e;
#line 628 "../src/engine/rfc822/rfc822-message.vala"
			_tmp7_ = _tmp6_->message;
#line 628 "../src/engine/rfc822/rfc822-message.vala"
			_tmp8_ = _error_;
#line 628 "../src/engine/rfc822/rfc822-message.vala"
			_tmp9_ = _tmp8_->message;
#line 628 "../src/engine/rfc822/rfc822-message.vala"
			g_debug ("rfc822-message.vala:628: Could not generate message preview: %s\n" \
" and: %s", _tmp7_, _tmp9_);
#line 624 "../src/engine/rfc822/rfc822-message.vala"
			_g_error_free0 (_error_);
#line 4939 "rfc822-message.c"
		}
		__finally1:
#line 624 "../src/engine/rfc822/rfc822-message.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 624 "../src/engine/rfc822/rfc822-message.vala"
			_g_error_free0 (e);
#line 624 "../src/engine/rfc822/rfc822-message.vala"
			_g_free0 (preview);
#line 624 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 624 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 624 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 4954 "rfc822-message.c"
		}
#line 621 "../src/engine/rfc822/rfc822-message.vala"
		_g_error_free0 (e);
#line 4958 "rfc822-message.c"
	}
	__finally0:
#line 621 "../src/engine/rfc822/rfc822-message.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 621 "../src/engine/rfc822/rfc822-message.vala"
		_g_free0 (preview);
#line 621 "../src/engine/rfc822/rfc822-message.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 621 "../src/engine/rfc822/rfc822-message.vala"
		g_clear_error (&_inner_error0_);
#line 621 "../src/engine/rfc822/rfc822-message.vala"
		return NULL;
#line 4971 "rfc822-message.c"
	}
#line 633 "../src/engine/rfc822/rfc822-message.vala"
	_tmp11_ = preview;
#line 633 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp11_ != NULL) {
#line 4977 "rfc822-message.c"
		const gchar* _tmp12_;
		gchar* _tmp13_;
#line 634 "../src/engine/rfc822/rfc822-message.vala"
		_tmp12_ = preview;
#line 634 "../src/engine/rfc822/rfc822-message.vala"
		_tmp13_ = geary_rf_c822_utils_to_preview_text (_tmp12_, format);
#line 634 "../src/engine/rfc822/rfc822-message.vala"
		_g_free0 (_tmp10_);
#line 634 "../src/engine/rfc822/rfc822-message.vala"
		_tmp10_ = _tmp13_;
#line 4988 "rfc822-message.c"
	} else {
		gchar* _tmp14_;
#line 635 "../src/engine/rfc822/rfc822-message.vala"
		_tmp14_ = g_strdup ("");
#line 635 "../src/engine/rfc822/rfc822-message.vala"
		_g_free0 (_tmp10_);
#line 635 "../src/engine/rfc822/rfc822-message.vala"
		_tmp10_ = _tmp14_;
#line 4997 "rfc822-message.c"
	}
#line 633 "../src/engine/rfc822/rfc822-message.vala"
	result = _tmp10_;
#line 633 "../src/engine/rfc822/rfc822-message.vala"
	_g_free0 (preview);
#line 633 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 5005 "rfc822-message.c"
}

GeeList*
geary_rf_c822_message_get_recipients (GearyRFC822Message* self)
{
	GeeList* addrs = NULL;
	GeeArrayList* _tmp0_;
	GearyRFC822MailboxAddresses* _tmp1_;
	GearyRFC822MailboxAddresses* _tmp2_;
	GearyRFC822MailboxAddresses* _tmp8_;
	GearyRFC822MailboxAddresses* _tmp9_;
	GearyRFC822MailboxAddresses* _tmp15_;
	GearyRFC822MailboxAddresses* _tmp16_;
	GeeList* _tmp22_ = NULL;
	GeeList* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	GeeList* _tmp27_;
	GeeList* result;
#line 638 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), NULL);
#line 639 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = gee_array_list_new (GEARY_RF_C822_TYPE_MAILBOX_ADDRESS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 639 "../src/engine/rfc822/rfc822-message.vala"
	addrs = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_LIST, GeeList);
#line 641 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = geary_email_header_set_get_to (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 641 "../src/engine/rfc822/rfc822-message.vala"
	_tmp2_ = _tmp1_;
#line 641 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp2_ != NULL) {
#line 5037 "rfc822-message.c"
		GeeList* _tmp3_;
		GearyRFC822MailboxAddresses* _tmp4_;
		GearyRFC822MailboxAddresses* _tmp5_;
		GeeList* _tmp6_;
		GeeList* _tmp7_;
#line 642 "../src/engine/rfc822/rfc822-message.vala"
		_tmp3_ = addrs;
#line 642 "../src/engine/rfc822/rfc822-message.vala"
		_tmp4_ = geary_email_header_set_get_to (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 642 "../src/engine/rfc822/rfc822-message.vala"
		_tmp5_ = _tmp4_;
#line 642 "../src/engine/rfc822/rfc822-message.vala"
		_tmp6_ = geary_rf_c822_mailbox_addresses_get_all (_tmp5_);
#line 642 "../src/engine/rfc822/rfc822-message.vala"
		_tmp7_ = _tmp6_;
#line 642 "../src/engine/rfc822/rfc822-message.vala"
		gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection));
#line 642 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_tmp7_);
#line 5057 "rfc822-message.c"
	}
#line 644 "../src/engine/rfc822/rfc822-message.vala"
	_tmp8_ = geary_email_header_set_get_cc (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 644 "../src/engine/rfc822/rfc822-message.vala"
	_tmp9_ = _tmp8_;
#line 644 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp9_ != NULL) {
#line 5065 "rfc822-message.c"
		GeeList* _tmp10_;
		GearyRFC822MailboxAddresses* _tmp11_;
		GearyRFC822MailboxAddresses* _tmp12_;
		GeeList* _tmp13_;
		GeeList* _tmp14_;
#line 645 "../src/engine/rfc822/rfc822-message.vala"
		_tmp10_ = addrs;
#line 645 "../src/engine/rfc822/rfc822-message.vala"
		_tmp11_ = geary_email_header_set_get_cc (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 645 "../src/engine/rfc822/rfc822-message.vala"
		_tmp12_ = _tmp11_;
#line 645 "../src/engine/rfc822/rfc822-message.vala"
		_tmp13_ = geary_rf_c822_mailbox_addresses_get_all (_tmp12_);
#line 645 "../src/engine/rfc822/rfc822-message.vala"
		_tmp14_ = _tmp13_;
#line 645 "../src/engine/rfc822/rfc822-message.vala"
		gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_COLLECTION, GeeCollection));
#line 645 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_tmp14_);
#line 5085 "rfc822-message.c"
	}
#line 647 "../src/engine/rfc822/rfc822-message.vala"
	_tmp15_ = geary_email_header_set_get_bcc (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 647 "../src/engine/rfc822/rfc822-message.vala"
	_tmp16_ = _tmp15_;
#line 647 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp16_ != NULL) {
#line 5093 "rfc822-message.c"
		GeeList* _tmp17_;
		GearyRFC822MailboxAddresses* _tmp18_;
		GearyRFC822MailboxAddresses* _tmp19_;
		GeeList* _tmp20_;
		GeeList* _tmp21_;
#line 648 "../src/engine/rfc822/rfc822-message.vala"
		_tmp17_ = addrs;
#line 648 "../src/engine/rfc822/rfc822-message.vala"
		_tmp18_ = geary_email_header_set_get_bcc (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 648 "../src/engine/rfc822/rfc822-message.vala"
		_tmp19_ = _tmp18_;
#line 648 "../src/engine/rfc822/rfc822-message.vala"
		_tmp20_ = geary_rf_c822_mailbox_addresses_get_all (_tmp19_);
#line 648 "../src/engine/rfc822/rfc822-message.vala"
		_tmp21_ = _tmp20_;
#line 648 "../src/engine/rfc822/rfc822-message.vala"
		gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_COLLECTION, GeeCollection));
#line 648 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_tmp21_);
#line 5113 "rfc822-message.c"
	}
#line 650 "../src/engine/rfc822/rfc822-message.vala"
	_tmp23_ = addrs;
#line 650 "../src/engine/rfc822/rfc822-message.vala"
	_tmp24_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_COLLECTION, GeeCollection));
#line 650 "../src/engine/rfc822/rfc822-message.vala"
	_tmp25_ = _tmp24_;
#line 650 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp25_ > 0) {
#line 5123 "rfc822-message.c"
		GeeList* _tmp26_;
#line 650 "../src/engine/rfc822/rfc822-message.vala"
		_tmp26_ = addrs;
#line 650 "../src/engine/rfc822/rfc822-message.vala"
		_tmp22_ = _tmp26_;
#line 5129 "rfc822-message.c"
	} else {
#line 650 "../src/engine/rfc822/rfc822-message.vala"
		_tmp22_ = NULL;
#line 5133 "rfc822-message.c"
	}
#line 650 "../src/engine/rfc822/rfc822-message.vala"
	_tmp27_ = _g_object_ref0 (_tmp22_);
#line 650 "../src/engine/rfc822/rfc822-message.vala"
	result = _tmp27_;
#line 650 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (addrs);
#line 650 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 5143 "rfc822-message.c"
}

/**
     * Returns the header of the message.
     */
GearyRFC822Header*
geary_rf_c822_message_get_header (GearyRFC822Message* self)
{
	GMimeMessage* _tmp0_;
	GearyRFC822Header* _tmp1_;
	GearyRFC822Header* result;
#line 656 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), NULL);
#line 657 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = self->priv->message;
#line 657 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = geary_rf_c822_header_new_from_gmime (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_mime_object_get_type (), GMimeObject));
#line 657 "../src/engine/rfc822/rfc822-message.vala"
	result = _tmp1_;
#line 657 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 5165 "rfc822-message.c"
}

/**
     * Returns the body of the message.
     */
static void
_vala_GMimeFormatOptions_free (GMimeFormatOptions* self)
{
#line 672 "../src/engine/rfc822/rfc822-message.vala"
	g_boxed_free (g_mime_format_options_get_type (), self);
#line 5176 "rfc822-message.c"
}

GearyRFC822Text*
geary_rf_c822_message_get_body (GearyRFC822Message* self)
{
	GearyRFC822Text* body = NULL;
	GMimeObject* gmime = NULL;
	GMimeMessage* _tmp0_;
	GMimeObject* _tmp1_;
	GMimeObject* _tmp2_;
	GMimeObject* _tmp3_;
	GearyRFC822Text* result;
#line 663 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), NULL);
#line 664 "../src/engine/rfc822/rfc822-message.vala"
	body = NULL;
#line 665 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = self->priv->message;
#line 665 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = g_mime_message_get_mime_part (_tmp0_);
#line 665 "../src/engine/rfc822/rfc822-message.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 665 "../src/engine/rfc822/rfc822-message.vala"
	gmime = _tmp2_;
#line 666 "../src/engine/rfc822/rfc822-message.vala"
	_tmp3_ = gmime;
#line 666 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp3_ != NULL) {
#line 5205 "rfc822-message.c"
		GMimeStreamMem* stream = NULL;
		GMimeStreamMem* _tmp4_;
		GMimeFormatOptions* options = NULL;
		GMimeFormatOptions* _tmp5_;
		GMimeFormatOptions* _tmp6_;
		GMimeFormatOptions* _tmp7_;
		GMimeFormatOptions* _tmp8_;
		GMimeHeaderList* headers = NULL;
		GMimeMessage* _tmp9_;
		GMimeHeaderList* _tmp10_;
		GMimeHeaderList* _tmp11_;
		gint count = 0;
		GMimeHeaderList* _tmp12_;
		GMimeObject* _tmp19_;
		GMimeFormatOptions* _tmp20_;
		GMimeStreamMem* _tmp21_;
		GMimeStreamMem* _tmp22_;
		GearyRFC822Text* _tmp23_;
#line 667 "../src/engine/rfc822/rfc822-message.vala"
		_tmp4_ = (GMimeStreamMem*) g_mime_stream_mem_new ();
#line 667 "../src/engine/rfc822/rfc822-message.vala"
		stream = _tmp4_;
#line 672 "../src/engine/rfc822/rfc822-message.vala"
		_tmp5_ = geary_rf_c822_get_format_options ();
#line 672 "../src/engine/rfc822/rfc822-message.vala"
		_tmp6_ = _tmp5_;
#line 672 "../src/engine/rfc822/rfc822-message.vala"
		_tmp7_ = g_mime_format_options_clone (_tmp6_);
#line 672 "../src/engine/rfc822/rfc822-message.vala"
		_tmp8_ = _tmp7_;
#line 672 "../src/engine/rfc822/rfc822-message.vala"
		__vala_GMimeFormatOptions_free0 (_tmp6_);
#line 672 "../src/engine/rfc822/rfc822-message.vala"
		options = _tmp8_;
#line 673 "../src/engine/rfc822/rfc822-message.vala"
		_tmp9_ = self->priv->message;
#line 673 "../src/engine/rfc822/rfc822-message.vala"
		_tmp10_ = g_mime_object_get_header_list (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, g_mime_object_get_type (), GMimeObject));
#line 673 "../src/engine/rfc822/rfc822-message.vala"
		_tmp11_ = _g_object_ref0 (_tmp10_);
#line 673 "../src/engine/rfc822/rfc822-message.vala"
		headers = _tmp11_;
#line 674 "../src/engine/rfc822/rfc822-message.vala"
		_tmp12_ = headers;
#line 674 "../src/engine/rfc822/rfc822-message.vala"
		count = g_mime_header_list_get_count (_tmp12_);
#line 5252 "rfc822-message.c"
		{
			gint i = 0;
#line 675 "../src/engine/rfc822/rfc822-message.vala"
			i = 0;
#line 5257 "rfc822-message.c"
			{
				gboolean _tmp13_ = FALSE;
#line 675 "../src/engine/rfc822/rfc822-message.vala"
				_tmp13_ = TRUE;
#line 675 "../src/engine/rfc822/rfc822-message.vala"
				while (TRUE) {
#line 5264 "rfc822-message.c"
					GMimeFormatOptions* _tmp15_;
					GMimeHeaderList* _tmp16_;
					GMimeHeader* _tmp17_;
					const gchar* _tmp18_;
#line 675 "../src/engine/rfc822/rfc822-message.vala"
					if (!_tmp13_) {
#line 5271 "rfc822-message.c"
						gint _tmp14_;
#line 675 "../src/engine/rfc822/rfc822-message.vala"
						_tmp14_ = i;
#line 675 "../src/engine/rfc822/rfc822-message.vala"
						i = _tmp14_ + 1;
#line 5277 "rfc822-message.c"
					}
#line 675 "../src/engine/rfc822/rfc822-message.vala"
					_tmp13_ = FALSE;
#line 675 "../src/engine/rfc822/rfc822-message.vala"
					if (!(i < count)) {
#line 675 "../src/engine/rfc822/rfc822-message.vala"
						break;
#line 5285 "rfc822-message.c"
					}
#line 676 "../src/engine/rfc822/rfc822-message.vala"
					_tmp15_ = options;
#line 676 "../src/engine/rfc822/rfc822-message.vala"
					_tmp16_ = headers;
#line 676 "../src/engine/rfc822/rfc822-message.vala"
					_tmp17_ = g_mime_header_list_get_header_at (_tmp16_, i);
#line 676 "../src/engine/rfc822/rfc822-message.vala"
					_tmp18_ = g_mime_header_get_name (_tmp17_);
#line 676 "../src/engine/rfc822/rfc822-message.vala"
					g_mime_format_options_add_hidden_header (_tmp15_, _tmp18_);
#line 5297 "rfc822-message.c"
				}
			}
		}
#line 678 "../src/engine/rfc822/rfc822-message.vala"
		_tmp19_ = gmime;
#line 678 "../src/engine/rfc822/rfc822-message.vala"
		_tmp20_ = options;
#line 678 "../src/engine/rfc822/rfc822-message.vala"
		_tmp21_ = stream;
#line 678 "../src/engine/rfc822/rfc822-message.vala"
		g_mime_object_write_to_stream (_tmp19_, _tmp20_, G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, g_mime_stream_get_type (), GMimeStream));
#line 679 "../src/engine/rfc822/rfc822-message.vala"
		_tmp22_ = stream;
#line 679 "../src/engine/rfc822/rfc822-message.vala"
		_tmp23_ = geary_rf_c822_text_new_from_gmime (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, g_mime_stream_get_type (), GMimeStream));
#line 679 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (body);
#line 679 "../src/engine/rfc822/rfc822-message.vala"
		body = _tmp23_;
#line 666 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (headers);
#line 666 "../src/engine/rfc822/rfc822-message.vala"
		__vala_GMimeFormatOptions_free0 (options);
#line 666 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (stream);
#line 5323 "rfc822-message.c"
	} else {
		GearyMemoryEmptyBuffer* _tmp24_;
		GearyMemoryEmptyBuffer* _tmp25_;
		GearyRFC822Text* _tmp26_;
#line 681 "../src/engine/rfc822/rfc822-message.vala"
		_tmp24_ = geary_memory_empty_buffer_get_instance ();
#line 681 "../src/engine/rfc822/rfc822-message.vala"
		_tmp25_ = _tmp24_;
#line 681 "../src/engine/rfc822/rfc822-message.vala"
		_tmp26_ = geary_rf_c822_text_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBuffer));
#line 681 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (body);
#line 681 "../src/engine/rfc822/rfc822-message.vala"
		body = _tmp26_;
#line 5338 "rfc822-message.c"
	}
#line 683 "../src/engine/rfc822/rfc822-message.vala"
	result = body;
#line 683 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (gmime);
#line 683 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 5346 "rfc822-message.c"
}

/**
     * Serialises the message using native (i.e. LF) line endings.
     */
GearyMemoryBuffer*
geary_rf_c822_message_get_native_buffer (GearyRFC822Message* self,
                                         GError** error)
{
	GearyMemoryBuffer* _tmp0_ = NULL;
	GearyMemoryBuffer* _tmp1_;
	GearyMemoryBuffer* _tmp2_;
	GError* _inner_error0_ = NULL;
	GearyMemoryBuffer* result;
#line 689 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), NULL);
#line 690 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = geary_rf_c822_message_message_to_memory_buffer (self, FALSE, GEARY_RF_C822_MESSAGE_RF_C822_FORMAT_OPTIONS_NONE, &_inner_error0_);
#line 690 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = _tmp1_;
#line 690 "../src/engine/rfc822/rfc822-message.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 690 "../src/engine/rfc822/rfc822-message.vala"
		if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 690 "../src/engine/rfc822/rfc822-message.vala"
			g_propagate_error (error, _inner_error0_);
#line 690 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 5375 "rfc822-message.c"
		} else {
#line 690 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 690 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 690 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 5383 "rfc822-message.c"
		}
	}
#line 690 "../src/engine/rfc822/rfc822-message.vala"
	_tmp2_ = _tmp0_;
#line 690 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = NULL;
#line 690 "../src/engine/rfc822/rfc822-message.vala"
	result = _tmp2_;
#line 690 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_tmp0_);
#line 690 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 5396 "rfc822-message.c"
}

/**
     * Serialises the message using RFC 822 (i.e. CRLF) line endings.
     *
     * Returns the message as a memory buffer suitable for network
     * transmission and interoperability with other RFC 822 consumers.
     */
GearyMemoryBuffer*
geary_rf_c822_message_get_rfc822_buffer (GearyRFC822Message* self,
                                         GearyRFC822MessageRFC822FormatOptions options,
                                         GError** error)
{
	GearyMemoryBuffer* _tmp0_ = NULL;
	GearyMemoryBuffer* _tmp1_;
	GearyMemoryBuffer* _tmp2_;
	GError* _inner_error0_ = NULL;
	GearyMemoryBuffer* result;
#line 699 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), NULL);
#line 701 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = geary_rf_c822_message_message_to_memory_buffer (self, TRUE, options, &_inner_error0_);
#line 701 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = _tmp1_;
#line 701 "../src/engine/rfc822/rfc822-message.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 701 "../src/engine/rfc822/rfc822-message.vala"
		if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 701 "../src/engine/rfc822/rfc822-message.vala"
			g_propagate_error (error, _inner_error0_);
#line 701 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 5429 "rfc822-message.c"
		} else {
#line 701 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 701 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 701 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 5437 "rfc822-message.c"
		}
	}
#line 701 "../src/engine/rfc822/rfc822-message.vala"
	_tmp2_ = _tmp0_;
#line 701 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = NULL;
#line 701 "../src/engine/rfc822/rfc822-message.vala"
	result = _tmp2_;
#line 701 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_tmp0_);
#line 701 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 5450 "rfc822-message.c"
}

/**
     * Determines if the message has one or display HTML parts.
     */
gboolean
geary_rf_c822_message_has_html_body (GearyRFC822Message* self)
{
	GMimeMessage* _tmp0_;
	GMimeObject* _tmp1_;
	gboolean result;
#line 707 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), FALSE);
#line 708 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = self->priv->message;
#line 708 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = g_mime_message_get_mime_part (_tmp0_);
#line 708 "../src/engine/rfc822/rfc822-message.vala"
	result = geary_rf_c822_message_has_body_parts (self, _tmp1_, "html");
#line 708 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 5472 "rfc822-message.c"
}

/**
     * Determines if the message has one or plain text display parts.
     */
gboolean
geary_rf_c822_message_has_plain_body (GearyRFC822Message* self)
{
	GMimeMessage* _tmp0_;
	GMimeObject* _tmp1_;
	gboolean result;
#line 714 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), FALSE);
#line 715 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = self->priv->message;
#line 715 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = g_mime_message_get_mime_part (_tmp0_);
#line 715 "../src/engine/rfc822/rfc822-message.vala"
	result = geary_rf_c822_message_has_body_parts (self, _tmp1_, "plain");
#line 715 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 5494 "rfc822-message.c"
}

/**
     * Determines if the message has any body text/subtype MIME parts.
     *
     * A body part is one that would be displayed to the user,
     * i.e. parts returned by {@link get_html_body} or {@link
     * get_plain_body}.
     *
     * The logic for selecting text nodes here must match that in
     * construct_body_from_mime_parts.
     */
static gboolean
geary_rf_c822_message_has_body_parts (GearyRFC822Message* self,
                                      GMimeObject* node,
                                      const gchar* text_subtype)
{
	GearyRFC822Part* part = NULL;
	GearyRFC822Part* _tmp0_;
	gboolean is_matching_part = FALSE;
	gboolean result;
#line 728 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), FALSE);
#line 728 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (node, g_mime_object_get_type ()), FALSE);
#line 728 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (text_subtype != NULL, FALSE);
#line 729 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = geary_rf_c822_part_new (node);
#line 729 "../src/engine/rfc822/rfc822-message.vala"
	part = _tmp0_;
#line 730 "../src/engine/rfc822/rfc822-message.vala"
	is_matching_part = FALSE;
#line 732 "../src/engine/rfc822/rfc822-message.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (node, g_mime_multipart_get_type ())) {
#line 5530 "rfc822-message.c"
		GMimeMultipart* multipart = NULL;
		GMimeMultipart* _tmp1_;
		gint count = 0;
		GMimeMultipart* _tmp2_;
#line 733 "../src/engine/rfc822/rfc822-message.vala"
		_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (node, g_mime_multipart_get_type (), GMimeMultipart));
#line 733 "../src/engine/rfc822/rfc822-message.vala"
		multipart = _tmp1_;
#line 734 "../src/engine/rfc822/rfc822-message.vala"
		_tmp2_ = multipart;
#line 734 "../src/engine/rfc822/rfc822-message.vala"
		count = g_mime_multipart_get_count (_tmp2_);
#line 5543 "rfc822-message.c"
		{
			gint i = 0;
#line 735 "../src/engine/rfc822/rfc822-message.vala"
			i = 0;
#line 5548 "rfc822-message.c"
			{
				gboolean _tmp3_ = FALSE;
#line 735 "../src/engine/rfc822/rfc822-message.vala"
				_tmp3_ = TRUE;
#line 735 "../src/engine/rfc822/rfc822-message.vala"
				while (TRUE) {
#line 5555 "rfc822-message.c"
					gboolean _tmp5_ = FALSE;
					GMimeMultipart* _tmp6_;
					GMimeObject* _tmp7_;
#line 735 "../src/engine/rfc822/rfc822-message.vala"
					if (!_tmp3_) {
#line 5561 "rfc822-message.c"
						gint _tmp4_;
#line 735 "../src/engine/rfc822/rfc822-message.vala"
						_tmp4_ = i;
#line 735 "../src/engine/rfc822/rfc822-message.vala"
						i = _tmp4_ + 1;
#line 5567 "rfc822-message.c"
					}
#line 735 "../src/engine/rfc822/rfc822-message.vala"
					_tmp3_ = FALSE;
#line 735 "../src/engine/rfc822/rfc822-message.vala"
					if (i < count) {
#line 735 "../src/engine/rfc822/rfc822-message.vala"
						_tmp5_ = !is_matching_part;
#line 5575 "rfc822-message.c"
					} else {
#line 735 "../src/engine/rfc822/rfc822-message.vala"
						_tmp5_ = FALSE;
#line 5579 "rfc822-message.c"
					}
#line 735 "../src/engine/rfc822/rfc822-message.vala"
					if (!_tmp5_) {
#line 735 "../src/engine/rfc822/rfc822-message.vala"
						break;
#line 5585 "rfc822-message.c"
					}
#line 736 "../src/engine/rfc822/rfc822-message.vala"
					_tmp6_ = multipart;
#line 736 "../src/engine/rfc822/rfc822-message.vala"
					_tmp7_ = g_mime_multipart_get_part (_tmp6_, i);
#line 736 "../src/engine/rfc822/rfc822-message.vala"
					is_matching_part = geary_rf_c822_message_has_body_parts (self, _tmp7_, text_subtype);
#line 5593 "rfc822-message.c"
				}
			}
		}
#line 732 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (multipart);
#line 5599 "rfc822-message.c"
	} else {
#line 740 "../src/engine/rfc822/rfc822-message.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (node, g_mime_part_get_type ())) {
#line 5603 "rfc822-message.c"
			GearyMimeDispositionType disposition = 0;
			GearyRFC822Part* _tmp8_;
			GearyMimeContentDisposition* _tmp9_;
			GearyMimeContentDisposition* _tmp10_;
			gboolean _tmp16_ = FALSE;
#line 741 "../src/engine/rfc822/rfc822-message.vala"
			disposition = GEARY_MIME_DISPOSITION_TYPE_UNSPECIFIED;
#line 742 "../src/engine/rfc822/rfc822-message.vala"
			_tmp8_ = part;
#line 742 "../src/engine/rfc822/rfc822-message.vala"
			_tmp9_ = geary_rf_c822_part_get_content_disposition (_tmp8_);
#line 742 "../src/engine/rfc822/rfc822-message.vala"
			_tmp10_ = _tmp9_;
#line 742 "../src/engine/rfc822/rfc822-message.vala"
			if (_tmp10_ != NULL) {
#line 5619 "rfc822-message.c"
				GearyRFC822Part* _tmp11_;
				GearyMimeContentDisposition* _tmp12_;
				GearyMimeContentDisposition* _tmp13_;
				GearyMimeDispositionType _tmp14_;
				GearyMimeDispositionType _tmp15_;
#line 743 "../src/engine/rfc822/rfc822-message.vala"
				_tmp11_ = part;
#line 743 "../src/engine/rfc822/rfc822-message.vala"
				_tmp12_ = geary_rf_c822_part_get_content_disposition (_tmp11_);
#line 743 "../src/engine/rfc822/rfc822-message.vala"
				_tmp13_ = _tmp12_;
#line 743 "../src/engine/rfc822/rfc822-message.vala"
				_tmp14_ = geary_mime_content_disposition_get_disposition_type (_tmp13_);
#line 743 "../src/engine/rfc822/rfc822-message.vala"
				_tmp15_ = _tmp14_;
#line 743 "../src/engine/rfc822/rfc822-message.vala"
				disposition = _tmp15_;
#line 5637 "rfc822-message.c"
			}
#line 746 "../src/engine/rfc822/rfc822-message.vala"
			if (disposition != GEARY_MIME_DISPOSITION_TYPE_ATTACHMENT) {
#line 5641 "rfc822-message.c"
				GearyRFC822Part* _tmp17_;
				GearyMimeContentType* _tmp18_;
				GearyMimeContentType* _tmp19_;
#line 748 "../src/engine/rfc822/rfc822-message.vala"
				_tmp17_ = part;
#line 748 "../src/engine/rfc822/rfc822-message.vala"
				_tmp18_ = geary_rf_c822_part_get_content_type (_tmp17_);
#line 748 "../src/engine/rfc822/rfc822-message.vala"
				_tmp19_ = _tmp18_;
#line 748 "../src/engine/rfc822/rfc822-message.vala"
				_tmp16_ = geary_mime_content_type_is_type (_tmp19_, "text", text_subtype);
#line 5653 "rfc822-message.c"
			} else {
#line 747 "../src/engine/rfc822/rfc822-message.vala"
				_tmp16_ = FALSE;
#line 5657 "rfc822-message.c"
			}
#line 746 "../src/engine/rfc822/rfc822-message.vala"
			is_matching_part = _tmp16_;
#line 5661 "rfc822-message.c"
		}
	}
#line 751 "../src/engine/rfc822/rfc822-message.vala"
	result = is_matching_part;
#line 751 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (part);
#line 751 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 5670 "rfc822-message.c"
}

/**
     * This method is the main utility method used by the other body-generating constructors.
     *
     * Only text/* MIME parts of the specified subtype are added to body.  If a non-text part is
     * within a multipart/mixed container, the {@link InlinePartReplacer} is invoked.
     *
     * If to_html is true, the text is run through a filter to HTML-ize it.  (Obviously, this
     * should be false if text/html is being searched for.).
     *
     * The final constructed body is stored in the body string.
     *
     * The initial call should pass the root of this message and UNSPECIFIED as its container
     * subtype.
     *
     * @return Whether a text part with the desired text_subtype was found
     */
static gboolean
geary_rf_c822_message_construct_body_from_mime_parts (GearyRFC822Message* self,
                                                      GMimeObject* node,
                                                      GearyMimeMultipartSubtype container_subtype,
                                                      const gchar* text_subtype,
                                                      gboolean to_html,
                                                      GearyRFC822MessageInlinePartReplacer replacer,
                                                      gpointer replacer_target,
                                                      gchar** body,
                                                      GError** error)
{
	GearyRFC822Part* part = NULL;
	GearyRFC822Part* _tmp0_;
	GearyMimeContentType* content_type = NULL;
	GearyRFC822Part* _tmp1_;
	GearyMimeContentType* _tmp2_;
	GearyMimeContentType* _tmp3_;
	GearyMimeContentType* _tmp4_;
	GMimeMultipart* multipart = NULL;
	GMimeMultipart* _tmp5_;
	GMimeMultipart* _tmp6_;
	GearyMimeDispositionType disposition = 0;
	GearyRFC822Part* _tmp28_;
	GearyMimeContentDisposition* _tmp29_;
	GearyMimeContentDisposition* _tmp30_;
	gboolean _tmp36_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 770 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), FALSE);
#line 770 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (node, g_mime_object_get_type ()), FALSE);
#line 770 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (text_subtype != NULL, FALSE);
#line 777 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = geary_rf_c822_part_new (node);
#line 777 "../src/engine/rfc822/rfc822-message.vala"
	part = _tmp0_;
#line 778 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = part;
#line 778 "../src/engine/rfc822/rfc822-message.vala"
	_tmp2_ = geary_rf_c822_part_get_content_type (_tmp1_);
#line 778 "../src/engine/rfc822/rfc822-message.vala"
	_tmp3_ = _tmp2_;
#line 778 "../src/engine/rfc822/rfc822-message.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 778 "../src/engine/rfc822/rfc822-message.vala"
	content_type = _tmp4_;
#line 781 "../src/engine/rfc822/rfc822-message.vala"
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (node, g_mime_multipart_get_type ()) ? ((GMimeMultipart*) node) : NULL);
#line 781 "../src/engine/rfc822/rfc822-message.vala"
	multipart = _tmp5_;
#line 782 "../src/engine/rfc822/rfc822-message.vala"
	_tmp6_ = multipart;
#line 782 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp6_ != NULL) {
#line 5745 "rfc822-message.c"
		GearyMimeMultipartSubtype this_subtype = 0;
		GearyMimeContentType* _tmp7_;
		gboolean found_text_subtype = FALSE;
		GString* builder = NULL;
		GString* _tmp8_;
		gint count = 0;
		GMimeMultipart* _tmp9_;
		GString* _tmp23_;
		const gchar* _tmp24_;
#line 783 "../src/engine/rfc822/rfc822-message.vala"
		_tmp7_ = content_type;
#line 783 "../src/engine/rfc822/rfc822-message.vala"
		this_subtype = geary_mime_multipart_subtype_from_content_type (_tmp7_, NULL);
#line 786 "../src/engine/rfc822/rfc822-message.vala"
		found_text_subtype = FALSE;
#line 788 "../src/engine/rfc822/rfc822-message.vala"
		_tmp8_ = g_string_new ("");
#line 788 "../src/engine/rfc822/rfc822-message.vala"
		builder = _tmp8_;
#line 789 "../src/engine/rfc822/rfc822-message.vala"
		_tmp9_ = multipart;
#line 789 "../src/engine/rfc822/rfc822-message.vala"
		count = g_mime_multipart_get_count (_tmp9_);
#line 5769 "rfc822-message.c"
		{
			gint i = 0;
#line 790 "../src/engine/rfc822/rfc822-message.vala"
			i = 0;
#line 5774 "rfc822-message.c"
			{
				gboolean _tmp10_ = FALSE;
#line 790 "../src/engine/rfc822/rfc822-message.vala"
				_tmp10_ = TRUE;
#line 790 "../src/engine/rfc822/rfc822-message.vala"
				while (TRUE) {
#line 5781 "rfc822-message.c"
					GMimeObject* child = NULL;
					GMimeMultipart* _tmp12_;
					GMimeObject* _tmp13_;
					GMimeObject* _tmp14_;
					gchar* child_body = NULL;
					gboolean _tmp15_ = FALSE;
					GMimeObject* _tmp16_;
					gboolean _tmp17_;
					const gchar* _tmp20_;
#line 790 "../src/engine/rfc822/rfc822-message.vala"
					if (!_tmp10_) {
#line 5793 "rfc822-message.c"
						gint _tmp11_;
#line 790 "../src/engine/rfc822/rfc822-message.vala"
						i = i + 1;
#line 790 "../src/engine/rfc822/rfc822-message.vala"
						_tmp11_ = i;
#line 5799 "rfc822-message.c"
					}
#line 790 "../src/engine/rfc822/rfc822-message.vala"
					_tmp10_ = FALSE;
#line 790 "../src/engine/rfc822/rfc822-message.vala"
					if (!(i < count)) {
#line 790 "../src/engine/rfc822/rfc822-message.vala"
						break;
#line 5807 "rfc822-message.c"
					}
#line 791 "../src/engine/rfc822/rfc822-message.vala"
					_tmp12_ = multipart;
#line 791 "../src/engine/rfc822/rfc822-message.vala"
					_tmp13_ = g_mime_multipart_get_part (_tmp12_, i);
#line 791 "../src/engine/rfc822/rfc822-message.vala"
					_tmp14_ = _g_object_ref0 (_tmp13_);
#line 791 "../src/engine/rfc822/rfc822-message.vala"
					child = _tmp14_;
#line 793 "../src/engine/rfc822/rfc822-message.vala"
					child_body = NULL;
#line 794 "../src/engine/rfc822/rfc822-message.vala"
					_tmp16_ = child;
#line 794 "../src/engine/rfc822/rfc822-message.vala"
					_tmp17_ = geary_rf_c822_message_construct_body_from_mime_parts (self, _tmp16_, this_subtype, text_subtype, to_html, replacer, replacer_target, &child_body, &_inner_error0_);
#line 794 "../src/engine/rfc822/rfc822-message.vala"
					_tmp15_ = _tmp17_;
#line 794 "../src/engine/rfc822/rfc822-message.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 794 "../src/engine/rfc822/rfc822-message.vala"
						if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 5829 "rfc822-message.c"
							gboolean _tmp18_ = FALSE;
#line 794 "../src/engine/rfc822/rfc822-message.vala"
							g_propagate_error (error, _inner_error0_);
#line 794 "../src/engine/rfc822/rfc822-message.vala"
							_g_free0 (child_body);
#line 794 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (child);
#line 794 "../src/engine/rfc822/rfc822-message.vala"
							_g_string_free0 (builder);
#line 794 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (multipart);
#line 794 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (content_type);
#line 794 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (part);
#line 794 "../src/engine/rfc822/rfc822-message.vala"
							return _tmp18_;
#line 5847 "rfc822-message.c"
						} else {
							gboolean _tmp19_ = FALSE;
#line 794 "../src/engine/rfc822/rfc822-message.vala"
							_g_free0 (child_body);
#line 794 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (child);
#line 794 "../src/engine/rfc822/rfc822-message.vala"
							_g_string_free0 (builder);
#line 794 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (multipart);
#line 794 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (content_type);
#line 794 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (part);
#line 794 "../src/engine/rfc822/rfc822-message.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 794 "../src/engine/rfc822/rfc822-message.vala"
							g_clear_error (&_inner_error0_);
#line 794 "../src/engine/rfc822/rfc822-message.vala"
							return _tmp19_;
#line 5868 "rfc822-message.c"
						}
					}
#line 794 "../src/engine/rfc822/rfc822-message.vala"
					found_text_subtype |= _tmp15_;
#line 796 "../src/engine/rfc822/rfc822-message.vala"
					_tmp20_ = child_body;
#line 796 "../src/engine/rfc822/rfc822-message.vala"
					if (_tmp20_ != NULL) {
#line 5877 "rfc822-message.c"
						GString* _tmp21_;
						const gchar* _tmp22_;
#line 797 "../src/engine/rfc822/rfc822-message.vala"
						_tmp21_ = builder;
#line 797 "../src/engine/rfc822/rfc822-message.vala"
						_tmp22_ = child_body;
#line 797 "../src/engine/rfc822/rfc822-message.vala"
						g_string_append (_tmp21_, _tmp22_);
#line 5886 "rfc822-message.c"
					}
#line 790 "../src/engine/rfc822/rfc822-message.vala"
					_g_free0 (child_body);
#line 790 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (child);
#line 5892 "rfc822-message.c"
				}
			}
		}
#line 800 "../src/engine/rfc822/rfc822-message.vala"
		_tmp23_ = builder;
#line 800 "../src/engine/rfc822/rfc822-message.vala"
		_tmp24_ = _tmp23_->str;
#line 800 "../src/engine/rfc822/rfc822-message.vala"
		if (!geary_string_is_empty (_tmp24_)) {
#line 5902 "rfc822-message.c"
			GString* _tmp25_;
			const gchar* _tmp26_;
			gchar* _tmp27_;
#line 801 "../src/engine/rfc822/rfc822-message.vala"
			_tmp25_ = builder;
#line 801 "../src/engine/rfc822/rfc822-message.vala"
			_tmp26_ = _tmp25_->str;
#line 801 "../src/engine/rfc822/rfc822-message.vala"
			_tmp27_ = g_strdup (_tmp26_);
#line 801 "../src/engine/rfc822/rfc822-message.vala"
			_g_free0 (*body);
#line 801 "../src/engine/rfc822/rfc822-message.vala"
			*body = _tmp27_;
#line 5916 "rfc822-message.c"
		}
#line 803 "../src/engine/rfc822/rfc822-message.vala"
		result = found_text_subtype;
#line 803 "../src/engine/rfc822/rfc822-message.vala"
		_g_string_free0 (builder);
#line 803 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (multipart);
#line 803 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (content_type);
#line 803 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (part);
#line 803 "../src/engine/rfc822/rfc822-message.vala"
		return result;
#line 5930 "rfc822-message.c"
	}
#line 806 "../src/engine/rfc822/rfc822-message.vala"
	disposition = GEARY_MIME_DISPOSITION_TYPE_UNSPECIFIED;
#line 807 "../src/engine/rfc822/rfc822-message.vala"
	_tmp28_ = part;
#line 807 "../src/engine/rfc822/rfc822-message.vala"
	_tmp29_ = geary_rf_c822_part_get_content_disposition (_tmp28_);
#line 807 "../src/engine/rfc822/rfc822-message.vala"
	_tmp30_ = _tmp29_;
#line 807 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp30_ != NULL) {
#line 5942 "rfc822-message.c"
		GearyRFC822Part* _tmp31_;
		GearyMimeContentDisposition* _tmp32_;
		GearyMimeContentDisposition* _tmp33_;
		GearyMimeDispositionType _tmp34_;
		GearyMimeDispositionType _tmp35_;
#line 808 "../src/engine/rfc822/rfc822-message.vala"
		_tmp31_ = part;
#line 808 "../src/engine/rfc822/rfc822-message.vala"
		_tmp32_ = geary_rf_c822_part_get_content_disposition (_tmp31_);
#line 808 "../src/engine/rfc822/rfc822-message.vala"
		_tmp33_ = _tmp32_;
#line 808 "../src/engine/rfc822/rfc822-message.vala"
		_tmp34_ = geary_mime_content_disposition_get_disposition_type (_tmp33_);
#line 808 "../src/engine/rfc822/rfc822-message.vala"
		_tmp35_ = _tmp34_;
#line 808 "../src/engine/rfc822/rfc822-message.vala"
		disposition = _tmp35_;
#line 5960 "rfc822-message.c"
	}
#line 812 "../src/engine/rfc822/rfc822-message.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (node, g_mime_part_get_type ())) {
#line 813 "../src/engine/rfc822/rfc822-message.vala"
		_tmp36_ = disposition != GEARY_MIME_DISPOSITION_TYPE_ATTACHMENT;
#line 5966 "rfc822-message.c"
	} else {
#line 812 "../src/engine/rfc822/rfc822-message.vala"
		_tmp36_ = FALSE;
#line 5970 "rfc822-message.c"
	}
#line 812 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp36_) {
#line 5974 "rfc822-message.c"
		GearyMimeContentType* _tmp37_;
#line 823 "../src/engine/rfc822/rfc822-message.vala"
		_tmp37_ = content_type;
#line 823 "../src/engine/rfc822/rfc822-message.vala"
		if (geary_mime_content_type_is_type (_tmp37_, "text", text_subtype)) {
#line 5980 "rfc822-message.c"
			GearyRFC822PartBodyFormatting _tmp38_ = 0;
			GearyMemoryBuffer* _tmp39_ = NULL;
			GearyRFC822Part* _tmp40_;
			GearyMemoryBuffer* _tmp41_;
			gchar* _tmp44_;
#line 826 "../src/engine/rfc822/rfc822-message.vala"
			if (to_html) {
#line 826 "../src/engine/rfc822/rfc822-message.vala"
				_tmp38_ = GEARY_RF_C822_PART_BODY_FORMATTING_HTML;
#line 5990 "rfc822-message.c"
			} else {
#line 826 "../src/engine/rfc822/rfc822-message.vala"
				_tmp38_ = GEARY_RF_C822_PART_BODY_FORMATTING_NONE;
#line 5994 "rfc822-message.c"
			}
#line 824 "../src/engine/rfc822/rfc822-message.vala"
			_tmp40_ = part;
#line 824 "../src/engine/rfc822/rfc822-message.vala"
			_tmp41_ = geary_rf_c822_part_write_to_buffer (_tmp40_, GEARY_RF_C822_PART_ENCODING_CONVERSION_UTF8, _tmp38_, &_inner_error0_);
#line 824 "../src/engine/rfc822/rfc822-message.vala"
			_tmp39_ = _tmp41_;
#line 824 "../src/engine/rfc822/rfc822-message.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 824 "../src/engine/rfc822/rfc822-message.vala"
				if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 6006 "rfc822-message.c"
					gboolean _tmp42_ = FALSE;
#line 824 "../src/engine/rfc822/rfc822-message.vala"
					g_propagate_error (error, _inner_error0_);
#line 824 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (multipart);
#line 824 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (content_type);
#line 824 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (part);
#line 824 "../src/engine/rfc822/rfc822-message.vala"
					return _tmp42_;
#line 6018 "rfc822-message.c"
				} else {
					gboolean _tmp43_ = FALSE;
#line 824 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (multipart);
#line 824 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (content_type);
#line 824 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (part);
#line 824 "../src/engine/rfc822/rfc822-message.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 824 "../src/engine/rfc822/rfc822-message.vala"
					g_clear_error (&_inner_error0_);
#line 824 "../src/engine/rfc822/rfc822-message.vala"
					return _tmp43_;
#line 6033 "rfc822-message.c"
				}
			}
#line 824 "../src/engine/rfc822/rfc822-message.vala"
			_tmp44_ = geary_memory_buffer_to_string (_tmp39_);
#line 824 "../src/engine/rfc822/rfc822-message.vala"
			_g_free0 (*body);
#line 824 "../src/engine/rfc822/rfc822-message.vala"
			*body = _tmp44_;
#line 823 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_tmp39_);
#line 6044 "rfc822-message.c"
		} else {
			gboolean _tmp45_ = FALSE;
			gboolean _tmp46_ = FALSE;
#line 828 "../src/engine/rfc822/rfc822-message.vala"
			if (replacer != NULL) {
#line 829 "../src/engine/rfc822/rfc822-message.vala"
				_tmp46_ = disposition == GEARY_MIME_DISPOSITION_TYPE_INLINE;
#line 6052 "rfc822-message.c"
			} else {
#line 828 "../src/engine/rfc822/rfc822-message.vala"
				_tmp46_ = FALSE;
#line 6056 "rfc822-message.c"
			}
#line 828 "../src/engine/rfc822/rfc822-message.vala"
			if (_tmp46_) {
#line 830 "../src/engine/rfc822/rfc822-message.vala"
				_tmp45_ = container_subtype == GEARY_MIME_MULTIPART_SUBTYPE_MIXED;
#line 6062 "rfc822-message.c"
			} else {
#line 828 "../src/engine/rfc822/rfc822-message.vala"
				_tmp45_ = FALSE;
#line 6066 "rfc822-message.c"
			}
#line 828 "../src/engine/rfc822/rfc822-message.vala"
			if (_tmp45_) {
#line 6070 "rfc822-message.c"
				GearyRFC822Part* _tmp47_;
				gchar* _tmp48_;
#line 831 "../src/engine/rfc822/rfc822-message.vala"
				_tmp47_ = part;
#line 831 "../src/engine/rfc822/rfc822-message.vala"
				_tmp48_ = replacer (_tmp47_, replacer_target);
#line 831 "../src/engine/rfc822/rfc822-message.vala"
				_g_free0 (*body);
#line 831 "../src/engine/rfc822/rfc822-message.vala"
				*body = _tmp48_;
#line 6081 "rfc822-message.c"
			}
		}
	}
#line 835 "../src/engine/rfc822/rfc822-message.vala"
	result = (*body) != NULL;
#line 835 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (multipart);
#line 835 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (content_type);
#line 835 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (part);
#line 835 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 6095 "rfc822-message.c"
}

/**
     * A front-end to construct_body_from_mime_parts() that converts its output parameters into
     * something that front-facing methods want to return.
     */
static gchar*
geary_rf_c822_message_internal_get_body (GearyRFC822Message* self,
                                         const gchar* text_subtype,
                                         gboolean to_html,
                                         GearyRFC822MessageInlinePartReplacer replacer,
                                         gpointer replacer_target,
                                         GError** error)
{
	gchar* body = NULL;
	gboolean _tmp0_ = FALSE;
	GMimeMessage* _tmp1_;
	GMimeObject* _tmp2_;
	gboolean _tmp3_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 842 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), NULL);
#line 842 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (text_subtype != NULL, NULL);
#line 844 "../src/engine/rfc822/rfc822-message.vala"
	body = NULL;
#line 845 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = self->priv->message;
#line 845 "../src/engine/rfc822/rfc822-message.vala"
	_tmp2_ = g_mime_message_get_mime_part (_tmp1_);
#line 845 "../src/engine/rfc822/rfc822-message.vala"
	_tmp3_ = geary_rf_c822_message_construct_body_from_mime_parts (self, _tmp2_, GEARY_MIME_MULTIPART_SUBTYPE_UNSPECIFIED, text_subtype, to_html, replacer, replacer_target, &body, &_inner_error0_);
#line 845 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = _tmp3_;
#line 845 "../src/engine/rfc822/rfc822-message.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 845 "../src/engine/rfc822/rfc822-message.vala"
		if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 845 "../src/engine/rfc822/rfc822-message.vala"
			g_propagate_error (error, _inner_error0_);
#line 845 "../src/engine/rfc822/rfc822-message.vala"
			_g_free0 (body);
#line 845 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 6141 "rfc822-message.c"
		} else {
#line 845 "../src/engine/rfc822/rfc822-message.vala"
			_g_free0 (body);
#line 845 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 845 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 845 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 6151 "rfc822-message.c"
		}
	}
#line 845 "../src/engine/rfc822/rfc822-message.vala"
	if (!_tmp0_) {
#line 6156 "rfc822-message.c"
		GError* _tmp4_;
#line 847 "../src/engine/rfc822/rfc822-message.vala"
		_tmp4_ = g_error_new (GEARY_RF_C822_ERROR, GEARY_RF_C822_ERROR_NOT_FOUND, "Could not find any \"text/%s\" parts", text_subtype);
#line 847 "../src/engine/rfc822/rfc822-message.vala"
		_inner_error0_ = _tmp4_;
#line 847 "../src/engine/rfc822/rfc822-message.vala"
		if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 847 "../src/engine/rfc822/rfc822-message.vala"
			g_propagate_error (error, _inner_error0_);
#line 847 "../src/engine/rfc822/rfc822-message.vala"
			_g_free0 (body);
#line 847 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 6170 "rfc822-message.c"
		} else {
#line 847 "../src/engine/rfc822/rfc822-message.vala"
			_g_free0 (body);
#line 847 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 847 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 847 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 6180 "rfc822-message.c"
		}
	}
#line 850 "../src/engine/rfc822/rfc822-message.vala"
	result = body;
#line 850 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 6187 "rfc822-message.c"
}

/**
     * Returns the HTML portion of the message body, if present.
     *
     * Recursively walks the MIME structure (depth-first) serializing
     * all text/html MIME parts of the specified type into a single
     * UTF-8 string.  Non-text MIME parts inside of multipart/mixed
     * containers are offered to the {@link InlinePartReplacer}, which
     * can either return null or return a string that is inserted in
     * lieu of the MIME part into the final document.  All other MIME
     * parts are ignored.
     *
     * @throws Error.NOT_FOUND if an HTML body is not present.
     */
gchar*
geary_rf_c822_message_get_html_body (GearyRFC822Message* self,
                                     GearyRFC822MessageInlinePartReplacer replacer,
                                     gpointer replacer_target,
                                     GError** error)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 866 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), NULL);
#line 867 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = geary_rf_c822_message_internal_get_body (self, "html", FALSE, replacer, replacer_target, &_inner_error0_);
#line 867 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = _tmp1_;
#line 867 "../src/engine/rfc822/rfc822-message.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 867 "../src/engine/rfc822/rfc822-message.vala"
		if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 867 "../src/engine/rfc822/rfc822-message.vala"
			g_propagate_error (error, _inner_error0_);
#line 867 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 6228 "rfc822-message.c"
		} else {
#line 867 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 867 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 867 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 6236 "rfc822-message.c"
		}
	}
#line 867 "../src/engine/rfc822/rfc822-message.vala"
	_tmp2_ = _tmp0_;
#line 867 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = NULL;
#line 867 "../src/engine/rfc822/rfc822-message.vala"
	result = _tmp2_;
#line 867 "../src/engine/rfc822/rfc822-message.vala"
	_g_free0 (_tmp0_);
#line 867 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 6249 "rfc822-message.c"
}

/**
     * Returns the plaintext portion of the message body, if present.
     *
     * Recursively walks the MIME structure (depth-first) serializing
     * all text/plain MIME parts of the specified type into a single
     * UTF-8 string.  Non-text MIME parts inside of multipart/mixed
     * containers are offered to the {@link InlinePartReplacer}, which
     * can either return null or return a string that is inserted in
     * lieu of the MIME part into the final document.  All other MIME
     * parts are ignored.
     *
     * The convert_to_html flag indicates if the plaintext body should
     * be converted into HTML.  Note that the InlinePartReplacer's
     * output is not converted; it's up to the caller to know what
     * format to return when invoked.
     *
     * @throws Error.NOT_FOUND if a plaintext body is not present.
     */
gchar*
geary_rf_c822_message_get_plain_body (GearyRFC822Message* self,
                                      gboolean convert_to_html,
                                      GearyRFC822MessageInlinePartReplacer replacer,
                                      gpointer replacer_target,
                                      GError** error)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 888 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), NULL);
#line 890 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = geary_rf_c822_message_internal_get_body (self, "plain", convert_to_html, replacer, replacer_target, &_inner_error0_);
#line 890 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = _tmp1_;
#line 890 "../src/engine/rfc822/rfc822-message.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 890 "../src/engine/rfc822/rfc822-message.vala"
		if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 890 "../src/engine/rfc822/rfc822-message.vala"
			g_propagate_error (error, _inner_error0_);
#line 890 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 6296 "rfc822-message.c"
		} else {
#line 890 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 890 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 890 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 6304 "rfc822-message.c"
		}
	}
#line 890 "../src/engine/rfc822/rfc822-message.vala"
	_tmp2_ = _tmp0_;
#line 890 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = NULL;
#line 890 "../src/engine/rfc822/rfc822-message.vala"
	result = _tmp2_;
#line 890 "../src/engine/rfc822/rfc822-message.vala"
	_g_free0 (_tmp0_);
#line 890 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 6317 "rfc822-message.c"
}

/**
     * Return the body as a searchable string.  The body in this case should
     * include everything visible in the message's body in the client, which
     * would be only one body part, plus any visible attachments (which can be
     * disabled by passing false in include_sub_messages).  Note that values
     * that come out of this function are persisted.
     */
gchar*
geary_rf_c822_message_get_searchable_body (GearyRFC822Message* self,
                                           gboolean include_sub_messages,
                                           GError** error)
{
	gchar* body = NULL;
	gboolean html = FALSE;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 900 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), NULL);
#line 902 "../src/engine/rfc822/rfc822-message.vala"
	body = NULL;
#line 903 "../src/engine/rfc822/rfc822-message.vala"
	html = FALSE;
#line 6344 "rfc822-message.c"
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 905 "../src/engine/rfc822/rfc822-message.vala"
		_tmp1_ = geary_rf_c822_message_get_html_body (self, NULL, NULL, &_inner_error0_);
#line 905 "../src/engine/rfc822/rfc822-message.vala"
		_tmp0_ = _tmp1_;
#line 905 "../src/engine/rfc822/rfc822-message.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 905 "../src/engine/rfc822/rfc822-message.vala"
			if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 6357 "rfc822-message.c"
				goto __catch0_geary_rf_c822_error;
			}
#line 905 "../src/engine/rfc822/rfc822-message.vala"
			_g_free0 (body);
#line 905 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 905 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 905 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 6368 "rfc822-message.c"
		}
#line 905 "../src/engine/rfc822/rfc822-message.vala"
		_tmp2_ = _tmp0_;
#line 905 "../src/engine/rfc822/rfc822-message.vala"
		_tmp0_ = NULL;
#line 905 "../src/engine/rfc822/rfc822-message.vala"
		_g_free0 (body);
#line 905 "../src/engine/rfc822/rfc822-message.vala"
		body = _tmp2_;
#line 906 "../src/engine/rfc822/rfc822-message.vala"
		html = TRUE;
#line 904 "../src/engine/rfc822/rfc822-message.vala"
		_g_free0 (_tmp0_);
#line 6382 "rfc822-message.c"
	}
	goto __finally0;
	__catch0_geary_rf_c822_error:
	{
#line 904 "../src/engine/rfc822/rfc822-message.vala"
		g_clear_error (&_inner_error0_);
#line 6389 "rfc822-message.c"
		{
			gchar* _tmp3_ = NULL;
			gchar* _tmp4_;
			gchar* _tmp5_;
#line 909 "../src/engine/rfc822/rfc822-message.vala"
			_tmp4_ = geary_rf_c822_message_get_plain_body (self, FALSE, NULL, NULL, &_inner_error0_);
#line 909 "../src/engine/rfc822/rfc822-message.vala"
			_tmp3_ = _tmp4_;
#line 909 "../src/engine/rfc822/rfc822-message.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 909 "../src/engine/rfc822/rfc822-message.vala"
				if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 6402 "rfc822-message.c"
					goto __catch1_geary_rf_c822_error;
				}
#line 909 "../src/engine/rfc822/rfc822-message.vala"
				_g_free0 (body);
#line 909 "../src/engine/rfc822/rfc822-message.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 909 "../src/engine/rfc822/rfc822-message.vala"
				g_clear_error (&_inner_error0_);
#line 909 "../src/engine/rfc822/rfc822-message.vala"
				return NULL;
#line 6413 "rfc822-message.c"
			}
#line 909 "../src/engine/rfc822/rfc822-message.vala"
			_tmp5_ = _tmp3_;
#line 909 "../src/engine/rfc822/rfc822-message.vala"
			_tmp3_ = NULL;
#line 909 "../src/engine/rfc822/rfc822-message.vala"
			_g_free0 (body);
#line 909 "../src/engine/rfc822/rfc822-message.vala"
			body = _tmp5_;
#line 908 "../src/engine/rfc822/rfc822-message.vala"
			_g_free0 (_tmp3_);
#line 6425 "rfc822-message.c"
		}
		goto __finally1;
		__catch1_geary_rf_c822_error:
		{
#line 908 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 6432 "rfc822-message.c"
		}
		__finally1:
#line 908 "../src/engine/rfc822/rfc822-message.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 908 "../src/engine/rfc822/rfc822-message.vala"
			_g_free0 (body);
#line 908 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 908 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 908 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 6445 "rfc822-message.c"
		}
	}
	__finally0:
#line 904 "../src/engine/rfc822/rfc822-message.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 904 "../src/engine/rfc822/rfc822-message.vala"
		if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 904 "../src/engine/rfc822/rfc822-message.vala"
			g_propagate_error (error, _inner_error0_);
#line 904 "../src/engine/rfc822/rfc822-message.vala"
			_g_free0 (body);
#line 904 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 6459 "rfc822-message.c"
		} else {
#line 904 "../src/engine/rfc822/rfc822-message.vala"
			_g_free0 (body);
#line 904 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 904 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 904 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 6469 "rfc822-message.c"
		}
	}
#line 915 "../src/engine/rfc822/rfc822-message.vala"
	_tmp7_ = body;
#line 915 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp7_ != NULL) {
#line 915 "../src/engine/rfc822/rfc822-message.vala"
		_tmp6_ = html;
#line 6478 "rfc822-message.c"
	} else {
#line 915 "../src/engine/rfc822/rfc822-message.vala"
		_tmp6_ = FALSE;
#line 6482 "rfc822-message.c"
	}
#line 915 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp6_) {
#line 6486 "rfc822-message.c"
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 916 "../src/engine/rfc822/rfc822-message.vala"
		_tmp8_ = body;
#line 916 "../src/engine/rfc822/rfc822-message.vala"
		_tmp9_ = geary_html_html_to_text (_tmp8_, TRUE, GEARY_RF_C822_UTF8_CHARSET);
#line 916 "../src/engine/rfc822/rfc822-message.vala"
		_g_free0 (body);
#line 916 "../src/engine/rfc822/rfc822-message.vala"
		body = _tmp9_;
#line 6497 "rfc822-message.c"
	}
#line 918 "../src/engine/rfc822/rfc822-message.vala"
	if (include_sub_messages) {
#line 6501 "rfc822-message.c"
		GeeList* _tmp10_ = NULL;
		GeeList* _tmp11_;
#line 919 "../src/engine/rfc822/rfc822-message.vala"
		_tmp11_ = geary_rf_c822_message_get_sub_messages (self, &_inner_error0_);
#line 919 "../src/engine/rfc822/rfc822-message.vala"
		_tmp10_ = _tmp11_;
#line 919 "../src/engine/rfc822/rfc822-message.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 919 "../src/engine/rfc822/rfc822-message.vala"
			if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 919 "../src/engine/rfc822/rfc822-message.vala"
				g_propagate_error (error, _inner_error0_);
#line 919 "../src/engine/rfc822/rfc822-message.vala"
				_g_free0 (body);
#line 919 "../src/engine/rfc822/rfc822-message.vala"
				return NULL;
#line 6518 "rfc822-message.c"
			} else {
#line 919 "../src/engine/rfc822/rfc822-message.vala"
				_g_free0 (body);
#line 919 "../src/engine/rfc822/rfc822-message.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 919 "../src/engine/rfc822/rfc822-message.vala"
				g_clear_error (&_inner_error0_);
#line 919 "../src/engine/rfc822/rfc822-message.vala"
				return NULL;
#line 6528 "rfc822-message.c"
			}
		}
		{
			GeeList* _sub_message_list = NULL;
			gint _sub_message_size = 0;
			GeeList* _tmp12_;
			gint _tmp13_;
			gint _tmp14_;
			gint _sub_message_index = 0;
#line 919 "../src/engine/rfc822/rfc822-message.vala"
			_sub_message_list = _tmp10_;
#line 919 "../src/engine/rfc822/rfc822-message.vala"
			_tmp12_ = _sub_message_list;
#line 919 "../src/engine/rfc822/rfc822-message.vala"
			_tmp13_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_COLLECTION, GeeCollection));
#line 919 "../src/engine/rfc822/rfc822-message.vala"
			_tmp14_ = _tmp13_;
#line 919 "../src/engine/rfc822/rfc822-message.vala"
			_sub_message_size = _tmp14_;
#line 919 "../src/engine/rfc822/rfc822-message.vala"
			_sub_message_index = -1;
#line 919 "../src/engine/rfc822/rfc822-message.vala"
			while (TRUE) {
#line 6552 "rfc822-message.c"
				gint _tmp15_;
				gint _tmp16_;
				GearyRFC822Message* sub_message = NULL;
				GeeList* _tmp17_;
				gpointer _tmp18_;
				GString* sub_full = NULL;
				GString* _tmp19_;
				GearyRFC822Message* _tmp20_;
				GearyRFC822Subject* _tmp21_;
				GearyRFC822Subject* _tmp22_;
				GearyRFC822Message* _tmp30_;
				GearyRFC822MailboxAddresses* _tmp31_;
				GearyRFC822MailboxAddresses* _tmp32_;
				gchar* recipients = NULL;
				GearyRFC822Message* _tmp40_;
				gchar* _tmp41_;
				const gchar* _tmp42_;
				gchar* sub_body = NULL;
				GearyRFC822Message* _tmp46_;
				gchar* _tmp47_;
				const gchar* _tmp48_;
				GString* _tmp51_;
#line 919 "../src/engine/rfc822/rfc822-message.vala"
				_sub_message_index = _sub_message_index + 1;
#line 919 "../src/engine/rfc822/rfc822-message.vala"
				_tmp15_ = _sub_message_index;
#line 919 "../src/engine/rfc822/rfc822-message.vala"
				_tmp16_ = _sub_message_size;
#line 919 "../src/engine/rfc822/rfc822-message.vala"
				if (!(_tmp15_ < _tmp16_)) {
#line 919 "../src/engine/rfc822/rfc822-message.vala"
					break;
#line 6585 "rfc822-message.c"
				}
#line 919 "../src/engine/rfc822/rfc822-message.vala"
				_tmp17_ = _sub_message_list;
#line 919 "../src/engine/rfc822/rfc822-message.vala"
				_tmp18_ = gee_list_get (_tmp17_, _sub_message_index);
#line 919 "../src/engine/rfc822/rfc822-message.vala"
				sub_message = (GearyRFC822Message*) _tmp18_;
#line 925 "../src/engine/rfc822/rfc822-message.vala"
				_tmp19_ = g_string_new ("");
#line 925 "../src/engine/rfc822/rfc822-message.vala"
				sub_full = _tmp19_;
#line 926 "../src/engine/rfc822/rfc822-message.vala"
				_tmp20_ = sub_message;
#line 926 "../src/engine/rfc822/rfc822-message.vala"
				_tmp21_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 926 "../src/engine/rfc822/rfc822-message.vala"
				_tmp22_ = _tmp21_;
#line 926 "../src/engine/rfc822/rfc822-message.vala"
				if (_tmp22_ != NULL) {
#line 6605 "rfc822-message.c"
					GString* _tmp23_;
					GearyRFC822Message* _tmp24_;
					GearyRFC822Subject* _tmp25_;
					GearyRFC822Subject* _tmp26_;
					gchar* _tmp27_;
					gchar* _tmp28_;
					GString* _tmp29_;
#line 927 "../src/engine/rfc822/rfc822-message.vala"
					_tmp23_ = sub_full;
#line 927 "../src/engine/rfc822/rfc822-message.vala"
					_tmp24_ = sub_message;
#line 927 "../src/engine/rfc822/rfc822-message.vala"
					_tmp25_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 927 "../src/engine/rfc822/rfc822-message.vala"
					_tmp26_ = _tmp25_;
#line 927 "../src/engine/rfc822/rfc822-message.vala"
					_tmp27_ = geary_message_data_searchable_message_data_to_searchable_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEARY_MESSAGE_DATA_TYPE_SEARCHABLE_MESSAGE_DATA, GearyMessageDataSearchableMessageData));
#line 927 "../src/engine/rfc822/rfc822-message.vala"
					_tmp28_ = _tmp27_;
#line 927 "../src/engine/rfc822/rfc822-message.vala"
					g_string_append (_tmp23_, _tmp28_);
#line 927 "../src/engine/rfc822/rfc822-message.vala"
					_g_free0 (_tmp28_);
#line 928 "../src/engine/rfc822/rfc822-message.vala"
					_tmp29_ = sub_full;
#line 928 "../src/engine/rfc822/rfc822-message.vala"
					g_string_append (_tmp29_, "\n");
#line 6633 "rfc822-message.c"
				}
#line 930 "../src/engine/rfc822/rfc822-message.vala"
				_tmp30_ = sub_message;
#line 930 "../src/engine/rfc822/rfc822-message.vala"
				_tmp31_ = geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 930 "../src/engine/rfc822/rfc822-message.vala"
				_tmp32_ = _tmp31_;
#line 930 "../src/engine/rfc822/rfc822-message.vala"
				if (_tmp32_ != NULL) {
#line 6643 "rfc822-message.c"
					GString* _tmp33_;
					GearyRFC822Message* _tmp34_;
					GearyRFC822MailboxAddresses* _tmp35_;
					GearyRFC822MailboxAddresses* _tmp36_;
					gchar* _tmp37_;
					gchar* _tmp38_;
					GString* _tmp39_;
#line 931 "../src/engine/rfc822/rfc822-message.vala"
					_tmp33_ = sub_full;
#line 931 "../src/engine/rfc822/rfc822-message.vala"
					_tmp34_ = sub_message;
#line 931 "../src/engine/rfc822/rfc822-message.vala"
					_tmp35_ = geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 931 "../src/engine/rfc822/rfc822-message.vala"
					_tmp36_ = _tmp35_;
#line 931 "../src/engine/rfc822/rfc822-message.vala"
					_tmp37_ = geary_message_data_searchable_message_data_to_searchable_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, GEARY_MESSAGE_DATA_TYPE_SEARCHABLE_MESSAGE_DATA, GearyMessageDataSearchableMessageData));
#line 931 "../src/engine/rfc822/rfc822-message.vala"
					_tmp38_ = _tmp37_;
#line 931 "../src/engine/rfc822/rfc822-message.vala"
					g_string_append (_tmp33_, _tmp38_);
#line 931 "../src/engine/rfc822/rfc822-message.vala"
					_g_free0 (_tmp38_);
#line 932 "../src/engine/rfc822/rfc822-message.vala"
					_tmp39_ = sub_full;
#line 932 "../src/engine/rfc822/rfc822-message.vala"
					g_string_append (_tmp39_, "\n");
#line 6671 "rfc822-message.c"
				}
#line 934 "../src/engine/rfc822/rfc822-message.vala"
				_tmp40_ = sub_message;
#line 934 "../src/engine/rfc822/rfc822-message.vala"
				_tmp41_ = geary_rf_c822_message_get_searchable_recipients (_tmp40_);
#line 934 "../src/engine/rfc822/rfc822-message.vala"
				recipients = _tmp41_;
#line 935 "../src/engine/rfc822/rfc822-message.vala"
				_tmp42_ = recipients;
#line 935 "../src/engine/rfc822/rfc822-message.vala"
				if (_tmp42_ != NULL) {
#line 6683 "rfc822-message.c"
					GString* _tmp43_;
					const gchar* _tmp44_;
					GString* _tmp45_;
#line 936 "../src/engine/rfc822/rfc822-message.vala"
					_tmp43_ = sub_full;
#line 936 "../src/engine/rfc822/rfc822-message.vala"
					_tmp44_ = recipients;
#line 936 "../src/engine/rfc822/rfc822-message.vala"
					g_string_append (_tmp43_, _tmp44_);
#line 937 "../src/engine/rfc822/rfc822-message.vala"
					_tmp45_ = sub_full;
#line 937 "../src/engine/rfc822/rfc822-message.vala"
					g_string_append (_tmp45_, "\n");
#line 6697 "rfc822-message.c"
				}
#line 942 "../src/engine/rfc822/rfc822-message.vala"
				_tmp46_ = sub_message;
#line 942 "../src/engine/rfc822/rfc822-message.vala"
				_tmp47_ = geary_rf_c822_message_get_searchable_body (_tmp46_, FALSE, &_inner_error0_);
#line 942 "../src/engine/rfc822/rfc822-message.vala"
				sub_body = _tmp47_;
#line 942 "../src/engine/rfc822/rfc822-message.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 942 "../src/engine/rfc822/rfc822-message.vala"
					if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 942 "../src/engine/rfc822/rfc822-message.vala"
						g_propagate_error (error, _inner_error0_);
#line 942 "../src/engine/rfc822/rfc822-message.vala"
						_g_free0 (recipients);
#line 942 "../src/engine/rfc822/rfc822-message.vala"
						_g_string_free0 (sub_full);
#line 942 "../src/engine/rfc822/rfc822-message.vala"
						_g_object_unref0 (sub_message);
#line 942 "../src/engine/rfc822/rfc822-message.vala"
						_g_object_unref0 (_tmp10_);
#line 942 "../src/engine/rfc822/rfc822-message.vala"
						_g_free0 (body);
#line 942 "../src/engine/rfc822/rfc822-message.vala"
						return NULL;
#line 6723 "rfc822-message.c"
					} else {
#line 942 "../src/engine/rfc822/rfc822-message.vala"
						_g_free0 (recipients);
#line 942 "../src/engine/rfc822/rfc822-message.vala"
						_g_string_free0 (sub_full);
#line 942 "../src/engine/rfc822/rfc822-message.vala"
						_g_object_unref0 (sub_message);
#line 942 "../src/engine/rfc822/rfc822-message.vala"
						_g_object_unref0 (_tmp10_);
#line 942 "../src/engine/rfc822/rfc822-message.vala"
						_g_free0 (body);
#line 942 "../src/engine/rfc822/rfc822-message.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 942 "../src/engine/rfc822/rfc822-message.vala"
						g_clear_error (&_inner_error0_);
#line 942 "../src/engine/rfc822/rfc822-message.vala"
						return NULL;
#line 6741 "rfc822-message.c"
					}
				}
#line 943 "../src/engine/rfc822/rfc822-message.vala"
				_tmp48_ = sub_body;
#line 943 "../src/engine/rfc822/rfc822-message.vala"
				if (_tmp48_ != NULL) {
#line 6748 "rfc822-message.c"
					GString* _tmp49_;
					const gchar* _tmp50_;
#line 944 "../src/engine/rfc822/rfc822-message.vala"
					_tmp49_ = sub_full;
#line 944 "../src/engine/rfc822/rfc822-message.vala"
					_tmp50_ = sub_body;
#line 944 "../src/engine/rfc822/rfc822-message.vala"
					g_string_append (_tmp49_, _tmp50_);
#line 6757 "rfc822-message.c"
				}
#line 946 "../src/engine/rfc822/rfc822-message.vala"
				_tmp51_ = sub_full;
#line 946 "../src/engine/rfc822/rfc822-message.vala"
				if (_tmp51_->len > ((gssize) 0)) {
#line 6763 "rfc822-message.c"
					const gchar* _tmp52_;
					const gchar* _tmp54_;
					GString* _tmp55_;
					const gchar* _tmp56_;
					gchar* _tmp57_;
					gchar* _tmp58_;
					gchar* _tmp59_;
#line 947 "../src/engine/rfc822/rfc822-message.vala"
					_tmp52_ = body;
#line 947 "../src/engine/rfc822/rfc822-message.vala"
					if (_tmp52_ == NULL) {
#line 6775 "rfc822-message.c"
						gchar* _tmp53_;
#line 948 "../src/engine/rfc822/rfc822-message.vala"
						_tmp53_ = g_strdup ("");
#line 948 "../src/engine/rfc822/rfc822-message.vala"
						_g_free0 (body);
#line 948 "../src/engine/rfc822/rfc822-message.vala"
						body = _tmp53_;
#line 6783 "rfc822-message.c"
					}
#line 949 "../src/engine/rfc822/rfc822-message.vala"
					_tmp54_ = body;
#line 949 "../src/engine/rfc822/rfc822-message.vala"
					_tmp55_ = sub_full;
#line 949 "../src/engine/rfc822/rfc822-message.vala"
					_tmp56_ = _tmp55_->str;
#line 949 "../src/engine/rfc822/rfc822-message.vala"
					_tmp57_ = g_strconcat ("\n", _tmp56_, NULL);
#line 949 "../src/engine/rfc822/rfc822-message.vala"
					_tmp58_ = _tmp57_;
#line 949 "../src/engine/rfc822/rfc822-message.vala"
					_tmp59_ = g_strconcat (_tmp54_, _tmp58_, NULL);
#line 949 "../src/engine/rfc822/rfc822-message.vala"
					_g_free0 (body);
#line 949 "../src/engine/rfc822/rfc822-message.vala"
					body = _tmp59_;
#line 949 "../src/engine/rfc822/rfc822-message.vala"
					_g_free0 (_tmp58_);
#line 6803 "rfc822-message.c"
				}
#line 919 "../src/engine/rfc822/rfc822-message.vala"
				_g_free0 (sub_body);
#line 919 "../src/engine/rfc822/rfc822-message.vala"
				_g_free0 (recipients);
#line 919 "../src/engine/rfc822/rfc822-message.vala"
				_g_string_free0 (sub_full);
#line 919 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (sub_message);
#line 6813 "rfc822-message.c"
			}
		}
#line 918 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_tmp10_);
#line 6818 "rfc822-message.c"
	}
#line 954 "../src/engine/rfc822/rfc822-message.vala"
	result = body;
#line 954 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 6824 "rfc822-message.c"
}

/**
     * Return the full list of recipients (to, cc, and bcc) as a searchable
     * string.  Note that values that come out of this function are persisted.
     */
gchar*
geary_rf_c822_message_get_searchable_recipients (GearyRFC822Message* self)
{
	gchar* searchable = NULL;
	GeeList* recipient_list = NULL;
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	gchar* result;
#line 961 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), NULL);
#line 962 "../src/engine/rfc822/rfc822-message.vala"
	searchable = NULL;
#line 963 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = geary_rf_c822_message_get_recipients (self);
#line 963 "../src/engine/rfc822/rfc822-message.vala"
	recipient_list = _tmp0_;
#line 964 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = recipient_list;
#line 964 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp1_ != NULL) {
#line 6851 "rfc822-message.c"
		GearyRFC822MailboxAddresses* recipients = NULL;
		GeeList* _tmp2_;
		GearyRFC822MailboxAddresses* _tmp3_;
		GearyRFC822MailboxAddresses* _tmp4_;
		gchar* _tmp5_;
#line 965 "../src/engine/rfc822/rfc822-message.vala"
		_tmp2_ = recipient_list;
#line 965 "../src/engine/rfc822/rfc822-message.vala"
		_tmp3_ = geary_rf_c822_mailbox_addresses_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection));
#line 965 "../src/engine/rfc822/rfc822-message.vala"
		recipients = _tmp3_;
#line 966 "../src/engine/rfc822/rfc822-message.vala"
		_tmp4_ = recipients;
#line 966 "../src/engine/rfc822/rfc822-message.vala"
		_tmp5_ = geary_message_data_searchable_message_data_to_searchable_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEARY_MESSAGE_DATA_TYPE_SEARCHABLE_MESSAGE_DATA, GearyMessageDataSearchableMessageData));
#line 966 "../src/engine/rfc822/rfc822-message.vala"
		_g_free0 (searchable);
#line 966 "../src/engine/rfc822/rfc822-message.vala"
		searchable = _tmp5_;
#line 964 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (recipients);
#line 6873 "rfc822-message.c"
	}
#line 968 "../src/engine/rfc822/rfc822-message.vala"
	result = searchable;
#line 968 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (recipient_list);
#line 968 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 6881 "rfc822-message.c"
}

GeeList*
geary_rf_c822_message_get_attachments (GearyRFC822Message* self,
                                       GearyMimeDispositionType disposition,
                                       GError** error)
{
	GeeList* attachments = NULL;
	GeeLinkedList* _tmp0_;
	GMimeMessage* _tmp1_;
	GMimeObject* _tmp2_;
	GError* _inner_error0_ = NULL;
	GeeList* result;
#line 972 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), NULL);
#line 975 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = gee_linked_list_new (GEARY_RF_C822_TYPE_PART, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 975 "../src/engine/rfc822/rfc822-message.vala"
	attachments = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_LIST, GeeList);
#line 976 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = self->priv->message;
#line 976 "../src/engine/rfc822/rfc822-message.vala"
	_tmp2_ = g_mime_message_get_mime_part (_tmp1_);
#line 976 "../src/engine/rfc822/rfc822-message.vala"
	geary_rf_c822_message_get_attachments_recursively (self, attachments, _tmp2_, disposition, &_inner_error0_);
#line 976 "../src/engine/rfc822/rfc822-message.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 976 "../src/engine/rfc822/rfc822-message.vala"
		if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 976 "../src/engine/rfc822/rfc822-message.vala"
			g_propagate_error (error, _inner_error0_);
#line 976 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (attachments);
#line 976 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 6917 "rfc822-message.c"
		} else {
#line 976 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (attachments);
#line 976 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 976 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 976 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 6927 "rfc822-message.c"
		}
	}
#line 977 "../src/engine/rfc822/rfc822-message.vala"
	result = attachments;
#line 977 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 6934 "rfc822-message.c"
}

static GearyRFC822MailboxAddresses*
geary_rf_c822_message_to_addresses (GearyRFC822Message* self,
                                    InternetAddressList* list,
                                    GError** error)
{
	GearyRFC822MailboxAddresses* addresses = NULL;
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
	GearyRFC822MailboxAddresses* result;
#line 980 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), NULL);
#line 980 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail ((list == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (list, internet_address_list_get_type ()), NULL);
#line 982 "../src/engine/rfc822/rfc822-message.vala"
	addresses = NULL;
#line 983 "../src/engine/rfc822/rfc822-message.vala"
	if (list != NULL) {
#line 983 "../src/engine/rfc822/rfc822-message.vala"
		_tmp0_ = internet_address_list_length (list) > 0;
#line 6956 "rfc822-message.c"
	} else {
#line 983 "../src/engine/rfc822/rfc822-message.vala"
		_tmp0_ = FALSE;
#line 6960 "rfc822-message.c"
	}
#line 983 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp0_) {
#line 6964 "rfc822-message.c"
		GearyRFC822MailboxAddresses* _tmp1_ = NULL;
		GearyRFC822MailboxAddresses* _tmp2_;
		GearyRFC822MailboxAddresses* _tmp3_;
#line 984 "../src/engine/rfc822/rfc822-message.vala"
		_tmp2_ = geary_rf_c822_mailbox_addresses_new_from_gmime (list, &_inner_error0_);
#line 984 "../src/engine/rfc822/rfc822-message.vala"
		_tmp1_ = _tmp2_;
#line 984 "../src/engine/rfc822/rfc822-message.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 984 "../src/engine/rfc822/rfc822-message.vala"
			if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 984 "../src/engine/rfc822/rfc822-message.vala"
				g_propagate_error (error, _inner_error0_);
#line 984 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (addresses);
#line 984 "../src/engine/rfc822/rfc822-message.vala"
				return NULL;
#line 6982 "rfc822-message.c"
			} else {
#line 984 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (addresses);
#line 984 "../src/engine/rfc822/rfc822-message.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 984 "../src/engine/rfc822/rfc822-message.vala"
				g_clear_error (&_inner_error0_);
#line 984 "../src/engine/rfc822/rfc822-message.vala"
				return NULL;
#line 6992 "rfc822-message.c"
			}
		}
#line 984 "../src/engine/rfc822/rfc822-message.vala"
		_tmp3_ = _tmp1_;
#line 984 "../src/engine/rfc822/rfc822-message.vala"
		_tmp1_ = NULL;
#line 984 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (addresses);
#line 984 "../src/engine/rfc822/rfc822-message.vala"
		addresses = _tmp3_;
#line 983 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_tmp1_);
#line 7005 "rfc822-message.c"
	}
#line 986 "../src/engine/rfc822/rfc822-message.vala"
	result = addresses;
#line 986 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 7011 "rfc822-message.c"
}

static GearyRFC822MessageIDList*
geary_rf_c822_message_append_message_id (GearyRFC822Message* self,
                                         GearyRFC822MessageIDList* existing,
                                         const gchar* header_value,
                                         GError** error)
{
	GearyRFC822MessageIDList* ids = NULL;
	GearyRFC822MessageIDList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GearyRFC822MessageIDList* result;
#line 989 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), NULL);
#line 989 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail ((existing == NULL) || GEARY_RF_C822_IS_MESSAGE_ID_LIST (existing), NULL);
#line 989 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (header_value != NULL, NULL);
#line 992 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = _g_object_ref0 (existing);
#line 992 "../src/engine/rfc822/rfc822-message.vala"
	ids = _tmp0_;
#line 993 "../src/engine/rfc822/rfc822-message.vala"
	if (!geary_string_is_empty_or_whitespace (header_value)) {
#line 7036 "rfc822-message.c"
		{
			GearyRFC822MessageIDList* _tmp1_ = NULL;
			GearyRFC822MessageIDList* _tmp2_;
			GearyRFC822MessageIDList* _tmp3_;
#line 995 "../src/engine/rfc822/rfc822-message.vala"
			_tmp2_ = geary_rf_c822_message_id_list_new_from_rfc822_string (header_value, &_inner_error0_);
#line 995 "../src/engine/rfc822/rfc822-message.vala"
			_tmp1_ = _tmp2_;
#line 995 "../src/engine/rfc822/rfc822-message.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 995 "../src/engine/rfc822/rfc822-message.vala"
				if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 7049 "rfc822-message.c"
					goto __catch0_geary_rf_c822_error;
				}
#line 995 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (ids);
#line 995 "../src/engine/rfc822/rfc822-message.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 995 "../src/engine/rfc822/rfc822-message.vala"
				g_clear_error (&_inner_error0_);
#line 995 "../src/engine/rfc822/rfc822-message.vala"
				return NULL;
#line 7060 "rfc822-message.c"
			}
#line 995 "../src/engine/rfc822/rfc822-message.vala"
			_tmp3_ = _tmp1_;
#line 995 "../src/engine/rfc822/rfc822-message.vala"
			_tmp1_ = NULL;
#line 995 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (ids);
#line 995 "../src/engine/rfc822/rfc822-message.vala"
			ids = _tmp3_;
#line 996 "../src/engine/rfc822/rfc822-message.vala"
			if (existing != NULL) {
#line 7072 "rfc822-message.c"
				GearyRFC822MessageIDList* _tmp4_;
				GearyRFC822MessageIDList* _tmp5_;
#line 997 "../src/engine/rfc822/rfc822-message.vala"
				_tmp4_ = ids;
#line 997 "../src/engine/rfc822/rfc822-message.vala"
				_tmp5_ = geary_rf_c822_message_id_list_concatenate_list (existing, _tmp4_);
#line 997 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (ids);
#line 997 "../src/engine/rfc822/rfc822-message.vala"
				ids = _tmp5_;
#line 7083 "rfc822-message.c"
			}
#line 994 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_tmp1_);
#line 7087 "rfc822-message.c"
		}
		goto __finally0;
		__catch0_geary_rf_c822_error:
		{
			GError* err = NULL;
			GError* _tmp6_;
			const gchar* _tmp7_;
#line 994 "../src/engine/rfc822/rfc822-message.vala"
			err = _inner_error0_;
#line 994 "../src/engine/rfc822/rfc822-message.vala"
			_inner_error0_ = NULL;
#line 1002 "../src/engine/rfc822/rfc822-message.vala"
			_tmp6_ = err;
#line 1002 "../src/engine/rfc822/rfc822-message.vala"
			_tmp7_ = _tmp6_->message;
#line 1002 "../src/engine/rfc822/rfc822-message.vala"
			g_debug ("rfc822-message.vala:1002: Error parsing message id list: %s", _tmp7_);
#line 994 "../src/engine/rfc822/rfc822-message.vala"
			_g_error_free0 (err);
#line 7107 "rfc822-message.c"
		}
		__finally0:
#line 994 "../src/engine/rfc822/rfc822-message.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 994 "../src/engine/rfc822/rfc822-message.vala"
			if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 994 "../src/engine/rfc822/rfc822-message.vala"
				g_propagate_error (error, _inner_error0_);
#line 994 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (ids);
#line 994 "../src/engine/rfc822/rfc822-message.vala"
				return NULL;
#line 7120 "rfc822-message.c"
			} else {
#line 994 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (ids);
#line 994 "../src/engine/rfc822/rfc822-message.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 994 "../src/engine/rfc822/rfc822-message.vala"
				g_clear_error (&_inner_error0_);
#line 994 "../src/engine/rfc822/rfc822-message.vala"
				return NULL;
#line 7130 "rfc822-message.c"
			}
		}
	}
#line 1005 "../src/engine/rfc822/rfc822-message.vala"
	result = ids;
#line 1005 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 7138 "rfc822-message.c"
}

static gpointer
_g_byte_array_ref0 (gpointer self)
{
#line 1059 "../src/engine/rfc822/rfc822-message.vala"
	return self ? g_byte_array_ref (self) : NULL;
#line 7146 "rfc822-message.c"
}

static void
geary_rf_c822_message_get_attachments_recursively (GearyRFC822Message* self,
                                                   GeeList* attachments,
                                                   GMimeObject* root,
                                                   GearyMimeDispositionType requested_disposition,
                                                   GError** error)
{
	GError* _inner_error0_ = NULL;
#line 1008 "../src/engine/rfc822/rfc822-message.vala"
	g_return_if_fail (GEARY_RF_C822_IS_MESSAGE (self));
#line 1008 "../src/engine/rfc822/rfc822-message.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (attachments, GEE_TYPE_LIST));
#line 1008 "../src/engine/rfc822/rfc822-message.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (root, g_mime_object_get_type ()));
#line 1012 "../src/engine/rfc822/rfc822-message.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (root, g_mime_multipart_get_type ())) {
#line 7165 "rfc822-message.c"
		GMimeMultipart* multipart = NULL;
		GMimeMultipart* _tmp0_;
		gint count = 0;
		GMimeMultipart* _tmp1_;
#line 1013 "../src/engine/rfc822/rfc822-message.vala"
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (root, g_mime_multipart_get_type (), GMimeMultipart));
#line 1013 "../src/engine/rfc822/rfc822-message.vala"
		multipart = _tmp0_;
#line 1014 "../src/engine/rfc822/rfc822-message.vala"
		_tmp1_ = multipart;
#line 1014 "../src/engine/rfc822/rfc822-message.vala"
		count = g_mime_multipart_get_count (_tmp1_);
#line 7178 "rfc822-message.c"
		{
			gint i = 0;
#line 1015 "../src/engine/rfc822/rfc822-message.vala"
			i = 0;
#line 7183 "rfc822-message.c"
			{
				gboolean _tmp2_ = FALSE;
#line 1015 "../src/engine/rfc822/rfc822-message.vala"
				_tmp2_ = TRUE;
#line 1015 "../src/engine/rfc822/rfc822-message.vala"
				while (TRUE) {
#line 7190 "rfc822-message.c"
					GMimeMultipart* _tmp4_;
					GMimeObject* _tmp5_;
#line 1015 "../src/engine/rfc822/rfc822-message.vala"
					if (!_tmp2_) {
#line 7195 "rfc822-message.c"
						gint _tmp3_;
#line 1015 "../src/engine/rfc822/rfc822-message.vala"
						i = i + 1;
#line 1015 "../src/engine/rfc822/rfc822-message.vala"
						_tmp3_ = i;
#line 7201 "rfc822-message.c"
					}
#line 1015 "../src/engine/rfc822/rfc822-message.vala"
					_tmp2_ = FALSE;
#line 1015 "../src/engine/rfc822/rfc822-message.vala"
					if (!(i < count)) {
#line 1015 "../src/engine/rfc822/rfc822-message.vala"
						break;
#line 7209 "rfc822-message.c"
					}
#line 1016 "../src/engine/rfc822/rfc822-message.vala"
					_tmp4_ = multipart;
#line 1016 "../src/engine/rfc822/rfc822-message.vala"
					_tmp5_ = g_mime_multipart_get_part (_tmp4_, i);
#line 1016 "../src/engine/rfc822/rfc822-message.vala"
					geary_rf_c822_message_get_attachments_recursively (self, attachments, _tmp5_, requested_disposition, &_inner_error0_);
#line 1016 "../src/engine/rfc822/rfc822-message.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1016 "../src/engine/rfc822/rfc822-message.vala"
						if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 1016 "../src/engine/rfc822/rfc822-message.vala"
							g_propagate_error (error, _inner_error0_);
#line 1016 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (multipart);
#line 1016 "../src/engine/rfc822/rfc822-message.vala"
							return;
#line 7227 "rfc822-message.c"
						} else {
#line 1016 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (multipart);
#line 1016 "../src/engine/rfc822/rfc822-message.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1016 "../src/engine/rfc822/rfc822-message.vala"
							g_clear_error (&_inner_error0_);
#line 1016 "../src/engine/rfc822/rfc822-message.vala"
							return;
#line 7237 "rfc822-message.c"
						}
					}
				}
			}
		}
#line 1012 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (multipart);
#line 7245 "rfc822-message.c"
	} else {
#line 1018 "../src/engine/rfc822/rfc822-message.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (root, g_mime_message_part_get_type ())) {
#line 7249 "rfc822-message.c"
			GMimeMessagePart* messagepart = NULL;
			GMimeMessagePart* _tmp6_;
			GMimeMessage* message = NULL;
			GMimeMessagePart* _tmp7_;
			GMimeMessage* _tmp8_;
			GMimeMessage* _tmp9_;
			gboolean is_unknown = FALSE;
			GearyMimeDispositionType disposition = 0;
			const gchar* _tmp10_;
			gboolean _tmp11_ = FALSE;
			GearyMimeDispositionType _tmp12_;
			gboolean _tmp13_ = FALSE;
			gboolean _tmp14_ = FALSE;
			GMimeMessage* _tmp34_;
			GMimeObject* _tmp35_;
#line 1019 "../src/engine/rfc822/rfc822-message.vala"
			_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (root, g_mime_message_part_get_type (), GMimeMessagePart));
#line 1019 "../src/engine/rfc822/rfc822-message.vala"
			messagepart = _tmp6_;
#line 1020 "../src/engine/rfc822/rfc822-message.vala"
			_tmp7_ = messagepart;
#line 1020 "../src/engine/rfc822/rfc822-message.vala"
			_tmp8_ = g_mime_message_part_get_message (_tmp7_);
#line 1020 "../src/engine/rfc822/rfc822-message.vala"
			_tmp9_ = _g_object_ref0 (_tmp8_);
#line 1020 "../src/engine/rfc822/rfc822-message.vala"
			message = _tmp9_;
#line 1022 "../src/engine/rfc822/rfc822-message.vala"
			_tmp10_ = g_mime_object_get_disposition (root);
#line 1022 "../src/engine/rfc822/rfc822-message.vala"
			_tmp12_ = geary_mime_disposition_type_deserialize (_tmp10_, &_tmp11_);
#line 1022 "../src/engine/rfc822/rfc822-message.vala"
			is_unknown = _tmp11_;
#line 1022 "../src/engine/rfc822/rfc822-message.vala"
			disposition = _tmp12_;
#line 1024 "../src/engine/rfc822/rfc822-message.vala"
			if (disposition == GEARY_MIME_DISPOSITION_TYPE_UNSPECIFIED) {
#line 1024 "../src/engine/rfc822/rfc822-message.vala"
				_tmp13_ = TRUE;
#line 7289 "rfc822-message.c"
			} else {
#line 1024 "../src/engine/rfc822/rfc822-message.vala"
				_tmp13_ = is_unknown;
#line 7293 "rfc822-message.c"
			}
#line 1024 "../src/engine/rfc822/rfc822-message.vala"
			if (_tmp13_) {
#line 1026 "../src/engine/rfc822/rfc822-message.vala"
				disposition = GEARY_MIME_DISPOSITION_TYPE_ATTACHMENT;
#line 7299 "rfc822-message.c"
			}
#line 1029 "../src/engine/rfc822/rfc822-message.vala"
			if (requested_disposition == GEARY_MIME_DISPOSITION_TYPE_UNSPECIFIED) {
#line 1029 "../src/engine/rfc822/rfc822-message.vala"
				_tmp14_ = TRUE;
#line 7305 "rfc822-message.c"
			} else {
#line 1029 "../src/engine/rfc822/rfc822-message.vala"
				_tmp14_ = disposition == requested_disposition;
#line 7309 "rfc822-message.c"
			}
#line 1029 "../src/engine/rfc822/rfc822-message.vala"
			if (_tmp14_) {
#line 7313 "rfc822-message.c"
				GMimeStream* stream = NULL;
				GMimeStreamMem* _tmp15_;
				GMimeMessage* _tmp16_;
				GMimeFormatOptions* _tmp17_;
				GMimeFormatOptions* _tmp18_;
				GMimeStream* _tmp19_;
				GMimeDataWrapper* data = NULL;
				GMimeStream* _tmp20_;
				GMimeDataWrapper* _tmp21_;
				GMimePart* part = NULL;
				GMimePart* _tmp22_;
				GMimePart* _tmp23_;
				GMimeDataWrapper* _tmp24_;
				const gchar* _tmp25_ = NULL;
				GMimeMessage* _tmp26_;
				const gchar* _tmp27_;
				GMimePart* _tmp28_;
				gchar* _tmp29_;
				gchar* _tmp30_;
				GMimePart* _tmp31_;
				GearyRFC822Part* _tmp32_;
				GearyRFC822Part* _tmp33_;
#line 1030 "../src/engine/rfc822/rfc822-message.vala"
				_tmp15_ = (GMimeStreamMem*) g_mime_stream_mem_new ();
#line 1030 "../src/engine/rfc822/rfc822-message.vala"
				stream = G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, g_mime_stream_get_type (), GMimeStream);
#line 1031 "../src/engine/rfc822/rfc822-message.vala"
				_tmp16_ = message;
#line 1031 "../src/engine/rfc822/rfc822-message.vala"
				_tmp17_ = geary_rf_c822_get_format_options ();
#line 1031 "../src/engine/rfc822/rfc822-message.vala"
				_tmp18_ = _tmp17_;
#line 1031 "../src/engine/rfc822/rfc822-message.vala"
				_tmp19_ = stream;
#line 1031 "../src/engine/rfc822/rfc822-message.vala"
				g_mime_object_write_to_stream (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, g_mime_object_get_type (), GMimeObject), _tmp18_, _tmp19_);
#line 1031 "../src/engine/rfc822/rfc822-message.vala"
				__vala_GMimeFormatOptions_free0 (_tmp18_);
#line 1032 "../src/engine/rfc822/rfc822-message.vala"
				_tmp20_ = stream;
#line 1032 "../src/engine/rfc822/rfc822-message.vala"
				_tmp21_ = g_mime_data_wrapper_new_with_stream (_tmp20_, GMIME_CONTENT_ENCODING_BINARY);
#line 1032 "../src/engine/rfc822/rfc822-message.vala"
				data = _tmp21_;
#line 1034 "../src/engine/rfc822/rfc822-message.vala"
				_tmp22_ = g_mime_part_new_with_type ("message", "rfc822");
#line 1034 "../src/engine/rfc822/rfc822-message.vala"
				part = _tmp22_;
#line 1035 "../src/engine/rfc822/rfc822-message.vala"
				_tmp23_ = part;
#line 1035 "../src/engine/rfc822/rfc822-message.vala"
				_tmp24_ = data;
#line 1035 "../src/engine/rfc822/rfc822-message.vala"
				g_mime_part_set_content (_tmp23_, _tmp24_);
#line 1036 "../src/engine/rfc822/rfc822-message.vala"
				_tmp26_ = message;
#line 1036 "../src/engine/rfc822/rfc822-message.vala"
				_tmp27_ = g_mime_message_get_subject (_tmp26_);
#line 1036 "../src/engine/rfc822/rfc822-message.vala"
				_tmp25_ = _tmp27_;
#line 1036 "../src/engine/rfc822/rfc822-message.vala"
				if (_tmp25_ == NULL) {
#line 1036 "../src/engine/rfc822/rfc822-message.vala"
					_tmp25_ = _ ("(no subject)");
#line 7378 "rfc822-message.c"
				}
#line 1036 "../src/engine/rfc822/rfc822-message.vala"
				_tmp28_ = part;
#line 1036 "../src/engine/rfc822/rfc822-message.vala"
				_tmp29_ = g_strconcat (_tmp25_, ".eml", NULL);
#line 1036 "../src/engine/rfc822/rfc822-message.vala"
				_tmp30_ = _tmp29_;
#line 1036 "../src/engine/rfc822/rfc822-message.vala"
				g_mime_part_set_filename (_tmp28_, _tmp30_);
#line 1036 "../src/engine/rfc822/rfc822-message.vala"
				_g_free0 (_tmp30_);
#line 1037 "../src/engine/rfc822/rfc822-message.vala"
				_tmp31_ = part;
#line 1037 "../src/engine/rfc822/rfc822-message.vala"
				_tmp32_ = geary_rf_c822_part_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, g_mime_object_get_type (), GMimeObject));
#line 1037 "../src/engine/rfc822/rfc822-message.vala"
				_tmp33_ = _tmp32_;
#line 1037 "../src/engine/rfc822/rfc822-message.vala"
				gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (attachments, GEE_TYPE_COLLECTION, GeeCollection), _tmp33_);
#line 1037 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (_tmp33_);
#line 1029 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (part);
#line 1029 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (data);
#line 1029 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (stream);
#line 7406 "rfc822-message.c"
			}
#line 1040 "../src/engine/rfc822/rfc822-message.vala"
			_tmp34_ = message;
#line 1040 "../src/engine/rfc822/rfc822-message.vala"
			_tmp35_ = g_mime_message_get_mime_part (_tmp34_);
#line 1040 "../src/engine/rfc822/rfc822-message.vala"
			geary_rf_c822_message_get_attachments_recursively (self, attachments, _tmp35_, requested_disposition, &_inner_error0_);
#line 1040 "../src/engine/rfc822/rfc822-message.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1040 "../src/engine/rfc822/rfc822-message.vala"
				if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 1040 "../src/engine/rfc822/rfc822-message.vala"
					g_propagate_error (error, _inner_error0_);
#line 1040 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (message);
#line 1040 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (messagepart);
#line 1040 "../src/engine/rfc822/rfc822-message.vala"
					return;
#line 7426 "rfc822-message.c"
				} else {
#line 1040 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (message);
#line 1040 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (messagepart);
#line 1040 "../src/engine/rfc822/rfc822-message.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1040 "../src/engine/rfc822/rfc822-message.vala"
					g_clear_error (&_inner_error0_);
#line 1040 "../src/engine/rfc822/rfc822-message.vala"
					return;
#line 7438 "rfc822-message.c"
				}
			}
#line 1018 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (message);
#line 1018 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (messagepart);
#line 7445 "rfc822-message.c"
		} else {
#line 1042 "../src/engine/rfc822/rfc822-message.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (root, g_mime_part_get_type ())) {
#line 7449 "rfc822-message.c"
				GearyRFC822Part* part = NULL;
				GearyRFC822Part* _tmp36_;
				GearyMimeDispositionType actual_disposition = 0;
				GearyRFC822Part* _tmp37_;
				GearyMimeContentDisposition* _tmp38_;
				GearyMimeContentDisposition* _tmp39_;
				gboolean _tmp45_ = FALSE;
#line 1043 "../src/engine/rfc822/rfc822-message.vala"
				_tmp36_ = geary_rf_c822_part_new (root);
#line 1043 "../src/engine/rfc822/rfc822-message.vala"
				part = _tmp36_;
#line 1045 "../src/engine/rfc822/rfc822-message.vala"
				actual_disposition = GEARY_MIME_DISPOSITION_TYPE_UNSPECIFIED;
#line 1047 "../src/engine/rfc822/rfc822-message.vala"
				_tmp37_ = part;
#line 1047 "../src/engine/rfc822/rfc822-message.vala"
				_tmp38_ = geary_rf_c822_part_get_content_disposition (_tmp37_);
#line 1047 "../src/engine/rfc822/rfc822-message.vala"
				_tmp39_ = _tmp38_;
#line 1047 "../src/engine/rfc822/rfc822-message.vala"
				if (_tmp39_ != NULL) {
#line 7471 "rfc822-message.c"
					GearyRFC822Part* _tmp40_;
					GearyMimeContentDisposition* _tmp41_;
					GearyMimeContentDisposition* _tmp42_;
					GearyMimeDispositionType _tmp43_;
					GearyMimeDispositionType _tmp44_;
#line 1048 "../src/engine/rfc822/rfc822-message.vala"
					_tmp40_ = part;
#line 1048 "../src/engine/rfc822/rfc822-message.vala"
					_tmp41_ = geary_rf_c822_part_get_content_disposition (_tmp40_);
#line 1048 "../src/engine/rfc822/rfc822-message.vala"
					_tmp42_ = _tmp41_;
#line 1048 "../src/engine/rfc822/rfc822-message.vala"
					_tmp43_ = geary_mime_content_disposition_get_disposition_type (_tmp42_);
#line 1048 "../src/engine/rfc822/rfc822-message.vala"
					_tmp44_ = _tmp43_;
#line 1048 "../src/engine/rfc822/rfc822-message.vala"
					actual_disposition = _tmp44_;
#line 7489 "rfc822-message.c"
				}
#line 1051 "../src/engine/rfc822/rfc822-message.vala"
				if (requested_disposition == GEARY_MIME_DISPOSITION_TYPE_UNSPECIFIED) {
#line 1051 "../src/engine/rfc822/rfc822-message.vala"
					_tmp45_ = TRUE;
#line 7495 "rfc822-message.c"
				} else {
#line 1052 "../src/engine/rfc822/rfc822-message.vala"
					_tmp45_ = actual_disposition == requested_disposition;
#line 7499 "rfc822-message.c"
				}
#line 1051 "../src/engine/rfc822/rfc822-message.vala"
				if (_tmp45_) {
#line 7503 "rfc822-message.c"
					GearyMimeContentType* content_type = NULL;
					GearyRFC822Part* _tmp46_;
					GearyMimeContentType* _tmp47_;
					GearyMimeContentType* _tmp48_;
					GearyMimeContentType* _tmp49_;
					GearyMimeContentType* _tmp50_;
#line 1053 "../src/engine/rfc822/rfc822-message.vala"
					_tmp46_ = part;
#line 1053 "../src/engine/rfc822/rfc822-message.vala"
					_tmp47_ = geary_rf_c822_part_get_content_type (_tmp46_);
#line 1053 "../src/engine/rfc822/rfc822-message.vala"
					_tmp48_ = _tmp47_;
#line 1053 "../src/engine/rfc822/rfc822-message.vala"
					_tmp49_ = _g_object_ref0 (_tmp48_);
#line 1053 "../src/engine/rfc822/rfc822-message.vala"
					content_type = _tmp49_;
#line 1056 "../src/engine/rfc822/rfc822-message.vala"
					_tmp50_ = content_type;
#line 1056 "../src/engine/rfc822/rfc822-message.vala"
					if (geary_mime_content_type_is_type (_tmp50_, "application", "vnd.ms-tnef")) {
#line 7524 "rfc822-message.c"
						GMimeStreamMem* stream = NULL;
						GMimeStreamMem* _tmp51_;
						GMimeDataWrapper* _tmp52_;
						GMimeStreamMem* _tmp53_;
						GByteArray* tnef_data = NULL;
						GMimeStreamMem* _tmp54_;
						GByteArray* _tmp55_;
						GByteArray* _tmp56_;
						TNEFStruct tn = {0};
						GByteArray* _tmp57_;
						guint8* _tmp58_;
						gint _tmp58__length1;
						gint _tmp59_;
#line 1057 "../src/engine/rfc822/rfc822-message.vala"
						_tmp51_ = (GMimeStreamMem*) g_mime_stream_mem_new ();
#line 1057 "../src/engine/rfc822/rfc822-message.vala"
						stream = _tmp51_;
#line 1058 "../src/engine/rfc822/rfc822-message.vala"
						_tmp52_ = g_mime_part_get_content (G_TYPE_CHECK_INSTANCE_CAST (root, g_mime_part_get_type (), GMimePart));
#line 1058 "../src/engine/rfc822/rfc822-message.vala"
						_tmp53_ = stream;
#line 1058 "../src/engine/rfc822/rfc822-message.vala"
						g_mime_data_wrapper_write_to_stream (_tmp52_, G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, g_mime_stream_get_type (), GMimeStream));
#line 1059 "../src/engine/rfc822/rfc822-message.vala"
						_tmp54_ = stream;
#line 1059 "../src/engine/rfc822/rfc822-message.vala"
						_tmp55_ = g_mime_stream_mem_get_byte_array (_tmp54_);
#line 1059 "../src/engine/rfc822/rfc822-message.vala"
						_tmp56_ = _g_byte_array_ref0 (_tmp55_);
#line 1059 "../src/engine/rfc822/rfc822-message.vala"
						tnef_data = _tmp56_;
#line 1060 "../src/engine/rfc822/rfc822-message.vala"
						TNEFInitialize (&tn);
#line 1061 "../src/engine/rfc822/rfc822-message.vala"
						_tmp57_ = tnef_data;
#line 1061 "../src/engine/rfc822/rfc822-message.vala"
						_tmp58_ = _tmp57_->data;
#line 1061 "../src/engine/rfc822/rfc822-message.vala"
						_tmp58__length1 = _tmp57_->len;
#line 1061 "../src/engine/rfc822/rfc822-message.vala"
						_tmp59_ = TNEFParseMemory (_tmp58_, (gint) _tmp58__length1, &tn);
#line 1061 "../src/engine/rfc822/rfc822-message.vala"
						if (_tmp59_ == 0) {
#line 7568 "rfc822-message.c"
							{
								Attachment* a = NULL;
								TNEFStruct _tmp60_;
								Attachment _tmp61_;
								Attachment* _tmp62_;
#line 1062 "../src/engine/rfc822/rfc822-message.vala"
								_tmp60_ = tn;
#line 1062 "../src/engine/rfc822/rfc822-message.vala"
								_tmp61_ = _tmp60_.starting_attach;
#line 1062 "../src/engine/rfc822/rfc822-message.vala"
								_tmp62_ = _tmp61_.next;
#line 1062 "../src/engine/rfc822/rfc822-message.vala"
								a = _tmp62_;
#line 7582 "rfc822-message.c"
								{
									gboolean _tmp63_ = FALSE;
#line 1062 "../src/engine/rfc822/rfc822-message.vala"
									_tmp63_ = TRUE;
#line 1062 "../src/engine/rfc822/rfc822-message.vala"
									while (TRUE) {
#line 7589 "rfc822-message.c"
										Attachment* _tmp66_;
										Attachment* _tmp67_;
										Attachment _tmp68_;
										GMimePart* _tmp69_;
										GMimePart* _tmp70_;
										GearyRFC822Part* _tmp71_;
										GearyRFC822Part* _tmp72_;
#line 1062 "../src/engine/rfc822/rfc822-message.vala"
										if (!_tmp63_) {
#line 7599 "rfc822-message.c"
											Attachment* _tmp64_;
											Attachment* _tmp65_;
#line 1062 "../src/engine/rfc822/rfc822-message.vala"
											_tmp64_ = a;
#line 1062 "../src/engine/rfc822/rfc822-message.vala"
											_tmp65_ = (*_tmp64_).next;
#line 1062 "../src/engine/rfc822/rfc822-message.vala"
											a = _tmp65_;
#line 7608 "rfc822-message.c"
										}
#line 1062 "../src/engine/rfc822/rfc822-message.vala"
										_tmp63_ = FALSE;
#line 1062 "../src/engine/rfc822/rfc822-message.vala"
										_tmp66_ = a;
#line 1062 "../src/engine/rfc822/rfc822-message.vala"
										if (!(_tmp66_ != NULL)) {
#line 1062 "../src/engine/rfc822/rfc822-message.vala"
											break;
#line 7618 "rfc822-message.c"
										}
#line 1063 "../src/engine/rfc822/rfc822-message.vala"
										_tmp67_ = a;
#line 1063 "../src/engine/rfc822/rfc822-message.vala"
										_tmp68_ = *_tmp67_;
#line 1063 "../src/engine/rfc822/rfc822-message.vala"
										_tmp69_ = geary_rf_c822_message_tnef_attachment_to_gmime_part (self, &_tmp68_);
#line 1063 "../src/engine/rfc822/rfc822-message.vala"
										_tmp70_ = _tmp69_;
#line 1063 "../src/engine/rfc822/rfc822-message.vala"
										_tmp71_ = geary_rf_c822_part_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp70_, g_mime_object_get_type (), GMimeObject));
#line 1063 "../src/engine/rfc822/rfc822-message.vala"
										_tmp72_ = _tmp71_;
#line 1063 "../src/engine/rfc822/rfc822-message.vala"
										gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (attachments, GEE_TYPE_COLLECTION, GeeCollection), _tmp72_);
#line 1063 "../src/engine/rfc822/rfc822-message.vala"
										_g_object_unref0 (_tmp72_);
#line 1063 "../src/engine/rfc822/rfc822-message.vala"
										_g_object_unref0 (_tmp70_);
#line 7638 "rfc822-message.c"
									}
								}
							}
						}
#line 1056 "../src/engine/rfc822/rfc822-message.vala"
						TNEFFree (&tn);
#line 1056 "../src/engine/rfc822/rfc822-message.vala"
						_g_byte_array_unref0 (tnef_data);
#line 1056 "../src/engine/rfc822/rfc822-message.vala"
						_g_object_unref0 (stream);
#line 7649 "rfc822-message.c"
					} else {
						gboolean _tmp73_ = FALSE;
#line 1068 "../src/engine/rfc822/rfc822-message.vala"
						if (actual_disposition == GEARY_MIME_DISPOSITION_TYPE_ATTACHMENT) {
#line 1068 "../src/engine/rfc822/rfc822-message.vala"
							_tmp73_ = TRUE;
#line 7656 "rfc822-message.c"
						} else {
							gboolean _tmp74_ = FALSE;
							GearyMimeContentType* _tmp75_;
#line 1069 "../src/engine/rfc822/rfc822-message.vala"
							_tmp75_ = content_type;
#line 1069 "../src/engine/rfc822/rfc822-message.vala"
							if (!geary_mime_content_type_is_type (_tmp75_, "text", "plain")) {
#line 7664 "rfc822-message.c"
								GearyMimeContentType* _tmp76_;
#line 1070 "../src/engine/rfc822/rfc822-message.vala"
								_tmp76_ = content_type;
#line 1070 "../src/engine/rfc822/rfc822-message.vala"
								_tmp74_ = !geary_mime_content_type_is_type (_tmp76_, "text", "html");
#line 7670 "rfc822-message.c"
							} else {
#line 1069 "../src/engine/rfc822/rfc822-message.vala"
								_tmp74_ = FALSE;
#line 7674 "rfc822-message.c"
							}
#line 1069 "../src/engine/rfc822/rfc822-message.vala"
							_tmp73_ = _tmp74_;
#line 7678 "rfc822-message.c"
						}
#line 1068 "../src/engine/rfc822/rfc822-message.vala"
						if (_tmp73_) {
#line 7682 "rfc822-message.c"
							GearyRFC822Part* _tmp77_;
#line 1073 "../src/engine/rfc822/rfc822-message.vala"
							_tmp77_ = part;
#line 1073 "../src/engine/rfc822/rfc822-message.vala"
							gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (attachments, GEE_TYPE_COLLECTION, GeeCollection), _tmp77_);
#line 7688 "rfc822-message.c"
						}
					}
#line 1051 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (content_type);
#line 7693 "rfc822-message.c"
				}
#line 1042 "../src/engine/rfc822/rfc822-message.vala"
				_g_object_unref0 (part);
#line 7697 "rfc822-message.c"
			}
		}
	}
}

static GMimePart*
geary_rf_c822_message_tnef_attachment_to_gmime_part (GearyRFC822Message* self,
                                                     Attachment* a)
{
	variableLength* filenameProp = NULL;
	Attachment _tmp0_;
	MAPIProps _tmp1_;
	variableLength* _tmp2_;
	variableLength* _tmp3_;
	variableLength* _tmp4_;
	gchar* filename = NULL;
	variableLength* _tmp10_;
	guint8* _tmp11_;
	gint _tmp11__length1;
	gchar* _tmp12_;
	guint8* data = NULL;
	Attachment _tmp13_;
	variableLength _tmp14_;
	guint8* _tmp15_;
	gint _tmp15__length1;
	GBytes* _tmp16_;
	gsize _tmp17_ = 0;
	guint8* _tmp18_;
	gint data_length1;
	gint _data_size_;
	GMimePart* part = NULL;
	GMimePart* _tmp19_;
	GMimeParserOptions* _tmp20_;
	GMimeParserOptions* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	GMimeContentType* _tmp24_;
	GMimeContentType* _tmp25_;
	GMimeStreamMem* _tmp26_;
	GMimeStreamMem* _tmp27_;
	GMimeDataWrapper* _tmp28_;
	GMimeDataWrapper* _tmp29_;
	GMimePart* result;
#line 1080 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), NULL);
#line 1080 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (a != NULL, NULL);
#line 1081 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = *a;
#line 1081 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = _tmp0_.MAPI;
#line 1081 "../src/engine/rfc822/rfc822-message.vala"
	_tmp2_ = MAPIFindProperty (&_tmp1_, (guint) PROP_TAG (PT_STRING8, PR_ATTACH_LONG_FILENAME));
#line 1081 "../src/engine/rfc822/rfc822-message.vala"
	filenameProp = _tmp2_;
#line 1082 "../src/engine/rfc822/rfc822-message.vala"
	_tmp3_ = filenameProp;
#line 1082 "../src/engine/rfc822/rfc822-message.vala"
	_tmp4_ = MAPI_UNDEFINED;
#line 1082 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp3_ == _tmp4_) {
#line 7759 "rfc822-message.c"
		Attachment _tmp5_;
		MAPIProps _tmp6_;
		variableLength* _tmp7_;
		variableLength* _tmp8_;
		variableLength* _tmp9_;
#line 1083 "../src/engine/rfc822/rfc822-message.vala"
		_tmp5_ = *a;
#line 1083 "../src/engine/rfc822/rfc822-message.vala"
		_tmp6_ = _tmp5_.MAPI;
#line 1083 "../src/engine/rfc822/rfc822-message.vala"
		_tmp7_ = MAPIFindProperty (&_tmp6_, (guint) PROP_TAG (PT_STRING8, PR_DISPLAY_NAME));
#line 1083 "../src/engine/rfc822/rfc822-message.vala"
		filenameProp = _tmp7_;
#line 1084 "../src/engine/rfc822/rfc822-message.vala"
		_tmp8_ = filenameProp;
#line 1084 "../src/engine/rfc822/rfc822-message.vala"
		_tmp9_ = MAPI_UNDEFINED;
#line 1084 "../src/engine/rfc822/rfc822-message.vala"
		if (_tmp8_ == _tmp9_) {
#line 1085 "../src/engine/rfc822/rfc822-message.vala"
			filenameProp = &(*a).Title;
#line 7781 "rfc822-message.c"
		}
	}
#line 1088 "../src/engine/rfc822/rfc822-message.vala"
	_tmp10_ = filenameProp;
#line 1088 "../src/engine/rfc822/rfc822-message.vala"
	_tmp11_ = (*_tmp10_).data;
#line 1088 "../src/engine/rfc822/rfc822-message.vala"
	_tmp11__length1 = (*_tmp10_).size;
#line 1088 "../src/engine/rfc822/rfc822-message.vala"
	_tmp12_ = g_strdup ((const gchar*) _tmp11_);
#line 1088 "../src/engine/rfc822/rfc822-message.vala"
	filename = _tmp12_;
#line 1089 "../src/engine/rfc822/rfc822-message.vala"
	_tmp13_ = *a;
#line 1089 "../src/engine/rfc822/rfc822-message.vala"
	_tmp14_ = _tmp13_.FileData;
#line 1089 "../src/engine/rfc822/rfc822-message.vala"
	_tmp15_ = _tmp14_.data;
#line 1089 "../src/engine/rfc822/rfc822-message.vala"
	_tmp15__length1 = _tmp14_.size;
#line 1089 "../src/engine/rfc822/rfc822-message.vala"
	_tmp16_ = g_bytes_new (_tmp15_, _tmp15__length1);
#line 1089 "../src/engine/rfc822/rfc822-message.vala"
	_tmp18_ = g_bytes_unref_to_data (_tmp16_, &_tmp17_);
#line 1089 "../src/engine/rfc822/rfc822-message.vala"
	data = _tmp18_;
#line 1089 "../src/engine/rfc822/rfc822-message.vala"
	data_length1 = _tmp17_;
#line 1089 "../src/engine/rfc822/rfc822-message.vala"
	_data_size_ = data_length1;
#line 1091 "../src/engine/rfc822/rfc822-message.vala"
	_tmp19_ = g_mime_part_new_with_type ("text", "plain");
#line 1091 "../src/engine/rfc822/rfc822-message.vala"
	part = _tmp19_;
#line 1092 "../src/engine/rfc822/rfc822-message.vala"
	g_mime_part_set_filename (part, filename);
#line 1093 "../src/engine/rfc822/rfc822-message.vala"
	_tmp20_ = geary_rf_c822_get_parser_options ();
#line 1093 "../src/engine/rfc822/rfc822-message.vala"
	_tmp21_ = _tmp20_;
#line 1093 "../src/engine/rfc822/rfc822-message.vala"
	_tmp22_ = g_content_type_guess (filename, data, (gsize) data_length1, NULL);
#line 1093 "../src/engine/rfc822/rfc822-message.vala"
	_tmp23_ = _tmp22_;
#line 1093 "../src/engine/rfc822/rfc822-message.vala"
	_tmp24_ = g_mime_content_type_parse (_tmp21_, _tmp23_);
#line 1093 "../src/engine/rfc822/rfc822-message.vala"
	_tmp25_ = _tmp24_;
#line 1093 "../src/engine/rfc822/rfc822-message.vala"
	g_mime_object_set_content_type (G_TYPE_CHECK_INSTANCE_CAST (part, g_mime_object_get_type (), GMimeObject), _tmp25_);
#line 1093 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_tmp25_);
#line 1093 "../src/engine/rfc822/rfc822-message.vala"
	_g_free0 (_tmp23_);
#line 1093 "../src/engine/rfc822/rfc822-message.vala"
	__vala_GMimeParserOptions_free0 (_tmp21_);
#line 1094 "../src/engine/rfc822/rfc822-message.vala"
	_tmp26_ = (GMimeStreamMem*) g_mime_stream_mem_new_with_buffer (data, data_length1);
#line 1094 "../src/engine/rfc822/rfc822-message.vala"
	_tmp27_ = _tmp26_;
#line 1094 "../src/engine/rfc822/rfc822-message.vala"
	_tmp28_ = g_mime_data_wrapper_new_with_stream (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, g_mime_stream_get_type (), GMimeStream), GMIME_CONTENT_ENCODING_BINARY);
#line 1094 "../src/engine/rfc822/rfc822-message.vala"
	_tmp29_ = _tmp28_;
#line 1094 "../src/engine/rfc822/rfc822-message.vala"
	g_mime_part_set_content (part, _tmp29_);
#line 1094 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_tmp29_);
#line 1094 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_tmp27_);
#line 1095 "../src/engine/rfc822/rfc822-message.vala"
	result = part;
#line 1095 "../src/engine/rfc822/rfc822-message.vala"
	data = (g_free (data), NULL);
#line 1095 "../src/engine/rfc822/rfc822-message.vala"
	_g_free0 (filename);
#line 1095 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 7860 "rfc822-message.c"
}

GeeList*
geary_rf_c822_message_get_sub_messages (GearyRFC822Message* self,
                                        GError** error)
{
	GeeList* messages = NULL;
	GeeArrayList* _tmp0_;
	GMimeMessage* _tmp1_;
	GMimeObject* _tmp2_;
	GError* _inner_error0_ = NULL;
	GeeList* result;
#line 1099 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), NULL);
#line 1101 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = gee_array_list_new (GEARY_RF_C822_TYPE_MESSAGE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1101 "../src/engine/rfc822/rfc822-message.vala"
	messages = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_LIST, GeeList);
#line 1102 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = self->priv->message;
#line 1102 "../src/engine/rfc822/rfc822-message.vala"
	_tmp2_ = g_mime_message_get_mime_part (_tmp1_);
#line 1102 "../src/engine/rfc822/rfc822-message.vala"
	geary_rf_c822_message_find_sub_messages (self, messages, _tmp2_, &_inner_error0_);
#line 1102 "../src/engine/rfc822/rfc822-message.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1102 "../src/engine/rfc822/rfc822-message.vala"
		if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 1102 "../src/engine/rfc822/rfc822-message.vala"
			g_propagate_error (error, _inner_error0_);
#line 1102 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (messages);
#line 1102 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 7895 "rfc822-message.c"
		} else {
#line 1102 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (messages);
#line 1102 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1102 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 1102 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 7905 "rfc822-message.c"
		}
	}
#line 1103 "../src/engine/rfc822/rfc822-message.vala"
	result = messages;
#line 1103 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 7912 "rfc822-message.c"
}

static void
geary_rf_c822_message_find_sub_messages (GearyRFC822Message* self,
                                         GeeList* messages,
                                         GMimeObject* root,
                                         GError** error)
{
	GMimeMultipart* multipart = NULL;
	GMimeMultipart* _tmp0_;
	GMimeMultipart* _tmp1_;
	GMimeMessagePart* messagepart = NULL;
	GMimeMessagePart* _tmp7_;
	GMimeMessagePart* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 1106 "../src/engine/rfc822/rfc822-message.vala"
	g_return_if_fail (GEARY_RF_C822_IS_MESSAGE (self));
#line 1106 "../src/engine/rfc822/rfc822-message.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (messages, GEE_TYPE_LIST));
#line 1106 "../src/engine/rfc822/rfc822-message.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (root, g_mime_object_get_type ()));
#line 1110 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (root, g_mime_multipart_get_type ()) ? ((GMimeMultipart*) root) : NULL);
#line 1110 "../src/engine/rfc822/rfc822-message.vala"
	multipart = _tmp0_;
#line 1111 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = multipart;
#line 1111 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp1_ != NULL) {
#line 7942 "rfc822-message.c"
		gint count = 0;
		GMimeMultipart* _tmp2_;
#line 1112 "../src/engine/rfc822/rfc822-message.vala"
		_tmp2_ = multipart;
#line 1112 "../src/engine/rfc822/rfc822-message.vala"
		count = g_mime_multipart_get_count (_tmp2_);
#line 7949 "rfc822-message.c"
		{
			gint i = 0;
#line 1113 "../src/engine/rfc822/rfc822-message.vala"
			i = 0;
#line 7954 "rfc822-message.c"
			{
				gboolean _tmp3_ = FALSE;
#line 1113 "../src/engine/rfc822/rfc822-message.vala"
				_tmp3_ = TRUE;
#line 1113 "../src/engine/rfc822/rfc822-message.vala"
				while (TRUE) {
#line 7961 "rfc822-message.c"
					GMimeMultipart* _tmp5_;
					GMimeObject* _tmp6_;
#line 1113 "../src/engine/rfc822/rfc822-message.vala"
					if (!_tmp3_) {
#line 7966 "rfc822-message.c"
						gint _tmp4_;
#line 1113 "../src/engine/rfc822/rfc822-message.vala"
						i = i + 1;
#line 1113 "../src/engine/rfc822/rfc822-message.vala"
						_tmp4_ = i;
#line 7972 "rfc822-message.c"
					}
#line 1113 "../src/engine/rfc822/rfc822-message.vala"
					_tmp3_ = FALSE;
#line 1113 "../src/engine/rfc822/rfc822-message.vala"
					if (!(i < count)) {
#line 1113 "../src/engine/rfc822/rfc822-message.vala"
						break;
#line 7980 "rfc822-message.c"
					}
#line 1114 "../src/engine/rfc822/rfc822-message.vala"
					_tmp5_ = multipart;
#line 1114 "../src/engine/rfc822/rfc822-message.vala"
					_tmp6_ = g_mime_multipart_get_part (_tmp5_, i);
#line 1114 "../src/engine/rfc822/rfc822-message.vala"
					geary_rf_c822_message_find_sub_messages (self, messages, _tmp6_, &_inner_error0_);
#line 1114 "../src/engine/rfc822/rfc822-message.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1114 "../src/engine/rfc822/rfc822-message.vala"
						if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 1114 "../src/engine/rfc822/rfc822-message.vala"
							g_propagate_error (error, _inner_error0_);
#line 1114 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (multipart);
#line 1114 "../src/engine/rfc822/rfc822-message.vala"
							return;
#line 7998 "rfc822-message.c"
						} else {
#line 1114 "../src/engine/rfc822/rfc822-message.vala"
							_g_object_unref0 (multipart);
#line 1114 "../src/engine/rfc822/rfc822-message.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1114 "../src/engine/rfc822/rfc822-message.vala"
							g_clear_error (&_inner_error0_);
#line 1114 "../src/engine/rfc822/rfc822-message.vala"
							return;
#line 8008 "rfc822-message.c"
						}
					}
				}
			}
		}
#line 1116 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (multipart);
#line 1116 "../src/engine/rfc822/rfc822-message.vala"
		return;
#line 8018 "rfc822-message.c"
	}
#line 1119 "../src/engine/rfc822/rfc822-message.vala"
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (root, g_mime_message_part_get_type ()) ? ((GMimeMessagePart*) root) : NULL);
#line 1119 "../src/engine/rfc822/rfc822-message.vala"
	messagepart = _tmp7_;
#line 1120 "../src/engine/rfc822/rfc822-message.vala"
	_tmp8_ = messagepart;
#line 1120 "../src/engine/rfc822/rfc822-message.vala"
	if (_tmp8_ != NULL) {
#line 8028 "rfc822-message.c"
		GMimeMessage* sub_message = NULL;
		GMimeMessagePart* _tmp9_;
		GMimeMessage* _tmp10_;
		GMimeMessage* _tmp11_;
		GMimeMessage* _tmp12_;
#line 1121 "../src/engine/rfc822/rfc822-message.vala"
		_tmp9_ = messagepart;
#line 1121 "../src/engine/rfc822/rfc822-message.vala"
		_tmp10_ = g_mime_message_part_get_message (_tmp9_);
#line 1121 "../src/engine/rfc822/rfc822-message.vala"
		_tmp11_ = _g_object_ref0 (_tmp10_);
#line 1121 "../src/engine/rfc822/rfc822-message.vala"
		sub_message = _tmp11_;
#line 1122 "../src/engine/rfc822/rfc822-message.vala"
		_tmp12_ = sub_message;
#line 1122 "../src/engine/rfc822/rfc822-message.vala"
		if (_tmp12_ != NULL) {
#line 8046 "rfc822-message.c"
			GearyRFC822Message* _tmp13_ = NULL;
			GMimeMessage* _tmp14_;
			GearyRFC822Message* _tmp15_;
#line 1123 "../src/engine/rfc822/rfc822-message.vala"
			_tmp14_ = sub_message;
#line 1123 "../src/engine/rfc822/rfc822-message.vala"
			_tmp15_ = geary_rf_c822_message_new_from_gmime_message (_tmp14_, &_inner_error0_);
#line 1123 "../src/engine/rfc822/rfc822-message.vala"
			_tmp13_ = _tmp15_;
#line 1123 "../src/engine/rfc822/rfc822-message.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1123 "../src/engine/rfc822/rfc822-message.vala"
				if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 1123 "../src/engine/rfc822/rfc822-message.vala"
					g_propagate_error (error, _inner_error0_);
#line 1123 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (sub_message);
#line 1123 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (messagepart);
#line 1123 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (multipart);
#line 1123 "../src/engine/rfc822/rfc822-message.vala"
					return;
#line 8070 "rfc822-message.c"
				} else {
#line 1123 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (sub_message);
#line 1123 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (messagepart);
#line 1123 "../src/engine/rfc822/rfc822-message.vala"
					_g_object_unref0 (multipart);
#line 1123 "../src/engine/rfc822/rfc822-message.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1123 "../src/engine/rfc822/rfc822-message.vala"
					g_clear_error (&_inner_error0_);
#line 1123 "../src/engine/rfc822/rfc822-message.vala"
					return;
#line 8084 "rfc822-message.c"
				}
			}
#line 1123 "../src/engine/rfc822/rfc822-message.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (messages, GEE_TYPE_COLLECTION, GeeCollection), _tmp13_);
#line 1122 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_tmp13_);
#line 8091 "rfc822-message.c"
		} else {
#line 1125 "../src/engine/rfc822/rfc822-message.vala"
			g_warning ("rfc822-message.vala:1125: Corrupt message, possibly bug 769697");
#line 8095 "rfc822-message.c"
		}
#line 1120 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (sub_message);
#line 8099 "rfc822-message.c"
	}
#line 1106 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (messagepart);
#line 1106 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (multipart);
#line 8105 "rfc822-message.c"
}

static GearyMemoryBuffer*
geary_rf_c822_message_message_to_memory_buffer (GearyRFC822Message* self,
                                                gboolean encode_lf,
                                                GearyRFC822MessageRFC822FormatOptions options,
                                                GError** error)
{
	GByteArray* byte_array = NULL;
	GByteArray* _tmp0_;
	GMimeStreamMem* stream = NULL;
	GByteArray* _tmp1_;
	GMimeStreamMem* _tmp2_;
	GMimeStreamMem* _tmp3_;
	GMimeStreamFilter* stream_filter = NULL;
	GMimeStreamMem* _tmp4_;
	GMimeStreamFilter* _tmp5_;
	GMimeFormatOptions* format = NULL;
	GMimeFormatOptions* _tmp15_;
	GMimeMessage* _tmp19_;
	GMimeFormatOptions* _tmp20_;
	GMimeStreamFilter* _tmp21_;
	GMimeStreamFilter* _tmp23_;
	GMimeStreamMem* _tmp25_;
	GByteArray* _tmp27_;
	GearyMemoryByteBuffer* _tmp28_;
	GError* _inner_error0_ = NULL;
	GearyMemoryBuffer* result;
#line 1130 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), NULL);
#line 1133 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = g_byte_array_new ();
#line 1133 "../src/engine/rfc822/rfc822-message.vala"
	byte_array = _tmp0_;
#line 1134 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = byte_array;
#line 1134 "../src/engine/rfc822/rfc822-message.vala"
	_tmp2_ = (GMimeStreamMem*) g_mime_stream_mem_new_with_byte_array (_tmp1_);
#line 1134 "../src/engine/rfc822/rfc822-message.vala"
	stream = _tmp2_;
#line 1135 "../src/engine/rfc822/rfc822-message.vala"
	_tmp3_ = stream;
#line 1135 "../src/engine/rfc822/rfc822-message.vala"
	g_mime_stream_mem_set_owner (_tmp3_, FALSE);
#line 1137 "../src/engine/rfc822/rfc822-message.vala"
	_tmp4_ = stream;
#line 1137 "../src/engine/rfc822/rfc822-message.vala"
	_tmp5_ = (GMimeStreamFilter*) g_mime_stream_filter_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, g_mime_stream_get_type (), GMimeStream));
#line 1137 "../src/engine/rfc822/rfc822-message.vala"
	stream_filter = _tmp5_;
#line 1138 "../src/engine/rfc822/rfc822-message.vala"
	if (encode_lf) {
#line 8158 "rfc822-message.c"
		GMimeStreamFilter* _tmp6_;
		GMimeFilterUnix2Dos* _tmp7_;
		GMimeFilterUnix2Dos* _tmp8_;
#line 1139 "../src/engine/rfc822/rfc822-message.vala"
		_tmp6_ = stream_filter;
#line 1139 "../src/engine/rfc822/rfc822-message.vala"
		_tmp7_ = (GMimeFilterUnix2Dos*) g_mime_filter_unix2dos_new (FALSE);
#line 1139 "../src/engine/rfc822/rfc822-message.vala"
		_tmp8_ = _tmp7_;
#line 1139 "../src/engine/rfc822/rfc822-message.vala"
		g_mime_stream_filter_add (_tmp6_, G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, g_mime_filter_get_type (), GMimeFilter));
#line 1139 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_tmp8_);
#line 8172 "rfc822-message.c"
	} else {
		GMimeStreamFilter* _tmp9_;
		GMimeFilterDos2Unix* _tmp10_;
		GMimeFilterDos2Unix* _tmp11_;
#line 1141 "../src/engine/rfc822/rfc822-message.vala"
		_tmp9_ = stream_filter;
#line 1141 "../src/engine/rfc822/rfc822-message.vala"
		_tmp10_ = (GMimeFilterDos2Unix*) g_mime_filter_dos2unix_new (FALSE);
#line 1141 "../src/engine/rfc822/rfc822-message.vala"
		_tmp11_ = _tmp10_;
#line 1141 "../src/engine/rfc822/rfc822-message.vala"
		g_mime_stream_filter_add (_tmp9_, G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, g_mime_filter_get_type (), GMimeFilter));
#line 1141 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_tmp11_);
#line 8187 "rfc822-message.c"
	}
#line 1143 "../src/engine/rfc822/rfc822-message.vala"
	if ((options & GEARY_RF_C822_MESSAGE_RF_C822_FORMAT_OPTIONS_SMTP_FORMAT) == GEARY_RF_C822_MESSAGE_RF_C822_FORMAT_OPTIONS_SMTP_FORMAT) {
#line 8191 "rfc822-message.c"
		GMimeStreamFilter* _tmp12_;
		GMimeFilterSmtpData* _tmp13_;
		GMimeFilterSmtpData* _tmp14_;
#line 1144 "../src/engine/rfc822/rfc822-message.vala"
		_tmp12_ = stream_filter;
#line 1144 "../src/engine/rfc822/rfc822-message.vala"
		_tmp13_ = (GMimeFilterSmtpData*) g_mime_filter_smtp_data_new ();
#line 1144 "../src/engine/rfc822/rfc822-message.vala"
		_tmp14_ = _tmp13_;
#line 1144 "../src/engine/rfc822/rfc822-message.vala"
		g_mime_stream_filter_add (_tmp12_, G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, g_mime_filter_get_type (), GMimeFilter));
#line 1144 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_tmp14_);
#line 8205 "rfc822-message.c"
	}
#line 1147 "../src/engine/rfc822/rfc822-message.vala"
	_tmp15_ = geary_rf_c822_get_format_options ();
#line 1147 "../src/engine/rfc822/rfc822-message.vala"
	format = _tmp15_;
#line 1148 "../src/engine/rfc822/rfc822-message.vala"
	if ((options & GEARY_RF_C822_MESSAGE_RF_C822_FORMAT_OPTIONS_SMTP_FORMAT) == GEARY_RF_C822_MESSAGE_RF_C822_FORMAT_OPTIONS_SMTP_FORMAT) {
#line 8213 "rfc822-message.c"
		GMimeFormatOptions* _tmp16_;
		GMimeFormatOptions* _tmp17_;
		GMimeFormatOptions* _tmp18_;
#line 1149 "../src/engine/rfc822/rfc822-message.vala"
		_tmp16_ = format;
#line 1149 "../src/engine/rfc822/rfc822-message.vala"
		_tmp17_ = g_mime_format_options_clone (_tmp16_);
#line 1149 "../src/engine/rfc822/rfc822-message.vala"
		__vala_GMimeFormatOptions_free0 (format);
#line 1149 "../src/engine/rfc822/rfc822-message.vala"
		format = _tmp17_;
#line 1150 "../src/engine/rfc822/rfc822-message.vala"
		_tmp18_ = format;
#line 1150 "../src/engine/rfc822/rfc822-message.vala"
		g_mime_format_options_add_hidden_header (_tmp18_, "Bcc");
#line 8229 "rfc822-message.c"
	}
#line 1153 "../src/engine/rfc822/rfc822-message.vala"
	_tmp19_ = self->priv->message;
#line 1153 "../src/engine/rfc822/rfc822-message.vala"
	_tmp20_ = format;
#line 1153 "../src/engine/rfc822/rfc822-message.vala"
	_tmp21_ = stream_filter;
#line 1153 "../src/engine/rfc822/rfc822-message.vala"
	if (g_mime_object_write_to_stream (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, g_mime_object_get_type (), GMimeObject), _tmp20_, G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, g_mime_stream_get_type (), GMimeStream)) < ((gssize) 0)) {
#line 8239 "rfc822-message.c"
		GError* _tmp22_;
#line 1154 "../src/engine/rfc822/rfc822-message.vala"
		_tmp22_ = g_error_new_literal (GEARY_RF_C822_ERROR, GEARY_RF_C822_ERROR_FAILED, "Unable to write RFC822 message to filter stream");
#line 1154 "../src/engine/rfc822/rfc822-message.vala"
		_inner_error0_ = _tmp22_;
#line 1154 "../src/engine/rfc822/rfc822-message.vala"
		if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 1154 "../src/engine/rfc822/rfc822-message.vala"
			g_propagate_error (error, _inner_error0_);
#line 1154 "../src/engine/rfc822/rfc822-message.vala"
			__vala_GMimeFormatOptions_free0 (format);
#line 1154 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (stream_filter);
#line 1154 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (stream);
#line 1154 "../src/engine/rfc822/rfc822-message.vala"
			_g_byte_array_unref0 (byte_array);
#line 1154 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 8259 "rfc822-message.c"
		} else {
#line 1154 "../src/engine/rfc822/rfc822-message.vala"
			__vala_GMimeFormatOptions_free0 (format);
#line 1154 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (stream_filter);
#line 1154 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (stream);
#line 1154 "../src/engine/rfc822/rfc822-message.vala"
			_g_byte_array_unref0 (byte_array);
#line 1154 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1154 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 1154 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 8275 "rfc822-message.c"
		}
	}
#line 1159 "../src/engine/rfc822/rfc822-message.vala"
	_tmp23_ = stream_filter;
#line 1159 "../src/engine/rfc822/rfc822-message.vala"
	if (g_mime_stream_flush (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, g_mime_stream_get_type (), GMimeStream)) != 0) {
#line 8282 "rfc822-message.c"
		GError* _tmp24_;
#line 1160 "../src/engine/rfc822/rfc822-message.vala"
		_tmp24_ = g_error_new_literal (GEARY_RF_C822_ERROR, GEARY_RF_C822_ERROR_FAILED, "Unable to flush RFC822 message to memory stream");
#line 1160 "../src/engine/rfc822/rfc822-message.vala"
		_inner_error0_ = _tmp24_;
#line 1160 "../src/engine/rfc822/rfc822-message.vala"
		if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 1160 "../src/engine/rfc822/rfc822-message.vala"
			g_propagate_error (error, _inner_error0_);
#line 1160 "../src/engine/rfc822/rfc822-message.vala"
			__vala_GMimeFormatOptions_free0 (format);
#line 1160 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (stream_filter);
#line 1160 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (stream);
#line 1160 "../src/engine/rfc822/rfc822-message.vala"
			_g_byte_array_unref0 (byte_array);
#line 1160 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 8302 "rfc822-message.c"
		} else {
#line 1160 "../src/engine/rfc822/rfc822-message.vala"
			__vala_GMimeFormatOptions_free0 (format);
#line 1160 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (stream_filter);
#line 1160 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (stream);
#line 1160 "../src/engine/rfc822/rfc822-message.vala"
			_g_byte_array_unref0 (byte_array);
#line 1160 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1160 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 1160 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 8318 "rfc822-message.c"
		}
	}
#line 1165 "../src/engine/rfc822/rfc822-message.vala"
	_tmp25_ = stream;
#line 1165 "../src/engine/rfc822/rfc822-message.vala"
	if (g_mime_stream_flush (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, g_mime_stream_get_type (), GMimeStream)) != 0) {
#line 8325 "rfc822-message.c"
		GError* _tmp26_;
#line 1166 "../src/engine/rfc822/rfc822-message.vala"
		_tmp26_ = g_error_new_literal (GEARY_RF_C822_ERROR, GEARY_RF_C822_ERROR_FAILED, "Unable to flush RFC822 message to memory buffer");
#line 1166 "../src/engine/rfc822/rfc822-message.vala"
		_inner_error0_ = _tmp26_;
#line 1166 "../src/engine/rfc822/rfc822-message.vala"
		if (_inner_error0_->domain == GEARY_RF_C822_ERROR) {
#line 1166 "../src/engine/rfc822/rfc822-message.vala"
			g_propagate_error (error, _inner_error0_);
#line 1166 "../src/engine/rfc822/rfc822-message.vala"
			__vala_GMimeFormatOptions_free0 (format);
#line 1166 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (stream_filter);
#line 1166 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (stream);
#line 1166 "../src/engine/rfc822/rfc822-message.vala"
			_g_byte_array_unref0 (byte_array);
#line 1166 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 8345 "rfc822-message.c"
		} else {
#line 1166 "../src/engine/rfc822/rfc822-message.vala"
			__vala_GMimeFormatOptions_free0 (format);
#line 1166 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (stream_filter);
#line 1166 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (stream);
#line 1166 "../src/engine/rfc822/rfc822-message.vala"
			_g_byte_array_unref0 (byte_array);
#line 1166 "../src/engine/rfc822/rfc822-message.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1166 "../src/engine/rfc822/rfc822-message.vala"
			g_clear_error (&_inner_error0_);
#line 1166 "../src/engine/rfc822/rfc822-message.vala"
			return NULL;
#line 8361 "rfc822-message.c"
		}
	}
#line 1171 "../src/engine/rfc822/rfc822-message.vala"
	_tmp27_ = byte_array;
#line 1171 "../src/engine/rfc822/rfc822-message.vala"
	_tmp28_ = geary_memory_byte_buffer_new_from_byte_array (_tmp27_);
#line 1171 "../src/engine/rfc822/rfc822-message.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBuffer);
#line 1171 "../src/engine/rfc822/rfc822-message.vala"
	__vala_GMimeFormatOptions_free0 (format);
#line 1171 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (stream_filter);
#line 1171 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (stream);
#line 1171 "../src/engine/rfc822/rfc822-message.vala"
	_g_byte_array_unref0 (byte_array);
#line 1171 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 8380 "rfc822-message.c"
}

gchar*
geary_rf_c822_message_to_string (GearyRFC822Message* self)
{
	GMimeMessage* _tmp0_;
	GMimeFormatOptions* _tmp1_;
	GMimeFormatOptions* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 1174 "../src/engine/rfc822/rfc822-message.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (self), NULL);
#line 1175 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = self->priv->message;
#line 1175 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = geary_rf_c822_get_format_options ();
#line 1175 "../src/engine/rfc822/rfc822-message.vala"
	_tmp2_ = _tmp1_;
#line 1175 "../src/engine/rfc822/rfc822-message.vala"
	_tmp3_ = g_mime_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_mime_object_get_type (), GMimeObject), _tmp2_);
#line 1175 "../src/engine/rfc822/rfc822-message.vala"
	_tmp4_ = _tmp3_;
#line 1175 "../src/engine/rfc822/rfc822-message.vala"
	__vala_GMimeFormatOptions_free0 (_tmp2_);
#line 1175 "../src/engine/rfc822/rfc822-message.vala"
	result = _tmp4_;
#line 1175 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 8410 "rfc822-message.c"
}

static void
geary_rf_c822_message_body_data_to_part_data_free (gpointer _data)
{
	GearyRfC822MessageBodyDataToPartData* _data_;
	_data_ = _data;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_g_free0 (_data_->charset);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_g_free0 (_data_->content_type);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->cancellable);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->result);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->self);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_slice_free (GearyRfC822MessageBodyDataToPartData, _data_);
#line 8430 "rfc822-message.c"
}

static void
geary_rf_c822_message_body_data_to_part (GearyRFC822Message* self,
                                         guint8* content,
                                         gint content_length1,
                                         const gchar* charset,
                                         const gchar* content_type,
                                         gboolean is_flowed,
                                         GCancellable* cancellable,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	GearyRfC822MessageBodyDataToPartData* _data_;
	GearyRFC822Message* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GCancellable* _tmp3_;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_return_if_fail (GEARY_RF_C822_IS_MESSAGE (self));
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_return_if_fail (content_type != NULL);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_ = g_slice_new0 (GearyRfC822MessageBodyDataToPartData);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_rf_c822_message_body_data_to_part_data_free);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_->self = _tmp0_;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_->content = content;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_->content_length1 = content_length1;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_tmp1_ = g_strdup (charset);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_g_free0 (_data_->charset);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_->charset = _tmp1_;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_tmp2_ = g_strdup (content_type);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_g_free0 (_data_->content_type);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_->content_type = _tmp2_;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_->is_flowed = is_flowed;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->cancellable);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_->cancellable = _tmp3_;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	geary_rf_c822_message_body_data_to_part_co (_data_);
#line 8491 "rfc822-message.c"
}

static GMimePart*
geary_rf_c822_message_body_data_to_part_finish (GearyRFC822Message* self,
                                                GAsyncResult* _res_,
                                                GError** error)
{
	GMimePart* result;
	GearyRfC822MessageBodyDataToPartData* _data_;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	if (NULL == _data_) {
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		return NULL;
#line 8507 "rfc822-message.c"
	}
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	result = _data_->result;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	_data_->result = NULL;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	return result;
#line 8515 "rfc822-message.c"
}

/**
     * Returns a MIME part for some body content.
     *
     * Determining the appropriate body charset and encoding is
     * unfortunately a multi-step process that involves reading it
     * completely, several times:
     *
     * 1. Guess the best charset by scanning the complete body.
     * 2. Convert the body into the preferred charset, essential
     *    to avoid e.g. guessing Base64 encoding for ISO-8859-1
     *    because of the 0x0's present in UTF bytes with high-bit
     *    chars.
     * 3. Determine, given the correctly encoded charset
     *    what the appropriate encoding is by scanning the
     *    complete, encoded body.
     *
     * This applies to both text/plain and text/html parts, but we
     * don't need to do it repeatedly for each, since HTML is 7-bit
     * clean ASCII. So if we have guessed both already for a plain
     * text body, it will still apply for any HTML part.
     */
static void
geary_rf_c822_message_body_data_to_part_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_)
{
	GearyRfC822MessageBodyDataToPartData* _data_;
#line 1207 "../src/engine/rfc822/rfc822-message.vala"
	_data_ = _user_data_;
#line 1207 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_source_object_ = source_object;
#line 1207 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_res_ = _res_;
#line 1207 "../src/engine/rfc822/rfc822-message.vala"
	geary_rf_c822_message_body_data_to_part_co (_data_);
#line 8553 "rfc822-message.c"
}

static gboolean
geary_rf_c822_message_body_data_to_part_co (GearyRfC822MessageBodyDataToPartData* _data_)
{
#line 1199 "../src/engine/rfc822/rfc822-message.vala"
	switch (_data_->_state_) {
#line 1199 "../src/engine/rfc822/rfc822-message.vala"
		case 0:
#line 8563 "rfc822-message.c"
		goto _state_0;
#line 1199 "../src/engine/rfc822/rfc822-message.vala"
		case 1:
#line 8567 "rfc822-message.c"
		goto _state_1;
#line 1199 "../src/engine/rfc822/rfc822-message.vala"
		case 2:
#line 8571 "rfc822-message.c"
		goto _state_2;
		default:
#line 1199 "../src/engine/rfc822/rfc822-message.vala"
		g_assert_not_reached ();
#line 8576 "rfc822-message.c"
	}
	_state_0:
#line 1205 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp0_ = (GMimeStreamMem*) g_mime_stream_mem_new_with_buffer (_data_->content, _data_->content_length1);
#line 1205 "../src/engine/rfc822/rfc822-message.vala"
	_data_->content_stream = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, g_mime_stream_get_type (), GMimeStream);
#line 1206 "../src/engine/rfc822/rfc822-message.vala"
	if (_data_->charset == NULL) {
#line 8585 "rfc822-message.c"
		gchar* _tmp4_;
#line 1207 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp2_ = _data_->content_stream;
#line 1207 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_state_ = 1;
#line 1207 "../src/engine/rfc822/rfc822-message.vala"
		geary_rf_c822_utils_get_best_charset (_data_->_tmp2_, _data_->cancellable, geary_rf_c822_message_body_data_to_part_ready, _data_);
#line 1207 "../src/engine/rfc822/rfc822-message.vala"
		return FALSE;
#line 8595 "rfc822-message.c"
		_state_1:
#line 1207 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp3_ = geary_rf_c822_utils_get_best_charset_finish (_data_->_res_, &_data_->_inner_error0_);
#line 1207 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp1_ = _data_->_tmp3_;
#line 1207 "../src/engine/rfc822/rfc822-message.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1207 "../src/engine/rfc822/rfc822-message.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1207 "../src/engine/rfc822/rfc822-message.vala"
			_g_object_unref0 (_data_->content_stream);
#line 1207 "../src/engine/rfc822/rfc822-message.vala"
			g_object_unref (_data_->_async_result);
#line 1207 "../src/engine/rfc822/rfc822-message.vala"
			return FALSE;
#line 8611 "rfc822-message.c"
		}
#line 1207 "../src/engine/rfc822/rfc822-message.vala"
		_tmp4_ = g_strdup (_data_->_tmp1_);
#line 1207 "../src/engine/rfc822/rfc822-message.vala"
		_g_free0 (_data_->charset);
#line 1207 "../src/engine/rfc822/rfc822-message.vala"
		_data_->charset = _tmp4_;
#line 1206 "../src/engine/rfc822/rfc822-message.vala"
		_g_free0 (_data_->_tmp1_);
#line 8621 "rfc822-message.c"
	}
#line 1209 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp5_ = _data_->content_stream;
#line 1209 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp6_ = (GMimeStreamFilter*) g_mime_stream_filter_new (_data_->_tmp5_);
#line 1209 "../src/engine/rfc822/rfc822-message.vala"
	_data_->filter_stream = _data_->_tmp6_;
#line 1210 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp7_ = _data_->filter_stream;
#line 1210 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp8_ = (GMimeFilterCharset*) g_mime_filter_charset_new (GEARY_RF_C822_UTF8_CHARSET, _data_->charset);
#line 1210 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp9_ = _data_->_tmp8_;
#line 1210 "../src/engine/rfc822/rfc822-message.vala"
	g_mime_stream_filter_add (_data_->_tmp7_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp9_, g_mime_filter_get_type (), GMimeFilter));
#line 1210 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->_tmp9_);
#line 1212 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp10_ = _data_->filter_stream;
#line 1212 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_state_ = 2;
#line 1212 "../src/engine/rfc822/rfc822-message.vala"
	geary_rf_c822_utils_get_best_encoding (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp10_, g_mime_stream_get_type (), GMimeStream), GMIME_ENCODING_CONSTRAINT_7BIT, _data_->cancellable, geary_rf_c822_message_body_data_to_part_ready, _data_);
#line 1212 "../src/engine/rfc822/rfc822-message.vala"
	return FALSE;
#line 8647 "rfc822-message.c"
	_state_2:
#line 1212 "../src/engine/rfc822/rfc822-message.vala"
	_data_->encoding = geary_rf_c822_utils_get_best_encoding_finish (_data_->_res_, &_data_->_inner_error0_);
#line 1212 "../src/engine/rfc822/rfc822-message.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1212 "../src/engine/rfc822/rfc822-message.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1212 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_data_->filter_stream);
#line 1212 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_data_->content_stream);
#line 1212 "../src/engine/rfc822/rfc822-message.vala"
		g_object_unref (_data_->_async_result);
#line 1212 "../src/engine/rfc822/rfc822-message.vala"
		return FALSE;
#line 8663 "rfc822-message.c"
	}
#line 1218 "../src/engine/rfc822/rfc822-message.vala"
	if (_data_->is_flowed) {
#line 1218 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp11_ = _data_->encoding == GMIME_CONTENT_ENCODING_BASE64;
#line 8669 "rfc822-message.c"
	} else {
#line 1218 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp11_ = FALSE;
#line 8673 "rfc822-message.c"
	}
#line 1218 "../src/engine/rfc822/rfc822-message.vala"
	if (_data_->_tmp11_) {
#line 1222 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp12_ = _data_->filter_stream;
#line 1222 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp13_ = (GMimeFilterUnix2Dos*) g_mime_filter_unix2dos_new (FALSE);
#line 1222 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp14_ = _data_->_tmp13_;
#line 1222 "../src/engine/rfc822/rfc822-message.vala"
		g_mime_stream_filter_add (_data_->_tmp12_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp14_, g_mime_filter_get_type (), GMimeFilter));
#line 1222 "../src/engine/rfc822/rfc822-message.vala"
		_g_object_unref0 (_data_->_tmp14_);
#line 8687 "rfc822-message.c"
	}
#line 1225 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp15_ = geary_rf_c822_get_parser_options ();
#line 1225 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp16_ = _data_->_tmp15_;
#line 1225 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp17_ = g_mime_content_type_parse (_data_->_tmp16_, _data_->content_type);
#line 1225 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp18_ = _data_->_tmp17_;
#line 1225 "../src/engine/rfc822/rfc822-message.vala"
	__vala_GMimeParserOptions_free0 (_data_->_tmp16_);
#line 1225 "../src/engine/rfc822/rfc822-message.vala"
	_data_->complete_type = _data_->_tmp18_;
#line 1229 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp19_ = _data_->complete_type;
#line 1229 "../src/engine/rfc822/rfc822-message.vala"
	g_mime_content_type_set_parameter (_data_->_tmp19_, "charset", _data_->charset);
#line 1230 "../src/engine/rfc822/rfc822-message.vala"
	if (_data_->is_flowed) {
#line 1231 "../src/engine/rfc822/rfc822-message.vala"
		_data_->_tmp20_ = _data_->complete_type;
#line 1231 "../src/engine/rfc822/rfc822-message.vala"
		g_mime_content_type_set_parameter (_data_->_tmp20_, "format", "flowed");
#line 8711 "rfc822-message.c"
	}
#line 1234 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp21_ = _data_->filter_stream;
#line 1234 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp22_ = g_mime_data_wrapper_new_with_stream (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp21_, g_mime_stream_get_type (), GMimeStream), GMIME_CONTENT_ENCODING_DEFAULT);
#line 1234 "../src/engine/rfc822/rfc822-message.vala"
	_data_->body = _data_->_tmp22_;
#line 1238 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp23_ = g_mime_part_new_with_type ("text", "plain");
#line 1238 "../src/engine/rfc822/rfc822-message.vala"
	_data_->body_part = _data_->_tmp23_;
#line 1239 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp24_ = _data_->body_part;
#line 1239 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp25_ = _data_->complete_type;
#line 1239 "../src/engine/rfc822/rfc822-message.vala"
	g_mime_object_set_content_type (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp24_, g_mime_object_get_type (), GMimeObject), _data_->_tmp25_);
#line 1240 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp26_ = _data_->body_part;
#line 1240 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp27_ = _data_->body;
#line 1240 "../src/engine/rfc822/rfc822-message.vala"
	g_mime_part_set_content (_data_->_tmp26_, _data_->_tmp27_);
#line 1241 "../src/engine/rfc822/rfc822-message.vala"
	_data_->_tmp28_ = _data_->body_part;
#line 1241 "../src/engine/rfc822/rfc822-message.vala"
	g_mime_part_set_content_encoding (_data_->_tmp28_, _data_->encoding);
#line 1242 "../src/engine/rfc822/rfc822-message.vala"
	_data_->result = _data_->body_part;
#line 1242 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->body);
#line 1242 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->complete_type);
#line 1242 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->filter_stream);
#line 1242 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (_data_->content_stream);
#line 1242 "../src/engine/rfc822/rfc822-message.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1242 "../src/engine/rfc822/rfc822-message.vala"
	if (_data_->_state_ != 0) {
#line 1242 "../src/engine/rfc822/rfc822-message.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1242 "../src/engine/rfc822/rfc822-message.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8757 "rfc822-message.c"
		}
	}
#line 1242 "../src/engine/rfc822/rfc822-message.vala"
	g_object_unref (_data_->_async_result);
#line 1242 "../src/engine/rfc822/rfc822-message.vala"
	return FALSE;
#line 8764 "rfc822-message.c"
}

static void
geary_rf_c822_message_class_init (GearyRFC822MessageClass * klass,
                                  gpointer klass_data)
{
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	geary_rf_c822_message_parent_class = g_type_class_peek_parent (klass);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_type_class_adjust_private_offset (klass, &GearyRFC822Message_private_offset);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_rf_c822_message_get_property;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_rf_c822_message_set_property;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_rf_c822_message_finalize;
#line 8781 "rfc822-message.c"
	/** {@inheritDoc} */
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_RF_C822_MESSAGE_FROM_PROPERTY, geary_rf_c822_message_properties[GEARY_RF_C822_MESSAGE_FROM_PROPERTY] = g_param_spec_object ("from", "from", "from", GEARY_RF_C822_TYPE_MAILBOX_ADDRESSES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8785 "rfc822-message.c"
	/** {@inheritDoc} */
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_RF_C822_MESSAGE_SENDER_PROPERTY, geary_rf_c822_message_properties[GEARY_RF_C822_MESSAGE_SENDER_PROPERTY] = g_param_spec_object ("sender", "sender", "sender", GEARY_RF_C822_TYPE_MAILBOX_ADDRESS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8789 "rfc822-message.c"
	/** {@inheritDoc} */
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_RF_C822_MESSAGE_REPLY_TO_PROPERTY, geary_rf_c822_message_properties[GEARY_RF_C822_MESSAGE_REPLY_TO_PROPERTY] = g_param_spec_object ("reply-to", "reply-to", "reply-to", GEARY_RF_C822_TYPE_MAILBOX_ADDRESSES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8793 "rfc822-message.c"
	/** {@inheritDoc} */
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_RF_C822_MESSAGE_TO_PROPERTY, geary_rf_c822_message_properties[GEARY_RF_C822_MESSAGE_TO_PROPERTY] = g_param_spec_object ("to", "to", "to", GEARY_RF_C822_TYPE_MAILBOX_ADDRESSES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8797 "rfc822-message.c"
	/** {@inheritDoc} */
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_RF_C822_MESSAGE_CC_PROPERTY, geary_rf_c822_message_properties[GEARY_RF_C822_MESSAGE_CC_PROPERTY] = g_param_spec_object ("cc", "cc", "cc", GEARY_RF_C822_TYPE_MAILBOX_ADDRESSES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8801 "rfc822-message.c"
	/** {@inheritDoc} */
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_RF_C822_MESSAGE_BCC_PROPERTY, geary_rf_c822_message_properties[GEARY_RF_C822_MESSAGE_BCC_PROPERTY] = g_param_spec_object ("bcc", "bcc", "bcc", GEARY_RF_C822_TYPE_MAILBOX_ADDRESSES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8805 "rfc822-message.c"
	/** {@inheritDoc} */
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_RF_C822_MESSAGE_MESSAGE_ID_PROPERTY, geary_rf_c822_message_properties[GEARY_RF_C822_MESSAGE_MESSAGE_ID_PROPERTY] = g_param_spec_object ("message-id", "message-id", "message-id", GEARY_RF_C822_TYPE_MESSAGE_ID, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8809 "rfc822-message.c"
	/** {@inheritDoc} */
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_RF_C822_MESSAGE_IN_REPLY_TO_PROPERTY, geary_rf_c822_message_properties[GEARY_RF_C822_MESSAGE_IN_REPLY_TO_PROPERTY] = g_param_spec_object ("in-reply-to", "in-reply-to", "in-reply-to", GEARY_RF_C822_TYPE_MESSAGE_ID_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8813 "rfc822-message.c"
	/** {@inheritDoc} */
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_RF_C822_MESSAGE_REFERENCES_PROPERTY, geary_rf_c822_message_properties[GEARY_RF_C822_MESSAGE_REFERENCES_PROPERTY] = g_param_spec_object ("references", "references", "references", GEARY_RF_C822_TYPE_MESSAGE_ID_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8817 "rfc822-message.c"
	/** {@inheritDoc} */
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_RF_C822_MESSAGE_SUBJECT_PROPERTY, geary_rf_c822_message_properties[GEARY_RF_C822_MESSAGE_SUBJECT_PROPERTY] = g_param_spec_object ("subject", "subject", "subject", GEARY_RF_C822_TYPE_SUBJECT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8821 "rfc822-message.c"
	/** {@inheritDoc} */
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_RF_C822_MESSAGE_DATE_PROPERTY, geary_rf_c822_message_properties[GEARY_RF_C822_MESSAGE_DATE_PROPERTY] = g_param_spec_object ("date", "date", "date", GEARY_RF_C822_TYPE_DATE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8825 "rfc822-message.c"
	/**
	     * {@inheritDoc}
	     *
	     * Value will be valid if {@link Field.AUTH_RESULTS} is set.
	     */
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_RF_C822_MESSAGE_AUTH_RESULTS_PROPERTY, geary_rf_c822_message_properties[GEARY_RF_C822_MESSAGE_AUTH_RESULTS_PROPERTY] = g_param_spec_object ("auth-results", "auth-results", "auth-results", GEARY_RF_C822_TYPE_AUTHENTICATION_RESULTS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8833 "rfc822-message.c"
	/** Value of the X-Mailer header. */
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_RF_C822_MESSAGE_MAILER_PROPERTY, geary_rf_c822_message_properties[GEARY_RF_C822_MESSAGE_MAILER_PROPERTY] = g_param_spec_string ("mailer", "mailer", "mailer", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8837 "rfc822-message.c"
}

static void
geary_rf_c822_message_geary_email_header_set_interface_init (GearyEmailHeaderSetIface * iface,
                                                             gpointer iface_data)
{
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	geary_rf_c822_message_geary_email_header_set_parent_iface = g_type_interface_peek_parent (iface);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	iface->get_from = geary_rf_c822_message_real_get_from;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	iface->get_sender = geary_rf_c822_message_real_get_sender;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	iface->get_reply_to = geary_rf_c822_message_real_get_reply_to;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	iface->get_to = geary_rf_c822_message_real_get_to;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	iface->get_cc = geary_rf_c822_message_real_get_cc;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	iface->get_bcc = geary_rf_c822_message_real_get_bcc;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	iface->get_message_id = geary_rf_c822_message_real_get_message_id;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	iface->get_in_reply_to = geary_rf_c822_message_real_get_in_reply_to;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	iface->get_references = geary_rf_c822_message_real_get_references;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	iface->get_subject = geary_rf_c822_message_real_get_subject;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	iface->get_date = geary_rf_c822_message_real_get_date;
#line 8868 "rfc822-message.c"
}

static void
geary_rf_c822_message_instance_init (GearyRFC822Message * self,
                                     gpointer klass)
{
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	self->priv = geary_rf_c822_message_get_instance_private (self);
#line 74 "../src/engine/rfc822/rfc822-message.vala"
	self->priv->_from = NULL;
#line 78 "../src/engine/rfc822/rfc822-message.vala"
	self->priv->_sender = NULL;
#line 82 "../src/engine/rfc822/rfc822-message.vala"
	self->priv->_reply_to = NULL;
#line 86 "../src/engine/rfc822/rfc822-message.vala"
	self->priv->_to = NULL;
#line 90 "../src/engine/rfc822/rfc822-message.vala"
	self->priv->_cc = NULL;
#line 94 "../src/engine/rfc822/rfc822-message.vala"
	self->priv->_bcc = NULL;
#line 98 "../src/engine/rfc822/rfc822-message.vala"
	self->priv->_message_id = NULL;
#line 102 "../src/engine/rfc822/rfc822-message.vala"
	self->priv->_in_reply_to = NULL;
#line 106 "../src/engine/rfc822/rfc822-message.vala"
	self->priv->_references = NULL;
#line 110 "../src/engine/rfc822/rfc822-message.vala"
	self->priv->_subject = NULL;
#line 114 "../src/engine/rfc822/rfc822-message.vala"
	self->priv->_date = NULL;
#line 122 "../src/engine/rfc822/rfc822-message.vala"
	self->priv->_auth_results = NULL;
#line 125 "../src/engine/rfc822/rfc822-message.vala"
	self->priv->_mailer = NULL;
#line 8903 "rfc822-message.c"
}

static void
geary_rf_c822_message_finalize (GObject * obj)
{
	GearyRFC822Message * self;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_RF_C822_TYPE_MESSAGE, GearyRFC822Message);
#line 74 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (self->priv->_from);
#line 78 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (self->priv->_sender);
#line 82 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (self->priv->_reply_to);
#line 86 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (self->priv->_to);
#line 90 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (self->priv->_cc);
#line 94 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (self->priv->_bcc);
#line 98 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (self->priv->_message_id);
#line 102 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (self->priv->_in_reply_to);
#line 106 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (self->priv->_references);
#line 110 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (self->priv->_subject);
#line 114 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (self->priv->_date);
#line 122 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (self->priv->_auth_results);
#line 125 "../src/engine/rfc822/rfc822-message.vala"
	_g_free0 (self->priv->_mailer);
#line 128 "../src/engine/rfc822/rfc822-message.vala"
	_g_object_unref0 (self->priv->message);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	G_OBJECT_CLASS (geary_rf_c822_message_parent_class)->finalize (obj);
#line 8942 "rfc822-message.c"
}

/**
 * An RFC-822 style email message.
 *
 * Unlike {@link Email}, these objects are always a complete
 * representation of an email message, and contain no information
 * other than what RFC-822 and its successor RFC documents specify.
 */
 G_GNUC_NO_INLINE static GType
geary_rf_c822_message_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyRFC822MessageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_rf_c822_message_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyRFC822Message), 0, (GInstanceInitFunc) geary_rf_c822_message_instance_init, NULL };
	static const GInterfaceInfo geary_email_header_set_info = { (GInterfaceInitFunc) geary_rf_c822_message_geary_email_header_set_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType geary_rf_c822_message_type_id;
	geary_rf_c822_message_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyRFC822Message", &g_define_type_info, 0);
	g_type_add_interface_static (geary_rf_c822_message_type_id, GEARY_TYPE_EMAIL_HEADER_SET, &geary_email_header_set_info);
	GearyRFC822Message_private_offset = g_type_add_instance_private (geary_rf_c822_message_type_id, sizeof (GearyRFC822MessagePrivate));
	return geary_rf_c822_message_type_id;
}

GType
geary_rf_c822_message_get_type (void)
{
	static gsize geary_rf_c822_message_type_id__once = 0;
	if (g_once_init_enter (&geary_rf_c822_message_type_id__once)) {
		GType geary_rf_c822_message_type_id;
		geary_rf_c822_message_type_id = geary_rf_c822_message_get_type_once ();
		g_once_init_leave (&geary_rf_c822_message_type_id__once, geary_rf_c822_message_type_id);
	}
	return geary_rf_c822_message_type_id__once;
}

static void
_vala_geary_rf_c822_message_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	GearyRFC822Message * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_RF_C822_TYPE_MESSAGE, GearyRFC822Message);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	switch (property_id) {
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		case GEARY_RF_C822_MESSAGE_FROM_PROPERTY:
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		g_value_set_object (value, geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet)));
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		break;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		case GEARY_RF_C822_MESSAGE_SENDER_PROPERTY:
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		g_value_set_object (value, geary_email_header_set_get_sender (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet)));
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		break;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		case GEARY_RF_C822_MESSAGE_REPLY_TO_PROPERTY:
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		g_value_set_object (value, geary_email_header_set_get_reply_to (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet)));
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		break;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		case GEARY_RF_C822_MESSAGE_TO_PROPERTY:
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		g_value_set_object (value, geary_email_header_set_get_to (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet)));
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		break;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		case GEARY_RF_C822_MESSAGE_CC_PROPERTY:
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		g_value_set_object (value, geary_email_header_set_get_cc (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet)));
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		break;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		case GEARY_RF_C822_MESSAGE_BCC_PROPERTY:
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		g_value_set_object (value, geary_email_header_set_get_bcc (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet)));
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		break;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		case GEARY_RF_C822_MESSAGE_MESSAGE_ID_PROPERTY:
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		g_value_set_object (value, geary_email_header_set_get_message_id (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet)));
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		break;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		case GEARY_RF_C822_MESSAGE_IN_REPLY_TO_PROPERTY:
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		g_value_set_object (value, geary_email_header_set_get_in_reply_to (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet)));
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		break;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		case GEARY_RF_C822_MESSAGE_REFERENCES_PROPERTY:
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		g_value_set_object (value, geary_email_header_set_get_references (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet)));
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		break;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		case GEARY_RF_C822_MESSAGE_SUBJECT_PROPERTY:
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		g_value_set_object (value, geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet)));
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		break;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		case GEARY_RF_C822_MESSAGE_DATE_PROPERTY:
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		g_value_set_object (value, geary_email_header_set_get_date (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet)));
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		break;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		case GEARY_RF_C822_MESSAGE_AUTH_RESULTS_PROPERTY:
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		g_value_set_object (value, geary_rf_c822_message_get_auth_results (self));
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		break;
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		case GEARY_RF_C822_MESSAGE_MAILER_PROPERTY:
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		g_value_set_string (value, geary_rf_c822_message_get_mailer (self));
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		break;
#line 9064 "rfc822-message.c"
		default:
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		break;
#line 9070 "rfc822-message.c"
	}
}

static void
_vala_geary_rf_c822_message_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	GearyRFC822Message * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_RF_C822_TYPE_MESSAGE, GearyRFC822Message);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
	switch (property_id) {
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		case GEARY_RF_C822_MESSAGE_MAILER_PROPERTY:
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		geary_rf_c822_message_set_mailer (self, g_value_get_string (value));
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		break;
#line 9090 "rfc822-message.c"
		default:
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 17 "../src/engine/rfc822/rfc822-message.vala"
		break;
#line 9096 "rfc822-message.c"
	}
}

