/* smtp-client-connection.c generated by valac 0.56.17, the Vala compiler
 * generated from smtp-client-connection.vala, do not modify */

/*
 * Copyright © 2016 Software Freedom Conservancy Inc.
 * Copyright © 2020 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>

#define GEARY_SMTP_CLIENT_CONNECTION_DEFAULT_TIMEOUT_SEC ((guint) 20)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define GEARY_SMTP_TYPE_CLIENT_CONNECTION (geary_smtp_client_connection_get_type ())
#define GEARY_SMTP_CLIENT_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_SMTP_TYPE_CLIENT_CONNECTION, GearySmtpClientConnection))
#define GEARY_SMTP_CLIENT_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_SMTP_TYPE_CLIENT_CONNECTION, GearySmtpClientConnectionClass))
#define GEARY_SMTP_IS_CLIENT_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_SMTP_TYPE_CLIENT_CONNECTION))
#define GEARY_SMTP_IS_CLIENT_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_SMTP_TYPE_CLIENT_CONNECTION))
#define GEARY_SMTP_CLIENT_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_SMTP_TYPE_CLIENT_CONNECTION, GearySmtpClientConnectionClass))

typedef struct _GearySmtpClientConnection GearySmtpClientConnection;
typedef struct _GearySmtpClientConnectionClass GearySmtpClientConnectionClass;
typedef struct _GearySmtpClientConnectionPrivate GearySmtpClientConnectionPrivate;
enum  {
	GEARY_SMTP_CLIENT_CONNECTION_0_PROPERTY,
	GEARY_SMTP_CLIENT_CONNECTION_CAPABILITIES_PROPERTY,
	GEARY_SMTP_CLIENT_CONNECTION_LOGGING_PARENT_PROPERTY,
	GEARY_SMTP_CLIENT_CONNECTION_NUM_PROPERTIES
};
static GParamSpec* geary_smtp_client_connection_properties[GEARY_SMTP_CLIENT_CONNECTION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _geary_smtp_response_unref0(var) ((var == NULL) ? NULL : (var = (geary_smtp_response_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _GearySmtpClientConnectionConnectAsyncData GearySmtpClientConnectionConnectAsyncData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _GearySmtpClientConnectionDisconnectAsyncData GearySmtpClientConnectionDisconnectAsyncData;
#define _geary_smtp_request_unref0(var) ((var == NULL) ? NULL : (var = (geary_smtp_request_unref (var), NULL)))
typedef struct _GearySmtpClientConnectionAuthenticateAsyncData GearySmtpClientConnectionAuthenticateAsyncData;
typedef struct _GearySmtpClientConnectionSendDataAsyncData GearySmtpClientConnectionSendDataAsyncData;
typedef struct _GearySmtpClientConnectionSendRequestAsyncData GearySmtpClientConnectionSendRequestAsyncData;
#define _geary_smtp_response_line_unref0(var) ((var == NULL) ? NULL : (var = (geary_smtp_response_line_unref (var), NULL)))
typedef struct _GearySmtpClientConnectionRecvResponseLinesAsyncData GearySmtpClientConnectionRecvResponseLinesAsyncData;
typedef struct _GearySmtpClientConnectionRecvResponseAsyncData GearySmtpClientConnectionRecvResponseAsyncData;
typedef struct _GearySmtpClientConnectionSayHelloAsyncData GearySmtpClientConnectionSayHelloAsyncData;
typedef struct _GearySmtpClientConnectionEstablishConnectionAsyncData GearySmtpClientConnectionEstablishConnectionAsyncData;
typedef struct _GearySmtpClientConnectionQuitAsyncData GearySmtpClientConnectionQuitAsyncData;
typedef struct _GearySmtpClientConnectionTransactionAsyncData GearySmtpClientConnectionTransactionAsyncData;
typedef struct _GearySmtpClientConnectionReadLineAsyncData GearySmtpClientConnectionReadLineAsyncData;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GearySmtpClientConnection {
	GearyBaseObject parent_instance;
	GearySmtpClientConnectionPrivate * priv;
};

struct _GearySmtpClientConnectionClass {
	GearyBaseObjectClass parent_class;
	GearyLoggingState* (*to_logging_state) (GearySmtpClientConnection* self);
};

struct _GearySmtpClientConnectionPrivate {
	GearySmtpCapabilities* _capabilities;
	GearyLoggingSource* _logging_parent;
	GearyEndpoint* endpoint;
	GIOStream* cx;
	GSocketConnection* socket_cx;
	GDataInputStream* dins;
	GDataOutputStream* douts;
};

struct _GearySmtpClientConnectionConnectAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearySmtpClientConnection* self;
	GCancellable* cancellable;
	GearySmtpGreeting* result;
	GIOStream* _tmp0_;
	GSocketConnection* _tmp1_;
	GearyEndpoint* _tmp2_;
	GSocketConnection* _tmp3_;
	GSocketConnection* _tmp4_;
	GSocketConnection* _tmp5_;
	GIOStream* _tmp6_;
	GIOStream* _tmp7_;
	GeeList* _tmp8_;
	GeeList* _tmp9_;
	GearySmtpGreeting* greeting;
	GearySmtpGreeting* _tmp10_;
	GearySmtpGreeting* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GError* _inner_error0_;
};

struct _GearySmtpClientConnectionDisconnectAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearySmtpClientConnection* self;
	GCancellable* cancellable;
	gboolean result;
	GIOStream* _tmp0_;
	GError* disconnect_error;
	GIOStream* _tmp1_;
	GError* err;
	GError* _tmp2_;
	GError* _tmp3_;
	GError* _tmp4_;
	GError* _tmp5_;
	GError* _tmp6_;
	GError* _inner_error0_;
};

struct _GearySmtpClientConnectionAuthenticateAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearySmtpClientConnection* self;
	GearySmtpAuthenticator* authenticator;
	GCancellable* cancellable;
	GearySmtpResponse* result;
	GearySmtpResponse* response;
	GearySmtpRequest* _tmp0_;
	GearySmtpRequest* _tmp1_;
	GearySmtpResponse* _tmp2_;
	GearySmtpResponse* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gint step;
	GearySmtpResponse* _tmp6_;
	GearySmtpResponseCode* _tmp7_;
	GearySmtpResponseCode* _tmp8_;
	GearyMemoryBuffer* data;
	gint _tmp9_;
	GearySmtpResponse* _tmp10_;
	GearyMemoryBuffer* _tmp11_;
	gboolean _tmp12_;
	GearyMemoryBuffer* _tmp13_;
	GearyMemoryBuffer* _tmp14_;
	gsize _tmp15_;
	gsize _tmp16_;
	GearyMemoryStringBuffer* _tmp17_;
	GDataOutputStream* _tmp18_;
	GearyMemoryBuffer* _tmp19_;
	GDataOutputStream* _tmp20_;
	GDataOutputStream* _tmp21_;
	GearySmtpResponse* _tmp22_;
	GearySmtpResponse* _tmp23_;
	GearySmtpResponse* _tmp24_;
	GError* _inner_error0_;
};

struct _GearySmtpClientConnectionSendDataAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearySmtpClientConnection* self;
	GearyMemoryBuffer* data;
	GCancellable* cancellable;
	GearySmtpResponse* result;
	GearySmtpResponse* response;
	GearySmtpRequest* _tmp0_;
	GearySmtpRequest* _tmp1_;
	GearySmtpResponse* _tmp2_;
	GearySmtpResponse* _tmp3_;
	GearySmtpResponse* _tmp4_;
	GearySmtpResponseCode* _tmp5_;
	GearySmtpResponseCode* _tmp6_;
	gsize _tmp7_;
	gsize _tmp8_;
	GDataOutputStream* _tmp9_;
	GDataOutputStream* _tmp10_;
	GDataOutputStream* _tmp11_;
	GearySmtpResponse* _tmp12_;
	GearySmtpResponse* _tmp13_;
	GearySmtpResponse* _tmp14_;
	GError* _inner_error0_;
};

struct _GearySmtpClientConnectionSendRequestAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearySmtpClientConnection* self;
	GearySmtpRequest* request;
	GCancellable* cancellable;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GDataOutputStream* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GDataOutputStream* _tmp5_;
	GDataOutputStream* _tmp6_;
	GError* _inner_error0_;
};

struct _GearySmtpClientConnectionRecvResponseLinesAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearySmtpClientConnection* self;
	GCancellable* cancellable;
	GeeList* result;
	GeeList* lines;
	GeeArrayList* _tmp0_;
	gboolean _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GearySmtpResponseLine* line;
	GearySmtpResponseLine* _tmp4_;
	GeeList* _tmp5_;
	GearySmtpResponseLine* _tmp6_;
	GearySmtpResponseLine* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	GeeList* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	GError* _inner_error0_;
};

struct _GearySmtpClientConnectionRecvResponseAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearySmtpClientConnection* self;
	GCancellable* cancellable;
	GearySmtpResponse* result;
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	GearySmtpResponse* response;
	GearySmtpResponse* _tmp2_;
	GearySmtpResponse* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GError* _inner_error0_;
};

struct _GearySmtpClientConnectionSayHelloAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearySmtpClientConnection* self;
	GCancellable* cancellable;
	GearySmtpResponse* result;
	GSocketAddress* _tmp0_;
	GSocketConnection* _tmp1_;
	GSocketAddress* _tmp2_;
	GInetAddress* local_addr;
	GInetAddress* _tmp3_;
	GInetAddress* _tmp4_;
	gchar* fqdn;
	gboolean _tmp5_;
	gboolean _tmp6_;
	GInetAddress* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	GInetAddress* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	GInetAddress* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	gchar* _tmp16_;
	GResolver* _tmp17_;
	GResolver* _tmp18_;
	GInetAddress* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	GError* err;
	GInetAddress* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	GError* _tmp26_;
	const gchar* _tmp27_;
	gboolean _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	const gchar* _tmp31_;
	GearySmtpEhloRequest* _tmp32_;
	const gchar* _tmp33_;
	const gchar* _tmp34_;
	GearySmtpEhloRequest* _tmp35_;
	GInetAddress* _tmp36_;
	GearySmtpEhloRequest* _tmp37_;
	GearySmtpEhloRequest* ehlo;
	GearySmtpEhloRequest* _tmp38_;
	GearySmtpResponse* response;
	GearySmtpEhloRequest* _tmp39_;
	GearySmtpResponse* _tmp40_;
	GearySmtpResponse* _tmp41_;
	GearySmtpResponseCode* _tmp42_;
	GearySmtpResponseCode* _tmp43_;
	GearySmtpCapabilities* _tmp44_;
	GearySmtpCapabilities* _tmp45_;
	GearySmtpCapabilities* _tmp46_;
	GearySmtpResponse* _tmp47_;
	gchar* first_response;
	GearySmtpResponse* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	GearySmtpHeloRequest* _tmp53_;
	const gchar* _tmp54_;
	const gchar* _tmp55_;
	GearySmtpHeloRequest* _tmp56_;
	GInetAddress* _tmp57_;
	GearySmtpHeloRequest* _tmp58_;
	GearySmtpHeloRequest* helo;
	GearySmtpHeloRequest* _tmp59_;
	GearySmtpResponse* _tmp60_;
	GearySmtpHeloRequest* _tmp61_;
	GearySmtpResponse* _tmp62_;
	GearySmtpResponse* _tmp63_;
	GearySmtpResponse* _tmp64_;
	GearySmtpResponseCode* _tmp65_;
	GearySmtpResponseCode* _tmp66_;
	const gchar* _tmp67_;
	GearySmtpResponse* _tmp68_;
	gchar* _tmp69_;
	gchar* _tmp70_;
	gchar* _tmp71_;
	gchar* _tmp72_;
	GError* _tmp73_;
	GError* _tmp74_;
	GError* _inner_error0_;
};

struct _GearySmtpClientConnectionEstablishConnectionAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearySmtpClientConnection* self;
	GCancellable* cancellable;
	GearySmtpResponse* result;
	GearySmtpResponse* response;
	GearySmtpResponse* _tmp0_;
	GearyEndpoint* _tmp1_;
	GearyTlsNegotiationMethod _tmp2_;
	GearyTlsNegotiationMethod _tmp3_;
	GearySmtpCapabilities* _tmp4_;
	GearyEndpoint* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GError* _tmp8_;
	GError* _tmp9_;
	GearySmtpResponse* starttls_response;
	GearySmtpRequest* _tmp10_;
	GearySmtpRequest* _tmp11_;
	GearySmtpResponse* _tmp12_;
	GearySmtpResponse* _tmp13_;
	GearySmtpResponse* _tmp14_;
	GearySmtpResponseCode* _tmp15_;
	GearySmtpResponseCode* _tmp16_;
	GearySmtpResponse* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	GError* _tmp20_;
	GError* _tmp21_;
	GTlsClientConnection* tls_cx;
	GearyEndpoint* _tmp22_;
	GIOStream* _tmp23_;
	GTlsClientConnection* _tmp24_;
	GTlsClientConnection* _tmp25_;
	GIOStream* _tmp26_;
	GTlsClientConnection* _tmp27_;
	GearySmtpResponse* _tmp28_;
	GearySmtpResponse* _tmp29_;
	GearySmtpResponse* _tmp30_;
	GError* _inner_error0_;
};

struct _GearySmtpClientConnectionQuitAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearySmtpClientConnection* self;
	GCancellable* cancellable;
	GearySmtpResponse* result;
	GearySmtpResponse* _tmp0_;
	GearySmtpRequest* _tmp1_;
	GearySmtpRequest* _tmp2_;
	GearySmtpResponse* _tmp3_;
	GearySmtpResponse* _tmp4_;
	GearySmtpResponse* _tmp5_;
	GError* _inner_error0_;
};

struct _GearySmtpClientConnectionTransactionAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearySmtpClientConnection* self;
	GearySmtpRequest* request;
	GCancellable* cancellable;
	GearySmtpResponse* result;
	GearySmtpResponse* _tmp0_;
	GearySmtpResponse* _tmp1_;
	GearySmtpResponse* _tmp2_;
	GError* _inner_error0_;
};

struct _GearySmtpClientConnectionReadLineAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearySmtpClientConnection* self;
	GCancellable* cancellable;
	gchar* result;
	gsize length;
	gchar* line;
	GDataInputStream* _tmp0_;
	gsize _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GError* _tmp6_;
	GError* _tmp7_;
	GError* _inner_error0_;
};

static gint GearySmtpClientConnection_private_offset;
static gpointer geary_smtp_client_connection_parent_class = NULL;
static GearyLoggingSourceIface * geary_smtp_client_connection_geary_logging_source_parent_iface = NULL;

VALA_EXTERN GType geary_smtp_client_connection_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GearyLoggingState* geary_smtp_client_connection_to_logging_state (GearySmtpClientConnection* self);
VALA_EXTERN GearySmtpCapabilities* geary_smtp_client_connection_get_capabilities (GearySmtpClientConnection* self);
static void geary_smtp_client_connection_set_capabilities (GearySmtpClientConnection* self,
                                                    GearySmtpCapabilities* value);
VALA_EXTERN GearySmtpClientConnection* geary_smtp_client_connection_new (GearyEndpoint* endpoint);
VALA_EXTERN GearySmtpClientConnection* geary_smtp_client_connection_construct (GType object_type,
                                                                   GearyEndpoint* endpoint);
VALA_EXTERN gboolean geary_smtp_client_connection_is_connected (GearySmtpClientConnection* self);
static void geary_smtp_client_connection_connect_async_data_free (gpointer _data);
VALA_EXTERN void geary_smtp_client_connection_connect_async (GearySmtpClientConnection* self,
                                                 GCancellable* cancellable,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
VALA_EXTERN GearySmtpGreeting* geary_smtp_client_connection_connect_finish (GearySmtpClientConnection* self,
                                                                GAsyncResult* _res_,
                                                                GError** error);
static gboolean geary_smtp_client_connection_connect_async_co (GearySmtpClientConnectionConnectAsyncData* _data_);
static void geary_smtp_client_connection_connect_async_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_);
static void geary_smtp_client_connection_set_data_streams (GearySmtpClientConnection* self,
                                                    GIOStream* stream);
static void geary_smtp_client_connection_recv_response_lines_async (GearySmtpClientConnection* self,
                                                             GCancellable* cancellable,
                                                             GAsyncReadyCallback _callback_,
                                                             gpointer _user_data_);
static GeeList* geary_smtp_client_connection_recv_response_lines_finish (GearySmtpClientConnection* self,
                                                                  GAsyncResult* _res_,
                                                                  GError** error);
static void geary_smtp_client_connection_disconnect_async_data_free (gpointer _data);
VALA_EXTERN void geary_smtp_client_connection_disconnect_async (GearySmtpClientConnection* self,
                                                    GCancellable* cancellable,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_);
VALA_EXTERN gboolean geary_smtp_client_connection_disconnect_finish (GearySmtpClientConnection* self,
                                                         GAsyncResult* _res_,
                                                         GError** error);
static gboolean geary_smtp_client_connection_disconnect_async_co (GearySmtpClientConnectionDisconnectAsyncData* _data_);
static void geary_smtp_client_connection_disconnect_async_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_);
static void geary_smtp_client_connection_authenticate_async_data_free (gpointer _data);
VALA_EXTERN void geary_smtp_client_connection_authenticate_async (GearySmtpClientConnection* self,
                                                      GearySmtpAuthenticator* authenticator,
                                                      GCancellable* cancellable,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_);
VALA_EXTERN GearySmtpResponse* geary_smtp_client_connection_authenticate_finish (GearySmtpClientConnection* self,
                                                                     GAsyncResult* _res_,
                                                                     GError** error);
static gboolean geary_smtp_client_connection_authenticate_async_co (GearySmtpClientConnectionAuthenticateAsyncData* _data_);
static void geary_smtp_client_connection_check_connected (GearySmtpClientConnection* self,
                                                   GError** error);
VALA_EXTERN void geary_smtp_client_connection_transaction_async (GearySmtpClientConnection* self,
                                                     GearySmtpRequest* request,
                                                     GCancellable* cancellable,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_);
VALA_EXTERN GearySmtpResponse* geary_smtp_client_connection_transaction_finish (GearySmtpClientConnection* self,
                                                                    GAsyncResult* _res_,
                                                                    GError** error);
static void geary_smtp_client_connection_authenticate_async_ready (GObject* source_object,
                                                            GAsyncResult* _res_,
                                                            gpointer _user_data_);
VALA_EXTERN void geary_smtp_client_connection_recv_response_async (GearySmtpClientConnection* self,
                                                       GCancellable* cancellable,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_);
VALA_EXTERN GearySmtpResponse* geary_smtp_client_connection_recv_response_finish (GearySmtpClientConnection* self,
                                                                      GAsyncResult* _res_,
                                                                      GError** error);
static void geary_smtp_client_connection_send_data_async_data_free (gpointer _data);
VALA_EXTERN void geary_smtp_client_connection_send_data_async (GearySmtpClientConnection* self,
                                                   GearyMemoryBuffer* data,
                                                   GCancellable* cancellable,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
VALA_EXTERN GearySmtpResponse* geary_smtp_client_connection_send_data_finish (GearySmtpClientConnection* self,
                                                                  GAsyncResult* _res_,
                                                                  GError** error);
static gboolean geary_smtp_client_connection_send_data_async_co (GearySmtpClientConnectionSendDataAsyncData* _data_);
static void geary_smtp_client_connection_send_data_async_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_);
static void geary_smtp_client_connection_send_request_async_data_free (gpointer _data);
VALA_EXTERN void geary_smtp_client_connection_send_request_async (GearySmtpClientConnection* self,
                                                      GearySmtpRequest* request,
                                                      GCancellable* cancellable,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_);
VALA_EXTERN void geary_smtp_client_connection_send_request_finish (GearySmtpClientConnection* self,
                                                       GAsyncResult* _res_,
                                                       GError** error);
static gboolean geary_smtp_client_connection_send_request_async_co (GearySmtpClientConnectionSendRequestAsyncData* _data_);
static void geary_smtp_client_connection_send_request_async_ready (GObject* source_object,
                                                            GAsyncResult* _res_,
                                                            gpointer _user_data_);
static void geary_smtp_client_connection_recv_response_lines_async_data_free (gpointer _data);
static gboolean geary_smtp_client_connection_recv_response_lines_async_co (GearySmtpClientConnectionRecvResponseLinesAsyncData* _data_);
static void geary_smtp_client_connection_read_line_async (GearySmtpClientConnection* self,
                                                   GCancellable* cancellable,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
static gchar* geary_smtp_client_connection_read_line_finish (GearySmtpClientConnection* self,
                                                      GAsyncResult* _res_,
                                                      GError** error);
static void geary_smtp_client_connection_recv_response_lines_async_ready (GObject* source_object,
                                                                   GAsyncResult* _res_,
                                                                   gpointer _user_data_);
static void geary_smtp_client_connection_recv_response_async_data_free (gpointer _data);
static gboolean geary_smtp_client_connection_recv_response_async_co (GearySmtpClientConnectionRecvResponseAsyncData* _data_);
static void geary_smtp_client_connection_recv_response_async_ready (GObject* source_object,
                                                             GAsyncResult* _res_,
                                                             gpointer _user_data_);
static void geary_smtp_client_connection_say_hello_async_data_free (gpointer _data);
VALA_EXTERN void geary_smtp_client_connection_say_hello_async (GearySmtpClientConnection* self,
                                                   GCancellable* cancellable,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
VALA_EXTERN GearySmtpResponse* geary_smtp_client_connection_say_hello_finish (GearySmtpClientConnection* self,
                                                                  GAsyncResult* _res_,
                                                                  GError** error);
static gboolean geary_smtp_client_connection_say_hello_async_co (GearySmtpClientConnectionSayHelloAsyncData* _data_);
static void geary_smtp_client_connection_say_hello_async_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_);
static void geary_smtp_client_connection_establish_connection_async_data_free (gpointer _data);
VALA_EXTERN void geary_smtp_client_connection_establish_connection_async (GearySmtpClientConnection* self,
                                                              GCancellable* cancellable,
                                                              GAsyncReadyCallback _callback_,
                                                              gpointer _user_data_);
VALA_EXTERN GearySmtpResponse* geary_smtp_client_connection_establish_connection_finish (GearySmtpClientConnection* self,
                                                                             GAsyncResult* _res_,
                                                                             GError** error);
static gboolean geary_smtp_client_connection_establish_connection_async_co (GearySmtpClientConnectionEstablishConnectionAsyncData* _data_);
static void geary_smtp_client_connection_establish_connection_async_ready (GObject* source_object,
                                                                    GAsyncResult* _res_,
                                                                    gpointer _user_data_);
static void geary_smtp_client_connection_quit_async_data_free (gpointer _data);
VALA_EXTERN void geary_smtp_client_connection_quit_async (GearySmtpClientConnection* self,
                                              GCancellable* cancellable,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
VALA_EXTERN GearySmtpResponse* geary_smtp_client_connection_quit_finish (GearySmtpClientConnection* self,
                                                             GAsyncResult* _res_,
                                                             GError** error);
static gboolean geary_smtp_client_connection_quit_async_co (GearySmtpClientConnectionQuitAsyncData* _data_);
static void geary_smtp_client_connection_quit_async_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_);
static void geary_smtp_client_connection_transaction_async_data_free (gpointer _data);
static gboolean geary_smtp_client_connection_transaction_async_co (GearySmtpClientConnectionTransactionAsyncData* _data_);
static void geary_smtp_client_connection_transaction_async_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_);
static void geary_smtp_client_connection_read_line_async_data_free (gpointer _data);
static gboolean geary_smtp_client_connection_read_line_async_co (GearySmtpClientConnectionReadLineAsyncData* _data_);
static void geary_smtp_client_connection_read_line_async_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_);
static GearyLoggingState* geary_smtp_client_connection_real_to_logging_state (GearySmtpClientConnection* self);
VALA_EXTERN void geary_smtp_client_connection_set_logging_parent (GearySmtpClientConnection* self,
                                                      GearyLoggingSource* parent);
static void geary_smtp_client_connection_finalize (GObject * obj);
static GType geary_smtp_client_connection_get_type_once (void);
static void _vala_geary_smtp_client_connection_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_geary_smtp_client_connection_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);

static inline gpointer
geary_smtp_client_connection_get_instance_private (GearySmtpClientConnection* self)
{
	return G_STRUCT_MEMBER_P (self, GearySmtpClientConnection_private_offset);
}

GearySmtpCapabilities*
geary_smtp_client_connection_get_capabilities (GearySmtpClientConnection* self)
{
	GearySmtpCapabilities* result;
	GearySmtpCapabilities* _tmp0_;
#line 16 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_val_if_fail (GEARY_SMTP_IS_CLIENT_CONNECTION (self), NULL);
#line 16 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp0_ = self->priv->_capabilities;
#line 16 "../src/engine/smtp/smtp-client-connection.vala"
	result = _tmp0_;
#line 16 "../src/engine/smtp/smtp-client-connection.vala"
	return result;
#line 656 "smtp-client-connection.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 16 "../src/engine/smtp/smtp-client-connection.vala"
	return self ? g_object_ref (self) : NULL;
#line 664 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_set_capabilities (GearySmtpClientConnection* self,
                                               GearySmtpCapabilities* value)
{
	GearySmtpCapabilities* old_value;
#line 16 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_CONNECTION (self));
#line 16 "../src/engine/smtp/smtp-client-connection.vala"
	old_value = geary_smtp_client_connection_get_capabilities (self);
#line 16 "../src/engine/smtp/smtp-client-connection.vala"
	if (old_value != value) {
#line 678 "smtp-client-connection.c"
		GearySmtpCapabilities* _tmp0_;
#line 16 "../src/engine/smtp/smtp-client-connection.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 16 "../src/engine/smtp/smtp-client-connection.vala"
		_g_object_unref0 (self->priv->_capabilities);
#line 16 "../src/engine/smtp/smtp-client-connection.vala"
		self->priv->_capabilities = _tmp0_;
#line 16 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_smtp_client_connection_properties[GEARY_SMTP_CLIENT_CONNECTION_CAPABILITIES_PROPERTY]);
#line 688 "smtp-client-connection.c"
	}
}

static const gchar*
geary_smtp_client_connection_real_get_logging_domain (GearyLoggingSource* base)
{
	const gchar* result;
	GearySmtpClientConnection* self;
#line 20 "../src/engine/smtp/smtp-client-connection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_SMTP_TYPE_CLIENT_CONNECTION, GearySmtpClientConnection);
#line 20 "../src/engine/smtp/smtp-client-connection.vala"
	result = GEARY_SMTP_CLIENT_SERVICE_PROTOCOL_LOGGING_DOMAIN;
#line 20 "../src/engine/smtp/smtp-client-connection.vala"
	return result;
#line 703 "smtp-client-connection.c"
}

static GearyLoggingSource*
geary_smtp_client_connection_real_get_logging_parent (GearyLoggingSource* base)
{
	GearyLoggingSource* result;
	GearySmtpClientConnection* self;
	GearyLoggingSource* _tmp0_;
#line 24 "../src/engine/smtp/smtp-client-connection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_SMTP_TYPE_CLIENT_CONNECTION, GearySmtpClientConnection);
#line 24 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp0_ = self->priv->_logging_parent;
#line 24 "../src/engine/smtp/smtp-client-connection.vala"
	result = _tmp0_;
#line 24 "../src/engine/smtp/smtp-client-connection.vala"
	return result;
#line 720 "smtp-client-connection.c"
}

GearySmtpClientConnection*
geary_smtp_client_connection_construct (GType object_type,
                                        GearyEndpoint* endpoint)
{
	GearySmtpClientConnection * self = NULL;
	GearyEndpoint* _tmp0_;
#line 33 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (endpoint), NULL);
#line 33 "../src/engine/smtp/smtp-client-connection.vala"
	self = (GearySmtpClientConnection*) geary_base_object_construct (object_type);
#line 34 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp0_ = _g_object_ref0 (endpoint);
#line 34 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (self->priv->endpoint);
#line 34 "../src/engine/smtp/smtp-client-connection.vala"
	self->priv->endpoint = _tmp0_;
#line 33 "../src/engine/smtp/smtp-client-connection.vala"
	return self;
#line 741 "smtp-client-connection.c"
}

GearySmtpClientConnection*
geary_smtp_client_connection_new (GearyEndpoint* endpoint)
{
#line 33 "../src/engine/smtp/smtp-client-connection.vala"
	return geary_smtp_client_connection_construct (GEARY_SMTP_TYPE_CLIENT_CONNECTION, endpoint);
#line 749 "smtp-client-connection.c"
}

gboolean
geary_smtp_client_connection_is_connected (GearySmtpClientConnection* self)
{
	GIOStream* _tmp0_;
	gboolean result;
#line 37 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_val_if_fail (GEARY_SMTP_IS_CLIENT_CONNECTION (self), FALSE);
#line 38 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp0_ = self->priv->cx;
#line 38 "../src/engine/smtp/smtp-client-connection.vala"
	result = _tmp0_ != NULL;
#line 38 "../src/engine/smtp/smtp-client-connection.vala"
	return result;
#line 765 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_connect_async_data_free (gpointer _data)
{
	GearySmtpClientConnectionConnectAsyncData* _data_;
	_data_ = _data;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_geary_smtp_response_unref0 (_data_->result);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_slice_free (GearySmtpClientConnectionConnectAsyncData, _data_);
#line 781 "smtp-client-connection.c"
}

void
geary_smtp_client_connection_connect_async (GearySmtpClientConnection* self,
                                            GCancellable* cancellable,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	GearySmtpClientConnectionConnectAsyncData* _data_;
	GearySmtpClientConnection* _tmp0_;
	GCancellable* _tmp1_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_CONNECTION (self));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = g_slice_new0 (GearySmtpClientConnectionConnectAsyncData);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_client_connection_connect_async_data_free);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->self = _tmp0_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->cancellable = _tmp1_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_connect_async_co (_data_);
#line 815 "smtp-client-connection.c"
}

GearySmtpGreeting*
geary_smtp_client_connection_connect_finish (GearySmtpClientConnection* self,
                                             GAsyncResult* _res_,
                                             GError** error)
{
	GearySmtpGreeting* result;
	GearySmtpClientConnectionConnectAsyncData* _data_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	if (NULL == _data_) {
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		return NULL;
#line 831 "smtp-client-connection.c"
	}
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	result = _data_->result;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->result = NULL;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	return result;
#line 839 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_connect_async_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_)
{
	GearySmtpClientConnectionConnectAsyncData* _data_;
#line 47 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = _user_data_;
#line 47 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_source_object_ = source_object;
#line 47 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_res_ = _res_;
#line 47 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_connect_async_co (_data_);
#line 856 "smtp-client-connection.c"
}

static gboolean
geary_smtp_client_connection_connect_async_co (GearySmtpClientConnectionConnectAsyncData* _data_)
{
#line 41 "../src/engine/smtp/smtp-client-connection.vala"
	switch (_data_->_state_) {
#line 41 "../src/engine/smtp/smtp-client-connection.vala"
		case 0:
#line 866 "smtp-client-connection.c"
		goto _state_0;
#line 41 "../src/engine/smtp/smtp-client-connection.vala"
		case 1:
#line 870 "smtp-client-connection.c"
		goto _state_1;
#line 41 "../src/engine/smtp/smtp-client-connection.vala"
		case 2:
#line 874 "smtp-client-connection.c"
		goto _state_2;
		default:
#line 41 "../src/engine/smtp/smtp-client-connection.vala"
		g_assert_not_reached ();
#line 879 "smtp-client-connection.c"
	}
	_state_0:
#line 42 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp0_ = _data_->self->priv->cx;
#line 42 "../src/engine/smtp/smtp-client-connection.vala"
	if (_data_->_tmp0_ != NULL) {
#line 43 "../src/engine/smtp/smtp-client-connection.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Already connected");
#line 44 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->result = NULL;
#line 44 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 44 "../src/engine/smtp/smtp-client-connection.vala"
		if (_data_->_state_ != 0) {
#line 44 "../src/engine/smtp/smtp-client-connection.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 44 "../src/engine/smtp/smtp-client-connection.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 898 "smtp-client-connection.c"
			}
		}
#line 44 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 44 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 905 "smtp-client-connection.c"
	}
#line 47 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp2_ = _data_->self->priv->endpoint;
#line 47 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_state_ = 1;
#line 47 "../src/engine/smtp/smtp-client-connection.vala"
	geary_endpoint_connect_async (_data_->_tmp2_, _data_->cancellable, geary_smtp_client_connection_connect_async_ready, _data_);
#line 47 "../src/engine/smtp/smtp-client-connection.vala"
	return FALSE;
#line 915 "smtp-client-connection.c"
	_state_1:
#line 47 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp3_ = geary_endpoint_connect_finish (_data_->_tmp2_, _data_->_res_, &_data_->_inner_error0_);
#line 47 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp1_ = _data_->_tmp3_;
#line 47 "../src/engine/smtp/smtp-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 47 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 47 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 47 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 929 "smtp-client-connection.c"
	}
#line 47 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp4_ = _data_->_tmp1_;
#line 47 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp1_ = NULL;
#line 47 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->self->priv->socket_cx);
#line 47 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->self->priv->socket_cx = _data_->_tmp4_;
#line 47 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp5_ = _data_->self->priv->socket_cx;
#line 47 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp5_, g_io_stream_get_type (), GIOStream));
#line 47 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->self->priv->cx);
#line 47 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->self->priv->cx = _data_->_tmp6_;
#line 48 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp7_ = _data_->self->priv->cx;
#line 48 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_set_data_streams (_data_->self, _data_->_tmp7_);
#line 51 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_state_ = 2;
#line 51 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_recv_response_lines_async (_data_->self, _data_->cancellable, geary_smtp_client_connection_connect_async_ready, _data_);
#line 51 "../src/engine/smtp/smtp-client-connection.vala"
	return FALSE;
#line 957 "smtp-client-connection.c"
	_state_2:
#line 51 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp9_ = geary_smtp_client_connection_recv_response_lines_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 51 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp8_ = _data_->_tmp9_;
#line 51 "../src/engine/smtp/smtp-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 51 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 51 "../src/engine/smtp/smtp-client-connection.vala"
		_g_object_unref0 (_data_->_tmp1_);
#line 51 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 51 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 973 "smtp-client-connection.c"
	}
#line 51 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp10_ = geary_smtp_greeting_new (_data_->_tmp8_);
#line 51 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->greeting = _data_->_tmp10_;
#line 52 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp11_ = _data_->greeting;
#line 52 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp12_ = geary_smtp_response_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp11_, GEARY_SMTP_TYPE_RESPONSE, GearySmtpResponse));
#line 52 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp13_ = _data_->_tmp12_;
#line 52 "../src/engine/smtp/smtp-client-connection.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "SMTP Greeting: %s", _data_->_tmp13_);
#line 52 "../src/engine/smtp/smtp-client-connection.vala"
	_g_free0 (_data_->_tmp13_);
#line 54 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->result = _data_->greeting;
#line 54 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->_tmp8_);
#line 54 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->_tmp1_);
#line 54 "../src/engine/smtp/smtp-client-connection.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 54 "../src/engine/smtp/smtp-client-connection.vala"
	if (_data_->_state_ != 0) {
#line 54 "../src/engine/smtp/smtp-client-connection.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 54 "../src/engine/smtp/smtp-client-connection.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1003 "smtp-client-connection.c"
		}
	}
#line 54 "../src/engine/smtp/smtp-client-connection.vala"
	g_object_unref (_data_->_async_result);
#line 54 "../src/engine/smtp/smtp-client-connection.vala"
	return FALSE;
#line 1010 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_disconnect_async_data_free (gpointer _data)
{
	GearySmtpClientConnectionDisconnectAsyncData* _data_;
	_data_ = _data;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_slice_free (GearySmtpClientConnectionDisconnectAsyncData, _data_);
#line 1024 "smtp-client-connection.c"
}

void
geary_smtp_client_connection_disconnect_async (GearySmtpClientConnection* self,
                                               GCancellable* cancellable,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
	GearySmtpClientConnectionDisconnectAsyncData* _data_;
	GearySmtpClientConnection* _tmp0_;
	GCancellable* _tmp1_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_CONNECTION (self));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = g_slice_new0 (GearySmtpClientConnectionDisconnectAsyncData);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_client_connection_disconnect_async_data_free);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->self = _tmp0_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->cancellable = _tmp1_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_disconnect_async_co (_data_);
#line 1058 "smtp-client-connection.c"
}

gboolean
geary_smtp_client_connection_disconnect_finish (GearySmtpClientConnection* self,
                                                GAsyncResult* _res_,
                                                GError** error)
{
	gboolean result;
	GearySmtpClientConnectionDisconnectAsyncData* _data_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	if (NULL == _data_) {
#line 1072 "smtp-client-connection.c"
		gboolean _tmp0_ = FALSE;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		return _tmp0_;
#line 1076 "smtp-client-connection.c"
	}
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	result = _data_->result;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	return result;
#line 1082 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_disconnect_async_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_)
{
	GearySmtpClientConnectionDisconnectAsyncData* _data_;
#line 63 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = _user_data_;
#line 63 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_source_object_ = source_object;
#line 63 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_res_ = _res_;
#line 63 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_disconnect_async_co (_data_);
#line 1099 "smtp-client-connection.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 65 "../src/engine/smtp/smtp-client-connection.vala"
	return self ? g_error_copy (self) : NULL;
#line 1107 "smtp-client-connection.c"
}

static gboolean
geary_smtp_client_connection_disconnect_async_co (GearySmtpClientConnectionDisconnectAsyncData* _data_)
{
#line 57 "../src/engine/smtp/smtp-client-connection.vala"
	switch (_data_->_state_) {
#line 57 "../src/engine/smtp/smtp-client-connection.vala"
		case 0:
#line 1117 "smtp-client-connection.c"
		goto _state_0;
#line 57 "../src/engine/smtp/smtp-client-connection.vala"
		case 1:
#line 1121 "smtp-client-connection.c"
		goto _state_1;
		default:
#line 57 "../src/engine/smtp/smtp-client-connection.vala"
		g_assert_not_reached ();
#line 1126 "smtp-client-connection.c"
	}
	_state_0:
#line 58 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp0_ = _data_->self->priv->cx;
#line 58 "../src/engine/smtp/smtp-client-connection.vala"
	if (_data_->_tmp0_ == NULL) {
#line 59 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->result = FALSE;
#line 59 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 59 "../src/engine/smtp/smtp-client-connection.vala"
		if (_data_->_state_ != 0) {
#line 59 "../src/engine/smtp/smtp-client-connection.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 59 "../src/engine/smtp/smtp-client-connection.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1143 "smtp-client-connection.c"
			}
		}
#line 59 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 59 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 1150 "smtp-client-connection.c"
	}
#line 61 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->disconnect_error = NULL;
#line 1154 "smtp-client-connection.c"
	{
#line 63 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp1_ = _data_->self->priv->cx;
#line 63 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_state_ = 1;
#line 63 "../src/engine/smtp/smtp-client-connection.vala"
		g_io_stream_close_async (_data_->_tmp1_, G_PRIORITY_DEFAULT, _data_->cancellable, geary_smtp_client_connection_disconnect_async_ready, _data_);
#line 63 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 1164 "smtp-client-connection.c"
		_state_1:
#line 63 "../src/engine/smtp/smtp-client-connection.vala"
		g_io_stream_close_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error0_);
#line 63 "../src/engine/smtp/smtp-client-connection.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1170 "smtp-client-connection.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 62 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->err = _data_->_inner_error0_;
#line 62 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_inner_error0_ = NULL;
#line 65 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp2_ = _data_->err;
#line 65 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp3_ = _g_error_copy0 (_data_->_tmp2_);
#line 65 "../src/engine/smtp/smtp-client-connection.vala"
		_g_error_free0 (_data_->disconnect_error);
#line 65 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->disconnect_error = _data_->_tmp3_;
#line 62 "../src/engine/smtp/smtp-client-connection.vala"
		_g_error_free0 (_data_->err);
#line 1191 "smtp-client-connection.c"
	}
	__finally0:
#line 62 "../src/engine/smtp/smtp-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 62 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 62 "../src/engine/smtp/smtp-client-connection.vala"
		_g_error_free0 (_data_->disconnect_error);
#line 62 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 62 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 1204 "smtp-client-connection.c"
	}
#line 68 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->self->priv->cx);
#line 68 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->self->priv->cx = NULL;
#line 70 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp4_ = _data_->disconnect_error;
#line 70 "../src/engine/smtp/smtp-client-connection.vala"
	if (_data_->_tmp4_ != NULL) {
#line 71 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp5_ = _data_->disconnect_error;
#line 71 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp6_ = _g_error_copy0 (_data_->_tmp5_);
#line 71 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_inner_error0_ = _data_->_tmp6_;
#line 71 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 71 "../src/engine/smtp/smtp-client-connection.vala"
		_g_error_free0 (_data_->disconnect_error);
#line 71 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 71 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 1228 "smtp-client-connection.c"
	}
#line 73 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->result = TRUE;
#line 73 "../src/engine/smtp/smtp-client-connection.vala"
	_g_error_free0 (_data_->disconnect_error);
#line 73 "../src/engine/smtp/smtp-client-connection.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 73 "../src/engine/smtp/smtp-client-connection.vala"
	if (_data_->_state_ != 0) {
#line 73 "../src/engine/smtp/smtp-client-connection.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 73 "../src/engine/smtp/smtp-client-connection.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1242 "smtp-client-connection.c"
		}
	}
#line 73 "../src/engine/smtp/smtp-client-connection.vala"
	g_object_unref (_data_->_async_result);
#line 73 "../src/engine/smtp/smtp-client-connection.vala"
	return FALSE;
#line 1249 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_authenticate_async_data_free (gpointer _data)
{
	GearySmtpClientConnectionAuthenticateAsyncData* _data_;
	_data_ = _data;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->authenticator);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_geary_smtp_response_unref0 (_data_->result);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_slice_free (GearySmtpClientConnectionAuthenticateAsyncData, _data_);
#line 1267 "smtp-client-connection.c"
}

void
geary_smtp_client_connection_authenticate_async (GearySmtpClientConnection* self,
                                                 GearySmtpAuthenticator* authenticator,
                                                 GCancellable* cancellable,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_)
{
	GearySmtpClientConnectionAuthenticateAsyncData* _data_;
	GearySmtpClientConnection* _tmp0_;
	GearySmtpAuthenticator* _tmp1_;
	GCancellable* _tmp2_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_CONNECTION (self));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail (GEARY_SMTP_IS_AUTHENTICATOR (authenticator));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = g_slice_new0 (GearySmtpClientConnectionAuthenticateAsyncData);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_client_connection_authenticate_async_data_free);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->self = _tmp0_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp1_ = _g_object_ref0 (authenticator);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->authenticator);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->authenticator = _tmp1_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->cancellable = _tmp2_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_authenticate_async_co (_data_);
#line 1311 "smtp-client-connection.c"
}

GearySmtpResponse*
geary_smtp_client_connection_authenticate_finish (GearySmtpClientConnection* self,
                                                  GAsyncResult* _res_,
                                                  GError** error)
{
	GearySmtpResponse* result;
	GearySmtpClientConnectionAuthenticateAsyncData* _data_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	if (NULL == _data_) {
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		return NULL;
#line 1327 "smtp-client-connection.c"
	}
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	result = _data_->result;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->result = NULL;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	return result;
#line 1335 "smtp-client-connection.c"
}

/**
     * Returns the final Response of the challenge-response.
     */
static void
geary_smtp_client_connection_authenticate_async_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_)
{
	GearySmtpClientConnectionAuthenticateAsyncData* _data_;
#line 83 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = _user_data_;
#line 83 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_source_object_ = source_object;
#line 83 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_res_ = _res_;
#line 83 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_authenticate_async_co (_data_);
#line 1355 "smtp-client-connection.c"
}

static gboolean
geary_smtp_client_connection_authenticate_async_co (GearySmtpClientConnectionAuthenticateAsyncData* _data_)
{
#line 79 "../src/engine/smtp/smtp-client-connection.vala"
	switch (_data_->_state_) {
#line 79 "../src/engine/smtp/smtp-client-connection.vala"
		case 0:
#line 1365 "smtp-client-connection.c"
		goto _state_0;
#line 79 "../src/engine/smtp/smtp-client-connection.vala"
		case 1:
#line 1369 "smtp-client-connection.c"
		goto _state_1;
#line 79 "../src/engine/smtp/smtp-client-connection.vala"
		case 2:
#line 1373 "smtp-client-connection.c"
		goto _state_2;
#line 79 "../src/engine/smtp/smtp-client-connection.vala"
		case 3:
#line 1377 "smtp-client-connection.c"
		goto _state_3;
#line 79 "../src/engine/smtp/smtp-client-connection.vala"
		case 4:
#line 1381 "smtp-client-connection.c"
		goto _state_4;
		default:
#line 79 "../src/engine/smtp/smtp-client-connection.vala"
		g_assert_not_reached ();
#line 1386 "smtp-client-connection.c"
	}
	_state_0:
#line 81 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_check_connected (_data_->self, &_data_->_inner_error0_);
#line 81 "../src/engine/smtp/smtp-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 81 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 81 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 81 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 1399 "smtp-client-connection.c"
	}
#line 83 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp0_ = geary_smtp_authenticator_initiate (_data_->authenticator);
#line 83 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 83 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_state_ = 1;
#line 83 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_transaction_async (_data_->self, _data_->_tmp1_, _data_->cancellable, geary_smtp_client_connection_authenticate_async_ready, _data_);
#line 83 "../src/engine/smtp/smtp-client-connection.vala"
	return FALSE;
#line 1411 "smtp-client-connection.c"
	_state_1:
#line 83 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp2_ = geary_smtp_client_connection_transaction_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 83 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 83 "../src/engine/smtp/smtp-client-connection.vala"
	_geary_smtp_request_unref0 (_data_->_tmp1_);
#line 83 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->response = _data_->_tmp3_;
#line 83 "../src/engine/smtp/smtp-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 83 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 83 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 83 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 1429 "smtp-client-connection.c"
	}
#line 85 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp4_ = geary_smtp_authenticator_to_string (_data_->authenticator);
#line 85 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 85 "../src/engine/smtp/smtp-client-connection.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Initiated SMTP %s authentication", _data_->_tmp5_);
#line 85 "../src/engine/smtp/smtp-client-connection.vala"
	_g_free0 (_data_->_tmp5_);
#line 94 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->step = 0;
#line 95 "../src/engine/smtp/smtp-client-connection.vala"
	while (TRUE) {
#line 95 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp6_ = _data_->response;
#line 95 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp7_ = geary_smtp_response_get_code (_data_->_tmp6_);
#line 95 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 95 "../src/engine/smtp/smtp-client-connection.vala"
		if (!geary_smtp_response_code_is_success_intermediate (_data_->_tmp8_)) {
#line 95 "../src/engine/smtp/smtp-client-connection.vala"
			break;
#line 1453 "smtp-client-connection.c"
		}
#line 96 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp9_ = _data_->step;
#line 96 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->step = _data_->_tmp9_ + 1;
#line 96 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp10_ = _data_->response;
#line 96 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp11_ = geary_smtp_authenticator_challenge (_data_->authenticator, _data_->_tmp9_, _data_->_tmp10_, &_data_->_inner_error0_);
#line 96 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->data = _data_->_tmp11_;
#line 96 "../src/engine/smtp/smtp-client-connection.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 96 "../src/engine/smtp/smtp-client-connection.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 96 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_response_unref0 (_data_->response);
#line 96 "../src/engine/smtp/smtp-client-connection.vala"
			g_object_unref (_data_->_async_result);
#line 96 "../src/engine/smtp/smtp-client-connection.vala"
			return FALSE;
#line 1475 "smtp-client-connection.c"
		}
#line 97 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp13_ = _data_->data;
#line 97 "../src/engine/smtp/smtp-client-connection.vala"
		if (_data_->_tmp13_ == NULL) {
#line 97 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp12_ = TRUE;
#line 1483 "smtp-client-connection.c"
		} else {
#line 97 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp14_ = _data_->data;
#line 97 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp15_ = geary_memory_buffer_get_size (_data_->_tmp14_);
#line 97 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp16_ = _data_->_tmp15_;
#line 97 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp12_ = _data_->_tmp16_ == ((gsize) 0);
#line 1493 "smtp-client-connection.c"
		}
#line 97 "../src/engine/smtp/smtp-client-connection.vala"
		if (_data_->_tmp12_) {
#line 98 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp17_ = geary_memory_string_buffer_new (GEARY_SMTP_DATA_FORMAT_CANCEL_AUTHENTICATION);
#line 98 "../src/engine/smtp/smtp-client-connection.vala"
			_g_object_unref0 (_data_->data);
#line 98 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->data = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp17_, GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBuffer);
#line 1503 "smtp-client-connection.c"
		}
#line 100 "../src/engine/smtp/smtp-client-connection.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "SMTP AUTH Challenge recvd");
#line 102 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp18_ = _data_->self->priv->douts;
#line 102 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp19_ = _data_->data;
#line 102 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_state_ = 2;
#line 102 "../src/engine/smtp/smtp-client-connection.vala"
		geary_stream_write_all_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp18_, g_output_stream_get_type (), GOutputStream), _data_->_tmp19_, _data_->cancellable, geary_smtp_client_connection_authenticate_async_ready, _data_);
#line 102 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 1517 "smtp-client-connection.c"
		_state_2:
#line 102 "../src/engine/smtp/smtp-client-connection.vala"
		geary_stream_write_all_finish (_data_->_res_, &_data_->_inner_error0_);
#line 102 "../src/engine/smtp/smtp-client-connection.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 102 "../src/engine/smtp/smtp-client-connection.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 102 "../src/engine/smtp/smtp-client-connection.vala"
			_g_object_unref0 (_data_->data);
#line 102 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_response_unref0 (_data_->response);
#line 102 "../src/engine/smtp/smtp-client-connection.vala"
			g_object_unref (_data_->_async_result);
#line 102 "../src/engine/smtp/smtp-client-connection.vala"
			return FALSE;
#line 1533 "smtp-client-connection.c"
		}
#line 103 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp20_ = _data_->self->priv->douts;
#line 103 "../src/engine/smtp/smtp-client-connection.vala"
		g_data_output_stream_put_string (_data_->_tmp20_, GEARY_SMTP_DATA_FORMAT_LINE_TERMINATOR, NULL, &_data_->_inner_error0_);
#line 103 "../src/engine/smtp/smtp-client-connection.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 103 "../src/engine/smtp/smtp-client-connection.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 103 "../src/engine/smtp/smtp-client-connection.vala"
			_g_object_unref0 (_data_->data);
#line 103 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_response_unref0 (_data_->response);
#line 103 "../src/engine/smtp/smtp-client-connection.vala"
			g_object_unref (_data_->_async_result);
#line 103 "../src/engine/smtp/smtp-client-connection.vala"
			return FALSE;
#line 1551 "smtp-client-connection.c"
		}
#line 104 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp21_ = _data_->self->priv->douts;
#line 104 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_state_ = 3;
#line 104 "../src/engine/smtp/smtp-client-connection.vala"
		g_output_stream_flush_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp21_, g_output_stream_get_type (), GOutputStream), G_PRIORITY_DEFAULT, _data_->cancellable, geary_smtp_client_connection_authenticate_async_ready, _data_);
#line 104 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 1561 "smtp-client-connection.c"
		_state_3:
#line 104 "../src/engine/smtp/smtp-client-connection.vala"
		g_output_stream_flush_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp21_, g_output_stream_get_type (), GOutputStream), _data_->_res_, &_data_->_inner_error0_);
#line 104 "../src/engine/smtp/smtp-client-connection.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 104 "../src/engine/smtp/smtp-client-connection.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 104 "../src/engine/smtp/smtp-client-connection.vala"
			_g_object_unref0 (_data_->data);
#line 104 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_response_unref0 (_data_->response);
#line 104 "../src/engine/smtp/smtp-client-connection.vala"
			g_object_unref (_data_->_async_result);
#line 104 "../src/engine/smtp/smtp-client-connection.vala"
			return FALSE;
#line 1577 "smtp-client-connection.c"
		}
#line 106 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_state_ = 4;
#line 106 "../src/engine/smtp/smtp-client-connection.vala"
		geary_smtp_client_connection_recv_response_async (_data_->self, _data_->cancellable, geary_smtp_client_connection_authenticate_async_ready, _data_);
#line 106 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 1585 "smtp-client-connection.c"
		_state_4:
#line 106 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp23_ = geary_smtp_client_connection_recv_response_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 106 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp22_ = _data_->_tmp23_;
#line 106 "../src/engine/smtp/smtp-client-connection.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 106 "../src/engine/smtp/smtp-client-connection.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 106 "../src/engine/smtp/smtp-client-connection.vala"
			_g_object_unref0 (_data_->data);
#line 106 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_response_unref0 (_data_->response);
#line 106 "../src/engine/smtp/smtp-client-connection.vala"
			g_object_unref (_data_->_async_result);
#line 106 "../src/engine/smtp/smtp-client-connection.vala"
			return FALSE;
#line 1603 "smtp-client-connection.c"
		}
#line 106 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp24_ = _data_->_tmp22_;
#line 106 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp22_ = NULL;
#line 106 "../src/engine/smtp/smtp-client-connection.vala"
		_geary_smtp_response_unref0 (_data_->response);
#line 106 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->response = _data_->_tmp24_;
#line 95 "../src/engine/smtp/smtp-client-connection.vala"
		_geary_smtp_response_unref0 (_data_->_tmp22_);
#line 95 "../src/engine/smtp/smtp-client-connection.vala"
		_g_object_unref0 (_data_->data);
#line 1617 "smtp-client-connection.c"
	}
#line 109 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->result = _data_->response;
#line 109 "../src/engine/smtp/smtp-client-connection.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 109 "../src/engine/smtp/smtp-client-connection.vala"
	if (_data_->_state_ != 0) {
#line 109 "../src/engine/smtp/smtp-client-connection.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 109 "../src/engine/smtp/smtp-client-connection.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1629 "smtp-client-connection.c"
		}
	}
#line 109 "../src/engine/smtp/smtp-client-connection.vala"
	g_object_unref (_data_->_async_result);
#line 109 "../src/engine/smtp/smtp-client-connection.vala"
	return FALSE;
#line 1636 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_send_data_async_data_free (gpointer _data)
{
	GearySmtpClientConnectionSendDataAsyncData* _data_;
	_data_ = _data;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->data);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_geary_smtp_response_unref0 (_data_->result);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_slice_free (GearySmtpClientConnectionSendDataAsyncData, _data_);
#line 1654 "smtp-client-connection.c"
}

void
geary_smtp_client_connection_send_data_async (GearySmtpClientConnection* self,
                                              GearyMemoryBuffer* data,
                                              GCancellable* cancellable,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	GearySmtpClientConnectionSendDataAsyncData* _data_;
	GearySmtpClientConnection* _tmp0_;
	GearyMemoryBuffer* _tmp1_;
	GCancellable* _tmp2_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_CONNECTION (self));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail (GEARY_MEMORY_IS_BUFFER (data));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = g_slice_new0 (GearySmtpClientConnectionSendDataAsyncData);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_client_connection_send_data_async_data_free);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->self = _tmp0_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp1_ = _g_object_ref0 (data);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->data);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->data = _tmp1_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->cancellable = _tmp2_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_send_data_async_co (_data_);
#line 1698 "smtp-client-connection.c"
}

GearySmtpResponse*
geary_smtp_client_connection_send_data_finish (GearySmtpClientConnection* self,
                                               GAsyncResult* _res_,
                                               GError** error)
{
	GearySmtpResponse* result;
	GearySmtpClientConnectionSendDataAsyncData* _data_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	if (NULL == _data_) {
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		return NULL;
#line 1714 "smtp-client-connection.c"
	}
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	result = _data_->result;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->result = NULL;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	return result;
#line 1722 "smtp-client-connection.c"
}

/**
     * Sends a block of data
     *
     * This first issues a DATA command and transmits the block if the
     * appropriate response is sent.
     *
     * Returns the final Response of the transaction. If the
     * ResponseCode is not a successful completion, the message should
     * not be considered sent.
     */
static void
geary_smtp_client_connection_send_data_async_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_)
{
	GearySmtpClientConnectionSendDataAsyncData* _data_;
#line 128 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = _user_data_;
#line 128 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_source_object_ = source_object;
#line 128 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_res_ = _res_;
#line 128 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_send_data_async_co (_data_);
#line 1749 "smtp-client-connection.c"
}

static gboolean
geary_smtp_client_connection_send_data_async_co (GearySmtpClientConnectionSendDataAsyncData* _data_)
{
#line 122 "../src/engine/smtp/smtp-client-connection.vala"
	switch (_data_->_state_) {
#line 122 "../src/engine/smtp/smtp-client-connection.vala"
		case 0:
#line 1759 "smtp-client-connection.c"
		goto _state_0;
#line 122 "../src/engine/smtp/smtp-client-connection.vala"
		case 1:
#line 1763 "smtp-client-connection.c"
		goto _state_1;
#line 122 "../src/engine/smtp/smtp-client-connection.vala"
		case 2:
#line 1767 "smtp-client-connection.c"
		goto _state_2;
#line 122 "../src/engine/smtp/smtp-client-connection.vala"
		case 3:
#line 1771 "smtp-client-connection.c"
		goto _state_3;
#line 122 "../src/engine/smtp/smtp-client-connection.vala"
		case 4:
#line 1775 "smtp-client-connection.c"
		goto _state_4;
#line 122 "../src/engine/smtp/smtp-client-connection.vala"
		case 5:
#line 1779 "smtp-client-connection.c"
		goto _state_5;
		default:
#line 122 "../src/engine/smtp/smtp-client-connection.vala"
		g_assert_not_reached ();
#line 1784 "smtp-client-connection.c"
	}
	_state_0:
#line 125 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_check_connected (_data_->self, &_data_->_inner_error0_);
#line 125 "../src/engine/smtp/smtp-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 125 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 125 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 125 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 1797 "smtp-client-connection.c"
	}
#line 128 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp0_ = geary_smtp_request_new (GEARY_SMTP_COMMAND_DATA, NULL, 0);
#line 128 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 128 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_state_ = 1;
#line 128 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_transaction_async (_data_->self, _data_->_tmp1_, _data_->cancellable, geary_smtp_client_connection_send_data_async_ready, _data_);
#line 128 "../src/engine/smtp/smtp-client-connection.vala"
	return FALSE;
#line 1809 "smtp-client-connection.c"
	_state_1:
#line 128 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp2_ = geary_smtp_client_connection_transaction_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 128 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 128 "../src/engine/smtp/smtp-client-connection.vala"
	_geary_smtp_request_unref0 (_data_->_tmp1_);
#line 128 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->response = _data_->_tmp3_;
#line 128 "../src/engine/smtp/smtp-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 128 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 128 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 128 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 1827 "smtp-client-connection.c"
	}
#line 129 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp4_ = _data_->response;
#line 129 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp5_ = geary_smtp_response_get_code (_data_->_tmp4_);
#line 129 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 129 "../src/engine/smtp/smtp-client-connection.vala"
	if (geary_smtp_response_code_is_start_data (_data_->_tmp6_)) {
#line 130 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp7_ = geary_memory_buffer_get_size (_data_->data);
#line 130 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 130 "../src/engine/smtp/smtp-client-connection.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "SMTP Data: <%z>", _data_->_tmp8_);
#line 133 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp9_ = _data_->self->priv->douts;
#line 133 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_state_ = 2;
#line 133 "../src/engine/smtp/smtp-client-connection.vala"
		geary_stream_write_all_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp9_, g_output_stream_get_type (), GOutputStream), _data_->data, _data_->cancellable, geary_smtp_client_connection_send_data_async_ready, _data_);
#line 133 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 1851 "smtp-client-connection.c"
		_state_2:
#line 133 "../src/engine/smtp/smtp-client-connection.vala"
		geary_stream_write_all_finish (_data_->_res_, &_data_->_inner_error0_);
#line 133 "../src/engine/smtp/smtp-client-connection.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 133 "../src/engine/smtp/smtp-client-connection.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 133 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_response_unref0 (_data_->response);
#line 133 "../src/engine/smtp/smtp-client-connection.vala"
			g_object_unref (_data_->_async_result);
#line 133 "../src/engine/smtp/smtp-client-connection.vala"
			return FALSE;
#line 1865 "smtp-client-connection.c"
		}
#line 136 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp10_ = _data_->self->priv->douts;
#line 136 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_state_ = 3;
#line 136 "../src/engine/smtp/smtp-client-connection.vala"
		geary_stream_write_string_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp10_, g_output_stream_get_type (), GOutputStream), GEARY_SMTP_DATA_FORMAT_DATA_TERMINATOR, _data_->cancellable, geary_smtp_client_connection_send_data_async_ready, _data_);
#line 136 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 1875 "smtp-client-connection.c"
		_state_3:
#line 136 "../src/engine/smtp/smtp-client-connection.vala"
		geary_stream_write_string_finish (_data_->_res_, &_data_->_inner_error0_);
#line 136 "../src/engine/smtp/smtp-client-connection.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 136 "../src/engine/smtp/smtp-client-connection.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 136 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_response_unref0 (_data_->response);
#line 136 "../src/engine/smtp/smtp-client-connection.vala"
			g_object_unref (_data_->_async_result);
#line 136 "../src/engine/smtp/smtp-client-connection.vala"
			return FALSE;
#line 1889 "smtp-client-connection.c"
		}
#line 139 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp11_ = _data_->self->priv->douts;
#line 139 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_state_ = 4;
#line 139 "../src/engine/smtp/smtp-client-connection.vala"
		g_output_stream_flush_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp11_, g_output_stream_get_type (), GOutputStream), G_PRIORITY_DEFAULT, _data_->cancellable, geary_smtp_client_connection_send_data_async_ready, _data_);
#line 139 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 1899 "smtp-client-connection.c"
		_state_4:
#line 139 "../src/engine/smtp/smtp-client-connection.vala"
		g_output_stream_flush_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp11_, g_output_stream_get_type (), GOutputStream), _data_->_res_, &_data_->_inner_error0_);
#line 139 "../src/engine/smtp/smtp-client-connection.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 139 "../src/engine/smtp/smtp-client-connection.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 139 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_response_unref0 (_data_->response);
#line 139 "../src/engine/smtp/smtp-client-connection.vala"
			g_object_unref (_data_->_async_result);
#line 139 "../src/engine/smtp/smtp-client-connection.vala"
			return FALSE;
#line 1913 "smtp-client-connection.c"
		}
#line 141 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_state_ = 5;
#line 141 "../src/engine/smtp/smtp-client-connection.vala"
		geary_smtp_client_connection_recv_response_async (_data_->self, _data_->cancellable, geary_smtp_client_connection_send_data_async_ready, _data_);
#line 141 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 1921 "smtp-client-connection.c"
		_state_5:
#line 141 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp13_ = geary_smtp_client_connection_recv_response_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 141 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp12_ = _data_->_tmp13_;
#line 141 "../src/engine/smtp/smtp-client-connection.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 141 "../src/engine/smtp/smtp-client-connection.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 141 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_response_unref0 (_data_->response);
#line 141 "../src/engine/smtp/smtp-client-connection.vala"
			g_object_unref (_data_->_async_result);
#line 141 "../src/engine/smtp/smtp-client-connection.vala"
			return FALSE;
#line 1937 "smtp-client-connection.c"
		}
#line 141 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp14_ = _data_->_tmp12_;
#line 141 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp12_ = NULL;
#line 141 "../src/engine/smtp/smtp-client-connection.vala"
		_geary_smtp_response_unref0 (_data_->response);
#line 141 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->response = _data_->_tmp14_;
#line 129 "../src/engine/smtp/smtp-client-connection.vala"
		_geary_smtp_response_unref0 (_data_->_tmp12_);
#line 1949 "smtp-client-connection.c"
	}
#line 143 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->result = _data_->response;
#line 143 "../src/engine/smtp/smtp-client-connection.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 143 "../src/engine/smtp/smtp-client-connection.vala"
	if (_data_->_state_ != 0) {
#line 143 "../src/engine/smtp/smtp-client-connection.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 143 "../src/engine/smtp/smtp-client-connection.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1961 "smtp-client-connection.c"
		}
	}
#line 143 "../src/engine/smtp/smtp-client-connection.vala"
	g_object_unref (_data_->_async_result);
#line 143 "../src/engine/smtp/smtp-client-connection.vala"
	return FALSE;
#line 1968 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_send_request_async_data_free (gpointer _data)
{
	GearySmtpClientConnectionSendRequestAsyncData* _data_;
	_data_ = _data;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_geary_smtp_request_unref0 (_data_->request);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_slice_free (GearySmtpClientConnectionSendRequestAsyncData, _data_);
#line 1984 "smtp-client-connection.c"
}

static gpointer
_geary_smtp_request_ref0 (gpointer self)
{
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	return self ? geary_smtp_request_ref (self) : NULL;
#line 1992 "smtp-client-connection.c"
}

void
geary_smtp_client_connection_send_request_async (GearySmtpClientConnection* self,
                                                 GearySmtpRequest* request,
                                                 GCancellable* cancellable,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_)
{
	GearySmtpClientConnectionSendRequestAsyncData* _data_;
	GearySmtpClientConnection* _tmp0_;
	GearySmtpRequest* _tmp1_;
	GCancellable* _tmp2_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_CONNECTION (self));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail (GEARY_SMTP_IS_REQUEST (request));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = g_slice_new0 (GearySmtpClientConnectionSendRequestAsyncData);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_client_connection_send_request_async_data_free);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->self = _tmp0_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp1_ = _geary_smtp_request_ref0 (request);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_geary_smtp_request_unref0 (_data_->request);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->request = _tmp1_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->cancellable = _tmp2_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_send_request_async_co (_data_);
#line 2036 "smtp-client-connection.c"
}

void
geary_smtp_client_connection_send_request_finish (GearySmtpClientConnection* self,
                                                  GAsyncResult* _res_,
                                                  GError** error)
{
	GearySmtpClientConnectionSendRequestAsyncData* _data_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	if (NULL == _data_) {
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		return;
#line 2051 "smtp-client-connection.c"
	}
}

static void
geary_smtp_client_connection_send_request_async_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_)
{
	GearySmtpClientConnectionSendRequestAsyncData* _data_;
#line 153 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = _user_data_;
#line 153 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_source_object_ = source_object;
#line 153 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_res_ = _res_;
#line 153 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_send_request_async_co (_data_);
#line 2069 "smtp-client-connection.c"
}

static gboolean
geary_smtp_client_connection_send_request_async_co (GearySmtpClientConnectionSendRequestAsyncData* _data_)
{
#line 146 "../src/engine/smtp/smtp-client-connection.vala"
	switch (_data_->_state_) {
#line 146 "../src/engine/smtp/smtp-client-connection.vala"
		case 0:
#line 2079 "smtp-client-connection.c"
		goto _state_0;
#line 146 "../src/engine/smtp/smtp-client-connection.vala"
		case 1:
#line 2083 "smtp-client-connection.c"
		goto _state_1;
		default:
#line 146 "../src/engine/smtp/smtp-client-connection.vala"
		g_assert_not_reached ();
#line 2088 "smtp-client-connection.c"
	}
	_state_0:
#line 147 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_check_connected (_data_->self, &_data_->_inner_error0_);
#line 147 "../src/engine/smtp/smtp-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 147 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 147 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 147 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 2101 "smtp-client-connection.c"
	}
#line 149 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp0_ = geary_smtp_request_to_string (_data_->request);
#line 149 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 149 "../src/engine/smtp/smtp-client-connection.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "SMTP Request: %s", _data_->_tmp1_);
#line 149 "../src/engine/smtp/smtp-client-connection.vala"
	_g_free0 (_data_->_tmp1_);
#line 151 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp2_ = _data_->self->priv->douts;
#line 151 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp3_ = geary_smtp_request_serialize (_data_->request);
#line 151 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 151 "../src/engine/smtp/smtp-client-connection.vala"
	g_data_output_stream_put_string (_data_->_tmp2_, _data_->_tmp4_, NULL, &_data_->_inner_error0_);
#line 151 "../src/engine/smtp/smtp-client-connection.vala"
	_g_free0 (_data_->_tmp4_);
#line 151 "../src/engine/smtp/smtp-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 151 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 151 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 151 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 2129 "smtp-client-connection.c"
	}
#line 152 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp5_ = _data_->self->priv->douts;
#line 152 "../src/engine/smtp/smtp-client-connection.vala"
	g_data_output_stream_put_string (_data_->_tmp5_, GEARY_SMTP_DATA_FORMAT_LINE_TERMINATOR, NULL, &_data_->_inner_error0_);
#line 152 "../src/engine/smtp/smtp-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 152 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 152 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 152 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 2143 "smtp-client-connection.c"
	}
#line 153 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp6_ = _data_->self->priv->douts;
#line 153 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_state_ = 1;
#line 153 "../src/engine/smtp/smtp-client-connection.vala"
	g_output_stream_flush_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, g_output_stream_get_type (), GOutputStream), G_PRIORITY_DEFAULT, _data_->cancellable, geary_smtp_client_connection_send_request_async_ready, _data_);
#line 153 "../src/engine/smtp/smtp-client-connection.vala"
	return FALSE;
#line 2153 "smtp-client-connection.c"
	_state_1:
#line 153 "../src/engine/smtp/smtp-client-connection.vala"
	g_output_stream_flush_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, g_output_stream_get_type (), GOutputStream), _data_->_res_, &_data_->_inner_error0_);
#line 153 "../src/engine/smtp/smtp-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 153 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 153 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 153 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 2165 "smtp-client-connection.c"
	}
#line 146 "../src/engine/smtp/smtp-client-connection.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 146 "../src/engine/smtp/smtp-client-connection.vala"
	if (_data_->_state_ != 0) {
#line 146 "../src/engine/smtp/smtp-client-connection.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 146 "../src/engine/smtp/smtp-client-connection.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2175 "smtp-client-connection.c"
		}
	}
#line 146 "../src/engine/smtp/smtp-client-connection.vala"
	g_object_unref (_data_->_async_result);
#line 146 "../src/engine/smtp/smtp-client-connection.vala"
	return FALSE;
#line 2182 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_recv_response_lines_async_data_free (gpointer _data)
{
	GearySmtpClientConnectionRecvResponseLinesAsyncData* _data_;
	_data_ = _data;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->result);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_slice_free (GearySmtpClientConnectionRecvResponseLinesAsyncData, _data_);
#line 2198 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_recv_response_lines_async (GearySmtpClientConnection* self,
                                                        GCancellable* cancellable,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_)
{
	GearySmtpClientConnectionRecvResponseLinesAsyncData* _data_;
	GearySmtpClientConnection* _tmp0_;
	GCancellable* _tmp1_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_CONNECTION (self));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = g_slice_new0 (GearySmtpClientConnectionRecvResponseLinesAsyncData);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_client_connection_recv_response_lines_async_data_free);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->self = _tmp0_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->cancellable = _tmp1_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_recv_response_lines_async_co (_data_);
#line 2232 "smtp-client-connection.c"
}

static GeeList*
geary_smtp_client_connection_recv_response_lines_finish (GearySmtpClientConnection* self,
                                                         GAsyncResult* _res_,
                                                         GError** error)
{
	GeeList* result;
	GearySmtpClientConnectionRecvResponseLinesAsyncData* _data_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	if (NULL == _data_) {
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		return NULL;
#line 2248 "smtp-client-connection.c"
	}
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	result = _data_->result;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->result = NULL;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	return result;
#line 2256 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_recv_response_lines_async_ready (GObject* source_object,
                                                              GAsyncResult* _res_,
                                                              gpointer _user_data_)
{
	GearySmtpClientConnectionRecvResponseLinesAsyncData* _data_;
#line 161 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = _user_data_;
#line 161 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_source_object_ = source_object;
#line 161 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_res_ = _res_;
#line 161 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_recv_response_lines_async_co (_data_);
#line 2273 "smtp-client-connection.c"
}

static gboolean
geary_smtp_client_connection_recv_response_lines_async_co (GearySmtpClientConnectionRecvResponseLinesAsyncData* _data_)
{
#line 156 "../src/engine/smtp/smtp-client-connection.vala"
	switch (_data_->_state_) {
#line 156 "../src/engine/smtp/smtp-client-connection.vala"
		case 0:
#line 2283 "smtp-client-connection.c"
		goto _state_0;
#line 156 "../src/engine/smtp/smtp-client-connection.vala"
		case 1:
#line 2287 "smtp-client-connection.c"
		goto _state_1;
		default:
#line 156 "../src/engine/smtp/smtp-client-connection.vala"
		g_assert_not_reached ();
#line 2292 "smtp-client-connection.c"
	}
	_state_0:
#line 157 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_check_connected (_data_->self, &_data_->_inner_error0_);
#line 157 "../src/engine/smtp/smtp-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 157 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 157 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 157 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 2305 "smtp-client-connection.c"
	}
#line 159 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp0_ = gee_array_list_new (GEARY_SMTP_TYPE_RESPONSE_LINE, (GBoxedCopyFunc) geary_smtp_response_line_ref, (GDestroyNotify) geary_smtp_response_line_unref, NULL, NULL, NULL);
#line 159 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->lines = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEE_TYPE_LIST, GeeList);
#line 2311 "smtp-client-connection.c"
	{
#line 160 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp1_ = TRUE;
#line 160 "../src/engine/smtp/smtp-client-connection.vala"
		while (TRUE) {
#line 160 "../src/engine/smtp/smtp-client-connection.vala"
			if (!_data_->_tmp1_) {
#line 2319 "smtp-client-connection.c"
			}
#line 160 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp1_ = FALSE;
#line 161 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_state_ = 1;
#line 161 "../src/engine/smtp/smtp-client-connection.vala"
			geary_smtp_client_connection_read_line_async (_data_->self, _data_->cancellable, geary_smtp_client_connection_recv_response_lines_async_ready, _data_);
#line 161 "../src/engine/smtp/smtp-client-connection.vala"
			return FALSE;
#line 2329 "smtp-client-connection.c"
			_state_1:
#line 161 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp3_ = geary_smtp_client_connection_read_line_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 161 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp2_ = _data_->_tmp3_;
#line 161 "../src/engine/smtp/smtp-client-connection.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 161 "../src/engine/smtp/smtp-client-connection.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 161 "../src/engine/smtp/smtp-client-connection.vala"
				_g_object_unref0 (_data_->lines);
#line 161 "../src/engine/smtp/smtp-client-connection.vala"
				g_object_unref (_data_->_async_result);
#line 161 "../src/engine/smtp/smtp-client-connection.vala"
				return FALSE;
#line 2345 "smtp-client-connection.c"
			}
#line 161 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp4_ = geary_smtp_response_line_deserialize (_data_->_tmp2_, &_data_->_inner_error0_);
#line 161 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->line = _data_->_tmp4_;
#line 161 "../src/engine/smtp/smtp-client-connection.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 161 "../src/engine/smtp/smtp-client-connection.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 161 "../src/engine/smtp/smtp-client-connection.vala"
				_g_free0 (_data_->_tmp2_);
#line 161 "../src/engine/smtp/smtp-client-connection.vala"
				_g_object_unref0 (_data_->lines);
#line 161 "../src/engine/smtp/smtp-client-connection.vala"
				g_object_unref (_data_->_async_result);
#line 161 "../src/engine/smtp/smtp-client-connection.vala"
				return FALSE;
#line 2363 "smtp-client-connection.c"
			}
#line 162 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp5_ = _data_->lines;
#line 162 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp6_ = _data_->line;
#line 162 "../src/engine/smtp/smtp-client-connection.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp5_, GEE_TYPE_COLLECTION, GeeCollection), _data_->_tmp6_);
#line 164 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp7_ = _data_->line;
#line 164 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp8_ = geary_smtp_response_line_get_continued (_data_->_tmp7_);
#line 164 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp9_ = _data_->_tmp8_;
#line 164 "../src/engine/smtp/smtp-client-connection.vala"
			if (!_data_->_tmp9_) {
#line 165 "../src/engine/smtp/smtp-client-connection.vala"
				_geary_smtp_response_line_unref0 (_data_->line);
#line 165 "../src/engine/smtp/smtp-client-connection.vala"
				_g_free0 (_data_->_tmp2_);
#line 165 "../src/engine/smtp/smtp-client-connection.vala"
				break;
#line 2385 "smtp-client-connection.c"
			}
#line 160 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_response_line_unref0 (_data_->line);
#line 160 "../src/engine/smtp/smtp-client-connection.vala"
			_g_free0 (_data_->_tmp2_);
#line 2391 "smtp-client-connection.c"
		}
	}
#line 169 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp10_ = _data_->lines;
#line 169 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp11_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp10_, GEE_TYPE_COLLECTION, GeeCollection));
#line 169 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 169 "../src/engine/smtp/smtp-client-connection.vala"
	_vala_assert (_data_->_tmp12_ > 0, "lines.size > 0");
#line 171 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->result = _data_->lines;
#line 171 "../src/engine/smtp/smtp-client-connection.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 171 "../src/engine/smtp/smtp-client-connection.vala"
	if (_data_->_state_ != 0) {
#line 171 "../src/engine/smtp/smtp-client-connection.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 171 "../src/engine/smtp/smtp-client-connection.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2412 "smtp-client-connection.c"
		}
	}
#line 171 "../src/engine/smtp/smtp-client-connection.vala"
	g_object_unref (_data_->_async_result);
#line 171 "../src/engine/smtp/smtp-client-connection.vala"
	return FALSE;
#line 2419 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_recv_response_async_data_free (gpointer _data)
{
	GearySmtpClientConnectionRecvResponseAsyncData* _data_;
	_data_ = _data;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_geary_smtp_response_unref0 (_data_->result);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_slice_free (GearySmtpClientConnectionRecvResponseAsyncData, _data_);
#line 2435 "smtp-client-connection.c"
}

void
geary_smtp_client_connection_recv_response_async (GearySmtpClientConnection* self,
                                                  GCancellable* cancellable,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_)
{
	GearySmtpClientConnectionRecvResponseAsyncData* _data_;
	GearySmtpClientConnection* _tmp0_;
	GCancellable* _tmp1_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_CONNECTION (self));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = g_slice_new0 (GearySmtpClientConnectionRecvResponseAsyncData);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_client_connection_recv_response_async_data_free);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->self = _tmp0_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->cancellable = _tmp1_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_recv_response_async_co (_data_);
#line 2469 "smtp-client-connection.c"
}

GearySmtpResponse*
geary_smtp_client_connection_recv_response_finish (GearySmtpClientConnection* self,
                                                   GAsyncResult* _res_,
                                                   GError** error)
{
	GearySmtpResponse* result;
	GearySmtpClientConnectionRecvResponseAsyncData* _data_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	if (NULL == _data_) {
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		return NULL;
#line 2485 "smtp-client-connection.c"
	}
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	result = _data_->result;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->result = NULL;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	return result;
#line 2493 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_recv_response_async_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_)
{
	GearySmtpClientConnectionRecvResponseAsyncData* _data_;
#line 175 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = _user_data_;
#line 175 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_source_object_ = source_object;
#line 175 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_res_ = _res_;
#line 175 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_recv_response_async_co (_data_);
#line 2510 "smtp-client-connection.c"
}

static gboolean
geary_smtp_client_connection_recv_response_async_co (GearySmtpClientConnectionRecvResponseAsyncData* _data_)
{
#line 174 "../src/engine/smtp/smtp-client-connection.vala"
	switch (_data_->_state_) {
#line 174 "../src/engine/smtp/smtp-client-connection.vala"
		case 0:
#line 2520 "smtp-client-connection.c"
		goto _state_0;
#line 174 "../src/engine/smtp/smtp-client-connection.vala"
		case 1:
#line 2524 "smtp-client-connection.c"
		goto _state_1;
		default:
#line 174 "../src/engine/smtp/smtp-client-connection.vala"
		g_assert_not_reached ();
#line 2529 "smtp-client-connection.c"
	}
	_state_0:
#line 175 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_state_ = 1;
#line 175 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_recv_response_lines_async (_data_->self, _data_->cancellable, geary_smtp_client_connection_recv_response_async_ready, _data_);
#line 175 "../src/engine/smtp/smtp-client-connection.vala"
	return FALSE;
#line 2538 "smtp-client-connection.c"
	_state_1:
#line 175 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp1_ = geary_smtp_client_connection_recv_response_lines_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 175 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp0_ = _data_->_tmp1_;
#line 175 "../src/engine/smtp/smtp-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 175 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 175 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 175 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 2552 "smtp-client-connection.c"
	}
#line 175 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp2_ = geary_smtp_response_new (_data_->_tmp0_);
#line 175 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->response = _data_->_tmp2_;
#line 176 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp3_ = _data_->response;
#line 176 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp4_ = geary_smtp_response_to_string (_data_->_tmp3_);
#line 176 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 176 "../src/engine/smtp/smtp-client-connection.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "SMTP Response: %s", _data_->_tmp5_);
#line 176 "../src/engine/smtp/smtp-client-connection.vala"
	_g_free0 (_data_->_tmp5_);
#line 177 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->result = _data_->response;
#line 177 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->_tmp0_);
#line 177 "../src/engine/smtp/smtp-client-connection.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 177 "../src/engine/smtp/smtp-client-connection.vala"
	if (_data_->_state_ != 0) {
#line 177 "../src/engine/smtp/smtp-client-connection.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 177 "../src/engine/smtp/smtp-client-connection.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2580 "smtp-client-connection.c"
		}
	}
#line 177 "../src/engine/smtp/smtp-client-connection.vala"
	g_object_unref (_data_->_async_result);
#line 177 "../src/engine/smtp/smtp-client-connection.vala"
	return FALSE;
#line 2587 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_say_hello_async_data_free (gpointer _data)
{
	GearySmtpClientConnectionSayHelloAsyncData* _data_;
	_data_ = _data;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_geary_smtp_response_unref0 (_data_->result);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_slice_free (GearySmtpClientConnectionSayHelloAsyncData, _data_);
#line 2603 "smtp-client-connection.c"
}

void
geary_smtp_client_connection_say_hello_async (GearySmtpClientConnection* self,
                                              GCancellable* cancellable,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	GearySmtpClientConnectionSayHelloAsyncData* _data_;
	GearySmtpClientConnection* _tmp0_;
	GCancellable* _tmp1_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_CONNECTION (self));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = g_slice_new0 (GearySmtpClientConnectionSayHelloAsyncData);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_client_connection_say_hello_async_data_free);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->self = _tmp0_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->cancellable = _tmp1_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_say_hello_async_co (_data_);
#line 2637 "smtp-client-connection.c"
}

GearySmtpResponse*
geary_smtp_client_connection_say_hello_finish (GearySmtpClientConnection* self,
                                               GAsyncResult* _res_,
                                               GError** error)
{
	GearySmtpResponse* result;
	GearySmtpClientConnectionSayHelloAsyncData* _data_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	if (NULL == _data_) {
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		return NULL;
#line 2653 "smtp-client-connection.c"
	}
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	result = _data_->result;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->result = NULL;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	return result;
#line 2661 "smtp-client-connection.c"
}

/**
     * Sends the appropriate HELO/EHLO command and returns the response of the one that worked.
     * Also saves the server's capabilities in the capabilities property (overwriting any that may
     * already be present).
     */
static void
geary_smtp_client_connection_say_hello_async_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_)
{
	GearySmtpClientConnectionSayHelloAsyncData* _data_;
#line 195 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = _user_data_;
#line 195 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_source_object_ = source_object;
#line 195 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_res_ = _res_;
#line 195 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_say_hello_async_co (_data_);
#line 2683 "smtp-client-connection.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 2702 "smtp-client-connection.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 2723 "smtp-client-connection.c"
}

static gboolean
geary_smtp_client_connection_say_hello_async_co (GearySmtpClientConnectionSayHelloAsyncData* _data_)
{
#line 185 "../src/engine/smtp/smtp-client-connection.vala"
	switch (_data_->_state_) {
#line 185 "../src/engine/smtp/smtp-client-connection.vala"
		case 0:
#line 2733 "smtp-client-connection.c"
		goto _state_0;
#line 185 "../src/engine/smtp/smtp-client-connection.vala"
		case 1:
#line 2737 "smtp-client-connection.c"
		goto _state_1;
#line 185 "../src/engine/smtp/smtp-client-connection.vala"
		case 2:
#line 2741 "smtp-client-connection.c"
		goto _state_2;
#line 185 "../src/engine/smtp/smtp-client-connection.vala"
		case 3:
#line 2745 "smtp-client-connection.c"
		goto _state_3;
		default:
#line 185 "../src/engine/smtp/smtp-client-connection.vala"
		g_assert_not_reached ();
#line 2750 "smtp-client-connection.c"
	}
	_state_0:
#line 188 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp1_ = _data_->self->priv->socket_cx;
#line 188 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp2_ = g_socket_connection_get_local_address (_data_->_tmp1_, &_data_->_inner_error0_);
#line 188 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp0_ = _data_->_tmp2_;
#line 188 "../src/engine/smtp/smtp-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 188 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 188 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 188 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 2767 "smtp-client-connection.c"
	}
#line 188 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp3_ = g_inet_socket_address_get_address (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, g_inet_socket_address_get_type (), GInetSocketAddress));
#line 188 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp4_ = _g_object_ref0 (_data_->_tmp3_);
#line 188 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->local_addr = _data_->_tmp4_;
#line 192 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->fqdn = NULL;
#line 193 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp7_ = _data_->local_addr;
#line 193 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp8_ = g_inet_address_get_is_link_local (_data_->_tmp7_);
#line 193 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp9_ = _data_->_tmp8_;
#line 193 "../src/engine/smtp/smtp-client-connection.vala"
	if (!_data_->_tmp9_) {
#line 193 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp10_ = _data_->local_addr;
#line 193 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp11_ = g_inet_address_get_is_loopback (_data_->_tmp10_);
#line 193 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp12_ = _data_->_tmp11_;
#line 193 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp6_ = !_data_->_tmp12_;
#line 2793 "smtp-client-connection.c"
	} else {
#line 193 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp6_ = FALSE;
#line 2797 "smtp-client-connection.c"
	}
#line 193 "../src/engine/smtp/smtp-client-connection.vala"
	if (_data_->_tmp6_) {
#line 193 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp13_ = _data_->local_addr;
#line 193 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp14_ = g_inet_address_get_is_site_local (_data_->_tmp13_);
#line 193 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 193 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp5_ = !_data_->_tmp15_;
#line 2809 "smtp-client-connection.c"
	} else {
#line 193 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp5_ = FALSE;
#line 2813 "smtp-client-connection.c"
	}
#line 193 "../src/engine/smtp/smtp-client-connection.vala"
	if (_data_->_tmp5_) {
#line 2817 "smtp-client-connection.c"
		{
#line 195 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp17_ = g_resolver_get_default ();
#line 195 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp18_ = _data_->_tmp17_;
#line 195 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp19_ = _data_->local_addr;
#line 195 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_state_ = 1;
#line 195 "../src/engine/smtp/smtp-client-connection.vala"
			g_resolver_lookup_by_address_async (_data_->_tmp18_, _data_->_tmp19_, _data_->cancellable, geary_smtp_client_connection_say_hello_async_ready, _data_);
#line 195 "../src/engine/smtp/smtp-client-connection.vala"
			return FALSE;
#line 2831 "smtp-client-connection.c"
			_state_1:
#line 195 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp20_ = g_resolver_lookup_by_address_finish (_data_->_tmp18_, _data_->_res_, &_data_->_inner_error0_);
#line 195 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp21_ = _data_->_tmp20_;
#line 195 "../src/engine/smtp/smtp-client-connection.vala"
			_g_object_unref0 (_data_->_tmp18_);
#line 195 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp16_ = _data_->_tmp21_;
#line 195 "../src/engine/smtp/smtp-client-connection.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2843 "smtp-client-connection.c"
				goto __catch0_g_error;
			}
#line 195 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp22_ = _data_->_tmp16_;
#line 195 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp16_ = NULL;
#line 195 "../src/engine/smtp/smtp-client-connection.vala"
			_g_free0 (_data_->fqdn);
#line 195 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->fqdn = _data_->_tmp22_;
#line 194 "../src/engine/smtp/smtp-client-connection.vala"
			_g_free0 (_data_->_tmp16_);
#line 2856 "smtp-client-connection.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 194 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->err = _data_->_inner_error0_;
#line 194 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_inner_error0_ = NULL;
#line 197 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp23_ = _data_->local_addr;
#line 197 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp24_ = g_inet_address_to_string (_data_->_tmp23_);
#line 197 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp25_ = _data_->_tmp24_;
#line 197 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp26_ = _data_->err;
#line 197 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp27_ = _data_->_tmp26_->message;
#line 197 "../src/engine/smtp/smtp-client-connection.vala"
			geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Unable to lookup local address for %s: %s", _data_->_tmp25_, _data_->_tmp27_);
#line 197 "../src/engine/smtp/smtp-client-connection.vala"
			_g_free0 (_data_->_tmp25_);
#line 194 "../src/engine/smtp/smtp-client-connection.vala"
			_g_error_free0 (_data_->err);
#line 2881 "smtp-client-connection.c"
		}
		__finally0:
#line 194 "../src/engine/smtp/smtp-client-connection.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 194 "../src/engine/smtp/smtp-client-connection.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 194 "../src/engine/smtp/smtp-client-connection.vala"
			_g_free0 (_data_->fqdn);
#line 194 "../src/engine/smtp/smtp-client-connection.vala"
			_g_object_unref0 (_data_->local_addr);
#line 194 "../src/engine/smtp/smtp-client-connection.vala"
			_g_object_unref0 (_data_->_tmp0_);
#line 194 "../src/engine/smtp/smtp-client-connection.vala"
			g_object_unref (_data_->_async_result);
#line 194 "../src/engine/smtp/smtp-client-connection.vala"
			return FALSE;
#line 2898 "smtp-client-connection.c"
		}
	}
#line 202 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp29_ = _data_->fqdn;
#line 202 "../src/engine/smtp/smtp-client-connection.vala"
	if (!geary_string_is_empty (_data_->_tmp29_)) {
#line 202 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp30_ = _data_->fqdn;
#line 202 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp28_ = !string_contains (_data_->_tmp30_, ".");
#line 2909 "smtp-client-connection.c"
	} else {
#line 202 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp28_ = FALSE;
#line 2913 "smtp-client-connection.c"
	}
#line 202 "../src/engine/smtp/smtp-client-connection.vala"
	if (_data_->_tmp28_) {
#line 203 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp31_ = _data_->fqdn;
#line 203 "../src/engine/smtp/smtp-client-connection.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Ignoring hostname, because it is not a FQDN: %s", _data_->_tmp31_);
#line 204 "../src/engine/smtp/smtp-client-connection.vala"
		_g_free0 (_data_->fqdn);
#line 204 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->fqdn = NULL;
#line 2925 "smtp-client-connection.c"
	}
#line 208 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp33_ = _data_->fqdn;
#line 208 "../src/engine/smtp/smtp-client-connection.vala"
	if (!geary_string_is_empty (_data_->_tmp33_)) {
#line 208 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp34_ = _data_->fqdn;
#line 208 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp35_ = geary_smtp_ehlo_request_new (_data_->_tmp34_);
#line 208 "../src/engine/smtp/smtp-client-connection.vala"
		_geary_smtp_request_unref0 (_data_->_tmp32_);
#line 208 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp32_ = _data_->_tmp35_;
#line 2939 "smtp-client-connection.c"
	} else {
#line 208 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp36_ = _data_->local_addr;
#line 208 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp37_ = geary_smtp_ehlo_request_new_for_local_address (_data_->_tmp36_);
#line 208 "../src/engine/smtp/smtp-client-connection.vala"
		_geary_smtp_request_unref0 (_data_->_tmp32_);
#line 208 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp32_ = _data_->_tmp37_;
#line 2949 "smtp-client-connection.c"
	}
#line 208 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp38_ = _geary_smtp_request_ref0 (_data_->_tmp32_);
#line 208 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->ehlo = _data_->_tmp38_;
#line 209 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp39_ = _data_->ehlo;
#line 209 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_state_ = 2;
#line 209 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_transaction_async (_data_->self, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp39_, GEARY_SMTP_TYPE_REQUEST, GearySmtpRequest), _data_->cancellable, geary_smtp_client_connection_say_hello_async_ready, _data_);
#line 209 "../src/engine/smtp/smtp-client-connection.vala"
	return FALSE;
#line 2963 "smtp-client-connection.c"
	_state_2:
#line 209 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp40_ = geary_smtp_client_connection_transaction_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 209 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->response = _data_->_tmp40_;
#line 209 "../src/engine/smtp/smtp-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 209 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 209 "../src/engine/smtp/smtp-client-connection.vala"
		_geary_smtp_request_unref0 (_data_->ehlo);
#line 209 "../src/engine/smtp/smtp-client-connection.vala"
		_geary_smtp_request_unref0 (_data_->_tmp32_);
#line 209 "../src/engine/smtp/smtp-client-connection.vala"
		_g_free0 (_data_->fqdn);
#line 209 "../src/engine/smtp/smtp-client-connection.vala"
		_g_object_unref0 (_data_->local_addr);
#line 209 "../src/engine/smtp/smtp-client-connection.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 209 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 209 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 2987 "smtp-client-connection.c"
	}
#line 210 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp41_ = _data_->response;
#line 210 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp42_ = geary_smtp_response_get_code (_data_->_tmp41_);
#line 210 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp43_ = _data_->_tmp42_;
#line 210 "../src/engine/smtp/smtp-client-connection.vala"
	if (geary_smtp_response_code_is_success_completed (_data_->_tmp43_)) {
#line 212 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp44_ = geary_smtp_capabilities_new ();
#line 212 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp45_ = _data_->_tmp44_;
#line 212 "../src/engine/smtp/smtp-client-connection.vala"
		geary_smtp_client_connection_set_capabilities (_data_->self, _data_->_tmp45_);
#line 212 "../src/engine/smtp/smtp-client-connection.vala"
		_g_object_unref0 (_data_->_tmp45_);
#line 213 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp46_ = _data_->self->priv->_capabilities;
#line 213 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp47_ = _data_->response;
#line 213 "../src/engine/smtp/smtp-client-connection.vala"
		geary_smtp_capabilities_add_ehlo_response (_data_->_tmp46_, _data_->_tmp47_);
#line 3011 "smtp-client-connection.c"
	} else {
#line 215 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp48_ = _data_->response;
#line 215 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp49_ = geary_smtp_response_to_string (_data_->_tmp48_);
#line 215 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp50_ = _data_->_tmp49_;
#line 215 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp51_ = string_strip (_data_->_tmp50_);
#line 215 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp52_ = _data_->_tmp51_;
#line 215 "../src/engine/smtp/smtp-client-connection.vala"
		_g_free0 (_data_->_tmp50_);
#line 215 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->first_response = _data_->_tmp52_;
#line 216 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp54_ = _data_->fqdn;
#line 216 "../src/engine/smtp/smtp-client-connection.vala"
		if (!geary_string_is_empty (_data_->_tmp54_)) {
#line 216 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp55_ = _data_->fqdn;
#line 216 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp56_ = geary_smtp_helo_request_new (_data_->_tmp55_);
#line 216 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_request_unref0 (_data_->_tmp53_);
#line 216 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp53_ = _data_->_tmp56_;
#line 3039 "smtp-client-connection.c"
		} else {
#line 216 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp57_ = _data_->local_addr;
#line 216 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp58_ = geary_smtp_helo_request_new_for_local_address (_data_->_tmp57_);
#line 216 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_request_unref0 (_data_->_tmp53_);
#line 216 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp53_ = _data_->_tmp58_;
#line 3049 "smtp-client-connection.c"
		}
#line 216 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp59_ = _geary_smtp_request_ref0 (_data_->_tmp53_);
#line 216 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->helo = _data_->_tmp59_;
#line 217 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp61_ = _data_->helo;
#line 217 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_state_ = 3;
#line 217 "../src/engine/smtp/smtp-client-connection.vala"
		geary_smtp_client_connection_transaction_async (_data_->self, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp61_, GEARY_SMTP_TYPE_REQUEST, GearySmtpRequest), _data_->cancellable, geary_smtp_client_connection_say_hello_async_ready, _data_);
#line 217 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 3063 "smtp-client-connection.c"
		_state_3:
#line 217 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp62_ = geary_smtp_client_connection_transaction_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 217 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp60_ = _data_->_tmp62_;
#line 217 "../src/engine/smtp/smtp-client-connection.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 217 "../src/engine/smtp/smtp-client-connection.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 217 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_request_unref0 (_data_->helo);
#line 217 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_request_unref0 (_data_->_tmp53_);
#line 217 "../src/engine/smtp/smtp-client-connection.vala"
			_g_free0 (_data_->first_response);
#line 217 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_response_unref0 (_data_->response);
#line 217 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_request_unref0 (_data_->ehlo);
#line 217 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_request_unref0 (_data_->_tmp32_);
#line 217 "../src/engine/smtp/smtp-client-connection.vala"
			_g_free0 (_data_->fqdn);
#line 217 "../src/engine/smtp/smtp-client-connection.vala"
			_g_object_unref0 (_data_->local_addr);
#line 217 "../src/engine/smtp/smtp-client-connection.vala"
			_g_object_unref0 (_data_->_tmp0_);
#line 217 "../src/engine/smtp/smtp-client-connection.vala"
			g_object_unref (_data_->_async_result);
#line 217 "../src/engine/smtp/smtp-client-connection.vala"
			return FALSE;
#line 3095 "smtp-client-connection.c"
		}
#line 217 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp63_ = _data_->_tmp60_;
#line 217 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp60_ = NULL;
#line 217 "../src/engine/smtp/smtp-client-connection.vala"
		_geary_smtp_response_unref0 (_data_->response);
#line 217 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->response = _data_->_tmp63_;
#line 218 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp64_ = _data_->response;
#line 218 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp65_ = geary_smtp_response_get_code (_data_->_tmp64_);
#line 218 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp66_ = _data_->_tmp65_;
#line 218 "../src/engine/smtp/smtp-client-connection.vala"
		if (!geary_smtp_response_code_is_success_completed (_data_->_tmp66_)) {
#line 219 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp67_ = _data_->first_response;
#line 219 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp68_ = _data_->response;
#line 219 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp69_ = geary_smtp_response_to_string (_data_->_tmp68_);
#line 219 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp70_ = _data_->_tmp69_;
#line 219 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp71_ = string_strip (_data_->_tmp70_);
#line 219 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp72_ = _data_->_tmp71_;
#line 219 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp73_ = g_error_new (GEARY_SMTP_ERROR, GEARY_SMTP_ERROR_SERVER_ERROR, "Refused service: \"%s\" and \"%s\"", _data_->_tmp67_, _data_->_tmp72_);
#line 219 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp74_ = _data_->_tmp73_;
#line 219 "../src/engine/smtp/smtp-client-connection.vala"
			_g_free0 (_data_->_tmp72_);
#line 219 "../src/engine/smtp/smtp-client-connection.vala"
			_g_free0 (_data_->_tmp70_);
#line 219 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_inner_error0_ = _data_->_tmp74_;
#line 219 "../src/engine/smtp/smtp-client-connection.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 219 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_response_unref0 (_data_->_tmp60_);
#line 219 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_request_unref0 (_data_->helo);
#line 219 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_request_unref0 (_data_->_tmp53_);
#line 219 "../src/engine/smtp/smtp-client-connection.vala"
			_g_free0 (_data_->first_response);
#line 219 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_response_unref0 (_data_->response);
#line 219 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_request_unref0 (_data_->ehlo);
#line 219 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_request_unref0 (_data_->_tmp32_);
#line 219 "../src/engine/smtp/smtp-client-connection.vala"
			_g_free0 (_data_->fqdn);
#line 219 "../src/engine/smtp/smtp-client-connection.vala"
			_g_object_unref0 (_data_->local_addr);
#line 219 "../src/engine/smtp/smtp-client-connection.vala"
			_g_object_unref0 (_data_->_tmp0_);
#line 219 "../src/engine/smtp/smtp-client-connection.vala"
			g_object_unref (_data_->_async_result);
#line 219 "../src/engine/smtp/smtp-client-connection.vala"
			return FALSE;
#line 3161 "smtp-client-connection.c"
		}
#line 210 "../src/engine/smtp/smtp-client-connection.vala"
		_geary_smtp_response_unref0 (_data_->_tmp60_);
#line 210 "../src/engine/smtp/smtp-client-connection.vala"
		_geary_smtp_request_unref0 (_data_->helo);
#line 210 "../src/engine/smtp/smtp-client-connection.vala"
		_geary_smtp_request_unref0 (_data_->_tmp53_);
#line 210 "../src/engine/smtp/smtp-client-connection.vala"
		_g_free0 (_data_->first_response);
#line 3171 "smtp-client-connection.c"
	}
#line 224 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->result = _data_->response;
#line 224 "../src/engine/smtp/smtp-client-connection.vala"
	_geary_smtp_request_unref0 (_data_->ehlo);
#line 224 "../src/engine/smtp/smtp-client-connection.vala"
	_geary_smtp_request_unref0 (_data_->_tmp32_);
#line 224 "../src/engine/smtp/smtp-client-connection.vala"
	_g_free0 (_data_->fqdn);
#line 224 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->local_addr);
#line 224 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->_tmp0_);
#line 224 "../src/engine/smtp/smtp-client-connection.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 224 "../src/engine/smtp/smtp-client-connection.vala"
	if (_data_->_state_ != 0) {
#line 224 "../src/engine/smtp/smtp-client-connection.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 224 "../src/engine/smtp/smtp-client-connection.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3193 "smtp-client-connection.c"
		}
	}
#line 224 "../src/engine/smtp/smtp-client-connection.vala"
	g_object_unref (_data_->_async_result);
#line 224 "../src/engine/smtp/smtp-client-connection.vala"
	return FALSE;
#line 3200 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_establish_connection_async_data_free (gpointer _data)
{
	GearySmtpClientConnectionEstablishConnectionAsyncData* _data_;
	_data_ = _data;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_geary_smtp_response_unref0 (_data_->result);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_slice_free (GearySmtpClientConnectionEstablishConnectionAsyncData, _data_);
#line 3216 "smtp-client-connection.c"
}

void
geary_smtp_client_connection_establish_connection_async (GearySmtpClientConnection* self,
                                                         GCancellable* cancellable,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_)
{
	GearySmtpClientConnectionEstablishConnectionAsyncData* _data_;
	GearySmtpClientConnection* _tmp0_;
	GCancellable* _tmp1_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_CONNECTION (self));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = g_slice_new0 (GearySmtpClientConnectionEstablishConnectionAsyncData);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_client_connection_establish_connection_async_data_free);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->self = _tmp0_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->cancellable = _tmp1_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_establish_connection_async_co (_data_);
#line 3250 "smtp-client-connection.c"
}

GearySmtpResponse*
geary_smtp_client_connection_establish_connection_finish (GearySmtpClientConnection* self,
                                                          GAsyncResult* _res_,
                                                          GError** error)
{
	GearySmtpResponse* result;
	GearySmtpClientConnectionEstablishConnectionAsyncData* _data_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	if (NULL == _data_) {
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		return NULL;
#line 3266 "smtp-client-connection.c"
	}
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	result = _data_->result;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->result = NULL;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	return result;
#line 3274 "smtp-client-connection.c"
}

/**
     * Sends the appropriate hello command to the server (EHLO / HELO) and establishes whatever
     * additional connection features are available (STARTTLS, compression).  For general-purpose
     * use, this is the preferred method for establishing a session with a server, as it will do
     * whatever is necessary to ensure quality-of-service and security.
     *
     * Note that this does *not* connect to the server; connect_async() should be used before
     * calling this method.
     *
     * Returns the Response of the final hello command (there may be more than one).
     */
static void
geary_smtp_client_connection_establish_connection_async_ready (GObject* source_object,
                                                               GAsyncResult* _res_,
                                                               gpointer _user_data_)
{
	GearySmtpClientConnectionEstablishConnectionAsyncData* _data_;
#line 242 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = _user_data_;
#line 242 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_source_object_ = source_object;
#line 242 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_res_ = _res_;
#line 242 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_establish_connection_async_co (_data_);
#line 3302 "smtp-client-connection.c"
}

static gboolean
geary_smtp_client_connection_establish_connection_async_co (GearySmtpClientConnectionEstablishConnectionAsyncData* _data_)
{
#line 238 "../src/engine/smtp/smtp-client-connection.vala"
	switch (_data_->_state_) {
#line 238 "../src/engine/smtp/smtp-client-connection.vala"
		case 0:
#line 3312 "smtp-client-connection.c"
		goto _state_0;
#line 238 "../src/engine/smtp/smtp-client-connection.vala"
		case 1:
#line 3316 "smtp-client-connection.c"
		goto _state_1;
#line 238 "../src/engine/smtp/smtp-client-connection.vala"
		case 2:
#line 3320 "smtp-client-connection.c"
		goto _state_2;
#line 238 "../src/engine/smtp/smtp-client-connection.vala"
		case 3:
#line 3324 "smtp-client-connection.c"
		goto _state_3;
#line 238 "../src/engine/smtp/smtp-client-connection.vala"
		case 4:
#line 3328 "smtp-client-connection.c"
		goto _state_4;
		default:
#line 238 "../src/engine/smtp/smtp-client-connection.vala"
		g_assert_not_reached ();
#line 3333 "smtp-client-connection.c"
	}
	_state_0:
#line 239 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_check_connected (_data_->self, &_data_->_inner_error0_);
#line 239 "../src/engine/smtp/smtp-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 239 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 239 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 239 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 3346 "smtp-client-connection.c"
	}
#line 242 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_state_ = 1;
#line 242 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_say_hello_async (_data_->self, _data_->cancellable, geary_smtp_client_connection_establish_connection_async_ready, _data_);
#line 242 "../src/engine/smtp/smtp-client-connection.vala"
	return FALSE;
#line 3354 "smtp-client-connection.c"
	_state_1:
#line 242 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp0_ = geary_smtp_client_connection_say_hello_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 242 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->response = _data_->_tmp0_;
#line 242 "../src/engine/smtp/smtp-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 242 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 242 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 242 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 3368 "smtp-client-connection.c"
	}
#line 245 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp1_ = _data_->self->priv->endpoint;
#line 245 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp2_ = geary_endpoint_get_tls_method (_data_->_tmp1_);
#line 245 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 245 "../src/engine/smtp/smtp-client-connection.vala"
	if (_data_->_tmp3_ == GEARY_TLS_NEGOTIATION_METHOD_START_TLS) {
#line 246 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp4_ = _data_->self->priv->_capabilities;
#line 246 "../src/engine/smtp/smtp-client-connection.vala"
		if (!geary_generic_capabilities_has_capability (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp4_, GEARY_TYPE_GENERIC_CAPABILITIES, GearyGenericCapabilities), GEARY_SMTP_CAPABILITIES_STARTTLS)) {
#line 247 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp5_ = _data_->self->priv->endpoint;
#line 247 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp6_ = geary_endpoint_to_string (_data_->_tmp5_);
#line 247 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp7_ = _data_->_tmp6_;
#line 247 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp8_ = g_error_new (GEARY_SMTP_ERROR, GEARY_SMTP_ERROR_NOT_SUPPORTED, "STARTTLS not available for %s", _data_->_tmp7_);
#line 247 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp9_ = _data_->_tmp8_;
#line 247 "../src/engine/smtp/smtp-client-connection.vala"
			_g_free0 (_data_->_tmp7_);
#line 247 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_inner_error0_ = _data_->_tmp9_;
#line 247 "../src/engine/smtp/smtp-client-connection.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 247 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_response_unref0 (_data_->response);
#line 247 "../src/engine/smtp/smtp-client-connection.vala"
			g_object_unref (_data_->_async_result);
#line 247 "../src/engine/smtp/smtp-client-connection.vala"
			return FALSE;
#line 3404 "smtp-client-connection.c"
		}
#line 252 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp10_ = geary_smtp_request_new (GEARY_SMTP_COMMAND_STARTTLS, NULL, 0);
#line 252 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp11_ = _data_->_tmp10_;
#line 252 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_state_ = 2;
#line 252 "../src/engine/smtp/smtp-client-connection.vala"
		geary_smtp_client_connection_transaction_async (_data_->self, _data_->_tmp11_, NULL, geary_smtp_client_connection_establish_connection_async_ready, _data_);
#line 252 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 3416 "smtp-client-connection.c"
		_state_2:
#line 252 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp12_ = geary_smtp_client_connection_transaction_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 252 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp13_ = _data_->_tmp12_;
#line 252 "../src/engine/smtp/smtp-client-connection.vala"
		_geary_smtp_request_unref0 (_data_->_tmp11_);
#line 252 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->starttls_response = _data_->_tmp13_;
#line 252 "../src/engine/smtp/smtp-client-connection.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 252 "../src/engine/smtp/smtp-client-connection.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 252 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_response_unref0 (_data_->response);
#line 252 "../src/engine/smtp/smtp-client-connection.vala"
			g_object_unref (_data_->_async_result);
#line 252 "../src/engine/smtp/smtp-client-connection.vala"
			return FALSE;
#line 3436 "smtp-client-connection.c"
		}
#line 253 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp14_ = _data_->starttls_response;
#line 253 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp15_ = geary_smtp_response_get_code (_data_->_tmp14_);
#line 253 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp16_ = _data_->_tmp15_;
#line 253 "../src/engine/smtp/smtp-client-connection.vala"
		if (!geary_smtp_response_code_is_starttls_ready (_data_->_tmp16_)) {
#line 254 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp17_ = _data_->response;
#line 254 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp18_ = geary_smtp_response_to_string (_data_->_tmp17_);
#line 254 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp19_ = _data_->_tmp18_;
#line 254 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp20_ = g_error_new (GEARY_SMTP_ERROR, GEARY_SMTP_ERROR_STARTTLS_FAILED, "STARTTLS failed: %s", _data_->_tmp19_);
#line 254 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_tmp21_ = _data_->_tmp20_;
#line 254 "../src/engine/smtp/smtp-client-connection.vala"
			_g_free0 (_data_->_tmp19_);
#line 254 "../src/engine/smtp/smtp-client-connection.vala"
			_data_->_inner_error0_ = _data_->_tmp21_;
#line 254 "../src/engine/smtp/smtp-client-connection.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 254 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_response_unref0 (_data_->starttls_response);
#line 254 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_response_unref0 (_data_->response);
#line 254 "../src/engine/smtp/smtp-client-connection.vala"
			g_object_unref (_data_->_async_result);
#line 254 "../src/engine/smtp/smtp-client-connection.vala"
			return FALSE;
#line 3470 "smtp-client-connection.c"
		}
#line 256 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp22_ = _data_->self->priv->endpoint;
#line 256 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp23_ = _data_->self->priv->cx;
#line 256 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_state_ = 3;
#line 256 "../src/engine/smtp/smtp-client-connection.vala"
		geary_endpoint_starttls_handshake_async (_data_->_tmp22_, _data_->_tmp23_, _data_->cancellable, geary_smtp_client_connection_establish_connection_async_ready, _data_);
#line 256 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 3482 "smtp-client-connection.c"
		_state_3:
#line 256 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp24_ = geary_endpoint_starttls_handshake_finish (_data_->_tmp22_, _data_->_res_, &_data_->_inner_error0_);
#line 256 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->tls_cx = _data_->_tmp24_;
#line 256 "../src/engine/smtp/smtp-client-connection.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 256 "../src/engine/smtp/smtp-client-connection.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 256 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_response_unref0 (_data_->starttls_response);
#line 256 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_response_unref0 (_data_->response);
#line 256 "../src/engine/smtp/smtp-client-connection.vala"
			g_object_unref (_data_->_async_result);
#line 256 "../src/engine/smtp/smtp-client-connection.vala"
			return FALSE;
#line 3500 "smtp-client-connection.c"
		}
#line 257 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp25_ = _data_->tls_cx;
#line 257 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp26_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp25_, g_io_stream_get_type (), GIOStream));
#line 257 "../src/engine/smtp/smtp-client-connection.vala"
		_g_object_unref0 (_data_->self->priv->cx);
#line 257 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->self->priv->cx = _data_->_tmp26_;
#line 258 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp27_ = _data_->tls_cx;
#line 258 "../src/engine/smtp/smtp-client-connection.vala"
		geary_smtp_client_connection_set_data_streams (_data_->self, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp27_, g_io_stream_get_type (), GIOStream));
#line 262 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_state_ = 4;
#line 262 "../src/engine/smtp/smtp-client-connection.vala"
		geary_smtp_client_connection_say_hello_async (_data_->self, _data_->cancellable, geary_smtp_client_connection_establish_connection_async_ready, _data_);
#line 262 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 3520 "smtp-client-connection.c"
		_state_4:
#line 262 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp29_ = geary_smtp_client_connection_say_hello_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 262 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp28_ = _data_->_tmp29_;
#line 262 "../src/engine/smtp/smtp-client-connection.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 262 "../src/engine/smtp/smtp-client-connection.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 262 "../src/engine/smtp/smtp-client-connection.vala"
			_g_object_unref0 (_data_->tls_cx);
#line 262 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_response_unref0 (_data_->starttls_response);
#line 262 "../src/engine/smtp/smtp-client-connection.vala"
			_geary_smtp_response_unref0 (_data_->response);
#line 262 "../src/engine/smtp/smtp-client-connection.vala"
			g_object_unref (_data_->_async_result);
#line 262 "../src/engine/smtp/smtp-client-connection.vala"
			return FALSE;
#line 3540 "smtp-client-connection.c"
		}
#line 262 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp30_ = _data_->_tmp28_;
#line 262 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp28_ = NULL;
#line 262 "../src/engine/smtp/smtp-client-connection.vala"
		_geary_smtp_response_unref0 (_data_->response);
#line 262 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->response = _data_->_tmp30_;
#line 245 "../src/engine/smtp/smtp-client-connection.vala"
		_geary_smtp_response_unref0 (_data_->_tmp28_);
#line 245 "../src/engine/smtp/smtp-client-connection.vala"
		_g_object_unref0 (_data_->tls_cx);
#line 245 "../src/engine/smtp/smtp-client-connection.vala"
		_geary_smtp_response_unref0 (_data_->starttls_response);
#line 3556 "smtp-client-connection.c"
	}
#line 265 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->result = _data_->response;
#line 265 "../src/engine/smtp/smtp-client-connection.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 265 "../src/engine/smtp/smtp-client-connection.vala"
	if (_data_->_state_ != 0) {
#line 265 "../src/engine/smtp/smtp-client-connection.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 265 "../src/engine/smtp/smtp-client-connection.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3568 "smtp-client-connection.c"
		}
	}
#line 265 "../src/engine/smtp/smtp-client-connection.vala"
	g_object_unref (_data_->_async_result);
#line 265 "../src/engine/smtp/smtp-client-connection.vala"
	return FALSE;
#line 3575 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_quit_async_data_free (gpointer _data)
{
	GearySmtpClientConnectionQuitAsyncData* _data_;
	_data_ = _data;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_geary_smtp_response_unref0 (_data_->result);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_slice_free (GearySmtpClientConnectionQuitAsyncData, _data_);
#line 3591 "smtp-client-connection.c"
}

void
geary_smtp_client_connection_quit_async (GearySmtpClientConnection* self,
                                         GCancellable* cancellable,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	GearySmtpClientConnectionQuitAsyncData* _data_;
	GearySmtpClientConnection* _tmp0_;
	GCancellable* _tmp1_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_CONNECTION (self));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = g_slice_new0 (GearySmtpClientConnectionQuitAsyncData);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_client_connection_quit_async_data_free);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->self = _tmp0_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->cancellable = _tmp1_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_quit_async_co (_data_);
#line 3625 "smtp-client-connection.c"
}

GearySmtpResponse*
geary_smtp_client_connection_quit_finish (GearySmtpClientConnection* self,
                                          GAsyncResult* _res_,
                                          GError** error)
{
	GearySmtpResponse* result;
	GearySmtpClientConnectionQuitAsyncData* _data_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	if (NULL == _data_) {
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		return NULL;
#line 3641 "smtp-client-connection.c"
	}
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	result = _data_->result;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->result = NULL;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	return result;
#line 3649 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_quit_async_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_)
{
	GearySmtpClientConnectionQuitAsyncData* _data_;
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = _user_data_;
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_source_object_ = source_object;
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_res_ = _res_;
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_quit_async_co (_data_);
#line 3666 "smtp-client-connection.c"
}

static gboolean
geary_smtp_client_connection_quit_async_co (GearySmtpClientConnectionQuitAsyncData* _data_)
{
#line 268 "../src/engine/smtp/smtp-client-connection.vala"
	switch (_data_->_state_) {
#line 268 "../src/engine/smtp/smtp-client-connection.vala"
		case 0:
#line 3676 "smtp-client-connection.c"
		goto _state_0;
#line 268 "../src/engine/smtp/smtp-client-connection.vala"
		case 1:
#line 3680 "smtp-client-connection.c"
		goto _state_1;
		default:
#line 268 "../src/engine/smtp/smtp-client-connection.vala"
		g_assert_not_reached ();
#line 3685 "smtp-client-connection.c"
	}
	_state_0:
#line 269 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_set_capabilities (_data_->self, NULL);
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp1_ = geary_smtp_request_new (GEARY_SMTP_COMMAND_QUIT, NULL, 0);
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_state_ = 1;
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_transaction_async (_data_->self, _data_->_tmp2_, _data_->cancellable, geary_smtp_client_connection_quit_async_ready, _data_);
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
	return FALSE;
#line 3700 "smtp-client-connection.c"
	_state_1:
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp3_ = geary_smtp_client_connection_transaction_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
	_geary_smtp_request_unref0 (_data_->_tmp2_);
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp0_ = _data_->_tmp4_;
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 3718 "smtp-client-connection.c"
	}
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp5_ = _data_->_tmp0_;
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp0_ = NULL;
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->result = _data_->_tmp5_;
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
	_geary_smtp_response_unref0 (_data_->_tmp0_);
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
	if (_data_->_state_ != 0) {
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3736 "smtp-client-connection.c"
		}
	}
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
	g_object_unref (_data_->_async_result);
#line 270 "../src/engine/smtp/smtp-client-connection.vala"
	return FALSE;
#line 3743 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_transaction_async_data_free (gpointer _data)
{
	GearySmtpClientConnectionTransactionAsyncData* _data_;
	_data_ = _data;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_geary_smtp_request_unref0 (_data_->request);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_geary_smtp_response_unref0 (_data_->result);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_slice_free (GearySmtpClientConnectionTransactionAsyncData, _data_);
#line 3761 "smtp-client-connection.c"
}

void
geary_smtp_client_connection_transaction_async (GearySmtpClientConnection* self,
                                                GearySmtpRequest* request,
                                                GCancellable* cancellable,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_)
{
	GearySmtpClientConnectionTransactionAsyncData* _data_;
	GearySmtpClientConnection* _tmp0_;
	GearySmtpRequest* _tmp1_;
	GCancellable* _tmp2_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_CONNECTION (self));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail (GEARY_SMTP_IS_REQUEST (request));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = g_slice_new0 (GearySmtpClientConnectionTransactionAsyncData);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_client_connection_transaction_async_data_free);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->self = _tmp0_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp1_ = _geary_smtp_request_ref0 (request);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_geary_smtp_request_unref0 (_data_->request);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->request = _tmp1_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->cancellable = _tmp2_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_transaction_async_co (_data_);
#line 3805 "smtp-client-connection.c"
}

GearySmtpResponse*
geary_smtp_client_connection_transaction_finish (GearySmtpClientConnection* self,
                                                 GAsyncResult* _res_,
                                                 GError** error)
{
	GearySmtpResponse* result;
	GearySmtpClientConnectionTransactionAsyncData* _data_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	if (NULL == _data_) {
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		return NULL;
#line 3821 "smtp-client-connection.c"
	}
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	result = _data_->result;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->result = NULL;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	return result;
#line 3829 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_transaction_async_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_)
{
	GearySmtpClientConnectionTransactionAsyncData* _data_;
#line 275 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = _user_data_;
#line 275 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_source_object_ = source_object;
#line 275 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_res_ = _res_;
#line 275 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_transaction_async_co (_data_);
#line 3846 "smtp-client-connection.c"
}

static gboolean
geary_smtp_client_connection_transaction_async_co (GearySmtpClientConnectionTransactionAsyncData* _data_)
{
#line 273 "../src/engine/smtp/smtp-client-connection.vala"
	switch (_data_->_state_) {
#line 273 "../src/engine/smtp/smtp-client-connection.vala"
		case 0:
#line 3856 "smtp-client-connection.c"
		goto _state_0;
#line 273 "../src/engine/smtp/smtp-client-connection.vala"
		case 1:
#line 3860 "smtp-client-connection.c"
		goto _state_1;
#line 273 "../src/engine/smtp/smtp-client-connection.vala"
		case 2:
#line 3864 "smtp-client-connection.c"
		goto _state_2;
		default:
#line 273 "../src/engine/smtp/smtp-client-connection.vala"
		g_assert_not_reached ();
#line 3869 "smtp-client-connection.c"
	}
	_state_0:
#line 275 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_state_ = 1;
#line 275 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_send_request_async (_data_->self, _data_->request, _data_->cancellable, geary_smtp_client_connection_transaction_async_ready, _data_);
#line 275 "../src/engine/smtp/smtp-client-connection.vala"
	return FALSE;
#line 3878 "smtp-client-connection.c"
	_state_1:
#line 275 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_send_request_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 275 "../src/engine/smtp/smtp-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 275 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 275 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 275 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 3890 "smtp-client-connection.c"
	}
#line 277 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_state_ = 2;
#line 277 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_recv_response_async (_data_->self, _data_->cancellable, geary_smtp_client_connection_transaction_async_ready, _data_);
#line 277 "../src/engine/smtp/smtp-client-connection.vala"
	return FALSE;
#line 3898 "smtp-client-connection.c"
	_state_2:
#line 277 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp1_ = geary_smtp_client_connection_recv_response_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 277 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp0_ = _data_->_tmp1_;
#line 277 "../src/engine/smtp/smtp-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 277 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 277 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 277 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 3912 "smtp-client-connection.c"
	}
#line 277 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp2_ = _data_->_tmp0_;
#line 277 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp0_ = NULL;
#line 277 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->result = _data_->_tmp2_;
#line 277 "../src/engine/smtp/smtp-client-connection.vala"
	_geary_smtp_response_unref0 (_data_->_tmp0_);
#line 277 "../src/engine/smtp/smtp-client-connection.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 277 "../src/engine/smtp/smtp-client-connection.vala"
	if (_data_->_state_ != 0) {
#line 277 "../src/engine/smtp/smtp-client-connection.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 277 "../src/engine/smtp/smtp-client-connection.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3930 "smtp-client-connection.c"
		}
	}
#line 277 "../src/engine/smtp/smtp-client-connection.vala"
	g_object_unref (_data_->_async_result);
#line 277 "../src/engine/smtp/smtp-client-connection.vala"
	return FALSE;
#line 3937 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_read_line_async_data_free (gpointer _data)
{
	GearySmtpClientConnectionReadLineAsyncData* _data_;
	_data_ = _data;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_free0 (_data_->result);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_slice_free (GearySmtpClientConnectionReadLineAsyncData, _data_);
#line 3953 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_read_line_async (GearySmtpClientConnection* self,
                                              GCancellable* cancellable,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	GearySmtpClientConnectionReadLineAsyncData* _data_;
	GearySmtpClientConnection* _tmp0_;
	GCancellable* _tmp1_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_CONNECTION (self));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = g_slice_new0 (GearySmtpClientConnectionReadLineAsyncData);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_client_connection_read_line_async_data_free);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->self = _tmp0_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->cancellable = _tmp1_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_read_line_async_co (_data_);
#line 3987 "smtp-client-connection.c"
}

static gchar*
geary_smtp_client_connection_read_line_finish (GearySmtpClientConnection* self,
                                               GAsyncResult* _res_,
                                               GError** error)
{
	gchar* result;
	GearySmtpClientConnectionReadLineAsyncData* _data_;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	if (NULL == _data_) {
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		return NULL;
#line 4003 "smtp-client-connection.c"
	}
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	result = _data_->result;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->result = NULL;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	return result;
#line 4011 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_read_line_async_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_)
{
	GearySmtpClientConnectionReadLineAsyncData* _data_;
#line 282 "../src/engine/smtp/smtp-client-connection.vala"
	_data_ = _user_data_;
#line 282 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_source_object_ = source_object;
#line 282 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_res_ = _res_;
#line 282 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_read_line_async_co (_data_);
#line 4028 "smtp-client-connection.c"
}

static gboolean
geary_smtp_client_connection_read_line_async_co (GearySmtpClientConnectionReadLineAsyncData* _data_)
{
#line 280 "../src/engine/smtp/smtp-client-connection.vala"
	switch (_data_->_state_) {
#line 280 "../src/engine/smtp/smtp-client-connection.vala"
		case 0:
#line 4038 "smtp-client-connection.c"
		goto _state_0;
#line 280 "../src/engine/smtp/smtp-client-connection.vala"
		case 1:
#line 4042 "smtp-client-connection.c"
		goto _state_1;
		default:
#line 280 "../src/engine/smtp/smtp-client-connection.vala"
		g_assert_not_reached ();
#line 4047 "smtp-client-connection.c"
	}
	_state_0:
#line 282 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp0_ = _data_->self->priv->dins;
#line 282 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp1_ = 0UL;
#line 282 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_state_ = 1;
#line 282 "../src/engine/smtp/smtp-client-connection.vala"
	g_data_input_stream_read_line_async (_data_->_tmp0_, G_PRIORITY_DEFAULT, _data_->cancellable, geary_smtp_client_connection_read_line_async_ready, _data_);
#line 282 "../src/engine/smtp/smtp-client-connection.vala"
	return FALSE;
#line 4060 "smtp-client-connection.c"
	_state_1:
#line 282 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp2_ = g_data_input_stream_read_line_finish (_data_->_tmp0_, _data_->_res_, &_data_->_tmp1_, &_data_->_inner_error0_);
#line 282 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->length = _data_->_tmp1_;
#line 282 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->line = _data_->_tmp2_;
#line 282 "../src/engine/smtp/smtp-client-connection.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 282 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 282 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 282 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 4076 "smtp-client-connection.c"
	}
#line 284 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->_tmp3_ = _data_->line;
#line 284 "../src/engine/smtp/smtp-client-connection.vala"
	if (geary_string_is_empty (_data_->_tmp3_)) {
#line 285 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp4_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 285 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 285 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp6_ = g_error_new (G_IO_ERROR, G_IO_ERROR_CLOSED, "End of stream detected on %s", _data_->_tmp5_);
#line 285 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 285 "../src/engine/smtp/smtp-client-connection.vala"
		_g_free0 (_data_->_tmp5_);
#line 285 "../src/engine/smtp/smtp-client-connection.vala"
		_data_->_inner_error0_ = _data_->_tmp7_;
#line 285 "../src/engine/smtp/smtp-client-connection.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 285 "../src/engine/smtp/smtp-client-connection.vala"
		_g_free0 (_data_->line);
#line 285 "../src/engine/smtp/smtp-client-connection.vala"
		g_object_unref (_data_->_async_result);
#line 285 "../src/engine/smtp/smtp-client-connection.vala"
		return FALSE;
#line 4102 "smtp-client-connection.c"
	}
#line 287 "../src/engine/smtp/smtp-client-connection.vala"
	_data_->result = _data_->line;
#line 287 "../src/engine/smtp/smtp-client-connection.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 287 "../src/engine/smtp/smtp-client-connection.vala"
	if (_data_->_state_ != 0) {
#line 287 "../src/engine/smtp/smtp-client-connection.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 287 "../src/engine/smtp/smtp-client-connection.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4114 "smtp-client-connection.c"
		}
	}
#line 287 "../src/engine/smtp/smtp-client-connection.vala"
	g_object_unref (_data_->_async_result);
#line 287 "../src/engine/smtp/smtp-client-connection.vala"
	return FALSE;
#line 4121 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_check_connected (GearySmtpClientConnection* self,
                                              GError** error)
{
	GIOStream* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 290 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_CONNECTION (self));
#line 291 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp0_ = self->priv->cx;
#line 291 "../src/engine/smtp/smtp-client-connection.vala"
	if (_tmp0_ == NULL) {
#line 4136 "smtp-client-connection.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
		GError* _tmp3_;
		GError* _tmp4_;
#line 292 "../src/engine/smtp/smtp-client-connection.vala"
		_tmp1_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 292 "../src/engine/smtp/smtp-client-connection.vala"
		_tmp2_ = _tmp1_;
#line 292 "../src/engine/smtp/smtp-client-connection.vala"
		_tmp3_ = g_error_new (GEARY_SMTP_ERROR, GEARY_SMTP_ERROR_NOT_CONNECTED, "Not connected to %s", _tmp2_);
#line 292 "../src/engine/smtp/smtp-client-connection.vala"
		_tmp4_ = _tmp3_;
#line 292 "../src/engine/smtp/smtp-client-connection.vala"
		_g_free0 (_tmp2_);
#line 292 "../src/engine/smtp/smtp-client-connection.vala"
		_inner_error0_ = _tmp4_;
#line 292 "../src/engine/smtp/smtp-client-connection.vala"
		g_propagate_error (error, _inner_error0_);
#line 292 "../src/engine/smtp/smtp-client-connection.vala"
		return;
#line 4157 "smtp-client-connection.c"
	}
}

/** {@inheritDoc} */
static GearyLoggingState*
geary_smtp_client_connection_real_to_logging_state (GearySmtpClientConnection* self)
{
	const gchar* _tmp0_ = NULL;
	GearyEndpoint* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GearyLoggingState* _tmp4_;
	GearyLoggingState* _tmp5_;
	GearyLoggingState* result;
#line 301 "../src/engine/smtp/smtp-client-connection.vala"
	if (geary_smtp_client_connection_is_connected (self)) {
#line 301 "../src/engine/smtp/smtp-client-connection.vala"
		_tmp0_ = "connected";
#line 4176 "smtp-client-connection.c"
	} else {
#line 301 "../src/engine/smtp/smtp-client-connection.vala"
		_tmp0_ = "disconnected";
#line 4180 "smtp-client-connection.c"
	}
#line 297 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp1_ = self->priv->endpoint;
#line 297 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp2_ = geary_endpoint_to_string (_tmp1_);
#line 297 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp3_ = _tmp2_;
#line 297 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp4_ = geary_logging_state_new (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "%s/%s", _tmp3_, _tmp0_);
#line 297 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp5_ = _tmp4_;
#line 297 "../src/engine/smtp/smtp-client-connection.vala"
	_g_free0 (_tmp3_);
#line 297 "../src/engine/smtp/smtp-client-connection.vala"
	result = _tmp5_;
#line 297 "../src/engine/smtp/smtp-client-connection.vala"
	return result;
#line 4198 "smtp-client-connection.c"
}

GearyLoggingState*
geary_smtp_client_connection_to_logging_state (GearySmtpClientConnection* self)
{
	GearySmtpClientConnectionClass* _klass_;
#line 296 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_val_if_fail (GEARY_SMTP_IS_CLIENT_CONNECTION (self), NULL);
#line 296 "../src/engine/smtp/smtp-client-connection.vala"
	_klass_ = GEARY_SMTP_CLIENT_CONNECTION_GET_CLASS (self);
#line 296 "../src/engine/smtp/smtp-client-connection.vala"
	if (_klass_->to_logging_state) {
#line 296 "../src/engine/smtp/smtp-client-connection.vala"
		return _klass_->to_logging_state (self);
#line 4213 "smtp-client-connection.c"
	}
#line 296 "../src/engine/smtp/smtp-client-connection.vala"
	return NULL;
#line 4217 "smtp-client-connection.c"
}

/** Sets the service's logging parent. */
void
geary_smtp_client_connection_set_logging_parent (GearySmtpClientConnection* self,
                                                 GearyLoggingSource* parent)
{
#line 306 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_CONNECTION (self));
#line 306 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail (GEARY_LOGGING_IS_SOURCE (parent));
#line 307 "../src/engine/smtp/smtp-client-connection.vala"
	self->priv->_logging_parent = parent;
#line 4231 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_set_data_streams (GearySmtpClientConnection* self,
                                               GIOStream* stream)
{
	GInputStream* _tmp0_;
	GInputStream* _tmp1_;
	GDataInputStream* _tmp2_;
	GDataInputStream* _tmp3_;
	GDataInputStream* _tmp4_;
	GOutputStream* _tmp5_;
	GOutputStream* _tmp6_;
	GDataOutputStream* _tmp7_;
	GDataOutputStream* _tmp8_;
#line 310 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_CONNECTION (self));
#line 310 "../src/engine/smtp/smtp-client-connection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (stream, g_io_stream_get_type ()));
#line 311 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp0_ = g_io_stream_get_input_stream (stream);
#line 311 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp1_ = _tmp0_;
#line 311 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp2_ = g_data_input_stream_new (_tmp1_);
#line 311 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (self->priv->dins);
#line 311 "../src/engine/smtp/smtp-client-connection.vala"
	self->priv->dins = _tmp2_;
#line 312 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp3_ = self->priv->dins;
#line 312 "../src/engine/smtp/smtp-client-connection.vala"
	g_data_input_stream_set_newline_type (_tmp3_, GEARY_SMTP_DATA_FORMAT_LINE_TERMINATOR_TYPE);
#line 313 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp4_ = self->priv->dins;
#line 313 "../src/engine/smtp/smtp-client-connection.vala"
	g_filter_input_stream_set_close_base_stream (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, g_filter_input_stream_get_type (), GFilterInputStream), FALSE);
#line 314 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp5_ = g_io_stream_get_output_stream (stream);
#line 314 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp6_ = _tmp5_;
#line 314 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp7_ = g_data_output_stream_new (_tmp6_);
#line 314 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (self->priv->douts);
#line 314 "../src/engine/smtp/smtp-client-connection.vala"
	self->priv->douts = _tmp7_;
#line 315 "../src/engine/smtp/smtp-client-connection.vala"
	_tmp8_ = self->priv->douts;
#line 315 "../src/engine/smtp/smtp-client-connection.vala"
	g_filter_output_stream_set_close_base_stream (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, g_filter_output_stream_get_type (), GFilterOutputStream), FALSE);
#line 4283 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_class_init (GearySmtpClientConnectionClass * klass,
                                         gpointer klass_data)
{
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_parent_class = g_type_class_peek_parent (klass);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_type_class_adjust_private_offset (klass, &GearySmtpClientConnection_private_offset);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	((GearySmtpClientConnectionClass *) klass)->to_logging_state = (GearyLoggingState* (*) (GearySmtpClientConnection*)) geary_smtp_client_connection_real_to_logging_state;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_smtp_client_connection_get_property;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_smtp_client_connection_set_property;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_smtp_client_connection_finalize;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SMTP_CLIENT_CONNECTION_CAPABILITIES_PROPERTY, geary_smtp_client_connection_properties[GEARY_SMTP_CLIENT_CONNECTION_CAPABILITIES_PROPERTY] = g_param_spec_object ("capabilities", "capabilities", "capabilities", GEARY_SMTP_TYPE_CAPABILITIES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4304 "smtp-client-connection.c"
	/** {@inheritDoc} */
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SMTP_CLIENT_CONNECTION_LOGGING_PARENT_PROPERTY, geary_smtp_client_connection_properties[GEARY_SMTP_CLIENT_CONNECTION_LOGGING_PARENT_PROPERTY] = g_param_spec_object ("logging-parent", "logging-parent", "logging-parent", GEARY_LOGGING_TYPE_SOURCE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4308 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_geary_logging_source_interface_init (GearyLoggingSourceIface * iface,
                                                                  gpointer iface_data)
{
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	geary_smtp_client_connection_geary_logging_source_parent_iface = g_type_interface_peek_parent (iface);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	iface->to_logging_state = (GearyLoggingState* (*) (GearyLoggingSource*)) geary_smtp_client_connection_to_logging_state;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	iface->get_logging_domain = geary_smtp_client_connection_real_get_logging_domain;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	iface->get_logging_parent = geary_smtp_client_connection_real_get_logging_parent;
#line 4323 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_instance_init (GearySmtpClientConnection * self,
                                            gpointer klass)
{
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	self->priv = geary_smtp_client_connection_get_instance_private (self);
#line 16 "../src/engine/smtp/smtp-client-connection.vala"
	self->priv->_capabilities = NULL;
#line 25 "../src/engine/smtp/smtp-client-connection.vala"
	self->priv->_logging_parent = NULL;
#line 28 "../src/engine/smtp/smtp-client-connection.vala"
	self->priv->cx = NULL;
#line 29 "../src/engine/smtp/smtp-client-connection.vala"
	self->priv->socket_cx = NULL;
#line 30 "../src/engine/smtp/smtp-client-connection.vala"
	self->priv->dins = NULL;
#line 31 "../src/engine/smtp/smtp-client-connection.vala"
	self->priv->douts = NULL;
#line 4344 "smtp-client-connection.c"
}

static void
geary_smtp_client_connection_finalize (GObject * obj)
{
	GearySmtpClientConnection * self;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_SMTP_TYPE_CLIENT_CONNECTION, GearySmtpClientConnection);
#line 16 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (self->priv->_capabilities);
#line 27 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (self->priv->endpoint);
#line 28 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (self->priv->cx);
#line 29 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (self->priv->socket_cx);
#line 30 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (self->priv->dins);
#line 31 "../src/engine/smtp/smtp-client-connection.vala"
	_g_object_unref0 (self->priv->douts);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	G_OBJECT_CLASS (geary_smtp_client_connection_parent_class)->finalize (obj);
#line 4367 "smtp-client-connection.c"
}

/** A network connection to a SMTP service. */
 G_GNUC_NO_INLINE static GType
geary_smtp_client_connection_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearySmtpClientConnectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_smtp_client_connection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearySmtpClientConnection), 0, (GInstanceInitFunc) geary_smtp_client_connection_instance_init, NULL };
	static const GInterfaceInfo geary_logging_source_info = { (GInterfaceInitFunc) geary_smtp_client_connection_geary_logging_source_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType geary_smtp_client_connection_type_id;
	geary_smtp_client_connection_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearySmtpClientConnection", &g_define_type_info, 0);
	g_type_add_interface_static (geary_smtp_client_connection_type_id, GEARY_LOGGING_TYPE_SOURCE, &geary_logging_source_info);
	GearySmtpClientConnection_private_offset = g_type_add_instance_private (geary_smtp_client_connection_type_id, sizeof (GearySmtpClientConnectionPrivate));
	return geary_smtp_client_connection_type_id;
}

GType
geary_smtp_client_connection_get_type (void)
{
	static gsize geary_smtp_client_connection_type_id__once = 0;
	if (g_once_init_enter (&geary_smtp_client_connection_type_id__once)) {
		GType geary_smtp_client_connection_type_id;
		geary_smtp_client_connection_type_id = geary_smtp_client_connection_get_type_once ();
		g_once_init_leave (&geary_smtp_client_connection_type_id__once, geary_smtp_client_connection_type_id);
	}
	return geary_smtp_client_connection_type_id__once;
}

static void
_vala_geary_smtp_client_connection_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	GearySmtpClientConnection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_SMTP_TYPE_CLIENT_CONNECTION, GearySmtpClientConnection);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	switch (property_id) {
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		case GEARY_SMTP_CLIENT_CONNECTION_CAPABILITIES_PROPERTY:
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		g_value_set_object (value, geary_smtp_client_connection_get_capabilities (self));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		break;
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		case GEARY_SMTP_CLIENT_CONNECTION_LOGGING_PARENT_PROPERTY:
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		g_value_set_object (value, geary_logging_source_get_logging_parent (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource)));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		break;
#line 4417 "smtp-client-connection.c"
		default:
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		break;
#line 4423 "smtp-client-connection.c"
	}
}

static void
_vala_geary_smtp_client_connection_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	GearySmtpClientConnection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_SMTP_TYPE_CLIENT_CONNECTION, GearySmtpClientConnection);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
	switch (property_id) {
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		case GEARY_SMTP_CLIENT_CONNECTION_CAPABILITIES_PROPERTY:
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		geary_smtp_client_connection_set_capabilities (self, g_value_get_object (value));
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		break;
#line 4443 "smtp-client-connection.c"
		default:
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/engine/smtp/smtp-client-connection.vala"
		break;
#line 4449 "smtp-client-connection.c"
	}
}

